
#
#  scan_ip37_001.ni version 1.1
#
#  MODIFICATION HISTORY:
#
#  WHEN      WHO             WHAT
#  --------  --------------  -------------------------------
#  xx/xx/xx  Karen Beighley  Original script written.
#  03/22/01  Karen Beighley  Removed message for brick location.
#
#  Script to complete a series of scan tests on a P0 IP37 w/ SYNERGY 1.0
#  This script invokes tests for the node board and NI/II connectors
#
BIN_PATH=/stand/sysco/bin
CFG_PATH=/stand/sysco/cfg/scan

SCANTEST=$BIN_PATH"/scantest"
SLIT=$BIN_PATH"/slit"

#
#  Test off-board connections
#
echo " "
echo "Place loopback cables on C-brick II and NI ports"
echo "Turn on power to C-brick motherboard"

echo " "
echo "--- TEST OF IP37 II and NI CONNECTIONS USING BOUNDARY REGISTER ---"
echo "Press ENTER to start interconnec test..."
read foo
$SCANTEST -f $CFG_PATH"/ip37_001ni.cfg"
echo "Results stored in log file: scantest.dmp"

echo " "
echo "--- TEST OF IP37 II and NI CONNECTIONS USING LLP (AT-SPEED) ---"
echo "Press ENTER to start interconnec test..."
read foo
$SLIT -f $CFG_PATH"/ip37_001.cfg" -i $CFG_PATH"/ip37_001.links"
echo "Results stored in log file: slit.dmp"

