##!/usr/local/bin/tclsh 
# for testing
#
# debug_port.tcl
#
# Kurt Kermes
# 2000/05/24
#
# script for setting up Synergy's Debug Port 
#
# User can optionally set the debug mask
#
#       (C) COPYRIGHT SILICON GRAPHICS, INC.
#       UNPUBLISHED PROPRIETARY INFORMATION.
#       ALL RIGHTS RESERVED.
#


source $env(SCAN_PATH_DATA)/diags/ip37/syn_procs.tcl


############################################################################
# script parameters
# You may modify the string after 'set <variable>'
#
############################################################################

############################################################################
############################################################################
# parameter initialization
#    user may put in value here-------------vvvvvvvvv
############################################################################

#set mod SYN1CHN 
#set brd SYN1BRD 
#set chip U0 

# debugAddr - select which address to send out -- 69 = di0.lbOpsCtl
set debugAddr 0x49 

# debugMask - if you want to mask off bits of the 32 bits 
#             that don't need to be output
set debugMask 0xffffffff 



############################################################################
############################################################################
# main
############################################################################
############################################################################

#RESET -H
#RESET

#SEL MOD  $mod
#SEL BRD  $brd
#SEL CHIP $chip


puts "Setting Debug port address $debugAddr"

if { $debugMask != 0xffffffff } {
	INST TRIG_MASK
	GOINST
	DATA $debugMask
	GODATA
}

set datahi [ expr 1 << 16  | ($debugAddr) ]
pio_write 0x38 $datahi 0

puts "Debug port set, enter additional commands"
