#
# stopclk.tcl
#
# Kurt Kermes
# 99/09/14
#
# stops the RTR clock and does a gmoc of the user's choice
# Mod history:
#  2001/08/23 - KK - Changed BRD/CHIP names
#
#############################################################################
#
#   (C) COPYRIGHT SILICON GRAPHICS, INC.
#   UNPUBLISHED PROPRIETARY INFORMATION
#   ALL RIGHTS RESERVED UNDER THE COPYRIGHT LAWS OF THE UNITED STATES.
#
#   Portions of this software may still be in development.  The existence
#   of the software still in development is not a commitment of actual
#   release or support by Silicon Graphics, Inc.  Silicon Graphics, Inc.
#   assumes no liability for any damages resulting from attempts to use any
#   product not officially released.  If it is released, the final form of
#   the product and the time of official release is at the discretion of
#   Silicon Graphics, Inc.
#
#############################################################################
#

#

############################################################################
# script parameters
#
# gmocType : 1 for a single or 2 for double clock at-speed sequence
#            
############################################################################
set gmocType 0


############################################################################

set slowMode   0
set lpraAccess 0
set chainSel   0
set chainCir   0
set chainInv   0

############################################################################
############################################################################

set brd R
set chip RTR

RESET

SEL MOD  $mod
SEL BRD  $brd
SEL CHIP $chip

INST MODE_REG
GOINST
DATA 1
GODATA    ;# this should stop the clock

INST SCAN_CTL_TDR
GOINST
set scanCtlReg  [ expr ($chainInv << 9) | ($chainCir << 8) | ($gmocType << 5) \
                     | ($chainSel << 2) | ($lpraAccess << 1) | ($slowMode) ]
DATA $scanCtlReg
GODATA

puts "Clock stopped, enter additional commands."
return

