#
#/**************************************************************************
# *                                                                        *
# *               Copyright (C) 2002-2005 Silicon Graphics, Inc.           *
# *                                                                        *
# *  These coded instructions, statements, and computer programs  contain  *
# *  unpublished  proprietary  information of Silicon Graphics, Inc., and  *
# *  are protected by Federal copyright law.  They  may  not be disclosed  *
# *  to  third  parties  or copied or duplicated in any form, in whole or  *
# *  in part, without the prior written consent of Silicon Graphics, Inc.  *
# *                                                                        *
# **************************************************************************/
#
# @(#)$Id: err_codes.pm,v 1.1 2006/05/28 08:52:10 meyer Exp $
#
#  FILE: err_codes.pm
#
#  DESCRIPTION:  This file contains defines used by par_dmp and errdmp.
#
#
#  MODIFICATION HISTORY:
#
#     WHEN      WHO             WHAT
#     --------  --------------  -----------------------------------------
#     05/26/06  Gary Meyer      Original source code submitted for release.
#
#
#
#-------------------------------------------------------------------------------



$SHUB_HW_ERR   = 0x0001;	# Any unrecoverable Hardware error in Shub1 or 2
$SHUB_SBE_ERR  = 0x0002;	# Correctable ECC error in Shub1 or 2
$SHUB_CRD_ERR  = 0x0004;	# Credit threshold error in Shub1 or 2
$SHUB_CSR_ERR  = 0x0008;	# Shub numalink CB, SN, or Retry error (retry timeouts would be covered in $SHUB_HW_ERR)
$SHUB_UCE_ERR  = 0x0010;	# Uncorrectable ECC error in Shub1 or 2
$SHUB_CFG_ERR  = 0x0020;	# Shub configuration error
$L1_LINK_ERR   = 0x0040;	# L1 detected link error
$JTAG_ABORT    = 0x0080;	# script aborted due to unrecoverable JTAG errors
$NL4R_HW_ERR   = 0x0101;	# NL4R unrecoverable Hardware error
$NL4R_CRD_ERR  = 0x0404;	# NL4R Credit threshold error
$NL4R_CSR_ERR  = 0x0808;	# NL4R numalink CB, SN, or Retry error (retry timeouts would be covered in $NL4R_HW_ERR)
$TIO_HW_ERR    = 0x1001;	# TIO unrecoverable Hardware error
$TIO_CRD_ERR   = 0x4004;	# TIO Credit threshold error
$TIO_CSR_ERR   = 0x8008;	# TIO numalink CB, SN, or Retry error (retry timeouts would be covered in $TIO_HW_ERR)



#-------------------------------------------------------------------------------

1;
