#
#/**************************************************************************
# *                                                                        *
# *               Copyright (C) 1989-1999 Silicon Graphics, Inc.           *
# *                                                                        *
# *  These coded instructions, statements, and computer programs  contain  *
# *  unpublished  proprietary  information of Silicon Graphics, Inc., and  *
# *  are protected by Federal copyright law.  They  may  not be disclosed  *
# *  to  third  parties  or copied or duplicated in any form, in whole or  *
# *  in part, without the prior written consent of Silicon Graphics, Inc.  *
# *                                                                        *
# **************************************************************************/
#
# @(#)$Id: fmt_subs.pm,v 1.3 2004/11/08 22:08:47 beighley Exp $


#-------------------------------------------------------------------------------
#  GLOBAL VARIABLES FOR THIS MODULE
#-------------------------------------------------------------------------------

@base_opt_labs = ( 'Hexidecimal', 'Decimal', 'Unsigned decimal', 'Octal');
@base_opt_vals = ( 'hex', 'dec', 'udec', 'oct' );

@convert_num_mask = 
(  0x0000000000000000, 0x0000000000000001, 0x0000000000000003, 0x0000000000000007, 0x000000000000000F, 0x000000000000001F,
   0x000000000000003F, 0x000000000000007F, 0x00000000000000FF, 0x00000000000001FF, 0x00000000000003FF, 0x00000000000007FF,
   0x0000000000000FFF, 0x0000000000001FFF, 0x0000000000003FFF, 0x0000000000007FFF, 0x000000000000FFFF, 0x000000000001FFFF,
   0x000000000003FFFF, 0x000000000007FFFF, 0x00000000000FFFFF, 0x00000000001FFFFF, 0x00000000003FFFFF, 0x00000000007FFFFF,
   0x0000000000FFFFFF, 0x0000000001FFFFFF, 0x0000000003FFFFFF, 0x0000000007FFFFFF, 0x000000000FFFFFFF, 0x000000001FFFFFFF,
   0x000000003FFFFFFF, 0x000000007FFFFFFF, 0x00000000FFFFFFFF, 0x00000001FFFFFFFF, 0x00000003FFFFFFFF, 0x00000007FFFFFFFF,
   0x0000000FFFFFFFFF, 0x0000001FFFFFFFFF, 0x0000003FFFFFFFFF, 0x0000007FFFFFFFFF, 0x000000FFFFFFFFFF, 0x000001FFFFFFFFFF,
   0x000003FFFFFFFFFF, 0x000007FFFFFFFFFF, 0x00000FFFFFFFFFFF, 0x00001FFFFFFFFFFF, 0x00003FFFFFFFFFFF, 0x00007FFFFFFFFFFF,
   0x0000FFFFFFFFFFFF, 0x0001FFFFFFFFFFFF, 0x0003FFFFFFFFFFFF, 0x0007FFFFFFFFFFFF, 0x000FFFFFFFFFFFFF, 0x001FFFFFFFFFFFFF,
   0x003FFFFFFFFFFFFF, 0x007FFFFFFFFFFFFF, 0x00FFFFFFFFFFFFFF, 0x01FFFFFFFFFFFFFF, 0x03FFFFFFFFFFFFFF, 0x07FFFFFFFFFFFFFF,
   0x0FFFFFFFFFFFFFFF, 0x1FFFFFFFFFFFFFFF, 0x3FFFFFFFFFFFFFFF, 0x7FFFFFFFFFFFFFFF, 0xFFFFFFFFFFFFFFFF
);


#-------------------------------------------------------------------------------

sub convert_text2num
{  return(0) if ( $#_ < 0 );
   my ($text, $num);
   $text = $_[0];
   $text =~ s/\s+//g;  # Remove all whitespace
   return(0) if ( length($text) <= 0 );

   #  Convert the string to a numeric value
   if ( ($text =~ /^x/i) || ($text =~ /^0x/i) )
   {  $num = hex( lc($text) );
   }
   elsif ( $text =~ /^0/ )
   {  $num = oct($text);
   }
   else
   {  $num = $text + 0;
   }
   return($num);
}


#-------------------------------------------------------------------------------

sub convert_num2text
{  my $num = $#_ + 1;

#   printf "\nconvert_num2text( @_ ) : num=$num\n";

   my $len  = 64;          # default bit-length of value
   my $base = 'hex';       # default base to use when converting value
   my $text = "";          # initialize string variable
   my ($tmp, $fmt);

   #  Extract the parameters
   if ( $num == 3 )
   {  $len  = $_[1];   
      $base = $_[2];
   }
   elsif ( $num == 2 )
   {  $len  = $_[1];   
   }
   elsif ( $num != 1 )
   {  return($text);
   }
   if ( ($len < 0) || ($len > 64) )
   {  $len = 64;
   }
   my $val = $_[0] & $convert_num_mask[$len];

   #  Convert the value to a formatted string
   if ( $base eq 'dec' )
   {  $text = sprintf("%lld", $val);
   }
   elsif ( $base eq 'udec' )
   {  $text = sprintf("%llu", $val);
   }
   elsif ( $base eq 'hex' )
   {  $tmp  = (($len - 1) >> 2) + 1;
      $fmt  = sprintf("0x%c0%uX", 0x25, $tmp);
      $text = sprintf($fmt, $val);
   }
   elsif ( $base eq 'oct' )
   {  $tmp = int( ($len - 1)/3 ) + 1;
      $fmt  = sprintf("0%c0%uo", 0x25, $tmp);
      $text = sprintf($fmt, $val);
   }

   return($text);
}


#-------------------------------------------------------------------------------

1;
