#
#/**************************************************************************
# *                                                                        *
# *               Copyright (C) 1989-1999 Silicon Graphics, Inc.           *
# *                                                                        *
# *  These coded instructions, statements, and computer programs  contain  *
# *  unpublished  proprietary  information of Silicon Graphics, Inc., and  *
# *  are protected by Federal copyright law.  They  may  not be disclosed  *
# *  to  third  parties  or copied or duplicated in any form, in whole or  *
# *  in part, without the prior written consent of Silicon Graphics, Inc.  *
# *                                                                        *
# **************************************************************************/
#
# @(#)$Id: misc_jtdrs.pm,v 1.3 2003/04/01 17:35:21 beighley Exp $


################################################################################
#   MCKINLEY A0 JTAG OPCODE/TDR DEFINITION
################################################################################

$mckinley_a0_tdr_defined = 0;

#-----------------------------------
#  TDR DEFINITION: BYPASS
#-----------------------------------

%mckinley_a0_flds_00000 =
#  NAME                     IND  POS  LEN  MODE    DESCRIPTION
#  -------------------      ---  ---  ---  ------  -----------------------
(  "RSVD"              => [   0,   0,   1, 0x0000, ""                       ],
);

%mckinley_a0_tdr_00000 =
(  NAME   => "BYPASS",
   NOTE   => "BYPASS JTAG Register",
   OPNAME => "BYPASS",
   OPCODE => 0xFF,
   LENGTH => 1,
   RESET  => [ 0x00000000 ],
   FIELDS => \%mckinley_a0_flds_00000
);


#-----------------------------------
#  TDR DEFINITION: IDCODE
#-----------------------------------

%mckinley_a0_flds_00001 =
#  NAME                     IND  POS  LEN  MODE    DESCRIPTION
#  -------------------      ---  ---  ---  ------  -----------------------
(  "VERSION",          => [   0,  28,   4, 0x0000, "Version number"         ],
   "PARTNUMBER",       => [   1,  12,  16, 0x0000, "Partnumber"             ],
   "MANUFACTURER",     => [   2,   1,  11, 0x0000, "Manufacturer Code"      ],
   "LSB",              => [   3,   0,   1, 0x0000, "Mandatory LSB"          ]
);

%mckinley_a0_tdr_00001 =
(  NAME   => "IDCODE",
   NOTE   => "JTAG Device Identification Register",
   OPNAME => "IDCODE",
   OPCODE => 0x02,
   LENGTH => 32,
   RESET  => [ 0x00000000 ],
   FIELDS => \%mckinley_a0_flds_00001
);


#-----------------------------------
#  HASH TABLE: LOOKUP TDR BY OPNAME
#-----------------------------------

%mckinley_a0_tdrs =
(  $mckinley_a0_tdr_00000{OPNAME} => \%mckinley_a0_tdr_00000,
   $mckinley_a0_tdr_00001{OPNAME} => \%mckinley_a0_tdr_00001
);


#-----------------------------------
#  ARRAY: STORE OPNAMES IN "ORDER"
#-----------------------------------

@mckinley_a0_opnames =
(  $mckinley_a0_tdr_00001{OPNAME},
   $mckinley_a0_tdr_00000{OPNAME}
);


################################################################################
#   MCKINLEY B1 JTAG OPCODE/TDR DEFINITION
################################################################################

$mckinley_b1_tdr_defined = 0;

#-----------------------------------
#  TDR DEFINITION: BYPASS
#-----------------------------------

%mckinley_b1_flds_00000 =
#  NAME                     IND  POS  LEN  MODE    DESCRIPTION
#  -------------------      ---  ---  ---  ------  -----------------------
(  "RSVD"              => [   0,   0,   1, 0x0000, ""                       ],
);

%mckinley_b1_tdr_00000 =
(  NAME   => "BYPASS",
   NOTE   => "BYPASS JTAG Register",
   OPNAME => "BYPASS",
   OPCODE => 0xFF,
   LENGTH => 1,
   RESET  => [ 0x00000000 ],
   FIELDS => \%mckinley_b1_flds_00000
);


#-----------------------------------
#  TDR DEFINITION: IDCODE
#-----------------------------------

%mckinley_b1_flds_00001 =
#  NAME                     IND  POS  LEN  MODE    DESCRIPTION
#  -------------------      ---  ---  ---  ------  -----------------------
(  "VERSION",          => [   0,  28,   4, 0x0000, "Version number"         ],
   "PARTNUMBER",       => [   1,  12,  16, 0x0000, "Partnumber"             ],
   "MANUFACTURER",     => [   2,   1,  11, 0x0000, "Manufacturer Code"      ],
   "LSB",              => [   3,   0,   1, 0x0000, "Mandatory LSB"          ]
);

%mckinley_b1_tdr_00001 =
(  NAME   => "IDCODE",
   NOTE   => "JTAG Device Identification Register",
   OPNAME => "IDCODE",
   OPCODE => 0x02,
   LENGTH => 32,
   RESET  => [ 0x00000000 ],
   FIELDS => \%mckinley_b1_flds_00001
);


#-----------------------------------
#  HASH TABLE: LOOKUP TDR BY OPNAME
#-----------------------------------

%mckinley_b1_tdrs =
(  $mckinley_b1_tdr_00000{OPNAME} => \%mckinley_b1_tdr_00000,
   $mckinley_b1_tdr_00001{OPNAME} => \%mckinley_b1_tdr_00001
);


#-----------------------------------
#  ARRAY: STORE OPNAMES IN "ORDER"
#-----------------------------------

@mckinley_b1_opnames =
(  $mckinley_b1_tdr_00001{OPNAME},
   $mckinley_b1_tdr_00000{OPNAME}
);


################################################################################
#   MADISON A2/B0 JTAG OPCODE/TDR DEFINITION
################################################################################

$madison_01_tdr_defined = 0;

#-----------------------------------
#  TDR DEFINITION: BYPASS
#-----------------------------------

%madison_01_flds_00000 =
#  NAME                     IND  POS  LEN  MODE    DESCRIPTION
#  -------------------      ---  ---  ---  ------  -----------------------
(  "RSVD"              => [   0,   0,   1, 0x0000, ""                       ],
);

%madison_01_tdr_00000 =
(  NAME   => "BYPASS",
   NOTE   => "BYPASS JTAG Register",
   OPNAME => "BYPASS",
   OPCODE => 0xFF,
   LENGTH => 1,
   RESET  => [ 0x00000000 ],
   FIELDS => \%madison_01_flds_00000
);


#-----------------------------------
#  TDR DEFINITION: IDCODE
#-----------------------------------

%madison_01_flds_00001 =
#  NAME                     IND  POS  LEN  MODE    DESCRIPTION
#  -------------------      ---  ---  ---  ------  -----------------------
(  "VERSION",          => [   0,  28,   4, 0x0000, "Version number"         ],
   "PARTNUMBER",       => [   1,  12,  16, 0x0000, "Partnumber"             ],
   "MANUFACTURER",     => [   2,   1,  11, 0x0000, "Manufacturer Code"      ],
   "LSB",              => [   3,   0,   1, 0x0000, "Mandatory LSB"          ]
);

%madison_01_tdr_00001 =
(  NAME   => "IDCODE",
   NOTE   => "JTAG Device Identification Register",
   OPNAME => "IDCODE",
   OPCODE => 0x02,
   LENGTH => 32,
   RESET  => [ 0x00000000 ],
   FIELDS => \%madison_01_flds_00001
);

#-----------------------------------
#  TDR DEFINITION: BOUNDARY using SAMPLE/PRELOAD
#-----------------------------------

%madison_01_flds_00002 =
#  NAME                     IND  POS  LEN  MODE    DESCRIPTION
#  -------------------      ---  ---  ---  ------  -----------------------
(  "RSVD"              => [   0,   0,1543, 0x0000, ""                       ],
);

%madison_01_tdr_00002 =
(  NAME   => "BOUNDARY_SAMPLE",
   NOTE   => "JTAG Boundary Register (Sample/Preload)",
   OPNAME => "SAMPLE/PRELOAD",
   OPCODE => 0x01,
   LENGTH => 1543,
   RESET  => [ 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
               0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
               0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
               0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
               0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
               0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
               0x00000000 ],
   FIELDS => \%madison_01_flds_00002
);


#-----------------------------------
#  TDR DEFINITION: BOUNDARY using EXTEST
#-----------------------------------

%madison_01_flds_00003 =
#  NAME                     IND  POS  LEN  MODE    DESCRIPTION
#  -------------------      ---  ---  ---  ------  -----------------------
(  "RSVD"              => [   0,   0,1543, 0x0000, ""                       ],
);

%madison_01_tdr_00003 =
(  NAME   => "BOUNDARY_EXTEST",
   NOTE   => "JTAG Boundary Register (Extest)",
   OPNAME => "EXTEST",
   OPCODE => 0x01,
   LENGTH => 1543,
   RESET  => [ 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
               0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
               0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
               0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
               0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
               0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
               0x00000000 ],
   FIELDS => \%madison_01_flds_00003
);


#-----------------------------------
#  HASH TABLE: LOOKUP TDR BY OPNAME
#-----------------------------------

%madison_01_tdrs =
(  $madison_01_tdr_00000{OPNAME} => \%madison_01_tdr_00000,
   $madison_01_tdr_00001{OPNAME} => \%madison_01_tdr_00001,
   $madison_01_tdr_00002{OPNAME} => \%madison_01_tdr_00002,
   $madison_01_tdr_00003{OPNAME} => \%madison_01_tdr_00003
);


#-----------------------------------
#  ARRAY: STORE OPNAMES IN "ORDER"
#-----------------------------------

@madison_01_opnames =
(  $madison_01_tdr_00001{OPNAME},
   $madison_01_tdr_00000{OPNAME},
   $madison_01_tdr_00002{OPNAME},
   $madison_01_tdr_00003{OPNAME}
);



################################################################################
#   SYNERGY JTAG OPCODE/TDR DEFINITION
################################################################################


$syn_00_tdr_defined = 0;

#-----------------------------------
#  TDR DEFINITION: BYPASS
#-----------------------------------

%syn_00_flds_00000 =
#  NAME                     IND  POS  LEN  MODE    DESCRIPTION
#  -------------------      ---  ---  ---  ------  -----------------------
(  "RSVD"              => [   0,   0,   1, 0x0000, ""                       ],
);

%syn_00_tdr_00000 =
(  NAME   => "BYPASS",
   NOTE   => "BYPASS JTAG Register",
   OPNAME => "BYPASS",
   OPCODE => 0x1F,
   LENGTH => 1,
   RESET  => [ 0x00000000 ],
   FIELDS => \%syn_00_flds_00000
);


#-----------------------------------
#  TDR DEFINITION: IDCODE
#-----------------------------------

%syn_00_flds_00001 =
#  NAME                     IND  POS  LEN  MODE    DESCRIPTION
#  -------------------      ---  ---  ---  ------  -----------------------
(  "VERSION",          => [   0,  28,   4, 0x0000, "Version number"         ],
   "PARTNUMBER",       => [   1,  12,  16, 0x0000, "Partnumber"             ],
   "MANUFACTURER",     => [   2,   1,  11, 0x0000, "Manufacturer Code"      ],
   "LSB",              => [   3,   0,   1, 0x0000, "Mandatory LSB"          ]
);

%syn_00_tdr_00001 =
(  NAME   => "IDCODE",
   NOTE   => "JTAG Device Identification Register",
   OPNAME => "IDCODE",
   OPCODE => 0x03,
   LENGTH => 32,
   RESET  => [ 0x00000000 ],
   FIELDS => \%syn_00_flds_00001
);


#-----------------------------------
#  HASH TABLE: LOOKUP TDR BY OPNAME
#-----------------------------------

%syn_00_tdrs =
(  $syn_00_tdr_00000{OPNAME} => \%syn_00_tdr_00000,
   $syn_00_tdr_00001{OPNAME} => \%syn_00_tdr_00001
);


#-----------------------------------
#  ARRAY: STORE OPNAMES IN "ORDER"
#-----------------------------------

@syn_00_opnames =
(  $syn_00_tdr_00001{OPNAME},
   $syn_00_tdr_00000{OPNAME}
);



################################################################################
#   BEDROCK JTAG OPCODE/TDR DEFINITION
################################################################################


$br_00_tdr_defined = 0;

#-----------------------------------
#  TDR DEFINITION: BYPASS
#-----------------------------------

%br_00_flds_00000 =
#  NAME                     IND  POS  LEN  MODE    DESCRIPTION
#  -------------------      ---  ---  ---  ------  -----------------------
(  "RSVD"              => [   0,   0,   1, 0x0000, ""                       ],
);

%br_00_tdr_00000 =
(  NAME   => "BYPASS",
   NOTE   => "BYPASS JTAG Register",
   OPNAME => "BYPASS",
   OPCODE => 0x1F,
   LENGTH => 1,
   RESET  => [ 0x00000000 ],
   FIELDS => \%br_00_flds_00000
);


#-----------------------------------
#  TDR DEFINITION: IDCODE
#-----------------------------------

%br_00_flds_00001 =
#  NAME                     IND  POS  LEN  MODE    DESCRIPTION
#  -------------------      ---  ---  ---  ------  -----------------------
(  "VERSION",          => [   0,  28,   4, 0x0000, "Version number"         ],
   "PARTNUMBER",       => [   1,  12,  16, 0x0000, "Partnumber"             ],
   "MANUFACTURER",     => [   2,   1,  11, 0x0000, "Manufacturer Code"      ],
   "LSB",              => [   3,   0,   1, 0x0000, "Mandatory LSB"          ]
);

%br_00_tdr_00001 =
(  NAME   => "IDCODE",
   NOTE   => "JTAG Device Identification Register",
   OPNAME => "IDCODE",
   OPCODE => 0x03,
   LENGTH => 32,
   RESET  => [ 0x00000000 ],
   FIELDS => \%br_00_flds_00001
);


#-----------------------------------
#  TDR DEFINITION: NI LLPTEST
#-----------------------------------

%br_00_flds_00002 =
#  NAME                     IND  POS  LEN  MODE    DESCRIPTION
#  -------------------      ---  ---  ---  ------  -----------------------
(  "RESYNC0"           => [   0,  57,   1, 0x0000, "Reserved"               ],
   "MODE"              => [   1,  56,   1, 0x0000, "Load or initiate test"  ],
   "ERR_CAPTURE"       => [   2,  55,   1, 0x0000, "Capture 1st mpkt w/ error" ],
   "CLEAR"             => [   3,  54,   1, 0x0000, "Clear and arm"          ],
   "FLIT_SELECT"       => [   4,  51,   3, 0x0000, "Flit selection"         ],
   "CRC_ERROR"         => [   5,  50,   1, 0x0000, "CRC error detected"     ],
   "VALID"             => [   6,  49,   1, 0x0000, "Valid flag"             ],
   "DATA"              => [   7,  29,  20, 0x0000, "Captured flit data"     ],
   "MASK"              => [   8,  21,   8, 0x0000, "Mask for packet data"   ],
   "SEED"              => [   9,   1,  20, 0x0000, "Seed for packet data"   ],
   "RESYNC1"           => [  10,   0,   1, 0x0000, "Reserved"               ]
);

%br_00_tdr_00002 =
(  NAME   => "LLPTEST_CORE",
   NOTE   => "NI JTAG LLP channel test register",
   OPNAME => "LLPTEST_CORE",
   OPCODE => 0x16,
   LENGTH => 58,
   RESET  => [ 0x00000000, 0x00000000 ],
   FIELDS => \%br_00_flds_00002
);

#-----------------------------------
#  HASH TABLE: LOOKUP TDR BY OPNAME
#-----------------------------------

%br_00_tdrs =
(  $br_00_tdr_00000{OPNAME} => \%br_00_tdr_00000,
   $br_00_tdr_00001{OPNAME} => \%br_00_tdr_00001,
   $br_00_tdr_00002{OPNAME} => \%br_00_tdr_00002
);


#-----------------------------------
#  ARRAY: STORE OPNAMES IN "ORDER"
#-----------------------------------

@br_00_opnames =
(  $br_00_tdr_00000{OPNAME},
   $br_00_tdr_00001{OPNAME},
   $br_00_tdr_00002{OPNAME}
);


################################################################################
#   SN1 ROUTER JTAG OPCODE/TDR DEFINITION
################################################################################


$rtr_00_tdr_defined = 0;

#-----------------------------------
#  TDR DEFINITION: BYPASS
#-----------------------------------

%rtr_00_flds_00000 =
#  NAME                     IND  POS  LEN  MODE    DESCRIPTION
#  -------------------      ---  ---  ---  ------  -----------------------
(  "RSVD"              => [   0,   0,   1, 0x0000, ""                       ],
);

%rtr_00_tdr_00000 =
(  NAME   => "BYPASS",
   NOTE   => "BYPASS JTAG Register",
   OPNAME => "BYPASS",
   OPCODE => 0x1F,
   LENGTH => 1,
   RESET  => [ 0x00000000 ],
   FIELDS => \%rtr_00_flds_00000
);


#-----------------------------------
#  TDR DEFINITION: IDCODE
#-----------------------------------

%rtr_00_flds_00001 =
#  NAME                     IND  POS  LEN  MODE    DESCRIPTION
#  -------------------      ---  ---  ---  ------  -----------------------
(  "VERSION",          => [   0,  28,   4, 0x0000, "Version number"         ],
   "PARTNUMBER",       => [   1,  12,  16, 0x0000, "Partnumber"             ],
   "MANUFACTURER",     => [   2,   1,  11, 0x0000, "Manufacturer Code"      ],
   "LSB",              => [   3,   0,   1, 0x0000, "Mandatory LSB"          ]
);

%rtr_00_tdr_00001 =
(  NAME   => "IDCODE",
   NOTE   => "JTAG Device Identification Register",
   OPNAME => "IDCODE",
   OPCODE => 0x03,
   LENGTH => 32,
   RESET  => [ 0x00000000 ],
   FIELDS => \%rtr_00_flds_00001
);


#-----------------------------------
#  TDR DEFINITION: GMR
#-----------------------------------

%rtr_00_flds_00002 =
#  NAME                     IND  POS  LEN  MODE    DESCRIPTION
#  -------------------      ---  ---  ---  ------  -----------------------
(  "RSVD"              => [   0,   0,   1, 0x0000, ""                       ],
);

%rtr_00_tdr_00002 =
(  NAME   => "GMR",
   NOTE   => "Give Me Reset (GMR)",
   OPNAME => "GMR",
   OPCODE => 0x0B,
   LENGTH => 1,
   RESET  => [ 0x00000000 ],
   FIELDS => \%rtr_00_flds_00002
);


#-----------------------------------
#  TDR DEFINITION: LLPTST_ABCH
#-----------------------------------

%rtr_00_flds_00003 =
#  NAME                     IND  POS  LEN  MODE    DESCRIPTION
#  -------------------      ---  ---  ---  ------  -----------------------
(  "RSVD1"             => [   0,  59,   1, 0x0000, ""                       ],
   "PORT_SEL"          => [   1,  57,   2, 0x0000, "Port: 0=A 1=B 2=C 3=H"  ],
   "LLP_RESET"         => [   2,  56,   1, 0x0000, "Load or initiate test"  ],
   "ERR_CAPTURE"       => [   3,  55,   1, 0x0000, "Capture 1st mpkt w/ error" ],
   "CLEAR"             => [   4,  54,   1, 0x0000, "Clear and arm"          ],
   "FLIT_SELECT"       => [   5,  51,   3, 0x0000, "Flit selection"         ],
   "CRC_ERROR"         => [   6,  50,   1, 0x0000, "CRC error detected"     ],
   "VALID"             => [   7,  49,   1, 0x0000, "Valid flag"             ],
   "DATA"              => [   8,  29,  20, 0x0000, "Captured flit data"     ],
   "MASK"              => [   9,  21,   8, 0x0000, "Mask for packet data"   ],
   "SEED"              => [  10,   1,  20, 0x0000, "Seed for packet data"   ],
   "RSVD0"             => [  11,   0,   1, 0x0000, ""                       ],
);

%rtr_00_tdr_00003 =
(  NAME   => "LLPTST_ABCH",
   NOTE   => "Channel test control ports H-C",
   OPNAME => "LLPTST_ABCH",
   OPCODE => 0x16,
   LENGTH => 60,
   RESET  => [ 0x00000000, 0x00000000 ],
   FIELDS => \%rtr_00_flds_00003
);


#-----------------------------------
#  TDR DEFINITION: LLPTST_DEFG
#-----------------------------------

%rtr_00_flds_00004 =
#  NAME                     IND  POS  LEN  MODE    DESCRIPTION
#  -------------------      ---  ---  ---  ------  -----------------------
(  "RSVD1"             => [   0,  59,   1, 0x0000, ""                       ],
   "PORT_SEL"          => [   1,  57,   2, 0x0000, "Port: 0=D 1=E 2=F 3=G"  ],
   "LLP_RESET"         => [   2,  56,   1, 0x0000, "Load or initiate test"  ],
   "ERR_CAPTURE"       => [   3,  55,   1, 0x0000, "Capture 1st mpkt w/ error" ],
   "CLEAR"             => [   4,  54,   1, 0x0000, "Clear and arm"          ],
   "FLIT_SELECT"       => [   5,  51,   3, 0x0000, "Flit selection"         ],
   "CRC_ERROR"         => [   6,  50,   1, 0x0000, "CRC error detected"     ],
   "VALID"             => [   7,  49,   1, 0x0000, "Valid flag"             ],
   "DATA"              => [   8,  29,  20, 0x0000, "Captured flit data"     ],
   "MASK"              => [   9,  21,   8, 0x0000, "Mask for packet data"   ],
   "SEED"              => [  10,   1,  20, 0x0000, "Seed for packet data"   ],
   "RSVD0"             => [  11,   0,   1, 0x0000, ""                       ],
);

%rtr_00_tdr_00004 =
(  NAME   => "LLPTST_DEFG",
   NOTE   => "Channel test control ports D-G",
   OPNAME => "LLPTST_DEFG",
   OPCODE => 0x17,
   LENGTH => 60,
   RESET  => [ 0x00000000, 0x00000000 ],
   FIELDS => \%rtr_00_flds_00004
);


#-----------------------------------
#  HASH TABLE: LOOKUP TDR BY OPNAME
#-----------------------------------

%rtr_00_tdrs =
(  $rtr_00_tdr_00000{OPNAME} => \%rtr_00_tdr_00000,
   $rtr_00_tdr_00001{OPNAME} => \%rtr_00_tdr_00001,
   $rtr_00_tdr_00002{OPNAME} => \%rtr_00_tdr_00002,
   $rtr_00_tdr_00003{OPNAME} => \%rtr_00_tdr_00003,
   $rtr_00_tdr_00004{OPNAME} => \%rtr_00_tdr_00004
);


#-----------------------------------
#  ARRAY: STORE OPNAMES IN "ORDER"
#-----------------------------------

@rtr_00_opnames =
(  $rtr_00_tdr_00001{OPNAME},
   $rtr_00_tdr_00000{OPNAME},
   $rtr_00_tdr_00002{OPNAME},
   $rtr_00_tdr_00003{OPNAME},
   $rtr_00_tdr_00004{OPNAME}
);




################################################################################

1;
