
$nl4rtr_01_tdr_defined = 0;

#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00000 =
#  NAME                     IND  POS  LEN  MODE    DESCRIPTION
#  -------------------      ---  ---  ---  ------  -----------------------
(  "RSVD"              => [   0,   0,   1, 0x0000, ""                       ],
);

%nl4rtr_01_tdr_00000 =
(  NAME   => "BYPASS",
   NOTE   => "BYPASS JTAG Register",
   OPNAME => "BYPASS",
   OPCODE => 0x7F,
   LENGTH => 1,
   RESET  => [ 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00000
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00001 =
#  NAME                     IND  POS  LEN  MODE    DESCRIPTION
#  -------------------      ---  ---  ---  ------  -----------------------
(  "VERSION",          => [   0,  28,   4, 0x0000, "Version number"         ],
   "PARTNUMBER",       => [   1,  12,  16, 0x0000, "Partnumber"             ],
   "MANUFACTURER",     => [   2,   1,  11, 0x0000, "Manufacturer Code"      ],
   "LSB",              => [   3,   0,   1, 0x0000, "Mandatory LSB"          ]
);

%nl4rtr_01_tdr_00001 =
(  NAME   => "IDCODE",
   NOTE   => "JTAG Device Identification Register",
   OPNAME => "IDCODE",
   OPCODE => 0x03,
   LENGTH => 32,
   RESET  => [ 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00001
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00002 =
#  NAME                         IND  POS  LEN  MODE    DESCRIPTION
#  -------------------          ---  ---  ---  ------  -----------------------
(  "SPARE"                 => [   0,   1,   1, 0x0000, "Spare bit" ],
   "EXT_CLK_SEL"           => [   1,   0,   1, 0x0000, "Select external clock" ],
);

%nl4rtr_01_tdr_00002 =
(  NAME   => "CONFIG",
   NOTE   => "NL4RTR Pre-reset Configuration",
   OPNAME => "CONFIG",
   OPCODE => 0x7E,
   LENGTH => 2,
   RESET  => [ 0x0000000 ],
   FIELDS => \%nl4rtr_01_flds_00002
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00003 =
#  NAME                     IND  POS  LEN  MODE    DESCRIPTION
#  -------------------      ---  ---  ---  ------  -----------------------
(  "RSVD"              => [   0,   0,   1, 0x0000, ""                       ],
);

%nl4rtr_01_tdr_00003 =
(  NAME   => "TDR_DEFAULT",
   NOTE   => "Reset Specific TDRs to default values",
   OPNAME => "TDR_DEFAULT",
   OPCODE => 0x7C,
   LENGTH => 1,
   RESET  => [ 0x0 ],
   FIELDS => \%nl4rtr_01_flds_00003
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00004 =
#  NAME                     IND  POS  LEN  MODE    DESCRIPTION
#  -------------------      ---  ---  ---  ------  -----------------------
(  "RSVD"              => [   0,   0,   1, 0x0000, ""                       ],
);

%nl4rtr_01_tdr_00004 =
(  NAME   => "JCLK_RST",
   NOTE   => "Clock Controller Reset Instruction",
   OPNAME => "JCLK_RST",
   OPCODE => 0x7D,
   LENGTH => 1,
   RESET  => [ 0x0 ],
   FIELDS => \%nl4rtr_01_flds_00004
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00005 =
#  NAME                     IND  POS  LEN  MODE    DESCRIPTION
#  -------------------      ---  ---  ---  ------  -----------------------
(  "GMXC_LOAD"         => [   0,  47,   4, 0x0000, "" ],
   "GMXC_SEQ"          => [   1,  27,  20, 0x0000, "" ],
   "SLOW1CLK"          => [   2,  26,   1, 0x0000, "" ],
   "SLOW2CLK"          => [   3,  25,   1, 0x0000, "" ],
   "GMXC_TDR_SEL"      => [   4,   8,  17, 0x0000, "" ],
   "TP"                => [   5,   2,   6, 0x0000, "" ],
   "SEL_CLKSTOP"       => [   6,   1,   1, 0x0000, "" ],
   "JTAG_CLKSTOP"      => [   7,   0,   1, 0x0000, "" ],
);

%nl4rtr_01_tdr_00005 =
(  NAME   => "CLKCNTL",
   NOTE   => "NL4RTR Clock Control Register",
   OPNAME => "CLKCNTL",
   OPCODE => 0x07,
   LENGTH => 51,
   RESET  => [ 0x00000000, 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00005
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00006 =
#  NAME                         IND  POS  LEN  MODE    DESCRIPTION
#  -------------------          ---  ---  ---  ------  -----------------------
(  "WRAP_JTAG_SCAN_ACCESS" => [   0,  10,  10, 0x0000, "Scan access bits for RAM wrappers" ],
   "CIR"                   => [   1,   9,   1, 0x0000, "Circulate TDO to TDI"              ],
   "INV"                   => [   2,   8,   1, 0x0000, "Invert circlated TDO value"        ],
   "NL3_CONFIG"            => [   3,   0,   8, 0x0000, "Config bit per channel (1=NL3)"    ]
);

%nl4rtr_01_tdr_00006 =
(  NAME   => "SCAN_CTL",
   NOTE   => "Controls gmoc_mode and scan access",
   OPNAME => "SCAN_CTL",
   OPCODE => 0x05,
   LENGTH => 20,
   RESET  => [ 0x00000 ],
   FIELDS => \%nl4rtr_01_flds_00006
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00007 =
#  NAME                     IND  POS  LEN  MODE    DESCRIPTION
#  -------------------      ---  ---  ---  ------  -----------------------
(  "VALUE"             => [   0,   0,  24, 0x0000, "Time to ignore any warm reset input" ],
);

%nl4rtr_01_tdr_00007 =
(  NAME   => "WARM_FENCE",
   NOTE   => "WARM_FENCE Register",
   OPNAME => "WARM_FENCE",
   OPCODE => 0x4B,
   LENGTH => 24,
   RESET  => [ 0x0 ],
   FIELDS => \%nl4rtr_01_flds_00007
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00008 =
#  NAME                       IND  POS  LEN  MODE    DESCRIPTION
#  -------------------        ---  ---  ---  ------  -----------------------
(  "PORTH_CLK_I_TERM_H"    => [   0,  31,   1, 0x0000, "Term value for *_i_clk_h" ],
   "PORTH_CLK_I_TERM_L"    => [   1,  30,   1, 0x0000, "Term value for *_i_clk_l" ],
   "PORTH_DATA_F_TERM_H"   => [   2,  29,   1, 0x0000, "Term value for *_data_f_h[19:0], *_idr_b_of_h" ],   
   "PORTH_DATA_F_TERM_L"   => [   3,  28,   1, 0x0000, "Term value for *_data_f_l[19:0], *_idr_b_of_l" ],
   "PORTG_CLK_I_TERM_H"    => [   4,  27,   1, 0x0000, "Term value for *_i_clk_h" ],
   "PORTG_CLK_I_TERM_L"    => [   5,  26,   1, 0x0000, "Term value for *_i_clk_l" ],
   "PORTG_DATA_F_TERM_H"   => [   6,  25,   1, 0x0000, "Term value for *_data_f_h[19:0], *_idr_b_of_h" ],   
   "PORTG_DATA_F_TERM_L"   => [   7,  24,   1, 0x0000, "Term value for *_data_f_l[19:0], *_idr_b_of_l" ],
   "PORTF_CLK_I_TERM_H"    => [   8,  23,   1, 0x0000, "Term value for *_i_clk_h" ],
   "PORTF_CLK_I_TERM_L"    => [   9,  22,   1, 0x0000, "Term value for *_i_clk_l" ],
   "PORTF_DATA_F_TERM_H"   => [  10,  21,   1, 0x0000, "Term value for *_data_f_h[19:0], *_idr_b_of_h" ],   
   "PORTF_DATA_F_TERM_L"   => [  11,  20,   1, 0x0000, "Term value for *_data_f_l[19:0], *_idr_b_of_l" ],
   "PORTE_CLK_I_TERM_H"    => [  12,  19,   1, 0x0000, "Term value for *_i_clk_h" ],
   "PORTE_CLK_I_TERM_L"    => [  13,  18,   1, 0x0000, "Term value for *_i_clk_l" ],
   "PORTE_DATA_F_TERM_H"   => [  14,  17,   1, 0x0000, "Term value for *_data_f_h[19:0], *_idr_b_of_h" ],   
   "PORTE_DATA_F_TERM_L"   => [  15,  16,   1, 0x0000, "Term value for *_data_f_l[19:0], *_idr_b_of_l" ],
   "PORTD_CLK_I_TERM_H"    => [  16,  15,   1, 0x0000, "Term value for *_i_clk_h" ],
   "PORTD_CLK_I_TERM_L"    => [  17,  14,   1, 0x0000, "Term value for *_i_clk_l" ],
   "PORTD_DATA_F_TERM_H"   => [  18,  13,   1, 0x0000, "Term value for *_data_f_h[19:0], *_idr_b_of_h" ],   
   "PORTD_DATA_F_TERM_L"   => [  19,  12,   1, 0x0000, "Term value for *_data_f_l[19:0], *_idr_b_of_l" ],
   "PORTC_CLK_I_TERM_H"    => [  20,  11,   1, 0x0000, "Term value for *_i_clk_h" ],
   "PORTC_CLK_I_TERM_L"    => [  21,  10,   1, 0x0000, "Term value for *_i_clk_l" ],
   "PORTC_DATA_F_TERM_H"   => [  22,   9,   1, 0x0000, "Term value for *_data_f_h[19:0], *_idr_b_of_h" ],   
   "PORTC_DATA_F_TERM_L"   => [  23,   8,   1, 0x0000, "Term value for *_data_f_l[19:0], *_idr_b_of_l" ],
   "PORTB_CLK_I_TERM_H"    => [  24,   7,   1, 0x0000, "Term value for *_i_clk_h" ],
   "PORTB_CLK_I_TERM_L"    => [  25,   6,   1, 0x0000, "Term value for *_i_clk_l" ],
   "PORTB_DATA_F_TERM_H"   => [  26,   5,   1, 0x0000, "Term value for *_data_f_h[19:0], *_idr_b_of_h" ],   
   "PORTB_DATA_F_TERM_L"   => [  27,   4,   1, 0x0000, "Term value for *_data_f_l[19:0], *_idr_b_of_l" ],
   "PORTA_CLK_I_TERM_H"    => [  28,   3,   1, 0x0000, "Term value for *_i_clk_h" ],
   "PORTA_CLK_I_TERM_L"    => [  29,   2,   1, 0x0000, "Term value for *_i_clk_l" ],
   "PORTA_DATA_F_TERM_H"   => [  30,   1,   1, 0x0000, "Term value for *_data_f_h[19:0], *_idr_b_of_h" ],   
   "PORTA_DATA_F_TERM_L"   => [  31,   0,   1, 0x0000, "Term value for *_data_f_l[19:0], *_idr_b_of_l" ]
);

%nl4rtr_01_tdr_00008 =
(  NAME   => "NL3_TERM",
   NOTE   => "NL termination value selection",
   OPNAME => "NL3_TERM",
   OPCODE => 0x09,
   LENGTH => 32,
   RESET  => [ 0xFF ],
   FIELDS => \%nl4rtr_01_flds_00008
);


#-------------------------------------------------------------------------------

#  NOTE : need to confirm the order of the _REFIO_VALUE fields!!!

%nl4rtr_01_flds_00009 =
#  NAME                     IND  POS  LEN  MODE    DESCRIPTION
#  -------------------      ---  ---  ---  ------  -----------------------
(  "SR_H_N_REFIO_VALUE", => [  95, 327,   9, 0x0000, "srH reference IO value for pvtn" ],
   "SR_H_P_REFIO_VALUE", => [  94, 318,   9, 0x0000, "srH reference IO value for pvtp" ],
   "SR_G_N_REFIO_VALUE", => [  93, 309,   9, 0x0000, "srG reference IO value for pvtn" ],
   "SR_G_P_REFIO_VALUE", => [  92, 300,   9, 0x0000, "srG reference IO value for pvtp" ],
   "SR_F_N_REFIO_VALUE", => [  91, 291,   9, 0x0000, "srF reference IO value for pvtn" ],
   "SR_F_P_REFIO_VALUE", => [  90, 282,   9, 0x0000, "srF reference IO value for pvtp" ],
   "SR_E_N_REFIO_VALUE", => [  89, 273,   9, 0x0000, "srE reference IO value for pvtn" ],
   "SR_E_P_REFIO_VALUE", => [  88, 264,   9, 0x0000, "srE reference IO value for pvtp" ],
   "SR_D_N_REFIO_VALUE", => [  87, 255,   9, 0x0000, "srD reference IO value for pvtn" ],
   "SR_D_P_REFIO_VALUE", => [  86, 246,   9, 0x0000, "srD reference IO value for pvtp" ],
   "SR_C_N_REFIO_VALUE", => [  85, 237,   9, 0x0000, "srC reference IO value for pvtn" ],
   "SR_C_P_REFIO_VALUE", => [  84, 228,   9, 0x0000, "srC reference IO value for pvtp" ],
   "SR_B_N_REFIO_VALUE", => [  83, 219,   9, 0x0000, "srB reference IO value for pvtn" ],
   "SR_B_P_REFIO_VALUE", => [  82, 210,   9, 0x0000, "srB reference IO value for pvtp" ],
   "SR_A_N_REFIO_VALUE", => [  81, 201,   9, 0x0000, "srA reference IO value for pvtn" ],
   "SR_A_P_REFIO_VALUE", => [  80, 192,   9, 0x0000, "srA reference IO value for pvtp" ],
   "SR_H_FILTER",        => [  79, 191,   1, 0x0000, "srH filter select" ],
   "SR_H_BYPASS",        => [  78, 190,   1, 0x0000, "srH bypass sequencer" ],
   "SR_H_DISABLE",       => [  77, 189,   1, 0x0000, "srH disable controller" ],
   "SR_H_RESET",         => [  76, 188,   1, 0x0000, "srH reset controller" ],
   "SR_H_N_TDR_VALUE",   => [  75, 180,   8, 0x0000, "srH value to apply to pvt_sys_n output" ],
   "SR_H_P_TDR_VALUE",   => [  74, 172,   8, 0x0000, "srH value to apply to pvt_sys_p output" ],
   "SR_H_SEL_TDR_VAL",   => [  73, 171,   1, 0x0000, "srH select TDR value" ],
   "SR_H_N_UPDN",        => [  72, 170,   1, 0x0000, "srH override value applied to nfet" ],
   "SR_H_P_UPDN",        => [  71, 169,   1, 0x0000, "srH override value applied to pfet" ],
   "SR_H_OVRD_UPDN",     => [  70, 168,   1, 0x0000, "srH override up/down control" ],
   "SR_G_FILTER",        => [  69, 167,   1, 0x0000, "srG filter select" ],
   "SR_G_BYPASS",        => [  68, 166,   1, 0x0000, "srG bypass sequencer" ],
   "SR_G_DISABLE",       => [  67, 165,   1, 0x0000, "srG disable controller" ],
   "SR_G_RESET",         => [  66, 164,   1, 0x0000, "srG reset controller" ],
   "SR_G_N_TDR_VALUE",   => [  65, 156,   8, 0x0000, "srG value to apply to pvt_sys_n output" ],
   "SR_G_P_TDR_VALUE",   => [  64, 148,   8, 0x0000, "srG value to apply to pvt_sys_p output" ],
   "SR_G_SEL_TDR_VAL",   => [  63, 147,   1, 0x0000, "srG select TDR value" ],
   "SR_G_N_UPDN",        => [  62, 146,   1, 0x0000, "srG override value applied to nfet" ],
   "SR_G_P_UPDN",        => [  61, 145,   1, 0x0000, "srG override value applied to pfet" ],
   "SR_G_OVRD_UPDN",     => [  60, 144,   1, 0x0000, "srG override up/down control" ],
   "SR_F_FILTER",        => [  59, 143,   1, 0x0000, "srF filter select" ],
   "SR_F_BYPASS",        => [  58, 142,   1, 0x0000, "srF bypass sequencer" ],
   "SR_F_DISABLE",       => [  57, 141,   1, 0x0000, "srF disable controller" ],
   "SR_F_RESET",         => [  56, 140,   1, 0x0000, "srF reset controller" ],
   "SR_F_N_TDR_VALUE",   => [  55, 132,   8, 0x0000, "srF value to apply to pvt_sys_n output" ],
   "SR_F_P_TDR_VALUE",   => [  54, 124,   8, 0x0000, "srF value to apply to pvt_sys_p output" ],
   "SR_F_SEL_TDR_VAL",   => [  53, 123,   1, 0x0000, "srF select TDR value" ],
   "SR_F_N_UPDN",        => [  52, 122,   1, 0x0000, "srF override value applied to nfet" ],
   "SR_F_P_UPDN",        => [  51, 121,   1, 0x0000, "srF override value applied to pfet" ],
   "SR_F_OVRD_UPDN",     => [  50, 120,   1, 0x0000, "srF override up/down control" ],
   "SR_E_FILTER",        => [  49, 119,   1, 0x0000, "srE filter select" ],
   "SR_E_BYPASS",        => [  48, 118,   1, 0x0000, "srE bypass sequencer" ],
   "SR_E_DISABLE",       => [  47, 117,   1, 0x0000, "srE disable controller" ],
   "SR_E_RESET",         => [  46, 116,   1, 0x0000, "srE reset controller" ],
   "SR_E_N_TDR_VALUE",   => [  45, 108,   8, 0x0000, "srE value to apply to pvt_sys_n output" ],
   "SR_E_P_TDR_VALUE",   => [  44, 100,   8, 0x0000, "srE value to apply to pvt_sys_p output" ],
   "SR_E_SEL_TDR_VAL",   => [  43,  99,   1, 0x0000, "srE select TDR value" ],
   "SR_E_N_UPDN",        => [  42,  98,   1, 0x0000, "srE override value applied to nfet" ],
   "SR_E_P_UPDN",        => [  41,  97,   1, 0x0000, "srE override value applied to pfet" ],
   "SR_E_OVRD_UPDN",     => [  40,  96,   1, 0x0000, "srE override up/down control" ],
   "SR_D_FILTER",        => [  39,  95,   1, 0x0000, "srD filter select" ],
   "SR_D_BYPASS",        => [  38,  94,   1, 0x0000, "srD bypass sequencer" ],
   "SR_D_DISABLE",       => [  37,  93,   1, 0x0000, "srD disable controller" ],
   "SR_D_RESET",         => [  36,  92,   1, 0x0000, "srD reset controller" ],
   "SR_D_N_TDR_VALUE",   => [  35,  84,   8, 0x0000, "srD value to apply to pvt_sys_n output" ],
   "SR_D_P_TDR_VALUE",   => [  34,  76,   8, 0x0000, "srD value to apply to pvt_sys_p output" ],
   "SR_D_SEL_TDR_VAL",   => [  33,  75,   1, 0x0000, "srD select TDR value" ],
   "SR_D_N_UPDN",        => [  32,  74,   1, 0x0000, "srD override value applied to nfet" ],
   "SR_D_P_UPDN",        => [  31,  73,   1, 0x0000, "srD override value applied to pfet" ],
   "SR_D_OVRD_UPDN",     => [  30,  72,   1, 0x0000, "srD override up/down control" ],
   "SR_C_FILTER",        => [  29,  71,   1, 0x0000, "srC filter select" ],
   "SR_C_BYPASS",        => [  28,  70,   1, 0x0000, "srC bypass sequencer" ],
   "SR_C_DISABLE",       => [  27,  69,   1, 0x0000, "srC disable controller" ],
   "SR_C_RESET",         => [  26,  68,   1, 0x0000, "srC reset controller" ],
   "SR_C_N_TDR_VALUE",   => [  25,  60,   8, 0x0000, "srC value to apply to pvt_sys_n output" ],
   "SR_C_P_TDR_VALUE",   => [  24,  52,   8, 0x0000, "srC value to apply to pvt_sys_p output" ],
   "SR_C_SEL_TDR_VAL",   => [  23,  51,   1, 0x0000, "srC select TDR value" ],
   "SR_C_N_UPDN",        => [  22,  50,   1, 0x0000, "srC override value applied to nfet" ],
   "SR_C_P_UPDN",        => [  21,  49,   1, 0x0000, "srC override value applied to pfet" ],
   "SR_C_OVRD_UPDN",     => [  20,  48,   1, 0x0000, "srC override up/down control" ],
   "SR_B_FILTER",        => [  19,  47,   1, 0x0000, "srB filter select" ],
   "SR_B_BYPASS",        => [  18,  46,   1, 0x0000, "srB bypass sequencer" ],
   "SR_B_DISABLE",       => [  17,  45,   1, 0x0000, "srB disable controller" ],
   "SR_B_RESET",         => [  16,  44,   1, 0x0000, "srB reset controller" ],
   "SR_B_N_TDR_VALUE",   => [  15,  36,   8, 0x0000, "srB value to apply to pvt_sys_n output" ],
   "SR_B_P_TDR_VALUE",   => [  14,  28,   8, 0x0000, "srB value to apply to pvt_sys_p output" ],
   "SR_B_SEL_TDR_VAL",   => [  13,  27,   1, 0x0000, "srB select TDR value" ],
   "SR_B_N_UPDN",        => [  12,  26,   1, 0x0000, "srB override value applied to nfet" ],
   "SR_B_P_UPDN",        => [  11,  25,   1, 0x0000, "srB override value applied to pfet" ],
   "SR_B_OVRD_UPDN",     => [  10,  24,   1, 0x0000, "srB override up/down control" ],
   "SR_A_FILTER",        => [   9,  23,   1, 0x0000, "srA filter select" ],
   "SR_A_BYPASS",        => [   8,  22,   1, 0x0000, "srA bypass sequencer" ],
   "SR_A_DISABLE",       => [   7,  21,   1, 0x0000, "srA disable controller" ],
   "SR_A_RESET",         => [   6,  20,   1, 0x0000, "srA reset controller" ],
   "SR_A_N_TDR_VALUE",   => [   5,  12,   8, 0x0000, "srA value to apply to pvt_sys_n output" ],
   "SR_A_P_TDR_VALUE",   => [   4,   4,   8, 0x0000, "srA value to apply to pvt_sys_p output" ],
   "SR_A_SEL_TDR_VAL",   => [   3,   3,   1, 0x0000, "srA select TDR value" ],
   "SR_A_N_UPDN",        => [   2,   2,   1, 0x0000, "srA override value applied to nfet" ],
   "SR_A_P_UPDN",        => [   1,   1,   1, 0x0000, "srA override value applied to pfet" ],
   "SR_A_OVRD_UPDN",     => [   0,   0,   1, 0x0000, "srA override up/down control" ]
);

%nl4rtr_01_tdr_00009 =
(  NAME   => "ICNTLR",
   NOTE   => "JTAG Impedance Controller Register",
   OPNAME => "ICNTLR",
   OPCODE => 0x06,
   LENGTH => 336,
   RESET  => [ 0x0000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
               0x0000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
               0x0000000, 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00009
);



#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00010 =
#  NAME                       IND  POS  LEN  MODE    DESCRIPTION
#  -------------------        ---  ---  ---  ------  -----------------------
(  "SPARE"               => [   0,  23,   4, 0x0000, "Spare register bits"                   ],
   "OBSERVE_ENABLE"      => [   1,  22,   1, 0x0000, "Enable observation circuitry"          ],
   "DATA_CLK_MUX_SEL"    => [   2,  21,   1, 0x0000, "Observation of clock or data (data=0)" ],
   "PFSSD_SYNC_MODE"     => [   3,  20,   1, 0x0000, "PFSSD sync mode"   ],
   "PFSSD_DEBUG_SEL"     => [   4,  18,   2, 0x0000, "PFSSD testpoint select"   ],
   "PFSSR_DEBUG_SEL"     => [   5,  12,   6, 0x0000, "PFSSR testpoint select"   ],
   "DAVAIL_SEL"          => [   6,  10,   2, 0x0000, "Control timing of data available signal" ],
   "CLK_ADAPT_HOLD_MODE" => [   7,   9,   1, 0x0000, "Delay controller mode of operation"         ],
   "SAMP_TIM_SEL"        => [   8,   8,   1, 0x0000, "Mode to provide additional collection time" ],
   "FMODE_JTAG_VAL"      => [   9,   7,   1, 0x0000, "JTAG FMODE value"                        ],
   "FMODE_JTAG_EN"       => [  10,   6,   1, 0x0000, "Enable JTAG control of FMODE bit"        ],
   "UPDATE_AFTER_CNT_EN" => [  11,   5,   1, 0x0000, "" ],
   "LLP_TUNING_CMPLT_EN" => [  12,   4,   1, 0x0000, "" ],
   "RMT_UPDATE_EN"       => [  13,   3,   1, 0x0000, "Enable remote fine update (via LLP)"     ],
   "DLINE_MAN_ADJ_EN"    => [  14,   2,   1, 0x0000, "Enable manual adjust mode"               ],
   "DLINE_MAN_HOLD"      => [  15,   1,   1, 0x0000, "Hold current delay value"                ],
   "DLY_CTRL_RESET"      => [  16,   0,   1, 0x0000, "Hold delay controller in reset if set"   ]

);

%nl4rtr_01_tdr_00010 =
(  NAME   => "DLY_CTRLA_0",
   NOTE   => "DLY_CTRLA_0 PFSSR Control",
   OPNAME => "DLY_CTRLA_0",
   OPCODE => 0x60,
   LENGTH => 27,
   RESET  => [ 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00010
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00011 =
#  NAME                     IND  POS  LEN  MODE    DESCRIPTION
#  -------------------      ---  ---  ---  ------  -----------------------
(  "FDE19"             => [   0,  32,   1, 0x0000, "" ],
   "FCE19"             => [   1,  31,   1, 0x0000, "" ],
   "DE19"              => [   2,  30,   1, 0x0000, "" ],
   "CE19"              => [   3,  29,   1, 0x0000, "" ],
   "DMAX"              => [   4,  22,   7, 0x0000, "" ],
   "DMIN"              => [   5,  15,   7, 0x0000, "" ],
   "DMCOUT"            => [   6,   8,   7, 0x0000, "" ],
   "DLINE_AND_DMC_SEL" => [   7,   2,   6, 0x0000, "" ],
   "DLINE_SHIFT_OP"    => [   8,   0,   2, 0x0000, "" ],
);


%nl4rtr_01_tdr_00011 =
(  NAME   => "DLY_CTRLA_1",
   NOTE   => "DLY_CTRLA_1 PFSSR Control",
   OPNAME => "DLY_CTRLA_1",
   OPCODE => 0x61,
   LENGTH => 33,
   RESET  => [ 0x0, 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00011
);

#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00012 =
#  NAME                       IND  POS  LEN  MODE    DESCRIPTION
#  -------------------        ---  ---  ---  ------  -----------------------
(  "SPARE"               => [   0,  23,   4, 0x0000, "Spare register bits"                   ],
   "OBSERVE_ENABLE"      => [   1,  22,   1, 0x0000, "Enable observation circuitry"          ],
   "DATA_CLK_MUX_SEL"    => [   2,  21,   1, 0x0000, "Observation of clock or data (data=0)" ],
   "PFSSD_SYNC_MODE"     => [   3,  20,   1, 0x0000, "PFSSD sync mode"   ],
   "PFSSD_DEBUG_SEL"     => [   4,  18,   2, 0x0000, "PFSSD testpoint select"   ],
   "PFSSR_DEBUG_SEL"     => [   5,  12,   6, 0x0000, "PFSSR testpoint select"   ],
   "DAVAIL_SEL"          => [   6,  10,   2, 0x0000, "Control timing of data available signal" ],
   "CLK_ADAPT_HOLD_MODE" => [   7,   9,   1, 0x0000, "Delay controller mode of operation"         ],
   "SAMP_TIM_SEL"        => [   8,   8,   1, 0x0000, "Mode to provide additional collection time" ],
   "FMODE_JTAG_VAL"      => [   9,   7,   1, 0x0000, "JTAG FMODE value"                        ],
   "FMODE_JTAG_EN"       => [  10,   6,   1, 0x0000, "Enable JTAG control of FMODE bit"        ],
   "UPDATE_AFTER_CNT_EN" => [  11,   5,   1, 0x0000, "" ],
   "LLP_TUNING_CMPLT_EN" => [  12,   4,   1, 0x0000, "" ],
   "RMT_UPDATE_EN"       => [  13,   3,   1, 0x0000, "Enable remote fine update (via LLP)"     ],
   "DLINE_MAN_ADJ_EN"    => [  14,   2,   1, 0x0000, "Enable manual adjust mode"               ],
   "DLINE_MAN_HOLD"      => [  15,   1,   1, 0x0000, "Hold current delay value"                ],
   "DLY_CTRL_RESET"      => [  16,   0,   1, 0x0000, "Hold delay controller in reset if set"   ]

);

%nl4rtr_01_tdr_00012 =
(  NAME   => "DLY_CTRLB_0",
   NOTE   => "DLY_CTRLB_0 PFSSR Control",
   OPNAME => "DLY_CTRLB_0",
   OPCODE => 0x62,
   LENGTH => 27,
   RESET  => [ 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00012
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00013 =
#  NAME                     IND  POS  LEN  MODE    DESCRIPTION
#  -------------------      ---  ---  ---  ------  -----------------------
(  "FDE19"             => [   0,  32,   1, 0x0000, "" ],
   "FCE19"             => [   1,  31,   1, 0x0000, "" ],
   "DE19"              => [   2,  30,   1, 0x0000, "" ],
   "CE19"              => [   3,  29,   1, 0x0000, "" ],
   "DMAX"              => [   4,  22,   7, 0x0000, "" ],
   "DMIN"              => [   5,  15,   7, 0x0000, "" ],
   "DMCOUT"            => [   6,   8,   7, 0x0000, "" ],
   "DLINE_AND_DMC_SEL" => [   7,   2,   6, 0x0000, "" ],
   "DLINE_SHIFT_OP"    => [   8,   0,   2, 0x0000, "" ],
);


%nl4rtr_01_tdr_00013 =
(  NAME   => "DLY_CTRLB_1",
   NOTE   => "DLY_CTRLB_1 PFSSR Control",
   OPNAME => "DLY_CTRLB_1",
   OPCODE => 0x63,
   LENGTH => 33,
   RESET  => [ 0x0, 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00013
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00014 =
#  NAME                       IND  POS  LEN  MODE    DESCRIPTION
#  -------------------        ---  ---  ---  ------  -----------------------
(  "SPARE"               => [   0,  23,   4, 0x0000, "Spare register bits"                   ],
   "OBSERVE_ENABLE"      => [   1,  22,   1, 0x0000, "Enable observation circuitry"          ],
   "DATA_CLK_MUX_SEL"    => [   2,  21,   1, 0x0000, "Observation of clock or data (data=0)" ],
   "PFSSD_SYNC_MODE"     => [   3,  20,   1, 0x0000, "PFSSD sync mode"   ],
   "PFSSD_DEBUG_SEL"     => [   4,  18,   2, 0x0000, "PFSSD testpoint select"   ],
   "PFSSR_DEBUG_SEL"     => [   5,  12,   6, 0x0000, "PFSSR testpoint select"   ],
   "DAVAIL_SEL"          => [   6,  10,   2, 0x0000, "Control timing of data available signal" ],
   "CLK_ADAPT_HOLD_MODE" => [   7,   9,   1, 0x0000, "Delay controller mode of operation"         ],
   "SAMP_TIM_SEL"        => [   8,   8,   1, 0x0000, "Mode to provide additional collection time" ],
   "FMODE_JTAG_VAL"      => [   9,   7,   1, 0x0000, "JTAG FMODE value"                        ],
   "FMODE_JTAG_EN"       => [  10,   6,   1, 0x0000, "Enable JTAG control of FMODE bit"        ],
   "UPDATE_AFTER_CNT_EN" => [  11,   5,   1, 0x0000, "" ],
   "LLP_TUNING_CMPLT_EN" => [  12,   4,   1, 0x0000, "" ],
   "RMT_UPDATE_EN"       => [  13,   3,   1, 0x0000, "Enable remote fine update (via LLP)"     ],
   "DLINE_MAN_ADJ_EN"    => [  14,   2,   1, 0x0000, "Enable manual adjust mode"               ],
   "DLINE_MAN_HOLD"      => [  15,   1,   1, 0x0000, "Hold current delay value"                ],
   "DLY_CTRL_RESET"      => [  16,   0,   1, 0x0000, "Hold delay controller in reset if set"   ]

);

%nl4rtr_01_tdr_00014 =
(  NAME   => "DLY_CTRLC_0",
   NOTE   => "DLY_CTRLC_0 PFSSR Control",
   OPNAME => "DLY_CTRLC_0",
   OPCODE => 0x64,
   LENGTH => 27,
   RESET  => [ 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00014
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00015 =
#  NAME                     IND  POS  LEN  MODE    DESCRIPTION
#  -------------------      ---  ---  ---  ------  -----------------------
(  "FDE19"             => [   0,  32,   1, 0x0000, "" ],
   "FCE19"             => [   1,  31,   1, 0x0000, "" ],
   "DE19"              => [   2,  30,   1, 0x0000, "" ],
   "CE19"              => [   3,  29,   1, 0x0000, "" ],
   "DMAX"              => [   4,  22,   7, 0x0000, "" ],
   "DMIN"              => [   5,  15,   7, 0x0000, "" ],
   "DMCOUT"            => [   6,   8,   7, 0x0000, "" ],
   "DLINE_AND_DMC_SEL" => [   7,   2,   6, 0x0000, "" ],
   "DLINE_SHIFT_OP"    => [   8,   0,   2, 0x0000, "" ],
);


%nl4rtr_01_tdr_00015 =
(  NAME   => "DLY_CTRLC_1",
   NOTE   => "DLY_CTRLC_1 PFSSR Control",
   OPNAME => "DLY_CTRLC_1",
   OPCODE => 0x65,
   LENGTH => 33,
   RESET  => [ 0x0, 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00015
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00016 =
#  NAME                       IND  POS  LEN  MODE    DESCRIPTION
#  -------------------        ---  ---  ---  ------  -----------------------
(  "SPARE"               => [   0,  23,   4, 0x0000, "Spare register bits"                   ],
   "OBSERVE_ENABLE"      => [   1,  22,   1, 0x0000, "Enable observation circuitry"          ],
   "DATA_CLK_MUX_SEL"    => [   2,  21,   1, 0x0000, "Observation of clock or data (data=0)" ],
   "PFSSD_SYNC_MODE"     => [   3,  20,   1, 0x0000, "PFSSD sync mode"   ],
   "PFSSD_DEBUG_SEL"     => [   4,  18,   2, 0x0000, "PFSSD testpoint select"   ],
   "PFSSR_DEBUG_SEL"     => [   5,  12,   6, 0x0000, "PFSSR testpoint select"   ],
   "DAVAIL_SEL"          => [   6,  10,   2, 0x0000, "Control timing of data available signal" ],
   "CLK_ADAPT_HOLD_MODE" => [   7,   9,   1, 0x0000, "Delay controller mode of operation"         ],
   "SAMP_TIM_SEL"        => [   8,   8,   1, 0x0000, "Mode to provide additional collection time" ],
   "FMODE_JTAG_VAL"      => [   9,   7,   1, 0x0000, "JTAG FMODE value"                        ],
   "FMODE_JTAG_EN"       => [  10,   6,   1, 0x0000, "Enable JTAG control of FMODE bit"        ],
   "UPDATE_AFTER_CNT_EN" => [  11,   5,   1, 0x0000, "" ],
   "LLP_TUNING_CMPLT_EN" => [  12,   4,   1, 0x0000, "" ],
   "RMT_UPDATE_EN"       => [  13,   3,   1, 0x0000, "Enable remote fine update (via LLP)"     ],
   "DLINE_MAN_ADJ_EN"    => [  14,   2,   1, 0x0000, "Enable manual adjust mode"               ],
   "DLINE_MAN_HOLD"      => [  15,   1,   1, 0x0000, "Hold current delay value"                ],
   "DLY_CTRL_RESET"      => [  16,   0,   1, 0x0000, "Hold delay controller in reset if set"   ]

);

%nl4rtr_01_tdr_00016 =
(  NAME   => "DLY_CTRLD_0",
   NOTE   => "DLY_CTRLD_0 PFSSR Control",
   OPNAME => "DLY_CTRLD_0",
   OPCODE => 0x66,
   LENGTH => 27,
   RESET  => [ 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00016
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00017 =
#  NAME                     IND  POS  LEN  MODE    DESCRIPTION
#  -------------------      ---  ---  ---  ------  -----------------------
(  "FDE19"             => [   0,  32,   1, 0x0000, "" ],
   "FCE19"             => [   1,  31,   1, 0x0000, "" ],
   "DE19"              => [   2,  30,   1, 0x0000, "" ],
   "CE19"              => [   3,  29,   1, 0x0000, "" ],
   "DMAX"              => [   4,  22,   7, 0x0000, "" ],
   "DMIN"              => [   5,  15,   7, 0x0000, "" ],
   "DMCOUT"            => [   6,   8,   7, 0x0000, "" ],
   "DLINE_AND_DMC_SEL" => [   7,   2,   6, 0x0000, "" ],
   "DLINE_SHIFT_OP"    => [   8,   0,   2, 0x0000, "" ],
);


%nl4rtr_01_tdr_00017 =
(  NAME   => "DLY_CTRLD_1",
   NOTE   => "DLY_CTRLD_1 PFSSR Control",
   OPNAME => "DLY_CTRLD_1",
   OPCODE => 0x67,
   LENGTH => 33,
   RESET  => [ 0x0, 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00017
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00018 =
#  NAME                       IND  POS  LEN  MODE    DESCRIPTION
#  -------------------        ---  ---  ---  ------  -----------------------
(  "SPARE"               => [   0,  23,   4, 0x0000, "Spare register bits"                   ],
   "OBSERVE_ENABLE"      => [   1,  22,   1, 0x0000, "Enable observation circuitry"          ],
   "DATA_CLK_MUX_SEL"    => [   2,  21,   1, 0x0000, "Observation of clock or data (data=0)" ],
   "PFSSD_SYNC_MODE"     => [   3,  20,   1, 0x0000, "PFSSD sync mode"   ],
   "PFSSD_DEBUG_SEL"     => [   4,  18,   2, 0x0000, "PFSSD testpoint select"   ],
   "PFSSR_DEBUG_SEL"     => [   5,  12,   6, 0x0000, "PFSSR testpoint select"   ],
   "DAVAIL_SEL"          => [   6,  10,   2, 0x0000, "Control timing of data available signal" ],
   "CLK_ADAPT_HOLD_MODE" => [   7,   9,   1, 0x0000, "Delay controller mode of operation"         ],
   "SAMP_TIM_SEL"        => [   8,   8,   1, 0x0000, "Mode to provide additional collection time" ],
   "FMODE_JTAG_VAL"      => [   9,   7,   1, 0x0000, "JTAG FMODE value"                        ],
   "FMODE_JTAG_EN"       => [  10,   6,   1, 0x0000, "Enable JTAG control of FMODE bit"        ],
   "UPDATE_AFTER_CNT_EN" => [  11,   5,   1, 0x0000, "" ],
   "LLP_TUNING_CMPLT_EN" => [  12,   4,   1, 0x0000, "" ],
   "RMT_UPDATE_EN"       => [  13,   3,   1, 0x0000, "Enable remote fine update (via LLP)"     ],
   "DLINE_MAN_ADJ_EN"    => [  14,   2,   1, 0x0000, "Enable manual adjust mode"               ],
   "DLINE_MAN_HOLD"      => [  15,   1,   1, 0x0000, "Hold current delay value"                ],
   "DLY_CTRL_RESET"      => [  16,   0,   1, 0x0000, "Hold delay controller in reset if set"   ]

);

%nl4rtr_01_tdr_00018 =
(  NAME   => "DLY_CTRLE_0",
   NOTE   => "DLY_CTRLE_0 PFSSR Control",
   OPNAME => "DLY_CTRLE_0",
   OPCODE => 0x68,
   LENGTH => 27,
   RESET  => [ 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00018
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00019 =
#  NAME                     IND  POS  LEN  MODE    DESCRIPTION
#  -------------------      ---  ---  ---  ------  -----------------------
(  "FDE19"             => [   0,  32,   1, 0x0000, "" ],
   "FCE19"             => [   1,  31,   1, 0x0000, "" ],
   "DE19"              => [   2,  30,   1, 0x0000, "" ],
   "CE19"              => [   3,  29,   1, 0x0000, "" ],
   "DMAX"              => [   4,  22,   7, 0x0000, "" ],
   "DMIN"              => [   5,  15,   7, 0x0000, "" ],
   "DMCOUT"            => [   6,   8,   7, 0x0000, "" ],
   "DLINE_AND_DMC_SEL" => [   7,   2,   6, 0x0000, "" ],
   "DLINE_SHIFT_OP"    => [   8,   0,   2, 0x0000, "" ],
);


%nl4rtr_01_tdr_00019 =
(  NAME   => "DLY_CTRLE_1",
   NOTE   => "DLY_CTRLE_1 PFSSR Control",
   OPNAME => "DLY_CTRLE_1",
   OPCODE => 0x69,
   LENGTH => 33,
   RESET  => [ 0x0, 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00019
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00020 =
#  NAME                       IND  POS  LEN  MODE    DESCRIPTION
#  -------------------        ---  ---  ---  ------  -----------------------
(  "SPARE"               => [   0,  23,   4, 0x0000, "Spare register bits"                   ],
   "OBSERVE_ENABLE"      => [   1,  22,   1, 0x0000, "Enable observation circuitry"          ],
   "DATA_CLK_MUX_SEL"    => [   2,  21,   1, 0x0000, "Observation of clock or data (data=0)" ],
   "PFSSD_SYNC_MODE"     => [   3,  20,   1, 0x0000, "PFSSD sync mode"   ],
   "PFSSD_DEBUG_SEL"     => [   4,  18,   2, 0x0000, "PFSSD testpoint select"   ],
   "PFSSR_DEBUG_SEL"     => [   5,  12,   6, 0x0000, "PFSSR testpoint select"   ],
   "DAVAIL_SEL"          => [   6,  10,   2, 0x0000, "Control timing of data available signal" ],
   "CLK_ADAPT_HOLD_MODE" => [   7,   9,   1, 0x0000, "Delay controller mode of operation"         ],
   "SAMP_TIM_SEL"        => [   8,   8,   1, 0x0000, "Mode to provide additional collection time" ],
   "FMODE_JTAG_VAL"      => [   9,   7,   1, 0x0000, "JTAG FMODE value"                        ],
   "FMODE_JTAG_EN"       => [  10,   6,   1, 0x0000, "Enable JTAG control of FMODE bit"        ],
   "UPDATE_AFTER_CNT_EN" => [  11,   5,   1, 0x0000, "" ],
   "LLP_TUNING_CMPLT_EN" => [  12,   4,   1, 0x0000, "" ],
   "RMT_UPDATE_EN"       => [  13,   3,   1, 0x0000, "Enable remote fine update (via LLP)"     ],
   "DLINE_MAN_ADJ_EN"    => [  14,   2,   1, 0x0000, "Enable manual adjust mode"               ],
   "DLINE_MAN_HOLD"      => [  15,   1,   1, 0x0000, "Hold current delay value"                ],
   "DLY_CTRL_RESET"      => [  16,   0,   1, 0x0000, "Hold delay controller in reset if set"   ]

);

%nl4rtr_01_tdr_00020 =
(  NAME   => "DLY_CTRLF_0",
   NOTE   => "DLY_CTRLF_0 PFSSR Control",
   OPNAME => "DLY_CTRLF_0",
   OPCODE => 0x6A,
   LENGTH => 27,
   RESET  => [ 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00020
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00021 =
#  NAME                     IND  POS  LEN  MODE    DESCRIPTION
#  -------------------      ---  ---  ---  ------  -----------------------
(  "FDE19"             => [   0,  32,   1, 0x0000, "" ],
   "FCE19"             => [   1,  31,   1, 0x0000, "" ],
   "DE19"              => [   2,  30,   1, 0x0000, "" ],
   "CE19"              => [   3,  29,   1, 0x0000, "" ],
   "DMAX"              => [   4,  22,   7, 0x0000, "" ],
   "DMIN"              => [   5,  15,   7, 0x0000, "" ],
   "DMCOUT"            => [   6,   8,   7, 0x0000, "" ],
   "DLINE_AND_DMC_SEL" => [   7,   2,   6, 0x0000, "" ],
   "DLINE_SHIFT_OP"    => [   8,   0,   2, 0x0000, "" ],
);


%nl4rtr_01_tdr_00021 =
(  NAME   => "DLY_CTRLF_1",
   NOTE   => "DLY_CTRLF_1 PFSSR Control",
   OPNAME => "DLY_CTRLF_1",
   OPCODE => 0x6B,
   LENGTH => 33,
   RESET  => [ 0x0, 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00021
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00022 =
#  NAME                       IND  POS  LEN  MODE    DESCRIPTION
#  -------------------        ---  ---  ---  ------  -----------------------
(  "SPARE"               => [   0,  23,   4, 0x0000, "Spare register bits"                   ],
   "OBSERVE_ENABLE"      => [   1,  22,   1, 0x0000, "Enable observation circuitry"          ],
   "DATA_CLK_MUX_SEL"    => [   2,  21,   1, 0x0000, "Observation of clock or data (data=0)" ],
   "PFSSD_SYNC_MODE"     => [   3,  20,   1, 0x0000, "PFSSD sync mode"   ],
   "PFSSD_DEBUG_SEL"     => [   4,  18,   2, 0x0000, "PFSSD testpoint select"   ],
   "PFSSR_DEBUG_SEL"     => [   5,  12,   6, 0x0000, "PFSSR testpoint select"   ],
   "DAVAIL_SEL"          => [   6,  10,   2, 0x0000, "Control timing of data available signal" ],
   "CLK_ADAPT_HOLD_MODE" => [   7,   9,   1, 0x0000, "Delay controller mode of operation"         ],
   "SAMP_TIM_SEL"        => [   8,   8,   1, 0x0000, "Mode to provide additional collection time" ],
   "FMODE_JTAG_VAL"      => [   9,   7,   1, 0x0000, "JTAG FMODE value"                        ],
   "FMODE_JTAG_EN"       => [  10,   6,   1, 0x0000, "Enable JTAG control of FMODE bit"        ],
   "UPDATE_AFTER_CNT_EN" => [  11,   5,   1, 0x0000, "" ],
   "LLP_TUNING_CMPLT_EN" => [  12,   4,   1, 0x0000, "" ],
   "RMT_UPDATE_EN"       => [  13,   3,   1, 0x0000, "Enable remote fine update (via LLP)"     ],
   "DLINE_MAN_ADJ_EN"    => [  14,   2,   1, 0x0000, "Enable manual adjust mode"               ],
   "DLINE_MAN_HOLD"      => [  15,   1,   1, 0x0000, "Hold current delay value"                ],
   "DLY_CTRL_RESET"      => [  16,   0,   1, 0x0000, "Hold delay controller in reset if set"   ]

);

%nl4rtr_01_tdr_00022 =
(  NAME   => "DLY_CTRLG_0",
   NOTE   => "DLY_CTRLG_0 PFSSR Control",
   OPNAME => "DLY_CTRLG_0",
   OPCODE => 0x6C,
   LENGTH => 27,
   RESET  => [ 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00022
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00023 =
#  NAME                     IND  POS  LEN  MODE    DESCRIPTION
#  -------------------      ---  ---  ---  ------  -----------------------
(  "FDE19"             => [   0,  32,   1, 0x0000, "" ],
   "FCE19"             => [   1,  31,   1, 0x0000, "" ],
   "DE19"              => [   2,  30,   1, 0x0000, "" ],
   "CE19"              => [   3,  29,   1, 0x0000, "" ],
   "DMAX"              => [   4,  22,   7, 0x0000, "" ],
   "DMIN"              => [   5,  15,   7, 0x0000, "" ],
   "DMCOUT"            => [   6,   8,   7, 0x0000, "" ],
   "DLINE_AND_DMC_SEL" => [   7,   2,   6, 0x0000, "" ],
   "DLINE_SHIFT_OP"    => [   8,   0,   2, 0x0000, "" ],
);


%nl4rtr_01_tdr_00023 =
(  NAME   => "DLY_CTRLG_1",
   NOTE   => "DLY_CTRLG_1 PFSSR Control",
   OPNAME => "DLY_CTRLG_1",
   OPCODE => 0x6D,
   LENGTH => 33,
   RESET  => [ 0x0, 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00023
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00024 =
#  NAME                       IND  POS  LEN  MODE    DESCRIPTION
#  -------------------        ---  ---  ---  ------  -----------------------
(  "SPARE"               => [   0,  23,   4, 0x0000, "Spare register bits"                   ],
   "OBSERVE_ENABLE"      => [   1,  22,   1, 0x0000, "Enable observation circuitry"          ],
   "DATA_CLK_MUX_SEL"    => [   2,  21,   1, 0x0000, "Observation of clock or data (data=0)" ],
   "PFSSD_SYNC_MODE"     => [   3,  20,   1, 0x0000, "PFSSD sync mode"   ],
   "PFSSD_DEBUG_SEL"     => [   4,  18,   2, 0x0000, "PFSSD testpoint select"   ],
   "PFSSR_DEBUG_SEL"     => [   5,  12,   6, 0x0000, "PFSSR testpoint select"   ],
   "DAVAIL_SEL"          => [   6,  10,   2, 0x0000, "Control timing of data available signal" ],
   "CLK_ADAPT_HOLD_MODE" => [   7,   9,   1, 0x0000, "Delay controller mode of operation"         ],
   "SAMP_TIM_SEL"        => [   8,   8,   1, 0x0000, "Mode to provide additional collection time" ],
   "FMODE_JTAG_VAL"      => [   9,   7,   1, 0x0000, "JTAG FMODE value"                        ],
   "FMODE_JTAG_EN"       => [  10,   6,   1, 0x0000, "Enable JTAG control of FMODE bit"        ],
   "UPDATE_AFTER_CNT_EN" => [  11,   5,   1, 0x0000, "" ],
   "LLP_TUNING_CMPLT_EN" => [  12,   4,   1, 0x0000, "" ],
   "RMT_UPDATE_EN"       => [  13,   3,   1, 0x0000, "Enable remote fine update (via LLP)"     ],
   "DLINE_MAN_ADJ_EN"    => [  14,   2,   1, 0x0000, "Enable manual adjust mode"               ],
   "DLINE_MAN_HOLD"      => [  15,   1,   1, 0x0000, "Hold current delay value"                ],
   "DLY_CTRL_RESET"      => [  16,   0,   1, 0x0000, "Hold delay controller in reset if set"   ]

);

%nl4rtr_01_tdr_00024 =
(  NAME   => "DLY_CTRLH_0",
   NOTE   => "DLY_CTRLH_0 PFSSR Control",
   OPNAME => "DLY_CTRLH_0",
   OPCODE => 0x6E,
   LENGTH => 27,
   RESET  => [ 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00024
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00025 =
#  NAME                     IND  POS  LEN  MODE    DESCRIPTION
#  -------------------      ---  ---  ---  ------  -----------------------
(  "FDE19"             => [   0,  32,   1, 0x0000, "" ],
   "FCE19"             => [   1,  31,   1, 0x0000, "" ],
   "DE19"              => [   2,  30,   1, 0x0000, "" ],
   "CE19"              => [   3,  29,   1, 0x0000, "" ],
   "DMAX"              => [   4,  22,   7, 0x0000, "" ],
   "DMIN"              => [   5,  15,   7, 0x0000, "" ],
   "DMCOUT"            => [   6,   8,   7, 0x0000, "" ],
   "DLINE_AND_DMC_SEL" => [   7,   2,   6, 0x0000, "" ],
   "DLINE_SHIFT_OP"    => [   8,   0,   2, 0x0000, "" ],
);


%nl4rtr_01_tdr_00025 =
(  NAME   => "DLY_CTRLH_1",
   NOTE   => "DLY_CTRLH_1 PFSSR Control",
   OPNAME => "DLY_CTRLH_1",
   OPCODE => 0x6F,
   LENGTH => 33,
   RESET  => [ 0x0, 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00025
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00026 =
#  NAME                               IND  POS  LEN  MODE    DESCRIPTION
#  -------------------                ---  ---  ---  ------  -----------------------
(  "SEND_LIMIT_VCH3"             => [   0, 196,   7, 0x0000, "Send limit value for VCh3" ],
   "SEND_LIMIT_VCH2"             => [   1, 189,   7, 0x0000, "Send limit value for VCh2" ],
   "SEND_LIMIT_VCH1"             => [   2, 182,   7, 0x0000, "Send limit value for VCh1" ],
   "SEND_LIMIT_VCH0"             => [   3, 175,   7, 0x0000, "Send limit value for VCh0" ],
   "RCV_INITIAL_VCH3"            => [   4, 169,   6, 0x0000, "Receive initial credit value for VCh3" ],
   "RCV_INITIAL_VCH2"            => [   5, 163,   6, 0x0000, "Receive initial credit value for VCh2" ],
   "RCV_INITIAL_VCH1"            => [   6, 157,   6, 0x0000, "Receive initial credit value for VCh1" ],
   "RCV_INITIAL_VCH0"            => [   7, 151,   6, 0x0000, "Receive initial credit value for VCh0" ],
   "FAKED_ALL_SN_ERRORS"         => [   8, 150,   1, 0x0000, "Asserted when fake SN counter reaches zero" ],
   "SENT_ALL_SN_ERRORS"          => [   9, 149,   1, 0x0000, "Asserted when SN counter reaches zero" ],
   "SENT_ALL_CB_ERRORS"          => [  10, 148,   1, 0x0000, "Asserted when CB counter reaches zero" ],
   "FAKE_SN_ERROR"               => [  11, 147,   1, 0x0000, "SSR pretends it received a bad SN" ],
   "SEND_SN_ERROR"               => [  12, 146,   1, 0x0000, "Inc. SN counter; SN errors may be forced" ],
   "SEND_CB_ERROR"               => [  13, 145,   1, 0x0000, "Inc. CB counter; CB errors may be forced" ],
   "USER_XCLR_TIME"              => [  14, 137,   8, 0x0000, "Interval to wait after reset and remotePOK" ],
   "ENABLE_USER_XCLR_TIME"       => [  15, 136,   1, 0x0000, "Enable user input of XClrTime" ],
   "USER_RWND_TIMEOUT"           => [  16, 128,   8, 0x0000, "Lost packet wait interval" ],
   "ENABLE_USER_RWND_TIMEOUT"    => [  17, 127,   1, 0x0000, "Enable user input of RewindTimeout" ],
   "USER_BOOT_TIME"              => [  18, 119,   8, 0x0000, "Failure wait interval" ],
   "ENABLE_USER_BOOT_TIME"       => [  19, 118,   1, 0x0000, "Enable user input of BootTime" ],
   "USER_IGNORE_TIME"            => [  20,  78,  40, 0x0000, "Ignore reset interval" ],
   "ENABLE_USER_IGNORE_TIME"     => [  21,  77,   1, 0x0000, "Enable user input of IgnoreTime" ],
   "USER_FT_TIME"                => [  22,  61,  16, 0x0000, "Number of clocks in reset tuning phase" ],
   "ENABLE_USER_FT_TIME"         => [  23,  60,   1, 0x0000, "Enable user input of FT_Time" ],
   "USER_FTU_TIME"               => [  24,  48,  12, 0x0000, "Internval between fine tune updates" ],
   "ENABLE_USER_FTU_TIME"        => [  25,  47,   1, 0x0000, "Enable user intput of FTU_Time" ],
   "USER_NULL_TIMEOUT"           => [  26,  41,   6, 0x0000, "Idle link time req'd to send null pkt" ],
   "ENABLE_USER_NULL_TIMEOUT"    => [  27,  40,   1, 0x0000, "Enable user input of NullTimeout" ],
   "USER_RWND_SYNC_RATIO"        => [  28,  34,   6, 0x0000, "Number of retries before resyncing" ],
   "ENABLE_USER_RWND_SYNC_RATIO" => [  29,  33,   1, 0x0000, "Enable user input of RewindSyncRatio" ],
   "USER_MAX_RETRY"              => [  30,  17,  16, 0x0000, "Maximum number of retries" ],
   "ENABLE_USER_MAX_RETRY"       => [  31,  16,   1, 0x0000, "Enable user input of MaxRetry" ],
   "USER_MAX_BURST"              => [  32,   6,  10, 0x0000, "Longest continuous data stream allowed" ],
   "ENABLE_USER_MAX_BURST"       => [  33,   5,   1, 0x0000, "Enable user input of MaxBurst" ],
   "ENABLE_RFTU"                 => [  34,   4,   1, 0x0000, "Enable fine tune update" ],
   "ENABLE_TUNING"               => [  35,   3,   1, 0x0000, "Enable PFSSR tuning" ],
   "ENABLE_AC"                   => [  36,   2,   1, 0x0000, "Enable AC encoding" ],
   "ENABLE_LINK"                 => [  37,   1,   1, 0x0000, "Enable LLP inputs" ],
   "BIT_MODE32"                  => [  38,   0,   1, 0x0000, "LLP should use 32 bit mode (0=16b)" ],
);

%nl4rtr_01_tdr_00026 =
(  NAME   => "LLP4_A",
   NOTE   => "Port A LLP4 Configuration Data",
   OPNAME => "LLP4_A",
   OPCODE => 0x10,
   LENGTH => 203,
   RESET  => [ 0x00000000, 0x00000000, 0x00000000, 0x00000000, 
               0x00000000, 0x00000000, 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00026
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00027 =
#  NAME                         IND  POS  LEN  MODE    DESCRIPTION
#  -------------------          ---  ---  ---  ------  -----------------------
(  "CAPTURE_RCV_SBSN"      => [   0, 226,  16, 0x0000, "description"            ],
   "CAPTURE_RCV_CRC"       => [   1, 210,  16, 0x0000, "description"            ],
   "CAPTURE_RCV_DATA_UP"   => [   2, 146,  64, 0x0000, "description"            ],
   "CAPTURE_RCV_DATA_LO"   => [   3,  82,  64, 0x0000, "description"            ],
   "CAPTURED_CB_ERR"       => [   4,  81,   1, 0x0000, "description"            ],
   "CAPTURED"              => [   5,  80,   1, 0x0000, "description"            ],
   "WIRE_ERR_OVERFLOW"     => [   6,  79,   1, 0x0000, "description"            ],
   "WIRE_ERR_CNT"          => [   7,  55,  24, 0x0000, "description"            ],
   "ERR_CAPTURE"           => [   8,  54,   1, 0x0000, "description"            ],
   "ARM_CAPTURE"           => [   9,  53,   1, 0x0000, "description"            ],
   "NOISE_MODE"            => [  10,  51,   2, 0x0000, "description"            ],
   "LFSR_MODE"             => [  11,  49,   2, 0x0000, "description"            ],
   "WIRE_SEL"              => [  12,  43,   6, 0x0000, "description"            ],
   "SEND_TEST_MODE"        => [  13,  41,   2, 0x0000, "description"            ],
   "TEST_PATTERN"          => [  14,   1,  40, 0x0000, "description"            ],
   "TEST_MODE"             => [  15,   0,   1, 0x0000, "description"            ]
);

%nl4rtr_01_tdr_00027 =
(  NAME   => "LLP4TEST_A",
   NOTE   => "Port A LLP Channel BIST",
   OPNAME => "LLP4TEST_A",
   OPCODE => 0x11,
   LENGTH => 242,
   RESET  => [ 0x0000000, 0x00000000, 0x00000000, 0x00000000,
               0x0000000, 0x00000000, 0x00000000, 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00027
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00028 =
#  NAME                               IND  POS  LEN  MODE    DESCRIPTION
#  -------------------                ---  ---  ---  ------  -----------------------
(  "SEND_LIMIT_VCH3"             => [   0, 196,   7, 0x0000, "Send limit value for VCh3" ],
   "SEND_LIMIT_VCH2"             => [   1, 189,   7, 0x0000, "Send limit value for VCh2" ],
   "SEND_LIMIT_VCH1"             => [   2, 182,   7, 0x0000, "Send limit value for VCh1" ],
   "SEND_LIMIT_VCH0"             => [   3, 175,   7, 0x0000, "Send limit value for VCh0" ],
   "RCV_INITIAL_VCH3"            => [   4, 169,   6, 0x0000, "Receive initial credit value for VCh3" ],
   "RCV_INITIAL_VCH2"            => [   5, 163,   6, 0x0000, "Receive initial credit value for VCh2" ],
   "RCV_INITIAL_VCH1"            => [   6, 157,   6, 0x0000, "Receive initial credit value for VCh1" ],
   "RCV_INITIAL_VCH0"            => [   7, 151,   6, 0x0000, "Receive initial credit value for VCh0" ],
   "FAKED_ALL_SN_ERRORS"         => [   8, 150,   1, 0x0000, "Asserted when fake SN counter reaches zero" ],
   "SENT_ALL_SN_ERRORS"          => [   9, 149,   1, 0x0000, "Asserted when SN counter reaches zero" ],
   "SENT_ALL_CB_ERRORS"          => [  10, 148,   1, 0x0000, "Asserted when CB counter reaches zero" ],
   "FAKE_SN_ERROR"               => [  11, 147,   1, 0x0000, "SSR pretends it received a bad SN" ],
   "SEND_SN_ERROR"               => [  12, 146,   1, 0x0000, "Inc. SN counter; SN errors may be forced" ],
   "SEND_CB_ERROR"               => [  13, 145,   1, 0x0000, "Inc. CB counter; CB errors may be forced" ],
   "USER_XCLR_TIME"              => [  14, 137,   8, 0x0000, "Interval to wait after reset and remotePOK" ],
   "ENABLE_USER_XCLR_TIME"       => [  15, 136,   1, 0x0000, "Enable user input of XClrTime" ],
   "USER_RWND_TIMEOUT"           => [  16, 128,   8, 0x0000, "Lost packet wait interval" ],
   "ENABLE_USER_RWND_TIMEOUT"    => [  17, 127,   1, 0x0000, "Enable user input of RewindTimeout" ],
   "USER_BOOT_TIME"              => [  18, 119,   8, 0x0000, "Failure wait interval" ],
   "ENABLE_USER_BOOT_TIME"       => [  19, 118,   1, 0x0000, "Enable user input of BootTime" ],
   "USER_IGNORE_TIME"            => [  20,  78,  40, 0x0000, "Ignore reset interval" ],
   "ENABLE_USER_IGNORE_TIME"     => [  21,  77,   1, 0x0000, "Enable user input of IgnoreTime" ],
   "USER_FT_TIME"                => [  22,  61,  16, 0x0000, "Number of clocks in reset tuning phase" ],
   "ENABLE_USER_FT_TIME"         => [  23,  60,   1, 0x0000, "Enable user input of FT_Time" ],
   "USER_FTU_TIME"               => [  24,  48,  12, 0x0000, "Internval between fine tune updates" ],
   "ENABLE_USER_FTU_TIME"        => [  25,  47,   1, 0x0000, "Enable user intput of FTU_Time" ],
   "USER_NULL_TIMEOUT"           => [  26,  41,   6, 0x0000, "Idle link time req'd to send null pkt" ],
   "ENABLE_USER_NULL_TIMEOUT"    => [  27,  40,   1, 0x0000, "Enable user input of NullTimeout" ],
   "USER_RWND_SYNC_RATIO"        => [  28,  34,   6, 0x0000, "Number of retries before resyncing" ],
   "ENABLE_USER_RWND_SYNC_RATIO" => [  29,  33,   1, 0x0000, "Enable user input of RewindSyncRatio" ],
   "USER_MAX_RETRY"              => [  30,  17,  16, 0x0000, "Maximum number of retries" ],
   "ENABLE_USER_MAX_RETRY"       => [  31,  16,   1, 0x0000, "Enable user input of MaxRetry" ],
   "USER_MAX_BURST"              => [  32,   6,  10, 0x0000, "Longest continuous data stream allowed" ],
   "ENABLE_USER_MAX_BURST"       => [  33,   5,   1, 0x0000, "Enable user input of MaxBurst" ],
   "ENABLE_RFTU"                 => [  34,   4,   1, 0x0000, "Enable fine tune update" ],
   "ENABLE_TUNING"               => [  35,   3,   1, 0x0000, "Enable PFSSR tuning" ],
   "ENABLE_AC"                   => [  36,   2,   1, 0x0000, "Enable AC encoding" ],
   "ENABLE_LINK"                 => [  37,   1,   1, 0x0000, "Enable LLP inputs" ],
   "BIT_MODE32"                  => [  38,   0,   1, 0x0000, "LLP should use 32 bit mode (0=16b)" ],
);

%nl4rtr_01_tdr_00028 =
(  NAME   => "LLP4_B",
   NOTE   => "Port B LLP4 Configuration Data",
   OPNAME => "LLP4_B",
   OPCODE => 0x12,
   LENGTH => 203,
   RESET  => [ 0x00000000, 0x00000000, 0x00000000, 0x00000000, 
               0x00000000, 0x00000000, 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00028
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00029 =
#  NAME                         IND  POS  LEN  MODE    DESCRIPTION
#  -------------------          ---  ---  ---  ------  -----------------------
(  "CAPTURE_RCV_SBSN"      => [   0, 226,  16, 0x0000, "description"            ],
   "CAPTURE_RCV_CRC"       => [   1, 210,  16, 0x0000, "description"            ],
   "CAPTURE_RCV_DATA_UP"   => [   2, 146,  64, 0x0000, "description"            ],
   "CAPTURE_RCV_DATA_LO"   => [   3,  82,  64, 0x0000, "description"            ],
   "CAPTURED_CB_ERR"       => [   4,  81,   1, 0x0000, "description"            ],
   "CAPTURED"              => [   5,  80,   1, 0x0000, "description"            ],
   "WIRE_ERR_OVERFLOW"     => [   6,  79,   1, 0x0000, "description"            ],
   "WIRE_ERR_CNT"          => [   7,  55,  24, 0x0000, "description"            ],
   "ERR_CAPTURE"           => [   8,  54,   1, 0x0000, "description"            ],
   "ARM_CAPTURE"           => [   9,  53,   1, 0x0000, "description"            ],
   "NOISE_MODE"            => [  10,  51,   2, 0x0000, "description"            ],
   "LFSR_MODE"             => [  11,  49,   2, 0x0000, "description"            ],
   "WIRE_SEL"              => [  12,  43,   6, 0x0000, "description"            ],
   "SEND_TEST_MODE"        => [  13,  41,   2, 0x0000, "description"            ],
   "TEST_PATTERN"          => [  14,   1,  40, 0x0000, "description"            ],
   "TEST_MODE"             => [  15,   0,   1, 0x0000, "description"            ]
);

%nl4rtr_01_tdr_00029 =
(  NAME   => "LLP4TEST_B",
   NOTE   => "Port B LLP Channel BIST",
   OPNAME => "LLP4TEST_B",
   OPCODE => 0x13,
   LENGTH => 242,
   RESET  => [ 0x0000000, 0x00000000, 0x00000000, 0x00000000,
               0x0000000, 0x00000000, 0x00000000, 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00029
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00030 =
#  NAME                               IND  POS  LEN  MODE    DESCRIPTION
#  -------------------                ---  ---  ---  ------  -----------------------
(  "SEND_LIMIT_VCH3"             => [   0, 196,   7, 0x0000, "Send limit value for VCh3" ],
   "SEND_LIMIT_VCH2"             => [   1, 189,   7, 0x0000, "Send limit value for VCh2" ],
   "SEND_LIMIT_VCH1"             => [   2, 182,   7, 0x0000, "Send limit value for VCh1" ],
   "SEND_LIMIT_VCH0"             => [   3, 175,   7, 0x0000, "Send limit value for VCh0" ],
   "RCV_INITIAL_VCH3"            => [   4, 169,   6, 0x0000, "Receive initial credit value for VCh3" ],
   "RCV_INITIAL_VCH2"            => [   5, 163,   6, 0x0000, "Receive initial credit value for VCh2" ],
   "RCV_INITIAL_VCH1"            => [   6, 157,   6, 0x0000, "Receive initial credit value for VCh1" ],
   "RCV_INITIAL_VCH0"            => [   7, 151,   6, 0x0000, "Receive initial credit value for VCh0" ],
   "FAKED_ALL_SN_ERRORS"         => [   8, 150,   1, 0x0000, "Asserted when fake SN counter reaches zero" ],
   "SENT_ALL_SN_ERRORS"          => [   9, 149,   1, 0x0000, "Asserted when SN counter reaches zero" ],
   "SENT_ALL_CB_ERRORS"          => [  10, 148,   1, 0x0000, "Asserted when CB counter reaches zero" ],
   "FAKE_SN_ERROR"               => [  11, 147,   1, 0x0000, "SSR pretends it received a bad SN" ],
   "SEND_SN_ERROR"               => [  12, 146,   1, 0x0000, "Inc. SN counter; SN errors may be forced" ],
   "SEND_CB_ERROR"               => [  13, 145,   1, 0x0000, "Inc. CB counter; CB errors may be forced" ],
   "USER_XCLR_TIME"              => [  14, 137,   8, 0x0000, "Interval to wait after reset and remotePOK" ],
   "ENABLE_USER_XCLR_TIME"       => [  15, 136,   1, 0x0000, "Enable user input of XClrTime" ],
   "USER_RWND_TIMEOUT"           => [  16, 128,   8, 0x0000, "Lost packet wait interval" ],
   "ENABLE_USER_RWND_TIMEOUT"    => [  17, 127,   1, 0x0000, "Enable user input of RewindTimeout" ],
   "USER_BOOT_TIME"              => [  18, 119,   8, 0x0000, "Failure wait interval" ],
   "ENABLE_USER_BOOT_TIME"       => [  19, 118,   1, 0x0000, "Enable user input of BootTime" ],
   "USER_IGNORE_TIME"            => [  20,  78,  40, 0x0000, "Ignore reset interval" ],
   "ENABLE_USER_IGNORE_TIME"     => [  21,  77,   1, 0x0000, "Enable user input of IgnoreTime" ],
   "USER_FT_TIME"                => [  22,  61,  16, 0x0000, "Number of clocks in reset tuning phase" ],
   "ENABLE_USER_FT_TIME"         => [  23,  60,   1, 0x0000, "Enable user input of FT_Time" ],
   "USER_FTU_TIME"               => [  24,  48,  12, 0x0000, "Internval between fine tune updates" ],
   "ENABLE_USER_FTU_TIME"        => [  25,  47,   1, 0x0000, "Enable user intput of FTU_Time" ],
   "USER_NULL_TIMEOUT"           => [  26,  41,   6, 0x0000, "Idle link time req'd to send null pkt" ],
   "ENABLE_USER_NULL_TIMEOUT"    => [  27,  40,   1, 0x0000, "Enable user input of NullTimeout" ],
   "USER_RWND_SYNC_RATIO"        => [  28,  34,   6, 0x0000, "Number of retries before resyncing" ],
   "ENABLE_USER_RWND_SYNC_RATIO" => [  29,  33,   1, 0x0000, "Enable user input of RewindSyncRatio" ],
   "USER_MAX_RETRY"              => [  30,  17,  16, 0x0000, "Maximum number of retries" ],
   "ENABLE_USER_MAX_RETRY"       => [  31,  16,   1, 0x0000, "Enable user input of MaxRetry" ],
   "USER_MAX_BURST"              => [  32,   6,  10, 0x0000, "Longest continuous data stream allowed" ],
   "ENABLE_USER_MAX_BURST"       => [  33,   5,   1, 0x0000, "Enable user input of MaxBurst" ],
   "ENABLE_RFTU"                 => [  34,   4,   1, 0x0000, "Enable fine tune update" ],
   "ENABLE_TUNING"               => [  35,   3,   1, 0x0000, "Enable PFSSR tuning" ],
   "ENABLE_AC"                   => [  36,   2,   1, 0x0000, "Enable AC encoding" ],
   "ENABLE_LINK"                 => [  37,   1,   1, 0x0000, "Enable LLP inputs" ],
   "BIT_MODE32"                  => [  38,   0,   1, 0x0000, "LLP should use 32 bit mode (0=16b)" ],
);

%nl4rtr_01_tdr_00030 =
(  NAME   => "LLP4_C",
   NOTE   => "Port C LLP4 Configuration Data",
   OPNAME => "LLP4_C",
   OPCODE => 0x14,
   LENGTH => 203,
   RESET  => [ 0x00000000, 0x00000000, 0x00000000, 0x00000000, 
               0x00000000, 0x00000000, 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00030
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00031 =
#  NAME                         IND  POS  LEN  MODE    DESCRIPTION
#  -------------------          ---  ---  ---  ------  -----------------------
(  "CAPTURE_RCV_SBSN"      => [   0, 226,  16, 0x0000, "description"            ],
   "CAPTURE_RCV_CRC"       => [   1, 210,  16, 0x0000, "description"            ],
   "CAPTURE_RCV_DATA_UP"   => [   2, 146,  64, 0x0000, "description"            ],
   "CAPTURE_RCV_DATA_LO"   => [   3,  82,  64, 0x0000, "description"            ],
   "CAPTURED_CB_ERR"       => [   4,  81,   1, 0x0000, "description"            ],
   "CAPTURED"              => [   5,  80,   1, 0x0000, "description"            ],
   "WIRE_ERR_OVERFLOW"     => [   6,  79,   1, 0x0000, "description"            ],
   "WIRE_ERR_CNT"          => [   7,  55,  24, 0x0000, "description"            ],
   "ERR_CAPTURE"           => [   8,  54,   1, 0x0000, "description"            ],
   "ARM_CAPTURE"           => [   9,  53,   1, 0x0000, "description"            ],
   "NOISE_MODE"            => [  10,  51,   2, 0x0000, "description"            ],
   "LFSR_MODE"             => [  11,  49,   2, 0x0000, "description"            ],
   "WIRE_SEL"              => [  12,  43,   6, 0x0000, "description"            ],
   "SEND_TEST_MODE"        => [  13,  41,   2, 0x0000, "description"            ],
   "TEST_PATTERN"          => [  14,   1,  40, 0x0000, "description"            ],
   "TEST_MODE"             => [  15,   0,   1, 0x0000, "description"            ]
);

%nl4rtr_01_tdr_00031 =
(  NAME   => "LLP4TEST_C",
   NOTE   => "Port C LLP Channel BIST",
   OPNAME => "LLP4TEST_C",
   OPCODE => 0x15,
   LENGTH => 242,
   RESET  => [ 0x0000000, 0x00000000, 0x00000000, 0x00000000,
               0x0000000, 0x00000000, 0x00000000, 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00031
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00032 =
#  NAME                               IND  POS  LEN  MODE    DESCRIPTION
#  -------------------                ---  ---  ---  ------  -----------------------
(  "SEND_LIMIT_VCH3"             => [   0, 196,   7, 0x0000, "Send limit value for VCh3" ],
   "SEND_LIMIT_VCH2"             => [   1, 189,   7, 0x0000, "Send limit value for VCh2" ],
   "SEND_LIMIT_VCH1"             => [   2, 182,   7, 0x0000, "Send limit value for VCh1" ],
   "SEND_LIMIT_VCH0"             => [   3, 175,   7, 0x0000, "Send limit value for VCh0" ],
   "RCV_INITIAL_VCH3"            => [   4, 169,   6, 0x0000, "Receive initial credit value for VCh3" ],
   "RCV_INITIAL_VCH2"            => [   5, 163,   6, 0x0000, "Receive initial credit value for VCh2" ],
   "RCV_INITIAL_VCH1"            => [   6, 157,   6, 0x0000, "Receive initial credit value for VCh1" ],
   "RCV_INITIAL_VCH0"            => [   7, 151,   6, 0x0000, "Receive initial credit value for VCh0" ],
   "FAKED_ALL_SN_ERRORS"         => [   8, 150,   1, 0x0000, "Asserted when fake SN counter reaches zero" ],
   "SENT_ALL_SN_ERRORS"          => [   9, 149,   1, 0x0000, "Asserted when SN counter reaches zero" ],
   "SENT_ALL_CB_ERRORS"          => [  10, 148,   1, 0x0000, "Asserted when CB counter reaches zero" ],
   "FAKE_SN_ERROR"               => [  11, 147,   1, 0x0000, "SSR pretends it received a bad SN" ],
   "SEND_SN_ERROR"               => [  12, 146,   1, 0x0000, "Inc. SN counter; SN errors may be forced" ],
   "SEND_CB_ERROR"               => [  13, 145,   1, 0x0000, "Inc. CB counter; CB errors may be forced" ],
   "USER_XCLR_TIME"              => [  14, 137,   8, 0x0000, "Interval to wait after reset and remotePOK" ],
   "ENABLE_USER_XCLR_TIME"       => [  15, 136,   1, 0x0000, "Enable user input of XClrTime" ],
   "USER_RWND_TIMEOUT"           => [  16, 128,   8, 0x0000, "Lost packet wait interval" ],
   "ENABLE_USER_RWND_TIMEOUT"    => [  17, 127,   1, 0x0000, "Enable user input of RewindTimeout" ],
   "USER_BOOT_TIME"              => [  18, 119,   8, 0x0000, "Failure wait interval" ],
   "ENABLE_USER_BOOT_TIME"       => [  19, 118,   1, 0x0000, "Enable user input of BootTime" ],
   "USER_IGNORE_TIME"            => [  20,  78,  40, 0x0000, "Ignore reset interval" ],
   "ENABLE_USER_IGNORE_TIME"     => [  21,  77,   1, 0x0000, "Enable user input of IgnoreTime" ],
   "USER_FT_TIME"                => [  22,  61,  16, 0x0000, "Number of clocks in reset tuning phase" ],
   "ENABLE_USER_FT_TIME"         => [  23,  60,   1, 0x0000, "Enable user input of FT_Time" ],
   "USER_FTU_TIME"               => [  24,  48,  12, 0x0000, "Internval between fine tune updates" ],
   "ENABLE_USER_FTU_TIME"        => [  25,  47,   1, 0x0000, "Enable user intput of FTU_Time" ],
   "USER_NULL_TIMEOUT"           => [  26,  41,   6, 0x0000, "Idle link time req'd to send null pkt" ],
   "ENABLE_USER_NULL_TIMEOUT"    => [  27,  40,   1, 0x0000, "Enable user input of NullTimeout" ],
   "USER_RWND_SYNC_RATIO"        => [  28,  34,   6, 0x0000, "Number of retries before resyncing" ],
   "ENABLE_USER_RWND_SYNC_RATIO" => [  29,  33,   1, 0x0000, "Enable user input of RewindSyncRatio" ],
   "USER_MAX_RETRY"              => [  30,  17,  16, 0x0000, "Maximum number of retries" ],
   "ENABLE_USER_MAX_RETRY"       => [  31,  16,   1, 0x0000, "Enable user input of MaxRetry" ],
   "USER_MAX_BURST"              => [  32,   6,  10, 0x0000, "Longest continuous data stream allowed" ],
   "ENABLE_USER_MAX_BURST"       => [  33,   5,   1, 0x0000, "Enable user input of MaxBurst" ],
   "ENABLE_RFTU"                 => [  34,   4,   1, 0x0000, "Enable fine tune update" ],
   "ENABLE_TUNING"               => [  35,   3,   1, 0x0000, "Enable PFSSR tuning" ],
   "ENABLE_AC"                   => [  36,   2,   1, 0x0000, "Enable AC encoding" ],
   "ENABLE_LINK"                 => [  37,   1,   1, 0x0000, "Enable LLP inputs" ],
   "BIT_MODE32"                  => [  38,   0,   1, 0x0000, "LLP should use 32 bit mode (0=16b)" ],
);

%nl4rtr_01_tdr_00032 =
(  NAME   => "LLP4_D",
   NOTE   => "Port D LLP4 Configuration Data",
   OPNAME => "LLP4_D",
   OPCODE => 0x16,
   LENGTH => 203,
   RESET  => [ 0x00000000, 0x00000000, 0x00000000, 0x00000000, 
               0x00000000, 0x00000000, 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00032
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00033 =
#  NAME                         IND  POS  LEN  MODE    DESCRIPTION
#  -------------------          ---  ---  ---  ------  -----------------------
(  "CAPTURE_RCV_SBSN"      => [   0, 226,  16, 0x0000, "description"            ],
   "CAPTURE_RCV_CRC"       => [   1, 210,  16, 0x0000, "description"            ],
   "CAPTURE_RCV_DATA_UP"   => [   2, 146,  64, 0x0000, "description"            ],
   "CAPTURE_RCV_DATA_LO"   => [   3,  82,  64, 0x0000, "description"            ],
   "CAPTURED_CB_ERR"       => [   4,  81,   1, 0x0000, "description"            ],
   "CAPTURED"              => [   5,  80,   1, 0x0000, "description"            ],
   "WIRE_ERR_OVERFLOW"     => [   6,  79,   1, 0x0000, "description"            ],
   "WIRE_ERR_CNT"          => [   7,  55,  24, 0x0000, "description"            ],
   "ERR_CAPTURE"           => [   8,  54,   1, 0x0000, "description"            ],
   "ARM_CAPTURE"           => [   9,  53,   1, 0x0000, "description"            ],
   "NOISE_MODE"            => [  10,  51,   2, 0x0000, "description"            ],
   "LFSR_MODE"             => [  11,  49,   2, 0x0000, "description"            ],
   "WIRE_SEL"              => [  12,  43,   6, 0x0000, "description"            ],
   "SEND_TEST_MODE"        => [  13,  41,   2, 0x0000, "description"            ],
   "TEST_PATTERN"          => [  14,   1,  40, 0x0000, "description"            ],
   "TEST_MODE"             => [  15,   0,   1, 0x0000, "description"            ]
);

%nl4rtr_01_tdr_00033 =
(  NAME   => "LLP4TEST_D",
   NOTE   => "Port D LLP Channel BIST",
   OPNAME => "LLP4TEST_D",
   OPCODE => 0x17,
   LENGTH => 242,
   RESET  => [ 0x0000000, 0x00000000, 0x00000000, 0x00000000,
               0x0000000, 0x00000000, 0x00000000, 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00033
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00034 =
#  NAME                               IND  POS  LEN  MODE    DESCRIPTION
#  -------------------                ---  ---  ---  ------  -----------------------
(  "SEND_LIMIT_VCH3"             => [   0, 196,   7, 0x0000, "Send limit value for VCh3" ],
   "SEND_LIMIT_VCH2"             => [   1, 189,   7, 0x0000, "Send limit value for VCh2" ],
   "SEND_LIMIT_VCH1"             => [   2, 182,   7, 0x0000, "Send limit value for VCh1" ],
   "SEND_LIMIT_VCH0"             => [   3, 175,   7, 0x0000, "Send limit value for VCh0" ],
   "RCV_INITIAL_VCH3"            => [   4, 169,   6, 0x0000, "Receive initial credit value for VCh3" ],
   "RCV_INITIAL_VCH2"            => [   5, 163,   6, 0x0000, "Receive initial credit value for VCh2" ],
   "RCV_INITIAL_VCH1"            => [   6, 157,   6, 0x0000, "Receive initial credit value for VCh1" ],
   "RCV_INITIAL_VCH0"            => [   7, 151,   6, 0x0000, "Receive initial credit value for VCh0" ],
   "FAKED_ALL_SN_ERRORS"         => [   8, 150,   1, 0x0000, "Asserted when fake SN counter reaches zero" ],
   "SENT_ALL_SN_ERRORS"          => [   9, 149,   1, 0x0000, "Asserted when SN counter reaches zero" ],
   "SENT_ALL_CB_ERRORS"          => [  10, 148,   1, 0x0000, "Asserted when CB counter reaches zero" ],
   "FAKE_SN_ERROR"               => [  11, 147,   1, 0x0000, "SSR pretends it received a bad SN" ],
   "SEND_SN_ERROR"               => [  12, 146,   1, 0x0000, "Inc. SN counter; SN errors may be forced" ],
   "SEND_CB_ERROR"               => [  13, 145,   1, 0x0000, "Inc. CB counter; CB errors may be forced" ],
   "USER_XCLR_TIME"              => [  14, 137,   8, 0x0000, "Interval to wait after reset and remotePOK" ],
   "ENABLE_USER_XCLR_TIME"       => [  15, 136,   1, 0x0000, "Enable user input of XClrTime" ],
   "USER_RWND_TIMEOUT"           => [  16, 128,   8, 0x0000, "Lost packet wait interval" ],
   "ENABLE_USER_RWND_TIMEOUT"    => [  17, 127,   1, 0x0000, "Enable user input of RewindTimeout" ],
   "USER_BOOT_TIME"              => [  18, 119,   8, 0x0000, "Failure wait interval" ],
   "ENABLE_USER_BOOT_TIME"       => [  19, 118,   1, 0x0000, "Enable user input of BootTime" ],
   "USER_IGNORE_TIME"            => [  20,  78,  40, 0x0000, "Ignore reset interval" ],
   "ENABLE_USER_IGNORE_TIME"     => [  21,  77,   1, 0x0000, "Enable user input of IgnoreTime" ],
   "USER_FT_TIME"                => [  22,  61,  16, 0x0000, "Number of clocks in reset tuning phase" ],
   "ENABLE_USER_FT_TIME"         => [  23,  60,   1, 0x0000, "Enable user input of FT_Time" ],
   "USER_FTU_TIME"               => [  24,  48,  12, 0x0000, "Internval between fine tune updates" ],
   "ENABLE_USER_FTU_TIME"        => [  25,  47,   1, 0x0000, "Enable user intput of FTU_Time" ],
   "USER_NULL_TIMEOUT"           => [  26,  41,   6, 0x0000, "Idle link time req'd to send null pkt" ],
   "ENABLE_USER_NULL_TIMEOUT"    => [  27,  40,   1, 0x0000, "Enable user input of NullTimeout" ],
   "USER_RWND_SYNC_RATIO"        => [  28,  34,   6, 0x0000, "Number of retries before resyncing" ],
   "ENABLE_USER_RWND_SYNC_RATIO" => [  29,  33,   1, 0x0000, "Enable user input of RewindSyncRatio" ],
   "USER_MAX_RETRY"              => [  30,  17,  16, 0x0000, "Maximum number of retries" ],
   "ENABLE_USER_MAX_RETRY"       => [  31,  16,   1, 0x0000, "Enable user input of MaxRetry" ],
   "USER_MAX_BURST"              => [  32,   6,  10, 0x0000, "Longest continuous data stream allowed" ],
   "ENABLE_USER_MAX_BURST"       => [  33,   5,   1, 0x0000, "Enable user input of MaxBurst" ],
   "ENABLE_RFTU"                 => [  34,   4,   1, 0x0000, "Enable fine tune update" ],
   "ENABLE_TUNING"               => [  35,   3,   1, 0x0000, "Enable PFSSR tuning" ],
   "ENABLE_AC"                   => [  36,   2,   1, 0x0000, "Enable AC encoding" ],
   "ENABLE_LINK"                 => [  37,   1,   1, 0x0000, "Enable LLP inputs" ],
   "BIT_MODE32"                  => [  38,   0,   1, 0x0000, "LLP should use 32 bit mode (0=16b)" ],
);

%nl4rtr_01_tdr_00034 =
(  NAME   => "LLP4_E",
   NOTE   => "Port E LLP4 Configuration Data",
   OPNAME => "LLP4_E",
   OPCODE => 0x18,
   LENGTH => 203,
   RESET  => [ 0x00000000, 0x00000000, 0x00000000, 0x00000000, 
               0x00000000, 0x00000000, 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00034
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00035 =
#  NAME                         IND  POS  LEN  MODE    DESCRIPTION
#  -------------------          ---  ---  ---  ------  -----------------------
(  "CAPTURE_RCV_SBSN"      => [   0, 226,  16, 0x0000, "description"            ],
   "CAPTURE_RCV_CRC"       => [   1, 210,  16, 0x0000, "description"            ],
   "CAPTURE_RCV_DATA_UP"   => [   2, 146,  64, 0x0000, "description"            ],
   "CAPTURE_RCV_DATA_LO"   => [   3,  82,  64, 0x0000, "description"            ],
   "CAPTURED_CB_ERR"       => [   4,  81,   1, 0x0000, "description"            ],
   "CAPTURED"              => [   5,  80,   1, 0x0000, "description"            ],
   "WIRE_ERR_OVERFLOW"     => [   6,  79,   1, 0x0000, "description"            ],
   "WIRE_ERR_CNT"          => [   7,  55,  24, 0x0000, "description"            ],
   "ERR_CAPTURE"           => [   8,  54,   1, 0x0000, "description"            ],
   "ARM_CAPTURE"           => [   9,  53,   1, 0x0000, "description"            ],
   "NOISE_MODE"            => [  10,  51,   2, 0x0000, "description"            ],
   "LFSR_MODE"             => [  11,  49,   2, 0x0000, "description"            ],
   "WIRE_SEL"              => [  12,  43,   6, 0x0000, "description"            ],
   "SEND_TEST_MODE"        => [  13,  41,   2, 0x0000, "description"            ],
   "TEST_PATTERN"          => [  14,   1,  40, 0x0000, "description"            ],
   "TEST_MODE"             => [  15,   0,   1, 0x0000, "description"            ]
);

%nl4rtr_01_tdr_00035 =
(  NAME   => "LLP4TEST_E",
   NOTE   => "Port E LLP Channel BIST",
   OPNAME => "LLP4TEST_E",
   OPCODE => 0x19,
   LENGTH => 242,
   RESET  => [ 0x0000000, 0x00000000, 0x00000000, 0x00000000,
               0x0000000, 0x00000000, 0x00000000, 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00035
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00036 =
#  NAME                               IND  POS  LEN  MODE    DESCRIPTION
#  -------------------                ---  ---  ---  ------  -----------------------
(  "SEND_LIMIT_VCH3"             => [   0, 196,   7, 0x0000, "Send limit value for VCh3" ],
   "SEND_LIMIT_VCH2"             => [   1, 189,   7, 0x0000, "Send limit value for VCh2" ],
   "SEND_LIMIT_VCH1"             => [   2, 182,   7, 0x0000, "Send limit value for VCh1" ],
   "SEND_LIMIT_VCH0"             => [   3, 175,   7, 0x0000, "Send limit value for VCh0" ],
   "RCV_INITIAL_VCH3"            => [   4, 169,   6, 0x0000, "Receive initial credit value for VCh3" ],
   "RCV_INITIAL_VCH2"            => [   5, 163,   6, 0x0000, "Receive initial credit value for VCh2" ],
   "RCV_INITIAL_VCH1"            => [   6, 157,   6, 0x0000, "Receive initial credit value for VCh1" ],
   "RCV_INITIAL_VCH0"            => [   7, 151,   6, 0x0000, "Receive initial credit value for VCh0" ],
   "FAKED_ALL_SN_ERRORS"         => [   8, 150,   1, 0x0000, "Asserted when fake SN counter reaches zero" ],
   "SENT_ALL_SN_ERRORS"          => [   9, 149,   1, 0x0000, "Asserted when SN counter reaches zero" ],
   "SENT_ALL_CB_ERRORS"          => [  10, 148,   1, 0x0000, "Asserted when CB counter reaches zero" ],
   "FAKE_SN_ERROR"               => [  11, 147,   1, 0x0000, "SSR pretends it received a bad SN" ],
   "SEND_SN_ERROR"               => [  12, 146,   1, 0x0000, "Inc. SN counter; SN errors may be forced" ],
   "SEND_CB_ERROR"               => [  13, 145,   1, 0x0000, "Inc. CB counter; CB errors may be forced" ],
   "USER_XCLR_TIME"              => [  14, 137,   8, 0x0000, "Interval to wait after reset and remotePOK" ],
   "ENABLE_USER_XCLR_TIME"       => [  15, 136,   1, 0x0000, "Enable user input of XClrTime" ],
   "USER_RWND_TIMEOUT"           => [  16, 128,   8, 0x0000, "Lost packet wait interval" ],
   "ENABLE_USER_RWND_TIMEOUT"    => [  17, 127,   1, 0x0000, "Enable user input of RewindTimeout" ],
   "USER_BOOT_TIME"              => [  18, 119,   8, 0x0000, "Failure wait interval" ],
   "ENABLE_USER_BOOT_TIME"       => [  19, 118,   1, 0x0000, "Enable user input of BootTime" ],
   "USER_IGNORE_TIME"            => [  20,  78,  40, 0x0000, "Ignore reset interval" ],
   "ENABLE_USER_IGNORE_TIME"     => [  21,  77,   1, 0x0000, "Enable user input of IgnoreTime" ],
   "USER_FT_TIME"                => [  22,  61,  16, 0x0000, "Number of clocks in reset tuning phase" ],
   "ENABLE_USER_FT_TIME"         => [  23,  60,   1, 0x0000, "Enable user input of FT_Time" ],
   "USER_FTU_TIME"               => [  24,  48,  12, 0x0000, "Internval between fine tune updates" ],
   "ENABLE_USER_FTU_TIME"        => [  25,  47,   1, 0x0000, "Enable user intput of FTU_Time" ],
   "USER_NULL_TIMEOUT"           => [  26,  41,   6, 0x0000, "Idle link time req'd to send null pkt" ],
   "ENABLE_USER_NULL_TIMEOUT"    => [  27,  40,   1, 0x0000, "Enable user input of NullTimeout" ],
   "USER_RWND_SYNC_RATIO"        => [  28,  34,   6, 0x0000, "Number of retries before resyncing" ],
   "ENABLE_USER_RWND_SYNC_RATIO" => [  29,  33,   1, 0x0000, "Enable user input of RewindSyncRatio" ],
   "USER_MAX_RETRY"              => [  30,  17,  16, 0x0000, "Maximum number of retries" ],
   "ENABLE_USER_MAX_RETRY"       => [  31,  16,   1, 0x0000, "Enable user input of MaxRetry" ],
   "USER_MAX_BURST"              => [  32,   6,  10, 0x0000, "Longest continuous data stream allowed" ],
   "ENABLE_USER_MAX_BURST"       => [  33,   5,   1, 0x0000, "Enable user input of MaxBurst" ],
   "ENABLE_RFTU"                 => [  34,   4,   1, 0x0000, "Enable fine tune update" ],
   "ENABLE_TUNING"               => [  35,   3,   1, 0x0000, "Enable PFSSR tuning" ],
   "ENABLE_AC"                   => [  36,   2,   1, 0x0000, "Enable AC encoding" ],
   "ENABLE_LINK"                 => [  37,   1,   1, 0x0000, "Enable LLP inputs" ],
   "BIT_MODE32"                  => [  38,   0,   1, 0x0000, "LLP should use 32 bit mode (0=16b)" ],
);

%nl4rtr_01_tdr_00036 =
(  NAME   => "LLP4_F",
   NOTE   => "Port F LLP4 Configuration Data",
   OPNAME => "LLP4_F",
   OPCODE => 0x1A,
   LENGTH => 203,
   RESET  => [ 0x00000000, 0x00000000, 0x00000000, 0x00000000, 
               0x00000000, 0x00000000, 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00036
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00037 =
#  NAME                         IND  POS  LEN  MODE    DESCRIPTION
#  -------------------          ---  ---  ---  ------  -----------------------
(  "CAPTURE_RCV_SBSN"      => [   0, 226,  16, 0x0000, "description"            ],
   "CAPTURE_RCV_CRC"       => [   1, 210,  16, 0x0000, "description"            ],
   "CAPTURE_RCV_DATA_UP"   => [   2, 146,  64, 0x0000, "description"            ],
   "CAPTURE_RCV_DATA_LO"   => [   3,  82,  64, 0x0000, "description"            ],
   "CAPTURED_CB_ERR"       => [   4,  81,   1, 0x0000, "description"            ],
   "CAPTURED"              => [   5,  80,   1, 0x0000, "description"            ],
   "WIRE_ERR_OVERFLOW"     => [   6,  79,   1, 0x0000, "description"            ],
   "WIRE_ERR_CNT"          => [   7,  55,  24, 0x0000, "description"            ],
   "ERR_CAPTURE"           => [   8,  54,   1, 0x0000, "description"            ],
   "ARM_CAPTURE"           => [   9,  53,   1, 0x0000, "description"            ],
   "NOISE_MODE"            => [  10,  51,   2, 0x0000, "description"            ],
   "LFSR_MODE"             => [  11,  49,   2, 0x0000, "description"            ],
   "WIRE_SEL"              => [  12,  43,   6, 0x0000, "description"            ],
   "SEND_TEST_MODE"        => [  13,  41,   2, 0x0000, "description"            ],
   "TEST_PATTERN"          => [  14,   1,  40, 0x0000, "description"            ],
   "TEST_MODE"             => [  15,   0,   1, 0x0000, "description"            ]
);

%nl4rtr_01_tdr_00037 =
(  NAME   => "LLP4TEST_F",
   NOTE   => "Port F LLP Channel BIST",
   OPNAME => "LLP4TEST_F",
   OPCODE => 0x1B,
   LENGTH => 242,
   RESET  => [ 0x0000000, 0x00000000, 0x00000000, 0x00000000,
               0x0000000, 0x00000000, 0x00000000, 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00037
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00038 =
#  NAME                               IND  POS  LEN  MODE    DESCRIPTION
#  -------------------                ---  ---  ---  ------  -----------------------
(  "SEND_LIMIT_VCH3"             => [   0, 196,   7, 0x0000, "Send limit value for VCh3" ],
   "SEND_LIMIT_VCH2"             => [   1, 189,   7, 0x0000, "Send limit value for VCh2" ],
   "SEND_LIMIT_VCH1"             => [   2, 182,   7, 0x0000, "Send limit value for VCh1" ],
   "SEND_LIMIT_VCH0"             => [   3, 175,   7, 0x0000, "Send limit value for VCh0" ],
   "RCV_INITIAL_VCH3"            => [   4, 169,   6, 0x0000, "Receive initial credit value for VCh3" ],
   "RCV_INITIAL_VCH2"            => [   5, 163,   6, 0x0000, "Receive initial credit value for VCh2" ],
   "RCV_INITIAL_VCH1"            => [   6, 157,   6, 0x0000, "Receive initial credit value for VCh1" ],
   "RCV_INITIAL_VCH0"            => [   7, 151,   6, 0x0000, "Receive initial credit value for VCh0" ],
   "FAKED_ALL_SN_ERRORS"         => [   8, 150,   1, 0x0000, "Asserted when fake SN counter reaches zero" ],
   "SENT_ALL_SN_ERRORS"          => [   9, 149,   1, 0x0000, "Asserted when SN counter reaches zero" ],
   "SENT_ALL_CB_ERRORS"          => [  10, 148,   1, 0x0000, "Asserted when CB counter reaches zero" ],
   "FAKE_SN_ERROR"               => [  11, 147,   1, 0x0000, "SSR pretends it received a bad SN" ],
   "SEND_SN_ERROR"               => [  12, 146,   1, 0x0000, "Inc. SN counter; SN errors may be forced" ],
   "SEND_CB_ERROR"               => [  13, 145,   1, 0x0000, "Inc. CB counter; CB errors may be forced" ],
   "USER_XCLR_TIME"              => [  14, 137,   8, 0x0000, "Interval to wait after reset and remotePOK" ],
   "ENABLE_USER_XCLR_TIME"       => [  15, 136,   1, 0x0000, "Enable user input of XClrTime" ],
   "USER_RWND_TIMEOUT"           => [  16, 128,   8, 0x0000, "Lost packet wait interval" ],
   "ENABLE_USER_RWND_TIMEOUT"    => [  17, 127,   1, 0x0000, "Enable user input of RewindTimeout" ],
   "USER_BOOT_TIME"              => [  18, 119,   8, 0x0000, "Failure wait interval" ],
   "ENABLE_USER_BOOT_TIME"       => [  19, 118,   1, 0x0000, "Enable user input of BootTime" ],
   "USER_IGNORE_TIME"            => [  20,  78,  40, 0x0000, "Ignore reset interval" ],
   "ENABLE_USER_IGNORE_TIME"     => [  21,  77,   1, 0x0000, "Enable user input of IgnoreTime" ],
   "USER_FT_TIME"                => [  22,  61,  16, 0x0000, "Number of clocks in reset tuning phase" ],
   "ENABLE_USER_FT_TIME"         => [  23,  60,   1, 0x0000, "Enable user input of FT_Time" ],
   "USER_FTU_TIME"               => [  24,  48,  12, 0x0000, "Internval between fine tune updates" ],
   "ENABLE_USER_FTU_TIME"        => [  25,  47,   1, 0x0000, "Enable user intput of FTU_Time" ],
   "USER_NULL_TIMEOUT"           => [  26,  41,   6, 0x0000, "Idle link time req'd to send null pkt" ],
   "ENABLE_USER_NULL_TIMEOUT"    => [  27,  40,   1, 0x0000, "Enable user input of NullTimeout" ],
   "USER_RWND_SYNC_RATIO"        => [  28,  34,   6, 0x0000, "Number of retries before resyncing" ],
   "ENABLE_USER_RWND_SYNC_RATIO" => [  29,  33,   1, 0x0000, "Enable user input of RewindSyncRatio" ],
   "USER_MAX_RETRY"              => [  30,  17,  16, 0x0000, "Maximum number of retries" ],
   "ENABLE_USER_MAX_RETRY"       => [  31,  16,   1, 0x0000, "Enable user input of MaxRetry" ],
   "USER_MAX_BURST"              => [  32,   6,  10, 0x0000, "Longest continuous data stream allowed" ],
   "ENABLE_USER_MAX_BURST"       => [  33,   5,   1, 0x0000, "Enable user input of MaxBurst" ],
   "ENABLE_RFTU"                 => [  34,   4,   1, 0x0000, "Enable fine tune update" ],
   "ENABLE_TUNING"               => [  35,   3,   1, 0x0000, "Enable PFSSR tuning" ],
   "ENABLE_AC"                   => [  36,   2,   1, 0x0000, "Enable AC encoding" ],
   "ENABLE_LINK"                 => [  37,   1,   1, 0x0000, "Enable LLP inputs" ],
   "BIT_MODE32"                  => [  38,   0,   1, 0x0000, "LLP should use 32 bit mode (0=16b)" ],
);

%nl4rtr_01_tdr_00038 =
(  NAME   => "LLP4_G",
   NOTE   => "Port G LLP4 Configuration Data",
   OPNAME => "LLP4_G",
   OPCODE => 0x1C,
   LENGTH => 203,
   RESET  => [ 0x00000000, 0x00000000, 0x00000000, 0x00000000, 
               0x00000000, 0x00000000, 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00038
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00039 =
#  NAME                         IND  POS  LEN  MODE    DESCRIPTION
#  -------------------          ---  ---  ---  ------  -----------------------
(  "CAPTURE_RCV_SBSN"      => [   0, 226,  16, 0x0000, "description"            ],
   "CAPTURE_RCV_CRC"       => [   1, 210,  16, 0x0000, "description"            ],
   "CAPTURE_RCV_DATA_UP"   => [   2, 146,  64, 0x0000, "description"            ],
   "CAPTURE_RCV_DATA_LO"   => [   3,  82,  64, 0x0000, "description"            ],
   "CAPTURED_CB_ERR"       => [   4,  81,   1, 0x0000, "description"            ],
   "CAPTURED"              => [   5,  80,   1, 0x0000, "description"            ],
   "WIRE_ERR_OVERFLOW"     => [   6,  79,   1, 0x0000, "description"            ],
   "WIRE_ERR_CNT"          => [   7,  55,  24, 0x0000, "description"            ],
   "ERR_CAPTURE"           => [   8,  54,   1, 0x0000, "description"            ],
   "ARM_CAPTURE"           => [   9,  53,   1, 0x0000, "description"            ],
   "NOISE_MODE"            => [  10,  51,   2, 0x0000, "description"            ],
   "LFSR_MODE"             => [  11,  49,   2, 0x0000, "description"            ],
   "WIRE_SEL"              => [  12,  43,   6, 0x0000, "description"            ],
   "SEND_TEST_MODE"        => [  13,  41,   2, 0x0000, "description"            ],
   "TEST_PATTERN"          => [  14,   1,  40, 0x0000, "description"            ],
   "TEST_MODE"             => [  15,   0,   1, 0x0000, "description"            ]
);

%nl4rtr_01_tdr_00039 =
(  NAME   => "LLP4TEST_G",
   NOTE   => "Port G LLP Channel BIST",
   OPNAME => "LLP4TEST_G",
   OPCODE => 0x1D,
   LENGTH => 242,
   RESET  => [ 0x0000000, 0x00000000, 0x00000000, 0x00000000,
               0x0000000, 0x00000000, 0x00000000, 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00039
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00040 =
#  NAME                               IND  POS  LEN  MODE    DESCRIPTION
#  -------------------                ---  ---  ---  ------  -----------------------
(  "SEND_LIMIT_VCH3"             => [   0, 196,   7, 0x0000, "Send limit value for VCh3" ],
   "SEND_LIMIT_VCH2"             => [   1, 189,   7, 0x0000, "Send limit value for VCh2" ],
   "SEND_LIMIT_VCH1"             => [   2, 182,   7, 0x0000, "Send limit value for VCh1" ],
   "SEND_LIMIT_VCH0"             => [   3, 175,   7, 0x0000, "Send limit value for VCh0" ],
   "RCV_INITIAL_VCH3"            => [   4, 169,   6, 0x0000, "Receive initial credit value for VCh3" ],
   "RCV_INITIAL_VCH2"            => [   5, 163,   6, 0x0000, "Receive initial credit value for VCh2" ],
   "RCV_INITIAL_VCH1"            => [   6, 157,   6, 0x0000, "Receive initial credit value for VCh1" ],
   "RCV_INITIAL_VCH0"            => [   7, 151,   6, 0x0000, "Receive initial credit value for VCh0" ],
   "FAKED_ALL_SN_ERRORS"         => [   8, 150,   1, 0x0000, "Asserted when fake SN counter reaches zero" ],
   "SENT_ALL_SN_ERRORS"          => [   9, 149,   1, 0x0000, "Asserted when SN counter reaches zero" ],
   "SENT_ALL_CB_ERRORS"          => [  10, 148,   1, 0x0000, "Asserted when CB counter reaches zero" ],
   "FAKE_SN_ERROR"               => [  11, 147,   1, 0x0000, "SSR pretends it received a bad SN" ],
   "SEND_SN_ERROR"               => [  12, 146,   1, 0x0000, "Inc. SN counter; SN errors may be forced" ],
   "SEND_CB_ERROR"               => [  13, 145,   1, 0x0000, "Inc. CB counter; CB errors may be forced" ],
   "USER_XCLR_TIME"              => [  14, 137,   8, 0x0000, "Interval to wait after reset and remotePOK" ],
   "ENABLE_USER_XCLR_TIME"       => [  15, 136,   1, 0x0000, "Enable user input of XClrTime" ],
   "USER_RWND_TIMEOUT"           => [  16, 128,   8, 0x0000, "Lost packet wait interval" ],
   "ENABLE_USER_RWND_TIMEOUT"    => [  17, 127,   1, 0x0000, "Enable user input of RewindTimeout" ],
   "USER_BOOT_TIME"              => [  18, 119,   8, 0x0000, "Failure wait interval" ],
   "ENABLE_USER_BOOT_TIME"       => [  19, 118,   1, 0x0000, "Enable user input of BootTime" ],
   "USER_IGNORE_TIME"            => [  20,  78,  40, 0x0000, "Ignore reset interval" ],
   "ENABLE_USER_IGNORE_TIME"     => [  21,  77,   1, 0x0000, "Enable user input of IgnoreTime" ],
   "USER_FT_TIME"                => [  22,  61,  16, 0x0000, "Number of clocks in reset tuning phase" ],
   "ENABLE_USER_FT_TIME"         => [  23,  60,   1, 0x0000, "Enable user input of FT_Time" ],
   "USER_FTU_TIME"               => [  24,  48,  12, 0x0000, "Internval between fine tune updates" ],
   "ENABLE_USER_FTU_TIME"        => [  25,  47,   1, 0x0000, "Enable user intput of FTU_Time" ],
   "USER_NULL_TIMEOUT"           => [  26,  41,   6, 0x0000, "Idle link time req'd to send null pkt" ],
   "ENABLE_USER_NULL_TIMEOUT"    => [  27,  40,   1, 0x0000, "Enable user input of NullTimeout" ],
   "USER_RWND_SYNC_RATIO"        => [  28,  34,   6, 0x0000, "Number of retries before resyncing" ],
   "ENABLE_USER_RWND_SYNC_RATIO" => [  29,  33,   1, 0x0000, "Enable user input of RewindSyncRatio" ],
   "USER_MAX_RETRY"              => [  30,  17,  16, 0x0000, "Maximum number of retries" ],
   "ENABLE_USER_MAX_RETRY"       => [  31,  16,   1, 0x0000, "Enable user input of MaxRetry" ],
   "USER_MAX_BURST"              => [  32,   6,  10, 0x0000, "Longest continuous data stream allowed" ],
   "ENABLE_USER_MAX_BURST"       => [  33,   5,   1, 0x0000, "Enable user input of MaxBurst" ],
   "ENABLE_RFTU"                 => [  34,   4,   1, 0x0000, "Enable fine tune update" ],
   "ENABLE_TUNING"               => [  35,   3,   1, 0x0000, "Enable PFSSR tuning" ],
   "ENABLE_AC"                   => [  36,   2,   1, 0x0000, "Enable AC encoding" ],
   "ENABLE_LINK"                 => [  37,   1,   1, 0x0000, "Enable LLP inputs" ],
   "BIT_MODE32"                  => [  38,   0,   1, 0x0000, "LLP should use 32 bit mode (0=16b)" ],
);

%nl4rtr_01_tdr_00040 =
(  NAME   => "LLP4_H",
   NOTE   => "Port H LLP4 Configuration Data",
   OPNAME => "LLP4_H",
   OPCODE => 0x1E,
   LENGTH => 203,
   RESET  => [ 0x00000000, 0x00000000, 0x00000000, 0x00000000, 
               0x00000000, 0x00000000, 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00040
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00041 =
#  NAME                         IND  POS  LEN  MODE    DESCRIPTION
#  -------------------          ---  ---  ---  ------  -----------------------
(  "CAPTURE_RCV_SBSN"      => [   0, 226,  16, 0x0000, "description"            ],
   "CAPTURE_RCV_CRC"       => [   1, 210,  16, 0x0000, "description"            ],
   "CAPTURE_RCV_DATA_UP"   => [   2, 146,  64, 0x0000, "description"            ],
   "CAPTURE_RCV_DATA_LO"   => [   3,  82,  64, 0x0000, "description"            ],
   "CAPTURED_CB_ERR"       => [   4,  81,   1, 0x0000, "description"            ],
   "CAPTURED"              => [   5,  80,   1, 0x0000, "description"            ],
   "WIRE_ERR_OVERFLOW"     => [   6,  79,   1, 0x0000, "description"            ],
   "WIRE_ERR_CNT"          => [   7,  55,  24, 0x0000, "description"            ],
   "ERR_CAPTURE"           => [   8,  54,   1, 0x0000, "description"            ],
   "ARM_CAPTURE"           => [   9,  53,   1, 0x0000, "description"            ],
   "NOISE_MODE"            => [  10,  51,   2, 0x0000, "description"            ],
   "LFSR_MODE"             => [  11,  49,   2, 0x0000, "description"            ],
   "WIRE_SEL"              => [  12,  43,   6, 0x0000, "description"            ],
   "SEND_TEST_MODE"        => [  13,  41,   2, 0x0000, "description"            ],
   "TEST_PATTERN"          => [  14,   1,  40, 0x0000, "description"            ],
   "TEST_MODE"             => [  15,   0,   1, 0x0000, "description"            ]
);

%nl4rtr_01_tdr_00041 =
(  NAME   => "LLP4TEST_H",
   NOTE   => "Port H LLP Channel BIST",
   OPNAME => "LLP4TEST_H",
   OPCODE => 0x1F,
   LENGTH => 242,
   RESET  => [ 0x0000000, 0x00000000, 0x00000000, 0x00000000,
               0x0000000, 0x00000000, 0x00000000, 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00041
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00042 =
#  NAME                     IND  POS  LEN  MODE    DESCRIPTION
#  -------------------      ---  ---  ---  ------  -----------------------
(  "DATA"              => [   0,   0,  64, 0x0000, ""                       ],
);

%nl4rtr_01_tdr_00042 =
(  NAME   => "ASIC_L1_DATA",
   NOTE   => "TIO to L1 data register",
   OPNAME => "ASIC_L1_DATA",
   OPCODE => 0x0C,
   LENGTH => 64,
   RESET  => [ 0x00000000, 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00042
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00043 =
#  NAME                     IND  POS  LEN  MODE    DESCRIPTION
#  -------------------      ---  ---  ---  ------  -----------------------
(  "DATA"              => [   0,   0,  64, 0x0000, ""                       ],
);

%nl4rtr_01_tdr_00043 =
(  NAME   => "L1_ASIC_DATA",
   NOTE   => "L1 to TIO data register",
   OPNAME => "L1_ASIC_DATA",
   OPCODE => 0x0D,
   LENGTH => 64,
   RESET  => [ 0x00000000, 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00043
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00044 =
#  NAME                       IND  POS  LEN  MODE    DESCRIPTION
#  -------------------        ---  ---  ---  ------  -----------------------
(  "START"               => [   0,  29,   1, 0x0000, "Start PIO operation to addressed MMR" ],
   "WRITE"               => [   1,  28,   1, 0x0000, "Operation is a write (1=write, 0=read)" ],
   "PIO_ADDRESS"         => [   2,   0,  28, 0x0000, "Physical address of MMR to access" ]
);

%nl4rtr_01_tdr_00044 =
(  NAME   => "PIO_CTRL",
   NOTE   => "Control Register for PIO",
   OPNAME => "PIO_CTRL",
   OPCODE => 0x0A,
   LENGTH => 30,
   RESET  => [ 0x0000000 ],
   FIELDS => \%nl4rtr_01_flds_00044
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00045 =
#  NAME                       IND  POS  LEN  MODE    DESCRIPTION
#  -------------------        ---  ---  ---  ------  -----------------------
(  "ERROR"               => [   0,  65,   1, 0x0000, "Error occured with the PIO operation"   ],
   "VALID"               => [   1,  64,   1, 0x0000, "Read data is valid; operation complete" ],
   "DATA"                => [   2,   0,  64, 0x0000, "Read or write data from/for MMR"        ]
);

%nl4rtr_01_tdr_00045 =
(  NAME   => "PIO_DATA",
   NOTE   => "Data Register for PIO",
   OPNAME => "PIO_DATA",
   OPCODE => 0x0B,
   LENGTH => 66,
   RESET  => [ 0x0, 0x00000000, 0x00000000 ],
   FIELDS => \%nl4rtr_01_flds_00045
);


#-------------------------------------------------------------------------------

%nl4rtr_01_flds_00046 =
#  NAME                     IND  POS  LEN  MODE    DESCRIPTION
#  -------------------      ---  ---  ---  ------  -----------------------
(  "RSVD"              => [   0,   0,   1, 0x0000, ""                       ],
);

%nl4rtr_01_tdr_00046 =
(  NAME   => "HIGHZ",
   NOTE   => "HIGHZ instruction",
   OPNAME => "HIGHZ",
   OPCODE => 0x04,
   LENGTH => 1,
   RESET  => [ 0x0 ],
   FIELDS => \%nl4rtr_01_flds_00046
);


#-------------------------------------------------------------------------------

#-----------------------------------
#  HASH TABLE: LOOKUP TDR BY OPNAME
#-----------------------------------

%nl4rtr_01_tdrs =
(  $nl4rtr_01_tdr_00000{OPNAME} => \%nl4rtr_01_tdr_00000,
   $nl4rtr_01_tdr_00001{OPNAME} => \%nl4rtr_01_tdr_00001,
   $nl4rtr_01_tdr_00002{OPNAME} => \%nl4rtr_01_tdr_00002,
   $nl4rtr_01_tdr_00003{OPNAME} => \%nl4rtr_01_tdr_00003,
   $nl4rtr_01_tdr_00004{OPNAME} => \%nl4rtr_01_tdr_00004,
   $nl4rtr_01_tdr_00005{OPNAME} => \%nl4rtr_01_tdr_00005,
   $nl4rtr_01_tdr_00006{OPNAME} => \%nl4rtr_01_tdr_00006,
   $nl4rtr_01_tdr_00007{OPNAME} => \%nl4rtr_01_tdr_00007,
   $nl4rtr_01_tdr_00008{OPNAME} => \%nl4rtr_01_tdr_00008,
   $nl4rtr_01_tdr_00009{OPNAME} => \%nl4rtr_01_tdr_00009,
   $nl4rtr_01_tdr_00010{OPNAME} => \%nl4rtr_01_tdr_00010,
   $nl4rtr_01_tdr_00011{OPNAME} => \%nl4rtr_01_tdr_00011,
   $nl4rtr_01_tdr_00012{OPNAME} => \%nl4rtr_01_tdr_00012,
   $nl4rtr_01_tdr_00013{OPNAME} => \%nl4rtr_01_tdr_00013,
   $nl4rtr_01_tdr_00014{OPNAME} => \%nl4rtr_01_tdr_00014,
   $nl4rtr_01_tdr_00015{OPNAME} => \%nl4rtr_01_tdr_00015,
   $nl4rtr_01_tdr_00016{OPNAME} => \%nl4rtr_01_tdr_00016,
   $nl4rtr_01_tdr_00017{OPNAME} => \%nl4rtr_01_tdr_00017,
   $nl4rtr_01_tdr_00018{OPNAME} => \%nl4rtr_01_tdr_00018,
   $nl4rtr_01_tdr_00019{OPNAME} => \%nl4rtr_01_tdr_00019,
   $nl4rtr_01_tdr_00020{OPNAME} => \%nl4rtr_01_tdr_00020,
   $nl4rtr_01_tdr_00021{OPNAME} => \%nl4rtr_01_tdr_00021,
   $nl4rtr_01_tdr_00022{OPNAME} => \%nl4rtr_01_tdr_00022,
   $nl4rtr_01_tdr_00023{OPNAME} => \%nl4rtr_01_tdr_00023,
   $nl4rtr_01_tdr_00024{OPNAME} => \%nl4rtr_01_tdr_00024,
   $nl4rtr_01_tdr_00025{OPNAME} => \%nl4rtr_01_tdr_00025,
   $nl4rtr_01_tdr_00026{OPNAME} => \%nl4rtr_01_tdr_00026,
   $nl4rtr_01_tdr_00027{OPNAME} => \%nl4rtr_01_tdr_00027,
   $nl4rtr_01_tdr_00028{OPNAME} => \%nl4rtr_01_tdr_00028,
   $nl4rtr_01_tdr_00029{OPNAME} => \%nl4rtr_01_tdr_00029,
   $nl4rtr_01_tdr_00030{OPNAME} => \%nl4rtr_01_tdr_00030,
   $nl4rtr_01_tdr_00031{OPNAME} => \%nl4rtr_01_tdr_00031,
   $nl4rtr_01_tdr_00032{OPNAME} => \%nl4rtr_01_tdr_00032,
   $nl4rtr_01_tdr_00033{OPNAME} => \%nl4rtr_01_tdr_00033,
   $nl4rtr_01_tdr_00034{OPNAME} => \%nl4rtr_01_tdr_00034,
   $nl4rtr_01_tdr_00035{OPNAME} => \%nl4rtr_01_tdr_00035,
   $nl4rtr_01_tdr_00036{OPNAME} => \%nl4rtr_01_tdr_00036,
   $nl4rtr_01_tdr_00037{OPNAME} => \%nl4rtr_01_tdr_00037,
   $nl4rtr_01_tdr_00038{OPNAME} => \%nl4rtr_01_tdr_00038,
   $nl4rtr_01_tdr_00039{OPNAME} => \%nl4rtr_01_tdr_00039,
   $nl4rtr_01_tdr_00040{OPNAME} => \%nl4rtr_01_tdr_00040,
   $nl4rtr_01_tdr_00041{OPNAME} => \%nl4rtr_01_tdr_00041,
   $nl4rtr_01_tdr_00042{OPNAME} => \%nl4rtr_01_tdr_00042,
   $nl4rtr_01_tdr_00043{OPNAME} => \%nl4rtr_01_tdr_00043,
   $nl4rtr_01_tdr_00044{OPNAME} => \%nl4rtr_01_tdr_00044,
   $nl4rtr_01_tdr_00045{OPNAME} => \%nl4rtr_01_tdr_00045,
   $nl4rtr_01_tdr_00046{OPNAME} => \%nl4rtr_01_tdr_00046
);


#-----------------------------------
#  ARRAY: STORE OPNAMES IN "ORDER"
#-----------------------------------

@nl4rtr_01_opnames =
(  $nl4rtr_01_tdr_00000{OPNAME},
   $nl4rtr_01_tdr_00001{OPNAME},
   $nl4rtr_01_tdr_00002{OPNAME},
   $nl4rtr_01_tdr_00003{OPNAME},
   $nl4rtr_01_tdr_00004{OPNAME},
   $nl4rtr_01_tdr_00005{OPNAME},
   $nl4rtr_01_tdr_00006{OPNAME},
   $nl4rtr_01_tdr_00007{OPNAME},
   $nl4rtr_01_tdr_00008{OPNAME},
   $nl4rtr_01_tdr_00009{OPNAME},
   $nl4rtr_01_tdr_00010{OPNAME},
   $nl4rtr_01_tdr_00011{OPNAME},
   $nl4rtr_01_tdr_00012{OPNAME},
   $nl4rtr_01_tdr_00013{OPNAME},
   $nl4rtr_01_tdr_00014{OPNAME},
   $nl4rtr_01_tdr_00015{OPNAME},
   $nl4rtr_01_tdr_00016{OPNAME},
   $nl4rtr_01_tdr_00017{OPNAME},
   $nl4rtr_01_tdr_00018{OPNAME},
   $nl4rtr_01_tdr_00019{OPNAME},
   $nl4rtr_01_tdr_00020{OPNAME},
   $nl4rtr_01_tdr_00021{OPNAME},
   $nl4rtr_01_tdr_00022{OPNAME},
   $nl4rtr_01_tdr_00023{OPNAME},
   $nl4rtr_01_tdr_00024{OPNAME},
   $nl4rtr_01_tdr_00025{OPNAME},
   $nl4rtr_01_tdr_00026{OPNAME},
   $nl4rtr_01_tdr_00027{OPNAME},
   $nl4rtr_01_tdr_00028{OPNAME},
   $nl4rtr_01_tdr_00029{OPNAME},
   $nl4rtr_01_tdr_00030{OPNAME},
   $nl4rtr_01_tdr_00031{OPNAME},
   $nl4rtr_01_tdr_00032{OPNAME},
   $nl4rtr_01_tdr_00033{OPNAME},
   $nl4rtr_01_tdr_00034{OPNAME},
   $nl4rtr_01_tdr_00035{OPNAME},
   $nl4rtr_01_tdr_00036{OPNAME},
   $nl4rtr_01_tdr_00037{OPNAME},
   $nl4rtr_01_tdr_00038{OPNAME},
   $nl4rtr_01_tdr_00039{OPNAME},
   $nl4rtr_01_tdr_00040{OPNAME},
   $nl4rtr_01_tdr_00041{OPNAME},
   $nl4rtr_01_tdr_00042{OPNAME},
   $nl4rtr_01_tdr_00043{OPNAME},
   $nl4rtr_01_tdr_00044{OPNAME},
   $nl4rtr_01_tdr_00045{OPNAME},
   $nl4rtr_01_tdr_00046{OPNAME}
);

#-------------------------------------------------------------------------------

1;
