#==============================================================================
#
#  Unpublished copyright (c) 2004-2005, Silicon Graphics, Inc.
#  THIS IS UNPUBLISHED CONFIDENTIAL AND PROPRIETARY SOURCE CODE OF SGI.
#
#  The copyright notice above does  not evidence any actual or intended
#  publication  or  disclosure  of  this source  code,  which  includes
#  information that is confidential  and/or proprietary, and is a trade
#  secret, of  Silicon Graphics, Inc.   ANY REPRODUCTION, MODIFICATION,
#  DISTRIBUTION, PUBLIC  PERFORMANCE, OR  PUBLIC DISPLAY OF  OR THROUGH
#  USE  OF THIS  SOURCE CODE  WITHOUT  THE EXPRESS  WRITTEN CONSENT  OF
#  SILICON GRAPHICS, INC.  IS  STRICTLY PROHIBITED, AND IN VIOLATION OF
#  APPLICABLE  LAWS   AND  INTERNATIONAL  TREATIES.    THE  RECEIPT  OR
#  POSSESSION OF  THIS SOURCE CODE AND/OR RELATED  INFORMATION DOES NOT
#  CONVEY OR IMPLY ANY RIGHTS  TO REPRODUCE, DISCLOSE OR DISTRIBUTE ITS
#  CONTENTS,  OR TO  MANUFACTURE, USE,  OR  SELL ANYTHING  THAT IT  MAY
#  DESCRIBE, IN WHOLE OR IN PART.
#
#------------------------------------------------------------------------------
#
# @(#)$Id: shubbt_help.pm,v 1.1 2005/06/14 15:52:51 oster Exp $
#
#------------------------------------------------------------------------------
#
#  FILE: shubbt_help.pm
#
#  DESCRIPTION:  Documentation/Help for "shubbt" utility.
#
#  REVISION HISTORY:
#
#  Rev.  Date      Author            Description
#  ----  --------  ----------------  ------------------------------------------
#        06/13/05  Darin Oster       Created
#
#==============================================================================

$HELP_SUMMARY = "\
SCRIPT USAGE:\
\
  shubbt -l2 <l2_host> [arglist...]\
\
SCRIPT OPTIONS:\
\
  commands         arguments  description\
  ----------------- --------- -------------------------------------------------\
  -help            [option]   print this screen or detail for specified option\
  -copy                       bte copy\
  -zero                       bte zerofill\
  -mmr_read        <arglist>  read MMR(s)\
  -mmr_write       <arglist>  write MMR(s)\
  -print_config [shubs|dimms] print configuration information\
  -assign_nasids              write each SH_SHUB_ID<NODE_ID> with unique nasid\
\
  parameters        arguments description\
  ----------------- --------- -------------------------------------------------\
  -v               <level>    select how verbose to be\
  -r               <int>      times to repeat selected option(s)\
  -sa              <int>      src byte address\
  -da              <int>      dst byte address\
  -na              <int>      notify byte address\
  -bytes           <int>      operation length specification (bytes)\
  -lines           <int>      operation length specification (lines)\
\
  configuration     arguments description\
  ----------------- --------- -------------------------------------------------\
  -l2              <L2 host>  Name or IP address of L2 system controller\
  -parts           <csvlist>  limit shub targets to these partitions\
  -racks           <csvlist>  limit shub targets to these racks\
  -slots           <csvlist>  limit shub targets to these slots\
  -boards          <csvlist>  limit shub targets to these boards\
  -chips           <csvlist>  limit shub targets to these chips\
  -nasids          <csvlist>  limit shub targets to these nasids\
\n";


$HELP_DETAIL_MMR_READ =
"Read MMR addresses specified with comma-separated list of MMR names.\
For example: shubmb -mmr_read SH_SCRATCH0,SH_SCRATCH1\
Alternately, a list of MMR addresses may be read from a file; the first option\
argument is interpretted as a filename if not a valid MMR name or address.\
Set verbosity level to > 3 to enable printing of individual fields.\n";
$HELP_DETAIL_MMR_WRITE =
"Write MMR addresses specified with the option mmr_name,value argument pairs.\
For example: shubmb -mmr_write SH_SCRATCH0,0xdeadbeef,SH_SCRATCH1,0xabc\
Alternately, a list of MMR mmr_name,value pairs may be read from a file; the\
first option argument is interpretted as a filename if not a valid MMR name.\n";
#123456789#123456789#123456789#123456789#123456789#123456789#123456789#123456789
$HELP_DETAIL_ASSIGN_NASIDS =
"Set this flag to cause script to initialize the selected targets SHUB_ID\
with unique NODE_ID values. Useful for headless testing.\n";
%HELP_DETAILS = (
  mmr_read        => $HELP_DETAIL_MMR_READ,
  mmr_write       => $HELP_DETAIL_MMR_WRITE,
  assign_nasids   => $HELP_DETAIL_ASSIGN_NASIDS,
);
