#==============================================================================
#
#  Unpublished copyright (c) 2004-2005, Silicon Graphics, Inc.
#  THIS IS UNPUBLISHED CONFIDENTIAL AND PROPRIETARY SOURCE CODE OF SGI.
#
#  The copyright notice above does  not evidence any actual or intended
#  publication  or  disclosure  of  this source  code,  which  includes
#  information that is confidential  and/or proprietary, and is a trade
#  secret, of  Silicon Graphics, Inc.   ANY REPRODUCTION, MODIFICATION,
#  DISTRIBUTION, PUBLIC  PERFORMANCE, OR  PUBLIC DISPLAY OF  OR THROUGH
#  USE  OF THIS  SOURCE CODE  WITHOUT  THE EXPRESS  WRITTEN CONSENT  OF
#  SILICON GRAPHICS, INC.  IS  STRICTLY PROHIBITED, AND IN VIOLATION OF
#  APPLICABLE  LAWS   AND  INTERNATIONAL  TREATIES.    THE  RECEIPT  OR
#  POSSESSION OF  THIS SOURCE CODE AND/OR RELATED  INFORMATION DOES NOT
#  CONVEY OR IMPLY ANY RIGHTS  TO REPRODUCE, DISCLOSE OR DISTRIBUTE ITS
#  CONTENTS,  OR TO  MANUFACTURE, USE,  OR  SELL ANYTHING  THAT IT  MAY
#  DESCRIBE, IN WHOLE OR IN PART.
#
#------------------------------------------------------------------------------
#
# @(#)$Id: shubmb_dimm.pm,v 1.4 2006/01/25 18:13:39 oster Exp $
#
#------------------------------------------------------------------------------
#
#  FILE: shubmb_dimm.pm
#
#  DESCRIPTION:  DIMM-related defines for shubmb utility.
#
#  REVISION HISTORY:
#
#  Rev.  Date      Author            Description
#  ----  --------  ----------------  ------------------------------------------
#  0.01  04/30/05  Darin Oster       Created.
#
#==============================================================================

$MAX_DIMM_GROUPS = 4;
$MAX_DIMMS       = $MAX_DIMM_GROUP * 4;

#------------------------------------------------------------------------------
# DIMM GROUP CONFIG MEMORY SIZES (DIMM_CFG_DIMM[x]_SIZE)
#------------------------------------------------------------------------------
$DIMM_SZ_256MB  = 0;
$DIMM_SZ_512MB  = 1;
$DIMM_SZ_1GB    = 2;
$DIMM_SZ_2GB    = 3;
$DIMM_SZ_4GB    = 4;
$DIMM_SZ_8GB    = 5;
$DIMM_SZ_16GB   = 6;
$DIMM_SZ_UNUSED = 7;

#------------------------------------------------------------------------------
# MEMORY TIMING PARAMETERS FOR SUPPORTED DIMM TYPES
#------------------------------------------------------------------------------
# sh_[x,y]_cfg
$MT_TA_DLYS     = 0;
$MT_DA_BB_CLR   = 1;
$MT_DC_BB_CLR   = 2;
$MT_WT_BB_CLR   = 3;
# sh_[x,y]_dqct_cfg
$MT_RD_SEL      = 4;
$MT_WT_SEL      = 5;
$MT_DTA_RD_SEL  = 6;
$MT_DTA_WT_SEL  = 7;
$MT_DIR_RD_SEL  = 8;
$MT_MDIR_RD_SEL = 9;
$MT_VALID       = 10;

# DIMM TYPES
$DIMM_100_CL2_0 = 0;
$DIMM_133_CL2_0 = 1;
$DIMM_133_CL2_5 = 2;
$DIMM_160_CL2_0 = 3;
$DIMM_160_CL2_5 = 4;
$DIMM_160_CL3_0 = 5;
$DIMM_200_CL2_0 = 6;
$DIMM_200_CL2_5 = 7;
$DIMM_200_CL3_0 = 8;

#    TA_DLYS  DABB DCBB WTBB RDSL WRSL DTAR DTAW DIRR MDIR  V     DIMM TYPE
@mem_timing_shub1 = (
  [0x00331210, 0x1, 0x2, 0x4, 0x8, 0x2, 0x6, 0x7, 0x8, 0x5, 1], # DIMM_100_CL2_0
  [0x00441210, 0x3, 0x4, 0x5, 0x7, 0x1, 0x3, 0x5, 0x7, 0x4, 1], # DIMM_133_CL2_0
  [0x00441210, 0x3, 0x4, 0x5, 0x8, 0x1, 0x4, 0x5, 0x8, 0x5, 1], # DIMM_133_CL2_5
  [0x00441210, 0x2, 0x3, 0x5, 0x6, 0x0, 0x4, 0x4, 0x6, 0x3, 0], # DIMM_160_CL2_0
  [0x00441210, 0x2, 0x3, 0x5, 0x6, 0x0, 0x2, 0x4, 0x6, 0x3, 1], # DIMM_160_CL2_5
  [0x00551210, 0x2, 0x3, 0x5, 0x7, 0x0, 0x3, 0x4, 0x7, 0x4, 1], # DIMM_160_CL3_0
  [0x00441210, 0x4, 0x5, 0x5, 0x6, 0x0, 0x2, 0x4, 0x6, 0x3, 1], # DIMM_200_CL2_0
  [0x00441210, 0x4, 0x5, 0x5, 0x6, 0x0, 0x2, 0x4, 0x6, 0x3, 1], # DIMM_200_CL2_5
  [0x00441210, 0x4, 0x5, 0x5, 0x6, 0x0, 0x2, 0x4, 0x6, 0x3, 1], # DIMM_200_CL3_0
);

#    TA_DLYS  DABB DCBB WTBB RDSL WRSL DTAR DTAW DIRR MDIR  V     DIMM TYPE
@mem_timing_shub2 = (
  [0x20332410, 0x3, 0x5, 0x3, 0x5, 0x1, 0x2, 0x4, 0x5, 0x2, 0], # DIMM_100_CL2_0
  [0x20332410, 0x3, 0x5, 0x3, 0x5, 0x1, 0x2, 0x4, 0x5, 0x2, 0], # DIMM_133_CL2_0
  [0x20332410, 0x3, 0x5, 0x3, 0x5, 0x1, 0x2, 0x4, 0x5, 0x2, 0], # DIMM_133_CL2_5
  [0x20332410, 0x3, 0x5, 0x3, 0x5, 0x1, 0x2, 0x4, 0x5, 0x2, 0], # DIMM_160_CL2_0
  [0x20332410, 0x3, 0x5, 0x3, 0x5, 0x1, 0x2, 0x4, 0x5, 0x2, 0], # DIMM_160_CL2_5
  [0x20332410, 0x3, 0x5, 0x3, 0x5, 0x1, 0x2, 0x4, 0x5, 0x2, 0], # DIMM_160_CL3_0
  [0x20332410, 0x3, 0x5, 0x3, 0x5, 0x1, 0x2, 0x4, 0x5, 0x2, 1], # DIMM_200_CL2_0
  [0x20332410, 0x3, 0x5, 0x3, 0x5, 0x1, 0x2, 0x4, 0x5, 0x2, 1], # DIMM_200_CL2_5
  [0x20332410, 0x3, 0x5, 0x3, 0x5, 0x1, 0x2, 0x4, 0x5, 0x2, 1], # DIMM_200_CL3_0
);

# CAT FREQ AND CAS LATENCY TO PRODUCE DIMM TYPE
#   $type = $dimm_type{$freq."_".$cas};
%dimm_type = (
  "100_2.0" => $DIMM_100_CL2_0,
  "133_2"   => $DIMM_133_CL2_0,
  "133_2.5" => $DIMM_133_CL2_5,
  "160_2"   => $DIMM_160_CL2_0,
  "160_2.5" => $DIMM_160_CL2_5,
  "160_3"   => $DIMM_160_CL3_0,
  "200_2"   => $DIMM_200_CL2_0,
  "200_2.5" => $DIMM_200_CL2_5,
  "200_3"   => $DIMM_200_CL3_0,
);


# DIMM SPD bytes needed to configure memory
$SPD_BYTE05_NUM_BANKS     =  5; # NUMBER OF PHYSICAL BANKS
$SPD_BYTE31_BANK_DENSITY  = 31; # BYTES IN EACH PHYSICAL BANK
$SPD_BYTE18_CAS_LATENCY   = 18; # MASK OF SUPPORTED CAS LATENCIES (CLs)
$SPD_BYTE09_CYCLE_TIME    =  9; # MIN CYCLE TIME @ CLX (HIGHEST CL)
$SPD_BYTE23_CYCLE_TIME_05 = 23; # MIN CYCLE TIME @ CLX-0.5
$SPD_BYTE25_CYCLE_TIME_10 = 25; # MIN CYCLE TIME @ CLX-1.0
$SPD_BYTE42_TRFC          = 42; # MIN HOLD TIME
$SPD_BYTE29_TRCD          = 29; # MIN RAS to CAS Delay

# DIMM SPD Cycle Time format: <7:4> int, <3:0> fraction
$SPD_SPEED10_0 = 0xA0;
$SPD_SPEED7_5  = 0x75;
$SPD_SPEED6_2  = 0x63;
$SPD_SPEED5_0  = 0x50;

# DIMM SPD CAS Latency bit assignments
$SPD_CAS_MASK3_0 = 0x10;
$SPD_CAS_MASK2_5 = 0x08;
$SPD_CAS_MASK2_0 = 0x04;

# RAS to CAS Delay values supported by Shub
$SPD_TRCD2 = 2;
$SPD_TRCD3 = 3;
$SPD_TRCD4 = 4;

# Arrays (membus_speeds and spd_speeds) are indexed by mdclk ratio.
@SPD_SPEEDS    = ($SPD_SPEED5_0, $SPD_SPEED6_2, $SPD_SPEED7_5, $SPD_SPEED10_0);
@MEMBUS_SPEEDS = ( 200,           160,           133,           100);

#------------------------------------------------------------------------------
# The following help define the DIMM BIST data format/sequence
# used when accessing data/address arrays associated with DIMM
# FILL operations.
#            +-----------------------+-----------------------+
#            |  LEFT_P     LEFT_S    |  RIGHT_P    RIGHT_S   |
# @pattern = (0xPPPPPPPP,0xSSSSSSSSSS,0xPPPPPPPP,0xSSSSSSSSSS,  # X_H
#             0xPPPPPPPP,0xSSSSSSSSSS,0xPPPPPPPP,0xSSSSSSSSSS,  # X_L
#             0xPPPPPPPP,0xSSSSSSSSSS,0xPPPPPPPP,0xSSSSSSSSSS,  # Y_H
#             0xPPPPPPPP,0xSSSSSSSSSS,0xPPPPPPPP,0xSSSSSSSSSS); # Y_L
$LPXH =  0;
$LSXH =  1;
$RPXH =  2;
$RSXH =  3;
$LPXL =  4;
$LSXL =  5;
$RPXL =  6;
$RSXL =  7;
$LPYH =  8;
$LSYH =  9;
$RPYH = 10;
$RSYH = 11;
$LPYL = 12;
$LSYL = 13;
$RPYL = 14;
$RSYL = 15;
