#==============================================================================
#
#  Unpublished copyright (c) 2004-2005, Silicon Graphics, Inc.
#  THIS IS UNPUBLISHED CONFIDENTIAL AND PROPRIETARY SOURCE CODE OF SGI.
#
#  The copyright notice above does  not evidence any actual or intended
#  publication  or  disclosure  of  this source  code,  which  includes
#  information that is confidential  and/or proprietary, and is a trade
#  secret, of  Silicon Graphics, Inc.   ANY REPRODUCTION, MODIFICATION,
#  DISTRIBUTION, PUBLIC  PERFORMANCE, OR  PUBLIC DISPLAY OF  OR THROUGH
#  USE  OF THIS  SOURCE CODE  WITHOUT  THE EXPRESS  WRITTEN CONSENT  OF
#  SILICON GRAPHICS, INC.  IS  STRICTLY PROHIBITED, AND IN VIOLATION OF
#  APPLICABLE  LAWS   AND  INTERNATIONAL  TREATIES.    THE  RECEIPT  OR
#  POSSESSION OF  THIS SOURCE CODE AND/OR RELATED  INFORMATION DOES NOT
#  CONVEY OR IMPLY ANY RIGHTS  TO REPRODUCE, DISCLOSE OR DISTRIBUTE ITS
#  CONTENTS,  OR TO  MANUFACTURE, USE,  OR  SELL ANYTHING  THAT IT  MAY
#  DESCRIBE, IN WHOLE OR IN PART.
#
#------------------------------------------------------------------------------
#
# @(#)$Id: shubmb_help.pm,v 1.9 2005/06/14 12:35:06 oster Exp $
#
#------------------------------------------------------------------------------
#
#  FILE: shubmb_help.pm
#
#  DESCRIPTION:  Documentation/Help for "shubmb" utility.
#
#  REVISION HISTORY:
#
#  Rev.  Date      Author            Description
#  ----  --------  ----------------  ------------------------------------------
#  0.01  04/30/05  Darin Oster       Created
#
#==============================================================================

$HELP_SUMMARY = "\
SCRIPT USAGE:\
\
  shubmem -l2 <l2_host> [arglist...]\
\
SCRIPT OPTIONS:\
\
  commands         arguments  description\
  ----------------- --------- -------------------------------------------------\
  -help            [option]   print this screen or detail for specified option\
  -mem_init                   configure shub memory controller and init. dimms\
  -mem_test                   test dimms with mmrbist write/read/cmp sequences\
  -shub_init                  configure shub memory controller\
  -mem_read        <arglist>  read memory location(s)\
  -mem_write       <arglist>  write memory location(s)\
  -mmr_read        <arglist>  read MMR(s)\
  -mmr_write       <arglist>  write MMR(s)\
  -dimm_init       [arglist]  use MMRBIST command to initialize dimms\
  -dimm_bist_read  [arglist]  use MMRBIST command to read/cmp dimm data\
  -fill_dir        [arglist]  use MMRBIST command to write directory location\
  -fill_data       [arglist]  use MMRBIST command to update dir for addresses\
  -fill_dir_access [arglist]  use MMRBIST command to update dir access only\
  -read_dir_pair   [arglist]  use MMRBIST command to read directory state\
  -read_dir_tag    [arglist]  use MMRBIST command to read directory cache\
  -print_config [shubs|dimms] print configuration information\
  -assign_nasids              write each SH_SHUB_ID<NODE_ID> with unique nasid\
\
  parameters        arguments description\
  ----------------- --------- -------------------------------------------------\
  -v               <level>    select how verbose to be\
  -r               <int>      times to repeat selected option(s)\
  -a              <csvlist>   comma-separated list of byte addresses\
  -bytes           <int>      operation length specification (bytes)\
  -lines           <int>      operation length specification (lines)\
  -dp              <arglist>  specify data pattern\
  -dm              <arglist>  specify data mask (shub2 only)\
  -pm              <arglist>  specify MMRBIST pio modes\
\
  configuration     arguments description\
  ----------------- --------- -------------------------------------------------\
  -l2              <L2 host>  Name or IP address of L2 system controller\
  -parts           <csvlist>  limit shub targets to these partitions\
  -racks           <csvlist>  limit shub targets to these racks\
  -slots           <csvlist>  limit shub targets to these slots\
  -boards          <csvlist>  limit shub targets to these boards\
  -chips           <csvlist>  limit shub targets to these chips\
  -nasids          <csvlist>  limit shub targets to these nasids\
  -dimm_groups     <bitmask>  dimm group select mask\
\
  expert options    arguments  description\
  ----------------- --------- -------------------------------------------------\
  -clear_dir                  set to clear directory cache during -shub_init\
  -stall_fsb                  set to stall FSB during operations\
  -reset_bist                 set to perform MMRBIST reset_state operation\
  -avoid_prom                 set to avoid overwriting prom area in memory\
  -flush_addr                 set to pre-flush target cachelines with PFCLs\
  -turbo                      set to monkey with credits to improve performance\
\n";


$HELP_DETAIL_MEM_INIT =
"This command option performs a complete memory initialization sequence. First,\
DIMM SPD information is gathered from the system controller and the memclk\
ratio is read from the SH_JTAG_CONFIG register. Next, each shubs memory\
controller is configured. Next, a sequence of MMRBIST DIMM_INIT commands are\
used to configure each DIMM bank. Finally, MMRBIST FILL_DATA commands are used\
to initialize the data in each DIMM bank. By default, a pattern of zeroes is\
written to produce valid ECC and UNOWNED directory states. However, the -dp\
option may be used to select an alternate data pattern.\n";
$HELP_DETAIL_MEM_TEST =
"The mem_test operation performs MMRBIST FILL_DATA and DIMM_BIST_READ command\
sequences to verify the integrity of dimm memory. By default, all available\
memory is tested with zeroes. Several other options are available to customize
the testing.\n";
$HELP_DETAIL_SHUB_INIT =
"The shub_init operation performs a partial memory initialization sequence.\
First, DIMM SPD information is gathered from the system controller and the\
memclk ratio is read from the SH_JTAG_CONFIG register. Finally, each shubs\
memory controller is configured appropriately. The DIMMs are not touched.\n";
$HELP_DETAIL_MEM_READ =
"Read memory addresses specified with the -a option\n";
$HELP_DETAIL_MEM_WRITE =
"Write memory addresses specified with the -a option\n";
$HELP_DETAIL_MMR_READ =
"Read MMR addresses specified with comma-separated list of MMR names.\
For example: shubmb -mmr_read SH_SCRATCH0,SH_SCRATCH1\
Alternately, a list of MMR addresses may be read from a file; the first option\
argument is interpretted as a filename if not a valid MMR name or address.\
Set verbosity level to > 3 to enable printing of individual fields.\n";
$HELP_DETAIL_MMR_WRITE =
"Write MMR addresses specified with the option mmr_name,value argument pairs.\
For example: shubmb -mmr_write SH_SCRATCH0,0xdeadbeef,SH_SCRATCH1,0xabc\
Alternately, a list of MMR mmr_name,value pairs may be read from a file; the\
first option argument is interpretted as a filename if not a valid MMR name.\n";
$HELP_DETAIL_DIMM_INIT =
"Initialize DIMM modes using MMRBIST DIMM_INIT command sequence\n";
$HELP_DETAIL_DIMM_BIST_READ =
"Perform MMRBIST read-compare sequence.\n";
$HELP_DETAIL_FILL_DIR =
"Write directory state for lines selected with -a <list> option. Either the\
-bytes or -lines option may be used to specify the operation length, but the\
hardware has a minimum granularity of 4 cachelines. This is a non-coherent\
operation (assumes lines are unowned). Four option arguments are required in\
this order: acc,pri,dirb,dira. For example:\
  \"shubmb -fill_dir 3,4,0x1234567,0x2345678 -a 0x1230000\"\n";
$HELP_DETAIL_FILL_DATA =
"Write data pattern to dimms.\n";
$HELP_DETAIL_FILL_DIR_ACCESS =
"Update directory access state for lines selected with -a <list> option. Either\
the -bytes or -lines option may be used to specify the operation length, but\
the hardware has a minimum granularity of 4 cachelines. This is a coherent\
operation (does not assume lines are unowned). One option argument is required.\
For example:\
  \"shubmb -fill_dir_access 3 -a 0x1230000\"\n";
$HELP_DETAIL_READ_DIR_PAIR =
"Read directory information for addresses specified with -a <list> option\n";
$HELP_DETAIL_READ_DIR_TAG =
"Read TAGs for shub directory cache.\n";
$HELP_DETAIL_ADDR =
"Specify the byte addresses for various operations. If the first element\
of the address list is \"node\", the addresses are interpreted as node\
addresses; ignoring the nasid bits and reading the locations on each selected \
shub node. By default, the addresses interpreted as global addresses.\n";
$HELP_DETAIL_DP =
#123456789#123456789#123456789#123456789#123456789#123456789#123456789#123456789
"The \"-dp <arglist>\" parameter option is available to specify a data pattern\
and data modes for MMRBIST FILL operations. By default, a zeroes data pattern\
is used with no modes (e.g. INV,ROT,RANDOM) set. A comma-separated argument\
list is required to contain at least one following arguments (in any order):\
  <value>  72-bit hexidecimal value to specify primary:secondary data\
  seed     use random data instead (use <value> as seed if provided)\
  hl|lh    set low   registers = ~high\
  rl|lr    set right registers = ~left\
  xy|yx    set Y-bus registers = ~X\
  fsb      swizzle data pattern for fsb; scrub ecc if <value> <= 64 bits\
  rot      enable mode to rotate data each cycle\
  inv      enable mode to invert data each cycle\
  random   enable mode to randomize data each cycle (shub2 only)\
For example:  shubmb -dp hl,0x112222333344445555,inv\n";
$HELP_DETAIL_DM =
"The \"-dm <arglist>\" parameter option is available to specify a data mask for\
shub2 based systems. The arglist needs to be a list of 8 hexidecimal values in\
the following order: XLP,XLS,XRP,XRS,YLP,YLS,YRP,YRS\
For example: shubmb -dm 0,0,0,0,0x100,0,0,0 will mask bit 8 for BUSYL_P\n";
$HELP_DETAIL_PM =
"The \"-pm <dec>[,<stride>,<stop>]\" parameter option is available to specify\
the PIO address modes for MMRBIST operations. By default, each modes is zero.\n";
$HELP_DETAIL_ASSIGN_NASIDS =
"Set this flag to cause script to initialize the selected targets SHUB_ID\
with unique NODE_ID values. Useful for headless testing.\n";
%HELP_DETAILS = (
  mem_init        => $HELP_DETAIL_MEM_INIT,
  mem_test        => $HELP_DETAIL_MEM_TEST,
  shub_init       => $HELP_DETAIL_SHUB_INIT,
  mem_read        => $HELP_DETAIL_MEM_READ,
  mem_write       => $HELP_DETAIL_MEM_WRITE,
  mmr_read        => $HELP_DETAIL_MMR_READ,
  mmr_write       => $HELP_DETAIL_MMR_WRITE,
  dimm_init       => $HELP_DETAIL_DIMM_INIT,
  dimm_bist_read  => $HELP_DETAIL_DIMM_BIST_READ,
  fill_dir        => $HELP_DETAIL_FILL_DIR,
  fill_data       => $HELP_DETAIL_FILL_DATA,
  fill_dir_access => $HELP_DETAIL_FILL_DIR_ACCESS,
  read_dir_pair   => $HELP_DETAIL_READ_DIR_PAIR,
  read_dir_tag    => $HELP_DETAIL_READ_DIR_TAG,
  assign_nasids   => $HELP_DETAIL_ASSIGN_NASIDS,
  addr            => $HELP_DETAIL_ADDR,
  dp              => $HELP_DETAIL_DP,
  dm              => $HELP_DETAIL_DM,
  pm              => $HELP_DETAIL_PM,
);
