#/**************************************************************************
# *                                                                        *
# *               Copyright (C) 2003-2004 Silicon Graphics, Inc.           *
# *                                                                        *
# *  These coded instructions, statements, and computer programs  contain  *
# *  unpublished  proprietary  information of Silicon Graphics, Inc., and  *
# *  are protected by Federal copyright law.  They  may  not be disclosed  *
# *  to  third  parties  or copied or duplicated in any form, in whole or  *
# *  in part, without the prior written consent of Silicon Graphics, Inc.  *
# *                                                                        *
# **************************************************************************/
#
# @(#)$Id: nl4rtr_01_mmrs.pm,v 1.1 2004/03/29 17:46:57 beighley Exp $
#
#---------------------------------------------------------------------------
#
#  MODIFICATION HISTORY:
#
#     WHEN      WHO             WHAT
#     --------  --------------  -----------------------------------------
#     02/18/04  Karen Beighley  Added header for initial submission.
#
#---------------------------------------------------------------------------

#
# The file contains PERL source that represents the MMRs from
#    an ASIC hardware register (hwreg) file.
#
# This file was generated using the "hwr2perl" utility.
# HWREG source file : r4_mmr.hwreg
# ASIC base name    : "nl4rtr_01"
# PERL file created : 15:08:57 Thursday October 23
#

$nl4rtr_01_defined = 1;


##########################################################################
#                                                                        #
#   R4_STATUS_REV_ID                                                     #
#                                                                        #
##########################################################################

%nl4rtr_01_00000_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  58,   6, 0xFC00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LOCAL_POK"                    => [   1,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "Local Power OK Pin Status" ],
   "LB_ERROR"                     => [   2,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "Local Block Error" ],
   "PORTH_ERROR"                  => [   3,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Port H Error" ],
   "PORTG_ERROR"                  => [   4,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "Port G Error" ],
   "PORTF_ERROR"                  => [   5,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "Port F Error" ],
   "PORTE_ERROR"                  => [   6,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "Port E Error" ],
   "PORTD_ERROR"                  => [   7,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Port D Error" ],
   "PORTC_ERROR"                  => [   8,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "Port C Error" ],
   "PORTB_ERROR"                  => [   9,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "Port B Error" ],
   "PORTA_ERROR"                  => [  10,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "Port A Error" ],
   "POSITION"                     => [  11,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "Position Bits" ],
   "INPORT"                       => [  12,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "Incoming Port of LB Packet" ],
   "PORTH_LINK_UP"                => [  13,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "PortH Link Up" ],
   "PORTG_LINK_UP"                => [  14,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "PortG Link Up" ],
   "PORTF_LINK_UP"                => [  15,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "PortF Link Up" ],
   "PORTE_LINK_UP"                => [  16,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "PortE Link Up" ],
   "PORTD_LINK_UP"                => [  17,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "PortD Link Up" ],
   "PORTC_LINK_UP"                => [  18,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PortC Link Up" ],
   "PORTB_LINK_UP"                => [  19,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PortB Link Up" ],
   "PORTA_LINK_UP"                => [  20,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PortA Link Up" ],
   "CHIP_REVISION"                => [  21,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Chip Revision" ],
   "PART_NUMBER"                  => [  22,  12,  16, 0x000000000FFFF000, 0x00, 0, 0x0000000000000000, "Part Number: 16'b0000001000111001" ],
   "MFG_ID"                       => [  23,   1,  11, 0x0000000000000FFE, 0x00, 0, 0x0000000000000000, "Manufacturer Identity: IBM - 11'b00000100100." ],
   "FORCE1"                       => [  24,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Force 1" ],
);

%nl4rtr_01_00000_def =
( NAME    => "R4_STATUS_REV_ID",
  ADDRESS => 0x0000000000000000,
  NOTE    => "The STATUS_REV_ID register. This register has the same address for note hub chips. It allows exploratory software to probe for c",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00000_flds
);


##########################################################################
#                                                                        #
#   R4_GLOBAL_PARM0                                                      #
#                                                                        #
##########################################################################

%nl4rtr_01_00001_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PORTH_DATELINE"               => [   1,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "PortH Dateline. Definition same as for PortA_Dateline field except pertains to port H." ],
   "PORTG_DATELINE"               => [   2,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "PortG Dateline. Definition same as for PortA_Dateline field except pertains to port G." ],
   "PORTF_DATELINE"               => [   3,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "PortF Dateline. Definition same as for PortA_Dateline field except pertains to port F." ],
   "PORTE_DATELINE"               => [   4,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "PortE Dateline. Definition same as for PortA_Dateline field except pertains to port E." ],
   "PORTD_DATELINE"               => [   5,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "PortD Dateline. Definition same as for PortA_Dateline field except pertains to port D." ],
   "PORTC_DATELINE"               => [   6,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "PortC Dateline. Definition same as for PortA_Dateline field except pertains to port C." ],
   "PORTB_DATELINE"               => [   7,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "PortB Dateline. Definition same as for PortA_Dateline field except pertains to port B." ],
   "PORTA_DATELINE"               => [   8,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "PortA Dateline. Definition same as for PortA_Dateline field except pertains to port A." ],
   "DEADLOCK_TO_VAL"              => [   9,  12,   4, 0x000000000000F000, 0x00, 1, 0x0000000000000000, "Deadlock Timeout Value" ],
   "TAIL_TO_VAL"                  => [  10,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "Tail Timeout Value" ],
   "RSVD1"                        => [  11,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "USE_OLDEST_AGE_ENABLE"        => [  12,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Use Oldest Age Enable" ],
   "INHERIT_AGE_ENABLE"           => [  13,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Inherit Age Enable" ],
   "PASS2_ARB_ENABLE"             => [  14,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Pass 2 Arbitration Enable" ],
   "PREFERRED_ENABLE"             => [  15,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Preferred Enable" ],
   "MOST_ELIGIBLE_ENABLE"         => [  16,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Most Eligible Enable" ],
   "BYPASS_ENABLE"                => [  17,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Bypass Enable" ],
);

%nl4rtr_01_00001_def =
( NAME    => "R4_GLOBAL_PARM0",
  ADDRESS => 0x0000000000000010,
  NOTE    => "The GLOBAL_PARM0 register. This register contains a set of note parameters that are shared by all 8 ports.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00001_flds
);


##########################################################################
#                                                                        #
#   R4_GLOBAL_PARM1                                                      #
#                                                                        #
##########################################################################

%nl4rtr_01_00002_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  21,  43, 0xFFFFFFFFFFE00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEADLOCK_TO_TICK"             => [   1,  16,   5, 0x00000000001F0000, 0x00, 1, 0x0000000000000000, "Deadlock Timeout Tick" ],
   "RSVD1"                        => [   2,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_TO_TICK"                 => [   3,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "Send Timeout Tick" ],
   "RSVD2"                        => [   4,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAIL_TO_TICK"                 => [   5,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Tail Timeout Tick" ],
);

%nl4rtr_01_00002_def =
( NAME    => "R4_GLOBAL_PARM1",
  ADDRESS => 0x0000000000000020,
  NOTE    => "The GLOBAL_PARM1 register. This register contains a set of note parameters that are shared by all 8 ports. The GLOBAL_PARM1 note",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00002_flds
);


##########################################################################
#                                                                        #
#   R4_ASIC_TO_L1_STATUS                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00003_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STATUS"                       => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Status" ],
);

%nl4rtr_01_00003_def =
( NAME    => "R4_ASIC_TO_L1_STATUS",
  ADDRESS => 0x0000000000000030,
  NOTE    => "ASIC_TO_L1_STATUS",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00003_flds
);


##########################################################################
#                                                                        #
#   R4_ASIC_TO_L1_DATA                                                   #
#                                                                        #
##########################################################################

%nl4rtr_01_00004_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data" ],
);

%nl4rtr_01_00004_def =
( NAME    => "R4_ASIC_TO_L1_DATA",
  ADDRESS => 0x0000000000000038,
  NOTE    => "ASIC_TO_L1_DATA",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00004_flds
);


##########################################################################
#                                                                        #
#   R4_L1_TO_ASIC_STATUS                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00005_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STATUS"                       => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Status" ],
);

%nl4rtr_01_00005_def =
( NAME    => "R4_L1_TO_ASIC_STATUS",
  ADDRESS => 0x0000000000000040,
  NOTE    => "L1_TO_ASIC_STATUS",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00005_flds
);


##########################################################################
#                                                                        #
#   R4_L1_TO_ASIC_DATA                                                   #
#                                                                        #
##########################################################################

%nl4rtr_01_00006_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data" ],
);

%nl4rtr_01_00006_def =
( NAME    => "R4_L1_TO_ASIC_DATA",
  ADDRESS => 0x0000000000000048,
  NOTE    => "L1_TO_ASIC_DATA",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00006_flds
);


##########################################################################
#                                                                        #
#   R4_LB_DATELINE                                                       #
#                                                                        #
##########################################################################

%nl4rtr_01_00007_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EN"                           => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable" ],
);

%nl4rtr_01_00007_def =
( NAME    => "R4_LB_DATELINE",
  ADDRESS => 0x0000000000004000,
  NOTE    => "The LB_DATELINE register. This MMR is used in selecting virtual note channels for all network messages generated by LB. The purp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00007_flds
);


##########################################################################
#                                                                        #
#   R4_LB_PREAGE                                                         #
#                                                                        #
##########################################################################

%nl4rtr_01_00008_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE"                          => [   1,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Age" ],
);

%nl4rtr_01_00008_def =
( NAME    => "R4_LB_PREAGE",
  ADDRESS => 0x0000000000004010,
  NOTE    => "The LB_PREAGE register. This MMR is used in selecting a pre-age note scaler for all network messages generated by LB.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00008_flds
);


##########################################################################
#                                                                        #
#   R4_PIO_TIME_OUT                                                      #
#                                                                        #
##########################################################################

%nl4rtr_01_00009_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VALUE"                        => [   1,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "Value" ],
);

%nl4rtr_01_00009_def =
( NAME    => "R4_PIO_TIME_OUT",
  ADDRESS => 0x0000000000004020,
  NOTE    => "PIO Channel Access Time Out",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00009_flds
);


##########################################################################
#                                                                        #
#   R4_MCAST_TRANS_TABLE_0                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00010_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,  32,  31, 0x7FFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TO"                           => [   2,  28,   4, 0x00000000F0000000, 0x00, 1, 0x0000000000000000, "Timeout" ],
   "RSVD1"                        => [   3,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SELF_INC_EN"                  => [   4,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "Self Include Enable" ],
   "VEC_UP_EN"                    => [   5,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Vector Up Enable" ],
   "VEC_LOW_EN"                   => [   6,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Vector Low Enable" ],
   "RSVD2"                        => [   7,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VEC_IDX"                      => [   8,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Vector Index" ],
   "RSVD3"                        => [   9,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ACTION"                       => [  10,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "Action" ],
   "CMD_OUT"                      => [  11,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Outgoing Command Code" ],
   "CMD_IN"                       => [  12,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Incoming Command Code" ],
);

%nl4rtr_01_00010_def =
( NAME    => "R4_MCAST_TRANS_TABLE_0",
  ADDRESS => 0x0000000000004e00,
  NOTE    => "MCAST_TRANS_TABLE represents a set of 16 registers which specify note multicast/gather message types and associated operating se",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00010_flds
);


##########################################################################
#                                                                        #
#   R4_MCAST_TRANS_TABLE_1                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00011_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,  32,  31, 0x7FFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TO"                           => [   2,  28,   4, 0x00000000F0000000, 0x00, 1, 0x0000000000000000, "Timeout" ],
   "RSVD1"                        => [   3,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SELF_INC_EN"                  => [   4,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "Self Include Enable" ],
   "VEC_UP_EN"                    => [   5,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Vector Up Enable" ],
   "VEC_LOW_EN"                   => [   6,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Vector Low Enable" ],
   "RSVD2"                        => [   7,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VEC_IDX"                      => [   8,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Vector Index" ],
   "RSVD3"                        => [   9,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ACTION"                       => [  10,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "Action" ],
   "CMD_OUT"                      => [  11,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Outgoing Command Code" ],
   "CMD_IN"                       => [  12,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Incoming Command Code" ],
);

%nl4rtr_01_00011_def =
( NAME    => "R4_MCAST_TRANS_TABLE_1",
  ADDRESS => 0x0000000000004e08,
  NOTE    => "Multicast Message Translation Table (MMTT): Entry 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00011_flds
);


##########################################################################
#                                                                        #
#   R4_MCAST_TRANS_TABLE_2                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00012_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,  32,  31, 0x7FFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TO"                           => [   2,  28,   4, 0x00000000F0000000, 0x00, 1, 0x0000000000000000, "Timeout" ],
   "RSVD1"                        => [   3,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SELF_INC_EN"                  => [   4,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "Self Include Enable" ],
   "VEC_UP_EN"                    => [   5,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Vector Up Enable" ],
   "VEC_LOW_EN"                   => [   6,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Vector Low Enable" ],
   "RSVD2"                        => [   7,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VEC_IDX"                      => [   8,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Vector Index" ],
   "RSVD3"                        => [   9,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ACTION"                       => [  10,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "Action" ],
   "CMD_OUT"                      => [  11,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Outgoing Command Code" ],
   "CMD_IN"                       => [  12,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Incoming Command Code" ],
);

%nl4rtr_01_00012_def =
( NAME    => "R4_MCAST_TRANS_TABLE_2",
  ADDRESS => 0x0000000000004e10,
  NOTE    => "Multicast Message Translation Table (MMTT): Entry 2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00012_flds
);


##########################################################################
#                                                                        #
#   R4_MCAST_TRANS_TABLE_3                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00013_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,  32,  31, 0x7FFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TO"                           => [   2,  28,   4, 0x00000000F0000000, 0x00, 1, 0x0000000000000000, "Timeout" ],
   "RSVD1"                        => [   3,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SELF_INC_EN"                  => [   4,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "Self Include Enable" ],
   "VEC_UP_EN"                    => [   5,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Vector Up Enable" ],
   "VEC_LOW_EN"                   => [   6,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Vector Low Enable" ],
   "RSVD2"                        => [   7,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VEC_IDX"                      => [   8,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Vector Index" ],
   "RSVD3"                        => [   9,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ACTION"                       => [  10,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "Action" ],
   "CMD_OUT"                      => [  11,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Outgoing Command Code" ],
   "CMD_IN"                       => [  12,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Incoming Command Code" ],
);

%nl4rtr_01_00013_def =
( NAME    => "R4_MCAST_TRANS_TABLE_3",
  ADDRESS => 0x0000000000004e18,
  NOTE    => "Multicast Message Translation Table (MMTT): Entry 3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00013_flds
);


##########################################################################
#                                                                        #
#   R4_MCAST_TRANS_TABLE_4                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00014_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,  32,  31, 0x7FFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TO"                           => [   2,  28,   4, 0x00000000F0000000, 0x00, 1, 0x0000000000000000, "Timeout" ],
   "RSVD1"                        => [   3,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SELF_INC_EN"                  => [   4,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "Self Include Enable" ],
   "VEC_UP_EN"                    => [   5,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Vector Up Enable" ],
   "VEC_LOW_EN"                   => [   6,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Vector Low Enable" ],
   "RSVD2"                        => [   7,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VEC_IDX"                      => [   8,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Vector Index" ],
   "RSVD3"                        => [   9,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ACTION"                       => [  10,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "Action" ],
   "CMD_OUT"                      => [  11,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Outgoing Command Code" ],
   "CMD_IN"                       => [  12,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Incoming Command Code" ],
);

%nl4rtr_01_00014_def =
( NAME    => "R4_MCAST_TRANS_TABLE_4",
  ADDRESS => 0x0000000000004e20,
  NOTE    => "Multicast Message Translation Table (MMTT): Entry 4",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00014_flds
);


##########################################################################
#                                                                        #
#   R4_MCAST_TRANS_TABLE_5                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00015_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,  32,  31, 0x7FFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TO"                           => [   2,  28,   4, 0x00000000F0000000, 0x00, 1, 0x0000000000000000, "Timeout" ],
   "RSVD1"                        => [   3,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SELF_INC_EN"                  => [   4,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "Self Include Enable" ],
   "VEC_UP_EN"                    => [   5,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Vector Up Enable" ],
   "VEC_LOW_EN"                   => [   6,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Vector Low Enable" ],
   "RSVD2"                        => [   7,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VEC_IDX"                      => [   8,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Vector Index" ],
   "RSVD3"                        => [   9,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ACTION"                       => [  10,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "Action" ],
   "CMD_OUT"                      => [  11,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Outgoing Command Code" ],
   "CMD_IN"                       => [  12,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Incoming Command Code" ],
);

%nl4rtr_01_00015_def =
( NAME    => "R4_MCAST_TRANS_TABLE_5",
  ADDRESS => 0x0000000000004e28,
  NOTE    => "Multicast Message Translation Table (MMTT): Entry 5",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00015_flds
);


##########################################################################
#                                                                        #
#   R4_MCAST_TRANS_TABLE_6                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00016_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,  32,  31, 0x7FFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TO"                           => [   2,  28,   4, 0x00000000F0000000, 0x00, 1, 0x0000000000000000, "Timeout" ],
   "RSVD1"                        => [   3,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SELF_INC_EN"                  => [   4,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "Self Include Enable" ],
   "VEC_UP_EN"                    => [   5,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Vector Up Enable" ],
   "VEC_LOW_EN"                   => [   6,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Vector Low Enable" ],
   "RSVD2"                        => [   7,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VEC_IDX"                      => [   8,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Vector Index" ],
   "RSVD3"                        => [   9,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ACTION"                       => [  10,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "Action" ],
   "CMD_OUT"                      => [  11,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Outgoing Command Code" ],
   "CMD_IN"                       => [  12,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Incoming Command Code" ],
);

%nl4rtr_01_00016_def =
( NAME    => "R4_MCAST_TRANS_TABLE_6",
  ADDRESS => 0x0000000000004e30,
  NOTE    => "Multicast Message Translation Table (MMTT): Entry 6",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00016_flds
);


##########################################################################
#                                                                        #
#   R4_MCAST_TRANS_TABLE_7                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00017_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,  32,  31, 0x7FFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TO"                           => [   2,  28,   4, 0x00000000F0000000, 0x00, 1, 0x0000000000000000, "Timeout" ],
   "RSVD1"                        => [   3,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SELF_INC_EN"                  => [   4,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "Self Include Enable" ],
   "VEC_UP_EN"                    => [   5,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Vector Up Enable" ],
   "VEC_LOW_EN"                   => [   6,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Vector Low Enable" ],
   "RSVD2"                        => [   7,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VEC_IDX"                      => [   8,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Vector Index" ],
   "RSVD3"                        => [   9,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ACTION"                       => [  10,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "Action" ],
   "CMD_OUT"                      => [  11,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Outgoing Command Code" ],
   "CMD_IN"                       => [  12,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Incoming Command Code" ],
);

%nl4rtr_01_00017_def =
( NAME    => "R4_MCAST_TRANS_TABLE_7",
  ADDRESS => 0x0000000000004e38,
  NOTE    => "Multicast Message Translation Table (MMTT): Entry 7",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00017_flds
);


##########################################################################
#                                                                        #
#   R4_MCAST_TRANS_TABLE_8                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00018_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,  32,  31, 0x7FFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TO"                           => [   2,  28,   4, 0x00000000F0000000, 0x00, 1, 0x0000000000000000, "Timeout" ],
   "RSVD1"                        => [   3,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SELF_INC_EN"                  => [   4,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "Self Include Enable" ],
   "VEC_UP_EN"                    => [   5,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Vector Up Enable" ],
   "VEC_LOW_EN"                   => [   6,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Vector Low Enable" ],
   "RSVD2"                        => [   7,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VEC_IDX"                      => [   8,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Vector Index" ],
   "RSVD3"                        => [   9,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ACTION"                       => [  10,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "Action" ],
   "CMD_OUT"                      => [  11,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Outgoing Command Code" ],
   "CMD_IN"                       => [  12,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Incoming Command Code" ],
);

%nl4rtr_01_00018_def =
( NAME    => "R4_MCAST_TRANS_TABLE_8",
  ADDRESS => 0x0000000000004e40,
  NOTE    => "Multicast Message Translation Table (MMTT): Entry 8",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00018_flds
);


##########################################################################
#                                                                        #
#   R4_MCAST_TRANS_TABLE_9                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00019_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,  32,  31, 0x7FFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TO"                           => [   2,  28,   4, 0x00000000F0000000, 0x00, 1, 0x0000000000000000, "Timeout" ],
   "RSVD1"                        => [   3,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SELF_INC_EN"                  => [   4,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "Self Include Enable" ],
   "VEC_UP_EN"                    => [   5,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Vector Up Enable" ],
   "VEC_LOW_EN"                   => [   6,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Vector Low Enable" ],
   "RSVD2"                        => [   7,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VEC_IDX"                      => [   8,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Vector Index" ],
   "RSVD3"                        => [   9,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ACTION"                       => [  10,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "Action" ],
   "CMD_OUT"                      => [  11,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Outgoing Command Code" ],
   "CMD_IN"                       => [  12,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Incoming Command Code" ],
);

%nl4rtr_01_00019_def =
( NAME    => "R4_MCAST_TRANS_TABLE_9",
  ADDRESS => 0x0000000000004e48,
  NOTE    => "Multicast Message Translation Table (MMTT): Entry 9",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00019_flds
);


##########################################################################
#                                                                        #
#   R4_MCAST_TRANS_TABLE_10                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00020_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,  32,  31, 0x7FFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TO"                           => [   2,  28,   4, 0x00000000F0000000, 0x00, 1, 0x0000000000000000, "Timeout" ],
   "RSVD1"                        => [   3,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SELF_INC_EN"                  => [   4,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "Self Include Enable" ],
   "VEC_UP_EN"                    => [   5,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Vector Up Enable" ],
   "VEC_LOW_EN"                   => [   6,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Vector Low Enable" ],
   "RSVD2"                        => [   7,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VEC_IDX"                      => [   8,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Vector Index" ],
   "RSVD3"                        => [   9,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ACTION"                       => [  10,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "Action" ],
   "CMD_OUT"                      => [  11,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Outgoing Command Code" ],
   "CMD_IN"                       => [  12,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Incoming Command Code" ],
);

%nl4rtr_01_00020_def =
( NAME    => "R4_MCAST_TRANS_TABLE_10",
  ADDRESS => 0x0000000000004e50,
  NOTE    => "Multicast Message Translation Table (MMTT): Entry 10",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00020_flds
);


##########################################################################
#                                                                        #
#   R4_MCAST_TRANS_TABLE_11                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00021_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,  32,  31, 0x7FFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TO"                           => [   2,  28,   4, 0x00000000F0000000, 0x00, 1, 0x0000000000000000, "Timeout" ],
   "RSVD1"                        => [   3,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SELF_INC_EN"                  => [   4,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "Self Include Enable" ],
   "VEC_UP_EN"                    => [   5,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Vector Up Enable" ],
   "VEC_LOW_EN"                   => [   6,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Vector Low Enable" ],
   "RSVD2"                        => [   7,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VEC_IDX"                      => [   8,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Vector Index" ],
   "RSVD3"                        => [   9,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ACTION"                       => [  10,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "Action" ],
   "CMD_OUT"                      => [  11,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Outgoing Command Code" ],
   "CMD_IN"                       => [  12,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Incoming Command Code" ],
);

%nl4rtr_01_00021_def =
( NAME    => "R4_MCAST_TRANS_TABLE_11",
  ADDRESS => 0x0000000000004e58,
  NOTE    => "Multicast Message Translation Table (MMTT): Entry 11",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00021_flds
);


##########################################################################
#                                                                        #
#   R4_MCAST_TRANS_TABLE_12                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00022_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,  32,  31, 0x7FFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TO"                           => [   2,  28,   4, 0x00000000F0000000, 0x00, 1, 0x0000000000000000, "Timeout" ],
   "RSVD1"                        => [   3,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SELF_INC_EN"                  => [   4,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "Self Include Enable" ],
   "VEC_UP_EN"                    => [   5,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Vector Up Enable" ],
   "VEC_LOW_EN"                   => [   6,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Vector Low Enable" ],
   "RSVD2"                        => [   7,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VEC_IDX"                      => [   8,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Vector Index" ],
   "RSVD3"                        => [   9,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ACTION"                       => [  10,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "Action" ],
   "CMD_OUT"                      => [  11,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Outgoing Command Code" ],
   "CMD_IN"                       => [  12,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Incoming Command Code" ],
);

%nl4rtr_01_00022_def =
( NAME    => "R4_MCAST_TRANS_TABLE_12",
  ADDRESS => 0x0000000000004e60,
  NOTE    => "Multicast Message Translation Table (MMTT): Entry 12",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00022_flds
);


##########################################################################
#                                                                        #
#   R4_MCAST_TRANS_TABLE_13                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00023_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,  32,  31, 0x7FFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TO"                           => [   2,  28,   4, 0x00000000F0000000, 0x00, 1, 0x0000000000000000, "Timeout" ],
   "RSVD1"                        => [   3,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SELF_INC_EN"                  => [   4,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "Self Include Enable" ],
   "VEC_UP_EN"                    => [   5,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Vector Up Enable" ],
   "VEC_LOW_EN"                   => [   6,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Vector Low Enable" ],
   "RSVD2"                        => [   7,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VEC_IDX"                      => [   8,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Vector Index" ],
   "RSVD3"                        => [   9,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ACTION"                       => [  10,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "Action" ],
   "CMD_OUT"                      => [  11,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Outgoing Command Code" ],
   "CMD_IN"                       => [  12,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Incoming Command Code" ],
);

%nl4rtr_01_00023_def =
( NAME    => "R4_MCAST_TRANS_TABLE_13",
  ADDRESS => 0x0000000000004e68,
  NOTE    => "Multicast Message Translation Table (MMTT): Entry 13",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00023_flds
);


##########################################################################
#                                                                        #
#   R4_MCAST_TRANS_TABLE_14                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00024_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,  32,  31, 0x7FFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TO"                           => [   2,  28,   4, 0x00000000F0000000, 0x00, 1, 0x0000000000000000, "Timeout" ],
   "RSVD1"                        => [   3,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SELF_INC_EN"                  => [   4,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "Self Include Enable" ],
   "VEC_UP_EN"                    => [   5,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Vector Up Enable" ],
   "VEC_LOW_EN"                   => [   6,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Vector Low Enable" ],
   "RSVD2"                        => [   7,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VEC_IDX"                      => [   8,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Vector Index" ],
   "RSVD3"                        => [   9,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ACTION"                       => [  10,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "Action" ],
   "CMD_OUT"                      => [  11,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Outgoing Command Code" ],
   "CMD_IN"                       => [  12,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Incoming Command Code" ],
);

%nl4rtr_01_00024_def =
( NAME    => "R4_MCAST_TRANS_TABLE_14",
  ADDRESS => 0x0000000000004e70,
  NOTE    => "Multicast Message Translation Table (MMTT): Entry 14",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00024_flds
);


##########################################################################
#                                                                        #
#   R4_MCAST_TRANS_TABLE_15                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00025_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,  32,  31, 0x7FFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TO"                           => [   2,  28,   4, 0x00000000F0000000, 0x00, 1, 0x0000000000000000, "Timeout" ],
   "RSVD1"                        => [   3,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SELF_INC_EN"                  => [   4,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "Self Include Enable" ],
   "VEC_UP_EN"                    => [   5,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Vector Up Enable" ],
   "VEC_LOW_EN"                   => [   6,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Vector Low Enable" ],
   "RSVD2"                        => [   7,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VEC_IDX"                      => [   8,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Vector Index" ],
   "RSVD3"                        => [   9,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ACTION"                       => [  10,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "Action" ],
   "CMD_OUT"                      => [  11,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Outgoing Command Code" ],
   "CMD_IN"                       => [  12,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Incoming Command Code" ],
);

%nl4rtr_01_00025_def =
( NAME    => "R4_MCAST_TRANS_TABLE_15",
  ADDRESS => 0x0000000000004e78,
  NOTE    => "Multicast Message Translation Table (MMTT): Entry 15",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00025_flds
);


##########################################################################
#                                                                        #
#   R4_MCAST_DEST_TABLE                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00026_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,  29,  34, 0x7FFFFFFFE0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR1"                         => [   2,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "Current Direction" ],
   "RSVD1"                        => [   3,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR0"                         => [   4,  16,   5, 0x00000000001F0000, 0x00, 0, 0x0000000000000000, "Direction" ],
   "RSVD2"                        => [   5,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   6,   0,  14, 0x0000000000003FFF, 0x00, 0, 0x0000000000000000, "Destination Node ID" ],
);

%nl4rtr_01_00026_def =
( NAME    => "R4_MCAST_DEST_TABLE",
  ADDRESS => 0x0000000000004e80,
  NOTE    => "MCAST_DEST_TABLE represents a set of 16 registers which specify note multicast message types and associated operating sequences ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00026_flds
);


##########################################################################
#                                                                        #
#   R4_MCAST_REP_GATHER_BUF                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00027_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FREE"                         => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Free Entry" ],
   "RSVD0"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERR"                          => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "Error" ],
   "FORCED_SUPPL"                 => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "Forced Supplement" ],
   "MCAST_DONE"                   => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Multicast Done" ],
   "ECHO"                         => [   5,  50,   9, 0x07FC000000000000, 0x00, 0, 0x0000000000000000, "Echo" ],
   "SOURCE_NODE"                  => [   6,  36,  14, 0x0003FFF000000000, 0x00, 0, 0x0000000000000000, "Source Node ID" ],
   "TIMER"                        => [   7,  32,   4, 0x0000000F00000000, 0x00, 0, 0x0000000000000000, "Timer" ],
   "RSVD1"                        => [   8,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR1"                         => [   9,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "This Dir" ],
   "RSVD2"                        => [  10,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR0"                         => [  11,  16,   5, 0x00000000001F0000, 0x00, 0, 0x0000000000000000, "Next Dir" ],
   "EXP_SUPPL"                    => [  12,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "Expected Supplement" ],
   "ACT_SUPPL"                    => [  13,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Expected Supplement" ],
);

%nl4rtr_01_00027_def =
( NAME    => "R4_MCAST_REP_GATHER_BUF",
  ADDRESS => 0x0000000000004f00,
  NOTE    => "MCAST_REP_GATHER_BUF represents a set of 16 registers which note maintains information on the gather operation that the router i",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00027_flds
);


##########################################################################
#                                                                        #
#   R4_MCAST_GATHER_CONFIG                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00028_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  13,  51, 0xFFFFFFFFFFFFE000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GATHER_TO_TICK"               => [   1,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "Gather Timeout Tick Select" ],
   "RSVD1"                        => [   2,   1,   7, 0x00000000000000FE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_PAIR"                     => [   3,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "The port used for gather's routing" ],
);

%nl4rtr_01_00028_def =
( NAME    => "R4_MCAST_GATHER_CONFIG",
  ADDRESS => 0x0000000000004f80,
  NOTE    => "The MCAST_GATHER_CONFIG register. This MMR which port's LUT is used note to look up the next dir of dest node of the final gathe",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00028_flds
);


##########################################################################
#                                                                        #
#   R4_MCAST_DEST_VEC_0                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00029_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXP_COUNT"                    => [   1,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Expected reply count" ],
   "BIT_MAP"                      => [   2,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "Destination Bit Map" ],
);

%nl4rtr_01_00029_def =
( NAME    => "R4_MCAST_DEST_VEC_0",
  ADDRESS => 0x0000000000004f90,
  NOTE    => "MCAST_DEST_VEC represents a set of 4 registers which provides the note destination vectors for a multicast message. The content ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00029_flds
);


##########################################################################
#                                                                        #
#   R4_MCAST_DEST_VEC_1                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00030_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXP_COUNT"                    => [   1,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Expected reply count" ],
   "BIT_MAP"                      => [   2,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "Destination Bit Map" ],
);

%nl4rtr_01_00030_def =
( NAME    => "R4_MCAST_DEST_VEC_1",
  ADDRESS => 0x0000000000004f98,
  NOTE    => "Multicast Message Translation Table (MMTT): Entry 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00030_flds
);


##########################################################################
#                                                                        #
#   R4_MCAST_DEST_VEC_2                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00031_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXP_COUNT"                    => [   1,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Expected reply count" ],
   "BIT_MAP"                      => [   2,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "Destination Bit Map" ],
);

%nl4rtr_01_00031_def =
( NAME    => "R4_MCAST_DEST_VEC_2",
  ADDRESS => 0x0000000000004fa0,
  NOTE    => "Multicast Message Translation Table (MMTT): Entry 2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00031_flds
);


##########################################################################
#                                                                        #
#   R4_MCAST_DEST_VEC_3                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00032_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXP_COUNT"                    => [   1,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Expected reply count" ],
   "BIT_MAP"                      => [   2,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "Destination Bit Map" ],
);

%nl4rtr_01_00032_def =
( NAME    => "R4_MCAST_DEST_VEC_3",
  ADDRESS => 0x0000000000004fa8,
  NOTE    => "Multicast Message Translation Table (MMTT): Entry 3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00032_flds
);


##########################################################################
#                                                                        #
#   R4_LB_LOCAL_TABLE                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00033_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR1"                         => [   2,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Current Direction" ],
);

%nl4rtr_01_00033_def =
( NAME    => "R4_LB_LOCAL_TABLE",
  ADDRESS => 0x0000000000005000,
  NOTE    => "LB_LOCAL_TABLE represents a set of 512 registers which constitute note the Local Look-up Table for the LB. The LB_LOCAL_TABLE gl",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00033_flds
);


##########################################################################
#                                                                        #
#   R4_LB_GLOBAL_TABLE                                                   #
#                                                                        #
##########################################################################

%nl4rtr_01_00034_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR1"                         => [   2,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Ciurrent Direction" ],
);

%nl4rtr_01_00034_def =
( NAME    => "R4_LB_GLOBAL_TABLE",
  ADDRESS => 0x0000000000006000,
  NOTE    => "LB_GLOBAL_TABLE represents a set of 256 registers which constitute note the Global Look-up Table for the LB. The LB_GLOBAL_TABLE",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00034_flds
);


##########################################################################
#                                                                        #
#   R4_RTC_SOURCE                                                        #
#                                                                        #
##########################################################################

%nl4rtr_01_00035_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  36,  28, 0xFFFFFFF000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PORTH_RTC_SELECT"             => [   1,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "PortH RTC Select" ],
   "PORTG_RTC_SELECT"             => [   2,  28,   4, 0x00000000F0000000, 0x00, 1, 0x0000000000000000, "PortG RTC Select" ],
   "PORTF_RTC_SELECT"             => [   3,  24,   4, 0x000000000F000000, 0x00, 1, 0x0000000000000000, "PortF RTC Select" ],
   "PORTE_RTC_SELECT"             => [   4,  20,   4, 0x0000000000F00000, 0x00, 1, 0x0000000000000000, "PortE RTC Select" ],
   "PORTD_RTC_SELECT"             => [   5,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "PortD RTC Select" ],
   "PORTC_RTC_SELECT"             => [   6,  12,   4, 0x000000000000F000, 0x00, 1, 0x0000000000000000, "PortC RTC Select" ],
   "PORTB_RTC_SELECT"             => [   7,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "PortB RTC Select" ],
   "PORTA_RTC_SELECT"             => [   8,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "PortA RTC Select" ],
   "LB_RTC_SELECT"                => [   9,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "LB RTC Select" ],
);

%nl4rtr_01_00035_def =
( NAME    => "R4_RTC_SOURCE",
  ADDRESS => 0x0000000001001900,
  NOTE    => "The RTC_SOURCE register. This register specifies the RTL (Real Time note Clock) sources selected by each of the 8 ports and LB.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00035_flds
);


##########################################################################
#                                                                        #
#   R4_RTC_INTRN_CNTRL                                                   #
#                                                                        #
##########################################################################

%nl4rtr_01_00036_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  26,  38, 0xFFFFFFFFFC000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,  16,  10, 0x0000000003FF0000, 0x00, 1, 0x0000000000000000, "Counter" ],
   "RSVD1"                        => [   2,  10,   6, 0x000000000000FC00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_COUNT"                    => [   3,   0,  10, 0x00000000000003FF, 0x00, 1, 0x0000000000000000, "Max Count" ],
);

%nl4rtr_01_00036_def =
( NAME    => "R4_RTC_INTRN_CNTRL",
  ADDRESS => 0x0000000001001908,
  NOTE    => "RTC Internal Control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00036_flds
);


##########################################################################
#                                                                        #
#   R4_THROTTLE_INTERVAL                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00037_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  30,  34, 0xFFFFFFFFC0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  30, 0x000000003FFFFFFF, 0x00, 1, 0x0000000000000000, "Throttle Interval" ],
);

%nl4rtr_01_00037_def =
( NAME    => "R4_THROTTLE_INTERVAL",
  ADDRESS => 0x0000000001001910,
  NOTE    => "Throttle Interval",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00037_flds
);


##########################################################################
#                                                                        #
#   R4_THROTTLE_TIME                                                     #
#                                                                        #
##########################################################################

%nl4rtr_01_00038_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  30,  34, 0xFFFFFFFFC0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  30, 0x000000003FFFFFFF, 0x00, 1, 0x0000000000000000, "Throttle Time" ],
);

%nl4rtr_01_00038_def =
( NAME    => "R4_THROTTLE_TIME",
  ADDRESS => 0x0000000001001918,
  NOTE    => "Throttle Time",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00038_flds
);


##########################################################################
#                                                                        #
#   R4_THROTTLE_STATUS                                                   #
#                                                                        #
##########################################################################

%nl4rtr_01_00039_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIME"                         => [   1,  32,  30, 0x3FFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Current throttle time count" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INTERVAL"                     => [   3,   0,  30, 0x000000003FFFFFFF, 0x00, 0, 0x0000000000000000, "Current throttle interval count" ],
);

%nl4rtr_01_00039_def =
( NAME    => "R4_THROTTLE_STATUS",
  ADDRESS => 0x0000000001001920,
  NOTE    => "The R4_THROTTLE_STATUS register contains the counter values of the note throttle interval counter and throttle time counter.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00039_flds
);


##########################################################################
#                                                                        #
#   R4_THROTTLE_SKIP                                                     #
#                                                                        #
##########################################################################

%nl4rtr_01_00040_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NEXT"                         => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Next" ],
);

%nl4rtr_01_00040_def =
( NAME    => "R4_THROTTLE_SKIP",
  ADDRESS => 0x0000000001001928,
  NOTE    => "Throttle Skip",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00040_flds
);


##########################################################################
#                                                                        #
#   R4_DEBUG_PORT_CONFIG                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00041_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EN"                           => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Enable" ],
);

%nl4rtr_01_00041_def =
( NAME    => "R4_DEBUG_PORT_CONFIG",
  ADDRESS => 0x0000000001001930,
  NOTE    => "The DEBUG_PORT_CONFIG register. This MMR is used in selecting the note data rate on the debug port.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00041_flds
);


##########################################################################
#                                                                        #
#   R4_VBIT_EMUL                                                         #
#                                                                        #
##########################################################################

%nl4rtr_01_00042_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "V_BIT_EMULATION"              => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "" ],
);

%nl4rtr_01_00042_def =
( NAME    => "R4_VBIT_EMUL",
  ADDRESS => 0x0000000001001938,
  NOTE    => "V Bit Emulation Enable",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00042_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_VC0_N_COUNT_INIT                                            #
#                                                                        #
##########################################################################

%nl4rtr_01_00043_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_LB"         => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port LB N Counter" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_H"          => [   3,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port H N Counter" ],
   "RSVD2"                        => [   4,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_G"          => [   5,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port G N Counter" ],
   "RSVD3"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_F"          => [   7,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port F N Counter" ],
   "RSVD4"                        => [   8,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_E"          => [   9,  16,   2, 0x0000000000030000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port E N Counter" ],
   "RSVD5"                        => [  10,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_D"          => [  11,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port D N Counter" ],
   "RSVD6"                        => [  12,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_C"          => [  13,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port C N Counter" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_B"          => [  15,   4,   2, 0x0000000000000030, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port B N Counter" ],
   "RSVD8"                        => [  16,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_A"          => [  17,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port A N Counter" ],
);

%nl4rtr_01_00043_def =
( NAME    => "R4_PORTA_VC0_N_COUNT_INIT",
  ADDRESS => 0x0000000002000010,
  NOTE    => "The PORTA_VC0_N_COUNT_INIT register provides the initialization note values for all input port virtual channel N counter values.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00043_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_VC1_N_COUNT_INIT                                            #
#                                                                        #
##########################################################################

%nl4rtr_01_00044_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_LB"         => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port LB N Counter" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_H"          => [   3,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port H N Counter" ],
   "RSVD2"                        => [   4,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_G"          => [   5,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port G N Counter" ],
   "RSVD3"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_F"          => [   7,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port F N Counter" ],
   "RSVD4"                        => [   8,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_E"          => [   9,  16,   2, 0x0000000000030000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port E N Counter" ],
   "RSVD5"                        => [  10,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_D"          => [  11,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port D N Counter" ],
   "RSVD6"                        => [  12,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_C"          => [  13,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port C N Counter" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_B"          => [  15,   4,   2, 0x0000000000000030, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port B N Counter" ],
   "RSVD8"                        => [  16,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_A"          => [  17,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port A N Counter" ],
);

%nl4rtr_01_00044_def =
( NAME    => "R4_PORTA_VC1_N_COUNT_INIT",
  ADDRESS => 0x0000000002000018,
  NOTE    => "The PORTA_VC1_N_COUNT_INIT register provides the initialization note values for all input port virtual channel N counter values.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00044_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_VC2_N_COUNT_INIT                                            #
#                                                                        #
##########################################################################

%nl4rtr_01_00045_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_LB"         => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port LB N Counter" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_H"          => [   3,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port H N Counter" ],
   "RSVD2"                        => [   4,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_G"          => [   5,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port G N Counter" ],
   "RSVD3"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_F"          => [   7,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port F N Counter" ],
   "RSVD4"                        => [   8,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_E"          => [   9,  16,   2, 0x0000000000030000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port E N Counter" ],
   "RSVD5"                        => [  10,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_D"          => [  11,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port D N Counter" ],
   "RSVD6"                        => [  12,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_C"          => [  13,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port C N Counter" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_B"          => [  15,   4,   2, 0x0000000000000030, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port B N Counter" ],
   "RSVD8"                        => [  16,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_A"          => [  17,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port A N Counter" ],
);

%nl4rtr_01_00045_def =
( NAME    => "R4_PORTA_VC2_N_COUNT_INIT",
  ADDRESS => 0x0000000002000020,
  NOTE    => "The PORTA_VC2_N_COUNT_INIT register provides the initialization note values for all input port virtual channel N counter values.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00045_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_VC3_N_COUNT_INIT                                            #
#                                                                        #
##########################################################################

%nl4rtr_01_00046_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_LB"         => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port LB N Counter" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_H"          => [   3,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port H N Counter" ],
   "RSVD2"                        => [   4,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_G"          => [   5,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port G N Counter" ],
   "RSVD3"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_F"          => [   7,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port F N Counter" ],
   "RSVD4"                        => [   8,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_E"          => [   9,  16,   2, 0x0000000000030000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port E N Counter" ],
   "RSVD5"                        => [  10,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_D"          => [  11,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port D N Counter" ],
   "RSVD6"                        => [  12,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_C"          => [  13,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port C N Counter" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_B"          => [  15,   4,   2, 0x0000000000000030, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port B N Counter" ],
   "RSVD8"                        => [  16,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_A"          => [  17,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port A N Counter" ],
);

%nl4rtr_01_00046_def =
( NAME    => "R4_PORTA_VC3_N_COUNT_INIT",
  ADDRESS => 0x0000000002000028,
  NOTE    => "The PORTA_VC3_N_COUNT_INIT register provides the initialization note values for all input port virtual channel N counter values.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00046_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_VC0_N_COUNT_INIT                                            #
#                                                                        #
##########################################################################

%nl4rtr_01_00047_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_LB"         => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port LB N Counter" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_H"          => [   3,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port H N Counter" ],
   "RSVD2"                        => [   4,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_G"          => [   5,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port G N Counter" ],
   "RSVD3"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_F"          => [   7,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port F N Counter" ],
   "RSVD4"                        => [   8,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_E"          => [   9,  16,   2, 0x0000000000030000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port E N Counter" ],
   "RSVD5"                        => [  10,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_D"          => [  11,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port D N Counter" ],
   "RSVD6"                        => [  12,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_C"          => [  13,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port C N Counter" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_B"          => [  15,   4,   2, 0x0000000000000030, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port B N Counter" ],
   "RSVD8"                        => [  16,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_A"          => [  17,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port A N Counter" ],
);

%nl4rtr_01_00047_def =
( NAME    => "R4_PORTB_VC0_N_COUNT_INIT",
  ADDRESS => 0x0000000002000030,
  NOTE    => "The PORTB_VC0_N_COUNT_INIT register provides the initialization note values for all input port virtual channel N counter values.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00047_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_VC1_N_COUNT_INIT                                            #
#                                                                        #
##########################################################################

%nl4rtr_01_00048_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_LB"         => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port LB N Counter" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_H"          => [   3,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port H N Counter" ],
   "RSVD2"                        => [   4,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_G"          => [   5,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port G N Counter" ],
   "RSVD3"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_F"          => [   7,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port F N Counter" ],
   "RSVD4"                        => [   8,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_E"          => [   9,  16,   2, 0x0000000000030000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port E N Counter" ],
   "RSVD5"                        => [  10,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_D"          => [  11,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port D N Counter" ],
   "RSVD6"                        => [  12,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_C"          => [  13,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port C N Counter" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_B"          => [  15,   4,   2, 0x0000000000000030, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port B N Counter" ],
   "RSVD8"                        => [  16,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_A"          => [  17,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port A N Counter" ],
);

%nl4rtr_01_00048_def =
( NAME    => "R4_PORTB_VC1_N_COUNT_INIT",
  ADDRESS => 0x0000000002000038,
  NOTE    => "The PORTB_VC1_N_COUNT_INIT register provides the initialization note values for all input port virtual channel N counter values.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00048_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_VC2_N_COUNT_INIT                                            #
#                                                                        #
##########################################################################

%nl4rtr_01_00049_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_LB"         => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port LB N Counter" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_H"          => [   3,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port H N Counter" ],
   "RSVD2"                        => [   4,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_G"          => [   5,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port G N Counter" ],
   "RSVD3"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_F"          => [   7,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port F N Counter" ],
   "RSVD4"                        => [   8,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_E"          => [   9,  16,   2, 0x0000000000030000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port E N Counter" ],
   "RSVD5"                        => [  10,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_D"          => [  11,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port D N Counter" ],
   "RSVD6"                        => [  12,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_C"          => [  13,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port C N Counter" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_B"          => [  15,   4,   2, 0x0000000000000030, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port B N Counter" ],
   "RSVD8"                        => [  16,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_A"          => [  17,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port A N Counter" ],
);

%nl4rtr_01_00049_def =
( NAME    => "R4_PORTB_VC2_N_COUNT_INIT",
  ADDRESS => 0x0000000002000040,
  NOTE    => "The PORTB_VC2_N_COUNT_INIT register provides the initialization note values for all input port virtual channel N counter values.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00049_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_VC3_N_COUNT_INIT                                            #
#                                                                        #
##########################################################################

%nl4rtr_01_00050_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_LB"         => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port LB N Counter" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_H"          => [   3,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port H N Counter" ],
   "RSVD2"                        => [   4,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_G"          => [   5,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port G N Counter" ],
   "RSVD3"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_F"          => [   7,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port F N Counter" ],
   "RSVD4"                        => [   8,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_E"          => [   9,  16,   2, 0x0000000000030000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port E N Counter" ],
   "RSVD5"                        => [  10,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_D"          => [  11,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port D N Counter" ],
   "RSVD6"                        => [  12,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_C"          => [  13,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port C N Counter" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_B"          => [  15,   4,   2, 0x0000000000000030, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port B N Counter" ],
   "RSVD8"                        => [  16,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_A"          => [  17,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port A N Counter" ],
);

%nl4rtr_01_00050_def =
( NAME    => "R4_PORTB_VC3_N_COUNT_INIT",
  ADDRESS => 0x0000000002000048,
  NOTE    => "The PORTB_VC3_N_COUNT_INIT register provides the initialization note values for all input port virtual channel N counter values.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00050_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_VC0_N_COUNT_INIT                                            #
#                                                                        #
##########################################################################

%nl4rtr_01_00051_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_LB"         => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port LB N Counter" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_H"          => [   3,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port H N Counter" ],
   "RSVD2"                        => [   4,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_G"          => [   5,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port G N Counter" ],
   "RSVD3"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_F"          => [   7,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port F N Counter" ],
   "RSVD4"                        => [   8,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_E"          => [   9,  16,   2, 0x0000000000030000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port E N Counter" ],
   "RSVD5"                        => [  10,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_D"          => [  11,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port D N Counter" ],
   "RSVD6"                        => [  12,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_C"          => [  13,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port C N Counter" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_B"          => [  15,   4,   2, 0x0000000000000030, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port B N Counter" ],
   "RSVD8"                        => [  16,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_A"          => [  17,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port A N Counter" ],
);

%nl4rtr_01_00051_def =
( NAME    => "R4_PORTC_VC0_N_COUNT_INIT",
  ADDRESS => 0x0000000002000050,
  NOTE    => "The PORTC_VC0_N_COUNT_INIT register provides the initialization note values for all input port virtual channel N counter values.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00051_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_VC1_N_COUNT_INIT                                            #
#                                                                        #
##########################################################################

%nl4rtr_01_00052_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_LB"         => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port LB N Counter" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_H"          => [   3,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port H N Counter" ],
   "RSVD2"                        => [   4,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_G"          => [   5,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port G N Counter" ],
   "RSVD3"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_F"          => [   7,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port F N Counter" ],
   "RSVD4"                        => [   8,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_E"          => [   9,  16,   2, 0x0000000000030000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port E N Counter" ],
   "RSVD5"                        => [  10,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_D"          => [  11,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port D N Counter" ],
   "RSVD6"                        => [  12,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_C"          => [  13,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port C N Counter" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_B"          => [  15,   4,   2, 0x0000000000000030, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port B N Counter" ],
   "RSVD8"                        => [  16,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_A"          => [  17,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port A N Counter" ],
);

%nl4rtr_01_00052_def =
( NAME    => "R4_PORTC_VC1_N_COUNT_INIT",
  ADDRESS => 0x0000000002000058,
  NOTE    => "The PORTC_VC1_N_COUNT_INIT register provides the initialization note values for all input port virtual channel N counter values.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00052_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_VC2_N_COUNT_INIT                                            #
#                                                                        #
##########################################################################

%nl4rtr_01_00053_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_LB"         => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port LB N Counter" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_H"          => [   3,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port H N Counter" ],
   "RSVD2"                        => [   4,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_G"          => [   5,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port G N Counter" ],
   "RSVD3"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_F"          => [   7,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port F N Counter" ],
   "RSVD4"                        => [   8,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_E"          => [   9,  16,   2, 0x0000000000030000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port E N Counter" ],
   "RSVD5"                        => [  10,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_D"          => [  11,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port D N Counter" ],
   "RSVD6"                        => [  12,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_C"          => [  13,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port C N Counter" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_B"          => [  15,   4,   2, 0x0000000000000030, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port B N Counter" ],
   "RSVD8"                        => [  16,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_A"          => [  17,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port A N Counter" ],
);

%nl4rtr_01_00053_def =
( NAME    => "R4_PORTC_VC2_N_COUNT_INIT",
  ADDRESS => 0x0000000002000060,
  NOTE    => "The PORTC_VC2_N_COUNT_INIT register provides the initialization note values for all input port virtual channel N counter values.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00053_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_VC3_N_COUNT_INIT                                            #
#                                                                        #
##########################################################################

%nl4rtr_01_00054_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_LB"         => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port LB N Counter" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_H"          => [   3,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port H N Counter" ],
   "RSVD2"                        => [   4,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_G"          => [   5,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port G N Counter" ],
   "RSVD3"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_F"          => [   7,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port F N Counter" ],
   "RSVD4"                        => [   8,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_E"          => [   9,  16,   2, 0x0000000000030000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port E N Counter" ],
   "RSVD5"                        => [  10,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_D"          => [  11,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port D N Counter" ],
   "RSVD6"                        => [  12,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_C"          => [  13,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port C N Counter" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_B"          => [  15,   4,   2, 0x0000000000000030, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port B N Counter" ],
   "RSVD8"                        => [  16,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_A"          => [  17,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port A N Counter" ],
);

%nl4rtr_01_00054_def =
( NAME    => "R4_PORTC_VC3_N_COUNT_INIT",
  ADDRESS => 0x0000000002000068,
  NOTE    => "The PORTC_VC3_N_COUNT_INIT register provides the initialization note values for all input port virtual channel N counter values.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00054_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_VC0_N_COUNT_INIT                                            #
#                                                                        #
##########################################################################

%nl4rtr_01_00055_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_LB"         => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port LB N Counter" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_H"          => [   3,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port H N Counter" ],
   "RSVD2"                        => [   4,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_G"          => [   5,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port G N Counter" ],
   "RSVD3"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_F"          => [   7,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port F N Counter" ],
   "RSVD4"                        => [   8,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_E"          => [   9,  16,   2, 0x0000000000030000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port E N Counter" ],
   "RSVD5"                        => [  10,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_D"          => [  11,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port D N Counter" ],
   "RSVD6"                        => [  12,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_C"          => [  13,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port C N Counter" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_B"          => [  15,   4,   2, 0x0000000000000030, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port B N Counter" ],
   "RSVD8"                        => [  16,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_A"          => [  17,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port A N Counter" ],
);

%nl4rtr_01_00055_def =
( NAME    => "R4_PORTD_VC0_N_COUNT_INIT",
  ADDRESS => 0x0000000002000070,
  NOTE    => "The PORTD_VC0_N_COUNT_INIT register provides the initialization note values for all input port virtual channel N counter values.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00055_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_VC1_N_COUNT_INIT                                            #
#                                                                        #
##########################################################################

%nl4rtr_01_00056_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_LB"         => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port LB N Counter" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_H"          => [   3,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port H N Counter" ],
   "RSVD2"                        => [   4,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_G"          => [   5,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port G N Counter" ],
   "RSVD3"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_F"          => [   7,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port F N Counter" ],
   "RSVD4"                        => [   8,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_E"          => [   9,  16,   2, 0x0000000000030000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port E N Counter" ],
   "RSVD5"                        => [  10,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_D"          => [  11,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port D N Counter" ],
   "RSVD6"                        => [  12,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_C"          => [  13,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port C N Counter" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_B"          => [  15,   4,   2, 0x0000000000000030, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port B N Counter" ],
   "RSVD8"                        => [  16,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_A"          => [  17,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port A N Counter" ],
);

%nl4rtr_01_00056_def =
( NAME    => "R4_PORTD_VC1_N_COUNT_INIT",
  ADDRESS => 0x0000000002000078,
  NOTE    => "The PORTD_VC1_N_COUNT_INIT register provides the initialization note values for all input port virtual channel N counter values.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00056_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_VC2_N_COUNT_INIT                                            #
#                                                                        #
##########################################################################

%nl4rtr_01_00057_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_LB"         => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port LB N Counter" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_H"          => [   3,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port H N Counter" ],
   "RSVD2"                        => [   4,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_G"          => [   5,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port G N Counter" ],
   "RSVD3"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_F"          => [   7,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port F N Counter" ],
   "RSVD4"                        => [   8,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_E"          => [   9,  16,   2, 0x0000000000030000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port E N Counter" ],
   "RSVD5"                        => [  10,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_D"          => [  11,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port D N Counter" ],
   "RSVD6"                        => [  12,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_C"          => [  13,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port C N Counter" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_B"          => [  15,   4,   2, 0x0000000000000030, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port B N Counter" ],
   "RSVD8"                        => [  16,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_A"          => [  17,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port A N Counter" ],
);

%nl4rtr_01_00057_def =
( NAME    => "R4_PORTD_VC2_N_COUNT_INIT",
  ADDRESS => 0x0000000002000080,
  NOTE    => "The PORTD_VC2_N_COUNT_INIT register provides the initialization note values for all input port virtual channel N counter values.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00057_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_VC3_N_COUNT_INIT                                            #
#                                                                        #
##########################################################################

%nl4rtr_01_00058_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_LB"         => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port LB N Counter" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_H"          => [   3,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port H N Counter" ],
   "RSVD2"                        => [   4,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_G"          => [   5,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port G N Counter" ],
   "RSVD3"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_F"          => [   7,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port F N Counter" ],
   "RSVD4"                        => [   8,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_E"          => [   9,  16,   2, 0x0000000000030000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port E N Counter" ],
   "RSVD5"                        => [  10,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_D"          => [  11,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port D N Counter" ],
   "RSVD6"                        => [  12,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_C"          => [  13,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port C N Counter" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_B"          => [  15,   4,   2, 0x0000000000000030, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port B N Counter" ],
   "RSVD8"                        => [  16,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_A"          => [  17,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port A N Counter" ],
);

%nl4rtr_01_00058_def =
( NAME    => "R4_PORTD_VC3_N_COUNT_INIT",
  ADDRESS => 0x0000000002000088,
  NOTE    => "The PORTD_VC3_N_COUNT_INIT register provides the initialization note values for all input port virtual channel N counter values.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00058_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_VC0_N_COUNT_INIT                                            #
#                                                                        #
##########################################################################

%nl4rtr_01_00059_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_LB"         => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port LB N Counter" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_H"          => [   3,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port H N Counter" ],
   "RSVD2"                        => [   4,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_G"          => [   5,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port G N Counter" ],
   "RSVD3"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_F"          => [   7,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port F N Counter" ],
   "RSVD4"                        => [   8,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_E"          => [   9,  16,   2, 0x0000000000030000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port E N Counter" ],
   "RSVD5"                        => [  10,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_D"          => [  11,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port D N Counter" ],
   "RSVD6"                        => [  12,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_C"          => [  13,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port C N Counter" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_B"          => [  15,   4,   2, 0x0000000000000030, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port B N Counter" ],
   "RSVD8"                        => [  16,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_A"          => [  17,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port A N Counter" ],
);

%nl4rtr_01_00059_def =
( NAME    => "R4_PORTE_VC0_N_COUNT_INIT",
  ADDRESS => 0x0000000002000090,
  NOTE    => "The PORTE_VC0_N_COUNT_INIT register provides the initialization note values for all input port virtual channel N counter values.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00059_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_VC1_N_COUNT_INIT                                            #
#                                                                        #
##########################################################################

%nl4rtr_01_00060_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_LB"         => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port LB N Counter" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_H"          => [   3,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port H N Counter" ],
   "RSVD2"                        => [   4,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_G"          => [   5,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port G N Counter" ],
   "RSVD3"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_F"          => [   7,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port F N Counter" ],
   "RSVD4"                        => [   8,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_E"          => [   9,  16,   2, 0x0000000000030000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port E N Counter" ],
   "RSVD5"                        => [  10,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_D"          => [  11,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port D N Counter" ],
   "RSVD6"                        => [  12,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_C"          => [  13,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port C N Counter" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_B"          => [  15,   4,   2, 0x0000000000000030, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port B N Counter" ],
   "RSVD8"                        => [  16,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_A"          => [  17,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port A N Counter" ],
);

%nl4rtr_01_00060_def =
( NAME    => "R4_PORTE_VC1_N_COUNT_INIT",
  ADDRESS => 0x0000000002000098,
  NOTE    => "The PORTE_VC1_N_COUNT_INIT register provides the initialization note values for all input port virtual channel N counter values.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00060_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_VC2_N_COUNT_INIT                                            #
#                                                                        #
##########################################################################

%nl4rtr_01_00061_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_LB"         => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port LB N Counter" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_H"          => [   3,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port H N Counter" ],
   "RSVD2"                        => [   4,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_G"          => [   5,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port G N Counter" ],
   "RSVD3"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_F"          => [   7,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port F N Counter" ],
   "RSVD4"                        => [   8,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_E"          => [   9,  16,   2, 0x0000000000030000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port E N Counter" ],
   "RSVD5"                        => [  10,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_D"          => [  11,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port D N Counter" ],
   "RSVD6"                        => [  12,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_C"          => [  13,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port C N Counter" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_B"          => [  15,   4,   2, 0x0000000000000030, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port B N Counter" ],
   "RSVD8"                        => [  16,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_A"          => [  17,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port A N Counter" ],
);

%nl4rtr_01_00061_def =
( NAME    => "R4_PORTE_VC2_N_COUNT_INIT",
  ADDRESS => 0x00000000020000a0,
  NOTE    => "The PORTE_VC2_N_COUNT_INIT register provides the initialization note values for all input port virtual channel N counter values.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00061_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_VC3_N_COUNT_INIT                                            #
#                                                                        #
##########################################################################

%nl4rtr_01_00062_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_LB"         => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port LB N Counter" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_H"          => [   3,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port H N Counter" ],
   "RSVD2"                        => [   4,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_G"          => [   5,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port G N Counter" ],
   "RSVD3"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_F"          => [   7,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port F N Counter" ],
   "RSVD4"                        => [   8,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_E"          => [   9,  16,   2, 0x0000000000030000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port E N Counter" ],
   "RSVD5"                        => [  10,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_D"          => [  11,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port D N Counter" ],
   "RSVD6"                        => [  12,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_C"          => [  13,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port C N Counter" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_B"          => [  15,   4,   2, 0x0000000000000030, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port B N Counter" ],
   "RSVD8"                        => [  16,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_A"          => [  17,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port A N Counter" ],
);

%nl4rtr_01_00062_def =
( NAME    => "R4_PORTE_VC3_N_COUNT_INIT",
  ADDRESS => 0x00000000020000a8,
  NOTE    => "The PORTE_VC3_N_COUNT_INIT register provides the initialization note values for all input port virtual channel N counter values.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00062_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_VC0_N_COUNT_INIT                                            #
#                                                                        #
##########################################################################

%nl4rtr_01_00063_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_LB"         => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port LB N Counter" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_H"          => [   3,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port H N Counter" ],
   "RSVD2"                        => [   4,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_G"          => [   5,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port G N Counter" ],
   "RSVD3"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_F"          => [   7,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port F N Counter" ],
   "RSVD4"                        => [   8,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_E"          => [   9,  16,   2, 0x0000000000030000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port E N Counter" ],
   "RSVD5"                        => [  10,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_D"          => [  11,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port D N Counter" ],
   "RSVD6"                        => [  12,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_C"          => [  13,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port C N Counter" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_B"          => [  15,   4,   2, 0x0000000000000030, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port B N Counter" ],
   "RSVD8"                        => [  16,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_A"          => [  17,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port A N Counter" ],
);

%nl4rtr_01_00063_def =
( NAME    => "R4_PORTF_VC0_N_COUNT_INIT",
  ADDRESS => 0x00000000020000b0,
  NOTE    => "The PORTF_VC0_N_COUNT_INIT register provides the initialization note values for all input port virtual channel N counter values.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00063_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_VC1_N_COUNT_INIT                                            #
#                                                                        #
##########################################################################

%nl4rtr_01_00064_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_LB"         => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port LB N Counter" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_H"          => [   3,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port H N Counter" ],
   "RSVD2"                        => [   4,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_G"          => [   5,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port G N Counter" ],
   "RSVD3"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_F"          => [   7,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port F N Counter" ],
   "RSVD4"                        => [   8,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_E"          => [   9,  16,   2, 0x0000000000030000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port E N Counter" ],
   "RSVD5"                        => [  10,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_D"          => [  11,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port D N Counter" ],
   "RSVD6"                        => [  12,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_C"          => [  13,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port C N Counter" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_B"          => [  15,   4,   2, 0x0000000000000030, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port B N Counter" ],
   "RSVD8"                        => [  16,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_A"          => [  17,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port A N Counter" ],
);

%nl4rtr_01_00064_def =
( NAME    => "R4_PORTF_VC1_N_COUNT_INIT",
  ADDRESS => 0x00000000020000b8,
  NOTE    => "The PORTF_VC1_N_COUNT_INIT register provides the initialization note values for all input port virtual channel N counter values.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00064_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_VC2_N_COUNT_INIT                                            #
#                                                                        #
##########################################################################

%nl4rtr_01_00065_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_LB"         => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port LB N Counter" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_H"          => [   3,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port H N Counter" ],
   "RSVD2"                        => [   4,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_G"          => [   5,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port G N Counter" ],
   "RSVD3"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_F"          => [   7,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port F N Counter" ],
   "RSVD4"                        => [   8,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_E"          => [   9,  16,   2, 0x0000000000030000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port E N Counter" ],
   "RSVD5"                        => [  10,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_D"          => [  11,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port D N Counter" ],
   "RSVD6"                        => [  12,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_C"          => [  13,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port C N Counter" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_B"          => [  15,   4,   2, 0x0000000000000030, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port B N Counter" ],
   "RSVD8"                        => [  16,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_A"          => [  17,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port A N Counter" ],
);

%nl4rtr_01_00065_def =
( NAME    => "R4_PORTF_VC2_N_COUNT_INIT",
  ADDRESS => 0x00000000020000c0,
  NOTE    => "The PORTF_VC2_N_COUNT_INIT register provides the initialization note values for all input port virtual channel N counter values.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00065_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_VC3_N_COUNT_INIT                                            #
#                                                                        #
##########################################################################

%nl4rtr_01_00066_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_LB"         => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port LB N Counter" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_H"          => [   3,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port H N Counter" ],
   "RSVD2"                        => [   4,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_G"          => [   5,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port G N Counter" ],
   "RSVD3"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_F"          => [   7,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port F N Counter" ],
   "RSVD4"                        => [   8,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_E"          => [   9,  16,   2, 0x0000000000030000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port E N Counter" ],
   "RSVD5"                        => [  10,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_D"          => [  11,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port D N Counter" ],
   "RSVD6"                        => [  12,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_C"          => [  13,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port C N Counter" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_B"          => [  15,   4,   2, 0x0000000000000030, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port B N Counter" ],
   "RSVD8"                        => [  16,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_A"          => [  17,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port A N Counter" ],
);

%nl4rtr_01_00066_def =
( NAME    => "R4_PORTF_VC3_N_COUNT_INIT",
  ADDRESS => 0x00000000020000c8,
  NOTE    => "The PORTF_VC3_N_COUNT_INIT register provides the initialization note values for all input port virtual channel N counter values.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00066_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_VC0_N_COUNT_INIT                                            #
#                                                                        #
##########################################################################

%nl4rtr_01_00067_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_LB"         => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port LB N Counter" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_H"          => [   3,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port H N Counter" ],
   "RSVD2"                        => [   4,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_G"          => [   5,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port G N Counter" ],
   "RSVD3"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_F"          => [   7,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port F N Counter" ],
   "RSVD4"                        => [   8,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_E"          => [   9,  16,   2, 0x0000000000030000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port E N Counter" ],
   "RSVD5"                        => [  10,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_D"          => [  11,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port D N Counter" ],
   "RSVD6"                        => [  12,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_C"          => [  13,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port C N Counter" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_B"          => [  15,   4,   2, 0x0000000000000030, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port B N Counter" ],
   "RSVD8"                        => [  16,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_A"          => [  17,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port A N Counter" ],
);

%nl4rtr_01_00067_def =
( NAME    => "R4_PORTG_VC0_N_COUNT_INIT",
  ADDRESS => 0x00000000020000d0,
  NOTE    => "The PORTG_VC0_N_COUNT_INIT register provides the initialization note values for all input port virtual channel N counter values.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00067_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_VC1_N_COUNT_INIT                                            #
#                                                                        #
##########################################################################

%nl4rtr_01_00068_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_LB"         => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port LB N Counter" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_H"          => [   3,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port H N Counter" ],
   "RSVD2"                        => [   4,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_G"          => [   5,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port G N Counter" ],
   "RSVD3"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_F"          => [   7,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port F N Counter" ],
   "RSVD4"                        => [   8,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_E"          => [   9,  16,   2, 0x0000000000030000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port E N Counter" ],
   "RSVD5"                        => [  10,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_D"          => [  11,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port D N Counter" ],
   "RSVD6"                        => [  12,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_C"          => [  13,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port C N Counter" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_B"          => [  15,   4,   2, 0x0000000000000030, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port B N Counter" ],
   "RSVD8"                        => [  16,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_A"          => [  17,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port A N Counter" ],
);

%nl4rtr_01_00068_def =
( NAME    => "R4_PORTG_VC1_N_COUNT_INIT",
  ADDRESS => 0x00000000020000d8,
  NOTE    => "The PORTG_VC1_N_COUNT_INIT register provides the initialization note values for all input port virtual channel N counter values.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00068_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_VC2_N_COUNT_INIT                                            #
#                                                                        #
##########################################################################

%nl4rtr_01_00069_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_LB"         => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port LB N Counter" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_H"          => [   3,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port H N Counter" ],
   "RSVD2"                        => [   4,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_G"          => [   5,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port G N Counter" ],
   "RSVD3"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_F"          => [   7,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port F N Counter" ],
   "RSVD4"                        => [   8,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_E"          => [   9,  16,   2, 0x0000000000030000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port E N Counter" ],
   "RSVD5"                        => [  10,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_D"          => [  11,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port D N Counter" ],
   "RSVD6"                        => [  12,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_C"          => [  13,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port C N Counter" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_B"          => [  15,   4,   2, 0x0000000000000030, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port B N Counter" ],
   "RSVD8"                        => [  16,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_A"          => [  17,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port A N Counter" ],
);

%nl4rtr_01_00069_def =
( NAME    => "R4_PORTG_VC2_N_COUNT_INIT",
  ADDRESS => 0x00000000020000e0,
  NOTE    => "The PORTG_VC2_N_COUNT_INIT register provides the initialization note values for all input port virtual channel N counter values.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00069_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_VC3_N_COUNT_INIT                                            #
#                                                                        #
##########################################################################

%nl4rtr_01_00070_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_LB"         => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port LB N Counter" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_H"          => [   3,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port H N Counter" ],
   "RSVD2"                        => [   4,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_G"          => [   5,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port G N Counter" ],
   "RSVD3"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_F"          => [   7,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port F N Counter" ],
   "RSVD4"                        => [   8,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_E"          => [   9,  16,   2, 0x0000000000030000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port E N Counter" ],
   "RSVD5"                        => [  10,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_D"          => [  11,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port D N Counter" ],
   "RSVD6"                        => [  12,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_C"          => [  13,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port C N Counter" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_B"          => [  15,   4,   2, 0x0000000000000030, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port B N Counter" ],
   "RSVD8"                        => [  16,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_A"          => [  17,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port A N Counter" ],
);

%nl4rtr_01_00070_def =
( NAME    => "R4_PORTG_VC3_N_COUNT_INIT",
  ADDRESS => 0x00000000020000e8,
  NOTE    => "The PORTG_VC3_N_COUNT_INIT register provides the initialization note values for all input port virtual channel N counter values.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00070_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_VC0_N_COUNT_INIT                                            #
#                                                                        #
##########################################################################

%nl4rtr_01_00071_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_LB"         => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port LB N Counter" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_H"          => [   3,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port H N Counter" ],
   "RSVD2"                        => [   4,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_G"          => [   5,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port G N Counter" ],
   "RSVD3"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_F"          => [   7,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port F N Counter" ],
   "RSVD4"                        => [   8,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_E"          => [   9,  16,   2, 0x0000000000030000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port E N Counter" ],
   "RSVD5"                        => [  10,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_D"          => [  11,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port D N Counter" ],
   "RSVD6"                        => [  12,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_C"          => [  13,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port C N Counter" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_B"          => [  15,   4,   2, 0x0000000000000030, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port B N Counter" ],
   "RSVD8"                        => [  16,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_A"          => [  17,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port A N Counter" ],
);

%nl4rtr_01_00071_def =
( NAME    => "R4_PORTH_VC0_N_COUNT_INIT",
  ADDRESS => 0x00000000020000f0,
  NOTE    => "The PORTH_VC0_N_COUNT_INIT register provides the initialization note values for all input port virtual channel N counter values.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00071_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_VC1_N_COUNT_INIT                                            #
#                                                                        #
##########################################################################

%nl4rtr_01_00072_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_LB"         => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port LB N Counter" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_H"          => [   3,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port H N Counter" ],
   "RSVD2"                        => [   4,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_G"          => [   5,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port G N Counter" ],
   "RSVD3"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_F"          => [   7,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port F N Counter" ],
   "RSVD4"                        => [   8,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_E"          => [   9,  16,   2, 0x0000000000030000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port E N Counter" ],
   "RSVD5"                        => [  10,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_D"          => [  11,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port D N Counter" ],
   "RSVD6"                        => [  12,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_C"          => [  13,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port C N Counter" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_B"          => [  15,   4,   2, 0x0000000000000030, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port B N Counter" ],
   "RSVD8"                        => [  16,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_A"          => [  17,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port A N Counter" ],
);

%nl4rtr_01_00072_def =
( NAME    => "R4_PORTH_VC1_N_COUNT_INIT",
  ADDRESS => 0x00000000020000f8,
  NOTE    => "The PORTH_VC1_N_COUNT_INIT register provides the initialization note values for all input port virtual channel N counter values.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00072_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_VC2_N_COUNT_INIT                                            #
#                                                                        #
##########################################################################

%nl4rtr_01_00073_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_LB"         => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port LB N Counter" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_H"          => [   3,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port H N Counter" ],
   "RSVD2"                        => [   4,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_G"          => [   5,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port G N Counter" ],
   "RSVD3"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_F"          => [   7,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port F N Counter" ],
   "RSVD4"                        => [   8,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_E"          => [   9,  16,   2, 0x0000000000030000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port E N Counter" ],
   "RSVD5"                        => [  10,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_D"          => [  11,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port D N Counter" ],
   "RSVD6"                        => [  12,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_C"          => [  13,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port C N Counter" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_B"          => [  15,   4,   2, 0x0000000000000030, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port B N Counter" ],
   "RSVD8"                        => [  16,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_A"          => [  17,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port A N Counter" ],
);

%nl4rtr_01_00073_def =
( NAME    => "R4_PORTH_VC2_N_COUNT_INIT",
  ADDRESS => 0x0000000002000100,
  NOTE    => "The PORTH_VC2_N_COUNT_INIT register provides the initialization note values for all input port virtual channel N counter values.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00073_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_VC3_N_COUNT_INIT                                            #
#                                                                        #
##########################################################################

%nl4rtr_01_00074_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_LB"         => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port LB N Counter" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_H"          => [   3,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port H N Counter" ],
   "RSVD2"                        => [   4,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_G"          => [   5,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port G N Counter" ],
   "RSVD3"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_F"          => [   7,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port F N Counter" ],
   "RSVD4"                        => [   8,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_E"          => [   9,  16,   2, 0x0000000000030000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port E N Counter" ],
   "RSVD5"                        => [  10,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_D"          => [  11,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port D N Counter" ],
   "RSVD6"                        => [  12,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_C"          => [  13,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port C N Counter" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_B"          => [  15,   4,   2, 0x0000000000000030, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port B N Counter" ],
   "RSVD8"                        => [  16,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_A"          => [  17,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port A N Counter" ],
);

%nl4rtr_01_00074_def =
( NAME    => "R4_PORTH_VC3_N_COUNT_INIT",
  ADDRESS => 0x0000000002000108,
  NOTE    => "The PORTH_VC3_N_COUNT_INIT register provides the initialization note values for all input port virtual channel N counter values.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00074_flds
);


##########################################################################
#                                                                        #
#   R4_PORTLB_ARBL_VC0_N_COUNT_INIT                                      #
#                                                                        #
##########################################################################

%nl4rtr_01_00075_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  30,  34, 0xFFFFFFFFC0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_H"          => [   1,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port H N Counter" ],
   "RSVD1"                        => [   2,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_G"          => [   3,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port G N Counter" ],
   "RSVD2"                        => [   4,   6,  18, 0x0000000000FFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_B"          => [   5,   4,   2, 0x0000000000000030, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port B N Counter" ],
   "RSVD3"                        => [   6,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_A"          => [   7,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port A N Counter" ],
);

%nl4rtr_01_00075_def =
( NAME    => "R4_PORTLB_ARBL_VC0_N_COUNT_INIT",
  ADDRESS => 0x0000000002000120,
  NOTE    => "The PORTLB_ARBL_VC0_N_COUNT_INIT register provides the note initialization values for input port virtual channel N counter note ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00075_flds
);


##########################################################################
#                                                                        #
#   R4_PORTLB_ARBL_VC1_N_COUNT_INIT                                      #
#                                                                        #
##########################################################################

%nl4rtr_01_00076_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  30,  34, 0xFFFFFFFFC0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_H"          => [   1,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port H N Counter" ],
   "RSVD1"                        => [   2,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_G"          => [   3,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port G N Counter" ],
   "RSVD2"                        => [   4,   6,  18, 0x0000000000FFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_B"          => [   5,   4,   2, 0x0000000000000030, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port B N Counter" ],
   "RSVD3"                        => [   6,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_A"          => [   7,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port A N Counter" ],
);

%nl4rtr_01_00076_def =
( NAME    => "R4_PORTLB_ARBL_VC1_N_COUNT_INIT",
  ADDRESS => 0x0000000002000128,
  NOTE    => "The PORTLB_ARBL_VC1_N_COUNT_INIT register provides the note initialization values for input port virtual channel N counter note ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00076_flds
);


##########################################################################
#                                                                        #
#   R4_PORTLB_ARBL_VC2_N_COUNT_INIT                                      #
#                                                                        #
##########################################################################

%nl4rtr_01_00077_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  30,  34, 0xFFFFFFFFC0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_H"          => [   1,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port H N Counter" ],
   "RSVD1"                        => [   2,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_G"          => [   3,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port G N Counter" ],
   "RSVD2"                        => [   4,   6,  18, 0x0000000000FFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_B"          => [   5,   4,   2, 0x0000000000000030, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port B N Counter" ],
   "RSVD3"                        => [   6,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_A"          => [   7,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port A N Counter" ],
);

%nl4rtr_01_00077_def =
( NAME    => "R4_PORTLB_ARBL_VC2_N_COUNT_INIT",
  ADDRESS => 0x0000000002000130,
  NOTE    => "The PORTLB_ARBL_VC2_N_COUNT_INIT register provides the note initialization values for input port virtual channel N counter note ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00077_flds
);


##########################################################################
#                                                                        #
#   R4_PORTLB_ARBL_VC3_N_COUNT_INIT                                      #
#                                                                        #
##########################################################################

%nl4rtr_01_00078_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  30,  34, 0xFFFFFFFFC0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_H"          => [   1,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port H N Counter" ],
   "RSVD1"                        => [   2,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_G"          => [   3,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port G N Counter" ],
   "RSVD2"                        => [   4,   6,  18, 0x0000000000FFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_B"          => [   5,   4,   2, 0x0000000000000030, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port B N Counter" ],
   "RSVD3"                        => [   6,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_A"          => [   7,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port A N Counter" ],
);

%nl4rtr_01_00078_def =
( NAME    => "R4_PORTLB_ARBL_VC3_N_COUNT_INIT",
  ADDRESS => 0x0000000002000138,
  NOTE    => "The PORTLB_ARBL_VC3_N_COUNT_INIT register provides the note initialization values for input port virtual channel N counter note ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00078_flds
);


##########################################################################
#                                                                        #
#   R4_PORTLB_ARBR_VC0_N_COUNT_INIT                                      #
#                                                                        #
##########################################################################

%nl4rtr_01_00079_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_F"          => [   1,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port F N Counter" ],
   "RSVD1"                        => [   2,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_E"          => [   3,  16,   2, 0x0000000000030000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port E N Counter" ],
   "RSVD2"                        => [   4,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_D"          => [   5,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port D N Counter" ],
   "RSVD3"                        => [   6,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_C"          => [   7,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port C N Counter" ],
);

%nl4rtr_01_00079_def =
( NAME    => "R4_PORTLB_ARBR_VC0_N_COUNT_INIT",
  ADDRESS => 0x0000000002000140,
  NOTE    => "The PORTLB_ARBR_VC0_N_COUNT_INIT register provides the note initialization values for input port virtual channel N counter note ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00079_flds
);


##########################################################################
#                                                                        #
#   R4_PORTLB_ARBR_VC1_N_COUNT_INIT                                      #
#                                                                        #
##########################################################################

%nl4rtr_01_00080_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_F"          => [   1,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port F N Counter" ],
   "RSVD1"                        => [   2,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_E"          => [   3,  16,   2, 0x0000000000030000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port E N Counter" ],
   "RSVD2"                        => [   4,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_D"          => [   5,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port D N Counter" ],
   "RSVD3"                        => [   6,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_C"          => [   7,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port C N Counter" ],
);

%nl4rtr_01_00080_def =
( NAME    => "R4_PORTLB_ARBR_VC1_N_COUNT_INIT",
  ADDRESS => 0x0000000002000148,
  NOTE    => "The PORTLB_ARBR_VC1_N_COUNT_INIT register provides the note initialization values for input port virtual channel N counter note ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00080_flds
);


##########################################################################
#                                                                        #
#   R4_PORTLB_ARBR_VC2_N_COUNT_INIT                                      #
#                                                                        #
##########################################################################

%nl4rtr_01_00081_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_F"          => [   1,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port F N Counter" ],
   "RSVD1"                        => [   2,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_E"          => [   3,  16,   2, 0x0000000000030000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port E N Counter" ],
   "RSVD2"                        => [   4,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_D"          => [   5,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port D N Counter" ],
   "RSVD3"                        => [   6,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_C"          => [   7,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port C N Counter" ],
);

%nl4rtr_01_00081_def =
( NAME    => "R4_PORTLB_ARBR_VC2_N_COUNT_INIT",
  ADDRESS => 0x0000000002000150,
  NOTE    => "The PORTLB_ARBR_VC2_N_COUNT_INIT register provides the note initialization values for input port virtual channel N counter note ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00081_flds
);


##########################################################################
#                                                                        #
#   R4_PORTLB_ARBR_VC3_N_COUNT_INIT                                      #
#                                                                        #
##########################################################################

%nl4rtr_01_00082_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_F"          => [   1,  20,   2, 0x0000000000300000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port F N Counter" ],
   "RSVD1"                        => [   2,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_E"          => [   3,  16,   2, 0x0000000000030000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port E N Counter" ],
   "RSVD2"                        => [   4,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_D"          => [   5,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port D N Counter" ],
   "RSVD3"                        => [   6,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "N_INIT_INPUT_PORT_C"          => [   7,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Initialization value for Input Port C N Counter" ],
);

%nl4rtr_01_00082_def =
( NAME    => "R4_PORTLB_ARBR_VC3_N_COUNT_INIT",
  ADDRESS => 0x0000000002000158,
  NOTE    => "The PORTLB_ARBR_VC3_N_COUNT_INIT register provides the note initialization values for input port virtual channel N counter note ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00082_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_D_COUNT_INIT                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00083_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "D_INIT_VC3"                   => [   1,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 3" ],
   "D_INIT_VC2"                   => [   2,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 2" ],
   "D_INIT_VC1"                   => [   3,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 1" ],
   "D_INIT_VC0"                   => [   4,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 0" ],
);

%nl4rtr_01_00083_def =
( NAME    => "R4_PORTA_D_COUNT_INIT",
  ADDRESS => 0x0000000002000400,
  NOTE    => "The PORTA_D_COUNT_INIT register provides the initialization values note for all virtual channel D counter values for send port A",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00083_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_D_COUNT_INIT                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00084_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "D_INIT_VC3"                   => [   1,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 3" ],
   "D_INIT_VC2"                   => [   2,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 2" ],
   "D_INIT_VC1"                   => [   3,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 1" ],
   "D_INIT_VC0"                   => [   4,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 0" ],
);

%nl4rtr_01_00084_def =
( NAME    => "R4_PORTB_D_COUNT_INIT",
  ADDRESS => 0x0000000002000408,
  NOTE    => "The PORTB_D_COUNT_INIT register provides the initialization values note for all virtual channel D counter values for send port B",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00084_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_D_COUNT_INIT                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00085_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "D_INIT_VC3"                   => [   1,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 3" ],
   "D_INIT_VC2"                   => [   2,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 2" ],
   "D_INIT_VC1"                   => [   3,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 1" ],
   "D_INIT_VC0"                   => [   4,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 0" ],
);

%nl4rtr_01_00085_def =
( NAME    => "R4_PORTG_D_COUNT_INIT",
  ADDRESS => 0x0000000002000410,
  NOTE    => "The PORTG_D_COUNT_INIT register provides the initialization values note for all virtual channel D counter values for send port G",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00085_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_D_COUNT_INIT                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00086_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "D_INIT_VC3"                   => [   1,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 3" ],
   "D_INIT_VC2"                   => [   2,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 2" ],
   "D_INIT_VC1"                   => [   3,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 1" ],
   "D_INIT_VC0"                   => [   4,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 0" ],
);

%nl4rtr_01_00086_def =
( NAME    => "R4_PORTH_D_COUNT_INIT",
  ADDRESS => 0x0000000002000418,
  NOTE    => "The PORTH_D_COUNT_INIT register provides the initialization values note for all virtual channel D counter values for send port H",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00086_flds
);


##########################################################################
#                                                                        #
#   R4_PORTLB_ARBL_D_COUNT_INIT                                          #
#                                                                        #
##########################################################################

%nl4rtr_01_00087_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "D_INIT_VC3"                   => [   1,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 3" ],
   "D_INIT_VC2"                   => [   2,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 2" ],
   "D_INIT_VC1"                   => [   3,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 1" ],
   "D_INIT_VC0"                   => [   4,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 0" ],
);

%nl4rtr_01_00087_def =
( NAME    => "R4_PORTLB_ARBL_D_COUNT_INIT",
  ADDRESS => 0x0000000002000420,
  NOTE    => "The PORTLB_ARBL_D_COUNT_INIT register provides the initialization note values for all virtual channel D counter values for send ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00087_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_D_COUNT_INIT                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00088_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "D_INIT_VC3"                   => [   1,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 3" ],
   "D_INIT_VC2"                   => [   2,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 2" ],
   "D_INIT_VC1"                   => [   3,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 1" ],
   "D_INIT_VC0"                   => [   4,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 0" ],
);

%nl4rtr_01_00088_def =
( NAME    => "R4_PORTC_D_COUNT_INIT",
  ADDRESS => 0x0000000002000428,
  NOTE    => "The PORTC_D_COUNT_INIT register provides the initialization values note for all virtual channel D counter values for send port C",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00088_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_D_COUNT_INIT                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00089_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "D_INIT_VC3"                   => [   1,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 3" ],
   "D_INIT_VC2"                   => [   2,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 2" ],
   "D_INIT_VC1"                   => [   3,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 1" ],
   "D_INIT_VC0"                   => [   4,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 0" ],
);

%nl4rtr_01_00089_def =
( NAME    => "R4_PORTD_D_COUNT_INIT",
  ADDRESS => 0x0000000002000430,
  NOTE    => "The PORTD_D_COUNT_INIT register provides the initialization values note for all virtual channel D counter values for send port D",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00089_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_D_COUNT_INIT                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00090_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "D_INIT_VC3"                   => [   1,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 3" ],
   "D_INIT_VC2"                   => [   2,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 2" ],
   "D_INIT_VC1"                   => [   3,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 1" ],
   "D_INIT_VC0"                   => [   4,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 0" ],
);

%nl4rtr_01_00090_def =
( NAME    => "R4_PORTE_D_COUNT_INIT",
  ADDRESS => 0x0000000002000438,
  NOTE    => "The PORTE_D_COUNT_INIT register provides the initialization values note for all virtual channel D counter values for send port E",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00090_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_D_COUNT_INIT                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00091_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "D_INIT_VC3"                   => [   1,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 3" ],
   "D_INIT_VC2"                   => [   2,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 2" ],
   "D_INIT_VC1"                   => [   3,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 1" ],
   "D_INIT_VC0"                   => [   4,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 0" ],
);

%nl4rtr_01_00091_def =
( NAME    => "R4_PORTF_D_COUNT_INIT",
  ADDRESS => 0x0000000002000440,
  NOTE    => "The PORTF_D_COUNT_INIT register provides the initialization values note for all virtual channel D counter values for send port F",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00091_flds
);


##########################################################################
#                                                                        #
#   R4_PORTLB_ARBR_D_COUNT_INIT                                          #
#                                                                        #
##########################################################################

%nl4rtr_01_00092_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "D_INIT_VC3"                   => [   1,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 3" ],
   "D_INIT_VC2"                   => [   2,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 2" ],
   "D_INIT_VC1"                   => [   3,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 1" ],
   "D_INIT_VC0"                   => [   4,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "D counter initialization value, virtual channel 0" ],
);

%nl4rtr_01_00092_def =
( NAME    => "R4_PORTLB_ARBR_D_COUNT_INIT",
  ADDRESS => 0x0000000002000448,
  NOTE    => "The PORTLB_ARBR_D_COUNT_INIT register provides the initialization note values for all virtual channel D counter values for send ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00092_flds
);


##########################################################################
#                                                                        #
#   R4_AGE_RATE_PORTA                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00093_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "AGE_RATE_ENABLE"              => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Age Rate Enable" ],
   "RSVD0"                        => [   1,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_7_TRIGGER"          => [   2,  56,   5, 0x1F00000000000000, 0x00, 1, 0x0000000000000000, "Age Range 7 Increment Trigger" ],
   "RSVD1"                        => [   3,  53,   3, 0x00E0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_6_TRIGGER"          => [   4,  48,   5, 0x001F000000000000, 0x00, 1, 0x0000000000000000, "Age Range 6 Increment Trigger" ],
   "RSVD2"                        => [   5,  45,   3, 0x0000E00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_5_TRIGGER"          => [   6,  40,   5, 0x00001F0000000000, 0x00, 1, 0x0000000000000000, "Age Range 5 Increment Trigger" ],
   "RSVD3"                        => [   7,  37,   3, 0x000000E000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_4_TRIGGER"          => [   8,  32,   5, 0x0000001F00000000, 0x00, 1, 0x0000000000000000, "Age Range 4 Increment Trigger" ],
   "RSVD4"                        => [   9,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_3_TRIGGER"          => [  10,  24,   5, 0x000000001F000000, 0x00, 1, 0x0000000000000000, "Age Range 3 Increment Trigger" ],
   "RSVD5"                        => [  11,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_2_TRIGGER"          => [  12,  16,   5, 0x00000000001F0000, 0x00, 1, 0x0000000000000000, "Age Range 2 Increment Trigger" ],
   "RSVD6"                        => [  13,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_1_TRIGGER"          => [  14,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "Age Range 1 Increment Trigger" ],
   "RSVD7"                        => [  15,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_0_TRIGGER"          => [  16,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Age Range 0 Increment Trigger" ],
);

%nl4rtr_01_00093_def =
( NAME    => "R4_AGE_RATE_PORTA",
  ADDRESS => 0x0000000002000600,
  NOTE    => "The AGE_RATE register.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00093_flds
);


##########################################################################
#                                                                        #
#   R4_AGE_RATE_PORTB                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00094_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "AGE_RATE_ENABLE"              => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Age Rate Enable" ],
   "RSVD0"                        => [   1,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_7_TRIGGER"          => [   2,  56,   5, 0x1F00000000000000, 0x00, 1, 0x0000000000000000, "Age Range 7 Increment Trigger" ],
   "RSVD1"                        => [   3,  53,   3, 0x00E0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_6_TRIGGER"          => [   4,  48,   5, 0x001F000000000000, 0x00, 1, 0x0000000000000000, "Age Range 6 Increment Trigger" ],
   "RSVD2"                        => [   5,  45,   3, 0x0000E00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_5_TRIGGER"          => [   6,  40,   5, 0x00001F0000000000, 0x00, 1, 0x0000000000000000, "Age Range 5 Increment Trigger" ],
   "RSVD3"                        => [   7,  37,   3, 0x000000E000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_4_TRIGGER"          => [   8,  32,   5, 0x0000001F00000000, 0x00, 1, 0x0000000000000000, "Age Range 4 Increment Trigger" ],
   "RSVD4"                        => [   9,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_3_TRIGGER"          => [  10,  24,   5, 0x000000001F000000, 0x00, 1, 0x0000000000000000, "Age Range 3 Increment Trigger" ],
   "RSVD5"                        => [  11,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_2_TRIGGER"          => [  12,  16,   5, 0x00000000001F0000, 0x00, 1, 0x0000000000000000, "Age Range 2 Increment Trigger" ],
   "RSVD6"                        => [  13,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_1_TRIGGER"          => [  14,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "Age Range 1 Increment Trigger" ],
   "RSVD7"                        => [  15,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_0_TRIGGER"          => [  16,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Age Range 0 Increment Trigger" ],
);

%nl4rtr_01_00094_def =
( NAME    => "R4_AGE_RATE_PORTB",
  ADDRESS => 0x0000000002000610,
  NOTE    => "Age rate selects for Port B",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00094_flds
);


##########################################################################
#                                                                        #
#   R4_AGE_RATE_PORTC                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00095_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "AGE_RATE_ENABLE"              => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Age Rate Enable" ],
   "RSVD0"                        => [   1,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_7_TRIGGER"          => [   2,  56,   5, 0x1F00000000000000, 0x00, 1, 0x0000000000000000, "Age Range 7 Increment Trigger" ],
   "RSVD1"                        => [   3,  53,   3, 0x00E0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_6_TRIGGER"          => [   4,  48,   5, 0x001F000000000000, 0x00, 1, 0x0000000000000000, "Age Range 6 Increment Trigger" ],
   "RSVD2"                        => [   5,  45,   3, 0x0000E00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_5_TRIGGER"          => [   6,  40,   5, 0x00001F0000000000, 0x00, 1, 0x0000000000000000, "Age Range 5 Increment Trigger" ],
   "RSVD3"                        => [   7,  37,   3, 0x000000E000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_4_TRIGGER"          => [   8,  32,   5, 0x0000001F00000000, 0x00, 1, 0x0000000000000000, "Age Range 4 Increment Trigger" ],
   "RSVD4"                        => [   9,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_3_TRIGGER"          => [  10,  24,   5, 0x000000001F000000, 0x00, 1, 0x0000000000000000, "Age Range 3 Increment Trigger" ],
   "RSVD5"                        => [  11,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_2_TRIGGER"          => [  12,  16,   5, 0x00000000001F0000, 0x00, 1, 0x0000000000000000, "Age Range 2 Increment Trigger" ],
   "RSVD6"                        => [  13,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_1_TRIGGER"          => [  14,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "Age Range 1 Increment Trigger" ],
   "RSVD7"                        => [  15,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_0_TRIGGER"          => [  16,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Age Range 0 Increment Trigger" ],
);

%nl4rtr_01_00095_def =
( NAME    => "R4_AGE_RATE_PORTC",
  ADDRESS => 0x0000000002000620,
  NOTE    => "Age rate selects for Port C",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00095_flds
);


##########################################################################
#                                                                        #
#   R4_AGE_RATE_PORTD                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00096_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "AGE_RATE_ENABLE"              => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Age Rate Enable" ],
   "RSVD0"                        => [   1,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_7_TRIGGER"          => [   2,  56,   5, 0x1F00000000000000, 0x00, 1, 0x0000000000000000, "Age Range 7 Increment Trigger" ],
   "RSVD1"                        => [   3,  53,   3, 0x00E0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_6_TRIGGER"          => [   4,  48,   5, 0x001F000000000000, 0x00, 1, 0x0000000000000000, "Age Range 6 Increment Trigger" ],
   "RSVD2"                        => [   5,  45,   3, 0x0000E00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_5_TRIGGER"          => [   6,  40,   5, 0x00001F0000000000, 0x00, 1, 0x0000000000000000, "Age Range 5 Increment Trigger" ],
   "RSVD3"                        => [   7,  37,   3, 0x000000E000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_4_TRIGGER"          => [   8,  32,   5, 0x0000001F00000000, 0x00, 1, 0x0000000000000000, "Age Range 4 Increment Trigger" ],
   "RSVD4"                        => [   9,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_3_TRIGGER"          => [  10,  24,   5, 0x000000001F000000, 0x00, 1, 0x0000000000000000, "Age Range 3 Increment Trigger" ],
   "RSVD5"                        => [  11,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_2_TRIGGER"          => [  12,  16,   5, 0x00000000001F0000, 0x00, 1, 0x0000000000000000, "Age Range 2 Increment Trigger" ],
   "RSVD6"                        => [  13,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_1_TRIGGER"          => [  14,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "Age Range 1 Increment Trigger" ],
   "RSVD7"                        => [  15,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_0_TRIGGER"          => [  16,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Age Range 0 Increment Trigger" ],
);

%nl4rtr_01_00096_def =
( NAME    => "R4_AGE_RATE_PORTD",
  ADDRESS => 0x0000000002000630,
  NOTE    => "Age rate selects for Port D",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00096_flds
);


##########################################################################
#                                                                        #
#   R4_AGE_RATE_PORTE                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00097_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "AGE_RATE_ENABLE"              => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Age Rate Enable" ],
   "RSVD0"                        => [   1,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_7_TRIGGER"          => [   2,  56,   5, 0x1F00000000000000, 0x00, 1, 0x0000000000000000, "Age Range 7 Increment Trigger" ],
   "RSVD1"                        => [   3,  53,   3, 0x00E0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_6_TRIGGER"          => [   4,  48,   5, 0x001F000000000000, 0x00, 1, 0x0000000000000000, "Age Range 6 Increment Trigger" ],
   "RSVD2"                        => [   5,  45,   3, 0x0000E00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_5_TRIGGER"          => [   6,  40,   5, 0x00001F0000000000, 0x00, 1, 0x0000000000000000, "Age Range 5 Increment Trigger" ],
   "RSVD3"                        => [   7,  37,   3, 0x000000E000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_4_TRIGGER"          => [   8,  32,   5, 0x0000001F00000000, 0x00, 1, 0x0000000000000000, "Age Range 4 Increment Trigger" ],
   "RSVD4"                        => [   9,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_3_TRIGGER"          => [  10,  24,   5, 0x000000001F000000, 0x00, 1, 0x0000000000000000, "Age Range 3 Increment Trigger" ],
   "RSVD5"                        => [  11,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_2_TRIGGER"          => [  12,  16,   5, 0x00000000001F0000, 0x00, 1, 0x0000000000000000, "Age Range 2 Increment Trigger" ],
   "RSVD6"                        => [  13,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_1_TRIGGER"          => [  14,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "Age Range 1 Increment Trigger" ],
   "RSVD7"                        => [  15,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_0_TRIGGER"          => [  16,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Age Range 0 Increment Trigger" ],
);

%nl4rtr_01_00097_def =
( NAME    => "R4_AGE_RATE_PORTE",
  ADDRESS => 0x0000000002000640,
  NOTE    => "Age rate selects for Port E",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00097_flds
);


##########################################################################
#                                                                        #
#   R4_AGE_RATE_PORTF                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00098_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "AGE_RATE_ENABLE"              => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Age Rate Enable" ],
   "RSVD0"                        => [   1,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_7_TRIGGER"          => [   2,  56,   5, 0x1F00000000000000, 0x00, 1, 0x0000000000000000, "Age Range 7 Increment Trigger" ],
   "RSVD1"                        => [   3,  53,   3, 0x00E0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_6_TRIGGER"          => [   4,  48,   5, 0x001F000000000000, 0x00, 1, 0x0000000000000000, "Age Range 6 Increment Trigger" ],
   "RSVD2"                        => [   5,  45,   3, 0x0000E00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_5_TRIGGER"          => [   6,  40,   5, 0x00001F0000000000, 0x00, 1, 0x0000000000000000, "Age Range 5 Increment Trigger" ],
   "RSVD3"                        => [   7,  37,   3, 0x000000E000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_4_TRIGGER"          => [   8,  32,   5, 0x0000001F00000000, 0x00, 1, 0x0000000000000000, "Age Range 4 Increment Trigger" ],
   "RSVD4"                        => [   9,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_3_TRIGGER"          => [  10,  24,   5, 0x000000001F000000, 0x00, 1, 0x0000000000000000, "Age Range 3 Increment Trigger" ],
   "RSVD5"                        => [  11,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_2_TRIGGER"          => [  12,  16,   5, 0x00000000001F0000, 0x00, 1, 0x0000000000000000, "Age Range 2 Increment Trigger" ],
   "RSVD6"                        => [  13,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_1_TRIGGER"          => [  14,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "Age Range 1 Increment Trigger" ],
   "RSVD7"                        => [  15,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_0_TRIGGER"          => [  16,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Age Range 0 Increment Trigger" ],
);

%nl4rtr_01_00098_def =
( NAME    => "R4_AGE_RATE_PORTF",
  ADDRESS => 0x0000000002000650,
  NOTE    => "Age rate selects for Port F",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00098_flds
);


##########################################################################
#                                                                        #
#   R4_AGE_RATE_PORTG                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00099_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "AGE_RATE_ENABLE"              => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Age Rate Enable" ],
   "RSVD0"                        => [   1,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_7_TRIGGER"          => [   2,  56,   5, 0x1F00000000000000, 0x00, 1, 0x0000000000000000, "Age Range 7 Increment Trigger" ],
   "RSVD1"                        => [   3,  53,   3, 0x00E0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_6_TRIGGER"          => [   4,  48,   5, 0x001F000000000000, 0x00, 1, 0x0000000000000000, "Age Range 6 Increment Trigger" ],
   "RSVD2"                        => [   5,  45,   3, 0x0000E00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_5_TRIGGER"          => [   6,  40,   5, 0x00001F0000000000, 0x00, 1, 0x0000000000000000, "Age Range 5 Increment Trigger" ],
   "RSVD3"                        => [   7,  37,   3, 0x000000E000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_4_TRIGGER"          => [   8,  32,   5, 0x0000001F00000000, 0x00, 1, 0x0000000000000000, "Age Range 4 Increment Trigger" ],
   "RSVD4"                        => [   9,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_3_TRIGGER"          => [  10,  24,   5, 0x000000001F000000, 0x00, 1, 0x0000000000000000, "Age Range 3 Increment Trigger" ],
   "RSVD5"                        => [  11,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_2_TRIGGER"          => [  12,  16,   5, 0x00000000001F0000, 0x00, 1, 0x0000000000000000, "Age Range 2 Increment Trigger" ],
   "RSVD6"                        => [  13,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_1_TRIGGER"          => [  14,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "Age Range 1 Increment Trigger" ],
   "RSVD7"                        => [  15,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_0_TRIGGER"          => [  16,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Age Range 0 Increment Trigger" ],
);

%nl4rtr_01_00099_def =
( NAME    => "R4_AGE_RATE_PORTG",
  ADDRESS => 0x0000000002000660,
  NOTE    => "Age rate selects for Port G",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00099_flds
);


##########################################################################
#                                                                        #
#   R4_AGE_RATE_PORTH                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00100_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "AGE_RATE_ENABLE"              => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Age Rate Enable" ],
   "RSVD0"                        => [   1,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_7_TRIGGER"          => [   2,  56,   5, 0x1F00000000000000, 0x00, 1, 0x0000000000000000, "Age Range 7 Increment Trigger" ],
   "RSVD1"                        => [   3,  53,   3, 0x00E0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_6_TRIGGER"          => [   4,  48,   5, 0x001F000000000000, 0x00, 1, 0x0000000000000000, "Age Range 6 Increment Trigger" ],
   "RSVD2"                        => [   5,  45,   3, 0x0000E00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_5_TRIGGER"          => [   6,  40,   5, 0x00001F0000000000, 0x00, 1, 0x0000000000000000, "Age Range 5 Increment Trigger" ],
   "RSVD3"                        => [   7,  37,   3, 0x000000E000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_4_TRIGGER"          => [   8,  32,   5, 0x0000001F00000000, 0x00, 1, 0x0000000000000000, "Age Range 4 Increment Trigger" ],
   "RSVD4"                        => [   9,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_3_TRIGGER"          => [  10,  24,   5, 0x000000001F000000, 0x00, 1, 0x0000000000000000, "Age Range 3 Increment Trigger" ],
   "RSVD5"                        => [  11,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_2_TRIGGER"          => [  12,  16,   5, 0x00000000001F0000, 0x00, 1, 0x0000000000000000, "Age Range 2 Increment Trigger" ],
   "RSVD6"                        => [  13,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_1_TRIGGER"          => [  14,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "Age Range 1 Increment Trigger" ],
   "RSVD7"                        => [  15,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_0_TRIGGER"          => [  16,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Age Range 0 Increment Trigger" ],
);

%nl4rtr_01_00100_def =
( NAME    => "R4_AGE_RATE_PORTH",
  ADDRESS => 0x0000000002000670,
  NOTE    => "Age rate selects for Port H",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00100_flds
);


##########################################################################
#                                                                        #
#   R4_AGE_RATE_PORTLB                                                   #
#                                                                        #
##########################################################################

%nl4rtr_01_00101_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "AGE_RATE_ENABLE"              => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Age Rate Enable" ],
   "RSVD0"                        => [   1,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_7_TRIGGER"          => [   2,  56,   5, 0x1F00000000000000, 0x00, 1, 0x0000000000000000, "Age Range 7 Increment Trigger" ],
   "RSVD1"                        => [   3,  53,   3, 0x00E0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_6_TRIGGER"          => [   4,  48,   5, 0x001F000000000000, 0x00, 1, 0x0000000000000000, "Age Range 6 Increment Trigger" ],
   "RSVD2"                        => [   5,  45,   3, 0x0000E00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_5_TRIGGER"          => [   6,  40,   5, 0x00001F0000000000, 0x00, 1, 0x0000000000000000, "Age Range 5 Increment Trigger" ],
   "RSVD3"                        => [   7,  37,   3, 0x000000E000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_4_TRIGGER"          => [   8,  32,   5, 0x0000001F00000000, 0x00, 1, 0x0000000000000000, "Age Range 4 Increment Trigger" ],
   "RSVD4"                        => [   9,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_3_TRIGGER"          => [  10,  24,   5, 0x000000001F000000, 0x00, 1, 0x0000000000000000, "Age Range 3 Increment Trigger" ],
   "RSVD5"                        => [  11,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_2_TRIGGER"          => [  12,  16,   5, 0x00000000001F0000, 0x00, 1, 0x0000000000000000, "Age Range 2 Increment Trigger" ],
   "RSVD6"                        => [  13,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_1_TRIGGER"          => [  14,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "Age Range 1 Increment Trigger" ],
   "RSVD7"                        => [  15,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_RANGE_0_TRIGGER"          => [  16,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Age Range 0 Increment Trigger" ],
);

%nl4rtr_01_00101_def =
( NAME    => "R4_AGE_RATE_PORTLB",
  ADDRESS => 0x0000000002000680,
  NOTE    => "Age rate selects for Port LB",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00101_flds
);


##########################################################################
#                                                                        #
#   R4_THROTTLE_ENABLE_ARBL                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00102_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INPUTH_VC3_ENABLE"            => [   1,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input H Vch3" ],
   "INPUTH_VC2_ENABLE"            => [   2,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input H Vch2" ],
   "INPUTH_VC1_ENABLE"            => [   3,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input H Vch1" ],
   "INPUTH_VC0_ENABLE"            => [   4,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input H Vch0" ],
   "INPUTG_VC3_ENABLE"            => [   5,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input G Vch3" ],
   "INPUTG_VC2_ENABLE"            => [   6,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input G Vch2" ],
   "INPUTG_VC1_ENABLE"            => [   7,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input G Vch1" ],
   "INPUTG_VC0_ENABLE"            => [   8,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input G Vch0" ],
   "INPUTF_VC3_ENABLE"            => [   9,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input F Vch3" ],
   "INPUTF_VC2_ENABLE"            => [  10,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input F Vch2" ],
   "INPUTF_VC1_ENABLE"            => [  11,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input F Vch1" ],
   "INPUTF_VC0_ENABLE"            => [  12,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input F Vch0" ],
   "INPUTE_VC3_ENABLE"            => [  13,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input E Vch3" ],
   "INPUTE_VC2_ENABLE"            => [  14,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input E Vch2" ],
   "INPUTE_VC1_ENABLE"            => [  15,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input E Vch1" ],
   "INPUTE_VC0_ENABLE"            => [  16,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input E Vch0" ],
   "INPUTD_VC3_ENABLE"            => [  17,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input D Vch3" ],
   "INPUTD_VC2_ENABLE"            => [  18,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input D Vch2" ],
   "INPUTD_VC1_ENABLE"            => [  19,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input D Vch1" ],
   "INPUTD_VC0_ENABLE"            => [  20,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input D Vch0" ],
   "INPUTC_VC3_ENABLE"            => [  21,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "Throttle enable for Input C Vch3" ],
   "INPUTC_VC2_ENABLE"            => [  22,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "Throttle enable for Input C Vch2" ],
   "INPUTC_VC1_ENABLE"            => [  23,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Throttle enable for Input C Vch1" ],
   "INPUTC_VC0_ENABLE"            => [  24,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Throttle enable for Input C Vch0" ],
   "INPUTB_VC3_ENABLE"            => [  25,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Throttle enable for Input B Vch3" ],
   "INPUTB_VC2_ENABLE"            => [  26,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Throttle enable for Input B Vch2" ],
   "INPUTB_VC1_ENABLE"            => [  27,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Throttle enable for Input B Vch1" ],
   "INPUTB_VC0_ENABLE"            => [  28,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Throttle enable for Input B Vch0" ],
   "INPUTA_VC3_ENABLE"            => [  29,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Throttle enable for Input A Vch3" ],
   "INPUTA_VC2_ENABLE"            => [  30,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Throttle enable for Input A Vch2" ],
   "INPUTA_VC1_ENABLE"            => [  31,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Throttle enable for Input A Vch1" ],
   "INPUTA_VC0_ENABLE"            => [  32,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Throttle enable for Input A Vch0" ],
);

%nl4rtr_01_00102_def =
( NAME    => "R4_THROTTLE_ENABLE_ARBL",
  ADDRESS => 0x0000000002000500,
  NOTE    => "The THROTTLE_ENABLE_ARBL register allows the throttling feature to note be enabled on any input. There is one enable for each vi",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00102_flds
);


##########################################################################
#                                                                        #
#   R4_THROTTLE_ENABLE_ARBR                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00103_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INPUTH_VC3_ENABLE"            => [   1,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input H Vch3" ],
   "INPUTH_VC2_ENABLE"            => [   2,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input H Vch2" ],
   "INPUTH_VC1_ENABLE"            => [   3,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input H Vch1" ],
   "INPUTH_VC0_ENABLE"            => [   4,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input H Vch0" ],
   "INPUTG_VC3_ENABLE"            => [   5,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input G Vch3" ],
   "INPUTG_VC2_ENABLE"            => [   6,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input G Vch2" ],
   "INPUTG_VC1_ENABLE"            => [   7,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input G Vch1" ],
   "INPUTG_VC0_ENABLE"            => [   8,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input G Vch0" ],
   "INPUTF_VC3_ENABLE"            => [   9,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input F Vch3" ],
   "INPUTF_VC2_ENABLE"            => [  10,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input F Vch2" ],
   "INPUTF_VC1_ENABLE"            => [  11,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input F Vch1" ],
   "INPUTF_VC0_ENABLE"            => [  12,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input F Vch0" ],
   "INPUTE_VC3_ENABLE"            => [  13,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input E Vch3" ],
   "INPUTE_VC2_ENABLE"            => [  14,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input E Vch2" ],
   "INPUTE_VC1_ENABLE"            => [  15,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input E Vch1" ],
   "INPUTE_VC0_ENABLE"            => [  16,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input E Vch0" ],
   "INPUTD_VC3_ENABLE"            => [  17,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input D Vch3" ],
   "INPUTD_VC2_ENABLE"            => [  18,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input D Vch2" ],
   "INPUTD_VC1_ENABLE"            => [  19,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input D Vch1" ],
   "INPUTD_VC0_ENABLE"            => [  20,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Throttle enable for Input D Vch0" ],
   "INPUTC_VC3_ENABLE"            => [  21,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "Throttle enable for Input C Vch3" ],
   "INPUTC_VC2_ENABLE"            => [  22,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "Throttle enable for Input C Vch2" ],
   "INPUTC_VC1_ENABLE"            => [  23,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Throttle enable for Input C Vch1" ],
   "INPUTC_VC0_ENABLE"            => [  24,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Throttle enable for Input C Vch0" ],
   "INPUTB_VC3_ENABLE"            => [  25,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Throttle enable for Input B Vch3" ],
   "INPUTB_VC2_ENABLE"            => [  26,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Throttle enable for Input B Vch2" ],
   "INPUTB_VC1_ENABLE"            => [  27,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Throttle enable for Input B Vch1" ],
   "INPUTB_VC0_ENABLE"            => [  28,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Throttle enable for Input B Vch0" ],
   "INPUTA_VC3_ENABLE"            => [  29,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Throttle enable for Input A Vch3" ],
   "INPUTA_VC2_ENABLE"            => [  30,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Throttle enable for Input A Vch2" ],
   "INPUTA_VC1_ENABLE"            => [  31,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Throttle enable for Input A Vch1" ],
   "INPUTA_VC0_ENABLE"            => [  32,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Throttle enable for Input A Vch0" ],
);

%nl4rtr_01_00103_def =
( NAME    => "R4_THROTTLE_ENABLE_ARBR",
  ADDRESS => 0x0000000002000508,
  NOTE    => "The THROTTLE_ENABLE_ARBR register allows the throttling feature to note be enabled on any input. There is one enable for each vi",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00103_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_LOCAL_TABLE                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00104_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR0"                         => [   2,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Direction" ],
);

%nl4rtr_01_00104_def =
( NAME    => "R4_PORTA_LOCAL_TABLE",
  ADDRESS => 0x0000000008000000,
  NOTE    => "LOCAL_TABLE represents a set of 512 registers which constitute the note Local Look-up Table for the input port. The LOCAL_TABLE ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00104_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_GLOBAL_TABLE                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00105_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR0"                         => [   2,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Direction" ],
);

%nl4rtr_01_00105_def =
( NAME    => "R4_PORTA_GLOBAL_TABLE",
  ADDRESS => 0x0000000008001000,
  NOTE    => "GLOBAL_TABLE represents a set of 256 registers which constitute the note Global Look-up Table for the input port. The GLOBAL_TAB",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00105_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_NEIGHBOR_TABLE                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00106_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,  14,  49, 0x7FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NEIGHBOR_ID"                  => [   2,   0,  14, 0x0000000000003FFF, 0x00, 0, 0x0000000000000000, "Neighbor Node ID" ],
);

%nl4rtr_01_00106_def =
( NAME    => "R4_PORTA_NEIGHBOR_TABLE",
  ADDRESS => 0x0000000008001800,
  NOTE    => "NEIGHBOR_TABLE represents a set of 8 registers which constitute the note Neighbor Look-up Table for the input port. The NEIGHBOR",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00106_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PARMS                                                       #
#                                                                        #
##########################################################################

%nl4rtr_01_00107_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SPARE"                        => [   1,  30,   8, 0x0000003FC0000000, 0x00, 1, 0x0000000000000000, "" ],
   "V_BIT_EMULATION"              => [   2,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "" ],
   "NEW_DIR_SPRAY_ENABLE"         => [   3,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "" ],
   "DIR_SPRAY_ENABLE"             => [   4,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "" ],
   "EXTEND_ENABLE"                => [   5,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "" ],
   "EXTEND_SHUB_INPUT"            => [   6,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "" ],
   "EXTEND_SHUB_DIR_VEC"          => [   7,  17,   8, 0x0000000001FE0000, 0x00, 1, 0x0000000000000000, "" ],
   "ARM_FORCE_CB_ERROR"           => [   8,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Arm Forcing of a Checkbyte Error" ],
   "LINKRESET_ON_BUFFEROVERFLOW"  => [   9,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Enable Link Reset On Buffer Overflow" ],
   "EATUNTILTAIL_ON_BUFFEROVERFLOW" => [  10,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Eat Until Tail On Buffer Overflow" ],
   "LINKRESET_ON_FIFOOVERFLOW"    => [  11,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Enable Link Reset On Fifo Overflow" ],
   "SEND_DEADLOCK_EAT_ENABLE_VCH3" => [  12,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "SEND_DEADLOCK_EAT_ENABLE_VCH2" => [  13,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "SEND_DEADLOCK_EAT_ENABLE_VCH1" => [  14,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "SEND_DEADLOCK_EAT_ENABLE_VCH0" => [  15,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "TAIL_TO_ERROR_TAIL_ENABLE_VCH3" => [  16,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "TAIL_TO_ERROR_TAIL_ENABLE_VCH2" => [  17,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "TAIL_TO_ERROR_TAIL_ENABLE_VCH1" => [  18,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "TAIL_TO_ERROR_TAIL_ENABLE_VCH0" => [  19,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "MIP_RESET_ENABLE"             => [  20,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Message-In-Progess Reset Enable" ],
   "SEND_DEADLOCK_TO_VAL"         => [  21,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Port Output Deadlock Timeout Value" ],
);

%nl4rtr_01_00107_def =
( NAME    => "R4_PORTA_PARMS",
  ADDRESS => 0x0000000008001840,
  NOTE    => "The PORT_PARMS register for a port. This register contains note port-specific LLP parameters.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00107_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_SPRAY_DIR                                                   #
#                                                                        #
##########################################################################

%nl4rtr_01_00108_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DIR7"                         => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 7" ],
   "DIR6"                         => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 6" ],
   "DIR5"                         => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 5" ],
   "DIR4"                         => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 4" ],
   "DIR3"                         => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 3" ],
   "DIR2"                         => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 2" ],
   "DIR1"                         => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 1" ],
);

%nl4rtr_01_00108_def =
( NAME    => "R4_PORTA_SPRAY_DIR",
  ADDRESS => 0x0000000008001848,
  NOTE    => "The PORT_SPRAY_DIR register for a port. This register contains note alternate direction information for distributed (i.e. spraye",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00108_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_SPRAY_CMD_3F_0                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00109_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Masks out commands to disable them from spraying" ],
);

%nl4rtr_01_00109_def =
( NAME    => "R4_PORTA_SPRAY_CMD_3F_0",
  ADDRESS => 0x0000000008001850,
  NOTE    => "The PORT_SPRAY_CMD_3f_0 register for each port masks off any of the note commands encodings from 0x0 to 0x3f and makes them non-",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00109_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_SPRAY_CMD_7F_40                                             #
#                                                                        #
##########################################################################

%nl4rtr_01_00110_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Masks out commands 0x40 to 0x7f to disable them from spraying" ],
);

%nl4rtr_01_00110_def =
( NAME    => "R4_PORTA_SPRAY_CMD_7F_40",
  ADDRESS => 0x0000000008001858,
  NOTE    => "The PORT_SPRAY_CMD_7f_40 register for each port masks off any of note the commands encodings from 0x40 to 0x7f and makes them no",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00110_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_SPRAY_CMD_BF_80                                             #
#                                                                        #
##########################################################################

%nl4rtr_01_00111_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Masks out commands 0x80 to 0xbf to disable them from spraying" ],
);

%nl4rtr_01_00111_def =
( NAME    => "R4_PORTA_SPRAY_CMD_BF_80",
  ADDRESS => 0x0000000008001860,
  NOTE    => "The PORT_SPRAY_CMD_bf_80 register for each port masks off any of note the commands encodings from 0x80 to 0xbf and makes them no",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00111_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_SPRAY_CMD_FF_C0                                             #
#                                                                        #
##########################################################################

%nl4rtr_01_00112_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Masks out commands 0xc0 to 0xff to disable them from spraying" ],
);

%nl4rtr_01_00112_def =
( NAME    => "R4_PORTA_SPRAY_CMD_FF_C0",
  ADDRESS => 0x0000000008001868,
  NOTE    => "The PORT_SPRAY_CMD_ff_c0 register for each port masks off any of note the commands encodings from 0xc0 to 0xff and makes them no",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00112_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_LLP_CONFIG                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00113_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_RMT_FT_UPD"            => [   1,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Enable Remote Fine-tuning Updates" ],
   "ENABLE_TUNING"                => [   2,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Enable Tuning" ],
   "AC_ENCODE"                    => [   3,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "DC Encoding Disabled" ],
   "ENABLELINK"                   => [   4,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Enable Link" ],
   "BITMODE32"                    => [   5,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "32-bit Mode Enabled" ],
);

%nl4rtr_01_00113_def =
( NAME    => "R4_PORTA_LLP_CONFIG",
  ADDRESS => 0x0000000008001888,
  NOTE    => "Port Parameters",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00113_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_LLP_TEST_CTL                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00114_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CB_ERROR"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Captured Micropacket Contained a CRC Error" ],
   "CAPTURED"                     => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "Micropacket Captured" ],
   "FAKESNERROR"                  => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "Inject a Sequence Number Error at the Receiver" ],
   "SEND_SN_ERROR"                => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Inject a Sequence Number Error" ],
   "SEND_CB_ERROR"                => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "Inject a CRC Error" ],
   "CAPTURE_CB_ONLY"              => [   6,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "Capture CRC Errors Only" ],
   "ARM_CAPTURE"                  => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "Arm Micropacket Capture Logic" ],
   "NOISE_MODE"                   => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Noise Mode" ],
   "LFSR_MODE"                    => [   9,  52,   2, 0x0030000000000000, 0x00, 0, 0x0000000000000000, "LFSR Mode" ],
   "RSVD1"                        => [  10,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WIRE_SEL"                     => [  11,  44,   6, 0x0003F00000000000, 0x00, 1, 0x0000000000000000, "Wire Select" ],
   "RSVD2"                        => [  12,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_TEST_MODE"               => [  13,  40,   2, 0x0000030000000000, 0x00, 1, 0x0000000000000000, "Send Test Mode" ],
   "PATTERN"                      => [  14,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Send Channel Seed Data Pattern" ],
);

%nl4rtr_01_00114_def =
( NAME    => "R4_PORTA_LLP_TEST_CTL",
  ADDRESS => 0x0000000008001890,
  NOTE    => "The PORT_LLP_TEST_CTL register controls LLP testing. The links may note be tested either online or offline. That is, errors may ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00114_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_LLP_STATE                                                   #
#                                                                        #
##########################################################################

%nl4rtr_01_00115_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LINK_SEND_FSM_STATE"          => [   1,  10,   6, 0x000000000000FC00, 0x00, 0, 0x0000000000000000, "Current State of Port A LLP" ],
   "LINK_RCV_FSM_STATE"           => [   2,   4,   6, 0x00000000000003F0, 0x00, 0, 0x0000000000000000, "Current State of Port A LLP" ],
   "LINK_RESET_STATE"             => [   3,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Current State of Port A LLP" ],
);

%nl4rtr_01_00115_def =
( NAME    => "R4_PORTA_LLP_STATE",
  ADDRESS => 0x0000000008001898,
  NOTE    => "The PORTA_LLP_STATE register allows software to monitor the state note of the Port A LLP.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00115_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_LLP_ERR1                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00116_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RETRY_COUNT"                  => [   0,  48,  16, 0xFFFF000000000000, 0x00, 1, 0x0000000000000000, "Retry Count" ],
   "RX_CB_ERR_COUNT"              => [   1,  16,  32, 0x0000FFFFFFFF0000, 0x00, 1, 0x0000000000000000, "CRC Error Count" ],
   "RX_SN_ERR_COUNT"              => [   2,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "Sequence Number Error Count" ],
);

%nl4rtr_01_00116_def =
( NAME    => "R4_PORTA_LLP_ERR1",
  ADDRESS => 0x00000000080018a0,
  NOTE    => "The PORTA_LLP_ERR1 register stores detail error and status note information pertaining to errors detected by the Port A LLP.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00116_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_LLP_ERR2                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00117_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CORESENTBADCRC_COUNT"         => [   1,  28,   6, 0x00000003F0000000, 0x00, 1, 0x0000000000000000, "Core Sent Bad CRC count" ],
   "SQUASH"                       => [   2,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "Squashed Micropacket" ],
   "RESET_TIMEOUT"                => [   3,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "Reset Timeout" ],
   "RETRY_TIMEOUT"                => [   4,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Retry Timeout" ],
   "WIRE_OVERFLOW"                => [   5,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Single-wire Error Counter Overflow" ],
   "WIRE_CNT"                     => [   6,   0,  24, 0x0000000000FFFFFF, 0x00, 1, 0x0000000000000000, "Single-wire Error Count" ],
);

%nl4rtr_01_00117_def =
( NAME    => "R4_PORTA_LLP_ERR2",
  ADDRESS => 0x00000000080018a8,
  NOTE    => "The PORTA_LLP_ERR2 register stores detail error status information note pertaining to errors detected by the Port A LLP.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00117_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_LLP_CAPT_WD1                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00118_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Captured Micropacket[63:0]" ],
);

%nl4rtr_01_00118_def =
( NAME    => "R4_PORTA_LLP_CAPT_WD1",
  ADDRESS => 0x00000000080018b0,
  NOTE    => "When the LLP micropacket capture circuitry is activated via the note ARMCAPTURE bit of the PORTA_LLP_TEST_CTL register, the note",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00118_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_LLP_CAPT_WD2                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00119_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Captured Micropacket[127:64]" ],
);

%nl4rtr_01_00119_def =
( NAME    => "R4_PORTA_LLP_CAPT_WD2",
  ADDRESS => 0x00000000080018b8,
  NOTE    => "When the LLP micropacket capture circuitry is activated via the note ARMCAPTURE bit of the PORTA_LLP_TEST_CTL register, the note",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00119_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_LLP_CAPT_SBCB                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00120_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FAKED_ALL_SN_ERRORS"          => [   1,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "All Faked Sequence Number Errors have been Sent" ],
   "SENT_ALL_SN_ERRORS"           => [   2,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "All Sequence Number Errors have been sent" ],
   "SENT_ALL_CB_ERRORS"           => [   3,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "All CRC Errors have been Sent" ],
   "CAPTURED_RCV_CRC"             => [   4,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "Captured CRC" ],
   "CAPTURED_RCVSBSN"             => [   5,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Captured Sideband and Sequence Number" ],
);

%nl4rtr_01_00120_def =
( NAME    => "R4_PORTA_LLP_CAPT_SBCB",
  ADDRESS => 0x00000000080018c0,
  NOTE    => "When the PORTA LLP micropacket capture circuitry is activated via note the ARMCAPTURE bit of the PORTA_LLP_TEST_CTL register, th",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00120_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_CREDIT                                                      #
#                                                                        #
##########################################################################

%nl4rtr_01_00121_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_LIMIT_VCH3"              => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RSVD1"                        => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_LIMIT_VCH2"              => [   3,  48,   7, 0x007F000000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RSVD2"                        => [   4,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_LIMIT_VCH1"              => [   5,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RSVD3"                        => [   6,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_LIMIT_VCH0"              => [   7,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "RSVD4"                        => [   8,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RCV_INITIAL_VCH3"             => [   9,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RSVD5"                        => [  10,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RCV_INITIAL_VCH2"             => [  11,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RSVD6"                        => [  12,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RCV_INITIAL_VCH1"             => [  13,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RCV_INITIAL_VCH0"             => [  15,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "VCh0" ],
);

%nl4rtr_01_00121_def =
( NAME    => "R4_PORTA_CREDIT",
  ADDRESS => 0x00000000080018c8,
  NOTE    => "This register powers up to an unknown state and is not reset. It note must be written prior to channel reset.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00121_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_DEBIT                                                       #
#                                                                        #
##########################################################################

%nl4rtr_01_00122_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  37,  27, 0xFFFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EN_SHORT_INTERVAL"            => [   1,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Enable Short Credit Only Interval" ],
   "EN_XMITBUF_THRESHOLD"         => [   2,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "Enable Transmit Buffer Threshold" ],
   "CREDIT_ONLY_INTERVAL"         => [   3,  32,   3, 0x0000000700000000, 0x00, 1, 0x0000000000000000, "Credit Only Packet Interval" ],
   "RSVD1"                        => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FORCE_DEBIT_VCH3"             => [   5,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "WITHHOLD_VCH3"                => [   6,  24,   6, 0x000000003F000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "RSVD2"                        => [   7,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FORCE_DEBIT_VCH2"             => [   8,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "WITHHOLD_VCH2"                => [   9,  16,   6, 0x00000000003F0000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "RSVD3"                        => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FORCE_DEBIT_VCH1"             => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "WITHHOLD_VCH1"                => [  12,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "RSVD4"                        => [  13,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FORCE_DEBIT_VCH0"             => [  14,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "WITHHOLD_VCH0"                => [  15,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VCh0" ],
);

%nl4rtr_01_00122_def =
( NAME    => "R4_PORTA_DEBIT",
  ADDRESS => 0x00000000080018d0,
  NOTE    => "This register allows diagnostic control of the debit counters. The note debit counters are used to track the debits (credits at ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00122_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_CREDIT_STATE                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00123_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CREDITS_VCH3"                 => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "CREDITS_VCH2"                 => [   1,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "CREDITS_VCH1"                 => [   2,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "CREDITS_VCH0"                 => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "RSVD0"                        => [   4,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBITS_VCH3"                  => [   5,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RSVD1"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBITS_VCH2"                  => [   7,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RSVD2"                        => [   8,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBITS_VCH1"                  => [   9,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RSVD3"                        => [  10,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBITS_VCH0"                  => [  11,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "VCh0" ],
);

%nl4rtr_01_00123_def =
( NAME    => "R4_PORTA_CREDIT_STATE",
  ADDRESS => 0x00000000080018d8,
  NOTE    => "This register is observing the state of the Debit and Credit note counters for each virtual channel. This register is for diagno",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00123_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_LLP_PKT                                                     #
#                                                                        #
##########################################################################

%nl4rtr_01_00124_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Micropacket Count" ],
);

%nl4rtr_01_00124_def =
( NAME    => "R4_PORTA_LLP_PKT",
  ADDRESS => 0x00000000080018e0,
  NOTE    => "This register counts DataValid pulses from the PFSSR. Each note DataValid pulse represents two micropackets.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00124_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_LOCAL_TABLE                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00125_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR0"                         => [   2,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Direction" ],
);

%nl4rtr_01_00125_def =
( NAME    => "R4_PORTB_LOCAL_TABLE",
  ADDRESS => 0x0000000009000000,
  NOTE    => "LOCAL_TABLE represents a set of 512 registers which constitute the note Local Look-up Table for the input port. The LOCAL_TABLE ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00125_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_GLOBAL_TABLE                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00126_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR0"                         => [   2,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Direction" ],
);

%nl4rtr_01_00126_def =
( NAME    => "R4_PORTB_GLOBAL_TABLE",
  ADDRESS => 0x0000000009001000,
  NOTE    => "GLOBAL_TABLE represents a set of 256 registers which constitute the note Global Look-up Table for the input port. The GLOBAL_TAB",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00126_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_NEIGHBOR_TABLE                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00127_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,  14,  49, 0x7FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NEIGHBOR_ID"                  => [   2,   0,  14, 0x0000000000003FFF, 0x00, 0, 0x0000000000000000, "Neighbor Node ID" ],
);

%nl4rtr_01_00127_def =
( NAME    => "R4_PORTB_NEIGHBOR_TABLE",
  ADDRESS => 0x0000000009001800,
  NOTE    => "NEIGHBOR_TABLE represents a set of 8 registers which constitute the note Neighbor Look-up Table for the input port. The NEIGHBOR",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00127_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PARMS                                                       #
#                                                                        #
##########################################################################

%nl4rtr_01_00128_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SPARE"                        => [   1,  30,   8, 0x0000003FC0000000, 0x00, 1, 0x0000000000000000, "" ],
   "V_BIT_EMULATION"              => [   2,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "" ],
   "NEW_DIR_SPRAY_ENABLE"         => [   3,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "" ],
   "DIR_SPRAY_ENABLE"             => [   4,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "" ],
   "EXTEND_ENABLE"                => [   5,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "" ],
   "EXTEND_SHUB_INPUT"            => [   6,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "" ],
   "EXTEND_SHUB_DIR_VEC"          => [   7,  17,   8, 0x0000000001FE0000, 0x00, 1, 0x0000000000000000, "" ],
   "ARM_FORCE_CB_ERROR"           => [   8,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Arm Forcing of a Checkbyte Error" ],
   "LINKRESET_ON_BUFFEROVERFLOW"  => [   9,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Enable Link Reset On Buffer Overflow" ],
   "EATUNTILTAIL_ON_BUFFEROVERFLOW" => [  10,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Eat Until Tail On Buffer Overflow" ],
   "LINKRESET_ON_FIFOOVERFLOW"    => [  11,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Enable Link Reset On Fifo Overflow" ],
   "SEND_DEADLOCK_EAT_ENABLE_VCH3" => [  12,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "SEND_DEADLOCK_EAT_ENABLE_VCH2" => [  13,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "SEND_DEADLOCK_EAT_ENABLE_VCH1" => [  14,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "SEND_DEADLOCK_EAT_ENABLE_VCH0" => [  15,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "TAIL_TO_ERROR_TAIL_ENABLE_VCH3" => [  16,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "TAIL_TO_ERROR_TAIL_ENABLE_VCH2" => [  17,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "TAIL_TO_ERROR_TAIL_ENABLE_VCH1" => [  18,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "TAIL_TO_ERROR_TAIL_ENABLE_VCH0" => [  19,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "MIP_RESET_ENABLE"             => [  20,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Message-In-Progess Reset Enable" ],
   "SEND_DEADLOCK_TO_VAL"         => [  21,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Port Output Deadlock Timeout Value" ],
);

%nl4rtr_01_00128_def =
( NAME    => "R4_PORTB_PARMS",
  ADDRESS => 0x0000000009001840,
  NOTE    => "The PORT_PARMS register for a port. This register contains note port-specific LLP parameters.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00128_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_SPRAY_DIR                                                   #
#                                                                        #
##########################################################################

%nl4rtr_01_00129_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DIR7"                         => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 7" ],
   "DIR6"                         => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 6" ],
   "DIR5"                         => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 5" ],
   "DIR4"                         => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 4" ],
   "DIR3"                         => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 3" ],
   "DIR2"                         => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 2" ],
   "DIR1"                         => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 1" ],
);

%nl4rtr_01_00129_def =
( NAME    => "R4_PORTB_SPRAY_DIR",
  ADDRESS => 0x0000000009001848,
  NOTE    => "The PORT_SPRAY_DIR register for a port. This register contains note alternate direction information for distributed (i.e. spraye",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00129_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_SPRAY_CMD_3F_0                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00130_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Masks out commands to disable them from spraying" ],
);

%nl4rtr_01_00130_def =
( NAME    => "R4_PORTB_SPRAY_CMD_3F_0",
  ADDRESS => 0x0000000009001850,
  NOTE    => "The PORT_SPRAY_CMD_3f_0 register for each port masks off any of the note commands encodings from 0x0 to 0x3f and makes them non-",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00130_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_SPRAY_CMD_7F_40                                             #
#                                                                        #
##########################################################################

%nl4rtr_01_00131_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Masks out commands 0x40 to 0x7f to disable them from spraying" ],
);

%nl4rtr_01_00131_def =
( NAME    => "R4_PORTB_SPRAY_CMD_7F_40",
  ADDRESS => 0x0000000009001858,
  NOTE    => "The PORT_SPRAY_CMD_7f_40 register for each port masks off any of note the commands encodings from 0x40 to 0x7f and makes them no",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00131_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_SPRAY_CMD_BF_80                                             #
#                                                                        #
##########################################################################

%nl4rtr_01_00132_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Masks out commands 0x80 to 0xbf to disable them from spraying" ],
);

%nl4rtr_01_00132_def =
( NAME    => "R4_PORTB_SPRAY_CMD_BF_80",
  ADDRESS => 0x0000000009001860,
  NOTE    => "The PORT_SPRAY_CMD_bf_80 register for each port masks off any of note the commands encodings from 0x80 to 0xbf and makes them no",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00132_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_SPRAY_CMD_FF_C0                                             #
#                                                                        #
##########################################################################

%nl4rtr_01_00133_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Masks out commands 0xc0 to 0xff to disable them from spraying" ],
);

%nl4rtr_01_00133_def =
( NAME    => "R4_PORTB_SPRAY_CMD_FF_C0",
  ADDRESS => 0x0000000009001868,
  NOTE    => "The PORT_SPRAY_CMD_ff_c0 register for each port masks off any of note the commands encodings from 0xc0 to 0xff and makes them no",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00133_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_LLP_CONFIG                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00134_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_RMT_FT_UPD"            => [   1,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Enable Remote Fine-tuning Updates" ],
   "ENABLE_TUNING"                => [   2,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Enable Tuning" ],
   "AC_ENCODE"                    => [   3,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "DC Encoding Disabled" ],
   "ENABLELINK"                   => [   4,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Enable Link" ],
   "BITMODE32"                    => [   5,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "32-bit Mode Enabled" ],
);

%nl4rtr_01_00134_def =
( NAME    => "R4_PORTB_LLP_CONFIG",
  ADDRESS => 0x0000000009001888,
  NOTE    => "Port Parameters",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00134_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_LLP_TEST_CTL                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00135_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CB_ERROR"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Captured Micropacket Contained a CRC Error" ],
   "CAPTURED"                     => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "Micropacket Captured" ],
   "FAKESNERROR"                  => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "Inject a Sequence Number Error at the Receiver" ],
   "SEND_SN_ERROR"                => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Inject a Sequence Number Error" ],
   "SEND_CB_ERROR"                => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "Inject a CRC Error" ],
   "CAPTURE_CB_ONLY"              => [   6,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "Capture CRC Errors Only" ],
   "ARM_CAPTURE"                  => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "Arm Micropacket Capture Logic" ],
   "NOISE_MODE"                   => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Noise Mode" ],
   "LFSR_MODE"                    => [   9,  52,   2, 0x0030000000000000, 0x00, 0, 0x0000000000000000, "LFSR Mode" ],
   "RSVD1"                        => [  10,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WIRE_SEL"                     => [  11,  44,   6, 0x0003F00000000000, 0x00, 1, 0x0000000000000000, "Wire Select" ],
   "RSVD2"                        => [  12,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_TEST_MODE"               => [  13,  40,   2, 0x0000030000000000, 0x00, 1, 0x0000000000000000, "Send Test Mode" ],
   "PATTERN"                      => [  14,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Send Channel Seed Data Pattern" ],
);

%nl4rtr_01_00135_def =
( NAME    => "R4_PORTB_LLP_TEST_CTL",
  ADDRESS => 0x0000000009001890,
  NOTE    => "The PORT_LLP_TEST_CTL register controls LLP testing. The links may note be tested either online or offline. That is, errors may ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00135_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_LLP_STATE                                                   #
#                                                                        #
##########################################################################

%nl4rtr_01_00136_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LINK_SEND_FSM_STATE"          => [   1,  10,   6, 0x000000000000FC00, 0x00, 0, 0x0000000000000000, "Current State of Port B LLP" ],
   "LINK_RCV_FSM_STATE"           => [   2,   4,   6, 0x00000000000003F0, 0x00, 0, 0x0000000000000000, "Current State of Port B LLP" ],
   "LINK_RESET_STATE"             => [   3,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Current State of Port B LLP" ],
);

%nl4rtr_01_00136_def =
( NAME    => "R4_PORTB_LLP_STATE",
  ADDRESS => 0x0000000009001898,
  NOTE    => "The PORTB_LLP_STATE register allows software to monitor the state note of the Port B LLP.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00136_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_LLP_ERR1                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00137_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RETRY_COUNT"                  => [   0,  48,  16, 0xFFFF000000000000, 0x00, 1, 0x0000000000000000, "Retry Count" ],
   "RX_CB_ERR_COUNT"              => [   1,  16,  32, 0x0000FFFFFFFF0000, 0x00, 1, 0x0000000000000000, "CRC Error Count" ],
   "RX_SN_ERR_COUNT"              => [   2,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "Sequence Number Error Count" ],
);

%nl4rtr_01_00137_def =
( NAME    => "R4_PORTB_LLP_ERR1",
  ADDRESS => 0x00000000090018a0,
  NOTE    => "The PORTB_LLP_ERR1 register stores detail error and status note information pertaining to errors detected by the Port B LLP.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00137_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_LLP_ERR2                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00138_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CORESENTBADCRC_COUNT"         => [   1,  28,   6, 0x00000003F0000000, 0x00, 1, 0x0000000000000000, "Core Sent Bad CRC count" ],
   "SQUASH"                       => [   2,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "Squashed Micropacket" ],
   "RESET_TIMEOUT"                => [   3,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "Reset Timeout" ],
   "RETRY_TIMEOUT"                => [   4,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Retry Timeout" ],
   "WIRE_OVERFLOW"                => [   5,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Single-wire Error Counter Overflow" ],
   "WIRE_CNT"                     => [   6,   0,  24, 0x0000000000FFFFFF, 0x00, 1, 0x0000000000000000, "Single-wire Error Count" ],
);

%nl4rtr_01_00138_def =
( NAME    => "R4_PORTB_LLP_ERR2",
  ADDRESS => 0x00000000090018a8,
  NOTE    => "The PORTB_LLP_ERR2 register stores detail error status information note pertaining to errors detected by the Port B LLP.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00138_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_LLP_CAPT_WD1                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00139_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Captured Micropacket[63:0]" ],
);

%nl4rtr_01_00139_def =
( NAME    => "R4_PORTB_LLP_CAPT_WD1",
  ADDRESS => 0x00000000090018b0,
  NOTE    => "When the LLP micropacket capture circuitry is activated via the note ARMCAPTURE bit of the PORTB_LLP_TEST_CTL register, the note",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00139_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_LLP_CAPT_WD2                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00140_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Captured Micropacket[127:64]" ],
);

%nl4rtr_01_00140_def =
( NAME    => "R4_PORTB_LLP_CAPT_WD2",
  ADDRESS => 0x00000000090018b8,
  NOTE    => "When the LLP micropacket capture circuitry is activated via the note ARMCAPTURE bit of the PORTB_LLP_TEST_CTL register, the note",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00140_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_LLP_CAPT_SBCB                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00141_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FAKED_ALL_SN_ERRORS"          => [   1,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "All Faked Sequence Number Errors have been Sent" ],
   "SENT_ALL_SN_ERRORS"           => [   2,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "All Sequence Number Errors have been sent" ],
   "SENT_ALL_CB_ERRORS"           => [   3,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "All CRC Errors have been Sent" ],
   "CAPTURED_RCV_CRC"             => [   4,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "Captured CRC" ],
   "CAPTURED_RCVSBSN"             => [   5,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Captured Sideband and Sequence Number" ],
);

%nl4rtr_01_00141_def =
( NAME    => "R4_PORTB_LLP_CAPT_SBCB",
  ADDRESS => 0x00000000090018c0,
  NOTE    => "When the PORTB LLP micropacket capture circuitry is activated via note the ARMCAPTURE bit of the PORTB_LLP_TEST_CTL register, th",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00141_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_CREDIT                                                      #
#                                                                        #
##########################################################################

%nl4rtr_01_00142_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_LIMIT_VCH3"              => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RSVD1"                        => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_LIMIT_VCH2"              => [   3,  48,   7, 0x007F000000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RSVD2"                        => [   4,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_LIMIT_VCH1"              => [   5,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RSVD3"                        => [   6,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_LIMIT_VCH0"              => [   7,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "RSVD4"                        => [   8,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RCV_INITIAL_VCH3"             => [   9,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RSVD5"                        => [  10,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RCV_INITIAL_VCH2"             => [  11,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RSVD6"                        => [  12,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RCV_INITIAL_VCH1"             => [  13,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RCV_INITIAL_VCH0"             => [  15,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "VCh0" ],
);

%nl4rtr_01_00142_def =
( NAME    => "R4_PORTB_CREDIT",
  ADDRESS => 0x00000000090018c8,
  NOTE    => "This register powers up to an unknown state and is not reset. It note must be written prior to channel reset.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00142_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_DEBIT                                                       #
#                                                                        #
##########################################################################

%nl4rtr_01_00143_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  37,  27, 0xFFFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EN_SHORT_INTERVAL"            => [   1,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Enable Short Credit Only Interval" ],
   "EN_XMITBUF_THRESHOLD"         => [   2,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "Enable Transmit Buffer Threshold" ],
   "CREDIT_ONLY_INTERVAL"         => [   3,  32,   3, 0x0000000700000000, 0x00, 1, 0x0000000000000000, "Credit Only Packet Interval" ],
   "RSVD1"                        => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FORCE_DEBIT_VCH3"             => [   5,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "WITHHOLD_VCH3"                => [   6,  24,   6, 0x000000003F000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "RSVD2"                        => [   7,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FORCE_DEBIT_VCH2"             => [   8,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "WITHHOLD_VCH2"                => [   9,  16,   6, 0x00000000003F0000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "RSVD3"                        => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FORCE_DEBIT_VCH1"             => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "WITHHOLD_VCH1"                => [  12,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "RSVD4"                        => [  13,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FORCE_DEBIT_VCH0"             => [  14,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "WITHHOLD_VCH0"                => [  15,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VCh0" ],
);

%nl4rtr_01_00143_def =
( NAME    => "R4_PORTB_DEBIT",
  ADDRESS => 0x00000000090018d0,
  NOTE    => "This register allows diagnostic control of the debit counters. The note debit counters are used to track the debits (credits at ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00143_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_CREDIT_STATE                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00144_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CREDITS_VCH3"                 => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "CREDITS_VCH2"                 => [   1,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "CREDITS_VCH1"                 => [   2,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "CREDITS_VCH0"                 => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "RSVD0"                        => [   4,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBITS_VCH3"                  => [   5,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RSVD1"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBITS_VCH2"                  => [   7,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RSVD2"                        => [   8,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBITS_VCH1"                  => [   9,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RSVD3"                        => [  10,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBITS_VCH0"                  => [  11,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "VCh0" ],
);

%nl4rtr_01_00144_def =
( NAME    => "R4_PORTB_CREDIT_STATE",
  ADDRESS => 0x00000000090018d8,
  NOTE    => "This register is observing the state of the Debit and Credit note counters for each virtual channel. This register is for diagno",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00144_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_LLP_PKT                                                     #
#                                                                        #
##########################################################################

%nl4rtr_01_00145_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Micropacket Count" ],
);

%nl4rtr_01_00145_def =
( NAME    => "R4_PORTB_LLP_PKT",
  ADDRESS => 0x00000000090018e0,
  NOTE    => "This register counts DataValid pulses from the PFSSR. Each note DataValid pulse represents two micropackets.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00145_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_LOCAL_TABLE                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00146_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR0"                         => [   2,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Direction" ],
);

%nl4rtr_01_00146_def =
( NAME    => "R4_PORTC_LOCAL_TABLE",
  ADDRESS => 0x000000000a000000,
  NOTE    => "LOCAL_TABLE represents a set of 512 registers which constitute the note Local Look-up Table for the input port. The LOCAL_TABLE ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00146_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_GLOBAL_TABLE                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00147_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR0"                         => [   2,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Direction" ],
);

%nl4rtr_01_00147_def =
( NAME    => "R4_PORTC_GLOBAL_TABLE",
  ADDRESS => 0x000000000a001000,
  NOTE    => "GLOBAL_TABLE represents a set of 256 registers which constitute the note Global Look-up Table for the input port. The GLOBAL_TAB",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00147_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_NEIGHBOR_TABLE                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00148_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,  14,  49, 0x7FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NEIGHBOR_ID"                  => [   2,   0,  14, 0x0000000000003FFF, 0x00, 0, 0x0000000000000000, "Neighbor Node ID" ],
);

%nl4rtr_01_00148_def =
( NAME    => "R4_PORTC_NEIGHBOR_TABLE",
  ADDRESS => 0x000000000a001800,
  NOTE    => "NEIGHBOR_TABLE represents a set of 8 registers which constitute the note Neighbor Look-up Table for the input port. The NEIGHBOR",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00148_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PARMS                                                       #
#                                                                        #
##########################################################################

%nl4rtr_01_00149_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SPARE"                        => [   1,  30,   8, 0x0000003FC0000000, 0x00, 1, 0x0000000000000000, "" ],
   "V_BIT_EMULATION"              => [   2,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "" ],
   "NEW_DIR_SPRAY_ENABLE"         => [   3,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "" ],
   "DIR_SPRAY_ENABLE"             => [   4,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "" ],
   "EXTEND_ENABLE"                => [   5,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "" ],
   "EXTEND_SHUB_INPUT"            => [   6,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "" ],
   "EXTEND_SHUB_DIR_VEC"          => [   7,  17,   8, 0x0000000001FE0000, 0x00, 1, 0x0000000000000000, "" ],
   "ARM_FORCE_CB_ERROR"           => [   8,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Arm Forcing of a Checkbyte Error" ],
   "LINKRESET_ON_BUFFEROVERFLOW"  => [   9,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Enable Link Reset On Buffer Overflow" ],
   "EATUNTILTAIL_ON_BUFFEROVERFLOW" => [  10,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Eat Until Tail On Buffer Overflow" ],
   "LINKRESET_ON_FIFOOVERFLOW"    => [  11,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Enable Link Reset On Fifo Overflow" ],
   "SEND_DEADLOCK_EAT_ENABLE_VCH3" => [  12,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "SEND_DEADLOCK_EAT_ENABLE_VCH2" => [  13,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "SEND_DEADLOCK_EAT_ENABLE_VCH1" => [  14,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "SEND_DEADLOCK_EAT_ENABLE_VCH0" => [  15,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "TAIL_TO_ERROR_TAIL_ENABLE_VCH3" => [  16,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "TAIL_TO_ERROR_TAIL_ENABLE_VCH2" => [  17,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "TAIL_TO_ERROR_TAIL_ENABLE_VCH1" => [  18,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "TAIL_TO_ERROR_TAIL_ENABLE_VCH0" => [  19,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "MIP_RESET_ENABLE"             => [  20,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Message-In-Progess Reset Enable" ],
   "SEND_DEADLOCK_TO_VAL"         => [  21,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Port Output Deadlock Timeout Value" ],
);

%nl4rtr_01_00149_def =
( NAME    => "R4_PORTC_PARMS",
  ADDRESS => 0x000000000a001840,
  NOTE    => "The PORT_PARMS register for a port. This register contains note port-specific LLP parameters.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00149_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_SPRAY_DIR                                                   #
#                                                                        #
##########################################################################

%nl4rtr_01_00150_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DIR7"                         => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 7" ],
   "DIR6"                         => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 6" ],
   "DIR5"                         => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 5" ],
   "DIR4"                         => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 4" ],
   "DIR3"                         => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 3" ],
   "DIR2"                         => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 2" ],
   "DIR1"                         => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 1" ],
);

%nl4rtr_01_00150_def =
( NAME    => "R4_PORTC_SPRAY_DIR",
  ADDRESS => 0x000000000a001848,
  NOTE    => "The PORT_SPRAY_DIR register for a port. This register contains note alternate direction information for distributed (i.e. spraye",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00150_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_SPRAY_CMD_3F_0                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00151_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Masks out commands to disable them from spraying" ],
);

%nl4rtr_01_00151_def =
( NAME    => "R4_PORTC_SPRAY_CMD_3F_0",
  ADDRESS => 0x000000000a001850,
  NOTE    => "The PORT_SPRAY_CMD_3f_0 register for each port masks off any of the note commands encodings from 0x0 to 0x3f and makes them non-",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00151_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_SPRAY_CMD_7F_40                                             #
#                                                                        #
##########################################################################

%nl4rtr_01_00152_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Masks out commands 0x40 to 0x7f to disable them from spraying" ],
);

%nl4rtr_01_00152_def =
( NAME    => "R4_PORTC_SPRAY_CMD_7F_40",
  ADDRESS => 0x000000000a001858,
  NOTE    => "The PORT_SPRAY_CMD_7f_40 register for each port masks off any of note the commands encodings from 0x40 to 0x7f and makes them no",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00152_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_SPRAY_CMD_BF_80                                             #
#                                                                        #
##########################################################################

%nl4rtr_01_00153_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Masks out commands 0x80 to 0xbf to disable them from spraying" ],
);

%nl4rtr_01_00153_def =
( NAME    => "R4_PORTC_SPRAY_CMD_BF_80",
  ADDRESS => 0x000000000a001860,
  NOTE    => "The PORT_SPRAY_CMD_bf_80 register for each port masks off any of note the commands encodings from 0x80 to 0xbf and makes them no",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00153_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_SPRAY_CMD_FF_C0                                             #
#                                                                        #
##########################################################################

%nl4rtr_01_00154_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Masks out commands 0xc0 to 0xff to disable them from spraying" ],
);

%nl4rtr_01_00154_def =
( NAME    => "R4_PORTC_SPRAY_CMD_FF_C0",
  ADDRESS => 0x000000000a001868,
  NOTE    => "The PORT_SPRAY_CMD_ff_c0 register for each port masks off any of note the commands encodings from 0xc0 to 0xff and makes them no",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00154_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_LLP_CONFIG                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00155_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_RMT_FT_UPD"            => [   1,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Enable Remote Fine-tuning Updates" ],
   "ENABLE_TUNING"                => [   2,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Enable Tuning" ],
   "AC_ENCODE"                    => [   3,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "DC Encoding Disabled" ],
   "ENABLELINK"                   => [   4,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Enable Link" ],
   "BITMODE32"                    => [   5,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "32-bit Mode Enabled" ],
);

%nl4rtr_01_00155_def =
( NAME    => "R4_PORTC_LLP_CONFIG",
  ADDRESS => 0x000000000a001888,
  NOTE    => "Port Parameters",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00155_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_LLP_TEST_CTL                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00156_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CB_ERROR"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Captured Micropacket Contained a CRC Error" ],
   "CAPTURED"                     => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "Micropacket Captured" ],
   "FAKESNERROR"                  => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "Inject a Sequence Number Error at the Receiver" ],
   "SEND_SN_ERROR"                => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Inject a Sequence Number Error" ],
   "SEND_CB_ERROR"                => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "Inject a CRC Error" ],
   "CAPTURE_CB_ONLY"              => [   6,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "Capture CRC Errors Only" ],
   "ARM_CAPTURE"                  => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "Arm Micropacket Capture Logic" ],
   "NOISE_MODE"                   => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Noise Mode" ],
   "LFSR_MODE"                    => [   9,  52,   2, 0x0030000000000000, 0x00, 0, 0x0000000000000000, "LFSR Mode" ],
   "RSVD1"                        => [  10,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WIRE_SEL"                     => [  11,  44,   6, 0x0003F00000000000, 0x00, 1, 0x0000000000000000, "Wire Select" ],
   "RSVD2"                        => [  12,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_TEST_MODE"               => [  13,  40,   2, 0x0000030000000000, 0x00, 1, 0x0000000000000000, "Send Test Mode" ],
   "PATTERN"                      => [  14,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Send Channel Seed Data Pattern" ],
);

%nl4rtr_01_00156_def =
( NAME    => "R4_PORTC_LLP_TEST_CTL",
  ADDRESS => 0x000000000a001890,
  NOTE    => "The PORT_LLP_TEST_CTL register controls LLP testing. The links may note be tested either online or offline. That is, errors may ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00156_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_LLP_STATE                                                   #
#                                                                        #
##########################################################################

%nl4rtr_01_00157_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LINK_SEND_FSM_STATE"          => [   1,  10,   6, 0x000000000000FC00, 0x00, 0, 0x0000000000000000, "Current State of Port C LLP" ],
   "LINK_RCV_FSM_STATE"           => [   2,   4,   6, 0x00000000000003F0, 0x00, 0, 0x0000000000000000, "Current State of Port C LLP" ],
   "LINK_RESET_STATE"             => [   3,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Current State of Port C LLP" ],
);

%nl4rtr_01_00157_def =
( NAME    => "R4_PORTC_LLP_STATE",
  ADDRESS => 0x000000000a001898,
  NOTE    => "The PORTC_LLP_STATE register allows software to monitor the state note of the Port C LLP.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00157_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_LLP_ERR1                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00158_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RETRY_COUNT"                  => [   0,  48,  16, 0xFFFF000000000000, 0x00, 1, 0x0000000000000000, "Retry Count" ],
   "RX_CB_ERR_COUNT"              => [   1,  16,  32, 0x0000FFFFFFFF0000, 0x00, 1, 0x0000000000000000, "CRC Error Count" ],
   "RX_SN_ERR_COUNT"              => [   2,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "Sequence Number Error Count" ],
);

%nl4rtr_01_00158_def =
( NAME    => "R4_PORTC_LLP_ERR1",
  ADDRESS => 0x000000000a0018a0,
  NOTE    => "The PORTC_LLP_ERR1 register stores detail error and status note information pertaining to errors detected by the Port C LLP.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00158_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_LLP_ERR2                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00159_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CORESENTBADCRC_COUNT"         => [   1,  28,   6, 0x00000003F0000000, 0x00, 1, 0x0000000000000000, "Core Sent Bad CRC count" ],
   "SQUASH"                       => [   2,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "Squashed Micropacket" ],
   "RESET_TIMEOUT"                => [   3,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "Reset Timeout" ],
   "RETRY_TIMEOUT"                => [   4,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Retry Timeout" ],
   "WIRE_OVERFLOW"                => [   5,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Single-wire Error Counter Overflow" ],
   "WIRE_CNT"                     => [   6,   0,  24, 0x0000000000FFFFFF, 0x00, 1, 0x0000000000000000, "Single-wire Error Count" ],
);

%nl4rtr_01_00159_def =
( NAME    => "R4_PORTC_LLP_ERR2",
  ADDRESS => 0x000000000a0018a8,
  NOTE    => "The PORTC_LLP_ERR2 register stores detail error status information note pertaining to errors detected by the Port C LLP.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00159_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_LLP_CAPT_WD1                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00160_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Captured Micropacket[63:0]" ],
);

%nl4rtr_01_00160_def =
( NAME    => "R4_PORTC_LLP_CAPT_WD1",
  ADDRESS => 0x000000000a0018b0,
  NOTE    => "When the LLP micropacket capture circuitry is activated via the note ARMCAPTURE bit of the PORTC_LLP_TEST_CTL register, the note",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00160_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_LLP_CAPT_WD2                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00161_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Captured Micropacket[127:64]" ],
);

%nl4rtr_01_00161_def =
( NAME    => "R4_PORTC_LLP_CAPT_WD2",
  ADDRESS => 0x000000000a0018b8,
  NOTE    => "When the LLP micropacket capture circuitry is activated via the note ARMCAPTURE bit of the PORTC_LLP_TEST_CTL register, the note",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00161_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_LLP_CAPT_SBCB                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00162_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FAKED_ALL_SN_ERRORS"          => [   1,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "All Faked Sequence Number Errors have been Sent" ],
   "SENT_ALL_SN_ERRORS"           => [   2,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "All Sequence Number Errors have been sent" ],
   "SENT_ALL_CB_ERRORS"           => [   3,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "All CRC Errors have been Sent" ],
   "CAPTURED_RCV_CRC"             => [   4,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "Captured CRC" ],
   "CAPTURED_RCVSBSN"             => [   5,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Captured Sideband and Sequence Number" ],
);

%nl4rtr_01_00162_def =
( NAME    => "R4_PORTC_LLP_CAPT_SBCB",
  ADDRESS => 0x000000000a0018c0,
  NOTE    => "When the PORTC LLP micropacket capture circuitry is activated via note the ARMCAPTURE bit of the PORTC_LLP_TEST_CTL register, th",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00162_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_CREDIT                                                      #
#                                                                        #
##########################################################################

%nl4rtr_01_00163_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_LIMIT_VCH3"              => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RSVD1"                        => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_LIMIT_VCH2"              => [   3,  48,   7, 0x007F000000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RSVD2"                        => [   4,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_LIMIT_VCH1"              => [   5,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RSVD3"                        => [   6,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_LIMIT_VCH0"              => [   7,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "RSVD4"                        => [   8,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RCV_INITIAL_VCH3"             => [   9,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RSVD5"                        => [  10,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RCV_INITIAL_VCH2"             => [  11,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RSVD6"                        => [  12,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RCV_INITIAL_VCH1"             => [  13,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RCV_INITIAL_VCH0"             => [  15,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "VCh0" ],
);

%nl4rtr_01_00163_def =
( NAME    => "R4_PORTC_CREDIT",
  ADDRESS => 0x000000000a0018c8,
  NOTE    => "This register powers up to an unknown state and is not reset. It note must be written prior to channel reset.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00163_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_DEBIT                                                       #
#                                                                        #
##########################################################################

%nl4rtr_01_00164_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  37,  27, 0xFFFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EN_SHORT_INTERVAL"            => [   1,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Enable Short Credit Only Interval" ],
   "EN_XMITBUF_THRESHOLD"         => [   2,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "Enable Transmit Buffer Threshold" ],
   "CREDIT_ONLY_INTERVAL"         => [   3,  32,   3, 0x0000000700000000, 0x00, 1, 0x0000000000000000, "Credit Only Packet Interval" ],
   "RSVD1"                        => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FORCE_DEBIT_VCH3"             => [   5,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "WITHHOLD_VCH3"                => [   6,  24,   6, 0x000000003F000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "RSVD2"                        => [   7,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FORCE_DEBIT_VCH2"             => [   8,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "WITHHOLD_VCH2"                => [   9,  16,   6, 0x00000000003F0000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "RSVD3"                        => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FORCE_DEBIT_VCH1"             => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "WITHHOLD_VCH1"                => [  12,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "RSVD4"                        => [  13,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FORCE_DEBIT_VCH0"             => [  14,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "WITHHOLD_VCH0"                => [  15,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VCh0" ],
);

%nl4rtr_01_00164_def =
( NAME    => "R4_PORTC_DEBIT",
  ADDRESS => 0x000000000a0018d0,
  NOTE    => "This register allows diagnostic control of the debit counters. The note debit counters are used to track the debits (credits at ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00164_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_CREDIT_STATE                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00165_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CREDITS_VCH3"                 => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "CREDITS_VCH2"                 => [   1,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "CREDITS_VCH1"                 => [   2,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "CREDITS_VCH0"                 => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "RSVD0"                        => [   4,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBITS_VCH3"                  => [   5,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RSVD1"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBITS_VCH2"                  => [   7,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RSVD2"                        => [   8,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBITS_VCH1"                  => [   9,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RSVD3"                        => [  10,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBITS_VCH0"                  => [  11,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "VCh0" ],
);

%nl4rtr_01_00165_def =
( NAME    => "R4_PORTC_CREDIT_STATE",
  ADDRESS => 0x000000000a0018d8,
  NOTE    => "This register is observing the state of the Debit and Credit note counters for each virtual channel. This register is for diagno",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00165_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_LLP_PKT                                                     #
#                                                                        #
##########################################################################

%nl4rtr_01_00166_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Micropacket Count" ],
);

%nl4rtr_01_00166_def =
( NAME    => "R4_PORTC_LLP_PKT",
  ADDRESS => 0x000000000a0018e0,
  NOTE    => "This register counts DataValid pulses from the PFSSR. Each note DataValid pulse represents two micropackets.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00166_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_LOCAL_TABLE                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00167_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR0"                         => [   2,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Direction" ],
);

%nl4rtr_01_00167_def =
( NAME    => "R4_PORTD_LOCAL_TABLE",
  ADDRESS => 0x000000000b000000,
  NOTE    => "LOCAL_TABLE represents a set of 512 registers which constitute the note Local Look-up Table for the input port. The LOCAL_TABLE ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00167_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_GLOBAL_TABLE                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00168_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR0"                         => [   2,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Direction" ],
);

%nl4rtr_01_00168_def =
( NAME    => "R4_PORTD_GLOBAL_TABLE",
  ADDRESS => 0x000000000b001000,
  NOTE    => "GLOBAL_TABLE represents a set of 256 registers which constitute the note Global Look-up Table for the input port. The GLOBAL_TAB",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00168_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_NEIGHBOR_TABLE                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00169_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,  14,  49, 0x7FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NEIGHBOR_ID"                  => [   2,   0,  14, 0x0000000000003FFF, 0x00, 0, 0x0000000000000000, "Neighbor Node ID" ],
);

%nl4rtr_01_00169_def =
( NAME    => "R4_PORTD_NEIGHBOR_TABLE",
  ADDRESS => 0x000000000b001800,
  NOTE    => "NEIGHBOR_TABLE represents a set of 8 registers which constitute the note Neighbor Look-up Table for the input port. The NEIGHBOR",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00169_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PARMS                                                       #
#                                                                        #
##########################################################################

%nl4rtr_01_00170_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SPARE"                        => [   1,  30,   8, 0x0000003FC0000000, 0x00, 1, 0x0000000000000000, "" ],
   "V_BIT_EMULATION"              => [   2,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "" ],
   "NEW_DIR_SPRAY_ENABLE"         => [   3,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "" ],
   "DIR_SPRAY_ENABLE"             => [   4,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "" ],
   "EXTEND_ENABLE"                => [   5,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "" ],
   "EXTEND_SHUB_INPUT"            => [   6,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "" ],
   "EXTEND_SHUB_DIR_VEC"          => [   7,  17,   8, 0x0000000001FE0000, 0x00, 1, 0x0000000000000000, "" ],
   "ARM_FORCE_CB_ERROR"           => [   8,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Arm Forcing of a Checkbyte Error" ],
   "LINKRESET_ON_BUFFEROVERFLOW"  => [   9,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Enable Link Reset On Buffer Overflow" ],
   "EATUNTILTAIL_ON_BUFFEROVERFLOW" => [  10,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Eat Until Tail On Buffer Overflow" ],
   "LINKRESET_ON_FIFOOVERFLOW"    => [  11,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Enable Link Reset On Fifo Overflow" ],
   "SEND_DEADLOCK_EAT_ENABLE_VCH3" => [  12,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "SEND_DEADLOCK_EAT_ENABLE_VCH2" => [  13,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "SEND_DEADLOCK_EAT_ENABLE_VCH1" => [  14,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "SEND_DEADLOCK_EAT_ENABLE_VCH0" => [  15,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "TAIL_TO_ERROR_TAIL_ENABLE_VCH3" => [  16,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "TAIL_TO_ERROR_TAIL_ENABLE_VCH2" => [  17,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "TAIL_TO_ERROR_TAIL_ENABLE_VCH1" => [  18,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "TAIL_TO_ERROR_TAIL_ENABLE_VCH0" => [  19,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "MIP_RESET_ENABLE"             => [  20,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Message-In-Progess Reset Enable" ],
   "SEND_DEADLOCK_TO_VAL"         => [  21,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Port Output Deadlock Timeout Value" ],
);

%nl4rtr_01_00170_def =
( NAME    => "R4_PORTD_PARMS",
  ADDRESS => 0x000000000b001840,
  NOTE    => "The PORT_PARMS register for a port. This register contains note port-specific LLP parameters.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00170_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_SPRAY_DIR                                                   #
#                                                                        #
##########################################################################

%nl4rtr_01_00171_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DIR7"                         => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 7" ],
   "DIR6"                         => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 6" ],
   "DIR5"                         => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 5" ],
   "DIR4"                         => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 4" ],
   "DIR3"                         => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 3" ],
   "DIR2"                         => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 2" ],
   "DIR1"                         => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 1" ],
);

%nl4rtr_01_00171_def =
( NAME    => "R4_PORTD_SPRAY_DIR",
  ADDRESS => 0x000000000b001848,
  NOTE    => "The PORT_SPRAY_DIR register for a port. This register contains note alternate direction information for distributed (i.e. spraye",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00171_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_SPRAY_CMD_3F_0                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00172_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Masks out commands to disable them from spraying" ],
);

%nl4rtr_01_00172_def =
( NAME    => "R4_PORTD_SPRAY_CMD_3F_0",
  ADDRESS => 0x000000000b001850,
  NOTE    => "The PORT_SPRAY_CMD_3f_0 register for each port masks off any of the note commands encodings from 0x0 to 0x3f and makes them non-",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00172_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_SPRAY_CMD_7F_40                                             #
#                                                                        #
##########################################################################

%nl4rtr_01_00173_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Masks out commands 0x40 to 0x7f to disable them from spraying" ],
);

%nl4rtr_01_00173_def =
( NAME    => "R4_PORTD_SPRAY_CMD_7F_40",
  ADDRESS => 0x000000000b001858,
  NOTE    => "The PORT_SPRAY_CMD_7f_40 register for each port masks off any of note the commands encodings from 0x40 to 0x7f and makes them no",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00173_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_SPRAY_CMD_BF_80                                             #
#                                                                        #
##########################################################################

%nl4rtr_01_00174_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Masks out commands 0x80 to 0xbf to disable them from spraying" ],
);

%nl4rtr_01_00174_def =
( NAME    => "R4_PORTD_SPRAY_CMD_BF_80",
  ADDRESS => 0x000000000b001860,
  NOTE    => "The PORT_SPRAY_CMD_bf_80 register for each port masks off any of note the commands encodings from 0x80 to 0xbf and makes them no",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00174_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_SPRAY_CMD_FF_C0                                             #
#                                                                        #
##########################################################################

%nl4rtr_01_00175_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Masks out commands 0xc0 to 0xff to disable them from spraying" ],
);

%nl4rtr_01_00175_def =
( NAME    => "R4_PORTD_SPRAY_CMD_FF_C0",
  ADDRESS => 0x000000000b001868,
  NOTE    => "The PORT_SPRAY_CMD_ff_c0 register for each port masks off any of note the commands encodings from 0xc0 to 0xff and makes them no",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00175_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_LLP_CONFIG                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00176_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_RMT_FT_UPD"            => [   1,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Enable Remote Fine-tuning Updates" ],
   "ENABLE_TUNING"                => [   2,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Enable Tuning" ],
   "AC_ENCODE"                    => [   3,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "DC Encoding Disabled" ],
   "ENABLELINK"                   => [   4,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Enable Link" ],
   "BITMODE32"                    => [   5,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "32-bit Mode Enabled" ],
);

%nl4rtr_01_00176_def =
( NAME    => "R4_PORTD_LLP_CONFIG",
  ADDRESS => 0x000000000b001888,
  NOTE    => "Port Parameters",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00176_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_LLP_TEST_CTL                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00177_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CB_ERROR"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Captured Micropacket Contained a CRC Error" ],
   "CAPTURED"                     => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "Micropacket Captured" ],
   "FAKESNERROR"                  => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "Inject a Sequence Number Error at the Receiver" ],
   "SEND_SN_ERROR"                => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Inject a Sequence Number Error" ],
   "SEND_CB_ERROR"                => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "Inject a CRC Error" ],
   "CAPTURE_CB_ONLY"              => [   6,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "Capture CRC Errors Only" ],
   "ARM_CAPTURE"                  => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "Arm Micropacket Capture Logic" ],
   "NOISE_MODE"                   => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Noise Mode" ],
   "LFSR_MODE"                    => [   9,  52,   2, 0x0030000000000000, 0x00, 0, 0x0000000000000000, "LFSR Mode" ],
   "RSVD1"                        => [  10,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WIRE_SEL"                     => [  11,  44,   6, 0x0003F00000000000, 0x00, 1, 0x0000000000000000, "Wire Select" ],
   "RSVD2"                        => [  12,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_TEST_MODE"               => [  13,  40,   2, 0x0000030000000000, 0x00, 1, 0x0000000000000000, "Send Test Mode" ],
   "PATTERN"                      => [  14,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Send Channel Seed Data Pattern" ],
);

%nl4rtr_01_00177_def =
( NAME    => "R4_PORTD_LLP_TEST_CTL",
  ADDRESS => 0x000000000b001890,
  NOTE    => "The PORT_LLP_TEST_CTL register controls LLP testing. The links may note be tested either online or offline. That is, errors may ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00177_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_LLP_STATE                                                   #
#                                                                        #
##########################################################################

%nl4rtr_01_00178_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LINK_SEND_FSM_STATE"          => [   1,  10,   6, 0x000000000000FC00, 0x00, 0, 0x0000000000000000, "Current State of Port D LLP" ],
   "LINK_RCV_FSM_STATE"           => [   2,   4,   6, 0x00000000000003F0, 0x00, 0, 0x0000000000000000, "Current State of Port D LLP" ],
   "LINK_RESET_STATE"             => [   3,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Current State of Port D LLP" ],
);

%nl4rtr_01_00178_def =
( NAME    => "R4_PORTD_LLP_STATE",
  ADDRESS => 0x000000000b001898,
  NOTE    => "The PORTD_LLP_STATE register allows software to monitor the state note of the Port D LLP.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00178_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_LLP_ERR1                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00179_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RETRY_COUNT"                  => [   0,  48,  16, 0xFFFF000000000000, 0x00, 1, 0x0000000000000000, "Retry Count" ],
   "RX_CB_ERR_COUNT"              => [   1,  16,  32, 0x0000FFFFFFFF0000, 0x00, 1, 0x0000000000000000, "CRC Error Count" ],
   "RX_SN_ERR_COUNT"              => [   2,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "Sequence Number Error Count" ],
);

%nl4rtr_01_00179_def =
( NAME    => "R4_PORTD_LLP_ERR1",
  ADDRESS => 0x000000000b0018a0,
  NOTE    => "The PORTD_LLP_ERR1 register stores detail error and status note information pertaining to errors detected by the Port D LLP.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00179_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_LLP_ERR2                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00180_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CORESENTBADCRC_COUNT"         => [   1,  28,   6, 0x00000003F0000000, 0x00, 1, 0x0000000000000000, "Core Sent Bad CRC count" ],
   "SQUASH"                       => [   2,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "Squashed Micropacket" ],
   "RESET_TIMEOUT"                => [   3,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "Reset Timeout" ],
   "RETRY_TIMEOUT"                => [   4,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Retry Timeout" ],
   "WIRE_OVERFLOW"                => [   5,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Single-wire Error Counter Overflow" ],
   "WIRE_CNT"                     => [   6,   0,  24, 0x0000000000FFFFFF, 0x00, 1, 0x0000000000000000, "Single-wire Error Count" ],
);

%nl4rtr_01_00180_def =
( NAME    => "R4_PORTD_LLP_ERR2",
  ADDRESS => 0x000000000b0018a8,
  NOTE    => "The PORTD_LLP_ERR2 register stores detail error status information note pertaining to errors detected by the Port D LLP.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00180_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_LLP_CAPT_WD1                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00181_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Captured Micropacket[63:0]" ],
);

%nl4rtr_01_00181_def =
( NAME    => "R4_PORTD_LLP_CAPT_WD1",
  ADDRESS => 0x000000000b0018b0,
  NOTE    => "When the LLP micropacket capture circuitry is activated via the note ARMCAPTURE bit of the PORTD_LLP_TEST_CTL register, the note",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00181_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_LLP_CAPT_WD2                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00182_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Captured Micropacket[127:64]" ],
);

%nl4rtr_01_00182_def =
( NAME    => "R4_PORTD_LLP_CAPT_WD2",
  ADDRESS => 0x000000000b0018b8,
  NOTE    => "When the LLP micropacket capture circuitry is activated via the note ARMCAPTURE bit of the PORTD_LLP_TEST_CTL register, the note",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00182_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_LLP_CAPT_SBCB                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00183_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FAKED_ALL_SN_ERRORS"          => [   1,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "All Faked Sequence Number Errors have been Sent" ],
   "SENT_ALL_SN_ERRORS"           => [   2,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "All Sequence Number Errors have been sent" ],
   "SENT_ALL_CB_ERRORS"           => [   3,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "All CRC Errors have been Sent" ],
   "CAPTURED_RCV_CRC"             => [   4,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "Captured CRC" ],
   "CAPTURED_RCVSBSN"             => [   5,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Captured Sideband and Sequence Number" ],
);

%nl4rtr_01_00183_def =
( NAME    => "R4_PORTD_LLP_CAPT_SBCB",
  ADDRESS => 0x000000000b0018c0,
  NOTE    => "When the PORTD LLP micropacket capture circuitry is activated via note the ARMCAPTURE bit of the PORTD_LLP_TEST_CTL register, th",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00183_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_CREDIT                                                      #
#                                                                        #
##########################################################################

%nl4rtr_01_00184_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_LIMIT_VCH3"              => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RSVD1"                        => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_LIMIT_VCH2"              => [   3,  48,   7, 0x007F000000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RSVD2"                        => [   4,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_LIMIT_VCH1"              => [   5,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RSVD3"                        => [   6,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_LIMIT_VCH0"              => [   7,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "RSVD4"                        => [   8,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RCV_INITIAL_VCH3"             => [   9,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RSVD5"                        => [  10,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RCV_INITIAL_VCH2"             => [  11,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RSVD6"                        => [  12,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RCV_INITIAL_VCH1"             => [  13,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RCV_INITIAL_VCH0"             => [  15,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "VCh0" ],
);

%nl4rtr_01_00184_def =
( NAME    => "R4_PORTD_CREDIT",
  ADDRESS => 0x000000000b0018c8,
  NOTE    => "This register powers up to an unknown state and is not reset. It note must be written prior to channel reset.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00184_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_DEBIT                                                       #
#                                                                        #
##########################################################################

%nl4rtr_01_00185_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  37,  27, 0xFFFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EN_SHORT_INTERVAL"            => [   1,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Enable Short Credit Only Interval" ],
   "EN_XMITBUF_THRESHOLD"         => [   2,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "Enable Transmit Buffer Threshold" ],
   "CREDIT_ONLY_INTERVAL"         => [   3,  32,   3, 0x0000000700000000, 0x00, 1, 0x0000000000000000, "Credit Only Packet Interval" ],
   "RSVD1"                        => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FORCE_DEBIT_VCH3"             => [   5,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "WITHHOLD_VCH3"                => [   6,  24,   6, 0x000000003F000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "RSVD2"                        => [   7,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FORCE_DEBIT_VCH2"             => [   8,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "WITHHOLD_VCH2"                => [   9,  16,   6, 0x00000000003F0000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "RSVD3"                        => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FORCE_DEBIT_VCH1"             => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "WITHHOLD_VCH1"                => [  12,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "RSVD4"                        => [  13,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FORCE_DEBIT_VCH0"             => [  14,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "WITHHOLD_VCH0"                => [  15,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VCh0" ],
);

%nl4rtr_01_00185_def =
( NAME    => "R4_PORTD_DEBIT",
  ADDRESS => 0x000000000b0018d0,
  NOTE    => "This register allows diagnostic control of the debit counters. The note debit counters are used to track the debits (credits at ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00185_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_CREDIT_STATE                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00186_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CREDITS_VCH3"                 => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "CREDITS_VCH2"                 => [   1,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "CREDITS_VCH1"                 => [   2,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "CREDITS_VCH0"                 => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "RSVD0"                        => [   4,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBITS_VCH3"                  => [   5,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RSVD1"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBITS_VCH2"                  => [   7,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RSVD2"                        => [   8,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBITS_VCH1"                  => [   9,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RSVD3"                        => [  10,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBITS_VCH0"                  => [  11,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "VCh0" ],
);

%nl4rtr_01_00186_def =
( NAME    => "R4_PORTD_CREDIT_STATE",
  ADDRESS => 0x000000000b0018d8,
  NOTE    => "This register is observing the state of the Debit and Credit note counters for each virtual channel. This register is for diagno",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00186_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_LLP_PKT                                                     #
#                                                                        #
##########################################################################

%nl4rtr_01_00187_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Micropacket Count" ],
);

%nl4rtr_01_00187_def =
( NAME    => "R4_PORTD_LLP_PKT",
  ADDRESS => 0x000000000b0018e0,
  NOTE    => "This register counts DataValid pulses from the PFSSR. Each note DataValid pulse represents two micropackets.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00187_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_LOCAL_TABLE                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00188_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR0"                         => [   2,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Direction" ],
);

%nl4rtr_01_00188_def =
( NAME    => "R4_PORTE_LOCAL_TABLE",
  ADDRESS => 0x000000000c000000,
  NOTE    => "LOCAL_TABLE represents a set of 512 registers which constitute the note Local Look-up Table for the input port. The LOCAL_TABLE ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00188_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_GLOBAL_TABLE                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00189_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR0"                         => [   2,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Direction" ],
);

%nl4rtr_01_00189_def =
( NAME    => "R4_PORTE_GLOBAL_TABLE",
  ADDRESS => 0x000000000c001000,
  NOTE    => "GLOBAL_TABLE represents a set of 256 registers which constitute the note Global Look-up Table for the input port. The GLOBAL_TAB",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00189_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_NEIGHBOR_TABLE                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00190_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,  14,  49, 0x7FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NEIGHBOR_ID"                  => [   2,   0,  14, 0x0000000000003FFF, 0x00, 0, 0x0000000000000000, "Neighbor Node ID" ],
);

%nl4rtr_01_00190_def =
( NAME    => "R4_PORTE_NEIGHBOR_TABLE",
  ADDRESS => 0x000000000c001800,
  NOTE    => "NEIGHBOR_TABLE represents a set of 8 registers which constitute the note Neighbor Look-up Table for the input port. The NEIGHBOR",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00190_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PARMS                                                       #
#                                                                        #
##########################################################################

%nl4rtr_01_00191_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SPARE"                        => [   1,  30,   8, 0x0000003FC0000000, 0x00, 1, 0x0000000000000000, "" ],
   "V_BIT_EMULATION"              => [   2,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "" ],
   "NEW_DIR_SPRAY_ENABLE"         => [   3,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "" ],
   "DIR_SPRAY_ENABLE"             => [   4,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "" ],
   "EXTEND_ENABLE"                => [   5,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "" ],
   "EXTEND_SHUB_INPUT"            => [   6,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "" ],
   "EXTEND_SHUB_DIR_VEC"          => [   7,  17,   8, 0x0000000001FE0000, 0x00, 1, 0x0000000000000000, "" ],
   "ARM_FORCE_CB_ERROR"           => [   8,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Arm Forcing of a Checkbyte Error" ],
   "LINKRESET_ON_BUFFEROVERFLOW"  => [   9,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Enable Link Reset On Buffer Overflow" ],
   "EATUNTILTAIL_ON_BUFFEROVERFLOW" => [  10,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Eat Until Tail On Buffer Overflow" ],
   "LINKRESET_ON_FIFOOVERFLOW"    => [  11,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Enable Link Reset On Fifo Overflow" ],
   "SEND_DEADLOCK_EAT_ENABLE_VCH3" => [  12,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "SEND_DEADLOCK_EAT_ENABLE_VCH2" => [  13,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "SEND_DEADLOCK_EAT_ENABLE_VCH1" => [  14,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "SEND_DEADLOCK_EAT_ENABLE_VCH0" => [  15,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "TAIL_TO_ERROR_TAIL_ENABLE_VCH3" => [  16,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "TAIL_TO_ERROR_TAIL_ENABLE_VCH2" => [  17,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "TAIL_TO_ERROR_TAIL_ENABLE_VCH1" => [  18,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "TAIL_TO_ERROR_TAIL_ENABLE_VCH0" => [  19,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "MIP_RESET_ENABLE"             => [  20,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Message-In-Progess Reset Enable" ],
   "SEND_DEADLOCK_TO_VAL"         => [  21,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Port Output Deadlock Timeout Value" ],
);

%nl4rtr_01_00191_def =
( NAME    => "R4_PORTE_PARMS",
  ADDRESS => 0x000000000c001840,
  NOTE    => "The PORT_PARMS register for a port. This register contains note port-specific LLP parameters.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00191_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_SPRAY_DIR                                                   #
#                                                                        #
##########################################################################

%nl4rtr_01_00192_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DIR7"                         => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 7" ],
   "DIR6"                         => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 6" ],
   "DIR5"                         => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 5" ],
   "DIR4"                         => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 4" ],
   "DIR3"                         => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 3" ],
   "DIR2"                         => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 2" ],
   "DIR1"                         => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 1" ],
);

%nl4rtr_01_00192_def =
( NAME    => "R4_PORTE_SPRAY_DIR",
  ADDRESS => 0x000000000c001848,
  NOTE    => "The PORT_SPRAY_DIR register for a port. This register contains note alternate direction information for distributed (i.e. spraye",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00192_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_SPRAY_CMD_3F_0                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00193_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Masks out commands to disable them from spraying" ],
);

%nl4rtr_01_00193_def =
( NAME    => "R4_PORTE_SPRAY_CMD_3F_0",
  ADDRESS => 0x000000000c001850,
  NOTE    => "The PORT_SPRAY_CMD_3f_0 register for each port masks off any of the note commands encodings from 0x0 to 0x3f and makes them non-",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00193_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_SPRAY_CMD_7F_40                                             #
#                                                                        #
##########################################################################

%nl4rtr_01_00194_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Masks out commands 0x40 to 0x7f to disable them from spraying" ],
);

%nl4rtr_01_00194_def =
( NAME    => "R4_PORTE_SPRAY_CMD_7F_40",
  ADDRESS => 0x000000000c001858,
  NOTE    => "The PORT_SPRAY_CMD_7f_40 register for each port masks off any of note the commands encodings from 0x40 to 0x7f and makes them no",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00194_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_SPRAY_CMD_BF_80                                             #
#                                                                        #
##########################################################################

%nl4rtr_01_00195_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Masks out commands 0x80 to 0xbf to disable them from spraying" ],
);

%nl4rtr_01_00195_def =
( NAME    => "R4_PORTE_SPRAY_CMD_BF_80",
  ADDRESS => 0x000000000c001860,
  NOTE    => "The PORT_SPRAY_CMD_bf_80 register for each port masks off any of note the commands encodings from 0x80 to 0xbf and makes them no",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00195_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_SPRAY_CMD_FF_C0                                             #
#                                                                        #
##########################################################################

%nl4rtr_01_00196_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Masks out commands 0xc0 to 0xff to disable them from spraying" ],
);

%nl4rtr_01_00196_def =
( NAME    => "R4_PORTE_SPRAY_CMD_FF_C0",
  ADDRESS => 0x000000000c001868,
  NOTE    => "The PORT_SPRAY_CMD_ff_c0 register for each port masks off any of note the commands encodings from 0xc0 to 0xff and makes them no",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00196_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_LLP_CONFIG                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00197_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_RMT_FT_UPD"            => [   1,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Enable Remote Fine-tuning Updates" ],
   "ENABLE_TUNING"                => [   2,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Enable Tuning" ],
   "AC_ENCODE"                    => [   3,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "DC Encoding Disabled" ],
   "ENABLELINK"                   => [   4,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Enable Link" ],
   "BITMODE32"                    => [   5,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "32-bit Mode Enabled" ],
);

%nl4rtr_01_00197_def =
( NAME    => "R4_PORTE_LLP_CONFIG",
  ADDRESS => 0x000000000c001888,
  NOTE    => "Port Parameters",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00197_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_LLP_TEST_CTL                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00198_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CB_ERROR"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Captured Micropacket Contained a CRC Error" ],
   "CAPTURED"                     => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "Micropacket Captured" ],
   "FAKESNERROR"                  => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "Inject a Sequence Number Error at the Receiver" ],
   "SEND_SN_ERROR"                => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Inject a Sequence Number Error" ],
   "SEND_CB_ERROR"                => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "Inject a CRC Error" ],
   "CAPTURE_CB_ONLY"              => [   6,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "Capture CRC Errors Only" ],
   "ARM_CAPTURE"                  => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "Arm Micropacket Capture Logic" ],
   "NOISE_MODE"                   => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Noise Mode" ],
   "LFSR_MODE"                    => [   9,  52,   2, 0x0030000000000000, 0x00, 0, 0x0000000000000000, "LFSR Mode" ],
   "RSVD1"                        => [  10,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WIRE_SEL"                     => [  11,  44,   6, 0x0003F00000000000, 0x00, 1, 0x0000000000000000, "Wire Select" ],
   "RSVD2"                        => [  12,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_TEST_MODE"               => [  13,  40,   2, 0x0000030000000000, 0x00, 1, 0x0000000000000000, "Send Test Mode" ],
   "PATTERN"                      => [  14,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Send Channel Seed Data Pattern" ],
);

%nl4rtr_01_00198_def =
( NAME    => "R4_PORTE_LLP_TEST_CTL",
  ADDRESS => 0x000000000c001890,
  NOTE    => "The PORT_LLP_TEST_CTL register controls LLP testing. The links may note be tested either online or offline. That is, errors may ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00198_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_LLP_STATE                                                   #
#                                                                        #
##########################################################################

%nl4rtr_01_00199_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LINK_SEND_FSM_STATE"          => [   1,  10,   6, 0x000000000000FC00, 0x00, 0, 0x0000000000000000, "Current State of Port E LLP" ],
   "LINK_RCV_FSM_STATE"           => [   2,   4,   6, 0x00000000000003F0, 0x00, 0, 0x0000000000000000, "Current State of Port E LLP" ],
   "LINK_RESET_STATE"             => [   3,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Current State of Port E LLP" ],
);

%nl4rtr_01_00199_def =
( NAME    => "R4_PORTE_LLP_STATE",
  ADDRESS => 0x000000000c001898,
  NOTE    => "The PORTE_LLP_STATE register allows software to monitor the state note of the Port E LLP.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00199_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_LLP_ERR1                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00200_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RETRY_COUNT"                  => [   0,  48,  16, 0xFFFF000000000000, 0x00, 1, 0x0000000000000000, "Retry Count" ],
   "RX_CB_ERR_COUNT"              => [   1,  16,  32, 0x0000FFFFFFFF0000, 0x00, 1, 0x0000000000000000, "CRC Error Count" ],
   "RX_SN_ERR_COUNT"              => [   2,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "Sequence Number Error Count" ],
);

%nl4rtr_01_00200_def =
( NAME    => "R4_PORTE_LLP_ERR1",
  ADDRESS => 0x000000000c0018a0,
  NOTE    => "The PORTE_LLP_ERR1 register stores detail error and status note information pertaining to errors detected by the Port E LLP.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00200_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_LLP_ERR2                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00201_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CORESENTBADCRC_COUNT"         => [   1,  28,   6, 0x00000003F0000000, 0x00, 1, 0x0000000000000000, "Core Sent Bad CRC count" ],
   "SQUASH"                       => [   2,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "Squashed Micropacket" ],
   "RESET_TIMEOUT"                => [   3,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "Reset Timeout" ],
   "RETRY_TIMEOUT"                => [   4,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Retry Timeout" ],
   "WIRE_OVERFLOW"                => [   5,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Single-wire Error Counter Overflow" ],
   "WIRE_CNT"                     => [   6,   0,  24, 0x0000000000FFFFFF, 0x00, 1, 0x0000000000000000, "Single-wire Error Count" ],
);

%nl4rtr_01_00201_def =
( NAME    => "R4_PORTE_LLP_ERR2",
  ADDRESS => 0x000000000c0018a8,
  NOTE    => "The PORTE_LLP_ERR2 register stores detail error status information note pertaining to errors detected by the Port E LLP.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00201_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_LLP_CAPT_WD1                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00202_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Captured Micropacket[63:0]" ],
);

%nl4rtr_01_00202_def =
( NAME    => "R4_PORTE_LLP_CAPT_WD1",
  ADDRESS => 0x000000000c0018b0,
  NOTE    => "When the LLP micropacket capture circuitry is activated via the note ARMCAPTURE bit of the PORTE_LLP_TEST_CTL register, the note",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00202_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_LLP_CAPT_WD2                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00203_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Captured Micropacket[127:64]" ],
);

%nl4rtr_01_00203_def =
( NAME    => "R4_PORTE_LLP_CAPT_WD2",
  ADDRESS => 0x000000000c0018b8,
  NOTE    => "When the LLP micropacket capture circuitry is activated via the note ARMCAPTURE bit of the PORTE_LLP_TEST_CTL register, the note",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00203_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_LLP_CAPT_SBCB                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00204_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FAKED_ALL_SN_ERRORS"          => [   1,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "All Faked Sequence Number Errors have been Sent" ],
   "SENT_ALL_SN_ERRORS"           => [   2,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "All Sequence Number Errors have been sent" ],
   "SENT_ALL_CB_ERRORS"           => [   3,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "All CRC Errors have been Sent" ],
   "CAPTURED_RCV_CRC"             => [   4,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "Captured CRC" ],
   "CAPTURED_RCVSBSN"             => [   5,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Captured Sideband and Sequence Number" ],
);

%nl4rtr_01_00204_def =
( NAME    => "R4_PORTE_LLP_CAPT_SBCB",
  ADDRESS => 0x000000000c0018c0,
  NOTE    => "When the PORTE LLP micropacket capture circuitry is activated via note the ARMCAPTURE bit of the PORTE_LLP_TEST_CTL register, th",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00204_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_CREDIT                                                      #
#                                                                        #
##########################################################################

%nl4rtr_01_00205_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_LIMIT_VCH3"              => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RSVD1"                        => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_LIMIT_VCH2"              => [   3,  48,   7, 0x007F000000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RSVD2"                        => [   4,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_LIMIT_VCH1"              => [   5,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RSVD3"                        => [   6,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_LIMIT_VCH0"              => [   7,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "RSVD4"                        => [   8,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RCV_INITIAL_VCH3"             => [   9,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RSVD5"                        => [  10,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RCV_INITIAL_VCH2"             => [  11,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RSVD6"                        => [  12,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RCV_INITIAL_VCH1"             => [  13,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RCV_INITIAL_VCH0"             => [  15,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "VCh0" ],
);

%nl4rtr_01_00205_def =
( NAME    => "R4_PORTE_CREDIT",
  ADDRESS => 0x000000000c0018c8,
  NOTE    => "This register powers up to an unknown state and is not reset. It note must be written prior to channel reset.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00205_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_DEBIT                                                       #
#                                                                        #
##########################################################################

%nl4rtr_01_00206_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  37,  27, 0xFFFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EN_SHORT_INTERVAL"            => [   1,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Enable Short Credit Only Interval" ],
   "EN_XMITBUF_THRESHOLD"         => [   2,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "Enable Transmit Buffer Threshold" ],
   "CREDIT_ONLY_INTERVAL"         => [   3,  32,   3, 0x0000000700000000, 0x00, 1, 0x0000000000000000, "Credit Only Packet Interval" ],
   "RSVD1"                        => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FORCE_DEBIT_VCH3"             => [   5,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "WITHHOLD_VCH3"                => [   6,  24,   6, 0x000000003F000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "RSVD2"                        => [   7,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FORCE_DEBIT_VCH2"             => [   8,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "WITHHOLD_VCH2"                => [   9,  16,   6, 0x00000000003F0000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "RSVD3"                        => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FORCE_DEBIT_VCH1"             => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "WITHHOLD_VCH1"                => [  12,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "RSVD4"                        => [  13,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FORCE_DEBIT_VCH0"             => [  14,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "WITHHOLD_VCH0"                => [  15,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VCh0" ],
);

%nl4rtr_01_00206_def =
( NAME    => "R4_PORTE_DEBIT",
  ADDRESS => 0x000000000c0018d0,
  NOTE    => "This register allows diagnostic control of the debit counters. The note debit counters are used to track the debits (credits at ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00206_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_CREDIT_STATE                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00207_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CREDITS_VCH3"                 => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "CREDITS_VCH2"                 => [   1,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "CREDITS_VCH1"                 => [   2,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "CREDITS_VCH0"                 => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "RSVD0"                        => [   4,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBITS_VCH3"                  => [   5,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RSVD1"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBITS_VCH2"                  => [   7,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RSVD2"                        => [   8,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBITS_VCH1"                  => [   9,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RSVD3"                        => [  10,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBITS_VCH0"                  => [  11,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "VCh0" ],
);

%nl4rtr_01_00207_def =
( NAME    => "R4_PORTE_CREDIT_STATE",
  ADDRESS => 0x000000000c0018d8,
  NOTE    => "This register is observing the state of the Debit and Credit note counters for each virtual channel. This register is for diagno",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00207_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_LLP_PKT                                                     #
#                                                                        #
##########################################################################

%nl4rtr_01_00208_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Micropacket Count" ],
);

%nl4rtr_01_00208_def =
( NAME    => "R4_PORTE_LLP_PKT",
  ADDRESS => 0x000000000c0018e0,
  NOTE    => "This register counts DataValid pulses from the PFSSR. Each note DataValid pulse represents two micropackets.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00208_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_LOCAL_TABLE                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00209_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR0"                         => [   2,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Direction" ],
);

%nl4rtr_01_00209_def =
( NAME    => "R4_PORTF_LOCAL_TABLE",
  ADDRESS => 0x000000000d000000,
  NOTE    => "LOCAL_TABLE represents a set of 512 registers which constitute the note Local Look-up Table for the input port. The LOCAL_TABLE ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00209_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_GLOBAL_TABLE                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00210_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR0"                         => [   2,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Direction" ],
);

%nl4rtr_01_00210_def =
( NAME    => "R4_PORTF_GLOBAL_TABLE",
  ADDRESS => 0x000000000d001000,
  NOTE    => "GLOBAL_TABLE represents a set of 256 registers which constitute the note Global Look-up Table for the input port. The GLOBAL_TAB",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00210_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_NEIGHBOR_TABLE                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00211_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,  14,  49, 0x7FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NEIGHBOR_ID"                  => [   2,   0,  14, 0x0000000000003FFF, 0x00, 0, 0x0000000000000000, "Neighbor Node ID" ],
);

%nl4rtr_01_00211_def =
( NAME    => "R4_PORTF_NEIGHBOR_TABLE",
  ADDRESS => 0x000000000d001800,
  NOTE    => "NEIGHBOR_TABLE represents a set of 8 registers which constitute the note Neighbor Look-up Table for the input port. The NEIGHBOR",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00211_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PARMS                                                       #
#                                                                        #
##########################################################################

%nl4rtr_01_00212_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SPARE"                        => [   1,  30,   8, 0x0000003FC0000000, 0x00, 1, 0x0000000000000000, "" ],
   "V_BIT_EMULATION"              => [   2,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "" ],
   "NEW_DIR_SPRAY_ENABLE"         => [   3,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "" ],
   "DIR_SPRAY_ENABLE"             => [   4,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "" ],
   "EXTEND_ENABLE"                => [   5,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "" ],
   "EXTEND_SHUB_INPUT"            => [   6,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "" ],
   "EXTEND_SHUB_DIR_VEC"          => [   7,  17,   8, 0x0000000001FE0000, 0x00, 1, 0x0000000000000000, "" ],
   "ARM_FORCE_CB_ERROR"           => [   8,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Arm Forcing of a Checkbyte Error" ],
   "LINKRESET_ON_BUFFEROVERFLOW"  => [   9,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Enable Link Reset On Buffer Overflow" ],
   "EATUNTILTAIL_ON_BUFFEROVERFLOW" => [  10,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Eat Until Tail On Buffer Overflow" ],
   "LINKRESET_ON_FIFOOVERFLOW"    => [  11,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Enable Link Reset On Fifo Overflow" ],
   "SEND_DEADLOCK_EAT_ENABLE_VCH3" => [  12,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "SEND_DEADLOCK_EAT_ENABLE_VCH2" => [  13,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "SEND_DEADLOCK_EAT_ENABLE_VCH1" => [  14,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "SEND_DEADLOCK_EAT_ENABLE_VCH0" => [  15,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "TAIL_TO_ERROR_TAIL_ENABLE_VCH3" => [  16,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "TAIL_TO_ERROR_TAIL_ENABLE_VCH2" => [  17,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "TAIL_TO_ERROR_TAIL_ENABLE_VCH1" => [  18,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "TAIL_TO_ERROR_TAIL_ENABLE_VCH0" => [  19,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "MIP_RESET_ENABLE"             => [  20,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Message-In-Progess Reset Enable" ],
   "SEND_DEADLOCK_TO_VAL"         => [  21,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Port Output Deadlock Timeout Value" ],
);

%nl4rtr_01_00212_def =
( NAME    => "R4_PORTF_PARMS",
  ADDRESS => 0x000000000d001840,
  NOTE    => "The PORT_PARMS register for a port. This register contains note port-specific LLP parameters.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00212_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_SPRAY_DIR                                                   #
#                                                                        #
##########################################################################

%nl4rtr_01_00213_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DIR7"                         => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 7" ],
   "DIR6"                         => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 6" ],
   "DIR5"                         => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 5" ],
   "DIR4"                         => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 4" ],
   "DIR3"                         => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 3" ],
   "DIR2"                         => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 2" ],
   "DIR1"                         => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 1" ],
);

%nl4rtr_01_00213_def =
( NAME    => "R4_PORTF_SPRAY_DIR",
  ADDRESS => 0x000000000d001848,
  NOTE    => "The PORT_SPRAY_DIR register for a port. This register contains note alternate direction information for distributed (i.e. spraye",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00213_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_SPRAY_CMD_3F_0                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00214_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Masks out commands to disable them from spraying" ],
);

%nl4rtr_01_00214_def =
( NAME    => "R4_PORTF_SPRAY_CMD_3F_0",
  ADDRESS => 0x000000000d001850,
  NOTE    => "The PORT_SPRAY_CMD_3f_0 register for each port masks off any of the note commands encodings from 0x0 to 0x3f and makes them non-",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00214_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_SPRAY_CMD_7F_40                                             #
#                                                                        #
##########################################################################

%nl4rtr_01_00215_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Masks out commands 0x40 to 0x7f to disable them from spraying" ],
);

%nl4rtr_01_00215_def =
( NAME    => "R4_PORTF_SPRAY_CMD_7F_40",
  ADDRESS => 0x000000000d001858,
  NOTE    => "The PORT_SPRAY_CMD_7f_40 register for each port masks off any of note the commands encodings from 0x40 to 0x7f and makes them no",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00215_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_SPRAY_CMD_BF_80                                             #
#                                                                        #
##########################################################################

%nl4rtr_01_00216_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Masks out commands 0x80 to 0xbf to disable them from spraying" ],
);

%nl4rtr_01_00216_def =
( NAME    => "R4_PORTF_SPRAY_CMD_BF_80",
  ADDRESS => 0x000000000d001860,
  NOTE    => "The PORT_SPRAY_CMD_bf_80 register for each port masks off any of note the commands encodings from 0x80 to 0xbf and makes them no",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00216_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_SPRAY_CMD_FF_C0                                             #
#                                                                        #
##########################################################################

%nl4rtr_01_00217_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Masks out commands 0xc0 to 0xff to disable them from spraying" ],
);

%nl4rtr_01_00217_def =
( NAME    => "R4_PORTF_SPRAY_CMD_FF_C0",
  ADDRESS => 0x000000000d001868,
  NOTE    => "The PORT_SPRAY_CMD_ff_c0 register for each port masks off any of note the commands encodings from 0xc0 to 0xff and makes them no",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00217_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_LLP_CONFIG                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00218_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_RMT_FT_UPD"            => [   1,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Enable Remote Fine-tuning Updates" ],
   "ENABLE_TUNING"                => [   2,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Enable Tuning" ],
   "AC_ENCODE"                    => [   3,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "DC Encoding Disabled" ],
   "ENABLELINK"                   => [   4,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Enable Link" ],
   "BITMODE32"                    => [   5,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "32-bit Mode Enabled" ],
);

%nl4rtr_01_00218_def =
( NAME    => "R4_PORTF_LLP_CONFIG",
  ADDRESS => 0x000000000d001888,
  NOTE    => "Port Parameters",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00218_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_LLP_TEST_CTL                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00219_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CB_ERROR"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Captured Micropacket Contained a CRC Error" ],
   "CAPTURED"                     => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "Micropacket Captured" ],
   "FAKESNERROR"                  => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "Inject a Sequence Number Error at the Receiver" ],
   "SEND_SN_ERROR"                => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Inject a Sequence Number Error" ],
   "SEND_CB_ERROR"                => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "Inject a CRC Error" ],
   "CAPTURE_CB_ONLY"              => [   6,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "Capture CRC Errors Only" ],
   "ARM_CAPTURE"                  => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "Arm Micropacket Capture Logic" ],
   "NOISE_MODE"                   => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Noise Mode" ],
   "LFSR_MODE"                    => [   9,  52,   2, 0x0030000000000000, 0x00, 0, 0x0000000000000000, "LFSR Mode" ],
   "RSVD1"                        => [  10,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WIRE_SEL"                     => [  11,  44,   6, 0x0003F00000000000, 0x00, 1, 0x0000000000000000, "Wire Select" ],
   "RSVD2"                        => [  12,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_TEST_MODE"               => [  13,  40,   2, 0x0000030000000000, 0x00, 1, 0x0000000000000000, "Send Test Mode" ],
   "PATTERN"                      => [  14,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Send Channel Seed Data Pattern" ],
);

%nl4rtr_01_00219_def =
( NAME    => "R4_PORTF_LLP_TEST_CTL",
  ADDRESS => 0x000000000d001890,
  NOTE    => "The PORT_LLP_TEST_CTL register controls LLP testing. The links may note be tested either online or offline. That is, errors may ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00219_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_LLP_STATE                                                   #
#                                                                        #
##########################################################################

%nl4rtr_01_00220_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LINK_SEND_FSM_STATE"          => [   1,  10,   6, 0x000000000000FC00, 0x00, 0, 0x0000000000000000, "Current State of Port F LLP" ],
   "LINK_RCV_FSM_STATE"           => [   2,   4,   6, 0x00000000000003F0, 0x00, 0, 0x0000000000000000, "Current State of Port F LLP" ],
   "LINK_RESET_STATE"             => [   3,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Current State of Port F LLP" ],
);

%nl4rtr_01_00220_def =
( NAME    => "R4_PORTF_LLP_STATE",
  ADDRESS => 0x000000000d001898,
  NOTE    => "The PORTF_LLP_STATE register allows software to monitor the state note of the Port F LLP.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00220_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_LLP_ERR1                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00221_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RETRY_COUNT"                  => [   0,  48,  16, 0xFFFF000000000000, 0x00, 1, 0x0000000000000000, "Retry Count" ],
   "RX_CB_ERR_COUNT"              => [   1,  16,  32, 0x0000FFFFFFFF0000, 0x00, 1, 0x0000000000000000, "CRC Error Count" ],
   "RX_SN_ERR_COUNT"              => [   2,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "Sequence Number Error Count" ],
);

%nl4rtr_01_00221_def =
( NAME    => "R4_PORTF_LLP_ERR1",
  ADDRESS => 0x000000000d0018a0,
  NOTE    => "The PORTF_LLP_ERR1 register stores detail error and status note information pertaining to errors detected by the Port F LLP.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00221_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_LLP_ERR2                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00222_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CORESENTBADCRC_COUNT"         => [   1,  28,   6, 0x00000003F0000000, 0x00, 1, 0x0000000000000000, "Core Sent Bad CRC count" ],
   "SQUASH"                       => [   2,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "Squashed Micropacket" ],
   "RESET_TIMEOUT"                => [   3,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "Reset Timeout" ],
   "RETRY_TIMEOUT"                => [   4,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Retry Timeout" ],
   "WIRE_OVERFLOW"                => [   5,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Single-wire Error Counter Overflow" ],
   "WIRE_CNT"                     => [   6,   0,  24, 0x0000000000FFFFFF, 0x00, 1, 0x0000000000000000, "Single-wire Error Count" ],
);

%nl4rtr_01_00222_def =
( NAME    => "R4_PORTF_LLP_ERR2",
  ADDRESS => 0x000000000d0018a8,
  NOTE    => "The PORTF_LLP_ERR2 register stores detail error status information note pertaining to errors detected by the Port F LLP.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00222_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_LLP_CAPT_WD1                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00223_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Captured Micropacket[63:0]" ],
);

%nl4rtr_01_00223_def =
( NAME    => "R4_PORTF_LLP_CAPT_WD1",
  ADDRESS => 0x000000000d0018b0,
  NOTE    => "When the LLP micropacket capture circuitry is activated via the note ARMCAPTURE bit of the PORTF_LLP_TEST_CTL register, the note",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00223_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_LLP_CAPT_WD2                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00224_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Captured Micropacket[127:64]" ],
);

%nl4rtr_01_00224_def =
( NAME    => "R4_PORTF_LLP_CAPT_WD2",
  ADDRESS => 0x000000000d0018b8,
  NOTE    => "When the LLP micropacket capture circuitry is activated via the note ARMCAPTURE bit of the PORTF_LLP_TEST_CTL register, the note",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00224_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_LLP_CAPT_SBCB                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00225_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FAKED_ALL_SN_ERRORS"          => [   1,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "All Faked Sequence Number Errors have been Sent" ],
   "SENT_ALL_SN_ERRORS"           => [   2,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "All Sequence Number Errors have been sent" ],
   "SENT_ALL_CB_ERRORS"           => [   3,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "All CRC Errors have been Sent" ],
   "CAPTURED_RCV_CRC"             => [   4,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "Captured CRC" ],
   "CAPTURED_RCVSBSN"             => [   5,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Captured Sideband and Sequence Number" ],
);

%nl4rtr_01_00225_def =
( NAME    => "R4_PORTF_LLP_CAPT_SBCB",
  ADDRESS => 0x000000000d0018c0,
  NOTE    => "When the PORTF LLP micropacket capture circuitry is activated via note the ARMCAPTURE bit of the PORTF_LLP_TEST_CTL register, th",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00225_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_CREDIT                                                      #
#                                                                        #
##########################################################################

%nl4rtr_01_00226_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_LIMIT_VCH3"              => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RSVD1"                        => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_LIMIT_VCH2"              => [   3,  48,   7, 0x007F000000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RSVD2"                        => [   4,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_LIMIT_VCH1"              => [   5,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RSVD3"                        => [   6,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_LIMIT_VCH0"              => [   7,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "RSVD4"                        => [   8,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RCV_INITIAL_VCH3"             => [   9,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RSVD5"                        => [  10,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RCV_INITIAL_VCH2"             => [  11,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RSVD6"                        => [  12,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RCV_INITIAL_VCH1"             => [  13,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RCV_INITIAL_VCH0"             => [  15,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "VCh0" ],
);

%nl4rtr_01_00226_def =
( NAME    => "R4_PORTF_CREDIT",
  ADDRESS => 0x000000000d0018c8,
  NOTE    => "This register powers up to an unknown state and is not reset. It note must be written prior to channel reset.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00226_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_DEBIT                                                       #
#                                                                        #
##########################################################################

%nl4rtr_01_00227_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  37,  27, 0xFFFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EN_SHORT_INTERVAL"            => [   1,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Enable Short Credit Only Interval" ],
   "EN_XMITBUF_THRESHOLD"         => [   2,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "Enable Transmit Buffer Threshold" ],
   "CREDIT_ONLY_INTERVAL"         => [   3,  32,   3, 0x0000000700000000, 0x00, 1, 0x0000000000000000, "Credit Only Packet Interval" ],
   "RSVD1"                        => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FORCE_DEBIT_VCH3"             => [   5,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "WITHHOLD_VCH3"                => [   6,  24,   6, 0x000000003F000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "RSVD2"                        => [   7,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FORCE_DEBIT_VCH2"             => [   8,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "WITHHOLD_VCH2"                => [   9,  16,   6, 0x00000000003F0000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "RSVD3"                        => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FORCE_DEBIT_VCH1"             => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "WITHHOLD_VCH1"                => [  12,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "RSVD4"                        => [  13,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FORCE_DEBIT_VCH0"             => [  14,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "WITHHOLD_VCH0"                => [  15,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VCh0" ],
);

%nl4rtr_01_00227_def =
( NAME    => "R4_PORTF_DEBIT",
  ADDRESS => 0x000000000d0018d0,
  NOTE    => "This register allows diagnostic control of the debit counters. The note debit counters are used to track the debits (credits at ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00227_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_CREDIT_STATE                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00228_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CREDITS_VCH3"                 => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "CREDITS_VCH2"                 => [   1,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "CREDITS_VCH1"                 => [   2,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "CREDITS_VCH0"                 => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "RSVD0"                        => [   4,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBITS_VCH3"                  => [   5,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RSVD1"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBITS_VCH2"                  => [   7,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RSVD2"                        => [   8,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBITS_VCH1"                  => [   9,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RSVD3"                        => [  10,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBITS_VCH0"                  => [  11,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "VCh0" ],
);

%nl4rtr_01_00228_def =
( NAME    => "R4_PORTF_CREDIT_STATE",
  ADDRESS => 0x000000000d0018d8,
  NOTE    => "This register is observing the state of the Debit and Credit note counters for each virtual channel. This register is for diagno",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00228_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_LLP_PKT                                                     #
#                                                                        #
##########################################################################

%nl4rtr_01_00229_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Micropacket Count" ],
);

%nl4rtr_01_00229_def =
( NAME    => "R4_PORTF_LLP_PKT",
  ADDRESS => 0x000000000d0018e0,
  NOTE    => "This register counts DataValid pulses from the PFSSR. Each note DataValid pulse represents two micropackets.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00229_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_LOCAL_TABLE                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00230_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR0"                         => [   2,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Direction" ],
);

%nl4rtr_01_00230_def =
( NAME    => "R4_PORTG_LOCAL_TABLE",
  ADDRESS => 0x000000000e000000,
  NOTE    => "LOCAL_TABLE represents a set of 512 registers which constitute the note Local Look-up Table for the input port. The LOCAL_TABLE ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00230_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_GLOBAL_TABLE                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00231_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR0"                         => [   2,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Direction" ],
);

%nl4rtr_01_00231_def =
( NAME    => "R4_PORTG_GLOBAL_TABLE",
  ADDRESS => 0x000000000e001000,
  NOTE    => "GLOBAL_TABLE represents a set of 256 registers which constitute the note Global Look-up Table for the input port. The GLOBAL_TAB",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00231_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_NEIGHBOR_TABLE                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00232_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,  14,  49, 0x7FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NEIGHBOR_ID"                  => [   2,   0,  14, 0x0000000000003FFF, 0x00, 0, 0x0000000000000000, "Neighbor Node ID" ],
);

%nl4rtr_01_00232_def =
( NAME    => "R4_PORTG_NEIGHBOR_TABLE",
  ADDRESS => 0x000000000e001800,
  NOTE    => "NEIGHBOR_TABLE represents a set of 8 registers which constitute the note Neighbor Look-up Table for the input port. The NEIGHBOR",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00232_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PARMS                                                       #
#                                                                        #
##########################################################################

%nl4rtr_01_00233_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SPARE"                        => [   1,  30,   8, 0x0000003FC0000000, 0x00, 1, 0x0000000000000000, "" ],
   "V_BIT_EMULATION"              => [   2,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "" ],
   "NEW_DIR_SPRAY_ENABLE"         => [   3,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "" ],
   "DIR_SPRAY_ENABLE"             => [   4,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "" ],
   "EXTEND_ENABLE"                => [   5,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "" ],
   "EXTEND_SHUB_INPUT"            => [   6,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "" ],
   "EXTEND_SHUB_DIR_VEC"          => [   7,  17,   8, 0x0000000001FE0000, 0x00, 1, 0x0000000000000000, "" ],
   "ARM_FORCE_CB_ERROR"           => [   8,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Arm Forcing of a Checkbyte Error" ],
   "LINKRESET_ON_BUFFEROVERFLOW"  => [   9,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Enable Link Reset On Buffer Overflow" ],
   "EATUNTILTAIL_ON_BUFFEROVERFLOW" => [  10,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Eat Until Tail On Buffer Overflow" ],
   "LINKRESET_ON_FIFOOVERFLOW"    => [  11,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Enable Link Reset On Fifo Overflow" ],
   "SEND_DEADLOCK_EAT_ENABLE_VCH3" => [  12,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "SEND_DEADLOCK_EAT_ENABLE_VCH2" => [  13,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "SEND_DEADLOCK_EAT_ENABLE_VCH1" => [  14,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "SEND_DEADLOCK_EAT_ENABLE_VCH0" => [  15,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "TAIL_TO_ERROR_TAIL_ENABLE_VCH3" => [  16,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "TAIL_TO_ERROR_TAIL_ENABLE_VCH2" => [  17,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "TAIL_TO_ERROR_TAIL_ENABLE_VCH1" => [  18,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "TAIL_TO_ERROR_TAIL_ENABLE_VCH0" => [  19,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "MIP_RESET_ENABLE"             => [  20,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Message-In-Progess Reset Enable" ],
   "SEND_DEADLOCK_TO_VAL"         => [  21,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Port Output Deadlock Timeout Value" ],
);

%nl4rtr_01_00233_def =
( NAME    => "R4_PORTG_PARMS",
  ADDRESS => 0x000000000e001840,
  NOTE    => "The PORT_PARMS register for a port. This register contains note port-specific LLP parameters.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00233_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_SPRAY_DIR                                                   #
#                                                                        #
##########################################################################

%nl4rtr_01_00234_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DIR7"                         => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 7" ],
   "DIR6"                         => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 6" ],
   "DIR5"                         => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 5" ],
   "DIR4"                         => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 4" ],
   "DIR3"                         => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 3" ],
   "DIR2"                         => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 2" ],
   "DIR1"                         => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 1" ],
);

%nl4rtr_01_00234_def =
( NAME    => "R4_PORTG_SPRAY_DIR",
  ADDRESS => 0x000000000e001848,
  NOTE    => "The PORT_SPRAY_DIR register for a port. This register contains note alternate direction information for distributed (i.e. spraye",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00234_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_SPRAY_CMD_3F_0                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00235_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Masks out commands to disable them from spraying" ],
);

%nl4rtr_01_00235_def =
( NAME    => "R4_PORTG_SPRAY_CMD_3F_0",
  ADDRESS => 0x000000000e001850,
  NOTE    => "The PORT_SPRAY_CMD_3f_0 register for each port masks off any of the note commands encodings from 0x0 to 0x3f and makes them non-",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00235_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_SPRAY_CMD_7F_40                                             #
#                                                                        #
##########################################################################

%nl4rtr_01_00236_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Masks out commands 0x40 to 0x7f to disable them from spraying" ],
);

%nl4rtr_01_00236_def =
( NAME    => "R4_PORTG_SPRAY_CMD_7F_40",
  ADDRESS => 0x000000000e001858,
  NOTE    => "The PORT_SPRAY_CMD_7f_40 register for each port masks off any of note the commands encodings from 0x40 to 0x7f and makes them no",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00236_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_SPRAY_CMD_BF_80                                             #
#                                                                        #
##########################################################################

%nl4rtr_01_00237_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Masks out commands 0x80 to 0xbf to disable them from spraying" ],
);

%nl4rtr_01_00237_def =
( NAME    => "R4_PORTG_SPRAY_CMD_BF_80",
  ADDRESS => 0x000000000e001860,
  NOTE    => "The PORT_SPRAY_CMD_bf_80 register for each port masks off any of note the commands encodings from 0x80 to 0xbf and makes them no",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00237_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_SPRAY_CMD_FF_C0                                             #
#                                                                        #
##########################################################################

%nl4rtr_01_00238_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Masks out commands 0xc0 to 0xff to disable them from spraying" ],
);

%nl4rtr_01_00238_def =
( NAME    => "R4_PORTG_SPRAY_CMD_FF_C0",
  ADDRESS => 0x000000000e001868,
  NOTE    => "The PORT_SPRAY_CMD_ff_c0 register for each port masks off any of note the commands encodings from 0xc0 to 0xff and makes them no",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00238_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_LLP_CONFIG                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00239_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_RMT_FT_UPD"            => [   1,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Enable Remote Fine-tuning Updates" ],
   "ENABLE_TUNING"                => [   2,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Enable Tuning" ],
   "AC_ENCODE"                    => [   3,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "DC Encoding Disabled" ],
   "ENABLELINK"                   => [   4,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Enable Link" ],
   "BITMODE32"                    => [   5,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "32-bit Mode Enabled" ],
);

%nl4rtr_01_00239_def =
( NAME    => "R4_PORTG_LLP_CONFIG",
  ADDRESS => 0x000000000e001888,
  NOTE    => "Port Parameters",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00239_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_LLP_TEST_CTL                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00240_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CB_ERROR"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Captured Micropacket Contained a CRC Error" ],
   "CAPTURED"                     => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "Micropacket Captured" ],
   "FAKESNERROR"                  => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "Inject a Sequence Number Error at the Receiver" ],
   "SEND_SN_ERROR"                => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Inject a Sequence Number Error" ],
   "SEND_CB_ERROR"                => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "Inject a CRC Error" ],
   "CAPTURE_CB_ONLY"              => [   6,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "Capture CRC Errors Only" ],
   "ARM_CAPTURE"                  => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "Arm Micropacket Capture Logic" ],
   "NOISE_MODE"                   => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Noise Mode" ],
   "LFSR_MODE"                    => [   9,  52,   2, 0x0030000000000000, 0x00, 0, 0x0000000000000000, "LFSR Mode" ],
   "RSVD1"                        => [  10,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WIRE_SEL"                     => [  11,  44,   6, 0x0003F00000000000, 0x00, 1, 0x0000000000000000, "Wire Select" ],
   "RSVD2"                        => [  12,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_TEST_MODE"               => [  13,  40,   2, 0x0000030000000000, 0x00, 1, 0x0000000000000000, "Send Test Mode" ],
   "PATTERN"                      => [  14,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Send Channel Seed Data Pattern" ],
);

%nl4rtr_01_00240_def =
( NAME    => "R4_PORTG_LLP_TEST_CTL",
  ADDRESS => 0x000000000e001890,
  NOTE    => "The PORT_LLP_TEST_CTL register controls LLP testing. The links may note be tested either online or offline. That is, errors may ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00240_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_LLP_STATE                                                   #
#                                                                        #
##########################################################################

%nl4rtr_01_00241_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LINK_SEND_FSM_STATE"          => [   1,  10,   6, 0x000000000000FC00, 0x00, 0, 0x0000000000000000, "Current State of Port G LLP" ],
   "LINK_RCV_FSM_STATE"           => [   2,   4,   6, 0x00000000000003F0, 0x00, 0, 0x0000000000000000, "Current State of Port G LLP" ],
   "LINK_RESET_STATE"             => [   3,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Current State of Port G LLP" ],
);

%nl4rtr_01_00241_def =
( NAME    => "R4_PORTG_LLP_STATE",
  ADDRESS => 0x000000000e001898,
  NOTE    => "The PORTG_LLP_STATE register allows software to monitor the state note of the Port G LLP.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00241_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_LLP_ERR1                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00242_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RETRY_COUNT"                  => [   0,  48,  16, 0xFFFF000000000000, 0x00, 1, 0x0000000000000000, "Retry Count" ],
   "RX_CB_ERR_COUNT"              => [   1,  16,  32, 0x0000FFFFFFFF0000, 0x00, 1, 0x0000000000000000, "CRC Error Count" ],
   "RX_SN_ERR_COUNT"              => [   2,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "Sequence Number Error Count" ],
);

%nl4rtr_01_00242_def =
( NAME    => "R4_PORTG_LLP_ERR1",
  ADDRESS => 0x000000000e0018a0,
  NOTE    => "The PORTG_LLP_ERR1 register stores detail error and status note information pertaining to errors detected by the Port G LLP.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00242_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_LLP_ERR2                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00243_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CORESENTBADCRC_COUNT"         => [   1,  28,   6, 0x00000003F0000000, 0x00, 1, 0x0000000000000000, "Core Sent Bad CRC count" ],
   "SQUASH"                       => [   2,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "Squashed Micropacket" ],
   "RESET_TIMEOUT"                => [   3,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "Reset Timeout" ],
   "RETRY_TIMEOUT"                => [   4,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Retry Timeout" ],
   "WIRE_OVERFLOW"                => [   5,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Single-wire Error Counter Overflow" ],
   "WIRE_CNT"                     => [   6,   0,  24, 0x0000000000FFFFFF, 0x00, 1, 0x0000000000000000, "Single-wire Error Count" ],
);

%nl4rtr_01_00243_def =
( NAME    => "R4_PORTG_LLP_ERR2",
  ADDRESS => 0x000000000e0018a8,
  NOTE    => "The PORTG_LLP_ERR2 register stores detail error status information note pertaining to errors detected by the Port G LLP.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00243_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_LLP_CAPT_WD1                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00244_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Captured Micropacket[63:0]" ],
);

%nl4rtr_01_00244_def =
( NAME    => "R4_PORTG_LLP_CAPT_WD1",
  ADDRESS => 0x000000000e0018b0,
  NOTE    => "When the LLP micropacket capture circuitry is activated via the note ARMCAPTURE bit of the PORTG_LLP_TEST_CTL register, the note",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00244_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_LLP_CAPT_WD2                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00245_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Captured Micropacket[127:64]" ],
);

%nl4rtr_01_00245_def =
( NAME    => "R4_PORTG_LLP_CAPT_WD2",
  ADDRESS => 0x000000000e0018b8,
  NOTE    => "When the LLP micropacket capture circuitry is activated via the note ARMCAPTURE bit of the PORTG_LLP_TEST_CTL register, the note",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00245_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_LLP_CAPT_SBCB                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00246_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FAKED_ALL_SN_ERRORS"          => [   1,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "All Faked Sequence Number Errors have been Sent" ],
   "SENT_ALL_SN_ERRORS"           => [   2,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "All Sequence Number Errors have been sent" ],
   "SENT_ALL_CB_ERRORS"           => [   3,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "All CRC Errors have been Sent" ],
   "CAPTURED_RCV_CRC"             => [   4,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "Captured CRC" ],
   "CAPTURED_RCVSBSN"             => [   5,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Captured Sideband and Sequence Number" ],
);

%nl4rtr_01_00246_def =
( NAME    => "R4_PORTG_LLP_CAPT_SBCB",
  ADDRESS => 0x000000000e0018c0,
  NOTE    => "When the PORTG LLP micropacket capture circuitry is activated via note the ARMCAPTURE bit of the PORTG_LLP_TEST_CTL register, th",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00246_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_CREDIT                                                      #
#                                                                        #
##########################################################################

%nl4rtr_01_00247_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_LIMIT_VCH3"              => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RSVD1"                        => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_LIMIT_VCH2"              => [   3,  48,   7, 0x007F000000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RSVD2"                        => [   4,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_LIMIT_VCH1"              => [   5,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RSVD3"                        => [   6,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_LIMIT_VCH0"              => [   7,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "RSVD4"                        => [   8,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RCV_INITIAL_VCH3"             => [   9,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RSVD5"                        => [  10,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RCV_INITIAL_VCH2"             => [  11,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RSVD6"                        => [  12,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RCV_INITIAL_VCH1"             => [  13,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RCV_INITIAL_VCH0"             => [  15,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "VCh0" ],
);

%nl4rtr_01_00247_def =
( NAME    => "R4_PORTG_CREDIT",
  ADDRESS => 0x000000000e0018c8,
  NOTE    => "This register powers up to an unknown state and is not reset. It note must be written prior to channel reset.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00247_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_DEBIT                                                       #
#                                                                        #
##########################################################################

%nl4rtr_01_00248_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  37,  27, 0xFFFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EN_SHORT_INTERVAL"            => [   1,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Enable Short Credit Only Interval" ],
   "EN_XMITBUF_THRESHOLD"         => [   2,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "Enable Transmit Buffer Threshold" ],
   "CREDIT_ONLY_INTERVAL"         => [   3,  32,   3, 0x0000000700000000, 0x00, 1, 0x0000000000000000, "Credit Only Packet Interval" ],
   "RSVD1"                        => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FORCE_DEBIT_VCH3"             => [   5,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "WITHHOLD_VCH3"                => [   6,  24,   6, 0x000000003F000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "RSVD2"                        => [   7,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FORCE_DEBIT_VCH2"             => [   8,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "WITHHOLD_VCH2"                => [   9,  16,   6, 0x00000000003F0000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "RSVD3"                        => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FORCE_DEBIT_VCH1"             => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "WITHHOLD_VCH1"                => [  12,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "RSVD4"                        => [  13,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FORCE_DEBIT_VCH0"             => [  14,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "WITHHOLD_VCH0"                => [  15,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VCh0" ],
);

%nl4rtr_01_00248_def =
( NAME    => "R4_PORTG_DEBIT",
  ADDRESS => 0x000000000e0018d0,
  NOTE    => "This register allows diagnostic control of the debit counters. The note debit counters are used to track the debits (credits at ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00248_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_CREDIT_STATE                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00249_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CREDITS_VCH3"                 => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "CREDITS_VCH2"                 => [   1,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "CREDITS_VCH1"                 => [   2,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "CREDITS_VCH0"                 => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "RSVD0"                        => [   4,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBITS_VCH3"                  => [   5,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RSVD1"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBITS_VCH2"                  => [   7,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RSVD2"                        => [   8,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBITS_VCH1"                  => [   9,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RSVD3"                        => [  10,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBITS_VCH0"                  => [  11,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "VCh0" ],
);

%nl4rtr_01_00249_def =
( NAME    => "R4_PORTG_CREDIT_STATE",
  ADDRESS => 0x000000000e0018d8,
  NOTE    => "This register is observing the state of the Debit and Credit note counters for each virtual channel. This register is for diagno",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00249_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_LLP_PKT                                                     #
#                                                                        #
##########################################################################

%nl4rtr_01_00250_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Micropacket Count" ],
);

%nl4rtr_01_00250_def =
( NAME    => "R4_PORTG_LLP_PKT",
  ADDRESS => 0x000000000e0018e0,
  NOTE    => "This register counts DataValid pulses from the PFSSR. Each note DataValid pulse represents two micropackets.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00250_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_LOCAL_TABLE                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00251_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR0"                         => [   2,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Direction" ],
);

%nl4rtr_01_00251_def =
( NAME    => "R4_PORTH_LOCAL_TABLE",
  ADDRESS => 0x000000000f000000,
  NOTE    => "LOCAL_TABLE represents a set of 512 registers which constitute the note Local Look-up Table for the input port. The LOCAL_TABLE ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00251_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_GLOBAL_TABLE                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00252_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR0"                         => [   2,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Direction" ],
);

%nl4rtr_01_00252_def =
( NAME    => "R4_PORTH_GLOBAL_TABLE",
  ADDRESS => 0x000000000f001000,
  NOTE    => "GLOBAL_TABLE represents a set of 256 registers which constitute the note Global Look-up Table for the input port. The GLOBAL_TAB",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00252_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_NEIGHBOR_TABLE                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00253_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Entry Valid" ],
   "RSVD0"                        => [   1,  14,  49, 0x7FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NEIGHBOR_ID"                  => [   2,   0,  14, 0x0000000000003FFF, 0x00, 0, 0x0000000000000000, "Neighbor Node ID" ],
);

%nl4rtr_01_00253_def =
( NAME    => "R4_PORTH_NEIGHBOR_TABLE",
  ADDRESS => 0x000000000f001800,
  NOTE    => "NEIGHBOR_TABLE represents a set of 8 registers which constitute the note Neighbor Look-up Table for the input port. The NEIGHBOR",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00253_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PARMS                                                       #
#                                                                        #
##########################################################################

%nl4rtr_01_00254_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SPARE"                        => [   1,  30,   8, 0x0000003FC0000000, 0x00, 1, 0x0000000000000000, "" ],
   "V_BIT_EMULATION"              => [   2,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "" ],
   "NEW_DIR_SPRAY_ENABLE"         => [   3,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "" ],
   "DIR_SPRAY_ENABLE"             => [   4,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "" ],
   "EXTEND_ENABLE"                => [   5,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "" ],
   "EXTEND_SHUB_INPUT"            => [   6,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "" ],
   "EXTEND_SHUB_DIR_VEC"          => [   7,  17,   8, 0x0000000001FE0000, 0x00, 1, 0x0000000000000000, "" ],
   "ARM_FORCE_CB_ERROR"           => [   8,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Arm Forcing of a Checkbyte Error" ],
   "LINKRESET_ON_BUFFEROVERFLOW"  => [   9,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Enable Link Reset On Buffer Overflow" ],
   "EATUNTILTAIL_ON_BUFFEROVERFLOW" => [  10,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Eat Until Tail On Buffer Overflow" ],
   "LINKRESET_ON_FIFOOVERFLOW"    => [  11,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Enable Link Reset On Fifo Overflow" ],
   "SEND_DEADLOCK_EAT_ENABLE_VCH3" => [  12,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "SEND_DEADLOCK_EAT_ENABLE_VCH2" => [  13,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "SEND_DEADLOCK_EAT_ENABLE_VCH1" => [  14,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "SEND_DEADLOCK_EAT_ENABLE_VCH0" => [  15,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "TAIL_TO_ERROR_TAIL_ENABLE_VCH3" => [  16,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "TAIL_TO_ERROR_TAIL_ENABLE_VCH2" => [  17,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "TAIL_TO_ERROR_TAIL_ENABLE_VCH1" => [  18,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "TAIL_TO_ERROR_TAIL_ENABLE_VCH0" => [  19,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "MIP_RESET_ENABLE"             => [  20,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Message-In-Progess Reset Enable" ],
   "SEND_DEADLOCK_TO_VAL"         => [  21,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Port Output Deadlock Timeout Value" ],
);

%nl4rtr_01_00254_def =
( NAME    => "R4_PORTH_PARMS",
  ADDRESS => 0x000000000f001840,
  NOTE    => "The PORT_PARMS register for a port. This register contains note port-specific LLP parameters.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00254_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_SPRAY_DIR                                                   #
#                                                                        #
##########################################################################

%nl4rtr_01_00255_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DIR7"                         => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 7" ],
   "DIR6"                         => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 6" ],
   "DIR5"                         => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 5" ],
   "DIR4"                         => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 4" ],
   "DIR3"                         => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 3" ],
   "DIR2"                         => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 2" ],
   "DIR1"                         => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Mask of unused spray directions for received direction field of 1" ],
);

%nl4rtr_01_00255_def =
( NAME    => "R4_PORTH_SPRAY_DIR",
  ADDRESS => 0x000000000f001848,
  NOTE    => "The PORT_SPRAY_DIR register for a port. This register contains note alternate direction information for distributed (i.e. spraye",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00255_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_SPRAY_CMD_3F_0                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00256_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Masks out commands to disable them from spraying" ],
);

%nl4rtr_01_00256_def =
( NAME    => "R4_PORTH_SPRAY_CMD_3F_0",
  ADDRESS => 0x000000000f001850,
  NOTE    => "The PORT_SPRAY_CMD_3f_0 register for each port masks off any of the note commands encodings from 0x0 to 0x3f and makes them non-",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00256_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_SPRAY_CMD_7F_40                                             #
#                                                                        #
##########################################################################

%nl4rtr_01_00257_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Masks out commands 0x40 to 0x7f to disable them from spraying" ],
);

%nl4rtr_01_00257_def =
( NAME    => "R4_PORTH_SPRAY_CMD_7F_40",
  ADDRESS => 0x000000000f001858,
  NOTE    => "The PORT_SPRAY_CMD_7f_40 register for each port masks off any of note the commands encodings from 0x40 to 0x7f and makes them no",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00257_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_SPRAY_CMD_BF_80                                             #
#                                                                        #
##########################################################################

%nl4rtr_01_00258_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Masks out commands 0x80 to 0xbf to disable them from spraying" ],
);

%nl4rtr_01_00258_def =
( NAME    => "R4_PORTH_SPRAY_CMD_BF_80",
  ADDRESS => 0x000000000f001860,
  NOTE    => "The PORT_SPRAY_CMD_bf_80 register for each port masks off any of note the commands encodings from 0x80 to 0xbf and makes them no",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00258_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_SPRAY_CMD_FF_C0                                             #
#                                                                        #
##########################################################################

%nl4rtr_01_00259_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Masks out commands 0xc0 to 0xff to disable them from spraying" ],
);

%nl4rtr_01_00259_def =
( NAME    => "R4_PORTH_SPRAY_CMD_FF_C0",
  ADDRESS => 0x000000000f001868,
  NOTE    => "The PORT_SPRAY_CMD_ff_c0 register for each port masks off any of note the commands encodings from 0xc0 to 0xff and makes them no",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00259_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_LLP_CONFIG                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00260_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_RMT_FT_UPD"            => [   1,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Enable Remote Fine-tuning Updates" ],
   "ENABLE_TUNING"                => [   2,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Enable Tuning" ],
   "AC_ENCODE"                    => [   3,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "DC Encoding Disabled" ],
   "ENABLELINK"                   => [   4,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Enable Link" ],
   "BITMODE32"                    => [   5,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "32-bit Mode Enabled" ],
);

%nl4rtr_01_00260_def =
( NAME    => "R4_PORTH_LLP_CONFIG",
  ADDRESS => 0x000000000f001888,
  NOTE    => "Port Parameters",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00260_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_LLP_TEST_CTL                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00261_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CB_ERROR"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Captured Micropacket Contained a CRC Error" ],
   "CAPTURED"                     => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "Micropacket Captured" ],
   "FAKESNERROR"                  => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "Inject a Sequence Number Error at the Receiver" ],
   "SEND_SN_ERROR"                => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Inject a Sequence Number Error" ],
   "SEND_CB_ERROR"                => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "Inject a CRC Error" ],
   "CAPTURE_CB_ONLY"              => [   6,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "Capture CRC Errors Only" ],
   "ARM_CAPTURE"                  => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "Arm Micropacket Capture Logic" ],
   "NOISE_MODE"                   => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Noise Mode" ],
   "LFSR_MODE"                    => [   9,  52,   2, 0x0030000000000000, 0x00, 0, 0x0000000000000000, "LFSR Mode" ],
   "RSVD1"                        => [  10,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WIRE_SEL"                     => [  11,  44,   6, 0x0003F00000000000, 0x00, 1, 0x0000000000000000, "Wire Select" ],
   "RSVD2"                        => [  12,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_TEST_MODE"               => [  13,  40,   2, 0x0000030000000000, 0x00, 1, 0x0000000000000000, "Send Test Mode" ],
   "PATTERN"                      => [  14,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Send Channel Seed Data Pattern" ],
);

%nl4rtr_01_00261_def =
( NAME    => "R4_PORTH_LLP_TEST_CTL",
  ADDRESS => 0x000000000f001890,
  NOTE    => "The PORT_LLP_TEST_CTL register controls LLP testing. The links may note be tested either online or offline. That is, errors may ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00261_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_LLP_STATE                                                   #
#                                                                        #
##########################################################################

%nl4rtr_01_00262_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LINK_SEND_FSM_STATE"          => [   1,  10,   6, 0x000000000000FC00, 0x00, 0, 0x0000000000000000, "Current State of Port H LLP" ],
   "LINK_RCV_FSM_STATE"           => [   2,   4,   6, 0x00000000000003F0, 0x00, 0, 0x0000000000000000, "Current State of Port H LLP" ],
   "LINK_RESET_STATE"             => [   3,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Current State of Port H LLP" ],
);

%nl4rtr_01_00262_def =
( NAME    => "R4_PORTH_LLP_STATE",
  ADDRESS => 0x000000000f001898,
  NOTE    => "The PORTH_LLP_STATE register allows software to monitor the state note of the Port H LLP.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00262_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_LLP_ERR1                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00263_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RETRY_COUNT"                  => [   0,  48,  16, 0xFFFF000000000000, 0x00, 1, 0x0000000000000000, "Retry Count" ],
   "RX_CB_ERR_COUNT"              => [   1,  16,  32, 0x0000FFFFFFFF0000, 0x00, 1, 0x0000000000000000, "CRC Error Count" ],
   "RX_SN_ERR_COUNT"              => [   2,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "Sequence Number Error Count" ],
);

%nl4rtr_01_00263_def =
( NAME    => "R4_PORTH_LLP_ERR1",
  ADDRESS => 0x000000000f0018a0,
  NOTE    => "The PORTH_LLP_ERR1 register stores detail error and status note information pertaining to errors detected by the Port H LLP.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00263_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_LLP_ERR2                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00264_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CORESENTBADCRC_COUNT"         => [   1,  28,   6, 0x00000003F0000000, 0x00, 1, 0x0000000000000000, "Core Sent Bad CRC count" ],
   "SQUASH"                       => [   2,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "Squashed Micropacket" ],
   "RESET_TIMEOUT"                => [   3,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "Reset Timeout" ],
   "RETRY_TIMEOUT"                => [   4,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Retry Timeout" ],
   "WIRE_OVERFLOW"                => [   5,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Single-wire Error Counter Overflow" ],
   "WIRE_CNT"                     => [   6,   0,  24, 0x0000000000FFFFFF, 0x00, 1, 0x0000000000000000, "Single-wire Error Count" ],
);

%nl4rtr_01_00264_def =
( NAME    => "R4_PORTH_LLP_ERR2",
  ADDRESS => 0x000000000f0018a8,
  NOTE    => "The PORTH_LLP_ERR2 register stores detail error status information note pertaining to errors detected by the Port H LLP.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00264_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_LLP_CAPT_WD1                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00265_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Captured Micropacket[63:0]" ],
);

%nl4rtr_01_00265_def =
( NAME    => "R4_PORTH_LLP_CAPT_WD1",
  ADDRESS => 0x000000000f0018b0,
  NOTE    => "When the LLP micropacket capture circuitry is activated via the note ARMCAPTURE bit of the PORTH_LLP_TEST_CTL register, the note",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00265_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_LLP_CAPT_WD2                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00266_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Captured Micropacket[127:64]" ],
);

%nl4rtr_01_00266_def =
( NAME    => "R4_PORTH_LLP_CAPT_WD2",
  ADDRESS => 0x000000000f0018b8,
  NOTE    => "When the LLP micropacket capture circuitry is activated via the note ARMCAPTURE bit of the PORTH_LLP_TEST_CTL register, the note",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00266_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_LLP_CAPT_SBCB                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00267_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FAKED_ALL_SN_ERRORS"          => [   1,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "All Faked Sequence Number Errors have been Sent" ],
   "SENT_ALL_SN_ERRORS"           => [   2,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "All Sequence Number Errors have been sent" ],
   "SENT_ALL_CB_ERRORS"           => [   3,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "All CRC Errors have been Sent" ],
   "CAPTURED_RCV_CRC"             => [   4,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "Captured CRC" ],
   "CAPTURED_RCVSBSN"             => [   5,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Captured Sideband and Sequence Number" ],
);

%nl4rtr_01_00267_def =
( NAME    => "R4_PORTH_LLP_CAPT_SBCB",
  ADDRESS => 0x000000000f0018c0,
  NOTE    => "When the PORTH LLP micropacket capture circuitry is activated via note the ARMCAPTURE bit of the PORTH_LLP_TEST_CTL register, th",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00267_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_CREDIT                                                      #
#                                                                        #
##########################################################################

%nl4rtr_01_00268_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_LIMIT_VCH3"              => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RSVD1"                        => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_LIMIT_VCH2"              => [   3,  48,   7, 0x007F000000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RSVD2"                        => [   4,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_LIMIT_VCH1"              => [   5,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RSVD3"                        => [   6,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_LIMIT_VCH0"              => [   7,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "RSVD4"                        => [   8,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RCV_INITIAL_VCH3"             => [   9,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RSVD5"                        => [  10,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RCV_INITIAL_VCH2"             => [  11,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RSVD6"                        => [  12,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RCV_INITIAL_VCH1"             => [  13,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RCV_INITIAL_VCH0"             => [  15,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "VCh0" ],
);

%nl4rtr_01_00268_def =
( NAME    => "R4_PORTH_CREDIT",
  ADDRESS => 0x000000000f0018c8,
  NOTE    => "This register powers up to an unknown state and is not reset. It note must be written prior to channel reset.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00268_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_DEBIT                                                       #
#                                                                        #
##########################################################################

%nl4rtr_01_00269_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  37,  27, 0xFFFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EN_SHORT_INTERVAL"            => [   1,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Enable Short Credit Only Interval" ],
   "EN_XMITBUF_THRESHOLD"         => [   2,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "Enable Transmit Buffer Threshold" ],
   "CREDIT_ONLY_INTERVAL"         => [   3,  32,   3, 0x0000000700000000, 0x00, 1, 0x0000000000000000, "Credit Only Packet Interval" ],
   "RSVD1"                        => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FORCE_DEBIT_VCH3"             => [   5,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "WITHHOLD_VCH3"                => [   6,  24,   6, 0x000000003F000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "RSVD2"                        => [   7,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FORCE_DEBIT_VCH2"             => [   8,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "WITHHOLD_VCH2"                => [   9,  16,   6, 0x00000000003F0000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "RSVD3"                        => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FORCE_DEBIT_VCH1"             => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "WITHHOLD_VCH1"                => [  12,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "RSVD4"                        => [  13,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FORCE_DEBIT_VCH0"             => [  14,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "WITHHOLD_VCH0"                => [  15,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VCh0" ],
);

%nl4rtr_01_00269_def =
( NAME    => "R4_PORTH_DEBIT",
  ADDRESS => 0x000000000f0018d0,
  NOTE    => "This register allows diagnostic control of the debit counters. The note debit counters are used to track the debits (credits at ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00269_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_CREDIT_STATE                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00270_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CREDITS_VCH3"                 => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "CREDITS_VCH2"                 => [   1,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "CREDITS_VCH1"                 => [   2,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "CREDITS_VCH0"                 => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "RSVD0"                        => [   4,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBITS_VCH3"                  => [   5,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RSVD1"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBITS_VCH2"                  => [   7,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RSVD2"                        => [   8,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBITS_VCH1"                  => [   9,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RSVD3"                        => [  10,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBITS_VCH0"                  => [  11,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "VCh0" ],
);

%nl4rtr_01_00270_def =
( NAME    => "R4_PORTH_CREDIT_STATE",
  ADDRESS => 0x000000000f0018d8,
  NOTE    => "This register is observing the state of the Debit and Credit note counters for each virtual channel. This register is for diagno",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00270_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_LLP_PKT                                                     #
#                                                                        #
##########################################################################

%nl4rtr_01_00271_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Micropacket Count" ],
);

%nl4rtr_01_00271_def =
( NAME    => "R4_PORTH_LLP_PKT",
  ADDRESS => 0x000000000f0018e0,
  NOTE    => "This register counts DataValid pulses from the PFSSR. Each note DataValid pulse represents two micropackets.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00271_flds
);


##########################################################################
#                                                                        #
#   R4_HARD_RESET                                                        #
#                                                                        #
##########################################################################

%nl4rtr_01_00272_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HARD_RESET"                   => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Hard Reset" ],
);

%nl4rtr_01_00272_def =
( NAME    => "R4_HARD_RESET",
  ADDRESS => 0x0000000001003000,
  NOTE    => "NL4R Hard Reset",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00272_flds
);


##########################################################################
#                                                                        #
#   R4_SOFT_RESET                                                        #
#                                                                        #
##########################################################################

%nl4rtr_01_00273_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SOFT_RESET"                   => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Soft Reset" ],
);

%nl4rtr_01_00273_def =
( NAME    => "R4_SOFT_RESET",
  ADDRESS => 0x0000000001003008,
  NOTE    => "NL4R Soft Reset",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00273_flds
);


##########################################################################
#                                                                        #
#   R4_PORT_RESET                                                        #
#                                                                        #
##########################################################################

%nl4rtr_01_00274_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  10,  54, 0xFFFFFFFFFFFFFC00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PORT_WARM_RESET"              => [   1,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Warm Reset to Ports" ],
   "PORTH_LINK_RESET"             => [   2,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Link Reset for PortH" ],
   "PORTG_LINK_RESET"             => [   3,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Link Reset for PortG" ],
   "PORTF_LINK_RESET"             => [   4,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Link Reset for PortF" ],
   "PORTE_LINK_RESET"             => [   5,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Link Reset for PortE" ],
   "PORTD_LINK_RESET"             => [   6,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Link Reset for PortD" ],
   "PORTC_LINK_RESET"             => [   7,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Link Reset for PortC" ],
   "PORTB_LINK_RESET"             => [   8,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Link Reset for PortB" ],
   "PORTA_LINK_RESET"             => [   9,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Link Reset for PortA" ],
   "LB_RESET"                     => [  10,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Local Block Reset" ],
);

%nl4rtr_01_00274_def =
( NAME    => "R4_PORT_RESET",
  ADDRESS => 0x0000000001003010,
  NOTE    => "The PORT_RESET register sends link reset or warm reset to Ports and note soft reset to the Local Block.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00274_flds
);


##########################################################################
#                                                                        #
#   R4_PROTECTION_CONFIG                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00275_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LB_FORCE_LOCAL_LUT"           => [   1,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "LB Force Local LUT" ],
   "PORTH_FORCE_LOCAL_LUT"        => [   2,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "PortH Force Local LUT" ],
   "PORTG_FORCE_LOCAL_LUT"        => [   3,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "PortG Force Local LUT" ],
   "PORTF_FORCE_LOCAL_LUT"        => [   4,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "PortF Force Local LUT" ],
   "PORTE_FORCE_LOCAL_LUT"        => [   5,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "PortE Force Local LUT" ],
   "PORTD_FORCE_LOCAL_LUT"        => [   6,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "PortD Force Local LUT" ],
   "PORTC_FORCE_LOCAL_LUT"        => [   7,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "PortC Force Local LUT" ],
   "PORTB_FORCE_LOCAL_LUT"        => [   8,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "PortB Force Local LUT" ],
   "PORTA_FORCE_LOCAL_LUT"        => [   9,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "PortA Force Local LUT" ],
   "NODE_ID"                      => [  10,   8,  14, 0x00000000003FFF00, 0x00, 1, 0x0000000000000000, "Node ID" ],
   "PORTH_LOCAL_RESET_EN"         => [  11,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Local Reset Enable for PortH" ],
   "PORTG_LOCAL_RESET_EN"         => [  12,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Local Reset Enable for PortG" ],
   "PORTF_LOCAL_RESET_EN"         => [  13,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Local Reset Enable for PortF" ],
   "PORTE_LOCAL_RESET_EN"         => [  14,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Local Reset Enable for PortE" ],
   "PORTD_LOCAL_RESET_EN"         => [  15,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Local Reset Enable for PortD" ],
   "PORTC_LOCAL_RESET_EN"         => [  16,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Local Reset Enable for PortC" ],
   "PORTB_LOCAL_RESET_EN"         => [  17,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Local Reset Enable for PortB" ],
   "PORTA_LOCAL_RESET_EN"         => [  18,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Local Reset Enable for PortA" ],
);

%nl4rtr_01_00275_def =
( NAME    => "R4_PROTECTION_CONFIG",
  ADDRESS => 0x0000000001003018,
  NOTE    => "The PROTECTION_CONFIG register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00275_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_RST_MASK                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00276_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FROM_PORTH"                   => [   1,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Warm Reset for PortH permitted" ],
   "FROM_PORTG"                   => [   2,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Warm Reset for PortG permitted" ],
   "FROM_PORTF"                   => [   3,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Warm Reset for PortF permitted" ],
   "FROM_PORTE"                   => [   4,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Warm Reset for PortE permitted" ],
   "FROM_PORTD"                   => [   5,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Warm Reset for PortD permitted" ],
   "FROM_PORTC"                   => [   6,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Warm Reset for PortC permitted" ],
   "FROM_PORTB"                   => [   7,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Warm Reset for PortB permitted" ],
   "FROM_PORTA"                   => [   8,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Warm Reset for PortA permitted" ],
);

%nl4rtr_01_00276_def =
( NAME    => "R4_PORTA_RST_MASK",
  ADDRESS => 0x0000000001003020,
  NOTE    => "The RESET_MASK register for a port. This register defines which of note the 8 ports are able to send warm reset this port's link",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00276_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_RST_MASK                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00277_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FROM_PORTH"                   => [   1,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Warm Reset for PortH permitted" ],
   "FROM_PORTG"                   => [   2,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Warm Reset for PortG permitted" ],
   "FROM_PORTF"                   => [   3,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Warm Reset for PortF permitted" ],
   "FROM_PORTE"                   => [   4,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Warm Reset for PortE permitted" ],
   "FROM_PORTD"                   => [   5,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Warm Reset for PortD permitted" ],
   "FROM_PORTC"                   => [   6,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Warm Reset for PortC permitted" ],
   "FROM_PORTB"                   => [   7,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Warm Reset for PortB permitted" ],
   "FROM_PORTA"                   => [   8,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Warm Reset for PortA permitted" ],
);

%nl4rtr_01_00277_def =
( NAME    => "R4_PORTB_RST_MASK",
  ADDRESS => 0x0000000001003028,
  NOTE    => "Port Reset Mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00277_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_RST_MASK                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00278_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FROM_PORTH"                   => [   1,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Warm Reset for PortH permitted" ],
   "FROM_PORTG"                   => [   2,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Warm Reset for PortG permitted" ],
   "FROM_PORTF"                   => [   3,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Warm Reset for PortF permitted" ],
   "FROM_PORTE"                   => [   4,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Warm Reset for PortE permitted" ],
   "FROM_PORTD"                   => [   5,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Warm Reset for PortD permitted" ],
   "FROM_PORTC"                   => [   6,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Warm Reset for PortC permitted" ],
   "FROM_PORTB"                   => [   7,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Warm Reset for PortB permitted" ],
   "FROM_PORTA"                   => [   8,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Warm Reset for PortA permitted" ],
);

%nl4rtr_01_00278_def =
( NAME    => "R4_PORTC_RST_MASK",
  ADDRESS => 0x0000000001003030,
  NOTE    => "Port Reset Mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00278_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_RST_MASK                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00279_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FROM_PORTH"                   => [   1,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Warm Reset for PortH permitted" ],
   "FROM_PORTG"                   => [   2,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Warm Reset for PortG permitted" ],
   "FROM_PORTF"                   => [   3,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Warm Reset for PortF permitted" ],
   "FROM_PORTE"                   => [   4,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Warm Reset for PortE permitted" ],
   "FROM_PORTD"                   => [   5,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Warm Reset for PortD permitted" ],
   "FROM_PORTC"                   => [   6,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Warm Reset for PortC permitted" ],
   "FROM_PORTB"                   => [   7,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Warm Reset for PortB permitted" ],
   "FROM_PORTA"                   => [   8,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Warm Reset for PortA permitted" ],
);

%nl4rtr_01_00279_def =
( NAME    => "R4_PORTD_RST_MASK",
  ADDRESS => 0x0000000001003038,
  NOTE    => "Port Reset Mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00279_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_RST_MASK                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00280_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FROM_PORTH"                   => [   1,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Warm Reset for PortH permitted" ],
   "FROM_PORTG"                   => [   2,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Warm Reset for PortG permitted" ],
   "FROM_PORTF"                   => [   3,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Warm Reset for PortF permitted" ],
   "FROM_PORTE"                   => [   4,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Warm Reset for PortE permitted" ],
   "FROM_PORTD"                   => [   5,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Warm Reset for PortD permitted" ],
   "FROM_PORTC"                   => [   6,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Warm Reset for PortC permitted" ],
   "FROM_PORTB"                   => [   7,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Warm Reset for PortB permitted" ],
   "FROM_PORTA"                   => [   8,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Warm Reset for PortA permitted" ],
);

%nl4rtr_01_00280_def =
( NAME    => "R4_PORTE_RST_MASK",
  ADDRESS => 0x0000000001003040,
  NOTE    => "Port Reset Mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00280_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_RST_MASK                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00281_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FROM_PORTH"                   => [   1,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Warm Reset for PortH permitted" ],
   "FROM_PORTG"                   => [   2,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Warm Reset for PortG permitted" ],
   "FROM_PORTF"                   => [   3,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Warm Reset for PortF permitted" ],
   "FROM_PORTE"                   => [   4,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Warm Reset for PortE permitted" ],
   "FROM_PORTD"                   => [   5,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Warm Reset for PortD permitted" ],
   "FROM_PORTC"                   => [   6,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Warm Reset for PortC permitted" ],
   "FROM_PORTB"                   => [   7,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Warm Reset for PortB permitted" ],
   "FROM_PORTA"                   => [   8,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Warm Reset for PortA permitted" ],
);

%nl4rtr_01_00281_def =
( NAME    => "R4_PORTF_RST_MASK",
  ADDRESS => 0x0000000001003048,
  NOTE    => "Port Reset Mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00281_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_RST_MASK                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00282_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FROM_PORTH"                   => [   1,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Warm Reset for PortH permitted" ],
   "FROM_PORTG"                   => [   2,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Warm Reset for PortG permitted" ],
   "FROM_PORTF"                   => [   3,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Warm Reset for PortF permitted" ],
   "FROM_PORTE"                   => [   4,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Warm Reset for PortE permitted" ],
   "FROM_PORTD"                   => [   5,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Warm Reset for PortD permitted" ],
   "FROM_PORTC"                   => [   6,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Warm Reset for PortC permitted" ],
   "FROM_PORTB"                   => [   7,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Warm Reset for PortB permitted" ],
   "FROM_PORTA"                   => [   8,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Warm Reset for PortA permitted" ],
);

%nl4rtr_01_00282_def =
( NAME    => "R4_PORTG_RST_MASK",
  ADDRESS => 0x0000000001003050,
  NOTE    => "Port Reset Mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00282_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_RST_MASK                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00283_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FROM_PORTH"                   => [   1,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Warm Reset for PortH permitted" ],
   "FROM_PORTG"                   => [   2,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Warm Reset for PortG permitted" ],
   "FROM_PORTF"                   => [   3,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Warm Reset for PortF permitted" ],
   "FROM_PORTE"                   => [   4,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Warm Reset for PortE permitted" ],
   "FROM_PORTD"                   => [   5,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Warm Reset for PortD permitted" ],
   "FROM_PORTC"                   => [   6,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Warm Reset for PortC permitted" ],
   "FROM_PORTB"                   => [   7,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Warm Reset for PortB permitted" ],
   "FROM_PORTA"                   => [   8,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Warm Reset for PortA permitted" ],
);

%nl4rtr_01_00283_def =
( NAME    => "R4_PORTH_RST_MASK",
  ADDRESS => 0x0000000001003058,
  NOTE    => "Port Reset Mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00283_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_ERROR_SUMMARY                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00284_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTEND_TURN_ERR"              => [   1,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CORESENTBADCRC_CNT_NON_ZERO"  => [   2,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RETRY_CNT_NON_ZERO"           => [   3,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CB_ERROR_CNT_NON_ZERO"        => [   4,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "" ],
   "SN_ERROR_CNT_NON_ZERO"        => [   5,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_TAIL_TO_VCH3"             => [   6,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RCV_TAIL_TO_VCH2"             => [   7,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RCV_TAIL_TO_VCH1"             => [   8,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RCV_TAIL_TO_VCH0"             => [   9,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "SEND_DEADLOCK_TO_VCH3"        => [  10,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "SEND_DEADLOCK_TO_VCH2"        => [  11,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "SEND_DEADLOCK_TO_VCH1"        => [  12,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "SEND_DEADLOCK_TO_VCH0"        => [  13,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "DAMQ_DEADLOCK_TO_VCH3"        => [  14,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "DAMQ_DEADLOCK_TO_VCH2"        => [  15,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "DAMQ_DEADLOCK_TO_VCH1"        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "DAMQ_DEADLOCK_TO_VCH0"        => [  17,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "INVALID_GLOBAL_LU_VCH3"       => [  18,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "INVALID_GLOBAL_LU_VCH2"       => [  19,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "INVALID_GLOBAL_LU_VCH1"       => [  20,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "INVALID_GLOBAL_LU_VCH0"       => [  21,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "INVALID_LOCAL_LU_VCH3"        => [  22,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "INVALID_LOCAL_LU_VCH2"        => [  23,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "INVALID_LOCAL_LU_VCH1"        => [  24,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "INVALID_LOCAL_LU_VCH0"        => [  25,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "DATELINE_ERROR_VCH3"          => [  26,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Dataline error on Vch3" ],
   "DATELINE_ERROR_VCH1"          => [  27,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Dataline error on Vch1" ],
   "ILLEGAL_DIR_VCH3"             => [  28,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "ILLEGAL_DIR_VCH2"             => [  29,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "ILLEGAL_DIR_VCH1"             => [  30,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "ILLEGAL_DIR_VCH0"             => [  31,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "CREDIT_OVERFLOW_VCH3"         => [  32,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "CREDIT_OVERFLOW_VCH2"         => [  33,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "CREDIT_OVERFLOW_VCH1"         => [  34,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "CREDIT_OVERFLOW_VCH0"         => [  35,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "FIFO_OVERFLOW_VCH3"           => [  36,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "FIFO_OVERFLOW_VCH2"           => [  37,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "FIFO_OVERFLOW_VCH1"           => [  38,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "FIFO_OVERFLOW_VCH0"           => [  39,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "BUFFER_OVERFLOW_VCH3"         => [  40,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "BUFFER_OVERFLOW_VCH2"         => [  41,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "BUFFER_OVERFLOW_VCH1"         => [  42,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "BUFFER_OVERFLOW_VCH0"         => [  43,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "RETRY_TO"                     => [  44,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Retry Timeout" ],
   "RCV_LINK_RESET"               => [  45,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Received Link Reset" ],
   "RCV_WARM_RESET"               => [  46,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Received Warm Reset" ],
   "POWER_NOT_OK"                 => [  47,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Power Not OK" ],
);

%nl4rtr_01_00284_def =
( NAME    => "R4_PORTA_ERROR_SUMMARY",
  ADDRESS => 0x0000000008002200,
  NOTE    => "The PORTA_ERROR_SUMMARY contains a summary of all errors since the note last write to the PORTA_ERROR_CLEAR register. The note P",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00284_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_ERROR_CLEAR                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00285_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
);

%nl4rtr_01_00285_def =
( NAME    => "R4_PORTA_ERROR_CLEAR",
  ADDRESS => 0x0000000008002208,
  NOTE    => "The PORTA_ERROR_CLEAR register clears the PORTA_ERROR_SUMMARY note register.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00285_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_FIRST_ERROR                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00286_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTEND_TURN_ERR"              => [   1,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CORESENTBADCRC_CNT_NON_ZERO"  => [   2,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RETRY_CNT_NON_ZERO"           => [   3,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CB_ERROR_CNT_NON_ZERO"        => [   4,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "" ],
   "SN_ERROR_CNT_NON_ZERO"        => [   5,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_TAIL_TO_VCH3"             => [   6,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RCV_TAIL_TO_VCH2"             => [   7,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RCV_TAIL_TO_VCH1"             => [   8,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RCV_TAIL_TO_VCH0"             => [   9,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "SEND_DEADLOCK_TO_VCH3"        => [  10,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "SEND_DEADLOCK_TO_VCH2"        => [  11,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "SEND_DEADLOCK_TO_VCH1"        => [  12,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "SEND_DEADLOCK_TO_VCH0"        => [  13,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "DAMQ_DEADLOCK_TO_VCH3"        => [  14,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "DAMQ_DEADLOCK_TO_VCH2"        => [  15,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "DAMQ_DEADLOCK_TO_VCH1"        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "DAMQ_DEADLOCK_TO_VCH0"        => [  17,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "INVALID_GLOBAL_LU_VCH3"       => [  18,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "INVALID_GLOBAL_LU_VCH2"       => [  19,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "INVALID_GLOBAL_LU_VCH1"       => [  20,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "INVALID_GLOBAL_LU_VCH0"       => [  21,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "INVALID_LOCAL_LU_VCH3"        => [  22,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "INVALID_LOCAL_LU_VCH2"        => [  23,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "INVALID_LOCAL_LU_VCH1"        => [  24,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "INVALID_LOCAL_LU_VCH0"        => [  25,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "DATELINE_ERROR_VCH3"          => [  26,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Dataline error on Vch3" ],
   "DATELINE_ERROR_VCH1"          => [  27,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Dataline error on Vch1" ],
   "ILLEGAL_DIR_VCH3"             => [  28,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "ILLEGAL_DIR_VCH2"             => [  29,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "ILLEGAL_DIR_VCH1"             => [  30,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "ILLEGAL_DIR_VCH0"             => [  31,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "CREDIT_OVERFLOW_VCH3"         => [  32,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "CREDIT_OVERFLOW_VCH2"         => [  33,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "CREDIT_OVERFLOW_VCH1"         => [  34,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "CREDIT_OVERFLOW_VCH0"         => [  35,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "FIFO_OVERFLOW_VCH3"           => [  36,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "FIFO_OVERFLOW_VCH2"           => [  37,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "FIFO_OVERFLOW_VCH1"           => [  38,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "FIFO_OVERFLOW_VCH0"           => [  39,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "BUFFER_OVERFLOW_VCH3"         => [  40,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "BUFFER_OVERFLOW_VCH2"         => [  41,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "BUFFER_OVERFLOW_VCH1"         => [  42,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "BUFFER_OVERFLOW_VCH0"         => [  43,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "RETRY_TO"                     => [  44,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Retry Timeout" ],
   "RCV_LINK_RESET"               => [  45,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Received Link Reset" ],
   "RCV_WARM_RESET"               => [  46,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Received Warm Reset" ],
   "POWER_NOT_OK"                 => [  47,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Power Not OK" ],
);

%nl4rtr_01_00286_def =
( NAME    => "R4_PORTA_FIRST_ERROR",
  ADDRESS => 0x0000000008002210,
  NOTE    => "The PORTA_FIRST_ERROR register holds the very first error detected note and only that error.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00286_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_ERROR_REPORT_MASK                                           #
#                                                                        #
##########################################################################

%nl4rtr_01_00287_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTEND_TURN_ERR"              => [   1,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "" ],
   "CORESENTBADCRC_CNT_NON_ZERO"  => [   2,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RETRY_CNT_NON_ZERO"           => [   3,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "" ],
   "CB_ERROR_CNT_NON_ZERO"        => [   4,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "" ],
   "SN_ERROR_CNT_NON_ZERO"        => [   5,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RCV_TAIL_TO_VCH3"             => [   6,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "RCV_TAIL_TO_VCH2"             => [   7,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "RCV_TAIL_TO_VCH1"             => [   8,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "RCV_TAIL_TO_VCH0"             => [   9,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "SEND_DEADLOCK_TO_VCH3"        => [  10,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "SEND_DEADLOCK_TO_VCH2"        => [  11,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "SEND_DEADLOCK_TO_VCH1"        => [  12,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "SEND_DEADLOCK_TO_VCH0"        => [  13,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "DAMQ_DEADLOCK_TO_VCH3"        => [  14,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "DAMQ_DEADLOCK_TO_VCH2"        => [  15,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "DAMQ_DEADLOCK_TO_VCH1"        => [  16,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "DAMQ_DEADLOCK_TO_VCH0"        => [  17,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "INVALID_GLOBAL_LU_VCH3"       => [  18,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "INVALID_GLOBAL_LU_VCH2"       => [  19,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "INVALID_GLOBAL_LU_VCH1"       => [  20,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "INVALID_GLOBAL_LU_VCH0"       => [  21,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "INVALID_LOCAL_LU_VCH3"        => [  22,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "INVALID_LOCAL_LU_VCH2"        => [  23,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "INVALID_LOCAL_LU_VCH1"        => [  24,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "INVALID_LOCAL_LU_VCH0"        => [  25,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "DATELINE_ERROR_VCH3"          => [  26,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "Dataline error on Vch3" ],
   "DATELINE_ERROR_VCH1"          => [  27,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "Dataline error on Vch1" ],
   "ILLEGAL_DIR_VCH3"             => [  28,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "ILLEGAL_DIR_VCH2"             => [  29,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "ILLEGAL_DIR_VCH1"             => [  30,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "ILLEGAL_DIR_VCH0"             => [  31,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "CREDIT_OVERFLOW_VCH3"         => [  32,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "CREDIT_OVERFLOW_VCH2"         => [  33,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "CREDIT_OVERFLOW_VCH1"         => [  34,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "CREDIT_OVERFLOW_VCH0"         => [  35,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "FIFO_OVERFLOW_VCH3"           => [  36,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "FIFO_OVERFLOW_VCH2"           => [  37,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "FIFO_OVERFLOW_VCH1"           => [  38,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "FIFO_OVERFLOW_VCH0"           => [  39,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "BUFFER_OVERFLOW_VCH3"         => [  40,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "BUFFER_OVERFLOW_VCH2"         => [  41,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "BUFFER_OVERFLOW_VCH1"         => [  42,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "BUFFER_OVERFLOW_VCH0"         => [  43,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "RETRY_TO"                     => [  44,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Retry Timeout" ],
   "RCV_LINK_RESET"               => [  45,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Received Link Reset" ],
   "RCV_WARM_RESET"               => [  46,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Received Warm Reset" ],
   "POWER_NOT_OK"                 => [  47,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Power Not OK" ],
);

%nl4rtr_01_00287_def =
( NAME    => "R4_PORTA_ERROR_REPORT_MASK",
  ADDRESS => 0x0000000008002218,
  NOTE    => "The PORTA_ERROR_REPORT_MASK register is used to mask errors from note being reported to a higher level. If a field is set to a o",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00287_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_ERROR_DETAIL                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00288_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DETAIL"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Detailed Error Data" ],
);

%nl4rtr_01_00288_def =
( NAME    => "R4_PORTA_ERROR_DETAIL",
  ADDRESS => 0x0000000008002000,
  NOTE    => "Port A Error Detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00288_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_ERROR_DETAIL_CLEAR                                          #
#                                                                        #
##########################################################################

%nl4rtr_01_00289_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE"                       => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Clear all error detail registers" ],
);

%nl4rtr_01_00289_def =
( NAME    => "R4_PORTA_ERROR_DETAIL_CLEAR",
  ADDRESS => 0x0000000008002100,
  NOTE    => "A write to this register causes a one-shot pulse which causes a note counter to cycle through each Error Detail location and wri",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00289_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_ERROR_SUMMARY                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00290_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTEND_TURN_ERR"              => [   1,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CORESENTBADCRC_CNT_NON_ZERO"  => [   2,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RETRY_CNT_NON_ZERO"           => [   3,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CB_ERROR_CNT_NON_ZERO"        => [   4,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "" ],
   "SN_ERROR_CNT_NON_ZERO"        => [   5,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_TAIL_TO_VCH3"             => [   6,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RCV_TAIL_TO_VCH2"             => [   7,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RCV_TAIL_TO_VCH1"             => [   8,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RCV_TAIL_TO_VCH0"             => [   9,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "SEND_DEADLOCK_TO_VCH3"        => [  10,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "SEND_DEADLOCK_TO_VCH2"        => [  11,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "SEND_DEADLOCK_TO_VCH1"        => [  12,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "SEND_DEADLOCK_TO_VCH0"        => [  13,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "DAMQ_DEADLOCK_TO_VCH3"        => [  14,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "DAMQ_DEADLOCK_TO_VCH2"        => [  15,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "DAMQ_DEADLOCK_TO_VCH1"        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "DAMQ_DEADLOCK_TO_VCH0"        => [  17,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "INVALID_GLOBAL_LU_VCH3"       => [  18,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "INVALID_GLOBAL_LU_VCH2"       => [  19,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "INVALID_GLOBAL_LU_VCH1"       => [  20,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "INVALID_GLOBAL_LU_VCH0"       => [  21,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "INVALID_LOCAL_LU_VCH3"        => [  22,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "INVALID_LOCAL_LU_VCH2"        => [  23,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "INVALID_LOCAL_LU_VCH1"        => [  24,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "INVALID_LOCAL_LU_VCH0"        => [  25,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "DATELINE_ERROR_VCH3"          => [  26,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Dataline error on Vch3" ],
   "DATELINE_ERROR_VCH1"          => [  27,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Dataline error on Vch1" ],
   "ILLEGAL_DIR_VCH3"             => [  28,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "ILLEGAL_DIR_VCH2"             => [  29,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "ILLEGAL_DIR_VCH1"             => [  30,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "ILLEGAL_DIR_VCH0"             => [  31,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "CREDIT_OVERFLOW_VCH3"         => [  32,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "CREDIT_OVERFLOW_VCH2"         => [  33,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "CREDIT_OVERFLOW_VCH1"         => [  34,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "CREDIT_OVERFLOW_VCH0"         => [  35,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "FIFO_OVERFLOW_VCH3"           => [  36,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "FIFO_OVERFLOW_VCH2"           => [  37,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "FIFO_OVERFLOW_VCH1"           => [  38,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "FIFO_OVERFLOW_VCH0"           => [  39,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "BUFFER_OVERFLOW_VCH3"         => [  40,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "BUFFER_OVERFLOW_VCH2"         => [  41,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "BUFFER_OVERFLOW_VCH1"         => [  42,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "BUFFER_OVERFLOW_VCH0"         => [  43,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "RETRY_TO"                     => [  44,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Retry Timeout" ],
   "RCV_LINK_RESET"               => [  45,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Received Link Reset" ],
   "RCV_WARM_RESET"               => [  46,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Received Warm Reset" ],
   "POWER_NOT_OK"                 => [  47,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Power Not OK" ],
);

%nl4rtr_01_00290_def =
( NAME    => "R4_PORTB_ERROR_SUMMARY",
  ADDRESS => 0x0000000009002200,
  NOTE    => "The PORTB_ERROR_SUMMARY contains a summary of all errors since the note last write to the PORTB_ERROR_CLEAR register. The note P",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00290_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_ERROR_CLEAR                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00291_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
);

%nl4rtr_01_00291_def =
( NAME    => "R4_PORTB_ERROR_CLEAR",
  ADDRESS => 0x0000000009002208,
  NOTE    => "The PORTB_ERROR_CLEAR register clears the PORTB_ERROR_SUMMARY note register.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00291_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_FIRST_ERROR                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00292_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTEND_TURN_ERR"              => [   1,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CORESENTBADCRC_CNT_NON_ZERO"  => [   2,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RETRY_CNT_NON_ZERO"           => [   3,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CB_ERROR_CNT_NON_ZERO"        => [   4,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "" ],
   "SN_ERROR_CNT_NON_ZERO"        => [   5,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_TAIL_TO_VCH3"             => [   6,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RCV_TAIL_TO_VCH2"             => [   7,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RCV_TAIL_TO_VCH1"             => [   8,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RCV_TAIL_TO_VCH0"             => [   9,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "SEND_DEADLOCK_TO_VCH3"        => [  10,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "SEND_DEADLOCK_TO_VCH2"        => [  11,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "SEND_DEADLOCK_TO_VCH1"        => [  12,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "SEND_DEADLOCK_TO_VCH0"        => [  13,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "DAMQ_DEADLOCK_TO_VCH3"        => [  14,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "DAMQ_DEADLOCK_TO_VCH2"        => [  15,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "DAMQ_DEADLOCK_TO_VCH1"        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "DAMQ_DEADLOCK_TO_VCH0"        => [  17,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "INVALID_GLOBAL_LU_VCH3"       => [  18,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "INVALID_GLOBAL_LU_VCH2"       => [  19,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "INVALID_GLOBAL_LU_VCH1"       => [  20,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "INVALID_GLOBAL_LU_VCH0"       => [  21,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "INVALID_LOCAL_LU_VCH3"        => [  22,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "INVALID_LOCAL_LU_VCH2"        => [  23,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "INVALID_LOCAL_LU_VCH1"        => [  24,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "INVALID_LOCAL_LU_VCH0"        => [  25,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "DATELINE_ERROR_VCH3"          => [  26,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Dataline error on Vch3" ],
   "DATELINE_ERROR_VCH1"          => [  27,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Dataline error on Vch1" ],
   "ILLEGAL_DIR_VCH3"             => [  28,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "ILLEGAL_DIR_VCH2"             => [  29,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "ILLEGAL_DIR_VCH1"             => [  30,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "ILLEGAL_DIR_VCH0"             => [  31,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "CREDIT_OVERFLOW_VCH3"         => [  32,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "CREDIT_OVERFLOW_VCH2"         => [  33,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "CREDIT_OVERFLOW_VCH1"         => [  34,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "CREDIT_OVERFLOW_VCH0"         => [  35,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "FIFO_OVERFLOW_VCH3"           => [  36,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "FIFO_OVERFLOW_VCH2"           => [  37,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "FIFO_OVERFLOW_VCH1"           => [  38,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "FIFO_OVERFLOW_VCH0"           => [  39,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "BUFFER_OVERFLOW_VCH3"         => [  40,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "BUFFER_OVERFLOW_VCH2"         => [  41,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "BUFFER_OVERFLOW_VCH1"         => [  42,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "BUFFER_OVERFLOW_VCH0"         => [  43,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "RETRY_TO"                     => [  44,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Retry Timeout" ],
   "RCV_LINK_RESET"               => [  45,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Received Link Reset" ],
   "RCV_WARM_RESET"               => [  46,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Received Warm Reset" ],
   "POWER_NOT_OK"                 => [  47,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Power Not OK" ],
);

%nl4rtr_01_00292_def =
( NAME    => "R4_PORTB_FIRST_ERROR",
  ADDRESS => 0x0000000009002210,
  NOTE    => "The PORTB_FIRST_ERROR register holds the very first error detected note and only that error.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00292_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_ERROR_REPORT_MASK                                           #
#                                                                        #
##########################################################################

%nl4rtr_01_00293_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTEND_TURN_ERR"              => [   1,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "" ],
   "CORESENTBADCRC_CNT_NON_ZERO"  => [   2,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RETRY_CNT_NON_ZERO"           => [   3,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "" ],
   "CB_ERROR_CNT_NON_ZERO"        => [   4,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "" ],
   "SN_ERROR_CNT_NON_ZERO"        => [   5,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RCV_TAIL_TO_VCH3"             => [   6,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "RCV_TAIL_TO_VCH2"             => [   7,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "RCV_TAIL_TO_VCH1"             => [   8,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "RCV_TAIL_TO_VCH0"             => [   9,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "SEND_DEADLOCK_TO_VCH3"        => [  10,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "SEND_DEADLOCK_TO_VCH2"        => [  11,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "SEND_DEADLOCK_TO_VCH1"        => [  12,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "SEND_DEADLOCK_TO_VCH0"        => [  13,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "DAMQ_DEADLOCK_TO_VCH3"        => [  14,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "DAMQ_DEADLOCK_TO_VCH2"        => [  15,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "DAMQ_DEADLOCK_TO_VCH1"        => [  16,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "DAMQ_DEADLOCK_TO_VCH0"        => [  17,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "INVALID_GLOBAL_LU_VCH3"       => [  18,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "INVALID_GLOBAL_LU_VCH2"       => [  19,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "INVALID_GLOBAL_LU_VCH1"       => [  20,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "INVALID_GLOBAL_LU_VCH0"       => [  21,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "INVALID_LOCAL_LU_VCH3"        => [  22,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "INVALID_LOCAL_LU_VCH2"        => [  23,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "INVALID_LOCAL_LU_VCH1"        => [  24,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "INVALID_LOCAL_LU_VCH0"        => [  25,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "DATELINE_ERROR_VCH3"          => [  26,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "Dataline error on Vch3" ],
   "DATELINE_ERROR_VCH1"          => [  27,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "Dataline error on Vch1" ],
   "ILLEGAL_DIR_VCH3"             => [  28,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "ILLEGAL_DIR_VCH2"             => [  29,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "ILLEGAL_DIR_VCH1"             => [  30,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "ILLEGAL_DIR_VCH0"             => [  31,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "CREDIT_OVERFLOW_VCH3"         => [  32,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "CREDIT_OVERFLOW_VCH2"         => [  33,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "CREDIT_OVERFLOW_VCH1"         => [  34,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "CREDIT_OVERFLOW_VCH0"         => [  35,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "FIFO_OVERFLOW_VCH3"           => [  36,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "FIFO_OVERFLOW_VCH2"           => [  37,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "FIFO_OVERFLOW_VCH1"           => [  38,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "FIFO_OVERFLOW_VCH0"           => [  39,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "BUFFER_OVERFLOW_VCH3"         => [  40,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "BUFFER_OVERFLOW_VCH2"         => [  41,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "BUFFER_OVERFLOW_VCH1"         => [  42,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "BUFFER_OVERFLOW_VCH0"         => [  43,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "RETRY_TO"                     => [  44,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Retry Timeout" ],
   "RCV_LINK_RESET"               => [  45,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Received Link Reset" ],
   "RCV_WARM_RESET"               => [  46,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Received Warm Reset" ],
   "POWER_NOT_OK"                 => [  47,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Power Not OK" ],
);

%nl4rtr_01_00293_def =
( NAME    => "R4_PORTB_ERROR_REPORT_MASK",
  ADDRESS => 0x0000000009002218,
  NOTE    => "The PORTB_ERROR_REPORT_MASK register is used to mask errors from note being reported to a higher level. If a field is set to a o",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00293_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_ERROR_DETAIL                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00294_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DETAIL"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Detailed Error Data" ],
);

%nl4rtr_01_00294_def =
( NAME    => "R4_PORTB_ERROR_DETAIL",
  ADDRESS => 0x0000000009002000,
  NOTE    => "Port B Error Detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00294_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_ERROR_DETAIL_CLEAR                                          #
#                                                                        #
##########################################################################

%nl4rtr_01_00295_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE"                       => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Clear all error detail registers" ],
);

%nl4rtr_01_00295_def =
( NAME    => "R4_PORTB_ERROR_DETAIL_CLEAR",
  ADDRESS => 0x0000000009002100,
  NOTE    => "A write to this register causes a one-shot pulse which causes a note counter to cycle through each Error Detail location and wri",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00295_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_ERROR_SUMMARY                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00296_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTEND_TURN_ERR"              => [   1,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CORESENTBADCRC_CNT_NON_ZERO"  => [   2,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RETRY_CNT_NON_ZERO"           => [   3,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CB_ERROR_CNT_NON_ZERO"        => [   4,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "" ],
   "SN_ERROR_CNT_NON_ZERO"        => [   5,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_TAIL_TO_VCH3"             => [   6,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RCV_TAIL_TO_VCH2"             => [   7,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RCV_TAIL_TO_VCH1"             => [   8,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RCV_TAIL_TO_VCH0"             => [   9,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "SEND_DEADLOCK_TO_VCH3"        => [  10,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "SEND_DEADLOCK_TO_VCH2"        => [  11,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "SEND_DEADLOCK_TO_VCH1"        => [  12,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "SEND_DEADLOCK_TO_VCH0"        => [  13,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "DAMQ_DEADLOCK_TO_VCH3"        => [  14,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "DAMQ_DEADLOCK_TO_VCH2"        => [  15,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "DAMQ_DEADLOCK_TO_VCH1"        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "DAMQ_DEADLOCK_TO_VCH0"        => [  17,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "INVALID_GLOBAL_LU_VCH3"       => [  18,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "INVALID_GLOBAL_LU_VCH2"       => [  19,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "INVALID_GLOBAL_LU_VCH1"       => [  20,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "INVALID_GLOBAL_LU_VCH0"       => [  21,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "INVALID_LOCAL_LU_VCH3"        => [  22,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "INVALID_LOCAL_LU_VCH2"        => [  23,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "INVALID_LOCAL_LU_VCH1"        => [  24,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "INVALID_LOCAL_LU_VCH0"        => [  25,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "DATELINE_ERROR_VCH3"          => [  26,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Dataline error on Vch3" ],
   "DATELINE_ERROR_VCH1"          => [  27,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Dataline error on Vch1" ],
   "ILLEGAL_DIR_VCH3"             => [  28,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "ILLEGAL_DIR_VCH2"             => [  29,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "ILLEGAL_DIR_VCH1"             => [  30,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "ILLEGAL_DIR_VCH0"             => [  31,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "CREDIT_OVERFLOW_VCH3"         => [  32,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "CREDIT_OVERFLOW_VCH2"         => [  33,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "CREDIT_OVERFLOW_VCH1"         => [  34,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "CREDIT_OVERFLOW_VCH0"         => [  35,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "FIFO_OVERFLOW_VCH3"           => [  36,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "FIFO_OVERFLOW_VCH2"           => [  37,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "FIFO_OVERFLOW_VCH1"           => [  38,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "FIFO_OVERFLOW_VCH0"           => [  39,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "BUFFER_OVERFLOW_VCH3"         => [  40,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "BUFFER_OVERFLOW_VCH2"         => [  41,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "BUFFER_OVERFLOW_VCH1"         => [  42,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "BUFFER_OVERFLOW_VCH0"         => [  43,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "RETRY_TO"                     => [  44,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Retry Timeout" ],
   "RCV_LINK_RESET"               => [  45,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Received Link Reset" ],
   "RCV_WARM_RESET"               => [  46,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Received Warm Reset" ],
   "POWER_NOT_OK"                 => [  47,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Power Not OK" ],
);

%nl4rtr_01_00296_def =
( NAME    => "R4_PORTC_ERROR_SUMMARY",
  ADDRESS => 0x000000000a002200,
  NOTE    => "The PORTC_ERROR_SUMMARY contains a summary of all errors since the note last write to the PORTC_ERROR_CLEAR register. The note P",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00296_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_ERROR_CLEAR                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00297_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
);

%nl4rtr_01_00297_def =
( NAME    => "R4_PORTC_ERROR_CLEAR",
  ADDRESS => 0x000000000a002208,
  NOTE    => "The PORTC_ERROR_CLEAR register clears the PORTC_ERROR_SUMMARY note register.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00297_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_FIRST_ERROR                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00298_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTEND_TURN_ERR"              => [   1,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CORESENTBADCRC_CNT_NON_ZERO"  => [   2,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RETRY_CNT_NON_ZERO"           => [   3,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CB_ERROR_CNT_NON_ZERO"        => [   4,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "" ],
   "SN_ERROR_CNT_NON_ZERO"        => [   5,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_TAIL_TO_VCH3"             => [   6,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RCV_TAIL_TO_VCH2"             => [   7,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RCV_TAIL_TO_VCH1"             => [   8,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RCV_TAIL_TO_VCH0"             => [   9,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "SEND_DEADLOCK_TO_VCH3"        => [  10,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "SEND_DEADLOCK_TO_VCH2"        => [  11,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "SEND_DEADLOCK_TO_VCH1"        => [  12,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "SEND_DEADLOCK_TO_VCH0"        => [  13,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "DAMQ_DEADLOCK_TO_VCH3"        => [  14,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "DAMQ_DEADLOCK_TO_VCH2"        => [  15,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "DAMQ_DEADLOCK_TO_VCH1"        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "DAMQ_DEADLOCK_TO_VCH0"        => [  17,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "INVALID_GLOBAL_LU_VCH3"       => [  18,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "INVALID_GLOBAL_LU_VCH2"       => [  19,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "INVALID_GLOBAL_LU_VCH1"       => [  20,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "INVALID_GLOBAL_LU_VCH0"       => [  21,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "INVALID_LOCAL_LU_VCH3"        => [  22,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "INVALID_LOCAL_LU_VCH2"        => [  23,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "INVALID_LOCAL_LU_VCH1"        => [  24,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "INVALID_LOCAL_LU_VCH0"        => [  25,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "DATELINE_ERROR_VCH3"          => [  26,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Dataline error on Vch3" ],
   "DATELINE_ERROR_VCH1"          => [  27,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Dataline error on Vch1" ],
   "ILLEGAL_DIR_VCH3"             => [  28,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "ILLEGAL_DIR_VCH2"             => [  29,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "ILLEGAL_DIR_VCH1"             => [  30,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "ILLEGAL_DIR_VCH0"             => [  31,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "CREDIT_OVERFLOW_VCH3"         => [  32,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "CREDIT_OVERFLOW_VCH2"         => [  33,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "CREDIT_OVERFLOW_VCH1"         => [  34,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "CREDIT_OVERFLOW_VCH0"         => [  35,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "FIFO_OVERFLOW_VCH3"           => [  36,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "FIFO_OVERFLOW_VCH2"           => [  37,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "FIFO_OVERFLOW_VCH1"           => [  38,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "FIFO_OVERFLOW_VCH0"           => [  39,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "BUFFER_OVERFLOW_VCH3"         => [  40,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "BUFFER_OVERFLOW_VCH2"         => [  41,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "BUFFER_OVERFLOW_VCH1"         => [  42,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "BUFFER_OVERFLOW_VCH0"         => [  43,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "RETRY_TO"                     => [  44,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Retry Timeout" ],
   "RCV_LINK_RESET"               => [  45,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Received Link Reset" ],
   "RCV_WARM_RESET"               => [  46,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Received Warm Reset" ],
   "POWER_NOT_OK"                 => [  47,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Power Not OK" ],
);

%nl4rtr_01_00298_def =
( NAME    => "R4_PORTC_FIRST_ERROR",
  ADDRESS => 0x000000000a002210,
  NOTE    => "The PORTC_FIRST_ERROR register holds the very first error detected note and only that error.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00298_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_ERROR_REPORT_MASK                                           #
#                                                                        #
##########################################################################

%nl4rtr_01_00299_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTEND_TURN_ERR"              => [   1,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "" ],
   "CORESENTBADCRC_CNT_NON_ZERO"  => [   2,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RETRY_CNT_NON_ZERO"           => [   3,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "" ],
   "CB_ERROR_CNT_NON_ZERO"        => [   4,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "" ],
   "SN_ERROR_CNT_NON_ZERO"        => [   5,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RCV_TAIL_TO_VCH3"             => [   6,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "RCV_TAIL_TO_VCH2"             => [   7,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "RCV_TAIL_TO_VCH1"             => [   8,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "RCV_TAIL_TO_VCH0"             => [   9,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "SEND_DEADLOCK_TO_VCH3"        => [  10,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "SEND_DEADLOCK_TO_VCH2"        => [  11,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "SEND_DEADLOCK_TO_VCH1"        => [  12,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "SEND_DEADLOCK_TO_VCH0"        => [  13,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "DAMQ_DEADLOCK_TO_VCH3"        => [  14,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "DAMQ_DEADLOCK_TO_VCH2"        => [  15,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "DAMQ_DEADLOCK_TO_VCH1"        => [  16,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "DAMQ_DEADLOCK_TO_VCH0"        => [  17,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "INVALID_GLOBAL_LU_VCH3"       => [  18,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "INVALID_GLOBAL_LU_VCH2"       => [  19,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "INVALID_GLOBAL_LU_VCH1"       => [  20,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "INVALID_GLOBAL_LU_VCH0"       => [  21,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "INVALID_LOCAL_LU_VCH3"        => [  22,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "INVALID_LOCAL_LU_VCH2"        => [  23,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "INVALID_LOCAL_LU_VCH1"        => [  24,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "INVALID_LOCAL_LU_VCH0"        => [  25,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "DATELINE_ERROR_VCH3"          => [  26,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "Dataline error on Vch3" ],
   "DATELINE_ERROR_VCH1"          => [  27,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "Dataline error on Vch1" ],
   "ILLEGAL_DIR_VCH3"             => [  28,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "ILLEGAL_DIR_VCH2"             => [  29,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "ILLEGAL_DIR_VCH1"             => [  30,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "ILLEGAL_DIR_VCH0"             => [  31,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "CREDIT_OVERFLOW_VCH3"         => [  32,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "CREDIT_OVERFLOW_VCH2"         => [  33,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "CREDIT_OVERFLOW_VCH1"         => [  34,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "CREDIT_OVERFLOW_VCH0"         => [  35,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "FIFO_OVERFLOW_VCH3"           => [  36,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "FIFO_OVERFLOW_VCH2"           => [  37,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "FIFO_OVERFLOW_VCH1"           => [  38,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "FIFO_OVERFLOW_VCH0"           => [  39,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "BUFFER_OVERFLOW_VCH3"         => [  40,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "BUFFER_OVERFLOW_VCH2"         => [  41,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "BUFFER_OVERFLOW_VCH1"         => [  42,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "BUFFER_OVERFLOW_VCH0"         => [  43,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "RETRY_TO"                     => [  44,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Retry Timeout" ],
   "RCV_LINK_RESET"               => [  45,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Received Link Reset" ],
   "RCV_WARM_RESET"               => [  46,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Received Warm Reset" ],
   "POWER_NOT_OK"                 => [  47,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Power Not OK" ],
);

%nl4rtr_01_00299_def =
( NAME    => "R4_PORTC_ERROR_REPORT_MASK",
  ADDRESS => 0x000000000a002218,
  NOTE    => "The PORTC_ERROR_REPORT_MASK register is used to mask errors from note being reported to a higher level. If a field is set to a o",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00299_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_ERROR_DETAIL                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00300_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DETAIL"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Detailed Error Data" ],
);

%nl4rtr_01_00300_def =
( NAME    => "R4_PORTC_ERROR_DETAIL",
  ADDRESS => 0x000000000a002000,
  NOTE    => "Port C Error Detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00300_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_ERROR_DETAIL_CLEAR                                          #
#                                                                        #
##########################################################################

%nl4rtr_01_00301_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE"                       => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Clear all error detail registers" ],
);

%nl4rtr_01_00301_def =
( NAME    => "R4_PORTC_ERROR_DETAIL_CLEAR",
  ADDRESS => 0x000000000a002100,
  NOTE    => "A write to this register causes a one-shot pulse which causes a note counter to cycle through each Error Detail location and wri",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00301_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_ERROR_SUMMARY                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00302_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTEND_TURN_ERR"              => [   1,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CORESENTBADCRC_CNT_NON_ZERO"  => [   2,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RETRY_CNT_NON_ZERO"           => [   3,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CB_ERROR_CNT_NON_ZERO"        => [   4,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "" ],
   "SN_ERROR_CNT_NON_ZERO"        => [   5,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_TAIL_TO_VCH3"             => [   6,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RCV_TAIL_TO_VCH2"             => [   7,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RCV_TAIL_TO_VCH1"             => [   8,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RCV_TAIL_TO_VCH0"             => [   9,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "SEND_DEADLOCK_TO_VCH3"        => [  10,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "SEND_DEADLOCK_TO_VCH2"        => [  11,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "SEND_DEADLOCK_TO_VCH1"        => [  12,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "SEND_DEADLOCK_TO_VCH0"        => [  13,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "DAMQ_DEADLOCK_TO_VCH3"        => [  14,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "DAMQ_DEADLOCK_TO_VCH2"        => [  15,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "DAMQ_DEADLOCK_TO_VCH1"        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "DAMQ_DEADLOCK_TO_VCH0"        => [  17,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "INVALID_GLOBAL_LU_VCH3"       => [  18,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "INVALID_GLOBAL_LU_VCH2"       => [  19,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "INVALID_GLOBAL_LU_VCH1"       => [  20,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "INVALID_GLOBAL_LU_VCH0"       => [  21,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "INVALID_LOCAL_LU_VCH3"        => [  22,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "INVALID_LOCAL_LU_VCH2"        => [  23,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "INVALID_LOCAL_LU_VCH1"        => [  24,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "INVALID_LOCAL_LU_VCH0"        => [  25,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "DATELINE_ERROR_VCH3"          => [  26,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Dataline error on Vch3" ],
   "DATELINE_ERROR_VCH1"          => [  27,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Dataline error on Vch1" ],
   "ILLEGAL_DIR_VCH3"             => [  28,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "ILLEGAL_DIR_VCH2"             => [  29,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "ILLEGAL_DIR_VCH1"             => [  30,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "ILLEGAL_DIR_VCH0"             => [  31,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "CREDIT_OVERFLOW_VCH3"         => [  32,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "CREDIT_OVERFLOW_VCH2"         => [  33,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "CREDIT_OVERFLOW_VCH1"         => [  34,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "CREDIT_OVERFLOW_VCH0"         => [  35,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "FIFO_OVERFLOW_VCH3"           => [  36,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "FIFO_OVERFLOW_VCH2"           => [  37,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "FIFO_OVERFLOW_VCH1"           => [  38,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "FIFO_OVERFLOW_VCH0"           => [  39,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "BUFFER_OVERFLOW_VCH3"         => [  40,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "BUFFER_OVERFLOW_VCH2"         => [  41,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "BUFFER_OVERFLOW_VCH1"         => [  42,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "BUFFER_OVERFLOW_VCH0"         => [  43,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "RETRY_TO"                     => [  44,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Retry Timeout" ],
   "RCV_LINK_RESET"               => [  45,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Received Link Reset" ],
   "RCV_WARM_RESET"               => [  46,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Received Warm Reset" ],
   "POWER_NOT_OK"                 => [  47,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Power Not OK" ],
);

%nl4rtr_01_00302_def =
( NAME    => "R4_PORTD_ERROR_SUMMARY",
  ADDRESS => 0x000000000b002200,
  NOTE    => "The PORTD_ERROR_SUMMARY contains a summary of all errors since the note last write to the PORTD_ERROR_CLEAR register. The note P",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00302_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_ERROR_CLEAR                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00303_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
);

%nl4rtr_01_00303_def =
( NAME    => "R4_PORTD_ERROR_CLEAR",
  ADDRESS => 0x000000000b002208,
  NOTE    => "The PORTD_ERROR_CLEAR register clears the PORTD_ERROR_SUMMARY note register.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00303_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_FIRST_ERROR                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00304_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTEND_TURN_ERR"              => [   1,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CORESENTBADCRC_CNT_NON_ZERO"  => [   2,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RETRY_CNT_NON_ZERO"           => [   3,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CB_ERROR_CNT_NON_ZERO"        => [   4,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "" ],
   "SN_ERROR_CNT_NON_ZERO"        => [   5,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_TAIL_TO_VCH3"             => [   6,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RCV_TAIL_TO_VCH2"             => [   7,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RCV_TAIL_TO_VCH1"             => [   8,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RCV_TAIL_TO_VCH0"             => [   9,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "SEND_DEADLOCK_TO_VCH3"        => [  10,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "SEND_DEADLOCK_TO_VCH2"        => [  11,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "SEND_DEADLOCK_TO_VCH1"        => [  12,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "SEND_DEADLOCK_TO_VCH0"        => [  13,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "DAMQ_DEADLOCK_TO_VCH3"        => [  14,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "DAMQ_DEADLOCK_TO_VCH2"        => [  15,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "DAMQ_DEADLOCK_TO_VCH1"        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "DAMQ_DEADLOCK_TO_VCH0"        => [  17,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "INVALID_GLOBAL_LU_VCH3"       => [  18,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "INVALID_GLOBAL_LU_VCH2"       => [  19,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "INVALID_GLOBAL_LU_VCH1"       => [  20,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "INVALID_GLOBAL_LU_VCH0"       => [  21,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "INVALID_LOCAL_LU_VCH3"        => [  22,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "INVALID_LOCAL_LU_VCH2"        => [  23,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "INVALID_LOCAL_LU_VCH1"        => [  24,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "INVALID_LOCAL_LU_VCH0"        => [  25,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "DATELINE_ERROR_VCH3"          => [  26,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Dataline error on Vch3" ],
   "DATELINE_ERROR_VCH1"          => [  27,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Dataline error on Vch1" ],
   "ILLEGAL_DIR_VCH3"             => [  28,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "ILLEGAL_DIR_VCH2"             => [  29,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "ILLEGAL_DIR_VCH1"             => [  30,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "ILLEGAL_DIR_VCH0"             => [  31,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "CREDIT_OVERFLOW_VCH3"         => [  32,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "CREDIT_OVERFLOW_VCH2"         => [  33,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "CREDIT_OVERFLOW_VCH1"         => [  34,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "CREDIT_OVERFLOW_VCH0"         => [  35,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "FIFO_OVERFLOW_VCH3"           => [  36,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "FIFO_OVERFLOW_VCH2"           => [  37,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "FIFO_OVERFLOW_VCH1"           => [  38,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "FIFO_OVERFLOW_VCH0"           => [  39,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "BUFFER_OVERFLOW_VCH3"         => [  40,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "BUFFER_OVERFLOW_VCH2"         => [  41,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "BUFFER_OVERFLOW_VCH1"         => [  42,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "BUFFER_OVERFLOW_VCH0"         => [  43,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "RETRY_TO"                     => [  44,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Retry Timeout" ],
   "RCV_LINK_RESET"               => [  45,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Received Link Reset" ],
   "RCV_WARM_RESET"               => [  46,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Received Warm Reset" ],
   "POWER_NOT_OK"                 => [  47,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Power Not OK" ],
);

%nl4rtr_01_00304_def =
( NAME    => "R4_PORTD_FIRST_ERROR",
  ADDRESS => 0x000000000b002210,
  NOTE    => "The PORTD_FIRST_ERROR register holds the very first error detected note and only that error.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00304_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_ERROR_REPORT_MASK                                           #
#                                                                        #
##########################################################################

%nl4rtr_01_00305_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTEND_TURN_ERR"              => [   1,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "" ],
   "CORESENTBADCRC_CNT_NON_ZERO"  => [   2,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RETRY_CNT_NON_ZERO"           => [   3,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "" ],
   "CB_ERROR_CNT_NON_ZERO"        => [   4,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "" ],
   "SN_ERROR_CNT_NON_ZERO"        => [   5,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RCV_TAIL_TO_VCH3"             => [   6,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "RCV_TAIL_TO_VCH2"             => [   7,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "RCV_TAIL_TO_VCH1"             => [   8,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "RCV_TAIL_TO_VCH0"             => [   9,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "SEND_DEADLOCK_TO_VCH3"        => [  10,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "SEND_DEADLOCK_TO_VCH2"        => [  11,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "SEND_DEADLOCK_TO_VCH1"        => [  12,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "SEND_DEADLOCK_TO_VCH0"        => [  13,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "DAMQ_DEADLOCK_TO_VCH3"        => [  14,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "DAMQ_DEADLOCK_TO_VCH2"        => [  15,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "DAMQ_DEADLOCK_TO_VCH1"        => [  16,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "DAMQ_DEADLOCK_TO_VCH0"        => [  17,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "INVALID_GLOBAL_LU_VCH3"       => [  18,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "INVALID_GLOBAL_LU_VCH2"       => [  19,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "INVALID_GLOBAL_LU_VCH1"       => [  20,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "INVALID_GLOBAL_LU_VCH0"       => [  21,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "INVALID_LOCAL_LU_VCH3"        => [  22,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "INVALID_LOCAL_LU_VCH2"        => [  23,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "INVALID_LOCAL_LU_VCH1"        => [  24,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "INVALID_LOCAL_LU_VCH0"        => [  25,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "DATELINE_ERROR_VCH3"          => [  26,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "Dataline error on Vch3" ],
   "DATELINE_ERROR_VCH1"          => [  27,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "Dataline error on Vch1" ],
   "ILLEGAL_DIR_VCH3"             => [  28,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "ILLEGAL_DIR_VCH2"             => [  29,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "ILLEGAL_DIR_VCH1"             => [  30,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "ILLEGAL_DIR_VCH0"             => [  31,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "CREDIT_OVERFLOW_VCH3"         => [  32,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "CREDIT_OVERFLOW_VCH2"         => [  33,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "CREDIT_OVERFLOW_VCH1"         => [  34,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "CREDIT_OVERFLOW_VCH0"         => [  35,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "FIFO_OVERFLOW_VCH3"           => [  36,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "FIFO_OVERFLOW_VCH2"           => [  37,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "FIFO_OVERFLOW_VCH1"           => [  38,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "FIFO_OVERFLOW_VCH0"           => [  39,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "BUFFER_OVERFLOW_VCH3"         => [  40,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "BUFFER_OVERFLOW_VCH2"         => [  41,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "BUFFER_OVERFLOW_VCH1"         => [  42,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "BUFFER_OVERFLOW_VCH0"         => [  43,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "RETRY_TO"                     => [  44,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Retry Timeout" ],
   "RCV_LINK_RESET"               => [  45,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Received Link Reset" ],
   "RCV_WARM_RESET"               => [  46,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Received Warm Reset" ],
   "POWER_NOT_OK"                 => [  47,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Power Not OK" ],
);

%nl4rtr_01_00305_def =
( NAME    => "R4_PORTD_ERROR_REPORT_MASK",
  ADDRESS => 0x000000000b002218,
  NOTE    => "The PORTD_ERROR_REPORT_MASK register is used to mask errors from note being reported to a higher level. If a field is set to a o",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00305_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_ERROR_DETAIL                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00306_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DETAIL"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Detailed Error Data" ],
);

%nl4rtr_01_00306_def =
( NAME    => "R4_PORTD_ERROR_DETAIL",
  ADDRESS => 0x000000000b002000,
  NOTE    => "Port D Error Detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00306_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_ERROR_DETAIL_CLEAR                                          #
#                                                                        #
##########################################################################

%nl4rtr_01_00307_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE"                       => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Clear all error detail registers" ],
);

%nl4rtr_01_00307_def =
( NAME    => "R4_PORTD_ERROR_DETAIL_CLEAR",
  ADDRESS => 0x000000000b002100,
  NOTE    => "A write to this register causes a one-shot pulse which causes a note counter to cycle through each Error Detail location and wri",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00307_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_ERROR_SUMMARY                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00308_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTEND_TURN_ERR"              => [   1,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CORESENTBADCRC_CNT_NON_ZERO"  => [   2,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RETRY_CNT_NON_ZERO"           => [   3,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CB_ERROR_CNT_NON_ZERO"        => [   4,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "" ],
   "SN_ERROR_CNT_NON_ZERO"        => [   5,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_TAIL_TO_VCH3"             => [   6,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RCV_TAIL_TO_VCH2"             => [   7,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RCV_TAIL_TO_VCH1"             => [   8,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RCV_TAIL_TO_VCH0"             => [   9,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "SEND_DEADLOCK_TO_VCH3"        => [  10,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "SEND_DEADLOCK_TO_VCH2"        => [  11,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "SEND_DEADLOCK_TO_VCH1"        => [  12,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "SEND_DEADLOCK_TO_VCH0"        => [  13,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "DAMQ_DEADLOCK_TO_VCH3"        => [  14,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "DAMQ_DEADLOCK_TO_VCH2"        => [  15,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "DAMQ_DEADLOCK_TO_VCH1"        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "DAMQ_DEADLOCK_TO_VCH0"        => [  17,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "INVALID_GLOBAL_LU_VCH3"       => [  18,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "INVALID_GLOBAL_LU_VCH2"       => [  19,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "INVALID_GLOBAL_LU_VCH1"       => [  20,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "INVALID_GLOBAL_LU_VCH0"       => [  21,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "INVALID_LOCAL_LU_VCH3"        => [  22,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "INVALID_LOCAL_LU_VCH2"        => [  23,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "INVALID_LOCAL_LU_VCH1"        => [  24,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "INVALID_LOCAL_LU_VCH0"        => [  25,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "DATELINE_ERROR_VCH3"          => [  26,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Dataline error on Vch3" ],
   "DATELINE_ERROR_VCH1"          => [  27,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Dataline error on Vch1" ],
   "ILLEGAL_DIR_VCH3"             => [  28,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "ILLEGAL_DIR_VCH2"             => [  29,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "ILLEGAL_DIR_VCH1"             => [  30,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "ILLEGAL_DIR_VCH0"             => [  31,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "CREDIT_OVERFLOW_VCH3"         => [  32,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "CREDIT_OVERFLOW_VCH2"         => [  33,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "CREDIT_OVERFLOW_VCH1"         => [  34,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "CREDIT_OVERFLOW_VCH0"         => [  35,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "FIFO_OVERFLOW_VCH3"           => [  36,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "FIFO_OVERFLOW_VCH2"           => [  37,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "FIFO_OVERFLOW_VCH1"           => [  38,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "FIFO_OVERFLOW_VCH0"           => [  39,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "BUFFER_OVERFLOW_VCH3"         => [  40,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "BUFFER_OVERFLOW_VCH2"         => [  41,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "BUFFER_OVERFLOW_VCH1"         => [  42,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "BUFFER_OVERFLOW_VCH0"         => [  43,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "RETRY_TO"                     => [  44,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Retry Timeout" ],
   "RCV_LINK_RESET"               => [  45,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Received Link Reset" ],
   "RCV_WARM_RESET"               => [  46,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Received Warm Reset" ],
   "POWER_NOT_OK"                 => [  47,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Power Not OK" ],
);

%nl4rtr_01_00308_def =
( NAME    => "R4_PORTE_ERROR_SUMMARY",
  ADDRESS => 0x000000000c002200,
  NOTE    => "The PORTE_ERROR_SUMMARY contains a summary of all errors since the note last write to the PORTE_ERROR_CLEAR register. The note P",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00308_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_ERROR_CLEAR                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00309_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
);

%nl4rtr_01_00309_def =
( NAME    => "R4_PORTE_ERROR_CLEAR",
  ADDRESS => 0x000000000c002208,
  NOTE    => "The PORTE_ERROR_CLEAR register clears the PORTE_ERROR_SUMMARY note register.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00309_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_FIRST_ERROR                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00310_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTEND_TURN_ERR"              => [   1,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CORESENTBADCRC_CNT_NON_ZERO"  => [   2,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RETRY_CNT_NON_ZERO"           => [   3,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CB_ERROR_CNT_NON_ZERO"        => [   4,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "" ],
   "SN_ERROR_CNT_NON_ZERO"        => [   5,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_TAIL_TO_VCH3"             => [   6,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RCV_TAIL_TO_VCH2"             => [   7,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RCV_TAIL_TO_VCH1"             => [   8,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RCV_TAIL_TO_VCH0"             => [   9,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "SEND_DEADLOCK_TO_VCH3"        => [  10,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "SEND_DEADLOCK_TO_VCH2"        => [  11,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "SEND_DEADLOCK_TO_VCH1"        => [  12,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "SEND_DEADLOCK_TO_VCH0"        => [  13,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "DAMQ_DEADLOCK_TO_VCH3"        => [  14,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "DAMQ_DEADLOCK_TO_VCH2"        => [  15,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "DAMQ_DEADLOCK_TO_VCH1"        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "DAMQ_DEADLOCK_TO_VCH0"        => [  17,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "INVALID_GLOBAL_LU_VCH3"       => [  18,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "INVALID_GLOBAL_LU_VCH2"       => [  19,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "INVALID_GLOBAL_LU_VCH1"       => [  20,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "INVALID_GLOBAL_LU_VCH0"       => [  21,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "INVALID_LOCAL_LU_VCH3"        => [  22,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "INVALID_LOCAL_LU_VCH2"        => [  23,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "INVALID_LOCAL_LU_VCH1"        => [  24,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "INVALID_LOCAL_LU_VCH0"        => [  25,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "DATELINE_ERROR_VCH3"          => [  26,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Dataline error on Vch3" ],
   "DATELINE_ERROR_VCH1"          => [  27,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Dataline error on Vch1" ],
   "ILLEGAL_DIR_VCH3"             => [  28,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "ILLEGAL_DIR_VCH2"             => [  29,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "ILLEGAL_DIR_VCH1"             => [  30,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "ILLEGAL_DIR_VCH0"             => [  31,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "CREDIT_OVERFLOW_VCH3"         => [  32,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "CREDIT_OVERFLOW_VCH2"         => [  33,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "CREDIT_OVERFLOW_VCH1"         => [  34,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "CREDIT_OVERFLOW_VCH0"         => [  35,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "FIFO_OVERFLOW_VCH3"           => [  36,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "FIFO_OVERFLOW_VCH2"           => [  37,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "FIFO_OVERFLOW_VCH1"           => [  38,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "FIFO_OVERFLOW_VCH0"           => [  39,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "BUFFER_OVERFLOW_VCH3"         => [  40,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "BUFFER_OVERFLOW_VCH2"         => [  41,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "BUFFER_OVERFLOW_VCH1"         => [  42,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "BUFFER_OVERFLOW_VCH0"         => [  43,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "RETRY_TO"                     => [  44,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Retry Timeout" ],
   "RCV_LINK_RESET"               => [  45,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Received Link Reset" ],
   "RCV_WARM_RESET"               => [  46,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Received Warm Reset" ],
   "POWER_NOT_OK"                 => [  47,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Power Not OK" ],
);

%nl4rtr_01_00310_def =
( NAME    => "R4_PORTE_FIRST_ERROR",
  ADDRESS => 0x000000000c002210,
  NOTE    => "The PORTE_FIRST_ERROR register holds the very first error detected note and only that error.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00310_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_ERROR_REPORT_MASK                                           #
#                                                                        #
##########################################################################

%nl4rtr_01_00311_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTEND_TURN_ERR"              => [   1,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "" ],
   "CORESENTBADCRC_CNT_NON_ZERO"  => [   2,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RETRY_CNT_NON_ZERO"           => [   3,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "" ],
   "CB_ERROR_CNT_NON_ZERO"        => [   4,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "" ],
   "SN_ERROR_CNT_NON_ZERO"        => [   5,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RCV_TAIL_TO_VCH3"             => [   6,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "RCV_TAIL_TO_VCH2"             => [   7,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "RCV_TAIL_TO_VCH1"             => [   8,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "RCV_TAIL_TO_VCH0"             => [   9,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "SEND_DEADLOCK_TO_VCH3"        => [  10,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "SEND_DEADLOCK_TO_VCH2"        => [  11,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "SEND_DEADLOCK_TO_VCH1"        => [  12,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "SEND_DEADLOCK_TO_VCH0"        => [  13,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "DAMQ_DEADLOCK_TO_VCH3"        => [  14,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "DAMQ_DEADLOCK_TO_VCH2"        => [  15,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "DAMQ_DEADLOCK_TO_VCH1"        => [  16,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "DAMQ_DEADLOCK_TO_VCH0"        => [  17,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "INVALID_GLOBAL_LU_VCH3"       => [  18,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "INVALID_GLOBAL_LU_VCH2"       => [  19,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "INVALID_GLOBAL_LU_VCH1"       => [  20,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "INVALID_GLOBAL_LU_VCH0"       => [  21,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "INVALID_LOCAL_LU_VCH3"        => [  22,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "INVALID_LOCAL_LU_VCH2"        => [  23,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "INVALID_LOCAL_LU_VCH1"        => [  24,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "INVALID_LOCAL_LU_VCH0"        => [  25,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "DATELINE_ERROR_VCH3"          => [  26,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "Dataline error on Vch3" ],
   "DATELINE_ERROR_VCH1"          => [  27,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "Dataline error on Vch1" ],
   "ILLEGAL_DIR_VCH3"             => [  28,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "ILLEGAL_DIR_VCH2"             => [  29,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "ILLEGAL_DIR_VCH1"             => [  30,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "ILLEGAL_DIR_VCH0"             => [  31,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "CREDIT_OVERFLOW_VCH3"         => [  32,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "CREDIT_OVERFLOW_VCH2"         => [  33,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "CREDIT_OVERFLOW_VCH1"         => [  34,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "CREDIT_OVERFLOW_VCH0"         => [  35,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "FIFO_OVERFLOW_VCH3"           => [  36,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "FIFO_OVERFLOW_VCH2"           => [  37,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "FIFO_OVERFLOW_VCH1"           => [  38,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "FIFO_OVERFLOW_VCH0"           => [  39,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "BUFFER_OVERFLOW_VCH3"         => [  40,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "BUFFER_OVERFLOW_VCH2"         => [  41,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "BUFFER_OVERFLOW_VCH1"         => [  42,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "BUFFER_OVERFLOW_VCH0"         => [  43,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "RETRY_TO"                     => [  44,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Retry Timeout" ],
   "RCV_LINK_RESET"               => [  45,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Received Link Reset" ],
   "RCV_WARM_RESET"               => [  46,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Received Warm Reset" ],
   "POWER_NOT_OK"                 => [  47,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Power Not OK" ],
);

%nl4rtr_01_00311_def =
( NAME    => "R4_PORTE_ERROR_REPORT_MASK",
  ADDRESS => 0x000000000c002218,
  NOTE    => "The PORTE_ERROR_REPORT_MASK register is used to mask errors from note being reported to a higher level. If a field is set to a o",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00311_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_ERROR_DETAIL                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00312_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DETAIL"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Detailed Error Data" ],
);

%nl4rtr_01_00312_def =
( NAME    => "R4_PORTE_ERROR_DETAIL",
  ADDRESS => 0x000000000c002000,
  NOTE    => "Port E Error Detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00312_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_ERROR_DETAIL_CLEAR                                          #
#                                                                        #
##########################################################################

%nl4rtr_01_00313_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE"                       => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Clear all error detail registers" ],
);

%nl4rtr_01_00313_def =
( NAME    => "R4_PORTE_ERROR_DETAIL_CLEAR",
  ADDRESS => 0x000000000c002100,
  NOTE    => "A write to this register causes a one-shot pulse which causes a note counter to cycle through each Error Detail location and wri",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00313_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_ERROR_SUMMARY                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00314_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTEND_TURN_ERR"              => [   1,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CORESENTBADCRC_CNT_NON_ZERO"  => [   2,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RETRY_CNT_NON_ZERO"           => [   3,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CB_ERROR_CNT_NON_ZERO"        => [   4,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "" ],
   "SN_ERROR_CNT_NON_ZERO"        => [   5,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_TAIL_TO_VCH3"             => [   6,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RCV_TAIL_TO_VCH2"             => [   7,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RCV_TAIL_TO_VCH1"             => [   8,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RCV_TAIL_TO_VCH0"             => [   9,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "SEND_DEADLOCK_TO_VCH3"        => [  10,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "SEND_DEADLOCK_TO_VCH2"        => [  11,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "SEND_DEADLOCK_TO_VCH1"        => [  12,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "SEND_DEADLOCK_TO_VCH0"        => [  13,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "DAMQ_DEADLOCK_TO_VCH3"        => [  14,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "DAMQ_DEADLOCK_TO_VCH2"        => [  15,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "DAMQ_DEADLOCK_TO_VCH1"        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "DAMQ_DEADLOCK_TO_VCH0"        => [  17,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "INVALID_GLOBAL_LU_VCH3"       => [  18,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "INVALID_GLOBAL_LU_VCH2"       => [  19,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "INVALID_GLOBAL_LU_VCH1"       => [  20,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "INVALID_GLOBAL_LU_VCH0"       => [  21,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "INVALID_LOCAL_LU_VCH3"        => [  22,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "INVALID_LOCAL_LU_VCH2"        => [  23,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "INVALID_LOCAL_LU_VCH1"        => [  24,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "INVALID_LOCAL_LU_VCH0"        => [  25,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "DATELINE_ERROR_VCH3"          => [  26,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Dataline error on Vch3" ],
   "DATELINE_ERROR_VCH1"          => [  27,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Dataline error on Vch1" ],
   "ILLEGAL_DIR_VCH3"             => [  28,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "ILLEGAL_DIR_VCH2"             => [  29,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "ILLEGAL_DIR_VCH1"             => [  30,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "ILLEGAL_DIR_VCH0"             => [  31,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "CREDIT_OVERFLOW_VCH3"         => [  32,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "CREDIT_OVERFLOW_VCH2"         => [  33,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "CREDIT_OVERFLOW_VCH1"         => [  34,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "CREDIT_OVERFLOW_VCH0"         => [  35,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "FIFO_OVERFLOW_VCH3"           => [  36,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "FIFO_OVERFLOW_VCH2"           => [  37,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "FIFO_OVERFLOW_VCH1"           => [  38,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "FIFO_OVERFLOW_VCH0"           => [  39,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "BUFFER_OVERFLOW_VCH3"         => [  40,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "BUFFER_OVERFLOW_VCH2"         => [  41,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "BUFFER_OVERFLOW_VCH1"         => [  42,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "BUFFER_OVERFLOW_VCH0"         => [  43,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "RETRY_TO"                     => [  44,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Retry Timeout" ],
   "RCV_LINK_RESET"               => [  45,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Received Link Reset" ],
   "RCV_WARM_RESET"               => [  46,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Received Warm Reset" ],
   "POWER_NOT_OK"                 => [  47,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Power Not OK" ],
);

%nl4rtr_01_00314_def =
( NAME    => "R4_PORTF_ERROR_SUMMARY",
  ADDRESS => 0x000000000d002200,
  NOTE    => "The PORTF_ERROR_SUMMARY contains a summary of all errors since the note last write to the PORTF_ERROR_CLEAR register. The note P",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00314_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_ERROR_CLEAR                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00315_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
);

%nl4rtr_01_00315_def =
( NAME    => "R4_PORTF_ERROR_CLEAR",
  ADDRESS => 0x000000000d002208,
  NOTE    => "The PORTF_ERROR_CLEAR register clears the PORTF_ERROR_SUMMARY note register.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00315_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_FIRST_ERROR                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00316_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTEND_TURN_ERR"              => [   1,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CORESENTBADCRC_CNT_NON_ZERO"  => [   2,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RETRY_CNT_NON_ZERO"           => [   3,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CB_ERROR_CNT_NON_ZERO"        => [   4,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "" ],
   "SN_ERROR_CNT_NON_ZERO"        => [   5,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_TAIL_TO_VCH3"             => [   6,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RCV_TAIL_TO_VCH2"             => [   7,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RCV_TAIL_TO_VCH1"             => [   8,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RCV_TAIL_TO_VCH0"             => [   9,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "SEND_DEADLOCK_TO_VCH3"        => [  10,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "SEND_DEADLOCK_TO_VCH2"        => [  11,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "SEND_DEADLOCK_TO_VCH1"        => [  12,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "SEND_DEADLOCK_TO_VCH0"        => [  13,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "DAMQ_DEADLOCK_TO_VCH3"        => [  14,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "DAMQ_DEADLOCK_TO_VCH2"        => [  15,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "DAMQ_DEADLOCK_TO_VCH1"        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "DAMQ_DEADLOCK_TO_VCH0"        => [  17,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "INVALID_GLOBAL_LU_VCH3"       => [  18,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "INVALID_GLOBAL_LU_VCH2"       => [  19,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "INVALID_GLOBAL_LU_VCH1"       => [  20,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "INVALID_GLOBAL_LU_VCH0"       => [  21,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "INVALID_LOCAL_LU_VCH3"        => [  22,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "INVALID_LOCAL_LU_VCH2"        => [  23,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "INVALID_LOCAL_LU_VCH1"        => [  24,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "INVALID_LOCAL_LU_VCH0"        => [  25,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "DATELINE_ERROR_VCH3"          => [  26,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Dataline error on Vch3" ],
   "DATELINE_ERROR_VCH1"          => [  27,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Dataline error on Vch1" ],
   "ILLEGAL_DIR_VCH3"             => [  28,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "ILLEGAL_DIR_VCH2"             => [  29,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "ILLEGAL_DIR_VCH1"             => [  30,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "ILLEGAL_DIR_VCH0"             => [  31,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "CREDIT_OVERFLOW_VCH3"         => [  32,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "CREDIT_OVERFLOW_VCH2"         => [  33,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "CREDIT_OVERFLOW_VCH1"         => [  34,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "CREDIT_OVERFLOW_VCH0"         => [  35,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "FIFO_OVERFLOW_VCH3"           => [  36,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "FIFO_OVERFLOW_VCH2"           => [  37,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "FIFO_OVERFLOW_VCH1"           => [  38,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "FIFO_OVERFLOW_VCH0"           => [  39,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "BUFFER_OVERFLOW_VCH3"         => [  40,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "BUFFER_OVERFLOW_VCH2"         => [  41,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "BUFFER_OVERFLOW_VCH1"         => [  42,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "BUFFER_OVERFLOW_VCH0"         => [  43,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "RETRY_TO"                     => [  44,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Retry Timeout" ],
   "RCV_LINK_RESET"               => [  45,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Received Link Reset" ],
   "RCV_WARM_RESET"               => [  46,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Received Warm Reset" ],
   "POWER_NOT_OK"                 => [  47,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Power Not OK" ],
);

%nl4rtr_01_00316_def =
( NAME    => "R4_PORTF_FIRST_ERROR",
  ADDRESS => 0x000000000d002210,
  NOTE    => "The PORTF_FIRST_ERROR register holds the very first error detected note and only that error.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00316_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_ERROR_REPORT_MASK                                           #
#                                                                        #
##########################################################################

%nl4rtr_01_00317_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTEND_TURN_ERR"              => [   1,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "" ],
   "CORESENTBADCRC_CNT_NON_ZERO"  => [   2,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RETRY_CNT_NON_ZERO"           => [   3,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "" ],
   "CB_ERROR_CNT_NON_ZERO"        => [   4,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "" ],
   "SN_ERROR_CNT_NON_ZERO"        => [   5,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RCV_TAIL_TO_VCH3"             => [   6,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "RCV_TAIL_TO_VCH2"             => [   7,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "RCV_TAIL_TO_VCH1"             => [   8,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "RCV_TAIL_TO_VCH0"             => [   9,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "SEND_DEADLOCK_TO_VCH3"        => [  10,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "SEND_DEADLOCK_TO_VCH2"        => [  11,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "SEND_DEADLOCK_TO_VCH1"        => [  12,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "SEND_DEADLOCK_TO_VCH0"        => [  13,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "DAMQ_DEADLOCK_TO_VCH3"        => [  14,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "DAMQ_DEADLOCK_TO_VCH2"        => [  15,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "DAMQ_DEADLOCK_TO_VCH1"        => [  16,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "DAMQ_DEADLOCK_TO_VCH0"        => [  17,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "INVALID_GLOBAL_LU_VCH3"       => [  18,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "INVALID_GLOBAL_LU_VCH2"       => [  19,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "INVALID_GLOBAL_LU_VCH1"       => [  20,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "INVALID_GLOBAL_LU_VCH0"       => [  21,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "INVALID_LOCAL_LU_VCH3"        => [  22,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "INVALID_LOCAL_LU_VCH2"        => [  23,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "INVALID_LOCAL_LU_VCH1"        => [  24,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "INVALID_LOCAL_LU_VCH0"        => [  25,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "DATELINE_ERROR_VCH3"          => [  26,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "Dataline error on Vch3" ],
   "DATELINE_ERROR_VCH1"          => [  27,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "Dataline error on Vch1" ],
   "ILLEGAL_DIR_VCH3"             => [  28,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "ILLEGAL_DIR_VCH2"             => [  29,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "ILLEGAL_DIR_VCH1"             => [  30,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "ILLEGAL_DIR_VCH0"             => [  31,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "CREDIT_OVERFLOW_VCH3"         => [  32,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "CREDIT_OVERFLOW_VCH2"         => [  33,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "CREDIT_OVERFLOW_VCH1"         => [  34,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "CREDIT_OVERFLOW_VCH0"         => [  35,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "FIFO_OVERFLOW_VCH3"           => [  36,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "FIFO_OVERFLOW_VCH2"           => [  37,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "FIFO_OVERFLOW_VCH1"           => [  38,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "FIFO_OVERFLOW_VCH0"           => [  39,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "BUFFER_OVERFLOW_VCH3"         => [  40,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "BUFFER_OVERFLOW_VCH2"         => [  41,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "BUFFER_OVERFLOW_VCH1"         => [  42,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "BUFFER_OVERFLOW_VCH0"         => [  43,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "RETRY_TO"                     => [  44,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Retry Timeout" ],
   "RCV_LINK_RESET"               => [  45,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Received Link Reset" ],
   "RCV_WARM_RESET"               => [  46,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Received Warm Reset" ],
   "POWER_NOT_OK"                 => [  47,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Power Not OK" ],
);

%nl4rtr_01_00317_def =
( NAME    => "R4_PORTF_ERROR_REPORT_MASK",
  ADDRESS => 0x000000000d002218,
  NOTE    => "The PORTF_ERROR_REPORT_MASK register is used to mask errors from note being reported to a higher level. If a field is set to a o",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00317_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_ERROR_DETAIL                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00318_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DETAIL"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Detailed Error Data" ],
);

%nl4rtr_01_00318_def =
( NAME    => "R4_PORTF_ERROR_DETAIL",
  ADDRESS => 0x000000000d002000,
  NOTE    => "Port F Error Detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00318_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_ERROR_DETAIL_CLEAR                                          #
#                                                                        #
##########################################################################

%nl4rtr_01_00319_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE"                       => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Clear all error detail registers" ],
);

%nl4rtr_01_00319_def =
( NAME    => "R4_PORTF_ERROR_DETAIL_CLEAR",
  ADDRESS => 0x000000000d002100,
  NOTE    => "A write to this register causes a one-shot pulse which causes a note counter to cycle through each Error Detail location and wri",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00319_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_ERROR_SUMMARY                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00320_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTEND_TURN_ERR"              => [   1,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CORESENTBADCRC_CNT_NON_ZERO"  => [   2,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RETRY_CNT_NON_ZERO"           => [   3,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CB_ERROR_CNT_NON_ZERO"        => [   4,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "" ],
   "SN_ERROR_CNT_NON_ZERO"        => [   5,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_TAIL_TO_VCH3"             => [   6,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RCV_TAIL_TO_VCH2"             => [   7,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RCV_TAIL_TO_VCH1"             => [   8,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RCV_TAIL_TO_VCH0"             => [   9,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "SEND_DEADLOCK_TO_VCH3"        => [  10,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "SEND_DEADLOCK_TO_VCH2"        => [  11,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "SEND_DEADLOCK_TO_VCH1"        => [  12,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "SEND_DEADLOCK_TO_VCH0"        => [  13,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "DAMQ_DEADLOCK_TO_VCH3"        => [  14,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "DAMQ_DEADLOCK_TO_VCH2"        => [  15,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "DAMQ_DEADLOCK_TO_VCH1"        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "DAMQ_DEADLOCK_TO_VCH0"        => [  17,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "INVALID_GLOBAL_LU_VCH3"       => [  18,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "INVALID_GLOBAL_LU_VCH2"       => [  19,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "INVALID_GLOBAL_LU_VCH1"       => [  20,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "INVALID_GLOBAL_LU_VCH0"       => [  21,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "INVALID_LOCAL_LU_VCH3"        => [  22,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "INVALID_LOCAL_LU_VCH2"        => [  23,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "INVALID_LOCAL_LU_VCH1"        => [  24,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "INVALID_LOCAL_LU_VCH0"        => [  25,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "DATELINE_ERROR_VCH3"          => [  26,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Dataline error on Vch3" ],
   "DATELINE_ERROR_VCH1"          => [  27,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Dataline error on Vch1" ],
   "ILLEGAL_DIR_VCH3"             => [  28,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "ILLEGAL_DIR_VCH2"             => [  29,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "ILLEGAL_DIR_VCH1"             => [  30,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "ILLEGAL_DIR_VCH0"             => [  31,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "CREDIT_OVERFLOW_VCH3"         => [  32,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "CREDIT_OVERFLOW_VCH2"         => [  33,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "CREDIT_OVERFLOW_VCH1"         => [  34,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "CREDIT_OVERFLOW_VCH0"         => [  35,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "FIFO_OVERFLOW_VCH3"           => [  36,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "FIFO_OVERFLOW_VCH2"           => [  37,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "FIFO_OVERFLOW_VCH1"           => [  38,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "FIFO_OVERFLOW_VCH0"           => [  39,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "BUFFER_OVERFLOW_VCH3"         => [  40,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "BUFFER_OVERFLOW_VCH2"         => [  41,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "BUFFER_OVERFLOW_VCH1"         => [  42,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "BUFFER_OVERFLOW_VCH0"         => [  43,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "RETRY_TO"                     => [  44,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Retry Timeout" ],
   "RCV_LINK_RESET"               => [  45,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Received Link Reset" ],
   "RCV_WARM_RESET"               => [  46,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Received Warm Reset" ],
   "POWER_NOT_OK"                 => [  47,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Power Not OK" ],
);

%nl4rtr_01_00320_def =
( NAME    => "R4_PORTG_ERROR_SUMMARY",
  ADDRESS => 0x000000000e002200,
  NOTE    => "The PORTG_ERROR_SUMMARY contains a summary of all errors since the note last write to the PORTG_ERROR_CLEAR register. The note P",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00320_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_ERROR_CLEAR                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00321_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
);

%nl4rtr_01_00321_def =
( NAME    => "R4_PORTG_ERROR_CLEAR",
  ADDRESS => 0x000000000e002208,
  NOTE    => "The PORTG_ERROR_CLEAR register clears the PORTG_ERROR_SUMMARY note register.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00321_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_FIRST_ERROR                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00322_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTEND_TURN_ERR"              => [   1,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CORESENTBADCRC_CNT_NON_ZERO"  => [   2,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RETRY_CNT_NON_ZERO"           => [   3,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CB_ERROR_CNT_NON_ZERO"        => [   4,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "" ],
   "SN_ERROR_CNT_NON_ZERO"        => [   5,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_TAIL_TO_VCH3"             => [   6,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RCV_TAIL_TO_VCH2"             => [   7,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RCV_TAIL_TO_VCH1"             => [   8,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RCV_TAIL_TO_VCH0"             => [   9,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "SEND_DEADLOCK_TO_VCH3"        => [  10,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "SEND_DEADLOCK_TO_VCH2"        => [  11,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "SEND_DEADLOCK_TO_VCH1"        => [  12,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "SEND_DEADLOCK_TO_VCH0"        => [  13,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "DAMQ_DEADLOCK_TO_VCH3"        => [  14,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "DAMQ_DEADLOCK_TO_VCH2"        => [  15,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "DAMQ_DEADLOCK_TO_VCH1"        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "DAMQ_DEADLOCK_TO_VCH0"        => [  17,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "INVALID_GLOBAL_LU_VCH3"       => [  18,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "INVALID_GLOBAL_LU_VCH2"       => [  19,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "INVALID_GLOBAL_LU_VCH1"       => [  20,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "INVALID_GLOBAL_LU_VCH0"       => [  21,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "INVALID_LOCAL_LU_VCH3"        => [  22,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "INVALID_LOCAL_LU_VCH2"        => [  23,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "INVALID_LOCAL_LU_VCH1"        => [  24,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "INVALID_LOCAL_LU_VCH0"        => [  25,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "DATELINE_ERROR_VCH3"          => [  26,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Dataline error on Vch3" ],
   "DATELINE_ERROR_VCH1"          => [  27,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Dataline error on Vch1" ],
   "ILLEGAL_DIR_VCH3"             => [  28,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "ILLEGAL_DIR_VCH2"             => [  29,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "ILLEGAL_DIR_VCH1"             => [  30,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "ILLEGAL_DIR_VCH0"             => [  31,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "CREDIT_OVERFLOW_VCH3"         => [  32,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "CREDIT_OVERFLOW_VCH2"         => [  33,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "CREDIT_OVERFLOW_VCH1"         => [  34,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "CREDIT_OVERFLOW_VCH0"         => [  35,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "FIFO_OVERFLOW_VCH3"           => [  36,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "FIFO_OVERFLOW_VCH2"           => [  37,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "FIFO_OVERFLOW_VCH1"           => [  38,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "FIFO_OVERFLOW_VCH0"           => [  39,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "BUFFER_OVERFLOW_VCH3"         => [  40,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "BUFFER_OVERFLOW_VCH2"         => [  41,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "BUFFER_OVERFLOW_VCH1"         => [  42,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "BUFFER_OVERFLOW_VCH0"         => [  43,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "RETRY_TO"                     => [  44,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Retry Timeout" ],
   "RCV_LINK_RESET"               => [  45,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Received Link Reset" ],
   "RCV_WARM_RESET"               => [  46,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Received Warm Reset" ],
   "POWER_NOT_OK"                 => [  47,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Power Not OK" ],
);

%nl4rtr_01_00322_def =
( NAME    => "R4_PORTG_FIRST_ERROR",
  ADDRESS => 0x000000000e002210,
  NOTE    => "The PORTG_FIRST_ERROR register holds the very first error detected note and only that error.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00322_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_ERROR_REPORT_MASK                                           #
#                                                                        #
##########################################################################

%nl4rtr_01_00323_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTEND_TURN_ERR"              => [   1,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "" ],
   "CORESENTBADCRC_CNT_NON_ZERO"  => [   2,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RETRY_CNT_NON_ZERO"           => [   3,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "" ],
   "CB_ERROR_CNT_NON_ZERO"        => [   4,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "" ],
   "SN_ERROR_CNT_NON_ZERO"        => [   5,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RCV_TAIL_TO_VCH3"             => [   6,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "RCV_TAIL_TO_VCH2"             => [   7,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "RCV_TAIL_TO_VCH1"             => [   8,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "RCV_TAIL_TO_VCH0"             => [   9,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "SEND_DEADLOCK_TO_VCH3"        => [  10,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "SEND_DEADLOCK_TO_VCH2"        => [  11,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "SEND_DEADLOCK_TO_VCH1"        => [  12,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "SEND_DEADLOCK_TO_VCH0"        => [  13,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "DAMQ_DEADLOCK_TO_VCH3"        => [  14,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "DAMQ_DEADLOCK_TO_VCH2"        => [  15,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "DAMQ_DEADLOCK_TO_VCH1"        => [  16,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "DAMQ_DEADLOCK_TO_VCH0"        => [  17,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "INVALID_GLOBAL_LU_VCH3"       => [  18,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "INVALID_GLOBAL_LU_VCH2"       => [  19,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "INVALID_GLOBAL_LU_VCH1"       => [  20,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "INVALID_GLOBAL_LU_VCH0"       => [  21,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "INVALID_LOCAL_LU_VCH3"        => [  22,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "INVALID_LOCAL_LU_VCH2"        => [  23,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "INVALID_LOCAL_LU_VCH1"        => [  24,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "INVALID_LOCAL_LU_VCH0"        => [  25,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "DATELINE_ERROR_VCH3"          => [  26,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "Dataline error on Vch3" ],
   "DATELINE_ERROR_VCH1"          => [  27,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "Dataline error on Vch1" ],
   "ILLEGAL_DIR_VCH3"             => [  28,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "ILLEGAL_DIR_VCH2"             => [  29,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "ILLEGAL_DIR_VCH1"             => [  30,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "ILLEGAL_DIR_VCH0"             => [  31,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "CREDIT_OVERFLOW_VCH3"         => [  32,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "CREDIT_OVERFLOW_VCH2"         => [  33,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "CREDIT_OVERFLOW_VCH1"         => [  34,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "CREDIT_OVERFLOW_VCH0"         => [  35,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "FIFO_OVERFLOW_VCH3"           => [  36,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "FIFO_OVERFLOW_VCH2"           => [  37,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "FIFO_OVERFLOW_VCH1"           => [  38,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "FIFO_OVERFLOW_VCH0"           => [  39,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "BUFFER_OVERFLOW_VCH3"         => [  40,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "BUFFER_OVERFLOW_VCH2"         => [  41,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "BUFFER_OVERFLOW_VCH1"         => [  42,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "BUFFER_OVERFLOW_VCH0"         => [  43,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "RETRY_TO"                     => [  44,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Retry Timeout" ],
   "RCV_LINK_RESET"               => [  45,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Received Link Reset" ],
   "RCV_WARM_RESET"               => [  46,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Received Warm Reset" ],
   "POWER_NOT_OK"                 => [  47,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Power Not OK" ],
);

%nl4rtr_01_00323_def =
( NAME    => "R4_PORTG_ERROR_REPORT_MASK",
  ADDRESS => 0x000000000e002218,
  NOTE    => "The PORTG_ERROR_REPORT_MASK register is used to mask errors from note being reported to a higher level. If a field is set to a o",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00323_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_ERROR_DETAIL                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00324_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DETAIL"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Detailed Error Data" ],
);

%nl4rtr_01_00324_def =
( NAME    => "R4_PORTG_ERROR_DETAIL",
  ADDRESS => 0x000000000e002000,
  NOTE    => "Port G Error Detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00324_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_ERROR_DETAIL_CLEAR                                          #
#                                                                        #
##########################################################################

%nl4rtr_01_00325_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE"                       => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Clear all error detail registers" ],
);

%nl4rtr_01_00325_def =
( NAME    => "R4_PORTG_ERROR_DETAIL_CLEAR",
  ADDRESS => 0x000000000e002100,
  NOTE    => "A write to this register causes a one-shot pulse which causes a note counter to cycle through each Error Detail location and wri",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00325_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_ERROR_SUMMARY                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00326_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTEND_TURN_ERR"              => [   1,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CORESENTBADCRC_CNT_NON_ZERO"  => [   2,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RETRY_CNT_NON_ZERO"           => [   3,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CB_ERROR_CNT_NON_ZERO"        => [   4,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "" ],
   "SN_ERROR_CNT_NON_ZERO"        => [   5,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_TAIL_TO_VCH3"             => [   6,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RCV_TAIL_TO_VCH2"             => [   7,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RCV_TAIL_TO_VCH1"             => [   8,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RCV_TAIL_TO_VCH0"             => [   9,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "SEND_DEADLOCK_TO_VCH3"        => [  10,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "SEND_DEADLOCK_TO_VCH2"        => [  11,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "SEND_DEADLOCK_TO_VCH1"        => [  12,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "SEND_DEADLOCK_TO_VCH0"        => [  13,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "DAMQ_DEADLOCK_TO_VCH3"        => [  14,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "DAMQ_DEADLOCK_TO_VCH2"        => [  15,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "DAMQ_DEADLOCK_TO_VCH1"        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "DAMQ_DEADLOCK_TO_VCH0"        => [  17,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "INVALID_GLOBAL_LU_VCH3"       => [  18,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "INVALID_GLOBAL_LU_VCH2"       => [  19,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "INVALID_GLOBAL_LU_VCH1"       => [  20,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "INVALID_GLOBAL_LU_VCH0"       => [  21,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "INVALID_LOCAL_LU_VCH3"        => [  22,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "INVALID_LOCAL_LU_VCH2"        => [  23,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "INVALID_LOCAL_LU_VCH1"        => [  24,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "INVALID_LOCAL_LU_VCH0"        => [  25,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "DATELINE_ERROR_VCH3"          => [  26,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Dataline error on Vch3" ],
   "DATELINE_ERROR_VCH1"          => [  27,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Dataline error on Vch1" ],
   "ILLEGAL_DIR_VCH3"             => [  28,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "ILLEGAL_DIR_VCH2"             => [  29,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "ILLEGAL_DIR_VCH1"             => [  30,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "ILLEGAL_DIR_VCH0"             => [  31,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "CREDIT_OVERFLOW_VCH3"         => [  32,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "CREDIT_OVERFLOW_VCH2"         => [  33,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "CREDIT_OVERFLOW_VCH1"         => [  34,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "CREDIT_OVERFLOW_VCH0"         => [  35,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "FIFO_OVERFLOW_VCH3"           => [  36,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "FIFO_OVERFLOW_VCH2"           => [  37,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "FIFO_OVERFLOW_VCH1"           => [  38,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "FIFO_OVERFLOW_VCH0"           => [  39,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "BUFFER_OVERFLOW_VCH3"         => [  40,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "BUFFER_OVERFLOW_VCH2"         => [  41,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "BUFFER_OVERFLOW_VCH1"         => [  42,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "BUFFER_OVERFLOW_VCH0"         => [  43,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "RETRY_TO"                     => [  44,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Retry Timeout" ],
   "RCV_LINK_RESET"               => [  45,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Received Link Reset" ],
   "RCV_WARM_RESET"               => [  46,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Received Warm Reset" ],
   "POWER_NOT_OK"                 => [  47,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Power Not OK" ],
);

%nl4rtr_01_00326_def =
( NAME    => "R4_PORTH_ERROR_SUMMARY",
  ADDRESS => 0x000000000f002200,
  NOTE    => "The PORTH_ERROR_SUMMARY contains a summary of all errors since the note last write to the PORTH_ERROR_CLEAR register. The note P",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00326_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_ERROR_CLEAR                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00327_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
);

%nl4rtr_01_00327_def =
( NAME    => "R4_PORTH_ERROR_CLEAR",
  ADDRESS => 0x000000000f002208,
  NOTE    => "The PORTH_ERROR_CLEAR register clears the PORTH_ERROR_SUMMARY note register.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00327_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_FIRST_ERROR                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00328_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTEND_TURN_ERR"              => [   1,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CORESENTBADCRC_CNT_NON_ZERO"  => [   2,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RETRY_CNT_NON_ZERO"           => [   3,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CB_ERROR_CNT_NON_ZERO"        => [   4,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "" ],
   "SN_ERROR_CNT_NON_ZERO"        => [   5,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_TAIL_TO_VCH3"             => [   6,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "RCV_TAIL_TO_VCH2"             => [   7,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "RCV_TAIL_TO_VCH1"             => [   8,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "RCV_TAIL_TO_VCH0"             => [   9,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "SEND_DEADLOCK_TO_VCH3"        => [  10,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "SEND_DEADLOCK_TO_VCH2"        => [  11,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "SEND_DEADLOCK_TO_VCH1"        => [  12,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "SEND_DEADLOCK_TO_VCH0"        => [  13,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "DAMQ_DEADLOCK_TO_VCH3"        => [  14,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "DAMQ_DEADLOCK_TO_VCH2"        => [  15,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "DAMQ_DEADLOCK_TO_VCH1"        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "DAMQ_DEADLOCK_TO_VCH0"        => [  17,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "INVALID_GLOBAL_LU_VCH3"       => [  18,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "INVALID_GLOBAL_LU_VCH2"       => [  19,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "INVALID_GLOBAL_LU_VCH1"       => [  20,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "INVALID_GLOBAL_LU_VCH0"       => [  21,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "INVALID_LOCAL_LU_VCH3"        => [  22,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "INVALID_LOCAL_LU_VCH2"        => [  23,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "INVALID_LOCAL_LU_VCH1"        => [  24,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "INVALID_LOCAL_LU_VCH0"        => [  25,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "DATELINE_ERROR_VCH3"          => [  26,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Dataline error on Vch3" ],
   "DATELINE_ERROR_VCH1"          => [  27,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Dataline error on Vch1" ],
   "ILLEGAL_DIR_VCH3"             => [  28,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "ILLEGAL_DIR_VCH2"             => [  29,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "ILLEGAL_DIR_VCH1"             => [  30,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "ILLEGAL_DIR_VCH0"             => [  31,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "CREDIT_OVERFLOW_VCH3"         => [  32,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "CREDIT_OVERFLOW_VCH2"         => [  33,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "CREDIT_OVERFLOW_VCH1"         => [  34,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "CREDIT_OVERFLOW_VCH0"         => [  35,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "FIFO_OVERFLOW_VCH3"           => [  36,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "FIFO_OVERFLOW_VCH2"           => [  37,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "FIFO_OVERFLOW_VCH1"           => [  38,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "FIFO_OVERFLOW_VCH0"           => [  39,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "BUFFER_OVERFLOW_VCH3"         => [  40,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "VCh3" ],
   "BUFFER_OVERFLOW_VCH2"         => [  41,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "VCh2" ],
   "BUFFER_OVERFLOW_VCH1"         => [  42,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "VCh1" ],
   "BUFFER_OVERFLOW_VCH0"         => [  43,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "VCh0" ],
   "RETRY_TO"                     => [  44,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Retry Timeout" ],
   "RCV_LINK_RESET"               => [  45,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Received Link Reset" ],
   "RCV_WARM_RESET"               => [  46,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Received Warm Reset" ],
   "POWER_NOT_OK"                 => [  47,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Power Not OK" ],
);

%nl4rtr_01_00328_def =
( NAME    => "R4_PORTH_FIRST_ERROR",
  ADDRESS => 0x000000000f002210,
  NOTE    => "The PORTH_FIRST_ERROR register holds the very first error detected note and only that error.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00328_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_ERROR_REPORT_MASK                                           #
#                                                                        #
##########################################################################

%nl4rtr_01_00329_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTEND_TURN_ERR"              => [   1,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "" ],
   "CORESENTBADCRC_CNT_NON_ZERO"  => [   2,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RETRY_CNT_NON_ZERO"           => [   3,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "" ],
   "CB_ERROR_CNT_NON_ZERO"        => [   4,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "" ],
   "SN_ERROR_CNT_NON_ZERO"        => [   5,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RCV_TAIL_TO_VCH3"             => [   6,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "RCV_TAIL_TO_VCH2"             => [   7,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "RCV_TAIL_TO_VCH1"             => [   8,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "RCV_TAIL_TO_VCH0"             => [   9,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "SEND_DEADLOCK_TO_VCH3"        => [  10,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "SEND_DEADLOCK_TO_VCH2"        => [  11,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "SEND_DEADLOCK_TO_VCH1"        => [  12,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "SEND_DEADLOCK_TO_VCH0"        => [  13,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "DAMQ_DEADLOCK_TO_VCH3"        => [  14,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "DAMQ_DEADLOCK_TO_VCH2"        => [  15,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "DAMQ_DEADLOCK_TO_VCH1"        => [  16,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "DAMQ_DEADLOCK_TO_VCH0"        => [  17,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "INVALID_GLOBAL_LU_VCH3"       => [  18,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "INVALID_GLOBAL_LU_VCH2"       => [  19,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "INVALID_GLOBAL_LU_VCH1"       => [  20,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "INVALID_GLOBAL_LU_VCH0"       => [  21,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "INVALID_LOCAL_LU_VCH3"        => [  22,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "INVALID_LOCAL_LU_VCH2"        => [  23,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "INVALID_LOCAL_LU_VCH1"        => [  24,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "INVALID_LOCAL_LU_VCH0"        => [  25,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "DATELINE_ERROR_VCH3"          => [  26,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "Dataline error on Vch3" ],
   "DATELINE_ERROR_VCH1"          => [  27,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "Dataline error on Vch1" ],
   "ILLEGAL_DIR_VCH3"             => [  28,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "ILLEGAL_DIR_VCH2"             => [  29,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "ILLEGAL_DIR_VCH1"             => [  30,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "ILLEGAL_DIR_VCH0"             => [  31,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "CREDIT_OVERFLOW_VCH3"         => [  32,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "CREDIT_OVERFLOW_VCH2"         => [  33,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "CREDIT_OVERFLOW_VCH1"         => [  34,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "CREDIT_OVERFLOW_VCH0"         => [  35,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "FIFO_OVERFLOW_VCH3"           => [  36,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "FIFO_OVERFLOW_VCH2"           => [  37,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "FIFO_OVERFLOW_VCH1"           => [  38,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "FIFO_OVERFLOW_VCH0"           => [  39,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "BUFFER_OVERFLOW_VCH3"         => [  40,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "VCh3" ],
   "BUFFER_OVERFLOW_VCH2"         => [  41,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "VCh2" ],
   "BUFFER_OVERFLOW_VCH1"         => [  42,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "VCh1" ],
   "BUFFER_OVERFLOW_VCH0"         => [  43,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "VCh0" ],
   "RETRY_TO"                     => [  44,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Retry Timeout" ],
   "RCV_LINK_RESET"               => [  45,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Received Link Reset" ],
   "RCV_WARM_RESET"               => [  46,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Received Warm Reset" ],
   "POWER_NOT_OK"                 => [  47,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Power Not OK" ],
);

%nl4rtr_01_00329_def =
( NAME    => "R4_PORTH_ERROR_REPORT_MASK",
  ADDRESS => 0x000000000f002218,
  NOTE    => "The PORTH_ERROR_REPORT_MASK register is used to mask errors from note being reported to a higher level. If a field is set to a o",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00329_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_ERROR_DETAIL                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00330_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DETAIL"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Detailed Error Data" ],
);

%nl4rtr_01_00330_def =
( NAME    => "R4_PORTH_ERROR_DETAIL",
  ADDRESS => 0x000000000f002000,
  NOTE    => "Port H Error Detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00330_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_ERROR_DETAIL_CLEAR                                          #
#                                                                        #
##########################################################################

%nl4rtr_01_00331_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE"                       => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Clear all error detail registers" ],
);

%nl4rtr_01_00331_def =
( NAME    => "R4_PORTH_ERROR_DETAIL_CLEAR",
  ADDRESS => 0x000000000f002100,
  NOTE    => "A write to this register causes a one-shot pulse which causes a note counter to cycle through each Error Detail location and wri",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00331_flds
);


##########################################################################
#                                                                        #
#   R4_ASIC_FIRST_ERROR                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00332_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LB_ERROR"                     => [   1,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Local Block Error" ],
   "PORTH_ERROR"                  => [   2,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Port H Error" ],
   "PORTG_ERROR"                  => [   3,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Port G Error" ],
   "PORTF_ERROR"                  => [   4,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Port F Error" ],
   "PORTE_ERROR"                  => [   5,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Port E Error" ],
   "PORTD_ERROR"                  => [   6,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Port D Error" ],
   "PORTC_ERROR"                  => [   7,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Port C Error" ],
   "PORTB_ERROR"                  => [   8,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Port B Error" ],
   "PORTA_ERROR"                  => [   9,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Port A Error" ],
);

%nl4rtr_01_00332_def =
( NAME    => "R4_ASIC_FIRST_ERROR",
  ADDRESS => 0x0000000000002000,
  NOTE    => "The ASIC_FIRST_ERROR register records first errors occured in note router chip. The access mode is normal read/write.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00332_flds
);


##########################################################################
#                                                                        #
#   R4_ASIC_FIRST_ERROR_TIMESTAMP                                        #
#                                                                        #
##########################################################################

%nl4rtr_01_00333_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RTC_VALUE"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Real Time Clock Value" ],
);

%nl4rtr_01_00333_def =
( NAME    => "R4_ASIC_FIRST_ERROR_TIMESTAMP",
  ADDRESS => 0x0000000000002008,
  NOTE    => "The ASIC_FIRST_ERROR_TIMESTAMP register records the RTC value when note first errors occured in router chip. The access mode is ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00333_flds
);


##########################################################################
#                                                                        #
#   R4_LB_ERROR_SUMMARY                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00334_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  21,  43, 0xFFFFFFFFFFE00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VCH3_DEADLOCK_TO"             => [   1,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "VCh3 Deadlock Timeout" ],
   "VCH2_DEADLOCK_TO"             => [   2,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "VCh2 Deadlock Timeout" ],
   "VCH1_DEADLOCK_TO"             => [   3,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "VCh1 Deadlock Timeout" ],
   "VCH0_DEADLOCK_TO"             => [   4,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VCh0 Deadlock Timeout" ],
   "GATHER_SPUR_ERR"              => [   5,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Spurious Gather Message Error" ],
   "GATHER_TO"                    => [   6,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Gather Buffer Timeout" ],
   "GATHER_ERR"                   => [   7,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Gather Buffer Error" ],
   "REP_BAD_NEXT_DIR"             => [   8,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Invalid Next Direction in Reply" ],
   "REP_BAD_THIS_DIR"             => [   9,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Reply Message Has Invalid This Direction" ],
   "REP_MSG_LEN_ERR"              => [  10,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Message Length Error" ],
   "BAD_REP_MSG"                  => [  11,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Bad Reply Message" ],
   "REP_SB_ERROR"                 => [  12,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Reply Message Sideband Error" ],
   "REQ_BAD_NEXT_DIR"             => [  13,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Invalid Next Direction in Request Packet" ],
   "REQ_BAD_THIS_DIR"             => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Request Message Has Invalid This Direction" ],
   "JTAG_PIO_ERR"                 => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Jtag PIO Access Error" ],
   "PIO_CHN_TO"                   => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "PIO Channel Access Time-out Error" ],
   "PIO_UNEXP_VALID"              => [  17,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "MMR Address Decode Error" ],
   "PIO_BAD_ADDR"                 => [  18,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Request MMR Address Error" ],
   "REQ_MSG_LEN_ERR"              => [  19,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Message Length Error" ],
   "BAD_REQ_MSG"                  => [  20,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Bad Request Message" ],
   "REQ_SB_ERROR"                 => [  21,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Request Message Sideband Error" ],
);

%nl4rtr_01_00334_def =
( NAME    => "R4_LB_ERROR_SUMMARY",
  ADDRESS => 0x0000000000002010,
  NOTE    => "The LB_ERROR_SUMMARY register records local block related errors. note The access mode is normal read/write.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00334_flds
);


##########################################################################
#                                                                        #
#   R4_LB_ERROR_CLEAR                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00335_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
);

%nl4rtr_01_00335_def =
( NAME    => "R4_LB_ERROR_CLEAR",
  ADDRESS => 0x0000000000002018,
  NOTE    => "The LB_ERROR_CLEAR register. This is an alias of LB_ERROR_SUMMARY note register. However, its access mode is Write-One-Clear.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00335_flds
);


##########################################################################
#                                                                        #
#   R4_LB_FIRST_ERROR                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00336_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  21,  43, 0xFFFFFFFFFFE00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VCH3_DEADLOCK_TO"             => [   1,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "VCh3 Deadlock Timeout" ],
   "VCH2_DEADLOCK_TO"             => [   2,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "VCh2 Deadlock Timeout" ],
   "VCH1_DEADLOCK_TO"             => [   3,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "VCh1 Deadlock Timeout" ],
   "VCH0_DEADLOCK_TO"             => [   4,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VCh0 Deadlock Timeout" ],
   "GATHER_SPUR_ERR"              => [   5,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Spurious Gather Message Error" ],
   "GATHER_TO"                    => [   6,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Gather Buffer Timeout" ],
   "GATHER_ERR"                   => [   7,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Gather Buffer Error" ],
   "REP_BAD_NEXT_DIR"             => [   8,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Invalid Next Direction in Reply" ],
   "REP_BAD_THIS_DIR"             => [   9,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Reply Message Has Invalid This Direction" ],
   "REP_MSG_LEN_ERR"              => [  10,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Message Length Error" ],
   "BAD_REP_MSG"                  => [  11,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Bad Reply Message" ],
   "REP_SB_ERROR"                 => [  12,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Reply Message Sideband Error" ],
   "REQ_BAD_NEXT_DIR"             => [  13,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Invalid Next Direction in Request Packet" ],
   "REQ_BAD_THIS_DIR"             => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Request Message Has Invalid This Direction" ],
   "JTAG_PIO_ERR"                 => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Jtag PIO Access Error" ],
   "PIO_CHN_TO"                   => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "PIO Channel Access Time-out Error" ],
   "PIO_UNEXP_VALID"              => [  17,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "MMR Address Decode Error" ],
   "PIO_BAD_ADDR"                 => [  18,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Request MMR Address Error" ],
   "REQ_MSG_LEN_ERR"              => [  19,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Message Length Error" ],
   "BAD_REQ_MSG"                  => [  20,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Bad Request Message" ],
   "REQ_SB_ERROR"                 => [  21,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Request Message Sideband Error" ],
);

%nl4rtr_01_00336_def =
( NAME    => "R4_LB_FIRST_ERROR",
  ADDRESS => 0x0000000000002020,
  NOTE    => "The LB_FIRST_ERROR register records first errors occured in local note block. The access mode is normal read/write.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00336_flds
);


##########################################################################
#                                                                        #
#   R4_LB_ERROR_REPORT_MASK                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00337_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  21,  43, 0xFFFFFFFFFFE00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VCH3_DEADLOCK_TO"             => [   1,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "VCh3 Deadlock Timeout" ],
   "VCH2_DEADLOCK_TO"             => [   2,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "VCh2 Deadlock Timeout" ],
   "VCH1_DEADLOCK_TO"             => [   3,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "VCh1 Deadlock Timeout" ],
   "VCH0_DEADLOCK_TO"             => [   4,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "VCh0 Deadlock Timeout" ],
   "GATHER_SPUR_ERR"              => [   5,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Spurious Gather Message Error" ],
   "GATHER_TO"                    => [   6,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Gather Buffer Timeout" ],
   "GATHER_ERR"                   => [   7,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Gather Buffer Error" ],
   "REP_BAD_NEXT_DIR"             => [   8,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Invalid Next Direction in Reply" ],
   "REP_BAD_THIS_DIR"             => [   9,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Reply Message Has Invalid This Direction" ],
   "REP_MSG_LEN_ERR"              => [  10,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "Message Length Error" ],
   "BAD_REP_MSG"                  => [  11,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "Bad Reply Message" ],
   "REP_SB_ERROR"                 => [  12,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Reply Message Sideband Error" ],
   "REQ_BAD_NEXT_DIR"             => [  13,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Invalid Next Direction in Request Packet" ],
   "REQ_BAD_THIS_DIR"             => [  14,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Request Message Has Invalid This Direction" ],
   "JTAG_PIO_ERR"                 => [  15,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Jtag PIO Access Error" ],
   "PIO_CHN_TO"                   => [  16,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "PIO Channel Access Time-out Error" ],
   "PIO_UNEXP_VALID"              => [  17,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "MMR Address Decode Error" ],
   "PIO_BAD_ADDR"                 => [  18,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Request MMR Address Error" ],
   "REQ_MSG_LEN_ERR"              => [  19,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Message Length Error" ],
   "BAD_REQ_MSG"                  => [  20,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Bad Request Message" ],
   "REQ_SB_ERROR"                 => [  21,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Request Message Sideband Error" ],
);

%nl4rtr_01_00337_def =
( NAME    => "R4_LB_ERROR_REPORT_MASK",
  ADDRESS => 0x0000000000002030,
  NOTE    => "The LB_ERROR_REPORT_MASK register is used to prevent any particular note type of error from being logged in any other error rela",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00337_flds
);


##########################################################################
#                                                                        #
#   R4_LB_ERROR_DETAIL_1                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00338_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COMMAND"                      => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Command" ],
   "ECHO3_0"                      => [   1,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Echo Bits 3-0" ],
   "ADDRESS"                      => [   2,   3,  49, 0x000FFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "Destination Chiplet" ],
   "RSVD0"                        => [   3,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEST_CHIPLET"                 => [   4,   0,   2, 0x0000000000000003, 0x00, 0, 0x0000000000000000, "Destination Chiplet" ],
);

%nl4rtr_01_00338_def =
( NAME    => "R4_LB_ERROR_DETAIL_1",
  ADDRESS => 0x0000000000002050,
  NOTE    => "The LB_ERROR_DETAIL_1 register records info contained in the header note flit of a message which has caused first errors occurri",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00338_flds
);


##########################################################################
#                                                                        #
#   R4_LB_ERROR_DETAIL_2                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00339_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SUPPLEMENTAL"                 => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Supplemental" ],
   "SRC_CHIPLET"                  => [   1,  46,   2, 0x0000C00000000000, 0x00, 0, 0x0000000000000000, "Source Chiplet" ],
   "SOURCE"                       => [   2,  32,  14, 0x00003FFF00000000, 0x00, 0, 0x0000000000000000, "Source Node" ],
   "DIR3_0"                       => [   3,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Direction Bits 3-0" ],
   "ECHO7_4"                      => [   4,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "Echo Bits 7-4" ],
   "ECHO8"                        => [   5,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Echo Bit 8" ],
   "DIR4"                         => [   6,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Direction Bit 4" ],
   "DESTINATION"                  => [   7,   8,  14, 0x00000000003FFF00, 0x00, 0, 0x0000000000000000, "Destination Node" ],
   "AGE"                          => [   8,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Age" ],
);

%nl4rtr_01_00339_def =
( NAME    => "R4_LB_ERROR_DETAIL_2",
  ADDRESS => 0x0000000000002060,
  NOTE    => "The LB_ERROR_DETAIL_2 register records info contained in the header note flit of a message which has caused first errors occurri",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00339_flds
);


##########################################################################
#                                                                        #
#   R4_PORT_PERF_WIN                                                     #
#                                                                        #
##########################################################################

%nl4rtr_01_00340_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FORCE_EN"                     => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Force Enable" ],
   "CLEAR"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Port Performance Monitor Global Clear" ],
   "RSVD0"                        => [   2,  60,   2, 0x3000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   3,   0,  60, 0x0FFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Count" ],
);

%nl4rtr_01_00340_def =
( NAME    => "R4_PORT_PERF_WIN",
  ADDRESS => 0x0000000001003100,
  NOTE    => "The PORT_PERF_WIN register is a down counter. When its value is note non-zero, the performance monitoring feature at each port i",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00340_flds
);


##########################################################################
#                                                                        #
#   R4_TSF_ARM_MASK                                                      #
#                                                                        #
##########################################################################

%nl4rtr_01_00341_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility arm mask" ],
);

%nl4rtr_01_00341_def =
( NAME    => "R4_TSF_ARM_MASK",
  ADDRESS => 0x0000000001004000,
  NOTE    => "Trigger sequencing facility arm mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00341_flds
);


##########################################################################
#                                                                        #
#   R4_TSF_COUNTER_PRESETS                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00342_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COUNT_8A"                     => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 8a" ],
   "COUNT_8B"                     => [   1,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 8b" ],
   "COUNT_16"                     => [   2,  32,  16, 0x0000FFFF00000000, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 16" ],
   "COUNT_32"                     => [   3,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 32" ],
);

%nl4rtr_01_00342_def =
( NAME    => "R4_TSF_COUNTER_PRESETS",
  ADDRESS => 0x0000000001004080,
  NOTE    => "The TSF_COUNTER_PRESETS register contains the initial values for note the trigger sequencing facility down counters.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00342_flds
);


##########################################################################
#                                                                        #
#   R4_TSF_DECREMENT_CTL                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00343_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CTL"                          => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter decrement control" ],
);

%nl4rtr_01_00343_def =
( NAME    => "R4_TSF_DECREMENT_CTL",
  ADDRESS => 0x0000000001004100,
  NOTE    => "Trigger sequencing facility counter decrement control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00343_flds
);


##########################################################################
#                                                                        #
#   R4_TSF_DIAG_MSG_CTL                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00344_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE"                       => [   1,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Trigger sequencing facility diagnostic message control" ],
);

%nl4rtr_01_00344_def =
( NAME    => "R4_TSF_DIAG_MSG_CTL",
  ADDRESS => 0x0000000001004180,
  NOTE    => "Trigger sequencing facility diagnostic message control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00344_flds
);


##########################################################################
#                                                                        #
#   R4_TSF_DISARM_MASK                                                   #
#                                                                        #
##########################################################################

%nl4rtr_01_00345_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility disarm mask" ],
);

%nl4rtr_01_00345_def =
( NAME    => "R4_TSF_DISARM_MASK",
  ADDRESS => 0x0000000001004200,
  NOTE    => "Trigger sequencing facility disarm mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00345_flds
);


##########################################################################
#                                                                        #
#   R4_TSF_ENABLE_CTL                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00346_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CTL"                          => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter enable control" ],
);

%nl4rtr_01_00346_def =
( NAME    => "R4_TSF_ENABLE_CTL",
  ADDRESS => 0x0000000001004280,
  NOTE    => "Trigger sequencing facility counter enable control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00346_flds
);


##########################################################################
#                                                                        #
#   R4_TSF_SOFTWARE_ARM                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00347_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BIT7"                         => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm Bit 7" ],
   "BIT6"                         => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm Bit 6" ],
   "BIT5"                         => [   3,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm Bit 5" ],
   "BIT4"                         => [   4,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm Bit 4" ],
   "BIT3"                         => [   5,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm Bit 3" ],
   "BIT2"                         => [   6,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm Bit 2" ],
   "BIT1"                         => [   7,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm Bit 1" ],
   "BIT0"                         => [   8,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm Bit 0" ],
);

%nl4rtr_01_00347_def =
( NAME    => "R4_TSF_SOFTWARE_ARM",
  ADDRESS => 0x0000000001004300,
  NOTE    => "The TSF_SOFTWARE_ARM register provides software with a means to arm note any of the trigger sequencing variables. Writing a one ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00347_flds
);


##########################################################################
#                                                                        #
#   R4_TSF_SOFTWARE_DISARM                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00348_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BIT7"                         => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 7" ],
   "BIT6"                         => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 6" ],
   "BIT5"                         => [   3,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 5" ],
   "BIT4"                         => [   4,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 4" ],
   "BIT3"                         => [   5,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 3" ],
   "BIT2"                         => [   6,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 2" ],
   "BIT1"                         => [   7,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 1" ],
   "BIT0"                         => [   8,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 0" ],
);

%nl4rtr_01_00348_def =
( NAME    => "R4_TSF_SOFTWARE_DISARM",
  ADDRESS => 0x0000000001004380,
  NOTE    => "The TSF_SOFTWARE_DISARM register provides software with a means to note disarm any of the trigger sequencing variables. Writing ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00348_flds
);


##########################################################################
#                                                                        #
#   R4_TSF_SOFTWARE_TRIGGERED                                            #
#                                                                        #
##########################################################################

%nl4rtr_01_00349_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BIT7"                         => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 7" ],
   "BIT6"                         => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 6" ],
   "BIT5"                         => [   3,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 5" ],
   "BIT4"                         => [   4,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 4" ],
   "BIT3"                         => [   5,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 3" ],
   "BIT2"                         => [   6,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 2" ],
   "BIT1"                         => [   7,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 1" ],
   "BIT0"                         => [   8,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 0" ],
);

%nl4rtr_01_00349_def =
( NAME    => "R4_TSF_SOFTWARE_TRIGGERED",
  ADDRESS => 0x0000000001004400,
  NOTE    => "The TSF_SOFTWARE_TRIGGERED register provides software with a means note to trigger any of the trigger sequencing variables. Writ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00349_flds
);


##########################################################################
#                                                                        #
#   R4_TSF_TRIGGER_MASK                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00350_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility trigger mask" ],
);

%nl4rtr_01_00350_def =
( NAME    => "R4_TSF_TRIGGER_MASK",
  ADDRESS => 0x0000000001004480,
  NOTE    => "The TSF_TRIGGER_MASK is used to enable an auxiliary trigger compare note to trigger a particular trigger sequencing variable. Bi",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00350_flds
);


##########################################################################
#                                                                        #
#   R4_TSF_ARMED_STATE                                                   #
#                                                                        #
##########################################################################

%nl4rtr_01_00351_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STATE"                        => [   1,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility armed state" ],
);

%nl4rtr_01_00351_def =
( NAME    => "R4_TSF_ARMED_STATE",
  ADDRESS => 0x0000000001005000,
  NOTE    => "The TSF_ARMED_STATE contains the armed state for each of the note trigger sequencing variables. Bit 0 is the armed state for tri",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00351_flds
);


##########################################################################
#                                                                        #
#   R4_TSF_COUNTER_VALUE                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00352_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COUNT_8A"                     => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 8a" ],
   "COUNT_8B"                     => [   1,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 8b" ],
   "COUNT_16"                     => [   2,  32,  16, 0x0000FFFF00000000, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 16" ],
   "COUNT_32"                     => [   3,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 32" ],
);

%nl4rtr_01_00352_def =
( NAME    => "R4_TSF_COUNTER_VALUE",
  ADDRESS => 0x0000000001005080,
  NOTE    => "The TSF_COUNTER_VALUE register contains the counter values of the note trigger sequencing down counters. These counters are load",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00352_flds
);


##########################################################################
#                                                                        #
#   R4_TSF_TRIGGERED_STATE                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00353_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STATE"                        => [   1,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility triggered state" ],
);

%nl4rtr_01_00353_def =
( NAME    => "R4_TSF_TRIGGERED_STATE",
  ADDRESS => 0x0000000001005100,
  NOTE    => "The TSF_TRIGGERED_STATE contains the triggered state for each of note the trigger sequencing variables. Bit 0 is the triggered s",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00353_flds
);


##########################################################################
#                                                                        #
#   R4_ROOT_TEST_POINT_SELECT                                            #
#                                                                        #
##########################################################################

%nl4rtr_01_00354_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TRIGGER_ENABLE"               => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Send Trigger Compare Result to Output Port Bit 31" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 7: Nibble Select" ],
   "RSVD0"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_CHIPLET_SEL"          => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 7: Port Select" ],
   "RSVD1"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 6: Nibble Select" ],
   "RSVD2"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_CHIPLET_SEL"          => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 6: Port Select" ],
   "RSVD3"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 5: Nibble Select" ],
   "RSVD4"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_CHIPLET_SEL"          => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 5: Port Select" ],
   "RSVD5"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 4: Nibble Select" ],
   "RSVD6"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_CHIPLET_SEL"          => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 4: Port Select" ],
   "RSVD7"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 3: Nibble Select" ],
   "RSVD8"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_CHIPLET_SEL"          => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 3: Port Select" ],
   "RSVD9"                        => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 2: Nibble Select" ],
   "RSVD10"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_CHIPLET_SEL"          => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 2: Port Select" ],
   "RSVD11"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 1: Nibble Select" ],
   "RSVD12"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_CHIPLET_SEL"          => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Output Port Nibble 1: Port Select" ],
   "RSVD13"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Output Port Nibble 0: Nibble Select" ],
   "RSVD14"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_CHIPLET_SEL"          => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Output Port Nibble 0: Port Select" ],
);

%nl4rtr_01_00354_def =
( NAME    => "R4_ROOT_TEST_POINT_SELECT",
  ADDRESS => 0x0000000001006000,
  NOTE    => "The ROOT_TEST_POINT_SELECT configures (i.e., contains the select note signals for) the PI's NL4R Test Point Multiplexer. The NL4",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00354_flds
);


##########################################################################
#                                                                        #
#   R4_ROOT_TEST_POINT_COMPARE                                           #
#                                                                        #
##########################################################################

%nl4rtr_01_00355_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COMPARE_PATTERN"              => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Trigger Comparison Test: Reference Pattern" ],
   "COMPARE_MASK"                 => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Trigger Comparison Test: Enable Bits" ],
);

%nl4rtr_01_00355_def =
( NAME    => "R4_ROOT_TEST_POINT_COMPARE",
  ADDRESS => 0x0000000001006008,
  NOTE    => "The NL4R register configures a comparison test between the output note of NL4R 32-bit Trigger Multiplexer and the NL4R register'",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00355_flds
);


##########################################################################
#                                                                        #
#   R4_ROOT_TEST_POINT_TRIGGER_SELECT                                     #
#                                                                        #
##########################################################################

%nl4rtr_01_00356_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_NIBBLE_SEL"          => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 7: Nibble Select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_CHIPLET_SEL"         => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 7: Port Select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_NIBBLE_SEL"          => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 6: Nibble Select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_CHIPLET_SEL"         => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 6: Port Select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_NIBBLE_SEL"          => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 5: Nibble Select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_CHIPLET_SEL"         => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 5: Port Select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_NIBBLE_SEL"          => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 4: Nibble Select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_CHIPLET_SEL"         => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 4: Port Select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_NIBBLE_SEL"          => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 3: Nibble Select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_CHIPLET_SEL"         => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 3: Port Select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_NIBBLE_SEL"          => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 2: Nibble Select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_CHIPLET_SEL"         => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 2: Port Select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_NIBBLE_SEL"          => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 1: Nibble Select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_CHIPLET_SEL"         => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Output Port Nibble 1: Port Select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_NIBBLE_SEL"          => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Output Port Nibble 0: Nibble Select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_CHIPLET_SEL"         => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Output Port Nibble 0: Port Select" ],
);

%nl4rtr_01_00356_def =
( NAME    => "R4_ROOT_TEST_POINT_TRIGGER_SELECT",
  ADDRESS => 0x0000000001006010,
  NOTE    => "The ROOT_TEST_POINT_TRIGGER_SELECT register contains the select note bits for the NL4R Trigger Multiplexer. The NL4R Trigger Mul",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00356_flds
);


##########################################################################
#                                                                        #
#   R4_BRANCH1_TEST_POINT_SELECT                                         #
#                                                                        #
##########################################################################

%nl4rtr_01_00357_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TRIGGER_ENABLE"               => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Send Trigger Compare Result to Output Port Bit 31" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 7: Nibble Select" ],
   "RSVD0"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_CHIPLET_SEL"          => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 7: Port Select" ],
   "RSVD1"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 6: Nibble Select" ],
   "RSVD2"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_CHIPLET_SEL"          => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 6: Port Select" ],
   "RSVD3"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 5: Nibble Select" ],
   "RSVD4"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_CHIPLET_SEL"          => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 5: Port Select" ],
   "RSVD5"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 4: Nibble Select" ],
   "RSVD6"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_CHIPLET_SEL"          => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 4: Port Select" ],
   "RSVD7"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 3: Nibble Select" ],
   "RSVD8"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_CHIPLET_SEL"          => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 3: Port Select" ],
   "RSVD9"                        => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 2: Nibble Select" ],
   "RSVD10"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_CHIPLET_SEL"          => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 2: Port Select" ],
   "RSVD11"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 1: Nibble Select" ],
   "RSVD12"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_CHIPLET_SEL"          => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Output Port Nibble 1: Port Select" ],
   "RSVD13"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Output Port Nibble 0: Nibble Select" ],
   "RSVD14"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_CHIPLET_SEL"          => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Output Port Nibble 0: Port Select" ],
);

%nl4rtr_01_00357_def =
( NAME    => "R4_BRANCH1_TEST_POINT_SELECT",
  ADDRESS => 0x0000000001006020,
  NOTE    => "The BRANCH1_TEST_POINT_SELECT configures (i.e., contains the select note signals for) the NL4R arbit Test Point Multiplexer. The",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00357_flds
);


##########################################################################
#                                                                        #
#   R4_BRANCH1_TEST_POINT_COMPARE                                        #
#                                                                        #
##########################################################################

%nl4rtr_01_00358_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COMPARE_PATTERN"              => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Trigger Comparison Test: Reference Pattern" ],
   "COMPARE_MASK"                 => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Trigger Comparison Test: Enable Bits" ],
);

%nl4rtr_01_00358_def =
( NAME    => "R4_BRANCH1_TEST_POINT_COMPARE",
  ADDRESS => 0x0000000001006028,
  NOTE    => "The NL4R arbit register configures a comparison test between the note output of NL4R arbit's 32-bit Trigger Multiplexer and the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00358_flds
);


##########################################################################
#                                                                        #
#   R4_BRANCH1_TEST_POINT_TRIGGER_SELECT                                     #
#                                                                        #
##########################################################################

%nl4rtr_01_00359_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_NIBBLE_SEL"          => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 7: Nibble Select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_CHIPLET_SEL"         => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 7: Port Select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_NIBBLE_SEL"          => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 6: Nibble Select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_CHIPLET_SEL"         => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 6: Port Select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_NIBBLE_SEL"          => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 5: Nibble Select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_CHIPLET_SEL"         => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 5: Port Select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_NIBBLE_SEL"          => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 4: Nibble Select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_CHIPLET_SEL"         => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 4: Port Select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_NIBBLE_SEL"          => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 3: Nibble Select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_CHIPLET_SEL"         => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 3: Port Select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_NIBBLE_SEL"          => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 2: Nibble Select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_CHIPLET_SEL"         => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 2: Port Select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_NIBBLE_SEL"          => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 1: Nibble Select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_CHIPLET_SEL"         => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Output Port Nibble 1: Port Select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_NIBBLE_SEL"          => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Output Port Nibble 0: Nibble Select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_CHIPLET_SEL"         => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Output Port Nibble 0: Port Select" ],
);

%nl4rtr_01_00359_def =
( NAME    => "R4_BRANCH1_TEST_POINT_TRIGGER_SELECT",
  ADDRESS => 0x0000000001006030,
  NOTE    => "The BRANCH1_TEST_POINT_TRIGGER_SELECT register contains the select note bits for the NL4R arbit's Trigger Multiplexer. The NL4R ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00359_flds
);


##########################################################################
#                                                                        #
#   R4_BRANCH2_TEST_POINT_SELECT                                         #
#                                                                        #
##########################################################################

%nl4rtr_01_00360_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TRIGGER_ENABLE"               => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Send Trigger Compare Result to Output Port Bit 31" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 7: Nibble Select" ],
   "RSVD0"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_CHIPLET_SEL"          => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 7: Port Select" ],
   "RSVD1"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 6: Nibble Select" ],
   "RSVD2"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_CHIPLET_SEL"          => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 6: Port Select" ],
   "RSVD3"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 5: Nibble Select" ],
   "RSVD4"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_CHIPLET_SEL"          => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 5: Port Select" ],
   "RSVD5"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 4: Nibble Select" ],
   "RSVD6"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_CHIPLET_SEL"          => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 4: Port Select" ],
   "RSVD7"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 3: Nibble Select" ],
   "RSVD8"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_CHIPLET_SEL"          => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 3: Port Select" ],
   "RSVD9"                        => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 2: Nibble Select" ],
   "RSVD10"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_CHIPLET_SEL"          => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 2: Port Select" ],
   "RSVD11"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 1: Nibble Select" ],
   "RSVD12"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_CHIPLET_SEL"          => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Output Port Nibble 1: Port Select" ],
   "RSVD13"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Output Port Nibble 0: Nibble Select" ],
   "RSVD14"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_CHIPLET_SEL"          => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Output Port Nibble 0: Port Select" ],
);

%nl4rtr_01_00360_def =
( NAME    => "R4_BRANCH2_TEST_POINT_SELECT",
  ADDRESS => 0x0000000001006040,
  NOTE    => "The BRANCH2_TEST_POINT_SELECT configures (i.e., contains the select note signals for) the NL4R port Test Point Multiplexer. The ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00360_flds
);


##########################################################################
#                                                                        #
#   R4_BRANCH2_TEST_POINT_COMPARE                                        #
#                                                                        #
##########################################################################

%nl4rtr_01_00361_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COMPARE_PATTERN"              => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Trigger Comparison Test: Reference Pattern" ],
   "COMPARE_MASK"                 => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Trigger Comparison Test: Enable Bits" ],
);

%nl4rtr_01_00361_def =
( NAME    => "R4_BRANCH2_TEST_POINT_COMPARE",
  ADDRESS => 0x0000000001006048,
  NOTE    => "The NL4R port register configures a comparison test between the note output of NL4R port's 32-bit Trigger Multiplexer and the NL",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00361_flds
);


##########################################################################
#                                                                        #
#   R4_BRANCH2_TEST_POINT_TRIGGER_SELECT                                     #
#                                                                        #
##########################################################################

%nl4rtr_01_00362_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_NIBBLE_SEL"          => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 7: Nibble Select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_CHIPLET_SEL"         => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 7: Port Select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_NIBBLE_SEL"          => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 6: Nibble Select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_CHIPLET_SEL"         => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 6: Port Select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_NIBBLE_SEL"          => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 5: Nibble Select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_CHIPLET_SEL"         => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 5: Port Select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_NIBBLE_SEL"          => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 4: Nibble Select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_CHIPLET_SEL"         => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 4: Port Select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_NIBBLE_SEL"          => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 3: Nibble Select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_CHIPLET_SEL"         => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 3: Port Select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_NIBBLE_SEL"          => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 2: Nibble Select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_CHIPLET_SEL"         => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 2: Port Select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_NIBBLE_SEL"          => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 1: Nibble Select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_CHIPLET_SEL"         => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Output Port Nibble 1: Port Select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_NIBBLE_SEL"          => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Output Port Nibble 0: Nibble Select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_CHIPLET_SEL"         => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Output Port Nibble 0: Port Select" ],
);

%nl4rtr_01_00362_def =
( NAME    => "R4_BRANCH2_TEST_POINT_TRIGGER_SELECT",
  ADDRESS => 0x0000000001006050,
  NOTE    => "The BRANCH2_TEST_POINT_TRIGGER_SELECT register contains the select note bits for the NL4R port's Trigger Multiplexer. The NL4R p",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00362_flds
);


##########################################################################
#                                                                        #
#   R4_BRANCH1_DEBUG_DATA                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00363_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TRIG"                         => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Trig" ],
   "DATA"                         => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Data" ],
);

%nl4rtr_01_00363_def =
( NAME    => "R4_BRANCH1_DEBUG_DATA",
  ADDRESS => 0x0000000001007100,
  NOTE    => "The BRANCH1_DEBUG_DATA register contains a copy of the debug data note being sent from the BRANCH1 to the LB chiplet.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00363_flds
);


##########################################################################
#                                                                        #
#   R4_BRANCH2_DEBUG_DATA                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00364_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TRIG"                         => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Trig" ],
   "DATA"                         => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Data" ],
);

%nl4rtr_01_00364_def =
( NAME    => "R4_BRANCH2_DEBUG_DATA",
  ADDRESS => 0x0000000001007108,
  NOTE    => "The BRANCH2_DEBUG_DATA register contains a copy of the debug data note being sent from the BRANCH2 to the LB chiplet.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00364_flds
);


##########################################################################
#                                                                        #
#   R4_ROOT_DEBUG_DATA                                                   #
#                                                                        #
##########################################################################

%nl4rtr_01_00365_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TRIG"                         => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Trig" ],
   "DATA"                         => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Data" ],
);

%nl4rtr_01_00365_def =
( NAME    => "R4_ROOT_DEBUG_DATA",
  ADDRESS => 0x0000000001007110,
  NOTE    => "The ROOT_DEBUG_DATA register contains a copy of the debug data note being sent into the top debug port.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00365_flds
);


##########################################################################
#                                                                        #
#   R4_STOP_CLK_CONTROL                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00366_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE"                       => [   1,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Clock stop enable (0-disabled, 1-enabled)" ],
   "MODE"                         => [   2,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Clock stop mode select (0-internal, 1-external)" ],
   "POLARITY"                     => [   3,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Clock stop polarity select (0-negative edge, 1-positive edge)" ],
   "EVENT"                        => [   4,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Clock stop format select (1-level, 0-edge)" ],
   "STIMULUS"                     => [   5,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Clock stop stimulus" ],
);

%nl4rtr_01_00366_def =
( NAME    => "R4_STOP_CLK_CONTROL",
  ADDRESS => 0x0000000001008000,
  NOTE    => "Stop Clock Control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00366_flds
);


##########################################################################
#                                                                        #
#   R4_STOP_CLK_DELAY_PHASE                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00367_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DELAY"                        => [   1,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Delay phase" ],
);

%nl4rtr_01_00367_def =
( NAME    => "R4_STOP_CLK_DELAY_PHASE",
  ADDRESS => 0x0000000001008080,
  NOTE    => "Stop Clock Delay Phase",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00367_flds
);


##########################################################################
#                                                                        #
#   R4_PERFORMANCE_COUNT0_CONTROL                                        #
#                                                                        #
##########################################################################

%nl4rtr_01_00368_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CLR_ENABLE"                   => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Counter enable clear" ],
   "CLR_MODE"                     => [   2,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Counter clear mode select (1-internal, 0-external)" ],
   "CLR_POLARITY"                 => [   3,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Counter clear polarity select (1-negative edge, 0-positive edge)" ],
   "CLR_EVENT"                    => [   4,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Counter clear format select (1-level, 0-edge)" ],
   "CLR_STIMULUS"                 => [   5,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "Counter clear stimulus" ],
   "RSVD1"                        => [   6,  19,   5, 0x0000000000F80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Counter enable peak detection" ],
   "DEC_ENABLE"                   => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Counter enable decrement" ],
   "INC_ENABLE"                   => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Counter enable increment" ],
   "DN_MODE"                      => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Counter down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Counter down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Counter down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "Counter down stimulus" ],
   "UP_MODE"                      => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Counter up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Counter up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Counter up format select (1-level, 0-edge)" ],
   "UP_STIMULUS"                  => [  17,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter up stimulus" ],
);

%nl4rtr_01_00368_def =
( NAME    => "R4_PERFORMANCE_COUNT0_CONTROL",
  ADDRESS => 0x0000000001080000,
  NOTE    => "The PERFORMANCE_COUNT0_CONTROL register controls the incrementing note and decrementing of event counter 0.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00368_flds
);


##########################################################################
#                                                                        #
#   R4_PERFORMANCE_COUNT1_CONTROL                                        #
#                                                                        #
##########################################################################

%nl4rtr_01_00369_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CLR_ENABLE"                   => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Counter enable clear" ],
   "CLR_MODE"                     => [   2,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Counter clear mode select (1-internal, 0-external)" ],
   "CLR_POLARITY"                 => [   3,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Counter clear polarity select (1-negative edge, 0-positive edge)" ],
   "CLR_EVENT"                    => [   4,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Counter clear format select (1-level, 0-edge)" ],
   "CLR_STIMULUS"                 => [   5,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "Counter clear stimulus" ],
   "RSVD1"                        => [   6,  19,   5, 0x0000000000F80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Counter enable peak detection" ],
   "DEC_ENABLE"                   => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Counter enable decrement" ],
   "INC_ENABLE"                   => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Counter enable increment" ],
   "DN_MODE"                      => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Counter down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Counter down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Counter down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "Counter down stimulus" ],
   "UP_MODE"                      => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Counter up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Counter up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Counter up format select (1-level, 0-edge)" ],
   "UP_STIMULUS"                  => [  17,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter up stimulus" ],
);

%nl4rtr_01_00369_def =
( NAME    => "R4_PERFORMANCE_COUNT1_CONTROL",
  ADDRESS => 0x0000000001090000,
  NOTE    => "The PERFORMANCE_COUNT1_CONTROL register controls the incrementing note and decrementing of event counter 1.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00369_flds
);


##########################################################################
#                                                                        #
#   R4_PERFORMANCE_COUNT2_CONTROL                                        #
#                                                                        #
##########################################################################

%nl4rtr_01_00370_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CLR_ENABLE"                   => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Counter enable clear" ],
   "CLR_MODE"                     => [   2,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Counter clear mode select (1-internal, 0-external)" ],
   "CLR_POLARITY"                 => [   3,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Counter clear polarity select (1-negative edge, 0-positive edge)" ],
   "CLR_EVENT"                    => [   4,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Counter clear format select (1-level, 0-edge)" ],
   "CLR_STIMULUS"                 => [   5,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "Counter clear stimulus" ],
   "RSVD1"                        => [   6,  19,   5, 0x0000000000F80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Counter enable peak detection" ],
   "DEC_ENABLE"                   => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Counter enable decrement" ],
   "INC_ENABLE"                   => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Counter enable increment" ],
   "DN_MODE"                      => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Counter down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Counter down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Counter down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "Counter down stimulus" ],
   "UP_MODE"                      => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Counter up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Counter up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Counter up format select (1-level, 0-edge)" ],
   "UP_STIMULUS"                  => [  17,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter up stimulus" ],
);

%nl4rtr_01_00370_def =
( NAME    => "R4_PERFORMANCE_COUNT2_CONTROL",
  ADDRESS => 0x00000000010a0000,
  NOTE    => "The PERFORMANCE_COUNT2_CONTROL register controls the incrementing note and decrementing of event counter 2.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00370_flds
);


##########################################################################
#                                                                        #
#   R4_PERFORMANCE_COUNT3_CONTROL                                        #
#                                                                        #
##########################################################################

%nl4rtr_01_00371_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CLR_ENABLE"                   => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Counter enable clear" ],
   "CLR_MODE"                     => [   2,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Counter clear mode select (1-internal, 0-external)" ],
   "CLR_POLARITY"                 => [   3,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Counter clear polarity select (1-negative edge, 0-positive edge)" ],
   "CLR_EVENT"                    => [   4,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Counter clear format select (1-level, 0-edge)" ],
   "CLR_STIMULUS"                 => [   5,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "Counter clear stimulus" ],
   "RSVD1"                        => [   6,  19,   5, 0x0000000000F80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Counter enable peak detection" ],
   "DEC_ENABLE"                   => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Counter enable decrement" ],
   "INC_ENABLE"                   => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Counter enable increment" ],
   "DN_MODE"                      => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Counter down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Counter down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Counter down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "Counter down stimulus" ],
   "UP_MODE"                      => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Counter up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Counter up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Counter up format select (1-level, 0-edge)" ],
   "UP_STIMULUS"                  => [  17,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter up stimulus" ],
);

%nl4rtr_01_00371_def =
( NAME    => "R4_PERFORMANCE_COUNT3_CONTROL",
  ADDRESS => 0x00000000010b0000,
  NOTE    => "The PERFORMANCE_COUNT3_CONTROL register controls the incrementing note and decrementing of event counter 3.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00371_flds
);


##########################################################################
#                                                                        #
#   R4_PERFORMANCE_COUNT4_CONTROL                                        #
#                                                                        #
##########################################################################

%nl4rtr_01_00372_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CLR_ENABLE"                   => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Counter enable clear" ],
   "CLR_MODE"                     => [   2,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Counter clear mode select (1-internal, 0-external)" ],
   "CLR_POLARITY"                 => [   3,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Counter clear polarity select (1-negative edge, 0-positive edge)" ],
   "CLR_EVENT"                    => [   4,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Counter clear format select (1-level, 0-edge)" ],
   "CLR_STIMULUS"                 => [   5,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "Counter clear stimulus" ],
   "RSVD1"                        => [   6,  19,   5, 0x0000000000F80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Counter enable peak detection" ],
   "DEC_ENABLE"                   => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Counter enable decrement" ],
   "INC_ENABLE"                   => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Counter enable increment" ],
   "DN_MODE"                      => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Counter down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Counter down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Counter down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "Counter down stimulus" ],
   "UP_MODE"                      => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Counter up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Counter up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Counter up format select (1-level, 0-edge)" ],
   "UP_STIMULUS"                  => [  17,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter up stimulus" ],
);

%nl4rtr_01_00372_def =
( NAME    => "R4_PERFORMANCE_COUNT4_CONTROL",
  ADDRESS => 0x00000000010c0000,
  NOTE    => "The PERFORMANCE_COUNT4_CONTROL register controls the incrementing note and decrementing of event counter 4.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00372_flds
);


##########################################################################
#                                                                        #
#   R4_PERFORMANCE_COUNT5_CONTROL                                        #
#                                                                        #
##########################################################################

%nl4rtr_01_00373_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CLR_ENABLE"                   => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Counter enable clear" ],
   "CLR_MODE"                     => [   2,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Counter clear mode select (1-internal, 0-external)" ],
   "CLR_POLARITY"                 => [   3,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Counter clear polarity select (1-negative edge, 0-positive edge)" ],
   "CLR_EVENT"                    => [   4,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Counter clear format select (1-level, 0-edge)" ],
   "CLR_STIMULUS"                 => [   5,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "Counter clear stimulus" ],
   "RSVD1"                        => [   6,  19,   5, 0x0000000000F80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Counter enable peak detection" ],
   "DEC_ENABLE"                   => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Counter enable decrement" ],
   "INC_ENABLE"                   => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Counter enable increment" ],
   "DN_MODE"                      => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Counter down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Counter down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Counter down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "Counter down stimulus" ],
   "UP_MODE"                      => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Counter up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Counter up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Counter up format select (1-level, 0-edge)" ],
   "UP_STIMULUS"                  => [  17,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter up stimulus" ],
);

%nl4rtr_01_00373_def =
( NAME    => "R4_PERFORMANCE_COUNT5_CONTROL",
  ADDRESS => 0x00000000010d0000,
  NOTE    => "The PERFORMANCE_COUNT5_CONTROL register controls the incrementing note and decrementing of event counter 5.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00373_flds
);


##########################################################################
#                                                                        #
#   R4_PERFORMANCE_COUNT6_CONTROL                                        #
#                                                                        #
##########################################################################

%nl4rtr_01_00374_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CLR_ENABLE"                   => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Counter enable clear" ],
   "CLR_MODE"                     => [   2,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Counter clear mode select (1-internal, 0-external)" ],
   "CLR_POLARITY"                 => [   3,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Counter clear polarity select (1-negative edge, 0-positive edge)" ],
   "CLR_EVENT"                    => [   4,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Counter clear format select (1-level, 0-edge)" ],
   "CLR_STIMULUS"                 => [   5,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "Counter clear stimulus" ],
   "RSVD1"                        => [   6,  19,   5, 0x0000000000F80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Counter enable peak detection" ],
   "DEC_ENABLE"                   => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Counter enable decrement" ],
   "INC_ENABLE"                   => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Counter enable increment" ],
   "DN_MODE"                      => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Counter down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Counter down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Counter down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "Counter down stimulus" ],
   "UP_MODE"                      => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Counter up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Counter up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Counter up format select (1-level, 0-edge)" ],
   "UP_STIMULUS"                  => [  17,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter up stimulus" ],
);

%nl4rtr_01_00374_def =
( NAME    => "R4_PERFORMANCE_COUNT6_CONTROL",
  ADDRESS => 0x00000000010e0000,
  NOTE    => "The PERFORMANCE_COUNT6_CONTROL register controls the incrementing note and decrementing of event counter 6.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00374_flds
);


##########################################################################
#                                                                        #
#   R4_PERFORMANCE_COUNT7_CONTROL                                        #
#                                                                        #
##########################################################################

%nl4rtr_01_00375_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CLR_ENABLE"                   => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Counter enable clear" ],
   "CLR_MODE"                     => [   2,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Counter clear mode select (1-internal, 0-external)" ],
   "CLR_POLARITY"                 => [   3,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Counter clear polarity select (1-negative edge, 0-positive edge)" ],
   "CLR_EVENT"                    => [   4,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Counter clear format select (1-level, 0-edge)" ],
   "CLR_STIMULUS"                 => [   5,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "Counter clear stimulus" ],
   "RSVD1"                        => [   6,  19,   5, 0x0000000000F80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Counter enable peak detection" ],
   "DEC_ENABLE"                   => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Counter enable decrement" ],
   "INC_ENABLE"                   => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Counter enable increment" ],
   "DN_MODE"                      => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Counter down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Counter down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Counter down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "Counter down stimulus" ],
   "UP_MODE"                      => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Counter up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Counter up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Counter up format select (1-level, 0-edge)" ],
   "UP_STIMULUS"                  => [  17,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter up stimulus" ],
);

%nl4rtr_01_00375_def =
( NAME    => "R4_PERFORMANCE_COUNT7_CONTROL",
  ADDRESS => 0x00000000010f0000,
  NOTE    => "The PERFORMANCE_COUNT7_CONTROL register controls the incrementing note and decrementing of event counter 7.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00375_flds
);


##########################################################################
#                                                                        #
#   R4_PROFILE_DN_CONTROL                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00376_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MODE"                         => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Counter mode select (1-internal, 0-external)" ],
   "POLARITY"                     => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Counter polarity select (1-negative edge, 0-positive edge)" ],
   "EVENT"                        => [   3,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Counter format select (1-level, 0-edge)" ],
   "STIMULUS"                     => [   4,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter stimulus" ],
);

%nl4rtr_01_00376_def =
( NAME    => "R4_PROFILE_DN_CONTROL",
  ADDRESS => 0x0000000001100000,
  NOTE    => "The PROFILE_DN_CONTROL register controls the decrementing of the note profile counter.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00376_flds
);


##########################################################################
#                                                                        #
#   R4_PROFILE_PEAK_CONTROL                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00377_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   7,  57, 0xFFFFFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "POLARITY"                     => [   1,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Counter polarity select (0-negative edge, 1-positive edge)" ],
   "EVENT"                        => [   2,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Counter format select (1-level, 0-edge)" ],
   "RSVD1"                        => [   3,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STIMULUS"                     => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Counter stimulus (1-equal, 0-greater than)" ],
);

%nl4rtr_01_00377_def =
( NAME    => "R4_PROFILE_PEAK_CONTROL",
  ADDRESS => 0x0000000001100080,
  NOTE    => "The PROFILE_PEAK_CONTROL register controls the loading of the note r4_profile_peak register.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00377_flds
);


##########################################################################
#                                                                        #
#   R4_PROFILE_RANGE                                                     #
#                                                                        #
##########################################################################

%nl4rtr_01_00378_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RANGE7"                       => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Profiling range 7" ],
   "RANGE6"                       => [   1,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "Profiling range 6" ],
   "RANGE5"                       => [   2,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "Profiling range 5" ],
   "RANGE4"                       => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Profiling range 4" ],
   "RANGE3"                       => [   4,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "Profiling range 3" ],
   "RANGE2"                       => [   5,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Profiling range 2" ],
   "RANGE1"                       => [   6,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "Profiling range 1" ],
   "RANGE0"                       => [   7,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Profiling range 0" ],
);

%nl4rtr_01_00378_def =
( NAME    => "R4_PROFILE_RANGE",
  ADDRESS => 0x0000000001100100,
  NOTE    => "There are eight profile range fields in the PROFILE_RANGE register. note The profiling count can be compared against the eight p",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00378_flds
);


##########################################################################
#                                                                        #
#   R4_PROFILE_UP_CONTROL                                                #
#                                                                        #
##########################################################################

%nl4rtr_01_00379_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MODE"                         => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Counter mode select (1-internal, 0-external)" ],
   "POLARITY"                     => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Counter polarity select (1-negative edge, 0-positive edge)" ],
   "EVENT"                        => [   3,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Counter format select (1-level, 0-edge)" ],
   "STIMULUS"                     => [   4,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter stimulus" ],
);

%nl4rtr_01_00379_def =
( NAME    => "R4_PROFILE_UP_CONTROL",
  ADDRESS => 0x0000000001100180,
  NOTE    => "The PROFILE_UP_CONTROL register controls the decrementing of the note profile counter.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00379_flds
);


##########################################################################
#                                                                        #
#   R4_PERF_TRIG_PATTERN_0                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00380_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "BIT_EN"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Bit Enable" ],
   "DATA"                         => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Data" ],
);

%nl4rtr_01_00380_def =
( NAME    => "R4_PERF_TRIG_PATTERN_0",
  ADDRESS => 0x0000000001100200,
  NOTE    => "PERF_TRIG_PATTERN represents a set of 16 registers.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00380_flds
);


##########################################################################
#                                                                        #
#   R4_PERF_TRIG_PATTERN_1                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00381_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "BIT_EN"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Bit Enable" ],
   "DATA"                         => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Data" ],
);

%nl4rtr_01_00381_def =
( NAME    => "R4_PERF_TRIG_PATTERN_1",
  ADDRESS => 0x0000000001100208,
  NOTE    => "Performance Monitor Trigger Pattern 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00381_flds
);


##########################################################################
#                                                                        #
#   R4_PERF_TRIG_PATTERN_2                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00382_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "BIT_EN"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Bit Enable" ],
   "DATA"                         => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Data" ],
);

%nl4rtr_01_00382_def =
( NAME    => "R4_PERF_TRIG_PATTERN_2",
  ADDRESS => 0x0000000001100210,
  NOTE    => "Performance Monitor Trigger Pattern 2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00382_flds
);


##########################################################################
#                                                                        #
#   R4_PERF_TRIG_PATTERN_3                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00383_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "BIT_EN"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Bit Enable" ],
   "DATA"                         => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Data" ],
);

%nl4rtr_01_00383_def =
( NAME    => "R4_PERF_TRIG_PATTERN_3",
  ADDRESS => 0x0000000001100218,
  NOTE    => "Performance Monitor Trigger Pattern 3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00383_flds
);


##########################################################################
#                                                                        #
#   R4_PERF_TRIG_PATTERN_4                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00384_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "BIT_EN"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Bit Enable" ],
   "DATA"                         => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Data" ],
);

%nl4rtr_01_00384_def =
( NAME    => "R4_PERF_TRIG_PATTERN_4",
  ADDRESS => 0x0000000001100220,
  NOTE    => "Performance Monitor Trigger Pattern 4",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00384_flds
);


##########################################################################
#                                                                        #
#   R4_PERF_TRIG_PATTERN_5                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00385_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "BIT_EN"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Bit Enable" ],
   "DATA"                         => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Data" ],
);

%nl4rtr_01_00385_def =
( NAME    => "R4_PERF_TRIG_PATTERN_5",
  ADDRESS => 0x0000000001100228,
  NOTE    => "Performance Monitor Trigger Pattern 5",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00385_flds
);


##########################################################################
#                                                                        #
#   R4_PERF_TRIG_PATTERN_6                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00386_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "BIT_EN"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Bit Enable" ],
   "DATA"                         => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Data" ],
);

%nl4rtr_01_00386_def =
( NAME    => "R4_PERF_TRIG_PATTERN_6",
  ADDRESS => 0x0000000001100230,
  NOTE    => "Performance Monitor Trigger Pattern 6",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00386_flds
);


##########################################################################
#                                                                        #
#   R4_PERF_TRIG_PATTERN_7                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00387_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "BIT_EN"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Bit Enable" ],
   "DATA"                         => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Data" ],
);

%nl4rtr_01_00387_def =
( NAME    => "R4_PERF_TRIG_PATTERN_7",
  ADDRESS => 0x0000000001100238,
  NOTE    => "Performance Monitor Trigger Pattern 7",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00387_flds
);


##########################################################################
#                                                                        #
#   R4_PERF_TRIG_PATTERN_8                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00388_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "BIT_EN"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Bit Enable" ],
   "DATA"                         => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Data" ],
);

%nl4rtr_01_00388_def =
( NAME    => "R4_PERF_TRIG_PATTERN_8",
  ADDRESS => 0x0000000001100240,
  NOTE    => "Performance Monitor Trigger Pattern 8",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00388_flds
);


##########################################################################
#                                                                        #
#   R4_PERF_TRIG_PATTERN_9                                               #
#                                                                        #
##########################################################################

%nl4rtr_01_00389_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "BIT_EN"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Bit Enable" ],
   "DATA"                         => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Data" ],
);

%nl4rtr_01_00389_def =
( NAME    => "R4_PERF_TRIG_PATTERN_9",
  ADDRESS => 0x0000000001100248,
  NOTE    => "Performance Monitor Trigger Pattern 9",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00389_flds
);


##########################################################################
#                                                                        #
#   R4_PERF_TRIG_PATTERN_10                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00390_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "BIT_EN"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Bit Enable" ],
   "DATA"                         => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Data" ],
);

%nl4rtr_01_00390_def =
( NAME    => "R4_PERF_TRIG_PATTERN_10",
  ADDRESS => 0x0000000001100250,
  NOTE    => "Performance Monitor Trigger Pattern 10",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00390_flds
);


##########################################################################
#                                                                        #
#   R4_PERF_TRIG_PATTERN_11                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00391_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "BIT_EN"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Bit Enable" ],
   "DATA"                         => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Data" ],
);

%nl4rtr_01_00391_def =
( NAME    => "R4_PERF_TRIG_PATTERN_11",
  ADDRESS => 0x0000000001100258,
  NOTE    => "Performance Monitor Trigger Pattern 11",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00391_flds
);


##########################################################################
#                                                                        #
#   R4_PERF_TRIG_PATTERN_12                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00392_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "BIT_EN"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Bit Enable" ],
   "DATA"                         => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Data" ],
);

%nl4rtr_01_00392_def =
( NAME    => "R4_PERF_TRIG_PATTERN_12",
  ADDRESS => 0x0000000001100260,
  NOTE    => "Performance Monitor Trigger Pattern 12",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00392_flds
);


##########################################################################
#                                                                        #
#   R4_PERF_TRIG_PATTERN_13                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00393_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "BIT_EN"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Bit Enable" ],
   "DATA"                         => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Data" ],
);

%nl4rtr_01_00393_def =
( NAME    => "R4_PERF_TRIG_PATTERN_13",
  ADDRESS => 0x0000000001100268,
  NOTE    => "Performance Monitor Trigger Pattern 13",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00393_flds
);


##########################################################################
#                                                                        #
#   R4_PERF_TRIG_PATTERN_14                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00394_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "BIT_EN"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Bit Enable" ],
   "DATA"                         => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Data" ],
);

%nl4rtr_01_00394_def =
( NAME    => "R4_PERF_TRIG_PATTERN_14",
  ADDRESS => 0x0000000001100270,
  NOTE    => "Performance Monitor Trigger Pattern 14",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00394_flds
);


##########################################################################
#                                                                        #
#   R4_PERF_TRIG_PATTERN_15                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00395_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "BIT_EN"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Bit Enable" ],
   "DATA"                         => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Data" ],
);

%nl4rtr_01_00395_def =
( NAME    => "R4_PERF_TRIG_PATTERN_15",
  ADDRESS => 0x0000000001100278,
  NOTE    => "Performance Monitor Trigger Pattern 15",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00395_flds
);


##########################################################################
#                                                                        #
#   R4_PERFORMANCE_COUNTER0                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00396_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 0" ],
);

%nl4rtr_01_00396_def =
( NAME    => "R4_PERFORMANCE_COUNTER0",
  ADDRESS => 0x0000000001110000,
  NOTE    => "Performance Counter 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00396_flds
);


##########################################################################
#                                                                        #
#   R4_PERFORMANCE_COUNTER1                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00397_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 1" ],
);

%nl4rtr_01_00397_def =
( NAME    => "R4_PERFORMANCE_COUNTER1",
  ADDRESS => 0x0000000001120000,
  NOTE    => "Performance Counter 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00397_flds
);


##########################################################################
#                                                                        #
#   R4_PERFORMANCE_COUNTER2                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00398_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 2" ],
);

%nl4rtr_01_00398_def =
( NAME    => "R4_PERFORMANCE_COUNTER2",
  ADDRESS => 0x0000000001130000,
  NOTE    => "Performance Counter 2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00398_flds
);


##########################################################################
#                                                                        #
#   R4_PERFORMANCE_COUNTER3                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00399_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 3" ],
);

%nl4rtr_01_00399_def =
( NAME    => "R4_PERFORMANCE_COUNTER3",
  ADDRESS => 0x0000000001140000,
  NOTE    => "Performance Counter 3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00399_flds
);


##########################################################################
#                                                                        #
#   R4_PERFORMANCE_COUNTER4                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00400_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 4" ],
);

%nl4rtr_01_00400_def =
( NAME    => "R4_PERFORMANCE_COUNTER4",
  ADDRESS => 0x0000000001150000,
  NOTE    => "Performance Counter 4",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00400_flds
);


##########################################################################
#                                                                        #
#   R4_PERFORMANCE_COUNTER5                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00401_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 5" ],
);

%nl4rtr_01_00401_def =
( NAME    => "R4_PERFORMANCE_COUNTER5",
  ADDRESS => 0x0000000001160000,
  NOTE    => "Performance Counter 5",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00401_flds
);


##########################################################################
#                                                                        #
#   R4_PERFORMANCE_COUNTER6                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00402_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 6" ],
);

%nl4rtr_01_00402_def =
( NAME    => "R4_PERFORMANCE_COUNTER6",
  ADDRESS => 0x0000000001170000,
  NOTE    => "Performance Counter 6",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00402_flds
);


##########################################################################
#                                                                        #
#   R4_PERFORMANCE_COUNTER7                                              #
#                                                                        #
##########################################################################

%nl4rtr_01_00403_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 7" ],
);

%nl4rtr_01_00403_def =
( NAME    => "R4_PERFORMANCE_COUNTER7",
  ADDRESS => 0x0000000001180000,
  NOTE    => "Performance Counter 7",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00403_flds
);


##########################################################################
#                                                                        #
#   R4_PROFILE_COUNTER                                                   #
#                                                                        #
##########################################################################

%nl4rtr_01_00404_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNTER"                      => [   1,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Counter Value" ],
);

%nl4rtr_01_00404_def =
( NAME    => "R4_PROFILE_COUNTER",
  ADDRESS => 0x0000000001190000,
  NOTE    => "Profile Counter",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00404_flds
);


##########################################################################
#                                                                        #
#   R4_PROFILE_PEAK                                                      #
#                                                                        #
##########################################################################

%nl4rtr_01_00405_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNTER"                      => [   1,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Counter Value" ],
);

%nl4rtr_01_00405_def =
( NAME    => "R4_PROFILE_PEAK",
  ADDRESS => 0x0000000001190080,
  NOTE    => "Profile Peak Counter",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00405_flds
);


##########################################################################
#                                                                        #
#   R4_LB0_TEST_POINT_SELECT_512                                         #
#                                                                        #
##########################################################################

%nl4rtr_01_00406_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7: Nibble Select" ],
   "NIBBLE7_CHIPLET_SEL"          => [   2,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7: Port Select" ],
   "RSVD1"                        => [   3,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   4,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6: Nibble Select" ],
   "NIBBLE6_CHIPLET_SEL"          => [   5,  48,   4, 0x000F000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6: Word Select" ],
   "RSVD2"                        => [   6,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   7,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5: Nibble Select" ],
   "NIBBLE5_CHIPLET_SEL"          => [   8,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "Nibble 5: Word Select" ],
   "RSVD3"                        => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  10,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4: Nibble Select" ],
   "NIBBLE4_CHIPLET_SEL"          => [  11,  32,   4, 0x0000000F00000000, 0x00, 0, 0x0000000000000000, "Nibble 4: Port Select" ],
   "RSVD4"                        => [  12,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  13,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3: Nibble Select" ],
   "NIBBLE3_CHIPLET_SEL"          => [  14,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "Nibble 3: Word Select" ],
   "RSVD5"                        => [  15,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  16,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2: Nibble Select" ],
   "NIBBLE2_CHIPLET_SEL"          => [  17,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "Nibble 2: Word Select" ],
   "RSVD6"                        => [  18,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  19,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1: Nibble Select" ],
   "NIBBLE1_CHIPLET_SEL"          => [  20,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Nibble 1: Word Select" ],
   "RSVD7"                        => [  21,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  22,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0: Nibble Select" ],
   "NIBBLE0_CHIPLET_SEL"          => [  23,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Nibble 0: Word Select" ],
);

%nl4rtr_01_00406_def =
( NAME    => "R4_LB0_TEST_POINT_SELECT_512",
  ADDRESS => 0x0000000000002700,
  NOTE    => "The LB0_TEST_POINT_SELECT_512 configures (i.e., contains the select note signals for) the LB0 Test Point Multiplexer. The LB0 Te",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00406_flds
);


##########################################################################
#                                                                        #
#   R4_LB1_TEST_POINT_SELECT_512                                         #
#                                                                        #
##########################################################################

%nl4rtr_01_00407_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7: Nibble Select" ],
   "NIBBLE7_CHIPLET_SEL"          => [   2,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7: Port Select" ],
   "RSVD1"                        => [   3,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   4,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6: Nibble Select" ],
   "NIBBLE6_CHIPLET_SEL"          => [   5,  48,   4, 0x000F000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6: Word Select" ],
   "RSVD2"                        => [   6,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   7,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5: Nibble Select" ],
   "NIBBLE5_CHIPLET_SEL"          => [   8,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "Nibble 5: Word Select" ],
   "RSVD3"                        => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  10,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4: Nibble Select" ],
   "NIBBLE4_CHIPLET_SEL"          => [  11,  32,   4, 0x0000000F00000000, 0x00, 0, 0x0000000000000000, "Nibble 4: Port Select" ],
   "RSVD4"                        => [  12,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  13,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3: Nibble Select" ],
   "NIBBLE3_CHIPLET_SEL"          => [  14,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "Nibble 3: Word Select" ],
   "RSVD5"                        => [  15,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  16,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2: Nibble Select" ],
   "NIBBLE2_CHIPLET_SEL"          => [  17,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "Nibble 2: Word Select" ],
   "RSVD6"                        => [  18,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  19,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1: Nibble Select" ],
   "NIBBLE1_CHIPLET_SEL"          => [  20,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Nibble 1: Word Select" ],
   "RSVD7"                        => [  21,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  22,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0: Nibble Select" ],
   "NIBBLE0_CHIPLET_SEL"          => [  23,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Nibble 0: Word Select" ],
);

%nl4rtr_01_00407_def =
( NAME    => "R4_LB1_TEST_POINT_SELECT_512",
  ADDRESS => 0x0000000001002700,
  NOTE    => "The LB1_TEST_POINT_SELECT_512 configures (i.e., contains the select note signals for) the LB1 Test Point Multiplexer. The LB1 Te",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00407_flds
);


##########################################################################
#                                                                        #
#   R4_ARBL_TEST_POINT_SELECT_512                                        #
#                                                                        #
##########################################################################

%nl4rtr_01_00408_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7: Nibble Select" ],
   "NIBBLE7_CHIPLET_SEL"          => [   2,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7: Port Select" ],
   "RSVD1"                        => [   3,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   4,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6: Nibble Select" ],
   "NIBBLE6_CHIPLET_SEL"          => [   5,  48,   4, 0x000F000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6: Word Select" ],
   "RSVD2"                        => [   6,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   7,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5: Nibble Select" ],
   "NIBBLE5_CHIPLET_SEL"          => [   8,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "Nibble 5: Word Select" ],
   "RSVD3"                        => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  10,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4: Nibble Select" ],
   "NIBBLE4_CHIPLET_SEL"          => [  11,  32,   4, 0x0000000F00000000, 0x00, 0, 0x0000000000000000, "Nibble 4: Port Select" ],
   "RSVD4"                        => [  12,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  13,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3: Nibble Select" ],
   "NIBBLE3_CHIPLET_SEL"          => [  14,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "Nibble 3: Word Select" ],
   "RSVD5"                        => [  15,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  16,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2: Nibble Select" ],
   "NIBBLE2_CHIPLET_SEL"          => [  17,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "Nibble 2: Word Select" ],
   "RSVD6"                        => [  18,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  19,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1: Nibble Select" ],
   "NIBBLE1_CHIPLET_SEL"          => [  20,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Nibble 1: Word Select" ],
   "RSVD7"                        => [  21,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  22,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0: Nibble Select" ],
   "NIBBLE0_CHIPLET_SEL"          => [  23,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Nibble 0: Word Select" ],
);

%nl4rtr_01_00408_def =
( NAME    => "R4_ARBL_TEST_POINT_SELECT_512",
  ADDRESS => 0x0000000002002700,
  NOTE    => "The ARBL_TEST_POINT_SELECT_512 configures (i.e., contains the note select signals for) the ARBL Test Point Multiplexer. The ARBL",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00408_flds
);


##########################################################################
#                                                                        #
#   R4_ARBR_TEST_POINT_SELECT_512                                        #
#                                                                        #
##########################################################################

%nl4rtr_01_00409_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7: Nibble Select" ],
   "NIBBLE7_CHIPLET_SEL"          => [   2,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7: Port Select" ],
   "RSVD1"                        => [   3,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   4,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6: Nibble Select" ],
   "NIBBLE6_CHIPLET_SEL"          => [   5,  48,   4, 0x000F000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6: Word Select" ],
   "RSVD2"                        => [   6,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   7,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5: Nibble Select" ],
   "NIBBLE5_CHIPLET_SEL"          => [   8,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "Nibble 5: Word Select" ],
   "RSVD3"                        => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  10,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4: Nibble Select" ],
   "NIBBLE4_CHIPLET_SEL"          => [  11,  32,   4, 0x0000000F00000000, 0x00, 0, 0x0000000000000000, "Nibble 4: Port Select" ],
   "RSVD4"                        => [  12,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  13,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3: Nibble Select" ],
   "NIBBLE3_CHIPLET_SEL"          => [  14,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "Nibble 3: Word Select" ],
   "RSVD5"                        => [  15,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  16,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2: Nibble Select" ],
   "NIBBLE2_CHIPLET_SEL"          => [  17,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "Nibble 2: Word Select" ],
   "RSVD6"                        => [  18,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  19,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1: Nibble Select" ],
   "NIBBLE1_CHIPLET_SEL"          => [  20,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Nibble 1: Word Select" ],
   "RSVD7"                        => [  21,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  22,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0: Nibble Select" ],
   "NIBBLE0_CHIPLET_SEL"          => [  23,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Nibble 0: Word Select" ],
);

%nl4rtr_01_00409_def =
( NAME    => "R4_ARBR_TEST_POINT_SELECT_512",
  ADDRESS => 0x0000000002002720,
  NOTE    => "The ARBR_TEST_POINT_SELECT_512 configures (i.e., contains the note select signals for) the ARBR Test Point Multiplexer. The ARBR",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00409_flds
);


##########################################################################
#                                                                        #
#   R4_CDQ0_TEST_POINT_SELECT_512                                        #
#                                                                        #
##########################################################################

%nl4rtr_01_00410_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7: Nibble Select" ],
   "NIBBLE7_CHIPLET_SEL"          => [   2,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7: Port Select" ],
   "RSVD1"                        => [   3,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   4,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6: Nibble Select" ],
   "NIBBLE6_CHIPLET_SEL"          => [   5,  48,   4, 0x000F000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6: Word Select" ],
   "RSVD2"                        => [   6,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   7,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5: Nibble Select" ],
   "NIBBLE5_CHIPLET_SEL"          => [   8,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "Nibble 5: Word Select" ],
   "RSVD3"                        => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  10,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4: Nibble Select" ],
   "NIBBLE4_CHIPLET_SEL"          => [  11,  32,   4, 0x0000000F00000000, 0x00, 0, 0x0000000000000000, "Nibble 4: Port Select" ],
   "RSVD4"                        => [  12,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  13,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3: Nibble Select" ],
   "NIBBLE3_CHIPLET_SEL"          => [  14,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "Nibble 3: Word Select" ],
   "RSVD5"                        => [  15,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  16,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2: Nibble Select" ],
   "NIBBLE2_CHIPLET_SEL"          => [  17,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "Nibble 2: Word Select" ],
   "RSVD6"                        => [  18,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  19,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1: Nibble Select" ],
   "NIBBLE1_CHIPLET_SEL"          => [  20,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Nibble 1: Word Select" ],
   "RSVD7"                        => [  21,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  22,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0: Nibble Select" ],
   "NIBBLE0_CHIPLET_SEL"          => [  23,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Nibble 0: Word Select" ],
);

%nl4rtr_01_00410_def =
( NAME    => "R4_CDQ0_TEST_POINT_SELECT_512",
  ADDRESS => 0x0000000002002740,
  NOTE    => "The CDQ0_TEST_POINT_SELECT_512 configures (i.e., contains the note select signals for) the CDQ0 Test Point Multiplexer. The CDQ0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00410_flds
);


##########################################################################
#                                                                        #
#   R4_CDQ1_TEST_POINT_SELECT_512                                        #
#                                                                        #
##########################################################################

%nl4rtr_01_00411_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7: Nibble Select" ],
   "NIBBLE7_CHIPLET_SEL"          => [   2,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7: Port Select" ],
   "RSVD1"                        => [   3,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   4,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6: Nibble Select" ],
   "NIBBLE6_CHIPLET_SEL"          => [   5,  48,   4, 0x000F000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6: Word Select" ],
   "RSVD2"                        => [   6,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   7,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5: Nibble Select" ],
   "NIBBLE5_CHIPLET_SEL"          => [   8,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "Nibble 5: Word Select" ],
   "RSVD3"                        => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  10,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4: Nibble Select" ],
   "NIBBLE4_CHIPLET_SEL"          => [  11,  32,   4, 0x0000000F00000000, 0x00, 0, 0x0000000000000000, "Nibble 4: Port Select" ],
   "RSVD4"                        => [  12,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  13,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3: Nibble Select" ],
   "NIBBLE3_CHIPLET_SEL"          => [  14,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "Nibble 3: Word Select" ],
   "RSVD5"                        => [  15,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  16,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2: Nibble Select" ],
   "NIBBLE2_CHIPLET_SEL"          => [  17,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "Nibble 2: Word Select" ],
   "RSVD6"                        => [  18,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  19,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1: Nibble Select" ],
   "NIBBLE1_CHIPLET_SEL"          => [  20,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Nibble 1: Word Select" ],
   "RSVD7"                        => [  21,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  22,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0: Nibble Select" ],
   "NIBBLE0_CHIPLET_SEL"          => [  23,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Nibble 0: Word Select" ],
);

%nl4rtr_01_00411_def =
( NAME    => "R4_CDQ1_TEST_POINT_SELECT_512",
  ADDRESS => 0x0000000002002760,
  NOTE    => "The CDQ1_TEST_POINT_SELECT_512 configures (i.e., contains the note select signals for) the CDQ1 Test Point Multiplexer. The CDQ1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00411_flds
);


##########################################################################
#                                                                        #
#   R4_CDQ2_TEST_POINT_SELECT_512                                        #
#                                                                        #
##########################################################################

%nl4rtr_01_00412_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7: Nibble Select" ],
   "NIBBLE7_CHIPLET_SEL"          => [   2,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7: Port Select" ],
   "RSVD1"                        => [   3,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   4,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6: Nibble Select" ],
   "NIBBLE6_CHIPLET_SEL"          => [   5,  48,   4, 0x000F000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6: Word Select" ],
   "RSVD2"                        => [   6,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   7,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5: Nibble Select" ],
   "NIBBLE5_CHIPLET_SEL"          => [   8,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "Nibble 5: Word Select" ],
   "RSVD3"                        => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  10,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4: Nibble Select" ],
   "NIBBLE4_CHIPLET_SEL"          => [  11,  32,   4, 0x0000000F00000000, 0x00, 0, 0x0000000000000000, "Nibble 4: Port Select" ],
   "RSVD4"                        => [  12,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  13,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3: Nibble Select" ],
   "NIBBLE3_CHIPLET_SEL"          => [  14,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "Nibble 3: Word Select" ],
   "RSVD5"                        => [  15,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  16,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2: Nibble Select" ],
   "NIBBLE2_CHIPLET_SEL"          => [  17,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "Nibble 2: Word Select" ],
   "RSVD6"                        => [  18,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  19,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1: Nibble Select" ],
   "NIBBLE1_CHIPLET_SEL"          => [  20,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Nibble 1: Word Select" ],
   "RSVD7"                        => [  21,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  22,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0: Nibble Select" ],
   "NIBBLE0_CHIPLET_SEL"          => [  23,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Nibble 0: Word Select" ],
);

%nl4rtr_01_00412_def =
( NAME    => "R4_CDQ2_TEST_POINT_SELECT_512",
  ADDRESS => 0x0000000002002780,
  NOTE    => "The CDQ2_TEST_POINT_SELECT_512 configures (i.e., contains the note select signals for) the CDQ2 Test Point Multiplexer. The CDQ2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00412_flds
);


##########################################################################
#                                                                        #
#   R4_CDQ3_TEST_POINT_SELECT_512                                        #
#                                                                        #
##########################################################################

%nl4rtr_01_00413_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7: Nibble Select" ],
   "NIBBLE7_CHIPLET_SEL"          => [   2,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7: Port Select" ],
   "RSVD1"                        => [   3,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   4,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6: Nibble Select" ],
   "NIBBLE6_CHIPLET_SEL"          => [   5,  48,   4, 0x000F000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6: Word Select" ],
   "RSVD2"                        => [   6,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   7,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5: Nibble Select" ],
   "NIBBLE5_CHIPLET_SEL"          => [   8,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "Nibble 5: Word Select" ],
   "RSVD3"                        => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  10,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4: Nibble Select" ],
   "NIBBLE4_CHIPLET_SEL"          => [  11,  32,   4, 0x0000000F00000000, 0x00, 0, 0x0000000000000000, "Nibble 4: Port Select" ],
   "RSVD4"                        => [  12,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  13,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3: Nibble Select" ],
   "NIBBLE3_CHIPLET_SEL"          => [  14,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "Nibble 3: Word Select" ],
   "RSVD5"                        => [  15,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  16,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2: Nibble Select" ],
   "NIBBLE2_CHIPLET_SEL"          => [  17,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "Nibble 2: Word Select" ],
   "RSVD6"                        => [  18,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  19,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1: Nibble Select" ],
   "NIBBLE1_CHIPLET_SEL"          => [  20,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Nibble 1: Word Select" ],
   "RSVD7"                        => [  21,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  22,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0: Nibble Select" ],
   "NIBBLE0_CHIPLET_SEL"          => [  23,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Nibble 0: Word Select" ],
);

%nl4rtr_01_00413_def =
( NAME    => "R4_CDQ3_TEST_POINT_SELECT_512",
  ADDRESS => 0x0000000002002800,
  NOTE    => "The CDQ3_TEST_POINT_SELECT_512 configures (i.e., contains the note select signals for) the CDQ3 Test Point Multiplexer. The CDQ3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00413_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_TEST_POINT_SELECT_512                                       #
#                                                                        #
##########################################################################

%nl4rtr_01_00414_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7: Nibble Select" ],
   "NIBBLE7_CHIPLET_SEL"          => [   2,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7: Port Select" ],
   "RSVD1"                        => [   3,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   4,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6: Nibble Select" ],
   "NIBBLE6_CHIPLET_SEL"          => [   5,  48,   4, 0x000F000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6: Word Select" ],
   "RSVD2"                        => [   6,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   7,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5: Nibble Select" ],
   "NIBBLE5_CHIPLET_SEL"          => [   8,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "Nibble 5: Word Select" ],
   "RSVD3"                        => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  10,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4: Nibble Select" ],
   "NIBBLE4_CHIPLET_SEL"          => [  11,  32,   4, 0x0000000F00000000, 0x00, 0, 0x0000000000000000, "Nibble 4: Port Select" ],
   "RSVD4"                        => [  12,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  13,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3: Nibble Select" ],
   "NIBBLE3_CHIPLET_SEL"          => [  14,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "Nibble 3: Word Select" ],
   "RSVD5"                        => [  15,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  16,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2: Nibble Select" ],
   "NIBBLE2_CHIPLET_SEL"          => [  17,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "Nibble 2: Word Select" ],
   "RSVD6"                        => [  18,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  19,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1: Nibble Select" ],
   "NIBBLE1_CHIPLET_SEL"          => [  20,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Nibble 1: Word Select" ],
   "RSVD7"                        => [  21,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  22,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0: Nibble Select" ],
   "NIBBLE0_CHIPLET_SEL"          => [  23,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Nibble 0: Word Select" ],
);

%nl4rtr_01_00414_def =
( NAME    => "R4_PORTA_TEST_POINT_SELECT_512",
  ADDRESS => 0x0000000008002700,
  NOTE    => "The PORTA_TEST_POINT_SELECT_512 configures (i.e., contains the note select signals for) the PORTA Test Point Multiplexer. The PO",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00414_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_TEST_POINT_SELECT_512                                       #
#                                                                        #
##########################################################################

%nl4rtr_01_00415_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7: Nibble Select" ],
   "NIBBLE7_CHIPLET_SEL"          => [   2,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7: Port Select" ],
   "RSVD1"                        => [   3,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   4,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6: Nibble Select" ],
   "NIBBLE6_CHIPLET_SEL"          => [   5,  48,   4, 0x000F000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6: Word Select" ],
   "RSVD2"                        => [   6,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   7,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5: Nibble Select" ],
   "NIBBLE5_CHIPLET_SEL"          => [   8,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "Nibble 5: Word Select" ],
   "RSVD3"                        => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  10,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4: Nibble Select" ],
   "NIBBLE4_CHIPLET_SEL"          => [  11,  32,   4, 0x0000000F00000000, 0x00, 0, 0x0000000000000000, "Nibble 4: Port Select" ],
   "RSVD4"                        => [  12,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  13,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3: Nibble Select" ],
   "NIBBLE3_CHIPLET_SEL"          => [  14,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "Nibble 3: Word Select" ],
   "RSVD5"                        => [  15,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  16,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2: Nibble Select" ],
   "NIBBLE2_CHIPLET_SEL"          => [  17,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "Nibble 2: Word Select" ],
   "RSVD6"                        => [  18,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  19,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1: Nibble Select" ],
   "NIBBLE1_CHIPLET_SEL"          => [  20,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Nibble 1: Word Select" ],
   "RSVD7"                        => [  21,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  22,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0: Nibble Select" ],
   "NIBBLE0_CHIPLET_SEL"          => [  23,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Nibble 0: Word Select" ],
);

%nl4rtr_01_00415_def =
( NAME    => "R4_PORTB_TEST_POINT_SELECT_512",
  ADDRESS => 0x0000000009002700,
  NOTE    => "The PORTB_TEST_POINT_SELECT_512 configures (i.e., contains the note select signals for) the PORTB Test Point Multiplexer. The PO",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00415_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_TEST_POINT_SELECT_512                                       #
#                                                                        #
##########################################################################

%nl4rtr_01_00416_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7: Nibble Select" ],
   "NIBBLE7_CHIPLET_SEL"          => [   2,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7: Port Select" ],
   "RSVD1"                        => [   3,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   4,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6: Nibble Select" ],
   "NIBBLE6_CHIPLET_SEL"          => [   5,  48,   4, 0x000F000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6: Word Select" ],
   "RSVD2"                        => [   6,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   7,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5: Nibble Select" ],
   "NIBBLE5_CHIPLET_SEL"          => [   8,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "Nibble 5: Word Select" ],
   "RSVD3"                        => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  10,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4: Nibble Select" ],
   "NIBBLE4_CHIPLET_SEL"          => [  11,  32,   4, 0x0000000F00000000, 0x00, 0, 0x0000000000000000, "Nibble 4: Port Select" ],
   "RSVD4"                        => [  12,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  13,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3: Nibble Select" ],
   "NIBBLE3_CHIPLET_SEL"          => [  14,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "Nibble 3: Word Select" ],
   "RSVD5"                        => [  15,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  16,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2: Nibble Select" ],
   "NIBBLE2_CHIPLET_SEL"          => [  17,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "Nibble 2: Word Select" ],
   "RSVD6"                        => [  18,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  19,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1: Nibble Select" ],
   "NIBBLE1_CHIPLET_SEL"          => [  20,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Nibble 1: Word Select" ],
   "RSVD7"                        => [  21,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  22,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0: Nibble Select" ],
   "NIBBLE0_CHIPLET_SEL"          => [  23,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Nibble 0: Word Select" ],
);

%nl4rtr_01_00416_def =
( NAME    => "R4_PORTC_TEST_POINT_SELECT_512",
  ADDRESS => 0x000000000a002700,
  NOTE    => "The PORTC_TEST_POINT_SELECT_512 configures (i.e., contains the note select signals for) the PORTC Test Point Multiplexer. The PO",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00416_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_TEST_POINT_SELECT_512                                       #
#                                                                        #
##########################################################################

%nl4rtr_01_00417_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7: Nibble Select" ],
   "NIBBLE7_CHIPLET_SEL"          => [   2,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7: Port Select" ],
   "RSVD1"                        => [   3,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   4,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6: Nibble Select" ],
   "NIBBLE6_CHIPLET_SEL"          => [   5,  48,   4, 0x000F000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6: Word Select" ],
   "RSVD2"                        => [   6,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   7,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5: Nibble Select" ],
   "NIBBLE5_CHIPLET_SEL"          => [   8,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "Nibble 5: Word Select" ],
   "RSVD3"                        => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  10,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4: Nibble Select" ],
   "NIBBLE4_CHIPLET_SEL"          => [  11,  32,   4, 0x0000000F00000000, 0x00, 0, 0x0000000000000000, "Nibble 4: Port Select" ],
   "RSVD4"                        => [  12,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  13,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3: Nibble Select" ],
   "NIBBLE3_CHIPLET_SEL"          => [  14,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "Nibble 3: Word Select" ],
   "RSVD5"                        => [  15,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  16,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2: Nibble Select" ],
   "NIBBLE2_CHIPLET_SEL"          => [  17,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "Nibble 2: Word Select" ],
   "RSVD6"                        => [  18,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  19,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1: Nibble Select" ],
   "NIBBLE1_CHIPLET_SEL"          => [  20,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Nibble 1: Word Select" ],
   "RSVD7"                        => [  21,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  22,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0: Nibble Select" ],
   "NIBBLE0_CHIPLET_SEL"          => [  23,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Nibble 0: Word Select" ],
);

%nl4rtr_01_00417_def =
( NAME    => "R4_PORTD_TEST_POINT_SELECT_512",
  ADDRESS => 0x000000000b002700,
  NOTE    => "The PORTD_TEST_POINT_SELECT_512 configures (i.e., contains the note select signals for) the PORTD Test Point Multiplexer. The PO",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00417_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_TEST_POINT_SELECT_512                                       #
#                                                                        #
##########################################################################

%nl4rtr_01_00418_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7: Nibble Select" ],
   "NIBBLE7_CHIPLET_SEL"          => [   2,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7: Port Select" ],
   "RSVD1"                        => [   3,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   4,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6: Nibble Select" ],
   "NIBBLE6_CHIPLET_SEL"          => [   5,  48,   4, 0x000F000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6: Word Select" ],
   "RSVD2"                        => [   6,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   7,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5: Nibble Select" ],
   "NIBBLE5_CHIPLET_SEL"          => [   8,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "Nibble 5: Word Select" ],
   "RSVD3"                        => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  10,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4: Nibble Select" ],
   "NIBBLE4_CHIPLET_SEL"          => [  11,  32,   4, 0x0000000F00000000, 0x00, 0, 0x0000000000000000, "Nibble 4: Port Select" ],
   "RSVD4"                        => [  12,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  13,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3: Nibble Select" ],
   "NIBBLE3_CHIPLET_SEL"          => [  14,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "Nibble 3: Word Select" ],
   "RSVD5"                        => [  15,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  16,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2: Nibble Select" ],
   "NIBBLE2_CHIPLET_SEL"          => [  17,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "Nibble 2: Word Select" ],
   "RSVD6"                        => [  18,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  19,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1: Nibble Select" ],
   "NIBBLE1_CHIPLET_SEL"          => [  20,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Nibble 1: Word Select" ],
   "RSVD7"                        => [  21,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  22,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0: Nibble Select" ],
   "NIBBLE0_CHIPLET_SEL"          => [  23,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Nibble 0: Word Select" ],
);

%nl4rtr_01_00418_def =
( NAME    => "R4_PORTE_TEST_POINT_SELECT_512",
  ADDRESS => 0x000000000c002700,
  NOTE    => "The PORTE_TEST_POINT_SELECT_512 configures (i.e., contains the note select signals for) the PORTE Test Point Multiplexer. The PO",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00418_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_TEST_POINT_SELECT_512                                       #
#                                                                        #
##########################################################################

%nl4rtr_01_00419_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7: Nibble Select" ],
   "NIBBLE7_CHIPLET_SEL"          => [   2,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7: Port Select" ],
   "RSVD1"                        => [   3,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   4,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6: Nibble Select" ],
   "NIBBLE6_CHIPLET_SEL"          => [   5,  48,   4, 0x000F000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6: Word Select" ],
   "RSVD2"                        => [   6,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   7,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5: Nibble Select" ],
   "NIBBLE5_CHIPLET_SEL"          => [   8,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "Nibble 5: Word Select" ],
   "RSVD3"                        => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  10,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4: Nibble Select" ],
   "NIBBLE4_CHIPLET_SEL"          => [  11,  32,   4, 0x0000000F00000000, 0x00, 0, 0x0000000000000000, "Nibble 4: Port Select" ],
   "RSVD4"                        => [  12,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  13,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3: Nibble Select" ],
   "NIBBLE3_CHIPLET_SEL"          => [  14,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "Nibble 3: Word Select" ],
   "RSVD5"                        => [  15,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  16,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2: Nibble Select" ],
   "NIBBLE2_CHIPLET_SEL"          => [  17,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "Nibble 2: Word Select" ],
   "RSVD6"                        => [  18,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  19,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1: Nibble Select" ],
   "NIBBLE1_CHIPLET_SEL"          => [  20,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Nibble 1: Word Select" ],
   "RSVD7"                        => [  21,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  22,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0: Nibble Select" ],
   "NIBBLE0_CHIPLET_SEL"          => [  23,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Nibble 0: Word Select" ],
);

%nl4rtr_01_00419_def =
( NAME    => "R4_PORTF_TEST_POINT_SELECT_512",
  ADDRESS => 0x000000000d002700,
  NOTE    => "The PORTF_TEST_POINT_SELECT_512 configures (i.e., contains the note select signals for) the PORTF Test Point Multiplexer. The PO",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00419_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_TEST_POINT_SELECT_512                                       #
#                                                                        #
##########################################################################

%nl4rtr_01_00420_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7: Nibble Select" ],
   "NIBBLE7_CHIPLET_SEL"          => [   2,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7: Port Select" ],
   "RSVD1"                        => [   3,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   4,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6: Nibble Select" ],
   "NIBBLE6_CHIPLET_SEL"          => [   5,  48,   4, 0x000F000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6: Word Select" ],
   "RSVD2"                        => [   6,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   7,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5: Nibble Select" ],
   "NIBBLE5_CHIPLET_SEL"          => [   8,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "Nibble 5: Word Select" ],
   "RSVD3"                        => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  10,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4: Nibble Select" ],
   "NIBBLE4_CHIPLET_SEL"          => [  11,  32,   4, 0x0000000F00000000, 0x00, 0, 0x0000000000000000, "Nibble 4: Port Select" ],
   "RSVD4"                        => [  12,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  13,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3: Nibble Select" ],
   "NIBBLE3_CHIPLET_SEL"          => [  14,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "Nibble 3: Word Select" ],
   "RSVD5"                        => [  15,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  16,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2: Nibble Select" ],
   "NIBBLE2_CHIPLET_SEL"          => [  17,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "Nibble 2: Word Select" ],
   "RSVD6"                        => [  18,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  19,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1: Nibble Select" ],
   "NIBBLE1_CHIPLET_SEL"          => [  20,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Nibble 1: Word Select" ],
   "RSVD7"                        => [  21,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  22,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0: Nibble Select" ],
   "NIBBLE0_CHIPLET_SEL"          => [  23,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Nibble 0: Word Select" ],
);

%nl4rtr_01_00420_def =
( NAME    => "R4_PORTG_TEST_POINT_SELECT_512",
  ADDRESS => 0x000000000e002700,
  NOTE    => "The PORTG_TEST_POINT_SELECT_512 configures (i.e., contains the note select signals for) the PORTG Test Point Multiplexer. The PO",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00420_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_TEST_POINT_SELECT_512                                       #
#                                                                        #
##########################################################################

%nl4rtr_01_00421_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7: Nibble Select" ],
   "NIBBLE7_CHIPLET_SEL"          => [   2,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7: Port Select" ],
   "RSVD1"                        => [   3,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   4,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6: Nibble Select" ],
   "NIBBLE6_CHIPLET_SEL"          => [   5,  48,   4, 0x000F000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6: Word Select" ],
   "RSVD2"                        => [   6,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   7,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5: Nibble Select" ],
   "NIBBLE5_CHIPLET_SEL"          => [   8,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "Nibble 5: Word Select" ],
   "RSVD3"                        => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  10,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4: Nibble Select" ],
   "NIBBLE4_CHIPLET_SEL"          => [  11,  32,   4, 0x0000000F00000000, 0x00, 0, 0x0000000000000000, "Nibble 4: Port Select" ],
   "RSVD4"                        => [  12,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  13,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3: Nibble Select" ],
   "NIBBLE3_CHIPLET_SEL"          => [  14,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "Nibble 3: Word Select" ],
   "RSVD5"                        => [  15,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  16,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2: Nibble Select" ],
   "NIBBLE2_CHIPLET_SEL"          => [  17,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "Nibble 2: Word Select" ],
   "RSVD6"                        => [  18,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  19,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1: Nibble Select" ],
   "NIBBLE1_CHIPLET_SEL"          => [  20,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Nibble 1: Word Select" ],
   "RSVD7"                        => [  21,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  22,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0: Nibble Select" ],
   "NIBBLE0_CHIPLET_SEL"          => [  23,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Nibble 0: Word Select" ],
);

%nl4rtr_01_00421_def =
( NAME    => "R4_PORTH_TEST_POINT_SELECT_512",
  ADDRESS => 0x000000000f002700,
  NOTE    => "The PORTH_TEST_POINT_SELECT_512 configures (i.e., contains the note select signals for) the PORTH Test Point Multiplexer. The PO",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00421_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CONFIG                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00422_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  59,   5, 0xF800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIAG"                         => [   1,  45,  14, 0x07FFE00000000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN"                           => [   2,   8,  37, 0x00001FFFFFFFFF00, 0x00, 1, 0x0000000000000000, "Enable Individual Counter" ],
   "DIR"                          => [   3,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Input/output selection for Command buckets" ],
);

%nl4rtr_01_00422_def =
( NAME    => "R4_PORTA_PERF_CONFIG",
  ADDRESS => 0x0000000008007000,
  NOTE    => "Port Performance Counter Configuration",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00422_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CMD_LO                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00423_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CNT7"                         => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 7" ],
   "CNT6"                         => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 6" ],
   "CNT5"                         => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 5" ],
   "CNT4"                         => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 4" ],
   "CNT3"                         => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 3" ],
   "CNT2"                         => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 2" ],
   "CNT1"                         => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 1" ],
   "CNT0"                         => [   7,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 0" ],
);

%nl4rtr_01_00423_def =
( NAME    => "R4_PORTA_PERF_CMD_LO",
  ADDRESS => 0x0000000008007008,
  NOTE    => "The first 8 performance counters are dedicated to command types. note This register is one of two configuration registers that s",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00423_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CMD_UP                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00424_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CNT7"                         => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 7" ],
   "CNT6"                         => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 6" ],
   "CNT5"                         => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 5" ],
   "CNT4"                         => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 4" ],
   "CNT3"                         => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 3" ],
   "CNT2"                         => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 2" ],
   "CNT1"                         => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 1" ],
   "CNT0"                         => [   7,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 0" ],
);

%nl4rtr_01_00424_def =
( NAME    => "R4_PORTA_PERF_CMD_UP",
  ADDRESS => 0x0000000008007010,
  NOTE    => "The first 8 performance counters are dedicated to command types. note This register is one of two configuration registers that s",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00424_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CNTR0                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00425_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 0" ],
);

%nl4rtr_01_00425_def =
( NAME    => "R4_PORTA_PERF_CNTR0",
  ADDRESS => 0x0000000008007018,
  NOTE    => "Performance Event Counter 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00425_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CNTR1                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00426_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 1" ],
);

%nl4rtr_01_00426_def =
( NAME    => "R4_PORTA_PERF_CNTR1",
  ADDRESS => 0x0000000008007020,
  NOTE    => "Performance Event Counter 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00426_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CNTR2                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00427_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 2" ],
);

%nl4rtr_01_00427_def =
( NAME    => "R4_PORTA_PERF_CNTR2",
  ADDRESS => 0x0000000008007028,
  NOTE    => "Performance Event Counter 2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00427_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CNTR3                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00428_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 3" ],
);

%nl4rtr_01_00428_def =
( NAME    => "R4_PORTA_PERF_CNTR3",
  ADDRESS => 0x0000000008007030,
  NOTE    => "Performance Event Counter 3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00428_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CNTR4                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00429_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 4" ],
);

%nl4rtr_01_00429_def =
( NAME    => "R4_PORTA_PERF_CNTR4",
  ADDRESS => 0x0000000008007038,
  NOTE    => "Performance Event Counter 4",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00429_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CNTR5                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00430_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 5" ],
);

%nl4rtr_01_00430_def =
( NAME    => "R4_PORTA_PERF_CNTR5",
  ADDRESS => 0x0000000008007040,
  NOTE    => "Performance Event Counter 5",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00430_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CNTR6                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00431_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 6" ],
);

%nl4rtr_01_00431_def =
( NAME    => "R4_PORTA_PERF_CNTR6",
  ADDRESS => 0x0000000008007048,
  NOTE    => "Performance Event Counter 6",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00431_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CNTR7                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00432_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 7" ],
);

%nl4rtr_01_00432_def =
( NAME    => "R4_PORTA_PERF_CNTR7",
  ADDRESS => 0x0000000008007050,
  NOTE    => "Performance Event Counter 7",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00432_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CNTR8                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00433_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 8" ],
);

%nl4rtr_01_00433_def =
( NAME    => "R4_PORTA_PERF_CNTR8",
  ADDRESS => 0x0000000008007058,
  NOTE    => "Performance Event Counter 8",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00433_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CNTR9                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00434_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 9" ],
);

%nl4rtr_01_00434_def =
( NAME    => "R4_PORTA_PERF_CNTR9",
  ADDRESS => 0x0000000008007060,
  NOTE    => "Performance Event Counter 9",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00434_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CNTR10                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00435_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 10" ],
);

%nl4rtr_01_00435_def =
( NAME    => "R4_PORTA_PERF_CNTR10",
  ADDRESS => 0x0000000008007068,
  NOTE    => "Performance Event Counter 10",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00435_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CNTR11                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00436_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 11" ],
);

%nl4rtr_01_00436_def =
( NAME    => "R4_PORTA_PERF_CNTR11",
  ADDRESS => 0x0000000008007070,
  NOTE    => "Performance Event Counter 11",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00436_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CNTR12                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00437_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 12" ],
);

%nl4rtr_01_00437_def =
( NAME    => "R4_PORTA_PERF_CNTR12",
  ADDRESS => 0x0000000008007078,
  NOTE    => "Performance Event Counter 12",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00437_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CNTR13                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00438_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 13" ],
);

%nl4rtr_01_00438_def =
( NAME    => "R4_PORTA_PERF_CNTR13",
  ADDRESS => 0x0000000008007080,
  NOTE    => "Performance Event Counter 13",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00438_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CNTR14                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00439_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 14" ],
);

%nl4rtr_01_00439_def =
( NAME    => "R4_PORTA_PERF_CNTR14",
  ADDRESS => 0x0000000008007088,
  NOTE    => "Performance Event Counter 14",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00439_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CNTR15                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00440_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 15" ],
);

%nl4rtr_01_00440_def =
( NAME    => "R4_PORTA_PERF_CNTR15",
  ADDRESS => 0x0000000008007090,
  NOTE    => "Performance Event Counter 15",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00440_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CNTR16                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00441_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 16" ],
);

%nl4rtr_01_00441_def =
( NAME    => "R4_PORTA_PERF_CNTR16",
  ADDRESS => 0x0000000008007098,
  NOTE    => "Performance Event Counter 16",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00441_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CNTR17                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00442_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 17" ],
);

%nl4rtr_01_00442_def =
( NAME    => "R4_PORTA_PERF_CNTR17",
  ADDRESS => 0x00000000080070a0,
  NOTE    => "Performance Event Counter 17",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00442_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CNTR18                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00443_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 18" ],
);

%nl4rtr_01_00443_def =
( NAME    => "R4_PORTA_PERF_CNTR18",
  ADDRESS => 0x00000000080070a8,
  NOTE    => "Performance Event Counter 18",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00443_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CNTR19                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00444_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 19" ],
);

%nl4rtr_01_00444_def =
( NAME    => "R4_PORTA_PERF_CNTR19",
  ADDRESS => 0x00000000080070b0,
  NOTE    => "Performance Event Counter 19",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00444_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CNTR20                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00445_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 20" ],
);

%nl4rtr_01_00445_def =
( NAME    => "R4_PORTA_PERF_CNTR20",
  ADDRESS => 0x00000000080070b8,
  NOTE    => "Performance Event Counter 20",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00445_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CNTR21                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00446_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 21" ],
);

%nl4rtr_01_00446_def =
( NAME    => "R4_PORTA_PERF_CNTR21",
  ADDRESS => 0x00000000080070c0,
  NOTE    => "Performance Event Counter 21",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00446_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CNTR22                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00447_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 22" ],
);

%nl4rtr_01_00447_def =
( NAME    => "R4_PORTA_PERF_CNTR22",
  ADDRESS => 0x00000000080070c8,
  NOTE    => "Performance Event Counter 22",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00447_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CNTR23                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00448_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 23" ],
);

%nl4rtr_01_00448_def =
( NAME    => "R4_PORTA_PERF_CNTR23",
  ADDRESS => 0x00000000080070d0,
  NOTE    => "Performance Event Counter 23",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00448_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CNTR24                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00449_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 24" ],
);

%nl4rtr_01_00449_def =
( NAME    => "R4_PORTA_PERF_CNTR24",
  ADDRESS => 0x00000000080070d8,
  NOTE    => "Performance Event Counter 24",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00449_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CNTR25                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00450_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 25" ],
);

%nl4rtr_01_00450_def =
( NAME    => "R4_PORTA_PERF_CNTR25",
  ADDRESS => 0x00000000080070e0,
  NOTE    => "Performance Event Counter 25",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00450_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CNTR26                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00451_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 26" ],
);

%nl4rtr_01_00451_def =
( NAME    => "R4_PORTA_PERF_CNTR26",
  ADDRESS => 0x00000000080070e8,
  NOTE    => "Performance Event Counter 26",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00451_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CNTR27                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00452_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 27" ],
);

%nl4rtr_01_00452_def =
( NAME    => "R4_PORTA_PERF_CNTR27",
  ADDRESS => 0x00000000080070f0,
  NOTE    => "Performance Event Counter 27",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00452_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CNTR28                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00453_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 28" ],
);

%nl4rtr_01_00453_def =
( NAME    => "R4_PORTA_PERF_CNTR28",
  ADDRESS => 0x00000000080070f8,
  NOTE    => "Performance Event Counter 28",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00453_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CNTR29                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00454_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 29" ],
);

%nl4rtr_01_00454_def =
( NAME    => "R4_PORTA_PERF_CNTR29",
  ADDRESS => 0x0000000008007100,
  NOTE    => "Performance Event Counter 29",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00454_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CNTR30                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00455_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 30" ],
);

%nl4rtr_01_00455_def =
( NAME    => "R4_PORTA_PERF_CNTR30",
  ADDRESS => 0x0000000008007108,
  NOTE    => "Performance Event Counter 30",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00455_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CNTR31                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00456_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 31" ],
);

%nl4rtr_01_00456_def =
( NAME    => "R4_PORTA_PERF_CNTR31",
  ADDRESS => 0x0000000008007110,
  NOTE    => "Performance Event Counter 31",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00456_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CNTR32                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00457_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 32" ],
);

%nl4rtr_01_00457_def =
( NAME    => "R4_PORTA_PERF_CNTR32",
  ADDRESS => 0x0000000008007118,
  NOTE    => "Performance Event Counter 32",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00457_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CNTR33                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00458_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 33" ],
);

%nl4rtr_01_00458_def =
( NAME    => "R4_PORTA_PERF_CNTR33",
  ADDRESS => 0x0000000008007120,
  NOTE    => "Performance Event Counter 33",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00458_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CNTR34                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00459_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 34" ],
);

%nl4rtr_01_00459_def =
( NAME    => "R4_PORTA_PERF_CNTR34",
  ADDRESS => 0x0000000008007128,
  NOTE    => "Performance Event Counter 34",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00459_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CNTR35                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00460_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 35" ],
);

%nl4rtr_01_00460_def =
( NAME    => "R4_PORTA_PERF_CNTR35",
  ADDRESS => 0x0000000008007130,
  NOTE    => "Performance Event Counter 35",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00460_flds
);


##########################################################################
#                                                                        #
#   R4_PORTA_PERF_CNTR36                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00461_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 36" ],
);

%nl4rtr_01_00461_def =
( NAME    => "R4_PORTA_PERF_CNTR36",
  ADDRESS => 0x0000000008007138,
  NOTE    => "Performance Event Counter 36",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00461_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CONFIG                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00462_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  59,   5, 0xF800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIAG"                         => [   1,  45,  14, 0x07FFE00000000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN"                           => [   2,   8,  37, 0x00001FFFFFFFFF00, 0x00, 1, 0x0000000000000000, "Enable Individual Counter" ],
   "DIR"                          => [   3,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Input/output selection for Command buckets" ],
);

%nl4rtr_01_00462_def =
( NAME    => "R4_PORTB_PERF_CONFIG",
  ADDRESS => 0x0000000009007000,
  NOTE    => "Port Performance Counter Configuration",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00462_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CMD_LO                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00463_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CNT7"                         => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 7" ],
   "CNT6"                         => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 6" ],
   "CNT5"                         => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 5" ],
   "CNT4"                         => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 4" ],
   "CNT3"                         => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 3" ],
   "CNT2"                         => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 2" ],
   "CNT1"                         => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 1" ],
   "CNT0"                         => [   7,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 0" ],
);

%nl4rtr_01_00463_def =
( NAME    => "R4_PORTB_PERF_CMD_LO",
  ADDRESS => 0x0000000009007008,
  NOTE    => "The first 8 performance counters are dedicated to command types. note This register is one of two configuration registers that s",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00463_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CMD_UP                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00464_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CNT7"                         => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 7" ],
   "CNT6"                         => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 6" ],
   "CNT5"                         => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 5" ],
   "CNT4"                         => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 4" ],
   "CNT3"                         => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 3" ],
   "CNT2"                         => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 2" ],
   "CNT1"                         => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 1" ],
   "CNT0"                         => [   7,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 0" ],
);

%nl4rtr_01_00464_def =
( NAME    => "R4_PORTB_PERF_CMD_UP",
  ADDRESS => 0x0000000009007010,
  NOTE    => "The first 8 performance counters are dedicated to command types. note This register is one of two configuration registers that s",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00464_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CNTR0                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00465_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 0" ],
);

%nl4rtr_01_00465_def =
( NAME    => "R4_PORTB_PERF_CNTR0",
  ADDRESS => 0x0000000009007018,
  NOTE    => "Performance Event Counter 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00465_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CNTR1                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00466_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 1" ],
);

%nl4rtr_01_00466_def =
( NAME    => "R4_PORTB_PERF_CNTR1",
  ADDRESS => 0x0000000009007020,
  NOTE    => "Performance Event Counter 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00466_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CNTR2                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00467_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 2" ],
);

%nl4rtr_01_00467_def =
( NAME    => "R4_PORTB_PERF_CNTR2",
  ADDRESS => 0x0000000009007028,
  NOTE    => "Performance Event Counter 2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00467_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CNTR3                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00468_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 3" ],
);

%nl4rtr_01_00468_def =
( NAME    => "R4_PORTB_PERF_CNTR3",
  ADDRESS => 0x0000000009007030,
  NOTE    => "Performance Event Counter 3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00468_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CNTR4                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00469_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 4" ],
);

%nl4rtr_01_00469_def =
( NAME    => "R4_PORTB_PERF_CNTR4",
  ADDRESS => 0x0000000009007038,
  NOTE    => "Performance Event Counter 4",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00469_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CNTR5                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00470_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 5" ],
);

%nl4rtr_01_00470_def =
( NAME    => "R4_PORTB_PERF_CNTR5",
  ADDRESS => 0x0000000009007040,
  NOTE    => "Performance Event Counter 5",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00470_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CNTR6                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00471_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 6" ],
);

%nl4rtr_01_00471_def =
( NAME    => "R4_PORTB_PERF_CNTR6",
  ADDRESS => 0x0000000009007048,
  NOTE    => "Performance Event Counter 6",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00471_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CNTR7                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00472_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 7" ],
);

%nl4rtr_01_00472_def =
( NAME    => "R4_PORTB_PERF_CNTR7",
  ADDRESS => 0x0000000009007050,
  NOTE    => "Performance Event Counter 7",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00472_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CNTR8                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00473_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 8" ],
);

%nl4rtr_01_00473_def =
( NAME    => "R4_PORTB_PERF_CNTR8",
  ADDRESS => 0x0000000009007058,
  NOTE    => "Performance Event Counter 8",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00473_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CNTR9                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00474_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 9" ],
);

%nl4rtr_01_00474_def =
( NAME    => "R4_PORTB_PERF_CNTR9",
  ADDRESS => 0x0000000009007060,
  NOTE    => "Performance Event Counter 9",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00474_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CNTR10                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00475_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 10" ],
);

%nl4rtr_01_00475_def =
( NAME    => "R4_PORTB_PERF_CNTR10",
  ADDRESS => 0x0000000009007068,
  NOTE    => "Performance Event Counter 10",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00475_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CNTR11                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00476_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 11" ],
);

%nl4rtr_01_00476_def =
( NAME    => "R4_PORTB_PERF_CNTR11",
  ADDRESS => 0x0000000009007070,
  NOTE    => "Performance Event Counter 11",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00476_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CNTR12                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00477_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 12" ],
);

%nl4rtr_01_00477_def =
( NAME    => "R4_PORTB_PERF_CNTR12",
  ADDRESS => 0x0000000009007078,
  NOTE    => "Performance Event Counter 12",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00477_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CNTR13                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00478_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 13" ],
);

%nl4rtr_01_00478_def =
( NAME    => "R4_PORTB_PERF_CNTR13",
  ADDRESS => 0x0000000009007080,
  NOTE    => "Performance Event Counter 13",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00478_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CNTR14                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00479_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 14" ],
);

%nl4rtr_01_00479_def =
( NAME    => "R4_PORTB_PERF_CNTR14",
  ADDRESS => 0x0000000009007088,
  NOTE    => "Performance Event Counter 14",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00479_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CNTR15                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00480_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 15" ],
);

%nl4rtr_01_00480_def =
( NAME    => "R4_PORTB_PERF_CNTR15",
  ADDRESS => 0x0000000009007090,
  NOTE    => "Performance Event Counter 15",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00480_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CNTR16                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00481_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 16" ],
);

%nl4rtr_01_00481_def =
( NAME    => "R4_PORTB_PERF_CNTR16",
  ADDRESS => 0x0000000009007098,
  NOTE    => "Performance Event Counter 16",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00481_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CNTR17                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00482_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 17" ],
);

%nl4rtr_01_00482_def =
( NAME    => "R4_PORTB_PERF_CNTR17",
  ADDRESS => 0x00000000090070a0,
  NOTE    => "Performance Event Counter 17",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00482_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CNTR18                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00483_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 18" ],
);

%nl4rtr_01_00483_def =
( NAME    => "R4_PORTB_PERF_CNTR18",
  ADDRESS => 0x00000000090070a8,
  NOTE    => "Performance Event Counter 18",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00483_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CNTR19                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00484_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 19" ],
);

%nl4rtr_01_00484_def =
( NAME    => "R4_PORTB_PERF_CNTR19",
  ADDRESS => 0x00000000090070b0,
  NOTE    => "Performance Event Counter 19",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00484_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CNTR20                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00485_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 20" ],
);

%nl4rtr_01_00485_def =
( NAME    => "R4_PORTB_PERF_CNTR20",
  ADDRESS => 0x00000000090070b8,
  NOTE    => "Performance Event Counter 20",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00485_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CNTR21                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00486_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 21" ],
);

%nl4rtr_01_00486_def =
( NAME    => "R4_PORTB_PERF_CNTR21",
  ADDRESS => 0x00000000090070c0,
  NOTE    => "Performance Event Counter 21",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00486_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CNTR22                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00487_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 22" ],
);

%nl4rtr_01_00487_def =
( NAME    => "R4_PORTB_PERF_CNTR22",
  ADDRESS => 0x00000000090070c8,
  NOTE    => "Performance Event Counter 22",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00487_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CNTR23                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00488_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 23" ],
);

%nl4rtr_01_00488_def =
( NAME    => "R4_PORTB_PERF_CNTR23",
  ADDRESS => 0x00000000090070d0,
  NOTE    => "Performance Event Counter 23",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00488_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CNTR24                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00489_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 24" ],
);

%nl4rtr_01_00489_def =
( NAME    => "R4_PORTB_PERF_CNTR24",
  ADDRESS => 0x00000000090070d8,
  NOTE    => "Performance Event Counter 24",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00489_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CNTR25                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00490_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 25" ],
);

%nl4rtr_01_00490_def =
( NAME    => "R4_PORTB_PERF_CNTR25",
  ADDRESS => 0x00000000090070e0,
  NOTE    => "Performance Event Counter 25",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00490_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CNTR26                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00491_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 26" ],
);

%nl4rtr_01_00491_def =
( NAME    => "R4_PORTB_PERF_CNTR26",
  ADDRESS => 0x00000000090070e8,
  NOTE    => "Performance Event Counter 26",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00491_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CNTR27                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00492_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 27" ],
);

%nl4rtr_01_00492_def =
( NAME    => "R4_PORTB_PERF_CNTR27",
  ADDRESS => 0x00000000090070f0,
  NOTE    => "Performance Event Counter 27",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00492_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CNTR28                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00493_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 28" ],
);

%nl4rtr_01_00493_def =
( NAME    => "R4_PORTB_PERF_CNTR28",
  ADDRESS => 0x00000000090070f8,
  NOTE    => "Performance Event Counter 28",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00493_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CNTR29                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00494_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 29" ],
);

%nl4rtr_01_00494_def =
( NAME    => "R4_PORTB_PERF_CNTR29",
  ADDRESS => 0x0000000009007100,
  NOTE    => "Performance Event Counter 29",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00494_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CNTR30                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00495_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 30" ],
);

%nl4rtr_01_00495_def =
( NAME    => "R4_PORTB_PERF_CNTR30",
  ADDRESS => 0x0000000009007108,
  NOTE    => "Performance Event Counter 30",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00495_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CNTR31                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00496_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 31" ],
);

%nl4rtr_01_00496_def =
( NAME    => "R4_PORTB_PERF_CNTR31",
  ADDRESS => 0x0000000009007110,
  NOTE    => "Performance Event Counter 31",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00496_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CNTR32                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00497_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 32" ],
);

%nl4rtr_01_00497_def =
( NAME    => "R4_PORTB_PERF_CNTR32",
  ADDRESS => 0x0000000009007118,
  NOTE    => "Performance Event Counter 32",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00497_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CNTR33                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00498_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 33" ],
);

%nl4rtr_01_00498_def =
( NAME    => "R4_PORTB_PERF_CNTR33",
  ADDRESS => 0x0000000009007120,
  NOTE    => "Performance Event Counter 33",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00498_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CNTR34                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00499_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 34" ],
);

%nl4rtr_01_00499_def =
( NAME    => "R4_PORTB_PERF_CNTR34",
  ADDRESS => 0x0000000009007128,
  NOTE    => "Performance Event Counter 34",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00499_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CNTR35                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00500_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 35" ],
);

%nl4rtr_01_00500_def =
( NAME    => "R4_PORTB_PERF_CNTR35",
  ADDRESS => 0x0000000009007130,
  NOTE    => "Performance Event Counter 35",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00500_flds
);


##########################################################################
#                                                                        #
#   R4_PORTB_PERF_CNTR36                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00501_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 36" ],
);

%nl4rtr_01_00501_def =
( NAME    => "R4_PORTB_PERF_CNTR36",
  ADDRESS => 0x0000000009007138,
  NOTE    => "Performance Event Counter 36",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00501_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CONFIG                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00502_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  59,   5, 0xF800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIAG"                         => [   1,  45,  14, 0x07FFE00000000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN"                           => [   2,   8,  37, 0x00001FFFFFFFFF00, 0x00, 1, 0x0000000000000000, "Enable Individual Counter" ],
   "DIR"                          => [   3,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Input/output selection for Command buckets" ],
);

%nl4rtr_01_00502_def =
( NAME    => "R4_PORTC_PERF_CONFIG",
  ADDRESS => 0x000000000a007000,
  NOTE    => "Port Performance Counter Configuration",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00502_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CMD_LO                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00503_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CNT7"                         => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 7" ],
   "CNT6"                         => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 6" ],
   "CNT5"                         => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 5" ],
   "CNT4"                         => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 4" ],
   "CNT3"                         => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 3" ],
   "CNT2"                         => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 2" ],
   "CNT1"                         => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 1" ],
   "CNT0"                         => [   7,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 0" ],
);

%nl4rtr_01_00503_def =
( NAME    => "R4_PORTC_PERF_CMD_LO",
  ADDRESS => 0x000000000a007008,
  NOTE    => "The first 8 performance counters are dedicated to command types. note This register is one of two configuration registers that s",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00503_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CMD_UP                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00504_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CNT7"                         => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 7" ],
   "CNT6"                         => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 6" ],
   "CNT5"                         => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 5" ],
   "CNT4"                         => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 4" ],
   "CNT3"                         => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 3" ],
   "CNT2"                         => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 2" ],
   "CNT1"                         => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 1" ],
   "CNT0"                         => [   7,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 0" ],
);

%nl4rtr_01_00504_def =
( NAME    => "R4_PORTC_PERF_CMD_UP",
  ADDRESS => 0x000000000a007010,
  NOTE    => "The first 8 performance counters are dedicated to command types. note This register is one of two configuration registers that s",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00504_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CNTR0                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00505_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 0" ],
);

%nl4rtr_01_00505_def =
( NAME    => "R4_PORTC_PERF_CNTR0",
  ADDRESS => 0x000000000a007018,
  NOTE    => "Performance Event Counter 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00505_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CNTR1                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00506_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 1" ],
);

%nl4rtr_01_00506_def =
( NAME    => "R4_PORTC_PERF_CNTR1",
  ADDRESS => 0x000000000a007020,
  NOTE    => "Performance Event Counter 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00506_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CNTR2                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00507_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 2" ],
);

%nl4rtr_01_00507_def =
( NAME    => "R4_PORTC_PERF_CNTR2",
  ADDRESS => 0x000000000a007028,
  NOTE    => "Performance Event Counter 2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00507_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CNTR3                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00508_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 3" ],
);

%nl4rtr_01_00508_def =
( NAME    => "R4_PORTC_PERF_CNTR3",
  ADDRESS => 0x000000000a007030,
  NOTE    => "Performance Event Counter 3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00508_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CNTR4                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00509_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 4" ],
);

%nl4rtr_01_00509_def =
( NAME    => "R4_PORTC_PERF_CNTR4",
  ADDRESS => 0x000000000a007038,
  NOTE    => "Performance Event Counter 4",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00509_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CNTR5                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00510_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 5" ],
);

%nl4rtr_01_00510_def =
( NAME    => "R4_PORTC_PERF_CNTR5",
  ADDRESS => 0x000000000a007040,
  NOTE    => "Performance Event Counter 5",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00510_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CNTR6                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00511_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 6" ],
);

%nl4rtr_01_00511_def =
( NAME    => "R4_PORTC_PERF_CNTR6",
  ADDRESS => 0x000000000a007048,
  NOTE    => "Performance Event Counter 6",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00511_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CNTR7                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00512_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 7" ],
);

%nl4rtr_01_00512_def =
( NAME    => "R4_PORTC_PERF_CNTR7",
  ADDRESS => 0x000000000a007050,
  NOTE    => "Performance Event Counter 7",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00512_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CNTR8                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00513_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 8" ],
);

%nl4rtr_01_00513_def =
( NAME    => "R4_PORTC_PERF_CNTR8",
  ADDRESS => 0x000000000a007058,
  NOTE    => "Performance Event Counter 8",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00513_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CNTR9                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00514_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 9" ],
);

%nl4rtr_01_00514_def =
( NAME    => "R4_PORTC_PERF_CNTR9",
  ADDRESS => 0x000000000a007060,
  NOTE    => "Performance Event Counter 9",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00514_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CNTR10                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00515_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 10" ],
);

%nl4rtr_01_00515_def =
( NAME    => "R4_PORTC_PERF_CNTR10",
  ADDRESS => 0x000000000a007068,
  NOTE    => "Performance Event Counter 10",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00515_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CNTR11                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00516_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 11" ],
);

%nl4rtr_01_00516_def =
( NAME    => "R4_PORTC_PERF_CNTR11",
  ADDRESS => 0x000000000a007070,
  NOTE    => "Performance Event Counter 11",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00516_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CNTR12                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00517_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 12" ],
);

%nl4rtr_01_00517_def =
( NAME    => "R4_PORTC_PERF_CNTR12",
  ADDRESS => 0x000000000a007078,
  NOTE    => "Performance Event Counter 12",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00517_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CNTR13                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00518_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 13" ],
);

%nl4rtr_01_00518_def =
( NAME    => "R4_PORTC_PERF_CNTR13",
  ADDRESS => 0x000000000a007080,
  NOTE    => "Performance Event Counter 13",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00518_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CNTR14                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00519_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 14" ],
);

%nl4rtr_01_00519_def =
( NAME    => "R4_PORTC_PERF_CNTR14",
  ADDRESS => 0x000000000a007088,
  NOTE    => "Performance Event Counter 14",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00519_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CNTR15                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00520_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 15" ],
);

%nl4rtr_01_00520_def =
( NAME    => "R4_PORTC_PERF_CNTR15",
  ADDRESS => 0x000000000a007090,
  NOTE    => "Performance Event Counter 15",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00520_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CNTR16                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00521_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 16" ],
);

%nl4rtr_01_00521_def =
( NAME    => "R4_PORTC_PERF_CNTR16",
  ADDRESS => 0x000000000a007098,
  NOTE    => "Performance Event Counter 16",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00521_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CNTR17                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00522_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 17" ],
);

%nl4rtr_01_00522_def =
( NAME    => "R4_PORTC_PERF_CNTR17",
  ADDRESS => 0x000000000a0070a0,
  NOTE    => "Performance Event Counter 17",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00522_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CNTR18                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00523_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 18" ],
);

%nl4rtr_01_00523_def =
( NAME    => "R4_PORTC_PERF_CNTR18",
  ADDRESS => 0x000000000a0070a8,
  NOTE    => "Performance Event Counter 18",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00523_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CNTR19                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00524_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 19" ],
);

%nl4rtr_01_00524_def =
( NAME    => "R4_PORTC_PERF_CNTR19",
  ADDRESS => 0x000000000a0070b0,
  NOTE    => "Performance Event Counter 19",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00524_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CNTR20                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00525_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 20" ],
);

%nl4rtr_01_00525_def =
( NAME    => "R4_PORTC_PERF_CNTR20",
  ADDRESS => 0x000000000a0070b8,
  NOTE    => "Performance Event Counter 20",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00525_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CNTR21                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00526_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 21" ],
);

%nl4rtr_01_00526_def =
( NAME    => "R4_PORTC_PERF_CNTR21",
  ADDRESS => 0x000000000a0070c0,
  NOTE    => "Performance Event Counter 21",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00526_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CNTR22                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00527_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 22" ],
);

%nl4rtr_01_00527_def =
( NAME    => "R4_PORTC_PERF_CNTR22",
  ADDRESS => 0x000000000a0070c8,
  NOTE    => "Performance Event Counter 22",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00527_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CNTR23                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00528_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 23" ],
);

%nl4rtr_01_00528_def =
( NAME    => "R4_PORTC_PERF_CNTR23",
  ADDRESS => 0x000000000a0070d0,
  NOTE    => "Performance Event Counter 23",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00528_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CNTR24                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00529_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 24" ],
);

%nl4rtr_01_00529_def =
( NAME    => "R4_PORTC_PERF_CNTR24",
  ADDRESS => 0x000000000a0070d8,
  NOTE    => "Performance Event Counter 24",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00529_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CNTR25                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00530_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 25" ],
);

%nl4rtr_01_00530_def =
( NAME    => "R4_PORTC_PERF_CNTR25",
  ADDRESS => 0x000000000a0070e0,
  NOTE    => "Performance Event Counter 25",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00530_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CNTR26                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00531_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 26" ],
);

%nl4rtr_01_00531_def =
( NAME    => "R4_PORTC_PERF_CNTR26",
  ADDRESS => 0x000000000a0070e8,
  NOTE    => "Performance Event Counter 26",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00531_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CNTR27                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00532_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 27" ],
);

%nl4rtr_01_00532_def =
( NAME    => "R4_PORTC_PERF_CNTR27",
  ADDRESS => 0x000000000a0070f0,
  NOTE    => "Performance Event Counter 27",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00532_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CNTR28                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00533_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 28" ],
);

%nl4rtr_01_00533_def =
( NAME    => "R4_PORTC_PERF_CNTR28",
  ADDRESS => 0x000000000a0070f8,
  NOTE    => "Performance Event Counter 28",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00533_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CNTR29                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00534_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 29" ],
);

%nl4rtr_01_00534_def =
( NAME    => "R4_PORTC_PERF_CNTR29",
  ADDRESS => 0x000000000a007100,
  NOTE    => "Performance Event Counter 29",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00534_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CNTR30                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00535_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 30" ],
);

%nl4rtr_01_00535_def =
( NAME    => "R4_PORTC_PERF_CNTR30",
  ADDRESS => 0x000000000a007108,
  NOTE    => "Performance Event Counter 30",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00535_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CNTR31                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00536_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 31" ],
);

%nl4rtr_01_00536_def =
( NAME    => "R4_PORTC_PERF_CNTR31",
  ADDRESS => 0x000000000a007110,
  NOTE    => "Performance Event Counter 31",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00536_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CNTR32                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00537_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 32" ],
);

%nl4rtr_01_00537_def =
( NAME    => "R4_PORTC_PERF_CNTR32",
  ADDRESS => 0x000000000a007118,
  NOTE    => "Performance Event Counter 32",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00537_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CNTR33                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00538_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 33" ],
);

%nl4rtr_01_00538_def =
( NAME    => "R4_PORTC_PERF_CNTR33",
  ADDRESS => 0x000000000a007120,
  NOTE    => "Performance Event Counter 33",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00538_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CNTR34                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00539_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 34" ],
);

%nl4rtr_01_00539_def =
( NAME    => "R4_PORTC_PERF_CNTR34",
  ADDRESS => 0x000000000a007128,
  NOTE    => "Performance Event Counter 34",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00539_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CNTR35                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00540_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 35" ],
);

%nl4rtr_01_00540_def =
( NAME    => "R4_PORTC_PERF_CNTR35",
  ADDRESS => 0x000000000a007130,
  NOTE    => "Performance Event Counter 35",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00540_flds
);


##########################################################################
#                                                                        #
#   R4_PORTC_PERF_CNTR36                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00541_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 36" ],
);

%nl4rtr_01_00541_def =
( NAME    => "R4_PORTC_PERF_CNTR36",
  ADDRESS => 0x000000000a007138,
  NOTE    => "Performance Event Counter 36",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00541_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CONFIG                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00542_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  59,   5, 0xF800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIAG"                         => [   1,  45,  14, 0x07FFE00000000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN"                           => [   2,   8,  37, 0x00001FFFFFFFFF00, 0x00, 1, 0x0000000000000000, "Enable Individual Counter" ],
   "DIR"                          => [   3,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Input/output selection for Command buckets" ],
);

%nl4rtr_01_00542_def =
( NAME    => "R4_PORTD_PERF_CONFIG",
  ADDRESS => 0x000000000b007000,
  NOTE    => "Port Performance Counter Configuration",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00542_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CMD_LO                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00543_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CNT7"                         => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 7" ],
   "CNT6"                         => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 6" ],
   "CNT5"                         => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 5" ],
   "CNT4"                         => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 4" ],
   "CNT3"                         => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 3" ],
   "CNT2"                         => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 2" ],
   "CNT1"                         => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 1" ],
   "CNT0"                         => [   7,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 0" ],
);

%nl4rtr_01_00543_def =
( NAME    => "R4_PORTD_PERF_CMD_LO",
  ADDRESS => 0x000000000b007008,
  NOTE    => "The first 8 performance counters are dedicated to command types. note This register is one of two configuration registers that s",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00543_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CMD_UP                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00544_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CNT7"                         => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 7" ],
   "CNT6"                         => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 6" ],
   "CNT5"                         => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 5" ],
   "CNT4"                         => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 4" ],
   "CNT3"                         => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 3" ],
   "CNT2"                         => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 2" ],
   "CNT1"                         => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 1" ],
   "CNT0"                         => [   7,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 0" ],
);

%nl4rtr_01_00544_def =
( NAME    => "R4_PORTD_PERF_CMD_UP",
  ADDRESS => 0x000000000b007010,
  NOTE    => "The first 8 performance counters are dedicated to command types. note This register is one of two configuration registers that s",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00544_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CNTR0                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00545_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 0" ],
);

%nl4rtr_01_00545_def =
( NAME    => "R4_PORTD_PERF_CNTR0",
  ADDRESS => 0x000000000b007018,
  NOTE    => "Performance Event Counter 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00545_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CNTR1                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00546_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 1" ],
);

%nl4rtr_01_00546_def =
( NAME    => "R4_PORTD_PERF_CNTR1",
  ADDRESS => 0x000000000b007020,
  NOTE    => "Performance Event Counter 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00546_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CNTR2                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00547_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 2" ],
);

%nl4rtr_01_00547_def =
( NAME    => "R4_PORTD_PERF_CNTR2",
  ADDRESS => 0x000000000b007028,
  NOTE    => "Performance Event Counter 2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00547_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CNTR3                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00548_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 3" ],
);

%nl4rtr_01_00548_def =
( NAME    => "R4_PORTD_PERF_CNTR3",
  ADDRESS => 0x000000000b007030,
  NOTE    => "Performance Event Counter 3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00548_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CNTR4                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00549_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 4" ],
);

%nl4rtr_01_00549_def =
( NAME    => "R4_PORTD_PERF_CNTR4",
  ADDRESS => 0x000000000b007038,
  NOTE    => "Performance Event Counter 4",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00549_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CNTR5                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00550_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 5" ],
);

%nl4rtr_01_00550_def =
( NAME    => "R4_PORTD_PERF_CNTR5",
  ADDRESS => 0x000000000b007040,
  NOTE    => "Performance Event Counter 5",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00550_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CNTR6                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00551_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 6" ],
);

%nl4rtr_01_00551_def =
( NAME    => "R4_PORTD_PERF_CNTR6",
  ADDRESS => 0x000000000b007048,
  NOTE    => "Performance Event Counter 6",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00551_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CNTR7                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00552_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 7" ],
);

%nl4rtr_01_00552_def =
( NAME    => "R4_PORTD_PERF_CNTR7",
  ADDRESS => 0x000000000b007050,
  NOTE    => "Performance Event Counter 7",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00552_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CNTR8                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00553_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 8" ],
);

%nl4rtr_01_00553_def =
( NAME    => "R4_PORTD_PERF_CNTR8",
  ADDRESS => 0x000000000b007058,
  NOTE    => "Performance Event Counter 8",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00553_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CNTR9                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00554_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 9" ],
);

%nl4rtr_01_00554_def =
( NAME    => "R4_PORTD_PERF_CNTR9",
  ADDRESS => 0x000000000b007060,
  NOTE    => "Performance Event Counter 9",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00554_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CNTR10                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00555_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 10" ],
);

%nl4rtr_01_00555_def =
( NAME    => "R4_PORTD_PERF_CNTR10",
  ADDRESS => 0x000000000b007068,
  NOTE    => "Performance Event Counter 10",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00555_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CNTR11                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00556_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 11" ],
);

%nl4rtr_01_00556_def =
( NAME    => "R4_PORTD_PERF_CNTR11",
  ADDRESS => 0x000000000b007070,
  NOTE    => "Performance Event Counter 11",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00556_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CNTR12                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00557_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 12" ],
);

%nl4rtr_01_00557_def =
( NAME    => "R4_PORTD_PERF_CNTR12",
  ADDRESS => 0x000000000b007078,
  NOTE    => "Performance Event Counter 12",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00557_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CNTR13                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00558_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 13" ],
);

%nl4rtr_01_00558_def =
( NAME    => "R4_PORTD_PERF_CNTR13",
  ADDRESS => 0x000000000b007080,
  NOTE    => "Performance Event Counter 13",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00558_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CNTR14                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00559_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 14" ],
);

%nl4rtr_01_00559_def =
( NAME    => "R4_PORTD_PERF_CNTR14",
  ADDRESS => 0x000000000b007088,
  NOTE    => "Performance Event Counter 14",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00559_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CNTR15                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00560_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 15" ],
);

%nl4rtr_01_00560_def =
( NAME    => "R4_PORTD_PERF_CNTR15",
  ADDRESS => 0x000000000b007090,
  NOTE    => "Performance Event Counter 15",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00560_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CNTR16                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00561_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 16" ],
);

%nl4rtr_01_00561_def =
( NAME    => "R4_PORTD_PERF_CNTR16",
  ADDRESS => 0x000000000b007098,
  NOTE    => "Performance Event Counter 16",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00561_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CNTR17                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00562_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 17" ],
);

%nl4rtr_01_00562_def =
( NAME    => "R4_PORTD_PERF_CNTR17",
  ADDRESS => 0x000000000b0070a0,
  NOTE    => "Performance Event Counter 17",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00562_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CNTR18                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00563_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 18" ],
);

%nl4rtr_01_00563_def =
( NAME    => "R4_PORTD_PERF_CNTR18",
  ADDRESS => 0x000000000b0070a8,
  NOTE    => "Performance Event Counter 18",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00563_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CNTR19                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00564_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 19" ],
);

%nl4rtr_01_00564_def =
( NAME    => "R4_PORTD_PERF_CNTR19",
  ADDRESS => 0x000000000b0070b0,
  NOTE    => "Performance Event Counter 19",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00564_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CNTR20                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00565_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 20" ],
);

%nl4rtr_01_00565_def =
( NAME    => "R4_PORTD_PERF_CNTR20",
  ADDRESS => 0x000000000b0070b8,
  NOTE    => "Performance Event Counter 20",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00565_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CNTR21                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00566_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 21" ],
);

%nl4rtr_01_00566_def =
( NAME    => "R4_PORTD_PERF_CNTR21",
  ADDRESS => 0x000000000b0070c0,
  NOTE    => "Performance Event Counter 21",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00566_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CNTR22                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00567_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 22" ],
);

%nl4rtr_01_00567_def =
( NAME    => "R4_PORTD_PERF_CNTR22",
  ADDRESS => 0x000000000b0070c8,
  NOTE    => "Performance Event Counter 22",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00567_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CNTR23                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00568_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 23" ],
);

%nl4rtr_01_00568_def =
( NAME    => "R4_PORTD_PERF_CNTR23",
  ADDRESS => 0x000000000b0070d0,
  NOTE    => "Performance Event Counter 23",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00568_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CNTR24                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00569_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 24" ],
);

%nl4rtr_01_00569_def =
( NAME    => "R4_PORTD_PERF_CNTR24",
  ADDRESS => 0x000000000b0070d8,
  NOTE    => "Performance Event Counter 24",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00569_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CNTR25                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00570_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 25" ],
);

%nl4rtr_01_00570_def =
( NAME    => "R4_PORTD_PERF_CNTR25",
  ADDRESS => 0x000000000b0070e0,
  NOTE    => "Performance Event Counter 25",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00570_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CNTR26                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00571_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 26" ],
);

%nl4rtr_01_00571_def =
( NAME    => "R4_PORTD_PERF_CNTR26",
  ADDRESS => 0x000000000b0070e8,
  NOTE    => "Performance Event Counter 26",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00571_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CNTR27                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00572_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 27" ],
);

%nl4rtr_01_00572_def =
( NAME    => "R4_PORTD_PERF_CNTR27",
  ADDRESS => 0x000000000b0070f0,
  NOTE    => "Performance Event Counter 27",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00572_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CNTR28                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00573_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 28" ],
);

%nl4rtr_01_00573_def =
( NAME    => "R4_PORTD_PERF_CNTR28",
  ADDRESS => 0x000000000b0070f8,
  NOTE    => "Performance Event Counter 28",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00573_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CNTR29                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00574_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 29" ],
);

%nl4rtr_01_00574_def =
( NAME    => "R4_PORTD_PERF_CNTR29",
  ADDRESS => 0x000000000b007100,
  NOTE    => "Performance Event Counter 29",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00574_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CNTR30                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00575_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 30" ],
);

%nl4rtr_01_00575_def =
( NAME    => "R4_PORTD_PERF_CNTR30",
  ADDRESS => 0x000000000b007108,
  NOTE    => "Performance Event Counter 30",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00575_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CNTR31                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00576_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 31" ],
);

%nl4rtr_01_00576_def =
( NAME    => "R4_PORTD_PERF_CNTR31",
  ADDRESS => 0x000000000b007110,
  NOTE    => "Performance Event Counter 31",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00576_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CNTR32                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00577_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 32" ],
);

%nl4rtr_01_00577_def =
( NAME    => "R4_PORTD_PERF_CNTR32",
  ADDRESS => 0x000000000b007118,
  NOTE    => "Performance Event Counter 32",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00577_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CNTR33                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00578_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 33" ],
);

%nl4rtr_01_00578_def =
( NAME    => "R4_PORTD_PERF_CNTR33",
  ADDRESS => 0x000000000b007120,
  NOTE    => "Performance Event Counter 33",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00578_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CNTR34                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00579_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 34" ],
);

%nl4rtr_01_00579_def =
( NAME    => "R4_PORTD_PERF_CNTR34",
  ADDRESS => 0x000000000b007128,
  NOTE    => "Performance Event Counter 34",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00579_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CNTR35                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00580_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 35" ],
);

%nl4rtr_01_00580_def =
( NAME    => "R4_PORTD_PERF_CNTR35",
  ADDRESS => 0x000000000b007130,
  NOTE    => "Performance Event Counter 35",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00580_flds
);


##########################################################################
#                                                                        #
#   R4_PORTD_PERF_CNTR36                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00581_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 36" ],
);

%nl4rtr_01_00581_def =
( NAME    => "R4_PORTD_PERF_CNTR36",
  ADDRESS => 0x000000000b007138,
  NOTE    => "Performance Event Counter 36",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00581_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CONFIG                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00582_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  59,   5, 0xF800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIAG"                         => [   1,  45,  14, 0x07FFE00000000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN"                           => [   2,   8,  37, 0x00001FFFFFFFFF00, 0x00, 1, 0x0000000000000000, "Enable Individual Counter" ],
   "DIR"                          => [   3,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Input/output selection for Command buckets" ],
);

%nl4rtr_01_00582_def =
( NAME    => "R4_PORTE_PERF_CONFIG",
  ADDRESS => 0x000000000c007000,
  NOTE    => "Port Performance Counter Configuration",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00582_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CMD_LO                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00583_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CNT7"                         => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 7" ],
   "CNT6"                         => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 6" ],
   "CNT5"                         => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 5" ],
   "CNT4"                         => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 4" ],
   "CNT3"                         => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 3" ],
   "CNT2"                         => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 2" ],
   "CNT1"                         => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 1" ],
   "CNT0"                         => [   7,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 0" ],
);

%nl4rtr_01_00583_def =
( NAME    => "R4_PORTE_PERF_CMD_LO",
  ADDRESS => 0x000000000c007008,
  NOTE    => "The first 8 performance counters are dedicated to command types. note This register is one of two configuration registers that s",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00583_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CMD_UP                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00584_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CNT7"                         => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 7" ],
   "CNT6"                         => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 6" ],
   "CNT5"                         => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 5" ],
   "CNT4"                         => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 4" ],
   "CNT3"                         => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 3" ],
   "CNT2"                         => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 2" ],
   "CNT1"                         => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 1" ],
   "CNT0"                         => [   7,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 0" ],
);

%nl4rtr_01_00584_def =
( NAME    => "R4_PORTE_PERF_CMD_UP",
  ADDRESS => 0x000000000c007010,
  NOTE    => "The first 8 performance counters are dedicated to command types. note This register is one of two configuration registers that s",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00584_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CNTR0                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00585_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 0" ],
);

%nl4rtr_01_00585_def =
( NAME    => "R4_PORTE_PERF_CNTR0",
  ADDRESS => 0x000000000c007018,
  NOTE    => "Performance Event Counter 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00585_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CNTR1                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00586_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 1" ],
);

%nl4rtr_01_00586_def =
( NAME    => "R4_PORTE_PERF_CNTR1",
  ADDRESS => 0x000000000c007020,
  NOTE    => "Performance Event Counter 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00586_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CNTR2                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00587_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 2" ],
);

%nl4rtr_01_00587_def =
( NAME    => "R4_PORTE_PERF_CNTR2",
  ADDRESS => 0x000000000c007028,
  NOTE    => "Performance Event Counter 2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00587_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CNTR3                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00588_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 3" ],
);

%nl4rtr_01_00588_def =
( NAME    => "R4_PORTE_PERF_CNTR3",
  ADDRESS => 0x000000000c007030,
  NOTE    => "Performance Event Counter 3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00588_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CNTR4                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00589_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 4" ],
);

%nl4rtr_01_00589_def =
( NAME    => "R4_PORTE_PERF_CNTR4",
  ADDRESS => 0x000000000c007038,
  NOTE    => "Performance Event Counter 4",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00589_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CNTR5                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00590_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 5" ],
);

%nl4rtr_01_00590_def =
( NAME    => "R4_PORTE_PERF_CNTR5",
  ADDRESS => 0x000000000c007040,
  NOTE    => "Performance Event Counter 5",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00590_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CNTR6                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00591_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 6" ],
);

%nl4rtr_01_00591_def =
( NAME    => "R4_PORTE_PERF_CNTR6",
  ADDRESS => 0x000000000c007048,
  NOTE    => "Performance Event Counter 6",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00591_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CNTR7                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00592_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 7" ],
);

%nl4rtr_01_00592_def =
( NAME    => "R4_PORTE_PERF_CNTR7",
  ADDRESS => 0x000000000c007050,
  NOTE    => "Performance Event Counter 7",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00592_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CNTR8                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00593_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 8" ],
);

%nl4rtr_01_00593_def =
( NAME    => "R4_PORTE_PERF_CNTR8",
  ADDRESS => 0x000000000c007058,
  NOTE    => "Performance Event Counter 8",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00593_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CNTR9                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00594_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 9" ],
);

%nl4rtr_01_00594_def =
( NAME    => "R4_PORTE_PERF_CNTR9",
  ADDRESS => 0x000000000c007060,
  NOTE    => "Performance Event Counter 9",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00594_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CNTR10                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00595_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 10" ],
);

%nl4rtr_01_00595_def =
( NAME    => "R4_PORTE_PERF_CNTR10",
  ADDRESS => 0x000000000c007068,
  NOTE    => "Performance Event Counter 10",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00595_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CNTR11                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00596_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 11" ],
);

%nl4rtr_01_00596_def =
( NAME    => "R4_PORTE_PERF_CNTR11",
  ADDRESS => 0x000000000c007070,
  NOTE    => "Performance Event Counter 11",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00596_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CNTR12                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00597_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 12" ],
);

%nl4rtr_01_00597_def =
( NAME    => "R4_PORTE_PERF_CNTR12",
  ADDRESS => 0x000000000c007078,
  NOTE    => "Performance Event Counter 12",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00597_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CNTR13                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00598_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 13" ],
);

%nl4rtr_01_00598_def =
( NAME    => "R4_PORTE_PERF_CNTR13",
  ADDRESS => 0x000000000c007080,
  NOTE    => "Performance Event Counter 13",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00598_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CNTR14                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00599_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 14" ],
);

%nl4rtr_01_00599_def =
( NAME    => "R4_PORTE_PERF_CNTR14",
  ADDRESS => 0x000000000c007088,
  NOTE    => "Performance Event Counter 14",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00599_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CNTR15                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00600_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 15" ],
);

%nl4rtr_01_00600_def =
( NAME    => "R4_PORTE_PERF_CNTR15",
  ADDRESS => 0x000000000c007090,
  NOTE    => "Performance Event Counter 15",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00600_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CNTR16                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00601_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 16" ],
);

%nl4rtr_01_00601_def =
( NAME    => "R4_PORTE_PERF_CNTR16",
  ADDRESS => 0x000000000c007098,
  NOTE    => "Performance Event Counter 16",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00601_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CNTR17                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00602_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 17" ],
);

%nl4rtr_01_00602_def =
( NAME    => "R4_PORTE_PERF_CNTR17",
  ADDRESS => 0x000000000c0070a0,
  NOTE    => "Performance Event Counter 17",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00602_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CNTR18                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00603_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 18" ],
);

%nl4rtr_01_00603_def =
( NAME    => "R4_PORTE_PERF_CNTR18",
  ADDRESS => 0x000000000c0070a8,
  NOTE    => "Performance Event Counter 18",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00603_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CNTR19                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00604_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 19" ],
);

%nl4rtr_01_00604_def =
( NAME    => "R4_PORTE_PERF_CNTR19",
  ADDRESS => 0x000000000c0070b0,
  NOTE    => "Performance Event Counter 19",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00604_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CNTR20                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00605_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 20" ],
);

%nl4rtr_01_00605_def =
( NAME    => "R4_PORTE_PERF_CNTR20",
  ADDRESS => 0x000000000c0070b8,
  NOTE    => "Performance Event Counter 20",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00605_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CNTR21                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00606_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 21" ],
);

%nl4rtr_01_00606_def =
( NAME    => "R4_PORTE_PERF_CNTR21",
  ADDRESS => 0x000000000c0070c0,
  NOTE    => "Performance Event Counter 21",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00606_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CNTR22                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00607_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 22" ],
);

%nl4rtr_01_00607_def =
( NAME    => "R4_PORTE_PERF_CNTR22",
  ADDRESS => 0x000000000c0070c8,
  NOTE    => "Performance Event Counter 22",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00607_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CNTR23                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00608_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 23" ],
);

%nl4rtr_01_00608_def =
( NAME    => "R4_PORTE_PERF_CNTR23",
  ADDRESS => 0x000000000c0070d0,
  NOTE    => "Performance Event Counter 23",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00608_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CNTR24                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00609_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 24" ],
);

%nl4rtr_01_00609_def =
( NAME    => "R4_PORTE_PERF_CNTR24",
  ADDRESS => 0x000000000c0070d8,
  NOTE    => "Performance Event Counter 24",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00609_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CNTR25                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00610_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 25" ],
);

%nl4rtr_01_00610_def =
( NAME    => "R4_PORTE_PERF_CNTR25",
  ADDRESS => 0x000000000c0070e0,
  NOTE    => "Performance Event Counter 25",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00610_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CNTR26                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00611_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 26" ],
);

%nl4rtr_01_00611_def =
( NAME    => "R4_PORTE_PERF_CNTR26",
  ADDRESS => 0x000000000c0070e8,
  NOTE    => "Performance Event Counter 26",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00611_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CNTR27                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00612_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 27" ],
);

%nl4rtr_01_00612_def =
( NAME    => "R4_PORTE_PERF_CNTR27",
  ADDRESS => 0x000000000c0070f0,
  NOTE    => "Performance Event Counter 27",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00612_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CNTR28                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00613_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 28" ],
);

%nl4rtr_01_00613_def =
( NAME    => "R4_PORTE_PERF_CNTR28",
  ADDRESS => 0x000000000c0070f8,
  NOTE    => "Performance Event Counter 28",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00613_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CNTR29                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00614_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 29" ],
);

%nl4rtr_01_00614_def =
( NAME    => "R4_PORTE_PERF_CNTR29",
  ADDRESS => 0x000000000c007100,
  NOTE    => "Performance Event Counter 29",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00614_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CNTR30                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00615_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 30" ],
);

%nl4rtr_01_00615_def =
( NAME    => "R4_PORTE_PERF_CNTR30",
  ADDRESS => 0x000000000c007108,
  NOTE    => "Performance Event Counter 30",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00615_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CNTR31                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00616_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 31" ],
);

%nl4rtr_01_00616_def =
( NAME    => "R4_PORTE_PERF_CNTR31",
  ADDRESS => 0x000000000c007110,
  NOTE    => "Performance Event Counter 31",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00616_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CNTR32                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00617_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 32" ],
);

%nl4rtr_01_00617_def =
( NAME    => "R4_PORTE_PERF_CNTR32",
  ADDRESS => 0x000000000c007118,
  NOTE    => "Performance Event Counter 32",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00617_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CNTR33                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00618_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 33" ],
);

%nl4rtr_01_00618_def =
( NAME    => "R4_PORTE_PERF_CNTR33",
  ADDRESS => 0x000000000c007120,
  NOTE    => "Performance Event Counter 33",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00618_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CNTR34                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00619_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 34" ],
);

%nl4rtr_01_00619_def =
( NAME    => "R4_PORTE_PERF_CNTR34",
  ADDRESS => 0x000000000c007128,
  NOTE    => "Performance Event Counter 34",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00619_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CNTR35                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00620_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 35" ],
);

%nl4rtr_01_00620_def =
( NAME    => "R4_PORTE_PERF_CNTR35",
  ADDRESS => 0x000000000c007130,
  NOTE    => "Performance Event Counter 35",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00620_flds
);


##########################################################################
#                                                                        #
#   R4_PORTE_PERF_CNTR36                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00621_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 36" ],
);

%nl4rtr_01_00621_def =
( NAME    => "R4_PORTE_PERF_CNTR36",
  ADDRESS => 0x000000000c007138,
  NOTE    => "Performance Event Counter 36",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00621_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CONFIG                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00622_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  59,   5, 0xF800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIAG"                         => [   1,  45,  14, 0x07FFE00000000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN"                           => [   2,   8,  37, 0x00001FFFFFFFFF00, 0x00, 1, 0x0000000000000000, "Enable Individual Counter" ],
   "DIR"                          => [   3,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Input/output selection for Command buckets" ],
);

%nl4rtr_01_00622_def =
( NAME    => "R4_PORTF_PERF_CONFIG",
  ADDRESS => 0x000000000d007000,
  NOTE    => "Port Performance Counter Configuration",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00622_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CMD_LO                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00623_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CNT7"                         => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 7" ],
   "CNT6"                         => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 6" ],
   "CNT5"                         => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 5" ],
   "CNT4"                         => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 4" ],
   "CNT3"                         => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 3" ],
   "CNT2"                         => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 2" ],
   "CNT1"                         => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 1" ],
   "CNT0"                         => [   7,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 0" ],
);

%nl4rtr_01_00623_def =
( NAME    => "R4_PORTF_PERF_CMD_LO",
  ADDRESS => 0x000000000d007008,
  NOTE    => "The first 8 performance counters are dedicated to command types. note This register is one of two configuration registers that s",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00623_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CMD_UP                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00624_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CNT7"                         => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 7" ],
   "CNT6"                         => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 6" ],
   "CNT5"                         => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 5" ],
   "CNT4"                         => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 4" ],
   "CNT3"                         => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 3" ],
   "CNT2"                         => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 2" ],
   "CNT1"                         => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 1" ],
   "CNT0"                         => [   7,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 0" ],
);

%nl4rtr_01_00624_def =
( NAME    => "R4_PORTF_PERF_CMD_UP",
  ADDRESS => 0x000000000d007010,
  NOTE    => "The first 8 performance counters are dedicated to command types. note This register is one of two configuration registers that s",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00624_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CNTR0                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00625_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 0" ],
);

%nl4rtr_01_00625_def =
( NAME    => "R4_PORTF_PERF_CNTR0",
  ADDRESS => 0x000000000d007018,
  NOTE    => "Performance Event Counter 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00625_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CNTR1                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00626_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 1" ],
);

%nl4rtr_01_00626_def =
( NAME    => "R4_PORTF_PERF_CNTR1",
  ADDRESS => 0x000000000d007020,
  NOTE    => "Performance Event Counter 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00626_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CNTR2                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00627_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 2" ],
);

%nl4rtr_01_00627_def =
( NAME    => "R4_PORTF_PERF_CNTR2",
  ADDRESS => 0x000000000d007028,
  NOTE    => "Performance Event Counter 2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00627_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CNTR3                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00628_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 3" ],
);

%nl4rtr_01_00628_def =
( NAME    => "R4_PORTF_PERF_CNTR3",
  ADDRESS => 0x000000000d007030,
  NOTE    => "Performance Event Counter 3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00628_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CNTR4                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00629_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 4" ],
);

%nl4rtr_01_00629_def =
( NAME    => "R4_PORTF_PERF_CNTR4",
  ADDRESS => 0x000000000d007038,
  NOTE    => "Performance Event Counter 4",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00629_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CNTR5                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00630_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 5" ],
);

%nl4rtr_01_00630_def =
( NAME    => "R4_PORTF_PERF_CNTR5",
  ADDRESS => 0x000000000d007040,
  NOTE    => "Performance Event Counter 5",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00630_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CNTR6                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00631_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 6" ],
);

%nl4rtr_01_00631_def =
( NAME    => "R4_PORTF_PERF_CNTR6",
  ADDRESS => 0x000000000d007048,
  NOTE    => "Performance Event Counter 6",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00631_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CNTR7                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00632_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 7" ],
);

%nl4rtr_01_00632_def =
( NAME    => "R4_PORTF_PERF_CNTR7",
  ADDRESS => 0x000000000d007050,
  NOTE    => "Performance Event Counter 7",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00632_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CNTR8                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00633_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 8" ],
);

%nl4rtr_01_00633_def =
( NAME    => "R4_PORTF_PERF_CNTR8",
  ADDRESS => 0x000000000d007058,
  NOTE    => "Performance Event Counter 8",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00633_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CNTR9                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00634_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 9" ],
);

%nl4rtr_01_00634_def =
( NAME    => "R4_PORTF_PERF_CNTR9",
  ADDRESS => 0x000000000d007060,
  NOTE    => "Performance Event Counter 9",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00634_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CNTR10                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00635_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 10" ],
);

%nl4rtr_01_00635_def =
( NAME    => "R4_PORTF_PERF_CNTR10",
  ADDRESS => 0x000000000d007068,
  NOTE    => "Performance Event Counter 10",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00635_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CNTR11                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00636_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 11" ],
);

%nl4rtr_01_00636_def =
( NAME    => "R4_PORTF_PERF_CNTR11",
  ADDRESS => 0x000000000d007070,
  NOTE    => "Performance Event Counter 11",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00636_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CNTR12                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00637_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 12" ],
);

%nl4rtr_01_00637_def =
( NAME    => "R4_PORTF_PERF_CNTR12",
  ADDRESS => 0x000000000d007078,
  NOTE    => "Performance Event Counter 12",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00637_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CNTR13                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00638_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 13" ],
);

%nl4rtr_01_00638_def =
( NAME    => "R4_PORTF_PERF_CNTR13",
  ADDRESS => 0x000000000d007080,
  NOTE    => "Performance Event Counter 13",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00638_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CNTR14                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00639_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 14" ],
);

%nl4rtr_01_00639_def =
( NAME    => "R4_PORTF_PERF_CNTR14",
  ADDRESS => 0x000000000d007088,
  NOTE    => "Performance Event Counter 14",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00639_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CNTR15                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00640_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 15" ],
);

%nl4rtr_01_00640_def =
( NAME    => "R4_PORTF_PERF_CNTR15",
  ADDRESS => 0x000000000d007090,
  NOTE    => "Performance Event Counter 15",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00640_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CNTR16                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00641_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 16" ],
);

%nl4rtr_01_00641_def =
( NAME    => "R4_PORTF_PERF_CNTR16",
  ADDRESS => 0x000000000d007098,
  NOTE    => "Performance Event Counter 16",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00641_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CNTR17                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00642_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 17" ],
);

%nl4rtr_01_00642_def =
( NAME    => "R4_PORTF_PERF_CNTR17",
  ADDRESS => 0x000000000d0070a0,
  NOTE    => "Performance Event Counter 17",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00642_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CNTR18                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00643_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 18" ],
);

%nl4rtr_01_00643_def =
( NAME    => "R4_PORTF_PERF_CNTR18",
  ADDRESS => 0x000000000d0070a8,
  NOTE    => "Performance Event Counter 18",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00643_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CNTR19                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00644_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 19" ],
);

%nl4rtr_01_00644_def =
( NAME    => "R4_PORTF_PERF_CNTR19",
  ADDRESS => 0x000000000d0070b0,
  NOTE    => "Performance Event Counter 19",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00644_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CNTR20                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00645_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 20" ],
);

%nl4rtr_01_00645_def =
( NAME    => "R4_PORTF_PERF_CNTR20",
  ADDRESS => 0x000000000d0070b8,
  NOTE    => "Performance Event Counter 20",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00645_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CNTR21                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00646_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 21" ],
);

%nl4rtr_01_00646_def =
( NAME    => "R4_PORTF_PERF_CNTR21",
  ADDRESS => 0x000000000d0070c0,
  NOTE    => "Performance Event Counter 21",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00646_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CNTR22                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00647_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 22" ],
);

%nl4rtr_01_00647_def =
( NAME    => "R4_PORTF_PERF_CNTR22",
  ADDRESS => 0x000000000d0070c8,
  NOTE    => "Performance Event Counter 22",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00647_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CNTR23                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00648_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 23" ],
);

%nl4rtr_01_00648_def =
( NAME    => "R4_PORTF_PERF_CNTR23",
  ADDRESS => 0x000000000d0070d0,
  NOTE    => "Performance Event Counter 23",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00648_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CNTR24                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00649_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 24" ],
);

%nl4rtr_01_00649_def =
( NAME    => "R4_PORTF_PERF_CNTR24",
  ADDRESS => 0x000000000d0070d8,
  NOTE    => "Performance Event Counter 24",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00649_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CNTR25                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00650_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 25" ],
);

%nl4rtr_01_00650_def =
( NAME    => "R4_PORTF_PERF_CNTR25",
  ADDRESS => 0x000000000d0070e0,
  NOTE    => "Performance Event Counter 25",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00650_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CNTR26                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00651_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 26" ],
);

%nl4rtr_01_00651_def =
( NAME    => "R4_PORTF_PERF_CNTR26",
  ADDRESS => 0x000000000d0070e8,
  NOTE    => "Performance Event Counter 26",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00651_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CNTR27                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00652_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 27" ],
);

%nl4rtr_01_00652_def =
( NAME    => "R4_PORTF_PERF_CNTR27",
  ADDRESS => 0x000000000d0070f0,
  NOTE    => "Performance Event Counter 27",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00652_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CNTR28                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00653_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 28" ],
);

%nl4rtr_01_00653_def =
( NAME    => "R4_PORTF_PERF_CNTR28",
  ADDRESS => 0x000000000d0070f8,
  NOTE    => "Performance Event Counter 28",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00653_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CNTR29                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00654_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 29" ],
);

%nl4rtr_01_00654_def =
( NAME    => "R4_PORTF_PERF_CNTR29",
  ADDRESS => 0x000000000d007100,
  NOTE    => "Performance Event Counter 29",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00654_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CNTR30                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00655_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 30" ],
);

%nl4rtr_01_00655_def =
( NAME    => "R4_PORTF_PERF_CNTR30",
  ADDRESS => 0x000000000d007108,
  NOTE    => "Performance Event Counter 30",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00655_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CNTR31                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00656_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 31" ],
);

%nl4rtr_01_00656_def =
( NAME    => "R4_PORTF_PERF_CNTR31",
  ADDRESS => 0x000000000d007110,
  NOTE    => "Performance Event Counter 31",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00656_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CNTR32                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00657_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 32" ],
);

%nl4rtr_01_00657_def =
( NAME    => "R4_PORTF_PERF_CNTR32",
  ADDRESS => 0x000000000d007118,
  NOTE    => "Performance Event Counter 32",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00657_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CNTR33                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00658_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 33" ],
);

%nl4rtr_01_00658_def =
( NAME    => "R4_PORTF_PERF_CNTR33",
  ADDRESS => 0x000000000d007120,
  NOTE    => "Performance Event Counter 33",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00658_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CNTR34                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00659_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 34" ],
);

%nl4rtr_01_00659_def =
( NAME    => "R4_PORTF_PERF_CNTR34",
  ADDRESS => 0x000000000d007128,
  NOTE    => "Performance Event Counter 34",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00659_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CNTR35                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00660_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 35" ],
);

%nl4rtr_01_00660_def =
( NAME    => "R4_PORTF_PERF_CNTR35",
  ADDRESS => 0x000000000d007130,
  NOTE    => "Performance Event Counter 35",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00660_flds
);


##########################################################################
#                                                                        #
#   R4_PORTF_PERF_CNTR36                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00661_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 36" ],
);

%nl4rtr_01_00661_def =
( NAME    => "R4_PORTF_PERF_CNTR36",
  ADDRESS => 0x000000000d007138,
  NOTE    => "Performance Event Counter 36",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00661_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CONFIG                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00662_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  59,   5, 0xF800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIAG"                         => [   1,  45,  14, 0x07FFE00000000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN"                           => [   2,   8,  37, 0x00001FFFFFFFFF00, 0x00, 1, 0x0000000000000000, "Enable Individual Counter" ],
   "DIR"                          => [   3,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Input/output selection for Command buckets" ],
);

%nl4rtr_01_00662_def =
( NAME    => "R4_PORTG_PERF_CONFIG",
  ADDRESS => 0x000000000e007000,
  NOTE    => "Port Performance Counter Configuration",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00662_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CMD_LO                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00663_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CNT7"                         => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 7" ],
   "CNT6"                         => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 6" ],
   "CNT5"                         => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 5" ],
   "CNT4"                         => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 4" ],
   "CNT3"                         => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 3" ],
   "CNT2"                         => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 2" ],
   "CNT1"                         => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 1" ],
   "CNT0"                         => [   7,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 0" ],
);

%nl4rtr_01_00663_def =
( NAME    => "R4_PORTG_PERF_CMD_LO",
  ADDRESS => 0x000000000e007008,
  NOTE    => "The first 8 performance counters are dedicated to command types. note This register is one of two configuration registers that s",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00663_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CMD_UP                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00664_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CNT7"                         => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 7" ],
   "CNT6"                         => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 6" ],
   "CNT5"                         => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 5" ],
   "CNT4"                         => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 4" ],
   "CNT3"                         => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 3" ],
   "CNT2"                         => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 2" ],
   "CNT1"                         => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 1" ],
   "CNT0"                         => [   7,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 0" ],
);

%nl4rtr_01_00664_def =
( NAME    => "R4_PORTG_PERF_CMD_UP",
  ADDRESS => 0x000000000e007010,
  NOTE    => "The first 8 performance counters are dedicated to command types. note This register is one of two configuration registers that s",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00664_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CNTR0                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00665_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 0" ],
);

%nl4rtr_01_00665_def =
( NAME    => "R4_PORTG_PERF_CNTR0",
  ADDRESS => 0x000000000e007018,
  NOTE    => "Performance Event Counter 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00665_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CNTR1                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00666_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 1" ],
);

%nl4rtr_01_00666_def =
( NAME    => "R4_PORTG_PERF_CNTR1",
  ADDRESS => 0x000000000e007020,
  NOTE    => "Performance Event Counter 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00666_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CNTR2                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00667_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 2" ],
);

%nl4rtr_01_00667_def =
( NAME    => "R4_PORTG_PERF_CNTR2",
  ADDRESS => 0x000000000e007028,
  NOTE    => "Performance Event Counter 2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00667_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CNTR3                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00668_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 3" ],
);

%nl4rtr_01_00668_def =
( NAME    => "R4_PORTG_PERF_CNTR3",
  ADDRESS => 0x000000000e007030,
  NOTE    => "Performance Event Counter 3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00668_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CNTR4                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00669_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 4" ],
);

%nl4rtr_01_00669_def =
( NAME    => "R4_PORTG_PERF_CNTR4",
  ADDRESS => 0x000000000e007038,
  NOTE    => "Performance Event Counter 4",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00669_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CNTR5                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00670_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 5" ],
);

%nl4rtr_01_00670_def =
( NAME    => "R4_PORTG_PERF_CNTR5",
  ADDRESS => 0x000000000e007040,
  NOTE    => "Performance Event Counter 5",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00670_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CNTR6                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00671_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 6" ],
);

%nl4rtr_01_00671_def =
( NAME    => "R4_PORTG_PERF_CNTR6",
  ADDRESS => 0x000000000e007048,
  NOTE    => "Performance Event Counter 6",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00671_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CNTR7                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00672_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 7" ],
);

%nl4rtr_01_00672_def =
( NAME    => "R4_PORTG_PERF_CNTR7",
  ADDRESS => 0x000000000e007050,
  NOTE    => "Performance Event Counter 7",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00672_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CNTR8                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00673_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 8" ],
);

%nl4rtr_01_00673_def =
( NAME    => "R4_PORTG_PERF_CNTR8",
  ADDRESS => 0x000000000e007058,
  NOTE    => "Performance Event Counter 8",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00673_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CNTR9                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00674_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 9" ],
);

%nl4rtr_01_00674_def =
( NAME    => "R4_PORTG_PERF_CNTR9",
  ADDRESS => 0x000000000e007060,
  NOTE    => "Performance Event Counter 9",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00674_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CNTR10                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00675_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 10" ],
);

%nl4rtr_01_00675_def =
( NAME    => "R4_PORTG_PERF_CNTR10",
  ADDRESS => 0x000000000e007068,
  NOTE    => "Performance Event Counter 10",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00675_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CNTR11                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00676_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 11" ],
);

%nl4rtr_01_00676_def =
( NAME    => "R4_PORTG_PERF_CNTR11",
  ADDRESS => 0x000000000e007070,
  NOTE    => "Performance Event Counter 11",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00676_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CNTR12                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00677_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 12" ],
);

%nl4rtr_01_00677_def =
( NAME    => "R4_PORTG_PERF_CNTR12",
  ADDRESS => 0x000000000e007078,
  NOTE    => "Performance Event Counter 12",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00677_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CNTR13                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00678_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 13" ],
);

%nl4rtr_01_00678_def =
( NAME    => "R4_PORTG_PERF_CNTR13",
  ADDRESS => 0x000000000e007080,
  NOTE    => "Performance Event Counter 13",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00678_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CNTR14                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00679_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 14" ],
);

%nl4rtr_01_00679_def =
( NAME    => "R4_PORTG_PERF_CNTR14",
  ADDRESS => 0x000000000e007088,
  NOTE    => "Performance Event Counter 14",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00679_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CNTR15                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00680_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 15" ],
);

%nl4rtr_01_00680_def =
( NAME    => "R4_PORTG_PERF_CNTR15",
  ADDRESS => 0x000000000e007090,
  NOTE    => "Performance Event Counter 15",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00680_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CNTR16                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00681_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 16" ],
);

%nl4rtr_01_00681_def =
( NAME    => "R4_PORTG_PERF_CNTR16",
  ADDRESS => 0x000000000e007098,
  NOTE    => "Performance Event Counter 16",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00681_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CNTR17                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00682_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 17" ],
);

%nl4rtr_01_00682_def =
( NAME    => "R4_PORTG_PERF_CNTR17",
  ADDRESS => 0x000000000e0070a0,
  NOTE    => "Performance Event Counter 17",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00682_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CNTR18                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00683_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 18" ],
);

%nl4rtr_01_00683_def =
( NAME    => "R4_PORTG_PERF_CNTR18",
  ADDRESS => 0x000000000e0070a8,
  NOTE    => "Performance Event Counter 18",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00683_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CNTR19                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00684_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 19" ],
);

%nl4rtr_01_00684_def =
( NAME    => "R4_PORTG_PERF_CNTR19",
  ADDRESS => 0x000000000e0070b0,
  NOTE    => "Performance Event Counter 19",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00684_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CNTR20                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00685_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 20" ],
);

%nl4rtr_01_00685_def =
( NAME    => "R4_PORTG_PERF_CNTR20",
  ADDRESS => 0x000000000e0070b8,
  NOTE    => "Performance Event Counter 20",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00685_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CNTR21                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00686_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 21" ],
);

%nl4rtr_01_00686_def =
( NAME    => "R4_PORTG_PERF_CNTR21",
  ADDRESS => 0x000000000e0070c0,
  NOTE    => "Performance Event Counter 21",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00686_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CNTR22                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00687_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 22" ],
);

%nl4rtr_01_00687_def =
( NAME    => "R4_PORTG_PERF_CNTR22",
  ADDRESS => 0x000000000e0070c8,
  NOTE    => "Performance Event Counter 22",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00687_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CNTR23                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00688_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 23" ],
);

%nl4rtr_01_00688_def =
( NAME    => "R4_PORTG_PERF_CNTR23",
  ADDRESS => 0x000000000e0070d0,
  NOTE    => "Performance Event Counter 23",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00688_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CNTR24                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00689_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 24" ],
);

%nl4rtr_01_00689_def =
( NAME    => "R4_PORTG_PERF_CNTR24",
  ADDRESS => 0x000000000e0070d8,
  NOTE    => "Performance Event Counter 24",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00689_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CNTR25                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00690_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 25" ],
);

%nl4rtr_01_00690_def =
( NAME    => "R4_PORTG_PERF_CNTR25",
  ADDRESS => 0x000000000e0070e0,
  NOTE    => "Performance Event Counter 25",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00690_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CNTR26                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00691_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 26" ],
);

%nl4rtr_01_00691_def =
( NAME    => "R4_PORTG_PERF_CNTR26",
  ADDRESS => 0x000000000e0070e8,
  NOTE    => "Performance Event Counter 26",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00691_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CNTR27                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00692_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 27" ],
);

%nl4rtr_01_00692_def =
( NAME    => "R4_PORTG_PERF_CNTR27",
  ADDRESS => 0x000000000e0070f0,
  NOTE    => "Performance Event Counter 27",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00692_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CNTR28                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00693_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 28" ],
);

%nl4rtr_01_00693_def =
( NAME    => "R4_PORTG_PERF_CNTR28",
  ADDRESS => 0x000000000e0070f8,
  NOTE    => "Performance Event Counter 28",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00693_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CNTR29                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00694_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 29" ],
);

%nl4rtr_01_00694_def =
( NAME    => "R4_PORTG_PERF_CNTR29",
  ADDRESS => 0x000000000e007100,
  NOTE    => "Performance Event Counter 29",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00694_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CNTR30                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00695_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 30" ],
);

%nl4rtr_01_00695_def =
( NAME    => "R4_PORTG_PERF_CNTR30",
  ADDRESS => 0x000000000e007108,
  NOTE    => "Performance Event Counter 30",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00695_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CNTR31                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00696_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 31" ],
);

%nl4rtr_01_00696_def =
( NAME    => "R4_PORTG_PERF_CNTR31",
  ADDRESS => 0x000000000e007110,
  NOTE    => "Performance Event Counter 31",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00696_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CNTR32                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00697_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 32" ],
);

%nl4rtr_01_00697_def =
( NAME    => "R4_PORTG_PERF_CNTR32",
  ADDRESS => 0x000000000e007118,
  NOTE    => "Performance Event Counter 32",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00697_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CNTR33                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00698_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 33" ],
);

%nl4rtr_01_00698_def =
( NAME    => "R4_PORTG_PERF_CNTR33",
  ADDRESS => 0x000000000e007120,
  NOTE    => "Performance Event Counter 33",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00698_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CNTR34                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00699_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 34" ],
);

%nl4rtr_01_00699_def =
( NAME    => "R4_PORTG_PERF_CNTR34",
  ADDRESS => 0x000000000e007128,
  NOTE    => "Performance Event Counter 34",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00699_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CNTR35                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00700_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 35" ],
);

%nl4rtr_01_00700_def =
( NAME    => "R4_PORTG_PERF_CNTR35",
  ADDRESS => 0x000000000e007130,
  NOTE    => "Performance Event Counter 35",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00700_flds
);


##########################################################################
#                                                                        #
#   R4_PORTG_PERF_CNTR36                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00701_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 36" ],
);

%nl4rtr_01_00701_def =
( NAME    => "R4_PORTG_PERF_CNTR36",
  ADDRESS => 0x000000000e007138,
  NOTE    => "Performance Event Counter 36",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00701_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CONFIG                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00702_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  59,   5, 0xF800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIAG"                         => [   1,  45,  14, 0x07FFE00000000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN"                           => [   2,   8,  37, 0x00001FFFFFFFFF00, 0x00, 1, 0x0000000000000000, "Enable Individual Counter" ],
   "DIR"                          => [   3,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Input/output selection for Command buckets" ],
);

%nl4rtr_01_00702_def =
( NAME    => "R4_PORTH_PERF_CONFIG",
  ADDRESS => 0x000000000f007000,
  NOTE    => "Port Performance Counter Configuration",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00702_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CMD_LO                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00703_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CNT7"                         => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 7" ],
   "CNT6"                         => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 6" ],
   "CNT5"                         => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 5" ],
   "CNT4"                         => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 4" ],
   "CNT3"                         => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 3" ],
   "CNT2"                         => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 2" ],
   "CNT1"                         => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 1" ],
   "CNT0"                         => [   7,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Lower command limit for performance counter 0" ],
);

%nl4rtr_01_00703_def =
( NAME    => "R4_PORTH_PERF_CMD_LO",
  ADDRESS => 0x000000000f007008,
  NOTE    => "The first 8 performance counters are dedicated to command types. note This register is one of two configuration registers that s",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00703_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CMD_UP                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00704_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CNT7"                         => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 7" ],
   "CNT6"                         => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 6" ],
   "CNT5"                         => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 5" ],
   "CNT4"                         => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 4" ],
   "CNT3"                         => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 3" ],
   "CNT2"                         => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 2" ],
   "CNT1"                         => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 1" ],
   "CNT0"                         => [   7,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Upper command limit for performance counter 0" ],
);

%nl4rtr_01_00704_def =
( NAME    => "R4_PORTH_PERF_CMD_UP",
  ADDRESS => 0x000000000f007010,
  NOTE    => "The first 8 performance counters are dedicated to command types. note This register is one of two configuration registers that s",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00704_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CNTR0                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00705_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 0" ],
);

%nl4rtr_01_00705_def =
( NAME    => "R4_PORTH_PERF_CNTR0",
  ADDRESS => 0x000000000f007018,
  NOTE    => "Performance Event Counter 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00705_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CNTR1                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00706_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 1" ],
);

%nl4rtr_01_00706_def =
( NAME    => "R4_PORTH_PERF_CNTR1",
  ADDRESS => 0x000000000f007020,
  NOTE    => "Performance Event Counter 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00706_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CNTR2                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00707_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 2" ],
);

%nl4rtr_01_00707_def =
( NAME    => "R4_PORTH_PERF_CNTR2",
  ADDRESS => 0x000000000f007028,
  NOTE    => "Performance Event Counter 2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00707_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CNTR3                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00708_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 3" ],
);

%nl4rtr_01_00708_def =
( NAME    => "R4_PORTH_PERF_CNTR3",
  ADDRESS => 0x000000000f007030,
  NOTE    => "Performance Event Counter 3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00708_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CNTR4                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00709_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 4" ],
);

%nl4rtr_01_00709_def =
( NAME    => "R4_PORTH_PERF_CNTR4",
  ADDRESS => 0x000000000f007038,
  NOTE    => "Performance Event Counter 4",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00709_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CNTR5                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00710_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 5" ],
);

%nl4rtr_01_00710_def =
( NAME    => "R4_PORTH_PERF_CNTR5",
  ADDRESS => 0x000000000f007040,
  NOTE    => "Performance Event Counter 5",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00710_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CNTR6                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00711_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 6" ],
);

%nl4rtr_01_00711_def =
( NAME    => "R4_PORTH_PERF_CNTR6",
  ADDRESS => 0x000000000f007048,
  NOTE    => "Performance Event Counter 6",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00711_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CNTR7                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00712_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 7" ],
);

%nl4rtr_01_00712_def =
( NAME    => "R4_PORTH_PERF_CNTR7",
  ADDRESS => 0x000000000f007050,
  NOTE    => "Performance Event Counter 7",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00712_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CNTR8                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00713_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 8" ],
);

%nl4rtr_01_00713_def =
( NAME    => "R4_PORTH_PERF_CNTR8",
  ADDRESS => 0x000000000f007058,
  NOTE    => "Performance Event Counter 8",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00713_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CNTR9                                                  #
#                                                                        #
##########################################################################

%nl4rtr_01_00714_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 9" ],
);

%nl4rtr_01_00714_def =
( NAME    => "R4_PORTH_PERF_CNTR9",
  ADDRESS => 0x000000000f007060,
  NOTE    => "Performance Event Counter 9",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00714_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CNTR10                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00715_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 10" ],
);

%nl4rtr_01_00715_def =
( NAME    => "R4_PORTH_PERF_CNTR10",
  ADDRESS => 0x000000000f007068,
  NOTE    => "Performance Event Counter 10",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00715_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CNTR11                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00716_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 11" ],
);

%nl4rtr_01_00716_def =
( NAME    => "R4_PORTH_PERF_CNTR11",
  ADDRESS => 0x000000000f007070,
  NOTE    => "Performance Event Counter 11",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00716_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CNTR12                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00717_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 12" ],
);

%nl4rtr_01_00717_def =
( NAME    => "R4_PORTH_PERF_CNTR12",
  ADDRESS => 0x000000000f007078,
  NOTE    => "Performance Event Counter 12",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00717_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CNTR13                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00718_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 13" ],
);

%nl4rtr_01_00718_def =
( NAME    => "R4_PORTH_PERF_CNTR13",
  ADDRESS => 0x000000000f007080,
  NOTE    => "Performance Event Counter 13",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00718_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CNTR14                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00719_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 14" ],
);

%nl4rtr_01_00719_def =
( NAME    => "R4_PORTH_PERF_CNTR14",
  ADDRESS => 0x000000000f007088,
  NOTE    => "Performance Event Counter 14",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00719_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CNTR15                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00720_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 15" ],
);

%nl4rtr_01_00720_def =
( NAME    => "R4_PORTH_PERF_CNTR15",
  ADDRESS => 0x000000000f007090,
  NOTE    => "Performance Event Counter 15",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00720_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CNTR16                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00721_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 16" ],
);

%nl4rtr_01_00721_def =
( NAME    => "R4_PORTH_PERF_CNTR16",
  ADDRESS => 0x000000000f007098,
  NOTE    => "Performance Event Counter 16",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00721_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CNTR17                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00722_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 17" ],
);

%nl4rtr_01_00722_def =
( NAME    => "R4_PORTH_PERF_CNTR17",
  ADDRESS => 0x000000000f0070a0,
  NOTE    => "Performance Event Counter 17",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00722_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CNTR18                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00723_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 18" ],
);

%nl4rtr_01_00723_def =
( NAME    => "R4_PORTH_PERF_CNTR18",
  ADDRESS => 0x000000000f0070a8,
  NOTE    => "Performance Event Counter 18",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00723_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CNTR19                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00724_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 19" ],
);

%nl4rtr_01_00724_def =
( NAME    => "R4_PORTH_PERF_CNTR19",
  ADDRESS => 0x000000000f0070b0,
  NOTE    => "Performance Event Counter 19",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00724_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CNTR20                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00725_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 20" ],
);

%nl4rtr_01_00725_def =
( NAME    => "R4_PORTH_PERF_CNTR20",
  ADDRESS => 0x000000000f0070b8,
  NOTE    => "Performance Event Counter 20",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00725_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CNTR21                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00726_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 21" ],
);

%nl4rtr_01_00726_def =
( NAME    => "R4_PORTH_PERF_CNTR21",
  ADDRESS => 0x000000000f0070c0,
  NOTE    => "Performance Event Counter 21",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00726_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CNTR22                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00727_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 22" ],
);

%nl4rtr_01_00727_def =
( NAME    => "R4_PORTH_PERF_CNTR22",
  ADDRESS => 0x000000000f0070c8,
  NOTE    => "Performance Event Counter 22",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00727_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CNTR23                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00728_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 23" ],
);

%nl4rtr_01_00728_def =
( NAME    => "R4_PORTH_PERF_CNTR23",
  ADDRESS => 0x000000000f0070d0,
  NOTE    => "Performance Event Counter 23",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00728_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CNTR24                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00729_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 24" ],
);

%nl4rtr_01_00729_def =
( NAME    => "R4_PORTH_PERF_CNTR24",
  ADDRESS => 0x000000000f0070d8,
  NOTE    => "Performance Event Counter 24",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00729_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CNTR25                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00730_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 25" ],
);

%nl4rtr_01_00730_def =
( NAME    => "R4_PORTH_PERF_CNTR25",
  ADDRESS => 0x000000000f0070e0,
  NOTE    => "Performance Event Counter 25",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00730_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CNTR26                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00731_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 26" ],
);

%nl4rtr_01_00731_def =
( NAME    => "R4_PORTH_PERF_CNTR26",
  ADDRESS => 0x000000000f0070e8,
  NOTE    => "Performance Event Counter 26",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00731_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CNTR27                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00732_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 27" ],
);

%nl4rtr_01_00732_def =
( NAME    => "R4_PORTH_PERF_CNTR27",
  ADDRESS => 0x000000000f0070f0,
  NOTE    => "Performance Event Counter 27",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00732_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CNTR28                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00733_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 28" ],
);

%nl4rtr_01_00733_def =
( NAME    => "R4_PORTH_PERF_CNTR28",
  ADDRESS => 0x000000000f0070f8,
  NOTE    => "Performance Event Counter 28",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00733_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CNTR29                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00734_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 29" ],
);

%nl4rtr_01_00734_def =
( NAME    => "R4_PORTH_PERF_CNTR29",
  ADDRESS => 0x000000000f007100,
  NOTE    => "Performance Event Counter 29",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00734_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CNTR30                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00735_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 30" ],
);

%nl4rtr_01_00735_def =
( NAME    => "R4_PORTH_PERF_CNTR30",
  ADDRESS => 0x000000000f007108,
  NOTE    => "Performance Event Counter 30",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00735_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CNTR31                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00736_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 31" ],
);

%nl4rtr_01_00736_def =
( NAME    => "R4_PORTH_PERF_CNTR31",
  ADDRESS => 0x000000000f007110,
  NOTE    => "Performance Event Counter 31",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00736_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CNTR32                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00737_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 32" ],
);

%nl4rtr_01_00737_def =
( NAME    => "R4_PORTH_PERF_CNTR32",
  ADDRESS => 0x000000000f007118,
  NOTE    => "Performance Event Counter 32",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00737_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CNTR33                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00738_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 33" ],
);

%nl4rtr_01_00738_def =
( NAME    => "R4_PORTH_PERF_CNTR33",
  ADDRESS => 0x000000000f007120,
  NOTE    => "Performance Event Counter 33",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00738_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CNTR34                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00739_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 34" ],
);

%nl4rtr_01_00739_def =
( NAME    => "R4_PORTH_PERF_CNTR34",
  ADDRESS => 0x000000000f007128,
  NOTE    => "Performance Event Counter 34",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00739_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CNTR35                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00740_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 35" ],
);

%nl4rtr_01_00740_def =
( NAME    => "R4_PORTH_PERF_CNTR35",
  ADDRESS => 0x000000000f007130,
  NOTE    => "Performance Event Counter 35",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00740_flds
);


##########################################################################
#                                                                        #
#   R4_PORTH_PERF_CNTR36                                                 #
#                                                                        #
##########################################################################

%nl4rtr_01_00741_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT"                          => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Performance Event Counter 36" ],
);

%nl4rtr_01_00741_def =
( NAME    => "R4_PORTH_PERF_CNTR36",
  ADDRESS => 0x000000000f007138,
  NOTE    => "Performance Event Counter 36",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00741_flds
);


##########################################################################
#                                                                        #
#   R4_SCRATCH0                                                          #
#                                                                        #
##########################################################################

%nl4rtr_01_00742_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH_64"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 0" ],
);

%nl4rtr_01_00742_def =
( NAME    => "R4_SCRATCH0",
  ADDRESS => 0x0000000000001000,
  NOTE    => "Scratch Register 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00742_flds
);


##########################################################################
#                                                                        #
#   R4_SCRATCH0_ALIAS                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00743_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH_64"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 0" ],
);

%nl4rtr_01_00743_def =
( NAME    => "R4_SCRATCH0_ALIAS",
  ADDRESS => 0x0000000000001008,
  NOTE    => "Scratch Register 0 Alias Address",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00743_flds
);


##########################################################################
#                                                                        #
#   R4_SCRATCH1                                                          #
#                                                                        #
##########################################################################

%nl4rtr_01_00744_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH_64"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Scratch register 1" ],
);

%nl4rtr_01_00744_def =
( NAME    => "R4_SCRATCH1",
  ADDRESS => 0x0000000000001010,
  NOTE    => "Scratch Register 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00744_flds
);


##########################################################################
#                                                                        #
#   R4_SCRATCH1_ALIAS                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00745_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH_64"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Scratch register 1" ],
);

%nl4rtr_01_00745_def =
( NAME    => "R4_SCRATCH1_ALIAS",
  ADDRESS => 0x0000000000001018,
  NOTE    => "Scratch Register 1 Alias Address",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00745_flds
);


##########################################################################
#                                                                        #
#   R4_SCRATCH2                                                          #
#                                                                        #
##########################################################################

%nl4rtr_01_00746_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH_64"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Scratch register 2" ],
);

%nl4rtr_01_00746_def =
( NAME    => "R4_SCRATCH2",
  ADDRESS => 0x0000000000001020,
  NOTE    => "Scratch Register 2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00746_flds
);


##########################################################################
#                                                                        #
#   R4_SCRATCH2_ALIAS                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00747_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH_64"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Scratch register 2" ],
);

%nl4rtr_01_00747_def =
( NAME    => "R4_SCRATCH2_ALIAS",
  ADDRESS => 0x0000000000001028,
  NOTE    => "Scratch Register 2 Alias Address",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00747_flds
);


##########################################################################
#                                                                        #
#   R4_SCRATCH3                                                          #
#                                                                        #
##########################################################################

%nl4rtr_01_00748_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCRATCH_1"                    => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Scratch register 3" ],
);

%nl4rtr_01_00748_def =
( NAME    => "R4_SCRATCH3",
  ADDRESS => 0x0000000000001030,
  NOTE    => "Scratch Register 3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00748_flds
);


##########################################################################
#                                                                        #
#   R4_SCRATCH3_ALIAS                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00749_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCRATCH_1"                    => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Scratch register 3" ],
);

%nl4rtr_01_00749_def =
( NAME    => "R4_SCRATCH3_ALIAS",
  ADDRESS => 0x0000000000001038,
  NOTE    => "Scratch Register 3 Alias Address",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00749_flds
);


##########################################################################
#                                                                        #
#   R4_SCRATCH4                                                          #
#                                                                        #
##########################################################################

%nl4rtr_01_00750_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCRATCH_1"                    => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Scratch register 4" ],
);

%nl4rtr_01_00750_def =
( NAME    => "R4_SCRATCH4",
  ADDRESS => 0x0000000000001040,
  NOTE    => "Scratch Register 4",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00750_flds
);


##########################################################################
#                                                                        #
#   R4_SCRATCH4_ALIAS                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00751_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCRATCH_1"                    => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Scratch register 4" ],
);

%nl4rtr_01_00751_def =
( NAME    => "R4_SCRATCH4_ALIAS",
  ADDRESS => 0x0000000000001048,
  NOTE    => "Scratch Register 4 Alias Address",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00751_flds
);


##########################################################################
#                                                                        #
#   R4_SCRATCH5                                                          #
#                                                                        #
##########################################################################

%nl4rtr_01_00752_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCRATCH_8"                    => [   1,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Scratch register 5" ],
);

%nl4rtr_01_00752_def =
( NAME    => "R4_SCRATCH5",
  ADDRESS => 0x0000000000001050,
  NOTE    => "Scratch Register 5",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00752_flds
);


##########################################################################
#                                                                        #
#   R4_SCRATCH5_ALIAS                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00753_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCRATCH_8"                    => [   1,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Scratch register 5" ],
);

%nl4rtr_01_00753_def =
( NAME    => "R4_SCRATCH5_ALIAS",
  ADDRESS => 0x0000000000001058,
  NOTE    => "Scratch Register 5 Alias Address",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00753_flds
);


##########################################################################
#                                                                        #
#   R4_SCRATCH6                                                          #
#                                                                        #
##########################################################################

%nl4rtr_01_00754_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCRATCH_8"                    => [   1,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Scratch register 6" ],
);

%nl4rtr_01_00754_def =
( NAME    => "R4_SCRATCH6",
  ADDRESS => 0x0000000000001060,
  NOTE    => "Scratch Register 6",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00754_flds
);


##########################################################################
#                                                                        #
#   R4_SCRATCH6_ALIAS                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00755_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCRATCH_8"                    => [   1,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Scratch register 6" ],
);

%nl4rtr_01_00755_def =
( NAME    => "R4_SCRATCH6_ALIAS",
  ADDRESS => 0x0000000000001068,
  NOTE    => "Scratch Register 6 Alias Address",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00755_flds
);


##########################################################################
#                                                                        #
#   R4_SCRATCH7                                                          #
#                                                                        #
##########################################################################

%nl4rtr_01_00756_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCRATCH_8"                    => [   1,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Scratch register 7" ],
);

%nl4rtr_01_00756_def =
( NAME    => "R4_SCRATCH7",
  ADDRESS => 0x0000000000001070,
  NOTE    => "Scratch Register 7",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00756_flds
);


##########################################################################
#                                                                        #
#   R4_SCRATCH7_ALIAS                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00757_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCRATCH_8"                    => [   1,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Scratch register 7" ],
);

%nl4rtr_01_00757_def =
( NAME    => "R4_SCRATCH7_ALIAS",
  ADDRESS => 0x0000000000001078,
  NOTE    => "Scratch Register 7 Alias Address",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00757_flds
);


##########################################################################
#                                                                        #
#   R4_SCRATCH8                                                          #
#                                                                        #
##########################################################################

%nl4rtr_01_00758_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCRATCH_8"                    => [   1,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Scratch register 8" ],
);

%nl4rtr_01_00758_def =
( NAME    => "R4_SCRATCH8",
  ADDRESS => 0x0000000000001080,
  NOTE    => "Scratch Register 8",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00758_flds
);


##########################################################################
#                                                                        #
#   R4_SCRATCH8_ALIAS                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00759_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCRATCH_8"                    => [   1,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Scratch register 8" ],
);

%nl4rtr_01_00759_def =
( NAME    => "R4_SCRATCH8_ALIAS",
  ADDRESS => 0x0000000000001088,
  NOTE    => "Scratch Register 8 Alias Address",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00759_flds
);


##########################################################################
#                                                                        #
#   R4_SCRATCH9                                                          #
#                                                                        #
##########################################################################

%nl4rtr_01_00760_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCRATCH_8"                    => [   1,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Scratch register 9" ],
);

%nl4rtr_01_00760_def =
( NAME    => "R4_SCRATCH9",
  ADDRESS => 0x0000000000001090,
  NOTE    => "Scratch Register 9",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00760_flds
);


##########################################################################
#                                                                        #
#   R4_SCRATCH9_ALIAS                                                    #
#                                                                        #
##########################################################################

%nl4rtr_01_00761_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCRATCH_8"                    => [   1,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Scratch register 9" ],
);

%nl4rtr_01_00761_def =
( NAME    => "R4_SCRATCH9_ALIAS",
  ADDRESS => 0x0000000000001098,
  NOTE    => "Scratch Register 9 Alias Address",
  RESET   => 0x0000000000000000,
  FIELDS  => \%nl4rtr_01_00761_flds
);


##########################################################################
#                                                                        #
#   MMR LOOKUP TABLES (BY NAME OR ADDRESS)                               #
#                                                                        #
##########################################################################

%nl4rtr_01_mmr_by_name = 
(
   R4_STATUS_REV_ID             => \%nl4rtr_01_00000_def,
   R4_GLOBAL_PARM0              => \%nl4rtr_01_00001_def,
   R4_GLOBAL_PARM1              => \%nl4rtr_01_00002_def,
   R4_ASIC_TO_L1_STATUS         => \%nl4rtr_01_00003_def,
   R4_ASIC_TO_L1_DATA           => \%nl4rtr_01_00004_def,
   R4_L1_TO_ASIC_STATUS         => \%nl4rtr_01_00005_def,
   R4_L1_TO_ASIC_DATA           => \%nl4rtr_01_00006_def,
   R4_LB_DATELINE               => \%nl4rtr_01_00007_def,
   R4_LB_PREAGE                 => \%nl4rtr_01_00008_def,
   R4_PIO_TIME_OUT              => \%nl4rtr_01_00009_def,
   R4_MCAST_TRANS_TABLE_0       => \%nl4rtr_01_00010_def,
   R4_MCAST_TRANS_TABLE_1       => \%nl4rtr_01_00011_def,
   R4_MCAST_TRANS_TABLE_2       => \%nl4rtr_01_00012_def,
   R4_MCAST_TRANS_TABLE_3       => \%nl4rtr_01_00013_def,
   R4_MCAST_TRANS_TABLE_4       => \%nl4rtr_01_00014_def,
   R4_MCAST_TRANS_TABLE_5       => \%nl4rtr_01_00015_def,
   R4_MCAST_TRANS_TABLE_6       => \%nl4rtr_01_00016_def,
   R4_MCAST_TRANS_TABLE_7       => \%nl4rtr_01_00017_def,
   R4_MCAST_TRANS_TABLE_8       => \%nl4rtr_01_00018_def,
   R4_MCAST_TRANS_TABLE_9       => \%nl4rtr_01_00019_def,
   R4_MCAST_TRANS_TABLE_10      => \%nl4rtr_01_00020_def,
   R4_MCAST_TRANS_TABLE_11      => \%nl4rtr_01_00021_def,
   R4_MCAST_TRANS_TABLE_12      => \%nl4rtr_01_00022_def,
   R4_MCAST_TRANS_TABLE_13      => \%nl4rtr_01_00023_def,
   R4_MCAST_TRANS_TABLE_14      => \%nl4rtr_01_00024_def,
   R4_MCAST_TRANS_TABLE_15      => \%nl4rtr_01_00025_def,
   R4_MCAST_DEST_TABLE          => \%nl4rtr_01_00026_def,
   R4_MCAST_REP_GATHER_BUF      => \%nl4rtr_01_00027_def,
   R4_MCAST_GATHER_CONFIG       => \%nl4rtr_01_00028_def,
   R4_MCAST_DEST_VEC_0          => \%nl4rtr_01_00029_def,
   R4_MCAST_DEST_VEC_1          => \%nl4rtr_01_00030_def,
   R4_MCAST_DEST_VEC_2          => \%nl4rtr_01_00031_def,
   R4_MCAST_DEST_VEC_3          => \%nl4rtr_01_00032_def,
   R4_LB_LOCAL_TABLE            => \%nl4rtr_01_00033_def,
   R4_LB_GLOBAL_TABLE           => \%nl4rtr_01_00034_def,
   R4_RTC_SOURCE                => \%nl4rtr_01_00035_def,
   R4_RTC_INTRN_CNTRL           => \%nl4rtr_01_00036_def,
   R4_THROTTLE_INTERVAL         => \%nl4rtr_01_00037_def,
   R4_THROTTLE_TIME             => \%nl4rtr_01_00038_def,
   R4_THROTTLE_STATUS           => \%nl4rtr_01_00039_def,
   R4_THROTTLE_SKIP             => \%nl4rtr_01_00040_def,
   R4_DEBUG_PORT_CONFIG         => \%nl4rtr_01_00041_def,
   R4_VBIT_EMUL                 => \%nl4rtr_01_00042_def,
   R4_PORTA_VC0_N_COUNT_INIT    => \%nl4rtr_01_00043_def,
   R4_PORTA_VC1_N_COUNT_INIT    => \%nl4rtr_01_00044_def,
   R4_PORTA_VC2_N_COUNT_INIT    => \%nl4rtr_01_00045_def,
   R4_PORTA_VC3_N_COUNT_INIT    => \%nl4rtr_01_00046_def,
   R4_PORTB_VC0_N_COUNT_INIT    => \%nl4rtr_01_00047_def,
   R4_PORTB_VC1_N_COUNT_INIT    => \%nl4rtr_01_00048_def,
   R4_PORTB_VC2_N_COUNT_INIT    => \%nl4rtr_01_00049_def,
   R4_PORTB_VC3_N_COUNT_INIT    => \%nl4rtr_01_00050_def,
   R4_PORTC_VC0_N_COUNT_INIT    => \%nl4rtr_01_00051_def,
   R4_PORTC_VC1_N_COUNT_INIT    => \%nl4rtr_01_00052_def,
   R4_PORTC_VC2_N_COUNT_INIT    => \%nl4rtr_01_00053_def,
   R4_PORTC_VC3_N_COUNT_INIT    => \%nl4rtr_01_00054_def,
   R4_PORTD_VC0_N_COUNT_INIT    => \%nl4rtr_01_00055_def,
   R4_PORTD_VC1_N_COUNT_INIT    => \%nl4rtr_01_00056_def,
   R4_PORTD_VC2_N_COUNT_INIT    => \%nl4rtr_01_00057_def,
   R4_PORTD_VC3_N_COUNT_INIT    => \%nl4rtr_01_00058_def,
   R4_PORTE_VC0_N_COUNT_INIT    => \%nl4rtr_01_00059_def,
   R4_PORTE_VC1_N_COUNT_INIT    => \%nl4rtr_01_00060_def,
   R4_PORTE_VC2_N_COUNT_INIT    => \%nl4rtr_01_00061_def,
   R4_PORTE_VC3_N_COUNT_INIT    => \%nl4rtr_01_00062_def,
   R4_PORTF_VC0_N_COUNT_INIT    => \%nl4rtr_01_00063_def,
   R4_PORTF_VC1_N_COUNT_INIT    => \%nl4rtr_01_00064_def,
   R4_PORTF_VC2_N_COUNT_INIT    => \%nl4rtr_01_00065_def,
   R4_PORTF_VC3_N_COUNT_INIT    => \%nl4rtr_01_00066_def,
   R4_PORTG_VC0_N_COUNT_INIT    => \%nl4rtr_01_00067_def,
   R4_PORTG_VC1_N_COUNT_INIT    => \%nl4rtr_01_00068_def,
   R4_PORTG_VC2_N_COUNT_INIT    => \%nl4rtr_01_00069_def,
   R4_PORTG_VC3_N_COUNT_INIT    => \%nl4rtr_01_00070_def,
   R4_PORTH_VC0_N_COUNT_INIT    => \%nl4rtr_01_00071_def,
   R4_PORTH_VC1_N_COUNT_INIT    => \%nl4rtr_01_00072_def,
   R4_PORTH_VC2_N_COUNT_INIT    => \%nl4rtr_01_00073_def,
   R4_PORTH_VC3_N_COUNT_INIT    => \%nl4rtr_01_00074_def,
   R4_PORTLB_ARBL_VC0_N_COUNT_INIT => \%nl4rtr_01_00075_def,
   R4_PORTLB_ARBL_VC1_N_COUNT_INIT => \%nl4rtr_01_00076_def,
   R4_PORTLB_ARBL_VC2_N_COUNT_INIT => \%nl4rtr_01_00077_def,
   R4_PORTLB_ARBL_VC3_N_COUNT_INIT => \%nl4rtr_01_00078_def,
   R4_PORTLB_ARBR_VC0_N_COUNT_INIT => \%nl4rtr_01_00079_def,
   R4_PORTLB_ARBR_VC1_N_COUNT_INIT => \%nl4rtr_01_00080_def,
   R4_PORTLB_ARBR_VC2_N_COUNT_INIT => \%nl4rtr_01_00081_def,
   R4_PORTLB_ARBR_VC3_N_COUNT_INIT => \%nl4rtr_01_00082_def,
   R4_PORTA_D_COUNT_INIT        => \%nl4rtr_01_00083_def,
   R4_PORTB_D_COUNT_INIT        => \%nl4rtr_01_00084_def,
   R4_PORTG_D_COUNT_INIT        => \%nl4rtr_01_00085_def,
   R4_PORTH_D_COUNT_INIT        => \%nl4rtr_01_00086_def,
   R4_PORTLB_ARBL_D_COUNT_INIT  => \%nl4rtr_01_00087_def,
   R4_PORTC_D_COUNT_INIT        => \%nl4rtr_01_00088_def,
   R4_PORTD_D_COUNT_INIT        => \%nl4rtr_01_00089_def,
   R4_PORTE_D_COUNT_INIT        => \%nl4rtr_01_00090_def,
   R4_PORTF_D_COUNT_INIT        => \%nl4rtr_01_00091_def,
   R4_PORTLB_ARBR_D_COUNT_INIT  => \%nl4rtr_01_00092_def,
   R4_AGE_RATE_PORTA            => \%nl4rtr_01_00093_def,
   R4_AGE_RATE_PORTB            => \%nl4rtr_01_00094_def,
   R4_AGE_RATE_PORTC            => \%nl4rtr_01_00095_def,
   R4_AGE_RATE_PORTD            => \%nl4rtr_01_00096_def,
   R4_AGE_RATE_PORTE            => \%nl4rtr_01_00097_def,
   R4_AGE_RATE_PORTF            => \%nl4rtr_01_00098_def,
   R4_AGE_RATE_PORTG            => \%nl4rtr_01_00099_def,
   R4_AGE_RATE_PORTH            => \%nl4rtr_01_00100_def,
   R4_AGE_RATE_PORTLB           => \%nl4rtr_01_00101_def,
   R4_THROTTLE_ENABLE_ARBL      => \%nl4rtr_01_00102_def,
   R4_THROTTLE_ENABLE_ARBR      => \%nl4rtr_01_00103_def,
   R4_PORTA_LOCAL_TABLE         => \%nl4rtr_01_00104_def,
   R4_PORTA_GLOBAL_TABLE        => \%nl4rtr_01_00105_def,
   R4_PORTA_NEIGHBOR_TABLE      => \%nl4rtr_01_00106_def,
   R4_PORTA_PARMS               => \%nl4rtr_01_00107_def,
   R4_PORTA_SPRAY_DIR           => \%nl4rtr_01_00108_def,
   R4_PORTA_SPRAY_CMD_3F_0      => \%nl4rtr_01_00109_def,
   R4_PORTA_SPRAY_CMD_7F_40     => \%nl4rtr_01_00110_def,
   R4_PORTA_SPRAY_CMD_BF_80     => \%nl4rtr_01_00111_def,
   R4_PORTA_SPRAY_CMD_FF_C0     => \%nl4rtr_01_00112_def,
   R4_PORTA_LLP_CONFIG          => \%nl4rtr_01_00113_def,
   R4_PORTA_LLP_TEST_CTL        => \%nl4rtr_01_00114_def,
   R4_PORTA_LLP_STATE           => \%nl4rtr_01_00115_def,
   R4_PORTA_LLP_ERR1            => \%nl4rtr_01_00116_def,
   R4_PORTA_LLP_ERR2            => \%nl4rtr_01_00117_def,
   R4_PORTA_LLP_CAPT_WD1        => \%nl4rtr_01_00118_def,
   R4_PORTA_LLP_CAPT_WD2        => \%nl4rtr_01_00119_def,
   R4_PORTA_LLP_CAPT_SBCB       => \%nl4rtr_01_00120_def,
   R4_PORTA_CREDIT              => \%nl4rtr_01_00121_def,
   R4_PORTA_DEBIT               => \%nl4rtr_01_00122_def,
   R4_PORTA_CREDIT_STATE        => \%nl4rtr_01_00123_def,
   R4_PORTA_LLP_PKT             => \%nl4rtr_01_00124_def,
   R4_PORTB_LOCAL_TABLE         => \%nl4rtr_01_00125_def,
   R4_PORTB_GLOBAL_TABLE        => \%nl4rtr_01_00126_def,
   R4_PORTB_NEIGHBOR_TABLE      => \%nl4rtr_01_00127_def,
   R4_PORTB_PARMS               => \%nl4rtr_01_00128_def,
   R4_PORTB_SPRAY_DIR           => \%nl4rtr_01_00129_def,
   R4_PORTB_SPRAY_CMD_3F_0      => \%nl4rtr_01_00130_def,
   R4_PORTB_SPRAY_CMD_7F_40     => \%nl4rtr_01_00131_def,
   R4_PORTB_SPRAY_CMD_BF_80     => \%nl4rtr_01_00132_def,
   R4_PORTB_SPRAY_CMD_FF_C0     => \%nl4rtr_01_00133_def,
   R4_PORTB_LLP_CONFIG          => \%nl4rtr_01_00134_def,
   R4_PORTB_LLP_TEST_CTL        => \%nl4rtr_01_00135_def,
   R4_PORTB_LLP_STATE           => \%nl4rtr_01_00136_def,
   R4_PORTB_LLP_ERR1            => \%nl4rtr_01_00137_def,
   R4_PORTB_LLP_ERR2            => \%nl4rtr_01_00138_def,
   R4_PORTB_LLP_CAPT_WD1        => \%nl4rtr_01_00139_def,
   R4_PORTB_LLP_CAPT_WD2        => \%nl4rtr_01_00140_def,
   R4_PORTB_LLP_CAPT_SBCB       => \%nl4rtr_01_00141_def,
   R4_PORTB_CREDIT              => \%nl4rtr_01_00142_def,
   R4_PORTB_DEBIT               => \%nl4rtr_01_00143_def,
   R4_PORTB_CREDIT_STATE        => \%nl4rtr_01_00144_def,
   R4_PORTB_LLP_PKT             => \%nl4rtr_01_00145_def,
   R4_PORTC_LOCAL_TABLE         => \%nl4rtr_01_00146_def,
   R4_PORTC_GLOBAL_TABLE        => \%nl4rtr_01_00147_def,
   R4_PORTC_NEIGHBOR_TABLE      => \%nl4rtr_01_00148_def,
   R4_PORTC_PARMS               => \%nl4rtr_01_00149_def,
   R4_PORTC_SPRAY_DIR           => \%nl4rtr_01_00150_def,
   R4_PORTC_SPRAY_CMD_3F_0      => \%nl4rtr_01_00151_def,
   R4_PORTC_SPRAY_CMD_7F_40     => \%nl4rtr_01_00152_def,
   R4_PORTC_SPRAY_CMD_BF_80     => \%nl4rtr_01_00153_def,
   R4_PORTC_SPRAY_CMD_FF_C0     => \%nl4rtr_01_00154_def,
   R4_PORTC_LLP_CONFIG          => \%nl4rtr_01_00155_def,
   R4_PORTC_LLP_TEST_CTL        => \%nl4rtr_01_00156_def,
   R4_PORTC_LLP_STATE           => \%nl4rtr_01_00157_def,
   R4_PORTC_LLP_ERR1            => \%nl4rtr_01_00158_def,
   R4_PORTC_LLP_ERR2            => \%nl4rtr_01_00159_def,
   R4_PORTC_LLP_CAPT_WD1        => \%nl4rtr_01_00160_def,
   R4_PORTC_LLP_CAPT_WD2        => \%nl4rtr_01_00161_def,
   R4_PORTC_LLP_CAPT_SBCB       => \%nl4rtr_01_00162_def,
   R4_PORTC_CREDIT              => \%nl4rtr_01_00163_def,
   R4_PORTC_DEBIT               => \%nl4rtr_01_00164_def,
   R4_PORTC_CREDIT_STATE        => \%nl4rtr_01_00165_def,
   R4_PORTC_LLP_PKT             => \%nl4rtr_01_00166_def,
   R4_PORTD_LOCAL_TABLE         => \%nl4rtr_01_00167_def,
   R4_PORTD_GLOBAL_TABLE        => \%nl4rtr_01_00168_def,
   R4_PORTD_NEIGHBOR_TABLE      => \%nl4rtr_01_00169_def,
   R4_PORTD_PARMS               => \%nl4rtr_01_00170_def,
   R4_PORTD_SPRAY_DIR           => \%nl4rtr_01_00171_def,
   R4_PORTD_SPRAY_CMD_3F_0      => \%nl4rtr_01_00172_def,
   R4_PORTD_SPRAY_CMD_7F_40     => \%nl4rtr_01_00173_def,
   R4_PORTD_SPRAY_CMD_BF_80     => \%nl4rtr_01_00174_def,
   R4_PORTD_SPRAY_CMD_FF_C0     => \%nl4rtr_01_00175_def,
   R4_PORTD_LLP_CONFIG          => \%nl4rtr_01_00176_def,
   R4_PORTD_LLP_TEST_CTL        => \%nl4rtr_01_00177_def,
   R4_PORTD_LLP_STATE           => \%nl4rtr_01_00178_def,
   R4_PORTD_LLP_ERR1            => \%nl4rtr_01_00179_def,
   R4_PORTD_LLP_ERR2            => \%nl4rtr_01_00180_def,
   R4_PORTD_LLP_CAPT_WD1        => \%nl4rtr_01_00181_def,
   R4_PORTD_LLP_CAPT_WD2        => \%nl4rtr_01_00182_def,
   R4_PORTD_LLP_CAPT_SBCB       => \%nl4rtr_01_00183_def,
   R4_PORTD_CREDIT              => \%nl4rtr_01_00184_def,
   R4_PORTD_DEBIT               => \%nl4rtr_01_00185_def,
   R4_PORTD_CREDIT_STATE        => \%nl4rtr_01_00186_def,
   R4_PORTD_LLP_PKT             => \%nl4rtr_01_00187_def,
   R4_PORTE_LOCAL_TABLE         => \%nl4rtr_01_00188_def,
   R4_PORTE_GLOBAL_TABLE        => \%nl4rtr_01_00189_def,
   R4_PORTE_NEIGHBOR_TABLE      => \%nl4rtr_01_00190_def,
   R4_PORTE_PARMS               => \%nl4rtr_01_00191_def,
   R4_PORTE_SPRAY_DIR           => \%nl4rtr_01_00192_def,
   R4_PORTE_SPRAY_CMD_3F_0      => \%nl4rtr_01_00193_def,
   R4_PORTE_SPRAY_CMD_7F_40     => \%nl4rtr_01_00194_def,
   R4_PORTE_SPRAY_CMD_BF_80     => \%nl4rtr_01_00195_def,
   R4_PORTE_SPRAY_CMD_FF_C0     => \%nl4rtr_01_00196_def,
   R4_PORTE_LLP_CONFIG          => \%nl4rtr_01_00197_def,
   R4_PORTE_LLP_TEST_CTL        => \%nl4rtr_01_00198_def,
   R4_PORTE_LLP_STATE           => \%nl4rtr_01_00199_def,
   R4_PORTE_LLP_ERR1            => \%nl4rtr_01_00200_def,
   R4_PORTE_LLP_ERR2            => \%nl4rtr_01_00201_def,
   R4_PORTE_LLP_CAPT_WD1        => \%nl4rtr_01_00202_def,
   R4_PORTE_LLP_CAPT_WD2        => \%nl4rtr_01_00203_def,
   R4_PORTE_LLP_CAPT_SBCB       => \%nl4rtr_01_00204_def,
   R4_PORTE_CREDIT              => \%nl4rtr_01_00205_def,
   R4_PORTE_DEBIT               => \%nl4rtr_01_00206_def,
   R4_PORTE_CREDIT_STATE        => \%nl4rtr_01_00207_def,
   R4_PORTE_LLP_PKT             => \%nl4rtr_01_00208_def,
   R4_PORTF_LOCAL_TABLE         => \%nl4rtr_01_00209_def,
   R4_PORTF_GLOBAL_TABLE        => \%nl4rtr_01_00210_def,
   R4_PORTF_NEIGHBOR_TABLE      => \%nl4rtr_01_00211_def,
   R4_PORTF_PARMS               => \%nl4rtr_01_00212_def,
   R4_PORTF_SPRAY_DIR           => \%nl4rtr_01_00213_def,
   R4_PORTF_SPRAY_CMD_3F_0      => \%nl4rtr_01_00214_def,
   R4_PORTF_SPRAY_CMD_7F_40     => \%nl4rtr_01_00215_def,
   R4_PORTF_SPRAY_CMD_BF_80     => \%nl4rtr_01_00216_def,
   R4_PORTF_SPRAY_CMD_FF_C0     => \%nl4rtr_01_00217_def,
   R4_PORTF_LLP_CONFIG          => \%nl4rtr_01_00218_def,
   R4_PORTF_LLP_TEST_CTL        => \%nl4rtr_01_00219_def,
   R4_PORTF_LLP_STATE           => \%nl4rtr_01_00220_def,
   R4_PORTF_LLP_ERR1            => \%nl4rtr_01_00221_def,
   R4_PORTF_LLP_ERR2            => \%nl4rtr_01_00222_def,
   R4_PORTF_LLP_CAPT_WD1        => \%nl4rtr_01_00223_def,
   R4_PORTF_LLP_CAPT_WD2        => \%nl4rtr_01_00224_def,
   R4_PORTF_LLP_CAPT_SBCB       => \%nl4rtr_01_00225_def,
   R4_PORTF_CREDIT              => \%nl4rtr_01_00226_def,
   R4_PORTF_DEBIT               => \%nl4rtr_01_00227_def,
   R4_PORTF_CREDIT_STATE        => \%nl4rtr_01_00228_def,
   R4_PORTF_LLP_PKT             => \%nl4rtr_01_00229_def,
   R4_PORTG_LOCAL_TABLE         => \%nl4rtr_01_00230_def,
   R4_PORTG_GLOBAL_TABLE        => \%nl4rtr_01_00231_def,
   R4_PORTG_NEIGHBOR_TABLE      => \%nl4rtr_01_00232_def,
   R4_PORTG_PARMS               => \%nl4rtr_01_00233_def,
   R4_PORTG_SPRAY_DIR           => \%nl4rtr_01_00234_def,
   R4_PORTG_SPRAY_CMD_3F_0      => \%nl4rtr_01_00235_def,
   R4_PORTG_SPRAY_CMD_7F_40     => \%nl4rtr_01_00236_def,
   R4_PORTG_SPRAY_CMD_BF_80     => \%nl4rtr_01_00237_def,
   R4_PORTG_SPRAY_CMD_FF_C0     => \%nl4rtr_01_00238_def,
   R4_PORTG_LLP_CONFIG          => \%nl4rtr_01_00239_def,
   R4_PORTG_LLP_TEST_CTL        => \%nl4rtr_01_00240_def,
   R4_PORTG_LLP_STATE           => \%nl4rtr_01_00241_def,
   R4_PORTG_LLP_ERR1            => \%nl4rtr_01_00242_def,
   R4_PORTG_LLP_ERR2            => \%nl4rtr_01_00243_def,
   R4_PORTG_LLP_CAPT_WD1        => \%nl4rtr_01_00244_def,
   R4_PORTG_LLP_CAPT_WD2        => \%nl4rtr_01_00245_def,
   R4_PORTG_LLP_CAPT_SBCB       => \%nl4rtr_01_00246_def,
   R4_PORTG_CREDIT              => \%nl4rtr_01_00247_def,
   R4_PORTG_DEBIT               => \%nl4rtr_01_00248_def,
   R4_PORTG_CREDIT_STATE        => \%nl4rtr_01_00249_def,
   R4_PORTG_LLP_PKT             => \%nl4rtr_01_00250_def,
   R4_PORTH_LOCAL_TABLE         => \%nl4rtr_01_00251_def,
   R4_PORTH_GLOBAL_TABLE        => \%nl4rtr_01_00252_def,
   R4_PORTH_NEIGHBOR_TABLE      => \%nl4rtr_01_00253_def,
   R4_PORTH_PARMS               => \%nl4rtr_01_00254_def,
   R4_PORTH_SPRAY_DIR           => \%nl4rtr_01_00255_def,
   R4_PORTH_SPRAY_CMD_3F_0      => \%nl4rtr_01_00256_def,
   R4_PORTH_SPRAY_CMD_7F_40     => \%nl4rtr_01_00257_def,
   R4_PORTH_SPRAY_CMD_BF_80     => \%nl4rtr_01_00258_def,
   R4_PORTH_SPRAY_CMD_FF_C0     => \%nl4rtr_01_00259_def,
   R4_PORTH_LLP_CONFIG          => \%nl4rtr_01_00260_def,
   R4_PORTH_LLP_TEST_CTL        => \%nl4rtr_01_00261_def,
   R4_PORTH_LLP_STATE           => \%nl4rtr_01_00262_def,
   R4_PORTH_LLP_ERR1            => \%nl4rtr_01_00263_def,
   R4_PORTH_LLP_ERR2            => \%nl4rtr_01_00264_def,
   R4_PORTH_LLP_CAPT_WD1        => \%nl4rtr_01_00265_def,
   R4_PORTH_LLP_CAPT_WD2        => \%nl4rtr_01_00266_def,
   R4_PORTH_LLP_CAPT_SBCB       => \%nl4rtr_01_00267_def,
   R4_PORTH_CREDIT              => \%nl4rtr_01_00268_def,
   R4_PORTH_DEBIT               => \%nl4rtr_01_00269_def,
   R4_PORTH_CREDIT_STATE        => \%nl4rtr_01_00270_def,
   R4_PORTH_LLP_PKT             => \%nl4rtr_01_00271_def,
   R4_HARD_RESET                => \%nl4rtr_01_00272_def,
   R4_SOFT_RESET                => \%nl4rtr_01_00273_def,
   R4_PORT_RESET                => \%nl4rtr_01_00274_def,
   R4_PROTECTION_CONFIG         => \%nl4rtr_01_00275_def,
   R4_PORTA_RST_MASK            => \%nl4rtr_01_00276_def,
   R4_PORTB_RST_MASK            => \%nl4rtr_01_00277_def,
   R4_PORTC_RST_MASK            => \%nl4rtr_01_00278_def,
   R4_PORTD_RST_MASK            => \%nl4rtr_01_00279_def,
   R4_PORTE_RST_MASK            => \%nl4rtr_01_00280_def,
   R4_PORTF_RST_MASK            => \%nl4rtr_01_00281_def,
   R4_PORTG_RST_MASK            => \%nl4rtr_01_00282_def,
   R4_PORTH_RST_MASK            => \%nl4rtr_01_00283_def,
   R4_PORTA_ERROR_SUMMARY       => \%nl4rtr_01_00284_def,
   R4_PORTA_ERROR_CLEAR         => \%nl4rtr_01_00285_def,
   R4_PORTA_FIRST_ERROR         => \%nl4rtr_01_00286_def,
   R4_PORTA_ERROR_REPORT_MASK   => \%nl4rtr_01_00287_def,
   R4_PORTA_ERROR_DETAIL        => \%nl4rtr_01_00288_def,
   R4_PORTA_ERROR_DETAIL_CLEAR  => \%nl4rtr_01_00289_def,
   R4_PORTB_ERROR_SUMMARY       => \%nl4rtr_01_00290_def,
   R4_PORTB_ERROR_CLEAR         => \%nl4rtr_01_00291_def,
   R4_PORTB_FIRST_ERROR         => \%nl4rtr_01_00292_def,
   R4_PORTB_ERROR_REPORT_MASK   => \%nl4rtr_01_00293_def,
   R4_PORTB_ERROR_DETAIL        => \%nl4rtr_01_00294_def,
   R4_PORTB_ERROR_DETAIL_CLEAR  => \%nl4rtr_01_00295_def,
   R4_PORTC_ERROR_SUMMARY       => \%nl4rtr_01_00296_def,
   R4_PORTC_ERROR_CLEAR         => \%nl4rtr_01_00297_def,
   R4_PORTC_FIRST_ERROR         => \%nl4rtr_01_00298_def,
   R4_PORTC_ERROR_REPORT_MASK   => \%nl4rtr_01_00299_def,
   R4_PORTC_ERROR_DETAIL        => \%nl4rtr_01_00300_def,
   R4_PORTC_ERROR_DETAIL_CLEAR  => \%nl4rtr_01_00301_def,
   R4_PORTD_ERROR_SUMMARY       => \%nl4rtr_01_00302_def,
   R4_PORTD_ERROR_CLEAR         => \%nl4rtr_01_00303_def,
   R4_PORTD_FIRST_ERROR         => \%nl4rtr_01_00304_def,
   R4_PORTD_ERROR_REPORT_MASK   => \%nl4rtr_01_00305_def,
   R4_PORTD_ERROR_DETAIL        => \%nl4rtr_01_00306_def,
   R4_PORTD_ERROR_DETAIL_CLEAR  => \%nl4rtr_01_00307_def,
   R4_PORTE_ERROR_SUMMARY       => \%nl4rtr_01_00308_def,
   R4_PORTE_ERROR_CLEAR         => \%nl4rtr_01_00309_def,
   R4_PORTE_FIRST_ERROR         => \%nl4rtr_01_00310_def,
   R4_PORTE_ERROR_REPORT_MASK   => \%nl4rtr_01_00311_def,
   R4_PORTE_ERROR_DETAIL        => \%nl4rtr_01_00312_def,
   R4_PORTE_ERROR_DETAIL_CLEAR  => \%nl4rtr_01_00313_def,
   R4_PORTF_ERROR_SUMMARY       => \%nl4rtr_01_00314_def,
   R4_PORTF_ERROR_CLEAR         => \%nl4rtr_01_00315_def,
   R4_PORTF_FIRST_ERROR         => \%nl4rtr_01_00316_def,
   R4_PORTF_ERROR_REPORT_MASK   => \%nl4rtr_01_00317_def,
   R4_PORTF_ERROR_DETAIL        => \%nl4rtr_01_00318_def,
   R4_PORTF_ERROR_DETAIL_CLEAR  => \%nl4rtr_01_00319_def,
   R4_PORTG_ERROR_SUMMARY       => \%nl4rtr_01_00320_def,
   R4_PORTG_ERROR_CLEAR         => \%nl4rtr_01_00321_def,
   R4_PORTG_FIRST_ERROR         => \%nl4rtr_01_00322_def,
   R4_PORTG_ERROR_REPORT_MASK   => \%nl4rtr_01_00323_def,
   R4_PORTG_ERROR_DETAIL        => \%nl4rtr_01_00324_def,
   R4_PORTG_ERROR_DETAIL_CLEAR  => \%nl4rtr_01_00325_def,
   R4_PORTH_ERROR_SUMMARY       => \%nl4rtr_01_00326_def,
   R4_PORTH_ERROR_CLEAR         => \%nl4rtr_01_00327_def,
   R4_PORTH_FIRST_ERROR         => \%nl4rtr_01_00328_def,
   R4_PORTH_ERROR_REPORT_MASK   => \%nl4rtr_01_00329_def,
   R4_PORTH_ERROR_DETAIL        => \%nl4rtr_01_00330_def,
   R4_PORTH_ERROR_DETAIL_CLEAR  => \%nl4rtr_01_00331_def,
   R4_ASIC_FIRST_ERROR          => \%nl4rtr_01_00332_def,
   R4_ASIC_FIRST_ERROR_TIMESTAMP => \%nl4rtr_01_00333_def,
   R4_LB_ERROR_SUMMARY          => \%nl4rtr_01_00334_def,
   R4_LB_ERROR_CLEAR            => \%nl4rtr_01_00335_def,
   R4_LB_FIRST_ERROR            => \%nl4rtr_01_00336_def,
   R4_LB_ERROR_REPORT_MASK      => \%nl4rtr_01_00337_def,
   R4_LB_ERROR_DETAIL_1         => \%nl4rtr_01_00338_def,
   R4_LB_ERROR_DETAIL_2         => \%nl4rtr_01_00339_def,
   R4_PORT_PERF_WIN             => \%nl4rtr_01_00340_def,
   R4_TSF_ARM_MASK              => \%nl4rtr_01_00341_def,
   R4_TSF_COUNTER_PRESETS       => \%nl4rtr_01_00342_def,
   R4_TSF_DECREMENT_CTL         => \%nl4rtr_01_00343_def,
   R4_TSF_DIAG_MSG_CTL          => \%nl4rtr_01_00344_def,
   R4_TSF_DISARM_MASK           => \%nl4rtr_01_00345_def,
   R4_TSF_ENABLE_CTL            => \%nl4rtr_01_00346_def,
   R4_TSF_SOFTWARE_ARM          => \%nl4rtr_01_00347_def,
   R4_TSF_SOFTWARE_DISARM       => \%nl4rtr_01_00348_def,
   R4_TSF_SOFTWARE_TRIGGERED    => \%nl4rtr_01_00349_def,
   R4_TSF_TRIGGER_MASK          => \%nl4rtr_01_00350_def,
   R4_TSF_ARMED_STATE           => \%nl4rtr_01_00351_def,
   R4_TSF_COUNTER_VALUE         => \%nl4rtr_01_00352_def,
   R4_TSF_TRIGGERED_STATE       => \%nl4rtr_01_00353_def,
   R4_ROOT_TEST_POINT_SELECT    => \%nl4rtr_01_00354_def,
   R4_ROOT_TEST_POINT_COMPARE   => \%nl4rtr_01_00355_def,
   R4_ROOT_TEST_POINT_TRIGGER_SELECT => \%nl4rtr_01_00356_def,
   R4_BRANCH1_TEST_POINT_SELECT => \%nl4rtr_01_00357_def,
   R4_BRANCH1_TEST_POINT_COMPARE => \%nl4rtr_01_00358_def,
   R4_BRANCH1_TEST_POINT_TRIGGER_SELECT => \%nl4rtr_01_00359_def,
   R4_BRANCH2_TEST_POINT_SELECT => \%nl4rtr_01_00360_def,
   R4_BRANCH2_TEST_POINT_COMPARE => \%nl4rtr_01_00361_def,
   R4_BRANCH2_TEST_POINT_TRIGGER_SELECT => \%nl4rtr_01_00362_def,
   R4_BRANCH1_DEBUG_DATA        => \%nl4rtr_01_00363_def,
   R4_BRANCH2_DEBUG_DATA        => \%nl4rtr_01_00364_def,
   R4_ROOT_DEBUG_DATA           => \%nl4rtr_01_00365_def,
   R4_STOP_CLK_CONTROL          => \%nl4rtr_01_00366_def,
   R4_STOP_CLK_DELAY_PHASE      => \%nl4rtr_01_00367_def,
   R4_PERFORMANCE_COUNT0_CONTROL => \%nl4rtr_01_00368_def,
   R4_PERFORMANCE_COUNT1_CONTROL => \%nl4rtr_01_00369_def,
   R4_PERFORMANCE_COUNT2_CONTROL => \%nl4rtr_01_00370_def,
   R4_PERFORMANCE_COUNT3_CONTROL => \%nl4rtr_01_00371_def,
   R4_PERFORMANCE_COUNT4_CONTROL => \%nl4rtr_01_00372_def,
   R4_PERFORMANCE_COUNT5_CONTROL => \%nl4rtr_01_00373_def,
   R4_PERFORMANCE_COUNT6_CONTROL => \%nl4rtr_01_00374_def,
   R4_PERFORMANCE_COUNT7_CONTROL => \%nl4rtr_01_00375_def,
   R4_PROFILE_DN_CONTROL        => \%nl4rtr_01_00376_def,
   R4_PROFILE_PEAK_CONTROL      => \%nl4rtr_01_00377_def,
   R4_PROFILE_RANGE             => \%nl4rtr_01_00378_def,
   R4_PROFILE_UP_CONTROL        => \%nl4rtr_01_00379_def,
   R4_PERF_TRIG_PATTERN_0       => \%nl4rtr_01_00380_def,
   R4_PERF_TRIG_PATTERN_1       => \%nl4rtr_01_00381_def,
   R4_PERF_TRIG_PATTERN_2       => \%nl4rtr_01_00382_def,
   R4_PERF_TRIG_PATTERN_3       => \%nl4rtr_01_00383_def,
   R4_PERF_TRIG_PATTERN_4       => \%nl4rtr_01_00384_def,
   R4_PERF_TRIG_PATTERN_5       => \%nl4rtr_01_00385_def,
   R4_PERF_TRIG_PATTERN_6       => \%nl4rtr_01_00386_def,
   R4_PERF_TRIG_PATTERN_7       => \%nl4rtr_01_00387_def,
   R4_PERF_TRIG_PATTERN_8       => \%nl4rtr_01_00388_def,
   R4_PERF_TRIG_PATTERN_9       => \%nl4rtr_01_00389_def,
   R4_PERF_TRIG_PATTERN_10      => \%nl4rtr_01_00390_def,
   R4_PERF_TRIG_PATTERN_11      => \%nl4rtr_01_00391_def,
   R4_PERF_TRIG_PATTERN_12      => \%nl4rtr_01_00392_def,
   R4_PERF_TRIG_PATTERN_13      => \%nl4rtr_01_00393_def,
   R4_PERF_TRIG_PATTERN_14      => \%nl4rtr_01_00394_def,
   R4_PERF_TRIG_PATTERN_15      => \%nl4rtr_01_00395_def,
   R4_PERFORMANCE_COUNTER0      => \%nl4rtr_01_00396_def,
   R4_PERFORMANCE_COUNTER1      => \%nl4rtr_01_00397_def,
   R4_PERFORMANCE_COUNTER2      => \%nl4rtr_01_00398_def,
   R4_PERFORMANCE_COUNTER3      => \%nl4rtr_01_00399_def,
   R4_PERFORMANCE_COUNTER4      => \%nl4rtr_01_00400_def,
   R4_PERFORMANCE_COUNTER5      => \%nl4rtr_01_00401_def,
   R4_PERFORMANCE_COUNTER6      => \%nl4rtr_01_00402_def,
   R4_PERFORMANCE_COUNTER7      => \%nl4rtr_01_00403_def,
   R4_PROFILE_COUNTER           => \%nl4rtr_01_00404_def,
   R4_PROFILE_PEAK              => \%nl4rtr_01_00405_def,
   R4_LB0_TEST_POINT_SELECT_512 => \%nl4rtr_01_00406_def,
   R4_LB1_TEST_POINT_SELECT_512 => \%nl4rtr_01_00407_def,
   R4_ARBL_TEST_POINT_SELECT_512 => \%nl4rtr_01_00408_def,
   R4_ARBR_TEST_POINT_SELECT_512 => \%nl4rtr_01_00409_def,
   R4_CDQ0_TEST_POINT_SELECT_512 => \%nl4rtr_01_00410_def,
   R4_CDQ1_TEST_POINT_SELECT_512 => \%nl4rtr_01_00411_def,
   R4_CDQ2_TEST_POINT_SELECT_512 => \%nl4rtr_01_00412_def,
   R4_CDQ3_TEST_POINT_SELECT_512 => \%nl4rtr_01_00413_def,
   R4_PORTA_TEST_POINT_SELECT_512 => \%nl4rtr_01_00414_def,
   R4_PORTB_TEST_POINT_SELECT_512 => \%nl4rtr_01_00415_def,
   R4_PORTC_TEST_POINT_SELECT_512 => \%nl4rtr_01_00416_def,
   R4_PORTD_TEST_POINT_SELECT_512 => \%nl4rtr_01_00417_def,
   R4_PORTE_TEST_POINT_SELECT_512 => \%nl4rtr_01_00418_def,
   R4_PORTF_TEST_POINT_SELECT_512 => \%nl4rtr_01_00419_def,
   R4_PORTG_TEST_POINT_SELECT_512 => \%nl4rtr_01_00420_def,
   R4_PORTH_TEST_POINT_SELECT_512 => \%nl4rtr_01_00421_def,
   R4_PORTA_PERF_CONFIG         => \%nl4rtr_01_00422_def,
   R4_PORTA_PERF_CMD_LO         => \%nl4rtr_01_00423_def,
   R4_PORTA_PERF_CMD_UP         => \%nl4rtr_01_00424_def,
   R4_PORTA_PERF_CNTR0          => \%nl4rtr_01_00425_def,
   R4_PORTA_PERF_CNTR1          => \%nl4rtr_01_00426_def,
   R4_PORTA_PERF_CNTR2          => \%nl4rtr_01_00427_def,
   R4_PORTA_PERF_CNTR3          => \%nl4rtr_01_00428_def,
   R4_PORTA_PERF_CNTR4          => \%nl4rtr_01_00429_def,
   R4_PORTA_PERF_CNTR5          => \%nl4rtr_01_00430_def,
   R4_PORTA_PERF_CNTR6          => \%nl4rtr_01_00431_def,
   R4_PORTA_PERF_CNTR7          => \%nl4rtr_01_00432_def,
   R4_PORTA_PERF_CNTR8          => \%nl4rtr_01_00433_def,
   R4_PORTA_PERF_CNTR9          => \%nl4rtr_01_00434_def,
   R4_PORTA_PERF_CNTR10         => \%nl4rtr_01_00435_def,
   R4_PORTA_PERF_CNTR11         => \%nl4rtr_01_00436_def,
   R4_PORTA_PERF_CNTR12         => \%nl4rtr_01_00437_def,
   R4_PORTA_PERF_CNTR13         => \%nl4rtr_01_00438_def,
   R4_PORTA_PERF_CNTR14         => \%nl4rtr_01_00439_def,
   R4_PORTA_PERF_CNTR15         => \%nl4rtr_01_00440_def,
   R4_PORTA_PERF_CNTR16         => \%nl4rtr_01_00441_def,
   R4_PORTA_PERF_CNTR17         => \%nl4rtr_01_00442_def,
   R4_PORTA_PERF_CNTR18         => \%nl4rtr_01_00443_def,
   R4_PORTA_PERF_CNTR19         => \%nl4rtr_01_00444_def,
   R4_PORTA_PERF_CNTR20         => \%nl4rtr_01_00445_def,
   R4_PORTA_PERF_CNTR21         => \%nl4rtr_01_00446_def,
   R4_PORTA_PERF_CNTR22         => \%nl4rtr_01_00447_def,
   R4_PORTA_PERF_CNTR23         => \%nl4rtr_01_00448_def,
   R4_PORTA_PERF_CNTR24         => \%nl4rtr_01_00449_def,
   R4_PORTA_PERF_CNTR25         => \%nl4rtr_01_00450_def,
   R4_PORTA_PERF_CNTR26         => \%nl4rtr_01_00451_def,
   R4_PORTA_PERF_CNTR27         => \%nl4rtr_01_00452_def,
   R4_PORTA_PERF_CNTR28         => \%nl4rtr_01_00453_def,
   R4_PORTA_PERF_CNTR29         => \%nl4rtr_01_00454_def,
   R4_PORTA_PERF_CNTR30         => \%nl4rtr_01_00455_def,
   R4_PORTA_PERF_CNTR31         => \%nl4rtr_01_00456_def,
   R4_PORTA_PERF_CNTR32         => \%nl4rtr_01_00457_def,
   R4_PORTA_PERF_CNTR33         => \%nl4rtr_01_00458_def,
   R4_PORTA_PERF_CNTR34         => \%nl4rtr_01_00459_def,
   R4_PORTA_PERF_CNTR35         => \%nl4rtr_01_00460_def,
   R4_PORTA_PERF_CNTR36         => \%nl4rtr_01_00461_def,
   R4_PORTB_PERF_CONFIG         => \%nl4rtr_01_00462_def,
   R4_PORTB_PERF_CMD_LO         => \%nl4rtr_01_00463_def,
   R4_PORTB_PERF_CMD_UP         => \%nl4rtr_01_00464_def,
   R4_PORTB_PERF_CNTR0          => \%nl4rtr_01_00465_def,
   R4_PORTB_PERF_CNTR1          => \%nl4rtr_01_00466_def,
   R4_PORTB_PERF_CNTR2          => \%nl4rtr_01_00467_def,
   R4_PORTB_PERF_CNTR3          => \%nl4rtr_01_00468_def,
   R4_PORTB_PERF_CNTR4          => \%nl4rtr_01_00469_def,
   R4_PORTB_PERF_CNTR5          => \%nl4rtr_01_00470_def,
   R4_PORTB_PERF_CNTR6          => \%nl4rtr_01_00471_def,
   R4_PORTB_PERF_CNTR7          => \%nl4rtr_01_00472_def,
   R4_PORTB_PERF_CNTR8          => \%nl4rtr_01_00473_def,
   R4_PORTB_PERF_CNTR9          => \%nl4rtr_01_00474_def,
   R4_PORTB_PERF_CNTR10         => \%nl4rtr_01_00475_def,
   R4_PORTB_PERF_CNTR11         => \%nl4rtr_01_00476_def,
   R4_PORTB_PERF_CNTR12         => \%nl4rtr_01_00477_def,
   R4_PORTB_PERF_CNTR13         => \%nl4rtr_01_00478_def,
   R4_PORTB_PERF_CNTR14         => \%nl4rtr_01_00479_def,
   R4_PORTB_PERF_CNTR15         => \%nl4rtr_01_00480_def,
   R4_PORTB_PERF_CNTR16         => \%nl4rtr_01_00481_def,
   R4_PORTB_PERF_CNTR17         => \%nl4rtr_01_00482_def,
   R4_PORTB_PERF_CNTR18         => \%nl4rtr_01_00483_def,
   R4_PORTB_PERF_CNTR19         => \%nl4rtr_01_00484_def,
   R4_PORTB_PERF_CNTR20         => \%nl4rtr_01_00485_def,
   R4_PORTB_PERF_CNTR21         => \%nl4rtr_01_00486_def,
   R4_PORTB_PERF_CNTR22         => \%nl4rtr_01_00487_def,
   R4_PORTB_PERF_CNTR23         => \%nl4rtr_01_00488_def,
   R4_PORTB_PERF_CNTR24         => \%nl4rtr_01_00489_def,
   R4_PORTB_PERF_CNTR25         => \%nl4rtr_01_00490_def,
   R4_PORTB_PERF_CNTR26         => \%nl4rtr_01_00491_def,
   R4_PORTB_PERF_CNTR27         => \%nl4rtr_01_00492_def,
   R4_PORTB_PERF_CNTR28         => \%nl4rtr_01_00493_def,
   R4_PORTB_PERF_CNTR29         => \%nl4rtr_01_00494_def,
   R4_PORTB_PERF_CNTR30         => \%nl4rtr_01_00495_def,
   R4_PORTB_PERF_CNTR31         => \%nl4rtr_01_00496_def,
   R4_PORTB_PERF_CNTR32         => \%nl4rtr_01_00497_def,
   R4_PORTB_PERF_CNTR33         => \%nl4rtr_01_00498_def,
   R4_PORTB_PERF_CNTR34         => \%nl4rtr_01_00499_def,
   R4_PORTB_PERF_CNTR35         => \%nl4rtr_01_00500_def,
   R4_PORTB_PERF_CNTR36         => \%nl4rtr_01_00501_def,
   R4_PORTC_PERF_CONFIG         => \%nl4rtr_01_00502_def,
   R4_PORTC_PERF_CMD_LO         => \%nl4rtr_01_00503_def,
   R4_PORTC_PERF_CMD_UP         => \%nl4rtr_01_00504_def,
   R4_PORTC_PERF_CNTR0          => \%nl4rtr_01_00505_def,
   R4_PORTC_PERF_CNTR1          => \%nl4rtr_01_00506_def,
   R4_PORTC_PERF_CNTR2          => \%nl4rtr_01_00507_def,
   R4_PORTC_PERF_CNTR3          => \%nl4rtr_01_00508_def,
   R4_PORTC_PERF_CNTR4          => \%nl4rtr_01_00509_def,
   R4_PORTC_PERF_CNTR5          => \%nl4rtr_01_00510_def,
   R4_PORTC_PERF_CNTR6          => \%nl4rtr_01_00511_def,
   R4_PORTC_PERF_CNTR7          => \%nl4rtr_01_00512_def,
   R4_PORTC_PERF_CNTR8          => \%nl4rtr_01_00513_def,
   R4_PORTC_PERF_CNTR9          => \%nl4rtr_01_00514_def,
   R4_PORTC_PERF_CNTR10         => \%nl4rtr_01_00515_def,
   R4_PORTC_PERF_CNTR11         => \%nl4rtr_01_00516_def,
   R4_PORTC_PERF_CNTR12         => \%nl4rtr_01_00517_def,
   R4_PORTC_PERF_CNTR13         => \%nl4rtr_01_00518_def,
   R4_PORTC_PERF_CNTR14         => \%nl4rtr_01_00519_def,
   R4_PORTC_PERF_CNTR15         => \%nl4rtr_01_00520_def,
   R4_PORTC_PERF_CNTR16         => \%nl4rtr_01_00521_def,
   R4_PORTC_PERF_CNTR17         => \%nl4rtr_01_00522_def,
   R4_PORTC_PERF_CNTR18         => \%nl4rtr_01_00523_def,
   R4_PORTC_PERF_CNTR19         => \%nl4rtr_01_00524_def,
   R4_PORTC_PERF_CNTR20         => \%nl4rtr_01_00525_def,
   R4_PORTC_PERF_CNTR21         => \%nl4rtr_01_00526_def,
   R4_PORTC_PERF_CNTR22         => \%nl4rtr_01_00527_def,
   R4_PORTC_PERF_CNTR23         => \%nl4rtr_01_00528_def,
   R4_PORTC_PERF_CNTR24         => \%nl4rtr_01_00529_def,
   R4_PORTC_PERF_CNTR25         => \%nl4rtr_01_00530_def,
   R4_PORTC_PERF_CNTR26         => \%nl4rtr_01_00531_def,
   R4_PORTC_PERF_CNTR27         => \%nl4rtr_01_00532_def,
   R4_PORTC_PERF_CNTR28         => \%nl4rtr_01_00533_def,
   R4_PORTC_PERF_CNTR29         => \%nl4rtr_01_00534_def,
   R4_PORTC_PERF_CNTR30         => \%nl4rtr_01_00535_def,
   R4_PORTC_PERF_CNTR31         => \%nl4rtr_01_00536_def,
   R4_PORTC_PERF_CNTR32         => \%nl4rtr_01_00537_def,
   R4_PORTC_PERF_CNTR33         => \%nl4rtr_01_00538_def,
   R4_PORTC_PERF_CNTR34         => \%nl4rtr_01_00539_def,
   R4_PORTC_PERF_CNTR35         => \%nl4rtr_01_00540_def,
   R4_PORTC_PERF_CNTR36         => \%nl4rtr_01_00541_def,
   R4_PORTD_PERF_CONFIG         => \%nl4rtr_01_00542_def,
   R4_PORTD_PERF_CMD_LO         => \%nl4rtr_01_00543_def,
   R4_PORTD_PERF_CMD_UP         => \%nl4rtr_01_00544_def,
   R4_PORTD_PERF_CNTR0          => \%nl4rtr_01_00545_def,
   R4_PORTD_PERF_CNTR1          => \%nl4rtr_01_00546_def,
   R4_PORTD_PERF_CNTR2          => \%nl4rtr_01_00547_def,
   R4_PORTD_PERF_CNTR3          => \%nl4rtr_01_00548_def,
   R4_PORTD_PERF_CNTR4          => \%nl4rtr_01_00549_def,
   R4_PORTD_PERF_CNTR5          => \%nl4rtr_01_00550_def,
   R4_PORTD_PERF_CNTR6          => \%nl4rtr_01_00551_def,
   R4_PORTD_PERF_CNTR7          => \%nl4rtr_01_00552_def,
   R4_PORTD_PERF_CNTR8          => \%nl4rtr_01_00553_def,
   R4_PORTD_PERF_CNTR9          => \%nl4rtr_01_00554_def,
   R4_PORTD_PERF_CNTR10         => \%nl4rtr_01_00555_def,
   R4_PORTD_PERF_CNTR11         => \%nl4rtr_01_00556_def,
   R4_PORTD_PERF_CNTR12         => \%nl4rtr_01_00557_def,
   R4_PORTD_PERF_CNTR13         => \%nl4rtr_01_00558_def,
   R4_PORTD_PERF_CNTR14         => \%nl4rtr_01_00559_def,
   R4_PORTD_PERF_CNTR15         => \%nl4rtr_01_00560_def,
   R4_PORTD_PERF_CNTR16         => \%nl4rtr_01_00561_def,
   R4_PORTD_PERF_CNTR17         => \%nl4rtr_01_00562_def,
   R4_PORTD_PERF_CNTR18         => \%nl4rtr_01_00563_def,
   R4_PORTD_PERF_CNTR19         => \%nl4rtr_01_00564_def,
   R4_PORTD_PERF_CNTR20         => \%nl4rtr_01_00565_def,
   R4_PORTD_PERF_CNTR21         => \%nl4rtr_01_00566_def,
   R4_PORTD_PERF_CNTR22         => \%nl4rtr_01_00567_def,
   R4_PORTD_PERF_CNTR23         => \%nl4rtr_01_00568_def,
   R4_PORTD_PERF_CNTR24         => \%nl4rtr_01_00569_def,
   R4_PORTD_PERF_CNTR25         => \%nl4rtr_01_00570_def,
   R4_PORTD_PERF_CNTR26         => \%nl4rtr_01_00571_def,
   R4_PORTD_PERF_CNTR27         => \%nl4rtr_01_00572_def,
   R4_PORTD_PERF_CNTR28         => \%nl4rtr_01_00573_def,
   R4_PORTD_PERF_CNTR29         => \%nl4rtr_01_00574_def,
   R4_PORTD_PERF_CNTR30         => \%nl4rtr_01_00575_def,
   R4_PORTD_PERF_CNTR31         => \%nl4rtr_01_00576_def,
   R4_PORTD_PERF_CNTR32         => \%nl4rtr_01_00577_def,
   R4_PORTD_PERF_CNTR33         => \%nl4rtr_01_00578_def,
   R4_PORTD_PERF_CNTR34         => \%nl4rtr_01_00579_def,
   R4_PORTD_PERF_CNTR35         => \%nl4rtr_01_00580_def,
   R4_PORTD_PERF_CNTR36         => \%nl4rtr_01_00581_def,
   R4_PORTE_PERF_CONFIG         => \%nl4rtr_01_00582_def,
   R4_PORTE_PERF_CMD_LO         => \%nl4rtr_01_00583_def,
   R4_PORTE_PERF_CMD_UP         => \%nl4rtr_01_00584_def,
   R4_PORTE_PERF_CNTR0          => \%nl4rtr_01_00585_def,
   R4_PORTE_PERF_CNTR1          => \%nl4rtr_01_00586_def,
   R4_PORTE_PERF_CNTR2          => \%nl4rtr_01_00587_def,
   R4_PORTE_PERF_CNTR3          => \%nl4rtr_01_00588_def,
   R4_PORTE_PERF_CNTR4          => \%nl4rtr_01_00589_def,
   R4_PORTE_PERF_CNTR5          => \%nl4rtr_01_00590_def,
   R4_PORTE_PERF_CNTR6          => \%nl4rtr_01_00591_def,
   R4_PORTE_PERF_CNTR7          => \%nl4rtr_01_00592_def,
   R4_PORTE_PERF_CNTR8          => \%nl4rtr_01_00593_def,
   R4_PORTE_PERF_CNTR9          => \%nl4rtr_01_00594_def,
   R4_PORTE_PERF_CNTR10         => \%nl4rtr_01_00595_def,
   R4_PORTE_PERF_CNTR11         => \%nl4rtr_01_00596_def,
   R4_PORTE_PERF_CNTR12         => \%nl4rtr_01_00597_def,
   R4_PORTE_PERF_CNTR13         => \%nl4rtr_01_00598_def,
   R4_PORTE_PERF_CNTR14         => \%nl4rtr_01_00599_def,
   R4_PORTE_PERF_CNTR15         => \%nl4rtr_01_00600_def,
   R4_PORTE_PERF_CNTR16         => \%nl4rtr_01_00601_def,
   R4_PORTE_PERF_CNTR17         => \%nl4rtr_01_00602_def,
   R4_PORTE_PERF_CNTR18         => \%nl4rtr_01_00603_def,
   R4_PORTE_PERF_CNTR19         => \%nl4rtr_01_00604_def,
   R4_PORTE_PERF_CNTR20         => \%nl4rtr_01_00605_def,
   R4_PORTE_PERF_CNTR21         => \%nl4rtr_01_00606_def,
   R4_PORTE_PERF_CNTR22         => \%nl4rtr_01_00607_def,
   R4_PORTE_PERF_CNTR23         => \%nl4rtr_01_00608_def,
   R4_PORTE_PERF_CNTR24         => \%nl4rtr_01_00609_def,
   R4_PORTE_PERF_CNTR25         => \%nl4rtr_01_00610_def,
   R4_PORTE_PERF_CNTR26         => \%nl4rtr_01_00611_def,
   R4_PORTE_PERF_CNTR27         => \%nl4rtr_01_00612_def,
   R4_PORTE_PERF_CNTR28         => \%nl4rtr_01_00613_def,
   R4_PORTE_PERF_CNTR29         => \%nl4rtr_01_00614_def,
   R4_PORTE_PERF_CNTR30         => \%nl4rtr_01_00615_def,
   R4_PORTE_PERF_CNTR31         => \%nl4rtr_01_00616_def,
   R4_PORTE_PERF_CNTR32         => \%nl4rtr_01_00617_def,
   R4_PORTE_PERF_CNTR33         => \%nl4rtr_01_00618_def,
   R4_PORTE_PERF_CNTR34         => \%nl4rtr_01_00619_def,
   R4_PORTE_PERF_CNTR35         => \%nl4rtr_01_00620_def,
   R4_PORTE_PERF_CNTR36         => \%nl4rtr_01_00621_def,
   R4_PORTF_PERF_CONFIG         => \%nl4rtr_01_00622_def,
   R4_PORTF_PERF_CMD_LO         => \%nl4rtr_01_00623_def,
   R4_PORTF_PERF_CMD_UP         => \%nl4rtr_01_00624_def,
   R4_PORTF_PERF_CNTR0          => \%nl4rtr_01_00625_def,
   R4_PORTF_PERF_CNTR1          => \%nl4rtr_01_00626_def,
   R4_PORTF_PERF_CNTR2          => \%nl4rtr_01_00627_def,
   R4_PORTF_PERF_CNTR3          => \%nl4rtr_01_00628_def,
   R4_PORTF_PERF_CNTR4          => \%nl4rtr_01_00629_def,
   R4_PORTF_PERF_CNTR5          => \%nl4rtr_01_00630_def,
   R4_PORTF_PERF_CNTR6          => \%nl4rtr_01_00631_def,
   R4_PORTF_PERF_CNTR7          => \%nl4rtr_01_00632_def,
   R4_PORTF_PERF_CNTR8          => \%nl4rtr_01_00633_def,
   R4_PORTF_PERF_CNTR9          => \%nl4rtr_01_00634_def,
   R4_PORTF_PERF_CNTR10         => \%nl4rtr_01_00635_def,
   R4_PORTF_PERF_CNTR11         => \%nl4rtr_01_00636_def,
   R4_PORTF_PERF_CNTR12         => \%nl4rtr_01_00637_def,
   R4_PORTF_PERF_CNTR13         => \%nl4rtr_01_00638_def,
   R4_PORTF_PERF_CNTR14         => \%nl4rtr_01_00639_def,
   R4_PORTF_PERF_CNTR15         => \%nl4rtr_01_00640_def,
   R4_PORTF_PERF_CNTR16         => \%nl4rtr_01_00641_def,
   R4_PORTF_PERF_CNTR17         => \%nl4rtr_01_00642_def,
   R4_PORTF_PERF_CNTR18         => \%nl4rtr_01_00643_def,
   R4_PORTF_PERF_CNTR19         => \%nl4rtr_01_00644_def,
   R4_PORTF_PERF_CNTR20         => \%nl4rtr_01_00645_def,
   R4_PORTF_PERF_CNTR21         => \%nl4rtr_01_00646_def,
   R4_PORTF_PERF_CNTR22         => \%nl4rtr_01_00647_def,
   R4_PORTF_PERF_CNTR23         => \%nl4rtr_01_00648_def,
   R4_PORTF_PERF_CNTR24         => \%nl4rtr_01_00649_def,
   R4_PORTF_PERF_CNTR25         => \%nl4rtr_01_00650_def,
   R4_PORTF_PERF_CNTR26         => \%nl4rtr_01_00651_def,
   R4_PORTF_PERF_CNTR27         => \%nl4rtr_01_00652_def,
   R4_PORTF_PERF_CNTR28         => \%nl4rtr_01_00653_def,
   R4_PORTF_PERF_CNTR29         => \%nl4rtr_01_00654_def,
   R4_PORTF_PERF_CNTR30         => \%nl4rtr_01_00655_def,
   R4_PORTF_PERF_CNTR31         => \%nl4rtr_01_00656_def,
   R4_PORTF_PERF_CNTR32         => \%nl4rtr_01_00657_def,
   R4_PORTF_PERF_CNTR33         => \%nl4rtr_01_00658_def,
   R4_PORTF_PERF_CNTR34         => \%nl4rtr_01_00659_def,
   R4_PORTF_PERF_CNTR35         => \%nl4rtr_01_00660_def,
   R4_PORTF_PERF_CNTR36         => \%nl4rtr_01_00661_def,
   R4_PORTG_PERF_CONFIG         => \%nl4rtr_01_00662_def,
   R4_PORTG_PERF_CMD_LO         => \%nl4rtr_01_00663_def,
   R4_PORTG_PERF_CMD_UP         => \%nl4rtr_01_00664_def,
   R4_PORTG_PERF_CNTR0          => \%nl4rtr_01_00665_def,
   R4_PORTG_PERF_CNTR1          => \%nl4rtr_01_00666_def,
   R4_PORTG_PERF_CNTR2          => \%nl4rtr_01_00667_def,
   R4_PORTG_PERF_CNTR3          => \%nl4rtr_01_00668_def,
   R4_PORTG_PERF_CNTR4          => \%nl4rtr_01_00669_def,
   R4_PORTG_PERF_CNTR5          => \%nl4rtr_01_00670_def,
   R4_PORTG_PERF_CNTR6          => \%nl4rtr_01_00671_def,
   R4_PORTG_PERF_CNTR7          => \%nl4rtr_01_00672_def,
   R4_PORTG_PERF_CNTR8          => \%nl4rtr_01_00673_def,
   R4_PORTG_PERF_CNTR9          => \%nl4rtr_01_00674_def,
   R4_PORTG_PERF_CNTR10         => \%nl4rtr_01_00675_def,
   R4_PORTG_PERF_CNTR11         => \%nl4rtr_01_00676_def,
   R4_PORTG_PERF_CNTR12         => \%nl4rtr_01_00677_def,
   R4_PORTG_PERF_CNTR13         => \%nl4rtr_01_00678_def,
   R4_PORTG_PERF_CNTR14         => \%nl4rtr_01_00679_def,
   R4_PORTG_PERF_CNTR15         => \%nl4rtr_01_00680_def,
   R4_PORTG_PERF_CNTR16         => \%nl4rtr_01_00681_def,
   R4_PORTG_PERF_CNTR17         => \%nl4rtr_01_00682_def,
   R4_PORTG_PERF_CNTR18         => \%nl4rtr_01_00683_def,
   R4_PORTG_PERF_CNTR19         => \%nl4rtr_01_00684_def,
   R4_PORTG_PERF_CNTR20         => \%nl4rtr_01_00685_def,
   R4_PORTG_PERF_CNTR21         => \%nl4rtr_01_00686_def,
   R4_PORTG_PERF_CNTR22         => \%nl4rtr_01_00687_def,
   R4_PORTG_PERF_CNTR23         => \%nl4rtr_01_00688_def,
   R4_PORTG_PERF_CNTR24         => \%nl4rtr_01_00689_def,
   R4_PORTG_PERF_CNTR25         => \%nl4rtr_01_00690_def,
   R4_PORTG_PERF_CNTR26         => \%nl4rtr_01_00691_def,
   R4_PORTG_PERF_CNTR27         => \%nl4rtr_01_00692_def,
   R4_PORTG_PERF_CNTR28         => \%nl4rtr_01_00693_def,
   R4_PORTG_PERF_CNTR29         => \%nl4rtr_01_00694_def,
   R4_PORTG_PERF_CNTR30         => \%nl4rtr_01_00695_def,
   R4_PORTG_PERF_CNTR31         => \%nl4rtr_01_00696_def,
   R4_PORTG_PERF_CNTR32         => \%nl4rtr_01_00697_def,
   R4_PORTG_PERF_CNTR33         => \%nl4rtr_01_00698_def,
   R4_PORTG_PERF_CNTR34         => \%nl4rtr_01_00699_def,
   R4_PORTG_PERF_CNTR35         => \%nl4rtr_01_00700_def,
   R4_PORTG_PERF_CNTR36         => \%nl4rtr_01_00701_def,
   R4_PORTH_PERF_CONFIG         => \%nl4rtr_01_00702_def,
   R4_PORTH_PERF_CMD_LO         => \%nl4rtr_01_00703_def,
   R4_PORTH_PERF_CMD_UP         => \%nl4rtr_01_00704_def,
   R4_PORTH_PERF_CNTR0          => \%nl4rtr_01_00705_def,
   R4_PORTH_PERF_CNTR1          => \%nl4rtr_01_00706_def,
   R4_PORTH_PERF_CNTR2          => \%nl4rtr_01_00707_def,
   R4_PORTH_PERF_CNTR3          => \%nl4rtr_01_00708_def,
   R4_PORTH_PERF_CNTR4          => \%nl4rtr_01_00709_def,
   R4_PORTH_PERF_CNTR5          => \%nl4rtr_01_00710_def,
   R4_PORTH_PERF_CNTR6          => \%nl4rtr_01_00711_def,
   R4_PORTH_PERF_CNTR7          => \%nl4rtr_01_00712_def,
   R4_PORTH_PERF_CNTR8          => \%nl4rtr_01_00713_def,
   R4_PORTH_PERF_CNTR9          => \%nl4rtr_01_00714_def,
   R4_PORTH_PERF_CNTR10         => \%nl4rtr_01_00715_def,
   R4_PORTH_PERF_CNTR11         => \%nl4rtr_01_00716_def,
   R4_PORTH_PERF_CNTR12         => \%nl4rtr_01_00717_def,
   R4_PORTH_PERF_CNTR13         => \%nl4rtr_01_00718_def,
   R4_PORTH_PERF_CNTR14         => \%nl4rtr_01_00719_def,
   R4_PORTH_PERF_CNTR15         => \%nl4rtr_01_00720_def,
   R4_PORTH_PERF_CNTR16         => \%nl4rtr_01_00721_def,
   R4_PORTH_PERF_CNTR17         => \%nl4rtr_01_00722_def,
   R4_PORTH_PERF_CNTR18         => \%nl4rtr_01_00723_def,
   R4_PORTH_PERF_CNTR19         => \%nl4rtr_01_00724_def,
   R4_PORTH_PERF_CNTR20         => \%nl4rtr_01_00725_def,
   R4_PORTH_PERF_CNTR21         => \%nl4rtr_01_00726_def,
   R4_PORTH_PERF_CNTR22         => \%nl4rtr_01_00727_def,
   R4_PORTH_PERF_CNTR23         => \%nl4rtr_01_00728_def,
   R4_PORTH_PERF_CNTR24         => \%nl4rtr_01_00729_def,
   R4_PORTH_PERF_CNTR25         => \%nl4rtr_01_00730_def,
   R4_PORTH_PERF_CNTR26         => \%nl4rtr_01_00731_def,
   R4_PORTH_PERF_CNTR27         => \%nl4rtr_01_00732_def,
   R4_PORTH_PERF_CNTR28         => \%nl4rtr_01_00733_def,
   R4_PORTH_PERF_CNTR29         => \%nl4rtr_01_00734_def,
   R4_PORTH_PERF_CNTR30         => \%nl4rtr_01_00735_def,
   R4_PORTH_PERF_CNTR31         => \%nl4rtr_01_00736_def,
   R4_PORTH_PERF_CNTR32         => \%nl4rtr_01_00737_def,
   R4_PORTH_PERF_CNTR33         => \%nl4rtr_01_00738_def,
   R4_PORTH_PERF_CNTR34         => \%nl4rtr_01_00739_def,
   R4_PORTH_PERF_CNTR35         => \%nl4rtr_01_00740_def,
   R4_PORTH_PERF_CNTR36         => \%nl4rtr_01_00741_def,
   R4_SCRATCH0                  => \%nl4rtr_01_00742_def,
   R4_SCRATCH0_ALIAS            => \%nl4rtr_01_00743_def,
   R4_SCRATCH1                  => \%nl4rtr_01_00744_def,
   R4_SCRATCH1_ALIAS            => \%nl4rtr_01_00745_def,
   R4_SCRATCH2                  => \%nl4rtr_01_00746_def,
   R4_SCRATCH2_ALIAS            => \%nl4rtr_01_00747_def,
   R4_SCRATCH3                  => \%nl4rtr_01_00748_def,
   R4_SCRATCH3_ALIAS            => \%nl4rtr_01_00749_def,
   R4_SCRATCH4                  => \%nl4rtr_01_00750_def,
   R4_SCRATCH4_ALIAS            => \%nl4rtr_01_00751_def,
   R4_SCRATCH5                  => \%nl4rtr_01_00752_def,
   R4_SCRATCH5_ALIAS            => \%nl4rtr_01_00753_def,
   R4_SCRATCH6                  => \%nl4rtr_01_00754_def,
   R4_SCRATCH6_ALIAS            => \%nl4rtr_01_00755_def,
   R4_SCRATCH7                  => \%nl4rtr_01_00756_def,
   R4_SCRATCH7_ALIAS            => \%nl4rtr_01_00757_def,
   R4_SCRATCH8                  => \%nl4rtr_01_00758_def,
   R4_SCRATCH8_ALIAS            => \%nl4rtr_01_00759_def,
   R4_SCRATCH9                  => \%nl4rtr_01_00760_def,
   R4_SCRATCH9_ALIAS            => \%nl4rtr_01_00761_def,
);

%nl4rtr_01_mmr_by_addr = 
(
   0x0000000000000000 => \%nl4rtr_01_00000_def,
   0x0000000000000010 => \%nl4rtr_01_00001_def,
   0x0000000000000020 => \%nl4rtr_01_00002_def,
   0x0000000000000030 => \%nl4rtr_01_00003_def,
   0x0000000000000038 => \%nl4rtr_01_00004_def,
   0x0000000000000040 => \%nl4rtr_01_00005_def,
   0x0000000000000048 => \%nl4rtr_01_00006_def,
   0x0000000000004000 => \%nl4rtr_01_00007_def,
   0x0000000000004010 => \%nl4rtr_01_00008_def,
   0x0000000000004020 => \%nl4rtr_01_00009_def,
   0x0000000000004E00 => \%nl4rtr_01_00010_def,
   0x0000000000004E08 => \%nl4rtr_01_00011_def,
   0x0000000000004E10 => \%nl4rtr_01_00012_def,
   0x0000000000004E18 => \%nl4rtr_01_00013_def,
   0x0000000000004E20 => \%nl4rtr_01_00014_def,
   0x0000000000004E28 => \%nl4rtr_01_00015_def,
   0x0000000000004E30 => \%nl4rtr_01_00016_def,
   0x0000000000004E38 => \%nl4rtr_01_00017_def,
   0x0000000000004E40 => \%nl4rtr_01_00018_def,
   0x0000000000004E48 => \%nl4rtr_01_00019_def,
   0x0000000000004E50 => \%nl4rtr_01_00020_def,
   0x0000000000004E58 => \%nl4rtr_01_00021_def,
   0x0000000000004E60 => \%nl4rtr_01_00022_def,
   0x0000000000004E68 => \%nl4rtr_01_00023_def,
   0x0000000000004E70 => \%nl4rtr_01_00024_def,
   0x0000000000004E78 => \%nl4rtr_01_00025_def,
   0x0000000000004E80 => \%nl4rtr_01_00026_def,
   0x0000000000004F00 => \%nl4rtr_01_00027_def,
   0x0000000000004F80 => \%nl4rtr_01_00028_def,
   0x0000000000004F90 => \%nl4rtr_01_00029_def,
   0x0000000000004F98 => \%nl4rtr_01_00030_def,
   0x0000000000004FA0 => \%nl4rtr_01_00031_def,
   0x0000000000004FA8 => \%nl4rtr_01_00032_def,
   0x0000000000005000 => \%nl4rtr_01_00033_def,
   0x0000000000006000 => \%nl4rtr_01_00034_def,
   0x0000000001001900 => \%nl4rtr_01_00035_def,
   0x0000000001001908 => \%nl4rtr_01_00036_def,
   0x0000000001001910 => \%nl4rtr_01_00037_def,
   0x0000000001001918 => \%nl4rtr_01_00038_def,
   0x0000000001001920 => \%nl4rtr_01_00039_def,
   0x0000000001001928 => \%nl4rtr_01_00040_def,
   0x0000000001001930 => \%nl4rtr_01_00041_def,
   0x0000000001001938 => \%nl4rtr_01_00042_def,
   0x0000000002000010 => \%nl4rtr_01_00043_def,
   0x0000000002000018 => \%nl4rtr_01_00044_def,
   0x0000000002000020 => \%nl4rtr_01_00045_def,
   0x0000000002000028 => \%nl4rtr_01_00046_def,
   0x0000000002000030 => \%nl4rtr_01_00047_def,
   0x0000000002000038 => \%nl4rtr_01_00048_def,
   0x0000000002000040 => \%nl4rtr_01_00049_def,
   0x0000000002000048 => \%nl4rtr_01_00050_def,
   0x0000000002000050 => \%nl4rtr_01_00051_def,
   0x0000000002000058 => \%nl4rtr_01_00052_def,
   0x0000000002000060 => \%nl4rtr_01_00053_def,
   0x0000000002000068 => \%nl4rtr_01_00054_def,
   0x0000000002000070 => \%nl4rtr_01_00055_def,
   0x0000000002000078 => \%nl4rtr_01_00056_def,
   0x0000000002000080 => \%nl4rtr_01_00057_def,
   0x0000000002000088 => \%nl4rtr_01_00058_def,
   0x0000000002000090 => \%nl4rtr_01_00059_def,
   0x0000000002000098 => \%nl4rtr_01_00060_def,
   0x00000000020000A0 => \%nl4rtr_01_00061_def,
   0x00000000020000A8 => \%nl4rtr_01_00062_def,
   0x00000000020000B0 => \%nl4rtr_01_00063_def,
   0x00000000020000B8 => \%nl4rtr_01_00064_def,
   0x00000000020000C0 => \%nl4rtr_01_00065_def,
   0x00000000020000C8 => \%nl4rtr_01_00066_def,
   0x00000000020000D0 => \%nl4rtr_01_00067_def,
   0x00000000020000D8 => \%nl4rtr_01_00068_def,
   0x00000000020000E0 => \%nl4rtr_01_00069_def,
   0x00000000020000E8 => \%nl4rtr_01_00070_def,
   0x00000000020000F0 => \%nl4rtr_01_00071_def,
   0x00000000020000F8 => \%nl4rtr_01_00072_def,
   0x0000000002000100 => \%nl4rtr_01_00073_def,
   0x0000000002000108 => \%nl4rtr_01_00074_def,
   0x0000000002000120 => \%nl4rtr_01_00075_def,
   0x0000000002000128 => \%nl4rtr_01_00076_def,
   0x0000000002000130 => \%nl4rtr_01_00077_def,
   0x0000000002000138 => \%nl4rtr_01_00078_def,
   0x0000000002000140 => \%nl4rtr_01_00079_def,
   0x0000000002000148 => \%nl4rtr_01_00080_def,
   0x0000000002000150 => \%nl4rtr_01_00081_def,
   0x0000000002000158 => \%nl4rtr_01_00082_def,
   0x0000000002000400 => \%nl4rtr_01_00083_def,
   0x0000000002000408 => \%nl4rtr_01_00084_def,
   0x0000000002000410 => \%nl4rtr_01_00085_def,
   0x0000000002000418 => \%nl4rtr_01_00086_def,
   0x0000000002000420 => \%nl4rtr_01_00087_def,
   0x0000000002000428 => \%nl4rtr_01_00088_def,
   0x0000000002000430 => \%nl4rtr_01_00089_def,
   0x0000000002000438 => \%nl4rtr_01_00090_def,
   0x0000000002000440 => \%nl4rtr_01_00091_def,
   0x0000000002000448 => \%nl4rtr_01_00092_def,
   0x0000000002000600 => \%nl4rtr_01_00093_def,
   0x0000000002000610 => \%nl4rtr_01_00094_def,
   0x0000000002000620 => \%nl4rtr_01_00095_def,
   0x0000000002000630 => \%nl4rtr_01_00096_def,
   0x0000000002000640 => \%nl4rtr_01_00097_def,
   0x0000000002000650 => \%nl4rtr_01_00098_def,
   0x0000000002000660 => \%nl4rtr_01_00099_def,
   0x0000000002000670 => \%nl4rtr_01_00100_def,
   0x0000000002000680 => \%nl4rtr_01_00101_def,
   0x0000000002000500 => \%nl4rtr_01_00102_def,
   0x0000000002000508 => \%nl4rtr_01_00103_def,
   0x0000000008000000 => \%nl4rtr_01_00104_def,
   0x0000000008001000 => \%nl4rtr_01_00105_def,
   0x0000000008001800 => \%nl4rtr_01_00106_def,
   0x0000000008001840 => \%nl4rtr_01_00107_def,
   0x0000000008001848 => \%nl4rtr_01_00108_def,
   0x0000000008001850 => \%nl4rtr_01_00109_def,
   0x0000000008001858 => \%nl4rtr_01_00110_def,
   0x0000000008001860 => \%nl4rtr_01_00111_def,
   0x0000000008001868 => \%nl4rtr_01_00112_def,
   0x0000000008001888 => \%nl4rtr_01_00113_def,
   0x0000000008001890 => \%nl4rtr_01_00114_def,
   0x0000000008001898 => \%nl4rtr_01_00115_def,
   0x00000000080018A0 => \%nl4rtr_01_00116_def,
   0x00000000080018A8 => \%nl4rtr_01_00117_def,
   0x00000000080018B0 => \%nl4rtr_01_00118_def,
   0x00000000080018B8 => \%nl4rtr_01_00119_def,
   0x00000000080018C0 => \%nl4rtr_01_00120_def,
   0x00000000080018C8 => \%nl4rtr_01_00121_def,
   0x00000000080018D0 => \%nl4rtr_01_00122_def,
   0x00000000080018D8 => \%nl4rtr_01_00123_def,
   0x00000000080018E0 => \%nl4rtr_01_00124_def,
   0x0000000009000000 => \%nl4rtr_01_00125_def,
   0x0000000009001000 => \%nl4rtr_01_00126_def,
   0x0000000009001800 => \%nl4rtr_01_00127_def,
   0x0000000009001840 => \%nl4rtr_01_00128_def,
   0x0000000009001848 => \%nl4rtr_01_00129_def,
   0x0000000009001850 => \%nl4rtr_01_00130_def,
   0x0000000009001858 => \%nl4rtr_01_00131_def,
   0x0000000009001860 => \%nl4rtr_01_00132_def,
   0x0000000009001868 => \%nl4rtr_01_00133_def,
   0x0000000009001888 => \%nl4rtr_01_00134_def,
   0x0000000009001890 => \%nl4rtr_01_00135_def,
   0x0000000009001898 => \%nl4rtr_01_00136_def,
   0x00000000090018A0 => \%nl4rtr_01_00137_def,
   0x00000000090018A8 => \%nl4rtr_01_00138_def,
   0x00000000090018B0 => \%nl4rtr_01_00139_def,
   0x00000000090018B8 => \%nl4rtr_01_00140_def,
   0x00000000090018C0 => \%nl4rtr_01_00141_def,
   0x00000000090018C8 => \%nl4rtr_01_00142_def,
   0x00000000090018D0 => \%nl4rtr_01_00143_def,
   0x00000000090018D8 => \%nl4rtr_01_00144_def,
   0x00000000090018E0 => \%nl4rtr_01_00145_def,
   0x000000000A000000 => \%nl4rtr_01_00146_def,
   0x000000000A001000 => \%nl4rtr_01_00147_def,
   0x000000000A001800 => \%nl4rtr_01_00148_def,
   0x000000000A001840 => \%nl4rtr_01_00149_def,
   0x000000000A001848 => \%nl4rtr_01_00150_def,
   0x000000000A001850 => \%nl4rtr_01_00151_def,
   0x000000000A001858 => \%nl4rtr_01_00152_def,
   0x000000000A001860 => \%nl4rtr_01_00153_def,
   0x000000000A001868 => \%nl4rtr_01_00154_def,
   0x000000000A001888 => \%nl4rtr_01_00155_def,
   0x000000000A001890 => \%nl4rtr_01_00156_def,
   0x000000000A001898 => \%nl4rtr_01_00157_def,
   0x000000000A0018A0 => \%nl4rtr_01_00158_def,
   0x000000000A0018A8 => \%nl4rtr_01_00159_def,
   0x000000000A0018B0 => \%nl4rtr_01_00160_def,
   0x000000000A0018B8 => \%nl4rtr_01_00161_def,
   0x000000000A0018C0 => \%nl4rtr_01_00162_def,
   0x000000000A0018C8 => \%nl4rtr_01_00163_def,
   0x000000000A0018D0 => \%nl4rtr_01_00164_def,
   0x000000000A0018D8 => \%nl4rtr_01_00165_def,
   0x000000000A0018E0 => \%nl4rtr_01_00166_def,
   0x000000000B000000 => \%nl4rtr_01_00167_def,
   0x000000000B001000 => \%nl4rtr_01_00168_def,
   0x000000000B001800 => \%nl4rtr_01_00169_def,
   0x000000000B001840 => \%nl4rtr_01_00170_def,
   0x000000000B001848 => \%nl4rtr_01_00171_def,
   0x000000000B001850 => \%nl4rtr_01_00172_def,
   0x000000000B001858 => \%nl4rtr_01_00173_def,
   0x000000000B001860 => \%nl4rtr_01_00174_def,
   0x000000000B001868 => \%nl4rtr_01_00175_def,
   0x000000000B001888 => \%nl4rtr_01_00176_def,
   0x000000000B001890 => \%nl4rtr_01_00177_def,
   0x000000000B001898 => \%nl4rtr_01_00178_def,
   0x000000000B0018A0 => \%nl4rtr_01_00179_def,
   0x000000000B0018A8 => \%nl4rtr_01_00180_def,
   0x000000000B0018B0 => \%nl4rtr_01_00181_def,
   0x000000000B0018B8 => \%nl4rtr_01_00182_def,
   0x000000000B0018C0 => \%nl4rtr_01_00183_def,
   0x000000000B0018C8 => \%nl4rtr_01_00184_def,
   0x000000000B0018D0 => \%nl4rtr_01_00185_def,
   0x000000000B0018D8 => \%nl4rtr_01_00186_def,
   0x000000000B0018E0 => \%nl4rtr_01_00187_def,
   0x000000000C000000 => \%nl4rtr_01_00188_def,
   0x000000000C001000 => \%nl4rtr_01_00189_def,
   0x000000000C001800 => \%nl4rtr_01_00190_def,
   0x000000000C001840 => \%nl4rtr_01_00191_def,
   0x000000000C001848 => \%nl4rtr_01_00192_def,
   0x000000000C001850 => \%nl4rtr_01_00193_def,
   0x000000000C001858 => \%nl4rtr_01_00194_def,
   0x000000000C001860 => \%nl4rtr_01_00195_def,
   0x000000000C001868 => \%nl4rtr_01_00196_def,
   0x000000000C001888 => \%nl4rtr_01_00197_def,
   0x000000000C001890 => \%nl4rtr_01_00198_def,
   0x000000000C001898 => \%nl4rtr_01_00199_def,
   0x000000000C0018A0 => \%nl4rtr_01_00200_def,
   0x000000000C0018A8 => \%nl4rtr_01_00201_def,
   0x000000000C0018B0 => \%nl4rtr_01_00202_def,
   0x000000000C0018B8 => \%nl4rtr_01_00203_def,
   0x000000000C0018C0 => \%nl4rtr_01_00204_def,
   0x000000000C0018C8 => \%nl4rtr_01_00205_def,
   0x000000000C0018D0 => \%nl4rtr_01_00206_def,
   0x000000000C0018D8 => \%nl4rtr_01_00207_def,
   0x000000000C0018E0 => \%nl4rtr_01_00208_def,
   0x000000000D000000 => \%nl4rtr_01_00209_def,
   0x000000000D001000 => \%nl4rtr_01_00210_def,
   0x000000000D001800 => \%nl4rtr_01_00211_def,
   0x000000000D001840 => \%nl4rtr_01_00212_def,
   0x000000000D001848 => \%nl4rtr_01_00213_def,
   0x000000000D001850 => \%nl4rtr_01_00214_def,
   0x000000000D001858 => \%nl4rtr_01_00215_def,
   0x000000000D001860 => \%nl4rtr_01_00216_def,
   0x000000000D001868 => \%nl4rtr_01_00217_def,
   0x000000000D001888 => \%nl4rtr_01_00218_def,
   0x000000000D001890 => \%nl4rtr_01_00219_def,
   0x000000000D001898 => \%nl4rtr_01_00220_def,
   0x000000000D0018A0 => \%nl4rtr_01_00221_def,
   0x000000000D0018A8 => \%nl4rtr_01_00222_def,
   0x000000000D0018B0 => \%nl4rtr_01_00223_def,
   0x000000000D0018B8 => \%nl4rtr_01_00224_def,
   0x000000000D0018C0 => \%nl4rtr_01_00225_def,
   0x000000000D0018C8 => \%nl4rtr_01_00226_def,
   0x000000000D0018D0 => \%nl4rtr_01_00227_def,
   0x000000000D0018D8 => \%nl4rtr_01_00228_def,
   0x000000000D0018E0 => \%nl4rtr_01_00229_def,
   0x000000000E000000 => \%nl4rtr_01_00230_def,
   0x000000000E001000 => \%nl4rtr_01_00231_def,
   0x000000000E001800 => \%nl4rtr_01_00232_def,
   0x000000000E001840 => \%nl4rtr_01_00233_def,
   0x000000000E001848 => \%nl4rtr_01_00234_def,
   0x000000000E001850 => \%nl4rtr_01_00235_def,
   0x000000000E001858 => \%nl4rtr_01_00236_def,
   0x000000000E001860 => \%nl4rtr_01_00237_def,
   0x000000000E001868 => \%nl4rtr_01_00238_def,
   0x000000000E001888 => \%nl4rtr_01_00239_def,
   0x000000000E001890 => \%nl4rtr_01_00240_def,
   0x000000000E001898 => \%nl4rtr_01_00241_def,
   0x000000000E0018A0 => \%nl4rtr_01_00242_def,
   0x000000000E0018A8 => \%nl4rtr_01_00243_def,
   0x000000000E0018B0 => \%nl4rtr_01_00244_def,
   0x000000000E0018B8 => \%nl4rtr_01_00245_def,
   0x000000000E0018C0 => \%nl4rtr_01_00246_def,
   0x000000000E0018C8 => \%nl4rtr_01_00247_def,
   0x000000000E0018D0 => \%nl4rtr_01_00248_def,
   0x000000000E0018D8 => \%nl4rtr_01_00249_def,
   0x000000000E0018E0 => \%nl4rtr_01_00250_def,
   0x000000000F000000 => \%nl4rtr_01_00251_def,
   0x000000000F001000 => \%nl4rtr_01_00252_def,
   0x000000000F001800 => \%nl4rtr_01_00253_def,
   0x000000000F001840 => \%nl4rtr_01_00254_def,
   0x000000000F001848 => \%nl4rtr_01_00255_def,
   0x000000000F001850 => \%nl4rtr_01_00256_def,
   0x000000000F001858 => \%nl4rtr_01_00257_def,
   0x000000000F001860 => \%nl4rtr_01_00258_def,
   0x000000000F001868 => \%nl4rtr_01_00259_def,
   0x000000000F001888 => \%nl4rtr_01_00260_def,
   0x000000000F001890 => \%nl4rtr_01_00261_def,
   0x000000000F001898 => \%nl4rtr_01_00262_def,
   0x000000000F0018A0 => \%nl4rtr_01_00263_def,
   0x000000000F0018A8 => \%nl4rtr_01_00264_def,
   0x000000000F0018B0 => \%nl4rtr_01_00265_def,
   0x000000000F0018B8 => \%nl4rtr_01_00266_def,
   0x000000000F0018C0 => \%nl4rtr_01_00267_def,
   0x000000000F0018C8 => \%nl4rtr_01_00268_def,
   0x000000000F0018D0 => \%nl4rtr_01_00269_def,
   0x000000000F0018D8 => \%nl4rtr_01_00270_def,
   0x000000000F0018E0 => \%nl4rtr_01_00271_def,
   0x0000000001003000 => \%nl4rtr_01_00272_def,
   0x0000000001003008 => \%nl4rtr_01_00273_def,
   0x0000000001003010 => \%nl4rtr_01_00274_def,
   0x0000000001003018 => \%nl4rtr_01_00275_def,
   0x0000000001003020 => \%nl4rtr_01_00276_def,
   0x0000000001003028 => \%nl4rtr_01_00277_def,
   0x0000000001003030 => \%nl4rtr_01_00278_def,
   0x0000000001003038 => \%nl4rtr_01_00279_def,
   0x0000000001003040 => \%nl4rtr_01_00280_def,
   0x0000000001003048 => \%nl4rtr_01_00281_def,
   0x0000000001003050 => \%nl4rtr_01_00282_def,
   0x0000000001003058 => \%nl4rtr_01_00283_def,
   0x0000000008002200 => \%nl4rtr_01_00284_def,
   0x0000000008002208 => \%nl4rtr_01_00285_def,
   0x0000000008002210 => \%nl4rtr_01_00286_def,
   0x0000000008002218 => \%nl4rtr_01_00287_def,
   0x0000000008002000 => \%nl4rtr_01_00288_def,
   0x0000000008002100 => \%nl4rtr_01_00289_def,
   0x0000000009002200 => \%nl4rtr_01_00290_def,
   0x0000000009002208 => \%nl4rtr_01_00291_def,
   0x0000000009002210 => \%nl4rtr_01_00292_def,
   0x0000000009002218 => \%nl4rtr_01_00293_def,
   0x0000000009002000 => \%nl4rtr_01_00294_def,
   0x0000000009002100 => \%nl4rtr_01_00295_def,
   0x000000000A002200 => \%nl4rtr_01_00296_def,
   0x000000000A002208 => \%nl4rtr_01_00297_def,
   0x000000000A002210 => \%nl4rtr_01_00298_def,
   0x000000000A002218 => \%nl4rtr_01_00299_def,
   0x000000000A002000 => \%nl4rtr_01_00300_def,
   0x000000000A002100 => \%nl4rtr_01_00301_def,
   0x000000000B002200 => \%nl4rtr_01_00302_def,
   0x000000000B002208 => \%nl4rtr_01_00303_def,
   0x000000000B002210 => \%nl4rtr_01_00304_def,
   0x000000000B002218 => \%nl4rtr_01_00305_def,
   0x000000000B002000 => \%nl4rtr_01_00306_def,
   0x000000000B002100 => \%nl4rtr_01_00307_def,
   0x000000000C002200 => \%nl4rtr_01_00308_def,
   0x000000000C002208 => \%nl4rtr_01_00309_def,
   0x000000000C002210 => \%nl4rtr_01_00310_def,
   0x000000000C002218 => \%nl4rtr_01_00311_def,
   0x000000000C002000 => \%nl4rtr_01_00312_def,
   0x000000000C002100 => \%nl4rtr_01_00313_def,
   0x000000000D002200 => \%nl4rtr_01_00314_def,
   0x000000000D002208 => \%nl4rtr_01_00315_def,
   0x000000000D002210 => \%nl4rtr_01_00316_def,
   0x000000000D002218 => \%nl4rtr_01_00317_def,
   0x000000000D002000 => \%nl4rtr_01_00318_def,
   0x000000000D002100 => \%nl4rtr_01_00319_def,
   0x000000000E002200 => \%nl4rtr_01_00320_def,
   0x000000000E002208 => \%nl4rtr_01_00321_def,
   0x000000000E002210 => \%nl4rtr_01_00322_def,
   0x000000000E002218 => \%nl4rtr_01_00323_def,
   0x000000000E002000 => \%nl4rtr_01_00324_def,
   0x000000000E002100 => \%nl4rtr_01_00325_def,
   0x000000000F002200 => \%nl4rtr_01_00326_def,
   0x000000000F002208 => \%nl4rtr_01_00327_def,
   0x000000000F002210 => \%nl4rtr_01_00328_def,
   0x000000000F002218 => \%nl4rtr_01_00329_def,
   0x000000000F002000 => \%nl4rtr_01_00330_def,
   0x000000000F002100 => \%nl4rtr_01_00331_def,
   0x0000000000002000 => \%nl4rtr_01_00332_def,
   0x0000000000002008 => \%nl4rtr_01_00333_def,
   0x0000000000002010 => \%nl4rtr_01_00334_def,
   0x0000000000002018 => \%nl4rtr_01_00335_def,
   0x0000000000002020 => \%nl4rtr_01_00336_def,
   0x0000000000002030 => \%nl4rtr_01_00337_def,
   0x0000000000002050 => \%nl4rtr_01_00338_def,
   0x0000000000002060 => \%nl4rtr_01_00339_def,
   0x0000000001003100 => \%nl4rtr_01_00340_def,
   0x0000000001004000 => \%nl4rtr_01_00341_def,
   0x0000000001004080 => \%nl4rtr_01_00342_def,
   0x0000000001004100 => \%nl4rtr_01_00343_def,
   0x0000000001004180 => \%nl4rtr_01_00344_def,
   0x0000000001004200 => \%nl4rtr_01_00345_def,
   0x0000000001004280 => \%nl4rtr_01_00346_def,
   0x0000000001004300 => \%nl4rtr_01_00347_def,
   0x0000000001004380 => \%nl4rtr_01_00348_def,
   0x0000000001004400 => \%nl4rtr_01_00349_def,
   0x0000000001004480 => \%nl4rtr_01_00350_def,
   0x0000000001005000 => \%nl4rtr_01_00351_def,
   0x0000000001005080 => \%nl4rtr_01_00352_def,
   0x0000000001005100 => \%nl4rtr_01_00353_def,
   0x0000000001006000 => \%nl4rtr_01_00354_def,
   0x0000000001006008 => \%nl4rtr_01_00355_def,
   0x0000000001006010 => \%nl4rtr_01_00356_def,
   0x0000000001006020 => \%nl4rtr_01_00357_def,
   0x0000000001006028 => \%nl4rtr_01_00358_def,
   0x0000000001006030 => \%nl4rtr_01_00359_def,
   0x0000000001006040 => \%nl4rtr_01_00360_def,
   0x0000000001006048 => \%nl4rtr_01_00361_def,
   0x0000000001006050 => \%nl4rtr_01_00362_def,
   0x0000000001007100 => \%nl4rtr_01_00363_def,
   0x0000000001007108 => \%nl4rtr_01_00364_def,
   0x0000000001007110 => \%nl4rtr_01_00365_def,
   0x0000000001008000 => \%nl4rtr_01_00366_def,
   0x0000000001008080 => \%nl4rtr_01_00367_def,
   0x0000000001080000 => \%nl4rtr_01_00368_def,
   0x0000000001090000 => \%nl4rtr_01_00369_def,
   0x00000000010A0000 => \%nl4rtr_01_00370_def,
   0x00000000010B0000 => \%nl4rtr_01_00371_def,
   0x00000000010C0000 => \%nl4rtr_01_00372_def,
   0x00000000010D0000 => \%nl4rtr_01_00373_def,
   0x00000000010E0000 => \%nl4rtr_01_00374_def,
   0x00000000010F0000 => \%nl4rtr_01_00375_def,
   0x0000000001100000 => \%nl4rtr_01_00376_def,
   0x0000000001100080 => \%nl4rtr_01_00377_def,
   0x0000000001100100 => \%nl4rtr_01_00378_def,
   0x0000000001100180 => \%nl4rtr_01_00379_def,
   0x0000000001100200 => \%nl4rtr_01_00380_def,
   0x0000000001100208 => \%nl4rtr_01_00381_def,
   0x0000000001100210 => \%nl4rtr_01_00382_def,
   0x0000000001100218 => \%nl4rtr_01_00383_def,
   0x0000000001100220 => \%nl4rtr_01_00384_def,
   0x0000000001100228 => \%nl4rtr_01_00385_def,
   0x0000000001100230 => \%nl4rtr_01_00386_def,
   0x0000000001100238 => \%nl4rtr_01_00387_def,
   0x0000000001100240 => \%nl4rtr_01_00388_def,
   0x0000000001100248 => \%nl4rtr_01_00389_def,
   0x0000000001100250 => \%nl4rtr_01_00390_def,
   0x0000000001100258 => \%nl4rtr_01_00391_def,
   0x0000000001100260 => \%nl4rtr_01_00392_def,
   0x0000000001100268 => \%nl4rtr_01_00393_def,
   0x0000000001100270 => \%nl4rtr_01_00394_def,
   0x0000000001100278 => \%nl4rtr_01_00395_def,
   0x0000000001110000 => \%nl4rtr_01_00396_def,
   0x0000000001120000 => \%nl4rtr_01_00397_def,
   0x0000000001130000 => \%nl4rtr_01_00398_def,
   0x0000000001140000 => \%nl4rtr_01_00399_def,
   0x0000000001150000 => \%nl4rtr_01_00400_def,
   0x0000000001160000 => \%nl4rtr_01_00401_def,
   0x0000000001170000 => \%nl4rtr_01_00402_def,
   0x0000000001180000 => \%nl4rtr_01_00403_def,
   0x0000000001190000 => \%nl4rtr_01_00404_def,
   0x0000000001190080 => \%nl4rtr_01_00405_def,
   0x0000000000002700 => \%nl4rtr_01_00406_def,
   0x0000000001002700 => \%nl4rtr_01_00407_def,
   0x0000000002002700 => \%nl4rtr_01_00408_def,
   0x0000000002002720 => \%nl4rtr_01_00409_def,
   0x0000000002002740 => \%nl4rtr_01_00410_def,
   0x0000000002002760 => \%nl4rtr_01_00411_def,
   0x0000000002002780 => \%nl4rtr_01_00412_def,
   0x0000000002002800 => \%nl4rtr_01_00413_def,
   0x0000000008002700 => \%nl4rtr_01_00414_def,
   0x0000000009002700 => \%nl4rtr_01_00415_def,
   0x000000000A002700 => \%nl4rtr_01_00416_def,
   0x000000000B002700 => \%nl4rtr_01_00417_def,
   0x000000000C002700 => \%nl4rtr_01_00418_def,
   0x000000000D002700 => \%nl4rtr_01_00419_def,
   0x000000000E002700 => \%nl4rtr_01_00420_def,
   0x000000000F002700 => \%nl4rtr_01_00421_def,
   0x0000000008007000 => \%nl4rtr_01_00422_def,
   0x0000000008007008 => \%nl4rtr_01_00423_def,
   0x0000000008007010 => \%nl4rtr_01_00424_def,
   0x0000000008007018 => \%nl4rtr_01_00425_def,
   0x0000000008007020 => \%nl4rtr_01_00426_def,
   0x0000000008007028 => \%nl4rtr_01_00427_def,
   0x0000000008007030 => \%nl4rtr_01_00428_def,
   0x0000000008007038 => \%nl4rtr_01_00429_def,
   0x0000000008007040 => \%nl4rtr_01_00430_def,
   0x0000000008007048 => \%nl4rtr_01_00431_def,
   0x0000000008007050 => \%nl4rtr_01_00432_def,
   0x0000000008007058 => \%nl4rtr_01_00433_def,
   0x0000000008007060 => \%nl4rtr_01_00434_def,
   0x0000000008007068 => \%nl4rtr_01_00435_def,
   0x0000000008007070 => \%nl4rtr_01_00436_def,
   0x0000000008007078 => \%nl4rtr_01_00437_def,
   0x0000000008007080 => \%nl4rtr_01_00438_def,
   0x0000000008007088 => \%nl4rtr_01_00439_def,
   0x0000000008007090 => \%nl4rtr_01_00440_def,
   0x0000000008007098 => \%nl4rtr_01_00441_def,
   0x00000000080070A0 => \%nl4rtr_01_00442_def,
   0x00000000080070A8 => \%nl4rtr_01_00443_def,
   0x00000000080070B0 => \%nl4rtr_01_00444_def,
   0x00000000080070B8 => \%nl4rtr_01_00445_def,
   0x00000000080070C0 => \%nl4rtr_01_00446_def,
   0x00000000080070C8 => \%nl4rtr_01_00447_def,
   0x00000000080070D0 => \%nl4rtr_01_00448_def,
   0x00000000080070D8 => \%nl4rtr_01_00449_def,
   0x00000000080070E0 => \%nl4rtr_01_00450_def,
   0x00000000080070E8 => \%nl4rtr_01_00451_def,
   0x00000000080070F0 => \%nl4rtr_01_00452_def,
   0x00000000080070F8 => \%nl4rtr_01_00453_def,
   0x0000000008007100 => \%nl4rtr_01_00454_def,
   0x0000000008007108 => \%nl4rtr_01_00455_def,
   0x0000000008007110 => \%nl4rtr_01_00456_def,
   0x0000000008007118 => \%nl4rtr_01_00457_def,
   0x0000000008007120 => \%nl4rtr_01_00458_def,
   0x0000000008007128 => \%nl4rtr_01_00459_def,
   0x0000000008007130 => \%nl4rtr_01_00460_def,
   0x0000000008007138 => \%nl4rtr_01_00461_def,
   0x0000000009007000 => \%nl4rtr_01_00462_def,
   0x0000000009007008 => \%nl4rtr_01_00463_def,
   0x0000000009007010 => \%nl4rtr_01_00464_def,
   0x0000000009007018 => \%nl4rtr_01_00465_def,
   0x0000000009007020 => \%nl4rtr_01_00466_def,
   0x0000000009007028 => \%nl4rtr_01_00467_def,
   0x0000000009007030 => \%nl4rtr_01_00468_def,
   0x0000000009007038 => \%nl4rtr_01_00469_def,
   0x0000000009007040 => \%nl4rtr_01_00470_def,
   0x0000000009007048 => \%nl4rtr_01_00471_def,
   0x0000000009007050 => \%nl4rtr_01_00472_def,
   0x0000000009007058 => \%nl4rtr_01_00473_def,
   0x0000000009007060 => \%nl4rtr_01_00474_def,
   0x0000000009007068 => \%nl4rtr_01_00475_def,
   0x0000000009007070 => \%nl4rtr_01_00476_def,
   0x0000000009007078 => \%nl4rtr_01_00477_def,
   0x0000000009007080 => \%nl4rtr_01_00478_def,
   0x0000000009007088 => \%nl4rtr_01_00479_def,
   0x0000000009007090 => \%nl4rtr_01_00480_def,
   0x0000000009007098 => \%nl4rtr_01_00481_def,
   0x00000000090070A0 => \%nl4rtr_01_00482_def,
   0x00000000090070A8 => \%nl4rtr_01_00483_def,
   0x00000000090070B0 => \%nl4rtr_01_00484_def,
   0x00000000090070B8 => \%nl4rtr_01_00485_def,
   0x00000000090070C0 => \%nl4rtr_01_00486_def,
   0x00000000090070C8 => \%nl4rtr_01_00487_def,
   0x00000000090070D0 => \%nl4rtr_01_00488_def,
   0x00000000090070D8 => \%nl4rtr_01_00489_def,
   0x00000000090070E0 => \%nl4rtr_01_00490_def,
   0x00000000090070E8 => \%nl4rtr_01_00491_def,
   0x00000000090070F0 => \%nl4rtr_01_00492_def,
   0x00000000090070F8 => \%nl4rtr_01_00493_def,
   0x0000000009007100 => \%nl4rtr_01_00494_def,
   0x0000000009007108 => \%nl4rtr_01_00495_def,
   0x0000000009007110 => \%nl4rtr_01_00496_def,
   0x0000000009007118 => \%nl4rtr_01_00497_def,
   0x0000000009007120 => \%nl4rtr_01_00498_def,
   0x0000000009007128 => \%nl4rtr_01_00499_def,
   0x0000000009007130 => \%nl4rtr_01_00500_def,
   0x0000000009007138 => \%nl4rtr_01_00501_def,
   0x000000000A007000 => \%nl4rtr_01_00502_def,
   0x000000000A007008 => \%nl4rtr_01_00503_def,
   0x000000000A007010 => \%nl4rtr_01_00504_def,
   0x000000000A007018 => \%nl4rtr_01_00505_def,
   0x000000000A007020 => \%nl4rtr_01_00506_def,
   0x000000000A007028 => \%nl4rtr_01_00507_def,
   0x000000000A007030 => \%nl4rtr_01_00508_def,
   0x000000000A007038 => \%nl4rtr_01_00509_def,
   0x000000000A007040 => \%nl4rtr_01_00510_def,
   0x000000000A007048 => \%nl4rtr_01_00511_def,
   0x000000000A007050 => \%nl4rtr_01_00512_def,
   0x000000000A007058 => \%nl4rtr_01_00513_def,
   0x000000000A007060 => \%nl4rtr_01_00514_def,
   0x000000000A007068 => \%nl4rtr_01_00515_def,
   0x000000000A007070 => \%nl4rtr_01_00516_def,
   0x000000000A007078 => \%nl4rtr_01_00517_def,
   0x000000000A007080 => \%nl4rtr_01_00518_def,
   0x000000000A007088 => \%nl4rtr_01_00519_def,
   0x000000000A007090 => \%nl4rtr_01_00520_def,
   0x000000000A007098 => \%nl4rtr_01_00521_def,
   0x000000000A0070A0 => \%nl4rtr_01_00522_def,
   0x000000000A0070A8 => \%nl4rtr_01_00523_def,
   0x000000000A0070B0 => \%nl4rtr_01_00524_def,
   0x000000000A0070B8 => \%nl4rtr_01_00525_def,
   0x000000000A0070C0 => \%nl4rtr_01_00526_def,
   0x000000000A0070C8 => \%nl4rtr_01_00527_def,
   0x000000000A0070D0 => \%nl4rtr_01_00528_def,
   0x000000000A0070D8 => \%nl4rtr_01_00529_def,
   0x000000000A0070E0 => \%nl4rtr_01_00530_def,
   0x000000000A0070E8 => \%nl4rtr_01_00531_def,
   0x000000000A0070F0 => \%nl4rtr_01_00532_def,
   0x000000000A0070F8 => \%nl4rtr_01_00533_def,
   0x000000000A007100 => \%nl4rtr_01_00534_def,
   0x000000000A007108 => \%nl4rtr_01_00535_def,
   0x000000000A007110 => \%nl4rtr_01_00536_def,
   0x000000000A007118 => \%nl4rtr_01_00537_def,
   0x000000000A007120 => \%nl4rtr_01_00538_def,
   0x000000000A007128 => \%nl4rtr_01_00539_def,
   0x000000000A007130 => \%nl4rtr_01_00540_def,
   0x000000000A007138 => \%nl4rtr_01_00541_def,
   0x000000000B007000 => \%nl4rtr_01_00542_def,
   0x000000000B007008 => \%nl4rtr_01_00543_def,
   0x000000000B007010 => \%nl4rtr_01_00544_def,
   0x000000000B007018 => \%nl4rtr_01_00545_def,
   0x000000000B007020 => \%nl4rtr_01_00546_def,
   0x000000000B007028 => \%nl4rtr_01_00547_def,
   0x000000000B007030 => \%nl4rtr_01_00548_def,
   0x000000000B007038 => \%nl4rtr_01_00549_def,
   0x000000000B007040 => \%nl4rtr_01_00550_def,
   0x000000000B007048 => \%nl4rtr_01_00551_def,
   0x000000000B007050 => \%nl4rtr_01_00552_def,
   0x000000000B007058 => \%nl4rtr_01_00553_def,
   0x000000000B007060 => \%nl4rtr_01_00554_def,
   0x000000000B007068 => \%nl4rtr_01_00555_def,
   0x000000000B007070 => \%nl4rtr_01_00556_def,
   0x000000000B007078 => \%nl4rtr_01_00557_def,
   0x000000000B007080 => \%nl4rtr_01_00558_def,
   0x000000000B007088 => \%nl4rtr_01_00559_def,
   0x000000000B007090 => \%nl4rtr_01_00560_def,
   0x000000000B007098 => \%nl4rtr_01_00561_def,
   0x000000000B0070A0 => \%nl4rtr_01_00562_def,
   0x000000000B0070A8 => \%nl4rtr_01_00563_def,
   0x000000000B0070B0 => \%nl4rtr_01_00564_def,
   0x000000000B0070B8 => \%nl4rtr_01_00565_def,
   0x000000000B0070C0 => \%nl4rtr_01_00566_def,
   0x000000000B0070C8 => \%nl4rtr_01_00567_def,
   0x000000000B0070D0 => \%nl4rtr_01_00568_def,
   0x000000000B0070D8 => \%nl4rtr_01_00569_def,
   0x000000000B0070E0 => \%nl4rtr_01_00570_def,
   0x000000000B0070E8 => \%nl4rtr_01_00571_def,
   0x000000000B0070F0 => \%nl4rtr_01_00572_def,
   0x000000000B0070F8 => \%nl4rtr_01_00573_def,
   0x000000000B007100 => \%nl4rtr_01_00574_def,
   0x000000000B007108 => \%nl4rtr_01_00575_def,
   0x000000000B007110 => \%nl4rtr_01_00576_def,
   0x000000000B007118 => \%nl4rtr_01_00577_def,
   0x000000000B007120 => \%nl4rtr_01_00578_def,
   0x000000000B007128 => \%nl4rtr_01_00579_def,
   0x000000000B007130 => \%nl4rtr_01_00580_def,
   0x000000000B007138 => \%nl4rtr_01_00581_def,
   0x000000000C007000 => \%nl4rtr_01_00582_def,
   0x000000000C007008 => \%nl4rtr_01_00583_def,
   0x000000000C007010 => \%nl4rtr_01_00584_def,
   0x000000000C007018 => \%nl4rtr_01_00585_def,
   0x000000000C007020 => \%nl4rtr_01_00586_def,
   0x000000000C007028 => \%nl4rtr_01_00587_def,
   0x000000000C007030 => \%nl4rtr_01_00588_def,
   0x000000000C007038 => \%nl4rtr_01_00589_def,
   0x000000000C007040 => \%nl4rtr_01_00590_def,
   0x000000000C007048 => \%nl4rtr_01_00591_def,
   0x000000000C007050 => \%nl4rtr_01_00592_def,
   0x000000000C007058 => \%nl4rtr_01_00593_def,
   0x000000000C007060 => \%nl4rtr_01_00594_def,
   0x000000000C007068 => \%nl4rtr_01_00595_def,
   0x000000000C007070 => \%nl4rtr_01_00596_def,
   0x000000000C007078 => \%nl4rtr_01_00597_def,
   0x000000000C007080 => \%nl4rtr_01_00598_def,
   0x000000000C007088 => \%nl4rtr_01_00599_def,
   0x000000000C007090 => \%nl4rtr_01_00600_def,
   0x000000000C007098 => \%nl4rtr_01_00601_def,
   0x000000000C0070A0 => \%nl4rtr_01_00602_def,
   0x000000000C0070A8 => \%nl4rtr_01_00603_def,
   0x000000000C0070B0 => \%nl4rtr_01_00604_def,
   0x000000000C0070B8 => \%nl4rtr_01_00605_def,
   0x000000000C0070C0 => \%nl4rtr_01_00606_def,
   0x000000000C0070C8 => \%nl4rtr_01_00607_def,
   0x000000000C0070D0 => \%nl4rtr_01_00608_def,
   0x000000000C0070D8 => \%nl4rtr_01_00609_def,
   0x000000000C0070E0 => \%nl4rtr_01_00610_def,
   0x000000000C0070E8 => \%nl4rtr_01_00611_def,
   0x000000000C0070F0 => \%nl4rtr_01_00612_def,
   0x000000000C0070F8 => \%nl4rtr_01_00613_def,
   0x000000000C007100 => \%nl4rtr_01_00614_def,
   0x000000000C007108 => \%nl4rtr_01_00615_def,
   0x000000000C007110 => \%nl4rtr_01_00616_def,
   0x000000000C007118 => \%nl4rtr_01_00617_def,
   0x000000000C007120 => \%nl4rtr_01_00618_def,
   0x000000000C007128 => \%nl4rtr_01_00619_def,
   0x000000000C007130 => \%nl4rtr_01_00620_def,
   0x000000000C007138 => \%nl4rtr_01_00621_def,
   0x000000000D007000 => \%nl4rtr_01_00622_def,
   0x000000000D007008 => \%nl4rtr_01_00623_def,
   0x000000000D007010 => \%nl4rtr_01_00624_def,
   0x000000000D007018 => \%nl4rtr_01_00625_def,
   0x000000000D007020 => \%nl4rtr_01_00626_def,
   0x000000000D007028 => \%nl4rtr_01_00627_def,
   0x000000000D007030 => \%nl4rtr_01_00628_def,
   0x000000000D007038 => \%nl4rtr_01_00629_def,
   0x000000000D007040 => \%nl4rtr_01_00630_def,
   0x000000000D007048 => \%nl4rtr_01_00631_def,
   0x000000000D007050 => \%nl4rtr_01_00632_def,
   0x000000000D007058 => \%nl4rtr_01_00633_def,
   0x000000000D007060 => \%nl4rtr_01_00634_def,
   0x000000000D007068 => \%nl4rtr_01_00635_def,
   0x000000000D007070 => \%nl4rtr_01_00636_def,
   0x000000000D007078 => \%nl4rtr_01_00637_def,
   0x000000000D007080 => \%nl4rtr_01_00638_def,
   0x000000000D007088 => \%nl4rtr_01_00639_def,
   0x000000000D007090 => \%nl4rtr_01_00640_def,
   0x000000000D007098 => \%nl4rtr_01_00641_def,
   0x000000000D0070A0 => \%nl4rtr_01_00642_def,
   0x000000000D0070A8 => \%nl4rtr_01_00643_def,
   0x000000000D0070B0 => \%nl4rtr_01_00644_def,
   0x000000000D0070B8 => \%nl4rtr_01_00645_def,
   0x000000000D0070C0 => \%nl4rtr_01_00646_def,
   0x000000000D0070C8 => \%nl4rtr_01_00647_def,
   0x000000000D0070D0 => \%nl4rtr_01_00648_def,
   0x000000000D0070D8 => \%nl4rtr_01_00649_def,
   0x000000000D0070E0 => \%nl4rtr_01_00650_def,
   0x000000000D0070E8 => \%nl4rtr_01_00651_def,
   0x000000000D0070F0 => \%nl4rtr_01_00652_def,
   0x000000000D0070F8 => \%nl4rtr_01_00653_def,
   0x000000000D007100 => \%nl4rtr_01_00654_def,
   0x000000000D007108 => \%nl4rtr_01_00655_def,
   0x000000000D007110 => \%nl4rtr_01_00656_def,
   0x000000000D007118 => \%nl4rtr_01_00657_def,
   0x000000000D007120 => \%nl4rtr_01_00658_def,
   0x000000000D007128 => \%nl4rtr_01_00659_def,
   0x000000000D007130 => \%nl4rtr_01_00660_def,
   0x000000000D007138 => \%nl4rtr_01_00661_def,
   0x000000000E007000 => \%nl4rtr_01_00662_def,
   0x000000000E007008 => \%nl4rtr_01_00663_def,
   0x000000000E007010 => \%nl4rtr_01_00664_def,
   0x000000000E007018 => \%nl4rtr_01_00665_def,
   0x000000000E007020 => \%nl4rtr_01_00666_def,
   0x000000000E007028 => \%nl4rtr_01_00667_def,
   0x000000000E007030 => \%nl4rtr_01_00668_def,
   0x000000000E007038 => \%nl4rtr_01_00669_def,
   0x000000000E007040 => \%nl4rtr_01_00670_def,
   0x000000000E007048 => \%nl4rtr_01_00671_def,
   0x000000000E007050 => \%nl4rtr_01_00672_def,
   0x000000000E007058 => \%nl4rtr_01_00673_def,
   0x000000000E007060 => \%nl4rtr_01_00674_def,
   0x000000000E007068 => \%nl4rtr_01_00675_def,
   0x000000000E007070 => \%nl4rtr_01_00676_def,
   0x000000000E007078 => \%nl4rtr_01_00677_def,
   0x000000000E007080 => \%nl4rtr_01_00678_def,
   0x000000000E007088 => \%nl4rtr_01_00679_def,
   0x000000000E007090 => \%nl4rtr_01_00680_def,
   0x000000000E007098 => \%nl4rtr_01_00681_def,
   0x000000000E0070A0 => \%nl4rtr_01_00682_def,
   0x000000000E0070A8 => \%nl4rtr_01_00683_def,
   0x000000000E0070B0 => \%nl4rtr_01_00684_def,
   0x000000000E0070B8 => \%nl4rtr_01_00685_def,
   0x000000000E0070C0 => \%nl4rtr_01_00686_def,
   0x000000000E0070C8 => \%nl4rtr_01_00687_def,
   0x000000000E0070D0 => \%nl4rtr_01_00688_def,
   0x000000000E0070D8 => \%nl4rtr_01_00689_def,
   0x000000000E0070E0 => \%nl4rtr_01_00690_def,
   0x000000000E0070E8 => \%nl4rtr_01_00691_def,
   0x000000000E0070F0 => \%nl4rtr_01_00692_def,
   0x000000000E0070F8 => \%nl4rtr_01_00693_def,
   0x000000000E007100 => \%nl4rtr_01_00694_def,
   0x000000000E007108 => \%nl4rtr_01_00695_def,
   0x000000000E007110 => \%nl4rtr_01_00696_def,
   0x000000000E007118 => \%nl4rtr_01_00697_def,
   0x000000000E007120 => \%nl4rtr_01_00698_def,
   0x000000000E007128 => \%nl4rtr_01_00699_def,
   0x000000000E007130 => \%nl4rtr_01_00700_def,
   0x000000000E007138 => \%nl4rtr_01_00701_def,
   0x000000000F007000 => \%nl4rtr_01_00702_def,
   0x000000000F007008 => \%nl4rtr_01_00703_def,
   0x000000000F007010 => \%nl4rtr_01_00704_def,
   0x000000000F007018 => \%nl4rtr_01_00705_def,
   0x000000000F007020 => \%nl4rtr_01_00706_def,
   0x000000000F007028 => \%nl4rtr_01_00707_def,
   0x000000000F007030 => \%nl4rtr_01_00708_def,
   0x000000000F007038 => \%nl4rtr_01_00709_def,
   0x000000000F007040 => \%nl4rtr_01_00710_def,
   0x000000000F007048 => \%nl4rtr_01_00711_def,
   0x000000000F007050 => \%nl4rtr_01_00712_def,
   0x000000000F007058 => \%nl4rtr_01_00713_def,
   0x000000000F007060 => \%nl4rtr_01_00714_def,
   0x000000000F007068 => \%nl4rtr_01_00715_def,
   0x000000000F007070 => \%nl4rtr_01_00716_def,
   0x000000000F007078 => \%nl4rtr_01_00717_def,
   0x000000000F007080 => \%nl4rtr_01_00718_def,
   0x000000000F007088 => \%nl4rtr_01_00719_def,
   0x000000000F007090 => \%nl4rtr_01_00720_def,
   0x000000000F007098 => \%nl4rtr_01_00721_def,
   0x000000000F0070A0 => \%nl4rtr_01_00722_def,
   0x000000000F0070A8 => \%nl4rtr_01_00723_def,
   0x000000000F0070B0 => \%nl4rtr_01_00724_def,
   0x000000000F0070B8 => \%nl4rtr_01_00725_def,
   0x000000000F0070C0 => \%nl4rtr_01_00726_def,
   0x000000000F0070C8 => \%nl4rtr_01_00727_def,
   0x000000000F0070D0 => \%nl4rtr_01_00728_def,
   0x000000000F0070D8 => \%nl4rtr_01_00729_def,
   0x000000000F0070E0 => \%nl4rtr_01_00730_def,
   0x000000000F0070E8 => \%nl4rtr_01_00731_def,
   0x000000000F0070F0 => \%nl4rtr_01_00732_def,
   0x000000000F0070F8 => \%nl4rtr_01_00733_def,
   0x000000000F007100 => \%nl4rtr_01_00734_def,
   0x000000000F007108 => \%nl4rtr_01_00735_def,
   0x000000000F007110 => \%nl4rtr_01_00736_def,
   0x000000000F007118 => \%nl4rtr_01_00737_def,
   0x000000000F007120 => \%nl4rtr_01_00738_def,
   0x000000000F007128 => \%nl4rtr_01_00739_def,
   0x000000000F007130 => \%nl4rtr_01_00740_def,
   0x000000000F007138 => \%nl4rtr_01_00741_def,
   0x0000000000001000 => \%nl4rtr_01_00742_def,
   0x0000000000001008 => \%nl4rtr_01_00743_def,
   0x0000000000001010 => \%nl4rtr_01_00744_def,
   0x0000000000001018 => \%nl4rtr_01_00745_def,
   0x0000000000001020 => \%nl4rtr_01_00746_def,
   0x0000000000001028 => \%nl4rtr_01_00747_def,
   0x0000000000001030 => \%nl4rtr_01_00748_def,
   0x0000000000001038 => \%nl4rtr_01_00749_def,
   0x0000000000001040 => \%nl4rtr_01_00750_def,
   0x0000000000001048 => \%nl4rtr_01_00751_def,
   0x0000000000001050 => \%nl4rtr_01_00752_def,
   0x0000000000001058 => \%nl4rtr_01_00753_def,
   0x0000000000001060 => \%nl4rtr_01_00754_def,
   0x0000000000001068 => \%nl4rtr_01_00755_def,
   0x0000000000001070 => \%nl4rtr_01_00756_def,
   0x0000000000001078 => \%nl4rtr_01_00757_def,
   0x0000000000001080 => \%nl4rtr_01_00758_def,
   0x0000000000001088 => \%nl4rtr_01_00759_def,
   0x0000000000001090 => \%nl4rtr_01_00760_def,
   0x0000000000001098 => \%nl4rtr_01_00761_def,
);

@nl4rtr_01_sorted_mmr_name = 
(
   "R4_AGE_RATE_PORTA",
   "R4_AGE_RATE_PORTB",
   "R4_AGE_RATE_PORTC",
   "R4_AGE_RATE_PORTD",
   "R4_AGE_RATE_PORTE",
   "R4_AGE_RATE_PORTF",
   "R4_AGE_RATE_PORTG",
   "R4_AGE_RATE_PORTH",
   "R4_AGE_RATE_PORTLB",
   "R4_ARBL_TEST_POINT_SELECT_512",
   "R4_ARBR_TEST_POINT_SELECT_512",
   "R4_ASIC_FIRST_ERROR",
   "R4_ASIC_FIRST_ERROR_TIMESTAMP",
   "R4_ASIC_TO_L1_DATA",
   "R4_ASIC_TO_L1_STATUS",
   "R4_BRANCH1_DEBUG_DATA",
   "R4_BRANCH1_TEST_POINT_COMPARE",
   "R4_BRANCH1_TEST_POINT_SELECT",
   "R4_BRANCH1_TEST_POINT_TRIGGER_SELECT",
   "R4_BRANCH2_DEBUG_DATA",
   "R4_BRANCH2_TEST_POINT_COMPARE",
   "R4_BRANCH2_TEST_POINT_SELECT",
   "R4_BRANCH2_TEST_POINT_TRIGGER_SELECT",
   "R4_CDQ0_TEST_POINT_SELECT_512",
   "R4_CDQ1_TEST_POINT_SELECT_512",
   "R4_CDQ2_TEST_POINT_SELECT_512",
   "R4_CDQ3_TEST_POINT_SELECT_512",
   "R4_DEBUG_PORT_CONFIG",
   "R4_GLOBAL_PARM0",
   "R4_GLOBAL_PARM1",
   "R4_HARD_RESET",
   "R4_L1_TO_ASIC_DATA",
   "R4_L1_TO_ASIC_STATUS",
   "R4_LB0_TEST_POINT_SELECT_512",
   "R4_LB1_TEST_POINT_SELECT_512",
   "R4_LB_DATELINE",
   "R4_LB_ERROR_CLEAR",
   "R4_LB_ERROR_DETAIL_1",
   "R4_LB_ERROR_DETAIL_2",
   "R4_LB_ERROR_REPORT_MASK",
   "R4_LB_ERROR_SUMMARY",
   "R4_LB_FIRST_ERROR",
   "R4_LB_GLOBAL_TABLE",
   "R4_LB_LOCAL_TABLE",
   "R4_LB_PREAGE",
   "R4_MCAST_DEST_TABLE",
   "R4_MCAST_DEST_VEC_0",
   "R4_MCAST_DEST_VEC_1",
   "R4_MCAST_DEST_VEC_2",
   "R4_MCAST_DEST_VEC_3",
   "R4_MCAST_GATHER_CONFIG",
   "R4_MCAST_REP_GATHER_BUF",
   "R4_MCAST_TRANS_TABLE_0",
   "R4_MCAST_TRANS_TABLE_1",
   "R4_MCAST_TRANS_TABLE_10",
   "R4_MCAST_TRANS_TABLE_11",
   "R4_MCAST_TRANS_TABLE_12",
   "R4_MCAST_TRANS_TABLE_13",
   "R4_MCAST_TRANS_TABLE_14",
   "R4_MCAST_TRANS_TABLE_15",
   "R4_MCAST_TRANS_TABLE_2",
   "R4_MCAST_TRANS_TABLE_3",
   "R4_MCAST_TRANS_TABLE_4",
   "R4_MCAST_TRANS_TABLE_5",
   "R4_MCAST_TRANS_TABLE_6",
   "R4_MCAST_TRANS_TABLE_7",
   "R4_MCAST_TRANS_TABLE_8",
   "R4_MCAST_TRANS_TABLE_9",
   "R4_PERFORMANCE_COUNT0_CONTROL",
   "R4_PERFORMANCE_COUNT1_CONTROL",
   "R4_PERFORMANCE_COUNT2_CONTROL",
   "R4_PERFORMANCE_COUNT3_CONTROL",
   "R4_PERFORMANCE_COUNT4_CONTROL",
   "R4_PERFORMANCE_COUNT5_CONTROL",
   "R4_PERFORMANCE_COUNT6_CONTROL",
   "R4_PERFORMANCE_COUNT7_CONTROL",
   "R4_PERFORMANCE_COUNTER0",
   "R4_PERFORMANCE_COUNTER1",
   "R4_PERFORMANCE_COUNTER2",
   "R4_PERFORMANCE_COUNTER3",
   "R4_PERFORMANCE_COUNTER4",
   "R4_PERFORMANCE_COUNTER5",
   "R4_PERFORMANCE_COUNTER6",
   "R4_PERFORMANCE_COUNTER7",
   "R4_PERF_TRIG_PATTERN_0",
   "R4_PERF_TRIG_PATTERN_1",
   "R4_PERF_TRIG_PATTERN_10",
   "R4_PERF_TRIG_PATTERN_11",
   "R4_PERF_TRIG_PATTERN_12",
   "R4_PERF_TRIG_PATTERN_13",
   "R4_PERF_TRIG_PATTERN_14",
   "R4_PERF_TRIG_PATTERN_15",
   "R4_PERF_TRIG_PATTERN_2",
   "R4_PERF_TRIG_PATTERN_3",
   "R4_PERF_TRIG_PATTERN_4",
   "R4_PERF_TRIG_PATTERN_5",
   "R4_PERF_TRIG_PATTERN_6",
   "R4_PERF_TRIG_PATTERN_7",
   "R4_PERF_TRIG_PATTERN_8",
   "R4_PERF_TRIG_PATTERN_9",
   "R4_PIO_TIME_OUT",
   "R4_PORTA_CREDIT",
   "R4_PORTA_CREDIT_STATE",
   "R4_PORTA_DEBIT",
   "R4_PORTA_D_COUNT_INIT",
   "R4_PORTA_ERROR_CLEAR",
   "R4_PORTA_ERROR_DETAIL",
   "R4_PORTA_ERROR_DETAIL_CLEAR",
   "R4_PORTA_ERROR_REPORT_MASK",
   "R4_PORTA_ERROR_SUMMARY",
   "R4_PORTA_FIRST_ERROR",
   "R4_PORTA_GLOBAL_TABLE",
   "R4_PORTA_LLP_CAPT_SBCB",
   "R4_PORTA_LLP_CAPT_WD1",
   "R4_PORTA_LLP_CAPT_WD2",
   "R4_PORTA_LLP_CONFIG",
   "R4_PORTA_LLP_ERR1",
   "R4_PORTA_LLP_ERR2",
   "R4_PORTA_LLP_PKT",
   "R4_PORTA_LLP_STATE",
   "R4_PORTA_LLP_TEST_CTL",
   "R4_PORTA_LOCAL_TABLE",
   "R4_PORTA_NEIGHBOR_TABLE",
   "R4_PORTA_PARMS",
   "R4_PORTA_PERF_CMD_LO",
   "R4_PORTA_PERF_CMD_UP",
   "R4_PORTA_PERF_CNTR0",
   "R4_PORTA_PERF_CNTR1",
   "R4_PORTA_PERF_CNTR10",
   "R4_PORTA_PERF_CNTR11",
   "R4_PORTA_PERF_CNTR12",
   "R4_PORTA_PERF_CNTR13",
   "R4_PORTA_PERF_CNTR14",
   "R4_PORTA_PERF_CNTR15",
   "R4_PORTA_PERF_CNTR16",
   "R4_PORTA_PERF_CNTR17",
   "R4_PORTA_PERF_CNTR18",
   "R4_PORTA_PERF_CNTR19",
   "R4_PORTA_PERF_CNTR2",
   "R4_PORTA_PERF_CNTR20",
   "R4_PORTA_PERF_CNTR21",
   "R4_PORTA_PERF_CNTR22",
   "R4_PORTA_PERF_CNTR23",
   "R4_PORTA_PERF_CNTR24",
   "R4_PORTA_PERF_CNTR25",
   "R4_PORTA_PERF_CNTR26",
   "R4_PORTA_PERF_CNTR27",
   "R4_PORTA_PERF_CNTR28",
   "R4_PORTA_PERF_CNTR29",
   "R4_PORTA_PERF_CNTR3",
   "R4_PORTA_PERF_CNTR30",
   "R4_PORTA_PERF_CNTR31",
   "R4_PORTA_PERF_CNTR32",
   "R4_PORTA_PERF_CNTR33",
   "R4_PORTA_PERF_CNTR34",
   "R4_PORTA_PERF_CNTR35",
   "R4_PORTA_PERF_CNTR36",
   "R4_PORTA_PERF_CNTR4",
   "R4_PORTA_PERF_CNTR5",
   "R4_PORTA_PERF_CNTR6",
   "R4_PORTA_PERF_CNTR7",
   "R4_PORTA_PERF_CNTR8",
   "R4_PORTA_PERF_CNTR9",
   "R4_PORTA_PERF_CONFIG",
   "R4_PORTA_RST_MASK",
   "R4_PORTA_SPRAY_CMD_3F_0",
   "R4_PORTA_SPRAY_CMD_7F_40",
   "R4_PORTA_SPRAY_CMD_BF_80",
   "R4_PORTA_SPRAY_CMD_FF_C0",
   "R4_PORTA_SPRAY_DIR",
   "R4_PORTA_TEST_POINT_SELECT_512",
   "R4_PORTA_VC0_N_COUNT_INIT",
   "R4_PORTA_VC1_N_COUNT_INIT",
   "R4_PORTA_VC2_N_COUNT_INIT",
   "R4_PORTA_VC3_N_COUNT_INIT",
   "R4_PORTB_CREDIT",
   "R4_PORTB_CREDIT_STATE",
   "R4_PORTB_DEBIT",
   "R4_PORTB_D_COUNT_INIT",
   "R4_PORTB_ERROR_CLEAR",
   "R4_PORTB_ERROR_DETAIL",
   "R4_PORTB_ERROR_DETAIL_CLEAR",
   "R4_PORTB_ERROR_REPORT_MASK",
   "R4_PORTB_ERROR_SUMMARY",
   "R4_PORTB_FIRST_ERROR",
   "R4_PORTB_GLOBAL_TABLE",
   "R4_PORTB_LLP_CAPT_SBCB",
   "R4_PORTB_LLP_CAPT_WD1",
   "R4_PORTB_LLP_CAPT_WD2",
   "R4_PORTB_LLP_CONFIG",
   "R4_PORTB_LLP_ERR1",
   "R4_PORTB_LLP_ERR2",
   "R4_PORTB_LLP_PKT",
   "R4_PORTB_LLP_STATE",
   "R4_PORTB_LLP_TEST_CTL",
   "R4_PORTB_LOCAL_TABLE",
   "R4_PORTB_NEIGHBOR_TABLE",
   "R4_PORTB_PARMS",
   "R4_PORTB_PERF_CMD_LO",
   "R4_PORTB_PERF_CMD_UP",
   "R4_PORTB_PERF_CNTR0",
   "R4_PORTB_PERF_CNTR1",
   "R4_PORTB_PERF_CNTR10",
   "R4_PORTB_PERF_CNTR11",
   "R4_PORTB_PERF_CNTR12",
   "R4_PORTB_PERF_CNTR13",
   "R4_PORTB_PERF_CNTR14",
   "R4_PORTB_PERF_CNTR15",
   "R4_PORTB_PERF_CNTR16",
   "R4_PORTB_PERF_CNTR17",
   "R4_PORTB_PERF_CNTR18",
   "R4_PORTB_PERF_CNTR19",
   "R4_PORTB_PERF_CNTR2",
   "R4_PORTB_PERF_CNTR20",
   "R4_PORTB_PERF_CNTR21",
   "R4_PORTB_PERF_CNTR22",
   "R4_PORTB_PERF_CNTR23",
   "R4_PORTB_PERF_CNTR24",
   "R4_PORTB_PERF_CNTR25",
   "R4_PORTB_PERF_CNTR26",
   "R4_PORTB_PERF_CNTR27",
   "R4_PORTB_PERF_CNTR28",
   "R4_PORTB_PERF_CNTR29",
   "R4_PORTB_PERF_CNTR3",
   "R4_PORTB_PERF_CNTR30",
   "R4_PORTB_PERF_CNTR31",
   "R4_PORTB_PERF_CNTR32",
   "R4_PORTB_PERF_CNTR33",
   "R4_PORTB_PERF_CNTR34",
   "R4_PORTB_PERF_CNTR35",
   "R4_PORTB_PERF_CNTR36",
   "R4_PORTB_PERF_CNTR4",
   "R4_PORTB_PERF_CNTR5",
   "R4_PORTB_PERF_CNTR6",
   "R4_PORTB_PERF_CNTR7",
   "R4_PORTB_PERF_CNTR8",
   "R4_PORTB_PERF_CNTR9",
   "R4_PORTB_PERF_CONFIG",
   "R4_PORTB_RST_MASK",
   "R4_PORTB_SPRAY_CMD_3F_0",
   "R4_PORTB_SPRAY_CMD_7F_40",
   "R4_PORTB_SPRAY_CMD_BF_80",
   "R4_PORTB_SPRAY_CMD_FF_C0",
   "R4_PORTB_SPRAY_DIR",
   "R4_PORTB_TEST_POINT_SELECT_512",
   "R4_PORTB_VC0_N_COUNT_INIT",
   "R4_PORTB_VC1_N_COUNT_INIT",
   "R4_PORTB_VC2_N_COUNT_INIT",
   "R4_PORTB_VC3_N_COUNT_INIT",
   "R4_PORTC_CREDIT",
   "R4_PORTC_CREDIT_STATE",
   "R4_PORTC_DEBIT",
   "R4_PORTC_D_COUNT_INIT",
   "R4_PORTC_ERROR_CLEAR",
   "R4_PORTC_ERROR_DETAIL",
   "R4_PORTC_ERROR_DETAIL_CLEAR",
   "R4_PORTC_ERROR_REPORT_MASK",
   "R4_PORTC_ERROR_SUMMARY",
   "R4_PORTC_FIRST_ERROR",
   "R4_PORTC_GLOBAL_TABLE",
   "R4_PORTC_LLP_CAPT_SBCB",
   "R4_PORTC_LLP_CAPT_WD1",
   "R4_PORTC_LLP_CAPT_WD2",
   "R4_PORTC_LLP_CONFIG",
   "R4_PORTC_LLP_ERR1",
   "R4_PORTC_LLP_ERR2",
   "R4_PORTC_LLP_PKT",
   "R4_PORTC_LLP_STATE",
   "R4_PORTC_LLP_TEST_CTL",
   "R4_PORTC_LOCAL_TABLE",
   "R4_PORTC_NEIGHBOR_TABLE",
   "R4_PORTC_PARMS",
   "R4_PORTC_PERF_CMD_LO",
   "R4_PORTC_PERF_CMD_UP",
   "R4_PORTC_PERF_CNTR0",
   "R4_PORTC_PERF_CNTR1",
   "R4_PORTC_PERF_CNTR10",
   "R4_PORTC_PERF_CNTR11",
   "R4_PORTC_PERF_CNTR12",
   "R4_PORTC_PERF_CNTR13",
   "R4_PORTC_PERF_CNTR14",
   "R4_PORTC_PERF_CNTR15",
   "R4_PORTC_PERF_CNTR16",
   "R4_PORTC_PERF_CNTR17",
   "R4_PORTC_PERF_CNTR18",
   "R4_PORTC_PERF_CNTR19",
   "R4_PORTC_PERF_CNTR2",
   "R4_PORTC_PERF_CNTR20",
   "R4_PORTC_PERF_CNTR21",
   "R4_PORTC_PERF_CNTR22",
   "R4_PORTC_PERF_CNTR23",
   "R4_PORTC_PERF_CNTR24",
   "R4_PORTC_PERF_CNTR25",
   "R4_PORTC_PERF_CNTR26",
   "R4_PORTC_PERF_CNTR27",
   "R4_PORTC_PERF_CNTR28",
   "R4_PORTC_PERF_CNTR29",
   "R4_PORTC_PERF_CNTR3",
   "R4_PORTC_PERF_CNTR30",
   "R4_PORTC_PERF_CNTR31",
   "R4_PORTC_PERF_CNTR32",
   "R4_PORTC_PERF_CNTR33",
   "R4_PORTC_PERF_CNTR34",
   "R4_PORTC_PERF_CNTR35",
   "R4_PORTC_PERF_CNTR36",
   "R4_PORTC_PERF_CNTR4",
   "R4_PORTC_PERF_CNTR5",
   "R4_PORTC_PERF_CNTR6",
   "R4_PORTC_PERF_CNTR7",
   "R4_PORTC_PERF_CNTR8",
   "R4_PORTC_PERF_CNTR9",
   "R4_PORTC_PERF_CONFIG",
   "R4_PORTC_RST_MASK",
   "R4_PORTC_SPRAY_CMD_3F_0",
   "R4_PORTC_SPRAY_CMD_7F_40",
   "R4_PORTC_SPRAY_CMD_BF_80",
   "R4_PORTC_SPRAY_CMD_FF_C0",
   "R4_PORTC_SPRAY_DIR",
   "R4_PORTC_TEST_POINT_SELECT_512",
   "R4_PORTC_VC0_N_COUNT_INIT",
   "R4_PORTC_VC1_N_COUNT_INIT",
   "R4_PORTC_VC2_N_COUNT_INIT",
   "R4_PORTC_VC3_N_COUNT_INIT",
   "R4_PORTD_CREDIT",
   "R4_PORTD_CREDIT_STATE",
   "R4_PORTD_DEBIT",
   "R4_PORTD_D_COUNT_INIT",
   "R4_PORTD_ERROR_CLEAR",
   "R4_PORTD_ERROR_DETAIL",
   "R4_PORTD_ERROR_DETAIL_CLEAR",
   "R4_PORTD_ERROR_REPORT_MASK",
   "R4_PORTD_ERROR_SUMMARY",
   "R4_PORTD_FIRST_ERROR",
   "R4_PORTD_GLOBAL_TABLE",
   "R4_PORTD_LLP_CAPT_SBCB",
   "R4_PORTD_LLP_CAPT_WD1",
   "R4_PORTD_LLP_CAPT_WD2",
   "R4_PORTD_LLP_CONFIG",
   "R4_PORTD_LLP_ERR1",
   "R4_PORTD_LLP_ERR2",
   "R4_PORTD_LLP_PKT",
   "R4_PORTD_LLP_STATE",
   "R4_PORTD_LLP_TEST_CTL",
   "R4_PORTD_LOCAL_TABLE",
   "R4_PORTD_NEIGHBOR_TABLE",
   "R4_PORTD_PARMS",
   "R4_PORTD_PERF_CMD_LO",
   "R4_PORTD_PERF_CMD_UP",
   "R4_PORTD_PERF_CNTR0",
   "R4_PORTD_PERF_CNTR1",
   "R4_PORTD_PERF_CNTR10",
   "R4_PORTD_PERF_CNTR11",
   "R4_PORTD_PERF_CNTR12",
   "R4_PORTD_PERF_CNTR13",
   "R4_PORTD_PERF_CNTR14",
   "R4_PORTD_PERF_CNTR15",
   "R4_PORTD_PERF_CNTR16",
   "R4_PORTD_PERF_CNTR17",
   "R4_PORTD_PERF_CNTR18",
   "R4_PORTD_PERF_CNTR19",
   "R4_PORTD_PERF_CNTR2",
   "R4_PORTD_PERF_CNTR20",
   "R4_PORTD_PERF_CNTR21",
   "R4_PORTD_PERF_CNTR22",
   "R4_PORTD_PERF_CNTR23",
   "R4_PORTD_PERF_CNTR24",
   "R4_PORTD_PERF_CNTR25",
   "R4_PORTD_PERF_CNTR26",
   "R4_PORTD_PERF_CNTR27",
   "R4_PORTD_PERF_CNTR28",
   "R4_PORTD_PERF_CNTR29",
   "R4_PORTD_PERF_CNTR3",
   "R4_PORTD_PERF_CNTR30",
   "R4_PORTD_PERF_CNTR31",
   "R4_PORTD_PERF_CNTR32",
   "R4_PORTD_PERF_CNTR33",
   "R4_PORTD_PERF_CNTR34",
   "R4_PORTD_PERF_CNTR35",
   "R4_PORTD_PERF_CNTR36",
   "R4_PORTD_PERF_CNTR4",
   "R4_PORTD_PERF_CNTR5",
   "R4_PORTD_PERF_CNTR6",
   "R4_PORTD_PERF_CNTR7",
   "R4_PORTD_PERF_CNTR8",
   "R4_PORTD_PERF_CNTR9",
   "R4_PORTD_PERF_CONFIG",
   "R4_PORTD_RST_MASK",
   "R4_PORTD_SPRAY_CMD_3F_0",
   "R4_PORTD_SPRAY_CMD_7F_40",
   "R4_PORTD_SPRAY_CMD_BF_80",
   "R4_PORTD_SPRAY_CMD_FF_C0",
   "R4_PORTD_SPRAY_DIR",
   "R4_PORTD_TEST_POINT_SELECT_512",
   "R4_PORTD_VC0_N_COUNT_INIT",
   "R4_PORTD_VC1_N_COUNT_INIT",
   "R4_PORTD_VC2_N_COUNT_INIT",
   "R4_PORTD_VC3_N_COUNT_INIT",
   "R4_PORTE_CREDIT",
   "R4_PORTE_CREDIT_STATE",
   "R4_PORTE_DEBIT",
   "R4_PORTE_D_COUNT_INIT",
   "R4_PORTE_ERROR_CLEAR",
   "R4_PORTE_ERROR_DETAIL",
   "R4_PORTE_ERROR_DETAIL_CLEAR",
   "R4_PORTE_ERROR_REPORT_MASK",
   "R4_PORTE_ERROR_SUMMARY",
   "R4_PORTE_FIRST_ERROR",
   "R4_PORTE_GLOBAL_TABLE",
   "R4_PORTE_LLP_CAPT_SBCB",
   "R4_PORTE_LLP_CAPT_WD1",
   "R4_PORTE_LLP_CAPT_WD2",
   "R4_PORTE_LLP_CONFIG",
   "R4_PORTE_LLP_ERR1",
   "R4_PORTE_LLP_ERR2",
   "R4_PORTE_LLP_PKT",
   "R4_PORTE_LLP_STATE",
   "R4_PORTE_LLP_TEST_CTL",
   "R4_PORTE_LOCAL_TABLE",
   "R4_PORTE_NEIGHBOR_TABLE",
   "R4_PORTE_PARMS",
   "R4_PORTE_PERF_CMD_LO",
   "R4_PORTE_PERF_CMD_UP",
   "R4_PORTE_PERF_CNTR0",
   "R4_PORTE_PERF_CNTR1",
   "R4_PORTE_PERF_CNTR10",
   "R4_PORTE_PERF_CNTR11",
   "R4_PORTE_PERF_CNTR12",
   "R4_PORTE_PERF_CNTR13",
   "R4_PORTE_PERF_CNTR14",
   "R4_PORTE_PERF_CNTR15",
   "R4_PORTE_PERF_CNTR16",
   "R4_PORTE_PERF_CNTR17",
   "R4_PORTE_PERF_CNTR18",
   "R4_PORTE_PERF_CNTR19",
   "R4_PORTE_PERF_CNTR2",
   "R4_PORTE_PERF_CNTR20",
   "R4_PORTE_PERF_CNTR21",
   "R4_PORTE_PERF_CNTR22",
   "R4_PORTE_PERF_CNTR23",
   "R4_PORTE_PERF_CNTR24",
   "R4_PORTE_PERF_CNTR25",
   "R4_PORTE_PERF_CNTR26",
   "R4_PORTE_PERF_CNTR27",
   "R4_PORTE_PERF_CNTR28",
   "R4_PORTE_PERF_CNTR29",
   "R4_PORTE_PERF_CNTR3",
   "R4_PORTE_PERF_CNTR30",
   "R4_PORTE_PERF_CNTR31",
   "R4_PORTE_PERF_CNTR32",
   "R4_PORTE_PERF_CNTR33",
   "R4_PORTE_PERF_CNTR34",
   "R4_PORTE_PERF_CNTR35",
   "R4_PORTE_PERF_CNTR36",
   "R4_PORTE_PERF_CNTR4",
   "R4_PORTE_PERF_CNTR5",
   "R4_PORTE_PERF_CNTR6",
   "R4_PORTE_PERF_CNTR7",
   "R4_PORTE_PERF_CNTR8",
   "R4_PORTE_PERF_CNTR9",
   "R4_PORTE_PERF_CONFIG",
   "R4_PORTE_RST_MASK",
   "R4_PORTE_SPRAY_CMD_3F_0",
   "R4_PORTE_SPRAY_CMD_7F_40",
   "R4_PORTE_SPRAY_CMD_BF_80",
   "R4_PORTE_SPRAY_CMD_FF_C0",
   "R4_PORTE_SPRAY_DIR",
   "R4_PORTE_TEST_POINT_SELECT_512",
   "R4_PORTE_VC0_N_COUNT_INIT",
   "R4_PORTE_VC1_N_COUNT_INIT",
   "R4_PORTE_VC2_N_COUNT_INIT",
   "R4_PORTE_VC3_N_COUNT_INIT",
   "R4_PORTF_CREDIT",
   "R4_PORTF_CREDIT_STATE",
   "R4_PORTF_DEBIT",
   "R4_PORTF_D_COUNT_INIT",
   "R4_PORTF_ERROR_CLEAR",
   "R4_PORTF_ERROR_DETAIL",
   "R4_PORTF_ERROR_DETAIL_CLEAR",
   "R4_PORTF_ERROR_REPORT_MASK",
   "R4_PORTF_ERROR_SUMMARY",
   "R4_PORTF_FIRST_ERROR",
   "R4_PORTF_GLOBAL_TABLE",
   "R4_PORTF_LLP_CAPT_SBCB",
   "R4_PORTF_LLP_CAPT_WD1",
   "R4_PORTF_LLP_CAPT_WD2",
   "R4_PORTF_LLP_CONFIG",
   "R4_PORTF_LLP_ERR1",
   "R4_PORTF_LLP_ERR2",
   "R4_PORTF_LLP_PKT",
   "R4_PORTF_LLP_STATE",
   "R4_PORTF_LLP_TEST_CTL",
   "R4_PORTF_LOCAL_TABLE",
   "R4_PORTF_NEIGHBOR_TABLE",
   "R4_PORTF_PARMS",
   "R4_PORTF_PERF_CMD_LO",
   "R4_PORTF_PERF_CMD_UP",
   "R4_PORTF_PERF_CNTR0",
   "R4_PORTF_PERF_CNTR1",
   "R4_PORTF_PERF_CNTR10",
   "R4_PORTF_PERF_CNTR11",
   "R4_PORTF_PERF_CNTR12",
   "R4_PORTF_PERF_CNTR13",
   "R4_PORTF_PERF_CNTR14",
   "R4_PORTF_PERF_CNTR15",
   "R4_PORTF_PERF_CNTR16",
   "R4_PORTF_PERF_CNTR17",
   "R4_PORTF_PERF_CNTR18",
   "R4_PORTF_PERF_CNTR19",
   "R4_PORTF_PERF_CNTR2",
   "R4_PORTF_PERF_CNTR20",
   "R4_PORTF_PERF_CNTR21",
   "R4_PORTF_PERF_CNTR22",
   "R4_PORTF_PERF_CNTR23",
   "R4_PORTF_PERF_CNTR24",
   "R4_PORTF_PERF_CNTR25",
   "R4_PORTF_PERF_CNTR26",
   "R4_PORTF_PERF_CNTR27",
   "R4_PORTF_PERF_CNTR28",
   "R4_PORTF_PERF_CNTR29",
   "R4_PORTF_PERF_CNTR3",
   "R4_PORTF_PERF_CNTR30",
   "R4_PORTF_PERF_CNTR31",
   "R4_PORTF_PERF_CNTR32",
   "R4_PORTF_PERF_CNTR33",
   "R4_PORTF_PERF_CNTR34",
   "R4_PORTF_PERF_CNTR35",
   "R4_PORTF_PERF_CNTR36",
   "R4_PORTF_PERF_CNTR4",
   "R4_PORTF_PERF_CNTR5",
   "R4_PORTF_PERF_CNTR6",
   "R4_PORTF_PERF_CNTR7",
   "R4_PORTF_PERF_CNTR8",
   "R4_PORTF_PERF_CNTR9",
   "R4_PORTF_PERF_CONFIG",
   "R4_PORTF_RST_MASK",
   "R4_PORTF_SPRAY_CMD_3F_0",
   "R4_PORTF_SPRAY_CMD_7F_40",
   "R4_PORTF_SPRAY_CMD_BF_80",
   "R4_PORTF_SPRAY_CMD_FF_C0",
   "R4_PORTF_SPRAY_DIR",
   "R4_PORTF_TEST_POINT_SELECT_512",
   "R4_PORTF_VC0_N_COUNT_INIT",
   "R4_PORTF_VC1_N_COUNT_INIT",
   "R4_PORTF_VC2_N_COUNT_INIT",
   "R4_PORTF_VC3_N_COUNT_INIT",
   "R4_PORTG_CREDIT",
   "R4_PORTG_CREDIT_STATE",
   "R4_PORTG_DEBIT",
   "R4_PORTG_D_COUNT_INIT",
   "R4_PORTG_ERROR_CLEAR",
   "R4_PORTG_ERROR_DETAIL",
   "R4_PORTG_ERROR_DETAIL_CLEAR",
   "R4_PORTG_ERROR_REPORT_MASK",
   "R4_PORTG_ERROR_SUMMARY",
   "R4_PORTG_FIRST_ERROR",
   "R4_PORTG_GLOBAL_TABLE",
   "R4_PORTG_LLP_CAPT_SBCB",
   "R4_PORTG_LLP_CAPT_WD1",
   "R4_PORTG_LLP_CAPT_WD2",
   "R4_PORTG_LLP_CONFIG",
   "R4_PORTG_LLP_ERR1",
   "R4_PORTG_LLP_ERR2",
   "R4_PORTG_LLP_PKT",
   "R4_PORTG_LLP_STATE",
   "R4_PORTG_LLP_TEST_CTL",
   "R4_PORTG_LOCAL_TABLE",
   "R4_PORTG_NEIGHBOR_TABLE",
   "R4_PORTG_PARMS",
   "R4_PORTG_PERF_CMD_LO",
   "R4_PORTG_PERF_CMD_UP",
   "R4_PORTG_PERF_CNTR0",
   "R4_PORTG_PERF_CNTR1",
   "R4_PORTG_PERF_CNTR10",
   "R4_PORTG_PERF_CNTR11",
   "R4_PORTG_PERF_CNTR12",
   "R4_PORTG_PERF_CNTR13",
   "R4_PORTG_PERF_CNTR14",
   "R4_PORTG_PERF_CNTR15",
   "R4_PORTG_PERF_CNTR16",
   "R4_PORTG_PERF_CNTR17",
   "R4_PORTG_PERF_CNTR18",
   "R4_PORTG_PERF_CNTR19",
   "R4_PORTG_PERF_CNTR2",
   "R4_PORTG_PERF_CNTR20",
   "R4_PORTG_PERF_CNTR21",
   "R4_PORTG_PERF_CNTR22",
   "R4_PORTG_PERF_CNTR23",
   "R4_PORTG_PERF_CNTR24",
   "R4_PORTG_PERF_CNTR25",
   "R4_PORTG_PERF_CNTR26",
   "R4_PORTG_PERF_CNTR27",
   "R4_PORTG_PERF_CNTR28",
   "R4_PORTG_PERF_CNTR29",
   "R4_PORTG_PERF_CNTR3",
   "R4_PORTG_PERF_CNTR30",
   "R4_PORTG_PERF_CNTR31",
   "R4_PORTG_PERF_CNTR32",
   "R4_PORTG_PERF_CNTR33",
   "R4_PORTG_PERF_CNTR34",
   "R4_PORTG_PERF_CNTR35",
   "R4_PORTG_PERF_CNTR36",
   "R4_PORTG_PERF_CNTR4",
   "R4_PORTG_PERF_CNTR5",
   "R4_PORTG_PERF_CNTR6",
   "R4_PORTG_PERF_CNTR7",
   "R4_PORTG_PERF_CNTR8",
   "R4_PORTG_PERF_CNTR9",
   "R4_PORTG_PERF_CONFIG",
   "R4_PORTG_RST_MASK",
   "R4_PORTG_SPRAY_CMD_3F_0",
   "R4_PORTG_SPRAY_CMD_7F_40",
   "R4_PORTG_SPRAY_CMD_BF_80",
   "R4_PORTG_SPRAY_CMD_FF_C0",
   "R4_PORTG_SPRAY_DIR",
   "R4_PORTG_TEST_POINT_SELECT_512",
   "R4_PORTG_VC0_N_COUNT_INIT",
   "R4_PORTG_VC1_N_COUNT_INIT",
   "R4_PORTG_VC2_N_COUNT_INIT",
   "R4_PORTG_VC3_N_COUNT_INIT",
   "R4_PORTH_CREDIT",
   "R4_PORTH_CREDIT_STATE",
   "R4_PORTH_DEBIT",
   "R4_PORTH_D_COUNT_INIT",
   "R4_PORTH_ERROR_CLEAR",
   "R4_PORTH_ERROR_DETAIL",
   "R4_PORTH_ERROR_DETAIL_CLEAR",
   "R4_PORTH_ERROR_REPORT_MASK",
   "R4_PORTH_ERROR_SUMMARY",
   "R4_PORTH_FIRST_ERROR",
   "R4_PORTH_GLOBAL_TABLE",
   "R4_PORTH_LLP_CAPT_SBCB",
   "R4_PORTH_LLP_CAPT_WD1",
   "R4_PORTH_LLP_CAPT_WD2",
   "R4_PORTH_LLP_CONFIG",
   "R4_PORTH_LLP_ERR1",
   "R4_PORTH_LLP_ERR2",
   "R4_PORTH_LLP_PKT",
   "R4_PORTH_LLP_STATE",
   "R4_PORTH_LLP_TEST_CTL",
   "R4_PORTH_LOCAL_TABLE",
   "R4_PORTH_NEIGHBOR_TABLE",
   "R4_PORTH_PARMS",
   "R4_PORTH_PERF_CMD_LO",
   "R4_PORTH_PERF_CMD_UP",
   "R4_PORTH_PERF_CNTR0",
   "R4_PORTH_PERF_CNTR1",
   "R4_PORTH_PERF_CNTR10",
   "R4_PORTH_PERF_CNTR11",
   "R4_PORTH_PERF_CNTR12",
   "R4_PORTH_PERF_CNTR13",
   "R4_PORTH_PERF_CNTR14",
   "R4_PORTH_PERF_CNTR15",
   "R4_PORTH_PERF_CNTR16",
   "R4_PORTH_PERF_CNTR17",
   "R4_PORTH_PERF_CNTR18",
   "R4_PORTH_PERF_CNTR19",
   "R4_PORTH_PERF_CNTR2",
   "R4_PORTH_PERF_CNTR20",
   "R4_PORTH_PERF_CNTR21",
   "R4_PORTH_PERF_CNTR22",
   "R4_PORTH_PERF_CNTR23",
   "R4_PORTH_PERF_CNTR24",
   "R4_PORTH_PERF_CNTR25",
   "R4_PORTH_PERF_CNTR26",
   "R4_PORTH_PERF_CNTR27",
   "R4_PORTH_PERF_CNTR28",
   "R4_PORTH_PERF_CNTR29",
   "R4_PORTH_PERF_CNTR3",
   "R4_PORTH_PERF_CNTR30",
   "R4_PORTH_PERF_CNTR31",
   "R4_PORTH_PERF_CNTR32",
   "R4_PORTH_PERF_CNTR33",
   "R4_PORTH_PERF_CNTR34",
   "R4_PORTH_PERF_CNTR35",
   "R4_PORTH_PERF_CNTR36",
   "R4_PORTH_PERF_CNTR4",
   "R4_PORTH_PERF_CNTR5",
   "R4_PORTH_PERF_CNTR6",
   "R4_PORTH_PERF_CNTR7",
   "R4_PORTH_PERF_CNTR8",
   "R4_PORTH_PERF_CNTR9",
   "R4_PORTH_PERF_CONFIG",
   "R4_PORTH_RST_MASK",
   "R4_PORTH_SPRAY_CMD_3F_0",
   "R4_PORTH_SPRAY_CMD_7F_40",
   "R4_PORTH_SPRAY_CMD_BF_80",
   "R4_PORTH_SPRAY_CMD_FF_C0",
   "R4_PORTH_SPRAY_DIR",
   "R4_PORTH_TEST_POINT_SELECT_512",
   "R4_PORTH_VC0_N_COUNT_INIT",
   "R4_PORTH_VC1_N_COUNT_INIT",
   "R4_PORTH_VC2_N_COUNT_INIT",
   "R4_PORTH_VC3_N_COUNT_INIT",
   "R4_PORTLB_ARBL_D_COUNT_INIT",
   "R4_PORTLB_ARBL_VC0_N_COUNT_INIT",
   "R4_PORTLB_ARBL_VC1_N_COUNT_INIT",
   "R4_PORTLB_ARBL_VC2_N_COUNT_INIT",
   "R4_PORTLB_ARBL_VC3_N_COUNT_INIT",
   "R4_PORTLB_ARBR_D_COUNT_INIT",
   "R4_PORTLB_ARBR_VC0_N_COUNT_INIT",
   "R4_PORTLB_ARBR_VC1_N_COUNT_INIT",
   "R4_PORTLB_ARBR_VC2_N_COUNT_INIT",
   "R4_PORTLB_ARBR_VC3_N_COUNT_INIT",
   "R4_PORT_PERF_WIN",
   "R4_PORT_RESET",
   "R4_PROFILE_COUNTER",
   "R4_PROFILE_DN_CONTROL",
   "R4_PROFILE_PEAK",
   "R4_PROFILE_PEAK_CONTROL",
   "R4_PROFILE_RANGE",
   "R4_PROFILE_UP_CONTROL",
   "R4_PROTECTION_CONFIG",
   "R4_ROOT_DEBUG_DATA",
   "R4_ROOT_TEST_POINT_COMPARE",
   "R4_ROOT_TEST_POINT_SELECT",
   "R4_ROOT_TEST_POINT_TRIGGER_SELECT",
   "R4_RTC_INTRN_CNTRL",
   "R4_RTC_SOURCE",
   "R4_SCRATCH0",
   "R4_SCRATCH0_ALIAS",
   "R4_SCRATCH1",
   "R4_SCRATCH1_ALIAS",
   "R4_SCRATCH2",
   "R4_SCRATCH2_ALIAS",
   "R4_SCRATCH3",
   "R4_SCRATCH3_ALIAS",
   "R4_SCRATCH4",
   "R4_SCRATCH4_ALIAS",
   "R4_SCRATCH5",
   "R4_SCRATCH5_ALIAS",
   "R4_SCRATCH6",
   "R4_SCRATCH6_ALIAS",
   "R4_SCRATCH7",
   "R4_SCRATCH7_ALIAS",
   "R4_SCRATCH8",
   "R4_SCRATCH8_ALIAS",
   "R4_SCRATCH9",
   "R4_SCRATCH9_ALIAS",
   "R4_SOFT_RESET",
   "R4_STATUS_REV_ID",
   "R4_STOP_CLK_CONTROL",
   "R4_STOP_CLK_DELAY_PHASE",
   "R4_THROTTLE_ENABLE_ARBL",
   "R4_THROTTLE_ENABLE_ARBR",
   "R4_THROTTLE_INTERVAL",
   "R4_THROTTLE_SKIP",
   "R4_THROTTLE_STATUS",
   "R4_THROTTLE_TIME",
   "R4_TSF_ARMED_STATE",
   "R4_TSF_ARM_MASK",
   "R4_TSF_COUNTER_PRESETS",
   "R4_TSF_COUNTER_VALUE",
   "R4_TSF_DECREMENT_CTL",
   "R4_TSF_DIAG_MSG_CTL",
   "R4_TSF_DISARM_MASK",
   "R4_TSF_ENABLE_CTL",
   "R4_TSF_SOFTWARE_ARM",
   "R4_TSF_SOFTWARE_DISARM",
   "R4_TSF_SOFTWARE_TRIGGERED",
   "R4_TSF_TRIGGERED_STATE",
   "R4_TSF_TRIGGER_MASK",
   "R4_VBIT_EMUL",
);

@nl4rtr_01_sorted_mmr_addr = 
(
   0x0000000000000000,
   0x0000000000000010,
   0x0000000000000020,
   0x0000000000000030,
   0x0000000000000038,
   0x0000000000000040,
   0x0000000000000048,
   0x0000000000001000,
   0x0000000000001008,
   0x0000000000001010,
   0x0000000000001018,
   0x0000000000001020,
   0x0000000000001028,
   0x0000000000001030,
   0x0000000000001038,
   0x0000000000001040,
   0x0000000000001048,
   0x0000000000001050,
   0x0000000000001058,
   0x0000000000001060,
   0x0000000000001068,
   0x0000000000001070,
   0x0000000000001078,
   0x0000000000001080,
   0x0000000000001088,
   0x0000000000001090,
   0x0000000000001098,
   0x0000000000002000,
   0x0000000000002008,
   0x0000000000002010,
   0x0000000000002018,
   0x0000000000002020,
   0x0000000000002030,
   0x0000000000002050,
   0x0000000000002060,
   0x0000000000002700,
   0x0000000000004000,
   0x0000000000004010,
   0x0000000000004020,
   0x0000000000004E00,
   0x0000000000004E08,
   0x0000000000004E10,
   0x0000000000004E18,
   0x0000000000004E20,
   0x0000000000004E28,
   0x0000000000004E30,
   0x0000000000004E38,
   0x0000000000004E40,
   0x0000000000004E48,
   0x0000000000004E50,
   0x0000000000004E58,
   0x0000000000004E60,
   0x0000000000004E68,
   0x0000000000004E70,
   0x0000000000004E78,
   0x0000000000004E80,
   0x0000000000004F00,
   0x0000000000004F80,
   0x0000000000004F90,
   0x0000000000004F98,
   0x0000000000004FA0,
   0x0000000000004FA8,
   0x0000000000005000,
   0x0000000000006000,
   0x0000000001001900,
   0x0000000001001908,
   0x0000000001001910,
   0x0000000001001918,
   0x0000000001001920,
   0x0000000001001928,
   0x0000000001001930,
   0x0000000001001938,
   0x0000000001002700,
   0x0000000001003000,
   0x0000000001003008,
   0x0000000001003010,
   0x0000000001003018,
   0x0000000001003020,
   0x0000000001003028,
   0x0000000001003030,
   0x0000000001003038,
   0x0000000001003040,
   0x0000000001003048,
   0x0000000001003050,
   0x0000000001003058,
   0x0000000001003100,
   0x0000000001004000,
   0x0000000001004080,
   0x0000000001004100,
   0x0000000001004180,
   0x0000000001004200,
   0x0000000001004280,
   0x0000000001004300,
   0x0000000001004380,
   0x0000000001004400,
   0x0000000001004480,
   0x0000000001005000,
   0x0000000001005080,
   0x0000000001005100,
   0x0000000001006000,
   0x0000000001006008,
   0x0000000001006010,
   0x0000000001006020,
   0x0000000001006028,
   0x0000000001006030,
   0x0000000001006040,
   0x0000000001006048,
   0x0000000001006050,
   0x0000000001007100,
   0x0000000001007108,
   0x0000000001007110,
   0x0000000001008000,
   0x0000000001008080,
   0x0000000001080000,
   0x0000000001090000,
   0x00000000010A0000,
   0x00000000010B0000,
   0x00000000010C0000,
   0x00000000010D0000,
   0x00000000010E0000,
   0x00000000010F0000,
   0x0000000001100000,
   0x0000000001100080,
   0x0000000001100100,
   0x0000000001100180,
   0x0000000001100200,
   0x0000000001100208,
   0x0000000001100210,
   0x0000000001100218,
   0x0000000001100220,
   0x0000000001100228,
   0x0000000001100230,
   0x0000000001100238,
   0x0000000001100240,
   0x0000000001100248,
   0x0000000001100250,
   0x0000000001100258,
   0x0000000001100260,
   0x0000000001100268,
   0x0000000001100270,
   0x0000000001100278,
   0x0000000001110000,
   0x0000000001120000,
   0x0000000001130000,
   0x0000000001140000,
   0x0000000001150000,
   0x0000000001160000,
   0x0000000001170000,
   0x0000000001180000,
   0x0000000001190000,
   0x0000000001190080,
   0x0000000002000010,
   0x0000000002000018,
   0x0000000002000020,
   0x0000000002000028,
   0x0000000002000030,
   0x0000000002000038,
   0x0000000002000040,
   0x0000000002000048,
   0x0000000002000050,
   0x0000000002000058,
   0x0000000002000060,
   0x0000000002000068,
   0x0000000002000070,
   0x0000000002000078,
   0x0000000002000080,
   0x0000000002000088,
   0x0000000002000090,
   0x0000000002000098,
   0x00000000020000A0,
   0x00000000020000A8,
   0x00000000020000B0,
   0x00000000020000B8,
   0x00000000020000C0,
   0x00000000020000C8,
   0x00000000020000D0,
   0x00000000020000D8,
   0x00000000020000E0,
   0x00000000020000E8,
   0x00000000020000F0,
   0x00000000020000F8,
   0x0000000002000100,
   0x0000000002000108,
   0x0000000002000120,
   0x0000000002000128,
   0x0000000002000130,
   0x0000000002000138,
   0x0000000002000140,
   0x0000000002000148,
   0x0000000002000150,
   0x0000000002000158,
   0x0000000002000400,
   0x0000000002000408,
   0x0000000002000410,
   0x0000000002000418,
   0x0000000002000420,
   0x0000000002000428,
   0x0000000002000430,
   0x0000000002000438,
   0x0000000002000440,
   0x0000000002000448,
   0x0000000002000500,
   0x0000000002000508,
   0x0000000002000600,
   0x0000000002000610,
   0x0000000002000620,
   0x0000000002000630,
   0x0000000002000640,
   0x0000000002000650,
   0x0000000002000660,
   0x0000000002000670,
   0x0000000002000680,
   0x0000000002002700,
   0x0000000002002720,
   0x0000000002002740,
   0x0000000002002760,
   0x0000000002002780,
   0x0000000002002800,
   0x0000000008000000,
   0x0000000008001000,
   0x0000000008001800,
   0x0000000008001840,
   0x0000000008001848,
   0x0000000008001850,
   0x0000000008001858,
   0x0000000008001860,
   0x0000000008001868,
   0x0000000008001888,
   0x0000000008001890,
   0x0000000008001898,
   0x00000000080018A0,
   0x00000000080018A8,
   0x00000000080018B0,
   0x00000000080018B8,
   0x00000000080018C0,
   0x00000000080018C8,
   0x00000000080018D0,
   0x00000000080018D8,
   0x00000000080018E0,
   0x0000000008002000,
   0x0000000008002100,
   0x0000000008002200,
   0x0000000008002208,
   0x0000000008002210,
   0x0000000008002218,
   0x0000000008002700,
   0x0000000008007000,
   0x0000000008007008,
   0x0000000008007010,
   0x0000000008007018,
   0x0000000008007020,
   0x0000000008007028,
   0x0000000008007030,
   0x0000000008007038,
   0x0000000008007040,
   0x0000000008007048,
   0x0000000008007050,
   0x0000000008007058,
   0x0000000008007060,
   0x0000000008007068,
   0x0000000008007070,
   0x0000000008007078,
   0x0000000008007080,
   0x0000000008007088,
   0x0000000008007090,
   0x0000000008007098,
   0x00000000080070A0,
   0x00000000080070A8,
   0x00000000080070B0,
   0x00000000080070B8,
   0x00000000080070C0,
   0x00000000080070C8,
   0x00000000080070D0,
   0x00000000080070D8,
   0x00000000080070E0,
   0x00000000080070E8,
   0x00000000080070F0,
   0x00000000080070F8,
   0x0000000008007100,
   0x0000000008007108,
   0x0000000008007110,
   0x0000000008007118,
   0x0000000008007120,
   0x0000000008007128,
   0x0000000008007130,
   0x0000000008007138,
   0x0000000009000000,
   0x0000000009001000,
   0x0000000009001800,
   0x0000000009001840,
   0x0000000009001848,
   0x0000000009001850,
   0x0000000009001858,
   0x0000000009001860,
   0x0000000009001868,
   0x0000000009001888,
   0x0000000009001890,
   0x0000000009001898,
   0x00000000090018A0,
   0x00000000090018A8,
   0x00000000090018B0,
   0x00000000090018B8,
   0x00000000090018C0,
   0x00000000090018C8,
   0x00000000090018D0,
   0x00000000090018D8,
   0x00000000090018E0,
   0x0000000009002000,
   0x0000000009002100,
   0x0000000009002200,
   0x0000000009002208,
   0x0000000009002210,
   0x0000000009002218,
   0x0000000009002700,
   0x0000000009007000,
   0x0000000009007008,
   0x0000000009007010,
   0x0000000009007018,
   0x0000000009007020,
   0x0000000009007028,
   0x0000000009007030,
   0x0000000009007038,
   0x0000000009007040,
   0x0000000009007048,
   0x0000000009007050,
   0x0000000009007058,
   0x0000000009007060,
   0x0000000009007068,
   0x0000000009007070,
   0x0000000009007078,
   0x0000000009007080,
   0x0000000009007088,
   0x0000000009007090,
   0x0000000009007098,
   0x00000000090070A0,
   0x00000000090070A8,
   0x00000000090070B0,
   0x00000000090070B8,
   0x00000000090070C0,
   0x00000000090070C8,
   0x00000000090070D0,
   0x00000000090070D8,
   0x00000000090070E0,
   0x00000000090070E8,
   0x00000000090070F0,
   0x00000000090070F8,
   0x0000000009007100,
   0x0000000009007108,
   0x0000000009007110,
   0x0000000009007118,
   0x0000000009007120,
   0x0000000009007128,
   0x0000000009007130,
   0x0000000009007138,
   0x000000000A000000,
   0x000000000A001000,
   0x000000000A001800,
   0x000000000A001840,
   0x000000000A001848,
   0x000000000A001850,
   0x000000000A001858,
   0x000000000A001860,
   0x000000000A001868,
   0x000000000A001888,
   0x000000000A001890,
   0x000000000A001898,
   0x000000000A0018A0,
   0x000000000A0018A8,
   0x000000000A0018B0,
   0x000000000A0018B8,
   0x000000000A0018C0,
   0x000000000A0018C8,
   0x000000000A0018D0,
   0x000000000A0018D8,
   0x000000000A0018E0,
   0x000000000A002000,
   0x000000000A002100,
   0x000000000A002200,
   0x000000000A002208,
   0x000000000A002210,
   0x000000000A002218,
   0x000000000A002700,
   0x000000000A007000,
   0x000000000A007008,
   0x000000000A007010,
   0x000000000A007018,
   0x000000000A007020,
   0x000000000A007028,
   0x000000000A007030,
   0x000000000A007038,
   0x000000000A007040,
   0x000000000A007048,
   0x000000000A007050,
   0x000000000A007058,
   0x000000000A007060,
   0x000000000A007068,
   0x000000000A007070,
   0x000000000A007078,
   0x000000000A007080,
   0x000000000A007088,
   0x000000000A007090,
   0x000000000A007098,
   0x000000000A0070A0,
   0x000000000A0070A8,
   0x000000000A0070B0,
   0x000000000A0070B8,
   0x000000000A0070C0,
   0x000000000A0070C8,
   0x000000000A0070D0,
   0x000000000A0070D8,
   0x000000000A0070E0,
   0x000000000A0070E8,
   0x000000000A0070F0,
   0x000000000A0070F8,
   0x000000000A007100,
   0x000000000A007108,
   0x000000000A007110,
   0x000000000A007118,
   0x000000000A007120,
   0x000000000A007128,
   0x000000000A007130,
   0x000000000A007138,
   0x000000000B000000,
   0x000000000B001000,
   0x000000000B001800,
   0x000000000B001840,
   0x000000000B001848,
   0x000000000B001850,
   0x000000000B001858,
   0x000000000B001860,
   0x000000000B001868,
   0x000000000B001888,
   0x000000000B001890,
   0x000000000B001898,
   0x000000000B0018A0,
   0x000000000B0018A8,
   0x000000000B0018B0,
   0x000000000B0018B8,
   0x000000000B0018C0,
   0x000000000B0018C8,
   0x000000000B0018D0,
   0x000000000B0018D8,
   0x000000000B0018E0,
   0x000000000B002000,
   0x000000000B002100,
   0x000000000B002200,
   0x000000000B002208,
   0x000000000B002210,
   0x000000000B002218,
   0x000000000B002700,
   0x000000000B007000,
   0x000000000B007008,
   0x000000000B007010,
   0x000000000B007018,
   0x000000000B007020,
   0x000000000B007028,
   0x000000000B007030,
   0x000000000B007038,
   0x000000000B007040,
   0x000000000B007048,
   0x000000000B007050,
   0x000000000B007058,
   0x000000000B007060,
   0x000000000B007068,
   0x000000000B007070,
   0x000000000B007078,
   0x000000000B007080,
   0x000000000B007088,
   0x000000000B007090,
   0x000000000B007098,
   0x000000000B0070A0,
   0x000000000B0070A8,
   0x000000000B0070B0,
   0x000000000B0070B8,
   0x000000000B0070C0,
   0x000000000B0070C8,
   0x000000000B0070D0,
   0x000000000B0070D8,
   0x000000000B0070E0,
   0x000000000B0070E8,
   0x000000000B0070F0,
   0x000000000B0070F8,
   0x000000000B007100,
   0x000000000B007108,
   0x000000000B007110,
   0x000000000B007118,
   0x000000000B007120,
   0x000000000B007128,
   0x000000000B007130,
   0x000000000B007138,
   0x000000000C000000,
   0x000000000C001000,
   0x000000000C001800,
   0x000000000C001840,
   0x000000000C001848,
   0x000000000C001850,
   0x000000000C001858,
   0x000000000C001860,
   0x000000000C001868,
   0x000000000C001888,
   0x000000000C001890,
   0x000000000C001898,
   0x000000000C0018A0,
   0x000000000C0018A8,
   0x000000000C0018B0,
   0x000000000C0018B8,
   0x000000000C0018C0,
   0x000000000C0018C8,
   0x000000000C0018D0,
   0x000000000C0018D8,
   0x000000000C0018E0,
   0x000000000C002000,
   0x000000000C002100,
   0x000000000C002200,
   0x000000000C002208,
   0x000000000C002210,
   0x000000000C002218,
   0x000000000C002700,
   0x000000000C007000,
   0x000000000C007008,
   0x000000000C007010,
   0x000000000C007018,
   0x000000000C007020,
   0x000000000C007028,
   0x000000000C007030,
   0x000000000C007038,
   0x000000000C007040,
   0x000000000C007048,
   0x000000000C007050,
   0x000000000C007058,
   0x000000000C007060,
   0x000000000C007068,
   0x000000000C007070,
   0x000000000C007078,
   0x000000000C007080,
   0x000000000C007088,
   0x000000000C007090,
   0x000000000C007098,
   0x000000000C0070A0,
   0x000000000C0070A8,
   0x000000000C0070B0,
   0x000000000C0070B8,
   0x000000000C0070C0,
   0x000000000C0070C8,
   0x000000000C0070D0,
   0x000000000C0070D8,
   0x000000000C0070E0,
   0x000000000C0070E8,
   0x000000000C0070F0,
   0x000000000C0070F8,
   0x000000000C007100,
   0x000000000C007108,
   0x000000000C007110,
   0x000000000C007118,
   0x000000000C007120,
   0x000000000C007128,
   0x000000000C007130,
   0x000000000C007138,
   0x000000000D000000,
   0x000000000D001000,
   0x000000000D001800,
   0x000000000D001840,
   0x000000000D001848,
   0x000000000D001850,
   0x000000000D001858,
   0x000000000D001860,
   0x000000000D001868,
   0x000000000D001888,
   0x000000000D001890,
   0x000000000D001898,
   0x000000000D0018A0,
   0x000000000D0018A8,
   0x000000000D0018B0,
   0x000000000D0018B8,
   0x000000000D0018C0,
   0x000000000D0018C8,
   0x000000000D0018D0,
   0x000000000D0018D8,
   0x000000000D0018E0,
   0x000000000D002000,
   0x000000000D002100,
   0x000000000D002200,
   0x000000000D002208,
   0x000000000D002210,
   0x000000000D002218,
   0x000000000D002700,
   0x000000000D007000,
   0x000000000D007008,
   0x000000000D007010,
   0x000000000D007018,
   0x000000000D007020,
   0x000000000D007028,
   0x000000000D007030,
   0x000000000D007038,
   0x000000000D007040,
   0x000000000D007048,
   0x000000000D007050,
   0x000000000D007058,
   0x000000000D007060,
   0x000000000D007068,
   0x000000000D007070,
   0x000000000D007078,
   0x000000000D007080,
   0x000000000D007088,
   0x000000000D007090,
   0x000000000D007098,
   0x000000000D0070A0,
   0x000000000D0070A8,
   0x000000000D0070B0,
   0x000000000D0070B8,
   0x000000000D0070C0,
   0x000000000D0070C8,
   0x000000000D0070D0,
   0x000000000D0070D8,
   0x000000000D0070E0,
   0x000000000D0070E8,
   0x000000000D0070F0,
   0x000000000D0070F8,
   0x000000000D007100,
   0x000000000D007108,
   0x000000000D007110,
   0x000000000D007118,
   0x000000000D007120,
   0x000000000D007128,
   0x000000000D007130,
   0x000000000D007138,
   0x000000000E000000,
   0x000000000E001000,
   0x000000000E001800,
   0x000000000E001840,
   0x000000000E001848,
   0x000000000E001850,
   0x000000000E001858,
   0x000000000E001860,
   0x000000000E001868,
   0x000000000E001888,
   0x000000000E001890,
   0x000000000E001898,
   0x000000000E0018A0,
   0x000000000E0018A8,
   0x000000000E0018B0,
   0x000000000E0018B8,
   0x000000000E0018C0,
   0x000000000E0018C8,
   0x000000000E0018D0,
   0x000000000E0018D8,
   0x000000000E0018E0,
   0x000000000E002000,
   0x000000000E002100,
   0x000000000E002200,
   0x000000000E002208,
   0x000000000E002210,
   0x000000000E002218,
   0x000000000E002700,
   0x000000000E007000,
   0x000000000E007008,
   0x000000000E007010,
   0x000000000E007018,
   0x000000000E007020,
   0x000000000E007028,
   0x000000000E007030,
   0x000000000E007038,
   0x000000000E007040,
   0x000000000E007048,
   0x000000000E007050,
   0x000000000E007058,
   0x000000000E007060,
   0x000000000E007068,
   0x000000000E007070,
   0x000000000E007078,
   0x000000000E007080,
   0x000000000E007088,
   0x000000000E007090,
   0x000000000E007098,
   0x000000000E0070A0,
   0x000000000E0070A8,
   0x000000000E0070B0,
   0x000000000E0070B8,
   0x000000000E0070C0,
   0x000000000E0070C8,
   0x000000000E0070D0,
   0x000000000E0070D8,
   0x000000000E0070E0,
   0x000000000E0070E8,
   0x000000000E0070F0,
   0x000000000E0070F8,
   0x000000000E007100,
   0x000000000E007108,
   0x000000000E007110,
   0x000000000E007118,
   0x000000000E007120,
   0x000000000E007128,
   0x000000000E007130,
   0x000000000E007138,
   0x000000000F000000,
   0x000000000F001000,
   0x000000000F001800,
   0x000000000F001840,
   0x000000000F001848,
   0x000000000F001850,
   0x000000000F001858,
   0x000000000F001860,
   0x000000000F001868,
   0x000000000F001888,
   0x000000000F001890,
   0x000000000F001898,
   0x000000000F0018A0,
   0x000000000F0018A8,
   0x000000000F0018B0,
   0x000000000F0018B8,
   0x000000000F0018C0,
   0x000000000F0018C8,
   0x000000000F0018D0,
   0x000000000F0018D8,
   0x000000000F0018E0,
   0x000000000F002000,
   0x000000000F002100,
   0x000000000F002200,
   0x000000000F002208,
   0x000000000F002210,
   0x000000000F002218,
   0x000000000F002700,
   0x000000000F007000,
   0x000000000F007008,
   0x000000000F007010,
   0x000000000F007018,
   0x000000000F007020,
   0x000000000F007028,
   0x000000000F007030,
   0x000000000F007038,
   0x000000000F007040,
   0x000000000F007048,
   0x000000000F007050,
   0x000000000F007058,
   0x000000000F007060,
   0x000000000F007068,
   0x000000000F007070,
   0x000000000F007078,
   0x000000000F007080,
   0x000000000F007088,
   0x000000000F007090,
   0x000000000F007098,
   0x000000000F0070A0,
   0x000000000F0070A8,
   0x000000000F0070B0,
   0x000000000F0070B8,
   0x000000000F0070C0,
   0x000000000F0070C8,
   0x000000000F0070D0,
   0x000000000F0070D8,
   0x000000000F0070E0,
   0x000000000F0070E8,
   0x000000000F0070F0,
   0x000000000F0070F8,
   0x000000000F007100,
   0x000000000F007108,
   0x000000000F007110,
   0x000000000F007118,
   0x000000000F007120,
   0x000000000F007128,
   0x000000000F007130,
   0x000000000F007138,
);


##########################################################################
#                                                                        #
#   REGISTER SEARCH SUBROUTINES (BY NAME OR ADDRESS)                     #
#                                                                        #
##########################################################################

sub nl4rtr_01_mmr_search_name
{  my $rptr = 0;
   return($rptr) if ( $#_ != 0 );
   $rptr = $nl4rtr_01_mmr_by_name{$_[0]} if ( exists $nl4rtr_01_mmr_by_name{$_[0]} );
   return($rptr);
}

sub nl4rtr_01_mmr_search_addr
{  my $rptr = 0;
   return($rptr) if ( $#_ != 0 );
   $rptr = $nl4rtr_01_mmr_by_addr{$_[0]} if ( exists $nl4rtr_01_mmr_by_addr{$_[0]} );
   return($rptr);
}


##########################################################################
# Number of MMRs    : 762

1;
