#
#/**************************************************************************
# *                                                                        *
# *               Copyright (C) 1989-1999 Silicon Graphics, Inc.           *
# *                                                                        *
# *  These coded instructions, statements, and computer programs  contain  *
# *  unpublished  proprietary  information of Silicon Graphics, Inc., and  *
# *  are protected by Federal copyright law.  They  may  not be disclosed  *
# *  to  third  parties  or copied or duplicated in any form, in whole or  *
# *  in part, without the prior written consent of Silicon Graphics, Inc.  *
# *                                                                        *
# **************************************************************************/
#
# @(#)$Id: orbit_01_mmrs.pm,v 1.1 2003/04/14 19:54:38 beighley Exp $
#
#
# The file contains PERL source that represents the MMRs from
#    an ASIC hardware register (hwreg) file.
#
# This file was generated using the "hwr2perl" utility.
# HWREG source file : hwreg_orbit.hwreg
# ASIC base name    : "orbit_01"
# PERL file created : 11:23:22 Monday April 14
#

$orbit_01_defined = 1;


##########################################################################
#                                                                        #
#   OC_MMRBIST_ERR                                                       #
#                                                                        #
##########################################################################

%orbit_01_00000_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  39,  25, 0xFFFFFF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CANCELLED"                    => [   1,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "mmr/bist was cancelled" ],
   "MULTIPLE_DETECTED"            => [   2,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "multiple errors detected flag" ],
   "DETECTED"                     => [   3,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "error detected flag" ],
   "RSVD1"                        => [   4,  33,   3, 0x0000000E00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR"                         => [   5,   0,  33, 0x00000001FFFFFFFF, 0x00, 1, 0x0000000000000000, "dword address of bist error" ],
);

%orbit_01_00000_def =
( NAME    => "OC_MMRBIST_ERR",
  ADDRESS => 0x0000000080000080,
  NOTE    => "This register may be used to monitor the status of the most recent note memory bist read sequence. The error flags are cleared b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00000_flds
);


##########################################################################
#                                                                        #
#   OC_MISC_ERR_HDR_LOWER                                                #
#                                                                        #
##########################################################################

%orbit_01_00001_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "set when capture occurs" ],
   "RSVD0"                        => [   1,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE"                        => [   2,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "reference is a write" ],
   "SRC"                          => [   3,  44,  16, 0x0FFFF00000000000, 0x00, 1, 0x0000000000000000, "source node of reference" ],
   "CMD"                          => [   4,  36,   8, 0x00000FF000000000, 0x00, 1, 0x0000000000000000, "command of reference" ],
);

%orbit_01_00001_def =
( NAME    => "OC_MISC_ERR_HDR_LOWER",
  ADDRESS => 0x0000000080000088,
  NOTE    => "This register logs some of the bits of the header on the first note occurrence of a packet or directory protocol error.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00001_flds
);


##########################################################################
#                                                                        #
#   OC_MISC_ERR_HDR_UPPER                                                #
#                                                                        #
##########################################################################

%orbit_01_00002_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  29,  35, 0xFFFFFFFFE0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECHO"                         => [   1,  20,   9, 0x000000001FF00000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD1"                        => [   2,   8,  12, 0x00000000000FFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_PKT_SIZE"                  => [   3,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "indicates a pkt size error from xn" ],
   "PI_PKT_SIZE"                  => [   4,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "indicates a pkt size error from pi" ],
   "DIR_ACC"                      => [   5,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "indicates a data request to directory memory error captured" ],
   "RMW_COR"                      => [   6,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "indicates a correctable store rmw" ],
   "RMW_UC"                       => [   7,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "indicates an uncorrectable store rmw" ],
   "NONEXIST_ADDR"                => [   8,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "indicates a non-existent memory error captured" ],
   "ILLEGAL_CMD"                  => [   9,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "indicates an illegal command error captured" ],
   "DIR_PROTOCOL"                 => [  10,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "indicates a directory protocol error captured" ],
);

%orbit_01_00002_def =
( NAME    => "OC_MISC_ERR_HDR_UPPER",
  ADDRESS => 0x0000000080000090,
  NOTE    => "This register logs some of the bits of the header on the first note capture of a packet or directory protocol error. A valid is ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00002_flds
);


##########################################################################
#                                                                        #
#   OC_DIR_UC_ERR_HDR_LOWER                                              #
#                                                                        #
##########################################################################

%orbit_01_00003_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "set when capture occurs" ],
   "RSVD0"                        => [   1,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE"                        => [   2,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "reference is a write" ],
   "SRC"                          => [   3,  44,  16, 0x0FFFF00000000000, 0x00, 1, 0x0000000000000000, "source node of reference" ],
   "CMD"                          => [   4,  36,   8, 0x00000FF000000000, 0x00, 1, 0x0000000000000000, "command of reference" ],
);

%orbit_01_00003_def =
( NAME    => "OC_DIR_UC_ERR_HDR_LOWER",
  ADDRESS => 0x0000000080000098,
  NOTE    => "This register logs some of the bits of the header on the first note occurrence of an uncorrectable directory error.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00003_flds
);


##########################################################################
#                                                                        #
#   OC_DIR_UC_ERR_HDR_UPPER                                              #
#                                                                        #
##########################################################################

%orbit_01_00004_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  29,  35, 0xFFFFFFFFE0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECHO"                         => [   1,  20,   9, 0x000000001FF00000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD1"                        => [   2,   4,  16, 0x00000000000FFFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR_UC"                       => [   3,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "indicates uncorrectable directory error captured" ],
);

%orbit_01_00004_def =
( NAME    => "OC_DIR_UC_ERR_HDR_UPPER",
  ADDRESS => 0x00000000800000a0,
  NOTE    => "This register logs some of the bits of the header on the first note capture of an uncorrectable directory error. A valid is capt",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00004_flds
);


##########################################################################
#                                                                        #
#   OC_DIR_COR_ERR_HDR_LOWER                                             #
#                                                                        #
##########################################################################

%orbit_01_00005_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "set when capture occurs" ],
   "RSVD0"                        => [   1,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE"                        => [   2,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "reference is a write" ],
   "SRC"                          => [   3,  44,  16, 0x0FFFF00000000000, 0x00, 1, 0x0000000000000000, "source node of reference" ],
   "CMD"                          => [   4,  36,   8, 0x00000FF000000000, 0x00, 1, 0x0000000000000000, "command of reference" ],
);

%orbit_01_00005_def =
( NAME    => "OC_DIR_COR_ERR_HDR_LOWER",
  ADDRESS => 0x00000000800000a8,
  NOTE    => "This register logs some of the bits of the header on the first note occurrence of a correctable directory error.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00005_flds
);


##########################################################################
#                                                                        #
#   OC_DIR_COR_ERR_HDR_UPPER                                             #
#                                                                        #
##########################################################################

%orbit_01_00006_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  29,  35, 0xFFFFFFFFE0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECHO"                         => [   1,  20,   9, 0x000000001FF00000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD1"                        => [   2,   9,  11, 0x00000000000FFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR_COR"                      => [   3,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "indicates correctable directory error captured" ],
);

%orbit_01_00006_def =
( NAME    => "OC_DIR_COR_ERR_HDR_UPPER",
  ADDRESS => 0x00000000800000b0,
  NOTE    => "This register logs some of the bits of the header on the first note capture of a correctable directory error. A valid is capture",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00006_flds
);


##########################################################################
#                                                                        #
#   OC_MEM_ERROR_SUMMARY                                                 #
#                                                                        #
##########################################################################

%orbit_01_00007_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_PKT_SIZE"                  => [   1,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: XN-to-MD Message Length Error" ],
   "PI_PKT_SIZE"                  => [   2,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: PI-to-MD Message Length Error" ],
   "RED_BLACK_ERR_TIMEOUT"        => [   3,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Red/Black Time-out Error" ],
   "XN_REQUEST_OVERFLOW"          => [   4,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: XN-to-MD Request Queue Overflow Error" ],
   "PI_REQUEST_OVERFLOW"          => [   5,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: PI-to-MD Request Queue Overflow Error" ],
   "XN_REPLY_OVERFLOW"            => [   6,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: XN-to-MD Reply Queue Overflow Error" ],
   "PI_REPLY_OVERFLOW"            => [   7,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: PI-to-MD Reply Queue Overflow Error" ],
   "RSVD1"                        => [   8,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQRS_INT_HW"                  => [   9,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQRS Hardware Error" ],
   "DQRS_INT_COR"                 => [  10,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQRS Correctable AMO Data Error" ],
   "DQRS_INT_UC"                  => [  11,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQRS Uncorrectable AMO Data Error" ],
   "RSVD2"                        => [  12,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQRP_INT_HW"                  => [  13,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQRP Hardware Error" ],
   "DQRP_INT_COR"                 => [  14,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQRP Correctable AMO Data Error" ],
   "DQRP_INT_UC"                  => [  15,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQRP Uncorrectable AMO Data Error" ],
   "RSVD3"                        => [  16,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQLS_INT_HW"                  => [  17,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQLS Hardware Error" ],
   "DQLS_INT_COR"                 => [  18,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQLS Correctable AMO Data Error" ],
   "DQLS_INT_UC"                  => [  19,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQLS Uncorrectable AMO Data Error" ],
   "RSVD4"                        => [  20,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQLP_INT_HW"                  => [  21,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQLP Hardware Error" ],
   "DQLP_INT_COR"                 => [  22,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQLP Correctable AMO Data Error" ],
   "DQLP_INT_UC"                  => [  23,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQLP Uncorrectable AMO Data Error" ],
   "RSVD5"                        => [  24,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR_ACC"                      => [  25,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Directory Memory Access Error" ],
   "ACY_INT_HW"                   => [  26,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "MD_HW_INT: ACY Hardware Error" ],
   "ACX_INT_HW"                   => [  27,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "MD_HW_INT: ACX Hardware Error" ],
   "DQRP_DIR_COR"                 => [  28,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQRP Correctable Directory Data Error" ],
   "DQRP_DIR_UC"                  => [  29,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQRP Uncorrectable Directory Data Error" ],
   "DQLP_DIR_COR"                 => [  30,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQLP Correctable Directory Data Error" ],
   "DQLP_DIR_UC"                  => [  31,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQLP Uncorrectable Directory Data Error" ],
   "DQRP_DIR_PERR"                => [  32,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQRP Directory Protocol Error" ],
   "DQLP_DIR_PERR"                => [  33,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQLP Directory Protocol Error" ],
   "NONEXIST_ADDR"                => [  34,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Non-existent Memory Address Error" ],
   "ILLEGAL_CMD"                  => [  35,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Illegal Command Error" ],
);

%orbit_01_00007_def =
( NAME    => "OC_MEM_ERROR_SUMMARY",
  ADDRESS => 0x00000000800000b8,
  NOTE    => "The MEM_ERROR_SUMMARY register is the MD's top-level error flag note register. It contains 30 flags. Each flag corresponds to on",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00007_flds
);


##########################################################################
#                                                                        #
#   OC_MEM_ERROR_SUMMARY_ALIAS                                           #
#                                                                        #
##########################################################################

%orbit_01_00008_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_PKT_SIZE"                  => [   1,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: XN-to-MD Message Length Error" ],
   "PI_PKT_SIZE"                  => [   2,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: PI-to-MD Message Length Error" ],
   "RED_BLACK_ERR_TIMEOUT"        => [   3,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Red/Black Time-out Error" ],
   "XN_REQUEST_OVERFLOW"          => [   4,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: XN-to-MD Request Queue Overflow Error" ],
   "PI_REQUEST_OVERFLOW"          => [   5,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: PI-to-MD Request Queue Overflow Error" ],
   "XN_REPLY_OVERFLOW"            => [   6,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: XN-to-MD Reply Queue Overflow Error" ],
   "PI_REPLY_OVERFLOW"            => [   7,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: PI-to-MD Reply Queue Overflow Error" ],
   "RSVD1"                        => [   8,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQRS_INT_HW"                  => [   9,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQRS Hardware Error" ],
   "DQRS_INT_COR"                 => [  10,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQRS Correctable AMO Data Error" ],
   "DQRS_INT_UC"                  => [  11,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQRS Uncorrectable AMO Data Error" ],
   "RSVD2"                        => [  12,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQRP_INT_HW"                  => [  13,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQRP Hardware Error" ],
   "DQRP_INT_COR"                 => [  14,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQRP Correctable AMO Data Error" ],
   "DQRP_INT_UC"                  => [  15,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQRP Uncorrectable AMO Data Error" ],
   "RSVD3"                        => [  16,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQLS_INT_HW"                  => [  17,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQLS Hardware Error" ],
   "DQLS_INT_COR"                 => [  18,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQLS Correctable AMO Data Error" ],
   "DQLS_INT_UC"                  => [  19,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQLS Uncorrectable AMO Data Error" ],
   "RSVD4"                        => [  20,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQLP_INT_HW"                  => [  21,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQLP Hardware Error" ],
   "DQLP_INT_COR"                 => [  22,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQLP Correctable AMO Data Error" ],
   "DQLP_INT_UC"                  => [  23,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQLP Uncorrectable AMO Data Error" ],
   "RSVD5"                        => [  24,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR_ACC"                      => [  25,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Directory Memory Access Error" ],
   "ACY_INT_HW"                   => [  26,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "MD_HW_INT: ACY Hardware Error" ],
   "ACX_INT_HW"                   => [  27,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "MD_HW_INT: ACX Hardware Error" ],
   "DQRP_DIR_COR"                 => [  28,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQRP Correctable Directory Data Error" ],
   "DQRP_DIR_UC"                  => [  29,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQRP Uncorrectable Directory Data Error" ],
   "DQLP_DIR_COR"                 => [  30,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQLP Correctable Directory Data Error" ],
   "DQLP_DIR_UC"                  => [  31,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQLP Uncorrectable Directory Data Error" ],
   "DQRP_DIR_PERR"                => [  32,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQRP Directory Protocol Error" ],
   "DQLP_DIR_PERR"                => [  33,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQLP Directory Protocol Error" ],
   "NONEXIST_ADDR"                => [  34,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Non-existent Memory Address Error" ],
   "ILLEGAL_CMD"                  => [  35,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Illegal Command Error" ],
);

%orbit_01_00008_def =
( NAME    => "OC_MEM_ERROR_SUMMARY_ALIAS",
  ADDRESS => 0x00000000800000c0,
  NOTE    => "The MEM_ERROR_SUMMARY_ALIAS address is an alias to the note MEM_ERROR_SUMMARY register. Refer to the MEM_ERROR_SUMMARY register ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00008_flds
);


##########################################################################
#                                                                        #
#   OC_MEM_ERROR_OVERFLOW                                                #
#                                                                        #
##########################################################################

%orbit_01_00009_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_PKT_SIZE"                  => [   1,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: XN-to-MD Message Length Error Overflow" ],
   "PI_PKT_SIZE"                  => [   2,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: PI-to-MD Message Length Error Overflow" ],
   "RED_BLACK_ERR_TIMEOUT"        => [   3,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Red/Black Time-out Error Overflow" ],
   "XN_REQUEST_OVERFLOW"          => [   4,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: XN-to-MD Request Queue Overflow Error Overflow" ],
   "PI_REQUEST_OVERFLOW"          => [   5,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: PI-to-MD Request Queue Overflow Error Overflow" ],
   "XN_REPLY_OVERFLOW"            => [   6,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: XN-to-MD Reply Queue Overflow Error Overflow" ],
   "PI_REPLY_OVERFLOW"            => [   7,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: PI-to-MD Reply Queue Overflow Error Overflow" ],
   "RSVD1"                        => [   8,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQRS_INT_HW"                  => [   9,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQRS Hardware Error Overflow" ],
   "DQRS_INT_COR"                 => [  10,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQRS Correctable AMO Data Error Overflow" ],
   "DQRS_INT_UC"                  => [  11,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQRS Uncorrectable AMO Data Error Overflow" ],
   "RSVD2"                        => [  12,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQRP_INT_HW"                  => [  13,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQRP Hardware Error Overflow" ],
   "DQRP_INT_COR"                 => [  14,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQRP Correctable AMO Data Error Overflow" ],
   "DQRP_INT_UC"                  => [  15,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQRP Uncorrectable AMO Data Error Overflow" ],
   "RSVD3"                        => [  16,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQLS_INT_HW"                  => [  17,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQLS Hardware Error Overflow" ],
   "DQLS_INT_COR"                 => [  18,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQLS Correctable AMO Data Error Overflow" ],
   "DQLS_INT_UC"                  => [  19,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQLS Uncorrectable AMO Data Error Overflow" ],
   "RSVD4"                        => [  20,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQLP_INT_HW"                  => [  21,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQLP Hardware Error Overflow" ],
   "DQLP_INT_COR"                 => [  22,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQLP Correctable AMO Data Error Overflow" ],
   "DQLP_INT_UC"                  => [  23,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQLP Uncorrectable AMO Data Error Overflow" ],
   "RSVD5"                        => [  24,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR_ACC"                      => [  25,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Directory Access Error Overflow" ],
   "ACY_INT_HW"                   => [  26,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "MD_HW_INT: ACY Hardware Error Overflow" ],
   "ACX_INT_HW"                   => [  27,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "MD_HW_INT: ACX Hardware Error Overflow" ],
   "DQRP_DIR_COR"                 => [  28,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQRP Correctable Directory Data Error Overflow" ],
   "DQRP_DIR_UC"                  => [  29,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQRP Uncorrectable Directory Data Error Overflow" ],
   "DQLP_DIR_COR"                 => [  30,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQLP Correctable Directory Data Error Overflow" ],
   "DQLP_DIR_UC"                  => [  31,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQLP Uncorrectable Directory Data Error Overflow" ],
   "DQRP_DIR_PERR"                => [  32,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQRP Directory Protocol Error Overflow" ],
   "DQLP_DIR_PERR"                => [  33,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQLP Directory Protocol Error Overflow" ],
   "NONEXIST_ADDR"                => [  34,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Non-existent Memory Address Error Overflow" ],
   "ILLEGAL_CMD"                  => [  35,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Illegal Command Error Overflow" ],
);

%orbit_01_00009_def =
( NAME    => "OC_MEM_ERROR_OVERFLOW",
  ADDRESS => 0x00000000800000c8,
  NOTE    => "The MEM_ERROR_OVERFLOW register contains 30 flags. Each flag note corresponds to 1 of the 30 errors detected by the MD chiplet. ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00009_flds
);


##########################################################################
#                                                                        #
#   OC_MEM_ERROR_OVERFLOW_ALIAS                                          #
#                                                                        #
##########################################################################

%orbit_01_00010_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_PKT_SIZE"                  => [   1,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: XN-to-MD Message Length Error Overflow" ],
   "PI_PKT_SIZE"                  => [   2,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: PI-to-MD Message Length Error Overflow" ],
   "RED_BLACK_ERR_TIMEOUT"        => [   3,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Red/Black Time-out Error Overflow" ],
   "XN_REQUEST_OVERFLOW"          => [   4,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: XN-to-MD Request Queue Overflow Error Overflow" ],
   "PI_REQUEST_OVERFLOW"          => [   5,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: PI-to-MD Request Queue Overflow Error Overflow" ],
   "XN_REPLY_OVERFLOW"            => [   6,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: XN-to-MD Reply Queue Overflow Error Overflow" ],
   "PI_REPLY_OVERFLOW"            => [   7,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: PI-to-MD Reply Queue Overflow Error Overflow" ],
   "RSVD1"                        => [   8,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQRS_INT_HW"                  => [   9,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQRS Hardware Error Overflow" ],
   "DQRS_INT_COR"                 => [  10,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQRS Correctable AMO Data Error Overflow" ],
   "DQRS_INT_UC"                  => [  11,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQRS Uncorrectable AMO Data Error Overflow" ],
   "RSVD2"                        => [  12,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQRP_INT_HW"                  => [  13,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQRP Hardware Error Overflow" ],
   "DQRP_INT_COR"                 => [  14,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQRP Correctable AMO Data Error Overflow" ],
   "DQRP_INT_UC"                  => [  15,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQRP Uncorrectable AMO Data Error Overflow" ],
   "RSVD3"                        => [  16,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQLS_INT_HW"                  => [  17,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQLS Hardware Error Overflow" ],
   "DQLS_INT_COR"                 => [  18,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQLS Correctable AMO Data Error Overflow" ],
   "DQLS_INT_UC"                  => [  19,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQLS Uncorrectable AMO Data Error Overflow" ],
   "RSVD4"                        => [  20,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQLP_INT_HW"                  => [  21,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQLP Hardware Error Overflow" ],
   "DQLP_INT_COR"                 => [  22,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQLP Correctable AMO Data Error Overflow" ],
   "DQLP_INT_UC"                  => [  23,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQLP Uncorrectable AMO Data Error Overflow" ],
   "RSVD5"                        => [  24,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR_ACC"                      => [  25,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Directory Access Error Overflow" ],
   "ACY_INT_HW"                   => [  26,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "MD_HW_INT: ACY Hardware Error Overflow" ],
   "ACX_INT_HW"                   => [  27,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "MD_HW_INT: ACX Hardware Error Overflow" ],
   "DQRP_DIR_COR"                 => [  28,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQRP Correctable Directory Data Error Overflow" ],
   "DQRP_DIR_UC"                  => [  29,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQRP Uncorrectable Directory Data Error Overflow" ],
   "DQLP_DIR_COR"                 => [  30,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQLP Correctable Directory Data Error Overflow" ],
   "DQLP_DIR_UC"                  => [  31,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQLP Uncorrectable Directory Data Error Overflow" ],
   "DQRP_DIR_PERR"                => [  32,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQRP Directory Protocol Error Overflow" ],
   "DQLP_DIR_PERR"                => [  33,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQLP Directory Protocol Error Overflow" ],
   "NONEXIST_ADDR"                => [  34,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Non-existent Memory Address Error Overflow" ],
   "ILLEGAL_CMD"                  => [  35,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Illegal Command Error Overflow" ],
);

%orbit_01_00010_def =
( NAME    => "OC_MEM_ERROR_OVERFLOW_ALIAS",
  ADDRESS => 0x00000000800000d0,
  NOTE    => "The MEM_ERROR_OVERFLOW_ALIAS address is an alias to the note MEM_ERROR_OVERFLOW register. Refer to the MEM_ERROR_OVERFLOW note r",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00010_flds
);


##########################################################################
#                                                                        #
#   OC_MEM_ERROR_MASK                                                    #
#                                                                        #
##########################################################################

%orbit_01_00011_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_PKT_SIZE"                  => [   1,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: XN-to-MD Message Length Error Mask" ],
   "PI_PKT_SIZE"                  => [   2,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: PI-to-MD Message Length Error Mask" ],
   "RED_BLACK_ERR_TIMEOUT"        => [   3,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Red/Black Time-out Error Mask" ],
   "XN_REQUEST_OVERFLOW"          => [   4,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: XN-to-MD Request Queue Overflow Error Mask" ],
   "PI_REQUEST_OVERFLOW"          => [   5,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: PI-to-MD Request Queue Overflow Error Mask" ],
   "XN_REPLY_OVERFLOW"            => [   6,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: XN-to-MD Reply Queue Overflow Error Mask" ],
   "PI_REPLY_OVERFLOW"            => [   7,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: PI-to-MD Reply Queue Overflow Error Mask" ],
   "RSVD1"                        => [   8,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQRS_INT_HW"                  => [   9,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQRS Hardware Error Mask" ],
   "DQRS_INT_COR"                 => [  10,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQRS Correctable AMO Data Error Mask" ],
   "DQRS_INT_UC"                  => [  11,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQRS Uncorrectable AMO Data Error Mask" ],
   "RSVD2"                        => [  12,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQRP_INT_HW"                  => [  13,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQRP Hardware Error Mask" ],
   "DQRP_INT_COR"                 => [  14,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQRP Correctable AMO Data Error Mask" ],
   "DQRP_INT_UC"                  => [  15,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQRP Uncorrectable AMO Data Error Mask" ],
   "RSVD3"                        => [  16,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQLS_INT_HW"                  => [  17,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQLS Hardware Error Mask" ],
   "DQLS_INT_COR"                 => [  18,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQLS Correctable AMO Data Error Mask" ],
   "DQLS_INT_UC"                  => [  19,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQLS Uncorrectable AMO Data Error Mask" ],
   "RSVD4"                        => [  20,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQLP_INT_HW"                  => [  21,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQLP Hardware Error Mask" ],
   "DQLP_INT_COR"                 => [  22,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQLP Correctable AMO Data Error Mask" ],
   "DQLP_INT_UC"                  => [  23,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQLP Uncorrectable AMO Data Error Mask" ],
   "RSVD5"                        => [  24,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR_ACC"                      => [  25,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Directory Access Error Mask" ],
   "ACY_INT_HW"                   => [  26,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "MD_HW_INT: ACY Hardware Error Mask" ],
   "ACX_INT_HW"                   => [  27,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "MD_HW_INT: ACX Hardware Error Mask" ],
   "DQRP_DIR_COR"                 => [  28,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQRP Correctable Directory Data Error Mask" ],
   "DQRP_DIR_UC"                  => [  29,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQRP Uncorrectable Directory Data Error Mask" ],
   "DQLP_DIR_COR"                 => [  30,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQLP Correctable Directory Data Error Mask" ],
   "DQLP_DIR_UC"                  => [  31,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQLP Uncorrectable Directory Data Error Mask" ],
   "DQRP_DIR_PERR"                => [  32,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQRP Directory Protocol Error Mask" ],
   "DQLP_DIR_PERR"                => [  33,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQLP Directory Protocol Error Mask" ],
   "NONEXIST_ADDR"                => [  34,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Non-existent Memory Address Error Mask" ],
   "ILLEGAL_CMD"                  => [  35,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Illegal Command Error Mask" ],
);

%orbit_01_00011_def =
( NAME    => "OC_MEM_ERROR_MASK",
  ADDRESS => 0x00000000800000d8,
  NOTE    => "The MEM_ERROR_MASK register is the MD's top-level error note configuration register. It contains 30 mask bits. Each mask bit not",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00011_flds
);


##########################################################################
#                                                                        #
#   OC_MISC_ADRS_ERR_HDR_LOWER_A                                         #
#                                                                        #
##########################################################################

%orbit_01_00012_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "set when capture occurs" ],
   "RSVD0"                        => [   1,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE"                        => [   2,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "reference is a write" ],
   "RSVD1"                        => [   3,  38,  22, 0x0FFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR"                         => [   4,   3,  35, 0x0000003FFFFFFFF8, 0x00, 1, 0x0000000000000000, "upper bits of reference address" ],
);

%orbit_01_00012_def =
( NAME    => "OC_MISC_ADRS_ERR_HDR_LOWER_A",
  ADDRESS => 0x00000000800000e0,
  NOTE    => "This register logs some of the bits of the header on the first note occurrence of a packet or directory protocol error.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00012_flds
);


##########################################################################
#                                                                        #
#   OC_DIR_UC_ADRS_ERR_HDR_LOWER_A                                       #
#                                                                        #
##########################################################################

%orbit_01_00013_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "set when capture occurs" ],
   "RSVD0"                        => [   1,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE"                        => [   2,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "reference is a write" ],
   "RSVD1"                        => [   3,  38,  22, 0x0FFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR"                         => [   4,   3,  35, 0x0000003FFFFFFFF8, 0x00, 1, 0x0000000000000000, "upper bits of reference address" ],
);

%orbit_01_00013_def =
( NAME    => "OC_DIR_UC_ADRS_ERR_HDR_LOWER_A",
  ADDRESS => 0x00000000800000e8,
  NOTE    => "This register logs some of the bits of the header on the first note occurrence of an uncorrectable directory error.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00013_flds
);


##########################################################################
#                                                                        #
#   OC_DIR_COR_ADRS_ERR_HDR_LOWER_A                                      #
#                                                                        #
##########################################################################

%orbit_01_00014_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "set when capture occurs" ],
   "RSVD0"                        => [   1,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE"                        => [   2,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "reference is a write" ],
   "RSVD1"                        => [   3,  38,  22, 0x0FFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR"                         => [   4,   3,  35, 0x0000003FFFFFFFF8, 0x00, 1, 0x0000000000000000, "upper bits of reference address" ],
);

%orbit_01_00014_def =
( NAME    => "OC_DIR_COR_ADRS_ERR_HDR_LOWER_A",
  ADDRESS => 0x00000000800000f0,
  NOTE    => "This register logs some of the bits of the header on the first note occurrence of a correctable directory error.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00014_flds
);


##########################################################################
#                                                                        #
#   OC_X_DIMM_CFG                                                        #
#                                                                        #
##########################################################################

%orbit_01_00015_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  37,  27, 0xFFFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "X4_DRAM_EN"                   => [   1,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "x4 dram enable" ],
   "FREQ"                         => [   2,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "DIMM frequency select" ],
   "RSVD1"                        => [   3,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIMM3_CS"                     => [   4,  29,   2, 0x0000000060000000, 0x00, 1, 0x0000000000000000, "DIMM 3 chip select, addr[35:34] match" ],
   "DIMM3_REV"                    => [   5,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "DIMM 3 physical banks reversed" ],
   "DIMM3_2BK"                    => [   6,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "DIMM 3 has two physical banks" ],
   "DIMM3_SIZE"                   => [   7,  24,   3, 0x0000000007000000, 0x00, 1, 0x0000000000000000, "DIMM 3 DRAM size" ],
   "RSVD2"                        => [   8,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIMM2_CS"                     => [   9,  21,   2, 0x0000000000600000, 0x00, 1, 0x0000000000000000, "DIMM 2 chip select, addr[35:34] match" ],
   "DIMM2_REV"                    => [  10,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "DIMM 2 physical banks reversed" ],
   "DIMM2_2BK"                    => [  11,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "DIMM 2 has two physical banks" ],
   "DIMM2_SIZE"                   => [  12,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "DIMM 2 DRAM size" ],
   "RSVD3"                        => [  13,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIMM1_CS"                     => [  14,  13,   2, 0x0000000000006000, 0x00, 1, 0x0000000000000000, "DIMM 1 chip select, addr[35:34] match" ],
   "DIMM1_REV"                    => [  15,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "DIMM 1 physical banks reversed" ],
   "DIMM1_2BK"                    => [  16,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "DIMM 1 has two physical banks" ],
   "DIMM1_SIZE"                   => [  17,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "DIMM 1 DRAM size" ],
   "RSVD4"                        => [  18,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIMM0_CS"                     => [  19,   5,   2, 0x0000000000000060, 0x00, 1, 0x0000000000000000, "DIMM 0 chip select, addr[35:34] match" ],
   "DIMM0_REV"                    => [  20,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "DIMM 0 physical banks reversed" ],
   "DIMM0_2BK"                    => [  21,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "DIMM 0 has two physical banks" ],
   "DIMM0_SIZE"                   => [  22,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "DIMM 0 DRAM size" ],
);

%orbit_01_00015_def =
( NAME    => "OC_X_DIMM_CFG",
  ADDRESS => 0x0000000080010000,
  NOTE    => "Memory configuration register - This register is used to set the note size of the memory DIMMs, number of memory DIMMs, sequenci",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00015_flds
);


##########################################################################
#                                                                        #
#   OC_Y_DIMM_CFG                                                        #
#                                                                        #
##########################################################################

%orbit_01_00016_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  37,  27, 0xFFFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "X4_DRAM_EN"                   => [   1,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "x4 dram enable" ],
   "FREQ"                         => [   2,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "DIMM frequency select" ],
   "RSVD1"                        => [   3,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIMM3_CS"                     => [   4,  29,   2, 0x0000000060000000, 0x00, 1, 0x0000000000000000, "DIMM 3 chip select, addr[35:34] match" ],
   "DIMM3_REV"                    => [   5,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "DIMM 3 physical banks reversed" ],
   "DIMM3_2BK"                    => [   6,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "DIMM 3 has two physical banks" ],
   "DIMM3_SIZE"                   => [   7,  24,   3, 0x0000000007000000, 0x00, 1, 0x0000000000000000, "DIMM 3 DRAM size" ],
   "RSVD2"                        => [   8,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIMM2_CS"                     => [   9,  21,   2, 0x0000000000600000, 0x00, 1, 0x0000000000000000, "DIMM 2 chip select, addr[35:34] match" ],
   "DIMM2_REV"                    => [  10,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "DIMM 2 physical banks reversed" ],
   "DIMM2_2BK"                    => [  11,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "DIMM 2 has two physical banks" ],
   "DIMM2_SIZE"                   => [  12,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "DIMM 2 DRAM size" ],
   "RSVD3"                        => [  13,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIMM1_CS"                     => [  14,  13,   2, 0x0000000000006000, 0x00, 1, 0x0000000000000000, "DIMM 1 chip select, addr[35:34] match" ],
   "DIMM1_REV"                    => [  15,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "DIMM 1 physical banks reversed" ],
   "DIMM1_2BK"                    => [  16,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "DIMM 1 has two physical banks" ],
   "DIMM1_SIZE"                   => [  17,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "DIMM 1 DRAM size" ],
   "RSVD4"                        => [  18,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIMM0_CS"                     => [  19,   5,   2, 0x0000000000000060, 0x00, 1, 0x0000000000000000, "DIMM 0 chip select, addr[35:34] match" ],
   "DIMM0_REV"                    => [  20,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "DIMM 0 physical banks reversed" ],
   "DIMM0_2BK"                    => [  21,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "DIMM 0 has two physical banks" ],
   "DIMM0_SIZE"                   => [  22,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "DIMM 0 DRAM size" ],
);

%orbit_01_00016_def =
( NAME    => "OC_Y_DIMM_CFG",
  ADDRESS => 0x0000000080010008,
  NOTE    => "Memory configuration register - This register is used to set the note size of the memory DIMMs, number of memory DIMMs, sequenci",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00016_flds
);


##########################################################################
#                                                                        #
#   OC_JNR_DIMM_CFG                                                      #
#                                                                        #
##########################################################################

%orbit_01_00017_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  37,  27, 0xFFFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "X4_DRAM_EN"                   => [   1,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "x4 dram enable" ],
   "FREQ"                         => [   2,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "DIMM frequency select" ],
   "RSVD1"                        => [   3,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIMM3_CS"                     => [   4,  29,   2, 0x0000000060000000, 0x00, 1, 0x0000000000000000, "DIMM 3 chip select, addr[35:34] match" ],
   "DIMM3_REV"                    => [   5,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "DIMM 3 physical banks reversed" ],
   "DIMM3_2BK"                    => [   6,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "DIMM 3 has two physical banks" ],
   "DIMM3_SIZE"                   => [   7,  24,   3, 0x0000000007000000, 0x00, 1, 0x0000000000000000, "DIMM 3 DRAM size" ],
   "RSVD2"                        => [   8,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIMM2_CS"                     => [   9,  21,   2, 0x0000000000600000, 0x00, 1, 0x0000000000000000, "DIMM 2 chip select, addr[35:34] match" ],
   "DIMM2_REV"                    => [  10,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "DIMM 2 physical banks reversed" ],
   "DIMM2_2BK"                    => [  11,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "DIMM 2 has two physical banks" ],
   "DIMM2_SIZE"                   => [  12,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "DIMM 2 DRAM size" ],
   "RSVD3"                        => [  13,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIMM1_CS"                     => [  14,  13,   2, 0x0000000000006000, 0x00, 1, 0x0000000000000000, "DIMM 1 chip select, addr[35:34] match" ],
   "DIMM1_REV"                    => [  15,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "DIMM 1 physical banks reversed" ],
   "DIMM1_2BK"                    => [  16,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "DIMM 1 has two physical banks" ],
   "DIMM1_SIZE"                   => [  17,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "DIMM 1 DRAM size" ],
   "RSVD4"                        => [  18,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIMM0_CS"                     => [  19,   5,   2, 0x0000000000000060, 0x00, 1, 0x0000000000000000, "DIMM 0 chip select, addr[35:34] match" ],
   "DIMM0_REV"                    => [  20,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "DIMM 0 physical banks reversed" ],
   "DIMM0_2BK"                    => [  21,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "DIMM 0 has two physical banks" ],
   "DIMM0_SIZE"                   => [  22,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "DIMM 0 DRAM size" ],
);

%orbit_01_00017_def =
( NAME    => "OC_JNR_DIMM_CFG",
  ADDRESS => 0x0000000080010010,
  NOTE    => "Memory configuration register - This register is used to set the note size of the memory DIMMs, number of memory DIMMs, sequenci",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00017_flds
);


##########################################################################
#                                                                        #
#   OC_X_PHASE_CFG                                                       #
#                                                                        #
##########################################################################

%orbit_01_00018_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQ_SEL_A"                     => [   1,  59,   4, 0x7800000000000000, 0x00, 1, 0x0000000000000000, "DATA MCI select A memory clock latch" ],
   "SEL_A"                        => [   2,  55,   4, 0x0780000000000000, 0x00, 1, 0x0000000000000000, "address,control select A memory clock latch" ],
   "PHE_BUBBLE"                   => [   3,  52,   3, 0x0070000000000000, 0x00, 1, 0x0000000000000000, "MMR phaseE bubble value" ],
   "PHD_BUBBLE"                   => [   4,  49,   3, 0x000E000000000000, 0x00, 1, 0x0000000000000000, "MMR phaseD bubble value" ],
   "PHC_BUBBLE"                   => [   5,  46,   3, 0x0001C00000000000, 0x00, 1, 0x0000000000000000, "MMR phaseC bubble value" ],
   "PHB_BUBBLE"                   => [   6,  43,   3, 0x0000380000000000, 0x00, 1, 0x0000000000000000, "MMR phaseB bubble value" ],
   "PHA_BUBBLE"                   => [   7,  40,   3, 0x0000070000000000, 0x00, 1, 0x0000000000000000, "MMR phaseA bubble value" ],
   "BUBBLE_EN"                    => [   8,  35,   5, 0x000000F800000000, 0x00, 1, 0x0000000000000000, "bubble, idle core clock to wait for memory clock" ],
   "ADD_CP"                       => [   9,  30,   5, 0x00000007C0000000, 0x00, 1, 0x0000000000000000, "add delay clock period to dqct delay chain on phase" ],
   "HOLD_REQ"                     => [  10,  25,   5, 0x000000003E000000, 0x00, 1, 0x0000000000000000, "Hold next request on core clock phase" ],
   "HOLD"                         => [  11,  20,   5, 0x0000000001F00000, 0x00, 1, 0x0000000000000000, "Hold request on core clock phase" ],
   "DQ_LD_B"                      => [  12,  15,   5, 0x00000000000F8000, 0x00, 1, 0x0000000000000000, "DATA MCI load core clock B latch" ],
   "DQ_LD_A"                      => [  13,  10,   5, 0x0000000000007C00, 0x00, 1, 0x0000000000000000, "DATA MCI load core clock A latch" ],
   "LD_B"                         => [  14,   5,   5, 0x00000000000003E0, 0x00, 1, 0x0000000000000000, "Address, control load core clock B latch" ],
   "LD_A"                         => [  15,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Address, control load core clock A latch" ],
);

%orbit_01_00018_def =
( NAME    => "OC_X_PHASE_CFG",
  ADDRESS => 0x0000000080010018,
  NOTE    => "Phase Config register is used to control when data is allowed to note cross clock boundaries and which latches are used between ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00018_flds
);


##########################################################################
#                                                                        #
#   OC_X_CFG                                                             #
#                                                                        #
##########################################################################

%orbit_01_00019_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CLR_DIR_CACHE"                => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Clear directory cache tags" ],
   "INV_CAS_ADDR"                 => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Invert cas address bits 3 to 7" ],
   "REQ_CNTR_VAL"                 => [   2,  56,   6, 0x3F00000000000000, 0x00, 1, 0x0000000000000000, "Request counter delay value in CPs" ],
   "REQ_CNTR_DIS"                 => [   3,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "Request delay counter disabled" ],
   "TRCD4_EN"                     => [   4,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "Trcd, ras to case delay of 4 CPs enabled" ],
   "TRCD2_EN"                     => [   5,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "Trcd, ras to cas delay of 2 CPs enabled" ],
   "SSO_WT_EN"                    => [   6,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "Simultaneous switching enabled on output data pins" ],
   "WT_BB_CLR"                    => [   7,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "Bank busy CPs for all write request" ],
   "DC_BB_CLR"                    => [   8,  44,   4, 0x0000F00000000000, 0x00, 1, 0x0000000000000000, "Bank busy CPs for a directory cache read request" ],
   "DA_BB_CLR"                    => [   9,  40,   4, 0x00000F0000000000, 0x00, 1, 0x0000000000000000, "Bank busy CPs for a data read request" ],
   "TA_DLYS"                      => [  10,   8,  32, 0x000000FFFFFFFF00, 0x00, 1, 0x0000000000000000, "Turn around delays" ],
   "DIR_COUNTER_INIT"             => [  11,   2,   6, 0x00000000000000FC, 0x00, 1, 0x0000000000000000, "Dir counter initial value" ],
   "DIRC_RANDOM_REPLACEMENT"      => [  12,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Directory cache random replacement" ],
   "MODE_SERIAL"                  => [  13,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Arbque arbitration in serial mode" ],
);

%orbit_01_00019_def =
( NAME    => "OC_X_CFG",
  ADDRESS => 0x0000000080010020,
  NOTE    => "AC (Address and control) configuration registers. This register has note MMR values to adjacent the performance of memory. Examp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00019_flds
);


##########################################################################
#                                                                        #
#   OC_X_DQCT_CFG                                                        #
#                                                                        #
##########################################################################

%orbit_01_00020_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  27,  37, 0xFFFFFFFFF8000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NCRP_FULL_CL"                 => [   1,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "NCRP reply is full cache line" ],
   "WBQ_FLUSH_ALL"                => [   2,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Dir cache victim flush enable for all requests" ],
   "WBQ_FLUSH_EN"                 => [   3,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Dir cache victim flush enable" ],
   "MDIR_RD_SEL"                  => [   4,  20,   4, 0x0000000000F00000, 0x00, 1, 0x0000000000000000, "Dir ready read select" ],
   "DIR_RD_SEL"                   => [   5,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "Dir ready read select" ],
   "DTA_WT_SEL"                   => [   6,  12,   4, 0x000000000000F000, 0x00, 1, 0x0000000000000000, "Data ready write select" ],
   "DTA_RD_SEL"                   => [   7,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "Data ready read select" ],
   "WT_SEL"                       => [   8,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "Write data select" ],
   "RD_SEL"                       => [   9,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Read data select" ],
);

%orbit_01_00020_def =
( NAME    => "OC_X_DQCT_CFG",
  ADDRESS => 0x0000000080010028,
  NOTE    => "The dqct config register configures the DQ (data path) control note logic. Examples include rd_sel which indicates when read dat",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00020_flds
);


##########################################################################
#                                                                        #
#   OC_X_REFRESH_CONTROL                                                 #
#                                                                        #
##########################################################################

%orbit_01_00021_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HALF_RATE"                    => [   1,  24,   4, 0x000000000F000000, 0x00, 1, 0x0000000000000000, "Refresh half rate" ],
   "INTERLEAVE"                   => [   2,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "Refresh interleave" ],
   "HOLD"                         => [   3,  17,   6, 0x00000000007E0000, 0x00, 1, 0x0000000000000000, "Refresh hold" ],
   "INTERVAL"                     => [   4,   8,   9, 0x000000000001FF00, 0x00, 1, 0x0000000000000000, "Refresh interval in core CPs" ],
   "ENABLE"                       => [   5,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Refresh enable" ],
);

%orbit_01_00021_def =
( NAME    => "OC_X_REFRESH_CONTROL",
  ADDRESS => 0x0000000080010030,
  NOTE    => "The refresh control register controls when and to which DIMMs note refresh requests are generated.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00021_flds
);


##########################################################################
#                                                                        #
#   OC_X_AMOC_CFG                                                        #
#                                                                        #
##########################################################################

%orbit_01_00022_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   4,  60, 0xFFFFFFFFFFFFFFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AMOC_TAG_CAP"                 => [   1,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "amoc tag capture" ],
   "AMOC_SEL_LTAG"                => [   2,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "amoc left side tag select" ],
   "AMOC_SEL_TAG1"                => [   3,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "amoc tag select" ],
   "AMOC_EN"                      => [   4,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "amoc enable" ],
);

%orbit_01_00022_def =
( NAME    => "OC_X_AMOC_CFG",
  ADDRESS => 0x0000000080010038,
  NOTE    => "The amoc config register configures amoc cache.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00022_flds
);


##########################################################################
#                                                                        #
#   OC_X_AMOC_TAG                                                        #
#                                                                        #
##########################################################################

%orbit_01_00023_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR"                         => [   1,   4,  30, 0x00000003FFFFFFF0, 0x00, 1, 0x0000000000000000, "tag address" ],
   "VAL"                          => [   2,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "tag valid" ],
);

%orbit_01_00023_def =
( NAME    => "OC_X_AMOC_TAG",
  ADDRESS => 0x0000000080010040,
  NOTE    => "The amoc tag capture register captures the amoc valid bit and note corresponding tag value.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00023_flds
);


##########################################################################
#                                                                        #
#   OC_Y_PHASE_CFG                                                       #
#                                                                        #
##########################################################################

%orbit_01_00024_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQ_SEL_A"                     => [   1,  59,   4, 0x7800000000000000, 0x00, 1, 0x0000000000000000, "DATA MCI select A memory clock latch" ],
   "SEL_A"                        => [   2,  55,   4, 0x0780000000000000, 0x00, 1, 0x0000000000000000, "address,control select A memory clock latch" ],
   "PHE_BUBBLE"                   => [   3,  52,   3, 0x0070000000000000, 0x00, 1, 0x0000000000000000, "MMR phaseE bubble value" ],
   "PHD_BUBBLE"                   => [   4,  49,   3, 0x000E000000000000, 0x00, 1, 0x0000000000000000, "MMR phaseD bubble value" ],
   "PHC_BUBBLE"                   => [   5,  46,   3, 0x0001C00000000000, 0x00, 1, 0x0000000000000000, "MMR phaseC bubble value" ],
   "PHB_BUBBLE"                   => [   6,  43,   3, 0x0000380000000000, 0x00, 1, 0x0000000000000000, "MMR phaseB bubble value" ],
   "PHA_BUBBLE"                   => [   7,  40,   3, 0x0000070000000000, 0x00, 1, 0x0000000000000000, "MMR phaseA bubble value" ],
   "BUBBLE_EN"                    => [   8,  35,   5, 0x000000F800000000, 0x00, 1, 0x0000000000000000, "bubble, idle core clock to wait for memory clock" ],
   "ADD_CP"                       => [   9,  30,   5, 0x00000007C0000000, 0x00, 1, 0x0000000000000000, "add delay clock period to dqct delay chain on phase" ],
   "HOLD_REQ"                     => [  10,  25,   5, 0x000000003E000000, 0x00, 1, 0x0000000000000000, "Hold next request on core clock phase" ],
   "HOLD"                         => [  11,  20,   5, 0x0000000001F00000, 0x00, 1, 0x0000000000000000, "Hold request on core clock phase" ],
   "DQ_LD_B"                      => [  12,  15,   5, 0x00000000000F8000, 0x00, 1, 0x0000000000000000, "DATA MCI load core clock B latch" ],
   "DQ_LD_A"                      => [  13,  10,   5, 0x0000000000007C00, 0x00, 1, 0x0000000000000000, "DATA MCI load core clock A latch" ],
   "LD_B"                         => [  14,   5,   5, 0x00000000000003E0, 0x00, 1, 0x0000000000000000, "Address, control load core clock B latch" ],
   "LD_A"                         => [  15,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Address, control load core clock A latch" ],
);

%orbit_01_00024_def =
( NAME    => "OC_Y_PHASE_CFG",
  ADDRESS => 0x0000000080010048,
  NOTE    => "Phase Config register is used to control when data is allowed to note cross clock boundaries and which latches are used between ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00024_flds
);


##########################################################################
#                                                                        #
#   OC_Y_CFG                                                             #
#                                                                        #
##########################################################################

%orbit_01_00025_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CLR_DIR_CACHE"                => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Clear directory cache tags" ],
   "INV_CAS_ADDR"                 => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Invert cas address bits 3 to 7" ],
   "REQ_CNTR_VAL"                 => [   2,  56,   6, 0x3F00000000000000, 0x00, 1, 0x0000000000000000, "Request counter delay value in CPs" ],
   "REQ_CNTR_DIS"                 => [   3,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "Request delay counter disabled" ],
   "TRCD4_EN"                     => [   4,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "Trcd, ras to case delay of 4 CPs enabled" ],
   "TRCD2_EN"                     => [   5,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "Trcd, ras to cas delay of 2 CPs enabled" ],
   "SSO_WT_EN"                    => [   6,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "Simultaneous switching enabled on output data pins" ],
   "WT_BB_CLR"                    => [   7,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "Bank busy CPs for all write request" ],
   "DC_BB_CLR"                    => [   8,  44,   4, 0x0000F00000000000, 0x00, 1, 0x0000000000000000, "Bank busy CPs for a directory cache read request" ],
   "DA_BB_CLR"                    => [   9,  40,   4, 0x00000F0000000000, 0x00, 1, 0x0000000000000000, "Bank busy CPs for a data read request" ],
   "TA_DLYS"                      => [  10,   8,  32, 0x000000FFFFFFFF00, 0x00, 1, 0x0000000000000000, "Turn around delays" ],
   "DIR_COUNTER_INIT"             => [  11,   2,   6, 0x00000000000000FC, 0x00, 1, 0x0000000000000000, "Dir counter initial value" ],
   "DIRC_RANDOM_REPLACEMENT"      => [  12,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Directory cache random replacement" ],
   "MODE_SERIAL"                  => [  13,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Arbque arbitration in serial mode" ],
);

%orbit_01_00025_def =
( NAME    => "OC_Y_CFG",
  ADDRESS => 0x0000000080010050,
  NOTE    => "AC (Address and control) configuration registers. This register has note MMR values to adjacent the performance of memory. Examp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00025_flds
);


##########################################################################
#                                                                        #
#   OC_Y_DQCT_CFG                                                        #
#                                                                        #
##########################################################################

%orbit_01_00026_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  27,  37, 0xFFFFFFFFF8000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NCRP_FULL_CL"                 => [   1,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "NCRP reply is full cache line" ],
   "WBQ_FLUSH_ALL"                => [   2,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Dir cache victim flush enable for all requests" ],
   "WBQ_FLUSH_EN"                 => [   3,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Dir cache victim flush enable" ],
   "MDIR_RD_SEL"                  => [   4,  20,   4, 0x0000000000F00000, 0x00, 1, 0x0000000000000000, "Dir ready read select" ],
   "DIR_RD_SEL"                   => [   5,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "Dir ready read select" ],
   "DTA_WT_SEL"                   => [   6,  12,   4, 0x000000000000F000, 0x00, 1, 0x0000000000000000, "Data ready write select" ],
   "DTA_RD_SEL"                   => [   7,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "Data ready read select" ],
   "WT_SEL"                       => [   8,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "Write data select" ],
   "RD_SEL"                       => [   9,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Read data select" ],
);

%orbit_01_00026_def =
( NAME    => "OC_Y_DQCT_CFG",
  ADDRESS => 0x0000000080010058,
  NOTE    => "The dqct config register configures the DQ (data path) control note logic. Examples include rd_sel which indicates when read dat",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00026_flds
);


##########################################################################
#                                                                        #
#   OC_Y_REFRESH_CONTROL                                                 #
#                                                                        #
##########################################################################

%orbit_01_00027_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HALF_RATE"                    => [   1,  24,   4, 0x000000000F000000, 0x00, 1, 0x0000000000000000, "Refresh half rate" ],
   "INTERLEAVE"                   => [   2,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "Refresh interleave" ],
   "HOLD"                         => [   3,  17,   6, 0x00000000007E0000, 0x00, 1, 0x0000000000000000, "Refresh hold" ],
   "INTERVAL"                     => [   4,   8,   9, 0x000000000001FF00, 0x00, 1, 0x0000000000000000, "Refresh interval in core CPs" ],
   "ENABLE"                       => [   5,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Refresh enable" ],
);

%orbit_01_00027_def =
( NAME    => "OC_Y_REFRESH_CONTROL",
  ADDRESS => 0x0000000080010060,
  NOTE    => "The refresh control register controls when and to which DIMMs note refresh requests are generated.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00027_flds
);


##########################################################################
#                                                                        #
#   OC_Y_AMOC_CFG                                                        #
#                                                                        #
##########################################################################

%orbit_01_00028_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   4,  60, 0xFFFFFFFFFFFFFFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AMOC_TAG_CAP"                 => [   1,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "amoc tag capture" ],
   "AMOC_SEL_LTAG"                => [   2,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "amoc left side tag select" ],
   "AMOC_SEL_TAG1"                => [   3,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "amoc tag select" ],
   "AMOC_EN"                      => [   4,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "amoc enable" ],
);

%orbit_01_00028_def =
( NAME    => "OC_Y_AMOC_CFG",
  ADDRESS => 0x0000000080010068,
  NOTE    => "The amoc config register configures amoc cache.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00028_flds
);


##########################################################################
#                                                                        #
#   OC_Y_AMOC_TAG                                                        #
#                                                                        #
##########################################################################

%orbit_01_00029_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR"                         => [   1,   4,  30, 0x00000003FFFFFFF0, 0x00, 1, 0x0000000000000000, "tag address" ],
   "VAL"                          => [   2,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "tag valid" ],
);

%orbit_01_00029_def =
( NAME    => "OC_Y_AMOC_TAG",
  ADDRESS => 0x0000000080010070,
  NOTE    => "The amoc tag capture register captures the amoc valid bit and note corresponding tag value.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00029_flds
);


##########################################################################
#                                                                        #
#   OC_MEM_RED_BLACK                                                     #
#                                                                        #
##########################################################################

%orbit_01_00030_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  52,  12, 0xFFF0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERR_TIME"                     => [   1,  16,  36, 0x000FFFFFFFFF0000, 0x00, 1, 0x0000000000000000, "Max clocks to wait after red/black change for old color to clear." ],
   "TIME"                         => [   2,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "Clocks to tag references with a given color" ],
);

%orbit_01_00030_def =
( NAME    => "OC_MEM_RED_BLACK",
  ADDRESS => 0x0000000080010078,
  NOTE    => "This register provides a means to ensure a maximum amount of time note that a reference can spend in the memory system. This is ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00030_flds
);


##########################################################################
#                                                                        #
#   OC_MISC_MEM_CFG                                                      #
#                                                                        #
##########################################################################

%orbit_01_00031_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NODE_ID_MASK_BIT_7"           => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Used for extending coherence domain greater than 256 nodes" ],
   "NODE_ID_MASK_BIT_8"           => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Used for extending coherence domain greater than 256 nodes" ],
   "NODE_ID_MASK_BIT_9"           => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "Used for extending coherence domain greater than 256 nodes" ],
   "NODE_ID_MASK_BIT_10"          => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "Used for extending coherence domain greater than 256 nodes" ],
   "NODE_ID_MASK_BIT_11"          => [   4,  59,   1, 0x0800000000000000, 0x00, 1, 0x0000000000000000, "Used for extending coherence domain greater than 256 nodes" ],
   "NODE_ID_MASK_BIT_12"          => [   5,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "Used for extending coherence domain greater than 256 nodes" ],
   "NODE_ID_MASK_BIT_13"          => [   6,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "Used for extending coherence domain greater than 256 nodes" ],
   "X4_DRAM_ENABLE"               => [   7,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "enables x4 dram dimm support logic" ],
   "NCRP_FULL_CL"                 => [   8,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "NCRP reply is full cache line" ],
   "RESPOND_TO_READ_IN_DIR_SPACE" => [   9,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "If set MD will respond with AERR to read in directory space" ],
   "DIMM_SELECT_MUX"              => [  10,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "If set MD will use [37:36] vs [35:34] for DIMM select mux" ],
   "ALTERNATE_XN_RP_PLANE"        => [  11,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "enables plane alternating for replies to XN" ],
   "RSVD0"                        => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SPEC_VALID"                   => [  13,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "If set Orbit MD behaves the same as Shub MD" ],
   "DISABLED_VICTIMS"             => [  14,  44,   6, 0x0003F00000000000, 0x00, 1, 0x0000000000000000, "number of dir cache victim buffers to take out of circulation in each quadrant of the MD" ],
   "RSVD1"                        => [  15,  41,   3, 0x00000E0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DISABLED_WRITE_TNUMS"         => [  16,  36,   5, 0x000001F000000000, 0x00, 1, 0x0000000000000000, "number of write tnums to take out of circulation" ],
   "RSVD2"                        => [  17,  33,   3, 0x0000000E00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DISABLED_READ_TNUMS"          => [  18,  28,   5, 0x00000001F0000000, 0x00, 1, 0x0000000000000000, "number of read tnums to take out of circulation" ],
   "THROTTLE_CNT"                 => [  19,  20,   8, 0x000000000FF00000, 0x00, 1, 0x0000000000000000, "number of clocks between accepting references" ],
   "RSVD3"                        => [  20,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LOW_VICTIM_BUFFER_THRESHOLD"  => [  21,  12,   6, 0x000000000003F000, 0x00, 1, 0x0000000000000000, "point at which dir cache writes get higher priority" ],
   "RSVD4"                        => [  22,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LOW_WRITE_BUFFER_THRESHOLD"   => [  23,   4,   6, 0x00000000000003F0, 0x00, 1, 0x0000000000000000, "point at which data writes get higher priority" ],
   "XN_RD_SAME_AS_PI"             => [  24,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "disables a one clock delay of XN read data" ],
   "JNR_BYPASS_ENABLE"            => [  25,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "enables bypass path for requests going through ac" ],
   "SPEC_HEADER_ENABLE"           => [  26,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "enables the use of speculative headers from md to pi" ],
   "EXPRESS_HEADER_ENABLE"        => [  27,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "enables the use of express headers from md to pi" ],
);

%orbit_01_00031_def =
( NAME    => "OC_MISC_MEM_CFG",
  ADDRESS => 0x0000000080010080,
  NOTE    => "This register contains miscellaneous memory configuration note information.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00031_flds
);


##########################################################################
#                                                                        #
#   OC_PIO_RQ_CRD_CTL                                                    #
#                                                                        #
##########################################################################

%orbit_01_00032_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   6,  58, 0xFFFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEPTH"                        => [   1,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Total depth of buffering (in sic packets)" ],
);

%orbit_01_00032_def =
( NAME    => "OC_PIO_RQ_CRD_CTL",
  ADDRESS => 0x0000000080010088,
  NOTE    => "This register provides control of the number of packets that are note allowed to be in progress on this virtual channel.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00032_flds
);


##########################################################################
#                                                                        #
#   OC_PI_MD_RQ_CRD_CTL                                                  #
#                                                                        #
##########################################################################

%orbit_01_00033_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   6,  58, 0xFFFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEPTH"                        => [   1,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Total depth of buffering (in sic packets)" ],
);

%orbit_01_00033_def =
( NAME    => "OC_PI_MD_RQ_CRD_CTL",
  ADDRESS => 0x0000000080010090,
  NOTE    => "This register provides control of the number of packets that are note allowed to be in progress on this virtual channel.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00033_flds
);


##########################################################################
#                                                                        #
#   OC_PI_MD_RP_CRD_CTL                                                  #
#                                                                        #
##########################################################################

%orbit_01_00034_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   6,  58, 0xFFFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEPTH"                        => [   1,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Total depth of buffering (in sic packets)" ],
);

%orbit_01_00034_def =
( NAME    => "OC_PI_MD_RP_CRD_CTL",
  ADDRESS => 0x0000000080010098,
  NOTE    => "This register provides control of the number of packets that are note allowed to be in progress on this virtual channel.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00034_flds
);


##########################################################################
#                                                                        #
#   OC_XN_MD_RQ_CRD_CTL                                                  #
#                                                                        #
##########################################################################

%orbit_01_00035_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   6,  58, 0xFFFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEPTH"                        => [   1,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Total depth of buffering (in sic packets)" ],
);

%orbit_01_00035_def =
( NAME    => "OC_XN_MD_RQ_CRD_CTL",
  ADDRESS => 0x00000000800100a0,
  NOTE    => "This register provides control of the number of packets that are note allowed to be in progress on this virtual channel.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00035_flds
);


##########################################################################
#                                                                        #
#   OC_XN_MD_RP_CRD_CTL                                                  #
#                                                                        #
##########################################################################

%orbit_01_00036_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   6,  58, 0xFFFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEPTH"                        => [   1,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Total depth of buffering (in sic packets)" ],
);

%orbit_01_00036_def =
( NAME    => "OC_XN_MD_RP_CRD_CTL",
  ADDRESS => 0x00000000800100a8,
  NOTE    => "This register provides control of the number of packets that are note allowed to be in progress on this virtual channel.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00036_flds
);


##########################################################################
#                                                                        #
#   OC_X_TAG0                                                            #
#                                                                        #
##########################################################################

%orbit_01_00037_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "Valid + Tag Address" ],
);

%orbit_01_00037_def =
( NAME    => "OC_X_TAG0",
  ADDRESS => 0x0000000080020000,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00037_flds
);


##########################################################################
#                                                                        #
#   OC_X_TAG1                                                            #
#                                                                        #
##########################################################################

%orbit_01_00038_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "Valid + Tag Address" ],
);

%orbit_01_00038_def =
( NAME    => "OC_X_TAG1",
  ADDRESS => 0x0000000080020008,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00038_flds
);


##########################################################################
#                                                                        #
#   OC_X_TAG2                                                            #
#                                                                        #
##########################################################################

%orbit_01_00039_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "Valid + Tag Address" ],
);

%orbit_01_00039_def =
( NAME    => "OC_X_TAG2",
  ADDRESS => 0x0000000080020010,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00039_flds
);


##########################################################################
#                                                                        #
#   OC_X_TAG3                                                            #
#                                                                        #
##########################################################################

%orbit_01_00040_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "Valid + Tag Address" ],
);

%orbit_01_00040_def =
( NAME    => "OC_X_TAG3",
  ADDRESS => 0x0000000080020018,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00040_flds
);


##########################################################################
#                                                                        #
#   OC_X_TAG4                                                            #
#                                                                        #
##########################################################################

%orbit_01_00041_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "Valid + Tag Address" ],
);

%orbit_01_00041_def =
( NAME    => "OC_X_TAG4",
  ADDRESS => 0x0000000080020020,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00041_flds
);


##########################################################################
#                                                                        #
#   OC_X_TAG5                                                            #
#                                                                        #
##########################################################################

%orbit_01_00042_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "Valid + Tag Address" ],
);

%orbit_01_00042_def =
( NAME    => "OC_X_TAG5",
  ADDRESS => 0x0000000080020028,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00042_flds
);


##########################################################################
#                                                                        #
#   OC_X_TAG6                                                            #
#                                                                        #
##########################################################################

%orbit_01_00043_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "Valid + Tag Address" ],
);

%orbit_01_00043_def =
( NAME    => "OC_X_TAG6",
  ADDRESS => 0x0000000080020030,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00043_flds
);


##########################################################################
#                                                                        #
#   OC_X_TAG7                                                            #
#                                                                        #
##########################################################################

%orbit_01_00044_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "Valid + Tag Address" ],
);

%orbit_01_00044_def =
( NAME    => "OC_X_TAG7",
  ADDRESS => 0x0000000080020038,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00044_flds
);


##########################################################################
#                                                                        #
#   OC_Y_TAG0                                                            #
#                                                                        #
##########################################################################

%orbit_01_00045_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "Valid + Tag Address" ],
);

%orbit_01_00045_def =
( NAME    => "OC_Y_TAG0",
  ADDRESS => 0x0000000080020040,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00045_flds
);


##########################################################################
#                                                                        #
#   OC_Y_TAG1                                                            #
#                                                                        #
##########################################################################

%orbit_01_00046_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "Valid + Tag Address" ],
);

%orbit_01_00046_def =
( NAME    => "OC_Y_TAG1",
  ADDRESS => 0x0000000080020048,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00046_flds
);


##########################################################################
#                                                                        #
#   OC_Y_TAG2                                                            #
#                                                                        #
##########################################################################

%orbit_01_00047_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "Valid + Tag Address" ],
);

%orbit_01_00047_def =
( NAME    => "OC_Y_TAG2",
  ADDRESS => 0x0000000080020050,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00047_flds
);


##########################################################################
#                                                                        #
#   OC_Y_TAG3                                                            #
#                                                                        #
##########################################################################

%orbit_01_00048_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "Valid + Tag Address" ],
);

%orbit_01_00048_def =
( NAME    => "OC_Y_TAG3",
  ADDRESS => 0x0000000080020058,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00048_flds
);


##########################################################################
#                                                                        #
#   OC_Y_TAG4                                                            #
#                                                                        #
##########################################################################

%orbit_01_00049_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "Valid + Tag Address" ],
);

%orbit_01_00049_def =
( NAME    => "OC_Y_TAG4",
  ADDRESS => 0x0000000080020060,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00049_flds
);


##########################################################################
#                                                                        #
#   OC_Y_TAG5                                                            #
#                                                                        #
##########################################################################

%orbit_01_00050_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "Valid + Tag Address" ],
);

%orbit_01_00050_def =
( NAME    => "OC_Y_TAG5",
  ADDRESS => 0x0000000080020068,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00050_flds
);


##########################################################################
#                                                                        #
#   OC_Y_TAG6                                                            #
#                                                                        #
##########################################################################

%orbit_01_00051_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "Valid + Tag Address" ],
);

%orbit_01_00051_def =
( NAME    => "OC_Y_TAG6",
  ADDRESS => 0x0000000080020070,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00051_flds
);


##########################################################################
#                                                                        #
#   OC_Y_TAG7                                                            #
#                                                                        #
##########################################################################

%orbit_01_00052_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "Valid + Tag Address" ],
);

%orbit_01_00052_def =
( NAME    => "OC_Y_TAG7",
  ADDRESS => 0x0000000080020078,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00052_flds
);


##########################################################################
#                                                                        #
#   OC_MMRBIST_BASE                                                      #
#                                                                        #
##########################################################################

%orbit_01_00053_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  50,  14, 0xFFFC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DWORD_ADDR"                   => [   1,   3,  47, 0x0003FFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "bits 49:3 of the memory address" ],
);

%orbit_01_00053_def =
( NAME    => "OC_MMRBIST_BASE",
  ADDRESS => 0x0000000080020080,
  NOTE    => "This register provides the starting address for an mmr/bist note operation.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00053_flds
);


##########################################################################
#                                                                        #
#   OC_MMRBIST_CTL                                                       #
#                                                                        #
##########################################################################

%orbit_01_00054_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  45,  19, 0xFFFFE00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RESET_STATE"                  => [   1,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "writing a 1 resets mmrbist hardware, hardware clears on completion" ],
   "RSVD1"                        => [   2,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MEM_IDLE"                     => [   3,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "all memory activity is complete" ],
   "FAIL"                         => [   4,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "mmr/bist had a data or address error" ],
   "IN_PROGRESS"                  => [   5,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "writing a 1 starts operation, hardware clears on completion" ],
   "RSVD2"                        => [   6,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CMD"                          => [   7,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "mmr/bist function" ],
   "RSVD3"                        => [   8,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BLOCK_LENGTH"                 => [   9,   0,  31, 0x000000007FFFFFFF, 0x00, 0, 0x0000000000000000, "number of dwords in operation" ],
);

%orbit_01_00054_def =
( NAME    => "OC_MMRBIST_CTL",
  ADDRESS => 0x0000000080020088,
  NOTE    => "The registers controls the size and function of the mmr/bist note operation. An operation will continue in the face of a data er",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00054_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DBUG_DATA_CFG                                                  #
#                                                                        #
##########################################################################

%orbit_01_00055_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE"               => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "selects which nibble from selected chiplet drives nibble7" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_CHIPLET"              => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "selects which md chiplet drives nibble7" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE"               => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "selects which nibble from selected chiplet drives nibble6" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_CHIPLET"              => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "selects which md chiplet drives nibble6" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE"               => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "selects which nibble from selected chiplet drives nibble5" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_CHIPLET"              => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "selects which md chiplet drives nibble5" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE"               => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "selects which nibble from selected chiplet drives nibble4" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_CHIPLET"              => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "selects which md chiplet drives nibble4" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE"               => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "selects which nibble from selected chiplet drives nibble3" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_CHIPLET"              => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "selects which md chiplet drives nibble3" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE"               => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "selects which nibble from selected chiplet drives nibble2" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_CHIPLET"              => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "selects which md chiplet drives nibble2" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE"               => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "selects which nibble from selected chiplet drives nibble1" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_CHIPLET"              => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "selects which md chiplet drives nibble1" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE"               => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "selects which nibble from selected chiplet drives nibble0" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_CHIPLET"              => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "selects which md chiplet drives nibble0" ],
);

%orbit_01_00055_def =
( NAME    => "OC_MD_DBUG_DATA_CFG",
  ADDRESS => 0x0000000080020100,
  NOTE    => "Maps chiplets and associated nibbles to MD debug port. This note register controls the construction of a 32-bit debug word that ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00055_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DBUG_TRIGGER_CFG                                               #
#                                                                        #
##########################################################################

%orbit_01_00056_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "enables triggering on pattern match" ],
   "NIBBLE7_NIBBLE"               => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "selects which nibble from selected chiplet drives nibble7" ],
   "RSVD0"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_CHIPLET"              => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "selects which md chiplet drives nibble7" ],
   "RSVD1"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE"               => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "selects which nibble from selected chiplet drives nibble6" ],
   "RSVD2"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_CHIPLET"              => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "selects which md chiplet drives nibble6" ],
   "RSVD3"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE"               => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "selects which nibble from selected chiplet drives nibble5" ],
   "RSVD4"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_CHIPLET"              => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "selects which md chiplet drives nibble5" ],
   "RSVD5"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE"               => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "selects which nibble from selected chiplet drives nibble4" ],
   "RSVD6"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_CHIPLET"              => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "selects which md chiplet drives nibble4" ],
   "RSVD7"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE"               => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "selects which nibble from selected chiplet drives nibble3" ],
   "RSVD8"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_CHIPLET"              => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "selects which md chiplet drives nibble3" ],
   "RSVD9"                        => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE"               => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "selects which nibble from selected chiplet drives nibble2" ],
   "RSVD10"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_CHIPLET"              => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "selects which md chiplet drives nibble2" ],
   "RSVD11"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE"               => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "selects which nibble from selected chiplet drives nibble1" ],
   "RSVD12"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_CHIPLET"              => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "selects which md chiplet drives nibble1" ],
   "RSVD13"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE"               => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "selects which nibble from selected chiplet drives nibble0" ],
   "RSVD14"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_CHIPLET"              => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "selects which md chiplet drives nibble0" ],
);

%orbit_01_00056_def =
( NAME    => "OC_MD_DBUG_TRIGGER_CFG",
  ADDRESS => 0x0000000080020108,
  NOTE    => "This register controls the muxes used for pattern matching. A set note of muxes exists to construct a 32 bit word to compare aga",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00056_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DBUG_COMPARE                                                   #
#                                                                        #
##########################################################################

%orbit_01_00057_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "bits to include in compare of dbug data for trigger" ],
   "PATTERN"                      => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "pattern against which to compare dbug data for trigger" ],
);

%orbit_01_00057_def =
( NAME    => "OC_MD_DBUG_COMPARE",
  ADDRESS => 0x0000000080020110,
  NOTE    => "The debug compare and mask values in this register are used to do note pattern matching on a 32 bit trigger word created from de",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00057_flds
);


##########################################################################
#                                                                        #
#   OC_X_TAG_DBUG_SEL                                                    #
#                                                                        #
##########################################################################

%orbit_01_00058_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG_SEL"                      => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "tagmgr select" ],
);

%orbit_01_00058_def =
( NAME    => "OC_X_TAG_DBUG_SEL",
  ADDRESS => 0x0000000080020118,
  NOTE    => "Each AC can be configured to send the appropriate internal state to note the output debug port. This register is used to select ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00058_flds
);


##########################################################################
#                                                                        #
#   OC_X_WBQ_DBUG_SEL                                                    #
#                                                                        #
##########################################################################

%orbit_01_00059_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WBQ_SEL"                      => [   1,   0,  24, 0x0000000000FFFFFF, 0x00, 0, 0x0000000000000000, "wbqtg select" ],
);

%orbit_01_00059_def =
( NAME    => "OC_X_WBQ_DBUG_SEL",
  ADDRESS => 0x0000000080020120,
  NOTE    => "Each AC can be configured to send the appropriate internal state to note the output debug port. This register is used to select ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00059_flds
);


##########################################################################
#                                                                        #
#   OC_X_ARB_DBUG_SEL                                                    #
#                                                                        #
##########################################################################

%orbit_01_00060_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARB_SEL"                      => [   1,   0,  24, 0x0000000000FFFFFF, 0x00, 0, 0x0000000000000000, "arbque select" ],
);

%orbit_01_00060_def =
( NAME    => "OC_X_ARB_DBUG_SEL",
  ADDRESS => 0x0000000080020128,
  NOTE    => "Each AC can be configured to send the appropriate internal state to note the output debug port. This register is used to select ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00060_flds
);


##########################################################################
#                                                                        #
#   OC_X_ATL_DBUG_SEL                                                    #
#                                                                        #
##########################################################################

%orbit_01_00061_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ATL_SEL"                      => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "aintl select" ],
);

%orbit_01_00061_def =
( NAME    => "OC_X_ATL_DBUG_SEL",
  ADDRESS => 0x0000000080020130,
  NOTE    => "Each AC can be configured to send the appropriate internal state to note the output debug port. This register is used to select ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00061_flds
);


##########################################################################
#                                                                        #
#   OC_X_ATR_DBUG_SEL                                                    #
#                                                                        #
##########################################################################

%orbit_01_00062_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ATR_SEL"                      => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "aintr select" ],
);

%orbit_01_00062_def =
( NAME    => "OC_X_ATR_DBUG_SEL",
  ADDRESS => 0x0000000080020138,
  NOTE    => "Each AC can be configured to send the appropriate internal state to note the output debug port. This register is used to select ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00062_flds
);


##########################################################################
#                                                                        #
#   OC_X_DQL_DBUG_SEL                                                    #
#                                                                        #
##########################################################################

%orbit_01_00063_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  15,  49, 0xFFFFFFFFFFFF8000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQL_SEL"                      => [   1,   0,  15, 0x0000000000007FFF, 0x00, 0, 0x0000000000000000, "dqctr select" ],
);

%orbit_01_00063_def =
( NAME    => "OC_X_DQL_DBUG_SEL",
  ADDRESS => 0x0000000080020140,
  NOTE    => "Each AC can be configured to send the appropriate internal state to note the output debug port. This register is used to select ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00063_flds
);


##########################################################################
#                                                                        #
#   OC_X_DQR_DBUG_SEL                                                    #
#                                                                        #
##########################################################################

%orbit_01_00064_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  15,  49, 0xFFFFFFFFFFFF8000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQR_SEL"                      => [   1,   0,  15, 0x0000000000007FFF, 0x00, 0, 0x0000000000000000, "dqctl select" ],
);

%orbit_01_00064_def =
( NAME    => "OC_X_DQR_DBUG_SEL",
  ADDRESS => 0x0000000080020148,
  NOTE    => "Each AC can be configured to send the appropriate internal state to note the output debug port. This register is used to select ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00064_flds
);


##########################################################################
#                                                                        #
#   OC_X_DBUG_SEL                                                        #
#                                                                        #
##########################################################################

%orbit_01_00065_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DBG_SEL"                      => [   1,   0,  24, 0x0000000000FFFFFF, 0x00, 0, 0x0000000000000000, "debug select" ],
);

%orbit_01_00065_def =
( NAME    => "OC_X_DBUG_SEL",
  ADDRESS => 0x0000000080020150,
  NOTE    => "This register selects between the submodules within the AC RLMs. note Additional tables that describe how the debug ports can be",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00065_flds
);


##########################################################################
#                                                                        #
#   OC_X_LADDR_CMP                                                       #
#                                                                        #
##########################################################################

%orbit_01_00066_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MASK_VAL"                     => [   1,  32,  30, 0x3FFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Mask value" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CMP_VAL"                      => [   3,   0,  30, 0x000000003FFFFFFF, 0x00, 0, 0x0000000000000000, "Compare value" ],
);

%orbit_01_00066_def =
( NAME    => "OC_X_LADDR_CMP",
  ADDRESS => 0x0000000080020158,
  NOTE    => "Address compare register is used to trigger on specific requests note that are issuing from arbque. The register consists of a c",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00066_flds
);


##########################################################################
#                                                                        #
#   OC_X_RADDR_CMP                                                       #
#                                                                        #
##########################################################################

%orbit_01_00067_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MASK_VAL"                     => [   1,  32,  30, 0x3FFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Mask value" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CMP_VAL"                      => [   3,   0,  30, 0x000000003FFFFFFF, 0x00, 0, 0x0000000000000000, "Compare value" ],
);

%orbit_01_00067_def =
( NAME    => "OC_X_RADDR_CMP",
  ADDRESS => 0x0000000080020160,
  NOTE    => "Address compare register is used to trigger on specific requests note that are issuing from arbque. The register consists of a c",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00067_flds
);


##########################################################################
#                                                                        #
#   OC_X_TAG_CMP                                                         #
#                                                                        #
##########################################################################

%orbit_01_00068_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SRC"                          => [   1,  44,  16, 0x0FFFF00000000000, 0x00, 0, 0x0000000000000000, "Source compare value" ],
   "RSVD1"                        => [   2,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR"                         => [   3,   8,  35, 0x000007FFFFFFFF00, 0x00, 0, 0x0000000000000000, "Address compare value" ],
   "CMD"                          => [   4,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Command compare value" ],
);

%orbit_01_00068_def =
( NAME    => "OC_X_TAG_CMP",
  ADDRESS => 0x0000000080020168,
  NOTE    => "Tag compare register is used to trigger on specific requests that note are issuing from MD JNR to AC tagmgr. The compare fields ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00068_flds
);


##########################################################################
#                                                                        #
#   OC_X_TAG_MASK                                                        #
#                                                                        #
##########################################################################

%orbit_01_00069_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SRC"                          => [   1,  44,  16, 0x0FFFF00000000000, 0x00, 0, 0x0000000000000000, "Source compare value" ],
   "RSVD1"                        => [   2,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR"                         => [   3,   8,  35, 0x000007FFFFFFFF00, 0x00, 0, 0x0000000000000000, "Address compare value" ],
   "CMD"                          => [   4,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Command compare value" ],
);

%orbit_01_00069_def =
( NAME    => "OC_X_TAG_MASK",
  ADDRESS => 0x0000000080020170,
  NOTE    => "Tag mask register is used with the tag compare register to fine note tune the desired trigger event. This register consists of a",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00069_flds
);


##########################################################################
#                                                                        #
#   OC_Y_TAG_DBUG_SEL                                                    #
#                                                                        #
##########################################################################

%orbit_01_00070_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG_SEL"                      => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "tagmgr select" ],
);

%orbit_01_00070_def =
( NAME    => "OC_Y_TAG_DBUG_SEL",
  ADDRESS => 0x0000000080020178,
  NOTE    => "Each AC can be configured to send the appropriate internal state to note the output debug port. This register is used to select ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00070_flds
);


##########################################################################
#                                                                        #
#   OC_Y_WBQ_DBUG_SEL                                                    #
#                                                                        #
##########################################################################

%orbit_01_00071_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WBQ_SEL"                      => [   1,   0,  24, 0x0000000000FFFFFF, 0x00, 0, 0x0000000000000000, "wbqtg select" ],
);

%orbit_01_00071_def =
( NAME    => "OC_Y_WBQ_DBUG_SEL",
  ADDRESS => 0x0000000080020180,
  NOTE    => "Each AC can be configured to send the appropriate internal state to note the output debug port. This register is used to select ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00071_flds
);


##########################################################################
#                                                                        #
#   OC_Y_ARB_DBUG_SEL                                                    #
#                                                                        #
##########################################################################

%orbit_01_00072_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARB_SEL"                      => [   1,   0,  24, 0x0000000000FFFFFF, 0x00, 0, 0x0000000000000000, "arbque select" ],
);

%orbit_01_00072_def =
( NAME    => "OC_Y_ARB_DBUG_SEL",
  ADDRESS => 0x0000000080020188,
  NOTE    => "Each AC can be configured to send the appropriate internal state to note the output debug port. This register is used to select ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00072_flds
);


##########################################################################
#                                                                        #
#   OC_Y_ATL_DBUG_SEL                                                    #
#                                                                        #
##########################################################################

%orbit_01_00073_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ATL_SEL"                      => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "aintl select" ],
);

%orbit_01_00073_def =
( NAME    => "OC_Y_ATL_DBUG_SEL",
  ADDRESS => 0x0000000080020190,
  NOTE    => "Each AC can be configured to send the appropriate internal state to note the output debug port. This register is used to select ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00073_flds
);


##########################################################################
#                                                                        #
#   OC_Y_ATR_DBUG_SEL                                                    #
#                                                                        #
##########################################################################

%orbit_01_00074_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ATR_SEL"                      => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "aintr select" ],
);

%orbit_01_00074_def =
( NAME    => "OC_Y_ATR_DBUG_SEL",
  ADDRESS => 0x0000000080020198,
  NOTE    => "Each AC can be configured to send the appropriate internal state to note the output debug port. This register is used to select ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00074_flds
);


##########################################################################
#                                                                        #
#   OC_Y_DQL_DBUG_SEL                                                    #
#                                                                        #
##########################################################################

%orbit_01_00075_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  15,  49, 0xFFFFFFFFFFFF8000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQL_SEL"                      => [   1,   0,  15, 0x0000000000007FFF, 0x00, 0, 0x0000000000000000, "dqctr select" ],
);

%orbit_01_00075_def =
( NAME    => "OC_Y_DQL_DBUG_SEL",
  ADDRESS => 0x00000000800201a0,
  NOTE    => "Each AC can be configured to send the appropriate internal state to note the output debug port. This register is used to select ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00075_flds
);


##########################################################################
#                                                                        #
#   OC_Y_DQR_DBUG_SEL                                                    #
#                                                                        #
##########################################################################

%orbit_01_00076_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  15,  49, 0xFFFFFFFFFFFF8000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQR_SEL"                      => [   1,   0,  15, 0x0000000000007FFF, 0x00, 0, 0x0000000000000000, "dqctl select" ],
);

%orbit_01_00076_def =
( NAME    => "OC_Y_DQR_DBUG_SEL",
  ADDRESS => 0x00000000800201a8,
  NOTE    => "Each AC can be configured to send the appropriate internal state to note the output debug port. This register is used to select ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00076_flds
);


##########################################################################
#                                                                        #
#   OC_Y_DBUG_SEL                                                        #
#                                                                        #
##########################################################################

%orbit_01_00077_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DBG_SEL"                      => [   1,   0,  24, 0x0000000000FFFFFF, 0x00, 0, 0x0000000000000000, "debug select" ],
);

%orbit_01_00077_def =
( NAME    => "OC_Y_DBUG_SEL",
  ADDRESS => 0x00000000800201b0,
  NOTE    => "This register selects between the submodules within the AC RLMs. note Additional tables that describe how the debug ports can be",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00077_flds
);


##########################################################################
#                                                                        #
#   OC_Y_LADDR_CMP                                                       #
#                                                                        #
##########################################################################

%orbit_01_00078_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MASK_VAL"                     => [   1,  32,  30, 0x3FFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Mask value" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CMP_VAL"                      => [   3,   0,  30, 0x000000003FFFFFFF, 0x00, 0, 0x0000000000000000, "Compare value" ],
);

%orbit_01_00078_def =
( NAME    => "OC_Y_LADDR_CMP",
  ADDRESS => 0x00000000800201b8,
  NOTE    => "Address compare register is used to trigger on specific requests note that are issuing from arbque. The register consists of a c",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00078_flds
);


##########################################################################
#                                                                        #
#   OC_Y_RADDR_CMP                                                       #
#                                                                        #
##########################################################################

%orbit_01_00079_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MASK_VAL"                     => [   1,  32,  30, 0x3FFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Mask value" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CMP_VAL"                      => [   3,   0,  30, 0x000000003FFFFFFF, 0x00, 0, 0x0000000000000000, "Compare value" ],
);

%orbit_01_00079_def =
( NAME    => "OC_Y_RADDR_CMP",
  ADDRESS => 0x00000000800201c0,
  NOTE    => "Address compare register is used to trigger on specific requests note that are issuing from arbque. The register consists of a c",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00079_flds
);


##########################################################################
#                                                                        #
#   OC_Y_TAG_CMP                                                         #
#                                                                        #
##########################################################################

%orbit_01_00080_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SRC"                          => [   1,  44,  16, 0x0FFFF00000000000, 0x00, 0, 0x0000000000000000, "Source compare value" ],
   "RSVD1"                        => [   2,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR"                         => [   3,   8,  35, 0x000007FFFFFFFF00, 0x00, 0, 0x0000000000000000, "Address compare value" ],
   "CMD"                          => [   4,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Command compare value" ],
);

%orbit_01_00080_def =
( NAME    => "OC_Y_TAG_CMP",
  ADDRESS => 0x00000000800201c8,
  NOTE    => "Tag compare register is used to trigger on specific requests that note are issuing from MD JNR to AC tagmgr. The compare fields ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00080_flds
);


##########################################################################
#                                                                        #
#   OC_Y_TAG_MASK                                                        #
#                                                                        #
##########################################################################

%orbit_01_00081_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SRC"                          => [   1,  44,  16, 0x0FFFF00000000000, 0x00, 0, 0x0000000000000000, "Source compare value" ],
   "RSVD1"                        => [   2,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR"                         => [   3,   8,  35, 0x000007FFFFFFFF00, 0x00, 0, 0x0000000000000000, "Address compare value" ],
   "CMD"                          => [   4,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Command compare value" ],
);

%orbit_01_00081_def =
( NAME    => "OC_Y_TAG_MASK",
  ADDRESS => 0x00000000800201d0,
  NOTE    => "Tag mask register is used with the tag compare register to fine note tune the desired trigger event. This register consists of a",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00081_flds
);


##########################################################################
#                                                                        #
#   OC_MD_JNR_DBUG_DATA_CFG                                              #
#                                                                        #
##########################################################################

%orbit_01_00082_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_SEL"                  => [   1,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "selects which data package drives nibble7" ],
   "RSVD1"                        => [   2,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_SEL"                  => [   3,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "selects which data package drives nibble6" ],
   "RSVD2"                        => [   4,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_SEL"                  => [   5,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "selects which data package drives nibble5" ],
   "RSVD3"                        => [   6,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_SEL"                  => [   7,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "selects which data package drives nibble4" ],
   "RSVD4"                        => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_SEL"                  => [   9,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "selects which data package drives nibble3" ],
   "RSVD5"                        => [  10,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_SEL"                  => [  11,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "selects which data package drives nibble2" ],
   "RSVD6"                        => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_SEL"                  => [  13,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "selects which data package drives nibble1" ],
   "RSVD7"                        => [  14,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_SEL"                  => [  15,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "selects which data package drives nibble0" ],
);

%orbit_01_00082_def =
( NAME    => "OC_MD_JNR_DBUG_DATA_CFG",
  ADDRESS => 0x00000000800201d8,
  NOTE    => "This register maps joiner signals to the 32-bit joiner debug word. note The signals are grouped into data packages that can be m",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00082_flds
);


##########################################################################
#                                                                        #
#   OC_MD_LAST_CREDIT                                                    #
#                                                                        #
##########################################################################

%orbit_01_00083_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TO_LB"                        => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "capture of credits to pi" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_TO_XN"                     => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "capture of reply credits to xn" ],
   "RSVD2"                        => [   4,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RQ_TO_XN"                     => [   5,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "capture of request credits to xn" ],
   "RSVD3"                        => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_TO_PI"                     => [   7,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "capture of reply credits to pi" ],
   "RSVD4"                        => [   8,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RQ_TO_PI"                     => [   9,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "capture of request credits to pi" ],
);

%orbit_01_00083_def =
( NAME    => "OC_MD_LAST_CREDIT",
  ADDRESS => 0x00000000800201e0,
  NOTE    => "This register captures all of the credit values from PI, XN, and LB note upon reset.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00083_flds
);


##########################################################################
#                                                                        #
#   OC_MEM_CAPTURE_ADDR                                                  #
#                                                                        #
##########################################################################

%orbit_01_00084_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  46,  18, 0xFFFFC00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CMD"                          => [   1,  38,   8, 0x00003FC000000000, 0x00, 1, 0x0000000000000000, "Command (i.e., JETSONSNET Message Code)" ],
   "ADDR"                         => [   2,   3,  35, 0x0000003FFFFFFFF8, 0x00, 1, 0x0000000000000000, "Address[37:3]" ],
);

%orbit_01_00084_def =
( NAME    => "OC_MEM_CAPTURE_ADDR",
  ADDRESS => 0x0000000080020300,
  NOTE    => "The MEM_CAPTURE_ADDR register provides a portion of the note configuration control for the MD's Message Capture circuitry. It no",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00084_flds
);


##########################################################################
#                                                                        #
#   OC_MEM_CAPTURE_MASK                                                  #
#                                                                        #
##########################################################################

%orbit_01_00085_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_REMOTE"                => [   1,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "Analyze Messages from Remote (XN)" ],
   "ENABLE_LOCAL"                 => [   2,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "Analyze Messages from Local (PI)" ],
   "CMD"                          => [   3,  38,   8, 0x00003FC000000000, 0x00, 1, 0x0000000000000000, "Command (i.e., JETSONSNET Command Code Code)" ],
   "ADDR"                         => [   4,   3,  35, 0x0000003FFFFFFFF8, 0x00, 1, 0x0000000000000000, "Address[37:3] Mask" ],
);

%orbit_01_00085_def =
( NAME    => "OC_MEM_CAPTURE_MASK",
  ADDRESS => 0x0000000080020308,
  NOTE    => "The MEM_CAPTURE_MASK register provides a portion of the note configuration control for the MD's Message Capture circuitry. It no",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00085_flds
);


##########################################################################
#                                                                        #
#   OC_MEM_CAPTURE_HDR                                                   #
#                                                                        #
##########################################################################

%orbit_01_00086_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CNTR"                         => [   0,  58,   6, 0xFC00000000000000, 0x00, 1, 0x0000000000000000, "increments on every capture" ],
   "SRC"                          => [   1,  42,  16, 0x03FFFC0000000000, 0x00, 1, 0x0000000000000000, "source node of reference" ],
   "CMD"                          => [   2,  34,   8, 0x000003FC00000000, 0x00, 1, 0x0000000000000000, "command of reference" ],
);

%orbit_01_00086_def =
( NAME    => "OC_MEM_CAPTURE_HDR",
  ADDRESS => 0x0000000080020310,
  NOTE    => "This register logs some of the bits of the header on each note occurrence of reference that matches the address in the address n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00086_flds
);


##########################################################################
#                                                                        #
#   OC_MEM_CAPTURE_HDR_ADDR                                              #
#                                                                        #
##########################################################################

%orbit_01_00087_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  37,  27, 0xFFFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR"                         => [   1,   2,  35, 0x0000001FFFFFFFFC, 0x00, 1, 0x0000000000000000, "upper bits of reference address" ],
);

%orbit_01_00087_def =
( NAME    => "OC_MEM_CAPTURE_HDR_ADDR",
  ADDRESS => 0x0000000080020318,
  NOTE    => "This register logs some of the bits of the header on each note occurrence of reference that matches the address in the address n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00087_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_DIR_CONFIG                                            #
#                                                                        #
##########################################################################

%orbit_01_00088_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIO_CHIPLET"                  => [   1,   6,   2, 0x00000000000000C0, 0x00, 1, 0x0000000000000000, "TIO chiplet value" ],
   "SW_GET_2_GETF"                => [   2,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "switch all GET requests to GETF requests" ],
   "EN_DIRPOIS"                   => [   3,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "enable local poisoning for dir table fall-through" ],
   "EN_DIRECC"                    => [   4,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "enable directory ecc correction" ],
   "SYS_SIZE"                     => [   5,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "system size code" ],
);

%orbit_01_00088_def =
( NAME    => "OC_MD_DQLP_MMR_DIR_CONFIG",
  ADDRESS => 0x0000000080030000,
  NOTE    => "This register holds DQ config bits. SYS_SIZE configures the note granularity of the local/remote vector.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00088_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_DIR_PRESVEC0                                          #
#                                                                        #
##########################################################################

%orbit_01_00089_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "node presence bits, 1=present" ],
);

%orbit_01_00089_def =
( NAME    => "OC_MD_DQLP_MMR_DIR_PRESVEC0",
  ADDRESS => 0x0000000080030100,
  NOTE    => "This group of registers holds the node presence vector for the note coherence doamin. If a bit is 1 then the node is assumed pre",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00089_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_DIR_PRESVEC1                                          #
#                                                                        #
##########################################################################

%orbit_01_00090_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "node presence bits, 1=present" ],
);

%orbit_01_00090_def =
( NAME    => "OC_MD_DQLP_MMR_DIR_PRESVEC1",
  ADDRESS => 0x0000000080030110,
  NOTE    => "node [127:64] presence bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00090_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_DIR_PRESVEC2                                          #
#                                                                        #
##########################################################################

%orbit_01_00091_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "node presence bits, 1=present" ],
);

%orbit_01_00091_def =
( NAME    => "OC_MD_DQLP_MMR_DIR_PRESVEC2",
  ADDRESS => 0x0000000080030120,
  NOTE    => "node [191:128] presence bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00091_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_DIR_PRESVEC3                                          #
#                                                                        #
##########################################################################

%orbit_01_00092_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "node presence bits, 1=present" ],
);

%orbit_01_00092_def =
( NAME    => "OC_MD_DQLP_MMR_DIR_PRESVEC3",
  ADDRESS => 0x0000000080030130,
  NOTE    => "node [255:192] presence bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00092_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_DIR_LOCVEC0                                           #
#                                                                        #
##########################################################################

%orbit_01_00093_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%orbit_01_00093_def =
( NAME    => "OC_MD_DQLP_MMR_DIR_LOCVEC0",
  ADDRESS => 0x0000000080030200,
  NOTE    => "This group of registers holds the local/remote bit vectors that is note used for access privilege checks in the directory logic.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00093_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_DIR_LOCVEC1                                           #
#                                                                        #
##########################################################################

%orbit_01_00094_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%orbit_01_00094_def =
( NAME    => "OC_MD_DQLP_MMR_DIR_LOCVEC1",
  ADDRESS => 0x0000000080030210,
  NOTE    => "local vector for acc=1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00094_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_DIR_LOCVEC2                                           #
#                                                                        #
##########################################################################

%orbit_01_00095_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%orbit_01_00095_def =
( NAME    => "OC_MD_DQLP_MMR_DIR_LOCVEC2",
  ADDRESS => 0x0000000080030220,
  NOTE    => "local vector for acc=2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00095_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_DIR_LOCVEC3                                           #
#                                                                        #
##########################################################################

%orbit_01_00096_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%orbit_01_00096_def =
( NAME    => "OC_MD_DQLP_MMR_DIR_LOCVEC3",
  ADDRESS => 0x0000000080030230,
  NOTE    => "local vector for acc=3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00096_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_DIR_LOCVEC4                                           #
#                                                                        #
##########################################################################

%orbit_01_00097_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%orbit_01_00097_def =
( NAME    => "OC_MD_DQLP_MMR_DIR_LOCVEC4",
  ADDRESS => 0x0000000080030240,
  NOTE    => "local vector for acc=4",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00097_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_DIR_LOCVEC5                                           #
#                                                                        #
##########################################################################

%orbit_01_00098_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%orbit_01_00098_def =
( NAME    => "OC_MD_DQLP_MMR_DIR_LOCVEC5",
  ADDRESS => 0x0000000080030250,
  NOTE    => "local vector for acc=5",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00098_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_DIR_LOCVEC6                                           #
#                                                                        #
##########################################################################

%orbit_01_00099_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%orbit_01_00099_def =
( NAME    => "OC_MD_DQLP_MMR_DIR_LOCVEC6",
  ADDRESS => 0x0000000080030260,
  NOTE    => "local vector for acc=6",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00099_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_DIR_LOCVEC7                                           #
#                                                                        #
##########################################################################

%orbit_01_00100_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%orbit_01_00100_def =
( NAME    => "OC_MD_DQLP_MMR_DIR_LOCVEC7",
  ADDRESS => 0x0000000080030270,
  NOTE    => "local vector for acc=7",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00100_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_DIR_PRIVEC0                                           #
#                                                                        #
##########################################################################

%orbit_01_00101_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%orbit_01_00101_def =
( NAME    => "OC_MD_DQLP_MMR_DIR_PRIVEC0",
  ADDRESS => 0x0000000080030300,
  NOTE    => "This group of registers holds the privilege mask for certain note request type categories. CPU and IO nodes have separate bits f",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00101_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_DIR_PRIVEC1                                           #
#                                                                        #
##########################################################################

%orbit_01_00102_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%orbit_01_00102_def =
( NAME    => "OC_MD_DQLP_MMR_DIR_PRIVEC1",
  ADDRESS => 0x0000000080030310,
  NOTE    => "privilege vector for acc=1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00102_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_DIR_PRIVEC2                                           #
#                                                                        #
##########################################################################

%orbit_01_00103_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%orbit_01_00103_def =
( NAME    => "OC_MD_DQLP_MMR_DIR_PRIVEC2",
  ADDRESS => 0x0000000080030320,
  NOTE    => "privilege vector for acc=2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00103_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_DIR_PRIVEC3                                           #
#                                                                        #
##########################################################################

%orbit_01_00104_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%orbit_01_00104_def =
( NAME    => "OC_MD_DQLP_MMR_DIR_PRIVEC3",
  ADDRESS => 0x0000000080030330,
  NOTE    => "privilege vector for acc=3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00104_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_DIR_PRIVEC4                                           #
#                                                                        #
##########################################################################

%orbit_01_00105_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%orbit_01_00105_def =
( NAME    => "OC_MD_DQLP_MMR_DIR_PRIVEC4",
  ADDRESS => 0x0000000080030340,
  NOTE    => "privilege vector for acc=4",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00105_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_DIR_PRIVEC5                                           #
#                                                                        #
##########################################################################

%orbit_01_00106_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%orbit_01_00106_def =
( NAME    => "OC_MD_DQLP_MMR_DIR_PRIVEC5",
  ADDRESS => 0x0000000080030350,
  NOTE    => "privilege vector for acc=5",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00106_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_DIR_PRIVEC6                                           #
#                                                                        #
##########################################################################

%orbit_01_00107_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%orbit_01_00107_def =
( NAME    => "OC_MD_DQLP_MMR_DIR_PRIVEC6",
  ADDRESS => 0x0000000080030360,
  NOTE    => "privilege vector for acc=6",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00107_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_DIR_PRIVEC7                                           #
#                                                                        #
##########################################################################

%orbit_01_00108_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%orbit_01_00108_def =
( NAME    => "OC_MD_DQLP_MMR_DIR_PRIVEC7",
  ADDRESS => 0x0000000080030370,
  NOTE    => "privilege vector for acc=7",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00108_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_DIR_TIMER                                             #
#                                                                        #
##########################################################################

%orbit_01_00109_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIMER_CUR"                    => [   1,  13,   9, 0x00000000003FE000, 0x00, 1, 0x0000000000000000, "value of current timer" ],
   "TIMER_EN"                     => [   2,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "timer enable" ],
   "TIMER_DIV"                    => [   3,   0,  12, 0x0000000000000FFF, 0x00, 1, 0x0000000000000000, "timer divide register" ],
);

%orbit_01_00109_def =
( NAME    => "OC_MD_DQLP_MMR_DIR_TIMER",
  ADDRESS => 0x0000000080030400,
  NOTE    => "This register holds enables and configuration bits of the MD SXRO note timer. The core clock 'psbclk' is devided by 64 in a pres",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00109_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_PIOWD_DIR_ENTRY                                       #
#                                                                        #
##########################################################################

%orbit_01_00110_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  58,   6, 0xFC00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ACC"                          => [   1,  55,   3, 0x0380000000000000, 0x00, 1, 0x0000000000000000, "directory access bits" ],
   "PRI"                          => [   2,  52,   3, 0x0070000000000000, 0x00, 1, 0x0000000000000000, "directory priority" ],
   "DIRB"                         => [   3,  26,  26, 0x000FFFFFFC000000, 0x00, 1, 0x0000000000000000, "directory entry B" ],
   "DIRA"                         => [   4,   0,  26, 0x0000000003FFFFFF, 0x00, 1, 0x0000000000000000, "directory entry A" ],
);

%orbit_01_00110_def =
( NAME    => "OC_MD_DQLP_MMR_PIOWD_DIR_ENTRY",
  ADDRESS => 0x0000000080031000,
  NOTE    => "Directory entries A and B with access, priority and rsvd bits.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00110_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_PIOWD_DIR_ECC                                         #
#                                                                        #
##########################################################################

%orbit_01_00111_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  14,  50, 0xFFFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECCB"                         => [   1,   7,   7, 0x0000000000003F80, 0x00, 1, 0x0000000000000000, "XOR bits for directory ECC group 2" ],
   "ECCA"                         => [   2,   0,   7, 0x000000000000007F, 0x00, 1, 0x0000000000000000, "XOR bits for directory ECC group 1" ],
);

%orbit_01_00111_def =
( NAME    => "OC_MD_DQLP_MMR_PIOWD_DIR_ECC",
  ADDRESS => 0x0000000080031010,
  NOTE    => "These two ECC values are XORed with the generated directory ECC note bits and should be 0 for normal operation. Diagnostic softw",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00111_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_XPIORD_XDIR_ENTRY                                     #
#                                                                        #
##########################################################################

%orbit_01_00112_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNC"                          => [   1,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error" ],
   "COR"                          => [   2,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error" ],
   "ACC"                          => [   3,  55,   3, 0x0380000000000000, 0x00, 0, 0x0000000000000000, "directory access bits" ],
   "PRI"                          => [   4,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "directory priority" ],
   "DIRB"                         => [   5,  26,  26, 0x000FFFFFFC000000, 0x00, 0, 0x0000000000000000, "directory entry B" ],
   "DIRA"                         => [   6,   0,  26, 0x0000000003FFFFFF, 0x00, 0, 0x0000000000000000, "directory entry A" ],
);

%orbit_01_00112_def =
( NAME    => "OC_MD_DQLP_MMR_XPIORD_XDIR_ENTRY",
  ADDRESS => 0x0000000080032000,
  NOTE    => "Directory entries A and B with access, priority and rsvd bits.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00112_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_XPIORD_XDIR_ECC                                       #
#                                                                        #
##########################################################################

%orbit_01_00113_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  14,  50, 0xFFFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECCB"                         => [   1,   7,   7, 0x0000000000003F80, 0x00, 0, 0x0000000000000000, "group 2 ecc" ],
   "ECCA"                         => [   2,   0,   7, 0x000000000000007F, 0x00, 0, 0x0000000000000000, "group 1 ecc" ],
);

%orbit_01_00113_def =
( NAME    => "OC_MD_DQLP_MMR_XPIORD_XDIR_ECC",
  ADDRESS => 0x0000000080032010,
  NOTE    => "ECC bits of group 1 and 2 of directory pair.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00113_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_YPIORD_YDIR_ENTRY                                     #
#                                                                        #
##########################################################################

%orbit_01_00114_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNC"                          => [   1,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error" ],
   "COR"                          => [   2,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error" ],
   "ACC"                          => [   3,  55,   3, 0x0380000000000000, 0x00, 0, 0x0000000000000000, "directory access bits" ],
   "PRI"                          => [   4,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "directory priority" ],
   "DIRB"                         => [   5,  26,  26, 0x000FFFFFFC000000, 0x00, 0, 0x0000000000000000, "directory entry B" ],
   "DIRA"                         => [   6,   0,  26, 0x0000000003FFFFFF, 0x00, 0, 0x0000000000000000, "directory entry A" ],
);

%orbit_01_00114_def =
( NAME    => "OC_MD_DQLP_MMR_YPIORD_YDIR_ENTRY",
  ADDRESS => 0x0000000080032800,
  NOTE    => "Directory entries A and B with access, priority and rsvd bits.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00114_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_YPIORD_YDIR_ECC                                       #
#                                                                        #
##########################################################################

%orbit_01_00115_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  14,  50, 0xFFFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECCB"                         => [   1,   7,   7, 0x0000000000003F80, 0x00, 0, 0x0000000000000000, "group 2 ecc" ],
   "ECCA"                         => [   2,   0,   7, 0x000000000000007F, 0x00, 0, 0x0000000000000000, "group 1 ecc" ],
);

%orbit_01_00115_def =
( NAME    => "OC_MD_DQLP_MMR_YPIORD_YDIR_ECC",
  ADDRESS => 0x0000000080032810,
  NOTE    => "ECC bits of group 1 and 2 of directory pair.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00115_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_XCERR1                                                #
#                                                                        #
##########################################################################

%orbit_01_00116_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  39,  25, 0xFFFFFF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms uncorrectable ecc error capture" ],
   "MORE"                         => [   2,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one correctable ecc error in group 1" ],
   "VAL"                          => [   3,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error in group 1 bits" ],
   "GRP1"                         => [   4,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 1 bits" ],
);

%orbit_01_00116_def =
( NAME    => "OC_MD_DQLP_MMR_XCERR1",
  ADDRESS => 0x0000000080033000,
  NOTE    => "These registers capture the data bits for correctable directory ecc note errors. The data bits of ecc groups 1 and 2 that make t",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00116_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_XCERR2                                                #
#                                                                        #
##########################################################################

%orbit_01_00117_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one correctable ecc error in group 2" ],
   "VAL"                          => [   2,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error in group 2 bits" ],
   "GRP2"                         => [   3,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 2 bits" ],
);

%orbit_01_00117_def =
( NAME    => "OC_MD_DQLP_MMR_XCERR2",
  ADDRESS => 0x0000000080033010,
  NOTE    => "correctable dir ecc group 2 error register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00117_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_XUERR1                                                #
#                                                                        #
##########################################################################

%orbit_01_00118_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  39,  25, 0xFFFFFF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms uncorrectable ecc error capture" ],
   "MORE"                         => [   2,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one uncorrectable ecc error in group 1" ],
   "VAL"                          => [   3,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error in group 1 bits" ],
   "GRP1"                         => [   4,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 1 bits" ],
);

%orbit_01_00118_def =
( NAME    => "OC_MD_DQLP_MMR_XUERR1",
  ADDRESS => 0x0000000080033020,
  NOTE    => "These registers capture the data bits for uncorrectable directory note ecc errors. The data bits of ecc groups 1 and 2 that make",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00118_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_XUERR2                                                #
#                                                                        #
##########################################################################

%orbit_01_00119_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one uncorrectable ecc error in group 2" ],
   "VAL"                          => [   2,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error in group 2 bits" ],
   "GRP2"                         => [   3,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 2 bits" ],
);

%orbit_01_00119_def =
( NAME    => "OC_MD_DQLP_MMR_XUERR2",
  ADDRESS => 0x0000000080033030,
  NOTE    => "uncorrectable dir ecc group 2 error register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00119_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_XPERR                                                 #
#                                                                        #
##########################################################################

%orbit_01_00120_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms error capture" ],
   "MORE"                         => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "more than one protocol error" ],
   "VAL"                          => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "protocol error info valid" ],
   "MYBIT"                        => [   4,  52,   8, 0x0FF0000000000000, 0x00, 0, 0x0000000000000000, "ptreq,timeq,timlast,timspec,onlyme,anytim,ptrii,srcii" ],
   "UNC"                          => [   5,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error" ],
   "COR"                          => [   6,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error" ],
   "PRIV"                         => [   7,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "access privilege bit" ],
   "PRIGE"                        => [   8,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "priority was greater-equal" ],
   "SRC"                          => [   9,  34,  14, 0x0000FFFC00000000, 0x00, 0, 0x0000000000000000, "source node of dir operation" ],
   "CMD"                          => [  10,  26,   8, 0x00000003FC000000, 0x00, 0, 0x0000000000000000, "incoming command" ],
   "DIR"                          => [  11,   0,  26, 0x0000000003FFFFFF, 0x00, 0, 0x0000000000000000, "directory entry" ],
);

%orbit_01_00120_def =
( NAME    => "OC_MD_DQLP_MMR_XPERR",
  ADDRESS => 0x0000000080033040,
  NOTE    => "This register captures the table inputs for the first occurence of note a directory protocol table fall-through case. The direct",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00120_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_YCERR1                                                #
#                                                                        #
##########################################################################

%orbit_01_00121_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  39,  25, 0xFFFFFF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms uncorrectable ecc error capture" ],
   "MORE"                         => [   2,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one correctable ecc error in group 1" ],
   "VAL"                          => [   3,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error in group 1 bits" ],
   "GRP1"                         => [   4,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 1 bits" ],
);

%orbit_01_00121_def =
( NAME    => "OC_MD_DQLP_MMR_YCERR1",
  ADDRESS => 0x0000000080033800,
  NOTE    => "These registers capture the data bits for correctable directory ecc note errors. The data bits of ecc groups 1 and 2 that make t",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00121_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_YCERR2                                                #
#                                                                        #
##########################################################################

%orbit_01_00122_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one correctable ecc error in group 2" ],
   "VAL"                          => [   2,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error in group 2 bits" ],
   "GRP2"                         => [   3,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 2 bits" ],
);

%orbit_01_00122_def =
( NAME    => "OC_MD_DQLP_MMR_YCERR2",
  ADDRESS => 0x0000000080033810,
  NOTE    => "correctable dir ecc group 2 error register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00122_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_YUERR1                                                #
#                                                                        #
##########################################################################

%orbit_01_00123_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  39,  25, 0xFFFFFF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms uncorrectable ecc error capture" ],
   "MORE"                         => [   2,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one uncorrectable ecc error in group 1" ],
   "VAL"                          => [   3,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error in group 1 bits" ],
   "GRP1"                         => [   4,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 1 bits" ],
);

%orbit_01_00123_def =
( NAME    => "OC_MD_DQLP_MMR_YUERR1",
  ADDRESS => 0x0000000080033820,
  NOTE    => "These registers capture the data bits for uncorrectable directory note ecc errors. The data bits of ecc groups 1 and 2 that make",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00123_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_YUERR2                                                #
#                                                                        #
##########################################################################

%orbit_01_00124_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one uncorrectable ecc error in group 2" ],
   "VAL"                          => [   2,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error in group 2 bits" ],
   "GRP2"                         => [   3,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 2 bits" ],
);

%orbit_01_00124_def =
( NAME    => "OC_MD_DQLP_MMR_YUERR2",
  ADDRESS => 0x0000000080033830,
  NOTE    => "uncorrectable dir ecc group 2 error register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00124_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_YPERR                                                 #
#                                                                        #
##########################################################################

%orbit_01_00125_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms error capture" ],
   "MORE"                         => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "more than one protocol error" ],
   "VAL"                          => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "protocol error info valid" ],
   "MYBIT"                        => [   4,  52,   8, 0x0FF0000000000000, 0x00, 0, 0x0000000000000000, "ptreq,timeq,timlast,timspec,onlyme,anytim,ptrii,srcii" ],
   "UNC"                          => [   5,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error" ],
   "COR"                          => [   6,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error" ],
   "PRIV"                         => [   7,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "access privilege bit" ],
   "PRIGE"                        => [   8,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "priority was greater-equal" ],
   "SRC"                          => [   9,  34,  14, 0x0000FFFC00000000, 0x00, 0, 0x0000000000000000, "source node of dir operation" ],
   "CMD"                          => [  10,  26,   8, 0x00000003FC000000, 0x00, 0, 0x0000000000000000, "incoming command" ],
   "DIR"                          => [  11,   0,  26, 0x0000000003FFFFFF, 0x00, 0, 0x0000000000000000, "directory entry" ],
);

%orbit_01_00125_def =
( NAME    => "OC_MD_DQLP_MMR_YPERR",
  ADDRESS => 0x0000000080033840,
  NOTE    => "This register captures the table inputs for the first occurence of note a directory protocol table fall-through case. The direct",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00125_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_DIR_CMDTRIG                                           #
#                                                                        #
##########################################################################

%orbit_01_00126_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "YDIR_DBG_SEL"                 => [   1,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "Select X directory debug path" ],
   "XDIR_DBG_SEL"                 => [   2,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Select X directory debug path" ],
   "CMD3"                         => [   3,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "command trigger 3" ],
   "CMD2"                         => [   4,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "command trigger 2" ],
   "CMD1"                         => [   5,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "command trigger 1" ],
   "CMD0"                         => [   6,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "command trigger 0" ],
);

%orbit_01_00126_def =
( NAME    => "OC_MD_DQLP_MMR_DIR_CMDTRIG",
  ADDRESS => 0x0000000080034000,
  NOTE    => "This register holds 4 cmd encodings that are compared to the note incoming directory request. Each of the four comparators drive",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00126_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_DIR_TBLTRIG                                           #
#                                                                        #
##########################################################################

%orbit_01_00127_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  44,  20, 0xFFFFF00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MYBIT"                        => [   1,  36,   8, 0x00000FF000000000, 0x00, 0, 0x0000000000000000, "ptreq,timeq,timlast,timspec,onlyme,anytim,ptrii,srcii" ],
   "DIRST"                        => [   2,  27,   9, 0x0000000FF8000000, 0x00, 0, 0x0000000000000000, "shrd,sxro,sub-state" ],
   "PRIGE"                        => [   3,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "priority greater-equal" ],
   "ACC"                          => [   4,  24,   2, 0x0000000003000000, 0x00, 0, 0x0000000000000000, "uncorrectable error, privilege bit" ],
   "CMD"                          => [   5,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "incoming request" ],
   "SRC"                          => [   6,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "source of request" ],
);

%orbit_01_00127_def =
( NAME    => "OC_MD_DQLP_MMR_DIR_TBLTRIG",
  ADDRESS => 0x0000000080034010,
  NOTE    => "This register holds a value which is compared to the inputs of the note directory table logic. If they match a debug signal is a",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00127_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_DIR_TBLMASK                                           #
#                                                                        #
##########################################################################

%orbit_01_00128_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  44,  20, 0xFFFFF00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MYBIT"                        => [   1,  36,   8, 0x00000FF000000000, 0x00, 1, 0x0000000000000000, "ptreq,timeq,timlast,timspec,onlyme,anytim,ptrii,srcii" ],
   "DIRST"                        => [   2,  27,   9, 0x0000000FF8000000, 0x00, 1, 0x0000000000000000, "shrd,sxro,sub-state" ],
   "PRIGE"                        => [   3,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "priority greater-equal" ],
   "ACC"                          => [   4,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "uncorrectable error, privilege bit" ],
   "CMD"                          => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "incoming request" ],
   "SRC"                          => [   6,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "source of request" ],
);

%orbit_01_00128_def =
( NAME    => "OC_MD_DQLP_MMR_DIR_TBLMASK",
  ADDRESS => 0x0000000080034020,
  NOTE    => "dir table trigger mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00128_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_XBIST_H                                               #
#                                                                        #
##########################################################################

%orbit_01_00129_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  43,  21, 0xFFFFF80000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms data miscompare capture" ],
   "ROT"                          => [   2,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   3,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "RSVD1"                        => [   4,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   5,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%orbit_01_00129_def =
( NAME    => "OC_MD_DQLP_MMR_XBIST_H",
  ADDRESS => 0x0000000080038000,
  NOTE    => "These registers hold the DDR rising and falling edge data pattern note and bist/fill mode bits. The width of the data depends on",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00129_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_XBIST_L                                               #
#                                                                        #
##########################################################################

%orbit_01_00130_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ROT"                          => [   1,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "RSVD1"                        => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   4,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%orbit_01_00130_def =
( NAME    => "OC_MD_DQLP_MMR_XBIST_L",
  ADDRESS => 0x0000000080038010,
  NOTE    => "falling edge bist/fill pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00130_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_XBIST_ERR_H                                           #
#                                                                        #
##########################################################################

%orbit_01_00131_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "RSVD1"                        => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   4,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%orbit_01_00131_def =
( NAME    => "OC_MD_DQLP_MMR_XBIST_ERR_H",
  ADDRESS => 0x0000000080038020,
  NOTE    => "These registers hold the DDR rising and falling edge data pattern note for the first data miscompare during bist read/compare op",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00131_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_XBIST_ERR_L                                           #
#                                                                        #
##########################################################################

%orbit_01_00132_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "RSVD1"                        => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   4,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%orbit_01_00132_def =
( NAME    => "OC_MD_DQLP_MMR_XBIST_ERR_L",
  ADDRESS => 0x0000000080038030,
  NOTE    => "falling edge bist error pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00132_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_YBIST_H                                               #
#                                                                        #
##########################################################################

%orbit_01_00133_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  43,  21, 0xFFFFF80000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms data miscompare capture" ],
   "ROT"                          => [   2,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   3,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "RSVD1"                        => [   4,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   5,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%orbit_01_00133_def =
( NAME    => "OC_MD_DQLP_MMR_YBIST_H",
  ADDRESS => 0x0000000080038800,
  NOTE    => "These registers hold the DDR rising and falling edge data pattern note and bist/fill mode bits. The width of the data depends on",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00133_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_YBIST_L                                               #
#                                                                        #
##########################################################################

%orbit_01_00134_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ROT"                          => [   1,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "RSVD1"                        => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   4,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%orbit_01_00134_def =
( NAME    => "OC_MD_DQLP_MMR_YBIST_L",
  ADDRESS => 0x0000000080038810,
  NOTE    => "falling edge bist/fill pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00134_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_YBIST_ERR_H                                           #
#                                                                        #
##########################################################################

%orbit_01_00135_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "RSVD1"                        => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   4,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%orbit_01_00135_def =
( NAME    => "OC_MD_DQLP_MMR_YBIST_ERR_H",
  ADDRESS => 0x0000000080038820,
  NOTE    => "These registers hold the DDR rising and falling edge data pattern note for the first data miscompare during bist read/compare op",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00135_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_YBIST_ERR_L                                           #
#                                                                        #
##########################################################################

%orbit_01_00136_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "RSVD1"                        => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   4,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%orbit_01_00136_def =
( NAME    => "OC_MD_DQLP_MMR_YBIST_ERR_L",
  ADDRESS => 0x0000000080038830,
  NOTE    => "falling edge bist error pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00136_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLP_MMR_AMO_CFG                                               #
#                                                                        #
##########################################################################

%orbit_01_00137_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   2,  62, 0xFFFFFFFFFFFFFFFC, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EN_YAMOECC"                   => [   1,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "enable y amo ecc detection-correction logic" ],
   "EN_XAMOECC"                   => [   2,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "enable x amo ecc detection-correction logic" ],
);

%orbit_01_00137_def =
( NAME    => "OC_MD_DQLP_MMR_AMO_CFG",
  ADDRESS => 0x0000000080034800,
  NOTE    => "This register configures the amo logic.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00137_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLS_MMR_XBIST_H                                               #
#                                                                        #
##########################################################################

%orbit_01_00138_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  43,  21, 0xFFFFF80000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms data miscompare capture" ],
   "ROT"                          => [   2,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   3,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "PAT"                          => [   4,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%orbit_01_00138_def =
( NAME    => "OC_MD_DQLS_MMR_XBIST_H",
  ADDRESS => 0x0000000080048000,
  NOTE    => "These registers hold the DDR rising and falling edge data pattern note and bist/fill mode bits. The width of the data depends on",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00138_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLS_MMR_XBIST_L                                               #
#                                                                        #
##########################################################################

%orbit_01_00139_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ROT"                          => [   1,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "PAT"                          => [   3,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%orbit_01_00139_def =
( NAME    => "OC_MD_DQLS_MMR_XBIST_L",
  ADDRESS => 0x0000000080048010,
  NOTE    => "falling edge bist/fill pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00139_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLS_MMR_XBIST_ERR_H                                           #
#                                                                        #
##########################################################################

%orbit_01_00140_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "PAT"                          => [   3,   0,  40, 0x000000FFFFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%orbit_01_00140_def =
( NAME    => "OC_MD_DQLS_MMR_XBIST_ERR_H",
  ADDRESS => 0x0000000080048020,
  NOTE    => "These registers hold the DDR rising and falling edge data pattern note for the first data miscompare during bist read/compare op",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00140_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLS_MMR_XBIST_ERR_L                                           #
#                                                                        #
##########################################################################

%orbit_01_00141_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "PAT"                          => [   3,   0,  40, 0x000000FFFFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%orbit_01_00141_def =
( NAME    => "OC_MD_DQLS_MMR_XBIST_ERR_L",
  ADDRESS => 0x0000000080048030,
  NOTE    => "falling edge bist error pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00141_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLS_MMR_YBIST_H                                               #
#                                                                        #
##########################################################################

%orbit_01_00142_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  43,  21, 0xFFFFF80000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms data miscompare capture" ],
   "ROT"                          => [   2,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   3,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "PAT"                          => [   4,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%orbit_01_00142_def =
( NAME    => "OC_MD_DQLS_MMR_YBIST_H",
  ADDRESS => 0x0000000080048800,
  NOTE    => "These registers hold the DDR rising and falling edge data pattern note and bist/fill mode bits. The width of the data depends on",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00142_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLS_MMR_YBIST_L                                               #
#                                                                        #
##########################################################################

%orbit_01_00143_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ROT"                          => [   1,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "PAT"                          => [   3,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%orbit_01_00143_def =
( NAME    => "OC_MD_DQLS_MMR_YBIST_L",
  ADDRESS => 0x0000000080048810,
  NOTE    => "falling edge bist/fill pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00143_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLS_MMR_YBIST_ERR_H                                           #
#                                                                        #
##########################################################################

%orbit_01_00144_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "PAT"                          => [   3,   0,  40, 0x000000FFFFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%orbit_01_00144_def =
( NAME    => "OC_MD_DQLS_MMR_YBIST_ERR_H",
  ADDRESS => 0x0000000080048820,
  NOTE    => "These registers hold the DDR rising and falling edge data pattern note for the first data miscompare during bist read/compare op",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00144_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLS_MMR_YBIST_ERR_L                                           #
#                                                                        #
##########################################################################

%orbit_01_00145_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "PAT"                          => [   3,   0,  40, 0x000000FFFFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%orbit_01_00145_def =
( NAME    => "OC_MD_DQLS_MMR_YBIST_ERR_L",
  ADDRESS => 0x0000000080048830,
  NOTE    => "falling edge bist error pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00145_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLS_MMR_JNR_DEBUG                                             #
#                                                                        #
##########################################################################

%orbit_01_00146_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   2,  62, 0xFFFFFFFFFFFFFFFC, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RW"                           => [   1,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "select 0=read 1=write side" ],
   "PX"                           => [   2,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "select 0=pi 1=xn side" ],
);

%orbit_01_00146_def =
( NAME    => "OC_MD_DQLS_MMR_JNR_DEBUG",
  ADDRESS => 0x0000000080049000,
  NOTE    => "This register configure the joiner side rbug/wbuf address output to note the debug/performance port. Different addresses can be ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00146_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLS_MMR_XAMOPW_ERR                                            #
#                                                                        #
##########################################################################

%orbit_01_00147_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  49,  15, 0xFFFE000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms ecc error capture" ],
   "RSVD1"                        => [   2,  42,   6, 0x0000FC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RUNC"                         => [   3,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc errror on read data" ],
   "RCOR"                         => [   4,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "correctable ecc errror on read data" ],
   "RSYN"                         => [   5,  24,  16, 0x000000FFFF000000, 0x00, 0, 0x0000000000000000, "memory read data syndrome" ],
   "RSVD2"                        => [   6,  18,   6, 0x0000000000FC0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SUNC"                         => [   7,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc errror on store data" ],
   "SCOR"                         => [   8,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "correctable ecc errror on store data" ],
   "SSYN"                         => [   9,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "store data syndrome" ],
);

%orbit_01_00147_def =
( NAME    => "OC_MD_DQLS_MMR_XAMOPW_ERR",
  ADDRESS => 0x000000008004a000,
  NOTE    => "This register holds the full syndrome of an ecc error encountered note on read-modify-write data for amo and partial byte writes",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00147_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQLS_MMR_AMO_CFG                                               #
#                                                                        #
##########################################################################

%orbit_01_00148_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   2,  62, 0xFFFFFFFFFFFFFFFC, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EN_YAMOECC"                   => [   1,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "enable y amo ecc detection-correction logic" ],
   "EN_XAMOECC"                   => [   2,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "enable x amo ecc detection-correction logic" ],
);

%orbit_01_00148_def =
( NAME    => "OC_MD_DQLS_MMR_AMO_CFG",
  ADDRESS => 0x000000008004b000,
  NOTE    => "This register configures the amo logic.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00148_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_DIR_CONFIG                                            #
#                                                                        #
##########################################################################

%orbit_01_00149_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIO_CHIPLET"                  => [   1,   6,   2, 0x00000000000000C0, 0x00, 1, 0x0000000000000000, "TIO chiplet value" ],
   "SW_GET_2_GETF"                => [   2,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "switch all GET requests to GETF requests" ],
   "EN_DIRPOIS"                   => [   3,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "enable local poisoning for dir table fall-through" ],
   "EN_DIRECC"                    => [   4,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "enable directory ecc correction" ],
   "SYS_SIZE"                     => [   5,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "system size code" ],
);

%orbit_01_00149_def =
( NAME    => "OC_MD_DQRP_MMR_DIR_CONFIG",
  ADDRESS => 0x0000000080050000,
  NOTE    => "This register holds DQ config bits. SYS_SIZE configures the note granularity of the local/remote vector.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00149_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_DIR_PRESVEC0                                          #
#                                                                        #
##########################################################################

%orbit_01_00150_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "node presence bits, 1=present" ],
);

%orbit_01_00150_def =
( NAME    => "OC_MD_DQRP_MMR_DIR_PRESVEC0",
  ADDRESS => 0x0000000080050100,
  NOTE    => "This group of registers holds the node presence vector for the note coherence doamin. If a bit is 1 then the node is assumed pre",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00150_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_DIR_PRESVEC1                                          #
#                                                                        #
##########################################################################

%orbit_01_00151_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "node presence bits, 1=present" ],
);

%orbit_01_00151_def =
( NAME    => "OC_MD_DQRP_MMR_DIR_PRESVEC1",
  ADDRESS => 0x0000000080050110,
  NOTE    => "node [127:64] presence bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00151_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_DIR_PRESVEC2                                          #
#                                                                        #
##########################################################################

%orbit_01_00152_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "node presence bits, 1=present" ],
);

%orbit_01_00152_def =
( NAME    => "OC_MD_DQRP_MMR_DIR_PRESVEC2",
  ADDRESS => 0x0000000080050120,
  NOTE    => "node [191:128] presence bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00152_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_DIR_PRESVEC3                                          #
#                                                                        #
##########################################################################

%orbit_01_00153_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "node presence bits, 1=present" ],
);

%orbit_01_00153_def =
( NAME    => "OC_MD_DQRP_MMR_DIR_PRESVEC3",
  ADDRESS => 0x0000000080050130,
  NOTE    => "node [255:192] presence bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00153_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_DIR_LOCVEC0                                           #
#                                                                        #
##########################################################################

%orbit_01_00154_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%orbit_01_00154_def =
( NAME    => "OC_MD_DQRP_MMR_DIR_LOCVEC0",
  ADDRESS => 0x0000000080050200,
  NOTE    => "This group of registers holds the local/remote bit vectors that is note used for access privilege checks in the directory logic.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00154_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_DIR_LOCVEC1                                           #
#                                                                        #
##########################################################################

%orbit_01_00155_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%orbit_01_00155_def =
( NAME    => "OC_MD_DQRP_MMR_DIR_LOCVEC1",
  ADDRESS => 0x0000000080050210,
  NOTE    => "local vector for acc=1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00155_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_DIR_LOCVEC2                                           #
#                                                                        #
##########################################################################

%orbit_01_00156_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%orbit_01_00156_def =
( NAME    => "OC_MD_DQRP_MMR_DIR_LOCVEC2",
  ADDRESS => 0x0000000080050220,
  NOTE    => "local vector for acc=2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00156_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_DIR_LOCVEC3                                           #
#                                                                        #
##########################################################################

%orbit_01_00157_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%orbit_01_00157_def =
( NAME    => "OC_MD_DQRP_MMR_DIR_LOCVEC3",
  ADDRESS => 0x0000000080050230,
  NOTE    => "local vector for acc=3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00157_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_DIR_LOCVEC4                                           #
#                                                                        #
##########################################################################

%orbit_01_00158_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%orbit_01_00158_def =
( NAME    => "OC_MD_DQRP_MMR_DIR_LOCVEC4",
  ADDRESS => 0x0000000080050240,
  NOTE    => "local vector for acc=4",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00158_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_DIR_LOCVEC5                                           #
#                                                                        #
##########################################################################

%orbit_01_00159_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%orbit_01_00159_def =
( NAME    => "OC_MD_DQRP_MMR_DIR_LOCVEC5",
  ADDRESS => 0x0000000080050250,
  NOTE    => "local vector for acc=5",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00159_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_DIR_LOCVEC6                                           #
#                                                                        #
##########################################################################

%orbit_01_00160_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%orbit_01_00160_def =
( NAME    => "OC_MD_DQRP_MMR_DIR_LOCVEC6",
  ADDRESS => 0x0000000080050260,
  NOTE    => "local vector for acc=6",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00160_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_DIR_LOCVEC7                                           #
#                                                                        #
##########################################################################

%orbit_01_00161_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%orbit_01_00161_def =
( NAME    => "OC_MD_DQRP_MMR_DIR_LOCVEC7",
  ADDRESS => 0x0000000080050270,
  NOTE    => "local vector for acc=7",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00161_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_DIR_PRIVEC0                                           #
#                                                                        #
##########################################################################

%orbit_01_00162_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%orbit_01_00162_def =
( NAME    => "OC_MD_DQRP_MMR_DIR_PRIVEC0",
  ADDRESS => 0x0000000080050300,
  NOTE    => "This group of registers holds the privilege mask for certain note request type categories. CPU and IO nodes have separate bits f",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00162_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_DIR_PRIVEC1                                           #
#                                                                        #
##########################################################################

%orbit_01_00163_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%orbit_01_00163_def =
( NAME    => "OC_MD_DQRP_MMR_DIR_PRIVEC1",
  ADDRESS => 0x0000000080050310,
  NOTE    => "privilege vector for acc=1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00163_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_DIR_PRIVEC2                                           #
#                                                                        #
##########################################################################

%orbit_01_00164_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%orbit_01_00164_def =
( NAME    => "OC_MD_DQRP_MMR_DIR_PRIVEC2",
  ADDRESS => 0x0000000080050320,
  NOTE    => "privilege vector for acc=2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00164_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_DIR_PRIVEC3                                           #
#                                                                        #
##########################################################################

%orbit_01_00165_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%orbit_01_00165_def =
( NAME    => "OC_MD_DQRP_MMR_DIR_PRIVEC3",
  ADDRESS => 0x0000000080050330,
  NOTE    => "privilege vector for acc=3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00165_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_DIR_PRIVEC4                                           #
#                                                                        #
##########################################################################

%orbit_01_00166_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%orbit_01_00166_def =
( NAME    => "OC_MD_DQRP_MMR_DIR_PRIVEC4",
  ADDRESS => 0x0000000080050340,
  NOTE    => "privilege vector for acc=4",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00166_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_DIR_PRIVEC5                                           #
#                                                                        #
##########################################################################

%orbit_01_00167_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%orbit_01_00167_def =
( NAME    => "OC_MD_DQRP_MMR_DIR_PRIVEC5",
  ADDRESS => 0x0000000080050350,
  NOTE    => "privilege vector for acc=5",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00167_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_DIR_PRIVEC6                                           #
#                                                                        #
##########################################################################

%orbit_01_00168_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%orbit_01_00168_def =
( NAME    => "OC_MD_DQRP_MMR_DIR_PRIVEC6",
  ADDRESS => 0x0000000080050360,
  NOTE    => "privilege vector for acc=6",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00168_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_DIR_PRIVEC7                                           #
#                                                                        #
##########################################################################

%orbit_01_00169_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%orbit_01_00169_def =
( NAME    => "OC_MD_DQRP_MMR_DIR_PRIVEC7",
  ADDRESS => 0x0000000080050370,
  NOTE    => "privilege vector for acc=7",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00169_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_DIR_TIMER                                             #
#                                                                        #
##########################################################################

%orbit_01_00170_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIMER_CUR"                    => [   1,  13,   9, 0x00000000003FE000, 0x00, 1, 0x0000000000000000, "value of current timer" ],
   "TIMER_EN"                     => [   2,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "timer enable" ],
   "TIMER_DIV"                    => [   3,   0,  12, 0x0000000000000FFF, 0x00, 1, 0x0000000000000000, "timer divide register" ],
);

%orbit_01_00170_def =
( NAME    => "OC_MD_DQRP_MMR_DIR_TIMER",
  ADDRESS => 0x0000000080050400,
  NOTE    => "This register holds enables and configuration bits of the MD SXRO note timer. The core clock 'psbclk' is devided by 64 in a pres",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00170_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_PIOWD_DIR_ENTRY                                       #
#                                                                        #
##########################################################################

%orbit_01_00171_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  58,   6, 0xFC00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ACC"                          => [   1,  55,   3, 0x0380000000000000, 0x00, 1, 0x0000000000000000, "directory access bits" ],
   "PRI"                          => [   2,  52,   3, 0x0070000000000000, 0x00, 1, 0x0000000000000000, "directory priority" ],
   "DIRB"                         => [   3,  26,  26, 0x000FFFFFFC000000, 0x00, 1, 0x0000000000000000, "directory entry B" ],
   "DIRA"                         => [   4,   0,  26, 0x0000000003FFFFFF, 0x00, 1, 0x0000000000000000, "directory entry A" ],
);

%orbit_01_00171_def =
( NAME    => "OC_MD_DQRP_MMR_PIOWD_DIR_ENTRY",
  ADDRESS => 0x0000000080051000,
  NOTE    => "Directory entries A and B with access, priority and rsvd bits.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00171_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_PIOWD_DIR_ECC                                         #
#                                                                        #
##########################################################################

%orbit_01_00172_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  14,  50, 0xFFFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECCB"                         => [   1,   7,   7, 0x0000000000003F80, 0x00, 1, 0x0000000000000000, "XOR bits for directory ECC group 2" ],
   "ECCA"                         => [   2,   0,   7, 0x000000000000007F, 0x00, 1, 0x0000000000000000, "XOR bits for directory ECC group 1" ],
);

%orbit_01_00172_def =
( NAME    => "OC_MD_DQRP_MMR_PIOWD_DIR_ECC",
  ADDRESS => 0x0000000080051010,
  NOTE    => "These two ECC values are XORed with the generated directory ECC note bits and should be 0 for normal operation. Diagnostic softw",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00172_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_XPIORD_XDIR_ENTRY                                     #
#                                                                        #
##########################################################################

%orbit_01_00173_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNC"                          => [   1,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error" ],
   "COR"                          => [   2,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error" ],
   "ACC"                          => [   3,  55,   3, 0x0380000000000000, 0x00, 0, 0x0000000000000000, "directory access bits" ],
   "PRI"                          => [   4,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "directory priority" ],
   "DIRB"                         => [   5,  26,  26, 0x000FFFFFFC000000, 0x00, 0, 0x0000000000000000, "directory entry B" ],
   "DIRA"                         => [   6,   0,  26, 0x0000000003FFFFFF, 0x00, 0, 0x0000000000000000, "directory entry A" ],
);

%orbit_01_00173_def =
( NAME    => "OC_MD_DQRP_MMR_XPIORD_XDIR_ENTRY",
  ADDRESS => 0x0000000080052000,
  NOTE    => "Directory entries A and B with access, priority and rsvd bits.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00173_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_XPIORD_XDIR_ECC                                       #
#                                                                        #
##########################################################################

%orbit_01_00174_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  14,  50, 0xFFFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECCB"                         => [   1,   7,   7, 0x0000000000003F80, 0x00, 0, 0x0000000000000000, "group 2 ecc" ],
   "ECCA"                         => [   2,   0,   7, 0x000000000000007F, 0x00, 0, 0x0000000000000000, "group 1 ecc" ],
);

%orbit_01_00174_def =
( NAME    => "OC_MD_DQRP_MMR_XPIORD_XDIR_ECC",
  ADDRESS => 0x0000000080052010,
  NOTE    => "ECC bits of group 1 and 2 of directory pair.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00174_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_YPIORD_YDIR_ENTRY                                     #
#                                                                        #
##########################################################################

%orbit_01_00175_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNC"                          => [   1,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error" ],
   "COR"                          => [   2,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error" ],
   "ACC"                          => [   3,  55,   3, 0x0380000000000000, 0x00, 0, 0x0000000000000000, "directory access bits" ],
   "PRI"                          => [   4,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "directory priority" ],
   "DIRB"                         => [   5,  26,  26, 0x000FFFFFFC000000, 0x00, 0, 0x0000000000000000, "directory entry B" ],
   "DIRA"                         => [   6,   0,  26, 0x0000000003FFFFFF, 0x00, 0, 0x0000000000000000, "directory entry A" ],
);

%orbit_01_00175_def =
( NAME    => "OC_MD_DQRP_MMR_YPIORD_YDIR_ENTRY",
  ADDRESS => 0x0000000080052800,
  NOTE    => "Directory entries A and B with access, priority and rsvd bits.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00175_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_YPIORD_YDIR_ECC                                       #
#                                                                        #
##########################################################################

%orbit_01_00176_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  14,  50, 0xFFFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECCB"                         => [   1,   7,   7, 0x0000000000003F80, 0x00, 0, 0x0000000000000000, "group 2 ecc" ],
   "ECCA"                         => [   2,   0,   7, 0x000000000000007F, 0x00, 0, 0x0000000000000000, "group 1 ecc" ],
);

%orbit_01_00176_def =
( NAME    => "OC_MD_DQRP_MMR_YPIORD_YDIR_ECC",
  ADDRESS => 0x0000000080052810,
  NOTE    => "ECC bits of group 1 and 2 of directory pair.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00176_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_XCERR1                                                #
#                                                                        #
##########################################################################

%orbit_01_00177_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  39,  25, 0xFFFFFF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms uncorrectable ecc error capture" ],
   "MORE"                         => [   2,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one correctable ecc error in group 1" ],
   "VAL"                          => [   3,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error in group 1 bits" ],
   "GRP1"                         => [   4,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 1 bits" ],
);

%orbit_01_00177_def =
( NAME    => "OC_MD_DQRP_MMR_XCERR1",
  ADDRESS => 0x0000000080053000,
  NOTE    => "These registers capture the data bits for correctable directory ecc note errors. The data bits of ecc groups 1 and 2 that make t",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00177_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_XCERR2                                                #
#                                                                        #
##########################################################################

%orbit_01_00178_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one correctable ecc error in group 2" ],
   "VAL"                          => [   2,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error in group 2 bits" ],
   "GRP2"                         => [   3,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 2 bits" ],
);

%orbit_01_00178_def =
( NAME    => "OC_MD_DQRP_MMR_XCERR2",
  ADDRESS => 0x0000000080053010,
  NOTE    => "correctable dir ecc group 2 error register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00178_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_XUERR1                                                #
#                                                                        #
##########################################################################

%orbit_01_00179_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  39,  25, 0xFFFFFF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms uncorrectable ecc error capture" ],
   "MORE"                         => [   2,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one uncorrectable ecc error in group 1" ],
   "VAL"                          => [   3,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error in group 1 bits" ],
   "GRP1"                         => [   4,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 1 bits" ],
);

%orbit_01_00179_def =
( NAME    => "OC_MD_DQRP_MMR_XUERR1",
  ADDRESS => 0x0000000080053020,
  NOTE    => "These registers capture the data bits for uncorrectable directory note ecc errors. The data bits of ecc groups 1 and 2 that make",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00179_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_XUERR2                                                #
#                                                                        #
##########################################################################

%orbit_01_00180_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one uncorrectable ecc error in group 2" ],
   "VAL"                          => [   2,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error in group 2 bits" ],
   "GRP2"                         => [   3,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 2 bits" ],
);

%orbit_01_00180_def =
( NAME    => "OC_MD_DQRP_MMR_XUERR2",
  ADDRESS => 0x0000000080053030,
  NOTE    => "uncorrectable dir ecc group 2 error register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00180_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_XPERR                                                 #
#                                                                        #
##########################################################################

%orbit_01_00181_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms error capture" ],
   "MORE"                         => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "more than one protocol error" ],
   "VAL"                          => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "protocol error info valid" ],
   "MYBIT"                        => [   4,  52,   8, 0x0FF0000000000000, 0x00, 0, 0x0000000000000000, "ptreq,timeq,timlast,timspec,onlyme,anytim,ptrii,srcii" ],
   "UNC"                          => [   5,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error" ],
   "COR"                          => [   6,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error" ],
   "PRIV"                         => [   7,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "access privilege bit" ],
   "PRIGE"                        => [   8,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "priority was greater-equal" ],
   "SRC"                          => [   9,  34,  14, 0x0000FFFC00000000, 0x00, 0, 0x0000000000000000, "source node of dir operation" ],
   "CMD"                          => [  10,  26,   8, 0x00000003FC000000, 0x00, 0, 0x0000000000000000, "incoming command" ],
   "DIR"                          => [  11,   0,  26, 0x0000000003FFFFFF, 0x00, 0, 0x0000000000000000, "directory entry" ],
);

%orbit_01_00181_def =
( NAME    => "OC_MD_DQRP_MMR_XPERR",
  ADDRESS => 0x0000000080053040,
  NOTE    => "This register captures the table inputs for the first occurence of note a directory protocol table fall-through case. The direct",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00181_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_YCERR1                                                #
#                                                                        #
##########################################################################

%orbit_01_00182_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  39,  25, 0xFFFFFF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms uncorrectable ecc error capture" ],
   "MORE"                         => [   2,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one correctable ecc error in group 1" ],
   "VAL"                          => [   3,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error in group 1 bits" ],
   "GRP1"                         => [   4,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 1 bits" ],
);

%orbit_01_00182_def =
( NAME    => "OC_MD_DQRP_MMR_YCERR1",
  ADDRESS => 0x0000000080053800,
  NOTE    => "These registers capture the data bits for correctable directory ecc note errors. The data bits of ecc groups 1 and 2 that make t",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00182_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_YCERR2                                                #
#                                                                        #
##########################################################################

%orbit_01_00183_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one correctable ecc error in group 2" ],
   "VAL"                          => [   2,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error in group 2 bits" ],
   "GRP2"                         => [   3,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 2 bits" ],
);

%orbit_01_00183_def =
( NAME    => "OC_MD_DQRP_MMR_YCERR2",
  ADDRESS => 0x0000000080053810,
  NOTE    => "correctable dir ecc group 2 error register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00183_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_YUERR1                                                #
#                                                                        #
##########################################################################

%orbit_01_00184_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  39,  25, 0xFFFFFF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms uncorrectable ecc error capture" ],
   "MORE"                         => [   2,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one uncorrectable ecc error in group 1" ],
   "VAL"                          => [   3,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error in group 1 bits" ],
   "GRP1"                         => [   4,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 1 bits" ],
);

%orbit_01_00184_def =
( NAME    => "OC_MD_DQRP_MMR_YUERR1",
  ADDRESS => 0x0000000080053820,
  NOTE    => "These registers capture the data bits for uncorrectable directory note ecc errors. The data bits of ecc groups 1 and 2 that make",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00184_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_YUERR2                                                #
#                                                                        #
##########################################################################

%orbit_01_00185_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one uncorrectable ecc error in group 2" ],
   "VAL"                          => [   2,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error in group 2 bits" ],
   "GRP2"                         => [   3,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 2 bits" ],
);

%orbit_01_00185_def =
( NAME    => "OC_MD_DQRP_MMR_YUERR2",
  ADDRESS => 0x0000000080053830,
  NOTE    => "uncorrectable dir ecc group 2 error register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00185_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_YPERR                                                 #
#                                                                        #
##########################################################################

%orbit_01_00186_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms error capture" ],
   "MORE"                         => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "more than one protocol error" ],
   "VAL"                          => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "protocol error info valid" ],
   "MYBIT"                        => [   4,  52,   8, 0x0FF0000000000000, 0x00, 0, 0x0000000000000000, "ptreq,timeq,timlast,timspec,onlyme,anytim,ptrii,srcii" ],
   "UNC"                          => [   5,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error" ],
   "COR"                          => [   6,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error" ],
   "PRIV"                         => [   7,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "access privilege bit" ],
   "PRIGE"                        => [   8,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "priority was greater-equal" ],
   "SRC"                          => [   9,  34,  14, 0x0000FFFC00000000, 0x00, 0, 0x0000000000000000, "source node of dir operation" ],
   "CMD"                          => [  10,  26,   8, 0x00000003FC000000, 0x00, 0, 0x0000000000000000, "incoming command" ],
   "DIR"                          => [  11,   0,  26, 0x0000000003FFFFFF, 0x00, 0, 0x0000000000000000, "directory entry" ],
);

%orbit_01_00186_def =
( NAME    => "OC_MD_DQRP_MMR_YPERR",
  ADDRESS => 0x0000000080053840,
  NOTE    => "This register captures the table inputs for the first occurence of note a directory protocol table fall-through case. The direct",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00186_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_DIR_CMDTRIG                                           #
#                                                                        #
##########################################################################

%orbit_01_00187_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "YDIR_DBG_SEL"                 => [   1,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "Select X directory debug path" ],
   "XDIR_DBG_SEL"                 => [   2,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Select X directory debug path" ],
   "CMD3"                         => [   3,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "command trigger 3" ],
   "CMD2"                         => [   4,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "command trigger 2" ],
   "CMD1"                         => [   5,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "command trigger 1" ],
   "CMD0"                         => [   6,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "command trigger 0" ],
);

%orbit_01_00187_def =
( NAME    => "OC_MD_DQRP_MMR_DIR_CMDTRIG",
  ADDRESS => 0x0000000080054000,
  NOTE    => "This register holds 4 cmd encodings that are compared to the note incoming directory request. Each of the four comparators drive",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00187_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_DIR_TBLTRIG                                           #
#                                                                        #
##########################################################################

%orbit_01_00188_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  44,  20, 0xFFFFF00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MYBIT"                        => [   1,  36,   8, 0x00000FF000000000, 0x00, 0, 0x0000000000000000, "ptreq,timeq,timlast,timspec,onlyme,anytim,ptrii,srcii" ],
   "DIRST"                        => [   2,  27,   9, 0x0000000FF8000000, 0x00, 0, 0x0000000000000000, "shrd,sxro,sub-state" ],
   "PRIGE"                        => [   3,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "priority greater-equal" ],
   "ACC"                          => [   4,  24,   2, 0x0000000003000000, 0x00, 0, 0x0000000000000000, "uncorrectable error, privilege bit" ],
   "CMD"                          => [   5,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "incoming request" ],
   "SRC"                          => [   6,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "source of request" ],
);

%orbit_01_00188_def =
( NAME    => "OC_MD_DQRP_MMR_DIR_TBLTRIG",
  ADDRESS => 0x0000000080054010,
  NOTE    => "This register holds a value which is compared to the inputs of the note directory table logic. If they match a debug signal is a",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00188_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_DIR_TBLMASK                                           #
#                                                                        #
##########################################################################

%orbit_01_00189_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  44,  20, 0xFFFFF00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MYBIT"                        => [   1,  36,   8, 0x00000FF000000000, 0x00, 1, 0x0000000000000000, "ptreq,timeq,timlast,timspec,onlyme,anytim,ptrii,srcii" ],
   "DIRST"                        => [   2,  27,   9, 0x0000000FF8000000, 0x00, 1, 0x0000000000000000, "shrd,sxro,sub-state" ],
   "PRIGE"                        => [   3,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "priority greater-equal" ],
   "ACC"                          => [   4,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "uncorrectable error, privilege bit" ],
   "CMD"                          => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "incoming request" ],
   "SRC"                          => [   6,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "source of request" ],
);

%orbit_01_00189_def =
( NAME    => "OC_MD_DQRP_MMR_DIR_TBLMASK",
  ADDRESS => 0x0000000080054020,
  NOTE    => "dir table trigger mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00189_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_XBIST_H                                               #
#                                                                        #
##########################################################################

%orbit_01_00190_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  43,  21, 0xFFFFF80000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms data miscompare capture" ],
   "ROT"                          => [   2,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   3,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "RSVD1"                        => [   4,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   5,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%orbit_01_00190_def =
( NAME    => "OC_MD_DQRP_MMR_XBIST_H",
  ADDRESS => 0x0000000080058000,
  NOTE    => "These registers hold the DDR rising and falling edge data pattern note and bist/fill mode bits. The width of the data depends on",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00190_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_XBIST_L                                               #
#                                                                        #
##########################################################################

%orbit_01_00191_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ROT"                          => [   1,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "RSVD1"                        => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   4,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%orbit_01_00191_def =
( NAME    => "OC_MD_DQRP_MMR_XBIST_L",
  ADDRESS => 0x0000000080058010,
  NOTE    => "falling edge bist/fill pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00191_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_XBIST_ERR_H                                           #
#                                                                        #
##########################################################################

%orbit_01_00192_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "RSVD1"                        => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   4,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%orbit_01_00192_def =
( NAME    => "OC_MD_DQRP_MMR_XBIST_ERR_H",
  ADDRESS => 0x0000000080058020,
  NOTE    => "These registers hold the DDR rising and falling edge data pattern note for the first data miscompare during bist read/compare op",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00192_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_XBIST_ERR_L                                           #
#                                                                        #
##########################################################################

%orbit_01_00193_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "RSVD1"                        => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   4,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%orbit_01_00193_def =
( NAME    => "OC_MD_DQRP_MMR_XBIST_ERR_L",
  ADDRESS => 0x0000000080058030,
  NOTE    => "falling edge bist error pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00193_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_YBIST_H                                               #
#                                                                        #
##########################################################################

%orbit_01_00194_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  43,  21, 0xFFFFF80000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms data miscompare capture" ],
   "ROT"                          => [   2,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   3,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "RSVD1"                        => [   4,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   5,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%orbit_01_00194_def =
( NAME    => "OC_MD_DQRP_MMR_YBIST_H",
  ADDRESS => 0x0000000080058800,
  NOTE    => "These registers hold the DDR rising and falling edge data pattern note and bist/fill mode bits. The width of the data depends on",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00194_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_YBIST_L                                               #
#                                                                        #
##########################################################################

%orbit_01_00195_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ROT"                          => [   1,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "RSVD1"                        => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   4,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%orbit_01_00195_def =
( NAME    => "OC_MD_DQRP_MMR_YBIST_L",
  ADDRESS => 0x0000000080058810,
  NOTE    => "falling edge bist/fill pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00195_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_YBIST_ERR_H                                           #
#                                                                        #
##########################################################################

%orbit_01_00196_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "RSVD1"                        => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   4,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%orbit_01_00196_def =
( NAME    => "OC_MD_DQRP_MMR_YBIST_ERR_H",
  ADDRESS => 0x0000000080058820,
  NOTE    => "These registers hold the DDR rising and falling edge data pattern note for the first data miscompare during bist read/compare op",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00196_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_YBIST_ERR_L                                           #
#                                                                        #
##########################################################################

%orbit_01_00197_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "RSVD1"                        => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   4,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%orbit_01_00197_def =
( NAME    => "OC_MD_DQRP_MMR_YBIST_ERR_L",
  ADDRESS => 0x0000000080058830,
  NOTE    => "falling edge bist error pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00197_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRP_MMR_AMO_CFG                                               #
#                                                                        #
##########################################################################

%orbit_01_00198_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   2,  62, 0xFFFFFFFFFFFFFFFC, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EN_YAMOECC"                   => [   1,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "enable y amo ecc detection-correction logic" ],
   "EN_XAMOECC"                   => [   2,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "enable x amo ecc detection-correction logic" ],
);

%orbit_01_00198_def =
( NAME    => "OC_MD_DQRP_MMR_AMO_CFG",
  ADDRESS => 0x0000000080054800,
  NOTE    => "This register configures the amo logic.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00198_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRS_MMR_XBIST_H                                               #
#                                                                        #
##########################################################################

%orbit_01_00199_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  43,  21, 0xFFFFF80000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms data miscompare capture" ],
   "ROT"                          => [   2,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   3,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "PAT"                          => [   4,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%orbit_01_00199_def =
( NAME    => "OC_MD_DQRS_MMR_XBIST_H",
  ADDRESS => 0x0000000080068000,
  NOTE    => "These registers hold the DDR rising and falling edge data pattern note and bist/fill mode bits. The width of the data depends on",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00199_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRS_MMR_XBIST_L                                               #
#                                                                        #
##########################################################################

%orbit_01_00200_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ROT"                          => [   1,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "PAT"                          => [   3,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%orbit_01_00200_def =
( NAME    => "OC_MD_DQRS_MMR_XBIST_L",
  ADDRESS => 0x0000000080068010,
  NOTE    => "falling edge bist/fill pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00200_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRS_MMR_XBIST_ERR_H                                           #
#                                                                        #
##########################################################################

%orbit_01_00201_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "PAT"                          => [   3,   0,  40, 0x000000FFFFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%orbit_01_00201_def =
( NAME    => "OC_MD_DQRS_MMR_XBIST_ERR_H",
  ADDRESS => 0x0000000080068020,
  NOTE    => "These registers hold the DDR rising and falling edge data pattern note for the first data miscompare during bist read/compare op",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00201_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRS_MMR_XBIST_ERR_L                                           #
#                                                                        #
##########################################################################

%orbit_01_00202_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "PAT"                          => [   3,   0,  40, 0x000000FFFFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%orbit_01_00202_def =
( NAME    => "OC_MD_DQRS_MMR_XBIST_ERR_L",
  ADDRESS => 0x0000000080068030,
  NOTE    => "falling edge bist error pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00202_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRS_MMR_YBIST_H                                               #
#                                                                        #
##########################################################################

%orbit_01_00203_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  43,  21, 0xFFFFF80000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms data miscompare capture" ],
   "ROT"                          => [   2,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   3,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "PAT"                          => [   4,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%orbit_01_00203_def =
( NAME    => "OC_MD_DQRS_MMR_YBIST_H",
  ADDRESS => 0x0000000080068800,
  NOTE    => "These registers hold the DDR rising and falling edge data pattern note and bist/fill mode bits. The width of the data depends on",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00203_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRS_MMR_YBIST_L                                               #
#                                                                        #
##########################################################################

%orbit_01_00204_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ROT"                          => [   1,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "PAT"                          => [   3,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%orbit_01_00204_def =
( NAME    => "OC_MD_DQRS_MMR_YBIST_L",
  ADDRESS => 0x0000000080068810,
  NOTE    => "falling edge bist/fill pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00204_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRS_MMR_YBIST_ERR_H                                           #
#                                                                        #
##########################################################################

%orbit_01_00205_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "PAT"                          => [   3,   0,  40, 0x000000FFFFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%orbit_01_00205_def =
( NAME    => "OC_MD_DQRS_MMR_YBIST_ERR_H",
  ADDRESS => 0x0000000080068820,
  NOTE    => "These registers hold the DDR rising and falling edge data pattern note for the first data miscompare during bist read/compare op",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00205_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRS_MMR_YBIST_ERR_L                                           #
#                                                                        #
##########################################################################

%orbit_01_00206_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "PAT"                          => [   3,   0,  40, 0x000000FFFFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%orbit_01_00206_def =
( NAME    => "OC_MD_DQRS_MMR_YBIST_ERR_L",
  ADDRESS => 0x0000000080068830,
  NOTE    => "falling edge bist error pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00206_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRS_MMR_JNR_DEBUG                                             #
#                                                                        #
##########################################################################

%orbit_01_00207_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   2,  62, 0xFFFFFFFFFFFFFFFC, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RW"                           => [   1,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "select 0=read 1=write side" ],
   "PX"                           => [   2,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "select 0=pi 1=xn side" ],
);

%orbit_01_00207_def =
( NAME    => "OC_MD_DQRS_MMR_JNR_DEBUG",
  ADDRESS => 0x0000000080069000,
  NOTE    => "This register configure the joiner side rbug/wbuf address output to note the debug/performance port. Different addresses can be ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00207_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRS_MMR_YAMOPW_ERR                                            #
#                                                                        #
##########################################################################

%orbit_01_00208_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  49,  15, 0xFFFE000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms ecc error capture" ],
   "RSVD1"                        => [   2,  42,   6, 0x0000FC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RUNC"                         => [   3,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc errror on read data" ],
   "RCOR"                         => [   4,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "correctable ecc errror on read data" ],
   "RSYN"                         => [   5,  24,  16, 0x000000FFFF000000, 0x00, 0, 0x0000000000000000, "memory read data syndrome" ],
   "RSVD2"                        => [   6,  18,   6, 0x0000000000FC0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SUNC"                         => [   7,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc errror on store data" ],
   "SCOR"                         => [   8,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "correctable ecc errror on store data" ],
   "SSYN"                         => [   9,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "store data syndrome" ],
);

%orbit_01_00208_def =
( NAME    => "OC_MD_DQRS_MMR_YAMOPW_ERR",
  ADDRESS => 0x000000008006a000,
  NOTE    => "This register holds the full syndrome of an ecc error encountered note on read-modify-write data for amo and partial byte writes",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00208_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DQRS_MMR_AMO_CFG                                               #
#                                                                        #
##########################################################################

%orbit_01_00209_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   2,  62, 0xFFFFFFFFFFFFFFFC, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EN_YAMOECC"                   => [   1,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "enable y amo ecc detection-correction logic" ],
   "EN_XAMOECC"                   => [   2,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "enable x amo ecc detection-correction logic" ],
);

%orbit_01_00209_def =
( NAME    => "OC_MD_DQRS_MMR_AMO_CFG",
  ADDRESS => 0x000000008006b000,
  NOTE    => "This register configures the amo logic.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00209_flds
);


##########################################################################
#                                                                        #
#   OC_INT_NODE_ID_CONFIG                                                #
#                                                                        #
##########################################################################

%orbit_01_00210_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  39,  25, 0xFFFFFF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VECTOR"                       => [   1,  32,   7, 0x0000007F00000000, 0x00, 1, 0x0000000000000000, "Vector number for remote interrupt messags" ],
   "RSVD1"                        => [   2,  17,  15, 0x00000000FFFE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ID_SEL"                       => [   3,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Select node id for interrupt messages" ],
   "RSVD2"                        => [   4,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   5,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "Node ID for interrupt messages" ],
);

%orbit_01_00210_def =
( NAME    => "OC_INT_NODE_ID_CONFIG",
  ADDRESS => 0x0000000090000400,
  NOTE    => "The INT_NODE_ID_CONFIG register determines if the LB sends note interrupts to the local PI or if they're transmited to a PI on a",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00210_flds
);


##########################################################################
#                                                                        #
#   OC_SHUB_INTERRUPT_CONFIG                                             #
#                                                                        #
##########################################################################

%orbit_01_00211_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE"                         => [   3,  21,  29, 0x0003FFFFFFE00000, 0x00, 1, 0x0000000000000000, "Optional Processor Interrupt Base Pointer" ],
   "RSVD2"                        => [   4,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   5,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   6,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   7,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Interrupt Type" ],
);

%orbit_01_00211_def =
( NAME    => "OC_SHUB_INTERRUPT_CONFIG",
  ADDRESS => 0x0000000090000480,
  NOTE    => "The SHUB_INTERRUPT_CONFIG register provides a method of generating note a LINTR message that will be recognized by a McKinley pr",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00211_flds
);


##########################################################################
#                                                                        #
#   OC_HW_STAT_INT_ENABLE                                                #
#                                                                        #
##########################################################################

%orbit_01_00212_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REMOTE_ORBIT_L4_INT"          => [   1,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "Enable Remote Orbit L4 Interrupt" ],
   "REMOTE_ORBIT_L3_INT"          => [   2,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "Enable Remote Orbit L3 Interrupt" ],
   "REMOTE_ORBIT_L2_INT"          => [   3,  59,   1, 0x0800000000000000, 0x00, 1, 0x0000000000000000, "Enable Remote Orbit L2 Interrupt" ],
   "ICE_L4_INT"                   => [   4,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "Enable ICE L4 Interrupt" ],
   "ICE_L3_INT"                   => [   5,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "Enable ICE L3 Interrupt" ],
   "ICE_L2_INT"                   => [   6,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "Enable ICE L2 Interrupt" ],
   "RSVD1"                        => [   7,  50,   6, 0x00FC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SYSTEM_SHUTDOWN_INT"          => [   8,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "Enable System Shutdown Interrupt" ],
   "STOP_CLOCK"                   => [   9,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "Enable Stop Clock Interrupt" ],
   "RSVD2"                        => [  10,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ASIC_TO_L1"                   => [  11,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "Enable ASIC to L1 Controller Interrupt" ],
   "L1_TO_ASIC"                   => [  12,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "Enable L1 Controller to ASIC Interrupt" ],
   "GFX_INT_PIPE1"                => [  13,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "Enable Graphics Pipe 1 Interrupt" ],
   "GFX_INT_PIPE0"                => [  14,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "Enable Graphics Pipe 0 Interrupt" ],
   "II_RE_INT"                    => [  15,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "Enable II Recoverable Hardware Interrupt" ],
   "RSVD3"                        => [  16,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "II_HW_INT"                    => [  17,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "Enable II Hardware Interrupt" ],
   "LB_RE_INT"                    => [  18,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "Enable LB Recoverable Hardware Interrupt" ],
   "RSVD4"                        => [  19,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LB_HW_INT"                    => [  20,  24,   4, 0x000000000F000000, 0x00, 1, 0x0000000000000000, "Enable LB Hardware Interrupt" ],
   "RSVD5"                        => [  21,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_RE_INT"                    => [  22,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "Enable XN Recoverable Hardware Interrupt" ],
   "XN_CE_INT"                    => [  23,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "Enable XN Correctable Data Interrupt" ],
   "XN_HW_INT"                    => [  24,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "Enable XN Hardware Interrupt" ],
   "RSVD6"                        => [  25,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MD_RE_INT"                    => [  26,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Enable MD Recoverable Hardware Interrupt" ],
   "MD_CE_INT"                    => [  27,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Enable MD Correctable Data Interrupt" ],
   "MD_HW_INT"                    => [  28,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "Enable MD Hardware Interrupt" ],
   "RSVD7"                        => [  29,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PI_RE_INT"                    => [  30,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Enable PI Recoverable Hardware Interrupt" ],
   "PI_CE_INT"                    => [  31,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Enable PI Correctable Data Interrupt" ],
   "PI_HW_INT"                    => [  32,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Enable PI Hardware Interrupts" ],
);

%orbit_01_00212_def =
( NAME    => "OC_HW_STAT_INT_ENABLE",
  ADDRESS => 0x0000000090000980,
  NOTE    => "The HW_STAT_INT_ENABLE register enables/disables the associated note local hardware status interrupts when specified hardware er",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00212_flds
);


##########################################################################
#                                                                        #
#   OC_PROFILE_INT_ENABLE                                                #
#                                                                        #
##########################################################################

%orbit_01_00213_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PROFILE_ENABLE"               => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable Profile Interrupt" ],
);

%orbit_01_00213_def =
( NAME    => "OC_PROFILE_INT_ENABLE",
  ADDRESS => 0x0000000090000a00,
  NOTE    => "The PROFILE_INT_ENABLE register validates the PROFILE_INT_CONFIG note register and enables/disables Profile Interrupt generation",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00213_flds
);


##########################################################################
#                                                                        #
#   OC_RTC0_INT_ENABLE                                                   #
#                                                                        #
##########################################################################

%orbit_01_00214_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RTC0_ENABLE"                  => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable RTC 0 Interrupt" ],
);

%orbit_01_00214_def =
( NAME    => "OC_RTC0_INT_ENABLE",
  ADDRESS => 0x0000000090000a80,
  NOTE    => "The RTC0_INT_ENABLE register enables/disables RTC 0 Interrupts.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00214_flds
);


##########################################################################
#                                                                        #
#   OC_RTC1_INT_ENABLE                                                   #
#                                                                        #
##########################################################################

%orbit_01_00215_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RTC1_ENABLE"                  => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable RTC 1 Interrupt" ],
);

%orbit_01_00215_def =
( NAME    => "OC_RTC1_INT_ENABLE",
  ADDRESS => 0x0000000090000b00,
  NOTE    => "The RTC1_INT_ENABLE register enables/disables RTC 1 Interrupts.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00215_flds
);


##########################################################################
#                                                                        #
#   OC_RTC2_INT_ENABLE                                                   #
#                                                                        #
##########################################################################

%orbit_01_00216_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RTC2_ENABLE"                  => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable RTC 2 Interrupt" ],
);

%orbit_01_00216_def =
( NAME    => "OC_RTC2_INT_ENABLE",
  ADDRESS => 0x0000000090000b80,
  NOTE    => "The RTC2_INT_ENABLE register enables/disables RTC 2 Interrupts.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00216_flds
);


##########################################################################
#                                                                        #
#   OC_RTC3_INT_ENABLE                                                   #
#                                                                        #
##########################################################################

%orbit_01_00217_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RTC3_ENABLE"                  => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable RTC 3 Interrupt" ],
);

%orbit_01_00217_def =
( NAME    => "OC_RTC3_INT_ENABLE",
  ADDRESS => 0x0000000090000c00,
  NOTE    => "The RTC3_INT_ENABLE register enables/disables RTC 3 Interrupts.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00217_flds
);


##########################################################################
#                                                                        #
#   OC_HW_ERR_INT_ENABLE                                                 #
#                                                                        #
##########################################################################

%orbit_01_00218_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  44,  20, 0xFFFFF00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REMOTE_ORBIT_L6_INT"          => [   1,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "Enable Remote Orbit L6 Interrupt" ],
   "REMOTE_ORBIT_L5_INT"          => [   2,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "Enable Remote Orbit L5 Interrupt" ],
   "ICE_L6_INT"                   => [   3,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "Enable ICE L6 Interrupt" ],
   "ICE_L5_INT"                   => [   4,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "Enable ICE L5 Interrupt" ],
   "RSVD1"                        => [   5,  35,   5, 0x000000F800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "II_NRE_INT"                   => [   6,  32,   3, 0x0000000700000000, 0x00, 1, 0x0000000000000000, "Enable II Hardware Error Interrupt" ],
   "RSVD2"                        => [   7,  27,   5, 0x00000000F8000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LB_NRE_INT"                   => [   8,  24,   3, 0x0000000007000000, 0x00, 1, 0x0000000000000000, "Enable LB Hardware Error Interrupt" ],
   "RSVD3"                        => [   9,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_UCE_INT"                   => [  10,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "Enable XN Uncorrectable Data Interrupt" ],
   "XN_NRE_INT"                   => [  11,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "Enable XN Hardware Error Interrupt" ],
   "RSVD4"                        => [  12,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MD_UCE_INT"                   => [  13,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "Enable MD Uncorrectable Data Interrupt" ],
   "MD_NRE_INT"                   => [  14,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "Enable MD Hardware Error Interrupt" ],
   "RSVD5"                        => [  15,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PI_UCE_INT"                   => [  16,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Enable PI Uncorrectable Data Interrupt" ],
   "PI_NRE_INT"                   => [  17,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Enable PI Hardware Error Interrupts" ],
);

%orbit_01_00218_def =
( NAME    => "OC_HW_ERR_INT_ENABLE",
  ADDRESS => 0x0000000090000c80,
  NOTE    => "The HW_ERR_INT_ENABLE register enables/disables the associated note local hardware error interrupts when specified hardware erro",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00218_flds
);


##########################################################################
#                                                                        #
#   OC_NMI_INT_ENABLE                                                    #
#                                                                        #
##########################################################################

%orbit_01_00219_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  10,  54, 0xFFFFFFFFFFFFFC00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REMOTE_ORBIT_NMI_INT"         => [   1,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Enable NMI Interrupt From Remote Orbit" ],
   "ICE_NMI_INT"                  => [   2,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Enable NMI Interrupt From Peer-IO" ],
   "RSVD1"                        => [   3,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NMI_TARGETS"                  => [   4,   1,   4, 0x000000000000001E, 0x00, 1, 0x0000000000000000, "NMI Targets" ],
   "L1_NMI_INT"                   => [   5,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable L1 NMI Interrupts" ],
);

%orbit_01_00219_def =
( NAME    => "OC_NMI_INT_ENABLE",
  ADDRESS => 0x0000000090000f00,
  NOTE    => "The NMI_INT_ENABLE register enables/disables the generation of note non-maskable interrupts from the L1 controller or remote NMI",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00219_flds
);


##########################################################################
#                                                                        #
#   OC_L2_PEND_MOD                                                       #
#                                                                        #
##########################################################################

%orbit_01_00220_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VALUE"                        => [   1,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "New value for modified bit" ],
   "RSVD1"                        => [   2,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BIT_SELECT"                   => [   3,   0,   7, 0x000000000000007F, 0x00, 1, 0x0000000000000000, "Bit within L2_INT_PEND to be modified" ],
);

%orbit_01_00220_def =
( NAME    => "OC_L2_PEND_MOD",
  ADDRESS => 0x0000000090000f80,
  NOTE    => "The L2_PEND_MOD register is used by the service routines to note manipulate individual bits within the L2 interrupt pending regi",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00220_flds
);


##########################################################################
#                                                                        #
#   OC_L3_PEND_MOD                                                       #
#                                                                        #
##########################################################################

%orbit_01_00221_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VALUE"                        => [   1,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "New value for modified bit" ],
   "RSVD1"                        => [   2,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BIT_SELECT"                   => [   3,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Bit within L3_INT_PEND to be modified" ],
);

%orbit_01_00221_def =
( NAME    => "OC_L3_PEND_MOD",
  ADDRESS => 0x0000000090001000,
  NOTE    => "The L3_PEND_MOD register is used by the service routines to note manipulate individual bits within the L3 interrupt pending regi",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00221_flds
);


##########################################################################
#                                                                        #
#   OC_L4_PEND_MOD                                                       #
#                                                                        #
##########################################################################

%orbit_01_00222_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VALUE"                        => [   1,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "New value for modified bit" ],
   "RSVD1"                        => [   2,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BIT_SELECT"                   => [   3,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Bit within L4_INT_PEND to be modified" ],
);

%orbit_01_00222_def =
( NAME    => "OC_L4_PEND_MOD",
  ADDRESS => 0x0000000090001080,
  NOTE    => "The L4_PEND_MOD register is used by the service routines to note manipulate individual bits within the L4 interrupt pending regi",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00222_flds
);


##########################################################################
#                                                                        #
#   OC_L5_PEND_MOD                                                       #
#                                                                        #
##########################################################################

%orbit_01_00223_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VALUE"                        => [   1,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "New value for modified bit" ],
   "RSVD1"                        => [   2,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BIT_SELECT"                   => [   3,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Bit within L5_INT_PEND to be modified" ],
);

%orbit_01_00223_def =
( NAME    => "OC_L5_PEND_MOD",
  ADDRESS => 0x0000000090001100,
  NOTE    => "The L5_PEND_MOD register is used by the service routines to note manipulate individual bits within the L5 interrupt pending regi",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00223_flds
);


##########################################################################
#                                                                        #
#   OC_L6_PEND_MOD                                                       #
#                                                                        #
##########################################################################

%orbit_01_00224_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VALUE"                        => [   1,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "New value for modified bit" ],
   "RSVD1"                        => [   2,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BIT_SELECT"                   => [   3,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Bit within L6_INT_PEND to be modified" ],
);

%orbit_01_00224_def =
( NAME    => "OC_L6_PEND_MOD",
  ADDRESS => 0x0000000090001180,
  NOTE    => "The L6_PEND_MOD register is used by the service routines to note manipulate individual bits within the L6 interrupt pending regi",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00224_flds
);


##########################################################################
#                                                                        #
#   OC_NMI_PEND_MOD                                                      #
#                                                                        #
##########################################################################

%orbit_01_00225_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VALUE"                        => [   1,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "New value for modified bit" ],
   "RSVD1"                        => [   2,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BIT_SELECT"                   => [   3,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Bit within NMI_INT_PEND to be modified" ],
);

%orbit_01_00225_def =
( NAME    => "OC_NMI_PEND_MOD",
  ADDRESS => 0x0000000090001200,
  NOTE    => "The NMI_PEND_MOD register is used by the service routines to note manipulate individual bits within the NMI interrupt pending no",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00225_flds
);


##########################################################################
#                                                                        #
#   OC_P0_L2_INT_MASK0                                                   #
#                                                                        #
##########################################################################

%orbit_01_00226_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P0 L2 Interrupt Mask Bits 0 - 63" ],
);

%orbit_01_00226_def =
( NAME    => "OC_P0_L2_INT_MASK0",
  ADDRESS => 0x0000000090001300,
  NOTE    => "The P0_L2_INT_MASK register is used to mask L2 interrupts to note processor 0. If a MASK bit is set and the corresponding bit in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00226_flds
);


##########################################################################
#                                                                        #
#   OC_P0_L2_INT_MASK1                                                   #
#                                                                        #
##########################################################################

%orbit_01_00227_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P0 L2 Interrupt Mask Bits 64 - 127" ],
);

%orbit_01_00227_def =
( NAME    => "OC_P0_L2_INT_MASK1",
  ADDRESS => 0x0000000090001380,
  NOTE    => "The P0_L2_INT_MASK register is used to mask L2 interrupts to note processor 0. If a MASK bit is set and the corresponding bit in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00227_flds
);


##########################################################################
#                                                                        #
#   OC_P0_L3_INT_MASK                                                    #
#                                                                        #
##########################################################################

%orbit_01_00228_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P0 L3 Interrupt Mask" ],
);

%orbit_01_00228_def =
( NAME    => "OC_P0_L3_INT_MASK",
  ADDRESS => 0x0000000090001400,
  NOTE    => "The P0_L3_INT_MASK register is used to mask L3 interrupts to note processor 0. If a MASK bit is set and the corresponding bit in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00228_flds
);


##########################################################################
#                                                                        #
#   OC_P0_L4_INT_MASK                                                    #
#                                                                        #
##########################################################################

%orbit_01_00229_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P0 L4 Interrupt Mask" ],
);

%orbit_01_00229_def =
( NAME    => "OC_P0_L4_INT_MASK",
  ADDRESS => 0x0000000090001480,
  NOTE    => "The P0_L4_INT_MASK register is used to mask L4 interrupts to note processor 0. If a MASK bit is set and the corresponding bit in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00229_flds
);


##########################################################################
#                                                                        #
#   OC_P0_L5_INT_MASK                                                    #
#                                                                        #
##########################################################################

%orbit_01_00230_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P0 L5 Interrupt Mask" ],
);

%orbit_01_00230_def =
( NAME    => "OC_P0_L5_INT_MASK",
  ADDRESS => 0x0000000090001500,
  NOTE    => "The P0_L5_INT_MASK register is used to mask L5 interrupts to note processor 0. If a MASK bit is set and the corresponding bit in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00230_flds
);


##########################################################################
#                                                                        #
#   OC_P0_L6_INT_MASK                                                    #
#                                                                        #
##########################################################################

%orbit_01_00231_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P0 L6 Interrupt Mask" ],
);

%orbit_01_00231_def =
( NAME    => "OC_P0_L6_INT_MASK",
  ADDRESS => 0x0000000090001580,
  NOTE    => "The P0_L6_INT_MASK register is used to mask L6 interrupts to note processor 0. If a MASK bit is set and the corresponding bit in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00231_flds
);


##########################################################################
#                                                                        #
#   OC_P1_L2_INT_MASK0                                                   #
#                                                                        #
##########################################################################

%orbit_01_00232_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P1 L2 Interrupt Mask Bits 0 - 63" ],
);

%orbit_01_00232_def =
( NAME    => "OC_P1_L2_INT_MASK0",
  ADDRESS => 0x0000000090001600,
  NOTE    => "The P1_L2_INT_MASK register is used to mask L2 interrupts to note processor 1. If a MASK bit is set and the corresponding bit in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00232_flds
);


##########################################################################
#                                                                        #
#   OC_P1_L2_INT_MASK1                                                   #
#                                                                        #
##########################################################################

%orbit_01_00233_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P1 L2 Interrupt Mask Bits 64 - 127" ],
);

%orbit_01_00233_def =
( NAME    => "OC_P1_L2_INT_MASK1",
  ADDRESS => 0x0000000090001680,
  NOTE    => "The P1_L2_INT_MASK register is used to mask L2 interrupts to note processor 1. If a MASK bit is set and the corresponding bit in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00233_flds
);


##########################################################################
#                                                                        #
#   OC_P1_L3_INT_MASK                                                    #
#                                                                        #
##########################################################################

%orbit_01_00234_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P1 L3 Interrupt Mask" ],
);

%orbit_01_00234_def =
( NAME    => "OC_P1_L3_INT_MASK",
  ADDRESS => 0x0000000090001700,
  NOTE    => "The P1_L3_INT_MASK register is used to mask L3 interrupts to note processor 1. If a MASK bit is set and the corresponding bit in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00234_flds
);


##########################################################################
#                                                                        #
#   OC_P1_L4_INT_MASK                                                    #
#                                                                        #
##########################################################################

%orbit_01_00235_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P1 L4 Interrupt Mask" ],
);

%orbit_01_00235_def =
( NAME    => "OC_P1_L4_INT_MASK",
  ADDRESS => 0x0000000090001780,
  NOTE    => "The P1_L4_INT_MASK register is used to mask L4 interrupts to note processor 1. If a MASK bit is set and the corresponding bit in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00235_flds
);


##########################################################################
#                                                                        #
#   OC_P1_L5_INT_MASK                                                    #
#                                                                        #
##########################################################################

%orbit_01_00236_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P1 L5 Interrupt Mask" ],
);

%orbit_01_00236_def =
( NAME    => "OC_P1_L5_INT_MASK",
  ADDRESS => 0x0000000090001800,
  NOTE    => "The P1_L5_INT_MASK register is used to mask L5 interrupts to note processor 1. If a MASK bit is set and the corresponding bit in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00236_flds
);


##########################################################################
#                                                                        #
#   OC_P1_L6_INT_MASK                                                    #
#                                                                        #
##########################################################################

%orbit_01_00237_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P1 L6 Interrupt Mask" ],
);

%orbit_01_00237_def =
( NAME    => "OC_P1_L6_INT_MASK",
  ADDRESS => 0x0000000090001880,
  NOTE    => "The P1_L6_INT_MASK register is used to mask L6 interrupts to note processor 1. If a MASK bit is set and the corresponding bit in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00237_flds
);


##########################################################################
#                                                                        #
#   OC_P2_L2_INT_MASK0                                                   #
#                                                                        #
##########################################################################

%orbit_01_00238_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P2 L2 Interrupt Mask Bits 0 - 63" ],
);

%orbit_01_00238_def =
( NAME    => "OC_P2_L2_INT_MASK0",
  ADDRESS => 0x0000000090001900,
  NOTE    => "The P2_L2_INT_MASK register is used to mask L2 interrupts to note processor 2. If a MASK bit is set and the corresponding bit in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00238_flds
);


##########################################################################
#                                                                        #
#   OC_P2_L2_INT_MASK1                                                   #
#                                                                        #
##########################################################################

%orbit_01_00239_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P2 L2 Interrupt Mask Bits 64 - 127" ],
);

%orbit_01_00239_def =
( NAME    => "OC_P2_L2_INT_MASK1",
  ADDRESS => 0x0000000090001980,
  NOTE    => "The P2_L2_INT_MASK register is used to mask L2 interrupts to note processor 2. If a MASK bit is set and the corresponding bit in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00239_flds
);


##########################################################################
#                                                                        #
#   OC_P2_L3_INT_MASK                                                    #
#                                                                        #
##########################################################################

%orbit_01_00240_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P2 L3 Interrupt Mask" ],
);

%orbit_01_00240_def =
( NAME    => "OC_P2_L3_INT_MASK",
  ADDRESS => 0x0000000090001a00,
  NOTE    => "The P2_L3_INT_MASK register is used to mask L3 interrupts to note processor 2. If a MASK bit is set and the corresponding bit in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00240_flds
);


##########################################################################
#                                                                        #
#   OC_P2_L4_INT_MASK                                                    #
#                                                                        #
##########################################################################

%orbit_01_00241_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P2 L4 Interrupt Mask" ],
);

%orbit_01_00241_def =
( NAME    => "OC_P2_L4_INT_MASK",
  ADDRESS => 0x0000000090001a80,
  NOTE    => "The P2_L4_INT_MASK register is used to mask L4 interrupts to note processor 2. If a MASK bit is set and the corresponding bit in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00241_flds
);


##########################################################################
#                                                                        #
#   OC_P2_L5_INT_MASK                                                    #
#                                                                        #
##########################################################################

%orbit_01_00242_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P2 L5 Interrupt Mask" ],
);

%orbit_01_00242_def =
( NAME    => "OC_P2_L5_INT_MASK",
  ADDRESS => 0x0000000090001b00,
  NOTE    => "The P2_L5_INT_MASK register is used to mask L5 interrupts to note processor 2. If a MASK bit is set and the corresponding bit in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00242_flds
);


##########################################################################
#                                                                        #
#   OC_P2_L6_INT_MASK                                                    #
#                                                                        #
##########################################################################

%orbit_01_00243_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P2 L6 Interrupt Mask" ],
);

%orbit_01_00243_def =
( NAME    => "OC_P2_L6_INT_MASK",
  ADDRESS => 0x0000000090001b80,
  NOTE    => "The P2_L6_INT_MASK register is used to mask L6 interrupts to note processor 2. If a MASK bit is set and the corresponding bit in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00243_flds
);


##########################################################################
#                                                                        #
#   OC_P3_L2_INT_MASK0                                                   #
#                                                                        #
##########################################################################

%orbit_01_00244_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P3 L2 Interrupt Mask Bits 0 - 63" ],
);

%orbit_01_00244_def =
( NAME    => "OC_P3_L2_INT_MASK0",
  ADDRESS => 0x0000000090001c00,
  NOTE    => "The P3_L2_INT_MASK register is used to mask L2 interrupts to note processor 3. If a MASK bit is set and the corresponding bit in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00244_flds
);


##########################################################################
#                                                                        #
#   OC_P3_L2_INT_MASK1                                                   #
#                                                                        #
##########################################################################

%orbit_01_00245_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P3 L2 Interrupt Mask Bits 64 - 127" ],
);

%orbit_01_00245_def =
( NAME    => "OC_P3_L2_INT_MASK1",
  ADDRESS => 0x0000000090001c80,
  NOTE    => "The P3_L2_INT_MASK register is used to mask L2 interrupts to note processor 3. If a MASK bit is set and the corresponding bit in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00245_flds
);


##########################################################################
#                                                                        #
#   OC_P3_L3_INT_MASK                                                    #
#                                                                        #
##########################################################################

%orbit_01_00246_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P3 L3 Interrupt Mask" ],
);

%orbit_01_00246_def =
( NAME    => "OC_P3_L3_INT_MASK",
  ADDRESS => 0x0000000090001d00,
  NOTE    => "The P3_L3_INT_MASK register is used to mask L3 interrupts to note processor 3. If a MASK bit is set and the corresponding bit in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00246_flds
);


##########################################################################
#                                                                        #
#   OC_P3_L4_INT_MASK                                                    #
#                                                                        #
##########################################################################

%orbit_01_00247_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P3 L4 Interrupt Mask" ],
);

%orbit_01_00247_def =
( NAME    => "OC_P3_L4_INT_MASK",
  ADDRESS => 0x0000000090001d80,
  NOTE    => "The P3_L4_INT_MASK register is used to mask L4 interrupts to note processor 3. If a MASK bit is set and the corresponding bit in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00247_flds
);


##########################################################################
#                                                                        #
#   OC_P3_L5_INT_MASK                                                    #
#                                                                        #
##########################################################################

%orbit_01_00248_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P3 L5 Interrupt Mask" ],
);

%orbit_01_00248_def =
( NAME    => "OC_P3_L5_INT_MASK",
  ADDRESS => 0x0000000090001e00,
  NOTE    => "The P3_L5_INT_MASK register is used to mask L5 interrupts to note processor 3. If a MASK bit is set and the corresponding bit in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00248_flds
);


##########################################################################
#                                                                        #
#   OC_P3_L6_INT_MASK                                                    #
#                                                                        #
##########################################################################

%orbit_01_00249_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P3 L6 Interrupt Mask" ],
);

%orbit_01_00249_def =
( NAME    => "OC_P3_L6_INT_MASK",
  ADDRESS => 0x0000000090001e80,
  NOTE    => "The P3_L6_INT_MASK register is used to mask L6 interrupts to note processor 3. If a MASK bit is set and the corresponding bit in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00249_flds
);


##########################################################################
#                                                                        #
#   OC_L2_INT_PEND0                                                      #
#                                                                        #
##########################################################################

%orbit_01_00250_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_PEND_L2"                  => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 1, 0x0000000000000000, "L2 General Purpose Interrupt Flags" ],
   "ASIC_TO_L1"                   => [   1,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "ASIC to L1 Controller Interrupt" ],
   "L1_TO_ASIC"                   => [   2,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "L1 Controller to ASIC Interrupt" ],
   "GFX_INT_PIPE1"                => [   3,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "L2 Graphics Interrupt From Pipe 1" ],
   "GFX_INT_PIPE0"                => [   4,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "L2 Graphics Interrupt From Pipe 0" ],
   "II_HW_INT"                    => [   5,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "L2 Hardware Interrupts From II" ],
   "LB_HW_INT"                    => [   6,  12,   4, 0x000000000000F000, 0x00, 1, 0x0000000000000000, "L2 Hardware Interrupts From LB" ],
   "XN_HW_INT"                    => [   7,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "L2 Hardware Interrupts From XN" ],
   "MD_HW_INT"                    => [   8,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "L2 Hardware Interrupts From MD" ],
   "PI_HW_INT"                    => [   9,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "L2 Hardware Interrupts From PI" ],
);

%orbit_01_00250_def =
( NAME    => "OC_L2_INT_PEND0",
  ADDRESS => 0x0000000090010000,
  NOTE    => "The L2_INT_PEND0 register contains bits 0 - 63 of the pending level note 2 interrupts. Hardware defined interrupts are mapped in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00250_flds
);


##########################################################################
#                                                                        #
#   OC_L2_INT_PEND1                                                      #
#                                                                        #
##########################################################################

%orbit_01_00251_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_PEND_L2"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "L2 General Purpose Interrupt Flags 64 - 127" ],
);

%orbit_01_00251_def =
( NAME    => "OC_L2_INT_PEND1",
  ADDRESS => 0x0000000090010080,
  NOTE    => "The L2_INT_PEND1 register contains bits 64 - 127 of the pending note level 2 interrupts. Hardware defined interrupts are mapped ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00251_flds
);


##########################################################################
#                                                                        #
#   OC_L3_INT_PEND                                                       #
#                                                                        #
##########################################################################

%orbit_01_00252_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_PEND_L3"                  => [   0,  10,  54, 0xFFFFFFFFFFFFFC00, 0x00, 1, 0x0000000000000000, "L2 General Purpose Interrupt Flags" ],
   "STOP_CLOCK"                   => [   1,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Stop Clock Interrupt From LB" ],
   "SYS_SHUTDOWN"                 => [   2,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "System SHutdown Interrupt From L1 Controller" ],
   "II_RE_INT"                    => [   3,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "L3 Recoverable Interrupt From II" ],
   "LB_RE_INT"                    => [   4,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "L3 Recoverable Interrupt From LB" ],
   "XN_RE_INT"                    => [   5,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "L3 Recoverable Interrupt From XN" ],
   "XN_CE_INT"                    => [   6,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "L3 Correctable Data Error Interrupt From XN" ],
   "MD_RE_INT"                    => [   7,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "L3 Recoverable Interrupt From MD" ],
   "MD_CE_INT"                    => [   8,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "L3 Correctable Data Error Interrupt From MD" ],
   "PI_RE_INT"                    => [   9,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "L3 Recoverable Interrupt From PI" ],
   "PI_CE_INT"                    => [  10,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "L3 Correctable Data Error Interrupt From PI" ],
);

%orbit_01_00252_def =
( NAME    => "OC_L3_INT_PEND",
  ADDRESS => 0x0000000090010100,
  NOTE    => "The L3_INT_PEND register contains the pending level 3 interrupts. note Hardware defined interrupts are mapped into the lower bit",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00252_flds
);


##########################################################################
#                                                                        #
#   OC_L4_INT_PEND                                                       #
#                                                                        #
##########################################################################

%orbit_01_00253_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_PEND_L4"                  => [   0,   4,  60, 0xFFFFFFFFFFFFFFF0, 0x00, 1, 0x0000000000000000, "L4 General Purpose Interrupt Flags" ],
   "RTC3_INT"                     => [   1,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Real Time Clock Interrupt 3" ],
   "RTC2_INT"                     => [   2,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Real Time Clock Interrupt 2" ],
   "RTC1_INT"                     => [   3,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Real Time Clock Interrupt 1" ],
   "RTC0_INT"                     => [   4,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Real Time Clock Interrupt 0" ],
);

%orbit_01_00253_def =
( NAME    => "OC_L4_INT_PEND",
  ADDRESS => 0x0000000090010180,
  NOTE    => "The L4_INT_PEND register contains the pending level 4 interrupts. note Hardware defined interrupts are mapped into the lower bit",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00253_flds
);


##########################################################################
#                                                                        #
#   OC_L5_INT_PEND                                                       #
#                                                                        #
##########################################################################

%orbit_01_00254_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_PEND_L5"                  => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 1, 0x0000000000000000, "L5 General Purpose Interrupt Flags" ],
   "PROFILE_INT"                  => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Profile Interrupt" ],
);

%orbit_01_00254_def =
( NAME    => "OC_L5_INT_PEND",
  ADDRESS => 0x0000000090010200,
  NOTE    => "The L5_INT_PEND register contains the pending level 5 interrupts. note Hardware defined interrupts are mapped into the lower bit",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00254_flds
);


##########################################################################
#                                                                        #
#   OC_L6_INT_PEND                                                       #
#                                                                        #
##########################################################################

%orbit_01_00255_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_PEND_L6"                  => [   0,  18,  46, 0xFFFFFFFFFFFC0000, 0x00, 1, 0x0000000000000000, "L6 General Purpose Interrupt Flags" ],
   "II_NRE_INT"                   => [   1,  15,   3, 0x0000000000038000, 0x00, 1, 0x0000000000000000, "L6 Non-revocerable Hardware Interrupts From II" ],
   "LB_NRE_INT"                   => [   2,  12,   3, 0x0000000000007000, 0x00, 1, 0x0000000000000000, "L6 Non-revocerable Hardware Interrupts From LB" ],
   "XN_UCE_INT"                   => [   3,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "L6 Uncorrectable Data Error Interrupt From XN" ],
   "XN_NRE_INT"                   => [   4,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "L6 Non-revocerable Hardware Interrupts From XN" ],
   "MD_UCE_INT"                   => [   5,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "L6 Uncorrectable Data Error Interrupt From MD" ],
   "MD_NRE_INT"                   => [   6,   4,   3, 0x0000000000000070, 0x00, 1, 0x0000000000000000, "L6 Non-revocerable Hardware Interrupts From MD" ],
   "PI_UCE_INT"                   => [   7,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "L6 Uncorrectable Data Error Interrupt From PI" ],
   "PI_NRE_INT"                   => [   8,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "L6 Non-revocerable Hardware Interrupts From PI" ],
);

%orbit_01_00255_def =
( NAME    => "OC_L6_INT_PEND",
  ADDRESS => 0x0000000090010280,
  NOTE    => "The L6_INT_PEND register contains the pending level 6 interrupts. note Hardware defined interrupts are mapped into the lower bit",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00255_flds
);


##########################################################################
#                                                                        #
#   OC_NMI_INT_PEND                                                      #
#                                                                        #
##########################################################################

%orbit_01_00256_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_PEND_NMI"                 => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 1, 0x0000000000000000, "General Purpose NMI Interrupt Flags" ],
   "L1_CONTROLLER"                => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "NMI Interrupt From L1 Controller" ],
);

%orbit_01_00256_def =
( NAME    => "OC_NMI_INT_PEND",
  ADDRESS => 0x0000000090010300,
  NOTE    => "The NMI_INT_PEND register contains the pending nmi interrupts. note Hardware defined interrupts are mapped into the lower bits a",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00256_flds
);


##########################################################################
#                                                                        #
#   OC_P0_L2_INT_STATUS0                                                 #
#                                                                        #
##########################################################################

%orbit_01_00257_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATUS"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P0 L2 Interrupt Status Bits 0 - 63" ],
);

%orbit_01_00257_def =
( NAME    => "OC_P0_L2_INT_STATUS0",
  ADDRESS => 0x0000000090010380,
  NOTE    => "The P0_L2_INT_STATUS0 register contains status bits 0 - 63 of the note pending L2 interrupts for processor 0. Each bit in this r",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00257_flds
);


##########################################################################
#                                                                        #
#   OC_P0_L2_INT_STATUS1                                                 #
#                                                                        #
##########################################################################

%orbit_01_00258_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATUS"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P0 L2 Interrupt Status Bits 64 - 127" ],
);

%orbit_01_00258_def =
( NAME    => "OC_P0_L2_INT_STATUS1",
  ADDRESS => 0x0000000090010400,
  NOTE    => "The P0_L2_INT_STATUS1 register contains status bits 64 - 127 of the note pending L2 interrupts for processor 0. Each bit in this",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00258_flds
);


##########################################################################
#                                                                        #
#   OC_P0_L3_INT_STATUS                                                  #
#                                                                        #
##########################################################################

%orbit_01_00259_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATUS"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P0 L3 Interrupt Status" ],
);

%orbit_01_00259_def =
( NAME    => "OC_P0_L3_INT_STATUS",
  ADDRESS => 0x0000000090010480,
  NOTE    => "The P0_L3_INT_STATUS register contains status of the pending L3 note interrupts for processor 0. Each bit in this register is an",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00259_flds
);


##########################################################################
#                                                                        #
#   OC_P0_L4_INT_STATUS                                                  #
#                                                                        #
##########################################################################

%orbit_01_00260_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATUS"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P0 L4 Interrupt Status" ],
);

%orbit_01_00260_def =
( NAME    => "OC_P0_L4_INT_STATUS",
  ADDRESS => 0x0000000090010500,
  NOTE    => "The P0_L4_INT_STATUS register contains status of the pending L4 note interrupts for processor 0. Each bit in this register is an",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00260_flds
);


##########################################################################
#                                                                        #
#   OC_P0_L5_INT_STATUS                                                  #
#                                                                        #
##########################################################################

%orbit_01_00261_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATUS"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P0 L5 Interrupt Status" ],
);

%orbit_01_00261_def =
( NAME    => "OC_P0_L5_INT_STATUS",
  ADDRESS => 0x0000000090010580,
  NOTE    => "The P0_L5_INT_STATUS register contains status of the pending L5 note interrupts for processor 0. Each bit in this register is an",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00261_flds
);


##########################################################################
#                                                                        #
#   OC_P0_L6_INT_STATUS                                                  #
#                                                                        #
##########################################################################

%orbit_01_00262_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATUS"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P0 L6 Interrupt Status" ],
);

%orbit_01_00262_def =
( NAME    => "OC_P0_L6_INT_STATUS",
  ADDRESS => 0x0000000090010600,
  NOTE    => "The P0_L6_INT_STATUS register contains status of the pending L6 note interrupts for processor 0. Each bit in this register is an",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00262_flds
);


##########################################################################
#                                                                        #
#   OC_P1_L2_INT_STATUS0                                                 #
#                                                                        #
##########################################################################

%orbit_01_00263_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATUS"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P1 L2 Interrupt Status Bits 0 - 63" ],
);

%orbit_01_00263_def =
( NAME    => "OC_P1_L2_INT_STATUS0",
  ADDRESS => 0x0000000090010680,
  NOTE    => "The P1_L2_INT_STATUS0 register contains status bits 0 - 63 of the note pending L2 interrupts for processor 1. Each bit in this r",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00263_flds
);


##########################################################################
#                                                                        #
#   OC_P1_L2_INT_STATUS1                                                 #
#                                                                        #
##########################################################################

%orbit_01_00264_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATUS"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P1 L2 Interrupt Status Bits 64 - 127" ],
);

%orbit_01_00264_def =
( NAME    => "OC_P1_L2_INT_STATUS1",
  ADDRESS => 0x0000000090010700,
  NOTE    => "The P1_L2_INT_STATUS1 register contains status bits 64 - 127 of the note pending L2 interrupts for processor 1. Each bit in this",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00264_flds
);


##########################################################################
#                                                                        #
#   OC_P1_L3_INT_STATUS                                                  #
#                                                                        #
##########################################################################

%orbit_01_00265_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATUS"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P1 L3 Interrupt Status" ],
);

%orbit_01_00265_def =
( NAME    => "OC_P1_L3_INT_STATUS",
  ADDRESS => 0x0000000090010780,
  NOTE    => "The P1_L3_INT_STATUS register contains status of the pending L3 note interrupts for processor 1. Each bit in this register is an",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00265_flds
);


##########################################################################
#                                                                        #
#   OC_P1_L4_INT_STATUS                                                  #
#                                                                        #
##########################################################################

%orbit_01_00266_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATUS"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P1 L4 Interrupt Status" ],
);

%orbit_01_00266_def =
( NAME    => "OC_P1_L4_INT_STATUS",
  ADDRESS => 0x0000000090010800,
  NOTE    => "The P1_L4_INT_STATUS register contains status of the pending L4 note interrupts for processor 1. Each bit in this register is an",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00266_flds
);


##########################################################################
#                                                                        #
#   OC_P1_L5_INT_STATUS                                                  #
#                                                                        #
##########################################################################

%orbit_01_00267_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATUS"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P1 L5 Interrupt Status" ],
);

%orbit_01_00267_def =
( NAME    => "OC_P1_L5_INT_STATUS",
  ADDRESS => 0x0000000090010880,
  NOTE    => "The P1_L5_INT_STATUS register contains status of the pending L5 note interrupts for processor 1. Each bit in this register is an",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00267_flds
);


##########################################################################
#                                                                        #
#   OC_P1_L6_INT_STATUS                                                  #
#                                                                        #
##########################################################################

%orbit_01_00268_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATUS"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P1 L6 Interrupt Status" ],
);

%orbit_01_00268_def =
( NAME    => "OC_P1_L6_INT_STATUS",
  ADDRESS => 0x0000000090010900,
  NOTE    => "The P1_L6_INT_STATUS register contains status of the pending L6 note interrupts for processor 1. Each bit in this register is an",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00268_flds
);


##########################################################################
#                                                                        #
#   OC_P2_L2_INT_STATUS0                                                 #
#                                                                        #
##########################################################################

%orbit_01_00269_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATUS"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P2 L2 Interrupt Status Bits 0 - 63" ],
);

%orbit_01_00269_def =
( NAME    => "OC_P2_L2_INT_STATUS0",
  ADDRESS => 0x0000000090010980,
  NOTE    => "The P2_L2_INT_STATUS0 register contains status bits 0 - 63 of the note pending L2 interrupts for processor 2. Each bit in this r",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00269_flds
);


##########################################################################
#                                                                        #
#   OC_P2_L2_INT_STATUS1                                                 #
#                                                                        #
##########################################################################

%orbit_01_00270_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATUS"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P2 L2 Interrupt Status Bits 64 - 127" ],
);

%orbit_01_00270_def =
( NAME    => "OC_P2_L2_INT_STATUS1",
  ADDRESS => 0x0000000090010a00,
  NOTE    => "The P2_L2_INT_STATUS1 register contains status bits 64 - 127 of the note pending L2 interrupts for processor 2. Each bit in this",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00270_flds
);


##########################################################################
#                                                                        #
#   OC_P2_L3_INT_STATUS                                                  #
#                                                                        #
##########################################################################

%orbit_01_00271_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATUS"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P2 L3 Interrupt Status" ],
);

%orbit_01_00271_def =
( NAME    => "OC_P2_L3_INT_STATUS",
  ADDRESS => 0x0000000090010a80,
  NOTE    => "The P2_L3_INT_STATUS register contains status of the pending L3 note interrupts for processor 2. Each bit in this register is an",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00271_flds
);


##########################################################################
#                                                                        #
#   OC_P2_L4_INT_STATUS                                                  #
#                                                                        #
##########################################################################

%orbit_01_00272_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATUS"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P2 L4 Interrupt Status" ],
);

%orbit_01_00272_def =
( NAME    => "OC_P2_L4_INT_STATUS",
  ADDRESS => 0x0000000090010b00,
  NOTE    => "The P2_L4_INT_STATUS register contains status of the pending L4 note interrupts for processor 2. Each bit in this register is an",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00272_flds
);


##########################################################################
#                                                                        #
#   OC_P2_L5_INT_STATUS                                                  #
#                                                                        #
##########################################################################

%orbit_01_00273_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATUS"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P2 L5 Interrupt Status" ],
);

%orbit_01_00273_def =
( NAME    => "OC_P2_L5_INT_STATUS",
  ADDRESS => 0x0000000090010b80,
  NOTE    => "The P2_L5_INT_STATUS register contains status of the pending L5 note interrupts for processor 2. Each bit in this register is an",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00273_flds
);


##########################################################################
#                                                                        #
#   OC_P2_L6_INT_STATUS                                                  #
#                                                                        #
##########################################################################

%orbit_01_00274_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATUS"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P2 L6 Interrupt Status" ],
);

%orbit_01_00274_def =
( NAME    => "OC_P2_L6_INT_STATUS",
  ADDRESS => 0x0000000090010c00,
  NOTE    => "The P2_L6_INT_STATUS register contains status of the pending L6 note interrupts for processor 2. Each bit in this register is an",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00274_flds
);


##########################################################################
#                                                                        #
#   OC_P3_L2_INT_STATUS0                                                 #
#                                                                        #
##########################################################################

%orbit_01_00275_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATUS"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P3 L2 Interrupt Status Bits 0 - 63" ],
);

%orbit_01_00275_def =
( NAME    => "OC_P3_L2_INT_STATUS0",
  ADDRESS => 0x0000000090010c80,
  NOTE    => "The P3_L2_INT_STATUS0 register contains status bits 0 - 63 of the note pending L2 interrupts for processor 3. Each bit in this r",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00275_flds
);


##########################################################################
#                                                                        #
#   OC_P3_L2_INT_STATUS1                                                 #
#                                                                        #
##########################################################################

%orbit_01_00276_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATUS"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P3 L2 Interrupt Status Bits 64 - 127" ],
);

%orbit_01_00276_def =
( NAME    => "OC_P3_L2_INT_STATUS1",
  ADDRESS => 0x0000000090010d00,
  NOTE    => "The P3_L2_INT_STATUS1 register contains status bits 64 - 127 of the note pending L2 interrupts for processor 3. Each bit in this",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00276_flds
);


##########################################################################
#                                                                        #
#   OC_P3_L3_INT_STATUS                                                  #
#                                                                        #
##########################################################################

%orbit_01_00277_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATUS"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P3 L3 Interrupt Status" ],
);

%orbit_01_00277_def =
( NAME    => "OC_P3_L3_INT_STATUS",
  ADDRESS => 0x0000000090010d80,
  NOTE    => "The P3_L3_INT_STATUS register contains status of the pending L3 note interrupts for processor 3. Each bit in this register is an",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00277_flds
);


##########################################################################
#                                                                        #
#   OC_P3_L4_INT_STATUS                                                  #
#                                                                        #
##########################################################################

%orbit_01_00278_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATUS"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P3 L4 Interrupt Status" ],
);

%orbit_01_00278_def =
( NAME    => "OC_P3_L4_INT_STATUS",
  ADDRESS => 0x0000000090010e00,
  NOTE    => "The P3_L4_INT_STATUS register contains status of the pending L4 note interrupts for processor 3. Each bit in this register is an",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00278_flds
);


##########################################################################
#                                                                        #
#   OC_P3_L5_INT_STATUS                                                  #
#                                                                        #
##########################################################################

%orbit_01_00279_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATUS"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P3 L5 Interrupt Status" ],
);

%orbit_01_00279_def =
( NAME    => "OC_P3_L5_INT_STATUS",
  ADDRESS => 0x0000000090010e80,
  NOTE    => "The P3_L5_INT_STATUS register contains status of the pending L5 note interrupts for processor 3. Each bit in this register is an",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00279_flds
);


##########################################################################
#                                                                        #
#   OC_P3_L6_INT_STATUS                                                  #
#                                                                        #
##########################################################################

%orbit_01_00280_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATUS"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "P3 L6 Interrupt Status" ],
);

%orbit_01_00280_def =
( NAME    => "OC_P3_L6_INT_STATUS",
  ADDRESS => 0x0000000090010f00,
  NOTE    => "The P3_L6_INT_STATUS register contains status of the pending L6 note interrupts for processor 3. Each bit in this register is an",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00280_flds
);


##########################################################################
#                                                                        #
#   OC_ASIC_TO_L1_DATA                                                   #
#                                                                        #
##########################################################################

%orbit_01_00281_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data" ],
);

%orbit_01_00281_def =
( NAME    => "OC_ASIC_TO_L1_DATA",
  ADDRESS => 0x0000000090038000,
  NOTE    => "The asic_to_l1_data register contains the data to be transfered to note the L1 controller. This register is used in place of the",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00281_flds
);


##########################################################################
#                                                                        #
#   OC_ASIC_TO_L1_STATUS                                                 #
#                                                                        #
##########################################################################

%orbit_01_00282_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STATUS"                       => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Status, 1 = busy, 0 = idle" ],
);

%orbit_01_00282_def =
( NAME    => "OC_ASIC_TO_L1_STATUS",
  ADDRESS => 0x0000000090038080,
  NOTE    => "The asic_to_l1_status register contains the status of the asic to note L1 controller data transfer.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00282_flds
);


##########################################################################
#                                                                        #
#   OC_L1_TO_ASIC_DATA                                                   #
#                                                                        #
##########################################################################

%orbit_01_00283_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data" ],
);

%orbit_01_00283_def =
( NAME    => "OC_L1_TO_ASIC_DATA",
  ADDRESS => 0x0000000090038100,
  NOTE    => "The l1_to_asic_data register contains the data transfered from the note L1 controller to the asic. This register is used in plac",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00283_flds
);


##########################################################################
#                                                                        #
#   OC_L1_TO_ASIC_STATUS                                                 #
#                                                                        #
##########################################################################

%orbit_01_00284_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STATUS"                       => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Status, 1 = busy, 0 = idle" ],
);

%orbit_01_00284_def =
( NAME    => "OC_L1_TO_ASIC_STATUS",
  ADDRESS => 0x0000000090038180,
  NOTE    => "The l1_to_asic_status register contains the status of the L1 to note asic data transfer. This register is used in place of the U",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00284_flds
);


##########################################################################
#                                                                        #
#   OC_JUNK_BUS_TIME                                                     #
#                                                                        #
##########################################################################

%orbit_01_00285_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIMEOUT_VALUE"                => [   1,  16,  32, 0x0000FFFFFFFF0000, 0x00, 1, 0x0000000000000000, "Timeout Value" ],
   "RSVD1"                        => [   2,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_DELAY"                   => [   3,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "Delay Time" ],
   "RSVD2"                        => [   4,   3,   5, 0x00000000000000F8, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SETUP_HOLD"                   => [   5,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Setup and Hold Time" ],
);

%orbit_01_00285_def =
( NAME    => "OC_JUNK_BUS_TIME",
  ADDRESS => 0x0000000090020000,
  NOTE    => "The JUNK_BUS_TIME register controls the timing for data being sent note to the Local Block Interface chip.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00285_flds
);


##########################################################################
#                                                                        #
#   OC_JUNK_NACK_RESET                                                   #
#                                                                        #
##########################################################################

%orbit_01_00286_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PULSE"                        => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Junk bus nack counter reset" ],
);

%orbit_01_00286_def =
( NAME    => "OC_JUNK_NACK_RESET",
  ADDRESS => 0x0000000090020100,
  NOTE    => "The Junk Bus uses a modified conveyor belt mechanism to keep Junk note Bus requests in order without stalling incoming messages ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00286_flds
);


##########################################################################
#                                                                        #
#   OC_JUNK_BUS_LED0                                                     #
#                                                                        #
##########################################################################

%orbit_01_00287_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LED0_DATA"                    => [   1,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "LED0_data" ],
);

%orbit_01_00287_def =
( NAME    => "OC_JUNK_BUS_LED0",
  ADDRESS => 0x0000000090030000,
  NOTE    => "The JUNK_BUS_LED0 register provides software with a mechanism for note monitoring the state of the 8 LED0 devices.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00287_flds
);


##########################################################################
#                                                                        #
#   OC_JUNK_BUS_LED1                                                     #
#                                                                        #
##########################################################################

%orbit_01_00288_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LED1_DATA"                    => [   1,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "LED1_data" ],
);

%orbit_01_00288_def =
( NAME    => "OC_JUNK_BUS_LED1",
  ADDRESS => 0x0000000090030080,
  NOTE    => "The JUNK_BUS_LED1 register provides software with a mechanism for note monitoring the state of the 8 LED1 devices.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00288_flds
);


##########################################################################
#                                                                        #
#   OC_JUNK_BUS_LED2                                                     #
#                                                                        #
##########################################################################

%orbit_01_00289_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LED2_DATA"                    => [   1,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "LED2_data" ],
);

%orbit_01_00289_def =
( NAME    => "OC_JUNK_BUS_LED2",
  ADDRESS => 0x0000000090030100,
  NOTE    => "The JUNK_BUS_LED2 register provides software with a mechanism for note monitoring the state of the 8 LED2 devices.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00289_flds
);


##########################################################################
#                                                                        #
#   OC_JUNK_BUS_LED3                                                     #
#                                                                        #
##########################################################################

%orbit_01_00290_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LED3_DATA"                    => [   1,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "LED3_data" ],
);

%orbit_01_00290_def =
( NAME    => "OC_JUNK_BUS_LED3",
  ADDRESS => 0x0000000090030180,
  NOTE    => "The JUNK_BUS_LED3 register provides software with a mechanism for note monitoring the state of the 8 LED3 devices.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00290_flds
);


##########################################################################
#                                                                        #
#   OC_LB_LIQ_CTL                                                        #
#                                                                        #
##########################################################################

%orbit_01_00291_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  19,  45, 0xFFFFFFFFFFF80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FORCE_LINVV_CREDIT"           => [   1,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Force linvv credit" ],
   "FORCE_RP_CREDIT"              => [   2,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Force reply credit" ],
   "FORCE_RQ_CREDIT"              => [   3,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Force request credit" ],
   "RSVD1"                        => [   4,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LIQ_RPL_CTL"                  => [   5,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "LIQ Reply Control" ],
   "RSVD2"                        => [   6,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LIQ_REQ_CTL"                  => [   7,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "LIQ Request Control" ],
);

%orbit_01_00291_def =
( NAME    => "OC_LB_LIQ_CTL",
  ADDRESS => 0x0000000090040000,
  NOTE    => "The LB_LIQ_CTL register provides credit control for the LB's Input note Request Queue and Input Reply Queue. Parameters specifie",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00291_flds
);


##########################################################################
#                                                                        #
#   OC_LB_LOQ_CTL                                                        #
#                                                                        #
##########################################################################

%orbit_01_00292_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   2,  62, 0xFFFFFFFFFFFFFFFC, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LOQ_RPL_CTL"                  => [   1,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "LOQ Reply Control" ],
   "LOQ_REQ_CTL"                  => [   2,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "LOQ Request Control" ],
);

%orbit_01_00292_def =
( NAME    => "OC_LB_LOQ_CTL",
  ADDRESS => 0x0000000090040080,
  NOTE    => "The LB_LOQ_CTL register provides maintenance testing facilities note which throttle request and reply messages leaving the LB's ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00292_flds
);


##########################################################################
#                                                                        #
#   OC_LB_MAX_REP_CREDIT_CNT                                             #
#                                                                        #
##########################################################################

%orbit_01_00293_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CNT"                      => [   1,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Max reply credits" ],
);

%orbit_01_00293_def =
( NAME    => "OC_LB_MAX_REP_CREDIT_CNT",
  ADDRESS => 0x0000000090040100,
  NOTE    => "The LB_MAX_REP_CREDIT_CNT register specifies the reply VC credit note limit for the LB's LOQ block.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00293_flds
);


##########################################################################
#                                                                        #
#   OC_LB_MAX_REQ_CREDIT_CNT                                             #
#                                                                        #
##########################################################################

%orbit_01_00294_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CNT"                      => [   1,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Max request credits" ],
);

%orbit_01_00294_def =
( NAME    => "OC_LB_MAX_REQ_CREDIT_CNT",
  ADDRESS => 0x0000000090040180,
  NOTE    => "The LB_MAX_REQ_CREDIT_CNT register specifies the request VC credit note limit for the LB's LOQ block.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00294_flds
);


##########################################################################
#                                                                        #
#   OC_LB_MAX_INT_CREDIT_CNT                                             #
#                                                                        #
##########################################################################

%orbit_01_00295_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   3,  61, 0xFFFFFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CNT"                      => [   1,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Max interrupt credits" ],
);

%orbit_01_00295_def =
( NAME    => "OC_LB_MAX_INT_CREDIT_CNT",
  ADDRESS => 0x0000000090040200,
  NOTE    => "This register holds the maximum number of interrupt credits that note are expected to be received from the PI. If the interrupt ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00295_flds
);


##########################################################################
#                                                                        #
#   OC_PIO_TIME_OUT                                                      #
#                                                                        #
##########################################################################

%orbit_01_00296_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VALUE"                        => [   1,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "PIO time out value" ],
);

%orbit_01_00296_def =
( NAME    => "OC_PIO_TIME_OUT",
  ADDRESS => 0x0000000090040280,
  NOTE    => "The PIO time out value register sets the time out value for PIO note request. This is the amount of time the PIO channel waits f",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00296_flds
);


##########################################################################
#                                                                        #
#   OC_LB_CREDIT_STATUS                                                  #
#                                                                        #
##########################################################################

%orbit_01_00297_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INT_CREDIT"                   => [   1,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Interrupt channel credit counter" ],
   "RSVD1"                        => [   2,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LOQ_RP_CREDIT"                => [   3,  23,   5, 0x000000000F800000, 0x00, 0, 0x0000000000000000, "LOQ reply queue credit counter" ],
   "LOQ_RQ_CREDIT"                => [   4,  18,   5, 0x00000000007C0000, 0x00, 0, 0x0000000000000000, "LOQ request queue credit counter" ],
   "LINVV_CREDIT"                 => [   5,  12,   6, 0x000000000003F000, 0x00, 0, 0x0000000000000000, "LINVV credit counter" ],
   "RSVD2"                        => [   6,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LIQ_RP_CREDIT"                => [   7,   6,   4, 0x00000000000003C0, 0x00, 0, 0x0000000000000000, "LIQ reply queue credit counter" ],
   "RSVD3"                        => [   8,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LIQ_RQ_CREDIT"                => [   9,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "LIQ request queue credit counter" ],
);

%orbit_01_00297_def =
( NAME    => "OC_LB_CREDIT_STATUS",
  ADDRESS => 0x0000000090050000,
  NOTE    => "The the LB_CREDIT_STATUS register contains the current value of the note LB's 6 credit counters.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00297_flds
);


##########################################################################
#                                                                        #
#   OC_LB_DEBUG_LOCAL_SEL                                                #
#                                                                        #
##########################################################################

%orbit_01_00298_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COMPARE_ENABLE"               => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Enable compare on bit 31 of Analyzer data" ],
   "FIELD_SELECT_7"               => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Field select" ],
   "RSVD0"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_7"               => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Group select" ],
   "RSVD1"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_6"               => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Field select" ],
   "RSVD2"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_6"               => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Group select" ],
   "RSVD3"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_5"               => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Field select" ],
   "RSVD4"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_5"               => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Group select" ],
   "RSVD5"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_4"               => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Field select" ],
   "RSVD6"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_4"               => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Group select" ],
   "RSVD7"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_3"               => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Field select" ],
   "RSVD8"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_3"               => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Group select" ],
   "RSVD9"                        => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_2"               => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Field select" ],
   "RSVD10"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_2"               => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 Group select" ],
   "RSVD11"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_1"               => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Field select" ],
   "RSVD12"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_1"               => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 Group select" ],
   "RSVD13"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_0"               => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Field select" ],
   "RSVD14"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_0"               => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Group select" ],
);

%orbit_01_00298_def =
( NAME    => "OC_LB_DEBUG_LOCAL_SEL",
  ADDRESS => 0x0000000090050080,
  NOTE    => "The oc_lb_debug_local_sel is the top level debug mux for the LB note chiplet. The chiplet select fields selects one of eight inp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00298_flds
);


##########################################################################
#                                                                        #
#   OC_LB_DEBUG_MUX0_SEL                                                 #
#                                                                        #
##########################################################################

%orbit_01_00299_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_7"               => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Field select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_7"               => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Group select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_6"               => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Field select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_6"               => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Group select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_5"               => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Field select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_5"               => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Group select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_4"               => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Field select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_4"               => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Group select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_3"               => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Field select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_3"               => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Group select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_2"               => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Field select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_2"               => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 Group select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_1"               => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Field select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_1"               => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 Group select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_0"               => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Field select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_0"               => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Group select" ],
);

%orbit_01_00299_def =
( NAME    => "OC_LB_DEBUG_MUX0_SEL",
  ADDRESS => 0x0000000090050100,
  NOTE    => "The oc_lb_debug_mux0_sel is one of the second level debug muxes for note the LB chiplet. The chiplet select fields selects one o",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00299_flds
);


##########################################################################
#                                                                        #
#   OC_LB_DEBUG_MUX1_SEL                                                 #
#                                                                        #
##########################################################################

%orbit_01_00300_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_7"               => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Field select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_7"               => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Group select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_6"               => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Field select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_6"               => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Chiplet select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_5"               => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Field select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_5"               => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Group select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_4"               => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Field select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_4"               => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Group select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_3"               => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Field select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_3"               => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Group select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_2"               => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Field select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_2"               => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 Group select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_1"               => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Field select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_1"               => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 Group select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_0"               => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Field select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_0"               => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Group select" ],
);

%orbit_01_00300_def =
( NAME    => "OC_LB_DEBUG_MUX1_SEL",
  ADDRESS => 0x0000000090050180,
  NOTE    => "The lb_debug_mux1_sel register controls the 2nd level debug mux for note the lb chiplet. The output of this debug mux is connect",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00300_flds
);


##########################################################################
#                                                                        #
#   OC_LB_DEBUG_COMPARE_SEL                                              #
#                                                                        #
##########################################################################

%orbit_01_00301_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_7"               => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Field select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_7"               => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Group select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_6"               => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Field select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_6"               => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Group select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_5"               => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Field select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_5"               => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Group select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_4"               => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Field select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_4"               => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Group select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_3"               => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Field select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_3"               => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Group select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_2"               => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Field select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_2"               => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 Group select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_1"               => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Field select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_1"               => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 Group select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_0"               => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Field select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_0"               => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Group select" ],
);

%orbit_01_00301_def =
( NAME    => "OC_LB_DEBUG_COMPARE_SEL",
  ADDRESS => 0x0000000090050200,
  NOTE    => "The lb_debug_compare_sel register controls the compare mux in the note top level LB debug mux. The output of the compare mux is ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00301_flds
);


##########################################################################
#                                                                        #
#   OC_LB_ERROR_DETAIL_1                                                 #
#                                                                        #
##########################################################################

%orbit_01_00302_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "VALID" ],
   "RSVD0"                        => [   1,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECHO"                         => [   2,  52,   9, 0x1FF0000000000000, 0x00, 0, 0x0000000000000000, "Echo Field" ],
   "RSVD1"                        => [   3,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_ERR"                     => [   4,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "DATA_ERR" ],
   "HDR_ERR"                      => [   5,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "HDR_ERR" ],
   "RSVD2"                        => [   6,  42,   6, 0x0000FC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEST"                         => [   7,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "Destination Chiplet Code" ],
   "SOURCE_CHIPLET_ID"            => [   8,  38,   2, 0x000000C000000000, 0x00, 0, 0x0000000000000000, "Chiplet Code" ],
   "SOURCE_NODE_ID"               => [   9,  24,  14, 0x0000003FFF000000, 0x00, 0, 0x0000000000000000, "Source Node Number" ],
   "SUPPL"                        => [  10,   8,  16, 0x0000000000FFFF00, 0x00, 0, 0x0000000000000000, "Supplemental Field" ],
   "COMMAND"                      => [  11,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "SN2NET Message Code" ],
);

%orbit_01_00302_def =
( NAME    => "OC_LB_ERROR_DETAIL_1",
  ADDRESS => 0x0000000090050280,
  NOTE    => "The LB_ERROR_DETAIL_1 register provides storage for detail error note information for the first LB Hardware Error detected.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00302_flds
);


##########################################################################
#                                                                        #
#   OC_LB_ERROR_DETAIL_2                                                 #
#                                                                        #
##########################################################################

%orbit_01_00303_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  49,  15, 0xFFFE000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDRESS"                      => [   1,   0,  49, 0x0001FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "ADDRESS" ],
);

%orbit_01_00303_def =
( NAME    => "OC_LB_ERROR_DETAIL_2",
  ADDRESS => 0x0000000090050300,
  NOTE    => "This register is part of the LB error capture information. This note particular register contains the physical address from the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00303_flds
);


##########################################################################
#                                                                        #
#   OC_LB_ERROR_DETAIL_3                                                 #
#                                                                        #
##########################################################################

%orbit_01_00304_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "DATA" ],
);

%orbit_01_00304_def =
( NAME    => "OC_LB_ERROR_DETAIL_3",
  ADDRESS => 0x0000000090050380,
  NOTE    => "The LB_ERROR_DETAIL_3 register provides storage for detail error note information for the first LB Hardware Error detected.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00304_flds
);


##########################################################################
#                                                                        #
#   OC_LB_ERROR_DETAIL_4                                                 #
#                                                                        #
##########################################################################

%orbit_01_00305_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ROUTE"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "ROUTE" ],
);

%orbit_01_00305_def =
( NAME    => "OC_LB_ERROR_DETAIL_4",
  ADDRESS => 0x0000000090050400,
  NOTE    => "The LB_ERROR_DETAIL_4 register provides storage for detail error note information for the first LB Hardware Error detected.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00305_flds
);


##########################################################################
#                                                                        #
#   OC_LB_ERROR_DETAIL_5                                                 #
#                                                                        #
##########################################################################

%orbit_01_00306_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STATUS"                       => [   1,  58,   5, 0x7C00000000000000, 0x00, 0, 0x0000000000000000, "Status" ],
   "MODE"                         => [   2,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "Mode" ],
   "CMD"                          => [   3,  49,   8, 0x01FE000000000000, 0x00, 0, 0x0000000000000000, "Junk bus command" ],
   "ADDRESS"                      => [   4,   0,  49, 0x0001FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Failing junk bus address" ],
);

%orbit_01_00306_def =
( NAME    => "OC_LB_ERROR_DETAIL_5",
  ADDRESS => 0x0000000090050480,
  NOTE    => "The LB_ERROR_DETAIL_5 register stores detail error information when note Junk Bus Errors are detected.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00306_flds
);


##########################################################################
#                                                                        #
#   OC_LB_ERROR_MASK                                                     #
#                                                                        #
##########################################################################

%orbit_01_00307_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  25,  39, 0xFFFFFFFFFE000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_BAD_REPLY"                 => [   1,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Bad Reply from NCWRF Request Mask" ],
   "INT_CREDIT_OVERFLOW"          => [   2,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "Interrupt Credit Overflow Error Mask" ],
   "RP_CREDIT_OVERFLOW"           => [   3,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "Reply Credit Overflow Error Mask" ],
   "RQ_CREDIT_OVERFLOW"           => [   4,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "Request Credit Overflow Error Mask" ],
   "UNEXP_VALID"                  => [   5,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "MMR Address Decode Error Mask" ],
   "RP_FIFO_ERROR"                => [   6,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "Reply Queue Overflow Error Mask" ],
   "RQ_FIFO_ERROR"                => [   7,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "Request Queue Overflow Error Mask" ],
   "GCLK_DROP"                    => [   8,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "Dropped Global Clock Error Mask" ],
   "VECTOR_RP_ROUTE_ERROR"        => [   9,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Vector Reply Route Error Mask" ],
   "VECTOR_RQ_ROUTE_ERROR"        => [  10,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Vector Request Route Error Mask" ],
   "PIO_CB_ERR"                   => [  11,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "PIO Conveyor Belt Error Mask" ],
   "JUNK_BUS_ERR"                 => [  12,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Junk Bus Error Mask" ],
   "RSVD1"                        => [  13,  11,   2, 0x0000000000001800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LINVV_OVERFLOW"               => [  14,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "LINVV Overflow Error Mask" ],
   "RQ_TIME_OUT"                  => [  15,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Request Time-out Error Mask" ],
   "RQ_BAD_ADDR"                  => [  16,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Request Bad Address Error Mask" ],
   "RP_BAD_DATA"                  => [  17,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Reply Bad Data Error Mask" ],
   "RQ_BAD_DATA"                  => [  18,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Request Bad Data Error Mask" ],
   "RP_LONG"                      => [  19,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Obese Reply Message Error Mask" ],
   "RQ_LONG"                      => [  20,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Obese Request Message Error Mask" ],
   "RP_SHORT"                     => [  21,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Runt Reply Message Error Mask" ],
   "RQ_SHORT"                     => [  22,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Runt Request Message Error Mask" ],
   "RP_BAD_CMD"                   => [  23,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Unsupported Reply Message Error Mask" ],
   "RQ_BAD_CMD"                   => [  24,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Unsupported Request Message Error Mask" ],
);

%orbit_01_00307_def =
( NAME    => "OC_LB_ERROR_MASK",
  ADDRESS => 0x0000000090050580,
  NOTE    => "The LB_ERROR_MASK register is the primary LB Hardware Error note configuration register. It contains a mask bit for each of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00307_flds
);


##########################################################################
#                                                                        #
#   OC_LB_ERROR_OVERFLOW                                                 #
#                                                                        #
##########################################################################

%orbit_01_00308_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  25,  39, 0xFFFFFFFFFE000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_BAD_REPLY_OVRFL"           => [   1,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Bad Reply from NCWRF Request" ],
   "INT_CREDIT_OVERFLOW_OVRFL"    => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Interrupt Credit Overflow Error Overflow" ],
   "RP_CREDIT_OVERFLOW_OVRFL"     => [   3,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Reply Credit Overflow Error Overflow" ],
   "RQ_CREDIT_OVERFLOW_OVRFL"     => [   4,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Request Credit Overflow Error Overflow" ],
   "UNEXP_VALID_OVRFL"            => [   5,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MMR Address Decode Error Overflow" ],
   "RP_FIFO_ERROR_OVRFL"          => [   6,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reply Queue Overflow Error Overflow" ],
   "RQ_FIFO_ERROR_OVRFL"          => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Request Queue Overflow Error Overflow" ],
   "GCLK_DROP_OVRFL"              => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Dropped Global Clock Error Overflow" ],
   "VECTOR_RP_ROUTE_ERROR_OVRFL"  => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Vector Reply Route Error Overflow" ],
   "VECTOR_RQ_ROUTE_ERROR_OVRFL"  => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Vector Request Route Error Overflow" ],
   "PIO_CB_ERR_OVRFL"             => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "PIO Conveyor Belt Error Overflow" ],
   "JUNK_BUS_ERR_OVRFL"           => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Junk Bus Error Overflow" ],
   "RSVD1"                        => [  13,  11,   2, 0x0000000000001800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LINVV_OVERFLOW_OVRFL"         => [  14,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "LINVV Overflow Error Overflow" ],
   "RQ_TIME_OUT_OVRFL"            => [  15,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Request Time-out Error Overflow" ],
   "RQ_BAD_ADDR_OVRFL"            => [  16,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Request Bad Address Error Overflow" ],
   "RP_BAD_DATA_OVRFL"            => [  17,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reply Bad Data Error Overflow" ],
   "RQ_BAD_DATA_OVRFL"            => [  18,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Request Bad Data Error Overflow" ],
   "RP_LONG_OVRFL"                => [  19,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Obese Reply Message Error Overflow" ],
   "RQ_LONG_OVRFL"                => [  20,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Obese Request Message Error Overflow" ],
   "RP_SHORT_OVRFL"               => [  21,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Runt Reply Message Error Overflow" ],
   "RQ_SHORT_OVRFL"               => [  22,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Runt Request Message Error Overflow" ],
   "RP_BAD_CMD_OVRFL"             => [  23,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Unsupported Reply Message Error Overflow" ],
   "RQ_BAD_CMD_OVRFL"             => [  24,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Unsupported Request Message Error Overflow" ],
);

%orbit_01_00308_def =
( NAME    => "OC_LB_ERROR_OVERFLOW",
  ADDRESS => 0x0000000090050600,
  NOTE    => "The LB_ERROR_OVERFLOW register contains 24 flags. Each flag note corresponds to 1 of the 24 hardware errors detected by the LB n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00308_flds
);


##########################################################################
#                                                                        #
#   OC_LB_ERROR_OVERFLOW_ALIAS                                           #
#                                                                        #
##########################################################################

%orbit_01_00309_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  25,  39, 0xFFFFFFFFFE000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_BAD_REPLY_OVRFL"           => [   1,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Bad Reply from NCWRF Request" ],
   "INT_CREDIT_OVERFLOW_OVRFL"    => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Interrupt Credit Overflow Error Overflow" ],
   "RP_CREDIT_OVERFLOW_OVRFL"     => [   3,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Reply Credit Overflow Error Overflow" ],
   "RQ_CREDIT_OVERFLOW_OVRFL"     => [   4,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Request Credit Overflow Error Overflow" ],
   "UNEXP_VALID_OVRFL"            => [   5,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MMR Address Decode Error Overflow" ],
   "RP_FIFO_ERROR_OVRFL"          => [   6,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reply Queue Overflow Error Overflow" ],
   "RQ_FIFO_ERROR_OVRFL"          => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Request Queue Overflow Error Overflow" ],
   "GCLK_DROP_OVRFL"              => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Dropped Global Clock Error Overflow" ],
   "VECTOR_RP_ROUTE_ERROR_OVRFL"  => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Vector Reply Route Error Overflow" ],
   "VECTOR_RQ_ROUTE_ERROR_OVRFL"  => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Vector Request Route Error Overflow" ],
   "PIO_CB_ERR_OVRFL"             => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "PIO Conveyor Belt Error Overflow" ],
   "JUNK_BUS_ERR_OVRFL"           => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Junk Bus Error Overflow" ],
   "RSVD1"                        => [  13,  11,   2, 0x0000000000001800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LINVV_OVERFLOW_OVRFL"         => [  14,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "LINVV Overflow Error Overflow" ],
   "RQ_TIME_OUT_OVRFL"            => [  15,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Request Time-out Error Overflow" ],
   "RQ_BAD_ADDR_OVRFL"            => [  16,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Request Bad Address Error Overflow" ],
   "RP_BAD_DATA_OVRFL"            => [  17,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reply Bad Data Error Overflow" ],
   "RQ_BAD_DATA_OVRFL"            => [  18,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Request Bad Data Error Overflow" ],
   "RP_LONG_OVRFL"                => [  19,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Obese Reply Message Error Overflow" ],
   "RQ_LONG_OVRFL"                => [  20,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Obese Request Message Error Overflow" ],
   "RP_SHORT_OVRFL"               => [  21,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Runt Reply Message Error Overflow" ],
   "RQ_SHORT_OVRFL"               => [  22,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Runt Request Message Error Overflow" ],
   "RP_BAD_CMD_OVRFL"             => [  23,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Unsupported Reply Message Error Overflow" ],
   "RQ_BAD_CMD_OVRFL"             => [  24,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Unsupported Request Message Error Overflow" ],
);

%orbit_01_00309_def =
( NAME    => "OC_LB_ERROR_OVERFLOW_ALIAS",
  ADDRESS => 0x0000000090050608,
  NOTE    => "The LB_ERROR_OVERFLOW_ALIAS address is an alias to the note LB_ERROR_OVERFLOW register. Refer to the LB_ERROR_OVERFLOW register ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00309_flds
);


##########################################################################
#                                                                        #
#   OC_LB_ERROR_SUMMARY                                                  #
#                                                                        #
##########################################################################

%orbit_01_00310_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  25,  39, 0xFFFFFFFFFE000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_BAD_REPLY"                 => [   1,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Bad Reply from NCWRF Request" ],
   "INT_CREDIT_OVERFLOW"          => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Interrupt Credit Overflow Error" ],
   "RP_CREDIT_OVERFLOW"           => [   3,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Reply Credit Overflow Error" ],
   "RQ_CREDIT_OVERFLOW"           => [   4,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Request Credit Overflow Error" ],
   "UNEXP_VALID"                  => [   5,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MMR Address Decode Error" ],
   "RP_FIFO_ERROR"                => [   6,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reply Queue Overflow Error" ],
   "RQ_FIFO_ERROR"                => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Request Queue Overflow Error" ],
   "GCLK_DROP"                    => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Dropped Global Clock Error" ],
   "VECTOR_RP_ROUTE_ERROR"        => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Vector Reply Route Error" ],
   "VECTOR_RQ_ROUTE_ERROR"        => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Vector Request Route Error" ],
   "PIO_CB_ERR"                   => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "PIO Conveyor Belt Error" ],
   "JUNK_BUS_ERR"                 => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Junk Bus Error" ],
   "RSVD1"                        => [  13,  11,   2, 0x0000000000001800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LINVV_OVERFLOW"               => [  14,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "LINVV Overflow Error" ],
   "RQ_TIME_OUT"                  => [  15,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Request Time-out Error" ],
   "RQ_BAD_ADDR"                  => [  16,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Request Bad Address Error" ],
   "RP_BAD_DATA"                  => [  17,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reply Bad Data Error" ],
   "RQ_BAD_DATA"                  => [  18,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Request Bad Data Error" ],
   "RP_LONG"                      => [  19,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Obese Reply Message Error" ],
   "RQ_LONG"                      => [  20,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Obese Request Message Error" ],
   "RP_SHORT"                     => [  21,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Runt Reply Message Error" ],
   "RQ_SHORT"                     => [  22,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Runt Request Message Error" ],
   "RP_BAD_CMD"                   => [  23,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Unsupported Reply Message Error" ],
   "RQ_BAD_CMD"                   => [  24,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Unsupported Request Message Error" ],
);

%orbit_01_00310_def =
( NAME    => "OC_LB_ERROR_SUMMARY",
  ADDRESS => 0x0000000090050680,
  NOTE    => "The LB_ERROR_SUMMARY register is the LB's top-level error flag note register. It contains 24 flags. Each flag corresponds to one",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00310_flds
);


##########################################################################
#                                                                        #
#   OC_LB_ERROR_SUMMARY_ALIAS                                            #
#                                                                        #
##########################################################################

%orbit_01_00311_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  25,  39, 0xFFFFFFFFFE000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_BAD_REPLY"                 => [   1,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Bad Reply from NCWRF Request" ],
   "INT_CREDIT_OVERFLOW"          => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Interrupt Credit Overflow Error" ],
   "RP_CREDIT_OVERFLOW"           => [   3,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Reply Credit Overflow Error" ],
   "RQ_CREDIT_OVERFLOW"           => [   4,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Request Credit Overflow Error" ],
   "UNEXP_VALID"                  => [   5,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MMR Address Decode Error" ],
   "RP_FIFO_ERROR"                => [   6,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reply Queue Overflow Error" ],
   "RQ_FIFO_ERROR"                => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Request Queue Overflow Error" ],
   "GCLK_DROP"                    => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Dropped Global Clock Error" ],
   "VECTOR_RP_ROUTE_ERROR"        => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Vector Reply Route Error" ],
   "VECTOR_RQ_ROUTE_ERROR"        => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Vector Request Route Error" ],
   "PIO_CB_ERR"                   => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "PIO Conveyor Belt Error" ],
   "JUNK_BUS_ERR"                 => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Junk Bus Error" ],
   "RSVD1"                        => [  13,  11,   2, 0x0000000000001800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LINVV_OVERFLOW"               => [  14,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "LINVV Overflow Error" ],
   "RQ_TIME_OUT"                  => [  15,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Request Time-out Error" ],
   "RQ_BAD_ADDR"                  => [  16,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Request Bad Address Error" ],
   "RP_BAD_DATA"                  => [  17,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reply Bad Data Error" ],
   "RQ_BAD_DATA"                  => [  18,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Request Bad Data Error" ],
   "RP_LONG"                      => [  19,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Obese Reply Message Error" ],
   "RQ_LONG"                      => [  20,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Obese Request Message Error" ],
   "RP_SHORT"                     => [  21,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Runt Reply Message Error" ],
   "RQ_SHORT"                     => [  22,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Runt Request Message Error" ],
   "RP_BAD_CMD"                   => [  23,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Unsupported Reply Message Error" ],
   "RQ_BAD_CMD"                   => [  24,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Unsupported Request Message Error" ],
);

%orbit_01_00311_def =
( NAME    => "OC_LB_ERROR_SUMMARY_ALIAS",
  ADDRESS => 0x0000000090050688,
  NOTE    => "The LB_ERROR_SUMMARY_ALIAS address is an alias to the note LB_ERROR_SUMMARY register. Refer to the LB_ERROR_SUMMARY register not",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00311_flds
);


##########################################################################
#                                                                        #
#   OC_LB_FIRST_ERROR                                                    #
#                                                                        #
##########################################################################

%orbit_01_00312_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  25,  39, 0xFFFFFFFFFE000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_BAD_REPLY"                 => [   1,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Bad Reply Error" ],
   "INT_CREDIT_OVERFLOW"          => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Interrupt Credit Overflow Error" ],
   "RP_CREDIT_OVERFLOW"           => [   3,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Reply Credit Overflow Error" ],
   "RQ_CREDIT_OVERFLOW"           => [   4,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Request Credit Overflow Error" ],
   "UNEXP_VALID"                  => [   5,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MMR Address Decode Error" ],
   "RP_FIFO_ERROR"                => [   6,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reply Queue Overflow Error" ],
   "RQ_FIFO_ERROR"                => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Request Queue Overflow Error" ],
   "GCLK_DROP"                    => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Dropped Global Clock Error" ],
   "VECTOR_RP_ROUTE_ERROR"        => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Vector Reply Route Error" ],
   "VECTOR_RQ_ROUTE_ERROR"        => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Vector Request Route Error" ],
   "PIO_CB_ERR"                   => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "PIO Conveyor Belt Error" ],
   "JUNK_BUS_ERR"                 => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Junk Bus Error" ],
   "RSVD1"                        => [  13,  11,   2, 0x0000000000001800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LINVV_OVERFLOW"               => [  14,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "LINVV Overflow Error" ],
   "RQ_TIME_OUT"                  => [  15,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Request Time-out Error" ],
   "RQ_BAD_ADDR"                  => [  16,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Request Bad Address Error" ],
   "RP_BAD_DATA"                  => [  17,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reply Bad Data Error" ],
   "RQ_BAD_DATA"                  => [  18,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Request Bad Data Error" ],
   "RP_LONG"                      => [  19,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Obese Reply Message Error" ],
   "RQ_LONG"                      => [  20,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Obese Request Message Error" ],
   "RP_SHORT"                     => [  21,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Runt Reply Message Error" ],
   "RQ_SHORT"                     => [  22,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Runt Request Message Error" ],
   "RP_BAD_CMD"                   => [  23,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Unsupported Reply Message Error" ],
   "RQ_BAD_CMD"                   => [  24,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Unsupported Request Message Error" ],
);

%orbit_01_00312_def =
( NAME    => "OC_LB_FIRST_ERROR",
  ADDRESS => 0x0000000090050700,
  NOTE    => "The LB_FIRST_ERROR register contains 24 flags. Each flag note corresponds to one of the 24 flags in the LB_ERROR_SUMMARY note re",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00312_flds
);


##########################################################################
#                                                                        #
#   OC_LB_LAST_CREDIT                                                    #
#                                                                        #
##########################################################################

%orbit_01_00313_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INT_CREDIT"                   => [   1,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Interrupt channel credit counter" ],
   "RSVD1"                        => [   2,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LOQ_RP_CREDIT"                => [   3,  23,   5, 0x000000000F800000, 0x00, 0, 0x0000000000000000, "LOQ reply queue credit counter" ],
   "LOQ_RQ_CREDIT"                => [   4,  18,   5, 0x00000000007C0000, 0x00, 0, 0x0000000000000000, "LOQ request queue credit counter" ],
   "LINVV_CREDIT"                 => [   5,  12,   6, 0x000000000003F000, 0x00, 0, 0x0000000000000000, "LINVV credit counter" ],
   "RSVD2"                        => [   6,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LIQ_RP_CREDIT"                => [   7,   6,   4, 0x00000000000003C0, 0x00, 0, 0x0000000000000000, "LIQ reply queue credit counter" ],
   "RSVD3"                        => [   8,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LIQ_RQ_CREDIT"                => [   9,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "LIQ request queue credit counter" ],
);

%orbit_01_00313_def =
( NAME    => "OC_LB_LAST_CREDIT",
  ADDRESS => 0x0000000090050780,
  NOTE    => "The LB_LAST_CREDIT register stores the value of the LB's five note credit counters when a reset occurs. The leading edge of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00313_flds
);


##########################################################################
#                                                                        #
#   OC_LB_NACK_STATUS                                                    #
#                                                                        #
##########################################################################

%orbit_01_00314_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "JUNK_NACK"                    => [   1,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "Junk bus nack counter" ],
);

%orbit_01_00314_def =
( NAME    => "OC_LB_NACK_STATUS",
  ADDRESS => 0x0000000090050800,
  NOTE    => "The LB_NACK_STATUS register contains the current value of the PIO note Conveyor Belt's and Junk Bus Conveyor Belt's NACK counter",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00314_flds
);


##########################################################################
#                                                                        #
#   OC_LB_COMPARE_COMPARE                                                #
#                                                                        #
##########################################################################

%orbit_01_00315_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MASK"                         => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Mask to select Debug bits for compare generation" ],
);

%orbit_01_00315_def =
( NAME    => "OC_LB_COMPARE_COMPARE",
  ADDRESS => 0x0000000090050880,
  NOTE    => "The LB_COMPARE_COMPARE register enables a comparison test between note the output of LB's 32-bit Trigger Multiplexer and the not",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00315_flds
);


##########################################################################
#                                                                        #
#   OC_LB_COMPARE_DATA                                                   #
#                                                                        #
##########################################################################

%orbit_01_00316_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COMPARE_PATTERN"              => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "debug bit pattern for compare generation" ],
);

%orbit_01_00316_def =
( NAME    => "OC_LB_COMPARE_DATA",
  ADDRESS => 0x0000000090050900,
  NOTE    => "The LB_COMPARE_DATA register contains the pattern to which the LB's note Trigger Multiplexer Output Port is compared. One or mor",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00316_flds
);


##########################################################################
#                                                                        #
#   OC_AUTO_REPLY_ENABLE0                                                #
#                                                                        #
##########################################################################

%orbit_01_00317_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE0"                      => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Enable 0" ],
);

%orbit_01_00317_def =
( NAME    => "OC_AUTO_REPLY_ENABLE0",
  ADDRESS => 0x0000000090062000,
  NOTE    => "The AUTO_REPLY_ENABLE0 register is a configuration registers for note the Orbit's Auto-reply Maintenance Test Facility.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00317_flds
);


##########################################################################
#                                                                        #
#   OC_AUTO_REPLY_ENABLE1                                                #
#                                                                        #
##########################################################################

%orbit_01_00318_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE1"                      => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Enable 1" ],
);

%orbit_01_00318_def =
( NAME    => "OC_AUTO_REPLY_ENABLE1",
  ADDRESS => 0x0000000090062080,
  NOTE    => "The AUTO_REPLY_ENABLE1 register is a configuration registers for note the Orbit's Auto-reply Maintenance Test Facility.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00318_flds
);


##########################################################################
#                                                                        #
#   OC_AUTO_REPLY_HEADER0                                                #
#                                                                        #
##########################################################################

%orbit_01_00319_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER0"                      => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Header 0" ],
);

%orbit_01_00319_def =
( NAME    => "OC_AUTO_REPLY_HEADER0",
  ADDRESS => 0x0000000090062100,
  NOTE    => "The AUTO_REPLY_HEADER0 register is a configuration registers for note the Orbit 's Auto-reply Maintenance Test Facility. It cont",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00319_flds
);


##########################################################################
#                                                                        #
#   OC_AUTO_REPLY_HEADER1                                                #
#                                                                        #
##########################################################################

%orbit_01_00320_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER1"                      => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Header 1" ],
);

%orbit_01_00320_def =
( NAME    => "OC_AUTO_REPLY_HEADER1",
  ADDRESS => 0x0000000090062180,
  NOTE    => "The AUTO_REPLY_HEADER1 register is a configuration registers for note the Orbit's Auto-reply Maintenance Test Facility. It conta",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00320_flds
);


##########################################################################
#                                                                        #
#   OC_ENABLE_RP_AUTO_REPLY                                              #
#                                                                        #
##########################################################################

%orbit_01_00321_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE"                       => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable Reply Auto Reply" ],
);

%orbit_01_00321_def =
( NAME    => "OC_ENABLE_RP_AUTO_REPLY",
  ADDRESS => 0x0000000090062200,
  NOTE    => "The ENABLE_RP_AUTO_REPLY register is a configuration registers for note the Orbit's Auto-reply Maintenance Test Facility. When t",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00321_flds
);


##########################################################################
#                                                                        #
#   OC_ENABLE_RQ_AUTO_REPLY                                              #
#                                                                        #
##########################################################################

%orbit_01_00322_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE"                       => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable Request Auto Reply" ],
);

%orbit_01_00322_def =
( NAME    => "OC_ENABLE_RQ_AUTO_REPLY",
  ADDRESS => 0x0000000090062280,
  NOTE    => "The automated reply feature is a maintenance feature that allows note the local block to generate a reply packet for a specific ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00322_flds
);


##########################################################################
#                                                                        #
#   OC_REDIRECT_INVAL                                                    #
#                                                                        #
##########################################################################

%orbit_01_00323_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REDIRECT"                     => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Redirect LINVV Messages Generated by the LB" ],
);

%orbit_01_00323_def =
( NAME    => "OC_REDIRECT_INVAL",
  ADDRESS => 0x0000000090062300,
  NOTE    => "The REDIRECT_INVAL register determines the destination chiplet ID note in LINVV messages generated by the LB. Normally, when the",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00323_flds
);


##########################################################################
#                                                                        #
#   OC_DIAG_MSG_CNTRL                                                    #
#                                                                        #
##########################################################################

%orbit_01_00324_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "BUSY"                         => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Diagnostic Message Facility is Busy" ],
   "START"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Start" ],
   "RSVD0"                        => [   2,  16,  46, 0x3FFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SUPPRESS_HEADER_ENABLE"       => [   3,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Enable suppressing the header field" ],
   "EXTRA_HEADER_FLAG_ENABLE"     => [   4,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Enable extra header flag" ],
   "PORT"                         => [   5,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Virtual Channel Code" ],
   "ERROR_INJECT_ENABLE"          => [   6,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Enable ERROR_INJECT_POINT field" ],
   "ERROR_INJECT_POINT"           => [   7,   6,   6, 0x0000000000000FC0, 0x00, 0, 0x0000000000000000, "Micropacket Targeted for Error Injection" ],
   "MSG_LENGTH"                   => [   8,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "Message data payload length, 0 - 63" ],
);

%orbit_01_00324_def =
( NAME    => "OC_DIAG_MSG_CNTRL",
  ADDRESS => 0x0000000090063000,
  NOTE    => "The DIAG_MSG_CNTRL register provides the facility for initiating note the transmission of a diagnostic message onto the SN2 netw",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00324_flds
);


##########################################################################
#                                                                        #
#   OC_DIAG_MSG_DATA0L                                                   #
#                                                                        #
##########################################################################

%orbit_01_00325_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_LOWER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "2nd Micropacket, Lower 64 Bits" ],
);

%orbit_01_00325_def =
( NAME    => "OC_DIAG_MSG_DATA0L",
  ADDRESS => 0x0000000090063080,
  NOTE    => "When a diagnostic message consists of 2 or more micropackets, the note DIAG_MSG_DATA0L register's DATA_LOWER field contains the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00325_flds
);


##########################################################################
#                                                                        #
#   OC_DIAG_MSG_DATA0U                                                   #
#                                                                        #
##########################################################################

%orbit_01_00326_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_UPPER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "2nd Micropacket, Upper 64 Bits" ],
);

%orbit_01_00326_def =
( NAME    => "OC_DIAG_MSG_DATA0U",
  ADDRESS => 0x0000000090063100,
  NOTE    => "When a diagnostic message consists of 2 or more micropackets, the note DIAG_MSG_DATA0U register's DATA_UPPER field contains the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00326_flds
);


##########################################################################
#                                                                        #
#   OC_DIAG_MSG_DATA1L                                                   #
#                                                                        #
##########################################################################

%orbit_01_00327_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_LOWER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "3rd Micropacket, Lower 64 Bits" ],
);

%orbit_01_00327_def =
( NAME    => "OC_DIAG_MSG_DATA1L",
  ADDRESS => 0x0000000090063180,
  NOTE    => "When a diagnostic message consists of 3 or more micropackets, the note DIAG_MSG_DATA1L register's DATA_LOWER field contains the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00327_flds
);


##########################################################################
#                                                                        #
#   OC_DIAG_MSG_DATA1U                                                   #
#                                                                        #
##########################################################################

%orbit_01_00328_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_UPPER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "3rd Micropacket, Upper 64 Bits" ],
);

%orbit_01_00328_def =
( NAME    => "OC_DIAG_MSG_DATA1U",
  ADDRESS => 0x0000000090063200,
  NOTE    => "When a diagnostic message consists of 3 or more micropackets, the note DIAG_MSG_DATA1U register's DATA_UPPER field contains the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00328_flds
);


##########################################################################
#                                                                        #
#   OC_DIAG_MSG_DATA2L                                                   #
#                                                                        #
##########################################################################

%orbit_01_00329_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_LOWER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "4th Micropacket, Lower 64 Bits" ],
);

%orbit_01_00329_def =
( NAME    => "OC_DIAG_MSG_DATA2L",
  ADDRESS => 0x0000000090063280,
  NOTE    => "When a diagnostic message consists of 4 or more micropackets, the note DIAG_MSG_DATA2L register's DATA_LOWER field contains the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00329_flds
);


##########################################################################
#                                                                        #
#   OC_DIAG_MSG_DATA2U                                                   #
#                                                                        #
##########################################################################

%orbit_01_00330_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_UPPER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "4th Micropacket, Upper 64 Bits" ],
);

%orbit_01_00330_def =
( NAME    => "OC_DIAG_MSG_DATA2U",
  ADDRESS => 0x0000000090063300,
  NOTE    => "When a diagnostic message consists of 4 or more micropackets, the note DIAG_MSG_DATA2U register's DATA_UPPER field contains the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00330_flds
);


##########################################################################
#                                                                        #
#   OC_DIAG_MSG_DATA3L                                                   #
#                                                                        #
##########################################################################

%orbit_01_00331_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_LOWER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "5th Micropacket, Lower 64 Bits" ],
);

%orbit_01_00331_def =
( NAME    => "OC_DIAG_MSG_DATA3L",
  ADDRESS => 0x0000000090063380,
  NOTE    => "When a diagnostic message consists of 5 or more micropackets, the note DIAG_MSG_DATA3L register's DATA_LOWER field contains the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00331_flds
);


##########################################################################
#                                                                        #
#   OC_DIAG_MSG_DATA3U                                                   #
#                                                                        #
##########################################################################

%orbit_01_00332_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_UPPER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "5th Micropacket, Upper 64 Bits" ],
);

%orbit_01_00332_def =
( NAME    => "OC_DIAG_MSG_DATA3U",
  ADDRESS => 0x0000000090063400,
  NOTE    => "When a diagnostic message consists of 5 or more micropackets, the note DIAG_MSG_DATA3U register's DATA_UPPER field contains the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00332_flds
);


##########################################################################
#                                                                        #
#   OC_DIAG_MSG_DATA4L                                                   #
#                                                                        #
##########################################################################

%orbit_01_00333_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_LOWER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "6th Micropacket, Lower 64 Bits" ],
);

%orbit_01_00333_def =
( NAME    => "OC_DIAG_MSG_DATA4L",
  ADDRESS => 0x0000000090063480,
  NOTE    => "When a diagnostic message consists of 6 or more micropackets, the note DIAG_MSG_DATA4L register's DATA_LOWER field contains the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00333_flds
);


##########################################################################
#                                                                        #
#   OC_DIAG_MSG_DATA4U                                                   #
#                                                                        #
##########################################################################

%orbit_01_00334_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_UPPER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "6th Micropacket, Upper 64 Bits" ],
);

%orbit_01_00334_def =
( NAME    => "OC_DIAG_MSG_DATA4U",
  ADDRESS => 0x0000000090063500,
  NOTE    => "When a diagnostic message consists of 6 or more micropackets, the note DIAG_MSG_DATA4U register's DATA_UPPER field contains the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00334_flds
);


##########################################################################
#                                                                        #
#   OC_DIAG_MSG_DATA5L                                                   #
#                                                                        #
##########################################################################

%orbit_01_00335_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_LOWER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "7th Micropacket, Lower 64 Bits" ],
);

%orbit_01_00335_def =
( NAME    => "OC_DIAG_MSG_DATA5L",
  ADDRESS => 0x0000000090063580,
  NOTE    => "When a diagnostic message consists of 7 or more micropackets, the note DIAG_MSG_DATA5L register's DATA_LOWER field contains the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00335_flds
);


##########################################################################
#                                                                        #
#   OC_DIAG_MSG_DATA5U                                                   #
#                                                                        #
##########################################################################

%orbit_01_00336_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_UPPER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "7th Micropacket, Upper 64 Bits" ],
);

%orbit_01_00336_def =
( NAME    => "OC_DIAG_MSG_DATA5U",
  ADDRESS => 0x0000000090063600,
  NOTE    => "When a diagnostic message consists of 7 or more micropackets, the note DIAG_MSG_DATA5U register's DATA_UPPER field contains the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00336_flds
);


##########################################################################
#                                                                        #
#   OC_DIAG_MSG_DATA6L                                                   #
#                                                                        #
##########################################################################

%orbit_01_00337_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_LOWER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "8th Micropacket, Lower 64 Bits" ],
);

%orbit_01_00337_def =
( NAME    => "OC_DIAG_MSG_DATA6L",
  ADDRESS => 0x0000000090063680,
  NOTE    => "When a diagnostic message consists of 8 or more micropackets, the note DIAG_MSG_DATA6L register's DATA_LOWER field contains the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00337_flds
);


##########################################################################
#                                                                        #
#   OC_DIAG_MSG_DATA6U                                                   #
#                                                                        #
##########################################################################

%orbit_01_00338_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_UPPER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "8th Micropacket, Upper 64 Bits" ],
);

%orbit_01_00338_def =
( NAME    => "OC_DIAG_MSG_DATA6U",
  ADDRESS => 0x0000000090063700,
  NOTE    => "When a diagnostic message consists of 8 or more micropackets, the note DIAG_MSG_DATA6U register's DATA_UPPER field contains the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00338_flds
);


##########################################################################
#                                                                        #
#   OC_DIAG_MSG_DATA7L                                                   #
#                                                                        #
##########################################################################

%orbit_01_00339_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_LOWER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "9th Micropacket, Lower 64 Bits" ],
);

%orbit_01_00339_def =
( NAME    => "OC_DIAG_MSG_DATA7L",
  ADDRESS => 0x0000000090063780,
  NOTE    => "When a diagnostic message consists of 9 or more micropackets, the note DIAG_MSG_DATA7L register's DATA_LOWER field contains the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00339_flds
);


##########################################################################
#                                                                        #
#   OC_DIAG_MSG_DATA7U                                                   #
#                                                                        #
##########################################################################

%orbit_01_00340_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_UPPER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "9th Micropacket, Upper 64 Bits" ],
);

%orbit_01_00340_def =
( NAME    => "OC_DIAG_MSG_DATA7U",
  ADDRESS => 0x0000000090063800,
  NOTE    => "When a diagnostic message consists of 9 or more micropackets, the note DIAG_MSG_DATA7U register's DATA_UPPER field contains the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00340_flds
);


##########################################################################
#                                                                        #
#   OC_DIAG_MSG_DATA8L                                                   #
#                                                                        #
##########################################################################

%orbit_01_00341_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_LOWER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "10th Micropacket, Lower 64 Bits" ],
);

%orbit_01_00341_def =
( NAME    => "OC_DIAG_MSG_DATA8L",
  ADDRESS => 0x0000000090063880,
  NOTE    => "When a diagnostic message consists of 10 or more micropackets, the note DIAG_MSG_DATA8L register's DATA_LOWER field contains the",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00341_flds
);


##########################################################################
#                                                                        #
#   OC_DIAG_MSG_DATA8U                                                   #
#                                                                        #
##########################################################################

%orbit_01_00342_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_UPPER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "10th Micropacket, Upper 64 Bits" ],
);

%orbit_01_00342_def =
( NAME    => "OC_DIAG_MSG_DATA8U",
  ADDRESS => 0x0000000090063900,
  NOTE    => "When a diagnostic message consists of 10 or more micropackets, the note DIAG_MSG_DATA8U register's DATA_UPPER field contains the",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00342_flds
);


##########################################################################
#                                                                        #
#   OC_DIAG_MSG_HDR0                                                     #
#                                                                        #
##########################################################################

%orbit_01_00343_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER0"                      => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "1st Micropacket, Lower 64 Bits" ],
);

%orbit_01_00343_def =
( NAME    => "OC_DIAG_MSG_HDR0",
  ADDRESS => 0x0000000090063980,
  NOTE    => "The DIAG_MSG_HDR0 register's HEADER0 field contains the header note payload transmitted in the lower 64 bits of the 1st micropac",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00343_flds
);


##########################################################################
#                                                                        #
#   OC_DIAG_MSG_HDR1                                                     #
#                                                                        #
##########################################################################

%orbit_01_00344_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER1"                      => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "1st Micropacket, Upper 64 Bits" ],
);

%orbit_01_00344_def =
( NAME    => "OC_DIAG_MSG_HDR1",
  ADDRESS => 0x0000000090063a00,
  NOTE    => "The DIAG_MSG_HDR1 register's HEADER1 field contains the header note payload transmitted in the upper 64 bits of the 1st micropac",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00344_flds
);


##########################################################################
#                                                                        #
#   OC_DEBUG_SELECT                                                      #
#                                                                        #
##########################################################################

%orbit_01_00345_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COMPARE_ENABLE"               => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Enable compare on bit 32 of Analyzer data" ],
   "GROUP_SELECT_7"               => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Group select 7" ],
   "RSVD0"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_7"               => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Field select 7" ],
   "RSVD1"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_6"               => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Group select 6" ],
   "RSVD2"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_6"               => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Field select 6" ],
   "RSVD3"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_5"               => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Group select 5" ],
   "RSVD4"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_5"               => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Field select 5" ],
   "RSVD5"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_4"               => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Group select 4" ],
   "RSVD6"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_4"               => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Field select 4" ],
   "RSVD7"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_3"               => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Group select 3" ],
   "RSVD8"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_3"               => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Field select 3" ],
   "RSVD9"                        => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_2"               => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Group select 2" ],
   "RSVD10"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_2"               => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Field select 2" ],
   "RSVD11"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_1"               => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Group select 1" ],
   "RSVD12"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_1"               => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Field select 1" ],
   "RSVD13"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_0"               => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Group select 0" ],
   "RSVD14"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_0"               => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Field select 0" ],
);

%orbit_01_00345_def =
( NAME    => "OC_DEBUG_SELECT",
  ADDRESS => 0x0000000090064000,
  NOTE    => "The oc_debug_select register controls the top level debug mux for note the TIO debug data. The group_select fields selects one o",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00345_flds
);


##########################################################################
#                                                                        #
#   OC_II_DEBUG_SELECT                                                   #
#                                                                        #
##########################################################################

%orbit_01_00346_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEL_II"                       => [   1,  51,   5, 0x00F8000000000000, 0x00, 0, 0x0000000000000000, "Select II to debug port" ],
   "DEBUG_II_SEL"                 => [   2,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Select bits to II port" ],
);

%orbit_01_00346_def =
( NAME    => "OC_II_DEBUG_SELECT",
  ADDRESS => 0x0000000090064480,
  NOTE    => "The ii_debug_select register will select the II data to the debug note port. There is one select bit for two nibbles of II data,",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00346_flds
);


##########################################################################
#                                                                        #
#   OC_COMPARE_COMPARE_MASK                                              #
#                                                                        #
##########################################################################

%orbit_01_00347_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MASK"                         => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Orbit Debug Compare Mask" ],
);

%orbit_01_00347_def =
( NAME    => "OC_COMPARE_COMPARE_MASK",
  ADDRESS => 0x0000000090064080,
  NOTE    => "Orbit Debug Compare Mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00347_flds
);


##########################################################################
#                                                                        #
#   OC_COMPARE_COMPARE_PATTERN                                           #
#                                                                        #
##########################################################################

%orbit_01_00348_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA"                         => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Orbit Debug Compare Pattern" ],
);

%orbit_01_00348_def =
( NAME    => "OC_COMPARE_COMPARE_PATTERN",
  ADDRESS => 0x0000000090064100,
  NOTE    => "Orbit Debug Compare Pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00348_flds
);


##########################################################################
#                                                                        #
#   OC_COMPARE_SEL                                                       #
#                                                                        #
##########################################################################

%orbit_01_00349_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_7"               => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_7"               => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 input select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_6"               => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_6"               => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 input select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_5"               => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_5"               => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 input select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_4"               => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_4"               => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 input select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_3"               => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_3"               => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 input select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_2"               => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_2"               => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 input select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_1"               => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_1"               => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 input select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_0"               => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_0"               => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 input select" ],
);

%orbit_01_00349_def =
( NAME    => "OC_COMPARE_SEL",
  ADDRESS => 0x0000000090064180,
  NOTE    => "The oc_compare_sel register controls the compare mux in the top note level Orbit debug mux. The output of the compare mux is com",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00349_flds
);


##########################################################################
#                                                                        #
#   OC_OB_LA_CONTROL                                                     #
#                                                                        #
##########################################################################

%orbit_01_00350_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RESET"                        => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Reset Logic Analyzer Buffer" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   3,  16,  14, 0x000000003FFF0000, 0x00, 1, 0x0000000000000000, "Node ID" ],
   "RSVD2"                        => [   4,   4,  12, 0x000000000000FFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRAP_MEM"                     => [   5,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Memory wrap control" ],
   "WRAP_BUFF"                    => [   6,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Buffer wrap control" ],
   "WRITE_MEM"                    => [   7,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Write memory control" ],
   "WRITE_BUFF"                   => [   8,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Write buffer control" ],
);

%orbit_01_00350_def =
( NAME    => "OC_OB_LA_CONTROL",
  ADDRESS => 0x0000000090064200,
  NOTE    => "The OB_LA_CONTROL register controls writing to the on board logic note analyzer buffer and writting that buffer to memory.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00350_flds
);


##########################################################################
#                                                                        #
#   OC_OB_LA_START_CONTROL                                               #
#                                                                        #
##########################################################################

%orbit_01_00351_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  10,  54, 0xFFFFFFFFFFFFFC00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WORD_MODE"                    => [   1,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Word mode select" ],
   "TRIGGER"                      => [   2,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Start control trigger select" ],
   "SOURCE"                       => [   3,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Start control source select" ],
   "POLARITY"                     => [   4,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Polarity of start stimulus" ],
   "RSVD1"                        => [   5,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SELECT"                       => [   6,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Start control select bits" ],
);

%orbit_01_00351_def =
( NAME    => "OC_OB_LA_START_CONTROL",
  ADDRESS => 0x0000000090064280,
  NOTE    => "The OB_LA_START_CONTROL register controls starting recording of the note on board logic analzyer.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00351_flds
);


##########################################################################
#                                                                        #
#   OC_OB_LA_STOP_CONTROL                                                #
#                                                                        #
##########################################################################

%orbit_01_00352_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER"                      => [   1,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Stop control trigger select" ],
   "SOURCE"                       => [   2,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Stop control source select" ],
   "POLARITY"                     => [   3,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Polarity of stop stimulus" ],
   "RSVD1"                        => [   4,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SELECT"                       => [   5,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Stop control select bits" ],
);

%orbit_01_00352_def =
( NAME    => "OC_OB_LA_STOP_CONTROL",
  ADDRESS => 0x0000000090064300,
  NOTE    => "The OB_LA_STOP_CONTROL register controls stopping recording of the note on board logic analzyer.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00352_flds
);


##########################################################################
#                                                                        #
#   OC_OB_LA_START_ADDRESS                                               #
#                                                                        #
##########################################################################

%orbit_01_00353_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDRESS"                      => [   1,   7,  31, 0x0000003FFFFFFF80, 0x00, 1, 0x0000000000000000, "Starting address bits 7 - 37" ],
);

%orbit_01_00353_def =
( NAME    => "OC_OB_LA_START_ADDRESS",
  ADDRESS => 0x0000000090064380,
  NOTE    => "The OB_LA_START_ADDRESS register contains the starting address for note storing the on board logic analyzer data in memory. This",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00353_flds
);


##########################################################################
#                                                                        #
#   OC_OB_LA_END_ADDRESS                                                 #
#                                                                        #
##########################################################################

%orbit_01_00354_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDRESS"                      => [   1,   7,  31, 0x0000003FFFFFFF80, 0x00, 1, 0x0000000000000000, "Ending address bits 7 - 37" ],
);

%orbit_01_00354_def =
( NAME    => "OC_OB_LA_END_ADDRESS",
  ADDRESS => 0x0000000090064400,
  NOTE    => "The OB_LA_END_ADDRESS register contains the ending address for note storing the on board logic analyzer data in memory. This is ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00354_flds
);


##########################################################################
#                                                                        #
#   OC_STOP_CLK_CONTROL                                                  #
#                                                                        #
##########################################################################

%orbit_01_00355_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE"                       => [   1,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Clock stop enable (0-disabled, 1-enabled)" ],
   "MODE"                         => [   2,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Counter mode select (0-external, 1-internal)" ],
   "POLARITY"                     => [   3,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Counter polarity select (0-negative edge, 1-positive edge)" ],
   "EVENT"                        => [   4,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Counter event select (0-greater than, 1-equal)" ],
   "STIMULUS"                     => [   5,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Counter stimulus" ],
);

%orbit_01_00355_def =
( NAME    => "OC_STOP_CLK_CONTROL",
  ADDRESS => 0x0000000090065000,
  NOTE    => "The stop clock facility is a means of precisely stopping the clocks note on the Orbit. Alternatively it can be used to send an i",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00355_flds
);


##########################################################################
#                                                                        #
#   OC_STOP_CLK_DELAY_PHASE                                              #
#                                                                        #
##########################################################################

%orbit_01_00356_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DELAY"                        => [   1,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Delay phase" ],
);

%orbit_01_00356_def =
( NAME    => "OC_STOP_CLK_DELAY_PHASE",
  ADDRESS => 0x0000000090065080,
  NOTE    => "Stop Clock Delay Phase",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00356_flds
);


##########################################################################
#                                                                        #
#   OC_TSF_ARM_MASK                                                      #
#                                                                        #
##########################################################################

%orbit_01_00357_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility arm mask" ],
);

%orbit_01_00357_def =
( NAME    => "OC_TSF_ARM_MASK",
  ADDRESS => 0x0000000090066000,
  NOTE    => "Trigger sequencing facility arm mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00357_flds
);


##########################################################################
#                                                                        #
#   OC_TSF_COUNTER_PRESETS                                               #
#                                                                        #
##########################################################################

%orbit_01_00358_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COUNT_8A"                     => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 8a" ],
   "COUNT_8B"                     => [   1,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 8b" ],
   "COUNT_16"                     => [   2,  32,  16, 0x0000FFFF00000000, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 16" ],
   "COUNT_32"                     => [   3,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 32" ],
);

%orbit_01_00358_def =
( NAME    => "OC_TSF_COUNTER_PRESETS",
  ADDRESS => 0x0000000090066080,
  NOTE    => "The oc_tsf_counter_presets register contains the initial values for note the trigger sequencing facility down counters.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00358_flds
);


##########################################################################
#                                                                        #
#   OC_TSF_DECREMENT_CTL                                                 #
#                                                                        #
##########################################################################

%orbit_01_00359_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CTL"                          => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter decrement control" ],
);

%orbit_01_00359_def =
( NAME    => "OC_TSF_DECREMENT_CTL",
  ADDRESS => 0x0000000090066100,
  NOTE    => "Trigger sequencing facility counter decrement control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00359_flds
);


##########################################################################
#                                                                        #
#   OC_TSF_DIAG_MSG_CTL                                                  #
#                                                                        #
##########################################################################

%orbit_01_00360_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE"                       => [   1,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Trigger sequencing facility diagnostic message control" ],
);

%orbit_01_00360_def =
( NAME    => "OC_TSF_DIAG_MSG_CTL",
  ADDRESS => 0x0000000090066180,
  NOTE    => "Trigger sequencing facility diagnostic message control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00360_flds
);


##########################################################################
#                                                                        #
#   OC_TSF_DISARM_MASK                                                   #
#                                                                        #
##########################################################################

%orbit_01_00361_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility disarm mask" ],
);

%orbit_01_00361_def =
( NAME    => "OC_TSF_DISARM_MASK",
  ADDRESS => 0x0000000090066200,
  NOTE    => "Trigger sequencing facility disarm mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00361_flds
);


##########################################################################
#                                                                        #
#   OC_TSF_ENABLE_CTL                                                    #
#                                                                        #
##########################################################################

%orbit_01_00362_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CTL"                          => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter enable control" ],
);

%orbit_01_00362_def =
( NAME    => "OC_TSF_ENABLE_CTL",
  ADDRESS => 0x0000000090066280,
  NOTE    => "Trigger sequencing facility counter enable control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00362_flds
);


##########################################################################
#                                                                        #
#   OC_TSF_SOFTWARE_ARM                                                  #
#                                                                        #
##########################################################################

%orbit_01_00363_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BIT7"                         => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm bit 7" ],
   "BIT6"                         => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm bit 6" ],
   "BIT5"                         => [   3,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm bit 5" ],
   "BIT4"                         => [   4,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm bit 4" ],
   "BIT3"                         => [   5,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm bit 3" ],
   "BIT2"                         => [   6,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm bit 2" ],
   "BIT1"                         => [   7,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm bit 1" ],
   "BIT0"                         => [   8,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm bit 0" ],
);

%orbit_01_00363_def =
( NAME    => "OC_TSF_SOFTWARE_ARM",
  ADDRESS => 0x0000000090066300,
  NOTE    => "The oc_tsf_software_arm register provides software with a means to note arm any of the trigger sequencing variables. Writing a o",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00363_flds
);


##########################################################################
#                                                                        #
#   OC_TSF_SOFTWARE_DISARM                                               #
#                                                                        #
##########################################################################

%orbit_01_00364_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BIT7"                         => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 7" ],
   "BIT6"                         => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 6" ],
   "BIT5"                         => [   3,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 5" ],
   "BIT4"                         => [   4,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 4" ],
   "BIT3"                         => [   5,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 3" ],
   "BIT2"                         => [   6,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 2" ],
   "BIT1"                         => [   7,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 1" ],
   "BIT0"                         => [   8,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 0" ],
);

%orbit_01_00364_def =
( NAME    => "OC_TSF_SOFTWARE_DISARM",
  ADDRESS => 0x0000000090066380,
  NOTE    => "The oc_tsf_software_disarm register provides software with a means note to disarm any of the trigger sequencing variables. Writi",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00364_flds
);


##########################################################################
#                                                                        #
#   OC_TSF_SOFTWARE_TRIGGERED                                            #
#                                                                        #
##########################################################################

%orbit_01_00365_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BIT7"                         => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 7" ],
   "BIT6"                         => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 6" ],
   "BIT5"                         => [   3,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 5" ],
   "BIT4"                         => [   4,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 4" ],
   "BIT3"                         => [   5,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 3" ],
   "BIT2"                         => [   6,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 2" ],
   "BIT1"                         => [   7,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 1" ],
   "BIT0"                         => [   8,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 0" ],
);

%orbit_01_00365_def =
( NAME    => "OC_TSF_SOFTWARE_TRIGGERED",
  ADDRESS => 0x0000000090066400,
  NOTE    => "The oc_tsf_software_triggered register provides software with a note means to trigger any of the trigger sequencing variables. W",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00365_flds
);


##########################################################################
#                                                                        #
#   OC_TSF_TRIGGER_MASK                                                  #
#                                                                        #
##########################################################################

%orbit_01_00366_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility trigger mask" ],
);

%orbit_01_00366_def =
( NAME    => "OC_TSF_TRIGGER_MASK",
  ADDRESS => 0x0000000090066480,
  NOTE    => "The oc_tsf_trigger_mask is used to enable an auxiliary trigger note compare to trigger a particular trigger sequencing variable.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00366_flds
);


##########################################################################
#                                                                        #
#   OC_TSF_COMPARE0                                                      #
#                                                                        #
##########################################################################

%orbit_01_00367_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Enable bits for TSF compare" ],
   "EXPECTED_DATA"                => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data for TSF compare" ],
);

%orbit_01_00367_def =
( NAME    => "OC_TSF_COMPARE0",
  ADDRESS => 0x0000000090066500,
  NOTE    => "The oc_tsf_compare registers are used to compare trigger data note against a data pattern and an enable. The results of the comp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00367_flds
);


##########################################################################
#                                                                        #
#   OC_TSF_COMPARE1                                                      #
#                                                                        #
##########################################################################

%orbit_01_00368_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Enable bits for TSF compare" ],
   "EXPECTED_DATA"                => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data for TSF compare" ],
);

%orbit_01_00368_def =
( NAME    => "OC_TSF_COMPARE1",
  ADDRESS => 0x0000000090066580,
  NOTE    => "The oc_tsf_compare registers are used to compare trigger data note against a data pattern and an enable. The results of the comp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00368_flds
);


##########################################################################
#                                                                        #
#   OC_TSF_COMPARE2                                                      #
#                                                                        #
##########################################################################

%orbit_01_00369_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Enable bits for TSF compare" ],
   "EXPECTED_DATA"                => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data for TSF compare" ],
);

%orbit_01_00369_def =
( NAME    => "OC_TSF_COMPARE2",
  ADDRESS => 0x0000000090066600,
  NOTE    => "The oc_tsf_compare registers are used to compare trigger data note against a data pattern and an enable. The results of the comp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00369_flds
);


##########################################################################
#                                                                        #
#   OC_TSF_COMPARE3                                                      #
#                                                                        #
##########################################################################

%orbit_01_00370_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Enable bits for TSF compare" ],
   "EXPECTED_DATA"                => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data for TSF compare" ],
);

%orbit_01_00370_def =
( NAME    => "OC_TSF_COMPARE3",
  ADDRESS => 0x0000000090066680,
  NOTE    => "The oc_tsf_compare registers are used to compare trigger data note against a data pattern and an enable. The results of the comp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00370_flds
);


##########################################################################
#                                                                        #
#   OC_TSF_COMPARE4                                                      #
#                                                                        #
##########################################################################

%orbit_01_00371_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Enable bits for TSF compare" ],
   "EXPECTED_DATA"                => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data for TSF compare" ],
);

%orbit_01_00371_def =
( NAME    => "OC_TSF_COMPARE4",
  ADDRESS => 0x0000000090066700,
  NOTE    => "The oc_tsf_compare registers are used to compare trigger data note against a data pattern and an enable. The results of the comp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00371_flds
);


##########################################################################
#                                                                        #
#   OC_TSF_COMPARE5                                                      #
#                                                                        #
##########################################################################

%orbit_01_00372_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Enable bits for TSF compare" ],
   "EXPECTED_DATA"                => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data for TSF compare" ],
);

%orbit_01_00372_def =
( NAME    => "OC_TSF_COMPARE5",
  ADDRESS => 0x0000000090066780,
  NOTE    => "The oc_tsf_compare registers are used to compare trigger data note against a data pattern and an enable. The results of the comp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00372_flds
);


##########################################################################
#                                                                        #
#   OC_TSF_COMPARE6                                                      #
#                                                                        #
##########################################################################

%orbit_01_00373_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Enable bits for TSF compare" ],
   "EXPECTED_DATA"                => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data for TSF compare" ],
);

%orbit_01_00373_def =
( NAME    => "OC_TSF_COMPARE6",
  ADDRESS => 0x0000000090066800,
  NOTE    => "The oc_tsf_compare registers are used to compare trigger data note against a data pattern and an enable. The results of the comp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00373_flds
);


##########################################################################
#                                                                        #
#   OC_TSF_COMPARE7                                                      #
#                                                                        #
##########################################################################

%orbit_01_00374_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Enable bits for TSF compare" ],
   "EXPECTED_DATA"                => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data for TSF compare" ],
);

%orbit_01_00374_def =
( NAME    => "OC_TSF_COMPARE7",
  ADDRESS => 0x0000000090066880,
  NOTE    => "The oc_tsf_compare registers are used to compare trigger data note against a data pattern and an enable. The results of the comp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00374_flds
);


##########################################################################
#                                                                        #
#   OC_TSF_COMPARE8                                                      #
#                                                                        #
##########################################################################

%orbit_01_00375_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Enable bits for TSF compare" ],
   "EXPECTED_DATA"                => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data for TSF compare" ],
);

%orbit_01_00375_def =
( NAME    => "OC_TSF_COMPARE8",
  ADDRESS => 0x0000000090066900,
  NOTE    => "The oc_tsf_compare registers are used to compare trigger data note against a data pattern and an enable. The results of the comp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00375_flds
);


##########################################################################
#                                                                        #
#   OC_TSF_COMPARE9                                                      #
#                                                                        #
##########################################################################

%orbit_01_00376_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Enable bits for TSF compare" ],
   "EXPECTED_DATA"                => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data for TSF compare" ],
);

%orbit_01_00376_def =
( NAME    => "OC_TSF_COMPARE9",
  ADDRESS => 0x0000000090066980,
  NOTE    => "The oc_tsf_compare registers are used to compare trigger data note against a data pattern and an enable. The results of the comp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00376_flds
);


##########################################################################
#                                                                        #
#   OC_TSF_COMPARE10                                                     #
#                                                                        #
##########################################################################

%orbit_01_00377_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Enable bits for TSF compare" ],
   "EXPECTED_DATA"                => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data for TSF compare" ],
);

%orbit_01_00377_def =
( NAME    => "OC_TSF_COMPARE10",
  ADDRESS => 0x0000000090066a00,
  NOTE    => "The oc_tsf_compare registers are used to compare trigger data note against a data pattern and an enable. The results of the comp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00377_flds
);


##########################################################################
#                                                                        #
#   OC_TSF_COMPARE11                                                     #
#                                                                        #
##########################################################################

%orbit_01_00378_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Enable bits for TSF compare" ],
   "EXPECTED_DATA"                => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data for TSF compare" ],
);

%orbit_01_00378_def =
( NAME    => "OC_TSF_COMPARE11",
  ADDRESS => 0x0000000090066a80,
  NOTE    => "The oc_tsf_compare registers are used to compare trigger data note against a data pattern and an enable. The results of the comp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00378_flds
);


##########################################################################
#                                                                        #
#   OC_TSF_COMPARE12                                                     #
#                                                                        #
##########################################################################

%orbit_01_00379_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Enable bits for TSF compare" ],
   "EXPECTED_DATA"                => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data for TSF compare" ],
);

%orbit_01_00379_def =
( NAME    => "OC_TSF_COMPARE12",
  ADDRESS => 0x0000000090066b00,
  NOTE    => "The oc_tsf_compare registers are used to compare trigger data note against a data pattern and an enable. The results of the comp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00379_flds
);


##########################################################################
#                                                                        #
#   OC_TSF_COMPARE13                                                     #
#                                                                        #
##########################################################################

%orbit_01_00380_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Enable bits for TSF compare" ],
   "EXPECTED_DATA"                => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data for TSF compare" ],
);

%orbit_01_00380_def =
( NAME    => "OC_TSF_COMPARE13",
  ADDRESS => 0x0000000090066b80,
  NOTE    => "The oc_tsf_compare registers are used to compare trigger data note against a data pattern and an enable. The results of the comp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00380_flds
);


##########################################################################
#                                                                        #
#   OC_TSF_COMPARE14                                                     #
#                                                                        #
##########################################################################

%orbit_01_00381_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Enable bits for TSF compare" ],
   "EXPECTED_DATA"                => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data for TSF compare" ],
);

%orbit_01_00381_def =
( NAME    => "OC_TSF_COMPARE14",
  ADDRESS => 0x0000000090066c00,
  NOTE    => "The oc_tsf_compare registers are used to compare trigger data note against a data pattern and an enable. The results of the comp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00381_flds
);


##########################################################################
#                                                                        #
#   OC_TSF_COMPARE15                                                     #
#                                                                        #
##########################################################################

%orbit_01_00382_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Enable bits for TSF compare" ],
   "EXPECTED_DATA"                => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data for TSF compare" ],
);

%orbit_01_00382_def =
( NAME    => "OC_TSF_COMPARE15",
  ADDRESS => 0x0000000090066c80,
  NOTE    => "The oc_tsf_compare registers are used to compare trigger data note against a data pattern and an enable. The results of the comp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00382_flds
);


##########################################################################
#                                                                        #
#   OC_VEC_DATA                                                          #
#                                                                        #
##########################################################################

%orbit_01_00383_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data" ],
);

%orbit_01_00383_def =
( NAME    => "OC_VEC_DATA",
  ADDRESS => 0x0000000090067000,
  NOTE    => "The VEC_DATA register contains the value used for the data payload note when the Orbit generates a Vector Write Request (VWR) me",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00383_flds
);


##########################################################################
#                                                                        #
#   OC_VEC_PARMS                                                         #
#                                                                        #
##########################################################################

%orbit_01_00384_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "BUSY"                         => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Busy" ],
   "START"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Start" ],
   "RSVD0"                        => [   2,  46,  16, 0x3FFFC00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_ID"                       => [   3,  35,  11, 0x00003FF800000000, 0x00, 0, 0x0000000000000000, "PIO ID" ],
   "ADDRESS"                      => [   4,   3,  32, 0x00000007FFFFFFF8, 0x00, 0, 0x0000000000000000, "Address[37:6]" ],
   "RSVD1"                        => [   5,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_PORT"                      => [   6,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Network Interface Port Select" ],
   "TYPE"                         => [   7,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Vector Request Message Type" ],
);

%orbit_01_00384_def =
( NAME    => "OC_VEC_PARMS",
  ADDRESS => 0x0000000090067080,
  NOTE    => "The VEC_PARMS register controls various parameters associated with note the Orbit's generation of Vector Request messages (i.e.,",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00384_flds
);


##########################################################################
#                                                                        #
#   OC_VEC_ROUTE                                                         #
#                                                                        #
##########################################################################

%orbit_01_00385_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ROUTE"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Route" ],
);

%orbit_01_00385_def =
( NAME    => "OC_VEC_ROUTE",
  ADDRESS => 0x0000000090067100,
  NOTE    => "The VEC_ROUTE register contains the routing information for Orbit note generated Vector Read Request (VRD) or Vector Write Reque",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00385_flds
);


##########################################################################
#                                                                        #
#   OC_CPU_PERM0                                                         #
#                                                                        #
##########################################################################

%orbit_01_00386_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 63 - 0" ],
);

%orbit_01_00386_def =
( NAME    => "OC_CPU_PERM0",
  ADDRESS => 0x0000000090060000,
  NOTE    => "CPU MMR Access Permission Bits 63 - 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00386_flds
);


##########################################################################
#                                                                        #
#   OC_CPU_PERM1                                                         #
#                                                                        #
##########################################################################

%orbit_01_00387_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 127 - 64" ],
);

%orbit_01_00387_def =
( NAME    => "OC_CPU_PERM1",
  ADDRESS => 0x0000000090060080,
  NOTE    => "CPU MMR Access Permission Bits 127 - 64",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00387_flds
);


##########################################################################
#                                                                        #
#   OC_CPU_PERM2                                                         #
#                                                                        #
##########################################################################

%orbit_01_00388_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 191 - 128" ],
);

%orbit_01_00388_def =
( NAME    => "OC_CPU_PERM2",
  ADDRESS => 0x0000000090060100,
  NOTE    => "CPU MMR Access Permission Bits 191 - 128",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00388_flds
);


##########################################################################
#                                                                        #
#   OC_CPU_PERM3                                                         #
#                                                                        #
##########################################################################

%orbit_01_00389_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 255 - 192" ],
);

%orbit_01_00389_def =
( NAME    => "OC_CPU_PERM3",
  ADDRESS => 0x0000000090060180,
  NOTE    => "CPU MMR Access Permission Bits 255 - 192",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00389_flds
);


##########################################################################
#                                                                        #
#   OC_CPU_PERM_OVR                                                      #
#                                                                        #
##########################################################################

%orbit_01_00390_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "OVERRIDE"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Override" ],
);

%orbit_01_00390_def =
( NAME    => "OC_CPU_PERM_OVR",
  ADDRESS => 0x0000000090060200,
  NOTE    => "A write to this register of the 64-bit value 'SGIrules' note (0x5347_4972_756C_6573) will cause the bit in the LB_CPU_PROTECT no",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00390_flds
);


##########################################################################
#                                                                        #
#   OC_EXT_IO_PERM0                                                      #
#                                                                        #
##########################################################################

%orbit_01_00391_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 63 - 0" ],
);

%orbit_01_00391_def =
( NAME    => "OC_EXT_IO_PERM0",
  ADDRESS => 0x0000000090060280,
  NOTE    => "External IO MMR Access Permission Bits 63 - 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00391_flds
);


##########################################################################
#                                                                        #
#   OC_EXT_IO_PERM1                                                      #
#                                                                        #
##########################################################################

%orbit_01_00392_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 127 - 64" ],
);

%orbit_01_00392_def =
( NAME    => "OC_EXT_IO_PERM1",
  ADDRESS => 0x0000000090060300,
  NOTE    => "External IO MMR Access Permission Bits 127 - 64",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00392_flds
);


##########################################################################
#                                                                        #
#   OC_EXT_IO_PERM2                                                      #
#                                                                        #
##########################################################################

%orbit_01_00393_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 191 - 128" ],
);

%orbit_01_00393_def =
( NAME    => "OC_EXT_IO_PERM2",
  ADDRESS => 0x0000000090060380,
  NOTE    => "External IO MMR Access Permission Bits 191 - 128",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00393_flds
);


##########################################################################
#                                                                        #
#   OC_EXT_IO_PERM3                                                      #
#                                                                        #
##########################################################################

%orbit_01_00394_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 255 - 192" ],
);

%orbit_01_00394_def =
( NAME    => "OC_EXT_IO_PERM3",
  ADDRESS => 0x0000000090060400,
  NOTE    => "External IO MMR Access Permission Bits 255 - 192",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00394_flds
);


##########################################################################
#                                                                        #
#   OC_EXT_IOI_ACCESS0                                                   #
#                                                                        #
##########################################################################

%orbit_01_00395_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 63 - 0" ],
);

%orbit_01_00395_def =
( NAME    => "OC_EXT_IOI_ACCESS0",
  ADDRESS => 0x0000000090060480,
  NOTE    => "External IO Interrupt Access Permission Bits 63 - 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00395_flds
);


##########################################################################
#                                                                        #
#   OC_EXT_IOI_ACCESS1                                                   #
#                                                                        #
##########################################################################

%orbit_01_00396_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 127 - 64" ],
);

%orbit_01_00396_def =
( NAME    => "OC_EXT_IOI_ACCESS1",
  ADDRESS => 0x0000000090060500,
  NOTE    => "External IO Interrupt Access Permission Bits 127 - 64",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00396_flds
);


##########################################################################
#                                                                        #
#   OC_EXT_IOI_ACCESS2                                                   #
#                                                                        #
##########################################################################

%orbit_01_00397_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 191 - 128" ],
);

%orbit_01_00397_def =
( NAME    => "OC_EXT_IOI_ACCESS2",
  ADDRESS => 0x0000000090060580,
  NOTE    => "External IO Interrupt Access Permission Bits 191 - 128",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00397_flds
);


##########################################################################
#                                                                        #
#   OC_EXT_IOI_ACCESS3                                                   #
#                                                                        #
##########################################################################

%orbit_01_00398_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 255 - 192" ],
);

%orbit_01_00398_def =
( NAME    => "OC_EXT_IOI_ACCESS3",
  ADDRESS => 0x0000000090060600,
  NOTE    => "External IO Interrupt Access Permission Bits 255 - 192",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00398_flds
);


##########################################################################
#                                                                        #
#   OC_GC_FIL_CTRL                                                       #
#                                                                        #
##########################################################################

%orbit_01_00399_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  58,   6, 0xFC00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERROR_COUNTER"                => [   1,  48,  10, 0x03FF000000000000, 0x00, 1, 0x0000000000000000, "Error counter" ],
   "RSVD1"                        => [   2,  46,   2, 0x0000C00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DROPOUT_THRESH"               => [   3,  36,  10, 0x00003FF000000000, 0x00, 1, 0x0000000000000000, "Dropout threshold" ],
   "RSVD2"                        => [   4,  34,   2, 0x0000000C00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DROPOUT_COUNTER"              => [   5,  24,  10, 0x00000003FF000000, 0x00, 1, 0x0000000000000000, "Dropout Counter" ],
   "RSVD3"                        => [   6,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MASK_ENABLE"                  => [   7,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "Mask Enable" ],
   "MASK_COUNTER"                 => [   8,   8,  12, 0x00000000000FFF00, 0x00, 1, 0x0000000000000000, "Mask Counter" ],
   "RSVD4"                        => [   9,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OFFSET"                       => [  10,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Offset" ],
);

%orbit_01_00399_def =
( NAME    => "OC_GC_FIL_CTRL",
  ADDRESS => 0x0000000090060680,
  NOTE    => "When the GC_SRC_CTRL register's SOURCE_SEL field is set to REMOTE_0 note or REMOTE_2, the Orbit receives its global clock from a",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00399_flds
);


##########################################################################
#                                                                        #
#   OC_GC_SRC_CTRL                                                       #
#                                                                        #
##########################################################################

%orbit_01_00400_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SOURCE_SEL"                   => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "Source select (0=ext., 1=Int., 2=ORBIT)" ],
   "RSVD1"                        => [   2,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TOGGLE_BIT"                   => [   3,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "Toggle bit" ],
   "RSVD2"                        => [   4,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNTER"                      => [   5,  16,  10, 0x0000000003FF0000, 0x00, 1, 0x0000000000000000, "Counter" ],
   "RSVD3"                        => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_COUNT"                    => [   7,   4,  10, 0x0000000000003FF0, 0x00, 1, 0x0000000000000000, "Max Count" ],
   "RSVD4"                        => [   8,   1,   3, 0x000000000000000E, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_COUNTER"               => [   9,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable Counter" ],
);

%orbit_01_00400_def =
( NAME    => "OC_GC_SRC_CTRL",
  ADDRESS => 0x0000000090060700,
  NOTE    => "The GC_SRC_CTRL register contains several parameters which note determine the source and period of the SN2 system's global clock",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00400_flds
);


##########################################################################
#                                                                        #
#   OC_HARD_RESET                                                        #
#                                                                        #
##########################################################################

%orbit_01_00401_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HARD_RESET"                   => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Hard Reset" ],
);

%orbit_01_00401_def =
( NAME    => "OC_HARD_RESET",
  ADDRESS => 0x0000000090060780,
  NOTE    => "Orbit Hard Reset",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00401_flds
);


##########################################################################
#                                                                        #
#   OC_IO_PERM0                                                          #
#                                                                        #
##########################################################################

%orbit_01_00402_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 63 - 0" ],
);

%orbit_01_00402_def =
( NAME    => "OC_IO_PERM0",
  ADDRESS => 0x0000000090060800,
  NOTE    => "II MMR Access Permission Bits 63 - 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00402_flds
);


##########################################################################
#                                                                        #
#   OC_IO_PERM1                                                          #
#                                                                        #
##########################################################################

%orbit_01_00403_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 127 - 64" ],
);

%orbit_01_00403_def =
( NAME    => "OC_IO_PERM1",
  ADDRESS => 0x0000000090060880,
  NOTE    => "II MMR Access Permission Bits 127 - 64",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00403_flds
);


##########################################################################
#                                                                        #
#   OC_IO_PERM2                                                          #
#                                                                        #
##########################################################################

%orbit_01_00404_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 191 - 128" ],
);

%orbit_01_00404_def =
( NAME    => "OC_IO_PERM2",
  ADDRESS => 0x0000000090060900,
  NOTE    => "II MMR Access Permission Bits 191 - 128",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00404_flds
);


##########################################################################
#                                                                        #
#   OC_IO_PERM3                                                          #
#                                                                        #
##########################################################################

%orbit_01_00405_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 255 - 192" ],
);

%orbit_01_00405_def =
( NAME    => "OC_IO_PERM3",
  ADDRESS => 0x0000000090060980,
  NOTE    => "II MMR Access Permission Bits 255 - 192",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00405_flds
);


##########################################################################
#                                                                        #
#   OC_IOI_ACCESS0                                                       #
#                                                                        #
##########################################################################

%orbit_01_00406_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 63 - 0" ],
);

%orbit_01_00406_def =
( NAME    => "OC_IOI_ACCESS0",
  ADDRESS => 0x0000000090060a00,
  NOTE    => "II Interrupt Access Permission Bits 63 - 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00406_flds
);


##########################################################################
#                                                                        #
#   OC_IOI_ACCESS1                                                       #
#                                                                        #
##########################################################################

%orbit_01_00407_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 127 - 64" ],
);

%orbit_01_00407_def =
( NAME    => "OC_IOI_ACCESS1",
  ADDRESS => 0x0000000090060a80,
  NOTE    => "II Interrupt Access Permission Bits 127 - 64",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00407_flds
);


##########################################################################
#                                                                        #
#   OC_IOI_ACCESS2                                                       #
#                                                                        #
##########################################################################

%orbit_01_00408_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 191 - 128" ],
);

%orbit_01_00408_def =
( NAME    => "OC_IOI_ACCESS2",
  ADDRESS => 0x0000000090060b00,
  NOTE    => "II Interrupt Access Permission Bits 191 - 128",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00408_flds
);


##########################################################################
#                                                                        #
#   OC_IOI_ACCESS3                                                       #
#                                                                        #
##########################################################################

%orbit_01_00409_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 255 - 192" ],
);

%orbit_01_00409_def =
( NAME    => "OC_IOI_ACCESS3",
  ADDRESS => 0x0000000090060b80,
  NOTE    => "II Interrupt Access Permission Bits 255 - 192",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00409_flds
);


##########################################################################
#                                                                        #
#   OC_IPI_ACCESS0                                                       #
#                                                                        #
##########################################################################

%orbit_01_00410_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 63 - 0" ],
);

%orbit_01_00410_def =
( NAME    => "OC_IPI_ACCESS0",
  ADDRESS => 0x0000000090060c00,
  NOTE    => "CPU interrupt Access Permission Bits 63 - 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00410_flds
);


##########################################################################
#                                                                        #
#   OC_IPI_ACCESS1                                                       #
#                                                                        #
##########################################################################

%orbit_01_00411_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 127 - 64" ],
);

%orbit_01_00411_def =
( NAME    => "OC_IPI_ACCESS1",
  ADDRESS => 0x0000000090060c80,
  NOTE    => "CPU interrupt Access Permission Bits 127 - 64",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00411_flds
);


##########################################################################
#                                                                        #
#   OC_IPI_ACCESS2                                                       #
#                                                                        #
##########################################################################

%orbit_01_00412_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 191 - 128" ],
);

%orbit_01_00412_def =
( NAME    => "OC_IPI_ACCESS2",
  ADDRESS => 0x0000000090060d00,
  NOTE    => "CPU interrupt Access Permission Bits 191 - 128",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00412_flds
);


##########################################################################
#                                                                        #
#   OC_IPI_ACCESS3                                                       #
#                                                                        #
##########################################################################

%orbit_01_00413_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 255 - 192" ],
);

%orbit_01_00413_def =
( NAME    => "OC_IPI_ACCESS3",
  ADDRESS => 0x0000000090060d80,
  NOTE    => "CPU interrupt Access Permission Bits 255 - 192",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00413_flds
);


##########################################################################
#                                                                        #
#   OC_JTAG_CONFIG                                                       #
#                                                                        #
##########################################################################

%orbit_01_00414_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  44,  20, 0xFFFFF00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ORB_CONFIG_AUX"               => [   1,  41,   3, 0x00000E0000000000, 0x00, 0, 0x0000000000000000, "Auxilary config bits" ],
   "WARM_FENCE_ENABLE"            => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "Warm reset fence enable" ],
   "JTAG_MCI_OVERRIDE"            => [   3,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "jtag_mci_override" ],
   "JTAG_MCI_TARGET"              => [   4,  25,  14, 0x0000007FFE000000, 0x00, 0, 0x0000000000000000, "jtag_mci_target" ],
   "JTAG_MCI_RESET_DELAY"         => [   5,  21,   4, 0x0000000001E00000, 0x00, 0, 0x0000000000000000, "jtag_mci_reset_delay" ],
   "WRT90_OVERRIDE"               => [   6,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "wrt90_override" ],
   "WRT90_OVERRIDER"              => [   7,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "wrt90_overrideR" ],
   "WRT90_TARGET"                 => [   8,   5,  14, 0x000000000007FFE0, 0x00, 0, 0x0000000000000000, "wrt90_target" ],
   "II_CLK_SEL"                   => [   9,   3,   2, 0x0000000000000018, 0x00, 0, 0x0000000000000000, "Selects clock source for IOCLK domain" ],
   "NI_CLK_SEL"                   => [  10,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Selects clock source for NICLK domain" ],
   "MD_CLK_SEL"                   => [  11,   0,   2, 0x0000000000000003, 0x00, 0, 0x0000000000000000, "Select divide freq of DRAMCLK" ],
);

%orbit_01_00414_def =
( NAME    => "OC_JTAG_CONFIG",
  ADDRESS => 0x0000000090060e00,
  NOTE    => "The oc_jtag_config register contains a copy of the JTAG note configuration bits. These bits are loaded by JTAG before clock note",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00414_flds
);


##########################################################################
#                                                                        #
#   OC_ORBIT_ID                                                          #
#                                                                        #
##########################################################################

%orbit_01_00415_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ICE_CHIPLET_ID"               => [   1,  59,   2, 0x1800000000000000, 0x00, 1, 0x0000000000000000, "Chiplet ID value for ICE chiplet" ],
   "SYSTEM_TYPE"                  => [   2,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "System type, 0 = SHub (SN2-IA), 1 = Orbit (SN2-MIPS)" ],
   "RSVD1"                        => [   3,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_PORT"                      => [   4,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI port of vector reference, 0 = NI0, 1 = NI1" ],
   "RSVD2"                        => [   5,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODES_PER_BIT"                => [   6,  48,   6, 0x003F000000000000, 0x00, 1, 0x0000000000000000, "Nodes Per Bit" ],
   "SHARING_MODE"                 => [   7,  46,   2, 0x0000C00000000000, 0x00, 1, 0x0000000000000000, "Sharing mode (Coherency Domain Size)" ],
   "NODE_ID"                      => [   8,  32,  14, 0x00003FFF00000000, 0x00, 1, 0x0000000000000000, "Node Identification" ],
   "REVISION"                     => [   9,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Revision" ],
   "PART_NUMBER"                  => [  10,  12,  16, 0x000000000FFFF000, 0x00, 0, 0x0000000000000000, "Part Number" ],
   "MANUFACTURER"                 => [  11,   1,  11, 0x0000000000000FFE, 0x00, 0, 0x0000000000000000, "Manufacturer" ],
   "FORCE1"                       => [  12,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Must be 1" ],
);

%orbit_01_00415_def =
( NAME    => "OC_ORBIT_ID",
  ADDRESS => 0x0000000090060e80,
  NOTE    => "Orbit ID Number",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00415_flds
);


##########################################################################
#                                                                        #
#   OC_ORBITS_PRESENT0                                                   #
#                                                                        #
##########################################################################

%orbit_01_00416_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ORBITS_PRESENT0"              => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Orbits 0 - 63 Present configuration" ],
);

%orbit_01_00416_def =
( NAME    => "OC_ORBITS_PRESENT0",
  ADDRESS => 0x0000000090060f00,
  NOTE    => "Orbits 0 - 63 Present. Used for invalidate generation",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00416_flds
);


##########################################################################
#                                                                        #
#   OC_ORBITS_PRESENT1                                                   #
#                                                                        #
##########################################################################

%orbit_01_00417_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ORBITS_PRESENT1"              => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Orbits 64 - 127 Present configuration" ],
);

%orbit_01_00417_def =
( NAME    => "OC_ORBITS_PRESENT1",
  ADDRESS => 0x0000000090060f80,
  NOTE    => "Orbits 64 - 127 Present. Used for invalidate generation",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00417_flds
);


##########################################################################
#                                                                        #
#   OC_ORBITS_PRESENT2                                                   #
#                                                                        #
##########################################################################

%orbit_01_00418_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ORBITS_PRESENT2"              => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Orbits 128 - 191 Present configuration" ],
);

%orbit_01_00418_def =
( NAME    => "OC_ORBITS_PRESENT2",
  ADDRESS => 0x0000000090061000,
  NOTE    => "Orbits 128 - 191 Present. Used for invalidate generation",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00418_flds
);


##########################################################################
#                                                                        #
#   OC_ORBITS_PRESENT3                                                   #
#                                                                        #
##########################################################################

%orbit_01_00419_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ORBITS_PRESENT3"              => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Orbits 192 - 255 Present configuration" ],
);

%orbit_01_00419_def =
( NAME    => "OC_ORBITS_PRESENT3",
  ADDRESS => 0x0000000090061080,
  NOTE    => "Orbits 192 - 255 Present. Used for invalidate generation",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00419_flds
);


##########################################################################
#                                                                        #
#   OC_SOFT_RESET                                                        #
#                                                                        #
##########################################################################

%orbit_01_00420_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SOFT_RESET"                   => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Soft Reset" ],
);

%orbit_01_00420_def =
( NAME    => "OC_SOFT_RESET",
  ADDRESS => 0x0000000090061100,
  NOTE    => "Orbit Soft Reset",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00420_flds
);


##########################################################################
#                                                                        #
#   OC_NODE_PRESENT_TABLE                                                #
#                                                                        #
##########################################################################

%orbit_01_00421_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NODES"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Nodes Present" ],
);

%orbit_01_00421_def =
( NAME    => "OC_NODE_PRESENT_TABLE",
  ADDRESS => 0x0000000090061400,
  NOTE    => "The node_present_table is a bit map of all of the nodes present in note the entire system. The bits are stored in an array, 64 b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00421_flds
);


##########################################################################
#                                                                        #
#   OC_THROTTLE_INTERVAL                                                 #
#                                                                        #
##########################################################################

%orbit_01_00422_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RESET"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reset Throttle Counter" ],
   "RSVD0"                        => [   1,  30,  33, 0x7FFFFFFFC0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   2,   0,  30, 0x000000003FFFFFFF, 0x00, 1, 0x0000000000000000, "Throttle Interval" ],
);

%orbit_01_00422_def =
( NAME    => "OC_THROTTLE_INTERVAL",
  ADDRESS => 0x0000000090068000,
  NOTE    => "Throttle Interval",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00422_flds
);


##########################################################################
#                                                                        #
#   OC_THROTTLE_TIME                                                     #
#                                                                        #
##########################################################################

%orbit_01_00423_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  30,  34, 0xFFFFFFFFC0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  30, 0x000000003FFFFFFF, 0x00, 1, 0x0000000000000000, "Throttle Time" ],
);

%orbit_01_00423_def =
( NAME    => "OC_THROTTLE_TIME",
  ADDRESS => 0x0000000090068080,
  NOTE    => "Throttle Time",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00423_flds
);


##########################################################################
#                                                                        #
#   OC_THROTTLE_ENABLE                                                   #
#                                                                        #
##########################################################################

%orbit_01_00424_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   4,  60, 0xFFFFFFFFFFFFFFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN"                           => [   1,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Enable Throttling on XN Port" ],
   "IILB"                         => [   2,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Enable Throttling on IILB Port" ],
   "MD"                           => [   3,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Enable Throttling on MD Port" ],
   "PI"                           => [   4,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable Throttling on PI Port" ],
);

%orbit_01_00424_def =
( NAME    => "OC_THROTTLE_ENABLE",
  ADDRESS => 0x0000000090068100,
  NOTE    => "Throttle Enable",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00424_flds
);


##########################################################################
#                                                                        #
#   OC_FIRST_ERROR                                                       #
#                                                                        #
##########################################################################

%orbit_01_00425_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  19,  45, 0xFFFFFFFFFFF80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIRST_ERROR"                  => [   1,   0,  19, 0x000000000007FFFF, 0x00, 0, 0x0000000000000000, "First Error Flags" ],
);

%orbit_01_00425_def =
( NAME    => "OC_FIRST_ERROR",
  ADDRESS => 0x0000000090071000,
  NOTE    => "The oc_first_error register is the top-level error register for the note Orbit. The oc_first_error register indicates which erro",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00425_flds
);


##########################################################################
#                                                                        #
#   OC_PI_HW_INT_TIME_STAMP                                              #
#                                                                        #
##########################################################################

%orbit_01_00426_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "PI hardware interrupt time stamp valid" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "PI hardware interrupt time stamp" ],
);

%orbit_01_00426_def =
( NAME    => "OC_PI_HW_INT_TIME_STAMP",
  ADDRESS => 0x0000000090071080,
  NOTE    => "The oc_pi_hw_int_time_stamp register stores the time stamp of the note first hardware interrupt detected by the PI chiplet.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00426_flds
);


##########################################################################
#                                                                        #
#   OC_PI_CE_INT_TIME_STAMP                                              #
#                                                                        #
##########################################################################

%orbit_01_00427_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "PI correctable data error interrupt time stamp valid" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "PI correctable data error interrupt time stamp" ],
);

%orbit_01_00427_def =
( NAME    => "OC_PI_CE_INT_TIME_STAMP",
  ADDRESS => 0x0000000090071100,
  NOTE    => "The oc_pi_ce_int_time_stamp register holds the time stamp for the note first PI correctable data error interrupt from the pi chi",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00427_flds
);


##########################################################################
#                                                                        #
#   OC_PI_RE_INT_TIME_STAMP                                              #
#                                                                        #
##########################################################################

%orbit_01_00428_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "PI recoverable interrupt time stamp valid" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "PI recoverable interrupt time stamp" ],
);

%orbit_01_00428_def =
( NAME    => "OC_PI_RE_INT_TIME_STAMP",
  ADDRESS => 0x0000000090071180,
  NOTE    => "The oc_pi_re_int_time_stamp register holds the time stamp for the note first PI correctable data error interrupt from the pi chi",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00428_flds
);


##########################################################################
#                                                                        #
#   OC_PI_NRE_INT_TIME_STAMP                                             #
#                                                                        #
##########################################################################

%orbit_01_00429_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "PI non-recoverable hardware error interrupt time stamp valid" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "PI non-recoverable hardware error interrupt time stamp" ],
);

%orbit_01_00429_def =
( NAME    => "OC_PI_NRE_INT_TIME_STAMP",
  ADDRESS => 0x0000000090071200,
  NOTE    => "The oc_pi_nre_int_time_stamp register stores the time stamp of the note first non-recoverable hardware error interrupt detected ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00429_flds
);


##########################################################################
#                                                                        #
#   OC_PI_UCE_INT_TIME_STAMP                                             #
#                                                                        #
##########################################################################

%orbit_01_00430_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "PI hardware uncorrectable data time stamp valid" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "PI uncorrectable data interrupt time stamp" ],
);

%orbit_01_00430_def =
( NAME    => "OC_PI_UCE_INT_TIME_STAMP",
  ADDRESS => 0x0000000090071280,
  NOTE    => "The oc_pi_uce_int_time_stamp register holds the time stamp for the note first PI uncorrectable data error interrupt from the pi ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00430_flds
);


##########################################################################
#                                                                        #
#   OC_MD_HW_INT_TIME_STAMP                                              #
#                                                                        #
##########################################################################

%orbit_01_00431_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "MD hardware interrupt time stamp valid" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "MD hardware interrupt time stamp" ],
);

%orbit_01_00431_def =
( NAME    => "OC_MD_HW_INT_TIME_STAMP",
  ADDRESS => 0x0000000090071300,
  NOTE    => "The oc_md_hw_int_time_stamp register stores the time stamp of the note first hardware interrupt detected by the MD chiplet.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00431_flds
);


##########################################################################
#                                                                        #
#   OC_MD_CE_INT_TIME_STAMP                                              #
#                                                                        #
##########################################################################

%orbit_01_00432_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "MD correctable data error interrupt time stamp valid" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "MD correctable data error interrupt time stamp" ],
);

%orbit_01_00432_def =
( NAME    => "OC_MD_CE_INT_TIME_STAMP",
  ADDRESS => 0x0000000090071380,
  NOTE    => "The oc_md_ce_int_time_stamp register holds the time stamp for the note first MD correctable data error interrupt from the md chi",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00432_flds
);


##########################################################################
#                                                                        #
#   OC_MD_RE_INT_TIME_STAMP                                              #
#                                                                        #
##########################################################################

%orbit_01_00433_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "MD recoverable interrupt time stamp valid" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "MD recoverable interrupt time stamp" ],
);

%orbit_01_00433_def =
( NAME    => "OC_MD_RE_INT_TIME_STAMP",
  ADDRESS => 0x0000000090071400,
  NOTE    => "The oc_md_re_int_time_stamp register holds the time stamp for the note first MD correctable data error interrupt from the md chi",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00433_flds
);


##########################################################################
#                                                                        #
#   OC_MD_NRE_INT_TIME_STAMP                                             #
#                                                                        #
##########################################################################

%orbit_01_00434_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "MD non-recoverable hardware error interrupt time stamp valid" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "MD non-recoverable hardware error interrupt time stamp" ],
);

%orbit_01_00434_def =
( NAME    => "OC_MD_NRE_INT_TIME_STAMP",
  ADDRESS => 0x0000000090071480,
  NOTE    => "The oc_md_nre_int_time_stamp register stores the time stamp of the note first non-recoverable hardware error interrupt detected ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00434_flds
);


##########################################################################
#                                                                        #
#   OC_MD_UCE_INT_TIME_STAMP                                             #
#                                                                        #
##########################################################################

%orbit_01_00435_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "MD uncorrectable data time stamp valid" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "MD uncorrectable data interrupt time stamp" ],
);

%orbit_01_00435_def =
( NAME    => "OC_MD_UCE_INT_TIME_STAMP",
  ADDRESS => 0x0000000090071500,
  NOTE    => "The oc_md_uce_int_time_stamp register holds the time stamp for the note first MD uncorrectable data error interrupt from the md ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00435_flds
);


##########################################################################
#                                                                        #
#   OC_XN_HW_INT_TIME_STAMP                                              #
#                                                                        #
##########################################################################

%orbit_01_00436_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "XN hardware interrupt time stamp valid" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "XN hardware interrupt time stamp" ],
);

%orbit_01_00436_def =
( NAME    => "OC_XN_HW_INT_TIME_STAMP",
  ADDRESS => 0x0000000090071580,
  NOTE    => "The oc_xn_hw_int_time_stamp register stores the time stamp of the note first hardware interrupt detected by the XN chiplet.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00436_flds
);


##########################################################################
#                                                                        #
#   OC_XN_CE_INT_TIME_STAMP                                              #
#                                                                        #
##########################################################################

%orbit_01_00437_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "XN correctable data error interrupt time stamp valid" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "XN correctable data error interrupt time stamp" ],
);

%orbit_01_00437_def =
( NAME    => "OC_XN_CE_INT_TIME_STAMP",
  ADDRESS => 0x0000000090071600,
  NOTE    => "The oc_xn_ce_int_time_stamp register holds the time stamp for the note first XN correctable data error interrupt from the xn chi",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00437_flds
);


##########################################################################
#                                                                        #
#   OC_XN_RE_INT_TIME_STAMP                                              #
#                                                                        #
##########################################################################

%orbit_01_00438_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "XN recoverable interrupt time stamp valid" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "XN recoverable interrupt time stamp" ],
);

%orbit_01_00438_def =
( NAME    => "OC_XN_RE_INT_TIME_STAMP",
  ADDRESS => 0x0000000090071680,
  NOTE    => "The oc_xn_re_int_time_stamp register holds the time stamp for the note first XN correctable data error interrupt from the xn chi",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00438_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NRE_INT_TIME_STAMP                                             #
#                                                                        #
##########################################################################

%orbit_01_00439_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "XN non-recoverable hardware error interrupt time stamp valid" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "XN non-recoverable hardware error interrupt time stamp" ],
);

%orbit_01_00439_def =
( NAME    => "OC_XN_NRE_INT_TIME_STAMP",
  ADDRESS => 0x0000000090071700,
  NOTE    => "The oc_xn_nre_int_time_stamp register stores the time stamp of the note first non-recoverable hardware error interrupt detected ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00439_flds
);


##########################################################################
#                                                                        #
#   OC_XN_UCE_INT_TIME_STAMP                                             #
#                                                                        #
##########################################################################

%orbit_01_00440_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "XN hardware uncorrectable data time stamp valid" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "XN uncorrectable data interrupt time stamp" ],
);

%orbit_01_00440_def =
( NAME    => "OC_XN_UCE_INT_TIME_STAMP",
  ADDRESS => 0x0000000090071780,
  NOTE    => "The oc_xn_uce_int_time_stamp register holds the time stamp for the note first XN uncorrectable data error interrupt from the xn ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00440_flds
);


##########################################################################
#                                                                        #
#   OC_LB_HW_INT_TIME_STAMP                                              #
#                                                                        #
##########################################################################

%orbit_01_00441_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "LB hardware interrupt time stamp valid" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "LB hardware interrupt time stamp" ],
);

%orbit_01_00441_def =
( NAME    => "OC_LB_HW_INT_TIME_STAMP",
  ADDRESS => 0x0000000090071800,
  NOTE    => "The oc_lb_hw_int_time_stamp register stores the time stamp of the note first hardware interrupt detected by the LB chiplet.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00441_flds
);


##########################################################################
#                                                                        #
#   OC_II_HW_INT_TIME_STAMP                                              #
#                                                                        #
##########################################################################

%orbit_01_00442_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "II hardware interrupt time stamp valid" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "II hardware interrupt time stamp" ],
);

%orbit_01_00442_def =
( NAME    => "OC_II_HW_INT_TIME_STAMP",
  ADDRESS => 0x0000000090071880,
  NOTE    => "The oc_ii_hw_int_time_stamp register stores the time stamp of the note first hardware interrupt detected by the II chiplet.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00442_flds
);


##########################################################################
#                                                                        #
#   OC_II_RE_INT_TIME_STAMP                                              #
#                                                                        #
##########################################################################

%orbit_01_00443_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "II recoverable interrupt time stamp valid" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "II recoverable interrupt time stamp" ],
);

%orbit_01_00443_def =
( NAME    => "OC_II_RE_INT_TIME_STAMP",
  ADDRESS => 0x0000000090071900,
  NOTE    => "The oc_ii_re_int_time_stamp register holds the time stamp for the note first II correctable data error interrupt from the ii chi",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00443_flds
);


##########################################################################
#                                                                        #
#   OC_II_NRE_INT_TIME_STAMP                                             #
#                                                                        #
##########################################################################

%orbit_01_00444_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "II non-recoverable hardware error interrupt time stamp valid" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "II non-recoverable hardware error interrupt time stamp" ],
);

%orbit_01_00444_def =
( NAME    => "OC_II_NRE_INT_TIME_STAMP",
  ADDRESS => 0x0000000090071980,
  NOTE    => "The oc_ii_nre_int_time_stamp register stores the time stamp of the note first non-recoverable hardware error interrupt detected ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00444_flds
);


##########################################################################
#                                                                        #
#   OC_DEBUG_PORT                                                        #
#                                                                        #
##########################################################################

%orbit_01_00445_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_NIBBLE7"                => [   1,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Debug port nibble 7" ],
   "DEBUG_NIBBLE6"                => [   2,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "Debug port nibble 6" ],
   "DEBUG_NIBBLE5"                => [   3,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Debug port nibble 5" ],
   "DEBUG_NIBBLE4"                => [   4,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "Debug port nibble 4" ],
   "DEBUG_NIBBLE3"                => [   5,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Debug port nibble 3" ],
   "DEBUG_NIBBLE2"                => [   6,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Debug port nibble 2" ],
   "DEBUG_NIBBLE1"                => [   7,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Debug port nibble 1" ],
   "DEBUG_NIBBLE0"                => [   8,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Debug port nibble 0" ],
);

%orbit_01_00445_def =
( NAME    => "OC_DEBUG_PORT",
  ADDRESS => 0x0000000090072000,
  NOTE    => "The oc_debug_port register is a copy of the data being sent to the note debug output port.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00445_flds
);


##########################################################################
#                                                                        #
#   OC_II_DEBUG_DATA                                                     #
#                                                                        #
##########################################################################

%orbit_01_00446_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "II_DATA"                      => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "II debug data" ],
);

%orbit_01_00446_def =
( NAME    => "OC_II_DEBUG_DATA",
  ADDRESS => 0x0000000090072080,
  NOTE    => "The oc_ii_debug_data register contains a copy of the debug data note being sent from the II to the LB.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00446_flds
);


##########################################################################
#                                                                        #
#   OC_II_WRAP_DEBUG_DATA                                                #
#                                                                        #
##########################################################################

%orbit_01_00447_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "II_WRAP_DATA"                 => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "II wrapper debug data" ],
);

%orbit_01_00447_def =
( NAME    => "OC_II_WRAP_DEBUG_DATA",
  ADDRESS => 0x0000000090072100,
  NOTE    => "The ii_wrap_debug_data register contains a copy of the debug data note being sent from the II wrapper to the LB.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00447_flds
);


##########################################################################
#                                                                        #
#   OC_LB_DEBUG_DATA                                                     #
#                                                                        #
##########################################################################

%orbit_01_00448_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LB_DATA"                      => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "LB debug data" ],
);

%orbit_01_00448_def =
( NAME    => "OC_LB_DEBUG_DATA",
  ADDRESS => 0x0000000090072180,
  NOTE    => "The lb_debug_data register contains a copy of the debug data being note sent from the LB to the top level Orbit debug mux.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00448_flds
);


##########################################################################
#                                                                        #
#   OC_MD_DEBUG_DATA                                                     #
#                                                                        #
##########################################################################

%orbit_01_00449_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MD_DATA"                      => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "MD debug data" ],
);

%orbit_01_00449_def =
( NAME    => "OC_MD_DEBUG_DATA",
  ADDRESS => 0x0000000090072200,
  NOTE    => "The oc_md_debug_data register contains a copy of the debug data note being sent from the MD to the LB.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00449_flds
);


##########################################################################
#                                                                        #
#   OC_PI_DEBUG_DATA                                                     #
#                                                                        #
##########################################################################

%orbit_01_00450_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PI_DATA"                      => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "PI Debug Data" ],
);

%orbit_01_00450_def =
( NAME    => "OC_PI_DEBUG_DATA",
  ADDRESS => 0x0000000090072280,
  NOTE    => "The oc_pi_debug_data register contains a copy of the debug data note being sent from the PI to the LB.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00450_flds
);


##########################################################################
#                                                                        #
#   OC_XN_DEBUG_DATA                                                     #
#                                                                        #
##########################################################################

%orbit_01_00451_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_DATA"                      => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "XN debug data" ],
);

%orbit_01_00451_def =
( NAME    => "OC_XN_DEBUG_DATA",
  ADDRESS => 0x0000000090072300,
  NOTE    => "The oc_xn_debug_data register contains a copy of the debug data note being sent from the XN to the LB.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00451_flds
);


##########################################################################
#                                                                        #
#   OC_OB_LA_STATUS                                                      #
#                                                                        #
##########################################################################

%orbit_01_00452_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  40,  24, 0xFFFFFF0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BUFFER_ADDR"                  => [   1,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Buffer Address" ],
   "RSVD1"                        => [   2,  17,  15, 0x00000000FFFE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RECORD"                       => [   3,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Buffer Recording On" ],
   "NCWRF"                        => [   4,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "Outstanding NCWRF Count" ],
);

%orbit_01_00452_def =
( NAME    => "OC_OB_LA_STATUS",
  ADDRESS => 0x0000000090072800,
  NOTE    => "The OB_LA_STATUS register contains the status of the on board logic note analyzer buffer.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00452_flds
);


##########################################################################
#                                                                        #
#   OC_OB_LA_SEQUENCE                                                    #
#                                                                        #
##########################################################################

%orbit_01_00453_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RTC"                          => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 1, 0x0000000000000000, "RTC Count" ],
   "SEQUENCE"                     => [   1,   0,   9, 0x00000000000001FF, 0x00, 1, 0x0000000000000000, "Current Sequence Number" ],
);

%orbit_01_00453_def =
( NAME    => "OC_OB_LA_SEQUENCE",
  ADDRESS => 0x0000000090072880,
  NOTE    => "The OB_LA_SEQUENCE register contains the sequence number of the note last cache line saved in the logic analyzer buffer.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00453_flds
);


##########################################################################
#                                                                        #
#   OC_OB_LA_CURRENT_ADDR                                                #
#                                                                        #
##########################################################################

%orbit_01_00454_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDRESS"                      => [   1,   7,  31, 0x0000003FFFFFFF80, 0x00, 1, 0x0000000000000000, "Current Memory Address" ],
);

%orbit_01_00454_def =
( NAME    => "OC_OB_LA_CURRENT_ADDR",
  ADDRESS => 0x0000000090072900,
  NOTE    => "The OB_LA_CURRENT_ADDR register contains the current memory address note for the on board logic analyzer buffer.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00454_flds
);


##########################################################################
#                                                                        #
#   OC_TSF_ARMED_STATE                                                   #
#                                                                        #
##########################################################################

%orbit_01_00455_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STATE"                        => [   1,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility armed state" ],
);

%orbit_01_00455_def =
( NAME    => "OC_TSF_ARMED_STATE",
  ADDRESS => 0x0000000090073000,
  NOTE    => "The oc_tsf_armed_state MMR contains the armed state for each of the note trigger sequencing variables. Bit 0 is the armed state ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00455_flds
);


##########################################################################
#                                                                        #
#   OC_TSF_COUNTER_VALUE                                                 #
#                                                                        #
##########################################################################

%orbit_01_00456_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COUNT_8A"                     => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 8a" ],
   "COUNT_8B"                     => [   1,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 8b" ],
   "COUNT_16"                     => [   2,  32,  16, 0x0000FFFF00000000, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 16" ],
   "COUNT_32"                     => [   3,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 32" ],
);

%orbit_01_00456_def =
( NAME    => "OC_TSF_COUNTER_VALUE",
  ADDRESS => 0x0000000090073080,
  NOTE    => "The oc_tsf_counter_value register contains the counter values of note the trigger sequencing down counters. These counters are l",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00456_flds
);


##########################################################################
#                                                                        #
#   OC_TSF_TRIGGERED_STATE                                               #
#                                                                        #
##########################################################################

%orbit_01_00457_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STATE"                        => [   1,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility triggered state" ],
);

%orbit_01_00457_def =
( NAME    => "OC_TSF_TRIGGERED_STATE",
  ADDRESS => 0x0000000090073100,
  NOTE    => "The oc_tsf_triggered_state contains the triggered state for each of note the trigger sequencing variables. Bit 0 is the triggere",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00457_flds
);


##########################################################################
#                                                                        #
#   OC_VEC_RDDATA                                                        #
#                                                                        #
##########################################################################

%orbit_01_00458_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data" ],
);

%orbit_01_00458_def =
( NAME    => "OC_VEC_RDDATA",
  ADDRESS => 0x0000000090074000,
  NOTE    => "This register contains the vector PIO read data, if any. The LB note will not modify this register's value if an incoming reply ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00458_flds
);


##########################################################################
#                                                                        #
#   OC_VEC_RETURN                                                        #
#                                                                        #
##########################################################################

%orbit_01_00459_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ROUTE"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Route" ],
);

%orbit_01_00459_def =
( NAME    => "OC_VEC_RETURN",
  ADDRESS => 0x0000000090074080,
  NOTE    => "This register contains the return vector PIO route. The LB will not note modify this register's value if an incoming reply packe",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00459_flds
);


##########################################################################
#                                                                        #
#   OC_VEC_STATUS                                                        #
#                                                                        #
##########################################################################

%orbit_01_00460_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATUS_VALID"                 => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Status_Valid" ],
   "OVERRUN"                      => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Overrun" ],
   "SOURCE"                       => [   2,  46,  16, 0x3FFFC00000000000, 0x00, 0, 0x0000000000000000, "Source" ],
   "PIO_ID"                       => [   3,  35,  11, 0x00003FF800000000, 0x00, 0, 0x0000000000000000, "PIO ID" ],
   "ADDRESS"                      => [   4,   3,  32, 0x00000007FFFFFFF8, 0x00, 0, 0x0000000000000000, "Address" ],
   "TYPE"                         => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Type" ],
);

%orbit_01_00460_def =
( NAME    => "OC_VEC_STATUS",
  ADDRESS => 0x0000000090074100,
  NOTE    => "This register contains the vector PIO return status. Software note should clear this register before launching a vector PIO requ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00460_flds
);


##########################################################################
#                                                                        #
#   OC_VEC_STATUS_ALIAS                                                  #
#                                                                        #
##########################################################################

%orbit_01_00461_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATUS_VALID"                 => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Status_Valid" ],
   "OVERRUN"                      => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Overrun" ],
   "SOURCE"                       => [   2,  46,  16, 0x3FFFC00000000000, 0x00, 0, 0x0000000000000000, "Source" ],
   "PIO_ID"                       => [   3,  35,  11, 0x00003FF800000000, 0x00, 0, 0x0000000000000000, "PIO ID" ],
   "ADDRESS"                      => [   4,   3,  32, 0x00000007FFFFFFF8, 0x00, 0, 0x0000000000000000, "Address" ],
   "TYPE"                         => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Type" ],
);

%orbit_01_00461_def =
( NAME    => "OC_VEC_STATUS_ALIAS",
  ADDRESS => 0x0000000090074108,
  NOTE    => "The VEC_STATUS_ALIAS is the alias address for the VEC_STATUS note registers. Refer to the VEC_STATUS description and its note AL",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00461_flds
);


##########################################################################
#                                                                        #
#   OC_LOGIC_ANALYZER_BUFFER                                             #
#                                                                        #
##########################################################################

%orbit_01_00462_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Logic Analyzer Data" ],
);

%orbit_01_00462_def =
( NAME    => "OC_LOGIC_ANALYZER_BUFFER",
  ADDRESS => 0x0000000090075000,
  NOTE    => "The logic_analyzer_buffer is a 64 bit by 256 word deep buffer for note the on-board logic analzyer. When enabled, debug port dat",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00462_flds
);


##########################################################################
#                                                                        #
#   OC_THROTTLE_STATUS                                                   #
#                                                                        #
##########################################################################

%orbit_01_00463_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIME"                         => [   1,  32,  30, 0x3FFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Current throttle time count" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INTERVAL"                     => [   3,   0,  30, 0x000000003FFFFFFF, 0x00, 0, 0x0000000000000000, "Current throttle interval count" ],
);

%orbit_01_00463_def =
( NAME    => "OC_THROTTLE_STATUS",
  ADDRESS => 0x0000000090077000,
  NOTE    => "The oc_throttle_status register contains the counter values of the note throttle interval counter and throttle time counter.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00463_flds
);


##########################################################################
#                                                                        #
#   OC_PERFORMANCE_COUNT0_CONTROL                                        #
#                                                                        #
##########################################################################

%orbit_01_00464_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CLR_ENABLE"                   => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Counter 0 enable clear" ],
   "CLR_MODE"                     => [   2,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Counter 0 clear mode select (1-internal, 0-external)" ],
   "CLR_POLARITY"                 => [   3,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Counter 0 clear polarity select (1-negative edge, 0-positive edge)" ],
   "CLR_EVENT"                    => [   4,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Counter 0 clear format select (1-level, 0-edge)" ],
   "CLR_STIMULUS"                 => [   5,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "Counter 0 clear stimulus" ],
   "RSVD1"                        => [   6,  19,   5, 0x0000000000F80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Counter 0 enable peak detection" ],
   "DEC_ENABLE"                   => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Counter 0 enable decrement" ],
   "INC_ENABLE"                   => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Counter 0 enable increment" ],
   "DN_MODE"                      => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Counter 0 down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Counter 0 down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Counter 0 down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "Counter 0 down stimulus" ],
   "UP_MODE"                      => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Counter 0 up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Counter 0 up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Counter 0 up format select (1-level, 0-edge)" ],
   "UP_STIMULUS"                  => [  17,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter 0 up stimulus" ],
);

%orbit_01_00464_def =
( NAME    => "OC_PERFORMANCE_COUNT0_CONTROL",
  ADDRESS => 0x0000000090080000,
  NOTE    => "The oc_performance_count0_control register controls the note incrementing and decrementing of event counter 0.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00464_flds
);


##########################################################################
#                                                                        #
#   OC_PERFORMANCE_COUNT1_CONTROL                                        #
#                                                                        #
##########################################################################

%orbit_01_00465_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CLR_ENABLE"                   => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Counter 1 enable clear" ],
   "CLR_MODE"                     => [   2,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Counter 1 clear mode select (1-internal, 0-external)" ],
   "CLR_POLARITY"                 => [   3,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Counter 1 clear polarity select (1-negative edge, 0-positive edge)" ],
   "CLR_EVENT"                    => [   4,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Counter 1 clear format select (1-level, 0-edge)" ],
   "CLR_STIMULUS"                 => [   5,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "Counter 1 clear stimulus" ],
   "RSVD1"                        => [   6,  19,   5, 0x0000000000F80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Counter 1 enable peak detection" ],
   "DEC_ENABLE"                   => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Counter 1 enable decrement" ],
   "INC_ENABLE"                   => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Counter 1 enable increment" ],
   "DN_MODE"                      => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Counter 1 down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Counter 1 down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Counter 1 down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "Counter 1 down stimulus" ],
   "UP_MODE"                      => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Counter 1 up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Counter 1 up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Counter 1 up format select (1-level, 0-edge)" ],
   "UP_STIMULUS"                  => [  17,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter 1 up stimulus" ],
);

%orbit_01_00465_def =
( NAME    => "OC_PERFORMANCE_COUNT1_CONTROL",
  ADDRESS => 0x0000000090090000,
  NOTE    => "The oc_performance_count1_control register controls the note incrementing and decrementing of event counter 1.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00465_flds
);


##########################################################################
#                                                                        #
#   OC_PERFORMANCE_COUNT2_CONTROL                                        #
#                                                                        #
##########################################################################

%orbit_01_00466_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CLR_ENABLE"                   => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Counter 2 enable clear" ],
   "CLR_MODE"                     => [   2,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Counter 2 clear mode select (1-internal, 0-external)" ],
   "CLR_POLARITY"                 => [   3,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Counter 2 clear polarity select (1-negative edge, 0-positive edge)" ],
   "CLR_EVENT"                    => [   4,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Counter 2 clear format select (1-level, 0-edge)" ],
   "CLR_STIMULUS"                 => [   5,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "Counter 2 clear stimulus" ],
   "RSVD1"                        => [   6,  19,   5, 0x0000000000F80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Counter 2 enable peak detection" ],
   "DEC_ENABLE"                   => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Counter 2 enable decrement" ],
   "INC_ENABLE"                   => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Counter 2 enable increment" ],
   "DN_MODE"                      => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Counter 2 down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Counter 2 down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Counter 2 down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "Counter 2 down stimulus" ],
   "UP_MODE"                      => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Counter 2 up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Counter 2 up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Counter 2 up format select (1-level 0-edge)" ],
   "UP_STIMULUS"                  => [  17,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter 2 up stimulus" ],
);

%orbit_01_00466_def =
( NAME    => "OC_PERFORMANCE_COUNT2_CONTROL",
  ADDRESS => 0x00000000900a0000,
  NOTE    => "The oc_performance_count2_control register controls the note incrementing and decrementing of event counter 2.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00466_flds
);


##########################################################################
#                                                                        #
#   OC_PERFORMANCE_COUNT3_CONTROL                                        #
#                                                                        #
##########################################################################

%orbit_01_00467_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CLR_ENABLE"                   => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Counter 3 enable clear" ],
   "CLR_MODE"                     => [   2,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Counter 3 clear mode select (1-internal, 0-external)" ],
   "CLR_POLARITY"                 => [   3,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Counter 3 clear polarity select (1-negative edge, 0-positive edge)" ],
   "CLR_EVENT"                    => [   4,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Counter 3 clear format select (1-level, 0-edge)" ],
   "CLR_STIMULUS"                 => [   5,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "Counter 3 clear stimulus" ],
   "RSVD1"                        => [   6,  19,   5, 0x0000000000F80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Counter 3 enable peak detection" ],
   "DEC_ENABLE"                   => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Counter 3 enable decrement" ],
   "INC_ENABLE"                   => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Counter 3 enable increment" ],
   "DN_MODE"                      => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Counter 3 down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Counter 3 down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Counter 3 down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "Counter 3 down stimulus" ],
   "UP_MODE"                      => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Counter 3 up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Counter 3 up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Counter 3 up format select (1-level, 0-edge)" ],
   "UP_STIMULUS"                  => [  17,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter 3 up stimulus" ],
);

%orbit_01_00467_def =
( NAME    => "OC_PERFORMANCE_COUNT3_CONTROL",
  ADDRESS => 0x00000000900b0000,
  NOTE    => "The oc_performance_count3_control register controls the note incrementing and decrementing of event counter 3.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00467_flds
);


##########################################################################
#                                                                        #
#   OC_PERFORMANCE_COUNT4_CONTROL                                        #
#                                                                        #
##########################################################################

%orbit_01_00468_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CLR_ENABLE"                   => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Counter 4 enable clear" ],
   "CLR_MODE"                     => [   2,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Counter 4 clear mode select (1-internal, 0-external)" ],
   "CLR_POLARITY"                 => [   3,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Counter 4 clear polarity select (1-negative edge, 0-positive edge)" ],
   "CLR_EVENT"                    => [   4,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Counter 4 clear format select (1-level, 0-edge)" ],
   "CLR_STIMULUS"                 => [   5,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "Counter 4 clear stimulus" ],
   "RSVD1"                        => [   6,  19,   5, 0x0000000000F80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Counter 4 enable peak detection" ],
   "DEC_ENABLE"                   => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Counter 4 enable decrement" ],
   "INC_ENABLE"                   => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Counter 4 enable increment" ],
   "DN_MODE"                      => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Counter 4 down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Counter 4 down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Counter 4 down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "Counter 4 down stimulus" ],
   "UP_MODE"                      => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Counter 4 up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Counter 4 up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Counter 4 up format select (1-level, 0-edge)" ],
   "UP_STIMULUS"                  => [  17,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter 4 up stimulus" ],
);

%orbit_01_00468_def =
( NAME    => "OC_PERFORMANCE_COUNT4_CONTROL",
  ADDRESS => 0x00000000900c0000,
  NOTE    => "The oc_performance_count4_control register controls the note incrementing and decrementing of event counter 4.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00468_flds
);


##########################################################################
#                                                                        #
#   OC_PERFORMANCE_COUNT5_CONTROL                                        #
#                                                                        #
##########################################################################

%orbit_01_00469_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CLR_ENABLE"                   => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Counter 5 enable clear" ],
   "CLR_MODE"                     => [   2,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Counter 5 clear mode select (1-internal, 0-external)" ],
   "CLR_POLARITY"                 => [   3,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Counter 5 clear polarity select (1-negative edge, 0-positive edge)" ],
   "CLR_EVENT"                    => [   4,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Counter 5 clear format select (1-level, 0-edge)" ],
   "CLR_STIMULUS"                 => [   5,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "Counter 5 clear stimulus" ],
   "RSVD1"                        => [   6,  19,   5, 0x0000000000F80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Counter 5 enable peak detection" ],
   "DEC_ENABLE"                   => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Counter 5 enable decrement" ],
   "INC_ENABLE"                   => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Counter 5 enable increment" ],
   "DN_MODE"                      => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Counter 5 down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Counter 5 down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Counter 5 down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "Counter 5 down stimulus" ],
   "UP_MODE"                      => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Counter 5 up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Counter 5 up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Counter 5 up format select (1-level, 0-edge)" ],
   "UP_STIMULUS"                  => [  17,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter 5 up stimulus" ],
);

%orbit_01_00469_def =
( NAME    => "OC_PERFORMANCE_COUNT5_CONTROL",
  ADDRESS => 0x00000000900d0000,
  NOTE    => "The oc_performance_count5_control register controls the note incrementing and decrementing of event counter 5.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00469_flds
);


##########################################################################
#                                                                        #
#   OC_PERFORMANCE_COUNT6_CONTROL                                        #
#                                                                        #
##########################################################################

%orbit_01_00470_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CLR_ENABLE"                   => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Counter 6 enable clear" ],
   "CLR_MODE"                     => [   2,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Counter 6 clear mode select (1-internal, 0-external)" ],
   "CLR_POLARITY"                 => [   3,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Counter 6 clear polarity select (1-negative edge, 0-positive edge)" ],
   "CLR_EVENT"                    => [   4,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Counter 6 clear format select (1-level, 0-edge)" ],
   "CLR_STIMULUS"                 => [   5,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "Counter 6 clear stimulus" ],
   "RSVD1"                        => [   6,  19,   5, 0x0000000000F80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Counter 6 enable peak detection" ],
   "DEC_ENABLE"                   => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Counter 6 enable decrement" ],
   "INC_ENABLE"                   => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Counter 6 enable increment" ],
   "DN_MODE"                      => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Counter 6 down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Counter 6 down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Counter 6 down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "Counter 6 down stimulus" ],
   "UP_MODE"                      => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Counter 6 up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Counter 6 up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Counter 6 up format select (1-level, 0-edge)" ],
   "UP_STIMULUS"                  => [  17,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter 6 up stimulus" ],
);

%orbit_01_00470_def =
( NAME    => "OC_PERFORMANCE_COUNT6_CONTROL",
  ADDRESS => 0x00000000900e0000,
  NOTE    => "The oc_performance_count6_control register controls the note incrementing and decrementing of event counter 6.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00470_flds
);


##########################################################################
#                                                                        #
#   OC_PERFORMANCE_COUNT7_CONTROL                                        #
#                                                                        #
##########################################################################

%orbit_01_00471_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CLR_ENABLE"                   => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Counter 7 enable clear" ],
   "CLR_MODE"                     => [   2,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Counter 7 clear mode select (1-internal, 0-external)" ],
   "CLR_POLARITY"                 => [   3,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Counter 7 clear polarity select (1-negative edge, 0-positive edge)" ],
   "CLR_EVENT"                    => [   4,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Counter 7 clear format select (1-level, 0-edge)" ],
   "CLR_STIMULUS"                 => [   5,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "Counter 7 clear stimulus" ],
   "RSVD1"                        => [   6,  19,   5, 0x0000000000F80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Counter 7 enable peak detection" ],
   "DEC_ENABLE"                   => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Counter 7 enable decrement" ],
   "INC_ENABLE"                   => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Counter 7 enable increment" ],
   "DN_MODE"                      => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Counter 7 down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Counter 7 down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Counter 7 down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "Counter 7 down stimulus" ],
   "UP_MODE"                      => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Counter 7 up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Counter 7 up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Counter 7 up format select (1-level, 0-edge)" ],
   "UP_STIMULUS"                  => [  17,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter 7 up stimulus" ],
);

%orbit_01_00471_def =
( NAME    => "OC_PERFORMANCE_COUNT7_CONTROL",
  ADDRESS => 0x00000000900f0000,
  NOTE    => "The oc_performance_count7_control register controls the note incrementing and decrementing of event counter 7.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00471_flds
);


##########################################################################
#                                                                        #
#   OC_PROFILE_DN_CONTROL                                                #
#                                                                        #
##########################################################################

%orbit_01_00472_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MODE"                         => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Counter mode select (1-internal, 0-external)" ],
   "POLARITY"                     => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Polarity Control" ],
   "EVENT"                        => [   3,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Event Control" ],
   "STIMULUS"                     => [   4,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter stimulus" ],
);

%orbit_01_00472_def =
( NAME    => "OC_PROFILE_DN_CONTROL",
  ADDRESS => 0x0000000090100000,
  NOTE    => "The PROFILE_DN_CONTROL register controls the decrementing of the note Profile Counter.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00472_flds
);


##########################################################################
#                                                                        #
#   OC_PROFILE_PEAK_CONTROL                                              #
#                                                                        #
##########################################################################

%orbit_01_00473_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   7,  57, 0xFFFFFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "POLARITY"                     => [   1,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Polarity Control" ],
   "EVENT"                        => [   2,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Event Control" ],
   "RSVD1"                        => [   3,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STIMULUS"                     => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Counter stimulus" ],
);

%orbit_01_00473_def =
( NAME    => "OC_PROFILE_PEAK_CONTROL",
  ADDRESS => 0x0000000090100080,
  NOTE    => "The PROFILE_PEAK_CONTROL register controls the comparison test note performed between the PROFILE_PEAK register and the PROFILE_",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00473_flds
);


##########################################################################
#                                                                        #
#   OC_PROFILE_RANGE                                                     #
#                                                                        #
##########################################################################

%orbit_01_00474_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RANGE7"                       => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Profiling range 7" ],
   "RANGE6"                       => [   1,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "Profiling range 6" ],
   "RANGE5"                       => [   2,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "Profiling range 5" ],
   "RANGE4"                       => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Profiling range 4" ],
   "RANGE3"                       => [   4,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "Profiling range 3" ],
   "RANGE2"                       => [   5,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Profiling range 2" ],
   "RANGE1"                       => [   6,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "Profiling range 1" ],
   "RANGE0"                       => [   7,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Profiling range 0" ],
);

%orbit_01_00474_def =
( NAME    => "OC_PROFILE_RANGE",
  ADDRESS => 0x0000000090100100,
  NOTE    => "The PROFILE_RANGE register contains 8 reference values used for note comparison tests when the PROFILE_COUNT register is selecte",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00474_flds
);


##########################################################################
#                                                                        #
#   OC_PROFILE_UP_CONTROL                                                #
#                                                                        #
##########################################################################

%orbit_01_00475_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MODE"                         => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Mode Control" ],
   "POLARITY"                     => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Polarity Control" ],
   "EVENT"                        => [   3,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Event Control" ],
   "STIMULUS"                     => [   4,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter stimulus" ],
);

%orbit_01_00475_def =
( NAME    => "OC_PROFILE_UP_CONTROL",
  ADDRESS => 0x0000000090100180,
  NOTE    => "The PROFILE_UP_CONTROL register controls the incrementing of the note Profile Counter.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00475_flds
);


##########################################################################
#                                                                        #
#   OC_PERFORMANCE_MONITOR_DESKEW                                        #
#                                                                        #
##########################################################################

%orbit_01_00476_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "BIT_31_DELAY"                 => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 31" ],
   "BIT_30_DELAY"                 => [   1,  60,   2, 0x3000000000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 30" ],
   "BIT_29_DELAY"                 => [   2,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 29" ],
   "BIT_28_DELAY"                 => [   3,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 28" ],
   "BIT_27_DELAY"                 => [   4,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 27" ],
   "BIT_26_DELAY"                 => [   5,  52,   2, 0x0030000000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 26" ],
   "BIT_25_DELAY"                 => [   6,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 25" ],
   "BIT_24_DELAY"                 => [   7,  48,   2, 0x0003000000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 24" ],
   "BIT_23_DELAY"                 => [   8,  46,   2, 0x0000C00000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 23" ],
   "BIT_22_DELAY"                 => [   9,  44,   2, 0x0000300000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 22" ],
   "BIT_21_DELAY"                 => [  10,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 21" ],
   "BIT_20_DELAY"                 => [  11,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 20" ],
   "BIT_19_DELAY"                 => [  12,  38,   2, 0x000000C000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 19" ],
   "BIT_18_DELAY"                 => [  13,  36,   2, 0x0000003000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 18" ],
   "BIT_17_DELAY"                 => [  14,  34,   2, 0x0000000C00000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 17" ],
   "BIT_16_DELAY"                 => [  15,  32,   2, 0x0000000300000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 16" ],
   "BIT_15_DELAY"                 => [  16,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 15" ],
   "BIT_14_DELAY"                 => [  17,  28,   2, 0x0000000030000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 14" ],
   "BIT_13_DELAY"                 => [  18,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 13" ],
   "BIT_12_DELAY"                 => [  19,  24,   2, 0x0000000003000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 12" ],
   "BIT_11_DELAY"                 => [  20,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 11" ],
   "BIT_10_DELAY"                 => [  21,  20,   2, 0x0000000000300000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 10" ],
   "BIT_9_DELAY"                  => [  22,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 9" ],
   "BIT_8_DELAY"                  => [  23,  16,   2, 0x0000000000030000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 8" ],
   "BIT_7_DELAY"                  => [  24,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 7" ],
   "BIT_6_DELAY"                  => [  25,  12,   2, 0x0000000000003000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 6" ],
   "BIT_5_DELAY"                  => [  26,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 5" ],
   "BIT_4_DELAY"                  => [  27,   8,   2, 0x0000000000000300, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 4" ],
   "BIT_3_DELAY"                  => [  28,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 3" ],
   "BIT_2_DELAY"                  => [  29,   4,   2, 0x0000000000000030, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 2" ],
   "BIT_1_DELAY"                  => [  30,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 1" ],
   "BIT_0_DELAY"                  => [  31,   0,   2, 0x0000000000000003, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 0" ],
);

%orbit_01_00476_def =
( NAME    => "OC_PERFORMANCE_MONITOR_DESKEW",
  ADDRESS => 0x0000000090101000,
  NOTE    => "The oc_performance_monitor_deskew register controls the amount of note deskew on each of the debug data bits going to the perfor",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00476_flds
);


##########################################################################
#                                                                        #
#   OC_PERFORMANCE_COUNTER0                                              #
#                                                                        #
##########################################################################

%orbit_01_00477_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 0" ],
);

%orbit_01_00477_def =
( NAME    => "OC_PERFORMANCE_COUNTER0",
  ADDRESS => 0x0000000090110000,
  NOTE    => "The PERFORMANCE_COUNTER0 register is a status register containing note the current value of Performance Counter 0.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00477_flds
);


##########################################################################
#                                                                        #
#   OC_PERFORMANCE_COUNTER1                                              #
#                                                                        #
##########################################################################

%orbit_01_00478_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 1" ],
);

%orbit_01_00478_def =
( NAME    => "OC_PERFORMANCE_COUNTER1",
  ADDRESS => 0x0000000090120000,
  NOTE    => "The PERFORMANCE_COUNTER1 register is a status register containing note the current value of Performance Counter 1.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00478_flds
);


##########################################################################
#                                                                        #
#   OC_PERFORMANCE_COUNTER2                                              #
#                                                                        #
##########################################################################

%orbit_01_00479_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 2" ],
);

%orbit_01_00479_def =
( NAME    => "OC_PERFORMANCE_COUNTER2",
  ADDRESS => 0x0000000090130000,
  NOTE    => "The PERFORMANCE_COUNTER2 register is a status register containing note the current value of Performance Counter 2.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00479_flds
);


##########################################################################
#                                                                        #
#   OC_PERFORMANCE_COUNTER3                                              #
#                                                                        #
##########################################################################

%orbit_01_00480_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 3" ],
);

%orbit_01_00480_def =
( NAME    => "OC_PERFORMANCE_COUNTER3",
  ADDRESS => 0x0000000090140000,
  NOTE    => "The PERFORMANCE_COUNTER3 register is a status register containing note the current value of Performance Counter 3.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00480_flds
);


##########################################################################
#                                                                        #
#   OC_PERFORMANCE_COUNTER4                                              #
#                                                                        #
##########################################################################

%orbit_01_00481_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 4" ],
);

%orbit_01_00481_def =
( NAME    => "OC_PERFORMANCE_COUNTER4",
  ADDRESS => 0x0000000090150000,
  NOTE    => "The PERFORMANCE_COUNTER4 register is a status register containing note the current value of Performance Counter 4.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00481_flds
);


##########################################################################
#                                                                        #
#   OC_PERFORMANCE_COUNTER5                                              #
#                                                                        #
##########################################################################

%orbit_01_00482_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 5" ],
);

%orbit_01_00482_def =
( NAME    => "OC_PERFORMANCE_COUNTER5",
  ADDRESS => 0x0000000090160000,
  NOTE    => "The PERFORMANCE_COUNTER5 register is a status register containing note the current value of Performance Counter 5.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00482_flds
);


##########################################################################
#                                                                        #
#   OC_PERFORMANCE_COUNTER6                                              #
#                                                                        #
##########################################################################

%orbit_01_00483_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 6" ],
);

%orbit_01_00483_def =
( NAME    => "OC_PERFORMANCE_COUNTER6",
  ADDRESS => 0x0000000090170000,
  NOTE    => "The PERFORMANCE_COUNTER6 register is a status register containing note the current value of Performance Counter 6.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00483_flds
);


##########################################################################
#                                                                        #
#   OC_PERFORMANCE_COUNTER7                                              #
#                                                                        #
##########################################################################

%orbit_01_00484_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 7" ],
);

%orbit_01_00484_def =
( NAME    => "OC_PERFORMANCE_COUNTER7",
  ADDRESS => 0x0000000090180000,
  NOTE    => "The PERFORMANCE_COUNTER7 register is a status register containing note the current value of Performance Counter 7.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00484_flds
);


##########################################################################
#                                                                        #
#   OC_PROFILE_COUNTER                                                   #
#                                                                        #
##########################################################################

%orbit_01_00485_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNTER"                      => [   1,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Current Value of the Profile Counter" ],
);

%orbit_01_00485_def =
( NAME    => "OC_PROFILE_COUNTER",
  ADDRESS => 0x0000000090190000,
  NOTE    => "The PROFILE_COUNTER register contains the current value of the note Profile Counter.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00485_flds
);


##########################################################################
#                                                                        #
#   OC_PROFILE_PEAK                                                      #
#                                                                        #
##########################################################################

%orbit_01_00486_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNTER"                      => [   1,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Peak Value of the Profile Counter" ],
);

%orbit_01_00486_def =
( NAME    => "OC_PROFILE_PEAK",
  ADDRESS => 0x0000000090190080,
  NOTE    => "The PROFILE_PEAK register can be used to capture the peak (i.e., note minimum or maximum) value of the Profile Counter.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00486_flds
);


##########################################################################
#                                                                        #
#   OC_INT_CMPA                                                          #
#                                                                        #
##########################################################################

%orbit_01_00487_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  55,   9, 0xFF80000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REAL_TIME_CMPA"               => [   1,   0,  55, 0x007FFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Real Time Clock Compare" ],
);

%orbit_01_00487_def =
( NAME    => "OC_INT_CMPA",
  ADDRESS => 0x00000000901b0000,
  NOTE    => "When the value of the Orbit's real-time clock (viewable via the RTC note register's REAL_TIME_CLOCK field) equals the value of t",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00487_flds
);


##########################################################################
#                                                                        #
#   OC_INT_CMPB                                                          #
#                                                                        #
##########################################################################

%orbit_01_00488_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  55,   9, 0xFF80000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REAL_TIME_CMPB"               => [   1,   0,  55, 0x007FFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Real Time Clock Compare" ],
);

%orbit_01_00488_def =
( NAME    => "OC_INT_CMPB",
  ADDRESS => 0x00000000901b0080,
  NOTE    => "When the value of the Orbit's real-time clock (viewable via the RTC note register's REAL_TIME_CLOCK field) equals the value of t",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00488_flds
);


##########################################################################
#                                                                        #
#   OC_INT_CMPC                                                          #
#                                                                        #
##########################################################################

%orbit_01_00489_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  55,   9, 0xFF80000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REAL_TIME_CMPC"               => [   1,   0,  55, 0x007FFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Real Time Clock Compare" ],
);

%orbit_01_00489_def =
( NAME    => "OC_INT_CMPC",
  ADDRESS => 0x00000000901b0100,
  NOTE    => "When the value of the Orbit's real-time clock (viewable via the RTC note register's REAL_TIME_CLOCK field) equals the value of t",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00489_flds
);


##########################################################################
#                                                                        #
#   OC_INT_CMPD                                                          #
#                                                                        #
##########################################################################

%orbit_01_00490_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  55,   9, 0xFF80000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REAL_TIME_CMPD"               => [   1,   0,  55, 0x007FFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Real Time Clock Compare" ],
);

%orbit_01_00490_def =
( NAME    => "OC_INT_CMPD",
  ADDRESS => 0x00000000901b0180,
  NOTE    => "When the value of the Orbit's real-time clock (viewable via the RTC note register's REAL_TIME_CLOCK field) equals the value of t",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00490_flds
);


##########################################################################
#                                                                        #
#   OC_INT_PROF                                                          #
#                                                                        #
##########################################################################

%orbit_01_00491_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PROFILE_COMPARE"              => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "Profile Compare" ],
);

%orbit_01_00491_def =
( NAME    => "OC_INT_PROF",
  ADDRESS => 0x00000000901b0200,
  NOTE    => "When the 32 least significant bits of the Orbit's real-time clock note (viewable via the RTC register's REAL_TIME_CLOCK field) e",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00491_flds
);


##########################################################################
#                                                                        #
#   OC_RTC                                                               #
#                                                                        #
##########################################################################

%orbit_01_00492_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  55,   9, 0xFF80000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REAL_TIME_CLOCK"              => [   1,   0,  55, 0x007FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Real-time Clock" ],
);

%orbit_01_00492_def =
( NAME    => "OC_RTC",
  ADDRESS => 0x00000000901c0000,
  NOTE    => "The RTC register stores the current value of the Real-time Clock note Counter.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00492_flds
);


##########################################################################
#                                                                        #
#   OC_SCRATCH0                                                          #
#                                                                        #
##########################################################################

%orbit_01_00493_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH0"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 0" ],
);

%orbit_01_00493_def =
( NAME    => "OC_SCRATCH0",
  ADDRESS => 0x00000000901d0000,
  NOTE    => "The SCRATCH0 register is a temporary storage register provided note exclusively for software purposes. The hardware does not mon",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00493_flds
);


##########################################################################
#                                                                        #
#   OC_SCRATCH0_ALIAS                                                    #
#                                                                        #
##########################################################################

%orbit_01_00494_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH0"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 0" ],
);

%orbit_01_00494_def =
( NAME    => "OC_SCRATCH0_ALIAS",
  ADDRESS => 0x00000000901d0008,
  NOTE    => "The SCRATCH0_ALIAS address is an alias to the SCRATCH0 register. note Refer to the SCRATCH0 register description for details on ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00494_flds
);


##########################################################################
#                                                                        #
#   OC_SCRATCH1                                                          #
#                                                                        #
##########################################################################

%orbit_01_00495_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH1"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 1" ],
);

%orbit_01_00495_def =
( NAME    => "OC_SCRATCH1",
  ADDRESS => 0x00000000901d0080,
  NOTE    => "The SCRATCH1 register is a temporary storage register provided note exclusively for software purposes. The hardware does not mon",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00495_flds
);


##########################################################################
#                                                                        #
#   OC_SCRATCH1_ALIAS                                                    #
#                                                                        #
##########################################################################

%orbit_01_00496_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH1"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 1" ],
);

%orbit_01_00496_def =
( NAME    => "OC_SCRATCH1_ALIAS",
  ADDRESS => 0x00000000901d0088,
  NOTE    => "The SCRATCH1_ALIAS address is an alias to the SCRATCH1 register. note Refer to the SCRATCH1 register description for details on ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00496_flds
);


##########################################################################
#                                                                        #
#   OC_SCRATCH2                                                          #
#                                                                        #
##########################################################################

%orbit_01_00497_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH2"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Scratch register 2" ],
);

%orbit_01_00497_def =
( NAME    => "OC_SCRATCH2",
  ADDRESS => 0x00000000901d0100,
  NOTE    => "The SCRATCH2 register is a temporary storage register provided note exclusively for software purposes. The hardware does not mon",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00497_flds
);


##########################################################################
#                                                                        #
#   OC_SCRATCH2_ALIAS                                                    #
#                                                                        #
##########################################################################

%orbit_01_00498_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH2"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Scratch register 2" ],
);

%orbit_01_00498_def =
( NAME    => "OC_SCRATCH2_ALIAS",
  ADDRESS => 0x00000000901d0108,
  NOTE    => "The SCRATCH2_ALIAS address is an alias to the SCRATCH2 register. note Refer to the SCRATCH2 register description for details on ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00498_flds
);


##########################################################################
#                                                                        #
#   OC_SCRATCH3                                                          #
#                                                                        #
##########################################################################

%orbit_01_00499_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCRATCH3"                     => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Scratch register 3" ],
);

%orbit_01_00499_def =
( NAME    => "OC_SCRATCH3",
  ADDRESS => 0x00000000901d0180,
  NOTE    => "The SCRATCH3 register is a temporary storage register provided note exclusively for software purposes. The hardware does not mon",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00499_flds
);


##########################################################################
#                                                                        #
#   OC_SCRATCH3_ALIAS                                                    #
#                                                                        #
##########################################################################

%orbit_01_00500_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCRATCH3"                     => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Scratch register 3" ],
);

%orbit_01_00500_def =
( NAME    => "OC_SCRATCH3_ALIAS",
  ADDRESS => 0x00000000901d0188,
  NOTE    => "The SCRATCH3_ALIAS address is an alias to the SCRATCH3 register. note Refer to the SCRATCH3 register description for details on ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00500_flds
);


##########################################################################
#                                                                        #
#   OC_SCRATCH4                                                          #
#                                                                        #
##########################################################################

%orbit_01_00501_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCRATCH4"                     => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Scratch register 4" ],
);

%orbit_01_00501_def =
( NAME    => "OC_SCRATCH4",
  ADDRESS => 0x00000000901d0200,
  NOTE    => "The SCRATCH4 register is a temporary storage register provided note exclusively for software purposes. The hardware does not mon",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00501_flds
);


##########################################################################
#                                                                        #
#   OC_SCRATCH4_ALIAS                                                    #
#                                                                        #
##########################################################################

%orbit_01_00502_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCRATCH4"                     => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Scratch register 4" ],
);

%orbit_01_00502_def =
( NAME    => "OC_SCRATCH4_ALIAS",
  ADDRESS => 0x00000000901d0208,
  NOTE    => "The SCRATCH4_ALIAS address is an alias to the SCRATCH4 register. note Refer to the SCRATCH4 register description for details on ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00502_flds
);


##########################################################################
#                                                                        #
#   OC_SCRATCH5                                                          #
#                                                                        #
##########################################################################

%orbit_01_00503_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH5"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 5" ],
);

%orbit_01_00503_def =
( NAME    => "OC_SCRATCH5",
  ADDRESS => 0x00000000901d0280,
  NOTE    => "The SCRATCH5 register is a temporary storage register provided note exclusively for software purposes. The hardware does not mon",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00503_flds
);


##########################################################################
#                                                                        #
#   OC_SCRATCH6                                                          #
#                                                                        #
##########################################################################

%orbit_01_00504_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH6"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 6" ],
);

%orbit_01_00504_def =
( NAME    => "OC_SCRATCH6",
  ADDRESS => 0x00000000901d0300,
  NOTE    => "The SCRATCH6 register is a temporary storage register provided note exclusively for software purposes. The hardware does not mon",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00504_flds
);


##########################################################################
#                                                                        #
#   OC_SCRATCH7                                                          #
#                                                                        #
##########################################################################

%orbit_01_00505_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH7"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 7" ],
);

%orbit_01_00505_def =
( NAME    => "OC_SCRATCH7",
  ADDRESS => 0x00000000901d0380,
  NOTE    => "The SCRATCH7 register is a temporary storage register provided note exclusively for software purposes. The hardware does not mon",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00505_flds
);


##########################################################################
#                                                                        #
#   OC_SCRATCH8                                                          #
#                                                                        #
##########################################################################

%orbit_01_00506_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH8"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 8" ],
);

%orbit_01_00506_def =
( NAME    => "OC_SCRATCH8",
  ADDRESS => 0x00000000901d0400,
  NOTE    => "The SCRATCH8 register is a temporary storage register provided note exclusively for software purposes. The hardware does not mon",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00506_flds
);


##########################################################################
#                                                                        #
#   OC_SCRATCH9                                                          #
#                                                                        #
##########################################################################

%orbit_01_00507_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH9"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 9" ],
);

%orbit_01_00507_def =
( NAME    => "OC_SCRATCH9",
  ADDRESS => 0x00000000901d0480,
  NOTE    => "The SCRATCH9 register is a temporary storage register provided note exclusively for software purposes. The hardware does not mon",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00507_flds
);


##########################################################################
#                                                                        #
#   OC_SCRATCH10                                                         #
#                                                                        #
##########################################################################

%orbit_01_00508_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH10"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 10" ],
);

%orbit_01_00508_def =
( NAME    => "OC_SCRATCH10",
  ADDRESS => 0x00000000901d0500,
  NOTE    => "The SCRATCH10 register is a temporary storage register provided note exclusively for software purposes. The hardware does not mo",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00508_flds
);


##########################################################################
#                                                                        #
#   OC_SCRATCH11                                                         #
#                                                                        #
##########################################################################

%orbit_01_00509_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH11"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 11" ],
);

%orbit_01_00509_def =
( NAME    => "OC_SCRATCH11",
  ADDRESS => 0x00000000901d0580,
  NOTE    => "The SCRATCH11 register is a temporary storage register provided note exclusively for software purposes. The hardware does not mo",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00509_flds
);


##########################################################################
#                                                                        #
#   OC_SCRATCH12                                                         #
#                                                                        #
##########################################################################

%orbit_01_00510_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH12"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 12" ],
);

%orbit_01_00510_def =
( NAME    => "OC_SCRATCH12",
  ADDRESS => 0x00000000901d0600,
  NOTE    => "The SCRATCH12 register is a temporary storage register provided note exclusively for software purposes. The hardware does not mo",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00510_flds
);


##########################################################################
#                                                                        #
#   OC_PI_MD2PI_REPLY_VC_CONFIG                                          #
#                                                                        #
##########################################################################

%orbit_01_00511_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CAPTURE_CREDIT_STATUS"        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Capture credit and status information" ],
   "FORCE_CREDIT"                 => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Send an extra credit to sender" ],
   "RSVD0"                        => [   2,  14,  48, 0x3FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CREDITS"                  => [   3,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "Maximum credits from sender" ],
   "DATA_DEPTH"                   => [   4,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "Number of data buffers Available" ],
   "HDR_DEPTH"                    => [   5,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Depth of header Buffer" ],
);

%orbit_01_00511_def =
( NAME    => "OC_PI_MD2PI_REPLY_VC_CONFIG",
  ADDRESS => 0x00000000a0000100,
  NOTE    => "This register provides information that used to manage the number note of virtual channel credits that are used on this virtual ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00511_flds
);


##########################################################################
#                                                                        #
#   OC_PI_MD2PI_REQUEST_VC_CONFIG                                        #
#                                                                        #
##########################################################################

%orbit_01_00512_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CAPTURE_CREDIT_STATUS"        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Capture credit and status information" ],
   "FORCE_CREDIT"                 => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Send an extra credit to sender" ],
   "RSVD0"                        => [   2,  14,  48, 0x3FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CREDITS"                  => [   3,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "Maximum credits from sender" ],
   "DATA_DEPTH"                   => [   4,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "Number of data buffers Available" ],
   "HDR_DEPTH"                    => [   5,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Depth of header Buffer" ],
);

%orbit_01_00512_def =
( NAME    => "OC_PI_MD2PI_REQUEST_VC_CONFIG",
  ADDRESS => 0x00000000a0000108,
  NOTE    => "This register provides information that used to manage the number note of virtual channel credits that are used on this virtual ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00512_flds
);


##########################################################################
#                                                                        #
#   OC_PI_XN2PI_REPLY_VC_CONFIG                                          #
#                                                                        #
##########################################################################

%orbit_01_00513_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CAPTURE_CREDIT_STATUS"        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Capture credit and status information" ],
   "FORCE_CREDIT"                 => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Send an extra credit to sender" ],
   "RSVD0"                        => [   2,  14,  48, 0x3FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CREDITS"                  => [   3,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "Maximum credits from sender" ],
   "DATA_DEPTH"                   => [   4,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "Number of data buffers Available" ],
   "HDR_DEPTH"                    => [   5,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Depth of header Buffer" ],
);

%orbit_01_00513_def =
( NAME    => "OC_PI_XN2PI_REPLY_VC_CONFIG",
  ADDRESS => 0x00000000a0000110,
  NOTE    => "This register provides information that used to manage the number note of virtual channel credits that are used on this virtual ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00513_flds
);


##########################################################################
#                                                                        #
#   OC_PI_XN2PI_REQUEST_VC_CONFIG                                        #
#                                                                        #
##########################################################################

%orbit_01_00514_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CAPTURE_CREDIT_STATUS"        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Capture credit and status information" ],
   "FORCE_CREDIT"                 => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Send an extra credit to sender" ],
   "RSVD0"                        => [   2,  14,  48, 0x3FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CREDITS"                  => [   3,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "Maximum credits from sender" ],
   "DATA_DEPTH"                   => [   4,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "Number of data buffers Available" ],
   "HDR_DEPTH"                    => [   5,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Depth of header Buffer" ],
);

%orbit_01_00514_def =
( NAME    => "OC_PI_XN2PI_REQUEST_VC_CONFIG",
  ADDRESS => 0x00000000a0000118,
  NOTE    => "This register provides information that used to manage the number note of virtual channel credits that are used on this virtual ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00514_flds
);


##########################################################################
#                                                                        #
#   OC_PI_PI2MD_REPLY_VC_STATUS                                          #
#                                                                        #
##########################################################################

%orbit_01_00515_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   6,  58, 0xFFFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUTPUT_CRD_STAT"              => [   1,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Status of output credits" ],
);

%orbit_01_00515_def =
( NAME    => "OC_PI_PI2MD_REPLY_VC_STATUS",
  ADDRESS => 0x00000000a0008120,
  NOTE    => "This register provides information about the virtual channel note credits and buffer fullness for the MD input and output reply ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00515_flds
);


##########################################################################
#                                                                        #
#   OC_PI_PI2MD_REQUEST_VC_STATUS                                        #
#                                                                        #
##########################################################################

%orbit_01_00516_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   6,  58, 0xFFFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUTPUT_CRD_STAT"              => [   1,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Status of output credits" ],
);

%orbit_01_00516_def =
( NAME    => "OC_PI_PI2MD_REQUEST_VC_STATUS",
  ADDRESS => 0x00000000a0008128,
  NOTE    => "This register provides information about the virtual channel note credits and buffer fullness for the MD input and output reques",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00516_flds
);


##########################################################################
#                                                                        #
#   OC_PI_PI2XN_REPLY_VC_STATUS                                          #
#                                                                        #
##########################################################################

%orbit_01_00517_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   6,  58, 0xFFFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUTPUT_CRD_STAT"              => [   1,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Status of output credits" ],
);

%orbit_01_00517_def =
( NAME    => "OC_PI_PI2XN_REPLY_VC_STATUS",
  ADDRESS => 0x00000000a0008130,
  NOTE    => "This register provides information about the virtual channel note credits and buffer fullness for the MD input and output replay",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00517_flds
);


##########################################################################
#                                                                        #
#   OC_PI_PI2XN_REQUEST_VC_STATUS                                        #
#                                                                        #
##########################################################################

%orbit_01_00518_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   6,  58, 0xFFFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUTPUT_CRD_STAT"              => [   1,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Status of output credits" ],
);

%orbit_01_00518_def =
( NAME    => "OC_PI_PI2XN_REQUEST_VC_STATUS",
  ADDRESS => 0x00000000a0008138,
  NOTE    => "This register provides information about the virtual channel note credits and buffer fullness for the XN input and output reques",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00518_flds
);


##########################################################################
#                                                                        #
#   OC_PI_MD2PI_REPLY_VC_STATUS                                          #
#                                                                        #
##########################################################################

%orbit_01_00519_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  12,  52, 0xFFFFFFFFFFFFF000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INPUT_QUEUE_STAT"             => [   1,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "Status of MD Reply Input Queue" ],
   "INPUT_DAT_CRD_STAT"           => [   2,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "Status of data credits" ],
   "INPUT_HDR_CRD_STAT"           => [   3,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Status of input header credits" ],
);

%orbit_01_00519_def =
( NAME    => "OC_PI_MD2PI_REPLY_VC_STATUS",
  ADDRESS => 0x00000000a0008100,
  NOTE    => "This register provides information about the virtual channel note credits and buffer fullness for the MD input and output reply ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00519_flds
);


##########################################################################
#                                                                        #
#   OC_PI_MD2PI_REQUEST_VC_STATUS                                        #
#                                                                        #
##########################################################################

%orbit_01_00520_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  12,  52, 0xFFFFFFFFFFFFF000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INPUT_QUEUE_STAT"             => [   1,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "Status of MD Request Input Queue" ],
   "INPUT_DAT_CRD_STAT"           => [   2,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "Status of input data credits" ],
   "INPUT_HDR_CRD_STAT"           => [   3,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Status of input header credits" ],
);

%orbit_01_00520_def =
( NAME    => "OC_PI_MD2PI_REQUEST_VC_STATUS",
  ADDRESS => 0x00000000a0008108,
  NOTE    => "This register provides information about the virtual channel note credits and buffer fullness for the MD input and output reques",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00520_flds
);


##########################################################################
#                                                                        #
#   OC_PI_XN2PI_REPLY_VC_STATUS                                          #
#                                                                        #
##########################################################################

%orbit_01_00521_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  12,  52, 0xFFFFFFFFFFFFF000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INPUT_QUEUE_STAT"             => [   1,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "Status of XN Reply Input Queue" ],
   "INPUT_DAT_CRD_STAT"           => [   2,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "Status of input data credits" ],
   "INPUT_HDR_CRD_STAT"           => [   3,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Status of input header credits" ],
);

%orbit_01_00521_def =
( NAME    => "OC_PI_XN2PI_REPLY_VC_STATUS",
  ADDRESS => 0x00000000a0008110,
  NOTE    => "This register provides information about the virtual channel note credits and buffer fullness for the MD input and output replay",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00521_flds
);


##########################################################################
#                                                                        #
#   OC_PI_XN2PI_REQUEST_VC_STATUS                                        #
#                                                                        #
##########################################################################

%orbit_01_00522_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  12,  52, 0xFFFFFFFFFFFFF000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INPUT_QUEUE_STAT"             => [   1,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "Status of XN Request Input Queue" ],
   "INPUT_DAT_CRD_STAT"           => [   2,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "Status of input data credits" ],
   "INPUT_HDR_CRD_STAT"           => [   3,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Status of input header credits" ],
);

%orbit_01_00522_def =
( NAME    => "OC_PI_XN2PI_REQUEST_VC_STATUS",
  ADDRESS => 0x00000000a0008118,
  NOTE    => "This register provides information about the virtual channel note credits and buffer fullness for the XN input and output reques",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00522_flds
);


##########################################################################
#                                                                        #
#   OC_PI_EVENT_MASK                                                     #
#                                                                        #
##########################################################################

%orbit_01_00523_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TFI_EVENT_TRIGGER_3"          => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: TFI Event Trigger 3" ],
   "TFI_EVENT_TRIGGER_2"          => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: TFI Event Trigger 2" ],
   "TFI_EVENT_TRIGGER_1"          => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: TFI Event Trigger 1" ],
   "TFI_EVENT_TRIGGER_0"          => [   4,  59,   1, 0x0800000000000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: TFI Event Trigger 0" ],
   "NCRP_EVENT_TRIGGER_3"         => [   5,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: NCRP Event Trigger 3" ],
   "NCRP_EVENT_TRIGGER_2"         => [   6,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: NCRP Event Trigger 2" ],
   "NCRP_EVENT_TRIGGER_1"         => [   7,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: NCRP Event Trigger 1" ],
   "NCRP_EVENT_TRIGGER_0"         => [   8,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: NCRP Event Trigger 0" ],
   "CRB_EVENT_TRIGGER_3"          => [   9,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: CRB Event Trigger 3" ],
   "CRB_EVENT_TRIGGER_2"          => [  10,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: CRB Event Trigger 2" ],
   "CRB_EVENT_TRIGGER_1"          => [  11,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: CRB Event Trigger 1" ],
   "CRB_EVENT_TRIGGER_0"          => [  12,  51,   1, 0x0008000000000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: CRB Event Trigger 0" ],
   "SPOOL_COMPARE_INT"            => [  13,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "SPOOL_COMPARE_INT: Spool Compare Match Interrupt" ],
   "GFX_INT_1"                    => [  14,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "GFX_INT_PIPE1: Graphics-write Interrupt for Processor 1" ],
   "GFX_INT_0"                    => [  15,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "GFX_INT_PIPE0: Graphics-write Interrupt for Processor 0" ],
   "PI_DATA_RESP_PATH_ERR"        => [  16,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PI Data Response Path Error" ],
   "PI_DATA_WR_PATH_ERR"          => [  17,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PI Data Write Path Error" ],
   "XN_RQ_Q_OFLOW"                => [  18,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: XN-to-PI Request Queue Overflow Error" ],
   "XN_RQ_CRD_OFLOW"              => [  19,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PI-to-XN Request Credit Overflow Error" ],
   "XN_RP_Q_OFLOW"                => [  20,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: XN-to-PI Reply Queue Overflow Error" ],
   "XN_RP_CRD_OFLOW"              => [  21,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PI-to-XN Reply Credit Overflow Error" ],
   "MD_RQ_Q_OFLOW"                => [  22,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: MD-to-PI Request Queue Overflow Error" ],
   "MD_RQ_CRD_OFLOW"              => [  23,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PI-to-MD Request Credit Overflow Error" ],
   "MD_RP_Q_OFLOW"                => [  24,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: MD-to-PI Reply Queue Overflow Error" ],
   "MD_RP_CRD_OFLOW"              => [  25,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PI-to-MD Reply Credit Overflow Error" ],
   "GFX_FIFO_ERR"                 => [  26,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Graphics Request Buffer FIFO Error" ],
   "PIO_FIFO_ERR"                 => [  27,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PIO Request Buffer FIFO Error" ],
   "IO_WR_PKT_LEN_ERR"            => [  28,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "IO Write Data Packet Length Error Mask" ],
   "IO_RD_PKT_LEN_ERR"            => [  29,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "IO Read Response Data Packet Length Error Mask" ],
   "IO_WR_UNCORR_DATA_ERR"        => [  30,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "IO Write UnCorrectable Data Error Mask" ],
   "IO_WR_CORR_DATA_ERR"          => [  31,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "IO Write Correctable Data Error Mask" ],
   "IO_RD_UNCORR_DATA_ERR"        => [  32,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "IO Read UnCorrectable Data Error Mask" ],
   "IO_RD_CORR_DATA_ERR"          => [  33,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "IO Read Correctable Data Error Mask" ],
   "IO_WR_TO_ERR"                 => [  34,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "I/O Write Time-out Error Enable" ],
   "IO_RD_TO_ERR"                 => [  35,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "I/O Read Time-out Error Enable" ],
   "IO_WR_SPURIOUS_MSG_ERR"       => [  36,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "I/O Write Spurious Response Message Error Enable" ],
   "IO_RD_SPURIOUS_MSG_ERR"       => [  37,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "I/O Read Spurious Response Message Error Enable" ],
   "IO_WR_ACCESS_ERR"             => [  38,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "I/O Write Access Error Enable" ],
   "IO_RD_ACCESS_ERR"             => [  39,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "I/O Read Access Error Enable" ],
   "CRB_BUF_ERR"                  => [  40,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "CRB Message Buffer Error Mask" ],
   "INTV_TO_ERR"                  => [  41,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "Intervention/Invalidate Request Timeout Error Mask" ],
   "INTV_SYSSTATE_FIFO_ERR"       => [  42,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "Intervention/Invalidate Request FIFO Error Mask" ],
   "RD_SYSSTATE_FIFO_ERR"         => [  43,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "Read Request SysState FIFO Error Masks" ],
   "SYS_MEM_RSP_TBL_MISS"         => [  44,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "System Response Table Miss Error Mask" ],
   "SYS_MEM_REQ_TBL_MISS"         => [  45,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "System Memory Request Table Miss Error Mask" ],
   "PROC_MEM_RSP_TBL_MISS"        => [  46,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "Processor Intervention/Invalidate Response Table Miss Error Mask" ],
   "PROC_MEM_REQ_TBL_MISS"        => [  47,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Processor Memory Request Table Miss Error Mask" ],
   "MEM_WR_PKT_LEN_ERR"           => [  48,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Memory Write Data Packet Length Error Mask" ],
   "MEM_RD_PKT_LEN_ERR"           => [  49,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Memory Read Response Data Packet Length Error Mask" ],
   "MEM_WR_UNCORR_DATA_ERR"       => [  50,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Memory Write UnCorrectable Data Error Mask" ],
   "MEM_WR_CORR_DATA_ERR"         => [  51,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Memory Write Correctable Data Error Mask" ],
   "MEM_RD_UNCORR_DATA_ERR"       => [  52,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "Memory Read UnCorrectable Data Error Mask" ],
   "MEM_RD_CORR_DATA_ERR"         => [  53,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "Memory Read Correctable Data Error Mask" ],
   "MEM_RD_NACK_CNT_ERR"          => [  54,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Memory Read NACK Count Overflow Error Mask" ],
   "MEM_RD_POISON_ERR"            => [  55,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "PI_RE_INT: Memory Read Poison Access Error Mask" ],
   "MEM_WR_TO_ERR"                => [  56,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Memory Write Timeout Error Mask" ],
   "MEM_RD_TO_ERR"                => [  57,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Memory Read Timeout Error Mask" ],
   "MEM_WR_DIR_ERR"               => [  58,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Memory Write Directory Error Mask" ],
   "MEM_RD_DIR_ERR"               => [  59,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Memory Read Directory Error Mask" ],
   "MEM_WR_SPURIOUS_MSG_ERR"      => [  60,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Memory Write Spurious Response Message Error Maks" ],
   "MEM_RD_SPURIOUS_MSG_ERR"      => [  61,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Memory Read Spurious Response Message Error Mask" ],
   "MEM_WR_ACCESS_ERR"            => [  62,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Memory Write Access Error Mask" ],
   "MEM_RD_ACCESS_ERR"            => [  63,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Memory Read Access Error Mask" ],
);

%orbit_01_00523_def =
( NAME    => "OC_PI_EVENT_MASK",
  ADDRESS => 0x00000000a0000800,
  NOTE    => "The PI records 64 different hardware errors and events. The note occurance of these events can be posted to the PI_EVENT_SUMMARY",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00523_flds
);


##########################################################################
#                                                                        #
#   OC_PI_EVENT_SUMMARY                                                  #
#                                                                        #
##########################################################################

%orbit_01_00524_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TFI_EVENT_TRIGGER_3"          => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: TFI Event Trigger 3" ],
   "TFI_EVENT_TRIGGER_2"          => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: TFI Event Trigger 2" ],
   "TFI_EVENT_TRIGGER_1"          => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: TFI Event Trigger 1" ],
   "TFI_EVENT_TRIGGER_0"          => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: TFI Event Trigger 0" ],
   "NCRP_EVENT_TRIGGER_3"         => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: CRB Event Trigger 3" ],
   "NCRP_EVENT_TRIGGER_2"         => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: CRB Event Trigger 2" ],
   "NCRP_EVENT_TRIGGER_1"         => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: CRB Event Trigger 1" ],
   "NCRP_EVENT_TRIGGER_0"         => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: CRB Event Trigger 0" ],
   "CRB_EVENT_TRIGGER_3"          => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: CRB Event Trigger 3" ],
   "CRB_EVENT_TRIGGER_2"          => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: CRB Event Trigger 2" ],
   "CRB_EVENT_TRIGGER_1"          => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: CRB Event Trigger 1" ],
   "CRB_EVENT_TRIGGER_0"          => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: CRB Event Trigger 0" ],
   "SPOOL_COMPARE_INT"            => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "SPOOL_COMPARE_INT: Spool Compare Match Interrupt" ],
   "GFX_INT_1"                    => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "GFX_INT_PIPE0: Graphics-write Interrupt for Processor 1" ],
   "GFX_INT_0"                    => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "GFX_INT_PIPE0: Graphics-write Interrupt for Processor 0" ],
   "PI_DATA_RESP_PATH_ERR"        => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PI Data Response Path Error" ],
   "PI_DATA_WR_PATH_ERR"          => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PI Data Write Path Error" ],
   "XN_RQ_Q_OFLOW"                => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: XN-to-PI Request Queue Overflow Error" ],
   "XN_RQ_CRD_OFLOW"              => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PI-to-XN Request Credit Overflow Error" ],
   "XN_RP_Q_OFLOW"                => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: XN-to-PI Reply Queue Overflow Error" ],
   "XN_RP_CRD_OFLOW"              => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PI-to-XN Reply Credit Overflow Error" ],
   "MD_RQ_Q_OFLOW"                => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: MD-to-PI Request Queue Overflow Error" ],
   "MD_RQ_CRD_OFLOW"              => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PI-to-MD Request Credit Overflow Error" ],
   "MD_RP_Q_OFLOW"                => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: MD-to-PI Reply Queue Overflow Error" ],
   "MD_RP_CRD_OFLOW"              => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PI-to-MD Reply Credit Overflow Error" ],
   "GFX_FIFO_ERR"                 => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Graphics Request Buffer FIFO Error" ],
   "PIO_FIFO_ERR"                 => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PIO Request Buffer FIFO Error" ],
   "IO_WR_PKT_LEN_ERR"            => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IO Write Data Packet Length Error" ],
   "IO_RD_PKT_LEN_ERR"            => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "IO Read Response Data Packet Length Error" ],
   "IO_WR_UNCORR_DATA_ERR"        => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: IO Write UnCorrectable Data Error" ],
   "IO_WR_CORR_DATA_ERR"          => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT: IO Write Correctable Data Error" ],
   "IO_RD_UNCORR_DATA_ERR"        => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: IO Read UnCorrectable Data Error" ],
   "IO_RD_CORR_DATA_ERR"          => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT: IO Read Correctable Data Error" ],
   "IO_WR_TO_ERR"                 => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: I/O Write Time-out Error" ],
   "IO_RD_TO_ERR"                 => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: I/O Read Time-out Error" ],
   "IO_WR_SPURIOUS_MSG_ERR"       => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: I/O Write Spurious Response Message Error" ],
   "IO_RD_SPURIOUS_MSG_ERR"       => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: I/O Read Spurious Response Message Error" ],
   "IO_WR_ACCESS_ERR"             => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: I/O Write Access Error" ],
   "IO_RD_ACCESS_ERR"             => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT: I/O Read Access Error" ],
   "CRB_BUF_ERR"                  => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "CRB Message Buffer Error Enable" ],
   "INTV_TO_ERR"                  => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Intervention/Invalidate Request Timeout Error" ],
   "INTV_SYSSTATE_FIFO_ERR"       => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Intervention/Invalidate Request SysState FIFO Error" ],
   "RD_SYSSTATE_FIFO_ERR"         => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Read Request SysState FIFO Error" ],
   "SYS_MEM_RSP_TBL_MISS"         => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: System Memory Response Table Miss Error" ],
   "SYS_MEM_REQ_TBL_MISS"         => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: System Memory Request Table Miss Error" ],
   "PROC_MEM_RSP_TBL_MISS"        => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Processor Memory Response Table Miss Error" ],
   "PROC_MEM_REQ_TBL_MISS"        => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Processor Memory Request Table Miss Error" ],
   "MEM_WR_PKT_LEN_ERR"           => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Memory Write Data Packet Length Error" ],
   "MEM_RD_PKT_LEN_ERR"           => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Memory Read Response Data Packet Length Error" ],
   "MEM_WR_UNCORR_DATA_ERR"       => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Write UnCorrectable Data Error" ],
   "MEM_WR_CORR_DATA_ERR"         => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI_RE_INT: Memory Write Correctable Data Error" ],
   "MEM_RD_UNCORR_DATA_ERR"       => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Read UnCorrectable Data Error" ],
   "MEM_RD_CORR_DATA_ERR"         => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI_RE_INT: Memory Read Correctable Data Error" ],
   "MEM_RD_NACK_CNT_ERR"          => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "PI_RE_INT: Memory Read NACK COunter Overflow Error" ],
   "MEM_RD_POISON_ERR"            => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "PI_RE_INT: Memory Read Poison Access Error" ],
   "MEM_WR_TO_ERR"                => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Write Time-out Error" ],
   "MEM_RD_TO_ERR"                => [  57,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Read Time-out Error" ],
   "MEM_WR_DIR_ERR"               => [  58,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Directory Error on Write" ],
   "MEM_RD_DIR_ERR"               => [  59,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Directory Error on Read" ],
   "MEM_WR_SPURIOUS_MSG_ERR"      => [  60,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Write Spurious Response Message Error" ],
   "MEM_RD_SPURIOUS_MSG_ERR"      => [  61,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Read Spurious Response Message Error" ],
   "MEM_WR_ACCESS_ERR"            => [  62,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Write Access Error" ],
   "MEM_RD_ACCESS_ERR"            => [  63,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "PI_RE_INT: Memory Read Access Error" ],
);

%orbit_01_00524_def =
( NAME    => "OC_PI_EVENT_SUMMARY",
  ADDRESS => 0x00000000a0008800,
  NOTE    => "The PI_EVENT_SUMMARY register is the PI's top-level interrupt event note flag register. It contains 33 error flags and 14 event ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00524_flds
);


##########################################################################
#                                                                        #
#   OC_PI_EVENT_SUMMARY_ALIAS                                            #
#                                                                        #
##########################################################################

%orbit_01_00525_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TFI_EVENT_TRIGGER_3"          => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: TFI Event Trigger 3" ],
   "TFI_EVENT_TRIGGER_2"          => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: TFI Event Trigger 2" ],
   "TFI_EVENT_TRIGGER_1"          => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: TFI Event Trigger 1" ],
   "TFI_EVENT_TRIGGER_0"          => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: TFI Event Trigger 0" ],
   "NCRP_EVENT_TRIGGER_3"         => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: CRB Event Trigger 3" ],
   "NCRP_EVENT_TRIGGER_2"         => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: CRB Event Trigger 2" ],
   "NCRP_EVENT_TRIGGER_1"         => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: CRB Event Trigger 1" ],
   "NCRP_EVENT_TRIGGER_0"         => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: CRB Event Trigger 0" ],
   "CRB_EVENT_TRIGGER_3"          => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: CRB Event Trigger 3" ],
   "CRB_EVENT_TRIGGER_2"          => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: CRB Event Trigger 2" ],
   "CRB_EVENT_TRIGGER_1"          => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: CRB Event Trigger 1" ],
   "CRB_EVENT_TRIGGER_0"          => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: CRB Event Trigger 0" ],
   "SPOOL_COMPARE_INT"            => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "SPOOL_COMPARE_INT: Spool Compare Match Interrupt" ],
   "GFX_INT_1"                    => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "GFX_INT_PIPE0: Graphics-write Interrupt for Processor 1" ],
   "GFX_INT_0"                    => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "GFX_INT_PIPE0: Graphics-write Interrupt for Processor 0" ],
   "PI_DATA_RESP_PATH_ERR"        => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PI Data Response Path Error" ],
   "PI_DATA_WR_PATH_ERR"          => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PI Data Write Path Error" ],
   "XN_RQ_Q_OFLOW"                => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: XN-to-PI Request Queue Overflow Error" ],
   "XN_RQ_CRD_OFLOW"              => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PI-to-XN Request Credit Overflow Error" ],
   "XN_RP_Q_OFLOW"                => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: XN-to-PI Reply Queue Overflow Error" ],
   "XN_RP_CRD_OFLOW"              => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PI-to-XN Reply Credit Overflow Error" ],
   "MD_RQ_Q_OFLOW"                => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: MD-to-PI Request Queue Overflow Error" ],
   "MD_RQ_CRD_OFLOW"              => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PI-to-MD Request Credit Overflow Error" ],
   "MD_RP_Q_OFLOW"                => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: MD-to-PI Reply Queue Overflow Error" ],
   "MD_RP_CRD_OFLOW"              => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PI-to-MD Reply Credit Overflow Error" ],
   "GFX_FIFO_ERR"                 => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Graphics Request Buffer FIFO Error" ],
   "PIO_FIFO_ERR"                 => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PIO Request Buffer FIFO Error" ],
   "IO_WR_PKT_LEN_ERR"            => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IO Write Data Packet Length Error" ],
   "IO_RD_PKT_LEN_ERR"            => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "IO Read Response Data Packet Length Error" ],
   "IO_WR_UNCORR_DATA_ERR"        => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: IO Write UnCorrectable Data Error" ],
   "IO_WR_CORR_DATA_ERR"          => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT: IO Write Correctable Data Error" ],
   "IO_RD_UNCORR_DATA_ERR"        => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: IO Read UnCorrectable Data Error" ],
   "IO_RD_CORR_DATA_ERR"          => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT: IO Read Correctable Data Error" ],
   "IO_WR_TO_ERR"                 => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: I/O Write Time-out Error" ],
   "IO_RD_TO_ERR"                 => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: I/O Read Time-out Error" ],
   "IO_WR_SPURIOUS_MSG_ERR"       => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: I/O Write Spurious Response Message Error" ],
   "IO_RD_SPURIOUS_MSG_ERR"       => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: I/O Read Spurious Response Message Error" ],
   "IO_WR_ACCESS_ERR"             => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: I/O Write Access Error" ],
   "IO_RD_ACCESS_ERR"             => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT: I/O Read Access Error" ],
   "CRB_BUF_ERR"                  => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "CRB Message Buffer Error Enable" ],
   "INTV_TO_ERR"                  => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Intervention/Invalidate Request Timeout Error" ],
   "INTV_SYSSTATE_FIFO_ERR"       => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Intervention/Invalidate Request SysState FIFO Error" ],
   "RD_SYSSTATE_FIFO_ERR"         => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Read Request SysState FIFO Error" ],
   "SYS_MEM_RSP_TBL_MISS"         => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: System Memory Response Table Miss Error" ],
   "SYS_MEM_REQ_TBL_MISS"         => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: System Memory Request Table Miss Error" ],
   "PROC_MEM_RSP_TBL_MISS"        => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Processor Memory Response Table Miss Error" ],
   "PROC_MEM_REQ_TBL_MISS"        => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Processor Memory Request Table Miss Error" ],
   "MEM_WR_PKT_LEN_ERR"           => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Memory Write Data Packet Length Error" ],
   "MEM_RD_PKT_LEN_ERR"           => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Memory Read Response Data Packet Length Error" ],
   "MEM_WR_UNCORR_DATA_ERR"       => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Write UnCorrectable Data Error" ],
   "MEM_WR_CORR_DATA_ERR"         => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI_RE_INT: Memory Write Correctable Data Error" ],
   "MEM_RD_UNCORR_DATA_ERR"       => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Read UnCorrectable Data Error" ],
   "MEM_RD_CORR_DATA_ERR"         => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI_RE_INT: Memory Read Correctable Data Error" ],
   "MEM_RD_NACK_CNT_ERR"          => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "PI_RE_INT: Memory Read NACK COunter Overflow Error" ],
   "MEM_RD_POISON_ERR"            => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "PI_RE_INT: Memory Read Poison Access Error" ],
   "MEM_WR_TO_ERR"                => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Write Time-out Error" ],
   "MEM_RD_TO_ERR"                => [  57,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Read Time-out Error" ],
   "MEM_WR_DIR_ERR"               => [  58,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Directory Error on Write" ],
   "MEM_RD_DIR_ERR"               => [  59,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Directory Error on Read" ],
   "MEM_WR_SPURIOUS_MSG_ERR"      => [  60,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Write Spurious Response Message Error" ],
   "MEM_RD_SPURIOUS_MSG_ERR"      => [  61,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Read Spurious Response Message Error" ],
   "MEM_WR_ACCESS_ERR"            => [  62,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Write Access Error" ],
   "MEM_RD_ACCESS_ERR"            => [  63,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "PI_RE_INT: Memory Read Access Error" ],
);

%orbit_01_00525_def =
( NAME    => "OC_PI_EVENT_SUMMARY_ALIAS",
  ADDRESS => 0x00000000a0008808,
  NOTE    => "The PI_EVENT_SUMMARY_ALIAS address is an alias to the note PI_EVENT_SUMMARY register. Refer to the PI_EVENT_SUMMARY register not",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00525_flds
);


##########################################################################
#                                                                        #
#   OC_PI_ERROR_SELECT                                                   #
#                                                                        #
##########################################################################

%orbit_01_00526_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  40,  24, 0xFFFFFF0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PI_DATA_RESP_PATH_ERR"        => [   1,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PI Data Response Path Error" ],
   "PI_DATA_WR_PATH_ERR"          => [   2,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PI Data Write Path Error" ],
   "XN_RQ_Q_OFLOW"                => [   3,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: XN-to-PI Request Queue Overflow Error" ],
   "XN_RQ_CRD_OFLOW"              => [   4,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PI-to-XN Request Credit Overflow Error" ],
   "XN_RP_Q_OFLOW"                => [   5,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: XN-to-PI Reply Queue Overflow Error" ],
   "XN_RP_CRD_OFLOW"              => [   6,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PI-to-XN Reply Credit Overflow Error" ],
   "MD_RQ_Q_OFLOW"                => [   7,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: MD-to-PI Request Queue Overflow Error" ],
   "MD_RQ_CRD_OFLOW"              => [   8,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PI-to-MD Request Credit Overflow Error" ],
   "MD_RP_Q_OFLOW"                => [   9,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: MD-to-PI Reply Queue Overflow Error" ],
   "MD_RP_CRD_OFLOW"              => [  10,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PI-to-MD Reply Credit Overflow Error" ],
   "GFX_FIFO_ERR"                 => [  11,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Graphics Request Buffer FIFO Error" ],
   "PIO_FIFO_ERR"                 => [  12,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PIO Request Buffer FIFO Error" ],
   "IO_WR_PKT_LEN_ERR"            => [  13,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: IO Write Data Packet Length Error" ],
   "IO_RD_PKT_LEN_ERR"            => [  14,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: IO Read Response Data Packet Length Error" ],
   "IO_WR_TO_ERR"                 => [  15,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: I/O Write Timeout Error" ],
   "IO_RD_TO_ERR"                 => [  16,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: I/O Read Timeout Error" ],
   "IO_WR_SPURIOUS_MSG_ERR"       => [  17,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: I/O Write Spurious Message Error" ],
   "IO_RD_SPURIOUS_MSG_ERR"       => [  18,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: I/O Read Spurious Message Error" ],
   "IO_WR_ACCESS_ERR"             => [  19,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: I/O Write Access Error" ],
   "IO_RD_ACCESS_ERR"             => [  20,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: I/O Read Access Error" ],
   "CRB_BUF_ERR"                  => [  21,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "CRB Message Buffer Error" ],
   "INTV_TO_ERR"                  => [  22,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "Intervention/Invalidate Request Timeout Error" ],
   "INTV_SYSSTATE_FIFO_ERR"       => [  23,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Intervention/Invalidate Request SysState FIFO Error" ],
   "RD_SYSSTATE_FIFO_ERR"         => [  24,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Read Request SysState FIFO Error" ],
   "SYS_MEM_RSP_TBL_MISS"         => [  25,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: System Memory Response Table Miss Error" ],
   "SYS_MEM_REQ_TBL_MISS"         => [  26,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: System Memory Request Table Miss Error" ],
   "PROC_MEM_RSP_TBL_MISS"        => [  27,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Processor Memory Response Table Miss Error" ],
   "PROC_MEM_REQ_TBL_MISS"        => [  28,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Processor Memory Request Table Miss Error" ],
   "MEM_WR_PKT_LEN_ERR"           => [  29,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Write Data Packet Length Error" ],
   "MEM_RD_PKT_LEN_ERR"           => [  30,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Read Response Data Packet Length Error" ],
   "MEM_RD_NACK_CNT_ERR"          => [  31,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Read NACK Count Overflow Error" ],
   "MEM_RD_POISON_ERR"            => [  32,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Read Poison Error" ],
   "MEM_WR_TO_ERR"                => [  33,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Write Timeout Error" ],
   "MEM_RD_TO_ERR"                => [  34,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Read Timeout Error" ],
   "MEM_WR_DIR_ERR"               => [  35,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Write Directory Error" ],
   "MEM_RD_DIR_ERR"               => [  36,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Read Directory Error" ],
   "MEM_WR_SPURIOUS_MSG_ERR"      => [  37,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Write Spurious Message Error" ],
   "MEM_RD_SPURIOUS_MSG_ERR"      => [  38,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Read Spurious Message Error" ],
   "MEM_WR_ACCESS_ERR"            => [  39,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Write Access Error" ],
   "MEM_RD_ACCESS_ERR"            => [  40,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Read Access Error" ],
);

%orbit_01_00526_def =
( NAME    => "OC_PI_ERROR_SELECT",
  ADDRESS => 0x00000000a0000808,
  NOTE    => "The PI_ERROR_SELECT register is used to map any non-data error to note either Recoverable(L3) or UnRecoverable(L6) interrupt sig",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00526_flds
);


##########################################################################
#                                                                        #
#   OC_PI_FIRST_ERROR                                                    #
#                                                                        #
##########################################################################

%orbit_01_00527_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PI_DATA_RESP_PATH_ERR"        => [   1,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PI Data Response Path Error" ],
   "PI_DATA_WR_PATH_ERR"          => [   2,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PI Data Write Path Error" ],
   "XN_RQ_Q_OFLOW"                => [   3,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: XN-to-PI Request Queue Overflow Error" ],
   "XN_RQ_CRD_OFLOW"              => [   4,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PI-to-XN Request Credit Overflow Error" ],
   "XN_RP_Q_OFLOW"                => [   5,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: XN-to-PI Reply Queue Overflow Error" ],
   "XN_RP_CRD_OFLOW"              => [   6,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PI-to-XN Reply Credit Overflow Error" ],
   "MD_RQ_Q_OFLOW"                => [   7,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: MD-to-PI Request Queue Overflow Error" ],
   "MD_RQ_CRD_OFLOW"              => [   8,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PI-to-MD Request Credit Overflow Error" ],
   "MD_RP_Q_OFLOW"                => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: MD-to-PI Reply Queue Overflow Error" ],
   "MD_RP_CRD_OFLOW"              => [  10,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PI-to-MD Reply Credit Overflow Error" ],
   "GFX_FIFO_ERR"                 => [  11,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Graphics Request Buffer FIFO Error" ],
   "PIO_FIFO_ERR"                 => [  12,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PIO Request Buffer FIFO Error" ],
   "IO_WR_PKT_LEN_ERR"            => [  13,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: IO Write Data Packet Length Error" ],
   "IO_RD_PKT_LEN_ERR"            => [  14,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: IO Read Data Packet Length Error" ],
   "IO_WR_UNCORR_DATA_ERR"        => [  15,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: IO Write Uncorrectable Data Protection Error" ],
   "IO_WR_CORR_DATA_ERR"          => [  16,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: IO Write Correctable Data Protection Error" ],
   "IO_RD_UNCORR_DATA_ERR"        => [  17,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: IO Read Uncorrectable Data Protection Error" ],
   "IO_RD_CORR_DATA_ERR"          => [  18,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: IO Read Correctable Data Protection Error" ],
   "IO_WR_TO_ERR"                 => [  19,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: I/O Write Time-out Error" ],
   "IO_RD_TO_ERR"                 => [  20,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: I/O Read Time-out Error" ],
   "IO_WR_SPURIOUS_MSG_ERR"       => [  21,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: I/O Write Spurious Response Message Error" ],
   "IO_RD_SPURIOUS_MSG_ERR"       => [  22,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: I/O Read Spurious Response Message Error" ],
   "IO_WR_ACCESS_ERR"             => [  23,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: I/O Write Access Error" ],
   "IO_RD_ACCESS_ERR"             => [  24,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: I/O Read Access Error" ],
   "CRB_BUF_ERR"                  => [  25,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: CRB Message Buffer Error" ],
   "INTV_TO_ERR"                  => [  26,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Intervention/Invalidate Entry Timeout Error" ],
   "INTV_SYSSTATE_FIFO_ERR"       => [  27,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Intervention/Invalidate SysState FIFO Error" ],
   "RD_SYSSTATE_FIFO_ERR"         => [  28,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Read Request SysState FIFO Error" ],
   "SYS_MEM_RSP_TBL_MISS"         => [  29,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: System Memory Response Table Miss Error" ],
   "SYS_MEM_REQ_TBL_MISS"         => [  30,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: System Memory Request Table Miss Error" ],
   "PROC_MEM_RSP_TBL_MISS"        => [  31,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Processor Intervention Response Table Miss Error" ],
   "PROC_MEM_REQ_TBL_MISS"        => [  32,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Processor Memory Request Table Miss Error" ],
   "MEM_WR_PKT_LEN_ERR"           => [  33,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Write Data Packet Length Error" ],
   "MEM_RD_PKT_LEN_ERR"           => [  34,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Read Data Packet Length Error" ],
   "MEM_WR_UNCORR_DATA_ERR"       => [  35,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Write Uncorrectable Data Protection Error" ],
   "MEM_WR_CORR_DATA_ERR"         => [  36,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Write Correctable Data Protection Error" ],
   "MEM_RD_UNCORR_DATA_ERR"       => [  37,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Read Uncorrectable Data Protection Error" ],
   "MEM_RD_CORR_DATA_ERR"         => [  38,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Read Correctable Data Protection Error" ],
   "MEM_RD_NACK_CNT_ERR"          => [  39,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Read NACK Count Overflow Error" ],
   "MEM_RD_POISON_ERR"            => [  40,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Read Poison Error" ],
   "MEM_WR_TO_ERR"                => [  41,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Write Time-out Error" ],
   "MEM_RD_TO_ERR"                => [  42,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Read Time-out Error" ],
   "MEM_WR_DIR_ERR"               => [  43,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Directory Error on Write" ],
   "MEM_RD_DIR_ERR"               => [  44,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Directory Error on Read" ],
   "MEM_WR_SPURIOUS_MSG_ERR"      => [  45,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Write Spurious Response Message Error" ],
   "MEM_RD_SPURIOUS_MSG_ERR"      => [  46,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Read Spurious Response Message Error" ],
   "MEM_WR_ACCESS_ERR"            => [  47,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Write Access Error" ],
   "MEM_RD_ACCESS_ERR"            => [  48,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Read Access Error" ],
);

%orbit_01_00527_def =
( NAME    => "OC_PI_FIRST_ERROR",
  ADDRESS => 0x00000000a0008860,
  NOTE    => "The PI_FIRST_ERROR register is the PI's top-level first error note interrupt register. It contains 33 error flags and each flag ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00527_flds
);


##########################################################################
#                                                                        #
#   OC_PI_FIRST_ERROR_ALIAS                                              #
#                                                                        #
##########################################################################

%orbit_01_00528_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PI_DATA_RESP_PATH_ERR"        => [   1,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PI Data Response Path Error" ],
   "PI_DATA_WR_PATH_ERR"          => [   2,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PI Data Write Path Error" ],
   "XN_RQ_Q_OFLOW"                => [   3,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: XN-to-PI Request Queue Overflow Error" ],
   "XN_RQ_CRD_OFLOW"              => [   4,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PI-to-XN Request Credit Overflow Error" ],
   "XN_RP_Q_OFLOW"                => [   5,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: XN-to-PI Reply Queue Overflow Error" ],
   "XN_RP_CRD_OFLOW"              => [   6,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PI-to-XN Reply Credit Overflow Error" ],
   "MD_RQ_Q_OFLOW"                => [   7,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: MD-to-PI Request Queue Overflow Error" ],
   "MD_RQ_CRD_OFLOW"              => [   8,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PI-to-MD Request Credit Overflow Error" ],
   "MD_RP_Q_OFLOW"                => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: MD-to-PI Reply Queue Overflow Error" ],
   "MD_RP_CRD_OFLOW"              => [  10,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PI-to-MD Reply Credit Overflow Error" ],
   "GFX_FIFO_ERR"                 => [  11,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Graphics Request Buffer FIFO Error" ],
   "PIO_FIFO_ERR"                 => [  12,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: PIO Request Buffer FIFO Error" ],
   "IO_WR_PKT_LEN_ERR"            => [  13,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: IO Write Data Packet Length Error" ],
   "IO_RD_PKT_LEN_ERR"            => [  14,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: IO Read Data Packet Length Error" ],
   "IO_WR_UNCORR_DATA_ERR"        => [  15,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: IO Write Uncorrectable Data Protection Error" ],
   "IO_WR_CORR_DATA_ERR"          => [  16,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: IO Write Correctable Data Protection Error" ],
   "IO_RD_UNCORR_DATA_ERR"        => [  17,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: IO Read Uncorrectable Data Protection Error" ],
   "IO_RD_CORR_DATA_ERR"          => [  18,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: IO Read Correctable Data Protection Error" ],
   "IO_WR_TO_ERR"                 => [  19,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: I/O Write Time-out Error" ],
   "IO_RD_TO_ERR"                 => [  20,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: I/O Read Time-out Error" ],
   "IO_WR_SPURIOUS_MSG_ERR"       => [  21,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: I/O Write Spurious Response Message Error" ],
   "IO_RD_SPURIOUS_MSG_ERR"       => [  22,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: I/O Read Spurious Response Message Error" ],
   "IO_WR_ACCESS_ERR"             => [  23,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: I/O Write Access Error" ],
   "IO_RD_ACCESS_ERR"             => [  24,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: I/O Read Access Error" ],
   "CRB_BUF_ERR"                  => [  25,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: CRB Message Buffer Error" ],
   "INTV_TO_ERR"                  => [  26,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Intervention/Invalidate Entry Timeout Error" ],
   "INTV_SYSSTATE_FIFO_ERR"       => [  27,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Intervention/Invalidate SysState FIFO Error" ],
   "RD_SYSSTATE_FIFO_ERR"         => [  28,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Read Request SysState FIFO Error" ],
   "SYS_MEM_RSP_TBL_MISS"         => [  29,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: System Memory Response Table Miss Error" ],
   "SYS_MEM_REQ_TBL_MISS"         => [  30,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: System Memory Request Table Miss Error" ],
   "PROC_MEM_RSP_TBL_MISS"        => [  31,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Processor Intervention Response Table Miss Error" ],
   "PROC_MEM_REQ_TBL_MISS"        => [  32,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Processor Memory Request Table Miss Error" ],
   "MEM_WR_PKT_LEN_ERR"           => [  33,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Write Data Packet Length Error" ],
   "MEM_RD_PKT_LEN_ERR"           => [  34,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Read Data Packet Length Error" ],
   "MEM_WR_UNCORR_DATA_ERR"       => [  35,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Write Uncorrectable Data Protection Error" ],
   "MEM_WR_CORR_DATA_ERR"         => [  36,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Write Correctable Data Protection Error" ],
   "MEM_RD_UNCORR_DATA_ERR"       => [  37,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Read Uncorrectable Data Protection Error" ],
   "MEM_RD_CORR_DATA_ERR"         => [  38,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Read Correctable Data Protection Error" ],
   "MEM_RD_NACK_CNT_ERR"          => [  39,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Read NACK Count Overflow Error" ],
   "MEM_RD_POISON_ERR"            => [  40,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Read Poison Error" ],
   "MEM_WR_TO_ERR"                => [  41,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Write Time-out Error" ],
   "MEM_RD_TO_ERR"                => [  42,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Read Time-out Error" ],
   "MEM_WR_DIR_ERR"               => [  43,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Directory Error on Write" ],
   "MEM_RD_DIR_ERR"               => [  44,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Directory Error on Read" ],
   "MEM_WR_SPURIOUS_MSG_ERR"      => [  45,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Write Spurious Response Message Error" ],
   "MEM_RD_SPURIOUS_MSG_ERR"      => [  46,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Read Spurious Response Message Error" ],
   "MEM_WR_ACCESS_ERR"            => [  47,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Write Access Error" ],
   "MEM_RD_ACCESS_ERR"            => [  48,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "PI_RE_INT/PI_URE_INT: Memory Read Access Error" ],
);

%orbit_01_00528_def =
( NAME    => "OC_PI_FIRST_ERROR_ALIAS",
  ADDRESS => 0x00000000a0008868,
  NOTE    => "The PI_FIRST_ERROR_ALIAS address is an alias to the PI_FIRST_ERROR note register. Refer to the PI_FIRST_ERROR register descripti",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00528_flds
);


##########################################################################
#                                                                        #
#   OC_PI_ERR_SPOOL0_ADDR                                                #
#                                                                        #
##########################################################################

%orbit_01_00529_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "START_ADDRESS"                => [   1,   3,  35, 0x0000003FFFFFFFF8, 0x00, 1, 0x0000000000000000, "Error Spool 0 Start Address" ],
);

%orbit_01_00529_def =
( NAME    => "OC_PI_ERR_SPOOL0_ADDR",
  ADDRESS => 0x00000000a0000810,
  NOTE    => "The PI_ERR_SPOOL0_ADDR register is used to set the start of PI note error spool 0 in memory. This pointer is used when Error Spo",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00529_flds
);


##########################################################################
#                                                                        #
#   OC_PI_ERR_SPOOL1_ADDR                                                #
#                                                                        #
##########################################################################

%orbit_01_00530_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "START_ADDRESS"                => [   1,   3,  35, 0x0000003FFFFFFFF8, 0x00, 1, 0x0000000000000000, "Error Spool 1 Start Address" ],
);

%orbit_01_00530_def =
( NAME    => "OC_PI_ERR_SPOOL1_ADDR",
  ADDRESS => 0x00000000a0000818,
  NOTE    => "The PI_ERR_SPOOL1_ADDR register is used to set the start of PI note error spool 1 in memory. This pointer is used when Error Spo",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00530_flds
);


##########################################################################
#                                                                        #
#   OC_PI_ERR_SPOOL2_ADDR                                                #
#                                                                        #
##########################################################################

%orbit_01_00531_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "START_ADDRESS"                => [   1,   3,  35, 0x0000003FFFFFFFF8, 0x00, 1, 0x0000000000000000, "Error Spool 2 Start Address" ],
);

%orbit_01_00531_def =
( NAME    => "OC_PI_ERR_SPOOL2_ADDR",
  ADDRESS => 0x00000000a0000820,
  NOTE    => "The PI_ERR_SPOOL2_ADDR register is used to set the start of PI note error spool 2 in memory. This pointer is used when Error Spo",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00531_flds
);


##########################################################################
#                                                                        #
#   OC_PI_ERR_SPOOL3_ADDR                                                #
#                                                                        #
##########################################################################

%orbit_01_00532_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "START_ADDRESS"                => [   1,   3,  35, 0x0000003FFFFFFFF8, 0x00, 1, 0x0000000000000000, "Error Spool 3 Start Address" ],
);

%orbit_01_00532_def =
( NAME    => "OC_PI_ERR_SPOOL3_ADDR",
  ADDRESS => 0x00000000a0000828,
  NOTE    => "The PI_ERR_SPOOL3_ADDR register is used to set the start of PI note error spool 3 in memory. This pointer is used when Error Spo",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00532_flds
);


##########################################################################
#                                                                        #
#   OC_PI_ERR_SPOOL_SIZE                                                 #
#                                                                        #
##########################################################################

%orbit_01_00533_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SIZE_3"                       => [   1,  24,   4, 0x000000000F000000, 0x00, 1, 0x0000000000000000, "Spool 3 Size" ],
   "RSVD1"                        => [   2,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SIZE_2"                       => [   3,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "Spool 2 Size" ],
   "RSVD2"                        => [   4,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SIZE_1"                       => [   5,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "Spool 1 Size" ],
   "RSVD3"                        => [   6,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SIZE_0"                       => [   7,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Spool 0 Size" ],
);

%orbit_01_00533_def =
( NAME    => "OC_PI_ERR_SPOOL_SIZE",
  ADDRESS => 0x00000000a0000830,
  NOTE    => "The PI_ERR_SPOOL_SIZE register is used to set the size of the PI note error spool in memory. This value is used when Error Spool",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00533_flds
);


##########################################################################
#                                                                        #
#   OC_PI_ERR_SPOOL_MASK                                                 #
#                                                                        #
##########################################################################

%orbit_01_00534_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  54,  10, 0xFFC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IO_WR_PKT_LEN"                => [   1,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "Mask IO Write Packet Length Errors" ],
   "IO_WR_UNCORR_DATA"            => [   2,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "Mask UnCorrectable IO Write Data Errors" ],
   "IO_WR_CORR_DATA"              => [   3,  51,   1, 0x0008000000000000, 0x00, 1, 0x0000000000000000, "Mask Correctable IO Write Data Errors" ],
   "IO_WR_TO"                     => [   4,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "Mask IO Write Request Timeout Errors" ],
   "IO_WR_SPURIOUS_MSG"           => [   5,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "Mask Spurious IO Write Responses" ],
   "IO_WR_ACCESS"                 => [   6,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "Mask IO Write Access Errors" ],
   "RSVD1"                        => [   7,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IO_RD_PKT_LEN"                => [   8,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "Mask IO Read Packet Length Errors" ],
   "IO_RD_UNCORR_DATA"            => [   9,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Mask UnCorrectable IO Read Data Errors" ],
   "IO_RD_CORR_DATA"              => [  10,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "Mask Correctable IO Read Data Errors" ],
   "IO_RD_TO"                     => [  11,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "Mask IO Read Request Timeout Errors" ],
   "IO_RD_SPURIOUS_MSG"           => [  12,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "Mask IO Spurious Read Responses" ],
   "IO_RD_ACCESS"                 => [  13,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "Mask IO Read Access Errors" ],
   "RSVD2"                        => [  14,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MEM_WR_PKT_LEN"               => [  15,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "Mask Memory Write Packet Length Errors" ],
   "MEM_WR_UNCORR_DATA"           => [  16,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "Mask UnCorrectable Memory Write Data Errors" ],
   "MEM_WR_CORR_DATA"             => [  17,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "Mask Correctable Memory Write Data Errors" ],
   "MEM_WR_TO"                    => [  18,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "Mask Write Request Timeout Errors" ],
   "MEM_WR_DIR"                   => [  19,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "Mask Memory Write Directory Errors" ],
   "MEM_WR_SPURIOUS_MSG"          => [  20,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "Mask Spurious Memory Write Responses" ],
   "MEM_UCAC_WR_ACCESS"           => [  21,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "Mask Memory UnCached Write Access Errors" ],
   "MEM_CAC_WR_ACCESS"            => [  22,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Mask Memory Cached Write Access Errors" ],
   "RSVD3"                        => [  23,  10,   6, 0x000000000000FC00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MEM_RD_PKT_LEN"               => [  24,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Mask Memory Read Packet Length Errors" ],
   "MEM_RD_UNCORR_DATA"           => [  25,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Mask UnCorrectable Memory Read Data Errors" ],
   "MEM_RD_CORR_DATA"             => [  26,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Mask Correctable Memory Read Data Errors" ],
   "MEM_RD_NACK_CNT"              => [  27,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Mask Memory Read NACK Count Overflow Errors" ],
   "MEM_RD_POISON"                => [  28,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Mask Memory Read Poisoned Access Errors" ],
   "MEM_RD_TO"                    => [  29,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Mask Memory Read Request Timeout Errors" ],
   "MEM_RD_DIR"                   => [  30,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Mask Memory Read Directory Errors" ],
   "MEM_RD_SPURIOUS_MSG"          => [  31,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Mask Spurious Memory Read Responses" ],
   "MEM_UCAC_RD_ACCESS"           => [  32,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Mask Memory UnCached Read Access Errors" ],
   "MEM_CAC_RD_ACCESS"            => [  33,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Mask Memory Cached Read Access Errors" ],
);

%orbit_01_00534_def =
( NAME    => "OC_PI_ERR_SPOOL_MASK",
  ADDRESS => 0x00000000a0000838,
  NOTE    => "The PI_ERR_SPOOL_MASK register is used to control which errors are note written into the memory based Error Spool. When a bit is",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00534_flds
);


##########################################################################
#                                                                        #
#   OC_PI_ERR_SPOOL_COUNT_0_1                                            #
#                                                                        #
##########################################################################

%orbit_01_00535_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  55,   9, 0xFF80000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DWORD_COUNT_1"                => [   1,  32,  23, 0x007FFFFF00000000, 0x00, 1, 0x0000000000000000, "Number of Dwords written to spool 1" ],
   "RSVD1"                        => [   2,  23,   9, 0x00000000FF800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DWORD_COUNT_0"                => [   3,   0,  23, 0x00000000007FFFFF, 0x00, 1, 0x0000000000000000, "Number of Dwords written to spool 0" ],
);

%orbit_01_00535_def =
( NAME    => "OC_PI_ERR_SPOOL_COUNT_0_1",
  ADDRESS => 0x00000000a0000840,
  NOTE    => "The PI_ERR_SPOOL_COUNT_0_1 register is used to provide a count of note the number of Dwords written in spool 0 and 1.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00535_flds
);


##########################################################################
#                                                                        #
#   OC_PI_ERR_SPOOL_COUNT_2_3                                            #
#                                                                        #
##########################################################################

%orbit_01_00536_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  55,   9, 0xFF80000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DWORD_COUNT_3"                => [   1,  32,  23, 0x007FFFFF00000000, 0x00, 1, 0x0000000000000000, "Number of Dwords written to spool 3" ],
   "RSVD1"                        => [   2,  23,   9, 0x00000000FF800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DWORD_COUNT_2"                => [   3,   0,  23, 0x00000000007FFFFF, 0x00, 1, 0x0000000000000000, "Number of Dwords written to spool 2" ],
);

%orbit_01_00536_def =
( NAME    => "OC_PI_ERR_SPOOL_COUNT_2_3",
  ADDRESS => 0x00000000a0000848,
  NOTE    => "The PI_ERR_SPOOL_COUNT_2_3 register is used to provide a count of note the number of Dwords written in spool 2 and 3.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00536_flds
);


##########################################################################
#                                                                        #
#   OC_PI_ERR_SPOOL_COUNT_COMPARE_0_1                                     #
#                                                                        #
##########################################################################

%orbit_01_00537_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COUNT_COMPARE_INTR_EN_1"      => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Count compare interrupt enable for spool 1" ],
   "RSVD0"                        => [   1,  55,   8, 0x7F80000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DWORD_COUNT_COMPARE_1"        => [   2,  32,  23, 0x007FFFFF00000000, 0x00, 1, 0x0000000000000000, "Dword count compare for spool 1" ],
   "COUNT_COMPARE_INTR_EN_0"      => [   3,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "Count compare interrupt enable for spool 0" ],
   "RSVD1"                        => [   4,  23,   8, 0x000000007F800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DWORD_COUNT_COMPARE_0"        => [   5,   0,  23, 0x00000000007FFFFF, 0x00, 1, 0x0000000000000000, "Dword count compare for spool 0" ],
);

%orbit_01_00537_def =
( NAME    => "OC_PI_ERR_SPOOL_COUNT_COMPARE_0_1",
  ADDRESS => 0x00000000a0000850,
  NOTE    => "The PI_ERR_SPOOL_COUNT_COMPARE_0_1 register fields are used to note compare against their corresponding fields in note PI_ERR_SP",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00537_flds
);


##########################################################################
#                                                                        #
#   OC_PI_ERR_SPOOL_COUNT_COMPARE_2_3                                     #
#                                                                        #
##########################################################################

%orbit_01_00538_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COUNT_COMPARE_INTR_EN_3"      => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Count compare interrupt enable for spool 3" ],
   "RSVD0"                        => [   1,  55,   8, 0x7F80000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DWORD_COUNT_COMPARE_3"        => [   2,  32,  23, 0x007FFFFF00000000, 0x00, 1, 0x0000000000000000, "Dword count compare for spool 3" ],
   "COUNT_COMPARE_INTR_EN_2"      => [   3,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "Count compare interrupt enable for spool 2" ],
   "RSVD1"                        => [   4,  23,   8, 0x000000007F800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DWORD_COUNT_COMPARE_2"        => [   5,   0,  23, 0x00000000007FFFFF, 0x00, 1, 0x0000000000000000, "Dword count compare for spool 2" ],
);

%orbit_01_00538_def =
( NAME    => "OC_PI_ERR_SPOOL_COUNT_COMPARE_2_3",
  ADDRESS => 0x00000000a0000858,
  NOTE    => "The PI_ERR_SPOOL_COUNT_COMPARE_2_3 register fields are used to note compare against their corresponding fields in note PI_ERR_SP",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00538_flds
);


##########################################################################
#                                                                        #
#   OC_PI_TEST_POINT_COMPARE                                             #
#                                                                        #
##########################################################################

%orbit_01_00539_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COMPARE_PATTERN"              => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 1, 0x0000000000000000, "Pattern of test point data to cause trigger" ],
   "COMPARE_MASK"                 => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "Mask to select test point data for trigger generation" ],
);

%orbit_01_00539_def =
( NAME    => "OC_PI_TEST_POINT_COMPARE",
  ADDRESS => 0x00000000a0001000,
  NOTE    => "This register controls which test pointed PI signals are delivered note to the Debug sub-block in the LB chiplet.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00539_flds
);


##########################################################################
#                                                                        #
#   OC_PI_TEST_POINT_SELECT                                              #
#                                                                        #
##########################################################################

%orbit_01_00540_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TRIGGER_ENABLE"               => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Enable trigger on bit 32 of Analyzer data" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 1, 0x0000000000000000, "Nibble X is routed to Nibble 7" ],
   "RSVD0"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_CHIPLET_SEL"          => [   3,  56,   3, 0x0700000000000000, 0x00, 1, 0x0000000000000000, "Nibble 7 data is from Chiplet X" ],
   "RSVD1"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 1, 0x0000000000000000, "Nibble X is routed to Nibble 6" ],
   "RSVD2"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_CHIPLET_SEL"          => [   7,  48,   3, 0x0007000000000000, 0x00, 1, 0x0000000000000000, "Nibble 6 data is from Chiplet X" ],
   "RSVD3"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 1, 0x0000000000000000, "Nibble X is routed to Nibble 5" ],
   "RSVD4"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_CHIPLET_SEL"          => [  11,  40,   3, 0x0000070000000000, 0x00, 1, 0x0000000000000000, "Nibble 5 data is from Chiplet X" ],
   "RSVD5"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "Nibble X is routed to Nibble 4" ],
   "RSVD6"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_CHIPLET_SEL"          => [  15,  32,   3, 0x0000000700000000, 0x00, 1, 0x0000000000000000, "Nibble 4 data is from Chiplet X" ],
   "RSVD7"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 1, 0x0000000000000000, "Nibble X is routed to Nibble 3" ],
   "RSVD8"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_CHIPLET_SEL"          => [  19,  24,   3, 0x0000000007000000, 0x00, 1, 0x0000000000000000, "Nibble 3 data is from Chiplet X" ],
   "RSVD9"                        => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 1, 0x0000000000000000, "Nibble X is routed to Nibble 2" ],
   "RSVD10"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_CHIPLET_SEL"          => [  23,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "Nibble 2 data is from Chiplet X" ],
   "RSVD11"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 1, 0x0000000000000000, "Nibble X is routed to Nibble 1" ],
   "RSVD12"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_CHIPLET_SEL"          => [  27,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "Nibble 1 data is from Chiplet X" ],
   "RSVD13"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 1, 0x0000000000000000, "Nibble X is routed to Nibble 0" ],
   "RSVD14"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_CHIPLET_SEL"          => [  31,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Nibble 0 data is from Chiplet X" ],
);

%orbit_01_00540_def =
( NAME    => "OC_PI_TEST_POINT_SELECT",
  ADDRESS => 0x00000000a0001008,
  NOTE    => "This register controls which test pointed PI signals are delivered note to the Debug sub-block in the LB chiplet.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00540_flds
);


##########################################################################
#                                                                        #
#   OC_PI_TEST_POINT_TRIGGER_SELECT                                      #
#                                                                        #
##########################################################################

%orbit_01_00541_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_NIBBLE_SEL"          => [   1,  60,   3, 0x7000000000000000, 0x00, 1, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_CHIPLET_SEL"         => [   3,  56,   3, 0x0700000000000000, 0x00, 1, 0x0000000000000000, "Nibble 7 Chiplet select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_NIBBLE_SEL"          => [   5,  52,   3, 0x0070000000000000, 0x00, 1, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_CHIPLET_SEL"         => [   7,  48,   3, 0x0007000000000000, 0x00, 1, 0x0000000000000000, "Nibble 6 Chiplet select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_NIBBLE_SEL"          => [   9,  44,   3, 0x0000700000000000, 0x00, 1, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_CHIPLET_SEL"         => [  11,  40,   3, 0x0000070000000000, 0x00, 1, 0x0000000000000000, "Nibble 5 Chiplet select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_NIBBLE_SEL"          => [  13,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_CHIPLET_SEL"         => [  15,  32,   3, 0x0000000700000000, 0x00, 1, 0x0000000000000000, "Nibble 4 Chiplet select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_NIBBLE_SEL"          => [  17,  28,   3, 0x0000000070000000, 0x00, 1, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_CHIPLET_SEL"         => [  19,  24,   3, 0x0000000007000000, 0x00, 1, 0x0000000000000000, "Nibble 3 Chiplet select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_NIBBLE_SEL"          => [  21,  20,   3, 0x0000000000700000, 0x00, 1, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_CHIPLET_SEL"         => [  23,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "Nibble 2 Chiplet select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_NIBBLE_SEL"          => [  25,  12,   3, 0x0000000000007000, 0x00, 1, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_CHIPLET_SEL"         => [  27,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "Nibble 1 Chiplet select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_NIBBLE_SEL"          => [  29,   4,   3, 0x0000000000000070, 0x00, 1, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_CHIPLET_SEL"         => [  31,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Nibble 0 Chiplet select" ],
);

%orbit_01_00541_def =
( NAME    => "OC_PI_TEST_POINT_TRIGGER_SELECT",
  ADDRESS => 0x00000000a0001010,
  NOTE    => "PI Test Point Trigger Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00541_flds
);


##########################################################################
#                                                                        #
#   OC_PI_HXB_TEST_POINT_COMPARE                                         #
#                                                                        #
##########################################################################

%orbit_01_00542_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COMPARE_PATTERN"              => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 1, 0x0000000000000000, "Pattern of test point data to cause trigger" ],
   "COMPARE_MASK"                 => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "Mask to select test point data for trigger generation" ],
);

%orbit_01_00542_def =
( NAME    => "OC_PI_HXB_TEST_POINT_COMPARE",
  ADDRESS => 0x00000000a0001020,
  NOTE    => "This register controls which test pointed PI HXB signals are note delivered to the PI Debug sub-block.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00542_flds
);


##########################################################################
#                                                                        #
#   OC_PI_HXB_TEST_POINT_SELECT                                          #
#                                                                        #
##########################################################################

%orbit_01_00543_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TRIGGER_ENABLE"               => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Enable trigger on bit 32 of Analyzer data" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 1, 0x0000000000000000, "Nibble X is routed to Nibble 7" ],
   "RSVD0"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_CHIPLET_SEL"          => [   3,  56,   3, 0x0700000000000000, 0x00, 1, 0x0000000000000000, "Nibble 7 data is from Chiplet X" ],
   "RSVD1"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 1, 0x0000000000000000, "Nibble X is routed to Nibble 6" ],
   "RSVD2"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_CHIPLET_SEL"          => [   7,  48,   3, 0x0007000000000000, 0x00, 1, 0x0000000000000000, "Nibble 6 data is from Chiplet X" ],
   "RSVD3"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 1, 0x0000000000000000, "Nibble X is routed to Nibble 5" ],
   "RSVD4"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_CHIPLET_SEL"          => [  11,  40,   3, 0x0000070000000000, 0x00, 1, 0x0000000000000000, "Nibble 5 data is from Chiplet X" ],
   "RSVD5"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "Nibble X is routed to Nibble 4" ],
   "RSVD6"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_CHIPLET_SEL"          => [  15,  32,   3, 0x0000000700000000, 0x00, 1, 0x0000000000000000, "Nibble 4 data is from Chiplet X" ],
   "RSVD7"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 1, 0x0000000000000000, "Nibble X is routed to Nibble 3" ],
   "RSVD8"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_CHIPLET_SEL"          => [  19,  24,   3, 0x0000000007000000, 0x00, 1, 0x0000000000000000, "Nibble 3 data is from Chiplet X" ],
   "RSVD9"                        => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 1, 0x0000000000000000, "Nibble X is routed to Nibble 2" ],
   "RSVD10"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_CHIPLET_SEL"          => [  23,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "Nibble 2 data is from Chiplet X" ],
   "RSVD11"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 1, 0x0000000000000000, "Nibble X is routed to Nibble 1" ],
   "RSVD12"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_CHIPLET_SEL"          => [  27,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "Nibble 1 data is from Chiplet X" ],
   "RSVD13"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 1, 0x0000000000000000, "Nibble X is routed to Nibble 0" ],
   "RSVD14"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_CHIPLET_SEL"          => [  31,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Nibble 0 data is from Chiplet X" ],
);

%orbit_01_00543_def =
( NAME    => "OC_PI_HXB_TEST_POINT_SELECT",
  ADDRESS => 0x00000000a0001028,
  NOTE    => "This register controls which test pointed PI HXB signals are note delivered to the PI Debug sub-block.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00543_flds
);


##########################################################################
#                                                                        #
#   OC_PI_HXB_TEST_POINT_TRIGGER_SELECT                                     #
#                                                                        #
##########################################################################

%orbit_01_00544_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_NIBBLE_SEL"          => [   1,  60,   3, 0x7000000000000000, 0x00, 1, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_CHIPLET_SEL"         => [   3,  56,   3, 0x0700000000000000, 0x00, 1, 0x0000000000000000, "Nibble 7 Chiplet select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_NIBBLE_SEL"          => [   5,  52,   3, 0x0070000000000000, 0x00, 1, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_CHIPLET_SEL"         => [   7,  48,   3, 0x0007000000000000, 0x00, 1, 0x0000000000000000, "Nibble 6 Chiplet select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_NIBBLE_SEL"          => [   9,  44,   3, 0x0000700000000000, 0x00, 1, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_CHIPLET_SEL"         => [  11,  40,   3, 0x0000070000000000, 0x00, 1, 0x0000000000000000, "Nibble 5 Chiplet select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_NIBBLE_SEL"          => [  13,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_CHIPLET_SEL"         => [  15,  32,   3, 0x0000000700000000, 0x00, 1, 0x0000000000000000, "Nibble 4 Chiplet select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_NIBBLE_SEL"          => [  17,  28,   3, 0x0000000070000000, 0x00, 1, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_CHIPLET_SEL"         => [  19,  24,   3, 0x0000000007000000, 0x00, 1, 0x0000000000000000, "Nibble 3 Chiplet select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_NIBBLE_SEL"          => [  21,  20,   3, 0x0000000000700000, 0x00, 1, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_CHIPLET_SEL"         => [  23,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "Nibble 2 Chiplet select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_NIBBLE_SEL"          => [  25,  12,   3, 0x0000000000007000, 0x00, 1, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_CHIPLET_SEL"         => [  27,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "Nibble 1 Chiplet select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_NIBBLE_SEL"          => [  29,   4,   3, 0x0000000000000070, 0x00, 1, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_CHIPLET_SEL"         => [  31,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Nibble 0 Chiplet select" ],
);

%orbit_01_00544_def =
( NAME    => "OC_PI_HXB_TEST_POINT_TRIGGER_SELECT",
  ADDRESS => 0x00000000a0001030,
  NOTE    => "PI HXB Test Point Trigger Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00544_flds
);


##########################################################################
#                                                                        #
#   OC_PI_MD_RP_CRD_OFLOW_ERR                                            #
#                                                                        #
##########################################################################

%orbit_01_00545_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid" ],
   "OVERFLOW"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Error Overflow" ],
   "RSVD0"                        => [   2,   6,  56, 0x3FFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DETAIL_CRD_CNT"               => [   3,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "Error Detail - Credit Count" ],
);

%orbit_01_00545_def =
( NAME    => "OC_PI_MD_RP_CRD_OFLOW_ERR",
  ADDRESS => 0x00000000a0008810,
  NOTE    => "PI-to-MD Reply Credit Overflow Error Detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00545_flds
);


##########################################################################
#                                                                        #
#   OC_PI_MD_RP_Q_OFLOW_ERR                                              #
#                                                                        #
##########################################################################

%orbit_01_00546_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid" ],
   "OVERFLOW"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Error Overflow" ],
   "DETAIL_ECHO_4_0"              => [   2,  57,   5, 0x3E00000000000000, 0x00, 0, 0x0000000000000000, "Error Detail - Echo[4:0]" ],
   "DETAIL_CMD"                   => [   3,  49,   8, 0x01FE000000000000, 0x00, 0, 0x0000000000000000, "Error Detail - Command" ],
   "DETAIL_SRC"                   => [   4,  35,  14, 0x0001FFF800000000, 0x00, 0, 0x0000000000000000, "Error Detail - Src Node" ],
   "DETAIL_ADDR_37_3"             => [   5,   0,  35, 0x00000007FFFFFFFF, 0x00, 0, 0x0000000000000000, "Error Detail - Address[37:3]" ],
);

%orbit_01_00546_def =
( NAME    => "OC_PI_MD_RP_Q_OFLOW_ERR",
  ADDRESS => 0x00000000a0008818,
  NOTE    => "Error",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00546_flds
);


##########################################################################
#                                                                        #
#   OC_PI_MD_RQ_CRD_OFLOW_ERR                                            #
#                                                                        #
##########################################################################

%orbit_01_00547_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid" ],
   "OVERFLOW"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Error Overflow" ],
   "RSVD0"                        => [   2,   6,  56, 0x3FFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DETAIL_CRD_CNT"               => [   3,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "Error Detail - Credit Count" ],
);

%orbit_01_00547_def =
( NAME    => "OC_PI_MD_RQ_CRD_OFLOW_ERR",
  ADDRESS => 0x00000000a0008820,
  NOTE    => "Error",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00547_flds
);


##########################################################################
#                                                                        #
#   OC_PI_MD_RQ_Q_OFLOW_ERR                                              #
#                                                                        #
##########################################################################

%orbit_01_00548_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid" ],
   "OVERFLOW"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Error Overflow" ],
   "DETAIL_ECHO_4_0"              => [   2,  57,   5, 0x3E00000000000000, 0x00, 0, 0x0000000000000000, "Error Detail - Echo[4:0]" ],
   "DETAIL_CMD"                   => [   3,  49,   8, 0x01FE000000000000, 0x00, 0, 0x0000000000000000, "Error Detail - Command" ],
   "DETAIL_SRC"                   => [   4,  35,  14, 0x0001FFF800000000, 0x00, 0, 0x0000000000000000, "Error Detail - Src Node" ],
   "DETAIL_ADDR_37_3"             => [   5,   0,  35, 0x00000007FFFFFFFF, 0x00, 0, 0x0000000000000000, "Error Detail - Address[37:3]" ],
);

%orbit_01_00548_def =
( NAME    => "OC_PI_MD_RQ_Q_OFLOW_ERR",
  ADDRESS => 0x00000000a0008828,
  NOTE    => "Error",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00548_flds
);


##########################################################################
#                                                                        #
#   OC_PI_XN_RP_CRD_OFLOW_ERR                                            #
#                                                                        #
##########################################################################

%orbit_01_00549_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid" ],
   "OVERFLOW"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Error Overflow" ],
   "RSVD0"                        => [   2,   6,  56, 0x3FFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DETAIL_CRD_CNT"               => [   3,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "Error Detail - Credit Count" ],
);

%orbit_01_00549_def =
( NAME    => "OC_PI_XN_RP_CRD_OFLOW_ERR",
  ADDRESS => 0x00000000a0008830,
  NOTE    => "PI-to-XN Reply Credit Overflow Error Detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00549_flds
);


##########################################################################
#                                                                        #
#   OC_PI_XN_RP_Q_OFLOW_ERR                                              #
#                                                                        #
##########################################################################

%orbit_01_00550_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid" ],
   "OVERFLOW"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Error Overflow" ],
   "DETAIL_ECHO_4_0"              => [   2,  57,   5, 0x3E00000000000000, 0x00, 0, 0x0000000000000000, "Error Detail - Echo[4:0]" ],
   "DETAIL_CMD"                   => [   3,  49,   8, 0x01FE000000000000, 0x00, 0, 0x0000000000000000, "Error Detail - Command" ],
   "DETAIL_SRC"                   => [   4,  35,  14, 0x0001FFF800000000, 0x00, 0, 0x0000000000000000, "Error Detail - Src Node" ],
   "DETAIL_ADDR_37_3"             => [   5,   0,  35, 0x00000007FFFFFFFF, 0x00, 0, 0x0000000000000000, "Error Detail - Address[37:3]" ],
);

%orbit_01_00550_def =
( NAME    => "OC_PI_XN_RP_Q_OFLOW_ERR",
  ADDRESS => 0x00000000a0008838,
  NOTE    => "Error",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00550_flds
);


##########################################################################
#                                                                        #
#   OC_PI_XN_RQ_CRD_OFLOW_ERR                                            #
#                                                                        #
##########################################################################

%orbit_01_00551_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid" ],
   "OVERFLOW"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Error Overflow" ],
   "RSVD0"                        => [   2,   6,  56, 0x3FFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DETAIL_CRD_CNT"               => [   3,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "Error Detail - Credit Count" ],
);

%orbit_01_00551_def =
( NAME    => "OC_PI_XN_RQ_CRD_OFLOW_ERR",
  ADDRESS => 0x00000000a0008840,
  NOTE    => "Error",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00551_flds
);


##########################################################################
#                                                                        #
#   OC_PI_XN_RQ_Q_OFLOW_ERR                                              #
#                                                                        #
##########################################################################

%orbit_01_00552_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid" ],
   "OVERFLOW"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Error Overflow" ],
   "DETAIL_ECHO_4_0"              => [   2,  57,   5, 0x3E00000000000000, 0x00, 0, 0x0000000000000000, "Error Detail - Echo[4:0]" ],
   "DETAIL_CMD"                   => [   3,  49,   8, 0x01FE000000000000, 0x00, 0, 0x0000000000000000, "Error Detail - Command" ],
   "DETAIL_SRC"                   => [   4,  35,  14, 0x0001FFF800000000, 0x00, 0, 0x0000000000000000, "Error Detail - Src Node" ],
   "DETAIL_ADDR_37_3"             => [   5,   0,  35, 0x00000007FFFFFFFF, 0x00, 0, 0x0000000000000000, "Error Detail - Address[37:3]" ],
);

%orbit_01_00552_def =
( NAME    => "OC_PI_XN_RQ_Q_OFLOW_ERR",
  ADDRESS => 0x00000000a0008848,
  NOTE    => "Error",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00552_flds
);


##########################################################################
#                                                                        #
#   OC_PI_PI_DATA_WR_PATH_ERR                                            #
#                                                                        #
##########################################################################

%orbit_01_00553_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid" ],
   "OVERFLOW"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Error Overflow" ],
   "RSVD0"                        => [   2,  12,  50, 0x3FFFFFFFFFFFF000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DETAIL_DXB_XN_D_OUT_DC_Q_OVRFLW" => [   3,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Error Detail DXB XN D_out DC queue overflow" ],
   "DETAIL_DXB_XN_D_OUT_DC_Q_UNDRFLW" => [   4,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Error Detail DXB XN D_out DC queue underflow" ],
   "DETAIL_DXB_MD_D_OUT_DC_Q_OVRFLW" => [   5,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Error Detail DXB MD D_out DC queue overflow" ],
   "DETAIL_DXB_MD_D_OUT_DC_Q_UNDRFLW" => [   6,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Error Detail DXB MD D_out DC queue underflow" ],
   "DETAIL_GDB_PIPE0_OVRFLW"      => [   7,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Error Detail GDB Pipe 0 queue overflow" ],
   "DETAIL_GDB_PIPE0_UNDRFLW"     => [   8,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Error Detail GDB Pipe 0 queue underflow" ],
   "DETAIL_GDB_PIPE1_OVRFLW"      => [   9,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Error Detail GDB Pipe 1 queue overflow" ],
   "DETAIL_GDB_PIPE1_UNDRFLW"     => [  10,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Error Detail GDB Pipe 1 queue underflow" ],
   "DETAIL_DPC_DC_Q_OVRFLW"       => [  11,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Error Detail DPC DC queue overflow" ],
   "DETAIL_DPC_DC_Q_UNDRFLW"      => [  12,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Error Detail DPC DC queue underflow" ],
   "DETAIL_CRB_AND_NCRP_DPC_DC_CLASH" => [  13,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Error Detail CRB and NCRP DPC DC Clash" ],
   "DETAIL_CURR_ITEM_CNT_OVRFLW"  => [  14,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Error Detail DPC Current Item Count Overflow" ],
);

%orbit_01_00553_def =
( NAME    => "OC_PI_PI_DATA_WR_PATH_ERR",
  ADDRESS => 0x00000000a0008880,
  NOTE    => "Error Detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00553_flds
);


##########################################################################
#                                                                        #
#   OC_PI_PI_DATA_RESP_PATH_ERR                                          #
#                                                                        #
##########################################################################

%orbit_01_00554_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid" ],
   "OVERFLOW"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Error Overflow" ],
   "RSVD0"                        => [   2,  12,  50, 0x3FFFFFFFFFFFF000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DETAIL_DXB_D_IN_DC_Q_OVRFLW"  => [   3,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Error Detail DXB D_in DC queue overflow" ],
   "DETAIL_DXB_D_IN_DC_Q_UNDRFLW" => [   4,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Error Detail DXB D_in DC queue underflow" ],
   "DETAIL_XN_SIC_OVRFLW"         => [   5,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Error Detail XN SIC overflow" ],
   "DETAIL_XN_SIC_UNDRFLW"        => [   6,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Error Detail XN SIC underflow" ],
   "DETAIL_MD_SIC_OVRFLW"         => [   7,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Error Detail MD SIC overflow" ],
   "DETAIL_MD_SIC_UNDRFLW"        => [   8,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Error Detail MD SIC underflow" ],
   "DETAIL_RESP_Q_OVRFLW"         => [   9,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Error Detail Response queue overflow" ],
   "DETAIL_RESP_Q_UNDRFLW"        => [  10,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Error Detail Response queue underflow" ],
   "DETAIL_REQ_Q_OVRFLW"          => [  11,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Error Detail Request queue overflow" ],
   "DETAIL_REQ_Q_UNDRFLW"         => [  12,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Error Detail Request queue underflow" ],
   "DETAIL_INTRPT_Q_OVRFLW"       => [  13,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Error Detail Interrupt queue overflow" ],
   "DETAIL_INTRPT_Q_UNDRFLW"      => [  14,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Error Detail Interrupt queue underflow" ],
);

%orbit_01_00554_def =
( NAME    => "OC_PI_PI_DATA_RESP_PATH_ERR",
  ADDRESS => 0x00000000a0008888,
  NOTE    => "Error Detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00554_flds
);


##########################################################################
#                                                                        #
#   OC_SYSTF_RESET_STATUS                                                #
#                                                                        #
##########################################################################

%orbit_01_00555_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   6,  58, 0xFFFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CPU1_ERR_DETECTED"            => [   1,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "CPU1 has error" ],
   "CPU0_ERR_DETECTED"            => [   2,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "CPU0 has error" ],
   "CPU1_GOOD"                    => [   3,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "CPU1 is Ok and has returned Sync token" ],
   "CPU0_GOOD"                    => [   4,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "CPU0 is Ok and has returned Sync token" ],
   "CPU1_PRESENT"                 => [   5,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "CPU1 is present" ],
   "CPU0_PRESENT"                 => [   6,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "CPU0 is present" ],
);

%orbit_01_00555_def =
( NAME    => "OC_SYSTF_RESET_STATUS",
  ADDRESS => 0x00000000a0010080,
  NOTE    => "The SYSTF_RESET_STATUS register provides status for the SysTF Bus",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00555_flds
);


##########################################################################
#                                                                        #
#   OC_SYSTF_RESET_FORCE_SYNC_BACKFLAP                                     #
#                                                                        #
##########################################################################

%orbit_01_00556_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   2,  62, 0xFFFFFFFFFFFFFFFC, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CPU1_FORCE_SYNC_BACKFLAP"     => [   1,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Force CPU1 to sync by asserting p1_force_sync" ],
   "CPU0_FORCE_SYNC_BACKFLAP"     => [   2,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Force CPU0 to sync by asserting p0_force_sync" ],
);

%orbit_01_00556_def =
( NAME    => "OC_SYSTF_RESET_FORCE_SYNC_BACKFLAP",
  ADDRESS => 0x00000000a0010088,
  NOTE    => "The SYSTF_FORCE_SYNC_BACKFLAP MMR",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00556_flds
);


##########################################################################
#                                                                        #
#   OC_SYSTF_RESET_SEQ_DELAY0                                            #
#                                                                        #
##########################################################################

%orbit_01_00557_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INIT_WINDOW_DELAY"            => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 1, 0x0000000000000000, "Nr of cycles to wait after Orbit hard_reset is deasserted for internal N1 clocks to stabilize" ],
   "SOFT_RESET_DELAY"             => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "Nr of cycles to assert SysReset for Soft Reset Sequence" ],
);

%orbit_01_00557_def =
( NAME    => "OC_SYSTF_RESET_SEQ_DELAY0",
  ADDRESS => 0x00000000a0010008,
  NOTE    => "This register provides config for mode bits for the SysTF Bus",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00557_flds
);


##########################################################################
#                                                                        #
#   OC_SYSTF_RESET_SEQ_DELAY1                                            #
#                                                                        #
##########################################################################

%orbit_01_00558_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CPU0_TO_CPU1_MODE_DELAY"      => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 1, 0x0000000000000000, "Nr of cycles to wait after presenting mode bits to CPU0 before presenting mode bits to CPU1" ],
   "RESET_TO_CPU0_MODE_DELAY"     => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "Nr of cycles to wait after Orbit's hard or soft reset before presenting mode bits to CPU0" ],
);

%orbit_01_00558_def =
( NAME    => "OC_SYSTF_RESET_SEQ_DELAY1",
  ADDRESS => 0x00000000a0010010,
  NOTE    => "This register provides config for mode bits for the SysTF Bus",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00558_flds
);


##########################################################################
#                                                                        #
#   OC_SYSTF_RESET_SEQ_DELAY2                                            #
#                                                                        #
##########################################################################

%orbit_01_00559_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SYSRESP_TO_CPU_DETECT_DELAY"  => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 1, 0x0000000000000000, "Nr of cycles to wait after asserting SysResp before asserting CPU Detect Enable" ],
   "CPU1_MODE_TO_SYSRESP_DELAY"   => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "Nr of cycles to wait after CPU1 mode bits are sent before asserting SysResp for synchronization" ],
);

%orbit_01_00559_def =
( NAME    => "OC_SYSTF_RESET_SEQ_DELAY2",
  ADDRESS => 0x00000000a0010018,
  NOTE    => "This register provides config for mode bits for the SysTF Bus",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00559_flds
);


##########################################################################
#                                                                        #
#   OC_SYSTF_RESET_SEQ_DELAY3                                            #
#                                                                        #
##########################################################################

%orbit_01_00560_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CPU_DETECT_TO_SYNC_DETECT_DELAY" => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 1, 0x0000000000000000, "Nr of cycles to wait after CPU is detected to sending the first Sync token" ],
   "CPU_DETECT_TIMEOUT_DELAY"     => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "Nr of cycles to wait after the first returning Sync token to deasserting Sysreset" ],
);

%orbit_01_00560_def =
( NAME    => "OC_SYSTF_RESET_SEQ_DELAY3",
  ADDRESS => 0x00000000a0010020,
  NOTE    => "This register provides config for mode bits for the SysTF Bus",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00560_flds
);


##########################################################################
#                                                                        #
#   OC_SYSTF_RESET_SEQ_DELAY4                                            #
#                                                                        #
##########################################################################

%orbit_01_00561_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SYNC_DETECT_TO_SYSRESET_DELAY" => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 1, 0x0000000000000000, "Nr of cycles to after first Sync token returns to deasserting SysReset" ],
   "SYNC_TOKEN_PERIOD"            => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "Nr of cycles between sending out a Sync Token" ],
);

%orbit_01_00561_def =
( NAME    => "OC_SYSTF_RESET_SEQ_DELAY4",
  ADDRESS => 0x00000000a0010028,
  NOTE    => "This register provides config for mode bits for the SysTF Bus",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00561_flds
);


##########################################################################
#                                                                        #
#   OC_SYSTF_RESET_SEQ_DELAY5                                            #
#                                                                        #
##########################################################################

%orbit_01_00562_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SYNC_DETECT_TIMEOUT_DELAY"    => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "Nr of cycles waiting for Sync Token to return before timing out" ],
);

%orbit_01_00562_def =
( NAME    => "OC_SYSTF_RESET_SEQ_DELAY5",
  ADDRESS => 0x00000000a0010030,
  NOTE    => "This register provides config for mode bits for the SysTF Bus",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00562_flds
);


##########################################################################
#                                                                        #
#   OC_SYSTF_RESET_MODE_HW_CPU0                                          #
#                                                                        #
##########################################################################

%orbit_01_00563_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CONFIG1"                      => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 1, 0x0000000000000000, "Config1 register mode bits for processor" ],
   "CONFIG0"                      => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "Config0 register mode bits for processor" ],
);

%orbit_01_00563_def =
( NAME    => "OC_SYSTF_RESET_MODE_HW_CPU0",
  ADDRESS => 0x00000000a0010100,
  NOTE    => "This register provides mode bits for the SysTF Bus",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00563_flds
);


##########################################################################
#                                                                        #
#   OC_SYSTF_RESET_MODE_HW_CPU1                                          #
#                                                                        #
##########################################################################

%orbit_01_00564_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CONFIG1"                      => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 1, 0x0000000000000000, "Config1 register mode bits for processor" ],
   "CONFIG0"                      => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "Config0 register mode bits for processor" ],
);

%orbit_01_00564_def =
( NAME    => "OC_SYSTF_RESET_MODE_HW_CPU1",
  ADDRESS => 0x00000000a0010108,
  NOTE    => "This register provides mode bits for the SysTF Bus",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00564_flds
);


##########################################################################
#                                                                        #
#   OC_SYSTF_RESET_MODE_SW_CPU0                                          #
#                                                                        #
##########################################################################

%orbit_01_00565_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CONFIG3"                      => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 1, 0x0000000000000000, "Config3 register mode bits for processor 0" ],
   "CONFIG2"                      => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "Config2 register mode bits for processor 0" ],
);

%orbit_01_00565_def =
( NAME    => "OC_SYSTF_RESET_MODE_SW_CPU0",
  ADDRESS => 0x00000000a0010110,
  NOTE    => "This register provides mode bits for the SysTF Bus",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00565_flds
);


##########################################################################
#                                                                        #
#   OC_SYSTF_RESET_MODE_SW_CPU1                                          #
#                                                                        #
##########################################################################

%orbit_01_00566_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CONFIG5"                      => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 1, 0x0000000000000000, "Config5 register mode bits for processor 1" ],
   "CONFIG4"                      => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "Config4 register mode bits for processor 1" ],
);

%orbit_01_00566_def =
( NAME    => "OC_SYSTF_RESET_MODE_SW_CPU1",
  ADDRESS => 0x00000000a0010118,
  NOTE    => "This register provides mode bits for the SysTF Bus",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00566_flds
);


##########################################################################
#                                                                        #
#   OC_PI_SYSTF_ERROR_INJECTION                                          #
#                                                                        #
##########################################################################

%orbit_01_00567_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DW3_UCE_FROM_SYSTF"           => [   1,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Inject a Uncorrectable Error in Doubleword 0 of SIC Data Packet 0" ],
   "DW3_CE_FROM_SYSTF"            => [   2,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "Inject a Correctable Error in Doubleword 0 of SIC Data Packet 0" ],
   "DW2_UCE_FROM_SYSTF"           => [   3,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "Inject a Uncorrectable Error in Doubleword 0 of SIC Data Packet 0" ],
   "DW2_CE_FROM_SYSTF"            => [   4,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Inject a Correctable Error in Doubleword 0 of SIC Data Packet 0" ],
   "DW1_UCE_FROM_SYSTF"           => [   5,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Inject a Uncorrectable Error in Doubleword 0 of SIC Data Packet 0" ],
   "DW1_CE_FROM_SYSTF"            => [   6,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Inject a Correctable Error in Doubleword 0 of SIC Data Packet 0" ],
   "DW0_UCE_FROM_SYSTF"           => [   7,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Inject a Uncorrectable Error in Doubleword 0 of SIC Data Packet 0" ],
   "DW0_CE_FROM_SYSTF"            => [   8,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Inject a Correctable Error in Doubleword 0 of SIC Data Packet 0" ],
   "RSVD1"                        => [   9,  17,   3, 0x00000000000E0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_PE_FROM_SYSTF"             => [  10,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Inject a RP# Parity Error When Sampling the SYSTF" ],
   "RSVD2"                        => [  11,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PH1_UCE_TO_SYST"              => [  12,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Inject an Uncorrectable Error in phase 1 onto the SYST" ],
   "PH1_CE_TO_SYST"               => [  13,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Inject a Correctable Error in phase 1 onto the SYST" ],
   "PH0_UCE_TO_SYST"              => [  14,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Inject an Uncorrectable Error in phase 0 onto the SYST" ],
   "PH0_CE_TO_SYST"               => [  15,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Inject a Correctable Error in phase 0 onto the SYST" ],
   "DW1_UCE_TO_SYSF"              => [  16,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Inject an Uncorrectable Error in Doubleword 1 onto the SYSF" ],
   "DW1_CE_TO_SYSF"               => [  17,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Inject a Correctable Error in Doubleword 1 onto the SYSF" ],
   "DW0_UCE_TO_SYSF"              => [  18,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Inject an Uncorrectable Error in Doubleword 0 onto the SYSF" ],
   "DW0_CE_TO_SYSF"               => [  19,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Inject a Correctable Error in Doubleword 0 onto the SYSF" ],
   "RSP_PE_TO_SYSF"               => [  20,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Inject a RSP# Parity Error onto the SYSTF" ],
);

%orbit_01_00567_def =
( NAME    => "OC_PI_SYSTF_ERROR_INJECTION",
  ADDRESS => 0x00000000a0010808,
  NOTE    => "This register provides error injection cababilities for the SYSTF. note Setting a bit in this register will cause the correspond",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00567_flds
);


##########################################################################
#                                                                        #
#   OC_PI_SYSTF_COMPARE_VALUE                                            #
#                                                                        #
##########################################################################

%orbit_01_00568_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COMPARE_VALUE"                => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Compare value" ],
);

%orbit_01_00568_def =
( NAME    => "OC_PI_SYSTF_COMPARE_VALUE",
  ADDRESS => 0x00000000a0011000,
  NOTE    => "This register is used to generate a signal to the TFI debug logic note indicating that the compare value matched a selected set ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00568_flds
);


##########################################################################
#                                                                        #
#   OC_PI_SYSTF_COMPARE_MASK                                             #
#                                                                        #
##########################################################################

%orbit_01_00569_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK_VALUE"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Mask value" ],
);

%orbit_01_00569_def =
( NAME    => "OC_PI_SYSTF_COMPARE_MASK",
  ADDRESS => 0x00000000a0011008,
  NOTE    => "This register is used to mask bits of the compare value MMR from note participating in the compare.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00569_flds
);


##########################################################################
#                                                                        #
#   OC_PI_DATA_TEST_POINT_COMPARE0                                       #
#                                                                        #
##########################################################################

%orbit_01_00570_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COMPARE_PATTERN"              => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 1, 0x0000000000000000, "debug bit pattern for trigger generation" ],
   "COMPARE_MASK"                 => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "Mask to select Debug bits for trigger generation" ],
);

%orbit_01_00570_def =
( NAME    => "OC_PI_DATA_TEST_POINT_COMPARE0",
  ADDRESS => 0x00000000a0011030,
  NOTE    => "PI Data Test Point Compare 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00570_flds
);


##########################################################################
#                                                                        #
#   OC_PI_DATA_TEST_POINT_SELECT0                                        #
#                                                                        #
##########################################################################

%orbit_01_00571_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TRIGGER_ENABLE"               => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Enable trigger on bit 32 of Analyzer data" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 1, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD0"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_CHIPLET_SEL"          => [   3,  56,   3, 0x0700000000000000, 0x00, 1, 0x0000000000000000, "Nibble 7 Chiplet select" ],
   "RSVD1"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 1, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD2"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_CHIPLET_SEL"          => [   7,  48,   3, 0x0007000000000000, 0x00, 1, 0x0000000000000000, "Nibble 6 Chiplet select" ],
   "RSVD3"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 1, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD4"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_CHIPLET_SEL"          => [  11,  40,   3, 0x0000070000000000, 0x00, 1, 0x0000000000000000, "Nibble 5 Chiplet select" ],
   "RSVD5"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD6"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_CHIPLET_SEL"          => [  15,  32,   3, 0x0000000700000000, 0x00, 1, 0x0000000000000000, "Nibble 4 Chiplet select" ],
   "RSVD7"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 1, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD8"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_CHIPLET_SEL"          => [  19,  24,   3, 0x0000000007000000, 0x00, 1, 0x0000000000000000, "Nibble 3 Chiplet select" ],
   "RSVD9"                        => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 1, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD10"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_CHIPLET_SEL"          => [  23,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "Nibble 2 Chiplet select" ],
   "RSVD11"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 1, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD12"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_CHIPLET_SEL"          => [  27,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "Nibble 1 Chiplet select" ],
   "RSVD13"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 1, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD14"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_CHIPLET_SEL"          => [  31,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Nibble 0 Chiplet select" ],
);

%orbit_01_00571_def =
( NAME    => "OC_PI_DATA_TEST_POINT_SELECT0",
  ADDRESS => 0x00000000a0011038,
  NOTE    => "PI DATA Test Point Select 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00571_flds
);


##########################################################################
#                                                                        #
#   OC_PI_DATA_TEST_POINT_TRIGGER_SELECT0                                     #
#                                                                        #
##########################################################################

%orbit_01_00572_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_NIBBLE_SEL"          => [   1,  60,   3, 0x7000000000000000, 0x00, 1, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_CHIPLET_SEL"         => [   3,  56,   3, 0x0700000000000000, 0x00, 1, 0x0000000000000000, "Nibble 7 Chiplet select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_NIBBLE_SEL"          => [   5,  52,   3, 0x0070000000000000, 0x00, 1, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_CHIPLET_SEL"         => [   7,  48,   3, 0x0007000000000000, 0x00, 1, 0x0000000000000000, "Nibble 6 Chiplet select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_NIBBLE_SEL"          => [   9,  44,   3, 0x0000700000000000, 0x00, 1, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_CHIPLET_SEL"         => [  11,  40,   3, 0x0000070000000000, 0x00, 1, 0x0000000000000000, "Nibble 5 Chiplet select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_NIBBLE_SEL"          => [  13,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_CHIPLET_SEL"         => [  15,  32,   3, 0x0000000700000000, 0x00, 1, 0x0000000000000000, "Nibble 4 Chiplet select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_NIBBLE_SEL"          => [  17,  28,   3, 0x0000000070000000, 0x00, 1, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_CHIPLET_SEL"         => [  19,  24,   3, 0x0000000007000000, 0x00, 1, 0x0000000000000000, "Nibble 3 Chiplet select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_NIBBLE_SEL"          => [  21,  20,   3, 0x0000000000700000, 0x00, 1, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_CHIPLET_SEL"         => [  23,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "Nibble 2 Chiplet select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_NIBBLE_SEL"          => [  25,  12,   3, 0x0000000000007000, 0x00, 1, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_CHIPLET_SEL"         => [  27,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "Nibble 1 Chiplet select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_NIBBLE_SEL"          => [  29,   4,   3, 0x0000000000000070, 0x00, 1, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_CHIPLET_SEL"         => [  31,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Nibble 0 Chiplet select" ],
);

%orbit_01_00572_def =
( NAME    => "OC_PI_DATA_TEST_POINT_TRIGGER_SELECT0",
  ADDRESS => 0x00000000a0011040,
  NOTE    => "PI DATA Test Point Trigger Select 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00572_flds
);


##########################################################################
#                                                                        #
#   OC_PI_DATA_TEST_POINT_COMPARE1                                       #
#                                                                        #
##########################################################################

%orbit_01_00573_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COMPARE_PATTERN"              => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 1, 0x0000000000000000, "debug bit pattern for trigger generation" ],
   "COMPARE_MASK"                 => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "Mask to select Debug bits for trigger generation" ],
);

%orbit_01_00573_def =
( NAME    => "OC_PI_DATA_TEST_POINT_COMPARE1",
  ADDRESS => 0x00000000a0011050,
  NOTE    => "PI Data Test Point Compare 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00573_flds
);


##########################################################################
#                                                                        #
#   OC_PI_DATA_TEST_POINT_SELECT1                                        #
#                                                                        #
##########################################################################

%orbit_01_00574_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TRIGGER_ENABLE"               => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Enable trigger on bit 32 of Analyzer data" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 1, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD0"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_CHIPLET_SEL"          => [   3,  56,   3, 0x0700000000000000, 0x00, 1, 0x0000000000000000, "Nibble 7 Chiplet select" ],
   "RSVD1"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 1, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD2"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_CHIPLET_SEL"          => [   7,  48,   3, 0x0007000000000000, 0x00, 1, 0x0000000000000000, "Nibble 6 Chiplet select" ],
   "RSVD3"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 1, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD4"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_CHIPLET_SEL"          => [  11,  40,   3, 0x0000070000000000, 0x00, 1, 0x0000000000000000, "Nibble 5 Chiplet select" ],
   "RSVD5"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD6"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_CHIPLET_SEL"          => [  15,  32,   3, 0x0000000700000000, 0x00, 1, 0x0000000000000000, "Nibble 4 Chiplet select" ],
   "RSVD7"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 1, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD8"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_CHIPLET_SEL"          => [  19,  24,   3, 0x0000000007000000, 0x00, 1, 0x0000000000000000, "Nibble 3 Chiplet select" ],
   "RSVD9"                        => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 1, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD10"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_CHIPLET_SEL"          => [  23,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "Nibble 2 Chiplet select" ],
   "RSVD11"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 1, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD12"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_CHIPLET_SEL"          => [  27,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "Nibble 1 Chiplet select" ],
   "RSVD13"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 1, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD14"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_CHIPLET_SEL"          => [  31,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Nibble 0 Chiplet select" ],
);

%orbit_01_00574_def =
( NAME    => "OC_PI_DATA_TEST_POINT_SELECT1",
  ADDRESS => 0x00000000a0011058,
  NOTE    => "PI DATA Test Point Select 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00574_flds
);


##########################################################################
#                                                                        #
#   OC_PI_DATA_TEST_POINT_TRIGGER_SELECT1                                     #
#                                                                        #
##########################################################################

%orbit_01_00575_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_NIBBLE_SEL"          => [   1,  60,   3, 0x7000000000000000, 0x00, 1, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_CHIPLET_SEL"         => [   3,  56,   3, 0x0700000000000000, 0x00, 1, 0x0000000000000000, "Nibble 7 Chiplet select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_NIBBLE_SEL"          => [   5,  52,   3, 0x0070000000000000, 0x00, 1, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_CHIPLET_SEL"         => [   7,  48,   3, 0x0007000000000000, 0x00, 1, 0x0000000000000000, "Nibble 6 Chiplet select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_NIBBLE_SEL"          => [   9,  44,   3, 0x0000700000000000, 0x00, 1, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_CHIPLET_SEL"         => [  11,  40,   3, 0x0000070000000000, 0x00, 1, 0x0000000000000000, "Nibble 5 Chiplet select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_NIBBLE_SEL"          => [  13,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_CHIPLET_SEL"         => [  15,  32,   3, 0x0000000700000000, 0x00, 1, 0x0000000000000000, "Nibble 4 Chiplet select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_NIBBLE_SEL"          => [  17,  28,   3, 0x0000000070000000, 0x00, 1, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_CHIPLET_SEL"         => [  19,  24,   3, 0x0000000007000000, 0x00, 1, 0x0000000000000000, "Nibble 3 Chiplet select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_NIBBLE_SEL"          => [  21,  20,   3, 0x0000000000700000, 0x00, 1, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_CHIPLET_SEL"         => [  23,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "Nibble 2 Chiplet select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_NIBBLE_SEL"          => [  25,  12,   3, 0x0000000000007000, 0x00, 1, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_CHIPLET_SEL"         => [  27,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "Nibble 1 Chiplet select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_NIBBLE_SEL"          => [  29,   4,   3, 0x0000000000000070, 0x00, 1, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_CHIPLET_SEL"         => [  31,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Nibble 0 Chiplet select" ],
);

%orbit_01_00575_def =
( NAME    => "OC_PI_DATA_TEST_POINT_TRIGGER_SELECT1",
  ADDRESS => 0x00000000a0011060,
  NOTE    => "PI DATA Test Point Trigger Select 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00575_flds
);


##########################################################################
#                                                                        #
#   OC_PI_DATA_TEST_POINT_COMPARE2                                       #
#                                                                        #
##########################################################################

%orbit_01_00576_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COMPARE_PATTERN"              => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 1, 0x0000000000000000, "debug bit pattern for trigger generation" ],
   "COMPARE_MASK"                 => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "Mask to select Debug bits for trigger generation" ],
);

%orbit_01_00576_def =
( NAME    => "OC_PI_DATA_TEST_POINT_COMPARE2",
  ADDRESS => 0x00000000a0011070,
  NOTE    => "PI Data Test Point Compare 2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00576_flds
);


##########################################################################
#                                                                        #
#   OC_PI_DATA_TEST_POINT_SELECT2                                        #
#                                                                        #
##########################################################################

%orbit_01_00577_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TRIGGER_ENABLE"               => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Enable trigger on bit 32 of Analyzer data" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 1, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD0"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_CHIPLET_SEL"          => [   3,  56,   3, 0x0700000000000000, 0x00, 1, 0x0000000000000000, "Nibble 7 Chiplet select" ],
   "RSVD1"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 1, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD2"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_CHIPLET_SEL"          => [   7,  48,   3, 0x0007000000000000, 0x00, 1, 0x0000000000000000, "Nibble 6 Chiplet select" ],
   "RSVD3"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 1, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD4"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_CHIPLET_SEL"          => [  11,  40,   3, 0x0000070000000000, 0x00, 1, 0x0000000000000000, "Nibble 5 Chiplet select" ],
   "RSVD5"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD6"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_CHIPLET_SEL"          => [  15,  32,   3, 0x0000000700000000, 0x00, 1, 0x0000000000000000, "Nibble 4 Chiplet select" ],
   "RSVD7"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 1, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD8"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_CHIPLET_SEL"          => [  19,  24,   3, 0x0000000007000000, 0x00, 1, 0x0000000000000000, "Nibble 3 Chiplet select" ],
   "RSVD9"                        => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 1, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD10"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_CHIPLET_SEL"          => [  23,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "Nibble 2 Chiplet select" ],
   "RSVD11"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 1, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD12"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_CHIPLET_SEL"          => [  27,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "Nibble 1 Chiplet select" ],
   "RSVD13"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 1, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD14"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_CHIPLET_SEL"          => [  31,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Nibble 0 Chiplet select" ],
);

%orbit_01_00577_def =
( NAME    => "OC_PI_DATA_TEST_POINT_SELECT2",
  ADDRESS => 0x00000000a0011078,
  NOTE    => "PI DATA Test Point Select 2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00577_flds
);


##########################################################################
#                                                                        #
#   OC_PI_DATA_TEST_POINT_TRIGGER_SELECT2                                     #
#                                                                        #
##########################################################################

%orbit_01_00578_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_NIBBLE_SEL"          => [   1,  60,   3, 0x7000000000000000, 0x00, 1, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_CHIPLET_SEL"         => [   3,  56,   3, 0x0700000000000000, 0x00, 1, 0x0000000000000000, "Nibble 7 Chiplet select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_NIBBLE_SEL"          => [   5,  52,   3, 0x0070000000000000, 0x00, 1, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_CHIPLET_SEL"         => [   7,  48,   3, 0x0007000000000000, 0x00, 1, 0x0000000000000000, "Nibble 6 Chiplet select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_NIBBLE_SEL"          => [   9,  44,   3, 0x0000700000000000, 0x00, 1, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_CHIPLET_SEL"         => [  11,  40,   3, 0x0000070000000000, 0x00, 1, 0x0000000000000000, "Nibble 5 Chiplet select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_NIBBLE_SEL"          => [  13,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_CHIPLET_SEL"         => [  15,  32,   3, 0x0000000700000000, 0x00, 1, 0x0000000000000000, "Nibble 4 Chiplet select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_NIBBLE_SEL"          => [  17,  28,   3, 0x0000000070000000, 0x00, 1, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_CHIPLET_SEL"         => [  19,  24,   3, 0x0000000007000000, 0x00, 1, 0x0000000000000000, "Nibble 3 Chiplet select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_NIBBLE_SEL"          => [  21,  20,   3, 0x0000000000700000, 0x00, 1, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_CHIPLET_SEL"         => [  23,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "Nibble 2 Chiplet select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_NIBBLE_SEL"          => [  25,  12,   3, 0x0000000000007000, 0x00, 1, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_CHIPLET_SEL"         => [  27,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "Nibble 1 Chiplet select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_NIBBLE_SEL"          => [  29,   4,   3, 0x0000000000000070, 0x00, 1, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_CHIPLET_SEL"         => [  31,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Nibble 0 Chiplet select" ],
);

%orbit_01_00578_def =
( NAME    => "OC_PI_DATA_TEST_POINT_TRIGGER_SELECT2",
  ADDRESS => 0x00000000a0011080,
  NOTE    => "PI DATA Test Point Trigger Select 2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00578_flds
);


##########################################################################
#                                                                        #
#   OC_PI_ORBIT_CE_ERR                                                   #
#                                                                        #
##########################################################################

%orbit_01_00579_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Valid" ],
   "OVERFLOW"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Error Overflow" ],
   "DETAIL"                       => [   2,   0,  62, 0x3FFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Error Detail" ],
);

%orbit_01_00579_def =
( NAME    => "OC_PI_ORBIT_CE_ERR",
  ADDRESS => 0x00000000a0018800,
  NOTE    => "Error Detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00579_flds
);


##########################################################################
#                                                                        #
#   OC_PI_SYSTF_CE_ERR                                                   #
#                                                                        #
##########################################################################

%orbit_01_00580_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Valid" ],
   "OVERFLOW"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Error Overflow" ],
   "DETAIL"                       => [   2,   0,  62, 0x3FFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Error Detail" ],
);

%orbit_01_00580_def =
( NAME    => "OC_PI_SYSTF_CE_ERR",
  ADDRESS => 0x00000000a0018808,
  NOTE    => "Error Detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00580_flds
);


##########################################################################
#                                                                        #
#   OC_PI_ORBIT_UCE_ERR                                                  #
#                                                                        #
##########################################################################

%orbit_01_00581_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Valid" ],
   "OVERFLOW"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Error Overflow" ],
   "DETAIL"                       => [   2,   0,  62, 0x3FFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Error Detail" ],
);

%orbit_01_00581_def =
( NAME    => "OC_PI_ORBIT_UCE_ERR",
  ADDRESS => 0x00000000a0018810,
  NOTE    => "Error Detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00581_flds
);


##########################################################################
#                                                                        #
#   OC_PI_SYSTF_UCE_ERR                                                  #
#                                                                        #
##########################################################################

%orbit_01_00582_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Valid" ],
   "OVERFLOW"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Error Overflow" ],
   "DETAIL"                       => [   2,   0,  62, 0x3FFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Error Detail" ],
);

%orbit_01_00582_def =
( NAME    => "OC_PI_SYSTF_UCE_ERR",
  ADDRESS => 0x00000000a0018818,
  NOTE    => "Error Detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00582_flds
);


##########################################################################
#                                                                        #
#   OC_PI_BAD_REQUEST_ERR                                                #
#                                                                        #
##########################################################################

%orbit_01_00583_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Valid" ],
   "OVERFLOW"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Error Overflow" ],
   "DETAIL"                       => [   2,   0,  62, 0x3FFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Error Detail" ],
);

%orbit_01_00583_def =
( NAME    => "OC_PI_BAD_REQUEST_ERR",
  ADDRESS => 0x00000000a0018820,
  NOTE    => "Error Detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00583_flds
);


##########################################################################
#                                                                        #
#   OC_PI_BAD_DATA_ERR                                                   #
#                                                                        #
##########################################################################

%orbit_01_00584_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Valid" ],
   "OVERFLOW"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Error Overflow" ],
   "DETAIL"                       => [   2,   0,  62, 0x3FFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Error Detail" ],
);

%orbit_01_00584_def =
( NAME    => "OC_PI_BAD_DATA_ERR",
  ADDRESS => 0x00000000a0018828,
  NOTE    => "Error Detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00584_flds
);


##########################################################################
#                                                                        #
#   OC_PI_BAD_STATE_RESP_ERR                                             #
#                                                                        #
##########################################################################

%orbit_01_00585_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Valid" ],
   "OVERFLOW"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Error Overflow" ],
   "DETAIL"                       => [   2,   0,  62, 0x3FFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Error Detail" ],
);

%orbit_01_00585_def =
( NAME    => "OC_PI_BAD_STATE_RESP_ERR",
  ADDRESS => 0x00000000a0018830,
  NOTE    => "Error Detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00585_flds
);


##########################################################################
#                                                                        #
#   OC_TFI_EVENT_TRIGGER                                                 #
#                                                                        #
##########################################################################

%orbit_01_00586_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   2,  62, 0xFFFFFFFFFFFFFFFC, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VALID"                        => [   1,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Valid" ],
   "OVERFLOW"                     => [   2,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Error Overflow" ],
);

%orbit_01_00586_def =
( NAME    => "OC_TFI_EVENT_TRIGGER",
  ADDRESS => 0x00000000a0018848,
  NOTE    => "TFI Trigger Events Valid/Overflow Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00586_flds
);


##########################################################################
#                                                                        #
#   OC_PI_CRB_MESSAGE_CONTROL                                            #
#                                                                        #
##########################################################################

%orbit_01_00587_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SYS_DRAIN_DURATION"           => [   0,  48,  16, 0xFFFF000000000000, 0x00, 1, 0x0000000000000000, "Flush duration controls" ],
   "SYS_DRAIN_INTERVAL"           => [   1,  32,  16, 0x0000FFFF00000000, 0x00, 1, 0x0000000000000000, "Flush interval controls" ],
   "RSVD0"                        => [   2,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCRATCH"                      => [   3,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "scratch bits" ],
   "REVISION"                     => [   4,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "quick revision ID" ],
   "RSVD1"                        => [   5,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PLANE_HINT_EN"                => [   6,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Enable Assertion of Plane Hints within requests" ],
   "MSG_COLOR_EN"                 => [   7,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Enable color message processing" ],
   "MSG_COLOR"                    => [   8,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Define color of message" ],
   "REMOTE_SPEC_MSG_EN"           => [   9,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Speculative Read Requests to Remote Memory Enabled" ],
   "LOCAL_SPEC_MSG_EN"            => [  10,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Speculative Read Requests to Local Memory Enabled" ],
);

%orbit_01_00587_def =
( NAME    => "OC_PI_CRB_MESSAGE_CONTROL",
  ADDRESS => 0x00000000a0020000,
  NOTE    => "The CRB_MESSAGE_CONTROL register determines the types of messages note generated by the Orbit.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00587_flds
);


##########################################################################
#                                                                        #
#   OC_PI_CRB_NACK_LIMIT                                                 #
#                                                                        #
##########################################################################

%orbit_01_00588_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NACK_EN"                      => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Enable NACK limit detection" ],
   "RSVD0"                        => [   1,  16,  47, 0x7FFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRI_FREQ"                     => [   2,  12,   4, 0x000000000000F000, 0x00, 1, 0x0000000000000000, "Frequency at which priority count is incremented" ],
   "LIMIT"                        => [   3,   0,  12, 0x0000000000000FFF, 0x00, 1, 0x0000000000000000, "Nack Count Limit" ],
);

%orbit_01_00588_def =
( NAME    => "OC_PI_CRB_NACK_LIMIT",
  ADDRESS => 0x00000000a0020010,
  NOTE    => "This register controls the NACK limit (i.e., the permissible number note of consecutive NACKs per RRB entry). When the RRB NACK ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00588_flds
);


##########################################################################
#                                                                        #
#   OC_CRB_TIMEOUT_PRESCALE                                              #
#                                                                        #
##########################################################################

%orbit_01_00589_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCALING_FACTOR"               => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "CRB Time-out Prescale Factor" ],
);

%orbit_01_00589_def =
( NAME    => "OC_CRB_TIMEOUT_PRESCALE",
  ADDRESS => 0x00000000a0020020,
  NOTE    => "This register controls the frequency at which the CRB entry timers note are incremented. The value loaded into this register rep",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00589_flds
);


##########################################################################
#                                                                        #
#   OC_PI_CRB_TIMEOUT_CNTL                                               #
#                                                                        #
##########################################################################

%orbit_01_00590_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INCREMENT_ICC"                => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Increment Intervention Credit Count by one" ],
   "RSVD0"                        => [   1,  49,  14, 0x7FFE000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RESET_IRB_COUNT"              => [   2,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "Reset IRB Timeout Counter" ],
   "RSVD1"                        => [   3,  41,   7, 0x0000FE0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RESET_WRB_COUNT"              => [   4,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "Reset WRB Timeout Counter" ],
   "RSVD2"                        => [   5,  33,   7, 0x000000FE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RESET_RRB_COUNT"              => [   6,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Reset RRB Timeout Counter" ],
   "RSVD3"                        => [   7,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IRB_TIMER_EN"                 => [   8,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "Enable IRB Timeouts" ],
   "RSVD4"                        => [   9,  21,   2, 0x0000000000600000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IRB_LIMIT"                    => [  10,  16,   5, 0x00000000001F0000, 0x00, 1, 0x0000000000000000, "CRB IRB Timed-out Entry Limit" ],
   "WRB_TIMER_EN"                 => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Enable WRB Timeouts" ],
   "RSVD5"                        => [  12,  13,   2, 0x0000000000006000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRB_LIMIT"                    => [  13,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "CRB WRB Timed-out Entry Limit" ],
   "RRB_TIMER_EN"                 => [  14,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Enable RRB Timeouts" ],
   "RSVD6"                        => [  15,   5,   2, 0x0000000000000060, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RRB_LIMIT"                    => [  16,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "CRB RRB Timed-out Entry Limit" ],
);

%orbit_01_00590_def =
( NAME    => "OC_PI_CRB_TIMEOUT_CNTL",
  ADDRESS => 0x00000000a0020030,
  NOTE    => "The values within this register control the number of timed out note entries that are allowed to accumulate within a given type ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00590_flds
);


##########################################################################
#                                                                        #
#   OC_PI_CRB_SUPPL_INIT                                                 #
#                                                                        #
##########################################################################

%orbit_01_00591_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INIT_EN"                      => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Enable Suppl Init." ],
   "RSVD0"                        => [   1,  16,  47, 0x7FFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INIT_VALUE"                   => [   2,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "Programmable Suppl. Init. Value" ],
);

%orbit_01_00591_def =
( NAME    => "OC_PI_CRB_SUPPL_INIT",
  ADDRESS => 0x00000000a0020040,
  NOTE    => "This register contains a programmable value that can be optionally note used for the initial value placed in the Supplemental fi",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00591_flds
);


##########################################################################
#                                                                        #
#   OC_PI_CRB_RD_FLW_CNTL                                                #
#                                                                        #
##########################################################################

%orbit_01_00592_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RD_HW_MARK"                   => [   1,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Read Flow Control High Water Mark" ],
);

%orbit_01_00592_def =
( NAME    => "OC_PI_CRB_RD_FLW_CNTL",
  ADDRESS => 0x00000000a0020050,
  NOTE    => "This register contains the programmable value for read request flow note control. The value programmed represents the maximum nu",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00592_flds
);


##########################################################################
#                                                                        #
#   OC_PI_CRB_WR_FLW_CNTL                                                #
#                                                                        #
##########################################################################

%orbit_01_00593_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRB_HW_MARK"                  => [   1,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Write Request Flow Control High Water Mark" ],
);

%orbit_01_00593_def =
( NAME    => "OC_PI_CRB_WR_FLW_CNTL",
  ADDRESS => 0x00000000a0020060,
  NOTE    => "This register contains the programmable value for write request note flow control.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00593_flds
);


##########################################################################
#                                                                        #
#   OC_PI_CRB_CDR_FLW_CNTL                                               #
#                                                                        #
##########################################################################

%orbit_01_00594_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   4,  60, 0xFFFFFFFFFFFFFFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CDR_HW_MARK"                  => [   1,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "CohDataResp Flow Control High Water Mark" ],
);

%orbit_01_00594_def =
( NAME    => "OC_PI_CRB_CDR_FLW_CNTL",
  ADDRESS => 0x00000000a0020070,
  NOTE    => "This register contains the programmable value for Coherent Data note Response flow control.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00594_flds
);


##########################################################################
#                                                                        #
#   OC_PI_CRB_NODE_PRESENT_TABLE                                         #
#                                                                        #
##########################################################################

%orbit_01_00595_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NODES"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Nodes Present" ],
);

%orbit_01_00595_def =
( NAME    => "OC_PI_CRB_NODE_PRESENT_TABLE",
  ADDRESS => 0x00000000a0020400,
  NOTE    => "The node_present_table is a bit map of all of the nodes present in note the entire system. The present bits are stored in an arr",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00595_flds
);


##########################################################################
#                                                                        #
#   OC_PI_CRB_AUTO_REPLY_ENABLE                                          #
#                                                                        #
##########################################################################

%orbit_01_00596_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AUTO_RPLY_EN"                 => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Auto Reply Enabled" ],
);

%orbit_01_00596_def =
( NAME    => "OC_PI_CRB_AUTO_REPLY_ENABLE",
  ADDRESS => 0x00000000a0021000,
  NOTE    => "The CRB_AUTO_REPLY_ENABLE register controls the routing of note JETSONSNET messages generated by the CRB.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00596_flds
);


##########################################################################
#                                                                        #
#   OC_PI_CRB_PROC_REQ_HDR_COMPARE                                       #
#                                                                        #
##########################################################################

%orbit_01_00597_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ECHO_CMP_EN"                  => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Enable Echo Compare" ],
   "CMD_CMP_EN"                   => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Enable Command Compare" ],
   "ADDR_CMP_EN"                  => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "Enable Address Compare" ],
   "ECHO"                         => [   3,  52,   9, 0x1FF0000000000000, 0x00, 1, 0x0000000000000000, "Request Header Echo Compare Value" ],
   "CMD"                          => [   4,  45,   7, 0x000FE00000000000, 0x00, 1, 0x0000000000000000, "Request Header Command Compare Value" ],
   "PHY_ADDR"                     => [   5,   0,  45, 0x00001FFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Request Physical Address Compare Value" ],
);

%orbit_01_00597_def =
( NAME    => "OC_PI_CRB_PROC_REQ_HDR_COMPARE",
  ADDRESS => 0x00000000a0021100,
  NOTE    => "This register is used to generate inputs to the CRB Pipe's Debug note logic. The value loaded into this register is first masked",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00597_flds
);


##########################################################################
#                                                                        #
#   OC_PI_CRB_PROC_REQ_HDR_MASK                                          #
#                                                                        #
##########################################################################

%orbit_01_00598_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECHO_MASK"                    => [   1,  52,   9, 0x1FF0000000000000, 0x00, 1, 0x0000000000000000, "Header Echo Comparison Mask" ],
   "CMD_MASK"                     => [   2,  45,   7, 0x000FE00000000000, 0x00, 1, 0x0000000000000000, "Header Command Comparison Mask" ],
   "ADDR_MASK"                    => [   3,   0,  45, 0x00001FFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Physical Address Comparison Mask" ],
);

%orbit_01_00598_def =
( NAME    => "OC_PI_CRB_PROC_REQ_HDR_MASK",
  ADDRESS => 0x00000000a0021110,
  NOTE    => "This register is used to define the bit mask to be applied against note the values loaded into the CRB_PROC_REQ_HDR_COMPARE regi",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00598_flds
);


##########################################################################
#                                                                        #
#   OC_PI_CRB_PROC_RSP_HDR_COMPARE                                       #
#                                                                        #
##########################################################################

%orbit_01_00599_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ECHO_CMP_EN"                  => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Enable Echo Compare" ],
   "CMD_CMP_EN"                   => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Enable Command Compare" ],
   "ADDR_CMP_EN"                  => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "Enable Address Compare" ],
   "ECHO"                         => [   3,  52,   9, 0x1FF0000000000000, 0x00, 1, 0x0000000000000000, "Response Header Echo Compare Value" ],
   "CMD"                          => [   4,  45,   7, 0x000FE00000000000, 0x00, 1, 0x0000000000000000, "Response Header Command Compare Value" ],
   "PHY_ADDR"                     => [   5,   0,  45, 0x00001FFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Response Physical Address Compare Value" ],
);

%orbit_01_00599_def =
( NAME    => "OC_PI_CRB_PROC_RSP_HDR_COMPARE",
  ADDRESS => 0x00000000a0021200,
  NOTE    => "This register is used to generate inputs to the CRB Pipe's Debug note logic. The value loaded into this register is first masked",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00599_flds
);


##########################################################################
#                                                                        #
#   OC_PI_CRB_PROC_RSP_HDR_MASK                                          #
#                                                                        #
##########################################################################

%orbit_01_00600_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECHO_MASK"                    => [   1,  52,   9, 0x1FF0000000000000, 0x00, 1, 0x0000000000000000, "Header Echo Comparison Mask" ],
   "CMD_MASK"                     => [   2,  45,   7, 0x000FE00000000000, 0x00, 1, 0x0000000000000000, "Header Command Comprison Mask" ],
   "ADDR_MASK"                    => [   3,   0,  45, 0x00001FFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Physical Address Comparison Mask" ],
);

%orbit_01_00600_def =
( NAME    => "OC_PI_CRB_PROC_RSP_HDR_MASK",
  ADDRESS => 0x00000000a0021210,
  NOTE    => "This register is used to define the bit mask to be applied against note the values loaded into the CRB_PROC_RSP_HDR_COMPARE regi",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00600_flds
);


##########################################################################
#                                                                        #
#   OC_PI_CRB_SYS_REQ_HDR_COMPARE                                        #
#                                                                        #
##########################################################################

%orbit_01_00601_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ECHO_CMP_EN"                  => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Enable Echo Compare" ],
   "CMD_CMP_EN"                   => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Enable Command Compare" ],
   "ADDR_CMP_EN"                  => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "Enable Address Compare" ],
   "ECHO"                         => [   3,  52,   9, 0x1FF0000000000000, 0x00, 1, 0x0000000000000000, "Request Header Echo Compare Value" ],
   "CMD"                          => [   4,  45,   7, 0x000FE00000000000, 0x00, 1, 0x0000000000000000, "Request Header Command Compare Value" ],
   "PHY_ADDR"                     => [   5,   0,  45, 0x00001FFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Request Physical Address Compare Value" ],
);

%orbit_01_00601_def =
( NAME    => "OC_PI_CRB_SYS_REQ_HDR_COMPARE",
  ADDRESS => 0x00000000a0021300,
  NOTE    => "This register is used to generate inputs to the CRB Pipe's Debug note logic. The value loaded into this register is first masked",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00601_flds
);


##########################################################################
#                                                                        #
#   OC_PI_CRB_SYS_REQ_HDR_MASK                                           #
#                                                                        #
##########################################################################

%orbit_01_00602_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECHO_MASK"                    => [   1,  52,   9, 0x1FF0000000000000, 0x00, 1, 0x0000000000000000, "Header Echo Comparison Mask" ],
   "CMD_MASK"                     => [   2,  45,   7, 0x000FE00000000000, 0x00, 1, 0x0000000000000000, "Header Command Comparison Mask" ],
   "ADDR_MASK"                    => [   3,   0,  45, 0x00001FFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Physical Address Comparison Mask" ],
);

%orbit_01_00602_def =
( NAME    => "OC_PI_CRB_SYS_REQ_HDR_MASK",
  ADDRESS => 0x00000000a0021310,
  NOTE    => "This register is used to define the bit mask to be applied against note the values loaded into the CRB_SYS_REQ_HDR_COMPARE regis",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00602_flds
);


##########################################################################
#                                                                        #
#   OC_PI_CRB_SYS_RSP_HDR_COMPARE                                        #
#                                                                        #
##########################################################################

%orbit_01_00603_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ECHO_CMP_EN"                  => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Enable Echo Compare" ],
   "CMD_CMP_EN"                   => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Enable Command Compare" ],
   "ADDR_CMP_EN"                  => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "Enable Address Compare" ],
   "ECHO"                         => [   3,  52,   9, 0x1FF0000000000000, 0x00, 1, 0x0000000000000000, "Response Header Echo Compare Value" ],
   "CMD"                          => [   4,  45,   7, 0x000FE00000000000, 0x00, 1, 0x0000000000000000, "Response Header Command Compare Value" ],
   "PHY_ADDR"                     => [   5,   0,  45, 0x00001FFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Response Physical Address Compare Value" ],
);

%orbit_01_00603_def =
( NAME    => "OC_PI_CRB_SYS_RSP_HDR_COMPARE",
  ADDRESS => 0x00000000a0021400,
  NOTE    => "This register is used to generate inputs to the CRB Pipe's Debug note logic. The value loaded into this register is first masked",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00603_flds
);


##########################################################################
#                                                                        #
#   OC_PI_CRB_SYS_RSP_HDR_MASK                                           #
#                                                                        #
##########################################################################

%orbit_01_00604_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECHO_MASK"                    => [   1,  52,   9, 0x1FF0000000000000, 0x00, 1, 0x0000000000000000, "Header Echo Comparison Mask" ],
   "CMD_MASK"                     => [   2,  45,   7, 0x000FE00000000000, 0x00, 1, 0x0000000000000000, "Header Command Comparison Mask" ],
   "ADDR_MASK"                    => [   3,   0,  45, 0x00001FFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Physical Address Comparison Mask" ],
);

%orbit_01_00604_def =
( NAME    => "OC_PI_CRB_SYS_RSP_HDR_MASK",
  ADDRESS => 0x00000000a0021410,
  NOTE    => "This register is used to define the bit mask to be applied against note the values loaded into the CRB_SYS_RSP_HDR_COMPARE regis",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00604_flds
);


##########################################################################
#                                                                        #
#   OC_PI_CRB_MUX0_TP_SELECT                                             #
#                                                                        #
##########################################################################

%orbit_01_00605_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TRIGGER_ENABLE"               => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Enable trigger on bit 32 of Analyzer data" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 1, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD0"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_CHIPLET_SEL"          => [   3,  56,   3, 0x0700000000000000, 0x00, 1, 0x0000000000000000, "Nibble 7 Chiplet select" ],
   "RSVD1"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 1, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD2"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_CHIPLET_SEL"          => [   7,  48,   3, 0x0007000000000000, 0x00, 1, 0x0000000000000000, "Nibble 6 Chiplet select" ],
   "RSVD3"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 1, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD4"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_CHIPLET_SEL"          => [  11,  40,   3, 0x0000070000000000, 0x00, 1, 0x0000000000000000, "Nibble 5 Chiplet select" ],
   "RSVD5"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD6"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_CHIPLET_SEL"          => [  15,  32,   3, 0x0000000700000000, 0x00, 1, 0x0000000000000000, "Nibble 4 Chiplet select" ],
   "RSVD7"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 1, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD8"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_CHIPLET_SEL"          => [  19,  24,   3, 0x0000000007000000, 0x00, 1, 0x0000000000000000, "Nibble 3 Chiplet select" ],
   "RSVD9"                        => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 1, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD10"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_CHIPLET_SEL"          => [  23,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "Nibble 2 Chiplet select" ],
   "RSVD11"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 1, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD12"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_CHIPLET_SEL"          => [  27,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "Nibble 1 Chiplet select" ],
   "RSVD13"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 1, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD14"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_CHIPLET_SEL"          => [  31,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Nibble 0 Chiplet select" ],
);

%orbit_01_00605_def =
( NAME    => "OC_PI_CRB_MUX0_TP_SELECT",
  ADDRESS => 0x00000000a0021500,
  NOTE    => "The CRB MUX0 Test Point Select register is used to select the debug note test points whose values are to be placed onto the CRB ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00605_flds
);


##########################################################################
#                                                                        #
#   OC_PI_CRB_MUX0_TP_TRIGGER_SELECT                                     #
#                                                                        #
##########################################################################

%orbit_01_00606_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_NIBBLE_SEL"          => [   1,  60,   3, 0x7000000000000000, 0x00, 1, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_CHIPLET_SEL"         => [   3,  56,   3, 0x0700000000000000, 0x00, 1, 0x0000000000000000, "Nibble 7 Chiplet select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_NIBBLE_SEL"          => [   5,  52,   3, 0x0070000000000000, 0x00, 1, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_CHIPLET_SEL"         => [   7,  48,   3, 0x0007000000000000, 0x00, 1, 0x0000000000000000, "Nibble 6 Chiplet select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_NIBBLE_SEL"          => [   9,  44,   3, 0x0000700000000000, 0x00, 1, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_CHIPLET_SEL"         => [  11,  40,   3, 0x0000070000000000, 0x00, 1, 0x0000000000000000, "Nibble 5 Chiplet select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_NIBBLE_SEL"          => [  13,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_CHIPLET_SEL"         => [  15,  32,   3, 0x0000000700000000, 0x00, 1, 0x0000000000000000, "Nibble 4 Chiplet select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_NIBBLE_SEL"          => [  17,  28,   3, 0x0000000070000000, 0x00, 1, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_CHIPLET_SEL"         => [  19,  24,   3, 0x0000000007000000, 0x00, 1, 0x0000000000000000, "Nibble 3 Chiplet select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_NIBBLE_SEL"          => [  21,  20,   3, 0x0000000000700000, 0x00, 1, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_CHIPLET_SEL"         => [  23,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "Nibble 2 Chiplet select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_NIBBLE_SEL"          => [  25,  12,   3, 0x0000000000007000, 0x00, 1, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_CHIPLET_SEL"         => [  27,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "Nibble 1 Chiplet select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_NIBBLE_SEL"          => [  29,   4,   3, 0x0000000000000070, 0x00, 1, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_CHIPLET_SEL"         => [  31,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Nibble 0 Chiplet select" ],
);

%orbit_01_00606_def =
( NAME    => "OC_PI_CRB_MUX0_TP_TRIGGER_SELECT",
  ADDRESS => 0x00000000a0021510,
  NOTE    => "The CRB MUX0 Test Point Trigger Select register is used in the same note way as the CRB MUX0 Test Point Select register is used.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00606_flds
);


##########################################################################
#                                                                        #
#   OC_PI_CRB_MUX0_TP_COMPARE                                            #
#                                                                        #
##########################################################################

%orbit_01_00607_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CMP_PATTERN"                  => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 1, 0x0000000000000000, "Pattern for CRB MUX0 Debug trigger generation" ],
   "CMP_MASK"                     => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "Mask for CRB MUX0 Debug trigger generation" ],
);

%orbit_01_00607_def =
( NAME    => "OC_PI_CRB_MUX0_TP_COMPARE",
  ADDRESS => 0x00000000a0021520,
  NOTE    => "The CRB MUX0 Test Point Compare register is used to establish a set note of values for the test points selected by the CRB MUX0 ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00607_flds
);


##########################################################################
#                                                                        #
#   OC_PI_CRB_MUX1_TP_SELECT                                             #
#                                                                        #
##########################################################################

%orbit_01_00608_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TRIGGER_ENABLE"               => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Enable trigger on bit 32 of Analyzer data" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 1, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD0"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_CHIPLET_SEL"          => [   3,  56,   3, 0x0700000000000000, 0x00, 1, 0x0000000000000000, "Nibble 7 Chiplet select" ],
   "RSVD1"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 1, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD2"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_CHIPLET_SEL"          => [   7,  48,   3, 0x0007000000000000, 0x00, 1, 0x0000000000000000, "Nibble 6 Chiplet select" ],
   "RSVD3"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 1, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD4"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_CHIPLET_SEL"          => [  11,  40,   3, 0x0000070000000000, 0x00, 1, 0x0000000000000000, "Nibble 5 Chiplet select" ],
   "RSVD5"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD6"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_CHIPLET_SEL"          => [  15,  32,   3, 0x0000000700000000, 0x00, 1, 0x0000000000000000, "Nibble 4 Chiplet select" ],
   "RSVD7"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 1, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD8"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_CHIPLET_SEL"          => [  19,  24,   3, 0x0000000007000000, 0x00, 1, 0x0000000000000000, "Nibble 3 Chiplet select" ],
   "RSVD9"                        => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 1, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD10"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_CHIPLET_SEL"          => [  23,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "Nibble 2 Chiplet select" ],
   "RSVD11"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 1, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD12"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_CHIPLET_SEL"          => [  27,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "Nibble 1 Chiplet select" ],
   "RSVD13"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 1, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD14"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_CHIPLET_SEL"          => [  31,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Nibble 0 Chiplet select" ],
);

%orbit_01_00608_def =
( NAME    => "OC_PI_CRB_MUX1_TP_SELECT",
  ADDRESS => 0x00000000a0021600,
  NOTE    => "The CRB MUX1 Test Point Select register is used to select the debug note test points whose values are to be placed onto the CRB ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00608_flds
);


##########################################################################
#                                                                        #
#   OC_PI_CRB_MUX1_TP_TRIGGER_SELECT                                     #
#                                                                        #
##########################################################################

%orbit_01_00609_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_NIBBLE_SEL"          => [   1,  60,   3, 0x7000000000000000, 0x00, 1, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_CHIPLET_SEL"         => [   3,  56,   3, 0x0700000000000000, 0x00, 1, 0x0000000000000000, "Nibble 7 Chiplet select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_NIBBLE_SEL"          => [   5,  52,   3, 0x0070000000000000, 0x00, 1, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_CHIPLET_SEL"         => [   7,  48,   3, 0x0007000000000000, 0x00, 1, 0x0000000000000000, "Nibble 6 Chiplet select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_NIBBLE_SEL"          => [   9,  44,   3, 0x0000700000000000, 0x00, 1, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_CHIPLET_SEL"         => [  11,  40,   3, 0x0000070000000000, 0x00, 1, 0x0000000000000000, "Nibble 5 Chiplet select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_NIBBLE_SEL"          => [  13,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_CHIPLET_SEL"         => [  15,  32,   3, 0x0000000700000000, 0x00, 1, 0x0000000000000000, "Nibble 4 Chiplet select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_NIBBLE_SEL"          => [  17,  28,   3, 0x0000000070000000, 0x00, 1, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_CHIPLET_SEL"         => [  19,  24,   3, 0x0000000007000000, 0x00, 1, 0x0000000000000000, "Nibble 3 Chiplet select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_NIBBLE_SEL"          => [  21,  20,   3, 0x0000000000700000, 0x00, 1, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_CHIPLET_SEL"         => [  23,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "Nibble 2 Chiplet select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_NIBBLE_SEL"          => [  25,  12,   3, 0x0000000000007000, 0x00, 1, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_CHIPLET_SEL"         => [  27,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "Nibble 1 Chiplet select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_NIBBLE_SEL"          => [  29,   4,   3, 0x0000000000000070, 0x00, 1, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_CHIPLET_SEL"         => [  31,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Nibble 0 Chiplet select" ],
);

%orbit_01_00609_def =
( NAME    => "OC_PI_CRB_MUX1_TP_TRIGGER_SELECT",
  ADDRESS => 0x00000000a0021610,
  NOTE    => "The CRB MUX1 Test Point Trigger Select register is used in the same note way as the CRB MUX1 Test Point Select register is used.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00609_flds
);


##########################################################################
#                                                                        #
#   OC_PI_CRB_MUX1_TP_COMPARE                                            #
#                                                                        #
##########################################################################

%orbit_01_00610_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CMP_PATTERN"                  => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 1, 0x0000000000000000, "Pattern for CRB MUX1 Debug trigger generation" ],
   "CMP_MASK"                     => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "Mask for CRB MUX1 Debug trigger generation" ],
);

%orbit_01_00610_def =
( NAME    => "OC_PI_CRB_MUX1_TP_COMPARE",
  ADDRESS => 0x00000000a0021620,
  NOTE    => "The CRB MUX1 Test Point Compare register is used to establish a set note of values for the test points selected by the CRB MUX1 ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00610_flds
);


##########################################################################
#                                                                        #
#   OC_PI_CRB_MUX2_TP_SELECT                                             #
#                                                                        #
##########################################################################

%orbit_01_00611_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TRIGGER_ENABLE"               => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Enable trigger on bit 32 of Analyzer data" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 1, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD0"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_CHIPLET_SEL"          => [   3,  56,   3, 0x0700000000000000, 0x00, 1, 0x0000000000000000, "Nibble 7 Chiplet select" ],
   "RSVD1"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 1, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD2"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_CHIPLET_SEL"          => [   7,  48,   3, 0x0007000000000000, 0x00, 1, 0x0000000000000000, "Nibble 6 Chiplet select" ],
   "RSVD3"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 1, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD4"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_CHIPLET_SEL"          => [  11,  40,   3, 0x0000070000000000, 0x00, 1, 0x0000000000000000, "Nibble 5 Chiplet select" ],
   "RSVD5"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD6"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_CHIPLET_SEL"          => [  15,  32,   3, 0x0000000700000000, 0x00, 1, 0x0000000000000000, "Nibble 4 Chiplet select" ],
   "RSVD7"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 1, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD8"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_CHIPLET_SEL"          => [  19,  24,   3, 0x0000000007000000, 0x00, 1, 0x0000000000000000, "Nibble 3 Chiplet select" ],
   "RSVD9"                        => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 1, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD10"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_CHIPLET_SEL"          => [  23,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "Nibble 2 Chiplet select" ],
   "RSVD11"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 1, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD12"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_CHIPLET_SEL"          => [  27,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "Nibble 1 Chiplet select" ],
   "RSVD13"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 1, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD14"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_CHIPLET_SEL"          => [  31,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Nibble 0 Chiplet select" ],
);

%orbit_01_00611_def =
( NAME    => "OC_PI_CRB_MUX2_TP_SELECT",
  ADDRESS => 0x00000000a0021700,
  NOTE    => "The CRB MUX2 Test Point Select register is used to select the debug note test points whose values are to be placed onto the CRB ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00611_flds
);


##########################################################################
#                                                                        #
#   OC_PI_CRB_MUX2_TP_TRIGGER_SELECT                                     #
#                                                                        #
##########################################################################

%orbit_01_00612_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_NIBBLE_SEL"          => [   1,  60,   3, 0x7000000000000000, 0x00, 1, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_CHIPLET_SEL"         => [   3,  56,   3, 0x0700000000000000, 0x00, 1, 0x0000000000000000, "Nibble 7 Chiplet select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_NIBBLE_SEL"          => [   5,  52,   3, 0x0070000000000000, 0x00, 1, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_CHIPLET_SEL"         => [   7,  48,   3, 0x0007000000000000, 0x00, 1, 0x0000000000000000, "Nibble 6 Chiplet select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_NIBBLE_SEL"          => [   9,  44,   3, 0x0000700000000000, 0x00, 1, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_CHIPLET_SEL"         => [  11,  40,   3, 0x0000070000000000, 0x00, 1, 0x0000000000000000, "Nibble 5 Chiplet select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_NIBBLE_SEL"          => [  13,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_CHIPLET_SEL"         => [  15,  32,   3, 0x0000000700000000, 0x00, 1, 0x0000000000000000, "Nibble 4 Chiplet select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_NIBBLE_SEL"          => [  17,  28,   3, 0x0000000070000000, 0x00, 1, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_CHIPLET_SEL"         => [  19,  24,   3, 0x0000000007000000, 0x00, 1, 0x0000000000000000, "Nibble 3 Chiplet select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_NIBBLE_SEL"          => [  21,  20,   3, 0x0000000000700000, 0x00, 1, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_CHIPLET_SEL"         => [  23,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "Nibble 2 Chiplet select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_NIBBLE_SEL"          => [  25,  12,   3, 0x0000000000007000, 0x00, 1, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_CHIPLET_SEL"         => [  27,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "Nibble 1 Chiplet select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_NIBBLE_SEL"          => [  29,   4,   3, 0x0000000000000070, 0x00, 1, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_CHIPLET_SEL"         => [  31,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Nibble 0 Chiplet select" ],
);

%orbit_01_00612_def =
( NAME    => "OC_PI_CRB_MUX2_TP_TRIGGER_SELECT",
  ADDRESS => 0x00000000a0021710,
  NOTE    => "The CRB MUX2 Test Point Trigger Select register is used in the same note way as the CRB MUX2 Test Point Select register is used.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00612_flds
);


##########################################################################
#                                                                        #
#   OC_PI_CRB_MUX2_TP_COMPARE                                            #
#                                                                        #
##########################################################################

%orbit_01_00613_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CMP_PATTERN"                  => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 1, 0x0000000000000000, "Pattern for CRB MUX2 Debug trigger generation" ],
   "CMP_MASK"                     => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "Mask for CRB MUX2 Debug trigger generation" ],
);

%orbit_01_00613_def =
( NAME    => "OC_PI_CRB_MUX2_TP_COMPARE",
  ADDRESS => 0x00000000a0021720,
  NOTE    => "The CRB MUX2 Test Point Compare register is used to establish a set note of values for the test points selected by the CRB MUX2 ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00613_flds
);


##########################################################################
#                                                                        #
#   OC_PI_CAM_ACCESS_CNTL                                                #
#                                                                        #
##########################################################################

%orbit_01_00614_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "START"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Start CRB CAM read/clr operation" ],
   "RSVD0"                        => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENTRY_CLR"                    => [   2,  59,   1, 0x0800000000000000, 0x00, 1, 0x0000000000000000, "Clear CAM Entry" ],
   "ACCESS_SEL"                   => [   3,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "Address/Index Select Bit" ],
   "CAM_BUF_SEL"                  => [   4,  56,   2, 0x0300000000000000, 0x00, 1, 0x0000000000000000, "CRB CAM Buffer to read" ],
   "RSVD1"                        => [   5,  53,   3, 0x00E0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CAM_IDX"                      => [   6,  48,   5, 0x001F000000000000, 0x00, 1, 0x0000000000000000, "Index of CRB CAM entry to read" ],
   "CAM_ADDR"                     => [   7,   7,  41, 0x0000FFFFFFFFFF80, 0x00, 1, 0x0000000000000000, "Address of CRB CAM entry to read" ],
);

%orbit_01_00614_def =
( NAME    => "OC_PI_CAM_ACCESS_CNTL",
  ADDRESS => 0x00000000a0022000,
  NOTE    => "This register is used to control PIO access operations to the CRB note CAM data. Read operations can be performed using either a",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00614_flds
);


##########################################################################
#                                                                        #
#   OC_PI_CAM_ADDRESS_DATA                                               #
#                                                                        #
##########################################################################

%orbit_01_00615_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENTRY_VAL"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CAM Entry Valid." ],
   "MATCH_VAL"                    => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CAM Match Valid." ],
   "ACCESS_CMPL"                  => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "CAM Access Complete." ],
   "RSVD0"                        => [   3,  53,   8, 0x1FE0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CAM_IDX"                      => [   4,  48,   5, 0x001F000000000000, 0x00, 1, 0x0000000000000000, "CAM Entry Index." ],
   "CAM_ADDR"                     => [   5,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "CAM Address Data." ],
);

%orbit_01_00615_def =
( NAME    => "OC_PI_CAM_ADDRESS_DATA",
  ADDRESS => 0x00000000a0024000,
  NOTE    => "This register contains the data from an MMR CRB CAM access note operation. The returned address and index values are from either",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00615_flds
);


##########################################################################
#                                                                        #
#   OC_PI_CAM_MEM_DATA                                                   #
#                                                                        #
##########################################################################

%orbit_01_00616_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "IRB_CHIPLET_ID"               => [   0,  62,   2, 0xC000000000000000, 0x00, 1, 0x0000000000000000, "IRB Source ChipletID." ],
   "IRB_NODE_ID"                  => [   1,  48,  14, 0x3FFF000000000000, 0x00, 1, 0x0000000000000000, "IRB Source NodeID." ],
   "IRB_ECHO"                     => [   2,  39,   9, 0x0000FF8000000000, 0x00, 1, 0x0000000000000000, "IRB entry Echo Value." ],
   "IRB_T"                        => [   3,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "IRB Request Type." ],
   "IRB_DWA"                      => [   4,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "IRB Double Wrord Address." ],
   "RSVD0"                        => [   5,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRB_PN"                       => [   6,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "WRB Processor Number." ],
   "RSVD1"                        => [   7,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRB_LEN"                      => [   8,  24,   3, 0x0000000007000000, 0x00, 1, 0x0000000000000000, "RRB entry is Item Read." ],
   "RSVD2"                        => [   9,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRB_T"                        => [  10,  20,   3, 0x0000000000700000, 0x00, 1, 0x0000000000000000, "WRB Request Type." ],
   "WRB_DWA"                      => [  11,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "WRB Double Wrord Address." ],
   "RRB_RN"                       => [  12,  11,   5, 0x000000000000F800, 0x00, 1, 0x0000000000000000, "RRB Request Number." ],
   "RRB_PN"                       => [  13,   9,   2, 0x0000000000000600, 0x00, 1, 0x0000000000000000, "RRB Processor Number." ],
   "RRB_LEN"                      => [  14,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "RRB entry is Item Read." ],
   "RRB_T"                        => [  15,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "RRB Request Type." ],
   "RRB_DWA"                      => [  16,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "RRB Double Wrord Address." ],
);

%orbit_01_00616_def =
( NAME    => "OC_PI_CAM_MEM_DATA",
  ADDRESS => 0x00000000a0024010,
  NOTE    => "This register contains the returned MEM data from a CRB CAM read note operation. The data returned is from the CAM buffer select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00616_flds
);


##########################################################################
#                                                                        #
#   OC_PI_CAM_STATE_DATA                                                 #
#                                                                        #
##########################################################################

%orbit_01_00617_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATE_DATA_VAL"               => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CAM read state data is valid." ],
   "RSVD0"                        => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENTRY_TIMER"                  => [   2,  56,   4, 0x0F00000000000000, 0x00, 1, 0x0000000000000000, "Entry Timer Value." ],
   "IRB_TO"                       => [   3,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "IRB Time-out Status." ],
   "IRB_WRB_IDX"                  => [   4,  50,   5, 0x007C000000000000, 0x00, 1, 0x0000000000000000, "CRB IRB Write Hit WRB Entry Index." ],
   "IRB_WH"                       => [   5,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "IRB Write Hit." ],
   "IRB_RH"                       => [   6,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "IRB Read Hit." ],
   "IRB_SR"                       => [   7,  45,   3, 0x0000E00000000000, 0x00, 1, 0x0000000000000000, "IRB SysState Response." ],
   "IRB_CV"                       => [   8,  43,   2, 0x0000180000000000, 0x00, 1, 0x0000000000000000, "IRB Conflict Vector." ],
   "IRB_S"                        => [   9,  40,   3, 0x0000070000000000, 0x00, 1, 0x0000000000000000, "IRB Entry State." ],
   "WRB_TO"                       => [  10,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "WRB Time-out Status." ],
   "WRB_IH"                       => [  11,  35,   4, 0x0000007800000000, 0x00, 1, 0x0000000000000000, "WRB Invalidate/Intervention Hit." ],
   "WRB_CV"                       => [  12,  33,   2, 0x0000000600000000, 0x00, 1, 0x0000000000000000, "WRB Conflict Vector." ],
   "WRB_IW"                       => [  13,  31,   2, 0x0000000180000000, 0x00, 1, 0x0000000000000000, "WRB Entry is Implicit Write." ],
   "WRB_S"                        => [  14,  28,   3, 0x0000000070000000, 0x00, 1, 0x0000000000000000, "WRB Entry State." ],
   "RRB_C"                        => [  15,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "RRB Counter Value." ],
   "RRB_TO"                       => [  16,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "RRB Time-out Status." ],
   "RRB_CS"                       => [  17,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "RRB Counter State." ],
   "RRB_IH"                       => [  18,  10,   4, 0x0000000000003C00, 0x00, 1, 0x0000000000000000, "RRB Invalidate/Intervention Hit." ],
   "RRB_E"                        => [  19,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "RRB Speculative Response State." ],
   "RRB_SR"                       => [  20,   6,   2, 0x00000000000000C0, 0x00, 1, 0x0000000000000000, "RRB SysState Response." ],
   "RRB_CV"                       => [  21,   3,   3, 0x0000000000000038, 0x00, 1, 0x0000000000000000, "RRB Conflict Vector." ],
   "RRB_S"                        => [  22,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "RRB Entry State." ],
);

%orbit_01_00617_def =
( NAME    => "OC_PI_CAM_STATE_DATA",
  ADDRESS => 0x00000000a0024020,
  NOTE    => "This register contains the returned STATE data from a CRB CAM read note operation. The data returned is from the CAM buffer sele",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00617_flds
);


##########################################################################
#                                                                        #
#   OC_PI_MEM_RD_ACCESS_ERR                                              #
#                                                                        #
##########################################################################

%orbit_01_00618_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CL_ADDR"                      => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 1, 0x0000000000000000, "Cache Line Address; PA[47:7]" ],
   "DW_ADDR"                      => [   1,  19,   4, 0x0000000000780000, 0x00, 1, 0x0000000000000000, "Cache Line Address; PA[6:3]" ],
   "ADDR_SPACE"                   => [   2,  17,   2, 0x0000000000060000, 0x00, 1, 0x0000000000000000, "Address Space" ],
   "RRB_CV_I"                     => [   3,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "RRB Conflict Vector Intervention" ],
   "RRB_S"                        => [   4,  13,   3, 0x000000000000E000, 0x00, 1, 0x0000000000000000, "Read Request State" ],
   "PROC_REQNUM"                  => [   5,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "Processor Request Number" ],
   "REQ_TYPE"                     => [   6,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "Read Request Type" ],
   "RSVD0"                        => [   7,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERR_OVRFLW"                   => [   8,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Memory Read Access Error Detail Overflow" ],
   "ERR_VAL"                      => [   9,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Memory Read Access Error Detail Valid" ],
);

%orbit_01_00618_def =
( NAME    => "OC_PI_MEM_RD_ACCESS_ERR",
  ADDRESS => 0x00000000a0028000,
  NOTE    => "This register captures the error detail for the first processor note memory read request that results in an access error status.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00618_flds
);


##########################################################################
#                                                                        #
#   OC_PI_MEM_RD_SPURIOUS_MSG_ERR                                        #
#                                                                        #
##########################################################################

%orbit_01_00619_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CL_ADDR"                      => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 1, 0x0000000000000000, "Spurious Read Response Cache Line Address" ],
   "CMD"                          => [   1,  16,   7, 0x00000000007F0000, 0x00, 1, 0x0000000000000000, "Spurious Read Response Command" ],
   "SRC_NODE"                     => [   2,   2,  14, 0x000000000000FFFC, 0x00, 1, 0x0000000000000000, "Spurious Read Response Source Node" ],
   "ERR_OVRFLW"                   => [   3,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Spurious Memory Read Response Error Overflow" ],
   "ERR_VAL"                      => [   4,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Spurious Memory Read Response Error" ],
);

%orbit_01_00619_def =
( NAME    => "OC_PI_MEM_RD_SPURIOUS_MSG_ERR",
  ADDRESS => 0x00000000a0028010,
  NOTE    => "The contents of this register are loaded with the error detail data note when the first memory read response message is received",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00619_flds
);


##########################################################################
#                                                                        #
#   OC_PI_MEM_RD_DIR_ERR                                                 #
#                                                                        #
##########################################################################

%orbit_01_00620_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CL_ADDR"                      => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 1, 0x0000000000000000, "Cache Line Address; PA[47:7]" ],
   "EXT_ERR_DETAIL"               => [   1,  17,   6, 0x00000000007E0000, 0x00, 1, 0x0000000000000000, "Extended Error Detail" ],
   "RRB_CV_I"                     => [   2,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "RRB Conflict Vector Intervention" ],
   "RRB_S"                        => [   3,  13,   3, 0x000000000000E000, 0x00, 1, 0x0000000000000000, "Read Request State" ],
   "PROC_REQNUM"                  => [   4,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "Processor Request Number" ],
   "REQ_TYPE"                     => [   5,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "Read Request Type" ],
   "RSVD0"                        => [   6,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERR_OVRFLW"                   => [   7,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Memory Read Directory Error Overflow" ],
   "ERR_VAL"                      => [   8,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Memory Read Directory Error Valid" ],
);

%orbit_01_00620_def =
( NAME    => "OC_PI_MEM_RD_DIR_ERR",
  ADDRESS => 0x00000000a0028020,
  NOTE    => "This register captures the error detail for the first processor note memory read request that receives a Directory Error respons",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00620_flds
);


##########################################################################
#                                                                        #
#   OC_PI_MEM_RD_TO_ERR                                                  #
#                                                                        #
##########################################################################

%orbit_01_00621_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATUS_VEC"                   => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 1, 0x0000000000000000, "RRB Timeout Error Status Vector" ],
   "RSVD0"                        => [   1,   9,  23, 0x00000000FFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIRST_ERR_IDX"                => [   2,   4,   5, 0x00000000000001F0, 0x00, 1, 0x0000000000000000, "RRB First Timeout Error Entry Index" ],
   "RSVD1"                        => [   3,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERR_OVRFLW"                   => [   4,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Memory Read Timeout Error Overflow" ],
   "ERR_VAL"                      => [   5,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Memory Read Timeout Error Valid" ],
);

%orbit_01_00621_def =
( NAME    => "OC_PI_MEM_RD_TO_ERR",
  ADDRESS => 0x00000000a0028030,
  NOTE    => "The Memory Read Timeout Error register is loaded whenever the timer note for a valid memory read request expires. If enabled, th",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00621_flds
);


##########################################################################
#                                                                        #
#   OC_PI_MEM_RD_POISON_ERR                                              #
#                                                                        #
##########################################################################

%orbit_01_00622_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CL_ADDR"                      => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 1, 0x0000000000000000, "Cache Line Address; PA[47:7]" ],
   "EXT_ERR_DETAIL"               => [   1,  17,   6, 0x00000000007E0000, 0x00, 1, 0x0000000000000000, "Extended Error Detail" ],
   "RRB_CV_I"                     => [   2,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "RRB Conflict Vector Intervention" ],
   "RRB_S"                        => [   3,  13,   3, 0x000000000000E000, 0x00, 1, 0x0000000000000000, "Read Request State" ],
   "PROC_REQNUM"                  => [   4,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "Processor Request Number" ],
   "REQ_TYPE"                     => [   5,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "Read Request Type" ],
   "RSVD0"                        => [   6,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERR_OVRFLW"                   => [   7,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Memory Read Poison Error Detail Overflow" ],
   "ERR_VAL"                      => [   8,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Memory Read Poison Error Detail Valid" ],
);

%orbit_01_00622_def =
( NAME    => "OC_PI_MEM_RD_POISON_ERR",
  ADDRESS => 0x00000000a0028040,
  NOTE    => "This register captures the error detail for the first processor note memory read request that receives a Poison Error response, ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00622_flds
);


##########################################################################
#                                                                        #
#   OC_PI_MEM_RD_NACK_CNT_ERR                                            #
#                                                                        #
##########################################################################

%orbit_01_00623_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CL_ADDR"                      => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 1, 0x0000000000000000, "Cache Line Address; PA[47:7]" ],
   "EXT_ERR_DETAIL"               => [   1,  17,   6, 0x00000000007E0000, 0x00, 1, 0x0000000000000000, "Extended Error Detail" ],
   "RRB_CV_I"                     => [   2,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "RRB Conflict Vector Intervention" ],
   "RRB_S"                        => [   3,  13,   3, 0x000000000000E000, 0x00, 1, 0x0000000000000000, "Read Request State" ],
   "PROC_REQNUM"                  => [   4,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "Processor Request Number" ],
   "REQ_TYPE"                     => [   5,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "Read Request Type" ],
   "RSVD0"                        => [   6,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERR_OVRFLW"                   => [   7,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Memory Read NACK Count Error Overflow" ],
   "ERR_VAL"                      => [   8,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Memory Read NACK Count Error Valid" ],
);

%orbit_01_00623_def =
( NAME    => "OC_PI_MEM_RD_NACK_CNT_ERR",
  ADDRESS => 0x00000000a0028050,
  NOTE    => "This register captures the error detail for the first processor note read request that received an amount of Negative Acknowledg",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00623_flds
);


##########################################################################
#                                                                        #
#   OC_PI_MEM_RD_CORR_DATA_ERR                                           #
#                                                                        #
##########################################################################

%orbit_01_00624_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CL_ADDR"                      => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 1, 0x0000000000000000, "Read Data Error Cache Line Address" ],
   "ADDR_SPACE"                   => [   1,  21,   2, 0x0000000000600000, 0x00, 1, 0x0000000000000000, "Address Space for Read Data Error" ],
   "LOCAL"                        => [   2,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "Read Local Data Error" ],
   "SYNDROME"                     => [   3,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Read Data Error Syndrome" ],
   "PROC_NUM"                     => [   4,   2,   2, 0x000000000000000C, 0x00, 1, 0x0000000000000000, "Processor Number" ],
   "ERR_OVRFLW"                   => [   5,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Memory Read Corr. Data Error Overflow" ],
   "ERR_VAL"                      => [   6,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Memory Read Corr. Data Error Valid" ],
);

%orbit_01_00624_def =
( NAME    => "OC_PI_MEM_RD_CORR_DATA_ERR",
  ADDRESS => 0x00000000a0028060,
  NOTE    => "The contents of this register are loaded with error detail data note when the first correctable memory read data error is detect",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00624_flds
);


##########################################################################
#                                                                        #
#   OC_PI_MEM_RD_UNCORR_DATA_ERR                                         #
#                                                                        #
##########################################################################

%orbit_01_00625_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CL_ADDR"                      => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 1, 0x0000000000000000, "Read Data Error Cache Line Address" ],
   "ADDR_SPACE"                   => [   1,  21,   2, 0x0000000000600000, 0x00, 1, 0x0000000000000000, "Address Space for Read Data Error" ],
   "LOCAL"                        => [   2,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "Read Local Data Error" ],
   "SYNDROME"                     => [   3,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Read Data Error Syndrome" ],
   "PROC_NUM"                     => [   4,   2,   2, 0x000000000000000C, 0x00, 1, 0x0000000000000000, "Processor Number" ],
   "ERR_OVRFLW"                   => [   5,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Memory Read UnCorrectable Data Error Overflow" ],
   "ERR_VAL"                      => [   6,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Memory Read UnCorrectable Data Error Valid" ],
);

%orbit_01_00625_def =
( NAME    => "OC_PI_MEM_RD_UNCORR_DATA_ERR",
  ADDRESS => 0x00000000a0028070,
  NOTE    => "The contents of this register are loaded with error detail data note when the first UnCorrectable Memory Read Data error is dete",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00625_flds
);


##########################################################################
#                                                                        #
#   OC_PI_MEM_RD_PKT_LEN_ERR                                             #
#                                                                        #
##########################################################################

%orbit_01_00626_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CL_ADDR"                      => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 1, 0x0000000000000000, "Cache Line Address; PA[47:7]" ],
   "ADDR_SPACE"                   => [   1,  21,   2, 0x0000000000600000, 0x00, 1, 0x0000000000000000, "Address Space for Read Data Error" ],
   "LOCAL"                        => [   2,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "Read Local Data Packet Error" ],
   "OBESE"                        => [   3,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "Read Obese Data Packet Error" ],
   "RSVD0"                        => [   4,  17,   2, 0x0000000000060000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RRB_CV_I"                     => [   5,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "RRB Conflict Vector Intervention" ],
   "RRB_S"                        => [   6,  13,   3, 0x000000000000E000, 0x00, 1, 0x0000000000000000, "Read Request State" ],
   "PROC_REQNUM"                  => [   7,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "Processor Request Number" ],
   "REQ_TYPE"                     => [   8,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "Read Request Type" ],
   "PROC_NUM"                     => [   9,   2,   2, 0x000000000000000C, 0x00, 1, 0x0000000000000000, "Processor Number" ],
   "ERR_OVRFLW"                   => [  10,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Memory Read Packet Length Error Overflow" ],
   "ERR_VAL"                      => [  11,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Memory Read Packet Length Error Valid" ],
);

%orbit_01_00626_def =
( NAME    => "OC_PI_MEM_RD_PKT_LEN_ERR",
  ADDRESS => 0x00000000a0028080,
  NOTE    => "This register captures the error detail for the first processor note memory read request that a Data Packet Length Error is dete",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00626_flds
);


##########################################################################
#                                                                        #
#   OC_PI_MEM_WR_ACCESS_ERR                                              #
#                                                                        #
##########################################################################

%orbit_01_00627_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CL_ADDR"                      => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 1, 0x0000000000000000, "Cache Line Address; PA[47:7]" ],
   "EXT_ERR_DETAIL"               => [   1,  17,   6, 0x00000000007E0000, 0x00, 1, 0x0000000000000000, "Extended Error Detail" ],
   "WRB_CV_I"                     => [   2,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "WRB Conflict Vector Intervention" ],
   "WRB_S"                        => [   3,  13,   3, 0x000000000000E000, 0x00, 1, 0x0000000000000000, "Write Request State" ],
   "RSVD0"                        => [   4,  10,   3, 0x0000000000001C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PROC_NUM"                     => [   5,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Processor Number" ],
   "REQ_TYPE"                     => [   6,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "Write Request Type" ],
   "RSVD1"                        => [   7,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERR_OVRFLW"                   => [   8,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Memory Write Access Error Overflow" ],
   "ERR_VAL"                      => [   9,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Memory Write Access Error Valid" ],
);

%orbit_01_00627_def =
( NAME    => "OC_PI_MEM_WR_ACCESS_ERR",
  ADDRESS => 0x00000000a0029000,
  NOTE    => "This register captures the error detail for the first processor note memory write request that receives an Access Error response",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00627_flds
);


##########################################################################
#                                                                        #
#   OC_PI_MEM_SPURIOUS_WR_MSG_ERR                                        #
#                                                                        #
##########################################################################

%orbit_01_00628_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CL_ADDR"                      => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 1, 0x0000000000000000, "Spurious Write Response Cache Line Address" ],
   "CMD"                          => [   1,  16,   7, 0x00000000007F0000, 0x00, 1, 0x0000000000000000, "Spurious Write Response Message Command" ],
   "SRC_NODE"                     => [   2,   2,  14, 0x000000000000FFFC, 0x00, 1, 0x0000000000000000, "Spurious Write Response Source Node" ],
   "ERR_OVRFLW"                   => [   3,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Spurious Memory Write Response Error Overflow" ],
   "ERR_VAL"                      => [   4,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Spurious Memory Write Response Error" ],
);

%orbit_01_00628_def =
( NAME    => "OC_PI_MEM_SPURIOUS_WR_MSG_ERR",
  ADDRESS => 0x00000000a0029010,
  NOTE    => "The contents of this register are loaded with the error detail data note when the first memory write response message is receive",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00628_flds
);


##########################################################################
#                                                                        #
#   OC_PI_MEM_WR_DIR_ERR                                                 #
#                                                                        #
##########################################################################

%orbit_01_00629_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CL_ADDR"                      => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 1, 0x0000000000000000, "Cache Line Address; PA[47:7]" ],
   "EXT_ERR_DETAIL"               => [   1,  17,   6, 0x00000000007E0000, 0x00, 1, 0x0000000000000000, "Extended Error Detail" ],
   "WRB_CV_I"                     => [   2,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "WRB Conflict Vector Intervention" ],
   "WRB_S"                        => [   3,  13,   3, 0x000000000000E000, 0x00, 1, 0x0000000000000000, "Write Request State" ],
   "RSVD0"                        => [   4,  10,   3, 0x0000000000001C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PROC_NUM"                     => [   5,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Processor Number" ],
   "REQ_TYPE"                     => [   6,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "Write Request Type" ],
   "RSVD1"                        => [   7,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERR_OVRFLW"                   => [   8,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Memory Write Directory Error Overflow" ],
   "ERR_VAL"                      => [   9,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Memory Write Directory Error Valid" ],
);

%orbit_01_00629_def =
( NAME    => "OC_PI_MEM_WR_DIR_ERR",
  ADDRESS => 0x00000000a0029020,
  NOTE    => "This register captures the error detail for the a processor write note request that receives a Directory Error response, (i.e., ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00629_flds
);


##########################################################################
#                                                                        #
#   OC_PI_MEM_WR_TO_ERR                                                  #
#                                                                        #
##########################################################################

%orbit_01_00630_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATUS_VEC"                   => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 1, 0x0000000000000000, "WRB Timeout Error Status Vector" ],
   "RSVD0"                        => [   1,   9,  23, 0x00000000FFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIRST_ERR_IDX"                => [   2,   4,   5, 0x00000000000001F0, 0x00, 1, 0x0000000000000000, "WRB First Timeout Error Entry Index" ],
   "RSVD1"                        => [   3,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERR_OVRFLW"                   => [   4,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Memory Write Request Timeout Error Overflow" ],
   "ERR_VAL"                      => [   5,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Memory Wirte Request Timeout Error Valid" ],
);

%orbit_01_00630_def =
( NAME    => "OC_PI_MEM_WR_TO_ERR",
  ADDRESS => 0x00000000a0029030,
  NOTE    => "The Memory Write Timeout Error register is loaded whenever the note timer for a valid write request expires. If enabled, the ent",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00630_flds
);


##########################################################################
#                                                                        #
#   OC_PI_MEM_WR_CORR_DATA_ERR                                           #
#                                                                        #
##########################################################################

%orbit_01_00631_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CL_ADDR"                      => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 1, 0x0000000000000000, "Write Data Error Cache Line Address" ],
   "ADDR_SPACE"                   => [   1,  21,   2, 0x0000000000600000, 0x00, 1, 0x0000000000000000, "Address Space for Write Data Error" ],
   "PARTIAL"                      => [   2,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "Parital Write Data Error" ],
   "PHASE1_SYNDROME"              => [   3,  12,   8, 0x00000000000FF000, 0x00, 1, 0x0000000000000000, "Phase1 Write Data Error Syndrome" ],
   "PHASE0_SYNDROME"              => [   4,   4,   8, 0x0000000000000FF0, 0x00, 1, 0x0000000000000000, "Phase0 Write Data Error Syndrome" ],
   "PROC_NUM"                     => [   5,   2,   2, 0x000000000000000C, 0x00, 1, 0x0000000000000000, "Processor Number" ],
   "ERR_OVRFLW"                   => [   6,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Memory Write Correctable Data Error Overflow" ],
   "ERR_VAL"                      => [   7,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Memory Write Correctable Data Error Valid" ],
);

%orbit_01_00631_def =
( NAME    => "OC_PI_MEM_WR_CORR_DATA_ERR",
  ADDRESS => 0x00000000a0029060,
  NOTE    => "The contents of this register are loaded with error detail data note when the first Correctable Memory Write Data Error is detec",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00631_flds
);


##########################################################################
#                                                                        #
#   OC_PI_MEM_WR_UNCORR_DATA_ERR                                         #
#                                                                        #
##########################################################################

%orbit_01_00632_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CL_ADDR"                      => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 1, 0x0000000000000000, "Write Data Error Cache Line Address" ],
   "ADDR_SPACE"                   => [   1,  21,   2, 0x0000000000600000, 0x00, 1, 0x0000000000000000, "Address Space for Write Data Error" ],
   "PARTIAL"                      => [   2,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "Parital Write Data Error" ],
   "PHASE1_SYNDROME"              => [   3,  12,   8, 0x00000000000FF000, 0x00, 1, 0x0000000000000000, "Phase1 Write Data Error Syndrome" ],
   "PHASE0_SYNDROME"              => [   4,   4,   8, 0x0000000000000FF0, 0x00, 1, 0x0000000000000000, "Phase0 Write Data Error Syndrome" ],
   "PROC_NUM"                     => [   5,   2,   2, 0x000000000000000C, 0x00, 1, 0x0000000000000000, "Processor Number" ],
   "ERR_OVRFLW"                   => [   6,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Memory Write UnCorrectable Data Error Overflow" ],
   "ERR_VAL"                      => [   7,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Memory Write UnCorrectable Data Error Valid" ],
);

%orbit_01_00632_def =
( NAME    => "OC_PI_MEM_WR_UNCORR_DATA_ERR",
  ADDRESS => 0x00000000a0029070,
  NOTE    => "The contents of this register are loaded with error detail note information when the first UnCorrectable Memory Write Data Error",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00632_flds
);


##########################################################################
#                                                                        #
#   OC_PI_MEM_WR_PKT_LEN_ERR                                             #
#                                                                        #
##########################################################################

%orbit_01_00633_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CL_ADDR"                      => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 1, 0x0000000000000000, "Cache Line Address; PA[47:7]" ],
   "ADDR_SPACE"                   => [   1,  21,   2, 0x0000000000600000, 0x00, 1, 0x0000000000000000, "Address Space for Write Data Error" ],
   "LOCAL"                        => [   2,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "Write Local Data Packet Error" ],
   "OBESE"                        => [   3,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "Write Obese Data Packet Error" ],
   "RSVD0"                        => [   4,  17,   2, 0x0000000000060000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRB_CV_I"                     => [   5,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "WRB Conflict Vector Intervention" ],
   "WRB_S"                        => [   6,  13,   3, 0x000000000000E000, 0x00, 1, 0x0000000000000000, "Write Request State" ],
   "PROC_REQNUM"                  => [   7,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "Processor Request Number" ],
   "REQ_TYPE"                     => [   8,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "Write Request Type" ],
   "PROC_NUM"                     => [   9,   2,   2, 0x000000000000000C, 0x00, 1, 0x0000000000000000, "Processor Number" ],
   "ERR_OVRFLW"                   => [  10,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Memory Write Packet Length Error Overflow" ],
   "ERR_VAL"                      => [  11,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Memory Write Packet Length Error Valid" ],
);

%orbit_01_00633_def =
( NAME    => "OC_PI_MEM_WR_PKT_LEN_ERR",
  ADDRESS => 0x00000000a0029080,
  NOTE    => "This register captures the error detail for the first processor note memory write request that a Data Packet Length Error is det",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00633_flds
);


##########################################################################
#                                                                        #
#   OC_PI_PROC_MEM_REQ_TBL_MISS                                          #
#                                                                        #
##########################################################################

%orbit_01_00634_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DW_ADDR"                      => [   0,  19,  45, 0xFFFFFFFFFFF80000, 0x00, 1, 0x0000000000000000, "Processor Request Double-word Address" ],
   "IRB_S"                        => [   1,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "Processor Request IRB_S Table Input" ],
   "RSVD0"                        => [   2,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RRB_S"                        => [   3,  12,   3, 0x0000000000007000, 0x00, 1, 0x0000000000000000, "Processor Request RRB_S Table Input" ],
   "WRB_S"                        => [   4,   9,   3, 0x0000000000000E00, 0x00, 1, 0x0000000000000000, "Processor Request WRB_S Table Input" ],
   "RD_REQ"                       => [   5,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Read/Write Request" ],
   "IMSG"                         => [   6,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "Processor Request Input Message" ],
   "PROC_NUM"                     => [   7,   2,   2, 0x000000000000000C, 0x00, 1, 0x0000000000000000, "Processor Number" ],
   "ERR_OVRFLW"                   => [   8,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Processor Memory Request Table Miss Overflow" ],
   "ERR_VAL"                      => [   9,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Processor Memory Request Table Miss Valid" ],
);

%orbit_01_00634_def =
( NAME    => "OC_PI_PROC_MEM_REQ_TBL_MISS",
  ADDRESS => 0x00000000a002a000,
  NOTE    => "The Processor Memory Request Table Miss register is loaded when a note valid local processor request cycle fails to hit a valid ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00634_flds
);


##########################################################################
#                                                                        #
#   OC_PI_SYS_MEM_REQ_TBL_MISS                                           #
#                                                                        #
##########################################################################

%orbit_01_00635_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CL_ADDR"                      => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 1, 0x0000000000000000, "System Request Cache Line Address" ],
   "SRC_NODE"                     => [   1,  10,  13, 0x00000000007FFC00, 0x00, 1, 0x0000000000000000, "System Request Source Node" ],
   "WRB_S"                        => [   2,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "System Request WRB_S Table Input" ],
   "RRB_S"                        => [   3,   5,   3, 0x00000000000000E0, 0x00, 1, 0x0000000000000000, "System Request RRB_S Table Input" ],
   "IMSG"                         => [   4,   2,   3, 0x000000000000001C, 0x00, 1, 0x0000000000000000, "System Request Table Input Message" ],
   "ERR_OVRFLW"                   => [   5,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "System Request Protocol Table Miss Overflow" ],
   "ERR_VAL"                      => [   6,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "System Request Protocol Table Miss" ],
);

%orbit_01_00635_def =
( NAME    => "OC_PI_SYS_MEM_REQ_TBL_MISS",
  ADDRESS => 0x00000000a002a020,
  NOTE    => "The contents of this register are loaded with the error detail data note when either a Invalidate or Intervention external syste",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00635_flds
);


##########################################################################
#                                                                        #
#   OC_PI_SYS_MEM_RSP_TBL_MISS                                           #
#                                                                        #
##########################################################################

%orbit_01_00636_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DW_ADDR"                      => [   0,  19,  45, 0xFFFFFFFFFFF80000, 0x00, 1, 0x0000000000000000, "System Response Doubleword Address" ],
   "RSP_ECHO"                     => [   1,  10,   9, 0x000000000007FC00, 0x00, 1, 0x0000000000000000, "System Response Table Miss Echo" ],
   "RSP_CMD"                      => [   2,   2,   8, 0x00000000000003FC, 0x00, 1, 0x0000000000000000, "System Response Table Miss Command" ],
   "ERR_OVRFLW"                   => [   3,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "System Memory Response Table Miss Overflow" ],
   "ERR_VAL"                      => [   4,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "System Memory Response Table Miss Valid" ],
);

%orbit_01_00636_def =
( NAME    => "OC_PI_SYS_MEM_RSP_TBL_MISS",
  ADDRESS => 0x00000000a002a030,
  NOTE    => "The System Memory Response Table Miss register is loaded when a note valid system response message header fails to hit a valid p",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00636_flds
);


##########################################################################
#                                                                        #
#   OC_PI_RD_SYSSTATE_FIFO_ERR                                           #
#                                                                        #
##########################################################################

%orbit_01_00637_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CPU1_FIFO_DATA"               => [   0,  50,  14, 0xFFFC000000000000, 0x00, 1, 0x0000000000000000, "CPU1 RRB FIFO Error Data" ],
   "CPU0_FIFO_DATA"               => [   1,  36,  14, 0x0003FFF000000000, 0x00, 1, 0x0000000000000000, "CPU0 RRB FIFO Error Data" ],
   "CPU1_PH1_SYSSTATE"            => [   2,  30,   6, 0x0000000FC0000000, 0x00, 1, 0x0000000000000000, "CPU1 Phase1 SysState Data" ],
   "CPU1_PH0_SYSSTATE"            => [   3,  24,   6, 0x000000003F000000, 0x00, 1, 0x0000000000000000, "CPU1 Phase0 SysState Data" ],
   "CPU0_PH1_SYSSTATE"            => [   4,  18,   6, 0x0000000000FC0000, 0x00, 1, 0x0000000000000000, "CPU0 Phase1 SysState Data" ],
   "CPU0_PH0_SYSSTATE"            => [   5,  12,   6, 0x000000000003F000, 0x00, 1, 0x0000000000000000, "CPU0 Phase0 SysState Data" ],
   "CPU1_BTAG"                    => [   6,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "CPU1 SysState Bad Tag Error" ],
   "CPU0_BTAG"                    => [   7,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "CPU0 SysState Bad Tag Error" ],
   "CPU1_PERR"                    => [   8,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "CPU1 SysState Parity Error" ],
   "CPU0_PERR"                    => [   9,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "CPU0 SysState Parity Error" ],
   "UNDRFLW_CPU1"                 => [  10,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "CPU1 FIFO Underflow Error" ],
   "UNDRFLW_CPU0"                 => [  11,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "CPU0 FIFO Underflow Error" ],
   "OVRFLW_CPU1"                  => [  12,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "CPU1 FIFO Overflow Error" ],
   "OVRFLW_CPU0"                  => [  13,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "CPU0 FIFO Overflow Error" ],
   "RSVD0"                        => [  14,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERR_OVRFLW"                   => [  15,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Read SysState FIFO Error Overflow" ],
   "ERR_VAL"                      => [  16,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Read SysState FIFO Error Valid" ],
);

%orbit_01_00637_def =
( NAME    => "OC_PI_RD_SYSSTATE_FIFO_ERR",
  ADDRESS => 0x00000000a002a040,
  NOTE    => "This register captures first error detail data from the Read note Request SysState response FIFO. This FIFO is used to gather th",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00637_flds
);


##########################################################################
#                                                                        #
#   OC_PI_INTV_SYSSTATE_FIFO_ERR                                         #
#                                                                        #
##########################################################################

%orbit_01_00638_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVRFLW_DATA"                  => [   1,  56,   5, 0x1F00000000000000, 0x00, 1, 0x0000000000000000, "Intv FIFO Overflow Data" ],
   "CPU1_RD_DATA1"                => [   2,  51,   5, 0x00F8000000000000, 0x00, 1, 0x0000000000000000, "CPU1 Intv FIFO Read Data1" ],
   "CPU1_RD_DATA0"                => [   3,  46,   5, 0x0007C00000000000, 0x00, 1, 0x0000000000000000, "CPU1 Intv FIFO Read Data0" ],
   "CPU0_RD_DATA1"                => [   4,  41,   5, 0x00003E0000000000, 0x00, 1, 0x0000000000000000, "CPU0 Intv FIFO Read Data1" ],
   "CPU0_RD_DATA0"                => [   5,  36,   5, 0x000001F000000000, 0x00, 1, 0x0000000000000000, "CPU0 Intv FIFO Read Data0" ],
   "CPU1_PH1_SYSSTATE"            => [   6,  30,   6, 0x0000000FC0000000, 0x00, 1, 0x0000000000000000, "CPU1 Phase1 SysState Data" ],
   "CPU1_PH0_SYSSTATE"            => [   7,  24,   6, 0x000000003F000000, 0x00, 1, 0x0000000000000000, "CPU1 Phase0 SysState Data" ],
   "CPU0_PH1_SYSSTATE"            => [   8,  18,   6, 0x0000000000FC0000, 0x00, 1, 0x0000000000000000, "CPU0 Phase1 SysState Data" ],
   "CPU0_PH0_SYSSTATE"            => [   9,  12,   6, 0x000000000003F000, 0x00, 1, 0x0000000000000000, "CPU0 Phase0 SysState Data" ],
   "CPU1_BTAG"                    => [  10,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "CPU1 SysState Bad Tag Error" ],
   "CPU0_BTAG"                    => [  11,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "CPU0 SysState Bad Tag Error" ],
   "CPU1_PERR"                    => [  12,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "CPU1 SysState Parity Error" ],
   "CPU0_PERR"                    => [  13,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "CPU0 SysState Parity Error" ],
   "UNDRFLW_CPU1"                 => [  14,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "CPU1 FIFO Underflow Error" ],
   "UNDRFLW_CPU0"                 => [  15,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "CPU0 FIFO Underflow Error" ],
   "OVRFLW_CPU1"                  => [  16,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "CPU1 FIFO Overflow Error" ],
   "OVRFLW_CPU0"                  => [  17,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "CPU0 FIFO Overflow Error" ],
   "RSVD1"                        => [  18,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERR_OVRFLW"                   => [  19,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Intv FIFO Error Detail Overflow" ],
   "ERR_VAL"                      => [  20,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Intv FIFO Error Detail Valid" ],
);

%orbit_01_00638_def =
( NAME    => "OC_PI_INTV_SYSSTATE_FIFO_ERR",
  ADDRESS => 0x00000000a002a050,
  NOTE    => "This register captures detailed first error data from the CRB FIFO note that gathers SysState responses to system Intervention a",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00638_flds
);


##########################################################################
#                                                                        #
#   OC_PI_INTV_TIMEOUT_ERR                                               #
#                                                                        #
##########################################################################

%orbit_01_00639_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TO_STATUS_VEC"                => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 1, 0x0000000000000000, "Intv Timeout Error Status Vector" ],
   "RSVD0"                        => [   1,   9,  23, 0x00000000FFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TO_FIRST_ERR_IDX"             => [   2,   4,   5, 0x00000000000001F0, 0x00, 1, 0x0000000000000000, "Intv First Timeout Error Entry Index" ],
   "RSVD1"                        => [   3,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TO_ERR_OVRFLW"                => [   4,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Intv Timeout Error Overflow" ],
   "TO_ERR_VAL"                   => [   5,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Intv Timeout Error Valid" ],
);

%orbit_01_00639_def =
( NAME    => "OC_PI_INTV_TIMEOUT_ERR",
  ADDRESS => 0x00000000a002a100,
  NOTE    => "The Intv Timeout Error register is loaded whenever the timer for a note valid read request expires. If enabled, the entry timers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00639_flds
);


##########################################################################
#                                                                        #
#   OC_PI_CRB_BUF_ERR                                                    #
#                                                                        #
##########################################################################

%orbit_01_00640_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IRB_WR_ERR_IDX"               => [   1,  33,   5, 0x0000003E00000000, 0x00, 1, 0x0000000000000000, "CAM IRB Write Error Index" ],
   "IRB_WR_ERR"                   => [   2,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "CAM IRB Write Error" ],
   "RSVD1"                        => [   3,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRB_WR_ERR_IDX"               => [   4,  25,   5, 0x000000003E000000, 0x00, 1, 0x0000000000000000, "CAM WRB Write Error Index" ],
   "WRB_WR_ERR"                   => [   5,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "CAM WRB Write Error" ],
   "RSVD2"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RRB_WR_ERR_IDX"               => [   7,  17,   5, 0x00000000003E0000, 0x00, 1, 0x0000000000000000, "CAM RRB Write Error Index" ],
   "RRB_WR_ERR"                   => [   8,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "CAM RRB Write Error" ],
   "RSVD3"                        => [   9,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXT_RSP_Q_UNDRFLW"            => [  10,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "System Response Queue Underflow Error" ],
   "EXT_RSP_Q_OVRFLW"             => [  11,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "System Response Queue Overflow Error" ],
   "IRB_REQ_Q_UNDRFLW"            => [  12,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "CPU Response Queue Underflow Error" ],
   "IRB_REQ_Q_OVRFLW"             => [  13,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "CPU Response Queue Overflow Error" ],
   "WRB_REQ_Q_UNDRFLW"            => [  14,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "CPU Write Request Queue Underflow Error" ],
   "WRB_REQ_Q_OVRFLW"             => [  15,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "CPU Write Request Queue Overflow Error" ],
   "RRB_REQ_Q_UNDRFLW"            => [  16,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "CPU Read Request Queue Underflow Error" ],
   "RRB_REQ_Q_OVRFLW"             => [  17,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "CPU Read Request Queue Overflow Error" ],
   "RSVD4"                        => [  18,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERR_OVRFLW"                   => [  19,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "CRB Buffer Error Detail Overflow" ],
   "ERR_VAL"                      => [  20,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "CRB Buffer Error Detail Valid" ],
);

%orbit_01_00640_def =
( NAME    => "OC_PI_CRB_BUF_ERR",
  ADDRESS => 0x00000000a002a060,
  NOTE    => "The CRB Buffer Error Detail register is used to capture error note indicators from all of the message buffers within the CRB. Th",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00640_flds
);


##########################################################################
#                                                                        #
#   OC_GFX_CREDIT_COUNT_0                                                #
#                                                                        #
##########################################################################

%orbit_01_00641_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RESET_GFX_STATE"              => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD0"                        => [   1,  12,  51, 0x7FFFFFFFFFFFF000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   2,   0,  12, 0x0000000000000FFF, 0x00, 1, 0x0000000000000000, "" ],
);

%orbit_01_00641_def =
( NAME    => "OC_GFX_CREDIT_COUNT_0",
  ADDRESS => 0x00000000a0030000,
  NOTE    => "Graphics-write Credit Count for processor 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00641_flds
);


##########################################################################
#                                                                        #
#   OC_GFX_CREDIT_COUNT_1                                                #
#                                                                        #
##########################################################################

%orbit_01_00642_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RESET_GFX_STATE"              => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD0"                        => [   1,  12,  51, 0x7FFFFFFFFFFFF000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   2,   0,  12, 0x0000000000000FFF, 0x00, 1, 0x0000000000000000, "" ],
);

%orbit_01_00642_def =
( NAME    => "OC_GFX_CREDIT_COUNT_1",
  ADDRESS => 0x00000000a0030008,
  NOTE    => "Graphics-write Credit Count for processor 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00642_flds
);


##########################################################################
#                                                                        #
#   OC_GFX_MODE_CNTRL_0                                                  #
#                                                                        #
##########################################################################

%orbit_01_00643_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PROCESSOR_SELECT"             => [   1,   3,   2, 0x0000000000000018, 0x00, 1, 0x0000000000000000, "GFX Pipe Processor Select" ],
   "RELAXED_ORDERING"             => [   2,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "GFX message routing order" ],
   "RSVD1"                        => [   3,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DWORD_CREDITS"                => [   4,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "GFX credits are tracked by D-words" ],
);

%orbit_01_00643_def =
( NAME    => "OC_GFX_MODE_CNTRL_0",
  ADDRESS => 0x00000000a0030010,
  NOTE    => "This register is used to define credit tracking, graphic message note ordering and associated processor for GFX Pipe 0.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00643_flds
);


##########################################################################
#                                                                        #
#   OC_GFX_MODE_CNTRL_1                                                  #
#                                                                        #
##########################################################################

%orbit_01_00644_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PROCESSOR_SELECT"             => [   1,   3,   2, 0x0000000000000018, 0x00, 1, 0x0000000000000000, "GFX Pipe Processor Select" ],
   "RELAXED_ORDERING"             => [   2,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "GFX message routing order" ],
   "RSVD1"                        => [   3,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DWORD_CREDITS"                => [   4,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "GFX credits are tracked by D-words" ],
);

%orbit_01_00644_def =
( NAME    => "OC_GFX_MODE_CNTRL_1",
  ADDRESS => 0x00000000a0030018,
  NOTE    => "This register is used to define credit tracking, graphic message note ordering and associated processor for GFX Pipe 1.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00644_flds
);


##########################################################################
#                                                                        #
#   OC_GFX_SKID_CREDIT_COUNT_0                                           #
#                                                                        #
##########################################################################

%orbit_01_00645_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  12,  52, 0xFFFFFFFFFFFFF000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SKID"                         => [   1,   0,  12, 0x0000000000000FFF, 0x00, 1, 0x0000000000000000, "Skid Credit Count" ],
);

%orbit_01_00645_def =
( NAME    => "OC_GFX_SKID_CREDIT_COUNT_0",
  ADDRESS => 0x00000000a0030020,
  NOTE    => "Graphics-write Skid Credit Count for processor 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00645_flds
);


##########################################################################
#                                                                        #
#   OC_GFX_SKID_CREDIT_COUNT_1                                           #
#                                                                        #
##########################################################################

%orbit_01_00646_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  12,  52, 0xFFFFFFFFFFFFF000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SKID"                         => [   1,   0,  12, 0x0000000000000FFF, 0x00, 1, 0x0000000000000000, "Skid Credit Count" ],
);

%orbit_01_00646_def =
( NAME    => "OC_GFX_SKID_CREDIT_COUNT_1",
  ADDRESS => 0x00000000a0030028,
  NOTE    => "Graphics-write Skid Credit Count for processor 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00646_flds
);


##########################################################################
#                                                                        #
#   OC_GFX_STALL_LIMIT_0                                                 #
#                                                                        #
##########################################################################

%orbit_01_00647_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  26,  38, 0xFFFFFFFFFC000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LIMIT"                        => [   1,   0,  26, 0x0000000003FFFFFF, 0x00, 1, 0x0000000000000000, "Graphics Stall Limit for GFX Pipe 0" ],
);

%orbit_01_00647_def =
( NAME    => "OC_GFX_STALL_LIMIT_0",
  ADDRESS => 0x00000000a0030030,
  NOTE    => "Graphics-write Stall Limit for processor 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00647_flds
);


##########################################################################
#                                                                        #
#   OC_GFX_STALL_LIMIT_1                                                 #
#                                                                        #
##########################################################################

%orbit_01_00648_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  26,  38, 0xFFFFFFFFFC000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LIMIT"                        => [   1,   0,  26, 0x0000000003FFFFFF, 0x00, 1, 0x0000000000000000, "Graphics Stall Limit for GFX Pipe 1" ],
);

%orbit_01_00648_def =
( NAME    => "OC_GFX_STALL_LIMIT_1",
  ADDRESS => 0x00000000a0030038,
  NOTE    => "Graphics-write Stall Limit for processor 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00648_flds
);


##########################################################################
#                                                                        #
#   OC_GFX_STALL_TIMER_0                                                 #
#                                                                        #
##########################################################################

%orbit_01_00649_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  26,  38, 0xFFFFFFFFFC000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIMER_VALUE"                  => [   1,   0,  26, 0x0000000003FFFFFF, 0x00, 1, 0x0000000000000000, "Graphics stall timer value for GFX Pipe 0" ],
);

%orbit_01_00649_def =
( NAME    => "OC_GFX_STALL_TIMER_0",
  ADDRESS => 0x00000000a0030040,
  NOTE    => "Graphics-write Stall Timer for processor 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00649_flds
);


##########################################################################
#                                                                        #
#   OC_GFX_STALL_TIMER_1                                                 #
#                                                                        #
##########################################################################

%orbit_01_00650_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  26,  38, 0xFFFFFFFFFC000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIMER_VALUE"                  => [   1,   0,  26, 0x0000000003FFFFFF, 0x00, 1, 0x0000000000000000, "Graphics stall timer value for GFX Pipe 1" ],
);

%orbit_01_00650_def =
( NAME    => "OC_GFX_STALL_TIMER_1",
  ADDRESS => 0x00000000a0030048,
  NOTE    => "Graphics-write Stall Timer for processor 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00650_flds
);


##########################################################################
#                                                                        #
#   OC_GFX_WINDOW_0                                                      #
#                                                                        #
##########################################################################

%orbit_01_00651_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "GFX_WINDOW_EN"                => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Graphics Window Enabled" ],
   "RSVD0"                        => [   1,  48,  15, 0x7FFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE_ADDR"                    => [   2,  24,  24, 0x0000FFFFFF000000, 0x00, 1, 0x0000000000000000, "Base Address for GFX Pipe 0's 16 MB Graphics Window" ],
);

%orbit_01_00651_def =
( NAME    => "OC_GFX_WINDOW_0",
  ADDRESS => 0x00000000a0030050,
  NOTE    => "This register identifies the base addresss of a 16MB 'window' in note memory for the processor of GFX Pipe 0 that is mapped into",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00651_flds
);


##########################################################################
#                                                                        #
#   OC_GFX_WINDOW_1                                                      #
#                                                                        #
##########################################################################

%orbit_01_00652_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "GFX_WINDOW_EN"                => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Graphics Window Enabled" ],
   "RSVD0"                        => [   1,  48,  15, 0x7FFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE_ADDR"                    => [   2,  24,  24, 0x0000FFFFFF000000, 0x00, 1, 0x0000000000000000, "Base Address for GFX Pipe 1's 16 MB Graphics Window" ],
);

%orbit_01_00652_def =
( NAME    => "OC_GFX_WINDOW_1",
  ADDRESS => 0x00000000a0030058,
  NOTE    => "This register identifies the base addresss of a 16MB 'window' in note memory for the processor of GFX Pipe 1 that is mapped into",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00652_flds
);


##########################################################################
#                                                                        #
#   OC_GFX_TIMEOUT_PRESCALE                                              #
#                                                                        #
##########################################################################

%orbit_01_00653_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCALING_FACTOR"               => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "GFX Time-out Prescale Factor" ],
);

%orbit_01_00653_def =
( NAME    => "OC_GFX_TIMEOUT_PRESCALE",
  ADDRESS => 0x00000000a0030060,
  NOTE    => "This register controls frequency at which the GFX Time-out Counter note increments.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00653_flds
);


##########################################################################
#                                                                        #
#   OC_GFX_FIFO_LOW_H2O_MARK                                             #
#                                                                        #
##########################################################################

%orbit_01_00654_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WATER_MARK"                   => [   1,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "GFX FIFO Low Water Mark" ],
);

%orbit_01_00654_def =
( NAME    => "OC_GFX_FIFO_LOW_H2O_MARK",
  ADDRESS => 0x00000000a0030080,
  NOTE    => "This register controls the low water mark for the Graphics Fifos",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00654_flds
);


##########################################################################
#                                                                        #
#   OC_GFX_DFIFO_LOW_H2O_MARK                                            #
#                                                                        #
##########################################################################

%orbit_01_00655_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   7,  57, 0xFFFFFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WATER_MARK"                   => [   1,   0,   7, 0x000000000000007F, 0x00, 1, 0x0000000000000000, "GFX Data FIFO Low Water Mark" ],
);

%orbit_01_00655_def =
( NAME    => "OC_GFX_DFIFO_LOW_H2O_MARK",
  ADDRESS => 0x00000000a0030088,
  NOTE    => "This register controls the low water mark for the Graphics Data note Fifos",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00655_flds
);


##########################################################################
#                                                                        #
#   OC_PIO_TIMEOUT_PRESCALE                                              #
#                                                                        #
##########################################################################

%orbit_01_00656_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCALING_FACTOR"               => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "PIO Time-out Prescale Factor" ],
);

%orbit_01_00656_def =
( NAME    => "OC_PIO_TIMEOUT_PRESCALE",
  ADDRESS => 0x00000000a0030100,
  NOTE    => "This register controls frequency at which the PIO Time-out Counter note increments.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00656_flds
);


##########################################################################
#                                                                        #
#   OC_PIO_FIFO_LOW_H2O_MARK                                             #
#                                                                        #
##########################################################################

%orbit_01_00657_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   4,  60, 0xFFFFFFFFFFFFFFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WATER_MARK"                   => [   1,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "PIO FIFO Low Water Mark" ],
);

%orbit_01_00657_def =
( NAME    => "OC_PIO_FIFO_LOW_H2O_MARK",
  ADDRESS => 0x00000000a0030108,
  NOTE    => "This register controls the low water mark for the PIO Fifos",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00657_flds
);


##########################################################################
#                                                                        #
#   OC_NCOH_MESSAGE_CONTROL                                              #
#                                                                        #
##########################################################################

%orbit_01_00658_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCRATCH"                      => [   1,   2,   6, 0x00000000000000FC, 0x00, 1, 0x0000000000000000, "scratch bits" ],
   "MESSAGE_COLOR_ENABLE"         => [   2,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Enable color message processing" ],
   "MESSAGE_COLOR"                => [   3,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Define color of message" ],
);

%orbit_01_00658_def =
( NAME    => "OC_NCOH_MESSAGE_CONTROL",
  ADDRESS => 0x00000000a0030118,
  NOTE    => "The PI_NCOH_MESSAGE_CONTROL register determines the types of note messages generated by the Orbit.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00658_flds
);


##########################################################################
#                                                                        #
#   OC_GFX_WRITE_STATUS_0                                                #
#                                                                        #
##########################################################################

%orbit_01_00659_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RE_ENABLE_GFX_STALL"          => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Re-enable GFX stall logic for this processor" ],
   "RSVD0"                        => [   1,   1,  62, 0x7FFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BUSY"                         => [   2,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Busy" ],
);

%orbit_01_00659_def =
( NAME    => "OC_GFX_WRITE_STATUS_0",
  ADDRESS => 0x00000000a0038000,
  NOTE    => "GFX_WRITE_STATUS_0 is a status register which allows software to note check for outstand graphics-write requests for CPU 0.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00659_flds
);


##########################################################################
#                                                                        #
#   OC_GFX_WRITE_STATUS_1                                                #
#                                                                        #
##########################################################################

%orbit_01_00660_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RE_ENABLE_GFX_STALL"          => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Re-enable GFX stall logic for this processor" ],
   "RSVD0"                        => [   1,   1,  62, 0x7FFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BUSY"                         => [   2,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Busy" ],
);

%orbit_01_00660_def =
( NAME    => "OC_GFX_WRITE_STATUS_1",
  ADDRESS => 0x00000000a0038008,
  NOTE    => "GFX_WRITE_STATUS_1 is a status register which allows software to note check for outstand graphics-write requests for CPU 1.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00660_flds
);


##########################################################################
#                                                                        #
#   OC_PIO_WRITE_STATUS_0                                                #
#                                                                        #
##########################################################################

%orbit_01_00661_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "WRITES_OK"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "No pending writes or errors" ],
   "RSVD0"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   2,  56,   6, 0x3F00000000000000, 0x00, 1, 0x0000000000000000, "Count of currently pending PIO writes" ],
   "RSVD1"                        => [   3,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE_ERROR_ADDRESS"          => [   4,   3,  49, 0x000FFFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "Address associated with error response" ],
   "WRITE_ERROR"                  => [   5,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Error response detected" ],
   "RSVD2"                        => [   6,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MULTI_WRITE_ERROR"            => [   7,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "More than one PIO write error occurred" ],
);

%orbit_01_00661_def =
( NAME    => "OC_PIO_WRITE_STATUS_0",
  ADDRESS => 0x00000000a0038010,
  NOTE    => "The PIO_WRITE_STATUS_0 register is used to provide status for note programmed I/O (PIO) write operations. It provides completion",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00661_flds
);


##########################################################################
#                                                                        #
#   OC_PIO_WRITE_STATUS_1                                                #
#                                                                        #
##########################################################################

%orbit_01_00662_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "WRITES_OK"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "No pending writes or errors" ],
   "RSVD0"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   2,  56,   6, 0x3F00000000000000, 0x00, 1, 0x0000000000000000, "Count of currently pending PIO writes" ],
   "RSVD1"                        => [   3,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE_ERROR_ADDRESS"          => [   4,   3,  49, 0x000FFFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "Address associated with error response" ],
   "WRITE_ERROR"                  => [   5,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Error response detected" ],
   "RSVD2"                        => [   6,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MULTI_WRITE_ERROR"            => [   7,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "More than one PIO write error occurred" ],
);

%orbit_01_00662_def =
( NAME    => "OC_PIO_WRITE_STATUS_1",
  ADDRESS => 0x00000000a0038020,
  NOTE    => "The PIO_WRITE_STATUS_1 register is used to provide status for note programmed I/O (PIO) write operations. It provides completion",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00662_flds
);


##########################################################################
#                                                                        #
#   OC_PIO_WRITE_STATUS_2                                                #
#                                                                        #
##########################################################################

%orbit_01_00663_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "WRITES_OK"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "No pending writes or errors" ],
   "RSVD0"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   2,  56,   6, 0x3F00000000000000, 0x00, 1, 0x0000000000000000, "Count of currently pending PIO writes" ],
   "RSVD1"                        => [   3,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE_ERROR_ADDRESS"          => [   4,   3,  49, 0x000FFFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "Address associated with error response" ],
   "WRITE_ERROR"                  => [   5,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Error response detected" ],
   "RSVD2"                        => [   6,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MULTI_WRITE_ERROR"            => [   7,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "More than one PIO write error occurred" ],
);

%orbit_01_00663_def =
( NAME    => "OC_PIO_WRITE_STATUS_2",
  ADDRESS => 0x00000000a0038030,
  NOTE    => "The PIO_WRITE_STATUS_2 register is used to provide status for note programmed I/O (PIO) write operations. It provides completion",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00663_flds
);


##########################################################################
#                                                                        #
#   OC_PIO_WRITE_STATUS_3                                                #
#                                                                        #
##########################################################################

%orbit_01_00664_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "WRITES_OK"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "No pending writes or errors" ],
   "RSVD0"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   2,  56,   6, 0x3F00000000000000, 0x00, 1, 0x0000000000000000, "Count of currently pending PIO writes" ],
   "RSVD1"                        => [   3,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE_ERROR_ADDRESS"          => [   4,   3,  49, 0x000FFFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "Address associated with error response" ],
   "WRITE_ERROR"                  => [   5,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Error response detected" ],
   "RSVD2"                        => [   6,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MULTI_WRITE_ERROR"            => [   7,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "More than one PIO write error occurred" ],
);

%orbit_01_00664_def =
( NAME    => "OC_PIO_WRITE_STATUS_3",
  ADDRESS => 0x00000000a0038040,
  NOTE    => "The PIO_WRITE_STATUS_3 register is used to provide status for note programmed I/O (PIO) write operations. It provides completion",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00664_flds
);


##########################################################################
#                                                                        #
#   OC_PIO_WRITE_STATUS_0_ALIAS                                          #
#                                                                        #
##########################################################################

%orbit_01_00665_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "WRITES_OK"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "No pending writes or errors" ],
   "RSVD0"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   2,  56,   6, 0x3F00000000000000, 0x00, 1, 0x0000000000000000, "Count of currently pending PIO writes" ],
   "RSVD1"                        => [   3,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE_ERROR_ADDRESS"          => [   4,   3,  49, 0x000FFFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "Address associated with error response" ],
   "WRITE_ERROR"                  => [   5,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Error response detected" ],
   "RSVD2"                        => [   6,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MULTI_WRITE_ERROR"            => [   7,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "More than one PIO write error occurred" ],
);

%orbit_01_00665_def =
( NAME    => "OC_PIO_WRITE_STATUS_0_ALIAS",
  ADDRESS => 0x00000000a0038018,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00665_flds
);


##########################################################################
#                                                                        #
#   OC_PIO_WRITE_STATUS_1_ALIAS                                          #
#                                                                        #
##########################################################################

%orbit_01_00666_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "WRITES_OK"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "No pending writes or errors" ],
   "RSVD0"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   2,  56,   6, 0x3F00000000000000, 0x00, 1, 0x0000000000000000, "Count of currently pending PIO writes" ],
   "RSVD1"                        => [   3,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE_ERROR_ADDRESS"          => [   4,   3,  49, 0x000FFFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "Address associated with error response" ],
   "WRITE_ERROR"                  => [   5,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Error response detected" ],
   "RSVD2"                        => [   6,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MULTI_WRITE_ERROR"            => [   7,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "More than one PIO write error occurred" ],
);

%orbit_01_00666_def =
( NAME    => "OC_PIO_WRITE_STATUS_1_ALIAS",
  ADDRESS => 0x00000000a0038028,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00666_flds
);


##########################################################################
#                                                                        #
#   OC_PIO_WRITE_STATUS_2_ALIAS                                          #
#                                                                        #
##########################################################################

%orbit_01_00667_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "WRITES_OK"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "No pending writes or errors" ],
   "RSVD0"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   2,  56,   6, 0x3F00000000000000, 0x00, 1, 0x0000000000000000, "Count of currently pending PIO writes" ],
   "RSVD1"                        => [   3,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE_ERROR_ADDRESS"          => [   4,   3,  49, 0x000FFFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "Address associated with error response" ],
   "WRITE_ERROR"                  => [   5,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Error response detected" ],
   "RSVD2"                        => [   6,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MULTI_WRITE_ERROR"            => [   7,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "More than one PIO write error occurred" ],
);

%orbit_01_00667_def =
( NAME    => "OC_PIO_WRITE_STATUS_2_ALIAS",
  ADDRESS => 0x00000000a0038038,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00667_flds
);


##########################################################################
#                                                                        #
#   OC_PIO_WRITE_STATUS_3_ALIAS                                          #
#                                                                        #
##########################################################################

%orbit_01_00668_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "WRITES_OK"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "No pending writes or errors" ],
   "RSVD0"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   2,  56,   6, 0x3F00000000000000, 0x00, 1, 0x0000000000000000, "Count of currently pending PIO writes" ],
   "RSVD1"                        => [   3,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE_ERROR_ADDRESS"          => [   4,   3,  49, 0x000FFFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "Address associated with error response" ],
   "WRITE_ERROR"                  => [   5,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Error response detected" ],
   "RSVD2"                        => [   6,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MULTI_WRITE_ERROR"            => [   7,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "More than one PIO write error occurred" ],
);

%orbit_01_00668_def =
( NAME    => "OC_PIO_WRITE_STATUS_3_ALIAS",
  ADDRESS => 0x00000000a0038048,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00668_flds
);


##########################################################################
#                                                                        #
#   OC_PI_IO_RD_ACCESS_ERR                                               #
#                                                                        #
##########################################################################

%orbit_01_00669_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CL_ADDR"                      => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 0, 0x0000000000000000, "IO Read Address Access Error Detail Cache Line Address; PA[47:7]" ],
   "DW_ADDR"                      => [   1,  19,   4, 0x0000000000780000, 0x00, 0, 0x0000000000000000, "IO Read Address Access Error Detail Cache Line Address; PA[6:3]" ],
   "ADDR_SPACE"                   => [   2,  17,   2, 0x0000000000060000, 0x00, 0, 0x0000000000000000, "IO Read Address Access Error Detail SysT Address Space Attribute" ],
   "RSVD0"                        => [   3,  13,   4, 0x000000000001E000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_NUM"                      => [   4,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "IO Read Address Access Error Detail SysT Request Number" ],
   "REQ_TYPE"                     => [   5,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "IO Read Address Access Error Detail Request Type" ],
   "PROC_NUM"                     => [   6,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "IO Read Address Access Error Detail Processor Number" ],
   "ERR_OVRFLW"                   => [   7,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "IO Read Address Access Error Overflow" ],
   "ERR_VAL"                      => [   8,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "IO Read Address Access Error Valid" ],
);

%orbit_01_00669_def =
( NAME    => "OC_PI_IO_RD_ACCESS_ERR",
  ADDRESS => 0x00000000a0038800,
  NOTE    => "IO Read Address Access Error Detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00669_flds
);


##########################################################################
#                                                                        #
#   OC_PI_IO_WR_ACCESS_ERR                                               #
#                                                                        #
##########################################################################

%orbit_01_00670_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CL_ADDR"                      => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 0, 0x0000000000000000, "IO Write Address Access Error Detail Cache Line Address; PA[47:7]" ],
   "DW_ADDR"                      => [   1,  19,   4, 0x0000000000780000, 0x00, 0, 0x0000000000000000, "IO Write Address Access Error Detail Cache Line Address; PA[6:3]" ],
   "ADDR_SPACE"                   => [   2,  17,   2, 0x0000000000060000, 0x00, 0, 0x0000000000000000, "IO Write Address Access Error Detail SysT Address Space Attribute" ],
   "RSVD0"                        => [   3,  13,   4, 0x000000000001E000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_NUM"                      => [   4,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "IO Write Address Access Error Detail SysT Request Number" ],
   "REQ_TYPE"                     => [   5,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "IO Write Address Access Error Detail Request Type" ],
   "PROC_NUM"                     => [   6,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "IO Write Address Access Error Detail Processor Number" ],
   "ERR_OVRFLW"                   => [   7,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "IO Write Address Access Error Overflow" ],
   "ERR_VAL"                      => [   8,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "IO Write Address Access Error Valid" ],
);

%orbit_01_00670_def =
( NAME    => "OC_PI_IO_WR_ACCESS_ERR",
  ADDRESS => 0x00000000a0038808,
  NOTE    => "IO Write Address Access Error Detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00670_flds
);


##########################################################################
#                                                                        #
#   OC_PI_IO_RD_SPURIOUS_MSG_ERR                                         #
#                                                                        #
##########################################################################

%orbit_01_00671_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CL_ADDR"                      => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 0, 0x0000000000000000, "Spurious IO Read Response Cache Line Address" ],
   "CMD"                          => [   1,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Spurious IO Read Response Command" ],
   "SRC_NODE"                     => [   2,   2,  14, 0x000000000000FFFC, 0x00, 0, 0x0000000000000000, "Spurious IO Read Response Source Node" ],
   "ERR_OVRFLW"                   => [   3,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Spurious IO Read Response Error Overflow" ],
   "ERR_VAL"                      => [   4,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Spurious IO Read Response Error" ],
);

%orbit_01_00671_def =
( NAME    => "OC_PI_IO_RD_SPURIOUS_MSG_ERR",
  ADDRESS => 0x00000000a0038810,
  NOTE    => "Error Detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00671_flds
);


##########################################################################
#                                                                        #
#   OC_PI_IO_WR_SPURIOUS_MSG_ERR                                         #
#                                                                        #
##########################################################################

%orbit_01_00672_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CL_ADDR"                      => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 0, 0x0000000000000000, "Spurious IO Write Response Cache Line Address" ],
   "CMD"                          => [   1,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Spurious IO Write Response Message Command" ],
   "SRC_NODE"                     => [   2,   2,  14, 0x000000000000FFFC, 0x00, 0, 0x0000000000000000, "Spurious IO Write Response Source Node" ],
   "ERR_OVRFLW"                   => [   3,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Spurious IO Write Response Error Overflow" ],
   "ERR_VAL"                      => [   4,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Spurious IO Write Response Error" ],
);

%orbit_01_00672_def =
( NAME    => "OC_PI_IO_WR_SPURIOUS_MSG_ERR",
  ADDRESS => 0x00000000a0038818,
  NOTE    => "Error Detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00672_flds
);


##########################################################################
#                                                                        #
#   OC_PI_IO_RD_TO_ERR                                                   #
#                                                                        #
##########################################################################

%orbit_01_00673_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CL_ADDR"                      => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 0, 0x0000000000000000, "IO Read Timeout Error Detail Cache Line Address; PA[47:7]" ],
   "DW_ADDR"                      => [   1,  19,   4, 0x0000000000780000, 0x00, 0, 0x0000000000000000, "IO Read Timeout Error Detail Cache Line Address; PA[6:3]" ],
   "ADDR_SPACE"                   => [   2,  17,   2, 0x0000000000060000, 0x00, 0, 0x0000000000000000, "IO Read Timeout Error Detail SysT Address Space Attribute" ],
   "RSVD0"                        => [   3,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_STATE"                    => [   4,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Error Detail Fifo Entry State" ],
   "RSVD1"                        => [   5,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_TYPE"                     => [   6,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "IO Read Timeout Error Detail Request Type" ],
   "PROC_NUM"                     => [   7,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "IO Read Timeout Error Detail Processor Number" ],
   "ERR_OVRFLW"                   => [   8,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "IO Read Timeout Error Overflow" ],
   "ERR_VAL"                      => [   9,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "IO Read Timeout Error Valid" ],
);

%orbit_01_00673_def =
( NAME    => "OC_PI_IO_RD_TO_ERR",
  ADDRESS => 0x00000000a0038820,
  NOTE    => "IO Read Timeout Error Detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00673_flds
);


##########################################################################
#                                                                        #
#   OC_PI_IO_WR_TO_ERR                                                   #
#                                                                        #
##########################################################################

%orbit_01_00674_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CL_ADDR"                      => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 0, 0x0000000000000000, "IO Read Timeout Error Detail Cache Line Address; PA[47:7]" ],
   "DW_ADDR"                      => [   1,  19,   4, 0x0000000000780000, 0x00, 0, 0x0000000000000000, "IO Read Timeout Error Detail Cache Line Address; PA[6:3]" ],
   "ADDR_SPACE"                   => [   2,  17,   2, 0x0000000000060000, 0x00, 0, 0x0000000000000000, "IO Read Timeout Error Detail SysT Address Space Attribute" ],
   "RSVD0"                        => [   3,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_STATE"                    => [   4,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Error Detail Fifo Entry State" ],
   "RSVD1"                        => [   5,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_TYPE"                     => [   6,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "IO Read Timeout Error Detail Request Type" ],
   "PROC_NUM"                     => [   7,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "IO Read Timeout Error Detail Processor Number" ],
   "ERR_OVRFLW"                   => [   8,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "IO Read Timeout Error Overflow" ],
   "ERR_VAL"                      => [   9,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "IO Read Timeout Error Valid" ],
);

%orbit_01_00674_def =
( NAME    => "OC_PI_IO_WR_TO_ERR",
  ADDRESS => 0x00000000a0038828,
  NOTE    => "IO Write Timeout Error Detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00674_flds
);


##########################################################################
#                                                                        #
#   OC_PI_IO_RD_CORR_DATA_ERR                                            #
#                                                                        #
##########################################################################

%orbit_01_00675_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CL_ADDR"                      => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 1, 0x0000000000000000, "Read Data Error Cache Line Address" ],
   "ADDR_SPACE"                   => [   1,  21,   2, 0x0000000000600000, 0x00, 1, 0x0000000000000000, "Address Space for IO Read Data Error" ],
   "LOCAL"                        => [   2,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "IO Read Local Data Error" ],
   "SYNDROME"                     => [   3,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "IO Read Data Error Syndrome" ],
   "PROC_NUM"                     => [   4,   2,   2, 0x000000000000000C, 0x00, 1, 0x0000000000000000, "Processor Number" ],
   "ERR_OVRFLW"                   => [   5,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Read Corr. Data Error Overflow" ],
   "ERR_VAL"                      => [   6,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Read Corr. Data Error Valid" ],
);

%orbit_01_00675_def =
( NAME    => "OC_PI_IO_RD_CORR_DATA_ERR",
  ADDRESS => 0x00000000a0038840,
  NOTE    => "The contents of this register are loaded with error detail data note when the first correctable read data error is detected. Thi",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00675_flds
);


##########################################################################
#                                                                        #
#   OC_PI_IO_RD_UNCORR_DATA_ERR                                          #
#                                                                        #
##########################################################################

%orbit_01_00676_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CL_ADDR"                      => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 1, 0x0000000000000000, "Read Data Error Cache Line Address" ],
   "ADDR_SPACE"                   => [   1,  21,   2, 0x0000000000600000, 0x00, 1, 0x0000000000000000, "Address Space for IO Read Data Error" ],
   "LOCAL"                        => [   2,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "IO Read Local Data Error" ],
   "SYNDROME"                     => [   3,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "IO Read Data Error Syndrome" ],
   "PROC_NUM"                     => [   4,   2,   2, 0x000000000000000C, 0x00, 1, 0x0000000000000000, "Processor Number" ],
   "ERR_OVRFLW"                   => [   5,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Read Uncorr. Data Error Overflow" ],
   "ERR_VAL"                      => [   6,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Read Uncorr. Data Error Valid" ],
);

%orbit_01_00676_def =
( NAME    => "OC_PI_IO_RD_UNCORR_DATA_ERR",
  ADDRESS => 0x00000000a0038848,
  NOTE    => "The contents of this register are loaded with error detail data note when the first uncorrectable read data error is detected. T",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00676_flds
);


##########################################################################
#                                                                        #
#   OC_PI_IO_WR_CORR_DATA_ERR                                            #
#                                                                        #
##########################################################################

%orbit_01_00677_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CL_ADDR"                      => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 1, 0x0000000000000000, "Write Data Error Cache Line Address" ],
   "ADDR_SPACE"                   => [   1,  21,   2, 0x0000000000600000, 0x00, 1, 0x0000000000000000, "Address Space for IO Write Data Error" ],
   "PARTIAL"                      => [   2,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "Parital Write Data Error" ],
   "PHASE1_SYNDROME"              => [   3,  12,   8, 0x00000000000FF000, 0x00, 1, 0x0000000000000000, "Phase1 Write Data Error Syndrome" ],
   "PHASE0_SYNDROME"              => [   4,   4,   8, 0x0000000000000FF0, 0x00, 1, 0x0000000000000000, "Phase0 Write Data Error Syndrome" ],
   "PROC_NUM"                     => [   5,   2,   2, 0x000000000000000C, 0x00, 1, 0x0000000000000000, "Processor Number" ],
   "ERR_OVRFLW"                   => [   6,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Write Corr. Data Error Overflow" ],
   "ERR_VAL"                      => [   7,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Write Corr. Data Error Valid" ],
);

%orbit_01_00677_def =
( NAME    => "OC_PI_IO_WR_CORR_DATA_ERR",
  ADDRESS => 0x00000000a0038850,
  NOTE    => "The contents of this register are loaded with error detail data note when the first correctable write data error is detected. Th",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00677_flds
);


##########################################################################
#                                                                        #
#   OC_PI_IO_WR_UNCORR_DATA_ERR                                          #
#                                                                        #
##########################################################################

%orbit_01_00678_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CL_ADDR"                      => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 1, 0x0000000000000000, "Write Data Error Cache Line Address" ],
   "ADDR_SPACE"                   => [   1,  21,   2, 0x0000000000600000, 0x00, 1, 0x0000000000000000, "Address Space for IO Write Data Error" ],
   "PARTIAL"                      => [   2,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "Parital Write Data Error" ],
   "PHASE1_SYNDROME"              => [   3,  12,   8, 0x00000000000FF000, 0x00, 1, 0x0000000000000000, "Phase1 Write Data Error Syndrome" ],
   "PHASE0_SYNDROME"              => [   4,   4,   8, 0x0000000000000FF0, 0x00, 1, 0x0000000000000000, "Phase0 Write Data Error Syndrome" ],
   "PROC_NUM"                     => [   5,   2,   2, 0x000000000000000C, 0x00, 1, 0x0000000000000000, "Processor Number" ],
   "ERR_OVRFLW"                   => [   6,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Write Uncorr. Data Error Overflow" ],
   "ERR_VAL"                      => [   7,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Write Uncorr. Data Error Valid" ],
);

%orbit_01_00678_def =
( NAME    => "OC_PI_IO_WR_UNCORR_DATA_ERR",
  ADDRESS => 0x00000000a0038858,
  NOTE    => "The contents of this register are loaded with error detail data note when the first uncorrectable write data error is detected. ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00678_flds
);


##########################################################################
#                                                                        #
#   OC_PI_IO_RD_PKT_LEN_ERR                                              #
#                                                                        #
##########################################################################

%orbit_01_00679_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CL_ADDR"                      => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 1, 0x0000000000000000, "IO Read Data Packet Length Error Cache Line Address" ],
   "ADDR_SPACE"                   => [   1,  21,   2, 0x0000000000600000, 0x00, 1, 0x0000000000000000, "Address Space for IO Read Data Packet Length Error" ],
   "LOCAL"                        => [   2,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "IO Read Local Data Packet Error" ],
   "OBESE"                        => [   3,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "IO Read Obese Data Packet Error" ],
   "RSVD0"                        => [   4,  13,   6, 0x000000000007E000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PROC_REQNUM"                  => [   5,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "Processor Request Number" ],
   "REQ_TYPE"                     => [   6,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "Read Request Type" ],
   "RSVD1"                        => [   7,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERR_OVRFLW"                   => [   8,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "IO Read Data Packet Length Error Detail Overflow" ],
   "ERR_VAL"                      => [   9,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "IO Read Data Packet Length Error Detail Valid" ],
);

%orbit_01_00679_def =
( NAME    => "OC_PI_IO_RD_PKT_LEN_ERR",
  ADDRESS => 0x00000000a0038860,
  NOTE    => "This register captures the error detail for the first processor PIO note read request that a Data Packet Length Error is detecte",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00679_flds
);


##########################################################################
#                                                                        #
#   OC_PI_IO_WR_PKT_LEN_ERR                                              #
#                                                                        #
##########################################################################

%orbit_01_00680_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CL_ADDR"                      => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 1, 0x0000000000000000, "IO Write Data Packet Length Error Cache Line Address" ],
   "ADDR_SPACE"                   => [   1,  21,   2, 0x0000000000600000, 0x00, 1, 0x0000000000000000, "Address Space for IO Write Data Packet Length Error" ],
   "LOCAL"                        => [   2,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "IO Write Local Data Packet Error" ],
   "OBESE"                        => [   3,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "IO Write Obese Data Packet Error" ],
   "RSVD0"                        => [   4,  13,   6, 0x000000000007E000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PROC_REQNUM"                  => [   5,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "Processor Request Number" ],
   "REQ_TYPE"                     => [   6,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "Write Request Type" ],
   "RSVD1"                        => [   7,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERR_OVRFLW"                   => [   8,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "IO Write Data Packet Length Error Detail Overflow" ],
   "ERR_VAL"                      => [   9,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "IO Write Data Packet Length Error Detail Valid" ],
);

%orbit_01_00680_def =
( NAME    => "OC_PI_IO_WR_PKT_LEN_ERR",
  ADDRESS => 0x00000000a0038868,
  NOTE    => "This register captures the error detail for the first processor PIO note write request that a Data Packet Length Error is detect",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00680_flds
);


##########################################################################
#                                                                        #
#   OC_PI_PIO_FIFO_ERR                                                   #
#                                                                        #
##########################################################################

%orbit_01_00681_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WR_PTR1"                      => [   1,  19,   5, 0x0000000000F80000, 0x00, 0, 0x0000000000000000, "Error Detail Read Pointer Pipe 1" ],
   "WR_PTR0"                      => [   2,  14,   5, 0x000000000007C000, 0x00, 0, 0x0000000000000000, "Error Detail Write Pointer Pipe 1" ],
   "RD_PTR1"                      => [   3,   9,   5, 0x0000000000003E00, 0x00, 0, 0x0000000000000000, "Error Detail Read Pointer Pipe 0" ],
   "RD_PTR0"                      => [   4,   4,   5, 0x00000000000001F0, 0x00, 0, 0x0000000000000000, "Error Detail Write Pointer Pipe 0" ],
   "OVFLW1"                       => [   5,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Error Detail Overflow Status Pipe 1" ],
   "OVFLW0"                       => [   6,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Error Detail Overflow Status Pipe 0" ],
   "ERR_OVRFLW"                   => [   7,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "PIO FIFO Error Overflow" ],
   "ERR_VAL"                      => [   8,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "PIO FIFO Error Valid" ],
);

%orbit_01_00681_def =
( NAME    => "OC_PI_PIO_FIFO_ERR",
  ADDRESS => 0x00000000a0038830,
  NOTE    => "PIO FIFO Error Detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00681_flds
);


##########################################################################
#                                                                        #
#   OC_PI_GFX_FIFO_ERR                                                   #
#                                                                        #
##########################################################################

%orbit_01_00682_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WR_PTR1"                      => [   1,  22,   6, 0x000000000FC00000, 0x00, 0, 0x0000000000000000, "Error Detail Read Pointer Pipe 1" ],
   "WR_PTR0"                      => [   2,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Error Detail Write Pointer Pipe 1" ],
   "RD_PTR1"                      => [   3,  10,   6, 0x000000000000FC00, 0x00, 0, 0x0000000000000000, "Error Detail Read Pointer Pipe 0" ],
   "RD_PTR0"                      => [   4,   4,   6, 0x00000000000003F0, 0x00, 0, 0x0000000000000000, "Error Detail Write Pointer Pipe 0" ],
   "OVFLW1"                       => [   5,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Error Detail Overflow Status Pipe 1" ],
   "OVFLW0"                       => [   6,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Error Detail Overflow Status Pipe 0" ],
   "ERR_OVRFLW"                   => [   7,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "GFX FIFO Error Overflow" ],
   "ERR_VAL"                      => [   8,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "GFX FIFO Error Valid" ],
);

%orbit_01_00682_def =
( NAME    => "OC_PI_GFX_FIFO_ERR",
  ADDRESS => 0x00000000a0038838,
  NOTE    => "Error Detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00682_flds
);


##########################################################################
#                                                                        #
#   OC_PI_NCRP_TEST_POINT_COMPARE                                        #
#                                                                        #
##########################################################################

%orbit_01_00683_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COMPARE_PATTERN"              => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 1, 0x0000000000000000, "debug bit pattern for trigger generation" ],
   "COMPARE_MASK"                 => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "Mask to select Debug bits for trigger generation" ],
);

%orbit_01_00683_def =
( NAME    => "OC_PI_NCRP_TEST_POINT_COMPARE",
  ADDRESS => 0x00000000a0031040,
  NOTE    => "PI NCRP Test Point Compare",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00683_flds
);


##########################################################################
#                                                                        #
#   OC_PI_NCRP_TEST_POINT_SELECT                                         #
#                                                                        #
##########################################################################

%orbit_01_00684_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TRIGGER_ENABLE"               => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Enable trigger on bit 32 of Analyzer data" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 1, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD0"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_CHIPLET_SEL"          => [   3,  56,   3, 0x0700000000000000, 0x00, 1, 0x0000000000000000, "Nibble 7 Chiplet select" ],
   "RSVD1"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 1, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD2"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_CHIPLET_SEL"          => [   7,  48,   3, 0x0007000000000000, 0x00, 1, 0x0000000000000000, "Nibble 6 Chiplet select" ],
   "RSVD3"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 1, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD4"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_CHIPLET_SEL"          => [  11,  40,   3, 0x0000070000000000, 0x00, 1, 0x0000000000000000, "Nibble 5 Chiplet select" ],
   "RSVD5"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD6"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_CHIPLET_SEL"          => [  15,  32,   3, 0x0000000700000000, 0x00, 1, 0x0000000000000000, "Nibble 4 Chiplet select" ],
   "RSVD7"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 1, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD8"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_CHIPLET_SEL"          => [  19,  24,   3, 0x0000000007000000, 0x00, 1, 0x0000000000000000, "Nibble 3 Chiplet select" ],
   "RSVD9"                        => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 1, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD10"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_CHIPLET_SEL"          => [  23,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "Nibble 2 Chiplet select" ],
   "RSVD11"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 1, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD12"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_CHIPLET_SEL"          => [  27,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "Nibble 1 Chiplet select" ],
   "RSVD13"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 1, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD14"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_CHIPLET_SEL"          => [  31,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Nibble 0 Chiplet select" ],
);

%orbit_01_00684_def =
( NAME    => "OC_PI_NCRP_TEST_POINT_SELECT",
  ADDRESS => 0x00000000a0031048,
  NOTE    => "PI NCRP Test Point Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00684_flds
);


##########################################################################
#                                                                        #
#   OC_PI_NCRP_TEST_POINT_TRIGGER_SELECT                                     #
#                                                                        #
##########################################################################

%orbit_01_00685_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_NIBBLE_SEL"          => [   1,  60,   3, 0x7000000000000000, 0x00, 1, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_CHIPLET_SEL"         => [   3,  56,   3, 0x0700000000000000, 0x00, 1, 0x0000000000000000, "Nibble 7 Chiplet select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_NIBBLE_SEL"          => [   5,  52,   3, 0x0070000000000000, 0x00, 1, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_CHIPLET_SEL"         => [   7,  48,   3, 0x0007000000000000, 0x00, 1, 0x0000000000000000, "Nibble 6 Chiplet select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_NIBBLE_SEL"          => [   9,  44,   3, 0x0000700000000000, 0x00, 1, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_CHIPLET_SEL"         => [  11,  40,   3, 0x0000070000000000, 0x00, 1, 0x0000000000000000, "Nibble 5 Chiplet select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_NIBBLE_SEL"          => [  13,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_CHIPLET_SEL"         => [  15,  32,   3, 0x0000000700000000, 0x00, 1, 0x0000000000000000, "Nibble 4 Chiplet select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_NIBBLE_SEL"          => [  17,  28,   3, 0x0000000070000000, 0x00, 1, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_CHIPLET_SEL"         => [  19,  24,   3, 0x0000000007000000, 0x00, 1, 0x0000000000000000, "Nibble 3 Chiplet select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_NIBBLE_SEL"          => [  21,  20,   3, 0x0000000000700000, 0x00, 1, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_CHIPLET_SEL"         => [  23,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "Nibble 2 Chiplet select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_NIBBLE_SEL"          => [  25,  12,   3, 0x0000000000007000, 0x00, 1, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_CHIPLET_SEL"         => [  27,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "Nibble 1 Chiplet select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_NIBBLE_SEL"          => [  29,   4,   3, 0x0000000000000070, 0x00, 1, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_CHIPLET_SEL"         => [  31,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Nibble 0 Chiplet select" ],
);

%orbit_01_00685_def =
( NAME    => "OC_PI_NCRP_TEST_POINT_TRIGGER_SELECT",
  ADDRESS => 0x00000000a0031050,
  NOTE    => "PI NCRP Test Point Trigger Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00685_flds
);


##########################################################################
#                                                                        #
#   OC_NI0_LLP_STAT                                                      #
#                                                                        #
##########################################################################

%orbit_01_00686_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   4,  60, 0xFFFFFFFFFFFFFFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LINK_RESET_STATE"             => [   1,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Status of LLP link." ],
);

%orbit_01_00686_def =
( NAME    => "OC_NI0_LLP_STAT",
  ADDRESS => 0x00000000d0000000,
  NOTE    => "This register describes the LLP status.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00686_flds
);


##########################################################################
#                                                                        #
#   OC_NI0_LLP_RESET                                                     #
#                                                                        #
##########################################################################

%orbit_01_00687_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   2,  62, 0xFFFFFFFFFFFFFFFC, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WARM"                         => [   1,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Send Warm Reset. Generates a pulse." ],
   "LINK"                         => [   2,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Send Link Reset. Generates a pulse." ],
);

%orbit_01_00687_def =
( NAME    => "OC_NI0_LLP_RESET",
  ADDRESS => 0x00000000d0000008,
  NOTE    => "Writing issues a reset to the network interface",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00687_flds
);


##########################################################################
#                                                                        #
#   OC_NI0_LLP_RESET_EN                                                  #
#                                                                        #
##########################################################################

%orbit_01_00688_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OK"                           => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Allow LLP warm reset to reset SHUB" ],
);

%orbit_01_00688_def =
( NAME    => "OC_NI0_LLP_RESET_EN",
  ADDRESS => 0x00000000d0000010,
  NOTE    => "Controls LLP warm reset propagation",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00688_flds
);


##########################################################################
#                                                                        #
#   OC_NI0_LLP_CHAN_MODE                                                 #
#                                                                        #
##########################################################################

%orbit_01_00689_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_CLKQUAD"               => [   1,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Reserved for future use. Terminated at dest." ],
   "ENABLE_RMT_FT_UPD"            => [   2,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Enables remote fine tune updates" ],
   "ENABLE_TUNING"                => [   3,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Enables automatic tuning of channel skew." ],
   "AC_ENCODE"                    => [   4,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Enables nearly dc-free encoding for AC-coupling" ],
   "BITMODE32"                    => [   5,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Enables 32-bit (plus sideband) channel phits" ],
);

%orbit_01_00689_def =
( NAME    => "OC_NI0_LLP_CHAN_MODE",
  ADDRESS => 0x00000000d0000018,
  NOTE    => "Sets the signaling mode of LLP and channel",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00689_flds
);


##########################################################################
#                                                                        #
#   OC_NI0_LLP_CONFIG                                                    #
#                                                                        #
##########################################################################

%orbit_01_00690_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FTU_TIME"                     => [   1,  26,  12, 0x0000003FFC000000, 0x00, 1, 0x0000000000000000, "" ],
   "NULLTIMEOUT"                  => [   2,  20,   6, 0x0000000003F00000, 0x00, 1, 0x0000000000000000, "" ],
   "MAXRETRY"                     => [   3,  10,  10, 0x00000000000FFC00, 0x00, 1, 0x0000000000000000, "" ],
   "MAXBURST"                     => [   4,   0,  10, 0x00000000000003FF, 0x00, 1, 0x0000000000000000, "" ],
);

%orbit_01_00690_def =
( NAME    => "OC_NI0_LLP_CONFIG",
  ADDRESS => 0x00000000d0000020,
  NOTE    => "Sets the configuration of LLP and channel",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00690_flds
);


##########################################################################
#                                                                        #
#   OC_NI0_LLP_TEST_CTL                                                  #
#                                                                        #
##########################################################################

%orbit_01_00691_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CBERROR"                      => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Indicates a Micropacket with a CB error was captured" ],
   "CAPTURED"                     => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "Indicates a Valid Micropacket was captured" ],
   "FAKESNERROR"                  => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "Causes receiver to pretend it saw a sn error" ],
   "SENDSNERROR"                  => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Sends a single sequence number error" ],
   "SENDCBERROR"                  => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "Sends a single error" ],
   "CAPTURECBONLY"                => [   6,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "Only capture a micropacket with a Check Byte error" ],
   "ARMCAPTURE"                   => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "Enable Capture of Next MicroPacket" ],
   "NOISE_MODE"                   => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "LFSR_MODE"                    => [   9,  52,   2, 0x0030000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [  10,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WIRE_SEL"                     => [  11,  44,   6, 0x0003F00000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD2"                        => [  12,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_TEST_MODE"               => [  13,  40,   2, 0x0000030000000000, 0x00, 1, 0x0000000000000000, "Enables continuous send of data" ],
   "PATTERN"                      => [  14,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Send channel data pattern" ],
);

%orbit_01_00691_def =
( NAME    => "OC_NI0_LLP_TEST_CTL",
  ADDRESS => 0x00000000d0000028,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00691_flds
);


##########################################################################
#                                                                        #
#   OC_NI0_LLP_CAPT_WD1                                                  #
#                                                                        #
##########################################################################

%orbit_01_00692_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "low order 64-bit captured word" ],
);

%orbit_01_00692_def =
( NAME    => "OC_NI0_LLP_CAPT_WD1",
  ADDRESS => 0x00000000d0000030,
  NOTE    => "low order 64-bit captured word",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00692_flds
);


##########################################################################
#                                                                        #
#   OC_NI0_LLP_CAPT_WD2                                                  #
#                                                                        #
##########################################################################

%orbit_01_00693_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "high order 64-bit captured word" ],
);

%orbit_01_00693_def =
( NAME    => "OC_NI0_LLP_CAPT_WD2",
  ADDRESS => 0x00000000d0000038,
  NOTE    => "high order 64-bit captured word",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00693_flds
);


##########################################################################
#                                                                        #
#   OC_NI0_LLP_CAPT_SBCB                                                 #
#                                                                        #
##########################################################################

%orbit_01_00694_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  37,  27, 0xFFFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CHARGEUNDERFLOW"              => [   1,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "wire charge counter underflowed, valid if llp_mode enabled" ],
   "CHARGEOVERFLOW"               => [   2,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "wire charge counter overflowed, valid if llp_mode enabled" ],
   "FAKEDALLSNERRORS"             => [   3,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "All faked SN errors have been sent" ],
   "SENTALLSNERRORS"              => [   4,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "All SN errors have been sent" ],
   "SENTALLCBERRORS"              => [   5,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "All CB errors have been sent" ],
   "CAPTUREDRCVCRC"               => [   6,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "CRC" ],
   "CAPTUREDRCVSBSN"              => [   7,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "sideband and sequence" ],
);

%orbit_01_00694_def =
( NAME    => "OC_NI0_LLP_CAPT_SBCB",
  ADDRESS => 0x00000000d0000040,
  NOTE    => "This register contains the sideband, sequence number, and CRC of note the flit that was captured. See LLP_CAPT_WD1 for descripti",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00694_flds
);


##########################################################################
#                                                                        #
#   OC_NI0_LLP_ERR                                                       #
#                                                                        #
##########################################################################

%orbit_01_00695_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WIRE_OVERFLOW"                => [   1,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "wire_error_cnt has overflowed" ],
   "WIRE_CNT"                     => [   2,  36,  24, 0x0FFFFFF000000000, 0x00, 0, 0x0000000000000000, "counts the errors detected on a single wire test" ],
   "POWER_NOT_OK"                 => [   3,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Detects and traps a loss of power_OK" ],
   "SQUASH"                       => [   4,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "Indicates a micropacket was squashed" ],
   "RCV_LINK_RESET"               => [   5,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "Indicates a link reset has been received" ],
   "RETRY_TIMEOUT"                => [   6,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Indicates a retry timeout has occured" ],
   "RETRY_COUNT"                  => [   7,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "Counts the retries" ],
   "RX_CB_ERR_COUNT"              => [   8,   8,  16, 0x0000000000FFFF00, 0x00, 0, 0x0000000000000000, "Counts the check byte errors received" ],
   "RX_SN_ERR_COUNT"              => [   9,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Counts the sequence number errors received" ],
);

%orbit_01_00695_def =
( NAME    => "OC_NI0_LLP_ERR",
  ADDRESS => 0x00000000d0000048,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00695_flds
);


##########################################################################
#                                                                        #
#   OC_NI1_LLP_STAT                                                      #
#                                                                        #
##########################################################################

%orbit_01_00696_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   4,  60, 0xFFFFFFFFFFFFFFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LINK_RESET_STATE"             => [   1,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Status of LLP link." ],
);

%orbit_01_00696_def =
( NAME    => "OC_NI1_LLP_STAT",
  ADDRESS => 0x00000000d0002000,
  NOTE    => "This register describes the LLP status.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00696_flds
);


##########################################################################
#                                                                        #
#   OC_NI1_LLP_RESET                                                     #
#                                                                        #
##########################################################################

%orbit_01_00697_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   2,  62, 0xFFFFFFFFFFFFFFFC, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WARM"                         => [   1,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Send Warm Reset. Generates a pulse." ],
   "LINK"                         => [   2,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Send Link Reset. Generates a pulse." ],
);

%orbit_01_00697_def =
( NAME    => "OC_NI1_LLP_RESET",
  ADDRESS => 0x00000000d0002008,
  NOTE    => "Writing issues a reset to the network interface",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00697_flds
);


##########################################################################
#                                                                        #
#   OC_NI1_LLP_RESET_EN                                                  #
#                                                                        #
##########################################################################

%orbit_01_00698_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OK"                           => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Allow LLP warm reset to reset SHUB" ],
);

%orbit_01_00698_def =
( NAME    => "OC_NI1_LLP_RESET_EN",
  ADDRESS => 0x00000000d0002010,
  NOTE    => "Controls LLP warm reset propagation",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00698_flds
);


##########################################################################
#                                                                        #
#   OC_NI1_LLP_CHAN_MODE                                                 #
#                                                                        #
##########################################################################

%orbit_01_00699_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_CLKQUAD"               => [   1,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Reserved for future use. Terminated at dest." ],
   "ENABLE_RMT_FT_UPD"            => [   2,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Enables remote fine tune updates" ],
   "ENABLE_TUNING"                => [   3,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Enables automatic tuning of channel skew." ],
   "AC_ENCODE"                    => [   4,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Enables nearly dc-free encoding for AC-coupling" ],
   "BITMODE32"                    => [   5,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Enables 32-bit (plus sideband) channel phits" ],
);

%orbit_01_00699_def =
( NAME    => "OC_NI1_LLP_CHAN_MODE",
  ADDRESS => 0x00000000d0002018,
  NOTE    => "Sets the signaling mode of LLP and channel",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00699_flds
);


##########################################################################
#                                                                        #
#   OC_NI1_LLP_CONFIG                                                    #
#                                                                        #
##########################################################################

%orbit_01_00700_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FTU_TIME"                     => [   1,  26,  12, 0x0000003FFC000000, 0x00, 1, 0x0000000000000000, "" ],
   "NULLTIMEOUT"                  => [   2,  20,   6, 0x0000000003F00000, 0x00, 1, 0x0000000000000000, "" ],
   "MAXRETRY"                     => [   3,  10,  10, 0x00000000000FFC00, 0x00, 1, 0x0000000000000000, "" ],
   "MAXBURST"                     => [   4,   0,  10, 0x00000000000003FF, 0x00, 1, 0x0000000000000000, "" ],
);

%orbit_01_00700_def =
( NAME    => "OC_NI1_LLP_CONFIG",
  ADDRESS => 0x00000000d0002020,
  NOTE    => "Sets the configuration of LLP and channel",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00700_flds
);


##########################################################################
#                                                                        #
#   OC_NI1_LLP_TEST_CTL                                                  #
#                                                                        #
##########################################################################

%orbit_01_00701_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CBERROR"                      => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Indicates a Micropacket with a CB error was captured" ],
   "CAPTURED"                     => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "Indicates a Valid Micropacket was captured" ],
   "FAKESNERROR"                  => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "Causes receiver to pretend it saw a sn error" ],
   "SENDSNERROR"                  => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Sends a single sequence number error" ],
   "SENDCBERROR"                  => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "Sends a single error" ],
   "CAPTURECBONLY"                => [   6,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "Only capture a micropacket with a Check Byte error" ],
   "ARMCAPTURE"                   => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "Enable Capture of Next MicroPacket" ],
   "NOISE_MODE"                   => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "LFSR_MODE"                    => [   9,  52,   2, 0x0030000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [  10,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WIRE_SEL"                     => [  11,  44,   6, 0x0003F00000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD2"                        => [  12,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_TEST_MODE"               => [  13,  40,   2, 0x0000030000000000, 0x00, 1, 0x0000000000000000, "Enables continuous send of data" ],
   "PATTERN"                      => [  14,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Send channel data pattern" ],
);

%orbit_01_00701_def =
( NAME    => "OC_NI1_LLP_TEST_CTL",
  ADDRESS => 0x00000000d0002028,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00701_flds
);


##########################################################################
#                                                                        #
#   OC_NI1_LLP_CAPT_WD1                                                  #
#                                                                        #
##########################################################################

%orbit_01_00702_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "low order 64-bit captured word" ],
);

%orbit_01_00702_def =
( NAME    => "OC_NI1_LLP_CAPT_WD1",
  ADDRESS => 0x00000000d0002030,
  NOTE    => "low order 64-bit captured word",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00702_flds
);


##########################################################################
#                                                                        #
#   OC_NI1_LLP_CAPT_WD2                                                  #
#                                                                        #
##########################################################################

%orbit_01_00703_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "high order 64-bit captured word" ],
);

%orbit_01_00703_def =
( NAME    => "OC_NI1_LLP_CAPT_WD2",
  ADDRESS => 0x00000000d0002038,
  NOTE    => "high order 64-bit captured word",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00703_flds
);


##########################################################################
#                                                                        #
#   OC_NI1_LLP_CAPT_SBCB                                                 #
#                                                                        #
##########################################################################

%orbit_01_00704_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  37,  27, 0xFFFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CHARGEUNDERFLOW"              => [   1,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "wire charge counter underflowed, valid if llp_mode enabled" ],
   "CHARGEOVERFLOW"               => [   2,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "wire charge counter overflowed, valid if llp_mode enabled" ],
   "FAKEDALLSNERRORS"             => [   3,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "All faked SN errors have been sent" ],
   "SENTALLSNERRORS"              => [   4,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "All SN errors have been sent" ],
   "SENTALLCBERRORS"              => [   5,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "All CB errors have been sent" ],
   "CAPTUREDRCVCRC"               => [   6,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "CRC" ],
   "CAPTUREDRCVSBSN"              => [   7,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "sideband and sequence" ],
);

%orbit_01_00704_def =
( NAME    => "OC_NI1_LLP_CAPT_SBCB",
  ADDRESS => 0x00000000d0002040,
  NOTE    => "This register contains the sideband, sequence number, and CRC of note the flit that was captured. See LLP_CAPT_WD1 for descripti",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00704_flds
);


##########################################################################
#                                                                        #
#   OC_NI1_LLP_ERR                                                       #
#                                                                        #
##########################################################################

%orbit_01_00705_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WIRE_OVERFLOW"                => [   1,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "wire_error_cnt has overflowed" ],
   "WIRE_CNT"                     => [   2,  36,  24, 0x0FFFFFF000000000, 0x00, 0, 0x0000000000000000, "counts the errors detected on a single wire test" ],
   "POWER_NOT_OK"                 => [   3,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Detects and traps a loss of power_OK" ],
   "SQUASH"                       => [   4,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "Indicates a micropacket was squashed" ],
   "RCV_LINK_RESET"               => [   5,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "Indicates a link reset has been received" ],
   "RETRY_TIMEOUT"                => [   6,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Indicates a retry timeout has occured" ],
   "RETRY_COUNT"                  => [   7,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "Counts the retries" ],
   "RX_CB_ERR_COUNT"              => [   8,   8,  16, 0x0000000000FFFF00, 0x00, 0, 0x0000000000000000, "Counts the check byte errors received" ],
   "RX_SN_ERR_COUNT"              => [   9,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Counts the sequence number errors received" ],
);

%orbit_01_00705_def =
( NAME    => "OC_NI1_LLP_ERR",
  ADDRESS => 0x00000000d0002048,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00705_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI0_LLP_DEBIT_FLOW                                              #
#                                                                        #
##########################################################################

%orbit_01_00706_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_CAP"                => [   1,  56,   5, 0x1F00000000000000, 0x00, 0, 0x0000000000000000, "vc3 debit captured value" ],
   "RSVD1"                        => [   2,  53,   3, 0x00E0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_DYN"                => [   3,  48,   5, 0x001F000000000000, 0x00, 0, 0x0000000000000000, "vc3 debit dynamic value" ],
   "RSVD2"                        => [   4,  45,   3, 0x0000E00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_CAP"                => [   5,  40,   5, 0x00001F0000000000, 0x00, 0, 0x0000000000000000, "vc2 debit captured value" ],
   "RSVD3"                        => [   6,  37,   3, 0x000000E000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_DYN"                => [   7,  32,   5, 0x0000001F00000000, 0x00, 0, 0x0000000000000000, "vc2 debit dynamic value" ],
   "RSVD4"                        => [   8,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_CAP"                => [   9,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "vc1 debit captured value" ],
   "RSVD5"                        => [  10,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_DYN"                => [  11,  16,   5, 0x00000000001F0000, 0x00, 0, 0x0000000000000000, "vc1 debit dynamic value" ],
   "RSVD6"                        => [  12,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_CAP"                => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "vc0 debit captured value" ],
   "RSVD7"                        => [  14,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_DYN"                => [  15,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "vc0 debit dynamic value" ],
);

%orbit_01_00706_def =
( NAME    => "OC_XNNI0_LLP_DEBIT_FLOW",
  ADDRESS => 0x00000000d0001030,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00706_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI0_LINK_0_FLOW                                                 #
#                                                                        #
##########################################################################

%orbit_01_00707_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   1,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Captured vc0 credit" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   3,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Dynamic vc0 credit value" ],
   "RSVD2"                        => [   4,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_TEST"              => [   5,   8,   7, 0x0000000000007F00, 0x00, 1, 0x0000000000000000, "vc0 Limit Test" ],
   "DEBIT_VC0_FORCE_CRED"         => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on vc0 from debit cntr" ],
   "RSVD3"                        => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [   8,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc0 withhold" ],
);

%orbit_01_00707_def =
( NAME    => "OC_XNNI0_LINK_0_FLOW",
  ADDRESS => 0x00000000d0001040,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00707_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI0_LINK_1_FLOW                                                 #
#                                                                        #
##########################################################################

%orbit_01_00708_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_CAP"               => [   1,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Captured vc1 credit" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_DYN"               => [   3,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Dynamic vc1 credit value" ],
   "RSVD2"                        => [   4,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_TEST"              => [   5,   8,   7, 0x0000000000007F00, 0x00, 1, 0x0000000000000000, "vc1 Limit Test" ],
   "DEBIT_VC1_FORCE_CRED"         => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on vc1 from debit cntr" ],
   "RSVD3"                        => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_WITHHOLD"           => [   8,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc1 withhold" ],
);

%orbit_01_00708_def =
( NAME    => "OC_XNNI0_LINK_1_FLOW",
  ADDRESS => 0x00000000d0001050,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00708_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI0_LINK_2_FLOW                                                 #
#                                                                        #
##########################################################################

%orbit_01_00709_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Captured vc2 credit" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Dynamic vc2 credit value" ],
   "RSVD2"                        => [   4,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_TEST"              => [   5,   8,   7, 0x0000000000007F00, 0x00, 1, 0x0000000000000000, "vc2 Limit Test" ],
   "DEBIT_VC2_FORCE_CRED"         => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on vc2 from debit cntr" ],
   "RSVD3"                        => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [   8,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc2 withhold" ],
);

%orbit_01_00709_def =
( NAME    => "OC_XNNI0_LINK_2_FLOW",
  ADDRESS => 0x00000000d0001060,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00709_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI0_LINK_3_FLOW                                                 #
#                                                                        #
##########################################################################

%orbit_01_00710_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_CAP"               => [   1,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Captured vc3 credit" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_DYN"               => [   3,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Dynamic vc3 credit value" ],
   "RSVD2"                        => [   4,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_TEST"              => [   5,   8,   7, 0x0000000000007F00, 0x00, 1, 0x0000000000000000, "vc3 Limit Test" ],
   "DEBIT_VC3_FORCE_CRED"         => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on vc3 from debit cntr" ],
   "RSVD3"                        => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_WITHHOLD"           => [   8,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc3 withhold" ],
);

%orbit_01_00710_def =
( NAME    => "OC_XNNI0_LINK_3_FLOW",
  ADDRESS => 0x00000000d0001070,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00710_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI1_LLP_DEBIT_FLOW                                              #
#                                                                        #
##########################################################################

%orbit_01_00711_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_CAP"                => [   1,  56,   5, 0x1F00000000000000, 0x00, 0, 0x0000000000000000, "vc3 debit captured value" ],
   "RSVD1"                        => [   2,  53,   3, 0x00E0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_DYN"                => [   3,  48,   5, 0x001F000000000000, 0x00, 0, 0x0000000000000000, "vc3 debit dynamic value" ],
   "RSVD2"                        => [   4,  45,   3, 0x0000E00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_CAP"                => [   5,  40,   5, 0x00001F0000000000, 0x00, 0, 0x0000000000000000, "vc2 debit captured value" ],
   "RSVD3"                        => [   6,  37,   3, 0x000000E000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_DYN"                => [   7,  32,   5, 0x0000001F00000000, 0x00, 0, 0x0000000000000000, "vc2 debit dynamic value" ],
   "RSVD4"                        => [   8,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_CAP"                => [   9,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "vc1 debit captured value" ],
   "RSVD5"                        => [  10,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_DYN"                => [  11,  16,   5, 0x00000000001F0000, 0x00, 0, 0x0000000000000000, "vc1 debit dynamic value" ],
   "RSVD6"                        => [  12,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_CAP"                => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "vc0 debit captured value" ],
   "RSVD7"                        => [  14,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_DYN"                => [  15,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "vc0 debit dynamic value" ],
);

%orbit_01_00711_def =
( NAME    => "OC_XNNI1_LLP_DEBIT_FLOW",
  ADDRESS => 0x00000000d0003030,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00711_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI1_LINK_0_FLOW                                                 #
#                                                                        #
##########################################################################

%orbit_01_00712_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   1,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Captured vc0 credit" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   3,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Dynamic vc0 credit value" ],
   "RSVD2"                        => [   4,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_TEST"              => [   5,   8,   7, 0x0000000000007F00, 0x00, 1, 0x0000000000000000, "vc0 Limit Test" ],
   "DEBIT_VC0_FORCE_CRED"         => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on vc0 from debit cntr" ],
   "RSVD3"                        => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [   8,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc0 withhold" ],
);

%orbit_01_00712_def =
( NAME    => "OC_XNNI1_LINK_0_FLOW",
  ADDRESS => 0x00000000d0003040,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00712_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI1_LINK_1_FLOW                                                 #
#                                                                        #
##########################################################################

%orbit_01_00713_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_CAP"               => [   1,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Captured vc1 credit" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_DYN"               => [   3,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Dynamic vc1 credit value" ],
   "RSVD2"                        => [   4,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_TEST"              => [   5,   8,   7, 0x0000000000007F00, 0x00, 1, 0x0000000000000000, "vc1 Limit Test" ],
   "DEBIT_VC1_FORCE_CRED"         => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on vc1 from debit cntr" ],
   "RSVD3"                        => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_WITHHOLD"           => [   8,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc1 withhold" ],
);

%orbit_01_00713_def =
( NAME    => "OC_XNNI1_LINK_1_FLOW",
  ADDRESS => 0x00000000d0003050,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00713_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI1_LINK_2_FLOW                                                 #
#                                                                        #
##########################################################################

%orbit_01_00714_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Captured vc2 credit" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Dynamic vc2 credit value" ],
   "RSVD2"                        => [   4,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_TEST"              => [   5,   8,   7, 0x0000000000007F00, 0x00, 1, 0x0000000000000000, "vc2 Limit Test" ],
   "DEBIT_VC2_FORCE_CRED"         => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on vc2 from debit cntr" ],
   "RSVD3"                        => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [   8,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc2 withhold" ],
);

%orbit_01_00714_def =
( NAME    => "OC_XNNI1_LINK_2_FLOW",
  ADDRESS => 0x00000000d0003060,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00714_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI1_LINK_3_FLOW                                                 #
#                                                                        #
##########################################################################

%orbit_01_00715_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_CAP"               => [   1,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Captured vc3 credit" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_DYN"               => [   3,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Dynamic vc3 credit value" ],
   "RSVD2"                        => [   4,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_TEST"              => [   5,   8,   7, 0x0000000000007F00, 0x00, 1, 0x0000000000000000, "vc3 Limit Test" ],
   "DEBIT_VC3_FORCE_CRED"         => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on vc3 from debit cntr" ],
   "RSVD3"                        => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_WITHHOLD"           => [   8,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc3 withhold" ],
);

%orbit_01_00715_def =
( NAME    => "OC_XNNI1_LINK_3_FLOW",
  ADDRESS => 0x00000000d0003070,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00715_flds
);


##########################################################################
#                                                                        #
#   OC_IILB_LOCAL_TABLE                                                  #
#                                                                        #
##########################################################################

%orbit_01_00716_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Indicates that this entry is valid" ],
   "RSVD0"                        => [   1,   6,  57, 0x7FFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL0"                      => [   2,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "ni select" ],
   "V0"                           => [   3,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   4,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
);

%orbit_01_00716_def =
( NAME    => "OC_IILB_LOCAL_TABLE",
  ADDRESS => 0x00000000d0020000,
  NOTE    => "This table provides the direction and vch for the outgoing header, note in the event that the global bits (upper bits) of the in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00716_flds
);


##########################################################################
#                                                                        #
#   OC_IILB_GLOBAL_TABLE                                                 #
#                                                                        #
##########################################################################

%orbit_01_00717_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Indicates that this entry is valid" ],
   "RSVD0"                        => [   1,   6,  57, 0x7FFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL0"                      => [   2,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "ni select" ],
   "V0"                           => [   3,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   4,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
);

%orbit_01_00717_def =
( NAME    => "OC_IILB_GLOBAL_TABLE",
  ADDRESS => 0x00000000d0020800,
  NOTE    => "This table provides the direction and vch for the outgoing header, note in the event that the global bits (upper bits) of the in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00717_flds
);


##########################################################################
#                                                                        #
#   OC_IILB_OVER_RIDE_TABLE                                              #
#                                                                        #
##########################################################################

%orbit_01_00718_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Indicates that this entry is enabled" ],
   "RSVD0"                        => [   1,   6,  57, 0x7FFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL0"                      => [   2,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "ni select" ],
   "V0"                           => [   3,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   4,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Direction field for next chip" ],
);

%orbit_01_00718_def =
( NAME    => "OC_IILB_OVER_RIDE_TABLE",
  ADDRESS => 0x00000000d0021000,
  NOTE    => "If enabled, bypass the Global/Local tables",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00718_flds
);


##########################################################################
#                                                                        #
#   OC_PI_LOCAL_TABLE                                                    #
#                                                                        #
##########################################################################

%orbit_01_00719_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Indicates that this entry is valid" ],
   "RSVD0"                        => [   1,  14,  49, 0x7FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL1"                      => [   2,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "ni select" ],
   "V1"                           => [   3,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR1"                         => [   4,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
   "RSVD1"                        => [   5,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL0"                      => [   6,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "ni select" ],
   "V0"                           => [   7,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   8,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
);

%orbit_01_00719_def =
( NAME    => "OC_PI_LOCAL_TABLE",
  ADDRESS => 0x00000000d0022000,
  NOTE    => "This table provides the direction and vch for the outgoing header, note in the event that the global bits (upper bits) of the in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00719_flds
);


##########################################################################
#                                                                        #
#   OC_PI_GLOBAL_TABLE                                                   #
#                                                                        #
##########################################################################

%orbit_01_00720_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Indicates that this entry is valid" ],
   "RSVD0"                        => [   1,  14,  49, 0x7FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL1"                      => [   2,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "ni select" ],
   "V1"                           => [   3,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR1"                         => [   4,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
   "RSVD1"                        => [   5,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL0"                      => [   6,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "ni select" ],
   "V0"                           => [   7,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   8,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
);

%orbit_01_00720_def =
( NAME    => "OC_PI_GLOBAL_TABLE",
  ADDRESS => 0x00000000d0022800,
  NOTE    => "This table provides the direction and vch for the outgoing header, note in the event that the global bits (upper bits) of the in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00720_flds
);


##########################################################################
#                                                                        #
#   OC_PI_OVER_RIDE_TABLE                                                #
#                                                                        #
##########################################################################

%orbit_01_00721_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Indicates that this entry is enabled" ],
   "RSVD0"                        => [   1,  14,  49, 0x7FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL1"                      => [   2,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "ni select" ],
   "V1"                           => [   3,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR1"                         => [   4,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "Direction field for next chip" ],
   "RSVD1"                        => [   5,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL0"                      => [   6,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "ni select" ],
   "V0"                           => [   7,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   8,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Direction field for next chip" ],
);

%orbit_01_00721_def =
( NAME    => "OC_PI_OVER_RIDE_TABLE",
  ADDRESS => 0x00000000d0023000,
  NOTE    => "If enabled, bypass the Global/Local tables",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00721_flds
);


##########################################################################
#                                                                        #
#   OC_PI_RSP_PLANE_HINT                                                 #
#                                                                        #
##########################################################################

%orbit_01_00722_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INVERT"                       => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Invert Response Plane Hint" ],
);

%orbit_01_00722_def =
( NAME    => "OC_PI_RSP_PLANE_HINT",
  ADDRESS => 0x00000000d0023008,
  NOTE    => "If enabled, invert incoming response only plane hint bit before note lookup",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00722_flds
);


##########################################################################
#                                                                        #
#   OC_NI0_LOCAL_TABLE                                                   #
#                                                                        #
##########################################################################

%orbit_01_00723_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Indicates that this entry is valid" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "V0"                           => [   2,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   3,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
);

%orbit_01_00723_def =
( NAME    => "OC_NI0_LOCAL_TABLE",
  ADDRESS => 0x00000000d0024000,
  NOTE    => "This table provides the direction and vch for the outgoing header, note in the event that the global bits (upper bits) of the in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00723_flds
);


##########################################################################
#                                                                        #
#   OC_NI0_GLOBAL_TABLE                                                  #
#                                                                        #
##########################################################################

%orbit_01_00724_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Indicates that this entry is valid" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "V0"                           => [   2,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   3,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
);

%orbit_01_00724_def =
( NAME    => "OC_NI0_GLOBAL_TABLE",
  ADDRESS => 0x00000000d0024800,
  NOTE    => "This table provides the direction and vch for the outgoing header, note in the event that the global bits (upper bits) of the in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00724_flds
);


##########################################################################
#                                                                        #
#   OC_NI0_OVER_RIDE_TABLE                                               #
#                                                                        #
##########################################################################

%orbit_01_00725_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Indicates that this entry is enabled" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "V0"                           => [   2,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   3,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Direction field for next chip" ],
);

%orbit_01_00725_def =
( NAME    => "OC_NI0_OVER_RIDE_TABLE",
  ADDRESS => 0x00000000d0025000,
  NOTE    => "If enabled, bypass the Global/Local tables",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00725_flds
);


##########################################################################
#                                                                        #
#   OC_NI1_LOCAL_TABLE                                                   #
#                                                                        #
##########################################################################

%orbit_01_00726_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Indicates that this entry is valid" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "V0"                           => [   2,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   3,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
);

%orbit_01_00726_def =
( NAME    => "OC_NI1_LOCAL_TABLE",
  ADDRESS => 0x00000000d0026000,
  NOTE    => "This table provides the direction and vch for the outgoing header, note in the event that the global bits (upper bits) of the in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00726_flds
);


##########################################################################
#                                                                        #
#   OC_NI1_GLOBAL_TABLE                                                  #
#                                                                        #
##########################################################################

%orbit_01_00727_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Indicates that this entry is valid" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "V0"                           => [   2,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   3,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
);

%orbit_01_00727_def =
( NAME    => "OC_NI1_GLOBAL_TABLE",
  ADDRESS => 0x00000000d0026800,
  NOTE    => "This table provides the direction and vch for the outgoing header, note in the event that the global bits (upper bits) of the in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00727_flds
);


##########################################################################
#                                                                        #
#   OC_NI1_OVER_RIDE_TABLE                                               #
#                                                                        #
##########################################################################

%orbit_01_00728_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Indicates that this entry is enabled" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "V0"                           => [   2,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   3,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Direction field for next chip" ],
);

%orbit_01_00728_def =
( NAME    => "OC_NI1_OVER_RIDE_TABLE",
  ADDRESS => 0x00000000d0027000,
  NOTE    => "If enabled, bypass the Global/Local tables",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00728_flds
);


##########################################################################
#                                                                        #
#   OC_MD_LOCAL_TABLE                                                    #
#                                                                        #
##########################################################################

%orbit_01_00729_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Indicates that this entry is valid" ],
   "RSVD0"                        => [   1,  14,  49, 0x7FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL1"                      => [   2,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "ni select" ],
   "V1"                           => [   3,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR1"                         => [   4,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
   "RSVD1"                        => [   5,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL0"                      => [   6,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "ni select" ],
   "V0"                           => [   7,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   8,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
);

%orbit_01_00729_def =
( NAME    => "OC_MD_LOCAL_TABLE",
  ADDRESS => 0x00000000d0028000,
  NOTE    => "This table provides the direction and vch for the outgoing header, note in the event that the global bits (upper bits) of the in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00729_flds
);


##########################################################################
#                                                                        #
#   OC_MD_GLOBAL_TABLE                                                   #
#                                                                        #
##########################################################################

%orbit_01_00730_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Indicates that this entry is valid" ],
   "RSVD0"                        => [   1,  14,  49, 0x7FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL1"                      => [   2,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "ni select" ],
   "V1"                           => [   3,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR1"                         => [   4,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
   "RSVD1"                        => [   5,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL0"                      => [   6,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "ni select" ],
   "V0"                           => [   7,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   8,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
);

%orbit_01_00730_def =
( NAME    => "OC_MD_GLOBAL_TABLE",
  ADDRESS => 0x00000000d0028800,
  NOTE    => "This table provides the direction and vch for the outgoing header, note in the event that the global bits (upper bits) of the in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00730_flds
);


##########################################################################
#                                                                        #
#   OC_MD_OVER_RIDE_TABLE                                                #
#                                                                        #
##########################################################################

%orbit_01_00731_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Indicates that this entry is enabled" ],
   "RSVD0"                        => [   1,  14,  49, 0x7FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL1"                      => [   2,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "ni select" ],
   "V1"                           => [   3,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR1"                         => [   4,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "Direction field for next chip" ],
   "RSVD1"                        => [   5,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL0"                      => [   6,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "ni select" ],
   "V0"                           => [   7,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   8,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Direction field for next chip" ],
);

%orbit_01_00731_def =
( NAME    => "OC_MD_OVER_RIDE_TABLE",
  ADDRESS => 0x00000000d0029000,
  NOTE    => "If enabled, bypass the Global/Local tables",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00731_flds
);


##########################################################################
#                                                                        #
#   OC_MD_RSP_PLANE_HINT                                                 #
#                                                                        #
##########################################################################

%orbit_01_00732_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INVERT"                       => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Invert Response Plane Hint" ],
);

%orbit_01_00732_def =
( NAME    => "OC_MD_RSP_PLANE_HINT",
  ADDRESS => 0x00000000d0029008,
  NOTE    => "If enabled, invert incoming response only plane hint bit before note lookup",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00732_flds
);


##########################################################################
#                                                                        #
#   OC_XNPI_SIC_FLOW                                                     #
#                                                                        #
##########################################################################

%orbit_01_00733_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  56,   5, 0x1F00000000000000, 0x00, 0, 0x0000000000000000, "VC2 credit captured value" ],
   "RSVD1"                        => [   2,  53,   3, 0x00E0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  48,   5, 0x001F000000000000, 0x00, 0, 0x0000000000000000, "VC2 credit dynamic value" ],
   "RSVD2"                        => [   4,  45,   3, 0x0000E00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_TEST"              => [   5,  40,   5, 0x00001F0000000000, 0x00, 1, 0x0000000000000000, "VC2 credit_test" ],
   "RSVD3"                        => [   6,  37,   3, 0x000000E000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   7,  32,   5, 0x0000001F00000000, 0x00, 0, 0x0000000000000000, "VC0 credit captured value" ],
   "RSVD4"                        => [   8,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   9,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "VC0 credit dynamic value" ],
   "RSVD5"                        => [  10,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_TEST"              => [  11,  16,   5, 0x00000000001F0000, 0x00, 1, 0x0000000000000000, "VC0 credit_test" ],
   "DEBIT_VC2_FORCE_CRED"         => [  12,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD6"                        => [  13,  13,   2, 0x0000000000006000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [  14,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
   "DEBIT_VC0_FORCE_CRED"         => [  15,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD7"                        => [  16,   5,   2, 0x0000000000000060, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [  17,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%orbit_01_00733_def =
( NAME    => "OC_XNPI_SIC_FLOW",
  ADDRESS => 0x00000000d0030000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00733_flds
);


##########################################################################
#                                                                        #
#   OC_XNPI_TO_NI0_PORT_FLOW                                             #
#                                                                        #
##########################################################################

%orbit_01_00734_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_FORCE_CRED"         => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
   "DEBIT_VC0_FORCE_CRED"         => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%orbit_01_00734_def =
( NAME    => "OC_XNPI_TO_NI0_PORT_FLOW",
  ADDRESS => 0x00000000d0030010,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00734_flds
);


##########################################################################
#                                                                        #
#   OC_XNPI_TO_NI0_PORT_FLOW13                                           #
#                                                                        #
##########################################################################

%orbit_01_00735_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_CAP"               => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_DYN"               => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_CAP"               => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_DYN"               => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_FORCE_CRED"         => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC3" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_WITHHOLD"           => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC3 Withhold" ],
   "DEBIT_VC1_FORCE_CRED"         => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC1" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_WITHHOLD"           => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC1 Withhold" ],
);

%orbit_01_00735_def =
( NAME    => "OC_XNPI_TO_NI0_PORT_FLOW13",
  ADDRESS => 0x00000000d0030020,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00735_flds
);


##########################################################################
#                                                                        #
#   OC_XNPI_TO_NI1_PORT_FLOW                                             #
#                                                                        #
##########################################################################

%orbit_01_00736_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_FORCE_CRED"         => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
   "DEBIT_VC0_FORCE_CRED"         => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%orbit_01_00736_def =
( NAME    => "OC_XNPI_TO_NI1_PORT_FLOW",
  ADDRESS => 0x00000000d0030030,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00736_flds
);


##########################################################################
#                                                                        #
#   OC_XNPI_TO_NI1_PORT_FLOW13                                           #
#                                                                        #
##########################################################################

%orbit_01_00737_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_CAP"               => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_DYN"               => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_CAP"               => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_DYN"               => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_FORCE_CRED"         => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC3" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_WITHHOLD"           => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC3 Withhold" ],
   "DEBIT_VC1_FORCE_CRED"         => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC1" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_WITHHOLD"           => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC1 Withhold" ],
);

%orbit_01_00737_def =
( NAME    => "OC_XNPI_TO_NI1_PORT_FLOW13",
  ADDRESS => 0x00000000d0030040,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00737_flds
);


##########################################################################
#                                                                        #
#   OC_XNPI_TO_IILB_PORT_FLOW                                            #
#                                                                        #
##########################################################################

%orbit_01_00738_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_FORCE_CRED"         => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
   "DEBIT_VC0_FORCE_CRED"         => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%orbit_01_00738_def =
( NAME    => "OC_XNPI_TO_IILB_PORT_FLOW",
  ADDRESS => 0x00000000d0030050,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00738_flds
);


##########################################################################
#                                                                        #
#   OC_XNPI_ARB_CONFIG                                                   #
#                                                                        #
##########################################################################

%orbit_01_00739_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_SYNC_BYPASS_IN"        => [   1,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Enable Bypass Mode" ],
);

%orbit_01_00739_def =
( NAME    => "OC_XNPI_ARB_CONFIG",
  ADDRESS => 0x00000000d0030060,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00739_flds
);


##########################################################################
#                                                                        #
#   OC_XNPI_LOCAL_AGE0                                                   #
#                                                                        #
##########################################################################

%orbit_01_00740_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "AGE_WRAP_SRC3_VC2"            => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "XN_NI1 VC2 Pre-Scale Value" ],
   "AGE_WRAP_SRC3_VC0"            => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "XN_NI1 VC0 Pre-Scale Value" ],
   "AGE_WRAP_SRC2_VC2"            => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "XN_NI0 VC3 Pre-Scale Value" ],
   "AGE_WRAP_SRC2_VC0"            => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "XN_NI0 VC1 Pre-Scale Value" ],
   "AGE_WRAP_SRC1_VC2"            => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "XN_NI0 VC2 Pre-Scale Value" ],
   "AGE_WRAP_SRC1_VC0"            => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "XN_NI0 VC0 Pre-Scale Value" ],
   "AGE_WRAP_SRC0_VC2"            => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "XN_IILB VC2 Pre-Scale Value" ],
   "AGE_WRAP_SRC0_VC0"            => [   7,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "XN_IILB VC0 Pre-Scale Value" ],
);

%orbit_01_00740_def =
( NAME    => "OC_XNPI_LOCAL_AGE0",
  ADDRESS => 0x00000000d0030070,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00740_flds
);


##########################################################################
#                                                                        #
#   OC_XNPI_LOCAL_AGE1                                                   #
#                                                                        #
##########################################################################

%orbit_01_00741_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_WRAP_SRC4_VC2"            => [   1,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "XN_NI1 VC3 Pre-Scale Value" ],
   "AGE_WRAP_SRC4_VC0"            => [   2,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "XN_NI1 VC1 Pre-Scale Value" ],
);

%orbit_01_00741_def =
( NAME    => "OC_XNPI_LOCAL_AGE1",
  ADDRESS => 0x00000000d0030080,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00741_flds
);


##########################################################################
#                                                                        #
#   OC_XNPI_STEERING_FIFO                                                #
#                                                                        #
##########################################################################

%orbit_01_00742_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  44,  20, 0xFFFFF00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT_VC2_CAP"                  => [   1,  40,   4, 0x00000F0000000000, 0x00, 1, 0x0000000000000000, "VC2 Captured Count" ],
   "RSVD1"                        => [   2,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT_VC2_DYN"                  => [   3,  32,   4, 0x0000000F00000000, 0x00, 0, 0x0000000000000000, "VC2 Dynamic Count" ],
   "RSVD2"                        => [   4,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT_VC0_CAP"                  => [   5,  24,   4, 0x000000000F000000, 0x00, 1, 0x0000000000000000, "VC0 Captured Count" ],
   "RSVD3"                        => [   6,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT_VC0_DYN"                  => [   7,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "VC0 Dynamic Count" ],
   "RSVD4"                        => [   8,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CNT_VC2"                  => [   9,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "VC2 Maximum Counter Value" ],
   "RSVD5"                        => [  10,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CNT_VC0"                  => [  11,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "VC0 Maximum Counter Value" ],
);

%orbit_01_00742_def =
( NAME    => "OC_XNPI_STEERING_FIFO",
  ADDRESS => 0x00000000d0030090,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00742_flds
);


##########################################################################
#                                                                        #
#   OC_XNPI_CREDIT_MGR_VC0                                               #
#                                                                        #
##########################################################################

%orbit_01_00743_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE_CNT_CAP"                 => [   1,  44,   3, 0x0000700000000000, 0x00, 1, 0x0000000000000000, "Base VC0 Captured Credit Count" ],
   "RSVD1"                        => [   2,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE_CNT_DYN"                 => [   3,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Base VC0 Dynamic Credit Count" ],
   "RSVD2"                        => [   4,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI1_CNT_CAP"                  => [   5,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "NI1 VC0 Captured Credit Count" ],
   "RSVD3"                        => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI1_CNT_DYN"                  => [   7,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Dynamic Credit Count" ],
   "RSVD4"                        => [   8,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI0_CNT_CAP"                  => [   9,  28,   3, 0x0000000070000000, 0x00, 1, 0x0000000000000000, "NI0 VC0 Captured Credit Count" ],
   "RSVD5"                        => [  10,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI0_CNT_DYN"                  => [  11,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Dynamic Credit Count" ],
   "RSVD6"                        => [  12,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_CNT_CAP"                 => [  13,  20,   3, 0x0000000000700000, 0x00, 1, 0x0000000000000000, "IILB VC0 Captured Credit Count" ],
   "RSVD7"                        => [  14,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_CNT_DYN"                 => [  15,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "IILB VC0 Dynamic Credit Count" ],
   "RSVD8"                        => [  16,  11,   5, 0x000000000000F800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CNT"                      => [  17,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "VC0 Maximum Credit Count" ],
   "RSVD9"                        => [  18,   1,   7, 0x00000000000000FE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE"                       => [  19,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "VC0 Credit Manager Enable" ],
);

%orbit_01_00743_def =
( NAME    => "OC_XNPI_CREDIT_MGR_VC0",
  ADDRESS => 0x00000000d00300a0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00743_flds
);


##########################################################################
#                                                                        #
#   OC_XNPI_CREDIT_MGR_VC2                                               #
#                                                                        #
##########################################################################

%orbit_01_00744_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE_CNT_CAP"                 => [   1,  44,   3, 0x0000700000000000, 0x00, 1, 0x0000000000000000, "Base VC2 Captured Credit Count" ],
   "RSVD1"                        => [   2,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE_CNT_DYN"                 => [   3,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Base VC2 Dynamic Credit Count" ],
   "RSVD2"                        => [   4,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI1_CNT_CAP"                  => [   5,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "NI1 VC2 Captured Credit Count" ],
   "RSVD3"                        => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI1_CNT_DYN"                  => [   7,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Dynamic Credit Count" ],
   "RSVD4"                        => [   8,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI0_CNT_CAP"                  => [   9,  28,   3, 0x0000000070000000, 0x00, 1, 0x0000000000000000, "NI0 VC2 Captured Credit Count" ],
   "RSVD5"                        => [  10,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI0_CNT_DYN"                  => [  11,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Dynamic Credit Count" ],
   "RSVD6"                        => [  12,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_CNT_CAP"                 => [  13,  20,   3, 0x0000000000700000, 0x00, 1, 0x0000000000000000, "IILB VC2 Captured Credit Count" ],
   "RSVD7"                        => [  14,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_CNT_DYN"                 => [  15,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "IILB VC2 Dynamic Credit Count" ],
   "RSVD8"                        => [  16,  11,   5, 0x000000000000F800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CNT"                      => [  17,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "VC2 Maximum Credit Count" ],
   "RSVD9"                        => [  18,   1,   7, 0x00000000000000FE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE"                       => [  19,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "VC2 Credit Manager Enable" ],
);

%orbit_01_00744_def =
( NAME    => "OC_XNPI_CREDIT_MGR_VC2",
  ADDRESS => 0x00000000d00300b0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00744_flds
);


##########################################################################
#                                                                        #
#   OC_XNMD_SIC_FLOW                                                     #
#                                                                        #
##########################################################################

%orbit_01_00745_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  56,   5, 0x1F00000000000000, 0x00, 0, 0x0000000000000000, "VC2 credit captured value" ],
   "RSVD1"                        => [   2,  53,   3, 0x00E0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  48,   5, 0x001F000000000000, 0x00, 0, 0x0000000000000000, "VC2 credit dynamic value" ],
   "RSVD2"                        => [   4,  45,   3, 0x0000E00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_TEST"              => [   5,  40,   5, 0x00001F0000000000, 0x00, 1, 0x0000000000000000, "VC2 credit_test" ],
   "RSVD3"                        => [   6,  37,   3, 0x000000E000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   7,  32,   5, 0x0000001F00000000, 0x00, 0, 0x0000000000000000, "VC0 credit captured value" ],
   "RSVD4"                        => [   8,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   9,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "VC0 credit dynamic value" ],
   "RSVD5"                        => [  10,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_TEST"              => [  11,  16,   5, 0x00000000001F0000, 0x00, 1, 0x0000000000000000, "VC0 credit_test" ],
   "DEBIT_VC2_FORCE_CRED"         => [  12,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD6"                        => [  13,  13,   2, 0x0000000000006000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [  14,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
   "DEBIT_VC0_FORCE_CRED"         => [  15,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD7"                        => [  16,   5,   2, 0x0000000000000060, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [  17,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%orbit_01_00745_def =
( NAME    => "OC_XNMD_SIC_FLOW",
  ADDRESS => 0x00000000d0030100,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00745_flds
);


##########################################################################
#                                                                        #
#   OC_XNMD_TO_NI0_PORT_FLOW                                             #
#                                                                        #
##########################################################################

%orbit_01_00746_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_FORCE_CRED"         => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
   "DEBIT_VC0_FORCE_CRED"         => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%orbit_01_00746_def =
( NAME    => "OC_XNMD_TO_NI0_PORT_FLOW",
  ADDRESS => 0x00000000d0030110,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00746_flds
);


##########################################################################
#                                                                        #
#   OC_XNMD_TO_NI0_PORT_FLOW13                                           #
#                                                                        #
##########################################################################

%orbit_01_00747_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_CAP"               => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_DYN"               => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_CAP"               => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_DYN"               => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_FORCE_CRED"         => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC3" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_WITHHOLD"           => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC3 Withhold" ],
   "DEBIT_VC1_FORCE_CRED"         => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC1" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_WITHHOLD"           => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC1 Withhold" ],
);

%orbit_01_00747_def =
( NAME    => "OC_XNMD_TO_NI0_PORT_FLOW13",
  ADDRESS => 0x00000000d0030120,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00747_flds
);


##########################################################################
#                                                                        #
#   OC_XNMD_TO_NI1_PORT_FLOW                                             #
#                                                                        #
##########################################################################

%orbit_01_00748_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_FORCE_CRED"         => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
   "DEBIT_VC0_FORCE_CRED"         => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%orbit_01_00748_def =
( NAME    => "OC_XNMD_TO_NI1_PORT_FLOW",
  ADDRESS => 0x00000000d0030130,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00748_flds
);


##########################################################################
#                                                                        #
#   OC_XNMD_TO_NI1_PORT_FLOW13                                           #
#                                                                        #
##########################################################################

%orbit_01_00749_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_CAP"               => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_DYN"               => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_CAP"               => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_DYN"               => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_FORCE_CRED"         => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC3" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_WITHHOLD"           => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC3 Withhold" ],
   "DEBIT_VC1_FORCE_CRED"         => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC1" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_WITHHOLD"           => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC1 Withhold" ],
);

%orbit_01_00749_def =
( NAME    => "OC_XNMD_TO_NI1_PORT_FLOW13",
  ADDRESS => 0x00000000d0030140,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00749_flds
);


##########################################################################
#                                                                        #
#   OC_XNMD_TO_IILB_PORT_FLOW                                            #
#                                                                        #
##########################################################################

%orbit_01_00750_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_FORCE_CRED"         => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
   "DEBIT_VC0_FORCE_CRED"         => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%orbit_01_00750_def =
( NAME    => "OC_XNMD_TO_IILB_PORT_FLOW",
  ADDRESS => 0x00000000d0030150,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00750_flds
);


##########################################################################
#                                                                        #
#   OC_XNMD_ARB_CONFIG                                                   #
#                                                                        #
##########################################################################

%orbit_01_00751_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_SYNC_BYPASS_IN"        => [   1,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Enable Bypass Mode" ],
);

%orbit_01_00751_def =
( NAME    => "OC_XNMD_ARB_CONFIG",
  ADDRESS => 0x00000000d0030160,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00751_flds
);


##########################################################################
#                                                                        #
#   OC_XNMD_LOCAL_AGE0                                                   #
#                                                                        #
##########################################################################

%orbit_01_00752_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "AGE_WRAP_SRC3_VC2"            => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "XN_NI1 VC2 Pre-Scale Value" ],
   "AGE_WRAP_SRC3_VC0"            => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "XN_NI1 VC0 Pre-Scale Value" ],
   "AGE_WRAP_SRC2_VC2"            => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "XN_NI0 VC3 Pre-Scale Value" ],
   "AGE_WRAP_SRC2_VC0"            => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "XN_NI0 VC1 Pre-Scale Value" ],
   "AGE_WRAP_SRC1_VC2"            => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "XN_NI0 VC2 Pre-Scale Value" ],
   "AGE_WRAP_SRC1_VC0"            => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "XN_NI0 VC0 Pre-Scale Value" ],
   "AGE_WRAP_SRC0_VC2"            => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "XN_IILB VC2 Pre-Scale Value" ],
   "AGE_WRAP_SRC0_VC0"            => [   7,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "XN_IILB VC0 Pre-Scale Value" ],
);

%orbit_01_00752_def =
( NAME    => "OC_XNMD_LOCAL_AGE0",
  ADDRESS => 0x00000000d0030170,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00752_flds
);


##########################################################################
#                                                                        #
#   OC_XNMD_LOCAL_AGE1                                                   #
#                                                                        #
##########################################################################

%orbit_01_00753_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_WRAP_SRC4_VC2"            => [   1,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "XN_NI1 VC3 Pre-Scale Value" ],
   "AGE_WRAP_SRC4_VC0"            => [   2,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "XN_NI1 VC1 Pre-Scale Value" ],
);

%orbit_01_00753_def =
( NAME    => "OC_XNMD_LOCAL_AGE1",
  ADDRESS => 0x00000000d0030180,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00753_flds
);


##########################################################################
#                                                                        #
#   OC_XNMD_STEERING_FIFO                                                #
#                                                                        #
##########################################################################

%orbit_01_00754_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  44,  20, 0xFFFFF00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT_VC2_CAP"                  => [   1,  40,   4, 0x00000F0000000000, 0x00, 1, 0x0000000000000000, "VC2 Captured Count" ],
   "RSVD1"                        => [   2,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT_VC2_DYN"                  => [   3,  32,   4, 0x0000000F00000000, 0x00, 0, 0x0000000000000000, "VC2 Dynamic Count" ],
   "RSVD2"                        => [   4,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT_VC0_CAP"                  => [   5,  24,   4, 0x000000000F000000, 0x00, 1, 0x0000000000000000, "VC0 Captured Count" ],
   "RSVD3"                        => [   6,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT_VC0_DYN"                  => [   7,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "VC0 Dynamic Count" ],
   "RSVD4"                        => [   8,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CNT_VC2"                  => [   9,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "VC2 Maximum Counter Value" ],
   "RSVD5"                        => [  10,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CNT_VC0"                  => [  11,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "VC0 Maximum Counter Value" ],
);

%orbit_01_00754_def =
( NAME    => "OC_XNMD_STEERING_FIFO",
  ADDRESS => 0x00000000d0030190,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00754_flds
);


##########################################################################
#                                                                        #
#   OC_XNMD_CREDIT_MGR_VC0                                               #
#                                                                        #
##########################################################################

%orbit_01_00755_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE_CNT_CAP"                 => [   1,  44,   3, 0x0000700000000000, 0x00, 1, 0x0000000000000000, "Base VC0 Captured Credit Count" ],
   "RSVD1"                        => [   2,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE_CNT_DYN"                 => [   3,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Base VC0 Dynamic Credit Count" ],
   "RSVD2"                        => [   4,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI1_CNT_CAP"                  => [   5,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "NI1 VC0 Captured Credit Count" ],
   "RSVD3"                        => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI1_CNT_DYN"                  => [   7,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Dynamic Credit Count" ],
   "RSVD4"                        => [   8,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI0_CNT_CAP"                  => [   9,  28,   3, 0x0000000070000000, 0x00, 1, 0x0000000000000000, "NI0 VC0 Captured Credit Count" ],
   "RSVD5"                        => [  10,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI0_CNT_DYN"                  => [  11,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Dynamic Credit Count" ],
   "RSVD6"                        => [  12,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_CNT_CAP"                 => [  13,  20,   3, 0x0000000000700000, 0x00, 1, 0x0000000000000000, "IILB VC0 Captured Credit Count" ],
   "RSVD7"                        => [  14,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_CNT_DYN"                 => [  15,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "IILB VC0 Dynamic Credit Count" ],
   "RSVD8"                        => [  16,  11,   5, 0x000000000000F800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CNT"                      => [  17,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "VC0 Maximum Credit Count" ],
   "RSVD9"                        => [  18,   1,   7, 0x00000000000000FE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE"                       => [  19,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "VC0 Credit Manager Enable" ],
);

%orbit_01_00755_def =
( NAME    => "OC_XNMD_CREDIT_MGR_VC0",
  ADDRESS => 0x00000000d00301a0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00755_flds
);


##########################################################################
#                                                                        #
#   OC_XNMD_CREDIT_MGR_VC2                                               #
#                                                                        #
##########################################################################

%orbit_01_00756_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE_CNT_CAP"                 => [   1,  44,   3, 0x0000700000000000, 0x00, 1, 0x0000000000000000, "Base VC2 Captured Credit Count" ],
   "RSVD1"                        => [   2,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE_CNT_DYN"                 => [   3,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Base VC2 Dynamic Credit Count" ],
   "RSVD2"                        => [   4,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI1_CNT_CAP"                  => [   5,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "NI1 VC2 Captured Credit Count" ],
   "RSVD3"                        => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI1_CNT_DYN"                  => [   7,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Dynamic Credit Count" ],
   "RSVD4"                        => [   8,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI0_CNT_CAP"                  => [   9,  28,   3, 0x0000000070000000, 0x00, 1, 0x0000000000000000, "NI0 VC2 Captured Credit Count" ],
   "RSVD5"                        => [  10,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI0_CNT_DYN"                  => [  11,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Dynamic Credit Count" ],
   "RSVD6"                        => [  12,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_CNT_CAP"                 => [  13,  20,   3, 0x0000000000700000, 0x00, 1, 0x0000000000000000, "IILB VC2 Captured Credit Count" ],
   "RSVD7"                        => [  14,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_CNT_DYN"                 => [  15,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "IILB VC2 Dynamic Credit Count" ],
   "RSVD8"                        => [  16,  11,   5, 0x000000000000F800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CNT"                      => [  17,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "VC2 Maximum Credit Count" ],
   "RSVD9"                        => [  18,   1,   7, 0x00000000000000FE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE"                       => [  19,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "VC2 Credit Manager Enable" ],
);

%orbit_01_00756_def =
( NAME    => "OC_XNMD_CREDIT_MGR_VC2",
  ADDRESS => 0x00000000d00301b0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00756_flds
);


##########################################################################
#                                                                        #
#   OC_XNII_INTRA_FLOW                                                   #
#                                                                        #
##########################################################################

%orbit_01_00757_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "VC2 credit captured value" ],
   "RSVD1"                        => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  48,   7, 0x007F000000000000, 0x00, 0, 0x0000000000000000, "VC2 credit dynamic value" ],
   "RSVD2"                        => [   4,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_TEST"              => [   5,  40,   7, 0x00007F0000000000, 0x00, 1, 0x0000000000000000, "VC2 credit_test" ],
   "RSVD3"                        => [   6,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   7,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "VC0 credit captured value" ],
   "RSVD4"                        => [   8,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   9,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "VC0 credit dynamic value" ],
   "RSVD5"                        => [  10,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_TEST"              => [  11,  16,   7, 0x00000000007F0000, 0x00, 1, 0x0000000000000000, "VC0 credit_test" ],
   "DEBIT_VC2_FORCE_CRED"         => [  12,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD6"                        => [  13,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [  14,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
   "DEBIT_VC0_FORCE_CRED"         => [  15,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD7"                        => [  16,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [  17,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%orbit_01_00757_def =
( NAME    => "OC_XNII_INTRA_FLOW",
  ADDRESS => 0x00000000d0030200,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00757_flds
);


##########################################################################
#                                                                        #
#   OC_XNLB_INTRA_FLOW                                                   #
#                                                                        #
##########################################################################

%orbit_01_00758_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "VC2 credit captured value" ],
   "RSVD1"                        => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  48,   7, 0x007F000000000000, 0x00, 0, 0x0000000000000000, "VC2 credit dynamic value" ],
   "RSVD2"                        => [   4,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_TEST"              => [   5,  40,   7, 0x00007F0000000000, 0x00, 1, 0x0000000000000000, "VC2 credit_test" ],
   "RSVD3"                        => [   6,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   7,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "VC0 credit captured value" ],
   "RSVD4"                        => [   8,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   9,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "VC0 credit dynamic value" ],
   "RSVD5"                        => [  10,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_TEST"              => [  11,  16,   7, 0x00000000007F0000, 0x00, 1, 0x0000000000000000, "VC0 credit_test" ],
   "DEBIT_VC2_FORCE_CRED"         => [  12,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD6"                        => [  13,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [  14,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
   "DEBIT_VC0_FORCE_CRED"         => [  15,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD7"                        => [  16,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [  17,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%orbit_01_00758_def =
( NAME    => "OC_XNLB_INTRA_FLOW",
  ADDRESS => 0x00000000d0030210,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00758_flds
);


##########################################################################
#                                                                        #
#   OC_XNIILB_TO_NI0_INTRA_FLOW_DEBIT                                     #
#                                                                        #
##########################################################################

%orbit_01_00759_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_FORCE_CRED"               => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_WITHHOLD"                 => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
   "VC0_FORCE_CRED"               => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_WITHHOLD"                 => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 withhold" ],
);

%orbit_01_00759_def =
( NAME    => "OC_XNIILB_TO_NI0_INTRA_FLOW_DEBIT",
  ADDRESS => 0x00000000d0030220,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00759_flds
);


##########################################################################
#                                                                        #
#   OC_XNIILB_TO_NI0_INTRA_FLOW_DEBIT13                                     #
#                                                                        #
##########################################################################

%orbit_01_00760_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_CAP"                      => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_DYN"                      => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_CAP"                      => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_DYN"                      => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_FORCE_CRED"               => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC3" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_WITHHOLD"                 => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC3 Withhold" ],
   "VC1_FORCE_CRED"               => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC1" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_WITHHOLD"                 => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC1 Withhold" ],
);

%orbit_01_00760_def =
( NAME    => "OC_XNIILB_TO_NI0_INTRA_FLOW_DEBIT13",
  ADDRESS => 0x00000000d0030230,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00760_flds
);


##########################################################################
#                                                                        #
#   OC_XNIILB_TO_NI1_INTRA_FLOW_DEBIT                                     #
#                                                                        #
##########################################################################

%orbit_01_00761_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_FORCE_CRED"               => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_WITHHOLD"                 => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
   "VC0_FORCE_CRED"               => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_WITHHOLD"                 => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 withhold" ],
);

%orbit_01_00761_def =
( NAME    => "OC_XNIILB_TO_NI1_INTRA_FLOW_DEBIT",
  ADDRESS => 0x00000000d0030240,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00761_flds
);


##########################################################################
#                                                                        #
#   OC_XNIILB_TO_NI1_INTRA_FLOW_DEBIT13                                     #
#                                                                        #
##########################################################################

%orbit_01_00762_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_CAP"                      => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_DYN"                      => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_CAP"                      => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_DYN"                      => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_FORCE_CRED"               => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC3" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_WITHHOLD"                 => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC3 Withhold" ],
   "VC1_FORCE_CRED"               => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC1" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_WITHHOLD"                 => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC1 Withhold" ],
);

%orbit_01_00762_def =
( NAME    => "OC_XNIILB_TO_NI1_INTRA_FLOW_DEBIT13",
  ADDRESS => 0x00000000d0030250,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00762_flds
);


##########################################################################
#                                                                        #
#   OC_XNIILB_TO_IILB_INTRA_FLOW_DEBIT                                     #
#                                                                        #
##########################################################################

%orbit_01_00763_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_FORCE_CRED"               => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_WITHHOLD"                 => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
   "VC0_FORCE_CRED"               => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_WITHHOLD"                 => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 withhold" ],
);

%orbit_01_00763_def =
( NAME    => "OC_XNIILB_TO_IILB_INTRA_FLOW_DEBIT",
  ADDRESS => 0x00000000d0030260,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00763_flds
);


##########################################################################
#                                                                        #
#   OC_XNIILB_FR_NI0_INTRA_FLOW_CREDIT                                     #
#                                                                        #
##########################################################################

%orbit_01_00764_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "VC2 credit captured value" ],
   "RSVD1"                        => [   2,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "VC2 credit dynamic value" ],
   "RSVD2"                        => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_TEST"                     => [   5,  24,   7, 0x000000007F000000, 0x00, 1, 0x0000000000000000, "VC2 credit_test" ],
   "RSVD3"                        => [   6,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   7,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "VC0 credit captured value" ],
   "RSVD4"                        => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   9,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "VC0 credit dynamic value" ],
   "RSVD5"                        => [  10,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_TEST"                     => [  11,   0,   7, 0x000000000000007F, 0x00, 1, 0x0000000000000000, "VC0 credit_test" ],
);

%orbit_01_00764_def =
( NAME    => "OC_XNIILB_FR_NI0_INTRA_FLOW_CREDIT",
  ADDRESS => 0x00000000d00302b0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00764_flds
);


##########################################################################
#                                                                        #
#   OC_XNIILB_FR_NI1_INTRA_FLOW_CREDIT                                     #
#                                                                        #
##########################################################################

%orbit_01_00765_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "VC2 credit captured value" ],
   "RSVD1"                        => [   2,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "VC2 credit dynamic value" ],
   "RSVD2"                        => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_TEST"                     => [   5,  24,   7, 0x000000007F000000, 0x00, 1, 0x0000000000000000, "VC2 credit_test" ],
   "RSVD3"                        => [   6,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   7,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "VC0 credit captured value" ],
   "RSVD4"                        => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   9,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "VC0 credit dynamic value" ],
   "RSVD5"                        => [  10,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_TEST"                     => [  11,   0,   7, 0x000000000000007F, 0x00, 1, 0x0000000000000000, "VC0 credit_test" ],
);

%orbit_01_00765_def =
( NAME    => "OC_XNIILB_FR_NI1_INTRA_FLOW_CREDIT",
  ADDRESS => 0x00000000d00302c0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00765_flds
);


##########################################################################
#                                                                        #
#   OC_XNIILB_FR_IILB_INTRA_FLOW_CREDIT                                     #
#                                                                        #
##########################################################################

%orbit_01_00766_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "VC2 credit captured value" ],
   "RSVD1"                        => [   2,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "VC2 credit dynamic value" ],
   "RSVD2"                        => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_TEST"                     => [   5,  24,   7, 0x000000007F000000, 0x00, 1, 0x0000000000000000, "VC2 credit_test" ],
   "RSVD3"                        => [   6,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   7,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "VC0 credit captured value" ],
   "RSVD4"                        => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   9,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "VC0 credit dynamic value" ],
   "RSVD5"                        => [  10,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_TEST"                     => [  11,   0,   7, 0x000000000000007F, 0x00, 1, 0x0000000000000000, "VC0 credit_test" ],
);

%orbit_01_00766_def =
( NAME    => "OC_XNIILB_FR_IILB_INTRA_FLOW_CREDIT",
  ADDRESS => 0x00000000d00302d0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00766_flds
);


##########################################################################
#                                                                        #
#   OC_XNIILB_II_FIFO_CREDIT_CNT                                         #
#                                                                        #
##########################################################################

%orbit_01_00767_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  46,  18, 0xFFFFC00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  40,   6, 0x00003F0000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  38,   2, 0x000000C000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  22,  10, 0x00000000FFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   5,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   7,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
);

%orbit_01_00767_def =
( NAME    => "OC_XNIILB_II_FIFO_CREDIT_CNT",
  ADDRESS => 0x00000000d0030300,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00767_flds
);


##########################################################################
#                                                                        #
#   OC_XNIILB_LB_FIFO_CREDIT_CNT                                         #
#                                                                        #
##########################################################################

%orbit_01_00768_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  46,  18, 0xFFFFC00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  40,   6, 0x00003F0000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  38,   2, 0x000000C000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  22,  10, 0x00000000FFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   5,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   7,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
);

%orbit_01_00768_def =
( NAME    => "OC_XNIILB_LB_FIFO_CREDIT_CNT",
  ADDRESS => 0x00000000d0030310,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00768_flds
);


##########################################################################
#                                                                        #
#   OC_XNIILB_ARB_CONFIG_SI                                              #
#                                                                        #
##########################################################################

%orbit_01_00769_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_FULL_BYP_SI"           => [   1,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Enable Bypass Mode" ],
);

%orbit_01_00769_def =
( NAME    => "OC_XNIILB_ARB_CONFIG_SI",
  ADDRESS => 0x00000000d0030320,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00769_flds
);


##########################################################################
#                                                                        #
#   OC_XNIILB_ARB_CONFIG_SO                                              #
#                                                                        #
##########################################################################

%orbit_01_00770_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_FULL_BYP_SO"           => [   1,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Enable Bypass Mode" ],
);

%orbit_01_00770_def =
( NAME    => "OC_XNIILB_ARB_CONFIG_SO",
  ADDRESS => 0x00000000d0030330,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00770_flds
);


##########################################################################
#                                                                        #
#   OC_XNIILB_AGE_WRAP0                                                  #
#                                                                        #
##########################################################################

%orbit_01_00771_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SRC1_VC1_SI"                  => [   1,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "LB VC2 Pre-Scale Value" ],
   "SRC1_VC0_SI"                  => [   2,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "LB VC0 Pre-Scale Value" ],
   "SRC0_VC1_SI"                  => [   3,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "II VC2 Pre-Scale Value" ],
   "SRC0_VC0_SI"                  => [   4,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "II VC0 Pre-Scale Value" ],
);

%orbit_01_00771_def =
( NAME    => "OC_XNIILB_AGE_WRAP0",
  ADDRESS => 0x00000000d0030340,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00771_flds
);


##########################################################################
#                                                                        #
#   OC_XNIILB_AGE_WRAP1                                                  #
#                                                                        #
##########################################################################

%orbit_01_00772_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SRC2_VC1_SO"                  => [   1,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "XN_NI0 VC3 Pre-Scale Value" ],
   "SRC2_VC0_SO"                  => [   2,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "XN_NI0 VC1 Pre-Scale Value" ],
   "SRC1_VC1_SO"                  => [   3,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "XN_NI0 VC2 Pre-Scale Value" ],
   "SRC1_VC0_SO"                  => [   4,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "XN_NI0 VC0 Pre-Scale Value" ],
   "SRC0_VC1_SO"                  => [   5,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "XN_IILB VC2 Pre-Scale Value" ],
   "SRC0_VC0_SO"                  => [   6,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "XN_IILB VC0 Pre-Scale Value" ],
);

%orbit_01_00772_def =
( NAME    => "OC_XNIILB_AGE_WRAP1",
  ADDRESS => 0x00000000d0030350,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00772_flds
);


##########################################################################
#                                                                        #
#   OC_XNIILB_AGE_WRAP2                                                  #
#                                                                        #
##########################################################################

%orbit_01_00773_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SRC6_VC1_SO"                  => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "XN_MD VC2 Pre-Scale Value" ],
   "SRC6_VC0_SO"                  => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "XN_MD VC0 Pre-Scale Value" ],
   "SRC5_VC1_SO"                  => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "XN_PI VC2 Pre-Scale Value" ],
   "SRC5_VC0_SO"                  => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "XN_PI VC0 Pre-Scale Value" ],
   "SRC4_VC1_SO"                  => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "XN_NI1 VC3 Pre-Scale Value" ],
   "SRC4_VC0_SO"                  => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "XN_NI1 VC1 Pre-Scale Value" ],
   "SRC3_VC1_SO"                  => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "XN_NI1 VC2 Pre-Scale Value" ],
   "SRC3_VC0_SO"                  => [   7,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "XN_NI1 VC0 Pre-Scale Value" ],
);

%orbit_01_00773_def =
( NAME    => "OC_XNIILB_AGE_WRAP2",
  ADDRESS => 0x00000000d0030360,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00773_flds
);


##########################################################################
#                                                                        #
#   OC_XNIILB_TO_PI_INTRA_FLOW_SIC_DEBIT_VC0                                     #
#                                                                        #
##########################################################################

%orbit_01_00774_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_CAP"                     => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 Data FIFO captured depth" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_DYN"                     => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 Data FIFO dynamic depth" ],
   "RSVD2"                        => [   4,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_CAP"                      => [   5,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VC0 Header FIFO captured depth" ],
   "RSVD3"                        => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_DYN"                      => [   7,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VC0 Header FIFO dynamic depth" ],
   "FORCE_CRED"                   => [   8,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD4"                        => [   9,   5,   2, 0x0000000000000060, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WITHHOLD"                     => [  10,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%orbit_01_00774_def =
( NAME    => "OC_XNIILB_TO_PI_INTRA_FLOW_SIC_DEBIT_VC0",
  ADDRESS => 0x00000000d0030270,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00774_flds
);


##########################################################################
#                                                                        #
#   OC_XNIILB_TO_PI_INTRA_FLOW_SIC_DEBIT_VC2                                     #
#                                                                        #
##########################################################################

%orbit_01_00775_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_CAP"                     => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC2 Data FIFO captured depth" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_DYN"                     => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC2 Data FIFO dynamic depth" ],
   "RSVD2"                        => [   4,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_CAP"                      => [   5,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VC2 Header FIFO captured depth" ],
   "RSVD3"                        => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_DYN"                      => [   7,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VC2 Header FIFO dynamic depth" ],
   "FORCE_CRED"                   => [   8,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD4"                        => [   9,   5,   2, 0x0000000000000060, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WITHHOLD"                     => [  10,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
);

%orbit_01_00775_def =
( NAME    => "OC_XNIILB_TO_PI_INTRA_FLOW_SIC_DEBIT_VC2",
  ADDRESS => 0x00000000d0030280,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00775_flds
);


##########################################################################
#                                                                        #
#   OC_XNIILB_TO_MD_INTRA_FLOW_SIC_DEBIT_VC0                                     #
#                                                                        #
##########################################################################

%orbit_01_00776_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_CAP"                     => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 Data FIFO captured depth" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_DYN"                     => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 Data FIFO dynamic depth" ],
   "RSVD2"                        => [   4,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_CAP"                      => [   5,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VC0 Header FIFO captured depth" ],
   "RSVD3"                        => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_DYN"                      => [   7,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VC0 Header FIFO dynamic depth" ],
   "FORCE_CRED"                   => [   8,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD4"                        => [   9,   5,   2, 0x0000000000000060, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WITHHOLD"                     => [  10,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%orbit_01_00776_def =
( NAME    => "OC_XNIILB_TO_MD_INTRA_FLOW_SIC_DEBIT_VC0",
  ADDRESS => 0x00000000d0030290,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00776_flds
);


##########################################################################
#                                                                        #
#   OC_XNIILB_TO_MD_INTRA_FLOW_SIC_DEBIT_VC2                                     #
#                                                                        #
##########################################################################

%orbit_01_00777_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_CAP"                     => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC2 Data FIFO captured depth" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_DYN"                     => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC2 Data FIFO dynamic depth" ],
   "RSVD2"                        => [   4,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_CAP"                      => [   5,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VC2 Header FIFO captured depth" ],
   "RSVD3"                        => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_DYN"                      => [   7,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VC2 Header FIFO dynamic depth" ],
   "FORCE_CRED"                   => [   8,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD4"                        => [   9,   5,   2, 0x0000000000000060, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WITHHOLD"                     => [  10,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
);

%orbit_01_00777_def =
( NAME    => "OC_XNIILB_TO_MD_INTRA_FLOW_SIC_DEBIT_VC2",
  ADDRESS => 0x00000000d00302a0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00777_flds
);


##########################################################################
#                                                                        #
#   OC_XNIILB_FR_MD_INTRA_FLOW_CREDIT                                     #
#                                                                        #
##########################################################################

%orbit_01_00778_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "VC2 credit captured value" ],
   "RSVD1"                        => [   2,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "VC2 credit dynamic value" ],
   "RSVD2"                        => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_TEST"                     => [   5,  24,   7, 0x000000007F000000, 0x00, 1, 0x0000000000000000, "VC2 credit_test" ],
   "RSVD3"                        => [   6,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   7,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "VC0 credit captured value" ],
   "RSVD4"                        => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   9,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "VC0 credit dynamic value" ],
   "RSVD5"                        => [  10,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_TEST"                     => [  11,   0,   7, 0x000000000000007F, 0x00, 1, 0x0000000000000000, "VC0 credit_test" ],
);

%orbit_01_00778_def =
( NAME    => "OC_XNIILB_FR_MD_INTRA_FLOW_CREDIT",
  ADDRESS => 0x00000000d00302e0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00778_flds
);


##########################################################################
#                                                                        #
#   OC_XNIILB_FR_PI_INTRA_FLOW_CREDIT                                     #
#                                                                        #
##########################################################################

%orbit_01_00779_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "VC2 credit captured value" ],
   "RSVD1"                        => [   2,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "VC2 credit dynamic value" ],
   "RSVD2"                        => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_TEST"                     => [   5,  24,   7, 0x000000007F000000, 0x00, 1, 0x0000000000000000, "VC2 credit_test" ],
   "RSVD3"                        => [   6,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   7,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "VC0 credit captured value" ],
   "RSVD4"                        => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   9,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "VC0 credit dynamic value" ],
   "RSVD5"                        => [  10,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_TEST"                     => [  11,   0,   7, 0x000000000000007F, 0x00, 1, 0x0000000000000000, "VC0 credit_test" ],
);

%orbit_01_00779_def =
( NAME    => "OC_XNIILB_FR_PI_INTRA_FLOW_CREDIT",
  ADDRESS => 0x00000000d00302f0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00779_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI0_TO_IILB_INTRA_FLOW_DEBIT                                     #
#                                                                        #
##########################################################################

%orbit_01_00780_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_FORCE_CRED"               => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_WITHHOLD"                 => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
   "VC0_FORCE_CRED"               => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_WITHHOLD"                 => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 withhold" ],
);

%orbit_01_00780_def =
( NAME    => "OC_XNNI0_TO_IILB_INTRA_FLOW_DEBIT",
  ADDRESS => 0x00000000d0030400,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00780_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI0_TO_PI_INTRA_FLOW_SIC_DEBIT_VC0                                     #
#                                                                        #
##########################################################################

%orbit_01_00781_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_CAP"                     => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 Data FIFO captured depth" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_DYN"                     => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 Data FIFO dynamic depth" ],
   "RSVD2"                        => [   4,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_CAP"                      => [   5,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VC0 Header FIFO captured depth" ],
   "RSVD3"                        => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_DYN"                      => [   7,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VC0 Header FIFO dynamic depth" ],
   "FORCE_CRED"                   => [   8,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD4"                        => [   9,   5,   2, 0x0000000000000060, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WITHHOLD"                     => [  10,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%orbit_01_00781_def =
( NAME    => "OC_XNNI0_TO_PI_INTRA_FLOW_SIC_DEBIT_VC0",
  ADDRESS => 0x00000000d0030410,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00781_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI0_TO_PI_INTRA_FLOW_SIC_DEBIT_VC2                                     #
#                                                                        #
##########################################################################

%orbit_01_00782_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_CAP"                     => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC2 Data FIFO captured depth" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_DYN"                     => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC2 Data FIFO dynamic depth" ],
   "RSVD2"                        => [   4,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_CAP"                      => [   5,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VC2 Header FIFO captured depth" ],
   "RSVD3"                        => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_DYN"                      => [   7,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VC2 Header FIFO dynamic depth" ],
   "FORCE_CRED"                   => [   8,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD4"                        => [   9,   5,   2, 0x0000000000000060, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WITHHOLD"                     => [  10,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
);

%orbit_01_00782_def =
( NAME    => "OC_XNNI0_TO_PI_INTRA_FLOW_SIC_DEBIT_VC2",
  ADDRESS => 0x00000000d0030420,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00782_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI0_TO_MD_INTRA_FLOW_SIC_DEBIT_VC0                                     #
#                                                                        #
##########################################################################

%orbit_01_00783_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_CAP"                     => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 Data FIFO captured depth" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_DYN"                     => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 Data FIFO dynamic depth" ],
   "RSVD2"                        => [   4,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_CAP"                      => [   5,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VC0 Header FIFO captured depth" ],
   "RSVD3"                        => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_DYN"                      => [   7,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VC0 Header FIFO dynamic depth" ],
   "FORCE_CRED"                   => [   8,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD4"                        => [   9,   5,   2, 0x0000000000000060, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WITHHOLD"                     => [  10,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%orbit_01_00783_def =
( NAME    => "OC_XNNI0_TO_MD_INTRA_FLOW_SIC_DEBIT_VC0",
  ADDRESS => 0x00000000d0030430,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00783_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI0_TO_MD_INTRA_FLOW_SIC_DEBIT_VC2                                     #
#                                                                        #
##########################################################################

%orbit_01_00784_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_CAP"                     => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC2 Data FIFO captured depth" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_DYN"                     => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC2 Data FIFO dynamic depth" ],
   "RSVD2"                        => [   4,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_CAP"                      => [   5,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VC2 Header FIFO captured depth" ],
   "RSVD3"                        => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_DYN"                      => [   7,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VC2 Header FIFO dynamic depth" ],
   "FORCE_CRED"                   => [   8,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD4"                        => [   9,   5,   2, 0x0000000000000060, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WITHHOLD"                     => [  10,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
);

%orbit_01_00784_def =
( NAME    => "OC_XNNI0_TO_MD_INTRA_FLOW_SIC_DEBIT_VC2",
  ADDRESS => 0x00000000d0030440,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00784_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI0_0_INTRANI_FLOW                                              #
#                                                                        #
##########################################################################

%orbit_01_00785_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,   8,  16, 0x0000000000FFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_FORCE_CRED"         => [   5,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD3"                        => [   6,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [   7,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%orbit_01_00785_def =
( NAME    => "OC_XNNI0_0_INTRANI_FLOW",
  ADDRESS => 0x00000000d0030450,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00785_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI0_1_INTRANI_FLOW                                              #
#                                                                        #
##########################################################################

%orbit_01_00786_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_CAP"                      => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_DYN"                      => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,   8,  16, 0x0000000000FFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_FORCE_CRED"         => [   5,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC1" ],
   "RSVD3"                        => [   6,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_WITHHOLD"           => [   7,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC1 Withhold" ],
);

%orbit_01_00786_def =
( NAME    => "OC_XNNI0_1_INTRANI_FLOW",
  ADDRESS => 0x00000000d0030460,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00786_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI0_2_INTRANI_FLOW                                              #
#                                                                        #
##########################################################################

%orbit_01_00787_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,   8,  16, 0x0000000000FFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_FORCE_CRED"         => [   5,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD3"                        => [   6,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [   7,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
);

%orbit_01_00787_def =
( NAME    => "OC_XNNI0_2_INTRANI_FLOW",
  ADDRESS => 0x00000000d0030470,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00787_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI0_3_INTRANI_FLOW                                              #
#                                                                        #
##########################################################################

%orbit_01_00788_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_CAP"                      => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_DYN"                      => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,   8,  16, 0x0000000000FFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_FORCE_CRED"         => [   5,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC3" ],
   "RSVD3"                        => [   6,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_WITHHOLD"           => [   7,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC3 Withhold" ],
);

%orbit_01_00788_def =
( NAME    => "OC_XNNI0_3_INTRANI_FLOW",
  ADDRESS => 0x00000000d0030480,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00788_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI0_VCSWITCH_FLOW                                               #
#                                                                        #
##########################################################################

%orbit_01_00789_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  25,  39, 0xFFFFFFFFFE000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_VCFIFO_SWITCH"           => [   1,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Select VC0/2 or VC1/3 for IILB" ],
   "RSVD1"                        => [   2,  17,   7, 0x0000000000FE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MD_VCFIFO_SWITCH"             => [   3,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Select VC0/2 or VC1/3 for MD" ],
   "RSVD2"                        => [   4,   9,   7, 0x000000000000FE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PI_VCFIFO_SWITCH"             => [   5,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Select VC0/2 or VC1/3 for PI" ],
   "RSVD3"                        => [   6,   1,   7, 0x00000000000000FE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_VCFIFO_DATELINE_SWITCH"    => [   7,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Swap VC0/2 with VC1/3" ],
);

%orbit_01_00789_def =
( NAME    => "OC_XNNI0_VCSWITCH_FLOW",
  ADDRESS => 0x00000000d0030490,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00789_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI0_TIMER_REG                                                   #
#                                                                        #
##########################################################################

%orbit_01_00790_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "QUEUECNTENABLE_REG"           => [   1,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "Queue Counter Enable" ],
   "LINKRESETENABLE_REG"          => [   2,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "Link Reset Enable" ],
   "LINKCLEANUP_REG"              => [   3,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "Link Clean Up" ],
   "RSVD1"                        => [   4,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIMEOUT_REG"                  => [   5,   0,  24, 0x0000000000FFFFFF, 0x00, 1, 0x0000000000000000, "Master Timeout Counter" ],
);

%orbit_01_00790_def =
( NAME    => "OC_XNNI0_TIMER_REG",
  ADDRESS => 0x00000000d00304a0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00790_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI0_IILB_TAILTO                                                 #
#                                                                        #
##########################################################################

%orbit_01_00791_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VC3_CAP"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter captured value" ],
   "VC3_DYN"                      => [   1,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter dynamic value" ],
   "RSVD0"                        => [   2,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_LIMIT"                    => [   3,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "vc3 limit reg, zero disables functionality" ],
   "VC2_CAP"                      => [   4,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "vc2 counter captured value" ],
   "VC2_DYN"                      => [   5,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "vc2 counter dynamic value" ],
   "RSVD1"                        => [   6,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_LIMIT"                    => [   7,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "vc2 limit reg, zero disables functionality" ],
   "VC1_CAP"                      => [   8,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "vc1 counter captured value" ],
   "VC1_DYN"                      => [   9,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "vc1 counter dynamic value" ],
   "RSVD2"                        => [  10,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_LIMIT"                    => [  11,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "vc1 limit reg, zero disables functionality" ],
   "VC0_CAP"                      => [  12,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "vc0 counter captured value" ],
   "VC0_DYN"                      => [  13,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "vc0 counter dynamic value" ],
   "RSVD3"                        => [  14,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_LIMIT"                    => [  15,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "vc0 limit reg, zero disables functionality" ],
);

%orbit_01_00791_def =
( NAME    => "OC_XNNI0_IILB_TAILTO",
  ADDRESS => 0x00000000d00304b0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00791_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI0_NI_TAILTO                                                   #
#                                                                        #
##########################################################################

%orbit_01_00792_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VC3_CAP"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter captured value" ],
   "VC3_DYN"                      => [   1,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter dynamic value" ],
   "RSVD0"                        => [   2,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_LIMIT"                    => [   3,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "vc3 limit reg, zero disables functionality" ],
   "VC2_CAP"                      => [   4,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "vc2 counter captured value" ],
   "VC2_DYN"                      => [   5,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "vc2 counter dynamic value" ],
   "RSVD1"                        => [   6,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_LIMIT"                    => [   7,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "vc2 limit reg, zero disables functionality" ],
   "VC1_CAP"                      => [   8,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "vc1 counter captured value" ],
   "VC1_DYN"                      => [   9,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "vc1 counter dynamic value" ],
   "RSVD2"                        => [  10,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_LIMIT"                    => [  11,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "vc1 limit reg, zero disables functionality" ],
   "VC0_CAP"                      => [  12,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "vc0 counter captured value" ],
   "VC0_DYN"                      => [  13,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "vc0 counter dynamic value" ],
   "RSVD3"                        => [  14,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_LIMIT"                    => [  15,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "vc0 limit reg, zero disables functionality" ],
);

%orbit_01_00792_def =
( NAME    => "OC_XNNI0_NI_TAILTO",
  ADDRESS => 0x00000000d00304c0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00792_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI0_NI_TAILTO_SUPPORT                                           #
#                                                                        #
##########################################################################

%orbit_01_00793_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INJECT_TAIL_ENABLE"           => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "" ],
);

%orbit_01_00793_def =
( NAME    => "OC_XNNI0_NI_TAILTO_SUPPORT",
  ADDRESS => 0x00000000d00304f0,
  NOTE    => "This register adds a 'tail injection' feature to the basic Tail note Timeout functionality. If enabled, when a Tail Timeout Limi",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00793_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI0_PI_TAILTO                                                   #
#                                                                        #
##########################################################################

%orbit_01_00794_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VC3_CAP"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter captured value" ],
   "VC3_DYN"                      => [   1,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter dynamic value" ],
   "RSVD0"                        => [   2,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_LIMIT"                    => [   3,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "vc3 limit reg, zero disables functionality" ],
   "VC2_CAP"                      => [   4,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "vc2 counter captured value" ],
   "VC2_DYN"                      => [   5,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "vc2 counter dynamic value" ],
   "RSVD1"                        => [   6,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_LIMIT"                    => [   7,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "vc2 limit reg, zero disables functionality" ],
   "VC1_CAP"                      => [   8,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "vc1 counter captured value" ],
   "VC1_DYN"                      => [   9,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "vc1 counter dynamic value" ],
   "RSVD2"                        => [  10,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_LIMIT"                    => [  11,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "vc1 limit reg, zero disables functionality" ],
   "VC0_CAP"                      => [  12,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "vc0 counter captured value" ],
   "VC0_DYN"                      => [  13,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "vc0 counter dynamic value" ],
   "RSVD3"                        => [  14,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_LIMIT"                    => [  15,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "vc0 limit reg, zero disables functionality" ],
);

%orbit_01_00794_def =
( NAME    => "OC_XNNI0_PI_TAILTO",
  ADDRESS => 0x00000000d00304d0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00794_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI0_MD_TAILTO                                                   #
#                                                                        #
##########################################################################

%orbit_01_00795_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VC3_CAP"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter captured value" ],
   "VC3_DYN"                      => [   1,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter dynamic value" ],
   "RSVD0"                        => [   2,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_LIMIT"                    => [   3,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "vc3 limit reg, zero disables functionality" ],
   "VC2_CAP"                      => [   4,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "vc2 counter captured value" ],
   "VC2_DYN"                      => [   5,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "vc2 counter dynamic value" ],
   "RSVD1"                        => [   6,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_LIMIT"                    => [   7,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "vc2 limit reg, zero disables functionality" ],
   "VC1_CAP"                      => [   8,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "vc1 counter captured value" ],
   "VC1_DYN"                      => [   9,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "vc1 counter dynamic value" ],
   "RSVD2"                        => [  10,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_LIMIT"                    => [  11,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "vc1 limit reg, zero disables functionality" ],
   "VC0_CAP"                      => [  12,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "vc0 counter captured value" ],
   "VC0_DYN"                      => [  13,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "vc0 counter dynamic value" ],
   "RSVD3"                        => [  14,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_LIMIT"                    => [  15,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "vc0 limit reg, zero disables functionality" ],
);

%orbit_01_00795_def =
( NAME    => "OC_XNNI0_MD_TAILTO",
  ADDRESS => 0x00000000d00304e0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00795_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI0_DEADLCK_FLOW                                                #
#                                                                        #
##########################################################################

%orbit_01_00796_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VC3_CAP"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter captured value" ],
   "VC3_DYN"                      => [   1,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter dynamic value" ],
   "RSVD0"                        => [   2,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_LIMIT"                    => [   3,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "vc3 limit reg, zero disables functionality" ],
   "VC2_CAP"                      => [   4,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "vc2 counter captured value" ],
   "VC2_DYN"                      => [   5,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "vc2 counter dynamic value" ],
   "RSVD1"                        => [   6,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_LIMIT"                    => [   7,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "vc2 limit reg, zero disables functionality" ],
   "VC1_CAP"                      => [   8,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "vc1 counter captured value" ],
   "VC1_DYN"                      => [   9,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "vc1 counter dynamic value" ],
   "RSVD2"                        => [  10,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_LIMIT"                    => [  11,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "vc1 limit reg, zero disables functionality" ],
   "VC0_CAP"                      => [  12,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "vc0 counter captured value" ],
   "VC0_DYN"                      => [  13,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "vc0 counter dynamic value" ],
   "RSVD3"                        => [  14,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_LIMIT"                    => [  15,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "vc0 limit reg, zero disables functionality" ],
);

%orbit_01_00796_def =
( NAME    => "OC_XNNI0_DEADLCK_FLOW",
  ADDRESS => 0x00000000d0030500,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00796_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI0_DEADLCK_FLOW_SUPPORT                                        #
#                                                                        #
##########################################################################

%orbit_01_00797_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FLUSH_ENABLE"                 => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "flush enable" ],
);

%orbit_01_00797_def =
( NAME    => "OC_XNNI0_DEADLCK_FLOW_SUPPORT",
  ADDRESS => 0x00000000d0030510,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00797_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI0_INJECT_AGE                                                  #
#                                                                        #
##########################################################################

%orbit_01_00798_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REPLY_INJECT"                 => [   1,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Value of AGE field for outgoing replies" ],
   "REQUEST_INJECT"               => [   2,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Value of AGE field for outgoing requests" ],
);

%orbit_01_00798_def =
( NAME    => "OC_XNNI0_INJECT_AGE",
  ADDRESS => 0x00000000d0030520,
  NOTE    => "This register allows the age field of network bound messages coming note from the II, LB, and in the case of Orbit, the PI and M",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00798_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI0_NETWORK_AGE                                                 #
#                                                                        #
##########################################################################

%orbit_01_00799_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  49,  15, 0xFFFE000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FR_MMR_AGE_THRESHOLD_ENABLE"  => [   1,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "Age Threshold Request Enable" ],
   "FR_MMR_AGE_THRESHOLD"         => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "Age Threshold" ],
   "RSVD1"                        => [   3,  33,   7, 0x000000FE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FR_MMR_FREERUN_ENABLE"        => [   4,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "Freerun Counter Enable" ],
   "RSVD2"                        => [   5,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FR_MMR_MUX_SEL3"              => [   6,  24,   5, 0x000000001F000000, 0x00, 1, 0x0000000000000000, "Mux Select3" ],
   "RSVD3"                        => [   7,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FR_MMR_MUX_SEL2"              => [   8,  16,   5, 0x00000000001F0000, 0x00, 1, 0x0000000000000000, "Mux Select2" ],
   "RSVD4"                        => [   9,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FR_MMR_MUX_SEL1"              => [  10,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "Mux Select1" ],
   "RSVD5"                        => [  11,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FR_MMR_MUX_SEL0"              => [  12,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Mux Select0" ],
);

%orbit_01_00799_def =
( NAME    => "OC_XNNI0_NETWORK_AGE",
  ADDRESS => 0x00000000d0030530,
  NOTE    => "This register configures the Network Aging features of the XN. note There is one of these registers for each of the two NI ports",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00799_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI0_ARB_CONFIG                                                  #
#                                                                        #
##########################################################################

%orbit_01_00800_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_SYNC_BYPASS_IN"        => [   1,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Enable Bypass Mode" ],
   "EN_THROT_SRC3"                => [   2,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Enable throttling of MD requests" ],
   "EN_THROT_SRC2"                => [   3,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Enable throttling of PI requests" ],
   "EN_THROT_SRC1"                => [   4,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Enable throttling of other NI requests" ],
   "EN_THROT_SRC0"                => [   5,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable throttling of II and LB requests" ],
);

%orbit_01_00800_def =
( NAME    => "OC_XNNI0_ARB_CONFIG",
  ADDRESS => 0x00000000d0030540,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00800_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI0_LOCAL_AGE0                                                  #
#                                                                        #
##########################################################################

%orbit_01_00801_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "AGE_WRAP_SRC1_VC3"            => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "Other XN_NI VC3 Pre-Scale Value" ],
   "AGE_WRAP_SRC1_VC2"            => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Other XN_NI VC2 Pre-Scale Value" ],
   "AGE_WRAP_SRC1_VC1"            => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "Other XN_NI VC1 Pre-Scale Value" ],
   "AGE_WRAP_SRC1_VC0"            => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Other XN_NI VC0 Pre-Scale Value" ],
   "AGE_WRAP_SRC0_VC3"            => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "XN_IILB VC3 Pre-Scale Value" ],
   "AGE_WRAP_SRC0_VC2"            => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "XN_IILB VC2 Pre-Scale Value" ],
   "AGE_WRAP_SRC0_VC1"            => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "XN_IILB VC1 Pre-Scale Value" ],
   "AGE_WRAP_SRC0_VC0"            => [   7,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "XN_IILB VC0 Pre-Scale Value" ],
);

%orbit_01_00801_def =
( NAME    => "OC_XNNI0_LOCAL_AGE0",
  ADDRESS => 0x00000000d0030550,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00801_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI0_LOCAL_AGE1                                                  #
#                                                                        #
##########################################################################

%orbit_01_00802_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "AGE_WRAP_SRC3_VC3"            => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "XN_MD VC3 Pre-Scale Value" ],
   "AGE_WRAP_SRC3_VC2"            => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "XN_MD VC2 Pre-Scale Value" ],
   "AGE_WRAP_SRC3_VC1"            => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "XN_MD VC1 Pre-Scale Value" ],
   "AGE_WRAP_SRC3_VC0"            => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "XN_MD VC0 Pre-Scale Value" ],
   "AGE_WRAP_SRC2_VC3"            => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "XN_PI VC3 Pre-Scale Value" ],
   "AGE_WRAP_SRC2_VC2"            => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "XN_PI VC2 Pre-Scale Value" ],
   "AGE_WRAP_SRC2_VC1"            => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "XN_PI VC1 Pre-Scale Value" ],
   "AGE_WRAP_SRC2_VC0"            => [   7,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "XN_PI VC0 Pre-Scale Value" ],
);

%orbit_01_00802_def =
( NAME    => "OC_XNNI0_LOCAL_AGE1",
  ADDRESS => 0x00000000d0030560,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00802_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI0_QUEUE_CNTR                                                  #
#                                                                        #
##########################################################################

%orbit_01_00803_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LAST_USED_VC3"                => [   1,  56,   6, 0x3F00000000000000, 0x00, 1, 0x0000000000000000, "VC3 Queue Counter Last Value Used" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DYNAMIC_VC3"                  => [   3,  48,   6, 0x003F000000000000, 0x00, 1, 0x0000000000000000, "VC3 Dynamic Queue Counter Value" ],
   "RSVD2"                        => [   4,  46,   2, 0x0000C00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LAST_USED_VC2"                => [   5,  40,   6, 0x00003F0000000000, 0x00, 1, 0x0000000000000000, "VC2 Queue Counter Last Value Used" ],
   "RSVD3"                        => [   6,  38,   2, 0x000000C000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DYNAMIC_VC2"                  => [   7,  32,   6, 0x0000003F00000000, 0x00, 1, 0x0000000000000000, "VC2 Dynamic Queue Counter Value" ],
   "RSVD4"                        => [   8,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LAST_USED_VC1"                => [   9,  24,   6, 0x000000003F000000, 0x00, 1, 0x0000000000000000, "VC1 Queue Counter Last Value Used" ],
   "RSVD5"                        => [  10,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DYNAMIC_VC1"                  => [  11,  16,   6, 0x00000000003F0000, 0x00, 1, 0x0000000000000000, "VC1 Dynamic Queue Counter Value" ],
   "RSVD6"                        => [  12,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LAST_USED_VC0"                => [  13,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC0 Queue Counter Last Value Used" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DYNAMIC_VC0"                  => [  15,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 Dynamic Queue Counter Value" ],
);

%orbit_01_00803_def =
( NAME    => "OC_XNNI0_QUEUE_CNTR",
  ADDRESS => 0x00000000d0030570,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00803_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI1_TO_IILB_INTRA_FLOW_DEBIT                                     #
#                                                                        #
##########################################################################

%orbit_01_00804_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_FORCE_CRED"               => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_WITHHOLD"                 => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
   "VC0_FORCE_CRED"               => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_WITHHOLD"                 => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 withhold" ],
);

%orbit_01_00804_def =
( NAME    => "OC_XNNI1_TO_IILB_INTRA_FLOW_DEBIT",
  ADDRESS => 0x00000000d0030600,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00804_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI1_TO_PI_INTRA_FLOW_SIC_DEBIT_VC0                                     #
#                                                                        #
##########################################################################

%orbit_01_00805_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_CAP"                     => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 Data FIFO captured depth" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_DYN"                     => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 Data FIFO dynamic depth" ],
   "RSVD2"                        => [   4,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_CAP"                      => [   5,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VC0 Header FIFO captured depth" ],
   "RSVD3"                        => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_DYN"                      => [   7,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VC0 Header FIFO dynamic depth" ],
   "FORCE_CRED"                   => [   8,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD4"                        => [   9,   5,   2, 0x0000000000000060, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WITHHOLD"                     => [  10,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%orbit_01_00805_def =
( NAME    => "OC_XNNI1_TO_PI_INTRA_FLOW_SIC_DEBIT_VC0",
  ADDRESS => 0x00000000d0030610,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00805_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI1_TO_PI_INTRA_FLOW_SIC_DEBIT_VC2                                     #
#                                                                        #
##########################################################################

%orbit_01_00806_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_CAP"                     => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC2 Data FIFO captured depth" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_DYN"                     => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC2 Data FIFO dynamic depth" ],
   "RSVD2"                        => [   4,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_CAP"                      => [   5,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VC2 Header FIFO captured depth" ],
   "RSVD3"                        => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_DYN"                      => [   7,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VC2 Header FIFO dynamic depth" ],
   "FORCE_CRED"                   => [   8,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD4"                        => [   9,   5,   2, 0x0000000000000060, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WITHHOLD"                     => [  10,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
);

%orbit_01_00806_def =
( NAME    => "OC_XNNI1_TO_PI_INTRA_FLOW_SIC_DEBIT_VC2",
  ADDRESS => 0x00000000d0030620,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00806_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI1_TO_MD_INTRA_FLOW_SIC_DEBIT_VC0                                     #
#                                                                        #
##########################################################################

%orbit_01_00807_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_CAP"                     => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 Data FIFO captured depth" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_DYN"                     => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 Data FIFO dynamic depth" ],
   "RSVD2"                        => [   4,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_CAP"                      => [   5,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VC0 Header FIFO captured depth" ],
   "RSVD3"                        => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_DYN"                      => [   7,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VC0 Header FIFO dynamic depth" ],
   "FORCE_CRED"                   => [   8,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD4"                        => [   9,   5,   2, 0x0000000000000060, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WITHHOLD"                     => [  10,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%orbit_01_00807_def =
( NAME    => "OC_XNNI1_TO_MD_INTRA_FLOW_SIC_DEBIT_VC0",
  ADDRESS => 0x00000000d0030630,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00807_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI1_TO_MD_INTRA_FLOW_SIC_DEBIT_VC2                                     #
#                                                                        #
##########################################################################

%orbit_01_00808_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_CAP"                     => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC2 Data FIFO captured depth" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_DYN"                     => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC2 Data FIFO dynamic depth" ],
   "RSVD2"                        => [   4,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_CAP"                      => [   5,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VC2 Header FIFO captured depth" ],
   "RSVD3"                        => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_DYN"                      => [   7,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VC2 Header FIFO dynamic depth" ],
   "FORCE_CRED"                   => [   8,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD4"                        => [   9,   5,   2, 0x0000000000000060, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WITHHOLD"                     => [  10,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
);

%orbit_01_00808_def =
( NAME    => "OC_XNNI1_TO_MD_INTRA_FLOW_SIC_DEBIT_VC2",
  ADDRESS => 0x00000000d0030640,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00808_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI1_0_INTRANI_FLOW                                              #
#                                                                        #
##########################################################################

%orbit_01_00809_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,   8,  16, 0x0000000000FFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_FORCE_CRED"         => [   5,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD3"                        => [   6,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [   7,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%orbit_01_00809_def =
( NAME    => "OC_XNNI1_0_INTRANI_FLOW",
  ADDRESS => 0x00000000d0030650,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00809_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI1_1_INTRANI_FLOW                                              #
#                                                                        #
##########################################################################

%orbit_01_00810_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_CAP"                      => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_DYN"                      => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,   8,  16, 0x0000000000FFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_FORCE_CRED"         => [   5,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC1" ],
   "RSVD3"                        => [   6,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_WITHHOLD"           => [   7,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC1 Withhold" ],
);

%orbit_01_00810_def =
( NAME    => "OC_XNNI1_1_INTRANI_FLOW",
  ADDRESS => 0x00000000d0030660,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00810_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI1_2_INTRANI_FLOW                                              #
#                                                                        #
##########################################################################

%orbit_01_00811_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,   8,  16, 0x0000000000FFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_FORCE_CRED"         => [   5,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD3"                        => [   6,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [   7,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
);

%orbit_01_00811_def =
( NAME    => "OC_XNNI1_2_INTRANI_FLOW",
  ADDRESS => 0x00000000d0030670,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00811_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI1_3_INTRANI_FLOW                                              #
#                                                                        #
##########################################################################

%orbit_01_00812_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_CAP"                      => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_DYN"                      => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,   8,  16, 0x0000000000FFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_FORCE_CRED"         => [   5,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC3" ],
   "RSVD3"                        => [   6,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_WITHHOLD"           => [   7,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC3 Withhold" ],
);

%orbit_01_00812_def =
( NAME    => "OC_XNNI1_3_INTRANI_FLOW",
  ADDRESS => 0x00000000d0030680,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00812_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI1_VCSWITCH_FLOW                                               #
#                                                                        #
##########################################################################

%orbit_01_00813_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  25,  39, 0xFFFFFFFFFE000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_VCFIFO_SWITCH"           => [   1,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Select VC0/2 or VC1/3 for IILB" ],
   "RSVD1"                        => [   2,  17,   7, 0x0000000000FE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MD_VCFIFO_SWITCH"             => [   3,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Select VC0/2 or VC1/3 for MD" ],
   "RSVD2"                        => [   4,   9,   7, 0x000000000000FE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PI_VCFIFO_SWITCH"             => [   5,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Select VC0/2 or VC1/3 for PI" ],
   "RSVD3"                        => [   6,   1,   7, 0x00000000000000FE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_VCFIFO_DATELINE_SWITCH"    => [   7,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Swap VC0/2 with VC1/3" ],
);

%orbit_01_00813_def =
( NAME    => "OC_XNNI1_VCSWITCH_FLOW",
  ADDRESS => 0x00000000d0030690,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00813_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI1_TIMER_REG                                                   #
#                                                                        #
##########################################################################

%orbit_01_00814_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "QUEUECNTENABLE_REG"           => [   1,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "Queue Counter Enable" ],
   "LINKRESETENABLE_REG"          => [   2,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "Link Reset Enable" ],
   "LINKCLEANUP_REG"              => [   3,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "Link Clean Up" ],
   "RSVD1"                        => [   4,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIMEOUT_REG"                  => [   5,   0,  24, 0x0000000000FFFFFF, 0x00, 1, 0x0000000000000000, "Master Timeout Counter" ],
);

%orbit_01_00814_def =
( NAME    => "OC_XNNI1_TIMER_REG",
  ADDRESS => 0x00000000d00306a0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00814_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI1_IILB_TAILTO                                                 #
#                                                                        #
##########################################################################

%orbit_01_00815_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VC3_CAP"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter captured value" ],
   "VC3_DYN"                      => [   1,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter dynamic value" ],
   "RSVD0"                        => [   2,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_LIMIT"                    => [   3,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "vc3 limit reg, zero disables functionality" ],
   "VC2_CAP"                      => [   4,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "vc2 counter captured value" ],
   "VC2_DYN"                      => [   5,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "vc2 counter dynamic value" ],
   "RSVD1"                        => [   6,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_LIMIT"                    => [   7,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "vc2 limit reg, zero disables functionality" ],
   "VC1_CAP"                      => [   8,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "vc1 counter captured value" ],
   "VC1_DYN"                      => [   9,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "vc1 counter dynamic value" ],
   "RSVD2"                        => [  10,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_LIMIT"                    => [  11,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "vc1 limit reg, zero disables functionality" ],
   "VC0_CAP"                      => [  12,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "vc0 counter captured value" ],
   "VC0_DYN"                      => [  13,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "vc0 counter dynamic value" ],
   "RSVD3"                        => [  14,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_LIMIT"                    => [  15,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "vc0 limit reg, zero disables functionality" ],
);

%orbit_01_00815_def =
( NAME    => "OC_XNNI1_IILB_TAILTO",
  ADDRESS => 0x00000000d00306b0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00815_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI1_NI_TAILTO                                                   #
#                                                                        #
##########################################################################

%orbit_01_00816_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VC3_CAP"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter captured value" ],
   "VC3_DYN"                      => [   1,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter dynamic value" ],
   "RSVD0"                        => [   2,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_LIMIT"                    => [   3,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "vc3 limit reg, zero disables functionality" ],
   "VC2_CAP"                      => [   4,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "vc2 counter captured value" ],
   "VC2_DYN"                      => [   5,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "vc2 counter dynamic value" ],
   "RSVD1"                        => [   6,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_LIMIT"                    => [   7,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "vc2 limit reg, zero disables functionality" ],
   "VC1_CAP"                      => [   8,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "vc1 counter captured value" ],
   "VC1_DYN"                      => [   9,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "vc1 counter dynamic value" ],
   "RSVD2"                        => [  10,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_LIMIT"                    => [  11,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "vc1 limit reg, zero disables functionality" ],
   "VC0_CAP"                      => [  12,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "vc0 counter captured value" ],
   "VC0_DYN"                      => [  13,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "vc0 counter dynamic value" ],
   "RSVD3"                        => [  14,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_LIMIT"                    => [  15,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "vc0 limit reg, zero disables functionality" ],
);

%orbit_01_00816_def =
( NAME    => "OC_XNNI1_NI_TAILTO",
  ADDRESS => 0x00000000d00306c0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00816_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI1_NI_TAILTO_SUPPORT                                           #
#                                                                        #
##########################################################################

%orbit_01_00817_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INJECT_TAIL_ENABLE"           => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "" ],
);

%orbit_01_00817_def =
( NAME    => "OC_XNNI1_NI_TAILTO_SUPPORT",
  ADDRESS => 0x00000000d00306f0,
  NOTE    => "This register adds a 'tail injection' feature to the basic Tail note Timeout functionality. If enabled, when a Tail Timeout Limi",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00817_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI1_PI_TAILTO                                                   #
#                                                                        #
##########################################################################

%orbit_01_00818_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VC3_CAP"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter captured value" ],
   "VC3_DYN"                      => [   1,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter dynamic value" ],
   "RSVD0"                        => [   2,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_LIMIT"                    => [   3,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "vc3 limit reg, zero disables functionality" ],
   "VC2_CAP"                      => [   4,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "vc2 counter captured value" ],
   "VC2_DYN"                      => [   5,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "vc2 counter dynamic value" ],
   "RSVD1"                        => [   6,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_LIMIT"                    => [   7,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "vc2 limit reg, zero disables functionality" ],
   "VC1_CAP"                      => [   8,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "vc1 counter captured value" ],
   "VC1_DYN"                      => [   9,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "vc1 counter dynamic value" ],
   "RSVD2"                        => [  10,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_LIMIT"                    => [  11,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "vc1 limit reg, zero disables functionality" ],
   "VC0_CAP"                      => [  12,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "vc0 counter captured value" ],
   "VC0_DYN"                      => [  13,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "vc0 counter dynamic value" ],
   "RSVD3"                        => [  14,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_LIMIT"                    => [  15,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "vc0 limit reg, zero disables functionality" ],
);

%orbit_01_00818_def =
( NAME    => "OC_XNNI1_PI_TAILTO",
  ADDRESS => 0x00000000d00306d0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00818_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI1_MD_TAILTO                                                   #
#                                                                        #
##########################################################################

%orbit_01_00819_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VC3_CAP"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter captured value" ],
   "VC3_DYN"                      => [   1,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter dynamic value" ],
   "RSVD0"                        => [   2,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_LIMIT"                    => [   3,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "vc3 limit reg, zero disables functionality" ],
   "VC2_CAP"                      => [   4,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "vc2 counter captured value" ],
   "VC2_DYN"                      => [   5,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "vc2 counter dynamic value" ],
   "RSVD1"                        => [   6,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_LIMIT"                    => [   7,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "vc2 limit reg, zero disables functionality" ],
   "VC1_CAP"                      => [   8,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "vc1 counter captured value" ],
   "VC1_DYN"                      => [   9,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "vc1 counter dynamic value" ],
   "RSVD2"                        => [  10,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_LIMIT"                    => [  11,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "vc1 limit reg, zero disables functionality" ],
   "VC0_CAP"                      => [  12,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "vc0 counter captured value" ],
   "VC0_DYN"                      => [  13,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "vc0 counter dynamic value" ],
   "RSVD3"                        => [  14,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_LIMIT"                    => [  15,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "vc0 limit reg, zero disables functionality" ],
);

%orbit_01_00819_def =
( NAME    => "OC_XNNI1_MD_TAILTO",
  ADDRESS => 0x00000000d00306e0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00819_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI1_DEADLCK_FLOW                                                #
#                                                                        #
##########################################################################

%orbit_01_00820_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VC3_CAP"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter captured value" ],
   "VC3_DYN"                      => [   1,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter dynamic value" ],
   "RSVD0"                        => [   2,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_LIMIT"                    => [   3,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "vc3 limit reg, zero disables functionality" ],
   "VC2_CAP"                      => [   4,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "vc2 counter captured value" ],
   "VC2_DYN"                      => [   5,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "vc2 counter dynamic value" ],
   "RSVD1"                        => [   6,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_LIMIT"                    => [   7,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "vc2 limit reg, zero disables functionality" ],
   "VC1_CAP"                      => [   8,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "vc1 counter captured value" ],
   "VC1_DYN"                      => [   9,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "vc1 counter dynamic value" ],
   "RSVD2"                        => [  10,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_LIMIT"                    => [  11,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "vc1 limit reg, zero disables functionality" ],
   "VC0_CAP"                      => [  12,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "vc0 counter captured value" ],
   "VC0_DYN"                      => [  13,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "vc0 counter dynamic value" ],
   "RSVD3"                        => [  14,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_LIMIT"                    => [  15,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "vc0 limit reg, zero disables functionality" ],
);

%orbit_01_00820_def =
( NAME    => "OC_XNNI1_DEADLCK_FLOW",
  ADDRESS => 0x00000000d0030700,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00820_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI1_DEADLCK_FLOW_SUPPORT                                        #
#                                                                        #
##########################################################################

%orbit_01_00821_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FLUSH_ENABLE"                 => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "flush enable" ],
);

%orbit_01_00821_def =
( NAME    => "OC_XNNI1_DEADLCK_FLOW_SUPPORT",
  ADDRESS => 0x00000000d0030710,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00821_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI1_INJECT_AGE                                                  #
#                                                                        #
##########################################################################

%orbit_01_00822_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REPLY_INJECT"                 => [   1,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Value of AGE field for outgoing replies" ],
   "REQUEST_INJECT"               => [   2,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Value of AGE field for outgoing requests" ],
);

%orbit_01_00822_def =
( NAME    => "OC_XNNI1_INJECT_AGE",
  ADDRESS => 0x00000000d0030720,
  NOTE    => "This register allows the age field of network bound messages coming note from the II, LB, and in the case of Orbit, the PI and M",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00822_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI1_NETWORK_AGE                                                 #
#                                                                        #
##########################################################################

%orbit_01_00823_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  49,  15, 0xFFFE000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FR_MMR_AGE_THRESHOLD_ENABLE"  => [   1,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "Age Threshold Request Enable" ],
   "FR_MMR_AGE_THRESHOLD"         => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "Age Threshold" ],
   "RSVD1"                        => [   3,  33,   7, 0x000000FE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FR_MMR_FREERUN_ENABLE"        => [   4,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "Freerun Counter Enable" ],
   "RSVD2"                        => [   5,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FR_MMR_MUX_SEL3"              => [   6,  24,   5, 0x000000001F000000, 0x00, 1, 0x0000000000000000, "Mux Select3" ],
   "RSVD3"                        => [   7,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FR_MMR_MUX_SEL2"              => [   8,  16,   5, 0x00000000001F0000, 0x00, 1, 0x0000000000000000, "Mux Select2" ],
   "RSVD4"                        => [   9,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FR_MMR_MUX_SEL1"              => [  10,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "Mux Select1" ],
   "RSVD5"                        => [  11,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FR_MMR_MUX_SEL0"              => [  12,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Mux Select0" ],
);

%orbit_01_00823_def =
( NAME    => "OC_XNNI1_NETWORK_AGE",
  ADDRESS => 0x00000000d0030730,
  NOTE    => "This register configures the Network Aging features of the XN. note There is one of these registers for each of the two NI ports",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00823_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI1_ARB_CONFIG                                                  #
#                                                                        #
##########################################################################

%orbit_01_00824_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_SYNC_BYPASS_IN"        => [   1,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Enable Bypass Mode" ],
   "EN_THROT_SRC3"                => [   2,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Enable throttling of MD requests" ],
   "EN_THROT_SRC2"                => [   3,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Enable throttling of PI requests" ],
   "EN_THROT_SRC1"                => [   4,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Enable throttling of other NI requests" ],
   "EN_THROT_SRC0"                => [   5,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable throttling of II and LB requests" ],
);

%orbit_01_00824_def =
( NAME    => "OC_XNNI1_ARB_CONFIG",
  ADDRESS => 0x00000000d0030740,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00824_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI1_LOCAL_AGE0                                                  #
#                                                                        #
##########################################################################

%orbit_01_00825_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "AGE_WRAP_SRC1_VC3"            => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "Other XN_NI VC3 Pre-Scale Value" ],
   "AGE_WRAP_SRC1_VC2"            => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Other XN_NI VC2 Pre-Scale Value" ],
   "AGE_WRAP_SRC1_VC1"            => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "Other XN_NI VC1 Pre-Scale Value" ],
   "AGE_WRAP_SRC1_VC0"            => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Other XN_NI VC0 Pre-Scale Value" ],
   "AGE_WRAP_SRC0_VC3"            => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "XN_IILB VC3 Pre-Scale Value" ],
   "AGE_WRAP_SRC0_VC2"            => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "XN_IILB VC2 Pre-Scale Value" ],
   "AGE_WRAP_SRC0_VC1"            => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "XN_IILB VC1 Pre-Scale Value" ],
   "AGE_WRAP_SRC0_VC0"            => [   7,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "XN_IILB VC0 Pre-Scale Value" ],
);

%orbit_01_00825_def =
( NAME    => "OC_XNNI1_LOCAL_AGE0",
  ADDRESS => 0x00000000d0030750,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00825_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI1_LOCAL_AGE1                                                  #
#                                                                        #
##########################################################################

%orbit_01_00826_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "AGE_WRAP_SRC3_VC3"            => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "XN_MD VC3 Pre-Scale Value" ],
   "AGE_WRAP_SRC3_VC2"            => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "XN_MD VC2 Pre-Scale Value" ],
   "AGE_WRAP_SRC3_VC1"            => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "XN_MD VC1 Pre-Scale Value" ],
   "AGE_WRAP_SRC3_VC0"            => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "XN_MD VC0 Pre-Scale Value" ],
   "AGE_WRAP_SRC2_VC3"            => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "XN_PI VC3 Pre-Scale Value" ],
   "AGE_WRAP_SRC2_VC2"            => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "XN_PI VC2 Pre-Scale Value" ],
   "AGE_WRAP_SRC2_VC1"            => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "XN_PI VC1 Pre-Scale Value" ],
   "AGE_WRAP_SRC2_VC0"            => [   7,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "XN_PI VC0 Pre-Scale Value" ],
);

%orbit_01_00826_def =
( NAME    => "OC_XNNI1_LOCAL_AGE1",
  ADDRESS => 0x00000000d0030760,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00826_flds
);


##########################################################################
#                                                                        #
#   OC_XNNI1_QUEUE_CNTR                                                  #
#                                                                        #
##########################################################################

%orbit_01_00827_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LAST_USED_VC3"                => [   1,  56,   6, 0x3F00000000000000, 0x00, 1, 0x0000000000000000, "VC3 Queue Counter Last Value Used" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DYNAMIC_VC3"                  => [   3,  48,   6, 0x003F000000000000, 0x00, 1, 0x0000000000000000, "VC3 Dynamic Queue Counter Value" ],
   "RSVD2"                        => [   4,  46,   2, 0x0000C00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LAST_USED_VC2"                => [   5,  40,   6, 0x00003F0000000000, 0x00, 1, 0x0000000000000000, "VC2 Queue Counter Last Value Used" ],
   "RSVD3"                        => [   6,  38,   2, 0x000000C000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DYNAMIC_VC2"                  => [   7,  32,   6, 0x0000003F00000000, 0x00, 1, 0x0000000000000000, "VC2 Dynamic Queue Counter Value" ],
   "RSVD4"                        => [   8,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LAST_USED_VC1"                => [   9,  24,   6, 0x000000003F000000, 0x00, 1, 0x0000000000000000, "VC1 Queue Counter Last Value Used" ],
   "RSVD5"                        => [  10,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DYNAMIC_VC1"                  => [  11,  16,   6, 0x00000000003F0000, 0x00, 1, 0x0000000000000000, "VC1 Dynamic Queue Counter Value" ],
   "RSVD6"                        => [  12,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LAST_USED_VC0"                => [  13,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC0 Queue Counter Last Value Used" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DYNAMIC_VC0"                  => [  15,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 Dynamic Queue Counter Value" ],
);

%orbit_01_00827_def =
( NAME    => "OC_XNNI1_QUEUE_CNTR",
  ADDRESS => 0x00000000d0030770,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00827_flds
);


##########################################################################
#                                                                        #
#   OC_XN_DEBUG_SEL                                                      #
#                                                                        #
##########################################################################

%orbit_01_00828_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TRIGGER_ENABLE"               => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Enable trigger on bit 32 of Analyzer data" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD0"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_RLM_SEL"              => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 RLM select" ],
   "RSVD1"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD2"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_RLM_SEL"              => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 RLM select" ],
   "RSVD3"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD4"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_RLM_SEL"              => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 RLM select" ],
   "RSVD5"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD6"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_RLM_SEL"              => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 RLM select" ],
   "RSVD7"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD8"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_RLM_SEL"              => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 RLM select" ],
   "RSVD9"                        => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD10"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_RLM_SEL"              => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 RLM select" ],
   "RSVD11"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD12"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_RLM_SEL"              => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 RLM select" ],
   "RSVD13"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD14"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_RLM_SEL"              => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 RLM select" ],
);

%orbit_01_00828_def =
( NAME    => "OC_XN_DEBUG_SEL",
  ADDRESS => 0x00000000d0031000,
  NOTE    => "XN Debug Port Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00828_flds
);


##########################################################################
#                                                                        #
#   OC_XN_DEBUG_TRIG_SEL                                                 #
#                                                                        #
##########################################################################

%orbit_01_00829_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_NIBBLE_SEL"          => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_RLM_SEL"             => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 RLM select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_NIBBLE_SEL"          => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_RLM_SEL"             => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 RLM select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_NIBBLE_SEL"          => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_RLM_SEL"             => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 RLM select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_NIBBLE_SEL"          => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_RLM_SEL"             => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 RLM select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_NIBBLE_SEL"          => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_RLM_SEL"             => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 RLM select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_NIBBLE_SEL"          => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_RLM_SEL"             => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 RLM select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_NIBBLE_SEL"          => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_RLM_SEL"             => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 RLM select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_NIBBLE_SEL"          => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_RLM_SEL"             => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 RLM select" ],
);

%orbit_01_00829_def =
( NAME    => "OC_XN_DEBUG_TRIG_SEL",
  ADDRESS => 0x00000000d0031020,
  NOTE    => "XN Debug trigger Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00829_flds
);


##########################################################################
#                                                                        #
#   OC_XN_TRIGGER_COMPARE                                                #
#                                                                        #
##########################################################################

%orbit_01_00830_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MASK"                         => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Mask to select Debug bits for trigger generation" ],
);

%orbit_01_00830_def =
( NAME    => "OC_XN_TRIGGER_COMPARE",
  ADDRESS => 0x00000000d0031040,
  NOTE    => "XN Debug Compare",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00830_flds
);


##########################################################################
#                                                                        #
#   OC_XN_TRIGGER_DATA                                                   #
#                                                                        #
##########################################################################

%orbit_01_00831_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COMPARE_PATTERN"              => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "debug bit pattern for trigger generation" ],
);

%orbit_01_00831_def =
( NAME    => "OC_XN_TRIGGER_DATA",
  ADDRESS => 0x00000000d0031050,
  NOTE    => "XN Debug Compare Data",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00831_flds
);


##########################################################################
#                                                                        #
#   OC_XN_IILB_DEBUG_SEL                                                 #
#                                                                        #
##########################################################################

%orbit_01_00832_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_INPUT_SEL"            => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 input select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_INPUT_SEL"            => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 input select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_INPUT_SEL"            => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 input select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_INPUT_SEL"            => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 input select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_INPUT_SEL"            => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 input select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_INPUT_SEL"            => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 input select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_INPUT_SEL"            => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 input select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_INPUT_SEL"            => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 input select" ],
);

%orbit_01_00832_def =
( NAME    => "OC_XN_IILB_DEBUG_SEL",
  ADDRESS => 0x00000000d0031060,
  NOTE    => "XN IILB Debug Port Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00832_flds
);


##########################################################################
#                                                                        #
#   OC_XN_IILB_LB_CMP_EXP_DATA0                                          #
#                                                                        #
##########################################################################

%orbit_01_00833_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%orbit_01_00833_def =
( NAME    => "OC_XN_IILB_LB_CMP_EXP_DATA0",
  ADDRESS => 0x00000000d0031100,
  NOTE    => "IILB compare LB input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00833_flds
);


##########################################################################
#                                                                        #
#   OC_XN_IILB_LB_CMP_EXP_DATA1                                          #
#                                                                        #
##########################################################################

%orbit_01_00834_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%orbit_01_00834_def =
( NAME    => "OC_XN_IILB_LB_CMP_EXP_DATA1",
  ADDRESS => 0x00000000d0031110,
  NOTE    => "IILB compare LB input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00834_flds
);


##########################################################################
#                                                                        #
#   OC_XN_IILB_LB_CMP_ENABLE0                                            #
#                                                                        #
##########################################################################

%orbit_01_00835_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%orbit_01_00835_def =
( NAME    => "OC_XN_IILB_LB_CMP_ENABLE0",
  ADDRESS => 0x00000000d0031120,
  NOTE    => "IILB compare LB input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00835_flds
);


##########################################################################
#                                                                        #
#   OC_XN_IILB_LB_CMP_ENABLE1                                            #
#                                                                        #
##########################################################################

%orbit_01_00836_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%orbit_01_00836_def =
( NAME    => "OC_XN_IILB_LB_CMP_ENABLE1",
  ADDRESS => 0x00000000d0031130,
  NOTE    => "IILB compare LB input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00836_flds
);


##########################################################################
#                                                                        #
#   OC_XN_IILB_II_CMP_EXP_DATA0                                          #
#                                                                        #
##########################################################################

%orbit_01_00837_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%orbit_01_00837_def =
( NAME    => "OC_XN_IILB_II_CMP_EXP_DATA0",
  ADDRESS => 0x00000000d0031140,
  NOTE    => "IILB compare II input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00837_flds
);


##########################################################################
#                                                                        #
#   OC_XN_IILB_II_CMP_EXP_DATA1                                          #
#                                                                        #
##########################################################################

%orbit_01_00838_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%orbit_01_00838_def =
( NAME    => "OC_XN_IILB_II_CMP_EXP_DATA1",
  ADDRESS => 0x00000000d0031150,
  NOTE    => "IILB compare II input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00838_flds
);


##########################################################################
#                                                                        #
#   OC_XN_IILB_II_CMP_ENABLE0                                            #
#                                                                        #
##########################################################################

%orbit_01_00839_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%orbit_01_00839_def =
( NAME    => "OC_XN_IILB_II_CMP_ENABLE0",
  ADDRESS => 0x00000000d0031160,
  NOTE    => "IILB compare II input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00839_flds
);


##########################################################################
#                                                                        #
#   OC_XN_IILB_II_CMP_ENABLE1                                            #
#                                                                        #
##########################################################################

%orbit_01_00840_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%orbit_01_00840_def =
( NAME    => "OC_XN_IILB_II_CMP_ENABLE1",
  ADDRESS => 0x00000000d0031170,
  NOTE    => "IILB compare II input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00840_flds
);


##########################################################################
#                                                                        #
#   OC_XN_IILB_MD_HDR_CMP_EXP_DATA0                                      #
#                                                                        #
##########################################################################

%orbit_01_00841_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%orbit_01_00841_def =
( NAME    => "OC_XN_IILB_MD_HDR_CMP_EXP_DATA0",
  ADDRESS => 0x00000000d0031200,
  NOTE    => "IILB compare MD hdr input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00841_flds
);


##########################################################################
#                                                                        #
#   OC_XN_IILB_MD_HDR_CMP_EXP_DATA1                                      #
#                                                                        #
##########################################################################

%orbit_01_00842_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%orbit_01_00842_def =
( NAME    => "OC_XN_IILB_MD_HDR_CMP_EXP_DATA1",
  ADDRESS => 0x00000000d0031210,
  NOTE    => "IILB compare MD hdr input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00842_flds
);


##########################################################################
#                                                                        #
#   OC_XN_IILB_MD_HDR_CMP_ENABLE0                                        #
#                                                                        #
##########################################################################

%orbit_01_00843_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%orbit_01_00843_def =
( NAME    => "OC_XN_IILB_MD_HDR_CMP_ENABLE0",
  ADDRESS => 0x00000000d0031220,
  NOTE    => "IILB compare MD hdr input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00843_flds
);


##########################################################################
#                                                                        #
#   OC_XN_IILB_MD_HDR_CMP_ENABLE1                                        #
#                                                                        #
##########################################################################

%orbit_01_00844_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%orbit_01_00844_def =
( NAME    => "OC_XN_IILB_MD_HDR_CMP_ENABLE1",
  ADDRESS => 0x00000000d0031230,
  NOTE    => "IILB compare MD hdr input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00844_flds
);


##########################################################################
#                                                                        #
#   OC_XN_IILB_PI_CMP_EXP_DATA0                                          #
#                                                                        #
##########################################################################

%orbit_01_00845_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%orbit_01_00845_def =
( NAME    => "OC_XN_IILB_PI_CMP_EXP_DATA0",
  ADDRESS => 0x00000000d0031240,
  NOTE    => "IILB compare PI input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00845_flds
);


##########################################################################
#                                                                        #
#   OC_XN_IILB_PI_CMP_EXP_DATA1                                          #
#                                                                        #
##########################################################################

%orbit_01_00846_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%orbit_01_00846_def =
( NAME    => "OC_XN_IILB_PI_CMP_EXP_DATA1",
  ADDRESS => 0x00000000d0031250,
  NOTE    => "IILB compare PI input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00846_flds
);


##########################################################################
#                                                                        #
#   OC_XN_IILB_PI_CMP_ENABLE0                                            #
#                                                                        #
##########################################################################

%orbit_01_00847_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%orbit_01_00847_def =
( NAME    => "OC_XN_IILB_PI_CMP_ENABLE0",
  ADDRESS => 0x00000000d0031260,
  NOTE    => "IILB compare PI input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00847_flds
);


##########################################################################
#                                                                        #
#   OC_XN_IILB_PI_CMP_ENABLE1                                            #
#                                                                        #
##########################################################################

%orbit_01_00848_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%orbit_01_00848_def =
( NAME    => "OC_XN_IILB_PI_CMP_ENABLE1",
  ADDRESS => 0x00000000d0031270,
  NOTE    => "IILB compare PI input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00848_flds
);


##########################################################################
#                                                                        #
#   OC_XN_IILB_NI0_CMP_EXP_DATA0                                         #
#                                                                        #
##########################################################################

%orbit_01_00849_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%orbit_01_00849_def =
( NAME    => "OC_XN_IILB_NI0_CMP_EXP_DATA0",
  ADDRESS => 0x00000000d0031280,
  NOTE    => "IILB compare NI0 input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00849_flds
);


##########################################################################
#                                                                        #
#   OC_XN_IILB_NI0_CMP_EXP_DATA1                                         #
#                                                                        #
##########################################################################

%orbit_01_00850_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%orbit_01_00850_def =
( NAME    => "OC_XN_IILB_NI0_CMP_EXP_DATA1",
  ADDRESS => 0x00000000d0031290,
  NOTE    => "IILB compare NI0 input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00850_flds
);


##########################################################################
#                                                                        #
#   OC_XN_IILB_NI0_CMP_ENABLE0                                           #
#                                                                        #
##########################################################################

%orbit_01_00851_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%orbit_01_00851_def =
( NAME    => "OC_XN_IILB_NI0_CMP_ENABLE0",
  ADDRESS => 0x00000000d00312a0,
  NOTE    => "IILB compare NI0 input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00851_flds
);


##########################################################################
#                                                                        #
#   OC_XN_IILB_NI0_CMP_ENABLE1                                           #
#                                                                        #
##########################################################################

%orbit_01_00852_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%orbit_01_00852_def =
( NAME    => "OC_XN_IILB_NI0_CMP_ENABLE1",
  ADDRESS => 0x00000000d00312b0,
  NOTE    => "IILB compare NI0 input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00852_flds
);


##########################################################################
#                                                                        #
#   OC_XN_IILB_NI1_CMP_EXP_DATA0                                         #
#                                                                        #
##########################################################################

%orbit_01_00853_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%orbit_01_00853_def =
( NAME    => "OC_XN_IILB_NI1_CMP_EXP_DATA0",
  ADDRESS => 0x00000000d00312c0,
  NOTE    => "IILB compare NI1 input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00853_flds
);


##########################################################################
#                                                                        #
#   OC_XN_IILB_NI1_CMP_EXP_DATA1                                         #
#                                                                        #
##########################################################################

%orbit_01_00854_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%orbit_01_00854_def =
( NAME    => "OC_XN_IILB_NI1_CMP_EXP_DATA1",
  ADDRESS => 0x00000000d00312d0,
  NOTE    => "IILB compare NI1 input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00854_flds
);


##########################################################################
#                                                                        #
#   OC_XN_IILB_NI1_CMP_ENABLE0                                           #
#                                                                        #
##########################################################################

%orbit_01_00855_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%orbit_01_00855_def =
( NAME    => "OC_XN_IILB_NI1_CMP_ENABLE0",
  ADDRESS => 0x00000000d00312e0,
  NOTE    => "IILB compare NI1 input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00855_flds
);


##########################################################################
#                                                                        #
#   OC_XN_IILB_NI1_CMP_ENABLE1                                           #
#                                                                        #
##########################################################################

%orbit_01_00856_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%orbit_01_00856_def =
( NAME    => "OC_XN_IILB_NI1_CMP_ENABLE1",
  ADDRESS => 0x00000000d00312f0,
  NOTE    => "IILB compare NI1 input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00856_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI0_DEBUG_SEL                                                  #
#                                                                        #
##########################################################################

%orbit_01_00857_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_INPUT_SEL"            => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 input select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_INPUT_SEL"            => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 input select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_INPUT_SEL"            => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 input select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_INPUT_SEL"            => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 input select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_INPUT_SEL"            => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 input select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_INPUT_SEL"            => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 input select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_INPUT_SEL"            => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 input select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_INPUT_SEL"            => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 input select" ],
);

%orbit_01_00857_def =
( NAME    => "OC_XN_NI0_DEBUG_SEL",
  ADDRESS => 0x00000000d00310c0,
  NOTE    => "XN NI0 Debug Port Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00857_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI0_IILB_CMP_EXP_DATA0                                         #
#                                                                        #
##########################################################################

%orbit_01_00858_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%orbit_01_00858_def =
( NAME    => "OC_XN_NI0_IILB_CMP_EXP_DATA0",
  ADDRESS => 0x00000000d0031700,
  NOTE    => "NI0 compare IILB input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00858_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI0_IILB_CMP_EXP_DATA1                                         #
#                                                                        #
##########################################################################

%orbit_01_00859_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%orbit_01_00859_def =
( NAME    => "OC_XN_NI0_IILB_CMP_EXP_DATA1",
  ADDRESS => 0x00000000d0031710,
  NOTE    => "NI0 compare IILB input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00859_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI0_IILB_CMP_ENABLE0                                           #
#                                                                        #
##########################################################################

%orbit_01_00860_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%orbit_01_00860_def =
( NAME    => "OC_XN_NI0_IILB_CMP_ENABLE0",
  ADDRESS => 0x00000000d0031720,
  NOTE    => "NI0 compare IILB input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00860_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI0_IILB_CMP_ENABLE1                                           #
#                                                                        #
##########################################################################

%orbit_01_00861_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%orbit_01_00861_def =
( NAME    => "OC_XN_NI0_IILB_CMP_ENABLE1",
  ADDRESS => 0x00000000d0031730,
  NOTE    => "NI0 compare IILB input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00861_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI0_PI_CMP_EXP_DATA0                                           #
#                                                                        #
##########################################################################

%orbit_01_00862_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%orbit_01_00862_def =
( NAME    => "OC_XN_NI0_PI_CMP_EXP_DATA0",
  ADDRESS => 0x00000000d0031740,
  NOTE    => "Included only for Orbit - Begin",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00862_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI0_PI_CMP_EXP_DATA1                                           #
#                                                                        #
##########################################################################

%orbit_01_00863_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%orbit_01_00863_def =
( NAME    => "OC_XN_NI0_PI_CMP_EXP_DATA1",
  ADDRESS => 0x00000000d0031750,
  NOTE    => "NI0 compare PI input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00863_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI0_PI_CMP_ENABLE0                                             #
#                                                                        #
##########################################################################

%orbit_01_00864_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%orbit_01_00864_def =
( NAME    => "OC_XN_NI0_PI_CMP_ENABLE0",
  ADDRESS => 0x00000000d0031760,
  NOTE    => "NI0 compare PI input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00864_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI0_PI_CMP_ENABLE1                                             #
#                                                                        #
##########################################################################

%orbit_01_00865_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%orbit_01_00865_def =
( NAME    => "OC_XN_NI0_PI_CMP_ENABLE1",
  ADDRESS => 0x00000000d0031770,
  NOTE    => "NI0 compare PI input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00865_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI0_NI_CMP_EXP_DATA0                                           #
#                                                                        #
##########################################################################

%orbit_01_00866_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%orbit_01_00866_def =
( NAME    => "OC_XN_NI0_NI_CMP_EXP_DATA0",
  ADDRESS => 0x00000000d00317c0,
  NOTE    => "Included only for Orbit - End",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00866_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI0_NI_CMP_EXP_DATA1                                           #
#                                                                        #
##########################################################################

%orbit_01_00867_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%orbit_01_00867_def =
( NAME    => "OC_XN_NI0_NI_CMP_EXP_DATA1",
  ADDRESS => 0x00000000d00317d0,
  NOTE    => "NI0 compare NI input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00867_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI0_NI_CMP_ENABLE0                                             #
#                                                                        #
##########################################################################

%orbit_01_00868_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%orbit_01_00868_def =
( NAME    => "OC_XN_NI0_NI_CMP_ENABLE0",
  ADDRESS => 0x00000000d00317e0,
  NOTE    => "NI0 compare NI input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00868_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI0_NI_CMP_ENABLE1                                             #
#                                                                        #
##########################################################################

%orbit_01_00869_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%orbit_01_00869_def =
( NAME    => "OC_XN_NI0_NI_CMP_ENABLE1",
  ADDRESS => 0x00000000d00317f0,
  NOTE    => "NI0 compare NI input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00869_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI0_LLP_CMP_EXP_DATA0                                          #
#                                                                        #
##########################################################################

%orbit_01_00870_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%orbit_01_00870_def =
( NAME    => "OC_XN_NI0_LLP_CMP_EXP_DATA0",
  ADDRESS => 0x00000000d0031800,
  NOTE    => "NI0 compare LLP input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00870_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI0_LLP_CMP_EXP_DATA1                                          #
#                                                                        #
##########################################################################

%orbit_01_00871_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%orbit_01_00871_def =
( NAME    => "OC_XN_NI0_LLP_CMP_EXP_DATA1",
  ADDRESS => 0x00000000d0031810,
  NOTE    => "NI0 compare LLP input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00871_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI0_LLP_CMP_ENABLE0                                            #
#                                                                        #
##########################################################################

%orbit_01_00872_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%orbit_01_00872_def =
( NAME    => "OC_XN_NI0_LLP_CMP_ENABLE0",
  ADDRESS => 0x00000000d0031820,
  NOTE    => "NI0 compare LLP input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00872_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI0_LLP_CMP_ENABLE1                                            #
#                                                                        #
##########################################################################

%orbit_01_00873_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%orbit_01_00873_def =
( NAME    => "OC_XN_NI0_LLP_CMP_ENABLE1",
  ADDRESS => 0x00000000d0031830,
  NOTE    => "NI0 compare LLP input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00873_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI0_MD_CMP_EXP_HDR0                                            #
#                                                                        #
##########################################################################

%orbit_01_00874_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected header 0" ],
);

%orbit_01_00874_def =
( NAME    => "OC_XN_NI0_MD_CMP_EXP_HDR0",
  ADDRESS => 0x00000000d0031b40,
  NOTE    => "Included only for Orbit - Begin",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00874_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI0_MD_CMP_EXP_HDR1                                            #
#                                                                        #
##########################################################################

%orbit_01_00875_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected header 1" ],
);

%orbit_01_00875_def =
( NAME    => "OC_XN_NI0_MD_CMP_EXP_HDR1",
  ADDRESS => 0x00000000d0031b50,
  NOTE    => "Added for Orbit",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00875_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI0_MD_CMP_HDR_ENABLE0                                         #
#                                                                        #
##########################################################################

%orbit_01_00876_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Header Enable 0" ],
);

%orbit_01_00876_def =
( NAME    => "OC_XN_NI0_MD_CMP_HDR_ENABLE0",
  ADDRESS => 0x00000000d0031b60,
  NOTE    => "Added for Orbit",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00876_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI0_MD_CMP_HDR_ENABLE1                                         #
#                                                                        #
##########################################################################

%orbit_01_00877_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Header Enable 1" ],
);

%orbit_01_00877_def =
( NAME    => "OC_XN_NI0_MD_CMP_HDR_ENABLE1",
  ADDRESS => 0x00000000d0031b70,
  NOTE    => "Added for Orbit",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00877_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI1_DEBUG_SEL                                                  #
#                                                                        #
##########################################################################

%orbit_01_00878_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_INPUT_SEL"            => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 input select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_INPUT_SEL"            => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 input select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_INPUT_SEL"            => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 input select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_INPUT_SEL"            => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 input select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_INPUT_SEL"            => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 input select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_INPUT_SEL"            => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 input select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_INPUT_SEL"            => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 input select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_INPUT_SEL"            => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 input select" ],
);

%orbit_01_00878_def =
( NAME    => "OC_XN_NI1_DEBUG_SEL",
  ADDRESS => 0x00000000d00310e0,
  NOTE    => "XN NI1 Debug Port Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00878_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI1_IILB_CMP_EXP_DATA0                                         #
#                                                                        #
##########################################################################

%orbit_01_00879_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%orbit_01_00879_def =
( NAME    => "OC_XN_NI1_IILB_CMP_EXP_DATA0",
  ADDRESS => 0x00000000d0031900,
  NOTE    => "NI1 compare IILB input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00879_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI1_IILB_CMP_EXP_DATA1                                         #
#                                                                        #
##########################################################################

%orbit_01_00880_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%orbit_01_00880_def =
( NAME    => "OC_XN_NI1_IILB_CMP_EXP_DATA1",
  ADDRESS => 0x00000000d0031910,
  NOTE    => "NI1 compare IILB input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00880_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI1_IILB_CMP_ENABLE0                                           #
#                                                                        #
##########################################################################

%orbit_01_00881_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%orbit_01_00881_def =
( NAME    => "OC_XN_NI1_IILB_CMP_ENABLE0",
  ADDRESS => 0x00000000d0031920,
  NOTE    => "NI1 compare IILB input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00881_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI1_IILB_CMP_ENABLE1                                           #
#                                                                        #
##########################################################################

%orbit_01_00882_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%orbit_01_00882_def =
( NAME    => "OC_XN_NI1_IILB_CMP_ENABLE1",
  ADDRESS => 0x00000000d0031930,
  NOTE    => "NI1 compare IILB input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00882_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI1_PI_CMP_EXP_DATA0                                           #
#                                                                        #
##########################################################################

%orbit_01_00883_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%orbit_01_00883_def =
( NAME    => "OC_XN_NI1_PI_CMP_EXP_DATA0",
  ADDRESS => 0x00000000d0031940,
  NOTE    => "Included only for Orbit - Begin",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00883_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI1_PI_CMP_EXP_DATA1                                           #
#                                                                        #
##########################################################################

%orbit_01_00884_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%orbit_01_00884_def =
( NAME    => "OC_XN_NI1_PI_CMP_EXP_DATA1",
  ADDRESS => 0x00000000d0031950,
  NOTE    => "NI1 compare PI input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00884_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI1_PI_CMP_ENABLE0                                             #
#                                                                        #
##########################################################################

%orbit_01_00885_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%orbit_01_00885_def =
( NAME    => "OC_XN_NI1_PI_CMP_ENABLE0",
  ADDRESS => 0x00000000d0031960,
  NOTE    => "NI1 compare PI input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00885_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI1_PI_CMP_ENABLE1                                             #
#                                                                        #
##########################################################################

%orbit_01_00886_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%orbit_01_00886_def =
( NAME    => "OC_XN_NI1_PI_CMP_ENABLE1",
  ADDRESS => 0x00000000d0031970,
  NOTE    => "NI1 compare PI input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00886_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI1_NI_CMP_EXP_DATA0                                           #
#                                                                        #
##########################################################################

%orbit_01_00887_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%orbit_01_00887_def =
( NAME    => "OC_XN_NI1_NI_CMP_EXP_DATA0",
  ADDRESS => 0x00000000d00319c0,
  NOTE    => "Included only for Orbit - End",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00887_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI1_NI_CMP_EXP_DATA1                                           #
#                                                                        #
##########################################################################

%orbit_01_00888_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%orbit_01_00888_def =
( NAME    => "OC_XN_NI1_NI_CMP_EXP_DATA1",
  ADDRESS => 0x00000000d00319d0,
  NOTE    => "NI1 compare NI input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00888_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI1_NI_CMP_ENABLE0                                             #
#                                                                        #
##########################################################################

%orbit_01_00889_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%orbit_01_00889_def =
( NAME    => "OC_XN_NI1_NI_CMP_ENABLE0",
  ADDRESS => 0x00000000d00319e0,
  NOTE    => "NI1 compare NI input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00889_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI1_NI_CMP_ENABLE1                                             #
#                                                                        #
##########################################################################

%orbit_01_00890_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%orbit_01_00890_def =
( NAME    => "OC_XN_NI1_NI_CMP_ENABLE1",
  ADDRESS => 0x00000000d00319f0,
  NOTE    => "NI1 compare NI input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00890_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI1_LLP_CMP_EXP_DATA0                                          #
#                                                                        #
##########################################################################

%orbit_01_00891_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%orbit_01_00891_def =
( NAME    => "OC_XN_NI1_LLP_CMP_EXP_DATA0",
  ADDRESS => 0x00000000d0031a00,
  NOTE    => "NI1 compare LLP input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00891_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI1_LLP_CMP_EXP_DATA1                                          #
#                                                                        #
##########################################################################

%orbit_01_00892_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%orbit_01_00892_def =
( NAME    => "OC_XN_NI1_LLP_CMP_EXP_DATA1",
  ADDRESS => 0x00000000d0031a10,
  NOTE    => "NI1 compare LLP input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00892_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI1_LLP_CMP_ENABLE0                                            #
#                                                                        #
##########################################################################

%orbit_01_00893_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%orbit_01_00893_def =
( NAME    => "OC_XN_NI1_LLP_CMP_ENABLE0",
  ADDRESS => 0x00000000d0031a20,
  NOTE    => "NI1 compare LLP input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00893_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI1_LLP_CMP_ENABLE1                                            #
#                                                                        #
##########################################################################

%orbit_01_00894_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%orbit_01_00894_def =
( NAME    => "OC_XN_NI1_LLP_CMP_ENABLE1",
  ADDRESS => 0x00000000d0031a30,
  NOTE    => "NI1 compare LLP input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00894_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI1_MD_CMP_EXP_HDR0                                            #
#                                                                        #
##########################################################################

%orbit_01_00895_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected header 0" ],
);

%orbit_01_00895_def =
( NAME    => "OC_XN_NI1_MD_CMP_EXP_HDR0",
  ADDRESS => 0x00000000d0031bc0,
  NOTE    => "Included only for Orbit - Begin",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00895_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI1_MD_CMP_EXP_HDR1                                            #
#                                                                        #
##########################################################################

%orbit_01_00896_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected header 1" ],
);

%orbit_01_00896_def =
( NAME    => "OC_XN_NI1_MD_CMP_EXP_HDR1",
  ADDRESS => 0x00000000d0031bd0,
  NOTE    => "Added for Orbit",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00896_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI1_MD_CMP_HDR_ENABLE0                                         #
#                                                                        #
##########################################################################

%orbit_01_00897_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Header Enable 0" ],
);

%orbit_01_00897_def =
( NAME    => "OC_XN_NI1_MD_CMP_HDR_ENABLE0",
  ADDRESS => 0x00000000d0031be0,
  NOTE    => "Added for Orbit",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00897_flds
);


##########################################################################
#                                                                        #
#   OC_XN_NI1_MD_CMP_HDR_ENABLE1                                         #
#                                                                        #
##########################################################################

%orbit_01_00898_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Header Enable 1" ],
);

%orbit_01_00898_def =
( NAME    => "OC_XN_NI1_MD_CMP_HDR_ENABLE1",
  ADDRESS => 0x00000000d0031bf0,
  NOTE    => "Added for Orbit",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00898_flds
);


##########################################################################
#                                                                        #
#   OC_XN_PI_DEBUG_SEL                                                   #
#                                                                        #
##########################################################################

%orbit_01_00899_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_INPUT_SEL"            => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 input select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_INPUT_SEL"            => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 input select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_INPUT_SEL"            => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 input select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_INPUT_SEL"            => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 input select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_INPUT_SEL"            => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 input select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_INPUT_SEL"            => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 input select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_INPUT_SEL"            => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 input select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_INPUT_SEL"            => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 input select" ],
);

%orbit_01_00899_def =
( NAME    => "OC_XN_PI_DEBUG_SEL",
  ADDRESS => 0x00000000d00310a0,
  NOTE    => "XN PI Debug Port Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00899_flds
);


##########################################################################
#                                                                        #
#   OC_XN_PI_IILB_CMP_EXP_DATA0                                          #
#                                                                        #
##########################################################################

%orbit_01_00900_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%orbit_01_00900_def =
( NAME    => "OC_XN_PI_IILB_CMP_EXP_DATA0",
  ADDRESS => 0x00000000d0031300,
  NOTE    => "PI compare IILB input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00900_flds
);


##########################################################################
#                                                                        #
#   OC_XN_PI_IILB_CMP_EXP_DATA1                                          #
#                                                                        #
##########################################################################

%orbit_01_00901_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%orbit_01_00901_def =
( NAME    => "OC_XN_PI_IILB_CMP_EXP_DATA1",
  ADDRESS => 0x00000000d0031310,
  NOTE    => "PI compare IILB input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00901_flds
);


##########################################################################
#                                                                        #
#   OC_XN_PI_IILB_CMP_ENABLE0                                            #
#                                                                        #
##########################################################################

%orbit_01_00902_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%orbit_01_00902_def =
( NAME    => "OC_XN_PI_IILB_CMP_ENABLE0",
  ADDRESS => 0x00000000d0031320,
  NOTE    => "PI compare IILB input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00902_flds
);


##########################################################################
#                                                                        #
#   OC_XN_PI_IILB_CMP_ENABLE1                                            #
#                                                                        #
##########################################################################

%orbit_01_00903_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%orbit_01_00903_def =
( NAME    => "OC_XN_PI_IILB_CMP_ENABLE1",
  ADDRESS => 0x00000000d0031330,
  NOTE    => "PI compare IILB input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00903_flds
);


##########################################################################
#                                                                        #
#   OC_XN_PI_NI0_CMP_EXP_DATA0                                           #
#                                                                        #
##########################################################################

%orbit_01_00904_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%orbit_01_00904_def =
( NAME    => "OC_XN_PI_NI0_CMP_EXP_DATA0",
  ADDRESS => 0x00000000d0031340,
  NOTE    => "PI compare NI0 input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00904_flds
);


##########################################################################
#                                                                        #
#   OC_XN_PI_NI0_CMP_EXP_DATA1                                           #
#                                                                        #
##########################################################################

%orbit_01_00905_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%orbit_01_00905_def =
( NAME    => "OC_XN_PI_NI0_CMP_EXP_DATA1",
  ADDRESS => 0x00000000d0031350,
  NOTE    => "PI compare NI0 input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00905_flds
);


##########################################################################
#                                                                        #
#   OC_XN_PI_NI0_CMP_ENABLE0                                             #
#                                                                        #
##########################################################################

%orbit_01_00906_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%orbit_01_00906_def =
( NAME    => "OC_XN_PI_NI0_CMP_ENABLE0",
  ADDRESS => 0x00000000d0031360,
  NOTE    => "PI compare NI0 input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00906_flds
);


##########################################################################
#                                                                        #
#   OC_XN_PI_NI0_CMP_ENABLE1                                             #
#                                                                        #
##########################################################################

%orbit_01_00907_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%orbit_01_00907_def =
( NAME    => "OC_XN_PI_NI0_CMP_ENABLE1",
  ADDRESS => 0x00000000d0031370,
  NOTE    => "PI compare NI0 input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00907_flds
);


##########################################################################
#                                                                        #
#   OC_XN_PI_NI1_CMP_EXP_DATA0                                           #
#                                                                        #
##########################################################################

%orbit_01_00908_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%orbit_01_00908_def =
( NAME    => "OC_XN_PI_NI1_CMP_EXP_DATA0",
  ADDRESS => 0x00000000d0031380,
  NOTE    => "PI compare NI1 input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00908_flds
);


##########################################################################
#                                                                        #
#   OC_XN_PI_NI1_CMP_EXP_DATA1                                           #
#                                                                        #
##########################################################################

%orbit_01_00909_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%orbit_01_00909_def =
( NAME    => "OC_XN_PI_NI1_CMP_EXP_DATA1",
  ADDRESS => 0x00000000d0031390,
  NOTE    => "PI compare NI1 input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00909_flds
);


##########################################################################
#                                                                        #
#   OC_XN_PI_NI1_CMP_ENABLE0                                             #
#                                                                        #
##########################################################################

%orbit_01_00910_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%orbit_01_00910_def =
( NAME    => "OC_XN_PI_NI1_CMP_ENABLE0",
  ADDRESS => 0x00000000d00313a0,
  NOTE    => "PI compare NI1 input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00910_flds
);


##########################################################################
#                                                                        #
#   OC_XN_PI_NI1_CMP_ENABLE1                                             #
#                                                                        #
##########################################################################

%orbit_01_00911_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%orbit_01_00911_def =
( NAME    => "OC_XN_PI_NI1_CMP_ENABLE1",
  ADDRESS => 0x00000000d00313b0,
  NOTE    => "PI compare NI1 input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00911_flds
);


##########################################################################
#                                                                        #
#   OC_XN_PI_SICN_CMP_DATA0                                              #
#                                                                        #
##########################################################################

%orbit_01_00912_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA0"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data0" ],
);

%orbit_01_00912_def =
( NAME    => "OC_XN_PI_SICN_CMP_DATA0",
  ADDRESS => 0x00000000d0031400,
  NOTE    => "PI compare SICN data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00912_flds
);


##########################################################################
#                                                                        #
#   OC_XN_PI_SICN_CMP_DATA1                                              #
#                                                                        #
##########################################################################

%orbit_01_00913_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA1"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data1" ],
);

%orbit_01_00913_def =
( NAME    => "OC_XN_PI_SICN_CMP_DATA1",
  ADDRESS => 0x00000000d0031410,
  NOTE    => "PI compare SICN data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00913_flds
);


##########################################################################
#                                                                        #
#   OC_XN_PI_SICN_CMP_DATA_ENABLE0                                       #
#                                                                        #
##########################################################################

%orbit_01_00914_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_ENABLE0"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data0" ],
);

%orbit_01_00914_def =
( NAME    => "OC_XN_PI_SICN_CMP_DATA_ENABLE0",
  ADDRESS => 0x00000000d0031440,
  NOTE    => "PI enable compare SICN data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00914_flds
);


##########################################################################
#                                                                        #
#   OC_XN_PI_SICN_CMP_DATA_ENABLE1                                       #
#                                                                        #
##########################################################################

%orbit_01_00915_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_ENABLE1"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data1" ],
);

%orbit_01_00915_def =
( NAME    => "OC_XN_PI_SICN_CMP_DATA_ENABLE1",
  ADDRESS => 0x00000000d0031450,
  NOTE    => "PI enable compare SICN data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00915_flds
);


##########################################################################
#                                                                        #
#   OC_XN_MD_DEBUG_SEL                                                   #
#                                                                        #
##########################################################################

%orbit_01_00916_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_INPUT_SEL"            => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 input select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_INPUT_SEL"            => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 input select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_INPUT_SEL"            => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 input select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_INPUT_SEL"            => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 input select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_INPUT_SEL"            => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 input select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_INPUT_SEL"            => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 input select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_INPUT_SEL"            => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 input select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_INPUT_SEL"            => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 input select" ],
);

%orbit_01_00916_def =
( NAME    => "OC_XN_MD_DEBUG_SEL",
  ADDRESS => 0x00000000d0031080,
  NOTE    => "XN MD Debug Port Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00916_flds
);


##########################################################################
#                                                                        #
#   OC_XN_MD_IILB_CMP_EXP_DATA0                                          #
#                                                                        #
##########################################################################

%orbit_01_00917_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%orbit_01_00917_def =
( NAME    => "OC_XN_MD_IILB_CMP_EXP_DATA0",
  ADDRESS => 0x00000000d0031500,
  NOTE    => "MD compare IILB input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00917_flds
);


##########################################################################
#                                                                        #
#   OC_XN_MD_IILB_CMP_EXP_DATA1                                          #
#                                                                        #
##########################################################################

%orbit_01_00918_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%orbit_01_00918_def =
( NAME    => "OC_XN_MD_IILB_CMP_EXP_DATA1",
  ADDRESS => 0x00000000d0031510,
  NOTE    => "MD compare IILB input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00918_flds
);


##########################################################################
#                                                                        #
#   OC_XN_MD_IILB_CMP_ENABLE0                                            #
#                                                                        #
##########################################################################

%orbit_01_00919_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%orbit_01_00919_def =
( NAME    => "OC_XN_MD_IILB_CMP_ENABLE0",
  ADDRESS => 0x00000000d0031520,
  NOTE    => "MD compare IILB input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00919_flds
);


##########################################################################
#                                                                        #
#   OC_XN_MD_IILB_CMP_ENABLE1                                            #
#                                                                        #
##########################################################################

%orbit_01_00920_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%orbit_01_00920_def =
( NAME    => "OC_XN_MD_IILB_CMP_ENABLE1",
  ADDRESS => 0x00000000d0031530,
  NOTE    => "MD compare IILB input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00920_flds
);


##########################################################################
#                                                                        #
#   OC_XN_MD_NI0_CMP_EXP_DATA0                                           #
#                                                                        #
##########################################################################

%orbit_01_00921_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%orbit_01_00921_def =
( NAME    => "OC_XN_MD_NI0_CMP_EXP_DATA0",
  ADDRESS => 0x00000000d0031540,
  NOTE    => "MD compare NI0 input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00921_flds
);


##########################################################################
#                                                                        #
#   OC_XN_MD_NI0_CMP_EXP_DATA1                                           #
#                                                                        #
##########################################################################

%orbit_01_00922_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%orbit_01_00922_def =
( NAME    => "OC_XN_MD_NI0_CMP_EXP_DATA1",
  ADDRESS => 0x00000000d0031550,
  NOTE    => "MD compare NI0 input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00922_flds
);


##########################################################################
#                                                                        #
#   OC_XN_MD_NI0_CMP_ENABLE0                                             #
#                                                                        #
##########################################################################

%orbit_01_00923_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%orbit_01_00923_def =
( NAME    => "OC_XN_MD_NI0_CMP_ENABLE0",
  ADDRESS => 0x00000000d0031560,
  NOTE    => "MD compare NI0 input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00923_flds
);


##########################################################################
#                                                                        #
#   OC_XN_MD_NI0_CMP_ENABLE1                                             #
#                                                                        #
##########################################################################

%orbit_01_00924_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%orbit_01_00924_def =
( NAME    => "OC_XN_MD_NI0_CMP_ENABLE1",
  ADDRESS => 0x00000000d0031570,
  NOTE    => "MD compare NI0 input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00924_flds
);


##########################################################################
#                                                                        #
#   OC_XN_MD_NI1_CMP_EXP_DATA0                                           #
#                                                                        #
##########################################################################

%orbit_01_00925_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%orbit_01_00925_def =
( NAME    => "OC_XN_MD_NI1_CMP_EXP_DATA0",
  ADDRESS => 0x00000000d0031580,
  NOTE    => "MD compare NI1 input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00925_flds
);


##########################################################################
#                                                                        #
#   OC_XN_MD_NI1_CMP_EXP_DATA1                                           #
#                                                                        #
##########################################################################

%orbit_01_00926_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%orbit_01_00926_def =
( NAME    => "OC_XN_MD_NI1_CMP_EXP_DATA1",
  ADDRESS => 0x00000000d0031590,
  NOTE    => "MD compare NI1 input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00926_flds
);


##########################################################################
#                                                                        #
#   OC_XN_MD_NI1_CMP_ENABLE0                                             #
#                                                                        #
##########################################################################

%orbit_01_00927_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%orbit_01_00927_def =
( NAME    => "OC_XN_MD_NI1_CMP_ENABLE0",
  ADDRESS => 0x00000000d00315a0,
  NOTE    => "MD compare NI1 input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00927_flds
);


##########################################################################
#                                                                        #
#   OC_XN_MD_NI1_CMP_ENABLE1                                             #
#                                                                        #
##########################################################################

%orbit_01_00928_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%orbit_01_00928_def =
( NAME    => "OC_XN_MD_NI1_CMP_ENABLE1",
  ADDRESS => 0x00000000d00315b0,
  NOTE    => "MD compare NI1 input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00928_flds
);


##########################################################################
#                                                                        #
#   OC_XN_MD_SIC_CMP_EXP_HDR0                                            #
#                                                                        #
##########################################################################

%orbit_01_00929_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%orbit_01_00929_def =
( NAME    => "OC_XN_MD_SIC_CMP_EXP_HDR0",
  ADDRESS => 0x00000000d00315c0,
  NOTE    => "MD compare SIC input expected header0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00929_flds
);


##########################################################################
#                                                                        #
#   OC_XN_MD_SIC_CMP_EXP_HDR1                                            #
#                                                                        #
##########################################################################

%orbit_01_00930_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA"                         => [   1,   0,  56, 0x00FFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%orbit_01_00930_def =
( NAME    => "OC_XN_MD_SIC_CMP_EXP_HDR1",
  ADDRESS => 0x00000000d00315d0,
  NOTE    => "MD compare SIC input expected header1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00930_flds
);


##########################################################################
#                                                                        #
#   OC_XN_MD_SIC_CMP_HDR_ENABLE0                                         #
#                                                                        #
##########################################################################

%orbit_01_00931_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%orbit_01_00931_def =
( NAME    => "OC_XN_MD_SIC_CMP_HDR_ENABLE0",
  ADDRESS => 0x00000000d00315e0,
  NOTE    => "MD compare SIC header enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00931_flds
);


##########################################################################
#                                                                        #
#   OC_XN_MD_SIC_CMP_HDR_ENABLE1                                         #
#                                                                        #
##########################################################################

%orbit_01_00932_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE"                       => [   1,   0,  56, 0x00FFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%orbit_01_00932_def =
( NAME    => "OC_XN_MD_SIC_CMP_HDR_ENABLE1",
  ADDRESS => 0x00000000d00315f0,
  NOTE    => "MD compare SIC header enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00932_flds
);


##########################################################################
#                                                                        #
#   OC_XNMD_ECC_INJ_REG                                                  #
#                                                                        #
##########################################################################

%orbit_01_00933_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_CB_CONT32"               => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Upper Continuous Replace Checkbyte" ],
   "DATA_CB_1SHOT32"              => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Upper One Shot Replace Checkbyte" ],
   "DATA_CONT32"                  => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "Upper Toggle Mask Data" ],
   "DATA_1SHOT32"                 => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "Upper One Shot Mask Data" ],
   "RSVD0"                        => [   4,  48,  12, 0x0FFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BYTE32"                       => [   5,  32,  16, 0x0000FFFF00000000, 0x00, 1, 0x0000000000000000, "Upper Replacement Checkbytes" ],
   "DATA_CB_CONT10"               => [   6,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "Lower Continuous Replace Checkbyte" ],
   "DATA_CB_1SHOT10"              => [   7,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "Lower One Shot Replace Checkbyte" ],
   "DATA_CONT10"                  => [   8,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "Lower Continuous Mask Data" ],
   "DATA_1SHOT10"                 => [   9,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "Lower One Shot Mask Data" ],
   "RSVD1"                        => [  10,  16,  12, 0x000000000FFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BYTE10"                       => [  11,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "Lower Replacement Checkbytes" ],
);

%orbit_01_00933_def =
( NAME    => "OC_XNMD_ECC_INJ_REG",
  ADDRESS => 0x00000000d0032050,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00933_flds
);


##########################################################################
#                                                                        #
#   OC_XNMD_ECC0_INJ_MASK_REG                                            #
#                                                                        #
##########################################################################

%orbit_01_00934_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK_ECC0"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Replacement Mask" ],
);

%orbit_01_00934_def =
( NAME    => "OC_XNMD_ECC0_INJ_MASK_REG",
  ADDRESS => 0x00000000d0032060,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00934_flds
);


##########################################################################
#                                                                        #
#   OC_XNMD_ECC1_INJ_MASK_REG                                            #
#                                                                        #
##########################################################################

%orbit_01_00935_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK_ECC1"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Replacement Mask" ],
);

%orbit_01_00935_def =
( NAME    => "OC_XNMD_ECC1_INJ_MASK_REG",
  ADDRESS => 0x00000000d0032070,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00935_flds
);


##########################################################################
#                                                                        #
#   OC_XNMD_ECC2_INJ_MASK_REG                                            #
#                                                                        #
##########################################################################

%orbit_01_00936_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK_ECC2"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Replacement Mask" ],
);

%orbit_01_00936_def =
( NAME    => "OC_XNMD_ECC2_INJ_MASK_REG",
  ADDRESS => 0x00000000d0032080,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00936_flds
);


##########################################################################
#                                                                        #
#   OC_XNMD_ECC3_INJ_MASK_REG                                            #
#                                                                        #
##########################################################################

%orbit_01_00937_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK_ECC3"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Replacement Mask" ],
);

%orbit_01_00937_def =
( NAME    => "OC_XNMD_ECC3_INJ_MASK_REG",
  ADDRESS => 0x00000000d0032090,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00937_flds
);


##########################################################################
#                                                                        #
#   OC_XNMD_ECC_ERR_REPORT                                               #
#                                                                        #
##########################################################################

%orbit_01_00938_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  17,  47, 0xFFFFFFFFFFFE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECC_DISABLE1"                 => [   1,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Disable Upper Error Correction" ],
   "RSVD1"                        => [   2,   1,  15, 0x000000000000FFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECC_DISABLE0"                 => [   3,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Disable Lower Error Correction" ],
);

%orbit_01_00938_def =
( NAME    => "OC_XNMD_ECC_ERR_REPORT",
  ADDRESS => 0x00000000d00320a0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00938_flds
);


##########################################################################
#                                                                        #
#   OC_NI0_ERROR_SUMMARY_1                                               #
#                                                                        #
##########################################################################

%orbit_01_00939_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_TAIL_TIMEOUT_VC3"          => [   1,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc3" ],
   "NI_TAIL_TIMEOUT_VC2"          => [   2,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc2" ],
   "NI_TAIL_TIMEOUT_VC1"          => [   3,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc1" ],
   "NI_TAIL_TIMEOUT_VC0"          => [   4,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc0" ],
   "PI_TAIL_TIMEOUT_VC3"          => [   5,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc3" ],
   "PI_TAIL_TIMEOUT_VC2"          => [   6,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc2" ],
   "PI_TAIL_TIMEOUT_VC1"          => [   7,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc1" ],
   "PI_TAIL_TIMEOUT_VC0"          => [   8,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc0" ],
   "MD_TAIL_TIMEOUT_VC3"          => [   9,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc3" ],
   "MD_TAIL_TIMEOUT_VC2"          => [  10,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc2" ],
   "MD_TAIL_TIMEOUT_VC1"          => [  11,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc1" ],
   "MD_TAIL_TIMEOUT_VC0"          => [  12,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc0" ],
   "IILB_TAIL_TIMEOUT_VC3"        => [  13,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc3" ],
   "IILB_TAIL_TIMEOUT_VC2"        => [  14,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc2" ],
   "IILB_TAIL_TIMEOUT_VC1"        => [  15,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc1" ],
   "IILB_TAIL_TIMEOUT_VC0"        => [  16,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc0" ],
   "NI_DEBITSAVER_OVERFLOW_VC3"   => [  17,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc3" ],
   "NI_DEBITSAVER_OVERFLOW_VC2"   => [  18,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc2" ],
   "NI_DEBITSAVER_OVERFLOW_VC1"   => [  19,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc1" ],
   "NI_DEBITSAVER_OVERFLOW_VC0"   => [  20,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc0" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC3"   => [  21,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc3" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC2"   => [  22,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc2" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC1"   => [  23,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc1" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC0"   => [  24,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc0" ],
   "NI_FAST_TAIL_OVERFLOW"        => [  25,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI fast tail overflow" ],
   "PI_DATA_FAST_TAIL_OVERFLOW"   => [  26,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail overflow" ],
   "PI_HDR_FAST_TAIL_OVERFLOW"    => [  27,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail overflow" ],
   "MD_DATA_FAST_TAIL_OVERFLOW"   => [  28,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "MD data fast tail overflow" ],
   "MD_HDR_FAST_TAIL_OVERFLOW"    => [  29,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail overflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  30,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC3"  => [  31,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc3" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC2"  => [  32,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc2" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC1"  => [  33,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc1" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC0"  => [  34,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc0" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  35,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc2" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  36,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc2" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  37,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc0" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  38,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc0" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  39,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc2" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  40,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc2" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  41,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc0" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  42,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc0" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC2" => [  43,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc2" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC0" => [  44,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc0" ],
   "NI_DEBIT_OVERFLOW_VC3"        => [  45,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc3" ],
   "NI_DEBIT_OVERFLOW_VC2"        => [  46,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc2" ],
   "NI_DEBIT_OVERFLOW_VC1"        => [  47,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc1" ],
   "NI_DEBIT_OVERFLOW_VC0"        => [  48,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc0" ],
   "PI_DEBIT_OVERFLOW_VC2"        => [  49,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc2" ],
   "PI_DEBIT_OVERFLOW_VC0"        => [  50,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc0" ],
   "MD_DEBIT_OVERFLOW_VC2"        => [  51,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "MD debit overflow vc2" ],
   "MD_DEBIT_OVERFLOW_VC0"        => [  52,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "MD debit overflow vc0" ],
   "IILB_DEBIT_OVERFLOW_VC2"      => [  53,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc2" ],
   "IILB_DEBIT_OVERFLOW_VC0"      => [  54,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc0" ],
   "OVERFLOW_NI_VC3_CREDIT"       => [  55,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit overflow vc3" ],
   "OVERFLOW_NI_VC2_CREDIT"       => [  56,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit overflow vc2" ],
   "OVERFLOW_NI_VC1_CREDIT"       => [  57,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit overflow vc1" ],
   "OVERFLOW_NI_VC0_CREDIT"       => [  58,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT3"          => [  59,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT2"          => [  60,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT1"          => [  61,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT0"          => [  62,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
);

%orbit_01_00939_def =
( NAME    => "OC_NI0_ERROR_SUMMARY_1",
  ADDRESS => 0x00000000d0040500,
  NOTE    => "ni0 Error Summary Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00939_flds
);


##########################################################################
#                                                                        #
#   OC_NI0_ERROR_SUMMARY_1_ALIAS                                         #
#                                                                        #
##########################################################################

%orbit_01_00940_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_TAIL_TIMEOUT_VC3"          => [   1,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc3" ],
   "NI_TAIL_TIMEOUT_VC2"          => [   2,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc2" ],
   "NI_TAIL_TIMEOUT_VC1"          => [   3,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc1" ],
   "NI_TAIL_TIMEOUT_VC0"          => [   4,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc0" ],
   "PI_TAIL_TIMEOUT_VC3"          => [   5,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc3" ],
   "PI_TAIL_TIMEOUT_VC2"          => [   6,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc2" ],
   "PI_TAIL_TIMEOUT_VC1"          => [   7,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc1" ],
   "PI_TAIL_TIMEOUT_VC0"          => [   8,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc0" ],
   "MD_TAIL_TIMEOUT_VC3"          => [   9,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc3" ],
   "MD_TAIL_TIMEOUT_VC2"          => [  10,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc2" ],
   "MD_TAIL_TIMEOUT_VC1"          => [  11,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc1" ],
   "MD_TAIL_TIMEOUT_VC0"          => [  12,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc0" ],
   "IILB_TAIL_TIMEOUT_VC3"        => [  13,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc3" ],
   "IILB_TAIL_TIMEOUT_VC2"        => [  14,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc2" ],
   "IILB_TAIL_TIMEOUT_VC1"        => [  15,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc1" ],
   "IILB_TAIL_TIMEOUT_VC0"        => [  16,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc0" ],
   "NI_DEBITSAVER_OVERFLOW_VC3"   => [  17,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc3" ],
   "NI_DEBITSAVER_OVERFLOW_VC2"   => [  18,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc2" ],
   "NI_DEBITSAVER_OVERFLOW_VC1"   => [  19,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc1" ],
   "NI_DEBITSAVER_OVERFLOW_VC0"   => [  20,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc0" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC3"   => [  21,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc3" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC2"   => [  22,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc2" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC1"   => [  23,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc1" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC0"   => [  24,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc0" ],
   "NI_FAST_TAIL_OVERFLOW"        => [  25,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI fast tail overflow" ],
   "PI_DATA_FAST_TAIL_OVERFLOW"   => [  26,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail overflow" ],
   "PI_HDR_FAST_TAIL_OVERFLOW"    => [  27,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail overflow" ],
   "MD_DATA_FAST_TAIL_OVERFLOW"   => [  28,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "MD data fast tail overflow" ],
   "MD_HDR_FAST_TAIL_OVERFLOW"    => [  29,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail overflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  30,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC3"  => [  31,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc3" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC2"  => [  32,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc2" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC1"  => [  33,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc1" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC0"  => [  34,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc0" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  35,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc2" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  36,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc2" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  37,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc0" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  38,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc0" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  39,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc2" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  40,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc2" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  41,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc0" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  42,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc0" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC2" => [  43,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc2" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC0" => [  44,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc0" ],
   "NI_DEBIT_OVERFLOW_VC3"        => [  45,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc3" ],
   "NI_DEBIT_OVERFLOW_VC2"        => [  46,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc2" ],
   "NI_DEBIT_OVERFLOW_VC1"        => [  47,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc1" ],
   "NI_DEBIT_OVERFLOW_VC0"        => [  48,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc0" ],
   "PI_DEBIT_OVERFLOW_VC2"        => [  49,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc2" ],
   "PI_DEBIT_OVERFLOW_VC0"        => [  50,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc0" ],
   "MD_DEBIT_OVERFLOW_VC2"        => [  51,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "MD debit overflow vc2" ],
   "MD_DEBIT_OVERFLOW_VC0"        => [  52,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "MD debit overflow vc0" ],
   "IILB_DEBIT_OVERFLOW_VC2"      => [  53,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc2" ],
   "IILB_DEBIT_OVERFLOW_VC0"      => [  54,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc0" ],
   "OVERFLOW_NI_VC3_CREDIT"       => [  55,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit overflow vc3" ],
   "OVERFLOW_NI_VC2_CREDIT"       => [  56,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit overflow vc2" ],
   "OVERFLOW_NI_VC1_CREDIT"       => [  57,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit overflow vc1" ],
   "OVERFLOW_NI_VC0_CREDIT"       => [  58,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT3"          => [  59,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT2"          => [  60,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT1"          => [  61,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT0"          => [  62,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
);

%orbit_01_00940_def =
( NAME    => "OC_NI0_ERROR_SUMMARY_1_ALIAS",
  ADDRESS => 0x00000000d0040508,
  NOTE    => "ni0 Error Summary Bits Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00940_flds
);


##########################################################################
#                                                                        #
#   OC_NI0_ERROR_SUMMARY_2                                               #
#                                                                        #
##########################################################################

%orbit_01_00941_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DAM_PI_XMIT_MSG_VC3"          => [   1,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "PI VC3 Xmit Message Lost" ],
   "DAM_PI_XMIT_MSG_VC2"          => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "PI VC2 Xmit Message Lost" ],
   "DAM_PI_XMIT_MSG_VC1"          => [   3,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "PI VC1 Xmit Message Lost" ],
   "DAM_PI_XMIT_MSG_VC0"          => [   4,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC3"          => [   5,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "MD VC3 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC2"          => [   6,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "MD VC2 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC1"          => [   7,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "MD VC1 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC0"          => [   8,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC3"          => [   9,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI VC3 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC2"          => [  10,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI VC2 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC1"          => [  11,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI VC1 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC0"          => [  12,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI VC0 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC3"        => [  13,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC3 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC2"        => [  14,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC1"        => [  15,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC1 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC0"        => [  16,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Xmit Message Lost" ],
   "RETRY_TIMEOUT_ERROR"          => [  17,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [  18,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [  19,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "MD_TAIL_CNT_ERROR"            => [  20,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "MD tail count error" ],
   "PI_TAIL_CNT_ERROR"            => [  21,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI tail count error" ],
   "NI_ILLEGAL_VC"                => [  22,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI illegal vc" ],
   "PI_ILLEGAL_VC"                => [  23,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "PI illegal vc" ],
   "MD_ILLEGAL_VC"                => [  24,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD illegal vc" ],
   "IILB_ILLEGAL_VC"              => [  25,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB illegal vc" ],
   "NI_FAST_TAIL_ERROR"           => [  26,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI fast tail error" ],
   "PI_FAST_TAIL_ERROR"           => [  27,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PI fast tail error" ],
   "MD_FAST_TAIL_ERROR"           => [  28,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD fast tail error" ],
   "IILB_FAST_TAIL_ERROR"         => [  29,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "NI_FAST_TAIL_UNDERFLOW"       => [  30,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fast tail underflow" ],
   "PI_DATA_FAST_TAIL_UNDERFLOW"  => [  31,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "PI data fast tail underflow" ],
   "PI_HDR_FAST_TAIL_UNDERFLOW"   => [  32,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail underflow" ],
   "MD_DATA_FAST_TAIL_UNDERFLOW"  => [  33,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "MD data fast tail underflow" ],
   "MD_HDR_FAST_TAIL_UNDERFLOW"   => [  34,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail underflow" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [  35,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC3" => [  36,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc3" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC2" => [  37,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc2" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC1" => [  38,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc1" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC0" => [  39,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc0" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  40,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc2" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  41,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc2" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  42,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc0" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  43,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc0" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  44,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc2" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  45,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc2" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  46,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc0" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  47,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc0" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC2" => [  48,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc2" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC0" => [  49,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc0" ],
   "PI_DEBIT_UNDERFLOW_VC2"       => [  50,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI debit underflow vc2" ],
   "PI_DEBIT_UNDERFLOW_VC0"       => [  51,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI debit underflow vc0" ],
   "MD_DEBIT_UNDERFLOW_VC2"       => [  52,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "MD debit underflow vc2" ],
   "MD_DEBIT_UNDERFLOW_VC0"       => [  53,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "MD debit underflow vc0" ],
   "UNDERFLOW_NI_VC3_CREDIT"      => [  54,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit underflow vc3" ],
   "UNDERFLOW_NI_VC2_CREDIT"      => [  55,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit underflow vc2" ],
   "UNDERFLOW_NI_VC1_CREDIT"      => [  56,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit underflow vc1" ],
   "UNDERFLOW_NI_VC0_CREDIT"      => [  57,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit underflow vc0" ],
   "LLP_DEADLOCK_VC3"             => [  58,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [  59,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [  60,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [  61,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
);

%orbit_01_00941_def =
( NAME    => "OC_NI0_ERROR_SUMMARY_2",
  ADDRESS => 0x00000000d0040510,
  NOTE    => "ni0 Error Summary Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00941_flds
);


##########################################################################
#                                                                        #
#   OC_NI0_ERROR_SUMMARY_2_ALIAS                                         #
#                                                                        #
##########################################################################

%orbit_01_00942_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DAM_PI_XMIT_MSG_VC3"          => [   1,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "PI VC3 Xmit Message Lost" ],
   "DAM_PI_XMIT_MSG_VC2"          => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "PI VC2 Xmit Message Lost" ],
   "DAM_PI_XMIT_MSG_VC1"          => [   3,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "PI VC1 Xmit Message Lost" ],
   "DAM_PI_XMIT_MSG_VC0"          => [   4,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC3"          => [   5,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "MD VC3 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC2"          => [   6,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "MD VC2 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC1"          => [   7,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "MD VC1 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC0"          => [   8,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC3"          => [   9,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI VC3 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC2"          => [  10,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI VC2 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC1"          => [  11,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI VC1 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC0"          => [  12,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI VC0 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC3"        => [  13,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC3 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC2"        => [  14,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC1"        => [  15,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC1 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC0"        => [  16,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Xmit Message Lost" ],
   "RETRY_TIMEOUT_ERROR"          => [  17,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [  18,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [  19,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "MD_TAIL_CNT_ERROR"            => [  20,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "MD tail count error" ],
   "PI_TAIL_CNT_ERROR"            => [  21,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI tail count error" ],
   "NI_ILLEGAL_VC"                => [  22,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI illegal vc" ],
   "PI_ILLEGAL_VC"                => [  23,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "PI illegal vc" ],
   "MD_ILLEGAL_VC"                => [  24,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD illegal vc" ],
   "IILB_ILLEGAL_VC"              => [  25,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB illegal vc" ],
   "NI_FAST_TAIL_ERROR"           => [  26,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI fast tail error" ],
   "PI_FAST_TAIL_ERROR"           => [  27,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PI fast tail error" ],
   "MD_FAST_TAIL_ERROR"           => [  28,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD fast tail error" ],
   "IILB_FAST_TAIL_ERROR"         => [  29,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "NI_FAST_TAIL_UNDERFLOW"       => [  30,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fast tail underflow" ],
   "PI_DATA_FAST_TAIL_UNDERFLOW"  => [  31,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "PI data fast tail underflow" ],
   "PI_HDR_FAST_TAIL_UNDERFLOW"   => [  32,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail underflow" ],
   "MD_DATA_FAST_TAIL_UNDERFLOW"  => [  33,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "MD data fast tail underflow" ],
   "MD_HDR_FAST_TAIL_UNDERFLOW"   => [  34,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail underflow" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [  35,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC3" => [  36,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc3" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC2" => [  37,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc2" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC1" => [  38,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc1" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC0" => [  39,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc0" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  40,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc2" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  41,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc2" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  42,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc0" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  43,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc0" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  44,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc2" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  45,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc2" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  46,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc0" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  47,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc0" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC2" => [  48,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc2" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC0" => [  49,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc0" ],
   "PI_DEBIT_UNDERFLOW_VC2"       => [  50,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI debit underflow vc2" ],
   "PI_DEBIT_UNDERFLOW_VC0"       => [  51,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI debit underflow vc0" ],
   "MD_DEBIT_UNDERFLOW_VC2"       => [  52,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "MD debit underflow vc2" ],
   "MD_DEBIT_UNDERFLOW_VC0"       => [  53,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "MD debit underflow vc0" ],
   "UNDERFLOW_NI_VC3_CREDIT"      => [  54,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit underflow vc3" ],
   "UNDERFLOW_NI_VC2_CREDIT"      => [  55,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit underflow vc2" ],
   "UNDERFLOW_NI_VC1_CREDIT"      => [  56,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit underflow vc1" ],
   "UNDERFLOW_NI_VC0_CREDIT"      => [  57,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit underflow vc0" ],
   "LLP_DEADLOCK_VC3"             => [  58,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [  59,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [  60,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [  61,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
);

%orbit_01_00942_def =
( NAME    => "OC_NI0_ERROR_SUMMARY_2_ALIAS",
  ADDRESS => 0x00000000d0040518,
  NOTE    => "ni0 Error Summary Bits Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00942_flds
);


##########################################################################
#                                                                        #
#   OC_NI0_ERROR_OVERFLOW_1                                              #
#                                                                        #
##########################################################################

%orbit_01_00943_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_TAIL_TIMEOUT_VC3"          => [   1,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc3" ],
   "NI_TAIL_TIMEOUT_VC2"          => [   2,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc2" ],
   "NI_TAIL_TIMEOUT_VC1"          => [   3,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc1" ],
   "NI_TAIL_TIMEOUT_VC0"          => [   4,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc0" ],
   "PI_TAIL_TIMEOUT_VC3"          => [   5,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc3" ],
   "PI_TAIL_TIMEOUT_VC2"          => [   6,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc2" ],
   "PI_TAIL_TIMEOUT_VC1"          => [   7,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc1" ],
   "PI_TAIL_TIMEOUT_VC0"          => [   8,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc0" ],
   "MD_TAIL_TIMEOUT_VC3"          => [   9,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc3" ],
   "MD_TAIL_TIMEOUT_VC2"          => [  10,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc2" ],
   "MD_TAIL_TIMEOUT_VC1"          => [  11,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc1" ],
   "MD_TAIL_TIMEOUT_VC0"          => [  12,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc0" ],
   "IILB_TAIL_TIMEOUT_VC3"        => [  13,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc3" ],
   "IILB_TAIL_TIMEOUT_VC2"        => [  14,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc2" ],
   "IILB_TAIL_TIMEOUT_VC1"        => [  15,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc1" ],
   "IILB_TAIL_TIMEOUT_VC0"        => [  16,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc0" ],
   "NI_DEBITSAVER_OVERFLOW_VC3"   => [  17,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc3" ],
   "NI_DEBITSAVER_OVERFLOW_VC2"   => [  18,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc2" ],
   "NI_DEBITSAVER_OVERFLOW_VC1"   => [  19,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc1" ],
   "NI_DEBITSAVER_OVERFLOW_VC0"   => [  20,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc0" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC3"   => [  21,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc3" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC2"   => [  22,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc2" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC1"   => [  23,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc1" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC0"   => [  24,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc0" ],
   "NI_FAST_TAIL_OVERFLOW"        => [  25,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI fast tail overflow" ],
   "PI_DATA_FAST_TAIL_OVERFLOW"   => [  26,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail overflow" ],
   "PI_HDR_FAST_TAIL_OVERFLOW"    => [  27,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail overflow" ],
   "MD_DATA_FAST_TAIL_OVERFLOW"   => [  28,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "MD data fast tail overflow" ],
   "MD_HDR_FAST_TAIL_OVERFLOW"    => [  29,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail overflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  30,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC3"  => [  31,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc3" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC2"  => [  32,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc2" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC1"  => [  33,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc1" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC0"  => [  34,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc0" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  35,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc2" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  36,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc2" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  37,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc0" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  38,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc0" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  39,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc2" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  40,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc2" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  41,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc0" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  42,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc0" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC2" => [  43,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc2" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC0" => [  44,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc0" ],
   "NI_DEBIT_OVERFLOW_VC3"        => [  45,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc3" ],
   "NI_DEBIT_OVERFLOW_VC2"        => [  46,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc2" ],
   "NI_DEBIT_OVERFLOW_VC1"        => [  47,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc1" ],
   "NI_DEBIT_OVERFLOW_VC0"        => [  48,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc0" ],
   "PI_DEBIT_OVERFLOW_VC2"        => [  49,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc2" ],
   "PI_DEBIT_OVERFLOW_VC0"        => [  50,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc0" ],
   "MD_DEBIT_OVERFLOW_VC2"        => [  51,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "MD debit overflow vc2" ],
   "MD_DEBIT_OVERFLOW_VC0"        => [  52,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "MD debit overflow vc0" ],
   "IILB_DEBIT_OVERFLOW_VC2"      => [  53,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc2" ],
   "IILB_DEBIT_OVERFLOW_VC0"      => [  54,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc0" ],
   "OVERFLOW_NI_VC3_CREDIT"       => [  55,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit overflow vc3" ],
   "OVERFLOW_NI_VC2_CREDIT"       => [  56,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit overflow vc2" ],
   "OVERFLOW_NI_VC1_CREDIT"       => [  57,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit overflow vc1" ],
   "OVERFLOW_NI_VC0_CREDIT"       => [  58,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT3"          => [  59,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT2"          => [  60,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT1"          => [  61,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT0"          => [  62,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
);

%orbit_01_00943_def =
( NAME    => "OC_NI0_ERROR_OVERFLOW_1",
  ADDRESS => 0x00000000d0040520,
  NOTE    => "ni0 Error Overflow Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00943_flds
);


##########################################################################
#                                                                        #
#   OC_NI0_ERROR_OVERFLOW_1_ALIAS                                        #
#                                                                        #
##########################################################################

%orbit_01_00944_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_TAIL_TIMEOUT_VC3"          => [   1,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc3" ],
   "NI_TAIL_TIMEOUT_VC2"          => [   2,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc2" ],
   "NI_TAIL_TIMEOUT_VC1"          => [   3,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc1" ],
   "NI_TAIL_TIMEOUT_VC0"          => [   4,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc0" ],
   "PI_TAIL_TIMEOUT_VC3"          => [   5,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc3" ],
   "PI_TAIL_TIMEOUT_VC2"          => [   6,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc2" ],
   "PI_TAIL_TIMEOUT_VC1"          => [   7,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc1" ],
   "PI_TAIL_TIMEOUT_VC0"          => [   8,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc0" ],
   "MD_TAIL_TIMEOUT_VC3"          => [   9,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc3" ],
   "MD_TAIL_TIMEOUT_VC2"          => [  10,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc2" ],
   "MD_TAIL_TIMEOUT_VC1"          => [  11,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc1" ],
   "MD_TAIL_TIMEOUT_VC0"          => [  12,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc0" ],
   "IILB_TAIL_TIMEOUT_VC3"        => [  13,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc3" ],
   "IILB_TAIL_TIMEOUT_VC2"        => [  14,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc2" ],
   "IILB_TAIL_TIMEOUT_VC1"        => [  15,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc1" ],
   "IILB_TAIL_TIMEOUT_VC0"        => [  16,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc0" ],
   "NI_DEBITSAVER_OVERFLOW_VC3"   => [  17,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc3" ],
   "NI_DEBITSAVER_OVERFLOW_VC2"   => [  18,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc2" ],
   "NI_DEBITSAVER_OVERFLOW_VC1"   => [  19,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc1" ],
   "NI_DEBITSAVER_OVERFLOW_VC0"   => [  20,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc0" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC3"   => [  21,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc3" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC2"   => [  22,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc2" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC1"   => [  23,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc1" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC0"   => [  24,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc0" ],
   "NI_FAST_TAIL_OVERFLOW"        => [  25,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI fast tail overflow" ],
   "PI_DATA_FAST_TAIL_OVERFLOW"   => [  26,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail overflow" ],
   "PI_HDR_FAST_TAIL_OVERFLOW"    => [  27,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail overflow" ],
   "MD_DATA_FAST_TAIL_OVERFLOW"   => [  28,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "MD data fast tail overflow" ],
   "MD_HDR_FAST_TAIL_OVERFLOW"    => [  29,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail overflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  30,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC3"  => [  31,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc3" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC2"  => [  32,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc2" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC1"  => [  33,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc1" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC0"  => [  34,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc0" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  35,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc2" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  36,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc2" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  37,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc0" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  38,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc0" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  39,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc2" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  40,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc2" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  41,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc0" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  42,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc0" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC2" => [  43,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc2" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC0" => [  44,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc0" ],
   "NI_DEBIT_OVERFLOW_VC3"        => [  45,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc3" ],
   "NI_DEBIT_OVERFLOW_VC2"        => [  46,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc2" ],
   "NI_DEBIT_OVERFLOW_VC1"        => [  47,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc1" ],
   "NI_DEBIT_OVERFLOW_VC0"        => [  48,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc0" ],
   "PI_DEBIT_OVERFLOW_VC2"        => [  49,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc2" ],
   "PI_DEBIT_OVERFLOW_VC0"        => [  50,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc0" ],
   "MD_DEBIT_OVERFLOW_VC2"        => [  51,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "MD debit overflow vc2" ],
   "MD_DEBIT_OVERFLOW_VC0"        => [  52,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "MD debit overflow vc0" ],
   "IILB_DEBIT_OVERFLOW_VC2"      => [  53,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc2" ],
   "IILB_DEBIT_OVERFLOW_VC0"      => [  54,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc0" ],
   "OVERFLOW_NI_VC3_CREDIT"       => [  55,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit overflow vc3" ],
   "OVERFLOW_NI_VC2_CREDIT"       => [  56,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit overflow vc2" ],
   "OVERFLOW_NI_VC1_CREDIT"       => [  57,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit overflow vc1" ],
   "OVERFLOW_NI_VC0_CREDIT"       => [  58,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT3"          => [  59,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT2"          => [  60,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT1"          => [  61,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT0"          => [  62,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
);

%orbit_01_00944_def =
( NAME    => "OC_NI0_ERROR_OVERFLOW_1_ALIAS",
  ADDRESS => 0x00000000d0040528,
  NOTE    => "ni0 Error Overflow Bits Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00944_flds
);


##########################################################################
#                                                                        #
#   OC_NI0_ERROR_OVERFLOW_2                                              #
#                                                                        #
##########################################################################

%orbit_01_00945_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DAM_PI_XMIT_MSG_VC3"          => [   1,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "PI VC3 Xmit Message Lost" ],
   "DAM_PI_XMIT_MSG_VC2"          => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "PI VC2 Xmit Message Lost" ],
   "DAM_PI_XMIT_MSG_VC1"          => [   3,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "PI VC1 Xmit Message Lost" ],
   "DAM_PI_XMIT_MSG_VC0"          => [   4,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC3"          => [   5,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "MD VC3 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC2"          => [   6,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "MD VC2 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC1"          => [   7,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "MD VC1 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC0"          => [   8,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC3"          => [   9,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI VC3 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC2"          => [  10,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI VC2 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC1"          => [  11,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI VC1 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC0"          => [  12,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI VC0 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC3"        => [  13,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC3 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC2"        => [  14,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC1"        => [  15,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC1 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC0"        => [  16,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Xmit Message Lost" ],
   "RETRY_TIMEOUT_ERROR"          => [  17,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [  18,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [  19,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "MD_TAIL_CNT_ERROR"            => [  20,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "MD tail count error" ],
   "PI_TAIL_CNT_ERROR"            => [  21,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI tail count error" ],
   "NI_ILLEGAL_VC"                => [  22,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI illegal vc" ],
   "PI_ILLEGAL_VC"                => [  23,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "PI illegal vc" ],
   "MD_ILLEGAL_VC"                => [  24,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD illegal vc" ],
   "IILB_ILLEGAL_VC"              => [  25,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB illegal vc" ],
   "NI_FAST_TAIL_ERROR"           => [  26,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI fast tail error" ],
   "PI_FAST_TAIL_ERROR"           => [  27,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PI fast tail error" ],
   "MD_FAST_TAIL_ERROR"           => [  28,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD fast tail error" ],
   "IILB_FAST_TAIL_ERROR"         => [  29,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "NI_FAST_TAIL_UNDERFLOW"       => [  30,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fast tail underflow" ],
   "PI_DATA_FAST_TAIL_UNDERFLOW"  => [  31,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "PI data fast tail underflow" ],
   "PI_HDR_FAST_TAIL_UNDERFLOW"   => [  32,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail underflow" ],
   "MD_DATA_FAST_TAIL_UNDERFLOW"  => [  33,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "MD data fast tail underflow" ],
   "MD_HDR_FAST_TAIL_UNDERFLOW"   => [  34,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail underflow" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [  35,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC3" => [  36,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc3" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC2" => [  37,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc2" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC1" => [  38,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc1" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC0" => [  39,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc0" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  40,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc2" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  41,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc2" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  42,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc0" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  43,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc0" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  44,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc2" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  45,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc2" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  46,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc0" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  47,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc0" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC2" => [  48,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc2" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC0" => [  49,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc0" ],
   "PI_DEBIT_UNDERFLOW_VC2"       => [  50,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI debit underflow vc2" ],
   "PI_DEBIT_UNDERFLOW_VC0"       => [  51,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI debit underflow vc0" ],
   "MD_DEBIT_UNDERFLOW_VC2"       => [  52,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "MD debit underflow vc2" ],
   "MD_DEBIT_UNDERFLOW_VC0"       => [  53,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "MD debit underflow vc0" ],
   "UNDERFLOW_NI_VC3_CREDIT"      => [  54,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit underflow vc3" ],
   "UNDERFLOW_NI_VC2_CREDIT"      => [  55,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit underflow vc2" ],
   "UNDERFLOW_NI_VC1_CREDIT"      => [  56,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit underflow vc1" ],
   "UNDERFLOW_NI_VC0_CREDIT"      => [  57,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit underflow vc0" ],
   "LLP_DEADLOCK_VC3"             => [  58,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [  59,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [  60,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [  61,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
);

%orbit_01_00945_def =
( NAME    => "OC_NI0_ERROR_OVERFLOW_2",
  ADDRESS => 0x00000000d0040530,
  NOTE    => "ni0 Error Overflow Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00945_flds
);


##########################################################################
#                                                                        #
#   OC_NI0_ERROR_OVERFLOW_2_ALIAS                                        #
#                                                                        #
##########################################################################

%orbit_01_00946_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DAM_PI_XMIT_MSG_VC3"          => [   1,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "PI VC3 Xmit Message Lost" ],
   "DAM_PI_XMIT_MSG_VC2"          => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "PI VC2 Xmit Message Lost" ],
   "DAM_PI_XMIT_MSG_VC1"          => [   3,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "PI VC1 Xmit Message Lost" ],
   "DAM_PI_XMIT_MSG_VC0"          => [   4,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC3"          => [   5,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "MD VC3 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC2"          => [   6,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "MD VC2 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC1"          => [   7,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "MD VC1 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC0"          => [   8,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC3"          => [   9,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI VC3 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC2"          => [  10,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI VC2 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC1"          => [  11,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI VC1 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC0"          => [  12,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI VC0 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC3"        => [  13,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC3 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC2"        => [  14,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC1"        => [  15,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC1 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC0"        => [  16,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Xmit Message Lost" ],
   "RETRY_TIMEOUT_ERROR"          => [  17,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [  18,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [  19,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "MD_TAIL_CNT_ERROR"            => [  20,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "MD tail count error" ],
   "PI_TAIL_CNT_ERROR"            => [  21,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI tail count error" ],
   "NI_ILLEGAL_VC"                => [  22,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI illegal vc" ],
   "PI_ILLEGAL_VC"                => [  23,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "PI illegal vc" ],
   "MD_ILLEGAL_VC"                => [  24,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD illegal vc" ],
   "IILB_ILLEGAL_VC"              => [  25,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB illegal vc" ],
   "NI_FAST_TAIL_ERROR"           => [  26,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI fast tail error" ],
   "PI_FAST_TAIL_ERROR"           => [  27,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PI fast tail error" ],
   "MD_FAST_TAIL_ERROR"           => [  28,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD fast tail error" ],
   "IILB_FAST_TAIL_ERROR"         => [  29,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "NI_FAST_TAIL_UNDERFLOW"       => [  30,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fast tail underflow" ],
   "PI_DATA_FAST_TAIL_UNDERFLOW"  => [  31,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "PI data fast tail underflow" ],
   "PI_HDR_FAST_TAIL_UNDERFLOW"   => [  32,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail underflow" ],
   "MD_DATA_FAST_TAIL_UNDERFLOW"  => [  33,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "MD data fast tail underflow" ],
   "MD_HDR_FAST_TAIL_UNDERFLOW"   => [  34,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail underflow" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [  35,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC3" => [  36,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc3" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC2" => [  37,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc2" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC1" => [  38,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc1" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC0" => [  39,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc0" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  40,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc2" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  41,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc2" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  42,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc0" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  43,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc0" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  44,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc2" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  45,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc2" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  46,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc0" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  47,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc0" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC2" => [  48,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc2" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC0" => [  49,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc0" ],
   "PI_DEBIT_UNDERFLOW_VC2"       => [  50,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI debit underflow vc2" ],
   "PI_DEBIT_UNDERFLOW_VC0"       => [  51,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI debit underflow vc0" ],
   "MD_DEBIT_UNDERFLOW_VC2"       => [  52,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "MD debit underflow vc2" ],
   "MD_DEBIT_UNDERFLOW_VC0"       => [  53,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "MD debit underflow vc0" ],
   "UNDERFLOW_NI_VC3_CREDIT"      => [  54,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit underflow vc3" ],
   "UNDERFLOW_NI_VC2_CREDIT"      => [  55,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit underflow vc2" ],
   "UNDERFLOW_NI_VC1_CREDIT"      => [  56,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit underflow vc1" ],
   "UNDERFLOW_NI_VC0_CREDIT"      => [  57,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit underflow vc0" ],
   "LLP_DEADLOCK_VC3"             => [  58,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [  59,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [  60,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [  61,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
);

%orbit_01_00946_def =
( NAME    => "OC_NI0_ERROR_OVERFLOW_2_ALIAS",
  ADDRESS => 0x00000000d0040538,
  NOTE    => "ni0 Error Overflow Bits Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00946_flds
);


##########################################################################
#                                                                        #
#   OC_NI0_ERROR_MASK_1                                                  #
#                                                                        #
##########################################################################

%orbit_01_00947_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_TAIL_TIMEOUT_VC3"          => [   1,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "NI tail timeout vc3" ],
   "NI_TAIL_TIMEOUT_VC2"          => [   2,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "NI tail timeout vc2" ],
   "NI_TAIL_TIMEOUT_VC1"          => [   3,  59,   1, 0x0800000000000000, 0x00, 1, 0x0000000000000000, "NI tail timeout vc1" ],
   "NI_TAIL_TIMEOUT_VC0"          => [   4,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "NI tail timeout vc0" ],
   "PI_TAIL_TIMEOUT_VC3"          => [   5,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "PI tail timeout vc3" ],
   "PI_TAIL_TIMEOUT_VC2"          => [   6,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "PI tail timeout vc2" ],
   "PI_TAIL_TIMEOUT_VC1"          => [   7,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "PI tail timeout vc1" ],
   "PI_TAIL_TIMEOUT_VC0"          => [   8,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "PI tail timeout vc0" ],
   "MD_TAIL_TIMEOUT_VC3"          => [   9,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "MD tail timeout vc3" ],
   "MD_TAIL_TIMEOUT_VC2"          => [  10,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "MD tail timeout vc2" ],
   "MD_TAIL_TIMEOUT_VC1"          => [  11,  51,   1, 0x0008000000000000, 0x00, 1, 0x0000000000000000, "MD tail timeout vc1" ],
   "MD_TAIL_TIMEOUT_VC0"          => [  12,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "MD tail timeout vc0" ],
   "IILB_TAIL_TIMEOUT_VC3"        => [  13,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "IILB tail timeout vc3" ],
   "IILB_TAIL_TIMEOUT_VC2"        => [  14,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "IILB tail timeout vc2" ],
   "IILB_TAIL_TIMEOUT_VC1"        => [  15,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "IILB tail timeout vc1" ],
   "IILB_TAIL_TIMEOUT_VC0"        => [  16,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "IILB tail timeout vc0" ],
   "NI_DEBITSAVER_OVERFLOW_VC3"   => [  17,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "NI debitsaver overflow vc3" ],
   "NI_DEBITSAVER_OVERFLOW_VC2"   => [  18,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "NI debitsaver overflow vc2" ],
   "NI_DEBITSAVER_OVERFLOW_VC1"   => [  19,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "NI debitsaver overflow vc1" ],
   "NI_DEBITSAVER_OVERFLOW_VC0"   => [  20,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "NI debitsaver overflow vc0" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC3"   => [  21,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "NI queue counter overflow vc3" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC2"   => [  22,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "NI queue counter overflow vc2" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC1"   => [  23,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "NI queue counter overflow vc1" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC0"   => [  24,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "NI queue counter overflow vc0" ],
   "NI_FAST_TAIL_OVERFLOW"        => [  25,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "NI fast tail overflow" ],
   "PI_DATA_FAST_TAIL_OVERFLOW"   => [  26,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "PI data fast tail overflow" ],
   "PI_HDR_FAST_TAIL_OVERFLOW"    => [  27,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "PI hdr fast tail overflow" ],
   "MD_DATA_FAST_TAIL_OVERFLOW"   => [  28,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "MD data fast tail overflow" ],
   "MD_HDR_FAST_TAIL_OVERFLOW"    => [  29,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "MD hdr fast tail overflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  30,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "IILB fast tail overflow" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC3"  => [  31,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "NI fifo overflow vc3" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC2"  => [  32,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "NI fifo overflow vc2" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC1"  => [  33,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "NI fifo overflow vc1" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC0"  => [  34,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "NI fifo overflow vc0" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  35,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "PI data fifo overflow vc2" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  36,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "PI hdr fifo overflow vc2" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  37,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "PI data fifo overflow vc0" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  38,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "PI hdr fifo overflow vc0" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  39,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "MD data fifo overflow vc2" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  40,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "MD hdr fifo overflow vc2" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  41,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "MD data fifo overflow vc0" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  42,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "MD hdr fifo overflow vc0" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC2" => [  43,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "IILB fifo overflow vc2" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC0" => [  44,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "IILB fifo overflow vc0" ],
   "NI_DEBIT_OVERFLOW_VC3"        => [  45,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "NI debit overflow vc3" ],
   "NI_DEBIT_OVERFLOW_VC2"        => [  46,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "NI debit overflow vc2" ],
   "NI_DEBIT_OVERFLOW_VC1"        => [  47,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "NI debit overflow vc1" ],
   "NI_DEBIT_OVERFLOW_VC0"        => [  48,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "NI debit overflow vc0" ],
   "PI_DEBIT_OVERFLOW_VC2"        => [  49,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "PI debit overflow vc2" ],
   "PI_DEBIT_OVERFLOW_VC0"        => [  50,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "PI debit overflow vc0" ],
   "MD_DEBIT_OVERFLOW_VC2"        => [  51,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "MD debit overflow vc2" ],
   "MD_DEBIT_OVERFLOW_VC0"        => [  52,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "MD debit overflow vc0" ],
   "IILB_DEBIT_OVERFLOW_VC2"      => [  53,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "IILB debit overflow vc2" ],
   "IILB_DEBIT_OVERFLOW_VC0"      => [  54,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "IILB debit overflow vc0" ],
   "OVERFLOW_NI_VC3_CREDIT"       => [  55,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "NI credit overflow vc3" ],
   "OVERFLOW_NI_VC2_CREDIT"       => [  56,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "NI credit overflow vc2" ],
   "OVERFLOW_NI_VC1_CREDIT"       => [  57,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "NI credit overflow vc1" ],
   "OVERFLOW_NI_VC0_CREDIT"       => [  58,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "NI credit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT3"          => [  59,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT2"          => [  60,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT1"          => [  61,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT0"          => [  62,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "llp debit overflow vc0" ],
);

%orbit_01_00947_def =
( NAME    => "OC_NI0_ERROR_MASK_1",
  ADDRESS => 0x00000000d0040540,
  NOTE    => "ni0 Error Mask Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00947_flds
);


##########################################################################
#                                                                        #
#   OC_NI0_ERROR_MASK_2                                                  #
#                                                                        #
##########################################################################

%orbit_01_00948_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DAM_PI_XMIT_MSG_VC3"          => [   1,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "PI VC3 Xmit Message Lost" ],
   "DAM_PI_XMIT_MSG_VC2"          => [   2,  59,   1, 0x0800000000000000, 0x00, 1, 0x0000000000000000, "PI VC2 Xmit Message Lost" ],
   "DAM_PI_XMIT_MSG_VC1"          => [   3,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "PI VC1 Xmit Message Lost" ],
   "DAM_PI_XMIT_MSG_VC0"          => [   4,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "PI VC0 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC3"          => [   5,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "MD VC3 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC2"          => [   6,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "MD VC2 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC1"          => [   7,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "MD VC1 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC0"          => [   8,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "MD VC0 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC3"          => [   9,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "NI VC3 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC2"          => [  10,  51,   1, 0x0008000000000000, 0x00, 1, 0x0000000000000000, "NI VC2 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC1"          => [  11,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "NI VC1 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC0"          => [  12,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "NI VC0 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC3"        => [  13,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "IILB VC3 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC2"        => [  14,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "IILB VC2 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC1"        => [  15,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "IILB VC1 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC0"        => [  16,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "IILB VC0 Xmit Message Lost" ],
   "RETRY_TIMEOUT_ERROR"          => [  17,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [  18,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [  19,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "chiplet nomatch" ],
   "MD_TAIL_CNT_ERROR"            => [  20,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "MD tail count error" ],
   "PI_TAIL_CNT_ERROR"            => [  21,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "PI tail count error" ],
   "NI_ILLEGAL_VC"                => [  22,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "NI illegal vc" ],
   "PI_ILLEGAL_VC"                => [  23,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "PI illegal vc" ],
   "MD_ILLEGAL_VC"                => [  24,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "MD illegal vc" ],
   "IILB_ILLEGAL_VC"              => [  25,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "IILB illegal vc" ],
   "NI_FAST_TAIL_ERROR"           => [  26,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "NI fast tail error" ],
   "PI_FAST_TAIL_ERROR"           => [  27,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "PI fast tail error" ],
   "MD_FAST_TAIL_ERROR"           => [  28,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "MD fast tail error" ],
   "IILB_FAST_TAIL_ERROR"         => [  29,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "IILB fast tail error" ],
   "NI_FAST_TAIL_UNDERFLOW"       => [  30,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "NI fast tail underflow" ],
   "PI_DATA_FAST_TAIL_UNDERFLOW"  => [  31,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "PI data fast tail underflow" ],
   "PI_HDR_FAST_TAIL_UNDERFLOW"   => [  32,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "PI hdr fast tail underflow" ],
   "MD_DATA_FAST_TAIL_UNDERFLOW"  => [  33,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "MD data fast tail underflow" ],
   "MD_HDR_FAST_TAIL_UNDERFLOW"   => [  34,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "MD hdr fast tail underflow" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [  35,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "IILB fast tail underflow" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC3" => [  36,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "NI fifo underflow vc3" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC2" => [  37,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "NI fifo underflow vc2" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC1" => [  38,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "NI fifo underflow vc1" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC0" => [  39,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "NI fifo underflow vc0" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  40,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "PI data fifo underflow vc2" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  41,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "PI hdr fifo underflow vc2" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  42,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "PI data fifo underflow vc0" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  43,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "PI hdr fifo underflow vc0" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  44,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "MD data fifo underflow vc2" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  45,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "MD hdr fifo underflow vc2" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  46,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "MD data fifo underflow vc0" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  47,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "MD hdr fifo underflow vc0" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC2" => [  48,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "IILB fifo underflow vc2" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC0" => [  49,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "IILB fifo underflow vc0" ],
   "PI_DEBIT_UNDERFLOW_VC2"       => [  50,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "PI debit underflow vc2" ],
   "PI_DEBIT_UNDERFLOW_VC0"       => [  51,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "PI debit underflow vc0" ],
   "MD_DEBIT_UNDERFLOW_VC2"       => [  52,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "MD debit underflow vc2" ],
   "MD_DEBIT_UNDERFLOW_VC0"       => [  53,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "MD debit underflow vc0" ],
   "UNDERFLOW_NI_VC3_CREDIT"      => [  54,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "NI credit underflow vc3" ],
   "UNDERFLOW_NI_VC2_CREDIT"      => [  55,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "NI credit underflow vc2" ],
   "UNDERFLOW_NI_VC1_CREDIT"      => [  56,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "NI credit underflow vc1" ],
   "UNDERFLOW_NI_VC0_CREDIT"      => [  57,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "NI credit underflow vc0" ],
   "LLP_DEADLOCK_VC3"             => [  58,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [  59,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [  60,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [  61,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "llp deadlock vc0" ],
);

%orbit_01_00948_def =
( NAME    => "OC_NI0_ERROR_MASK_2",
  ADDRESS => 0x00000000d0040550,
  NOTE    => "ni0 Error Mask Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00948_flds
);


##########################################################################
#                                                                        #
#   OC_NI0_FIRST_ERROR_1                                                 #
#                                                                        #
##########################################################################

%orbit_01_00949_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_TAIL_TIMEOUT_VC3"          => [   1,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc3" ],
   "NI_TAIL_TIMEOUT_VC2"          => [   2,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc2" ],
   "NI_TAIL_TIMEOUT_VC1"          => [   3,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc1" ],
   "NI_TAIL_TIMEOUT_VC0"          => [   4,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc0" ],
   "PI_TAIL_TIMEOUT_VC3"          => [   5,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc3" ],
   "PI_TAIL_TIMEOUT_VC2"          => [   6,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc2" ],
   "PI_TAIL_TIMEOUT_VC1"          => [   7,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc1" ],
   "PI_TAIL_TIMEOUT_VC0"          => [   8,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc0" ],
   "MD_TAIL_TIMEOUT_VC3"          => [   9,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc3" ],
   "MD_TAIL_TIMEOUT_VC2"          => [  10,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc2" ],
   "MD_TAIL_TIMEOUT_VC1"          => [  11,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc1" ],
   "MD_TAIL_TIMEOUT_VC0"          => [  12,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc0" ],
   "IILB_TAIL_TIMEOUT_VC3"        => [  13,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc3" ],
   "IILB_TAIL_TIMEOUT_VC2"        => [  14,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc2" ],
   "IILB_TAIL_TIMEOUT_VC1"        => [  15,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc1" ],
   "IILB_TAIL_TIMEOUT_VC0"        => [  16,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc0" ],
   "NI_DEBITSAVER_OVERFLOW_VC3"   => [  17,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc3" ],
   "NI_DEBITSAVER_OVERFLOW_VC2"   => [  18,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc2" ],
   "NI_DEBITSAVER_OVERFLOW_VC1"   => [  19,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc1" ],
   "NI_DEBITSAVER_OVERFLOW_VC0"   => [  20,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc0" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC3"   => [  21,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc3" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC2"   => [  22,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc2" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC1"   => [  23,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc1" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC0"   => [  24,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc0" ],
   "NI_FAST_TAIL_OVERFLOW"        => [  25,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI fast tail overflow" ],
   "PI_DATA_FAST_TAIL_OVERFLOW"   => [  26,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail overflow" ],
   "PI_HDR_FAST_TAIL_OVERFLOW"    => [  27,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail overflow" ],
   "MD_DATA_FAST_TAIL_OVERFLOW"   => [  28,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "MD data fast tail overflow" ],
   "MD_HDR_FAST_TAIL_OVERFLOW"    => [  29,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail overflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  30,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC3"  => [  31,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc3" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC2"  => [  32,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc2" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC1"  => [  33,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc1" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC0"  => [  34,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc0" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  35,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc2" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  36,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc2" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  37,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc0" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  38,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc0" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  39,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc2" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  40,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc2" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  41,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc0" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  42,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc0" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC2" => [  43,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc2" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC0" => [  44,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc0" ],
   "NI_DEBIT_OVERFLOW_VC3"        => [  45,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc3" ],
   "NI_DEBIT_OVERFLOW_VC2"        => [  46,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc2" ],
   "NI_DEBIT_OVERFLOW_VC1"        => [  47,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc1" ],
   "NI_DEBIT_OVERFLOW_VC0"        => [  48,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc0" ],
   "PI_DEBIT_OVERFLOW_VC2"        => [  49,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc2" ],
   "PI_DEBIT_OVERFLOW_VC0"        => [  50,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc0" ],
   "MD_DEBIT_OVERFLOW_VC2"        => [  51,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "MD debit overflow vc2" ],
   "MD_DEBIT_OVERFLOW_VC0"        => [  52,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "MD debit overflow vc0" ],
   "IILB_DEBIT_OVERFLOW_VC2"      => [  53,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc2" ],
   "IILB_DEBIT_OVERFLOW_VC0"      => [  54,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc0" ],
   "OVERFLOW_NI_VC3_CREDIT"       => [  55,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit overflow vc3" ],
   "OVERFLOW_NI_VC2_CREDIT"       => [  56,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit overflow vc2" ],
   "OVERFLOW_NI_VC1_CREDIT"       => [  57,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit overflow vc1" ],
   "OVERFLOW_NI_VC0_CREDIT"       => [  58,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT3"          => [  59,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT2"          => [  60,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT1"          => [  61,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT0"          => [  62,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
);

%orbit_01_00949_def =
( NAME    => "OC_NI0_FIRST_ERROR_1",
  ADDRESS => 0x00000000d0040560,
  NOTE    => "ni0 First Error Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00949_flds
);


##########################################################################
#                                                                        #
#   OC_NI0_FIRST_ERROR_2                                                 #
#                                                                        #
##########################################################################

%orbit_01_00950_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DAM_PI_XMIT_MSG_VC3"          => [   1,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "PI VC3 Xmit Message Lost" ],
   "DAM_PI_XMIT_MSG_VC2"          => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "PI VC2 Xmit Message Lost" ],
   "DAM_PI_XMIT_MSG_VC1"          => [   3,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "PI VC1 Xmit Message Lost" ],
   "DAM_PI_XMIT_MSG_VC0"          => [   4,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC3"          => [   5,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "MD VC3 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC2"          => [   6,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "MD VC2 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC1"          => [   7,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "MD VC1 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC0"          => [   8,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC3"          => [   9,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI VC3 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC2"          => [  10,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI VC2 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC1"          => [  11,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI VC1 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC0"          => [  12,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI VC0 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC3"        => [  13,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC3 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC2"        => [  14,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC1"        => [  15,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC1 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC0"        => [  16,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Xmit Message Lost" ],
   "RETRY_TIMEOUT_ERROR"          => [  17,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [  18,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [  19,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "MD_TAIL_CNT_ERROR"            => [  20,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "MD tail count error" ],
   "PI_TAIL_CNT_ERROR"            => [  21,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI tail count error" ],
   "NI_ILLEGAL_VC"                => [  22,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI illegal vc" ],
   "PI_ILLEGAL_VC"                => [  23,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "PI illegal vc" ],
   "MD_ILLEGAL_VC"                => [  24,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD illegal vc" ],
   "IILB_ILLEGAL_VC"              => [  25,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB illegal vc" ],
   "NI_FAST_TAIL_ERROR"           => [  26,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI fast tail error" ],
   "PI_FAST_TAIL_ERROR"           => [  27,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PI fast tail error" ],
   "MD_FAST_TAIL_ERROR"           => [  28,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD fast tail error" ],
   "IILB_FAST_TAIL_ERROR"         => [  29,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "NI_FAST_TAIL_UNDERFLOW"       => [  30,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fast tail underflow" ],
   "PI_DATA_FAST_TAIL_UNDERFLOW"  => [  31,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "PI data fast tail underflow" ],
   "PI_HDR_FAST_TAIL_UNDERFLOW"   => [  32,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail underflow" ],
   "MD_DATA_FAST_TAIL_UNDERFLOW"  => [  33,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "MD data fast tail underflow" ],
   "MD_HDR_FAST_TAIL_UNDERFLOW"   => [  34,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail underflow" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [  35,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC3" => [  36,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc3" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC2" => [  37,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc2" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC1" => [  38,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc1" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC0" => [  39,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc0" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  40,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc2" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  41,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc2" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  42,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc0" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  43,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc0" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  44,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc2" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  45,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc2" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  46,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc0" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  47,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc0" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC2" => [  48,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc2" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC0" => [  49,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc0" ],
   "PI_DEBIT_UNDERFLOW_VC2"       => [  50,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI debit underflow vc2" ],
   "PI_DEBIT_UNDERFLOW_VC0"       => [  51,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI debit underflow vc0" ],
   "MD_DEBIT_UNDERFLOW_VC2"       => [  52,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "MD debit underflow vc2" ],
   "MD_DEBIT_UNDERFLOW_VC0"       => [  53,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "MD debit underflow vc0" ],
   "UNDERFLOW_NI_VC3_CREDIT"      => [  54,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit underflow vc3" ],
   "UNDERFLOW_NI_VC2_CREDIT"      => [  55,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit underflow vc2" ],
   "UNDERFLOW_NI_VC1_CREDIT"      => [  56,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit underflow vc1" ],
   "UNDERFLOW_NI_VC0_CREDIT"      => [  57,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit underflow vc0" ],
   "LLP_DEADLOCK_VC3"             => [  58,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [  59,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [  60,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [  61,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
);

%orbit_01_00950_def =
( NAME    => "OC_NI0_FIRST_ERROR_2",
  ADDRESS => 0x00000000d0040570,
  NOTE    => "ni0 First Error Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00950_flds
);


##########################################################################
#                                                                        #
#   OC_NI0_ERROR_DETAIL_1                                                #
#                                                                        #
##########################################################################

%orbit_01_00951_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Header bits 63:0" ],
);

%orbit_01_00951_def =
( NAME    => "OC_NI0_ERROR_DETAIL_1",
  ADDRESS => 0x00000000d0040580,
  NOTE    => "ni0 Chiplet no match header bits 63:0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00951_flds
);


##########################################################################
#                                                                        #
#   OC_NI0_ERROR_DETAIL_2                                                #
#                                                                        #
##########################################################################

%orbit_01_00952_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Header bits 127:64" ],
);

%orbit_01_00952_def =
( NAME    => "OC_NI0_ERROR_DETAIL_2",
  ADDRESS => 0x00000000d0040590,
  NOTE    => "ni0 Chiplet no match header bits 127:64",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00952_flds
);


##########################################################################
#                                                                        #
#   OC_NI1_ERROR_SUMMARY_1                                               #
#                                                                        #
##########################################################################

%orbit_01_00953_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_TAIL_TIMEOUT_VC3"          => [   1,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc3" ],
   "NI_TAIL_TIMEOUT_VC2"          => [   2,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc2" ],
   "NI_TAIL_TIMEOUT_VC1"          => [   3,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc1" ],
   "NI_TAIL_TIMEOUT_VC0"          => [   4,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc0" ],
   "PI_TAIL_TIMEOUT_VC3"          => [   5,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc3" ],
   "PI_TAIL_TIMEOUT_VC2"          => [   6,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc2" ],
   "PI_TAIL_TIMEOUT_VC1"          => [   7,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc1" ],
   "PI_TAIL_TIMEOUT_VC0"          => [   8,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc0" ],
   "MD_TAIL_TIMEOUT_VC3"          => [   9,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc3" ],
   "MD_TAIL_TIMEOUT_VC2"          => [  10,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc2" ],
   "MD_TAIL_TIMEOUT_VC1"          => [  11,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc1" ],
   "MD_TAIL_TIMEOUT_VC0"          => [  12,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc0" ],
   "IILB_TAIL_TIMEOUT_VC3"        => [  13,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc3" ],
   "IILB_TAIL_TIMEOUT_VC2"        => [  14,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc2" ],
   "IILB_TAIL_TIMEOUT_VC1"        => [  15,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc1" ],
   "IILB_TAIL_TIMEOUT_VC0"        => [  16,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc0" ],
   "NI_DEBITSAVER_OVERFLOW_VC3"   => [  17,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc3" ],
   "NI_DEBITSAVER_OVERFLOW_VC2"   => [  18,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc2" ],
   "NI_DEBITSAVER_OVERFLOW_VC1"   => [  19,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc1" ],
   "NI_DEBITSAVER_OVERFLOW_VC0"   => [  20,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc0" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC3"   => [  21,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc3" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC2"   => [  22,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc2" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC1"   => [  23,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc1" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC0"   => [  24,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc0" ],
   "NI_FAST_TAIL_OVERFLOW"        => [  25,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI fast tail overflow" ],
   "PI_DATA_FAST_TAIL_OVERFLOW"   => [  26,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail overflow" ],
   "PI_HDR_FAST_TAIL_OVERFLOW"    => [  27,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail overflow" ],
   "MD_DATA_FAST_TAIL_OVERFLOW"   => [  28,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "MD data fast tail overflow" ],
   "MD_HDR_FAST_TAIL_OVERFLOW"    => [  29,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail overflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  30,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC3"  => [  31,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc3" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC2"  => [  32,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc2" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC1"  => [  33,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc1" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC0"  => [  34,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc0" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  35,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc2" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  36,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc2" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  37,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc0" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  38,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc0" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  39,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc2" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  40,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc2" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  41,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc0" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  42,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc0" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC2" => [  43,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc2" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC0" => [  44,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc0" ],
   "NI_DEBIT_OVERFLOW_VC3"        => [  45,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc3" ],
   "NI_DEBIT_OVERFLOW_VC2"        => [  46,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc2" ],
   "NI_DEBIT_OVERFLOW_VC1"        => [  47,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc1" ],
   "NI_DEBIT_OVERFLOW_VC0"        => [  48,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc0" ],
   "PI_DEBIT_OVERFLOW_VC2"        => [  49,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc2" ],
   "PI_DEBIT_OVERFLOW_VC0"        => [  50,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc0" ],
   "MD_DEBIT_OVERFLOW_VC2"        => [  51,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "MD debit overflow vc2" ],
   "MD_DEBIT_OVERFLOW_VC0"        => [  52,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "MD debit overflow vc0" ],
   "IILB_DEBIT_OVERFLOW_VC2"      => [  53,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc2" ],
   "IILB_DEBIT_OVERFLOW_VC0"      => [  54,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc0" ],
   "OVERFLOW_NI_VC3_CREDIT"       => [  55,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit overflow vc3" ],
   "OVERFLOW_NI_VC2_CREDIT"       => [  56,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit overflow vc2" ],
   "OVERFLOW_NI_VC1_CREDIT"       => [  57,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit overflow vc1" ],
   "OVERFLOW_NI_VC0_CREDIT"       => [  58,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT3"          => [  59,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT2"          => [  60,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT1"          => [  61,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT0"          => [  62,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
);

%orbit_01_00953_def =
( NAME    => "OC_NI1_ERROR_SUMMARY_1",
  ADDRESS => 0x00000000d0040600,
  NOTE    => "ni1 Error Summary Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00953_flds
);


##########################################################################
#                                                                        #
#   OC_NI1_ERROR_SUMMARY_1_ALIAS                                         #
#                                                                        #
##########################################################################

%orbit_01_00954_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_TAIL_TIMEOUT_VC3"          => [   1,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc3" ],
   "NI_TAIL_TIMEOUT_VC2"          => [   2,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc2" ],
   "NI_TAIL_TIMEOUT_VC1"          => [   3,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc1" ],
   "NI_TAIL_TIMEOUT_VC0"          => [   4,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc0" ],
   "PI_TAIL_TIMEOUT_VC3"          => [   5,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc3" ],
   "PI_TAIL_TIMEOUT_VC2"          => [   6,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc2" ],
   "PI_TAIL_TIMEOUT_VC1"          => [   7,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc1" ],
   "PI_TAIL_TIMEOUT_VC0"          => [   8,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc0" ],
   "MD_TAIL_TIMEOUT_VC3"          => [   9,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc3" ],
   "MD_TAIL_TIMEOUT_VC2"          => [  10,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc2" ],
   "MD_TAIL_TIMEOUT_VC1"          => [  11,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc1" ],
   "MD_TAIL_TIMEOUT_VC0"          => [  12,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc0" ],
   "IILB_TAIL_TIMEOUT_VC3"        => [  13,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc3" ],
   "IILB_TAIL_TIMEOUT_VC2"        => [  14,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc2" ],
   "IILB_TAIL_TIMEOUT_VC1"        => [  15,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc1" ],
   "IILB_TAIL_TIMEOUT_VC0"        => [  16,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc0" ],
   "NI_DEBITSAVER_OVERFLOW_VC3"   => [  17,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc3" ],
   "NI_DEBITSAVER_OVERFLOW_VC2"   => [  18,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc2" ],
   "NI_DEBITSAVER_OVERFLOW_VC1"   => [  19,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc1" ],
   "NI_DEBITSAVER_OVERFLOW_VC0"   => [  20,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc0" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC3"   => [  21,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc3" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC2"   => [  22,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc2" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC1"   => [  23,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc1" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC0"   => [  24,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc0" ],
   "NI_FAST_TAIL_OVERFLOW"        => [  25,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI fast tail overflow" ],
   "PI_DATA_FAST_TAIL_OVERFLOW"   => [  26,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail overflow" ],
   "PI_HDR_FAST_TAIL_OVERFLOW"    => [  27,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail overflow" ],
   "MD_DATA_FAST_TAIL_OVERFLOW"   => [  28,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "MD data fast tail overflow" ],
   "MD_HDR_FAST_TAIL_OVERFLOW"    => [  29,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail overflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  30,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC3"  => [  31,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc3" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC2"  => [  32,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc2" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC1"  => [  33,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc1" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC0"  => [  34,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc0" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  35,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc2" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  36,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc2" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  37,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc0" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  38,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc0" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  39,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc2" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  40,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc2" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  41,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc0" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  42,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc0" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC2" => [  43,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc2" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC0" => [  44,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc0" ],
   "NI_DEBIT_OVERFLOW_VC3"        => [  45,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc3" ],
   "NI_DEBIT_OVERFLOW_VC2"        => [  46,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc2" ],
   "NI_DEBIT_OVERFLOW_VC1"        => [  47,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc1" ],
   "NI_DEBIT_OVERFLOW_VC0"        => [  48,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc0" ],
   "PI_DEBIT_OVERFLOW_VC2"        => [  49,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc2" ],
   "PI_DEBIT_OVERFLOW_VC0"        => [  50,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc0" ],
   "MD_DEBIT_OVERFLOW_VC2"        => [  51,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "MD debit overflow vc2" ],
   "MD_DEBIT_OVERFLOW_VC0"        => [  52,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "MD debit overflow vc0" ],
   "IILB_DEBIT_OVERFLOW_VC2"      => [  53,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc2" ],
   "IILB_DEBIT_OVERFLOW_VC0"      => [  54,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc0" ],
   "OVERFLOW_NI_VC3_CREDIT"       => [  55,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit overflow vc3" ],
   "OVERFLOW_NI_VC2_CREDIT"       => [  56,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit overflow vc2" ],
   "OVERFLOW_NI_VC1_CREDIT"       => [  57,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit overflow vc1" ],
   "OVERFLOW_NI_VC0_CREDIT"       => [  58,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT3"          => [  59,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT2"          => [  60,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT1"          => [  61,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT0"          => [  62,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
);

%orbit_01_00954_def =
( NAME    => "OC_NI1_ERROR_SUMMARY_1_ALIAS",
  ADDRESS => 0x00000000d0040608,
  NOTE    => "ni1 Error Summary Bits Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00954_flds
);


##########################################################################
#                                                                        #
#   OC_NI1_ERROR_SUMMARY_2                                               #
#                                                                        #
##########################################################################

%orbit_01_00955_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DAM_PI_XMIT_MSG_VC3"          => [   1,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "PI VC3 Xmit Message Lost" ],
   "DAM_PI_XMIT_MSG_VC2"          => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "PI VC2 Xmit Message Lost" ],
   "DAM_PI_XMIT_MSG_VC1"          => [   3,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "PI VC1 Xmit Message Lost" ],
   "DAM_PI_XMIT_MSG_VC0"          => [   4,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC3"          => [   5,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "MD VC3 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC2"          => [   6,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "MD VC2 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC1"          => [   7,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "MD VC1 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC0"          => [   8,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC3"          => [   9,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI VC3 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC2"          => [  10,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI VC2 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC1"          => [  11,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI VC1 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC0"          => [  12,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI VC0 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC3"        => [  13,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC3 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC2"        => [  14,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC1"        => [  15,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC1 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC0"        => [  16,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Xmit Message Lost" ],
   "RETRY_TIMEOUT_ERROR"          => [  17,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [  18,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [  19,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "MD_TAIL_CNT_ERROR"            => [  20,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "MD tail count error" ],
   "PI_TAIL_CNT_ERROR"            => [  21,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI tail count error" ],
   "NI_ILLEGAL_VC"                => [  22,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI illegal vc" ],
   "PI_ILLEGAL_VC"                => [  23,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "PI illegal vc" ],
   "MD_ILLEGAL_VC"                => [  24,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD illegal vc" ],
   "IILB_ILLEGAL_VC"              => [  25,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB illegal vc" ],
   "NI_FAST_TAIL_ERROR"           => [  26,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI fast tail error" ],
   "PI_FAST_TAIL_ERROR"           => [  27,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PI fast tail error" ],
   "MD_FAST_TAIL_ERROR"           => [  28,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD fast tail error" ],
   "IILB_FAST_TAIL_ERROR"         => [  29,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "NI_FAST_TAIL_UNDERFLOW"       => [  30,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fast tail underflow" ],
   "PI_DATA_FAST_TAIL_UNDERFLOW"  => [  31,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "PI data fast tail underflow" ],
   "PI_HDR_FAST_TAIL_UNDERFLOW"   => [  32,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail underflow" ],
   "MD_DATA_FAST_TAIL_UNDERFLOW"  => [  33,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "MD data fast tail underflow" ],
   "MD_HDR_FAST_TAIL_UNDERFLOW"   => [  34,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail underflow" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [  35,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC3" => [  36,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc3" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC2" => [  37,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc2" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC1" => [  38,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc1" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC0" => [  39,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc0" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  40,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc2" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  41,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc2" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  42,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc0" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  43,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc0" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  44,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc2" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  45,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc2" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  46,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc0" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  47,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc0" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC2" => [  48,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc2" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC0" => [  49,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc0" ],
   "PI_DEBIT_UNDERFLOW_VC2"       => [  50,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI debit underflow vc2" ],
   "PI_DEBIT_UNDERFLOW_VC0"       => [  51,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI debit underflow vc0" ],
   "MD_DEBIT_UNDERFLOW_VC2"       => [  52,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "MD debit underflow vc2" ],
   "MD_DEBIT_UNDERFLOW_VC0"       => [  53,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "MD debit underflow vc0" ],
   "UNDERFLOW_NI_VC3_CREDIT"      => [  54,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit underflow vc3" ],
   "UNDERFLOW_NI_VC2_CREDIT"      => [  55,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit underflow vc2" ],
   "UNDERFLOW_NI_VC1_CREDIT"      => [  56,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit underflow vc1" ],
   "UNDERFLOW_NI_VC0_CREDIT"      => [  57,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit underflow vc0" ],
   "LLP_DEADLOCK_VC3"             => [  58,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [  59,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [  60,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [  61,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
);

%orbit_01_00955_def =
( NAME    => "OC_NI1_ERROR_SUMMARY_2",
  ADDRESS => 0x00000000d0040610,
  NOTE    => "ni1 Error Summary Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00955_flds
);


##########################################################################
#                                                                        #
#   OC_NI1_ERROR_SUMMARY_2_ALIAS                                         #
#                                                                        #
##########################################################################

%orbit_01_00956_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DAM_PI_XMIT_MSG_VC3"          => [   1,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "PI VC3 Xmit Message Lost" ],
   "DAM_PI_XMIT_MSG_VC2"          => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "PI VC2 Xmit Message Lost" ],
   "DAM_PI_XMIT_MSG_VC1"          => [   3,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "PI VC1 Xmit Message Lost" ],
   "DAM_PI_XMIT_MSG_VC0"          => [   4,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC3"          => [   5,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "MD VC3 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC2"          => [   6,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "MD VC2 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC1"          => [   7,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "MD VC1 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC0"          => [   8,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC3"          => [   9,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI VC3 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC2"          => [  10,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI VC2 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC1"          => [  11,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI VC1 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC0"          => [  12,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI VC0 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC3"        => [  13,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC3 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC2"        => [  14,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC1"        => [  15,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC1 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC0"        => [  16,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Xmit Message Lost" ],
   "RETRY_TIMEOUT_ERROR"          => [  17,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [  18,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [  19,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "MD_TAIL_CNT_ERROR"            => [  20,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "MD tail count error" ],
   "PI_TAIL_CNT_ERROR"            => [  21,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI tail count error" ],
   "NI_ILLEGAL_VC"                => [  22,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI illegal vc" ],
   "PI_ILLEGAL_VC"                => [  23,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "PI illegal vc" ],
   "MD_ILLEGAL_VC"                => [  24,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD illegal vc" ],
   "IILB_ILLEGAL_VC"              => [  25,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB illegal vc" ],
   "NI_FAST_TAIL_ERROR"           => [  26,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI fast tail error" ],
   "PI_FAST_TAIL_ERROR"           => [  27,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PI fast tail error" ],
   "MD_FAST_TAIL_ERROR"           => [  28,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD fast tail error" ],
   "IILB_FAST_TAIL_ERROR"         => [  29,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "NI_FAST_TAIL_UNDERFLOW"       => [  30,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fast tail underflow" ],
   "PI_DATA_FAST_TAIL_UNDERFLOW"  => [  31,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "PI data fast tail underflow" ],
   "PI_HDR_FAST_TAIL_UNDERFLOW"   => [  32,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail underflow" ],
   "MD_DATA_FAST_TAIL_UNDERFLOW"  => [  33,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "MD data fast tail underflow" ],
   "MD_HDR_FAST_TAIL_UNDERFLOW"   => [  34,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail underflow" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [  35,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC3" => [  36,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc3" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC2" => [  37,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc2" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC1" => [  38,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc1" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC0" => [  39,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc0" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  40,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc2" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  41,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc2" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  42,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc0" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  43,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc0" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  44,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc2" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  45,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc2" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  46,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc0" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  47,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc0" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC2" => [  48,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc2" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC0" => [  49,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc0" ],
   "PI_DEBIT_UNDERFLOW_VC2"       => [  50,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI debit underflow vc2" ],
   "PI_DEBIT_UNDERFLOW_VC0"       => [  51,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI debit underflow vc0" ],
   "MD_DEBIT_UNDERFLOW_VC2"       => [  52,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "MD debit underflow vc2" ],
   "MD_DEBIT_UNDERFLOW_VC0"       => [  53,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "MD debit underflow vc0" ],
   "UNDERFLOW_NI_VC3_CREDIT"      => [  54,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit underflow vc3" ],
   "UNDERFLOW_NI_VC2_CREDIT"      => [  55,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit underflow vc2" ],
   "UNDERFLOW_NI_VC1_CREDIT"      => [  56,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit underflow vc1" ],
   "UNDERFLOW_NI_VC0_CREDIT"      => [  57,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit underflow vc0" ],
   "LLP_DEADLOCK_VC3"             => [  58,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [  59,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [  60,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [  61,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
);

%orbit_01_00956_def =
( NAME    => "OC_NI1_ERROR_SUMMARY_2_ALIAS",
  ADDRESS => 0x00000000d0040618,
  NOTE    => "ni1 Error Summary Bits Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00956_flds
);


##########################################################################
#                                                                        #
#   OC_NI1_ERROR_OVERFLOW_1                                              #
#                                                                        #
##########################################################################

%orbit_01_00957_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_TAIL_TIMEOUT_VC3"          => [   1,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc3" ],
   "NI_TAIL_TIMEOUT_VC2"          => [   2,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc2" ],
   "NI_TAIL_TIMEOUT_VC1"          => [   3,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc1" ],
   "NI_TAIL_TIMEOUT_VC0"          => [   4,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc0" ],
   "PI_TAIL_TIMEOUT_VC3"          => [   5,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc3" ],
   "PI_TAIL_TIMEOUT_VC2"          => [   6,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc2" ],
   "PI_TAIL_TIMEOUT_VC1"          => [   7,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc1" ],
   "PI_TAIL_TIMEOUT_VC0"          => [   8,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc0" ],
   "MD_TAIL_TIMEOUT_VC3"          => [   9,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc3" ],
   "MD_TAIL_TIMEOUT_VC2"          => [  10,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc2" ],
   "MD_TAIL_TIMEOUT_VC1"          => [  11,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc1" ],
   "MD_TAIL_TIMEOUT_VC0"          => [  12,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc0" ],
   "IILB_TAIL_TIMEOUT_VC3"        => [  13,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc3" ],
   "IILB_TAIL_TIMEOUT_VC2"        => [  14,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc2" ],
   "IILB_TAIL_TIMEOUT_VC1"        => [  15,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc1" ],
   "IILB_TAIL_TIMEOUT_VC0"        => [  16,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc0" ],
   "NI_DEBITSAVER_OVERFLOW_VC3"   => [  17,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc3" ],
   "NI_DEBITSAVER_OVERFLOW_VC2"   => [  18,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc2" ],
   "NI_DEBITSAVER_OVERFLOW_VC1"   => [  19,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc1" ],
   "NI_DEBITSAVER_OVERFLOW_VC0"   => [  20,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc0" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC3"   => [  21,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc3" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC2"   => [  22,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc2" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC1"   => [  23,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc1" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC0"   => [  24,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc0" ],
   "NI_FAST_TAIL_OVERFLOW"        => [  25,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI fast tail overflow" ],
   "PI_DATA_FAST_TAIL_OVERFLOW"   => [  26,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail overflow" ],
   "PI_HDR_FAST_TAIL_OVERFLOW"    => [  27,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail overflow" ],
   "MD_DATA_FAST_TAIL_OVERFLOW"   => [  28,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "MD data fast tail overflow" ],
   "MD_HDR_FAST_TAIL_OVERFLOW"    => [  29,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail overflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  30,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC3"  => [  31,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc3" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC2"  => [  32,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc2" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC1"  => [  33,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc1" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC0"  => [  34,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc0" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  35,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc2" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  36,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc2" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  37,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc0" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  38,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc0" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  39,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc2" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  40,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc2" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  41,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc0" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  42,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc0" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC2" => [  43,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc2" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC0" => [  44,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc0" ],
   "NI_DEBIT_OVERFLOW_VC3"        => [  45,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc3" ],
   "NI_DEBIT_OVERFLOW_VC2"        => [  46,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc2" ],
   "NI_DEBIT_OVERFLOW_VC1"        => [  47,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc1" ],
   "NI_DEBIT_OVERFLOW_VC0"        => [  48,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc0" ],
   "PI_DEBIT_OVERFLOW_VC2"        => [  49,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc2" ],
   "PI_DEBIT_OVERFLOW_VC0"        => [  50,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc0" ],
   "MD_DEBIT_OVERFLOW_VC2"        => [  51,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "MD debit overflow vc2" ],
   "MD_DEBIT_OVERFLOW_VC0"        => [  52,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "MD debit overflow vc0" ],
   "IILB_DEBIT_OVERFLOW_VC2"      => [  53,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc2" ],
   "IILB_DEBIT_OVERFLOW_VC0"      => [  54,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc0" ],
   "OVERFLOW_NI_VC3_CREDIT"       => [  55,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit overflow vc3" ],
   "OVERFLOW_NI_VC2_CREDIT"       => [  56,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit overflow vc2" ],
   "OVERFLOW_NI_VC1_CREDIT"       => [  57,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit overflow vc1" ],
   "OVERFLOW_NI_VC0_CREDIT"       => [  58,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT3"          => [  59,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT2"          => [  60,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT1"          => [  61,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT0"          => [  62,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
);

%orbit_01_00957_def =
( NAME    => "OC_NI1_ERROR_OVERFLOW_1",
  ADDRESS => 0x00000000d0040620,
  NOTE    => "ni1 Error Overflow Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00957_flds
);


##########################################################################
#                                                                        #
#   OC_NI1_ERROR_OVERFLOW_1_ALIAS                                        #
#                                                                        #
##########################################################################

%orbit_01_00958_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_TAIL_TIMEOUT_VC3"          => [   1,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc3" ],
   "NI_TAIL_TIMEOUT_VC2"          => [   2,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc2" ],
   "NI_TAIL_TIMEOUT_VC1"          => [   3,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc1" ],
   "NI_TAIL_TIMEOUT_VC0"          => [   4,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc0" ],
   "PI_TAIL_TIMEOUT_VC3"          => [   5,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc3" ],
   "PI_TAIL_TIMEOUT_VC2"          => [   6,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc2" ],
   "PI_TAIL_TIMEOUT_VC1"          => [   7,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc1" ],
   "PI_TAIL_TIMEOUT_VC0"          => [   8,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc0" ],
   "MD_TAIL_TIMEOUT_VC3"          => [   9,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc3" ],
   "MD_TAIL_TIMEOUT_VC2"          => [  10,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc2" ],
   "MD_TAIL_TIMEOUT_VC1"          => [  11,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc1" ],
   "MD_TAIL_TIMEOUT_VC0"          => [  12,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc0" ],
   "IILB_TAIL_TIMEOUT_VC3"        => [  13,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc3" ],
   "IILB_TAIL_TIMEOUT_VC2"        => [  14,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc2" ],
   "IILB_TAIL_TIMEOUT_VC1"        => [  15,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc1" ],
   "IILB_TAIL_TIMEOUT_VC0"        => [  16,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc0" ],
   "NI_DEBITSAVER_OVERFLOW_VC3"   => [  17,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc3" ],
   "NI_DEBITSAVER_OVERFLOW_VC2"   => [  18,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc2" ],
   "NI_DEBITSAVER_OVERFLOW_VC1"   => [  19,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc1" ],
   "NI_DEBITSAVER_OVERFLOW_VC0"   => [  20,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc0" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC3"   => [  21,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc3" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC2"   => [  22,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc2" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC1"   => [  23,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc1" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC0"   => [  24,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc0" ],
   "NI_FAST_TAIL_OVERFLOW"        => [  25,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI fast tail overflow" ],
   "PI_DATA_FAST_TAIL_OVERFLOW"   => [  26,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail overflow" ],
   "PI_HDR_FAST_TAIL_OVERFLOW"    => [  27,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail overflow" ],
   "MD_DATA_FAST_TAIL_OVERFLOW"   => [  28,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "MD data fast tail overflow" ],
   "MD_HDR_FAST_TAIL_OVERFLOW"    => [  29,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail overflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  30,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC3"  => [  31,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc3" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC2"  => [  32,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc2" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC1"  => [  33,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc1" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC0"  => [  34,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc0" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  35,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc2" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  36,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc2" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  37,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc0" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  38,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc0" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  39,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc2" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  40,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc2" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  41,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc0" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  42,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc0" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC2" => [  43,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc2" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC0" => [  44,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc0" ],
   "NI_DEBIT_OVERFLOW_VC3"        => [  45,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc3" ],
   "NI_DEBIT_OVERFLOW_VC2"        => [  46,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc2" ],
   "NI_DEBIT_OVERFLOW_VC1"        => [  47,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc1" ],
   "NI_DEBIT_OVERFLOW_VC0"        => [  48,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc0" ],
   "PI_DEBIT_OVERFLOW_VC2"        => [  49,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc2" ],
   "PI_DEBIT_OVERFLOW_VC0"        => [  50,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc0" ],
   "MD_DEBIT_OVERFLOW_VC2"        => [  51,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "MD debit overflow vc2" ],
   "MD_DEBIT_OVERFLOW_VC0"        => [  52,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "MD debit overflow vc0" ],
   "IILB_DEBIT_OVERFLOW_VC2"      => [  53,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc2" ],
   "IILB_DEBIT_OVERFLOW_VC0"      => [  54,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc0" ],
   "OVERFLOW_NI_VC3_CREDIT"       => [  55,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit overflow vc3" ],
   "OVERFLOW_NI_VC2_CREDIT"       => [  56,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit overflow vc2" ],
   "OVERFLOW_NI_VC1_CREDIT"       => [  57,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit overflow vc1" ],
   "OVERFLOW_NI_VC0_CREDIT"       => [  58,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT3"          => [  59,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT2"          => [  60,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT1"          => [  61,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT0"          => [  62,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
);

%orbit_01_00958_def =
( NAME    => "OC_NI1_ERROR_OVERFLOW_1_ALIAS",
  ADDRESS => 0x00000000d0040628,
  NOTE    => "ni1 Error Overflow Bits Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00958_flds
);


##########################################################################
#                                                                        #
#   OC_NI1_ERROR_OVERFLOW_2                                              #
#                                                                        #
##########################################################################

%orbit_01_00959_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DAM_PI_XMIT_MSG_VC3"          => [   1,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "PI VC3 Xmit Message Lost" ],
   "DAM_PI_XMIT_MSG_VC2"          => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "PI VC2 Xmit Message Lost" ],
   "DAM_PI_XMIT_MSG_VC1"          => [   3,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "PI VC1 Xmit Message Lost" ],
   "DAM_PI_XMIT_MSG_VC0"          => [   4,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC3"          => [   5,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "MD VC3 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC2"          => [   6,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "MD VC2 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC1"          => [   7,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "MD VC1 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC0"          => [   8,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC3"          => [   9,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI VC3 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC2"          => [  10,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI VC2 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC1"          => [  11,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI VC1 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC0"          => [  12,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI VC0 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC3"        => [  13,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC3 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC2"        => [  14,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC1"        => [  15,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC1 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC0"        => [  16,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Xmit Message Lost" ],
   "RETRY_TIMEOUT_ERROR"          => [  17,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [  18,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [  19,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "MD_TAIL_CNT_ERROR"            => [  20,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "MD tail count error" ],
   "PI_TAIL_CNT_ERROR"            => [  21,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI tail count error" ],
   "NI_ILLEGAL_VC"                => [  22,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI illegal vc" ],
   "PI_ILLEGAL_VC"                => [  23,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "PI illegal vc" ],
   "MD_ILLEGAL_VC"                => [  24,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD illegal vc" ],
   "IILB_ILLEGAL_VC"              => [  25,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB illegal vc" ],
   "NI_FAST_TAIL_ERROR"           => [  26,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI fast tail error" ],
   "PI_FAST_TAIL_ERROR"           => [  27,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PI fast tail error" ],
   "MD_FAST_TAIL_ERROR"           => [  28,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD fast tail error" ],
   "IILB_FAST_TAIL_ERROR"         => [  29,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "NI_FAST_TAIL_UNDERFLOW"       => [  30,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fast tail underflow" ],
   "PI_DATA_FAST_TAIL_UNDERFLOW"  => [  31,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "PI data fast tail underflow" ],
   "PI_HDR_FAST_TAIL_UNDERFLOW"   => [  32,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail underflow" ],
   "MD_DATA_FAST_TAIL_UNDERFLOW"  => [  33,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "MD data fast tail underflow" ],
   "MD_HDR_FAST_TAIL_UNDERFLOW"   => [  34,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail underflow" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [  35,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC3" => [  36,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc3" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC2" => [  37,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc2" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC1" => [  38,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc1" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC0" => [  39,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc0" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  40,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc2" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  41,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc2" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  42,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc0" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  43,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc0" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  44,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc2" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  45,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc2" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  46,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc0" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  47,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc0" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC2" => [  48,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc2" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC0" => [  49,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc0" ],
   "PI_DEBIT_UNDERFLOW_VC2"       => [  50,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI debit underflow vc2" ],
   "PI_DEBIT_UNDERFLOW_VC0"       => [  51,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI debit underflow vc0" ],
   "MD_DEBIT_UNDERFLOW_VC2"       => [  52,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "MD debit underflow vc2" ],
   "MD_DEBIT_UNDERFLOW_VC0"       => [  53,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "MD debit underflow vc0" ],
   "UNDERFLOW_NI_VC3_CREDIT"      => [  54,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit underflow vc3" ],
   "UNDERFLOW_NI_VC2_CREDIT"      => [  55,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit underflow vc2" ],
   "UNDERFLOW_NI_VC1_CREDIT"      => [  56,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit underflow vc1" ],
   "UNDERFLOW_NI_VC0_CREDIT"      => [  57,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit underflow vc0" ],
   "LLP_DEADLOCK_VC3"             => [  58,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [  59,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [  60,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [  61,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
);

%orbit_01_00959_def =
( NAME    => "OC_NI1_ERROR_OVERFLOW_2",
  ADDRESS => 0x00000000d0040630,
  NOTE    => "ni1 Error Overflow Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00959_flds
);


##########################################################################
#                                                                        #
#   OC_NI1_ERROR_OVERFLOW_2_ALIAS                                        #
#                                                                        #
##########################################################################

%orbit_01_00960_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DAM_PI_XMIT_MSG_VC3"          => [   1,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "PI VC3 Xmit Message Lost" ],
   "DAM_PI_XMIT_MSG_VC2"          => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "PI VC2 Xmit Message Lost" ],
   "DAM_PI_XMIT_MSG_VC1"          => [   3,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "PI VC1 Xmit Message Lost" ],
   "DAM_PI_XMIT_MSG_VC0"          => [   4,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC3"          => [   5,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "MD VC3 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC2"          => [   6,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "MD VC2 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC1"          => [   7,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "MD VC1 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC0"          => [   8,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC3"          => [   9,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI VC3 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC2"          => [  10,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI VC2 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC1"          => [  11,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI VC1 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC0"          => [  12,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI VC0 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC3"        => [  13,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC3 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC2"        => [  14,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC1"        => [  15,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC1 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC0"        => [  16,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Xmit Message Lost" ],
   "RETRY_TIMEOUT_ERROR"          => [  17,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [  18,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [  19,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "MD_TAIL_CNT_ERROR"            => [  20,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "MD tail count error" ],
   "PI_TAIL_CNT_ERROR"            => [  21,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI tail count error" ],
   "NI_ILLEGAL_VC"                => [  22,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI illegal vc" ],
   "PI_ILLEGAL_VC"                => [  23,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "PI illegal vc" ],
   "MD_ILLEGAL_VC"                => [  24,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD illegal vc" ],
   "IILB_ILLEGAL_VC"              => [  25,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB illegal vc" ],
   "NI_FAST_TAIL_ERROR"           => [  26,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI fast tail error" ],
   "PI_FAST_TAIL_ERROR"           => [  27,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PI fast tail error" ],
   "MD_FAST_TAIL_ERROR"           => [  28,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD fast tail error" ],
   "IILB_FAST_TAIL_ERROR"         => [  29,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "NI_FAST_TAIL_UNDERFLOW"       => [  30,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fast tail underflow" ],
   "PI_DATA_FAST_TAIL_UNDERFLOW"  => [  31,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "PI data fast tail underflow" ],
   "PI_HDR_FAST_TAIL_UNDERFLOW"   => [  32,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail underflow" ],
   "MD_DATA_FAST_TAIL_UNDERFLOW"  => [  33,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "MD data fast tail underflow" ],
   "MD_HDR_FAST_TAIL_UNDERFLOW"   => [  34,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail underflow" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [  35,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC3" => [  36,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc3" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC2" => [  37,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc2" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC1" => [  38,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc1" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC0" => [  39,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc0" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  40,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc2" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  41,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc2" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  42,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc0" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  43,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc0" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  44,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc2" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  45,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc2" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  46,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc0" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  47,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc0" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC2" => [  48,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc2" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC0" => [  49,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc0" ],
   "PI_DEBIT_UNDERFLOW_VC2"       => [  50,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI debit underflow vc2" ],
   "PI_DEBIT_UNDERFLOW_VC0"       => [  51,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI debit underflow vc0" ],
   "MD_DEBIT_UNDERFLOW_VC2"       => [  52,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "MD debit underflow vc2" ],
   "MD_DEBIT_UNDERFLOW_VC0"       => [  53,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "MD debit underflow vc0" ],
   "UNDERFLOW_NI_VC3_CREDIT"      => [  54,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit underflow vc3" ],
   "UNDERFLOW_NI_VC2_CREDIT"      => [  55,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit underflow vc2" ],
   "UNDERFLOW_NI_VC1_CREDIT"      => [  56,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit underflow vc1" ],
   "UNDERFLOW_NI_VC0_CREDIT"      => [  57,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit underflow vc0" ],
   "LLP_DEADLOCK_VC3"             => [  58,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [  59,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [  60,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [  61,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
);

%orbit_01_00960_def =
( NAME    => "OC_NI1_ERROR_OVERFLOW_2_ALIAS",
  ADDRESS => 0x00000000d0040638,
  NOTE    => "ni1 Error Overflow Bits Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00960_flds
);


##########################################################################
#                                                                        #
#   OC_NI1_ERROR_MASK_1                                                  #
#                                                                        #
##########################################################################

%orbit_01_00961_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_TAIL_TIMEOUT_VC3"          => [   1,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "NI tail timeout vc3" ],
   "NI_TAIL_TIMEOUT_VC2"          => [   2,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "NI tail timeout vc2" ],
   "NI_TAIL_TIMEOUT_VC1"          => [   3,  59,   1, 0x0800000000000000, 0x00, 1, 0x0000000000000000, "NI tail timeout vc1" ],
   "NI_TAIL_TIMEOUT_VC0"          => [   4,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "NI tail timeout vc0" ],
   "PI_TAIL_TIMEOUT_VC3"          => [   5,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "PI tail timeout vc3" ],
   "PI_TAIL_TIMEOUT_VC2"          => [   6,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "PI tail timeout vc2" ],
   "PI_TAIL_TIMEOUT_VC1"          => [   7,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "PI tail timeout vc1" ],
   "PI_TAIL_TIMEOUT_VC0"          => [   8,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "PI tail timeout vc0" ],
   "MD_TAIL_TIMEOUT_VC3"          => [   9,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "MD tail timeout vc3" ],
   "MD_TAIL_TIMEOUT_VC2"          => [  10,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "MD tail timeout vc2" ],
   "MD_TAIL_TIMEOUT_VC1"          => [  11,  51,   1, 0x0008000000000000, 0x00, 1, 0x0000000000000000, "MD tail timeout vc1" ],
   "MD_TAIL_TIMEOUT_VC0"          => [  12,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "MD tail timeout vc0" ],
   "IILB_TAIL_TIMEOUT_VC3"        => [  13,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "IILB tail timeout vc3" ],
   "IILB_TAIL_TIMEOUT_VC2"        => [  14,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "IILB tail timeout vc2" ],
   "IILB_TAIL_TIMEOUT_VC1"        => [  15,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "IILB tail timeout vc1" ],
   "IILB_TAIL_TIMEOUT_VC0"        => [  16,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "IILB tail timeout vc0" ],
   "NI_DEBITSAVER_OVERFLOW_VC3"   => [  17,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "NI debitsaver overflow vc3" ],
   "NI_DEBITSAVER_OVERFLOW_VC2"   => [  18,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "NI debitsaver overflow vc2" ],
   "NI_DEBITSAVER_OVERFLOW_VC1"   => [  19,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "NI debitsaver overflow vc1" ],
   "NI_DEBITSAVER_OVERFLOW_VC0"   => [  20,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "NI debitsaver overflow vc0" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC3"   => [  21,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "NI queue counter overflow vc3" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC2"   => [  22,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "NI queue counter overflow vc2" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC1"   => [  23,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "NI queue counter overflow vc1" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC0"   => [  24,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "NI queue counter overflow vc0" ],
   "NI_FAST_TAIL_OVERFLOW"        => [  25,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "NI fast tail overflow" ],
   "PI_DATA_FAST_TAIL_OVERFLOW"   => [  26,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "PI data fast tail overflow" ],
   "PI_HDR_FAST_TAIL_OVERFLOW"    => [  27,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "PI hdr fast tail overflow" ],
   "MD_DATA_FAST_TAIL_OVERFLOW"   => [  28,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "MD data fast tail overflow" ],
   "MD_HDR_FAST_TAIL_OVERFLOW"    => [  29,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "MD hdr fast tail overflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  30,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "IILB fast tail overflow" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC3"  => [  31,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "NI fifo overflow vc3" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC2"  => [  32,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "NI fifo overflow vc2" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC1"  => [  33,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "NI fifo overflow vc1" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC0"  => [  34,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "NI fifo overflow vc0" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  35,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "PI data fifo overflow vc2" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  36,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "PI hdr fifo overflow vc2" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  37,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "PI data fifo overflow vc0" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  38,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "PI hdr fifo overflow vc0" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  39,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "MD data fifo overflow vc2" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  40,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "MD hdr fifo overflow vc2" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  41,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "MD data fifo overflow vc0" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  42,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "MD hdr fifo overflow vc0" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC2" => [  43,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "IILB fifo overflow vc2" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC0" => [  44,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "IILB fifo overflow vc0" ],
   "NI_DEBIT_OVERFLOW_VC3"        => [  45,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "NI debit overflow vc3" ],
   "NI_DEBIT_OVERFLOW_VC2"        => [  46,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "NI debit overflow vc2" ],
   "NI_DEBIT_OVERFLOW_VC1"        => [  47,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "NI debit overflow vc1" ],
   "NI_DEBIT_OVERFLOW_VC0"        => [  48,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "NI debit overflow vc0" ],
   "PI_DEBIT_OVERFLOW_VC2"        => [  49,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "PI debit overflow vc2" ],
   "PI_DEBIT_OVERFLOW_VC0"        => [  50,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "PI debit overflow vc0" ],
   "MD_DEBIT_OVERFLOW_VC2"        => [  51,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "MD debit overflow vc2" ],
   "MD_DEBIT_OVERFLOW_VC0"        => [  52,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "MD debit overflow vc0" ],
   "IILB_DEBIT_OVERFLOW_VC2"      => [  53,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "IILB debit overflow vc2" ],
   "IILB_DEBIT_OVERFLOW_VC0"      => [  54,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "IILB debit overflow vc0" ],
   "OVERFLOW_NI_VC3_CREDIT"       => [  55,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "NI credit overflow vc3" ],
   "OVERFLOW_NI_VC2_CREDIT"       => [  56,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "NI credit overflow vc2" ],
   "OVERFLOW_NI_VC1_CREDIT"       => [  57,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "NI credit overflow vc1" ],
   "OVERFLOW_NI_VC0_CREDIT"       => [  58,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "NI credit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT3"          => [  59,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT2"          => [  60,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT1"          => [  61,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT0"          => [  62,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "llp debit overflow vc0" ],
);

%orbit_01_00961_def =
( NAME    => "OC_NI1_ERROR_MASK_1",
  ADDRESS => 0x00000000d0040640,
  NOTE    => "ni1 Error Mask Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00961_flds
);


##########################################################################
#                                                                        #
#   OC_NI1_ERROR_MASK_2                                                  #
#                                                                        #
##########################################################################

%orbit_01_00962_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DAM_PI_XMIT_MSG_VC3"          => [   1,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "PI VC3 Xmit Message Lost" ],
   "DAM_PI_XMIT_MSG_VC2"          => [   2,  59,   1, 0x0800000000000000, 0x00, 1, 0x0000000000000000, "PI VC2 Xmit Message Lost" ],
   "DAM_PI_XMIT_MSG_VC1"          => [   3,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "PI VC1 Xmit Message Lost" ],
   "DAM_PI_XMIT_MSG_VC0"          => [   4,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "PI VC0 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC3"          => [   5,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "MD VC3 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC2"          => [   6,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "MD VC2 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC1"          => [   7,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "MD VC1 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC0"          => [   8,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "MD VC0 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC3"          => [   9,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "NI VC3 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC2"          => [  10,  51,   1, 0x0008000000000000, 0x00, 1, 0x0000000000000000, "NI VC2 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC1"          => [  11,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "NI VC1 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC0"          => [  12,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "NI VC0 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC3"        => [  13,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "IILB VC3 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC2"        => [  14,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "IILB VC2 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC1"        => [  15,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "IILB VC1 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC0"        => [  16,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "IILB VC0 Xmit Message Lost" ],
   "RETRY_TIMEOUT_ERROR"          => [  17,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [  18,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [  19,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "chiplet nomatch" ],
   "MD_TAIL_CNT_ERROR"            => [  20,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "MD tail count error" ],
   "PI_TAIL_CNT_ERROR"            => [  21,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "PI tail count error" ],
   "NI_ILLEGAL_VC"                => [  22,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "NI illegal vc" ],
   "PI_ILLEGAL_VC"                => [  23,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "PI illegal vc" ],
   "MD_ILLEGAL_VC"                => [  24,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "MD illegal vc" ],
   "IILB_ILLEGAL_VC"              => [  25,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "IILB illegal vc" ],
   "NI_FAST_TAIL_ERROR"           => [  26,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "NI fast tail error" ],
   "PI_FAST_TAIL_ERROR"           => [  27,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "PI fast tail error" ],
   "MD_FAST_TAIL_ERROR"           => [  28,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "MD fast tail error" ],
   "IILB_FAST_TAIL_ERROR"         => [  29,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "IILB fast tail error" ],
   "NI_FAST_TAIL_UNDERFLOW"       => [  30,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "NI fast tail underflow" ],
   "PI_DATA_FAST_TAIL_UNDERFLOW"  => [  31,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "PI data fast tail underflow" ],
   "PI_HDR_FAST_TAIL_UNDERFLOW"   => [  32,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "PI hdr fast tail underflow" ],
   "MD_DATA_FAST_TAIL_UNDERFLOW"  => [  33,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "MD data fast tail underflow" ],
   "MD_HDR_FAST_TAIL_UNDERFLOW"   => [  34,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "MD hdr fast tail underflow" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [  35,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "IILB fast tail underflow" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC3" => [  36,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "NI fifo underflow vc3" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC2" => [  37,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "NI fifo underflow vc2" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC1" => [  38,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "NI fifo underflow vc1" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC0" => [  39,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "NI fifo underflow vc0" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  40,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "PI data fifo underflow vc2" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  41,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "PI hdr fifo underflow vc2" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  42,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "PI data fifo underflow vc0" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  43,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "PI hdr fifo underflow vc0" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  44,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "MD data fifo underflow vc2" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  45,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "MD hdr fifo underflow vc2" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  46,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "MD data fifo underflow vc0" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  47,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "MD hdr fifo underflow vc0" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC2" => [  48,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "IILB fifo underflow vc2" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC0" => [  49,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "IILB fifo underflow vc0" ],
   "PI_DEBIT_UNDERFLOW_VC2"       => [  50,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "PI debit underflow vc2" ],
   "PI_DEBIT_UNDERFLOW_VC0"       => [  51,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "PI debit underflow vc0" ],
   "MD_DEBIT_UNDERFLOW_VC2"       => [  52,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "MD debit underflow vc2" ],
   "MD_DEBIT_UNDERFLOW_VC0"       => [  53,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "MD debit underflow vc0" ],
   "UNDERFLOW_NI_VC3_CREDIT"      => [  54,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "NI credit underflow vc3" ],
   "UNDERFLOW_NI_VC2_CREDIT"      => [  55,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "NI credit underflow vc2" ],
   "UNDERFLOW_NI_VC1_CREDIT"      => [  56,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "NI credit underflow vc1" ],
   "UNDERFLOW_NI_VC0_CREDIT"      => [  57,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "NI credit underflow vc0" ],
   "LLP_DEADLOCK_VC3"             => [  58,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [  59,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [  60,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [  61,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "llp deadlock vc0" ],
);

%orbit_01_00962_def =
( NAME    => "OC_NI1_ERROR_MASK_2",
  ADDRESS => 0x00000000d0040650,
  NOTE    => "ni1 Error Mask Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00962_flds
);


##########################################################################
#                                                                        #
#   OC_NI1_FIRST_ERROR_1                                                 #
#                                                                        #
##########################################################################

%orbit_01_00963_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_TAIL_TIMEOUT_VC3"          => [   1,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc3" ],
   "NI_TAIL_TIMEOUT_VC2"          => [   2,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc2" ],
   "NI_TAIL_TIMEOUT_VC1"          => [   3,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc1" ],
   "NI_TAIL_TIMEOUT_VC0"          => [   4,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc0" ],
   "PI_TAIL_TIMEOUT_VC3"          => [   5,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc3" ],
   "PI_TAIL_TIMEOUT_VC2"          => [   6,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc2" ],
   "PI_TAIL_TIMEOUT_VC1"          => [   7,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc1" ],
   "PI_TAIL_TIMEOUT_VC0"          => [   8,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc0" ],
   "MD_TAIL_TIMEOUT_VC3"          => [   9,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc3" ],
   "MD_TAIL_TIMEOUT_VC2"          => [  10,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc2" ],
   "MD_TAIL_TIMEOUT_VC1"          => [  11,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc1" ],
   "MD_TAIL_TIMEOUT_VC0"          => [  12,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc0" ],
   "IILB_TAIL_TIMEOUT_VC3"        => [  13,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc3" ],
   "IILB_TAIL_TIMEOUT_VC2"        => [  14,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc2" ],
   "IILB_TAIL_TIMEOUT_VC1"        => [  15,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc1" ],
   "IILB_TAIL_TIMEOUT_VC0"        => [  16,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc0" ],
   "NI_DEBITSAVER_OVERFLOW_VC3"   => [  17,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc3" ],
   "NI_DEBITSAVER_OVERFLOW_VC2"   => [  18,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc2" ],
   "NI_DEBITSAVER_OVERFLOW_VC1"   => [  19,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc1" ],
   "NI_DEBITSAVER_OVERFLOW_VC0"   => [  20,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc0" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC3"   => [  21,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc3" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC2"   => [  22,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc2" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC1"   => [  23,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc1" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC0"   => [  24,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc0" ],
   "NI_FAST_TAIL_OVERFLOW"        => [  25,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI fast tail overflow" ],
   "PI_DATA_FAST_TAIL_OVERFLOW"   => [  26,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail overflow" ],
   "PI_HDR_FAST_TAIL_OVERFLOW"    => [  27,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail overflow" ],
   "MD_DATA_FAST_TAIL_OVERFLOW"   => [  28,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "MD data fast tail overflow" ],
   "MD_HDR_FAST_TAIL_OVERFLOW"    => [  29,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail overflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  30,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC3"  => [  31,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc3" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC2"  => [  32,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc2" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC1"  => [  33,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc1" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC0"  => [  34,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc0" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  35,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc2" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  36,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc2" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  37,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc0" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  38,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc0" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  39,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc2" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  40,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc2" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  41,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc0" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  42,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc0" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC2" => [  43,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc2" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC0" => [  44,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc0" ],
   "NI_DEBIT_OVERFLOW_VC3"        => [  45,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc3" ],
   "NI_DEBIT_OVERFLOW_VC2"        => [  46,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc2" ],
   "NI_DEBIT_OVERFLOW_VC1"        => [  47,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc1" ],
   "NI_DEBIT_OVERFLOW_VC0"        => [  48,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc0" ],
   "PI_DEBIT_OVERFLOW_VC2"        => [  49,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc2" ],
   "PI_DEBIT_OVERFLOW_VC0"        => [  50,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc0" ],
   "MD_DEBIT_OVERFLOW_VC2"        => [  51,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "MD debit overflow vc2" ],
   "MD_DEBIT_OVERFLOW_VC0"        => [  52,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "MD debit overflow vc0" ],
   "IILB_DEBIT_OVERFLOW_VC2"      => [  53,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc2" ],
   "IILB_DEBIT_OVERFLOW_VC0"      => [  54,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc0" ],
   "OVERFLOW_NI_VC3_CREDIT"       => [  55,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit overflow vc3" ],
   "OVERFLOW_NI_VC2_CREDIT"       => [  56,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit overflow vc2" ],
   "OVERFLOW_NI_VC1_CREDIT"       => [  57,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit overflow vc1" ],
   "OVERFLOW_NI_VC0_CREDIT"       => [  58,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT3"          => [  59,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT2"          => [  60,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT1"          => [  61,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT0"          => [  62,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
);

%orbit_01_00963_def =
( NAME    => "OC_NI1_FIRST_ERROR_1",
  ADDRESS => 0x00000000d0040660,
  NOTE    => "ni1 First Error Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00963_flds
);


##########################################################################
#                                                                        #
#   OC_NI1_FIRST_ERROR_2                                                 #
#                                                                        #
##########################################################################

%orbit_01_00964_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DAM_PI_XMIT_MSG_VC3"          => [   1,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "PI VC3 Xmit Message Lost" ],
   "DAM_PI_XMIT_MSG_VC2"          => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "PI VC2 Xmit Message Lost" ],
   "DAM_PI_XMIT_MSG_VC1"          => [   3,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "PI VC1 Xmit Message Lost" ],
   "DAM_PI_XMIT_MSG_VC0"          => [   4,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC3"          => [   5,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "MD VC3 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC2"          => [   6,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "MD VC2 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC1"          => [   7,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "MD VC1 Xmit Message Lost" ],
   "DAM_MD_XMIT_MSG_VC0"          => [   8,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC3"          => [   9,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI VC3 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC2"          => [  10,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI VC2 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC1"          => [  11,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI VC1 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC0"          => [  12,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI VC0 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC3"        => [  13,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC3 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC2"        => [  14,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC1"        => [  15,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC1 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC0"        => [  16,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Xmit Message Lost" ],
   "RETRY_TIMEOUT_ERROR"          => [  17,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [  18,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [  19,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "MD_TAIL_CNT_ERROR"            => [  20,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "MD tail count error" ],
   "PI_TAIL_CNT_ERROR"            => [  21,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI tail count error" ],
   "NI_ILLEGAL_VC"                => [  22,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI illegal vc" ],
   "PI_ILLEGAL_VC"                => [  23,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "PI illegal vc" ],
   "MD_ILLEGAL_VC"                => [  24,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD illegal vc" ],
   "IILB_ILLEGAL_VC"              => [  25,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB illegal vc" ],
   "NI_FAST_TAIL_ERROR"           => [  26,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI fast tail error" ],
   "PI_FAST_TAIL_ERROR"           => [  27,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PI fast tail error" ],
   "MD_FAST_TAIL_ERROR"           => [  28,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD fast tail error" ],
   "IILB_FAST_TAIL_ERROR"         => [  29,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "NI_FAST_TAIL_UNDERFLOW"       => [  30,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fast tail underflow" ],
   "PI_DATA_FAST_TAIL_UNDERFLOW"  => [  31,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "PI data fast tail underflow" ],
   "PI_HDR_FAST_TAIL_UNDERFLOW"   => [  32,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail underflow" ],
   "MD_DATA_FAST_TAIL_UNDERFLOW"  => [  33,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "MD data fast tail underflow" ],
   "MD_HDR_FAST_TAIL_UNDERFLOW"   => [  34,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail underflow" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [  35,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC3" => [  36,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc3" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC2" => [  37,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc2" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC1" => [  38,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc1" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC0" => [  39,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc0" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  40,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc2" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  41,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc2" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  42,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc0" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  43,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc0" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  44,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc2" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  45,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc2" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  46,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc0" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  47,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc0" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC2" => [  48,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc2" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC0" => [  49,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc0" ],
   "PI_DEBIT_UNDERFLOW_VC2"       => [  50,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI debit underflow vc2" ],
   "PI_DEBIT_UNDERFLOW_VC0"       => [  51,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI debit underflow vc0" ],
   "MD_DEBIT_UNDERFLOW_VC2"       => [  52,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "MD debit underflow vc2" ],
   "MD_DEBIT_UNDERFLOW_VC0"       => [  53,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "MD debit underflow vc0" ],
   "UNDERFLOW_NI_VC3_CREDIT"      => [  54,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit underflow vc3" ],
   "UNDERFLOW_NI_VC2_CREDIT"      => [  55,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit underflow vc2" ],
   "UNDERFLOW_NI_VC1_CREDIT"      => [  56,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit underflow vc1" ],
   "UNDERFLOW_NI_VC0_CREDIT"      => [  57,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit underflow vc0" ],
   "LLP_DEADLOCK_VC3"             => [  58,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [  59,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [  60,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [  61,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
);

%orbit_01_00964_def =
( NAME    => "OC_NI1_FIRST_ERROR_2",
  ADDRESS => 0x00000000d0040670,
  NOTE    => "ni1 First Error Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00964_flds
);


##########################################################################
#                                                                        #
#   OC_NI1_ERROR_DETAIL_1                                                #
#                                                                        #
##########################################################################

%orbit_01_00965_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Header bits 63:0" ],
);

%orbit_01_00965_def =
( NAME    => "OC_NI1_ERROR_DETAIL_1",
  ADDRESS => 0x00000000d0040680,
  NOTE    => "ni1 Chiplet no match header bits 63:0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00965_flds
);


##########################################################################
#                                                                        #
#   OC_NI1_ERROR_DETAIL_2                                                #
#                                                                        #
##########################################################################

%orbit_01_00966_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Header bits 127:64" ],
);

%orbit_01_00966_def =
( NAME    => "OC_NI1_ERROR_DETAIL_2",
  ADDRESS => 0x00000000d0040690,
  NOTE    => "ni1 Chiplet no match header bits 127:64",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00966_flds
);


##########################################################################
#                                                                        #
#   OC_XN_CORRECTED_DETAIL_1                                             #
#                                                                        #
##########################################################################

%orbit_01_00967_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  52,  12, 0xFFF0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECC1_VC"                      => [   1,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "ECC1 Virtual Channel" ],
   "ECC1_WC"                      => [   2,  48,   2, 0x0003000000000000, 0x00, 0, 0x0000000000000000, "ECC1 Word Count" ],
   "ECC1_SYNDROME"                => [   3,  32,  16, 0x0000FFFF00000000, 0x00, 0, 0x0000000000000000, "ECC1 Syndrome" ],
   "RSVD1"                        => [   4,  20,  12, 0x00000000FFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECC0_VC"                      => [   5,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "ECC0 Virtual Channel" ],
   "ECC0_WC"                      => [   6,  16,   2, 0x0000000000030000, 0x00, 0, 0x0000000000000000, "ECC0 Word Count" ],
   "ECC0_SYNDROME"                => [   7,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "ECC0 Syndrome" ],
);

%orbit_01_00967_def =
( NAME    => "OC_XN_CORRECTED_DETAIL_1",
  ADDRESS => 0x00000000d0040070,
  NOTE    => "This register contains the XN NI0 errors status bits.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00967_flds
);


##########################################################################
#                                                                        #
#   OC_XN_CORRECTED_DETAIL_2A                                            #
#                                                                        #
##########################################################################

%orbit_01_00968_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "ECC data0" ],
);

%orbit_01_00968_def =
( NAME    => "OC_XN_CORRECTED_DETAIL_2A",
  ADDRESS => 0x00000000d0040080,
  NOTE    => "Corrected error data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00968_flds
);


##########################################################################
#                                                                        #
#   OC_XN_CORRECTED_DETAIL_2B                                            #
#                                                                        #
##########################################################################

%orbit_01_00969_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "ECC data1" ],
);

%orbit_01_00969_def =
( NAME    => "OC_XN_CORRECTED_DETAIL_2B",
  ADDRESS => 0x00000000d0040090,
  NOTE    => "Corrected error data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00969_flds
);


##########################################################################
#                                                                        #
#   OC_XN_CORRECTED_DETAIL_3                                             #
#                                                                        #
##########################################################################

%orbit_01_00970_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER0"                      => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "ECC header0 (bits 63 - 0)" ],
);

%orbit_01_00970_def =
( NAME    => "OC_XN_CORRECTED_DETAIL_3",
  ADDRESS => 0x00000000d00400a0,
  NOTE    => "Corrected error header0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00970_flds
);


##########################################################################
#                                                                        #
#   OC_XN_CORRECTED_DETAIL_4                                             #
#                                                                        #
##########################################################################

%orbit_01_00971_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ERR_GROUP"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Error group" ],
   "RSVD0"                        => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HEADER1"                      => [   2,   0,  56, 0x00FFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "ECC header1 (bits 119 - 64)" ],
);

%orbit_01_00971_def =
( NAME    => "OC_XN_CORRECTED_DETAIL_4",
  ADDRESS => 0x00000000d00400b0,
  NOTE    => "Corrected error header1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00971_flds
);


##########################################################################
#                                                                        #
#   OC_XN_UNCORRECTED_DETAIL_1                                           #
#                                                                        #
##########################################################################

%orbit_01_00972_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  52,  12, 0xFFF0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECC1_VC"                      => [   1,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "ECC1 Virtual Channel" ],
   "ECC1_WC"                      => [   2,  48,   2, 0x0003000000000000, 0x00, 0, 0x0000000000000000, "ECC1 Word Count" ],
   "ECC1_SYNDROME"                => [   3,  32,  16, 0x0000FFFF00000000, 0x00, 0, 0x0000000000000000, "ECC1 Syndrome" ],
   "RSVD1"                        => [   4,  20,  12, 0x00000000FFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECC0_VC"                      => [   5,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "ECC0 Virtual Channel" ],
   "ECC0_WC"                      => [   6,  16,   2, 0x0000000000030000, 0x00, 0, 0x0000000000000000, "ECC0 Word Count" ],
   "ECC0_SYNDROME"                => [   7,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "ECC0 Syndrome" ],
);

%orbit_01_00972_def =
( NAME    => "OC_XN_UNCORRECTED_DETAIL_1",
  ADDRESS => 0x00000000d00400c0,
  NOTE    => "Uncorrected error details",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00972_flds
);


##########################################################################
#                                                                        #
#   OC_XN_UNCORRECTED_DETAIL_2A                                          #
#                                                                        #
##########################################################################

%orbit_01_00973_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "ECC data0" ],
);

%orbit_01_00973_def =
( NAME    => "OC_XN_UNCORRECTED_DETAIL_2A",
  ADDRESS => 0x00000000d00400d0,
  NOTE    => "Uncorrected error data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00973_flds
);


##########################################################################
#                                                                        #
#   OC_XN_UNCORRECTED_DETAIL_2B                                          #
#                                                                        #
##########################################################################

%orbit_01_00974_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "ECC data1" ],
);

%orbit_01_00974_def =
( NAME    => "OC_XN_UNCORRECTED_DETAIL_2B",
  ADDRESS => 0x00000000d00400e0,
  NOTE    => "Uncorrected error data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00974_flds
);


##########################################################################
#                                                                        #
#   OC_XN_UNCORRECTED_DETAIL_3                                           #
#                                                                        #
##########################################################################

%orbit_01_00975_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER0"                      => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "ECC header0 (bits 63 - 0)" ],
);

%orbit_01_00975_def =
( NAME    => "OC_XN_UNCORRECTED_DETAIL_3",
  ADDRESS => 0x00000000d00400f0,
  NOTE    => "Uncorrected error header0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00975_flds
);


##########################################################################
#                                                                        #
#   OC_XN_UNCORRECTED_DETAIL_4                                           #
#                                                                        #
##########################################################################

%orbit_01_00976_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ERR_GROUP"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Error group" ],
   "RSVD0"                        => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HEADER1"                      => [   2,   0,  56, 0x00FFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "ECC header1 (bits 119 - 64)" ],
);

%orbit_01_00976_def =
( NAME    => "OC_XN_UNCORRECTED_DETAIL_4",
  ADDRESS => 0x00000000d0040100,
  NOTE    => "Uncorrected error header1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00976_flds
);


##########################################################################
#                                                                        #
#   OC_XNMD_ERROR_DETAIL_1                                               #
#                                                                        #
##########################################################################

%orbit_01_00977_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_ADDR"                     => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Look Up Table Read Address" ],
);

%orbit_01_00977_def =
( NAME    => "OC_XNMD_ERROR_DETAIL_1",
  ADDRESS => 0x00000000d0040110,
  NOTE    => "Look Up Table Address (md)",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00977_flds
);


##########################################################################
#                                                                        #
#   OC_XNPI_ERROR_DETAIL_1                                               #
#                                                                        #
##########################################################################

%orbit_01_00978_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_ADDR"                     => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Look Up Table Read Address" ],
);

%orbit_01_00978_def =
( NAME    => "OC_XNPI_ERROR_DETAIL_1",
  ADDRESS => 0x00000000d0040120,
  NOTE    => "Look Up Table Address (pi)",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00978_flds
);


##########################################################################
#                                                                        #
#   OC_XNIILB_ERROR_DETAIL_1                                             #
#                                                                        #
##########################################################################

%orbit_01_00979_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "header bits [63:0]" ],
);

%orbit_01_00979_def =
( NAME    => "OC_XNIILB_ERROR_DETAIL_1",
  ADDRESS => 0x00000000d0040130,
  NOTE    => "Chiplet NoMatch header [63:0]",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00979_flds
);


##########################################################################
#                                                                        #
#   OC_XNIILB_ERROR_DETAIL_2                                             #
#                                                                        #
##########################################################################

%orbit_01_00980_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "header bits [127:64]" ],
);

%orbit_01_00980_def =
( NAME    => "OC_XNIILB_ERROR_DETAIL_2",
  ADDRESS => 0x00000000d0040140,
  NOTE    => "Chiplet NoMatch header [127:64]",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00980_flds
);


##########################################################################
#                                                                        #
#   OC_XNIILB_ERROR_DETAIL_3                                             #
#                                                                        #
##########################################################################

%orbit_01_00981_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_ADDR"                     => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Look Up Table Read Address" ],
);

%orbit_01_00981_def =
( NAME    => "OC_XNIILB_ERROR_DETAIL_3",
  ADDRESS => 0x00000000d0040150,
  NOTE    => "Look Up Table Address (iilb)",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00981_flds
);


##########################################################################
#                                                                        #
#   OC_NI0_ERROR_DETAIL_3                                                #
#                                                                        #
##########################################################################

%orbit_01_00982_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_ADDR"                     => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Look Up Table Read Address" ],
);

%orbit_01_00982_def =
( NAME    => "OC_NI0_ERROR_DETAIL_3",
  ADDRESS => 0x00000000d0040160,
  NOTE    => "Look Up Table Address (ni0)",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00982_flds
);


##########################################################################
#                                                                        #
#   OC_NI1_ERROR_DETAIL_3                                                #
#                                                                        #
##########################################################################

%orbit_01_00983_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_ADDR"                     => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Look Up Table Read Address" ],
);

%orbit_01_00983_def =
( NAME    => "OC_NI1_ERROR_DETAIL_3",
  ADDRESS => 0x00000000d0040170,
  NOTE    => "Look Up Table Address (ni1)",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00983_flds
);


##########################################################################
#                                                                        #
#   OC_XN_ERROR_SUMMARY                                                  #
#                                                                        #
##########################################################################

%orbit_01_00984_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  37,  27, 0xFFFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XNPI_LUT_ERROR"               => [   1,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "XNPI look up table error" ],
   "XNPI_DEBIT_OVERFLOW"          => [   2,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "XNPI debit overflow" ],
   "XNPI_FIFO_UNDERFLOW"          => [   3,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "XNPI fifo underflow" ],
   "XNPI_FIFO_OVERFLOW"           => [   4,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "XNPI fifo overflow" ],
   "XNPI_CREDIT_UNDERFLOW"        => [   5,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "XNPI credit underflow" ],
   "XNPI_CREDIT_OVERFLOW"         => [   6,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "XNPI credit overflow" ],
   "XNMD_LUT_ERROR"               => [   7,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "XNMD look up table error" ],
   "XNMD_DEBIT_OVERFLOW"          => [   8,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "XNMD debit overflow" ],
   "XNMD_FIFO_UNDERFLOW"          => [   9,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "XNMD fifo underflow" ],
   "XNMD_FIFO_OVERFLOW"           => [  10,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "XNMD fifo overflow" ],
   "XNMD_CREDIT_UNDERFLOW"        => [  11,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "XNMD credit underflow" ],
   "XNMD_CREDIT_OVERFLOW"         => [  12,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "XNMD credit overflow" ],
   "XNMD_UCE_ERROR"               => [  13,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "XNMD uncorrectable error" ],
   "XNMD_SBE_ERROR"               => [  14,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "XNMD single bit error" ],
   "IILB_CHIPLET_OR_LUT"          => [  15,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB chiplet nomatch or lut read error" ],
   "IILB_FIFO_UNDERFLOW"          => [  16,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow" ],
   "IILB_FIFO_OVERFLOW"           => [  17,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow" ],
   "IILB_CREDIT_UNDERFLOW"        => [  18,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB credit underflow" ],
   "IILB_CREDIT_OVERFLOW"         => [  19,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB credit overflow" ],
   "IILB_DEBIT_UNDERFLOW"         => [  20,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "IILB debit underflow" ],
   "IILB_DEBIT_OVERFLOW"          => [  21,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "IILB debit overflow" ],
   "NI1_LLP_ERROR"                => [  22,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI1 llp error" ],
   "NI1_PIPE_ERROR"               => [  23,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 pipe in/out error" ],
   "NI1_FIFO_UNDERFLOW"           => [  24,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 fifo underflow" ],
   "NI1_FIFO_OVERFLOW"            => [  25,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI1 fifo overflow" ],
   "NI1_CREDIT_UNDERFLOW"         => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI1 credit underflow" ],
   "NI1_CREDIT_OVERFLOW"          => [  27,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "NI1 credit overflow" ],
   "NI1_DEBIT_UNDERFLOW"          => [  28,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 debit underflow" ],
   "NI1_DEBIT_OVERFLOW"           => [  29,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 debit overflow" ],
   "NI0_LLP_ERROR"                => [  30,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI0 llp error" ],
   "NI0_PIPE_ERROR"               => [  31,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI0 Pipe in/out errors" ],
   "NI0_FIFO_UNDERFLOW"           => [  32,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 fifo underflow" ],
   "NI0_FIFO_OVERFLOW"            => [  33,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 fifo overflow" ],
   "NI0_CREDIT_UNDERFLOW"         => [  34,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 credit underflow" ],
   "NI0_CREDIT_OVERFLOW"          => [  35,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 credit overflow" ],
   "NI0_DEBIT_UNDERFLOW"          => [  36,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "NI0 debit underflow" ],
   "NI0_DEBIT_OVERFLOW"           => [  37,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "NI0 debit overflow" ],
);

%orbit_01_00984_def =
( NAME    => "OC_XN_ERROR_SUMMARY",
  ADDRESS => 0x00000000d0040000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00984_flds
);


##########################################################################
#                                                                        #
#   OC_XN_ERRORS_ALIAS                                                   #
#                                                                        #
##########################################################################

%orbit_01_00985_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  37,  27, 0xFFFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XNPI_LUT_ERROR"               => [   1,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "XNPI look up table error" ],
   "XNPI_DEBIT_OVERFLOW"          => [   2,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "XNPI debit overflow" ],
   "XNPI_FIFO_UNDERFLOW"          => [   3,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "XNPI fifo underflow" ],
   "XNPI_FIFO_OVERFLOW"           => [   4,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "XNPI fifo overflow" ],
   "XNPI_CREDIT_UNDERFLOW"        => [   5,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "XNPI credit underflow" ],
   "XNPI_CREDIT_OVERFLOW"         => [   6,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "XNPI credit overflow" ],
   "XNMD_LUT_ERROR"               => [   7,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "XNMD look up table error" ],
   "XNMD_DEBIT_OVERFLOW"          => [   8,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "XNMD debit overflow" ],
   "XNMD_FIFO_UNDERFLOW"          => [   9,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "XNMD fifo underflow" ],
   "XNMD_FIFO_OVERFLOW"           => [  10,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "XNMD fifo overflow" ],
   "XNMD_CREDIT_UNDERFLOW"        => [  11,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "XNMD credit underflow" ],
   "XNMD_CREDIT_OVERFLOW"         => [  12,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "XNMD credit overflow" ],
   "XNMD_UCE_ERROR"               => [  13,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "XNMD uncorrectable error" ],
   "XNMD_SBE_ERROR"               => [  14,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "XNMD single bit error" ],
   "IILB_CHIPLET_OR_LUT"          => [  15,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB chiplet nomatch or lut read error" ],
   "IILB_FIFO_UNDERFLOW"          => [  16,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow" ],
   "IILB_FIFO_OVERFLOW"           => [  17,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow" ],
   "IILB_CREDIT_UNDERFLOW"        => [  18,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB credit underflow" ],
   "IILB_CREDIT_OVERFLOW"         => [  19,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB credit overflow" ],
   "IILB_DEBIT_UNDERFLOW"         => [  20,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "IILB debit underflow" ],
   "IILB_DEBIT_OVERFLOW"          => [  21,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "IILB debit overflow" ],
   "NI1_LLP_ERROR"                => [  22,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI1 llp error" ],
   "NI1_PIPE_ERROR"               => [  23,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 pipe in/out error" ],
   "NI1_FIFO_UNDERFLOW"           => [  24,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 fifo underflow" ],
   "NI1_FIFO_OVERFLOW"            => [  25,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI1 fifo overflow" ],
   "NI1_CREDIT_UNDERFLOW"         => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI1 credit underflow" ],
   "NI1_CREDIT_OVERFLOW"          => [  27,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "NI1 credit overflow" ],
   "NI1_DEBIT_UNDERFLOW"          => [  28,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 debit underflow" ],
   "NI1_DEBIT_OVERFLOW"           => [  29,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 debit overflow" ],
   "NI0_LLP_ERROR"                => [  30,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI0 llp error" ],
   "NI0_PIPE_ERROR"               => [  31,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI0 Pipe in/out errors" ],
   "NI0_FIFO_UNDERFLOW"           => [  32,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 fifo underflow" ],
   "NI0_FIFO_OVERFLOW"            => [  33,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 fifo overflow" ],
   "NI0_CREDIT_UNDERFLOW"         => [  34,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 credit underflow" ],
   "NI0_CREDIT_OVERFLOW"          => [  35,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 credit overflow" ],
   "NI0_DEBIT_UNDERFLOW"          => [  36,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "NI0 debit underflow" ],
   "NI0_DEBIT_OVERFLOW"           => [  37,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "NI0 debit overflow" ],
);

%orbit_01_00985_def =
( NAME    => "OC_XN_ERRORS_ALIAS",
  ADDRESS => 0x00000000d0040008,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00985_flds
);


##########################################################################
#                                                                        #
#   OC_XN_ERROR_OVERFLOW                                                 #
#                                                                        #
##########################################################################

%orbit_01_00986_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  37,  27, 0xFFFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XNPI_LUT_ERROR"               => [   1,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "XNPI look up table error" ],
   "XNPI_DEBIT_OVERFLOW"          => [   2,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "XNPI debit overflow" ],
   "XNPI_FIFO_UNDERFLOW"          => [   3,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "XNPI fifo underflow" ],
   "XNPI_FIFO_OVERFLOW"           => [   4,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "XNPI fifo overflow" ],
   "XNPI_CREDIT_UNDERFLOW"        => [   5,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "XNPI credit underflow" ],
   "XNPI_CREDIT_OVERFLOW"         => [   6,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "XNPI credit overflow" ],
   "XNMD_LUT_ERROR"               => [   7,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "XNMD look up table error" ],
   "XNMD_DEBIT_OVERFLOW"          => [   8,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "XNMD debit overflow" ],
   "XNMD_FIFO_UNDERFLOW"          => [   9,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "XNMD fifo underflow" ],
   "XNMD_FIFO_OVERFLOW"           => [  10,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "XNMD fifo overflow" ],
   "XNMD_CREDIT_UNDERFLOW"        => [  11,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "XNMD credit underflow" ],
   "XNMD_CREDIT_OVERFLOW"         => [  12,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "XNMD credit overflow" ],
   "XNMD_UCE_ERROR"               => [  13,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "XNMD uncorrectable error" ],
   "XNMD_SBE_ERROR"               => [  14,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "XNMD single bit error" ],
   "IILB_CHIPLET_OR_LUT"          => [  15,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB chiplet nomatch or lut read error" ],
   "IILB_FIFO_UNDERFLOW"          => [  16,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow" ],
   "IILB_FIFO_OVERFLOW"           => [  17,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow" ],
   "IILB_CREDIT_UNDERFLOW"        => [  18,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB credit underflow" ],
   "IILB_CREDIT_OVERFLOW"         => [  19,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB credit overflow" ],
   "IILB_DEBIT_UNDERFLOW"         => [  20,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "IILB debit underflow" ],
   "IILB_DEBIT_OVERFLOW"          => [  21,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "IILB debit overflow" ],
   "NI1_LLP_ERROR"                => [  22,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI1 llp error" ],
   "NI1_PIPE_ERROR"               => [  23,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 pipe in/out error" ],
   "NI1_FIFO_UNDERFLOW"           => [  24,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 fifo underflow" ],
   "NI1_FIFO_OVERFLOW"            => [  25,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI1 fifo overflow" ],
   "NI1_CREDIT_UNDERFLOW"         => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI1 credit underflow" ],
   "NI1_CREDIT_OVERFLOW"          => [  27,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "NI1 credit overflow" ],
   "NI1_DEBIT_UNDERFLOW"          => [  28,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 debit underflow" ],
   "NI1_DEBIT_OVERFLOW"           => [  29,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 debit overflow" ],
   "NI0_LLP_ERROR"                => [  30,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI0 llp error" ],
   "NI0_PIPE_ERROR"               => [  31,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI0 Pipe in/out errors" ],
   "NI0_FIFO_UNDERFLOW"           => [  32,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 fifo underflow" ],
   "NI0_FIFO_OVERFLOW"            => [  33,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 fifo overflow" ],
   "NI0_CREDIT_UNDERFLOW"         => [  34,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 credit underflow" ],
   "NI0_CREDIT_OVERFLOW"          => [  35,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 credit overflow" ],
   "NI0_DEBIT_UNDERFLOW"          => [  36,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "NI0 debit underflow" ],
   "NI0_DEBIT_OVERFLOW"           => [  37,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "NI0 debit overflow" ],
);

%orbit_01_00986_def =
( NAME    => "OC_XN_ERROR_OVERFLOW",
  ADDRESS => 0x00000000d0040020,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00986_flds
);


##########################################################################
#                                                                        #
#   OC_XN_ERROR_OVERFLOW_ALIAS                                           #
#                                                                        #
##########################################################################

%orbit_01_00987_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  37,  27, 0xFFFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XNPI_LUT_ERROR"               => [   1,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "XNPI look up table error" ],
   "XNPI_DEBIT_OVERFLOW"          => [   2,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "XNPI debit overflow" ],
   "XNPI_FIFO_UNDERFLOW"          => [   3,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "XNPI fifo underflow" ],
   "XNPI_FIFO_OVERFLOW"           => [   4,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "XNPI fifo overflow" ],
   "XNPI_CREDIT_UNDERFLOW"        => [   5,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "XNPI credit underflow" ],
   "XNPI_CREDIT_OVERFLOW"         => [   6,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "XNPI credit overflow" ],
   "XNMD_LUT_ERROR"               => [   7,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "XNMD look up table error" ],
   "XNMD_DEBIT_OVERFLOW"          => [   8,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "XNMD debit overflow" ],
   "XNMD_FIFO_UNDERFLOW"          => [   9,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "XNMD fifo underflow" ],
   "XNMD_FIFO_OVERFLOW"           => [  10,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "XNMD fifo overflow" ],
   "XNMD_CREDIT_UNDERFLOW"        => [  11,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "XNMD credit underflow" ],
   "XNMD_CREDIT_OVERFLOW"         => [  12,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "XNMD credit overflow" ],
   "XNMD_UCE_ERROR"               => [  13,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "XNMD uncorrectable error" ],
   "XNMD_SBE_ERROR"               => [  14,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "XNMD single bit error" ],
   "IILB_CHIPLET_OR_LUT"          => [  15,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB chiplet nomatch or lut read error" ],
   "IILB_FIFO_UNDERFLOW"          => [  16,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow" ],
   "IILB_FIFO_OVERFLOW"           => [  17,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow" ],
   "IILB_CREDIT_UNDERFLOW"        => [  18,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB credit underflow" ],
   "IILB_CREDIT_OVERFLOW"         => [  19,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB credit overflow" ],
   "IILB_DEBIT_UNDERFLOW"         => [  20,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "IILB debit underflow" ],
   "IILB_DEBIT_OVERFLOW"          => [  21,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "IILB debit overflow" ],
   "NI1_LLP_ERROR"                => [  22,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI1 llp error" ],
   "NI1_PIPE_ERROR"               => [  23,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 pipe in/out error" ],
   "NI1_FIFO_UNDERFLOW"           => [  24,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 fifo underflow" ],
   "NI1_FIFO_OVERFLOW"            => [  25,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI1 fifo overflow" ],
   "NI1_CREDIT_UNDERFLOW"         => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI1 credit underflow" ],
   "NI1_CREDIT_OVERFLOW"          => [  27,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "NI1 credit overflow" ],
   "NI1_DEBIT_UNDERFLOW"          => [  28,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 debit underflow" ],
   "NI1_DEBIT_OVERFLOW"           => [  29,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 debit overflow" ],
   "NI0_LLP_ERROR"                => [  30,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI0 llp error" ],
   "NI0_PIPE_ERROR"               => [  31,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI0 Pipe in/out errors" ],
   "NI0_FIFO_UNDERFLOW"           => [  32,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 fifo underflow" ],
   "NI0_FIFO_OVERFLOW"            => [  33,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 fifo overflow" ],
   "NI0_CREDIT_UNDERFLOW"         => [  34,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 credit underflow" ],
   "NI0_CREDIT_OVERFLOW"          => [  35,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 credit overflow" ],
   "NI0_DEBIT_UNDERFLOW"          => [  36,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "NI0 debit underflow" ],
   "NI0_DEBIT_OVERFLOW"           => [  37,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "NI0 debit overflow" ],
);

%orbit_01_00987_def =
( NAME    => "OC_XN_ERROR_OVERFLOW_ALIAS",
  ADDRESS => 0x00000000d0040028,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00987_flds
);


##########################################################################
#                                                                        #
#   OC_XN_ERROR_MASK                                                     #
#                                                                        #
##########################################################################

%orbit_01_00988_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  37,  27, 0xFFFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XNPI_LUT_ERROR"               => [   1,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "XNPI look up table error" ],
   "XNPI_DEBIT_OVERFLOW"          => [   2,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "XNPI debit overflow" ],
   "XNPI_FIFO_UNDERFLOW"          => [   3,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "XNPI fifo underflow" ],
   "XNPI_FIFO_OVERFLOW"           => [   4,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "XNPI fifo overflow" ],
   "XNPI_CREDIT_UNDERFLOW"        => [   5,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "XNPI credit underflow" ],
   "XNPI_CREDIT_OVERFLOW"         => [   6,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "XNPI credit overflow" ],
   "XNMD_LUT_ERROR"               => [   7,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "XNMD look up table error" ],
   "XNMD_DEBIT_OVERFLOW"          => [   8,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "XNMD debit overflow" ],
   "XNMD_FIFO_UNDERFLOW"          => [   9,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "XNMD fifo underflow" ],
   "XNMD_FIFO_OVERFLOW"           => [  10,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "XNMD fifo overflow" ],
   "XNMD_CREDIT_UNDERFLOW"        => [  11,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "XNMD credit underflow" ],
   "XNMD_CREDIT_OVERFLOW"         => [  12,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "XNMD credit overflow" ],
   "XNMD_UCE_ERROR"               => [  13,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "XNMD uncorrectable error" ],
   "XNMD_SBE_ERROR"               => [  14,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "XNMD single bit error" ],
   "IILB_CHIPLET_OR_LUT"          => [  15,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "IILB chiplet nomatch or lut read error" ],
   "IILB_FIFO_UNDERFLOW"          => [  16,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "IILB fifo underflow" ],
   "IILB_FIFO_OVERFLOW"           => [  17,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "IILB fifo overflow" ],
   "IILB_CREDIT_UNDERFLOW"        => [  18,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "IILB credit underflow" ],
   "IILB_CREDIT_OVERFLOW"         => [  19,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "IILB credit overflow" ],
   "IILB_DEBIT_UNDERFLOW"         => [  20,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "IILB debit underflow" ],
   "IILB_DEBIT_OVERFLOW"          => [  21,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "IILB debit overflow" ],
   "NI1_LLP_ERROR"                => [  22,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "NI1 llp error" ],
   "NI1_PIPE_ERROR"               => [  23,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "NI1 pipe in/out error" ],
   "NI1_FIFO_UNDERFLOW"           => [  24,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "NI1 fifo underflow" ],
   "NI1_FIFO_OVERFLOW"            => [  25,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "NI1 fifo overflow" ],
   "NI1_CREDIT_UNDERFLOW"         => [  26,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "NI1 credit underflow" ],
   "NI1_CREDIT_OVERFLOW"          => [  27,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "NI1 credit overflow" ],
   "NI1_DEBIT_UNDERFLOW"          => [  28,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "NI1 debit underflow" ],
   "NI1_DEBIT_OVERFLOW"           => [  29,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "NI1 debit overflow" ],
   "NI0_LLP_ERROR"                => [  30,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "NI0 llp error" ],
   "NI0_PIPE_ERROR"               => [  31,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "NI0 Pipe in/out errors" ],
   "NI0_FIFO_UNDERFLOW"           => [  32,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "NI0 fifo underflow" ],
   "NI0_FIFO_OVERFLOW"            => [  33,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "NI0 fifo overflow" ],
   "NI0_CREDIT_UNDERFLOW"         => [  34,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "NI0 credit underflow" ],
   "NI0_CREDIT_OVERFLOW"          => [  35,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "NI0 credit overflow" ],
   "NI0_DEBIT_UNDERFLOW"          => [  36,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "NI0 debit underflow" ],
   "NI0_DEBIT_OVERFLOW"           => [  37,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "NI0 debit overflow" ],
);

%orbit_01_00988_def =
( NAME    => "OC_XN_ERROR_MASK",
  ADDRESS => 0x00000000d0040040,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00988_flds
);


##########################################################################
#                                                                        #
#   OC_XN_FIRST_ERROR                                                    #
#                                                                        #
##########################################################################

%orbit_01_00989_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  37,  27, 0xFFFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XNPI_LUT_ERROR"               => [   1,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "XNPI look up table error" ],
   "XNPI_DEBIT_OVERFLOW"          => [   2,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "XNPI debit overflow" ],
   "XNPI_FIFO_UNDERFLOW"          => [   3,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "XNPI fifo underflow" ],
   "XNPI_FIFO_OVERFLOW"           => [   4,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "XNPI fifo overflow" ],
   "XNPI_CREDIT_UNDERFLOW"        => [   5,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "XNPI credit underflow" ],
   "XNPI_CREDIT_OVERFLOW"         => [   6,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "XNPI credit overflow" ],
   "XNMD_LUT_ERROR"               => [   7,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "XNMD look up table error" ],
   "XNMD_DEBIT_OVERFLOW"          => [   8,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "XNMD debit overflow" ],
   "XNMD_FIFO_UNDERFLOW"          => [   9,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "XNMD fifo underflow" ],
   "XNMD_FIFO_OVERFLOW"           => [  10,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "XNMD fifo overflow" ],
   "XNMD_CREDIT_UNDERFLOW"        => [  11,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "XNMD credit underflow" ],
   "XNMD_CREDIT_OVERFLOW"         => [  12,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "XNMD credit overflow" ],
   "XNMD_UCE_ERROR"               => [  13,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "XNMD uncorrectable error" ],
   "XNMD_SBE_ERROR"               => [  14,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "XNMD single bit error" ],
   "IILB_CHIPLET_OR_LUT"          => [  15,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB chiplet nomatch or lut read error" ],
   "IILB_FIFO_UNDERFLOW"          => [  16,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow" ],
   "IILB_FIFO_OVERFLOW"           => [  17,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow" ],
   "IILB_CREDIT_UNDERFLOW"        => [  18,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB credit underflow" ],
   "IILB_CREDIT_OVERFLOW"         => [  19,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB credit overflow" ],
   "IILB_DEBIT_UNDERFLOW"         => [  20,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "IILB debit underflow" ],
   "IILB_DEBIT_OVERFLOW"          => [  21,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "IILB debit overflow" ],
   "NI1_LLP_ERROR"                => [  22,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI1 llp error" ],
   "NI1_PIPE_ERROR"               => [  23,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 pipe in/out error" ],
   "NI1_FIFO_UNDERFLOW"           => [  24,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 fifo underflow" ],
   "NI1_FIFO_OVERFLOW"            => [  25,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI1 fifo overflow" ],
   "NI1_CREDIT_UNDERFLOW"         => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI1 credit underflow" ],
   "NI1_CREDIT_OVERFLOW"          => [  27,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "NI1 credit overflow" ],
   "NI1_DEBIT_UNDERFLOW"          => [  28,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 debit underflow" ],
   "NI1_DEBIT_OVERFLOW"           => [  29,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 debit overflow" ],
   "NI0_LLP_ERROR"                => [  30,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI0 llp error" ],
   "NI0_PIPE_ERROR"               => [  31,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI0 Pipe in/out errors" ],
   "NI0_FIFO_UNDERFLOW"           => [  32,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 fifo underflow" ],
   "NI0_FIFO_OVERFLOW"            => [  33,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 fifo overflow" ],
   "NI0_CREDIT_UNDERFLOW"         => [  34,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 credit underflow" ],
   "NI0_CREDIT_OVERFLOW"          => [  35,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 credit overflow" ],
   "NI0_DEBIT_UNDERFLOW"          => [  36,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "NI0 debit underflow" ],
   "NI0_DEBIT_OVERFLOW"           => [  37,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "NI0 debit overflow" ],
);

%orbit_01_00989_def =
( NAME    => "OC_XN_FIRST_ERROR",
  ADDRESS => 0x00000000d0040060,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00989_flds
);


##########################################################################
#                                                                        #
#   OC_XNIILB_ERROR_SUMMARY                                              #
#                                                                        #
##########################################################################

%orbit_01_00990_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_LB_FAST_TAIL"        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail overflow" ],
   "OVERFLOW_II_FAST_TAIL"        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "II fast tail overflow" ],
   "OVERFLOW_MD_DATA_FAST_TAIL"   => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "MD data fast tail overflow" ],
   "OVERFLOW_MD_HDR_FAST_TAIL"    => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail overflow" ],
   "OVERFLOW_PI_DATA_FAST_TAIL"   => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail overflow" ],
   "OVERFLOW_PI_HDR_FAST_TAIL"    => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail overflow" ],
   "OVERFLOW_NI1_FAST_TAIL"       => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail overflow" ],
   "OVERFLOW_NI0_FAST_TAIL"       => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail overflow" ],
   "OVERFLOW_IILB_FAST_TAIL"      => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "OVERFLOW_LB_DEBIT2"           => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "LB VC2 debit overflow" ],
   "OVERFLOW_LB_DEBIT0"           => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "LB VC0 debit overflow" ],
   "OVERFLOW_II_DEBIT2"           => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "II VC2 debit overflow" ],
   "OVERFLOW_II_DEBIT0"           => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "II VC0 debit overflow" ],
   "OVERFLOW_MD_DEBIT2"           => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "MD VC2 fifo debit overflow" ],
   "OVERFLOW_MD_DEBIT0"           => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 fifo debit overflow" ],
   "OVERFLOW_PI_DEBIT2"           => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "PI VC2 fifo debit overflow" ],
   "OVERFLOW_PI_DEBIT0"           => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "PI VC0 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT3"          => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo debit overflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo debit overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo debit overflow" ],
   "OVERFLOW_LB_VC2_CREDIT_OUT"   => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "LB VC2 credit overflow" ],
   "OVERFLOW_LB_VC0_CREDIT_OUT"   => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "LB VC0 credit overflow" ],
   "OVERFLOW_II_VC2_CREDIT_OUT"   => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "II VC2 credit overflow" ],
   "OVERFLOW_II_VC0_CREDIT_OUT"   => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "II VC0 credit overflow" ],
   "OVERFLOW_MD_VC2_CREDIT_IN"    => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "MD VC2 credit overflow" ],
   "OVERFLOW_MD_VC0_CREDIT_IN"    => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "MD VC0 credit overflow" ],
   "OVERFLOW_PI_VC2_CREDIT_IN"    => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI VC2 credit overflow" ],
   "OVERFLOW_PI_VC0_CREDIT_IN"    => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "PI VC0 credit overflow" ],
   "OVERFLOW_NI1_VC2_CREDIT_IN"   => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit overflow" ],
   "OVERFLOW_NI1_VC0_CREDIT_IN"   => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit overflow" ],
   "OVERFLOW_NI0_VC2_CREDIT_IN"   => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit overflow" ],
   "OVERFLOW_NI0_VC0_CREDIT_IN"   => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT_IN"  => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit overflow" ],
   "OVERFLOW_IILB_VC0_CREDIT_IN"  => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit overflow" ],
   "OVERFLOW_LB_VC2"              => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "LB VC2 fifo overflow" ],
   "OVERFLOW_LB_VC0"              => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "LB VC0 fifo overflow" ],
   "OVERFLOW_II_VC2"              => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "II VC2 fifo overflow" ],
   "OVERFLOW_II_VC0"              => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "II VC0 fifo overflow" ],
   "OVERFLOW_MD_DATA_VC2_CREDIT_OUT" => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD VC0 data fifo overflow" ],
   "OVERFLOW_MD_DATA_VC0_CREDIT_OUT" => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD VC0 data fifo overflow" ],
   "OVERFLOW_MD_HDR_VC2_CREDIT_OUT" => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD VC0 hdr fifo overflow" ],
   "OVERFLOW_MD_HDR_VC0_CREDIT_OUT" => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD VC0 hdr fifo overflow" ],
   "OVERFLOW_PI_DATA_VC2_CREDIT_OUT" => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI VC2 data fifo overflow" ],
   "OVERFLOW_PI_DATA_VC0_CREDIT_OUT" => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI VC0 data fifo overflow" ],
   "OVERFLOW_PI_HDR_VC2_CREDIT_OUT" => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI VC2 hdr fifo overflow" ],
   "OVERFLOW_PI_HDR_VC0_CREDIT_OUT" => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI VC0 hdr fifo overflow" ],
   "OVERFLOW_NI1_VC3_CREDIT_OUT"  => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo overflow" ],
   "OVERFLOW_NI1_VC2_CREDIT_OUT"  => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo overflow" ],
   "OVERFLOW_NI1_VC1_CREDIT_OUT"  => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo overflow" ],
   "OVERFLOW_NI1_VC0_CREDIT_OUT"  => [  57,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo overflow" ],
   "OVERFLOW_NI0_VC3_CREDIT_OUT"  => [  58,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo overflow" ],
   "OVERFLOW_NI0_VC2_CREDIT_OUT"  => [  59,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo overflow" ],
   "OVERFLOW_NI0_VC1_CREDIT_OUT"  => [  60,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo overflow" ],
   "OVERFLOW_NI0_VC0_CREDIT_OUT"  => [  61,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT_OUT" => [  62,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo overflow" ],
   "OVERFLOW_IILB_VC0_CREDIT_OUT" => [  63,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo overflow" ],
);

%orbit_01_00990_def =
( NAME    => "OC_XNIILB_ERROR_SUMMARY",
  ADDRESS => 0x00000000d0040200,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00990_flds
);


##########################################################################
#                                                                        #
#   OC_XNIILB_ERRORS_ALIAS                                               #
#                                                                        #
##########################################################################

%orbit_01_00991_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_LB_FAST_TAIL"        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail overflow" ],
   "OVERFLOW_II_FAST_TAIL"        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "II fast tail overflow" ],
   "OVERFLOW_MD_DATA_FAST_TAIL"   => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "MD data fast tail overflow" ],
   "OVERFLOW_MD_HDR_FAST_TAIL"    => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail overflow" ],
   "OVERFLOW_PI_DATA_FAST_TAIL"   => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail overflow" ],
   "OVERFLOW_PI_HDR_FAST_TAIL"    => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail overflow" ],
   "OVERFLOW_NI1_FAST_TAIL"       => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail overflow" ],
   "OVERFLOW_NI0_FAST_TAIL"       => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail overflow" ],
   "OVERFLOW_IILB_FAST_TAIL"      => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "OVERFLOW_LB_DEBIT2"           => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "LB VC2 debit overflow" ],
   "OVERFLOW_LB_DEBIT0"           => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "LB VC0 debit overflow" ],
   "OVERFLOW_II_DEBIT2"           => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "II VC2 debit overflow" ],
   "OVERFLOW_II_DEBIT0"           => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "II VC0 debit overflow" ],
   "OVERFLOW_MD_DEBIT2"           => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "MD VC2 fifo debit overflow" ],
   "OVERFLOW_MD_DEBIT0"           => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 fifo debit overflow" ],
   "OVERFLOW_PI_DEBIT2"           => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "PI VC2 fifo debit overflow" ],
   "OVERFLOW_PI_DEBIT0"           => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "PI VC0 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT3"          => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo debit overflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo debit overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo debit overflow" ],
   "OVERFLOW_LB_VC2_CREDIT_OUT"   => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "LB VC2 credit overflow" ],
   "OVERFLOW_LB_VC0_CREDIT_OUT"   => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "LB VC0 credit overflow" ],
   "OVERFLOW_II_VC2_CREDIT_OUT"   => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "II VC2 credit overflow" ],
   "OVERFLOW_II_VC0_CREDIT_OUT"   => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "II VC0 credit overflow" ],
   "OVERFLOW_MD_VC2_CREDIT_IN"    => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "MD VC2 credit overflow" ],
   "OVERFLOW_MD_VC0_CREDIT_IN"    => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "MD VC0 credit overflow" ],
   "OVERFLOW_PI_VC2_CREDIT_IN"    => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI VC2 credit overflow" ],
   "OVERFLOW_PI_VC0_CREDIT_IN"    => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "PI VC0 credit overflow" ],
   "OVERFLOW_NI1_VC2_CREDIT_IN"   => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit overflow" ],
   "OVERFLOW_NI1_VC0_CREDIT_IN"   => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit overflow" ],
   "OVERFLOW_NI0_VC2_CREDIT_IN"   => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit overflow" ],
   "OVERFLOW_NI0_VC0_CREDIT_IN"   => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT_IN"  => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit overflow" ],
   "OVERFLOW_IILB_VC0_CREDIT_IN"  => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit overflow" ],
   "OVERFLOW_LB_VC2"              => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "LB VC2 fifo overflow" ],
   "OVERFLOW_LB_VC0"              => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "LB VC0 fifo overflow" ],
   "OVERFLOW_II_VC2"              => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "II VC2 fifo overflow" ],
   "OVERFLOW_II_VC0"              => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "II VC0 fifo overflow" ],
   "OVERFLOW_MD_DATA_VC2_CREDIT_OUT" => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD VC0 data fifo overflow" ],
   "OVERFLOW_MD_DATA_VC0_CREDIT_OUT" => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD VC0 data fifo overflow" ],
   "OVERFLOW_MD_HDR_VC2_CREDIT_OUT" => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD VC0 hdr fifo overflow" ],
   "OVERFLOW_MD_HDR_VC0_CREDIT_OUT" => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD VC0 hdr fifo overflow" ],
   "OVERFLOW_PI_DATA_VC2_CREDIT_OUT" => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI VC2 data fifo overflow" ],
   "OVERFLOW_PI_DATA_VC0_CREDIT_OUT" => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI VC0 data fifo overflow" ],
   "OVERFLOW_PI_HDR_VC2_CREDIT_OUT" => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI VC2 hdr fifo overflow" ],
   "OVERFLOW_PI_HDR_VC0_CREDIT_OUT" => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI VC0 hdr fifo overflow" ],
   "OVERFLOW_NI1_VC3_CREDIT_OUT"  => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo overflow" ],
   "OVERFLOW_NI1_VC2_CREDIT_OUT"  => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo overflow" ],
   "OVERFLOW_NI1_VC1_CREDIT_OUT"  => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo overflow" ],
   "OVERFLOW_NI1_VC0_CREDIT_OUT"  => [  57,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo overflow" ],
   "OVERFLOW_NI0_VC3_CREDIT_OUT"  => [  58,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo overflow" ],
   "OVERFLOW_NI0_VC2_CREDIT_OUT"  => [  59,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo overflow" ],
   "OVERFLOW_NI0_VC1_CREDIT_OUT"  => [  60,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo overflow" ],
   "OVERFLOW_NI0_VC0_CREDIT_OUT"  => [  61,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT_OUT" => [  62,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo overflow" ],
   "OVERFLOW_IILB_VC0_CREDIT_OUT" => [  63,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo overflow" ],
);

%orbit_01_00991_def =
( NAME    => "OC_XNIILB_ERRORS_ALIAS",
  ADDRESS => 0x00000000d0040208,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00991_flds
);


##########################################################################
#                                                                        #
#   OC_XNIILB_ERROR_OVERFLOW                                             #
#                                                                        #
##########################################################################

%orbit_01_00992_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_LB_FAST_TAIL"        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail overflow" ],
   "OVERFLOW_II_FAST_TAIL"        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "II fast tail overflow" ],
   "OVERFLOW_MD_DATA_FAST_TAIL"   => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "MD data fast tail overflow" ],
   "OVERFLOW_MD_HDR_FAST_TAIL"    => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail overflow" ],
   "OVERFLOW_PI_DATA_FAST_TAIL"   => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail overflow" ],
   "OVERFLOW_PI_HDR_FAST_TAIL"    => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail overflow" ],
   "OVERFLOW_NI1_FAST_TAIL"       => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail overflow" ],
   "OVERFLOW_NI0_FAST_TAIL"       => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail overflow" ],
   "OVERFLOW_IILB_FAST_TAIL"      => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "OVERFLOW_LB_DEBIT2"           => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "LB VC2 debit overflow" ],
   "OVERFLOW_LB_DEBIT0"           => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "LB VC0 debit overflow" ],
   "OVERFLOW_II_DEBIT2"           => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "II VC2 debit overflow" ],
   "OVERFLOW_II_DEBIT0"           => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "II VC0 debit overflow" ],
   "OVERFLOW_MD_DEBIT2"           => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "MD VC2 fifo debit overflow" ],
   "OVERFLOW_MD_DEBIT0"           => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 fifo debit overflow" ],
   "OVERFLOW_PI_DEBIT2"           => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "PI VC2 fifo debit overflow" ],
   "OVERFLOW_PI_DEBIT0"           => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "PI VC0 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT3"          => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo debit overflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo debit overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo debit overflow" ],
   "OVERFLOW_LB_VC2_CREDIT_OUT"   => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "LB VC2 credit overflow" ],
   "OVERFLOW_LB_VC0_CREDIT_OUT"   => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "LB VC0 credit overflow" ],
   "OVERFLOW_II_VC2_CREDIT_OUT"   => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "II VC2 credit overflow" ],
   "OVERFLOW_II_VC0_CREDIT_OUT"   => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "II VC0 credit overflow" ],
   "OVERFLOW_MD_VC2_CREDIT_IN"    => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "MD VC2 credit overflow" ],
   "OVERFLOW_MD_VC0_CREDIT_IN"    => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "MD VC0 credit overflow" ],
   "OVERFLOW_PI_VC2_CREDIT_IN"    => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI VC2 credit overflow" ],
   "OVERFLOW_PI_VC0_CREDIT_IN"    => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "PI VC0 credit overflow" ],
   "OVERFLOW_NI1_VC2_CREDIT_IN"   => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit overflow" ],
   "OVERFLOW_NI1_VC0_CREDIT_IN"   => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit overflow" ],
   "OVERFLOW_NI0_VC2_CREDIT_IN"   => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit overflow" ],
   "OVERFLOW_NI0_VC0_CREDIT_IN"   => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT_IN"  => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit overflow" ],
   "OVERFLOW_IILB_VC0_CREDIT_IN"  => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit overflow" ],
   "OVERFLOW_LB_VC2"              => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "LB VC2 fifo overflow" ],
   "OVERFLOW_LB_VC0"              => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "LB VC0 fifo overflow" ],
   "OVERFLOW_II_VC2"              => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "II VC2 fifo overflow" ],
   "OVERFLOW_II_VC0"              => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "II VC0 fifo overflow" ],
   "OVERFLOW_MD_DATA_VC2_CREDIT_OUT" => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD VC0 data fifo overflow" ],
   "OVERFLOW_MD_DATA_VC0_CREDIT_OUT" => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD VC0 data fifo overflow" ],
   "OVERFLOW_MD_HDR_VC2_CREDIT_OUT" => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD VC0 hdr fifo overflow" ],
   "OVERFLOW_MD_HDR_VC0_CREDIT_OUT" => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD VC0 hdr fifo overflow" ],
   "OVERFLOW_PI_DATA_VC2_CREDIT_OUT" => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI VC2 data fifo overflow" ],
   "OVERFLOW_PI_DATA_VC0_CREDIT_OUT" => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI VC0 data fifo overflow" ],
   "OVERFLOW_PI_HDR_VC2_CREDIT_OUT" => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI VC2 hdr fifo overflow" ],
   "OVERFLOW_PI_HDR_VC0_CREDIT_OUT" => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI VC0 hdr fifo overflow" ],
   "OVERFLOW_NI1_VC3_CREDIT_OUT"  => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo overflow" ],
   "OVERFLOW_NI1_VC2_CREDIT_OUT"  => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo overflow" ],
   "OVERFLOW_NI1_VC1_CREDIT_OUT"  => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo overflow" ],
   "OVERFLOW_NI1_VC0_CREDIT_OUT"  => [  57,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo overflow" ],
   "OVERFLOW_NI0_VC3_CREDIT_OUT"  => [  58,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo overflow" ],
   "OVERFLOW_NI0_VC2_CREDIT_OUT"  => [  59,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo overflow" ],
   "OVERFLOW_NI0_VC1_CREDIT_OUT"  => [  60,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo overflow" ],
   "OVERFLOW_NI0_VC0_CREDIT_OUT"  => [  61,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT_OUT" => [  62,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo overflow" ],
   "OVERFLOW_IILB_VC0_CREDIT_OUT" => [  63,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo overflow" ],
);

%orbit_01_00992_def =
( NAME    => "OC_XNIILB_ERROR_OVERFLOW",
  ADDRESS => 0x00000000d0040220,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00992_flds
);


##########################################################################
#                                                                        #
#   OC_XNIILB_ERROR_OVERFLOW_ALIAS                                       #
#                                                                        #
##########################################################################

%orbit_01_00993_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_LB_FAST_TAIL"        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail overflow" ],
   "OVERFLOW_II_FAST_TAIL"        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "II fast tail overflow" ],
   "OVERFLOW_MD_DATA_FAST_TAIL"   => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "MD data fast tail overflow" ],
   "OVERFLOW_MD_HDR_FAST_TAIL"    => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail overflow" ],
   "OVERFLOW_PI_DATA_FAST_TAIL"   => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail overflow" ],
   "OVERFLOW_PI_HDR_FAST_TAIL"    => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail overflow" ],
   "OVERFLOW_NI1_FAST_TAIL"       => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail overflow" ],
   "OVERFLOW_NI0_FAST_TAIL"       => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail overflow" ],
   "OVERFLOW_IILB_FAST_TAIL"      => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "OVERFLOW_LB_DEBIT2"           => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "LB VC2 debit overflow" ],
   "OVERFLOW_LB_DEBIT0"           => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "LB VC0 debit overflow" ],
   "OVERFLOW_II_DEBIT2"           => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "II VC2 debit overflow" ],
   "OVERFLOW_II_DEBIT0"           => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "II VC0 debit overflow" ],
   "OVERFLOW_MD_DEBIT2"           => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "MD VC2 fifo debit overflow" ],
   "OVERFLOW_MD_DEBIT0"           => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 fifo debit overflow" ],
   "OVERFLOW_PI_DEBIT2"           => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "PI VC2 fifo debit overflow" ],
   "OVERFLOW_PI_DEBIT0"           => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "PI VC0 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT3"          => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo debit overflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo debit overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo debit overflow" ],
   "OVERFLOW_LB_VC2_CREDIT_OUT"   => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "LB VC2 credit overflow" ],
   "OVERFLOW_LB_VC0_CREDIT_OUT"   => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "LB VC0 credit overflow" ],
   "OVERFLOW_II_VC2_CREDIT_OUT"   => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "II VC2 credit overflow" ],
   "OVERFLOW_II_VC0_CREDIT_OUT"   => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "II VC0 credit overflow" ],
   "OVERFLOW_MD_VC2_CREDIT_IN"    => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "MD VC2 credit overflow" ],
   "OVERFLOW_MD_VC0_CREDIT_IN"    => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "MD VC0 credit overflow" ],
   "OVERFLOW_PI_VC2_CREDIT_IN"    => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI VC2 credit overflow" ],
   "OVERFLOW_PI_VC0_CREDIT_IN"    => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "PI VC0 credit overflow" ],
   "OVERFLOW_NI1_VC2_CREDIT_IN"   => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit overflow" ],
   "OVERFLOW_NI1_VC0_CREDIT_IN"   => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit overflow" ],
   "OVERFLOW_NI0_VC2_CREDIT_IN"   => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit overflow" ],
   "OVERFLOW_NI0_VC0_CREDIT_IN"   => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT_IN"  => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit overflow" ],
   "OVERFLOW_IILB_VC0_CREDIT_IN"  => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit overflow" ],
   "OVERFLOW_LB_VC2"              => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "LB VC2 fifo overflow" ],
   "OVERFLOW_LB_VC0"              => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "LB VC0 fifo overflow" ],
   "OVERFLOW_II_VC2"              => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "II VC2 fifo overflow" ],
   "OVERFLOW_II_VC0"              => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "II VC0 fifo overflow" ],
   "OVERFLOW_MD_DATA_VC2_CREDIT_OUT" => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD VC0 data fifo overflow" ],
   "OVERFLOW_MD_DATA_VC0_CREDIT_OUT" => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD VC0 data fifo overflow" ],
   "OVERFLOW_MD_HDR_VC2_CREDIT_OUT" => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD VC0 hdr fifo overflow" ],
   "OVERFLOW_MD_HDR_VC0_CREDIT_OUT" => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD VC0 hdr fifo overflow" ],
   "OVERFLOW_PI_DATA_VC2_CREDIT_OUT" => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI VC2 data fifo overflow" ],
   "OVERFLOW_PI_DATA_VC0_CREDIT_OUT" => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI VC0 data fifo overflow" ],
   "OVERFLOW_PI_HDR_VC2_CREDIT_OUT" => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI VC2 hdr fifo overflow" ],
   "OVERFLOW_PI_HDR_VC0_CREDIT_OUT" => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI VC0 hdr fifo overflow" ],
   "OVERFLOW_NI1_VC3_CREDIT_OUT"  => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo overflow" ],
   "OVERFLOW_NI1_VC2_CREDIT_OUT"  => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo overflow" ],
   "OVERFLOW_NI1_VC1_CREDIT_OUT"  => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo overflow" ],
   "OVERFLOW_NI1_VC0_CREDIT_OUT"  => [  57,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo overflow" ],
   "OVERFLOW_NI0_VC3_CREDIT_OUT"  => [  58,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo overflow" ],
   "OVERFLOW_NI0_VC2_CREDIT_OUT"  => [  59,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo overflow" ],
   "OVERFLOW_NI0_VC1_CREDIT_OUT"  => [  60,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo overflow" ],
   "OVERFLOW_NI0_VC0_CREDIT_OUT"  => [  61,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT_OUT" => [  62,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo overflow" ],
   "OVERFLOW_IILB_VC0_CREDIT_OUT" => [  63,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo overflow" ],
);

%orbit_01_00993_def =
( NAME    => "OC_XNIILB_ERROR_OVERFLOW_ALIAS",
  ADDRESS => 0x00000000d0040228,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00993_flds
);


##########################################################################
#                                                                        #
#   OC_XNIILB_ERROR_MASK                                                 #
#                                                                        #
##########################################################################

%orbit_01_00994_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_LB_FAST_TAIL"        => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "LB fast tail overflow" ],
   "OVERFLOW_II_FAST_TAIL"        => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "II fast tail overflow" ],
   "OVERFLOW_MD_DATA_FAST_TAIL"   => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "MD data fast tail overflow" ],
   "OVERFLOW_MD_HDR_FAST_TAIL"    => [   4,  59,   1, 0x0800000000000000, 0x00, 1, 0x0000000000000000, "MD hdr fast tail overflow" ],
   "OVERFLOW_PI_DATA_FAST_TAIL"   => [   5,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "PI data fast tail overflow" ],
   "OVERFLOW_PI_HDR_FAST_TAIL"    => [   6,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "PI hdr fast tail overflow" ],
   "OVERFLOW_NI1_FAST_TAIL"       => [   7,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "NI1 fast tail overflow" ],
   "OVERFLOW_NI0_FAST_TAIL"       => [   8,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "NI0 fast tail overflow" ],
   "OVERFLOW_IILB_FAST_TAIL"      => [   9,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "IILB fast tail overflow" ],
   "OVERFLOW_LB_DEBIT2"           => [  10,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "LB VC2 debit overflow" ],
   "OVERFLOW_LB_DEBIT0"           => [  11,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "LB VC0 debit overflow" ],
   "OVERFLOW_II_DEBIT2"           => [  12,  51,   1, 0x0008000000000000, 0x00, 1, 0x0000000000000000, "II VC2 debit overflow" ],
   "OVERFLOW_II_DEBIT0"           => [  13,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "II VC0 debit overflow" ],
   "OVERFLOW_MD_DEBIT2"           => [  14,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "MD VC2 fifo debit overflow" ],
   "OVERFLOW_MD_DEBIT0"           => [  15,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "MD VC0 fifo debit overflow" ],
   "OVERFLOW_PI_DEBIT2"           => [  16,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "PI VC2 fifo debit overflow" ],
   "OVERFLOW_PI_DEBIT0"           => [  17,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "PI VC0 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT3"          => [  18,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "NI1 VC3 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  19,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "NI1 VC2 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  20,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "NI1 VC1 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  21,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "NI1 VC0 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  22,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "NI0 VC3 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  23,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "NI0 VC2 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  24,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "NI0 VC1 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  25,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "NI0 VC0 fifo debit overflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  26,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "IILB VC2 fifo debit overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  27,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "IILB VC0 fifo debit overflow" ],
   "OVERFLOW_LB_VC2_CREDIT_OUT"   => [  28,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "LB VC2 credit overflow" ],
   "OVERFLOW_LB_VC0_CREDIT_OUT"   => [  29,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "LB VC0 credit overflow" ],
   "OVERFLOW_II_VC2_CREDIT_OUT"   => [  30,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "II VC2 credit overflow" ],
   "OVERFLOW_II_VC0_CREDIT_OUT"   => [  31,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "II VC0 credit overflow" ],
   "OVERFLOW_MD_VC2_CREDIT_IN"    => [  32,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "MD VC2 credit overflow" ],
   "OVERFLOW_MD_VC0_CREDIT_IN"    => [  33,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "MD VC0 credit overflow" ],
   "OVERFLOW_PI_VC2_CREDIT_IN"    => [  34,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "PI VC2 credit overflow" ],
   "OVERFLOW_PI_VC0_CREDIT_IN"    => [  35,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "PI VC0 credit overflow" ],
   "OVERFLOW_NI1_VC2_CREDIT_IN"   => [  36,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "NI1 VC2 credit overflow" ],
   "OVERFLOW_NI1_VC0_CREDIT_IN"   => [  37,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "NI1 VC0 credit overflow" ],
   "OVERFLOW_NI0_VC2_CREDIT_IN"   => [  38,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "NI0 VC2 credit overflow" ],
   "OVERFLOW_NI0_VC0_CREDIT_IN"   => [  39,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "NI0 VC0 credit overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT_IN"  => [  40,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "IILB VC2 credit overflow" ],
   "OVERFLOW_IILB_VC0_CREDIT_IN"  => [  41,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "IILB VC0 credit overflow" ],
   "OVERFLOW_LB_VC2"              => [  42,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "LB VC2 fifo overflow" ],
   "OVERFLOW_LB_VC0"              => [  43,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "LB VC0 fifo overflow" ],
   "OVERFLOW_II_VC2"              => [  44,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "II VC2 fifo overflow" ],
   "OVERFLOW_II_VC0"              => [  45,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "II VC0 fifo overflow" ],
   "OVERFLOW_MD_DATA_VC2_CREDIT_OUT" => [  46,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "MD VC0 data fifo overflow" ],
   "OVERFLOW_MD_DATA_VC0_CREDIT_OUT" => [  47,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "MD VC0 data fifo overflow" ],
   "OVERFLOW_MD_HDR_VC2_CREDIT_OUT" => [  48,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "MD VC0 hdr fifo overflow" ],
   "OVERFLOW_MD_HDR_VC0_CREDIT_OUT" => [  49,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "MD VC0 hdr fifo overflow" ],
   "OVERFLOW_PI_DATA_VC2_CREDIT_OUT" => [  50,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "PI VC2 data fifo overflow" ],
   "OVERFLOW_PI_DATA_VC0_CREDIT_OUT" => [  51,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "PI VC0 data fifo overflow" ],
   "OVERFLOW_PI_HDR_VC2_CREDIT_OUT" => [  52,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "PI VC2 hdr fifo overflow" ],
   "OVERFLOW_PI_HDR_VC0_CREDIT_OUT" => [  53,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "PI VC0 hdr fifo overflow" ],
   "OVERFLOW_NI1_VC3_CREDIT_OUT"  => [  54,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "NI1 VC3 fifo overflow" ],
   "OVERFLOW_NI1_VC2_CREDIT_OUT"  => [  55,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "NI1 VC2 fifo overflow" ],
   "OVERFLOW_NI1_VC1_CREDIT_OUT"  => [  56,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "NI1 VC1 fifo overflow" ],
   "OVERFLOW_NI1_VC0_CREDIT_OUT"  => [  57,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "NI1 VC0 fifo overflow" ],
   "OVERFLOW_NI0_VC3_CREDIT_OUT"  => [  58,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "NI0 VC3 fifo overflow" ],
   "OVERFLOW_NI0_VC2_CREDIT_OUT"  => [  59,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "NI0 VC2 fifo overflow" ],
   "OVERFLOW_NI0_VC1_CREDIT_OUT"  => [  60,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "NI0 VC1 fifo overflow" ],
   "OVERFLOW_NI0_VC0_CREDIT_OUT"  => [  61,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "NI0 VC0 fifo overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT_OUT" => [  62,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "IILB VC2 fifo overflow" ],
   "OVERFLOW_IILB_VC0_CREDIT_OUT" => [  63,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "IILB VC0 fifo overflow" ],
);

%orbit_01_00994_def =
( NAME    => "OC_XNIILB_ERROR_MASK",
  ADDRESS => 0x00000000d0040240,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00994_flds
);


##########################################################################
#                                                                        #
#   OC_XNIILB_FIRST_ERROR                                                #
#                                                                        #
##########################################################################

%orbit_01_00995_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_LB_FAST_TAIL"        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail overflow" ],
   "OVERFLOW_II_FAST_TAIL"        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "II fast tail overflow" ],
   "OVERFLOW_MD_DATA_FAST_TAIL"   => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "MD data fast tail overflow" ],
   "OVERFLOW_MD_HDR_FAST_TAIL"    => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail overflow" ],
   "OVERFLOW_PI_DATA_FAST_TAIL"   => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail overflow" ],
   "OVERFLOW_PI_HDR_FAST_TAIL"    => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail overflow" ],
   "OVERFLOW_NI1_FAST_TAIL"       => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail overflow" ],
   "OVERFLOW_NI0_FAST_TAIL"       => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail overflow" ],
   "OVERFLOW_IILB_FAST_TAIL"      => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "OVERFLOW_LB_DEBIT2"           => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "LB VC2 debit overflow" ],
   "OVERFLOW_LB_DEBIT0"           => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "LB VC0 debit overflow" ],
   "OVERFLOW_II_DEBIT2"           => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "II VC2 debit overflow" ],
   "OVERFLOW_II_DEBIT0"           => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "II VC0 debit overflow" ],
   "OVERFLOW_MD_DEBIT2"           => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "MD VC2 fifo debit overflow" ],
   "OVERFLOW_MD_DEBIT0"           => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 fifo debit overflow" ],
   "OVERFLOW_PI_DEBIT2"           => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "PI VC2 fifo debit overflow" ],
   "OVERFLOW_PI_DEBIT0"           => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "PI VC0 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT3"          => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo debit overflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo debit overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo debit overflow" ],
   "OVERFLOW_LB_VC2_CREDIT_OUT"   => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "LB VC2 credit overflow" ],
   "OVERFLOW_LB_VC0_CREDIT_OUT"   => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "LB VC0 credit overflow" ],
   "OVERFLOW_II_VC2_CREDIT_OUT"   => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "II VC2 credit overflow" ],
   "OVERFLOW_II_VC0_CREDIT_OUT"   => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "II VC0 credit overflow" ],
   "OVERFLOW_MD_VC2_CREDIT_IN"    => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "MD VC2 credit overflow" ],
   "OVERFLOW_MD_VC0_CREDIT_IN"    => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "MD VC0 credit overflow" ],
   "OVERFLOW_PI_VC2_CREDIT_IN"    => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI VC2 credit overflow" ],
   "OVERFLOW_PI_VC0_CREDIT_IN"    => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "PI VC0 credit overflow" ],
   "OVERFLOW_NI1_VC2_CREDIT_IN"   => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit overflow" ],
   "OVERFLOW_NI1_VC0_CREDIT_IN"   => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit overflow" ],
   "OVERFLOW_NI0_VC2_CREDIT_IN"   => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit overflow" ],
   "OVERFLOW_NI0_VC0_CREDIT_IN"   => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT_IN"  => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit overflow" ],
   "OVERFLOW_IILB_VC0_CREDIT_IN"  => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit overflow" ],
   "OVERFLOW_LB_VC2"              => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "LB VC2 fifo overflow" ],
   "OVERFLOW_LB_VC0"              => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "LB VC0 fifo overflow" ],
   "OVERFLOW_II_VC2"              => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "II VC2 fifo overflow" ],
   "OVERFLOW_II_VC0"              => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "II VC0 fifo overflow" ],
   "OVERFLOW_MD_DATA_VC2_CREDIT_OUT" => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD VC0 data fifo overflow" ],
   "OVERFLOW_MD_DATA_VC0_CREDIT_OUT" => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD VC0 data fifo overflow" ],
   "OVERFLOW_MD_HDR_VC2_CREDIT_OUT" => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD VC0 hdr fifo overflow" ],
   "OVERFLOW_MD_HDR_VC0_CREDIT_OUT" => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD VC0 hdr fifo overflow" ],
   "OVERFLOW_PI_DATA_VC2_CREDIT_OUT" => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI VC2 data fifo overflow" ],
   "OVERFLOW_PI_DATA_VC0_CREDIT_OUT" => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI VC0 data fifo overflow" ],
   "OVERFLOW_PI_HDR_VC2_CREDIT_OUT" => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI VC2 hdr fifo overflow" ],
   "OVERFLOW_PI_HDR_VC0_CREDIT_OUT" => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI VC0 hdr fifo overflow" ],
   "OVERFLOW_NI1_VC3_CREDIT_OUT"  => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo overflow" ],
   "OVERFLOW_NI1_VC2_CREDIT_OUT"  => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo overflow" ],
   "OVERFLOW_NI1_VC1_CREDIT_OUT"  => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo overflow" ],
   "OVERFLOW_NI1_VC0_CREDIT_OUT"  => [  57,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo overflow" ],
   "OVERFLOW_NI0_VC3_CREDIT_OUT"  => [  58,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo overflow" ],
   "OVERFLOW_NI0_VC2_CREDIT_OUT"  => [  59,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo overflow" ],
   "OVERFLOW_NI0_VC1_CREDIT_OUT"  => [  60,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo overflow" ],
   "OVERFLOW_NI0_VC0_CREDIT_OUT"  => [  61,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT_OUT" => [  62,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo overflow" ],
   "OVERFLOW_IILB_VC0_CREDIT_OUT" => [  63,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo overflow" ],
);

%orbit_01_00995_def =
( NAME    => "OC_XNIILB_FIRST_ERROR",
  ADDRESS => 0x00000000d0040260,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00995_flds
);


##########################################################################
#                                                                        #
#   OC_XNIILB_ERRORS_SUMMARY_1                                           #
#                                                                        #
##########################################################################

%orbit_01_00996_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_READ_ERROR"               => [   1,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [   2,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "ERROR_MD_TAIL_CNT"            => [   3,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "MD tail count error" ],
   "ERROR_PI_TAIL_CNT"            => [   4,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "PI tail count error" ],
   "ERROR_LB_FAST_TAIL"           => [   5,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail error" ],
   "ERROR_II_FAST_TAIL"           => [   6,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "II fast tail error" ],
   "ERROR_MD_FAST_TAIL"           => [   7,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD fast tail error" ],
   "ERROR_PI_FAST_TAIL"           => [   8,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "PI fast tail error" ],
   "ERROR_NI1_FAST_TAIL"          => [   9,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail error" ],
   "ERROR_NI0_FAST_TAIL"          => [  10,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail error" ],
   "ERROR_IILB_FAST_TAIL"         => [  11,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "UNDERFLOW_LB_FAST_TAIL"       => [  12,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail underflow" ],
   "UNDERFLOW_II_FAST_TAIL"       => [  13,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "II fast tail underflow" ],
   "UNDERFLOW_MD_DATA_FAST_TAIL"  => [  14,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "MD data fast tail underflow" ],
   "UNDERFLOW_MD_HDR_FAST_TAIL"   => [  15,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail underflow" ],
   "UNDERFLOW_PI_DATA_FAST_TAIL"  => [  16,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail underflow" ],
   "UNDERFLOW_PI_HDR_FAST_TAIL"   => [  17,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail underflow" ],
   "UNDERFLOW_NI1_FAST_TAIL"      => [  18,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail underflow" ],
   "UNDERFLOW_NI0_FAST_TAIL"      => [  19,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail underflow" ],
   "UNDERFLOW_IILB_FAST_TAIL"     => [  20,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "UNDERFLOW_MD_DEBIT2"          => [  21,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "MD VC2 fifo debit underflow" ],
   "UNDERFLOW_MD_DEBIT0"          => [  22,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "MD VC0 fifo debit underflow" ],
   "UNDERFLOW_PI_DEBIT2"          => [  23,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "PI VC2 fifo debit underflow" ],
   "UNDERFLOW_PI_DEBIT0"          => [  24,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "PI VC0 fifo debit underflow" ],
   "UNDERFLOW_LB_VC2_CREDIT_OUT"  => [  25,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "LB VC2 credit underflow" ],
   "UNDERFLOW_LB_VC0_CREDIT_OUT"  => [  26,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "LB VC0 credit underflow" ],
   "UNDERFLOW_II_VC2_CREDIT_OUT"  => [  27,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "II VC2 credit underflow" ],
   "UNDERFLOW_II_VC0_CREDIT_OUT"  => [  28,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "II VC0 credit underflow" ],
   "UNDERFLOW_MD_VC2_CREDIT_IN"   => [  29,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "MD VC2 credit underflow" ],
   "UNDERFLOW_MD_VC0_CREDIT_IN"   => [  30,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "MD VC0 credit underflow" ],
   "UNDERFLOW_PI_VC2_CREDIT_IN"   => [  31,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI VC2 credit underflow" ],
   "UNDERFLOW_PI_VC0_CREDIT_IN"   => [  32,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "PI VC0 credit underflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT_IN"  => [  33,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit underflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT_IN"  => [  34,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit underflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT_IN"  => [  35,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit underflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT_IN"  => [  36,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit underflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT_IN" => [  37,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit underflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT_IN" => [  38,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit underflow" ],
   "UNDERFLOW_LB_VC2"             => [  39,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "LB VC2 fifo underflow" ],
   "UNDERFLOW_LB_VC0"             => [  40,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "LB VC0 fifo underflow" ],
   "UNDERFLOW_II_VC2"             => [  41,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "II VC2 fifo underflow" ],
   "UNDERFLOW_II_VC0"             => [  42,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "II VC0 fifo underflow" ],
   "UNDERFLOW_MD_DATA_VC2_CREDIT_OUT" => [  43,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD VC2 data fifo underflow" ],
   "UNDERFLOW_MD_DATA_VC0_CREDIT_OUT" => [  44,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD VC0 data fifo underflow" ],
   "UNDERFLOW_MD_HDR_VC2_CREDIT_OUT" => [  45,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD VC2 hdr fifo underflow" ],
   "UNDERFLOW_MD_HDR_VC0_CREDIT_OUT" => [  46,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD VC0 hdr fifo underflow" ],
   "UNDERFLOW_PI_DATA_VC2_CREDIT_OUT" => [  47,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI VC2 data fifo underflow" ],
   "UNDERFLOW_PI_DATA_VC0_CREDIT_OUT" => [  48,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI VC0 data fifo underflow" ],
   "UNDERFLOW_PI_HDR_VC2_CREDIT_OUT" => [  49,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI VC2 hdr fifo underflow" ],
   "UNDERFLOW_PI_HDR_VC0_CREDIT_OUT" => [  50,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI VC0 hdr fifo underflow" ],
   "UNDERFLOW_NI1_VC3_CREDIT_OUT" => [  51,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo underflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT_OUT" => [  52,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo underflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT_OUT" => [  53,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo underflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT_OUT" => [  54,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo underflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT_OUT" => [  55,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo underflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT_OUT" => [  56,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo underflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT_OUT" => [  57,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo underflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT_OUT" => [  58,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo underflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT_OUT" => [  59,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo underflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT_OUT" => [  60,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo underflow" ],
);

%orbit_01_00996_def =
( NAME    => "OC_XNIILB_ERRORS_SUMMARY_1",
  ADDRESS => 0x00000000d0040210,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00996_flds
);


##########################################################################
#                                                                        #
#   OC_XNIILB_ERRORS_ALIAS_1                                             #
#                                                                        #
##########################################################################

%orbit_01_00997_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_READ_ERROR"               => [   1,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [   2,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "ERROR_MD_TAIL_CNT"            => [   3,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "MD tail count error" ],
   "ERROR_PI_TAIL_CNT"            => [   4,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "PI tail count error" ],
   "ERROR_LB_FAST_TAIL"           => [   5,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail error" ],
   "ERROR_II_FAST_TAIL"           => [   6,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "II fast tail error" ],
   "ERROR_MD_FAST_TAIL"           => [   7,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD fast tail error" ],
   "ERROR_PI_FAST_TAIL"           => [   8,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "PI fast tail error" ],
   "ERROR_NI1_FAST_TAIL"          => [   9,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail error" ],
   "ERROR_NI0_FAST_TAIL"          => [  10,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail error" ],
   "ERROR_IILB_FAST_TAIL"         => [  11,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "UNDERFLOW_LB_FAST_TAIL"       => [  12,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail underflow" ],
   "UNDERFLOW_II_FAST_TAIL"       => [  13,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "II fast tail underflow" ],
   "UNDERFLOW_MD_DATA_FAST_TAIL"  => [  14,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "MD data fast tail underflow" ],
   "UNDERFLOW_MD_HDR_FAST_TAIL"   => [  15,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail underflow" ],
   "UNDERFLOW_PI_DATA_FAST_TAIL"  => [  16,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail underflow" ],
   "UNDERFLOW_PI_HDR_FAST_TAIL"   => [  17,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail underflow" ],
   "UNDERFLOW_NI1_FAST_TAIL"      => [  18,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail underflow" ],
   "UNDERFLOW_NI0_FAST_TAIL"      => [  19,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail underflow" ],
   "UNDERFLOW_IILB_FAST_TAIL"     => [  20,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "UNDERFLOW_MD_DEBIT2"          => [  21,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "MD VC2 fifo debit underflow" ],
   "UNDERFLOW_MD_DEBIT0"          => [  22,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "MD VC0 fifo debit underflow" ],
   "UNDERFLOW_PI_DEBIT2"          => [  23,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "PI VC2 fifo debit underflow" ],
   "UNDERFLOW_PI_DEBIT0"          => [  24,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "PI VC0 fifo debit underflow" ],
   "UNDERFLOW_LB_VC2_CREDIT_OUT"  => [  25,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "LB VC2 credit underflow" ],
   "UNDERFLOW_LB_VC0_CREDIT_OUT"  => [  26,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "LB VC0 credit underflow" ],
   "UNDERFLOW_II_VC2_CREDIT_OUT"  => [  27,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "II VC2 credit underflow" ],
   "UNDERFLOW_II_VC0_CREDIT_OUT"  => [  28,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "II VC0 credit underflow" ],
   "UNDERFLOW_MD_VC2_CREDIT_IN"   => [  29,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "MD VC2 credit underflow" ],
   "UNDERFLOW_MD_VC0_CREDIT_IN"   => [  30,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "MD VC0 credit underflow" ],
   "UNDERFLOW_PI_VC2_CREDIT_IN"   => [  31,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI VC2 credit underflow" ],
   "UNDERFLOW_PI_VC0_CREDIT_IN"   => [  32,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "PI VC0 credit underflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT_IN"  => [  33,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit underflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT_IN"  => [  34,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit underflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT_IN"  => [  35,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit underflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT_IN"  => [  36,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit underflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT_IN" => [  37,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit underflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT_IN" => [  38,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit underflow" ],
   "UNDERFLOW_LB_VC2"             => [  39,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "LB VC2 fifo underflow" ],
   "UNDERFLOW_LB_VC0"             => [  40,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "LB VC0 fifo underflow" ],
   "UNDERFLOW_II_VC2"             => [  41,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "II VC2 fifo underflow" ],
   "UNDERFLOW_II_VC0"             => [  42,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "II VC0 fifo underflow" ],
   "UNDERFLOW_MD_DATA_VC2_CREDIT_OUT" => [  43,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD VC2 data fifo underflow" ],
   "UNDERFLOW_MD_DATA_VC0_CREDIT_OUT" => [  44,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD VC0 data fifo underflow" ],
   "UNDERFLOW_MD_HDR_VC2_CREDIT_OUT" => [  45,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD VC2 hdr fifo underflow" ],
   "UNDERFLOW_MD_HDR_VC0_CREDIT_OUT" => [  46,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD VC0 hdr fifo underflow" ],
   "UNDERFLOW_PI_DATA_VC2_CREDIT_OUT" => [  47,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI VC2 data fifo underflow" ],
   "UNDERFLOW_PI_DATA_VC0_CREDIT_OUT" => [  48,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI VC0 data fifo underflow" ],
   "UNDERFLOW_PI_HDR_VC2_CREDIT_OUT" => [  49,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI VC2 hdr fifo underflow" ],
   "UNDERFLOW_PI_HDR_VC0_CREDIT_OUT" => [  50,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI VC0 hdr fifo underflow" ],
   "UNDERFLOW_NI1_VC3_CREDIT_OUT" => [  51,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo underflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT_OUT" => [  52,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo underflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT_OUT" => [  53,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo underflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT_OUT" => [  54,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo underflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT_OUT" => [  55,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo underflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT_OUT" => [  56,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo underflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT_OUT" => [  57,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo underflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT_OUT" => [  58,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo underflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT_OUT" => [  59,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo underflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT_OUT" => [  60,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo underflow" ],
);

%orbit_01_00997_def =
( NAME    => "OC_XNIILB_ERRORS_ALIAS_1",
  ADDRESS => 0x00000000d0040218,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00997_flds
);


##########################################################################
#                                                                        #
#   OC_XNIILB_ERROR_OVERFLOW_1                                           #
#                                                                        #
##########################################################################

%orbit_01_00998_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_READ_ERROR"               => [   1,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [   2,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "ERROR_MD_TAIL_CNT"            => [   3,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "MD tail count error" ],
   "ERROR_PI_TAIL_CNT"            => [   4,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "PI tail count error" ],
   "ERROR_LB_FAST_TAIL"           => [   5,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail error" ],
   "ERROR_II_FAST_TAIL"           => [   6,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "II fast tail error" ],
   "ERROR_MD_FAST_TAIL"           => [   7,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD fast tail error" ],
   "ERROR_PI_FAST_TAIL"           => [   8,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "PI fast tail error" ],
   "ERROR_NI1_FAST_TAIL"          => [   9,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail error" ],
   "ERROR_NI0_FAST_TAIL"          => [  10,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail error" ],
   "ERROR_IILB_FAST_TAIL"         => [  11,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "UNDERFLOW_LB_FAST_TAIL"       => [  12,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail underflow" ],
   "UNDERFLOW_II_FAST_TAIL"       => [  13,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "II fast tail underflow" ],
   "UNDERFLOW_MD_DATA_FAST_TAIL"  => [  14,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "MD data fast tail underflow" ],
   "UNDERFLOW_MD_HDR_FAST_TAIL"   => [  15,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail underflow" ],
   "UNDERFLOW_PI_DATA_FAST_TAIL"  => [  16,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail underflow" ],
   "UNDERFLOW_PI_HDR_FAST_TAIL"   => [  17,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail underflow" ],
   "UNDERFLOW_NI1_FAST_TAIL"      => [  18,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail underflow" ],
   "UNDERFLOW_NI0_FAST_TAIL"      => [  19,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail underflow" ],
   "UNDERFLOW_IILB_FAST_TAIL"     => [  20,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "UNDERFLOW_MD_DEBIT2"          => [  21,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "MD VC2 fifo debit underflow" ],
   "UNDERFLOW_MD_DEBIT0"          => [  22,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "MD VC0 fifo debit underflow" ],
   "UNDERFLOW_PI_DEBIT2"          => [  23,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "PI VC2 fifo debit underflow" ],
   "UNDERFLOW_PI_DEBIT0"          => [  24,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "PI VC0 fifo debit underflow" ],
   "UNDERFLOW_LB_VC2_CREDIT_OUT"  => [  25,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "LB VC2 credit underflow" ],
   "UNDERFLOW_LB_VC0_CREDIT_OUT"  => [  26,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "LB VC0 credit underflow" ],
   "UNDERFLOW_II_VC2_CREDIT_OUT"  => [  27,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "II VC2 credit underflow" ],
   "UNDERFLOW_II_VC0_CREDIT_OUT"  => [  28,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "II VC0 credit underflow" ],
   "UNDERFLOW_MD_VC2_CREDIT_IN"   => [  29,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "MD VC2 credit underflow" ],
   "UNDERFLOW_MD_VC0_CREDIT_IN"   => [  30,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "MD VC0 credit underflow" ],
   "UNDERFLOW_PI_VC2_CREDIT_IN"   => [  31,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI VC2 credit underflow" ],
   "UNDERFLOW_PI_VC0_CREDIT_IN"   => [  32,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "PI VC0 credit underflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT_IN"  => [  33,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit underflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT_IN"  => [  34,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit underflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT_IN"  => [  35,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit underflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT_IN"  => [  36,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit underflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT_IN" => [  37,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit underflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT_IN" => [  38,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit underflow" ],
   "UNDERFLOW_LB_VC2"             => [  39,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "LB VC2 fifo underflow" ],
   "UNDERFLOW_LB_VC0"             => [  40,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "LB VC0 fifo underflow" ],
   "UNDERFLOW_II_VC2"             => [  41,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "II VC2 fifo underflow" ],
   "UNDERFLOW_II_VC0"             => [  42,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "II VC0 fifo underflow" ],
   "UNDERFLOW_MD_DATA_VC2_CREDIT_OUT" => [  43,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD VC2 data fifo underflow" ],
   "UNDERFLOW_MD_DATA_VC0_CREDIT_OUT" => [  44,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD VC0 data fifo underflow" ],
   "UNDERFLOW_MD_HDR_VC2_CREDIT_OUT" => [  45,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD VC2 hdr fifo underflow" ],
   "UNDERFLOW_MD_HDR_VC0_CREDIT_OUT" => [  46,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD VC0 hdr fifo underflow" ],
   "UNDERFLOW_PI_DATA_VC2_CREDIT_OUT" => [  47,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI VC2 data fifo underflow" ],
   "UNDERFLOW_PI_DATA_VC0_CREDIT_OUT" => [  48,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI VC0 data fifo underflow" ],
   "UNDERFLOW_PI_HDR_VC2_CREDIT_OUT" => [  49,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI VC2 hdr fifo underflow" ],
   "UNDERFLOW_PI_HDR_VC0_CREDIT_OUT" => [  50,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI VC0 hdr fifo underflow" ],
   "UNDERFLOW_NI1_VC3_CREDIT_OUT" => [  51,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo underflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT_OUT" => [  52,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo underflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT_OUT" => [  53,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo underflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT_OUT" => [  54,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo underflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT_OUT" => [  55,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo underflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT_OUT" => [  56,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo underflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT_OUT" => [  57,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo underflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT_OUT" => [  58,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo underflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT_OUT" => [  59,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo underflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT_OUT" => [  60,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo underflow" ],
);

%orbit_01_00998_def =
( NAME    => "OC_XNIILB_ERROR_OVERFLOW_1",
  ADDRESS => 0x00000000d0040230,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00998_flds
);


##########################################################################
#                                                                        #
#   OC_XNIILB_ERROR_OVERFLOW_ALIAS_1                                     #
#                                                                        #
##########################################################################

%orbit_01_00999_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_READ_ERROR"               => [   1,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [   2,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "ERROR_MD_TAIL_CNT"            => [   3,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "MD tail count error" ],
   "ERROR_PI_TAIL_CNT"            => [   4,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "PI tail count error" ],
   "ERROR_LB_FAST_TAIL"           => [   5,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail error" ],
   "ERROR_II_FAST_TAIL"           => [   6,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "II fast tail error" ],
   "ERROR_MD_FAST_TAIL"           => [   7,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD fast tail error" ],
   "ERROR_PI_FAST_TAIL"           => [   8,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "PI fast tail error" ],
   "ERROR_NI1_FAST_TAIL"          => [   9,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail error" ],
   "ERROR_NI0_FAST_TAIL"          => [  10,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail error" ],
   "ERROR_IILB_FAST_TAIL"         => [  11,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "UNDERFLOW_LB_FAST_TAIL"       => [  12,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail underflow" ],
   "UNDERFLOW_II_FAST_TAIL"       => [  13,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "II fast tail underflow" ],
   "UNDERFLOW_MD_DATA_FAST_TAIL"  => [  14,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "MD data fast tail underflow" ],
   "UNDERFLOW_MD_HDR_FAST_TAIL"   => [  15,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail underflow" ],
   "UNDERFLOW_PI_DATA_FAST_TAIL"  => [  16,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail underflow" ],
   "UNDERFLOW_PI_HDR_FAST_TAIL"   => [  17,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail underflow" ],
   "UNDERFLOW_NI1_FAST_TAIL"      => [  18,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail underflow" ],
   "UNDERFLOW_NI0_FAST_TAIL"      => [  19,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail underflow" ],
   "UNDERFLOW_IILB_FAST_TAIL"     => [  20,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "UNDERFLOW_MD_DEBIT2"          => [  21,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "MD VC2 fifo debit underflow" ],
   "UNDERFLOW_MD_DEBIT0"          => [  22,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "MD VC0 fifo debit underflow" ],
   "UNDERFLOW_PI_DEBIT2"          => [  23,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "PI VC2 fifo debit underflow" ],
   "UNDERFLOW_PI_DEBIT0"          => [  24,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "PI VC0 fifo debit underflow" ],
   "UNDERFLOW_LB_VC2_CREDIT_OUT"  => [  25,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "LB VC2 credit underflow" ],
   "UNDERFLOW_LB_VC0_CREDIT_OUT"  => [  26,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "LB VC0 credit underflow" ],
   "UNDERFLOW_II_VC2_CREDIT_OUT"  => [  27,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "II VC2 credit underflow" ],
   "UNDERFLOW_II_VC0_CREDIT_OUT"  => [  28,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "II VC0 credit underflow" ],
   "UNDERFLOW_MD_VC2_CREDIT_IN"   => [  29,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "MD VC2 credit underflow" ],
   "UNDERFLOW_MD_VC0_CREDIT_IN"   => [  30,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "MD VC0 credit underflow" ],
   "UNDERFLOW_PI_VC2_CREDIT_IN"   => [  31,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI VC2 credit underflow" ],
   "UNDERFLOW_PI_VC0_CREDIT_IN"   => [  32,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "PI VC0 credit underflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT_IN"  => [  33,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit underflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT_IN"  => [  34,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit underflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT_IN"  => [  35,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit underflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT_IN"  => [  36,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit underflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT_IN" => [  37,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit underflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT_IN" => [  38,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit underflow" ],
   "UNDERFLOW_LB_VC2"             => [  39,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "LB VC2 fifo underflow" ],
   "UNDERFLOW_LB_VC0"             => [  40,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "LB VC0 fifo underflow" ],
   "UNDERFLOW_II_VC2"             => [  41,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "II VC2 fifo underflow" ],
   "UNDERFLOW_II_VC0"             => [  42,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "II VC0 fifo underflow" ],
   "UNDERFLOW_MD_DATA_VC2_CREDIT_OUT" => [  43,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD VC2 data fifo underflow" ],
   "UNDERFLOW_MD_DATA_VC0_CREDIT_OUT" => [  44,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD VC0 data fifo underflow" ],
   "UNDERFLOW_MD_HDR_VC2_CREDIT_OUT" => [  45,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD VC2 hdr fifo underflow" ],
   "UNDERFLOW_MD_HDR_VC0_CREDIT_OUT" => [  46,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD VC0 hdr fifo underflow" ],
   "UNDERFLOW_PI_DATA_VC2_CREDIT_OUT" => [  47,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI VC2 data fifo underflow" ],
   "UNDERFLOW_PI_DATA_VC0_CREDIT_OUT" => [  48,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI VC0 data fifo underflow" ],
   "UNDERFLOW_PI_HDR_VC2_CREDIT_OUT" => [  49,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI VC2 hdr fifo underflow" ],
   "UNDERFLOW_PI_HDR_VC0_CREDIT_OUT" => [  50,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI VC0 hdr fifo underflow" ],
   "UNDERFLOW_NI1_VC3_CREDIT_OUT" => [  51,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo underflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT_OUT" => [  52,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo underflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT_OUT" => [  53,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo underflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT_OUT" => [  54,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo underflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT_OUT" => [  55,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo underflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT_OUT" => [  56,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo underflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT_OUT" => [  57,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo underflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT_OUT" => [  58,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo underflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT_OUT" => [  59,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo underflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT_OUT" => [  60,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo underflow" ],
);

%orbit_01_00999_def =
( NAME    => "OC_XNIILB_ERROR_OVERFLOW_ALIAS_1",
  ADDRESS => 0x00000000d0040238,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_00999_flds
);


##########################################################################
#                                                                        #
#   OC_XNIILB_ERROR_MASK_1                                               #
#                                                                        #
##########################################################################

%orbit_01_01000_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_READ_ERROR"               => [   1,  59,   1, 0x0800000000000000, 0x00, 1, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [   2,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "chiplet nomatch" ],
   "ERROR_MD_TAIL_CNT"            => [   3,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "MD tail count error" ],
   "ERROR_PI_TAIL_CNT"            => [   4,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "PI tail count error" ],
   "ERROR_LB_FAST_TAIL"           => [   5,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "LB fast tail error" ],
   "ERROR_II_FAST_TAIL"           => [   6,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "II fast tail error" ],
   "ERROR_MD_FAST_TAIL"           => [   7,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "MD fast tail error" ],
   "ERROR_PI_FAST_TAIL"           => [   8,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "PI fast tail error" ],
   "ERROR_NI1_FAST_TAIL"          => [   9,  51,   1, 0x0008000000000000, 0x00, 1, 0x0000000000000000, "NI1 fast tail error" ],
   "ERROR_NI0_FAST_TAIL"          => [  10,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "NI0 fast tail error" ],
   "ERROR_IILB_FAST_TAIL"         => [  11,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "IILB fast tail error" ],
   "UNDERFLOW_LB_FAST_TAIL"       => [  12,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "LB fast tail underflow" ],
   "UNDERFLOW_II_FAST_TAIL"       => [  13,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "II fast tail underflow" ],
   "UNDERFLOW_MD_DATA_FAST_TAIL"  => [  14,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "MD data fast tail underflow" ],
   "UNDERFLOW_MD_HDR_FAST_TAIL"   => [  15,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "MD hdr fast tail underflow" ],
   "UNDERFLOW_PI_DATA_FAST_TAIL"  => [  16,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "PI data fast tail underflow" ],
   "UNDERFLOW_PI_HDR_FAST_TAIL"   => [  17,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "PI hdr fast tail underflow" ],
   "UNDERFLOW_NI1_FAST_TAIL"      => [  18,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "NI1 fast tail underflow" ],
   "UNDERFLOW_NI0_FAST_TAIL"      => [  19,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "NI0 fast tail underflow" ],
   "UNDERFLOW_IILB_FAST_TAIL"     => [  20,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "IILB fast tail underflow" ],
   "UNDERFLOW_MD_DEBIT2"          => [  21,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "MD VC2 fifo debit underflow" ],
   "UNDERFLOW_MD_DEBIT0"          => [  22,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "MD VC0 fifo debit underflow" ],
   "UNDERFLOW_PI_DEBIT2"          => [  23,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "PI VC2 fifo debit underflow" ],
   "UNDERFLOW_PI_DEBIT0"          => [  24,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "PI VC0 fifo debit underflow" ],
   "UNDERFLOW_LB_VC2_CREDIT_OUT"  => [  25,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "LB VC2 credit underflow" ],
   "UNDERFLOW_LB_VC0_CREDIT_OUT"  => [  26,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "LB VC0 credit underflow" ],
   "UNDERFLOW_II_VC2_CREDIT_OUT"  => [  27,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "II VC2 credit underflow" ],
   "UNDERFLOW_II_VC0_CREDIT_OUT"  => [  28,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "II VC0 credit underflow" ],
   "UNDERFLOW_MD_VC2_CREDIT_IN"   => [  29,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "MD VC2 credit underflow" ],
   "UNDERFLOW_MD_VC0_CREDIT_IN"   => [  30,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "MD VC0 credit underflow" ],
   "UNDERFLOW_PI_VC2_CREDIT_IN"   => [  31,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "PI VC2 credit underflow" ],
   "UNDERFLOW_PI_VC0_CREDIT_IN"   => [  32,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "PI VC0 credit underflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT_IN"  => [  33,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "NI1 VC2 credit underflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT_IN"  => [  34,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "NI1 VC0 credit underflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT_IN"  => [  35,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "NI0 VC2 credit underflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT_IN"  => [  36,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "NI0 VC0 credit underflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT_IN" => [  37,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "IILB VC2 credit underflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT_IN" => [  38,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "IILB VC0 credit underflow" ],
   "UNDERFLOW_LB_VC2"             => [  39,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "LB VC2 fifo underflow" ],
   "UNDERFLOW_LB_VC0"             => [  40,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "LB VC0 fifo underflow" ],
   "UNDERFLOW_II_VC2"             => [  41,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "II VC2 fifo underflow" ],
   "UNDERFLOW_II_VC0"             => [  42,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "II VC0 fifo underflow" ],
   "UNDERFLOW_MD_DATA_VC2_CREDIT_OUT" => [  43,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "MD VC2 data fifo underflow" ],
   "UNDERFLOW_MD_DATA_VC0_CREDIT_OUT" => [  44,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "MD VC0 data fifo underflow" ],
   "UNDERFLOW_MD_HDR_VC2_CREDIT_OUT" => [  45,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "MD VC2 hdr fifo underflow" ],
   "UNDERFLOW_MD_HDR_VC0_CREDIT_OUT" => [  46,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "MD VC0 hdr fifo underflow" ],
   "UNDERFLOW_PI_DATA_VC2_CREDIT_OUT" => [  47,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "PI VC2 data fifo underflow" ],
   "UNDERFLOW_PI_DATA_VC0_CREDIT_OUT" => [  48,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "PI VC0 data fifo underflow" ],
   "UNDERFLOW_PI_HDR_VC2_CREDIT_OUT" => [  49,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "PI VC2 hdr fifo underflow" ],
   "UNDERFLOW_PI_HDR_VC0_CREDIT_OUT" => [  50,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "PI VC0 hdr fifo underflow" ],
   "UNDERFLOW_NI1_VC3_CREDIT_OUT" => [  51,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "NI1 VC3 fifo underflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT_OUT" => [  52,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "NI1 VC2 fifo underflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT_OUT" => [  53,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "NI1 VC1 fifo underflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT_OUT" => [  54,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "NI1 VC0 fifo underflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT_OUT" => [  55,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "NI0 VC3 fifo underflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT_OUT" => [  56,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "NI0 VC2 fifo underflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT_OUT" => [  57,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "NI0 VC1 fifo underflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT_OUT" => [  58,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "NI0 VC0 fifo underflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT_OUT" => [  59,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "IILB VC2 fifo underflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT_OUT" => [  60,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "IILB VC0 fifo underflow" ],
);

%orbit_01_01000_def =
( NAME    => "OC_XNIILB_ERROR_MASK_1",
  ADDRESS => 0x00000000d0040250,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_01000_flds
);


##########################################################################
#                                                                        #
#   OC_XNIILB_FIRST_ERROR_1                                              #
#                                                                        #
##########################################################################

%orbit_01_01001_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_READ_ERROR"               => [   1,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [   2,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "ERROR_MD_TAIL_CNT"            => [   3,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "MD tail count error" ],
   "ERROR_PI_TAIL_CNT"            => [   4,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "PI tail count error" ],
   "ERROR_LB_FAST_TAIL"           => [   5,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail error" ],
   "ERROR_II_FAST_TAIL"           => [   6,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "II fast tail error" ],
   "ERROR_MD_FAST_TAIL"           => [   7,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD fast tail error" ],
   "ERROR_PI_FAST_TAIL"           => [   8,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "PI fast tail error" ],
   "ERROR_NI1_FAST_TAIL"          => [   9,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail error" ],
   "ERROR_NI0_FAST_TAIL"          => [  10,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail error" ],
   "ERROR_IILB_FAST_TAIL"         => [  11,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "UNDERFLOW_LB_FAST_TAIL"       => [  12,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail underflow" ],
   "UNDERFLOW_II_FAST_TAIL"       => [  13,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "II fast tail underflow" ],
   "UNDERFLOW_MD_DATA_FAST_TAIL"  => [  14,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "MD data fast tail underflow" ],
   "UNDERFLOW_MD_HDR_FAST_TAIL"   => [  15,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail underflow" ],
   "UNDERFLOW_PI_DATA_FAST_TAIL"  => [  16,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail underflow" ],
   "UNDERFLOW_PI_HDR_FAST_TAIL"   => [  17,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail underflow" ],
   "UNDERFLOW_NI1_FAST_TAIL"      => [  18,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail underflow" ],
   "UNDERFLOW_NI0_FAST_TAIL"      => [  19,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail underflow" ],
   "UNDERFLOW_IILB_FAST_TAIL"     => [  20,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "UNDERFLOW_MD_DEBIT2"          => [  21,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "MD VC2 fifo debit underflow" ],
   "UNDERFLOW_MD_DEBIT0"          => [  22,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "MD VC0 fifo debit underflow" ],
   "UNDERFLOW_PI_DEBIT2"          => [  23,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "PI VC2 fifo debit underflow" ],
   "UNDERFLOW_PI_DEBIT0"          => [  24,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "PI VC0 fifo debit underflow" ],
   "UNDERFLOW_LB_VC2_CREDIT_OUT"  => [  25,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "LB VC2 credit underflow" ],
   "UNDERFLOW_LB_VC0_CREDIT_OUT"  => [  26,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "LB VC0 credit underflow" ],
   "UNDERFLOW_II_VC2_CREDIT_OUT"  => [  27,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "II VC2 credit underflow" ],
   "UNDERFLOW_II_VC0_CREDIT_OUT"  => [  28,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "II VC0 credit underflow" ],
   "UNDERFLOW_MD_VC2_CREDIT_IN"   => [  29,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "MD VC2 credit underflow" ],
   "UNDERFLOW_MD_VC0_CREDIT_IN"   => [  30,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "MD VC0 credit underflow" ],
   "UNDERFLOW_PI_VC2_CREDIT_IN"   => [  31,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI VC2 credit underflow" ],
   "UNDERFLOW_PI_VC0_CREDIT_IN"   => [  32,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "PI VC0 credit underflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT_IN"  => [  33,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit underflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT_IN"  => [  34,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit underflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT_IN"  => [  35,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit underflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT_IN"  => [  36,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit underflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT_IN" => [  37,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit underflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT_IN" => [  38,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit underflow" ],
   "UNDERFLOW_LB_VC2"             => [  39,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "LB VC2 fifo underflow" ],
   "UNDERFLOW_LB_VC0"             => [  40,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "LB VC0 fifo underflow" ],
   "UNDERFLOW_II_VC2"             => [  41,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "II VC2 fifo underflow" ],
   "UNDERFLOW_II_VC0"             => [  42,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "II VC0 fifo underflow" ],
   "UNDERFLOW_MD_DATA_VC2_CREDIT_OUT" => [  43,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD VC2 data fifo underflow" ],
   "UNDERFLOW_MD_DATA_VC0_CREDIT_OUT" => [  44,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD VC0 data fifo underflow" ],
   "UNDERFLOW_MD_HDR_VC2_CREDIT_OUT" => [  45,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD VC2 hdr fifo underflow" ],
   "UNDERFLOW_MD_HDR_VC0_CREDIT_OUT" => [  46,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD VC0 hdr fifo underflow" ],
   "UNDERFLOW_PI_DATA_VC2_CREDIT_OUT" => [  47,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI VC2 data fifo underflow" ],
   "UNDERFLOW_PI_DATA_VC0_CREDIT_OUT" => [  48,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI VC0 data fifo underflow" ],
   "UNDERFLOW_PI_HDR_VC2_CREDIT_OUT" => [  49,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI VC2 hdr fifo underflow" ],
   "UNDERFLOW_PI_HDR_VC0_CREDIT_OUT" => [  50,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI VC0 hdr fifo underflow" ],
   "UNDERFLOW_NI1_VC3_CREDIT_OUT" => [  51,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo underflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT_OUT" => [  52,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo underflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT_OUT" => [  53,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo underflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT_OUT" => [  54,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo underflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT_OUT" => [  55,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo underflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT_OUT" => [  56,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo underflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT_OUT" => [  57,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo underflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT_OUT" => [  58,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo underflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT_OUT" => [  59,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo underflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT_OUT" => [  60,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo underflow" ],
);

%orbit_01_01001_def =
( NAME    => "OC_XNIILB_FIRST_ERROR_1",
  ADDRESS => 0x00000000d0040270,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_01001_flds
);


##########################################################################
#                                                                        #
#   OC_XNPI_ERROR_SUMMARY                                                #
#                                                                        #
##########################################################################

%orbit_01_01002_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NI1_HEAD_OR_TAIL_CNT_ERROR"   => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "NI1 Head or Tail Count Error" ],
   "NI0_HEAD_OR_TAIL_CNT_ERROR"   => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "NI0 Head or Tail Count Error" ],
   "IILB_HEAD_OR_TAIL_CNT_ERROR"  => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "IILB Head or Tail Count Error" ],
   "IILB_FAST_TAIL_UPR_ERROR"     => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Upper Error" ],
   "NI1_FAST_TAIL_UPR_ERROR"      => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Upper Error" ],
   "NI0_FAST_TAIL_UPR_ERROR"      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Upper Error" ],
   "IILB_FAST_TAIL_LWR_ERROR"     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Lower Error" ],
   "NI1_FAST_TAIL_LWR_ERROR"      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Lower Error" ],
   "NI0_FAST_TAIL_LWR_ERROR"      => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Lower Error" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Underflow" ],
   "NI1_FAST_TAIL_UNDERFLOW"      => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Underflow" ],
   "NI0_FAST_TAIL_UNDERFLOW"      => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Underflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Overflow" ],
   "NI1_FAST_TAIL_OVERFLOW"       => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Overflow" ],
   "NI0_FAST_TAIL_OVERFLOW"       => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Overflow" ],
   "OVERFLOW_CREDIT_MGR_VC2"      => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC2"     => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Underflow" ],
   "OVERFLOW_CREDIT_MGR_VC0"      => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC0"     => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC2"   => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC2"  => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC0"   => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC0"  => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Underflow" ],
   "OVERFLOW_NI1_VC3_CREDIT"      => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Overflow" ],
   "UNDERFLOW_NI1_VC3_CREDIT"     => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Underflow" ],
   "OVERFLOW_NI1_VC1_CREDIT"      => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Overflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT"     => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Underflow" ],
   "OVERFLOW_NI0_VC3_CREDIT"      => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Overflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT"     => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Underflow" ],
   "OVERFLOW_NI0_VC1_CREDIT"      => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Overflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT"     => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Underflow" ],
   "OVERFLOW_NI1_DEBIT3"          => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 3 Overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 1 Overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 3 Overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 1 Overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT"     => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Overflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT"    => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Underflow" ],
   "OVERFLOW_IILB_VC0_CREDIT"     => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Overflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT"    => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Underflow" ],
   "OVERFLOW_NI1_VC2_CREDIT"      => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT"     => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Underflow" ],
   "OVERFLOW_NI1_VC0_CREDIT"      => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Overflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT"     => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Underflow" ],
   "OVERFLOW_NI0_VC2_CREDIT"      => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Overflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT"     => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Underflow" ],
   "OVERFLOW_NI0_VC0_CREDIT"      => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Overflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT"     => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Underflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "IILB Debit 2 Overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "IILB Debit 0 Overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 Debit 2 Overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 Debit 0 Overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI0 Debit 2 Overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI0 Debit 0 Overflow" ],
   "OVERFLOW_SIC_CNTR2"           => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Overflow" ],
   "UNDERFLOW_SIC_CNTR2"          => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Underflow" ],
   "OVERFLOW_SIC_CNTR0"           => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Overflow" ],
   "UNDERFLOW_SIC_CNTR0"          => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Underflow" ],
   "RSVD0"                        => [  57,   3,   4, 0x0000000000000078, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_READ_ERROR"               => [  58,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "OVERFLOW_VC2_CREDIT"          => [  59,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "VC2 Credit overflow" ],
   "OVERFLOW_VC0_CREDIT"          => [  60,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "VC0 Credit overflow" ],
);

%orbit_01_01002_def =
( NAME    => "OC_XNPI_ERROR_SUMMARY",
  ADDRESS => 0x00000000d0040300,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_01002_flds
);


##########################################################################
#                                                                        #
#   OC_XNPI_ERRORS_ALIAS                                                 #
#                                                                        #
##########################################################################

%orbit_01_01003_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NI1_HEAD_OR_TAIL_CNT_ERROR"   => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "NI1 Head or Tail Count Error" ],
   "NI0_HEAD_OR_TAIL_CNT_ERROR"   => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "NI0 Head or Tail Count Error" ],
   "IILB_HEAD_OR_TAIL_CNT_ERROR"  => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "IILB Head or Tail Count Error" ],
   "IILB_FAST_TAIL_UPR_ERROR"     => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Upper Error" ],
   "NI1_FAST_TAIL_UPR_ERROR"      => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Upper Error" ],
   "NI0_FAST_TAIL_UPR_ERROR"      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Upper Error" ],
   "IILB_FAST_TAIL_LWR_ERROR"     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Lower Error" ],
   "NI1_FAST_TAIL_LWR_ERROR"      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Lower Error" ],
   "NI0_FAST_TAIL_LWR_ERROR"      => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Lower Error" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Underflow" ],
   "NI1_FAST_TAIL_UNDERFLOW"      => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Underflow" ],
   "NI0_FAST_TAIL_UNDERFLOW"      => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Underflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Overflow" ],
   "NI1_FAST_TAIL_OVERFLOW"       => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Overflow" ],
   "NI0_FAST_TAIL_OVERFLOW"       => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Overflow" ],
   "OVERFLOW_CREDIT_MGR_VC2"      => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC2"     => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Underflow" ],
   "OVERFLOW_CREDIT_MGR_VC0"      => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC0"     => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC2"   => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC2"  => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC0"   => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC0"  => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Underflow" ],
   "OVERFLOW_NI1_VC3_CREDIT"      => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Overflow" ],
   "UNDERFLOW_NI1_VC3_CREDIT"     => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Underflow" ],
   "OVERFLOW_NI1_VC1_CREDIT"      => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Overflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT"     => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Underflow" ],
   "OVERFLOW_NI0_VC3_CREDIT"      => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Overflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT"     => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Underflow" ],
   "OVERFLOW_NI0_VC1_CREDIT"      => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Overflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT"     => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Underflow" ],
   "OVERFLOW_NI1_DEBIT3"          => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 3 Overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 1 Overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 3 Overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 1 Overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT"     => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Overflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT"    => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Underflow" ],
   "OVERFLOW_IILB_VC0_CREDIT"     => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Overflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT"    => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Underflow" ],
   "OVERFLOW_NI1_VC2_CREDIT"      => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT"     => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Underflow" ],
   "OVERFLOW_NI1_VC0_CREDIT"      => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Overflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT"     => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Underflow" ],
   "OVERFLOW_NI0_VC2_CREDIT"      => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Overflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT"     => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Underflow" ],
   "OVERFLOW_NI0_VC0_CREDIT"      => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Overflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT"     => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Underflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "IILB Debit 2 Overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "IILB Debit 0 Overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 Debit 2 Overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 Debit 0 Overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI0 Debit 2 Overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI0 Debit 0 Overflow" ],
   "OVERFLOW_SIC_CNTR2"           => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Overflow" ],
   "UNDERFLOW_SIC_CNTR2"          => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Underflow" ],
   "OVERFLOW_SIC_CNTR0"           => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Overflow" ],
   "UNDERFLOW_SIC_CNTR0"          => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Underflow" ],
   "RSVD0"                        => [  57,   3,   4, 0x0000000000000078, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_READ_ERROR"               => [  58,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "OVERFLOW_VC2_CREDIT"          => [  59,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "VC2 Credit overflow" ],
   "OVERFLOW_VC0_CREDIT"          => [  60,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "VC0 Credit overflow" ],
);

%orbit_01_01003_def =
( NAME    => "OC_XNPI_ERRORS_ALIAS",
  ADDRESS => 0x00000000d0040308,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_01003_flds
);


##########################################################################
#                                                                        #
#   OC_XNPI_ERROR_OVERFLOW                                               #
#                                                                        #
##########################################################################

%orbit_01_01004_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NI1_HEAD_OR_TAIL_CNT_ERROR"   => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "NI1 Head or Tail Count Error" ],
   "NI0_HEAD_OR_TAIL_CNT_ERROR"   => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "NI0 Head or Tail Count Error" ],
   "IILB_HEAD_OR_TAIL_CNT_ERROR"  => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "IILB Head or Tail Count Error" ],
   "IILB_FAST_TAIL_UPR_ERROR"     => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Upper Error" ],
   "NI1_FAST_TAIL_UPR_ERROR"      => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Upper Error" ],
   "NI0_FAST_TAIL_UPR_ERROR"      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Upper Error" ],
   "IILB_FAST_TAIL_LWR_ERROR"     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Lower Error" ],
   "NI1_FAST_TAIL_LWR_ERROR"      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Lower Error" ],
   "NI0_FAST_TAIL_LWR_ERROR"      => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Lower Error" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Underflow" ],
   "NI1_FAST_TAIL_UNDERFLOW"      => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Underflow" ],
   "NI0_FAST_TAIL_UNDERFLOW"      => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Underflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Overflow" ],
   "NI1_FAST_TAIL_OVERFLOW"       => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Overflow" ],
   "NI0_FAST_TAIL_OVERFLOW"       => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Overflow" ],
   "OVERFLOW_CREDIT_MGR_VC2"      => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC2"     => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Underflow" ],
   "OVERFLOW_CREDIT_MGR_VC0"      => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC0"     => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC2"   => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC2"  => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC0"   => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC0"  => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Underflow" ],
   "OVERFLOW_NI1_VC3_CREDIT"      => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Overflow" ],
   "UNDERFLOW_NI1_VC3_CREDIT"     => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Underflow" ],
   "OVERFLOW_NI1_VC1_CREDIT"      => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Overflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT"     => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Underflow" ],
   "OVERFLOW_NI0_VC3_CREDIT"      => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Overflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT"     => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Underflow" ],
   "OVERFLOW_NI0_VC1_CREDIT"      => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Overflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT"     => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Underflow" ],
   "OVERFLOW_NI1_DEBIT3"          => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 3 Overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 1 Overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 3 Overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 1 Overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT"     => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Overflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT"    => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Underflow" ],
   "OVERFLOW_IILB_VC0_CREDIT"     => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Overflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT"    => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Underflow" ],
   "OVERFLOW_NI1_VC2_CREDIT"      => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT"     => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Underflow" ],
   "OVERFLOW_NI1_VC0_CREDIT"      => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Overflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT"     => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Underflow" ],
   "OVERFLOW_NI0_VC2_CREDIT"      => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Overflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT"     => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Underflow" ],
   "OVERFLOW_NI0_VC0_CREDIT"      => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Overflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT"     => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Underflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "IILB Debit 2 Overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "IILB Debit 0 Overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 Debit 2 Overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 Debit 0 Overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI0 Debit 2 Overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI0 Debit 0 Overflow" ],
   "OVERFLOW_SIC_CNTR2"           => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Overflow" ],
   "UNDERFLOW_SIC_CNTR2"          => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Underflow" ],
   "OVERFLOW_SIC_CNTR0"           => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Overflow" ],
   "UNDERFLOW_SIC_CNTR0"          => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Underflow" ],
   "RSVD0"                        => [  57,   3,   4, 0x0000000000000078, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_READ_ERROR"               => [  58,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "OVERFLOW_VC2_CREDIT"          => [  59,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "VC2 Credit overflow" ],
   "OVERFLOW_VC0_CREDIT"          => [  60,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "VC0 Credit overflow" ],
);

%orbit_01_01004_def =
( NAME    => "OC_XNPI_ERROR_OVERFLOW",
  ADDRESS => 0x00000000d0040320,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_01004_flds
);


##########################################################################
#                                                                        #
#   OC_XNPI_ERROR_OVERFLOW_ALIAS                                         #
#                                                                        #
##########################################################################

%orbit_01_01005_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NI1_HEAD_OR_TAIL_CNT_ERROR"   => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "NI1 Head or Tail Count Error" ],
   "NI0_HEAD_OR_TAIL_CNT_ERROR"   => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "NI0 Head or Tail Count Error" ],
   "IILB_HEAD_OR_TAIL_CNT_ERROR"  => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "IILB Head or Tail Count Error" ],
   "IILB_FAST_TAIL_UPR_ERROR"     => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Upper Error" ],
   "NI1_FAST_TAIL_UPR_ERROR"      => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Upper Error" ],
   "NI0_FAST_TAIL_UPR_ERROR"      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Upper Error" ],
   "IILB_FAST_TAIL_LWR_ERROR"     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Lower Error" ],
   "NI1_FAST_TAIL_LWR_ERROR"      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Lower Error" ],
   "NI0_FAST_TAIL_LWR_ERROR"      => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Lower Error" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Underflow" ],
   "NI1_FAST_TAIL_UNDERFLOW"      => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Underflow" ],
   "NI0_FAST_TAIL_UNDERFLOW"      => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Underflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Overflow" ],
   "NI1_FAST_TAIL_OVERFLOW"       => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Overflow" ],
   "NI0_FAST_TAIL_OVERFLOW"       => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Overflow" ],
   "OVERFLOW_CREDIT_MGR_VC2"      => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC2"     => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Underflow" ],
   "OVERFLOW_CREDIT_MGR_VC0"      => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC0"     => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC2"   => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC2"  => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC0"   => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC0"  => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Underflow" ],
   "OVERFLOW_NI1_VC3_CREDIT"      => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Overflow" ],
   "UNDERFLOW_NI1_VC3_CREDIT"     => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Underflow" ],
   "OVERFLOW_NI1_VC1_CREDIT"      => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Overflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT"     => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Underflow" ],
   "OVERFLOW_NI0_VC3_CREDIT"      => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Overflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT"     => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Underflow" ],
   "OVERFLOW_NI0_VC1_CREDIT"      => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Overflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT"     => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Underflow" ],
   "OVERFLOW_NI1_DEBIT3"          => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 3 Overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 1 Overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 3 Overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 1 Overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT"     => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Overflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT"    => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Underflow" ],
   "OVERFLOW_IILB_VC0_CREDIT"     => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Overflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT"    => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Underflow" ],
   "OVERFLOW_NI1_VC2_CREDIT"      => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT"     => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Underflow" ],
   "OVERFLOW_NI1_VC0_CREDIT"      => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Overflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT"     => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Underflow" ],
   "OVERFLOW_NI0_VC2_CREDIT"      => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Overflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT"     => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Underflow" ],
   "OVERFLOW_NI0_VC0_CREDIT"      => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Overflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT"     => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Underflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "IILB Debit 2 Overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "IILB Debit 0 Overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 Debit 2 Overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 Debit 0 Overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI0 Debit 2 Overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI0 Debit 0 Overflow" ],
   "OVERFLOW_SIC_CNTR2"           => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Overflow" ],
   "UNDERFLOW_SIC_CNTR2"          => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Underflow" ],
   "OVERFLOW_SIC_CNTR0"           => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Overflow" ],
   "UNDERFLOW_SIC_CNTR0"          => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Underflow" ],
   "RSVD0"                        => [  57,   3,   4, 0x0000000000000078, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_READ_ERROR"               => [  58,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "OVERFLOW_VC2_CREDIT"          => [  59,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "VC2 Credit overflow" ],
   "OVERFLOW_VC0_CREDIT"          => [  60,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "VC0 Credit overflow" ],
);

%orbit_01_01005_def =
( NAME    => "OC_XNPI_ERROR_OVERFLOW_ALIAS",
  ADDRESS => 0x00000000d0040328,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_01005_flds
);


##########################################################################
#                                                                        #
#   OC_XNPI_ERROR_MASK                                                   #
#                                                                        #
##########################################################################

%orbit_01_01006_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NI1_HEAD_OR_TAIL_CNT_ERROR"   => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "NI1 Head or Tail Count Error" ],
   "NI0_HEAD_OR_TAIL_CNT_ERROR"   => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "NI0 Head or Tail Count Error" ],
   "IILB_HEAD_OR_TAIL_CNT_ERROR"  => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "IILB Head or Tail Count Error" ],
   "IILB_FAST_TAIL_UPR_ERROR"     => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "IILB Fast Tail Upper Error" ],
   "NI1_FAST_TAIL_UPR_ERROR"      => [   4,  59,   1, 0x0800000000000000, 0x00, 1, 0x0000000000000000, "NI1 Fast Tail Upper Error" ],
   "NI0_FAST_TAIL_UPR_ERROR"      => [   5,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "NI0 Fast Tail Upper Error" ],
   "IILB_FAST_TAIL_LWR_ERROR"     => [   6,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "IILB Fast Tail Lower Error" ],
   "NI1_FAST_TAIL_LWR_ERROR"      => [   7,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "NI1 Fast Tail Lower Error" ],
   "NI0_FAST_TAIL_LWR_ERROR"      => [   8,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "NI0 Fast Tail Lower Error" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [   9,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "IILB Fast Tail Underflow" ],
   "NI1_FAST_TAIL_UNDERFLOW"      => [  10,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "NI1 Fast Tail Underflow" ],
   "NI0_FAST_TAIL_UNDERFLOW"      => [  11,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "NI0 Fast Tail Underflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  12,  51,   1, 0x0008000000000000, 0x00, 1, 0x0000000000000000, "IILB Fast Tail Overflow" ],
   "NI1_FAST_TAIL_OVERFLOW"       => [  13,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "NI1 Fast Tail Overflow" ],
   "NI0_FAST_TAIL_OVERFLOW"       => [  14,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "NI0 Fast Tail Overflow" ],
   "OVERFLOW_CREDIT_MGR_VC2"      => [  15,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "VC2 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC2"     => [  16,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "VC2 Credit Manager Underflow" ],
   "OVERFLOW_CREDIT_MGR_VC0"      => [  17,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "VC0 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC0"     => [  18,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "VC0 Credit Manager Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC2"   => [  19,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "VC2 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC2"  => [  20,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "VC2 Steering FIFO Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC0"   => [  21,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "VC0 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC0"  => [  22,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "VC0 Steering FIFO Underflow" ],
   "OVERFLOW_NI1_VC3_CREDIT"      => [  23,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "NI1 VC3 Credit Overflow" ],
   "UNDERFLOW_NI1_VC3_CREDIT"     => [  24,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "NI1 VC3 Credit Underflow" ],
   "OVERFLOW_NI1_VC1_CREDIT"      => [  25,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "NI1 VC1 Credit Overflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT"     => [  26,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "NI1 VC1 Credit Underflow" ],
   "OVERFLOW_NI0_VC3_CREDIT"      => [  27,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "NI0 VC3 Credit Overflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT"     => [  28,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "NI0 VC3 Credit Underflow" ],
   "OVERFLOW_NI0_VC1_CREDIT"      => [  29,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "NI0 VC1 Credit Overflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT"     => [  30,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "NI0 VC1 Credit Underflow" ],
   "OVERFLOW_NI1_DEBIT3"          => [  31,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "NI1 Debit 3 Overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  32,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "NI1 Debit 1 Overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  33,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "NI0 Debit 3 Overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  34,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "NI0 Debit 1 Overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT"     => [  35,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "IILB VC2 Credit Overflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT"    => [  36,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "IILB VC2 Credit Underflow" ],
   "OVERFLOW_IILB_VC0_CREDIT"     => [  37,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "IILB VC0 Credit Overflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT"    => [  38,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "IILB VC0 Credit Underflow" ],
   "OVERFLOW_NI1_VC2_CREDIT"      => [  39,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "NI1 VC2 Credit Overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT"     => [  40,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "NI1 VC2 Credit Underflow" ],
   "OVERFLOW_NI1_VC0_CREDIT"      => [  41,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "NI1 VC0 Credit Overflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT"     => [  42,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "NI1 VC0 Credit Underflow" ],
   "OVERFLOW_NI0_VC2_CREDIT"      => [  43,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "NI0 VC2 Credit Overflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT"     => [  44,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "NI0 VC2 Credit Underflow" ],
   "OVERFLOW_NI0_VC0_CREDIT"      => [  45,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "NI0 VC0 Credit Overflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT"     => [  46,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "NI0 VC0 Credit Underflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  47,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "IILB Debit 2 Overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  48,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "IILB Debit 0 Overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  49,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "NI1 Debit 2 Overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  50,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "NI1 Debit 0 Overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  51,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "NI0 Debit 2 Overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  52,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "NI0 Debit 0 Overflow" ],
   "OVERFLOW_SIC_CNTR2"           => [  53,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "SIC Counter 2 Overflow" ],
   "UNDERFLOW_SIC_CNTR2"          => [  54,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "SIC Counter 2 Underflow" ],
   "OVERFLOW_SIC_CNTR0"           => [  55,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "SIC Counter 0 Overflow" ],
   "UNDERFLOW_SIC_CNTR0"          => [  56,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "SIC Counter 0 Underflow" ],
   "RSVD0"                        => [  57,   3,   4, 0x0000000000000078, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_READ_ERROR"               => [  58,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "LUT Read Error" ],
   "OVERFLOW_VC2_CREDIT"          => [  59,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "VC2 Credit overflow" ],
   "OVERFLOW_VC0_CREDIT"          => [  60,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "VC0 Credit overflow" ],
);

%orbit_01_01006_def =
( NAME    => "OC_XNPI_ERROR_MASK",
  ADDRESS => 0x00000000d0040340,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_01006_flds
);


##########################################################################
#                                                                        #
#   OC_XNPI_FIRST_ERROR                                                  #
#                                                                        #
##########################################################################

%orbit_01_01007_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NI1_HEAD_OR_TAIL_CNT_ERROR"   => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "NI1 Head or Tail Count Error" ],
   "NI0_HEAD_OR_TAIL_CNT_ERROR"   => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "NI0 Head or Tail Count Error" ],
   "IILB_HEAD_OR_TAIL_CNT_ERROR"  => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "IILB Head or Tail Count Error" ],
   "IILB_FAST_TAIL_UPR_ERROR"     => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Upper Error" ],
   "NI1_FAST_TAIL_UPR_ERROR"      => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Upper Error" ],
   "NI0_FAST_TAIL_UPR_ERROR"      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Upper Error" ],
   "IILB_FAST_TAIL_LWR_ERROR"     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Lower Error" ],
   "NI1_FAST_TAIL_LWR_ERROR"      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Lower Error" ],
   "NI0_FAST_TAIL_LWR_ERROR"      => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Lower Error" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Underflow" ],
   "NI1_FAST_TAIL_UNDERFLOW"      => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Underflow" ],
   "NI0_FAST_TAIL_UNDERFLOW"      => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Underflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Overflow" ],
   "NI1_FAST_TAIL_OVERFLOW"       => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Overflow" ],
   "NI0_FAST_TAIL_OVERFLOW"       => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Overflow" ],
   "OVERFLOW_CREDIT_MGR_VC2"      => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC2"     => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Underflow" ],
   "OVERFLOW_CREDIT_MGR_VC0"      => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC0"     => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC2"   => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC2"  => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC0"   => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC0"  => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Underflow" ],
   "OVERFLOW_NI1_VC3_CREDIT"      => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Overflow" ],
   "UNDERFLOW_NI1_VC3_CREDIT"     => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Underflow" ],
   "OVERFLOW_NI1_VC1_CREDIT"      => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Overflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT"     => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Underflow" ],
   "OVERFLOW_NI0_VC3_CREDIT"      => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Overflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT"     => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Underflow" ],
   "OVERFLOW_NI0_VC1_CREDIT"      => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Overflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT"     => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Underflow" ],
   "OVERFLOW_NI1_DEBIT3"          => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 3 Overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 1 Overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 3 Overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 1 Overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT"     => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Overflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT"    => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Underflow" ],
   "OVERFLOW_IILB_VC0_CREDIT"     => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Overflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT"    => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Underflow" ],
   "OVERFLOW_NI1_VC2_CREDIT"      => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT"     => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Underflow" ],
   "OVERFLOW_NI1_VC0_CREDIT"      => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Overflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT"     => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Underflow" ],
   "OVERFLOW_NI0_VC2_CREDIT"      => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Overflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT"     => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Underflow" ],
   "OVERFLOW_NI0_VC0_CREDIT"      => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Overflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT"     => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Underflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "IILB Debit 2 Overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "IILB Debit 0 Overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 Debit 2 Overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 Debit 0 Overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI0 Debit 2 Overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI0 Debit 0 Overflow" ],
   "OVERFLOW_SIC_CNTR2"           => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Overflow" ],
   "UNDERFLOW_SIC_CNTR2"          => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Underflow" ],
   "OVERFLOW_SIC_CNTR0"           => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Overflow" ],
   "UNDERFLOW_SIC_CNTR0"          => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Underflow" ],
   "RSVD0"                        => [  57,   3,   4, 0x0000000000000078, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_READ_ERROR"               => [  58,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "OVERFLOW_VC2_CREDIT"          => [  59,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "VC2 Credit overflow" ],
   "OVERFLOW_VC0_CREDIT"          => [  60,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "VC0 Credit overflow" ],
);

%orbit_01_01007_def =
( NAME    => "OC_XNPI_FIRST_ERROR",
  ADDRESS => 0x00000000d0040360,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_01007_flds
);


##########################################################################
#                                                                        #
#   OC_XNMD_ERROR_SUMMARY                                                #
#                                                                        #
##########################################################################

%orbit_01_01008_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NI1_HEAD_OR_TAIL_CNT_ERROR"   => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "NI1 Head or Tail Count Error" ],
   "NI0_HEAD_OR_TAIL_CNT_ERROR"   => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "NI0 Head or Tail Count Error" ],
   "IILB_HEAD_OR_TAIL_CNT_ERROR"  => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "IILB Head or Tail Count Error" ],
   "IILB_FAST_TAIL_UPR_ERROR"     => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Upper Error" ],
   "NI1_FAST_TAIL_UPR_ERROR"      => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Upper Error" ],
   "NI0_FAST_TAIL_UPR_ERROR"      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Upper Error" ],
   "IILB_FAST_TAIL_LWR_ERROR"     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Lower Error" ],
   "NI1_FAST_TAIL_LWR_ERROR"      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Lower Error" ],
   "NI0_FAST_TAIL_LWR_ERROR"      => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Lower Error" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Underflow" ],
   "NI1_FAST_TAIL_UNDERFLOW"      => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Underflow" ],
   "NI0_FAST_TAIL_UNDERFLOW"      => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Underflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Overflow" ],
   "NI1_FAST_TAIL_OVERFLOW"       => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Overflow" ],
   "NI0_FAST_TAIL_OVERFLOW"       => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Overflow" ],
   "OVERFLOW_CREDIT_MGR_VC2"      => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC2"     => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Underflow" ],
   "OVERFLOW_CREDIT_MGR_VC0"      => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC0"     => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC2"   => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC2"  => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC0"   => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC0"  => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Underflow" ],
   "OVERFLOW_NI1_VC3_CREDIT"      => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Overflow" ],
   "UNDERFLOW_NI1_VC3_CREDIT"     => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Underflow" ],
   "OVERFLOW_NI1_VC1_CREDIT"      => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Overflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT"     => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Underflow" ],
   "OVERFLOW_NI0_VC3_CREDIT"      => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Overflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT"     => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Underflow" ],
   "OVERFLOW_NI0_VC1_CREDIT"      => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Overflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT"     => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Underflow" ],
   "OVERFLOW_NI1_DEBIT3"          => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 3 Overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 1 Overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 3 Overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 1 Overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT"     => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Overflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT"    => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Underflow" ],
   "OVERFLOW_IILB_VC0_CREDIT"     => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Overflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT"    => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Underflow" ],
   "OVERFLOW_NI1_VC2_CREDIT"      => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT"     => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Underflow" ],
   "OVERFLOW_NI1_VC0_CREDIT"      => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Overflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT"     => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Underflow" ],
   "OVERFLOW_NI0_VC2_CREDIT"      => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Overflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT"     => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Underflow" ],
   "OVERFLOW_NI0_VC0_CREDIT"      => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Overflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT"     => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Underflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "IILB Debit 2 Overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "IILB Debit 0 Overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 Debit 2 Overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 Debit 0 Overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI0 Debit 2 Overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI0 Debit 0 Overflow" ],
   "OVERFLOW_SIC_CNTR2"           => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Overflow" ],
   "UNDERFLOW_SIC_CNTR2"          => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Underflow" ],
   "OVERFLOW_SIC_CNTR0"           => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Overflow" ],
   "UNDERFLOW_SIC_CNTR0"          => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Underflow" ],
   "UNCOR_ERROR1"                 => [  57,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 255:128" ],
   "UNCOR_ERROR0"                 => [  58,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 127:0" ],
   "SINGLE_BIT_ERROR1"            => [  59,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 255:128" ],
   "SINGLE_BIT_ERROR0"            => [  60,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 127:0" ],
   "LUT_READ_ERROR"               => [  61,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "OVERFLOW_VC2_CREDIT"          => [  62,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "VC2 Credit overflow" ],
   "OVERFLOW_VC0_CREDIT"          => [  63,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "VC0 Credit overflow" ],
);

%orbit_01_01008_def =
( NAME    => "OC_XNMD_ERROR_SUMMARY",
  ADDRESS => 0x00000000d0040400,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_01008_flds
);


##########################################################################
#                                                                        #
#   OC_XNMD_ERRORS_ALIAS                                                 #
#                                                                        #
##########################################################################

%orbit_01_01009_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NI1_HEAD_OR_TAIL_CNT_ERROR"   => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "NI1 Head or Tail Count Error" ],
   "NI0_HEAD_OR_TAIL_CNT_ERROR"   => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "NI0 Head or Tail Count Error" ],
   "IILB_HEAD_OR_TAIL_CNT_ERROR"  => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "IILB Head or Tail Count Error" ],
   "IILB_FAST_TAIL_UPR_ERROR"     => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Upper Error" ],
   "NI1_FAST_TAIL_UPR_ERROR"      => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Upper Error" ],
   "NI0_FAST_TAIL_UPR_ERROR"      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Upper Error" ],
   "IILB_FAST_TAIL_LWR_ERROR"     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Lower Error" ],
   "NI1_FAST_TAIL_LWR_ERROR"      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Lower Error" ],
   "NI0_FAST_TAIL_LWR_ERROR"      => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Lower Error" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Underflow" ],
   "NI1_FAST_TAIL_UNDERFLOW"      => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Underflow" ],
   "NI0_FAST_TAIL_UNDERFLOW"      => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Underflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Overflow" ],
   "NI1_FAST_TAIL_OVERFLOW"       => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Overflow" ],
   "NI0_FAST_TAIL_OVERFLOW"       => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Overflow" ],
   "OVERFLOW_CREDIT_MGR_VC2"      => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC2"     => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Underflow" ],
   "OVERFLOW_CREDIT_MGR_VC0"      => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC0"     => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC2"   => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC2"  => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC0"   => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC0"  => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Underflow" ],
   "OVERFLOW_NI1_VC3_CREDIT"      => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Overflow" ],
   "UNDERFLOW_NI1_VC3_CREDIT"     => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Underflow" ],
   "OVERFLOW_NI1_VC1_CREDIT"      => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Overflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT"     => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Underflow" ],
   "OVERFLOW_NI0_VC3_CREDIT"      => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Overflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT"     => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Underflow" ],
   "OVERFLOW_NI0_VC1_CREDIT"      => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Overflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT"     => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Underflow" ],
   "OVERFLOW_NI1_DEBIT3"          => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 3 Overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 1 Overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 3 Overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 1 Overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT"     => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Overflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT"    => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Underflow" ],
   "OVERFLOW_IILB_VC0_CREDIT"     => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Overflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT"    => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Underflow" ],
   "OVERFLOW_NI1_VC2_CREDIT"      => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT"     => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Underflow" ],
   "OVERFLOW_NI1_VC0_CREDIT"      => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Overflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT"     => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Underflow" ],
   "OVERFLOW_NI0_VC2_CREDIT"      => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Overflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT"     => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Underflow" ],
   "OVERFLOW_NI0_VC0_CREDIT"      => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Overflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT"     => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Underflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "IILB Debit 2 Overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "IILB Debit 0 Overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 Debit 2 Overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 Debit 0 Overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI0 Debit 2 Overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI0 Debit 0 Overflow" ],
   "OVERFLOW_SIC_CNTR2"           => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Overflow" ],
   "UNDERFLOW_SIC_CNTR2"          => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Underflow" ],
   "OVERFLOW_SIC_CNTR0"           => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Overflow" ],
   "UNDERFLOW_SIC_CNTR0"          => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Underflow" ],
   "UNCOR_ERROR1"                 => [  57,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 255:128" ],
   "UNCOR_ERROR0"                 => [  58,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 127:0" ],
   "SINGLE_BIT_ERROR1"            => [  59,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 255:128" ],
   "SINGLE_BIT_ERROR0"            => [  60,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 127:0" ],
   "LUT_READ_ERROR"               => [  61,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "OVERFLOW_VC2_CREDIT"          => [  62,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "VC2 Credit overflow" ],
   "OVERFLOW_VC0_CREDIT"          => [  63,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "VC0 Credit overflow" ],
);

%orbit_01_01009_def =
( NAME    => "OC_XNMD_ERRORS_ALIAS",
  ADDRESS => 0x00000000d0040408,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_01009_flds
);


##########################################################################
#                                                                        #
#   OC_XNMD_ERROR_OVERFLOW                                               #
#                                                                        #
##########################################################################

%orbit_01_01010_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NI1_HEAD_OR_TAIL_CNT_ERROR"   => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "NI1 Head or Tail Count Error" ],
   "NI0_HEAD_OR_TAIL_CNT_ERROR"   => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "NI0 Head or Tail Count Error" ],
   "IILB_HEAD_OR_TAIL_CNT_ERROR"  => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "IILB Head or Tail Count Error" ],
   "IILB_FAST_TAIL_UPR_ERROR"     => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Upper Error" ],
   "NI1_FAST_TAIL_UPR_ERROR"      => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Upper Error" ],
   "NI0_FAST_TAIL_UPR_ERROR"      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Upper Error" ],
   "IILB_FAST_TAIL_LWR_ERROR"     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Lower Error" ],
   "NI1_FAST_TAIL_LWR_ERROR"      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Lower Error" ],
   "NI0_FAST_TAIL_LWR_ERROR"      => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Lower Error" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Underflow" ],
   "NI1_FAST_TAIL_UNDERFLOW"      => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Underflow" ],
   "NI0_FAST_TAIL_UNDERFLOW"      => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Underflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Overflow" ],
   "NI1_FAST_TAIL_OVERFLOW"       => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Overflow" ],
   "NI0_FAST_TAIL_OVERFLOW"       => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Overflow" ],
   "OVERFLOW_CREDIT_MGR_VC2"      => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC2"     => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Underflow" ],
   "OVERFLOW_CREDIT_MGR_VC0"      => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC0"     => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC2"   => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC2"  => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC0"   => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC0"  => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Underflow" ],
   "OVERFLOW_NI1_VC3_CREDIT"      => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Overflow" ],
   "UNDERFLOW_NI1_VC3_CREDIT"     => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Underflow" ],
   "OVERFLOW_NI1_VC1_CREDIT"      => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Overflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT"     => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Underflow" ],
   "OVERFLOW_NI0_VC3_CREDIT"      => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Overflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT"     => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Underflow" ],
   "OVERFLOW_NI0_VC1_CREDIT"      => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Overflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT"     => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Underflow" ],
   "OVERFLOW_NI1_DEBIT3"          => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 3 Overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 1 Overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 3 Overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 1 Overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT"     => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Overflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT"    => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Underflow" ],
   "OVERFLOW_IILB_VC0_CREDIT"     => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Overflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT"    => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Underflow" ],
   "OVERFLOW_NI1_VC2_CREDIT"      => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT"     => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Underflow" ],
   "OVERFLOW_NI1_VC0_CREDIT"      => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Overflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT"     => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Underflow" ],
   "OVERFLOW_NI0_VC2_CREDIT"      => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Overflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT"     => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Underflow" ],
   "OVERFLOW_NI0_VC0_CREDIT"      => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Overflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT"     => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Underflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "IILB Debit 2 Overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "IILB Debit 0 Overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 Debit 2 Overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 Debit 0 Overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI0 Debit 2 Overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI0 Debit 0 Overflow" ],
   "OVERFLOW_SIC_CNTR2"           => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Overflow" ],
   "UNDERFLOW_SIC_CNTR2"          => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Underflow" ],
   "OVERFLOW_SIC_CNTR0"           => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Overflow" ],
   "UNDERFLOW_SIC_CNTR0"          => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Underflow" ],
   "UNCOR_ERROR1"                 => [  57,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 255:128" ],
   "UNCOR_ERROR0"                 => [  58,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 127:0" ],
   "SINGLE_BIT_ERROR1"            => [  59,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 255:128" ],
   "SINGLE_BIT_ERROR0"            => [  60,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 127:0" ],
   "LUT_READ_ERROR"               => [  61,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "OVERFLOW_VC2_CREDIT"          => [  62,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "VC2 Credit overflow" ],
   "OVERFLOW_VC0_CREDIT"          => [  63,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "VC0 Credit overflow" ],
);

%orbit_01_01010_def =
( NAME    => "OC_XNMD_ERROR_OVERFLOW",
  ADDRESS => 0x00000000d0040420,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_01010_flds
);


##########################################################################
#                                                                        #
#   OC_XNMD_ERROR_OVERFLOW_ALIAS                                         #
#                                                                        #
##########################################################################

%orbit_01_01011_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NI1_HEAD_OR_TAIL_CNT_ERROR"   => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "NI1 Head or Tail Count Error" ],
   "NI0_HEAD_OR_TAIL_CNT_ERROR"   => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "NI0 Head or Tail Count Error" ],
   "IILB_HEAD_OR_TAIL_CNT_ERROR"  => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "IILB Head or Tail Count Error" ],
   "IILB_FAST_TAIL_UPR_ERROR"     => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Upper Error" ],
   "NI1_FAST_TAIL_UPR_ERROR"      => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Upper Error" ],
   "NI0_FAST_TAIL_UPR_ERROR"      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Upper Error" ],
   "IILB_FAST_TAIL_LWR_ERROR"     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Lower Error" ],
   "NI1_FAST_TAIL_LWR_ERROR"      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Lower Error" ],
   "NI0_FAST_TAIL_LWR_ERROR"      => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Lower Error" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Underflow" ],
   "NI1_FAST_TAIL_UNDERFLOW"      => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Underflow" ],
   "NI0_FAST_TAIL_UNDERFLOW"      => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Underflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Overflow" ],
   "NI1_FAST_TAIL_OVERFLOW"       => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Overflow" ],
   "NI0_FAST_TAIL_OVERFLOW"       => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Overflow" ],
   "OVERFLOW_CREDIT_MGR_VC2"      => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC2"     => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Underflow" ],
   "OVERFLOW_CREDIT_MGR_VC0"      => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC0"     => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC2"   => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC2"  => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC0"   => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC0"  => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Underflow" ],
   "OVERFLOW_NI1_VC3_CREDIT"      => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Overflow" ],
   "UNDERFLOW_NI1_VC3_CREDIT"     => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Underflow" ],
   "OVERFLOW_NI1_VC1_CREDIT"      => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Overflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT"     => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Underflow" ],
   "OVERFLOW_NI0_VC3_CREDIT"      => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Overflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT"     => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Underflow" ],
   "OVERFLOW_NI0_VC1_CREDIT"      => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Overflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT"     => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Underflow" ],
   "OVERFLOW_NI1_DEBIT3"          => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 3 Overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 1 Overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 3 Overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 1 Overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT"     => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Overflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT"    => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Underflow" ],
   "OVERFLOW_IILB_VC0_CREDIT"     => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Overflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT"    => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Underflow" ],
   "OVERFLOW_NI1_VC2_CREDIT"      => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT"     => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Underflow" ],
   "OVERFLOW_NI1_VC0_CREDIT"      => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Overflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT"     => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Underflow" ],
   "OVERFLOW_NI0_VC2_CREDIT"      => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Overflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT"     => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Underflow" ],
   "OVERFLOW_NI0_VC0_CREDIT"      => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Overflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT"     => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Underflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "IILB Debit 2 Overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "IILB Debit 0 Overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 Debit 2 Overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 Debit 0 Overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI0 Debit 2 Overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI0 Debit 0 Overflow" ],
   "OVERFLOW_SIC_CNTR2"           => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Overflow" ],
   "UNDERFLOW_SIC_CNTR2"          => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Underflow" ],
   "OVERFLOW_SIC_CNTR0"           => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Overflow" ],
   "UNDERFLOW_SIC_CNTR0"          => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Underflow" ],
   "UNCOR_ERROR1"                 => [  57,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 255:128" ],
   "UNCOR_ERROR0"                 => [  58,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 127:0" ],
   "SINGLE_BIT_ERROR1"            => [  59,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 255:128" ],
   "SINGLE_BIT_ERROR0"            => [  60,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 127:0" ],
   "LUT_READ_ERROR"               => [  61,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "OVERFLOW_VC2_CREDIT"          => [  62,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "VC2 Credit overflow" ],
   "OVERFLOW_VC0_CREDIT"          => [  63,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "VC0 Credit overflow" ],
);

%orbit_01_01011_def =
( NAME    => "OC_XNMD_ERROR_OVERFLOW_ALIAS",
  ADDRESS => 0x00000000d0040428,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_01011_flds
);


##########################################################################
#                                                                        #
#   OC_XNMD_ERROR_MASK                                                   #
#                                                                        #
##########################################################################

%orbit_01_01012_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NI1_HEAD_OR_TAIL_CNT_ERROR"   => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "NI1 Head or Tail Count Error" ],
   "NI0_HEAD_OR_TAIL_CNT_ERROR"   => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "NI0 Head or Tail Count Error" ],
   "IILB_HEAD_OR_TAIL_CNT_ERROR"  => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "IILB Head or Tail Count Error" ],
   "IILB_FAST_TAIL_UPR_ERROR"     => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "IILB Fast Tail Upper Error" ],
   "NI1_FAST_TAIL_UPR_ERROR"      => [   4,  59,   1, 0x0800000000000000, 0x00, 1, 0x0000000000000000, "NI1 Fast Tail Upper Error" ],
   "NI0_FAST_TAIL_UPR_ERROR"      => [   5,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "NI0 Fast Tail Upper Error" ],
   "IILB_FAST_TAIL_LWR_ERROR"     => [   6,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "IILB Fast Tail Lower Error" ],
   "NI1_FAST_TAIL_LWR_ERROR"      => [   7,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "NI1 Fast Tail Lower Error" ],
   "NI0_FAST_TAIL_LWR_ERROR"      => [   8,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "NI0 Fast Tail Lower Error" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [   9,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "IILB Fast Tail Underflow" ],
   "NI1_FAST_TAIL_UNDERFLOW"      => [  10,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "NI1 Fast Tail Underflow" ],
   "NI0_FAST_TAIL_UNDERFLOW"      => [  11,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "NI0 Fast Tail Underflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  12,  51,   1, 0x0008000000000000, 0x00, 1, 0x0000000000000000, "IILB Fast Tail Overflow" ],
   "NI1_FAST_TAIL_OVERFLOW"       => [  13,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "NI1 Fast Tail Overflow" ],
   "NI0_FAST_TAIL_OVERFLOW"       => [  14,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "NI0 Fast Tail Overflow" ],
   "OVERFLOW_CREDIT_MGR_VC2"      => [  15,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "VC2 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC2"     => [  16,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "VC2 Credit Manager Underflow" ],
   "OVERFLOW_CREDIT_MGR_VC0"      => [  17,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "VC0 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC0"     => [  18,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "VC0 Credit Manager Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC2"   => [  19,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "VC2 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC2"  => [  20,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "VC2 Steering FIFO Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC0"   => [  21,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "VC0 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC0"  => [  22,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "VC0 Steering FIFO Underflow" ],
   "OVERFLOW_NI1_VC3_CREDIT"      => [  23,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "NI1 VC3 Credit Overflow" ],
   "UNDERFLOW_NI1_VC3_CREDIT"     => [  24,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "NI1 VC3 Credit Underflow" ],
   "OVERFLOW_NI1_VC1_CREDIT"      => [  25,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "NI1 VC1 Credit Overflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT"     => [  26,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "NI1 VC1 Credit Underflow" ],
   "OVERFLOW_NI0_VC3_CREDIT"      => [  27,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "NI0 VC3 Credit Overflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT"     => [  28,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "NI0 VC3 Credit Underflow" ],
   "OVERFLOW_NI0_VC1_CREDIT"      => [  29,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "NI0 VC1 Credit Overflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT"     => [  30,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "NI0 VC1 Credit Underflow" ],
   "OVERFLOW_NI1_DEBIT3"          => [  31,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "NI1 Debit 3 Overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  32,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "NI1 Debit 1 Overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  33,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "NI0 Debit 3 Overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  34,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "NI0 Debit 1 Overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT"     => [  35,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "IILB VC2 Credit Overflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT"    => [  36,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "IILB VC2 Credit Underflow" ],
   "OVERFLOW_IILB_VC0_CREDIT"     => [  37,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "IILB VC0 Credit Overflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT"    => [  38,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "IILB VC0 Credit Underflow" ],
   "OVERFLOW_NI1_VC2_CREDIT"      => [  39,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "NI1 VC2 Credit Overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT"     => [  40,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "NI1 VC2 Credit Underflow" ],
   "OVERFLOW_NI1_VC0_CREDIT"      => [  41,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "NI1 VC0 Credit Overflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT"     => [  42,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "NI1 VC0 Credit Underflow" ],
   "OVERFLOW_NI0_VC2_CREDIT"      => [  43,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "NI0 VC2 Credit Overflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT"     => [  44,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "NI0 VC2 Credit Underflow" ],
   "OVERFLOW_NI0_VC0_CREDIT"      => [  45,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "NI0 VC0 Credit Overflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT"     => [  46,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "NI0 VC0 Credit Underflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  47,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "IILB Debit 2 Overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  48,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "IILB Debit 0 Overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  49,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "NI1 Debit 2 Overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  50,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "NI1 Debit 0 Overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  51,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "NI0 Debit 2 Overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  52,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "NI0 Debit 0 Overflow" ],
   "OVERFLOW_SIC_CNTR2"           => [  53,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "SIC Counter 2 Overflow" ],
   "UNDERFLOW_SIC_CNTR2"          => [  54,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "SIC Counter 2 Underflow" ],
   "OVERFLOW_SIC_CNTR0"           => [  55,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "SIC Counter 0 Overflow" ],
   "UNDERFLOW_SIC_CNTR0"          => [  56,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "SIC Counter 0 Underflow" ],
   "UNCOR_ERROR1"                 => [  57,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Uncorrectable Error in Bits 255:128" ],
   "UNCOR_ERROR0"                 => [  58,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Uncorrectable Error in Bits 127:0" ],
   "SINGLE_BIT_ERROR1"            => [  59,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Single Bit Error in Bits 255:128" ],
   "SINGLE_BIT_ERROR0"            => [  60,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Single Bit Error in Bits 127:0" ],
   "LUT_READ_ERROR"               => [  61,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "LUT Read Error" ],
   "OVERFLOW_VC2_CREDIT"          => [  62,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "VC2 Credit overflow" ],
   "OVERFLOW_VC0_CREDIT"          => [  63,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "VC0 Credit overflow" ],
);

%orbit_01_01012_def =
( NAME    => "OC_XNMD_ERROR_MASK",
  ADDRESS => 0x00000000d0040440,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_01012_flds
);


##########################################################################
#                                                                        #
#   OC_XNMD_FIRST_ERROR                                                  #
#                                                                        #
##########################################################################

%orbit_01_01013_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NI1_HEAD_OR_TAIL_CNT_ERROR"   => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "NI1 Head or Tail Count Error" ],
   "NI0_HEAD_OR_TAIL_CNT_ERROR"   => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "NI0 Head or Tail Count Error" ],
   "IILB_HEAD_OR_TAIL_CNT_ERROR"  => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "IILB Head or Tail Count Error" ],
   "IILB_FAST_TAIL_UPR_ERROR"     => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Upper Error" ],
   "NI1_FAST_TAIL_UPR_ERROR"      => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Upper Error" ],
   "NI0_FAST_TAIL_UPR_ERROR"      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Upper Error" ],
   "IILB_FAST_TAIL_LWR_ERROR"     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Lower Error" ],
   "NI1_FAST_TAIL_LWR_ERROR"      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Lower Error" ],
   "NI0_FAST_TAIL_LWR_ERROR"      => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Lower Error" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Underflow" ],
   "NI1_FAST_TAIL_UNDERFLOW"      => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Underflow" ],
   "NI0_FAST_TAIL_UNDERFLOW"      => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Underflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Overflow" ],
   "NI1_FAST_TAIL_OVERFLOW"       => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Overflow" ],
   "NI0_FAST_TAIL_OVERFLOW"       => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Overflow" ],
   "OVERFLOW_CREDIT_MGR_VC2"      => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC2"     => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Underflow" ],
   "OVERFLOW_CREDIT_MGR_VC0"      => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC0"     => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC2"   => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC2"  => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC0"   => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC0"  => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Underflow" ],
   "OVERFLOW_NI1_VC3_CREDIT"      => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Overflow" ],
   "UNDERFLOW_NI1_VC3_CREDIT"     => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Underflow" ],
   "OVERFLOW_NI1_VC1_CREDIT"      => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Overflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT"     => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Underflow" ],
   "OVERFLOW_NI0_VC3_CREDIT"      => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Overflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT"     => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Underflow" ],
   "OVERFLOW_NI0_VC1_CREDIT"      => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Overflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT"     => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Underflow" ],
   "OVERFLOW_NI1_DEBIT3"          => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 3 Overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 1 Overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 3 Overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 1 Overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT"     => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Overflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT"    => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Underflow" ],
   "OVERFLOW_IILB_VC0_CREDIT"     => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Overflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT"    => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Underflow" ],
   "OVERFLOW_NI1_VC2_CREDIT"      => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT"     => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Underflow" ],
   "OVERFLOW_NI1_VC0_CREDIT"      => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Overflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT"     => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Underflow" ],
   "OVERFLOW_NI0_VC2_CREDIT"      => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Overflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT"     => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Underflow" ],
   "OVERFLOW_NI0_VC0_CREDIT"      => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Overflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT"     => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Underflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "IILB Debit 2 Overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "IILB Debit 0 Overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 Debit 2 Overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 Debit 0 Overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI0 Debit 2 Overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI0 Debit 0 Overflow" ],
   "OVERFLOW_SIC_CNTR2"           => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Overflow" ],
   "UNDERFLOW_SIC_CNTR2"          => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Underflow" ],
   "OVERFLOW_SIC_CNTR0"           => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Overflow" ],
   "UNDERFLOW_SIC_CNTR0"          => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Underflow" ],
   "UNCOR_ERROR1"                 => [  57,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 255:128" ],
   "UNCOR_ERROR0"                 => [  58,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 127:0" ],
   "SINGLE_BIT_ERROR1"            => [  59,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 255:128" ],
   "SINGLE_BIT_ERROR0"            => [  60,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 127:0" ],
   "LUT_READ_ERROR"               => [  61,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "OVERFLOW_VC2_CREDIT"          => [  62,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "VC2 Credit overflow" ],
   "OVERFLOW_VC0_CREDIT"          => [  63,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "VC0 Credit overflow" ],
);

%orbit_01_01013_def =
( NAME    => "OC_XNMD_FIRST_ERROR",
  ADDRESS => 0x00000000d0040460,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%orbit_01_01013_flds
);


##########################################################################
#                                                                        #
#   MMR LOOKUP TABLES (BY NAME OR ADDRESS)                               #
#                                                                        #
##########################################################################

%orbit_01_mmr_by_name = 
(
   OC_MMRBIST_ERR               => \%orbit_01_00000_def,
   OC_MISC_ERR_HDR_LOWER        => \%orbit_01_00001_def,
   OC_MISC_ERR_HDR_UPPER        => \%orbit_01_00002_def,
   OC_DIR_UC_ERR_HDR_LOWER      => \%orbit_01_00003_def,
   OC_DIR_UC_ERR_HDR_UPPER      => \%orbit_01_00004_def,
   OC_DIR_COR_ERR_HDR_LOWER     => \%orbit_01_00005_def,
   OC_DIR_COR_ERR_HDR_UPPER     => \%orbit_01_00006_def,
   OC_MEM_ERROR_SUMMARY         => \%orbit_01_00007_def,
   OC_MEM_ERROR_SUMMARY_ALIAS   => \%orbit_01_00008_def,
   OC_MEM_ERROR_OVERFLOW        => \%orbit_01_00009_def,
   OC_MEM_ERROR_OVERFLOW_ALIAS  => \%orbit_01_00010_def,
   OC_MEM_ERROR_MASK            => \%orbit_01_00011_def,
   OC_MISC_ADRS_ERR_HDR_LOWER_A => \%orbit_01_00012_def,
   OC_DIR_UC_ADRS_ERR_HDR_LOWER_A => \%orbit_01_00013_def,
   OC_DIR_COR_ADRS_ERR_HDR_LOWER_A => \%orbit_01_00014_def,
   OC_X_DIMM_CFG                => \%orbit_01_00015_def,
   OC_Y_DIMM_CFG                => \%orbit_01_00016_def,
   OC_JNR_DIMM_CFG              => \%orbit_01_00017_def,
   OC_X_PHASE_CFG               => \%orbit_01_00018_def,
   OC_X_CFG                     => \%orbit_01_00019_def,
   OC_X_DQCT_CFG                => \%orbit_01_00020_def,
   OC_X_REFRESH_CONTROL         => \%orbit_01_00021_def,
   OC_X_AMOC_CFG                => \%orbit_01_00022_def,
   OC_X_AMOC_TAG                => \%orbit_01_00023_def,
   OC_Y_PHASE_CFG               => \%orbit_01_00024_def,
   OC_Y_CFG                     => \%orbit_01_00025_def,
   OC_Y_DQCT_CFG                => \%orbit_01_00026_def,
   OC_Y_REFRESH_CONTROL         => \%orbit_01_00027_def,
   OC_Y_AMOC_CFG                => \%orbit_01_00028_def,
   OC_Y_AMOC_TAG                => \%orbit_01_00029_def,
   OC_MEM_RED_BLACK             => \%orbit_01_00030_def,
   OC_MISC_MEM_CFG              => \%orbit_01_00031_def,
   OC_PIO_RQ_CRD_CTL            => \%orbit_01_00032_def,
   OC_PI_MD_RQ_CRD_CTL          => \%orbit_01_00033_def,
   OC_PI_MD_RP_CRD_CTL          => \%orbit_01_00034_def,
   OC_XN_MD_RQ_CRD_CTL          => \%orbit_01_00035_def,
   OC_XN_MD_RP_CRD_CTL          => \%orbit_01_00036_def,
   OC_X_TAG0                    => \%orbit_01_00037_def,
   OC_X_TAG1                    => \%orbit_01_00038_def,
   OC_X_TAG2                    => \%orbit_01_00039_def,
   OC_X_TAG3                    => \%orbit_01_00040_def,
   OC_X_TAG4                    => \%orbit_01_00041_def,
   OC_X_TAG5                    => \%orbit_01_00042_def,
   OC_X_TAG6                    => \%orbit_01_00043_def,
   OC_X_TAG7                    => \%orbit_01_00044_def,
   OC_Y_TAG0                    => \%orbit_01_00045_def,
   OC_Y_TAG1                    => \%orbit_01_00046_def,
   OC_Y_TAG2                    => \%orbit_01_00047_def,
   OC_Y_TAG3                    => \%orbit_01_00048_def,
   OC_Y_TAG4                    => \%orbit_01_00049_def,
   OC_Y_TAG5                    => \%orbit_01_00050_def,
   OC_Y_TAG6                    => \%orbit_01_00051_def,
   OC_Y_TAG7                    => \%orbit_01_00052_def,
   OC_MMRBIST_BASE              => \%orbit_01_00053_def,
   OC_MMRBIST_CTL               => \%orbit_01_00054_def,
   OC_MD_DBUG_DATA_CFG          => \%orbit_01_00055_def,
   OC_MD_DBUG_TRIGGER_CFG       => \%orbit_01_00056_def,
   OC_MD_DBUG_COMPARE           => \%orbit_01_00057_def,
   OC_X_TAG_DBUG_SEL            => \%orbit_01_00058_def,
   OC_X_WBQ_DBUG_SEL            => \%orbit_01_00059_def,
   OC_X_ARB_DBUG_SEL            => \%orbit_01_00060_def,
   OC_X_ATL_DBUG_SEL            => \%orbit_01_00061_def,
   OC_X_ATR_DBUG_SEL            => \%orbit_01_00062_def,
   OC_X_DQL_DBUG_SEL            => \%orbit_01_00063_def,
   OC_X_DQR_DBUG_SEL            => \%orbit_01_00064_def,
   OC_X_DBUG_SEL                => \%orbit_01_00065_def,
   OC_X_LADDR_CMP               => \%orbit_01_00066_def,
   OC_X_RADDR_CMP               => \%orbit_01_00067_def,
   OC_X_TAG_CMP                 => \%orbit_01_00068_def,
   OC_X_TAG_MASK                => \%orbit_01_00069_def,
   OC_Y_TAG_DBUG_SEL            => \%orbit_01_00070_def,
   OC_Y_WBQ_DBUG_SEL            => \%orbit_01_00071_def,
   OC_Y_ARB_DBUG_SEL            => \%orbit_01_00072_def,
   OC_Y_ATL_DBUG_SEL            => \%orbit_01_00073_def,
   OC_Y_ATR_DBUG_SEL            => \%orbit_01_00074_def,
   OC_Y_DQL_DBUG_SEL            => \%orbit_01_00075_def,
   OC_Y_DQR_DBUG_SEL            => \%orbit_01_00076_def,
   OC_Y_DBUG_SEL                => \%orbit_01_00077_def,
   OC_Y_LADDR_CMP               => \%orbit_01_00078_def,
   OC_Y_RADDR_CMP               => \%orbit_01_00079_def,
   OC_Y_TAG_CMP                 => \%orbit_01_00080_def,
   OC_Y_TAG_MASK                => \%orbit_01_00081_def,
   OC_MD_JNR_DBUG_DATA_CFG      => \%orbit_01_00082_def,
   OC_MD_LAST_CREDIT            => \%orbit_01_00083_def,
   OC_MEM_CAPTURE_ADDR          => \%orbit_01_00084_def,
   OC_MEM_CAPTURE_MASK          => \%orbit_01_00085_def,
   OC_MEM_CAPTURE_HDR           => \%orbit_01_00086_def,
   OC_MEM_CAPTURE_HDR_ADDR      => \%orbit_01_00087_def,
   OC_MD_DQLP_MMR_DIR_CONFIG    => \%orbit_01_00088_def,
   OC_MD_DQLP_MMR_DIR_PRESVEC0  => \%orbit_01_00089_def,
   OC_MD_DQLP_MMR_DIR_PRESVEC1  => \%orbit_01_00090_def,
   OC_MD_DQLP_MMR_DIR_PRESVEC2  => \%orbit_01_00091_def,
   OC_MD_DQLP_MMR_DIR_PRESVEC3  => \%orbit_01_00092_def,
   OC_MD_DQLP_MMR_DIR_LOCVEC0   => \%orbit_01_00093_def,
   OC_MD_DQLP_MMR_DIR_LOCVEC1   => \%orbit_01_00094_def,
   OC_MD_DQLP_MMR_DIR_LOCVEC2   => \%orbit_01_00095_def,
   OC_MD_DQLP_MMR_DIR_LOCVEC3   => \%orbit_01_00096_def,
   OC_MD_DQLP_MMR_DIR_LOCVEC4   => \%orbit_01_00097_def,
   OC_MD_DQLP_MMR_DIR_LOCVEC5   => \%orbit_01_00098_def,
   OC_MD_DQLP_MMR_DIR_LOCVEC6   => \%orbit_01_00099_def,
   OC_MD_DQLP_MMR_DIR_LOCVEC7   => \%orbit_01_00100_def,
   OC_MD_DQLP_MMR_DIR_PRIVEC0   => \%orbit_01_00101_def,
   OC_MD_DQLP_MMR_DIR_PRIVEC1   => \%orbit_01_00102_def,
   OC_MD_DQLP_MMR_DIR_PRIVEC2   => \%orbit_01_00103_def,
   OC_MD_DQLP_MMR_DIR_PRIVEC3   => \%orbit_01_00104_def,
   OC_MD_DQLP_MMR_DIR_PRIVEC4   => \%orbit_01_00105_def,
   OC_MD_DQLP_MMR_DIR_PRIVEC5   => \%orbit_01_00106_def,
   OC_MD_DQLP_MMR_DIR_PRIVEC6   => \%orbit_01_00107_def,
   OC_MD_DQLP_MMR_DIR_PRIVEC7   => \%orbit_01_00108_def,
   OC_MD_DQLP_MMR_DIR_TIMER     => \%orbit_01_00109_def,
   OC_MD_DQLP_MMR_PIOWD_DIR_ENTRY => \%orbit_01_00110_def,
   OC_MD_DQLP_MMR_PIOWD_DIR_ECC => \%orbit_01_00111_def,
   OC_MD_DQLP_MMR_XPIORD_XDIR_ENTRY => \%orbit_01_00112_def,
   OC_MD_DQLP_MMR_XPIORD_XDIR_ECC => \%orbit_01_00113_def,
   OC_MD_DQLP_MMR_YPIORD_YDIR_ENTRY => \%orbit_01_00114_def,
   OC_MD_DQLP_MMR_YPIORD_YDIR_ECC => \%orbit_01_00115_def,
   OC_MD_DQLP_MMR_XCERR1        => \%orbit_01_00116_def,
   OC_MD_DQLP_MMR_XCERR2        => \%orbit_01_00117_def,
   OC_MD_DQLP_MMR_XUERR1        => \%orbit_01_00118_def,
   OC_MD_DQLP_MMR_XUERR2        => \%orbit_01_00119_def,
   OC_MD_DQLP_MMR_XPERR         => \%orbit_01_00120_def,
   OC_MD_DQLP_MMR_YCERR1        => \%orbit_01_00121_def,
   OC_MD_DQLP_MMR_YCERR2        => \%orbit_01_00122_def,
   OC_MD_DQLP_MMR_YUERR1        => \%orbit_01_00123_def,
   OC_MD_DQLP_MMR_YUERR2        => \%orbit_01_00124_def,
   OC_MD_DQLP_MMR_YPERR         => \%orbit_01_00125_def,
   OC_MD_DQLP_MMR_DIR_CMDTRIG   => \%orbit_01_00126_def,
   OC_MD_DQLP_MMR_DIR_TBLTRIG   => \%orbit_01_00127_def,
   OC_MD_DQLP_MMR_DIR_TBLMASK   => \%orbit_01_00128_def,
   OC_MD_DQLP_MMR_XBIST_H       => \%orbit_01_00129_def,
   OC_MD_DQLP_MMR_XBIST_L       => \%orbit_01_00130_def,
   OC_MD_DQLP_MMR_XBIST_ERR_H   => \%orbit_01_00131_def,
   OC_MD_DQLP_MMR_XBIST_ERR_L   => \%orbit_01_00132_def,
   OC_MD_DQLP_MMR_YBIST_H       => \%orbit_01_00133_def,
   OC_MD_DQLP_MMR_YBIST_L       => \%orbit_01_00134_def,
   OC_MD_DQLP_MMR_YBIST_ERR_H   => \%orbit_01_00135_def,
   OC_MD_DQLP_MMR_YBIST_ERR_L   => \%orbit_01_00136_def,
   OC_MD_DQLP_MMR_AMO_CFG       => \%orbit_01_00137_def,
   OC_MD_DQLS_MMR_XBIST_H       => \%orbit_01_00138_def,
   OC_MD_DQLS_MMR_XBIST_L       => \%orbit_01_00139_def,
   OC_MD_DQLS_MMR_XBIST_ERR_H   => \%orbit_01_00140_def,
   OC_MD_DQLS_MMR_XBIST_ERR_L   => \%orbit_01_00141_def,
   OC_MD_DQLS_MMR_YBIST_H       => \%orbit_01_00142_def,
   OC_MD_DQLS_MMR_YBIST_L       => \%orbit_01_00143_def,
   OC_MD_DQLS_MMR_YBIST_ERR_H   => \%orbit_01_00144_def,
   OC_MD_DQLS_MMR_YBIST_ERR_L   => \%orbit_01_00145_def,
   OC_MD_DQLS_MMR_JNR_DEBUG     => \%orbit_01_00146_def,
   OC_MD_DQLS_MMR_XAMOPW_ERR    => \%orbit_01_00147_def,
   OC_MD_DQLS_MMR_AMO_CFG       => \%orbit_01_00148_def,
   OC_MD_DQRP_MMR_DIR_CONFIG    => \%orbit_01_00149_def,
   OC_MD_DQRP_MMR_DIR_PRESVEC0  => \%orbit_01_00150_def,
   OC_MD_DQRP_MMR_DIR_PRESVEC1  => \%orbit_01_00151_def,
   OC_MD_DQRP_MMR_DIR_PRESVEC2  => \%orbit_01_00152_def,
   OC_MD_DQRP_MMR_DIR_PRESVEC3  => \%orbit_01_00153_def,
   OC_MD_DQRP_MMR_DIR_LOCVEC0   => \%orbit_01_00154_def,
   OC_MD_DQRP_MMR_DIR_LOCVEC1   => \%orbit_01_00155_def,
   OC_MD_DQRP_MMR_DIR_LOCVEC2   => \%orbit_01_00156_def,
   OC_MD_DQRP_MMR_DIR_LOCVEC3   => \%orbit_01_00157_def,
   OC_MD_DQRP_MMR_DIR_LOCVEC4   => \%orbit_01_00158_def,
   OC_MD_DQRP_MMR_DIR_LOCVEC5   => \%orbit_01_00159_def,
   OC_MD_DQRP_MMR_DIR_LOCVEC6   => \%orbit_01_00160_def,
   OC_MD_DQRP_MMR_DIR_LOCVEC7   => \%orbit_01_00161_def,
   OC_MD_DQRP_MMR_DIR_PRIVEC0   => \%orbit_01_00162_def,
   OC_MD_DQRP_MMR_DIR_PRIVEC1   => \%orbit_01_00163_def,
   OC_MD_DQRP_MMR_DIR_PRIVEC2   => \%orbit_01_00164_def,
   OC_MD_DQRP_MMR_DIR_PRIVEC3   => \%orbit_01_00165_def,
   OC_MD_DQRP_MMR_DIR_PRIVEC4   => \%orbit_01_00166_def,
   OC_MD_DQRP_MMR_DIR_PRIVEC5   => \%orbit_01_00167_def,
   OC_MD_DQRP_MMR_DIR_PRIVEC6   => \%orbit_01_00168_def,
   OC_MD_DQRP_MMR_DIR_PRIVEC7   => \%orbit_01_00169_def,
   OC_MD_DQRP_MMR_DIR_TIMER     => \%orbit_01_00170_def,
   OC_MD_DQRP_MMR_PIOWD_DIR_ENTRY => \%orbit_01_00171_def,
   OC_MD_DQRP_MMR_PIOWD_DIR_ECC => \%orbit_01_00172_def,
   OC_MD_DQRP_MMR_XPIORD_XDIR_ENTRY => \%orbit_01_00173_def,
   OC_MD_DQRP_MMR_XPIORD_XDIR_ECC => \%orbit_01_00174_def,
   OC_MD_DQRP_MMR_YPIORD_YDIR_ENTRY => \%orbit_01_00175_def,
   OC_MD_DQRP_MMR_YPIORD_YDIR_ECC => \%orbit_01_00176_def,
   OC_MD_DQRP_MMR_XCERR1        => \%orbit_01_00177_def,
   OC_MD_DQRP_MMR_XCERR2        => \%orbit_01_00178_def,
   OC_MD_DQRP_MMR_XUERR1        => \%orbit_01_00179_def,
   OC_MD_DQRP_MMR_XUERR2        => \%orbit_01_00180_def,
   OC_MD_DQRP_MMR_XPERR         => \%orbit_01_00181_def,
   OC_MD_DQRP_MMR_YCERR1        => \%orbit_01_00182_def,
   OC_MD_DQRP_MMR_YCERR2        => \%orbit_01_00183_def,
   OC_MD_DQRP_MMR_YUERR1        => \%orbit_01_00184_def,
   OC_MD_DQRP_MMR_YUERR2        => \%orbit_01_00185_def,
   OC_MD_DQRP_MMR_YPERR         => \%orbit_01_00186_def,
   OC_MD_DQRP_MMR_DIR_CMDTRIG   => \%orbit_01_00187_def,
   OC_MD_DQRP_MMR_DIR_TBLTRIG   => \%orbit_01_00188_def,
   OC_MD_DQRP_MMR_DIR_TBLMASK   => \%orbit_01_00189_def,
   OC_MD_DQRP_MMR_XBIST_H       => \%orbit_01_00190_def,
   OC_MD_DQRP_MMR_XBIST_L       => \%orbit_01_00191_def,
   OC_MD_DQRP_MMR_XBIST_ERR_H   => \%orbit_01_00192_def,
   OC_MD_DQRP_MMR_XBIST_ERR_L   => \%orbit_01_00193_def,
   OC_MD_DQRP_MMR_YBIST_H       => \%orbit_01_00194_def,
   OC_MD_DQRP_MMR_YBIST_L       => \%orbit_01_00195_def,
   OC_MD_DQRP_MMR_YBIST_ERR_H   => \%orbit_01_00196_def,
   OC_MD_DQRP_MMR_YBIST_ERR_L   => \%orbit_01_00197_def,
   OC_MD_DQRP_MMR_AMO_CFG       => \%orbit_01_00198_def,
   OC_MD_DQRS_MMR_XBIST_H       => \%orbit_01_00199_def,
   OC_MD_DQRS_MMR_XBIST_L       => \%orbit_01_00200_def,
   OC_MD_DQRS_MMR_XBIST_ERR_H   => \%orbit_01_00201_def,
   OC_MD_DQRS_MMR_XBIST_ERR_L   => \%orbit_01_00202_def,
   OC_MD_DQRS_MMR_YBIST_H       => \%orbit_01_00203_def,
   OC_MD_DQRS_MMR_YBIST_L       => \%orbit_01_00204_def,
   OC_MD_DQRS_MMR_YBIST_ERR_H   => \%orbit_01_00205_def,
   OC_MD_DQRS_MMR_YBIST_ERR_L   => \%orbit_01_00206_def,
   OC_MD_DQRS_MMR_JNR_DEBUG     => \%orbit_01_00207_def,
   OC_MD_DQRS_MMR_YAMOPW_ERR    => \%orbit_01_00208_def,
   OC_MD_DQRS_MMR_AMO_CFG       => \%orbit_01_00209_def,
   OC_INT_NODE_ID_CONFIG        => \%orbit_01_00210_def,
   OC_SHUB_INTERRUPT_CONFIG     => \%orbit_01_00211_def,
   OC_HW_STAT_INT_ENABLE        => \%orbit_01_00212_def,
   OC_PROFILE_INT_ENABLE        => \%orbit_01_00213_def,
   OC_RTC0_INT_ENABLE           => \%orbit_01_00214_def,
   OC_RTC1_INT_ENABLE           => \%orbit_01_00215_def,
   OC_RTC2_INT_ENABLE           => \%orbit_01_00216_def,
   OC_RTC3_INT_ENABLE           => \%orbit_01_00217_def,
   OC_HW_ERR_INT_ENABLE         => \%orbit_01_00218_def,
   OC_NMI_INT_ENABLE            => \%orbit_01_00219_def,
   OC_L2_PEND_MOD               => \%orbit_01_00220_def,
   OC_L3_PEND_MOD               => \%orbit_01_00221_def,
   OC_L4_PEND_MOD               => \%orbit_01_00222_def,
   OC_L5_PEND_MOD               => \%orbit_01_00223_def,
   OC_L6_PEND_MOD               => \%orbit_01_00224_def,
   OC_NMI_PEND_MOD              => \%orbit_01_00225_def,
   OC_P0_L2_INT_MASK0           => \%orbit_01_00226_def,
   OC_P0_L2_INT_MASK1           => \%orbit_01_00227_def,
   OC_P0_L3_INT_MASK            => \%orbit_01_00228_def,
   OC_P0_L4_INT_MASK            => \%orbit_01_00229_def,
   OC_P0_L5_INT_MASK            => \%orbit_01_00230_def,
   OC_P0_L6_INT_MASK            => \%orbit_01_00231_def,
   OC_P1_L2_INT_MASK0           => \%orbit_01_00232_def,
   OC_P1_L2_INT_MASK1           => \%orbit_01_00233_def,
   OC_P1_L3_INT_MASK            => \%orbit_01_00234_def,
   OC_P1_L4_INT_MASK            => \%orbit_01_00235_def,
   OC_P1_L5_INT_MASK            => \%orbit_01_00236_def,
   OC_P1_L6_INT_MASK            => \%orbit_01_00237_def,
   OC_P2_L2_INT_MASK0           => \%orbit_01_00238_def,
   OC_P2_L2_INT_MASK1           => \%orbit_01_00239_def,
   OC_P2_L3_INT_MASK            => \%orbit_01_00240_def,
   OC_P2_L4_INT_MASK            => \%orbit_01_00241_def,
   OC_P2_L5_INT_MASK            => \%orbit_01_00242_def,
   OC_P2_L6_INT_MASK            => \%orbit_01_00243_def,
   OC_P3_L2_INT_MASK0           => \%orbit_01_00244_def,
   OC_P3_L2_INT_MASK1           => \%orbit_01_00245_def,
   OC_P3_L3_INT_MASK            => \%orbit_01_00246_def,
   OC_P3_L4_INT_MASK            => \%orbit_01_00247_def,
   OC_P3_L5_INT_MASK            => \%orbit_01_00248_def,
   OC_P3_L6_INT_MASK            => \%orbit_01_00249_def,
   OC_L2_INT_PEND0              => \%orbit_01_00250_def,
   OC_L2_INT_PEND1              => \%orbit_01_00251_def,
   OC_L3_INT_PEND               => \%orbit_01_00252_def,
   OC_L4_INT_PEND               => \%orbit_01_00253_def,
   OC_L5_INT_PEND               => \%orbit_01_00254_def,
   OC_L6_INT_PEND               => \%orbit_01_00255_def,
   OC_NMI_INT_PEND              => \%orbit_01_00256_def,
   OC_P0_L2_INT_STATUS0         => \%orbit_01_00257_def,
   OC_P0_L2_INT_STATUS1         => \%orbit_01_00258_def,
   OC_P0_L3_INT_STATUS          => \%orbit_01_00259_def,
   OC_P0_L4_INT_STATUS          => \%orbit_01_00260_def,
   OC_P0_L5_INT_STATUS          => \%orbit_01_00261_def,
   OC_P0_L6_INT_STATUS          => \%orbit_01_00262_def,
   OC_P1_L2_INT_STATUS0         => \%orbit_01_00263_def,
   OC_P1_L2_INT_STATUS1         => \%orbit_01_00264_def,
   OC_P1_L3_INT_STATUS          => \%orbit_01_00265_def,
   OC_P1_L4_INT_STATUS          => \%orbit_01_00266_def,
   OC_P1_L5_INT_STATUS          => \%orbit_01_00267_def,
   OC_P1_L6_INT_STATUS          => \%orbit_01_00268_def,
   OC_P2_L2_INT_STATUS0         => \%orbit_01_00269_def,
   OC_P2_L2_INT_STATUS1         => \%orbit_01_00270_def,
   OC_P2_L3_INT_STATUS          => \%orbit_01_00271_def,
   OC_P2_L4_INT_STATUS          => \%orbit_01_00272_def,
   OC_P2_L5_INT_STATUS          => \%orbit_01_00273_def,
   OC_P2_L6_INT_STATUS          => \%orbit_01_00274_def,
   OC_P3_L2_INT_STATUS0         => \%orbit_01_00275_def,
   OC_P3_L2_INT_STATUS1         => \%orbit_01_00276_def,
   OC_P3_L3_INT_STATUS          => \%orbit_01_00277_def,
   OC_P3_L4_INT_STATUS          => \%orbit_01_00278_def,
   OC_P3_L5_INT_STATUS          => \%orbit_01_00279_def,
   OC_P3_L6_INT_STATUS          => \%orbit_01_00280_def,
   OC_ASIC_TO_L1_DATA           => \%orbit_01_00281_def,
   OC_ASIC_TO_L1_STATUS         => \%orbit_01_00282_def,
   OC_L1_TO_ASIC_DATA           => \%orbit_01_00283_def,
   OC_L1_TO_ASIC_STATUS         => \%orbit_01_00284_def,
   OC_JUNK_BUS_TIME             => \%orbit_01_00285_def,
   OC_JUNK_NACK_RESET           => \%orbit_01_00286_def,
   OC_JUNK_BUS_LED0             => \%orbit_01_00287_def,
   OC_JUNK_BUS_LED1             => \%orbit_01_00288_def,
   OC_JUNK_BUS_LED2             => \%orbit_01_00289_def,
   OC_JUNK_BUS_LED3             => \%orbit_01_00290_def,
   OC_LB_LIQ_CTL                => \%orbit_01_00291_def,
   OC_LB_LOQ_CTL                => \%orbit_01_00292_def,
   OC_LB_MAX_REP_CREDIT_CNT     => \%orbit_01_00293_def,
   OC_LB_MAX_REQ_CREDIT_CNT     => \%orbit_01_00294_def,
   OC_LB_MAX_INT_CREDIT_CNT     => \%orbit_01_00295_def,
   OC_PIO_TIME_OUT              => \%orbit_01_00296_def,
   OC_LB_CREDIT_STATUS          => \%orbit_01_00297_def,
   OC_LB_DEBUG_LOCAL_SEL        => \%orbit_01_00298_def,
   OC_LB_DEBUG_MUX0_SEL         => \%orbit_01_00299_def,
   OC_LB_DEBUG_MUX1_SEL         => \%orbit_01_00300_def,
   OC_LB_DEBUG_COMPARE_SEL      => \%orbit_01_00301_def,
   OC_LB_ERROR_DETAIL_1         => \%orbit_01_00302_def,
   OC_LB_ERROR_DETAIL_2         => \%orbit_01_00303_def,
   OC_LB_ERROR_DETAIL_3         => \%orbit_01_00304_def,
   OC_LB_ERROR_DETAIL_4         => \%orbit_01_00305_def,
   OC_LB_ERROR_DETAIL_5         => \%orbit_01_00306_def,
   OC_LB_ERROR_MASK             => \%orbit_01_00307_def,
   OC_LB_ERROR_OVERFLOW         => \%orbit_01_00308_def,
   OC_LB_ERROR_OVERFLOW_ALIAS   => \%orbit_01_00309_def,
   OC_LB_ERROR_SUMMARY          => \%orbit_01_00310_def,
   OC_LB_ERROR_SUMMARY_ALIAS    => \%orbit_01_00311_def,
   OC_LB_FIRST_ERROR            => \%orbit_01_00312_def,
   OC_LB_LAST_CREDIT            => \%orbit_01_00313_def,
   OC_LB_NACK_STATUS            => \%orbit_01_00314_def,
   OC_LB_COMPARE_COMPARE        => \%orbit_01_00315_def,
   OC_LB_COMPARE_DATA           => \%orbit_01_00316_def,
   OC_AUTO_REPLY_ENABLE0        => \%orbit_01_00317_def,
   OC_AUTO_REPLY_ENABLE1        => \%orbit_01_00318_def,
   OC_AUTO_REPLY_HEADER0        => \%orbit_01_00319_def,
   OC_AUTO_REPLY_HEADER1        => \%orbit_01_00320_def,
   OC_ENABLE_RP_AUTO_REPLY      => \%orbit_01_00321_def,
   OC_ENABLE_RQ_AUTO_REPLY      => \%orbit_01_00322_def,
   OC_REDIRECT_INVAL            => \%orbit_01_00323_def,
   OC_DIAG_MSG_CNTRL            => \%orbit_01_00324_def,
   OC_DIAG_MSG_DATA0L           => \%orbit_01_00325_def,
   OC_DIAG_MSG_DATA0U           => \%orbit_01_00326_def,
   OC_DIAG_MSG_DATA1L           => \%orbit_01_00327_def,
   OC_DIAG_MSG_DATA1U           => \%orbit_01_00328_def,
   OC_DIAG_MSG_DATA2L           => \%orbit_01_00329_def,
   OC_DIAG_MSG_DATA2U           => \%orbit_01_00330_def,
   OC_DIAG_MSG_DATA3L           => \%orbit_01_00331_def,
   OC_DIAG_MSG_DATA3U           => \%orbit_01_00332_def,
   OC_DIAG_MSG_DATA4L           => \%orbit_01_00333_def,
   OC_DIAG_MSG_DATA4U           => \%orbit_01_00334_def,
   OC_DIAG_MSG_DATA5L           => \%orbit_01_00335_def,
   OC_DIAG_MSG_DATA5U           => \%orbit_01_00336_def,
   OC_DIAG_MSG_DATA6L           => \%orbit_01_00337_def,
   OC_DIAG_MSG_DATA6U           => \%orbit_01_00338_def,
   OC_DIAG_MSG_DATA7L           => \%orbit_01_00339_def,
   OC_DIAG_MSG_DATA7U           => \%orbit_01_00340_def,
   OC_DIAG_MSG_DATA8L           => \%orbit_01_00341_def,
   OC_DIAG_MSG_DATA8U           => \%orbit_01_00342_def,
   OC_DIAG_MSG_HDR0             => \%orbit_01_00343_def,
   OC_DIAG_MSG_HDR1             => \%orbit_01_00344_def,
   OC_DEBUG_SELECT              => \%orbit_01_00345_def,
   OC_II_DEBUG_SELECT           => \%orbit_01_00346_def,
   OC_COMPARE_COMPARE_MASK      => \%orbit_01_00347_def,
   OC_COMPARE_COMPARE_PATTERN   => \%orbit_01_00348_def,
   OC_COMPARE_SEL               => \%orbit_01_00349_def,
   OC_OB_LA_CONTROL             => \%orbit_01_00350_def,
   OC_OB_LA_START_CONTROL       => \%orbit_01_00351_def,
   OC_OB_LA_STOP_CONTROL        => \%orbit_01_00352_def,
   OC_OB_LA_START_ADDRESS       => \%orbit_01_00353_def,
   OC_OB_LA_END_ADDRESS         => \%orbit_01_00354_def,
   OC_STOP_CLK_CONTROL          => \%orbit_01_00355_def,
   OC_STOP_CLK_DELAY_PHASE      => \%orbit_01_00356_def,
   OC_TSF_ARM_MASK              => \%orbit_01_00357_def,
   OC_TSF_COUNTER_PRESETS       => \%orbit_01_00358_def,
   OC_TSF_DECREMENT_CTL         => \%orbit_01_00359_def,
   OC_TSF_DIAG_MSG_CTL          => \%orbit_01_00360_def,
   OC_TSF_DISARM_MASK           => \%orbit_01_00361_def,
   OC_TSF_ENABLE_CTL            => \%orbit_01_00362_def,
   OC_TSF_SOFTWARE_ARM          => \%orbit_01_00363_def,
   OC_TSF_SOFTWARE_DISARM       => \%orbit_01_00364_def,
   OC_TSF_SOFTWARE_TRIGGERED    => \%orbit_01_00365_def,
   OC_TSF_TRIGGER_MASK          => \%orbit_01_00366_def,
   OC_TSF_COMPARE0              => \%orbit_01_00367_def,
   OC_TSF_COMPARE1              => \%orbit_01_00368_def,
   OC_TSF_COMPARE2              => \%orbit_01_00369_def,
   OC_TSF_COMPARE3              => \%orbit_01_00370_def,
   OC_TSF_COMPARE4              => \%orbit_01_00371_def,
   OC_TSF_COMPARE5              => \%orbit_01_00372_def,
   OC_TSF_COMPARE6              => \%orbit_01_00373_def,
   OC_TSF_COMPARE7              => \%orbit_01_00374_def,
   OC_TSF_COMPARE8              => \%orbit_01_00375_def,
   OC_TSF_COMPARE9              => \%orbit_01_00376_def,
   OC_TSF_COMPARE10             => \%orbit_01_00377_def,
   OC_TSF_COMPARE11             => \%orbit_01_00378_def,
   OC_TSF_COMPARE12             => \%orbit_01_00379_def,
   OC_TSF_COMPARE13             => \%orbit_01_00380_def,
   OC_TSF_COMPARE14             => \%orbit_01_00381_def,
   OC_TSF_COMPARE15             => \%orbit_01_00382_def,
   OC_VEC_DATA                  => \%orbit_01_00383_def,
   OC_VEC_PARMS                 => \%orbit_01_00384_def,
   OC_VEC_ROUTE                 => \%orbit_01_00385_def,
   OC_CPU_PERM0                 => \%orbit_01_00386_def,
   OC_CPU_PERM1                 => \%orbit_01_00387_def,
   OC_CPU_PERM2                 => \%orbit_01_00388_def,
   OC_CPU_PERM3                 => \%orbit_01_00389_def,
   OC_CPU_PERM_OVR              => \%orbit_01_00390_def,
   OC_EXT_IO_PERM0              => \%orbit_01_00391_def,
   OC_EXT_IO_PERM1              => \%orbit_01_00392_def,
   OC_EXT_IO_PERM2              => \%orbit_01_00393_def,
   OC_EXT_IO_PERM3              => \%orbit_01_00394_def,
   OC_EXT_IOI_ACCESS0           => \%orbit_01_00395_def,
   OC_EXT_IOI_ACCESS1           => \%orbit_01_00396_def,
   OC_EXT_IOI_ACCESS2           => \%orbit_01_00397_def,
   OC_EXT_IOI_ACCESS3           => \%orbit_01_00398_def,
   OC_GC_FIL_CTRL               => \%orbit_01_00399_def,
   OC_GC_SRC_CTRL               => \%orbit_01_00400_def,
   OC_HARD_RESET                => \%orbit_01_00401_def,
   OC_IO_PERM0                  => \%orbit_01_00402_def,
   OC_IO_PERM1                  => \%orbit_01_00403_def,
   OC_IO_PERM2                  => \%orbit_01_00404_def,
   OC_IO_PERM3                  => \%orbit_01_00405_def,
   OC_IOI_ACCESS0               => \%orbit_01_00406_def,
   OC_IOI_ACCESS1               => \%orbit_01_00407_def,
   OC_IOI_ACCESS2               => \%orbit_01_00408_def,
   OC_IOI_ACCESS3               => \%orbit_01_00409_def,
   OC_IPI_ACCESS0               => \%orbit_01_00410_def,
   OC_IPI_ACCESS1               => \%orbit_01_00411_def,
   OC_IPI_ACCESS2               => \%orbit_01_00412_def,
   OC_IPI_ACCESS3               => \%orbit_01_00413_def,
   OC_JTAG_CONFIG               => \%orbit_01_00414_def,
   OC_ORBIT_ID                  => \%orbit_01_00415_def,
   OC_ORBITS_PRESENT0           => \%orbit_01_00416_def,
   OC_ORBITS_PRESENT1           => \%orbit_01_00417_def,
   OC_ORBITS_PRESENT2           => \%orbit_01_00418_def,
   OC_ORBITS_PRESENT3           => \%orbit_01_00419_def,
   OC_SOFT_RESET                => \%orbit_01_00420_def,
   OC_NODE_PRESENT_TABLE        => \%orbit_01_00421_def,
   OC_THROTTLE_INTERVAL         => \%orbit_01_00422_def,
   OC_THROTTLE_TIME             => \%orbit_01_00423_def,
   OC_THROTTLE_ENABLE           => \%orbit_01_00424_def,
   OC_FIRST_ERROR               => \%orbit_01_00425_def,
   OC_PI_HW_INT_TIME_STAMP      => \%orbit_01_00426_def,
   OC_PI_CE_INT_TIME_STAMP      => \%orbit_01_00427_def,
   OC_PI_RE_INT_TIME_STAMP      => \%orbit_01_00428_def,
   OC_PI_NRE_INT_TIME_STAMP     => \%orbit_01_00429_def,
   OC_PI_UCE_INT_TIME_STAMP     => \%orbit_01_00430_def,
   OC_MD_HW_INT_TIME_STAMP      => \%orbit_01_00431_def,
   OC_MD_CE_INT_TIME_STAMP      => \%orbit_01_00432_def,
   OC_MD_RE_INT_TIME_STAMP      => \%orbit_01_00433_def,
   OC_MD_NRE_INT_TIME_STAMP     => \%orbit_01_00434_def,
   OC_MD_UCE_INT_TIME_STAMP     => \%orbit_01_00435_def,
   OC_XN_HW_INT_TIME_STAMP      => \%orbit_01_00436_def,
   OC_XN_CE_INT_TIME_STAMP      => \%orbit_01_00437_def,
   OC_XN_RE_INT_TIME_STAMP      => \%orbit_01_00438_def,
   OC_XN_NRE_INT_TIME_STAMP     => \%orbit_01_00439_def,
   OC_XN_UCE_INT_TIME_STAMP     => \%orbit_01_00440_def,
   OC_LB_HW_INT_TIME_STAMP      => \%orbit_01_00441_def,
   OC_II_HW_INT_TIME_STAMP      => \%orbit_01_00442_def,
   OC_II_RE_INT_TIME_STAMP      => \%orbit_01_00443_def,
   OC_II_NRE_INT_TIME_STAMP     => \%orbit_01_00444_def,
   OC_DEBUG_PORT                => \%orbit_01_00445_def,
   OC_II_DEBUG_DATA             => \%orbit_01_00446_def,
   OC_II_WRAP_DEBUG_DATA        => \%orbit_01_00447_def,
   OC_LB_DEBUG_DATA             => \%orbit_01_00448_def,
   OC_MD_DEBUG_DATA             => \%orbit_01_00449_def,
   OC_PI_DEBUG_DATA             => \%orbit_01_00450_def,
   OC_XN_DEBUG_DATA             => \%orbit_01_00451_def,
   OC_OB_LA_STATUS              => \%orbit_01_00452_def,
   OC_OB_LA_SEQUENCE            => \%orbit_01_00453_def,
   OC_OB_LA_CURRENT_ADDR        => \%orbit_01_00454_def,
   OC_TSF_ARMED_STATE           => \%orbit_01_00455_def,
   OC_TSF_COUNTER_VALUE         => \%orbit_01_00456_def,
   OC_TSF_TRIGGERED_STATE       => \%orbit_01_00457_def,
   OC_VEC_RDDATA                => \%orbit_01_00458_def,
   OC_VEC_RETURN                => \%orbit_01_00459_def,
   OC_VEC_STATUS                => \%orbit_01_00460_def,
   OC_VEC_STATUS_ALIAS          => \%orbit_01_00461_def,
   OC_LOGIC_ANALYZER_BUFFER     => \%orbit_01_00462_def,
   OC_THROTTLE_STATUS           => \%orbit_01_00463_def,
   OC_PERFORMANCE_COUNT0_CONTROL => \%orbit_01_00464_def,
   OC_PERFORMANCE_COUNT1_CONTROL => \%orbit_01_00465_def,
   OC_PERFORMANCE_COUNT2_CONTROL => \%orbit_01_00466_def,
   OC_PERFORMANCE_COUNT3_CONTROL => \%orbit_01_00467_def,
   OC_PERFORMANCE_COUNT4_CONTROL => \%orbit_01_00468_def,
   OC_PERFORMANCE_COUNT5_CONTROL => \%orbit_01_00469_def,
   OC_PERFORMANCE_COUNT6_CONTROL => \%orbit_01_00470_def,
   OC_PERFORMANCE_COUNT7_CONTROL => \%orbit_01_00471_def,
   OC_PROFILE_DN_CONTROL        => \%orbit_01_00472_def,
   OC_PROFILE_PEAK_CONTROL      => \%orbit_01_00473_def,
   OC_PROFILE_RANGE             => \%orbit_01_00474_def,
   OC_PROFILE_UP_CONTROL        => \%orbit_01_00475_def,
   OC_PERFORMANCE_MONITOR_DESKEW => \%orbit_01_00476_def,
   OC_PERFORMANCE_COUNTER0      => \%orbit_01_00477_def,
   OC_PERFORMANCE_COUNTER1      => \%orbit_01_00478_def,
   OC_PERFORMANCE_COUNTER2      => \%orbit_01_00479_def,
   OC_PERFORMANCE_COUNTER3      => \%orbit_01_00480_def,
   OC_PERFORMANCE_COUNTER4      => \%orbit_01_00481_def,
   OC_PERFORMANCE_COUNTER5      => \%orbit_01_00482_def,
   OC_PERFORMANCE_COUNTER6      => \%orbit_01_00483_def,
   OC_PERFORMANCE_COUNTER7      => \%orbit_01_00484_def,
   OC_PROFILE_COUNTER           => \%orbit_01_00485_def,
   OC_PROFILE_PEAK              => \%orbit_01_00486_def,
   OC_INT_CMPA                  => \%orbit_01_00487_def,
   OC_INT_CMPB                  => \%orbit_01_00488_def,
   OC_INT_CMPC                  => \%orbit_01_00489_def,
   OC_INT_CMPD                  => \%orbit_01_00490_def,
   OC_INT_PROF                  => \%orbit_01_00491_def,
   OC_RTC                       => \%orbit_01_00492_def,
   OC_SCRATCH0                  => \%orbit_01_00493_def,
   OC_SCRATCH0_ALIAS            => \%orbit_01_00494_def,
   OC_SCRATCH1                  => \%orbit_01_00495_def,
   OC_SCRATCH1_ALIAS            => \%orbit_01_00496_def,
   OC_SCRATCH2                  => \%orbit_01_00497_def,
   OC_SCRATCH2_ALIAS            => \%orbit_01_00498_def,
   OC_SCRATCH3                  => \%orbit_01_00499_def,
   OC_SCRATCH3_ALIAS            => \%orbit_01_00500_def,
   OC_SCRATCH4                  => \%orbit_01_00501_def,
   OC_SCRATCH4_ALIAS            => \%orbit_01_00502_def,
   OC_SCRATCH5                  => \%orbit_01_00503_def,
   OC_SCRATCH6                  => \%orbit_01_00504_def,
   OC_SCRATCH7                  => \%orbit_01_00505_def,
   OC_SCRATCH8                  => \%orbit_01_00506_def,
   OC_SCRATCH9                  => \%orbit_01_00507_def,
   OC_SCRATCH10                 => \%orbit_01_00508_def,
   OC_SCRATCH11                 => \%orbit_01_00509_def,
   OC_SCRATCH12                 => \%orbit_01_00510_def,
   OC_PI_MD2PI_REPLY_VC_CONFIG  => \%orbit_01_00511_def,
   OC_PI_MD2PI_REQUEST_VC_CONFIG => \%orbit_01_00512_def,
   OC_PI_XN2PI_REPLY_VC_CONFIG  => \%orbit_01_00513_def,
   OC_PI_XN2PI_REQUEST_VC_CONFIG => \%orbit_01_00514_def,
   OC_PI_PI2MD_REPLY_VC_STATUS  => \%orbit_01_00515_def,
   OC_PI_PI2MD_REQUEST_VC_STATUS => \%orbit_01_00516_def,
   OC_PI_PI2XN_REPLY_VC_STATUS  => \%orbit_01_00517_def,
   OC_PI_PI2XN_REQUEST_VC_STATUS => \%orbit_01_00518_def,
   OC_PI_MD2PI_REPLY_VC_STATUS  => \%orbit_01_00519_def,
   OC_PI_MD2PI_REQUEST_VC_STATUS => \%orbit_01_00520_def,
   OC_PI_XN2PI_REPLY_VC_STATUS  => \%orbit_01_00521_def,
   OC_PI_XN2PI_REQUEST_VC_STATUS => \%orbit_01_00522_def,
   OC_PI_EVENT_MASK             => \%orbit_01_00523_def,
   OC_PI_EVENT_SUMMARY          => \%orbit_01_00524_def,
   OC_PI_EVENT_SUMMARY_ALIAS    => \%orbit_01_00525_def,
   OC_PI_ERROR_SELECT           => \%orbit_01_00526_def,
   OC_PI_FIRST_ERROR            => \%orbit_01_00527_def,
   OC_PI_FIRST_ERROR_ALIAS      => \%orbit_01_00528_def,
   OC_PI_ERR_SPOOL0_ADDR        => \%orbit_01_00529_def,
   OC_PI_ERR_SPOOL1_ADDR        => \%orbit_01_00530_def,
   OC_PI_ERR_SPOOL2_ADDR        => \%orbit_01_00531_def,
   OC_PI_ERR_SPOOL3_ADDR        => \%orbit_01_00532_def,
   OC_PI_ERR_SPOOL_SIZE         => \%orbit_01_00533_def,
   OC_PI_ERR_SPOOL_MASK         => \%orbit_01_00534_def,
   OC_PI_ERR_SPOOL_COUNT_0_1    => \%orbit_01_00535_def,
   OC_PI_ERR_SPOOL_COUNT_2_3    => \%orbit_01_00536_def,
   OC_PI_ERR_SPOOL_COUNT_COMPARE_0_1 => \%orbit_01_00537_def,
   OC_PI_ERR_SPOOL_COUNT_COMPARE_2_3 => \%orbit_01_00538_def,
   OC_PI_TEST_POINT_COMPARE     => \%orbit_01_00539_def,
   OC_PI_TEST_POINT_SELECT      => \%orbit_01_00540_def,
   OC_PI_TEST_POINT_TRIGGER_SELECT => \%orbit_01_00541_def,
   OC_PI_HXB_TEST_POINT_COMPARE => \%orbit_01_00542_def,
   OC_PI_HXB_TEST_POINT_SELECT  => \%orbit_01_00543_def,
   OC_PI_HXB_TEST_POINT_TRIGGER_SELECT => \%orbit_01_00544_def,
   OC_PI_MD_RP_CRD_OFLOW_ERR    => \%orbit_01_00545_def,
   OC_PI_MD_RP_Q_OFLOW_ERR      => \%orbit_01_00546_def,
   OC_PI_MD_RQ_CRD_OFLOW_ERR    => \%orbit_01_00547_def,
   OC_PI_MD_RQ_Q_OFLOW_ERR      => \%orbit_01_00548_def,
   OC_PI_XN_RP_CRD_OFLOW_ERR    => \%orbit_01_00549_def,
   OC_PI_XN_RP_Q_OFLOW_ERR      => \%orbit_01_00550_def,
   OC_PI_XN_RQ_CRD_OFLOW_ERR    => \%orbit_01_00551_def,
   OC_PI_XN_RQ_Q_OFLOW_ERR      => \%orbit_01_00552_def,
   OC_PI_PI_DATA_WR_PATH_ERR    => \%orbit_01_00553_def,
   OC_PI_PI_DATA_RESP_PATH_ERR  => \%orbit_01_00554_def,
   OC_SYSTF_RESET_STATUS        => \%orbit_01_00555_def,
   OC_SYSTF_RESET_FORCE_SYNC_BACKFLAP => \%orbit_01_00556_def,
   OC_SYSTF_RESET_SEQ_DELAY0    => \%orbit_01_00557_def,
   OC_SYSTF_RESET_SEQ_DELAY1    => \%orbit_01_00558_def,
   OC_SYSTF_RESET_SEQ_DELAY2    => \%orbit_01_00559_def,
   OC_SYSTF_RESET_SEQ_DELAY3    => \%orbit_01_00560_def,
   OC_SYSTF_RESET_SEQ_DELAY4    => \%orbit_01_00561_def,
   OC_SYSTF_RESET_SEQ_DELAY5    => \%orbit_01_00562_def,
   OC_SYSTF_RESET_MODE_HW_CPU0  => \%orbit_01_00563_def,
   OC_SYSTF_RESET_MODE_HW_CPU1  => \%orbit_01_00564_def,
   OC_SYSTF_RESET_MODE_SW_CPU0  => \%orbit_01_00565_def,
   OC_SYSTF_RESET_MODE_SW_CPU1  => \%orbit_01_00566_def,
   OC_PI_SYSTF_ERROR_INJECTION  => \%orbit_01_00567_def,
   OC_PI_SYSTF_COMPARE_VALUE    => \%orbit_01_00568_def,
   OC_PI_SYSTF_COMPARE_MASK     => \%orbit_01_00569_def,
   OC_PI_DATA_TEST_POINT_COMPARE0 => \%orbit_01_00570_def,
   OC_PI_DATA_TEST_POINT_SELECT0 => \%orbit_01_00571_def,
   OC_PI_DATA_TEST_POINT_TRIGGER_SELECT0 => \%orbit_01_00572_def,
   OC_PI_DATA_TEST_POINT_COMPARE1 => \%orbit_01_00573_def,
   OC_PI_DATA_TEST_POINT_SELECT1 => \%orbit_01_00574_def,
   OC_PI_DATA_TEST_POINT_TRIGGER_SELECT1 => \%orbit_01_00575_def,
   OC_PI_DATA_TEST_POINT_COMPARE2 => \%orbit_01_00576_def,
   OC_PI_DATA_TEST_POINT_SELECT2 => \%orbit_01_00577_def,
   OC_PI_DATA_TEST_POINT_TRIGGER_SELECT2 => \%orbit_01_00578_def,
   OC_PI_ORBIT_CE_ERR           => \%orbit_01_00579_def,
   OC_PI_SYSTF_CE_ERR           => \%orbit_01_00580_def,
   OC_PI_ORBIT_UCE_ERR          => \%orbit_01_00581_def,
   OC_PI_SYSTF_UCE_ERR          => \%orbit_01_00582_def,
   OC_PI_BAD_REQUEST_ERR        => \%orbit_01_00583_def,
   OC_PI_BAD_DATA_ERR           => \%orbit_01_00584_def,
   OC_PI_BAD_STATE_RESP_ERR     => \%orbit_01_00585_def,
   OC_TFI_EVENT_TRIGGER         => \%orbit_01_00586_def,
   OC_PI_CRB_MESSAGE_CONTROL    => \%orbit_01_00587_def,
   OC_PI_CRB_NACK_LIMIT         => \%orbit_01_00588_def,
   OC_CRB_TIMEOUT_PRESCALE      => \%orbit_01_00589_def,
   OC_PI_CRB_TIMEOUT_CNTL       => \%orbit_01_00590_def,
   OC_PI_CRB_SUPPL_INIT         => \%orbit_01_00591_def,
   OC_PI_CRB_RD_FLW_CNTL        => \%orbit_01_00592_def,
   OC_PI_CRB_WR_FLW_CNTL        => \%orbit_01_00593_def,
   OC_PI_CRB_CDR_FLW_CNTL       => \%orbit_01_00594_def,
   OC_PI_CRB_NODE_PRESENT_TABLE => \%orbit_01_00595_def,
   OC_PI_CRB_AUTO_REPLY_ENABLE  => \%orbit_01_00596_def,
   OC_PI_CRB_PROC_REQ_HDR_COMPARE => \%orbit_01_00597_def,
   OC_PI_CRB_PROC_REQ_HDR_MASK  => \%orbit_01_00598_def,
   OC_PI_CRB_PROC_RSP_HDR_COMPARE => \%orbit_01_00599_def,
   OC_PI_CRB_PROC_RSP_HDR_MASK  => \%orbit_01_00600_def,
   OC_PI_CRB_SYS_REQ_HDR_COMPARE => \%orbit_01_00601_def,
   OC_PI_CRB_SYS_REQ_HDR_MASK   => \%orbit_01_00602_def,
   OC_PI_CRB_SYS_RSP_HDR_COMPARE => \%orbit_01_00603_def,
   OC_PI_CRB_SYS_RSP_HDR_MASK   => \%orbit_01_00604_def,
   OC_PI_CRB_MUX0_TP_SELECT     => \%orbit_01_00605_def,
   OC_PI_CRB_MUX0_TP_TRIGGER_SELECT => \%orbit_01_00606_def,
   OC_PI_CRB_MUX0_TP_COMPARE    => \%orbit_01_00607_def,
   OC_PI_CRB_MUX1_TP_SELECT     => \%orbit_01_00608_def,
   OC_PI_CRB_MUX1_TP_TRIGGER_SELECT => \%orbit_01_00609_def,
   OC_PI_CRB_MUX1_TP_COMPARE    => \%orbit_01_00610_def,
   OC_PI_CRB_MUX2_TP_SELECT     => \%orbit_01_00611_def,
   OC_PI_CRB_MUX2_TP_TRIGGER_SELECT => \%orbit_01_00612_def,
   OC_PI_CRB_MUX2_TP_COMPARE    => \%orbit_01_00613_def,
   OC_PI_CAM_ACCESS_CNTL        => \%orbit_01_00614_def,
   OC_PI_CAM_ADDRESS_DATA       => \%orbit_01_00615_def,
   OC_PI_CAM_MEM_DATA           => \%orbit_01_00616_def,
   OC_PI_CAM_STATE_DATA         => \%orbit_01_00617_def,
   OC_PI_MEM_RD_ACCESS_ERR      => \%orbit_01_00618_def,
   OC_PI_MEM_RD_SPURIOUS_MSG_ERR => \%orbit_01_00619_def,
   OC_PI_MEM_RD_DIR_ERR         => \%orbit_01_00620_def,
   OC_PI_MEM_RD_TO_ERR          => \%orbit_01_00621_def,
   OC_PI_MEM_RD_POISON_ERR      => \%orbit_01_00622_def,
   OC_PI_MEM_RD_NACK_CNT_ERR    => \%orbit_01_00623_def,
   OC_PI_MEM_RD_CORR_DATA_ERR   => \%orbit_01_00624_def,
   OC_PI_MEM_RD_UNCORR_DATA_ERR => \%orbit_01_00625_def,
   OC_PI_MEM_RD_PKT_LEN_ERR     => \%orbit_01_00626_def,
   OC_PI_MEM_WR_ACCESS_ERR      => \%orbit_01_00627_def,
   OC_PI_MEM_SPURIOUS_WR_MSG_ERR => \%orbit_01_00628_def,
   OC_PI_MEM_WR_DIR_ERR         => \%orbit_01_00629_def,
   OC_PI_MEM_WR_TO_ERR          => \%orbit_01_00630_def,
   OC_PI_MEM_WR_CORR_DATA_ERR   => \%orbit_01_00631_def,
   OC_PI_MEM_WR_UNCORR_DATA_ERR => \%orbit_01_00632_def,
   OC_PI_MEM_WR_PKT_LEN_ERR     => \%orbit_01_00633_def,
   OC_PI_PROC_MEM_REQ_TBL_MISS  => \%orbit_01_00634_def,
   OC_PI_SYS_MEM_REQ_TBL_MISS   => \%orbit_01_00635_def,
   OC_PI_SYS_MEM_RSP_TBL_MISS   => \%orbit_01_00636_def,
   OC_PI_RD_SYSSTATE_FIFO_ERR   => \%orbit_01_00637_def,
   OC_PI_INTV_SYSSTATE_FIFO_ERR => \%orbit_01_00638_def,
   OC_PI_INTV_TIMEOUT_ERR       => \%orbit_01_00639_def,
   OC_PI_CRB_BUF_ERR            => \%orbit_01_00640_def,
   OC_GFX_CREDIT_COUNT_0        => \%orbit_01_00641_def,
   OC_GFX_CREDIT_COUNT_1        => \%orbit_01_00642_def,
   OC_GFX_MODE_CNTRL_0          => \%orbit_01_00643_def,
   OC_GFX_MODE_CNTRL_1          => \%orbit_01_00644_def,
   OC_GFX_SKID_CREDIT_COUNT_0   => \%orbit_01_00645_def,
   OC_GFX_SKID_CREDIT_COUNT_1   => \%orbit_01_00646_def,
   OC_GFX_STALL_LIMIT_0         => \%orbit_01_00647_def,
   OC_GFX_STALL_LIMIT_1         => \%orbit_01_00648_def,
   OC_GFX_STALL_TIMER_0         => \%orbit_01_00649_def,
   OC_GFX_STALL_TIMER_1         => \%orbit_01_00650_def,
   OC_GFX_WINDOW_0              => \%orbit_01_00651_def,
   OC_GFX_WINDOW_1              => \%orbit_01_00652_def,
   OC_GFX_TIMEOUT_PRESCALE      => \%orbit_01_00653_def,
   OC_GFX_FIFO_LOW_H2O_MARK     => \%orbit_01_00654_def,
   OC_GFX_DFIFO_LOW_H2O_MARK    => \%orbit_01_00655_def,
   OC_PIO_TIMEOUT_PRESCALE      => \%orbit_01_00656_def,
   OC_PIO_FIFO_LOW_H2O_MARK     => \%orbit_01_00657_def,
   OC_NCOH_MESSAGE_CONTROL      => \%orbit_01_00658_def,
   OC_GFX_WRITE_STATUS_0        => \%orbit_01_00659_def,
   OC_GFX_WRITE_STATUS_1        => \%orbit_01_00660_def,
   OC_PIO_WRITE_STATUS_0        => \%orbit_01_00661_def,
   OC_PIO_WRITE_STATUS_1        => \%orbit_01_00662_def,
   OC_PIO_WRITE_STATUS_2        => \%orbit_01_00663_def,
   OC_PIO_WRITE_STATUS_3        => \%orbit_01_00664_def,
   OC_PIO_WRITE_STATUS_0_ALIAS  => \%orbit_01_00665_def,
   OC_PIO_WRITE_STATUS_1_ALIAS  => \%orbit_01_00666_def,
   OC_PIO_WRITE_STATUS_2_ALIAS  => \%orbit_01_00667_def,
   OC_PIO_WRITE_STATUS_3_ALIAS  => \%orbit_01_00668_def,
   OC_PI_IO_RD_ACCESS_ERR       => \%orbit_01_00669_def,
   OC_PI_IO_WR_ACCESS_ERR       => \%orbit_01_00670_def,
   OC_PI_IO_RD_SPURIOUS_MSG_ERR => \%orbit_01_00671_def,
   OC_PI_IO_WR_SPURIOUS_MSG_ERR => \%orbit_01_00672_def,
   OC_PI_IO_RD_TO_ERR           => \%orbit_01_00673_def,
   OC_PI_IO_WR_TO_ERR           => \%orbit_01_00674_def,
   OC_PI_IO_RD_CORR_DATA_ERR    => \%orbit_01_00675_def,
   OC_PI_IO_RD_UNCORR_DATA_ERR  => \%orbit_01_00676_def,
   OC_PI_IO_WR_CORR_DATA_ERR    => \%orbit_01_00677_def,
   OC_PI_IO_WR_UNCORR_DATA_ERR  => \%orbit_01_00678_def,
   OC_PI_IO_RD_PKT_LEN_ERR      => \%orbit_01_00679_def,
   OC_PI_IO_WR_PKT_LEN_ERR      => \%orbit_01_00680_def,
   OC_PI_PIO_FIFO_ERR           => \%orbit_01_00681_def,
   OC_PI_GFX_FIFO_ERR           => \%orbit_01_00682_def,
   OC_PI_NCRP_TEST_POINT_COMPARE => \%orbit_01_00683_def,
   OC_PI_NCRP_TEST_POINT_SELECT => \%orbit_01_00684_def,
   OC_PI_NCRP_TEST_POINT_TRIGGER_SELECT => \%orbit_01_00685_def,
   OC_NI0_LLP_STAT              => \%orbit_01_00686_def,
   OC_NI0_LLP_RESET             => \%orbit_01_00687_def,
   OC_NI0_LLP_RESET_EN          => \%orbit_01_00688_def,
   OC_NI0_LLP_CHAN_MODE         => \%orbit_01_00689_def,
   OC_NI0_LLP_CONFIG            => \%orbit_01_00690_def,
   OC_NI0_LLP_TEST_CTL          => \%orbit_01_00691_def,
   OC_NI0_LLP_CAPT_WD1          => \%orbit_01_00692_def,
   OC_NI0_LLP_CAPT_WD2          => \%orbit_01_00693_def,
   OC_NI0_LLP_CAPT_SBCB         => \%orbit_01_00694_def,
   OC_NI0_LLP_ERR               => \%orbit_01_00695_def,
   OC_NI1_LLP_STAT              => \%orbit_01_00696_def,
   OC_NI1_LLP_RESET             => \%orbit_01_00697_def,
   OC_NI1_LLP_RESET_EN          => \%orbit_01_00698_def,
   OC_NI1_LLP_CHAN_MODE         => \%orbit_01_00699_def,
   OC_NI1_LLP_CONFIG            => \%orbit_01_00700_def,
   OC_NI1_LLP_TEST_CTL          => \%orbit_01_00701_def,
   OC_NI1_LLP_CAPT_WD1          => \%orbit_01_00702_def,
   OC_NI1_LLP_CAPT_WD2          => \%orbit_01_00703_def,
   OC_NI1_LLP_CAPT_SBCB         => \%orbit_01_00704_def,
   OC_NI1_LLP_ERR               => \%orbit_01_00705_def,
   OC_XNNI0_LLP_DEBIT_FLOW      => \%orbit_01_00706_def,
   OC_XNNI0_LINK_0_FLOW         => \%orbit_01_00707_def,
   OC_XNNI0_LINK_1_FLOW         => \%orbit_01_00708_def,
   OC_XNNI0_LINK_2_FLOW         => \%orbit_01_00709_def,
   OC_XNNI0_LINK_3_FLOW         => \%orbit_01_00710_def,
   OC_XNNI1_LLP_DEBIT_FLOW      => \%orbit_01_00711_def,
   OC_XNNI1_LINK_0_FLOW         => \%orbit_01_00712_def,
   OC_XNNI1_LINK_1_FLOW         => \%orbit_01_00713_def,
   OC_XNNI1_LINK_2_FLOW         => \%orbit_01_00714_def,
   OC_XNNI1_LINK_3_FLOW         => \%orbit_01_00715_def,
   OC_IILB_LOCAL_TABLE          => \%orbit_01_00716_def,
   OC_IILB_GLOBAL_TABLE         => \%orbit_01_00717_def,
   OC_IILB_OVER_RIDE_TABLE      => \%orbit_01_00718_def,
   OC_PI_LOCAL_TABLE            => \%orbit_01_00719_def,
   OC_PI_GLOBAL_TABLE           => \%orbit_01_00720_def,
   OC_PI_OVER_RIDE_TABLE        => \%orbit_01_00721_def,
   OC_PI_RSP_PLANE_HINT         => \%orbit_01_00722_def,
   OC_NI0_LOCAL_TABLE           => \%orbit_01_00723_def,
   OC_NI0_GLOBAL_TABLE          => \%orbit_01_00724_def,
   OC_NI0_OVER_RIDE_TABLE       => \%orbit_01_00725_def,
   OC_NI1_LOCAL_TABLE           => \%orbit_01_00726_def,
   OC_NI1_GLOBAL_TABLE          => \%orbit_01_00727_def,
   OC_NI1_OVER_RIDE_TABLE       => \%orbit_01_00728_def,
   OC_MD_LOCAL_TABLE            => \%orbit_01_00729_def,
   OC_MD_GLOBAL_TABLE           => \%orbit_01_00730_def,
   OC_MD_OVER_RIDE_TABLE        => \%orbit_01_00731_def,
   OC_MD_RSP_PLANE_HINT         => \%orbit_01_00732_def,
   OC_XNPI_SIC_FLOW             => \%orbit_01_00733_def,
   OC_XNPI_TO_NI0_PORT_FLOW     => \%orbit_01_00734_def,
   OC_XNPI_TO_NI0_PORT_FLOW13   => \%orbit_01_00735_def,
   OC_XNPI_TO_NI1_PORT_FLOW     => \%orbit_01_00736_def,
   OC_XNPI_TO_NI1_PORT_FLOW13   => \%orbit_01_00737_def,
   OC_XNPI_TO_IILB_PORT_FLOW    => \%orbit_01_00738_def,
   OC_XNPI_ARB_CONFIG           => \%orbit_01_00739_def,
   OC_XNPI_LOCAL_AGE0           => \%orbit_01_00740_def,
   OC_XNPI_LOCAL_AGE1           => \%orbit_01_00741_def,
   OC_XNPI_STEERING_FIFO        => \%orbit_01_00742_def,
   OC_XNPI_CREDIT_MGR_VC0       => \%orbit_01_00743_def,
   OC_XNPI_CREDIT_MGR_VC2       => \%orbit_01_00744_def,
   OC_XNMD_SIC_FLOW             => \%orbit_01_00745_def,
   OC_XNMD_TO_NI0_PORT_FLOW     => \%orbit_01_00746_def,
   OC_XNMD_TO_NI0_PORT_FLOW13   => \%orbit_01_00747_def,
   OC_XNMD_TO_NI1_PORT_FLOW     => \%orbit_01_00748_def,
   OC_XNMD_TO_NI1_PORT_FLOW13   => \%orbit_01_00749_def,
   OC_XNMD_TO_IILB_PORT_FLOW    => \%orbit_01_00750_def,
   OC_XNMD_ARB_CONFIG           => \%orbit_01_00751_def,
   OC_XNMD_LOCAL_AGE0           => \%orbit_01_00752_def,
   OC_XNMD_LOCAL_AGE1           => \%orbit_01_00753_def,
   OC_XNMD_STEERING_FIFO        => \%orbit_01_00754_def,
   OC_XNMD_CREDIT_MGR_VC0       => \%orbit_01_00755_def,
   OC_XNMD_CREDIT_MGR_VC2       => \%orbit_01_00756_def,
   OC_XNII_INTRA_FLOW           => \%orbit_01_00757_def,
   OC_XNLB_INTRA_FLOW           => \%orbit_01_00758_def,
   OC_XNIILB_TO_NI0_INTRA_FLOW_DEBIT => \%orbit_01_00759_def,
   OC_XNIILB_TO_NI0_INTRA_FLOW_DEBIT13 => \%orbit_01_00760_def,
   OC_XNIILB_TO_NI1_INTRA_FLOW_DEBIT => \%orbit_01_00761_def,
   OC_XNIILB_TO_NI1_INTRA_FLOW_DEBIT13 => \%orbit_01_00762_def,
   OC_XNIILB_TO_IILB_INTRA_FLOW_DEBIT => \%orbit_01_00763_def,
   OC_XNIILB_FR_NI0_INTRA_FLOW_CREDIT => \%orbit_01_00764_def,
   OC_XNIILB_FR_NI1_INTRA_FLOW_CREDIT => \%orbit_01_00765_def,
   OC_XNIILB_FR_IILB_INTRA_FLOW_CREDIT => \%orbit_01_00766_def,
   OC_XNIILB_II_FIFO_CREDIT_CNT => \%orbit_01_00767_def,
   OC_XNIILB_LB_FIFO_CREDIT_CNT => \%orbit_01_00768_def,
   OC_XNIILB_ARB_CONFIG_SI      => \%orbit_01_00769_def,
   OC_XNIILB_ARB_CONFIG_SO      => \%orbit_01_00770_def,
   OC_XNIILB_AGE_WRAP0          => \%orbit_01_00771_def,
   OC_XNIILB_AGE_WRAP1          => \%orbit_01_00772_def,
   OC_XNIILB_AGE_WRAP2          => \%orbit_01_00773_def,
   OC_XNIILB_TO_PI_INTRA_FLOW_SIC_DEBIT_VC0 => \%orbit_01_00774_def,
   OC_XNIILB_TO_PI_INTRA_FLOW_SIC_DEBIT_VC2 => \%orbit_01_00775_def,
   OC_XNIILB_TO_MD_INTRA_FLOW_SIC_DEBIT_VC0 => \%orbit_01_00776_def,
   OC_XNIILB_TO_MD_INTRA_FLOW_SIC_DEBIT_VC2 => \%orbit_01_00777_def,
   OC_XNIILB_FR_MD_INTRA_FLOW_CREDIT => \%orbit_01_00778_def,
   OC_XNIILB_FR_PI_INTRA_FLOW_CREDIT => \%orbit_01_00779_def,
   OC_XNNI0_TO_IILB_INTRA_FLOW_DEBIT => \%orbit_01_00780_def,
   OC_XNNI0_TO_PI_INTRA_FLOW_SIC_DEBIT_VC0 => \%orbit_01_00781_def,
   OC_XNNI0_TO_PI_INTRA_FLOW_SIC_DEBIT_VC2 => \%orbit_01_00782_def,
   OC_XNNI0_TO_MD_INTRA_FLOW_SIC_DEBIT_VC0 => \%orbit_01_00783_def,
   OC_XNNI0_TO_MD_INTRA_FLOW_SIC_DEBIT_VC2 => \%orbit_01_00784_def,
   OC_XNNI0_0_INTRANI_FLOW      => \%orbit_01_00785_def,
   OC_XNNI0_1_INTRANI_FLOW      => \%orbit_01_00786_def,
   OC_XNNI0_2_INTRANI_FLOW      => \%orbit_01_00787_def,
   OC_XNNI0_3_INTRANI_FLOW      => \%orbit_01_00788_def,
   OC_XNNI0_VCSWITCH_FLOW       => \%orbit_01_00789_def,
   OC_XNNI0_TIMER_REG           => \%orbit_01_00790_def,
   OC_XNNI0_IILB_TAILTO         => \%orbit_01_00791_def,
   OC_XNNI0_NI_TAILTO           => \%orbit_01_00792_def,
   OC_XNNI0_NI_TAILTO_SUPPORT   => \%orbit_01_00793_def,
   OC_XNNI0_PI_TAILTO           => \%orbit_01_00794_def,
   OC_XNNI0_MD_TAILTO           => \%orbit_01_00795_def,
   OC_XNNI0_DEADLCK_FLOW        => \%orbit_01_00796_def,
   OC_XNNI0_DEADLCK_FLOW_SUPPORT => \%orbit_01_00797_def,
   OC_XNNI0_INJECT_AGE          => \%orbit_01_00798_def,
   OC_XNNI0_NETWORK_AGE         => \%orbit_01_00799_def,
   OC_XNNI0_ARB_CONFIG          => \%orbit_01_00800_def,
   OC_XNNI0_LOCAL_AGE0          => \%orbit_01_00801_def,
   OC_XNNI0_LOCAL_AGE1          => \%orbit_01_00802_def,
   OC_XNNI0_QUEUE_CNTR          => \%orbit_01_00803_def,
   OC_XNNI1_TO_IILB_INTRA_FLOW_DEBIT => \%orbit_01_00804_def,
   OC_XNNI1_TO_PI_INTRA_FLOW_SIC_DEBIT_VC0 => \%orbit_01_00805_def,
   OC_XNNI1_TO_PI_INTRA_FLOW_SIC_DEBIT_VC2 => \%orbit_01_00806_def,
   OC_XNNI1_TO_MD_INTRA_FLOW_SIC_DEBIT_VC0 => \%orbit_01_00807_def,
   OC_XNNI1_TO_MD_INTRA_FLOW_SIC_DEBIT_VC2 => \%orbit_01_00808_def,
   OC_XNNI1_0_INTRANI_FLOW      => \%orbit_01_00809_def,
   OC_XNNI1_1_INTRANI_FLOW      => \%orbit_01_00810_def,
   OC_XNNI1_2_INTRANI_FLOW      => \%orbit_01_00811_def,
   OC_XNNI1_3_INTRANI_FLOW      => \%orbit_01_00812_def,
   OC_XNNI1_VCSWITCH_FLOW       => \%orbit_01_00813_def,
   OC_XNNI1_TIMER_REG           => \%orbit_01_00814_def,
   OC_XNNI1_IILB_TAILTO         => \%orbit_01_00815_def,
   OC_XNNI1_NI_TAILTO           => \%orbit_01_00816_def,
   OC_XNNI1_NI_TAILTO_SUPPORT   => \%orbit_01_00817_def,
   OC_XNNI1_PI_TAILTO           => \%orbit_01_00818_def,
   OC_XNNI1_MD_TAILTO           => \%orbit_01_00819_def,
   OC_XNNI1_DEADLCK_FLOW        => \%orbit_01_00820_def,
   OC_XNNI1_DEADLCK_FLOW_SUPPORT => \%orbit_01_00821_def,
   OC_XNNI1_INJECT_AGE          => \%orbit_01_00822_def,
   OC_XNNI1_NETWORK_AGE         => \%orbit_01_00823_def,
   OC_XNNI1_ARB_CONFIG          => \%orbit_01_00824_def,
   OC_XNNI1_LOCAL_AGE0          => \%orbit_01_00825_def,
   OC_XNNI1_LOCAL_AGE1          => \%orbit_01_00826_def,
   OC_XNNI1_QUEUE_CNTR          => \%orbit_01_00827_def,
   OC_XN_DEBUG_SEL              => \%orbit_01_00828_def,
   OC_XN_DEBUG_TRIG_SEL         => \%orbit_01_00829_def,
   OC_XN_TRIGGER_COMPARE        => \%orbit_01_00830_def,
   OC_XN_TRIGGER_DATA           => \%orbit_01_00831_def,
   OC_XN_IILB_DEBUG_SEL         => \%orbit_01_00832_def,
   OC_XN_IILB_LB_CMP_EXP_DATA0  => \%orbit_01_00833_def,
   OC_XN_IILB_LB_CMP_EXP_DATA1  => \%orbit_01_00834_def,
   OC_XN_IILB_LB_CMP_ENABLE0    => \%orbit_01_00835_def,
   OC_XN_IILB_LB_CMP_ENABLE1    => \%orbit_01_00836_def,
   OC_XN_IILB_II_CMP_EXP_DATA0  => \%orbit_01_00837_def,
   OC_XN_IILB_II_CMP_EXP_DATA1  => \%orbit_01_00838_def,
   OC_XN_IILB_II_CMP_ENABLE0    => \%orbit_01_00839_def,
   OC_XN_IILB_II_CMP_ENABLE1    => \%orbit_01_00840_def,
   OC_XN_IILB_MD_HDR_CMP_EXP_DATA0 => \%orbit_01_00841_def,
   OC_XN_IILB_MD_HDR_CMP_EXP_DATA1 => \%orbit_01_00842_def,
   OC_XN_IILB_MD_HDR_CMP_ENABLE0 => \%orbit_01_00843_def,
   OC_XN_IILB_MD_HDR_CMP_ENABLE1 => \%orbit_01_00844_def,
   OC_XN_IILB_PI_CMP_EXP_DATA0  => \%orbit_01_00845_def,
   OC_XN_IILB_PI_CMP_EXP_DATA1  => \%orbit_01_00846_def,
   OC_XN_IILB_PI_CMP_ENABLE0    => \%orbit_01_00847_def,
   OC_XN_IILB_PI_CMP_ENABLE1    => \%orbit_01_00848_def,
   OC_XN_IILB_NI0_CMP_EXP_DATA0 => \%orbit_01_00849_def,
   OC_XN_IILB_NI0_CMP_EXP_DATA1 => \%orbit_01_00850_def,
   OC_XN_IILB_NI0_CMP_ENABLE0   => \%orbit_01_00851_def,
   OC_XN_IILB_NI0_CMP_ENABLE1   => \%orbit_01_00852_def,
   OC_XN_IILB_NI1_CMP_EXP_DATA0 => \%orbit_01_00853_def,
   OC_XN_IILB_NI1_CMP_EXP_DATA1 => \%orbit_01_00854_def,
   OC_XN_IILB_NI1_CMP_ENABLE0   => \%orbit_01_00855_def,
   OC_XN_IILB_NI1_CMP_ENABLE1   => \%orbit_01_00856_def,
   OC_XN_NI0_DEBUG_SEL          => \%orbit_01_00857_def,
   OC_XN_NI0_IILB_CMP_EXP_DATA0 => \%orbit_01_00858_def,
   OC_XN_NI0_IILB_CMP_EXP_DATA1 => \%orbit_01_00859_def,
   OC_XN_NI0_IILB_CMP_ENABLE0   => \%orbit_01_00860_def,
   OC_XN_NI0_IILB_CMP_ENABLE1   => \%orbit_01_00861_def,
   OC_XN_NI0_PI_CMP_EXP_DATA0   => \%orbit_01_00862_def,
   OC_XN_NI0_PI_CMP_EXP_DATA1   => \%orbit_01_00863_def,
   OC_XN_NI0_PI_CMP_ENABLE0     => \%orbit_01_00864_def,
   OC_XN_NI0_PI_CMP_ENABLE1     => \%orbit_01_00865_def,
   OC_XN_NI0_NI_CMP_EXP_DATA0   => \%orbit_01_00866_def,
   OC_XN_NI0_NI_CMP_EXP_DATA1   => \%orbit_01_00867_def,
   OC_XN_NI0_NI_CMP_ENABLE0     => \%orbit_01_00868_def,
   OC_XN_NI0_NI_CMP_ENABLE1     => \%orbit_01_00869_def,
   OC_XN_NI0_LLP_CMP_EXP_DATA0  => \%orbit_01_00870_def,
   OC_XN_NI0_LLP_CMP_EXP_DATA1  => \%orbit_01_00871_def,
   OC_XN_NI0_LLP_CMP_ENABLE0    => \%orbit_01_00872_def,
   OC_XN_NI0_LLP_CMP_ENABLE1    => \%orbit_01_00873_def,
   OC_XN_NI0_MD_CMP_EXP_HDR0    => \%orbit_01_00874_def,
   OC_XN_NI0_MD_CMP_EXP_HDR1    => \%orbit_01_00875_def,
   OC_XN_NI0_MD_CMP_HDR_ENABLE0 => \%orbit_01_00876_def,
   OC_XN_NI0_MD_CMP_HDR_ENABLE1 => \%orbit_01_00877_def,
   OC_XN_NI1_DEBUG_SEL          => \%orbit_01_00878_def,
   OC_XN_NI1_IILB_CMP_EXP_DATA0 => \%orbit_01_00879_def,
   OC_XN_NI1_IILB_CMP_EXP_DATA1 => \%orbit_01_00880_def,
   OC_XN_NI1_IILB_CMP_ENABLE0   => \%orbit_01_00881_def,
   OC_XN_NI1_IILB_CMP_ENABLE1   => \%orbit_01_00882_def,
   OC_XN_NI1_PI_CMP_EXP_DATA0   => \%orbit_01_00883_def,
   OC_XN_NI1_PI_CMP_EXP_DATA1   => \%orbit_01_00884_def,
   OC_XN_NI1_PI_CMP_ENABLE0     => \%orbit_01_00885_def,
   OC_XN_NI1_PI_CMP_ENABLE1     => \%orbit_01_00886_def,
   OC_XN_NI1_NI_CMP_EXP_DATA0   => \%orbit_01_00887_def,
   OC_XN_NI1_NI_CMP_EXP_DATA1   => \%orbit_01_00888_def,
   OC_XN_NI1_NI_CMP_ENABLE0     => \%orbit_01_00889_def,
   OC_XN_NI1_NI_CMP_ENABLE1     => \%orbit_01_00890_def,
   OC_XN_NI1_LLP_CMP_EXP_DATA0  => \%orbit_01_00891_def,
   OC_XN_NI1_LLP_CMP_EXP_DATA1  => \%orbit_01_00892_def,
   OC_XN_NI1_LLP_CMP_ENABLE0    => \%orbit_01_00893_def,
   OC_XN_NI1_LLP_CMP_ENABLE1    => \%orbit_01_00894_def,
   OC_XN_NI1_MD_CMP_EXP_HDR0    => \%orbit_01_00895_def,
   OC_XN_NI1_MD_CMP_EXP_HDR1    => \%orbit_01_00896_def,
   OC_XN_NI1_MD_CMP_HDR_ENABLE0 => \%orbit_01_00897_def,
   OC_XN_NI1_MD_CMP_HDR_ENABLE1 => \%orbit_01_00898_def,
   OC_XN_PI_DEBUG_SEL           => \%orbit_01_00899_def,
   OC_XN_PI_IILB_CMP_EXP_DATA0  => \%orbit_01_00900_def,
   OC_XN_PI_IILB_CMP_EXP_DATA1  => \%orbit_01_00901_def,
   OC_XN_PI_IILB_CMP_ENABLE0    => \%orbit_01_00902_def,
   OC_XN_PI_IILB_CMP_ENABLE1    => \%orbit_01_00903_def,
   OC_XN_PI_NI0_CMP_EXP_DATA0   => \%orbit_01_00904_def,
   OC_XN_PI_NI0_CMP_EXP_DATA1   => \%orbit_01_00905_def,
   OC_XN_PI_NI0_CMP_ENABLE0     => \%orbit_01_00906_def,
   OC_XN_PI_NI0_CMP_ENABLE1     => \%orbit_01_00907_def,
   OC_XN_PI_NI1_CMP_EXP_DATA0   => \%orbit_01_00908_def,
   OC_XN_PI_NI1_CMP_EXP_DATA1   => \%orbit_01_00909_def,
   OC_XN_PI_NI1_CMP_ENABLE0     => \%orbit_01_00910_def,
   OC_XN_PI_NI1_CMP_ENABLE1     => \%orbit_01_00911_def,
   OC_XN_PI_SICN_CMP_DATA0      => \%orbit_01_00912_def,
   OC_XN_PI_SICN_CMP_DATA1      => \%orbit_01_00913_def,
   OC_XN_PI_SICN_CMP_DATA_ENABLE0 => \%orbit_01_00914_def,
   OC_XN_PI_SICN_CMP_DATA_ENABLE1 => \%orbit_01_00915_def,
   OC_XN_MD_DEBUG_SEL           => \%orbit_01_00916_def,
   OC_XN_MD_IILB_CMP_EXP_DATA0  => \%orbit_01_00917_def,
   OC_XN_MD_IILB_CMP_EXP_DATA1  => \%orbit_01_00918_def,
   OC_XN_MD_IILB_CMP_ENABLE0    => \%orbit_01_00919_def,
   OC_XN_MD_IILB_CMP_ENABLE1    => \%orbit_01_00920_def,
   OC_XN_MD_NI0_CMP_EXP_DATA0   => \%orbit_01_00921_def,
   OC_XN_MD_NI0_CMP_EXP_DATA1   => \%orbit_01_00922_def,
   OC_XN_MD_NI0_CMP_ENABLE0     => \%orbit_01_00923_def,
   OC_XN_MD_NI0_CMP_ENABLE1     => \%orbit_01_00924_def,
   OC_XN_MD_NI1_CMP_EXP_DATA0   => \%orbit_01_00925_def,
   OC_XN_MD_NI1_CMP_EXP_DATA1   => \%orbit_01_00926_def,
   OC_XN_MD_NI1_CMP_ENABLE0     => \%orbit_01_00927_def,
   OC_XN_MD_NI1_CMP_ENABLE1     => \%orbit_01_00928_def,
   OC_XN_MD_SIC_CMP_EXP_HDR0    => \%orbit_01_00929_def,
   OC_XN_MD_SIC_CMP_EXP_HDR1    => \%orbit_01_00930_def,
   OC_XN_MD_SIC_CMP_HDR_ENABLE0 => \%orbit_01_00931_def,
   OC_XN_MD_SIC_CMP_HDR_ENABLE1 => \%orbit_01_00932_def,
   OC_XNMD_ECC_INJ_REG          => \%orbit_01_00933_def,
   OC_XNMD_ECC0_INJ_MASK_REG    => \%orbit_01_00934_def,
   OC_XNMD_ECC1_INJ_MASK_REG    => \%orbit_01_00935_def,
   OC_XNMD_ECC2_INJ_MASK_REG    => \%orbit_01_00936_def,
   OC_XNMD_ECC3_INJ_MASK_REG    => \%orbit_01_00937_def,
   OC_XNMD_ECC_ERR_REPORT       => \%orbit_01_00938_def,
   OC_NI0_ERROR_SUMMARY_1       => \%orbit_01_00939_def,
   OC_NI0_ERROR_SUMMARY_1_ALIAS => \%orbit_01_00940_def,
   OC_NI0_ERROR_SUMMARY_2       => \%orbit_01_00941_def,
   OC_NI0_ERROR_SUMMARY_2_ALIAS => \%orbit_01_00942_def,
   OC_NI0_ERROR_OVERFLOW_1      => \%orbit_01_00943_def,
   OC_NI0_ERROR_OVERFLOW_1_ALIAS => \%orbit_01_00944_def,
   OC_NI0_ERROR_OVERFLOW_2      => \%orbit_01_00945_def,
   OC_NI0_ERROR_OVERFLOW_2_ALIAS => \%orbit_01_00946_def,
   OC_NI0_ERROR_MASK_1          => \%orbit_01_00947_def,
   OC_NI0_ERROR_MASK_2          => \%orbit_01_00948_def,
   OC_NI0_FIRST_ERROR_1         => \%orbit_01_00949_def,
   OC_NI0_FIRST_ERROR_2         => \%orbit_01_00950_def,
   OC_NI0_ERROR_DETAIL_1        => \%orbit_01_00951_def,
   OC_NI0_ERROR_DETAIL_2        => \%orbit_01_00952_def,
   OC_NI1_ERROR_SUMMARY_1       => \%orbit_01_00953_def,
   OC_NI1_ERROR_SUMMARY_1_ALIAS => \%orbit_01_00954_def,
   OC_NI1_ERROR_SUMMARY_2       => \%orbit_01_00955_def,
   OC_NI1_ERROR_SUMMARY_2_ALIAS => \%orbit_01_00956_def,
   OC_NI1_ERROR_OVERFLOW_1      => \%orbit_01_00957_def,
   OC_NI1_ERROR_OVERFLOW_1_ALIAS => \%orbit_01_00958_def,
   OC_NI1_ERROR_OVERFLOW_2      => \%orbit_01_00959_def,
   OC_NI1_ERROR_OVERFLOW_2_ALIAS => \%orbit_01_00960_def,
   OC_NI1_ERROR_MASK_1          => \%orbit_01_00961_def,
   OC_NI1_ERROR_MASK_2          => \%orbit_01_00962_def,
   OC_NI1_FIRST_ERROR_1         => \%orbit_01_00963_def,
   OC_NI1_FIRST_ERROR_2         => \%orbit_01_00964_def,
   OC_NI1_ERROR_DETAIL_1        => \%orbit_01_00965_def,
   OC_NI1_ERROR_DETAIL_2        => \%orbit_01_00966_def,
   OC_XN_CORRECTED_DETAIL_1     => \%orbit_01_00967_def,
   OC_XN_CORRECTED_DETAIL_2A    => \%orbit_01_00968_def,
   OC_XN_CORRECTED_DETAIL_2B    => \%orbit_01_00969_def,
   OC_XN_CORRECTED_DETAIL_3     => \%orbit_01_00970_def,
   OC_XN_CORRECTED_DETAIL_4     => \%orbit_01_00971_def,
   OC_XN_UNCORRECTED_DETAIL_1   => \%orbit_01_00972_def,
   OC_XN_UNCORRECTED_DETAIL_2A  => \%orbit_01_00973_def,
   OC_XN_UNCORRECTED_DETAIL_2B  => \%orbit_01_00974_def,
   OC_XN_UNCORRECTED_DETAIL_3   => \%orbit_01_00975_def,
   OC_XN_UNCORRECTED_DETAIL_4   => \%orbit_01_00976_def,
   OC_XNMD_ERROR_DETAIL_1       => \%orbit_01_00977_def,
   OC_XNPI_ERROR_DETAIL_1       => \%orbit_01_00978_def,
   OC_XNIILB_ERROR_DETAIL_1     => \%orbit_01_00979_def,
   OC_XNIILB_ERROR_DETAIL_2     => \%orbit_01_00980_def,
   OC_XNIILB_ERROR_DETAIL_3     => \%orbit_01_00981_def,
   OC_NI0_ERROR_DETAIL_3        => \%orbit_01_00982_def,
   OC_NI1_ERROR_DETAIL_3        => \%orbit_01_00983_def,
   OC_XN_ERROR_SUMMARY          => \%orbit_01_00984_def,
   OC_XN_ERRORS_ALIAS           => \%orbit_01_00985_def,
   OC_XN_ERROR_OVERFLOW         => \%orbit_01_00986_def,
   OC_XN_ERROR_OVERFLOW_ALIAS   => \%orbit_01_00987_def,
   OC_XN_ERROR_MASK             => \%orbit_01_00988_def,
   OC_XN_FIRST_ERROR            => \%orbit_01_00989_def,
   OC_XNIILB_ERROR_SUMMARY      => \%orbit_01_00990_def,
   OC_XNIILB_ERRORS_ALIAS       => \%orbit_01_00991_def,
   OC_XNIILB_ERROR_OVERFLOW     => \%orbit_01_00992_def,
   OC_XNIILB_ERROR_OVERFLOW_ALIAS => \%orbit_01_00993_def,
   OC_XNIILB_ERROR_MASK         => \%orbit_01_00994_def,
   OC_XNIILB_FIRST_ERROR        => \%orbit_01_00995_def,
   OC_XNIILB_ERRORS_SUMMARY_1   => \%orbit_01_00996_def,
   OC_XNIILB_ERRORS_ALIAS_1     => \%orbit_01_00997_def,
   OC_XNIILB_ERROR_OVERFLOW_1   => \%orbit_01_00998_def,
   OC_XNIILB_ERROR_OVERFLOW_ALIAS_1 => \%orbit_01_00999_def,
   OC_XNIILB_ERROR_MASK_1       => \%orbit_01_01000_def,
   OC_XNIILB_FIRST_ERROR_1      => \%orbit_01_01001_def,
   OC_XNPI_ERROR_SUMMARY        => \%orbit_01_01002_def,
   OC_XNPI_ERRORS_ALIAS         => \%orbit_01_01003_def,
   OC_XNPI_ERROR_OVERFLOW       => \%orbit_01_01004_def,
   OC_XNPI_ERROR_OVERFLOW_ALIAS => \%orbit_01_01005_def,
   OC_XNPI_ERROR_MASK           => \%orbit_01_01006_def,
   OC_XNPI_FIRST_ERROR          => \%orbit_01_01007_def,
   OC_XNMD_ERROR_SUMMARY        => \%orbit_01_01008_def,
   OC_XNMD_ERRORS_ALIAS         => \%orbit_01_01009_def,
   OC_XNMD_ERROR_OVERFLOW       => \%orbit_01_01010_def,
   OC_XNMD_ERROR_OVERFLOW_ALIAS => \%orbit_01_01011_def,
   OC_XNMD_ERROR_MASK           => \%orbit_01_01012_def,
   OC_XNMD_FIRST_ERROR          => \%orbit_01_01013_def,
);

%orbit_01_mmr_by_addr = 
(
   0x0000000080000080 => \%orbit_01_00000_def,
   0x0000000080000088 => \%orbit_01_00001_def,
   0x0000000080000090 => \%orbit_01_00002_def,
   0x0000000080000098 => \%orbit_01_00003_def,
   0x00000000800000A0 => \%orbit_01_00004_def,
   0x00000000800000A8 => \%orbit_01_00005_def,
   0x00000000800000B0 => \%orbit_01_00006_def,
   0x00000000800000B8 => \%orbit_01_00007_def,
   0x00000000800000C0 => \%orbit_01_00008_def,
   0x00000000800000C8 => \%orbit_01_00009_def,
   0x00000000800000D0 => \%orbit_01_00010_def,
   0x00000000800000D8 => \%orbit_01_00011_def,
   0x00000000800000E0 => \%orbit_01_00012_def,
   0x00000000800000E8 => \%orbit_01_00013_def,
   0x00000000800000F0 => \%orbit_01_00014_def,
   0x0000000080010000 => \%orbit_01_00015_def,
   0x0000000080010008 => \%orbit_01_00016_def,
   0x0000000080010010 => \%orbit_01_00017_def,
   0x0000000080010018 => \%orbit_01_00018_def,
   0x0000000080010020 => \%orbit_01_00019_def,
   0x0000000080010028 => \%orbit_01_00020_def,
   0x0000000080010030 => \%orbit_01_00021_def,
   0x0000000080010038 => \%orbit_01_00022_def,
   0x0000000080010040 => \%orbit_01_00023_def,
   0x0000000080010048 => \%orbit_01_00024_def,
   0x0000000080010050 => \%orbit_01_00025_def,
   0x0000000080010058 => \%orbit_01_00026_def,
   0x0000000080010060 => \%orbit_01_00027_def,
   0x0000000080010068 => \%orbit_01_00028_def,
   0x0000000080010070 => \%orbit_01_00029_def,
   0x0000000080010078 => \%orbit_01_00030_def,
   0x0000000080010080 => \%orbit_01_00031_def,
   0x0000000080010088 => \%orbit_01_00032_def,
   0x0000000080010090 => \%orbit_01_00033_def,
   0x0000000080010098 => \%orbit_01_00034_def,
   0x00000000800100A0 => \%orbit_01_00035_def,
   0x00000000800100A8 => \%orbit_01_00036_def,
   0x0000000080020000 => \%orbit_01_00037_def,
   0x0000000080020008 => \%orbit_01_00038_def,
   0x0000000080020010 => \%orbit_01_00039_def,
   0x0000000080020018 => \%orbit_01_00040_def,
   0x0000000080020020 => \%orbit_01_00041_def,
   0x0000000080020028 => \%orbit_01_00042_def,
   0x0000000080020030 => \%orbit_01_00043_def,
   0x0000000080020038 => \%orbit_01_00044_def,
   0x0000000080020040 => \%orbit_01_00045_def,
   0x0000000080020048 => \%orbit_01_00046_def,
   0x0000000080020050 => \%orbit_01_00047_def,
   0x0000000080020058 => \%orbit_01_00048_def,
   0x0000000080020060 => \%orbit_01_00049_def,
   0x0000000080020068 => \%orbit_01_00050_def,
   0x0000000080020070 => \%orbit_01_00051_def,
   0x0000000080020078 => \%orbit_01_00052_def,
   0x0000000080020080 => \%orbit_01_00053_def,
   0x0000000080020088 => \%orbit_01_00054_def,
   0x0000000080020100 => \%orbit_01_00055_def,
   0x0000000080020108 => \%orbit_01_00056_def,
   0x0000000080020110 => \%orbit_01_00057_def,
   0x0000000080020118 => \%orbit_01_00058_def,
   0x0000000080020120 => \%orbit_01_00059_def,
   0x0000000080020128 => \%orbit_01_00060_def,
   0x0000000080020130 => \%orbit_01_00061_def,
   0x0000000080020138 => \%orbit_01_00062_def,
   0x0000000080020140 => \%orbit_01_00063_def,
   0x0000000080020148 => \%orbit_01_00064_def,
   0x0000000080020150 => \%orbit_01_00065_def,
   0x0000000080020158 => \%orbit_01_00066_def,
   0x0000000080020160 => \%orbit_01_00067_def,
   0x0000000080020168 => \%orbit_01_00068_def,
   0x0000000080020170 => \%orbit_01_00069_def,
   0x0000000080020178 => \%orbit_01_00070_def,
   0x0000000080020180 => \%orbit_01_00071_def,
   0x0000000080020188 => \%orbit_01_00072_def,
   0x0000000080020190 => \%orbit_01_00073_def,
   0x0000000080020198 => \%orbit_01_00074_def,
   0x00000000800201A0 => \%orbit_01_00075_def,
   0x00000000800201A8 => \%orbit_01_00076_def,
   0x00000000800201B0 => \%orbit_01_00077_def,
   0x00000000800201B8 => \%orbit_01_00078_def,
   0x00000000800201C0 => \%orbit_01_00079_def,
   0x00000000800201C8 => \%orbit_01_00080_def,
   0x00000000800201D0 => \%orbit_01_00081_def,
   0x00000000800201D8 => \%orbit_01_00082_def,
   0x00000000800201E0 => \%orbit_01_00083_def,
   0x0000000080020300 => \%orbit_01_00084_def,
   0x0000000080020308 => \%orbit_01_00085_def,
   0x0000000080020310 => \%orbit_01_00086_def,
   0x0000000080020318 => \%orbit_01_00087_def,
   0x0000000080030000 => \%orbit_01_00088_def,
   0x0000000080030100 => \%orbit_01_00089_def,
   0x0000000080030110 => \%orbit_01_00090_def,
   0x0000000080030120 => \%orbit_01_00091_def,
   0x0000000080030130 => \%orbit_01_00092_def,
   0x0000000080030200 => \%orbit_01_00093_def,
   0x0000000080030210 => \%orbit_01_00094_def,
   0x0000000080030220 => \%orbit_01_00095_def,
   0x0000000080030230 => \%orbit_01_00096_def,
   0x0000000080030240 => \%orbit_01_00097_def,
   0x0000000080030250 => \%orbit_01_00098_def,
   0x0000000080030260 => \%orbit_01_00099_def,
   0x0000000080030270 => \%orbit_01_00100_def,
   0x0000000080030300 => \%orbit_01_00101_def,
   0x0000000080030310 => \%orbit_01_00102_def,
   0x0000000080030320 => \%orbit_01_00103_def,
   0x0000000080030330 => \%orbit_01_00104_def,
   0x0000000080030340 => \%orbit_01_00105_def,
   0x0000000080030350 => \%orbit_01_00106_def,
   0x0000000080030360 => \%orbit_01_00107_def,
   0x0000000080030370 => \%orbit_01_00108_def,
   0x0000000080030400 => \%orbit_01_00109_def,
   0x0000000080031000 => \%orbit_01_00110_def,
   0x0000000080031010 => \%orbit_01_00111_def,
   0x0000000080032000 => \%orbit_01_00112_def,
   0x0000000080032010 => \%orbit_01_00113_def,
   0x0000000080032800 => \%orbit_01_00114_def,
   0x0000000080032810 => \%orbit_01_00115_def,
   0x0000000080033000 => \%orbit_01_00116_def,
   0x0000000080033010 => \%orbit_01_00117_def,
   0x0000000080033020 => \%orbit_01_00118_def,
   0x0000000080033030 => \%orbit_01_00119_def,
   0x0000000080033040 => \%orbit_01_00120_def,
   0x0000000080033800 => \%orbit_01_00121_def,
   0x0000000080033810 => \%orbit_01_00122_def,
   0x0000000080033820 => \%orbit_01_00123_def,
   0x0000000080033830 => \%orbit_01_00124_def,
   0x0000000080033840 => \%orbit_01_00125_def,
   0x0000000080034000 => \%orbit_01_00126_def,
   0x0000000080034010 => \%orbit_01_00127_def,
   0x0000000080034020 => \%orbit_01_00128_def,
   0x0000000080038000 => \%orbit_01_00129_def,
   0x0000000080038010 => \%orbit_01_00130_def,
   0x0000000080038020 => \%orbit_01_00131_def,
   0x0000000080038030 => \%orbit_01_00132_def,
   0x0000000080038800 => \%orbit_01_00133_def,
   0x0000000080038810 => \%orbit_01_00134_def,
   0x0000000080038820 => \%orbit_01_00135_def,
   0x0000000080038830 => \%orbit_01_00136_def,
   0x0000000080034800 => \%orbit_01_00137_def,
   0x0000000080048000 => \%orbit_01_00138_def,
   0x0000000080048010 => \%orbit_01_00139_def,
   0x0000000080048020 => \%orbit_01_00140_def,
   0x0000000080048030 => \%orbit_01_00141_def,
   0x0000000080048800 => \%orbit_01_00142_def,
   0x0000000080048810 => \%orbit_01_00143_def,
   0x0000000080048820 => \%orbit_01_00144_def,
   0x0000000080048830 => \%orbit_01_00145_def,
   0x0000000080049000 => \%orbit_01_00146_def,
   0x000000008004A000 => \%orbit_01_00147_def,
   0x000000008004B000 => \%orbit_01_00148_def,
   0x0000000080050000 => \%orbit_01_00149_def,
   0x0000000080050100 => \%orbit_01_00150_def,
   0x0000000080050110 => \%orbit_01_00151_def,
   0x0000000080050120 => \%orbit_01_00152_def,
   0x0000000080050130 => \%orbit_01_00153_def,
   0x0000000080050200 => \%orbit_01_00154_def,
   0x0000000080050210 => \%orbit_01_00155_def,
   0x0000000080050220 => \%orbit_01_00156_def,
   0x0000000080050230 => \%orbit_01_00157_def,
   0x0000000080050240 => \%orbit_01_00158_def,
   0x0000000080050250 => \%orbit_01_00159_def,
   0x0000000080050260 => \%orbit_01_00160_def,
   0x0000000080050270 => \%orbit_01_00161_def,
   0x0000000080050300 => \%orbit_01_00162_def,
   0x0000000080050310 => \%orbit_01_00163_def,
   0x0000000080050320 => \%orbit_01_00164_def,
   0x0000000080050330 => \%orbit_01_00165_def,
   0x0000000080050340 => \%orbit_01_00166_def,
   0x0000000080050350 => \%orbit_01_00167_def,
   0x0000000080050360 => \%orbit_01_00168_def,
   0x0000000080050370 => \%orbit_01_00169_def,
   0x0000000080050400 => \%orbit_01_00170_def,
   0x0000000080051000 => \%orbit_01_00171_def,
   0x0000000080051010 => \%orbit_01_00172_def,
   0x0000000080052000 => \%orbit_01_00173_def,
   0x0000000080052010 => \%orbit_01_00174_def,
   0x0000000080052800 => \%orbit_01_00175_def,
   0x0000000080052810 => \%orbit_01_00176_def,
   0x0000000080053000 => \%orbit_01_00177_def,
   0x0000000080053010 => \%orbit_01_00178_def,
   0x0000000080053020 => \%orbit_01_00179_def,
   0x0000000080053030 => \%orbit_01_00180_def,
   0x0000000080053040 => \%orbit_01_00181_def,
   0x0000000080053800 => \%orbit_01_00182_def,
   0x0000000080053810 => \%orbit_01_00183_def,
   0x0000000080053820 => \%orbit_01_00184_def,
   0x0000000080053830 => \%orbit_01_00185_def,
   0x0000000080053840 => \%orbit_01_00186_def,
   0x0000000080054000 => \%orbit_01_00187_def,
   0x0000000080054010 => \%orbit_01_00188_def,
   0x0000000080054020 => \%orbit_01_00189_def,
   0x0000000080058000 => \%orbit_01_00190_def,
   0x0000000080058010 => \%orbit_01_00191_def,
   0x0000000080058020 => \%orbit_01_00192_def,
   0x0000000080058030 => \%orbit_01_00193_def,
   0x0000000080058800 => \%orbit_01_00194_def,
   0x0000000080058810 => \%orbit_01_00195_def,
   0x0000000080058820 => \%orbit_01_00196_def,
   0x0000000080058830 => \%orbit_01_00197_def,
   0x0000000080054800 => \%orbit_01_00198_def,
   0x0000000080068000 => \%orbit_01_00199_def,
   0x0000000080068010 => \%orbit_01_00200_def,
   0x0000000080068020 => \%orbit_01_00201_def,
   0x0000000080068030 => \%orbit_01_00202_def,
   0x0000000080068800 => \%orbit_01_00203_def,
   0x0000000080068810 => \%orbit_01_00204_def,
   0x0000000080068820 => \%orbit_01_00205_def,
   0x0000000080068830 => \%orbit_01_00206_def,
   0x0000000080069000 => \%orbit_01_00207_def,
   0x000000008006A000 => \%orbit_01_00208_def,
   0x000000008006B000 => \%orbit_01_00209_def,
   0x0000000090000400 => \%orbit_01_00210_def,
   0x0000000090000480 => \%orbit_01_00211_def,
   0x0000000090000980 => \%orbit_01_00212_def,
   0x0000000090000A00 => \%orbit_01_00213_def,
   0x0000000090000A80 => \%orbit_01_00214_def,
   0x0000000090000B00 => \%orbit_01_00215_def,
   0x0000000090000B80 => \%orbit_01_00216_def,
   0x0000000090000C00 => \%orbit_01_00217_def,
   0x0000000090000C80 => \%orbit_01_00218_def,
   0x0000000090000F00 => \%orbit_01_00219_def,
   0x0000000090000F80 => \%orbit_01_00220_def,
   0x0000000090001000 => \%orbit_01_00221_def,
   0x0000000090001080 => \%orbit_01_00222_def,
   0x0000000090001100 => \%orbit_01_00223_def,
   0x0000000090001180 => \%orbit_01_00224_def,
   0x0000000090001200 => \%orbit_01_00225_def,
   0x0000000090001300 => \%orbit_01_00226_def,
   0x0000000090001380 => \%orbit_01_00227_def,
   0x0000000090001400 => \%orbit_01_00228_def,
   0x0000000090001480 => \%orbit_01_00229_def,
   0x0000000090001500 => \%orbit_01_00230_def,
   0x0000000090001580 => \%orbit_01_00231_def,
   0x0000000090001600 => \%orbit_01_00232_def,
   0x0000000090001680 => \%orbit_01_00233_def,
   0x0000000090001700 => \%orbit_01_00234_def,
   0x0000000090001780 => \%orbit_01_00235_def,
   0x0000000090001800 => \%orbit_01_00236_def,
   0x0000000090001880 => \%orbit_01_00237_def,
   0x0000000090001900 => \%orbit_01_00238_def,
   0x0000000090001980 => \%orbit_01_00239_def,
   0x0000000090001A00 => \%orbit_01_00240_def,
   0x0000000090001A80 => \%orbit_01_00241_def,
   0x0000000090001B00 => \%orbit_01_00242_def,
   0x0000000090001B80 => \%orbit_01_00243_def,
   0x0000000090001C00 => \%orbit_01_00244_def,
   0x0000000090001C80 => \%orbit_01_00245_def,
   0x0000000090001D00 => \%orbit_01_00246_def,
   0x0000000090001D80 => \%orbit_01_00247_def,
   0x0000000090001E00 => \%orbit_01_00248_def,
   0x0000000090001E80 => \%orbit_01_00249_def,
   0x0000000090010000 => \%orbit_01_00250_def,
   0x0000000090010080 => \%orbit_01_00251_def,
   0x0000000090010100 => \%orbit_01_00252_def,
   0x0000000090010180 => \%orbit_01_00253_def,
   0x0000000090010200 => \%orbit_01_00254_def,
   0x0000000090010280 => \%orbit_01_00255_def,
   0x0000000090010300 => \%orbit_01_00256_def,
   0x0000000090010380 => \%orbit_01_00257_def,
   0x0000000090010400 => \%orbit_01_00258_def,
   0x0000000090010480 => \%orbit_01_00259_def,
   0x0000000090010500 => \%orbit_01_00260_def,
   0x0000000090010580 => \%orbit_01_00261_def,
   0x0000000090010600 => \%orbit_01_00262_def,
   0x0000000090010680 => \%orbit_01_00263_def,
   0x0000000090010700 => \%orbit_01_00264_def,
   0x0000000090010780 => \%orbit_01_00265_def,
   0x0000000090010800 => \%orbit_01_00266_def,
   0x0000000090010880 => \%orbit_01_00267_def,
   0x0000000090010900 => \%orbit_01_00268_def,
   0x0000000090010980 => \%orbit_01_00269_def,
   0x0000000090010A00 => \%orbit_01_00270_def,
   0x0000000090010A80 => \%orbit_01_00271_def,
   0x0000000090010B00 => \%orbit_01_00272_def,
   0x0000000090010B80 => \%orbit_01_00273_def,
   0x0000000090010C00 => \%orbit_01_00274_def,
   0x0000000090010C80 => \%orbit_01_00275_def,
   0x0000000090010D00 => \%orbit_01_00276_def,
   0x0000000090010D80 => \%orbit_01_00277_def,
   0x0000000090010E00 => \%orbit_01_00278_def,
   0x0000000090010E80 => \%orbit_01_00279_def,
   0x0000000090010F00 => \%orbit_01_00280_def,
   0x0000000090038000 => \%orbit_01_00281_def,
   0x0000000090038080 => \%orbit_01_00282_def,
   0x0000000090038100 => \%orbit_01_00283_def,
   0x0000000090038180 => \%orbit_01_00284_def,
   0x0000000090020000 => \%orbit_01_00285_def,
   0x0000000090020100 => \%orbit_01_00286_def,
   0x0000000090030000 => \%orbit_01_00287_def,
   0x0000000090030080 => \%orbit_01_00288_def,
   0x0000000090030100 => \%orbit_01_00289_def,
   0x0000000090030180 => \%orbit_01_00290_def,
   0x0000000090040000 => \%orbit_01_00291_def,
   0x0000000090040080 => \%orbit_01_00292_def,
   0x0000000090040100 => \%orbit_01_00293_def,
   0x0000000090040180 => \%orbit_01_00294_def,
   0x0000000090040200 => \%orbit_01_00295_def,
   0x0000000090040280 => \%orbit_01_00296_def,
   0x0000000090050000 => \%orbit_01_00297_def,
   0x0000000090050080 => \%orbit_01_00298_def,
   0x0000000090050100 => \%orbit_01_00299_def,
   0x0000000090050180 => \%orbit_01_00300_def,
   0x0000000090050200 => \%orbit_01_00301_def,
   0x0000000090050280 => \%orbit_01_00302_def,
   0x0000000090050300 => \%orbit_01_00303_def,
   0x0000000090050380 => \%orbit_01_00304_def,
   0x0000000090050400 => \%orbit_01_00305_def,
   0x0000000090050480 => \%orbit_01_00306_def,
   0x0000000090050580 => \%orbit_01_00307_def,
   0x0000000090050600 => \%orbit_01_00308_def,
   0x0000000090050608 => \%orbit_01_00309_def,
   0x0000000090050680 => \%orbit_01_00310_def,
   0x0000000090050688 => \%orbit_01_00311_def,
   0x0000000090050700 => \%orbit_01_00312_def,
   0x0000000090050780 => \%orbit_01_00313_def,
   0x0000000090050800 => \%orbit_01_00314_def,
   0x0000000090050880 => \%orbit_01_00315_def,
   0x0000000090050900 => \%orbit_01_00316_def,
   0x0000000090062000 => \%orbit_01_00317_def,
   0x0000000090062080 => \%orbit_01_00318_def,
   0x0000000090062100 => \%orbit_01_00319_def,
   0x0000000090062180 => \%orbit_01_00320_def,
   0x0000000090062200 => \%orbit_01_00321_def,
   0x0000000090062280 => \%orbit_01_00322_def,
   0x0000000090062300 => \%orbit_01_00323_def,
   0x0000000090063000 => \%orbit_01_00324_def,
   0x0000000090063080 => \%orbit_01_00325_def,
   0x0000000090063100 => \%orbit_01_00326_def,
   0x0000000090063180 => \%orbit_01_00327_def,
   0x0000000090063200 => \%orbit_01_00328_def,
   0x0000000090063280 => \%orbit_01_00329_def,
   0x0000000090063300 => \%orbit_01_00330_def,
   0x0000000090063380 => \%orbit_01_00331_def,
   0x0000000090063400 => \%orbit_01_00332_def,
   0x0000000090063480 => \%orbit_01_00333_def,
   0x0000000090063500 => \%orbit_01_00334_def,
   0x0000000090063580 => \%orbit_01_00335_def,
   0x0000000090063600 => \%orbit_01_00336_def,
   0x0000000090063680 => \%orbit_01_00337_def,
   0x0000000090063700 => \%orbit_01_00338_def,
   0x0000000090063780 => \%orbit_01_00339_def,
   0x0000000090063800 => \%orbit_01_00340_def,
   0x0000000090063880 => \%orbit_01_00341_def,
   0x0000000090063900 => \%orbit_01_00342_def,
   0x0000000090063980 => \%orbit_01_00343_def,
   0x0000000090063A00 => \%orbit_01_00344_def,
   0x0000000090064000 => \%orbit_01_00345_def,
   0x0000000090064480 => \%orbit_01_00346_def,
   0x0000000090064080 => \%orbit_01_00347_def,
   0x0000000090064100 => \%orbit_01_00348_def,
   0x0000000090064180 => \%orbit_01_00349_def,
   0x0000000090064200 => \%orbit_01_00350_def,
   0x0000000090064280 => \%orbit_01_00351_def,
   0x0000000090064300 => \%orbit_01_00352_def,
   0x0000000090064380 => \%orbit_01_00353_def,
   0x0000000090064400 => \%orbit_01_00354_def,
   0x0000000090065000 => \%orbit_01_00355_def,
   0x0000000090065080 => \%orbit_01_00356_def,
   0x0000000090066000 => \%orbit_01_00357_def,
   0x0000000090066080 => \%orbit_01_00358_def,
   0x0000000090066100 => \%orbit_01_00359_def,
   0x0000000090066180 => \%orbit_01_00360_def,
   0x0000000090066200 => \%orbit_01_00361_def,
   0x0000000090066280 => \%orbit_01_00362_def,
   0x0000000090066300 => \%orbit_01_00363_def,
   0x0000000090066380 => \%orbit_01_00364_def,
   0x0000000090066400 => \%orbit_01_00365_def,
   0x0000000090066480 => \%orbit_01_00366_def,
   0x0000000090066500 => \%orbit_01_00367_def,
   0x0000000090066580 => \%orbit_01_00368_def,
   0x0000000090066600 => \%orbit_01_00369_def,
   0x0000000090066680 => \%orbit_01_00370_def,
   0x0000000090066700 => \%orbit_01_00371_def,
   0x0000000090066780 => \%orbit_01_00372_def,
   0x0000000090066800 => \%orbit_01_00373_def,
   0x0000000090066880 => \%orbit_01_00374_def,
   0x0000000090066900 => \%orbit_01_00375_def,
   0x0000000090066980 => \%orbit_01_00376_def,
   0x0000000090066A00 => \%orbit_01_00377_def,
   0x0000000090066A80 => \%orbit_01_00378_def,
   0x0000000090066B00 => \%orbit_01_00379_def,
   0x0000000090066B80 => \%orbit_01_00380_def,
   0x0000000090066C00 => \%orbit_01_00381_def,
   0x0000000090066C80 => \%orbit_01_00382_def,
   0x0000000090067000 => \%orbit_01_00383_def,
   0x0000000090067080 => \%orbit_01_00384_def,
   0x0000000090067100 => \%orbit_01_00385_def,
   0x0000000090060000 => \%orbit_01_00386_def,
   0x0000000090060080 => \%orbit_01_00387_def,
   0x0000000090060100 => \%orbit_01_00388_def,
   0x0000000090060180 => \%orbit_01_00389_def,
   0x0000000090060200 => \%orbit_01_00390_def,
   0x0000000090060280 => \%orbit_01_00391_def,
   0x0000000090060300 => \%orbit_01_00392_def,
   0x0000000090060380 => \%orbit_01_00393_def,
   0x0000000090060400 => \%orbit_01_00394_def,
   0x0000000090060480 => \%orbit_01_00395_def,
   0x0000000090060500 => \%orbit_01_00396_def,
   0x0000000090060580 => \%orbit_01_00397_def,
   0x0000000090060600 => \%orbit_01_00398_def,
   0x0000000090060680 => \%orbit_01_00399_def,
   0x0000000090060700 => \%orbit_01_00400_def,
   0x0000000090060780 => \%orbit_01_00401_def,
   0x0000000090060800 => \%orbit_01_00402_def,
   0x0000000090060880 => \%orbit_01_00403_def,
   0x0000000090060900 => \%orbit_01_00404_def,
   0x0000000090060980 => \%orbit_01_00405_def,
   0x0000000090060A00 => \%orbit_01_00406_def,
   0x0000000090060A80 => \%orbit_01_00407_def,
   0x0000000090060B00 => \%orbit_01_00408_def,
   0x0000000090060B80 => \%orbit_01_00409_def,
   0x0000000090060C00 => \%orbit_01_00410_def,
   0x0000000090060C80 => \%orbit_01_00411_def,
   0x0000000090060D00 => \%orbit_01_00412_def,
   0x0000000090060D80 => \%orbit_01_00413_def,
   0x0000000090060E00 => \%orbit_01_00414_def,
   0x0000000090060E80 => \%orbit_01_00415_def,
   0x0000000090060F00 => \%orbit_01_00416_def,
   0x0000000090060F80 => \%orbit_01_00417_def,
   0x0000000090061000 => \%orbit_01_00418_def,
   0x0000000090061080 => \%orbit_01_00419_def,
   0x0000000090061100 => \%orbit_01_00420_def,
   0x0000000090061400 => \%orbit_01_00421_def,
   0x0000000090068000 => \%orbit_01_00422_def,
   0x0000000090068080 => \%orbit_01_00423_def,
   0x0000000090068100 => \%orbit_01_00424_def,
   0x0000000090071000 => \%orbit_01_00425_def,
   0x0000000090071080 => \%orbit_01_00426_def,
   0x0000000090071100 => \%orbit_01_00427_def,
   0x0000000090071180 => \%orbit_01_00428_def,
   0x0000000090071200 => \%orbit_01_00429_def,
   0x0000000090071280 => \%orbit_01_00430_def,
   0x0000000090071300 => \%orbit_01_00431_def,
   0x0000000090071380 => \%orbit_01_00432_def,
   0x0000000090071400 => \%orbit_01_00433_def,
   0x0000000090071480 => \%orbit_01_00434_def,
   0x0000000090071500 => \%orbit_01_00435_def,
   0x0000000090071580 => \%orbit_01_00436_def,
   0x0000000090071600 => \%orbit_01_00437_def,
   0x0000000090071680 => \%orbit_01_00438_def,
   0x0000000090071700 => \%orbit_01_00439_def,
   0x0000000090071780 => \%orbit_01_00440_def,
   0x0000000090071800 => \%orbit_01_00441_def,
   0x0000000090071880 => \%orbit_01_00442_def,
   0x0000000090071900 => \%orbit_01_00443_def,
   0x0000000090071980 => \%orbit_01_00444_def,
   0x0000000090072000 => \%orbit_01_00445_def,
   0x0000000090072080 => \%orbit_01_00446_def,
   0x0000000090072100 => \%orbit_01_00447_def,
   0x0000000090072180 => \%orbit_01_00448_def,
   0x0000000090072200 => \%orbit_01_00449_def,
   0x0000000090072280 => \%orbit_01_00450_def,
   0x0000000090072300 => \%orbit_01_00451_def,
   0x0000000090072800 => \%orbit_01_00452_def,
   0x0000000090072880 => \%orbit_01_00453_def,
   0x0000000090072900 => \%orbit_01_00454_def,
   0x0000000090073000 => \%orbit_01_00455_def,
   0x0000000090073080 => \%orbit_01_00456_def,
   0x0000000090073100 => \%orbit_01_00457_def,
   0x0000000090074000 => \%orbit_01_00458_def,
   0x0000000090074080 => \%orbit_01_00459_def,
   0x0000000090074100 => \%orbit_01_00460_def,
   0x0000000090074108 => \%orbit_01_00461_def,
   0x0000000090075000 => \%orbit_01_00462_def,
   0x0000000090077000 => \%orbit_01_00463_def,
   0x0000000090080000 => \%orbit_01_00464_def,
   0x0000000090090000 => \%orbit_01_00465_def,
   0x00000000900A0000 => \%orbit_01_00466_def,
   0x00000000900B0000 => \%orbit_01_00467_def,
   0x00000000900C0000 => \%orbit_01_00468_def,
   0x00000000900D0000 => \%orbit_01_00469_def,
   0x00000000900E0000 => \%orbit_01_00470_def,
   0x00000000900F0000 => \%orbit_01_00471_def,
   0x0000000090100000 => \%orbit_01_00472_def,
   0x0000000090100080 => \%orbit_01_00473_def,
   0x0000000090100100 => \%orbit_01_00474_def,
   0x0000000090100180 => \%orbit_01_00475_def,
   0x0000000090101000 => \%orbit_01_00476_def,
   0x0000000090110000 => \%orbit_01_00477_def,
   0x0000000090120000 => \%orbit_01_00478_def,
   0x0000000090130000 => \%orbit_01_00479_def,
   0x0000000090140000 => \%orbit_01_00480_def,
   0x0000000090150000 => \%orbit_01_00481_def,
   0x0000000090160000 => \%orbit_01_00482_def,
   0x0000000090170000 => \%orbit_01_00483_def,
   0x0000000090180000 => \%orbit_01_00484_def,
   0x0000000090190000 => \%orbit_01_00485_def,
   0x0000000090190080 => \%orbit_01_00486_def,
   0x00000000901B0000 => \%orbit_01_00487_def,
   0x00000000901B0080 => \%orbit_01_00488_def,
   0x00000000901B0100 => \%orbit_01_00489_def,
   0x00000000901B0180 => \%orbit_01_00490_def,
   0x00000000901B0200 => \%orbit_01_00491_def,
   0x00000000901C0000 => \%orbit_01_00492_def,
   0x00000000901D0000 => \%orbit_01_00493_def,
   0x00000000901D0008 => \%orbit_01_00494_def,
   0x00000000901D0080 => \%orbit_01_00495_def,
   0x00000000901D0088 => \%orbit_01_00496_def,
   0x00000000901D0100 => \%orbit_01_00497_def,
   0x00000000901D0108 => \%orbit_01_00498_def,
   0x00000000901D0180 => \%orbit_01_00499_def,
   0x00000000901D0188 => \%orbit_01_00500_def,
   0x00000000901D0200 => \%orbit_01_00501_def,
   0x00000000901D0208 => \%orbit_01_00502_def,
   0x00000000901D0280 => \%orbit_01_00503_def,
   0x00000000901D0300 => \%orbit_01_00504_def,
   0x00000000901D0380 => \%orbit_01_00505_def,
   0x00000000901D0400 => \%orbit_01_00506_def,
   0x00000000901D0480 => \%orbit_01_00507_def,
   0x00000000901D0500 => \%orbit_01_00508_def,
   0x00000000901D0580 => \%orbit_01_00509_def,
   0x00000000901D0600 => \%orbit_01_00510_def,
   0x00000000A0000100 => \%orbit_01_00511_def,
   0x00000000A0000108 => \%orbit_01_00512_def,
   0x00000000A0000110 => \%orbit_01_00513_def,
   0x00000000A0000118 => \%orbit_01_00514_def,
   0x00000000A0008120 => \%orbit_01_00515_def,
   0x00000000A0008128 => \%orbit_01_00516_def,
   0x00000000A0008130 => \%orbit_01_00517_def,
   0x00000000A0008138 => \%orbit_01_00518_def,
   0x00000000A0008100 => \%orbit_01_00519_def,
   0x00000000A0008108 => \%orbit_01_00520_def,
   0x00000000A0008110 => \%orbit_01_00521_def,
   0x00000000A0008118 => \%orbit_01_00522_def,
   0x00000000A0000800 => \%orbit_01_00523_def,
   0x00000000A0008800 => \%orbit_01_00524_def,
   0x00000000A0008808 => \%orbit_01_00525_def,
   0x00000000A0000808 => \%orbit_01_00526_def,
   0x00000000A0008860 => \%orbit_01_00527_def,
   0x00000000A0008868 => \%orbit_01_00528_def,
   0x00000000A0000810 => \%orbit_01_00529_def,
   0x00000000A0000818 => \%orbit_01_00530_def,
   0x00000000A0000820 => \%orbit_01_00531_def,
   0x00000000A0000828 => \%orbit_01_00532_def,
   0x00000000A0000830 => \%orbit_01_00533_def,
   0x00000000A0000838 => \%orbit_01_00534_def,
   0x00000000A0000840 => \%orbit_01_00535_def,
   0x00000000A0000848 => \%orbit_01_00536_def,
   0x00000000A0000850 => \%orbit_01_00537_def,
   0x00000000A0000858 => \%orbit_01_00538_def,
   0x00000000A0001000 => \%orbit_01_00539_def,
   0x00000000A0001008 => \%orbit_01_00540_def,
   0x00000000A0001010 => \%orbit_01_00541_def,
   0x00000000A0001020 => \%orbit_01_00542_def,
   0x00000000A0001028 => \%orbit_01_00543_def,
   0x00000000A0001030 => \%orbit_01_00544_def,
   0x00000000A0008810 => \%orbit_01_00545_def,
   0x00000000A0008818 => \%orbit_01_00546_def,
   0x00000000A0008820 => \%orbit_01_00547_def,
   0x00000000A0008828 => \%orbit_01_00548_def,
   0x00000000A0008830 => \%orbit_01_00549_def,
   0x00000000A0008838 => \%orbit_01_00550_def,
   0x00000000A0008840 => \%orbit_01_00551_def,
   0x00000000A0008848 => \%orbit_01_00552_def,
   0x00000000A0008880 => \%orbit_01_00553_def,
   0x00000000A0008888 => \%orbit_01_00554_def,
   0x00000000A0010080 => \%orbit_01_00555_def,
   0x00000000A0010088 => \%orbit_01_00556_def,
   0x00000000A0010008 => \%orbit_01_00557_def,
   0x00000000A0010010 => \%orbit_01_00558_def,
   0x00000000A0010018 => \%orbit_01_00559_def,
   0x00000000A0010020 => \%orbit_01_00560_def,
   0x00000000A0010028 => \%orbit_01_00561_def,
   0x00000000A0010030 => \%orbit_01_00562_def,
   0x00000000A0010100 => \%orbit_01_00563_def,
   0x00000000A0010108 => \%orbit_01_00564_def,
   0x00000000A0010110 => \%orbit_01_00565_def,
   0x00000000A0010118 => \%orbit_01_00566_def,
   0x00000000A0010808 => \%orbit_01_00567_def,
   0x00000000A0011000 => \%orbit_01_00568_def,
   0x00000000A0011008 => \%orbit_01_00569_def,
   0x00000000A0011030 => \%orbit_01_00570_def,
   0x00000000A0011038 => \%orbit_01_00571_def,
   0x00000000A0011040 => \%orbit_01_00572_def,
   0x00000000A0011050 => \%orbit_01_00573_def,
   0x00000000A0011058 => \%orbit_01_00574_def,
   0x00000000A0011060 => \%orbit_01_00575_def,
   0x00000000A0011070 => \%orbit_01_00576_def,
   0x00000000A0011078 => \%orbit_01_00577_def,
   0x00000000A0011080 => \%orbit_01_00578_def,
   0x00000000A0018800 => \%orbit_01_00579_def,
   0x00000000A0018808 => \%orbit_01_00580_def,
   0x00000000A0018810 => \%orbit_01_00581_def,
   0x00000000A0018818 => \%orbit_01_00582_def,
   0x00000000A0018820 => \%orbit_01_00583_def,
   0x00000000A0018828 => \%orbit_01_00584_def,
   0x00000000A0018830 => \%orbit_01_00585_def,
   0x00000000A0018848 => \%orbit_01_00586_def,
   0x00000000A0020000 => \%orbit_01_00587_def,
   0x00000000A0020010 => \%orbit_01_00588_def,
   0x00000000A0020020 => \%orbit_01_00589_def,
   0x00000000A0020030 => \%orbit_01_00590_def,
   0x00000000A0020040 => \%orbit_01_00591_def,
   0x00000000A0020050 => \%orbit_01_00592_def,
   0x00000000A0020060 => \%orbit_01_00593_def,
   0x00000000A0020070 => \%orbit_01_00594_def,
   0x00000000A0020400 => \%orbit_01_00595_def,
   0x00000000A0021000 => \%orbit_01_00596_def,
   0x00000000A0021100 => \%orbit_01_00597_def,
   0x00000000A0021110 => \%orbit_01_00598_def,
   0x00000000A0021200 => \%orbit_01_00599_def,
   0x00000000A0021210 => \%orbit_01_00600_def,
   0x00000000A0021300 => \%orbit_01_00601_def,
   0x00000000A0021310 => \%orbit_01_00602_def,
   0x00000000A0021400 => \%orbit_01_00603_def,
   0x00000000A0021410 => \%orbit_01_00604_def,
   0x00000000A0021500 => \%orbit_01_00605_def,
   0x00000000A0021510 => \%orbit_01_00606_def,
   0x00000000A0021520 => \%orbit_01_00607_def,
   0x00000000A0021600 => \%orbit_01_00608_def,
   0x00000000A0021610 => \%orbit_01_00609_def,
   0x00000000A0021620 => \%orbit_01_00610_def,
   0x00000000A0021700 => \%orbit_01_00611_def,
   0x00000000A0021710 => \%orbit_01_00612_def,
   0x00000000A0021720 => \%orbit_01_00613_def,
   0x00000000A0022000 => \%orbit_01_00614_def,
   0x00000000A0024000 => \%orbit_01_00615_def,
   0x00000000A0024010 => \%orbit_01_00616_def,
   0x00000000A0024020 => \%orbit_01_00617_def,
   0x00000000A0028000 => \%orbit_01_00618_def,
   0x00000000A0028010 => \%orbit_01_00619_def,
   0x00000000A0028020 => \%orbit_01_00620_def,
   0x00000000A0028030 => \%orbit_01_00621_def,
   0x00000000A0028040 => \%orbit_01_00622_def,
   0x00000000A0028050 => \%orbit_01_00623_def,
   0x00000000A0028060 => \%orbit_01_00624_def,
   0x00000000A0028070 => \%orbit_01_00625_def,
   0x00000000A0028080 => \%orbit_01_00626_def,
   0x00000000A0029000 => \%orbit_01_00627_def,
   0x00000000A0029010 => \%orbit_01_00628_def,
   0x00000000A0029020 => \%orbit_01_00629_def,
   0x00000000A0029030 => \%orbit_01_00630_def,
   0x00000000A0029060 => \%orbit_01_00631_def,
   0x00000000A0029070 => \%orbit_01_00632_def,
   0x00000000A0029080 => \%orbit_01_00633_def,
   0x00000000A002A000 => \%orbit_01_00634_def,
   0x00000000A002A020 => \%orbit_01_00635_def,
   0x00000000A002A030 => \%orbit_01_00636_def,
   0x00000000A002A040 => \%orbit_01_00637_def,
   0x00000000A002A050 => \%orbit_01_00638_def,
   0x00000000A002A100 => \%orbit_01_00639_def,
   0x00000000A002A060 => \%orbit_01_00640_def,
   0x00000000A0030000 => \%orbit_01_00641_def,
   0x00000000A0030008 => \%orbit_01_00642_def,
   0x00000000A0030010 => \%orbit_01_00643_def,
   0x00000000A0030018 => \%orbit_01_00644_def,
   0x00000000A0030020 => \%orbit_01_00645_def,
   0x00000000A0030028 => \%orbit_01_00646_def,
   0x00000000A0030030 => \%orbit_01_00647_def,
   0x00000000A0030038 => \%orbit_01_00648_def,
   0x00000000A0030040 => \%orbit_01_00649_def,
   0x00000000A0030048 => \%orbit_01_00650_def,
   0x00000000A0030050 => \%orbit_01_00651_def,
   0x00000000A0030058 => \%orbit_01_00652_def,
   0x00000000A0030060 => \%orbit_01_00653_def,
   0x00000000A0030080 => \%orbit_01_00654_def,
   0x00000000A0030088 => \%orbit_01_00655_def,
   0x00000000A0030100 => \%orbit_01_00656_def,
   0x00000000A0030108 => \%orbit_01_00657_def,
   0x00000000A0030118 => \%orbit_01_00658_def,
   0x00000000A0038000 => \%orbit_01_00659_def,
   0x00000000A0038008 => \%orbit_01_00660_def,
   0x00000000A0038010 => \%orbit_01_00661_def,
   0x00000000A0038020 => \%orbit_01_00662_def,
   0x00000000A0038030 => \%orbit_01_00663_def,
   0x00000000A0038040 => \%orbit_01_00664_def,
   0x00000000A0038018 => \%orbit_01_00665_def,
   0x00000000A0038028 => \%orbit_01_00666_def,
   0x00000000A0038038 => \%orbit_01_00667_def,
   0x00000000A0038048 => \%orbit_01_00668_def,
   0x00000000A0038800 => \%orbit_01_00669_def,
   0x00000000A0038808 => \%orbit_01_00670_def,
   0x00000000A0038810 => \%orbit_01_00671_def,
   0x00000000A0038818 => \%orbit_01_00672_def,
   0x00000000A0038820 => \%orbit_01_00673_def,
   0x00000000A0038828 => \%orbit_01_00674_def,
   0x00000000A0038840 => \%orbit_01_00675_def,
   0x00000000A0038848 => \%orbit_01_00676_def,
   0x00000000A0038850 => \%orbit_01_00677_def,
   0x00000000A0038858 => \%orbit_01_00678_def,
   0x00000000A0038860 => \%orbit_01_00679_def,
   0x00000000A0038868 => \%orbit_01_00680_def,
   0x00000000A0038830 => \%orbit_01_00681_def,
   0x00000000A0038838 => \%orbit_01_00682_def,
   0x00000000A0031040 => \%orbit_01_00683_def,
   0x00000000A0031048 => \%orbit_01_00684_def,
   0x00000000A0031050 => \%orbit_01_00685_def,
   0x00000000D0000000 => \%orbit_01_00686_def,
   0x00000000D0000008 => \%orbit_01_00687_def,
   0x00000000D0000010 => \%orbit_01_00688_def,
   0x00000000D0000018 => \%orbit_01_00689_def,
   0x00000000D0000020 => \%orbit_01_00690_def,
   0x00000000D0000028 => \%orbit_01_00691_def,
   0x00000000D0000030 => \%orbit_01_00692_def,
   0x00000000D0000038 => \%orbit_01_00693_def,
   0x00000000D0000040 => \%orbit_01_00694_def,
   0x00000000D0000048 => \%orbit_01_00695_def,
   0x00000000D0002000 => \%orbit_01_00696_def,
   0x00000000D0002008 => \%orbit_01_00697_def,
   0x00000000D0002010 => \%orbit_01_00698_def,
   0x00000000D0002018 => \%orbit_01_00699_def,
   0x00000000D0002020 => \%orbit_01_00700_def,
   0x00000000D0002028 => \%orbit_01_00701_def,
   0x00000000D0002030 => \%orbit_01_00702_def,
   0x00000000D0002038 => \%orbit_01_00703_def,
   0x00000000D0002040 => \%orbit_01_00704_def,
   0x00000000D0002048 => \%orbit_01_00705_def,
   0x00000000D0001030 => \%orbit_01_00706_def,
   0x00000000D0001040 => \%orbit_01_00707_def,
   0x00000000D0001050 => \%orbit_01_00708_def,
   0x00000000D0001060 => \%orbit_01_00709_def,
   0x00000000D0001070 => \%orbit_01_00710_def,
   0x00000000D0003030 => \%orbit_01_00711_def,
   0x00000000D0003040 => \%orbit_01_00712_def,
   0x00000000D0003050 => \%orbit_01_00713_def,
   0x00000000D0003060 => \%orbit_01_00714_def,
   0x00000000D0003070 => \%orbit_01_00715_def,
   0x00000000D0020000 => \%orbit_01_00716_def,
   0x00000000D0020800 => \%orbit_01_00717_def,
   0x00000000D0021000 => \%orbit_01_00718_def,
   0x00000000D0022000 => \%orbit_01_00719_def,
   0x00000000D0022800 => \%orbit_01_00720_def,
   0x00000000D0023000 => \%orbit_01_00721_def,
   0x00000000D0023008 => \%orbit_01_00722_def,
   0x00000000D0024000 => \%orbit_01_00723_def,
   0x00000000D0024800 => \%orbit_01_00724_def,
   0x00000000D0025000 => \%orbit_01_00725_def,
   0x00000000D0026000 => \%orbit_01_00726_def,
   0x00000000D0026800 => \%orbit_01_00727_def,
   0x00000000D0027000 => \%orbit_01_00728_def,
   0x00000000D0028000 => \%orbit_01_00729_def,
   0x00000000D0028800 => \%orbit_01_00730_def,
   0x00000000D0029000 => \%orbit_01_00731_def,
   0x00000000D0029008 => \%orbit_01_00732_def,
   0x00000000D0030000 => \%orbit_01_00733_def,
   0x00000000D0030010 => \%orbit_01_00734_def,
   0x00000000D0030020 => \%orbit_01_00735_def,
   0x00000000D0030030 => \%orbit_01_00736_def,
   0x00000000D0030040 => \%orbit_01_00737_def,
   0x00000000D0030050 => \%orbit_01_00738_def,
   0x00000000D0030060 => \%orbit_01_00739_def,
   0x00000000D0030070 => \%orbit_01_00740_def,
   0x00000000D0030080 => \%orbit_01_00741_def,
   0x00000000D0030090 => \%orbit_01_00742_def,
   0x00000000D00300A0 => \%orbit_01_00743_def,
   0x00000000D00300B0 => \%orbit_01_00744_def,
   0x00000000D0030100 => \%orbit_01_00745_def,
   0x00000000D0030110 => \%orbit_01_00746_def,
   0x00000000D0030120 => \%orbit_01_00747_def,
   0x00000000D0030130 => \%orbit_01_00748_def,
   0x00000000D0030140 => \%orbit_01_00749_def,
   0x00000000D0030150 => \%orbit_01_00750_def,
   0x00000000D0030160 => \%orbit_01_00751_def,
   0x00000000D0030170 => \%orbit_01_00752_def,
   0x00000000D0030180 => \%orbit_01_00753_def,
   0x00000000D0030190 => \%orbit_01_00754_def,
   0x00000000D00301A0 => \%orbit_01_00755_def,
   0x00000000D00301B0 => \%orbit_01_00756_def,
   0x00000000D0030200 => \%orbit_01_00757_def,
   0x00000000D0030210 => \%orbit_01_00758_def,
   0x00000000D0030220 => \%orbit_01_00759_def,
   0x00000000D0030230 => \%orbit_01_00760_def,
   0x00000000D0030240 => \%orbit_01_00761_def,
   0x00000000D0030250 => \%orbit_01_00762_def,
   0x00000000D0030260 => \%orbit_01_00763_def,
   0x00000000D00302B0 => \%orbit_01_00764_def,
   0x00000000D00302C0 => \%orbit_01_00765_def,
   0x00000000D00302D0 => \%orbit_01_00766_def,
   0x00000000D0030300 => \%orbit_01_00767_def,
   0x00000000D0030310 => \%orbit_01_00768_def,
   0x00000000D0030320 => \%orbit_01_00769_def,
   0x00000000D0030330 => \%orbit_01_00770_def,
   0x00000000D0030340 => \%orbit_01_00771_def,
   0x00000000D0030350 => \%orbit_01_00772_def,
   0x00000000D0030360 => \%orbit_01_00773_def,
   0x00000000D0030270 => \%orbit_01_00774_def,
   0x00000000D0030280 => \%orbit_01_00775_def,
   0x00000000D0030290 => \%orbit_01_00776_def,
   0x00000000D00302A0 => \%orbit_01_00777_def,
   0x00000000D00302E0 => \%orbit_01_00778_def,
   0x00000000D00302F0 => \%orbit_01_00779_def,
   0x00000000D0030400 => \%orbit_01_00780_def,
   0x00000000D0030410 => \%orbit_01_00781_def,
   0x00000000D0030420 => \%orbit_01_00782_def,
   0x00000000D0030430 => \%orbit_01_00783_def,
   0x00000000D0030440 => \%orbit_01_00784_def,
   0x00000000D0030450 => \%orbit_01_00785_def,
   0x00000000D0030460 => \%orbit_01_00786_def,
   0x00000000D0030470 => \%orbit_01_00787_def,
   0x00000000D0030480 => \%orbit_01_00788_def,
   0x00000000D0030490 => \%orbit_01_00789_def,
   0x00000000D00304A0 => \%orbit_01_00790_def,
   0x00000000D00304B0 => \%orbit_01_00791_def,
   0x00000000D00304C0 => \%orbit_01_00792_def,
   0x00000000D00304F0 => \%orbit_01_00793_def,
   0x00000000D00304D0 => \%orbit_01_00794_def,
   0x00000000D00304E0 => \%orbit_01_00795_def,
   0x00000000D0030500 => \%orbit_01_00796_def,
   0x00000000D0030510 => \%orbit_01_00797_def,
   0x00000000D0030520 => \%orbit_01_00798_def,
   0x00000000D0030530 => \%orbit_01_00799_def,
   0x00000000D0030540 => \%orbit_01_00800_def,
   0x00000000D0030550 => \%orbit_01_00801_def,
   0x00000000D0030560 => \%orbit_01_00802_def,
   0x00000000D0030570 => \%orbit_01_00803_def,
   0x00000000D0030600 => \%orbit_01_00804_def,
   0x00000000D0030610 => \%orbit_01_00805_def,
   0x00000000D0030620 => \%orbit_01_00806_def,
   0x00000000D0030630 => \%orbit_01_00807_def,
   0x00000000D0030640 => \%orbit_01_00808_def,
   0x00000000D0030650 => \%orbit_01_00809_def,
   0x00000000D0030660 => \%orbit_01_00810_def,
   0x00000000D0030670 => \%orbit_01_00811_def,
   0x00000000D0030680 => \%orbit_01_00812_def,
   0x00000000D0030690 => \%orbit_01_00813_def,
   0x00000000D00306A0 => \%orbit_01_00814_def,
   0x00000000D00306B0 => \%orbit_01_00815_def,
   0x00000000D00306C0 => \%orbit_01_00816_def,
   0x00000000D00306F0 => \%orbit_01_00817_def,
   0x00000000D00306D0 => \%orbit_01_00818_def,
   0x00000000D00306E0 => \%orbit_01_00819_def,
   0x00000000D0030700 => \%orbit_01_00820_def,
   0x00000000D0030710 => \%orbit_01_00821_def,
   0x00000000D0030720 => \%orbit_01_00822_def,
   0x00000000D0030730 => \%orbit_01_00823_def,
   0x00000000D0030740 => \%orbit_01_00824_def,
   0x00000000D0030750 => \%orbit_01_00825_def,
   0x00000000D0030760 => \%orbit_01_00826_def,
   0x00000000D0030770 => \%orbit_01_00827_def,
   0x00000000D0031000 => \%orbit_01_00828_def,
   0x00000000D0031020 => \%orbit_01_00829_def,
   0x00000000D0031040 => \%orbit_01_00830_def,
   0x00000000D0031050 => \%orbit_01_00831_def,
   0x00000000D0031060 => \%orbit_01_00832_def,
   0x00000000D0031100 => \%orbit_01_00833_def,
   0x00000000D0031110 => \%orbit_01_00834_def,
   0x00000000D0031120 => \%orbit_01_00835_def,
   0x00000000D0031130 => \%orbit_01_00836_def,
   0x00000000D0031140 => \%orbit_01_00837_def,
   0x00000000D0031150 => \%orbit_01_00838_def,
   0x00000000D0031160 => \%orbit_01_00839_def,
   0x00000000D0031170 => \%orbit_01_00840_def,
   0x00000000D0031200 => \%orbit_01_00841_def,
   0x00000000D0031210 => \%orbit_01_00842_def,
   0x00000000D0031220 => \%orbit_01_00843_def,
   0x00000000D0031230 => \%orbit_01_00844_def,
   0x00000000D0031240 => \%orbit_01_00845_def,
   0x00000000D0031250 => \%orbit_01_00846_def,
   0x00000000D0031260 => \%orbit_01_00847_def,
   0x00000000D0031270 => \%orbit_01_00848_def,
   0x00000000D0031280 => \%orbit_01_00849_def,
   0x00000000D0031290 => \%orbit_01_00850_def,
   0x00000000D00312A0 => \%orbit_01_00851_def,
   0x00000000D00312B0 => \%orbit_01_00852_def,
   0x00000000D00312C0 => \%orbit_01_00853_def,
   0x00000000D00312D0 => \%orbit_01_00854_def,
   0x00000000D00312E0 => \%orbit_01_00855_def,
   0x00000000D00312F0 => \%orbit_01_00856_def,
   0x00000000D00310C0 => \%orbit_01_00857_def,
   0x00000000D0031700 => \%orbit_01_00858_def,
   0x00000000D0031710 => \%orbit_01_00859_def,
   0x00000000D0031720 => \%orbit_01_00860_def,
   0x00000000D0031730 => \%orbit_01_00861_def,
   0x00000000D0031740 => \%orbit_01_00862_def,
   0x00000000D0031750 => \%orbit_01_00863_def,
   0x00000000D0031760 => \%orbit_01_00864_def,
   0x00000000D0031770 => \%orbit_01_00865_def,
   0x00000000D00317C0 => \%orbit_01_00866_def,
   0x00000000D00317D0 => \%orbit_01_00867_def,
   0x00000000D00317E0 => \%orbit_01_00868_def,
   0x00000000D00317F0 => \%orbit_01_00869_def,
   0x00000000D0031800 => \%orbit_01_00870_def,
   0x00000000D0031810 => \%orbit_01_00871_def,
   0x00000000D0031820 => \%orbit_01_00872_def,
   0x00000000D0031830 => \%orbit_01_00873_def,
   0x00000000D0031B40 => \%orbit_01_00874_def,
   0x00000000D0031B50 => \%orbit_01_00875_def,
   0x00000000D0031B60 => \%orbit_01_00876_def,
   0x00000000D0031B70 => \%orbit_01_00877_def,
   0x00000000D00310E0 => \%orbit_01_00878_def,
   0x00000000D0031900 => \%orbit_01_00879_def,
   0x00000000D0031910 => \%orbit_01_00880_def,
   0x00000000D0031920 => \%orbit_01_00881_def,
   0x00000000D0031930 => \%orbit_01_00882_def,
   0x00000000D0031940 => \%orbit_01_00883_def,
   0x00000000D0031950 => \%orbit_01_00884_def,
   0x00000000D0031960 => \%orbit_01_00885_def,
   0x00000000D0031970 => \%orbit_01_00886_def,
   0x00000000D00319C0 => \%orbit_01_00887_def,
   0x00000000D00319D0 => \%orbit_01_00888_def,
   0x00000000D00319E0 => \%orbit_01_00889_def,
   0x00000000D00319F0 => \%orbit_01_00890_def,
   0x00000000D0031A00 => \%orbit_01_00891_def,
   0x00000000D0031A10 => \%orbit_01_00892_def,
   0x00000000D0031A20 => \%orbit_01_00893_def,
   0x00000000D0031A30 => \%orbit_01_00894_def,
   0x00000000D0031BC0 => \%orbit_01_00895_def,
   0x00000000D0031BD0 => \%orbit_01_00896_def,
   0x00000000D0031BE0 => \%orbit_01_00897_def,
   0x00000000D0031BF0 => \%orbit_01_00898_def,
   0x00000000D00310A0 => \%orbit_01_00899_def,
   0x00000000D0031300 => \%orbit_01_00900_def,
   0x00000000D0031310 => \%orbit_01_00901_def,
   0x00000000D0031320 => \%orbit_01_00902_def,
   0x00000000D0031330 => \%orbit_01_00903_def,
   0x00000000D0031340 => \%orbit_01_00904_def,
   0x00000000D0031350 => \%orbit_01_00905_def,
   0x00000000D0031360 => \%orbit_01_00906_def,
   0x00000000D0031370 => \%orbit_01_00907_def,
   0x00000000D0031380 => \%orbit_01_00908_def,
   0x00000000D0031390 => \%orbit_01_00909_def,
   0x00000000D00313A0 => \%orbit_01_00910_def,
   0x00000000D00313B0 => \%orbit_01_00911_def,
   0x00000000D0031400 => \%orbit_01_00912_def,
   0x00000000D0031410 => \%orbit_01_00913_def,
   0x00000000D0031440 => \%orbit_01_00914_def,
   0x00000000D0031450 => \%orbit_01_00915_def,
   0x00000000D0031080 => \%orbit_01_00916_def,
   0x00000000D0031500 => \%orbit_01_00917_def,
   0x00000000D0031510 => \%orbit_01_00918_def,
   0x00000000D0031520 => \%orbit_01_00919_def,
   0x00000000D0031530 => \%orbit_01_00920_def,
   0x00000000D0031540 => \%orbit_01_00921_def,
   0x00000000D0031550 => \%orbit_01_00922_def,
   0x00000000D0031560 => \%orbit_01_00923_def,
   0x00000000D0031570 => \%orbit_01_00924_def,
   0x00000000D0031580 => \%orbit_01_00925_def,
   0x00000000D0031590 => \%orbit_01_00926_def,
   0x00000000D00315A0 => \%orbit_01_00927_def,
   0x00000000D00315B0 => \%orbit_01_00928_def,
   0x00000000D00315C0 => \%orbit_01_00929_def,
   0x00000000D00315D0 => \%orbit_01_00930_def,
   0x00000000D00315E0 => \%orbit_01_00931_def,
   0x00000000D00315F0 => \%orbit_01_00932_def,
   0x00000000D0032050 => \%orbit_01_00933_def,
   0x00000000D0032060 => \%orbit_01_00934_def,
   0x00000000D0032070 => \%orbit_01_00935_def,
   0x00000000D0032080 => \%orbit_01_00936_def,
   0x00000000D0032090 => \%orbit_01_00937_def,
   0x00000000D00320A0 => \%orbit_01_00938_def,
   0x00000000D0040500 => \%orbit_01_00939_def,
   0x00000000D0040508 => \%orbit_01_00940_def,
   0x00000000D0040510 => \%orbit_01_00941_def,
   0x00000000D0040518 => \%orbit_01_00942_def,
   0x00000000D0040520 => \%orbit_01_00943_def,
   0x00000000D0040528 => \%orbit_01_00944_def,
   0x00000000D0040530 => \%orbit_01_00945_def,
   0x00000000D0040538 => \%orbit_01_00946_def,
   0x00000000D0040540 => \%orbit_01_00947_def,
   0x00000000D0040550 => \%orbit_01_00948_def,
   0x00000000D0040560 => \%orbit_01_00949_def,
   0x00000000D0040570 => \%orbit_01_00950_def,
   0x00000000D0040580 => \%orbit_01_00951_def,
   0x00000000D0040590 => \%orbit_01_00952_def,
   0x00000000D0040600 => \%orbit_01_00953_def,
   0x00000000D0040608 => \%orbit_01_00954_def,
   0x00000000D0040610 => \%orbit_01_00955_def,
   0x00000000D0040618 => \%orbit_01_00956_def,
   0x00000000D0040620 => \%orbit_01_00957_def,
   0x00000000D0040628 => \%orbit_01_00958_def,
   0x00000000D0040630 => \%orbit_01_00959_def,
   0x00000000D0040638 => \%orbit_01_00960_def,
   0x00000000D0040640 => \%orbit_01_00961_def,
   0x00000000D0040650 => \%orbit_01_00962_def,
   0x00000000D0040660 => \%orbit_01_00963_def,
   0x00000000D0040670 => \%orbit_01_00964_def,
   0x00000000D0040680 => \%orbit_01_00965_def,
   0x00000000D0040690 => \%orbit_01_00966_def,
   0x00000000D0040070 => \%orbit_01_00967_def,
   0x00000000D0040080 => \%orbit_01_00968_def,
   0x00000000D0040090 => \%orbit_01_00969_def,
   0x00000000D00400A0 => \%orbit_01_00970_def,
   0x00000000D00400B0 => \%orbit_01_00971_def,
   0x00000000D00400C0 => \%orbit_01_00972_def,
   0x00000000D00400D0 => \%orbit_01_00973_def,
   0x00000000D00400E0 => \%orbit_01_00974_def,
   0x00000000D00400F0 => \%orbit_01_00975_def,
   0x00000000D0040100 => \%orbit_01_00976_def,
   0x00000000D0040110 => \%orbit_01_00977_def,
   0x00000000D0040120 => \%orbit_01_00978_def,
   0x00000000D0040130 => \%orbit_01_00979_def,
   0x00000000D0040140 => \%orbit_01_00980_def,
   0x00000000D0040150 => \%orbit_01_00981_def,
   0x00000000D0040160 => \%orbit_01_00982_def,
   0x00000000D0040170 => \%orbit_01_00983_def,
   0x00000000D0040000 => \%orbit_01_00984_def,
   0x00000000D0040008 => \%orbit_01_00985_def,
   0x00000000D0040020 => \%orbit_01_00986_def,
   0x00000000D0040028 => \%orbit_01_00987_def,
   0x00000000D0040040 => \%orbit_01_00988_def,
   0x00000000D0040060 => \%orbit_01_00989_def,
   0x00000000D0040200 => \%orbit_01_00990_def,
   0x00000000D0040208 => \%orbit_01_00991_def,
   0x00000000D0040220 => \%orbit_01_00992_def,
   0x00000000D0040228 => \%orbit_01_00993_def,
   0x00000000D0040240 => \%orbit_01_00994_def,
   0x00000000D0040260 => \%orbit_01_00995_def,
   0x00000000D0040210 => \%orbit_01_00996_def,
   0x00000000D0040218 => \%orbit_01_00997_def,
   0x00000000D0040230 => \%orbit_01_00998_def,
   0x00000000D0040238 => \%orbit_01_00999_def,
   0x00000000D0040250 => \%orbit_01_01000_def,
   0x00000000D0040270 => \%orbit_01_01001_def,
   0x00000000D0040300 => \%orbit_01_01002_def,
   0x00000000D0040308 => \%orbit_01_01003_def,
   0x00000000D0040320 => \%orbit_01_01004_def,
   0x00000000D0040328 => \%orbit_01_01005_def,
   0x00000000D0040340 => \%orbit_01_01006_def,
   0x00000000D0040360 => \%orbit_01_01007_def,
   0x00000000D0040400 => \%orbit_01_01008_def,
   0x00000000D0040408 => \%orbit_01_01009_def,
   0x00000000D0040420 => \%orbit_01_01010_def,
   0x00000000D0040428 => \%orbit_01_01011_def,
   0x00000000D0040440 => \%orbit_01_01012_def,
   0x00000000D0040460 => \%orbit_01_01013_def,
);

@orbit_01_sorted_mmr_name = 
(
   "OC_ASIC_TO_L1_DATA",
   "OC_ASIC_TO_L1_STATUS",
   "OC_AUTO_REPLY_ENABLE0",
   "OC_AUTO_REPLY_ENABLE1",
   "OC_AUTO_REPLY_HEADER0",
   "OC_AUTO_REPLY_HEADER1",
   "OC_COMPARE_COMPARE_MASK",
   "OC_COMPARE_COMPARE_PATTERN",
   "OC_COMPARE_SEL",
   "OC_CPU_PERM0",
   "OC_CPU_PERM1",
   "OC_CPU_PERM2",
   "OC_CPU_PERM3",
   "OC_CPU_PERM_OVR",
   "OC_CRB_TIMEOUT_PRESCALE",
   "OC_DEBUG_PORT",
   "OC_DEBUG_SELECT",
   "OC_DIAG_MSG_CNTRL",
   "OC_DIAG_MSG_DATA0L",
   "OC_DIAG_MSG_DATA0U",
   "OC_DIAG_MSG_DATA1L",
   "OC_DIAG_MSG_DATA1U",
   "OC_DIAG_MSG_DATA2L",
   "OC_DIAG_MSG_DATA2U",
   "OC_DIAG_MSG_DATA3L",
   "OC_DIAG_MSG_DATA3U",
   "OC_DIAG_MSG_DATA4L",
   "OC_DIAG_MSG_DATA4U",
   "OC_DIAG_MSG_DATA5L",
   "OC_DIAG_MSG_DATA5U",
   "OC_DIAG_MSG_DATA6L",
   "OC_DIAG_MSG_DATA6U",
   "OC_DIAG_MSG_DATA7L",
   "OC_DIAG_MSG_DATA7U",
   "OC_DIAG_MSG_DATA8L",
   "OC_DIAG_MSG_DATA8U",
   "OC_DIAG_MSG_HDR0",
   "OC_DIAG_MSG_HDR1",
   "OC_DIR_COR_ADRS_ERR_HDR_LOWER_A",
   "OC_DIR_COR_ERR_HDR_LOWER",
   "OC_DIR_COR_ERR_HDR_UPPER",
   "OC_DIR_UC_ADRS_ERR_HDR_LOWER_A",
   "OC_DIR_UC_ERR_HDR_LOWER",
   "OC_DIR_UC_ERR_HDR_UPPER",
   "OC_ENABLE_RP_AUTO_REPLY",
   "OC_ENABLE_RQ_AUTO_REPLY",
   "OC_EXT_IOI_ACCESS0",
   "OC_EXT_IOI_ACCESS1",
   "OC_EXT_IOI_ACCESS2",
   "OC_EXT_IOI_ACCESS3",
   "OC_EXT_IO_PERM0",
   "OC_EXT_IO_PERM1",
   "OC_EXT_IO_PERM2",
   "OC_EXT_IO_PERM3",
   "OC_FIRST_ERROR",
   "OC_GC_FIL_CTRL",
   "OC_GC_SRC_CTRL",
   "OC_GFX_CREDIT_COUNT_0",
   "OC_GFX_CREDIT_COUNT_1",
   "OC_GFX_DFIFO_LOW_H2O_MARK",
   "OC_GFX_FIFO_LOW_H2O_MARK",
   "OC_GFX_MODE_CNTRL_0",
   "OC_GFX_MODE_CNTRL_1",
   "OC_GFX_SKID_CREDIT_COUNT_0",
   "OC_GFX_SKID_CREDIT_COUNT_1",
   "OC_GFX_STALL_LIMIT_0",
   "OC_GFX_STALL_LIMIT_1",
   "OC_GFX_STALL_TIMER_0",
   "OC_GFX_STALL_TIMER_1",
   "OC_GFX_TIMEOUT_PRESCALE",
   "OC_GFX_WINDOW_0",
   "OC_GFX_WINDOW_1",
   "OC_GFX_WRITE_STATUS_0",
   "OC_GFX_WRITE_STATUS_1",
   "OC_HARD_RESET",
   "OC_HW_ERR_INT_ENABLE",
   "OC_HW_STAT_INT_ENABLE",
   "OC_IILB_GLOBAL_TABLE",
   "OC_IILB_LOCAL_TABLE",
   "OC_IILB_OVER_RIDE_TABLE",
   "OC_II_DEBUG_DATA",
   "OC_II_DEBUG_SELECT",
   "OC_II_HW_INT_TIME_STAMP",
   "OC_II_NRE_INT_TIME_STAMP",
   "OC_II_RE_INT_TIME_STAMP",
   "OC_II_WRAP_DEBUG_DATA",
   "OC_INT_CMPA",
   "OC_INT_CMPB",
   "OC_INT_CMPC",
   "OC_INT_CMPD",
   "OC_INT_NODE_ID_CONFIG",
   "OC_INT_PROF",
   "OC_IOI_ACCESS0",
   "OC_IOI_ACCESS1",
   "OC_IOI_ACCESS2",
   "OC_IOI_ACCESS3",
   "OC_IO_PERM0",
   "OC_IO_PERM1",
   "OC_IO_PERM2",
   "OC_IO_PERM3",
   "OC_IPI_ACCESS0",
   "OC_IPI_ACCESS1",
   "OC_IPI_ACCESS2",
   "OC_IPI_ACCESS3",
   "OC_JNR_DIMM_CFG",
   "OC_JTAG_CONFIG",
   "OC_JUNK_BUS_LED0",
   "OC_JUNK_BUS_LED1",
   "OC_JUNK_BUS_LED2",
   "OC_JUNK_BUS_LED3",
   "OC_JUNK_BUS_TIME",
   "OC_JUNK_NACK_RESET",
   "OC_L1_TO_ASIC_DATA",
   "OC_L1_TO_ASIC_STATUS",
   "OC_L2_INT_PEND0",
   "OC_L2_INT_PEND1",
   "OC_L2_PEND_MOD",
   "OC_L3_INT_PEND",
   "OC_L3_PEND_MOD",
   "OC_L4_INT_PEND",
   "OC_L4_PEND_MOD",
   "OC_L5_INT_PEND",
   "OC_L5_PEND_MOD",
   "OC_L6_INT_PEND",
   "OC_L6_PEND_MOD",
   "OC_LB_COMPARE_COMPARE",
   "OC_LB_COMPARE_DATA",
   "OC_LB_CREDIT_STATUS",
   "OC_LB_DEBUG_COMPARE_SEL",
   "OC_LB_DEBUG_DATA",
   "OC_LB_DEBUG_LOCAL_SEL",
   "OC_LB_DEBUG_MUX0_SEL",
   "OC_LB_DEBUG_MUX1_SEL",
   "OC_LB_ERROR_DETAIL_1",
   "OC_LB_ERROR_DETAIL_2",
   "OC_LB_ERROR_DETAIL_3",
   "OC_LB_ERROR_DETAIL_4",
   "OC_LB_ERROR_DETAIL_5",
   "OC_LB_ERROR_MASK",
   "OC_LB_ERROR_OVERFLOW",
   "OC_LB_ERROR_OVERFLOW_ALIAS",
   "OC_LB_ERROR_SUMMARY",
   "OC_LB_ERROR_SUMMARY_ALIAS",
   "OC_LB_FIRST_ERROR",
   "OC_LB_HW_INT_TIME_STAMP",
   "OC_LB_LAST_CREDIT",
   "OC_LB_LIQ_CTL",
   "OC_LB_LOQ_CTL",
   "OC_LB_MAX_INT_CREDIT_CNT",
   "OC_LB_MAX_REP_CREDIT_CNT",
   "OC_LB_MAX_REQ_CREDIT_CNT",
   "OC_LB_NACK_STATUS",
   "OC_LOGIC_ANALYZER_BUFFER",
   "OC_MD_CE_INT_TIME_STAMP",
   "OC_MD_DBUG_COMPARE",
   "OC_MD_DBUG_DATA_CFG",
   "OC_MD_DBUG_TRIGGER_CFG",
   "OC_MD_DEBUG_DATA",
   "OC_MD_DQLP_MMR_AMO_CFG",
   "OC_MD_DQLP_MMR_DIR_CMDTRIG",
   "OC_MD_DQLP_MMR_DIR_CONFIG",
   "OC_MD_DQLP_MMR_DIR_LOCVEC0",
   "OC_MD_DQLP_MMR_DIR_LOCVEC1",
   "OC_MD_DQLP_MMR_DIR_LOCVEC2",
   "OC_MD_DQLP_MMR_DIR_LOCVEC3",
   "OC_MD_DQLP_MMR_DIR_LOCVEC4",
   "OC_MD_DQLP_MMR_DIR_LOCVEC5",
   "OC_MD_DQLP_MMR_DIR_LOCVEC6",
   "OC_MD_DQLP_MMR_DIR_LOCVEC7",
   "OC_MD_DQLP_MMR_DIR_PRESVEC0",
   "OC_MD_DQLP_MMR_DIR_PRESVEC1",
   "OC_MD_DQLP_MMR_DIR_PRESVEC2",
   "OC_MD_DQLP_MMR_DIR_PRESVEC3",
   "OC_MD_DQLP_MMR_DIR_PRIVEC0",
   "OC_MD_DQLP_MMR_DIR_PRIVEC1",
   "OC_MD_DQLP_MMR_DIR_PRIVEC2",
   "OC_MD_DQLP_MMR_DIR_PRIVEC3",
   "OC_MD_DQLP_MMR_DIR_PRIVEC4",
   "OC_MD_DQLP_MMR_DIR_PRIVEC5",
   "OC_MD_DQLP_MMR_DIR_PRIVEC6",
   "OC_MD_DQLP_MMR_DIR_PRIVEC7",
   "OC_MD_DQLP_MMR_DIR_TBLMASK",
   "OC_MD_DQLP_MMR_DIR_TBLTRIG",
   "OC_MD_DQLP_MMR_DIR_TIMER",
   "OC_MD_DQLP_MMR_PIOWD_DIR_ECC",
   "OC_MD_DQLP_MMR_PIOWD_DIR_ENTRY",
   "OC_MD_DQLP_MMR_XBIST_ERR_H",
   "OC_MD_DQLP_MMR_XBIST_ERR_L",
   "OC_MD_DQLP_MMR_XBIST_H",
   "OC_MD_DQLP_MMR_XBIST_L",
   "OC_MD_DQLP_MMR_XCERR1",
   "OC_MD_DQLP_MMR_XCERR2",
   "OC_MD_DQLP_MMR_XPERR",
   "OC_MD_DQLP_MMR_XPIORD_XDIR_ECC",
   "OC_MD_DQLP_MMR_XPIORD_XDIR_ENTRY",
   "OC_MD_DQLP_MMR_XUERR1",
   "OC_MD_DQLP_MMR_XUERR2",
   "OC_MD_DQLP_MMR_YBIST_ERR_H",
   "OC_MD_DQLP_MMR_YBIST_ERR_L",
   "OC_MD_DQLP_MMR_YBIST_H",
   "OC_MD_DQLP_MMR_YBIST_L",
   "OC_MD_DQLP_MMR_YCERR1",
   "OC_MD_DQLP_MMR_YCERR2",
   "OC_MD_DQLP_MMR_YPERR",
   "OC_MD_DQLP_MMR_YPIORD_YDIR_ECC",
   "OC_MD_DQLP_MMR_YPIORD_YDIR_ENTRY",
   "OC_MD_DQLP_MMR_YUERR1",
   "OC_MD_DQLP_MMR_YUERR2",
   "OC_MD_DQLS_MMR_AMO_CFG",
   "OC_MD_DQLS_MMR_JNR_DEBUG",
   "OC_MD_DQLS_MMR_XAMOPW_ERR",
   "OC_MD_DQLS_MMR_XBIST_ERR_H",
   "OC_MD_DQLS_MMR_XBIST_ERR_L",
   "OC_MD_DQLS_MMR_XBIST_H",
   "OC_MD_DQLS_MMR_XBIST_L",
   "OC_MD_DQLS_MMR_YBIST_ERR_H",
   "OC_MD_DQLS_MMR_YBIST_ERR_L",
   "OC_MD_DQLS_MMR_YBIST_H",
   "OC_MD_DQLS_MMR_YBIST_L",
   "OC_MD_DQRP_MMR_AMO_CFG",
   "OC_MD_DQRP_MMR_DIR_CMDTRIG",
   "OC_MD_DQRP_MMR_DIR_CONFIG",
   "OC_MD_DQRP_MMR_DIR_LOCVEC0",
   "OC_MD_DQRP_MMR_DIR_LOCVEC1",
   "OC_MD_DQRP_MMR_DIR_LOCVEC2",
   "OC_MD_DQRP_MMR_DIR_LOCVEC3",
   "OC_MD_DQRP_MMR_DIR_LOCVEC4",
   "OC_MD_DQRP_MMR_DIR_LOCVEC5",
   "OC_MD_DQRP_MMR_DIR_LOCVEC6",
   "OC_MD_DQRP_MMR_DIR_LOCVEC7",
   "OC_MD_DQRP_MMR_DIR_PRESVEC0",
   "OC_MD_DQRP_MMR_DIR_PRESVEC1",
   "OC_MD_DQRP_MMR_DIR_PRESVEC2",
   "OC_MD_DQRP_MMR_DIR_PRESVEC3",
   "OC_MD_DQRP_MMR_DIR_PRIVEC0",
   "OC_MD_DQRP_MMR_DIR_PRIVEC1",
   "OC_MD_DQRP_MMR_DIR_PRIVEC2",
   "OC_MD_DQRP_MMR_DIR_PRIVEC3",
   "OC_MD_DQRP_MMR_DIR_PRIVEC4",
   "OC_MD_DQRP_MMR_DIR_PRIVEC5",
   "OC_MD_DQRP_MMR_DIR_PRIVEC6",
   "OC_MD_DQRP_MMR_DIR_PRIVEC7",
   "OC_MD_DQRP_MMR_DIR_TBLMASK",
   "OC_MD_DQRP_MMR_DIR_TBLTRIG",
   "OC_MD_DQRP_MMR_DIR_TIMER",
   "OC_MD_DQRP_MMR_PIOWD_DIR_ECC",
   "OC_MD_DQRP_MMR_PIOWD_DIR_ENTRY",
   "OC_MD_DQRP_MMR_XBIST_ERR_H",
   "OC_MD_DQRP_MMR_XBIST_ERR_L",
   "OC_MD_DQRP_MMR_XBIST_H",
   "OC_MD_DQRP_MMR_XBIST_L",
   "OC_MD_DQRP_MMR_XCERR1",
   "OC_MD_DQRP_MMR_XCERR2",
   "OC_MD_DQRP_MMR_XPERR",
   "OC_MD_DQRP_MMR_XPIORD_XDIR_ECC",
   "OC_MD_DQRP_MMR_XPIORD_XDIR_ENTRY",
   "OC_MD_DQRP_MMR_XUERR1",
   "OC_MD_DQRP_MMR_XUERR2",
   "OC_MD_DQRP_MMR_YBIST_ERR_H",
   "OC_MD_DQRP_MMR_YBIST_ERR_L",
   "OC_MD_DQRP_MMR_YBIST_H",
   "OC_MD_DQRP_MMR_YBIST_L",
   "OC_MD_DQRP_MMR_YCERR1",
   "OC_MD_DQRP_MMR_YCERR2",
   "OC_MD_DQRP_MMR_YPERR",
   "OC_MD_DQRP_MMR_YPIORD_YDIR_ECC",
   "OC_MD_DQRP_MMR_YPIORD_YDIR_ENTRY",
   "OC_MD_DQRP_MMR_YUERR1",
   "OC_MD_DQRP_MMR_YUERR2",
   "OC_MD_DQRS_MMR_AMO_CFG",
   "OC_MD_DQRS_MMR_JNR_DEBUG",
   "OC_MD_DQRS_MMR_XBIST_ERR_H",
   "OC_MD_DQRS_MMR_XBIST_ERR_L",
   "OC_MD_DQRS_MMR_XBIST_H",
   "OC_MD_DQRS_MMR_XBIST_L",
   "OC_MD_DQRS_MMR_YAMOPW_ERR",
   "OC_MD_DQRS_MMR_YBIST_ERR_H",
   "OC_MD_DQRS_MMR_YBIST_ERR_L",
   "OC_MD_DQRS_MMR_YBIST_H",
   "OC_MD_DQRS_MMR_YBIST_L",
   "OC_MD_GLOBAL_TABLE",
   "OC_MD_HW_INT_TIME_STAMP",
   "OC_MD_JNR_DBUG_DATA_CFG",
   "OC_MD_LAST_CREDIT",
   "OC_MD_LOCAL_TABLE",
   "OC_MD_NRE_INT_TIME_STAMP",
   "OC_MD_OVER_RIDE_TABLE",
   "OC_MD_RE_INT_TIME_STAMP",
   "OC_MD_RSP_PLANE_HINT",
   "OC_MD_UCE_INT_TIME_STAMP",
   "OC_MEM_CAPTURE_ADDR",
   "OC_MEM_CAPTURE_HDR",
   "OC_MEM_CAPTURE_HDR_ADDR",
   "OC_MEM_CAPTURE_MASK",
   "OC_MEM_ERROR_MASK",
   "OC_MEM_ERROR_OVERFLOW",
   "OC_MEM_ERROR_OVERFLOW_ALIAS",
   "OC_MEM_ERROR_SUMMARY",
   "OC_MEM_ERROR_SUMMARY_ALIAS",
   "OC_MEM_RED_BLACK",
   "OC_MISC_ADRS_ERR_HDR_LOWER_A",
   "OC_MISC_ERR_HDR_LOWER",
   "OC_MISC_ERR_HDR_UPPER",
   "OC_MISC_MEM_CFG",
   "OC_MMRBIST_BASE",
   "OC_MMRBIST_CTL",
   "OC_MMRBIST_ERR",
   "OC_NCOH_MESSAGE_CONTROL",
   "OC_NI0_ERROR_DETAIL_1",
   "OC_NI0_ERROR_DETAIL_2",
   "OC_NI0_ERROR_DETAIL_3",
   "OC_NI0_ERROR_MASK_1",
   "OC_NI0_ERROR_MASK_2",
   "OC_NI0_ERROR_OVERFLOW_1",
   "OC_NI0_ERROR_OVERFLOW_1_ALIAS",
   "OC_NI0_ERROR_OVERFLOW_2",
   "OC_NI0_ERROR_OVERFLOW_2_ALIAS",
   "OC_NI0_ERROR_SUMMARY_1",
   "OC_NI0_ERROR_SUMMARY_1_ALIAS",
   "OC_NI0_ERROR_SUMMARY_2",
   "OC_NI0_ERROR_SUMMARY_2_ALIAS",
   "OC_NI0_FIRST_ERROR_1",
   "OC_NI0_FIRST_ERROR_2",
   "OC_NI0_GLOBAL_TABLE",
   "OC_NI0_LLP_CAPT_SBCB",
   "OC_NI0_LLP_CAPT_WD1",
   "OC_NI0_LLP_CAPT_WD2",
   "OC_NI0_LLP_CHAN_MODE",
   "OC_NI0_LLP_CONFIG",
   "OC_NI0_LLP_ERR",
   "OC_NI0_LLP_RESET",
   "OC_NI0_LLP_RESET_EN",
   "OC_NI0_LLP_STAT",
   "OC_NI0_LLP_TEST_CTL",
   "OC_NI0_LOCAL_TABLE",
   "OC_NI0_OVER_RIDE_TABLE",
   "OC_NI1_ERROR_DETAIL_1",
   "OC_NI1_ERROR_DETAIL_2",
   "OC_NI1_ERROR_DETAIL_3",
   "OC_NI1_ERROR_MASK_1",
   "OC_NI1_ERROR_MASK_2",
   "OC_NI1_ERROR_OVERFLOW_1",
   "OC_NI1_ERROR_OVERFLOW_1_ALIAS",
   "OC_NI1_ERROR_OVERFLOW_2",
   "OC_NI1_ERROR_OVERFLOW_2_ALIAS",
   "OC_NI1_ERROR_SUMMARY_1",
   "OC_NI1_ERROR_SUMMARY_1_ALIAS",
   "OC_NI1_ERROR_SUMMARY_2",
   "OC_NI1_ERROR_SUMMARY_2_ALIAS",
   "OC_NI1_FIRST_ERROR_1",
   "OC_NI1_FIRST_ERROR_2",
   "OC_NI1_GLOBAL_TABLE",
   "OC_NI1_LLP_CAPT_SBCB",
   "OC_NI1_LLP_CAPT_WD1",
   "OC_NI1_LLP_CAPT_WD2",
   "OC_NI1_LLP_CHAN_MODE",
   "OC_NI1_LLP_CONFIG",
   "OC_NI1_LLP_ERR",
   "OC_NI1_LLP_RESET",
   "OC_NI1_LLP_RESET_EN",
   "OC_NI1_LLP_STAT",
   "OC_NI1_LLP_TEST_CTL",
   "OC_NI1_LOCAL_TABLE",
   "OC_NI1_OVER_RIDE_TABLE",
   "OC_NMI_INT_ENABLE",
   "OC_NMI_INT_PEND",
   "OC_NMI_PEND_MOD",
   "OC_NODE_PRESENT_TABLE",
   "OC_OB_LA_CONTROL",
   "OC_OB_LA_CURRENT_ADDR",
   "OC_OB_LA_END_ADDRESS",
   "OC_OB_LA_SEQUENCE",
   "OC_OB_LA_START_ADDRESS",
   "OC_OB_LA_START_CONTROL",
   "OC_OB_LA_STATUS",
   "OC_OB_LA_STOP_CONTROL",
   "OC_ORBITS_PRESENT0",
   "OC_ORBITS_PRESENT1",
   "OC_ORBITS_PRESENT2",
   "OC_ORBITS_PRESENT3",
   "OC_ORBIT_ID",
   "OC_P0_L2_INT_MASK0",
   "OC_P0_L2_INT_MASK1",
   "OC_P0_L2_INT_STATUS0",
   "OC_P0_L2_INT_STATUS1",
   "OC_P0_L3_INT_MASK",
   "OC_P0_L3_INT_STATUS",
   "OC_P0_L4_INT_MASK",
   "OC_P0_L4_INT_STATUS",
   "OC_P0_L5_INT_MASK",
   "OC_P0_L5_INT_STATUS",
   "OC_P0_L6_INT_MASK",
   "OC_P0_L6_INT_STATUS",
   "OC_P1_L2_INT_MASK0",
   "OC_P1_L2_INT_MASK1",
   "OC_P1_L2_INT_STATUS0",
   "OC_P1_L2_INT_STATUS1",
   "OC_P1_L3_INT_MASK",
   "OC_P1_L3_INT_STATUS",
   "OC_P1_L4_INT_MASK",
   "OC_P1_L4_INT_STATUS",
   "OC_P1_L5_INT_MASK",
   "OC_P1_L5_INT_STATUS",
   "OC_P1_L6_INT_MASK",
   "OC_P1_L6_INT_STATUS",
   "OC_P2_L2_INT_MASK0",
   "OC_P2_L2_INT_MASK1",
   "OC_P2_L2_INT_STATUS0",
   "OC_P2_L2_INT_STATUS1",
   "OC_P2_L3_INT_MASK",
   "OC_P2_L3_INT_STATUS",
   "OC_P2_L4_INT_MASK",
   "OC_P2_L4_INT_STATUS",
   "OC_P2_L5_INT_MASK",
   "OC_P2_L5_INT_STATUS",
   "OC_P2_L6_INT_MASK",
   "OC_P2_L6_INT_STATUS",
   "OC_P3_L2_INT_MASK0",
   "OC_P3_L2_INT_MASK1",
   "OC_P3_L2_INT_STATUS0",
   "OC_P3_L2_INT_STATUS1",
   "OC_P3_L3_INT_MASK",
   "OC_P3_L3_INT_STATUS",
   "OC_P3_L4_INT_MASK",
   "OC_P3_L4_INT_STATUS",
   "OC_P3_L5_INT_MASK",
   "OC_P3_L5_INT_STATUS",
   "OC_P3_L6_INT_MASK",
   "OC_P3_L6_INT_STATUS",
   "OC_PERFORMANCE_COUNT0_CONTROL",
   "OC_PERFORMANCE_COUNT1_CONTROL",
   "OC_PERFORMANCE_COUNT2_CONTROL",
   "OC_PERFORMANCE_COUNT3_CONTROL",
   "OC_PERFORMANCE_COUNT4_CONTROL",
   "OC_PERFORMANCE_COUNT5_CONTROL",
   "OC_PERFORMANCE_COUNT6_CONTROL",
   "OC_PERFORMANCE_COUNT7_CONTROL",
   "OC_PERFORMANCE_COUNTER0",
   "OC_PERFORMANCE_COUNTER1",
   "OC_PERFORMANCE_COUNTER2",
   "OC_PERFORMANCE_COUNTER3",
   "OC_PERFORMANCE_COUNTER4",
   "OC_PERFORMANCE_COUNTER5",
   "OC_PERFORMANCE_COUNTER6",
   "OC_PERFORMANCE_COUNTER7",
   "OC_PERFORMANCE_MONITOR_DESKEW",
   "OC_PIO_FIFO_LOW_H2O_MARK",
   "OC_PIO_RQ_CRD_CTL",
   "OC_PIO_TIMEOUT_PRESCALE",
   "OC_PIO_TIME_OUT",
   "OC_PIO_WRITE_STATUS_0",
   "OC_PIO_WRITE_STATUS_0_ALIAS",
   "OC_PIO_WRITE_STATUS_1",
   "OC_PIO_WRITE_STATUS_1_ALIAS",
   "OC_PIO_WRITE_STATUS_2",
   "OC_PIO_WRITE_STATUS_2_ALIAS",
   "OC_PIO_WRITE_STATUS_3",
   "OC_PIO_WRITE_STATUS_3_ALIAS",
   "OC_PI_BAD_DATA_ERR",
   "OC_PI_BAD_REQUEST_ERR",
   "OC_PI_BAD_STATE_RESP_ERR",
   "OC_PI_CAM_ACCESS_CNTL",
   "OC_PI_CAM_ADDRESS_DATA",
   "OC_PI_CAM_MEM_DATA",
   "OC_PI_CAM_STATE_DATA",
   "OC_PI_CE_INT_TIME_STAMP",
   "OC_PI_CRB_AUTO_REPLY_ENABLE",
   "OC_PI_CRB_BUF_ERR",
   "OC_PI_CRB_CDR_FLW_CNTL",
   "OC_PI_CRB_MESSAGE_CONTROL",
   "OC_PI_CRB_MUX0_TP_COMPARE",
   "OC_PI_CRB_MUX0_TP_SELECT",
   "OC_PI_CRB_MUX0_TP_TRIGGER_SELECT",
   "OC_PI_CRB_MUX1_TP_COMPARE",
   "OC_PI_CRB_MUX1_TP_SELECT",
   "OC_PI_CRB_MUX1_TP_TRIGGER_SELECT",
   "OC_PI_CRB_MUX2_TP_COMPARE",
   "OC_PI_CRB_MUX2_TP_SELECT",
   "OC_PI_CRB_MUX2_TP_TRIGGER_SELECT",
   "OC_PI_CRB_NACK_LIMIT",
   "OC_PI_CRB_NODE_PRESENT_TABLE",
   "OC_PI_CRB_PROC_REQ_HDR_COMPARE",
   "OC_PI_CRB_PROC_REQ_HDR_MASK",
   "OC_PI_CRB_PROC_RSP_HDR_COMPARE",
   "OC_PI_CRB_PROC_RSP_HDR_MASK",
   "OC_PI_CRB_RD_FLW_CNTL",
   "OC_PI_CRB_SUPPL_INIT",
   "OC_PI_CRB_SYS_REQ_HDR_COMPARE",
   "OC_PI_CRB_SYS_REQ_HDR_MASK",
   "OC_PI_CRB_SYS_RSP_HDR_COMPARE",
   "OC_PI_CRB_SYS_RSP_HDR_MASK",
   "OC_PI_CRB_TIMEOUT_CNTL",
   "OC_PI_CRB_WR_FLW_CNTL",
   "OC_PI_DATA_TEST_POINT_COMPARE0",
   "OC_PI_DATA_TEST_POINT_COMPARE1",
   "OC_PI_DATA_TEST_POINT_COMPARE2",
   "OC_PI_DATA_TEST_POINT_SELECT0",
   "OC_PI_DATA_TEST_POINT_SELECT1",
   "OC_PI_DATA_TEST_POINT_SELECT2",
   "OC_PI_DATA_TEST_POINT_TRIGGER_SELECT0",
   "OC_PI_DATA_TEST_POINT_TRIGGER_SELECT1",
   "OC_PI_DATA_TEST_POINT_TRIGGER_SELECT2",
   "OC_PI_DEBUG_DATA",
   "OC_PI_ERROR_SELECT",
   "OC_PI_ERR_SPOOL0_ADDR",
   "OC_PI_ERR_SPOOL1_ADDR",
   "OC_PI_ERR_SPOOL2_ADDR",
   "OC_PI_ERR_SPOOL3_ADDR",
   "OC_PI_ERR_SPOOL_COUNT_0_1",
   "OC_PI_ERR_SPOOL_COUNT_2_3",
   "OC_PI_ERR_SPOOL_COUNT_COMPARE_0_1",
   "OC_PI_ERR_SPOOL_COUNT_COMPARE_2_3",
   "OC_PI_ERR_SPOOL_MASK",
   "OC_PI_ERR_SPOOL_SIZE",
   "OC_PI_EVENT_MASK",
   "OC_PI_EVENT_SUMMARY",
   "OC_PI_EVENT_SUMMARY_ALIAS",
   "OC_PI_FIRST_ERROR",
   "OC_PI_FIRST_ERROR_ALIAS",
   "OC_PI_GFX_FIFO_ERR",
   "OC_PI_GLOBAL_TABLE",
   "OC_PI_HW_INT_TIME_STAMP",
   "OC_PI_HXB_TEST_POINT_COMPARE",
   "OC_PI_HXB_TEST_POINT_SELECT",
   "OC_PI_HXB_TEST_POINT_TRIGGER_SELECT",
   "OC_PI_INTV_SYSSTATE_FIFO_ERR",
   "OC_PI_INTV_TIMEOUT_ERR",
   "OC_PI_IO_RD_ACCESS_ERR",
   "OC_PI_IO_RD_CORR_DATA_ERR",
   "OC_PI_IO_RD_PKT_LEN_ERR",
   "OC_PI_IO_RD_SPURIOUS_MSG_ERR",
   "OC_PI_IO_RD_TO_ERR",
   "OC_PI_IO_RD_UNCORR_DATA_ERR",
   "OC_PI_IO_WR_ACCESS_ERR",
   "OC_PI_IO_WR_CORR_DATA_ERR",
   "OC_PI_IO_WR_PKT_LEN_ERR",
   "OC_PI_IO_WR_SPURIOUS_MSG_ERR",
   "OC_PI_IO_WR_TO_ERR",
   "OC_PI_IO_WR_UNCORR_DATA_ERR",
   "OC_PI_LOCAL_TABLE",
   "OC_PI_MD2PI_REPLY_VC_CONFIG",
   "OC_PI_MD2PI_REPLY_VC_STATUS",
   "OC_PI_MD2PI_REQUEST_VC_CONFIG",
   "OC_PI_MD2PI_REQUEST_VC_STATUS",
   "OC_PI_MD_RP_CRD_CTL",
   "OC_PI_MD_RP_CRD_OFLOW_ERR",
   "OC_PI_MD_RP_Q_OFLOW_ERR",
   "OC_PI_MD_RQ_CRD_CTL",
   "OC_PI_MD_RQ_CRD_OFLOW_ERR",
   "OC_PI_MD_RQ_Q_OFLOW_ERR",
   "OC_PI_MEM_RD_ACCESS_ERR",
   "OC_PI_MEM_RD_CORR_DATA_ERR",
   "OC_PI_MEM_RD_DIR_ERR",
   "OC_PI_MEM_RD_NACK_CNT_ERR",
   "OC_PI_MEM_RD_PKT_LEN_ERR",
   "OC_PI_MEM_RD_POISON_ERR",
   "OC_PI_MEM_RD_SPURIOUS_MSG_ERR",
   "OC_PI_MEM_RD_TO_ERR",
   "OC_PI_MEM_RD_UNCORR_DATA_ERR",
   "OC_PI_MEM_SPURIOUS_WR_MSG_ERR",
   "OC_PI_MEM_WR_ACCESS_ERR",
   "OC_PI_MEM_WR_CORR_DATA_ERR",
   "OC_PI_MEM_WR_DIR_ERR",
   "OC_PI_MEM_WR_PKT_LEN_ERR",
   "OC_PI_MEM_WR_TO_ERR",
   "OC_PI_MEM_WR_UNCORR_DATA_ERR",
   "OC_PI_NCRP_TEST_POINT_COMPARE",
   "OC_PI_NCRP_TEST_POINT_SELECT",
   "OC_PI_NCRP_TEST_POINT_TRIGGER_SELECT",
   "OC_PI_NRE_INT_TIME_STAMP",
   "OC_PI_ORBIT_CE_ERR",
   "OC_PI_ORBIT_UCE_ERR",
   "OC_PI_OVER_RIDE_TABLE",
   "OC_PI_PI2MD_REPLY_VC_STATUS",
   "OC_PI_PI2MD_REQUEST_VC_STATUS",
   "OC_PI_PI2XN_REPLY_VC_STATUS",
   "OC_PI_PI2XN_REQUEST_VC_STATUS",
   "OC_PI_PIO_FIFO_ERR",
   "OC_PI_PI_DATA_RESP_PATH_ERR",
   "OC_PI_PI_DATA_WR_PATH_ERR",
   "OC_PI_PROC_MEM_REQ_TBL_MISS",
   "OC_PI_RD_SYSSTATE_FIFO_ERR",
   "OC_PI_RE_INT_TIME_STAMP",
   "OC_PI_RSP_PLANE_HINT",
   "OC_PI_SYSTF_CE_ERR",
   "OC_PI_SYSTF_COMPARE_MASK",
   "OC_PI_SYSTF_COMPARE_VALUE",
   "OC_PI_SYSTF_ERROR_INJECTION",
   "OC_PI_SYSTF_UCE_ERR",
   "OC_PI_SYS_MEM_REQ_TBL_MISS",
   "OC_PI_SYS_MEM_RSP_TBL_MISS",
   "OC_PI_TEST_POINT_COMPARE",
   "OC_PI_TEST_POINT_SELECT",
   "OC_PI_TEST_POINT_TRIGGER_SELECT",
   "OC_PI_UCE_INT_TIME_STAMP",
   "OC_PI_XN2PI_REPLY_VC_CONFIG",
   "OC_PI_XN2PI_REPLY_VC_STATUS",
   "OC_PI_XN2PI_REQUEST_VC_CONFIG",
   "OC_PI_XN2PI_REQUEST_VC_STATUS",
   "OC_PI_XN_RP_CRD_OFLOW_ERR",
   "OC_PI_XN_RP_Q_OFLOW_ERR",
   "OC_PI_XN_RQ_CRD_OFLOW_ERR",
   "OC_PI_XN_RQ_Q_OFLOW_ERR",
   "OC_PROFILE_COUNTER",
   "OC_PROFILE_DN_CONTROL",
   "OC_PROFILE_INT_ENABLE",
   "OC_PROFILE_PEAK",
   "OC_PROFILE_PEAK_CONTROL",
   "OC_PROFILE_RANGE",
   "OC_PROFILE_UP_CONTROL",
   "OC_REDIRECT_INVAL",
   "OC_RTC",
   "OC_RTC0_INT_ENABLE",
   "OC_RTC1_INT_ENABLE",
   "OC_RTC2_INT_ENABLE",
   "OC_RTC3_INT_ENABLE",
   "OC_SCRATCH0",
   "OC_SCRATCH0_ALIAS",
   "OC_SCRATCH1",
   "OC_SCRATCH10",
   "OC_SCRATCH11",
   "OC_SCRATCH12",
   "OC_SCRATCH1_ALIAS",
   "OC_SCRATCH2",
   "OC_SCRATCH2_ALIAS",
   "OC_SCRATCH3",
   "OC_SCRATCH3_ALIAS",
   "OC_SCRATCH4",
   "OC_SCRATCH4_ALIAS",
   "OC_SCRATCH5",
   "OC_SCRATCH6",
   "OC_SCRATCH7",
   "OC_SCRATCH8",
   "OC_SCRATCH9",
   "OC_SHUB_INTERRUPT_CONFIG",
   "OC_SOFT_RESET",
   "OC_STOP_CLK_CONTROL",
   "OC_STOP_CLK_DELAY_PHASE",
   "OC_SYSTF_RESET_FORCE_SYNC_BACKFLAP",
   "OC_SYSTF_RESET_MODE_HW_CPU0",
   "OC_SYSTF_RESET_MODE_HW_CPU1",
   "OC_SYSTF_RESET_MODE_SW_CPU0",
   "OC_SYSTF_RESET_MODE_SW_CPU1",
   "OC_SYSTF_RESET_SEQ_DELAY0",
   "OC_SYSTF_RESET_SEQ_DELAY1",
   "OC_SYSTF_RESET_SEQ_DELAY2",
   "OC_SYSTF_RESET_SEQ_DELAY3",
   "OC_SYSTF_RESET_SEQ_DELAY4",
   "OC_SYSTF_RESET_SEQ_DELAY5",
   "OC_SYSTF_RESET_STATUS",
   "OC_TFI_EVENT_TRIGGER",
   "OC_THROTTLE_ENABLE",
   "OC_THROTTLE_INTERVAL",
   "OC_THROTTLE_STATUS",
   "OC_THROTTLE_TIME",
   "OC_TSF_ARMED_STATE",
   "OC_TSF_ARM_MASK",
   "OC_TSF_COMPARE0",
   "OC_TSF_COMPARE1",
   "OC_TSF_COMPARE10",
   "OC_TSF_COMPARE11",
   "OC_TSF_COMPARE12",
   "OC_TSF_COMPARE13",
   "OC_TSF_COMPARE14",
   "OC_TSF_COMPARE15",
   "OC_TSF_COMPARE2",
   "OC_TSF_COMPARE3",
   "OC_TSF_COMPARE4",
   "OC_TSF_COMPARE5",
   "OC_TSF_COMPARE6",
   "OC_TSF_COMPARE7",
   "OC_TSF_COMPARE8",
   "OC_TSF_COMPARE9",
   "OC_TSF_COUNTER_PRESETS",
   "OC_TSF_COUNTER_VALUE",
   "OC_TSF_DECREMENT_CTL",
   "OC_TSF_DIAG_MSG_CTL",
   "OC_TSF_DISARM_MASK",
   "OC_TSF_ENABLE_CTL",
   "OC_TSF_SOFTWARE_ARM",
   "OC_TSF_SOFTWARE_DISARM",
   "OC_TSF_SOFTWARE_TRIGGERED",
   "OC_TSF_TRIGGERED_STATE",
   "OC_TSF_TRIGGER_MASK",
   "OC_VEC_DATA",
   "OC_VEC_PARMS",
   "OC_VEC_RDDATA",
   "OC_VEC_RETURN",
   "OC_VEC_ROUTE",
   "OC_VEC_STATUS",
   "OC_VEC_STATUS_ALIAS",
   "OC_XNIILB_AGE_WRAP0",
   "OC_XNIILB_AGE_WRAP1",
   "OC_XNIILB_AGE_WRAP2",
   "OC_XNIILB_ARB_CONFIG_SI",
   "OC_XNIILB_ARB_CONFIG_SO",
   "OC_XNIILB_ERRORS_ALIAS",
   "OC_XNIILB_ERRORS_ALIAS_1",
   "OC_XNIILB_ERRORS_SUMMARY_1",
   "OC_XNIILB_ERROR_DETAIL_1",
   "OC_XNIILB_ERROR_DETAIL_2",
   "OC_XNIILB_ERROR_DETAIL_3",
   "OC_XNIILB_ERROR_MASK",
   "OC_XNIILB_ERROR_MASK_1",
   "OC_XNIILB_ERROR_OVERFLOW",
   "OC_XNIILB_ERROR_OVERFLOW_1",
   "OC_XNIILB_ERROR_OVERFLOW_ALIAS",
   "OC_XNIILB_ERROR_OVERFLOW_ALIAS_1",
   "OC_XNIILB_ERROR_SUMMARY",
   "OC_XNIILB_FIRST_ERROR",
   "OC_XNIILB_FIRST_ERROR_1",
   "OC_XNIILB_FR_IILB_INTRA_FLOW_CREDIT",
   "OC_XNIILB_FR_MD_INTRA_FLOW_CREDIT",
   "OC_XNIILB_FR_NI0_INTRA_FLOW_CREDIT",
   "OC_XNIILB_FR_NI1_INTRA_FLOW_CREDIT",
   "OC_XNIILB_FR_PI_INTRA_FLOW_CREDIT",
   "OC_XNIILB_II_FIFO_CREDIT_CNT",
   "OC_XNIILB_LB_FIFO_CREDIT_CNT",
   "OC_XNIILB_TO_IILB_INTRA_FLOW_DEBIT",
   "OC_XNIILB_TO_MD_INTRA_FLOW_SIC_DEBIT_VC0",
   "OC_XNIILB_TO_MD_INTRA_FLOW_SIC_DEBIT_VC2",
   "OC_XNIILB_TO_NI0_INTRA_FLOW_DEBIT",
   "OC_XNIILB_TO_NI0_INTRA_FLOW_DEBIT13",
   "OC_XNIILB_TO_NI1_INTRA_FLOW_DEBIT",
   "OC_XNIILB_TO_NI1_INTRA_FLOW_DEBIT13",
   "OC_XNIILB_TO_PI_INTRA_FLOW_SIC_DEBIT_VC0",
   "OC_XNIILB_TO_PI_INTRA_FLOW_SIC_DEBIT_VC2",
   "OC_XNII_INTRA_FLOW",
   "OC_XNLB_INTRA_FLOW",
   "OC_XNMD_ARB_CONFIG",
   "OC_XNMD_CREDIT_MGR_VC0",
   "OC_XNMD_CREDIT_MGR_VC2",
   "OC_XNMD_ECC0_INJ_MASK_REG",
   "OC_XNMD_ECC1_INJ_MASK_REG",
   "OC_XNMD_ECC2_INJ_MASK_REG",
   "OC_XNMD_ECC3_INJ_MASK_REG",
   "OC_XNMD_ECC_ERR_REPORT",
   "OC_XNMD_ECC_INJ_REG",
   "OC_XNMD_ERRORS_ALIAS",
   "OC_XNMD_ERROR_DETAIL_1",
   "OC_XNMD_ERROR_MASK",
   "OC_XNMD_ERROR_OVERFLOW",
   "OC_XNMD_ERROR_OVERFLOW_ALIAS",
   "OC_XNMD_ERROR_SUMMARY",
   "OC_XNMD_FIRST_ERROR",
   "OC_XNMD_LOCAL_AGE0",
   "OC_XNMD_LOCAL_AGE1",
   "OC_XNMD_SIC_FLOW",
   "OC_XNMD_STEERING_FIFO",
   "OC_XNMD_TO_IILB_PORT_FLOW",
   "OC_XNMD_TO_NI0_PORT_FLOW",
   "OC_XNMD_TO_NI0_PORT_FLOW13",
   "OC_XNMD_TO_NI1_PORT_FLOW",
   "OC_XNMD_TO_NI1_PORT_FLOW13",
   "OC_XNNI0_0_INTRANI_FLOW",
   "OC_XNNI0_1_INTRANI_FLOW",
   "OC_XNNI0_2_INTRANI_FLOW",
   "OC_XNNI0_3_INTRANI_FLOW",
   "OC_XNNI0_ARB_CONFIG",
   "OC_XNNI0_DEADLCK_FLOW",
   "OC_XNNI0_DEADLCK_FLOW_SUPPORT",
   "OC_XNNI0_IILB_TAILTO",
   "OC_XNNI0_INJECT_AGE",
   "OC_XNNI0_LINK_0_FLOW",
   "OC_XNNI0_LINK_1_FLOW",
   "OC_XNNI0_LINK_2_FLOW",
   "OC_XNNI0_LINK_3_FLOW",
   "OC_XNNI0_LLP_DEBIT_FLOW",
   "OC_XNNI0_LOCAL_AGE0",
   "OC_XNNI0_LOCAL_AGE1",
   "OC_XNNI0_MD_TAILTO",
   "OC_XNNI0_NETWORK_AGE",
   "OC_XNNI0_NI_TAILTO",
   "OC_XNNI0_NI_TAILTO_SUPPORT",
   "OC_XNNI0_PI_TAILTO",
   "OC_XNNI0_QUEUE_CNTR",
   "OC_XNNI0_TIMER_REG",
   "OC_XNNI0_TO_IILB_INTRA_FLOW_DEBIT",
   "OC_XNNI0_TO_MD_INTRA_FLOW_SIC_DEBIT_VC0",
   "OC_XNNI0_TO_MD_INTRA_FLOW_SIC_DEBIT_VC2",
   "OC_XNNI0_TO_PI_INTRA_FLOW_SIC_DEBIT_VC0",
   "OC_XNNI0_TO_PI_INTRA_FLOW_SIC_DEBIT_VC2",
   "OC_XNNI0_VCSWITCH_FLOW",
   "OC_XNNI1_0_INTRANI_FLOW",
   "OC_XNNI1_1_INTRANI_FLOW",
   "OC_XNNI1_2_INTRANI_FLOW",
   "OC_XNNI1_3_INTRANI_FLOW",
   "OC_XNNI1_ARB_CONFIG",
   "OC_XNNI1_DEADLCK_FLOW",
   "OC_XNNI1_DEADLCK_FLOW_SUPPORT",
   "OC_XNNI1_IILB_TAILTO",
   "OC_XNNI1_INJECT_AGE",
   "OC_XNNI1_LINK_0_FLOW",
   "OC_XNNI1_LINK_1_FLOW",
   "OC_XNNI1_LINK_2_FLOW",
   "OC_XNNI1_LINK_3_FLOW",
   "OC_XNNI1_LLP_DEBIT_FLOW",
   "OC_XNNI1_LOCAL_AGE0",
   "OC_XNNI1_LOCAL_AGE1",
   "OC_XNNI1_MD_TAILTO",
   "OC_XNNI1_NETWORK_AGE",
   "OC_XNNI1_NI_TAILTO",
   "OC_XNNI1_NI_TAILTO_SUPPORT",
   "OC_XNNI1_PI_TAILTO",
   "OC_XNNI1_QUEUE_CNTR",
   "OC_XNNI1_TIMER_REG",
   "OC_XNNI1_TO_IILB_INTRA_FLOW_DEBIT",
   "OC_XNNI1_TO_MD_INTRA_FLOW_SIC_DEBIT_VC0",
   "OC_XNNI1_TO_MD_INTRA_FLOW_SIC_DEBIT_VC2",
   "OC_XNNI1_TO_PI_INTRA_FLOW_SIC_DEBIT_VC0",
   "OC_XNNI1_TO_PI_INTRA_FLOW_SIC_DEBIT_VC2",
   "OC_XNNI1_VCSWITCH_FLOW",
   "OC_XNPI_ARB_CONFIG",
   "OC_XNPI_CREDIT_MGR_VC0",
   "OC_XNPI_CREDIT_MGR_VC2",
   "OC_XNPI_ERRORS_ALIAS",
   "OC_XNPI_ERROR_DETAIL_1",
   "OC_XNPI_ERROR_MASK",
   "OC_XNPI_ERROR_OVERFLOW",
   "OC_XNPI_ERROR_OVERFLOW_ALIAS",
   "OC_XNPI_ERROR_SUMMARY",
   "OC_XNPI_FIRST_ERROR",
   "OC_XNPI_LOCAL_AGE0",
   "OC_XNPI_LOCAL_AGE1",
   "OC_XNPI_SIC_FLOW",
   "OC_XNPI_STEERING_FIFO",
   "OC_XNPI_TO_IILB_PORT_FLOW",
   "OC_XNPI_TO_NI0_PORT_FLOW",
   "OC_XNPI_TO_NI0_PORT_FLOW13",
   "OC_XNPI_TO_NI1_PORT_FLOW",
   "OC_XNPI_TO_NI1_PORT_FLOW13",
   "OC_XN_CE_INT_TIME_STAMP",
   "OC_XN_CORRECTED_DETAIL_1",
   "OC_XN_CORRECTED_DETAIL_2A",
   "OC_XN_CORRECTED_DETAIL_2B",
   "OC_XN_CORRECTED_DETAIL_3",
   "OC_XN_CORRECTED_DETAIL_4",
   "OC_XN_DEBUG_DATA",
   "OC_XN_DEBUG_SEL",
   "OC_XN_DEBUG_TRIG_SEL",
   "OC_XN_ERRORS_ALIAS",
   "OC_XN_ERROR_MASK",
   "OC_XN_ERROR_OVERFLOW",
   "OC_XN_ERROR_OVERFLOW_ALIAS",
   "OC_XN_ERROR_SUMMARY",
   "OC_XN_FIRST_ERROR",
   "OC_XN_HW_INT_TIME_STAMP",
   "OC_XN_IILB_DEBUG_SEL",
   "OC_XN_IILB_II_CMP_ENABLE0",
   "OC_XN_IILB_II_CMP_ENABLE1",
   "OC_XN_IILB_II_CMP_EXP_DATA0",
   "OC_XN_IILB_II_CMP_EXP_DATA1",
   "OC_XN_IILB_LB_CMP_ENABLE0",
   "OC_XN_IILB_LB_CMP_ENABLE1",
   "OC_XN_IILB_LB_CMP_EXP_DATA0",
   "OC_XN_IILB_LB_CMP_EXP_DATA1",
   "OC_XN_IILB_MD_HDR_CMP_ENABLE0",
   "OC_XN_IILB_MD_HDR_CMP_ENABLE1",
   "OC_XN_IILB_MD_HDR_CMP_EXP_DATA0",
   "OC_XN_IILB_MD_HDR_CMP_EXP_DATA1",
   "OC_XN_IILB_NI0_CMP_ENABLE0",
   "OC_XN_IILB_NI0_CMP_ENABLE1",
   "OC_XN_IILB_NI0_CMP_EXP_DATA0",
   "OC_XN_IILB_NI0_CMP_EXP_DATA1",
   "OC_XN_IILB_NI1_CMP_ENABLE0",
   "OC_XN_IILB_NI1_CMP_ENABLE1",
   "OC_XN_IILB_NI1_CMP_EXP_DATA0",
   "OC_XN_IILB_NI1_CMP_EXP_DATA1",
   "OC_XN_IILB_PI_CMP_ENABLE0",
   "OC_XN_IILB_PI_CMP_ENABLE1",
   "OC_XN_IILB_PI_CMP_EXP_DATA0",
   "OC_XN_IILB_PI_CMP_EXP_DATA1",
   "OC_XN_MD_DEBUG_SEL",
   "OC_XN_MD_IILB_CMP_ENABLE0",
   "OC_XN_MD_IILB_CMP_ENABLE1",
   "OC_XN_MD_IILB_CMP_EXP_DATA0",
   "OC_XN_MD_IILB_CMP_EXP_DATA1",
   "OC_XN_MD_NI0_CMP_ENABLE0",
   "OC_XN_MD_NI0_CMP_ENABLE1",
   "OC_XN_MD_NI0_CMP_EXP_DATA0",
   "OC_XN_MD_NI0_CMP_EXP_DATA1",
   "OC_XN_MD_NI1_CMP_ENABLE0",
   "OC_XN_MD_NI1_CMP_ENABLE1",
   "OC_XN_MD_NI1_CMP_EXP_DATA0",
   "OC_XN_MD_NI1_CMP_EXP_DATA1",
   "OC_XN_MD_RP_CRD_CTL",
   "OC_XN_MD_RQ_CRD_CTL",
   "OC_XN_MD_SIC_CMP_EXP_HDR0",
   "OC_XN_MD_SIC_CMP_EXP_HDR1",
   "OC_XN_MD_SIC_CMP_HDR_ENABLE0",
   "OC_XN_MD_SIC_CMP_HDR_ENABLE1",
   "OC_XN_NI0_DEBUG_SEL",
   "OC_XN_NI0_IILB_CMP_ENABLE0",
   "OC_XN_NI0_IILB_CMP_ENABLE1",
   "OC_XN_NI0_IILB_CMP_EXP_DATA0",
   "OC_XN_NI0_IILB_CMP_EXP_DATA1",
   "OC_XN_NI0_LLP_CMP_ENABLE0",
   "OC_XN_NI0_LLP_CMP_ENABLE1",
   "OC_XN_NI0_LLP_CMP_EXP_DATA0",
   "OC_XN_NI0_LLP_CMP_EXP_DATA1",
   "OC_XN_NI0_MD_CMP_EXP_HDR0",
   "OC_XN_NI0_MD_CMP_EXP_HDR1",
   "OC_XN_NI0_MD_CMP_HDR_ENABLE0",
   "OC_XN_NI0_MD_CMP_HDR_ENABLE1",
   "OC_XN_NI0_NI_CMP_ENABLE0",
   "OC_XN_NI0_NI_CMP_ENABLE1",
   "OC_XN_NI0_NI_CMP_EXP_DATA0",
   "OC_XN_NI0_NI_CMP_EXP_DATA1",
   "OC_XN_NI0_PI_CMP_ENABLE0",
   "OC_XN_NI0_PI_CMP_ENABLE1",
   "OC_XN_NI0_PI_CMP_EXP_DATA0",
   "OC_XN_NI0_PI_CMP_EXP_DATA1",
   "OC_XN_NI1_DEBUG_SEL",
   "OC_XN_NI1_IILB_CMP_ENABLE0",
   "OC_XN_NI1_IILB_CMP_ENABLE1",
   "OC_XN_NI1_IILB_CMP_EXP_DATA0",
   "OC_XN_NI1_IILB_CMP_EXP_DATA1",
   "OC_XN_NI1_LLP_CMP_ENABLE0",
   "OC_XN_NI1_LLP_CMP_ENABLE1",
   "OC_XN_NI1_LLP_CMP_EXP_DATA0",
   "OC_XN_NI1_LLP_CMP_EXP_DATA1",
   "OC_XN_NI1_MD_CMP_EXP_HDR0",
   "OC_XN_NI1_MD_CMP_EXP_HDR1",
   "OC_XN_NI1_MD_CMP_HDR_ENABLE0",
   "OC_XN_NI1_MD_CMP_HDR_ENABLE1",
   "OC_XN_NI1_NI_CMP_ENABLE0",
   "OC_XN_NI1_NI_CMP_ENABLE1",
   "OC_XN_NI1_NI_CMP_EXP_DATA0",
   "OC_XN_NI1_NI_CMP_EXP_DATA1",
   "OC_XN_NI1_PI_CMP_ENABLE0",
   "OC_XN_NI1_PI_CMP_ENABLE1",
   "OC_XN_NI1_PI_CMP_EXP_DATA0",
   "OC_XN_NI1_PI_CMP_EXP_DATA1",
   "OC_XN_NRE_INT_TIME_STAMP",
   "OC_XN_PI_DEBUG_SEL",
   "OC_XN_PI_IILB_CMP_ENABLE0",
   "OC_XN_PI_IILB_CMP_ENABLE1",
   "OC_XN_PI_IILB_CMP_EXP_DATA0",
   "OC_XN_PI_IILB_CMP_EXP_DATA1",
   "OC_XN_PI_NI0_CMP_ENABLE0",
   "OC_XN_PI_NI0_CMP_ENABLE1",
   "OC_XN_PI_NI0_CMP_EXP_DATA0",
   "OC_XN_PI_NI0_CMP_EXP_DATA1",
   "OC_XN_PI_NI1_CMP_ENABLE0",
   "OC_XN_PI_NI1_CMP_ENABLE1",
   "OC_XN_PI_NI1_CMP_EXP_DATA0",
   "OC_XN_PI_NI1_CMP_EXP_DATA1",
   "OC_XN_PI_SICN_CMP_DATA0",
   "OC_XN_PI_SICN_CMP_DATA1",
   "OC_XN_PI_SICN_CMP_DATA_ENABLE0",
   "OC_XN_PI_SICN_CMP_DATA_ENABLE1",
   "OC_XN_RE_INT_TIME_STAMP",
   "OC_XN_TRIGGER_COMPARE",
   "OC_XN_TRIGGER_DATA",
   "OC_XN_UCE_INT_TIME_STAMP",
   "OC_XN_UNCORRECTED_DETAIL_1",
   "OC_XN_UNCORRECTED_DETAIL_2A",
   "OC_XN_UNCORRECTED_DETAIL_2B",
   "OC_XN_UNCORRECTED_DETAIL_3",
   "OC_XN_UNCORRECTED_DETAIL_4",
   "OC_X_AMOC_CFG",
   "OC_X_AMOC_TAG",
   "OC_X_ARB_DBUG_SEL",
   "OC_X_ATL_DBUG_SEL",
   "OC_X_ATR_DBUG_SEL",
   "OC_X_CFG",
   "OC_X_DBUG_SEL",
   "OC_X_DIMM_CFG",
   "OC_X_DQCT_CFG",
   "OC_X_DQL_DBUG_SEL",
   "OC_X_DQR_DBUG_SEL",
   "OC_X_LADDR_CMP",
   "OC_X_PHASE_CFG",
   "OC_X_RADDR_CMP",
   "OC_X_REFRESH_CONTROL",
   "OC_X_TAG0",
   "OC_X_TAG1",
   "OC_X_TAG2",
   "OC_X_TAG3",
   "OC_X_TAG4",
   "OC_X_TAG5",
   "OC_X_TAG6",
   "OC_X_TAG7",
   "OC_X_TAG_CMP",
   "OC_X_TAG_DBUG_SEL",
   "OC_X_TAG_MASK",
   "OC_X_WBQ_DBUG_SEL",
   "OC_Y_AMOC_CFG",
   "OC_Y_AMOC_TAG",
   "OC_Y_ARB_DBUG_SEL",
   "OC_Y_ATL_DBUG_SEL",
   "OC_Y_ATR_DBUG_SEL",
   "OC_Y_CFG",
   "OC_Y_DBUG_SEL",
   "OC_Y_DIMM_CFG",
   "OC_Y_DQCT_CFG",
   "OC_Y_DQL_DBUG_SEL",
   "OC_Y_DQR_DBUG_SEL",
   "OC_Y_LADDR_CMP",
   "OC_Y_PHASE_CFG",
   "OC_Y_RADDR_CMP",
   "OC_Y_REFRESH_CONTROL",
   "OC_Y_TAG0",
   "OC_Y_TAG1",
   "OC_Y_TAG2",
   "OC_Y_TAG3",
   "OC_Y_TAG4",
   "OC_Y_TAG5",
   "OC_Y_TAG6",
   "OC_Y_TAG7",
   "OC_Y_TAG_CMP",
   "OC_Y_TAG_DBUG_SEL",
   "OC_Y_TAG_MASK",
   "OC_Y_WBQ_DBUG_SEL",
);

@orbit_01_sorted_mmr_addr = 
(
   0x0000000080000080,
   0x0000000080000088,
   0x0000000080000090,
   0x0000000080000098,
   0x00000000800000A0,
   0x00000000800000A8,
   0x00000000800000B0,
   0x00000000800000B8,
   0x00000000800000C0,
   0x00000000800000C8,
   0x00000000800000D0,
   0x00000000800000D8,
   0x00000000800000E0,
   0x00000000800000E8,
   0x00000000800000F0,
   0x0000000080010000,
   0x0000000080010008,
   0x0000000080010010,
   0x0000000080010018,
   0x0000000080010020,
   0x0000000080010028,
   0x0000000080010030,
   0x0000000080010038,
   0x0000000080010040,
   0x0000000080010048,
   0x0000000080010050,
   0x0000000080010058,
   0x0000000080010060,
   0x0000000080010068,
   0x0000000080010070,
   0x0000000080010078,
   0x0000000080010080,
   0x0000000080010088,
   0x0000000080010090,
   0x0000000080010098,
   0x00000000800100A0,
   0x00000000800100A8,
   0x0000000080020000,
   0x0000000080020008,
   0x0000000080020010,
   0x0000000080020018,
   0x0000000080020020,
   0x0000000080020028,
   0x0000000080020030,
   0x0000000080020038,
   0x0000000080020040,
   0x0000000080020048,
   0x0000000080020050,
   0x0000000080020058,
   0x0000000080020060,
   0x0000000080020068,
   0x0000000080020070,
   0x0000000080020078,
   0x0000000080020080,
   0x0000000080020088,
   0x0000000080020100,
   0x0000000080020108,
   0x0000000080020110,
   0x0000000080020118,
   0x0000000080020120,
   0x0000000080020128,
   0x0000000080020130,
   0x0000000080020138,
   0x0000000080020140,
   0x0000000080020148,
   0x0000000080020150,
   0x0000000080020158,
   0x0000000080020160,
   0x0000000080020168,
   0x0000000080020170,
   0x0000000080020178,
   0x0000000080020180,
   0x0000000080020188,
   0x0000000080020190,
   0x0000000080020198,
   0x00000000800201A0,
   0x00000000800201A8,
   0x00000000800201B0,
   0x00000000800201B8,
   0x00000000800201C0,
   0x00000000800201C8,
   0x00000000800201D0,
   0x00000000800201D8,
   0x00000000800201E0,
   0x0000000080020300,
   0x0000000080020308,
   0x0000000080020310,
   0x0000000080020318,
   0x0000000080030000,
   0x0000000080030100,
   0x0000000080030110,
   0x0000000080030120,
   0x0000000080030130,
   0x0000000080030200,
   0x0000000080030210,
   0x0000000080030220,
   0x0000000080030230,
   0x0000000080030240,
   0x0000000080030250,
   0x0000000080030260,
   0x0000000080030270,
   0x0000000080030300,
   0x0000000080030310,
   0x0000000080030320,
   0x0000000080030330,
   0x0000000080030340,
   0x0000000080030350,
   0x0000000080030360,
   0x0000000080030370,
   0x0000000080030400,
   0x0000000080031000,
   0x0000000080031010,
   0x0000000080032000,
   0x0000000080032010,
   0x0000000080032800,
   0x0000000080032810,
   0x0000000080033000,
   0x0000000080033010,
   0x0000000080033020,
   0x0000000080033030,
   0x0000000080033040,
   0x0000000080033800,
   0x0000000080033810,
   0x0000000080033820,
   0x0000000080033830,
   0x0000000080033840,
   0x0000000080034000,
   0x0000000080034010,
   0x0000000080034020,
   0x0000000080034800,
   0x0000000080038000,
   0x0000000080038010,
   0x0000000080038020,
   0x0000000080038030,
   0x0000000080038800,
   0x0000000080038810,
   0x0000000080038820,
   0x0000000080038830,
   0x0000000080048000,
   0x0000000080048010,
   0x0000000080048020,
   0x0000000080048030,
   0x0000000080048800,
   0x0000000080048810,
   0x0000000080048820,
   0x0000000080048830,
   0x0000000080049000,
   0x000000008004A000,
   0x000000008004B000,
   0x0000000080050000,
   0x0000000080050100,
   0x0000000080050110,
   0x0000000080050120,
   0x0000000080050130,
   0x0000000080050200,
   0x0000000080050210,
   0x0000000080050220,
   0x0000000080050230,
   0x0000000080050240,
   0x0000000080050250,
   0x0000000080050260,
   0x0000000080050270,
   0x0000000080050300,
   0x0000000080050310,
   0x0000000080050320,
   0x0000000080050330,
   0x0000000080050340,
   0x0000000080050350,
   0x0000000080050360,
   0x0000000080050370,
   0x0000000080050400,
   0x0000000080051000,
   0x0000000080051010,
   0x0000000080052000,
   0x0000000080052010,
   0x0000000080052800,
   0x0000000080052810,
   0x0000000080053000,
   0x0000000080053010,
   0x0000000080053020,
   0x0000000080053030,
   0x0000000080053040,
   0x0000000080053800,
   0x0000000080053810,
   0x0000000080053820,
   0x0000000080053830,
   0x0000000080053840,
   0x0000000080054000,
   0x0000000080054010,
   0x0000000080054020,
   0x0000000080054800,
   0x0000000080058000,
   0x0000000080058010,
   0x0000000080058020,
   0x0000000080058030,
   0x0000000080058800,
   0x0000000080058810,
   0x0000000080058820,
   0x0000000080058830,
   0x0000000080068000,
   0x0000000080068010,
   0x0000000080068020,
   0x0000000080068030,
   0x0000000080068800,
   0x0000000080068810,
   0x0000000080068820,
   0x0000000080068830,
   0x0000000080069000,
   0x000000008006A000,
   0x000000008006B000,
   0x0000000090000400,
   0x0000000090000480,
   0x0000000090000980,
   0x0000000090000A00,
   0x0000000090000A80,
   0x0000000090000B00,
   0x0000000090000B80,
   0x0000000090000C00,
   0x0000000090000C80,
   0x0000000090000F00,
   0x0000000090000F80,
   0x0000000090001000,
   0x0000000090001080,
   0x0000000090001100,
   0x0000000090001180,
   0x0000000090001200,
   0x0000000090001300,
   0x0000000090001380,
   0x0000000090001400,
   0x0000000090001480,
   0x0000000090001500,
   0x0000000090001580,
   0x0000000090001600,
   0x0000000090001680,
   0x0000000090001700,
   0x0000000090001780,
   0x0000000090001800,
   0x0000000090001880,
   0x0000000090001900,
   0x0000000090001980,
   0x0000000090001A00,
   0x0000000090001A80,
   0x0000000090001B00,
   0x0000000090001B80,
   0x0000000090001C00,
   0x0000000090001C80,
   0x0000000090001D00,
   0x0000000090001D80,
   0x0000000090001E00,
   0x0000000090001E80,
   0x0000000090010000,
   0x0000000090010080,
   0x0000000090010100,
   0x0000000090010180,
   0x0000000090010200,
   0x0000000090010280,
   0x0000000090010300,
   0x0000000090010380,
   0x0000000090010400,
   0x0000000090010480,
   0x0000000090010500,
   0x0000000090010580,
   0x0000000090010600,
   0x0000000090010680,
   0x0000000090010700,
   0x0000000090010780,
   0x0000000090010800,
   0x0000000090010880,
   0x0000000090010900,
   0x0000000090010980,
   0x0000000090010A00,
   0x0000000090010A80,
   0x0000000090010B00,
   0x0000000090010B80,
   0x0000000090010C00,
   0x0000000090010C80,
   0x0000000090010D00,
   0x0000000090010D80,
   0x0000000090010E00,
   0x0000000090010E80,
   0x0000000090010F00,
   0x0000000090020000,
   0x0000000090020100,
   0x0000000090030000,
   0x0000000090030080,
   0x0000000090030100,
   0x0000000090030180,
   0x0000000090038000,
   0x0000000090038080,
   0x0000000090038100,
   0x0000000090038180,
   0x0000000090040000,
   0x0000000090040080,
   0x0000000090040100,
   0x0000000090040180,
   0x0000000090040200,
   0x0000000090040280,
   0x0000000090050000,
   0x0000000090050080,
   0x0000000090050100,
   0x0000000090050180,
   0x0000000090050200,
   0x0000000090050280,
   0x0000000090050300,
   0x0000000090050380,
   0x0000000090050400,
   0x0000000090050480,
   0x0000000090050580,
   0x0000000090050600,
   0x0000000090050608,
   0x0000000090050680,
   0x0000000090050688,
   0x0000000090050700,
   0x0000000090050780,
   0x0000000090050800,
   0x0000000090050880,
   0x0000000090050900,
   0x0000000090060000,
   0x0000000090060080,
   0x0000000090060100,
   0x0000000090060180,
   0x0000000090060200,
   0x0000000090060280,
   0x0000000090060300,
   0x0000000090060380,
   0x0000000090060400,
   0x0000000090060480,
   0x0000000090060500,
   0x0000000090060580,
   0x0000000090060600,
   0x0000000090060680,
   0x0000000090060700,
   0x0000000090060780,
   0x0000000090060800,
   0x0000000090060880,
   0x0000000090060900,
   0x0000000090060980,
   0x0000000090060A00,
   0x0000000090060A80,
   0x0000000090060B00,
   0x0000000090060B80,
   0x0000000090060C00,
   0x0000000090060C80,
   0x0000000090060D00,
   0x0000000090060D80,
   0x0000000090060E00,
   0x0000000090060E80,
   0x0000000090060F00,
   0x0000000090060F80,
   0x0000000090061000,
   0x0000000090061080,
   0x0000000090061100,
   0x0000000090061400,
   0x0000000090062000,
   0x0000000090062080,
   0x0000000090062100,
   0x0000000090062180,
   0x0000000090062200,
   0x0000000090062280,
   0x0000000090062300,
   0x0000000090063000,
   0x0000000090063080,
   0x0000000090063100,
   0x0000000090063180,
   0x0000000090063200,
   0x0000000090063280,
   0x0000000090063300,
   0x0000000090063380,
   0x0000000090063400,
   0x0000000090063480,
   0x0000000090063500,
   0x0000000090063580,
   0x0000000090063600,
   0x0000000090063680,
   0x0000000090063700,
   0x0000000090063780,
   0x0000000090063800,
   0x0000000090063880,
   0x0000000090063900,
   0x0000000090063980,
   0x0000000090063A00,
   0x0000000090064000,
   0x0000000090064080,
   0x0000000090064100,
   0x0000000090064180,
   0x0000000090064200,
   0x0000000090064280,
   0x0000000090064300,
   0x0000000090064380,
   0x0000000090064400,
   0x0000000090064480,
   0x0000000090065000,
   0x0000000090065080,
   0x0000000090066000,
   0x0000000090066080,
   0x0000000090066100,
   0x0000000090066180,
   0x0000000090066200,
   0x0000000090066280,
   0x0000000090066300,
   0x0000000090066380,
   0x0000000090066400,
   0x0000000090066480,
   0x0000000090066500,
   0x0000000090066580,
   0x0000000090066600,
   0x0000000090066680,
   0x0000000090066700,
   0x0000000090066780,
   0x0000000090066800,
   0x0000000090066880,
   0x0000000090066900,
   0x0000000090066980,
   0x0000000090066A00,
   0x0000000090066A80,
   0x0000000090066B00,
   0x0000000090066B80,
   0x0000000090066C00,
   0x0000000090066C80,
   0x0000000090067000,
   0x0000000090067080,
   0x0000000090067100,
   0x0000000090068000,
   0x0000000090068080,
   0x0000000090068100,
   0x0000000090071000,
   0x0000000090071080,
   0x0000000090071100,
   0x0000000090071180,
   0x0000000090071200,
   0x0000000090071280,
   0x0000000090071300,
   0x0000000090071380,
   0x0000000090071400,
   0x0000000090071480,
   0x0000000090071500,
   0x0000000090071580,
   0x0000000090071600,
   0x0000000090071680,
   0x0000000090071700,
   0x0000000090071780,
   0x0000000090071800,
   0x0000000090071880,
   0x0000000090071900,
   0x0000000090071980,
   0x0000000090072000,
   0x0000000090072080,
   0x0000000090072100,
   0x0000000090072180,
   0x0000000090072200,
   0x0000000090072280,
   0x0000000090072300,
   0x0000000090072800,
   0x0000000090072880,
   0x0000000090072900,
   0x0000000090073000,
   0x0000000090073080,
   0x0000000090073100,
   0x0000000090074000,
   0x0000000090074080,
   0x0000000090074100,
   0x0000000090074108,
   0x0000000090075000,
   0x0000000090077000,
   0x0000000090080000,
   0x0000000090090000,
   0x00000000900A0000,
   0x00000000900B0000,
   0x00000000900C0000,
   0x00000000900D0000,
   0x00000000900E0000,
   0x00000000900F0000,
   0x0000000090100000,
   0x0000000090100080,
   0x0000000090100100,
   0x0000000090100180,
   0x0000000090101000,
   0x0000000090110000,
   0x0000000090120000,
   0x0000000090130000,
   0x0000000090140000,
   0x0000000090150000,
   0x0000000090160000,
   0x0000000090170000,
   0x0000000090180000,
   0x0000000090190000,
   0x0000000090190080,
   0x00000000901B0000,
   0x00000000901B0080,
   0x00000000901B0100,
   0x00000000901B0180,
   0x00000000901B0200,
   0x00000000901C0000,
   0x00000000901D0000,
   0x00000000901D0008,
   0x00000000901D0080,
   0x00000000901D0088,
   0x00000000901D0100,
   0x00000000901D0108,
   0x00000000901D0180,
   0x00000000901D0188,
   0x00000000901D0200,
   0x00000000901D0208,
   0x00000000901D0280,
   0x00000000901D0300,
   0x00000000901D0380,
   0x00000000901D0400,
   0x00000000901D0480,
   0x00000000901D0500,
   0x00000000901D0580,
   0x00000000901D0600,
   0x00000000A0000100,
   0x00000000A0000108,
   0x00000000A0000110,
   0x00000000A0000118,
   0x00000000A0000800,
   0x00000000A0000808,
   0x00000000A0000810,
   0x00000000A0000818,
   0x00000000A0000820,
   0x00000000A0000828,
   0x00000000A0000830,
   0x00000000A0000838,
   0x00000000A0000840,
   0x00000000A0000848,
   0x00000000A0000850,
   0x00000000A0000858,
   0x00000000A0001000,
   0x00000000A0001008,
   0x00000000A0001010,
   0x00000000A0001020,
   0x00000000A0001028,
   0x00000000A0001030,
   0x00000000A0008100,
   0x00000000A0008108,
   0x00000000A0008110,
   0x00000000A0008118,
   0x00000000A0008120,
   0x00000000A0008128,
   0x00000000A0008130,
   0x00000000A0008138,
   0x00000000A0008800,
   0x00000000A0008808,
   0x00000000A0008810,
   0x00000000A0008818,
   0x00000000A0008820,
   0x00000000A0008828,
   0x00000000A0008830,
   0x00000000A0008838,
   0x00000000A0008840,
   0x00000000A0008848,
   0x00000000A0008860,
   0x00000000A0008868,
   0x00000000A0008880,
   0x00000000A0008888,
   0x00000000A0010008,
   0x00000000A0010010,
   0x00000000A0010018,
   0x00000000A0010020,
   0x00000000A0010028,
   0x00000000A0010030,
   0x00000000A0010080,
   0x00000000A0010088,
   0x00000000A0010100,
   0x00000000A0010108,
   0x00000000A0010110,
   0x00000000A0010118,
   0x00000000A0010808,
   0x00000000A0011000,
   0x00000000A0011008,
   0x00000000A0011030,
   0x00000000A0011038,
   0x00000000A0011040,
   0x00000000A0011050,
   0x00000000A0011058,
   0x00000000A0011060,
   0x00000000A0011070,
   0x00000000A0011078,
   0x00000000A0011080,
   0x00000000A0018800,
   0x00000000A0018808,
   0x00000000A0018810,
   0x00000000A0018818,
   0x00000000A0018820,
   0x00000000A0018828,
   0x00000000A0018830,
   0x00000000A0018848,
   0x00000000A0020000,
   0x00000000A0020010,
   0x00000000A0020020,
   0x00000000A0020030,
   0x00000000A0020040,
   0x00000000A0020050,
   0x00000000A0020060,
   0x00000000A0020070,
   0x00000000A0020400,
   0x00000000A0021000,
   0x00000000A0021100,
   0x00000000A0021110,
   0x00000000A0021200,
   0x00000000A0021210,
   0x00000000A0021300,
   0x00000000A0021310,
   0x00000000A0021400,
   0x00000000A0021410,
   0x00000000A0021500,
   0x00000000A0021510,
   0x00000000A0021520,
   0x00000000A0021600,
   0x00000000A0021610,
   0x00000000A0021620,
   0x00000000A0021700,
   0x00000000A0021710,
   0x00000000A0021720,
   0x00000000A0022000,
   0x00000000A0024000,
   0x00000000A0024010,
   0x00000000A0024020,
   0x00000000A0028000,
   0x00000000A0028010,
   0x00000000A0028020,
   0x00000000A0028030,
   0x00000000A0028040,
   0x00000000A0028050,
   0x00000000A0028060,
   0x00000000A0028070,
   0x00000000A0028080,
   0x00000000A0029000,
   0x00000000A0029010,
   0x00000000A0029020,
   0x00000000A0029030,
   0x00000000A0029060,
   0x00000000A0029070,
   0x00000000A0029080,
   0x00000000A002A000,
   0x00000000A002A020,
   0x00000000A002A030,
   0x00000000A002A040,
   0x00000000A002A050,
   0x00000000A002A060,
   0x00000000A002A100,
   0x00000000A0030000,
   0x00000000A0030008,
   0x00000000A0030010,
   0x00000000A0030018,
   0x00000000A0030020,
   0x00000000A0030028,
   0x00000000A0030030,
   0x00000000A0030038,
   0x00000000A0030040,
   0x00000000A0030048,
   0x00000000A0030050,
   0x00000000A0030058,
   0x00000000A0030060,
   0x00000000A0030080,
   0x00000000A0030088,
   0x00000000A0030100,
   0x00000000A0030108,
   0x00000000A0030118,
   0x00000000A0031040,
   0x00000000A0031048,
   0x00000000A0031050,
   0x00000000A0038000,
   0x00000000A0038008,
   0x00000000A0038010,
   0x00000000A0038018,
   0x00000000A0038020,
   0x00000000A0038028,
   0x00000000A0038030,
   0x00000000A0038038,
   0x00000000A0038040,
   0x00000000A0038048,
   0x00000000A0038800,
   0x00000000A0038808,
   0x00000000A0038810,
   0x00000000A0038818,
   0x00000000A0038820,
   0x00000000A0038828,
   0x00000000A0038830,
   0x00000000A0038838,
   0x00000000A0038840,
   0x00000000A0038848,
   0x00000000A0038850,
   0x00000000A0038858,
   0x00000000A0038860,
   0x00000000A0038868,
   0x00000000D0000000,
   0x00000000D0000008,
   0x00000000D0000010,
   0x00000000D0000018,
   0x00000000D0000020,
   0x00000000D0000028,
   0x00000000D0000030,
   0x00000000D0000038,
   0x00000000D0000040,
   0x00000000D0000048,
   0x00000000D0001030,
   0x00000000D0001040,
   0x00000000D0001050,
   0x00000000D0001060,
   0x00000000D0001070,
   0x00000000D0002000,
   0x00000000D0002008,
   0x00000000D0002010,
   0x00000000D0002018,
   0x00000000D0002020,
   0x00000000D0002028,
   0x00000000D0002030,
   0x00000000D0002038,
   0x00000000D0002040,
   0x00000000D0002048,
   0x00000000D0003030,
   0x00000000D0003040,
   0x00000000D0003050,
   0x00000000D0003060,
   0x00000000D0003070,
   0x00000000D0020000,
   0x00000000D0020800,
   0x00000000D0021000,
   0x00000000D0022000,
   0x00000000D0022800,
   0x00000000D0023000,
   0x00000000D0023008,
   0x00000000D0024000,
   0x00000000D0024800,
   0x00000000D0025000,
   0x00000000D0026000,
   0x00000000D0026800,
   0x00000000D0027000,
   0x00000000D0028000,
   0x00000000D0028800,
   0x00000000D0029000,
   0x00000000D0029008,
   0x00000000D0030000,
   0x00000000D0030010,
   0x00000000D0030020,
   0x00000000D0030030,
   0x00000000D0030040,
   0x00000000D0030050,
   0x00000000D0030060,
   0x00000000D0030070,
   0x00000000D0030080,
   0x00000000D0030090,
   0x00000000D00300A0,
   0x00000000D00300B0,
   0x00000000D0030100,
   0x00000000D0030110,
   0x00000000D0030120,
   0x00000000D0030130,
   0x00000000D0030140,
   0x00000000D0030150,
   0x00000000D0030160,
   0x00000000D0030170,
   0x00000000D0030180,
   0x00000000D0030190,
   0x00000000D00301A0,
   0x00000000D00301B0,
   0x00000000D0030200,
   0x00000000D0030210,
   0x00000000D0030220,
   0x00000000D0030230,
   0x00000000D0030240,
   0x00000000D0030250,
   0x00000000D0030260,
   0x00000000D0030270,
   0x00000000D0030280,
   0x00000000D0030290,
   0x00000000D00302A0,
   0x00000000D00302B0,
   0x00000000D00302C0,
   0x00000000D00302D0,
   0x00000000D00302E0,
   0x00000000D00302F0,
   0x00000000D0030300,
   0x00000000D0030310,
   0x00000000D0030320,
   0x00000000D0030330,
   0x00000000D0030340,
   0x00000000D0030350,
   0x00000000D0030360,
   0x00000000D0030400,
   0x00000000D0030410,
   0x00000000D0030420,
   0x00000000D0030430,
   0x00000000D0030440,
   0x00000000D0030450,
   0x00000000D0030460,
   0x00000000D0030470,
   0x00000000D0030480,
   0x00000000D0030490,
   0x00000000D00304A0,
   0x00000000D00304B0,
   0x00000000D00304C0,
   0x00000000D00304D0,
   0x00000000D00304E0,
   0x00000000D00304F0,
   0x00000000D0030500,
   0x00000000D0030510,
   0x00000000D0030520,
   0x00000000D0030530,
   0x00000000D0030540,
   0x00000000D0030550,
   0x00000000D0030560,
   0x00000000D0030570,
   0x00000000D0030600,
   0x00000000D0030610,
   0x00000000D0030620,
   0x00000000D0030630,
   0x00000000D0030640,
   0x00000000D0030650,
   0x00000000D0030660,
   0x00000000D0030670,
   0x00000000D0030680,
   0x00000000D0030690,
   0x00000000D00306A0,
   0x00000000D00306B0,
   0x00000000D00306C0,
   0x00000000D00306D0,
   0x00000000D00306E0,
   0x00000000D00306F0,
   0x00000000D0030700,
   0x00000000D0030710,
   0x00000000D0030720,
   0x00000000D0030730,
   0x00000000D0030740,
   0x00000000D0030750,
   0x00000000D0030760,
   0x00000000D0030770,
   0x00000000D0031000,
   0x00000000D0031020,
   0x00000000D0031040,
   0x00000000D0031050,
   0x00000000D0031060,
   0x00000000D0031080,
   0x00000000D00310A0,
   0x00000000D00310C0,
   0x00000000D00310E0,
   0x00000000D0031100,
   0x00000000D0031110,
   0x00000000D0031120,
   0x00000000D0031130,
   0x00000000D0031140,
   0x00000000D0031150,
   0x00000000D0031160,
   0x00000000D0031170,
   0x00000000D0031200,
   0x00000000D0031210,
   0x00000000D0031220,
   0x00000000D0031230,
   0x00000000D0031240,
   0x00000000D0031250,
   0x00000000D0031260,
   0x00000000D0031270,
   0x00000000D0031280,
   0x00000000D0031290,
   0x00000000D00312A0,
   0x00000000D00312B0,
   0x00000000D00312C0,
   0x00000000D00312D0,
   0x00000000D00312E0,
   0x00000000D00312F0,
   0x00000000D0031300,
   0x00000000D0031310,
   0x00000000D0031320,
   0x00000000D0031330,
   0x00000000D0031340,
   0x00000000D0031350,
   0x00000000D0031360,
   0x00000000D0031370,
   0x00000000D0031380,
   0x00000000D0031390,
   0x00000000D00313A0,
   0x00000000D00313B0,
   0x00000000D0031400,
   0x00000000D0031410,
   0x00000000D0031440,
   0x00000000D0031450,
   0x00000000D0031500,
   0x00000000D0031510,
   0x00000000D0031520,
   0x00000000D0031530,
   0x00000000D0031540,
   0x00000000D0031550,
   0x00000000D0031560,
   0x00000000D0031570,
   0x00000000D0031580,
   0x00000000D0031590,
   0x00000000D00315A0,
   0x00000000D00315B0,
   0x00000000D00315C0,
   0x00000000D00315D0,
   0x00000000D00315E0,
   0x00000000D00315F0,
   0x00000000D0031700,
   0x00000000D0031710,
   0x00000000D0031720,
   0x00000000D0031730,
   0x00000000D0031740,
   0x00000000D0031750,
   0x00000000D0031760,
   0x00000000D0031770,
   0x00000000D00317C0,
   0x00000000D00317D0,
   0x00000000D00317E0,
   0x00000000D00317F0,
   0x00000000D0031800,
   0x00000000D0031810,
   0x00000000D0031820,
   0x00000000D0031830,
   0x00000000D0031900,
   0x00000000D0031910,
   0x00000000D0031920,
   0x00000000D0031930,
   0x00000000D0031940,
   0x00000000D0031950,
   0x00000000D0031960,
   0x00000000D0031970,
   0x00000000D00319C0,
   0x00000000D00319D0,
   0x00000000D00319E0,
   0x00000000D00319F0,
   0x00000000D0031A00,
   0x00000000D0031A10,
   0x00000000D0031A20,
   0x00000000D0031A30,
   0x00000000D0031B40,
   0x00000000D0031B50,
   0x00000000D0031B60,
   0x00000000D0031B70,
   0x00000000D0031BC0,
   0x00000000D0031BD0,
   0x00000000D0031BE0,
   0x00000000D0031BF0,
   0x00000000D0032050,
   0x00000000D0032060,
   0x00000000D0032070,
   0x00000000D0032080,
   0x00000000D0032090,
   0x00000000D00320A0,
   0x00000000D0040000,
   0x00000000D0040008,
   0x00000000D0040020,
   0x00000000D0040028,
   0x00000000D0040040,
   0x00000000D0040060,
   0x00000000D0040070,
   0x00000000D0040080,
   0x00000000D0040090,
   0x00000000D00400A0,
   0x00000000D00400B0,
   0x00000000D00400C0,
   0x00000000D00400D0,
   0x00000000D00400E0,
   0x00000000D00400F0,
   0x00000000D0040100,
   0x00000000D0040110,
   0x00000000D0040120,
   0x00000000D0040130,
   0x00000000D0040140,
   0x00000000D0040150,
   0x00000000D0040160,
   0x00000000D0040170,
   0x00000000D0040200,
   0x00000000D0040208,
   0x00000000D0040210,
   0x00000000D0040218,
   0x00000000D0040220,
   0x00000000D0040228,
   0x00000000D0040230,
   0x00000000D0040238,
   0x00000000D0040240,
   0x00000000D0040250,
   0x00000000D0040260,
   0x00000000D0040270,
   0x00000000D0040300,
   0x00000000D0040308,
   0x00000000D0040320,
   0x00000000D0040328,
   0x00000000D0040340,
   0x00000000D0040360,
   0x00000000D0040400,
   0x00000000D0040408,
   0x00000000D0040420,
   0x00000000D0040428,
   0x00000000D0040440,
   0x00000000D0040460,
   0x00000000D0040500,
   0x00000000D0040508,
   0x00000000D0040510,
   0x00000000D0040518,
   0x00000000D0040520,
   0x00000000D0040528,
   0x00000000D0040530,
   0x00000000D0040538,
   0x00000000D0040540,
   0x00000000D0040550,
   0x00000000D0040560,
   0x00000000D0040570,
   0x00000000D0040580,
   0x00000000D0040590,
   0x00000000D0040600,
   0x00000000D0040608,
   0x00000000D0040610,
   0x00000000D0040618,
   0x00000000D0040620,
   0x00000000D0040628,
   0x00000000D0040630,
   0x00000000D0040638,
   0x00000000D0040640,
   0x00000000D0040650,
   0x00000000D0040660,
   0x00000000D0040670,
   0x00000000D0040680,
   0x00000000D0040690,
);


##########################################################################
#                                                                        #
#   REGISTER SEARCH SUBROUTINES (BY NAME OR ADDRESS)                     #
#                                                                        #
##########################################################################

sub orbit_01_mmr_search_name
{  my $rptr = 0;
   return($rptr) if ( $#_ != 0 );
   $rptr = $orbit_01_mmr_by_name{$_[0]} if ( exists $orbit_01_mmr_by_name{$_[0]} );
   return($rptr);
}

sub orbit_01_mmr_search_addr
{  my $rptr = 0;
   return($rptr) if ( $#_ != 0 );
   $rptr = $orbit_01_mmr_by_addr{$_[0]} if ( exists $orbit_01_mmr_by_addr{$_[0]} );
   return($rptr);
}


##########################################################################
# Number of MMRs    : 1014

1;
