#
# The file contains PERL source that represents the MMRs from
#    an ASIC hardware register (hwreg) file.
#
# This file was generated using the "hwr2perl" utility.
# HWREG source file : hwreg_shub2.hwreg
# ASIC base name    : "shub2_01"
# PERL file created : 15:51:37 Tuesday November  1
#

$shub2_01_defined = 1;


##########################################################################
#                                                                        #
#   SH2_JUNK_BUS_TIME                                                    #
#                                                                        #
##########################################################################

%shub2_01_00000_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIMEOUT_VALUE"                => [   1,  16,  32, 0x0000FFFFFFFF0000, 0x00, 1, 0x0000000000000000, "Timeout Value" ],
   "RSVD1"                        => [   2,   3,  13, 0x000000000000FFF8, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SETUP_HOLD"                   => [   3,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Setup and Hold Time" ],
);

%shub2_01_00000_def =
( NAME    => "SH2_JUNK_BUS_TIME",
  ADDRESS => 0x0000000010020000,
  NOTE    => "The JUNK_BUS_TIME register controls the timing for data being sent note to the Local Block Interface chip.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00000_flds
);


##########################################################################
#                                                                        #
#   SH2_JUNK_NACK_RESET                                                  #
#                                                                        #
##########################################################################

%shub2_01_00001_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PULSE"                        => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Junk bus nack counter reset" ],
);

%shub2_01_00001_def =
( NAME    => "SH2_JUNK_NACK_RESET",
  ADDRESS => 0x0000000010020100,
  NOTE    => "The Junk Bus uses a modified conveyor belt mechanism to keep Junk note Bus requests in order without stalling incoming messages ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00001_flds
);


##########################################################################
#                                                                        #
#   SH2_JUNK_BUS_LED0                                                    #
#                                                                        #
##########################################################################

%shub2_01_00002_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LED0_DATA"                    => [   1,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "LED0_data" ],
);

%shub2_01_00002_def =
( NAME    => "SH2_JUNK_BUS_LED0",
  ADDRESS => 0x0000000010030000,
  NOTE    => "The JUNK_BUS_LED0 register provides software with a mechanism for note monitoring the state of the 8 LED0 devices.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00002_flds
);


##########################################################################
#                                                                        #
#   SH2_JUNK_BUS_LED1                                                    #
#                                                                        #
##########################################################################

%shub2_01_00003_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LED1_DATA"                    => [   1,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "LED1_data" ],
);

%shub2_01_00003_def =
( NAME    => "SH2_JUNK_BUS_LED1",
  ADDRESS => 0x0000000010030080,
  NOTE    => "The JUNK_BUS_LED1 register provides software with a mechanism for note monitoring the state of the 8 LED1 devices.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00003_flds
);


##########################################################################
#                                                                        #
#   SH2_JUNK_BUS_LED2                                                    #
#                                                                        #
##########################################################################

%shub2_01_00004_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LED2_DATA"                    => [   1,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "LED2_data" ],
);

%shub2_01_00004_def =
( NAME    => "SH2_JUNK_BUS_LED2",
  ADDRESS => 0x0000000010030100,
  NOTE    => "The JUNK_BUS_LED2 register provides software with a mechanism for note monitoring the state of the 8 LED2 devices.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00004_flds
);


##########################################################################
#                                                                        #
#   SH2_JUNK_BUS_LED3                                                    #
#                                                                        #
##########################################################################

%shub2_01_00005_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LED3_DATA"                    => [   1,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "LED3_data" ],
);

%shub2_01_00005_def =
( NAME    => "SH2_JUNK_BUS_LED3",
  ADDRESS => 0x0000000010030180,
  NOTE    => "The JUNK_BUS_LED3 register provides software with a mechanism for note monitoring the state of the 8 LED3 devices.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00005_flds
);


##########################################################################
#                                                                        #
#   SH2_LB_LIQ_CTL                                                       #
#                                                                        #
##########################################################################

%shub2_01_00006_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  19,  45, 0xFFFFFFFFFFF80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FORCE_LINVV_CREDIT"           => [   1,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Force linvv credit" ],
   "FORCE_RP_CREDIT"              => [   2,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Force reply credit" ],
   "FORCE_RQ_CREDIT"              => [   3,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Force request credit" ],
   "RSVD1"                        => [   4,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LIQ_RPL_CTL"                  => [   5,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "LIQ Reply Control" ],
   "RSVD2"                        => [   6,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LIQ_REQ_CTL"                  => [   7,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "LIQ Request Control" ],
);

%shub2_01_00006_def =
( NAME    => "SH2_LB_LIQ_CTL",
  ADDRESS => 0x0000000010040000,
  NOTE    => "The LB_LIQ_CTL register provides credit control for the LB's Input note Request Queue and Input Reply Queue. Parameters specifie",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00006_flds
);


##########################################################################
#                                                                        #
#   SH2_LB_LOQ_CTL                                                       #
#                                                                        #
##########################################################################

%shub2_01_00007_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   2,  62, 0xFFFFFFFFFFFFFFFC, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LOQ_RPL_CTL"                  => [   1,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "LOQ Reply Control" ],
   "LOQ_REQ_CTL"                  => [   2,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "LOQ Request Control" ],
);

%shub2_01_00007_def =
( NAME    => "SH2_LB_LOQ_CTL",
  ADDRESS => 0x0000000010040080,
  NOTE    => "The LB_LOQ_CTL register provides maintenance testing facilities note which throttle request and reply messages leaving the LB's ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00007_flds
);


##########################################################################
#                                                                        #
#   SH2_LB_MAX_REP_CREDIT_CNT                                            #
#                                                                        #
##########################################################################

%shub2_01_00008_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CNT"                      => [   1,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Max reply credits" ],
);

%shub2_01_00008_def =
( NAME    => "SH2_LB_MAX_REP_CREDIT_CNT",
  ADDRESS => 0x0000000010040100,
  NOTE    => "The LB_MAX_REP_CREDIT_CNT register specifies the reply VC credit note limit for the LB's LOQ block.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00008_flds
);


##########################################################################
#                                                                        #
#   SH2_LB_MAX_REQ_CREDIT_CNT                                            #
#                                                                        #
##########################################################################

%shub2_01_00009_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CNT"                      => [   1,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Max request credits" ],
);

%shub2_01_00009_def =
( NAME    => "SH2_LB_MAX_REQ_CREDIT_CNT",
  ADDRESS => 0x0000000010040180,
  NOTE    => "The LB_MAX_REQ_CREDIT_CNT register specifies the request VC credit note limit for the LB's LOQ block.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00009_flds
);


##########################################################################
#                                                                        #
#   SH2_PIO_TIME_OUT                                                     #
#                                                                        #
##########################################################################

%shub2_01_00010_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VALUE"                        => [   1,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "PIO time out value" ],
);

%shub2_01_00010_def =
( NAME    => "SH2_PIO_TIME_OUT",
  ADDRESS => 0x0000000010040280,
  NOTE    => "The PIO time out value register sets the time out value for PIO note request. This is the amount of time the PIO channel waits f",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00010_flds
);


##########################################################################
#                                                                        #
#   SH2_PIO_NACK_RESET                                                   #
#                                                                        #
##########################################################################

%shub2_01_00011_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   6,  58, 0xFFFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PTC_RESET"                    => [   1,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "PTC Conveyor Belt NACK Counter Reset" ],
   "EXTIO_INT3_RESET"             => [   2,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "extio_int3 Conveyor Belt NACK Counter Reset" ],
   "EXTIO_INT2_RESET"             => [   3,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "extio_int2 Conveyor Belt NACK Counter Reset" ],
   "EXTIO_INT1_RESET"             => [   4,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "extio_int1 Conveyor Belt NACK Counter Reset" ],
   "EXTIO_INT0_RESET"             => [   5,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "extio_int0 Conveyor Belt NACK Counter Reset" ],
   "IPI_RESET"                    => [   6,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "IPI Conveyor Belt NACK Counter Reset" ],
);

%shub2_01_00011_def =
( NAME    => "SH2_PIO_NACK_RESET",
  ADDRESS => 0x0000000010040300,
  NOTE    => "The PIO_NACK_RESET register provides a mechanism for resetting the note PIO Conveyor Belt's NACK counters. The PIO Conveyor Belt",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00011_flds
);


##########################################################################
#                                                                        #
#   SH2_CONVEYOR_BELT_TIME_OUT                                           #
#                                                                        #
##########################################################################

%shub2_01_00012_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  12,  52, 0xFFFFFFFFFFFFF000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VALUE"                        => [   1,   0,  12, 0x0000000000000FFF, 0x00, 1, 0x0000000000000000, "Conveyor Belt Time-out Counter Limit" ],
);

%shub2_01_00012_def =
( NAME    => "SH2_CONVEYOR_BELT_TIME_OUT",
  ADDRESS => 0x0000000010040380,
  NOTE    => "The CONVEYOR_BELT_TIME_OUT register along with the PTC_PARMS note register's PTC_TO_WRAP field control the maximum number of clo",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00012_flds
);


##########################################################################
#                                                                        #
#   SH2_CONVEYOR_BELT_CONFIG                                             #
#                                                                        #
##########################################################################

%shub2_01_00013_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  21,  43, 0xFFFFFFFFFFE00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PTC_CB_ENABLE"                => [   1,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "Conveyor Belt for PTC Register Enable" ],
   "RSVD1"                        => [   2,  17,   3, 0x00000000000E0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTIO_3_CB_ENABLE"            => [   3,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Conveyor Belt for External IO 0 Interrupt Register Enable" ],
   "RSVD2"                        => [   4,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTIO_2_CB_ENABLE"            => [   5,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Conveyor Belt for External IO 0 Interrupt Register Enable" ],
   "RSVD3"                        => [   6,   9,   3, 0x0000000000000E00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTIO_1_CB_ENABLE"            => [   7,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Conveyor Belt for External IO 0 Interrupt Register Enable" ],
   "RSVD4"                        => [   8,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTIO_0_CB_ENABLE"            => [   9,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Conveyor Belt for External IO 0 Interrupt Register Enable" ],
   "RSVD5"                        => [  10,   1,   3, 0x000000000000000E, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IPI_CB_ENABLE"                => [  11,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Conveyor Belt for IPI Interrupt Register Enable" ],
);

%shub2_01_00013_def =
( NAME    => "SH2_CONVEYOR_BELT_CONFIG",
  ADDRESS => 0x0000000010040400,
  NOTE    => "Conveyor Belt Configuration",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00013_flds
);


##########################################################################
#                                                                        #
#   SH2_LB_CREDIT_STATUS                                                 #
#                                                                        #
##########################################################################

%shub2_01_00014_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LOQ_RP_CREDIT"                => [   1,  23,   5, 0x000000000F800000, 0x00, 0, 0x0000000000000000, "LOQ reply queue credit counter" ],
   "LOQ_RQ_CREDIT"                => [   2,  18,   5, 0x00000000007C0000, 0x00, 0, 0x0000000000000000, "LOQ request queue credit counter" ],
   "LINVV_CREDIT"                 => [   3,  12,   6, 0x000000000003F000, 0x00, 0, 0x0000000000000000, "LINVV credit counter" ],
   "RSVD1"                        => [   4,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LIQ_RP_CREDIT"                => [   5,   6,   4, 0x00000000000003C0, 0x00, 0, 0x0000000000000000, "LIQ reply queue credit counter" ],
   "RSVD2"                        => [   6,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LIQ_RQ_CREDIT"                => [   7,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "LIQ request queue credit counter" ],
);

%shub2_01_00014_def =
( NAME    => "SH2_LB_CREDIT_STATUS",
  ADDRESS => 0x0000000010050000,
  NOTE    => "The the LB_CREDIT_STATUS register contains the current value of the note LB's 6 credit counters.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00014_flds
);


##########################################################################
#                                                                        #
#   SH2_LB_DEBUG_LOCAL_SEL                                               #
#                                                                        #
##########################################################################

%shub2_01_00015_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COMPARE_ENABLE"               => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Enable compare on bit 31 of Analyzer data" ],
   "FIELD_SELECT_7"               => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Field select" ],
   "RSVD0"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_7"               => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Group select" ],
   "RSVD1"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_6"               => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Field select" ],
   "RSVD2"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_6"               => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Group select" ],
   "RSVD3"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_5"               => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Field select" ],
   "RSVD4"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_5"               => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Group select" ],
   "RSVD5"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_4"               => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Field select" ],
   "RSVD6"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_4"               => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Group select" ],
   "RSVD7"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_3"               => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Field select" ],
   "RSVD8"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_3"               => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Group select" ],
   "RSVD9"                        => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_2"               => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Field select" ],
   "RSVD10"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_2"               => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 Group select" ],
   "RSVD11"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_1"               => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Field select" ],
   "RSVD12"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_1"               => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 Group select" ],
   "RSVD13"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_0"               => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Field select" ],
   "RSVD14"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_0"               => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Group select" ],
);

%shub2_01_00015_def =
( NAME    => "SH2_LB_DEBUG_LOCAL_SEL",
  ADDRESS => 0x0000000010050080,
  NOTE    => "The sh2_lb_debug_local_sel is the top level debug mux for the LB note chiplet. The chiplet select fields selects one of eight in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00015_flds
);


##########################################################################
#                                                                        #
#   SH2_LB_DEBUG_MUX0_SEL                                                #
#                                                                        #
##########################################################################

%shub2_01_00016_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_7"               => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Field select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_7"               => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Group select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_6"               => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Field select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_6"               => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Group select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_5"               => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Field select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_5"               => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Group select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_4"               => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Field select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_4"               => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Group select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_3"               => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Field select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_3"               => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Group select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_2"               => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Field select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_2"               => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 Group select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_1"               => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Field select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_1"               => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 Group select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_0"               => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Field select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_0"               => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Group select" ],
);

%shub2_01_00016_def =
( NAME    => "SH2_LB_DEBUG_MUX0_SEL",
  ADDRESS => 0x0000000010050100,
  NOTE    => "The sh2_lb_debug_mux0_sel is one of the second level debug muxes note for the LB chiplet. The chiplet select fields selects one ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00016_flds
);


##########################################################################
#                                                                        #
#   SH2_LB_DEBUG_MUX1_SEL                                                #
#                                                                        #
##########################################################################

%shub2_01_00017_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_7"               => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Field select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_7"               => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Group select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_6"               => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Field select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_6"               => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Chiplet select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_5"               => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Field select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_5"               => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Group select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_4"               => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Field select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_4"               => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Group select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_3"               => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Field select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_3"               => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Group select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_2"               => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Field select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_2"               => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 Group select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_1"               => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Field select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_1"               => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 Group select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_0"               => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Field select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_0"               => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Group select" ],
);

%shub2_01_00017_def =
( NAME    => "SH2_LB_DEBUG_MUX1_SEL",
  ADDRESS => 0x0000000010050180,
  NOTE    => "The lb_debug_mux1_sel register controls the 2nd level debug mux for note the lb chiplet. The output of this debug mux is connect",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00017_flds
);


##########################################################################
#                                                                        #
#   SH2_LB_DEBUG_COMPARE_SEL                                             #
#                                                                        #
##########################################################################

%shub2_01_00018_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_7"               => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Field select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_7"               => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Group select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_6"               => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Field select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_6"               => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Group select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_5"               => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Field select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_5"               => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Group select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_4"               => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Field select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_4"               => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Group select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_3"               => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Field select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_3"               => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Group select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_2"               => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Field select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_2"               => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 Group select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_1"               => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Field select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_1"               => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 Group select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_0"               => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Field select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_0"               => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Group select" ],
);

%shub2_01_00018_def =
( NAME    => "SH2_LB_DEBUG_COMPARE_SEL",
  ADDRESS => 0x0000000010050200,
  NOTE    => "The lb_debug_compare_sel register controls the compare mux in the note top level LB debug mux. The output of the compare mux is ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00018_flds
);


##########################################################################
#                                                                        #
#   SH2_LB_ERROR_DETAIL_1                                                #
#                                                                        #
##########################################################################

%shub2_01_00019_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "VALID" ],
   "RSVD0"                        => [   1,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECHO"                         => [   2,  52,   9, 0x1FF0000000000000, 0x00, 0, 0x0000000000000000, "Echo Field" ],
   "RSVD1"                        => [   3,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_ERR"                     => [   4,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "DATA_ERR" ],
   "HDR_ERR"                      => [   5,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "HDR_ERR" ],
   "RSVD2"                        => [   6,  42,   6, 0x0000FC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEST"                         => [   7,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "Destination Chiplet Code" ],
   "SOURCE_CHIPLET_ID"            => [   8,  38,   2, 0x000000C000000000, 0x00, 0, 0x0000000000000000, "Chiplet Code" ],
   "SOURCE_NODE_ID"               => [   9,  24,  14, 0x0000003FFF000000, 0x00, 0, 0x0000000000000000, "Source Node Number" ],
   "SUPPL"                        => [  10,   8,  16, 0x0000000000FFFF00, 0x00, 0, 0x0000000000000000, "Supplemental Field" ],
   "COMMAND"                      => [  11,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "SN2NET Message Code" ],
);

%shub2_01_00019_def =
( NAME    => "SH2_LB_ERROR_DETAIL_1",
  ADDRESS => 0x0000000010050280,
  NOTE    => "The LB_ERROR_DETAIL_1 register provides storage for detail error note information for the first LB Hardware Error detected.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00019_flds
);


##########################################################################
#                                                                        #
#   SH2_LB_ERROR_DETAIL_2                                                #
#                                                                        #
##########################################################################

%shub2_01_00020_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  49,  15, 0xFFFE000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDRESS"                      => [   1,   0,  49, 0x0001FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "ADDRESS" ],
);

%shub2_01_00020_def =
( NAME    => "SH2_LB_ERROR_DETAIL_2",
  ADDRESS => 0x0000000010050300,
  NOTE    => "This register is part of the LB error capture information. This note particular register contains the physical address from the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00020_flds
);


##########################################################################
#                                                                        #
#   SH2_LB_ERROR_DETAIL_3                                                #
#                                                                        #
##########################################################################

%shub2_01_00021_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "DATA" ],
);

%shub2_01_00021_def =
( NAME    => "SH2_LB_ERROR_DETAIL_3",
  ADDRESS => 0x0000000010050380,
  NOTE    => "The LB_ERROR_DETAIL_3 register provides storage for detail error note information for the first LB Hardware Error detected.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00021_flds
);


##########################################################################
#                                                                        #
#   SH2_LB_ERROR_DETAIL_4                                                #
#                                                                        #
##########################################################################

%shub2_01_00022_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ROUTE"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "ROUTE" ],
);

%shub2_01_00022_def =
( NAME    => "SH2_LB_ERROR_DETAIL_4",
  ADDRESS => 0x0000000010050400,
  NOTE    => "The LB_ERROR_DETAIL_4 register provides storage for detail error note information for the first LB Hardware Error detected.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00022_flds
);


##########################################################################
#                                                                        #
#   SH2_LB_ERROR_DETAIL_5                                                #
#                                                                        #
##########################################################################

%shub2_01_00023_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  27,  37, 0xFFFFFFFFF8000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PTC_NACK_B_TIMEOUT"           => [   1,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "PTC NACK-B Counter Time-out Error" ],
   "PTC_NACK_A_TIMEOUT"           => [   2,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "PTC NACK-A Counter Time-out Error" ],
   "PTC_COUNT_B_OVERFLOW"         => [   3,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "PTC NACK-B Counter Overflow Error" ],
   "PTC_COUNT_A_OVERFLOW"         => [   4,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "PTC NACK-A Counter Overflow Error" ],
   "EXTIO_INT3_NACK_B_TIMEOUT"    => [   5,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "EXTIO_INT3 NACK-B Counter Time-out Error" ],
   "EXTIO_INT3_NACK_A_TIMEOUT"    => [   6,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "EXTIO_INT3 NACK-A Counter Time-out Error" ],
   "EXTIO_INT3_COUNT_B_OVERFLOW"  => [   7,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "EXTIO_INT3 NACK-B Counter Overflow Error" ],
   "EXTIO_INT3_COUNT_A_OVERFLOW"  => [   8,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "EXTIO_INT3 NACK-A Counter Overflow Error" ],
   "EXTIO_INT2_NACK_B_TIMEOUT"    => [   9,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "EXTIO_INT2 NACK-B Counter Time-out Error" ],
   "EXTIO_INT2_NACK_A_TIMEOUT"    => [  10,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "EXTIO_INT2 NACK-A Counter Time-out Error" ],
   "EXTIO_INT2_COUNT_B_OVERFLOW"  => [  11,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "EXTIO_INT2 NACK-B Counter Overflow Error" ],
   "EXTIO_INT2_COUNT_A_OVERFLOW"  => [  12,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "EXTIO_INT2 NACK-A Counter Overflow Error" ],
   "EXTIO_INT1_NACK_B_TIMEOUT"    => [  13,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "EXTIO_INT1 NACK-B Counter Time-out Error" ],
   "EXTIO_INT1_NACK_A_TIMEOUT"    => [  14,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "EXTIO_INT1 NACK-A Counter Time-out Error" ],
   "EXTIO_INT1_COUNT_B_OVERFLOW"  => [  15,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "EXTIO_INT1 NACK-B Counter Overflow Error" ],
   "EXTIO_INT1_COUNT_A_OVERFLOW"  => [  16,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "EXTIO_INT1 NACK-A Counter Overflow Error" ],
   "EXTIO_INT0_NACK_B_TIMEOUT"    => [  17,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "EXTIO_INT0 NACK-B Counter Time-out Error" ],
   "EXTIO_INT0_NACK_A_TIMEOUT"    => [  18,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "EXTIO_INT0 NACK-A Counter Time-out Error" ],
   "EXTIO_INT0_COUNT_B_OVERFLOW"  => [  19,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "EXTIO_INT0 NACK-B Counter Overflow Error" ],
   "EXTIO_INT0_COUNT_A_OVERFLOW"  => [  20,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "EXTIO_INT0 NACK-A Counter Overflow Error" ],
   "IPI_NACK_B_TIMEOUT"           => [  21,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "IPI NACK-B Counter Time-out Error" ],
   "IPI_NACK_A_TIMEOUT"           => [  22,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "IPI NACK-A Counter Time-out Error" ],
   "IPI_COUNT_B_OVERFLOW"         => [  23,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "IPI NACK-B Counter Overflow Error" ],
   "IPI_COUNT_A_OVERFLOW"         => [  24,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "IPI NACK-A Counter Overflow Error" ],
   "WRITE_RETRY"                  => [  25,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Write Retry Error" ],
   "RSVD1"                        => [  26,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "READ_RETRY"                   => [  27,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Read Retry Error" ],
);

%shub2_01_00023_def =
( NAME    => "SH2_LB_ERROR_DETAIL_5",
  ADDRESS => 0x0000000010050480,
  NOTE    => "The LB_ERROR_DETAIL_5 register provides storage for detail error note information for the first PIO Conveyor Belt Error (PIO_CB_",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00023_flds
);


##########################################################################
#                                                                        #
#   SH2_LB_ERROR_DETAIL_6                                                #
#                                                                        #
##########################################################################

%shub2_01_00024_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STATUS"                       => [   1,  58,   5, 0x7C00000000000000, 0x00, 0, 0x0000000000000000, "Status" ],
   "MODE"                         => [   2,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "Mode" ],
   "CMD"                          => [   3,  49,   8, 0x01FE000000000000, 0x00, 0, 0x0000000000000000, "Junk bus command" ],
   "ADDRESS"                      => [   4,   0,  49, 0x0001FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Failing junk bus address" ],
);

%shub2_01_00024_def =
( NAME    => "SH2_LB_ERROR_DETAIL_6",
  ADDRESS => 0x0000000010050500,
  NOTE    => "The LB_ERROR_DETAIL_6 register stores detail error information when note Junk Bus Errors are detected.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00024_flds
);


##########################################################################
#                                                                        #
#   SH2_LB_ERROR_MASK                                                    #
#                                                                        #
##########################################################################

%shub2_01_00025_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  25,  39, 0xFFFFFFFFFE000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_BAD_REPLY"                 => [   1,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Bad Reply from NCWRF Request Mask" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_CREDIT_OVERFLOW"           => [   3,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "Reply Credit Overflow Error Mask" ],
   "RQ_CREDIT_OVERFLOW"           => [   4,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "Request Credit Overflow Error Mask" ],
   "UNEXP_VALID"                  => [   5,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "MMR Address Decode Error Mask" ],
   "RP_FIFO_ERROR"                => [   6,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "Reply Queue Overflow Error Mask" ],
   "RQ_FIFO_ERROR"                => [   7,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "Request Queue Overflow Error Mask" ],
   "GCLK_DROP"                    => [   8,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "Dropped Global Clock Error Mask" ],
   "VECTOR_RP_ROUTE_ERROR"        => [   9,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Vector Reply Route Error Mask" ],
   "VECTOR_RQ_ROUTE_ERROR"        => [  10,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Vector Request Route Error Mask" ],
   "PIO_CB_ERR"                   => [  11,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "PIO Conveyor Belt Error Mask" ],
   "JUNK_BUS_ERR"                 => [  12,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Junk Bus Error Mask" ],
   "RSVD2"                        => [  13,  11,   2, 0x0000000000001800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LINVV_OVERFLOW"               => [  14,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "LINVV Overflow Error Mask" ],
   "RQ_TIME_OUT"                  => [  15,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Request Time-out Error Mask" ],
   "RQ_BAD_ADDR"                  => [  16,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Request Bad Address Error Mask" ],
   "RP_BAD_DATA"                  => [  17,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Reply Bad Data Error Mask" ],
   "RQ_BAD_DATA"                  => [  18,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Request Bad Data Error Mask" ],
   "RP_LONG"                      => [  19,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Obese Reply Message Error Mask" ],
   "RQ_LONG"                      => [  20,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Obese Request Message Error Mask" ],
   "RP_SHORT"                     => [  21,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Runt Reply Message Error Mask" ],
   "RQ_SHORT"                     => [  22,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Runt Request Message Error Mask" ],
   "RP_BAD_CMD"                   => [  23,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Unsupported Reply Message Error Mask" ],
   "RQ_BAD_CMD"                   => [  24,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Unsupported Request Message Error Mask" ],
);

%shub2_01_00025_def =
( NAME    => "SH2_LB_ERROR_MASK",
  ADDRESS => 0x0000000010050580,
  NOTE    => "The LB_ERROR_MASK register is the primary LB Hardware Error note configuration register. It contains a mask bit for each of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00025_flds
);


##########################################################################
#                                                                        #
#   SH2_LB_ERROR_OVERFLOW                                                #
#                                                                        #
##########################################################################

%shub2_01_00026_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  25,  39, 0xFFFFFFFFFE000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_BAD_REPLY_OVRFL"           => [   1,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Bad Reply from NCWRF Request" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_CREDIT_OVERFLOW_OVRFL"     => [   3,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Reply Credit Overflow Error Overflow" ],
   "RQ_CREDIT_OVERFLOW_OVRFL"     => [   4,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Request Credit Overflow Error Overflow" ],
   "UNEXP_VALID_OVRFL"            => [   5,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MMR Address Decode Error Overflow" ],
   "RP_FIFO_ERROR_OVRFL"          => [   6,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reply Queue Overflow Error Overflow" ],
   "RQ_FIFO_ERROR_OVRFL"          => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Request Queue Overflow Error Overflow" ],
   "GCLK_DROP_OVRFL"              => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Dropped Global Clock Error Overflow" ],
   "VECTOR_RP_ROUTE_ERROR_OVRFL"  => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Vector Reply Route Error Overflow" ],
   "VECTOR_RQ_ROUTE_ERROR_OVRFL"  => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Vector Request Route Error Overflow" ],
   "PIO_CB_ERR_OVRFL"             => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "PIO Conveyor Belt Error Overflow" ],
   "JUNK_BUS_ERR_OVRFL"           => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Junk Bus Error Overflow" ],
   "RSVD2"                        => [  13,  11,   2, 0x0000000000001800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LINVV_OVERFLOW_OVRFL"         => [  14,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "LINVV Overflow Error Overflow" ],
   "RQ_TIME_OUT_OVRFL"            => [  15,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Request Time-out Error Overflow" ],
   "RQ_BAD_ADDR_OVRFL"            => [  16,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Request Bad Address Error Overflow" ],
   "RP_BAD_DATA_OVRFL"            => [  17,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reply Bad Data Error Overflow" ],
   "RQ_BAD_DATA_OVRFL"            => [  18,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Request Bad Data Error Overflow" ],
   "RP_LONG_OVRFL"                => [  19,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Obese Reply Message Error Overflow" ],
   "RQ_LONG_OVRFL"                => [  20,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Obese Request Message Error Overflow" ],
   "RP_SHORT_OVRFL"               => [  21,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Runt Reply Message Error Overflow" ],
   "RQ_SHORT_OVRFL"               => [  22,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Runt Request Message Error Overflow" ],
   "RP_BAD_CMD_OVRFL"             => [  23,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Unsupported Reply Message Error Overflow" ],
   "RQ_BAD_CMD_OVRFL"             => [  24,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Unsupported Request Message Error Overflow" ],
);

%shub2_01_00026_def =
( NAME    => "SH2_LB_ERROR_OVERFLOW",
  ADDRESS => 0x0000000010050600,
  NOTE    => "The LB_ERROR_OVERFLOW register contains 24 flags. Each flag note corresponds to 1 of the 24 hardware errors detected by the LB n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00026_flds
);


##########################################################################
#                                                                        #
#   SH2_LB_ERROR_OVERFLOW_ALIAS                                          #
#                                                                        #
##########################################################################

%shub2_01_00027_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  25,  39, 0xFFFFFFFFFE000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_BAD_REPLY_OVRFL"           => [   1,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Bad Reply from NCWRF Request" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_CREDIT_OVERFLOW_OVRFL"     => [   3,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Reply Credit Overflow Error Overflow" ],
   "RQ_CREDIT_OVERFLOW_OVRFL"     => [   4,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Request Credit Overflow Error Overflow" ],
   "UNEXP_VALID_OVRFL"            => [   5,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MMR Address Decode Error Overflow" ],
   "RP_FIFO_ERROR_OVRFL"          => [   6,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reply Queue Overflow Error Overflow" ],
   "RQ_FIFO_ERROR_OVRFL"          => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Request Queue Overflow Error Overflow" ],
   "GCLK_DROP_OVRFL"              => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Dropped Global Clock Error Overflow" ],
   "VECTOR_RP_ROUTE_ERROR_OVRFL"  => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Vector Reply Route Error Overflow" ],
   "VECTOR_RQ_ROUTE_ERROR_OVRFL"  => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Vector Request Route Error Overflow" ],
   "PIO_CB_ERR_OVRFL"             => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "PIO Conveyor Belt Error Overflow" ],
   "JUNK_BUS_ERR_OVRFL"           => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Junk Bus Error Overflow" ],
   "RSVD2"                        => [  13,  11,   2, 0x0000000000001800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LINVV_OVERFLOW_OVRFL"         => [  14,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "LINVV Overflow Error Overflow" ],
   "RQ_TIME_OUT_OVRFL"            => [  15,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Request Time-out Error Overflow" ],
   "RQ_BAD_ADDR_OVRFL"            => [  16,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Request Bad Address Error Overflow" ],
   "RP_BAD_DATA_OVRFL"            => [  17,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reply Bad Data Error Overflow" ],
   "RQ_BAD_DATA_OVRFL"            => [  18,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Request Bad Data Error Overflow" ],
   "RP_LONG_OVRFL"                => [  19,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Obese Reply Message Error Overflow" ],
   "RQ_LONG_OVRFL"                => [  20,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Obese Request Message Error Overflow" ],
   "RP_SHORT_OVRFL"               => [  21,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Runt Reply Message Error Overflow" ],
   "RQ_SHORT_OVRFL"               => [  22,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Runt Request Message Error Overflow" ],
   "RP_BAD_CMD_OVRFL"             => [  23,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Unsupported Reply Message Error Overflow" ],
   "RQ_BAD_CMD_OVRFL"             => [  24,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Unsupported Request Message Error Overflow" ],
);

%shub2_01_00027_def =
( NAME    => "SH2_LB_ERROR_OVERFLOW_ALIAS",
  ADDRESS => 0x0000000010050608,
  NOTE    => "The LB_ERROR_OVERFLOW_ALIAS address is an alias to the note LB_ERROR_OVERFLOW register. Refer to the LB_ERROR_OVERFLOW register ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00027_flds
);


##########################################################################
#                                                                        #
#   SH2_LB_ERROR_SUMMARY                                                 #
#                                                                        #
##########################################################################

%shub2_01_00028_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  25,  39, 0xFFFFFFFFFE000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_BAD_REPLY"                 => [   1,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Bad Reply from NCWRF Request" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_CREDIT_OVERFLOW"           => [   3,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Reply Credit Overflow Error" ],
   "RQ_CREDIT_OVERFLOW"           => [   4,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Request Credit Overflow Error" ],
   "UNEXP_VALID"                  => [   5,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MMR Address Decode Error" ],
   "RP_FIFO_ERROR"                => [   6,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reply Queue Overflow Error" ],
   "RQ_FIFO_ERROR"                => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Request Queue Overflow Error" ],
   "GCLK_DROP"                    => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Dropped Global Clock Error" ],
   "VECTOR_RP_ROUTE_ERROR"        => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Vector Reply Route Error" ],
   "VECTOR_RQ_ROUTE_ERROR"        => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Vector Request Route Error" ],
   "PIO_CB_ERR"                   => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "PIO Conveyor Belt Error" ],
   "JUNK_BUS_ERR"                 => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Junk Bus Error" ],
   "RSVD2"                        => [  13,  11,   2, 0x0000000000001800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LINVV_OVERFLOW"               => [  14,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "LINVV Overflow Error" ],
   "RQ_TIME_OUT"                  => [  15,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Request Time-out Error" ],
   "RQ_BAD_ADDR"                  => [  16,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Request Bad Address Error" ],
   "RP_BAD_DATA"                  => [  17,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reply Bad Data Error" ],
   "RQ_BAD_DATA"                  => [  18,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Request Bad Data Error" ],
   "RP_LONG"                      => [  19,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Obese Reply Message Error" ],
   "RQ_LONG"                      => [  20,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Obese Request Message Error" ],
   "RP_SHORT"                     => [  21,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Runt Reply Message Error" ],
   "RQ_SHORT"                     => [  22,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Runt Request Message Error" ],
   "RP_BAD_CMD"                   => [  23,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Unsupported Reply Message Error" ],
   "RQ_BAD_CMD"                   => [  24,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Unsupported Request Message Error" ],
);

%shub2_01_00028_def =
( NAME    => "SH2_LB_ERROR_SUMMARY",
  ADDRESS => 0x0000000010050680,
  NOTE    => "The LB_ERROR_SUMMARY register is the LB's top-level error flag note register. It contains 24 flags. Each flag corresponds to one",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00028_flds
);


##########################################################################
#                                                                        #
#   SH2_LB_ERROR_SUMMARY_ALIAS                                           #
#                                                                        #
##########################################################################

%shub2_01_00029_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  25,  39, 0xFFFFFFFFFE000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_BAD_REPLY"                 => [   1,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Bad Reply from NCWRF Request" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_CREDIT_OVERFLOW"           => [   3,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Reply Credit Overflow Error" ],
   "RQ_CREDIT_OVERFLOW"           => [   4,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Request Credit Overflow Error" ],
   "UNEXP_VALID"                  => [   5,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MMR Address Decode Error" ],
   "RP_FIFO_ERROR"                => [   6,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reply Queue Overflow Error" ],
   "RQ_FIFO_ERROR"                => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Request Queue Overflow Error" ],
   "GCLK_DROP"                    => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Dropped Global Clock Error" ],
   "VECTOR_RP_ROUTE_ERROR"        => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Vector Reply Route Error" ],
   "VECTOR_RQ_ROUTE_ERROR"        => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Vector Request Route Error" ],
   "PIO_CB_ERR"                   => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "PIO Conveyor Belt Error" ],
   "JUNK_BUS_ERR"                 => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Junk Bus Error" ],
   "RSVD2"                        => [  13,  11,   2, 0x0000000000001800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LINVV_OVERFLOW"               => [  14,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "LINVV Overflow Error" ],
   "RQ_TIME_OUT"                  => [  15,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Request Time-out Error" ],
   "RQ_BAD_ADDR"                  => [  16,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Request Bad Address Error" ],
   "RP_BAD_DATA"                  => [  17,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reply Bad Data Error" ],
   "RQ_BAD_DATA"                  => [  18,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Request Bad Data Error" ],
   "RP_LONG"                      => [  19,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Obese Reply Message Error" ],
   "RQ_LONG"                      => [  20,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Obese Request Message Error" ],
   "RP_SHORT"                     => [  21,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Runt Reply Message Error" ],
   "RQ_SHORT"                     => [  22,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Runt Request Message Error" ],
   "RP_BAD_CMD"                   => [  23,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Unsupported Reply Message Error" ],
   "RQ_BAD_CMD"                   => [  24,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Unsupported Request Message Error" ],
);

%shub2_01_00029_def =
( NAME    => "SH2_LB_ERROR_SUMMARY_ALIAS",
  ADDRESS => 0x0000000010050688,
  NOTE    => "The LB_ERROR_SUMMARY_ALIAS address is an alias to the note LB_ERROR_SUMMARY register. Refer to the LB_ERROR_SUMMARY register not",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00029_flds
);


##########################################################################
#                                                                        #
#   SH2_LB_FIRST_ERROR                                                   #
#                                                                        #
##########################################################################

%shub2_01_00030_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  25,  39, 0xFFFFFFFFFE000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_BAD_REPLY"                 => [   1,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Bad Reply Error" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_CREDIT_OVERFLOW"           => [   3,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Reply Credit Overflow Error" ],
   "RQ_CREDIT_OVERFLOW"           => [   4,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Request Credit Overflow Error" ],
   "UNEXP_VALID"                  => [   5,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MMR Address Decode Error" ],
   "RP_FIFO_ERROR"                => [   6,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reply Queue Overflow Error" ],
   "RQ_FIFO_ERROR"                => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Request Queue Overflow Error" ],
   "GCLK_DROP"                    => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Dropped Global Clock Error" ],
   "VECTOR_RP_ROUTE_ERROR"        => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Vector Reply Route Error" ],
   "VECTOR_RQ_ROUTE_ERROR"        => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Vector Request Route Error" ],
   "PIO_CB_ERR"                   => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "PIO Conveyor Belt Error" ],
   "JUNK_BUS_ERR"                 => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Junk Bus Error" ],
   "RSVD2"                        => [  13,  11,   2, 0x0000000000001800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LINVV_OVERFLOW"               => [  14,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "LINVV Overflow Error" ],
   "RQ_TIME_OUT"                  => [  15,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Request Time-out Error" ],
   "RQ_BAD_ADDR"                  => [  16,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Request Bad Address Error" ],
   "RP_BAD_DATA"                  => [  17,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reply Bad Data Error" ],
   "RQ_BAD_DATA"                  => [  18,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Request Bad Data Error" ],
   "RP_LONG"                      => [  19,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Obese Reply Message Error" ],
   "RQ_LONG"                      => [  20,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Obese Request Message Error" ],
   "RP_SHORT"                     => [  21,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Runt Reply Message Error" ],
   "RQ_SHORT"                     => [  22,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Runt Request Message Error" ],
   "RP_BAD_CMD"                   => [  23,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Unsupported Reply Message Error" ],
   "RQ_BAD_CMD"                   => [  24,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Unsupported Request Message Error" ],
);

%shub2_01_00030_def =
( NAME    => "SH2_LB_FIRST_ERROR",
  ADDRESS => 0x0000000010050700,
  NOTE    => "The LB_FIRST_ERROR register contains 24 flags. Each flag note corresponds to one of the 24 flags in the LB_ERROR_SUMMARY note re",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00030_flds
);


##########################################################################
#                                                                        #
#   SH2_LB_LAST_CREDIT                                                   #
#                                                                        #
##########################################################################

%shub2_01_00031_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LOQ_RP_CREDIT"                => [   1,  23,   5, 0x000000000F800000, 0x00, 0, 0x0000000000000000, "LOQ reply queue credit counter" ],
   "LOQ_RQ_CREDIT"                => [   2,  18,   5, 0x00000000007C0000, 0x00, 0, 0x0000000000000000, "LOQ request queue credit counter" ],
   "LINVV_CREDIT"                 => [   3,  12,   6, 0x000000000003F000, 0x00, 0, 0x0000000000000000, "LINVV credit counter" ],
   "RSVD1"                        => [   4,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LIQ_RP_CREDIT"                => [   5,   6,   4, 0x00000000000003C0, 0x00, 0, 0x0000000000000000, "LIQ reply queue credit counter" ],
   "RSVD2"                        => [   6,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LIQ_RQ_CREDIT"                => [   7,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "LIQ request queue credit counter" ],
);

%shub2_01_00031_def =
( NAME    => "SH2_LB_LAST_CREDIT",
  ADDRESS => 0x0000000010050780,
  NOTE    => "The LB_LAST_CREDIT register stores the value of the LB's five note credit counters when a reset occurs. The leading edge of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00031_flds
);


##########################################################################
#                                                                        #
#   SH2_LB_NACK_STATUS0                                                  #
#                                                                        #
##########################################################################

%shub2_01_00032_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IPI_CB_STATE"                 => [   1,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "IPI Conveyor Belt State" ],
   "CB_TIMEOUT_COUNT"             => [   2,  48,  12, 0x0FFF000000000000, 0x00, 1, 0x0000000000000000, "PTC Conveyor Belt Time-out Count" ],
   "JUNK_NACK"                    => [   3,  32,  16, 0x0000FFFF00000000, 0x00, 1, 0x0000000000000000, "Junk Bus Conveyor Belt NACK Counter" ],
   "RSVD1"                        => [   4,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IPI_NACK_B"                   => [   5,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "IPI Conveyor Belt NACK-B Count" ],
   "RSVD2"                        => [   6,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IPI_NACK_A"                   => [   7,   0,  12, 0x0000000000000FFF, 0x00, 1, 0x0000000000000000, "IPI Conveyor Belt NACK-A Count" ],
);

%shub2_01_00032_def =
( NAME    => "SH2_LB_NACK_STATUS0",
  ADDRESS => 0x0000000010050800,
  NOTE    => "The LB_NACK_STATUS0 register contains the current value of the PIO note IPI Conveyor Belt's and Junk Bus Conveyor Belt's NACK co",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00032_flds
);


##########################################################################
#                                                                        #
#   SH2_LB_NACK_STATUS1                                                  #
#                                                                        #
##########################################################################

%shub2_01_00033_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTIO_INT1_CB_STATE"          => [   1,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "EXTIO_INT1 Conveyor Belt State" ],
   "EXTIO_INT1_NACK_B"            => [   2,  48,  12, 0x0FFF000000000000, 0x00, 1, 0x0000000000000000, "EXTIO_INT1 Conveyor Belt NACK-B Count" ],
   "RSVD1"                        => [   3,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTIO_INT1_NACK_A"            => [   4,  32,  12, 0x00000FFF00000000, 0x00, 1, 0x0000000000000000, "EXTIO_INT1 Conveyor Belt NACK-A Count" ],
   "RSVD2"                        => [   5,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTIO_INT0_CB_STATE"          => [   6,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "EXTIO_INT0 Conveyor Belt State" ],
   "EXTIO_INT0_NACK_B"            => [   7,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "EXTIO_INT0 Conveyor Belt NACK-B Count" ],
   "RSVD3"                        => [   8,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTIO_INT0_NACK_A"            => [   9,   0,  12, 0x0000000000000FFF, 0x00, 1, 0x0000000000000000, "EXTIO_INT0 Conveyor Belt NACK-A Count" ],
);

%shub2_01_00033_def =
( NAME    => "SH2_LB_NACK_STATUS1",
  ADDRESS => 0x0000000010050880,
  NOTE    => "The LB_NACK_STATUS1 register contains the current value of the PIO note EXTIO_INT0 Conveyor Belt's and the PIO EXTIO_INT1 Convey",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00033_flds
);


##########################################################################
#                                                                        #
#   SH2_LB_NACK_STATUS2                                                  #
#                                                                        #
##########################################################################

%shub2_01_00034_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTIO_INT3_CB_STATE"          => [   1,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "EXTIO_INT3 Conveyor Belt State" ],
   "EXTIO_INT3_NACK_B"            => [   2,  48,  12, 0x0FFF000000000000, 0x00, 1, 0x0000000000000000, "EXTIO_INT3 Conveyor Belt NACK-B Count" ],
   "RSVD1"                        => [   3,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTIO_INT3_NACK_A"            => [   4,  32,  12, 0x00000FFF00000000, 0x00, 1, 0x0000000000000000, "EXTIO_INT3 Conveyor Belt NACK-A Count" ],
   "RSVD2"                        => [   5,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTIO_INT2_CB_STATE"          => [   6,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "EXTIO_INT2 Conveyor Belt State" ],
   "EXTIO_INT2_NACK_B"            => [   7,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "EXTIO_INT2 Conveyor Belt NACK-B Count" ],
   "RSVD3"                        => [   8,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTIO_INT2_NACK_A"            => [   9,   0,  12, 0x0000000000000FFF, 0x00, 1, 0x0000000000000000, "EXTIO_INT2 Conveyor Belt NACK-A Count" ],
);

%shub2_01_00034_def =
( NAME    => "SH2_LB_NACK_STATUS2",
  ADDRESS => 0x0000000010050900,
  NOTE    => "The LB_NACK_STATUS2 register contains the current value of the PIO note EXTIO_INT2 Conveyor Belt's and the PIO EXTIO_INT3 Convey",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00034_flds
);


##########################################################################
#                                                                        #
#   SH2_LB_NACK_STATUS3                                                  #
#                                                                        #
##########################################################################

%shub2_01_00035_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  30,  34, 0xFFFFFFFFC0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PTC_CB_STATE"                 => [   1,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "PTC Conveyor Belt State" ],
   "PTC_NACK_B"                   => [   2,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "PTC Conveyor Belt NACK-B Count" ],
   "RSVD1"                        => [   3,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PTC_NACK_A"                   => [   4,   0,  12, 0x0000000000000FFF, 0x00, 1, 0x0000000000000000, "PTC Conveyor Belt NACK-A Count" ],
);

%shub2_01_00035_def =
( NAME    => "SH2_LB_NACK_STATUS3",
  ADDRESS => 0x0000000010050980,
  NOTE    => "The LB_NACK_STATUS3 register contains the current value of the PIO note PTC Conveyor Belt's NACK counters. It also contains the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00035_flds
);


##########################################################################
#                                                                        #
#   SH2_LB_COMPARE_COMPARE                                               #
#                                                                        #
##########################################################################

%shub2_01_00036_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MASK"                         => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Mask to select Debug bits for compare generation" ],
);

%shub2_01_00036_def =
( NAME    => "SH2_LB_COMPARE_COMPARE",
  ADDRESS => 0x0000000010050a00,
  NOTE    => "The LB_COMPARE_COMPARE register enables a comparison test between note the output of LB's 32-bit Trigger Multiplexer and the not",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00036_flds
);


##########################################################################
#                                                                        #
#   SH2_LB_COMPARE_DATA                                                  #
#                                                                        #
##########################################################################

%shub2_01_00037_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COMPARE_PATTERN"              => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "debug bit pattern for compare generation" ],
);

%shub2_01_00037_def =
( NAME    => "SH2_LB_COMPARE_DATA",
  ADDRESS => 0x0000000010050a80,
  NOTE    => "The LB_COMPARE_DATA register contains the pattern to which the LB's note Trigger Multiplexer Output Port is compared. One or mor",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00037_flds
);


##########################################################################
#                                                                        #
#   SH2_PERFORMANCE_COUNT0_CONTROL                                       #
#                                                                        #
##########################################################################

%shub2_01_00038_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CLR_ENABLE"                   => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Counter 0 enable clear" ],
   "CLR_MODE"                     => [   2,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Counter 0 clear mode select (1-internal, 0-external)" ],
   "CLR_POLARITY"                 => [   3,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Counter 0 clear polarity select (1-negative edge, 0-positive edge)" ],
   "CLR_EVENT"                    => [   4,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Counter 0 clear format select (1-level, 0-edge)" ],
   "CLR_STIMULUS"                 => [   5,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "Counter 0 clear stimulus" ],
   "RSVD1"                        => [   6,  19,   5, 0x0000000000F80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Counter 0 enable peak detection" ],
   "DEC_ENABLE"                   => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Counter 0 enable decrement" ],
   "INC_ENABLE"                   => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Counter 0 enable increment" ],
   "DN_MODE"                      => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Counter 0 down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Counter 0 down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Counter 0 down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "Counter 0 down stimulus" ],
   "UP_MODE"                      => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Counter 0 up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Counter 0 up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Counter 0 up format select (1-level, 0-edge)" ],
   "UP_STIMULUS"                  => [  17,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter 0 up stimulus" ],
);

%shub2_01_00038_def =
( NAME    => "SH2_PERFORMANCE_COUNT0_CONTROL",
  ADDRESS => 0x0000000010080000,
  NOTE    => "The sh2_performance_count0_control register controls the note incrementing and decrementing of event counter 0.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00038_flds
);


##########################################################################
#                                                                        #
#   SH2_PERFORMANCE_COUNT1_CONTROL                                       #
#                                                                        #
##########################################################################

%shub2_01_00039_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CLR_ENABLE"                   => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Counter 1 enable clear" ],
   "CLR_MODE"                     => [   2,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Counter 1 clear mode select (1-internal, 0-external)" ],
   "CLR_POLARITY"                 => [   3,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Counter 1 clear polarity select (1-negative edge, 0-positive edge)" ],
   "CLR_EVENT"                    => [   4,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Counter 1 clear format select (1-level, 0-edge)" ],
   "CLR_STIMULUS"                 => [   5,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "Counter 1 clear stimulus" ],
   "RSVD1"                        => [   6,  19,   5, 0x0000000000F80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Counter 1 enable peak detection" ],
   "DEC_ENABLE"                   => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Counter 1 enable decrement" ],
   "INC_ENABLE"                   => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Counter 1 enable increment" ],
   "DN_MODE"                      => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Counter 1 down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Counter 1 down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Counter 1 down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "Counter 1 down stimulus" ],
   "UP_MODE"                      => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Counter 1 up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Counter 1 up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Counter 1 up format select (1-level, 0-edge)" ],
   "UP_STIMULUS"                  => [  17,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter 1 up stimulus" ],
);

%shub2_01_00039_def =
( NAME    => "SH2_PERFORMANCE_COUNT1_CONTROL",
  ADDRESS => 0x0000000010090000,
  NOTE    => "The sh2_performance_count1_control register controls the note incrementing and decrementing of event counter 1.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00039_flds
);


##########################################################################
#                                                                        #
#   SH2_PERFORMANCE_COUNT2_CONTROL                                       #
#                                                                        #
##########################################################################

%shub2_01_00040_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CLR_ENABLE"                   => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Counter 2 enable clear" ],
   "CLR_MODE"                     => [   2,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Counter 2 clear mode select (1-internal, 0-external)" ],
   "CLR_POLARITY"                 => [   3,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Counter 2 clear polarity select (1-negative edge, 0-positive edge)" ],
   "CLR_EVENT"                    => [   4,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Counter 2 clear format select (1-level, 0-edge)" ],
   "CLR_STIMULUS"                 => [   5,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "Counter 2 clear stimulus" ],
   "RSVD1"                        => [   6,  19,   5, 0x0000000000F80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Counter 2 enable peak detection" ],
   "DEC_ENABLE"                   => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Counter 2 enable decrement" ],
   "INC_ENABLE"                   => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Counter 2 enable increment" ],
   "DN_MODE"                      => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Counter 2 down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Counter 2 down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Counter 2 down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "Counter 2 down stimulus" ],
   "UP_MODE"                      => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Counter 2 up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Counter 2 up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Counter 2 up format select (1-level 0-edge)" ],
   "UP_STIMULUS"                  => [  17,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter 2 up stimulus" ],
);

%shub2_01_00040_def =
( NAME    => "SH2_PERFORMANCE_COUNT2_CONTROL",
  ADDRESS => 0x00000000100a0000,
  NOTE    => "The sh2_performance_count2_control register controls the note incrementing and decrementing of event counter 2.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00040_flds
);


##########################################################################
#                                                                        #
#   SH2_PERFORMANCE_COUNT3_CONTROL                                       #
#                                                                        #
##########################################################################

%shub2_01_00041_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CLR_ENABLE"                   => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Counter 3 enable clear" ],
   "CLR_MODE"                     => [   2,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Counter 3 clear mode select (1-internal, 0-external)" ],
   "CLR_POLARITY"                 => [   3,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Counter 3 clear polarity select (1-negative edge, 0-positive edge)" ],
   "CLR_EVENT"                    => [   4,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Counter 3 clear format select (1-level, 0-edge)" ],
   "CLR_STIMULUS"                 => [   5,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "Counter 3 clear stimulus" ],
   "RSVD1"                        => [   6,  19,   5, 0x0000000000F80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Counter 3 enable peak detection" ],
   "DEC_ENABLE"                   => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Counter 3 enable decrement" ],
   "INC_ENABLE"                   => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Counter 3 enable increment" ],
   "DN_MODE"                      => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Counter 3 down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Counter 3 down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Counter 3 down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "Counter 3 down stimulus" ],
   "UP_MODE"                      => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Counter 3 up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Counter 3 up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Counter 3 up format select (1-level, 0-edge)" ],
   "UP_STIMULUS"                  => [  17,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter 3 up stimulus" ],
);

%shub2_01_00041_def =
( NAME    => "SH2_PERFORMANCE_COUNT3_CONTROL",
  ADDRESS => 0x00000000100b0000,
  NOTE    => "The sh2_performance_count3_control register controls the note incrementing and decrementing of event counter 3.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00041_flds
);


##########################################################################
#                                                                        #
#   SH2_PERFORMANCE_COUNT4_CONTROL                                       #
#                                                                        #
##########################################################################

%shub2_01_00042_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CLR_ENABLE"                   => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Counter 4 enable clear" ],
   "CLR_MODE"                     => [   2,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Counter 4 clear mode select (1-internal, 0-external)" ],
   "CLR_POLARITY"                 => [   3,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Counter 4 clear polarity select (1-negative edge, 0-positive edge)" ],
   "CLR_EVENT"                    => [   4,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Counter 4 clear format select (1-level, 0-edge)" ],
   "CLR_STIMULUS"                 => [   5,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "Counter 4 clear stimulus" ],
   "RSVD1"                        => [   6,  19,   5, 0x0000000000F80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Counter 4 enable peak detection" ],
   "DEC_ENABLE"                   => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Counter 4 enable decrement" ],
   "INC_ENABLE"                   => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Counter 4 enable increment" ],
   "DN_MODE"                      => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Counter 4 down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Counter 4 down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Counter 4 down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "Counter 4 down stimulus" ],
   "UP_MODE"                      => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Counter 4 up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Counter 4 up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Counter 4 up format select (1-level, 0-edge)" ],
   "UP_STIMULUS"                  => [  17,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter 4 up stimulus" ],
);

%shub2_01_00042_def =
( NAME    => "SH2_PERFORMANCE_COUNT4_CONTROL",
  ADDRESS => 0x00000000100c0000,
  NOTE    => "The sh2_performance_count4_control register controls the note incrementing and decrementing of event counter 4.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00042_flds
);


##########################################################################
#                                                                        #
#   SH2_PERFORMANCE_COUNT5_CONTROL                                       #
#                                                                        #
##########################################################################

%shub2_01_00043_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CLR_ENABLE"                   => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Counter 5 enable clear" ],
   "CLR_MODE"                     => [   2,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Counter 5 clear mode select (1-internal, 0-external)" ],
   "CLR_POLARITY"                 => [   3,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Counter 5 clear polarity select (1-negative edge, 0-positive edge)" ],
   "CLR_EVENT"                    => [   4,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Counter 5 clear format select (1-level, 0-edge)" ],
   "CLR_STIMULUS"                 => [   5,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "Counter 5 clear stimulus" ],
   "RSVD1"                        => [   6,  19,   5, 0x0000000000F80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Counter 5 enable peak detection" ],
   "DEC_ENABLE"                   => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Counter 5 enable decrement" ],
   "INC_ENABLE"                   => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Counter 5 enable increment" ],
   "DN_MODE"                      => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Counter 5 down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Counter 5 down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Counter 5 down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "Counter 5 down stimulus" ],
   "UP_MODE"                      => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Counter 5 up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Counter 5 up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Counter 5 up format select (1-level, 0-edge)" ],
   "UP_STIMULUS"                  => [  17,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter 5 up stimulus" ],
);

%shub2_01_00043_def =
( NAME    => "SH2_PERFORMANCE_COUNT5_CONTROL",
  ADDRESS => 0x00000000100d0000,
  NOTE    => "The sh2_performance_count5_control register controls the note incrementing and decrementing of event counter 5.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00043_flds
);


##########################################################################
#                                                                        #
#   SH2_PERFORMANCE_COUNT6_CONTROL                                       #
#                                                                        #
##########################################################################

%shub2_01_00044_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CLR_ENABLE"                   => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Counter 6 enable clear" ],
   "CLR_MODE"                     => [   2,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Counter 6 clear mode select (1-internal, 0-external)" ],
   "CLR_POLARITY"                 => [   3,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Counter 6 clear polarity select (1-negative edge, 0-positive edge)" ],
   "CLR_EVENT"                    => [   4,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Counter 6 clear format select (1-level, 0-edge)" ],
   "CLR_STIMULUS"                 => [   5,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "Counter 6 clear stimulus" ],
   "RSVD1"                        => [   6,  19,   5, 0x0000000000F80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Counter 6 enable peak detection" ],
   "DEC_ENABLE"                   => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Counter 6 enable decrement" ],
   "INC_ENABLE"                   => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Counter 6 enable increment" ],
   "DN_MODE"                      => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Counter 6 down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Counter 6 down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Counter 6 down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "Counter 6 down stimulus" ],
   "UP_MODE"                      => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Counter 6 up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Counter 6 up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Counter 6 up format select (1-level, 0-edge)" ],
   "UP_STIMULUS"                  => [  17,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter 6 up stimulus" ],
);

%shub2_01_00044_def =
( NAME    => "SH2_PERFORMANCE_COUNT6_CONTROL",
  ADDRESS => 0x00000000100e0000,
  NOTE    => "The sh2_performance_count6_control register controls the note incrementing and decrementing of event counter 6.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00044_flds
);


##########################################################################
#                                                                        #
#   SH2_PERFORMANCE_COUNT7_CONTROL                                       #
#                                                                        #
##########################################################################

%shub2_01_00045_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CLR_ENABLE"                   => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Counter 7 enable clear" ],
   "CLR_MODE"                     => [   2,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Counter 7 clear mode select (1-internal, 0-external)" ],
   "CLR_POLARITY"                 => [   3,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Counter 7 clear polarity select (1-negative edge, 0-positive edge)" ],
   "CLR_EVENT"                    => [   4,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Counter 7 clear format select (1-level, 0-edge)" ],
   "CLR_STIMULUS"                 => [   5,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "Counter 7 clear stimulus" ],
   "RSVD1"                        => [   6,  19,   5, 0x0000000000F80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Counter 7 enable peak detection" ],
   "DEC_ENABLE"                   => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Counter 7 enable decrement" ],
   "INC_ENABLE"                   => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Counter 7 enable increment" ],
   "DN_MODE"                      => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Counter 7 down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Counter 7 down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Counter 7 down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "Counter 7 down stimulus" ],
   "UP_MODE"                      => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Counter 7 up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Counter 7 up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Counter 7 up format select (1-level, 0-edge)" ],
   "UP_STIMULUS"                  => [  17,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter 7 up stimulus" ],
);

%shub2_01_00045_def =
( NAME    => "SH2_PERFORMANCE_COUNT7_CONTROL",
  ADDRESS => 0x00000000100f0000,
  NOTE    => "The sh2_performance_count7_control register controls the note incrementing and decrementing of event counter 7.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00045_flds
);


##########################################################################
#                                                                        #
#   SH2_PROFILE_DN_CONTROL                                               #
#                                                                        #
##########################################################################

%shub2_01_00046_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MODE"                         => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Counter mode select (1-internal, 0-external)" ],
   "POLARITY"                     => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Polarity Control" ],
   "EVENT"                        => [   3,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Event Control" ],
   "STIMULUS"                     => [   4,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter stimulus" ],
);

%shub2_01_00046_def =
( NAME    => "SH2_PROFILE_DN_CONTROL",
  ADDRESS => 0x0000000010100000,
  NOTE    => "The PROFILE_DN_CONTROL register controls the decrementing of the note Profile Counter.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00046_flds
);


##########################################################################
#                                                                        #
#   SH2_PROFILE_PEAK_CONTROL                                             #
#                                                                        #
##########################################################################

%shub2_01_00047_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   7,  57, 0xFFFFFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "POLARITY"                     => [   1,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Polarity Control" ],
   "EVENT"                        => [   2,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Event Control" ],
   "RSVD1"                        => [   3,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STIMULUS"                     => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Counter stimulus" ],
);

%shub2_01_00047_def =
( NAME    => "SH2_PROFILE_PEAK_CONTROL",
  ADDRESS => 0x0000000010100080,
  NOTE    => "The PROFILE_PEAK_CONTROL register controls the comparison test note performed between the PROFILE_PEAK register and the PROFILE_",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00047_flds
);


##########################################################################
#                                                                        #
#   SH2_PROFILE_RANGE                                                    #
#                                                                        #
##########################################################################

%shub2_01_00048_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RANGE7"                       => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Profiling range 7" ],
   "RANGE6"                       => [   1,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "Profiling range 6" ],
   "RANGE5"                       => [   2,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "Profiling range 5" ],
   "RANGE4"                       => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Profiling range 4" ],
   "RANGE3"                       => [   4,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "Profiling range 3" ],
   "RANGE2"                       => [   5,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Profiling range 2" ],
   "RANGE1"                       => [   6,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "Profiling range 1" ],
   "RANGE0"                       => [   7,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Profiling range 0" ],
);

%shub2_01_00048_def =
( NAME    => "SH2_PROFILE_RANGE",
  ADDRESS => 0x0000000010100100,
  NOTE    => "The PROFILE_RANGE register contains 8 reference values used for note comparison tests when the PROFILE_COUNT register is selecte",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00048_flds
);


##########################################################################
#                                                                        #
#   SH2_PROFILE_UP_CONTROL                                               #
#                                                                        #
##########################################################################

%shub2_01_00049_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MODE"                         => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Mode Control" ],
   "POLARITY"                     => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Polarity Control" ],
   "EVENT"                        => [   3,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Event Control" ],
   "STIMULUS"                     => [   4,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter stimulus" ],
);

%shub2_01_00049_def =
( NAME    => "SH2_PROFILE_UP_CONTROL",
  ADDRESS => 0x0000000010100180,
  NOTE    => "The PROFILE_UP_CONTROL register controls the incrementing of the note Profile Counter.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00049_flds
);


##########################################################################
#                                                                        #
#   SH2_PERFORMANCE_MONITOR_DESKEW                                       #
#                                                                        #
##########################################################################

%shub2_01_00050_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "BIT_31_DELAY"                 => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 31" ],
   "BIT_30_DELAY"                 => [   1,  60,   2, 0x3000000000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 30" ],
   "BIT_29_DELAY"                 => [   2,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 29" ],
   "BIT_28_DELAY"                 => [   3,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 28" ],
   "BIT_27_DELAY"                 => [   4,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 27" ],
   "BIT_26_DELAY"                 => [   5,  52,   2, 0x0030000000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 26" ],
   "BIT_25_DELAY"                 => [   6,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 25" ],
   "BIT_24_DELAY"                 => [   7,  48,   2, 0x0003000000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 24" ],
   "BIT_23_DELAY"                 => [   8,  46,   2, 0x0000C00000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 23" ],
   "BIT_22_DELAY"                 => [   9,  44,   2, 0x0000300000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 22" ],
   "BIT_21_DELAY"                 => [  10,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 21" ],
   "BIT_20_DELAY"                 => [  11,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 20" ],
   "BIT_19_DELAY"                 => [  12,  38,   2, 0x000000C000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 19" ],
   "BIT_18_DELAY"                 => [  13,  36,   2, 0x0000003000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 18" ],
   "BIT_17_DELAY"                 => [  14,  34,   2, 0x0000000C00000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 17" ],
   "BIT_16_DELAY"                 => [  15,  32,   2, 0x0000000300000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 16" ],
   "BIT_15_DELAY"                 => [  16,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 15" ],
   "BIT_14_DELAY"                 => [  17,  28,   2, 0x0000000030000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 14" ],
   "BIT_13_DELAY"                 => [  18,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 13" ],
   "BIT_12_DELAY"                 => [  19,  24,   2, 0x0000000003000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 12" ],
   "BIT_11_DELAY"                 => [  20,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 11" ],
   "BIT_10_DELAY"                 => [  21,  20,   2, 0x0000000000300000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 10" ],
   "BIT_9_DELAY"                  => [  22,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 9" ],
   "BIT_8_DELAY"                  => [  23,  16,   2, 0x0000000000030000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 8" ],
   "BIT_7_DELAY"                  => [  24,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 7" ],
   "BIT_6_DELAY"                  => [  25,  12,   2, 0x0000000000003000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 6" ],
   "BIT_5_DELAY"                  => [  26,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 5" ],
   "BIT_4_DELAY"                  => [  27,   8,   2, 0x0000000000000300, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 4" ],
   "BIT_3_DELAY"                  => [  28,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 3" ],
   "BIT_2_DELAY"                  => [  29,   4,   2, 0x0000000000000030, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 2" ],
   "BIT_1_DELAY"                  => [  30,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 1" ],
   "BIT_0_DELAY"                  => [  31,   0,   2, 0x0000000000000003, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 0" ],
);

%shub2_01_00050_def =
( NAME    => "SH2_PERFORMANCE_MONITOR_DESKEW",
  ADDRESS => 0x0000000010101000,
  NOTE    => "The sh2_performance_monitor_deskew register controls the amount of note deskew on each of the debug data bits going to the perfo",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00050_flds
);


##########################################################################
#                                                                        #
#   SH2_PERFORMANCE_COUNTER0                                             #
#                                                                        #
##########################################################################

%shub2_01_00051_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 0" ],
);

%shub2_01_00051_def =
( NAME    => "SH2_PERFORMANCE_COUNTER0",
  ADDRESS => 0x0000000010110000,
  NOTE    => "The PERFORMANCE_COUNTER0 register is a status register containing note the current value of Performance Counter 0.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00051_flds
);


##########################################################################
#                                                                        #
#   SH2_PERFORMANCE_COUNTER1                                             #
#                                                                        #
##########################################################################

%shub2_01_00052_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 1" ],
);

%shub2_01_00052_def =
( NAME    => "SH2_PERFORMANCE_COUNTER1",
  ADDRESS => 0x0000000010120000,
  NOTE    => "The PERFORMANCE_COUNTER1 register is a status register containing note the current value of Performance Counter 1.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00052_flds
);


##########################################################################
#                                                                        #
#   SH2_PERFORMANCE_COUNTER2                                             #
#                                                                        #
##########################################################################

%shub2_01_00053_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 2" ],
);

%shub2_01_00053_def =
( NAME    => "SH2_PERFORMANCE_COUNTER2",
  ADDRESS => 0x0000000010130000,
  NOTE    => "The PERFORMANCE_COUNTER2 register is a status register containing note the current value of Performance Counter 2.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00053_flds
);


##########################################################################
#                                                                        #
#   SH2_PERFORMANCE_COUNTER3                                             #
#                                                                        #
##########################################################################

%shub2_01_00054_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 3" ],
);

%shub2_01_00054_def =
( NAME    => "SH2_PERFORMANCE_COUNTER3",
  ADDRESS => 0x0000000010140000,
  NOTE    => "The PERFORMANCE_COUNTER3 register is a status register containing note the current value of Performance Counter 3.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00054_flds
);


##########################################################################
#                                                                        #
#   SH2_PERFORMANCE_COUNTER4                                             #
#                                                                        #
##########################################################################

%shub2_01_00055_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 4" ],
);

%shub2_01_00055_def =
( NAME    => "SH2_PERFORMANCE_COUNTER4",
  ADDRESS => 0x0000000010150000,
  NOTE    => "The PERFORMANCE_COUNTER4 register is a status register containing note the current value of Performance Counter 4.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00055_flds
);


##########################################################################
#                                                                        #
#   SH2_PERFORMANCE_COUNTER5                                             #
#                                                                        #
##########################################################################

%shub2_01_00056_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 5" ],
);

%shub2_01_00056_def =
( NAME    => "SH2_PERFORMANCE_COUNTER5",
  ADDRESS => 0x0000000010160000,
  NOTE    => "The PERFORMANCE_COUNTER5 register is a status register containing note the current value of Performance Counter 5.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00056_flds
);


##########################################################################
#                                                                        #
#   SH2_PERFORMANCE_COUNTER6                                             #
#                                                                        #
##########################################################################

%shub2_01_00057_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 6" ],
);

%shub2_01_00057_def =
( NAME    => "SH2_PERFORMANCE_COUNTER6",
  ADDRESS => 0x0000000010170000,
  NOTE    => "The PERFORMANCE_COUNTER6 register is a status register containing note the current value of Performance Counter 6.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00057_flds
);


##########################################################################
#                                                                        #
#   SH2_PERFORMANCE_COUNTER7                                             #
#                                                                        #
##########################################################################

%shub2_01_00058_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 7" ],
);

%shub2_01_00058_def =
( NAME    => "SH2_PERFORMANCE_COUNTER7",
  ADDRESS => 0x0000000010180000,
  NOTE    => "The PERFORMANCE_COUNTER7 register is a status register containing note the current value of Performance Counter 7.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00058_flds
);


##########################################################################
#                                                                        #
#   SH2_PROFILE_COUNTER                                                  #
#                                                                        #
##########################################################################

%shub2_01_00059_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNTER"                      => [   1,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Current Value of the Profile Counter" ],
);

%shub2_01_00059_def =
( NAME    => "SH2_PROFILE_COUNTER",
  ADDRESS => 0x0000000010190000,
  NOTE    => "The PROFILE_COUNTER register contains the current value of the note Profile Counter.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00059_flds
);


##########################################################################
#                                                                        #
#   SH2_PROFILE_PEAK                                                     #
#                                                                        #
##########################################################################

%shub2_01_00060_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNTER"                      => [   1,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Peak Value of the Profile Counter" ],
);

%shub2_01_00060_def =
( NAME    => "SH2_PROFILE_PEAK",
  ADDRESS => 0x0000000010190080,
  NOTE    => "The PROFILE_PEAK register can be used to capture the peak (i.e., note minimum or maximum) value of the Profile Counter.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00060_flds
);


##########################################################################
#                                                                        #
#   SH2_INT_CMPA                                                         #
#                                                                        #
##########################################################################

%shub2_01_00061_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  55,   9, 0xFF80000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REAL_TIME_CMPA"               => [   1,   0,  55, 0x007FFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Real Time Clock Compare" ],
);

%shub2_01_00061_def =
( NAME    => "SH2_INT_CMPA",
  ADDRESS => 0x00000000101b0000,
  NOTE    => "When the value of the SHub2's real-time clock (viewable via the RTC note register's REAL_TIME_CLOCK field) equals the value of t",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00061_flds
);


##########################################################################
#                                                                        #
#   SH2_INT_CMPB                                                         #
#                                                                        #
##########################################################################

%shub2_01_00062_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  55,   9, 0xFF80000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REAL_TIME_CMPB"               => [   1,   0,  55, 0x007FFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Real Time Clock Compare" ],
);

%shub2_01_00062_def =
( NAME    => "SH2_INT_CMPB",
  ADDRESS => 0x00000000101b0080,
  NOTE    => "When the value of the SHub2's real-time clock (viewable via the RTC note register's REAL_TIME_CLOCK field) equals the value of t",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00062_flds
);


##########################################################################
#                                                                        #
#   SH2_INT_CMPC                                                         #
#                                                                        #
##########################################################################

%shub2_01_00063_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  55,   9, 0xFF80000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REAL_TIME_CMPC"               => [   1,   0,  55, 0x007FFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Real Time Clock Compare" ],
);

%shub2_01_00063_def =
( NAME    => "SH2_INT_CMPC",
  ADDRESS => 0x00000000101b0100,
  NOTE    => "When the value of the SHub2's real-time clock (viewable via the RTC note register's REAL_TIME_CLOCK field) equals the value of t",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00063_flds
);


##########################################################################
#                                                                        #
#   SH2_INT_CMPD                                                         #
#                                                                        #
##########################################################################

%shub2_01_00064_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  55,   9, 0xFF80000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REAL_TIME_CMPD"               => [   1,   0,  55, 0x007FFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Real Time Clock Compare" ],
);

%shub2_01_00064_def =
( NAME    => "SH2_INT_CMPD",
  ADDRESS => 0x00000000101b0180,
  NOTE    => "When the value of the SHub2's real-time clock (viewable via the RTC note register's REAL_TIME_CLOCK field) equals the value of t",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00064_flds
);


##########################################################################
#                                                                        #
#   SH2_INT_PROF                                                         #
#                                                                        #
##########################################################################

%shub2_01_00065_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PROFILE_COMPARE"              => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "Profile Compare" ],
);

%shub2_01_00065_def =
( NAME    => "SH2_INT_PROF",
  ADDRESS => 0x00000000101b0200,
  NOTE    => "When the 32 least significant bits of the SHub2's real-time clock note (viewable via the RTC register's REAL_TIME_CLOCK field) e",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00065_flds
);


##########################################################################
#                                                                        #
#   SH2_RTC                                                              #
#                                                                        #
##########################################################################

%shub2_01_00066_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  55,   9, 0xFF80000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REAL_TIME_CLOCK"              => [   1,   0,  55, 0x007FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Real-time Clock" ],
);

%shub2_01_00066_def =
( NAME    => "SH2_RTC",
  ADDRESS => 0x00000000101c0000,
  NOTE    => "The RTC register stores the current value of the Real-time Clock note Counter.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00066_flds
);


##########################################################################
#                                                                        #
#   SH2_LB_PI_GCLK_SEL                                                   #
#                                                                        #
##########################################################################

%shub2_01_00067_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   4,  60, 0xFFFFFFFFFFFFFFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SELECT"                       => [   1,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "LB to PI gclk select" ],
);

%shub2_01_00067_def =
( NAME    => "SH2_LB_PI_GCLK_SEL",
  ADDRESS => 0x0000000010060800,
  NOTE    => "The LB_PI_GCLK_SEL register selects one bit of the real time clock note counter to be sent to the PI chiplet. The PI chiplet use",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00067_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH0                                                         #
#                                                                        #
##########################################################################

%shub2_01_00068_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH0"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 0" ],
);

%shub2_01_00068_def =
( NAME    => "SH2_SCRATCH0",
  ADDRESS => 0x00000000101d0000,
  NOTE    => "The SCRATCH0 register is a temporary storage register provided note exclusively for software purposes. The hardware does not mon",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00068_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH0_ALIAS                                                   #
#                                                                        #
##########################################################################

%shub2_01_00069_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH0"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 0" ],
);

%shub2_01_00069_def =
( NAME    => "SH2_SCRATCH0_ALIAS",
  ADDRESS => 0x00000000101d0008,
  NOTE    => "The SCRATCH0_ALIAS address is an alias to the SCRATCH0 register. note Refer to the SCRATCH0 register description for details on ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00069_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH1                                                         #
#                                                                        #
##########################################################################

%shub2_01_00070_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH1"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 1" ],
);

%shub2_01_00070_def =
( NAME    => "SH2_SCRATCH1",
  ADDRESS => 0x00000000101d0080,
  NOTE    => "The SCRATCH1 register is a temporary storage register provided note exclusively for software purposes. The hardware does not mon",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00070_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH1_ALIAS                                                   #
#                                                                        #
##########################################################################

%shub2_01_00071_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH1"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 1" ],
);

%shub2_01_00071_def =
( NAME    => "SH2_SCRATCH1_ALIAS",
  ADDRESS => 0x00000000101d0088,
  NOTE    => "The SCRATCH1_ALIAS address is an alias to the SCRATCH1 register. note Refer to the SCRATCH1 register description for details on ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00071_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH2                                                         #
#                                                                        #
##########################################################################

%shub2_01_00072_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH2"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Scratch register 2" ],
);

%shub2_01_00072_def =
( NAME    => "SH2_SCRATCH2",
  ADDRESS => 0x00000000101d0100,
  NOTE    => "The SCRATCH2 register is a temporary storage register provided note exclusively for software purposes. The hardware does not mon",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00072_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH2_ALIAS                                                   #
#                                                                        #
##########################################################################

%shub2_01_00073_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH2"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Scratch register 2" ],
);

%shub2_01_00073_def =
( NAME    => "SH2_SCRATCH2_ALIAS",
  ADDRESS => 0x00000000101d0108,
  NOTE    => "The SCRATCH2_ALIAS address is an alias to the SCRATCH2 register. note Refer to the SCRATCH2 register description for details on ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00073_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH3                                                         #
#                                                                        #
##########################################################################

%shub2_01_00074_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCRATCH3"                     => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Scratch register 3" ],
);

%shub2_01_00074_def =
( NAME    => "SH2_SCRATCH3",
  ADDRESS => 0x00000000101d0180,
  NOTE    => "The SCRATCH3 register is a temporary storage register provided note exclusively for software purposes. The hardware does not mon",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00074_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH3_ALIAS                                                   #
#                                                                        #
##########################################################################

%shub2_01_00075_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCRATCH3"                     => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Scratch register 3" ],
);

%shub2_01_00075_def =
( NAME    => "SH2_SCRATCH3_ALIAS",
  ADDRESS => 0x00000000101d0188,
  NOTE    => "The SCRATCH3_ALIAS address is an alias to the SCRATCH3 register. note Refer to the SCRATCH3 register description for details on ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00075_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH4                                                         #
#                                                                        #
##########################################################################

%shub2_01_00076_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCRATCH4"                     => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Scratch register 4" ],
);

%shub2_01_00076_def =
( NAME    => "SH2_SCRATCH4",
  ADDRESS => 0x00000000101d0200,
  NOTE    => "The SCRATCH4 register is a temporary storage register provided note exclusively for software purposes. The hardware does not mon",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00076_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH4_ALIAS                                                   #
#                                                                        #
##########################################################################

%shub2_01_00077_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCRATCH4"                     => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Scratch register 4" ],
);

%shub2_01_00077_def =
( NAME    => "SH2_SCRATCH4_ALIAS",
  ADDRESS => 0x00000000101d0208,
  NOTE    => "The SCRATCH4_ALIAS address is an alias to the SCRATCH4 register. note Refer to the SCRATCH4 register description for details on ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00077_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH5                                                         #
#                                                                        #
##########################################################################

%shub2_01_00078_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH5"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 5" ],
);

%shub2_01_00078_def =
( NAME    => "SH2_SCRATCH5",
  ADDRESS => 0x00000000101d0280,
  NOTE    => "The SCRATCH5 register is a temporary storage register provided note exclusively for software purposes. The hardware does not mon",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00078_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH5_ALIAS                                                   #
#                                                                        #
##########################################################################

%shub2_01_00079_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH5"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 5" ],
);

%shub2_01_00079_def =
( NAME    => "SH2_SCRATCH5_ALIAS",
  ADDRESS => 0x00000000101d0288,
  NOTE    => "The SCRATCH5_ALIAS address is an alias to the SCRATCH5 register. note Refer to the SCRATCH5 register description for details on ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00079_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH5_ALIAS_2                                                 #
#                                                                        #
##########################################################################

%shub2_01_00080_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH5"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 5" ],
);

%shub2_01_00080_def =
( NAME    => "SH2_SCRATCH5_ALIAS_2",
  ADDRESS => 0x00000000101d0290,
  NOTE    => "The SCRATCH5_ALIAS_2 address is an alias to the SCRATCH5 register. note Refer to the SCRATCH5 register description for details o",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00080_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH6                                                         #
#                                                                        #
##########################################################################

%shub2_01_00081_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH6"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 6" ],
);

%shub2_01_00081_def =
( NAME    => "SH2_SCRATCH6",
  ADDRESS => 0x00000000101d0300,
  NOTE    => "The SCRATCH6 register is a temporary storage register provided note exclusively for software purposes. The hardware does not mon",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00081_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH6_ALIAS                                                   #
#                                                                        #
##########################################################################

%shub2_01_00082_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH6"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 6" ],
);

%shub2_01_00082_def =
( NAME    => "SH2_SCRATCH6_ALIAS",
  ADDRESS => 0x00000000101d0308,
  NOTE    => "The SCRATCH6_ALIAS address is an alias to the SCRATCH6 register. note Refer to the SCRATCH6 register description for details on ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00082_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH6_ALIAS_2                                                 #
#                                                                        #
##########################################################################

%shub2_01_00083_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH6"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 6" ],
);

%shub2_01_00083_def =
( NAME    => "SH2_SCRATCH6_ALIAS_2",
  ADDRESS => 0x00000000101d0310,
  NOTE    => "The SCRATCH6_ALIAS_2 address is an alias to the SCRATCH6 register. note Refer to the SCRATCH6 register description for details o",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00083_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH7                                                         #
#                                                                        #
##########################################################################

%shub2_01_00084_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH7"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 7" ],
);

%shub2_01_00084_def =
( NAME    => "SH2_SCRATCH7",
  ADDRESS => 0x00000000101d0380,
  NOTE    => "The SCRATCH7 register is a temporary storage register provided note exclusively for software purposes. The hardware does not mon",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00084_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH7_ALIAS                                                   #
#                                                                        #
##########################################################################

%shub2_01_00085_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH7"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 7" ],
);

%shub2_01_00085_def =
( NAME    => "SH2_SCRATCH7_ALIAS",
  ADDRESS => 0x00000000101d0388,
  NOTE    => "The SCRATCH7_ALIAS address is an alias to the SCRATCH7 register. note Refer to the SCRATCH7 register description for details on ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00085_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH7_ALIAS_2                                                 #
#                                                                        #
##########################################################################

%shub2_01_00086_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH7"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 7" ],
);

%shub2_01_00086_def =
( NAME    => "SH2_SCRATCH7_ALIAS_2",
  ADDRESS => 0x00000000101d0390,
  NOTE    => "The SCRATCH7_ALIAS_2 address is an alias to the SCRATCH7 register. note Refer to the SCRATCH7 register description for details o",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00086_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH8                                                         #
#                                                                        #
##########################################################################

%shub2_01_00087_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH8"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 8" ],
);

%shub2_01_00087_def =
( NAME    => "SH2_SCRATCH8",
  ADDRESS => 0x00000000101d0400,
  NOTE    => "The SCRATCH8 register is a temporary storage register provided note exclusively for software purposes. The hardware does not mon",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00087_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH8_ALIAS                                                   #
#                                                                        #
##########################################################################

%shub2_01_00088_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH8"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 8" ],
);

%shub2_01_00088_def =
( NAME    => "SH2_SCRATCH8_ALIAS",
  ADDRESS => 0x00000000101d0408,
  NOTE    => "The SCRATCH8_ALIAS address is an alias to the SCRATCH8 register. note Refer to the SCRATCH8 register description for details on ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00088_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH8_ALIAS_2                                                 #
#                                                                        #
##########################################################################

%shub2_01_00089_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH8"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 8" ],
);

%shub2_01_00089_def =
( NAME    => "SH2_SCRATCH8_ALIAS_2",
  ADDRESS => 0x00000000101d0410,
  NOTE    => "The SCRATCH8_ALIAS_2 address is an alias to the SCRATCH8 register. note Refer to the SCRATCH8 register description for details o",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00089_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH9                                                         #
#                                                                        #
##########################################################################

%shub2_01_00090_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH9"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 9" ],
);

%shub2_01_00090_def =
( NAME    => "SH2_SCRATCH9",
  ADDRESS => 0x00000000101d0480,
  NOTE    => "The SCRATCH9 register is a temporary storage register provided note exclusively for software purposes. The hardware does not mon",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00090_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH9_ALIAS                                                   #
#                                                                        #
##########################################################################

%shub2_01_00091_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH9"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 9" ],
);

%shub2_01_00091_def =
( NAME    => "SH2_SCRATCH9_ALIAS",
  ADDRESS => 0x00000000101d0488,
  NOTE    => "The SCRATCH9_ALIAS address is an alias to the SCRATCH9 register. note Refer to the SCRATCH9 register description for details on ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00091_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH9_ALIAS_2                                                 #
#                                                                        #
##########################################################################

%shub2_01_00092_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH9"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 9" ],
);

%shub2_01_00092_def =
( NAME    => "SH2_SCRATCH9_ALIAS_2",
  ADDRESS => 0x00000000101d0490,
  NOTE    => "The SCRATCH9_ALIAS_2 address is an alias to the SCRATCH9 register. note Refer to the SCRATCH9 register description for details o",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00092_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH10                                                        #
#                                                                        #
##########################################################################

%shub2_01_00093_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH10"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 10" ],
);

%shub2_01_00093_def =
( NAME    => "SH2_SCRATCH10",
  ADDRESS => 0x00000000101d0500,
  NOTE    => "The SCRATCH10 register is a temporary storage register provided note exclusively for software purposes. The hardware does not mo",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00093_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH10_ALIAS                                                  #
#                                                                        #
##########################################################################

%shub2_01_00094_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH10"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 10" ],
);

%shub2_01_00094_def =
( NAME    => "SH2_SCRATCH10_ALIAS",
  ADDRESS => 0x00000000101d0508,
  NOTE    => "The SCRATCH10_ALIAS address is an alias to the SCRATCH10 register. note Refer to the SCRATCH10 register description for details ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00094_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH10_ALIAS_2                                                #
#                                                                        #
##########################################################################

%shub2_01_00095_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH10"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 10" ],
);

%shub2_01_00095_def =
( NAME    => "SH2_SCRATCH10_ALIAS_2",
  ADDRESS => 0x00000000101d0510,
  NOTE    => "The SCRATCH10_ALIAS_2 address is an alias to the SCRATCH10 note register. Refer to the SCRATCH10 register description for detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00095_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH11                                                        #
#                                                                        #
##########################################################################

%shub2_01_00096_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH11"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 11" ],
);

%shub2_01_00096_def =
( NAME    => "SH2_SCRATCH11",
  ADDRESS => 0x00000000101d0580,
  NOTE    => "The SCRATCH11 register is a temporary storage register provided note exclusively for software purposes. The hardware does not mo",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00096_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH11_ALIAS                                                  #
#                                                                        #
##########################################################################

%shub2_01_00097_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH11"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 11" ],
);

%shub2_01_00097_def =
( NAME    => "SH2_SCRATCH11_ALIAS",
  ADDRESS => 0x00000000101d0588,
  NOTE    => "The SCRATCH11_ALIAS address is an alias to the SCRATCH11 register. note Refer to the SCRATCH11 register description for details ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00097_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH11_ALIAS_2                                                #
#                                                                        #
##########################################################################

%shub2_01_00098_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH11"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 11" ],
);

%shub2_01_00098_def =
( NAME    => "SH2_SCRATCH11_ALIAS_2",
  ADDRESS => 0x00000000101d0590,
  NOTE    => "The SCRATCH11_ALIAS_2 address is an alias to the SCRATCH11 note register. Refer to the SCRATCH11 register description for detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00098_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH12                                                        #
#                                                                        #
##########################################################################

%shub2_01_00099_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH12"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 12" ],
);

%shub2_01_00099_def =
( NAME    => "SH2_SCRATCH12",
  ADDRESS => 0x00000000101d0600,
  NOTE    => "The SCRATCH12 register is a temporary storage register provided note exclusively for software purposes. The hardware does not mo",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00099_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH12_ALIAS                                                  #
#                                                                        #
##########################################################################

%shub2_01_00100_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH12"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 12" ],
);

%shub2_01_00100_def =
( NAME    => "SH2_SCRATCH12_ALIAS",
  ADDRESS => 0x00000000101d0608,
  NOTE    => "The SCRATCH12_ALIAS address is an alias to the SCRATCH12 register. note Refer to the SCRATCH12 register description for details ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00100_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH12_ALIAS_2                                                #
#                                                                        #
##########################################################################

%shub2_01_00101_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH12"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 12" ],
);

%shub2_01_00101_def =
( NAME    => "SH2_SCRATCH12_ALIAS_2",
  ADDRESS => 0x00000000101d0610,
  NOTE    => "The SCRATCH12_ALIAS_2 address is an alias to the SCRATCH12 note register. Refer to the SCRATCH12 register description for detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00101_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH13                                                        #
#                                                                        #
##########################################################################

%shub2_01_00102_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH13"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 13" ],
);

%shub2_01_00102_def =
( NAME    => "SH2_SCRATCH13",
  ADDRESS => 0x00000000101d0680,
  NOTE    => "The SCRATCH13 register is a temporary storage register provided note exclusively for software purposes. The hardware does not mo",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00102_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH13_ALIAS                                                  #
#                                                                        #
##########################################################################

%shub2_01_00103_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH13"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 13" ],
);

%shub2_01_00103_def =
( NAME    => "SH2_SCRATCH13_ALIAS",
  ADDRESS => 0x00000000101d0688,
  NOTE    => "The SCRATCH13_ALIAS address is an alias to the SCRATCH13 register. note Refer to the SCRATCH13 register description for details ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00103_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH13_ALIAS_2                                                #
#                                                                        #
##########################################################################

%shub2_01_00104_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH13"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 13" ],
);

%shub2_01_00104_def =
( NAME    => "SH2_SCRATCH13_ALIAS_2",
  ADDRESS => 0x00000000101d0690,
  NOTE    => "The SCRATCH13_ALIAS_2 address is an alias to the SCRATCH13 note register. Refer to the SCRATCH13 register description for detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00104_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH14                                                        #
#                                                                        #
##########################################################################

%shub2_01_00105_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH14"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 14" ],
);

%shub2_01_00105_def =
( NAME    => "SH2_SCRATCH14",
  ADDRESS => 0x00000000101d0700,
  NOTE    => "The SCRATCH14 register is a temporary storage register provided note exclusively for software purposes. The hardware does not mo",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00105_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH14_ALIAS                                                  #
#                                                                        #
##########################################################################

%shub2_01_00106_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH14"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 14" ],
);

%shub2_01_00106_def =
( NAME    => "SH2_SCRATCH14_ALIAS",
  ADDRESS => 0x00000000101d0708,
  NOTE    => "The SCRATCH14_ALIAS address is an alias to the SCRATCH14 register. note Refer to the SCRATCH14 register description for details ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00106_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH14_ALIAS_2                                                #
#                                                                        #
##########################################################################

%shub2_01_00107_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH14"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 14" ],
);

%shub2_01_00107_def =
( NAME    => "SH2_SCRATCH14_ALIAS_2",
  ADDRESS => 0x00000000101d0710,
  NOTE    => "The SCRATCH14_ALIAS_2 address is an alias to the SCRATCH14 note register. Refer to the SCRATCH14 register description for detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00107_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH15                                                        #
#                                                                        #
##########################################################################

%shub2_01_00108_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH15"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 15" ],
);

%shub2_01_00108_def =
( NAME    => "SH2_SCRATCH15",
  ADDRESS => 0x00000000101d0780,
  NOTE    => "The SCRATCH15 register is a temporary storage register provided note exclusively for software purposes. The hardware does not mo",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00108_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH15_ALIAS                                                  #
#                                                                        #
##########################################################################

%shub2_01_00109_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH15"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 15" ],
);

%shub2_01_00109_def =
( NAME    => "SH2_SCRATCH15_ALIAS",
  ADDRESS => 0x00000000101d0788,
  NOTE    => "The SCRATCH15_ALIAS address is an alias to the SCRATCH15 register. note Refer to the SCRATCH15 register description for details ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00109_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH15_ALIAS_2                                                #
#                                                                        #
##########################################################################

%shub2_01_00110_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH15"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 15" ],
);

%shub2_01_00110_def =
( NAME    => "SH2_SCRATCH15_ALIAS_2",
  ADDRESS => 0x00000000101d0790,
  NOTE    => "The SCRATCH15_ALIAS_2 address is an alias to the SCRATCH15 note register. Refer to the SCRATCH15 register description for detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00110_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH16                                                        #
#                                                                        #
##########################################################################

%shub2_01_00111_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH16"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 16" ],
);

%shub2_01_00111_def =
( NAME    => "SH2_SCRATCH16",
  ADDRESS => 0x00000000101d0800,
  NOTE    => "The SCRATCH16 register is a temporary storage register provided note exclusively for software purposes. The hardware does not mo",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00111_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH16_ALIAS                                                  #
#                                                                        #
##########################################################################

%shub2_01_00112_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH16"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 16" ],
);

%shub2_01_00112_def =
( NAME    => "SH2_SCRATCH16_ALIAS",
  ADDRESS => 0x00000000101d0808,
  NOTE    => "The SCRATCH16_ALIAS address is an alias to the SCRATCH16 register. note Refer to the SCRATCH16 register description for details ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00112_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH16_ALIAS_2                                                #
#                                                                        #
##########################################################################

%shub2_01_00113_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH16"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 16" ],
);

%shub2_01_00113_def =
( NAME    => "SH2_SCRATCH16_ALIAS_2",
  ADDRESS => 0x00000000101d0810,
  NOTE    => "The SCRATCH16_ALIAS_2 address is an alias to the SCRATCH16 note register. Refer to the SCRATCH16 register description for detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00113_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH17                                                        #
#                                                                        #
##########################################################################

%shub2_01_00114_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH17"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 17" ],
);

%shub2_01_00114_def =
( NAME    => "SH2_SCRATCH17",
  ADDRESS => 0x00000000101d0880,
  NOTE    => "The SCRATCH17 register is a temporary storage register provided note exclusively for software purposes. The hardware does not mo",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00114_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH17_ALIAS                                                  #
#                                                                        #
##########################################################################

%shub2_01_00115_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH17"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 17" ],
);

%shub2_01_00115_def =
( NAME    => "SH2_SCRATCH17_ALIAS",
  ADDRESS => 0x00000000101d0888,
  NOTE    => "The SCRATCH17_ALIAS address is an alias to the SCRATCH17 register. note Refer to the SCRATCH17 register description for details ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00115_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH17_ALIAS_2                                                #
#                                                                        #
##########################################################################

%shub2_01_00116_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH17"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 17" ],
);

%shub2_01_00116_def =
( NAME    => "SH2_SCRATCH17_ALIAS_2",
  ADDRESS => 0x00000000101d0890,
  NOTE    => "The SCRATCH17_ALIAS_2 address is an alias to the SCRATCH17 note register. Refer to the SCRATCH17 register description for detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00116_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH18                                                        #
#                                                                        #
##########################################################################

%shub2_01_00117_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH18"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 18" ],
);

%shub2_01_00117_def =
( NAME    => "SH2_SCRATCH18",
  ADDRESS => 0x00000000101d0900,
  NOTE    => "The SCRATCH18 register is a temporary storage register provided note exclusively for software purposes. The hardware does not mo",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00117_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH18_ALIAS                                                  #
#                                                                        #
##########################################################################

%shub2_01_00118_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH18"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 18" ],
);

%shub2_01_00118_def =
( NAME    => "SH2_SCRATCH18_ALIAS",
  ADDRESS => 0x00000000101d0908,
  NOTE    => "The SCRATCH18_ALIAS address is an alias to the SCRATCH18 register. note Refer to the SCRATCH18 register description for details ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00118_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH18_ALIAS_2                                                #
#                                                                        #
##########################################################################

%shub2_01_00119_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH18"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 18" ],
);

%shub2_01_00119_def =
( NAME    => "SH2_SCRATCH18_ALIAS_2",
  ADDRESS => 0x00000000101d0910,
  NOTE    => "The SCRATCH18_ALIAS_2 address is an alias to the SCRATCH18 note register. Refer to the SCRATCH18 register description for detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00119_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH19                                                        #
#                                                                        #
##########################################################################

%shub2_01_00120_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH19"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 19" ],
);

%shub2_01_00120_def =
( NAME    => "SH2_SCRATCH19",
  ADDRESS => 0x00000000101d0980,
  NOTE    => "The SCRATCH19 register is a temporary storage register provided note exclusively for software purposes. The hardware does not mo",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00120_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH19_ALIAS                                                  #
#                                                                        #
##########################################################################

%shub2_01_00121_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH19"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 19" ],
);

%shub2_01_00121_def =
( NAME    => "SH2_SCRATCH19_ALIAS",
  ADDRESS => 0x00000000101d0988,
  NOTE    => "The SCRATCH19_ALIAS address is an alias to the SCRATCH19 register. note Refer to the SCRATCH19 register description for details ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00121_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH19_ALIAS_2                                                #
#                                                                        #
##########################################################################

%shub2_01_00122_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH19"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 19" ],
);

%shub2_01_00122_def =
( NAME    => "SH2_SCRATCH19_ALIAS_2",
  ADDRESS => 0x00000000101d0990,
  NOTE    => "The SCRATCH19_ALIAS_2 address is an alias to the SCRATCH19 note register. Refer to the SCRATCH19 register description for detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00122_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH20                                                        #
#                                                                        #
##########################################################################

%shub2_01_00123_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH20"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 20" ],
);

%shub2_01_00123_def =
( NAME    => "SH2_SCRATCH20",
  ADDRESS => 0x00000000101d0a00,
  NOTE    => "The SCRATCH20 register is a temporary storage register provided note exclusively for software purposes. The hardware does not mo",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00123_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH20_ALIAS                                                  #
#                                                                        #
##########################################################################

%shub2_01_00124_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH20"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 20" ],
);

%shub2_01_00124_def =
( NAME    => "SH2_SCRATCH20_ALIAS",
  ADDRESS => 0x00000000101d0a08,
  NOTE    => "The SCRATCH20_ALIAS address is an alias to the SCRATCH20 register. note Refer to the SCRATCH20 register description for details ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00124_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH20_ALIAS_2                                                #
#                                                                        #
##########################################################################

%shub2_01_00125_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH20"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 20" ],
);

%shub2_01_00125_def =
( NAME    => "SH2_SCRATCH20_ALIAS_2",
  ADDRESS => 0x00000000101d0a10,
  NOTE    => "The SCRATCH20_ALIAS_2 address is an alias to the SCRATCH20 note register. Refer to the SCRATCH20 register description for detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00125_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH21                                                        #
#                                                                        #
##########################################################################

%shub2_01_00126_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH21"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 21" ],
);

%shub2_01_00126_def =
( NAME    => "SH2_SCRATCH21",
  ADDRESS => 0x00000000101d0a80,
  NOTE    => "The SCRATCH21 register is a temporary storage register provided note exclusively for software purposes. The hardware does not mo",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00126_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH21_ALIAS                                                  #
#                                                                        #
##########################################################################

%shub2_01_00127_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH21"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 21" ],
);

%shub2_01_00127_def =
( NAME    => "SH2_SCRATCH21_ALIAS",
  ADDRESS => 0x00000000101d0a88,
  NOTE    => "The SCRATCH21_ALIAS address is an alias to the SCRATCH21 register. note Refer to the SCRATCH21 register description for details ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00127_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH21_ALIAS_2                                                #
#                                                                        #
##########################################################################

%shub2_01_00128_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH21"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 21" ],
);

%shub2_01_00128_def =
( NAME    => "SH2_SCRATCH21_ALIAS_2",
  ADDRESS => 0x00000000101d0a90,
  NOTE    => "The SCRATCH21_ALIAS_2 address is an alias to the SCRATCH21 note register. Refer to the SCRATCH21 register description for detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00128_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH22                                                        #
#                                                                        #
##########################################################################

%shub2_01_00129_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH22"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 22" ],
);

%shub2_01_00129_def =
( NAME    => "SH2_SCRATCH22",
  ADDRESS => 0x00000000101d0b00,
  NOTE    => "The SCRATCH22 register is a temporary storage register provided note exclusively for software purposes. The hardware does not mo",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00129_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH22_ALIAS                                                  #
#                                                                        #
##########################################################################

%shub2_01_00130_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH22"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 22" ],
);

%shub2_01_00130_def =
( NAME    => "SH2_SCRATCH22_ALIAS",
  ADDRESS => 0x00000000101d0b08,
  NOTE    => "The SCRATCH22_ALIAS address is an alias to the SCRATCH22 register. note Refer to the SCRATCH22 register description for details ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00130_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH22_ALIAS_2                                                #
#                                                                        #
##########################################################################

%shub2_01_00131_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH22"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 22" ],
);

%shub2_01_00131_def =
( NAME    => "SH2_SCRATCH22_ALIAS_2",
  ADDRESS => 0x00000000101d0b10,
  NOTE    => "The SCRATCH22_ALIAS_2 address is an alias to the SCRATCH22 note register. Refer to the SCRATCH22 register description for detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00131_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH23                                                        #
#                                                                        #
##########################################################################

%shub2_01_00132_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH23"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 23" ],
);

%shub2_01_00132_def =
( NAME    => "SH2_SCRATCH23",
  ADDRESS => 0x00000000101d0b80,
  NOTE    => "The SCRATCH23 register is a temporary storage register provided note exclusively for software purposes. The hardware does not mo",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00132_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH23_ALIAS                                                  #
#                                                                        #
##########################################################################

%shub2_01_00133_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH23"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 23" ],
);

%shub2_01_00133_def =
( NAME    => "SH2_SCRATCH23_ALIAS",
  ADDRESS => 0x00000000101d0b88,
  NOTE    => "The SCRATCH23_ALIAS address is an alias to the SCRATCH23 register. note Refer to the SCRATCH23 register description for details ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00133_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH23_ALIAS_2                                                #
#                                                                        #
##########################################################################

%shub2_01_00134_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH23"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 23" ],
);

%shub2_01_00134_def =
( NAME    => "SH2_SCRATCH23_ALIAS_2",
  ADDRESS => 0x00000000101d0b90,
  NOTE    => "The SCRATCH23_ALIAS_2 address is an alias to the SCRATCH23 note register. Refer to the SCRATCH23 register description for detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00134_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH24                                                        #
#                                                                        #
##########################################################################

%shub2_01_00135_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH24"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 24" ],
);

%shub2_01_00135_def =
( NAME    => "SH2_SCRATCH24",
  ADDRESS => 0x00000000101d0c00,
  NOTE    => "The SCRATCH24 register is a temporary storage register provided note exclusively for software purposes. The hardware does not mo",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00135_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH24_ALIAS                                                  #
#                                                                        #
##########################################################################

%shub2_01_00136_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH24"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 24" ],
);

%shub2_01_00136_def =
( NAME    => "SH2_SCRATCH24_ALIAS",
  ADDRESS => 0x00000000101d0c08,
  NOTE    => "The SCRATCH24_ALIAS address is an alias to the SCRATCH24 register. note Refer to the SCRATCH24 register description for details ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00136_flds
);


##########################################################################
#                                                                        #
#   SH2_SCRATCH24_ALIAS_2                                                #
#                                                                        #
##########################################################################

%shub2_01_00137_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH24"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 24" ],
);

%shub2_01_00137_def =
( NAME    => "SH2_SCRATCH24_ALIAS_2",
  ADDRESS => 0x00000000101d0c10,
  NOTE    => "The SCRATCH24_ALIAS_2 address is an alias to the SCRATCH24 note register. Refer to the SCRATCH24 register description for detail",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00137_flds
);


##########################################################################
#                                                                        #
#   SH2_EXTIO_INT0                                                       #
#                                                                        #
##########################################################################

%shub2_01_00138_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND"                         => [   1,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Initiate an Interrupt" ],
   "IDX"                          => [   2,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
);

%shub2_01_00138_def =
( NAME    => "SH2_EXTIO_INT0",
  ADDRESS => 0x0000000010000000,
  NOTE    => "The EXTIO_INT0 register along with the EXTIO_INT0_CONFIG and note EXTIO_INT0_ENABLE registers provide external IO nodes (i.e., T",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00138_flds
);


##########################################################################
#                                                                        #
#   SH2_EXTIO_INT0_CONFIG                                                #
#                                                                        #
##########################################################################

%shub2_01_00139_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  20,  44, 0xFFFFFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   1,   4,  16, 0x00000000000FFFF0, 0x00, 0, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   2,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   3,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Interrupt Type" ],
);

%shub2_01_00139_def =
( NAME    => "SH2_EXTIO_INT0_CONFIG",
  ADDRESS => 0x0000000010000080,
  NOTE    => "The EXTIO_INT0_CONFIG register along with the EXTIO_INT0 and note EXTIO_INT0_ENABLE registers provide IO nodes (i.e., TIO chips)",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00139_flds
);


##########################################################################
#                                                                        #
#   SH2_EXTIO_INT0_ENABLE                                                #
#                                                                        #
##########################################################################

%shub2_01_00140_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTIO_ENABLE"                 => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable EXTIO Interrupt 0" ],
);

%shub2_01_00140_def =
( NAME    => "SH2_EXTIO_INT0_ENABLE",
  ADDRESS => 0x0000000010000200,
  NOTE    => "The EXTIO_INT0_ENABLE register along with the EXTIO_INT0_CONFIG and note EXTIO_INT0 registers provide IO nodes (i.e., TIO chips)",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00140_flds
);


##########################################################################
#                                                                        #
#   SH2_EXTIO_INT1                                                       #
#                                                                        #
##########################################################################

%shub2_01_00141_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND"                         => [   1,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Send Interrupt" ],
   "IDX"                          => [   2,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
);

%shub2_01_00141_def =
( NAME    => "SH2_EXTIO_INT1",
  ADDRESS => 0x0000000010000100,
  NOTE    => "The EXTIO_INT1 register along with the EXTIO_INT1_CONFIG and note EXTIO_INT1_ENABLE registers provide IO nodes (i.e., TIO chips)",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00141_flds
);


##########################################################################
#                                                                        #
#   SH2_EXTIO_INT1_CONFIG                                                #
#                                                                        #
##########################################################################

%shub2_01_00142_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  20,  44, 0xFFFFFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   1,   4,  16, 0x00000000000FFFF0, 0x00, 0, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   2,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   3,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Interrupt Type" ],
);

%shub2_01_00142_def =
( NAME    => "SH2_EXTIO_INT1_CONFIG",
  ADDRESS => 0x0000000010000180,
  NOTE    => "The EXTIO_INT1_CONFIG register along with the EXTIO_INT1 and note EXTIO_INT1_ENABLE registers provide IO nodes (i.e., TIO chips)",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00142_flds
);


##########################################################################
#                                                                        #
#   SH2_EXTIO_INT1_ENABLE                                                #
#                                                                        #
##########################################################################

%shub2_01_00143_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTIO_ENABLE"                 => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable EXTIO Interrupt 1" ],
);

%shub2_01_00143_def =
( NAME    => "SH2_EXTIO_INT1_ENABLE",
  ADDRESS => 0x0000000010000280,
  NOTE    => "The EXTIO_INT1_ENABLE register along with the EXTIO_INT1_CONFIG and note EXTIO_INT1 registers provide IO nodes (i.e., TIO chips)",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00143_flds
);


##########################################################################
#                                                                        #
#   SH2_EXTIO_INT2                                                       #
#                                                                        #
##########################################################################

%shub2_01_00144_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND"                         => [   1,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Send Interrupt" ],
   "IDX"                          => [   2,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
);

%shub2_01_00144_def =
( NAME    => "SH2_EXTIO_INT2",
  ADDRESS => 0x0000000010000f00,
  NOTE    => "The EXTIO_INT2 register along with the EXTIO_INT2_CONFIG and note EXTIO_INT2_ENABLE registers provide IO nodes (i.e., TIO chips)",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00144_flds
);


##########################################################################
#                                                                        #
#   SH2_EXTIO_INT2_CONFIG                                                #
#                                                                        #
##########################################################################

%shub2_01_00145_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  20,  44, 0xFFFFFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   1,   4,  16, 0x00000000000FFFF0, 0x00, 0, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   2,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   3,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Interrupt Type" ],
);

%shub2_01_00145_def =
( NAME    => "SH2_EXTIO_INT2_CONFIG",
  ADDRESS => 0x0000000010000f80,
  NOTE    => "The EXTIO_INT2_CONFIG register along with the EXTIO_INT2 and note EXTIO_INT2_ENABLE registers provide IO nodes (i.e., TIO chips)",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00145_flds
);


##########################################################################
#                                                                        #
#   SH2_EXTIO_INT2_ENABLE                                                #
#                                                                        #
##########################################################################

%shub2_01_00146_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTIO_ENABLE"                 => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable EXTIO Interrupt 2" ],
);

%shub2_01_00146_def =
( NAME    => "SH2_EXTIO_INT2_ENABLE",
  ADDRESS => 0x0000000010001100,
  NOTE    => "The EXTIO_INT2_ENABLE register along with the EXTIO_INT2_CONFIG and note EXTIO_INT2 registers provide IO nodes (i.e., TIO chips)",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00146_flds
);


##########################################################################
#                                                                        #
#   SH2_EXTIO_INT3                                                       #
#                                                                        #
##########################################################################

%shub2_01_00147_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND"                         => [   1,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Send Interrupt" ],
   "IDX"                          => [   2,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
);

%shub2_01_00147_def =
( NAME    => "SH2_EXTIO_INT3",
  ADDRESS => 0x0000000010001000,
  NOTE    => "The EXTIO_INT3 register along with the EXTIO_INT3_CONFIG and note EXTIO_INT3_ENABLE registers provide IO nodes (i.e., TIO chips)",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00147_flds
);


##########################################################################
#                                                                        #
#   SH2_EXTIO_INT3_CONFIG                                                #
#                                                                        #
##########################################################################

%shub2_01_00148_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  20,  44, 0xFFFFFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   1,   4,  16, 0x00000000000FFFF0, 0x00, 0, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   2,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   3,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Interrupt Type" ],
);

%shub2_01_00148_def =
( NAME    => "SH2_EXTIO_INT3_CONFIG",
  ADDRESS => 0x0000000010001080,
  NOTE    => "The EXTIO_INT3_CONFIG register along with the EXTIO_INT3 and note EXTIO_INT3_ENABLE registers provide IO nodes (i.e., TIO chips)",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00148_flds
);


##########################################################################
#                                                                        #
#   SH2_EXTIO_INT3_ENABLE                                                #
#                                                                        #
##########################################################################

%shub2_01_00149_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXTIO_ENABLE"                 => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable EXTIO Interrupt 3" ],
);

%shub2_01_00149_def =
( NAME    => "SH2_EXTIO_INT3_ENABLE",
  ADDRESS => 0x0000000010001180,
  NOTE    => "The EXTIO_INT3_ENABLE register along with the EXTIO_INT3_CONFIG and note EXTIO_INT3 registers provide IO nodes (i.e., TIO chips)",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00149_flds
);


##########################################################################
#                                                                        #
#   SH2_INT_NODE_ID_CONFIG                                               #
#                                                                        #
##########################################################################

%shub2_01_00150_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  17,  47, 0xFFFFFFFFFFFE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ID_SEL"                       => [   1,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Select node id for interrupt messages" ],
   "RSVD1"                        => [   2,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   3,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "Node ID for interrupt messages" ],
);

%shub2_01_00150_def =
( NAME    => "SH2_INT_NODE_ID_CONFIG",
  ADDRESS => 0x0000000010000300,
  NOTE    => "The INT_NODE_ID_CONFIG register determines if the LB sends note interrupts to the local PI or if they're transmited to a PI on a",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00150_flds
);


##########################################################################
#                                                                        #
#   SH2_IPI_INT                                                          #
#                                                                        #
##########################################################################

%shub2_01_00151_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SEND"                         => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Send Interrupt" ],
   "RSVD0"                        => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   2,  52,   8, 0x0FF0000000000000, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   3,  20,  32, 0x000FFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   4,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   5,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   6,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Interrupt Type" ],
);

%shub2_01_00151_def =
( NAME    => "SH2_IPI_INT",
  ADDRESS => 0x0000000010000380,
  NOTE    => "The IPI_INT register along with the IPI_INT_ENABLE register provide note processors with a mechanism for generating interrupts.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00151_flds
);


##########################################################################
#                                                                        #
#   SH2_IPI_INT_ENABLE                                                   #
#                                                                        #
##########################################################################

%shub2_01_00152_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_ENABLE"                   => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable IPI Interrupt" ],
);

%shub2_01_00152_def =
( NAME    => "SH2_IPI_INT_ENABLE",
  ADDRESS => 0x0000000010000400,
  NOTE    => "The IPI_INT_ENABLE register along with the IPI_INT register provide note processors, SHub II chiplets, and IO nodes (i.e., ICE c",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00152_flds
);


##########################################################################
#                                                                        #
#   SH2_LOCAL_INT0_CONFIG                                                #
#                                                                        #
##########################################################################

%shub2_01_00153_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 0, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  20,  32, 0x000FFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   3,   4,  16, 0x00000000000FFFF0, 0x00, 0, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Interrupt Type" ],
);

%shub2_01_00153_def =
( NAME    => "SH2_LOCAL_INT0_CONFIG",
  ADDRESS => 0x0000000010000480,
  NOTE    => "The LOCAL_INT0_CONFIG register contains the parameters used when note the LB generates a SN2NET LINTR message due to the occurre",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00153_flds
);


##########################################################################
#                                                                        #
#   SH2_LOCAL_INT0_ENABLE                                                #
#                                                                        #
##########################################################################

%shub2_01_00154_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  18,  46, 0xFFFFFFFFFFFC0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "L1_TO_ASIC"                   => [   1,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "Map L1 to asic Events to Local Interrupt 0" ],
   "ASIC_TO_L1"                   => [   2,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Map asic to L1 Events to Local Interrupt 0" ],
   "STOP_CLOCK"                   => [   3,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Map Stop Clock Events to Local Interrupt 0" ],
   "L1_NMI_INT"                   => [   4,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Map L1 Controller NMI to Local Interrupt 0" ],
   "LBI_INT"                      => [   5,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Map LBI Interrupt to Local Interrupt 0" ],
   "SYSTEM_SHUTDOWN_INT"          => [   6,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Map System Shutdown Events to Local Interrupt 0" ],
   "RSVD1"                        => [   7,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_UCE_INT"                   => [   8,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "Map XN Uncorrectable Data Errors to Local Interrupt 0" ],
   "MD_UCE_INT"                   => [   9,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Map MD Uncorrectable Data Errors to Local Interrupt 0" ],
   "PI_UCE_INT"                   => [  10,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Map PI Uncorrectable Data Errors to Local Interrupt 0" ],
   "XN_CE_INT"                    => [  11,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Map XN Correctable Data Errors to Local Interrupt 0" ],
   "MD_CE_INT"                    => [  12,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Map MD Correctable Data Errors to Local Interrupt 0" ],
   "PI_CE_INT"                    => [  13,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Map PI Correctable Data Errors to Local Interrupt 0" ],
   "BT_HW_INT"                    => [  14,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "" ],
   "LB_HW_INT"                    => [  15,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Map LB Hardware Errors to Local Interrupt 0" ],
   "XN_HW_INT"                    => [  16,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Map XN Hardware Errors to Local Interrupt 0" ],
   "MD_HW_INT"                    => [  17,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Map MD Hardware Errors to Local Interrupt 0" ],
   "PI_HW_INT"                    => [  18,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Map PI Hardware Errors to Local Interrupt 0" ],
);

%shub2_01_00154_def =
( NAME    => "SH2_LOCAL_INT0_ENABLE",
  ADDRESS => 0x0000000010000500,
  NOTE    => "The LOCAL_INT0_ENABLE register maps up to 14 local events to Local note Interrupt 0. If a mapped event occurs, the LB uses the p",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00154_flds
);


##########################################################################
#                                                                        #
#   SH2_LOCAL_INT1_CONFIG                                                #
#                                                                        #
##########################################################################

%shub2_01_00155_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 0, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  20,  32, 0x000FFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   3,   4,  16, 0x00000000000FFFF0, 0x00, 0, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Interrupt Type" ],
);

%shub2_01_00155_def =
( NAME    => "SH2_LOCAL_INT1_CONFIG",
  ADDRESS => 0x0000000010000580,
  NOTE    => "The LOCAL_INT1_CONFIG register contains the parameters used when note the LB generates a SN2NET LINTR message due to the occurre",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00155_flds
);


##########################################################################
#                                                                        #
#   SH2_LOCAL_INT1_ENABLE                                                #
#                                                                        #
##########################################################################

%shub2_01_00156_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  18,  46, 0xFFFFFFFFFFFC0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "L1_TO_ASIC"                   => [   1,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "Map L1 to asic Events to Local Interrupt 0" ],
   "ASIC_TO_L1"                   => [   2,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Map asic to L1 Events to Local Interrupt 0" ],
   "STOP_CLOCK"                   => [   3,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Map Stop Clock Events to Local Interrupt 1" ],
   "L1_NMI_INT"                   => [   4,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Map L1 Controller NMI to Local Interrupt 1" ],
   "LBI_INT"                      => [   5,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Map LBI Interrupts to Local Interrupt 1" ],
   "SYSTEM_SHUTDOWN_INT"          => [   6,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Map System Shutdown Events to Local Interrupt 1" ],
   "RSVD1"                        => [   7,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_UCE_INT"                   => [   8,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "Map XN Uncorrectable Data Errors to Local Interrupt 1" ],
   "MD_UCE_INT"                   => [   9,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Map MD Uncorrectable Data Errors to Local Interrupt 1" ],
   "PI_UCE_INT"                   => [  10,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Map PI Uncorrectable Data Errors to Local Interrupt 1" ],
   "XN_CE_INT"                    => [  11,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Map XN Correctable Data Errors to Local Interrupt 1" ],
   "MD_CE_INT"                    => [  12,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Map MD Correctable Data Errors to Local Interrupt 1" ],
   "PI_CE_INT"                    => [  13,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Map PI Correctable Data Errors to Local Interrupt 1" ],
   "BT_HW_INT"                    => [  14,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Map BT Hardware Errors to Local Interrupt 1" ],
   "LB_HW_INT"                    => [  15,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Map LB Hardware Errors to Local Interrupt 1" ],
   "XN_HW_INT"                    => [  16,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Map XN Hardware Errors to Local Interrupt 1" ],
   "MD_HW_INT"                    => [  17,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Map MD Hardware Errors to Local Interrupt 1" ],
   "PI_HW_INT"                    => [  18,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Map PI Hardware Errors to Local Interrupt 1" ],
);

%shub2_01_00156_def =
( NAME    => "SH2_LOCAL_INT1_ENABLE",
  ADDRESS => 0x0000000010000600,
  NOTE    => "The LOCAL_INT1_ENABLE register is analogous to the note LOCAL_INT0_ENABLE register except that it maps up to 14 local note event",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00156_flds
);


##########################################################################
#                                                                        #
#   SH2_LOCAL_INT2_CONFIG                                                #
#                                                                        #
##########################################################################

%shub2_01_00157_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 0, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  20,  32, 0x000FFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   3,   4,  16, 0x00000000000FFFF0, 0x00, 0, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Interrupt Type" ],
);

%shub2_01_00157_def =
( NAME    => "SH2_LOCAL_INT2_CONFIG",
  ADDRESS => 0x0000000010000680,
  NOTE    => "The LOCAL_INT2_CONFIG register contains the parameters used when note the LB generates a SN2NET LINTR message due to the occurre",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00157_flds
);


##########################################################################
#                                                                        #
#   SH2_LOCAL_INT2_ENABLE                                                #
#                                                                        #
##########################################################################

%shub2_01_00158_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  18,  46, 0xFFFFFFFFFFFC0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "L1_TO_ASIC"                   => [   1,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "Map L1 to asic Events to Local Interrupt 0" ],
   "ASIC_TO_L1"                   => [   2,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Map asic to L1 Events to Local Interrupt 0" ],
   "STOP_CLOCK"                   => [   3,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Map Stop Clock Events to Local Interrupt 2" ],
   "L1_NMI_INT"                   => [   4,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Map L1 Controller NMI to Local Interrupt 2" ],
   "LBI_INT"                      => [   5,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Map LBI Interrupts to Local Interrupt 2" ],
   "SYSTEM_SHUTDOWN_INT"          => [   6,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Map System Shutdown Events to Local Interrupt 2" ],
   "RSVD1"                        => [   7,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_UCE_INT"                   => [   8,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "Map XN Uncorrectable Data Errors to Local Interrupt 2" ],
   "MD_UCE_INT"                   => [   9,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Map MD Uncorrectable Data Errors to Local Interrupt 2" ],
   "PI_UCE_INT"                   => [  10,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Map PI Uncorrectable Data Errors to Local Interrupt 2" ],
   "XN_CE_INT"                    => [  11,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Map XN Correctable Data Errors to Local Interrupt 2" ],
   "MD_CE_INT"                    => [  12,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Map MD Correctable Data Errors to Local Interrupt 2" ],
   "PI_CE_INT"                    => [  13,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Map PI Correctable Data Errors to Local Interrupt 2" ],
   "BT_HW_INT"                    => [  14,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Map BT Hardware Errors to Local Interrupt 2" ],
   "LB_HW_INT"                    => [  15,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Map LB Hardware Errors to Local Interrupt 2" ],
   "XN_HW_INT"                    => [  16,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Map XN Hardware Errors to Local Interrupt 2" ],
   "MD_HW_INT"                    => [  17,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Map MD Hardware Errors to Local Interrupt 2" ],
   "PI_HW_INT"                    => [  18,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Map PI Hardware Errors to Local Interrupt 2" ],
);

%shub2_01_00158_def =
( NAME    => "SH2_LOCAL_INT2_ENABLE",
  ADDRESS => 0x0000000010000700,
  NOTE    => "The LOCAL_INT2_ENABLE register is analogous to the note LOCAL_INT0_ENABLE register except that it maps up to 14 local note event",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00158_flds
);


##########################################################################
#                                                                        #
#   SH2_LOCAL_INT3_CONFIG                                                #
#                                                                        #
##########################################################################

%shub2_01_00159_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 0, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  20,  32, 0x000FFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   3,   4,  16, 0x00000000000FFFF0, 0x00, 0, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Interrupt Type" ],
);

%shub2_01_00159_def =
( NAME    => "SH2_LOCAL_INT3_CONFIG",
  ADDRESS => 0x0000000010000780,
  NOTE    => "The LOCAL_INT3_CONFIG register contains the parameters used when note the LB generates a SN2NET LINTR message due to the occurre",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00159_flds
);


##########################################################################
#                                                                        #
#   SH2_LOCAL_INT3_ENABLE                                                #
#                                                                        #
##########################################################################

%shub2_01_00160_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  18,  46, 0xFFFFFFFFFFFC0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "L1_TO_ASIC"                   => [   1,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "Map L1 to asic Events to Local Interrupt 0" ],
   "ASIC_TO_L1"                   => [   2,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Map asic to L1 Events to Local Interrupt 0" ],
   "STOP_CLOCK"                   => [   3,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Map Stop Clock Events to Local Interrupt 3" ],
   "L1_NMI_INT"                   => [   4,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Map L1 Controller NMI to Local Interrupt 3" ],
   "LBI_INT"                      => [   5,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Map LBI Interrupts to Local Interrupt 3" ],
   "SYSTEM_SHUTDOWN_INT"          => [   6,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Map System Shutdown Events to Local Interrupt 3" ],
   "RSVD1"                        => [   7,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_UCE_INT"                   => [   8,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "Map XN Uncorrectable Data Errors to Local Interrupt 3" ],
   "MD_UCE_INT"                   => [   9,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Map MD Uncorrectable Data Errors to Local Interrupt 3" ],
   "PI_UCE_INT"                   => [  10,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Map PI Uncorrectable Data Errors to Local Interrupt 3" ],
   "XN_CE_INT"                    => [  11,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Map XN Correctable Data Errors to Local Interrupt 3" ],
   "MD_CE_INT"                    => [  12,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Map MD Correctable Data Errors to Local Interrupt 3" ],
   "PI_CE_INT"                    => [  13,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Map PI Correctable Data Errors to Local Interrupt 3" ],
   "BT_HW_INT"                    => [  14,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Map BT Hardware Errors to Local Interrupt 3" ],
   "LB_HW_INT"                    => [  15,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Map LB Hardware Errors to Local Interrupt 3" ],
   "XN_HW_INT"                    => [  16,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Map XN Hardware Errors to Local Interrupt 3" ],
   "MD_HW_INT"                    => [  17,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Map MD Hardware Errors to Local Interrupt 3" ],
   "PI_HW_INT"                    => [  18,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Map PI Hardware Errors to Local Interrupt 3" ],
);

%shub2_01_00160_def =
( NAME    => "SH2_LOCAL_INT3_ENABLE",
  ADDRESS => 0x0000000010000800,
  NOTE    => "The LOCAL_INT3_ENABLE register is analogous to the note LOCAL_INT0_ENABLE register except that it maps up to 14 local note event",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00160_flds
);


##########################################################################
#                                                                        #
#   SH2_LOCAL_INT4_CONFIG                                                #
#                                                                        #
##########################################################################

%shub2_01_00161_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 0, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  20,  32, 0x000FFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   3,   4,  16, 0x00000000000FFFF0, 0x00, 0, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Interrupt Type" ],
);

%shub2_01_00161_def =
( NAME    => "SH2_LOCAL_INT4_CONFIG",
  ADDRESS => 0x0000000010000880,
  NOTE    => "The LOCAL_INT4_CONFIG register contains the parameters used when note the LB generates a SN2NET LINTR message due to the occurre",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00161_flds
);


##########################################################################
#                                                                        #
#   SH2_LOCAL_INT4_ENABLE                                                #
#                                                                        #
##########################################################################

%shub2_01_00162_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  18,  46, 0xFFFFFFFFFFFC0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "L1_TO_ASIC"                   => [   1,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "Map L1 to asic Events to Local Interrupt 0" ],
   "ASIC_TO_L1"                   => [   2,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Map asic to L1 Events to Local Interrupt 0" ],
   "STOP_CLOCK"                   => [   3,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Map Stop Clock Events to Local Interrupt 4" ],
   "L1_NMI_INT"                   => [   4,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Map L1 Controller NMI to Local Interrupt 4" ],
   "LBI_INT"                      => [   5,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Map LBI Interrupts to Local Interrupt 4" ],
   "SYSTEM_SHUTDOWN_INT"          => [   6,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Map System Shutdown Events to Local Interrupt 4" ],
   "RSVD1"                        => [   7,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_UCE_INT"                   => [   8,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "Map XN Uncorrectable Data Errors to Local Interrupt 4" ],
   "MD_UCE_INT"                   => [   9,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Map MD Uncorrectable Data Errors to Local Interrupt 4" ],
   "PI_UCE_INT"                   => [  10,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Map PI Uncorrectable Data Errors to Local Interrupt 4" ],
   "XN_CE_INT"                    => [  11,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Map XN Correctable Data Errors to Local Interrupt 4" ],
   "MD_CE_INT"                    => [  12,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Map MD Correctable Data Errors to Local Interrupt 4" ],
   "PI_CE_INT"                    => [  13,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Map PI Correctable Data Errors to Local Interrupt 4" ],
   "BT_HW_INT"                    => [  14,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Map BT Hardware Errors to Local Interrupt 4" ],
   "LB_HW_INT"                    => [  15,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Map LB Hardware Errors to Local Interrupt 4" ],
   "XN_HW_INT"                    => [  16,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Map XN Hardware Errors to Local Interrupt 4" ],
   "MD_HW_INT"                    => [  17,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Map MD Hardware Errors to Local Interrupt 4" ],
   "PI_HW_INT"                    => [  18,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Map PI Hardware Errors to Local Interrupt 4" ],
);

%shub2_01_00162_def =
( NAME    => "SH2_LOCAL_INT4_ENABLE",
  ADDRESS => 0x0000000010000900,
  NOTE    => "The LOCAL_INT4_ENABLE register is analogous to the note LOCAL_INT0_ENABLE register except that it maps up to 14 local note event",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00162_flds
);


##########################################################################
#                                                                        #
#   SH2_LOCAL_INT5_CONFIG                                                #
#                                                                        #
##########################################################################

%shub2_01_00163_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 0, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  20,  32, 0x000FFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   3,   4,  16, 0x00000000000FFFF0, 0x00, 0, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Interrupt Type" ],
);

%shub2_01_00163_def =
( NAME    => "SH2_LOCAL_INT5_CONFIG",
  ADDRESS => 0x0000000010000980,
  NOTE    => "The LOCAL_INT5_CONFIG register contains the parameters used when note the LB generates a SN2NET LINTR message due to the occurre",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00163_flds
);


##########################################################################
#                                                                        #
#   SH2_LOCAL_INT5_ENABLE                                                #
#                                                                        #
##########################################################################

%shub2_01_00164_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  18,  46, 0xFFFFFFFFFFFC0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "L1_TO_ASIC"                   => [   1,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "Map L1 to asic Events to Local Interrupt 0" ],
   "ASIC_TO_L1"                   => [   2,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Map asic to L1 Events to Local Interrupt 0" ],
   "STOP_CLOCK"                   => [   3,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Map Stop Clock Events to Local Interrupt 5" ],
   "L1_NMI_INT"                   => [   4,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Map L1 Controller NMI to Local Interrupt 5" ],
   "LBI_INT"                      => [   5,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Map LBI Interrupts to Local Interrupt 5" ],
   "SYSTEM_SHUTDOWN_INT"          => [   6,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Map System Shutdown Events to Local Interrupt 5" ],
   "RSVD1"                        => [   7,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_UCE_INT"                   => [   8,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "Map XN Uncorrectable Data Errors to Local Interrupt 5" ],
   "MD_UCE_INT"                   => [   9,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Map MD Uncorrectable Data Errors to Local Interrupt 5" ],
   "PI_UCE_INT"                   => [  10,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Map PI Uncorrectable Data Errors to Local Interrupt 5" ],
   "XN_CE_INT"                    => [  11,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Map XN Correctable Data Errors to Local Interrupt 5" ],
   "MD_CE_INT"                    => [  12,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Map MD Correctable Data Errors to Local Interrupt 5" ],
   "PI_CE_INT"                    => [  13,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Map PI Correctable Data Errors to Local Interrupt 5" ],
   "BT_HW_INT"                    => [  14,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Map BT Hardware Errors to Local Interrupt 5" ],
   "LB_HW_INT"                    => [  15,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Map LB Hardware Errors to Local Interrupt 5" ],
   "XN_HW_INT"                    => [  16,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Map XN Hardware Errors to Local Interrupt 5" ],
   "MD_HW_INT"                    => [  17,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Map MD Hardware Errors to Local Interrupt 5" ],
   "PI_HW_INT"                    => [  18,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Map PI Hardware Errors to Local Interrupt 5" ],
);

%shub2_01_00164_def =
( NAME    => "SH2_LOCAL_INT5_ENABLE",
  ADDRESS => 0x0000000010000a00,
  NOTE    => "The LOCAL_INT5_ENABLE register is analogous to the note LOCAL_INT0_ENABLE register except that it maps up to 14 local note event",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00164_flds
);


##########################################################################
#                                                                        #
#   SH2_LOCAL_INT6_CONFIG                                                #
#                                                                        #
##########################################################################

%shub2_01_00165_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 0, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  20,  32, 0x000FFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   3,   4,  16, 0x00000000000FFFF0, 0x00, 0, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Interrupt Type" ],
);

%shub2_01_00165_def =
( NAME    => "SH2_LOCAL_INT6_CONFIG",
  ADDRESS => 0x0000000010000a80,
  NOTE    => "The LOCAL_INT6_CONFIG register contains the parameters used when note the LB generates a SN2NET LINTR message due to the occurre",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00165_flds
);


##########################################################################
#                                                                        #
#   SH2_LOCAL_INT6_ENABLE                                                #
#                                                                        #
##########################################################################

%shub2_01_00166_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  18,  46, 0xFFFFFFFFFFFC0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "L1_TO_ASIC"                   => [   1,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "Map L1 to asic Events to Local Interrupt 0" ],
   "ASIC_TO_L1"                   => [   2,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Map asic to L1 Events to Local Interrupt 0" ],
   "STOP_CLOCK"                   => [   3,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Map Stop Clock Events to Local Interrupt 6" ],
   "L1_NMI_INT"                   => [   4,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Map L1 Controller NMI to Local Interrupt 6" ],
   "LBI_INT"                      => [   5,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Map LBI Interrupts to Local Interrupt 6" ],
   "SYSTEM_SHUTDOWN_INT"          => [   6,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Map System Shutdown Events to Local Interrupt 6" ],
   "RSVD1"                        => [   7,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_UCE_INT"                   => [   8,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "Map XN Uncorrectable Data Errors to Local Interrupt 6" ],
   "MD_UCE_INT"                   => [   9,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Map MD Uncorrectable Data Errors to Local Interrupt 6" ],
   "PI_UCE_INT"                   => [  10,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Map PI Uncorrectable Data Errors to Local Interrupt 6" ],
   "XN_CE_INT"                    => [  11,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Map XN Correctable Data Errors to Local Interrupt 6" ],
   "MD_CE_INT"                    => [  12,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Map MD Correctable Data Errors to Local Interrupt 6" ],
   "PI_CE_INT"                    => [  13,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Map PI Correctable Data Errors to Local Interrupt 6" ],
   "BT_HW_INT"                    => [  14,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Map BT Hardware Errors to Local Interrupt 6" ],
   "LB_HW_INT"                    => [  15,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Map LB Hardware Errors to Local Interrupt 6" ],
   "XN_HW_INT"                    => [  16,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Map XN Hardware Errors to Local Interrupt 6" ],
   "MD_HW_INT"                    => [  17,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Map MD Hardware Errors to Local Interrupt 6" ],
   "PI_HW_INT"                    => [  18,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Map PI Hardware Errors to Local Interrupt 6" ],
);

%shub2_01_00166_def =
( NAME    => "SH2_LOCAL_INT6_ENABLE",
  ADDRESS => 0x0000000010000b00,
  NOTE    => "The LOCAL_INT6_ENABLE register is analogous to the note LOCAL_INT0_ENABLE register except that it maps up to 14 local note event",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00166_flds
);


##########################################################################
#                                                                        #
#   SH2_LOCAL_INT7_CONFIG                                                #
#                                                                        #
##########################################################################

%shub2_01_00167_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 0, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  20,  32, 0x000FFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   3,   4,  16, 0x00000000000FFFF0, 0x00, 0, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Interrupt Type" ],
);

%shub2_01_00167_def =
( NAME    => "SH2_LOCAL_INT7_CONFIG",
  ADDRESS => 0x0000000010000b80,
  NOTE    => "The LOCAL_INT7_CONFIG register contains the parameters used when note the LB generates a SN2NET LINTR message due to the occurre",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00167_flds
);


##########################################################################
#                                                                        #
#   SH2_LOCAL_INT7_ENABLE                                                #
#                                                                        #
##########################################################################

%shub2_01_00168_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  18,  46, 0xFFFFFFFFFFFC0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "L1_TO_ASIC"                   => [   1,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "Map L1 to asic Events to Local Interrupt 0" ],
   "ASIC_TO_L1"                   => [   2,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Map asic to L1 Events to Local Interrupt 0" ],
   "STOP_CLOCK"                   => [   3,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Map Stop Clock Events to Local Interrupt 7" ],
   "L1_NMI_INT"                   => [   4,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Map L1 Controller NMI to Local Interrupt 7" ],
   "LBI_INT"                      => [   5,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Map LBI Interrupts to Local Interrupt 7" ],
   "SYSTEM_SHUTDOWN_INT"          => [   6,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Map System Shutdown Events to Local Interrupt 7" ],
   "RSVD1"                        => [   7,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_UCE_INT"                   => [   8,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "Map XN Uncorrectable Data Errors to Local Interrupt 7" ],
   "MD_UCE_INT"                   => [   9,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Map MD Uncorrectable Data Errors to Local Interrupt 7" ],
   "PI_UCE_INT"                   => [  10,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Map PI Uncorrectable Data Errors to Local Interrupt 7" ],
   "XN_CE_INT"                    => [  11,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Map XN Correctable Data Errors to Local Interrupt 7" ],
   "MD_CE_INT"                    => [  12,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Map MD Correctable Data Errors to Local Interrupt 7" ],
   "PI_CE_INT"                    => [  13,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Map PI Correctable Data Errors to Local Interrupt 7" ],
   "BT_HW_INT"                    => [  14,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Map BT Hardware Errors to Local Interrupt 7" ],
   "LB_HW_INT"                    => [  15,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Map LB Hardware Errors to Local Interrupt 7" ],
   "XN_HW_INT"                    => [  16,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Map XN Hardware Errors to Local Interrupt 7" ],
   "MD_HW_INT"                    => [  17,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Map MD Hardware Errors to Local Interrupt 7" ],
   "PI_HW_INT"                    => [  18,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Map PI Hardware Errors to Local Interrupt 7" ],
);

%shub2_01_00168_def =
( NAME    => "SH2_LOCAL_INT7_ENABLE",
  ADDRESS => 0x0000000010000c00,
  NOTE    => "The LOCAL_INT7_ENABLE register is analogous to the note LOCAL_INT0_ENABLE register except that it maps up to 14 local note event",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00168_flds
);


##########################################################################
#                                                                        #
#   SH2_LOCAL_INT8_CONFIG                                                #
#                                                                        #
##########################################################################

%shub2_01_00169_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 0, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  20,  32, 0x000FFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   3,   4,  16, 0x00000000000FFFF0, 0x00, 0, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Interrupt Type" ],
);

%shub2_01_00169_def =
( NAME    => "SH2_LOCAL_INT8_CONFIG",
  ADDRESS => 0x0000000010000c80,
  NOTE    => "The LOCAL_INT8_CONFIG register contains the parameters used when note the LB generates a SN2NET LINTR message due to the occurre",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00169_flds
);


##########################################################################
#                                                                        #
#   SH2_LOCAL_INT8_ENABLE                                                #
#                                                                        #
##########################################################################

%shub2_01_00170_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  18,  46, 0xFFFFFFFFFFFC0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "L1_TO_ASIC"                   => [   1,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "Map L1 to asic Events to Local Interrupt 0" ],
   "ASIC_TO_L1"                   => [   2,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Map asic to L1 Events to Local Interrupt 0" ],
   "STOP_CLOCK"                   => [   3,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Map Stop Clock Events to Local Interrupt 8" ],
   "L1_NMI_INT"                   => [   4,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Map L1 Controller NMI to Local Interrupt 8" ],
   "LBI_INT"                      => [   5,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Map LBI Interrupts to Local Interrupt 8" ],
   "SYSTEM_SHUTDOWN_INT"          => [   6,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Map System Shutdown Events to Local Interrupt 8" ],
   "RSVD1"                        => [   7,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_UCE_INT"                   => [   8,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "Map XN Uncorrectable Data Errors to Local Interrupt 8" ],
   "MD_UCE_INT"                   => [   9,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Map MD Uncorrectable Data Errors to Local Interrupt 8" ],
   "PI_UCE_INT"                   => [  10,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Map PI Uncorrectable Data Errors to Local Interrupt 8" ],
   "XN_CE_INT"                    => [  11,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Map XN Correctable Data Errors to Local Interrupt 8" ],
   "MD_CE_INT"                    => [  12,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Map MD Correctable Data Errors to Local Interrupt 8" ],
   "PI_CE_INT"                    => [  13,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Map PI Correctable Data Errors to Local Interrupt 8" ],
   "BT_HW_INT"                    => [  14,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Map BT Hardware Errors to Local Interrupt 8" ],
   "LB_HW_INT"                    => [  15,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Map LB Hardware Errors to Local Interrupt 8" ],
   "XN_HW_INT"                    => [  16,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Map XN Hardware Errors to Local Interrupt 8" ],
   "MD_HW_INT"                    => [  17,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Map MD Hardware Errors to Local Interrupt 8" ],
   "PI_HW_INT"                    => [  18,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Map PI Hardware Errors to Local Interrupt 8" ],
);

%shub2_01_00170_def =
( NAME    => "SH2_LOCAL_INT8_ENABLE",
  ADDRESS => 0x0000000010000d00,
  NOTE    => "The LOCAL_INT8_ENABLE register is analogous to the note LOCAL_INT0_ENABLE register except that it maps up to 14 local note event",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00170_flds
);


##########################################################################
#                                                                        #
#   SH2_LOCAL_INT9_CONFIG                                                #
#                                                                        #
##########################################################################

%shub2_01_00171_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 0, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  20,  32, 0x000FFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   3,   4,  16, 0x00000000000FFFF0, 0x00, 0, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Interrupt Type" ],
);

%shub2_01_00171_def =
( NAME    => "SH2_LOCAL_INT9_CONFIG",
  ADDRESS => 0x0000000010000d80,
  NOTE    => "The LOCAL_INT9_CONFIG register contains the parameters used when note the LB generates a SN2NET LINTR message due to the occurre",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00171_flds
);


##########################################################################
#                                                                        #
#   SH2_LOCAL_INT9_ENABLE                                                #
#                                                                        #
##########################################################################

%shub2_01_00172_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  18,  46, 0xFFFFFFFFFFFC0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "L1_TO_ASIC"                   => [   1,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "Map L1 to asic Events to Local Interrupt 0" ],
   "ASIC_TO_L1"                   => [   2,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Map asic to L1 Events to Local Interrupt 0" ],
   "STOP_CLOCK"                   => [   3,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Map Stop Clock Events to Local Interrupt 9" ],
   "L1_NMI_INT"                   => [   4,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Map L1 Controller NMI to Local Interrupt 9" ],
   "LBI_INT"                      => [   5,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Map LBI Interrupts to Local Interrupt 9" ],
   "SYSTEM_SHUTDOWN_INT"          => [   6,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Map System Shutdown Events to Local Interrupt 9" ],
   "RSVD1"                        => [   7,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_UCE_INT"                   => [   8,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "Map XN Uncorrectable Data Errors to Local Interrupt 9" ],
   "MD_UCE_INT"                   => [   9,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Map MD Uncorrectable Data Errors to Local Interrupt 9" ],
   "PI_UCE_INT"                   => [  10,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Map PI Uncorrectable Data Errors to Local Interrupt 9" ],
   "XN_CE_INT"                    => [  11,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Map XN Correctable Data Errors to Local Interrupt 9" ],
   "MD_CE_INT"                    => [  12,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Map MD Correctable Data Errors to Local Interrupt 9" ],
   "PI_CE_INT"                    => [  13,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Map PI Correctable Data Errors to Local Interrupt 9" ],
   "BT_HW_INT"                    => [  14,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Map BT Hardware Errors to Local Interrupt 9" ],
   "LB_HW_INT"                    => [  15,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Map LB Hardware Errors to Local Interrupt 9" ],
   "XN_HW_INT"                    => [  16,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Map XN Hardware Errors to Local Interrupt 9" ],
   "MD_HW_INT"                    => [  17,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Map MD Hardware Errors to Local Interrupt 9" ],
   "PI_HW_INT"                    => [  18,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Map PI Hardware Errors to Local Interrupt 9" ],
);

%shub2_01_00172_def =
( NAME    => "SH2_LOCAL_INT9_ENABLE",
  ADDRESS => 0x0000000010000e00,
  NOTE    => "The LOCAL_INT9_ENABLE register is analogous to the note LOCAL_INT0_ENABLE register except that it maps up to 14 local note event",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00172_flds
);


##########################################################################
#                                                                        #
#   SH2_PROFILE_INT_CONFIG                                               #
#                                                                        #
##########################################################################

%shub2_01_00173_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 0, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  20,  32, 0x000FFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   3,   4,  16, 0x00000000000FFFF0, 0x00, 0, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Interrupt Type" ],
);

%shub2_01_00173_def =
( NAME    => "SH2_PROFILE_INT_CONFIG",
  ADDRESS => 0x0000000010001280,
  NOTE    => "A Profiling Event occurs when the 32 least significant bits of the note SHub's real-time clock (viewable via the RTC register's ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00173_flds
);


##########################################################################
#                                                                        #
#   SH2_PROFILE_INT_ENABLE                                               #
#                                                                        #
##########################################################################

%shub2_01_00174_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PROFILE_ENABLE"               => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable Profile Interrupt" ],
);

%shub2_01_00174_def =
( NAME    => "SH2_PROFILE_INT_ENABLE",
  ADDRESS => 0x0000000010001300,
  NOTE    => "The PROFILE_INT_ENABLE register determines if the LB generates a note SN2NET LINTR message when a Profiling Event occurs. Refer ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00174_flds
);


##########################################################################
#                                                                        #
#   SH2_RTC0_INT_CONFIG                                                  #
#                                                                        #
##########################################################################

%shub2_01_00175_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 0, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  20,  32, 0x000FFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   3,   4,  16, 0x00000000000FFFF0, 0x00, 0, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Interrupt Type" ],
);

%shub2_01_00175_def =
( NAME    => "SH2_RTC0_INT_CONFIG",
  ADDRESS => 0x0000000010001380,
  NOTE    => "A RTC 0 Event occurs when the value of the SHub's real-time clock note (viewable via the RTC register's REAL_TIME_CLOCK field) e",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00175_flds
);


##########################################################################
#                                                                        #
#   SH2_RTC0_INT_ENABLE                                                  #
#                                                                        #
##########################################################################

%shub2_01_00176_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RTC0_ENABLE"                  => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable RTC 0 Interrupt" ],
);

%shub2_01_00176_def =
( NAME    => "SH2_RTC0_INT_ENABLE",
  ADDRESS => 0x0000000010001400,
  NOTE    => "The RTC0_INT_ENABLE register determines if the LB generates a note SN2NET LINTR message when a RTC 0 Event occurs. Refer to the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00176_flds
);


##########################################################################
#                                                                        #
#   SH2_RTC1_INT_CONFIG                                                  #
#                                                                        #
##########################################################################

%shub2_01_00177_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 0, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  20,  32, 0x000FFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   3,   4,  16, 0x00000000000FFFF0, 0x00, 0, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Interrupt Type" ],
);

%shub2_01_00177_def =
( NAME    => "SH2_RTC1_INT_CONFIG",
  ADDRESS => 0x0000000010001480,
  NOTE    => "A RTC 1 Event occurs when the value of the SHub's real-time clock note (viewable via the RTC register's REAL_TIME_CLOCK field) e",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00177_flds
);


##########################################################################
#                                                                        #
#   SH2_RTC1_INT_ENABLE                                                  #
#                                                                        #
##########################################################################

%shub2_01_00178_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RTC1_ENABLE"                  => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable RTC 1 Interrupt" ],
);

%shub2_01_00178_def =
( NAME    => "SH2_RTC1_INT_ENABLE",
  ADDRESS => 0x0000000010001500,
  NOTE    => "The RTC1_INT_ENABLE register determines if the LB generates a note SN2NET LINTR message when a RTC 1 Event occurs. Refer to the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00178_flds
);


##########################################################################
#                                                                        #
#   SH2_RTC2_INT_CONFIG                                                  #
#                                                                        #
##########################################################################

%shub2_01_00179_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 0, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  20,  32, 0x000FFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   3,   4,  16, 0x00000000000FFFF0, 0x00, 0, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Interrupt Type" ],
);

%shub2_01_00179_def =
( NAME    => "SH2_RTC2_INT_CONFIG",
  ADDRESS => 0x0000000010001580,
  NOTE    => "A RTC 2 Event occurs when the value of the SHub's real-time clock note (viewable via the RTC register's REAL_TIME_CLOCK field) e",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00179_flds
);


##########################################################################
#                                                                        #
#   SH2_RTC2_INT_ENABLE                                                  #
#                                                                        #
##########################################################################

%shub2_01_00180_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RTC2_ENABLE"                  => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable RTC 2 Interrupt" ],
);

%shub2_01_00180_def =
( NAME    => "SH2_RTC2_INT_ENABLE",
  ADDRESS => 0x0000000010001600,
  NOTE    => "The RTC2_INT_ENABLE register determines if the LB generates a note SN2NET LINTR message when a RTC 2 Event occurs. Refer to the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00180_flds
);


##########################################################################
#                                                                        #
#   SH2_RTC3_INT_CONFIG                                                  #
#                                                                        #
##########################################################################

%shub2_01_00181_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 0, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  20,  32, 0x000FFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   3,   4,  16, 0x00000000000FFFF0, 0x00, 0, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Interrupt Type" ],
);

%shub2_01_00181_def =
( NAME    => "SH2_RTC3_INT_CONFIG",
  ADDRESS => 0x0000000010001680,
  NOTE    => "A RTC 3 Event occurs when the value of the SHub's real-time clock note (viewable via the RTC register's REAL_TIME_CLOCK field) e",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00181_flds
);


##########################################################################
#                                                                        #
#   SH2_RTC3_INT_ENABLE                                                  #
#                                                                        #
##########################################################################

%shub2_01_00182_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RTC3_ENABLE"                  => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable RTC 3 Interrupt" ],
);

%shub2_01_00182_def =
( NAME    => "SH2_RTC3_INT_ENABLE",
  ADDRESS => 0x0000000010001700,
  NOTE    => "The RTC3_INT_ENABLE register determines if the LB generates a note SN2NET LINTR message when a RTC 3 Event occurs. Refer to the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00182_flds
);


##########################################################################
#                                                                        #
#   SH2_BT0_INT_CONFIG                                                   #
#                                                                        #
##########################################################################

%shub2_01_00183_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 0, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  20,  32, 0x000FFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   3,   4,  16, 0x00000000000FFFF0, 0x00, 0, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Interrupt Type" ],
);

%shub2_01_00183_def =
( NAME    => "SH2_BT0_INT_CONFIG",
  ADDRESS => 0x0000000010001780,
  NOTE    => "The BT0_INT_CONFIG register along with the BT0_INT_ENABLE registers note provide a mechansism for the Block Transfer Engine to g",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00183_flds
);


##########################################################################
#                                                                        #
#   SH2_BT0_INT_ENABLE                                                   #
#                                                                        #
##########################################################################

%shub2_01_00184_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BT0_ENABLE"                   => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable BT 0 Interrupt" ],
);

%shub2_01_00184_def =
( NAME    => "SH2_BT0_INT_ENABLE",
  ADDRESS => 0x0000000010001800,
  NOTE    => "The BT0_INT_ENABLE register determines if the LB generates a SN2NET note LINTR message when a BT 0 Event occurs. Refer to the BT",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00184_flds
);


##########################################################################
#                                                                        #
#   SH2_BT1_INT_CONFIG                                                   #
#                                                                        #
##########################################################################

%shub2_01_00185_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 0, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  20,  32, 0x000FFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   3,   4,  16, 0x00000000000FFFF0, 0x00, 0, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Interrupt Type" ],
);

%shub2_01_00185_def =
( NAME    => "SH2_BT1_INT_CONFIG",
  ADDRESS => 0x0000000010001880,
  NOTE    => "The BT1_INT_CONFIG register along with the BT1_INT_ENABLE registers note provide a mechansism for the Block Transfer Engine to g",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00185_flds
);


##########################################################################
#                                                                        #
#   SH2_BT1_INT_ENABLE                                                   #
#                                                                        #
##########################################################################

%shub2_01_00186_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BT1_ENABLE"                   => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable BT 1 Interrupt" ],
);

%shub2_01_00186_def =
( NAME    => "SH2_BT1_INT_ENABLE",
  ADDRESS => 0x0000000010001900,
  NOTE    => "The BT1_INT_ENABLE register determines if the LB generates a SN2NET note LINTR message when a BT 1 Event occurs. Refer to the BT",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00186_flds
);


##########################################################################
#                                                                        #
#   SH2_BT2_INT_CONFIG                                                   #
#                                                                        #
##########################################################################

%shub2_01_00187_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 0, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  20,  32, 0x000FFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   3,   4,  16, 0x00000000000FFFF0, 0x00, 0, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Interrupt Type" ],
);

%shub2_01_00187_def =
( NAME    => "SH2_BT2_INT_CONFIG",
  ADDRESS => 0x0000000010001980,
  NOTE    => "The BT2_INT_CONFIG register along with the BT2_INT_ENABLE registers note provide a mechansism for the Block Transfer Engine to g",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00187_flds
);


##########################################################################
#                                                                        #
#   SH2_BT2_INT_ENABLE                                                   #
#                                                                        #
##########################################################################

%shub2_01_00188_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BT2_ENABLE"                   => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable BT 2 Interrupt" ],
);

%shub2_01_00188_def =
( NAME    => "SH2_BT2_INT_ENABLE",
  ADDRESS => 0x0000000010001a00,
  NOTE    => "The BT2_INT_ENABLE register determines if the LB generates a SN2NET note LINTR message when a BT 2 Event occurs. Refer to the BT",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00188_flds
);


##########################################################################
#                                                                        #
#   SH2_BT3_INT_CONFIG                                                   #
#                                                                        #
##########################################################################

%shub2_01_00189_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 0, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  20,  32, 0x000FFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   3,   4,  16, 0x00000000000FFFF0, 0x00, 0, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Interrupt Type" ],
);

%shub2_01_00189_def =
( NAME    => "SH2_BT3_INT_CONFIG",
  ADDRESS => 0x0000000010001a80,
  NOTE    => "The BT3_INT_CONFIG register along with the BT3_INT_ENABLE registers note provide a mechansism for the Block Transfer Engine to g",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00189_flds
);


##########################################################################
#                                                                        #
#   SH2_BT3_INT_ENABLE                                                   #
#                                                                        #
##########################################################################

%shub2_01_00190_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BT3_ENABLE"                   => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable BT 3 Interrupt" ],
);

%shub2_01_00190_def =
( NAME    => "SH2_BT3_INT_ENABLE",
  ADDRESS => 0x0000000010001b00,
  NOTE    => "The BT3_INT_ENABLE register determines if the LB generates a SN2NET note LINTR message when a BT 3 Event occurs. Refer to the BT",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00190_flds
);


##########################################################################
#                                                                        #
#   SH2_NOTIFICATION_MEMORY_INT0_CONFIG                                     #
#                                                                        #
##########################################################################

%shub2_01_00191_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 0, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  20,  32, 0x000FFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   3,   4,  16, 0x00000000000FFFF0, 0x00, 0, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Interrupt Type" ],
);

%shub2_01_00191_def =
( NAME    => "SH2_NOTIFICATION_MEMORY_INT0_CONFIG",
  ADDRESS => 0x0000000010001b80,
  NOTE    => "The NOTIFICATION_MEMORY_INT0_CONFIG register along with the note NOTIFICATION_MEMORY_INT0_ENABLE registers provide a mechansism ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00191_flds
);


##########################################################################
#                                                                        #
#   SH2_NOTIFICATION_MEMORY_INT0_ENABLE                                     #
#                                                                        #
##########################################################################

%shub2_01_00192_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE"                       => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable NOTIFICATION_MEMORY Interrupt 0" ],
);

%shub2_01_00192_def =
( NAME    => "SH2_NOTIFICATION_MEMORY_INT0_ENABLE",
  ADDRESS => 0x0000000010001c00,
  NOTE    => "The NOTIFICATION_MEMORY_INT0_ENABLE register determines if the LB note generates a SN2NET LINTR message when an AMO operation to",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00192_flds
);


##########################################################################
#                                                                        #
#   SH2_NOTIFICATION_MEMORY_INT1_CONFIG                                     #
#                                                                        #
##########################################################################

%shub2_01_00193_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 0, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  20,  32, 0x000FFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   3,   4,  16, 0x00000000000FFFF0, 0x00, 0, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Interrupt Type" ],
);

%shub2_01_00193_def =
( NAME    => "SH2_NOTIFICATION_MEMORY_INT1_CONFIG",
  ADDRESS => 0x0000000010001c80,
  NOTE    => "The NOTIFICATION_MEMORY_INT1_CONFIG register along with the note NOTIFICATION_MEMORY_INT1_ENABLE registers provide a mechansism ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00193_flds
);


##########################################################################
#                                                                        #
#   SH2_NOTIFICATION_MEMORY_INT1_ENABLE                                     #
#                                                                        #
##########################################################################

%shub2_01_00194_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE"                       => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable NOTIFICATION_MEMORY Interrupt 1" ],
);

%shub2_01_00194_def =
( NAME    => "SH2_NOTIFICATION_MEMORY_INT1_ENABLE",
  ADDRESS => 0x0000000010001d00,
  NOTE    => "The NOTIFICATION_MEMORY_INT1_ENABLE register determines if the LB note generates a SN2NET LINTR message when an AMO operation to",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00194_flds
);


##########################################################################
#                                                                        #
#   SH2_NOTIFICATION_MEMORY_INT2_CONFIG                                     #
#                                                                        #
##########################################################################

%shub2_01_00195_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 0, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  20,  32, 0x000FFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   3,   4,  16, 0x00000000000FFFF0, 0x00, 0, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Interrupt Type" ],
);

%shub2_01_00195_def =
( NAME    => "SH2_NOTIFICATION_MEMORY_INT2_CONFIG",
  ADDRESS => 0x0000000010001d80,
  NOTE    => "The NOTIFICATION_MEMORY_INT2_CONFIG register along with the note NOTIFICATION_MEMORY_INT2_ENABLE registers provide a mechansism ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00195_flds
);


##########################################################################
#                                                                        #
#   SH2_NOTIFICATION_MEMORY_INT2_ENABLE                                     #
#                                                                        #
##########################################################################

%shub2_01_00196_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE"                       => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable NOTIFICATION_MEMORY Interrupt 2" ],
);

%shub2_01_00196_def =
( NAME    => "SH2_NOTIFICATION_MEMORY_INT2_ENABLE",
  ADDRESS => 0x0000000010001e00,
  NOTE    => "The NOTIFICATION_MEMORY_INT2_ENABLE register determines if the LB note generates a SN2NET LINTR message when an AMO operation to",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00196_flds
);


##########################################################################
#                                                                        #
#   SH2_NOTIFICATION_MEMORY_INT3_CONFIG                                     #
#                                                                        #
##########################################################################

%shub2_01_00197_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 0, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  20,  32, 0x000FFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   3,   4,  16, 0x00000000000FFFF0, 0x00, 0, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Interrupt Type" ],
);

%shub2_01_00197_def =
( NAME    => "SH2_NOTIFICATION_MEMORY_INT3_CONFIG",
  ADDRESS => 0x0000000010001e80,
  NOTE    => "The NOTIFICATION_MEMORY_INT3_CONFIG register along with the note NOTIFICATION_MEMORY_INT3_ENABLE registers provide a mechansism ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00197_flds
);


##########################################################################
#                                                                        #
#   SH2_NOTIFICATION_MEMORY_INT3_ENABLE                                     #
#                                                                        #
##########################################################################

%shub2_01_00198_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE"                       => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable NOTIFICATION_MEMORY Interrupt 3" ],
);

%shub2_01_00198_def =
( NAME    => "SH2_NOTIFICATION_MEMORY_INT3_ENABLE",
  ADDRESS => 0x0000000010001f00,
  NOTE    => "The NOTIFICATION_MEMORY_INT3_ENABLE register determines if the LB note generates a SN2NET LINTR message when an AMO operation to",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00198_flds
);


##########################################################################
#                                                                        #
#   SH2_EVENT_OCCURRED                                                   #
#                                                                        #
##########################################################################

%shub2_01_00199_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  43,  21, 0xFFFFF80000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NOTIFICATION_MEMORY_INT3"     => [   1,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "Notification Memory Interrupt 3 Pending" ],
   "NOTIFICATION_MEMORY_INT2"     => [   2,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "Notification Memory Interrupt 2 Pending" ],
   "NOTIFICATION_MEMORY_INT1"     => [   3,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "Notification Memory Interrupt 1 Pending" ],
   "NOTIFICATION_MEMORY_INT0"     => [   4,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "Notification Memory Interrupt 0 Pending" ],
   "BT3_INT"                      => [   5,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "BT Engine 3 Interrupt Pending" ],
   "BT2_INT"                      => [   6,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "BT Engine 2 Interrupt Pending" ],
   "BT1_INT"                      => [   7,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "BT Engine 1 Interrupt Pending" ],
   "BT0_INT"                      => [   8,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "BT Engine 0 Interrupt Pending" ],
   "EXTIO_INT3"                   => [   9,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "EXTIO 3 Interrupt Pending" ],
   "EXTIO_INT2"                   => [  10,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "EXTIO 2 Interrupt Pending" ],
   "L1_TO_ASIC_INT"               => [  11,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "L1 to_Asic Interrupt Pending" ],
   "ASIC_TO_L1_INT"               => [  12,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "Asic to L1 Interrupt Pending" ],
   "EXTIO_INT1"                   => [  13,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "EXTIO 1 Interrupt Pending" ],
   "EXTIO_INT0"                   => [  14,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "EXTIO 0 Interrupt Pending" ],
   "IPI_INT"                      => [  15,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "Inter-processor Interrupt Pending" ],
   "PROFILE_INT"                  => [  16,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "Profile Interrupt Pending" ],
   "RTC3_INT"                     => [  17,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "RTC 3 Interrupt Pending" ],
   "RTC2_INT"                     => [  18,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "RTC 2 Interrupt Pending" ],
   "RTC1_INT"                     => [  19,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "RTC 1 Interrupt Pending" ],
   "RTC0_INT"                     => [  20,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "RTC 0 Interrupt Pending" ],
   "STOP_CLOCK"                   => [  21,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "Stop Clock Interrupt Pending" ],
   "L1_NMI_INT"                   => [  22,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "L1 Controller NMI Interrupt Pending" ],
   "LBI_INT"                      => [  23,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "LBI Interrupt Pending" ],
   "SYSTEM_SHUTDOWN_INT"          => [  24,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "System Shutdown Interrupt Pending" ],
   "RSVD1"                        => [  25,  11,   8, 0x000000000007F800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_UCE_INT"                   => [  26,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "XN Uncorrectable Error Interrupt Pending" ],
   "MD_UCE_INT"                   => [  27,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "MD Uncorrectable Error Interrupt Pending" ],
   "PI_UCE_INT"                   => [  28,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "PI Uncorrectable Error Interrupt Pending" ],
   "XN_CE_INT"                    => [  29,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "XN Correctable Error Interrupt Pending" ],
   "MD_CE_INT"                    => [  30,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "MD Correctable Error Interrupt Pending" ],
   "PI_CE_INT"                    => [  31,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "PI Correctable Error Interrupt Pending" ],
   "BT_HW_INT"                    => [  32,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "BT Hardware Interrupt Pending" ],
   "LB_HW_INT"                    => [  33,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "LB Hardware Interrupt Pending" ],
   "XN_HW_INT"                    => [  34,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "XN Hardware Interrupt Pending" ],
   "MD_HW_INT"                    => [  35,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "MD Hardware Interrupt Pending" ],
   "PI_HW_INT"                    => [  36,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "PI Hardware Interrupt Pending" ],
);

%shub2_01_00199_def =
( NAME    => "SH2_EVENT_OCCURRED",
  ADDRESS => 0x0000000010010000,
  NOTE    => "The EVENT_OCCURRED register contains 31 flags. When a flag is note asserted, it indicates that the associated event has occurred",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00199_flds
);


##########################################################################
#                                                                        #
#   SH2_EVENT_OCCURRED_ALIAS                                             #
#                                                                        #
##########################################################################

%shub2_01_00200_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  43,  21, 0xFFFFF80000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NOTIFICATION_MEMORY_INT3"     => [   1,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "Notification Memory Interrupt 3 Pending" ],
   "NOTIFICATION_MEMORY_INT2"     => [   2,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "Notification Memory Interrupt 2 Pending" ],
   "NOTIFICATION_MEMORY_INT1"     => [   3,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "Notification Memory Interrupt 1 Pending" ],
   "NOTIFICATION_MEMORY_INT0"     => [   4,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "Notification Memory Interrupt 0 Pending" ],
   "BT3_INT"                      => [   5,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "BT Engine 3 Interrupt Pending" ],
   "BT2_INT"                      => [   6,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "BT Engine 2 Interrupt Pending" ],
   "BT1_INT"                      => [   7,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "BT Engine 1 Interrupt Pending" ],
   "BT0_INT"                      => [   8,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "BT Engine 0 Interrupt Pending" ],
   "EXTIO_INT3"                   => [   9,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "EXTIO 3 Interrupt Pending" ],
   "EXTIO_INT2"                   => [  10,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "EXTIO 2 Interrupt Pending" ],
   "L1_TO_ASIC_INT"               => [  11,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "L1 to_Asic Interrupt Pending" ],
   "ASIC_TO_L1_INT"               => [  12,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "Asic to L1 Interrupt Pending" ],
   "EXTIO_INT1"                   => [  13,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "EXTIO 1 Interrupt Pending" ],
   "EXTIO_INT0"                   => [  14,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "EXTIO 0 Interrupt Pending" ],
   "IPI_INT"                      => [  15,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "Inter-processor Interrupt Pending" ],
   "PROFILE_INT"                  => [  16,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "Profile Interrupt Pending" ],
   "RTC3_INT"                     => [  17,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "RTC 3 Interrupt Pending" ],
   "RTC2_INT"                     => [  18,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "RTC 2 Interrupt Pending" ],
   "RTC1_INT"                     => [  19,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "RTC 1 Interrupt Pending" ],
   "RTC0_INT"                     => [  20,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "RTC 0 Interrupt Pending" ],
   "STOP_CLOCK"                   => [  21,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "Stop Clock Interrupt Pending" ],
   "L1_NMI_INT"                   => [  22,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "L1 Controller NMI Interrupt Pending" ],
   "LBI_INT"                      => [  23,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "LBI Interrupt Pending" ],
   "SYSTEM_SHUTDOWN_INT"          => [  24,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "System Shutdown Interrupt Pending" ],
   "RSVD1"                        => [  25,  11,   8, 0x000000000007F800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_UCE_INT"                   => [  26,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "XN Uncorrectable Error Interrupt Pending" ],
   "MD_UCE_INT"                   => [  27,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "MD Uncorrectable Error Interrupt Pending" ],
   "PI_UCE_INT"                   => [  28,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "PI Uncorrectable Error Interrupt Pending" ],
   "XN_CE_INT"                    => [  29,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "XN Correctable Error Interrupt Pending" ],
   "MD_CE_INT"                    => [  30,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "MD Correctable Error Interrupt Pending" ],
   "PI_CE_INT"                    => [  31,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "PI Correctable Error Interrupt Pending" ],
   "BT_HW_INT"                    => [  32,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "BT Hardware Interrupt Pending" ],
   "LB_HW_INT"                    => [  33,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "LB Hardware Interrupt Pending" ],
   "XN_HW_INT"                    => [  34,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "XN Hardware Interrupt Pending" ],
   "MD_HW_INT"                    => [  35,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "MD Hardware Interrupt Pending" ],
   "PI_HW_INT"                    => [  36,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "PI Hardware Interrupt Pending" ],
);

%shub2_01_00200_def =
( NAME    => "SH2_EVENT_OCCURRED_ALIAS",
  ADDRESS => 0x0000000010010008,
  NOTE    => "The EVENT_OCCURRED_ALIAS address is an alias to the EVENT_OCCURRED note register. Refer to the EVENT_OCCURRED register descripti",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00200_flds
);


##########################################################################
#                                                                        #
#   SH2_EVENT_OVERFLOW                                                   #
#                                                                        #
##########################################################################

%shub2_01_00201_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  39,  25, 0xFFFFFF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BT3_INT"                      => [   1,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "BT Engine 3 Interrupt Overflow" ],
   "BT2_INT"                      => [   2,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "BT Engine 2 Interrupt Overflow" ],
   "BT1_INT"                      => [   3,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "BT Engine 1 Interrupt Overflow" ],
   "BT0_INT"                      => [   4,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "BT Engine 0 Interrupt Overflow" ],
   "RSVD1"                        => [   5,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "L1_TO_ASIC_INT"               => [   6,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "L1 to Asic Interrupt Overflow" ],
   "ASIC_TO_L1_INT"               => [   7,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "Asic to L1 Interrupt Overflow" ],
   "RSVD2"                        => [   8,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PROFILE_INT"                  => [   9,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "Profile Interrupt Overflow" ],
   "RTC3_INT"                     => [  10,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "RTC 3 Interrupt Overflow" ],
   "RTC2_INT"                     => [  11,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "RTC 2 Interrupt Overflow" ],
   "RTC1_INT"                     => [  12,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "RTC 1 Interrupt Overflow" ],
   "RTC0_INT"                     => [  13,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "RTC 0 Interrupt Overflow" ],
   "STOP_CLOCK"                   => [  14,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "Stop Clock Interrupt Overflow" ],
   "L1_NMI_INT"                   => [  15,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "L1 Controller NMI Interrupt Overflow" ],
   "LBI_INT"                      => [  16,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "LBI Interrupt Overflow" ],
   "SYSTEM_SHUTDOWN_INT"          => [  17,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "System Shutdown Interrupt Overflow" ],
   "RSVD3"                        => [  18,  11,   8, 0x000000000007F800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_UCE_INT"                   => [  19,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "XN Correctable Error Interrupt Overflow" ],
   "MD_UCE_INT"                   => [  20,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "MD Correctable Error Interrupt Overflow" ],
   "PI_UCE_INT"                   => [  21,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "PI Correctable Error Interrupt Overflow" ],
   "XN_CE_INT"                    => [  22,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "XN Correctable Error Interrupt Overflow" ],
   "MD_CE_INT"                    => [  23,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "MD Correctable Error Interrupt Overflow" ],
   "PI_CE_INT"                    => [  24,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "PI Correctable Error Interrupt Overflow" ],
   "BT_HW_INT"                    => [  25,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "BT Hardware Interrupt Overflow" ],
   "LB_HW_INT"                    => [  26,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "LB Hardware Interrupt Overflow" ],
   "XN_HW_INT"                    => [  27,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "XN Hardware Interrupt Overflow" ],
   "MD_HW_INT"                    => [  28,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "MD Hardware Interrupt Overflow" ],
   "PI_HW_INT"                    => [  29,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "PI Hardware Interrupt Overflow" ],
);

%shub2_01_00201_def =
( NAME    => "SH2_EVENT_OVERFLOW",
  ADDRESS => 0x0000000010010080,
  NOTE    => "The EVENT_OVERFLOW register contains 28 flags. When a flag is note asserted, it indicates that the associated event has occurred",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00201_flds
);


##########################################################################
#                                                                        #
#   SH2_EVENT_OVERFLOW_ALIAS                                             #
#                                                                        #
##########################################################################

%shub2_01_00202_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  39,  25, 0xFFFFFF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BT3_INT"                      => [   1,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "BT Engine 3 Interrupt Overflow" ],
   "BT2_INT"                      => [   2,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "BT Engine 2 Interrupt Overflow" ],
   "BT1_INT"                      => [   3,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "BT Engine 1 Interrupt Overflow" ],
   "BT0_INT"                      => [   4,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "BT Engine 0 Interrupt Overflow" ],
   "RSVD1"                        => [   5,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "L1_TO_ASIC_INT"               => [   6,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "L1 to Asic Interrupt Overflow" ],
   "ASIC_TO_L1_INT"               => [   7,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "Asic to L1 Interrupt Overflow" ],
   "RSVD2"                        => [   8,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PROFILE_INT"                  => [   9,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "Profile Interrupt Overflow" ],
   "RTC3_INT"                     => [  10,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "RTC 3 Interrupt Overflow" ],
   "RTC2_INT"                     => [  11,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "RTC 2 Interrupt Overflow" ],
   "RTC1_INT"                     => [  12,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "RTC 1 Interrupt Overflow" ],
   "RTC0_INT"                     => [  13,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "RTC 0 Interrupt Overflow" ],
   "STOP_CLOCK"                   => [  14,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "Stop Clock Interrupt Overflow" ],
   "L1_NMI_INT"                   => [  15,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "L1 Controller NMI Interrupt Overflow" ],
   "LBI_INT"                      => [  16,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "LBI Interrupt Overflow" ],
   "SYSTEM_SHUTDOWN_INT"          => [  17,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "System Shutdown Interrupt Overflow" ],
   "RSVD3"                        => [  18,  11,   8, 0x000000000007F800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_UCE_INT"                   => [  19,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "XN Correctable Error Interrupt Overflow" ],
   "MD_UCE_INT"                   => [  20,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "MD Correctable Error Interrupt Overflow" ],
   "PI_UCE_INT"                   => [  21,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "PI Correctable Error Interrupt Overflow" ],
   "XN_CE_INT"                    => [  22,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "XN Correctable Error Interrupt Overflow" ],
   "MD_CE_INT"                    => [  23,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "MD Correctable Error Interrupt Overflow" ],
   "PI_CE_INT"                    => [  24,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "PI Correctable Error Interrupt Overflow" ],
   "BT_HW_INT"                    => [  25,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "BT Hardware Interrupt Overflow" ],
   "LB_HW_INT"                    => [  26,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "LB Hardware Interrupt Overflow" ],
   "XN_HW_INT"                    => [  27,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "XN Hardware Interrupt Overflow" ],
   "MD_HW_INT"                    => [  28,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "MD Hardware Interrupt Overflow" ],
   "PI_HW_INT"                    => [  29,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "PI Hardware Interrupt Overflow" ],
);

%shub2_01_00202_def =
( NAME    => "SH2_EVENT_OVERFLOW_ALIAS",
  ADDRESS => 0x0000000010010088,
  NOTE    => "The EVENT_OVERFLOW_ALIAS address is an alias to the EVENT_OVERFLOW note register. Refer to the EVENT_OVERFLOW register descripti",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00202_flds
);


##########################################################################
#                                                                        #
#   SH2_ASIC_TO_L1_DATA                                                  #
#                                                                        #
##########################################################################

%shub2_01_00203_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data" ],
);

%shub2_01_00203_def =
( NAME    => "SH2_ASIC_TO_L1_DATA",
  ADDRESS => 0x0000000010038000,
  NOTE    => "The asic_to_l1_data register contains the data to be transfered to note the L1 controller. This register is used in place of the",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00203_flds
);


##########################################################################
#                                                                        #
#   SH2_ASIC_TO_L1_STATUS                                                #
#                                                                        #
##########################################################################

%shub2_01_00204_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STATUS"                       => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Status, 1 = busy, 0 = idle" ],
);

%shub2_01_00204_def =
( NAME    => "SH2_ASIC_TO_L1_STATUS",
  ADDRESS => 0x0000000010038080,
  NOTE    => "The asic_to_l1_status register contains the status of the asic to note L1 controller data transfer.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00204_flds
);


##########################################################################
#                                                                        #
#   SH2_L1_TO_ASIC_DATA                                                  #
#                                                                        #
##########################################################################

%shub2_01_00205_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data" ],
);

%shub2_01_00205_def =
( NAME    => "SH2_L1_TO_ASIC_DATA",
  ADDRESS => 0x0000000010038100,
  NOTE    => "The l1_to_asic_data register contains the data transfered from the note L1 controller to the asic. This register is used in plac",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00205_flds
);


##########################################################################
#                                                                        #
#   SH2_L1_TO_ASIC_STATUS                                                #
#                                                                        #
##########################################################################

%shub2_01_00206_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STATUS"                       => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Status, 1 = busy, 0 = idle" ],
);

%shub2_01_00206_def =
( NAME    => "SH2_L1_TO_ASIC_STATUS",
  ADDRESS => 0x0000000010038180,
  NOTE    => "The l1_to_asic_status register contains the status of the L1 to note asic data transfer. This register is used in place of the U",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00206_flds
);


##########################################################################
#                                                                        #
#   SH2_RACK_SLOT_DATA                                                   #
#                                                                        #
##########################################################################

%shub2_01_00207_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data" ],
);

%shub2_01_00207_def =
( NAME    => "SH2_RACK_SLOT_DATA",
  ADDRESS => 0x0000000010038200,
  NOTE    => "The rack_slot_data register contains the rack, slot, and partition note information transfered from the L1 controller to the asi",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00207_flds
);


##########################################################################
#                                                                        #
#   SH2_PTC                                                              #
#                                                                        #
##########################################################################

%shub2_01_00208_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "START"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Initiate PTC Sequence" ],
   "RSVD0"                        => [   1,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VPN"                          => [   2,  12,  49, 0x1FFFFFFFFFFFF000, 0x00, 1, 0x0000000000000000, "Virtual Page Number" ],
   "RSVD1"                        => [   3,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PS"                           => [   4,   2,   6, 0x00000000000000FC, 0x00, 1, 0x0000000000000000, "Page Size" ],
   "RSVD2"                        => [   5,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "A"                            => [   6,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Source Instruction" ],
);

%shub2_01_00208_def =
( NAME    => "SH2_PTC",
  ADDRESS => 0x00000000101a0000,
  NOTE    => "The PTC register contains parameters that are passed to the local note PI when the LB generates a SN2NET LPTC message. The PI th",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00208_flds
);


##########################################################################
#                                                                        #
#   SH2_PTC_PARMS                                                        #
#                                                                        #
##########################################################################

%shub2_01_00209_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  36,  28, 0xFFFFFFF000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PTC_TO_VAL"                   => [   1,  24,  12, 0x0000000FFF000000, 0x00, 1, 0x0000000000000000, "PTC Time-out Counter Limit" ],
   "PTC_TO_WRAP"                  => [   2,   0,  24, 0x0000000000FFFFFF, 0x00, 1, 0x0000000000000000, "PTC Time-out Counter Scaling Factor" ],
);

%shub2_01_00209_def =
( NAME    => "SH2_PTC_PARMS",
  ADDRESS => 0x00000000101a0100,
  NOTE    => "The PTC_PARMS register contains time-out parameters that restrict note the length of time that the PI may assert the TND signal ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00209_flds
);


##########################################################################
#                                                                        #
#   SH2_AUTO_REPLY_ENABLE0                                               #
#                                                                        #
##########################################################################

%shub2_01_00210_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE0"                      => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Enable 0" ],
);

%shub2_01_00210_def =
( NAME    => "SH2_AUTO_REPLY_ENABLE0",
  ADDRESS => 0x0000000010062000,
  NOTE    => "The AUTO_REPLY_ENABLE0 register is a configuration registers for note the SHub2's Auto-reply Maintenance Test Facility.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00210_flds
);


##########################################################################
#                                                                        #
#   SH2_AUTO_REPLY_ENABLE1                                               #
#                                                                        #
##########################################################################

%shub2_01_00211_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE1"                      => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Enable 1" ],
);

%shub2_01_00211_def =
( NAME    => "SH2_AUTO_REPLY_ENABLE1",
  ADDRESS => 0x0000000010062080,
  NOTE    => "The AUTO_REPLY_ENABLE1 register is a configuration registers for note the SHub2's Auto-reply Maintenance Test Facility.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00211_flds
);


##########################################################################
#                                                                        #
#   SH2_AUTO_REPLY_HEADER0                                               #
#                                                                        #
##########################################################################

%shub2_01_00212_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER0"                      => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Header 0" ],
);

%shub2_01_00212_def =
( NAME    => "SH2_AUTO_REPLY_HEADER0",
  ADDRESS => 0x0000000010062100,
  NOTE    => "The AUTO_REPLY_HEADER0 register is a configuration registers for note the SHub2's Auto-reply Maintenance Test Facility. It conta",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00212_flds
);


##########################################################################
#                                                                        #
#   SH2_AUTO_REPLY_HEADER1                                               #
#                                                                        #
##########################################################################

%shub2_01_00213_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER1"                      => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Header 1" ],
);

%shub2_01_00213_def =
( NAME    => "SH2_AUTO_REPLY_HEADER1",
  ADDRESS => 0x0000000010062180,
  NOTE    => "The AUTO_REPLY_HEADER1 register is a configuration registers for note the SHub2's Auto-reply Maintenance Test Facility. It conta",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00213_flds
);


##########################################################################
#                                                                        #
#   SH2_ENABLE_RP_AUTO_REPLY                                             #
#                                                                        #
##########################################################################

%shub2_01_00214_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE"                       => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable Reply Auto Reply" ],
);

%shub2_01_00214_def =
( NAME    => "SH2_ENABLE_RP_AUTO_REPLY",
  ADDRESS => 0x0000000010062200,
  NOTE    => "The ENABLE_RP_AUTO_REPLY register is a configuration registers for note the SHub2's Auto-reply Maintenance Test Facility. When t",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00214_flds
);


##########################################################################
#                                                                        #
#   SH2_ENABLE_RQ_AUTO_REPLY                                             #
#                                                                        #
##########################################################################

%shub2_01_00215_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE"                       => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable Request Auto Reply" ],
);

%shub2_01_00215_def =
( NAME    => "SH2_ENABLE_RQ_AUTO_REPLY",
  ADDRESS => 0x0000000010062280,
  NOTE    => "The automated reply feature is a maintenance feature that allows note the local block to generate a reply packet for a specific ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00215_flds
);


##########################################################################
#                                                                        #
#   SH2_REDIRECT_INVAL                                                   #
#                                                                        #
##########################################################################

%shub2_01_00216_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REDIRECT"                     => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Redirect LINVV Messages Generated by the LB" ],
);

%shub2_01_00216_def =
( NAME    => "SH2_REDIRECT_INVAL",
  ADDRESS => 0x0000000010062300,
  NOTE    => "The REDIRECT_INVAL register determines the destination chiplet ID note in LINVV messages generated by the LB. Normally, when the",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00216_flds
);


##########################################################################
#                                                                        #
#   SH2_DIAG_MSG_CNTRL                                                   #
#                                                                        #
##########################################################################

%shub2_01_00217_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "BUSY"                         => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Diagnostic Message Facility is Busy" ],
   "START"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Start" ],
   "RSVD0"                        => [   2,  16,  46, 0x3FFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SUPPRESS_HEADER_ENABLE"       => [   3,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Enable suppressing the header field" ],
   "EXTRA_HEADER_FLAG_ENABLE"     => [   4,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Enable extra header flag" ],
   "PORT"                         => [   5,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Virtual Channel Code" ],
   "ERROR_INJECT_ENABLE"          => [   6,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Enable ERROR_INJECT_POINT field" ],
   "ERROR_INJECT_POINT"           => [   7,   6,   6, 0x0000000000000FC0, 0x00, 0, 0x0000000000000000, "Micropacket Targeted for Error Injection" ],
   "MSG_LENGTH"                   => [   8,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "Message data payload length, 0 - 63" ],
);

%shub2_01_00217_def =
( NAME    => "SH2_DIAG_MSG_CNTRL",
  ADDRESS => 0x0000000010063000,
  NOTE    => "The DIAG_MSG_CNTRL register provides the facility for initiating note the transmission of a diagnostic message onto the SN2 netw",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00217_flds
);


##########################################################################
#                                                                        #
#   SH2_DIAG_MSG_DATA0L                                                  #
#                                                                        #
##########################################################################

%shub2_01_00218_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_LOWER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "2nd Micropacket, Lower 64 Bits" ],
);

%shub2_01_00218_def =
( NAME    => "SH2_DIAG_MSG_DATA0L",
  ADDRESS => 0x0000000010063080,
  NOTE    => "When a diagnostic message consists of 2 or more micropackets, the note DIAG_MSG_DATA0L register's DATA_LOWER field contains the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00218_flds
);


##########################################################################
#                                                                        #
#   SH2_DIAG_MSG_DATA0U                                                  #
#                                                                        #
##########################################################################

%shub2_01_00219_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_UPPER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "2nd Micropacket, Upper 64 Bits" ],
);

%shub2_01_00219_def =
( NAME    => "SH2_DIAG_MSG_DATA0U",
  ADDRESS => 0x0000000010063100,
  NOTE    => "When a diagnostic message consists of 2 or more micropackets, the note DIAG_MSG_DATA0U register's DATA_UPPER field contains the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00219_flds
);


##########################################################################
#                                                                        #
#   SH2_DIAG_MSG_DATA1L                                                  #
#                                                                        #
##########################################################################

%shub2_01_00220_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_LOWER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "3rd Micropacket, Lower 64 Bits" ],
);

%shub2_01_00220_def =
( NAME    => "SH2_DIAG_MSG_DATA1L",
  ADDRESS => 0x0000000010063180,
  NOTE    => "When a diagnostic message consists of 3 or more micropackets, the note DIAG_MSG_DATA1L register's DATA_LOWER field contains the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00220_flds
);


##########################################################################
#                                                                        #
#   SH2_DIAG_MSG_DATA1U                                                  #
#                                                                        #
##########################################################################

%shub2_01_00221_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_UPPER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "3rd Micropacket, Upper 64 Bits" ],
);

%shub2_01_00221_def =
( NAME    => "SH2_DIAG_MSG_DATA1U",
  ADDRESS => 0x0000000010063200,
  NOTE    => "When a diagnostic message consists of 3 or more micropackets, the note DIAG_MSG_DATA1U register's DATA_UPPER field contains the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00221_flds
);


##########################################################################
#                                                                        #
#   SH2_DIAG_MSG_DATA2L                                                  #
#                                                                        #
##########################################################################

%shub2_01_00222_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_LOWER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "4th Micropacket, Lower 64 Bits" ],
);

%shub2_01_00222_def =
( NAME    => "SH2_DIAG_MSG_DATA2L",
  ADDRESS => 0x0000000010063280,
  NOTE    => "When a diagnostic message consists of 4 or more micropackets, the note DIAG_MSG_DATA2L register's DATA_LOWER field contains the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00222_flds
);


##########################################################################
#                                                                        #
#   SH2_DIAG_MSG_DATA2U                                                  #
#                                                                        #
##########################################################################

%shub2_01_00223_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_UPPER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "4th Micropacket, Upper 64 Bits" ],
);

%shub2_01_00223_def =
( NAME    => "SH2_DIAG_MSG_DATA2U",
  ADDRESS => 0x0000000010063300,
  NOTE    => "When a diagnostic message consists of 4 or more micropackets, the note DIAG_MSG_DATA2U register's DATA_UPPER field contains the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00223_flds
);


##########################################################################
#                                                                        #
#   SH2_DIAG_MSG_DATA3L                                                  #
#                                                                        #
##########################################################################

%shub2_01_00224_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_LOWER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "5th Micropacket, Lower 64 Bits" ],
);

%shub2_01_00224_def =
( NAME    => "SH2_DIAG_MSG_DATA3L",
  ADDRESS => 0x0000000010063380,
  NOTE    => "When a diagnostic message consists of 5 or more micropackets, the note DIAG_MSG_DATA3L register's DATA_LOWER field contains the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00224_flds
);


##########################################################################
#                                                                        #
#   SH2_DIAG_MSG_DATA3U                                                  #
#                                                                        #
##########################################################################

%shub2_01_00225_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_UPPER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "5th Micropacket, Upper 64 Bits" ],
);

%shub2_01_00225_def =
( NAME    => "SH2_DIAG_MSG_DATA3U",
  ADDRESS => 0x0000000010063400,
  NOTE    => "When a diagnostic message consists of 5 or more micropackets, the note DIAG_MSG_DATA3U register's DATA_UPPER field contains the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00225_flds
);


##########################################################################
#                                                                        #
#   SH2_DIAG_MSG_DATA4L                                                  #
#                                                                        #
##########################################################################

%shub2_01_00226_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_LOWER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "6th Micropacket, Lower 64 Bits" ],
);

%shub2_01_00226_def =
( NAME    => "SH2_DIAG_MSG_DATA4L",
  ADDRESS => 0x0000000010063480,
  NOTE    => "When a diagnostic message consists of 6 or more micropackets, the note DIAG_MSG_DATA4L register's DATA_LOWER field contains the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00226_flds
);


##########################################################################
#                                                                        #
#   SH2_DIAG_MSG_DATA4U                                                  #
#                                                                        #
##########################################################################

%shub2_01_00227_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_UPPER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "6th Micropacket, Upper 64 Bits" ],
);

%shub2_01_00227_def =
( NAME    => "SH2_DIAG_MSG_DATA4U",
  ADDRESS => 0x0000000010063500,
  NOTE    => "When a diagnostic message consists of 6 or more micropackets, the note DIAG_MSG_DATA4U register's DATA_UPPER field contains the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00227_flds
);


##########################################################################
#                                                                        #
#   SH2_DIAG_MSG_DATA5L                                                  #
#                                                                        #
##########################################################################

%shub2_01_00228_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_LOWER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "7th Micropacket, Lower 64 Bits" ],
);

%shub2_01_00228_def =
( NAME    => "SH2_DIAG_MSG_DATA5L",
  ADDRESS => 0x0000000010063580,
  NOTE    => "When a diagnostic message consists of 7 or more micropackets, the note DIAG_MSG_DATA5L register's DATA_LOWER field contains the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00228_flds
);


##########################################################################
#                                                                        #
#   SH2_DIAG_MSG_DATA5U                                                  #
#                                                                        #
##########################################################################

%shub2_01_00229_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_UPPER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "7th Micropacket, Upper 64 Bits" ],
);

%shub2_01_00229_def =
( NAME    => "SH2_DIAG_MSG_DATA5U",
  ADDRESS => 0x0000000010063600,
  NOTE    => "When a diagnostic message consists of 7 or more micropackets, the note DIAG_MSG_DATA5U register's DATA_UPPER field contains the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00229_flds
);


##########################################################################
#                                                                        #
#   SH2_DIAG_MSG_DATA6L                                                  #
#                                                                        #
##########################################################################

%shub2_01_00230_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_LOWER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "8th Micropacket, Lower 64 Bits" ],
);

%shub2_01_00230_def =
( NAME    => "SH2_DIAG_MSG_DATA6L",
  ADDRESS => 0x0000000010063680,
  NOTE    => "When a diagnostic message consists of 8 or more micropackets, the note DIAG_MSG_DATA6L register's DATA_LOWER field contains the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00230_flds
);


##########################################################################
#                                                                        #
#   SH2_DIAG_MSG_DATA6U                                                  #
#                                                                        #
##########################################################################

%shub2_01_00231_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_UPPER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "8th Micropacket, Upper 64 Bits" ],
);

%shub2_01_00231_def =
( NAME    => "SH2_DIAG_MSG_DATA6U",
  ADDRESS => 0x0000000010063700,
  NOTE    => "When a diagnostic message consists of 8 or more micropackets, the note DIAG_MSG_DATA6U register's DATA_UPPER field contains the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00231_flds
);


##########################################################################
#                                                                        #
#   SH2_DIAG_MSG_DATA7L                                                  #
#                                                                        #
##########################################################################

%shub2_01_00232_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_LOWER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "9th Micropacket, Lower 64 Bits" ],
);

%shub2_01_00232_def =
( NAME    => "SH2_DIAG_MSG_DATA7L",
  ADDRESS => 0x0000000010063780,
  NOTE    => "When a diagnostic message consists of 9 or more micropackets, the note DIAG_MSG_DATA7L register's DATA_LOWER field contains the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00232_flds
);


##########################################################################
#                                                                        #
#   SH2_DIAG_MSG_DATA7U                                                  #
#                                                                        #
##########################################################################

%shub2_01_00233_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_UPPER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "9th Micropacket, Upper 64 Bits" ],
);

%shub2_01_00233_def =
( NAME    => "SH2_DIAG_MSG_DATA7U",
  ADDRESS => 0x0000000010063800,
  NOTE    => "When a diagnostic message consists of 9 or more micropackets, the note DIAG_MSG_DATA7U register's DATA_UPPER field contains the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00233_flds
);


##########################################################################
#                                                                        #
#   SH2_DIAG_MSG_DATA8L                                                  #
#                                                                        #
##########################################################################

%shub2_01_00234_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_LOWER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "10th Micropacket, Lower 64 Bits" ],
);

%shub2_01_00234_def =
( NAME    => "SH2_DIAG_MSG_DATA8L",
  ADDRESS => 0x0000000010063880,
  NOTE    => "When a diagnostic message consists of 10 or more micropackets, the note DIAG_MSG_DATA8L register's DATA_LOWER field contains the",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00234_flds
);


##########################################################################
#                                                                        #
#   SH2_DIAG_MSG_DATA8U                                                  #
#                                                                        #
##########################################################################

%shub2_01_00235_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_UPPER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "10th Micropacket, Upper 64 Bits" ],
);

%shub2_01_00235_def =
( NAME    => "SH2_DIAG_MSG_DATA8U",
  ADDRESS => 0x0000000010063900,
  NOTE    => "When a diagnostic message consists of 10 or more micropackets, the note DIAG_MSG_DATA8U register's DATA_UPPER field contains the",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00235_flds
);


##########################################################################
#                                                                        #
#   SH2_DIAG_MSG_HDR0                                                    #
#                                                                        #
##########################################################################

%shub2_01_00236_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER0"                      => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "1st Micropacket, Lower 64 Bits" ],
);

%shub2_01_00236_def =
( NAME    => "SH2_DIAG_MSG_HDR0",
  ADDRESS => 0x0000000010063980,
  NOTE    => "The DIAG_MSG_HDR0 register's HEADER0 field contains the header note payload transmitted in the lower 64 bits of the 1st micropac",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00236_flds
);


##########################################################################
#                                                                        #
#   SH2_DIAG_MSG_HDR1                                                    #
#                                                                        #
##########################################################################

%shub2_01_00237_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER1"                      => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "1st Micropacket, Upper 64 Bits" ],
);

%shub2_01_00237_def =
( NAME    => "SH2_DIAG_MSG_HDR1",
  ADDRESS => 0x0000000010063a00,
  NOTE    => "The DIAG_MSG_HDR1 register's HEADER1 field contains the header note payload transmitted in the upper 64 bits of the 1st micropac",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00237_flds
);


##########################################################################
#                                                                        #
#   SH2_DEBUG_SELECT                                                     #
#                                                                        #
##########################################################################

%shub2_01_00238_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COMPARE_ENABLE"               => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Enable compare on bit 32 of Analyzer data" ],
   "GROUP_SELECT_7"               => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Group select 7" ],
   "RSVD0"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_7"               => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Field select 7" ],
   "RSVD1"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_6"               => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Group select 6" ],
   "RSVD2"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_6"               => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Field select 6" ],
   "RSVD3"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_5"               => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Group select 5" ],
   "RSVD4"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_5"               => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Field select 5" ],
   "RSVD5"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_4"               => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Group select 4" ],
   "RSVD6"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_4"               => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Field select 4" ],
   "RSVD7"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_3"               => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Group select 3" ],
   "RSVD8"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_3"               => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Field select 3" ],
   "RSVD9"                        => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_2"               => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Group select 2" ],
   "RSVD10"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_2"               => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Field select 2" ],
   "RSVD11"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_1"               => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Group select 1" ],
   "RSVD12"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_1"               => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Field select 1" ],
   "RSVD13"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_0"               => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Group select 0" ],
   "RSVD14"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_0"               => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Field select 0" ],
);

%shub2_01_00238_def =
( NAME    => "SH2_DEBUG_SELECT",
  ADDRESS => 0x0000000010064000,
  NOTE    => "The sh2_debug_select register controls the top level debug mux for note the SHub2 debug data. The group_select fields selects on",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00238_flds
);


##########################################################################
#                                                                        #
#   SH2_COMPARE_COMPARE_MASK                                             #
#                                                                        #
##########################################################################

%shub2_01_00239_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MASK"                         => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "SHub2 Debug Compare Mask" ],
);

%shub2_01_00239_def =
( NAME    => "SH2_COMPARE_COMPARE_MASK",
  ADDRESS => 0x0000000010064080,
  NOTE    => "SHub2 Debug Compare Mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00239_flds
);


##########################################################################
#                                                                        #
#   SH2_COMPARE_COMPARE_PATTERN                                          #
#                                                                        #
##########################################################################

%shub2_01_00240_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA"                         => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "SHub2 Debug Compare Pattern" ],
);

%shub2_01_00240_def =
( NAME    => "SH2_COMPARE_COMPARE_PATTERN",
  ADDRESS => 0x0000000010064100,
  NOTE    => "SHub2 Debug Compare Pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00240_flds
);


##########################################################################
#                                                                        #
#   SH2_COMPARE_SEL                                                      #
#                                                                        #
##########################################################################

%shub2_01_00241_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_7"               => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_7"               => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 input select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_6"               => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_6"               => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 input select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_5"               => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_5"               => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 input select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_4"               => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_4"               => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 input select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_3"               => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_3"               => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 input select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_2"               => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_2"               => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 input select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_1"               => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_1"               => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 input select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_0"               => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_0"               => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 input select" ],
);

%shub2_01_00241_def =
( NAME    => "SH2_COMPARE_SEL",
  ADDRESS => 0x0000000010064180,
  NOTE    => "The sh2_compare_sel register controls the compare mux in the top note level SHub2 debug mux. The output of the compare mux is co",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00241_flds
);


##########################################################################
#                                                                        #
#   SH2_OB_LA_CONTROL                                                    #
#                                                                        #
##########################################################################

%shub2_01_00242_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RESET"                        => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Reset Logic Analyzer Buffer" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   3,  16,  14, 0x000000003FFF0000, 0x00, 1, 0x0000000000000000, "Node ID" ],
   "RSVD2"                        => [   4,   4,  12, 0x000000000000FFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRAP_MEM"                     => [   5,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Memory wrap control" ],
   "WRAP_BUFF"                    => [   6,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Buffer wrap control" ],
   "WRITE_MEM"                    => [   7,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Write memory control" ],
   "WRITE_BUFF"                   => [   8,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Write buffer control" ],
);

%shub2_01_00242_def =
( NAME    => "SH2_OB_LA_CONTROL",
  ADDRESS => 0x0000000010064200,
  NOTE    => "The OB_LA_CONTROL register controls writing to the on board logic note analyzer buffer and writting that buffer to memory.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00242_flds
);


##########################################################################
#                                                                        #
#   SH2_OB_LA_START_CONTROL                                              #
#                                                                        #
##########################################################################

%shub2_01_00243_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  10,  54, 0xFFFFFFFFFFFFFC00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WORD_MODE"                    => [   1,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Word mode select" ],
   "TRIGGER"                      => [   2,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Start control trigger select" ],
   "SOURCE"                       => [   3,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Start control source select" ],
   "POLARITY"                     => [   4,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Polarity of start stimulus" ],
   "RSVD1"                        => [   5,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SELECT"                       => [   6,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Start control select bits" ],
);

%shub2_01_00243_def =
( NAME    => "SH2_OB_LA_START_CONTROL",
  ADDRESS => 0x0000000010064280,
  NOTE    => "The OB_LA_START_CONTROL register controls starting recording of the note on board logic analzyer.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00243_flds
);


##########################################################################
#                                                                        #
#   SH2_OB_LA_STOP_CONTROL                                               #
#                                                                        #
##########################################################################

%shub2_01_00244_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER"                      => [   1,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Stop control trigger select" ],
   "SOURCE"                       => [   2,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Stop control source select" ],
   "POLARITY"                     => [   3,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Polarity of stop stimulus" ],
   "RSVD1"                        => [   4,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SELECT"                       => [   5,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Stop control select bits" ],
);

%shub2_01_00244_def =
( NAME    => "SH2_OB_LA_STOP_CONTROL",
  ADDRESS => 0x0000000010064300,
  NOTE    => "The OB_LA_STOP_CONTROL register controls stopping recording of the note on board logic analzyer.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00244_flds
);


##########################################################################
#                                                                        #
#   SH2_OB_LA_START_ADDRESS                                              #
#                                                                        #
##########################################################################

%shub2_01_00245_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDRESS"                      => [   1,   7,  31, 0x0000003FFFFFFF80, 0x00, 1, 0x0000000000000000, "Starting address bits 7 - 37" ],
);

%shub2_01_00245_def =
( NAME    => "SH2_OB_LA_START_ADDRESS",
  ADDRESS => 0x0000000010064380,
  NOTE    => "The OB_LA_START_ADDRESS register contains the starting address for note storing the on board logic analyzer data in memory. This",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00245_flds
);


##########################################################################
#                                                                        #
#   SH2_OB_LA_END_ADDRESS                                                #
#                                                                        #
##########################################################################

%shub2_01_00246_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDRESS"                      => [   1,   7,  31, 0x0000003FFFFFFF80, 0x00, 1, 0x0000000000000000, "Ending address bits 7 - 37" ],
);

%shub2_01_00246_def =
( NAME    => "SH2_OB_LA_END_ADDRESS",
  ADDRESS => 0x0000000010064400,
  NOTE    => "The OB_LA_END_ADDRESS register contains the ending address for note storing the on board logic analyzer data in memory. This is ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00246_flds
);


##########################################################################
#                                                                        #
#   SH2_DEBUG_PORT_CONFIG                                                #
#                                                                        #
##########################################################################

%shub2_01_00247_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EN"                           => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Enable" ],
);

%shub2_01_00247_def =
( NAME    => "SH2_DEBUG_PORT_CONFIG",
  ADDRESS => 0x0000000010064600,
  NOTE    => "The DEBUG_PORT_CONFIG register. This MMR is used in selecting the note data rate on the debug port.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00247_flds
);


##########################################################################
#                                                                        #
#   SH2_STOP_CLK_CONTROL                                                 #
#                                                                        #
##########################################################################

%shub2_01_00248_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE"                       => [   1,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Clock stop enable (0-disabled, 1-enabled)" ],
   "MODE"                         => [   2,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Counter mode select (0-external, 1-internal)" ],
   "POLARITY"                     => [   3,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Counter polarity select (0-negative edge, 1-positive edge)" ],
   "EVENT"                        => [   4,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Counter event select (0-greater than, 1-equal)" ],
   "STIMULUS"                     => [   5,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Counter stimulus" ],
);

%shub2_01_00248_def =
( NAME    => "SH2_STOP_CLK_CONTROL",
  ADDRESS => 0x0000000010065000,
  NOTE    => "The stop clock facility is a means of precisely stopping the clocks note on the SHub2. Alternatively it can be used to send an i",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00248_flds
);


##########################################################################
#                                                                        #
#   SH2_STOP_CLK_DELAY_PHASE                                             #
#                                                                        #
##########################################################################

%shub2_01_00249_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DELAY"                        => [   1,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Delay phase" ],
);

%shub2_01_00249_def =
( NAME    => "SH2_STOP_CLK_DELAY_PHASE",
  ADDRESS => 0x0000000010065080,
  NOTE    => "Stop Clock Delay Phase",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00249_flds
);


##########################################################################
#                                                                        #
#   SH2_TSF_ARM_MASK                                                     #
#                                                                        #
##########################################################################

%shub2_01_00250_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility arm mask" ],
);

%shub2_01_00250_def =
( NAME    => "SH2_TSF_ARM_MASK",
  ADDRESS => 0x0000000010066000,
  NOTE    => "Trigger sequencing facility arm mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00250_flds
);


##########################################################################
#                                                                        #
#   SH2_TSF_COUNTER_PRESETS                                              #
#                                                                        #
##########################################################################

%shub2_01_00251_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COUNT_8A"                     => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 8a" ],
   "COUNT_8B"                     => [   1,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 8b" ],
   "COUNT_16"                     => [   2,  32,  16, 0x0000FFFF00000000, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 16" ],
   "COUNT_32"                     => [   3,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 32" ],
);

%shub2_01_00251_def =
( NAME    => "SH2_TSF_COUNTER_PRESETS",
  ADDRESS => 0x0000000010066080,
  NOTE    => "The sh2_tsf_counter_presets register contains the initial values note for the trigger sequencing facility down counters.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00251_flds
);


##########################################################################
#                                                                        #
#   SH2_TSF_DECREMENT_CTL                                                #
#                                                                        #
##########################################################################

%shub2_01_00252_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CTL"                          => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter decrement control" ],
);

%shub2_01_00252_def =
( NAME    => "SH2_TSF_DECREMENT_CTL",
  ADDRESS => 0x0000000010066100,
  NOTE    => "Trigger sequencing facility counter decrement control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00252_flds
);


##########################################################################
#                                                                        #
#   SH2_TSF_DIAG_MSG_CTL                                                 #
#                                                                        #
##########################################################################

%shub2_01_00253_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE"                       => [   1,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Trigger sequencing facility diagnostic message control" ],
);

%shub2_01_00253_def =
( NAME    => "SH2_TSF_DIAG_MSG_CTL",
  ADDRESS => 0x0000000010066180,
  NOTE    => "Trigger sequencing facility diagnostic message control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00253_flds
);


##########################################################################
#                                                                        #
#   SH2_TSF_DISARM_MASK                                                  #
#                                                                        #
##########################################################################

%shub2_01_00254_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility disarm mask" ],
);

%shub2_01_00254_def =
( NAME    => "SH2_TSF_DISARM_MASK",
  ADDRESS => 0x0000000010066200,
  NOTE    => "Trigger sequencing facility disarm mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00254_flds
);


##########################################################################
#                                                                        #
#   SH2_TSF_ENABLE_CTL                                                   #
#                                                                        #
##########################################################################

%shub2_01_00255_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CTL"                          => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter enable control" ],
);

%shub2_01_00255_def =
( NAME    => "SH2_TSF_ENABLE_CTL",
  ADDRESS => 0x0000000010066280,
  NOTE    => "Trigger sequencing facility counter enable control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00255_flds
);


##########################################################################
#                                                                        #
#   SH2_TSF_SOFTWARE_ARM                                                 #
#                                                                        #
##########################################################################

%shub2_01_00256_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BIT7"                         => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm bit 7" ],
   "BIT6"                         => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm bit 6" ],
   "BIT5"                         => [   3,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm bit 5" ],
   "BIT4"                         => [   4,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm bit 4" ],
   "BIT3"                         => [   5,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm bit 3" ],
   "BIT2"                         => [   6,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm bit 2" ],
   "BIT1"                         => [   7,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm bit 1" ],
   "BIT0"                         => [   8,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm bit 0" ],
);

%shub2_01_00256_def =
( NAME    => "SH2_TSF_SOFTWARE_ARM",
  ADDRESS => 0x0000000010066300,
  NOTE    => "The sh2_tsf_software_arm register provides software with a means to note arm any of the trigger sequencing variables. Writing a ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00256_flds
);


##########################################################################
#                                                                        #
#   SH2_TSF_SOFTWARE_DISARM                                              #
#                                                                        #
##########################################################################

%shub2_01_00257_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BIT7"                         => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 7" ],
   "BIT6"                         => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 6" ],
   "BIT5"                         => [   3,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 5" ],
   "BIT4"                         => [   4,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 4" ],
   "BIT3"                         => [   5,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 3" ],
   "BIT2"                         => [   6,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 2" ],
   "BIT1"                         => [   7,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 1" ],
   "BIT0"                         => [   8,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 0" ],
);

%shub2_01_00257_def =
( NAME    => "SH2_TSF_SOFTWARE_DISARM",
  ADDRESS => 0x0000000010066380,
  NOTE    => "The sh2_tsf_software_disarm register provides software with a means note to disarm any of the trigger sequencing variables. Writ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00257_flds
);


##########################################################################
#                                                                        #
#   SH2_TSF_SOFTWARE_TRIGGERED                                           #
#                                                                        #
##########################################################################

%shub2_01_00258_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BIT7"                         => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 7" ],
   "BIT6"                         => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 6" ],
   "BIT5"                         => [   3,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 5" ],
   "BIT4"                         => [   4,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 4" ],
   "BIT3"                         => [   5,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 3" ],
   "BIT2"                         => [   6,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 2" ],
   "BIT1"                         => [   7,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 1" ],
   "BIT0"                         => [   8,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 0" ],
);

%shub2_01_00258_def =
( NAME    => "SH2_TSF_SOFTWARE_TRIGGERED",
  ADDRESS => 0x0000000010066400,
  NOTE    => "The sh2_tsf_software_triggered register provides software with a note means to trigger any of the trigger sequencing variables. ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00258_flds
);


##########################################################################
#                                                                        #
#   SH2_TSF_TRIGGER_MASK                                                 #
#                                                                        #
##########################################################################

%shub2_01_00259_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility trigger mask" ],
);

%shub2_01_00259_def =
( NAME    => "SH2_TSF_TRIGGER_MASK",
  ADDRESS => 0x0000000010066480,
  NOTE    => "The sh2_tsf_trigger_mask is used to enable an auxiliary trigger note compare to trigger a particular trigger sequencing variable",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00259_flds
);


##########################################################################
#                                                                        #
#   SH2_TSF_COMPARE0                                                     #
#                                                                        #
##########################################################################

%shub2_01_00260_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Enable bits for TSF compare" ],
   "EXPECTED_DATA"                => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data for TSF compare" ],
);

%shub2_01_00260_def =
( NAME    => "SH2_TSF_COMPARE0",
  ADDRESS => 0x0000000010066500,
  NOTE    => "The sh2_tsf_compare registers are used to compare trigger data note against a data pattern and an enable. The results of the com",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00260_flds
);


##########################################################################
#                                                                        #
#   SH2_TSF_COMPARE1                                                     #
#                                                                        #
##########################################################################

%shub2_01_00261_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Enable bits for TSF compare" ],
   "EXPECTED_DATA"                => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data for TSF compare" ],
);

%shub2_01_00261_def =
( NAME    => "SH2_TSF_COMPARE1",
  ADDRESS => 0x0000000010066580,
  NOTE    => "The sh2_tsf_compare registers are used to compare trigger data note against a data pattern and an enable. The results of the com",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00261_flds
);


##########################################################################
#                                                                        #
#   SH2_TSF_COMPARE2                                                     #
#                                                                        #
##########################################################################

%shub2_01_00262_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Enable bits for TSF compare" ],
   "EXPECTED_DATA"                => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data for TSF compare" ],
);

%shub2_01_00262_def =
( NAME    => "SH2_TSF_COMPARE2",
  ADDRESS => 0x0000000010066600,
  NOTE    => "The sh2_tsf_compare registers are used to compare trigger data note against a data pattern and an enable. The results of the com",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00262_flds
);


##########################################################################
#                                                                        #
#   SH2_TSF_COMPARE3                                                     #
#                                                                        #
##########################################################################

%shub2_01_00263_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Enable bits for TSF compare" ],
   "EXPECTED_DATA"                => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data for TSF compare" ],
);

%shub2_01_00263_def =
( NAME    => "SH2_TSF_COMPARE3",
  ADDRESS => 0x0000000010066680,
  NOTE    => "The sh2_tsf_compare registers are used to compare trigger data note against a data pattern and an enable. The results of the com",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00263_flds
);


##########################################################################
#                                                                        #
#   SH2_TSF_COMPARE4                                                     #
#                                                                        #
##########################################################################

%shub2_01_00264_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Enable bits for TSF compare" ],
   "EXPECTED_DATA"                => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data for TSF compare" ],
);

%shub2_01_00264_def =
( NAME    => "SH2_TSF_COMPARE4",
  ADDRESS => 0x0000000010066700,
  NOTE    => "The sh2_tsf_compare registers are used to compare trigger data note against a data pattern and an enable. The results of the com",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00264_flds
);


##########################################################################
#                                                                        #
#   SH2_TSF_COMPARE5                                                     #
#                                                                        #
##########################################################################

%shub2_01_00265_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Enable bits for TSF compare" ],
   "EXPECTED_DATA"                => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data for TSF compare" ],
);

%shub2_01_00265_def =
( NAME    => "SH2_TSF_COMPARE5",
  ADDRESS => 0x0000000010066780,
  NOTE    => "The sh2_tsf_compare registers are used to compare trigger data note against a data pattern and an enable. The results of the com",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00265_flds
);


##########################################################################
#                                                                        #
#   SH2_TSF_COMPARE6                                                     #
#                                                                        #
##########################################################################

%shub2_01_00266_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Enable bits for TSF compare" ],
   "EXPECTED_DATA"                => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data for TSF compare" ],
);

%shub2_01_00266_def =
( NAME    => "SH2_TSF_COMPARE6",
  ADDRESS => 0x0000000010066800,
  NOTE    => "The sh2_tsf_compare registers are used to compare trigger data note against a data pattern and an enable. The results of the com",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00266_flds
);


##########################################################################
#                                                                        #
#   SH2_TSF_COMPARE7                                                     #
#                                                                        #
##########################################################################

%shub2_01_00267_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Enable bits for TSF compare" ],
   "EXPECTED_DATA"                => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data for TSF compare" ],
);

%shub2_01_00267_def =
( NAME    => "SH2_TSF_COMPARE7",
  ADDRESS => 0x0000000010066880,
  NOTE    => "The sh2_tsf_compare registers are used to compare trigger data note against a data pattern and an enable. The results of the com",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00267_flds
);


##########################################################################
#                                                                        #
#   SH2_TSF_COMPARE8                                                     #
#                                                                        #
##########################################################################

%shub2_01_00268_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Enable bits for TSF compare" ],
   "EXPECTED_DATA"                => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data for TSF compare" ],
);

%shub2_01_00268_def =
( NAME    => "SH2_TSF_COMPARE8",
  ADDRESS => 0x0000000010066900,
  NOTE    => "The sh2_tsf_compare registers are used to compare trigger data note against a data pattern and an enable. The results of the com",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00268_flds
);


##########################################################################
#                                                                        #
#   SH2_TSF_COMPARE9                                                     #
#                                                                        #
##########################################################################

%shub2_01_00269_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Enable bits for TSF compare" ],
   "EXPECTED_DATA"                => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data for TSF compare" ],
);

%shub2_01_00269_def =
( NAME    => "SH2_TSF_COMPARE9",
  ADDRESS => 0x0000000010066980,
  NOTE    => "The sh2_tsf_compare registers are used to compare trigger data note against a data pattern and an enable. The results of the com",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00269_flds
);


##########################################################################
#                                                                        #
#   SH2_TSF_COMPARE10                                                    #
#                                                                        #
##########################################################################

%shub2_01_00270_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Enable bits for TSF compare" ],
   "EXPECTED_DATA"                => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data for TSF compare" ],
);

%shub2_01_00270_def =
( NAME    => "SH2_TSF_COMPARE10",
  ADDRESS => 0x0000000010066a00,
  NOTE    => "The sh2_tsf_compare registers are used to compare trigger data note against a data pattern and an enable. The results of the com",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00270_flds
);


##########################################################################
#                                                                        #
#   SH2_TSF_COMPARE11                                                    #
#                                                                        #
##########################################################################

%shub2_01_00271_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Enable bits for TSF compare" ],
   "EXPECTED_DATA"                => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data for TSF compare" ],
);

%shub2_01_00271_def =
( NAME    => "SH2_TSF_COMPARE11",
  ADDRESS => 0x0000000010066a80,
  NOTE    => "The sh2_tsf_compare registers are used to compare trigger data note against a data pattern and an enable. The results of the com",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00271_flds
);


##########################################################################
#                                                                        #
#   SH2_TSF_COMPARE12                                                    #
#                                                                        #
##########################################################################

%shub2_01_00272_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Enable bits for TSF compare" ],
   "EXPECTED_DATA"                => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data for TSF compare" ],
);

%shub2_01_00272_def =
( NAME    => "SH2_TSF_COMPARE12",
  ADDRESS => 0x0000000010066b00,
  NOTE    => "The sh2_tsf_compare registers are used to compare trigger data note against a data pattern and an enable. The results of the com",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00272_flds
);


##########################################################################
#                                                                        #
#   SH2_TSF_COMPARE13                                                    #
#                                                                        #
##########################################################################

%shub2_01_00273_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Enable bits for TSF compare" ],
   "EXPECTED_DATA"                => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data for TSF compare" ],
);

%shub2_01_00273_def =
( NAME    => "SH2_TSF_COMPARE13",
  ADDRESS => 0x0000000010066b80,
  NOTE    => "The sh2_tsf_compare registers are used to compare trigger data note against a data pattern and an enable. The results of the com",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00273_flds
);


##########################################################################
#                                                                        #
#   SH2_TSF_COMPARE14                                                    #
#                                                                        #
##########################################################################

%shub2_01_00274_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Enable bits for TSF compare" ],
   "EXPECTED_DATA"                => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data for TSF compare" ],
);

%shub2_01_00274_def =
( NAME    => "SH2_TSF_COMPARE14",
  ADDRESS => 0x0000000010066c00,
  NOTE    => "The sh2_tsf_compare registers are used to compare trigger data note against a data pattern and an enable. The results of the com",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00274_flds
);


##########################################################################
#                                                                        #
#   SH2_TSF_COMPARE15                                                    #
#                                                                        #
##########################################################################

%shub2_01_00275_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Enable bits for TSF compare" ],
   "EXPECTED_DATA"                => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data for TSF compare" ],
);

%shub2_01_00275_def =
( NAME    => "SH2_TSF_COMPARE15",
  ADDRESS => 0x0000000010066c80,
  NOTE    => "The sh2_tsf_compare registers are used to compare trigger data note against a data pattern and an enable. The results of the com",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00275_flds
);


##########################################################################
#                                                                        #
#   SH2_VEC_DATA                                                         #
#                                                                        #
##########################################################################

%shub2_01_00276_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data" ],
);

%shub2_01_00276_def =
( NAME    => "SH2_VEC_DATA",
  ADDRESS => 0x0000000010067000,
  NOTE    => "The VEC_DATA register contains the value used for the data payload note when the SHub2 generates a Vector Write Request (VWR) me",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00276_flds
);


##########################################################################
#                                                                        #
#   SH2_VEC_PARMS                                                        #
#                                                                        #
##########################################################################

%shub2_01_00277_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "BUSY"                         => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Busy" ],
   "START"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Start" ],
   "RSVD0"                        => [   2,  46,  16, 0x3FFFC00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_ID"                       => [   3,  35,  11, 0x00003FF800000000, 0x00, 0, 0x0000000000000000, "PIO ID" ],
   "ADDRESS"                      => [   4,   3,  32, 0x00000007FFFFFFF8, 0x00, 0, 0x0000000000000000, "Address[37:6]" ],
   "RSVD1"                        => [   5,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_PORT"                      => [   6,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Network Interface Port Select" ],
   "TYPE"                         => [   7,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Vector Request Message Type" ],
);

%shub2_01_00277_def =
( NAME    => "SH2_VEC_PARMS",
  ADDRESS => 0x0000000010067080,
  NOTE    => "The VEC_PARMS register controls various parameters associated with note the SHub2's generation of Vector Request messages (i.e.,",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00277_flds
);


##########################################################################
#                                                                        #
#   SH2_VEC_ROUTE                                                        #
#                                                                        #
##########################################################################

%shub2_01_00278_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ROUTE"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Route" ],
);

%shub2_01_00278_def =
( NAME    => "SH2_VEC_ROUTE",
  ADDRESS => 0x0000000010067100,
  NOTE    => "The VEC_ROUTE register contains the routing information for SHub2 note generated Vector Read Request (VRD) or Vector Write Reque",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00278_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_0A                                                    #
#                                                                        #
##########################################################################

%shub2_01_00279_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00279_def =
( NAME    => "SH2_MCAST_DEST_0A",
  ADDRESS => 0x0000000010069000,
  NOTE    => "Multicast 0A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00279_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_0B                                                    #
#                                                                        #
##########################################################################

%shub2_01_00280_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00280_def =
( NAME    => "SH2_MCAST_DEST_0B",
  ADDRESS => 0x0000000010069080,
  NOTE    => "Multicast 0B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00280_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_1A                                                    #
#                                                                        #
##########################################################################

%shub2_01_00281_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00281_def =
( NAME    => "SH2_MCAST_DEST_1A",
  ADDRESS => 0x0000000010069100,
  NOTE    => "Multicast 1A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00281_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_1B                                                    #
#                                                                        #
##########################################################################

%shub2_01_00282_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00282_def =
( NAME    => "SH2_MCAST_DEST_1B",
  ADDRESS => 0x0000000010069180,
  NOTE    => "Multicast 1B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00282_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_2A                                                    #
#                                                                        #
##########################################################################

%shub2_01_00283_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00283_def =
( NAME    => "SH2_MCAST_DEST_2A",
  ADDRESS => 0x0000000010069200,
  NOTE    => "Multicast 2A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00283_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_2B                                                    #
#                                                                        #
##########################################################################

%shub2_01_00284_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00284_def =
( NAME    => "SH2_MCAST_DEST_2B",
  ADDRESS => 0x0000000010069280,
  NOTE    => "Multicast 2B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00284_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_3A                                                    #
#                                                                        #
##########################################################################

%shub2_01_00285_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00285_def =
( NAME    => "SH2_MCAST_DEST_3A",
  ADDRESS => 0x0000000010069300,
  NOTE    => "Multicast 3A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00285_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_3B                                                    #
#                                                                        #
##########################################################################

%shub2_01_00286_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00286_def =
( NAME    => "SH2_MCAST_DEST_3B",
  ADDRESS => 0x0000000010069380,
  NOTE    => "Multicast 3B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00286_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_4A                                                    #
#                                                                        #
##########################################################################

%shub2_01_00287_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00287_def =
( NAME    => "SH2_MCAST_DEST_4A",
  ADDRESS => 0x0000000010069400,
  NOTE    => "Multicast 4A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00287_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_4B                                                    #
#                                                                        #
##########################################################################

%shub2_01_00288_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00288_def =
( NAME    => "SH2_MCAST_DEST_4B",
  ADDRESS => 0x0000000010069480,
  NOTE    => "Multicast 4B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00288_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_5A                                                    #
#                                                                        #
##########################################################################

%shub2_01_00289_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00289_def =
( NAME    => "SH2_MCAST_DEST_5A",
  ADDRESS => 0x0000000010069500,
  NOTE    => "Multicast 5A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00289_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_5B                                                    #
#                                                                        #
##########################################################################

%shub2_01_00290_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00290_def =
( NAME    => "SH2_MCAST_DEST_5B",
  ADDRESS => 0x0000000010069580,
  NOTE    => "Multicast 5B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00290_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_6A                                                    #
#                                                                        #
##########################################################################

%shub2_01_00291_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00291_def =
( NAME    => "SH2_MCAST_DEST_6A",
  ADDRESS => 0x0000000010069600,
  NOTE    => "Multicast 6A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00291_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_6B                                                    #
#                                                                        #
##########################################################################

%shub2_01_00292_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00292_def =
( NAME    => "SH2_MCAST_DEST_6B",
  ADDRESS => 0x0000000010069680,
  NOTE    => "Multicast 6B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00292_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_7A                                                    #
#                                                                        #
##########################################################################

%shub2_01_00293_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00293_def =
( NAME    => "SH2_MCAST_DEST_7A",
  ADDRESS => 0x0000000010069700,
  NOTE    => "Multicast 7A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00293_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_7B                                                    #
#                                                                        #
##########################################################################

%shub2_01_00294_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00294_def =
( NAME    => "SH2_MCAST_DEST_7B",
  ADDRESS => 0x0000000010069780,
  NOTE    => "Multicast 7B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00294_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_8A                                                    #
#                                                                        #
##########################################################################

%shub2_01_00295_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00295_def =
( NAME    => "SH2_MCAST_DEST_8A",
  ADDRESS => 0x0000000010069800,
  NOTE    => "Multicast 8A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00295_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_8B                                                    #
#                                                                        #
##########################################################################

%shub2_01_00296_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00296_def =
( NAME    => "SH2_MCAST_DEST_8B",
  ADDRESS => 0x0000000010069880,
  NOTE    => "Multicast 8B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00296_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_9A                                                    #
#                                                                        #
##########################################################################

%shub2_01_00297_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00297_def =
( NAME    => "SH2_MCAST_DEST_9A",
  ADDRESS => 0x0000000010069900,
  NOTE    => "Multicast 9A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00297_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_9B                                                    #
#                                                                        #
##########################################################################

%shub2_01_00298_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00298_def =
( NAME    => "SH2_MCAST_DEST_9B",
  ADDRESS => 0x0000000010069980,
  NOTE    => "Multicast 9B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00298_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_10A                                                   #
#                                                                        #
##########################################################################

%shub2_01_00299_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00299_def =
( NAME    => "SH2_MCAST_DEST_10A",
  ADDRESS => 0x0000000010069a00,
  NOTE    => "Multicast 10A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00299_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_10B                                                   #
#                                                                        #
##########################################################################

%shub2_01_00300_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00300_def =
( NAME    => "SH2_MCAST_DEST_10B",
  ADDRESS => 0x0000000010069a80,
  NOTE    => "Multicast 10B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00300_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_11A                                                   #
#                                                                        #
##########################################################################

%shub2_01_00301_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00301_def =
( NAME    => "SH2_MCAST_DEST_11A",
  ADDRESS => 0x0000000010069b00,
  NOTE    => "Multicast 11A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00301_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_11B                                                   #
#                                                                        #
##########################################################################

%shub2_01_00302_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00302_def =
( NAME    => "SH2_MCAST_DEST_11B",
  ADDRESS => 0x0000000010069b80,
  NOTE    => "Multicast 11B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00302_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_12A                                                   #
#                                                                        #
##########################################################################

%shub2_01_00303_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00303_def =
( NAME    => "SH2_MCAST_DEST_12A",
  ADDRESS => 0x0000000010069c00,
  NOTE    => "Multicast 12A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00303_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_12B                                                   #
#                                                                        #
##########################################################################

%shub2_01_00304_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00304_def =
( NAME    => "SH2_MCAST_DEST_12B",
  ADDRESS => 0x0000000010069c80,
  NOTE    => "Multicast 12B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00304_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_13A                                                   #
#                                                                        #
##########################################################################

%shub2_01_00305_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00305_def =
( NAME    => "SH2_MCAST_DEST_13A",
  ADDRESS => 0x0000000010069d00,
  NOTE    => "Multicast 13A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00305_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_13B                                                   #
#                                                                        #
##########################################################################

%shub2_01_00306_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00306_def =
( NAME    => "SH2_MCAST_DEST_13B",
  ADDRESS => 0x0000000010069d80,
  NOTE    => "Multicast 13B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00306_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_14A                                                   #
#                                                                        #
##########################################################################

%shub2_01_00307_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00307_def =
( NAME    => "SH2_MCAST_DEST_14A",
  ADDRESS => 0x0000000010069e00,
  NOTE    => "Multicast 14A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00307_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_14B                                                   #
#                                                                        #
##########################################################################

%shub2_01_00308_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00308_def =
( NAME    => "SH2_MCAST_DEST_14B",
  ADDRESS => 0x0000000010069e80,
  NOTE    => "Multicast 14B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00308_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_15A                                                   #
#                                                                        #
##########################################################################

%shub2_01_00309_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00309_def =
( NAME    => "SH2_MCAST_DEST_15A",
  ADDRESS => 0x0000000010069f00,
  NOTE    => "Multicast 15A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00309_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_15B                                                   #
#                                                                        #
##########################################################################

%shub2_01_00310_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00310_def =
( NAME    => "SH2_MCAST_DEST_15B",
  ADDRESS => 0x0000000010069f80,
  NOTE    => "Multicast 15B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00310_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_16A                                                   #
#                                                                        #
##########################################################################

%shub2_01_00311_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00311_def =
( NAME    => "SH2_MCAST_DEST_16A",
  ADDRESS => 0x000000001006a000,
  NOTE    => "Multicast 16A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00311_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_16B                                                   #
#                                                                        #
##########################################################################

%shub2_01_00312_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00312_def =
( NAME    => "SH2_MCAST_DEST_16B",
  ADDRESS => 0x000000001006a080,
  NOTE    => "Multicast 16B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00312_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_17A                                                   #
#                                                                        #
##########################################################################

%shub2_01_00313_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00313_def =
( NAME    => "SH2_MCAST_DEST_17A",
  ADDRESS => 0x000000001006a100,
  NOTE    => "Multicast 17A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00313_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_17B                                                   #
#                                                                        #
##########################################################################

%shub2_01_00314_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00314_def =
( NAME    => "SH2_MCAST_DEST_17B",
  ADDRESS => 0x000000001006a180,
  NOTE    => "Multicast 17B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00314_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_18A                                                   #
#                                                                        #
##########################################################################

%shub2_01_00315_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00315_def =
( NAME    => "SH2_MCAST_DEST_18A",
  ADDRESS => 0x000000001006a200,
  NOTE    => "Multicast 18A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00315_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_18B                                                   #
#                                                                        #
##########################################################################

%shub2_01_00316_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00316_def =
( NAME    => "SH2_MCAST_DEST_18B",
  ADDRESS => 0x000000001006a280,
  NOTE    => "Multicast 18B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00316_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_19A                                                   #
#                                                                        #
##########################################################################

%shub2_01_00317_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00317_def =
( NAME    => "SH2_MCAST_DEST_19A",
  ADDRESS => 0x000000001006a300,
  NOTE    => "Multicast 19A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00317_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_19B                                                   #
#                                                                        #
##########################################################################

%shub2_01_00318_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00318_def =
( NAME    => "SH2_MCAST_DEST_19B",
  ADDRESS => 0x000000001006a380,
  NOTE    => "Multicast 19B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00318_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_20A                                                   #
#                                                                        #
##########################################################################

%shub2_01_00319_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00319_def =
( NAME    => "SH2_MCAST_DEST_20A",
  ADDRESS => 0x000000001006a400,
  NOTE    => "Multicast 20A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00319_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_20B                                                   #
#                                                                        #
##########################################################################

%shub2_01_00320_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00320_def =
( NAME    => "SH2_MCAST_DEST_20B",
  ADDRESS => 0x000000001006a480,
  NOTE    => "Multicast 20B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00320_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_21A                                                   #
#                                                                        #
##########################################################################

%shub2_01_00321_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00321_def =
( NAME    => "SH2_MCAST_DEST_21A",
  ADDRESS => 0x000000001006a500,
  NOTE    => "Multicast 21A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00321_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_21B                                                   #
#                                                                        #
##########################################################################

%shub2_01_00322_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00322_def =
( NAME    => "SH2_MCAST_DEST_21B",
  ADDRESS => 0x000000001006a580,
  NOTE    => "Multicast 21B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00322_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_22A                                                   #
#                                                                        #
##########################################################################

%shub2_01_00323_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00323_def =
( NAME    => "SH2_MCAST_DEST_22A",
  ADDRESS => 0x000000001006a600,
  NOTE    => "Multicast 22A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00323_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_22B                                                   #
#                                                                        #
##########################################################################

%shub2_01_00324_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00324_def =
( NAME    => "SH2_MCAST_DEST_22B",
  ADDRESS => 0x000000001006a680,
  NOTE    => "Multicast 22B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00324_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_23A                                                   #
#                                                                        #
##########################################################################

%shub2_01_00325_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00325_def =
( NAME    => "SH2_MCAST_DEST_23A",
  ADDRESS => 0x000000001006a700,
  NOTE    => "Multicast 23A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00325_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_23B                                                   #
#                                                                        #
##########################################################################

%shub2_01_00326_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00326_def =
( NAME    => "SH2_MCAST_DEST_23B",
  ADDRESS => 0x000000001006a780,
  NOTE    => "Multicast 23B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00326_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_24A                                                   #
#                                                                        #
##########################################################################

%shub2_01_00327_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00327_def =
( NAME    => "SH2_MCAST_DEST_24A",
  ADDRESS => 0x000000001006a800,
  NOTE    => "Multicast 24A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00327_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_24B                                                   #
#                                                                        #
##########################################################################

%shub2_01_00328_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00328_def =
( NAME    => "SH2_MCAST_DEST_24B",
  ADDRESS => 0x000000001006a880,
  NOTE    => "Multicast 24B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00328_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_25A                                                   #
#                                                                        #
##########################################################################

%shub2_01_00329_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00329_def =
( NAME    => "SH2_MCAST_DEST_25A",
  ADDRESS => 0x000000001006a900,
  NOTE    => "Multicast 25A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00329_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_25B                                                   #
#                                                                        #
##########################################################################

%shub2_01_00330_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00330_def =
( NAME    => "SH2_MCAST_DEST_25B",
  ADDRESS => 0x000000001006a980,
  NOTE    => "Multicast 25B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00330_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_26A                                                   #
#                                                                        #
##########################################################################

%shub2_01_00331_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00331_def =
( NAME    => "SH2_MCAST_DEST_26A",
  ADDRESS => 0x000000001006aa00,
  NOTE    => "Multicast 26A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00331_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_26B                                                   #
#                                                                        #
##########################################################################

%shub2_01_00332_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00332_def =
( NAME    => "SH2_MCAST_DEST_26B",
  ADDRESS => 0x000000001006aa80,
  NOTE    => "Multicast 26B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00332_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_27A                                                   #
#                                                                        #
##########################################################################

%shub2_01_00333_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00333_def =
( NAME    => "SH2_MCAST_DEST_27A",
  ADDRESS => 0x000000001006ab00,
  NOTE    => "Multicast 27A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00333_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_27B                                                   #
#                                                                        #
##########################################################################

%shub2_01_00334_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00334_def =
( NAME    => "SH2_MCAST_DEST_27B",
  ADDRESS => 0x000000001006ab80,
  NOTE    => "Multicast 27B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00334_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_28A                                                   #
#                                                                        #
##########################################################################

%shub2_01_00335_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00335_def =
( NAME    => "SH2_MCAST_DEST_28A",
  ADDRESS => 0x000000001006ac00,
  NOTE    => "Multicast 28A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00335_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_28B                                                   #
#                                                                        #
##########################################################################

%shub2_01_00336_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00336_def =
( NAME    => "SH2_MCAST_DEST_28B",
  ADDRESS => 0x000000001006ac80,
  NOTE    => "Multicast 28B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00336_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_29A                                                   #
#                                                                        #
##########################################################################

%shub2_01_00337_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00337_def =
( NAME    => "SH2_MCAST_DEST_29A",
  ADDRESS => 0x000000001006ad00,
  NOTE    => "Multicast 29A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00337_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_29B                                                   #
#                                                                        #
##########################################################################

%shub2_01_00338_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00338_def =
( NAME    => "SH2_MCAST_DEST_29B",
  ADDRESS => 0x000000001006ad80,
  NOTE    => "Multicast 29B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00338_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_30A                                                   #
#                                                                        #
##########################################################################

%shub2_01_00339_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00339_def =
( NAME    => "SH2_MCAST_DEST_30A",
  ADDRESS => 0x000000001006ae00,
  NOTE    => "Multicast 30A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00339_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_30B                                                   #
#                                                                        #
##########################################################################

%shub2_01_00340_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00340_def =
( NAME    => "SH2_MCAST_DEST_30B",
  ADDRESS => 0x000000001006ae80,
  NOTE    => "Multicast 30B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00340_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_31A                                                   #
#                                                                        #
##########################################################################

%shub2_01_00341_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00341_def =
( NAME    => "SH2_MCAST_DEST_31A",
  ADDRESS => 0x000000001006af00,
  NOTE    => "Multicast 31A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00341_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_31B                                                   #
#                                                                        #
##########################################################################

%shub2_01_00342_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00342_def =
( NAME    => "SH2_MCAST_DEST_31B",
  ADDRESS => 0x000000001006af80,
  NOTE    => "Multicast 31B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00342_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_100A                                                  #
#                                                                        #
##########################################################################

%shub2_01_00343_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00343_def =
( NAME    => "SH2_MCAST_DEST_100A",
  ADDRESS => 0x000000001006b000,
  NOTE    => "Multicast 100A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00343_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_100B                                                  #
#                                                                        #
##########################################################################

%shub2_01_00344_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00344_def =
( NAME    => "SH2_MCAST_DEST_100B",
  ADDRESS => 0x000000001006b080,
  NOTE    => "Multicast 100B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00344_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_101A                                                  #
#                                                                        #
##########################################################################

%shub2_01_00345_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00345_def =
( NAME    => "SH2_MCAST_DEST_101A",
  ADDRESS => 0x000000001006b100,
  NOTE    => "Multicast 101A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00345_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_101B                                                  #
#                                                                        #
##########################################################################

%shub2_01_00346_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00346_def =
( NAME    => "SH2_MCAST_DEST_101B",
  ADDRESS => 0x000000001006b180,
  NOTE    => "Multicast 101B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00346_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_102A                                                  #
#                                                                        #
##########################################################################

%shub2_01_00347_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00347_def =
( NAME    => "SH2_MCAST_DEST_102A",
  ADDRESS => 0x000000001006b200,
  NOTE    => "Multicast 102A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00347_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_102B                                                  #
#                                                                        #
##########################################################################

%shub2_01_00348_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00348_def =
( NAME    => "SH2_MCAST_DEST_102B",
  ADDRESS => 0x000000001006b280,
  NOTE    => "Multicast 102B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00348_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_103A                                                  #
#                                                                        #
##########################################################################

%shub2_01_00349_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00349_def =
( NAME    => "SH2_MCAST_DEST_103A",
  ADDRESS => 0x000000001006b300,
  NOTE    => "Multicast 103A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00349_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_103B                                                  #
#                                                                        #
##########################################################################

%shub2_01_00350_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00350_def =
( NAME    => "SH2_MCAST_DEST_103B",
  ADDRESS => 0x000000001006b380,
  NOTE    => "Multicast 103B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00350_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_104A                                                  #
#                                                                        #
##########################################################################

%shub2_01_00351_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00351_def =
( NAME    => "SH2_MCAST_DEST_104A",
  ADDRESS => 0x000000001006b400,
  NOTE    => "Multicast 104A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00351_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_104B                                                  #
#                                                                        #
##########################################################################

%shub2_01_00352_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00352_def =
( NAME    => "SH2_MCAST_DEST_104B",
  ADDRESS => 0x000000001006b480,
  NOTE    => "Multicast 104B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00352_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_105A                                                  #
#                                                                        #
##########################################################################

%shub2_01_00353_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00353_def =
( NAME    => "SH2_MCAST_DEST_105A",
  ADDRESS => 0x000000001006b500,
  NOTE    => "Multicast 105A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00353_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_105B                                                  #
#                                                                        #
##########################################################################

%shub2_01_00354_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00354_def =
( NAME    => "SH2_MCAST_DEST_105B",
  ADDRESS => 0x000000001006b580,
  NOTE    => "Multicast 105B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00354_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_106A                                                  #
#                                                                        #
##########################################################################

%shub2_01_00355_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00355_def =
( NAME    => "SH2_MCAST_DEST_106A",
  ADDRESS => 0x000000001006b600,
  NOTE    => "Multicast 106A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00355_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_106B                                                  #
#                                                                        #
##########################################################################

%shub2_01_00356_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00356_def =
( NAME    => "SH2_MCAST_DEST_106B",
  ADDRESS => 0x000000001006b680,
  NOTE    => "Multicast 106B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00356_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_107A                                                  #
#                                                                        #
##########################################################################

%shub2_01_00357_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00357_def =
( NAME    => "SH2_MCAST_DEST_107A",
  ADDRESS => 0x000000001006b700,
  NOTE    => "Multicast 107A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00357_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_107B                                                  #
#                                                                        #
##########################################################################

%shub2_01_00358_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00358_def =
( NAME    => "SH2_MCAST_DEST_107B",
  ADDRESS => 0x000000001006b780,
  NOTE    => "Multicast 107B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00358_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_108A                                                  #
#                                                                        #
##########################################################################

%shub2_01_00359_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00359_def =
( NAME    => "SH2_MCAST_DEST_108A",
  ADDRESS => 0x000000001006b800,
  NOTE    => "Multicast 108A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00359_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_108B                                                  #
#                                                                        #
##########################################################################

%shub2_01_00360_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00360_def =
( NAME    => "SH2_MCAST_DEST_108B",
  ADDRESS => 0x000000001006b880,
  NOTE    => "Multicast 108B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00360_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_109A                                                  #
#                                                                        #
##########################################################################

%shub2_01_00361_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00361_def =
( NAME    => "SH2_MCAST_DEST_109A",
  ADDRESS => 0x000000001006b900,
  NOTE    => "Multicast 109A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00361_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_109B                                                  #
#                                                                        #
##########################################################################

%shub2_01_00362_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00362_def =
( NAME    => "SH2_MCAST_DEST_109B",
  ADDRESS => 0x000000001006b980,
  NOTE    => "Multicast 109B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00362_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_110A                                                  #
#                                                                        #
##########################################################################

%shub2_01_00363_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00363_def =
( NAME    => "SH2_MCAST_DEST_110A",
  ADDRESS => 0x000000001006ba00,
  NOTE    => "Multicast 110A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00363_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_110B                                                  #
#                                                                        #
##########################################################################

%shub2_01_00364_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00364_def =
( NAME    => "SH2_MCAST_DEST_110B",
  ADDRESS => 0x000000001006ba80,
  NOTE    => "Multicast 110B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00364_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_111A                                                  #
#                                                                        #
##########################################################################

%shub2_01_00365_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00365_def =
( NAME    => "SH2_MCAST_DEST_111A",
  ADDRESS => 0x000000001006bb00,
  NOTE    => "Multicast 111A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00365_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_111B                                                  #
#                                                                        #
##########################################################################

%shub2_01_00366_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00366_def =
( NAME    => "SH2_MCAST_DEST_111B",
  ADDRESS => 0x000000001006bb80,
  NOTE    => "Multicast 111B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00366_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_112A                                                  #
#                                                                        #
##########################################################################

%shub2_01_00367_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00367_def =
( NAME    => "SH2_MCAST_DEST_112A",
  ADDRESS => 0x000000001006bc00,
  NOTE    => "Multicast 112A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00367_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_112B                                                  #
#                                                                        #
##########################################################################

%shub2_01_00368_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00368_def =
( NAME    => "SH2_MCAST_DEST_112B",
  ADDRESS => 0x000000001006bc80,
  NOTE    => "Multicast 112B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00368_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_113A                                                  #
#                                                                        #
##########################################################################

%shub2_01_00369_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00369_def =
( NAME    => "SH2_MCAST_DEST_113A",
  ADDRESS => 0x000000001006bd00,
  NOTE    => "Multicast 113A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00369_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_113B                                                  #
#                                                                        #
##########################################################################

%shub2_01_00370_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00370_def =
( NAME    => "SH2_MCAST_DEST_113B",
  ADDRESS => 0x000000001006bd80,
  NOTE    => "Multicast 113B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00370_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_114A                                                  #
#                                                                        #
##########################################################################

%shub2_01_00371_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00371_def =
( NAME    => "SH2_MCAST_DEST_114A",
  ADDRESS => 0x000000001006be00,
  NOTE    => "Multicast 114A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00371_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_114B                                                  #
#                                                                        #
##########################################################################

%shub2_01_00372_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00372_def =
( NAME    => "SH2_MCAST_DEST_114B",
  ADDRESS => 0x000000001006be80,
  NOTE    => "Multicast 114B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00372_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_115A                                                  #
#                                                                        #
##########################################################################

%shub2_01_00373_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00373_def =
( NAME    => "SH2_MCAST_DEST_115A",
  ADDRESS => 0x000000001006bf00,
  NOTE    => "Multicast 115A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00373_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_115B                                                  #
#                                                                        #
##########################################################################

%shub2_01_00374_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00374_def =
( NAME    => "SH2_MCAST_DEST_115B",
  ADDRESS => 0x000000001006bf80,
  NOTE    => "Multicast 115B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00374_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_116A                                                  #
#                                                                        #
##########################################################################

%shub2_01_00375_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00375_def =
( NAME    => "SH2_MCAST_DEST_116A",
  ADDRESS => 0x000000001006c000,
  NOTE    => "Multicast 116A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00375_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_116B                                                  #
#                                                                        #
##########################################################################

%shub2_01_00376_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00376_def =
( NAME    => "SH2_MCAST_DEST_116B",
  ADDRESS => 0x000000001006c080,
  NOTE    => "Multicast 116B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00376_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_117A                                                  #
#                                                                        #
##########################################################################

%shub2_01_00377_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00377_def =
( NAME    => "SH2_MCAST_DEST_117A",
  ADDRESS => 0x000000001006c100,
  NOTE    => "Multicast 117A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00377_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_117B                                                  #
#                                                                        #
##########################################################################

%shub2_01_00378_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00378_def =
( NAME    => "SH2_MCAST_DEST_117B",
  ADDRESS => 0x000000001006c180,
  NOTE    => "Multicast 117B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00378_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_118A                                                  #
#                                                                        #
##########################################################################

%shub2_01_00379_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00379_def =
( NAME    => "SH2_MCAST_DEST_118A",
  ADDRESS => 0x000000001006c200,
  NOTE    => "Multicast 118A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00379_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_118B                                                  #
#                                                                        #
##########################################################################

%shub2_01_00380_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00380_def =
( NAME    => "SH2_MCAST_DEST_118B",
  ADDRESS => 0x000000001006c280,
  NOTE    => "Multicast 118B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00380_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_119A                                                  #
#                                                                        #
##########################################################################

%shub2_01_00381_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00381_def =
( NAME    => "SH2_MCAST_DEST_119A",
  ADDRESS => 0x000000001006c300,
  NOTE    => "Multicast 119A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00381_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_119B                                                  #
#                                                                        #
##########################################################################

%shub2_01_00382_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00382_def =
( NAME    => "SH2_MCAST_DEST_119B",
  ADDRESS => 0x000000001006c380,
  NOTE    => "Multicast 119B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00382_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_120A                                                  #
#                                                                        #
##########################################################################

%shub2_01_00383_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00383_def =
( NAME    => "SH2_MCAST_DEST_120A",
  ADDRESS => 0x000000001006c400,
  NOTE    => "Multicast 120A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00383_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_120B                                                  #
#                                                                        #
##########################################################################

%shub2_01_00384_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00384_def =
( NAME    => "SH2_MCAST_DEST_120B",
  ADDRESS => 0x000000001006c480,
  NOTE    => "Multicast 120B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00384_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_121A                                                  #
#                                                                        #
##########################################################################

%shub2_01_00385_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00385_def =
( NAME    => "SH2_MCAST_DEST_121A",
  ADDRESS => 0x000000001006c500,
  NOTE    => "Multicast 121A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00385_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_121B                                                  #
#                                                                        #
##########################################################################

%shub2_01_00386_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00386_def =
( NAME    => "SH2_MCAST_DEST_121B",
  ADDRESS => 0x000000001006c580,
  NOTE    => "Multicast 121B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00386_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_122A                                                  #
#                                                                        #
##########################################################################

%shub2_01_00387_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00387_def =
( NAME    => "SH2_MCAST_DEST_122A",
  ADDRESS => 0x000000001006c600,
  NOTE    => "Multicast 122A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00387_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_122B                                                  #
#                                                                        #
##########################################################################

%shub2_01_00388_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00388_def =
( NAME    => "SH2_MCAST_DEST_122B",
  ADDRESS => 0x000000001006c680,
  NOTE    => "Multicast 122B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00388_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_123A                                                  #
#                                                                        #
##########################################################################

%shub2_01_00389_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00389_def =
( NAME    => "SH2_MCAST_DEST_123A",
  ADDRESS => 0x000000001006c700,
  NOTE    => "Multicast 123A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00389_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_123B                                                  #
#                                                                        #
##########################################################################

%shub2_01_00390_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00390_def =
( NAME    => "SH2_MCAST_DEST_123B",
  ADDRESS => 0x000000001006c780,
  NOTE    => "Multicast 123B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00390_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_124A                                                  #
#                                                                        #
##########################################################################

%shub2_01_00391_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00391_def =
( NAME    => "SH2_MCAST_DEST_124A",
  ADDRESS => 0x000000001006c800,
  NOTE    => "Multicast 124A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00391_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_124B                                                  #
#                                                                        #
##########################################################################

%shub2_01_00392_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00392_def =
( NAME    => "SH2_MCAST_DEST_124B",
  ADDRESS => 0x000000001006c880,
  NOTE    => "Multicast 124B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00392_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_125A                                                  #
#                                                                        #
##########################################################################

%shub2_01_00393_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00393_def =
( NAME    => "SH2_MCAST_DEST_125A",
  ADDRESS => 0x000000001006c900,
  NOTE    => "Multicast 125A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00393_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_125B                                                  #
#                                                                        #
##########################################################################

%shub2_01_00394_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00394_def =
( NAME    => "SH2_MCAST_DEST_125B",
  ADDRESS => 0x000000001006c980,
  NOTE    => "Multicast 125B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00394_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_126A                                                  #
#                                                                        #
##########################################################################

%shub2_01_00395_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00395_def =
( NAME    => "SH2_MCAST_DEST_126A",
  ADDRESS => 0x000000001006ca00,
  NOTE    => "Multicast 126A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00395_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_126B                                                  #
#                                                                        #
##########################################################################

%shub2_01_00396_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00396_def =
( NAME    => "SH2_MCAST_DEST_126B",
  ADDRESS => 0x000000001006ca80,
  NOTE    => "Multicast 126B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00396_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_127A                                                  #
#                                                                        #
##########################################################################

%shub2_01_00397_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00397_def =
( NAME    => "SH2_MCAST_DEST_127A",
  ADDRESS => 0x000000001006cb00,
  NOTE    => "Multicast 127A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00397_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_127B                                                  #
#                                                                        #
##########################################################################

%shub2_01_00398_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00398_def =
( NAME    => "SH2_MCAST_DEST_127B",
  ADDRESS => 0x000000001006cb80,
  NOTE    => "Multicast 127B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00398_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_128A                                                  #
#                                                                        #
##########################################################################

%shub2_01_00399_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00399_def =
( NAME    => "SH2_MCAST_DEST_128A",
  ADDRESS => 0x000000001006cc00,
  NOTE    => "Multicast 128A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00399_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_128B                                                  #
#                                                                        #
##########################################################################

%shub2_01_00400_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00400_def =
( NAME    => "SH2_MCAST_DEST_128B",
  ADDRESS => 0x000000001006cc80,
  NOTE    => "Multicast 128B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00400_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_129A                                                  #
#                                                                        #
##########################################################################

%shub2_01_00401_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00401_def =
( NAME    => "SH2_MCAST_DEST_129A",
  ADDRESS => 0x000000001006cd00,
  NOTE    => "Multicast 129A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00401_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_129B                                                  #
#                                                                        #
##########################################################################

%shub2_01_00402_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00402_def =
( NAME    => "SH2_MCAST_DEST_129B",
  ADDRESS => 0x000000001006cd80,
  NOTE    => "Multicast 129B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00402_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_130A                                                  #
#                                                                        #
##########################################################################

%shub2_01_00403_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00403_def =
( NAME    => "SH2_MCAST_DEST_130A",
  ADDRESS => 0x000000001006ce00,
  NOTE    => "Multicast 130A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00403_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_130B                                                  #
#                                                                        #
##########################################################################

%shub2_01_00404_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00404_def =
( NAME    => "SH2_MCAST_DEST_130B",
  ADDRESS => 0x000000001006ce80,
  NOTE    => "Multicast 130B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00404_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_131A                                                  #
#                                                                        #
##########################################################################

%shub2_01_00405_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00405_def =
( NAME    => "SH2_MCAST_DEST_131A",
  ADDRESS => 0x000000001006cf00,
  NOTE    => "Multicast 131A Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00405_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_DEST_131B                                                  #
#                                                                        #
##########################################################################

%shub2_01_00406_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Node ID" ],
);

%shub2_01_00406_def =
( NAME    => "SH2_MCAST_DEST_131B",
  ADDRESS => 0x000000001006cf80,
  NOTE    => "Multicast 131B Destination",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00406_flds
);


##########################################################################
#                                                                        #
#   SH2_CPU_PERM0                                                        #
#                                                                        #
##########################################################################

%shub2_01_00407_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 63 - 0" ],
);

%shub2_01_00407_def =
( NAME    => "SH2_CPU_PERM0",
  ADDRESS => 0x0000000010060000,
  NOTE    => "CPU MMR Access Permission Bits 63 - 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00407_flds
);


##########################################################################
#                                                                        #
#   SH2_CPU_PERM1                                                        #
#                                                                        #
##########################################################################

%shub2_01_00408_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 127 - 64" ],
);

%shub2_01_00408_def =
( NAME    => "SH2_CPU_PERM1",
  ADDRESS => 0x0000000010060080,
  NOTE    => "CPU MMR Access Permission Bits 127 - 64",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00408_flds
);


##########################################################################
#                                                                        #
#   SH2_CPU_PERM2                                                        #
#                                                                        #
##########################################################################

%shub2_01_00409_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 191 - 128" ],
);

%shub2_01_00409_def =
( NAME    => "SH2_CPU_PERM2",
  ADDRESS => 0x0000000010060100,
  NOTE    => "CPU MMR Access Permission Bits 191 - 128",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00409_flds
);


##########################################################################
#                                                                        #
#   SH2_CPU_PERM3                                                        #
#                                                                        #
##########################################################################

%shub2_01_00410_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 255 - 192" ],
);

%shub2_01_00410_def =
( NAME    => "SH2_CPU_PERM3",
  ADDRESS => 0x0000000010060180,
  NOTE    => "CPU MMR Access Permission Bits 255 - 192",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00410_flds
);


##########################################################################
#                                                                        #
#   SH2_CPU_PERM_OVR                                                     #
#                                                                        #
##########################################################################

%shub2_01_00411_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "OVERRIDE"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Override" ],
);

%shub2_01_00411_def =
( NAME    => "SH2_CPU_PERM_OVR",
  ADDRESS => 0x0000000010060200,
  NOTE    => "A write to this register of the 64-bit value 'SGIrules' note (0x5347_4972_756C_6573) will cause the bit in the LB_CPU_PROTECT no",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00411_flds
);


##########################################################################
#                                                                        #
#   SH2_EXT_IO_PERM0                                                     #
#                                                                        #
##########################################################################

%shub2_01_00412_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 63 - 0" ],
);

%shub2_01_00412_def =
( NAME    => "SH2_EXT_IO_PERM0",
  ADDRESS => 0x0000000010060280,
  NOTE    => "External IO MMR Access Permission Bits 63 - 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00412_flds
);


##########################################################################
#                                                                        #
#   SH2_EXT_IO_PERM1                                                     #
#                                                                        #
##########################################################################

%shub2_01_00413_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 127 - 64" ],
);

%shub2_01_00413_def =
( NAME    => "SH2_EXT_IO_PERM1",
  ADDRESS => 0x0000000010060300,
  NOTE    => "External IO MMR Access Permission Bits 127 - 64",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00413_flds
);


##########################################################################
#                                                                        #
#   SH2_EXT_IO_PERM2                                                     #
#                                                                        #
##########################################################################

%shub2_01_00414_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 191 - 128" ],
);

%shub2_01_00414_def =
( NAME    => "SH2_EXT_IO_PERM2",
  ADDRESS => 0x0000000010060380,
  NOTE    => "External IO MMR Access Permission Bits 191 - 128",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00414_flds
);


##########################################################################
#                                                                        #
#   SH2_EXT_IO_PERM3                                                     #
#                                                                        #
##########################################################################

%shub2_01_00415_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 255 - 192" ],
);

%shub2_01_00415_def =
( NAME    => "SH2_EXT_IO_PERM3",
  ADDRESS => 0x0000000010060400,
  NOTE    => "External IO MMR Access Permission Bits 255 - 192",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00415_flds
);


##########################################################################
#                                                                        #
#   SH2_EXT_IOI_ACCESS0                                                  #
#                                                                        #
##########################################################################

%shub2_01_00416_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 63 - 0" ],
);

%shub2_01_00416_def =
( NAME    => "SH2_EXT_IOI_ACCESS0",
  ADDRESS => 0x0000000010060480,
  NOTE    => "External IO Interrupt Access Permission Bits 63 - 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00416_flds
);


##########################################################################
#                                                                        #
#   SH2_EXT_IOI_ACCESS1                                                  #
#                                                                        #
##########################################################################

%shub2_01_00417_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 127 - 64" ],
);

%shub2_01_00417_def =
( NAME    => "SH2_EXT_IOI_ACCESS1",
  ADDRESS => 0x0000000010060500,
  NOTE    => "External IO Interrupt Access Permission Bits 127 - 64",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00417_flds
);


##########################################################################
#                                                                        #
#   SH2_EXT_IOI_ACCESS2                                                  #
#                                                                        #
##########################################################################

%shub2_01_00418_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 191 - 128" ],
);

%shub2_01_00418_def =
( NAME    => "SH2_EXT_IOI_ACCESS2",
  ADDRESS => 0x0000000010060580,
  NOTE    => "External IO Interrupt Access Permission Bits 191 - 128",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00418_flds
);


##########################################################################
#                                                                        #
#   SH2_EXT_IOI_ACCESS3                                                  #
#                                                                        #
##########################################################################

%shub2_01_00419_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 255 - 192" ],
);

%shub2_01_00419_def =
( NAME    => "SH2_EXT_IOI_ACCESS3",
  ADDRESS => 0x0000000010060600,
  NOTE    => "External IO Interrupt Access Permission Bits 255 - 192",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00419_flds
);


##########################################################################
#                                                                        #
#   SH2_GC_FIL_CTRL                                                      #
#                                                                        #
##########################################################################

%shub2_01_00420_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  58,   6, 0xFC00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERROR_COUNTER"                => [   1,  48,  10, 0x03FF000000000000, 0x00, 1, 0x0000000000000000, "Error counter" ],
   "RSVD1"                        => [   2,  46,   2, 0x0000C00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DROPOUT_THRESH"               => [   3,  36,  10, 0x00003FF000000000, 0x00, 1, 0x0000000000000000, "Dropout threshold" ],
   "RSVD2"                        => [   4,  34,   2, 0x0000000C00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DROPOUT_COUNTER"              => [   5,  24,  10, 0x00000003FF000000, 0x00, 1, 0x0000000000000000, "Dropout Counter" ],
   "RSVD3"                        => [   6,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MASK_ENABLE"                  => [   7,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "Mask Enable" ],
   "MASK_COUNTER"                 => [   8,   8,  12, 0x00000000000FFF00, 0x00, 1, 0x0000000000000000, "Mask Counter" ],
   "RSVD4"                        => [   9,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OFFSET"                       => [  10,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Offset" ],
);

%shub2_01_00420_def =
( NAME    => "SH2_GC_FIL_CTRL",
  ADDRESS => 0x0000000010060680,
  NOTE    => "When the GC_SRC_CTRL register's SOURCE_SEL field is set to REMOTE_0 note or REMOTE_2, the SHub2 receives its global clock from a",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00420_flds
);


##########################################################################
#                                                                        #
#   SH2_GC_SRC_CTRL                                                      #
#                                                                        #
##########################################################################

%shub2_01_00421_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SOURCE_SEL"                   => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "Source select (0=ext., 1=Int., 2=SHub2)" ],
   "RSVD1"                        => [   2,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TOGGLE_BIT"                   => [   3,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "Toggle bit" ],
   "RSVD2"                        => [   4,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNTER"                      => [   5,  16,  10, 0x0000000003FF0000, 0x00, 1, 0x0000000000000000, "Counter" ],
   "RSVD3"                        => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_COUNT"                    => [   7,   4,  10, 0x0000000000003FF0, 0x00, 1, 0x0000000000000000, "Max Count" ],
   "RSVD4"                        => [   8,   1,   3, 0x000000000000000E, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_COUNTER"               => [   9,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable Counter" ],
);

%shub2_01_00421_def =
( NAME    => "SH2_GC_SRC_CTRL",
  ADDRESS => 0x0000000010060700,
  NOTE    => "The GC_SRC_CTRL register contains several parameters which note determine the source and period of the SN2 system's global clock",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00421_flds
);


##########################################################################
#                                                                        #
#   SH2_HARD_RESET                                                       #
#                                                                        #
##########################################################################

%shub2_01_00422_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HARD_RESET"                   => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Hard Reset" ],
);

%shub2_01_00422_def =
( NAME    => "SH2_HARD_RESET",
  ADDRESS => 0x0000000010060780,
  NOTE    => "SHub2 Hard Reset",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00422_flds
);


##########################################################################
#                                                                        #
#   SH2_IPI_ACCESS0                                                      #
#                                                                        #
##########################################################################

%shub2_01_00423_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 63 - 0" ],
);

%shub2_01_00423_def =
( NAME    => "SH2_IPI_ACCESS0",
  ADDRESS => 0x0000000010060c00,
  NOTE    => "CPU interrupt Access Permission Bits 63 - 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00423_flds
);


##########################################################################
#                                                                        #
#   SH2_IPI_ACCESS1                                                      #
#                                                                        #
##########################################################################

%shub2_01_00424_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 127 - 64" ],
);

%shub2_01_00424_def =
( NAME    => "SH2_IPI_ACCESS1",
  ADDRESS => 0x0000000010060c80,
  NOTE    => "CPU interrupt Access Permission Bits 127 - 64",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00424_flds
);


##########################################################################
#                                                                        #
#   SH2_IPI_ACCESS2                                                      #
#                                                                        #
##########################################################################

%shub2_01_00425_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 191 - 128" ],
);

%shub2_01_00425_def =
( NAME    => "SH2_IPI_ACCESS2",
  ADDRESS => 0x0000000010060d00,
  NOTE    => "CPU interrupt Access Permission Bits 191 - 128",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00425_flds
);


##########################################################################
#                                                                        #
#   SH2_IPI_ACCESS3                                                      #
#                                                                        #
##########################################################################

%shub2_01_00426_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 255 - 192" ],
);

%shub2_01_00426_def =
( NAME    => "SH2_IPI_ACCESS3",
  ADDRESS => 0x0000000010060d80,
  NOTE    => "CPU interrupt Access Permission Bits 255 - 192",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00426_flds
);


##########################################################################
#                                                                        #
#   SH2_JTAG_CONFIG0                                                     #
#                                                                        #
##########################################################################

%shub2_01_00427_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "JTAG_MCI_OVERRIDE"            => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "jtag_mci_override" ],
   "JTAG_MCI_TARGET"              => [   1,  49,  14, 0x7FFE000000000000, 0x00, 0, 0x0000000000000000, "jtag_mci_target" ],
   "JTAG_MCI_RESET_DELAY"         => [   2,  42,   7, 0x0001FC0000000000, 0x00, 0, 0x0000000000000000, "jtag_mci_reset_delay" ],
   "JTAG_MCI_WRTACT_LATENCY"      => [   3,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "jtag_mci_reset_delay" ],
   "WRT90_OVERRIDE"               => [   4,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "wrt90_override" ],
   "WRT90_OVERRIDEA"              => [   5,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "wrt90_overrideA" ],
   "WRT90_TARGET"                 => [   6,  24,  14, 0x0000003FFF000000, 0x00, 0, 0x0000000000000000, "wrt90_target" ],
   "J_SEL_OSC_FSBCLK"             => [   7,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Selects core or ext osc. for raw_fsbclk" ],
   "J_SEL_OSC_CORECLK"            => [   8,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Selects core or ext osc. for raw_coreclk" ],
   "J_SEL_FSB_1X_BY2"             => [   9,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Selects output freq. of clkcntl for FSB clock domain" ],
   "J_SEL_OSCFSB_CORE"            => [  10,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Selects input freq. for clkcntl for FSB clock domain" ],
   "JSEL0_PI4CLK_DSKW"            => [  11,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "selects fine tuning deskew of pi4clk" ],
   "JSEL1_PI4CLK_DSKW"            => [  12,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "selects fine tuning deskew of pi4clk" ],
   "JSEL0_PI2CLK_DSKW"            => [  13,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "selects fine tuning deskew of pi2clk" ],
   "JSEL1_PI2CLK_DSKW"            => [  14,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "selects fine tuning deskew of pi2clk" ],
   "JSEL0_BCLKA_DSKW"             => [  15,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "selects fine tuning deskew of bclka" ],
   "JSEL1_BCLKA_DSKW"             => [  16,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "selects fine tuning deskew of bclka" ],
   "JSEL0_NETCHNCLK_DSKW"         => [  17,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "selects fine tuning deskew of netchnclk" ],
   "JSEL1_NETCHNCLK_DSKW"         => [  18,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "selects fine tuning deskew of netchnclk" ],
   "JSEL0_CORECLK_DSKW"           => [  19,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "selects fine tuning deskew of coreclk" ],
   "JSEL1_CORECLK_DSKW"           => [  20,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "selects fine tuning deskew of coreclk" ],
   "JSEL0_DRAMCLK_DSKW"           => [  21,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "selects fine tuning deskew of dramclk" ],
   "JSEL1_DRAMCLK_DSKW"           => [  22,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "selects fine tuning deskew of dramclk" ],
   "JSEL0_CORE2XCLK_DSKW"         => [  23,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "selects fine tuning deskew of core2xclk" ],
   "JSEL1_CORE2XCLK_DSKW"         => [  24,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "selects fine tuning deskew of core2xclk" ],
   "JSEL_CORE2XCLK_INV"           => [  25,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "selects polarity of core2xclk, 0 normal, 1 invert" ],
   "II_CLK_SEL"                   => [  26,   3,   2, 0x0000000000000018, 0x00, 0, 0x0000000000000000, "Selects clock source for IOCLK domain" ],
   "NI_CLK_SEL"                   => [  27,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Selects clock source for NICLK domain" ],
   "MD_CLK_SEL"                   => [  28,   0,   2, 0x0000000000000003, 0x00, 0, 0x0000000000000000, "Select divide freq of DRAMCLK" ],
);

%shub2_01_00427_def =
( NAME    => "SH2_JTAG_CONFIG0",
  ADDRESS => 0x0000000010060e00,
  NOTE    => "The sh2_jtag_config register contains a copy of the JTAG note configuration bits. These bits are loaded by JTAG before clock not",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00427_flds
);


##########################################################################
#                                                                        #
#   SH2_JTAG_CONFIG1                                                     #
#                                                                        #
##########################################################################

%shub2_01_00428_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CONFIG_SPARE"                 => [   1,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "spare config bits" ],
   "FSB_DEBUG_CONFIG_OE"          => [   2,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Enable FSB debug port" ],
   "LB_DBUG_CONFIG_OE"            => [   3,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Enable SHub2 debug port" ],
   "GTL_CONFIG_RE"                => [   4,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "glt_config_re" ],
   "DQSGATE_EN"                   => [   5,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "DQSgate_en" ],
   "FMAC_DDR_RCVR_CLOCK_CONFIG"   => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "fmac_ddr_rcvr_config_config" ],
   "R_FMAC_DDR_RCVR_DRDY_CONFIG"  => [   7,   5,   2, 0x0000000000000060, 0x00, 0, 0x0000000000000000, "r_fmac_ddr_rcvr_drdy_config" ],
   "L_FMAC_DDR_RCVR_DRDY_CONFIG"  => [   8,   3,   2, 0x0000000000000018, 0x00, 0, 0x0000000000000000, "l_fmac_ddr_rcvr_drdy_config" ],
   "FMAC_DDR_RCVR_FIFO_CONFIG"    => [   9,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "fmac_ddr_rcvr_fifo_config" ],
   "FMAC_TXRX_CAPTURE_PHASE"      => [  10,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "fmac_txrx_capture_phase" ],
   "FMAC_TXRX_LAUNCH_PHASE"       => [  11,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "fmac_txrx_launch_phase" ],
);

%shub2_01_00428_def =
( NAME    => "SH2_JTAG_CONFIG1",
  ADDRESS => 0x0000000010060e80,
  NOTE    => "SHub2 JTAG configuration register 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00428_flds
);


##########################################################################
#                                                                        #
#   SH2_NODE_ID                                                          #
#                                                                        #
##########################################################################

%shub2_01_00429_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  59,   5, 0xF800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SYSTEM_TYPE"                  => [   1,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "System type, 0 = SHub (SN2-IA), 1 = Orbit (SN2-MIPS)" ],
   "RSVD1"                        => [   2,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_PORT"                      => [   3,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI port of vector reference, 0 = NI0, 1 = NI1" ],
   "RANGE_CHECK"                  => [   4,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "Range check" ],
   "SHARERS_1K"                   => [   5,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "STANDARD/EXTENDED Sharing Mode Select" ],
   "NODES_PER_BIT"                => [   6,  48,   6, 0x003F000000000000, 0x00, 1, 0x0000000000000000, "Nodes Per Bit" ],
   "SHARING_MODE"                 => [   7,  46,   2, 0x0000C00000000000, 0x00, 1, 0x0000000000000000, "Sharing Mode" ],
   "NODE_ID"                      => [   8,  32,  14, 0x00003FFF00000000, 0x00, 1, 0x0000000000000000, "Node Identification" ],
   "REVISION"                     => [   9,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Revision" ],
   "PART_NUMBER"                  => [  10,  12,  16, 0x000000000FFFF000, 0x00, 0, 0x0000000000000000, "Part Number" ],
   "MANUFACTURER"                 => [  11,   1,  11, 0x0000000000000FFE, 0x00, 0, 0x0000000000000000, "Manufacturer" ],
   "FORCE1"                       => [  12,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Must be 1" ],
);

%shub2_01_00429_def =
( NAME    => "SH2_NODE_ID",
  ADDRESS => 0x0000000010060f00,
  NOTE    => "The NODE_ID register contains the Manufacturer id, revision, note node_id, sharing mode, nodes per bit, ni port, system type and",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00429_flds
);


##########################################################################
#                                                                        #
#   SH2_SOFT_RESET                                                       #
#                                                                        #
##########################################################################

%shub2_01_00430_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SOFT_RESET"                   => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Soft Reset" ],
);

%shub2_01_00430_def =
( NAME    => "SH2_SOFT_RESET",
  ADDRESS => 0x0000000010061100,
  NOTE    => "SHub2 Soft Reset",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00430_flds
);


##########################################################################
#                                                                        #
#   SH2_NODE_PRESENT_TABLE                                               #
#                                                                        #
##########################################################################

%shub2_01_00431_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NODES"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Nodes Present" ],
);

%shub2_01_00431_def =
( NAME    => "SH2_NODE_PRESENT_TABLE",
  ADDRESS => 0x0000000010061400,
  NOTE    => "The node_present_table is a bit map of all of the nodes present in note the entire system. The bits are stored in an array, 64 b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00431_flds
);


##########################################################################
#                                                                        #
#   SH2_THROTTLE_INTERVAL                                                #
#                                                                        #
##########################################################################

%shub2_01_00432_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RESET"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reset Throttle Counters" ],
   "RSVD0"                        => [   1,  30,  33, 0x7FFFFFFFC0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   2,   0,  30, 0x000000003FFFFFFF, 0x00, 1, 0x0000000000000000, "Throttle Interval" ],
);

%shub2_01_00432_def =
( NAME    => "SH2_THROTTLE_INTERVAL",
  ADDRESS => 0x0000000010068000,
  NOTE    => "Throttle Interval",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00432_flds
);


##########################################################################
#                                                                        #
#   SH2_THROTTLE_TIME                                                    #
#                                                                        #
##########################################################################

%shub2_01_00433_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  30,  34, 0xFFFFFFFFC0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  30, 0x000000003FFFFFFF, 0x00, 1, 0x0000000000000000, "Throttle Time" ],
);

%shub2_01_00433_def =
( NAME    => "SH2_THROTTLE_TIME",
  ADDRESS => 0x0000000010068080,
  NOTE    => "Throttle Time",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00433_flds
);


##########################################################################
#                                                                        #
#   SH2_THROTTLE_ENABLE                                                  #
#                                                                        #
##########################################################################

%shub2_01_00434_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   4,  60, 0xFFFFFFFFFFFFFFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN"                           => [   1,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Enable Throttling on XN Port" ],
   "IILB"                         => [   2,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Enable Throttling on IILB Port" ],
   "MD"                           => [   3,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Enable Throttling on MD Port" ],
   "PI"                           => [   4,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable Throttling on PI Port" ],
);

%shub2_01_00434_def =
( NAME    => "SH2_THROTTLE_ENABLE",
  ADDRESS => 0x0000000010068100,
  NOTE    => "Throttle Enable",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00434_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_INV_CONFIG                                                 #
#                                                                        #
##########################################################################

%shub2_01_00435_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CMD_LEVEL2"                   => [   1,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Command Field level 1" ],
   "CMD_LEVEL1"                   => [   2,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Command Field level 1" ],
   "RSVD1"                        => [   3,   3,   5, 0x00000000000000F8, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SINGLE_DEST_ENABLE"           => [   4,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Single Destination Enable" ],
   "REMOTE_ENABLE"                => [   5,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Enable Remote Multicast" ],
   "LOCAL_ENABLE"                 => [   6,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable Local Multicast" ],
);

%shub2_01_00435_def =
( NAME    => "SH2_MCAST_INV_CONFIG",
  ADDRESS => 0x0000000010068200,
  NOTE    => "Multicast Configuration",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00435_flds
);


##########################################################################
#                                                                        #
#   SH2_MCAST_MASK                                                       #
#                                                                        #
##########################################################################

%shub2_01_00436_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MASK_B_1K"                    => [   1,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "Mask B 1K Mode" ],
   "RSVD1"                        => [   2,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MASK_A_1K"                    => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Mask A 1K Mode" ],
   "RSVD2"                        => [   4,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MASK_B"                       => [   5,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Mask B" ],
   "RSVD3"                        => [   6,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MASK_A"                       => [   7,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Mask A" ],
);

%shub2_01_00436_def =
( NAME    => "SH2_MCAST_MASK",
  ADDRESS => 0x0000000010068300,
  NOTE    => "Multicast Masks",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00436_flds
);


##########################################################################
#                                                                        #
#   SH2_FIRST_ERROR                                                      #
#                                                                        #
##########################################################################

%shub2_01_00437_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_UCE_INT"                   => [   1,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "XN Uncorrectable Error Interrupt Pending" ],
   "MD_UCE_INT"                   => [   2,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "MD Uncorrectable Error Interrupt Pending" ],
   "PI_UCE_INT"                   => [   3,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "PI Uncorrectable Error Interrupt Pending" ],
   "XN_CE_INT"                    => [   4,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "XN Correctable Error Interrupt Pending" ],
   "MD_CE_INT"                    => [   5,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "MD Correctable Error Interrupt Pending" ],
   "PI_CE_INT"                    => [   6,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "PI Correctable Error Interrupt Pending" ],
   "BT_HW_INT"                    => [   7,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "BT Hardware Interrupt Pending" ],
   "LB_HW_INT"                    => [   8,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "LB Hardware Interrupt Pending" ],
   "XN_HW_INT"                    => [   9,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "XN Hardware Interrupt Pending" ],
   "MD_HW_INT"                    => [  10,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "MD Hardware Interrupt Pending" ],
   "PI_HW_INT"                    => [  11,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "PI Hardware Interrupt Pending" ],
);

%shub2_01_00437_def =
( NAME    => "SH2_FIRST_ERROR",
  ADDRESS => 0x0000000010071000,
  NOTE    => "The sh2_first_error register is the top-level error register for note the SHub2. The sh2_first_error register indicates which er",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00437_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_HW_TIME_STAMP                                                 #
#                                                                        #
##########################################################################

%shub2_01_00438_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid Flag" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Time Stamp Value" ],
);

%shub2_01_00438_def =
( NAME    => "SH2_BT_HW_TIME_STAMP",
  ADDRESS => 0x0000000010071080,
  NOTE    => "The sh2_bt_hw_time_stamp register stores the time stamp of the note first hardware error detected by the BT chiplet.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00438_flds
);


##########################################################################
#                                                                        #
#   SH2_LB_HW_TIME_STAMP                                                 #
#                                                                        #
##########################################################################

%shub2_01_00439_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid Flag" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Time Stamp Value" ],
);

%shub2_01_00439_def =
( NAME    => "SH2_LB_HW_TIME_STAMP",
  ADDRESS => 0x0000000010071100,
  NOTE    => "The sh2_lb_hw_time_stamp register stores the time stamp of the note first hardware error detected by the LB chiplet.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00439_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_COR_TIME_STAMP                                                #
#                                                                        #
##########################################################################

%shub2_01_00440_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid Flag" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Time Stamp Value" ],
);

%shub2_01_00440_def =
( NAME    => "SH2_MD_COR_TIME_STAMP",
  ADDRESS => 0x0000000010071180,
  NOTE    => "The sh2_md_cor_time_stamp register stores the time stamp of the note first correctable data error detected by the MD chiplet.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00440_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_HW_TIME_STAMP                                                 #
#                                                                        #
##########################################################################

%shub2_01_00441_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid Flag" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Time Stamp Value" ],
);

%shub2_01_00441_def =
( NAME    => "SH2_MD_HW_TIME_STAMP",
  ADDRESS => 0x0000000010071200,
  NOTE    => "The sh2_md_hw_time_stamp register stores the time stamp of the note first hardware error detected by the MD chiplet.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00441_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_UNCOR_TIME_STAMP                                              #
#                                                                        #
##########################################################################

%shub2_01_00442_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid Flag" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Time Stamp Value" ],
);

%shub2_01_00442_def =
( NAME    => "SH2_MD_UNCOR_TIME_STAMP",
  ADDRESS => 0x0000000010071280,
  NOTE    => "The sh2_md_uncor_time_stamp register stores the time stamp of the note first uncorrectable data error detected by the MD chiplet",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00442_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_COR_TIME_STAMP                                                #
#                                                                        #
##########################################################################

%shub2_01_00443_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid Flag" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Time Stamp Value" ],
);

%shub2_01_00443_def =
( NAME    => "SH2_PI_COR_TIME_STAMP",
  ADDRESS => 0x0000000010071300,
  NOTE    => "The sh2_pi_cor_time_stamp register stores the time stamp of the note first correctable data error detected by the PI chiplet.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00443_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_HW_TIME_STAMP                                                 #
#                                                                        #
##########################################################################

%shub2_01_00444_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid Flag" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Time Stamp Value" ],
);

%shub2_01_00444_def =
( NAME    => "SH2_PI_HW_TIME_STAMP",
  ADDRESS => 0x0000000010071380,
  NOTE    => "The sh2_pi_hw_time_stamp register stores the time stamp of the note first hardware error detected by the PI chiplet.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00444_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_UNCOR_TIME_STAMP                                              #
#                                                                        #
##########################################################################

%shub2_01_00445_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid Flag" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Time Stamp Value" ],
);

%shub2_01_00445_def =
( NAME    => "SH2_PI_UNCOR_TIME_STAMP",
  ADDRESS => 0x0000000010071400,
  NOTE    => "The sh2_pi_uncor_time_stamp register stores the time stamp of the note first uncorrectable data error detected by the PI chiplet",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00445_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_COR_TIME_STAMP                                                #
#                                                                        #
##########################################################################

%shub2_01_00446_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid Flag" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Time Stamp Value" ],
);

%shub2_01_00446_def =
( NAME    => "SH2_XN_COR_TIME_STAMP",
  ADDRESS => 0x0000000010071880,
  NOTE    => "The sh2_xn_cor_time_stamp register stores the time stamp of the note first correctable data error detected by the XN chiplet.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00446_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_HW_TIME_STAMP                                                 #
#                                                                        #
##########################################################################

%shub2_01_00447_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid Flag" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Time Stamp Value" ],
);

%shub2_01_00447_def =
( NAME    => "SH2_XN_HW_TIME_STAMP",
  ADDRESS => 0x0000000010071900,
  NOTE    => "The sh2_xn_hw_time_stamp register stores the time stamp of the note first hardware error detected by the XN chiplet.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00447_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_UNCOR_TIME_STAMP                                              #
#                                                                        #
##########################################################################

%shub2_01_00448_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid Flag" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Time Stamp Value" ],
);

%shub2_01_00448_def =
( NAME    => "SH2_XN_UNCOR_TIME_STAMP",
  ADDRESS => 0x0000000010071980,
  NOTE    => "The sh2_xn_uncor_time_stamp register stores the time stamp of the note first uncorrectable data error detected by the XN chiplet",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00448_flds
);


##########################################################################
#                                                                        #
#   SH2_DEBUG_PORT                                                       #
#                                                                        #
##########################################################################

%shub2_01_00449_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_NIBBLE7"                => [   1,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Debug port nibble 7" ],
   "DEBUG_NIBBLE6"                => [   2,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "Debug port nibble 6" ],
   "DEBUG_NIBBLE5"                => [   3,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Debug port nibble 5" ],
   "DEBUG_NIBBLE4"                => [   4,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "Debug port nibble 4" ],
   "DEBUG_NIBBLE3"                => [   5,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Debug port nibble 3" ],
   "DEBUG_NIBBLE2"                => [   6,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Debug port nibble 2" ],
   "DEBUG_NIBBLE1"                => [   7,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Debug port nibble 1" ],
   "DEBUG_NIBBLE0"                => [   8,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Debug port nibble 0" ],
);

%shub2_01_00449_def =
( NAME    => "SH2_DEBUG_PORT",
  ADDRESS => 0x0000000010072000,
  NOTE    => "The sh2_debug_port register is a copy of the data being sent to the note debug output port.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00449_flds
);


##########################################################################
#                                                                        #
#   SH2_LB_DEBUG_DATA                                                    #
#                                                                        #
##########################################################################

%shub2_01_00450_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LB_DATA"                      => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "LB debug data" ],
);

%shub2_01_00450_def =
( NAME    => "SH2_LB_DEBUG_DATA",
  ADDRESS => 0x0000000010072180,
  NOTE    => "The lb_debug_data register contains a copy of the debug data being note sent from the LB to the top level SHub2 debug mux.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00450_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DEBUG_DATA                                                    #
#                                                                        #
##########################################################################

%shub2_01_00451_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MD_DATA"                      => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "MD debug data" ],
);

%shub2_01_00451_def =
( NAME    => "SH2_MD_DEBUG_DATA",
  ADDRESS => 0x0000000010072200,
  NOTE    => "The sh2_md_debug_data register contains a copy of the debug data note being sent from the MD to the LB.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00451_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_DEBUG_DATA                                                    #
#                                                                        #
##########################################################################

%shub2_01_00452_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PI_DATA"                      => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "PI Debug Data" ],
);

%shub2_01_00452_def =
( NAME    => "SH2_PI_DEBUG_DATA",
  ADDRESS => 0x0000000010072280,
  NOTE    => "The sh2_pi_debug_data register contains a copy of the debug data note being sent from the PI to the LB.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00452_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_DEBUG_DATA                                                    #
#                                                                        #
##########################################################################

%shub2_01_00453_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_DATA"                      => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "XN debug data" ],
);

%shub2_01_00453_def =
( NAME    => "SH2_XN_DEBUG_DATA",
  ADDRESS => 0x0000000010072300,
  NOTE    => "The sh2_xn_debug_data register contains a copy of the debug data note being sent from the XN to the LB.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00453_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_DEBUG_DATA                                                    #
#                                                                        #
##########################################################################

%shub2_01_00454_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BT_DATA"                      => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "BT debug data" ],
);

%shub2_01_00454_def =
( NAME    => "SH2_BT_DEBUG_DATA",
  ADDRESS => 0x0000000010072380,
  NOTE    => "The sh2_bt_debug_data register contains a copy of the debug data note being sent from the BT to the LB.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00454_flds
);


##########################################################################
#                                                                        #
#   SH2_OB_LA_STATUS                                                     #
#                                                                        #
##########################################################################

%shub2_01_00455_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  40,  24, 0xFFFFFF0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BUFFER_ADDR"                  => [   1,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Buffer Address" ],
   "RSVD1"                        => [   2,  25,   7, 0x00000000FE000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGERED"                    => [   3,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Buffer Recording Triggered" ],
   "RSVD2"                        => [   4,  17,   7, 0x0000000000FE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RECORD"                       => [   5,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Buffer Recording On" ],
   "NCWRF"                        => [   6,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "Outstanding NCWRF Count" ],
);

%shub2_01_00455_def =
( NAME    => "SH2_OB_LA_STATUS",
  ADDRESS => 0x0000000010072800,
  NOTE    => "The OB_LA_STATUS register contains the status of the on board logic note analyzer buffer.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00455_flds
);


##########################################################################
#                                                                        #
#   SH2_OB_LA_SEQUENCE                                                   #
#                                                                        #
##########################################################################

%shub2_01_00456_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RTC"                          => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 1, 0x0000000000000000, "RTC Count" ],
   "SEQUENCE"                     => [   1,   0,   9, 0x00000000000001FF, 0x00, 1, 0x0000000000000000, "Current Sequence Number" ],
);

%shub2_01_00456_def =
( NAME    => "SH2_OB_LA_SEQUENCE",
  ADDRESS => 0x0000000010072880,
  NOTE    => "The OB_LA_SEQUENCE register contains the sequence number of the note last cache line saved in the logic analyzer buffer.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00456_flds
);


##########################################################################
#                                                                        #
#   SH2_OB_LA_CURRENT_ADDR                                               #
#                                                                        #
##########################################################################

%shub2_01_00457_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDRESS"                      => [   1,   7,  31, 0x0000003FFFFFFF80, 0x00, 1, 0x0000000000000000, "Current Memory Address" ],
);

%shub2_01_00457_def =
( NAME    => "SH2_OB_LA_CURRENT_ADDR",
  ADDRESS => 0x0000000010072900,
  NOTE    => "The OB_LA_CURRENT_ADDR register contains the current memory address note for the on board logic analyzer buffer.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00457_flds
);


##########################################################################
#                                                                        #
#   SH2_TSF_ARMED_STATE                                                  #
#                                                                        #
##########################################################################

%shub2_01_00458_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STATE"                        => [   1,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility armed state" ],
);

%shub2_01_00458_def =
( NAME    => "SH2_TSF_ARMED_STATE",
  ADDRESS => 0x0000000010073000,
  NOTE    => "The sh2_tsf_armed_state MMR contains the armed state for each of note the trigger sequencing variables. Bit 0 is the armed state",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00458_flds
);


##########################################################################
#                                                                        #
#   SH2_TSF_COUNTER_VALUE                                                #
#                                                                        #
##########################################################################

%shub2_01_00459_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COUNT_8A"                     => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 8a" ],
   "COUNT_8B"                     => [   1,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 8b" ],
   "COUNT_16"                     => [   2,  32,  16, 0x0000FFFF00000000, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 16" ],
   "COUNT_32"                     => [   3,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 32" ],
);

%shub2_01_00459_def =
( NAME    => "SH2_TSF_COUNTER_VALUE",
  ADDRESS => 0x0000000010073080,
  NOTE    => "The sh2_tsf_counter_value register contains the counter values of note the trigger sequencing down counters. These counters are ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00459_flds
);


##########################################################################
#                                                                        #
#   SH2_TSF_TRIGGERED_STATE                                              #
#                                                                        #
##########################################################################

%shub2_01_00460_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STATE"                        => [   1,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility triggered state" ],
);

%shub2_01_00460_def =
( NAME    => "SH2_TSF_TRIGGERED_STATE",
  ADDRESS => 0x0000000010073100,
  NOTE    => "The sh2_tsf_triggered_state contains the triggered state for each note of the trigger sequencing variables. Bit 0 is the trigger",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00460_flds
);


##########################################################################
#                                                                        #
#   SH2_VEC_RDDATA                                                       #
#                                                                        #
##########################################################################

%shub2_01_00461_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data" ],
);

%shub2_01_00461_def =
( NAME    => "SH2_VEC_RDDATA",
  ADDRESS => 0x0000000010074000,
  NOTE    => "This register contains the vector PIO read data, if any. The LB note will not modify this register's value if an incoming reply ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00461_flds
);


##########################################################################
#                                                                        #
#   SH2_VEC_RETURN                                                       #
#                                                                        #
##########################################################################

%shub2_01_00462_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ROUTE"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Route" ],
);

%shub2_01_00462_def =
( NAME    => "SH2_VEC_RETURN",
  ADDRESS => 0x0000000010074080,
  NOTE    => "This register contains the return vector PIO route. The LB will not note modify this register's value if an incoming reply packe",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00462_flds
);


##########################################################################
#                                                                        #
#   SH2_VEC_STATUS                                                       #
#                                                                        #
##########################################################################

%shub2_01_00463_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATUS_VALID"                 => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Status_Valid" ],
   "OVERRUN"                      => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Overrun" ],
   "SOURCE"                       => [   2,  46,  16, 0x3FFFC00000000000, 0x00, 0, 0x0000000000000000, "Source" ],
   "PIO_ID"                       => [   3,  35,  11, 0x00003FF800000000, 0x00, 0, 0x0000000000000000, "PIO ID" ],
   "ADDRESS"                      => [   4,   3,  32, 0x00000007FFFFFFF8, 0x00, 0, 0x0000000000000000, "Address" ],
   "TYPE"                         => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Type" ],
);

%shub2_01_00463_def =
( NAME    => "SH2_VEC_STATUS",
  ADDRESS => 0x0000000010074100,
  NOTE    => "This register contains the vector PIO return status. Software note should clear this register before launching a vector PIO requ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00463_flds
);


##########################################################################
#                                                                        #
#   SH2_VEC_STATUS_ALIAS                                                 #
#                                                                        #
##########################################################################

%shub2_01_00464_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATUS_VALID"                 => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Status_Valid" ],
   "OVERRUN"                      => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Overrun" ],
   "SOURCE"                       => [   2,  46,  16, 0x3FFFC00000000000, 0x00, 0, 0x0000000000000000, "Source" ],
   "PIO_ID"                       => [   3,  35,  11, 0x00003FF800000000, 0x00, 0, 0x0000000000000000, "PIO ID" ],
   "ADDRESS"                      => [   4,   3,  32, 0x00000007FFFFFFF8, 0x00, 0, 0x0000000000000000, "Address" ],
   "TYPE"                         => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Type" ],
);

%shub2_01_00464_def =
( NAME    => "SH2_VEC_STATUS_ALIAS",
  ADDRESS => 0x0000000010074108,
  NOTE    => "The VEC_STATUS_ALIAS is the alias address for the VEC_STATUS note registers. Refer to the VEC_STATUS description and its note AL",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00464_flds
);


##########################################################################
#                                                                        #
#   SH2_LOGIC_ANALYZER_BUFFER                                            #
#                                                                        #
##########################################################################

%shub2_01_00465_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Logic Analyzer Data" ],
);

%shub2_01_00465_def =
( NAME    => "SH2_LOGIC_ANALYZER_BUFFER",
  ADDRESS => 0x0000000010075000,
  NOTE    => "The logic_analyzer_buffer is a 64 bit by 256 word deep buffer for note the on-board logic analzyer. When enabled, debug port dat",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00465_flds
);


##########################################################################
#                                                                        #
#   SH2_THROTTLE_STATUS                                                  #
#                                                                        #
##########################################################################

%shub2_01_00466_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIME"                         => [   1,  32,  30, 0x3FFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Current throttle time count" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INTERVAL"                     => [   3,   0,  30, 0x000000003FFFFFFF, 0x00, 0, 0x0000000000000000, "Current throttle interval count" ],
);

%shub2_01_00466_def =
( NAME    => "SH2_THROTTLE_STATUS",
  ADDRESS => 0x0000000010077000,
  NOTE    => "The sh2_throttle_status register contains the counter values of the note throttle interval counter and throttle time counter.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00466_flds
);


##########################################################################
#                                                                        #
#   SH2_MMRBIST_ERR                                                      #
#                                                                        #
##########################################################################

%shub2_01_00467_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  39,  25, 0xFFFFFF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CANCELLED"                    => [   1,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "mmr/bist was cancelled" ],
   "MULTIPLE_DETECTED"            => [   2,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "multiple errors detected flag" ],
   "DETECTED"                     => [   3,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "error detected flag" ],
   "RSVD1"                        => [   4,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR"                         => [   5,   0,  35, 0x00000007FFFFFFFF, 0x00, 0, 0x0000000000000000, "dword address of bist error" ],
);

%shub2_01_00467_def =
( NAME    => "SH2_MMRBIST_ERR",
  ADDRESS => 0x0000000000000080,
  NOTE    => "This register may be used to monitor the status of the most recent note memory bist read sequence. The error flags are cleared b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00467_flds
);


##########################################################################
#                                                                        #
#   SH2_MISC_ERR_HDR_LOWER                                               #
#                                                                        #
##########################################################################

%shub2_01_00468_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "set when capture occurs" ],
   "RSVD0"                        => [   1,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE"                        => [   2,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "reference is a write" ],
   "SRC"                          => [   3,  44,  16, 0x0FFFF00000000000, 0x00, 0, 0x0000000000000000, "source node of reference" ],
   "CMD"                          => [   4,  36,   8, 0x00000FF000000000, 0x00, 0, 0x0000000000000000, "command of reference" ],
);

%shub2_01_00468_def =
( NAME    => "SH2_MISC_ERR_HDR_LOWER",
  ADDRESS => 0x0000000000000088,
  NOTE    => "This register logs some of the bits of the header on the first note occurrence of a packet or directory protocol error.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00468_flds
);


##########################################################################
#                                                                        #
#   SH2_MISC_ERR_HDR_UPPER                                               #
#                                                                        #
##########################################################################

%shub2_01_00469_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  29,  35, 0xFFFFFFFFE0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECHO"                         => [   1,  20,   9, 0x000000001FF00000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   2,   8,  12, 0x00000000000FFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_PKT_SIZE"                  => [   3,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "indicates a pkt size error from xn" ],
   "PI_PKT_SIZE"                  => [   4,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "indicates a pkt size error from pi" ],
   "DIR_ACC"                      => [   5,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "indicates a data request to directory memory error captured" ],
   "RMW_COR"                      => [   6,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "indicates a correctable store rmw" ],
   "RMW_UC"                       => [   7,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "indicates an uncorrectable store rmw" ],
   "NONEXIST_ADDR"                => [   8,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "indicates a non-existent memory error captured" ],
   "ILLEGAL_CMD"                  => [   9,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "indicates an illegal command error captured" ],
   "DIR_PROTOCOL"                 => [  10,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "indicates a directory protocol error captured" ],
);

%shub2_01_00469_def =
( NAME    => "SH2_MISC_ERR_HDR_UPPER",
  ADDRESS => 0x0000000000000090,
  NOTE    => "This register logs some of the bits of the header on the first note capture of a packet or directory protocol error. A valid is ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00469_flds
);


##########################################################################
#                                                                        #
#   SH2_DIR_UC_ERR_HDR_LOWER                                             #
#                                                                        #
##########################################################################

%shub2_01_00470_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "set when capture occurs" ],
   "RSVD0"                        => [   1,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE"                        => [   2,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "reference is a write" ],
   "SRC"                          => [   3,  44,  16, 0x0FFFF00000000000, 0x00, 0, 0x0000000000000000, "source node of reference" ],
   "CMD"                          => [   4,  36,   8, 0x00000FF000000000, 0x00, 0, 0x0000000000000000, "command of reference" ],
);

%shub2_01_00470_def =
( NAME    => "SH2_DIR_UC_ERR_HDR_LOWER",
  ADDRESS => 0x0000000000000098,
  NOTE    => "This register logs some of the bits of the header on the first note occurrence of an uncorrectable directory error.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00470_flds
);


##########################################################################
#                                                                        #
#   SH2_DIR_UC_ERR_HDR_UPPER                                             #
#                                                                        #
##########################################################################

%shub2_01_00471_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  29,  35, 0xFFFFFFFFE0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECHO"                         => [   1,  20,   9, 0x000000001FF00000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   2,   4,  16, 0x00000000000FFFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR_UC"                       => [   3,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "indicates uncorrectable directory error captured" ],
);

%shub2_01_00471_def =
( NAME    => "SH2_DIR_UC_ERR_HDR_UPPER",
  ADDRESS => 0x00000000000000a0,
  NOTE    => "This register logs some of the bits of the header on the first note capture of an uncorrectable directory error. A valid is capt",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00471_flds
);


##########################################################################
#                                                                        #
#   SH2_DIR_COR_ERR_HDR_LOWER                                            #
#                                                                        #
##########################################################################

%shub2_01_00472_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "set when capture occurs" ],
   "RSVD0"                        => [   1,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE"                        => [   2,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "reference is a write" ],
   "SRC"                          => [   3,  44,  16, 0x0FFFF00000000000, 0x00, 0, 0x0000000000000000, "source node of reference" ],
   "CMD"                          => [   4,  36,   8, 0x00000FF000000000, 0x00, 0, 0x0000000000000000, "command of reference" ],
);

%shub2_01_00472_def =
( NAME    => "SH2_DIR_COR_ERR_HDR_LOWER",
  ADDRESS => 0x00000000000000a8,
  NOTE    => "This register logs some of the bits of the header on the first note occurrence of a correctable directory error.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00472_flds
);


##########################################################################
#                                                                        #
#   SH2_DIR_COR_ERR_HDR_UPPER                                            #
#                                                                        #
##########################################################################

%shub2_01_00473_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  29,  35, 0xFFFFFFFFE0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECHO"                         => [   1,  20,   9, 0x000000001FF00000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   2,   9,  11, 0x00000000000FFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR_COR"                      => [   3,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "indicates correctable directory error captured" ],
);

%shub2_01_00473_def =
( NAME    => "SH2_DIR_COR_ERR_HDR_UPPER",
  ADDRESS => 0x00000000000000b0,
  NOTE    => "This register logs some of the bits of the header on the first note capture of a correctable directory error. A valid is capture",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00473_flds
);


##########################################################################
#                                                                        #
#   SH2_MEM_ERROR_SUMMARY                                                #
#                                                                        #
##########################################################################

%shub2_01_00474_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  44,  20, 0xFFFFF00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INCOMING_XN_REQUEST_OVERFLOW" => [   1,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: MD-to-XN Request Queue Overflow Error Overflow" ],
   "INCOMING_PI_REQUEST_OVERFLOW" => [   2,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: MD-to-PI Request Queue Overflow Error Overflow" ],
   "INCOMING_XN_REPLY_OVERFLOW"   => [   3,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: MD-to-XN Reply Queue Overflow Error Overflow" ],
   "INCOMING_PI_REPLY_OVERFLOW"   => [   4,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: MD-to-PI Reply Queue Overflow Error Overflow" ],
   "BIST_DONE"                    => [   5,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: MMRBIST completed or had error" ],
   "ACY_PTY_ERR_R"                => [   6,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: ACY left side address parity Error" ],
   "ACY_PTY_ERR_L"                => [   7,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: ACY left side address parity Error" ],
   "ACX_PTY_ERR_R"                => [   8,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: ACX right side address parity Error" ],
   "ACX_PTY_ERR_L"                => [   9,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: ACX left side address parity Error" ],
   "XN_PKT_SIZE"                  => [  10,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: XN-to-MD Message Length Error" ],
   "PI_PKT_SIZE"                  => [  11,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: PI-to-MD Message Length Error" ],
   "RED_BLACK_ERR_TIMEOUT"        => [  12,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: Red/Black Time-out Error" ],
   "XN_REQUEST_OVERFLOW"          => [  13,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: XN-to-MD Request Queue Overflow Error" ],
   "PI_REQUEST_OVERFLOW"          => [  14,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: PI-to-MD Request Queue Overflow Error" ],
   "XN_REPLY_OVERFLOW"            => [  15,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: XN-to-MD Reply Queue Overflow Error" ],
   "PI_REPLY_OVERFLOW"            => [  16,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: PI-to-MD Reply Queue Overflow Error" ],
   "RSVD1"                        => [  17,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQRS_INT_HW"                  => [  18,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: DQRS Hardware Error" ],
   "DQRS_INT_COR"                 => [  19,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "MD_CE_INT: DQRS Correctable AMO Data Error" ],
   "DQRS_INT_UC"                  => [  20,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "MD_UCE_INT: DQRS Uncorrectable AMO Data Error" ],
   "RSVD2"                        => [  21,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQRP_INT_HW"                  => [  22,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: DQRP Hardware Error" ],
   "DQRP_INT_COR"                 => [  23,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "MD_CE_INT: DQRP Correctable AMO Data Error" ],
   "DQRP_INT_UC"                  => [  24,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MD_UCE_INT: DQRP Uncorrectable AMO Data Error" ],
   "RSVD3"                        => [  25,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQLS_INT_HW"                  => [  26,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: DQLS Hardware Error" ],
   "DQLS_INT_COR"                 => [  27,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD_CE_INT: DQLS Correctable AMO Data Error" ],
   "DQLS_INT_UC"                  => [  28,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD_UCE_INT: DQLS Uncorrectable AMO Data Error" ],
   "RSVD4"                        => [  29,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQLP_INT_HW"                  => [  30,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: DQLP Hardware Error" ],
   "DQLP_INT_COR"                 => [  31,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "MD_CE_INT: DQLP Correctable AMO Data Error" ],
   "DQLP_INT_UC"                  => [  32,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "MD_UCE_INT: DQLP Uncorrectable AMO Data Error" ],
   "RSVD5"                        => [  33,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR_ACC"                      => [  34,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "MD_HW_INT: Directory Memory Access Error" ],
   "ACY_INT_HW"                   => [  35,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "MD_HW_INT: ACY Hardware Error" ],
   "ACX_INT_HW"                   => [  36,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "MD_HW_INT: ACX Hardware Error" ],
   "DQRP_DIR_COR"                 => [  37,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "MD_CE_INT: DQRP Correctable Directory Data Error" ],
   "DQRP_DIR_UC"                  => [  38,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "MD_UCE_INT: DQRP Uncorrectable Directory Data Error" ],
   "DQLP_DIR_COR"                 => [  39,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "MD_CE_INT: DQLP Correctable Directory Data Error" ],
   "DQLP_DIR_UC"                  => [  40,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "MD_UCE_INT: DQLP Uncorrectable Directory Data Error" ],
   "DQRP_DIR_PERR"                => [  41,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "MD_HW_INT: DQRP Directory Protocol Error" ],
   "DQLP_DIR_PERR"                => [  42,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "MD_HW_INT: DQLP Directory Protocol Error" ],
   "NONEXIST_ADDR"                => [  43,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "MD_HW_INT: Non-existent Memory Address Error" ],
   "ILLEGAL_CMD"                  => [  44,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "MD_HW_INT: Illegal Command Error" ],
);

%shub2_01_00474_def =
( NAME    => "SH2_MEM_ERROR_SUMMARY",
  ADDRESS => 0x00000000000000b8,
  NOTE    => "The MEM_ERROR_SUMMARY register is the MD's top-level error flag note register. It contains 30 flags. Each flag corresponds to on",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00474_flds
);


##########################################################################
#                                                                        #
#   SH2_MEM_ERROR_SUMMARY_ALIAS                                          #
#                                                                        #
##########################################################################

%shub2_01_00475_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  44,  20, 0xFFFFF00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INCOMING_XN_REQUEST_OVERFLOW" => [   1,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: MD-to-XN Request Queue Overflow Error Overflow" ],
   "INCOMING_PI_REQUEST_OVERFLOW" => [   2,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: MD-to-PI Request Queue Overflow Error Overflow" ],
   "INCOMING_XN_REPLY_OVERFLOW"   => [   3,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: MD-to-XN Reply Queue Overflow Error Overflow" ],
   "INCOMING_PI_REPLY_OVERFLOW"   => [   4,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: MD-to-PI Reply Queue Overflow Error Overflow" ],
   "BIST_DONE"                    => [   5,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: MMRBIST completed or had error" ],
   "ACY_PTY_ERR_R"                => [   6,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: ACY left side address parity Error" ],
   "ACY_PTY_ERR_L"                => [   7,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: ACY left side address parity Error" ],
   "ACX_PTY_ERR_R"                => [   8,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: ACX right side address parity Error" ],
   "ACX_PTY_ERR_L"                => [   9,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: ACX left side address parity Error" ],
   "XN_PKT_SIZE"                  => [  10,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: XN-to-MD Message Length Error" ],
   "PI_PKT_SIZE"                  => [  11,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: PI-to-MD Message Length Error" ],
   "RED_BLACK_ERR_TIMEOUT"        => [  12,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: Red/Black Time-out Error" ],
   "XN_REQUEST_OVERFLOW"          => [  13,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: XN-to-MD Request Queue Overflow Error" ],
   "PI_REQUEST_OVERFLOW"          => [  14,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: PI-to-MD Request Queue Overflow Error" ],
   "XN_REPLY_OVERFLOW"            => [  15,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: XN-to-MD Reply Queue Overflow Error" ],
   "PI_REPLY_OVERFLOW"            => [  16,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: PI-to-MD Reply Queue Overflow Error" ],
   "RSVD1"                        => [  17,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQRS_INT_HW"                  => [  18,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: DQRS Hardware Error" ],
   "DQRS_INT_COR"                 => [  19,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "MD_CE_INT: DQRS Correctable AMO Data Error" ],
   "DQRS_INT_UC"                  => [  20,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "MD_UCE_INT: DQRS Uncorrectable AMO Data Error" ],
   "RSVD2"                        => [  21,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQRP_INT_HW"                  => [  22,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: DQRP Hardware Error" ],
   "DQRP_INT_COR"                 => [  23,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "MD_CE_INT: DQRP Correctable AMO Data Error" ],
   "DQRP_INT_UC"                  => [  24,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MD_UCE_INT: DQRP Uncorrectable AMO Data Error" ],
   "RSVD3"                        => [  25,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQLS_INT_HW"                  => [  26,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: DQLS Hardware Error" ],
   "DQLS_INT_COR"                 => [  27,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD_CE_INT: DQLS Correctable AMO Data Error" ],
   "DQLS_INT_UC"                  => [  28,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD_UCE_INT: DQLS Uncorrectable AMO Data Error" ],
   "RSVD4"                        => [  29,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQLP_INT_HW"                  => [  30,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: DQLP Hardware Error" ],
   "DQLP_INT_COR"                 => [  31,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "MD_CE_INT: DQLP Correctable AMO Data Error" ],
   "DQLP_INT_UC"                  => [  32,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "MD_UCE_INT: DQLP Uncorrectable AMO Data Error" ],
   "RSVD5"                        => [  33,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR_ACC"                      => [  34,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "MD_HW_INT: Directory Memory Access Error" ],
   "ACY_INT_HW"                   => [  35,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "MD_HW_INT: ACY Hardware Error" ],
   "ACX_INT_HW"                   => [  36,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "MD_HW_INT: ACX Hardware Error" ],
   "DQRP_DIR_COR"                 => [  37,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "MD_CE_INT: DQRP Correctable Directory Data Error" ],
   "DQRP_DIR_UC"                  => [  38,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "MD_UCE_INT: DQRP Uncorrectable Directory Data Error" ],
   "DQLP_DIR_COR"                 => [  39,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "MD_CE_INT: DQLP Correctable Directory Data Error" ],
   "DQLP_DIR_UC"                  => [  40,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "MD_UCE_INT: DQLP Uncorrectable Directory Data Error" ],
   "DQRP_DIR_PERR"                => [  41,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "MD_HW_INT: DQRP Directory Protocol Error" ],
   "DQLP_DIR_PERR"                => [  42,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "MD_HW_INT: DQLP Directory Protocol Error" ],
   "NONEXIST_ADDR"                => [  43,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "MD_HW_INT: Non-existent Memory Address Error" ],
   "ILLEGAL_CMD"                  => [  44,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "MD_HW_INT: Illegal Command Error" ],
);

%shub2_01_00475_def =
( NAME    => "SH2_MEM_ERROR_SUMMARY_ALIAS",
  ADDRESS => 0x00000000000000c0,
  NOTE    => "The MEM_ERROR_SUMMARY_ALIAS address is an alias to the note MEM_ERROR_SUMMARY register. Refer to the MEM_ERROR_SUMMARY register ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00475_flds
);


##########################################################################
#                                                                        #
#   SH2_MEM_ERROR_OVERFLOW                                               #
#                                                                        #
##########################################################################

%shub2_01_00476_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  43,  21, 0xFFFFF80000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INCOMING_XN_REQUEST_OVERFLOW" => [   1,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: MD-to-XN Request Queue Overflow Error Overflow" ],
   "INCOMING_PI_REQUEST_OVERFLOW" => [   2,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: MD-to-PI Request Queue Overflow Error Overflow" ],
   "INCOMING_XN_REPLY_OVERFLOW"   => [   3,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: MD-to-XN Reply Queue Overflow Error Overflow" ],
   "INCOMING_PI_REPLY_OVERFLOW"   => [   4,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: MD-to-PI Reply Queue Overflow Error Overflow" ],
   "ACY_PTY_ERR_R"                => [   5,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: ACY left side address parity Error Overflow" ],
   "ACY_PTY_ERR_L"                => [   6,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: ACY left side address parity Error Overflow" ],
   "ACX_PTY_ERR_R"                => [   7,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: ACX right side address parity Error Overflow" ],
   "ACX_PTY_ERR_L"                => [   8,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: ACX left side address parity Error Overflow" ],
   "XN_PKT_SIZE"                  => [   9,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: XN-to-MD Message Length Error Overflow" ],
   "PI_PKT_SIZE"                  => [  10,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: PI-to-MD Message Length Error Overflow" ],
   "RED_BLACK_ERR_TIMEOUT"        => [  11,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: Red/Black Time-out Error Overflow" ],
   "XN_REQUEST_OVERFLOW"          => [  12,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: XN-to-MD Request Queue Overflow Error Overflow" ],
   "PI_REQUEST_OVERFLOW"          => [  13,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: PI-to-MD Request Queue Overflow Error Overflow" ],
   "XN_REPLY_OVERFLOW"            => [  14,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: XN-to-MD Reply Queue Overflow Error Overflow" ],
   "PI_REPLY_OVERFLOW"            => [  15,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: PI-to-MD Reply Queue Overflow Error Overflow" ],
   "RSVD1"                        => [  16,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQRS_INT_HW"                  => [  17,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: DQRS Hardware Error Overflow" ],
   "DQRS_INT_COR"                 => [  18,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "MD_CE_INT: DQRS Correctable AMO Data Error Overflow" ],
   "DQRS_INT_UC"                  => [  19,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "MD_UCE_INT: DQRS Uncorrectable AMO Data Error Overflow" ],
   "RSVD2"                        => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQRP_INT_HW"                  => [  21,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: DQRP Hardware Error Overflow" ],
   "DQRP_INT_COR"                 => [  22,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "MD_CE_INT: DQRP Correctable AMO Data Error Overflow" ],
   "DQRP_INT_UC"                  => [  23,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MD_UCE_INT: DQRP Uncorrectable AMO Data Error Overflow" ],
   "RSVD3"                        => [  24,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQLS_INT_HW"                  => [  25,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: DQLS Hardware Error Overflow" ],
   "DQLS_INT_COR"                 => [  26,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD_CE_INT: DQLS Correctable AMO Data Error Overflow" ],
   "DQLS_INT_UC"                  => [  27,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD_UCE_INT: DQLS Uncorrectable AMO Data Error Overflow" ],
   "RSVD4"                        => [  28,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQLP_INT_HW"                  => [  29,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: DQLP Hardware Error Overflow" ],
   "DQLP_INT_COR"                 => [  30,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "MD_CE_INT: DQLP Correctable AMO Data Error Overflow" ],
   "DQLP_INT_UC"                  => [  31,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "MD_UCE_INT: DQLP Uncorrectable AMO Data Error Overflow" ],
   "RSVD5"                        => [  32,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR_ACC"                      => [  33,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "MD_HW_INT: Directory Access Error Overflow" ],
   "ACY_INT_HW"                   => [  34,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "MD_HW_INT: ACY Hardware Error Overflow" ],
   "ACX_INT_HW"                   => [  35,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "MD_HW_INT: ACX Hardware Error Overflow" ],
   "DQRP_DIR_COR"                 => [  36,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "MD_CE_INT: DQRP Correctable Directory Data Error Overflow" ],
   "DQRP_DIR_UC"                  => [  37,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "MD_UCE_INT: DQRP Uncorrectable Directory Data Error Overflow" ],
   "DQLP_DIR_COR"                 => [  38,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "MD_CE_INT: DQLP Correctable Directory Data Error Overflow" ],
   "DQLP_DIR_UC"                  => [  39,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "MD_UCE_INT: DQLP Uncorrectable Directory Data Error Overflow" ],
   "DQRP_DIR_PERR"                => [  40,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "MD_HW_INT: DQRP Directory Protocol Error Overflow" ],
   "DQLP_DIR_PERR"                => [  41,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "MD_HW_INT: DQLP Directory Protocol Error Overflow" ],
   "NONEXIST_ADDR"                => [  42,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "MD_HW_INT: Non-existent Memory Address Error Overflow" ],
   "ILLEGAL_CMD"                  => [  43,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "MD_HW_INT: Illegal Command Error Overflow" ],
);

%shub2_01_00476_def =
( NAME    => "SH2_MEM_ERROR_OVERFLOW",
  ADDRESS => 0x00000000000000c8,
  NOTE    => "The MEM_ERROR_OVERFLOW register contains 30 flags. Each flag note corresponds to 1 of the 30 errors detected by the MD chiplet. ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00476_flds
);


##########################################################################
#                                                                        #
#   SH2_MEM_ERROR_OVERFLOW_ALIAS                                         #
#                                                                        #
##########################################################################

%shub2_01_00477_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  43,  21, 0xFFFFF80000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INCOMING_XN_REQUEST_OVERFLOW" => [   1,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: MD-to-XN Request Queue Overflow Error Overflow" ],
   "INCOMING_PI_REQUEST_OVERFLOW" => [   2,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: MD-to-PI Request Queue Overflow Error Overflow" ],
   "INCOMING_XN_REPLY_OVERFLOW"   => [   3,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: MD-to-XN Reply Queue Overflow Error Overflow" ],
   "INCOMING_PI_REPLY_OVERFLOW"   => [   4,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: MD-to-PI Reply Queue Overflow Error Overflow" ],
   "ACY_PTY_ERR_R"                => [   5,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: ACY left side address parity Error Overflow" ],
   "ACY_PTY_ERR_L"                => [   6,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: ACY left side address parity Error Overflow" ],
   "ACX_PTY_ERR_R"                => [   7,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: ACX right side address parity Error Overflow" ],
   "ACX_PTY_ERR_L"                => [   8,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: ACX left side address parity Error Overflow" ],
   "XN_PKT_SIZE"                  => [   9,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: XN-to-MD Message Length Error Overflow" ],
   "PI_PKT_SIZE"                  => [  10,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: PI-to-MD Message Length Error Overflow" ],
   "RED_BLACK_ERR_TIMEOUT"        => [  11,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: Red/Black Time-out Error Overflow" ],
   "XN_REQUEST_OVERFLOW"          => [  12,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: XN-to-MD Request Queue Overflow Error Overflow" ],
   "PI_REQUEST_OVERFLOW"          => [  13,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: PI-to-MD Request Queue Overflow Error Overflow" ],
   "XN_REPLY_OVERFLOW"            => [  14,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: XN-to-MD Reply Queue Overflow Error Overflow" ],
   "PI_REPLY_OVERFLOW"            => [  15,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: PI-to-MD Reply Queue Overflow Error Overflow" ],
   "RSVD1"                        => [  16,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQRS_INT_HW"                  => [  17,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: DQRS Hardware Error Overflow" ],
   "DQRS_INT_COR"                 => [  18,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "MD_CE_INT: DQRS Correctable AMO Data Error Overflow" ],
   "DQRS_INT_UC"                  => [  19,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "MD_UCE_INT: DQRS Uncorrectable AMO Data Error Overflow" ],
   "RSVD2"                        => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQRP_INT_HW"                  => [  21,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: DQRP Hardware Error Overflow" ],
   "DQRP_INT_COR"                 => [  22,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "MD_CE_INT: DQRP Correctable AMO Data Error Overflow" ],
   "DQRP_INT_UC"                  => [  23,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MD_UCE_INT: DQRP Uncorrectable AMO Data Error Overflow" ],
   "RSVD3"                        => [  24,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQLS_INT_HW"                  => [  25,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: DQLS Hardware Error Overflow" ],
   "DQLS_INT_COR"                 => [  26,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD_CE_INT: DQLS Correctable AMO Data Error Overflow" ],
   "DQLS_INT_UC"                  => [  27,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD_UCE_INT: DQLS Uncorrectable AMO Data Error Overflow" ],
   "RSVD4"                        => [  28,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQLP_INT_HW"                  => [  29,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: DQLP Hardware Error Overflow" ],
   "DQLP_INT_COR"                 => [  30,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "MD_CE_INT: DQLP Correctable AMO Data Error Overflow" ],
   "DQLP_INT_UC"                  => [  31,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "MD_UCE_INT: DQLP Uncorrectable AMO Data Error Overflow" ],
   "RSVD5"                        => [  32,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR_ACC"                      => [  33,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "MD_HW_INT: Directory Access Error Overflow" ],
   "ACY_INT_HW"                   => [  34,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "MD_HW_INT: ACY Hardware Error Overflow" ],
   "ACX_INT_HW"                   => [  35,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "MD_HW_INT: ACX Hardware Error Overflow" ],
   "DQRP_DIR_COR"                 => [  36,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "MD_CE_INT: DQRP Correctable Directory Data Error Overflow" ],
   "DQRP_DIR_UC"                  => [  37,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "MD_UCE_INT: DQRP Uncorrectable Directory Data Error Overflow" ],
   "DQLP_DIR_COR"                 => [  38,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "MD_CE_INT: DQLP Correctable Directory Data Error Overflow" ],
   "DQLP_DIR_UC"                  => [  39,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "MD_UCE_INT: DQLP Uncorrectable Directory Data Error Overflow" ],
   "DQRP_DIR_PERR"                => [  40,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "MD_HW_INT: DQRP Directory Protocol Error Overflow" ],
   "DQLP_DIR_PERR"                => [  41,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "MD_HW_INT: DQLP Directory Protocol Error Overflow" ],
   "NONEXIST_ADDR"                => [  42,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "MD_HW_INT: Non-existent Memory Address Error Overflow" ],
   "ILLEGAL_CMD"                  => [  43,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "MD_HW_INT: Illegal Command Error Overflow" ],
);

%shub2_01_00477_def =
( NAME    => "SH2_MEM_ERROR_OVERFLOW_ALIAS",
  ADDRESS => 0x00000000000000d0,
  NOTE    => "The MEM_ERROR_OVERFLOW_ALIAS address is an alias to the note MEM_ERROR_OVERFLOW register. Refer to the MEM_ERROR_OVERFLOW note r",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00477_flds
);


##########################################################################
#                                                                        #
#   SH2_MEM_ERROR_MASK                                                   #
#                                                                        #
##########################################################################

%shub2_01_00478_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  44,  20, 0xFFFFF00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INCOMING_XN_REQUEST_OVERFLOW" => [   1,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: MD-to-XN Request Queue Overflow Error Overflow Mask" ],
   "INCOMING_PI_REQUEST_OVERFLOW" => [   2,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: MD-to-PI Request Queue Overflow Error Overflow Mask" ],
   "INCOMING_XN_REPLY_OVERFLOW"   => [   3,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: MD-to-XN Reply Queue Overflow Error Overflow Mask" ],
   "INCOMING_PI_REPLY_OVERFLOW"   => [   4,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: MD-to-PI Reply Queue Overflow Error Overflow Mask" ],
   "BIST_DONE"                    => [   5,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: MMRBIST completed or had error Mask" ],
   "ACY_PTY_ERR_R"                => [   6,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: ACY left side address parity Error Mask" ],
   "ACY_PTY_ERR_L"                => [   7,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: ACY left side address parity Error Mask" ],
   "ACX_PTY_ERR_R"                => [   8,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: ACX right side address parity Error Mask" ],
   "ACX_PTY_ERR_L"                => [   9,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: ACX left side address parity Error Mask" ],
   "XN_PKT_SIZE"                  => [  10,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: XN-to-MD Message Length Error Mask" ],
   "PI_PKT_SIZE"                  => [  11,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: PI-to-MD Message Length Error Mask" ],
   "RED_BLACK_ERR_TIMEOUT"        => [  12,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Red/Black Time-out Error Mask" ],
   "XN_REQUEST_OVERFLOW"          => [  13,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: XN-to-MD Request Queue Overflow Error Mask" ],
   "PI_REQUEST_OVERFLOW"          => [  14,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: PI-to-MD Request Queue Overflow Error Mask" ],
   "XN_REPLY_OVERFLOW"            => [  15,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: XN-to-MD Reply Queue Overflow Error Mask" ],
   "PI_REPLY_OVERFLOW"            => [  16,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: PI-to-MD Reply Queue Overflow Error Mask" ],
   "RSVD1"                        => [  17,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQRS_INT_HW"                  => [  18,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQRS Hardware Error Mask" ],
   "DQRS_INT_COR"                 => [  19,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQRS Correctable AMO Data Error Mask" ],
   "DQRS_INT_UC"                  => [  20,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQRS Uncorrectable AMO Data Error Mask" ],
   "RSVD2"                        => [  21,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQRP_INT_HW"                  => [  22,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQRP Hardware Error Mask" ],
   "DQRP_INT_COR"                 => [  23,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQRP Correctable AMO Data Error Mask" ],
   "DQRP_INT_UC"                  => [  24,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQRP Uncorrectable AMO Data Error Mask" ],
   "RSVD3"                        => [  25,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQLS_INT_HW"                  => [  26,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQLS Hardware Error Mask" ],
   "DQLS_INT_COR"                 => [  27,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQLS Correctable AMO Data Error Mask" ],
   "DQLS_INT_UC"                  => [  28,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQLS Uncorrectable AMO Data Error Mask" ],
   "RSVD4"                        => [  29,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQLP_INT_HW"                  => [  30,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQLP Hardware Error Mask" ],
   "DQLP_INT_COR"                 => [  31,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQLP Correctable AMO Data Error Mask" ],
   "DQLP_INT_UC"                  => [  32,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQLP Uncorrectable AMO Data Error Mask" ],
   "RSVD5"                        => [  33,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR_ACC"                      => [  34,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Directory Access Error Mask" ],
   "ACY_INT_HW"                   => [  35,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "MD_HW_INT: ACY Hardware Error Mask" ],
   "ACX_INT_HW"                   => [  36,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "MD_HW_INT: ACX Hardware Error Mask" ],
   "DQRP_DIR_COR"                 => [  37,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQRP Correctable Directory Data Error Mask" ],
   "DQRP_DIR_UC"                  => [  38,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQRP Uncorrectable Directory Data Error Mask" ],
   "DQLP_DIR_COR"                 => [  39,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQLP Correctable Directory Data Error Mask" ],
   "DQLP_DIR_UC"                  => [  40,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQLP Uncorrectable Directory Data Error Mask" ],
   "DQRP_DIR_PERR"                => [  41,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQRP Directory Protocol Error Mask" ],
   "DQLP_DIR_PERR"                => [  42,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQLP Directory Protocol Error Mask" ],
   "NONEXIST_ADDR"                => [  43,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Non-existent Memory Address Error Mask" ],
   "ILLEGAL_CMD"                  => [  44,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Illegal Command Error Mask" ],
);

%shub2_01_00478_def =
( NAME    => "SH2_MEM_ERROR_MASK",
  ADDRESS => 0x00000000000000d8,
  NOTE    => "The MEM_ERROR_MASK register is the MD's top-level error note configuration register. It contains 30 mask bits. Each mask bit not",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00478_flds
);


##########################################################################
#                                                                        #
#   SH2_MISC_ADRS_ERR_HDR_LOWER_A                                        #
#                                                                        #
##########################################################################

%shub2_01_00479_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "set when capture occurs" ],
   "RSVD0"                        => [   1,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE"                        => [   2,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "reference is a write" ],
   "RSVD1"                        => [   3,  38,  22, 0x0FFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR"                         => [   4,   3,  35, 0x0000003FFFFFFFF8, 0x00, 0, 0x0000000000000000, "upper bits of reference address" ],
);

%shub2_01_00479_def =
( NAME    => "SH2_MISC_ADRS_ERR_HDR_LOWER_A",
  ADDRESS => 0x00000000000000e0,
  NOTE    => "This register logs some of the bits of the header on the first note occurrence of a packet or directory protocol error.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00479_flds
);


##########################################################################
#                                                                        #
#   SH2_DIR_UC_ADRS_ERR_HDR_LOWER_A                                      #
#                                                                        #
##########################################################################

%shub2_01_00480_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "set when capture occurs" ],
   "RSVD0"                        => [   1,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE"                        => [   2,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "reference is a write" ],
   "RSVD1"                        => [   3,  38,  22, 0x0FFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR"                         => [   4,   3,  35, 0x0000003FFFFFFFF8, 0x00, 0, 0x0000000000000000, "upper bits of reference address" ],
);

%shub2_01_00480_def =
( NAME    => "SH2_DIR_UC_ADRS_ERR_HDR_LOWER_A",
  ADDRESS => 0x00000000000000e8,
  NOTE    => "This register logs some of the bits of the header on the first note occurrence of an uncorrectable directory error.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00480_flds
);


##########################################################################
#                                                                        #
#   SH2_DIR_COR_ADRS_ERR_HDR_LOWER_A                                     #
#                                                                        #
##########################################################################

%shub2_01_00481_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "set when capture occurs" ],
   "RSVD0"                        => [   1,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE"                        => [   2,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "reference is a write" ],
   "RSVD1"                        => [   3,  38,  22, 0x0FFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR"                         => [   4,   3,  35, 0x0000003FFFFFFFF8, 0x00, 0, 0x0000000000000000, "upper bits of reference address" ],
);

%shub2_01_00481_def =
( NAME    => "SH2_DIR_COR_ADRS_ERR_HDR_LOWER_A",
  ADDRESS => 0x00000000000000f0,
  NOTE    => "This register logs some of the bits of the header on the first note occurrence of a correctable directory error.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00481_flds
);


##########################################################################
#                                                                        #
#   SH2_MEM_FIRST_ERROR                                                  #
#                                                                        #
##########################################################################

%shub2_01_00482_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  43,  21, 0xFFFFF80000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INCOMING_XN_REQUEST_OVERFLOW" => [   1,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: MD-to-XN Request Queue Overflow Error Overflow" ],
   "INCOMING_PI_REQUEST_OVERFLOW" => [   2,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: MD-to-PI Request Queue Overflow Error Overflow" ],
   "INCOMING_XN_REPLY_OVERFLOW"   => [   3,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: MD-to-XN Reply Queue Overflow Error Overflow" ],
   "INCOMING_PI_REPLY_OVERFLOW"   => [   4,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: MD-to-PI Reply Queue Overflow Error Overflow" ],
   "ACY_PTY_ERR_R"                => [   5,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: ACY left side address parity Error" ],
   "ACY_PTY_ERR_L"                => [   6,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: ACY left side address parity Error" ],
   "ACX_PTY_ERR_R"                => [   7,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: ACX right side address parity Error" ],
   "ACX_PTY_ERR_L"                => [   8,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: ACX left side address parity Error" ],
   "XN_PKT_SIZE"                  => [   9,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: XN-to-MD Message Length Error" ],
   "PI_PKT_SIZE"                  => [  10,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: PI-to-MD Message Length Error" ],
   "RED_BLACK_ERR_TIMEOUT"        => [  11,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: Red/Black Time-out Error" ],
   "XN_REQUEST_OVERFLOW"          => [  12,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: XN-to-MD Request Queue Overflow Error" ],
   "PI_REQUEST_OVERFLOW"          => [  13,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: PI-to-MD Request Queue Overflow Error" ],
   "XN_REPLY_OVERFLOW"            => [  14,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: XN-to-MD Reply Queue Overflow Error" ],
   "PI_REPLY_OVERFLOW"            => [  15,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: PI-to-MD Reply Queue Overflow Error" ],
   "RSVD1"                        => [  16,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQRS_INT_HW"                  => [  17,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: DQRS Hardware Error" ],
   "DQRS_INT_COR"                 => [  18,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "MD_CE_INT: DQRS Correctable AMO Data Error" ],
   "DQRS_INT_UC"                  => [  19,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "MD_UCE_INT: DQRS Uncorrectable AMO Data Error" ],
   "RSVD2"                        => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQRP_INT_HW"                  => [  21,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: DQRP Hardware Error" ],
   "DQRP_INT_COR"                 => [  22,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "MD_CE_INT: DQRP Correctable AMO Data Error" ],
   "DQRP_INT_UC"                  => [  23,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MD_UCE_INT: DQRP Uncorrectable AMO Data Error" ],
   "RSVD3"                        => [  24,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQLS_INT_HW"                  => [  25,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: DQLS Hardware Error" ],
   "DQLS_INT_COR"                 => [  26,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD_CE_INT: DQLS Correctable AMO Data Error" ],
   "DQLS_INT_UC"                  => [  27,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD_UCE_INT: DQLS Uncorrectable AMO Data Error" ],
   "RSVD4"                        => [  28,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQLP_INT_HW"                  => [  29,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: DQLP Hardware Error" ],
   "DQLP_INT_COR"                 => [  30,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "MD_CE_INT: DQLP Correctable AMO Data Error" ],
   "DQLP_INT_UC"                  => [  31,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "MD_UCE_INT: DQLP Uncorrectable AMO Data Error" ],
   "RSVD5"                        => [  32,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR_ACC"                      => [  33,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "MD_HW_INT: Directory Memory Access Error" ],
   "ACY_INT_HW"                   => [  34,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "MD_HW_INT: ACY Hardware Error" ],
   "ACX_INT_HW"                   => [  35,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "MD_HW_INT: ACX Hardware Error" ],
   "DQRP_DIR_COR"                 => [  36,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "MD_CE_INT: DQRP Correctable Directory Data Error" ],
   "DQRP_DIR_UC"                  => [  37,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "MD_UCE_INT: DQRP Uncorrectable Directory Data Error" ],
   "DQLP_DIR_COR"                 => [  38,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "MD_CE_INT: DQLP Correctable Directory Data Error" ],
   "DQLP_DIR_UC"                  => [  39,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "MD_UCE_INT: DQLP Uncorrectable Directory Data Error" ],
   "DQRP_DIR_PERR"                => [  40,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "MD_HW_INT: DQRP Directory Protocol Error" ],
   "DQLP_DIR_PERR"                => [  41,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "MD_HW_INT: DQLP Directory Protocol Error" ],
   "NONEXIST_ADDR"                => [  42,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "MD_HW_INT: Non-existent Memory Address Error" ],
   "ILLEGAL_CMD"                  => [  43,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "MD_HW_INT: Illegal Command Error" ],
);

%shub2_01_00482_def =
( NAME    => "SH2_MEM_FIRST_ERROR",
  ADDRESS => 0x00000000000000f8,
  NOTE    => "The MEM_FIRST_ERROR register is the MD's top-level error flag note register. It contains 30 flags. Each flag corresponds to one ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00482_flds
);


##########################################################################
#                                                                        #
#   SH2_MEM_FIRST_ERROR_ALIAS                                            #
#                                                                        #
##########################################################################

%shub2_01_00483_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  43,  21, 0xFFFFF80000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INCOMING_XN_REQUEST_OVERFLOW" => [   1,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: MD-to-XN Request Queue Overflow Error Overflow" ],
   "INCOMING_PI_REQUEST_OVERFLOW" => [   2,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: MD-to-PI Request Queue Overflow Error Overflow" ],
   "INCOMING_XN_REPLY_OVERFLOW"   => [   3,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: MD-to-XN Reply Queue Overflow Error Overflow" ],
   "INCOMING_PI_REPLY_OVERFLOW"   => [   4,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: MD-to-PI Reply Queue Overflow Error Overflow" ],
   "ACY_PTY_ERR_R"                => [   5,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: ACY left side address parity Error" ],
   "ACY_PTY_ERR_L"                => [   6,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: ACY left side address parity Error" ],
   "ACX_PTY_ERR_R"                => [   7,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: ACX right side address parity Error" ],
   "ACX_PTY_ERR_L"                => [   8,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: ACX left side address parity Error" ],
   "XN_PKT_SIZE"                  => [   9,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: XN-to-MD Message Length Error" ],
   "PI_PKT_SIZE"                  => [  10,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: PI-to-MD Message Length Error" ],
   "RED_BLACK_ERR_TIMEOUT"        => [  11,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: Red/Black Time-out Error" ],
   "XN_REQUEST_OVERFLOW"          => [  12,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: XN-to-MD Request Queue Overflow Error" ],
   "PI_REQUEST_OVERFLOW"          => [  13,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: PI-to-MD Request Queue Overflow Error" ],
   "XN_REPLY_OVERFLOW"            => [  14,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: XN-to-MD Reply Queue Overflow Error" ],
   "PI_REPLY_OVERFLOW"            => [  15,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: PI-to-MD Reply Queue Overflow Error" ],
   "RSVD1"                        => [  16,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQRS_INT_HW"                  => [  17,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: DQRS Hardware Error" ],
   "DQRS_INT_COR"                 => [  18,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "MD_CE_INT: DQRS Correctable AMO Data Error" ],
   "DQRS_INT_UC"                  => [  19,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "MD_UCE_INT: DQRS Uncorrectable AMO Data Error" ],
   "RSVD2"                        => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQRP_INT_HW"                  => [  21,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: DQRP Hardware Error" ],
   "DQRP_INT_COR"                 => [  22,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "MD_CE_INT: DQRP Correctable AMO Data Error" ],
   "DQRP_INT_UC"                  => [  23,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MD_UCE_INT: DQRP Uncorrectable AMO Data Error" ],
   "RSVD3"                        => [  24,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQLS_INT_HW"                  => [  25,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: DQLS Hardware Error" ],
   "DQLS_INT_COR"                 => [  26,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD_CE_INT: DQLS Correctable AMO Data Error" ],
   "DQLS_INT_UC"                  => [  27,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD_UCE_INT: DQLS Uncorrectable AMO Data Error" ],
   "RSVD4"                        => [  28,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQLP_INT_HW"                  => [  29,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD_HW_INT: DQLP Hardware Error" ],
   "DQLP_INT_COR"                 => [  30,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "MD_CE_INT: DQLP Correctable AMO Data Error" ],
   "DQLP_INT_UC"                  => [  31,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "MD_UCE_INT: DQLP Uncorrectable AMO Data Error" ],
   "RSVD5"                        => [  32,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR_ACC"                      => [  33,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "MD_HW_INT: Directory Memory Access Error" ],
   "ACY_INT_HW"                   => [  34,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "MD_HW_INT: ACY Hardware Error" ],
   "ACX_INT_HW"                   => [  35,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "MD_HW_INT: ACX Hardware Error" ],
   "DQRP_DIR_COR"                 => [  36,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "MD_CE_INT: DQRP Correctable Directory Data Error" ],
   "DQRP_DIR_UC"                  => [  37,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "MD_UCE_INT: DQRP Uncorrectable Directory Data Error" ],
   "DQLP_DIR_COR"                 => [  38,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "MD_CE_INT: DQLP Correctable Directory Data Error" ],
   "DQLP_DIR_UC"                  => [  39,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "MD_UCE_INT: DQLP Uncorrectable Directory Data Error" ],
   "DQRP_DIR_PERR"                => [  40,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "MD_HW_INT: DQRP Directory Protocol Error" ],
   "DQLP_DIR_PERR"                => [  41,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "MD_HW_INT: DQLP Directory Protocol Error" ],
   "NONEXIST_ADDR"                => [  42,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "MD_HW_INT: Non-existent Memory Address Error" ],
   "ILLEGAL_CMD"                  => [  43,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "MD_HW_INT: Illegal Command Error" ],
);

%shub2_01_00483_def =
( NAME    => "SH2_MEM_FIRST_ERROR_ALIAS",
  ADDRESS => 0x0000000000000100,
  NOTE    => "The MEM_FIRST_ERROR_ALIAS address is an alias to the note MEM_FIRST_ERROR register. Refer to the MEM_FIRST_ERROR register note d",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00483_flds
);


##########################################################################
#                                                                        #
#   SH2_X_DIMM_CFG                                                       #
#                                                                        #
##########################################################################

%shub2_01_00484_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  39,  25, 0xFFFFFF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TOG_DIRC_BA"                  => [   1,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "Toggle Directory Cache MSB Bank Address" ],
   "CLK_EN_RIGHT"                 => [   2,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "Clock Enable to right memory bus" ],
   "CLK_EN_LEFT"                  => [   3,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Clock Enable to left memory bus" ],
   "FREQ"                         => [   4,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "DIMM frequency select" ],
   "RSVD1"                        => [   5,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIMM3_CS"                     => [   6,  29,   2, 0x0000000060000000, 0x00, 1, 0x0000000000000000, "DIMM 3 chip select, addr[35:34] match" ],
   "DIMM3_REV"                    => [   7,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "DIMM 3 physical banks reversed" ],
   "DIMM3_2BK"                    => [   8,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "DIMM 3 has two physical banks" ],
   "DIMM3_SIZE"                   => [   9,  24,   3, 0x0000000007000000, 0x00, 1, 0x0000000000000000, "DIMM 3 DRAM size" ],
   "RSVD2"                        => [  10,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIMM2_CS"                     => [  11,  21,   2, 0x0000000000600000, 0x00, 1, 0x0000000000000000, "DIMM 2 chip select, addr[35:34] match" ],
   "DIMM2_REV"                    => [  12,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "DIMM 2 physical banks reversed" ],
   "DIMM2_2BK"                    => [  13,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "DIMM 2 has two physical banks" ],
   "DIMM2_SIZE"                   => [  14,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "DIMM 2 DRAM size" ],
   "RSVD3"                        => [  15,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIMM1_CS"                     => [  16,  13,   2, 0x0000000000006000, 0x00, 1, 0x0000000000000000, "DIMM 1 chip select, addr[35:34] match" ],
   "DIMM1_REV"                    => [  17,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "DIMM 1 physical banks reversed" ],
   "DIMM1_2BK"                    => [  18,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "DIMM 1 has two physical banks" ],
   "DIMM1_SIZE"                   => [  19,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "DIMM 1 DRAM size" ],
   "RSVD4"                        => [  20,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIMM0_CS"                     => [  21,   5,   2, 0x0000000000000060, 0x00, 1, 0x0000000000000000, "DIMM 0 chip select, addr[35:34] match" ],
   "DIMM0_REV"                    => [  22,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "DIMM 0 physical banks reversed" ],
   "DIMM0_2BK"                    => [  23,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "DIMM 0 has two physical banks" ],
   "DIMM0_SIZE"                   => [  24,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "DIMM 0 DRAM size" ],
);

%shub2_01_00484_def =
( NAME    => "SH2_X_DIMM_CFG",
  ADDRESS => 0x0000000000010000,
  NOTE    => "Memory configuration register - This register is used to set the note size of the memory DIMMs, number of memory DIMMs, sequenci",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00484_flds
);


##########################################################################
#                                                                        #
#   SH2_Y_DIMM_CFG                                                       #
#                                                                        #
##########################################################################

%shub2_01_00485_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  39,  25, 0xFFFFFF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TOG_DIRC_BA"                  => [   1,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "Toggle Directory Cache MSB Bank Address" ],
   "CLK_EN_RIGHT"                 => [   2,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "Clock Enable to right memory bus" ],
   "CLK_EN_LEFT"                  => [   3,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Clock Enable to left memory bus" ],
   "FREQ"                         => [   4,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "DIMM frequency select" ],
   "RSVD1"                        => [   5,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIMM3_CS"                     => [   6,  29,   2, 0x0000000060000000, 0x00, 1, 0x0000000000000000, "DIMM 3 chip select, addr[35:34] match" ],
   "DIMM3_REV"                    => [   7,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "DIMM 3 physical banks reversed" ],
   "DIMM3_2BK"                    => [   8,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "DIMM 3 has two physical banks" ],
   "DIMM3_SIZE"                   => [   9,  24,   3, 0x0000000007000000, 0x00, 1, 0x0000000000000000, "DIMM 3 DRAM size" ],
   "RSVD2"                        => [  10,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIMM2_CS"                     => [  11,  21,   2, 0x0000000000600000, 0x00, 1, 0x0000000000000000, "DIMM 2 chip select, addr[35:34] match" ],
   "DIMM2_REV"                    => [  12,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "DIMM 2 physical banks reversed" ],
   "DIMM2_2BK"                    => [  13,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "DIMM 2 has two physical banks" ],
   "DIMM2_SIZE"                   => [  14,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "DIMM 2 DRAM size" ],
   "RSVD3"                        => [  15,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIMM1_CS"                     => [  16,  13,   2, 0x0000000000006000, 0x00, 1, 0x0000000000000000, "DIMM 1 chip select, addr[35:34] match" ],
   "DIMM1_REV"                    => [  17,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "DIMM 1 physical banks reversed" ],
   "DIMM1_2BK"                    => [  18,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "DIMM 1 has two physical banks" ],
   "DIMM1_SIZE"                   => [  19,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "DIMM 1 DRAM size" ],
   "RSVD4"                        => [  20,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIMM0_CS"                     => [  21,   5,   2, 0x0000000000000060, 0x00, 1, 0x0000000000000000, "DIMM 0 chip select, addr[35:34] match" ],
   "DIMM0_REV"                    => [  22,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "DIMM 0 physical banks reversed" ],
   "DIMM0_2BK"                    => [  23,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "DIMM 0 has two physical banks" ],
   "DIMM0_SIZE"                   => [  24,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "DIMM 0 DRAM size" ],
);

%shub2_01_00485_def =
( NAME    => "SH2_Y_DIMM_CFG",
  ADDRESS => 0x0000000000010008,
  NOTE    => "Memory configuration register - This register is used to set the note size of the memory DIMMs, number of memory DIMMs, sequenci",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00485_flds
);


##########################################################################
#                                                                        #
#   SH2_JNR_DIMM_CFG                                                     #
#                                                                        #
##########################################################################

%shub2_01_00486_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  39,  25, 0xFFFFFF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TOG_DIRC_BA"                  => [   1,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "Toggle Directory Cache MSB Bank Address" ],
   "CLK_EN_RIGHT"                 => [   2,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "Clock Enable to right memory bus" ],
   "CLK_EN_LEFT"                  => [   3,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Clock Enable to left memory bus" ],
   "FREQ"                         => [   4,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "DIMM frequency select" ],
   "RSVD1"                        => [   5,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIMM3_CS"                     => [   6,  29,   2, 0x0000000060000000, 0x00, 1, 0x0000000000000000, "DIMM 3 chip select, addr[35:34] match" ],
   "DIMM3_REV"                    => [   7,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "DIMM 3 physical banks reversed" ],
   "DIMM3_2BK"                    => [   8,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "DIMM 3 has two physical banks" ],
   "DIMM3_SIZE"                   => [   9,  24,   3, 0x0000000007000000, 0x00, 1, 0x0000000000000000, "DIMM 3 DRAM size" ],
   "RSVD2"                        => [  10,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIMM2_CS"                     => [  11,  21,   2, 0x0000000000600000, 0x00, 1, 0x0000000000000000, "DIMM 2 chip select, addr[35:34] match" ],
   "DIMM2_REV"                    => [  12,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "DIMM 2 physical banks reversed" ],
   "DIMM2_2BK"                    => [  13,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "DIMM 2 has two physical banks" ],
   "DIMM2_SIZE"                   => [  14,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "DIMM 2 DRAM size" ],
   "RSVD3"                        => [  15,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIMM1_CS"                     => [  16,  13,   2, 0x0000000000006000, 0x00, 1, 0x0000000000000000, "DIMM 1 chip select, addr[35:34] match" ],
   "DIMM1_REV"                    => [  17,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "DIMM 1 physical banks reversed" ],
   "DIMM1_2BK"                    => [  18,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "DIMM 1 has two physical banks" ],
   "DIMM1_SIZE"                   => [  19,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "DIMM 1 DRAM size" ],
   "RSVD4"                        => [  20,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIMM0_CS"                     => [  21,   5,   2, 0x0000000000000060, 0x00, 1, 0x0000000000000000, "DIMM 0 chip select, addr[35:34] match" ],
   "DIMM0_REV"                    => [  22,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "DIMM 0 physical banks reversed" ],
   "DIMM0_2BK"                    => [  23,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "DIMM 0 has two physical banks" ],
   "DIMM0_SIZE"                   => [  24,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "DIMM 0 DRAM size" ],
);

%shub2_01_00486_def =
( NAME    => "SH2_JNR_DIMM_CFG",
  ADDRESS => 0x0000000000010010,
  NOTE    => "Memory configuration register - This register is used to set the note size of the memory DIMMs, number of memory DIMMs, sequenci",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00486_flds
);


##########################################################################
#                                                                        #
#   SH2_X_ODT_CFG                                                        #
#                                                                        #
##########################################################################

%shub2_01_00487_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  52,  12, 0xFFF0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ODT_RD3"                      => [   1,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "ODT read to DIMM3" ],
   "ODT_RD2"                      => [   2,  44,   4, 0x0000F00000000000, 0x00, 1, 0x0000000000000000, "ODT read to DIMM2" ],
   "ODT_RD1"                      => [   3,  40,   4, 0x00000F0000000000, 0x00, 1, 0x0000000000000000, "ODT read to DIMM1" ],
   "ODT_RD0"                      => [   4,  36,   4, 0x000000F000000000, 0x00, 1, 0x0000000000000000, "ODT read to DIMM0" ],
   "ODT_WT3"                      => [   5,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "ODT write to DIMM2" ],
   "ODT_WT2"                      => [   6,  28,   4, 0x00000000F0000000, 0x00, 1, 0x0000000000000000, "ODT write to DIMM2" ],
   "ODT_WT1"                      => [   7,  24,   4, 0x000000000F000000, 0x00, 1, 0x0000000000000000, "ODT write to DIMM1" ],
   "ODT_WT0"                      => [   8,  20,   4, 0x0000000000F00000, 0x00, 1, 0x0000000000000000, "ODT write to DIMM0" ],
   "ODT_IDLE"                     => [   9,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "ODT Idle" ],
   "ODT_WT_HOLD"                  => [  10,  14,   2, 0x000000000000C000, 0x00, 1, 0x0000000000000000, "ODT Write Hold" ],
   "ODT_WT_EN"                    => [  11,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "ODT Write Enable" ],
   "ODT_RD_HOLD"                  => [  12,  10,   2, 0x0000000000000C00, 0x00, 1, 0x0000000000000000, "ODT Read Hold" ],
   "ODT_RD_EN"                    => [  13,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "ODT Read Enable" ],
   "ODT_RDIMM_EN"                 => [  14,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "ODT right DIMM Enable" ],
   "ODT_LDIMM_EN"                 => [  15,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "ODT left DIMM Enable" ],
);

%shub2_01_00487_def =
( NAME    => "SH2_X_ODT_CFG",
  ADDRESS => 0x0000000000010018,
  NOTE    => "Memory ODT configuration register - This register is used to set note the ODT values for read and write operations to the DIMMs.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00487_flds
);


##########################################################################
#                                                                        #
#   SH2_X_CFG                                                            #
#                                                                        #
##########################################################################

%shub2_01_00488_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FAW_THROTTLE_EN"              => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Four activate throttle" ],
   "TOG_PAR_IN"                   => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Toggle parity in" ],
   "CLR_DIR_CACHE"                => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "Clear directory cache tags" ],
   "INV_CAS_ADDR"                 => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "Invert cas address bits 3 to 7" ],
   "REQ_CNTR_VAL"                 => [   4,  55,   5, 0x0F80000000000000, 0x00, 1, 0x0000000000000000, "Request counter delay value in CPs" ],
   "REQ_CNTR_DIS"                 => [   5,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "Request delay counter disabled" ],
   "TRCD4_EN"                     => [   6,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "Trcd, ras to case delay of 4 CPs enabled" ],
   "SSO_WT_EN"                    => [   7,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "Simultaneous switching enabled on output data pins" ],
   "WT_BB_CLR"                    => [   8,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "Bank busy CPs for all write request" ],
   "DC_BB_CLR"                    => [   9,  44,   4, 0x0000F00000000000, 0x00, 1, 0x0000000000000000, "Bank busy CPs for a directory cache read request" ],
   "DA_BB_CLR"                    => [  10,  40,   4, 0x00000F0000000000, 0x00, 1, 0x0000000000000000, "Bank busy CPs for a data read request" ],
   "TA_DLYS"                      => [  11,   8,  32, 0x000000FFFFFFFF00, 0x00, 1, 0x0000000000000000, "Turn around delays" ],
   "DIR_COUNTER_INIT"             => [  12,   2,   6, 0x00000000000000FC, 0x00, 1, 0x0000000000000000, "Dir counter initial value" ],
   "DIRC_RANDOM_REPLACEMENT"      => [  13,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Directory cache random replacement" ],
   "MODE_SERIAL"                  => [  14,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Arbque arbitration in serial mode" ],
);

%shub2_01_00488_def =
( NAME    => "SH2_X_CFG",
  ADDRESS => 0x0000000000010020,
  NOTE    => "AC (Address and control) configuration registers. This register has note MMR values to adjacent the performance of memory. Examp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00488_flds
);


##########################################################################
#                                                                        #
#   SH2_X_DQCT_CFG                                                       #
#                                                                        #
##########################################################################

%shub2_01_00489_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  25,  39, 0xFFFFFFFFFE000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NCRP_FULL_CL"                 => [   1,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "NCRP reply is full cache line" ],
   "MDIR_RD_SEL"                  => [   2,  20,   4, 0x0000000000F00000, 0x00, 1, 0x0000000000000000, "Dir ready read select" ],
   "DIR_RD_SEL"                   => [   3,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "Dir ready read select" ],
   "DTA_WT_SEL"                   => [   4,  12,   4, 0x000000000000F000, 0x00, 1, 0x0000000000000000, "Data ready write select" ],
   "DTA_RD_SEL"                   => [   5,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "Data ready read select" ],
   "WT_SEL"                       => [   6,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "Write data select" ],
   "RD_SEL"                       => [   7,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Read data select" ],
);

%shub2_01_00489_def =
( NAME    => "SH2_X_DQCT_CFG",
  ADDRESS => 0x0000000000010028,
  NOTE    => "The dqct config register configures the DQ (data path) control note logic. Examples include rd_sel which indicates when read dat",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00489_flds
);


##########################################################################
#                                                                        #
#   SH2_X_REFRESH_CONTROL                                                #
#                                                                        #
##########################################################################

%shub2_01_00490_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HALF_RATE"                    => [   1,  24,   4, 0x000000000F000000, 0x00, 1, 0x0000000000000000, "Refresh half rate" ],
   "INTERLEAVE"                   => [   2,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "Refresh interleave" ],
   "HOLD"                         => [   3,  17,   6, 0x00000000007E0000, 0x00, 1, 0x0000000000000000, "Refresh hold" ],
   "INTERVAL"                     => [   4,   8,   9, 0x000000000001FF00, 0x00, 1, 0x0000000000000000, "Refresh interval in core CPs" ],
   "ENABLE"                       => [   5,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Refresh enable" ],
);

%shub2_01_00490_def =
( NAME    => "SH2_X_REFRESH_CONTROL",
  ADDRESS => 0x0000000000010030,
  NOTE    => "The refresh control register controls when and to which DIMMs note refresh requests are generated.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00490_flds
);


##########################################################################
#                                                                        #
#   SH2_X_AMOC_CFG                                                       #
#                                                                        #
##########################################################################

%shub2_01_00491_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   4,  60, 0xFFFFFFFFFFFFFFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AMOC_TAG_CAP"                 => [   1,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Enable amoc tag capture" ],
   "AMOC_SEL_LTAG"                => [   2,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Select left aint amoc tag when loading amoc_tag register" ],
   "AMOC_SEL_TAG1"                => [   3,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Select amoc tag register 1 when loading amoc_tag register" ],
   "AMOC_EN"                      => [   4,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "amoc enable - not used" ],
);

%shub2_01_00491_def =
( NAME    => "SH2_X_AMOC_CFG",
  ADDRESS => 0x0000000000010038,
  NOTE    => "The amoc config register configures amoc cache.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00491_flds
);


##########################################################################
#                                                                        #
#   SH2_X_AMOC_TAG                                                       #
#                                                                        #
##########################################################################

%shub2_01_00492_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR"                         => [   1,   4,  30, 0x00000003FFFFFFF0, 0x00, 1, 0x0000000000000000, "tag address == byte address bits [37-8]" ],
   "VAL"                          => [   2,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "tag valid" ],
);

%shub2_01_00492_def =
( NAME    => "SH2_X_AMOC_TAG",
  ADDRESS => 0x0000000000010040,
  NOTE    => "The amoc tag capture register captures the amoc valid bit and note corresponding tag as configured by amoc_cfg register.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00492_flds
);


##########################################################################
#                                                                        #
#   SH2_Y_ODT_CFG                                                        #
#                                                                        #
##########################################################################

%shub2_01_00493_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  52,  12, 0xFFF0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ODT_RD3"                      => [   1,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "ODT read to DIMM3" ],
   "ODT_RD2"                      => [   2,  44,   4, 0x0000F00000000000, 0x00, 1, 0x0000000000000000, "ODT read to DIMM2" ],
   "ODT_RD1"                      => [   3,  40,   4, 0x00000F0000000000, 0x00, 1, 0x0000000000000000, "ODT read to DIMM1" ],
   "ODT_RD0"                      => [   4,  36,   4, 0x000000F000000000, 0x00, 1, 0x0000000000000000, "ODT read to DIMM0" ],
   "ODT_WT3"                      => [   5,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "ODT write to DIMM2" ],
   "ODT_WT2"                      => [   6,  28,   4, 0x00000000F0000000, 0x00, 1, 0x0000000000000000, "ODT write to DIMM2" ],
   "ODT_WT1"                      => [   7,  24,   4, 0x000000000F000000, 0x00, 1, 0x0000000000000000, "ODT write to DIMM1" ],
   "ODT_WT0"                      => [   8,  20,   4, 0x0000000000F00000, 0x00, 1, 0x0000000000000000, "ODT write to DIMM0" ],
   "ODT_IDLE"                     => [   9,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "ODT Idle" ],
   "ODT_WT_HOLD"                  => [  10,  14,   2, 0x000000000000C000, 0x00, 1, 0x0000000000000000, "ODT Write Hold" ],
   "ODT_WT_EN"                    => [  11,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "ODT Write Enable" ],
   "ODT_RD_HOLD"                  => [  12,  10,   2, 0x0000000000000C00, 0x00, 1, 0x0000000000000000, "ODT Read Hold" ],
   "ODT_RD_EN"                    => [  13,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "ODT Read Enable" ],
   "ODT_RDIMM_EN"                 => [  14,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "ODT right DIMM Enable" ],
   "ODT_LDIMM_EN"                 => [  15,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "ODT left DIMM Enable" ],
);

%shub2_01_00493_def =
( NAME    => "SH2_Y_ODT_CFG",
  ADDRESS => 0x0000000000010048,
  NOTE    => "Memory ODT configuration register - This register is used to set note the ODT values for read and write operations to the DIMMs.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00493_flds
);


##########################################################################
#                                                                        #
#   SH2_Y_CFG                                                            #
#                                                                        #
##########################################################################

%shub2_01_00494_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FAW_THROTTLE_EN"              => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Four activate throttle" ],
   "TOG_PAR_IN"                   => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Toggle parity in" ],
   "CLR_DIR_CACHE"                => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "Clear directory cache tags" ],
   "INV_CAS_ADDR"                 => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "Invert cas address bits 3 to 7" ],
   "REQ_CNTR_VAL"                 => [   4,  55,   5, 0x0F80000000000000, 0x00, 1, 0x0000000000000000, "Request counter delay value in CPs" ],
   "REQ_CNTR_DIS"                 => [   5,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "Request delay counter disabled" ],
   "TRCD4_EN"                     => [   6,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "Trcd, ras to case delay of 4 CPs enabled" ],
   "SSO_WT_EN"                    => [   7,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "Simultaneous switching enabled on output data pins" ],
   "WT_BB_CLR"                    => [   8,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "Bank busy CPs for all write request" ],
   "DC_BB_CLR"                    => [   9,  44,   4, 0x0000F00000000000, 0x00, 1, 0x0000000000000000, "Bank busy CPs for a directory cache read request" ],
   "DA_BB_CLR"                    => [  10,  40,   4, 0x00000F0000000000, 0x00, 1, 0x0000000000000000, "Bank busy CPs for a data read request" ],
   "TA_DLYS"                      => [  11,   8,  32, 0x000000FFFFFFFF00, 0x00, 1, 0x0000000000000000, "Turn around delays" ],
   "DIR_COUNTER_INIT"             => [  12,   2,   6, 0x00000000000000FC, 0x00, 1, 0x0000000000000000, "Dir counter initial value" ],
   "DIRC_RANDOM_REPLACEMENT"      => [  13,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Directory cache random replacement" ],
   "MODE_SERIAL"                  => [  14,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Arbque arbitration in serial mode" ],
);

%shub2_01_00494_def =
( NAME    => "SH2_Y_CFG",
  ADDRESS => 0x0000000000010050,
  NOTE    => "AC (Address and control) configuration registers. This register has note MMR values to adjacent the performance of memory. Examp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00494_flds
);


##########################################################################
#                                                                        #
#   SH2_Y_DQCT_CFG                                                       #
#                                                                        #
##########################################################################

%shub2_01_00495_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  25,  39, 0xFFFFFFFFFE000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NCRP_FULL_CL"                 => [   1,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "NCRP reply is full cache line" ],
   "MDIR_RD_SEL"                  => [   2,  20,   4, 0x0000000000F00000, 0x00, 1, 0x0000000000000000, "Dir ready read select" ],
   "DIR_RD_SEL"                   => [   3,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "Dir ready read select" ],
   "DTA_WT_SEL"                   => [   4,  12,   4, 0x000000000000F000, 0x00, 1, 0x0000000000000000, "Data ready write select" ],
   "DTA_RD_SEL"                   => [   5,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "Data ready read select" ],
   "WT_SEL"                       => [   6,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "Write data select" ],
   "RD_SEL"                       => [   7,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Read data select" ],
);

%shub2_01_00495_def =
( NAME    => "SH2_Y_DQCT_CFG",
  ADDRESS => 0x0000000000010058,
  NOTE    => "The dqct config register configures the DQ (data path) control note logic. Examples include rd_sel which indicates when read dat",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00495_flds
);


##########################################################################
#                                                                        #
#   SH2_Y_REFRESH_CONTROL                                                #
#                                                                        #
##########################################################################

%shub2_01_00496_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HALF_RATE"                    => [   1,  24,   4, 0x000000000F000000, 0x00, 1, 0x0000000000000000, "Refresh half rate" ],
   "INTERLEAVE"                   => [   2,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "Refresh interleave" ],
   "HOLD"                         => [   3,  17,   6, 0x00000000007E0000, 0x00, 1, 0x0000000000000000, "Refresh hold" ],
   "INTERVAL"                     => [   4,   8,   9, 0x000000000001FF00, 0x00, 1, 0x0000000000000000, "Refresh interval in core CPs" ],
   "ENABLE"                       => [   5,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Refresh enable" ],
);

%shub2_01_00496_def =
( NAME    => "SH2_Y_REFRESH_CONTROL",
  ADDRESS => 0x0000000000010060,
  NOTE    => "The refresh control register controls when and to which DIMMs note refresh requests are generated.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00496_flds
);


##########################################################################
#                                                                        #
#   SH2_Y_AMOC_CFG                                                       #
#                                                                        #
##########################################################################

%shub2_01_00497_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   4,  60, 0xFFFFFFFFFFFFFFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AMOC_TAG_CAP"                 => [   1,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Enable amoc tag capture" ],
   "AMOC_SEL_LTAG"                => [   2,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Select left aint amoc tag when loading amoc_tag register" ],
   "AMOC_SEL_TAG1"                => [   3,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Select amoc tag register 1 when loading amoc_tag register" ],
   "AMOC_EN"                      => [   4,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "amoc enable - not used" ],
);

%shub2_01_00497_def =
( NAME    => "SH2_Y_AMOC_CFG",
  ADDRESS => 0x0000000000010068,
  NOTE    => "The amoc config register configures amoc cache.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00497_flds
);


##########################################################################
#                                                                        #
#   SH2_Y_AMOC_TAG                                                       #
#                                                                        #
##########################################################################

%shub2_01_00498_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR"                         => [   1,   4,  30, 0x00000003FFFFFFF0, 0x00, 1, 0x0000000000000000, "tag address == byte address bits [37-8]" ],
   "VAL"                          => [   2,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "tag valid" ],
);

%shub2_01_00498_def =
( NAME    => "SH2_Y_AMOC_TAG",
  ADDRESS => 0x0000000000010070,
  NOTE    => "The amoc tag capture register captures the amoc valid bit and note corresponding tag as configured by amoc_cfg register.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00498_flds
);


##########################################################################
#                                                                        #
#   SH2_MEM_RED_BLACK                                                    #
#                                                                        #
##########################################################################

%shub2_01_00499_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  52,  12, 0xFFF0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERR_TIME"                     => [   1,  16,  36, 0x000FFFFFFFFF0000, 0x00, 1, 0x0000000000000000, "Max clocks to wait after red/black change for old color to clear." ],
   "TIME"                         => [   2,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "Clocks to tag references with a given color" ],
);

%shub2_01_00499_def =
( NAME    => "SH2_MEM_RED_BLACK",
  ADDRESS => 0x0000000000010078,
  NOTE    => "This register provides a means to ensure a maximum amount of time note that a reference can spend in the memory system. This is ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00499_flds
);


##########################################################################
#                                                                        #
#   SH2_MISC_MEM_CFG                                                     #
#                                                                        #
##########################################################################

%shub2_01_00500_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID_MASK_BIT_7"           => [   1,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "Used for extending coherence domain greater than 256 nodes" ],
   "NODE_ID_MASK_BIT_8"           => [   2,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "Used for extending coherence domain greater than 256 nodes" ],
   "NODE_ID_MASK_BIT_9"           => [   3,  59,   1, 0x0800000000000000, 0x00, 1, 0x0000000000000000, "Used for extending coherence domain greater than 256 nodes" ],
   "NODE_ID_MASK_BIT_10"          => [   4,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "Used for extending coherence domain greater than 256 nodes" ],
   "NODE_ID_MASK_BIT_11"          => [   5,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "Used for extending coherence domain greater than 256 nodes" ],
   "NODE_ID_MASK_BIT_12"          => [   6,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "Used for extending coherence domain greater than 256 nodes" ],
   "NODE_ID_MASK_BIT_13"          => [   7,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "Used for extending coherence domain greater than 256 nodes" ],
   "NCRP_FULL_CL"                 => [   8,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "NCRP reply is full cache line" ],
   "RESPOND_TO_READ_IN_DIR_SPACE" => [   9,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "If set MD will respond with AERR to read in directory space" ],
   "DIMM_SELECT_MUX"              => [  10,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "If set MD will use [37:36] vs [35:34] for DIMM select mux" ],
   "ALTERNATE_XN_RP_PLANE"        => [  11,  51,   1, 0x0008000000000000, 0x00, 1, 0x0000000000000000, "enables plane alternating for replies to XN" ],
   "SPEC_VALID"                   => [  12,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "If set Orbit MD behaves the same as Shub MD" ],
   "DISABLED_VICTIMS"             => [  13,  44,   6, 0x0003F00000000000, 0x00, 1, 0x0000000000000000, "number of dir cache victim buffers to take out of circulation in each quadrant of the MD" ],
   "RSVD1"                        => [  14,  41,   3, 0x00000E0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DISABLED_WRITE_TNUMS"         => [  15,  36,   5, 0x000001F000000000, 0x00, 1, 0x0000000000000000, "number of write tnums to take out of circulation" ],
   "RSVD2"                        => [  16,  33,   3, 0x0000000E00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DISABLED_READ_TNUMS"          => [  17,  28,   5, 0x00000001F0000000, 0x00, 1, 0x0000000000000000, "number of read tnums to take out of circulation" ],
   "THROTTLE_CNT"                 => [  18,  20,   8, 0x000000000FF00000, 0x00, 1, 0x0000000000000000, "number of clocks between accepting references" ],
   "NM_INT_EN_3"                  => [  19,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "Notification memory interrupt enable 3" ],
   "NM_INT_EN_2"                  => [  20,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "Notification memory interrupt enable 2" ],
   "LOW_VICTIM_BUFFER_THRESHOLD"  => [  21,  12,   6, 0x000000000003F000, 0x00, 1, 0x0000000000000000, "point at which dir cache writes get higher priority" ],
   "NM_INT_EN_1"                  => [  22,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "Notification memory interrupt enable 1" ],
   "NM_INT_EN_0"                  => [  23,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "Notification memory interrupt enable 0" ],
   "LOW_WRITE_BUFFER_THRESHOLD"   => [  24,   4,   6, 0x00000000000003F0, 0x00, 1, 0x0000000000000000, "point at which data writes get higher priority" ],
   "XN_RD_SAME_AS_PI"             => [  25,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "disables a one clock delay of XN read data" ],
   "JNR_BYPASS_ENABLE"            => [  26,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "enables bypass path for requests going through ac" ],
   "SPEC_HEADER_ENABLE"           => [  27,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "enables the use of speculative headers from md to pi" ],
   "EXPRESS_HEADER_ENABLE"        => [  28,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "enables the use of express headers from md to pi" ],
);

%shub2_01_00500_def =
( NAME    => "SH2_MISC_MEM_CFG",
  ADDRESS => 0x0000000000010080,
  NOTE    => "This register contains miscellaneous memory configuration note information.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00500_flds
);


##########################################################################
#                                                                        #
#   SH2_MEM_CREDITS                                                      #
#                                                                        #
##########################################################################

%shub2_01_00501_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  40,  24, 0xFFFFFF0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LB"                           => [   1,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Credits available to LB" ],
   "XN_RPY"                       => [   2,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "Reply credits available to XN" ],
   "XN_REQ"                       => [   3,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Request credits available to XN" ],
   "PI_RPY"                       => [   4,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Reply credits available to PI" ],
   "PI_REQ"                       => [   5,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Request credits available to PI" ],
);

%shub2_01_00501_def =
( NAME    => "SH2_MEM_CREDITS",
  ADDRESS => 0x0000000000010088,
  NOTE    => "This register provides a means for software to examine the request note and reply credit that PI,XN and LB have from MD's perspe",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00501_flds
);


##########################################################################
#                                                                        #
#   SH2_STATUS0                                                          #
#                                                                        #
##########################################################################

%shub2_01_00502_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "REG_BIT63"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "63 bit of Notification block status register 0" ],
   "REG_BIT62"                    => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "62 bit of Notification block status register 0" ],
   "REG_BIT61"                    => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "61 bit of Notification block status register 0" ],
   "REG_BIT60"                    => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "60 bit of Notification block status register 0" ],
   "REG_BIT59"                    => [   4,  59,   1, 0x0800000000000000, 0x00, 1, 0x0000000000000000, "59 bit of Notification block status register 0" ],
   "REG_BIT58"                    => [   5,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "58 bit of Notification block status register 0" ],
   "REG_BIT57"                    => [   6,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "57 bit of Notification block status register 0" ],
   "REG_BIT56"                    => [   7,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "56 bit of Notification block status register 0" ],
   "REG_BIT55"                    => [   8,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "55 bit of Notification block status register 0" ],
   "REG_BIT54"                    => [   9,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "54 bit of Notification block status register 0" ],
   "REG_BIT53"                    => [  10,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "53 bit of Notification block status register 0" ],
   "REG_BIT52"                    => [  11,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "52 bit of Notification block status register 0" ],
   "REG_BIT51"                    => [  12,  51,   1, 0x0008000000000000, 0x00, 1, 0x0000000000000000, "51 bit of Notification block status register 0" ],
   "REG_BIT50"                    => [  13,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "50 bit of Notification block status register 0" ],
   "REG_BIT49"                    => [  14,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "49 bit of Notification block status register 0" ],
   "REG_BIT48"                    => [  15,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "48 bit of Notification block status register 0" ],
   "REG_BIT47"                    => [  16,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "47 bit of Notification block status register 0" ],
   "REG_BIT46"                    => [  17,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "46 bit of Notification block status register 0" ],
   "REG_BIT45"                    => [  18,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "45 bit of Notification block status register 0" ],
   "REG_BIT44"                    => [  19,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "44 bit of Notification block status register 0" ],
   "REG_BIT43"                    => [  20,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "43 bit of Notification block status register 0" ],
   "REG_BIT42"                    => [  21,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "42 bit of Notification block status register 0" ],
   "REG_BIT41"                    => [  22,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "41 bit of Notification block status register 0" ],
   "REG_BIT40"                    => [  23,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "40 bit of Notification block status register 0" ],
   "REG_BIT39"                    => [  24,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "39 bit of Notification block status register 0" ],
   "REG_BIT38"                    => [  25,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "38 bit of Notification block status register 0" ],
   "REG_BIT37"                    => [  26,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "37 bit of Notification block status register 0" ],
   "REG_BIT36"                    => [  27,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "36 bit of Notification block status register 0" ],
   "REG_BIT35"                    => [  28,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "35 bit of Notification block status register 0" ],
   "REG_BIT34"                    => [  29,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "34 bit of Notification block status register 0" ],
   "REG_BIT33"                    => [  30,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "33 bit of Notification block status register 0" ],
   "REG_BIT32"                    => [  31,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "32 bit of Notification block status register 0" ],
   "REG_BIT31"                    => [  32,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "31 bit of Notification block status register 0" ],
   "REG_BIT30"                    => [  33,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "30 bit of Notification block status register 0" ],
   "REG_BIT29"                    => [  34,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "29 bit of Notification block status register 0" ],
   "REG_BIT28"                    => [  35,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "28 bit of Notification block status register 0" ],
   "REG_BIT27"                    => [  36,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "27 bit of Notification block status register 0" ],
   "REG_BIT26"                    => [  37,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "26 bit of Notification block status register 0" ],
   "REG_BIT25"                    => [  38,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "25 bit of Notification block status register 0" ],
   "REG_BIT24"                    => [  39,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "24 bit of Notification block status register 0" ],
   "REG_BIT23"                    => [  40,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "23 bit of Notification block status register 0" ],
   "REG_BIT22"                    => [  41,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "22 bit of Notification block status register 0" ],
   "REG_BIT21"                    => [  42,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "21 bit of Notification block status register 0" ],
   "REG_BIT20"                    => [  43,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "20 bit of Notification block status register 0" ],
   "REG_BIT19"                    => [  44,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "19 bit of Notification block status register 0" ],
   "REG_BIT18"                    => [  45,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "18 bit of Notification block status register 0" ],
   "REG_BIT17"                    => [  46,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "17 bit of Notification block status register 0" ],
   "REG_BIT16"                    => [  47,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "16 bit of Notification block status register 0" ],
   "REG_BIT15"                    => [  48,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "15 bit of Notification block status register 0" ],
   "REG_BIT14"                    => [  49,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "14 bit of Notification block status register 0" ],
   "REG_BIT13"                    => [  50,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "13 bit of Notification block status register 0" ],
   "REG_BIT12"                    => [  51,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "12 bit of Notification block status register 0" ],
   "REG_BIT11"                    => [  52,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "11 bit of Notification block status register 0" ],
   "REG_BIT10"                    => [  53,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "10 bit of Notification block status register 0" ],
   "REG_BIT9"                     => [  54,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "9 bit of Notification block status register 0" ],
   "REG_BIT8"                     => [  55,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "8 bit of Notification block status register 0" ],
   "REG_BIT7"                     => [  56,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "7 bit of Notification block status register 0" ],
   "REG_BIT6"                     => [  57,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "6 bit of Notification block status register 0" ],
   "REG_BIT5"                     => [  58,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "5 bit of Notification block status register 0" ],
   "REG_BIT4"                     => [  59,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "4 bit of Notification block status register 0" ],
   "REG_BIT3"                     => [  60,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "3 bit of Notification block status register 0" ],
   "REG_BIT2"                     => [  61,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "2 bit of Notification block status register 0" ],
   "REG_BIT1"                     => [  62,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "1 bit of Notification block status register 0" ],
   "REG_BIT0"                     => [  63,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "0 bit of Notification block status register 0" ],
);

%shub2_01_00502_def =
( NAME    => "SH2_STATUS0",
  ADDRESS => 0x0000000000010090,
  NOTE    => "This is NOTIFICATION BLOCK STATUS register 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00502_flds
);


##########################################################################
#                                                                        #
#   SH2_STATUS0_ALIAS                                                    #
#                                                                        #
##########################################################################

%shub2_01_00503_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "REG_BIT63"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "63 bit of Notification block status register 0" ],
   "REG_BIT62"                    => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "62 bit of Notification block status register 0" ],
   "REG_BIT61"                    => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "61 bit of Notification block status register 0" ],
   "REG_BIT60"                    => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "60 bit of Notification block status register 0" ],
   "REG_BIT59"                    => [   4,  59,   1, 0x0800000000000000, 0x00, 1, 0x0000000000000000, "59 bit of Notification block status register 0" ],
   "REG_BIT58"                    => [   5,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "58 bit of Notification block status register 0" ],
   "REG_BIT57"                    => [   6,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "57 bit of Notification block status register 0" ],
   "REG_BIT56"                    => [   7,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "56 bit of Notification block status register 0" ],
   "REG_BIT55"                    => [   8,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "55 bit of Notification block status register 0" ],
   "REG_BIT54"                    => [   9,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "54 bit of Notification block status register 0" ],
   "REG_BIT53"                    => [  10,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "53 bit of Notification block status register 0" ],
   "REG_BIT52"                    => [  11,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "52 bit of Notification block status register 0" ],
   "REG_BIT51"                    => [  12,  51,   1, 0x0008000000000000, 0x00, 1, 0x0000000000000000, "51 bit of Notification block status register 0" ],
   "REG_BIT50"                    => [  13,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "50 bit of Notification block status register 0" ],
   "REG_BIT49"                    => [  14,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "49 bit of Notification block status register 0" ],
   "REG_BIT48"                    => [  15,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "48 bit of Notification block status register 0" ],
   "REG_BIT47"                    => [  16,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "47 bit of Notification block status register 0" ],
   "REG_BIT46"                    => [  17,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "46 bit of Notification block status register 0" ],
   "REG_BIT45"                    => [  18,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "45 bit of Notification block status register 0" ],
   "REG_BIT44"                    => [  19,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "44 bit of Notification block status register 0" ],
   "REG_BIT43"                    => [  20,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "43 bit of Notification block status register 0" ],
   "REG_BIT42"                    => [  21,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "42 bit of Notification block status register 0" ],
   "REG_BIT41"                    => [  22,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "41 bit of Notification block status register 0" ],
   "REG_BIT40"                    => [  23,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "40 bit of Notification block status register 0" ],
   "REG_BIT39"                    => [  24,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "39 bit of Notification block status register 0" ],
   "REG_BIT38"                    => [  25,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "38 bit of Notification block status register 0" ],
   "REG_BIT37"                    => [  26,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "37 bit of Notification block status register 0" ],
   "REG_BIT36"                    => [  27,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "36 bit of Notification block status register 0" ],
   "REG_BIT35"                    => [  28,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "35 bit of Notification block status register 0" ],
   "REG_BIT34"                    => [  29,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "34 bit of Notification block status register 0" ],
   "REG_BIT33"                    => [  30,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "33 bit of Notification block status register 0" ],
   "REG_BIT32"                    => [  31,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "32 bit of Notification block status register 0" ],
   "REG_BIT31"                    => [  32,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "31 bit of Notification block status register 0" ],
   "REG_BIT30"                    => [  33,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "30 bit of Notification block status register 0" ],
   "REG_BIT29"                    => [  34,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "29 bit of Notification block status register 0" ],
   "REG_BIT28"                    => [  35,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "28 bit of Notification block status register 0" ],
   "REG_BIT27"                    => [  36,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "27 bit of Notification block status register 0" ],
   "REG_BIT26"                    => [  37,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "26 bit of Notification block status register 0" ],
   "REG_BIT25"                    => [  38,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "25 bit of Notification block status register 0" ],
   "REG_BIT24"                    => [  39,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "24 bit of Notification block status register 0" ],
   "REG_BIT23"                    => [  40,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "23 bit of Notification block status register 0" ],
   "REG_BIT22"                    => [  41,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "22 bit of Notification block status register 0" ],
   "REG_BIT21"                    => [  42,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "21 bit of Notification block status register 0" ],
   "REG_BIT20"                    => [  43,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "20 bit of Notification block status register 0" ],
   "REG_BIT19"                    => [  44,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "19 bit of Notification block status register 0" ],
   "REG_BIT18"                    => [  45,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "18 bit of Notification block status register 0" ],
   "REG_BIT17"                    => [  46,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "17 bit of Notification block status register 0" ],
   "REG_BIT16"                    => [  47,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "16 bit of Notification block status register 0" ],
   "REG_BIT15"                    => [  48,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "15 bit of Notification block status register 0" ],
   "REG_BIT14"                    => [  49,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "14 bit of Notification block status register 0" ],
   "REG_BIT13"                    => [  50,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "13 bit of Notification block status register 0" ],
   "REG_BIT12"                    => [  51,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "12 bit of Notification block status register 0" ],
   "REG_BIT11"                    => [  52,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "11 bit of Notification block status register 0" ],
   "REG_BIT10"                    => [  53,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "10 bit of Notification block status register 0" ],
   "REG_BIT9"                     => [  54,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "9 bit of Notification block status register 0" ],
   "REG_BIT8"                     => [  55,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "8 bit of Notification block status register 0" ],
   "REG_BIT7"                     => [  56,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "7 bit of Notification block status register 0" ],
   "REG_BIT6"                     => [  57,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "6 bit of Notification block status register 0" ],
   "REG_BIT5"                     => [  58,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "5 bit of Notification block status register 0" ],
   "REG_BIT4"                     => [  59,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "4 bit of Notification block status register 0" ],
   "REG_BIT3"                     => [  60,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "3 bit of Notification block status register 0" ],
   "REG_BIT2"                     => [  61,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "2 bit of Notification block status register 0" ],
   "REG_BIT1"                     => [  62,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "1 bit of Notification block status register 0" ],
   "REG_BIT0"                     => [  63,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "0 bit of Notification block status register 0" ],
);

%shub2_01_00503_def =
( NAME    => "SH2_STATUS0_ALIAS",
  ADDRESS => 0x0000000000010098,
  NOTE    => "nb_status0 alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00503_flds
);


##########################################################################
#                                                                        #
#   SH2_STATUS1                                                          #
#                                                                        #
##########################################################################

%shub2_01_00504_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "REG_BIT63"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "63 bit of Notification block status register 1" ],
   "REG_BIT62"                    => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "62 bit of Notification block status register 1" ],
   "REG_BIT61"                    => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "61 bit of Notification block status register 1" ],
   "REG_BIT60"                    => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "60 bit of Notification block status register 1" ],
   "REG_BIT59"                    => [   4,  59,   1, 0x0800000000000000, 0x00, 1, 0x0000000000000000, "59 bit of Notification block status register 1" ],
   "REG_BIT58"                    => [   5,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "58 bit of Notification block status register 1" ],
   "REG_BIT57"                    => [   6,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "57 bit of Notification block status register 1" ],
   "REG_BIT56"                    => [   7,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "56 bit of Notification block status register 1" ],
   "REG_BIT55"                    => [   8,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "55 bit of Notification block status register 1" ],
   "REG_BIT54"                    => [   9,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "54 bit of Notification block status register 1" ],
   "REG_BIT53"                    => [  10,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "53 bit of Notification block status register 1" ],
   "REG_BIT52"                    => [  11,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "52 bit of Notification block status register 1" ],
   "REG_BIT51"                    => [  12,  51,   1, 0x0008000000000000, 0x00, 1, 0x0000000000000000, "51 bit of Notification block status register 1" ],
   "REG_BIT50"                    => [  13,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "50 bit of Notification block status register 1" ],
   "REG_BIT49"                    => [  14,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "49 bit of Notification block status register 1" ],
   "REG_BIT48"                    => [  15,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "48 bit of Notification block status register 1" ],
   "REG_BIT47"                    => [  16,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "47 bit of Notification block status register 1" ],
   "REG_BIT46"                    => [  17,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "46 bit of Notification block status register 1" ],
   "REG_BIT45"                    => [  18,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "45 bit of Notification block status register 1" ],
   "REG_BIT44"                    => [  19,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "44 bit of Notification block status register 1" ],
   "REG_BIT43"                    => [  20,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "43 bit of Notification block status register 1" ],
   "REG_BIT42"                    => [  21,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "42 bit of Notification block status register 1" ],
   "REG_BIT41"                    => [  22,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "41 bit of Notification block status register 1" ],
   "REG_BIT40"                    => [  23,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "40 bit of Notification block status register 1" ],
   "REG_BIT39"                    => [  24,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "39 bit of Notification block status register 1" ],
   "REG_BIT38"                    => [  25,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "38 bit of Notification block status register 1" ],
   "REG_BIT37"                    => [  26,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "37 bit of Notification block status register 1" ],
   "REG_BIT36"                    => [  27,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "36 bit of Notification block status register 1" ],
   "REG_BIT35"                    => [  28,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "35 bit of Notification block status register 1" ],
   "REG_BIT34"                    => [  29,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "34 bit of Notification block status register 1" ],
   "REG_BIT33"                    => [  30,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "33 bit of Notification block status register 1" ],
   "REG_BIT32"                    => [  31,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "32 bit of Notification block status register 1" ],
   "REG_BIT31"                    => [  32,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "31 bit of Notification block status register 1" ],
   "REG_BIT30"                    => [  33,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "30 bit of Notification block status register 1" ],
   "REG_BIT29"                    => [  34,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "29 bit of Notification block status register 1" ],
   "REG_BIT28"                    => [  35,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "28 bit of Notification block status register 1" ],
   "REG_BIT27"                    => [  36,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "27 bit of Notification block status register 1" ],
   "REG_BIT26"                    => [  37,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "26 bit of Notification block status register 1" ],
   "REG_BIT25"                    => [  38,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "25 bit of Notification block status register 1" ],
   "REG_BIT24"                    => [  39,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "24 bit of Notification block status register 1" ],
   "REG_BIT23"                    => [  40,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "23 bit of Notification block status register 1" ],
   "REG_BIT22"                    => [  41,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "22 bit of Notification block status register 1" ],
   "REG_BIT21"                    => [  42,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "21 bit of Notification block status register 1" ],
   "REG_BIT20"                    => [  43,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "20 bit of Notification block status register 1" ],
   "REG_BIT19"                    => [  44,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "19 bit of Notification block status register 1" ],
   "REG_BIT18"                    => [  45,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "18 bit of Notification block status register 1" ],
   "REG_BIT17"                    => [  46,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "17 bit of Notification block status register 1" ],
   "REG_BIT16"                    => [  47,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "16 bit of Notification block status register 1" ],
   "REG_BIT15"                    => [  48,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "15 bit of Notification block status register 1" ],
   "REG_BIT14"                    => [  49,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "14 bit of Notification block status register 1" ],
   "REG_BIT13"                    => [  50,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "13 bit of Notification block status register 1" ],
   "REG_BIT12"                    => [  51,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "12 bit of Notification block status register 1" ],
   "REG_BIT11"                    => [  52,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "11 bit of Notification block status register 1" ],
   "REG_BIT10"                    => [  53,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "10 bit of Notification block status register 1" ],
   "REG_BIT9"                     => [  54,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "9 bit of Notification block status register 1" ],
   "REG_BIT8"                     => [  55,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "8 bit of Notification block status register 1" ],
   "REG_BIT7"                     => [  56,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "7 bit of Notification block status register 1" ],
   "REG_BIT6"                     => [  57,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "6 bit of Notification block status register 1" ],
   "REG_BIT5"                     => [  58,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "5 bit of Notification block status register 1" ],
   "REG_BIT4"                     => [  59,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "4 bit of Notification block status register 1" ],
   "REG_BIT3"                     => [  60,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "3 bit of Notification block status register 1" ],
   "REG_BIT2"                     => [  61,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "2 bit of Notification block status register 1" ],
   "REG_BIT1"                     => [  62,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "1 bit of Notification block status register 1" ],
   "REG_BIT0"                     => [  63,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "0 bit of Notification block status register 1" ],
);

%shub2_01_00504_def =
( NAME    => "SH2_STATUS1",
  ADDRESS => 0x00000000000100a0,
  NOTE    => "This is NOTIFICATION BLOCK STATUS register 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00504_flds
);


##########################################################################
#                                                                        #
#   SH2_STATUS1_ALIAS                                                    #
#                                                                        #
##########################################################################

%shub2_01_00505_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "REG_BIT63"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "63 bit of Notification block status register 1" ],
   "REG_BIT62"                    => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "62 bit of Notification block status register 1" ],
   "REG_BIT61"                    => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "61 bit of Notification block status register 1" ],
   "REG_BIT60"                    => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "60 bit of Notification block status register 1" ],
   "REG_BIT59"                    => [   4,  59,   1, 0x0800000000000000, 0x00, 1, 0x0000000000000000, "59 bit of Notification block status register 1" ],
   "REG_BIT58"                    => [   5,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "58 bit of Notification block status register 1" ],
   "REG_BIT57"                    => [   6,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "57 bit of Notification block status register 1" ],
   "REG_BIT56"                    => [   7,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "56 bit of Notification block status register 1" ],
   "REG_BIT55"                    => [   8,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "55 bit of Notification block status register 1" ],
   "REG_BIT54"                    => [   9,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "54 bit of Notification block status register 1" ],
   "REG_BIT53"                    => [  10,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "53 bit of Notification block status register 1" ],
   "REG_BIT52"                    => [  11,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "52 bit of Notification block status register 1" ],
   "REG_BIT51"                    => [  12,  51,   1, 0x0008000000000000, 0x00, 1, 0x0000000000000000, "51 bit of Notification block status register 1" ],
   "REG_BIT50"                    => [  13,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "50 bit of Notification block status register 1" ],
   "REG_BIT49"                    => [  14,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "49 bit of Notification block status register 1" ],
   "REG_BIT48"                    => [  15,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "48 bit of Notification block status register 1" ],
   "REG_BIT47"                    => [  16,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "47 bit of Notification block status register 1" ],
   "REG_BIT46"                    => [  17,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "46 bit of Notification block status register 1" ],
   "REG_BIT45"                    => [  18,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "45 bit of Notification block status register 1" ],
   "REG_BIT44"                    => [  19,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "44 bit of Notification block status register 1" ],
   "REG_BIT43"                    => [  20,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "43 bit of Notification block status register 1" ],
   "REG_BIT42"                    => [  21,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "42 bit of Notification block status register 1" ],
   "REG_BIT41"                    => [  22,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "41 bit of Notification block status register 1" ],
   "REG_BIT40"                    => [  23,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "40 bit of Notification block status register 1" ],
   "REG_BIT39"                    => [  24,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "39 bit of Notification block status register 1" ],
   "REG_BIT38"                    => [  25,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "38 bit of Notification block status register 1" ],
   "REG_BIT37"                    => [  26,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "37 bit of Notification block status register 1" ],
   "REG_BIT36"                    => [  27,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "36 bit of Notification block status register 1" ],
   "REG_BIT35"                    => [  28,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "35 bit of Notification block status register 1" ],
   "REG_BIT34"                    => [  29,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "34 bit of Notification block status register 1" ],
   "REG_BIT33"                    => [  30,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "33 bit of Notification block status register 1" ],
   "REG_BIT32"                    => [  31,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "32 bit of Notification block status register 1" ],
   "REG_BIT31"                    => [  32,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "31 bit of Notification block status register 1" ],
   "REG_BIT30"                    => [  33,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "30 bit of Notification block status register 1" ],
   "REG_BIT29"                    => [  34,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "29 bit of Notification block status register 1" ],
   "REG_BIT28"                    => [  35,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "28 bit of Notification block status register 1" ],
   "REG_BIT27"                    => [  36,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "27 bit of Notification block status register 1" ],
   "REG_BIT26"                    => [  37,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "26 bit of Notification block status register 1" ],
   "REG_BIT25"                    => [  38,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "25 bit of Notification block status register 1" ],
   "REG_BIT24"                    => [  39,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "24 bit of Notification block status register 1" ],
   "REG_BIT23"                    => [  40,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "23 bit of Notification block status register 1" ],
   "REG_BIT22"                    => [  41,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "22 bit of Notification block status register 1" ],
   "REG_BIT21"                    => [  42,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "21 bit of Notification block status register 1" ],
   "REG_BIT20"                    => [  43,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "20 bit of Notification block status register 1" ],
   "REG_BIT19"                    => [  44,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "19 bit of Notification block status register 1" ],
   "REG_BIT18"                    => [  45,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "18 bit of Notification block status register 1" ],
   "REG_BIT17"                    => [  46,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "17 bit of Notification block status register 1" ],
   "REG_BIT16"                    => [  47,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "16 bit of Notification block status register 1" ],
   "REG_BIT15"                    => [  48,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "15 bit of Notification block status register 1" ],
   "REG_BIT14"                    => [  49,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "14 bit of Notification block status register 1" ],
   "REG_BIT13"                    => [  50,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "13 bit of Notification block status register 1" ],
   "REG_BIT12"                    => [  51,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "12 bit of Notification block status register 1" ],
   "REG_BIT11"                    => [  52,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "11 bit of Notification block status register 1" ],
   "REG_BIT10"                    => [  53,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "10 bit of Notification block status register 1" ],
   "REG_BIT9"                     => [  54,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "9 bit of Notification block status register 1" ],
   "REG_BIT8"                     => [  55,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "8 bit of Notification block status register 1" ],
   "REG_BIT7"                     => [  56,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "7 bit of Notification block status register 1" ],
   "REG_BIT6"                     => [  57,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "6 bit of Notification block status register 1" ],
   "REG_BIT5"                     => [  58,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "5 bit of Notification block status register 1" ],
   "REG_BIT4"                     => [  59,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "4 bit of Notification block status register 1" ],
   "REG_BIT3"                     => [  60,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "3 bit of Notification block status register 1" ],
   "REG_BIT2"                     => [  61,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "2 bit of Notification block status register 1" ],
   "REG_BIT1"                     => [  62,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "1 bit of Notification block status register 1" ],
   "REG_BIT0"                     => [  63,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "0 bit of Notification block status register 1" ],
);

%shub2_01_00505_def =
( NAME    => "SH2_STATUS1_ALIAS",
  ADDRESS => 0x00000000000100a8,
  NOTE    => "nb_status1 alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00505_flds
);


##########################################################################
#                                                                        #
#   SH2_STATUS2                                                          #
#                                                                        #
##########################################################################

%shub2_01_00506_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "REG_BIT63"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "63 bit of Notification block status register 2" ],
   "REG_BIT62"                    => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "62 bit of Notification block status register 2" ],
   "REG_BIT61"                    => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "61 bit of Notification block status register 2" ],
   "REG_BIT60"                    => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "60 bit of Notification block status register 2" ],
   "REG_BIT59"                    => [   4,  59,   1, 0x0800000000000000, 0x00, 1, 0x0000000000000000, "59 bit of Notification block status register 2" ],
   "REG_BIT58"                    => [   5,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "58 bit of Notification block status register 2" ],
   "REG_BIT57"                    => [   6,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "57 bit of Notification block status register 2" ],
   "REG_BIT56"                    => [   7,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "56 bit of Notification block status register 2" ],
   "REG_BIT55"                    => [   8,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "55 bit of Notification block status register 2" ],
   "REG_BIT54"                    => [   9,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "54 bit of Notification block status register 2" ],
   "REG_BIT53"                    => [  10,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "53 bit of Notification block status register 2" ],
   "REG_BIT52"                    => [  11,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "52 bit of Notification block status register 2" ],
   "REG_BIT51"                    => [  12,  51,   1, 0x0008000000000000, 0x00, 1, 0x0000000000000000, "51 bit of Notification block status register 2" ],
   "REG_BIT50"                    => [  13,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "50 bit of Notification block status register 2" ],
   "REG_BIT49"                    => [  14,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "49 bit of Notification block status register 2" ],
   "REG_BIT48"                    => [  15,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "48 bit of Notification block status register 2" ],
   "REG_BIT47"                    => [  16,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "47 bit of Notification block status register 2" ],
   "REG_BIT46"                    => [  17,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "46 bit of Notification block status register 2" ],
   "REG_BIT45"                    => [  18,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "45 bit of Notification block status register 2" ],
   "REG_BIT44"                    => [  19,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "44 bit of Notification block status register 2" ],
   "REG_BIT43"                    => [  20,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "43 bit of Notification block status register 2" ],
   "REG_BIT42"                    => [  21,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "42 bit of Notification block status register 2" ],
   "REG_BIT41"                    => [  22,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "41 bit of Notification block status register 2" ],
   "REG_BIT40"                    => [  23,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "40 bit of Notification block status register 2" ],
   "REG_BIT39"                    => [  24,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "39 bit of Notification block status register 2" ],
   "REG_BIT38"                    => [  25,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "38 bit of Notification block status register 2" ],
   "REG_BIT37"                    => [  26,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "37 bit of Notification block status register 2" ],
   "REG_BIT36"                    => [  27,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "36 bit of Notification block status register 2" ],
   "REG_BIT35"                    => [  28,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "35 bit of Notification block status register 2" ],
   "REG_BIT34"                    => [  29,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "34 bit of Notification block status register 2" ],
   "REG_BIT33"                    => [  30,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "33 bit of Notification block status register 2" ],
   "REG_BIT32"                    => [  31,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "32 bit of Notification block status register 2" ],
   "REG_BIT31"                    => [  32,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "31 bit of Notification block status register 2" ],
   "REG_BIT30"                    => [  33,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "30 bit of Notification block status register 2" ],
   "REG_BIT29"                    => [  34,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "29 bit of Notification block status register 2" ],
   "REG_BIT28"                    => [  35,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "28 bit of Notification block status register 2" ],
   "REG_BIT27"                    => [  36,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "27 bit of Notification block status register 2" ],
   "REG_BIT26"                    => [  37,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "26 bit of Notification block status register 2" ],
   "REG_BIT25"                    => [  38,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "25 bit of Notification block status register 2" ],
   "REG_BIT24"                    => [  39,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "24 bit of Notification block status register 2" ],
   "REG_BIT23"                    => [  40,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "23 bit of Notification block status register 2" ],
   "REG_BIT22"                    => [  41,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "22 bit of Notification block status register 2" ],
   "REG_BIT21"                    => [  42,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "21 bit of Notification block status register 2" ],
   "REG_BIT20"                    => [  43,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "20 bit of Notification block status register 2" ],
   "REG_BIT19"                    => [  44,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "19 bit of Notification block status register 2" ],
   "REG_BIT18"                    => [  45,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "18 bit of Notification block status register 2" ],
   "REG_BIT17"                    => [  46,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "17 bit of Notification block status register 2" ],
   "REG_BIT16"                    => [  47,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "16 bit of Notification block status register 2" ],
   "REG_BIT15"                    => [  48,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "15 bit of Notification block status register 2" ],
   "REG_BIT14"                    => [  49,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "14 bit of Notification block status register 2" ],
   "REG_BIT13"                    => [  50,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "13 bit of Notification block status register 2" ],
   "REG_BIT12"                    => [  51,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "12 bit of Notification block status register 2" ],
   "REG_BIT11"                    => [  52,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "11 bit of Notification block status register 2" ],
   "REG_BIT10"                    => [  53,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "10 bit of Notification block status register 2" ],
   "REG_BIT9"                     => [  54,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "9 bit of Notification block status register 2" ],
   "REG_BIT8"                     => [  55,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "8 bit of Notification block status register 2" ],
   "REG_BIT7"                     => [  56,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "7 bit of Notification block status register 2" ],
   "REG_BIT6"                     => [  57,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "6 bit of Notification block status register 2" ],
   "REG_BIT5"                     => [  58,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "5 bit of Notification block status register 2" ],
   "REG_BIT4"                     => [  59,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "4 bit of Notification block status register 2" ],
   "REG_BIT3"                     => [  60,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "3 bit of Notification block status register 2" ],
   "REG_BIT2"                     => [  61,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "2 bit of Notification block status register 2" ],
   "REG_BIT1"                     => [  62,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "1 bit of Notification block status register 2" ],
   "REG_BIT0"                     => [  63,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "0 bit of Notification block status register 2" ],
);

%shub2_01_00506_def =
( NAME    => "SH2_STATUS2",
  ADDRESS => 0x00000000000100b0,
  NOTE    => "This is NOTIFICATION BLOCK STATUS register 2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00506_flds
);


##########################################################################
#                                                                        #
#   SH2_STATUS2_ALIAS                                                    #
#                                                                        #
##########################################################################

%shub2_01_00507_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "REG_BIT63"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "63 bit of Notification block status register 2" ],
   "REG_BIT62"                    => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "62 bit of Notification block status register 2" ],
   "REG_BIT61"                    => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "61 bit of Notification block status register 2" ],
   "REG_BIT60"                    => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "60 bit of Notification block status register 2" ],
   "REG_BIT59"                    => [   4,  59,   1, 0x0800000000000000, 0x00, 1, 0x0000000000000000, "59 bit of Notification block status register 2" ],
   "REG_BIT58"                    => [   5,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "58 bit of Notification block status register 2" ],
   "REG_BIT57"                    => [   6,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "57 bit of Notification block status register 2" ],
   "REG_BIT56"                    => [   7,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "56 bit of Notification block status register 2" ],
   "REG_BIT55"                    => [   8,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "55 bit of Notification block status register 2" ],
   "REG_BIT54"                    => [   9,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "54 bit of Notification block status register 2" ],
   "REG_BIT53"                    => [  10,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "53 bit of Notification block status register 2" ],
   "REG_BIT52"                    => [  11,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "52 bit of Notification block status register 2" ],
   "REG_BIT51"                    => [  12,  51,   1, 0x0008000000000000, 0x00, 1, 0x0000000000000000, "51 bit of Notification block status register 2" ],
   "REG_BIT50"                    => [  13,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "50 bit of Notification block status register 2" ],
   "REG_BIT49"                    => [  14,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "49 bit of Notification block status register 2" ],
   "REG_BIT48"                    => [  15,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "48 bit of Notification block status register 2" ],
   "REG_BIT47"                    => [  16,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "47 bit of Notification block status register 2" ],
   "REG_BIT46"                    => [  17,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "46 bit of Notification block status register 2" ],
   "REG_BIT45"                    => [  18,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "45 bit of Notification block status register 2" ],
   "REG_BIT44"                    => [  19,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "44 bit of Notification block status register 2" ],
   "REG_BIT43"                    => [  20,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "43 bit of Notification block status register 2" ],
   "REG_BIT42"                    => [  21,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "42 bit of Notification block status register 2" ],
   "REG_BIT41"                    => [  22,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "41 bit of Notification block status register 2" ],
   "REG_BIT40"                    => [  23,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "40 bit of Notification block status register 2" ],
   "REG_BIT39"                    => [  24,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "39 bit of Notification block status register 2" ],
   "REG_BIT38"                    => [  25,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "38 bit of Notification block status register 2" ],
   "REG_BIT37"                    => [  26,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "37 bit of Notification block status register 2" ],
   "REG_BIT36"                    => [  27,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "36 bit of Notification block status register 2" ],
   "REG_BIT35"                    => [  28,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "35 bit of Notification block status register 2" ],
   "REG_BIT34"                    => [  29,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "34 bit of Notification block status register 2" ],
   "REG_BIT33"                    => [  30,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "33 bit of Notification block status register 2" ],
   "REG_BIT32"                    => [  31,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "32 bit of Notification block status register 2" ],
   "REG_BIT31"                    => [  32,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "31 bit of Notification block status register 2" ],
   "REG_BIT30"                    => [  33,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "30 bit of Notification block status register 2" ],
   "REG_BIT29"                    => [  34,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "29 bit of Notification block status register 2" ],
   "REG_BIT28"                    => [  35,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "28 bit of Notification block status register 2" ],
   "REG_BIT27"                    => [  36,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "27 bit of Notification block status register 2" ],
   "REG_BIT26"                    => [  37,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "26 bit of Notification block status register 2" ],
   "REG_BIT25"                    => [  38,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "25 bit of Notification block status register 2" ],
   "REG_BIT24"                    => [  39,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "24 bit of Notification block status register 2" ],
   "REG_BIT23"                    => [  40,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "23 bit of Notification block status register 2" ],
   "REG_BIT22"                    => [  41,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "22 bit of Notification block status register 2" ],
   "REG_BIT21"                    => [  42,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "21 bit of Notification block status register 2" ],
   "REG_BIT20"                    => [  43,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "20 bit of Notification block status register 2" ],
   "REG_BIT19"                    => [  44,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "19 bit of Notification block status register 2" ],
   "REG_BIT18"                    => [  45,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "18 bit of Notification block status register 2" ],
   "REG_BIT17"                    => [  46,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "17 bit of Notification block status register 2" ],
   "REG_BIT16"                    => [  47,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "16 bit of Notification block status register 2" ],
   "REG_BIT15"                    => [  48,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "15 bit of Notification block status register 2" ],
   "REG_BIT14"                    => [  49,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "14 bit of Notification block status register 2" ],
   "REG_BIT13"                    => [  50,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "13 bit of Notification block status register 2" ],
   "REG_BIT12"                    => [  51,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "12 bit of Notification block status register 2" ],
   "REG_BIT11"                    => [  52,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "11 bit of Notification block status register 2" ],
   "REG_BIT10"                    => [  53,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "10 bit of Notification block status register 2" ],
   "REG_BIT9"                     => [  54,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "9 bit of Notification block status register 2" ],
   "REG_BIT8"                     => [  55,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "8 bit of Notification block status register 2" ],
   "REG_BIT7"                     => [  56,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "7 bit of Notification block status register 2" ],
   "REG_BIT6"                     => [  57,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "6 bit of Notification block status register 2" ],
   "REG_BIT5"                     => [  58,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "5 bit of Notification block status register 2" ],
   "REG_BIT4"                     => [  59,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "4 bit of Notification block status register 2" ],
   "REG_BIT3"                     => [  60,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "3 bit of Notification block status register 2" ],
   "REG_BIT2"                     => [  61,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "2 bit of Notification block status register 2" ],
   "REG_BIT1"                     => [  62,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "1 bit of Notification block status register 2" ],
   "REG_BIT0"                     => [  63,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "0 bit of Notification block status register 2" ],
);

%shub2_01_00507_def =
( NAME    => "SH2_STATUS2_ALIAS",
  ADDRESS => 0x00000000000100b8,
  NOTE    => "nb_status2 alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00507_flds
);


##########################################################################
#                                                                        #
#   SH2_STATUS3                                                          #
#                                                                        #
##########################################################################

%shub2_01_00508_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "REG_BIT63"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "63 bit of Notification block status register 3" ],
   "REG_BIT62"                    => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "62 bit of Notification block status register 3" ],
   "REG_BIT61"                    => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "61 bit of Notification block status register 3" ],
   "REG_BIT60"                    => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "60 bit of Notification block status register 3" ],
   "REG_BIT59"                    => [   4,  59,   1, 0x0800000000000000, 0x00, 1, 0x0000000000000000, "59 bit of Notification block status register 3" ],
   "REG_BIT58"                    => [   5,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "58 bit of Notification block status register 3" ],
   "REG_BIT57"                    => [   6,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "57 bit of Notification block status register 3" ],
   "REG_BIT56"                    => [   7,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "56 bit of Notification block status register 3" ],
   "REG_BIT55"                    => [   8,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "55 bit of Notification block status register 3" ],
   "REG_BIT54"                    => [   9,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "54 bit of Notification block status register 3" ],
   "REG_BIT53"                    => [  10,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "53 bit of Notification block status register 3" ],
   "REG_BIT52"                    => [  11,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "52 bit of Notification block status register 3" ],
   "REG_BIT51"                    => [  12,  51,   1, 0x0008000000000000, 0x00, 1, 0x0000000000000000, "51 bit of Notification block status register 3" ],
   "REG_BIT50"                    => [  13,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "50 bit of Notification block status register 3" ],
   "REG_BIT49"                    => [  14,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "49 bit of Notification block status register 3" ],
   "REG_BIT48"                    => [  15,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "48 bit of Notification block status register 3" ],
   "REG_BIT47"                    => [  16,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "47 bit of Notification block status register 3" ],
   "REG_BIT46"                    => [  17,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "46 bit of Notification block status register 3" ],
   "REG_BIT45"                    => [  18,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "45 bit of Notification block status register 3" ],
   "REG_BIT44"                    => [  19,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "44 bit of Notification block status register 3" ],
   "REG_BIT43"                    => [  20,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "43 bit of Notification block status register 3" ],
   "REG_BIT42"                    => [  21,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "42 bit of Notification block status register 3" ],
   "REG_BIT41"                    => [  22,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "41 bit of Notification block status register 3" ],
   "REG_BIT40"                    => [  23,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "40 bit of Notification block status register 3" ],
   "REG_BIT39"                    => [  24,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "39 bit of Notification block status register 3" ],
   "REG_BIT38"                    => [  25,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "38 bit of Notification block status register 3" ],
   "REG_BIT37"                    => [  26,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "37 bit of Notification block status register 3" ],
   "REG_BIT36"                    => [  27,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "36 bit of Notification block status register 3" ],
   "REG_BIT35"                    => [  28,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "35 bit of Notification block status register 3" ],
   "REG_BIT34"                    => [  29,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "34 bit of Notification block status register 3" ],
   "REG_BIT33"                    => [  30,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "33 bit of Notification block status register 3" ],
   "REG_BIT32"                    => [  31,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "32 bit of Notification block status register 3" ],
   "REG_BIT31"                    => [  32,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "31 bit of Notification block status register 3" ],
   "REG_BIT30"                    => [  33,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "30 bit of Notification block status register 3" ],
   "REG_BIT29"                    => [  34,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "29 bit of Notification block status register 3" ],
   "REG_BIT28"                    => [  35,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "28 bit of Notification block status register 3" ],
   "REG_BIT27"                    => [  36,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "27 bit of Notification block status register 3" ],
   "REG_BIT26"                    => [  37,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "26 bit of Notification block status register 3" ],
   "REG_BIT25"                    => [  38,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "25 bit of Notification block status register 3" ],
   "REG_BIT24"                    => [  39,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "24 bit of Notification block status register 3" ],
   "REG_BIT23"                    => [  40,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "23 bit of Notification block status register 3" ],
   "REG_BIT22"                    => [  41,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "22 bit of Notification block status register 3" ],
   "REG_BIT21"                    => [  42,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "21 bit of Notification block status register 3" ],
   "REG_BIT20"                    => [  43,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "20 bit of Notification block status register 3" ],
   "REG_BIT19"                    => [  44,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "19 bit of Notification block status register 3" ],
   "REG_BIT18"                    => [  45,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "18 bit of Notification block status register 3" ],
   "REG_BIT17"                    => [  46,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "17 bit of Notification block status register 3" ],
   "REG_BIT16"                    => [  47,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "16 bit of Notification block status register 3" ],
   "REG_BIT15"                    => [  48,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "15 bit of Notification block status register 3" ],
   "REG_BIT14"                    => [  49,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "14 bit of Notification block status register 3" ],
   "REG_BIT13"                    => [  50,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "13 bit of Notification block status register 3" ],
   "REG_BIT12"                    => [  51,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "12 bit of Notification block status register 3" ],
   "REG_BIT11"                    => [  52,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "11 bit of Notification block status register 3" ],
   "REG_BIT10"                    => [  53,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "10 bit of Notification block status register 3" ],
   "REG_BIT9"                     => [  54,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "9 bit of Notification block status register 3" ],
   "REG_BIT8"                     => [  55,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "8 bit of Notification block status register 3" ],
   "REG_BIT7"                     => [  56,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "7 bit of Notification block status register 3" ],
   "REG_BIT6"                     => [  57,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "6 bit of Notification block status register 3" ],
   "REG_BIT5"                     => [  58,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "5 bit of Notification block status register 3" ],
   "REG_BIT4"                     => [  59,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "4 bit of Notification block status register 3" ],
   "REG_BIT3"                     => [  60,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "3 bit of Notification block status register 3" ],
   "REG_BIT2"                     => [  61,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "2 bit of Notification block status register 3" ],
   "REG_BIT1"                     => [  62,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "1 bit of Notification block status register 3" ],
   "REG_BIT0"                     => [  63,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "0 bit of Notification block status register 3" ],
);

%shub2_01_00508_def =
( NAME    => "SH2_STATUS3",
  ADDRESS => 0x00000000000100c0,
  NOTE    => "This is NOTIFICATION BLOCK STATUS register 3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00508_flds
);


##########################################################################
#                                                                        #
#   SH2_STATUS3_ALIAS                                                    #
#                                                                        #
##########################################################################

%shub2_01_00509_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "REG_BIT63"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "63 bit of Notification block status register 3" ],
   "REG_BIT62"                    => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "62 bit of Notification block status register 3" ],
   "REG_BIT61"                    => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "61 bit of Notification block status register 3" ],
   "REG_BIT60"                    => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "60 bit of Notification block status register 3" ],
   "REG_BIT59"                    => [   4,  59,   1, 0x0800000000000000, 0x00, 1, 0x0000000000000000, "59 bit of Notification block status register 3" ],
   "REG_BIT58"                    => [   5,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "58 bit of Notification block status register 3" ],
   "REG_BIT57"                    => [   6,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "57 bit of Notification block status register 3" ],
   "REG_BIT56"                    => [   7,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "56 bit of Notification block status register 3" ],
   "REG_BIT55"                    => [   8,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "55 bit of Notification block status register 3" ],
   "REG_BIT54"                    => [   9,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "54 bit of Notification block status register 3" ],
   "REG_BIT53"                    => [  10,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "53 bit of Notification block status register 3" ],
   "REG_BIT52"                    => [  11,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "52 bit of Notification block status register 3" ],
   "REG_BIT51"                    => [  12,  51,   1, 0x0008000000000000, 0x00, 1, 0x0000000000000000, "51 bit of Notification block status register 3" ],
   "REG_BIT50"                    => [  13,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "50 bit of Notification block status register 3" ],
   "REG_BIT49"                    => [  14,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "49 bit of Notification block status register 3" ],
   "REG_BIT48"                    => [  15,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "48 bit of Notification block status register 3" ],
   "REG_BIT47"                    => [  16,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "47 bit of Notification block status register 3" ],
   "REG_BIT46"                    => [  17,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "46 bit of Notification block status register 3" ],
   "REG_BIT45"                    => [  18,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "45 bit of Notification block status register 3" ],
   "REG_BIT44"                    => [  19,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "44 bit of Notification block status register 3" ],
   "REG_BIT43"                    => [  20,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "43 bit of Notification block status register 3" ],
   "REG_BIT42"                    => [  21,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "42 bit of Notification block status register 3" ],
   "REG_BIT41"                    => [  22,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "41 bit of Notification block status register 3" ],
   "REG_BIT40"                    => [  23,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "40 bit of Notification block status register 3" ],
   "REG_BIT39"                    => [  24,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "39 bit of Notification block status register 3" ],
   "REG_BIT38"                    => [  25,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "38 bit of Notification block status register 3" ],
   "REG_BIT37"                    => [  26,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "37 bit of Notification block status register 3" ],
   "REG_BIT36"                    => [  27,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "36 bit of Notification block status register 3" ],
   "REG_BIT35"                    => [  28,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "35 bit of Notification block status register 3" ],
   "REG_BIT34"                    => [  29,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "34 bit of Notification block status register 3" ],
   "REG_BIT33"                    => [  30,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "33 bit of Notification block status register 3" ],
   "REG_BIT32"                    => [  31,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "32 bit of Notification block status register 3" ],
   "REG_BIT31"                    => [  32,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "31 bit of Notification block status register 3" ],
   "REG_BIT30"                    => [  33,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "30 bit of Notification block status register 3" ],
   "REG_BIT29"                    => [  34,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "29 bit of Notification block status register 3" ],
   "REG_BIT28"                    => [  35,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "28 bit of Notification block status register 3" ],
   "REG_BIT27"                    => [  36,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "27 bit of Notification block status register 3" ],
   "REG_BIT26"                    => [  37,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "26 bit of Notification block status register 3" ],
   "REG_BIT25"                    => [  38,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "25 bit of Notification block status register 3" ],
   "REG_BIT24"                    => [  39,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "24 bit of Notification block status register 3" ],
   "REG_BIT23"                    => [  40,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "23 bit of Notification block status register 3" ],
   "REG_BIT22"                    => [  41,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "22 bit of Notification block status register 3" ],
   "REG_BIT21"                    => [  42,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "21 bit of Notification block status register 3" ],
   "REG_BIT20"                    => [  43,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "20 bit of Notification block status register 3" ],
   "REG_BIT19"                    => [  44,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "19 bit of Notification block status register 3" ],
   "REG_BIT18"                    => [  45,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "18 bit of Notification block status register 3" ],
   "REG_BIT17"                    => [  46,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "17 bit of Notification block status register 3" ],
   "REG_BIT16"                    => [  47,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "16 bit of Notification block status register 3" ],
   "REG_BIT15"                    => [  48,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "15 bit of Notification block status register 3" ],
   "REG_BIT14"                    => [  49,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "14 bit of Notification block status register 3" ],
   "REG_BIT13"                    => [  50,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "13 bit of Notification block status register 3" ],
   "REG_BIT12"                    => [  51,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "12 bit of Notification block status register 3" ],
   "REG_BIT11"                    => [  52,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "11 bit of Notification block status register 3" ],
   "REG_BIT10"                    => [  53,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "10 bit of Notification block status register 3" ],
   "REG_BIT9"                     => [  54,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "9 bit of Notification block status register 3" ],
   "REG_BIT8"                     => [  55,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "8 bit of Notification block status register 3" ],
   "REG_BIT7"                     => [  56,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "7 bit of Notification block status register 3" ],
   "REG_BIT6"                     => [  57,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "6 bit of Notification block status register 3" ],
   "REG_BIT5"                     => [  58,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "5 bit of Notification block status register 3" ],
   "REG_BIT4"                     => [  59,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "4 bit of Notification block status register 3" ],
   "REG_BIT3"                     => [  60,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "3 bit of Notification block status register 3" ],
   "REG_BIT2"                     => [  61,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "2 bit of Notification block status register 3" ],
   "REG_BIT1"                     => [  62,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "1 bit of Notification block status register 3" ],
   "REG_BIT0"                     => [  63,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "0 bit of Notification block status register 3" ],
);

%shub2_01_00509_def =
( NAME    => "SH2_STATUS3_ALIAS",
  ADDRESS => 0x00000000000100c8,
  NOTE    => "nb_status3 alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00509_flds
);


##########################################################################
#                                                                        #
#   SH2_CFG                                                              #
#                                                                        #
##########################################################################

%shub2_01_00510_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  52,  12, 0xFFF0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DW_BLOCK_SIZE_EXPONENT"       => [   1,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "dw block size exponent" ],
   "RSVD1"                        => [   2,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ALIGNED_BASE_ADDR"            => [   3,  12,  26, 0x0000003FFFFFF000, 0x00, 1, 0x0000000000000000, "aligned base address" ],
);

%shub2_01_00510_def =
( NAME    => "SH2_CFG",
  ADDRESS => 0x00000000000100d0,
  NOTE    => "This is NOTIFICATION MEMORY CONFIGURATION REGISTER",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00510_flds
);


##########################################################################
#                                                                        #
#   SH2_PIO_RQ_CRD_CTL                                                   #
#                                                                        #
##########################################################################

%shub2_01_00511_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   6,  58, 0xFFFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEPTH"                        => [   1,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "Total depth of buffering (in sic packets)" ],
);

%shub2_01_00511_def =
( NAME    => "SH2_PIO_RQ_CRD_CTL",
  ADDRESS => 0x00000000000100d8,
  NOTE    => "This register provides control of the number of packets that are note allowed to be in progress on this virtual channel.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00511_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_MD_RQ_CRD_CTL                                                 #
#                                                                        #
##########################################################################

%shub2_01_00512_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   6,  58, 0xFFFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEPTH"                        => [   1,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "Total depth of buffering (in sic packets)" ],
);

%shub2_01_00512_def =
( NAME    => "SH2_PI_MD_RQ_CRD_CTL",
  ADDRESS => 0x00000000000100e0,
  NOTE    => "This register provides control of the number of packets that are note allowed to be in progress on this virtual channel.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00512_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_MD_RP_CRD_CTL                                                 #
#                                                                        #
##########################################################################

%shub2_01_00513_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   6,  58, 0xFFFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEPTH"                        => [   1,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "Total depth of buffering (in sic packets)" ],
);

%shub2_01_00513_def =
( NAME    => "SH2_PI_MD_RP_CRD_CTL",
  ADDRESS => 0x00000000000100e8,
  NOTE    => "This register provides control of the number of packets that are note allowed to be in progress on this virtual channel.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00513_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_MD_RQ_CRD_CTL                                                 #
#                                                                        #
##########################################################################

%shub2_01_00514_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   6,  58, 0xFFFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEPTH"                        => [   1,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "Total depth of buffering (in sic packets)" ],
);

%shub2_01_00514_def =
( NAME    => "SH2_XN_MD_RQ_CRD_CTL",
  ADDRESS => 0x00000000000100f0,
  NOTE    => "This register provides control of the number of packets that are note allowed to be in progress on this virtual channel.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00514_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_MD_RP_CRD_CTL                                                 #
#                                                                        #
##########################################################################

%shub2_01_00515_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   6,  58, 0xFFFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEPTH"                        => [   1,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "Total depth of buffering (in sic packets)" ],
);

%shub2_01_00515_def =
( NAME    => "SH2_XN_MD_RP_CRD_CTL",
  ADDRESS => 0x00000000000100f8,
  NOTE    => "This register provides control of the number of packets that are note allowed to be in progress on this virtual channel.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00515_flds
);


##########################################################################
#                                                                        #
#   SH2_X_TAG0                                                           #
#                                                                        #
##########################################################################

%shub2_01_00516_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "Tag address == tag[21:1], Valid == tag[0]" ],
);

%shub2_01_00516_def =
( NAME    => "SH2_X_TAG0",
  ADDRESS => 0x0000000000020000,
  NOTE    => "Directory cache tag registers are loaded using MMRBIST READ_DIR_TAG note function. Tag address == byte address bits [37:17]",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00516_flds
);


##########################################################################
#                                                                        #
#   SH2_X_TAG1                                                           #
#                                                                        #
##########################################################################

%shub2_01_00517_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "Tag address == tag[21:1], Valid == tag[0]" ],
);

%shub2_01_00517_def =
( NAME    => "SH2_X_TAG1",
  ADDRESS => 0x0000000000020008,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00517_flds
);


##########################################################################
#                                                                        #
#   SH2_X_TAG2                                                           #
#                                                                        #
##########################################################################

%shub2_01_00518_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "Tag address == tag[21:1], Valid == tag[0]" ],
);

%shub2_01_00518_def =
( NAME    => "SH2_X_TAG2",
  ADDRESS => 0x0000000000020010,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00518_flds
);


##########################################################################
#                                                                        #
#   SH2_X_TAG3                                                           #
#                                                                        #
##########################################################################

%shub2_01_00519_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "Tag address == tag[21:1], Valid == tag[0]" ],
);

%shub2_01_00519_def =
( NAME    => "SH2_X_TAG3",
  ADDRESS => 0x0000000000020018,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00519_flds
);


##########################################################################
#                                                                        #
#   SH2_X_TAG4                                                           #
#                                                                        #
##########################################################################

%shub2_01_00520_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "Tag address == tag[21:1], Valid == tag[0]" ],
);

%shub2_01_00520_def =
( NAME    => "SH2_X_TAG4",
  ADDRESS => 0x0000000000020020,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00520_flds
);


##########################################################################
#                                                                        #
#   SH2_X_TAG5                                                           #
#                                                                        #
##########################################################################

%shub2_01_00521_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "Tag address == tag[21:1], Valid == tag[0]" ],
);

%shub2_01_00521_def =
( NAME    => "SH2_X_TAG5",
  ADDRESS => 0x0000000000020028,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00521_flds
);


##########################################################################
#                                                                        #
#   SH2_X_TAG6                                                           #
#                                                                        #
##########################################################################

%shub2_01_00522_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "Tag address == tag[21:1], Valid == tag[0]" ],
);

%shub2_01_00522_def =
( NAME    => "SH2_X_TAG6",
  ADDRESS => 0x0000000000020030,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00522_flds
);


##########################################################################
#                                                                        #
#   SH2_X_TAG7                                                           #
#                                                                        #
##########################################################################

%shub2_01_00523_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "Tag address == tag[21:1], Valid == tag[0]" ],
);

%shub2_01_00523_def =
( NAME    => "SH2_X_TAG7",
  ADDRESS => 0x0000000000020038,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00523_flds
);


##########################################################################
#                                                                        #
#   SH2_Y_TAG0                                                           #
#                                                                        #
##########################################################################

%shub2_01_00524_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "Tag address == tag[21:1], Valid == tag[0]" ],
);

%shub2_01_00524_def =
( NAME    => "SH2_Y_TAG0",
  ADDRESS => 0x0000000000020040,
  NOTE    => "Directory cache tag registers are loaded using MMRBIST READ_DIR_TAG note function. Tag address == byte address bits [37:17]",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00524_flds
);


##########################################################################
#                                                                        #
#   SH2_Y_TAG1                                                           #
#                                                                        #
##########################################################################

%shub2_01_00525_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "Tag address == tag[21:1], Valid == tag[0]" ],
);

%shub2_01_00525_def =
( NAME    => "SH2_Y_TAG1",
  ADDRESS => 0x0000000000020048,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00525_flds
);


##########################################################################
#                                                                        #
#   SH2_Y_TAG2                                                           #
#                                                                        #
##########################################################################

%shub2_01_00526_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "Tag address == tag[21:1], Valid == tag[0]" ],
);

%shub2_01_00526_def =
( NAME    => "SH2_Y_TAG2",
  ADDRESS => 0x0000000000020050,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00526_flds
);


##########################################################################
#                                                                        #
#   SH2_Y_TAG3                                                           #
#                                                                        #
##########################################################################

%shub2_01_00527_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "Tag address == tag[21:1], Valid == tag[0]" ],
);

%shub2_01_00527_def =
( NAME    => "SH2_Y_TAG3",
  ADDRESS => 0x0000000000020058,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00527_flds
);


##########################################################################
#                                                                        #
#   SH2_Y_TAG4                                                           #
#                                                                        #
##########################################################################

%shub2_01_00528_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "Tag address == tag[21:1], Valid == tag[0]" ],
);

%shub2_01_00528_def =
( NAME    => "SH2_Y_TAG4",
  ADDRESS => 0x0000000000020060,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00528_flds
);


##########################################################################
#                                                                        #
#   SH2_Y_TAG5                                                           #
#                                                                        #
##########################################################################

%shub2_01_00529_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "Tag address == tag[21:1], Valid == tag[0]" ],
);

%shub2_01_00529_def =
( NAME    => "SH2_Y_TAG5",
  ADDRESS => 0x0000000000020068,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00529_flds
);


##########################################################################
#                                                                        #
#   SH2_Y_TAG6                                                           #
#                                                                        #
##########################################################################

%shub2_01_00530_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "Tag address == tag[21:1], Valid == tag[0]" ],
);

%shub2_01_00530_def =
( NAME    => "SH2_Y_TAG6",
  ADDRESS => 0x0000000000020070,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00530_flds
);


##########################################################################
#                                                                        #
#   SH2_Y_TAG7                                                           #
#                                                                        #
##########################################################################

%shub2_01_00531_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "Tag address == tag[21:1], Valid == tag[0]" ],
);

%shub2_01_00531_def =
( NAME    => "SH2_Y_TAG7",
  ADDRESS => 0x0000000000020078,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00531_flds
);


##########################################################################
#                                                                        #
#   SH2_MMRBIST_BASE                                                     #
#                                                                        #
##########################################################################

%shub2_01_00532_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  50,  14, 0xFFFC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DWORD_ADDR"                   => [   1,   3,  47, 0x0003FFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "bits 49:3 of the memory address" ],
);

%shub2_01_00532_def =
( NAME    => "SH2_MMRBIST_BASE",
  ADDRESS => 0x0000000000020080,
  NOTE    => "This register provides the starting address for an mmr/bist note operation.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00532_flds
);


##########################################################################
#                                                                        #
#   SH2_MMRBIST_CTL                                                      #
#                                                                        #
##########################################################################

%shub2_01_00533_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  51,  13, 0xFFF8000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_MODE_STOP_ON_ERR"         => [   1,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "If we get bist_err pio_operation will stop if this is set" ],
   "PIO_MODE_STRIDE_ORDER"        => [   2,  46,   4, 0x0003C00000000000, 0x00, 1, 0x0000000000000000, "This register is used to define the stride order of the address, RAS,CAS,BANKS and EXTERNAL BANKS can be selected to incerment or decrement" ],
   "PIO_MODE_ADDR_DEC"            => [   3,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "If this bit is set then MD will decrement next pio address if this bit is cleared then MD will increment next pio address" ],
   "RESET_STATE"                  => [   4,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "writing a 1 resets mmrbist hardware, hardware clears on completion" ],
   "RSVD1"                        => [   5,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MEM_IDLE"                     => [   6,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "all memory activity is complete" ],
   "FAIL"                         => [   7,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "mmr/bist had a data or address error" ],
   "IN_PROGRESS"                  => [   8,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "writing a 1 starts operation, hardware clears on completion" ],
   "RSVD2"                        => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CMD"                          => [  10,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "mmr/bist function" ],
   "RSVD3"                        => [  11,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BLOCK_LENGTH"                 => [  12,   0,  31, 0x000000007FFFFFFF, 0x00, 0, 0x0000000000000000, "number of dwords in operation" ],
);

%shub2_01_00533_def =
( NAME    => "SH2_MMRBIST_CTL",
  ADDRESS => 0x0000000000020088,
  NOTE    => "The registers controls the size and function of the mmr/bist note operation. An operation will continue in the face of a data er",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00533_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DBUG_DATA_CFG                                                 #
#                                                                        #
##########################################################################

%shub2_01_00534_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE"               => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "selects nibble[7:0] from selected chiplet to connect to nibble7 of debug output port" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_CHIPLET"              => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "selects which md rlm connects to nibble7 of debug output port" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE"               => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "selects nibble[7:0] from selected chiplet to connect to nibble6 of debug output port" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_CHIPLET"              => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "selects which md rlm connects to nibble6 of debug output port" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE"               => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "selects nibble[7:0] from selected chiplet to connect to nibble5 of debug output port" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_CHIPLET"              => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "selects which md rlm connects to nibble5 of debug output port" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE"               => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "selects nibble[7:0] from selected chiplet to connect to nibble4 of debug output port" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_CHIPLET"              => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "selects which md rlm connects to nibble4 of debug output port" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE"               => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "selects nibble[7:0] from selected chiplet to connect to nibble3 of debug output port" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_CHIPLET"              => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "selects which md rlm connects to nibble3 of debug output port" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE"               => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "selects nibble[7:0] from selected chiplet to connect to nibble2 of debug output port" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_CHIPLET"              => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "selects which md rlm connects to nibble2 of debug output port" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE"               => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "selects nibble[7:0] from selected chiplet to connect to nibble1 of debug output port" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_CHIPLET"              => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "selects which md rlm connects to nibble1 of debug output port" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE"               => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "selects nibble[7:0] from selected chiplet to connect to nibble0 of debug output port" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_CHIPLET"              => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "selects which md rlm connects to nibble0 of debug output port" ],
);

%shub2_01_00534_def =
( NAME    => "SH2_MD_DBUG_DATA_CFG",
  ADDRESS => 0x0000000000020100,
  NOTE    => "Maps chiplets and associated nibbles to MD debug port. This note register controls the construction of a 32-bit debug word that ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00534_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DBUG_TRIGGER_CFG                                              #
#                                                                        #
##########################################################################

%shub2_01_00535_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "enables triggering on pattern match" ],
   "NIBBLE7_NIBBLE"               => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "selects which nibble[7:0] to connect to nibble7 of trigger configuration register" ],
   "RSVD0"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_CHIPLET"              => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "select md rlm to connect to nibble7 of trigger configuration register" ],
   "RSVD1"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE"               => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "selects which nibble[7:0] to connect to nibble6 of trigger configuration register" ],
   "RSVD2"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_CHIPLET"              => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "select md rlm to connect to nibble6 of trigger configuration register" ],
   "RSVD3"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE"               => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "selects which nibble[7:0] to connect to nibble5 of trigger configuration register" ],
   "RSVD4"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_CHIPLET"              => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "select md rlm to connect to nibble5 of trigger configuration register" ],
   "RSVD5"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE"               => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "selects which nibble[7:0] to connect to nibble4 of trigger configuration register" ],
   "RSVD6"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_CHIPLET"              => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "select md rlm to connect to nibble4 of trigger configuration register" ],
   "RSVD7"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE"               => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "selects which nibble[7:0] to connect to nibble3 of trigger configuration register" ],
   "RSVD8"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_CHIPLET"              => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "select md rlm to connect to nibble3 of trigger configuration register" ],
   "RSVD9"                        => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE"               => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "selects which nibble[7:0] to connect to nibble2 of trigger configuration register" ],
   "RSVD10"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_CHIPLET"              => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "select md rlm to connect to nibble2 of trigger configuration register" ],
   "RSVD11"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE"               => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "selects which nibble[7:0] to connect to nibble1 of trigger configuration register" ],
   "RSVD12"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_CHIPLET"              => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "select md rlm to connect to nibble1 of trigger configuration register" ],
   "RSVD13"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE"               => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "selects which nibble[7:0] to connect to nibble0 of trigger configuration register" ],
   "RSVD14"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_CHIPLET"              => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "select md rlm to connect to nibble0 of trigger configuration register" ],
);

%shub2_01_00535_def =
( NAME    => "SH2_MD_DBUG_TRIGGER_CFG",
  ADDRESS => 0x0000000000020108,
  NOTE    => "This register controls the muxes used for pattern matching. A set note of muxes exists to construct a 32 bit word to compare aga",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00535_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DBUG_COMPARE                                                  #
#                                                                        #
##########################################################################

%shub2_01_00536_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "bits to include in compare of dbug data for trigger" ],
   "PATTERN"                      => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "pattern against which to compare dbug data for trigger" ],
);

%shub2_01_00536_def =
( NAME    => "SH2_MD_DBUG_COMPARE",
  ADDRESS => 0x0000000000020110,
  NOTE    => "The debug compare and mask values in this register are used to do note pattern matching on a 32 bit trigger word created from de",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00536_flds
);


##########################################################################
#                                                                        #
#   SH2_X_TAG_DBUG_SEL                                                   #
#                                                                        #
##########################################################################

%shub2_01_00537_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG_SEL"                      => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "tagmgr select" ],
);

%shub2_01_00537_def =
( NAME    => "SH2_X_TAG_DBUG_SEL",
  ADDRESS => 0x0000000000020118,
  NOTE    => "Each AC can be configured to send the appropriate internal state to note the output debug port. This register is used to select ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00537_flds
);


##########################################################################
#                                                                        #
#   SH2_X_WBQ_DBUG_SEL                                                   #
#                                                                        #
##########################################################################

%shub2_01_00538_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WBQ_SEL"                      => [   1,   0,  24, 0x0000000000FFFFFF, 0x00, 0, 0x0000000000000000, "wbqtg select" ],
);

%shub2_01_00538_def =
( NAME    => "SH2_X_WBQ_DBUG_SEL",
  ADDRESS => 0x0000000000020120,
  NOTE    => "Each AC can be configured to send the appropriate internal state to note the output debug port. This register is used to select ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00538_flds
);


##########################################################################
#                                                                        #
#   SH2_X_ARB_DBUG_SEL                                                   #
#                                                                        #
##########################################################################

%shub2_01_00539_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARB_SEL"                      => [   1,   0,  24, 0x0000000000FFFFFF, 0x00, 0, 0x0000000000000000, "arbque select" ],
);

%shub2_01_00539_def =
( NAME    => "SH2_X_ARB_DBUG_SEL",
  ADDRESS => 0x0000000000020128,
  NOTE    => "Each AC can be configured to send the appropriate internal state to note the output debug port. This register is used to select ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00539_flds
);


##########################################################################
#                                                                        #
#   SH2_X_ATL_DBUG_SEL                                                   #
#                                                                        #
##########################################################################

%shub2_01_00540_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ATL_SEL"                      => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "aintl select" ],
);

%shub2_01_00540_def =
( NAME    => "SH2_X_ATL_DBUG_SEL",
  ADDRESS => 0x0000000000020130,
  NOTE    => "Each AC can be configured to send the appropriate internal state to note the output debug port. This register is used to select ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00540_flds
);


##########################################################################
#                                                                        #
#   SH2_X_ATR_DBUG_SEL                                                   #
#                                                                        #
##########################################################################

%shub2_01_00541_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ATR_SEL"                      => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "aintr select" ],
);

%shub2_01_00541_def =
( NAME    => "SH2_X_ATR_DBUG_SEL",
  ADDRESS => 0x0000000000020138,
  NOTE    => "Each AC can be configured to send the appropriate internal state to note the output debug port. This register is used to select ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00541_flds
);


##########################################################################
#                                                                        #
#   SH2_X_DQL_DBUG_SEL                                                   #
#                                                                        #
##########################################################################

%shub2_01_00542_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  15,  49, 0xFFFFFFFFFFFF8000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQL_SEL"                      => [   1,   0,  15, 0x0000000000007FFF, 0x00, 0, 0x0000000000000000, "dqctr select" ],
);

%shub2_01_00542_def =
( NAME    => "SH2_X_DQL_DBUG_SEL",
  ADDRESS => 0x0000000000020140,
  NOTE    => "Each AC can be configured to send the appropriate internal state to note the output debug port. This register is used to select ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00542_flds
);


##########################################################################
#                                                                        #
#   SH2_X_DQR_DBUG_SEL                                                   #
#                                                                        #
##########################################################################

%shub2_01_00543_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  15,  49, 0xFFFFFFFFFFFF8000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQR_SEL"                      => [   1,   0,  15, 0x0000000000007FFF, 0x00, 0, 0x0000000000000000, "dqctl select" ],
);

%shub2_01_00543_def =
( NAME    => "SH2_X_DQR_DBUG_SEL",
  ADDRESS => 0x0000000000020148,
  NOTE    => "Each AC can be configured to send the appropriate internal state to note the output debug port. This register is used to select ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00543_flds
);


##########################################################################
#                                                                        #
#   SH2_X_DBUG_SEL                                                       #
#                                                                        #
##########################################################################

%shub2_01_00544_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DBG_SEL"                      => [   1,   0,  24, 0x0000000000FFFFFF, 0x00, 0, 0x0000000000000000, "Nibble[7:0] RLM select" ],
);

%shub2_01_00544_def =
( NAME    => "SH2_X_DBUG_SEL",
  ADDRESS => 0x0000000000020150,
  NOTE    => "This register selects between the submodules within the AC RLMs. note Additional tables that describe how the debug ports can be",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00544_flds
);


##########################################################################
#                                                                        #
#   SH2_X_LADDR_CMP                                                      #
#                                                                        #
##########################################################################

%shub2_01_00545_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MASK_VAL"                     => [   1,  32,  30, 0x3FFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Byte address [37-8] mask value, 1=enables compare check" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CMP_VAL"                      => [   3,   0,  30, 0x000000003FFFFFFF, 0x00, 0, 0x0000000000000000, "Byte address [37-8] compare value" ],
);

%shub2_01_00545_def =
( NAME    => "SH2_X_LADDR_CMP",
  ADDRESS => 0x0000000000020158,
  NOTE    => "Address compare register is used to trigger on specific requests note that are issuing from arbque. The register consists of a c",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00545_flds
);


##########################################################################
#                                                                        #
#   SH2_X_RADDR_CMP                                                      #
#                                                                        #
##########################################################################

%shub2_01_00546_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MASK_VAL"                     => [   1,  32,  30, 0x3FFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Byte address [37-8] mask value, 1=enables compare check" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CMP_VAL"                      => [   3,   0,  30, 0x000000003FFFFFFF, 0x00, 0, 0x0000000000000000, "Byte address [37-8] compare value" ],
);

%shub2_01_00546_def =
( NAME    => "SH2_X_RADDR_CMP",
  ADDRESS => 0x0000000000020160,
  NOTE    => "Address compare register is used to trigger on specific requests note that are issuing from arbque. The register consists of a c",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00546_flds
);


##########################################################################
#                                                                        #
#   SH2_X_TAG_CMP                                                        #
#                                                                        #
##########################################################################

%shub2_01_00547_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SRC"                          => [   1,  44,  16, 0x0FFFF00000000000, 0x00, 0, 0x0000000000000000, "Source compare value" ],
   "RSVD1"                        => [   2,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR"                         => [   3,   8,  35, 0x000007FFFFFFFF00, 0x00, 0, 0x0000000000000000, "Address compare value" ],
   "CMD"                          => [   4,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Command compare value" ],
);

%shub2_01_00547_def =
( NAME    => "SH2_X_TAG_CMP",
  ADDRESS => 0x0000000000020168,
  NOTE    => "Tag compare register is used to trigger on specific requests that note are issuing from MD JNR to AC tagmgr. The compare fields ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00547_flds
);


##########################################################################
#                                                                        #
#   SH2_X_TAG_MASK                                                       #
#                                                                        #
##########################################################################

%shub2_01_00548_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SRC"                          => [   1,  44,  16, 0x0FFFF00000000000, 0x00, 0, 0x0000000000000000, "Source compare value" ],
   "RSVD1"                        => [   2,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR"                         => [   3,   8,  35, 0x000007FFFFFFFF00, 0x00, 0, 0x0000000000000000, "Address compare value, 1=enables compare check" ],
   "CMD"                          => [   4,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Command compare value, 1=enables compare check" ],
);

%shub2_01_00548_def =
( NAME    => "SH2_X_TAG_MASK",
  ADDRESS => 0x0000000000020170,
  NOTE    => "Tag mask register is used with the tag compare register to fine note tune the desired trigger event. This register consists of a",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00548_flds
);


##########################################################################
#                                                                        #
#   SH2_Y_TAG_DBUG_SEL                                                   #
#                                                                        #
##########################################################################

%shub2_01_00549_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG_SEL"                      => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "tagmgr select" ],
);

%shub2_01_00549_def =
( NAME    => "SH2_Y_TAG_DBUG_SEL",
  ADDRESS => 0x0000000000020178,
  NOTE    => "Each AC can be configured to send the appropriate internal state to note the output debug port. This register is used to select ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00549_flds
);


##########################################################################
#                                                                        #
#   SH2_Y_WBQ_DBUG_SEL                                                   #
#                                                                        #
##########################################################################

%shub2_01_00550_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WBQ_SEL"                      => [   1,   0,  24, 0x0000000000FFFFFF, 0x00, 0, 0x0000000000000000, "wbqtg select" ],
);

%shub2_01_00550_def =
( NAME    => "SH2_Y_WBQ_DBUG_SEL",
  ADDRESS => 0x0000000000020180,
  NOTE    => "Each AC can be configured to send the appropriate internal state to note the output debug port. This register is used to select ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00550_flds
);


##########################################################################
#                                                                        #
#   SH2_Y_ARB_DBUG_SEL                                                   #
#                                                                        #
##########################################################################

%shub2_01_00551_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARB_SEL"                      => [   1,   0,  24, 0x0000000000FFFFFF, 0x00, 0, 0x0000000000000000, "arbque select" ],
);

%shub2_01_00551_def =
( NAME    => "SH2_Y_ARB_DBUG_SEL",
  ADDRESS => 0x0000000000020188,
  NOTE    => "Each AC can be configured to send the appropriate internal state to note the output debug port. This register is used to select ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00551_flds
);


##########################################################################
#                                                                        #
#   SH2_Y_ATL_DBUG_SEL                                                   #
#                                                                        #
##########################################################################

%shub2_01_00552_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ATL_SEL"                      => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "aintl select" ],
);

%shub2_01_00552_def =
( NAME    => "SH2_Y_ATL_DBUG_SEL",
  ADDRESS => 0x0000000000020190,
  NOTE    => "Each AC can be configured to send the appropriate internal state to note the output debug port. This register is used to select ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00552_flds
);


##########################################################################
#                                                                        #
#   SH2_Y_ATR_DBUG_SEL                                                   #
#                                                                        #
##########################################################################

%shub2_01_00553_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ATR_SEL"                      => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "aintr select" ],
);

%shub2_01_00553_def =
( NAME    => "SH2_Y_ATR_DBUG_SEL",
  ADDRESS => 0x0000000000020198,
  NOTE    => "Each AC can be configured to send the appropriate internal state to note the output debug port. This register is used to select ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00553_flds
);


##########################################################################
#                                                                        #
#   SH2_Y_DQL_DBUG_SEL                                                   #
#                                                                        #
##########################################################################

%shub2_01_00554_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  15,  49, 0xFFFFFFFFFFFF8000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQL_SEL"                      => [   1,   0,  15, 0x0000000000007FFF, 0x00, 0, 0x0000000000000000, "dqctr select" ],
);

%shub2_01_00554_def =
( NAME    => "SH2_Y_DQL_DBUG_SEL",
  ADDRESS => 0x00000000000201a0,
  NOTE    => "Each AC can be configured to send the appropriate internal state to note the output debug port. This register is used to select ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00554_flds
);


##########################################################################
#                                                                        #
#   SH2_Y_DQR_DBUG_SEL                                                   #
#                                                                        #
##########################################################################

%shub2_01_00555_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  15,  49, 0xFFFFFFFFFFFF8000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQR_SEL"                      => [   1,   0,  15, 0x0000000000007FFF, 0x00, 0, 0x0000000000000000, "dqctl select" ],
);

%shub2_01_00555_def =
( NAME    => "SH2_Y_DQR_DBUG_SEL",
  ADDRESS => 0x00000000000201a8,
  NOTE    => "Each AC can be configured to send the appropriate internal state to note the output debug port. This register is used to select ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00555_flds
);


##########################################################################
#                                                                        #
#   SH2_Y_DBUG_SEL                                                       #
#                                                                        #
##########################################################################

%shub2_01_00556_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DBG_SEL"                      => [   1,   0,  24, 0x0000000000FFFFFF, 0x00, 0, 0x0000000000000000, "Nibble[7:0] RLM select" ],
);

%shub2_01_00556_def =
( NAME    => "SH2_Y_DBUG_SEL",
  ADDRESS => 0x00000000000201b0,
  NOTE    => "This register selects between the submodules within the AC RLMs. note Additional tables that describe how the debug ports can be",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00556_flds
);


##########################################################################
#                                                                        #
#   SH2_Y_LADDR_CMP                                                      #
#                                                                        #
##########################################################################

%shub2_01_00557_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MASK_VAL"                     => [   1,  32,  30, 0x3FFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Byte address [37-8] mask value, 1=enables compare check" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CMP_VAL"                      => [   3,   0,  30, 0x000000003FFFFFFF, 0x00, 0, 0x0000000000000000, "Byte address [37-8] compare value" ],
);

%shub2_01_00557_def =
( NAME    => "SH2_Y_LADDR_CMP",
  ADDRESS => 0x00000000000201b8,
  NOTE    => "Address compare register is used to trigger on specific requests note that are issuing from arbque. The register consists of a c",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00557_flds
);


##########################################################################
#                                                                        #
#   SH2_Y_RADDR_CMP                                                      #
#                                                                        #
##########################################################################

%shub2_01_00558_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MASK_VAL"                     => [   1,  32,  30, 0x3FFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Byte address [37-8] mask value, 1=enables compare check" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CMP_VAL"                      => [   3,   0,  30, 0x000000003FFFFFFF, 0x00, 0, 0x0000000000000000, "Byte address [37-8] compare value" ],
);

%shub2_01_00558_def =
( NAME    => "SH2_Y_RADDR_CMP",
  ADDRESS => 0x00000000000201c0,
  NOTE    => "Address compare register is used to trigger on specific requests note that are issuing from arbque. The register consists of a c",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00558_flds
);


##########################################################################
#                                                                        #
#   SH2_Y_TAG_CMP                                                        #
#                                                                        #
##########################################################################

%shub2_01_00559_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SRC"                          => [   1,  44,  16, 0x0FFFF00000000000, 0x00, 0, 0x0000000000000000, "Source compare value" ],
   "RSVD1"                        => [   2,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR"                         => [   3,   8,  35, 0x000007FFFFFFFF00, 0x00, 0, 0x0000000000000000, "Address compare value" ],
   "CMD"                          => [   4,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Command compare value" ],
);

%shub2_01_00559_def =
( NAME    => "SH2_Y_TAG_CMP",
  ADDRESS => 0x00000000000201c8,
  NOTE    => "Tag compare register is used to trigger on specific requests that note are issuing from MD JNR to AC tagmgr. The compare fields ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00559_flds
);


##########################################################################
#                                                                        #
#   SH2_Y_TAG_MASK                                                       #
#                                                                        #
##########################################################################

%shub2_01_00560_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SRC"                          => [   1,  44,  16, 0x0FFFF00000000000, 0x00, 0, 0x0000000000000000, "Source compare value" ],
   "RSVD1"                        => [   2,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR"                         => [   3,   8,  35, 0x000007FFFFFFFF00, 0x00, 0, 0x0000000000000000, "Address compare value, 1=enables compare check" ],
   "CMD"                          => [   4,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Command compare value, 1=enables compare check" ],
);

%shub2_01_00560_def =
( NAME    => "SH2_Y_TAG_MASK",
  ADDRESS => 0x00000000000201d0,
  NOTE    => "Tag mask register is used with the tag compare register to fine note tune the desired trigger event. This register consists of a",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00560_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_JNR_DBUG_DATA_CFG                                             #
#                                                                        #
##########################################################################

%shub2_01_00561_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_SEL"                  => [   1,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "selects which data package drives nibble7" ],
   "RSVD1"                        => [   2,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_SEL"                  => [   3,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "selects which data package drives nibble6" ],
   "RSVD2"                        => [   4,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_SEL"                  => [   5,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "selects which data package drives nibble5" ],
   "RSVD3"                        => [   6,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_SEL"                  => [   7,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "selects which data package drives nibble4" ],
   "RSVD4"                        => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_SEL"                  => [   9,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "selects which data package drives nibble3" ],
   "RSVD5"                        => [  10,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_SEL"                  => [  11,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "selects which data package drives nibble2" ],
   "RSVD6"                        => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_SEL"                  => [  13,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "selects which data package drives nibble1" ],
   "RSVD7"                        => [  14,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_SEL"                  => [  15,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "selects which data package drives nibble0" ],
);

%shub2_01_00561_def =
( NAME    => "SH2_MD_JNR_DBUG_DATA_CFG",
  ADDRESS => 0x00000000000201d8,
  NOTE    => "This register maps joiner signals to the 32-bit joiner debug word. note The signals are grouped into data packages that can be m",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00561_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_LAST_CREDIT                                                   #
#                                                                        #
##########################################################################

%shub2_01_00562_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TO_LB"                        => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "capture of credits to pi" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_TO_XN"                     => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "capture of reply credits to xn" ],
   "RSVD2"                        => [   4,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RQ_TO_XN"                     => [   5,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "capture of request credits to xn" ],
   "RSVD3"                        => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_TO_PI"                     => [   7,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "capture of reply credits to pi" ],
   "RSVD4"                        => [   8,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RQ_TO_PI"                     => [   9,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "capture of request credits to pi" ],
);

%shub2_01_00562_def =
( NAME    => "SH2_MD_LAST_CREDIT",
  ADDRESS => 0x00000000000201e0,
  NOTE    => "This register captures all of the credit values from PI, XN, and LB note upon reset. The write enable into the register is gener",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00562_flds
);


##########################################################################
#                                                                        #
#   SH2_MEM_REDUCE_XN_TNUMS                                              #
#                                                                        #
##########################################################################

%shub2_01_00563_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TNUMS"                        => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Remove TNUMS from XN" ],
);

%shub2_01_00563_def =
( NAME    => "SH2_MEM_REDUCE_XN_TNUMS",
  ADDRESS => 0x00000000000201e8,
  NOTE    => "This feature allows software to reallocate the MD's resources based note on the application. This is a 16 bits register each bit",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00563_flds
);


##########################################################################
#                                                                        #
#   SH2_MEM_CAPTURE_ADDR                                                 #
#                                                                        #
##########################################################################

%shub2_01_00564_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  46,  18, 0xFFFFC00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CMD"                          => [   1,  38,   8, 0x00003FC000000000, 0x00, 0, 0x0000000000000000, "Command (i.e., JETSONSNET Message Code)" ],
   "ADDR"                         => [   2,   3,  35, 0x0000003FFFFFFFF8, 0x00, 0, 0x0000000000000000, "Address[37:3]" ],
);

%shub2_01_00564_def =
( NAME    => "SH2_MEM_CAPTURE_ADDR",
  ADDRESS => 0x0000000000020300,
  NOTE    => "The MEM_CAPTURE_ADDR register provides a portion of the note configuration control for the MD's Message Capture circuitry. It no",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00564_flds
);


##########################################################################
#                                                                        #
#   SH2_MEM_CAPTURE_MASK                                                 #
#                                                                        #
##########################################################################

%shub2_01_00565_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_REMOTE"                => [   1,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "Analyze Messages from Remote (XN)" ],
   "ENABLE_LOCAL"                 => [   2,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "Analyze Messages from Local (PI)" ],
   "CMD"                          => [   3,  38,   8, 0x00003FC000000000, 0x00, 1, 0x0000000000000000, "Command (i.e., JETSONSNET Command Code Code)" ],
   "ADDR"                         => [   4,   3,  35, 0x0000003FFFFFFFF8, 0x00, 1, 0x0000000000000000, "Address[37:3] Mask" ],
);

%shub2_01_00565_def =
( NAME    => "SH2_MEM_CAPTURE_MASK",
  ADDRESS => 0x0000000000020308,
  NOTE    => "The MEM_CAPTURE_MASK register provides a portion of the note configuration control for the MD's Message Capture circuitry. It no",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00565_flds
);


##########################################################################
#                                                                        #
#   SH2_MEM_CAPTURE_HDR                                                  #
#                                                                        #
##########################################################################

%shub2_01_00566_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CNTR"                         => [   0,  58,   6, 0xFC00000000000000, 0x00, 0, 0x0000000000000000, "increments on every capture" ],
   "SRC"                          => [   1,  42,  16, 0x03FFFC0000000000, 0x00, 0, 0x0000000000000000, "source node of reference" ],
   "CMD"                          => [   2,  34,   8, 0x000003FC00000000, 0x00, 0, 0x0000000000000000, "command of reference" ],
);

%shub2_01_00566_def =
( NAME    => "SH2_MEM_CAPTURE_HDR",
  ADDRESS => 0x0000000000020310,
  NOTE    => "This register logs some of the bits of the header on each note occurrence of reference that matches the address in the address n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00566_flds
);


##########################################################################
#                                                                        #
#   SH2_MEM_CAPTURE_HDR_ADDR                                             #
#                                                                        #
##########################################################################

%shub2_01_00567_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  37,  27, 0xFFFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR"                         => [   1,   2,  35, 0x0000001FFFFFFFFC, 0x00, 0, 0x0000000000000000, "upper bits of reference address" ],
);

%shub2_01_00567_def =
( NAME    => "SH2_MEM_CAPTURE_HDR_ADDR",
  ADDRESS => 0x0000000000020318,
  NOTE    => "This register logs some of the bits of the header on each note occurrence of reference that matches the address in the address n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00567_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_DIR_CONFIG                                           #
#                                                                        #
##########################################################################

%shub2_01_00568_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  17,  47, 0xFFFFFFFFFFFE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SHARERS_1K"                   => [   1,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Sharing vector expanded from 256 to 1K nodes" ],
   "LOG_DIR_ERR"                  => [   2,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Log all directory error replies and protocal fall through cases" ],
   "RDSHD_TO_RDEXC_MASK"          => [   3,   8,   7, 0x0000000000007F00, 0x00, 1, 0x0000000000000000, "Source, directory pointer mask for converting RDSHD to RDEXC requests" ],
   "TIO_CHIPLET"                  => [   4,   6,   2, 0x00000000000000C0, 0x00, 1, 0x0000000000000000, "TIO chiplet value" ],
   "SW_GET_2_GETF"                => [   5,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "switch all GET requests to GETF requests" ],
   "EN_DIRPOIS"                   => [   6,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "enable local poisoning for dir table fall-through" ],
   "EN_DIRECC"                    => [   7,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "enable directory ecc correction" ],
   "SYS_SIZE"                     => [   8,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "configures the granularity of the local/remote vector" ],
);

%shub2_01_00568_def =
( NAME    => "SH2_MD_DQLP_MMR_DIR_CONFIG",
  ADDRESS => 0x0000000000030000,
  NOTE    => "This register holds DQ config bits. The SYS_SIZE field is used to note configure the local/remote vector bit granularity. The EN",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00568_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_DIR_PRESVEC0                                         #
#                                                                        #
##########################################################################

%shub2_01_00569_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "node presence bits, 1=present" ],
);

%shub2_01_00569_def =
( NAME    => "SH2_MD_DQLP_MMR_DIR_PRESVEC0",
  ADDRESS => 0x0000000000030100,
  NOTE    => "This group of registers holds the node presence vector for the note coherence doamin. If a bit is 1 then the node is assumed pre",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00569_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_DIR_PRESVEC1                                         #
#                                                                        #
##########################################################################

%shub2_01_00570_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "node presence bits, 1=present" ],
);

%shub2_01_00570_def =
( NAME    => "SH2_MD_DQLP_MMR_DIR_PRESVEC1",
  ADDRESS => 0x0000000000030110,
  NOTE    => "node [127:64] presence bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00570_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_DIR_PRESVEC2                                         #
#                                                                        #
##########################################################################

%shub2_01_00571_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "node presence bits, 1=present" ],
);

%shub2_01_00571_def =
( NAME    => "SH2_MD_DQLP_MMR_DIR_PRESVEC2",
  ADDRESS => 0x0000000000030120,
  NOTE    => "node [191:128] presence bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00571_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_DIR_PRESVEC3                                         #
#                                                                        #
##########################################################################

%shub2_01_00572_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "node presence bits, 1=present" ],
);

%shub2_01_00572_def =
( NAME    => "SH2_MD_DQLP_MMR_DIR_PRESVEC3",
  ADDRESS => 0x0000000000030130,
  NOTE    => "node [255:192] presence bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00572_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_DIR_LOCVEC0                                          #
#                                                                        #
##########################################################################

%shub2_01_00573_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%shub2_01_00573_def =
( NAME    => "SH2_MD_DQLP_MMR_DIR_LOCVEC0",
  ADDRESS => 0x0000000000030200,
  NOTE    => "This group of registers holds the local/remote bit vectors that is note used for access privilege checks in the directory logic.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00573_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_DIR_LOCVEC1                                          #
#                                                                        #
##########################################################################

%shub2_01_00574_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%shub2_01_00574_def =
( NAME    => "SH2_MD_DQLP_MMR_DIR_LOCVEC1",
  ADDRESS => 0x0000000000030210,
  NOTE    => "local vector for acc=1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00574_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_DIR_LOCVEC2                                          #
#                                                                        #
##########################################################################

%shub2_01_00575_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%shub2_01_00575_def =
( NAME    => "SH2_MD_DQLP_MMR_DIR_LOCVEC2",
  ADDRESS => 0x0000000000030220,
  NOTE    => "local vector for acc=2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00575_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_DIR_LOCVEC3                                          #
#                                                                        #
##########################################################################

%shub2_01_00576_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%shub2_01_00576_def =
( NAME    => "SH2_MD_DQLP_MMR_DIR_LOCVEC3",
  ADDRESS => 0x0000000000030230,
  NOTE    => "local vector for acc=3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00576_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_DIR_LOCVEC4                                          #
#                                                                        #
##########################################################################

%shub2_01_00577_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%shub2_01_00577_def =
( NAME    => "SH2_MD_DQLP_MMR_DIR_LOCVEC4",
  ADDRESS => 0x0000000000030240,
  NOTE    => "local vector for acc=4",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00577_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_DIR_LOCVEC5                                          #
#                                                                        #
##########################################################################

%shub2_01_00578_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%shub2_01_00578_def =
( NAME    => "SH2_MD_DQLP_MMR_DIR_LOCVEC5",
  ADDRESS => 0x0000000000030250,
  NOTE    => "local vector for acc=5",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00578_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_DIR_LOCVEC6                                          #
#                                                                        #
##########################################################################

%shub2_01_00579_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%shub2_01_00579_def =
( NAME    => "SH2_MD_DQLP_MMR_DIR_LOCVEC6",
  ADDRESS => 0x0000000000030260,
  NOTE    => "local vector for acc=6",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00579_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_DIR_LOCVEC7                                          #
#                                                                        #
##########################################################################

%shub2_01_00580_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%shub2_01_00580_def =
( NAME    => "SH2_MD_DQLP_MMR_DIR_LOCVEC7",
  ADDRESS => 0x0000000000030270,
  NOTE    => "local vector for acc=7",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00580_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_DIR_PRIVEC0                                          #
#                                                                        #
##########################################################################

%shub2_01_00581_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%shub2_01_00581_def =
( NAME    => "SH2_MD_DQLP_MMR_DIR_PRIVEC0",
  ADDRESS => 0x0000000000030300,
  NOTE    => "This group of registers holds the privilege mask for certain note request type categories. CPU and IO nodes have separate bits f",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00581_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_DIR_PRIVEC1                                          #
#                                                                        #
##########################################################################

%shub2_01_00582_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%shub2_01_00582_def =
( NAME    => "SH2_MD_DQLP_MMR_DIR_PRIVEC1",
  ADDRESS => 0x0000000000030310,
  NOTE    => "privilege vector for acc=1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00582_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_DIR_PRIVEC2                                          #
#                                                                        #
##########################################################################

%shub2_01_00583_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%shub2_01_00583_def =
( NAME    => "SH2_MD_DQLP_MMR_DIR_PRIVEC2",
  ADDRESS => 0x0000000000030320,
  NOTE    => "privilege vector for acc=2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00583_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_DIR_PRIVEC3                                          #
#                                                                        #
##########################################################################

%shub2_01_00584_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%shub2_01_00584_def =
( NAME    => "SH2_MD_DQLP_MMR_DIR_PRIVEC3",
  ADDRESS => 0x0000000000030330,
  NOTE    => "privilege vector for acc=3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00584_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_DIR_PRIVEC4                                          #
#                                                                        #
##########################################################################

%shub2_01_00585_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%shub2_01_00585_def =
( NAME    => "SH2_MD_DQLP_MMR_DIR_PRIVEC4",
  ADDRESS => 0x0000000000030340,
  NOTE    => "privilege vector for acc=4",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00585_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_DIR_PRIVEC5                                          #
#                                                                        #
##########################################################################

%shub2_01_00586_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%shub2_01_00586_def =
( NAME    => "SH2_MD_DQLP_MMR_DIR_PRIVEC5",
  ADDRESS => 0x0000000000030350,
  NOTE    => "privilege vector for acc=5",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00586_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_DIR_PRIVEC6                                          #
#                                                                        #
##########################################################################

%shub2_01_00587_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%shub2_01_00587_def =
( NAME    => "SH2_MD_DQLP_MMR_DIR_PRIVEC6",
  ADDRESS => 0x0000000000030360,
  NOTE    => "privilege vector for acc=6",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00587_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_DIR_PRIVEC7                                          #
#                                                                        #
##########################################################################

%shub2_01_00588_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%shub2_01_00588_def =
( NAME    => "SH2_MD_DQLP_MMR_DIR_PRIVEC7",
  ADDRESS => 0x0000000000030370,
  NOTE    => "privilege vector for acc=7",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00588_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_DIR_TIMER                                            #
#                                                                        #
##########################################################################

%shub2_01_00589_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIMER_CUR"                    => [   1,  13,   9, 0x00000000003FE000, 0x00, 1, 0x0000000000000000, "value of current timer" ],
   "TIMER_EN"                     => [   2,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "timer enable" ],
   "TIMER_DIV"                    => [   3,   0,  12, 0x0000000000000FFF, 0x00, 1, 0x0000000000000000, "timer divide register" ],
);

%shub2_01_00589_def =
( NAME    => "SH2_MD_DQLP_MMR_DIR_TIMER",
  ADDRESS => 0x0000000000030400,
  NOTE    => "This register holds enables and configuration bits of the MD SXRO note timer. The core clock 'coreclk' is devided by 64 in a pre",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00589_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_PIOWD_DIR_ENTRY                                      #
#                                                                        #
##########################################################################

%shub2_01_00590_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  58,   6, 0xFC00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ACC"                          => [   1,  55,   3, 0x0380000000000000, 0x00, 1, 0x0000000000000000, "directory access bits" ],
   "PRI"                          => [   2,  52,   3, 0x0070000000000000, 0x00, 1, 0x0000000000000000, "directory priority" ],
   "DIRB"                         => [   3,  26,  26, 0x000FFFFFFC000000, 0x00, 1, 0x0000000000000000, "directory entry B" ],
   "DIRA"                         => [   4,   0,  26, 0x0000000003FFFFFF, 0x00, 1, 0x0000000000000000, "directory entry A" ],
);

%shub2_01_00590_def =
( NAME    => "SH2_MD_DQLP_MMR_PIOWD_DIR_ENTRY",
  ADDRESS => 0x0000000000031000,
  NOTE    => "Directory entries A and B with access, priority and rsvd bits.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00590_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_PIOWD_DIR_ECC                                        #
#                                                                        #
##########################################################################

%shub2_01_00591_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  14,  50, 0xFFFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECCB"                         => [   1,   7,   7, 0x0000000000003F80, 0x00, 1, 0x0000000000000000, "XOR bits for directory ECC group 2" ],
   "ECCA"                         => [   2,   0,   7, 0x000000000000007F, 0x00, 1, 0x0000000000000000, "XOR bits for directory ECC group 1" ],
);

%shub2_01_00591_def =
( NAME    => "SH2_MD_DQLP_MMR_PIOWD_DIR_ECC",
  ADDRESS => 0x0000000000031010,
  NOTE    => "These two ECC values are XORed with the generated directory ECC note bits and should be 0 for normal operation. Diagnostic softw",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00591_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_XPIORD_XDIR_ENTRY                                     #
#                                                                        #
##########################################################################

%shub2_01_00592_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNC"                          => [   1,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error" ],
   "COR"                          => [   2,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error" ],
   "ACC"                          => [   3,  55,   3, 0x0380000000000000, 0x00, 0, 0x0000000000000000, "directory access bits" ],
   "PRI"                          => [   4,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "directory priority" ],
   "DIRB"                         => [   5,  26,  26, 0x000FFFFFFC000000, 0x00, 0, 0x0000000000000000, "directory entry B" ],
   "DIRA"                         => [   6,   0,  26, 0x0000000003FFFFFF, 0x00, 0, 0x0000000000000000, "directory entry A" ],
);

%shub2_01_00592_def =
( NAME    => "SH2_MD_DQLP_MMR_XPIORD_XDIR_ENTRY",
  ADDRESS => 0x0000000000032000,
  NOTE    => "Directory entries A and B with access, priority and rsvd bits.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00592_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_XPIORD_XDIR_ECC                                      #
#                                                                        #
##########################################################################

%shub2_01_00593_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  14,  50, 0xFFFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECCB"                         => [   1,   7,   7, 0x0000000000003F80, 0x00, 0, 0x0000000000000000, "group 2 ecc" ],
   "ECCA"                         => [   2,   0,   7, 0x000000000000007F, 0x00, 0, 0x0000000000000000, "group 1 ecc" ],
);

%shub2_01_00593_def =
( NAME    => "SH2_MD_DQLP_MMR_XPIORD_XDIR_ECC",
  ADDRESS => 0x0000000000032010,
  NOTE    => "ECC bits of group 1 and 2 of directory pair.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00593_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_YPIORD_YDIR_ENTRY                                     #
#                                                                        #
##########################################################################

%shub2_01_00594_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNC"                          => [   1,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error" ],
   "COR"                          => [   2,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error" ],
   "ACC"                          => [   3,  55,   3, 0x0380000000000000, 0x00, 0, 0x0000000000000000, "directory access bits" ],
   "PRI"                          => [   4,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "directory priority" ],
   "DIRB"                         => [   5,  26,  26, 0x000FFFFFFC000000, 0x00, 0, 0x0000000000000000, "directory entry B" ],
   "DIRA"                         => [   6,   0,  26, 0x0000000003FFFFFF, 0x00, 0, 0x0000000000000000, "directory entry A" ],
);

%shub2_01_00594_def =
( NAME    => "SH2_MD_DQLP_MMR_YPIORD_YDIR_ENTRY",
  ADDRESS => 0x0000000000032800,
  NOTE    => "Directory entries A and B with access, priority and rsvd bits.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00594_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_YPIORD_YDIR_ECC                                      #
#                                                                        #
##########################################################################

%shub2_01_00595_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  14,  50, 0xFFFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECCB"                         => [   1,   7,   7, 0x0000000000003F80, 0x00, 0, 0x0000000000000000, "group 2 ecc" ],
   "ECCA"                         => [   2,   0,   7, 0x000000000000007F, 0x00, 0, 0x0000000000000000, "group 1 ecc" ],
);

%shub2_01_00595_def =
( NAME    => "SH2_MD_DQLP_MMR_YPIORD_YDIR_ECC",
  ADDRESS => 0x0000000000032810,
  NOTE    => "ECC bits of group 1 and 2 of directory pair.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00595_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_XCERR1                                               #
#                                                                        #
##########################################################################

%shub2_01_00596_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  39,  25, 0xFFFFFF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms uncorrectable ecc error capture" ],
   "MORE"                         => [   2,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one correctable ecc error in group 1" ],
   "VAL"                          => [   3,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error in group 1 bits" ],
   "GRP1"                         => [   4,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 1 bits" ],
);

%shub2_01_00596_def =
( NAME    => "SH2_MD_DQLP_MMR_XCERR1",
  ADDRESS => 0x0000000000033000,
  NOTE    => "These registers capture the data bits for correctable directory ecc note errors. The data bits of ecc groups 1 and 2 that make t",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00596_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_XCERR2                                               #
#                                                                        #
##########################################################################

%shub2_01_00597_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one correctable ecc error in group 2" ],
   "VAL"                          => [   2,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error in group 2 bits" ],
   "GRP2"                         => [   3,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 2 bits" ],
);

%shub2_01_00597_def =
( NAME    => "SH2_MD_DQLP_MMR_XCERR2",
  ADDRESS => 0x0000000000033010,
  NOTE    => "correctable dir ecc group 2 error register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00597_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_XUERR1                                               #
#                                                                        #
##########################################################################

%shub2_01_00598_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  39,  25, 0xFFFFFF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms uncorrectable ecc error capture" ],
   "MORE"                         => [   2,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one uncorrectable ecc error in group 1" ],
   "VAL"                          => [   3,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error in group 1 bits" ],
   "GRP1"                         => [   4,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 1 bits" ],
);

%shub2_01_00598_def =
( NAME    => "SH2_MD_DQLP_MMR_XUERR1",
  ADDRESS => 0x0000000000033020,
  NOTE    => "These registers capture the data bits for uncorrectable directory note ecc errors. The data bits of ecc groups 1 and 2 that make",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00598_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_XUERR2                                               #
#                                                                        #
##########################################################################

%shub2_01_00599_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one uncorrectable ecc error in group 2" ],
   "VAL"                          => [   2,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error in group 2 bits" ],
   "GRP2"                         => [   3,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 2 bits" ],
);

%shub2_01_00599_def =
( NAME    => "SH2_MD_DQLP_MMR_XUERR2",
  ADDRESS => 0x0000000000033030,
  NOTE    => "uncorrectable dir ecc group 2 error register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00599_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_XPERR0                                               #
#                                                                        #
##########################################################################

%shub2_01_00600_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  57,   7, 0xFE00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms error capture" ],
   "MORE"                         => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "more than one protocol error" ],
   "VAL"                          => [   3,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "protocol error info valid" ],
   "UNC"                          => [   4,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error" ],
   "COR"                          => [   5,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error" ],
   "PRIV"                         => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "access privilege bit" ],
   "PRIGE"                        => [   7,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "priority was greater-equal" ],
   "SRC"                          => [   8,  34,  16, 0x0003FFFC00000000, 0x00, 0, 0x0000000000000000, "source node of dir operation" ],
   "CMD"                          => [   9,  26,   8, 0x00000003FC000000, 0x00, 0, 0x0000000000000000, "incoming command" ],
   "DIR"                          => [  10,   0,  26, 0x0000000003FFFFFF, 0x00, 0, 0x0000000000000000, "directory entry" ],
);

%shub2_01_00600_def =
( NAME    => "SH2_MD_DQLP_MMR_XPERR0",
  ADDRESS => 0x0000000000033040,
  NOTE    => "This register captures the table inputs for the first occurence of note a directory protocol table fall-through case. The direct",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00600_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_XPERR1                                               #
#                                                                        #
##########################################################################

%shub2_01_00601_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   7,  57, 0xFFFFFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MYBIT"                        => [   1,   0,   7, 0x000000000000007F, 0x00, 0, 0x0000000000000000, "dfpart,ptreq,timeq,timlast,timspec,onlyme,anytim,ptrii,srcii" ],
);

%shub2_01_00601_def =
( NAME    => "SH2_MD_DQLP_MMR_XPERR1",
  ADDRESS => 0x0000000000033050,
  NOTE    => "This register captures the table inputs for the first occurence of note a directory protocol table fall-through case. The direct",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00601_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_YCERR1                                               #
#                                                                        #
##########################################################################

%shub2_01_00602_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  39,  25, 0xFFFFFF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms uncorrectable ecc error capture" ],
   "MORE"                         => [   2,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one correctable ecc error in group 1" ],
   "VAL"                          => [   3,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error in group 1 bits" ],
   "GRP1"                         => [   4,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 1 bits" ],
);

%shub2_01_00602_def =
( NAME    => "SH2_MD_DQLP_MMR_YCERR1",
  ADDRESS => 0x0000000000033800,
  NOTE    => "These registers capture the data bits for correctable directory ecc note errors. The data bits of ecc groups 1 and 2 that make t",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00602_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_YCERR2                                               #
#                                                                        #
##########################################################################

%shub2_01_00603_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one correctable ecc error in group 2" ],
   "VAL"                          => [   2,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error in group 2 bits" ],
   "GRP2"                         => [   3,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 2 bits" ],
);

%shub2_01_00603_def =
( NAME    => "SH2_MD_DQLP_MMR_YCERR2",
  ADDRESS => 0x0000000000033810,
  NOTE    => "correctable dir ecc group 2 error register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00603_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_YUERR1                                               #
#                                                                        #
##########################################################################

%shub2_01_00604_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  39,  25, 0xFFFFFF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms uncorrectable ecc error capture" ],
   "MORE"                         => [   2,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one uncorrectable ecc error in group 1" ],
   "VAL"                          => [   3,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error in group 1 bits" ],
   "GRP1"                         => [   4,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 1 bits" ],
);

%shub2_01_00604_def =
( NAME    => "SH2_MD_DQLP_MMR_YUERR1",
  ADDRESS => 0x0000000000033820,
  NOTE    => "These registers capture the data bits for uncorrectable directory note ecc errors. The data bits of ecc groups 1 and 2 that make",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00604_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_YUERR2                                               #
#                                                                        #
##########################################################################

%shub2_01_00605_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one uncorrectable ecc error in group 2" ],
   "VAL"                          => [   2,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error in group 2 bits" ],
   "GRP2"                         => [   3,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 2 bits" ],
);

%shub2_01_00605_def =
( NAME    => "SH2_MD_DQLP_MMR_YUERR2",
  ADDRESS => 0x0000000000033830,
  NOTE    => "uncorrectable dir ecc group 2 error register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00605_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_YPERR0                                               #
#                                                                        #
##########################################################################

%shub2_01_00606_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  57,   7, 0xFE00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms error capture" ],
   "MORE"                         => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "more than one protocol error" ],
   "VAL"                          => [   3,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "protocol error info valid" ],
   "UNC"                          => [   4,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error" ],
   "COR"                          => [   5,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error" ],
   "PRIV"                         => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "access privilege bit" ],
   "PRIGE"                        => [   7,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "priority was greater-equal" ],
   "SRC"                          => [   8,  34,  16, 0x0003FFFC00000000, 0x00, 0, 0x0000000000000000, "source node of dir operation" ],
   "CMD"                          => [   9,  26,   8, 0x00000003FC000000, 0x00, 0, 0x0000000000000000, "incoming command" ],
   "DIR"                          => [  10,   0,  26, 0x0000000003FFFFFF, 0x00, 0, 0x0000000000000000, "directory entry" ],
);

%shub2_01_00606_def =
( NAME    => "SH2_MD_DQLP_MMR_YPERR0",
  ADDRESS => 0x0000000000033840,
  NOTE    => "This register captures the table inputs for the first occurence of note a directory protocol table fall-through case. The direct",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00606_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_YPERR1                                               #
#                                                                        #
##########################################################################

%shub2_01_00607_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   7,  57, 0xFFFFFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MYBIT"                        => [   1,   0,   7, 0x000000000000007F, 0x00, 0, 0x0000000000000000, "dfpart,ptreq,timeq,timlast,timspec,onlyme,anytim,ptrii,srcii" ],
);

%shub2_01_00607_def =
( NAME    => "SH2_MD_DQLP_MMR_YPERR1",
  ADDRESS => 0x0000000000033850,
  NOTE    => "This register captures the table inputs for the first occurence of note a directory protocol table fall-through case. The direct",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00607_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_DIR_CMDTRIG                                          #
#                                                                        #
##########################################################################

%shub2_01_00608_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "YDIR_DBG_SEL"                 => [   1,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "Select X directory debug path, used with ac cmp_match to track directory transitions" ],
   "XDIR_DBG_SEL"                 => [   2,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Select X directory debug path, used with ac cmp_match to track directory transitions" ],
   "CMD3"                         => [   3,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "command trigger 3" ],
   "CMD2"                         => [   4,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "command trigger 2" ],
   "CMD1"                         => [   5,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "command trigger 1" ],
   "CMD0"                         => [   6,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "command trigger 0" ],
);

%shub2_01_00608_def =
( NAME    => "SH2_MD_DQLP_MMR_DIR_CMDTRIG",
  ADDRESS => 0x0000000000034000,
  NOTE    => "This register holds 4 cmd encodings that are compared to the note incoming directory request. Each of the four comparators drive",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00608_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_DIR_TBLTRIG                                          #
#                                                                        #
##########################################################################

%shub2_01_00609_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  43,  21, 0xFFFFF80000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MYBIT"                        => [   1,  36,   7, 0x000007F000000000, 0x00, 0, 0x0000000000000000, "ptreq,timeq,timlast,timspec,onlyme,anytim,ptrii,srcii" ],
   "DIRST"                        => [   2,  27,   9, 0x0000000FF8000000, 0x00, 0, 0x0000000000000000, "shrd,sxro,sub-state" ],
   "PRIGE"                        => [   3,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "priority greater-equal" ],
   "ACC"                          => [   4,  24,   2, 0x0000000003000000, 0x00, 0, 0x0000000000000000, "uncorrectable error, privilege bit" ],
   "CMD"                          => [   5,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "incoming request" ],
   "SRC"                          => [   6,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "source of request" ],
);

%shub2_01_00609_def =
( NAME    => "SH2_MD_DQLP_MMR_DIR_TBLTRIG",
  ADDRESS => 0x0000000000034010,
  NOTE    => "This register holds a value which is compared to the inputs of the note directory table logic. If they match a debug signal is a",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00609_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_DIR_TBLMASK                                          #
#                                                                        #
##########################################################################

%shub2_01_00610_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  43,  21, 0xFFFFF80000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MYBIT"                        => [   1,  36,   7, 0x000007F000000000, 0x00, 1, 0x0000000000000000, "ptreq,timeq,timlast,timspec,onlyme,anytim,ptrii,srcii" ],
   "DIRST"                        => [   2,  27,   9, 0x0000000FF8000000, 0x00, 1, 0x0000000000000000, "shrd,sxro,sub-state" ],
   "PRIGE"                        => [   3,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "priority greater-equal" ],
   "ACC"                          => [   4,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "uncorrectable error, privilege bit" ],
   "CMD"                          => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "incoming request" ],
   "SRC"                          => [   6,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "source of request" ],
);

%shub2_01_00610_def =
( NAME    => "SH2_MD_DQLP_MMR_DIR_TBLMASK",
  ADDRESS => 0x0000000000034020,
  NOTE    => "dir table trigger mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00610_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_XBIST_H                                              #
#                                                                        #
##########################################################################

%shub2_01_00611_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  44,  20, 0xFFFFF00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms data miscompare capture" ],
   "RANDOM"                       => [   2,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "generate random data pattern in next cycle" ],
   "ROT"                          => [   3,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   4,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "RSVD1"                        => [   5,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   6,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%shub2_01_00611_def =
( NAME    => "SH2_MD_DQLP_MMR_XBIST_H",
  ADDRESS => 0x0000000000038000,
  NOTE    => "These registers hold the DDR rising and falling edge data pattern note and bist/fill mode bits. The width of the data depends on",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00611_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_XBIST_L                                              #
#                                                                        #
##########################################################################

%shub2_01_00612_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  43,  21, 0xFFFFF80000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RANDOM"                       => [   1,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "generate random data pattern in next cycle" ],
   "ROT"                          => [   2,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   3,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "RSVD1"                        => [   4,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   5,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%shub2_01_00612_def =
( NAME    => "SH2_MD_DQLP_MMR_XBIST_L",
  ADDRESS => 0x0000000000038010,
  NOTE    => "falling edge bist/fill pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00612_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_XBIST_ERR_H                                          #
#                                                                        #
##########################################################################

%shub2_01_00613_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "RSVD1"                        => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   4,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%shub2_01_00613_def =
( NAME    => "SH2_MD_DQLP_MMR_XBIST_ERR_H",
  ADDRESS => 0x0000000000038020,
  NOTE    => "These registers hold the DDR rising and falling edge data pattern note for the first data miscompare during bist read/compare op",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00613_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_XBIST_ERR_L                                          #
#                                                                        #
##########################################################################

%shub2_01_00614_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "RSVD1"                        => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   4,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%shub2_01_00614_def =
( NAME    => "SH2_MD_DQLP_MMR_XBIST_ERR_L",
  ADDRESS => 0x0000000000038030,
  NOTE    => "falling edge bist error pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00614_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_XBIST_MASK                                           #
#                                                                        #
##########################################################################

%shub2_01_00615_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COMP_DIS"                     => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "compare disable" ],
);

%shub2_01_00615_def =
( NAME    => "SH2_MD_DQLP_MMR_XBIST_MASK",
  ADDRESS => 0x0000000000038040,
  NOTE    => "This register holds the compare mask to enable or disable note individual data bit compares.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00615_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_YBIST_H                                              #
#                                                                        #
##########################################################################

%shub2_01_00616_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  44,  20, 0xFFFFF00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms data miscompare capture" ],
   "RANDOM"                       => [   2,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "generate random data pattern in next cycle" ],
   "ROT"                          => [   3,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   4,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "RSVD1"                        => [   5,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   6,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%shub2_01_00616_def =
( NAME    => "SH2_MD_DQLP_MMR_YBIST_H",
  ADDRESS => 0x0000000000038800,
  NOTE    => "These registers hold the DDR rising and falling edge data pattern note and bist/fill mode bits. The width of the data depends on",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00616_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_YBIST_L                                              #
#                                                                        #
##########################################################################

%shub2_01_00617_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  43,  21, 0xFFFFF80000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RANDOM"                       => [   1,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "generate random data pattern in next cycle" ],
   "ROT"                          => [   2,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   3,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "RSVD1"                        => [   4,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   5,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%shub2_01_00617_def =
( NAME    => "SH2_MD_DQLP_MMR_YBIST_L",
  ADDRESS => 0x0000000000038810,
  NOTE    => "falling edge bist/fill pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00617_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_YBIST_ERR_H                                          #
#                                                                        #
##########################################################################

%shub2_01_00618_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "RSVD1"                        => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   4,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%shub2_01_00618_def =
( NAME    => "SH2_MD_DQLP_MMR_YBIST_ERR_H",
  ADDRESS => 0x0000000000038820,
  NOTE    => "These registers hold the DDR rising and falling edge data pattern note for the first data miscompare during bist read/compare op",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00618_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_YBIST_ERR_L                                          #
#                                                                        #
##########################################################################

%shub2_01_00619_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "RSVD1"                        => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   4,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%shub2_01_00619_def =
( NAME    => "SH2_MD_DQLP_MMR_YBIST_ERR_L",
  ADDRESS => 0x0000000000038830,
  NOTE    => "falling edge bist error pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00619_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_YBIST_MASK                                           #
#                                                                        #
##########################################################################

%shub2_01_00620_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COMP_DIS"                     => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "compare disable" ],
);

%shub2_01_00620_def =
( NAME    => "SH2_MD_DQLP_MMR_YBIST_MASK",
  ADDRESS => 0x0000000000038840,
  NOTE    => "This register holds the compare mask to enable or disable note individual data bit compares.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00620_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLP_MMR_AMO_CFG                                              #
#                                                                        #
##########################################################################

%shub2_01_00621_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   4,  60, 0xFFFFFFFFFFFFFFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EN_YLITTLE_END"               => [   1,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "enable y little endian mode" ],
   "EN_XLITTLE_END"               => [   2,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "enable x little endian mode" ],
   "EN_YAMOECC"                   => [   3,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "enable y amo ecc detection-correction logic" ],
   "EN_XAMOECC"                   => [   4,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "enable x amo ecc detection-correction logic" ],
);

%shub2_01_00621_def =
( NAME    => "SH2_MD_DQLP_MMR_AMO_CFG",
  ADDRESS => 0x0000000000034800,
  NOTE    => "This register configures the amo logic.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00621_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLS_MMR_XBIST_H                                              #
#                                                                        #
##########################################################################

%shub2_01_00622_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  44,  20, 0xFFFFF00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms data miscompare capture" ],
   "RANDOM"                       => [   2,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "generate random data pattern in next cycle" ],
   "ROT"                          => [   3,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   4,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "PAT"                          => [   5,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%shub2_01_00622_def =
( NAME    => "SH2_MD_DQLS_MMR_XBIST_H",
  ADDRESS => 0x0000000000048000,
  NOTE    => "These registers hold the DDR rising and falling edge data pattern note and bist/fill mode bits. The width of the data depends on",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00622_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLS_MMR_XBIST_L                                              #
#                                                                        #
##########################################################################

%shub2_01_00623_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  43,  21, 0xFFFFF80000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RANDOM"                       => [   1,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "generate random data pattern in next cycle" ],
   "ROT"                          => [   2,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   3,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "PAT"                          => [   4,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%shub2_01_00623_def =
( NAME    => "SH2_MD_DQLS_MMR_XBIST_L",
  ADDRESS => 0x0000000000048010,
  NOTE    => "falling edge bist/fill pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00623_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLS_MMR_XBIST_ERR_H                                          #
#                                                                        #
##########################################################################

%shub2_01_00624_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "PAT"                          => [   3,   0,  40, 0x000000FFFFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%shub2_01_00624_def =
( NAME    => "SH2_MD_DQLS_MMR_XBIST_ERR_H",
  ADDRESS => 0x0000000000048020,
  NOTE    => "These registers hold the DDR rising and falling edge data pattern note for the first data miscompare during bist read/compare op",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00624_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLS_MMR_XBIST_ERR_L                                          #
#                                                                        #
##########################################################################

%shub2_01_00625_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "PAT"                          => [   3,   0,  40, 0x000000FFFFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%shub2_01_00625_def =
( NAME    => "SH2_MD_DQLS_MMR_XBIST_ERR_L",
  ADDRESS => 0x0000000000048030,
  NOTE    => "falling edge bist error pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00625_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLS_MMR_XBIST_MASK                                           #
#                                                                        #
##########################################################################

%shub2_01_00626_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  40,  24, 0xFFFFFF0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COMP_DIS"                     => [   1,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "compare disable" ],
);

%shub2_01_00626_def =
( NAME    => "SH2_MD_DQLS_MMR_XBIST_MASK",
  ADDRESS => 0x0000000000048040,
  NOTE    => "This register holds the compare mask to enable or disable note individual data bit compares.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00626_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLS_MMR_YBIST_H                                              #
#                                                                        #
##########################################################################

%shub2_01_00627_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  44,  20, 0xFFFFF00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms data miscompare capture" ],
   "RANDOM"                       => [   2,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "generate random data pattern in next cycle" ],
   "ROT"                          => [   3,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   4,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "PAT"                          => [   5,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%shub2_01_00627_def =
( NAME    => "SH2_MD_DQLS_MMR_YBIST_H",
  ADDRESS => 0x0000000000048800,
  NOTE    => "These registers hold the DDR rising and falling edge data pattern note and bist/fill mode bits. The width of the data depends on",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00627_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLS_MMR_YBIST_L                                              #
#                                                                        #
##########################################################################

%shub2_01_00628_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  43,  21, 0xFFFFF80000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RANDOM"                       => [   1,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "generate random data pattern in next cycle" ],
   "ROT"                          => [   2,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   3,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "PAT"                          => [   4,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%shub2_01_00628_def =
( NAME    => "SH2_MD_DQLS_MMR_YBIST_L",
  ADDRESS => 0x0000000000048810,
  NOTE    => "falling edge bist/fill pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00628_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLS_MMR_YBIST_ERR_H                                          #
#                                                                        #
##########################################################################

%shub2_01_00629_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "PAT"                          => [   3,   0,  40, 0x000000FFFFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%shub2_01_00629_def =
( NAME    => "SH2_MD_DQLS_MMR_YBIST_ERR_H",
  ADDRESS => 0x0000000000048820,
  NOTE    => "These registers hold the DDR rising and falling edge data pattern note for the first data miscompare during bist read/compare op",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00629_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLS_MMR_YBIST_ERR_L                                          #
#                                                                        #
##########################################################################

%shub2_01_00630_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "PAT"                          => [   3,   0,  40, 0x000000FFFFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%shub2_01_00630_def =
( NAME    => "SH2_MD_DQLS_MMR_YBIST_ERR_L",
  ADDRESS => 0x0000000000048830,
  NOTE    => "falling edge bist error pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00630_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLS_MMR_YBIST_MASK                                           #
#                                                                        #
##########################################################################

%shub2_01_00631_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  40,  24, 0xFFFFFF0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COMP_DIS"                     => [   1,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "compare disable" ],
);

%shub2_01_00631_def =
( NAME    => "SH2_MD_DQLS_MMR_YBIST_MASK",
  ADDRESS => 0x0000000000048840,
  NOTE    => "This register holds the compare mask to enable or disable note individual data bit compares.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00631_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLS_MMR_JNR_DEBUG                                            #
#                                                                        #
##########################################################################

%shub2_01_00632_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   3,  61, 0xFFFFFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR_SEL"                     => [   1,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "select 0=pi_x_rdaddr,1=pi_y_rdaddr,2=pi_wraddr,3=xn_rdaddr,4=xn_wraddr" ],
);

%shub2_01_00632_def =
( NAME    => "SH2_MD_DQLS_MMR_JNR_DEBUG",
  ADDRESS => 0x0000000000049000,
  NOTE    => "This register configure the joiner side rbuf/wbuf address output to note the debug/performance port. Different addresses can be ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00632_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLS_MMR_XAMOPW_ERR                                           #
#                                                                        #
##########################################################################

%shub2_01_00633_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  49,  15, 0xFFFE000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms ecc error capture" ],
   "RSVD1"                        => [   2,  42,   6, 0x0000FC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RUNC"                         => [   3,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc errror on read data" ],
   "RCOR"                         => [   4,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "correctable ecc errror on read data" ],
   "RSYN"                         => [   5,  24,  16, 0x000000FFFF000000, 0x00, 0, 0x0000000000000000, "memory read data syndrome" ],
   "RSVD2"                        => [   6,  18,   6, 0x0000000000FC0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SUNC"                         => [   7,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc errror on store data" ],
   "SCOR"                         => [   8,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "correctable ecc errror on store data" ],
   "SSYN"                         => [   9,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "store data syndrome" ],
);

%shub2_01_00633_def =
( NAME    => "SH2_MD_DQLS_MMR_XAMOPW_ERR",
  ADDRESS => 0x000000000004a000,
  NOTE    => "This register holds the full syndrome of an ecc error encountered note on read-modify-write data for amo and partial byte writes",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00633_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQLS_MMR_AMO_CFG                                              #
#                                                                        #
##########################################################################

%shub2_01_00634_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   4,  60, 0xFFFFFFFFFFFFFFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EN_YLITTLE_END"               => [   1,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "enable y little endian mode" ],
   "EN_XLITTLE_END"               => [   2,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "enable x little endian mode" ],
   "EN_YAMOECC"                   => [   3,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "enable y amo ecc detection-correction logic" ],
   "EN_XAMOECC"                   => [   4,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "enable x amo ecc detection-correction logic" ],
);

%shub2_01_00634_def =
( NAME    => "SH2_MD_DQLS_MMR_AMO_CFG",
  ADDRESS => 0x000000000004b000,
  NOTE    => "This register configures the amo logic.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00634_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_DIR_CONFIG                                           #
#                                                                        #
##########################################################################

%shub2_01_00635_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  17,  47, 0xFFFFFFFFFFFE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SHARERS_1K"                   => [   1,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Sharing vector expanded from 256 to 1K nodes" ],
   "LOG_DIR_ERR"                  => [   2,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Log all directory error replies and protocal fall through cases" ],
   "RDSHD_TO_RDEXC_MASK"          => [   3,   8,   7, 0x0000000000007F00, 0x00, 1, 0x0000000000000000, "Source, directory pointer mask for converting RDSHD to RDEXC requests" ],
   "TIO_CHIPLET"                  => [   4,   6,   2, 0x00000000000000C0, 0x00, 1, 0x0000000000000000, "TIO chiplet value" ],
   "SW_GET_2_GETF"                => [   5,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "switch all GET requests to GETF requests" ],
   "EN_DIRPOIS"                   => [   6,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "enable local poisoning for dir table fall-through" ],
   "EN_DIRECC"                    => [   7,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "enable directory ecc correction" ],
   "SYS_SIZE"                     => [   8,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "configures the granularity of the local/remote vector" ],
);

%shub2_01_00635_def =
( NAME    => "SH2_MD_DQRP_MMR_DIR_CONFIG",
  ADDRESS => 0x0000000000050000,
  NOTE    => "This register holds DQ config bits. The SYS_SIZE field is used to note configure the local/remote vector bit granularity. The EN",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00635_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_DIR_PRESVEC0                                         #
#                                                                        #
##########################################################################

%shub2_01_00636_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "node presence bits, 1=present" ],
);

%shub2_01_00636_def =
( NAME    => "SH2_MD_DQRP_MMR_DIR_PRESVEC0",
  ADDRESS => 0x0000000000050100,
  NOTE    => "This group of registers holds the node presence vector for the note coherence doamin. If a bit is 1 then the node is assumed pre",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00636_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_DIR_PRESVEC1                                         #
#                                                                        #
##########################################################################

%shub2_01_00637_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "node presence bits, 1=present" ],
);

%shub2_01_00637_def =
( NAME    => "SH2_MD_DQRP_MMR_DIR_PRESVEC1",
  ADDRESS => 0x0000000000050110,
  NOTE    => "node [127:64] presence bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00637_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_DIR_PRESVEC2                                         #
#                                                                        #
##########################################################################

%shub2_01_00638_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "node presence bits, 1=present" ],
);

%shub2_01_00638_def =
( NAME    => "SH2_MD_DQRP_MMR_DIR_PRESVEC2",
  ADDRESS => 0x0000000000050120,
  NOTE    => "node [191:128] presence bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00638_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_DIR_PRESVEC3                                         #
#                                                                        #
##########################################################################

%shub2_01_00639_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "node presence bits, 1=present" ],
);

%shub2_01_00639_def =
( NAME    => "SH2_MD_DQRP_MMR_DIR_PRESVEC3",
  ADDRESS => 0x0000000000050130,
  NOTE    => "node [255:192] presence bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00639_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_DIR_LOCVEC0                                          #
#                                                                        #
##########################################################################

%shub2_01_00640_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%shub2_01_00640_def =
( NAME    => "SH2_MD_DQRP_MMR_DIR_LOCVEC0",
  ADDRESS => 0x0000000000050200,
  NOTE    => "This group of registers holds the local/remote bit vectors that is note used for access privilege checks in the directory logic.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00640_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_DIR_LOCVEC1                                          #
#                                                                        #
##########################################################################

%shub2_01_00641_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%shub2_01_00641_def =
( NAME    => "SH2_MD_DQRP_MMR_DIR_LOCVEC1",
  ADDRESS => 0x0000000000050210,
  NOTE    => "local vector for acc=1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00641_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_DIR_LOCVEC2                                          #
#                                                                        #
##########################################################################

%shub2_01_00642_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%shub2_01_00642_def =
( NAME    => "SH2_MD_DQRP_MMR_DIR_LOCVEC2",
  ADDRESS => 0x0000000000050220,
  NOTE    => "local vector for acc=2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00642_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_DIR_LOCVEC3                                          #
#                                                                        #
##########################################################################

%shub2_01_00643_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%shub2_01_00643_def =
( NAME    => "SH2_MD_DQRP_MMR_DIR_LOCVEC3",
  ADDRESS => 0x0000000000050230,
  NOTE    => "local vector for acc=3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00643_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_DIR_LOCVEC4                                          #
#                                                                        #
##########################################################################

%shub2_01_00644_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%shub2_01_00644_def =
( NAME    => "SH2_MD_DQRP_MMR_DIR_LOCVEC4",
  ADDRESS => 0x0000000000050240,
  NOTE    => "local vector for acc=4",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00644_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_DIR_LOCVEC5                                          #
#                                                                        #
##########################################################################

%shub2_01_00645_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%shub2_01_00645_def =
( NAME    => "SH2_MD_DQRP_MMR_DIR_LOCVEC5",
  ADDRESS => 0x0000000000050250,
  NOTE    => "local vector for acc=5",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00645_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_DIR_LOCVEC6                                          #
#                                                                        #
##########################################################################

%shub2_01_00646_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%shub2_01_00646_def =
( NAME    => "SH2_MD_DQRP_MMR_DIR_LOCVEC6",
  ADDRESS => 0x0000000000050260,
  NOTE    => "local vector for acc=6",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00646_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_DIR_LOCVEC7                                          #
#                                                                        #
##########################################################################

%shub2_01_00647_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%shub2_01_00647_def =
( NAME    => "SH2_MD_DQRP_MMR_DIR_LOCVEC7",
  ADDRESS => 0x0000000000050270,
  NOTE    => "local vector for acc=7",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00647_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_DIR_PRIVEC0                                          #
#                                                                        #
##########################################################################

%shub2_01_00648_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%shub2_01_00648_def =
( NAME    => "SH2_MD_DQRP_MMR_DIR_PRIVEC0",
  ADDRESS => 0x0000000000050300,
  NOTE    => "This group of registers holds the privilege mask for certain note request type categories. CPU and IO nodes have separate bits f",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00648_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_DIR_PRIVEC1                                          #
#                                                                        #
##########################################################################

%shub2_01_00649_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%shub2_01_00649_def =
( NAME    => "SH2_MD_DQRP_MMR_DIR_PRIVEC1",
  ADDRESS => 0x0000000000050310,
  NOTE    => "privilege vector for acc=1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00649_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_DIR_PRIVEC2                                          #
#                                                                        #
##########################################################################

%shub2_01_00650_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%shub2_01_00650_def =
( NAME    => "SH2_MD_DQRP_MMR_DIR_PRIVEC2",
  ADDRESS => 0x0000000000050320,
  NOTE    => "privilege vector for acc=2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00650_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_DIR_PRIVEC3                                          #
#                                                                        #
##########################################################################

%shub2_01_00651_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%shub2_01_00651_def =
( NAME    => "SH2_MD_DQRP_MMR_DIR_PRIVEC3",
  ADDRESS => 0x0000000000050330,
  NOTE    => "privilege vector for acc=3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00651_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_DIR_PRIVEC4                                          #
#                                                                        #
##########################################################################

%shub2_01_00652_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%shub2_01_00652_def =
( NAME    => "SH2_MD_DQRP_MMR_DIR_PRIVEC4",
  ADDRESS => 0x0000000000050340,
  NOTE    => "privilege vector for acc=4",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00652_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_DIR_PRIVEC5                                          #
#                                                                        #
##########################################################################

%shub2_01_00653_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%shub2_01_00653_def =
( NAME    => "SH2_MD_DQRP_MMR_DIR_PRIVEC5",
  ADDRESS => 0x0000000000050350,
  NOTE    => "privilege vector for acc=5",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00653_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_DIR_PRIVEC6                                          #
#                                                                        #
##########################################################################

%shub2_01_00654_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%shub2_01_00654_def =
( NAME    => "SH2_MD_DQRP_MMR_DIR_PRIVEC6",
  ADDRESS => 0x0000000000050360,
  NOTE    => "privilege vector for acc=6",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00654_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_DIR_PRIVEC7                                          #
#                                                                        #
##########################################################################

%shub2_01_00655_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%shub2_01_00655_def =
( NAME    => "SH2_MD_DQRP_MMR_DIR_PRIVEC7",
  ADDRESS => 0x0000000000050370,
  NOTE    => "privilege vector for acc=7",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00655_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_DIR_TIMER                                            #
#                                                                        #
##########################################################################

%shub2_01_00656_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIMER_CUR"                    => [   1,  13,   9, 0x00000000003FE000, 0x00, 1, 0x0000000000000000, "value of current timer" ],
   "TIMER_EN"                     => [   2,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "timer enable" ],
   "TIMER_DIV"                    => [   3,   0,  12, 0x0000000000000FFF, 0x00, 1, 0x0000000000000000, "timer divide register" ],
);

%shub2_01_00656_def =
( NAME    => "SH2_MD_DQRP_MMR_DIR_TIMER",
  ADDRESS => 0x0000000000050400,
  NOTE    => "This register holds enables and configuration bits of the MD SXRO note timer. The core clock 'coreclk' is devided by 64 in a pre",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00656_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_PIOWD_DIR_ENTRY                                      #
#                                                                        #
##########################################################################

%shub2_01_00657_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  58,   6, 0xFC00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ACC"                          => [   1,  55,   3, 0x0380000000000000, 0x00, 1, 0x0000000000000000, "directory access bits" ],
   "PRI"                          => [   2,  52,   3, 0x0070000000000000, 0x00, 1, 0x0000000000000000, "directory priority" ],
   "DIRB"                         => [   3,  26,  26, 0x000FFFFFFC000000, 0x00, 1, 0x0000000000000000, "directory entry B" ],
   "DIRA"                         => [   4,   0,  26, 0x0000000003FFFFFF, 0x00, 1, 0x0000000000000000, "directory entry A" ],
);

%shub2_01_00657_def =
( NAME    => "SH2_MD_DQRP_MMR_PIOWD_DIR_ENTRY",
  ADDRESS => 0x0000000000051000,
  NOTE    => "Directory entries A and B with access, priority and rsvd bits.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00657_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_PIOWD_DIR_ECC                                        #
#                                                                        #
##########################################################################

%shub2_01_00658_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  14,  50, 0xFFFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECCB"                         => [   1,   7,   7, 0x0000000000003F80, 0x00, 1, 0x0000000000000000, "XOR bits for directory ECC group 2" ],
   "ECCA"                         => [   2,   0,   7, 0x000000000000007F, 0x00, 1, 0x0000000000000000, "XOR bits for directory ECC group 1" ],
);

%shub2_01_00658_def =
( NAME    => "SH2_MD_DQRP_MMR_PIOWD_DIR_ECC",
  ADDRESS => 0x0000000000051010,
  NOTE    => "These two ECC values are XORed with the generated directory ECC note bits and should be 0 for normal operation. Diagnostic softw",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00658_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_XPIORD_XDIR_ENTRY                                     #
#                                                                        #
##########################################################################

%shub2_01_00659_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNC"                          => [   1,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error" ],
   "COR"                          => [   2,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error" ],
   "ACC"                          => [   3,  55,   3, 0x0380000000000000, 0x00, 0, 0x0000000000000000, "directory access bits" ],
   "PRI"                          => [   4,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "directory priority" ],
   "DIRB"                         => [   5,  26,  26, 0x000FFFFFFC000000, 0x00, 0, 0x0000000000000000, "directory entry B" ],
   "DIRA"                         => [   6,   0,  26, 0x0000000003FFFFFF, 0x00, 0, 0x0000000000000000, "directory entry A" ],
);

%shub2_01_00659_def =
( NAME    => "SH2_MD_DQRP_MMR_XPIORD_XDIR_ENTRY",
  ADDRESS => 0x0000000000052000,
  NOTE    => "Directory entries A and B with access, priority and rsvd bits.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00659_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_XPIORD_XDIR_ECC                                      #
#                                                                        #
##########################################################################

%shub2_01_00660_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  14,  50, 0xFFFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECCB"                         => [   1,   7,   7, 0x0000000000003F80, 0x00, 0, 0x0000000000000000, "group 2 ecc" ],
   "ECCA"                         => [   2,   0,   7, 0x000000000000007F, 0x00, 0, 0x0000000000000000, "group 1 ecc" ],
);

%shub2_01_00660_def =
( NAME    => "SH2_MD_DQRP_MMR_XPIORD_XDIR_ECC",
  ADDRESS => 0x0000000000052010,
  NOTE    => "ECC bits of group 1 and 2 of directory pair.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00660_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_YPIORD_YDIR_ENTRY                                     #
#                                                                        #
##########################################################################

%shub2_01_00661_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNC"                          => [   1,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error" ],
   "COR"                          => [   2,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error" ],
   "ACC"                          => [   3,  55,   3, 0x0380000000000000, 0x00, 0, 0x0000000000000000, "directory access bits" ],
   "PRI"                          => [   4,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "directory priority" ],
   "DIRB"                         => [   5,  26,  26, 0x000FFFFFFC000000, 0x00, 0, 0x0000000000000000, "directory entry B" ],
   "DIRA"                         => [   6,   0,  26, 0x0000000003FFFFFF, 0x00, 0, 0x0000000000000000, "directory entry A" ],
);

%shub2_01_00661_def =
( NAME    => "SH2_MD_DQRP_MMR_YPIORD_YDIR_ENTRY",
  ADDRESS => 0x0000000000052800,
  NOTE    => "Directory entries A and B with access, priority and rsvd bits.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00661_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_YPIORD_YDIR_ECC                                      #
#                                                                        #
##########################################################################

%shub2_01_00662_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  14,  50, 0xFFFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECCB"                         => [   1,   7,   7, 0x0000000000003F80, 0x00, 0, 0x0000000000000000, "group 2 ecc" ],
   "ECCA"                         => [   2,   0,   7, 0x000000000000007F, 0x00, 0, 0x0000000000000000, "group 1 ecc" ],
);

%shub2_01_00662_def =
( NAME    => "SH2_MD_DQRP_MMR_YPIORD_YDIR_ECC",
  ADDRESS => 0x0000000000052810,
  NOTE    => "ECC bits of group 1 and 2 of directory pair.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00662_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_XCERR1                                               #
#                                                                        #
##########################################################################

%shub2_01_00663_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  39,  25, 0xFFFFFF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms uncorrectable ecc error capture" ],
   "MORE"                         => [   2,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one correctable ecc error in group 1" ],
   "VAL"                          => [   3,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error in group 1 bits" ],
   "GRP1"                         => [   4,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 1 bits" ],
);

%shub2_01_00663_def =
( NAME    => "SH2_MD_DQRP_MMR_XCERR1",
  ADDRESS => 0x0000000000053000,
  NOTE    => "These registers capture the data bits for correctable directory ecc note errors. The data bits of ecc groups 1 and 2 that make t",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00663_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_XCERR2                                               #
#                                                                        #
##########################################################################

%shub2_01_00664_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one correctable ecc error in group 2" ],
   "VAL"                          => [   2,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error in group 2 bits" ],
   "GRP2"                         => [   3,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 2 bits" ],
);

%shub2_01_00664_def =
( NAME    => "SH2_MD_DQRP_MMR_XCERR2",
  ADDRESS => 0x0000000000053010,
  NOTE    => "correctable dir ecc group 2 error register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00664_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_XUERR1                                               #
#                                                                        #
##########################################################################

%shub2_01_00665_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  39,  25, 0xFFFFFF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms uncorrectable ecc error capture" ],
   "MORE"                         => [   2,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one uncorrectable ecc error in group 1" ],
   "VAL"                          => [   3,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error in group 1 bits" ],
   "GRP1"                         => [   4,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 1 bits" ],
);

%shub2_01_00665_def =
( NAME    => "SH2_MD_DQRP_MMR_XUERR1",
  ADDRESS => 0x0000000000053020,
  NOTE    => "These registers capture the data bits for uncorrectable directory note ecc errors. The data bits of ecc groups 1 and 2 that make",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00665_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_XUERR2                                               #
#                                                                        #
##########################################################################

%shub2_01_00666_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one uncorrectable ecc error in group 2" ],
   "VAL"                          => [   2,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error in group 2 bits" ],
   "GRP2"                         => [   3,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 2 bits" ],
);

%shub2_01_00666_def =
( NAME    => "SH2_MD_DQRP_MMR_XUERR2",
  ADDRESS => 0x0000000000053030,
  NOTE    => "uncorrectable dir ecc group 2 error register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00666_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_XPERR0                                               #
#                                                                        #
##########################################################################

%shub2_01_00667_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  57,   7, 0xFE00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms error capture" ],
   "MORE"                         => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "more than one protocol error" ],
   "VAL"                          => [   3,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "protocol error info valid" ],
   "UNC"                          => [   4,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error" ],
   "COR"                          => [   5,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error" ],
   "PRIV"                         => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "access privilege bit" ],
   "PRIGE"                        => [   7,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "priority was greater-equal" ],
   "SRC"                          => [   8,  34,  16, 0x0003FFFC00000000, 0x00, 0, 0x0000000000000000, "source node of dir operation" ],
   "CMD"                          => [   9,  26,   8, 0x00000003FC000000, 0x00, 0, 0x0000000000000000, "incoming command" ],
   "DIR"                          => [  10,   0,  26, 0x0000000003FFFFFF, 0x00, 0, 0x0000000000000000, "directory entry" ],
);

%shub2_01_00667_def =
( NAME    => "SH2_MD_DQRP_MMR_XPERR0",
  ADDRESS => 0x0000000000053040,
  NOTE    => "This register captures the table inputs for the first occurence of note a directory protocol table fall-through case. The direct",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00667_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_XPERR1                                               #
#                                                                        #
##########################################################################

%shub2_01_00668_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   7,  57, 0xFFFFFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MYBIT"                        => [   1,   0,   7, 0x000000000000007F, 0x00, 0, 0x0000000000000000, "dfpart,ptreq,timeq,timlast,timspec,onlyme,anytim,ptrii,srcii" ],
);

%shub2_01_00668_def =
( NAME    => "SH2_MD_DQRP_MMR_XPERR1",
  ADDRESS => 0x0000000000053050,
  NOTE    => "This register captures the table inputs for the first occurence of note a directory protocol table fall-through case. The direct",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00668_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_YCERR1                                               #
#                                                                        #
##########################################################################

%shub2_01_00669_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  39,  25, 0xFFFFFF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms uncorrectable ecc error capture" ],
   "MORE"                         => [   2,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one correctable ecc error in group 1" ],
   "VAL"                          => [   3,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error in group 1 bits" ],
   "GRP1"                         => [   4,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 1 bits" ],
);

%shub2_01_00669_def =
( NAME    => "SH2_MD_DQRP_MMR_YCERR1",
  ADDRESS => 0x0000000000053800,
  NOTE    => "These registers capture the data bits for correctable directory ecc note errors. The data bits of ecc groups 1 and 2 that make t",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00669_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_YCERR2                                               #
#                                                                        #
##########################################################################

%shub2_01_00670_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one correctable ecc error in group 2" ],
   "VAL"                          => [   2,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error in group 2 bits" ],
   "GRP2"                         => [   3,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 2 bits" ],
);

%shub2_01_00670_def =
( NAME    => "SH2_MD_DQRP_MMR_YCERR2",
  ADDRESS => 0x0000000000053810,
  NOTE    => "correctable dir ecc group 2 error register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00670_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_YUERR1                                               #
#                                                                        #
##########################################################################

%shub2_01_00671_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  39,  25, 0xFFFFFF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms uncorrectable ecc error capture" ],
   "MORE"                         => [   2,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one uncorrectable ecc error in group 1" ],
   "VAL"                          => [   3,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error in group 1 bits" ],
   "GRP1"                         => [   4,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 1 bits" ],
);

%shub2_01_00671_def =
( NAME    => "SH2_MD_DQRP_MMR_YUERR1",
  ADDRESS => 0x0000000000053820,
  NOTE    => "These registers capture the data bits for uncorrectable directory note ecc errors. The data bits of ecc groups 1 and 2 that make",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00671_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_YUERR2                                               #
#                                                                        #
##########################################################################

%shub2_01_00672_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one uncorrectable ecc error in group 2" ],
   "VAL"                          => [   2,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error in group 2 bits" ],
   "GRP2"                         => [   3,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 2 bits" ],
);

%shub2_01_00672_def =
( NAME    => "SH2_MD_DQRP_MMR_YUERR2",
  ADDRESS => 0x0000000000053830,
  NOTE    => "uncorrectable dir ecc group 2 error register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00672_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_YPERR0                                               #
#                                                                        #
##########################################################################

%shub2_01_00673_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  57,   7, 0xFE00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms error capture" ],
   "MORE"                         => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "more than one protocol error" ],
   "VAL"                          => [   3,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "protocol error info valid" ],
   "UNC"                          => [   4,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error" ],
   "COR"                          => [   5,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error" ],
   "PRIV"                         => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "access privilege bit" ],
   "PRIGE"                        => [   7,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "priority was greater-equal" ],
   "SRC"                          => [   8,  34,  16, 0x0003FFFC00000000, 0x00, 0, 0x0000000000000000, "source node of dir operation" ],
   "CMD"                          => [   9,  26,   8, 0x00000003FC000000, 0x00, 0, 0x0000000000000000, "incoming command" ],
   "DIR"                          => [  10,   0,  26, 0x0000000003FFFFFF, 0x00, 0, 0x0000000000000000, "directory entry" ],
);

%shub2_01_00673_def =
( NAME    => "SH2_MD_DQRP_MMR_YPERR0",
  ADDRESS => 0x0000000000053840,
  NOTE    => "This register captures the table inputs for the first occurence of note a directory protocol table fall-through case. The direct",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00673_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_YPERR1                                               #
#                                                                        #
##########################################################################

%shub2_01_00674_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   7,  57, 0xFFFFFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MYBIT"                        => [   1,   0,   7, 0x000000000000007F, 0x00, 0, 0x0000000000000000, "dfpart,ptreq,timeq,timlast,timspec,onlyme,anytim,ptrii,srcii" ],
);

%shub2_01_00674_def =
( NAME    => "SH2_MD_DQRP_MMR_YPERR1",
  ADDRESS => 0x0000000000053850,
  NOTE    => "This register captures the table inputs for the first occurence of note a directory protocol table fall-through case. The direct",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00674_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_DIR_CMDTRIG                                          #
#                                                                        #
##########################################################################

%shub2_01_00675_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "YDIR_DBG_SEL"                 => [   1,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "Select X directory debug path, used with ac cmp_match to track directory transitions" ],
   "XDIR_DBG_SEL"                 => [   2,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Select X directory debug path, used with ac cmp_match to track directory transitions" ],
   "CMD3"                         => [   3,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "command trigger 3" ],
   "CMD2"                         => [   4,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "command trigger 2" ],
   "CMD1"                         => [   5,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "command trigger 1" ],
   "CMD0"                         => [   6,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "command trigger 0" ],
);

%shub2_01_00675_def =
( NAME    => "SH2_MD_DQRP_MMR_DIR_CMDTRIG",
  ADDRESS => 0x0000000000054000,
  NOTE    => "This register holds 4 cmd encodings that are compared to the note incoming directory request. Each of the four comparators drive",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00675_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_DIR_TBLTRIG                                          #
#                                                                        #
##########################################################################

%shub2_01_00676_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  43,  21, 0xFFFFF80000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MYBIT"                        => [   1,  36,   7, 0x000007F000000000, 0x00, 0, 0x0000000000000000, "ptreq,timeq,timlast,timspec,onlyme,anytim,ptrii,srcii" ],
   "DIRST"                        => [   2,  27,   9, 0x0000000FF8000000, 0x00, 0, 0x0000000000000000, "shrd,sxro,sub-state" ],
   "PRIGE"                        => [   3,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "priority greater-equal" ],
   "ACC"                          => [   4,  24,   2, 0x0000000003000000, 0x00, 0, 0x0000000000000000, "uncorrectable error, privilege bit" ],
   "CMD"                          => [   5,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "incoming request" ],
   "SRC"                          => [   6,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "source of request" ],
);

%shub2_01_00676_def =
( NAME    => "SH2_MD_DQRP_MMR_DIR_TBLTRIG",
  ADDRESS => 0x0000000000054010,
  NOTE    => "This register holds a value which is compared to the inputs of the note directory table logic. If they match a debug signal is a",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00676_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_DIR_TBLMASK                                          #
#                                                                        #
##########################################################################

%shub2_01_00677_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  43,  21, 0xFFFFF80000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MYBIT"                        => [   1,  36,   7, 0x000007F000000000, 0x00, 1, 0x0000000000000000, "ptreq,timeq,timlast,timspec,onlyme,anytim,ptrii,srcii" ],
   "DIRST"                        => [   2,  27,   9, 0x0000000FF8000000, 0x00, 1, 0x0000000000000000, "shrd,sxro,sub-state" ],
   "PRIGE"                        => [   3,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "priority greater-equal" ],
   "ACC"                          => [   4,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "uncorrectable error, privilege bit" ],
   "CMD"                          => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "incoming request" ],
   "SRC"                          => [   6,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "source of request" ],
);

%shub2_01_00677_def =
( NAME    => "SH2_MD_DQRP_MMR_DIR_TBLMASK",
  ADDRESS => 0x0000000000054020,
  NOTE    => "dir table trigger mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00677_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_XBIST_H                                              #
#                                                                        #
##########################################################################

%shub2_01_00678_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  44,  20, 0xFFFFF00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms data miscompare capture" ],
   "RANDOM"                       => [   2,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "generate random data pattern in next cycle" ],
   "ROT"                          => [   3,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   4,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "RSVD1"                        => [   5,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   6,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%shub2_01_00678_def =
( NAME    => "SH2_MD_DQRP_MMR_XBIST_H",
  ADDRESS => 0x0000000000058000,
  NOTE    => "These registers hold the DDR rising and falling edge data pattern note and bist/fill mode bits. The width of the data depends on",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00678_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_XBIST_L                                              #
#                                                                        #
##########################################################################

%shub2_01_00679_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  43,  21, 0xFFFFF80000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RANDOM"                       => [   1,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "generate random data pattern in next cycle" ],
   "ROT"                          => [   2,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   3,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "RSVD1"                        => [   4,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   5,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%shub2_01_00679_def =
( NAME    => "SH2_MD_DQRP_MMR_XBIST_L",
  ADDRESS => 0x0000000000058010,
  NOTE    => "falling edge bist/fill pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00679_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_XBIST_ERR_H                                          #
#                                                                        #
##########################################################################

%shub2_01_00680_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "RSVD1"                        => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   4,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%shub2_01_00680_def =
( NAME    => "SH2_MD_DQRP_MMR_XBIST_ERR_H",
  ADDRESS => 0x0000000000058020,
  NOTE    => "These registers hold the DDR rising and falling edge data pattern note for the first data miscompare during bist read/compare op",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00680_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_XBIST_ERR_L                                          #
#                                                                        #
##########################################################################

%shub2_01_00681_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "RSVD1"                        => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   4,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%shub2_01_00681_def =
( NAME    => "SH2_MD_DQRP_MMR_XBIST_ERR_L",
  ADDRESS => 0x0000000000058030,
  NOTE    => "falling edge bist error pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00681_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_XBIST_MASK                                           #
#                                                                        #
##########################################################################

%shub2_01_00682_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COMP_DIS"                     => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "compare disable" ],
);

%shub2_01_00682_def =
( NAME    => "SH2_MD_DQRP_MMR_XBIST_MASK",
  ADDRESS => 0x0000000000058040,
  NOTE    => "This register holds the compare mask to enable or disable note individual data bit compares.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00682_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_YBIST_H                                              #
#                                                                        #
##########################################################################

%shub2_01_00683_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  44,  20, 0xFFFFF00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms data miscompare capture" ],
   "RANDOM"                       => [   2,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "generate random data pattern in next cycle" ],
   "ROT"                          => [   3,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   4,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "RSVD1"                        => [   5,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   6,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%shub2_01_00683_def =
( NAME    => "SH2_MD_DQRP_MMR_YBIST_H",
  ADDRESS => 0x0000000000058800,
  NOTE    => "These registers hold the DDR rising and falling edge data pattern note and bist/fill mode bits. The width of the data depends on",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00683_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_YBIST_L                                              #
#                                                                        #
##########################################################################

%shub2_01_00684_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  43,  21, 0xFFFFF80000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RANDOM"                       => [   1,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "generate random data pattern in next cycle" ],
   "ROT"                          => [   2,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   3,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "RSVD1"                        => [   4,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   5,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%shub2_01_00684_def =
( NAME    => "SH2_MD_DQRP_MMR_YBIST_L",
  ADDRESS => 0x0000000000058810,
  NOTE    => "falling edge bist/fill pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00684_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_YBIST_ERR_H                                          #
#                                                                        #
##########################################################################

%shub2_01_00685_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "RSVD1"                        => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   4,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%shub2_01_00685_def =
( NAME    => "SH2_MD_DQRP_MMR_YBIST_ERR_H",
  ADDRESS => 0x0000000000058820,
  NOTE    => "These registers hold the DDR rising and falling edge data pattern note for the first data miscompare during bist read/compare op",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00685_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_YBIST_ERR_L                                          #
#                                                                        #
##########################################################################

%shub2_01_00686_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "RSVD1"                        => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   4,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%shub2_01_00686_def =
( NAME    => "SH2_MD_DQRP_MMR_YBIST_ERR_L",
  ADDRESS => 0x0000000000058830,
  NOTE    => "falling edge bist error pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00686_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_YBIST_MASK                                           #
#                                                                        #
##########################################################################

%shub2_01_00687_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COMP_DIS"                     => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "compare disable" ],
);

%shub2_01_00687_def =
( NAME    => "SH2_MD_DQRP_MMR_YBIST_MASK",
  ADDRESS => 0x0000000000058840,
  NOTE    => "This register holds the compare mask to enable or disable note individual data bit compares.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00687_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRP_MMR_AMO_CFG                                              #
#                                                                        #
##########################################################################

%shub2_01_00688_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   4,  60, 0xFFFFFFFFFFFFFFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EN_YLITTLE_END"               => [   1,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "enable y little endian mode" ],
   "EN_XLITTLE_END"               => [   2,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "enable x little endian mode" ],
   "EN_YAMOECC"                   => [   3,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "enable y amo ecc detection-correction logic" ],
   "EN_XAMOECC"                   => [   4,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "enable x amo ecc detection-correction logic" ],
);

%shub2_01_00688_def =
( NAME    => "SH2_MD_DQRP_MMR_AMO_CFG",
  ADDRESS => 0x0000000000054800,
  NOTE    => "This register configures the amo logic.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00688_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRS_MMR_XBIST_H                                              #
#                                                                        #
##########################################################################

%shub2_01_00689_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  44,  20, 0xFFFFF00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms data miscompare capture" ],
   "RANDOM"                       => [   2,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "generate random data pattern in next cycle" ],
   "ROT"                          => [   3,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   4,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "PAT"                          => [   5,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%shub2_01_00689_def =
( NAME    => "SH2_MD_DQRS_MMR_XBIST_H",
  ADDRESS => 0x0000000000068000,
  NOTE    => "These registers hold the DDR rising and falling edge data pattern note and bist/fill mode bits. The width of the data depends on",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00689_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRS_MMR_XBIST_L                                              #
#                                                                        #
##########################################################################

%shub2_01_00690_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  43,  21, 0xFFFFF80000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RANDOM"                       => [   1,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "generate random data pattern in next cycle" ],
   "ROT"                          => [   2,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   3,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "PAT"                          => [   4,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%shub2_01_00690_def =
( NAME    => "SH2_MD_DQRS_MMR_XBIST_L",
  ADDRESS => 0x0000000000068010,
  NOTE    => "falling edge bist/fill pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00690_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRS_MMR_XBIST_ERR_H                                          #
#                                                                        #
##########################################################################

%shub2_01_00691_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "PAT"                          => [   3,   0,  40, 0x000000FFFFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%shub2_01_00691_def =
( NAME    => "SH2_MD_DQRS_MMR_XBIST_ERR_H",
  ADDRESS => 0x0000000000068020,
  NOTE    => "These registers hold the DDR rising and falling edge data pattern note for the first data miscompare during bist read/compare op",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00691_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRS_MMR_XBIST_ERR_L                                          #
#                                                                        #
##########################################################################

%shub2_01_00692_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "PAT"                          => [   3,   0,  40, 0x000000FFFFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%shub2_01_00692_def =
( NAME    => "SH2_MD_DQRS_MMR_XBIST_ERR_L",
  ADDRESS => 0x0000000000068030,
  NOTE    => "falling edge bist error pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00692_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRS_MMR_XBIST_MASK                                           #
#                                                                        #
##########################################################################

%shub2_01_00693_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  40,  24, 0xFFFFFF0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COMP_DIS"                     => [   1,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "compare disable" ],
);

%shub2_01_00693_def =
( NAME    => "SH2_MD_DQRS_MMR_XBIST_MASK",
  ADDRESS => 0x0000000000068040,
  NOTE    => "This register holds the compare mask to enable or disable note individual data bit compares.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00693_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRS_MMR_YBIST_H                                              #
#                                                                        #
##########################################################################

%shub2_01_00694_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  44,  20, 0xFFFFF00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms data miscompare capture" ],
   "RANDOM"                       => [   2,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "generate random data pattern in next cycle" ],
   "ROT"                          => [   3,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   4,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "PAT"                          => [   5,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%shub2_01_00694_def =
( NAME    => "SH2_MD_DQRS_MMR_YBIST_H",
  ADDRESS => 0x0000000000068800,
  NOTE    => "These registers hold the DDR rising and falling edge data pattern note and bist/fill mode bits. The width of the data depends on",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00694_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRS_MMR_YBIST_L                                              #
#                                                                        #
##########################################################################

%shub2_01_00695_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  43,  21, 0xFFFFF80000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RANDOM"                       => [   1,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "generate random data pattern in next cycle" ],
   "ROT"                          => [   2,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   3,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "PAT"                          => [   4,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%shub2_01_00695_def =
( NAME    => "SH2_MD_DQRS_MMR_YBIST_L",
  ADDRESS => 0x0000000000068810,
  NOTE    => "falling edge bist/fill pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00695_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRS_MMR_YBIST_ERR_H                                          #
#                                                                        #
##########################################################################

%shub2_01_00696_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "PAT"                          => [   3,   0,  40, 0x000000FFFFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%shub2_01_00696_def =
( NAME    => "SH2_MD_DQRS_MMR_YBIST_ERR_H",
  ADDRESS => 0x0000000000068820,
  NOTE    => "These registers hold the DDR rising and falling edge data pattern note for the first data miscompare during bist read/compare op",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00696_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRS_MMR_YBIST_ERR_L                                          #
#                                                                        #
##########################################################################

%shub2_01_00697_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "PAT"                          => [   3,   0,  40, 0x000000FFFFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%shub2_01_00697_def =
( NAME    => "SH2_MD_DQRS_MMR_YBIST_ERR_L",
  ADDRESS => 0x0000000000068830,
  NOTE    => "falling edge bist error pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00697_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRS_MMR_YBIST_MASK                                           #
#                                                                        #
##########################################################################

%shub2_01_00698_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  40,  24, 0xFFFFFF0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COMP_DIS"                     => [   1,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "compare disable" ],
);

%shub2_01_00698_def =
( NAME    => "SH2_MD_DQRS_MMR_YBIST_MASK",
  ADDRESS => 0x0000000000068840,
  NOTE    => "This register holds the compare mask to enable or disable note individual data bit compares.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00698_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRS_MMR_JNR_DEBUG                                            #
#                                                                        #
##########################################################################

%shub2_01_00699_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   3,  61, 0xFFFFFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR_SEL"                     => [   1,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "select 0=pi_x_rdaddr,1=pi_y_rdaddr,2=pi_wraddr,3=xn_rdaddr,4=xn_wraddr" ],
);

%shub2_01_00699_def =
( NAME    => "SH2_MD_DQRS_MMR_JNR_DEBUG",
  ADDRESS => 0x0000000000069000,
  NOTE    => "This register configure the joiner side rbuf/wbuf address output to note the debug/performance port. Different addresses can be ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00699_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRS_MMR_YAMOPW_ERR                                           #
#                                                                        #
##########################################################################

%shub2_01_00700_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  49,  15, 0xFFFE000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms ecc error capture" ],
   "RSVD1"                        => [   2,  42,   6, 0x0000FC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RUNC"                         => [   3,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc errror on read data" ],
   "RCOR"                         => [   4,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "correctable ecc errror on read data" ],
   "RSYN"                         => [   5,  24,  16, 0x000000FFFF000000, 0x00, 0, 0x0000000000000000, "memory read data syndrome" ],
   "RSVD2"                        => [   6,  18,   6, 0x0000000000FC0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SUNC"                         => [   7,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc errror on store data" ],
   "SCOR"                         => [   8,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "correctable ecc errror on store data" ],
   "SSYN"                         => [   9,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "store data syndrome" ],
);

%shub2_01_00700_def =
( NAME    => "SH2_MD_DQRS_MMR_YAMOPW_ERR",
  ADDRESS => 0x000000000006a000,
  NOTE    => "This register holds the full syndrome of an ecc error encountered note on read-modify-write data for amo and partial byte writes",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00700_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_DQRS_MMR_AMO_CFG                                              #
#                                                                        #
##########################################################################

%shub2_01_00701_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   4,  60, 0xFFFFFFFFFFFFFFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EN_YLITTLE_END"               => [   1,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "enable y little endian mode" ],
   "EN_XLITTLE_END"               => [   2,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "enable x little endian mode" ],
   "EN_YAMOECC"                   => [   3,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "enable y amo ecc detection-correction logic" ],
   "EN_XAMOECC"                   => [   4,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "enable x amo ecc detection-correction logic" ],
);

%shub2_01_00701_def =
( NAME    => "SH2_MD_DQRS_MMR_AMO_CFG",
  ADDRESS => 0x000000000006b000,
  NOTE    => "This register configures the amo logic.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00701_flds
);


##########################################################################
#                                                                        #
#   SH2_ADDRESS_MODE                                                     #
#                                                                        #
##########################################################################

%shub2_01_00702_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   3,  61, 0xFFFFFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CODE"                         => [   1,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%shub2_01_00702_def =
( NAME    => "SH2_ADDRESS_MODE",
  ADDRESS => 0x0000000020110000,
  NOTE    => "The ADDRESS_MODE MMR monitors the contents of the ADDRESS_MODE JTAG note TDR. It's purpose is to provide SAL/kernel with visibil",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00702_flds
);


##########################################################################
#                                                                        #
#   SH2_FIRMWARE_REMAP                                                   #
#                                                                        #
##########################################################################

%shub2_01_00703_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE"                       => [   1,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD1"                        => [   2,  33,  27, 0x0FFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OFFSET"                       => [   3,  24,   9, 0x00000001FF000000, 0x00, 1, 0x0000000000000000, "" ],
);

%shub2_01_00703_def =
( NAME    => "SH2_FIRMWARE_REMAP",
  ADDRESS => 0x0000000020110008,
  NOTE    => "The FIRMWARE_REMAP register provides a redirection mechanisms for note requests issued to the node's 16 MB Firmware Region of it",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00703_flds
);


##########################################################################
#                                                                        #
#   SH2_PROCESSOR_TYPE                                                   #
#                                                                        #
##########################################################################

%shub2_01_00704_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CODE"                         => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%shub2_01_00704_def =
( NAME    => "SH2_PROCESSOR_TYPE",
  ADDRESS => 0x0000000020110010,
  NOTE    => "The PROCESSOR_TYPE MMR monitors the contents of the PROCESSOR_TYPE note JTAG TDR. It's purpose is to provide SAL/kernel with vis",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00704_flds
);


##########################################################################
#                                                                        #
#   SH2_VGA_REMAP                                                        #
#                                                                        #
##########################################################################

%shub2_01_00705_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  41,  23, 0xFFFFFE0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NID"                          => [   1,  28,  13, 0x000001FFF0000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD1"                        => [   2,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ASID"                         => [   3,  24,   2, 0x0000000003000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD2"                        => [   4,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OFFSET"                       => [   5,   1,  21, 0x00000000003FFFFE, 0x00, 1, 0x0000000000000000, "" ],
);

%shub2_01_00705_def =
( NAME    => "SH2_VGA_REMAP",
  ADDRESS => 0x0000000020110018,
  NOTE    => "The VGA_REMAP register provides redirection mechanisms for requests note issued to the node's 128 kB Graphics Adapter Memory (VG",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00705_flds
);


##########################################################################
#                                                                        #
#   SH2_FSB_BINIT_CONTROL                                                #
#                                                                        #
##########################################################################

%shub2_01_00706_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BINIT"                        => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Assert the FSB's BINIT# Signal" ],
);

%shub2_01_00706_def =
( NAME    => "SH2_FSB_BINIT_CONTROL",
  ADDRESS => 0x0000000020010000,
  NOTE    => "The FSB_BINIT_CONTROL register provides a mechanism for forcing the note SHub to assert the FSB's BINIT# signal.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00706_flds
);


##########################################################################
#                                                                        #
#   SH2_FSB_POWER_ON_CONFIG                                              #
#                                                                        #
##########################################################################

%shub2_01_00707_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RESERVED_63_50"               => [   0,  50,  14, 0xFFFC000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "A_49_32_RESERVED"             => [   1,  32,  18, 0x0003FFFF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "A_31_28_OUTPUT_TRISTATE_ENABLED" => [   2,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "" ],
   "A_27_22_RESERVED"             => [   3,  22,   6, 0x000000000FC00000, 0x00, 0, 0x0000000000000000, "" ],
   "A_21_17_CLOCK_RATIO"          => [   4,  17,   5, 0x00000000003E0000, 0x00, 0, 0x0000000000000000, "" ],
   "A_16_RESERVED"                => [   5,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "" ],
   "A_15_REQUEST_BUS_PARKING_ENABLED" => [   6,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "" ],
   "A_14_11_RESERVED"             => [   7,  11,   4, 0x0000000000007800, 0x00, 0, 0x0000000000000000, "" ],
   "A_10_BINIT_SAMPLING_ENABLED"  => [   8,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "A_9_8_RESERVED"               => [   9,   8,   2, 0x0000000000000300, 0x00, 0, 0x0000000000000000, "" ],
   "A_7_IN_ORDER_QUEUE_DEPTH"     => [  10,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "A_6_RESERVED"                 => [  11,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "A_5_SOCKET_LEVEL_LOCKSTEP"    => [  12,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "A_4_3_RESERVED"               => [  13,   3,   2, 0x0000000000000018, 0x00, 0, 0x0000000000000000, "" ],
   "RESERVED_2_0"                 => [  14,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%shub2_01_00707_def =
( NAME    => "SH2_FSB_POWER_ON_CONFIG",
  ADDRESS => 0x0000000020010008,
  NOTE    => "The FSB_POWER_ON_CONFIG MMR shadows the JTAG_FSB_POWER_ON_CFG TDR. note The MMR allows software to monitor the contents of the n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00707_flds
);


##########################################################################
#                                                                        #
#   SH2_FSB_RESET_CONTROL                                                #
#                                                                        #
##########################################################################

%shub2_01_00708_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RESET"                        => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Assert the FSB's RESET# Signal" ],
);

%shub2_01_00708_def =
( NAME    => "SH2_FSB_RESET_CONTROL",
  ADDRESS => 0x0000000020010010,
  NOTE    => "The FSB_RESET_CONTROL register provides a mechanism for forcing the note SHub to assert the FSB's RESET# signal.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00708_flds
);


##########################################################################
#                                                                        #
#   SH2_FSB_SYSTEM_AGENT_CONFIG                                          #
#                                                                        #
##########################################################################

%shub2_01_00709_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  46,  18, 0xFFFFC00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BINIT_EVENT_ENABLES"          => [   1,  32,  14, 0x00003FFF00000000, 0x00, 1, 0x0000000000000000, "BINIT Event Enables" ],
   "RSVD1"                        => [   2,  25,   7, 0x00000000FE000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SERIALIZE_FSB_EN"             => [   3,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Serialize FSB Transactions Enabled" ],
   "RSVD2"                        => [   4,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INTA_RSP_DATA"                => [   5,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Interrupt Acknowledge Response Data" ],
   "SHORT_HANG_EN"                => [   6,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Short Duration for Timeouts Enabled" ],
   "BNR_THROTTLING_EN"            => [   7,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "BNR Throttling Enabled" ],
   "BINIT_ASSERT_EN"              => [   8,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "BINIT Assertion Enabled" ],
   "BERR_SAMPLING_EN"             => [   9,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "BERR Sampling Enabled" ],
   "BERR_ASSERT_EN"               => [  10,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "BERR Assertion Enabled for Bus Errors" ],
   "BINIT_SAMPLING_EN"            => [  11,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "BINIT Sampling Enabled in SHub" ],
   "RSVD3"                        => [  12,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RCNT_SCNT_EN"                 => [  13,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "RCNT/SCNT Assertion Enabled" ],
);

%shub2_01_00709_def =
( NAME    => "SH2_FSB_SYSTEM_AGENT_CONFIG",
  ADDRESS => 0x0000000020010018,
  NOTE    => "The FSB_SYSTEM_AGENT_CONFIG register controls FSB configuration note parameters for the node's system agent (i.e., the SHub). So",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00709_flds
);


##########################################################################
#                                                                        #
#   SH2_FSB_IO_READ_TRANS                                                #
#                                                                        #
##########################################################################

%shub2_01_00710_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RESPONSE"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "IO Read Transaction Response Data" ],
);

%shub2_01_00710_def =
( NAME    => "SH2_FSB_IO_READ_TRANS",
  ADDRESS => 0x0000000020020000,
  NOTE    => "The FSB_IO_READ_TRANS register is a scratch register. It's contents note are returned to the processor whenever a it generates a",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00710_flds
);


##########################################################################
#                                                                        #
#   SH2_FSB_IO_READ_TRANS_ODD                                            #
#                                                                        #
##########################################################################

%shub2_01_00711_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RESPONSE"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "IO Read Transaction Response Data" ],
);

%shub2_01_00711_def =
( NAME    => "SH2_FSB_IO_READ_TRANS_ODD",
  ADDRESS => 0x0000000020020018,
  NOTE    => "The FSB_IO_READ_TRANS register is a scratch register. It's contents note are returned to the processor whenever a it generates a",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00711_flds
);


##########################################################################
#                                                                        #
#   SH2_FSB_RESET_STATUS                                                 #
#                                                                        #
##########################################################################

%shub2_01_00712_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RESET_IN_PROGRESS"            => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Reset in Progress" ],
);

%shub2_01_00712_def =
( NAME    => "SH2_FSB_RESET_STATUS",
  ADDRESS => 0x0000000020020008,
  NOTE    => "The FSB_RESET_STATUS register provides means for software to note monitor the state of the FSB's RESET# signal.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00712_flds
);


##########################################################################
#                                                                        #
#   SH2_FSB_SYMMETRIC_AGENT_STATUS                                       #
#                                                                        #
##########################################################################

%shub2_01_00713_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   3,  61, 0xFFFFFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CPUS_READY"                   => [   1,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "The Processors are Ready" ],
   "CPU_1_ACTIVE"                 => [   2,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "CPU 1 Active." ],
   "CPU_0_ACTIVE"                 => [   3,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "CPU 0 Active." ],
);

%shub2_01_00713_def =
( NAME    => "SH2_FSB_SYMMETRIC_AGENT_STATUS",
  ADDRESS => 0x0000000020020010,
  NOTE    => "The FSB_SYMMETRIC_AGENT_STATUS register provides 3 bits of status note pertaining to the symmetric agents (i.e., the processors)",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00713_flds
);


##########################################################################
#                                                                        #
#   SH2_MEMORY_WRITE_STATUS_00                                           #
#                                                                        #
##########################################################################

%shub2_01_00714_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   6,  58, 0xFFFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   1,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Pending Write Count" ],
);

%shub2_01_00714_def =
( NAME    => "SH2_MEMORY_WRITE_STATUS_00",
  ADDRESS => 0x0000000020070000,
  NOTE    => "The MEMORY_WRITE_STATUS_00 register contains the current value of note the 6-bit counter that tracks Processor 0's Thread 0 outs",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00714_flds
);


##########################################################################
#                                                                        #
#   SH2_MEMORY_WRITE_STATUS_01                                           #
#                                                                        #
##########################################################################

%shub2_01_00715_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   6,  58, 0xFFFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   1,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Pending Write Count" ],
);

%shub2_01_00715_def =
( NAME    => "SH2_MEMORY_WRITE_STATUS_01",
  ADDRESS => 0x0000000020070080,
  NOTE    => "The MEMORY_WRITE_STATUS_01 register contains the current value of note the 6-bit counter that tracks Processor 1's Thread 0 outs",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00715_flds
);


##########################################################################
#                                                                        #
#   SH2_MEMORY_WRITE_STATUS_10                                           #
#                                                                        #
##########################################################################

%shub2_01_00716_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   6,  58, 0xFFFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   1,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Pending Write Count" ],
);

%shub2_01_00716_def =
( NAME    => "SH2_MEMORY_WRITE_STATUS_10",
  ADDRESS => 0x0000000020070100,
  NOTE    => "The MEMORY_WRITE_STATUS_10 register contains the current value of note the 6-bit counter that tracks Processor 0's Thread 1 outs",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00716_flds
);


##########################################################################
#                                                                        #
#   SH2_MEMORY_WRITE_STATUS_11                                           #
#                                                                        #
##########################################################################

%shub2_01_00717_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   6,  58, 0xFFFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   1,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Pending Write Count" ],
);

%shub2_01_00717_def =
( NAME    => "SH2_MEMORY_WRITE_STATUS_11",
  ADDRESS => 0x0000000020070180,
  NOTE    => "The MEMORY_WRITE_STATUS_11 register contains the current value of note the 6-bit counter that tracks Processor 1's Thread 1 outs",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00717_flds
);


##########################################################################
#                                                                        #
#   SH2_PIO_WRITE_STATUS_00                                              #
#                                                                        #
##########################################################################

%shub2_01_00718_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "WRITES_OK"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PIO Write Requests are OK" ],
   "RSVD0"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   2,  56,   6, 0x3F00000000000000, 0x00, 1, 0x0000000000000000, "Pending PIO Write Request Count" ],
   "RSVD1"                        => [   3,  50,   6, 0x00FC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE_ERROR_ADDRESS"          => [   4,   3,  47, 0x0003FFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "Address of the First Failed PIO Write Request" ],
   "WRITE_ERROR"                  => [   5,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "PIO Write Error" ],
   "WRITE_DEADLOCK"               => [   6,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "PIO Write Deadlock Error" ],
   "MULTI_WRITE_ERROR"            => [   7,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "PIO Write Error Overflow Flag" ],
);

%shub2_01_00718_def =
( NAME    => "SH2_PIO_WRITE_STATUS_00",
  ADDRESS => 0x0000000020070200,
  NOTE    => "The PIO_WRITE_STATUS_0 register contains status information related note to Programmed I/O Write (PIO Write) Requests issued by ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00718_flds
);


##########################################################################
#                                                                        #
#   SH2_PIO_WRITE_STATUS_00_ALIAS                                        #
#                                                                        #
##########################################################################

%shub2_01_00719_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "WRITES_OK"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PIO Write Requests are OK" ],
   "RSVD0"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   2,  56,   6, 0x3F00000000000000, 0x00, 1, 0x0000000000000000, "Pending PIO Write Request Count" ],
   "RSVD1"                        => [   3,  50,   6, 0x00FC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE_ERROR_ADDRESS"          => [   4,   3,  47, 0x0003FFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "Address of the First Failed PIO Write Request" ],
   "WRITE_ERROR"                  => [   5,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "PIO Write Error" ],
   "WRITE_DEADLOCK"               => [   6,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "PIO Write Deadlock Error" ],
   "MULTI_WRITE_ERROR"            => [   7,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "PIO Write Error Overflow Flag" ],
);

%shub2_01_00719_def =
( NAME    => "SH2_PIO_WRITE_STATUS_00_ALIAS",
  ADDRESS => 0x0000000020070208,
  NOTE    => "The PIO_WRITE_STATUS_00_ALIAS address is an alias to the note PIO_WRITE_STATUS_00 register. Refer to the PIO_WRITE_STATUS_00 not",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00719_flds
);


##########################################################################
#                                                                        #
#   SH2_PIO_WRITE_STATUS_01                                              #
#                                                                        #
##########################################################################

%shub2_01_00720_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "WRITES_OK"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PIO Write Requests are OK" ],
   "RSVD0"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   2,  56,   6, 0x3F00000000000000, 0x00, 1, 0x0000000000000000, "Pending PIO Write Request Count" ],
   "RSVD1"                        => [   3,  50,   6, 0x00FC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE_ERROR_ADDRESS"          => [   4,   3,  47, 0x0003FFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "Address of the First Failed PIO Write Request" ],
   "WRITE_ERROR"                  => [   5,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "PIO Write Error" ],
   "WRITE_DEADLOCK"               => [   6,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "PIO Write Deadlock Error" ],
   "MULTI_WRITE_ERROR"            => [   7,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "PIO Write Error Overflow Flag" ],
);

%shub2_01_00720_def =
( NAME    => "SH2_PIO_WRITE_STATUS_01",
  ADDRESS => 0x0000000020070280,
  NOTE    => "The PIO_WRITE_STATUS_0 register contains status information related note to Programmed I/O Write (PIO Write) Requests issued by ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00720_flds
);


##########################################################################
#                                                                        #
#   SH2_PIO_WRITE_STATUS_01_ALIAS                                        #
#                                                                        #
##########################################################################

%shub2_01_00721_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "WRITES_OK"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PIO Write Requests are OK" ],
   "RSVD0"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   2,  56,   6, 0x3F00000000000000, 0x00, 1, 0x0000000000000000, "Pending PIO Write Request Count" ],
   "RSVD1"                        => [   3,  50,   6, 0x00FC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE_ERROR_ADDRESS"          => [   4,   3,  47, 0x0003FFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "Address of the First Failed PIO Write Request" ],
   "WRITE_ERROR"                  => [   5,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "PIO Write Error" ],
   "WRITE_DEADLOCK"               => [   6,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "PIO Write Deadlock Error" ],
   "MULTI_WRITE_ERROR"            => [   7,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "PIO Write Error Overflow Flag" ],
);

%shub2_01_00721_def =
( NAME    => "SH2_PIO_WRITE_STATUS_01_ALIAS",
  ADDRESS => 0x0000000020070288,
  NOTE    => "The PIO_WRITE_STATUS_01_ALIAS address is an alias to the note PIO_WRITE_STATUS_01 register. Refer to the PIO_WRITE_STATUS_01 not",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00721_flds
);


##########################################################################
#                                                                        #
#   SH2_PIO_WRITE_STATUS_10                                              #
#                                                                        #
##########################################################################

%shub2_01_00722_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "WRITES_OK"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PIO Write Requests are OK" ],
   "RSVD0"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   2,  56,   6, 0x3F00000000000000, 0x00, 1, 0x0000000000000000, "Pending PIO Write Request Count" ],
   "RSVD1"                        => [   3,  50,   6, 0x00FC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE_ERROR_ADDRESS"          => [   4,   3,  47, 0x0003FFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "Address of the First Failed PIO Write Request" ],
   "WRITE_ERROR"                  => [   5,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "PIO Write Error" ],
   "WRITE_DEADLOCK"               => [   6,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "PIO Write Deadlock Error" ],
   "MULTI_WRITE_ERROR"            => [   7,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "PIO Write Error Overflow Flag" ],
);

%shub2_01_00722_def =
( NAME    => "SH2_PIO_WRITE_STATUS_10",
  ADDRESS => 0x0000000020070300,
  NOTE    => "The PIO_WRITE_STATUS_1 register contains status information related note to Programmed I/O Write (PIO Write) Requests issued by ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00722_flds
);


##########################################################################
#                                                                        #
#   SH2_PIO_WRITE_STATUS_10_ALIAS                                        #
#                                                                        #
##########################################################################

%shub2_01_00723_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "WRITES_OK"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PIO Write Requests are OK" ],
   "RSVD0"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   2,  56,   6, 0x3F00000000000000, 0x00, 1, 0x0000000000000000, "Pending PIO Write Request Count" ],
   "RSVD1"                        => [   3,  50,   6, 0x00FC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE_ERROR_ADDRESS"          => [   4,   3,  47, 0x0003FFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "Address of the First Failed PIO Write Request" ],
   "WRITE_ERROR"                  => [   5,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "PIO Write Error" ],
   "WRITE_DEADLOCK"               => [   6,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "PIO Write Deadlock Error" ],
   "MULTI_WRITE_ERROR"            => [   7,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "PIO Write Error Overflow Flag" ],
);

%shub2_01_00723_def =
( NAME    => "SH2_PIO_WRITE_STATUS_10_ALIAS",
  ADDRESS => 0x0000000020070308,
  NOTE    => "The PIO_WRITE_STATUS_10_ALIAS address is an alias to the note PIO_WRITE_STATUS_10 register. Refer to the PIO_WRITE_STATUS_10 not",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00723_flds
);


##########################################################################
#                                                                        #
#   SH2_PIO_WRITE_STATUS_11                                              #
#                                                                        #
##########################################################################

%shub2_01_00724_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "WRITES_OK"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PIO Write Requests are OK" ],
   "RSVD0"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   2,  56,   6, 0x3F00000000000000, 0x00, 1, 0x0000000000000000, "Pending PIO Write Request Count" ],
   "RSVD1"                        => [   3,  50,   6, 0x00FC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE_ERROR_ADDRESS"          => [   4,   3,  47, 0x0003FFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "Address of the First Failed PIO Write Request" ],
   "WRITE_ERROR"                  => [   5,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "PIO Write Error" ],
   "WRITE_DEADLOCK"               => [   6,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "PIO Write Deadlock Error" ],
   "MULTI_WRITE_ERROR"            => [   7,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "PIO Write Error Overflow Flag" ],
);

%shub2_01_00724_def =
( NAME    => "SH2_PIO_WRITE_STATUS_11",
  ADDRESS => 0x0000000020070380,
  NOTE    => "The PIO_WRITE_STATUS_1 register contains status information related note to Programmed I/O Write (PIO Write) Requests issued by ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00724_flds
);


##########################################################################
#                                                                        #
#   SH2_PIO_WRITE_STATUS_11_ALIAS                                        #
#                                                                        #
##########################################################################

%shub2_01_00725_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "WRITES_OK"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PIO Write Requests are OK" ],
   "RSVD0"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   2,  56,   6, 0x3F00000000000000, 0x00, 1, 0x0000000000000000, "Pending PIO Write Request Count" ],
   "RSVD1"                        => [   3,  50,   6, 0x00FC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE_ERROR_ADDRESS"          => [   4,   3,  47, 0x0003FFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "Address of the First Failed PIO Write Request" ],
   "WRITE_ERROR"                  => [   5,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "PIO Write Error" ],
   "WRITE_DEADLOCK"               => [   6,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "PIO Write Deadlock Error" ],
   "MULTI_WRITE_ERROR"            => [   7,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "PIO Write Error Overflow Flag" ],
);

%shub2_01_00725_def =
( NAME    => "SH2_PIO_WRITE_STATUS_11_ALIAS",
  ADDRESS => 0x0000000020070388,
  NOTE    => "The PIO_WRITE_STATUS_11_ALIAS address is an alias to the note PIO_WRITE_STATUS_11 register. Refer to the PIO_WRITE_STATUS_11 not",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00725_flds
);


##########################################################################
#                                                                        #
#   SH2_MEMORY_WRITE_STATUS_NON_USER_00                                     #
#                                                                        #
##########################################################################

%shub2_01_00726_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CLEAR"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Clear pending write count" ],
   "RSVD0"                        => [   1,   6,  57, 0x7FFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   2,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Pending Write Count" ],
);

%shub2_01_00726_def =
( NAME    => "SH2_MEMORY_WRITE_STATUS_NON_USER_00",
  ADDRESS => 0x0000000020070400,
  NOTE    => "The MEMORY_WRITE_STATUS_NON_USER_00 register contains the current note value of the 6-bit counter that tracks Processor 0's Thre",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00726_flds
);


##########################################################################
#                                                                        #
#   SH2_MEMORY_WRITE_STATUS_NON_USER_01                                     #
#                                                                        #
##########################################################################

%shub2_01_00727_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CLEAR"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Clear pending write count" ],
   "RSVD0"                        => [   1,   6,  57, 0x7FFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   2,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Pending Write Count" ],
);

%shub2_01_00727_def =
( NAME    => "SH2_MEMORY_WRITE_STATUS_NON_USER_01",
  ADDRESS => 0x0000000020070480,
  NOTE    => "The MEMORY_WRITE_STATUS_NON_USER_01 register contains the current note value of the 6-bit counter that tracks Processor 1's Thre",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00727_flds
);


##########################################################################
#                                                                        #
#   SH2_MEMORY_WRITE_STATUS_NON_USER_10                                     #
#                                                                        #
##########################################################################

%shub2_01_00728_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CLEAR"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Clear pending write count" ],
   "RSVD0"                        => [   1,   6,  57, 0x7FFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   2,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Pending Write Count" ],
);

%shub2_01_00728_def =
( NAME    => "SH2_MEMORY_WRITE_STATUS_NON_USER_10",
  ADDRESS => 0x0000000020070500,
  NOTE    => "The MEMORY_WRITE_STATUS_NON_USER_10 register contains the current note value of the 6-bit counter that tracks Processor 0's Thre",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00728_flds
);


##########################################################################
#                                                                        #
#   SH2_MEMORY_WRITE_STATUS_NON_USER_11                                     #
#                                                                        #
##########################################################################

%shub2_01_00729_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CLEAR"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Clear pending write count" ],
   "RSVD0"                        => [   1,   6,  57, 0x7FFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   2,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Pending Write Count" ],
);

%shub2_01_00729_def =
( NAME    => "SH2_MEMORY_WRITE_STATUS_NON_USER_11",
  ADDRESS => 0x0000000020070580,
  NOTE    => "The MEMORY_WRITE_STATUS_NON_USER_11 register contains the current note value of the 6-bit counter that tracks Processor 1's Thre",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00729_flds
);


##########################################################################
#                                                                        #
#   SH2_PIO_WC_WRITE_STATUS_00                                           #
#                                                                        #
##########################################################################

%shub2_01_00730_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "WRITES_OK"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PIO WC Write Requests are OK" ],
   "RSVD0"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   2,  56,   6, 0x3F00000000000000, 0x00, 1, 0x0000000000000000, "Pending PIO WC Write Request Count" ],
   "RSVD1"                        => [   3,  50,   6, 0x00FC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE_ERROR_ADDRESS"          => [   4,   3,  47, 0x0003FFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "Address of the First Failed PIO WC Write Request" ],
   "WRITE_ERROR"                  => [   5,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "PIO WC Write Error" ],
   "RSVD2"                        => [   6,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MULTI_WRITE_ERROR"            => [   7,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "PIO WC Write Error Overflow Flag" ],
);

%shub2_01_00730_def =
( NAME    => "SH2_PIO_WC_WRITE_STATUS_00",
  ADDRESS => 0x0000000020070600,
  NOTE    => "The PIO_WC_WRITE_STATUS_00 register contains status information note related to Programmed I/O Write (PIO Write) Requests with a",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00730_flds
);


##########################################################################
#                                                                        #
#   SH2_PIO_WC_WRITE_STATUS_00_ALIAS                                     #
#                                                                        #
##########################################################################

%shub2_01_00731_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "WRITES_OK"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PIO WC Write Requests are OK" ],
   "RSVD0"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   2,  56,   6, 0x3F00000000000000, 0x00, 1, 0x0000000000000000, "Pending PIO WC Write Request Count" ],
   "RSVD1"                        => [   3,  50,   6, 0x00FC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE_ERROR_ADDRESS"          => [   4,   3,  47, 0x0003FFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "Address of the First Failed PIO WC Write Request" ],
   "WRITE_ERROR"                  => [   5,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "PIO WC Write Error" ],
   "RSVD2"                        => [   6,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MULTI_WRITE_ERROR"            => [   7,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "PIO WC Write Error Overflow Flag" ],
);

%shub2_01_00731_def =
( NAME    => "SH2_PIO_WC_WRITE_STATUS_00_ALIAS",
  ADDRESS => 0x0000000020070608,
  NOTE    => "The PIO_WC_WRITE_STATUS_00_ALIAS address is an alias to the note PIO_WC_WRITE_STATUS_00 register. Refer to the note PIO_WC_WRITE",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00731_flds
);


##########################################################################
#                                                                        #
#   SH2_PIO_WC_WRITE_STATUS_01                                           #
#                                                                        #
##########################################################################

%shub2_01_00732_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "WRITES_OK"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PIO WC Write Requests are OK" ],
   "RSVD0"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   2,  56,   6, 0x3F00000000000000, 0x00, 1, 0x0000000000000000, "Pending PIO WC Write Request Count" ],
   "RSVD1"                        => [   3,  50,   6, 0x00FC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE_ERROR_ADDRESS"          => [   4,   3,  47, 0x0003FFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "Address of the First Failed PIO WC Write Request" ],
   "WRITE_ERROR"                  => [   5,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "PIO WC Write Error" ],
   "RSVD2"                        => [   6,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MULTI_WRITE_ERROR"            => [   7,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "PIO WC Write Error Overflow Flag" ],
);

%shub2_01_00732_def =
( NAME    => "SH2_PIO_WC_WRITE_STATUS_01",
  ADDRESS => 0x0000000020070680,
  NOTE    => "The PIO_WC_WRITE_STATUS_01 register contains status information note related to Programmed I/O Write (PIO Write) Requests with a",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00732_flds
);


##########################################################################
#                                                                        #
#   SH2_PIO_WC_WRITE_STATUS_01_ALIAS                                     #
#                                                                        #
##########################################################################

%shub2_01_00733_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "WRITES_OK"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PIO WC Write Requests are OK" ],
   "RSVD0"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   2,  56,   6, 0x3F00000000000000, 0x00, 1, 0x0000000000000000, "Pending PIO WC Write Request Count" ],
   "RSVD1"                        => [   3,  50,   6, 0x00FC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE_ERROR_ADDRESS"          => [   4,   3,  47, 0x0003FFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "Address of the First Failed PIO WC Write Request" ],
   "WRITE_ERROR"                  => [   5,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "PIO WC Write Error" ],
   "RSVD2"                        => [   6,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MULTI_WRITE_ERROR"            => [   7,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "PIO WC Write Error Overflow Flag" ],
);

%shub2_01_00733_def =
( NAME    => "SH2_PIO_WC_WRITE_STATUS_01_ALIAS",
  ADDRESS => 0x0000000020070688,
  NOTE    => "The PIO_WC_WRITE_STATUS_01_ALIAS address is an alias to the note PIO_WC_WRITE_STATUS_01 register. Refer to the note PIO_WC_WRITE",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00733_flds
);


##########################################################################
#                                                                        #
#   SH2_PIO_WC_WRITE_STATUS_10                                           #
#                                                                        #
##########################################################################

%shub2_01_00734_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "WRITES_OK"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PIO WC Write Requests are OK" ],
   "RSVD0"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   2,  56,   6, 0x3F00000000000000, 0x00, 1, 0x0000000000000000, "Pending PIO WC Write Request Count" ],
   "RSVD1"                        => [   3,  50,   6, 0x00FC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE_ERROR_ADDRESS"          => [   4,   3,  47, 0x0003FFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "Address of the First Failed PIO WC Write Request" ],
   "WRITE_ERROR"                  => [   5,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "PIO WC Write Error" ],
   "RSVD2"                        => [   6,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MULTI_WRITE_ERROR"            => [   7,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "PIO WC Write Error Overflow Flag" ],
);

%shub2_01_00734_def =
( NAME    => "SH2_PIO_WC_WRITE_STATUS_10",
  ADDRESS => 0x0000000020070700,
  NOTE    => "The PIO_WC_WRITE_STATUS_10 register contains status information note related to Programmed I/O Write (PIO Write) Requests with a",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00734_flds
);


##########################################################################
#                                                                        #
#   SH2_PIO_WC_WRITE_STATUS_10_ALIAS                                     #
#                                                                        #
##########################################################################

%shub2_01_00735_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "WRITES_OK"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PIO WC Write Requests are OK" ],
   "RSVD0"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   2,  56,   6, 0x3F00000000000000, 0x00, 1, 0x0000000000000000, "Pending PIO WC Write Request Count" ],
   "RSVD1"                        => [   3,  50,   6, 0x00FC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE_ERROR_ADDRESS"          => [   4,   3,  47, 0x0003FFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "Address of the First Failed PIO WC Write Request" ],
   "WRITE_ERROR"                  => [   5,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "PIO WC Write Error" ],
   "RSVD2"                        => [   6,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MULTI_WRITE_ERROR"            => [   7,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "PIO WC Write Error Overflow Flag" ],
);

%shub2_01_00735_def =
( NAME    => "SH2_PIO_WC_WRITE_STATUS_10_ALIAS",
  ADDRESS => 0x0000000020070708,
  NOTE    => "The PIO_WC_WRITE_STATUS_10_ALIAS address is an alias to the note PIO_WC_WRITE_STATUS_10 register. Refer to the note PIO_WC_WRITE",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00735_flds
);


##########################################################################
#                                                                        #
#   SH2_PIO_WC_WRITE_STATUS_11                                           #
#                                                                        #
##########################################################################

%shub2_01_00736_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "WRITES_OK"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PIO WC Write Requests are OK" ],
   "RSVD0"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   2,  56,   6, 0x3F00000000000000, 0x00, 1, 0x0000000000000000, "Pending PIO WC Write Request Count" ],
   "RSVD1"                        => [   3,  50,   6, 0x00FC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE_ERROR_ADDRESS"          => [   4,   3,  47, 0x0003FFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "Address of the First Failed PIO WC Write Request" ],
   "WRITE_ERROR"                  => [   5,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "PIO WC Write Error" ],
   "RSVD2"                        => [   6,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MULTI_WRITE_ERROR"            => [   7,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "PIO WC Write Error Overflow Flag" ],
);

%shub2_01_00736_def =
( NAME    => "SH2_PIO_WC_WRITE_STATUS_11",
  ADDRESS => 0x0000000020070780,
  NOTE    => "The PIO_WC_WRITE_STATUS_11 register contains status information note related to Programmed I/O Write (PIO Write) Requests with a",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00736_flds
);


##########################################################################
#                                                                        #
#   SH2_PIO_WC_WRITE_STATUS_11_ALIAS                                     #
#                                                                        #
##########################################################################

%shub2_01_00737_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "WRITES_OK"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PIO WC Write Requests are OK" ],
   "RSVD0"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   2,  56,   6, 0x3F00000000000000, 0x00, 1, 0x0000000000000000, "Pending PIO WC Write Request Count" ],
   "RSVD1"                        => [   3,  50,   6, 0x00FC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE_ERROR_ADDRESS"          => [   4,   3,  47, 0x0003FFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "Address of the First Failed PIO WC Write Request" ],
   "WRITE_ERROR"                  => [   5,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "PIO WC Write Error" ],
   "RSVD2"                        => [   6,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MULTI_WRITE_ERROR"            => [   7,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "PIO WC Write Error Overflow Flag" ],
);

%shub2_01_00737_def =
( NAME    => "SH2_PIO_WC_WRITE_STATUS_11_ALIAS",
  ADDRESS => 0x0000000020070788,
  NOTE    => "The PIO_WC_WRITE_STATUS_11_ALIAS address is an alias to the note PIO_WC_WRITE_STATUS_11 register. Refer to the note PIO_WC_WRITE",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00737_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_FSBC_CTP_COMPARATOR                                           #
#                                                                        #
##########################################################################

%shub2_01_00738_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "REFERENCE"                    => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "FSBC CTP Comparator Reference Value" ],
   "ENABLE"                       => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "FSBC CTP Comparator Enable" ],
);

%shub2_01_00738_def =
( NAME    => "SH2_PI_FSBC_CTP_COMPARATOR",
  ADDRESS => 0x0000000020050110,
  NOTE    => "The PI_FSBC_CTP_COMPARATOR register enables/disables the comparison note test performed by the FSBC CORECLK-domain Test Point Co",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00738_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_FSBC_CTP_DEBUG_PORT                                           #
#                                                                        #
##########################################################################

%shub2_01_00739_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NIB_7_SEL"                    => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Select" ],
   "NIB_6_SEL"                    => [   1,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Select" ],
   "NIB_5_SEL"                    => [   2,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Select" ],
   "NIB_4_SEL"                    => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Select" ],
   "NIB_3_SEL"                    => [   4,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Select" ],
   "NIB_2_SEL"                    => [   5,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Nibble 2 Select" ],
   "NIB_1_SEL"                    => [   6,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "Nibble 1 Select" ],
   "NIB_0_SEL"                    => [   7,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Nibble 0 Select" ],
);

%shub2_01_00739_def =
( NAME    => "SH2_PI_FSBC_CTP_DEBUG_PORT",
  ADDRESS => 0x00000000200501a0,
  NOTE    => "The PI_FSBC_CTP_DEBUG_PORT configures the PI FSBC CORECLK-domain note Test Point Debug Port Multiplexers.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00739_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_FSBC_CTP_COMPARATOR_OPERAND                                     #
#                                                                        #
##########################################################################

%shub2_01_00740_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NIB_7_SEL"                    => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Select" ],
   "NIB_6_SEL"                    => [   1,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Select" ],
   "NIB_5_SEL"                    => [   2,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Select" ],
   "NIB_4_SEL"                    => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Select" ],
   "NIB_3_SEL"                    => [   4,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Select" ],
   "NIB_2_SEL"                    => [   5,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Nibble 2 Select" ],
   "NIB_1_SEL"                    => [   6,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "Nibble 1 Select" ],
   "NIB_0_SEL"                    => [   7,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Nibble 0 Select" ],
);

%shub2_01_00740_def =
( NAME    => "SH2_PI_FSBC_CTP_COMPARATOR_OPERAND",
  ADDRESS => 0x0000000020050210,
  NOTE    => "The PI_FSBC_CTP_COMPARATOR_OPERAND register controls the note multiplexers which select the CORECLK-domain test points which wil",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00740_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_FSBC_FTP_COMPARATOR                                           #
#                                                                        #
##########################################################################

%shub2_01_00741_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "REFERENCE"                    => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "FSBC FTP Comparator Reference Value" ],
   "ENABLE"                       => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "FSBC FTP Comparator Enable" ],
);

%shub2_01_00741_def =
( NAME    => "SH2_PI_FSBC_FTP_COMPARATOR",
  ADDRESS => 0x0000000020050120,
  NOTE    => "The PI_FSBC_FTP_COMPARATOR register enables/disables the comparison note test performed by the FSBC FSBCLK-domain Test Point Com",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00741_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_FSBC_FTP_DEBUG_PORT                                           #
#                                                                        #
##########################################################################

%shub2_01_00742_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NIB_7_SEL"                    => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Select" ],
   "NIB_6_SEL"                    => [   1,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Select" ],
   "NIB_5_SEL"                    => [   2,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Select" ],
   "NIB_4_SEL"                    => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Select" ],
   "NIB_3_SEL"                    => [   4,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Select" ],
   "NIB_2_SEL"                    => [   5,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Nibble 2 Select" ],
   "NIB_1_SEL"                    => [   6,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "Nibble 1 Select" ],
   "NIB_0_SEL"                    => [   7,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Nibble 0 Select" ],
);

%shub2_01_00742_def =
( NAME    => "SH2_PI_FSBC_FTP_DEBUG_PORT",
  ADDRESS => 0x00000000200501b0,
  NOTE    => "The PI_FSBC_FTP_DEBUG_PORT configures the PI FSBC FSBCLK-domain note Test Point Debug Port Multiplexers.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00742_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_FSBC_FTP_COMPARATOR_OPERAND                                     #
#                                                                        #
##########################################################################

%shub2_01_00743_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NIB_7_SEL"                    => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Select" ],
   "NIB_6_SEL"                    => [   1,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Select" ],
   "NIB_5_SEL"                    => [   2,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Select" ],
   "NIB_4_SEL"                    => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Select" ],
   "NIB_3_SEL"                    => [   4,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Select" ],
   "NIB_2_SEL"                    => [   5,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Nibble 2 Select" ],
   "NIB_1_SEL"                    => [   6,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "Nibble 1 Select" ],
   "NIB_0_SEL"                    => [   7,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Nibble 0 Select" ],
);

%shub2_01_00743_def =
( NAME    => "SH2_PI_FSBC_FTP_COMPARATOR_OPERAND",
  ADDRESS => 0x0000000020050220,
  NOTE    => "The PI_FSBC_CTP_COMPARATOR_OPERAND register controls the note multiplexers which select the FSBCLK-domain test points which will",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00743_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_AFI_ERROR_MASK                                                #
#                                                                        #
##########################################################################

%shub2_01_00744_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  36,  28, 0xFFFFFFF000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FSB_BINIT_OCCURRED"           => [   1,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: FSB BINIT Occurred Error Mask" ],
   "FSB_TBL_MISS"                 => [   2,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: FSB Table Miss Error Mask" ],
   "BAD_SNOOP"                    => [   3,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: FSB Snoop Error Mask" ],
   "LIVELOCK"                     => [   4,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: FSB Live-lock Error Mask" ],
   "ADDR_PARITY"                  => [   5,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Address Parity Error Mask" ],
   "REQ_PARITY"                   => [   6,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Request Parity Error Mask" ],
   "ADDR_ACCESS"                  => [   7,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Address Access Error Mask" ],
   "REQ_FORMAT"                   => [   8,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Request Format Error Mask" ],
   "IOQ_OVERRUN"                  => [   9,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: IOQ Overrun Error Mask" ],
   "RSP_PARITY"                   => [  10,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Response Parity Error Mask" ],
   "HUNG_BUS"                     => [  11,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Hung Bus Error Mask" ],
);

%shub2_01_00744_def =
( NAME    => "SH2_PI_AFI_ERROR_MASK",
  ADDRESS => 0x0000000020050080,
  NOTE    => "The PI_AFI_ERROR_MASK register controls error detection/correction note capabilities for all errors detected by the PI's AFI RLM",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00744_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_AUTO_REPLY_ENABLE                                             #
#                                                                        #
##########################################################################

%shub2_01_00745_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AUTO_REPLY_ENABLE"            => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Auto Reply Enabled" ],
);

%shub2_01_00745_def =
( NAME    => "SH2_PI_AUTO_REPLY_ENABLE",
  ADDRESS => 0x0000000020050280,
  NOTE    => "The PI_AUTO_REPLY_ENABLE register controls the routing of SN2NET note messages generated by the PI.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00745_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_CAM_CONTROL                                                   #
#                                                                        #
##########################################################################

%shub2_01_00746_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "START"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Start CRB Write or Read Operation" ],
   "RSVD0"                        => [   1,  10,  53, 0x7FFFFFFFFFFFFC00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RRB_RD_XFER_CLEAR"            => [   2,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Clear RRB Read Transfer Pending." ],
   "CAM_WRITE"                    => [   3,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Write CRB Entry." ],
   "CAM_INDX"                     => [   4,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Index of Targeted CRB Entry" ],
);

%shub2_01_00746_def =
( NAME    => "SH2_PI_CAM_CONTROL",
  ADDRESS => 0x0000000020050300,
  NOTE    => "The PI_CAM_CONTROL register provides a facility for reading or note writing a specific CRB entry. Results from a read operation ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00746_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_CRBC_TEST_POINT_COMPARE                                       #
#                                                                        #
##########################################################################

%shub2_01_00747_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COMPARE_PATTERN"              => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Trigger Comparison Test: Reference Pattern" ],
   "COMPARE_MASK"                 => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Trigger Comparison Test: Enable Bits" ],
);

%shub2_01_00747_def =
( NAME    => "SH2_PI_CRBC_TEST_POINT_COMPARE",
  ADDRESS => 0x0000000020050380,
  NOTE    => "The PI_CRBC_TEST_POINT_COMPARE register configures a comparison note test between the output of CRBC's 32-bit Trigger Multiplexe",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00747_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_CRBC_TEST_POINT_SELECT                                        #
#                                                                        #
##########################################################################

%shub2_01_00748_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TRIGGER_ENABLE"               => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Send Trigger Compare Result to Output Port Bit 31" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 7: Nibble Select" ],
   "RSVD0"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_CHIPLET_SEL"          => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 7: Port Select" ],
   "RSVD1"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 6: Nibble Select" ],
   "RSVD2"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_CHIPLET_SEL"          => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 6: Port Select" ],
   "RSVD3"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 5: Nibble Select" ],
   "RSVD4"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_CHIPLET_SEL"          => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 5: Port Select" ],
   "RSVD5"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 4: Nibble Select" ],
   "RSVD6"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_CHIPLET_SEL"          => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 4: Port Select" ],
   "RSVD7"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 3: Nibble Select" ],
   "RSVD8"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_CHIPLET_SEL"          => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 3: Port Select" ],
   "RSVD9"                        => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 2: Nibble Select" ],
   "RSVD10"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_CHIPLET_SEL"          => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 2: Port Select" ],
   "RSVD11"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 1: Nibble Select" ],
   "RSVD12"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_CHIPLET_SEL"          => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Output Port Nibble 1: Port Select" ],
   "RSVD13"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Output Port Nibble 0: Nibble Select" ],
   "RSVD14"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_CHIPLET_SEL"          => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Output Port Nibble 0: Port Select" ],
);

%shub2_01_00748_def =
( NAME    => "SH2_PI_CRBC_TEST_POINT_SELECT",
  ADDRESS => 0x0000000020050400,
  NOTE    => "The PI_CRBC_TEST_POINT_SELECT configures (i.e., contains the select note signals for) the PI's CRBC Test Point Multiplexer. The ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00748_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_CRBC_TEST_POINT_TRIGGER_SELECT                                     #
#                                                                        #
##########################################################################

%shub2_01_00749_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_NIBBLE_SEL"          => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 7: Nibble Select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_CHIPLET_SEL"         => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 7: Port Select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_NIBBLE_SEL"          => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 6: Nibble Select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_CHIPLET_SEL"         => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 6: Port Select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_NIBBLE_SEL"          => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 5: Nibble Select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_CHIPLET_SEL"         => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 5: Port Select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_NIBBLE_SEL"          => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 4: Nibble Select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_CHIPLET_SEL"         => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 4: Port Select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_NIBBLE_SEL"          => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 3: Nibble Select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_CHIPLET_SEL"         => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 3: Port Select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_NIBBLE_SEL"          => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 2: Nibble Select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_CHIPLET_SEL"         => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 2: Port Select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_NIBBLE_SEL"          => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 1: Nibble Select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_CHIPLET_SEL"         => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Output Port Nibble 1: Port Select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_NIBBLE_SEL"          => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Output Port Nibble 0: Nibble Select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_CHIPLET_SEL"         => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Output Port Nibble 0: Port Select" ],
);

%shub2_01_00749_def =
( NAME    => "SH2_PI_CRBC_TEST_POINT_TRIGGER_SELECT",
  ADDRESS => 0x0000000020050480,
  NOTE    => "The PI_CRBC_TEST_POINT_TRIGGER_SELECT register contains the select note bits for the CRBC's Trigger Multiplexer. The CRBC's Trig",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00749_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_CRBP_ERROR_MASK                                               #
#                                                                        #
##########################################################################

%shub2_01_00750_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  25,  39, 0xFFFFFFFFFE000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SHUB_FSB_CE"                  => [   1,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "PI_CE_INT: SHub-to-FSB Correctable Data Error Mask" ],
   "SHUB_FSB_UCE"                 => [   2,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "PI_UCE_INT: SHub-to-FSB Uncorrectable Data Error Mask" ],
   "FSB_SHUB_CE"                  => [   3,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "PI_CE_INT: FSB-to-SHUB Correctable Data Error Mask" ],
   "FSB_SHUB_UCE"                 => [   4,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "PI_UCE_INT: FSB-to-SHub Uncorrectable Data Error Mask" ],
   "XN_RP_CRD_OFLOW"              => [   5,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PI-to-XN Reply Credit Overflow Error Mask" ],
   "XN_RQ_CRD_OFLOW"              => [   6,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PI-to-XN Request Credit Overflow Error Mask" ],
   "MD_RP_CRD_OFLOW"              => [   7,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PI-to-MD Reply Credit Overflow Error Mask" ],
   "MD_RQ_CRD_OFLOW"              => [   8,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PI-to-MD Request Credit Overflow Error Mask" ],
   "NACK_OFLOW"                   => [   9,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: NACK Overflow Error Mask" ],
   "FSB_SHUB_DQE"                 => [  10,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PI-WDAT Queue Error Mask" ],
   "SHUB_FSB_DQE"                 => [  11,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PI-RDAT Queue Error Mask" ],
   "XN_RP_Q_OFLOW"                => [  12,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: XN-to-PI Reply Queue Overflow Error Mask" ],
   "XN_RQ_Q_OFLOW"                => [  13,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: XN-to-PI Request Queue Overflow Error Mask" ],
   "MD_RP_Q_OFLOW"                => [  14,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "PI_HW_INT: MD-to-PI Reply Queue Overflow Error Mask" ],
   "MD_RQ_Q_OFLOW"                => [  15,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "PI_HW_INT: MD-to-PI Request Queue Overflow Error Mask" ],
   "MSG_LEN"                      => [  16,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Message Length Error Mask" ],
   "MSG_COLOR_ERR"                => [  17,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Message Color Error Mask" ],
   "PIO_TO_ERR"                   => [  18,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PIO Time-out Error Mask" ],
   "IRB_TO_ERR"                   => [  19,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "PI_HW_INT: WRB Memory Time-out Error Mask" ],
   "WRB_TO_ERR"                   => [  20,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "PI_HW_INT: WRB Memory Time-out Error Mask" ],
   "RRB_TO_ERR"                   => [  21,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "PI_HW_INT: RRB Memory Time-out Error Mask" ],
   "PIO_RP_ERR"                   => [  22,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PIO Reply Error Mask" ],
   "MEM_RP_ERR"                   => [  23,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Memory Reply Error Mask" ],
   "XB_PROTO_ERR"                 => [  24,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "PI_HW_INT: XB-pipe Protocol Error Mask" ],
   "FSB_PROTO_ERR"                => [  25,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "PI_HW_INT: FSB-pipe Protocol Error Mask" ],
);

%shub2_01_00750_def =
( NAME    => "SH2_PI_CRBP_ERROR_MASK",
  ADDRESS => 0x0000000020050500,
  NOTE    => "The PI_CRBP_ERROR_MASK register controls error detection/correction note capabilities for all errors detected by the PI's CRBP R",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00750_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_CRBP_FSB_PIPE_COMPARE                                         #
#                                                                        #
##########################################################################

%shub2_01_00751_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  53,  11, 0xFFE0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COMPARE_REQ"                  => [   1,  47,   6, 0x001F800000000000, 0x00, 0, 0x0000000000000000, "Comparison Test: REQa Reference Pattern" ],
   "COMPARE_ADDRESS"              => [   2,   0,  47, 0x00007FFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Comparison Test: Address Reference Pattern" ],
);

%shub2_01_00751_def =
( NAME    => "SH2_PI_CRBP_FSB_PIPE_COMPARE",
  ADDRESS => 0x0000000020050580,
  NOTE    => "The PI provides a facility for triggering on address and/or request note information received from the FSB. The PI_CRBP_FSB_PIPE",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00751_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_CRBP_FSB_PIPE_MASK                                            #
#                                                                        #
##########################################################################

%shub2_01_00752_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  53,  11, 0xFFE0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COMPARE_REQ_MASK"             => [   1,  47,   6, 0x001F800000000000, 0x00, 0, 0x0000000000000000, "Mask All or a Portion of the REQa Comparison Test" ],
   "COMPARE_ADDRESS_MASK"         => [   2,   0,  47, 0x00007FFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Mask All or a Portion of the Address Comparison Test" ],
);

%shub2_01_00752_def =
( NAME    => "SH2_PI_CRBP_FSB_PIPE_MASK",
  ADDRESS => 0x0000000020050600,
  NOTE    => "The PI provides a facility for triggering on address and/or request note information received from the FSB. The facility compare",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00752_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_CRBP_TEST_POINT_COMPARE                                       #
#                                                                        #
##########################################################################

%shub2_01_00753_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COMPARE_PATTERN"              => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Trigger Comparison Test: Reference Pattern" ],
   "COMPARE_MASK"                 => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Trigger Comparison Test: Enable Bits" ],
);

%shub2_01_00753_def =
( NAME    => "SH2_PI_CRBP_TEST_POINT_COMPARE",
  ADDRESS => 0x0000000020050680,
  NOTE    => "The PI_CRBP_TEST_POINT_COMPARE register configures a comparison note test between the output of CRBP's 32-bit Trigger Multiplexe",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00753_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_CRBP_TEST_POINT_SELECT                                        #
#                                                                        #
##########################################################################

%shub2_01_00754_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TRIGGER_ENABLE"               => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Send Trigger Compare Result to Output Port Bit 31" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 7: Nibble Select" ],
   "RSVD0"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_CHIPLET_SEL"          => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 7: Port Select" ],
   "RSVD1"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 6: Nibble Select" ],
   "RSVD2"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_CHIPLET_SEL"          => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 6: Port Select" ],
   "RSVD3"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 5: Nibble Select" ],
   "RSVD4"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_CHIPLET_SEL"          => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 5: Port Select" ],
   "RSVD5"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 4: Nibble Select" ],
   "RSVD6"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_CHIPLET_SEL"          => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 4: Port Select" ],
   "RSVD7"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 3: Nibble Select" ],
   "RSVD8"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_CHIPLET_SEL"          => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 3: Port Select" ],
   "RSVD9"                        => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 2: Nibble Select" ],
   "RSVD10"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_CHIPLET_SEL"          => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 2: Port Select" ],
   "RSVD11"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 1: Nibble Select" ],
   "RSVD12"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_CHIPLET_SEL"          => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Output Port Nibble 1: Port Select" ],
   "RSVD13"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Output Port Nibble 0: Nibble Select" ],
   "RSVD14"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_CHIPLET_SEL"          => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Output Port Nibble 0: Port Select" ],
);

%shub2_01_00754_def =
( NAME    => "SH2_PI_CRBP_TEST_POINT_SELECT",
  ADDRESS => 0x0000000020050700,
  NOTE    => "The PI_CRBP_TEST_POINT_SELECT configures (i.e., contains the select note signals for) the PI's CRBP Test Point Multiplexer. The ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00754_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_CRBP_TEST_POINT_TRIGGER_SELECT                                     #
#                                                                        #
##########################################################################

%shub2_01_00755_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_NIBBLE_SEL"          => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 7: Nibble Select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_CHIPLET_SEL"         => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 7: Port Select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_NIBBLE_SEL"          => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 6: Nibble Select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_CHIPLET_SEL"         => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 6: Port Select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_NIBBLE_SEL"          => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 5: Nibble Select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_CHIPLET_SEL"         => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 5: Port Select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_NIBBLE_SEL"          => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 4: Nibble Select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_CHIPLET_SEL"         => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 4: Port Select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_NIBBLE_SEL"          => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 3: Nibble Select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_CHIPLET_SEL"         => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 3: Port Select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_NIBBLE_SEL"          => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 2: Nibble Select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_CHIPLET_SEL"         => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 2: Port Select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_NIBBLE_SEL"          => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 1: Nibble Select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_CHIPLET_SEL"         => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Output Port Nibble 1: Port Select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_NIBBLE_SEL"          => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Output Port Nibble 0: Nibble Select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_CHIPLET_SEL"         => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Output Port Nibble 0: Port Select" ],
);

%shub2_01_00755_def =
( NAME    => "SH2_PI_CRBP_TEST_POINT_TRIGGER_SELECT",
  ADDRESS => 0x0000000020050780,
  NOTE    => "The PI_CRBP_TEST_POINT_TRIGGER_SELECT register contains the select note bits for the CRBP's Trigger Multiplexer. The CRBP's Trig",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00755_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_CRBP_XB_PIPE_COMPARE_0                                        #
#                                                                        #
##########################################################################

%shub2_01_00756_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  55,   9, 0xFF80000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COMPARE_COMMAND"              => [   1,  47,   8, 0x007F800000000000, 0x00, 0, 0x0000000000000000, "Comparison Test: SN2NET Command Reference Pattern" ],
   "COMPARE_ADDRESS"              => [   2,   0,  47, 0x00007FFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Comparison Test: Address Reference Pattern" ],
);

%shub2_01_00756_def =
( NAME    => "SH2_PI_CRBP_XB_PIPE_COMPARE_0",
  ADDRESS => 0x0000000020050800,
  NOTE    => "The PI provides a facility for triggering on address, command, note echo, source, and/or supplemental information contained in S",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00756_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_CRBP_XB_PIPE_COMPARE_1                                        #
#                                                                        #
##########################################################################

%shub2_01_00757_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  41,  23, 0xFFFFFE0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COMPARE_ECHO"                 => [   1,  32,   9, 0x000001FF00000000, 0x00, 0, 0x0000000000000000, "Comparison Test: Echo Reference Pattern" ],
   "COMPARE_SUPPLEMENTAL"         => [   2,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "Comparison Test: Supplemental Reference Pattern" ],
   "COMPARE_SOURCE"               => [   3,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Comparison Test: Source Reference Pattern" ],
);

%shub2_01_00757_def =
( NAME    => "SH2_PI_CRBP_XB_PIPE_COMPARE_1",
  ADDRESS => 0x0000000020050880,
  NOTE    => "The PI provides a facility for triggering on address, command, note echo, source, and/or supplemental information contained in S",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00757_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_CRBP_XB_PIPE_MASK_0                                           #
#                                                                        #
##########################################################################

%shub2_01_00758_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  55,   9, 0xFF80000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COMPARE_COMMAND_MASK"         => [   1,  47,   8, 0x007F800000000000, 0x00, 0, 0x0000000000000000, "Mask All or a Portion of the Command Comparison Test" ],
   "COMPARE_ADDRESS_MASK"         => [   2,   0,  47, 0x00007FFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Mask All or a Portion of the Address Comparison Test" ],
);

%shub2_01_00758_def =
( NAME    => "SH2_PI_CRBP_XB_PIPE_MASK_0",
  ADDRESS => 0x0000000020050900,
  NOTE    => "The PI provides a facility for triggering on address, command, note echo, source, and/or supplemental information received from ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00758_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_CRBP_XB_PIPE_MASK_1                                           #
#                                                                        #
##########################################################################

%shub2_01_00759_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  41,  23, 0xFFFFFE0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COMPARE_ECHO_MASK"            => [   1,  32,   9, 0x000001FF00000000, 0x00, 0, 0x0000000000000000, "Mask All or a Portion of the Echo Comparison Test" ],
   "COMPARE_SUPPLEMENTAL_MASK"    => [   2,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "Mask All or a Portion of the Supplemental Comparison Test" ],
   "COMPARE_SOURCE_MASK"          => [   3,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Mask All or a Portion of the Source Comparison Test" ],
);

%shub2_01_00759_def =
( NAME    => "SH2_PI_CRBP_XB_PIPE_MASK_1",
  ADDRESS => 0x0000000020050980,
  NOTE    => "The PI provides a facility for triggering on address, command, note echo, source, and/or supplemental information received from ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00759_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_DPC_QUEUE_CONFIG                                              #
#                                                                        #
##########################################################################

%shub2_01_00760_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  29,  35, 0xFFFFFFFFE0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FWCQ_AF_THRESH"               => [   1,  24,   5, 0x000000001F000000, 0x00, 1, 0x0000000000000000, "FSB WTL Command Queue Almost Full Threshold" ],
   "RSVD1"                        => [   2,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FWCQ_AE_LEVEL"                => [   3,  16,   5, 0x00000000001F0000, 0x00, 1, 0x0000000000000000, "FSB WTL Command Queue Almost Empty Level" ],
   "RSVD2"                        => [   4,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DWCQ_AF_THRESH"               => [   5,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "DXB WTL Command Queue Almost Full Threshold" ],
   "RSVD3"                        => [   6,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DWCQ_AE_LEVEL"                => [   7,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "DXB WTL Command Queue Almost Empty Level" ],
);

%shub2_01_00760_def =
( NAME    => "SH2_PI_DPC_QUEUE_CONFIG",
  ADDRESS => 0x0000000020050a00,
  NOTE    => "The PI's AFI RLM implements 2 queues in its DPC block: The DXB WTL note Command Queue and the FSB WTL Command Queue. The note PI",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00760_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_FSB_ERROR_INJECTION                                           #
#                                                                        #
##########################################################################

%shub2_01_00761_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD3"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BUS_HANG"                     => [   1,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "Inject a Bus Hang on the FSB" ],
   "LIVELOCK"                     => [   2,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "Inject a Live-lock Error on the FSB" ],
   "IOQ_OVERRUN"                  => [   3,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Inject an ioq overrun Error on the FSB" ],
   "RSVD2"                        => [   4,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DW3_UCE_FROM_FSB"             => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Inject a Uncorrectable Error in Doubleword 0 of SIC Data Packet 0" ],
   "DW3_CE_FROM_FSB"              => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "Inject a Correctable Error in Doubleword 0 of SIC Data Packet 0" ],
   "DW2_UCE_FROM_FSB"             => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "Inject a Uncorrectable Error in Doubleword 0 of SIC Data Packet 0" ],
   "DW2_CE_FROM_FSB"              => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Inject a Correctable Error in Doubleword 0 of SIC Data Packet 0" ],
   "DW1_UCE_FROM_FSB"             => [   9,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Inject a Uncorrectable Error in Doubleword 0 of SIC Data Packet 0" ],
   "DW1_CE_FROM_FSB"              => [  10,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Inject a Correctable Error in Doubleword 0 of SIC Data Packet 0" ],
   "DW0_UCE_FROM_FSB"             => [  11,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Inject a Uncorrectable Error in Doubleword 0 of SIC Data Packet 0" ],
   "DW0_CE_FROM_FSB"              => [  12,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Inject a Correctable Error in Doubleword 0 of SIC Data Packet 0" ],
   "RSP_PE_FROM_FSB"              => [  13,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Inject a RSP# Parity Error When Sampling the FSB" ],
   "AP1_PE_FROM_FSB"              => [  14,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Inject an AP[1]# Parity Error When Sampling the FSB" ],
   "AP0_PE_FROM_FSB"              => [  15,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Inject an AP[0]# Parity Error When Sampling the FSB" ],
   "RP_PE_FROM_FSB"               => [  16,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Inject a RP# Parity Error When Sampling the FSB" ],
   "RSVD1"                        => [  17,  10,   6, 0x000000000000FC00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IP1_PE_TO_FSB"                => [  18,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Inject an IP[1]# Parity Error onto the FSB" ],
   "IP0_PE_TO_FSB"                => [  19,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Inject an IP[0]# Parity Error onto the FSB" ],
   "RSVD0"                        => [  20,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_PE_TO_FSB"                => [  21,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Inject a RSP# Parity Error onto the FSB" ],
   "AP1_PE_TO_FSB"                => [  22,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Inject an AP[1]# Parity Error onto the FSB" ],
   "AP0_PE_TO_FSB"                => [  23,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Inject an AP[0]# Parity Error onto the FSB" ],
   "RP_PE_TO_FSB"                 => [  24,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Inject a RP# Parity Error onto the FSB" ],
);

%shub2_01_00761_def =
( NAME    => "SH2_PI_FSB_ERROR_INJECTION",
  ADDRESS => 0x0000000020050c80,
  NOTE    => "Inject an Error onto the FSB",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00761_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_ERROR_MASK                                                    #
#                                                                        #
##########################################################################

%shub2_01_00762_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  36,  28, 0xFFFFFFF000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FSB_BINIT_OCCURRED"           => [   1,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: FSB BINIT Occurred Error Mask" ],
   "FSB_TBL_MISS"                 => [   2,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: FSB Table Miss Error Mask" ],
   "BAD_SNOOP"                    => [   3,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: FSB Snoop Error Mask" ],
   "LIVELOCK"                     => [   4,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: FSB Livelock Error Mask" ],
   "ADDR_PARITY"                  => [   5,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Address Parity Error Mask" ],
   "REQ_PARITY"                   => [   6,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Request Parity Error Mask" ],
   "ADDR_ACCESS"                  => [   7,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Address Access Error Mask" ],
   "REQ_FORMAT"                   => [   8,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Request Format Error Mask" ],
   "IOQ_OVERRUN"                  => [   9,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: IOQ Overrun Error Mask" ],
   "RSP_PARITY"                   => [  10,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Response Parity Error Mask" ],
   "HUNG_BUS"                     => [  11,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Hung Bus Error Mask" ],
   "SHUB_FSB_CE"                  => [  12,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "PI_CE_INT: SHub-to-FSB Correctable Data Error Mask" ],
   "SHUB_FSB_UCE"                 => [  13,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "PI_UCE_INT: SHub-to-FSB Uncorrectable Data Error Mask" ],
   "FSB_SHUB_CE"                  => [  14,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "PI_CE_INT: FSB-to-SHub Correctable Data Error Mask" ],
   "FSB_SHUB_UCE"                 => [  15,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "PI_UCE_INT: FSB-to-SHub Uncorrectable Data Error Mask" ],
   "XN_RP_CRD_OFLOW"              => [  16,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PI-to-XN Reply Credit Overflow Error Mask" ],
   "XN_RQ_CRD_OFLOW"              => [  17,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PI-to-XN Request Credit Overflow Error Mask" ],
   "MD_RP_CRD_OFLOW"              => [  18,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PI-to-MD Reply Credit Overflow Error Mask" ],
   "MD_RQ_CRD_OFLOW"              => [  19,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PI-to-MD Request Credit Overflow Error Mask" ],
   "NACK_OFLOW"                   => [  20,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: NACK Overflow Error Mask" ],
   "FSB_SHUB_DQE"                 => [  21,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PI-WDAT Queue Error Mask" ],
   "SHUB_FSB_DQE"                 => [  22,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PI-RDAT Queue Error Mask" ],
   "XN_RP_Q_OFLOW"                => [  23,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: XN-to-PI Reply Queue Overflow Error Mask" ],
   "XN_RQ_Q_OFLOW"                => [  24,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: XN-to-PI Request Queue Overflow Error Mask" ],
   "MD_RP_Q_OFLOW"                => [  25,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "PI_HW_INT: MD-to-PI Reply Queue Overflow Error Mask" ],
   "MD_RQ_Q_OFLOW"                => [  26,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "PI_HW_INT: MD-to-PI Request Queue Overflow Error Mask" ],
   "MSG_LENGTH"                   => [  27,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Message Length Error Mask" ],
   "MSG_COLOR_ERR"                => [  28,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Message Color Error Mask" ],
   "PIO_TO_ERR"                   => [  29,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PIO Time-out Error Mask" ],
   "IRB_TO_ERR"                   => [  30,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "PI_HW_INT: IRB Memory Time-out Error Mask" ],
   "WRB_TO_ERR"                   => [  31,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "PI_HW_INT: WRB Memory Time-out Error Mask" ],
   "RRB_TO_ERR"                   => [  32,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "PI_HW_INT: RRB Memory Time-out Error Mask" ],
   "PIO_RP_ERR"                   => [  33,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PIO Reply Error Mask" ],
   "MEM_RP_ERR"                   => [  34,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Memory Reply Error Mask" ],
   "XB_PROTO_ERR"                 => [  35,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "PI_HW_INT: XB-pipe Protocol Error Mask" ],
   "FSB_PROTO_ERR"                => [  36,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "PI_HW_INT: FSB-pipe Protocol Error Mask" ],
);

%shub2_01_00762_def =
( NAME    => "SH2_PI_ERROR_MASK",
  ADDRESS => 0x0000000020050a80,
  NOTE    => "The PI_ERROR_MASK register is the PI's top-level error note configuration register. It contains 35 mask bits. Each mask bit note",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00762_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_FSB_COMPARE_VALUE                                             #
#                                                                        #
##########################################################################

%shub2_01_00763_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COMPARE_VALUE"                => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Comparison Test Reference Value" ],
);

%shub2_01_00763_def =
( NAME    => "SH2_PI_FSB_COMPARE_VALUE",
  ADDRESS => 0x0000000020050c00,
  NOTE    => "The SHub provides a maintenance/performance-monitor trigger note facility which compares signals sampled off the FSB to the note",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00763_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_FSB_COMPARE_MASK                                              #
#                                                                        #
##########################################################################

%shub2_01_00764_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK_VALUE"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Mask One or More Bits from the Comparison" ],
);

%shub2_01_00764_def =
( NAME    => "SH2_PI_FSB_COMPARE_MASK",
  ADDRESS => 0x0000000020050b80,
  NOTE    => "The SHub provides a maintenance/performance-monitor trigger note facility which compares signals sampled off the FSB to the note",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00764_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_FSB_ERROR_INJECTION                                           #
#                                                                        #
##########################################################################

%shub2_01_00765_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BUS_HANG"                     => [   1,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "Inject a Bus Hang on the FSB" ],
   "LIVELOCK"                     => [   2,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "Inject a Live-lock Error on the FSB" ],
   "IOQ_OVERRUN"                  => [   3,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Inject an ioq overrun Error on the FSB" ],
   "RSVD1"                        => [   4,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DW3_UCE_FROM_FSB"             => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Inject a Uncorrectable Error in Doubleword 0 of SIC Data Packet 0" ],
   "DW3_CE_FROM_FSB"              => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "Inject a Correctable Error in Doubleword 0 of SIC Data Packet 0" ],
   "DW2_UCE_FROM_FSB"             => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "Inject a Uncorrectable Error in Doubleword 0 of SIC Data Packet 0" ],
   "DW2_CE_FROM_FSB"              => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Inject a Correctable Error in Doubleword 0 of SIC Data Packet 0" ],
   "DW1_UCE_FROM_FSB"             => [   9,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Inject a Uncorrectable Error in Doubleword 0 of SIC Data Packet 0" ],
   "DW1_CE_FROM_FSB"              => [  10,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Inject a Correctable Error in Doubleword 0 of SIC Data Packet 0" ],
   "DW0_UCE_FROM_FSB"             => [  11,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Inject a Uncorrectable Error in Doubleword 0 of SIC Data Packet 0" ],
   "DW0_CE_FROM_FSB"              => [  12,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Inject a Correctable Error in Doubleword 0 of SIC Data Packet 0" ],
   "RSP_PE_FROM_FSB"              => [  13,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Inject a RSP# Parity Error When Sampling the FSB" ],
   "AP1_PE_FROM_FSB"              => [  14,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Inject an AP[1]# Parity Error When Sampling the FSB" ],
   "AP0_PE_FROM_FSB"              => [  15,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Inject an AP[0]# Parity Error When Sampling the FSB" ],
   "RP_PE_FROM_FSB"               => [  16,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Inject a RP# Parity Error When Sampling the FSB" ],
   "RSVD2"                        => [  17,  10,   6, 0x000000000000FC00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IP1_PE_TO_FSB"                => [  18,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Inject an IP[1]# Parity Error onto the FSB" ],
   "IP0_PE_TO_FSB"                => [  19,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Inject an IP[0]# Parity Error onto the FSB" ],
   "RSVD3"                        => [  20,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_PE_TO_FSB"                => [  21,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Inject a RSP# Parity Error onto the FSB" ],
   "AP1_PE_TO_FSB"                => [  22,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Inject an AP[1]# Parity Error onto the FSB" ],
   "AP0_PE_TO_FSB"                => [  23,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Inject an AP[0]# Parity Error onto the FSB" ],
   "RP_PE_TO_FSB"                 => [  24,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Inject a RP# Parity Error onto the FSB" ],
);

%shub2_01_00765_def =
( NAME    => "SH2_PI_FSB_ERROR_INJECTION",
  ADDRESS => 0x0000000020050c80,
  NOTE    => "The PI_FSB_ERROR_INJECTION register provides a mechanism for which note can inject errors on the FSB. Writing a one to any bit i",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00765_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_FTP_COMPARATOR                                                #
#                                                                        #
##########################################################################

%shub2_01_00766_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "REFERENCE"                    => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Top-level FTP Comparator Reference Value" ],
   "ENABLE"                       => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Top-level FTP Comparator Enable" ],
);

%shub2_01_00766_def =
( NAME    => "SH2_PI_FTP_COMPARATOR",
  ADDRESS => 0x0000000020052078,
  NOTE    => "The PI_FTP_COMPARATOR register enables/disables the comparison test note performed by the Top-level FSBCLK-domain Test Point Com",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00766_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_FTP_COMPARATOR_OPERAND                                        #
#                                                                        #
##########################################################################

%shub2_01_00767_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_7_SEL"                    => [   1,  56,   5, 0x1F00000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Select" ],
   "RSVD1"                        => [   2,  53,   3, 0x00E0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_6_SEL"                    => [   3,  48,   5, 0x001F000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Select" ],
   "RSVD2"                        => [   4,  45,   3, 0x0000E00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_5_SEL"                    => [   5,  40,   5, 0x00001F0000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Select" ],
   "RSVD3"                        => [   6,  37,   3, 0x000000E000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_4_SEL"                    => [   7,  32,   5, 0x0000001F00000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Select" ],
   "RSVD4"                        => [   8,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_3_SEL"                    => [   9,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Select" ],
   "RSVD5"                        => [  10,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_2_SEL"                    => [  11,  16,   5, 0x00000000001F0000, 0x00, 0, 0x0000000000000000, "Nibble 2 Select" ],
   "RSVD6"                        => [  12,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_1_SEL"                    => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "Nibble 1 Select" ],
   "RSVD7"                        => [  14,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_0_SEL"                    => [  15,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Nibble 0 Select" ],
);

%shub2_01_00767_def =
( NAME    => "SH2_PI_FTP_COMPARATOR_OPERAND",
  ADDRESS => 0x0000000020052080,
  NOTE    => "The PI_FTP_COMPARATOR_OPERAND register controls the multiplexers note which select the FSBCLK-domain test points which will be c",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00767_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_FTP_DEBUG_PORT                                                #
#                                                                        #
##########################################################################

%shub2_01_00768_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_7_SEL"                    => [   1,  56,   5, 0x1F00000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Select" ],
   "RSVD1"                        => [   2,  53,   3, 0x00E0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_6_SEL"                    => [   3,  48,   5, 0x001F000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Select" ],
   "RSVD2"                        => [   4,  45,   3, 0x0000E00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_5_SEL"                    => [   5,  40,   5, 0x00001F0000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Select" ],
   "RSVD3"                        => [   6,  37,   3, 0x000000E000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_4_SEL"                    => [   7,  32,   5, 0x0000001F00000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Select" ],
   "RSVD4"                        => [   8,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_3_SEL"                    => [   9,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Select" ],
   "RSVD5"                        => [  10,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_2_SEL"                    => [  11,  16,   5, 0x00000000001F0000, 0x00, 0, 0x0000000000000000, "Nibble 2 Select" ],
   "RSVD6"                        => [  12,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_1_SEL"                    => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "Nibble 1 Select" ],
   "RSVD7"                        => [  14,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_0_SEL"                    => [  15,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Nibble 0 Select" ],
);

%shub2_01_00768_def =
( NAME    => "SH2_PI_FTP_DEBUG_PORT",
  ADDRESS => 0x0000000020052088,
  NOTE    => "The PI_FTP_DEBUG_PORT configures the PI's Top-level FSBCLK-domain note Test Point Debug Port Multiplexer.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00768_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_MD2PI_REPLY_VC_CONFIG                                         #
#                                                                        #
##########################################################################

%shub2_01_00769_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CAPTURE_CREDIT_STATUS"        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Capture the PI's MD-to-PI Reply VC Credit Status" ],
   "FORCE_CREDIT"                 => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Send an Extra MD-to-PI Reply VC Credit to the MD" ],
   "RSVD0"                        => [   2,  14,  48, 0x3FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CREDITS"                  => [   3,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "PI-to-MD Reply VC Credit Limit" ],
   "DATA_DEPTH"                   => [   4,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "Data-bearing Reply Message Limit" ],
   "HDR_DEPTH"                    => [   5,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Reply Message Limit" ],
);

%shub2_01_00769_def =
( NAME    => "SH2_PI_MD2PI_REPLY_VC_CONFIG",
  ADDRESS => 0x0000000020050d00,
  NOTE    => "The PI_MD2PI_REPLY_VC_CONFIG register contains parameters which note manage reply VC credit allocation for the PI's MD-to-PI ins",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00769_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_MD2PI_REQUEST_VC_CONFIG                                       #
#                                                                        #
##########################################################################

%shub2_01_00770_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CAPTURE_CREDIT_STATUS"        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Capture the PI's MD-to-PI Request VC Credit Status" ],
   "FORCE_CREDIT"                 => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Send an Extra MD-to-PI Request VC Credit to the MD" ],
   "RSVD0"                        => [   2,  14,  48, 0x3FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CREDITS"                  => [   3,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "PI-to-MD Request VC Credit Limit" ],
   "DATA_DEPTH"                   => [   4,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "Data-bearing Request Message Limit" ],
   "HDR_DEPTH"                    => [   5,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Request Message Limit" ],
);

%shub2_01_00770_def =
( NAME    => "SH2_PI_MD2PI_REQUEST_VC_CONFIG",
  ADDRESS => 0x0000000020050d80,
  NOTE    => "The PI_MD2PI_REQUEST_VC_CONFIG register contains parameters which note manage request VC credit allocation for the PI's MD-to-PI",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00770_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_QUEUE_ERROR_INJECTION                                         #
#                                                                        #
##########################################################################

%shub2_01_00771_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XNPI_RPY_BFR"                 => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "RXL_RDY_Q"                    => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "RXL_KILL_Q"                   => [   3,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "PTC_INTR"                     => [   4,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "MDPI_RPY_BFR"                 => [   5,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "FSB_WTL_CMND_Q"               => [   6,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "DXB_WTL_CMND_Q"               => [   7,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "DAT_DFR_Q"                    => [   8,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%shub2_01_00771_def =
( NAME    => "SH2_PI_QUEUE_ERROR_INJECTION",
  ADDRESS => 0x0000000020050e00,
  NOTE    => "The PI_QUEUE_ERROR_INJECTION register provides an error injection note facility for maintenance testing purposes. Each bit in th",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00771_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_RDAT_CLEAR_ERROR                                              #
#                                                                        #
##########################################################################

%shub2_01_00772_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SHUB_FSB_CDE"                 => [   1,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "PI_CE_INT: Clear SHub-to-FSB Correctable Data Error" ],
   "SHUB_FSB_UDE"                 => [   2,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI_UCE_INT: Clear SHub-to-FSB Uncorrectable Data Error" ],
);

%shub2_01_00772_def =
( NAME    => "SH2_PI_RDAT_CLEAR_ERROR",
  ADDRESS => 0x0000000020052070,
  NOTE    => "The PI_RDAT_CLEAR_ERROR register rearms the RDAT's detail error note status capture circuitry. The RDAT only captures detailed s",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00772_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_RDAT_CTP_COMPARATOR                                           #
#                                                                        #
##########################################################################

%shub2_01_00773_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "REFERENCE"                    => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "RDAT CTP Comparator Reference Value" ],
   "ENABLE"                       => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "RDAT CTP Comparator Enable" ],
);

%shub2_01_00773_def =
( NAME    => "SH2_PI_RDAT_CTP_COMPARATOR",
  ADDRESS => 0x0000000020052030,
  NOTE    => "The PI_RDAT_CTP_COMPARATOR register enables/disables the comparison note test performed by the RDAT CORECLK-domain Test Point Co",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00773_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_RDAT_CTP_COMPARATOR_OPERAND                                     #
#                                                                        #
##########################################################################

%shub2_01_00774_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_7_SEL"                    => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Select" ],
   "RSVD1"                        => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_6_SEL"                    => [   3,  48,   7, 0x007F000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Select" ],
   "RSVD2"                        => [   4,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_5_SEL"                    => [   5,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Select" ],
   "RSVD3"                        => [   6,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_4_SEL"                    => [   7,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Select" ],
   "RSVD4"                        => [   8,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_3_SEL"                    => [   9,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Select" ],
   "RSVD5"                        => [  10,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_2_SEL"                    => [  11,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Nibble 2 Select" ],
   "RSVD6"                        => [  12,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_1_SEL"                    => [  13,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "Nibble 1 Select" ],
   "RSVD7"                        => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_0_SEL"                    => [  15,   0,   7, 0x000000000000007F, 0x00, 0, 0x0000000000000000, "Nibble 0 Select" ],
);

%shub2_01_00774_def =
( NAME    => "SH2_PI_RDAT_CTP_COMPARATOR_OPERAND",
  ADDRESS => 0x0000000020052038,
  NOTE    => "The PI_RDAT_CTP_COMPARATOR_OPERAND register controls the note multiplexers which select the CORECLK-domain test points which wil",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00774_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_RDAT_CTP_DEBUG_PORT                                           #
#                                                                        #
##########################################################################

%shub2_01_00775_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_7_SEL"                    => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Select" ],
   "RSVD1"                        => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_6_SEL"                    => [   3,  48,   7, 0x007F000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Select" ],
   "RSVD2"                        => [   4,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_5_SEL"                    => [   5,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Select" ],
   "RSVD3"                        => [   6,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_4_SEL"                    => [   7,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Select" ],
   "RSVD4"                        => [   8,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_3_SEL"                    => [   9,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Select" ],
   "RSVD5"                        => [  10,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_2_SEL"                    => [  11,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Nibble 2 Select" ],
   "RSVD6"                        => [  12,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_1_SEL"                    => [  13,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "Nibble 1 Select" ],
   "RSVD7"                        => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_0_SEL"                    => [  15,   0,   7, 0x000000000000007F, 0x00, 0, 0x0000000000000000, "Nibble 0 Select" ],
);

%shub2_01_00775_def =
( NAME    => "SH2_PI_RDAT_CTP_DEBUG_PORT",
  ADDRESS => 0x0000000020052040,
  NOTE    => "The PI_RDAT_CTP_DEBUG_PORT configures the PI RDAT CORECLK-domain note Test Point Debug Port Multiplexers.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00775_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_RDAT_ERROR_MASK                                               #
#                                                                        #
##########################################################################

%shub2_01_00776_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SHUB_FSB_CDE"                 => [   1,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "PI_CE_INT: SHub-to-FSB Correctable Data Error Mask" ],
   "SHUB_FSB_UDE"                 => [   2,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "PI_UCE_INT: SHub-to-FSB Uncorrectable Data Error Mask" ],
);

%shub2_01_00776_def =
( NAME    => "SH2_PI_RDAT_ERROR_MASK",
  ADDRESS => 0x0000000020052060,
  NOTE    => "The PI_RDAT_ERROR_MASK register controls error detection/correction note capabilities for all errors detected by the PI's RDAT R",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00776_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_RDAT_FTP_COMPARATOR                                           #
#                                                                        #
##########################################################################

%shub2_01_00777_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "REFERENCE"                    => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "RDAT FTP Comparator Reference Value" ],
   "ENABLE"                       => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "RDAT FTP Comparator Enable" ],
);

%shub2_01_00777_def =
( NAME    => "SH2_PI_RDAT_FTP_COMPARATOR",
  ADDRESS => 0x0000000020052048,
  NOTE    => "The PI_RDAT_FTP_COMPARATOR register enables/disables the comparison note test performed by the RDAT FSBCLK-domain Test Point Com",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00777_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_RDAT_FTP_COMPARATOR_OPERAND                                     #
#                                                                        #
##########################################################################

%shub2_01_00778_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_7_SEL"                    => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Select" ],
   "RSVD1"                        => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_6_SEL"                    => [   3,  48,   7, 0x007F000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Select" ],
   "RSVD2"                        => [   4,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_5_SEL"                    => [   5,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Select" ],
   "RSVD3"                        => [   6,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_4_SEL"                    => [   7,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Select" ],
   "RSVD4"                        => [   8,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_3_SEL"                    => [   9,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Select" ],
   "RSVD5"                        => [  10,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_2_SEL"                    => [  11,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Nibble 2 Select" ],
   "RSVD6"                        => [  12,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_1_SEL"                    => [  13,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "Nibble 1 Select" ],
   "RSVD7"                        => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_0_SEL"                    => [  15,   0,   7, 0x000000000000007F, 0x00, 0, 0x0000000000000000, "Nibble 0 Select" ],
);

%shub2_01_00778_def =
( NAME    => "SH2_PI_RDAT_FTP_COMPARATOR_OPERAND",
  ADDRESS => 0x0000000020052050,
  NOTE    => "The PI_RDAT_FTP_COMPARATOR_OPERAND register controls the note multiplexers which select the FSBCLK-domain test points which will",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00778_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_RDAT_FTP_DEBUG_PORT                                           #
#                                                                        #
##########################################################################

%shub2_01_00779_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_7_SEL"                    => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Select" ],
   "RSVD1"                        => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_6_SEL"                    => [   3,  48,   7, 0x007F000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Select" ],
   "RSVD2"                        => [   4,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_5_SEL"                    => [   5,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Select" ],
   "RSVD3"                        => [   6,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_4_SEL"                    => [   7,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Select" ],
   "RSVD4"                        => [   8,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_3_SEL"                    => [   9,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Select" ],
   "RSVD5"                        => [  10,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_2_SEL"                    => [  11,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Nibble 2 Select" ],
   "RSVD6"                        => [  12,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_1_SEL"                    => [  13,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "Nibble 1 Select" ],
   "RSVD7"                        => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_0_SEL"                    => [  15,   0,   7, 0x000000000000007F, 0x00, 0, 0x0000000000000000, "Nibble 0 Select" ],
);

%shub2_01_00779_def =
( NAME    => "SH2_PI_RDAT_FTP_DEBUG_PORT",
  ADDRESS => 0x0000000020052058,
  NOTE    => "The PI_RDAT_FTP_DEBUG_PORT configures the PI RDAT FSBCLK-domain note Test Point Debug Port Multiplexers.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00779_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_RDAT_POISON_SNAN_DEP                                          #
#                                                                        #
##########################################################################

%shub2_01_00780_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLED"                      => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Poisoned SNAN DEP Enabled" ],
);

%shub2_01_00780_def =
( NAME    => "SH2_PI_RDAT_POISON_SNAN_DEP",
  ADDRESS => 0x0000000020050e08,
  NOTE    => "In certain error situations (e.g., read request timeouts), it is note desirable for the SHub to complete the pending deferred ph",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00780_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_TEST_POINT_COMPARE                                            #
#                                                                        #
##########################################################################

%shub2_01_00781_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COMPARE_PATTERN"              => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Trigger Comparison Test: Reference Pattern" ],
   "COMPARE_MASK"                 => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Trigger Comparison Test: Enable Bits" ],
);

%shub2_01_00781_def =
( NAME    => "SH2_PI_TEST_POINT_COMPARE",
  ADDRESS => 0x0000000020050e80,
  NOTE    => "The PI_TEST_POINT_COMPARE register configures a comparison test note between the output of PI's 32-bit Trigger Multiplexer and t",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00781_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_TEST_POINT_SELECT                                             #
#                                                                        #
##########################################################################

%shub2_01_00782_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TRIGGER_ENABLE"               => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Send Trigger Compare Result to Output Port Bit 31" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 7: Nibble Select" ],
   "RSVD0"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_CHIPLET_SEL"          => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 7: Port Select" ],
   "RSVD1"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 6: Nibble Select" ],
   "RSVD2"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_CHIPLET_SEL"          => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 6: Port Select" ],
   "RSVD3"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 5: Nibble Select" ],
   "RSVD4"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_CHIPLET_SEL"          => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 5: Port Select" ],
   "RSVD5"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 4: Nibble Select" ],
   "RSVD6"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_CHIPLET_SEL"          => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 4: Port Select" ],
   "RSVD7"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 3: Nibble Select" ],
   "RSVD8"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_CHIPLET_SEL"          => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 3: Port Select" ],
   "RSVD9"                        => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 2: Nibble Select" ],
   "RSVD10"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_CHIPLET_SEL"          => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 2: Port Select" ],
   "RSVD11"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 1: Nibble Select" ],
   "RSVD12"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_CHIPLET_SEL"          => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Output Port Nibble 1: Port Select" ],
   "RSVD13"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Output Port Nibble 0: Nibble Select" ],
   "RSVD14"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_CHIPLET_SEL"          => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Output Port Nibble 0: Port Select" ],
);

%shub2_01_00782_def =
( NAME    => "SH2_PI_TEST_POINT_SELECT",
  ADDRESS => 0x0000000020050f00,
  NOTE    => "The PI_TEST_POINT_SELECT configures (i.e., contains the select note signals for) the PI's Top-level Test Point Multiplexer. The ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00782_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_TEST_POINT_TRIGGER_SELECT                                     #
#                                                                        #
##########################################################################

%shub2_01_00783_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_NIBBLE_SEL"          => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 7: Nibble Select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_CHIPLET_SEL"         => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 7: Port Select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_NIBBLE_SEL"          => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 6: Nibble Select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_CHIPLET_SEL"         => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 6: Port Select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_NIBBLE_SEL"          => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 5: Nibble Select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_CHIPLET_SEL"         => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 5: Port Select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_NIBBLE_SEL"          => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 4: Nibble Select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_CHIPLET_SEL"         => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 4: Port Select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_NIBBLE_SEL"          => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 3: Nibble Select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_CHIPLET_SEL"         => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 3: Port Select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_NIBBLE_SEL"          => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 2: Nibble Select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_CHIPLET_SEL"         => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 2: Port Select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_NIBBLE_SEL"          => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Output Port Nibble 1: Nibble Select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_CHIPLET_SEL"         => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Output Port Nibble 1: Port Select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_NIBBLE_SEL"          => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Output Port Nibble 0: Nibble Select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_CHIPLET_SEL"         => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Output Port Nibble 0: Port Select" ],
);

%shub2_01_00783_def =
( NAME    => "SH2_PI_TEST_POINT_TRIGGER_SELECT",
  ADDRESS => 0x0000000020050f80,
  NOTE    => "The PI_TEST_POINT_TRIGGER_SELECT register contains the select bits note for the PI's Top-level Trigger Multiplexer. The PI's Top",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00783_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_WDAT_CTP_COMPARATOR                                           #
#                                                                        #
##########################################################################

%shub2_01_00784_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "REFERENCE"                    => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "WDAT CTP Comparator Reference Value" ],
   "ENABLE"                       => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "WDAT CTP Comparator Enable" ],
);

%shub2_01_00784_def =
( NAME    => "SH2_PI_WDAT_CTP_COMPARATOR",
  ADDRESS => 0x0000000020052000,
  NOTE    => "The PI_WDAT_CTP_COMPARATOR register enables/disables the comparison note test performed by the WDAT CORECLK-domain Test Point Co",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00784_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_WDAT_CTP_COMPARATOR_OPERAND                                     #
#                                                                        #
##########################################################################

%shub2_01_00785_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_7_SEL"                    => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Select" ],
   "RSVD1"                        => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_6_SEL"                    => [   3,  48,   7, 0x007F000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Select" ],
   "RSVD2"                        => [   4,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_5_SEL"                    => [   5,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Select" ],
   "RSVD3"                        => [   6,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_4_SEL"                    => [   7,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Select" ],
   "RSVD4"                        => [   8,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_3_SEL"                    => [   9,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Select" ],
   "RSVD5"                        => [  10,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_2_SEL"                    => [  11,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Nibble 2 Select" ],
   "RSVD6"                        => [  12,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_1_SEL"                    => [  13,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "Nibble 1 Select" ],
   "RSVD7"                        => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_0_SEL"                    => [  15,   0,   7, 0x000000000000007F, 0x00, 0, 0x0000000000000000, "Nibble 0 Select" ],
);

%shub2_01_00785_def =
( NAME    => "SH2_PI_WDAT_CTP_COMPARATOR_OPERAND",
  ADDRESS => 0x0000000020052008,
  NOTE    => "The PI_WDAT_CTP_COMPARATOR_OPERAND register controls the note multiplexers which select the CORECLK-domain test points which wil",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00785_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_WDAT_CTP_DEBUG_PORT                                           #
#                                                                        #
##########################################################################

%shub2_01_00786_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_7_SEL"                    => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Select" ],
   "RSVD1"                        => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_6_SEL"                    => [   3,  48,   7, 0x007F000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Select" ],
   "RSVD2"                        => [   4,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_5_SEL"                    => [   5,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Select" ],
   "RSVD3"                        => [   6,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_4_SEL"                    => [   7,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Select" ],
   "RSVD4"                        => [   8,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_3_SEL"                    => [   9,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Select" ],
   "RSVD5"                        => [  10,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_2_SEL"                    => [  11,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Nibble 2 Select" ],
   "RSVD6"                        => [  12,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_1_SEL"                    => [  13,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "Nibble 1 Select" ],
   "RSVD7"                        => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_0_SEL"                    => [  15,   0,   7, 0x000000000000007F, 0x00, 0, 0x0000000000000000, "Nibble 0 Select" ],
);

%shub2_01_00786_def =
( NAME    => "SH2_PI_WDAT_CTP_DEBUG_PORT",
  ADDRESS => 0x0000000020052010,
  NOTE    => "The PI_WDAT_CTP_DEBUG_PORT configures the PI WDAT CORECLK-domain note Test Point Debug Port Multiplexers.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00786_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_WDAT_ERROR_MASK                                               #
#                                                                        #
##########################################################################

%shub2_01_00787_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FSB_SHUB_CDE"                 => [   1,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "PI_CE_INT: FSB-to-SHub Correctable Data Error Mask" ],
   "FSB_SHUB_UDE"                 => [   2,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "PI_UCE_INT: FSB-to-SHub Uncorrectable Data Error Mask" ],
);

%shub2_01_00787_def =
( NAME    => "SH2_PI_WDAT_ERROR_MASK",
  ADDRESS => 0x0000000020052068,
  NOTE    => "The PI_WDAT_ERROR_MASK register controls error detection/correction note capabilities for all errors detected by the PI's WDAT R",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00787_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_WDAT_FSB_ACK_Q_CONFIG                                         #
#                                                                        #
##########################################################################

%shub2_01_00788_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BYPASS_POP_RESYNC"            => [   1,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Bypass FSB Acknowledge Queue Pop Resynchronization" ],
   "RSVD1"                        => [   2,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BYPASS_PUSH_RESYNC"           => [   3,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Bypass FSB Acknowledge Queue Push Resynchronization" ],
   "RSVD2"                        => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STALL"                        => [   5,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "WDAT FSB Acknowledge Queue Stall" ],
);

%shub2_01_00788_def =
( NAME    => "SH2_PI_WDAT_FSB_ACK_Q_CONFIG",
  ADDRESS => 0x0000000020053008,
  NOTE    => "The PI_WDAT_FSB_ACK_Q_CONFIG register provides configuration note parameters for the WDAT's FSB Acknowledge Queue.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00788_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_WDAT_FSB_CMND_Q_CONFIG                                        #
#                                                                        #
##########################################################################

%shub2_01_00789_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BYPASS_POP_RESYNC"            => [   1,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Bypass FSB Command Queue Pop Resynchronization" ],
   "RSVD1"                        => [   2,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BYPASS_PUSH_RESYNC"           => [   3,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Bypass FSB Command Queue Push Resynchronization" ],
   "RSVD2"                        => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STALL"                        => [   5,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "WDAT FSB Command Queue Stall" ],
);

%shub2_01_00789_def =
( NAME    => "SH2_PI_WDAT_FSB_CMND_Q_CONFIG",
  ADDRESS => 0x0000000020052090,
  NOTE    => "The PI_WDAT_FSB_CMND_Q_CONFIG register provides configuration note parameters for the WDAT's FSB Command Queue.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00789_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_WDAT_FTP_COMPARATOR                                           #
#                                                                        #
##########################################################################

%shub2_01_00790_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "REFERENCE"                    => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "WDAT FTP Comparator Reference Value" ],
   "ENABLE"                       => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "WDAT FTP Comparator Enable" ],
);

%shub2_01_00790_def =
( NAME    => "SH2_PI_WDAT_FTP_COMPARATOR",
  ADDRESS => 0x0000000020052018,
  NOTE    => "The PI_WDAT_FTP_COMPARATOR register enables/disables the comparison note test performed by the WDAT FSBCLK-domain Test Point Com",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00790_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_WDAT_FTP_COMPARATOR_OPERAND                                     #
#                                                                        #
##########################################################################

%shub2_01_00791_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_7_SEL"                    => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Select" ],
   "RSVD1"                        => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_6_SEL"                    => [   3,  48,   7, 0x007F000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Select" ],
   "RSVD2"                        => [   4,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_5_SEL"                    => [   5,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Select" ],
   "RSVD3"                        => [   6,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_4_SEL"                    => [   7,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Select" ],
   "RSVD4"                        => [   8,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_3_SEL"                    => [   9,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Select" ],
   "RSVD5"                        => [  10,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_2_SEL"                    => [  11,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Nibble 2 Select" ],
   "RSVD6"                        => [  12,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_1_SEL"                    => [  13,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "Nibble 1 Select" ],
   "RSVD7"                        => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_0_SEL"                    => [  15,   0,   7, 0x000000000000007F, 0x00, 0, 0x0000000000000000, "Nibble 0 Select" ],
);

%shub2_01_00791_def =
( NAME    => "SH2_PI_WDAT_FTP_COMPARATOR_OPERAND",
  ADDRESS => 0x0000000020052020,
  NOTE    => "The PI_WDAT_FTP_COMPARATOR_OPERAND register controls the note multiplexers which select the FSBCLK-domain test points which will",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00791_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_WDAT_FTP_DEBUG_PORT                                           #
#                                                                        #
##########################################################################

%shub2_01_00792_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_7_SEL"                    => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Select" ],
   "RSVD1"                        => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_6_SEL"                    => [   3,  48,   7, 0x007F000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Select" ],
   "RSVD2"                        => [   4,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_5_SEL"                    => [   5,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Select" ],
   "RSVD3"                        => [   6,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_4_SEL"                    => [   7,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Select" ],
   "RSVD4"                        => [   8,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_3_SEL"                    => [   9,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Select" ],
   "RSVD5"                        => [  10,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_2_SEL"                    => [  11,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Nibble 2 Select" ],
   "RSVD6"                        => [  12,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_1_SEL"                    => [  13,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "Nibble 1 Select" ],
   "RSVD7"                        => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB_0_SEL"                    => [  15,   0,   7, 0x000000000000007F, 0x00, 0, 0x0000000000000000, "Nibble 0 Select" ],
);

%shub2_01_00792_def =
( NAME    => "SH2_PI_WDAT_FTP_DEBUG_PORT",
  ADDRESS => 0x0000000020052028,
  NOTE    => "The PI_WDAT_FTP_DEBUG_PORT configures the PI WDAT FSBCLK-domain note Test Point Debug Port Multiplexers.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00792_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_WDAT_REPLAY_COUNT_RESET                                       #
#                                                                        #
##########################################################################

%shub2_01_00793_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PULSE"                        => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Replay Count Reset Pulse" ],
);

%shub2_01_00793_def =
( NAME    => "SH2_PI_WDAT_REPLAY_COUNT_RESET",
  ADDRESS => 0x0000000020052098,
  NOTE    => "The PI_WDAT_REPLAY_COUNT_RESET register provides the programmer note with a mechanism to reset the WDAT's Replay Counter. The pr",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00793_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_XN2PI_REPLY_VC_CONFIG                                         #
#                                                                        #
##########################################################################

%shub2_01_00794_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CAPTURE_CREDIT_STATUS"        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Capture the PI's XN-to-PI Reply VC Credit Status" ],
   "FORCE_CREDIT"                 => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Send an Extra XN-to-PI Reply VC Credit to the XN" ],
   "RSVD0"                        => [   2,  14,  48, 0x3FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CREDITS"                  => [   3,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "PI-to-XN Reply VC Credit Limit" ],
   "DATA_DEPTH"                   => [   4,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "Data-bearing Reply Message Limit" ],
   "HDR_DEPTH"                    => [   5,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Reply Message Limit" ],
);

%shub2_01_00794_def =
( NAME    => "SH2_PI_XN2PI_REPLY_VC_CONFIG",
  ADDRESS => 0x0000000020051000,
  NOTE    => "The PI_XN2PI_REPLY_VC_CONFIG register contains parameters which note manage reply VC credit allocation for the PI's XN-to-PI ins",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00794_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_XN2PI_REQUEST_VC_CONFIG                                       #
#                                                                        #
##########################################################################

%shub2_01_00795_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CAPTURE_CREDIT_STATUS"        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Capture the PI's XN-to-PI Request VC Credit Status" ],
   "FORCE_CREDIT"                 => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Send an Extra XN-to-PI Request VC Credit to the XN" ],
   "RSVD0"                        => [   2,  14,  48, 0x3FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CREDITS"                  => [   3,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "PI-to-XN Request VC Credit Limit" ],
   "DATA_DEPTH"                   => [   4,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "Data-bearing Request Message Limit" ],
   "HDR_DEPTH"                    => [   5,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Request Message Limit" ],
);

%shub2_01_00795_def =
( NAME    => "SH2_PI_XN2PI_REQUEST_VC_CONFIG",
  ADDRESS => 0x0000000020051080,
  NOTE    => "The PI_XN2PI_REQUEST_VC_CONFIG register contains parameters which note manage request VC credit allocation for the PI's XN-to-PI",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00795_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_CRB_STALL_SKID                                                #
#                                                                        #
##########################################################################

%shub2_01_00796_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  52,  12, 0xFFF0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WC_SQ_ALMOST_FULL_LIMIT"      => [   1,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "Write Combining Sequential Queue Almost Full Limit" ],
   "RSVD1"                        => [   2,  45,   3, 0x0000E00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB11_STALL_SKID"             => [   3,  40,   5, 0x00001F0000000000, 0x00, 1, 0x0000000000000000, "PRB stall skid value for Thread 11." ],
   "RSVD2"                        => [   4,  37,   3, 0x000000E000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB10_STALL_SKID"             => [   5,  32,   5, 0x0000001F00000000, 0x00, 1, 0x0000000000000000, "PRB stall skid value for Thread 10." ],
   "RSVD3"                        => [   6,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB01_STALL_SKID"             => [   7,  24,   5, 0x000000001F000000, 0x00, 1, 0x0000000000000000, "PRB stall skid value for Thread 01." ],
   "RSVD4"                        => [   8,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB00_STALL_SKID"             => [   9,  16,   5, 0x00000000001F0000, 0x00, 1, 0x0000000000000000, "PRB stall skid value for Thread 00." ],
   "RSVD5"                        => [  10,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRB_STALL_SKID"               => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "WRB stall skid value." ],
   "RSVD6"                        => [  12,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RRB_STALL_SKID"               => [  13,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "RRB stall skid value." ],
);

%shub2_01_00796_def =
( NAME    => "SH2_PI_CRB_STALL_SKID",
  ADDRESS => 0x0000000020051100,
  NOTE    => "The PI_CRB_STALL_SKID register provides a mechanism to configure note when the FSB should be stalled based on request buffer res",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00796_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_AFI_FIRST_ERROR                                               #
#                                                                        #
##########################################################################

%shub2_01_00797_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  36,  28, 0xFFFFFFF000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FSB_BINIT_OCCURRED"           => [   1,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB BINIT Occurred Error" ],
   "FSB_TBL_MISS"                 => [   2,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB Table Miss Error" ],
   "BAD_SNOOP"                    => [   3,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB Snoop Error" ],
   "LIVELOCK"                     => [   4,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB Live-lock Error" ],
   "ADDR_PARITY"                  => [   5,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Address Parity Error" ],
   "REQ_PARITY"                   => [   6,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Request Parity Error" ],
   "ADDR_ACCESS"                  => [   7,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Address Access Error" ],
   "REQ_FORMAT"                   => [   8,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Request Format Error" ],
   "IOQ_OVERRUN"                  => [   9,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: IOQ Overrun Error" ],
   "RSP_PARITY"                   => [  10,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Response Parity Error" ],
   "HUNG_BUS"                     => [  11,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Hung Bus Error" ],
);

%shub2_01_00797_def =
( NAME    => "SH2_PI_AFI_FIRST_ERROR",
  ADDRESS => 0x0000000020060080,
  NOTE    => "The PI_AFI_FIRST_ERROR register is somewhat misleading. The note function of the PI_AFI_FIRST_ERROR register is to rearm the AFI",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00797_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_CAM_ADDRESS_READ_DATA                                         #
#                                                                        #
##########################################################################

%shub2_01_00798_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CAM_ADDR_VAL"                 => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB CAM Address Read Data Valid." ],
   "RSVD0"                        => [   1,  48,  15, 0x7FFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CAM_ADDR"                     => [   2,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "CRB CAM Address Read Data." ],
);

%shub2_01_00798_def =
( NAME    => "SH2_PI_CAM_ADDRESS_READ_DATA",
  ADDRESS => 0x0000000020060100,
  NOTE    => "The SHub provides a facility for reading or writing a specific CRB note entry. Refer to the PI_CAM_CONTROL register description ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00798_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_CAM_LPRA_READ_DATA                                            #
#                                                                        #
##########################################################################

%shub2_01_00799_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CAM_LPRA"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "CRB CAM LPRA Read Data." ],
);

%shub2_01_00799_def =
( NAME    => "SH2_PI_CAM_LPRA_READ_DATA",
  ADDRESS => 0x0000000020060180,
  NOTE    => "The SHub provides a facility for reading or writing a specific CRB note entry. Refer to the PI_CAM_CONTROL register description ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00799_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_CAM_STATE_READ_DATA                                           #
#                                                                        #
##########################################################################

%shub2_01_00800_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CAM_RD_DATA_VAL"              => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB CAM MMR Read Data Valid." ],
   "RSVD0"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CAM_LPRA"                     => [   2,  28,  34, 0x3FFFFFFFF0000000, 0x00, 1, 0x0000000000000000, "CRB LPRA Read Data." ],
   "RSVD1"                        => [   3,   6,  22, 0x000000000FFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CAM_STATE_RD_PEND"            => [   4,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "RRB CAM State Read Pending." ],
   "CAM_TO"                       => [   5,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "CRB CAM Time-out Status." ],
   "CAM_STATE"                    => [   6,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "CRB CAM State Read Data." ],
);

%shub2_01_00800_def =
( NAME    => "SH2_PI_CAM_STATE_READ_DATA",
  ADDRESS => 0x0000000020060200,
  NOTE    => "The SHub provides a facility for reading or writing a specific CRB note entry. Refer to the PI_CAM_CONTROL register description ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00800_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_CORRECTED_DETAIL_1                                            #
#                                                                        #
##########################################################################

%shub2_01_00801_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DEP"                          => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Data-ECC-Protection Bits of the First Failing Doubleword" ],
   "SYNDROME"                     => [   1,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "Syndrome of the First Failing Doubleword" ],
   "ADDRESS"                      => [   2,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Physical Address of the First Failing Doubleword" ],
);

%shub2_01_00801_def =
( NAME    => "SH2_PI_CORRECTED_DETAIL_1",
  ADDRESS => 0x0000000020060280,
  NOTE    => "The PI_CORRECTED_DETAIL_1 register captures detail SHUB_FSB_CE note error information when the first SHUB_FSB_CE error is detect",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00801_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_CORRECTED_DETAIL_2                                            #
#                                                                        #
##########################################################################

%shub2_01_00802_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Failing Doubleword Value" ],
);

%shub2_01_00802_def =
( NAME    => "SH2_PI_CORRECTED_DETAIL_2",
  ADDRESS => 0x0000000020060300,
  NOTE    => "The PI_CORRECTED_DETAIL_2 register captures detail SHUB_FSB_CE note error information when the first SHUB_FSB_CE error is detect",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00802_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_CORRECTED_DETAIL_3                                            #
#                                                                        #
##########################################################################

%shub2_01_00803_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  10,  54, 0xFFFFFFFFFFFFFC00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DID"                          => [   1,   0,  10, 0x00000000000003FF, 0x00, 0, 0x0000000000000000, "Deferred ID" ],
);

%shub2_01_00803_def =
( NAME    => "SH2_PI_CORRECTED_DETAIL_3",
  ADDRESS => 0x0000000020060308,
  NOTE    => "The PI_CORRECTED_DETAIL_3 register captures detail SHUB_FSB_CE note error information when the first SHUB_FSB_CE error is detect",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00803_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_CORRECTED_DETAIL_4                                            #
#                                                                        #
##########################################################################

%shub2_01_00804_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DEP"                          => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Data-ECC-Protection Bits of the First Failing Doubleword" ],
   "SYNDROME"                     => [   1,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "Syndrome of the First Failing Doubleword" ],
   "ADDRESS"                      => [   2,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Physical Address of the First Failing Doubleword" ],
);

%shub2_01_00804_def =
( NAME    => "SH2_PI_CORRECTED_DETAIL_4",
  ADDRESS => 0x0000000020060380,
  NOTE    => "The PI_CORRECTED_DETAIL_4 register captures detail FSB_SHUB_CE note error information when the first FSB_SHUB_CE error is detect",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00804_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_CORRECTED_DETAIL_5                                            #
#                                                                        #
##########################################################################

%shub2_01_00805_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Failing Doubleword Value" ],
);

%shub2_01_00805_def =
( NAME    => "SH2_PI_CORRECTED_DETAIL_5",
  ADDRESS => 0x0000000020060400,
  NOTE    => "The PI_CORRECTED_DETAIL_5 register captures detail FSB_SHUB_CE note error information when the first FSB_SHUB_CE error is detect",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00805_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_CORRECTED_DETAIL_6                                            #
#                                                                        #
##########################################################################

%shub2_01_00806_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   2,  62, 0xFFFFFFFFFFFFFFFC, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "THREAD"                       => [   1,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Failing CPU thread" ],
   "CPU"                          => [   2,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Failing CPU" ],
);

%shub2_01_00806_def =
( NAME    => "SH2_PI_CORRECTED_DETAIL_6",
  ADDRESS => 0x0000000020060408,
  NOTE    => "The PI_CORRECTED_DETAIL_6 register captures detail FSB_SHUB_CE note error information when the first FSB_SHUB_CE error is detect",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00806_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_CRBP_FIRST_ERROR                                              #
#                                                                        #
##########################################################################

%shub2_01_00807_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  25,  39, 0xFFFFFFFFFE000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SHUB_FSB_CE"                  => [   1,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "PI_CE_INT: SHub-to-FSB Correctable Data Error Overflow" ],
   "SHUB_FSB_UCE"                 => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "PI_UCE_INT: SHub-to-FSB Uncorrectable Data Error Overflow" ],
   "FSB_SHUB_CE"                  => [   3,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "PI_CE_INT: FSB-to-SHub Correctable Data Error" ],
   "FSB_SHUB_UCE"                 => [   4,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "PI_UCE_INT: FSB-to-SHub Uncorrectable Data Error" ],
   "XN_RP_CRD_OFLOW"              => [   5,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-XN Reply Credit Overflow Error" ],
   "XN_RQ_CRD_OFLOW"              => [   6,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-XN Request Credit Overflow Error" ],
   "MD_RP_CRD_OFLOW"              => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-MD Reply Credit Overflow Error" ],
   "MD_RQ_CRD_OFLOW"              => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-MD Request Credit Overflow Error" ],
   "NACK_OFLOW"                   => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: NACK Overflow Error" ],
   "FSB_SHUB_DQE"                 => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-AFI Queue Error Overflow" ],
   "SHUB_FSB_DQE"                 => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-AFI Queue Error Overflow" ],
   "XN_RP_Q_OFLOW"                => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: XN-to-PI Reply Queue Overflow Error" ],
   "XN_RQ_Q_OFLOW"                => [  13,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: XN-to-PI Request Queue Overflow Error" ],
   "MD_RP_Q_OFLOW"                => [  14,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI_HW_INT: MD-to-PI Reply Queue Overflow Error" ],
   "MD_RQ_Q_OFLOW"                => [  15,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI_HW_INT: MD-to-PI Request Queue Overflow Error" ],
   "MSG_LENGTH"                   => [  16,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Message Length Error Overflow" ],
   "MSG_COLOR_ERR"                => [  17,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Message Color Error" ],
   "PIO_TO_ERR"                   => [  18,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PIO Time-out Error" ],
   "IRB_TO_ERR"                   => [  19,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "PI_HW_INT: IRB Memory Time-out Error" ],
   "WRB_TO_ERR"                   => [  20,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "PI_HW_INT: WRB Memory Time-out Error" ],
   "RRB_TO_ERR"                   => [  21,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "PI_HW_INT: RRB Memory Time-out Error" ],
   "PIO_RP_ERR"                   => [  22,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PIO Reply Error" ],
   "MEM_RP_ERR"                   => [  23,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Memory Reply Error" ],
   "XB_PROTO_ERR"                 => [  24,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "PI_HW_INT: XB-pipe Protocol Error" ],
   "FSB_PROTO_ERR"                => [  25,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB-pipe Protocol Error" ],
);

%shub2_01_00807_def =
( NAME    => "SH2_PI_CRBP_FIRST_ERROR",
  ADDRESS => 0x0000000020060480,
  NOTE    => "The PI_CRBP_FIRST_ERROR register is somewhat misleading. The note function of the PI_CRBP_FIRST_ERROR register is to rearm the C",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00807_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_ERROR_DETAIL_1                                                #
#                                                                        #
##########################################################################

%shub2_01_00808_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATUS"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "PI Hardware Error Detail Status" ],
);

%shub2_01_00808_def =
( NAME    => "SH2_PI_ERROR_DETAIL_1",
  ADDRESS => 0x0000000020060500,
  NOTE    => "The PI_ERROR_DETAIL_1 register is part of the first error capture note circuitry for the PI chiplet. It captures detail error in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00808_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_ERROR_DETAIL_2                                                #
#                                                                        #
##########################################################################

%shub2_01_00809_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATUS"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "PI Hardware Error Detail Status" ],
);

%shub2_01_00809_def =
( NAME    => "SH2_PI_ERROR_DETAIL_2",
  ADDRESS => 0x0000000020060580,
  NOTE    => "The PI_ERROR_DETAIL_2 register is part of the first error capture note circuitry for the PI chiplet. It captures detail error in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00809_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_ERROR_OVERFLOW                                                #
#                                                                        #
##########################################################################

%shub2_01_00810_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  36,  28, 0xFFFFFFF000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FSB_BINIT_OCCURRED"           => [   1,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB BINIT Occurred Overflow" ],
   "FSB_TBL_MISS"                 => [   2,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB Table Miss Error Overflow" ],
   "BAD_SNOOP"                    => [   3,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB Snoop Error Overflow" ],
   "LIVELOCK"                     => [   4,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB Livelock Error Overflow" ],
   "ADDR_PARITY"                  => [   5,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Address Parity Error Overflow" ],
   "REQ_PARITY"                   => [   6,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Request Parity Error Overflow" ],
   "ADDR_ACCESS"                  => [   7,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Address Access Error Overflow" ],
   "REQ_FORMAT"                   => [   8,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Request Format Error Overflow" ],
   "IOQ_OVERRUN"                  => [   9,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: IOQ Overrun Error Overflow" ],
   "RSP_PARITY"                   => [  10,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Response Parity Error Overflow" ],
   "HUNG_BUS"                     => [  11,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Hung Bus Error Overflow" ],
   "SHUB_FSB_CE"                  => [  12,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "PI_CE_INT: SHub-to-FSB Correctable Data Error Overflow" ],
   "SHUB_FSB_UCE"                 => [  13,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "PI_UCE_INT: SHub-to-FSB Uncorrectable Data Error Overflow" ],
   "FSB_SHUB_CE"                  => [  14,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "PI_CE_INT: FSB-to-SHub Correctable Data Error Overflow" ],
   "FSB_SHUB_UCE"                 => [  15,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "PI_UCE_INT: FSB-to-SHub Uncorrectable Data Error Overflow" ],
   "XN_RP_CRD_OFLOW"              => [  16,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-XN Reply Credit Overflow Error Overflow" ],
   "XN_RQ_CRD_OFLOW"              => [  17,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-XN Request Credit Overflow Error Overflow" ],
   "MD_RP_CRD_OFLOW"              => [  18,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-MD Reply Credit Overflow Error Overflow" ],
   "MD_RQ_CRD_OFLOW"              => [  19,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-MD Request Credit Overflow Error Overflow" ],
   "NACK_OFLOW"                   => [  20,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: NACK Overflow Error Overflow" ],
   "FSB_SHUB_DQE"                 => [  21,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-AFI Queue Error Overflow" ],
   "SHUB_FSB_DQE"                 => [  22,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-AFI Queue Error Overflow" ],
   "XN_RP_Q_OFLOW"                => [  23,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: XN-to-PI Reply Queue Overflow Error Overflow" ],
   "XN_RQ_Q_OFLOW"                => [  24,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: XN-to-PI Request Queue Overflow Error Overflow" ],
   "MD_RP_Q_OFLOW"                => [  25,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI_HW_INT: MD-to-PI Reply Queue Overflow Error Overflow" ],
   "MD_RQ_Q_OFLOW"                => [  26,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI_HW_INT: MD-to-PI Request Queue Overflow Error Overflow" ],
   "MSG_LENGTH"                   => [  27,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Message Length Error Overflow" ],
   "MSG_COLOR_ERR"                => [  28,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Message Color Error Overflow" ],
   "PIO_TO_ERR"                   => [  29,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PIO Time-out Error Overflow" ],
   "IRB_TO_ERR"                   => [  30,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "PI_HW_INT: IRB Time-out Error Overflow" ],
   "WRB_TO_ERR"                   => [  31,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "PI_HW_INT: WRB Time-out Error Overflow" ],
   "RRB_TO_ERR"                   => [  32,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "PI_HW_INT: RRB Time-out Error Overflow" ],
   "PIO_RP_ERR"                   => [  33,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PIO Reply Error Overflow" ],
   "MEM_RP_ERR"                   => [  34,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Memory Reply Error Overflow" ],
   "XB_PROTO_ERR"                 => [  35,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "PI_HW_INT: XB-pipe Protocol Error Overflow" ],
   "FSB_PROTO_ERR"                => [  36,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB-pipe Protocol Error Overflow" ],
);

%shub2_01_00810_def =
( NAME    => "SH2_PI_ERROR_OVERFLOW",
  ADDRESS => 0x0000000020060600,
  NOTE    => "The PI_ERROR_OVERFLOW register contains 35 flags. Each flag note corresponds to 1 of the 35 errors or advisories detected by the",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00810_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_ERROR_OVERFLOW_ALIAS                                          #
#                                                                        #
##########################################################################

%shub2_01_00811_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  36,  28, 0xFFFFFFF000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FSB_BINIT_OCCURRED"           => [   1,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB BINIT Occurred Overflow" ],
   "FSB_TBL_MISS"                 => [   2,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB Table Miss Error Overflow" ],
   "BAD_SNOOP"                    => [   3,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB Snoop Error Overflow" ],
   "LIVELOCK"                     => [   4,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB Livelock Error Overflow" ],
   "ADDR_PARITY"                  => [   5,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Address Parity Error Overflow" ],
   "REQ_PARITY"                   => [   6,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Request Parity Error Overflow" ],
   "ADDR_ACCESS"                  => [   7,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Address Access Error Overflow" ],
   "REQ_FORMAT"                   => [   8,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Request Format Error Overflow" ],
   "IOQ_OVERRUN"                  => [   9,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: IOQ Overrun Error Overflow" ],
   "RSP_PARITY"                   => [  10,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Response Parity Error Overflow" ],
   "HUNG_BUS"                     => [  11,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Hung Bus Error Overflow" ],
   "SHUB_FSB_CE"                  => [  12,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "PI_CE_INT: SHub-to-FSB Correctable Data Error Overflow" ],
   "SHUB_FSB_UCE"                 => [  13,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "PI_UCE_INT: SHub-to-FSB Uncorrectable Data Error Overflow" ],
   "FSB_SHUB_CE"                  => [  14,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "PI_CE_INT: FSB-to-SHub Correctable Data Error Overflow" ],
   "FSB_SHUB_UCE"                 => [  15,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "PI_UCE_INT: FSB-to-SHub Uncorrectable Data Error Overflow" ],
   "XN_RP_CRD_OFLOW"              => [  16,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-XN Reply Credit Overflow Error Overflow" ],
   "XN_RQ_CRD_OFLOW"              => [  17,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-XN Request Credit Overflow Error Overflow" ],
   "MD_RP_CRD_OFLOW"              => [  18,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-MD Reply Credit Overflow Error Overflow" ],
   "MD_RQ_CRD_OFLOW"              => [  19,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-MD Request Credit Overflow Error Overflow" ],
   "NACK_OFLOW"                   => [  20,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: NACK Overflow Error Overflow" ],
   "FSB_SHUB_DQE"                 => [  21,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-AFI Queue Error Overflow" ],
   "SHUB_FSB_DQE"                 => [  22,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-AFI Queue Error Overflow" ],
   "XN_RP_Q_OFLOW"                => [  23,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: XN-to-PI Reply Queue Overflow Error Overflow" ],
   "XN_RQ_Q_OFLOW"                => [  24,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: XN-to-PI Request Queue Overflow Error Overflow" ],
   "MD_RP_Q_OFLOW"                => [  25,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI_HW_INT: MD-to-PI Reply Queue Overflow Error Overflow" ],
   "MD_RQ_Q_OFLOW"                => [  26,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI_HW_INT: MD-to-PI Request Queue Overflow Error Overflow" ],
   "MSG_LENGTH"                   => [  27,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Message Length Error Overflow" ],
   "MSG_COLOR_ERR"                => [  28,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Message Color Error Overflow" ],
   "PIO_TO_ERR"                   => [  29,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PIO Time-out Error Overflow" ],
   "IRB_TO_ERR"                   => [  30,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "PI_HW_INT: IRB Time-out Error Overflow" ],
   "WRB_TO_ERR"                   => [  31,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "PI_HW_INT: WRB Time-out Error Overflow" ],
   "RRB_TO_ERR"                   => [  32,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "PI_HW_INT: RRB Time-out Error Overflow" ],
   "PIO_RP_ERR"                   => [  33,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PIO Reply Error Overflow" ],
   "MEM_RP_ERR"                   => [  34,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Memory Reply Error Overflow" ],
   "XB_PROTO_ERR"                 => [  35,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "PI_HW_INT: XB-pipe Protocol Error Overflow" ],
   "FSB_PROTO_ERR"                => [  36,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB-pipe Protocol Error Overflow" ],
);

%shub2_01_00811_def =
( NAME    => "SH2_PI_ERROR_OVERFLOW_ALIAS",
  ADDRESS => 0x0000000020060608,
  NOTE    => "The PI_ERROR_OVERFLOW_ALIAS address is an alias to the note PI_ERROR_OVERFLOW register. Refer to the PI_ERROR_OVERFLOW register ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00811_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_ERROR_SUMMARY                                                 #
#                                                                        #
##########################################################################

%shub2_01_00812_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  36,  28, 0xFFFFFFF000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FSB_BINIT_OCCURRED"           => [   1,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB BINIT Occured" ],
   "FSB_TBL_MISS"                 => [   2,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB Table Miss Error" ],
   "BAD_SNOOP"                    => [   3,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB Snoop Error" ],
   "LIVELOCK"                     => [   4,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB Live-lock Error" ],
   "ADDR_PARITY"                  => [   5,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Address Parity Error" ],
   "REQ_PARITY"                   => [   6,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Request Parity Error" ],
   "ADDR_ACCESS"                  => [   7,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Address Access Error" ],
   "REQ_FORMAT"                   => [   8,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Request Format Error" ],
   "IOQ_OVERRUN"                  => [   9,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: IOQ Overrun Error" ],
   "RSP_PARITY"                   => [  10,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Response Parity Error" ],
   "HUNG_BUS"                     => [  11,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Hung Bus Error" ],
   "SHUB_FSB_CE"                  => [  12,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "PI_CE_INT: SHub-to-FSB Correctable Data Error" ],
   "SHUB_FSB_UCE"                 => [  13,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "PI_UCE_INT: SHub-to-FSB Uncorrectable Data Error" ],
   "FSB_SHUB_CE"                  => [  14,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "PI_CE_INT: FSB-to-SHub Correctable Data Error" ],
   "FSB_SHUB_UCE"                 => [  15,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "PI_UCE_INT: FSB-to-SHub Uncorrectable Data Error" ],
   "XN_RP_CRD_OFLOW"              => [  16,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-XN Reply Credit Overflow Error" ],
   "XN_RQ_CRD_OFLOW"              => [  17,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-XN Request Credit Overflow Error" ],
   "MD_RP_CRD_OFLOW"              => [  18,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-MD Reply Credit Overflow Error" ],
   "MD_RQ_CRD_OFLOW"              => [  19,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-MD Request Credit Overflow Error" ],
   "NACK_OFLOW"                   => [  20,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: NACK Overflow Error" ],
   "FSB_SHUB_DQE"                 => [  21,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-WDAT Queue Error" ],
   "SHUB_FSB_DQE"                 => [  22,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-RDAT Queue Error" ],
   "XN_RP_Q_OFLOW"                => [  23,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: XN-to-PI Reply Queue Overflow Error" ],
   "XN_RQ_Q_OFLOW"                => [  24,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: XN-to-PI Request Queue Overflow Error" ],
   "MD_RP_Q_OFLOW"                => [  25,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI_HW_INT: MD-to-PI Reply Queue Overflow Error" ],
   "MD_RQ_Q_OFLOW"                => [  26,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI_HW_INT: MD-to-PI Request Queue Overflow Error" ],
   "MSG_LENGTH"                   => [  27,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Message Length Error" ],
   "MSG_COLOR_ERR"                => [  28,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Message Color Error" ],
   "PIO_TO_ERR"                   => [  29,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PIO Time-out Error" ],
   "IRB_TO_ERR"                   => [  30,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "PI_HW_INT: IRB Time-out Error" ],
   "WRB_TO_ERR"                   => [  31,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "PI_HW_INT: WRB Time-out Error" ],
   "RRB_TO_ERR"                   => [  32,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "PI_HW_INT: RRB Time-out Error" ],
   "PIO_RP_ERR"                   => [  33,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PIO Reply Error" ],
   "MEM_RP_ERR"                   => [  34,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Memory Reply Error" ],
   "XB_PROTO_ERR"                 => [  35,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "PI_HW_INT: XB-pipe Protocol Error" ],
   "FSB_PROTO_ERR"                => [  36,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB-pipe Protocol Error" ],
);

%shub2_01_00812_def =
( NAME    => "SH2_PI_ERROR_SUMMARY",
  ADDRESS => 0x0000000020060680,
  NOTE    => "The PI_ERROR_SUMMARY register is the PI's top-level error flag note register. It contains 35 flags. Each flag corresponds to one",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00812_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_ERROR_SUMMARY_ALIAS                                           #
#                                                                        #
##########################################################################

%shub2_01_00813_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  36,  28, 0xFFFFFFF000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FSB_BINIT_OCCURRED"           => [   1,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB BINIT Occured" ],
   "FSB_TBL_MISS"                 => [   2,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB Table Miss Error" ],
   "BAD_SNOOP"                    => [   3,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB Snoop Error" ],
   "LIVELOCK"                     => [   4,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB Live-lock Error" ],
   "ADDR_PARITY"                  => [   5,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Address Parity Error" ],
   "REQ_PARITY"                   => [   6,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Request Parity Error" ],
   "ADDR_ACCESS"                  => [   7,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Address Access Error" ],
   "REQ_FORMAT"                   => [   8,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Request Format Error" ],
   "IOQ_OVERRUN"                  => [   9,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: IOQ Overrun Error" ],
   "RSP_PARITY"                   => [  10,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Response Parity Error" ],
   "HUNG_BUS"                     => [  11,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Hung Bus Error" ],
   "SHUB_FSB_CE"                  => [  12,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "PI_CE_INT: SHub-to-FSB Correctable Data Error" ],
   "SHUB_FSB_UCE"                 => [  13,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "PI_UCE_INT: SHub-to-FSB Uncorrectable Data Error" ],
   "FSB_SHUB_CE"                  => [  14,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "PI_CE_INT: FSB-to-SHub Correctable Data Error" ],
   "FSB_SHUB_UCE"                 => [  15,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "PI_UCE_INT: FSB-to-SHub Uncorrectable Data Error" ],
   "XN_RP_CRD_OFLOW"              => [  16,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-XN Reply Credit Overflow Error" ],
   "XN_RQ_CRD_OFLOW"              => [  17,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-XN Request Credit Overflow Error" ],
   "MD_RP_CRD_OFLOW"              => [  18,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-MD Reply Credit Overflow Error" ],
   "MD_RQ_CRD_OFLOW"              => [  19,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-MD Request Credit Overflow Error" ],
   "NACK_OFLOW"                   => [  20,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: NACK Overflow Error" ],
   "FSB_SHUB_DQE"                 => [  21,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-WDAT Queue Error" ],
   "SHUB_FSB_DQE"                 => [  22,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-RDAT Queue Error" ],
   "XN_RP_Q_OFLOW"                => [  23,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: XN-to-PI Reply Queue Overflow Error" ],
   "XN_RQ_Q_OFLOW"                => [  24,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: XN-to-PI Request Queue Overflow Error" ],
   "MD_RP_Q_OFLOW"                => [  25,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI_HW_INT: MD-to-PI Reply Queue Overflow Error" ],
   "MD_RQ_Q_OFLOW"                => [  26,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI_HW_INT: MD-to-PI Request Queue Overflow Error" ],
   "MSG_LENGTH"                   => [  27,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Message Length Error" ],
   "MSG_COLOR_ERR"                => [  28,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Message Color Error" ],
   "PIO_TO_ERR"                   => [  29,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PIO Time-out Error" ],
   "IRB_TO_ERR"                   => [  30,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "PI_HW_INT: IRB Time-out Error" ],
   "WRB_TO_ERR"                   => [  31,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "PI_HW_INT: WRB Time-out Error" ],
   "RRB_TO_ERR"                   => [  32,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "PI_HW_INT: RRB Time-out Error" ],
   "PIO_RP_ERR"                   => [  33,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PIO Reply Error" ],
   "MEM_RP_ERR"                   => [  34,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Memory Reply Error" ],
   "XB_PROTO_ERR"                 => [  35,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "PI_HW_INT: XB-pipe Protocol Error" ],
   "FSB_PROTO_ERR"                => [  36,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB-pipe Protocol Error" ],
);

%shub2_01_00813_def =
( NAME    => "SH2_PI_ERROR_SUMMARY_ALIAS",
  ADDRESS => 0x0000000020060688,
  NOTE    => "The PI_ERROR_SUMMARY_ALIAS address is an alias to the note PI_ERROR_SUMMARY register. Refer to the PI_ERROR_SUMMARY register not",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00813_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_FIRST_ERROR                                                   #
#                                                                        #
##########################################################################

%shub2_01_00814_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  36,  28, 0xFFFFFFF000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FSB_BINIT_OCCURRED"           => [   1,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB BINIT Occured Error" ],
   "FSB_TBL_MISS"                 => [   2,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB Table Miss Error" ],
   "BAD_SNOOP"                    => [   3,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB Snoop Error" ],
   "LIVELOCK"                     => [   4,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB Livelock Error" ],
   "ADDR_PARITY"                  => [   5,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Address Parity Error" ],
   "REQ_PARITY"                   => [   6,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Request Parity Error" ],
   "ADDR_ACCESS"                  => [   7,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Address Access Error" ],
   "REQ_FORMAT"                   => [   8,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Request Format Error" ],
   "IOQ_OVERRUN"                  => [   9,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: IOQ Overrun Error" ],
   "RSP_PARITY"                   => [  10,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Response Parity Error" ],
   "HUNG_BUS"                     => [  11,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Hung Bus Error" ],
   "SHUB_FSB_CE"                  => [  12,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "PI_CE_INT: SHub-to-FSB Correctable Data Error" ],
   "SHUB_FSB_UCE"                 => [  13,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "PI_UCE_INT: SHub-to-FSB Uncorrectable Data Error" ],
   "FSB_SHUB_CE"                  => [  14,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "PI_CE_INT: FSB-to-SHub Correctable Data Error" ],
   "FSB_SHUB_UCE"                 => [  15,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "PI_UCE_INT: FSB-to-SHub Uncorrectable Data Error" ],
   "XN_RP_CRD_OFLOW"              => [  16,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-XN Reply Credit Overflow Error" ],
   "XN_RQ_CRD_OFLOW"              => [  17,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-XN Request Credit Overflow Error" ],
   "MD_RP_CRD_OFLOW"              => [  18,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-MD Reply Credit Overflow Error" ],
   "MD_RQ_CRD_OFLOW"              => [  19,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-MD Request Credit Overflow Error" ],
   "NACK_OFLOW"                   => [  20,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: NACK Overflow Error" ],
   "FSB_SHUB_DQE"                 => [  21,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-AFI Queue Error" ],
   "SHUB_FSB_DQE"                 => [  22,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-AFI Queue Error" ],
   "XN_RP_Q_OFLOW"                => [  23,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: XN-to-PI Reply Queue Overflow Error" ],
   "XN_RQ_Q_OFLOW"                => [  24,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: XN-to-PI Request Queue Overflow Error" ],
   "MD_RP_Q_OFLOW"                => [  25,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI_HW_INT: MD-to-PI Reply Queue Overflow Error" ],
   "MD_RQ_Q_OFLOW"                => [  26,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI_HW_INT: MD-to-PI Request Queue Overflow Error" ],
   "MSG_LENGTH"                   => [  27,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Message Length Error" ],
   "MSG_COLOR_ERR"                => [  28,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Message Color Error" ],
   "PIO_TO_ERR"                   => [  29,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PIO Time-out Error" ],
   "IRB_TO_ERR"                   => [  30,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "PI_HW_INT: IRB Time-out Error" ],
   "WRB_TO_ERR"                   => [  31,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "PI_HW_INT: WRB Time-out Error" ],
   "RRB_TO_ERR"                   => [  32,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "PI_HW_INT: RRB Time-out Error" ],
   "PIO_RP_ERR"                   => [  33,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PIO Reply Error" ],
   "MEM_RP_ERR"                   => [  34,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Memory Reply Error" ],
   "XB_PROTO_ERR"                 => [  35,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "PI_HW_INT: XB-pipe Protocol Error" ],
   "FSB_PROTO_ERR"                => [  36,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB-pipe Protocol Error" ],
);

%shub2_01_00814_def =
( NAME    => "SH2_PI_FIRST_ERROR",
  ADDRESS => 0x0000000020060780,
  NOTE    => "The PI_FIRST_ERROR register contains 35 flags. Each flag note corresponds to one of the 35 flags in the PI_ERROR_SUMMARY note re",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00814_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_FIRST_ERROR_ALIAS                                             #
#                                                                        #
##########################################################################

%shub2_01_00815_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  36,  28, 0xFFFFFFF000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FSB_BINIT_OCCURRED"           => [   1,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB BINIT Occured Error" ],
   "FSB_TBL_MISS"                 => [   2,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB Table Miss Error" ],
   "BAD_SNOOP"                    => [   3,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB Snoop Error" ],
   "LIVELOCK"                     => [   4,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB Livelock Error" ],
   "ADDR_PARITY"                  => [   5,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Address Parity Error" ],
   "REQ_PARITY"                   => [   6,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Request Parity Error" ],
   "ADDR_ACCESS"                  => [   7,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Address Access Error" ],
   "REQ_FORMAT"                   => [   8,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Request Format Error" ],
   "IOQ_OVERRUN"                  => [   9,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: IOQ Overrun Error" ],
   "RSP_PARITY"                   => [  10,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Response Parity Error" ],
   "HUNG_BUS"                     => [  11,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Hung Bus Error" ],
   "SHUB_FSB_CE"                  => [  12,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "PI_CE_INT: SHub-to-FSB Correctable Data Error" ],
   "SHUB_FSB_UCE"                 => [  13,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "PI_UCE_INT: SHub-to-FSB Uncorrectable Data Error" ],
   "FSB_SHUB_CE"                  => [  14,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "PI_CE_INT: FSB-to-SHub Correctable Data Error" ],
   "FSB_SHUB_UCE"                 => [  15,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "PI_UCE_INT: FSB-to-SHub Uncorrectable Data Error" ],
   "XN_RP_CRD_OFLOW"              => [  16,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-XN Reply Credit Overflow Error" ],
   "XN_RQ_CRD_OFLOW"              => [  17,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-XN Request Credit Overflow Error" ],
   "MD_RP_CRD_OFLOW"              => [  18,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-MD Reply Credit Overflow Error" ],
   "MD_RQ_CRD_OFLOW"              => [  19,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-MD Request Credit Overflow Error" ],
   "NACK_OFLOW"                   => [  20,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: NACK Overflow Error" ],
   "FSB_SHUB_DQE"                 => [  21,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-AFI Queue Error" ],
   "SHUB_FSB_DQE"                 => [  22,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-AFI Queue Error" ],
   "XN_RP_Q_OFLOW"                => [  23,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: XN-to-PI Reply Queue Overflow Error" ],
   "XN_RQ_Q_OFLOW"                => [  24,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: XN-to-PI Request Queue Overflow Error" ],
   "MD_RP_Q_OFLOW"                => [  25,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI_HW_INT: MD-to-PI Reply Queue Overflow Error" ],
   "MD_RQ_Q_OFLOW"                => [  26,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI_HW_INT: MD-to-PI Request Queue Overflow Error" ],
   "MSG_LENGTH"                   => [  27,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Message Length Error" ],
   "MSG_COLOR_ERR"                => [  28,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Message Color Error" ],
   "PIO_TO_ERR"                   => [  29,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PIO Time-out Error" ],
   "IRB_TO_ERR"                   => [  30,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "PI_HW_INT: IRB Time-out Error" ],
   "WRB_TO_ERR"                   => [  31,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "PI_HW_INT: WRB Time-out Error" ],
   "RRB_TO_ERR"                   => [  32,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "PI_HW_INT: RRB Time-out Error" ],
   "PIO_RP_ERR"                   => [  33,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PIO Reply Error" ],
   "MEM_RP_ERR"                   => [  34,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Memory Reply Error" ],
   "XB_PROTO_ERR"                 => [  35,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "PI_HW_INT: XB-pipe Protocol Error" ],
   "FSB_PROTO_ERR"                => [  36,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB-pipe Protocol Error" ],
);

%shub2_01_00815_def =
( NAME    => "SH2_PI_FIRST_ERROR_ALIAS",
  ADDRESS => 0x0000000020060788,
  NOTE    => "The PI_FIRST_ERROR_ALIAS address is an alias to the PI_FIRST_ERROR note register. Refer to the PI_FIRST_ERROR register descripti",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00815_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_PI2MD_REPLY_VC_STATUS                                         #
#                                                                        #
##########################################################################

%shub2_01_00816_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  14,  50, 0xFFFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CURRENT_CRD_STAT"             => [   1,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "Unconsumed PI-to-MD Reply VC Credits" ],
   "RSVD1"                        => [   2,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CAPTURED_CRD_STAT"            => [   3,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "Captured Unconsumed PI-to-MD Reply VC Credits" ],
);

%shub2_01_00816_def =
( NAME    => "SH2_PI_PI2MD_REPLY_VC_STATUS",
  ADDRESS => 0x0000000020060900,
  NOTE    => "The PI_PI2MD_REPLY_VC_STATUS register stores status information note pertaining to the Reply VC of the PI's PI-to-MD instance of",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00816_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_PI2MD_REQUEST_VC_STATUS                                       #
#                                                                        #
##########################################################################

%shub2_01_00817_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  14,  50, 0xFFFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CURRENT_CRD_STAT"             => [   1,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "Unconsumed PI-to-MD Request VC Credits" ],
   "RSVD1"                        => [   2,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CAPTURED_CRD_STAT"            => [   3,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "Captured Unconsumed PI-to-MD Request VC Credits" ],
);

%shub2_01_00817_def =
( NAME    => "SH2_PI_PI2MD_REQUEST_VC_STATUS",
  ADDRESS => 0x0000000020060980,
  NOTE    => "The PI_PI2MD_REQUEST_VC_STATUS register stores status information note pertaining to the Request VC of the PI's PI-to-MD instanc",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00817_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_PI2XN_REPLY_VC_STATUS                                         #
#                                                                        #
##########################################################################

%shub2_01_00818_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  14,  50, 0xFFFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CURRENT_CRD_STAT"             => [   1,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "Unconsumed PI-to-XN Reply VC Credits" ],
   "RSVD1"                        => [   2,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CAPTURED_CRD_STAT"            => [   3,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "Captured Unconsumed PI-to-XN Reply VC Credits" ],
);

%shub2_01_00818_def =
( NAME    => "SH2_PI_PI2XN_REPLY_VC_STATUS",
  ADDRESS => 0x0000000020060a00,
  NOTE    => "The PI_PI2XN_REPLY_VC_STATUS register stores status information note pertaining to the Reply VC of the PI's PI-to-XN instance of",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00818_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_PI2XN_REQUEST_VC_STATUS                                       #
#                                                                        #
##########################################################################

%shub2_01_00819_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  14,  50, 0xFFFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CURRENT_CRD_STAT"             => [   1,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "Unconsumed PI-to-XN Request VC Credits" ],
   "RSVD1"                        => [   2,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CAPTURED_CRD_STAT"            => [   3,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "Unconsumed PI-to-XN Request VC Credits" ],
);

%shub2_01_00819_def =
( NAME    => "SH2_PI_PI2XN_REQUEST_VC_STATUS",
  ADDRESS => 0x0000000020060a80,
  NOTE    => "The PI_PI2XN_REQUEST_VC_STATUS register stores status information note pertaining to the Request VC of the PI's PI-to-XN instanc",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00819_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_UNCORRECTED_DETAIL_1                                          #
#                                                                        #
##########################################################################

%shub2_01_00820_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DEP"                          => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Data-ECC-Protection Bits of the First Failing Doubleword" ],
   "SYNDROME"                     => [   1,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "Syndrome of the First Failing Doubleword" ],
   "ADDRESS"                      => [   2,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Physical Address of the First Failing Doubleword" ],
);

%shub2_01_00820_def =
( NAME    => "SH2_PI_UNCORRECTED_DETAIL_1",
  ADDRESS => 0x0000000020060b00,
  NOTE    => "The PI_UNCORRECTED_DETAIL_1 register captures detail SHUB_FSB_UCE note error information when the first SHUB_FSB_UCE error is de",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00820_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_UNCORRECTED_DETAIL_2                                          #
#                                                                        #
##########################################################################

%shub2_01_00821_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Failing Doubleword Value" ],
);

%shub2_01_00821_def =
( NAME    => "SH2_PI_UNCORRECTED_DETAIL_2",
  ADDRESS => 0x0000000020060b80,
  NOTE    => "The PI_UNCORRECTED_DETAIL_2 register captures detail SHUB_FSB_UCE note error information when the first SHUB_FSB_UCE error is de",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00821_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_UNCORRECTED_DETAIL_3                                          #
#                                                                        #
##########################################################################

%shub2_01_00822_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  10,  54, 0xFFFFFFFFFFFFFC00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DID"                          => [   1,   0,  10, 0x00000000000003FF, 0x00, 0, 0x0000000000000000, "Deferred ID" ],
);

%shub2_01_00822_def =
( NAME    => "SH2_PI_UNCORRECTED_DETAIL_3",
  ADDRESS => 0x0000000020060b88,
  NOTE    => "The PI_UNCORRECTED_DETAIL_3 register captures detail SHUB_FSB_UCE note error information when the first SHUB_FSB_UCE error is de",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00822_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_UNCORRECTED_DETAIL_4                                          #
#                                                                        #
##########################################################################

%shub2_01_00823_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DEP"                          => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Data-ECC-Proctection Bits of the First Failing Doubleword" ],
   "SYNDROME"                     => [   1,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "Syndrome of the First Failing Doubleword" ],
   "ADDRESS"                      => [   2,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Physical Address of the First Failing Doubleword" ],
);

%shub2_01_00823_def =
( NAME    => "SH2_PI_UNCORRECTED_DETAIL_4",
  ADDRESS => 0x0000000020060c00,
  NOTE    => "The PI_UNCORRECTED_DETAIL_4 register captures detail FSB_SHUB_UCE note error information when the first FSB_SHUB_UCE error is de",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00823_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_UNCORRECTED_DETAIL_5                                          #
#                                                                        #
##########################################################################

%shub2_01_00824_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Failing Doubleword Value" ],
);

%shub2_01_00824_def =
( NAME    => "SH2_PI_UNCORRECTED_DETAIL_5",
  ADDRESS => 0x0000000020060c80,
  NOTE    => "The PI_UNCORRECTED_DETAIL_5 register captures detail FSB_SHUB_UCE note error information when the first FSB_SHUB_UCE error is de",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00824_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_UNCORRECTED_DETAIL_6                                          #
#                                                                        #
##########################################################################

%shub2_01_00825_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   2,  62, 0xFFFFFFFFFFFFFFFC, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "THREAD"                       => [   1,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Failing CPU thread" ],
   "CPU"                          => [   2,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Failing CPU" ],
);

%shub2_01_00825_def =
( NAME    => "SH2_PI_UNCORRECTED_DETAIL_6",
  ADDRESS => 0x0000000020060c88,
  NOTE    => "The PI_UNCORRECTED_DETAIL_6 register captures detail FSB_SHUB_UCE note error information when the first FSB_SHUB_UCE error is de",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00825_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_MD2PI_REPLY_VC_STATUS                                         #
#                                                                        #
##########################################################################

%shub2_01_00826_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  12,  52, 0xFFFFFFFFFFFFF000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INPUT_QUEUE_STAT"             => [   1,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Consumed MD-to-PI Reply VC Credits" ],
   "INPUT_DAT_CRD_STAT"           => [   2,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Unconsumed MD-to-PI Reply VC Credits for Data-bearing Messages" ],
   "INPUT_HDR_CRD_STAT"           => [   3,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Unconsumed MD-to-PI Reply VC Credits" ],
);

%shub2_01_00826_def =
( NAME    => "SH2_PI_MD2PI_REPLY_VC_STATUS",
  ADDRESS => 0x0000000020060800,
  NOTE    => "The PI_MD2PI_REPLY_VC_STATUS register stores status information note pertaining to the Reply VC of the MD-to-PI instance of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00826_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_MD2PI_REQUEST_VC_STATUS                                       #
#                                                                        #
##########################################################################

%shub2_01_00827_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  12,  52, 0xFFFFFFFFFFFFF000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INPUT_QUEUE_STAT"             => [   1,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Consumed MD-to-PI Request VC Credits" ],
   "INPUT_DAT_CRD_STAT"           => [   2,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Unconsumed MD-to-PI Request VC Credits for Data-bearing Messages" ],
   "INPUT_HDR_CRD_STAT"           => [   3,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Unconsumed MD-to-PI Request VC Credits" ],
);

%shub2_01_00827_def =
( NAME    => "SH2_PI_MD2PI_REQUEST_VC_STATUS",
  ADDRESS => 0x0000000020060880,
  NOTE    => "The PI_MD2PI_REQUEST_VC_STATUS register stores status information note pertaining to the Request VC of the MD-to-PI instance of ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00827_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_WDAT_REPLAY_COUNT                                             #
#                                                                        #
##########################################################################

%shub2_01_00828_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW"                     => [   1,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Replay Counter Overflow" ],
   "VALUE"                        => [   2,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Replay Counter Value" ],
);

%shub2_01_00828_def =
( NAME    => "SH2_PI_WDAT_REPLAY_COUNT",
  ADDRESS => 0x0000000020060e00,
  NOTE    => "The PI_WDAT_REPLAY_COUNT register allows the programmer to monitor note the number of Uncorrectable Data Error Replays which hav",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00828_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_XN2PI_REPLY_VC_STATUS                                         #
#                                                                        #
##########################################################################

%shub2_01_00829_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  12,  52, 0xFFFFFFFFFFFFF000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INPUT_QUEUE_STAT"             => [   1,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Consumed XN-to-PI Reply VC Credits" ],
   "INPUT_DAT_CRD_STAT"           => [   2,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Unconsumed XN-to-PI Reply VC Credits for Data-bearing Messages" ],
   "INPUT_HDR_CRD_STAT"           => [   3,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Unconsumed XN-to-PI Reply VC Credits" ],
);

%shub2_01_00829_def =
( NAME    => "SH2_PI_XN2PI_REPLY_VC_STATUS",
  ADDRESS => 0x0000000020060d00,
  NOTE    => "The PI_XN2PI_REPLY_VC_STATUS register stores status information note pertaining to the Reply VC of the XN-to-PI instance of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00829_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_XN2PI_REQUEST_VC_STATUS                                       #
#                                                                        #
##########################################################################

%shub2_01_00830_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ICC_UNDERFLOW"                => [   1,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "Underflow condition detected with Intervention Credit Counter" ],
   "ICC_OVERFLOW"                 => [   2,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "Overflow condition detected with Intervention Credit Counter" ],
   "ICC_STATUS"                   => [   3,  32,   4, 0x0000000F00000000, 0x00, 0, 0x0000000000000000, "Current Intervention Credit Counter value" ],
   "RSVD1"                        => [   4,  12,  20, 0x00000000FFFFF000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INPUT_QUEUE_STAT"             => [   5,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Consumed XN-to-PI Request VC Credits" ],
   "INPUT_DAT_CRD_STAT"           => [   6,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Unconsumed XN-to-PI Request VC Credits for Data-bearing Messages" ],
   "INPUT_HDR_CRD_STAT"           => [   7,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Unconsumed XN-to-PI Request VC Credits" ],
);

%shub2_01_00830_def =
( NAME    => "SH2_PI_XN2PI_REQUEST_VC_STATUS",
  ADDRESS => 0x0000000020060d80,
  NOTE    => "The PI_XN2PI_REQUEST_VC_STATUS register stores status information note pertaining to the Request VC of the XN-to-PI instance of ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00830_flds
);


##########################################################################
#                                                                        #
#   SH2_CRB_MESSAGE_CONTROL                                              #
#                                                                        #
##########################################################################

%shub2_01_00831_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SYSTEM_FLUSH_DURATION"        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 1, 0x0000000000000000, "Flush Duration Controls" ],
   "SYSTEM_FLUSH_INTERVAL"        => [   1,  32,  16, 0x0000FFFF00000000, 0x00, 1, 0x0000000000000000, "Flush Interval Controls" ],
   "RSVD0"                        => [   2,  25,   7, 0x00000000FE000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_FORCE_GETF"            => [   3,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Enable Force GETF" ],
   "FUN"                          => [   4,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Fun Scratch Bits" ],
   "RSVD1"                        => [   5,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_FSB_NACK_HAMMER"       => [   6,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Enable XB Pipe NACK Hammer" ],
   "ENABLE_XB_PIPE_NACK_HAMMER"   => [   7,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Enable XB Pipe NACK Hammer" ],
   "ENABLE_PIPE_SNOOP_ERRORS"     => [   8,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Enable FSB Pipe Snoop Errors" ],
   "RSVD2"                        => [   9,   5,   7, 0x0000000000000FE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MESSAGE_COLOR_ENABLE"         => [  10,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Enable color message processing" ],
   "MESSAGE_COLOR"                => [  11,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Define color of message" ],
   "REMOTE_SPECULATIVE_MESSAGE_ENABLE" => [  12,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Speculative Read Requests to Remote Memory Enabled" ],
   "LOCAL_SPECULATIVE_MESSAGE_ENABLE" => [  13,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Speculative Read Requests to Local Memory Enabled" ],
   "SYSTEM_COHERENCE_ENABLE"      => [  14,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "System Coherence Enabled" ],
);

%shub2_01_00831_def =
( NAME    => "SH2_CRB_MESSAGE_CONTROL",
  ADDRESS => 0x0000000020000000,
  NOTE    => "The CRB_MESSAGE_CONTROL register determines the types of messages note generated by the SHub. It enables/disables system coheren",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00831_flds
);


##########################################################################
#                                                                        #
#   SH2_CRB_NACK_LIMIT                                                   #
#                                                                        #
##########################################################################

%shub2_01_00832_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Enable NACK Limit Detection" ],
   "RSVD0"                        => [   1,  20,  43, 0x7FFFFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRI_FREQ"                     => [   2,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "Memory Priority Increment Frequency" ],
   "RSVD1"                        => [   3,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LIMIT"                        => [   4,   0,  15, 0x0000000000007FFF, 0x00, 1, 0x0000000000000000, "NACK Count Limit" ],
);

%shub2_01_00832_def =
( NAME    => "SH2_CRB_NACK_LIMIT",
  ADDRESS => 0x0000000020000080,
  NOTE    => "The CRB_NACK_LIMIT register controls the NACK limit (i.e., the note permissible number of consecutive NACKs) for each RRB entry.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00832_flds
);


##########################################################################
#                                                                        #
#   SH2_CRB_TIMEOUT_PRESCALE                                             #
#                                                                        #
##########################################################################

%shub2_01_00833_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCALING_FACTOR"               => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "CRB Time-out Scaling Factor" ],
);

%shub2_01_00833_def =
( NAME    => "SH2_CRB_TIMEOUT_PRESCALE",
  ADDRESS => 0x0000000020000100,
  NOTE    => "The CRB_TIMEOUT_PRESCALE register controls frequency at which the note RRB Time-out Counters increment.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00833_flds
);


##########################################################################
#                                                                        #
#   SH2_CRB_TIMEOUT_SKID                                                 #
#                                                                        #
##########################################################################

%shub2_01_00834_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RESET_SKID_COUNT"             => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reset Skid Counter" ],
   "INCREMENT_ICC"                => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Increment Intervention Credit Count by One" ],
   "DECREMENT_ICC"                => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "Decrement Intervention Credit Count by One" ],
   "RSVD0"                        => [   3,  38,  23, 0x1FFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SKID_COUNT"                   => [   4,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "Current value of the skid counter" ],
   "RSVD1"                        => [   5,  12,  20, 0x00000000FFFFF000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_TIMEOUT_ENABLE"           => [   6,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "Enable PRB Timeouts" ],
   "IRB_TIMEOUT_ENABLE"           => [   7,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "Enable IRB Timeouts" ],
   "WRB_TIMEOUT_ENABLE"           => [   8,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Enable WRB Timeouts" ],
   "RRB_TIMEOUT_ENABLE"           => [   9,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Enable RRB Timeouts" ],
   "RSVD2"                        => [  10,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SKID"                         => [  11,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "CRB Time-out Skid" ],
);

%shub2_01_00834_def =
( NAME    => "SH2_CRB_TIMEOUT_SKID",
  ADDRESS => 0x0000000020000180,
  NOTE    => "The CRB_TIMEOUT_SKID register provides several configuration and note recovery features pertaining to CRB time-outs mechanisms.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00834_flds
);


##########################################################################
#                                                                        #
#   SH2_NI0_LLP_STAT                                                     #
#                                                                        #
##########################################################################

%shub2_01_00835_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   4,  60, 0xFFFFFFFFFFFFFFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LINK_RESET_STATE"             => [   1,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Status of LLP link." ],
);

%shub2_01_00835_def =
( NAME    => "SH2_NI0_LLP_STAT",
  ADDRESS => 0x0000000050000000,
  NOTE    => "This register describes the LLP status.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00835_flds
);


##########################################################################
#                                                                        #
#   SH2_NI0_LLP_RESET                                                    #
#                                                                        #
##########################################################################

%shub2_01_00836_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   2,  62, 0xFFFFFFFFFFFFFFFC, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WARM"                         => [   1,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Send Warm Reset. Generates a pulse." ],
   "LINK"                         => [   2,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Send Link Reset. Generates a pulse." ],
);

%shub2_01_00836_def =
( NAME    => "SH2_NI0_LLP_RESET",
  ADDRESS => 0x0000000050000008,
  NOTE    => "Writing issues a reset to the network interface",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00836_flds
);


##########################################################################
#                                                                        #
#   SH2_NI0_LLP_RESET_EN                                                 #
#                                                                        #
##########################################################################

%shub2_01_00837_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OK"                           => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Allow LLP warm reset to reset SHUB2 core" ],
);

%shub2_01_00837_def =
( NAME    => "SH2_NI0_LLP_RESET_EN",
  ADDRESS => 0x0000000050000010,
  NOTE    => "Controls LLP warm reset propagation",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00837_flds
);


##########################################################################
#                                                                        #
#   SH2_NI0_LLP_CHAN_MODE                                                #
#                                                                        #
##########################################################################

%shub2_01_00838_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   6,  58, 0xFFFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_LINK"                  => [   1,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Enables link." ],
   "ENABLE_CLKQUAD"               => [   2,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Reserved for future use. Terminated at dest." ],
   "ENABLE_RMT_FT_UPD"            => [   3,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Enables remote fine tune updates" ],
   "ENABLE_TUNING"                => [   4,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Enables automatic tuning of channel skew." ],
   "AC_ENCODE"                    => [   5,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Enables nearly dc-free encoding for AC-coupling" ],
   "BITMODE32"                    => [   6,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Enables 32-bit (plus sideband) channel phits" ],
);

%shub2_01_00838_def =
( NAME    => "SH2_NI0_LLP_CHAN_MODE",
  ADDRESS => 0x0000000050000018,
  NOTE    => "Sets the signaling mode of LLP and channel",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00838_flds
);


##########################################################################
#                                                                        #
#   SH2_NI0_LLP_CONFIG                                                   #
#                                                                        #
##########################################################################

%shub2_01_00839_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_MAXRETRY"              => [   1,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Enables maxretry" ],
   "ENABLE_FTU_TIME"              => [   2,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "Enables fine tuning time" ],
   "ENABLE_NULLTIMEOUT"           => [   3,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "Enables nulltimeout" ],
   "ENABLE_MAXBURST"              => [   4,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "Enables maxburst" ],
   "MAXRETRY"                     => [   5,  40,  16, 0x00FFFF0000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   6,  38,   2, 0x000000C000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FTU_TIME"                     => [   7,  26,  12, 0x0000003FFC000000, 0x00, 0, 0x0000000000000000, "" ],
   "NULLTIMEOUT"                  => [   8,  20,   6, 0x0000000003F00000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD2"                        => [   9,  10,  10, 0x00000000000FFC00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAXBURST"                     => [  10,   0,  10, 0x00000000000003FF, 0x00, 0, 0x0000000000000000, "" ],
);

%shub2_01_00839_def =
( NAME    => "SH2_NI0_LLP_CONFIG",
  ADDRESS => 0x0000000050000020,
  NOTE    => "Sets the configuration of LLP and channel",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00839_flds
);


##########################################################################
#                                                                        #
#   SH2_NI0_LLP_TEST_CTL                                                 #
#                                                                        #
##########################################################################

%shub2_01_00840_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CBERROR"                      => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Captured Micropacket Contained a CRC Error" ],
   "CAPTURED"                     => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "Micropacket Captured" ],
   "FAKESNERROR"                  => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "Inject a Sequence Number Error at the Receiver" ],
   "SENDSNERROR"                  => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Sends a single sequence number error" ],
   "SENDCBERROR"                  => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "Sends a single error" ],
   "CAPTURECBONLY"                => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "Only capture a micropacket with a Check Byte error" ],
   "ARMCAPTURE"                   => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "Enable Capture of Next MicroPacket" ],
   "NOISE_MODE"                   => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "LFSR_MODE"                    => [   9,  52,   2, 0x0030000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [  10,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WIRE_SEL"                     => [  11,  44,   6, 0x0003F00000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD2"                        => [  12,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_TEST_MODE"               => [  13,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "Send Test Mode" ],
   "PATTERN"                      => [  14,   0,  40, 0x000000FFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Send channel data pattern" ],
);

%shub2_01_00840_def =
( NAME    => "SH2_NI0_LLP_TEST_CTL",
  ADDRESS => 0x0000000050000028,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00840_flds
);


##########################################################################
#                                                                        #
#   SH2_NI0_LLP_CAPT_WD1                                                 #
#                                                                        #
##########################################################################

%shub2_01_00841_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "low order 64-bit captured word" ],
);

%shub2_01_00841_def =
( NAME    => "SH2_NI0_LLP_CAPT_WD1",
  ADDRESS => 0x0000000050000030,
  NOTE    => "low order 64-bit captured word",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00841_flds
);


##########################################################################
#                                                                        #
#   SH2_NI0_LLP_CAPT_WD2                                                 #
#                                                                        #
##########################################################################

%shub2_01_00842_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "high order 64-bit captured word" ],
);

%shub2_01_00842_def =
( NAME    => "SH2_NI0_LLP_CAPT_WD2",
  ADDRESS => 0x0000000050000038,
  NOTE    => "high order 64-bit captured word",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00842_flds
);


##########################################################################
#                                                                        #
#   SH2_NI0_LLP_CAPT_SBCB                                                #
#                                                                        #
##########################################################################

%shub2_01_00843_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  37,  27, 0xFFFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CHARGEUNDERFLOW"              => [   1,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "wire charge counter underflowed, valid if llp_mode enabled" ],
   "CHARGEOVERFLOW"               => [   2,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "wire charge counter overflowed, valid if llp_mode enabled" ],
   "FAKEDALLSNERRORS"             => [   3,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "All faked SN errors have been sent" ],
   "SENTALLSNERRORS"              => [   4,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "All SN errors have been sent" ],
   "SENTALLCBERRORS"              => [   5,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "All CB errors have been sent" ],
   "CAPTUREDRCVCRC"               => [   6,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "CRC" ],
   "CAPTUREDRCVSBSN"              => [   7,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "sideband and sequence" ],
);

%shub2_01_00843_def =
( NAME    => "SH2_NI0_LLP_CAPT_SBCB",
  ADDRESS => 0x0000000050000040,
  NOTE    => "This register contains the sideband, sequence number, and CRC of note the flit that was captured. See LLP_CAPT_WD1 for descripti",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00843_flds
);


##########################################################################
#                                                                        #
#   SH2_NI0_LLP_ERR                                                      #
#                                                                        #
##########################################################################

%shub2_01_00844_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WIRE_OVERFLOW"                => [   1,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "wire_error_cnt has overflowed" ],
   "WIRE_CNT"                     => [   2,  36,  24, 0x0FFFFFF000000000, 0x00, 0, 0x0000000000000000, "counts the errors detected on a single wire test" ],
   "POWER_NOT_OK"                 => [   3,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Detects and traps a loss of power_OK" ],
   "SQUASH"                       => [   4,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "Indicates a micropacket was squashed" ],
   "RCV_LINK_RESET"               => [   5,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "Indicates a link reset has been received" ],
   "RETRY_TIMEOUT"                => [   6,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Indicates a retry timeout has occured" ],
);

%shub2_01_00844_def =
( NAME    => "SH2_NI0_LLP_ERR",
  ADDRESS => 0x0000000050000048,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00844_flds
);


##########################################################################
#                                                                        #
#   SH2_NI0_LLP_ERR1                                                     #
#                                                                        #
##########################################################################

%shub2_01_00845_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RETRY_COUNT"                  => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Counts the retries" ],
   "RX_SN_ERR_COUNT"              => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Counts the sequence number errors received" ],
);

%shub2_01_00845_def =
( NAME    => "SH2_NI0_LLP_ERR1",
  ADDRESS => 0x0000000050000050,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00845_flds
);


##########################################################################
#                                                                        #
#   SH2_NI0_LLP_ERR2                                                     #
#                                                                        #
##########################################################################

%shub2_01_00846_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RX_CB_ERR_COUNT"              => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Counts the check byte errors received" ],
);

%shub2_01_00846_def =
( NAME    => "SH2_NI0_LLP_ERR2",
  ADDRESS => 0x0000000050000058,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00846_flds
);


##########################################################################
#                                                                        #
#   SH2_NI0_LLP_PKT                                                      #
#                                                                        #
##########################################################################

%shub2_01_00847_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Micropacket Count" ],
);

%shub2_01_00847_def =
( NAME    => "SH2_NI0_LLP_PKT",
  ADDRESS => 0x0000000050000060,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00847_flds
);


##########################################################################
#                                                                        #
#   SH2_NI1_LLP_STAT                                                     #
#                                                                        #
##########################################################################

%shub2_01_00848_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   4,  60, 0xFFFFFFFFFFFFFFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LINK_RESET_STATE"             => [   1,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Status of LLP link." ],
);

%shub2_01_00848_def =
( NAME    => "SH2_NI1_LLP_STAT",
  ADDRESS => 0x0000000050002000,
  NOTE    => "This register describes the LLP status.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00848_flds
);


##########################################################################
#                                                                        #
#   SH2_NI1_LLP_RESET                                                    #
#                                                                        #
##########################################################################

%shub2_01_00849_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   2,  62, 0xFFFFFFFFFFFFFFFC, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WARM"                         => [   1,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Send Warm Reset. Generates a pulse." ],
   "LINK"                         => [   2,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Send Link Reset. Generates a pulse." ],
);

%shub2_01_00849_def =
( NAME    => "SH2_NI1_LLP_RESET",
  ADDRESS => 0x0000000050002008,
  NOTE    => "Writing issues a reset to the network interface",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00849_flds
);


##########################################################################
#                                                                        #
#   SH2_NI1_LLP_RESET_EN                                                 #
#                                                                        #
##########################################################################

%shub2_01_00850_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OK"                           => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Allow LLP warm reset to reset SHUB2 core" ],
);

%shub2_01_00850_def =
( NAME    => "SH2_NI1_LLP_RESET_EN",
  ADDRESS => 0x0000000050002010,
  NOTE    => "Controls LLP warm reset propagation",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00850_flds
);


##########################################################################
#                                                                        #
#   SH2_NI1_LLP_CHAN_MODE                                                #
#                                                                        #
##########################################################################

%shub2_01_00851_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   6,  58, 0xFFFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_LINK"                  => [   1,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Enables link." ],
   "ENABLE_CLKQUAD"               => [   2,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Reserved for future use. Terminated at dest." ],
   "ENABLE_RMT_FT_UPD"            => [   3,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Enables remote fine tune updates" ],
   "ENABLE_TUNING"                => [   4,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Enables automatic tuning of channel skew." ],
   "AC_ENCODE"                    => [   5,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Enables nearly dc-free encoding for AC-coupling" ],
   "BITMODE32"                    => [   6,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Enables 32-bit (plus sideband) channel phits" ],
);

%shub2_01_00851_def =
( NAME    => "SH2_NI1_LLP_CHAN_MODE",
  ADDRESS => 0x0000000050002018,
  NOTE    => "Sets the signaling mode of LLP and channel",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00851_flds
);


##########################################################################
#                                                                        #
#   SH2_NI1_LLP_CONFIG                                                   #
#                                                                        #
##########################################################################

%shub2_01_00852_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_MAXRETRY"              => [   1,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Enables maxretry" ],
   "ENABLE_FTU_TIME"              => [   2,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "Enables fine tuning time" ],
   "ENABLE_NULLTIMEOUT"           => [   3,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "Enables nulltimeout" ],
   "ENABLE_MAXBURST"              => [   4,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "Enables maxburst" ],
   "MAXRETRY"                     => [   5,  40,  16, 0x00FFFF0000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   6,  38,   2, 0x000000C000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FTU_TIME"                     => [   7,  26,  12, 0x0000003FFC000000, 0x00, 0, 0x0000000000000000, "" ],
   "NULLTIMEOUT"                  => [   8,  20,   6, 0x0000000003F00000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD2"                        => [   9,  10,  10, 0x00000000000FFC00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAXBURST"                     => [  10,   0,  10, 0x00000000000003FF, 0x00, 0, 0x0000000000000000, "" ],
);

%shub2_01_00852_def =
( NAME    => "SH2_NI1_LLP_CONFIG",
  ADDRESS => 0x0000000050002020,
  NOTE    => "Sets the configuration of LLP and channel",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00852_flds
);


##########################################################################
#                                                                        #
#   SH2_NI1_LLP_TEST_CTL                                                 #
#                                                                        #
##########################################################################

%shub2_01_00853_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CBERROR"                      => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Captured Micropacket Contained a CRC Error" ],
   "CAPTURED"                     => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "Micropacket Captured" ],
   "FAKESNERROR"                  => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "Inject a Sequence Number Error at the Receiver" ],
   "SENDSNERROR"                  => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Sends a single sequence number error" ],
   "SENDCBERROR"                  => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "Sends a single error" ],
   "CAPTURECBONLY"                => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "Only capture a micropacket with a Check Byte error" ],
   "ARMCAPTURE"                   => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "Enable Capture of Next MicroPacket" ],
   "NOISE_MODE"                   => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "LFSR_MODE"                    => [   9,  52,   2, 0x0030000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [  10,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WIRE_SEL"                     => [  11,  44,   6, 0x0003F00000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD2"                        => [  12,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_TEST_MODE"               => [  13,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "Send Test Mode" ],
   "PATTERN"                      => [  14,   0,  40, 0x000000FFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Send channel data pattern" ],
);

%shub2_01_00853_def =
( NAME    => "SH2_NI1_LLP_TEST_CTL",
  ADDRESS => 0x0000000050002028,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00853_flds
);


##########################################################################
#                                                                        #
#   SH2_NI1_LLP_CAPT_WD1                                                 #
#                                                                        #
##########################################################################

%shub2_01_00854_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "low order 64-bit captured word" ],
);

%shub2_01_00854_def =
( NAME    => "SH2_NI1_LLP_CAPT_WD1",
  ADDRESS => 0x0000000050002030,
  NOTE    => "low order 64-bit captured word",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00854_flds
);


##########################################################################
#                                                                        #
#   SH2_NI1_LLP_CAPT_WD2                                                 #
#                                                                        #
##########################################################################

%shub2_01_00855_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "high order 64-bit captured word" ],
);

%shub2_01_00855_def =
( NAME    => "SH2_NI1_LLP_CAPT_WD2",
  ADDRESS => 0x0000000050002038,
  NOTE    => "high order 64-bit captured word",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00855_flds
);


##########################################################################
#                                                                        #
#   SH2_NI1_LLP_CAPT_SBCB                                                #
#                                                                        #
##########################################################################

%shub2_01_00856_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  37,  27, 0xFFFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CHARGEUNDERFLOW"              => [   1,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "wire charge counter underflowed, valid if llp_mode enabled" ],
   "CHARGEOVERFLOW"               => [   2,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "wire charge counter overflowed, valid if llp_mode enabled" ],
   "FAKEDALLSNERRORS"             => [   3,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "All faked SN errors have been sent" ],
   "SENTALLSNERRORS"              => [   4,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "All SN errors have been sent" ],
   "SENTALLCBERRORS"              => [   5,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "All CB errors have been sent" ],
   "CAPTUREDRCVCRC"               => [   6,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "CRC" ],
   "CAPTUREDRCVSBSN"              => [   7,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "sideband and sequence" ],
);

%shub2_01_00856_def =
( NAME    => "SH2_NI1_LLP_CAPT_SBCB",
  ADDRESS => 0x0000000050002040,
  NOTE    => "This register contains the sideband, sequence number, and CRC of note the flit that was captured. See LLP_CAPT_WD1 for descripti",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00856_flds
);


##########################################################################
#                                                                        #
#   SH2_NI1_LLP_ERR                                                      #
#                                                                        #
##########################################################################

%shub2_01_00857_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WIRE_OVERFLOW"                => [   1,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "wire_error_cnt has overflowed" ],
   "WIRE_CNT"                     => [   2,  36,  24, 0x0FFFFFF000000000, 0x00, 0, 0x0000000000000000, "counts the errors detected on a single wire test" ],
   "POWER_NOT_OK"                 => [   3,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Detects and traps a loss of power_OK" ],
   "SQUASH"                       => [   4,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "Indicates a micropacket was squashed" ],
   "RCV_LINK_RESET"               => [   5,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "Indicates a link reset has been received" ],
   "RETRY_TIMEOUT"                => [   6,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Indicates a retry timeout has occured" ],
);

%shub2_01_00857_def =
( NAME    => "SH2_NI1_LLP_ERR",
  ADDRESS => 0x0000000050002048,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00857_flds
);


##########################################################################
#                                                                        #
#   SH2_NI1_LLP_ERR1                                                     #
#                                                                        #
##########################################################################

%shub2_01_00858_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RETRY_COUNT"                  => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Counts the retries" ],
   "RX_SN_ERR_COUNT"              => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Counts the sequence number errors received" ],
);

%shub2_01_00858_def =
( NAME    => "SH2_NI1_LLP_ERR1",
  ADDRESS => 0x0000000050002050,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00858_flds
);


##########################################################################
#                                                                        #
#   SH2_NI1_LLP_ERR2                                                     #
#                                                                        #
##########################################################################

%shub2_01_00859_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RX_CB_ERR_COUNT"              => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Counts the check byte errors received" ],
);

%shub2_01_00859_def =
( NAME    => "SH2_NI1_LLP_ERR2",
  ADDRESS => 0x0000000050002058,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00859_flds
);


##########################################################################
#                                                                        #
#   SH2_NI1_LLP_PKT                                                      #
#                                                                        #
##########################################################################

%shub2_01_00860_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Micropacket Count" ],
);

%shub2_01_00860_def =
( NAME    => "SH2_NI1_LLP_PKT",
  ADDRESS => 0x0000000050002060,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00860_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI0_LLP_DEBIT_FLOW                                             #
#                                                                        #
##########################################################################

%shub2_01_00861_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_CAP"                => [   1,  56,   5, 0x1F00000000000000, 0x00, 0, 0x0000000000000000, "vc3 debit captured value" ],
   "RSVD1"                        => [   2,  53,   3, 0x00E0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_DYN"                => [   3,  48,   5, 0x001F000000000000, 0x00, 0, 0x0000000000000000, "vc3 debit dynamic value" ],
   "RSVD2"                        => [   4,  45,   3, 0x0000E00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_CAP"                => [   5,  40,   5, 0x00001F0000000000, 0x00, 0, 0x0000000000000000, "vc2 debit captured value" ],
   "RSVD3"                        => [   6,  37,   3, 0x000000E000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_DYN"                => [   7,  32,   5, 0x0000001F00000000, 0x00, 0, 0x0000000000000000, "vc2 debit dynamic value" ],
   "RSVD4"                        => [   8,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_CAP"                => [   9,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "vc1 debit captured value" ],
   "RSVD5"                        => [  10,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_DYN"                => [  11,  16,   5, 0x00000000001F0000, 0x00, 0, 0x0000000000000000, "vc1 debit dynamic value" ],
   "RSVD6"                        => [  12,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_CAP"                => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "vc0 debit captured value" ],
   "RSVD7"                        => [  14,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_DYN"                => [  15,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "vc0 debit dynamic value" ],
);

%shub2_01_00861_def =
( NAME    => "SH2_XNNI0_LLP_DEBIT_FLOW",
  ADDRESS => 0x0000000050001030,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00861_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI0_LINK_0_FLOW                                                #
#                                                                        #
##########################################################################

%shub2_01_00862_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   1,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Captured vc0 credit" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   3,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Dynamic vc0 credit value" ],
   "RSVD2"                        => [   4,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_TEST"              => [   5,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "vc0 Limit Test" ],
   "DEBIT_VC0_FORCE_CRED"         => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on vc0 from debit cntr" ],
   "RSVD3"                        => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [   8,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc0 withhold" ],
);

%shub2_01_00862_def =
( NAME    => "SH2_XNNI0_LINK_0_FLOW",
  ADDRESS => 0x0000000050001040,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00862_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI0_LINK_1_FLOW                                                #
#                                                                        #
##########################################################################

%shub2_01_00863_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_CAP"               => [   1,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Captured vc1 credit" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_DYN"               => [   3,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Dynamic vc1 credit value" ],
   "RSVD2"                        => [   4,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_TEST"              => [   5,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "vc1 Limit Test" ],
   "DEBIT_VC1_FORCE_CRED"         => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on vc1 from debit cntr" ],
   "RSVD3"                        => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_WITHHOLD"           => [   8,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc1 withhold" ],
);

%shub2_01_00863_def =
( NAME    => "SH2_XNNI0_LINK_1_FLOW",
  ADDRESS => 0x0000000050001050,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00863_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI0_LINK_2_FLOW                                                #
#                                                                        #
##########################################################################

%shub2_01_00864_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Captured vc2 credit" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Dynamic vc2 credit value" ],
   "RSVD2"                        => [   4,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_TEST"              => [   5,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "vc2 Limit Test" ],
   "DEBIT_VC2_FORCE_CRED"         => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on vc2 from debit cntr" ],
   "RSVD3"                        => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [   8,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc2 withhold" ],
);

%shub2_01_00864_def =
( NAME    => "SH2_XNNI0_LINK_2_FLOW",
  ADDRESS => 0x0000000050001060,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00864_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI0_LINK_3_FLOW                                                #
#                                                                        #
##########################################################################

%shub2_01_00865_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_CAP"               => [   1,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Captured vc3 credit" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_DYN"               => [   3,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Dynamic vc3 credit value" ],
   "RSVD2"                        => [   4,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_TEST"              => [   5,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "vc3 Limit Test" ],
   "DEBIT_VC3_FORCE_CRED"         => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on vc3 from debit cntr" ],
   "RSVD3"                        => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_WITHHOLD"           => [   8,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc3 withhold" ],
);

%shub2_01_00865_def =
( NAME    => "SH2_XNNI0_LINK_3_FLOW",
  ADDRESS => 0x0000000050001070,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00865_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI1_LLP_DEBIT_FLOW                                             #
#                                                                        #
##########################################################################

%shub2_01_00866_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_CAP"                => [   1,  56,   5, 0x1F00000000000000, 0x00, 0, 0x0000000000000000, "vc3 debit captured value" ],
   "RSVD1"                        => [   2,  53,   3, 0x00E0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_DYN"                => [   3,  48,   5, 0x001F000000000000, 0x00, 0, 0x0000000000000000, "vc3 debit dynamic value" ],
   "RSVD2"                        => [   4,  45,   3, 0x0000E00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_CAP"                => [   5,  40,   5, 0x00001F0000000000, 0x00, 0, 0x0000000000000000, "vc2 debit captured value" ],
   "RSVD3"                        => [   6,  37,   3, 0x000000E000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_DYN"                => [   7,  32,   5, 0x0000001F00000000, 0x00, 0, 0x0000000000000000, "vc2 debit dynamic value" ],
   "RSVD4"                        => [   8,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_CAP"                => [   9,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "vc1 debit captured value" ],
   "RSVD5"                        => [  10,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_DYN"                => [  11,  16,   5, 0x00000000001F0000, 0x00, 0, 0x0000000000000000, "vc1 debit dynamic value" ],
   "RSVD6"                        => [  12,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_CAP"                => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "vc0 debit captured value" ],
   "RSVD7"                        => [  14,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_DYN"                => [  15,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "vc0 debit dynamic value" ],
);

%shub2_01_00866_def =
( NAME    => "SH2_XNNI1_LLP_DEBIT_FLOW",
  ADDRESS => 0x0000000050003030,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00866_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI1_LINK_0_FLOW                                                #
#                                                                        #
##########################################################################

%shub2_01_00867_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   1,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Captured vc0 credit" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   3,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Dynamic vc0 credit value" ],
   "RSVD2"                        => [   4,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_TEST"              => [   5,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "vc0 Limit Test" ],
   "DEBIT_VC0_FORCE_CRED"         => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on vc0 from debit cntr" ],
   "RSVD3"                        => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [   8,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc0 withhold" ],
);

%shub2_01_00867_def =
( NAME    => "SH2_XNNI1_LINK_0_FLOW",
  ADDRESS => 0x0000000050003040,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00867_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI1_LINK_1_FLOW                                                #
#                                                                        #
##########################################################################

%shub2_01_00868_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_CAP"               => [   1,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Captured vc1 credit" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_DYN"               => [   3,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Dynamic vc1 credit value" ],
   "RSVD2"                        => [   4,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_TEST"              => [   5,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "vc1 Limit Test" ],
   "DEBIT_VC1_FORCE_CRED"         => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on vc1 from debit cntr" ],
   "RSVD3"                        => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_WITHHOLD"           => [   8,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc1 withhold" ],
);

%shub2_01_00868_def =
( NAME    => "SH2_XNNI1_LINK_1_FLOW",
  ADDRESS => 0x0000000050003050,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00868_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI1_LINK_2_FLOW                                                #
#                                                                        #
##########################################################################

%shub2_01_00869_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Captured vc2 credit" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Dynamic vc2 credit value" ],
   "RSVD2"                        => [   4,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_TEST"              => [   5,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "vc2 Limit Test" ],
   "DEBIT_VC2_FORCE_CRED"         => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on vc2 from debit cntr" ],
   "RSVD3"                        => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [   8,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc2 withhold" ],
);

%shub2_01_00869_def =
( NAME    => "SH2_XNNI1_LINK_2_FLOW",
  ADDRESS => 0x0000000050003060,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00869_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI1_LINK_3_FLOW                                                #
#                                                                        #
##########################################################################

%shub2_01_00870_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_CAP"               => [   1,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Captured vc3 credit" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_DYN"               => [   3,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Dynamic vc3 credit value" ],
   "RSVD2"                        => [   4,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_TEST"              => [   5,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "vc3 Limit Test" ],
   "DEBIT_VC3_FORCE_CRED"         => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on vc3 from debit cntr" ],
   "RSVD3"                        => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_WITHHOLD"           => [   8,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc3 withhold" ],
);

%shub2_01_00870_def =
( NAME    => "SH2_XNNI1_LINK_3_FLOW",
  ADDRESS => 0x0000000050003070,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00870_flds
);


##########################################################################
#                                                                        #
#   SH2_IILB_LOCAL_TABLE                                                 #
#                                                                        #
##########################################################################

%shub2_01_00871_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Indicates that this entry is valid" ],
   "RSVD0"                        => [   1,   6,  57, 0x7FFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL0"                      => [   2,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "ni select" ],
   "V0"                           => [   3,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   4,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
);

%shub2_01_00871_def =
( NAME    => "SH2_IILB_LOCAL_TABLE",
  ADDRESS => 0x0000000050020000,
  NOTE    => "This table provides the direction and vch for the outgoing header, note in the event that the global bits (upper bits) of the in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00871_flds
);


##########################################################################
#                                                                        #
#   SH2_IILB_GLOBAL_TABLE                                                #
#                                                                        #
##########################################################################

%shub2_01_00872_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Indicates that this entry is valid" ],
   "RSVD0"                        => [   1,   6,  57, 0x7FFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL0"                      => [   2,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "ni select" ],
   "V0"                           => [   3,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   4,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
);

%shub2_01_00872_def =
( NAME    => "SH2_IILB_GLOBAL_TABLE",
  ADDRESS => 0x0000000050020800,
  NOTE    => "This table provides the direction and vch for the outgoing header, note in the event that the global bits (upper bits) of the in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00872_flds
);


##########################################################################
#                                                                        #
#   SH2_IILB_OVER_RIDE_TABLE                                             #
#                                                                        #
##########################################################################

%shub2_01_00873_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Indicates that this entry is enabled" ],
   "RSVD0"                        => [   1,   6,  57, 0x7FFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL0"                      => [   2,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "ni select" ],
   "V0"                           => [   3,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   4,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Direction field for next chip" ],
);

%shub2_01_00873_def =
( NAME    => "SH2_IILB_OVER_RIDE_TABLE",
  ADDRESS => 0x0000000050021000,
  NOTE    => "If enabled, bypass the Global/Local tables",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00873_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_LOCAL_TABLE                                                   #
#                                                                        #
##########################################################################

%shub2_01_00874_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Indicates that this entry is valid" ],
   "RSVD0"                        => [   1,  14,  49, 0x7FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL1"                      => [   2,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "ni select" ],
   "V1"                           => [   3,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR1"                         => [   4,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
   "RSVD1"                        => [   5,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL0"                      => [   6,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "ni select" ],
   "V0"                           => [   7,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   8,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
);

%shub2_01_00874_def =
( NAME    => "SH2_PI_LOCAL_TABLE",
  ADDRESS => 0x0000000050022000,
  NOTE    => "This table provides the direction and vch for the outgoing header, note in the event that the global bits (upper bits) of the in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00874_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_GLOBAL_TABLE                                                  #
#                                                                        #
##########################################################################

%shub2_01_00875_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Indicates that this entry is valid" ],
   "RSVD0"                        => [   1,  14,  49, 0x7FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL1"                      => [   2,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "ni select" ],
   "V1"                           => [   3,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR1"                         => [   4,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
   "RSVD1"                        => [   5,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL0"                      => [   6,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "ni select" ],
   "V0"                           => [   7,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   8,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
);

%shub2_01_00875_def =
( NAME    => "SH2_PI_GLOBAL_TABLE",
  ADDRESS => 0x0000000050022800,
  NOTE    => "This table provides the direction and vch for the outgoing header, note in the event that the global bits (upper bits) of the in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00875_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_OVER_RIDE_TABLE                                               #
#                                                                        #
##########################################################################

%shub2_01_00876_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Indicates that this entry is enabled" ],
   "RSVD0"                        => [   1,  14,  49, 0x7FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL1"                      => [   2,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "ni select" ],
   "V1"                           => [   3,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR1"                         => [   4,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "Direction field for next chip" ],
   "RSVD1"                        => [   5,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL0"                      => [   6,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "ni select" ],
   "V0"                           => [   7,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   8,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Direction field for next chip" ],
);

%shub2_01_00876_def =
( NAME    => "SH2_PI_OVER_RIDE_TABLE",
  ADDRESS => 0x0000000050023000,
  NOTE    => "If enabled, bypass the Global/Local tables",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00876_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_RSP_PLANE_HINT                                                #
#                                                                        #
##########################################################################

%shub2_01_00877_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INVERT"                       => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Invert Response Plane Hint" ],
);

%shub2_01_00877_def =
( NAME    => "SH2_PI_RSP_PLANE_HINT",
  ADDRESS => 0x0000000050023008,
  NOTE    => "If enabled, invert incoming response only plane hint bit before note lookup",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00877_flds
);


##########################################################################
#                                                                        #
#   SH2_NI0_LOCAL_TABLE                                                  #
#                                                                        #
##########################################################################

%shub2_01_00878_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Indicates that this entry is valid" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "V0"                           => [   2,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   3,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
);

%shub2_01_00878_def =
( NAME    => "SH2_NI0_LOCAL_TABLE",
  ADDRESS => 0x0000000050024000,
  NOTE    => "This table provides the direction and vch for the outgoing header, note in the event that the global bits (upper bits) of the in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00878_flds
);


##########################################################################
#                                                                        #
#   SH2_NI0_GLOBAL_TABLE                                                 #
#                                                                        #
##########################################################################

%shub2_01_00879_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Indicates that this entry is valid" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "V0"                           => [   2,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   3,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
);

%shub2_01_00879_def =
( NAME    => "SH2_NI0_GLOBAL_TABLE",
  ADDRESS => 0x0000000050024800,
  NOTE    => "This table provides the direction and vch for the outgoing header, note in the event that the global bits (upper bits) of the in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00879_flds
);


##########################################################################
#                                                                        #
#   SH2_NI0_OVER_RIDE_TABLE                                              #
#                                                                        #
##########################################################################

%shub2_01_00880_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Indicates that this entry is enabled" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "V0"                           => [   2,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   3,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Direction field for next chip" ],
);

%shub2_01_00880_def =
( NAME    => "SH2_NI0_OVER_RIDE_TABLE",
  ADDRESS => 0x0000000050025000,
  NOTE    => "If enabled, bypass the Global/Local tables",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00880_flds
);


##########################################################################
#                                                                        #
#   SH2_NI1_LOCAL_TABLE                                                  #
#                                                                        #
##########################################################################

%shub2_01_00881_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Indicates that this entry is valid" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "V0"                           => [   2,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   3,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
);

%shub2_01_00881_def =
( NAME    => "SH2_NI1_LOCAL_TABLE",
  ADDRESS => 0x0000000050026000,
  NOTE    => "This table provides the direction and vch for the outgoing header, note in the event that the global bits (upper bits) of the in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00881_flds
);


##########################################################################
#                                                                        #
#   SH2_NI1_GLOBAL_TABLE                                                 #
#                                                                        #
##########################################################################

%shub2_01_00882_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Indicates that this entry is valid" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "V0"                           => [   2,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   3,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
);

%shub2_01_00882_def =
( NAME    => "SH2_NI1_GLOBAL_TABLE",
  ADDRESS => 0x0000000050026800,
  NOTE    => "This table provides the direction and vch for the outgoing header, note in the event that the global bits (upper bits) of the in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00882_flds
);


##########################################################################
#                                                                        #
#   SH2_NI1_OVER_RIDE_TABLE                                              #
#                                                                        #
##########################################################################

%shub2_01_00883_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Indicates that this entry is enabled" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "V0"                           => [   2,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   3,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Direction field for next chip" ],
);

%shub2_01_00883_def =
( NAME    => "SH2_NI1_OVER_RIDE_TABLE",
  ADDRESS => 0x0000000050027000,
  NOTE    => "If enabled, bypass the Global/Local tables",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00883_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_LOCAL_TABLE                                                   #
#                                                                        #
##########################################################################

%shub2_01_00884_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Indicates that this entry is valid" ],
   "RSVD0"                        => [   1,  14,  49, 0x7FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL1"                      => [   2,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "ni select" ],
   "V1"                           => [   3,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR1"                         => [   4,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
   "RSVD1"                        => [   5,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL0"                      => [   6,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "ni select" ],
   "V0"                           => [   7,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   8,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
);

%shub2_01_00884_def =
( NAME    => "SH2_MD_LOCAL_TABLE",
  ADDRESS => 0x0000000050028000,
  NOTE    => "This table provides the direction and vch for the outgoing header, note in the event that the global bits (upper bits) of the in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00884_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_GLOBAL_TABLE                                                  #
#                                                                        #
##########################################################################

%shub2_01_00885_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Indicates that this entry is valid" ],
   "RSVD0"                        => [   1,  14,  49, 0x7FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL1"                      => [   2,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "ni select" ],
   "V1"                           => [   3,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR1"                         => [   4,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
   "RSVD1"                        => [   5,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL0"                      => [   6,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "ni select" ],
   "V0"                           => [   7,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   8,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
);

%shub2_01_00885_def =
( NAME    => "SH2_MD_GLOBAL_TABLE",
  ADDRESS => 0x0000000050028800,
  NOTE    => "This table provides the direction and vch for the outgoing header, note in the event that the global bits (upper bits) of the in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00885_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_OVER_RIDE_TABLE                                               #
#                                                                        #
##########################################################################

%shub2_01_00886_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Indicates that this entry is enabled" ],
   "RSVD0"                        => [   1,  14,  49, 0x7FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL1"                      => [   2,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "ni select" ],
   "V1"                           => [   3,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR1"                         => [   4,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "Direction field for next chip" ],
   "RSVD1"                        => [   5,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL0"                      => [   6,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "ni select" ],
   "V0"                           => [   7,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   8,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Direction field for next chip" ],
);

%shub2_01_00886_def =
( NAME    => "SH2_MD_OVER_RIDE_TABLE",
  ADDRESS => 0x0000000050029000,
  NOTE    => "If enabled, bypass the Global/Local tables",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00886_flds
);


##########################################################################
#                                                                        #
#   SH2_MD_RSP_PLANE_HINT                                                #
#                                                                        #
##########################################################################

%shub2_01_00887_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INVERT"                       => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Invert Response Plane Hint" ],
);

%shub2_01_00887_def =
( NAME    => "SH2_MD_RSP_PLANE_HINT",
  ADDRESS => 0x0000000050029008,
  NOTE    => "If enabled, invert incoming response only plane hint bit before note lookup",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00887_flds
);


##########################################################################
#                                                                        #
#   SH2_XNPI_SIC_FLOW                                                    #
#                                                                        #
##########################################################################

%shub2_01_00888_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  56,   5, 0x1F00000000000000, 0x00, 0, 0x0000000000000000, "VC2 credit captured value" ],
   "RSVD1"                        => [   2,  53,   3, 0x00E0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  48,   5, 0x001F000000000000, 0x00, 0, 0x0000000000000000, "VC2 credit dynamic value" ],
   "RSVD2"                        => [   4,  45,   3, 0x0000E00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_TEST"              => [   5,  40,   5, 0x00001F0000000000, 0x00, 1, 0x0000000000000000, "VC2 credit_test" ],
   "RSVD3"                        => [   6,  37,   3, 0x000000E000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   7,  32,   5, 0x0000001F00000000, 0x00, 0, 0x0000000000000000, "VC0 credit captured value" ],
   "RSVD4"                        => [   8,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   9,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "VC0 credit dynamic value" ],
   "RSVD5"                        => [  10,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_TEST"              => [  11,  16,   5, 0x00000000001F0000, 0x00, 1, 0x0000000000000000, "VC0 credit_test" ],
   "DEBIT_VC2_FORCE_CRED"         => [  12,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD6"                        => [  13,  13,   2, 0x0000000000006000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [  14,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
   "DEBIT_VC0_FORCE_CRED"         => [  15,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD7"                        => [  16,   5,   2, 0x0000000000000060, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [  17,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%shub2_01_00888_def =
( NAME    => "SH2_XNPI_SIC_FLOW",
  ADDRESS => 0x0000000050030000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00888_flds
);


##########################################################################
#                                                                        #
#   SH2_XNPI_TO_NI0_PORT_FLOW                                            #
#                                                                        #
##########################################################################

%shub2_01_00889_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_FORCE_CRED"         => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
   "DEBIT_VC0_FORCE_CRED"         => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%shub2_01_00889_def =
( NAME    => "SH2_XNPI_TO_NI0_PORT_FLOW",
  ADDRESS => 0x0000000050030010,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00889_flds
);


##########################################################################
#                                                                        #
#   SH2_XNPI_TO_NI0_PORT_FLOW13                                          #
#                                                                        #
##########################################################################

%shub2_01_00890_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_CAP"               => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_DYN"               => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_CAP"               => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_DYN"               => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_FORCE_CRED"         => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC3" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_WITHHOLD"           => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC3 Withhold" ],
   "DEBIT_VC1_FORCE_CRED"         => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC1" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_WITHHOLD"           => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC1 Withhold" ],
);

%shub2_01_00890_def =
( NAME    => "SH2_XNPI_TO_NI0_PORT_FLOW13",
  ADDRESS => 0x0000000050030020,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00890_flds
);


##########################################################################
#                                                                        #
#   SH2_XNPI_TO_NI1_PORT_FLOW                                            #
#                                                                        #
##########################################################################

%shub2_01_00891_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_FORCE_CRED"         => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
   "DEBIT_VC0_FORCE_CRED"         => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%shub2_01_00891_def =
( NAME    => "SH2_XNPI_TO_NI1_PORT_FLOW",
  ADDRESS => 0x0000000050030030,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00891_flds
);


##########################################################################
#                                                                        #
#   SH2_XNPI_TO_NI1_PORT_FLOW13                                          #
#                                                                        #
##########################################################################

%shub2_01_00892_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_CAP"               => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_DYN"               => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_CAP"               => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_DYN"               => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_FORCE_CRED"         => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC3" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_WITHHOLD"           => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC3 Withhold" ],
   "DEBIT_VC1_FORCE_CRED"         => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC1" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_WITHHOLD"           => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC1 Withhold" ],
);

%shub2_01_00892_def =
( NAME    => "SH2_XNPI_TO_NI1_PORT_FLOW13",
  ADDRESS => 0x0000000050030040,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00892_flds
);


##########################################################################
#                                                                        #
#   SH2_XNPI_TO_IILB_PORT_FLOW                                           #
#                                                                        #
##########################################################################

%shub2_01_00893_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_FORCE_CRED"         => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
   "DEBIT_VC0_FORCE_CRED"         => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%shub2_01_00893_def =
( NAME    => "SH2_XNPI_TO_IILB_PORT_FLOW",
  ADDRESS => 0x0000000050030050,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00893_flds
);


##########################################################################
#                                                                        #
#   SH2_XNPI_ARB_CONFIG                                                  #
#                                                                        #
##########################################################################

%shub2_01_00894_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_SYNC_BYPASS_IN"        => [   1,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Enable Bypass Mode" ],
);

%shub2_01_00894_def =
( NAME    => "SH2_XNPI_ARB_CONFIG",
  ADDRESS => 0x0000000050030060,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00894_flds
);


##########################################################################
#                                                                        #
#   SH2_XNPI_LOCAL_AGE0                                                  #
#                                                                        #
##########################################################################

%shub2_01_00895_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "AGE_WRAP_SRC3_VC2"            => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "XN_NI1 VC2 Pre-Scale Value" ],
   "AGE_WRAP_SRC3_VC0"            => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "XN_NI1 VC0 Pre-Scale Value" ],
   "AGE_WRAP_SRC2_VC2"            => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "XN_NI0 VC3 Pre-Scale Value" ],
   "AGE_WRAP_SRC2_VC0"            => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "XN_NI0 VC1 Pre-Scale Value" ],
   "AGE_WRAP_SRC1_VC2"            => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "XN_NI0 VC2 Pre-Scale Value" ],
   "AGE_WRAP_SRC1_VC0"            => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "XN_NI0 VC0 Pre-Scale Value" ],
   "AGE_WRAP_SRC0_VC2"            => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "XN_IILB VC2 Pre-Scale Value" ],
   "AGE_WRAP_SRC0_VC0"            => [   7,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "XN_IILB VC0 Pre-Scale Value" ],
);

%shub2_01_00895_def =
( NAME    => "SH2_XNPI_LOCAL_AGE0",
  ADDRESS => 0x0000000050030070,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00895_flds
);


##########################################################################
#                                                                        #
#   SH2_XNPI_LOCAL_AGE1                                                  #
#                                                                        #
##########################################################################

%shub2_01_00896_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_WRAP_SRC4_VC2"            => [   1,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "XN_NI1 VC3 Pre-Scale Value" ],
   "AGE_WRAP_SRC4_VC0"            => [   2,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "XN_NI1 VC1 Pre-Scale Value" ],
);

%shub2_01_00896_def =
( NAME    => "SH2_XNPI_LOCAL_AGE1",
  ADDRESS => 0x0000000050030080,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00896_flds
);


##########################################################################
#                                                                        #
#   SH2_XNPI_STEERING_FIFO                                               #
#                                                                        #
##########################################################################

%shub2_01_00897_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  45,  19, 0xFFFFE00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT_VC2_CAP"                  => [   1,  40,   5, 0x00001F0000000000, 0x00, 1, 0x0000000000000000, "VC2 Captured Count" ],
   "RSVD1"                        => [   2,  37,   3, 0x000000E000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT_VC2_DYN"                  => [   3,  32,   5, 0x0000001F00000000, 0x00, 0, 0x0000000000000000, "VC2 Dynamic Count" ],
   "RSVD2"                        => [   4,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT_VC0_CAP"                  => [   5,  24,   5, 0x000000001F000000, 0x00, 1, 0x0000000000000000, "VC0 Captured Count" ],
   "RSVD3"                        => [   6,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT_VC0_DYN"                  => [   7,  16,   5, 0x00000000001F0000, 0x00, 0, 0x0000000000000000, "VC0 Dynamic Count" ],
   "RSVD4"                        => [   8,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CNT_VC2"                  => [   9,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "VC2 Maximum Counter Value" ],
   "RSVD5"                        => [  10,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CNT_VC0"                  => [  11,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "VC0 Maximum Counter Value" ],
);

%shub2_01_00897_def =
( NAME    => "SH2_XNPI_STEERING_FIFO",
  ADDRESS => 0x0000000050030090,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00897_flds
);


##########################################################################
#                                                                        #
#   SH2_XNPI_CREDIT_MGR_VC0                                              #
#                                                                        #
##########################################################################

%shub2_01_00898_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE_CNT_CAP"                 => [   1,  44,   3, 0x0000700000000000, 0x00, 1, 0x0000000000000000, "Base VC0 Captured Credit Count" ],
   "RSVD1"                        => [   2,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE_CNT_DYN"                 => [   3,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Base VC0 Dynamic Credit Count" ],
   "RSVD2"                        => [   4,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI1_CNT_CAP"                  => [   5,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "NI1 VC0 Captured Credit Count" ],
   "RSVD3"                        => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI1_CNT_DYN"                  => [   7,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Dynamic Credit Count" ],
   "RSVD4"                        => [   8,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI0_CNT_CAP"                  => [   9,  28,   3, 0x0000000070000000, 0x00, 1, 0x0000000000000000, "NI0 VC0 Captured Credit Count" ],
   "RSVD5"                        => [  10,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI0_CNT_DYN"                  => [  11,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Dynamic Credit Count" ],
   "RSVD6"                        => [  12,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_CNT_CAP"                 => [  13,  20,   3, 0x0000000000700000, 0x00, 1, 0x0000000000000000, "IILB VC0 Captured Credit Count" ],
   "RSVD7"                        => [  14,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_CNT_DYN"                 => [  15,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "IILB VC0 Dynamic Credit Count" ],
   "RSVD8"                        => [  16,  11,   5, 0x000000000000F800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CNT"                      => [  17,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "VC0 Maximum Credit Count" ],
);

%shub2_01_00898_def =
( NAME    => "SH2_XNPI_CREDIT_MGR_VC0",
  ADDRESS => 0x00000000500300a0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00898_flds
);


##########################################################################
#                                                                        #
#   SH2_XNPI_CREDIT_MGR_VC2                                              #
#                                                                        #
##########################################################################

%shub2_01_00899_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE_CNT_CAP"                 => [   1,  44,   3, 0x0000700000000000, 0x00, 1, 0x0000000000000000, "Base VC2 Captured Credit Count" ],
   "RSVD1"                        => [   2,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE_CNT_DYN"                 => [   3,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Base VC2 Dynamic Credit Count" ],
   "RSVD2"                        => [   4,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI1_CNT_CAP"                  => [   5,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "NI1 VC2 Captured Credit Count" ],
   "RSVD3"                        => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI1_CNT_DYN"                  => [   7,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Dynamic Credit Count" ],
   "RSVD4"                        => [   8,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI0_CNT_CAP"                  => [   9,  28,   3, 0x0000000070000000, 0x00, 1, 0x0000000000000000, "NI0 VC2 Captured Credit Count" ],
   "RSVD5"                        => [  10,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI0_CNT_DYN"                  => [  11,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Dynamic Credit Count" ],
   "RSVD6"                        => [  12,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_CNT_CAP"                 => [  13,  20,   3, 0x0000000000700000, 0x00, 1, 0x0000000000000000, "IILB VC2 Captured Credit Count" ],
   "RSVD7"                        => [  14,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_CNT_DYN"                 => [  15,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "IILB VC2 Dynamic Credit Count" ],
   "RSVD8"                        => [  16,  11,   5, 0x000000000000F800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CNT"                      => [  17,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "VC2 Maximum Credit Count" ],
);

%shub2_01_00899_def =
( NAME    => "SH2_XNPI_CREDIT_MGR_VC2",
  ADDRESS => 0x00000000500300b0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00899_flds
);


##########################################################################
#                                                                        #
#   SH2_XNMD_SIC_FLOW                                                    #
#                                                                        #
##########################################################################

%shub2_01_00900_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  56,   5, 0x1F00000000000000, 0x00, 0, 0x0000000000000000, "VC2 credit captured value" ],
   "RSVD1"                        => [   2,  53,   3, 0x00E0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  48,   5, 0x001F000000000000, 0x00, 0, 0x0000000000000000, "VC2 credit dynamic value" ],
   "RSVD2"                        => [   4,  45,   3, 0x0000E00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_TEST"              => [   5,  40,   5, 0x00001F0000000000, 0x00, 1, 0x0000000000000000, "VC2 credit_test" ],
   "RSVD3"                        => [   6,  37,   3, 0x000000E000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   7,  32,   5, 0x0000001F00000000, 0x00, 0, 0x0000000000000000, "VC0 credit captured value" ],
   "RSVD4"                        => [   8,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   9,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "VC0 credit dynamic value" ],
   "RSVD5"                        => [  10,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_TEST"              => [  11,  16,   5, 0x00000000001F0000, 0x00, 1, 0x0000000000000000, "VC0 credit_test" ],
   "DEBIT_VC2_FORCE_CRED"         => [  12,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD6"                        => [  13,  13,   2, 0x0000000000006000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [  14,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
   "DEBIT_VC0_FORCE_CRED"         => [  15,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD7"                        => [  16,   5,   2, 0x0000000000000060, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [  17,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%shub2_01_00900_def =
( NAME    => "SH2_XNMD_SIC_FLOW",
  ADDRESS => 0x0000000050030100,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00900_flds
);


##########################################################################
#                                                                        #
#   SH2_XNMD_TO_NI0_PORT_FLOW                                            #
#                                                                        #
##########################################################################

%shub2_01_00901_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_FORCE_CRED"         => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
   "DEBIT_VC0_FORCE_CRED"         => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%shub2_01_00901_def =
( NAME    => "SH2_XNMD_TO_NI0_PORT_FLOW",
  ADDRESS => 0x0000000050030110,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00901_flds
);


##########################################################################
#                                                                        #
#   SH2_XNMD_TO_NI0_PORT_FLOW13                                          #
#                                                                        #
##########################################################################

%shub2_01_00902_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_CAP"               => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_DYN"               => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_CAP"               => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_DYN"               => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_FORCE_CRED"         => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC3" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_WITHHOLD"           => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC3 Withhold" ],
   "DEBIT_VC1_FORCE_CRED"         => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC1" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_WITHHOLD"           => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC1 Withhold" ],
);

%shub2_01_00902_def =
( NAME    => "SH2_XNMD_TO_NI0_PORT_FLOW13",
  ADDRESS => 0x0000000050030120,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00902_flds
);


##########################################################################
#                                                                        #
#   SH2_XNMD_TO_NI1_PORT_FLOW                                            #
#                                                                        #
##########################################################################

%shub2_01_00903_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_FORCE_CRED"         => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
   "DEBIT_VC0_FORCE_CRED"         => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%shub2_01_00903_def =
( NAME    => "SH2_XNMD_TO_NI1_PORT_FLOW",
  ADDRESS => 0x0000000050030130,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00903_flds
);


##########################################################################
#                                                                        #
#   SH2_XNMD_TO_NI1_PORT_FLOW13                                          #
#                                                                        #
##########################################################################

%shub2_01_00904_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_CAP"               => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_DYN"               => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_CAP"               => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_DYN"               => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_FORCE_CRED"         => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC3" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_WITHHOLD"           => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC3 Withhold" ],
   "DEBIT_VC1_FORCE_CRED"         => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC1" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_WITHHOLD"           => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC1 Withhold" ],
);

%shub2_01_00904_def =
( NAME    => "SH2_XNMD_TO_NI1_PORT_FLOW13",
  ADDRESS => 0x0000000050030140,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00904_flds
);


##########################################################################
#                                                                        #
#   SH2_XNMD_TO_IILB_PORT_FLOW                                           #
#                                                                        #
##########################################################################

%shub2_01_00905_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_FORCE_CRED"         => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
   "DEBIT_VC0_FORCE_CRED"         => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%shub2_01_00905_def =
( NAME    => "SH2_XNMD_TO_IILB_PORT_FLOW",
  ADDRESS => 0x0000000050030150,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00905_flds
);


##########################################################################
#                                                                        #
#   SH2_XNMD_ARB_CONFIG                                                  #
#                                                                        #
##########################################################################

%shub2_01_00906_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_SYNC_BYPASS_IN"        => [   1,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Enable Bypass Mode" ],
);

%shub2_01_00906_def =
( NAME    => "SH2_XNMD_ARB_CONFIG",
  ADDRESS => 0x0000000050030160,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00906_flds
);


##########################################################################
#                                                                        #
#   SH2_XNMD_LOCAL_AGE0                                                  #
#                                                                        #
##########################################################################

%shub2_01_00907_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "AGE_WRAP_SRC3_VC2"            => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "XN_NI1 VC2 Pre-Scale Value" ],
   "AGE_WRAP_SRC3_VC0"            => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "XN_NI1 VC0 Pre-Scale Value" ],
   "AGE_WRAP_SRC2_VC2"            => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "XN_NI0 VC3 Pre-Scale Value" ],
   "AGE_WRAP_SRC2_VC0"            => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "XN_NI0 VC1 Pre-Scale Value" ],
   "AGE_WRAP_SRC1_VC2"            => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "XN_NI0 VC2 Pre-Scale Value" ],
   "AGE_WRAP_SRC1_VC0"            => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "XN_NI0 VC0 Pre-Scale Value" ],
   "AGE_WRAP_SRC0_VC2"            => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "XN_IILB VC2 Pre-Scale Value" ],
   "AGE_WRAP_SRC0_VC0"            => [   7,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "XN_IILB VC0 Pre-Scale Value" ],
);

%shub2_01_00907_def =
( NAME    => "SH2_XNMD_LOCAL_AGE0",
  ADDRESS => 0x0000000050030170,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00907_flds
);


##########################################################################
#                                                                        #
#   SH2_XNMD_LOCAL_AGE1                                                  #
#                                                                        #
##########################################################################

%shub2_01_00908_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGE_WRAP_SRC4_VC2"            => [   1,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "XN_NI1 VC3 Pre-Scale Value" ],
   "AGE_WRAP_SRC4_VC0"            => [   2,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "XN_NI1 VC1 Pre-Scale Value" ],
);

%shub2_01_00908_def =
( NAME    => "SH2_XNMD_LOCAL_AGE1",
  ADDRESS => 0x0000000050030180,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00908_flds
);


##########################################################################
#                                                                        #
#   SH2_XNMD_STEERING_FIFO                                               #
#                                                                        #
##########################################################################

%shub2_01_00909_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  45,  19, 0xFFFFE00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT_VC2_CAP"                  => [   1,  40,   5, 0x00001F0000000000, 0x00, 1, 0x0000000000000000, "VC2 Captured Count" ],
   "RSVD1"                        => [   2,  37,   3, 0x000000E000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT_VC2_DYN"                  => [   3,  32,   5, 0x0000001F00000000, 0x00, 0, 0x0000000000000000, "VC2 Dynamic Count" ],
   "RSVD2"                        => [   4,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT_VC0_CAP"                  => [   5,  24,   5, 0x000000001F000000, 0x00, 1, 0x0000000000000000, "VC0 Captured Count" ],
   "RSVD3"                        => [   6,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CNT_VC0_DYN"                  => [   7,  16,   5, 0x00000000001F0000, 0x00, 0, 0x0000000000000000, "VC0 Dynamic Count" ],
   "RSVD4"                        => [   8,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CNT_VC2"                  => [   9,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "VC2 Maximum Counter Value" ],
   "RSVD5"                        => [  10,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CNT_VC0"                  => [  11,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "VC0 Maximum Counter Value" ],
);

%shub2_01_00909_def =
( NAME    => "SH2_XNMD_STEERING_FIFO",
  ADDRESS => 0x0000000050030190,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00909_flds
);


##########################################################################
#                                                                        #
#   SH2_XNMD_CREDIT_MGR_VC0                                              #
#                                                                        #
##########################################################################

%shub2_01_00910_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE_CNT_CAP"                 => [   1,  44,   3, 0x0000700000000000, 0x00, 1, 0x0000000000000000, "Base VC0 Captured Credit Count" ],
   "RSVD1"                        => [   2,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE_CNT_DYN"                 => [   3,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Base VC0 Dynamic Credit Count" ],
   "RSVD2"                        => [   4,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI1_CNT_CAP"                  => [   5,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "NI1 VC0 Captured Credit Count" ],
   "RSVD3"                        => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI1_CNT_DYN"                  => [   7,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Dynamic Credit Count" ],
   "RSVD4"                        => [   8,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI0_CNT_CAP"                  => [   9,  28,   3, 0x0000000070000000, 0x00, 1, 0x0000000000000000, "NI0 VC0 Captured Credit Count" ],
   "RSVD5"                        => [  10,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI0_CNT_DYN"                  => [  11,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Dynamic Credit Count" ],
   "RSVD6"                        => [  12,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_CNT_CAP"                 => [  13,  20,   3, 0x0000000000700000, 0x00, 1, 0x0000000000000000, "IILB VC0 Captured Credit Count" ],
   "RSVD7"                        => [  14,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_CNT_DYN"                 => [  15,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "IILB VC0 Dynamic Credit Count" ],
   "RSVD8"                        => [  16,  11,   5, 0x000000000000F800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CNT"                      => [  17,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "VC0 Maximum Credit Count" ],
);

%shub2_01_00910_def =
( NAME    => "SH2_XNMD_CREDIT_MGR_VC0",
  ADDRESS => 0x00000000500301a0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00910_flds
);


##########################################################################
#                                                                        #
#   SH2_XNMD_CREDIT_MGR_VC2                                              #
#                                                                        #
##########################################################################

%shub2_01_00911_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE_CNT_CAP"                 => [   1,  44,   3, 0x0000700000000000, 0x00, 1, 0x0000000000000000, "Base VC2 Captured Credit Count" ],
   "RSVD1"                        => [   2,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE_CNT_DYN"                 => [   3,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Base VC2 Dynamic Credit Count" ],
   "RSVD2"                        => [   4,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI1_CNT_CAP"                  => [   5,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "NI1 VC2 Captured Credit Count" ],
   "RSVD3"                        => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI1_CNT_DYN"                  => [   7,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Dynamic Credit Count" ],
   "RSVD4"                        => [   8,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI0_CNT_CAP"                  => [   9,  28,   3, 0x0000000070000000, 0x00, 1, 0x0000000000000000, "NI0 VC2 Captured Credit Count" ],
   "RSVD5"                        => [  10,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI0_CNT_DYN"                  => [  11,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Dynamic Credit Count" ],
   "RSVD6"                        => [  12,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_CNT_CAP"                 => [  13,  20,   3, 0x0000000000700000, 0x00, 1, 0x0000000000000000, "IILB VC2 Captured Credit Count" ],
   "RSVD7"                        => [  14,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_CNT_DYN"                 => [  15,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "IILB VC2 Dynamic Credit Count" ],
   "RSVD8"                        => [  16,  11,   5, 0x000000000000F800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CNT"                      => [  17,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "VC2 Maximum Credit Count" ],
);

%shub2_01_00911_def =
( NAME    => "SH2_XNMD_CREDIT_MGR_VC2",
  ADDRESS => 0x00000000500301b0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00911_flds
);


##########################################################################
#                                                                        #
#   SH2_XNII_INTRA_FLOW                                                  #
#                                                                        #
##########################################################################

%shub2_01_00912_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "VC2 credit captured value" ],
   "RSVD1"                        => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  48,   7, 0x007F000000000000, 0x00, 0, 0x0000000000000000, "VC2 credit dynamic value" ],
   "RSVD2"                        => [   4,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_TEST"              => [   5,  40,   7, 0x00007F0000000000, 0x00, 1, 0x0000000000000000, "VC2 credit_test" ],
   "RSVD3"                        => [   6,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   7,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "VC0 credit captured value" ],
   "RSVD4"                        => [   8,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   9,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "VC0 credit dynamic value" ],
   "RSVD5"                        => [  10,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_TEST"              => [  11,  16,   7, 0x00000000007F0000, 0x00, 1, 0x0000000000000000, "VC0 credit_test" ],
   "DEBIT_VC2_FORCE_CRED"         => [  12,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD6"                        => [  13,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [  14,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
   "DEBIT_VC0_FORCE_CRED"         => [  15,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD7"                        => [  16,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [  17,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%shub2_01_00912_def =
( NAME    => "SH2_XNII_INTRA_FLOW",
  ADDRESS => 0x0000000050030200,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00912_flds
);


##########################################################################
#                                                                        #
#   SH2_XNLB_INTRA_FLOW                                                  #
#                                                                        #
##########################################################################

%shub2_01_00913_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "VC2 credit captured value" ],
   "RSVD1"                        => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  48,   7, 0x007F000000000000, 0x00, 0, 0x0000000000000000, "VC2 credit dynamic value" ],
   "RSVD2"                        => [   4,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_TEST"              => [   5,  40,   7, 0x00007F0000000000, 0x00, 1, 0x0000000000000000, "VC2 credit_test" ],
   "RSVD3"                        => [   6,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   7,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "VC0 credit captured value" ],
   "RSVD4"                        => [   8,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   9,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "VC0 credit dynamic value" ],
   "RSVD5"                        => [  10,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_TEST"              => [  11,  16,   7, 0x00000000007F0000, 0x00, 1, 0x0000000000000000, "VC0 credit_test" ],
   "DEBIT_VC2_FORCE_CRED"         => [  12,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD6"                        => [  13,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [  14,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
   "DEBIT_VC0_FORCE_CRED"         => [  15,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD7"                        => [  16,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [  17,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%shub2_01_00913_def =
( NAME    => "SH2_XNLB_INTRA_FLOW",
  ADDRESS => 0x0000000050030210,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00913_flds
);


##########################################################################
#                                                                        #
#   SH2_XNIILB_TO_NI0_INTRA_FLOW_DEBIT                                     #
#                                                                        #
##########################################################################

%shub2_01_00914_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_FORCE_CRED"               => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_WITHHOLD"                 => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
   "VC0_FORCE_CRED"               => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_WITHHOLD"                 => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 withhold" ],
);

%shub2_01_00914_def =
( NAME    => "SH2_XNIILB_TO_NI0_INTRA_FLOW_DEBIT",
  ADDRESS => 0x0000000050030220,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00914_flds
);


##########################################################################
#                                                                        #
#   SH2_XNIILB_TO_NI0_INTRA_FLOW_DEBIT13                                     #
#                                                                        #
##########################################################################

%shub2_01_00915_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_CAP"                      => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_DYN"                      => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_CAP"                      => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_DYN"                      => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_FORCE_CRED"               => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC3" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_WITHHOLD"                 => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC3 Withhold" ],
   "VC1_FORCE_CRED"               => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC1" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_WITHHOLD"                 => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC1 Withhold" ],
);

%shub2_01_00915_def =
( NAME    => "SH2_XNIILB_TO_NI0_INTRA_FLOW_DEBIT13",
  ADDRESS => 0x0000000050030230,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00915_flds
);


##########################################################################
#                                                                        #
#   SH2_XNIILB_TO_NI1_INTRA_FLOW_DEBIT                                     #
#                                                                        #
##########################################################################

%shub2_01_00916_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_FORCE_CRED"               => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_WITHHOLD"                 => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
   "VC0_FORCE_CRED"               => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_WITHHOLD"                 => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 withhold" ],
);

%shub2_01_00916_def =
( NAME    => "SH2_XNIILB_TO_NI1_INTRA_FLOW_DEBIT",
  ADDRESS => 0x0000000050030240,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00916_flds
);


##########################################################################
#                                                                        #
#   SH2_XNIILB_TO_NI1_INTRA_FLOW_DEBIT13                                     #
#                                                                        #
##########################################################################

%shub2_01_00917_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_CAP"                      => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_DYN"                      => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_CAP"                      => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_DYN"                      => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_FORCE_CRED"               => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC3" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_WITHHOLD"                 => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC3 Withhold" ],
   "VC1_FORCE_CRED"               => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC1" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_WITHHOLD"                 => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC1 Withhold" ],
);

%shub2_01_00917_def =
( NAME    => "SH2_XNIILB_TO_NI1_INTRA_FLOW_DEBIT13",
  ADDRESS => 0x0000000050030250,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00917_flds
);


##########################################################################
#                                                                        #
#   SH2_XNIILB_TO_IILB_INTRA_FLOW_DEBIT                                     #
#                                                                        #
##########################################################################

%shub2_01_00918_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_FORCE_CRED"               => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_WITHHOLD"                 => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
   "VC0_FORCE_CRED"               => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_WITHHOLD"                 => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 withhold" ],
);

%shub2_01_00918_def =
( NAME    => "SH2_XNIILB_TO_IILB_INTRA_FLOW_DEBIT",
  ADDRESS => 0x0000000050030260,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00918_flds
);


##########################################################################
#                                                                        #
#   SH2_XNIILB_FR_NI0_INTRA_FLOW_CREDIT                                     #
#                                                                        #
##########################################################################

%shub2_01_00919_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "VC2 credit captured value" ],
   "RSVD1"                        => [   2,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "VC2 credit dynamic value" ],
   "RSVD2"                        => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_TEST"                     => [   5,  24,   7, 0x000000007F000000, 0x00, 1, 0x0000000000000000, "VC2 credit_test" ],
   "RSVD3"                        => [   6,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   7,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "VC0 credit captured value" ],
   "RSVD4"                        => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   9,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "VC0 credit dynamic value" ],
   "RSVD5"                        => [  10,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_TEST"                     => [  11,   0,   7, 0x000000000000007F, 0x00, 1, 0x0000000000000000, "VC0 credit_test" ],
);

%shub2_01_00919_def =
( NAME    => "SH2_XNIILB_FR_NI0_INTRA_FLOW_CREDIT",
  ADDRESS => 0x00000000500302b0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00919_flds
);


##########################################################################
#                                                                        #
#   SH2_XNIILB_FR_NI1_INTRA_FLOW_CREDIT                                     #
#                                                                        #
##########################################################################

%shub2_01_00920_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "VC2 credit captured value" ],
   "RSVD1"                        => [   2,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "VC2 credit dynamic value" ],
   "RSVD2"                        => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_TEST"                     => [   5,  24,   7, 0x000000007F000000, 0x00, 1, 0x0000000000000000, "VC2 credit_test" ],
   "RSVD3"                        => [   6,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   7,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "VC0 credit captured value" ],
   "RSVD4"                        => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   9,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "VC0 credit dynamic value" ],
   "RSVD5"                        => [  10,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_TEST"                     => [  11,   0,   7, 0x000000000000007F, 0x00, 1, 0x0000000000000000, "VC0 credit_test" ],
);

%shub2_01_00920_def =
( NAME    => "SH2_XNIILB_FR_NI1_INTRA_FLOW_CREDIT",
  ADDRESS => 0x00000000500302c0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00920_flds
);


##########################################################################
#                                                                        #
#   SH2_XNIILB_FR_IILB_INTRA_FLOW_CREDIT                                     #
#                                                                        #
##########################################################################

%shub2_01_00921_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "VC2 credit captured value" ],
   "RSVD1"                        => [   2,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "VC2 credit dynamic value" ],
   "RSVD2"                        => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_TEST"                     => [   5,  24,   7, 0x000000007F000000, 0x00, 1, 0x0000000000000000, "VC2 credit_test" ],
   "RSVD3"                        => [   6,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   7,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "VC0 credit captured value" ],
   "RSVD4"                        => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   9,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "VC0 credit dynamic value" ],
   "RSVD5"                        => [  10,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_TEST"                     => [  11,   0,   7, 0x000000000000007F, 0x00, 1, 0x0000000000000000, "VC0 credit_test" ],
);

%shub2_01_00921_def =
( NAME    => "SH2_XNIILB_FR_IILB_INTRA_FLOW_CREDIT",
  ADDRESS => 0x00000000500302d0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00921_flds
);


##########################################################################
#                                                                        #
#   SH2_XNIILB_II_FIFO_CREDIT_CNT                                        #
#                                                                        #
##########################################################################

%shub2_01_00922_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  46,  18, 0xFFFFC00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  40,   6, 0x00003F0000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  38,   2, 0x000000C000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  22,  10, 0x00000000FFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   5,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   7,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
);

%shub2_01_00922_def =
( NAME    => "SH2_XNIILB_II_FIFO_CREDIT_CNT",
  ADDRESS => 0x0000000050030300,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00922_flds
);


##########################################################################
#                                                                        #
#   SH2_XNIILB_LB_FIFO_CREDIT_CNT                                        #
#                                                                        #
##########################################################################

%shub2_01_00923_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  46,  18, 0xFFFFC00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  40,   6, 0x00003F0000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  38,   2, 0x000000C000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  22,  10, 0x00000000FFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   5,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   7,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
);

%shub2_01_00923_def =
( NAME    => "SH2_XNIILB_LB_FIFO_CREDIT_CNT",
  ADDRESS => 0x0000000050030310,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00923_flds
);


##########################################################################
#                                                                        #
#   SH2_XNIILB_ARB_CONFIG_SI                                             #
#                                                                        #
##########################################################################

%shub2_01_00924_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_FULL_BYP_SI"           => [   1,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Enable Bypass Mode" ],
);

%shub2_01_00924_def =
( NAME    => "SH2_XNIILB_ARB_CONFIG_SI",
  ADDRESS => 0x0000000050030320,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00924_flds
);


##########################################################################
#                                                                        #
#   SH2_XNIILB_ARB_CONFIG_SO                                             #
#                                                                        #
##########################################################################

%shub2_01_00925_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_FULL_BYP_SO"           => [   1,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Enable Bypass Mode" ],
);

%shub2_01_00925_def =
( NAME    => "SH2_XNIILB_ARB_CONFIG_SO",
  ADDRESS => 0x0000000050030330,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00925_flds
);


##########################################################################
#                                                                        #
#   SH2_XNIILB_AGE_WRAP0                                                 #
#                                                                        #
##########################################################################

%shub2_01_00926_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SRC1_VC1_SI"                  => [   1,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "LB VC2 Pre-Scale Value" ],
   "SRC1_VC0_SI"                  => [   2,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "LB VC0 Pre-Scale Value" ],
   "SRC0_VC1_SI"                  => [   3,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "II VC2 Pre-Scale Value" ],
   "SRC0_VC0_SI"                  => [   4,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "II VC0 Pre-Scale Value" ],
);

%shub2_01_00926_def =
( NAME    => "SH2_XNIILB_AGE_WRAP0",
  ADDRESS => 0x0000000050030340,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00926_flds
);


##########################################################################
#                                                                        #
#   SH2_XNIILB_AGE_WRAP1                                                 #
#                                                                        #
##########################################################################

%shub2_01_00927_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SRC2_VC1_SO"                  => [   1,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "XN_NI0 VC3 Pre-Scale Value" ],
   "SRC2_VC0_SO"                  => [   2,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "XN_NI0 VC1 Pre-Scale Value" ],
   "SRC1_VC1_SO"                  => [   3,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "XN_NI0 VC2 Pre-Scale Value" ],
   "SRC1_VC0_SO"                  => [   4,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "XN_NI0 VC0 Pre-Scale Value" ],
   "SRC0_VC1_SO"                  => [   5,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "XN_IILB VC2 Pre-Scale Value" ],
   "SRC0_VC0_SO"                  => [   6,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "XN_IILB VC0 Pre-Scale Value" ],
);

%shub2_01_00927_def =
( NAME    => "SH2_XNIILB_AGE_WRAP1",
  ADDRESS => 0x0000000050030350,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00927_flds
);


##########################################################################
#                                                                        #
#   SH2_XNIILB_AGE_WRAP2                                                 #
#                                                                        #
##########################################################################

%shub2_01_00928_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SRC6_VC1_SO"                  => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "XN_MD VC2 Pre-Scale Value" ],
   "SRC6_VC0_SO"                  => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "XN_MD VC0 Pre-Scale Value" ],
   "SRC5_VC1_SO"                  => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "XN_PI VC2 Pre-Scale Value" ],
   "SRC5_VC0_SO"                  => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "XN_PI VC0 Pre-Scale Value" ],
   "SRC4_VC1_SO"                  => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "XN_NI1 VC3 Pre-Scale Value" ],
   "SRC4_VC0_SO"                  => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "XN_NI1 VC1 Pre-Scale Value" ],
   "SRC3_VC1_SO"                  => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "XN_NI1 VC2 Pre-Scale Value" ],
   "SRC3_VC0_SO"                  => [   7,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "XN_NI1 VC0 Pre-Scale Value" ],
);

%shub2_01_00928_def =
( NAME    => "SH2_XNIILB_AGE_WRAP2",
  ADDRESS => 0x0000000050030360,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00928_flds
);


##########################################################################
#                                                                        #
#   SH2_XNIILB_TO_PI_INTRA_FLOW_SIC_DEBIT_VC0                                     #
#                                                                        #
##########################################################################

%shub2_01_00929_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_CAP"                     => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 Data FIFO captured depth" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_DYN"                     => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 Data FIFO dynamic depth" ],
   "RSVD2"                        => [   4,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_CAP"                      => [   5,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VC0 Header FIFO captured depth" ],
   "RSVD3"                        => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_DYN"                      => [   7,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VC0 Header FIFO dynamic depth" ],
   "FORCE_CRED"                   => [   8,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD4"                        => [   9,   5,   2, 0x0000000000000060, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WITHHOLD"                     => [  10,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%shub2_01_00929_def =
( NAME    => "SH2_XNIILB_TO_PI_INTRA_FLOW_SIC_DEBIT_VC0",
  ADDRESS => 0x0000000050030270,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00929_flds
);


##########################################################################
#                                                                        #
#   SH2_XNIILB_TO_PI_INTRA_FLOW_SIC_DEBIT_VC2                                     #
#                                                                        #
##########################################################################

%shub2_01_00930_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_CAP"                     => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC2 Data FIFO captured depth" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_DYN"                     => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC2 Data FIFO dynamic depth" ],
   "RSVD2"                        => [   4,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_CAP"                      => [   5,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VC2 Header FIFO captured depth" ],
   "RSVD3"                        => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_DYN"                      => [   7,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VC2 Header FIFO dynamic depth" ],
   "FORCE_CRED"                   => [   8,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD4"                        => [   9,   5,   2, 0x0000000000000060, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WITHHOLD"                     => [  10,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
);

%shub2_01_00930_def =
( NAME    => "SH2_XNIILB_TO_PI_INTRA_FLOW_SIC_DEBIT_VC2",
  ADDRESS => 0x0000000050030280,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00930_flds
);


##########################################################################
#                                                                        #
#   SH2_XNIILB_TO_MD_INTRA_FLOW_SIC_DEBIT_VC0                                     #
#                                                                        #
##########################################################################

%shub2_01_00931_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_CAP"                     => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 Data FIFO captured depth" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_DYN"                     => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 Data FIFO dynamic depth" ],
   "RSVD2"                        => [   4,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_CAP"                      => [   5,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VC0 Header FIFO captured depth" ],
   "RSVD3"                        => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_DYN"                      => [   7,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VC0 Header FIFO dynamic depth" ],
   "FORCE_CRED"                   => [   8,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD4"                        => [   9,   5,   2, 0x0000000000000060, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WITHHOLD"                     => [  10,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%shub2_01_00931_def =
( NAME    => "SH2_XNIILB_TO_MD_INTRA_FLOW_SIC_DEBIT_VC0",
  ADDRESS => 0x0000000050030290,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00931_flds
);


##########################################################################
#                                                                        #
#   SH2_XNIILB_TO_MD_INTRA_FLOW_SIC_DEBIT_VC2                                     #
#                                                                        #
##########################################################################

%shub2_01_00932_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_CAP"                     => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC2 Data FIFO captured depth" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_DYN"                     => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC2 Data FIFO dynamic depth" ],
   "RSVD2"                        => [   4,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_CAP"                      => [   5,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VC2 Header FIFO captured depth" ],
   "RSVD3"                        => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_DYN"                      => [   7,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VC2 Header FIFO dynamic depth" ],
   "FORCE_CRED"                   => [   8,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD4"                        => [   9,   5,   2, 0x0000000000000060, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WITHHOLD"                     => [  10,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
);

%shub2_01_00932_def =
( NAME    => "SH2_XNIILB_TO_MD_INTRA_FLOW_SIC_DEBIT_VC2",
  ADDRESS => 0x00000000500302a0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00932_flds
);


##########################################################################
#                                                                        #
#   SH2_XNIILB_FR_MD_INTRA_FLOW_CREDIT                                     #
#                                                                        #
##########################################################################

%shub2_01_00933_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "VC2 credit captured value" ],
   "RSVD1"                        => [   2,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "VC2 credit dynamic value" ],
   "RSVD2"                        => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_TEST"                     => [   5,  24,   7, 0x000000007F000000, 0x00, 1, 0x0000000000000000, "VC2 credit_test" ],
   "RSVD3"                        => [   6,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   7,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "VC0 credit captured value" ],
   "RSVD4"                        => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   9,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "VC0 credit dynamic value" ],
   "RSVD5"                        => [  10,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_TEST"                     => [  11,   0,   7, 0x000000000000007F, 0x00, 1, 0x0000000000000000, "VC0 credit_test" ],
);

%shub2_01_00933_def =
( NAME    => "SH2_XNIILB_FR_MD_INTRA_FLOW_CREDIT",
  ADDRESS => 0x00000000500302e0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00933_flds
);


##########################################################################
#                                                                        #
#   SH2_XNIILB_FR_PI_INTRA_FLOW_CREDIT                                     #
#                                                                        #
##########################################################################

%shub2_01_00934_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "VC2 credit captured value" ],
   "RSVD1"                        => [   2,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "VC2 credit dynamic value" ],
   "RSVD2"                        => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_TEST"                     => [   5,  24,   7, 0x000000007F000000, 0x00, 1, 0x0000000000000000, "VC2 credit_test" ],
   "RSVD3"                        => [   6,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   7,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "VC0 credit captured value" ],
   "RSVD4"                        => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   9,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "VC0 credit dynamic value" ],
   "RSVD5"                        => [  10,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_TEST"                     => [  11,   0,   7, 0x000000000000007F, 0x00, 1, 0x0000000000000000, "VC0 credit_test" ],
);

%shub2_01_00934_def =
( NAME    => "SH2_XNIILB_FR_PI_INTRA_FLOW_CREDIT",
  ADDRESS => 0x00000000500302f0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00934_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI0_TO_IILB_INTRA_FLOW_DEBIT                                     #
#                                                                        #
##########################################################################

%shub2_01_00935_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_FORCE_CRED"               => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_WITHHOLD"                 => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
   "VC0_FORCE_CRED"               => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_WITHHOLD"                 => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 withhold" ],
);

%shub2_01_00935_def =
( NAME    => "SH2_XNNI0_TO_IILB_INTRA_FLOW_DEBIT",
  ADDRESS => 0x0000000050030400,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00935_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI0_TO_PI_INTRA_FLOW_SIC_DEBIT_VC0                                     #
#                                                                        #
##########################################################################

%shub2_01_00936_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_CAP"                     => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 Data FIFO captured depth" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_DYN"                     => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 Data FIFO dynamic depth" ],
   "RSVD2"                        => [   4,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_CAP"                      => [   5,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VC0 Header FIFO captured depth" ],
   "RSVD3"                        => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_DYN"                      => [   7,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VC0 Header FIFO dynamic depth" ],
   "FORCE_CRED"                   => [   8,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD4"                        => [   9,   5,   2, 0x0000000000000060, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WITHHOLD"                     => [  10,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%shub2_01_00936_def =
( NAME    => "SH2_XNNI0_TO_PI_INTRA_FLOW_SIC_DEBIT_VC0",
  ADDRESS => 0x0000000050030410,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00936_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI0_TO_PI_INTRA_FLOW_SIC_DEBIT_VC2                                     #
#                                                                        #
##########################################################################

%shub2_01_00937_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_CAP"                     => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC2 Data FIFO captured depth" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_DYN"                     => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC2 Data FIFO dynamic depth" ],
   "RSVD2"                        => [   4,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_CAP"                      => [   5,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VC2 Header FIFO captured depth" ],
   "RSVD3"                        => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_DYN"                      => [   7,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VC2 Header FIFO dynamic depth" ],
   "FORCE_CRED"                   => [   8,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD4"                        => [   9,   5,   2, 0x0000000000000060, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WITHHOLD"                     => [  10,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
);

%shub2_01_00937_def =
( NAME    => "SH2_XNNI0_TO_PI_INTRA_FLOW_SIC_DEBIT_VC2",
  ADDRESS => 0x0000000050030420,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00937_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI0_TO_MD_INTRA_FLOW_SIC_DEBIT_VC0                                     #
#                                                                        #
##########################################################################

%shub2_01_00938_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_CAP"                     => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 Data FIFO captured depth" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_DYN"                     => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 Data FIFO dynamic depth" ],
   "RSVD2"                        => [   4,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_CAP"                      => [   5,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VC0 Header FIFO captured depth" ],
   "RSVD3"                        => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_DYN"                      => [   7,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VC0 Header FIFO dynamic depth" ],
   "FORCE_CRED"                   => [   8,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD4"                        => [   9,   5,   2, 0x0000000000000060, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WITHHOLD"                     => [  10,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%shub2_01_00938_def =
( NAME    => "SH2_XNNI0_TO_MD_INTRA_FLOW_SIC_DEBIT_VC0",
  ADDRESS => 0x0000000050030430,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00938_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI0_TO_MD_INTRA_FLOW_SIC_DEBIT_VC2                                     #
#                                                                        #
##########################################################################

%shub2_01_00939_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_CAP"                     => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC2 Data FIFO captured depth" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_DYN"                     => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC2 Data FIFO dynamic depth" ],
   "RSVD2"                        => [   4,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_CAP"                      => [   5,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VC2 Header FIFO captured depth" ],
   "RSVD3"                        => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_DYN"                      => [   7,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VC2 Header FIFO dynamic depth" ],
   "FORCE_CRED"                   => [   8,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD4"                        => [   9,   5,   2, 0x0000000000000060, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WITHHOLD"                     => [  10,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
);

%shub2_01_00939_def =
( NAME    => "SH2_XNNI0_TO_MD_INTRA_FLOW_SIC_DEBIT_VC2",
  ADDRESS => 0x0000000050030440,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00939_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI0_0_INTRANI_FLOW                                             #
#                                                                        #
##########################################################################

%shub2_01_00940_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,   8,  16, 0x0000000000FFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_FORCE_CRED"         => [   5,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD3"                        => [   6,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [   7,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%shub2_01_00940_def =
( NAME    => "SH2_XNNI0_0_INTRANI_FLOW",
  ADDRESS => 0x0000000050030450,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00940_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI0_1_INTRANI_FLOW                                             #
#                                                                        #
##########################################################################

%shub2_01_00941_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_CAP"                      => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_DYN"                      => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,   8,  16, 0x0000000000FFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_FORCE_CRED"         => [   5,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC1" ],
   "RSVD3"                        => [   6,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_WITHHOLD"           => [   7,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC1 Withhold" ],
);

%shub2_01_00941_def =
( NAME    => "SH2_XNNI0_1_INTRANI_FLOW",
  ADDRESS => 0x0000000050030460,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00941_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI0_2_INTRANI_FLOW                                             #
#                                                                        #
##########################################################################

%shub2_01_00942_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,   8,  16, 0x0000000000FFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_FORCE_CRED"         => [   5,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD3"                        => [   6,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [   7,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
);

%shub2_01_00942_def =
( NAME    => "SH2_XNNI0_2_INTRANI_FLOW",
  ADDRESS => 0x0000000050030470,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00942_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI0_3_INTRANI_FLOW                                             #
#                                                                        #
##########################################################################

%shub2_01_00943_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_CAP"                      => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_DYN"                      => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,   8,  16, 0x0000000000FFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_FORCE_CRED"         => [   5,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC3" ],
   "RSVD3"                        => [   6,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_WITHHOLD"           => [   7,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC3 Withhold" ],
);

%shub2_01_00943_def =
( NAME    => "SH2_XNNI0_3_INTRANI_FLOW",
  ADDRESS => 0x0000000050030480,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00943_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI0_VCSWITCH_FLOW                                              #
#                                                                        #
##########################################################################

%shub2_01_00944_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_MGR_ENABLE"            => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Enable credit manager mode for pi/md" ],
   "RSVD1"                        => [   2,  25,   7, 0x00000000FE000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_VCFIFO_SWITCH"           => [   3,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Select VC0/2 or VC1/3 for IILB" ],
   "RSVD2"                        => [   4,  17,   7, 0x0000000000FE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MD_VCFIFO_SWITCH"             => [   5,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Select VC0/2 or VC1/3 for MD" ],
   "RSVD3"                        => [   6,   9,   7, 0x000000000000FE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PI_VCFIFO_SWITCH"             => [   7,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Select VC0/2 or VC1/3 for PI" ],
   "RSVD4"                        => [   8,   1,   7, 0x00000000000000FE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_VCFIFO_DATELINE_SWITCH"    => [   9,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Swap VC0/2 with VC1/3" ],
);

%shub2_01_00944_def =
( NAME    => "SH2_XNNI0_VCSWITCH_FLOW",
  ADDRESS => 0x0000000050030490,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00944_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI0_TIMER_REG                                                  #
#                                                                        #
##########################################################################

%shub2_01_00945_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "QUEUECNTENABLE_REG"           => [   1,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "Queue Counter Enable" ],
   "LINKRESETENABLE_REG"          => [   2,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "Link Reset Enable" ],
   "LINKCLEANUP_REG"              => [   3,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "Link Clean Up" ],
   "TIMEOUT_REG"                  => [   4,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "Master Timeout Counter" ],
);

%shub2_01_00945_def =
( NAME    => "SH2_XNNI0_TIMER_REG",
  ADDRESS => 0x00000000500304a0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00945_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI0_IILB_TAILTO                                                #
#                                                                        #
##########################################################################

%shub2_01_00946_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VC3_CAP"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter captured value" ],
   "VC3_DYN"                      => [   1,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter dynamic value" ],
   "RSVD0"                        => [   2,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_LIMIT"                    => [   3,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "vc3 limit reg, zero disables functionality" ],
   "VC2_CAP"                      => [   4,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "vc2 counter captured value" ],
   "VC2_DYN"                      => [   5,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "vc2 counter dynamic value" ],
   "RSVD1"                        => [   6,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_LIMIT"                    => [   7,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "vc2 limit reg, zero disables functionality" ],
   "VC1_CAP"                      => [   8,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "vc1 counter captured value" ],
   "VC1_DYN"                      => [   9,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "vc1 counter dynamic value" ],
   "RSVD2"                        => [  10,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_LIMIT"                    => [  11,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "vc1 limit reg, zero disables functionality" ],
   "VC0_CAP"                      => [  12,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "vc0 counter captured value" ],
   "VC0_DYN"                      => [  13,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "vc0 counter dynamic value" ],
   "RSVD3"                        => [  14,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_LIMIT"                    => [  15,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "vc0 limit reg, zero disables functionality" ],
);

%shub2_01_00946_def =
( NAME    => "SH2_XNNI0_IILB_TAILTO",
  ADDRESS => 0x00000000500304b0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00946_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI0_NI_TAILTO                                                  #
#                                                                        #
##########################################################################

%shub2_01_00947_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VC3_CAP"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter captured value" ],
   "VC3_DYN"                      => [   1,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter dynamic value" ],
   "RSVD0"                        => [   2,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_LIMIT"                    => [   3,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "vc3 limit reg, zero disables functionality" ],
   "VC2_CAP"                      => [   4,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "vc2 counter captured value" ],
   "VC2_DYN"                      => [   5,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "vc2 counter dynamic value" ],
   "RSVD1"                        => [   6,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_LIMIT"                    => [   7,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "vc2 limit reg, zero disables functionality" ],
   "VC1_CAP"                      => [   8,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "vc1 counter captured value" ],
   "VC1_DYN"                      => [   9,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "vc1 counter dynamic value" ],
   "RSVD2"                        => [  10,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_LIMIT"                    => [  11,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "vc1 limit reg, zero disables functionality" ],
   "VC0_CAP"                      => [  12,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "vc0 counter captured value" ],
   "VC0_DYN"                      => [  13,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "vc0 counter dynamic value" ],
   "RSVD3"                        => [  14,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_LIMIT"                    => [  15,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "vc0 limit reg, zero disables functionality" ],
);

%shub2_01_00947_def =
( NAME    => "SH2_XNNI0_NI_TAILTO",
  ADDRESS => 0x00000000500304c0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00947_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI0_NI_TAILTO_SUPPORT                                          #
#                                                                        #
##########################################################################

%shub2_01_00948_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INJECT_TAIL_ENABLE"           => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "" ],
);

%shub2_01_00948_def =
( NAME    => "SH2_XNNI0_NI_TAILTO_SUPPORT",
  ADDRESS => 0x00000000500304f0,
  NOTE    => "This register adds a 'tail injection' feature to the basic Tail note Timeout functionality. If enabled, when a Tail Timeout Limi",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00948_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI0_PI_TAILTO                                                  #
#                                                                        #
##########################################################################

%shub2_01_00949_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VC3_CAP"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter captured value" ],
   "VC3_DYN"                      => [   1,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter dynamic value" ],
   "RSVD0"                        => [   2,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_LIMIT"                    => [   3,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "vc3 limit reg, zero disables functionality" ],
   "VC2_CAP"                      => [   4,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "vc2 counter captured value" ],
   "VC2_DYN"                      => [   5,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "vc2 counter dynamic value" ],
   "RSVD1"                        => [   6,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_LIMIT"                    => [   7,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "vc2 limit reg, zero disables functionality" ],
   "VC1_CAP"                      => [   8,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "vc1 counter captured value" ],
   "VC1_DYN"                      => [   9,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "vc1 counter dynamic value" ],
   "RSVD2"                        => [  10,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_LIMIT"                    => [  11,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "vc1 limit reg, zero disables functionality" ],
   "VC0_CAP"                      => [  12,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "vc0 counter captured value" ],
   "VC0_DYN"                      => [  13,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "vc0 counter dynamic value" ],
   "RSVD3"                        => [  14,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_LIMIT"                    => [  15,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "vc0 limit reg, zero disables functionality" ],
);

%shub2_01_00949_def =
( NAME    => "SH2_XNNI0_PI_TAILTO",
  ADDRESS => 0x00000000500304d0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00949_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI0_MD_TAILTO                                                  #
#                                                                        #
##########################################################################

%shub2_01_00950_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VC3_CAP"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter captured value" ],
   "VC3_DYN"                      => [   1,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter dynamic value" ],
   "RSVD0"                        => [   2,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_LIMIT"                    => [   3,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "vc3 limit reg, zero disables functionality" ],
   "VC2_CAP"                      => [   4,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "vc2 counter captured value" ],
   "VC2_DYN"                      => [   5,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "vc2 counter dynamic value" ],
   "RSVD1"                        => [   6,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_LIMIT"                    => [   7,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "vc2 limit reg, zero disables functionality" ],
   "VC1_CAP"                      => [   8,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "vc1 counter captured value" ],
   "VC1_DYN"                      => [   9,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "vc1 counter dynamic value" ],
   "RSVD2"                        => [  10,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_LIMIT"                    => [  11,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "vc1 limit reg, zero disables functionality" ],
   "VC0_CAP"                      => [  12,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "vc0 counter captured value" ],
   "VC0_DYN"                      => [  13,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "vc0 counter dynamic value" ],
   "RSVD3"                        => [  14,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_LIMIT"                    => [  15,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "vc0 limit reg, zero disables functionality" ],
);

%shub2_01_00950_def =
( NAME    => "SH2_XNNI0_MD_TAILTO",
  ADDRESS => 0x00000000500304e0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00950_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI0_DEADLCK_FLOW                                               #
#                                                                        #
##########################################################################

%shub2_01_00951_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VC3_CAP"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter captured value" ],
   "VC3_DYN"                      => [   1,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter dynamic value" ],
   "RSVD0"                        => [   2,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_LIMIT"                    => [   3,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "vc3 limit reg, zero disables functionality" ],
   "VC2_CAP"                      => [   4,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "vc2 counter captured value" ],
   "VC2_DYN"                      => [   5,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "vc2 counter dynamic value" ],
   "RSVD1"                        => [   6,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_LIMIT"                    => [   7,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "vc2 limit reg, zero disables functionality" ],
   "VC1_CAP"                      => [   8,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "vc1 counter captured value" ],
   "VC1_DYN"                      => [   9,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "vc1 counter dynamic value" ],
   "RSVD2"                        => [  10,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_LIMIT"                    => [  11,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "vc1 limit reg, zero disables functionality" ],
   "VC0_CAP"                      => [  12,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "vc0 counter captured value" ],
   "VC0_DYN"                      => [  13,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "vc0 counter dynamic value" ],
   "RSVD3"                        => [  14,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_LIMIT"                    => [  15,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "vc0 limit reg, zero disables functionality" ],
);

%shub2_01_00951_def =
( NAME    => "SH2_XNNI0_DEADLCK_FLOW",
  ADDRESS => 0x0000000050030500,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00951_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI0_DEADLCK_FLOW_SUPPORT                                       #
#                                                                        #
##########################################################################

%shub2_01_00952_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FLUSH_ENABLE"                 => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "flush enable" ],
);

%shub2_01_00952_def =
( NAME    => "SH2_XNNI0_DEADLCK_FLOW_SUPPORT",
  ADDRESS => 0x0000000050030510,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00952_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI0_INJECT_AGE                                                 #
#                                                                        #
##########################################################################

%shub2_01_00953_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REPLY_INJECT"                 => [   1,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Value of AGE field for outgoing replies" ],
   "REQUEST_INJECT"               => [   2,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Value of AGE field for outgoing requests" ],
);

%shub2_01_00953_def =
( NAME    => "SH2_XNNI0_INJECT_AGE",
  ADDRESS => 0x0000000050030520,
  NOTE    => "This register allows the age field of network bound messages coming note from the II, LB, and in the case of SHub2 , the PI and ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00953_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI0_NETWORK_AGE                                                #
#                                                                        #
##########################################################################

%shub2_01_00954_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  49,  15, 0xFFFE000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FR_MMR_AGE_THRESHOLD_ENABLE"  => [   1,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "Age Threshold Request Enable" ],
   "FR_MMR_AGE_THRESHOLD"         => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "Age Threshold" ],
   "RSVD1"                        => [   3,  33,   7, 0x000000FE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FR_MMR_FREERUN_ENABLE"        => [   4,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "Freerun Counter Enable" ],
   "RSVD2"                        => [   5,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FR_MMR_MUX_SEL3"              => [   6,  24,   5, 0x000000001F000000, 0x00, 1, 0x0000000000000000, "Mux Select3" ],
   "RSVD3"                        => [   7,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FR_MMR_MUX_SEL2"              => [   8,  16,   5, 0x00000000001F0000, 0x00, 1, 0x0000000000000000, "Mux Select2" ],
   "RSVD4"                        => [   9,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FR_MMR_MUX_SEL1"              => [  10,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "Mux Select1" ],
   "RSVD5"                        => [  11,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FR_MMR_MUX_SEL0"              => [  12,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Mux Select0" ],
);

%shub2_01_00954_def =
( NAME    => "SH2_XNNI0_NETWORK_AGE",
  ADDRESS => 0x0000000050030530,
  NOTE    => "This register configures the Network Aging features of the XN. note There is one of these registers for each of the two NI ports",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00954_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI0_ARB_CONFIG                                                 #
#                                                                        #
##########################################################################

%shub2_01_00955_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_SYNC_BYPASS_IN"        => [   1,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Enable Bypass Mode" ],
   "EN_THROT_SRC3"                => [   2,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Enable throttling of MD requests" ],
   "EN_THROT_SRC2"                => [   3,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Enable throttling of PI requests" ],
   "EN_THROT_SRC1"                => [   4,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Enable throttling of other NI requests" ],
   "EN_THROT_SRC0"                => [   5,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable throttling of II and LB requests" ],
);

%shub2_01_00955_def =
( NAME    => "SH2_XNNI0_ARB_CONFIG",
  ADDRESS => 0x0000000050030540,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00955_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI0_LOCAL_AGE0                                                 #
#                                                                        #
##########################################################################

%shub2_01_00956_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "AGE_WRAP_SRC1_VC3"            => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "Other XN_NI VC3 Pre-Scale Value" ],
   "AGE_WRAP_SRC1_VC2"            => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Other XN_NI VC2 Pre-Scale Value" ],
   "AGE_WRAP_SRC1_VC1"            => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "Other XN_NI VC1 Pre-Scale Value" ],
   "AGE_WRAP_SRC1_VC0"            => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Other XN_NI VC0 Pre-Scale Value" ],
   "AGE_WRAP_SRC0_VC3"            => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "XN_IILB VC3 Pre-Scale Value" ],
   "AGE_WRAP_SRC0_VC2"            => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "XN_IILB VC2 Pre-Scale Value" ],
   "AGE_WRAP_SRC0_VC1"            => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "XN_IILB VC1 Pre-Scale Value" ],
   "AGE_WRAP_SRC0_VC0"            => [   7,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "XN_IILB VC0 Pre-Scale Value" ],
);

%shub2_01_00956_def =
( NAME    => "SH2_XNNI0_LOCAL_AGE0",
  ADDRESS => 0x0000000050030550,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00956_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI0_LOCAL_AGE1                                                 #
#                                                                        #
##########################################################################

%shub2_01_00957_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "AGE_WRAP_SRC3_VC3"            => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "XN_MD VC3 Pre-Scale Value" ],
   "AGE_WRAP_SRC3_VC2"            => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "XN_MD VC2 Pre-Scale Value" ],
   "AGE_WRAP_SRC3_VC1"            => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "XN_MD VC1 Pre-Scale Value" ],
   "AGE_WRAP_SRC3_VC0"            => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "XN_MD VC0 Pre-Scale Value" ],
   "AGE_WRAP_SRC2_VC3"            => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "XN_PI VC3 Pre-Scale Value" ],
   "AGE_WRAP_SRC2_VC2"            => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "XN_PI VC2 Pre-Scale Value" ],
   "AGE_WRAP_SRC2_VC1"            => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "XN_PI VC1 Pre-Scale Value" ],
   "AGE_WRAP_SRC2_VC0"            => [   7,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "XN_PI VC0 Pre-Scale Value" ],
);

%shub2_01_00957_def =
( NAME    => "SH2_XNNI0_LOCAL_AGE1",
  ADDRESS => 0x0000000050030560,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00957_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI0_QUEUE_CNTR                                                 #
#                                                                        #
##########################################################################

%shub2_01_00958_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LAST_USED_VC3"                => [   1,  56,   6, 0x3F00000000000000, 0x00, 1, 0x0000000000000000, "VC3 Queue Counter Last Value Used" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DYNAMIC_VC3"                  => [   3,  48,   6, 0x003F000000000000, 0x00, 1, 0x0000000000000000, "VC3 Dynamic Queue Counter Value" ],
   "RSVD2"                        => [   4,  46,   2, 0x0000C00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LAST_USED_VC2"                => [   5,  40,   6, 0x00003F0000000000, 0x00, 1, 0x0000000000000000, "VC2 Queue Counter Last Value Used" ],
   "RSVD3"                        => [   6,  38,   2, 0x000000C000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DYNAMIC_VC2"                  => [   7,  32,   6, 0x0000003F00000000, 0x00, 1, 0x0000000000000000, "VC2 Dynamic Queue Counter Value" ],
   "RSVD4"                        => [   8,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LAST_USED_VC1"                => [   9,  24,   6, 0x000000003F000000, 0x00, 1, 0x0000000000000000, "VC1 Queue Counter Last Value Used" ],
   "RSVD5"                        => [  10,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DYNAMIC_VC1"                  => [  11,  16,   6, 0x00000000003F0000, 0x00, 1, 0x0000000000000000, "VC1 Dynamic Queue Counter Value" ],
   "RSVD6"                        => [  12,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LAST_USED_VC0"                => [  13,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC0 Queue Counter Last Value Used" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DYNAMIC_VC0"                  => [  15,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 Dynamic Queue Counter Value" ],
);

%shub2_01_00958_def =
( NAME    => "SH2_XNNI0_QUEUE_CNTR",
  ADDRESS => 0x0000000050030570,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00958_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI1_TO_IILB_INTRA_FLOW_DEBIT                                     #
#                                                                        #
##########################################################################

%shub2_01_00959_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_FORCE_CRED"               => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_WITHHOLD"                 => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
   "VC0_FORCE_CRED"               => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_WITHHOLD"                 => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 withhold" ],
);

%shub2_01_00959_def =
( NAME    => "SH2_XNNI1_TO_IILB_INTRA_FLOW_DEBIT",
  ADDRESS => 0x0000000050030600,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00959_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI1_TO_PI_INTRA_FLOW_SIC_DEBIT_VC0                                     #
#                                                                        #
##########################################################################

%shub2_01_00960_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_CAP"                     => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 Data FIFO captured depth" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_DYN"                     => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 Data FIFO dynamic depth" ],
   "RSVD2"                        => [   4,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_CAP"                      => [   5,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VC0 Header FIFO captured depth" ],
   "RSVD3"                        => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_DYN"                      => [   7,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VC0 Header FIFO dynamic depth" ],
   "FORCE_CRED"                   => [   8,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD4"                        => [   9,   5,   2, 0x0000000000000060, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WITHHOLD"                     => [  10,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%shub2_01_00960_def =
( NAME    => "SH2_XNNI1_TO_PI_INTRA_FLOW_SIC_DEBIT_VC0",
  ADDRESS => 0x0000000050030610,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00960_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI1_TO_PI_INTRA_FLOW_SIC_DEBIT_VC2                                     #
#                                                                        #
##########################################################################

%shub2_01_00961_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_CAP"                     => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC2 Data FIFO captured depth" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_DYN"                     => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC2 Data FIFO dynamic depth" ],
   "RSVD2"                        => [   4,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_CAP"                      => [   5,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VC2 Header FIFO captured depth" ],
   "RSVD3"                        => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_DYN"                      => [   7,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VC2 Header FIFO dynamic depth" ],
   "FORCE_CRED"                   => [   8,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD4"                        => [   9,   5,   2, 0x0000000000000060, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WITHHOLD"                     => [  10,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
);

%shub2_01_00961_def =
( NAME    => "SH2_XNNI1_TO_PI_INTRA_FLOW_SIC_DEBIT_VC2",
  ADDRESS => 0x0000000050030620,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00961_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI1_TO_MD_INTRA_FLOW_SIC_DEBIT_VC0                                     #
#                                                                        #
##########################################################################

%shub2_01_00962_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_CAP"                     => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 Data FIFO captured depth" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_DYN"                     => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 Data FIFO dynamic depth" ],
   "RSVD2"                        => [   4,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_CAP"                      => [   5,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VC0 Header FIFO captured depth" ],
   "RSVD3"                        => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_DYN"                      => [   7,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VC0 Header FIFO dynamic depth" ],
   "FORCE_CRED"                   => [   8,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD4"                        => [   9,   5,   2, 0x0000000000000060, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WITHHOLD"                     => [  10,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%shub2_01_00962_def =
( NAME    => "SH2_XNNI1_TO_MD_INTRA_FLOW_SIC_DEBIT_VC0",
  ADDRESS => 0x0000000050030630,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00962_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI1_TO_MD_INTRA_FLOW_SIC_DEBIT_VC2                                     #
#                                                                        #
##########################################################################

%shub2_01_00963_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_CAP"                     => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC2 Data FIFO captured depth" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_DYN"                     => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC2 Data FIFO dynamic depth" ],
   "RSVD2"                        => [   4,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_CAP"                      => [   5,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VC2 Header FIFO captured depth" ],
   "RSVD3"                        => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_DYN"                      => [   7,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VC2 Header FIFO dynamic depth" ],
   "FORCE_CRED"                   => [   8,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD4"                        => [   9,   5,   2, 0x0000000000000060, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WITHHOLD"                     => [  10,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
);

%shub2_01_00963_def =
( NAME    => "SH2_XNNI1_TO_MD_INTRA_FLOW_SIC_DEBIT_VC2",
  ADDRESS => 0x0000000050030640,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00963_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI1_0_INTRANI_FLOW                                             #
#                                                                        #
##########################################################################

%shub2_01_00964_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,   8,  16, 0x0000000000FFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_FORCE_CRED"         => [   5,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD3"                        => [   6,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [   7,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%shub2_01_00964_def =
( NAME    => "SH2_XNNI1_0_INTRANI_FLOW",
  ADDRESS => 0x0000000050030650,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00964_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI1_1_INTRANI_FLOW                                             #
#                                                                        #
##########################################################################

%shub2_01_00965_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_CAP"                      => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_DYN"                      => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,   8,  16, 0x0000000000FFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_FORCE_CRED"         => [   5,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC1" ],
   "RSVD3"                        => [   6,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_WITHHOLD"           => [   7,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC1 Withhold" ],
);

%shub2_01_00965_def =
( NAME    => "SH2_XNNI1_1_INTRANI_FLOW",
  ADDRESS => 0x0000000050030660,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00965_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI1_2_INTRANI_FLOW                                             #
#                                                                        #
##########################################################################

%shub2_01_00966_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,   8,  16, 0x0000000000FFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_FORCE_CRED"         => [   5,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD3"                        => [   6,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [   7,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
);

%shub2_01_00966_def =
( NAME    => "SH2_XNNI1_2_INTRANI_FLOW",
  ADDRESS => 0x0000000050030670,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00966_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI1_3_INTRANI_FLOW                                             #
#                                                                        #
##########################################################################

%shub2_01_00967_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_CAP"                      => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_DYN"                      => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,   8,  16, 0x0000000000FFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_FORCE_CRED"         => [   5,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC3" ],
   "RSVD3"                        => [   6,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_WITHHOLD"           => [   7,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC3 Withhold" ],
);

%shub2_01_00967_def =
( NAME    => "SH2_XNNI1_3_INTRANI_FLOW",
  ADDRESS => 0x0000000050030680,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00967_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI1_VCSWITCH_FLOW                                              #
#                                                                        #
##########################################################################

%shub2_01_00968_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_MGR_ENABLE"            => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Enable credit manager mode for pi/md" ],
   "RSVD1"                        => [   2,  25,   7, 0x00000000FE000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_VCFIFO_SWITCH"           => [   3,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Select VC0/2 or VC1/3 for IILB" ],
   "RSVD2"                        => [   4,  17,   7, 0x0000000000FE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MD_VCFIFO_SWITCH"             => [   5,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Select VC0/2 or VC1/3 for MD" ],
   "RSVD3"                        => [   6,   9,   7, 0x000000000000FE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PI_VCFIFO_SWITCH"             => [   7,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Select VC0/2 or VC1/3 for PI" ],
   "RSVD4"                        => [   8,   1,   7, 0x00000000000000FE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_VCFIFO_DATELINE_SWITCH"    => [   9,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Swap VC0/2 with VC1/3" ],
);

%shub2_01_00968_def =
( NAME    => "SH2_XNNI1_VCSWITCH_FLOW",
  ADDRESS => 0x0000000050030690,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00968_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI1_TIMER_REG                                                  #
#                                                                        #
##########################################################################

%shub2_01_00969_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "QUEUECNTENABLE_REG"           => [   1,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "Queue Counter Enable" ],
   "LINKRESETENABLE_REG"          => [   2,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "Link Reset Enable" ],
   "LINKCLEANUP_REG"              => [   3,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "Link Clean Up" ],
   "TIMEOUT_REG"                  => [   4,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "Master Timeout Counter" ],
);

%shub2_01_00969_def =
( NAME    => "SH2_XNNI1_TIMER_REG",
  ADDRESS => 0x00000000500306a0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00969_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI1_IILB_TAILTO                                                #
#                                                                        #
##########################################################################

%shub2_01_00970_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VC3_CAP"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter captured value" ],
   "VC3_DYN"                      => [   1,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter dynamic value" ],
   "RSVD0"                        => [   2,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_LIMIT"                    => [   3,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "vc3 limit reg, zero disables functionality" ],
   "VC2_CAP"                      => [   4,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "vc2 counter captured value" ],
   "VC2_DYN"                      => [   5,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "vc2 counter dynamic value" ],
   "RSVD1"                        => [   6,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_LIMIT"                    => [   7,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "vc2 limit reg, zero disables functionality" ],
   "VC1_CAP"                      => [   8,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "vc1 counter captured value" ],
   "VC1_DYN"                      => [   9,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "vc1 counter dynamic value" ],
   "RSVD2"                        => [  10,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_LIMIT"                    => [  11,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "vc1 limit reg, zero disables functionality" ],
   "VC0_CAP"                      => [  12,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "vc0 counter captured value" ],
   "VC0_DYN"                      => [  13,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "vc0 counter dynamic value" ],
   "RSVD3"                        => [  14,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_LIMIT"                    => [  15,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "vc0 limit reg, zero disables functionality" ],
);

%shub2_01_00970_def =
( NAME    => "SH2_XNNI1_IILB_TAILTO",
  ADDRESS => 0x00000000500306b0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00970_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI1_NI_TAILTO                                                  #
#                                                                        #
##########################################################################

%shub2_01_00971_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VC3_CAP"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter captured value" ],
   "VC3_DYN"                      => [   1,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter dynamic value" ],
   "RSVD0"                        => [   2,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_LIMIT"                    => [   3,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "vc3 limit reg, zero disables functionality" ],
   "VC2_CAP"                      => [   4,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "vc2 counter captured value" ],
   "VC2_DYN"                      => [   5,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "vc2 counter dynamic value" ],
   "RSVD1"                        => [   6,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_LIMIT"                    => [   7,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "vc2 limit reg, zero disables functionality" ],
   "VC1_CAP"                      => [   8,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "vc1 counter captured value" ],
   "VC1_DYN"                      => [   9,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "vc1 counter dynamic value" ],
   "RSVD2"                        => [  10,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_LIMIT"                    => [  11,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "vc1 limit reg, zero disables functionality" ],
   "VC0_CAP"                      => [  12,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "vc0 counter captured value" ],
   "VC0_DYN"                      => [  13,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "vc0 counter dynamic value" ],
   "RSVD3"                        => [  14,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_LIMIT"                    => [  15,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "vc0 limit reg, zero disables functionality" ],
);

%shub2_01_00971_def =
( NAME    => "SH2_XNNI1_NI_TAILTO",
  ADDRESS => 0x00000000500306c0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00971_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI1_NI_TAILTO_SUPPORT                                          #
#                                                                        #
##########################################################################

%shub2_01_00972_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INJECT_TAIL_ENABLE"           => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "" ],
);

%shub2_01_00972_def =
( NAME    => "SH2_XNNI1_NI_TAILTO_SUPPORT",
  ADDRESS => 0x00000000500306f0,
  NOTE    => "This register adds a 'tail injection' feature to the basic Tail note Timeout functionality. If enabled, when a Tail Timeout Limi",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00972_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI1_PI_TAILTO                                                  #
#                                                                        #
##########################################################################

%shub2_01_00973_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VC3_CAP"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter captured value" ],
   "VC3_DYN"                      => [   1,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter dynamic value" ],
   "RSVD0"                        => [   2,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_LIMIT"                    => [   3,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "vc3 limit reg, zero disables functionality" ],
   "VC2_CAP"                      => [   4,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "vc2 counter captured value" ],
   "VC2_DYN"                      => [   5,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "vc2 counter dynamic value" ],
   "RSVD1"                        => [   6,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_LIMIT"                    => [   7,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "vc2 limit reg, zero disables functionality" ],
   "VC1_CAP"                      => [   8,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "vc1 counter captured value" ],
   "VC1_DYN"                      => [   9,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "vc1 counter dynamic value" ],
   "RSVD2"                        => [  10,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_LIMIT"                    => [  11,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "vc1 limit reg, zero disables functionality" ],
   "VC0_CAP"                      => [  12,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "vc0 counter captured value" ],
   "VC0_DYN"                      => [  13,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "vc0 counter dynamic value" ],
   "RSVD3"                        => [  14,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_LIMIT"                    => [  15,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "vc0 limit reg, zero disables functionality" ],
);

%shub2_01_00973_def =
( NAME    => "SH2_XNNI1_PI_TAILTO",
  ADDRESS => 0x00000000500306d0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00973_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI1_MD_TAILTO                                                  #
#                                                                        #
##########################################################################

%shub2_01_00974_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VC3_CAP"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter captured value" ],
   "VC3_DYN"                      => [   1,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter dynamic value" ],
   "RSVD0"                        => [   2,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_LIMIT"                    => [   3,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "vc3 limit reg, zero disables functionality" ],
   "VC2_CAP"                      => [   4,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "vc2 counter captured value" ],
   "VC2_DYN"                      => [   5,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "vc2 counter dynamic value" ],
   "RSVD1"                        => [   6,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_LIMIT"                    => [   7,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "vc2 limit reg, zero disables functionality" ],
   "VC1_CAP"                      => [   8,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "vc1 counter captured value" ],
   "VC1_DYN"                      => [   9,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "vc1 counter dynamic value" ],
   "RSVD2"                        => [  10,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_LIMIT"                    => [  11,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "vc1 limit reg, zero disables functionality" ],
   "VC0_CAP"                      => [  12,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "vc0 counter captured value" ],
   "VC0_DYN"                      => [  13,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "vc0 counter dynamic value" ],
   "RSVD3"                        => [  14,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_LIMIT"                    => [  15,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "vc0 limit reg, zero disables functionality" ],
);

%shub2_01_00974_def =
( NAME    => "SH2_XNNI1_MD_TAILTO",
  ADDRESS => 0x00000000500306e0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00974_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI1_DEADLCK_FLOW                                               #
#                                                                        #
##########################################################################

%shub2_01_00975_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VC3_CAP"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter captured value" ],
   "VC3_DYN"                      => [   1,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter dynamic value" ],
   "RSVD0"                        => [   2,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_LIMIT"                    => [   3,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "vc3 limit reg, zero disables functionality" ],
   "VC2_CAP"                      => [   4,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "vc2 counter captured value" ],
   "VC2_DYN"                      => [   5,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "vc2 counter dynamic value" ],
   "RSVD1"                        => [   6,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_LIMIT"                    => [   7,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "vc2 limit reg, zero disables functionality" ],
   "VC1_CAP"                      => [   8,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "vc1 counter captured value" ],
   "VC1_DYN"                      => [   9,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "vc1 counter dynamic value" ],
   "RSVD2"                        => [  10,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_LIMIT"                    => [  11,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "vc1 limit reg, zero disables functionality" ],
   "VC0_CAP"                      => [  12,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "vc0 counter captured value" ],
   "VC0_DYN"                      => [  13,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "vc0 counter dynamic value" ],
   "RSVD3"                        => [  14,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_LIMIT"                    => [  15,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "vc0 limit reg, zero disables functionality" ],
);

%shub2_01_00975_def =
( NAME    => "SH2_XNNI1_DEADLCK_FLOW",
  ADDRESS => 0x0000000050030700,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00975_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI1_DEADLCK_FLOW_SUPPORT                                       #
#                                                                        #
##########################################################################

%shub2_01_00976_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FLUSH_ENABLE"                 => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "flush enable" ],
);

%shub2_01_00976_def =
( NAME    => "SH2_XNNI1_DEADLCK_FLOW_SUPPORT",
  ADDRESS => 0x0000000050030710,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00976_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI1_INJECT_AGE                                                 #
#                                                                        #
##########################################################################

%shub2_01_00977_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REPLY_INJECT"                 => [   1,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Value of AGE field for outgoing replies" ],
   "REQUEST_INJECT"               => [   2,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Value of AGE field for outgoing requests" ],
);

%shub2_01_00977_def =
( NAME    => "SH2_XNNI1_INJECT_AGE",
  ADDRESS => 0x0000000050030720,
  NOTE    => "This register allows the age field of network bound messages coming note from the II, LB, and in the case of SHub2 , the PI and ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00977_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI1_NETWORK_AGE                                                #
#                                                                        #
##########################################################################

%shub2_01_00978_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  49,  15, 0xFFFE000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FR_MMR_AGE_THRESHOLD_ENABLE"  => [   1,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "Age Threshold Request Enable" ],
   "FR_MMR_AGE_THRESHOLD"         => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "Age Threshold" ],
   "RSVD1"                        => [   3,  33,   7, 0x000000FE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FR_MMR_FREERUN_ENABLE"        => [   4,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "Freerun Counter Enable" ],
   "RSVD2"                        => [   5,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FR_MMR_MUX_SEL3"              => [   6,  24,   5, 0x000000001F000000, 0x00, 1, 0x0000000000000000, "Mux Select3" ],
   "RSVD3"                        => [   7,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FR_MMR_MUX_SEL2"              => [   8,  16,   5, 0x00000000001F0000, 0x00, 1, 0x0000000000000000, "Mux Select2" ],
   "RSVD4"                        => [   9,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FR_MMR_MUX_SEL1"              => [  10,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "Mux Select1" ],
   "RSVD5"                        => [  11,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FR_MMR_MUX_SEL0"              => [  12,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Mux Select0" ],
);

%shub2_01_00978_def =
( NAME    => "SH2_XNNI1_NETWORK_AGE",
  ADDRESS => 0x0000000050030730,
  NOTE    => "This register configures the Network Aging features of the XN. note There is one of these registers for each of the two NI ports",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00978_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI1_ARB_CONFIG                                                 #
#                                                                        #
##########################################################################

%shub2_01_00979_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_SYNC_BYPASS_IN"        => [   1,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Enable Bypass Mode" ],
   "EN_THROT_SRC3"                => [   2,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Enable throttling of MD requests" ],
   "EN_THROT_SRC2"                => [   3,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Enable throttling of PI requests" ],
   "EN_THROT_SRC1"                => [   4,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Enable throttling of other NI requests" ],
   "EN_THROT_SRC0"                => [   5,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable throttling of II and LB requests" ],
);

%shub2_01_00979_def =
( NAME    => "SH2_XNNI1_ARB_CONFIG",
  ADDRESS => 0x0000000050030740,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00979_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI1_LOCAL_AGE0                                                 #
#                                                                        #
##########################################################################

%shub2_01_00980_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "AGE_WRAP_SRC1_VC3"            => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "Other XN_NI VC3 Pre-Scale Value" ],
   "AGE_WRAP_SRC1_VC2"            => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Other XN_NI VC2 Pre-Scale Value" ],
   "AGE_WRAP_SRC1_VC1"            => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "Other XN_NI VC1 Pre-Scale Value" ],
   "AGE_WRAP_SRC1_VC0"            => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Other XN_NI VC0 Pre-Scale Value" ],
   "AGE_WRAP_SRC0_VC3"            => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "XN_IILB VC3 Pre-Scale Value" ],
   "AGE_WRAP_SRC0_VC2"            => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "XN_IILB VC2 Pre-Scale Value" ],
   "AGE_WRAP_SRC0_VC1"            => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "XN_IILB VC1 Pre-Scale Value" ],
   "AGE_WRAP_SRC0_VC0"            => [   7,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "XN_IILB VC0 Pre-Scale Value" ],
);

%shub2_01_00980_def =
( NAME    => "SH2_XNNI1_LOCAL_AGE0",
  ADDRESS => 0x0000000050030750,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00980_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI1_LOCAL_AGE1                                                 #
#                                                                        #
##########################################################################

%shub2_01_00981_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "AGE_WRAP_SRC3_VC3"            => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "XN_MD VC3 Pre-Scale Value" ],
   "AGE_WRAP_SRC3_VC2"            => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "XN_MD VC2 Pre-Scale Value" ],
   "AGE_WRAP_SRC3_VC1"            => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "XN_MD VC1 Pre-Scale Value" ],
   "AGE_WRAP_SRC3_VC0"            => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "XN_MD VC0 Pre-Scale Value" ],
   "AGE_WRAP_SRC2_VC3"            => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "XN_PI VC3 Pre-Scale Value" ],
   "AGE_WRAP_SRC2_VC2"            => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "XN_PI VC2 Pre-Scale Value" ],
   "AGE_WRAP_SRC2_VC1"            => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "XN_PI VC1 Pre-Scale Value" ],
   "AGE_WRAP_SRC2_VC0"            => [   7,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "XN_PI VC0 Pre-Scale Value" ],
);

%shub2_01_00981_def =
( NAME    => "SH2_XNNI1_LOCAL_AGE1",
  ADDRESS => 0x0000000050030760,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00981_flds
);


##########################################################################
#                                                                        #
#   SH2_XNNI1_QUEUE_CNTR                                                 #
#                                                                        #
##########################################################################

%shub2_01_00982_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LAST_USED_VC3"                => [   1,  56,   6, 0x3F00000000000000, 0x00, 1, 0x0000000000000000, "VC3 Queue Counter Last Value Used" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DYNAMIC_VC3"                  => [   3,  48,   6, 0x003F000000000000, 0x00, 1, 0x0000000000000000, "VC3 Dynamic Queue Counter Value" ],
   "RSVD2"                        => [   4,  46,   2, 0x0000C00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LAST_USED_VC2"                => [   5,  40,   6, 0x00003F0000000000, 0x00, 1, 0x0000000000000000, "VC2 Queue Counter Last Value Used" ],
   "RSVD3"                        => [   6,  38,   2, 0x000000C000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DYNAMIC_VC2"                  => [   7,  32,   6, 0x0000003F00000000, 0x00, 1, 0x0000000000000000, "VC2 Dynamic Queue Counter Value" ],
   "RSVD4"                        => [   8,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LAST_USED_VC1"                => [   9,  24,   6, 0x000000003F000000, 0x00, 1, 0x0000000000000000, "VC1 Queue Counter Last Value Used" ],
   "RSVD5"                        => [  10,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DYNAMIC_VC1"                  => [  11,  16,   6, 0x00000000003F0000, 0x00, 1, 0x0000000000000000, "VC1 Dynamic Queue Counter Value" ],
   "RSVD6"                        => [  12,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LAST_USED_VC0"                => [  13,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC0 Queue Counter Last Value Used" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DYNAMIC_VC0"                  => [  15,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 Dynamic Queue Counter Value" ],
);

%shub2_01_00982_def =
( NAME    => "SH2_XNNI1_QUEUE_CNTR",
  ADDRESS => 0x0000000050030770,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00982_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_DEBUG_SEL                                                     #
#                                                                        #
##########################################################################

%shub2_01_00983_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TRIGGER_ENABLE"               => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Enable trigger on bit 32 of Analyzer data" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD0"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_RLM_SEL"              => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 RLM select" ],
   "RSVD1"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD2"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_RLM_SEL"              => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 RLM select" ],
   "RSVD3"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD4"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_RLM_SEL"              => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 RLM select" ],
   "RSVD5"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD6"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_RLM_SEL"              => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 RLM select" ],
   "RSVD7"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD8"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_RLM_SEL"              => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 RLM select" ],
   "RSVD9"                        => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD10"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_RLM_SEL"              => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 RLM select" ],
   "RSVD11"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD12"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_RLM_SEL"              => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 RLM select" ],
   "RSVD13"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD14"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_RLM_SEL"              => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 RLM select" ],
);

%shub2_01_00983_def =
( NAME    => "SH2_XN_DEBUG_SEL",
  ADDRESS => 0x0000000050031000,
  NOTE    => "XN Debug Port Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00983_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_DEBUG_TRIG_SEL                                                #
#                                                                        #
##########################################################################

%shub2_01_00984_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_NIBBLE_SEL"          => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_RLM_SEL"             => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 RLM select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_NIBBLE_SEL"          => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_RLM_SEL"             => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 RLM select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_NIBBLE_SEL"          => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_RLM_SEL"             => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 RLM select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_NIBBLE_SEL"          => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_RLM_SEL"             => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 RLM select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_NIBBLE_SEL"          => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_RLM_SEL"             => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 RLM select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_NIBBLE_SEL"          => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_RLM_SEL"             => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 RLM select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_NIBBLE_SEL"          => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_RLM_SEL"             => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 RLM select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_NIBBLE_SEL"          => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_RLM_SEL"             => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 RLM select" ],
);

%shub2_01_00984_def =
( NAME    => "SH2_XN_DEBUG_TRIG_SEL",
  ADDRESS => 0x0000000050031020,
  NOTE    => "XN Debug trigger Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00984_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_TRIGGER_COMPARE                                               #
#                                                                        #
##########################################################################

%shub2_01_00985_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MASK"                         => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Mask to select Debug bits for trigger generation" ],
);

%shub2_01_00985_def =
( NAME    => "SH2_XN_TRIGGER_COMPARE",
  ADDRESS => 0x0000000050031040,
  NOTE    => "XN Debug Compare",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00985_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_TRIGGER_DATA                                                  #
#                                                                        #
##########################################################################

%shub2_01_00986_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COMPARE_PATTERN"              => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "debug bit pattern for trigger generation" ],
);

%shub2_01_00986_def =
( NAME    => "SH2_XN_TRIGGER_DATA",
  ADDRESS => 0x0000000050031050,
  NOTE    => "XN Debug Compare Data",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00986_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_IILB_DEBUG_SEL                                                #
#                                                                        #
##########################################################################

%shub2_01_00987_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_INPUT_SEL"            => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 input select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_INPUT_SEL"            => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 input select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_INPUT_SEL"            => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 input select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_INPUT_SEL"            => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 input select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_INPUT_SEL"            => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 input select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_INPUT_SEL"            => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 input select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_INPUT_SEL"            => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 input select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_INPUT_SEL"            => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 input select" ],
);

%shub2_01_00987_def =
( NAME    => "SH2_XN_IILB_DEBUG_SEL",
  ADDRESS => 0x0000000050031060,
  NOTE    => "XN IILB Debug Port Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00987_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_IILB_LB_CMP_EXP_DATA0                                         #
#                                                                        #
##########################################################################

%shub2_01_00988_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub2_01_00988_def =
( NAME    => "SH2_XN_IILB_LB_CMP_EXP_DATA0",
  ADDRESS => 0x0000000050031100,
  NOTE    => "IILB compare LB input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00988_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_IILB_LB_CMP_EXP_DATA1                                         #
#                                                                        #
##########################################################################

%shub2_01_00989_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub2_01_00989_def =
( NAME    => "SH2_XN_IILB_LB_CMP_EXP_DATA1",
  ADDRESS => 0x0000000050031110,
  NOTE    => "IILB compare LB input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00989_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_IILB_LB_CMP_ENABLE0                                           #
#                                                                        #
##########################################################################

%shub2_01_00990_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub2_01_00990_def =
( NAME    => "SH2_XN_IILB_LB_CMP_ENABLE0",
  ADDRESS => 0x0000000050031120,
  NOTE    => "IILB compare LB input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00990_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_IILB_LB_CMP_ENABLE1                                           #
#                                                                        #
##########################################################################

%shub2_01_00991_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub2_01_00991_def =
( NAME    => "SH2_XN_IILB_LB_CMP_ENABLE1",
  ADDRESS => 0x0000000050031130,
  NOTE    => "IILB compare LB input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00991_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_IILB_II_CMP_EXP_DATA0                                         #
#                                                                        #
##########################################################################

%shub2_01_00992_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub2_01_00992_def =
( NAME    => "SH2_XN_IILB_II_CMP_EXP_DATA0",
  ADDRESS => 0x0000000050031140,
  NOTE    => "IILB compare II input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00992_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_IILB_II_CMP_EXP_DATA1                                         #
#                                                                        #
##########################################################################

%shub2_01_00993_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub2_01_00993_def =
( NAME    => "SH2_XN_IILB_II_CMP_EXP_DATA1",
  ADDRESS => 0x0000000050031150,
  NOTE    => "IILB compare II input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00993_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_IILB_II_CMP_ENABLE0                                           #
#                                                                        #
##########################################################################

%shub2_01_00994_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub2_01_00994_def =
( NAME    => "SH2_XN_IILB_II_CMP_ENABLE0",
  ADDRESS => 0x0000000050031160,
  NOTE    => "IILB compare II input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00994_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_IILB_II_CMP_ENABLE1                                           #
#                                                                        #
##########################################################################

%shub2_01_00995_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub2_01_00995_def =
( NAME    => "SH2_XN_IILB_II_CMP_ENABLE1",
  ADDRESS => 0x0000000050031170,
  NOTE    => "IILB compare II input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00995_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_IILB_MD_HDR_CMP_EXP_DATA0                                     #
#                                                                        #
##########################################################################

%shub2_01_00996_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub2_01_00996_def =
( NAME    => "SH2_XN_IILB_MD_HDR_CMP_EXP_DATA0",
  ADDRESS => 0x0000000050031200,
  NOTE    => "IILB compare MD hdr input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00996_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_IILB_MD_HDR_CMP_EXP_DATA1                                     #
#                                                                        #
##########################################################################

%shub2_01_00997_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub2_01_00997_def =
( NAME    => "SH2_XN_IILB_MD_HDR_CMP_EXP_DATA1",
  ADDRESS => 0x0000000050031210,
  NOTE    => "IILB compare MD hdr input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00997_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_IILB_MD_HDR_CMP_ENABLE0                                       #
#                                                                        #
##########################################################################

%shub2_01_00998_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub2_01_00998_def =
( NAME    => "SH2_XN_IILB_MD_HDR_CMP_ENABLE0",
  ADDRESS => 0x0000000050031220,
  NOTE    => "IILB compare MD hdr input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00998_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_IILB_MD_HDR_CMP_ENABLE1                                       #
#                                                                        #
##########################################################################

%shub2_01_00999_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub2_01_00999_def =
( NAME    => "SH2_XN_IILB_MD_HDR_CMP_ENABLE1",
  ADDRESS => 0x0000000050031230,
  NOTE    => "IILB compare MD hdr input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_00999_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_IILB_PI_CMP_EXP_DATA0                                         #
#                                                                        #
##########################################################################

%shub2_01_01000_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub2_01_01000_def =
( NAME    => "SH2_XN_IILB_PI_CMP_EXP_DATA0",
  ADDRESS => 0x0000000050031240,
  NOTE    => "IILB compare PI input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01000_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_IILB_PI_CMP_EXP_DATA1                                         #
#                                                                        #
##########################################################################

%shub2_01_01001_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub2_01_01001_def =
( NAME    => "SH2_XN_IILB_PI_CMP_EXP_DATA1",
  ADDRESS => 0x0000000050031250,
  NOTE    => "IILB compare PI input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01001_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_IILB_PI_CMP_ENABLE0                                           #
#                                                                        #
##########################################################################

%shub2_01_01002_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub2_01_01002_def =
( NAME    => "SH2_XN_IILB_PI_CMP_ENABLE0",
  ADDRESS => 0x0000000050031260,
  NOTE    => "IILB compare PI input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01002_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_IILB_PI_CMP_ENABLE1                                           #
#                                                                        #
##########################################################################

%shub2_01_01003_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub2_01_01003_def =
( NAME    => "SH2_XN_IILB_PI_CMP_ENABLE1",
  ADDRESS => 0x0000000050031270,
  NOTE    => "IILB compare PI input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01003_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_IILB_NI0_CMP_EXP_DATA0                                        #
#                                                                        #
##########################################################################

%shub2_01_01004_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub2_01_01004_def =
( NAME    => "SH2_XN_IILB_NI0_CMP_EXP_DATA0",
  ADDRESS => 0x0000000050031280,
  NOTE    => "IILB compare NI0 input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01004_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_IILB_NI0_CMP_EXP_DATA1                                        #
#                                                                        #
##########################################################################

%shub2_01_01005_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub2_01_01005_def =
( NAME    => "SH2_XN_IILB_NI0_CMP_EXP_DATA1",
  ADDRESS => 0x0000000050031290,
  NOTE    => "IILB compare NI0 input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01005_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_IILB_NI0_CMP_ENABLE0                                          #
#                                                                        #
##########################################################################

%shub2_01_01006_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub2_01_01006_def =
( NAME    => "SH2_XN_IILB_NI0_CMP_ENABLE0",
  ADDRESS => 0x00000000500312a0,
  NOTE    => "IILB compare NI0 input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01006_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_IILB_NI0_CMP_ENABLE1                                          #
#                                                                        #
##########################################################################

%shub2_01_01007_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub2_01_01007_def =
( NAME    => "SH2_XN_IILB_NI0_CMP_ENABLE1",
  ADDRESS => 0x00000000500312b0,
  NOTE    => "IILB compare NI0 input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01007_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_IILB_NI1_CMP_EXP_DATA0                                        #
#                                                                        #
##########################################################################

%shub2_01_01008_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub2_01_01008_def =
( NAME    => "SH2_XN_IILB_NI1_CMP_EXP_DATA0",
  ADDRESS => 0x00000000500312c0,
  NOTE    => "IILB compare NI1 input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01008_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_IILB_NI1_CMP_EXP_DATA1                                        #
#                                                                        #
##########################################################################

%shub2_01_01009_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub2_01_01009_def =
( NAME    => "SH2_XN_IILB_NI1_CMP_EXP_DATA1",
  ADDRESS => 0x00000000500312d0,
  NOTE    => "IILB compare NI1 input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01009_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_IILB_NI1_CMP_ENABLE0                                          #
#                                                                        #
##########################################################################

%shub2_01_01010_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub2_01_01010_def =
( NAME    => "SH2_XN_IILB_NI1_CMP_ENABLE0",
  ADDRESS => 0x00000000500312e0,
  NOTE    => "IILB compare NI1 input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01010_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_IILB_NI1_CMP_ENABLE1                                          #
#                                                                        #
##########################################################################

%shub2_01_01011_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub2_01_01011_def =
( NAME    => "SH2_XN_IILB_NI1_CMP_ENABLE1",
  ADDRESS => 0x00000000500312f0,
  NOTE    => "IILB compare NI1 input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01011_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI0_DEBUG_SEL                                                 #
#                                                                        #
##########################################################################

%shub2_01_01012_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_INPUT_SEL"            => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 input select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_INPUT_SEL"            => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 input select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_INPUT_SEL"            => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 input select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_INPUT_SEL"            => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 input select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_INPUT_SEL"            => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 input select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_INPUT_SEL"            => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 input select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_INPUT_SEL"            => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 input select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_INPUT_SEL"            => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 input select" ],
);

%shub2_01_01012_def =
( NAME    => "SH2_XN_NI0_DEBUG_SEL",
  ADDRESS => 0x00000000500310c0,
  NOTE    => "XN NI0 Debug Port Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01012_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI0_IILB_CMP_EXP_DATA0                                        #
#                                                                        #
##########################################################################

%shub2_01_01013_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub2_01_01013_def =
( NAME    => "SH2_XN_NI0_IILB_CMP_EXP_DATA0",
  ADDRESS => 0x0000000050031700,
  NOTE    => "NI0 compare IILB input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01013_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI0_IILB_CMP_EXP_DATA1                                        #
#                                                                        #
##########################################################################

%shub2_01_01014_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub2_01_01014_def =
( NAME    => "SH2_XN_NI0_IILB_CMP_EXP_DATA1",
  ADDRESS => 0x0000000050031710,
  NOTE    => "NI0 compare IILB input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01014_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI0_IILB_CMP_ENABLE0                                          #
#                                                                        #
##########################################################################

%shub2_01_01015_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub2_01_01015_def =
( NAME    => "SH2_XN_NI0_IILB_CMP_ENABLE0",
  ADDRESS => 0x0000000050031720,
  NOTE    => "NI0 compare IILB input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01015_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI0_IILB_CMP_ENABLE1                                          #
#                                                                        #
##########################################################################

%shub2_01_01016_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub2_01_01016_def =
( NAME    => "SH2_XN_NI0_IILB_CMP_ENABLE1",
  ADDRESS => 0x0000000050031730,
  NOTE    => "NI0 compare IILB input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01016_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI0_PI_CMP_EXP_DATA0                                          #
#                                                                        #
##########################################################################

%shub2_01_01017_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub2_01_01017_def =
( NAME    => "SH2_XN_NI0_PI_CMP_EXP_DATA0",
  ADDRESS => 0x0000000050031740,
  NOTE    => "Included only for SHub2 - Begin",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01017_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI0_PI_CMP_EXP_DATA1                                          #
#                                                                        #
##########################################################################

%shub2_01_01018_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub2_01_01018_def =
( NAME    => "SH2_XN_NI0_PI_CMP_EXP_DATA1",
  ADDRESS => 0x0000000050031750,
  NOTE    => "NI0 compare PI input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01018_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI0_PI_CMP_ENABLE0                                            #
#                                                                        #
##########################################################################

%shub2_01_01019_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub2_01_01019_def =
( NAME    => "SH2_XN_NI0_PI_CMP_ENABLE0",
  ADDRESS => 0x0000000050031760,
  NOTE    => "NI0 compare PI input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01019_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI0_PI_CMP_ENABLE1                                            #
#                                                                        #
##########################################################################

%shub2_01_01020_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub2_01_01020_def =
( NAME    => "SH2_XN_NI0_PI_CMP_ENABLE1",
  ADDRESS => 0x0000000050031770,
  NOTE    => "NI0 compare PI input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01020_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI0_NI_CMP_EXP_DATA0                                          #
#                                                                        #
##########################################################################

%shub2_01_01021_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub2_01_01021_def =
( NAME    => "SH2_XN_NI0_NI_CMP_EXP_DATA0",
  ADDRESS => 0x00000000500317c0,
  NOTE    => "Included only for SHub2 - End",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01021_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI0_NI_CMP_EXP_DATA1                                          #
#                                                                        #
##########################################################################

%shub2_01_01022_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub2_01_01022_def =
( NAME    => "SH2_XN_NI0_NI_CMP_EXP_DATA1",
  ADDRESS => 0x00000000500317d0,
  NOTE    => "NI0 compare NI input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01022_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI0_NI_CMP_ENABLE0                                            #
#                                                                        #
##########################################################################

%shub2_01_01023_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub2_01_01023_def =
( NAME    => "SH2_XN_NI0_NI_CMP_ENABLE0",
  ADDRESS => 0x00000000500317e0,
  NOTE    => "NI0 compare NI input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01023_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI0_NI_CMP_ENABLE1                                            #
#                                                                        #
##########################################################################

%shub2_01_01024_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub2_01_01024_def =
( NAME    => "SH2_XN_NI0_NI_CMP_ENABLE1",
  ADDRESS => 0x00000000500317f0,
  NOTE    => "NI0 compare NI input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01024_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI0_LLP_CMP_EXP_DATA0                                         #
#                                                                        #
##########################################################################

%shub2_01_01025_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub2_01_01025_def =
( NAME    => "SH2_XN_NI0_LLP_CMP_EXP_DATA0",
  ADDRESS => 0x0000000050031800,
  NOTE    => "NI0 compare LLP input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01025_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI0_LLP_CMP_EXP_DATA1                                         #
#                                                                        #
##########################################################################

%shub2_01_01026_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub2_01_01026_def =
( NAME    => "SH2_XN_NI0_LLP_CMP_EXP_DATA1",
  ADDRESS => 0x0000000050031810,
  NOTE    => "NI0 compare LLP input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01026_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI0_LLP_CMP_ENABLE0                                           #
#                                                                        #
##########################################################################

%shub2_01_01027_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub2_01_01027_def =
( NAME    => "SH2_XN_NI0_LLP_CMP_ENABLE0",
  ADDRESS => 0x0000000050031820,
  NOTE    => "NI0 compare LLP input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01027_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI0_LLP_CMP_ENABLE1                                           #
#                                                                        #
##########################################################################

%shub2_01_01028_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub2_01_01028_def =
( NAME    => "SH2_XN_NI0_LLP_CMP_ENABLE1",
  ADDRESS => 0x0000000050031830,
  NOTE    => "NI0 compare LLP input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01028_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI0_MD_CMP_EXP_HDR0                                           #
#                                                                        #
##########################################################################

%shub2_01_01029_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected header 0" ],
);

%shub2_01_01029_def =
( NAME    => "SH2_XN_NI0_MD_CMP_EXP_HDR0",
  ADDRESS => 0x0000000050031b40,
  NOTE    => "Included only for SHub2 - Begin",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01029_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI0_MD_CMP_EXP_HDR1                                           #
#                                                                        #
##########################################################################

%shub2_01_01030_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected header 1" ],
);

%shub2_01_01030_def =
( NAME    => "SH2_XN_NI0_MD_CMP_EXP_HDR1",
  ADDRESS => 0x0000000050031b50,
  NOTE    => "Added for SHub2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01030_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI0_MD_CMP_HDR_ENABLE0                                        #
#                                                                        #
##########################################################################

%shub2_01_01031_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Header Enable 0" ],
);

%shub2_01_01031_def =
( NAME    => "SH2_XN_NI0_MD_CMP_HDR_ENABLE0",
  ADDRESS => 0x0000000050031b60,
  NOTE    => "Added for SHub2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01031_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI0_MD_CMP_HDR_ENABLE1                                        #
#                                                                        #
##########################################################################

%shub2_01_01032_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Header Enable 1" ],
);

%shub2_01_01032_def =
( NAME    => "SH2_XN_NI0_MD_CMP_HDR_ENABLE1",
  ADDRESS => 0x0000000050031b70,
  NOTE    => "Added for SHub2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01032_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI1_DEBUG_SEL                                                 #
#                                                                        #
##########################################################################

%shub2_01_01033_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_INPUT_SEL"            => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 input select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_INPUT_SEL"            => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 input select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_INPUT_SEL"            => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 input select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_INPUT_SEL"            => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 input select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_INPUT_SEL"            => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 input select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_INPUT_SEL"            => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 input select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_INPUT_SEL"            => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 input select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_INPUT_SEL"            => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 input select" ],
);

%shub2_01_01033_def =
( NAME    => "SH2_XN_NI1_DEBUG_SEL",
  ADDRESS => 0x00000000500310e0,
  NOTE    => "XN NI1 Debug Port Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01033_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI1_IILB_CMP_EXP_DATA0                                        #
#                                                                        #
##########################################################################

%shub2_01_01034_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub2_01_01034_def =
( NAME    => "SH2_XN_NI1_IILB_CMP_EXP_DATA0",
  ADDRESS => 0x0000000050031900,
  NOTE    => "NI1 compare IILB input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01034_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI1_IILB_CMP_EXP_DATA1                                        #
#                                                                        #
##########################################################################

%shub2_01_01035_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub2_01_01035_def =
( NAME    => "SH2_XN_NI1_IILB_CMP_EXP_DATA1",
  ADDRESS => 0x0000000050031910,
  NOTE    => "NI1 compare IILB input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01035_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI1_IILB_CMP_ENABLE0                                          #
#                                                                        #
##########################################################################

%shub2_01_01036_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub2_01_01036_def =
( NAME    => "SH2_XN_NI1_IILB_CMP_ENABLE0",
  ADDRESS => 0x0000000050031920,
  NOTE    => "NI1 compare IILB input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01036_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI1_IILB_CMP_ENABLE1                                          #
#                                                                        #
##########################################################################

%shub2_01_01037_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub2_01_01037_def =
( NAME    => "SH2_XN_NI1_IILB_CMP_ENABLE1",
  ADDRESS => 0x0000000050031930,
  NOTE    => "NI1 compare IILB input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01037_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI1_PI_CMP_EXP_DATA0                                          #
#                                                                        #
##########################################################################

%shub2_01_01038_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub2_01_01038_def =
( NAME    => "SH2_XN_NI1_PI_CMP_EXP_DATA0",
  ADDRESS => 0x0000000050031940,
  NOTE    => "Included only for SHub2 - Begin",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01038_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI1_PI_CMP_EXP_DATA1                                          #
#                                                                        #
##########################################################################

%shub2_01_01039_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub2_01_01039_def =
( NAME    => "SH2_XN_NI1_PI_CMP_EXP_DATA1",
  ADDRESS => 0x0000000050031950,
  NOTE    => "NI1 compare PI input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01039_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI1_PI_CMP_ENABLE0                                            #
#                                                                        #
##########################################################################

%shub2_01_01040_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub2_01_01040_def =
( NAME    => "SH2_XN_NI1_PI_CMP_ENABLE0",
  ADDRESS => 0x0000000050031960,
  NOTE    => "NI1 compare PI input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01040_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI1_PI_CMP_ENABLE1                                            #
#                                                                        #
##########################################################################

%shub2_01_01041_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub2_01_01041_def =
( NAME    => "SH2_XN_NI1_PI_CMP_ENABLE1",
  ADDRESS => 0x0000000050031970,
  NOTE    => "NI1 compare PI input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01041_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI1_NI_CMP_EXP_DATA0                                          #
#                                                                        #
##########################################################################

%shub2_01_01042_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub2_01_01042_def =
( NAME    => "SH2_XN_NI1_NI_CMP_EXP_DATA0",
  ADDRESS => 0x00000000500319c0,
  NOTE    => "Included only for SHub2 - End",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01042_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI1_NI_CMP_EXP_DATA1                                          #
#                                                                        #
##########################################################################

%shub2_01_01043_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub2_01_01043_def =
( NAME    => "SH2_XN_NI1_NI_CMP_EXP_DATA1",
  ADDRESS => 0x00000000500319d0,
  NOTE    => "NI1 compare NI input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01043_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI1_NI_CMP_ENABLE0                                            #
#                                                                        #
##########################################################################

%shub2_01_01044_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub2_01_01044_def =
( NAME    => "SH2_XN_NI1_NI_CMP_ENABLE0",
  ADDRESS => 0x00000000500319e0,
  NOTE    => "NI1 compare NI input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01044_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI1_NI_CMP_ENABLE1                                            #
#                                                                        #
##########################################################################

%shub2_01_01045_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub2_01_01045_def =
( NAME    => "SH2_XN_NI1_NI_CMP_ENABLE1",
  ADDRESS => 0x00000000500319f0,
  NOTE    => "NI1 compare NI input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01045_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI1_LLP_CMP_EXP_DATA0                                         #
#                                                                        #
##########################################################################

%shub2_01_01046_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub2_01_01046_def =
( NAME    => "SH2_XN_NI1_LLP_CMP_EXP_DATA0",
  ADDRESS => 0x0000000050031a00,
  NOTE    => "NI1 compare LLP input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01046_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI1_LLP_CMP_EXP_DATA1                                         #
#                                                                        #
##########################################################################

%shub2_01_01047_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub2_01_01047_def =
( NAME    => "SH2_XN_NI1_LLP_CMP_EXP_DATA1",
  ADDRESS => 0x0000000050031a10,
  NOTE    => "NI1 compare LLP input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01047_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI1_LLP_CMP_ENABLE0                                           #
#                                                                        #
##########################################################################

%shub2_01_01048_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub2_01_01048_def =
( NAME    => "SH2_XN_NI1_LLP_CMP_ENABLE0",
  ADDRESS => 0x0000000050031a20,
  NOTE    => "NI1 compare LLP input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01048_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI1_LLP_CMP_ENABLE1                                           #
#                                                                        #
##########################################################################

%shub2_01_01049_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub2_01_01049_def =
( NAME    => "SH2_XN_NI1_LLP_CMP_ENABLE1",
  ADDRESS => 0x0000000050031a30,
  NOTE    => "NI1 compare LLP input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01049_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI1_MD_CMP_EXP_HDR0                                           #
#                                                                        #
##########################################################################

%shub2_01_01050_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected header 0" ],
);

%shub2_01_01050_def =
( NAME    => "SH2_XN_NI1_MD_CMP_EXP_HDR0",
  ADDRESS => 0x0000000050031bc0,
  NOTE    => "Included only for SHub2 - Begin",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01050_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI1_MD_CMP_EXP_HDR1                                           #
#                                                                        #
##########################################################################

%shub2_01_01051_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected header 1" ],
);

%shub2_01_01051_def =
( NAME    => "SH2_XN_NI1_MD_CMP_EXP_HDR1",
  ADDRESS => 0x0000000050031bd0,
  NOTE    => "Added for SHub2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01051_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI1_MD_CMP_HDR_ENABLE0                                        #
#                                                                        #
##########################################################################

%shub2_01_01052_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Header Enable 0" ],
);

%shub2_01_01052_def =
( NAME    => "SH2_XN_NI1_MD_CMP_HDR_ENABLE0",
  ADDRESS => 0x0000000050031be0,
  NOTE    => "Added for SHub2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01052_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_NI1_MD_CMP_HDR_ENABLE1                                        #
#                                                                        #
##########################################################################

%shub2_01_01053_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Header Enable 1" ],
);

%shub2_01_01053_def =
( NAME    => "SH2_XN_NI1_MD_CMP_HDR_ENABLE1",
  ADDRESS => 0x0000000050031bf0,
  NOTE    => "Added for SHub2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01053_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_PI_DEBUG_SEL                                                  #
#                                                                        #
##########################################################################

%shub2_01_01054_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_INPUT_SEL"            => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 input select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_INPUT_SEL"            => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 input select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_INPUT_SEL"            => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 input select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_INPUT_SEL"            => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 input select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_INPUT_SEL"            => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 input select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_INPUT_SEL"            => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 input select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_INPUT_SEL"            => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 input select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_INPUT_SEL"            => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 input select" ],
);

%shub2_01_01054_def =
( NAME    => "SH2_XN_PI_DEBUG_SEL",
  ADDRESS => 0x00000000500310a0,
  NOTE    => "XN PI Debug Port Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01054_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_PI_IILB_CMP_EXP_DATA0                                         #
#                                                                        #
##########################################################################

%shub2_01_01055_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub2_01_01055_def =
( NAME    => "SH2_XN_PI_IILB_CMP_EXP_DATA0",
  ADDRESS => 0x0000000050031300,
  NOTE    => "PI compare IILB input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01055_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_PI_IILB_CMP_EXP_DATA1                                         #
#                                                                        #
##########################################################################

%shub2_01_01056_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub2_01_01056_def =
( NAME    => "SH2_XN_PI_IILB_CMP_EXP_DATA1",
  ADDRESS => 0x0000000050031310,
  NOTE    => "PI compare IILB input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01056_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_PI_IILB_CMP_ENABLE0                                           #
#                                                                        #
##########################################################################

%shub2_01_01057_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub2_01_01057_def =
( NAME    => "SH2_XN_PI_IILB_CMP_ENABLE0",
  ADDRESS => 0x0000000050031320,
  NOTE    => "PI compare IILB input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01057_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_PI_IILB_CMP_ENABLE1                                           #
#                                                                        #
##########################################################################

%shub2_01_01058_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub2_01_01058_def =
( NAME    => "SH2_XN_PI_IILB_CMP_ENABLE1",
  ADDRESS => 0x0000000050031330,
  NOTE    => "PI compare IILB input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01058_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_PI_NI0_CMP_EXP_DATA0                                          #
#                                                                        #
##########################################################################

%shub2_01_01059_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub2_01_01059_def =
( NAME    => "SH2_XN_PI_NI0_CMP_EXP_DATA0",
  ADDRESS => 0x0000000050031340,
  NOTE    => "PI compare NI0 input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01059_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_PI_NI0_CMP_EXP_DATA1                                          #
#                                                                        #
##########################################################################

%shub2_01_01060_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub2_01_01060_def =
( NAME    => "SH2_XN_PI_NI0_CMP_EXP_DATA1",
  ADDRESS => 0x0000000050031350,
  NOTE    => "PI compare NI0 input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01060_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_PI_NI0_CMP_ENABLE0                                            #
#                                                                        #
##########################################################################

%shub2_01_01061_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub2_01_01061_def =
( NAME    => "SH2_XN_PI_NI0_CMP_ENABLE0",
  ADDRESS => 0x0000000050031360,
  NOTE    => "PI compare NI0 input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01061_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_PI_NI0_CMP_ENABLE1                                            #
#                                                                        #
##########################################################################

%shub2_01_01062_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub2_01_01062_def =
( NAME    => "SH2_XN_PI_NI0_CMP_ENABLE1",
  ADDRESS => 0x0000000050031370,
  NOTE    => "PI compare NI0 input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01062_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_PI_NI1_CMP_EXP_DATA0                                          #
#                                                                        #
##########################################################################

%shub2_01_01063_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub2_01_01063_def =
( NAME    => "SH2_XN_PI_NI1_CMP_EXP_DATA0",
  ADDRESS => 0x0000000050031380,
  NOTE    => "PI compare NI1 input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01063_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_PI_NI1_CMP_EXP_DATA1                                          #
#                                                                        #
##########################################################################

%shub2_01_01064_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub2_01_01064_def =
( NAME    => "SH2_XN_PI_NI1_CMP_EXP_DATA1",
  ADDRESS => 0x0000000050031390,
  NOTE    => "PI compare NI1 input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01064_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_PI_NI1_CMP_ENABLE0                                            #
#                                                                        #
##########################################################################

%shub2_01_01065_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub2_01_01065_def =
( NAME    => "SH2_XN_PI_NI1_CMP_ENABLE0",
  ADDRESS => 0x00000000500313a0,
  NOTE    => "PI compare NI1 input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01065_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_PI_NI1_CMP_ENABLE1                                            #
#                                                                        #
##########################################################################

%shub2_01_01066_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub2_01_01066_def =
( NAME    => "SH2_XN_PI_NI1_CMP_ENABLE1",
  ADDRESS => 0x00000000500313b0,
  NOTE    => "PI compare NI1 input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01066_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_PI_SIC_CMP_DATA0                                              #
#                                                                        #
##########################################################################

%shub2_01_01067_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA0"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data0" ],
);

%shub2_01_01067_def =
( NAME    => "SH2_XN_PI_SIC_CMP_DATA0",
  ADDRESS => 0x0000000050031400,
  NOTE    => "PI compare SICN data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01067_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_PI_SIC_CMP_DATA1                                              #
#                                                                        #
##########################################################################

%shub2_01_01068_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA1"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data1" ],
);

%shub2_01_01068_def =
( NAME    => "SH2_XN_PI_SIC_CMP_DATA1",
  ADDRESS => 0x0000000050031410,
  NOTE    => "PI compare SICN data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01068_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_PI_SIC_CMP_DATA_ENABLE0                                       #
#                                                                        #
##########################################################################

%shub2_01_01069_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_ENABLE0"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data0" ],
);

%shub2_01_01069_def =
( NAME    => "SH2_XN_PI_SIC_CMP_DATA_ENABLE0",
  ADDRESS => 0x0000000050031440,
  NOTE    => "PI enable compare SICN data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01069_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_PI_SIC_CMP_DATA_ENABLE1                                       #
#                                                                        #
##########################################################################

%shub2_01_01070_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_ENABLE1"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data1" ],
);

%shub2_01_01070_def =
( NAME    => "SH2_XN_PI_SIC_CMP_DATA_ENABLE1",
  ADDRESS => 0x0000000050031450,
  NOTE    => "PI enable compare SICN data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01070_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_MD_DEBUG_SEL                                                  #
#                                                                        #
##########################################################################

%shub2_01_01071_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_INPUT_SEL"            => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 input select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_INPUT_SEL"            => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 input select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_INPUT_SEL"            => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 input select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_INPUT_SEL"            => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 input select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_INPUT_SEL"            => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 input select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_INPUT_SEL"            => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 input select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_INPUT_SEL"            => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 input select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_INPUT_SEL"            => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 input select" ],
);

%shub2_01_01071_def =
( NAME    => "SH2_XN_MD_DEBUG_SEL",
  ADDRESS => 0x0000000050031080,
  NOTE    => "XN MD Debug Port Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01071_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_MD_IILB_CMP_EXP_DATA0                                         #
#                                                                        #
##########################################################################

%shub2_01_01072_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub2_01_01072_def =
( NAME    => "SH2_XN_MD_IILB_CMP_EXP_DATA0",
  ADDRESS => 0x0000000050031500,
  NOTE    => "MD compare IILB input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01072_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_MD_IILB_CMP_EXP_DATA1                                         #
#                                                                        #
##########################################################################

%shub2_01_01073_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub2_01_01073_def =
( NAME    => "SH2_XN_MD_IILB_CMP_EXP_DATA1",
  ADDRESS => 0x0000000050031510,
  NOTE    => "MD compare IILB input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01073_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_MD_IILB_CMP_ENABLE0                                           #
#                                                                        #
##########################################################################

%shub2_01_01074_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub2_01_01074_def =
( NAME    => "SH2_XN_MD_IILB_CMP_ENABLE0",
  ADDRESS => 0x0000000050031520,
  NOTE    => "MD compare IILB input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01074_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_MD_IILB_CMP_ENABLE1                                           #
#                                                                        #
##########################################################################

%shub2_01_01075_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub2_01_01075_def =
( NAME    => "SH2_XN_MD_IILB_CMP_ENABLE1",
  ADDRESS => 0x0000000050031530,
  NOTE    => "MD compare IILB input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01075_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_MD_NI0_CMP_EXP_DATA0                                          #
#                                                                        #
##########################################################################

%shub2_01_01076_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub2_01_01076_def =
( NAME    => "SH2_XN_MD_NI0_CMP_EXP_DATA0",
  ADDRESS => 0x0000000050031540,
  NOTE    => "MD compare NI0 input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01076_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_MD_NI0_CMP_EXP_DATA1                                          #
#                                                                        #
##########################################################################

%shub2_01_01077_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub2_01_01077_def =
( NAME    => "SH2_XN_MD_NI0_CMP_EXP_DATA1",
  ADDRESS => 0x0000000050031550,
  NOTE    => "MD compare NI0 input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01077_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_MD_NI0_CMP_ENABLE0                                            #
#                                                                        #
##########################################################################

%shub2_01_01078_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub2_01_01078_def =
( NAME    => "SH2_XN_MD_NI0_CMP_ENABLE0",
  ADDRESS => 0x0000000050031560,
  NOTE    => "MD compare NI0 input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01078_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_MD_NI0_CMP_ENABLE1                                            #
#                                                                        #
##########################################################################

%shub2_01_01079_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub2_01_01079_def =
( NAME    => "SH2_XN_MD_NI0_CMP_ENABLE1",
  ADDRESS => 0x0000000050031570,
  NOTE    => "MD compare NI0 input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01079_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_MD_NI1_CMP_EXP_DATA0                                          #
#                                                                        #
##########################################################################

%shub2_01_01080_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub2_01_01080_def =
( NAME    => "SH2_XN_MD_NI1_CMP_EXP_DATA0",
  ADDRESS => 0x0000000050031580,
  NOTE    => "MD compare NI1 input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01080_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_MD_NI1_CMP_EXP_DATA1                                          #
#                                                                        #
##########################################################################

%shub2_01_01081_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub2_01_01081_def =
( NAME    => "SH2_XN_MD_NI1_CMP_EXP_DATA1",
  ADDRESS => 0x0000000050031590,
  NOTE    => "MD compare NI1 input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01081_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_MD_NI1_CMP_ENABLE0                                            #
#                                                                        #
##########################################################################

%shub2_01_01082_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub2_01_01082_def =
( NAME    => "SH2_XN_MD_NI1_CMP_ENABLE0",
  ADDRESS => 0x00000000500315a0,
  NOTE    => "MD compare NI1 input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01082_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_MD_NI1_CMP_ENABLE1                                            #
#                                                                        #
##########################################################################

%shub2_01_01083_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub2_01_01083_def =
( NAME    => "SH2_XN_MD_NI1_CMP_ENABLE1",
  ADDRESS => 0x00000000500315b0,
  NOTE    => "MD compare NI1 input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01083_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_MD_SIC_CMP_EXP_HDR0                                           #
#                                                                        #
##########################################################################

%shub2_01_01084_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub2_01_01084_def =
( NAME    => "SH2_XN_MD_SIC_CMP_EXP_HDR0",
  ADDRESS => 0x00000000500315c0,
  NOTE    => "MD compare SIC input expected header0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01084_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_MD_SIC_CMP_EXP_HDR1                                           #
#                                                                        #
##########################################################################

%shub2_01_01085_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub2_01_01085_def =
( NAME    => "SH2_XN_MD_SIC_CMP_EXP_HDR1",
  ADDRESS => 0x00000000500315d0,
  NOTE    => "MD compare SIC input expected header1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01085_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_MD_SIC_CMP_HDR_ENABLE0                                        #
#                                                                        #
##########################################################################

%shub2_01_01086_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub2_01_01086_def =
( NAME    => "SH2_XN_MD_SIC_CMP_HDR_ENABLE0",
  ADDRESS => 0x00000000500315e0,
  NOTE    => "MD compare SIC header enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01086_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_MD_SIC_CMP_HDR_ENABLE1                                        #
#                                                                        #
##########################################################################

%shub2_01_01087_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub2_01_01087_def =
( NAME    => "SH2_XN_MD_SIC_CMP_HDR_ENABLE1",
  ADDRESS => 0x00000000500315f0,
  NOTE    => "MD compare SIC header enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01087_flds
);


##########################################################################
#                                                                        #
#   SH2_XNPI_ECC_INJ_REG                                                 #
#                                                                        #
##########################################################################

%shub2_01_01088_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_CB_CONT3"                => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Continuous Replace Checkbyte" ],
   "DATA_CB_1SHOT3"               => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "One Shot Replace Checkbyte" ],
   "DATA_CONT3"                   => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "Toggle Mask Data" ],
   "DATA_1SHOT3"                  => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "One Shot Mask Data" ],
   "RSVD0"                        => [   4,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BYTE3"                        => [   5,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Replacement Checkbyte" ],
   "DATA_CB_CONT2"                => [   6,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "Continuous Replace Checkbyte" ],
   "DATA_CB_1SHOT2"               => [   7,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "One Shot Replace Checkbyte" ],
   "DATA_CONT2"                   => [   8,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "Continuous Mask Data" ],
   "DATA_1SHOT2"                  => [   9,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "One Shot Mask Data" ],
   "RSVD1"                        => [  10,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BYTE2"                        => [  11,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Replacement Checkbyte" ],
   "DATA_CB_CONT1"                => [  12,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "Continuous Replace Checkbyte" ],
   "DATA_CB_1SHOT1"               => [  13,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "One Shot Replace Checkbyte" ],
   "DATA_CONT1"                   => [  14,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "Toggle Mask Data" ],
   "DATA_1SHOT1"                  => [  15,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "One Shot Mask Data" ],
   "RSVD2"                        => [  16,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BYTE1"                        => [  17,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Replacement Checkbyte" ],
   "DATA_CB_CONT0"                => [  18,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Continuous Replace Checkbyte" ],
   "DATA_CB_1SHOT0"               => [  19,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "One Shot Replace Checkbyte" ],
   "DATA_CONT0"                   => [  20,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Continuous Mask Data" ],
   "DATA_1SHOT0"                  => [  21,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "One Shot Mask Data" ],
   "RSVD3"                        => [  22,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BYTE0"                        => [  23,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Replacement Checkbyte" ],
);

%shub2_01_01088_def =
( NAME    => "SH2_XNPI_ECC_INJ_REG",
  ADDRESS => 0x0000000050032000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01088_flds
);


##########################################################################
#                                                                        #
#   SH2_XNPI_ECC0_INJ_MASK_REG                                           #
#                                                                        #
##########################################################################

%shub2_01_01089_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK_ECC0"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Replacement Mask" ],
);

%shub2_01_01089_def =
( NAME    => "SH2_XNPI_ECC0_INJ_MASK_REG",
  ADDRESS => 0x0000000050032010,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01089_flds
);


##########################################################################
#                                                                        #
#   SH2_XNPI_ECC1_INJ_MASK_REG                                           #
#                                                                        #
##########################################################################

%shub2_01_01090_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK_ECC1"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Replacement Mask" ],
);

%shub2_01_01090_def =
( NAME    => "SH2_XNPI_ECC1_INJ_MASK_REG",
  ADDRESS => 0x0000000050032020,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01090_flds
);


##########################################################################
#                                                                        #
#   SH2_XNPI_ECC2_INJ_MASK_REG                                           #
#                                                                        #
##########################################################################

%shub2_01_01091_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK_ECC2"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Replacement Mask" ],
);

%shub2_01_01091_def =
( NAME    => "SH2_XNPI_ECC2_INJ_MASK_REG",
  ADDRESS => 0x0000000050032030,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01091_flds
);


##########################################################################
#                                                                        #
#   SH2_XNPI_ECC3_INJ_MASK_REG                                           #
#                                                                        #
##########################################################################

%shub2_01_01092_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK_ECC3"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Replacement Mask" ],
);

%shub2_01_01092_def =
( NAME    => "SH2_XNPI_ECC3_INJ_MASK_REG",
  ADDRESS => 0x0000000050032040,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01092_flds
);


##########################################################################
#                                                                        #
#   SH2_XNMD_ECC_INJ_REG                                                 #
#                                                                        #
##########################################################################

%shub2_01_01093_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_CB_CONT3"                => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Continuous Replace Checkbyte" ],
   "DATA_CB_1SHOT3"               => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "One Shot Replace Checkbyte" ],
   "DATA_CONT3"                   => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "Toggle Mask Data" ],
   "DATA_1SHOT3"                  => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "One Shot Mask Data" ],
   "RSVD0"                        => [   4,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BYTE3"                        => [   5,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Replacement Checkbyte" ],
   "DATA_CB_CONT2"                => [   6,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "Continuous Replace Checkbyte" ],
   "DATA_CB_1SHOT2"               => [   7,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "One Shot Replace Checkbyte" ],
   "DATA_CONT2"                   => [   8,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "Continuous Mask Data" ],
   "DATA_1SHOT2"                  => [   9,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "One Shot Mask Data" ],
   "RSVD1"                        => [  10,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BYTE2"                        => [  11,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Replacement Checkbyte" ],
   "DATA_CB_CONT1"                => [  12,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "Continuous Replace Checkbyte" ],
   "DATA_CB_1SHOT1"               => [  13,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "One Shot Replace Checkbyte" ],
   "DATA_CONT1"                   => [  14,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "Toggle Mask Data" ],
   "DATA_1SHOT1"                  => [  15,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "One Shot Mask Data" ],
   "RSVD2"                        => [  16,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BYTE1"                        => [  17,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Replacement Checkbyte" ],
   "DATA_CB_CONT0"                => [  18,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Continuous Replace Checkbyte" ],
   "DATA_CB_1SHOT0"               => [  19,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "One Shot Replace Checkbyte" ],
   "DATA_CONT0"                   => [  20,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Continuous Mask Data" ],
   "DATA_1SHOT0"                  => [  21,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "One Shot Mask Data" ],
   "RSVD3"                        => [  22,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BYTE0"                        => [  23,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Replacement Checkbyte" ],
);

%shub2_01_01093_def =
( NAME    => "SH2_XNMD_ECC_INJ_REG",
  ADDRESS => 0x0000000050032050,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01093_flds
);


##########################################################################
#                                                                        #
#   SH2_XNMD_ECC0_INJ_MASK_REG                                           #
#                                                                        #
##########################################################################

%shub2_01_01094_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK_ECC0"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Replacement Mask" ],
);

%shub2_01_01094_def =
( NAME    => "SH2_XNMD_ECC0_INJ_MASK_REG",
  ADDRESS => 0x0000000050032060,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01094_flds
);


##########################################################################
#                                                                        #
#   SH2_XNMD_ECC1_INJ_MASK_REG                                           #
#                                                                        #
##########################################################################

%shub2_01_01095_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK_ECC1"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Replacement Mask" ],
);

%shub2_01_01095_def =
( NAME    => "SH2_XNMD_ECC1_INJ_MASK_REG",
  ADDRESS => 0x0000000050032070,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01095_flds
);


##########################################################################
#                                                                        #
#   SH2_XNMD_ECC2_INJ_MASK_REG                                           #
#                                                                        #
##########################################################################

%shub2_01_01096_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK_ECC2"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Replacement Mask" ],
);

%shub2_01_01096_def =
( NAME    => "SH2_XNMD_ECC2_INJ_MASK_REG",
  ADDRESS => 0x0000000050032080,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01096_flds
);


##########################################################################
#                                                                        #
#   SH2_XNMD_ECC3_INJ_MASK_REG                                           #
#                                                                        #
##########################################################################

%shub2_01_01097_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK_ECC3"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Replacement Mask" ],
);

%shub2_01_01097_def =
( NAME    => "SH2_XNMD_ECC3_INJ_MASK_REG",
  ADDRESS => 0x0000000050032090,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01097_flds
);


##########################################################################
#                                                                        #
#   SH2_XNMD_ECC_ERR_REPORT                                              #
#                                                                        #
##########################################################################

%shub2_01_01098_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  49,  15, 0xFFFE000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECC_DISABLE3"                 => [   1,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "Disable Error Correction and Reporting DW3" ],
   "RSVD1"                        => [   2,  33,  15, 0x0000FFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECC_DISABLE2"                 => [   3,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "Disable Error Correction and Reporting DW2" ],
   "RSVD2"                        => [   4,  17,  15, 0x00000000FFFE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECC_DISABLE1"                 => [   5,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Disable Error Correction and Reporting DW1" ],
   "RSVD3"                        => [   6,   1,  15, 0x000000000000FFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECC_DISABLE0"                 => [   7,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Disable Error Correction and Reporting DW0" ],
);

%shub2_01_01098_def =
( NAME    => "SH2_XNMD_ECC_ERR_REPORT",
  ADDRESS => 0x00000000500320a0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01098_flds
);


##########################################################################
#                                                                        #
#   SH2_NI0_ERROR_SUMMARY_1                                              #
#                                                                        #
##########################################################################

%shub2_01_01099_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_TAIL_TIMEOUT_VC3"          => [   1,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc3" ],
   "NI_TAIL_TIMEOUT_VC2"          => [   2,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc2" ],
   "NI_TAIL_TIMEOUT_VC1"          => [   3,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc1" ],
   "NI_TAIL_TIMEOUT_VC0"          => [   4,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc0" ],
   "PI_TAIL_TIMEOUT_VC3"          => [   5,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc3" ],
   "PI_TAIL_TIMEOUT_VC2"          => [   6,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc2" ],
   "PI_TAIL_TIMEOUT_VC1"          => [   7,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc1" ],
   "PI_TAIL_TIMEOUT_VC0"          => [   8,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc0" ],
   "MD_TAIL_TIMEOUT_VC3"          => [   9,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc3" ],
   "MD_TAIL_TIMEOUT_VC2"          => [  10,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc2" ],
   "MD_TAIL_TIMEOUT_VC1"          => [  11,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc1" ],
   "MD_TAIL_TIMEOUT_VC0"          => [  12,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc0" ],
   "IILB_TAIL_TIMEOUT_VC3"        => [  13,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc3" ],
   "IILB_TAIL_TIMEOUT_VC2"        => [  14,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc2" ],
   "IILB_TAIL_TIMEOUT_VC1"        => [  15,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc1" ],
   "IILB_TAIL_TIMEOUT_VC0"        => [  16,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc0" ],
   "NI_DEBITSAVER_OVERFLOW_VC3"   => [  17,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc3" ],
   "NI_DEBITSAVER_OVERFLOW_VC2"   => [  18,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc2" ],
   "NI_DEBITSAVER_OVERFLOW_VC1"   => [  19,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc1" ],
   "NI_DEBITSAVER_OVERFLOW_VC0"   => [  20,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc0" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC3"   => [  21,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc3" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC2"   => [  22,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc2" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC1"   => [  23,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc1" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC0"   => [  24,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc0" ],
   "NI_FAST_TAIL_OVERFLOW"        => [  25,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI fast tail overflow" ],
   "PI_DATA_FAST_TAIL_OVERFLOW"   => [  26,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail overflow" ],
   "PI_HDR_FAST_TAIL_OVERFLOW"    => [  27,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail overflow" ],
   "MD_DATA_FAST_TAIL_OVERFLOW"   => [  28,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "MD data fast tail overflow" ],
   "MD_HDR_FAST_TAIL_OVERFLOW"    => [  29,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail overflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  30,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC3"  => [  31,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc3" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC2"  => [  32,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc2" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC1"  => [  33,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc1" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC0"  => [  34,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc0" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  35,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc2" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  36,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc2" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  37,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc0" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  38,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc0" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  39,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc2" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  40,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc2" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  41,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc0" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  42,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc0" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC2" => [  43,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc2" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC0" => [  44,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc0" ],
   "NI_DEBIT_OVERFLOW_VC3"        => [  45,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc3" ],
   "NI_DEBIT_OVERFLOW_VC2"        => [  46,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc2" ],
   "NI_DEBIT_OVERFLOW_VC1"        => [  47,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc1" ],
   "NI_DEBIT_OVERFLOW_VC0"        => [  48,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc0" ],
   "PI_DEBIT_OVERFLOW_VC2"        => [  49,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc2" ],
   "PI_DEBIT_OVERFLOW_VC0"        => [  50,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc0" ],
   "MD_DEBIT_OVERFLOW_VC2"        => [  51,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "MD debit overflow vc2" ],
   "MD_DEBIT_OVERFLOW_VC0"        => [  52,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "MD debit overflow vc0" ],
   "IILB_DEBIT_OVERFLOW_VC2"      => [  53,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc2" ],
   "IILB_DEBIT_OVERFLOW_VC0"      => [  54,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc0" ],
   "OVERFLOW_NI_VC3_CREDIT"       => [  55,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit overflow vc3" ],
   "OVERFLOW_NI_VC2_CREDIT"       => [  56,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit overflow vc2" ],
   "OVERFLOW_NI_VC1_CREDIT"       => [  57,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit overflow vc1" ],
   "OVERFLOW_NI_VC0_CREDIT"       => [  58,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT3"          => [  59,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT2"          => [  60,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT1"          => [  61,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT0"          => [  62,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
);

%shub2_01_01099_def =
( NAME    => "SH2_NI0_ERROR_SUMMARY_1",
  ADDRESS => 0x0000000050040500,
  NOTE    => "ni0 Error Summary Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01099_flds
);


##########################################################################
#                                                                        #
#   SH2_NI0_ERROR_SUMMARY_1_ALIAS                                        #
#                                                                        #
##########################################################################

%shub2_01_01100_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_TAIL_TIMEOUT_VC3"          => [   1,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc3" ],
   "NI_TAIL_TIMEOUT_VC2"          => [   2,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc2" ],
   "NI_TAIL_TIMEOUT_VC1"          => [   3,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc1" ],
   "NI_TAIL_TIMEOUT_VC0"          => [   4,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc0" ],
   "PI_TAIL_TIMEOUT_VC3"          => [   5,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc3" ],
   "PI_TAIL_TIMEOUT_VC2"          => [   6,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc2" ],
   "PI_TAIL_TIMEOUT_VC1"          => [   7,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc1" ],
   "PI_TAIL_TIMEOUT_VC0"          => [   8,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc0" ],
   "MD_TAIL_TIMEOUT_VC3"          => [   9,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc3" ],
   "MD_TAIL_TIMEOUT_VC2"          => [  10,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc2" ],
   "MD_TAIL_TIMEOUT_VC1"          => [  11,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc1" ],
   "MD_TAIL_TIMEOUT_VC0"          => [  12,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc0" ],
   "IILB_TAIL_TIMEOUT_VC3"        => [  13,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc3" ],
   "IILB_TAIL_TIMEOUT_VC2"        => [  14,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc2" ],
   "IILB_TAIL_TIMEOUT_VC1"        => [  15,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc1" ],
   "IILB_TAIL_TIMEOUT_VC0"        => [  16,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc0" ],
   "NI_DEBITSAVER_OVERFLOW_VC3"   => [  17,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc3" ],
   "NI_DEBITSAVER_OVERFLOW_VC2"   => [  18,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc2" ],
   "NI_DEBITSAVER_OVERFLOW_VC1"   => [  19,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc1" ],
   "NI_DEBITSAVER_OVERFLOW_VC0"   => [  20,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc0" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC3"   => [  21,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc3" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC2"   => [  22,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc2" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC1"   => [  23,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc1" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC0"   => [  24,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc0" ],
   "NI_FAST_TAIL_OVERFLOW"        => [  25,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI fast tail overflow" ],
   "PI_DATA_FAST_TAIL_OVERFLOW"   => [  26,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail overflow" ],
   "PI_HDR_FAST_TAIL_OVERFLOW"    => [  27,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail overflow" ],
   "MD_DATA_FAST_TAIL_OVERFLOW"   => [  28,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "MD data fast tail overflow" ],
   "MD_HDR_FAST_TAIL_OVERFLOW"    => [  29,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail overflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  30,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC3"  => [  31,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc3" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC2"  => [  32,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc2" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC1"  => [  33,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc1" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC0"  => [  34,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc0" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  35,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc2" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  36,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc2" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  37,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc0" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  38,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc0" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  39,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc2" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  40,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc2" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  41,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc0" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  42,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc0" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC2" => [  43,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc2" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC0" => [  44,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc0" ],
   "NI_DEBIT_OVERFLOW_VC3"        => [  45,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc3" ],
   "NI_DEBIT_OVERFLOW_VC2"        => [  46,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc2" ],
   "NI_DEBIT_OVERFLOW_VC1"        => [  47,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc1" ],
   "NI_DEBIT_OVERFLOW_VC0"        => [  48,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc0" ],
   "PI_DEBIT_OVERFLOW_VC2"        => [  49,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc2" ],
   "PI_DEBIT_OVERFLOW_VC0"        => [  50,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc0" ],
   "MD_DEBIT_OVERFLOW_VC2"        => [  51,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "MD debit overflow vc2" ],
   "MD_DEBIT_OVERFLOW_VC0"        => [  52,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "MD debit overflow vc0" ],
   "IILB_DEBIT_OVERFLOW_VC2"      => [  53,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc2" ],
   "IILB_DEBIT_OVERFLOW_VC0"      => [  54,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc0" ],
   "OVERFLOW_NI_VC3_CREDIT"       => [  55,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit overflow vc3" ],
   "OVERFLOW_NI_VC2_CREDIT"       => [  56,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit overflow vc2" ],
   "OVERFLOW_NI_VC1_CREDIT"       => [  57,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit overflow vc1" ],
   "OVERFLOW_NI_VC0_CREDIT"       => [  58,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT3"          => [  59,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT2"          => [  60,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT1"          => [  61,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT0"          => [  62,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
);

%shub2_01_01100_def =
( NAME    => "SH2_NI0_ERROR_SUMMARY_1_ALIAS",
  ADDRESS => 0x0000000050040508,
  NOTE    => "ni0 Error Summary Bits Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01100_flds
);


##########################################################################
#                                                                        #
#   SH2_NI0_ERROR_SUMMARY_2                                              #
#                                                                        #
##########################################################################

%shub2_01_01101_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DAM_PI_XMIT_MSG_VC3"          => [   1,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "PI VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_PI_XMIT_MSG_VC2"          => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "PI VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_PI_XMIT_MSG_VC1"          => [   3,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "PI VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_PI_XMIT_MSG_VC0"          => [   4,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC3"          => [   5,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "MD VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC2"          => [   6,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "MD VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC1"          => [   7,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "MD VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC0"          => [   8,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC3"          => [   9,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC2"          => [  10,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC1"          => [  11,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC0"          => [  12,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI VC0 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC3"        => [  13,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC2"        => [  14,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC1"        => [  15,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC0"        => [  16,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Xmit Message Lost, as result of Link Reset" ],
   "RETRY_TIMEOUT_ERROR"          => [  17,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [  18,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [  19,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "MD_TAIL_CNT_ERROR"            => [  20,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "MD tail count error" ],
   "PI_TAIL_CNT_ERROR"            => [  21,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI tail count error" ],
   "NI_ILLEGAL_VC"                => [  22,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI illegal vc" ],
   "PI_ILLEGAL_VC"                => [  23,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "PI illegal vc" ],
   "MD_ILLEGAL_VC"                => [  24,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD illegal vc" ],
   "IILB_ILLEGAL_VC"              => [  25,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB illegal vc" ],
   "NI_FAST_TAIL_ERROR"           => [  26,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI fast tail error" ],
   "PI_FAST_TAIL_ERROR"           => [  27,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PI fast tail error" ],
   "MD_FAST_TAIL_ERROR"           => [  28,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD fast tail error" ],
   "IILB_FAST_TAIL_ERROR"         => [  29,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "NI_FAST_TAIL_UNDERFLOW"       => [  30,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fast tail underflow" ],
   "PI_DATA_FAST_TAIL_UNDERFLOW"  => [  31,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "PI data fast tail underflow" ],
   "PI_HDR_FAST_TAIL_UNDERFLOW"   => [  32,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail underflow" ],
   "MD_DATA_FAST_TAIL_UNDERFLOW"  => [  33,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "MD data fast tail underflow" ],
   "MD_HDR_FAST_TAIL_UNDERFLOW"   => [  34,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail underflow" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [  35,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC3" => [  36,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc3" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC2" => [  37,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc2" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC1" => [  38,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc1" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC0" => [  39,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc0" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  40,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc2" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  41,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc2" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  42,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc0" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  43,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc0" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  44,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc2" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  45,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc2" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  46,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc0" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  47,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc0" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC2" => [  48,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc2" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC0" => [  49,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc0" ],
   "PI_DEBIT_UNDERFLOW_VC2"       => [  50,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI debit underflow vc2" ],
   "PI_DEBIT_UNDERFLOW_VC0"       => [  51,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI debit underflow vc0" ],
   "MD_DEBIT_UNDERFLOW_VC2"       => [  52,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "MD debit underflow vc2" ],
   "MD_DEBIT_UNDERFLOW_VC0"       => [  53,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "MD debit underflow vc0" ],
   "UNDERFLOW_NI_VC3_CREDIT"      => [  54,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit underflow vc3" ],
   "UNDERFLOW_NI_VC2_CREDIT"      => [  55,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit underflow vc2" ],
   "UNDERFLOW_NI_VC1_CREDIT"      => [  56,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit underflow vc1" ],
   "UNDERFLOW_NI_VC0_CREDIT"      => [  57,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit underflow vc0" ],
   "LLP_DEADLOCK_VC3"             => [  58,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [  59,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [  60,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [  61,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
);

%shub2_01_01101_def =
( NAME    => "SH2_NI0_ERROR_SUMMARY_2",
  ADDRESS => 0x0000000050040510,
  NOTE    => "ni0 Error Summary Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01101_flds
);


##########################################################################
#                                                                        #
#   SH2_NI0_ERROR_SUMMARY_2_ALIAS                                        #
#                                                                        #
##########################################################################

%shub2_01_01102_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DAM_PI_XMIT_MSG_VC3"          => [   1,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "PI VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_PI_XMIT_MSG_VC2"          => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "PI VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_PI_XMIT_MSG_VC1"          => [   3,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "PI VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_PI_XMIT_MSG_VC0"          => [   4,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC3"          => [   5,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "MD VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC2"          => [   6,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "MD VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC1"          => [   7,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "MD VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC0"          => [   8,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC3"          => [   9,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC2"          => [  10,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC1"          => [  11,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC0"          => [  12,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI VC0 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC3"        => [  13,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC2"        => [  14,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC1"        => [  15,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC0"        => [  16,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Xmit Message Lost, as result of Link Reset" ],
   "RETRY_TIMEOUT_ERROR"          => [  17,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [  18,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [  19,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "MD_TAIL_CNT_ERROR"            => [  20,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "MD tail count error" ],
   "PI_TAIL_CNT_ERROR"            => [  21,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI tail count error" ],
   "NI_ILLEGAL_VC"                => [  22,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI illegal vc" ],
   "PI_ILLEGAL_VC"                => [  23,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "PI illegal vc" ],
   "MD_ILLEGAL_VC"                => [  24,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD illegal vc" ],
   "IILB_ILLEGAL_VC"              => [  25,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB illegal vc" ],
   "NI_FAST_TAIL_ERROR"           => [  26,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI fast tail error" ],
   "PI_FAST_TAIL_ERROR"           => [  27,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PI fast tail error" ],
   "MD_FAST_TAIL_ERROR"           => [  28,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD fast tail error" ],
   "IILB_FAST_TAIL_ERROR"         => [  29,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "NI_FAST_TAIL_UNDERFLOW"       => [  30,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fast tail underflow" ],
   "PI_DATA_FAST_TAIL_UNDERFLOW"  => [  31,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "PI data fast tail underflow" ],
   "PI_HDR_FAST_TAIL_UNDERFLOW"   => [  32,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail underflow" ],
   "MD_DATA_FAST_TAIL_UNDERFLOW"  => [  33,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "MD data fast tail underflow" ],
   "MD_HDR_FAST_TAIL_UNDERFLOW"   => [  34,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail underflow" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [  35,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC3" => [  36,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc3" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC2" => [  37,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc2" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC1" => [  38,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc1" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC0" => [  39,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc0" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  40,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc2" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  41,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc2" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  42,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc0" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  43,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc0" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  44,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc2" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  45,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc2" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  46,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc0" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  47,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc0" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC2" => [  48,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc2" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC0" => [  49,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc0" ],
   "PI_DEBIT_UNDERFLOW_VC2"       => [  50,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI debit underflow vc2" ],
   "PI_DEBIT_UNDERFLOW_VC0"       => [  51,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI debit underflow vc0" ],
   "MD_DEBIT_UNDERFLOW_VC2"       => [  52,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "MD debit underflow vc2" ],
   "MD_DEBIT_UNDERFLOW_VC0"       => [  53,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "MD debit underflow vc0" ],
   "UNDERFLOW_NI_VC3_CREDIT"      => [  54,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit underflow vc3" ],
   "UNDERFLOW_NI_VC2_CREDIT"      => [  55,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit underflow vc2" ],
   "UNDERFLOW_NI_VC1_CREDIT"      => [  56,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit underflow vc1" ],
   "UNDERFLOW_NI_VC0_CREDIT"      => [  57,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit underflow vc0" ],
   "LLP_DEADLOCK_VC3"             => [  58,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [  59,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [  60,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [  61,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
);

%shub2_01_01102_def =
( NAME    => "SH2_NI0_ERROR_SUMMARY_2_ALIAS",
  ADDRESS => 0x0000000050040518,
  NOTE    => "ni0 Error Summary Bits Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01102_flds
);


##########################################################################
#                                                                        #
#   SH2_NI0_ERROR_OVERFLOW_1                                             #
#                                                                        #
##########################################################################

%shub2_01_01103_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_TAIL_TIMEOUT_VC3"          => [   1,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc3" ],
   "NI_TAIL_TIMEOUT_VC2"          => [   2,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc2" ],
   "NI_TAIL_TIMEOUT_VC1"          => [   3,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc1" ],
   "NI_TAIL_TIMEOUT_VC0"          => [   4,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc0" ],
   "PI_TAIL_TIMEOUT_VC3"          => [   5,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc3" ],
   "PI_TAIL_TIMEOUT_VC2"          => [   6,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc2" ],
   "PI_TAIL_TIMEOUT_VC1"          => [   7,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc1" ],
   "PI_TAIL_TIMEOUT_VC0"          => [   8,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc0" ],
   "MD_TAIL_TIMEOUT_VC3"          => [   9,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc3" ],
   "MD_TAIL_TIMEOUT_VC2"          => [  10,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc2" ],
   "MD_TAIL_TIMEOUT_VC1"          => [  11,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc1" ],
   "MD_TAIL_TIMEOUT_VC0"          => [  12,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc0" ],
   "IILB_TAIL_TIMEOUT_VC3"        => [  13,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc3" ],
   "IILB_TAIL_TIMEOUT_VC2"        => [  14,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc2" ],
   "IILB_TAIL_TIMEOUT_VC1"        => [  15,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc1" ],
   "IILB_TAIL_TIMEOUT_VC0"        => [  16,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc0" ],
   "NI_DEBITSAVER_OVERFLOW_VC3"   => [  17,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc3" ],
   "NI_DEBITSAVER_OVERFLOW_VC2"   => [  18,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc2" ],
   "NI_DEBITSAVER_OVERFLOW_VC1"   => [  19,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc1" ],
   "NI_DEBITSAVER_OVERFLOW_VC0"   => [  20,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc0" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC3"   => [  21,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc3" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC2"   => [  22,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc2" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC1"   => [  23,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc1" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC0"   => [  24,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc0" ],
   "NI_FAST_TAIL_OVERFLOW"        => [  25,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI fast tail overflow" ],
   "PI_DATA_FAST_TAIL_OVERFLOW"   => [  26,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail overflow" ],
   "PI_HDR_FAST_TAIL_OVERFLOW"    => [  27,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail overflow" ],
   "MD_DATA_FAST_TAIL_OVERFLOW"   => [  28,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "MD data fast tail overflow" ],
   "MD_HDR_FAST_TAIL_OVERFLOW"    => [  29,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail overflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  30,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC3"  => [  31,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc3" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC2"  => [  32,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc2" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC1"  => [  33,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc1" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC0"  => [  34,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc0" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  35,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc2" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  36,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc2" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  37,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc0" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  38,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc0" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  39,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc2" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  40,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc2" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  41,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc0" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  42,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc0" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC2" => [  43,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc2" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC0" => [  44,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc0" ],
   "NI_DEBIT_OVERFLOW_VC3"        => [  45,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc3" ],
   "NI_DEBIT_OVERFLOW_VC2"        => [  46,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc2" ],
   "NI_DEBIT_OVERFLOW_VC1"        => [  47,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc1" ],
   "NI_DEBIT_OVERFLOW_VC0"        => [  48,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc0" ],
   "PI_DEBIT_OVERFLOW_VC2"        => [  49,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc2" ],
   "PI_DEBIT_OVERFLOW_VC0"        => [  50,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc0" ],
   "MD_DEBIT_OVERFLOW_VC2"        => [  51,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "MD debit overflow vc2" ],
   "MD_DEBIT_OVERFLOW_VC0"        => [  52,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "MD debit overflow vc0" ],
   "IILB_DEBIT_OVERFLOW_VC2"      => [  53,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc2" ],
   "IILB_DEBIT_OVERFLOW_VC0"      => [  54,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc0" ],
   "OVERFLOW_NI_VC3_CREDIT"       => [  55,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit overflow vc3" ],
   "OVERFLOW_NI_VC2_CREDIT"       => [  56,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit overflow vc2" ],
   "OVERFLOW_NI_VC1_CREDIT"       => [  57,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit overflow vc1" ],
   "OVERFLOW_NI_VC0_CREDIT"       => [  58,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT3"          => [  59,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT2"          => [  60,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT1"          => [  61,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT0"          => [  62,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
);

%shub2_01_01103_def =
( NAME    => "SH2_NI0_ERROR_OVERFLOW_1",
  ADDRESS => 0x0000000050040520,
  NOTE    => "ni0 Error Overflow Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01103_flds
);


##########################################################################
#                                                                        #
#   SH2_NI0_ERROR_OVERFLOW_1_ALIAS                                       #
#                                                                        #
##########################################################################

%shub2_01_01104_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_TAIL_TIMEOUT_VC3"          => [   1,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc3" ],
   "NI_TAIL_TIMEOUT_VC2"          => [   2,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc2" ],
   "NI_TAIL_TIMEOUT_VC1"          => [   3,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc1" ],
   "NI_TAIL_TIMEOUT_VC0"          => [   4,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc0" ],
   "PI_TAIL_TIMEOUT_VC3"          => [   5,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc3" ],
   "PI_TAIL_TIMEOUT_VC2"          => [   6,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc2" ],
   "PI_TAIL_TIMEOUT_VC1"          => [   7,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc1" ],
   "PI_TAIL_TIMEOUT_VC0"          => [   8,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc0" ],
   "MD_TAIL_TIMEOUT_VC3"          => [   9,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc3" ],
   "MD_TAIL_TIMEOUT_VC2"          => [  10,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc2" ],
   "MD_TAIL_TIMEOUT_VC1"          => [  11,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc1" ],
   "MD_TAIL_TIMEOUT_VC0"          => [  12,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc0" ],
   "IILB_TAIL_TIMEOUT_VC3"        => [  13,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc3" ],
   "IILB_TAIL_TIMEOUT_VC2"        => [  14,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc2" ],
   "IILB_TAIL_TIMEOUT_VC1"        => [  15,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc1" ],
   "IILB_TAIL_TIMEOUT_VC0"        => [  16,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc0" ],
   "NI_DEBITSAVER_OVERFLOW_VC3"   => [  17,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc3" ],
   "NI_DEBITSAVER_OVERFLOW_VC2"   => [  18,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc2" ],
   "NI_DEBITSAVER_OVERFLOW_VC1"   => [  19,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc1" ],
   "NI_DEBITSAVER_OVERFLOW_VC0"   => [  20,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc0" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC3"   => [  21,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc3" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC2"   => [  22,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc2" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC1"   => [  23,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc1" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC0"   => [  24,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc0" ],
   "NI_FAST_TAIL_OVERFLOW"        => [  25,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI fast tail overflow" ],
   "PI_DATA_FAST_TAIL_OVERFLOW"   => [  26,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail overflow" ],
   "PI_HDR_FAST_TAIL_OVERFLOW"    => [  27,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail overflow" ],
   "MD_DATA_FAST_TAIL_OVERFLOW"   => [  28,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "MD data fast tail overflow" ],
   "MD_HDR_FAST_TAIL_OVERFLOW"    => [  29,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail overflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  30,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC3"  => [  31,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc3" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC2"  => [  32,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc2" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC1"  => [  33,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc1" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC0"  => [  34,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc0" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  35,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc2" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  36,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc2" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  37,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc0" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  38,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc0" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  39,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc2" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  40,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc2" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  41,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc0" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  42,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc0" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC2" => [  43,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc2" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC0" => [  44,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc0" ],
   "NI_DEBIT_OVERFLOW_VC3"        => [  45,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc3" ],
   "NI_DEBIT_OVERFLOW_VC2"        => [  46,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc2" ],
   "NI_DEBIT_OVERFLOW_VC1"        => [  47,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc1" ],
   "NI_DEBIT_OVERFLOW_VC0"        => [  48,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc0" ],
   "PI_DEBIT_OVERFLOW_VC2"        => [  49,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc2" ],
   "PI_DEBIT_OVERFLOW_VC0"        => [  50,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc0" ],
   "MD_DEBIT_OVERFLOW_VC2"        => [  51,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "MD debit overflow vc2" ],
   "MD_DEBIT_OVERFLOW_VC0"        => [  52,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "MD debit overflow vc0" ],
   "IILB_DEBIT_OVERFLOW_VC2"      => [  53,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc2" ],
   "IILB_DEBIT_OVERFLOW_VC0"      => [  54,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc0" ],
   "OVERFLOW_NI_VC3_CREDIT"       => [  55,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit overflow vc3" ],
   "OVERFLOW_NI_VC2_CREDIT"       => [  56,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit overflow vc2" ],
   "OVERFLOW_NI_VC1_CREDIT"       => [  57,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit overflow vc1" ],
   "OVERFLOW_NI_VC0_CREDIT"       => [  58,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT3"          => [  59,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT2"          => [  60,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT1"          => [  61,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT0"          => [  62,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
);

%shub2_01_01104_def =
( NAME    => "SH2_NI0_ERROR_OVERFLOW_1_ALIAS",
  ADDRESS => 0x0000000050040528,
  NOTE    => "ni0 Error Overflow Bits Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01104_flds
);


##########################################################################
#                                                                        #
#   SH2_NI0_ERROR_OVERFLOW_2                                             #
#                                                                        #
##########################################################################

%shub2_01_01105_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DAM_PI_XMIT_MSG_VC3"          => [   1,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "PI VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_PI_XMIT_MSG_VC2"          => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "PI VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_PI_XMIT_MSG_VC1"          => [   3,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "PI VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_PI_XMIT_MSG_VC0"          => [   4,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC3"          => [   5,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "MD VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC2"          => [   6,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "MD VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC1"          => [   7,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "MD VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC0"          => [   8,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC3"          => [   9,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC2"          => [  10,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC1"          => [  11,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC0"          => [  12,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI VC0 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC3"        => [  13,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC2"        => [  14,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC1"        => [  15,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC0"        => [  16,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Xmit Message Lost, as result of Link Reset" ],
   "RETRY_TIMEOUT_ERROR"          => [  17,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [  18,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [  19,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "MD_TAIL_CNT_ERROR"            => [  20,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "MD tail count error" ],
   "PI_TAIL_CNT_ERROR"            => [  21,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI tail count error" ],
   "NI_ILLEGAL_VC"                => [  22,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI illegal vc" ],
   "PI_ILLEGAL_VC"                => [  23,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "PI illegal vc" ],
   "MD_ILLEGAL_VC"                => [  24,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD illegal vc" ],
   "IILB_ILLEGAL_VC"              => [  25,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB illegal vc" ],
   "NI_FAST_TAIL_ERROR"           => [  26,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI fast tail error" ],
   "PI_FAST_TAIL_ERROR"           => [  27,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PI fast tail error" ],
   "MD_FAST_TAIL_ERROR"           => [  28,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD fast tail error" ],
   "IILB_FAST_TAIL_ERROR"         => [  29,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "NI_FAST_TAIL_UNDERFLOW"       => [  30,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fast tail underflow" ],
   "PI_DATA_FAST_TAIL_UNDERFLOW"  => [  31,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "PI data fast tail underflow" ],
   "PI_HDR_FAST_TAIL_UNDERFLOW"   => [  32,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail underflow" ],
   "MD_DATA_FAST_TAIL_UNDERFLOW"  => [  33,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "MD data fast tail underflow" ],
   "MD_HDR_FAST_TAIL_UNDERFLOW"   => [  34,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail underflow" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [  35,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC3" => [  36,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc3" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC2" => [  37,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc2" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC1" => [  38,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc1" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC0" => [  39,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc0" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  40,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc2" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  41,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc2" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  42,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc0" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  43,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc0" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  44,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc2" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  45,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc2" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  46,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc0" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  47,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc0" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC2" => [  48,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc2" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC0" => [  49,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc0" ],
   "PI_DEBIT_UNDERFLOW_VC2"       => [  50,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI debit underflow vc2" ],
   "PI_DEBIT_UNDERFLOW_VC0"       => [  51,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI debit underflow vc0" ],
   "MD_DEBIT_UNDERFLOW_VC2"       => [  52,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "MD debit underflow vc2" ],
   "MD_DEBIT_UNDERFLOW_VC0"       => [  53,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "MD debit underflow vc0" ],
   "UNDERFLOW_NI_VC3_CREDIT"      => [  54,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit underflow vc3" ],
   "UNDERFLOW_NI_VC2_CREDIT"      => [  55,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit underflow vc2" ],
   "UNDERFLOW_NI_VC1_CREDIT"      => [  56,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit underflow vc1" ],
   "UNDERFLOW_NI_VC0_CREDIT"      => [  57,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit underflow vc0" ],
   "LLP_DEADLOCK_VC3"             => [  58,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [  59,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [  60,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [  61,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
);

%shub2_01_01105_def =
( NAME    => "SH2_NI0_ERROR_OVERFLOW_2",
  ADDRESS => 0x0000000050040530,
  NOTE    => "ni0 Error Overflow Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01105_flds
);


##########################################################################
#                                                                        #
#   SH2_NI0_ERROR_OVERFLOW_2_ALIAS                                       #
#                                                                        #
##########################################################################

%shub2_01_01106_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DAM_PI_XMIT_MSG_VC3"          => [   1,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "PI VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_PI_XMIT_MSG_VC2"          => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "PI VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_PI_XMIT_MSG_VC1"          => [   3,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "PI VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_PI_XMIT_MSG_VC0"          => [   4,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC3"          => [   5,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "MD VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC2"          => [   6,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "MD VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC1"          => [   7,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "MD VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC0"          => [   8,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC3"          => [   9,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC2"          => [  10,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC1"          => [  11,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC0"          => [  12,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI VC0 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC3"        => [  13,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC2"        => [  14,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC1"        => [  15,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC0"        => [  16,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Xmit Message Lost, as result of Link Reset" ],
   "RETRY_TIMEOUT_ERROR"          => [  17,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [  18,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [  19,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "MD_TAIL_CNT_ERROR"            => [  20,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "MD tail count error" ],
   "PI_TAIL_CNT_ERROR"            => [  21,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI tail count error" ],
   "NI_ILLEGAL_VC"                => [  22,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI illegal vc" ],
   "PI_ILLEGAL_VC"                => [  23,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "PI illegal vc" ],
   "MD_ILLEGAL_VC"                => [  24,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD illegal vc" ],
   "IILB_ILLEGAL_VC"              => [  25,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB illegal vc" ],
   "NI_FAST_TAIL_ERROR"           => [  26,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI fast tail error" ],
   "PI_FAST_TAIL_ERROR"           => [  27,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PI fast tail error" ],
   "MD_FAST_TAIL_ERROR"           => [  28,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD fast tail error" ],
   "IILB_FAST_TAIL_ERROR"         => [  29,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "NI_FAST_TAIL_UNDERFLOW"       => [  30,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fast tail underflow" ],
   "PI_DATA_FAST_TAIL_UNDERFLOW"  => [  31,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "PI data fast tail underflow" ],
   "PI_HDR_FAST_TAIL_UNDERFLOW"   => [  32,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail underflow" ],
   "MD_DATA_FAST_TAIL_UNDERFLOW"  => [  33,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "MD data fast tail underflow" ],
   "MD_HDR_FAST_TAIL_UNDERFLOW"   => [  34,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail underflow" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [  35,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC3" => [  36,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc3" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC2" => [  37,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc2" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC1" => [  38,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc1" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC0" => [  39,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc0" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  40,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc2" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  41,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc2" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  42,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc0" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  43,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc0" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  44,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc2" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  45,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc2" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  46,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc0" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  47,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc0" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC2" => [  48,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc2" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC0" => [  49,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc0" ],
   "PI_DEBIT_UNDERFLOW_VC2"       => [  50,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI debit underflow vc2" ],
   "PI_DEBIT_UNDERFLOW_VC0"       => [  51,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI debit underflow vc0" ],
   "MD_DEBIT_UNDERFLOW_VC2"       => [  52,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "MD debit underflow vc2" ],
   "MD_DEBIT_UNDERFLOW_VC0"       => [  53,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "MD debit underflow vc0" ],
   "UNDERFLOW_NI_VC3_CREDIT"      => [  54,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit underflow vc3" ],
   "UNDERFLOW_NI_VC2_CREDIT"      => [  55,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit underflow vc2" ],
   "UNDERFLOW_NI_VC1_CREDIT"      => [  56,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit underflow vc1" ],
   "UNDERFLOW_NI_VC0_CREDIT"      => [  57,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit underflow vc0" ],
   "LLP_DEADLOCK_VC3"             => [  58,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [  59,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [  60,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [  61,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
);

%shub2_01_01106_def =
( NAME    => "SH2_NI0_ERROR_OVERFLOW_2_ALIAS",
  ADDRESS => 0x0000000050040538,
  NOTE    => "ni0 Error Overflow Bits Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01106_flds
);


##########################################################################
#                                                                        #
#   SH2_NI0_ERROR_MASK_1                                                 #
#                                                                        #
##########################################################################

%shub2_01_01107_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_TAIL_TIMEOUT_VC3"          => [   1,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "NI tail timeout vc3" ],
   "NI_TAIL_TIMEOUT_VC2"          => [   2,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "NI tail timeout vc2" ],
   "NI_TAIL_TIMEOUT_VC1"          => [   3,  59,   1, 0x0800000000000000, 0x00, 1, 0x0000000000000000, "NI tail timeout vc1" ],
   "NI_TAIL_TIMEOUT_VC0"          => [   4,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "NI tail timeout vc0" ],
   "PI_TAIL_TIMEOUT_VC3"          => [   5,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "PI tail timeout vc3" ],
   "PI_TAIL_TIMEOUT_VC2"          => [   6,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "PI tail timeout vc2" ],
   "PI_TAIL_TIMEOUT_VC1"          => [   7,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "PI tail timeout vc1" ],
   "PI_TAIL_TIMEOUT_VC0"          => [   8,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "PI tail timeout vc0" ],
   "MD_TAIL_TIMEOUT_VC3"          => [   9,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "MD tail timeout vc3" ],
   "MD_TAIL_TIMEOUT_VC2"          => [  10,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "MD tail timeout vc2" ],
   "MD_TAIL_TIMEOUT_VC1"          => [  11,  51,   1, 0x0008000000000000, 0x00, 1, 0x0000000000000000, "MD tail timeout vc1" ],
   "MD_TAIL_TIMEOUT_VC0"          => [  12,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "MD tail timeout vc0" ],
   "IILB_TAIL_TIMEOUT_VC3"        => [  13,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "IILB tail timeout vc3" ],
   "IILB_TAIL_TIMEOUT_VC2"        => [  14,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "IILB tail timeout vc2" ],
   "IILB_TAIL_TIMEOUT_VC1"        => [  15,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "IILB tail timeout vc1" ],
   "IILB_TAIL_TIMEOUT_VC0"        => [  16,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "IILB tail timeout vc0" ],
   "NI_DEBITSAVER_OVERFLOW_VC3"   => [  17,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "NI debitsaver overflow vc3" ],
   "NI_DEBITSAVER_OVERFLOW_VC2"   => [  18,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "NI debitsaver overflow vc2" ],
   "NI_DEBITSAVER_OVERFLOW_VC1"   => [  19,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "NI debitsaver overflow vc1" ],
   "NI_DEBITSAVER_OVERFLOW_VC0"   => [  20,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "NI debitsaver overflow vc0" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC3"   => [  21,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "NI queue counter overflow vc3" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC2"   => [  22,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "NI queue counter overflow vc2" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC1"   => [  23,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "NI queue counter overflow vc1" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC0"   => [  24,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "NI queue counter overflow vc0" ],
   "NI_FAST_TAIL_OVERFLOW"        => [  25,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "NI fast tail overflow" ],
   "PI_DATA_FAST_TAIL_OVERFLOW"   => [  26,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "PI data fast tail overflow" ],
   "PI_HDR_FAST_TAIL_OVERFLOW"    => [  27,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "PI hdr fast tail overflow" ],
   "MD_DATA_FAST_TAIL_OVERFLOW"   => [  28,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "MD data fast tail overflow" ],
   "MD_HDR_FAST_TAIL_OVERFLOW"    => [  29,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "MD hdr fast tail overflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  30,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "IILB fast tail overflow" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC3"  => [  31,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "NI fifo overflow vc3" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC2"  => [  32,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "NI fifo overflow vc2" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC1"  => [  33,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "NI fifo overflow vc1" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC0"  => [  34,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "NI fifo overflow vc0" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  35,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "PI data fifo overflow vc2" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  36,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "PI hdr fifo overflow vc2" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  37,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "PI data fifo overflow vc0" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  38,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "PI hdr fifo overflow vc0" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  39,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "MD data fifo overflow vc2" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  40,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "MD hdr fifo overflow vc2" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  41,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "MD data fifo overflow vc0" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  42,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "MD hdr fifo overflow vc0" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC2" => [  43,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "IILB fifo overflow vc2" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC0" => [  44,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "IILB fifo overflow vc0" ],
   "NI_DEBIT_OVERFLOW_VC3"        => [  45,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "NI debit overflow vc3" ],
   "NI_DEBIT_OVERFLOW_VC2"        => [  46,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "NI debit overflow vc2" ],
   "NI_DEBIT_OVERFLOW_VC1"        => [  47,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "NI debit overflow vc1" ],
   "NI_DEBIT_OVERFLOW_VC0"        => [  48,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "NI debit overflow vc0" ],
   "PI_DEBIT_OVERFLOW_VC2"        => [  49,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "PI debit overflow vc2" ],
   "PI_DEBIT_OVERFLOW_VC0"        => [  50,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "PI debit overflow vc0" ],
   "MD_DEBIT_OVERFLOW_VC2"        => [  51,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "MD debit overflow vc2" ],
   "MD_DEBIT_OVERFLOW_VC0"        => [  52,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "MD debit overflow vc0" ],
   "IILB_DEBIT_OVERFLOW_VC2"      => [  53,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "IILB debit overflow vc2" ],
   "IILB_DEBIT_OVERFLOW_VC0"      => [  54,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "IILB debit overflow vc0" ],
   "OVERFLOW_NI_VC3_CREDIT"       => [  55,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "NI credit overflow vc3" ],
   "OVERFLOW_NI_VC2_CREDIT"       => [  56,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "NI credit overflow vc2" ],
   "OVERFLOW_NI_VC1_CREDIT"       => [  57,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "NI credit overflow vc1" ],
   "OVERFLOW_NI_VC0_CREDIT"       => [  58,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "NI credit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT3"          => [  59,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT2"          => [  60,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT1"          => [  61,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT0"          => [  62,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "llp debit overflow vc0" ],
);

%shub2_01_01107_def =
( NAME    => "SH2_NI0_ERROR_MASK_1",
  ADDRESS => 0x0000000050040540,
  NOTE    => "ni0 Error Mask Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01107_flds
);


##########################################################################
#                                                                        #
#   SH2_NI0_ERROR_MASK_2                                                 #
#                                                                        #
##########################################################################

%shub2_01_01108_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DAM_PI_XMIT_MSG_VC3"          => [   1,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "PI VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_PI_XMIT_MSG_VC2"          => [   2,  59,   1, 0x0800000000000000, 0x00, 1, 0x0000000000000000, "PI VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_PI_XMIT_MSG_VC1"          => [   3,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "PI VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_PI_XMIT_MSG_VC0"          => [   4,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "PI VC0 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC3"          => [   5,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "MD VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC2"          => [   6,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "MD VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC1"          => [   7,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "MD VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC0"          => [   8,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "MD VC0 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC3"          => [   9,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "NI VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC2"          => [  10,  51,   1, 0x0008000000000000, 0x00, 1, 0x0000000000000000, "NI VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC1"          => [  11,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "NI VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC0"          => [  12,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "NI VC0 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC3"        => [  13,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "IILB VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC2"        => [  14,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "IILB VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC1"        => [  15,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "IILB VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC0"        => [  16,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "IILB VC0 Xmit Message Lost, as result of Link Reset" ],
   "RETRY_TIMEOUT_ERROR"          => [  17,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [  18,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [  19,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "chiplet nomatch" ],
   "MD_TAIL_CNT_ERROR"            => [  20,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "MD tail count error" ],
   "PI_TAIL_CNT_ERROR"            => [  21,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "PI tail count error" ],
   "NI_ILLEGAL_VC"                => [  22,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "NI illegal vc" ],
   "PI_ILLEGAL_VC"                => [  23,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "PI illegal vc" ],
   "MD_ILLEGAL_VC"                => [  24,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "MD illegal vc" ],
   "IILB_ILLEGAL_VC"              => [  25,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "IILB illegal vc" ],
   "NI_FAST_TAIL_ERROR"           => [  26,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "NI fast tail error" ],
   "PI_FAST_TAIL_ERROR"           => [  27,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "PI fast tail error" ],
   "MD_FAST_TAIL_ERROR"           => [  28,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "MD fast tail error" ],
   "IILB_FAST_TAIL_ERROR"         => [  29,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "IILB fast tail error" ],
   "NI_FAST_TAIL_UNDERFLOW"       => [  30,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "NI fast tail underflow" ],
   "PI_DATA_FAST_TAIL_UNDERFLOW"  => [  31,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "PI data fast tail underflow" ],
   "PI_HDR_FAST_TAIL_UNDERFLOW"   => [  32,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "PI hdr fast tail underflow" ],
   "MD_DATA_FAST_TAIL_UNDERFLOW"  => [  33,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "MD data fast tail underflow" ],
   "MD_HDR_FAST_TAIL_UNDERFLOW"   => [  34,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "MD hdr fast tail underflow" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [  35,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "IILB fast tail underflow" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC3" => [  36,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "NI fifo underflow vc3" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC2" => [  37,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "NI fifo underflow vc2" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC1" => [  38,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "NI fifo underflow vc1" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC0" => [  39,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "NI fifo underflow vc0" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  40,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "PI data fifo underflow vc2" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  41,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "PI hdr fifo underflow vc2" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  42,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "PI data fifo underflow vc0" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  43,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "PI hdr fifo underflow vc0" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  44,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "MD data fifo underflow vc2" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  45,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "MD hdr fifo underflow vc2" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  46,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "MD data fifo underflow vc0" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  47,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "MD hdr fifo underflow vc0" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC2" => [  48,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "IILB fifo underflow vc2" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC0" => [  49,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "IILB fifo underflow vc0" ],
   "PI_DEBIT_UNDERFLOW_VC2"       => [  50,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "PI debit underflow vc2" ],
   "PI_DEBIT_UNDERFLOW_VC0"       => [  51,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "PI debit underflow vc0" ],
   "MD_DEBIT_UNDERFLOW_VC2"       => [  52,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "MD debit underflow vc2" ],
   "MD_DEBIT_UNDERFLOW_VC0"       => [  53,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "MD debit underflow vc0" ],
   "UNDERFLOW_NI_VC3_CREDIT"      => [  54,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "NI credit underflow vc3" ],
   "UNDERFLOW_NI_VC2_CREDIT"      => [  55,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "NI credit underflow vc2" ],
   "UNDERFLOW_NI_VC1_CREDIT"      => [  56,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "NI credit underflow vc1" ],
   "UNDERFLOW_NI_VC0_CREDIT"      => [  57,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "NI credit underflow vc0" ],
   "LLP_DEADLOCK_VC3"             => [  58,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [  59,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [  60,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [  61,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "llp deadlock vc0" ],
);

%shub2_01_01108_def =
( NAME    => "SH2_NI0_ERROR_MASK_2",
  ADDRESS => 0x0000000050040550,
  NOTE    => "ni0 Error Mask Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01108_flds
);


##########################################################################
#                                                                        #
#   SH2_NI0_FIRST_ERROR_1                                                #
#                                                                        #
##########################################################################

%shub2_01_01109_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_TAIL_TIMEOUT_VC3"          => [   1,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc3" ],
   "NI_TAIL_TIMEOUT_VC2"          => [   2,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc2" ],
   "NI_TAIL_TIMEOUT_VC1"          => [   3,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc1" ],
   "NI_TAIL_TIMEOUT_VC0"          => [   4,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc0" ],
   "PI_TAIL_TIMEOUT_VC3"          => [   5,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc3" ],
   "PI_TAIL_TIMEOUT_VC2"          => [   6,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc2" ],
   "PI_TAIL_TIMEOUT_VC1"          => [   7,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc1" ],
   "PI_TAIL_TIMEOUT_VC0"          => [   8,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc0" ],
   "MD_TAIL_TIMEOUT_VC3"          => [   9,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc3" ],
   "MD_TAIL_TIMEOUT_VC2"          => [  10,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc2" ],
   "MD_TAIL_TIMEOUT_VC1"          => [  11,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc1" ],
   "MD_TAIL_TIMEOUT_VC0"          => [  12,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc0" ],
   "IILB_TAIL_TIMEOUT_VC3"        => [  13,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc3" ],
   "IILB_TAIL_TIMEOUT_VC2"        => [  14,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc2" ],
   "IILB_TAIL_TIMEOUT_VC1"        => [  15,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc1" ],
   "IILB_TAIL_TIMEOUT_VC0"        => [  16,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc0" ],
   "NI_DEBITSAVER_OVERFLOW_VC3"   => [  17,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc3" ],
   "NI_DEBITSAVER_OVERFLOW_VC2"   => [  18,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc2" ],
   "NI_DEBITSAVER_OVERFLOW_VC1"   => [  19,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc1" ],
   "NI_DEBITSAVER_OVERFLOW_VC0"   => [  20,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc0" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC3"   => [  21,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc3" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC2"   => [  22,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc2" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC1"   => [  23,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc1" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC0"   => [  24,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc0" ],
   "NI_FAST_TAIL_OVERFLOW"        => [  25,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI fast tail overflow" ],
   "PI_DATA_FAST_TAIL_OVERFLOW"   => [  26,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail overflow" ],
   "PI_HDR_FAST_TAIL_OVERFLOW"    => [  27,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail overflow" ],
   "MD_DATA_FAST_TAIL_OVERFLOW"   => [  28,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "MD data fast tail overflow" ],
   "MD_HDR_FAST_TAIL_OVERFLOW"    => [  29,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail overflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  30,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC3"  => [  31,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc3" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC2"  => [  32,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc2" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC1"  => [  33,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc1" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC0"  => [  34,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc0" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  35,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc2" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  36,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc2" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  37,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc0" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  38,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc0" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  39,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc2" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  40,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc2" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  41,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc0" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  42,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc0" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC2" => [  43,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc2" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC0" => [  44,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc0" ],
   "NI_DEBIT_OVERFLOW_VC3"        => [  45,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc3" ],
   "NI_DEBIT_OVERFLOW_VC2"        => [  46,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc2" ],
   "NI_DEBIT_OVERFLOW_VC1"        => [  47,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc1" ],
   "NI_DEBIT_OVERFLOW_VC0"        => [  48,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc0" ],
   "PI_DEBIT_OVERFLOW_VC2"        => [  49,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc2" ],
   "PI_DEBIT_OVERFLOW_VC0"        => [  50,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc0" ],
   "MD_DEBIT_OVERFLOW_VC2"        => [  51,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "MD debit overflow vc2" ],
   "MD_DEBIT_OVERFLOW_VC0"        => [  52,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "MD debit overflow vc0" ],
   "IILB_DEBIT_OVERFLOW_VC2"      => [  53,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc2" ],
   "IILB_DEBIT_OVERFLOW_VC0"      => [  54,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc0" ],
   "OVERFLOW_NI_VC3_CREDIT"       => [  55,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit overflow vc3" ],
   "OVERFLOW_NI_VC2_CREDIT"       => [  56,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit overflow vc2" ],
   "OVERFLOW_NI_VC1_CREDIT"       => [  57,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit overflow vc1" ],
   "OVERFLOW_NI_VC0_CREDIT"       => [  58,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT3"          => [  59,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT2"          => [  60,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT1"          => [  61,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT0"          => [  62,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
);

%shub2_01_01109_def =
( NAME    => "SH2_NI0_FIRST_ERROR_1",
  ADDRESS => 0x0000000050040560,
  NOTE    => "ni0 First Error Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01109_flds
);


##########################################################################
#                                                                        #
#   SH2_NI0_FIRST_ERROR_2                                                #
#                                                                        #
##########################################################################

%shub2_01_01110_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DAM_PI_XMIT_MSG_VC3"          => [   1,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "PI VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_PI_XMIT_MSG_VC2"          => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "PI VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_PI_XMIT_MSG_VC1"          => [   3,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "PI VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_PI_XMIT_MSG_VC0"          => [   4,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC3"          => [   5,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "MD VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC2"          => [   6,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "MD VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC1"          => [   7,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "MD VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC0"          => [   8,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC3"          => [   9,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC2"          => [  10,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC1"          => [  11,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC0"          => [  12,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI VC0 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC3"        => [  13,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC2"        => [  14,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC1"        => [  15,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC0"        => [  16,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Xmit Message Lost, as result of Link Reset" ],
   "RETRY_TIMEOUT_ERROR"          => [  17,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [  18,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [  19,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "MD_TAIL_CNT_ERROR"            => [  20,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "MD tail count error" ],
   "PI_TAIL_CNT_ERROR"            => [  21,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI tail count error" ],
   "NI_ILLEGAL_VC"                => [  22,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI illegal vc" ],
   "PI_ILLEGAL_VC"                => [  23,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "PI illegal vc" ],
   "MD_ILLEGAL_VC"                => [  24,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD illegal vc" ],
   "IILB_ILLEGAL_VC"              => [  25,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB illegal vc" ],
   "NI_FAST_TAIL_ERROR"           => [  26,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI fast tail error" ],
   "PI_FAST_TAIL_ERROR"           => [  27,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PI fast tail error" ],
   "MD_FAST_TAIL_ERROR"           => [  28,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD fast tail error" ],
   "IILB_FAST_TAIL_ERROR"         => [  29,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "NI_FAST_TAIL_UNDERFLOW"       => [  30,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fast tail underflow" ],
   "PI_DATA_FAST_TAIL_UNDERFLOW"  => [  31,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "PI data fast tail underflow" ],
   "PI_HDR_FAST_TAIL_UNDERFLOW"   => [  32,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail underflow" ],
   "MD_DATA_FAST_TAIL_UNDERFLOW"  => [  33,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "MD data fast tail underflow" ],
   "MD_HDR_FAST_TAIL_UNDERFLOW"   => [  34,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail underflow" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [  35,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC3" => [  36,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc3" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC2" => [  37,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc2" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC1" => [  38,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc1" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC0" => [  39,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc0" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  40,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc2" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  41,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc2" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  42,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc0" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  43,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc0" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  44,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc2" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  45,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc2" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  46,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc0" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  47,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc0" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC2" => [  48,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc2" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC0" => [  49,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc0" ],
   "PI_DEBIT_UNDERFLOW_VC2"       => [  50,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI debit underflow vc2" ],
   "PI_DEBIT_UNDERFLOW_VC0"       => [  51,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI debit underflow vc0" ],
   "MD_DEBIT_UNDERFLOW_VC2"       => [  52,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "MD debit underflow vc2" ],
   "MD_DEBIT_UNDERFLOW_VC0"       => [  53,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "MD debit underflow vc0" ],
   "UNDERFLOW_NI_VC3_CREDIT"      => [  54,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit underflow vc3" ],
   "UNDERFLOW_NI_VC2_CREDIT"      => [  55,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit underflow vc2" ],
   "UNDERFLOW_NI_VC1_CREDIT"      => [  56,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit underflow vc1" ],
   "UNDERFLOW_NI_VC0_CREDIT"      => [  57,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit underflow vc0" ],
   "LLP_DEADLOCK_VC3"             => [  58,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [  59,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [  60,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [  61,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
);

%shub2_01_01110_def =
( NAME    => "SH2_NI0_FIRST_ERROR_2",
  ADDRESS => 0x0000000050040570,
  NOTE    => "ni0 First Error Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01110_flds
);


##########################################################################
#                                                                        #
#   SH2_NI0_ERROR_DETAIL_1                                               #
#                                                                        #
##########################################################################

%shub2_01_01111_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Header bits 63:0" ],
);

%shub2_01_01111_def =
( NAME    => "SH2_NI0_ERROR_DETAIL_1",
  ADDRESS => 0x0000000050040580,
  NOTE    => "ni0 Chiplet no match header bits 63:0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01111_flds
);


##########################################################################
#                                                                        #
#   SH2_NI0_ERROR_DETAIL_2                                               #
#                                                                        #
##########################################################################

%shub2_01_01112_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Header bits 127:64" ],
);

%shub2_01_01112_def =
( NAME    => "SH2_NI0_ERROR_DETAIL_2",
  ADDRESS => 0x0000000050040590,
  NOTE    => "ni0 Chiplet no match header bits 127:64",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01112_flds
);


##########################################################################
#                                                                        #
#   SH2_NI1_ERROR_SUMMARY_1                                              #
#                                                                        #
##########################################################################

%shub2_01_01113_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_TAIL_TIMEOUT_VC3"          => [   1,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc3" ],
   "NI_TAIL_TIMEOUT_VC2"          => [   2,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc2" ],
   "NI_TAIL_TIMEOUT_VC1"          => [   3,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc1" ],
   "NI_TAIL_TIMEOUT_VC0"          => [   4,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc0" ],
   "PI_TAIL_TIMEOUT_VC3"          => [   5,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc3" ],
   "PI_TAIL_TIMEOUT_VC2"          => [   6,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc2" ],
   "PI_TAIL_TIMEOUT_VC1"          => [   7,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc1" ],
   "PI_TAIL_TIMEOUT_VC0"          => [   8,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc0" ],
   "MD_TAIL_TIMEOUT_VC3"          => [   9,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc3" ],
   "MD_TAIL_TIMEOUT_VC2"          => [  10,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc2" ],
   "MD_TAIL_TIMEOUT_VC1"          => [  11,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc1" ],
   "MD_TAIL_TIMEOUT_VC0"          => [  12,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc0" ],
   "IILB_TAIL_TIMEOUT_VC3"        => [  13,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc3" ],
   "IILB_TAIL_TIMEOUT_VC2"        => [  14,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc2" ],
   "IILB_TAIL_TIMEOUT_VC1"        => [  15,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc1" ],
   "IILB_TAIL_TIMEOUT_VC0"        => [  16,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc0" ],
   "NI_DEBITSAVER_OVERFLOW_VC3"   => [  17,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc3" ],
   "NI_DEBITSAVER_OVERFLOW_VC2"   => [  18,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc2" ],
   "NI_DEBITSAVER_OVERFLOW_VC1"   => [  19,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc1" ],
   "NI_DEBITSAVER_OVERFLOW_VC0"   => [  20,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc0" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC3"   => [  21,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc3" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC2"   => [  22,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc2" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC1"   => [  23,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc1" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC0"   => [  24,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc0" ],
   "NI_FAST_TAIL_OVERFLOW"        => [  25,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI fast tail overflow" ],
   "PI_DATA_FAST_TAIL_OVERFLOW"   => [  26,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail overflow" ],
   "PI_HDR_FAST_TAIL_OVERFLOW"    => [  27,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail overflow" ],
   "MD_DATA_FAST_TAIL_OVERFLOW"   => [  28,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "MD data fast tail overflow" ],
   "MD_HDR_FAST_TAIL_OVERFLOW"    => [  29,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail overflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  30,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC3"  => [  31,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc3" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC2"  => [  32,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc2" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC1"  => [  33,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc1" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC0"  => [  34,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc0" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  35,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc2" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  36,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc2" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  37,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc0" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  38,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc0" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  39,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc2" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  40,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc2" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  41,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc0" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  42,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc0" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC2" => [  43,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc2" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC0" => [  44,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc0" ],
   "NI_DEBIT_OVERFLOW_VC3"        => [  45,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc3" ],
   "NI_DEBIT_OVERFLOW_VC2"        => [  46,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc2" ],
   "NI_DEBIT_OVERFLOW_VC1"        => [  47,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc1" ],
   "NI_DEBIT_OVERFLOW_VC0"        => [  48,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc0" ],
   "PI_DEBIT_OVERFLOW_VC2"        => [  49,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc2" ],
   "PI_DEBIT_OVERFLOW_VC0"        => [  50,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc0" ],
   "MD_DEBIT_OVERFLOW_VC2"        => [  51,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "MD debit overflow vc2" ],
   "MD_DEBIT_OVERFLOW_VC0"        => [  52,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "MD debit overflow vc0" ],
   "IILB_DEBIT_OVERFLOW_VC2"      => [  53,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc2" ],
   "IILB_DEBIT_OVERFLOW_VC0"      => [  54,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc0" ],
   "OVERFLOW_NI_VC3_CREDIT"       => [  55,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit overflow vc3" ],
   "OVERFLOW_NI_VC2_CREDIT"       => [  56,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit overflow vc2" ],
   "OVERFLOW_NI_VC1_CREDIT"       => [  57,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit overflow vc1" ],
   "OVERFLOW_NI_VC0_CREDIT"       => [  58,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT3"          => [  59,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT2"          => [  60,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT1"          => [  61,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT0"          => [  62,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
);

%shub2_01_01113_def =
( NAME    => "SH2_NI1_ERROR_SUMMARY_1",
  ADDRESS => 0x0000000050040600,
  NOTE    => "ni1 Error Summary Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01113_flds
);


##########################################################################
#                                                                        #
#   SH2_NI1_ERROR_SUMMARY_1_ALIAS                                        #
#                                                                        #
##########################################################################

%shub2_01_01114_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_TAIL_TIMEOUT_VC3"          => [   1,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc3" ],
   "NI_TAIL_TIMEOUT_VC2"          => [   2,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc2" ],
   "NI_TAIL_TIMEOUT_VC1"          => [   3,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc1" ],
   "NI_TAIL_TIMEOUT_VC0"          => [   4,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc0" ],
   "PI_TAIL_TIMEOUT_VC3"          => [   5,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc3" ],
   "PI_TAIL_TIMEOUT_VC2"          => [   6,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc2" ],
   "PI_TAIL_TIMEOUT_VC1"          => [   7,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc1" ],
   "PI_TAIL_TIMEOUT_VC0"          => [   8,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc0" ],
   "MD_TAIL_TIMEOUT_VC3"          => [   9,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc3" ],
   "MD_TAIL_TIMEOUT_VC2"          => [  10,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc2" ],
   "MD_TAIL_TIMEOUT_VC1"          => [  11,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc1" ],
   "MD_TAIL_TIMEOUT_VC0"          => [  12,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc0" ],
   "IILB_TAIL_TIMEOUT_VC3"        => [  13,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc3" ],
   "IILB_TAIL_TIMEOUT_VC2"        => [  14,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc2" ],
   "IILB_TAIL_TIMEOUT_VC1"        => [  15,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc1" ],
   "IILB_TAIL_TIMEOUT_VC0"        => [  16,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc0" ],
   "NI_DEBITSAVER_OVERFLOW_VC3"   => [  17,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc3" ],
   "NI_DEBITSAVER_OVERFLOW_VC2"   => [  18,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc2" ],
   "NI_DEBITSAVER_OVERFLOW_VC1"   => [  19,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc1" ],
   "NI_DEBITSAVER_OVERFLOW_VC0"   => [  20,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc0" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC3"   => [  21,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc3" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC2"   => [  22,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc2" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC1"   => [  23,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc1" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC0"   => [  24,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc0" ],
   "NI_FAST_TAIL_OVERFLOW"        => [  25,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI fast tail overflow" ],
   "PI_DATA_FAST_TAIL_OVERFLOW"   => [  26,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail overflow" ],
   "PI_HDR_FAST_TAIL_OVERFLOW"    => [  27,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail overflow" ],
   "MD_DATA_FAST_TAIL_OVERFLOW"   => [  28,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "MD data fast tail overflow" ],
   "MD_HDR_FAST_TAIL_OVERFLOW"    => [  29,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail overflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  30,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC3"  => [  31,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc3" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC2"  => [  32,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc2" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC1"  => [  33,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc1" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC0"  => [  34,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc0" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  35,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc2" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  36,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc2" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  37,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc0" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  38,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc0" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  39,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc2" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  40,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc2" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  41,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc0" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  42,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc0" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC2" => [  43,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc2" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC0" => [  44,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc0" ],
   "NI_DEBIT_OVERFLOW_VC3"        => [  45,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc3" ],
   "NI_DEBIT_OVERFLOW_VC2"        => [  46,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc2" ],
   "NI_DEBIT_OVERFLOW_VC1"        => [  47,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc1" ],
   "NI_DEBIT_OVERFLOW_VC0"        => [  48,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc0" ],
   "PI_DEBIT_OVERFLOW_VC2"        => [  49,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc2" ],
   "PI_DEBIT_OVERFLOW_VC0"        => [  50,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc0" ],
   "MD_DEBIT_OVERFLOW_VC2"        => [  51,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "MD debit overflow vc2" ],
   "MD_DEBIT_OVERFLOW_VC0"        => [  52,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "MD debit overflow vc0" ],
   "IILB_DEBIT_OVERFLOW_VC2"      => [  53,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc2" ],
   "IILB_DEBIT_OVERFLOW_VC0"      => [  54,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc0" ],
   "OVERFLOW_NI_VC3_CREDIT"       => [  55,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit overflow vc3" ],
   "OVERFLOW_NI_VC2_CREDIT"       => [  56,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit overflow vc2" ],
   "OVERFLOW_NI_VC1_CREDIT"       => [  57,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit overflow vc1" ],
   "OVERFLOW_NI_VC0_CREDIT"       => [  58,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT3"          => [  59,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT2"          => [  60,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT1"          => [  61,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT0"          => [  62,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
);

%shub2_01_01114_def =
( NAME    => "SH2_NI1_ERROR_SUMMARY_1_ALIAS",
  ADDRESS => 0x0000000050040608,
  NOTE    => "ni1 Error Summary Bits Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01114_flds
);


##########################################################################
#                                                                        #
#   SH2_NI1_ERROR_SUMMARY_2                                              #
#                                                                        #
##########################################################################

%shub2_01_01115_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DAM_PI_XMIT_MSG_VC3"          => [   1,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "PI VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_PI_XMIT_MSG_VC2"          => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "PI VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_PI_XMIT_MSG_VC1"          => [   3,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "PI VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_PI_XMIT_MSG_VC0"          => [   4,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC3"          => [   5,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "MD VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC2"          => [   6,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "MD VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC1"          => [   7,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "MD VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC0"          => [   8,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC3"          => [   9,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC2"          => [  10,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC1"          => [  11,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC0"          => [  12,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI VC0 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC3"        => [  13,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC2"        => [  14,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC1"        => [  15,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC0"        => [  16,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Xmit Message Lost, as result of Link Reset" ],
   "RETRY_TIMEOUT_ERROR"          => [  17,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [  18,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [  19,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "MD_TAIL_CNT_ERROR"            => [  20,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "MD tail count error" ],
   "PI_TAIL_CNT_ERROR"            => [  21,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI tail count error" ],
   "NI_ILLEGAL_VC"                => [  22,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI illegal vc" ],
   "PI_ILLEGAL_VC"                => [  23,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "PI illegal vc" ],
   "MD_ILLEGAL_VC"                => [  24,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD illegal vc" ],
   "IILB_ILLEGAL_VC"              => [  25,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB illegal vc" ],
   "NI_FAST_TAIL_ERROR"           => [  26,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI fast tail error" ],
   "PI_FAST_TAIL_ERROR"           => [  27,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PI fast tail error" ],
   "MD_FAST_TAIL_ERROR"           => [  28,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD fast tail error" ],
   "IILB_FAST_TAIL_ERROR"         => [  29,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "NI_FAST_TAIL_UNDERFLOW"       => [  30,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fast tail underflow" ],
   "PI_DATA_FAST_TAIL_UNDERFLOW"  => [  31,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "PI data fast tail underflow" ],
   "PI_HDR_FAST_TAIL_UNDERFLOW"   => [  32,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail underflow" ],
   "MD_DATA_FAST_TAIL_UNDERFLOW"  => [  33,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "MD data fast tail underflow" ],
   "MD_HDR_FAST_TAIL_UNDERFLOW"   => [  34,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail underflow" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [  35,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC3" => [  36,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc3" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC2" => [  37,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc2" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC1" => [  38,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc1" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC0" => [  39,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc0" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  40,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc2" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  41,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc2" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  42,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc0" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  43,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc0" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  44,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc2" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  45,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc2" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  46,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc0" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  47,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc0" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC2" => [  48,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc2" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC0" => [  49,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc0" ],
   "PI_DEBIT_UNDERFLOW_VC2"       => [  50,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI debit underflow vc2" ],
   "PI_DEBIT_UNDERFLOW_VC0"       => [  51,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI debit underflow vc0" ],
   "MD_DEBIT_UNDERFLOW_VC2"       => [  52,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "MD debit underflow vc2" ],
   "MD_DEBIT_UNDERFLOW_VC0"       => [  53,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "MD debit underflow vc0" ],
   "UNDERFLOW_NI_VC3_CREDIT"      => [  54,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit underflow vc3" ],
   "UNDERFLOW_NI_VC2_CREDIT"      => [  55,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit underflow vc2" ],
   "UNDERFLOW_NI_VC1_CREDIT"      => [  56,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit underflow vc1" ],
   "UNDERFLOW_NI_VC0_CREDIT"      => [  57,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit underflow vc0" ],
   "LLP_DEADLOCK_VC3"             => [  58,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [  59,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [  60,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [  61,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
);

%shub2_01_01115_def =
( NAME    => "SH2_NI1_ERROR_SUMMARY_2",
  ADDRESS => 0x0000000050040610,
  NOTE    => "ni1 Error Summary Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01115_flds
);


##########################################################################
#                                                                        #
#   SH2_NI1_ERROR_SUMMARY_2_ALIAS                                        #
#                                                                        #
##########################################################################

%shub2_01_01116_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DAM_PI_XMIT_MSG_VC3"          => [   1,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "PI VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_PI_XMIT_MSG_VC2"          => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "PI VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_PI_XMIT_MSG_VC1"          => [   3,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "PI VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_PI_XMIT_MSG_VC0"          => [   4,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC3"          => [   5,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "MD VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC2"          => [   6,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "MD VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC1"          => [   7,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "MD VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC0"          => [   8,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC3"          => [   9,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC2"          => [  10,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC1"          => [  11,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC0"          => [  12,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI VC0 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC3"        => [  13,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC2"        => [  14,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC1"        => [  15,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC0"        => [  16,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Xmit Message Lost, as result of Link Reset" ],
   "RETRY_TIMEOUT_ERROR"          => [  17,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [  18,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [  19,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "MD_TAIL_CNT_ERROR"            => [  20,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "MD tail count error" ],
   "PI_TAIL_CNT_ERROR"            => [  21,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI tail count error" ],
   "NI_ILLEGAL_VC"                => [  22,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI illegal vc" ],
   "PI_ILLEGAL_VC"                => [  23,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "PI illegal vc" ],
   "MD_ILLEGAL_VC"                => [  24,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD illegal vc" ],
   "IILB_ILLEGAL_VC"              => [  25,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB illegal vc" ],
   "NI_FAST_TAIL_ERROR"           => [  26,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI fast tail error" ],
   "PI_FAST_TAIL_ERROR"           => [  27,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PI fast tail error" ],
   "MD_FAST_TAIL_ERROR"           => [  28,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD fast tail error" ],
   "IILB_FAST_TAIL_ERROR"         => [  29,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "NI_FAST_TAIL_UNDERFLOW"       => [  30,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fast tail underflow" ],
   "PI_DATA_FAST_TAIL_UNDERFLOW"  => [  31,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "PI data fast tail underflow" ],
   "PI_HDR_FAST_TAIL_UNDERFLOW"   => [  32,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail underflow" ],
   "MD_DATA_FAST_TAIL_UNDERFLOW"  => [  33,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "MD data fast tail underflow" ],
   "MD_HDR_FAST_TAIL_UNDERFLOW"   => [  34,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail underflow" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [  35,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC3" => [  36,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc3" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC2" => [  37,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc2" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC1" => [  38,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc1" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC0" => [  39,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc0" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  40,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc2" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  41,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc2" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  42,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc0" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  43,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc0" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  44,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc2" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  45,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc2" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  46,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc0" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  47,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc0" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC2" => [  48,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc2" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC0" => [  49,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc0" ],
   "PI_DEBIT_UNDERFLOW_VC2"       => [  50,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI debit underflow vc2" ],
   "PI_DEBIT_UNDERFLOW_VC0"       => [  51,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI debit underflow vc0" ],
   "MD_DEBIT_UNDERFLOW_VC2"       => [  52,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "MD debit underflow vc2" ],
   "MD_DEBIT_UNDERFLOW_VC0"       => [  53,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "MD debit underflow vc0" ],
   "UNDERFLOW_NI_VC3_CREDIT"      => [  54,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit underflow vc3" ],
   "UNDERFLOW_NI_VC2_CREDIT"      => [  55,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit underflow vc2" ],
   "UNDERFLOW_NI_VC1_CREDIT"      => [  56,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit underflow vc1" ],
   "UNDERFLOW_NI_VC0_CREDIT"      => [  57,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit underflow vc0" ],
   "LLP_DEADLOCK_VC3"             => [  58,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [  59,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [  60,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [  61,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
);

%shub2_01_01116_def =
( NAME    => "SH2_NI1_ERROR_SUMMARY_2_ALIAS",
  ADDRESS => 0x0000000050040618,
  NOTE    => "ni1 Error Summary Bits Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01116_flds
);


##########################################################################
#                                                                        #
#   SH2_NI1_ERROR_OVERFLOW_1                                             #
#                                                                        #
##########################################################################

%shub2_01_01117_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_TAIL_TIMEOUT_VC3"          => [   1,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc3" ],
   "NI_TAIL_TIMEOUT_VC2"          => [   2,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc2" ],
   "NI_TAIL_TIMEOUT_VC1"          => [   3,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc1" ],
   "NI_TAIL_TIMEOUT_VC0"          => [   4,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc0" ],
   "PI_TAIL_TIMEOUT_VC3"          => [   5,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc3" ],
   "PI_TAIL_TIMEOUT_VC2"          => [   6,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc2" ],
   "PI_TAIL_TIMEOUT_VC1"          => [   7,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc1" ],
   "PI_TAIL_TIMEOUT_VC0"          => [   8,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc0" ],
   "MD_TAIL_TIMEOUT_VC3"          => [   9,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc3" ],
   "MD_TAIL_TIMEOUT_VC2"          => [  10,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc2" ],
   "MD_TAIL_TIMEOUT_VC1"          => [  11,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc1" ],
   "MD_TAIL_TIMEOUT_VC0"          => [  12,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc0" ],
   "IILB_TAIL_TIMEOUT_VC3"        => [  13,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc3" ],
   "IILB_TAIL_TIMEOUT_VC2"        => [  14,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc2" ],
   "IILB_TAIL_TIMEOUT_VC1"        => [  15,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc1" ],
   "IILB_TAIL_TIMEOUT_VC0"        => [  16,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc0" ],
   "NI_DEBITSAVER_OVERFLOW_VC3"   => [  17,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc3" ],
   "NI_DEBITSAVER_OVERFLOW_VC2"   => [  18,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc2" ],
   "NI_DEBITSAVER_OVERFLOW_VC1"   => [  19,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc1" ],
   "NI_DEBITSAVER_OVERFLOW_VC0"   => [  20,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc0" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC3"   => [  21,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc3" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC2"   => [  22,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc2" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC1"   => [  23,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc1" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC0"   => [  24,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc0" ],
   "NI_FAST_TAIL_OVERFLOW"        => [  25,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI fast tail overflow" ],
   "PI_DATA_FAST_TAIL_OVERFLOW"   => [  26,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail overflow" ],
   "PI_HDR_FAST_TAIL_OVERFLOW"    => [  27,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail overflow" ],
   "MD_DATA_FAST_TAIL_OVERFLOW"   => [  28,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "MD data fast tail overflow" ],
   "MD_HDR_FAST_TAIL_OVERFLOW"    => [  29,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail overflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  30,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC3"  => [  31,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc3" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC2"  => [  32,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc2" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC1"  => [  33,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc1" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC0"  => [  34,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc0" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  35,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc2" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  36,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc2" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  37,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc0" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  38,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc0" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  39,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc2" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  40,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc2" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  41,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc0" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  42,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc0" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC2" => [  43,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc2" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC0" => [  44,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc0" ],
   "NI_DEBIT_OVERFLOW_VC3"        => [  45,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc3" ],
   "NI_DEBIT_OVERFLOW_VC2"        => [  46,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc2" ],
   "NI_DEBIT_OVERFLOW_VC1"        => [  47,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc1" ],
   "NI_DEBIT_OVERFLOW_VC0"        => [  48,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc0" ],
   "PI_DEBIT_OVERFLOW_VC2"        => [  49,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc2" ],
   "PI_DEBIT_OVERFLOW_VC0"        => [  50,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc0" ],
   "MD_DEBIT_OVERFLOW_VC2"        => [  51,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "MD debit overflow vc2" ],
   "MD_DEBIT_OVERFLOW_VC0"        => [  52,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "MD debit overflow vc0" ],
   "IILB_DEBIT_OVERFLOW_VC2"      => [  53,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc2" ],
   "IILB_DEBIT_OVERFLOW_VC0"      => [  54,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc0" ],
   "OVERFLOW_NI_VC3_CREDIT"       => [  55,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit overflow vc3" ],
   "OVERFLOW_NI_VC2_CREDIT"       => [  56,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit overflow vc2" ],
   "OVERFLOW_NI_VC1_CREDIT"       => [  57,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit overflow vc1" ],
   "OVERFLOW_NI_VC0_CREDIT"       => [  58,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT3"          => [  59,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT2"          => [  60,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT1"          => [  61,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT0"          => [  62,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
);

%shub2_01_01117_def =
( NAME    => "SH2_NI1_ERROR_OVERFLOW_1",
  ADDRESS => 0x0000000050040620,
  NOTE    => "ni1 Error Overflow Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01117_flds
);


##########################################################################
#                                                                        #
#   SH2_NI1_ERROR_OVERFLOW_1_ALIAS                                       #
#                                                                        #
##########################################################################

%shub2_01_01118_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_TAIL_TIMEOUT_VC3"          => [   1,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc3" ],
   "NI_TAIL_TIMEOUT_VC2"          => [   2,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc2" ],
   "NI_TAIL_TIMEOUT_VC1"          => [   3,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc1" ],
   "NI_TAIL_TIMEOUT_VC0"          => [   4,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc0" ],
   "PI_TAIL_TIMEOUT_VC3"          => [   5,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc3" ],
   "PI_TAIL_TIMEOUT_VC2"          => [   6,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc2" ],
   "PI_TAIL_TIMEOUT_VC1"          => [   7,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc1" ],
   "PI_TAIL_TIMEOUT_VC0"          => [   8,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc0" ],
   "MD_TAIL_TIMEOUT_VC3"          => [   9,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc3" ],
   "MD_TAIL_TIMEOUT_VC2"          => [  10,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc2" ],
   "MD_TAIL_TIMEOUT_VC1"          => [  11,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc1" ],
   "MD_TAIL_TIMEOUT_VC0"          => [  12,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc0" ],
   "IILB_TAIL_TIMEOUT_VC3"        => [  13,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc3" ],
   "IILB_TAIL_TIMEOUT_VC2"        => [  14,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc2" ],
   "IILB_TAIL_TIMEOUT_VC1"        => [  15,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc1" ],
   "IILB_TAIL_TIMEOUT_VC0"        => [  16,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc0" ],
   "NI_DEBITSAVER_OVERFLOW_VC3"   => [  17,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc3" ],
   "NI_DEBITSAVER_OVERFLOW_VC2"   => [  18,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc2" ],
   "NI_DEBITSAVER_OVERFLOW_VC1"   => [  19,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc1" ],
   "NI_DEBITSAVER_OVERFLOW_VC0"   => [  20,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc0" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC3"   => [  21,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc3" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC2"   => [  22,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc2" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC1"   => [  23,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc1" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC0"   => [  24,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc0" ],
   "NI_FAST_TAIL_OVERFLOW"        => [  25,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI fast tail overflow" ],
   "PI_DATA_FAST_TAIL_OVERFLOW"   => [  26,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail overflow" ],
   "PI_HDR_FAST_TAIL_OVERFLOW"    => [  27,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail overflow" ],
   "MD_DATA_FAST_TAIL_OVERFLOW"   => [  28,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "MD data fast tail overflow" ],
   "MD_HDR_FAST_TAIL_OVERFLOW"    => [  29,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail overflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  30,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC3"  => [  31,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc3" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC2"  => [  32,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc2" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC1"  => [  33,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc1" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC0"  => [  34,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc0" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  35,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc2" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  36,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc2" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  37,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc0" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  38,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc0" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  39,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc2" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  40,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc2" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  41,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc0" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  42,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc0" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC2" => [  43,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc2" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC0" => [  44,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc0" ],
   "NI_DEBIT_OVERFLOW_VC3"        => [  45,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc3" ],
   "NI_DEBIT_OVERFLOW_VC2"        => [  46,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc2" ],
   "NI_DEBIT_OVERFLOW_VC1"        => [  47,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc1" ],
   "NI_DEBIT_OVERFLOW_VC0"        => [  48,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc0" ],
   "PI_DEBIT_OVERFLOW_VC2"        => [  49,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc2" ],
   "PI_DEBIT_OVERFLOW_VC0"        => [  50,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc0" ],
   "MD_DEBIT_OVERFLOW_VC2"        => [  51,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "MD debit overflow vc2" ],
   "MD_DEBIT_OVERFLOW_VC0"        => [  52,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "MD debit overflow vc0" ],
   "IILB_DEBIT_OVERFLOW_VC2"      => [  53,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc2" ],
   "IILB_DEBIT_OVERFLOW_VC0"      => [  54,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc0" ],
   "OVERFLOW_NI_VC3_CREDIT"       => [  55,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit overflow vc3" ],
   "OVERFLOW_NI_VC2_CREDIT"       => [  56,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit overflow vc2" ],
   "OVERFLOW_NI_VC1_CREDIT"       => [  57,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit overflow vc1" ],
   "OVERFLOW_NI_VC0_CREDIT"       => [  58,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT3"          => [  59,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT2"          => [  60,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT1"          => [  61,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT0"          => [  62,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
);

%shub2_01_01118_def =
( NAME    => "SH2_NI1_ERROR_OVERFLOW_1_ALIAS",
  ADDRESS => 0x0000000050040628,
  NOTE    => "ni1 Error Overflow Bits Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01118_flds
);


##########################################################################
#                                                                        #
#   SH2_NI1_ERROR_OVERFLOW_2                                             #
#                                                                        #
##########################################################################

%shub2_01_01119_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DAM_PI_XMIT_MSG_VC3"          => [   1,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "PI VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_PI_XMIT_MSG_VC2"          => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "PI VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_PI_XMIT_MSG_VC1"          => [   3,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "PI VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_PI_XMIT_MSG_VC0"          => [   4,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC3"          => [   5,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "MD VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC2"          => [   6,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "MD VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC1"          => [   7,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "MD VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC0"          => [   8,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC3"          => [   9,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC2"          => [  10,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC1"          => [  11,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC0"          => [  12,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI VC0 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC3"        => [  13,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC2"        => [  14,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC1"        => [  15,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC0"        => [  16,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Xmit Message Lost, as result of Link Reset" ],
   "RETRY_TIMEOUT_ERROR"          => [  17,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [  18,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [  19,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "MD_TAIL_CNT_ERROR"            => [  20,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "MD tail count error" ],
   "PI_TAIL_CNT_ERROR"            => [  21,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI tail count error" ],
   "NI_ILLEGAL_VC"                => [  22,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI illegal vc" ],
   "PI_ILLEGAL_VC"                => [  23,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "PI illegal vc" ],
   "MD_ILLEGAL_VC"                => [  24,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD illegal vc" ],
   "IILB_ILLEGAL_VC"              => [  25,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB illegal vc" ],
   "NI_FAST_TAIL_ERROR"           => [  26,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI fast tail error" ],
   "PI_FAST_TAIL_ERROR"           => [  27,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PI fast tail error" ],
   "MD_FAST_TAIL_ERROR"           => [  28,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD fast tail error" ],
   "IILB_FAST_TAIL_ERROR"         => [  29,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "NI_FAST_TAIL_UNDERFLOW"       => [  30,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fast tail underflow" ],
   "PI_DATA_FAST_TAIL_UNDERFLOW"  => [  31,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "PI data fast tail underflow" ],
   "PI_HDR_FAST_TAIL_UNDERFLOW"   => [  32,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail underflow" ],
   "MD_DATA_FAST_TAIL_UNDERFLOW"  => [  33,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "MD data fast tail underflow" ],
   "MD_HDR_FAST_TAIL_UNDERFLOW"   => [  34,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail underflow" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [  35,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC3" => [  36,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc3" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC2" => [  37,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc2" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC1" => [  38,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc1" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC0" => [  39,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc0" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  40,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc2" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  41,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc2" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  42,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc0" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  43,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc0" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  44,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc2" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  45,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc2" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  46,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc0" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  47,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc0" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC2" => [  48,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc2" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC0" => [  49,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc0" ],
   "PI_DEBIT_UNDERFLOW_VC2"       => [  50,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI debit underflow vc2" ],
   "PI_DEBIT_UNDERFLOW_VC0"       => [  51,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI debit underflow vc0" ],
   "MD_DEBIT_UNDERFLOW_VC2"       => [  52,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "MD debit underflow vc2" ],
   "MD_DEBIT_UNDERFLOW_VC0"       => [  53,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "MD debit underflow vc0" ],
   "UNDERFLOW_NI_VC3_CREDIT"      => [  54,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit underflow vc3" ],
   "UNDERFLOW_NI_VC2_CREDIT"      => [  55,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit underflow vc2" ],
   "UNDERFLOW_NI_VC1_CREDIT"      => [  56,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit underflow vc1" ],
   "UNDERFLOW_NI_VC0_CREDIT"      => [  57,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit underflow vc0" ],
   "LLP_DEADLOCK_VC3"             => [  58,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [  59,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [  60,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [  61,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
);

%shub2_01_01119_def =
( NAME    => "SH2_NI1_ERROR_OVERFLOW_2",
  ADDRESS => 0x0000000050040630,
  NOTE    => "ni1 Error Overflow Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01119_flds
);


##########################################################################
#                                                                        #
#   SH2_NI1_ERROR_OVERFLOW_2_ALIAS                                       #
#                                                                        #
##########################################################################

%shub2_01_01120_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DAM_PI_XMIT_MSG_VC3"          => [   1,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "PI VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_PI_XMIT_MSG_VC2"          => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "PI VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_PI_XMIT_MSG_VC1"          => [   3,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "PI VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_PI_XMIT_MSG_VC0"          => [   4,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC3"          => [   5,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "MD VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC2"          => [   6,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "MD VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC1"          => [   7,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "MD VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC0"          => [   8,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC3"          => [   9,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC2"          => [  10,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC1"          => [  11,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC0"          => [  12,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI VC0 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC3"        => [  13,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC2"        => [  14,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC1"        => [  15,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC0"        => [  16,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Xmit Message Lost, as result of Link Reset" ],
   "RETRY_TIMEOUT_ERROR"          => [  17,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [  18,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [  19,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "MD_TAIL_CNT_ERROR"            => [  20,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "MD tail count error" ],
   "PI_TAIL_CNT_ERROR"            => [  21,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI tail count error" ],
   "NI_ILLEGAL_VC"                => [  22,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI illegal vc" ],
   "PI_ILLEGAL_VC"                => [  23,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "PI illegal vc" ],
   "MD_ILLEGAL_VC"                => [  24,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD illegal vc" ],
   "IILB_ILLEGAL_VC"              => [  25,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB illegal vc" ],
   "NI_FAST_TAIL_ERROR"           => [  26,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI fast tail error" ],
   "PI_FAST_TAIL_ERROR"           => [  27,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PI fast tail error" ],
   "MD_FAST_TAIL_ERROR"           => [  28,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD fast tail error" ],
   "IILB_FAST_TAIL_ERROR"         => [  29,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "NI_FAST_TAIL_UNDERFLOW"       => [  30,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fast tail underflow" ],
   "PI_DATA_FAST_TAIL_UNDERFLOW"  => [  31,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "PI data fast tail underflow" ],
   "PI_HDR_FAST_TAIL_UNDERFLOW"   => [  32,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail underflow" ],
   "MD_DATA_FAST_TAIL_UNDERFLOW"  => [  33,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "MD data fast tail underflow" ],
   "MD_HDR_FAST_TAIL_UNDERFLOW"   => [  34,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail underflow" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [  35,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC3" => [  36,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc3" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC2" => [  37,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc2" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC1" => [  38,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc1" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC0" => [  39,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc0" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  40,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc2" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  41,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc2" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  42,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc0" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  43,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc0" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  44,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc2" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  45,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc2" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  46,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc0" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  47,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc0" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC2" => [  48,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc2" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC0" => [  49,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc0" ],
   "PI_DEBIT_UNDERFLOW_VC2"       => [  50,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI debit underflow vc2" ],
   "PI_DEBIT_UNDERFLOW_VC0"       => [  51,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI debit underflow vc0" ],
   "MD_DEBIT_UNDERFLOW_VC2"       => [  52,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "MD debit underflow vc2" ],
   "MD_DEBIT_UNDERFLOW_VC0"       => [  53,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "MD debit underflow vc0" ],
   "UNDERFLOW_NI_VC3_CREDIT"      => [  54,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit underflow vc3" ],
   "UNDERFLOW_NI_VC2_CREDIT"      => [  55,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit underflow vc2" ],
   "UNDERFLOW_NI_VC1_CREDIT"      => [  56,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit underflow vc1" ],
   "UNDERFLOW_NI_VC0_CREDIT"      => [  57,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit underflow vc0" ],
   "LLP_DEADLOCK_VC3"             => [  58,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [  59,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [  60,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [  61,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
);

%shub2_01_01120_def =
( NAME    => "SH2_NI1_ERROR_OVERFLOW_2_ALIAS",
  ADDRESS => 0x0000000050040638,
  NOTE    => "ni1 Error Overflow Bits Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01120_flds
);


##########################################################################
#                                                                        #
#   SH2_NI1_ERROR_MASK_1                                                 #
#                                                                        #
##########################################################################

%shub2_01_01121_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_TAIL_TIMEOUT_VC3"          => [   1,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "NI tail timeout vc3" ],
   "NI_TAIL_TIMEOUT_VC2"          => [   2,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "NI tail timeout vc2" ],
   "NI_TAIL_TIMEOUT_VC1"          => [   3,  59,   1, 0x0800000000000000, 0x00, 1, 0x0000000000000000, "NI tail timeout vc1" ],
   "NI_TAIL_TIMEOUT_VC0"          => [   4,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "NI tail timeout vc0" ],
   "PI_TAIL_TIMEOUT_VC3"          => [   5,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "PI tail timeout vc3" ],
   "PI_TAIL_TIMEOUT_VC2"          => [   6,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "PI tail timeout vc2" ],
   "PI_TAIL_TIMEOUT_VC1"          => [   7,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "PI tail timeout vc1" ],
   "PI_TAIL_TIMEOUT_VC0"          => [   8,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "PI tail timeout vc0" ],
   "MD_TAIL_TIMEOUT_VC3"          => [   9,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "MD tail timeout vc3" ],
   "MD_TAIL_TIMEOUT_VC2"          => [  10,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "MD tail timeout vc2" ],
   "MD_TAIL_TIMEOUT_VC1"          => [  11,  51,   1, 0x0008000000000000, 0x00, 1, 0x0000000000000000, "MD tail timeout vc1" ],
   "MD_TAIL_TIMEOUT_VC0"          => [  12,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "MD tail timeout vc0" ],
   "IILB_TAIL_TIMEOUT_VC3"        => [  13,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "IILB tail timeout vc3" ],
   "IILB_TAIL_TIMEOUT_VC2"        => [  14,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "IILB tail timeout vc2" ],
   "IILB_TAIL_TIMEOUT_VC1"        => [  15,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "IILB tail timeout vc1" ],
   "IILB_TAIL_TIMEOUT_VC0"        => [  16,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "IILB tail timeout vc0" ],
   "NI_DEBITSAVER_OVERFLOW_VC3"   => [  17,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "NI debitsaver overflow vc3" ],
   "NI_DEBITSAVER_OVERFLOW_VC2"   => [  18,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "NI debitsaver overflow vc2" ],
   "NI_DEBITSAVER_OVERFLOW_VC1"   => [  19,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "NI debitsaver overflow vc1" ],
   "NI_DEBITSAVER_OVERFLOW_VC0"   => [  20,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "NI debitsaver overflow vc0" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC3"   => [  21,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "NI queue counter overflow vc3" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC2"   => [  22,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "NI queue counter overflow vc2" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC1"   => [  23,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "NI queue counter overflow vc1" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC0"   => [  24,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "NI queue counter overflow vc0" ],
   "NI_FAST_TAIL_OVERFLOW"        => [  25,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "NI fast tail overflow" ],
   "PI_DATA_FAST_TAIL_OVERFLOW"   => [  26,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "PI data fast tail overflow" ],
   "PI_HDR_FAST_TAIL_OVERFLOW"    => [  27,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "PI hdr fast tail overflow" ],
   "MD_DATA_FAST_TAIL_OVERFLOW"   => [  28,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "MD data fast tail overflow" ],
   "MD_HDR_FAST_TAIL_OVERFLOW"    => [  29,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "MD hdr fast tail overflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  30,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "IILB fast tail overflow" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC3"  => [  31,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "NI fifo overflow vc3" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC2"  => [  32,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "NI fifo overflow vc2" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC1"  => [  33,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "NI fifo overflow vc1" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC0"  => [  34,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "NI fifo overflow vc0" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  35,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "PI data fifo overflow vc2" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  36,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "PI hdr fifo overflow vc2" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  37,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "PI data fifo overflow vc0" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  38,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "PI hdr fifo overflow vc0" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  39,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "MD data fifo overflow vc2" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  40,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "MD hdr fifo overflow vc2" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  41,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "MD data fifo overflow vc0" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  42,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "MD hdr fifo overflow vc0" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC2" => [  43,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "IILB fifo overflow vc2" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC0" => [  44,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "IILB fifo overflow vc0" ],
   "NI_DEBIT_OVERFLOW_VC3"        => [  45,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "NI debit overflow vc3" ],
   "NI_DEBIT_OVERFLOW_VC2"        => [  46,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "NI debit overflow vc2" ],
   "NI_DEBIT_OVERFLOW_VC1"        => [  47,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "NI debit overflow vc1" ],
   "NI_DEBIT_OVERFLOW_VC0"        => [  48,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "NI debit overflow vc0" ],
   "PI_DEBIT_OVERFLOW_VC2"        => [  49,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "PI debit overflow vc2" ],
   "PI_DEBIT_OVERFLOW_VC0"        => [  50,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "PI debit overflow vc0" ],
   "MD_DEBIT_OVERFLOW_VC2"        => [  51,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "MD debit overflow vc2" ],
   "MD_DEBIT_OVERFLOW_VC0"        => [  52,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "MD debit overflow vc0" ],
   "IILB_DEBIT_OVERFLOW_VC2"      => [  53,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "IILB debit overflow vc2" ],
   "IILB_DEBIT_OVERFLOW_VC0"      => [  54,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "IILB debit overflow vc0" ],
   "OVERFLOW_NI_VC3_CREDIT"       => [  55,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "NI credit overflow vc3" ],
   "OVERFLOW_NI_VC2_CREDIT"       => [  56,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "NI credit overflow vc2" ],
   "OVERFLOW_NI_VC1_CREDIT"       => [  57,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "NI credit overflow vc1" ],
   "OVERFLOW_NI_VC0_CREDIT"       => [  58,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "NI credit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT3"          => [  59,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT2"          => [  60,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT1"          => [  61,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT0"          => [  62,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "llp debit overflow vc0" ],
);

%shub2_01_01121_def =
( NAME    => "SH2_NI1_ERROR_MASK_1",
  ADDRESS => 0x0000000050040640,
  NOTE    => "ni1 Error Mask Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01121_flds
);


##########################################################################
#                                                                        #
#   SH2_NI1_ERROR_MASK_2                                                 #
#                                                                        #
##########################################################################

%shub2_01_01122_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DAM_PI_XMIT_MSG_VC3"          => [   1,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "PI VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_PI_XMIT_MSG_VC2"          => [   2,  59,   1, 0x0800000000000000, 0x00, 1, 0x0000000000000000, "PI VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_PI_XMIT_MSG_VC1"          => [   3,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "PI VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_PI_XMIT_MSG_VC0"          => [   4,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "PI VC0 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC3"          => [   5,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "MD VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC2"          => [   6,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "MD VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC1"          => [   7,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "MD VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC0"          => [   8,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "MD VC0 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC3"          => [   9,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "NI VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC2"          => [  10,  51,   1, 0x0008000000000000, 0x00, 1, 0x0000000000000000, "NI VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC1"          => [  11,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "NI VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC0"          => [  12,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "NI VC0 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC3"        => [  13,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "IILB VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC2"        => [  14,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "IILB VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC1"        => [  15,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "IILB VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC0"        => [  16,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "IILB VC0 Xmit Message Lost, as result of Link Reset" ],
   "RETRY_TIMEOUT_ERROR"          => [  17,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [  18,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [  19,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "chiplet nomatch" ],
   "MD_TAIL_CNT_ERROR"            => [  20,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "MD tail count error" ],
   "PI_TAIL_CNT_ERROR"            => [  21,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "PI tail count error" ],
   "NI_ILLEGAL_VC"                => [  22,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "NI illegal vc" ],
   "PI_ILLEGAL_VC"                => [  23,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "PI illegal vc" ],
   "MD_ILLEGAL_VC"                => [  24,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "MD illegal vc" ],
   "IILB_ILLEGAL_VC"              => [  25,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "IILB illegal vc" ],
   "NI_FAST_TAIL_ERROR"           => [  26,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "NI fast tail error" ],
   "PI_FAST_TAIL_ERROR"           => [  27,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "PI fast tail error" ],
   "MD_FAST_TAIL_ERROR"           => [  28,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "MD fast tail error" ],
   "IILB_FAST_TAIL_ERROR"         => [  29,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "IILB fast tail error" ],
   "NI_FAST_TAIL_UNDERFLOW"       => [  30,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "NI fast tail underflow" ],
   "PI_DATA_FAST_TAIL_UNDERFLOW"  => [  31,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "PI data fast tail underflow" ],
   "PI_HDR_FAST_TAIL_UNDERFLOW"   => [  32,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "PI hdr fast tail underflow" ],
   "MD_DATA_FAST_TAIL_UNDERFLOW"  => [  33,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "MD data fast tail underflow" ],
   "MD_HDR_FAST_TAIL_UNDERFLOW"   => [  34,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "MD hdr fast tail underflow" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [  35,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "IILB fast tail underflow" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC3" => [  36,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "NI fifo underflow vc3" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC2" => [  37,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "NI fifo underflow vc2" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC1" => [  38,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "NI fifo underflow vc1" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC0" => [  39,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "NI fifo underflow vc0" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  40,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "PI data fifo underflow vc2" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  41,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "PI hdr fifo underflow vc2" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  42,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "PI data fifo underflow vc0" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  43,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "PI hdr fifo underflow vc0" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  44,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "MD data fifo underflow vc2" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  45,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "MD hdr fifo underflow vc2" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  46,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "MD data fifo underflow vc0" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  47,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "MD hdr fifo underflow vc0" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC2" => [  48,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "IILB fifo underflow vc2" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC0" => [  49,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "IILB fifo underflow vc0" ],
   "PI_DEBIT_UNDERFLOW_VC2"       => [  50,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "PI debit underflow vc2" ],
   "PI_DEBIT_UNDERFLOW_VC0"       => [  51,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "PI debit underflow vc0" ],
   "MD_DEBIT_UNDERFLOW_VC2"       => [  52,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "MD debit underflow vc2" ],
   "MD_DEBIT_UNDERFLOW_VC0"       => [  53,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "MD debit underflow vc0" ],
   "UNDERFLOW_NI_VC3_CREDIT"      => [  54,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "NI credit underflow vc3" ],
   "UNDERFLOW_NI_VC2_CREDIT"      => [  55,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "NI credit underflow vc2" ],
   "UNDERFLOW_NI_VC1_CREDIT"      => [  56,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "NI credit underflow vc1" ],
   "UNDERFLOW_NI_VC0_CREDIT"      => [  57,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "NI credit underflow vc0" ],
   "LLP_DEADLOCK_VC3"             => [  58,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [  59,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [  60,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [  61,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "llp deadlock vc0" ],
);

%shub2_01_01122_def =
( NAME    => "SH2_NI1_ERROR_MASK_2",
  ADDRESS => 0x0000000050040650,
  NOTE    => "ni1 Error Mask Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01122_flds
);


##########################################################################
#                                                                        #
#   SH2_NI1_FIRST_ERROR_1                                                #
#                                                                        #
##########################################################################

%shub2_01_01123_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_TAIL_TIMEOUT_VC3"          => [   1,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc3" ],
   "NI_TAIL_TIMEOUT_VC2"          => [   2,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc2" ],
   "NI_TAIL_TIMEOUT_VC1"          => [   3,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc1" ],
   "NI_TAIL_TIMEOUT_VC0"          => [   4,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc0" ],
   "PI_TAIL_TIMEOUT_VC3"          => [   5,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc3" ],
   "PI_TAIL_TIMEOUT_VC2"          => [   6,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc2" ],
   "PI_TAIL_TIMEOUT_VC1"          => [   7,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc1" ],
   "PI_TAIL_TIMEOUT_VC0"          => [   8,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "PI tail timeout vc0" ],
   "MD_TAIL_TIMEOUT_VC3"          => [   9,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc3" ],
   "MD_TAIL_TIMEOUT_VC2"          => [  10,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc2" ],
   "MD_TAIL_TIMEOUT_VC1"          => [  11,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc1" ],
   "MD_TAIL_TIMEOUT_VC0"          => [  12,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD tail timeout vc0" ],
   "IILB_TAIL_TIMEOUT_VC3"        => [  13,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc3" ],
   "IILB_TAIL_TIMEOUT_VC2"        => [  14,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc2" ],
   "IILB_TAIL_TIMEOUT_VC1"        => [  15,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc1" ],
   "IILB_TAIL_TIMEOUT_VC0"        => [  16,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc0" ],
   "NI_DEBITSAVER_OVERFLOW_VC3"   => [  17,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc3" ],
   "NI_DEBITSAVER_OVERFLOW_VC2"   => [  18,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc2" ],
   "NI_DEBITSAVER_OVERFLOW_VC1"   => [  19,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc1" ],
   "NI_DEBITSAVER_OVERFLOW_VC0"   => [  20,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc0" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC3"   => [  21,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc3" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC2"   => [  22,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc2" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC1"   => [  23,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc1" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC0"   => [  24,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc0" ],
   "NI_FAST_TAIL_OVERFLOW"        => [  25,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI fast tail overflow" ],
   "PI_DATA_FAST_TAIL_OVERFLOW"   => [  26,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail overflow" ],
   "PI_HDR_FAST_TAIL_OVERFLOW"    => [  27,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail overflow" ],
   "MD_DATA_FAST_TAIL_OVERFLOW"   => [  28,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "MD data fast tail overflow" ],
   "MD_HDR_FAST_TAIL_OVERFLOW"    => [  29,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail overflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  30,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC3"  => [  31,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc3" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC2"  => [  32,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc2" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC1"  => [  33,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc1" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC0"  => [  34,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc0" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  35,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc2" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  36,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc2" ],
   "PI_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  37,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "PI data fifo overflow vc0" ],
   "PI_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  38,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "PI hdr fifo overflow vc0" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC2" => [  39,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc2" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC2" => [  40,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc2" ],
   "MD_DATA_FIFO_CREDIT_OVERFLOW_VC0" => [  41,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "MD data fifo overflow vc0" ],
   "MD_HDR_FIFO_CREDIT_OVERFLOW_VC0" => [  42,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MD hdr fifo overflow vc0" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC2" => [  43,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc2" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC0" => [  44,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc0" ],
   "NI_DEBIT_OVERFLOW_VC3"        => [  45,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc3" ],
   "NI_DEBIT_OVERFLOW_VC2"        => [  46,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc2" ],
   "NI_DEBIT_OVERFLOW_VC1"        => [  47,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc1" ],
   "NI_DEBIT_OVERFLOW_VC0"        => [  48,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc0" ],
   "PI_DEBIT_OVERFLOW_VC2"        => [  49,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc2" ],
   "PI_DEBIT_OVERFLOW_VC0"        => [  50,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI debit overflow vc0" ],
   "MD_DEBIT_OVERFLOW_VC2"        => [  51,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "MD debit overflow vc2" ],
   "MD_DEBIT_OVERFLOW_VC0"        => [  52,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "MD debit overflow vc0" ],
   "IILB_DEBIT_OVERFLOW_VC2"      => [  53,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc2" ],
   "IILB_DEBIT_OVERFLOW_VC0"      => [  54,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc0" ],
   "OVERFLOW_NI_VC3_CREDIT"       => [  55,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit overflow vc3" ],
   "OVERFLOW_NI_VC2_CREDIT"       => [  56,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit overflow vc2" ],
   "OVERFLOW_NI_VC1_CREDIT"       => [  57,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit overflow vc1" ],
   "OVERFLOW_NI_VC0_CREDIT"       => [  58,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT3"          => [  59,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT2"          => [  60,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT1"          => [  61,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT0"          => [  62,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
);

%shub2_01_01123_def =
( NAME    => "SH2_NI1_FIRST_ERROR_1",
  ADDRESS => 0x0000000050040660,
  NOTE    => "ni1 First Error Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01123_flds
);


##########################################################################
#                                                                        #
#   SH2_NI1_FIRST_ERROR_2                                                #
#                                                                        #
##########################################################################

%shub2_01_01124_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DAM_PI_XMIT_MSG_VC3"          => [   1,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "PI VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_PI_XMIT_MSG_VC2"          => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "PI VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_PI_XMIT_MSG_VC1"          => [   3,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "PI VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_PI_XMIT_MSG_VC0"          => [   4,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC3"          => [   5,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "MD VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC2"          => [   6,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "MD VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC1"          => [   7,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "MD VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_MD_XMIT_MSG_VC0"          => [   8,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC3"          => [   9,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC2"          => [  10,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC1"          => [  11,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_NI_XMIT_MSG_VC0"          => [  12,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI VC0 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC3"        => [  13,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC3 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC2"        => [  14,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC1"        => [  15,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC1 Xmit Message Lost, as result of Link Reset" ],
   "DAM_IILB_XMIT_MSG_VC0"        => [  16,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Xmit Message Lost, as result of Link Reset" ],
   "RETRY_TIMEOUT_ERROR"          => [  17,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [  18,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [  19,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "MD_TAIL_CNT_ERROR"            => [  20,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "MD tail count error" ],
   "PI_TAIL_CNT_ERROR"            => [  21,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI tail count error" ],
   "NI_ILLEGAL_VC"                => [  22,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI illegal vc" ],
   "PI_ILLEGAL_VC"                => [  23,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "PI illegal vc" ],
   "MD_ILLEGAL_VC"                => [  24,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD illegal vc" ],
   "IILB_ILLEGAL_VC"              => [  25,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB illegal vc" ],
   "NI_FAST_TAIL_ERROR"           => [  26,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI fast tail error" ],
   "PI_FAST_TAIL_ERROR"           => [  27,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PI fast tail error" ],
   "MD_FAST_TAIL_ERROR"           => [  28,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "MD fast tail error" ],
   "IILB_FAST_TAIL_ERROR"         => [  29,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "NI_FAST_TAIL_UNDERFLOW"       => [  30,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fast tail underflow" ],
   "PI_DATA_FAST_TAIL_UNDERFLOW"  => [  31,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "PI data fast tail underflow" ],
   "PI_HDR_FAST_TAIL_UNDERFLOW"   => [  32,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail underflow" ],
   "MD_DATA_FAST_TAIL_UNDERFLOW"  => [  33,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "MD data fast tail underflow" ],
   "MD_HDR_FAST_TAIL_UNDERFLOW"   => [  34,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail underflow" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [  35,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC3" => [  36,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc3" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC2" => [  37,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc2" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC1" => [  38,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc1" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC0" => [  39,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc0" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  40,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc2" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  41,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc2" ],
   "PI_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  42,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "PI data fifo underflow vc0" ],
   "PI_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  43,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "PI hdr fifo underflow vc0" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC2" => [  44,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc2" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC2" => [  45,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc2" ],
   "MD_DATA_FIFO_CREDIT_UNDERFLOW_VC0" => [  46,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD data fifo underflow vc0" ],
   "MD_HDR_FIFO_CREDIT_UNDERFLOW_VC0" => [  47,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD hdr fifo underflow vc0" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC2" => [  48,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc2" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC0" => [  49,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc0" ],
   "PI_DEBIT_UNDERFLOW_VC2"       => [  50,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI debit underflow vc2" ],
   "PI_DEBIT_UNDERFLOW_VC0"       => [  51,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI debit underflow vc0" ],
   "MD_DEBIT_UNDERFLOW_VC2"       => [  52,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "MD debit underflow vc2" ],
   "MD_DEBIT_UNDERFLOW_VC0"       => [  53,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "MD debit underflow vc0" ],
   "UNDERFLOW_NI_VC3_CREDIT"      => [  54,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit underflow vc3" ],
   "UNDERFLOW_NI_VC2_CREDIT"      => [  55,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit underflow vc2" ],
   "UNDERFLOW_NI_VC1_CREDIT"      => [  56,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit underflow vc1" ],
   "UNDERFLOW_NI_VC0_CREDIT"      => [  57,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit underflow vc0" ],
   "LLP_DEADLOCK_VC3"             => [  58,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [  59,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [  60,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [  61,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
);

%shub2_01_01124_def =
( NAME    => "SH2_NI1_FIRST_ERROR_2",
  ADDRESS => 0x0000000050040670,
  NOTE    => "ni1 First Error Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01124_flds
);


##########################################################################
#                                                                        #
#   SH2_NI1_ERROR_DETAIL_1                                               #
#                                                                        #
##########################################################################

%shub2_01_01125_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Header bits 63:0" ],
);

%shub2_01_01125_def =
( NAME    => "SH2_NI1_ERROR_DETAIL_1",
  ADDRESS => 0x0000000050040680,
  NOTE    => "ni1 Chiplet no match header bits 63:0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01125_flds
);


##########################################################################
#                                                                        #
#   SH2_NI1_ERROR_DETAIL_2                                               #
#                                                                        #
##########################################################################

%shub2_01_01126_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Header bits 127:64" ],
);

%shub2_01_01126_def =
( NAME    => "SH2_NI1_ERROR_DETAIL_2",
  ADDRESS => 0x0000000050040690,
  NOTE    => "ni1 Chiplet no match header bits 127:64",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01126_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_CORRECTED_DETAIL_1                                            #
#                                                                        #
##########################################################################

%shub2_01_01127_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ERR_GROUP"                    => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Captured Error group" ],
   "RSVD0"                        => [   1,  60,   2, 0x3000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECC3_VC"                      => [   2,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "Captured Virtual Channel for DW3" ],
   "ECC3_WC"                      => [   3,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "Captured Word Count for DW3" ],
   "ECC3_SYNDROME"                => [   4,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "Captured ECC Syndrome for DW3" ],
   "RSVD1"                        => [   5,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECC2_VC"                      => [   6,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "Captured Virtual Channel for DW2" ],
   "ECC2_WC"                      => [   7,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "Captured Word Count for DW2" ],
   "ECC2_SYNDROME"                => [   8,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Captured ECC Syndrome for DW2" ],
   "RSVD2"                        => [   9,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECC1_VC"                      => [  10,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Captured Virtual Channel for DW1" ],
   "ECC1_WC"                      => [  11,  24,   2, 0x0000000003000000, 0x00, 0, 0x0000000000000000, "Captured Word Count for DW1" ],
   "ECC1_SYNDROME"                => [  12,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Captured ECC Syndrome for DW1" ],
   "RSVD3"                        => [  13,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECC0_VC"                      => [  14,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Captured Virtual Channel for DW0" ],
   "ECC0_WC"                      => [  15,   8,   2, 0x0000000000000300, 0x00, 0, 0x0000000000000000, "Captured Word Count for DW0" ],
   "ECC0_SYNDROME"                => [  16,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Captured ECC Syndrome for DW0" ],
);

%shub2_01_01127_def =
( NAME    => "SH2_XN_CORRECTED_DETAIL_1",
  ADDRESS => 0x0000000050040070,
  NOTE    => "This register contains captured XN error status bits for note correctable errors in the SIC channel data payload recieved from n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01127_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_CORRECTED_DETAIL_2                                            #
#                                                                        #
##########################################################################

%shub2_01_01128_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Captured data" ],
);

%shub2_01_01128_def =
( NAME    => "SH2_XN_CORRECTED_DETAIL_2",
  ADDRESS => 0x0000000050040080,
  NOTE    => "Corrected error data",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01128_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_CORRECTED_DETAIL_3                                            #
#                                                                        #
##########################################################################

%shub2_01_01129_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER0"                      => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Captured header0 (bits 63 - 0)" ],
);

%shub2_01_01129_def =
( NAME    => "SH2_XN_CORRECTED_DETAIL_3",
  ADDRESS => 0x00000000500400a0,
  NOTE    => "Corrected error header0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01129_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_CORRECTED_DETAIL_4                                            #
#                                                                        #
##########################################################################

%shub2_01_01130_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER1"                      => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Captured header1 (bits 127 - 64)" ],
);

%shub2_01_01130_def =
( NAME    => "SH2_XN_CORRECTED_DETAIL_4",
  ADDRESS => 0x00000000500400b0,
  NOTE    => "Corrected error header1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01130_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_UNCORRECTED_DETAIL_1                                          #
#                                                                        #
##########################################################################

%shub2_01_01131_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ERR_GROUP"                    => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Error group" ],
   "RSVD0"                        => [   1,  60,   2, 0x3000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECC3_VC"                      => [   2,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "ECC3 Virtual Channel" ],
   "ECC3_WC"                      => [   3,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "ECC3 Word Count" ],
   "ECC3_SYNDROME"                => [   4,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "ECC3 Syndrome" ],
   "RSVD1"                        => [   5,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECC2_VC"                      => [   6,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "ECC2 Virtual Channel" ],
   "ECC2_WC"                      => [   7,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "ECC2 Word Count" ],
   "ECC2_SYNDROME"                => [   8,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "ECC2 Syndrome" ],
   "RSVD2"                        => [   9,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECC1_VC"                      => [  10,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "ECC1 Virtual Channel" ],
   "ECC1_WC"                      => [  11,  24,   2, 0x0000000003000000, 0x00, 0, 0x0000000000000000, "ECC1 Word Count" ],
   "ECC1_SYNDROME"                => [  12,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "ECC1 Syndrome" ],
   "RSVD3"                        => [  13,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECC0_VC"                      => [  14,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "ECC0 Virtual Channel" ],
   "ECC0_WC"                      => [  15,   8,   2, 0x0000000000000300, 0x00, 0, 0x0000000000000000, "ECC0 Word Count" ],
   "ECC0_SYNDROME"                => [  16,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "ECC0 Syndrome" ],
);

%shub2_01_01131_def =
( NAME    => "SH2_XN_UNCORRECTED_DETAIL_1",
  ADDRESS => 0x00000000500400c0,
  NOTE    => "This register contains captured XN error status bits for note uncorrectable errors in the SIC channel data payload recieved from",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01131_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_UNCORRECTED_DETAIL_2                                          #
#                                                                        #
##########################################################################

%shub2_01_01132_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "ECC data" ],
);

%shub2_01_01132_def =
( NAME    => "SH2_XN_UNCORRECTED_DETAIL_2",
  ADDRESS => 0x00000000500400d0,
  NOTE    => "Uncorrected error data",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01132_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_UNCORRECTED_DETAIL_3                                          #
#                                                                        #
##########################################################################

%shub2_01_01133_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER0"                      => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "ECC header0 (bits 63 - 0)" ],
);

%shub2_01_01133_def =
( NAME    => "SH2_XN_UNCORRECTED_DETAIL_3",
  ADDRESS => 0x00000000500400f0,
  NOTE    => "Uncorrected error header0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01133_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_UNCORRECTED_DETAIL_4                                          #
#                                                                        #
##########################################################################

%shub2_01_01134_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER1"                      => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "ECC header1 (bits 127 - 64)" ],
);

%shub2_01_01134_def =
( NAME    => "SH2_XN_UNCORRECTED_DETAIL_4",
  ADDRESS => 0x0000000050040100,
  NOTE    => "Uncorrected error header1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01134_flds
);


##########################################################################
#                                                                        #
#   SH2_XNMD_ERROR_DETAIL_1                                              #
#                                                                        #
##########################################################################

%shub2_01_01135_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_ADDR"                     => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Look Up Table Read Address" ],
);

%shub2_01_01135_def =
( NAME    => "SH2_XNMD_ERROR_DETAIL_1",
  ADDRESS => 0x0000000050040110,
  NOTE    => "Look Up Table Address (md)",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01135_flds
);


##########################################################################
#                                                                        #
#   SH2_XNPI_ERROR_DETAIL_1                                              #
#                                                                        #
##########################################################################

%shub2_01_01136_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_ADDR"                     => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Look Up Table Read Address" ],
);

%shub2_01_01136_def =
( NAME    => "SH2_XNPI_ERROR_DETAIL_1",
  ADDRESS => 0x0000000050040120,
  NOTE    => "Look Up Table Address (pi)",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01136_flds
);


##########################################################################
#                                                                        #
#   SH2_XNIILB_ERROR_DETAIL_1                                            #
#                                                                        #
##########################################################################

%shub2_01_01137_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "header bits [63:0]" ],
);

%shub2_01_01137_def =
( NAME    => "SH2_XNIILB_ERROR_DETAIL_1",
  ADDRESS => 0x0000000050040130,
  NOTE    => "Chiplet NoMatch header [63:0]",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01137_flds
);


##########################################################################
#                                                                        #
#   SH2_XNIILB_ERROR_DETAIL_2                                            #
#                                                                        #
##########################################################################

%shub2_01_01138_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "header bits [127:64]" ],
);

%shub2_01_01138_def =
( NAME    => "SH2_XNIILB_ERROR_DETAIL_2",
  ADDRESS => 0x0000000050040140,
  NOTE    => "Chiplet NoMatch header [127:64]",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01138_flds
);


##########################################################################
#                                                                        #
#   SH2_XNIILB_ERROR_DETAIL_3                                            #
#                                                                        #
##########################################################################

%shub2_01_01139_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_ADDR"                     => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Look Up Table Read Address" ],
);

%shub2_01_01139_def =
( NAME    => "SH2_XNIILB_ERROR_DETAIL_3",
  ADDRESS => 0x0000000050040150,
  NOTE    => "Look Up Table Address (iilb)",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01139_flds
);


##########################################################################
#                                                                        #
#   SH2_NI0_ERROR_DETAIL_3                                               #
#                                                                        #
##########################################################################

%shub2_01_01140_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_ADDR"                     => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Look Up Table Read Address" ],
);

%shub2_01_01140_def =
( NAME    => "SH2_NI0_ERROR_DETAIL_3",
  ADDRESS => 0x0000000050040160,
  NOTE    => "Look Up Table Address (ni0)",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01140_flds
);


##########################################################################
#                                                                        #
#   SH2_NI1_ERROR_DETAIL_3                                               #
#                                                                        #
##########################################################################

%shub2_01_01141_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_ADDR"                     => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Look Up Table Read Address" ],
);

%shub2_01_01141_def =
( NAME    => "SH2_NI1_ERROR_DETAIL_3",
  ADDRESS => 0x0000000050040170,
  NOTE    => "Look Up Table Address (ni1)",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01141_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_ERROR_SUMMARY                                                 #
#                                                                        #
##########################################################################

%shub2_01_01142_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  37,  27, 0xFFFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XNPI_LUT_ERROR"               => [   1,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "XNPI look up table error" ],
   "XNPI_DEBIT_OVERFLOW"          => [   2,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "XNPI debit overflow" ],
   "XNPI_FIFO_UNDERFLOW"          => [   3,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "XNPI fifo underflow" ],
   "XNPI_FIFO_OVERFLOW"           => [   4,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "XNPI fifo overflow" ],
   "XNPI_CREDIT_UNDERFLOW"        => [   5,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "XNPI credit underflow" ],
   "XNPI_CREDIT_OVERFLOW"         => [   6,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "XNPI credit overflow" ],
   "XNMD_LUT_ERROR"               => [   7,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "XNMD look up table error" ],
   "XNMD_DEBIT_OVERFLOW"          => [   8,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "XNMD debit overflow" ],
   "XNMD_FIFO_UNDERFLOW"          => [   9,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "XNMD fifo underflow" ],
   "XNMD_FIFO_OVERFLOW"           => [  10,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "XNMD fifo overflow" ],
   "XNMD_CREDIT_UNDERFLOW"        => [  11,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "XNMD credit underflow" ],
   "XNMD_CREDIT_OVERFLOW"         => [  12,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "XNMD credit overflow" ],
   "XNMD_UCE_ERROR"               => [  13,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "XNMD uncorrectable error" ],
   "XNMD_SBE_ERROR"               => [  14,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "XNMD single bit error" ],
   "IILB_CHIPLET_OR_LUT"          => [  15,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB chiplet nomatch or lut read error" ],
   "IILB_FIFO_UNDERFLOW"          => [  16,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow" ],
   "IILB_FIFO_OVERFLOW"           => [  17,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow" ],
   "IILB_CREDIT_UNDERFLOW"        => [  18,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB credit underflow" ],
   "IILB_CREDIT_OVERFLOW"         => [  19,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB credit overflow" ],
   "IILB_DEBIT_UNDERFLOW"         => [  20,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "IILB debit underflow" ],
   "IILB_DEBIT_OVERFLOW"          => [  21,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "IILB debit overflow" ],
   "NI1_LLP_ERROR"                => [  22,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI1 llp error" ],
   "NI1_PIPE_ERROR"               => [  23,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 pipe in/out error" ],
   "NI1_FIFO_UNDERFLOW"           => [  24,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 fifo underflow" ],
   "NI1_FIFO_OVERFLOW"            => [  25,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI1 fifo overflow" ],
   "NI1_CREDIT_UNDERFLOW"         => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI1 credit underflow" ],
   "NI1_CREDIT_OVERFLOW"          => [  27,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "NI1 credit overflow" ],
   "NI1_DEBIT_UNDERFLOW"          => [  28,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 debit underflow" ],
   "NI1_DEBIT_OVERFLOW"           => [  29,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 debit overflow" ],
   "NI0_LLP_ERROR"                => [  30,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI0 llp error" ],
   "NI0_PIPE_ERROR"               => [  31,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI0 Pipe in/out errors" ],
   "NI0_FIFO_UNDERFLOW"           => [  32,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 fifo underflow" ],
   "NI0_FIFO_OVERFLOW"            => [  33,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 fifo overflow" ],
   "NI0_CREDIT_UNDERFLOW"         => [  34,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 credit underflow" ],
   "NI0_CREDIT_OVERFLOW"          => [  35,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 credit overflow" ],
   "NI0_DEBIT_UNDERFLOW"          => [  36,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "NI0 debit underflow" ],
   "NI0_DEBIT_OVERFLOW"           => [  37,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "NI0 debit overflow" ],
);

%shub2_01_01142_def =
( NAME    => "SH2_XN_ERROR_SUMMARY",
  ADDRESS => 0x0000000050040000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01142_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_ERROR_SUMMARY_ALIAS                                           #
#                                                                        #
##########################################################################

%shub2_01_01143_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  37,  27, 0xFFFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XNPI_LUT_ERROR"               => [   1,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "XNPI look up table error" ],
   "XNPI_DEBIT_OVERFLOW"          => [   2,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "XNPI debit overflow" ],
   "XNPI_FIFO_UNDERFLOW"          => [   3,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "XNPI fifo underflow" ],
   "XNPI_FIFO_OVERFLOW"           => [   4,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "XNPI fifo overflow" ],
   "XNPI_CREDIT_UNDERFLOW"        => [   5,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "XNPI credit underflow" ],
   "XNPI_CREDIT_OVERFLOW"         => [   6,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "XNPI credit overflow" ],
   "XNMD_LUT_ERROR"               => [   7,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "XNMD look up table error" ],
   "XNMD_DEBIT_OVERFLOW"          => [   8,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "XNMD debit overflow" ],
   "XNMD_FIFO_UNDERFLOW"          => [   9,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "XNMD fifo underflow" ],
   "XNMD_FIFO_OVERFLOW"           => [  10,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "XNMD fifo overflow" ],
   "XNMD_CREDIT_UNDERFLOW"        => [  11,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "XNMD credit underflow" ],
   "XNMD_CREDIT_OVERFLOW"         => [  12,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "XNMD credit overflow" ],
   "XNMD_UCE_ERROR"               => [  13,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "XNMD uncorrectable error" ],
   "XNMD_SBE_ERROR"               => [  14,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "XNMD single bit error" ],
   "IILB_CHIPLET_OR_LUT"          => [  15,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB chiplet nomatch or lut read error" ],
   "IILB_FIFO_UNDERFLOW"          => [  16,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow" ],
   "IILB_FIFO_OVERFLOW"           => [  17,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow" ],
   "IILB_CREDIT_UNDERFLOW"        => [  18,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB credit underflow" ],
   "IILB_CREDIT_OVERFLOW"         => [  19,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB credit overflow" ],
   "IILB_DEBIT_UNDERFLOW"         => [  20,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "IILB debit underflow" ],
   "IILB_DEBIT_OVERFLOW"          => [  21,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "IILB debit overflow" ],
   "NI1_LLP_ERROR"                => [  22,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI1 llp error" ],
   "NI1_PIPE_ERROR"               => [  23,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 pipe in/out error" ],
   "NI1_FIFO_UNDERFLOW"           => [  24,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 fifo underflow" ],
   "NI1_FIFO_OVERFLOW"            => [  25,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI1 fifo overflow" ],
   "NI1_CREDIT_UNDERFLOW"         => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI1 credit underflow" ],
   "NI1_CREDIT_OVERFLOW"          => [  27,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "NI1 credit overflow" ],
   "NI1_DEBIT_UNDERFLOW"          => [  28,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 debit underflow" ],
   "NI1_DEBIT_OVERFLOW"           => [  29,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 debit overflow" ],
   "NI0_LLP_ERROR"                => [  30,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI0 llp error" ],
   "NI0_PIPE_ERROR"               => [  31,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI0 Pipe in/out errors" ],
   "NI0_FIFO_UNDERFLOW"           => [  32,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 fifo underflow" ],
   "NI0_FIFO_OVERFLOW"            => [  33,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 fifo overflow" ],
   "NI0_CREDIT_UNDERFLOW"         => [  34,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 credit underflow" ],
   "NI0_CREDIT_OVERFLOW"          => [  35,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 credit overflow" ],
   "NI0_DEBIT_UNDERFLOW"          => [  36,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "NI0 debit underflow" ],
   "NI0_DEBIT_OVERFLOW"           => [  37,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "NI0 debit overflow" ],
);

%shub2_01_01143_def =
( NAME    => "SH2_XN_ERROR_SUMMARY_ALIAS",
  ADDRESS => 0x0000000050040008,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01143_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_ERROR_OVERFLOW                                                #
#                                                                        #
##########################################################################

%shub2_01_01144_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  37,  27, 0xFFFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XNPI_LUT_ERROR"               => [   1,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "XNPI look up table error" ],
   "XNPI_DEBIT_OVERFLOW"          => [   2,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "XNPI debit overflow" ],
   "XNPI_FIFO_UNDERFLOW"          => [   3,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "XNPI fifo underflow" ],
   "XNPI_FIFO_OVERFLOW"           => [   4,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "XNPI fifo overflow" ],
   "XNPI_CREDIT_UNDERFLOW"        => [   5,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "XNPI credit underflow" ],
   "XNPI_CREDIT_OVERFLOW"         => [   6,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "XNPI credit overflow" ],
   "XNMD_LUT_ERROR"               => [   7,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "XNMD look up table error" ],
   "XNMD_DEBIT_OVERFLOW"          => [   8,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "XNMD debit overflow" ],
   "XNMD_FIFO_UNDERFLOW"          => [   9,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "XNMD fifo underflow" ],
   "XNMD_FIFO_OVERFLOW"           => [  10,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "XNMD fifo overflow" ],
   "XNMD_CREDIT_UNDERFLOW"        => [  11,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "XNMD credit underflow" ],
   "XNMD_CREDIT_OVERFLOW"         => [  12,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "XNMD credit overflow" ],
   "XNMD_UCE_ERROR"               => [  13,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "XNMD uncorrectable error" ],
   "XNMD_SBE_ERROR"               => [  14,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "XNMD single bit error" ],
   "IILB_CHIPLET_OR_LUT"          => [  15,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB chiplet nomatch or lut read error" ],
   "IILB_FIFO_UNDERFLOW"          => [  16,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow" ],
   "IILB_FIFO_OVERFLOW"           => [  17,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow" ],
   "IILB_CREDIT_UNDERFLOW"        => [  18,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB credit underflow" ],
   "IILB_CREDIT_OVERFLOW"         => [  19,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB credit overflow" ],
   "IILB_DEBIT_UNDERFLOW"         => [  20,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "IILB debit underflow" ],
   "IILB_DEBIT_OVERFLOW"          => [  21,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "IILB debit overflow" ],
   "NI1_LLP_ERROR"                => [  22,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI1 llp error" ],
   "NI1_PIPE_ERROR"               => [  23,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 pipe in/out error" ],
   "NI1_FIFO_UNDERFLOW"           => [  24,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 fifo underflow" ],
   "NI1_FIFO_OVERFLOW"            => [  25,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI1 fifo overflow" ],
   "NI1_CREDIT_UNDERFLOW"         => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI1 credit underflow" ],
   "NI1_CREDIT_OVERFLOW"          => [  27,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "NI1 credit overflow" ],
   "NI1_DEBIT_UNDERFLOW"          => [  28,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 debit underflow" ],
   "NI1_DEBIT_OVERFLOW"           => [  29,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 debit overflow" ],
   "NI0_LLP_ERROR"                => [  30,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI0 llp error" ],
   "NI0_PIPE_ERROR"               => [  31,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI0 Pipe in/out errors" ],
   "NI0_FIFO_UNDERFLOW"           => [  32,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 fifo underflow" ],
   "NI0_FIFO_OVERFLOW"            => [  33,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 fifo overflow" ],
   "NI0_CREDIT_UNDERFLOW"         => [  34,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 credit underflow" ],
   "NI0_CREDIT_OVERFLOW"          => [  35,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 credit overflow" ],
   "NI0_DEBIT_UNDERFLOW"          => [  36,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "NI0 debit underflow" ],
   "NI0_DEBIT_OVERFLOW"           => [  37,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "NI0 debit overflow" ],
);

%shub2_01_01144_def =
( NAME    => "SH2_XN_ERROR_OVERFLOW",
  ADDRESS => 0x0000000050040020,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01144_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_ERROR_OVERFLOW_ALIAS                                          #
#                                                                        #
##########################################################################

%shub2_01_01145_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  37,  27, 0xFFFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XNPI_LUT_ERROR"               => [   1,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "XNPI look up table error" ],
   "XNPI_DEBIT_OVERFLOW"          => [   2,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "XNPI debit overflow" ],
   "XNPI_FIFO_UNDERFLOW"          => [   3,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "XNPI fifo underflow" ],
   "XNPI_FIFO_OVERFLOW"           => [   4,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "XNPI fifo overflow" ],
   "XNPI_CREDIT_UNDERFLOW"        => [   5,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "XNPI credit underflow" ],
   "XNPI_CREDIT_OVERFLOW"         => [   6,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "XNPI credit overflow" ],
   "XNMD_LUT_ERROR"               => [   7,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "XNMD look up table error" ],
   "XNMD_DEBIT_OVERFLOW"          => [   8,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "XNMD debit overflow" ],
   "XNMD_FIFO_UNDERFLOW"          => [   9,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "XNMD fifo underflow" ],
   "XNMD_FIFO_OVERFLOW"           => [  10,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "XNMD fifo overflow" ],
   "XNMD_CREDIT_UNDERFLOW"        => [  11,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "XNMD credit underflow" ],
   "XNMD_CREDIT_OVERFLOW"         => [  12,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "XNMD credit overflow" ],
   "XNMD_UCE_ERROR"               => [  13,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "XNMD uncorrectable error" ],
   "XNMD_SBE_ERROR"               => [  14,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "XNMD single bit error" ],
   "IILB_CHIPLET_OR_LUT"          => [  15,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB chiplet nomatch or lut read error" ],
   "IILB_FIFO_UNDERFLOW"          => [  16,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow" ],
   "IILB_FIFO_OVERFLOW"           => [  17,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow" ],
   "IILB_CREDIT_UNDERFLOW"        => [  18,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB credit underflow" ],
   "IILB_CREDIT_OVERFLOW"         => [  19,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB credit overflow" ],
   "IILB_DEBIT_UNDERFLOW"         => [  20,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "IILB debit underflow" ],
   "IILB_DEBIT_OVERFLOW"          => [  21,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "IILB debit overflow" ],
   "NI1_LLP_ERROR"                => [  22,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI1 llp error" ],
   "NI1_PIPE_ERROR"               => [  23,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 pipe in/out error" ],
   "NI1_FIFO_UNDERFLOW"           => [  24,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 fifo underflow" ],
   "NI1_FIFO_OVERFLOW"            => [  25,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI1 fifo overflow" ],
   "NI1_CREDIT_UNDERFLOW"         => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI1 credit underflow" ],
   "NI1_CREDIT_OVERFLOW"          => [  27,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "NI1 credit overflow" ],
   "NI1_DEBIT_UNDERFLOW"          => [  28,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 debit underflow" ],
   "NI1_DEBIT_OVERFLOW"           => [  29,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 debit overflow" ],
   "NI0_LLP_ERROR"                => [  30,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI0 llp error" ],
   "NI0_PIPE_ERROR"               => [  31,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI0 Pipe in/out errors" ],
   "NI0_FIFO_UNDERFLOW"           => [  32,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 fifo underflow" ],
   "NI0_FIFO_OVERFLOW"            => [  33,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 fifo overflow" ],
   "NI0_CREDIT_UNDERFLOW"         => [  34,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 credit underflow" ],
   "NI0_CREDIT_OVERFLOW"          => [  35,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 credit overflow" ],
   "NI0_DEBIT_UNDERFLOW"          => [  36,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "NI0 debit underflow" ],
   "NI0_DEBIT_OVERFLOW"           => [  37,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "NI0 debit overflow" ],
);

%shub2_01_01145_def =
( NAME    => "SH2_XN_ERROR_OVERFLOW_ALIAS",
  ADDRESS => 0x0000000050040028,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01145_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_ERROR_MASK                                                    #
#                                                                        #
##########################################################################

%shub2_01_01146_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  37,  27, 0xFFFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XNPI_LUT_ERROR"               => [   1,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "XNPI look up table error" ],
   "XNPI_DEBIT_OVERFLOW"          => [   2,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "XNPI debit overflow" ],
   "XNPI_FIFO_UNDERFLOW"          => [   3,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "XNPI fifo underflow" ],
   "XNPI_FIFO_OVERFLOW"           => [   4,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "XNPI fifo overflow" ],
   "XNPI_CREDIT_UNDERFLOW"        => [   5,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "XNPI credit underflow" ],
   "XNPI_CREDIT_OVERFLOW"         => [   6,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "XNPI credit overflow" ],
   "XNMD_LUT_ERROR"               => [   7,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "XNMD look up table error" ],
   "XNMD_DEBIT_OVERFLOW"          => [   8,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "XNMD debit overflow" ],
   "XNMD_FIFO_UNDERFLOW"          => [   9,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "XNMD fifo underflow" ],
   "XNMD_FIFO_OVERFLOW"           => [  10,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "XNMD fifo overflow" ],
   "XNMD_CREDIT_UNDERFLOW"        => [  11,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "XNMD credit underflow" ],
   "XNMD_CREDIT_OVERFLOW"         => [  12,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "XNMD credit overflow" ],
   "XNMD_UCE_ERROR"               => [  13,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "XNMD uncorrectable error" ],
   "XNMD_SBE_ERROR"               => [  14,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "XNMD single bit error" ],
   "IILB_CHIPLET_OR_LUT"          => [  15,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "IILB chiplet nomatch or lut read error" ],
   "IILB_FIFO_UNDERFLOW"          => [  16,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "IILB fifo underflow" ],
   "IILB_FIFO_OVERFLOW"           => [  17,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "IILB fifo overflow" ],
   "IILB_CREDIT_UNDERFLOW"        => [  18,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "IILB credit underflow" ],
   "IILB_CREDIT_OVERFLOW"         => [  19,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "IILB credit overflow" ],
   "IILB_DEBIT_UNDERFLOW"         => [  20,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "IILB debit underflow" ],
   "IILB_DEBIT_OVERFLOW"          => [  21,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "IILB debit overflow" ],
   "NI1_LLP_ERROR"                => [  22,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "NI1 llp error" ],
   "NI1_PIPE_ERROR"               => [  23,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "NI1 pipe in/out error" ],
   "NI1_FIFO_UNDERFLOW"           => [  24,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "NI1 fifo underflow" ],
   "NI1_FIFO_OVERFLOW"            => [  25,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "NI1 fifo overflow" ],
   "NI1_CREDIT_UNDERFLOW"         => [  26,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "NI1 credit underflow" ],
   "NI1_CREDIT_OVERFLOW"          => [  27,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "NI1 credit overflow" ],
   "NI1_DEBIT_UNDERFLOW"          => [  28,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "NI1 debit underflow" ],
   "NI1_DEBIT_OVERFLOW"           => [  29,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "NI1 debit overflow" ],
   "NI0_LLP_ERROR"                => [  30,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "NI0 llp error" ],
   "NI0_PIPE_ERROR"               => [  31,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "NI0 Pipe in/out errors" ],
   "NI0_FIFO_UNDERFLOW"           => [  32,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "NI0 fifo underflow" ],
   "NI0_FIFO_OVERFLOW"            => [  33,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "NI0 fifo overflow" ],
   "NI0_CREDIT_UNDERFLOW"         => [  34,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "NI0 credit underflow" ],
   "NI0_CREDIT_OVERFLOW"          => [  35,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "NI0 credit overflow" ],
   "NI0_DEBIT_UNDERFLOW"          => [  36,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "NI0 debit underflow" ],
   "NI0_DEBIT_OVERFLOW"           => [  37,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "NI0 debit overflow" ],
);

%shub2_01_01146_def =
( NAME    => "SH2_XN_ERROR_MASK",
  ADDRESS => 0x0000000050040040,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01146_flds
);


##########################################################################
#                                                                        #
#   SH2_XN_FIRST_ERROR                                                   #
#                                                                        #
##########################################################################

%shub2_01_01147_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  37,  27, 0xFFFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XNPI_LUT_ERROR"               => [   1,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "XNPI look up table error" ],
   "XNPI_DEBIT_OVERFLOW"          => [   2,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "XNPI debit overflow" ],
   "XNPI_FIFO_UNDERFLOW"          => [   3,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "XNPI fifo underflow" ],
   "XNPI_FIFO_OVERFLOW"           => [   4,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "XNPI fifo overflow" ],
   "XNPI_CREDIT_UNDERFLOW"        => [   5,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "XNPI credit underflow" ],
   "XNPI_CREDIT_OVERFLOW"         => [   6,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "XNPI credit overflow" ],
   "XNMD_LUT_ERROR"               => [   7,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "XNMD look up table error" ],
   "XNMD_DEBIT_OVERFLOW"          => [   8,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "XNMD debit overflow" ],
   "XNMD_FIFO_UNDERFLOW"          => [   9,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "XNMD fifo underflow" ],
   "XNMD_FIFO_OVERFLOW"           => [  10,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "XNMD fifo overflow" ],
   "XNMD_CREDIT_UNDERFLOW"        => [  11,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "XNMD credit underflow" ],
   "XNMD_CREDIT_OVERFLOW"         => [  12,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "XNMD credit overflow" ],
   "XNMD_UCE_ERROR"               => [  13,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "XNMD uncorrectable error" ],
   "XNMD_SBE_ERROR"               => [  14,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "XNMD single bit error" ],
   "IILB_CHIPLET_OR_LUT"          => [  15,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB chiplet nomatch or lut read error" ],
   "IILB_FIFO_UNDERFLOW"          => [  16,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow" ],
   "IILB_FIFO_OVERFLOW"           => [  17,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow" ],
   "IILB_CREDIT_UNDERFLOW"        => [  18,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB credit underflow" ],
   "IILB_CREDIT_OVERFLOW"         => [  19,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB credit overflow" ],
   "IILB_DEBIT_UNDERFLOW"         => [  20,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "IILB debit underflow" ],
   "IILB_DEBIT_OVERFLOW"          => [  21,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "IILB debit overflow" ],
   "NI1_LLP_ERROR"                => [  22,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI1 llp error" ],
   "NI1_PIPE_ERROR"               => [  23,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 pipe in/out error" ],
   "NI1_FIFO_UNDERFLOW"           => [  24,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 fifo underflow" ],
   "NI1_FIFO_OVERFLOW"            => [  25,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI1 fifo overflow" ],
   "NI1_CREDIT_UNDERFLOW"         => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI1 credit underflow" ],
   "NI1_CREDIT_OVERFLOW"          => [  27,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "NI1 credit overflow" ],
   "NI1_DEBIT_UNDERFLOW"          => [  28,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 debit underflow" ],
   "NI1_DEBIT_OVERFLOW"           => [  29,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 debit overflow" ],
   "NI0_LLP_ERROR"                => [  30,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI0 llp error" ],
   "NI0_PIPE_ERROR"               => [  31,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI0 Pipe in/out errors" ],
   "NI0_FIFO_UNDERFLOW"           => [  32,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 fifo underflow" ],
   "NI0_FIFO_OVERFLOW"            => [  33,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 fifo overflow" ],
   "NI0_CREDIT_UNDERFLOW"         => [  34,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 credit underflow" ],
   "NI0_CREDIT_OVERFLOW"          => [  35,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 credit overflow" ],
   "NI0_DEBIT_UNDERFLOW"          => [  36,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "NI0 debit underflow" ],
   "NI0_DEBIT_OVERFLOW"           => [  37,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "NI0 debit overflow" ],
);

%shub2_01_01147_def =
( NAME    => "SH2_XN_FIRST_ERROR",
  ADDRESS => 0x0000000050040060,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01147_flds
);


##########################################################################
#                                                                        #
#   SH2_XNIILB_ERROR_SUMMARY                                             #
#                                                                        #
##########################################################################

%shub2_01_01148_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_LB_FAST_TAIL"        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail overflow" ],
   "OVERFLOW_II_FAST_TAIL"        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "II fast tail overflow" ],
   "OVERFLOW_MD_DATA_FAST_TAIL"   => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "MD data fast tail overflow" ],
   "OVERFLOW_MD_HDR_FAST_TAIL"    => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail overflow" ],
   "OVERFLOW_PI_DATA_FAST_TAIL"   => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail overflow" ],
   "OVERFLOW_PI_HDR_FAST_TAIL"    => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail overflow" ],
   "OVERFLOW_NI1_FAST_TAIL"       => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail overflow" ],
   "OVERFLOW_NI0_FAST_TAIL"       => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail overflow" ],
   "OVERFLOW_IILB_FAST_TAIL"      => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "OVERFLOW_LB_DEBIT2"           => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "LB VC2 debit overflow" ],
   "OVERFLOW_LB_DEBIT0"           => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "LB VC0 debit overflow" ],
   "OVERFLOW_II_DEBIT2"           => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "II VC2 debit overflow" ],
   "OVERFLOW_II_DEBIT0"           => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "II VC0 debit overflow" ],
   "OVERFLOW_MD_DEBIT2"           => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "MD VC2 fifo debit overflow" ],
   "OVERFLOW_MD_DEBIT0"           => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 fifo debit overflow" ],
   "OVERFLOW_PI_DEBIT2"           => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "PI VC2 fifo debit overflow" ],
   "OVERFLOW_PI_DEBIT0"           => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "PI VC0 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT3"          => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo debit overflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo debit overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo debit overflow" ],
   "OVERFLOW_LB_VC2_CREDIT_OUT"   => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "LB VC2 fifo overflow" ],
   "OVERFLOW_LB_VC0_CREDIT_OUT"   => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "LB VC0 fifo overflow" ],
   "OVERFLOW_II_VC2_CREDIT_OUT"   => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "II VC2 fifo overflow" ],
   "OVERFLOW_II_VC0_CREDIT_OUT"   => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "II VC0 fifo overflow" ],
   "OVERFLOW_MD_VC2_CREDIT_IN"    => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "MD VC2 credit overflow" ],
   "OVERFLOW_MD_VC0_CREDIT_IN"    => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "MD VC0 credit overflow" ],
   "OVERFLOW_PI_VC2_CREDIT_IN"    => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI VC2 credit overflow" ],
   "OVERFLOW_PI_VC0_CREDIT_IN"    => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "PI VC0 credit overflow" ],
   "OVERFLOW_NI1_VC2_CREDIT_IN"   => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit overflow" ],
   "OVERFLOW_NI1_VC0_CREDIT_IN"   => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit overflow" ],
   "OVERFLOW_NI0_VC2_CREDIT_IN"   => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit overflow" ],
   "OVERFLOW_NI0_VC0_CREDIT_IN"   => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT_IN"  => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit overflow" ],
   "OVERFLOW_IILB_VC0_CREDIT_IN"  => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit overflow" ],
   "OVERFLOW_LB_VC2"              => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "LB VC2 credit overflow" ],
   "OVERFLOW_LB_VC0"              => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "LB VC0 credit overflow" ],
   "OVERFLOW_II_VC2"              => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "II VC2 credit overflow" ],
   "OVERFLOW_II_VC0"              => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "II VC0 credit overflow" ],
   "OVERFLOW_MD_DATA_VC2_CREDIT_OUT" => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD VC0 data fifo overflow" ],
   "OVERFLOW_MD_DATA_VC0_CREDIT_OUT" => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD VC0 data fifo overflow" ],
   "OVERFLOW_MD_HDR_VC2_CREDIT_OUT" => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD VC0 hdr fifo overflow" ],
   "OVERFLOW_MD_HDR_VC0_CREDIT_OUT" => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD VC0 hdr fifo overflow" ],
   "OVERFLOW_PI_DATA_VC2_CREDIT_OUT" => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI VC2 data fifo overflow" ],
   "OVERFLOW_PI_DATA_VC0_CREDIT_OUT" => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI VC0 data fifo overflow" ],
   "OVERFLOW_PI_HDR_VC2_CREDIT_OUT" => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI VC2 hdr fifo overflow" ],
   "OVERFLOW_PI_HDR_VC0_CREDIT_OUT" => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI VC0 hdr fifo overflow" ],
   "OVERFLOW_NI1_VC3_CREDIT_OUT"  => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo overflow" ],
   "OVERFLOW_NI1_VC2_CREDIT_OUT"  => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo overflow" ],
   "OVERFLOW_NI1_VC1_CREDIT_OUT"  => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo overflow" ],
   "OVERFLOW_NI1_VC0_CREDIT_OUT"  => [  57,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo overflow" ],
   "OVERFLOW_NI0_VC3_CREDIT_OUT"  => [  58,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo overflow" ],
   "OVERFLOW_NI0_VC2_CREDIT_OUT"  => [  59,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo overflow" ],
   "OVERFLOW_NI0_VC1_CREDIT_OUT"  => [  60,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo overflow" ],
   "OVERFLOW_NI0_VC0_CREDIT_OUT"  => [  61,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT_OUT" => [  62,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo overflow" ],
   "OVERFLOW_IILB_VC0_CREDIT_OUT" => [  63,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo overflow" ],
);

%shub2_01_01148_def =
( NAME    => "SH2_XNIILB_ERROR_SUMMARY",
  ADDRESS => 0x0000000050040200,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01148_flds
);


##########################################################################
#                                                                        #
#   SH2_XNIILB_ERROR_SUMMARY_ALIAS                                       #
#                                                                        #
##########################################################################

%shub2_01_01149_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_LB_FAST_TAIL"        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail overflow" ],
   "OVERFLOW_II_FAST_TAIL"        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "II fast tail overflow" ],
   "OVERFLOW_MD_DATA_FAST_TAIL"   => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "MD data fast tail overflow" ],
   "OVERFLOW_MD_HDR_FAST_TAIL"    => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail overflow" ],
   "OVERFLOW_PI_DATA_FAST_TAIL"   => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail overflow" ],
   "OVERFLOW_PI_HDR_FAST_TAIL"    => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail overflow" ],
   "OVERFLOW_NI1_FAST_TAIL"       => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail overflow" ],
   "OVERFLOW_NI0_FAST_TAIL"       => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail overflow" ],
   "OVERFLOW_IILB_FAST_TAIL"      => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "OVERFLOW_LB_DEBIT2"           => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "LB VC2 debit overflow" ],
   "OVERFLOW_LB_DEBIT0"           => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "LB VC0 debit overflow" ],
   "OVERFLOW_II_DEBIT2"           => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "II VC2 debit overflow" ],
   "OVERFLOW_II_DEBIT0"           => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "II VC0 debit overflow" ],
   "OVERFLOW_MD_DEBIT2"           => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "MD VC2 fifo debit overflow" ],
   "OVERFLOW_MD_DEBIT0"           => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 fifo debit overflow" ],
   "OVERFLOW_PI_DEBIT2"           => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "PI VC2 fifo debit overflow" ],
   "OVERFLOW_PI_DEBIT0"           => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "PI VC0 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT3"          => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo debit overflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo debit overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo debit overflow" ],
   "OVERFLOW_LB_VC2_CREDIT_OUT"   => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "LB VC2 fifo overflow" ],
   "OVERFLOW_LB_VC0_CREDIT_OUT"   => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "LB VC0 fifo overflow" ],
   "OVERFLOW_II_VC2_CREDIT_OUT"   => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "II VC2 fifo overflow" ],
   "OVERFLOW_II_VC0_CREDIT_OUT"   => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "II VC0 fifo overflow" ],
   "OVERFLOW_MD_VC2_CREDIT_IN"    => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "MD VC2 credit overflow" ],
   "OVERFLOW_MD_VC0_CREDIT_IN"    => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "MD VC0 credit overflow" ],
   "OVERFLOW_PI_VC2_CREDIT_IN"    => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI VC2 credit overflow" ],
   "OVERFLOW_PI_VC0_CREDIT_IN"    => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "PI VC0 credit overflow" ],
   "OVERFLOW_NI1_VC2_CREDIT_IN"   => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit overflow" ],
   "OVERFLOW_NI1_VC0_CREDIT_IN"   => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit overflow" ],
   "OVERFLOW_NI0_VC2_CREDIT_IN"   => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit overflow" ],
   "OVERFLOW_NI0_VC0_CREDIT_IN"   => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT_IN"  => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit overflow" ],
   "OVERFLOW_IILB_VC0_CREDIT_IN"  => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit overflow" ],
   "OVERFLOW_LB_VC2"              => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "LB VC2 credit overflow" ],
   "OVERFLOW_LB_VC0"              => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "LB VC0 credit overflow" ],
   "OVERFLOW_II_VC2"              => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "II VC2 credit overflow" ],
   "OVERFLOW_II_VC0"              => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "II VC0 credit overflow" ],
   "OVERFLOW_MD_DATA_VC2_CREDIT_OUT" => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD VC0 data fifo overflow" ],
   "OVERFLOW_MD_DATA_VC0_CREDIT_OUT" => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD VC0 data fifo overflow" ],
   "OVERFLOW_MD_HDR_VC2_CREDIT_OUT" => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD VC0 hdr fifo overflow" ],
   "OVERFLOW_MD_HDR_VC0_CREDIT_OUT" => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD VC0 hdr fifo overflow" ],
   "OVERFLOW_PI_DATA_VC2_CREDIT_OUT" => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI VC2 data fifo overflow" ],
   "OVERFLOW_PI_DATA_VC0_CREDIT_OUT" => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI VC0 data fifo overflow" ],
   "OVERFLOW_PI_HDR_VC2_CREDIT_OUT" => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI VC2 hdr fifo overflow" ],
   "OVERFLOW_PI_HDR_VC0_CREDIT_OUT" => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI VC0 hdr fifo overflow" ],
   "OVERFLOW_NI1_VC3_CREDIT_OUT"  => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo overflow" ],
   "OVERFLOW_NI1_VC2_CREDIT_OUT"  => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo overflow" ],
   "OVERFLOW_NI1_VC1_CREDIT_OUT"  => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo overflow" ],
   "OVERFLOW_NI1_VC0_CREDIT_OUT"  => [  57,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo overflow" ],
   "OVERFLOW_NI0_VC3_CREDIT_OUT"  => [  58,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo overflow" ],
   "OVERFLOW_NI0_VC2_CREDIT_OUT"  => [  59,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo overflow" ],
   "OVERFLOW_NI0_VC1_CREDIT_OUT"  => [  60,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo overflow" ],
   "OVERFLOW_NI0_VC0_CREDIT_OUT"  => [  61,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT_OUT" => [  62,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo overflow" ],
   "OVERFLOW_IILB_VC0_CREDIT_OUT" => [  63,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo overflow" ],
);

%shub2_01_01149_def =
( NAME    => "SH2_XNIILB_ERROR_SUMMARY_ALIAS",
  ADDRESS => 0x0000000050040208,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01149_flds
);


##########################################################################
#                                                                        #
#   SH2_XNIILB_ERROR_OVERFLOW                                            #
#                                                                        #
##########################################################################

%shub2_01_01150_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_LB_FAST_TAIL"        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail overflow" ],
   "OVERFLOW_II_FAST_TAIL"        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "II fast tail overflow" ],
   "OVERFLOW_MD_DATA_FAST_TAIL"   => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "MD data fast tail overflow" ],
   "OVERFLOW_MD_HDR_FAST_TAIL"    => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail overflow" ],
   "OVERFLOW_PI_DATA_FAST_TAIL"   => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail overflow" ],
   "OVERFLOW_PI_HDR_FAST_TAIL"    => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail overflow" ],
   "OVERFLOW_NI1_FAST_TAIL"       => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail overflow" ],
   "OVERFLOW_NI0_FAST_TAIL"       => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail overflow" ],
   "OVERFLOW_IILB_FAST_TAIL"      => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "OVERFLOW_LB_DEBIT2"           => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "LB VC2 debit overflow" ],
   "OVERFLOW_LB_DEBIT0"           => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "LB VC0 debit overflow" ],
   "OVERFLOW_II_DEBIT2"           => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "II VC2 debit overflow" ],
   "OVERFLOW_II_DEBIT0"           => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "II VC0 debit overflow" ],
   "OVERFLOW_MD_DEBIT2"           => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "MD VC2 fifo debit overflow" ],
   "OVERFLOW_MD_DEBIT0"           => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 fifo debit overflow" ],
   "OVERFLOW_PI_DEBIT2"           => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "PI VC2 fifo debit overflow" ],
   "OVERFLOW_PI_DEBIT0"           => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "PI VC0 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT3"          => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo debit overflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo debit overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo debit overflow" ],
   "OVERFLOW_LB_VC2_CREDIT_OUT"   => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "LB VC2 fifo overflow" ],
   "OVERFLOW_LB_VC0_CREDIT_OUT"   => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "LB VC0 fifo overflow" ],
   "OVERFLOW_II_VC2_CREDIT_OUT"   => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "II VC2 fifo overflow" ],
   "OVERFLOW_II_VC0_CREDIT_OUT"   => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "II VC0 fifo overflow" ],
   "OVERFLOW_MD_VC2_CREDIT_IN"    => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "MD VC2 credit overflow" ],
   "OVERFLOW_MD_VC0_CREDIT_IN"    => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "MD VC0 credit overflow" ],
   "OVERFLOW_PI_VC2_CREDIT_IN"    => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI VC2 credit overflow" ],
   "OVERFLOW_PI_VC0_CREDIT_IN"    => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "PI VC0 credit overflow" ],
   "OVERFLOW_NI1_VC2_CREDIT_IN"   => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit overflow" ],
   "OVERFLOW_NI1_VC0_CREDIT_IN"   => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit overflow" ],
   "OVERFLOW_NI0_VC2_CREDIT_IN"   => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit overflow" ],
   "OVERFLOW_NI0_VC0_CREDIT_IN"   => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT_IN"  => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit overflow" ],
   "OVERFLOW_IILB_VC0_CREDIT_IN"  => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit overflow" ],
   "OVERFLOW_LB_VC2"              => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "LB VC2 credit overflow" ],
   "OVERFLOW_LB_VC0"              => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "LB VC0 credit overflow" ],
   "OVERFLOW_II_VC2"              => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "II VC2 credit overflow" ],
   "OVERFLOW_II_VC0"              => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "II VC0 credit overflow" ],
   "OVERFLOW_MD_DATA_VC2_CREDIT_OUT" => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD VC0 data fifo overflow" ],
   "OVERFLOW_MD_DATA_VC0_CREDIT_OUT" => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD VC0 data fifo overflow" ],
   "OVERFLOW_MD_HDR_VC2_CREDIT_OUT" => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD VC0 hdr fifo overflow" ],
   "OVERFLOW_MD_HDR_VC0_CREDIT_OUT" => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD VC0 hdr fifo overflow" ],
   "OVERFLOW_PI_DATA_VC2_CREDIT_OUT" => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI VC2 data fifo overflow" ],
   "OVERFLOW_PI_DATA_VC0_CREDIT_OUT" => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI VC0 data fifo overflow" ],
   "OVERFLOW_PI_HDR_VC2_CREDIT_OUT" => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI VC2 hdr fifo overflow" ],
   "OVERFLOW_PI_HDR_VC0_CREDIT_OUT" => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI VC0 hdr fifo overflow" ],
   "OVERFLOW_NI1_VC3_CREDIT_OUT"  => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo overflow" ],
   "OVERFLOW_NI1_VC2_CREDIT_OUT"  => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo overflow" ],
   "OVERFLOW_NI1_VC1_CREDIT_OUT"  => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo overflow" ],
   "OVERFLOW_NI1_VC0_CREDIT_OUT"  => [  57,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo overflow" ],
   "OVERFLOW_NI0_VC3_CREDIT_OUT"  => [  58,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo overflow" ],
   "OVERFLOW_NI0_VC2_CREDIT_OUT"  => [  59,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo overflow" ],
   "OVERFLOW_NI0_VC1_CREDIT_OUT"  => [  60,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo overflow" ],
   "OVERFLOW_NI0_VC0_CREDIT_OUT"  => [  61,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT_OUT" => [  62,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo overflow" ],
   "OVERFLOW_IILB_VC0_CREDIT_OUT" => [  63,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo overflow" ],
);

%shub2_01_01150_def =
( NAME    => "SH2_XNIILB_ERROR_OVERFLOW",
  ADDRESS => 0x0000000050040220,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01150_flds
);


##########################################################################
#                                                                        #
#   SH2_XNIILB_ERROR_OVERFLOW_ALIAS                                      #
#                                                                        #
##########################################################################

%shub2_01_01151_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_LB_FAST_TAIL"        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail overflow" ],
   "OVERFLOW_II_FAST_TAIL"        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "II fast tail overflow" ],
   "OVERFLOW_MD_DATA_FAST_TAIL"   => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "MD data fast tail overflow" ],
   "OVERFLOW_MD_HDR_FAST_TAIL"    => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail overflow" ],
   "OVERFLOW_PI_DATA_FAST_TAIL"   => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail overflow" ],
   "OVERFLOW_PI_HDR_FAST_TAIL"    => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail overflow" ],
   "OVERFLOW_NI1_FAST_TAIL"       => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail overflow" ],
   "OVERFLOW_NI0_FAST_TAIL"       => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail overflow" ],
   "OVERFLOW_IILB_FAST_TAIL"      => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "OVERFLOW_LB_DEBIT2"           => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "LB VC2 debit overflow" ],
   "OVERFLOW_LB_DEBIT0"           => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "LB VC0 debit overflow" ],
   "OVERFLOW_II_DEBIT2"           => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "II VC2 debit overflow" ],
   "OVERFLOW_II_DEBIT0"           => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "II VC0 debit overflow" ],
   "OVERFLOW_MD_DEBIT2"           => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "MD VC2 fifo debit overflow" ],
   "OVERFLOW_MD_DEBIT0"           => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 fifo debit overflow" ],
   "OVERFLOW_PI_DEBIT2"           => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "PI VC2 fifo debit overflow" ],
   "OVERFLOW_PI_DEBIT0"           => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "PI VC0 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT3"          => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo debit overflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo debit overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo debit overflow" ],
   "OVERFLOW_LB_VC2_CREDIT_OUT"   => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "LB VC2 fifo overflow" ],
   "OVERFLOW_LB_VC0_CREDIT_OUT"   => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "LB VC0 fifo overflow" ],
   "OVERFLOW_II_VC2_CREDIT_OUT"   => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "II VC2 fifo overflow" ],
   "OVERFLOW_II_VC0_CREDIT_OUT"   => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "II VC0 fifo overflow" ],
   "OVERFLOW_MD_VC2_CREDIT_IN"    => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "MD VC2 credit overflow" ],
   "OVERFLOW_MD_VC0_CREDIT_IN"    => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "MD VC0 credit overflow" ],
   "OVERFLOW_PI_VC2_CREDIT_IN"    => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI VC2 credit overflow" ],
   "OVERFLOW_PI_VC0_CREDIT_IN"    => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "PI VC0 credit overflow" ],
   "OVERFLOW_NI1_VC2_CREDIT_IN"   => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit overflow" ],
   "OVERFLOW_NI1_VC0_CREDIT_IN"   => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit overflow" ],
   "OVERFLOW_NI0_VC2_CREDIT_IN"   => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit overflow" ],
   "OVERFLOW_NI0_VC0_CREDIT_IN"   => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT_IN"  => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit overflow" ],
   "OVERFLOW_IILB_VC0_CREDIT_IN"  => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit overflow" ],
   "OVERFLOW_LB_VC2"              => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "LB VC2 credit overflow" ],
   "OVERFLOW_LB_VC0"              => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "LB VC0 credit overflow" ],
   "OVERFLOW_II_VC2"              => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "II VC2 credit overflow" ],
   "OVERFLOW_II_VC0"              => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "II VC0 credit overflow" ],
   "OVERFLOW_MD_DATA_VC2_CREDIT_OUT" => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD VC0 data fifo overflow" ],
   "OVERFLOW_MD_DATA_VC0_CREDIT_OUT" => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD VC0 data fifo overflow" ],
   "OVERFLOW_MD_HDR_VC2_CREDIT_OUT" => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD VC0 hdr fifo overflow" ],
   "OVERFLOW_MD_HDR_VC0_CREDIT_OUT" => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD VC0 hdr fifo overflow" ],
   "OVERFLOW_PI_DATA_VC2_CREDIT_OUT" => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI VC2 data fifo overflow" ],
   "OVERFLOW_PI_DATA_VC0_CREDIT_OUT" => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI VC0 data fifo overflow" ],
   "OVERFLOW_PI_HDR_VC2_CREDIT_OUT" => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI VC2 hdr fifo overflow" ],
   "OVERFLOW_PI_HDR_VC0_CREDIT_OUT" => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI VC0 hdr fifo overflow" ],
   "OVERFLOW_NI1_VC3_CREDIT_OUT"  => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo overflow" ],
   "OVERFLOW_NI1_VC2_CREDIT_OUT"  => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo overflow" ],
   "OVERFLOW_NI1_VC1_CREDIT_OUT"  => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo overflow" ],
   "OVERFLOW_NI1_VC0_CREDIT_OUT"  => [  57,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo overflow" ],
   "OVERFLOW_NI0_VC3_CREDIT_OUT"  => [  58,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo overflow" ],
   "OVERFLOW_NI0_VC2_CREDIT_OUT"  => [  59,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo overflow" ],
   "OVERFLOW_NI0_VC1_CREDIT_OUT"  => [  60,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo overflow" ],
   "OVERFLOW_NI0_VC0_CREDIT_OUT"  => [  61,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT_OUT" => [  62,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo overflow" ],
   "OVERFLOW_IILB_VC0_CREDIT_OUT" => [  63,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo overflow" ],
);

%shub2_01_01151_def =
( NAME    => "SH2_XNIILB_ERROR_OVERFLOW_ALIAS",
  ADDRESS => 0x0000000050040228,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01151_flds
);


##########################################################################
#                                                                        #
#   SH2_XNIILB_ERROR_MASK                                                #
#                                                                        #
##########################################################################

%shub2_01_01152_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_LB_FAST_TAIL"        => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "LB fast tail overflow" ],
   "OVERFLOW_II_FAST_TAIL"        => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "II fast tail overflow" ],
   "OVERFLOW_MD_DATA_FAST_TAIL"   => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "MD data fast tail overflow" ],
   "OVERFLOW_MD_HDR_FAST_TAIL"    => [   4,  59,   1, 0x0800000000000000, 0x00, 1, 0x0000000000000000, "MD hdr fast tail overflow" ],
   "OVERFLOW_PI_DATA_FAST_TAIL"   => [   5,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "PI data fast tail overflow" ],
   "OVERFLOW_PI_HDR_FAST_TAIL"    => [   6,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "PI hdr fast tail overflow" ],
   "OVERFLOW_NI1_FAST_TAIL"       => [   7,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "NI1 fast tail overflow" ],
   "OVERFLOW_NI0_FAST_TAIL"       => [   8,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "NI0 fast tail overflow" ],
   "OVERFLOW_IILB_FAST_TAIL"      => [   9,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "IILB fast tail overflow" ],
   "OVERFLOW_LB_DEBIT2"           => [  10,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "LB VC2 debit overflow" ],
   "OVERFLOW_LB_DEBIT0"           => [  11,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "LB VC0 debit overflow" ],
   "OVERFLOW_II_DEBIT2"           => [  12,  51,   1, 0x0008000000000000, 0x00, 1, 0x0000000000000000, "II VC2 debit overflow" ],
   "OVERFLOW_II_DEBIT0"           => [  13,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "II VC0 debit overflow" ],
   "OVERFLOW_MD_DEBIT2"           => [  14,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "MD VC2 fifo debit overflow" ],
   "OVERFLOW_MD_DEBIT0"           => [  15,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "MD VC0 fifo debit overflow" ],
   "OVERFLOW_PI_DEBIT2"           => [  16,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "PI VC2 fifo debit overflow" ],
   "OVERFLOW_PI_DEBIT0"           => [  17,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "PI VC0 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT3"          => [  18,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "NI1 VC3 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  19,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "NI1 VC2 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  20,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "NI1 VC1 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  21,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "NI1 VC0 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  22,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "NI0 VC3 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  23,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "NI0 VC2 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  24,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "NI0 VC1 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  25,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "NI0 VC0 fifo debit overflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  26,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "IILB VC2 fifo debit overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  27,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "IILB VC0 fifo debit overflow" ],
   "OVERFLOW_LB_VC2_CREDIT_OUT"   => [  28,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "LB VC2 fifo overflow" ],
   "OVERFLOW_LB_VC0_CREDIT_OUT"   => [  29,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "LB VC0 fifo overflow" ],
   "OVERFLOW_II_VC2_CREDIT_OUT"   => [  30,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "II VC2 fifo overflow" ],
   "OVERFLOW_II_VC0_CREDIT_OUT"   => [  31,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "II VC0 fifo overflow" ],
   "OVERFLOW_MD_VC2_CREDIT_IN"    => [  32,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "MD VC2 credit overflow" ],
   "OVERFLOW_MD_VC0_CREDIT_IN"    => [  33,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "MD VC0 credit overflow" ],
   "OVERFLOW_PI_VC2_CREDIT_IN"    => [  34,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "PI VC2 credit overflow" ],
   "OVERFLOW_PI_VC0_CREDIT_IN"    => [  35,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "PI VC0 credit overflow" ],
   "OVERFLOW_NI1_VC2_CREDIT_IN"   => [  36,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "NI1 VC2 credit overflow" ],
   "OVERFLOW_NI1_VC0_CREDIT_IN"   => [  37,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "NI1 VC0 credit overflow" ],
   "OVERFLOW_NI0_VC2_CREDIT_IN"   => [  38,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "NI0 VC2 credit overflow" ],
   "OVERFLOW_NI0_VC0_CREDIT_IN"   => [  39,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "NI0 VC0 credit overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT_IN"  => [  40,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "IILB VC2 credit overflow" ],
   "OVERFLOW_IILB_VC0_CREDIT_IN"  => [  41,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "IILB VC0 credit overflow" ],
   "OVERFLOW_LB_VC2"              => [  42,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "LB VC2 credit overflow" ],
   "OVERFLOW_LB_VC0"              => [  43,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "LB VC0 credit overflow" ],
   "OVERFLOW_II_VC2"              => [  44,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "II VC2 credit overflow" ],
   "OVERFLOW_II_VC0"              => [  45,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "II VC0 credit overflow" ],
   "OVERFLOW_MD_DATA_VC2_CREDIT_OUT" => [  46,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "MD VC0 data fifo overflow" ],
   "OVERFLOW_MD_DATA_VC0_CREDIT_OUT" => [  47,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "MD VC0 data fifo overflow" ],
   "OVERFLOW_MD_HDR_VC2_CREDIT_OUT" => [  48,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "MD VC0 hdr fifo overflow" ],
   "OVERFLOW_MD_HDR_VC0_CREDIT_OUT" => [  49,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "MD VC0 hdr fifo overflow" ],
   "OVERFLOW_PI_DATA_VC2_CREDIT_OUT" => [  50,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "PI VC2 data fifo overflow" ],
   "OVERFLOW_PI_DATA_VC0_CREDIT_OUT" => [  51,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "PI VC0 data fifo overflow" ],
   "OVERFLOW_PI_HDR_VC2_CREDIT_OUT" => [  52,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "PI VC2 hdr fifo overflow" ],
   "OVERFLOW_PI_HDR_VC0_CREDIT_OUT" => [  53,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "PI VC0 hdr fifo overflow" ],
   "OVERFLOW_NI1_VC3_CREDIT_OUT"  => [  54,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "NI1 VC3 fifo overflow" ],
   "OVERFLOW_NI1_VC2_CREDIT_OUT"  => [  55,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "NI1 VC2 fifo overflow" ],
   "OVERFLOW_NI1_VC1_CREDIT_OUT"  => [  56,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "NI1 VC1 fifo overflow" ],
   "OVERFLOW_NI1_VC0_CREDIT_OUT"  => [  57,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "NI1 VC0 fifo overflow" ],
   "OVERFLOW_NI0_VC3_CREDIT_OUT"  => [  58,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "NI0 VC3 fifo overflow" ],
   "OVERFLOW_NI0_VC2_CREDIT_OUT"  => [  59,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "NI0 VC2 fifo overflow" ],
   "OVERFLOW_NI0_VC1_CREDIT_OUT"  => [  60,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "NI0 VC1 fifo overflow" ],
   "OVERFLOW_NI0_VC0_CREDIT_OUT"  => [  61,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "NI0 VC0 fifo overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT_OUT" => [  62,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "IILB VC2 fifo overflow" ],
   "OVERFLOW_IILB_VC0_CREDIT_OUT" => [  63,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "IILB VC0 fifo overflow" ],
);

%shub2_01_01152_def =
( NAME    => "SH2_XNIILB_ERROR_MASK",
  ADDRESS => 0x0000000050040240,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01152_flds
);


##########################################################################
#                                                                        #
#   SH2_XNIILB_FIRST_ERROR                                               #
#                                                                        #
##########################################################################

%shub2_01_01153_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_LB_FAST_TAIL"        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail overflow" ],
   "OVERFLOW_II_FAST_TAIL"        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "II fast tail overflow" ],
   "OVERFLOW_MD_DATA_FAST_TAIL"   => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "MD data fast tail overflow" ],
   "OVERFLOW_MD_HDR_FAST_TAIL"    => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail overflow" ],
   "OVERFLOW_PI_DATA_FAST_TAIL"   => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail overflow" ],
   "OVERFLOW_PI_HDR_FAST_TAIL"    => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail overflow" ],
   "OVERFLOW_NI1_FAST_TAIL"       => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail overflow" ],
   "OVERFLOW_NI0_FAST_TAIL"       => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail overflow" ],
   "OVERFLOW_IILB_FAST_TAIL"      => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "OVERFLOW_LB_DEBIT2"           => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "LB VC2 debit overflow" ],
   "OVERFLOW_LB_DEBIT0"           => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "LB VC0 debit overflow" ],
   "OVERFLOW_II_DEBIT2"           => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "II VC2 debit overflow" ],
   "OVERFLOW_II_DEBIT0"           => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "II VC0 debit overflow" ],
   "OVERFLOW_MD_DEBIT2"           => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "MD VC2 fifo debit overflow" ],
   "OVERFLOW_MD_DEBIT0"           => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 fifo debit overflow" ],
   "OVERFLOW_PI_DEBIT2"           => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "PI VC2 fifo debit overflow" ],
   "OVERFLOW_PI_DEBIT0"           => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "PI VC0 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT3"          => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo debit overflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo debit overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo debit overflow" ],
   "OVERFLOW_LB_VC2_CREDIT_OUT"   => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "LB VC2 fifo overflow" ],
   "OVERFLOW_LB_VC0_CREDIT_OUT"   => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "LB VC0 fifo overflow" ],
   "OVERFLOW_II_VC2_CREDIT_OUT"   => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "II VC2 fifo overflow" ],
   "OVERFLOW_II_VC0_CREDIT_OUT"   => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "II VC0 fifo overflow" ],
   "OVERFLOW_MD_VC2_CREDIT_IN"    => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "MD VC2 credit overflow" ],
   "OVERFLOW_MD_VC0_CREDIT_IN"    => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "MD VC0 credit overflow" ],
   "OVERFLOW_PI_VC2_CREDIT_IN"    => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI VC2 credit overflow" ],
   "OVERFLOW_PI_VC0_CREDIT_IN"    => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "PI VC0 credit overflow" ],
   "OVERFLOW_NI1_VC2_CREDIT_IN"   => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit overflow" ],
   "OVERFLOW_NI1_VC0_CREDIT_IN"   => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit overflow" ],
   "OVERFLOW_NI0_VC2_CREDIT_IN"   => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit overflow" ],
   "OVERFLOW_NI0_VC0_CREDIT_IN"   => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT_IN"  => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit overflow" ],
   "OVERFLOW_IILB_VC0_CREDIT_IN"  => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit overflow" ],
   "OVERFLOW_LB_VC2"              => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "LB VC2 credit overflow" ],
   "OVERFLOW_LB_VC0"              => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "LB VC0 credit overflow" ],
   "OVERFLOW_II_VC2"              => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "II VC2 credit overflow" ],
   "OVERFLOW_II_VC0"              => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "II VC0 credit overflow" ],
   "OVERFLOW_MD_DATA_VC2_CREDIT_OUT" => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD VC0 data fifo overflow" ],
   "OVERFLOW_MD_DATA_VC0_CREDIT_OUT" => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD VC0 data fifo overflow" ],
   "OVERFLOW_MD_HDR_VC2_CREDIT_OUT" => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD VC0 hdr fifo overflow" ],
   "OVERFLOW_MD_HDR_VC0_CREDIT_OUT" => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD VC0 hdr fifo overflow" ],
   "OVERFLOW_PI_DATA_VC2_CREDIT_OUT" => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI VC2 data fifo overflow" ],
   "OVERFLOW_PI_DATA_VC0_CREDIT_OUT" => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI VC0 data fifo overflow" ],
   "OVERFLOW_PI_HDR_VC2_CREDIT_OUT" => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI VC2 hdr fifo overflow" ],
   "OVERFLOW_PI_HDR_VC0_CREDIT_OUT" => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI VC0 hdr fifo overflow" ],
   "OVERFLOW_NI1_VC3_CREDIT_OUT"  => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo overflow" ],
   "OVERFLOW_NI1_VC2_CREDIT_OUT"  => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo overflow" ],
   "OVERFLOW_NI1_VC1_CREDIT_OUT"  => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo overflow" ],
   "OVERFLOW_NI1_VC0_CREDIT_OUT"  => [  57,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo overflow" ],
   "OVERFLOW_NI0_VC3_CREDIT_OUT"  => [  58,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo overflow" ],
   "OVERFLOW_NI0_VC2_CREDIT_OUT"  => [  59,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo overflow" ],
   "OVERFLOW_NI0_VC1_CREDIT_OUT"  => [  60,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo overflow" ],
   "OVERFLOW_NI0_VC0_CREDIT_OUT"  => [  61,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT_OUT" => [  62,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo overflow" ],
   "OVERFLOW_IILB_VC0_CREDIT_OUT" => [  63,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo overflow" ],
);

%shub2_01_01153_def =
( NAME    => "SH2_XNIILB_FIRST_ERROR",
  ADDRESS => 0x0000000050040260,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01153_flds
);


##########################################################################
#                                                                        #
#   SH2_XNIILB_ERROR_SUMMARY_1                                           #
#                                                                        #
##########################################################################

%shub2_01_01154_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_READ_ERROR"               => [   1,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [   2,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "ERROR_MD_TAIL_CNT"            => [   3,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "MD tail count error" ],
   "ERROR_PI_TAIL_CNT"            => [   4,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "PI tail count error" ],
   "ERROR_LB_FAST_TAIL"           => [   5,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail error" ],
   "ERROR_II_FAST_TAIL"           => [   6,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "II fast tail error" ],
   "ERROR_MD_FAST_TAIL"           => [   7,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD fast tail error" ],
   "ERROR_PI_FAST_TAIL"           => [   8,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "PI fast tail error" ],
   "ERROR_NI1_FAST_TAIL"          => [   9,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail error" ],
   "ERROR_NI0_FAST_TAIL"          => [  10,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail error" ],
   "ERROR_IILB_FAST_TAIL"         => [  11,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "UNDERFLOW_LB_FAST_TAIL"       => [  12,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail underflow" ],
   "UNDERFLOW_II_FAST_TAIL"       => [  13,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "II fast tail underflow" ],
   "UNDERFLOW_MD_DATA_FAST_TAIL"  => [  14,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "MD data fast tail underflow" ],
   "UNDERFLOW_MD_HDR_FAST_TAIL"   => [  15,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail underflow" ],
   "UNDERFLOW_PI_DATA_FAST_TAIL"  => [  16,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail underflow" ],
   "UNDERFLOW_PI_HDR_FAST_TAIL"   => [  17,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail underflow" ],
   "UNDERFLOW_NI1_FAST_TAIL"      => [  18,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail underflow" ],
   "UNDERFLOW_NI0_FAST_TAIL"      => [  19,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail underflow" ],
   "UNDERFLOW_IILB_FAST_TAIL"     => [  20,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "UNDERFLOW_MD_DEBIT2"          => [  21,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "MD VC2 fifo debit underflow" ],
   "UNDERFLOW_MD_DEBIT0"          => [  22,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "MD VC0 fifo debit underflow" ],
   "UNDERFLOW_PI_DEBIT2"          => [  23,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "PI VC2 fifo debit underflow" ],
   "UNDERFLOW_PI_DEBIT0"          => [  24,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "PI VC0 fifo debit underflow" ],
   "UNDERFLOW_LB_VC2_CREDIT_OUT"  => [  25,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "LB VC2 fifo underflow" ],
   "UNDERFLOW_LB_VC0_CREDIT_OUT"  => [  26,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "LB VC0 fifo underflow" ],
   "UNDERFLOW_II_VC2_CREDIT_OUT"  => [  27,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "II VC2 fifo underflow" ],
   "UNDERFLOW_II_VC0_CREDIT_OUT"  => [  28,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "II VC0 fifo underflow" ],
   "UNDERFLOW_MD_VC2_CREDIT_IN"   => [  29,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "MD VC2 credit underflow" ],
   "UNDERFLOW_MD_VC0_CREDIT_IN"   => [  30,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "MD VC0 credit underflow" ],
   "UNDERFLOW_PI_VC2_CREDIT_IN"   => [  31,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI VC2 credit underflow" ],
   "UNDERFLOW_PI_VC0_CREDIT_IN"   => [  32,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "PI VC0 credit underflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT_IN"  => [  33,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit underflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT_IN"  => [  34,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit underflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT_IN"  => [  35,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit underflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT_IN"  => [  36,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit underflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT_IN" => [  37,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit underflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT_IN" => [  38,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit underflow" ],
   "UNDERFLOW_LB_VC2"             => [  39,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "LB VC2 credit underflow" ],
   "UNDERFLOW_LB_VC0"             => [  40,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "LB VC0 credit underflow" ],
   "UNDERFLOW_II_VC2"             => [  41,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "II VC2 credit underflow" ],
   "UNDERFLOW_II_VC0"             => [  42,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "II VC0 credit underflow" ],
   "UNDERFLOW_MD_DATA_VC2_CREDIT_OUT" => [  43,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD VC2 data fifo underflow" ],
   "UNDERFLOW_MD_DATA_VC0_CREDIT_OUT" => [  44,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD VC0 data fifo underflow" ],
   "UNDERFLOW_MD_HDR_VC2_CREDIT_OUT" => [  45,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD VC2 hdr fifo underflow" ],
   "UNDERFLOW_MD_HDR_VC0_CREDIT_OUT" => [  46,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD VC0 hdr fifo underflow" ],
   "UNDERFLOW_PI_DATA_VC2_CREDIT_OUT" => [  47,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI VC2 data fifo underflow" ],
   "UNDERFLOW_PI_DATA_VC0_CREDIT_OUT" => [  48,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI VC0 data fifo underflow" ],
   "UNDERFLOW_PI_HDR_VC2_CREDIT_OUT" => [  49,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI VC2 hdr fifo underflow" ],
   "UNDERFLOW_PI_HDR_VC0_CREDIT_OUT" => [  50,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI VC0 hdr fifo underflow" ],
   "UNDERFLOW_NI1_VC3_CREDIT_OUT" => [  51,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo underflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT_OUT" => [  52,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo underflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT_OUT" => [  53,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo underflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT_OUT" => [  54,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo underflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT_OUT" => [  55,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo underflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT_OUT" => [  56,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo underflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT_OUT" => [  57,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo underflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT_OUT" => [  58,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo underflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT_OUT" => [  59,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo underflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT_OUT" => [  60,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo underflow" ],
);

%shub2_01_01154_def =
( NAME    => "SH2_XNIILB_ERROR_SUMMARY_1",
  ADDRESS => 0x0000000050040210,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01154_flds
);


##########################################################################
#                                                                        #
#   SH2_XNIILB_ERROR_SUMMARY_ALIAS_1                                     #
#                                                                        #
##########################################################################

%shub2_01_01155_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_READ_ERROR"               => [   1,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [   2,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "ERROR_MD_TAIL_CNT"            => [   3,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "MD tail count error" ],
   "ERROR_PI_TAIL_CNT"            => [   4,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "PI tail count error" ],
   "ERROR_LB_FAST_TAIL"           => [   5,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail error" ],
   "ERROR_II_FAST_TAIL"           => [   6,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "II fast tail error" ],
   "ERROR_MD_FAST_TAIL"           => [   7,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD fast tail error" ],
   "ERROR_PI_FAST_TAIL"           => [   8,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "PI fast tail error" ],
   "ERROR_NI1_FAST_TAIL"          => [   9,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail error" ],
   "ERROR_NI0_FAST_TAIL"          => [  10,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail error" ],
   "ERROR_IILB_FAST_TAIL"         => [  11,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "UNDERFLOW_LB_FAST_TAIL"       => [  12,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail underflow" ],
   "UNDERFLOW_II_FAST_TAIL"       => [  13,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "II fast tail underflow" ],
   "UNDERFLOW_MD_DATA_FAST_TAIL"  => [  14,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "MD data fast tail underflow" ],
   "UNDERFLOW_MD_HDR_FAST_TAIL"   => [  15,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail underflow" ],
   "UNDERFLOW_PI_DATA_FAST_TAIL"  => [  16,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail underflow" ],
   "UNDERFLOW_PI_HDR_FAST_TAIL"   => [  17,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail underflow" ],
   "UNDERFLOW_NI1_FAST_TAIL"      => [  18,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail underflow" ],
   "UNDERFLOW_NI0_FAST_TAIL"      => [  19,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail underflow" ],
   "UNDERFLOW_IILB_FAST_TAIL"     => [  20,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "UNDERFLOW_MD_DEBIT2"          => [  21,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "MD VC2 fifo debit underflow" ],
   "UNDERFLOW_MD_DEBIT0"          => [  22,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "MD VC0 fifo debit underflow" ],
   "UNDERFLOW_PI_DEBIT2"          => [  23,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "PI VC2 fifo debit underflow" ],
   "UNDERFLOW_PI_DEBIT0"          => [  24,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "PI VC0 fifo debit underflow" ],
   "UNDERFLOW_LB_VC2_CREDIT_OUT"  => [  25,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "LB VC2 fifo underflow" ],
   "UNDERFLOW_LB_VC0_CREDIT_OUT"  => [  26,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "LB VC0 fifo underflow" ],
   "UNDERFLOW_II_VC2_CREDIT_OUT"  => [  27,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "II VC2 fifo underflow" ],
   "UNDERFLOW_II_VC0_CREDIT_OUT"  => [  28,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "II VC0 fifo underflow" ],
   "UNDERFLOW_MD_VC2_CREDIT_IN"   => [  29,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "MD VC2 credit underflow" ],
   "UNDERFLOW_MD_VC0_CREDIT_IN"   => [  30,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "MD VC0 credit underflow" ],
   "UNDERFLOW_PI_VC2_CREDIT_IN"   => [  31,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI VC2 credit underflow" ],
   "UNDERFLOW_PI_VC0_CREDIT_IN"   => [  32,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "PI VC0 credit underflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT_IN"  => [  33,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit underflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT_IN"  => [  34,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit underflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT_IN"  => [  35,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit underflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT_IN"  => [  36,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit underflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT_IN" => [  37,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit underflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT_IN" => [  38,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit underflow" ],
   "UNDERFLOW_LB_VC2"             => [  39,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "LB VC2 credit underflow" ],
   "UNDERFLOW_LB_VC0"             => [  40,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "LB VC0 credit underflow" ],
   "UNDERFLOW_II_VC2"             => [  41,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "II VC2 credit underflow" ],
   "UNDERFLOW_II_VC0"             => [  42,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "II VC0 credit underflow" ],
   "UNDERFLOW_MD_DATA_VC2_CREDIT_OUT" => [  43,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD VC2 data fifo underflow" ],
   "UNDERFLOW_MD_DATA_VC0_CREDIT_OUT" => [  44,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD VC0 data fifo underflow" ],
   "UNDERFLOW_MD_HDR_VC2_CREDIT_OUT" => [  45,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD VC2 hdr fifo underflow" ],
   "UNDERFLOW_MD_HDR_VC0_CREDIT_OUT" => [  46,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD VC0 hdr fifo underflow" ],
   "UNDERFLOW_PI_DATA_VC2_CREDIT_OUT" => [  47,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI VC2 data fifo underflow" ],
   "UNDERFLOW_PI_DATA_VC0_CREDIT_OUT" => [  48,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI VC0 data fifo underflow" ],
   "UNDERFLOW_PI_HDR_VC2_CREDIT_OUT" => [  49,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI VC2 hdr fifo underflow" ],
   "UNDERFLOW_PI_HDR_VC0_CREDIT_OUT" => [  50,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI VC0 hdr fifo underflow" ],
   "UNDERFLOW_NI1_VC3_CREDIT_OUT" => [  51,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo underflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT_OUT" => [  52,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo underflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT_OUT" => [  53,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo underflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT_OUT" => [  54,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo underflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT_OUT" => [  55,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo underflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT_OUT" => [  56,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo underflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT_OUT" => [  57,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo underflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT_OUT" => [  58,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo underflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT_OUT" => [  59,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo underflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT_OUT" => [  60,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo underflow" ],
);

%shub2_01_01155_def =
( NAME    => "SH2_XNIILB_ERROR_SUMMARY_ALIAS_1",
  ADDRESS => 0x0000000050040218,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01155_flds
);


##########################################################################
#                                                                        #
#   SH2_XNIILB_ERROR_OVERFLOW_1                                          #
#                                                                        #
##########################################################################

%shub2_01_01156_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_READ_ERROR"               => [   1,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [   2,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "ERROR_MD_TAIL_CNT"            => [   3,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "MD tail count error" ],
   "ERROR_PI_TAIL_CNT"            => [   4,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "PI tail count error" ],
   "ERROR_LB_FAST_TAIL"           => [   5,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail error" ],
   "ERROR_II_FAST_TAIL"           => [   6,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "II fast tail error" ],
   "ERROR_MD_FAST_TAIL"           => [   7,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD fast tail error" ],
   "ERROR_PI_FAST_TAIL"           => [   8,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "PI fast tail error" ],
   "ERROR_NI1_FAST_TAIL"          => [   9,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail error" ],
   "ERROR_NI0_FAST_TAIL"          => [  10,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail error" ],
   "ERROR_IILB_FAST_TAIL"         => [  11,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "UNDERFLOW_LB_FAST_TAIL"       => [  12,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail underflow" ],
   "UNDERFLOW_II_FAST_TAIL"       => [  13,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "II fast tail underflow" ],
   "UNDERFLOW_MD_DATA_FAST_TAIL"  => [  14,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "MD data fast tail underflow" ],
   "UNDERFLOW_MD_HDR_FAST_TAIL"   => [  15,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail underflow" ],
   "UNDERFLOW_PI_DATA_FAST_TAIL"  => [  16,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail underflow" ],
   "UNDERFLOW_PI_HDR_FAST_TAIL"   => [  17,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail underflow" ],
   "UNDERFLOW_NI1_FAST_TAIL"      => [  18,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail underflow" ],
   "UNDERFLOW_NI0_FAST_TAIL"      => [  19,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail underflow" ],
   "UNDERFLOW_IILB_FAST_TAIL"     => [  20,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "UNDERFLOW_MD_DEBIT2"          => [  21,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "MD VC2 fifo debit underflow" ],
   "UNDERFLOW_MD_DEBIT0"          => [  22,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "MD VC0 fifo debit underflow" ],
   "UNDERFLOW_PI_DEBIT2"          => [  23,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "PI VC2 fifo debit underflow" ],
   "UNDERFLOW_PI_DEBIT0"          => [  24,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "PI VC0 fifo debit underflow" ],
   "UNDERFLOW_LB_VC2_CREDIT_OUT"  => [  25,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "LB VC2 fifo underflow" ],
   "UNDERFLOW_LB_VC0_CREDIT_OUT"  => [  26,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "LB VC0 fifo underflow" ],
   "UNDERFLOW_II_VC2_CREDIT_OUT"  => [  27,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "II VC2 fifo underflow" ],
   "UNDERFLOW_II_VC0_CREDIT_OUT"  => [  28,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "II VC0 fifo underflow" ],
   "UNDERFLOW_MD_VC2_CREDIT_IN"   => [  29,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "MD VC2 credit underflow" ],
   "UNDERFLOW_MD_VC0_CREDIT_IN"   => [  30,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "MD VC0 credit underflow" ],
   "UNDERFLOW_PI_VC2_CREDIT_IN"   => [  31,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI VC2 credit underflow" ],
   "UNDERFLOW_PI_VC0_CREDIT_IN"   => [  32,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "PI VC0 credit underflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT_IN"  => [  33,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit underflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT_IN"  => [  34,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit underflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT_IN"  => [  35,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit underflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT_IN"  => [  36,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit underflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT_IN" => [  37,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit underflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT_IN" => [  38,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit underflow" ],
   "UNDERFLOW_LB_VC2"             => [  39,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "LB VC2 credit underflow" ],
   "UNDERFLOW_LB_VC0"             => [  40,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "LB VC0 credit underflow" ],
   "UNDERFLOW_II_VC2"             => [  41,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "II VC2 credit underflow" ],
   "UNDERFLOW_II_VC0"             => [  42,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "II VC0 credit underflow" ],
   "UNDERFLOW_MD_DATA_VC2_CREDIT_OUT" => [  43,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD VC2 data fifo underflow" ],
   "UNDERFLOW_MD_DATA_VC0_CREDIT_OUT" => [  44,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD VC0 data fifo underflow" ],
   "UNDERFLOW_MD_HDR_VC2_CREDIT_OUT" => [  45,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD VC2 hdr fifo underflow" ],
   "UNDERFLOW_MD_HDR_VC0_CREDIT_OUT" => [  46,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD VC0 hdr fifo underflow" ],
   "UNDERFLOW_PI_DATA_VC2_CREDIT_OUT" => [  47,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI VC2 data fifo underflow" ],
   "UNDERFLOW_PI_DATA_VC0_CREDIT_OUT" => [  48,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI VC0 data fifo underflow" ],
   "UNDERFLOW_PI_HDR_VC2_CREDIT_OUT" => [  49,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI VC2 hdr fifo underflow" ],
   "UNDERFLOW_PI_HDR_VC0_CREDIT_OUT" => [  50,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI VC0 hdr fifo underflow" ],
   "UNDERFLOW_NI1_VC3_CREDIT_OUT" => [  51,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo underflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT_OUT" => [  52,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo underflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT_OUT" => [  53,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo underflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT_OUT" => [  54,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo underflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT_OUT" => [  55,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo underflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT_OUT" => [  56,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo underflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT_OUT" => [  57,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo underflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT_OUT" => [  58,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo underflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT_OUT" => [  59,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo underflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT_OUT" => [  60,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo underflow" ],
);

%shub2_01_01156_def =
( NAME    => "SH2_XNIILB_ERROR_OVERFLOW_1",
  ADDRESS => 0x0000000050040230,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01156_flds
);


##########################################################################
#                                                                        #
#   SH2_XNIILB_ERROR_OVERFLOW_ALIAS_1                                     #
#                                                                        #
##########################################################################

%shub2_01_01157_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_READ_ERROR"               => [   1,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [   2,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "ERROR_MD_TAIL_CNT"            => [   3,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "MD tail count error" ],
   "ERROR_PI_TAIL_CNT"            => [   4,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "PI tail count error" ],
   "ERROR_LB_FAST_TAIL"           => [   5,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail error" ],
   "ERROR_II_FAST_TAIL"           => [   6,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "II fast tail error" ],
   "ERROR_MD_FAST_TAIL"           => [   7,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD fast tail error" ],
   "ERROR_PI_FAST_TAIL"           => [   8,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "PI fast tail error" ],
   "ERROR_NI1_FAST_TAIL"          => [   9,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail error" ],
   "ERROR_NI0_FAST_TAIL"          => [  10,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail error" ],
   "ERROR_IILB_FAST_TAIL"         => [  11,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "UNDERFLOW_LB_FAST_TAIL"       => [  12,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail underflow" ],
   "UNDERFLOW_II_FAST_TAIL"       => [  13,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "II fast tail underflow" ],
   "UNDERFLOW_MD_DATA_FAST_TAIL"  => [  14,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "MD data fast tail underflow" ],
   "UNDERFLOW_MD_HDR_FAST_TAIL"   => [  15,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail underflow" ],
   "UNDERFLOW_PI_DATA_FAST_TAIL"  => [  16,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail underflow" ],
   "UNDERFLOW_PI_HDR_FAST_TAIL"   => [  17,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail underflow" ],
   "UNDERFLOW_NI1_FAST_TAIL"      => [  18,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail underflow" ],
   "UNDERFLOW_NI0_FAST_TAIL"      => [  19,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail underflow" ],
   "UNDERFLOW_IILB_FAST_TAIL"     => [  20,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "UNDERFLOW_MD_DEBIT2"          => [  21,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "MD VC2 fifo debit underflow" ],
   "UNDERFLOW_MD_DEBIT0"          => [  22,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "MD VC0 fifo debit underflow" ],
   "UNDERFLOW_PI_DEBIT2"          => [  23,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "PI VC2 fifo debit underflow" ],
   "UNDERFLOW_PI_DEBIT0"          => [  24,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "PI VC0 fifo debit underflow" ],
   "UNDERFLOW_LB_VC2_CREDIT_OUT"  => [  25,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "LB VC2 fifo underflow" ],
   "UNDERFLOW_LB_VC0_CREDIT_OUT"  => [  26,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "LB VC0 fifo underflow" ],
   "UNDERFLOW_II_VC2_CREDIT_OUT"  => [  27,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "II VC2 fifo underflow" ],
   "UNDERFLOW_II_VC0_CREDIT_OUT"  => [  28,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "II VC0 fifo underflow" ],
   "UNDERFLOW_MD_VC2_CREDIT_IN"   => [  29,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "MD VC2 credit underflow" ],
   "UNDERFLOW_MD_VC0_CREDIT_IN"   => [  30,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "MD VC0 credit underflow" ],
   "UNDERFLOW_PI_VC2_CREDIT_IN"   => [  31,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI VC2 credit underflow" ],
   "UNDERFLOW_PI_VC0_CREDIT_IN"   => [  32,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "PI VC0 credit underflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT_IN"  => [  33,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit underflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT_IN"  => [  34,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit underflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT_IN"  => [  35,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit underflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT_IN"  => [  36,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit underflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT_IN" => [  37,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit underflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT_IN" => [  38,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit underflow" ],
   "UNDERFLOW_LB_VC2"             => [  39,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "LB VC2 credit underflow" ],
   "UNDERFLOW_LB_VC0"             => [  40,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "LB VC0 credit underflow" ],
   "UNDERFLOW_II_VC2"             => [  41,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "II VC2 credit underflow" ],
   "UNDERFLOW_II_VC0"             => [  42,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "II VC0 credit underflow" ],
   "UNDERFLOW_MD_DATA_VC2_CREDIT_OUT" => [  43,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD VC2 data fifo underflow" ],
   "UNDERFLOW_MD_DATA_VC0_CREDIT_OUT" => [  44,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD VC0 data fifo underflow" ],
   "UNDERFLOW_MD_HDR_VC2_CREDIT_OUT" => [  45,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD VC2 hdr fifo underflow" ],
   "UNDERFLOW_MD_HDR_VC0_CREDIT_OUT" => [  46,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD VC0 hdr fifo underflow" ],
   "UNDERFLOW_PI_DATA_VC2_CREDIT_OUT" => [  47,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI VC2 data fifo underflow" ],
   "UNDERFLOW_PI_DATA_VC0_CREDIT_OUT" => [  48,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI VC0 data fifo underflow" ],
   "UNDERFLOW_PI_HDR_VC2_CREDIT_OUT" => [  49,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI VC2 hdr fifo underflow" ],
   "UNDERFLOW_PI_HDR_VC0_CREDIT_OUT" => [  50,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI VC0 hdr fifo underflow" ],
   "UNDERFLOW_NI1_VC3_CREDIT_OUT" => [  51,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo underflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT_OUT" => [  52,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo underflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT_OUT" => [  53,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo underflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT_OUT" => [  54,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo underflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT_OUT" => [  55,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo underflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT_OUT" => [  56,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo underflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT_OUT" => [  57,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo underflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT_OUT" => [  58,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo underflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT_OUT" => [  59,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo underflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT_OUT" => [  60,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo underflow" ],
);

%shub2_01_01157_def =
( NAME    => "SH2_XNIILB_ERROR_OVERFLOW_ALIAS_1",
  ADDRESS => 0x0000000050040238,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01157_flds
);


##########################################################################
#                                                                        #
#   SH2_XNIILB_ERROR_MASK_1                                              #
#                                                                        #
##########################################################################

%shub2_01_01158_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_READ_ERROR"               => [   1,  59,   1, 0x0800000000000000, 0x00, 1, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [   2,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "chiplet nomatch" ],
   "ERROR_MD_TAIL_CNT"            => [   3,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "MD tail count error" ],
   "ERROR_PI_TAIL_CNT"            => [   4,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "PI tail count error" ],
   "ERROR_LB_FAST_TAIL"           => [   5,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "LB fast tail error" ],
   "ERROR_II_FAST_TAIL"           => [   6,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "II fast tail error" ],
   "ERROR_MD_FAST_TAIL"           => [   7,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "MD fast tail error" ],
   "ERROR_PI_FAST_TAIL"           => [   8,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "PI fast tail error" ],
   "ERROR_NI1_FAST_TAIL"          => [   9,  51,   1, 0x0008000000000000, 0x00, 1, 0x0000000000000000, "NI1 fast tail error" ],
   "ERROR_NI0_FAST_TAIL"          => [  10,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "NI0 fast tail error" ],
   "ERROR_IILB_FAST_TAIL"         => [  11,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "IILB fast tail error" ],
   "UNDERFLOW_LB_FAST_TAIL"       => [  12,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "LB fast tail underflow" ],
   "UNDERFLOW_II_FAST_TAIL"       => [  13,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "II fast tail underflow" ],
   "UNDERFLOW_MD_DATA_FAST_TAIL"  => [  14,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "MD data fast tail underflow" ],
   "UNDERFLOW_MD_HDR_FAST_TAIL"   => [  15,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "MD hdr fast tail underflow" ],
   "UNDERFLOW_PI_DATA_FAST_TAIL"  => [  16,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "PI data fast tail underflow" ],
   "UNDERFLOW_PI_HDR_FAST_TAIL"   => [  17,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "PI hdr fast tail underflow" ],
   "UNDERFLOW_NI1_FAST_TAIL"      => [  18,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "NI1 fast tail underflow" ],
   "UNDERFLOW_NI0_FAST_TAIL"      => [  19,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "NI0 fast tail underflow" ],
   "UNDERFLOW_IILB_FAST_TAIL"     => [  20,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "IILB fast tail underflow" ],
   "UNDERFLOW_MD_DEBIT2"          => [  21,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "MD VC2 fifo debit underflow" ],
   "UNDERFLOW_MD_DEBIT0"          => [  22,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "MD VC0 fifo debit underflow" ],
   "UNDERFLOW_PI_DEBIT2"          => [  23,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "PI VC2 fifo debit underflow" ],
   "UNDERFLOW_PI_DEBIT0"          => [  24,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "PI VC0 fifo debit underflow" ],
   "UNDERFLOW_LB_VC2_CREDIT_OUT"  => [  25,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "LB VC2 fifo underflow" ],
   "UNDERFLOW_LB_VC0_CREDIT_OUT"  => [  26,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "LB VC0 fifo underflow" ],
   "UNDERFLOW_II_VC2_CREDIT_OUT"  => [  27,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "II VC2 fifo underflow" ],
   "UNDERFLOW_II_VC0_CREDIT_OUT"  => [  28,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "II VC0 fifo underflow" ],
   "UNDERFLOW_MD_VC2_CREDIT_IN"   => [  29,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "MD VC2 credit underflow" ],
   "UNDERFLOW_MD_VC0_CREDIT_IN"   => [  30,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "MD VC0 credit underflow" ],
   "UNDERFLOW_PI_VC2_CREDIT_IN"   => [  31,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "PI VC2 credit underflow" ],
   "UNDERFLOW_PI_VC0_CREDIT_IN"   => [  32,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "PI VC0 credit underflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT_IN"  => [  33,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "NI1 VC2 credit underflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT_IN"  => [  34,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "NI1 VC0 credit underflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT_IN"  => [  35,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "NI0 VC2 credit underflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT_IN"  => [  36,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "NI0 VC0 credit underflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT_IN" => [  37,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "IILB VC2 credit underflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT_IN" => [  38,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "IILB VC0 credit underflow" ],
   "UNDERFLOW_LB_VC2"             => [  39,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "LB VC2 credit underflow" ],
   "UNDERFLOW_LB_VC0"             => [  40,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "LB VC0 credit underflow" ],
   "UNDERFLOW_II_VC2"             => [  41,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "II VC2 credit underflow" ],
   "UNDERFLOW_II_VC0"             => [  42,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "II VC0 credit underflow" ],
   "UNDERFLOW_MD_DATA_VC2_CREDIT_OUT" => [  43,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "MD VC2 data fifo underflow" ],
   "UNDERFLOW_MD_DATA_VC0_CREDIT_OUT" => [  44,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "MD VC0 data fifo underflow" ],
   "UNDERFLOW_MD_HDR_VC2_CREDIT_OUT" => [  45,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "MD VC2 hdr fifo underflow" ],
   "UNDERFLOW_MD_HDR_VC0_CREDIT_OUT" => [  46,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "MD VC0 hdr fifo underflow" ],
   "UNDERFLOW_PI_DATA_VC2_CREDIT_OUT" => [  47,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "PI VC2 data fifo underflow" ],
   "UNDERFLOW_PI_DATA_VC0_CREDIT_OUT" => [  48,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "PI VC0 data fifo underflow" ],
   "UNDERFLOW_PI_HDR_VC2_CREDIT_OUT" => [  49,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "PI VC2 hdr fifo underflow" ],
   "UNDERFLOW_PI_HDR_VC0_CREDIT_OUT" => [  50,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "PI VC0 hdr fifo underflow" ],
   "UNDERFLOW_NI1_VC3_CREDIT_OUT" => [  51,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "NI1 VC3 fifo underflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT_OUT" => [  52,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "NI1 VC2 fifo underflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT_OUT" => [  53,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "NI1 VC1 fifo underflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT_OUT" => [  54,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "NI1 VC0 fifo underflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT_OUT" => [  55,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "NI0 VC3 fifo underflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT_OUT" => [  56,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "NI0 VC2 fifo underflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT_OUT" => [  57,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "NI0 VC1 fifo underflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT_OUT" => [  58,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "NI0 VC0 fifo underflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT_OUT" => [  59,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "IILB VC2 fifo underflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT_OUT" => [  60,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "IILB VC0 fifo underflow" ],
);

%shub2_01_01158_def =
( NAME    => "SH2_XNIILB_ERROR_MASK_1",
  ADDRESS => 0x0000000050040250,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01158_flds
);


##########################################################################
#                                                                        #
#   SH2_XNIILB_FIRST_ERROR_1                                             #
#                                                                        #
##########################################################################

%shub2_01_01159_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_READ_ERROR"               => [   1,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [   2,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "ERROR_MD_TAIL_CNT"            => [   3,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "MD tail count error" ],
   "ERROR_PI_TAIL_CNT"            => [   4,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "PI tail count error" ],
   "ERROR_LB_FAST_TAIL"           => [   5,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail error" ],
   "ERROR_II_FAST_TAIL"           => [   6,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "II fast tail error" ],
   "ERROR_MD_FAST_TAIL"           => [   7,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "MD fast tail error" ],
   "ERROR_PI_FAST_TAIL"           => [   8,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "PI fast tail error" ],
   "ERROR_NI1_FAST_TAIL"          => [   9,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail error" ],
   "ERROR_NI0_FAST_TAIL"          => [  10,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail error" ],
   "ERROR_IILB_FAST_TAIL"         => [  11,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "UNDERFLOW_LB_FAST_TAIL"       => [  12,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail underflow" ],
   "UNDERFLOW_II_FAST_TAIL"       => [  13,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "II fast tail underflow" ],
   "UNDERFLOW_MD_DATA_FAST_TAIL"  => [  14,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "MD data fast tail underflow" ],
   "UNDERFLOW_MD_HDR_FAST_TAIL"   => [  15,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "MD hdr fast tail underflow" ],
   "UNDERFLOW_PI_DATA_FAST_TAIL"  => [  16,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "PI data fast tail underflow" ],
   "UNDERFLOW_PI_HDR_FAST_TAIL"   => [  17,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "PI hdr fast tail underflow" ],
   "UNDERFLOW_NI1_FAST_TAIL"      => [  18,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail underflow" ],
   "UNDERFLOW_NI0_FAST_TAIL"      => [  19,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail underflow" ],
   "UNDERFLOW_IILB_FAST_TAIL"     => [  20,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "UNDERFLOW_MD_DEBIT2"          => [  21,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "MD VC2 fifo debit underflow" ],
   "UNDERFLOW_MD_DEBIT0"          => [  22,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "MD VC0 fifo debit underflow" ],
   "UNDERFLOW_PI_DEBIT2"          => [  23,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "PI VC2 fifo debit underflow" ],
   "UNDERFLOW_PI_DEBIT0"          => [  24,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "PI VC0 fifo debit underflow" ],
   "UNDERFLOW_LB_VC2_CREDIT_OUT"  => [  25,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "LB VC2 fifo underflow" ],
   "UNDERFLOW_LB_VC0_CREDIT_OUT"  => [  26,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "LB VC0 fifo underflow" ],
   "UNDERFLOW_II_VC2_CREDIT_OUT"  => [  27,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "II VC2 fifo underflow" ],
   "UNDERFLOW_II_VC0_CREDIT_OUT"  => [  28,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "II VC0 fifo underflow" ],
   "UNDERFLOW_MD_VC2_CREDIT_IN"   => [  29,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "MD VC2 credit underflow" ],
   "UNDERFLOW_MD_VC0_CREDIT_IN"   => [  30,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "MD VC0 credit underflow" ],
   "UNDERFLOW_PI_VC2_CREDIT_IN"   => [  31,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI VC2 credit underflow" ],
   "UNDERFLOW_PI_VC0_CREDIT_IN"   => [  32,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "PI VC0 credit underflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT_IN"  => [  33,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit underflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT_IN"  => [  34,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit underflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT_IN"  => [  35,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit underflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT_IN"  => [  36,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit underflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT_IN" => [  37,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit underflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT_IN" => [  38,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit underflow" ],
   "UNDERFLOW_LB_VC2"             => [  39,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "LB VC2 credit underflow" ],
   "UNDERFLOW_LB_VC0"             => [  40,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "LB VC0 credit underflow" ],
   "UNDERFLOW_II_VC2"             => [  41,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "II VC2 credit underflow" ],
   "UNDERFLOW_II_VC0"             => [  42,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "II VC0 credit underflow" ],
   "UNDERFLOW_MD_DATA_VC2_CREDIT_OUT" => [  43,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD VC2 data fifo underflow" ],
   "UNDERFLOW_MD_DATA_VC0_CREDIT_OUT" => [  44,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "MD VC0 data fifo underflow" ],
   "UNDERFLOW_MD_HDR_VC2_CREDIT_OUT" => [  45,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "MD VC2 hdr fifo underflow" ],
   "UNDERFLOW_MD_HDR_VC0_CREDIT_OUT" => [  46,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD VC0 hdr fifo underflow" ],
   "UNDERFLOW_PI_DATA_VC2_CREDIT_OUT" => [  47,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI VC2 data fifo underflow" ],
   "UNDERFLOW_PI_DATA_VC0_CREDIT_OUT" => [  48,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI VC0 data fifo underflow" ],
   "UNDERFLOW_PI_HDR_VC2_CREDIT_OUT" => [  49,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI VC2 hdr fifo underflow" ],
   "UNDERFLOW_PI_HDR_VC0_CREDIT_OUT" => [  50,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI VC0 hdr fifo underflow" ],
   "UNDERFLOW_NI1_VC3_CREDIT_OUT" => [  51,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo underflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT_OUT" => [  52,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo underflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT_OUT" => [  53,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo underflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT_OUT" => [  54,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo underflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT_OUT" => [  55,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo underflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT_OUT" => [  56,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo underflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT_OUT" => [  57,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo underflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT_OUT" => [  58,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo underflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT_OUT" => [  59,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo underflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT_OUT" => [  60,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo underflow" ],
);

%shub2_01_01159_def =
( NAME    => "SH2_XNIILB_FIRST_ERROR_1",
  ADDRESS => 0x0000000050040270,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01159_flds
);


##########################################################################
#                                                                        #
#   SH2_XNPI_ERROR_SUMMARY                                               #
#                                                                        #
##########################################################################

%shub2_01_01160_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NI1_HEAD_OR_TAIL_CNT_ERROR"   => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "NI1 Head or Tail Count Error" ],
   "NI0_HEAD_OR_TAIL_CNT_ERROR"   => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "NI0 Head or Tail Count Error" ],
   "IILB_HEAD_OR_TAIL_CNT_ERROR"  => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "IILB Head or Tail Count Error" ],
   "IILB_FAST_TAIL_UPR_ERROR"     => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Upper Error" ],
   "NI1_FAST_TAIL_UPR_ERROR"      => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Upper Error" ],
   "NI0_FAST_TAIL_UPR_ERROR"      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Upper Error" ],
   "IILB_FAST_TAIL_LWR_ERROR"     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Lower Error" ],
   "NI1_FAST_TAIL_LWR_ERROR"      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Lower Error" ],
   "NI0_FAST_TAIL_LWR_ERROR"      => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Lower Error" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Underflow" ],
   "NI1_FAST_TAIL_UNDERFLOW"      => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Underflow" ],
   "NI0_FAST_TAIL_UNDERFLOW"      => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Underflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Overflow" ],
   "NI1_FAST_TAIL_OVERFLOW"       => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Overflow" ],
   "NI0_FAST_TAIL_OVERFLOW"       => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Overflow" ],
   "OVERFLOW_CREDIT_MGR_VC2"      => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC2"     => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Underflow" ],
   "OVERFLOW_CREDIT_MGR_VC0"      => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC0"     => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC2"   => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC2"  => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC0"   => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC0"  => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Underflow" ],
   "OVERFLOW_NI1_VC3_CREDIT"      => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Overflow" ],
   "UNDERFLOW_NI1_VC3_CREDIT"     => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Underflow" ],
   "OVERFLOW_NI1_VC1_CREDIT"      => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Overflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT"     => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Underflow" ],
   "OVERFLOW_NI0_VC3_CREDIT"      => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Overflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT"     => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Underflow" ],
   "OVERFLOW_NI0_VC1_CREDIT"      => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Overflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT"     => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Underflow" ],
   "OVERFLOW_NI1_DEBIT3"          => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 3 Overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 1 Overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 3 Overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 1 Overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT"     => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Overflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT"    => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Underflow" ],
   "OVERFLOW_IILB_VC0_CREDIT"     => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Overflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT"    => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Underflow" ],
   "OVERFLOW_NI1_VC2_CREDIT"      => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT"     => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Underflow" ],
   "OVERFLOW_NI1_VC0_CREDIT"      => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Overflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT"     => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Underflow" ],
   "OVERFLOW_NI0_VC2_CREDIT"      => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Overflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT"     => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Underflow" ],
   "OVERFLOW_NI0_VC0_CREDIT"      => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Overflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT"     => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Underflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "IILB Debit 2 Overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "IILB Debit 0 Overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 Debit 2 Overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 Debit 0 Overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI0 Debit 2 Overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI0 Debit 0 Overflow" ],
   "OVERFLOW_SIC_CNTR2"           => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Overflow" ],
   "UNDERFLOW_SIC_CNTR2"          => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Underflow" ],
   "OVERFLOW_SIC_CNTR0"           => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Overflow" ],
   "UNDERFLOW_SIC_CNTR0"          => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Underflow" ],
   "RSVD0"                        => [  57,   3,   4, 0x0000000000000078, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_READ_ERROR"               => [  58,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "OVERFLOW_VC2_CREDIT"          => [  59,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "VC2 Credit overflow" ],
   "OVERFLOW_VC0_CREDIT"          => [  60,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "VC0 Credit overflow" ],
);

%shub2_01_01160_def =
( NAME    => "SH2_XNPI_ERROR_SUMMARY",
  ADDRESS => 0x0000000050040300,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01160_flds
);


##########################################################################
#                                                                        #
#   SH2_XNPI_ERROR_SUMMARY_ALIAS                                         #
#                                                                        #
##########################################################################

%shub2_01_01161_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NI1_HEAD_OR_TAIL_CNT_ERROR"   => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "NI1 Head or Tail Count Error" ],
   "NI0_HEAD_OR_TAIL_CNT_ERROR"   => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "NI0 Head or Tail Count Error" ],
   "IILB_HEAD_OR_TAIL_CNT_ERROR"  => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "IILB Head or Tail Count Error" ],
   "IILB_FAST_TAIL_UPR_ERROR"     => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Upper Error" ],
   "NI1_FAST_TAIL_UPR_ERROR"      => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Upper Error" ],
   "NI0_FAST_TAIL_UPR_ERROR"      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Upper Error" ],
   "IILB_FAST_TAIL_LWR_ERROR"     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Lower Error" ],
   "NI1_FAST_TAIL_LWR_ERROR"      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Lower Error" ],
   "NI0_FAST_TAIL_LWR_ERROR"      => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Lower Error" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Underflow" ],
   "NI1_FAST_TAIL_UNDERFLOW"      => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Underflow" ],
   "NI0_FAST_TAIL_UNDERFLOW"      => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Underflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Overflow" ],
   "NI1_FAST_TAIL_OVERFLOW"       => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Overflow" ],
   "NI0_FAST_TAIL_OVERFLOW"       => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Overflow" ],
   "OVERFLOW_CREDIT_MGR_VC2"      => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC2"     => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Underflow" ],
   "OVERFLOW_CREDIT_MGR_VC0"      => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC0"     => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC2"   => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC2"  => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC0"   => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC0"  => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Underflow" ],
   "OVERFLOW_NI1_VC3_CREDIT"      => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Overflow" ],
   "UNDERFLOW_NI1_VC3_CREDIT"     => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Underflow" ],
   "OVERFLOW_NI1_VC1_CREDIT"      => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Overflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT"     => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Underflow" ],
   "OVERFLOW_NI0_VC3_CREDIT"      => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Overflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT"     => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Underflow" ],
   "OVERFLOW_NI0_VC1_CREDIT"      => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Overflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT"     => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Underflow" ],
   "OVERFLOW_NI1_DEBIT3"          => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 3 Overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 1 Overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 3 Overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 1 Overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT"     => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Overflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT"    => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Underflow" ],
   "OVERFLOW_IILB_VC0_CREDIT"     => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Overflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT"    => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Underflow" ],
   "OVERFLOW_NI1_VC2_CREDIT"      => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT"     => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Underflow" ],
   "OVERFLOW_NI1_VC0_CREDIT"      => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Overflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT"     => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Underflow" ],
   "OVERFLOW_NI0_VC2_CREDIT"      => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Overflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT"     => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Underflow" ],
   "OVERFLOW_NI0_VC0_CREDIT"      => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Overflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT"     => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Underflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "IILB Debit 2 Overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "IILB Debit 0 Overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 Debit 2 Overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 Debit 0 Overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI0 Debit 2 Overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI0 Debit 0 Overflow" ],
   "OVERFLOW_SIC_CNTR2"           => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Overflow" ],
   "UNDERFLOW_SIC_CNTR2"          => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Underflow" ],
   "OVERFLOW_SIC_CNTR0"           => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Overflow" ],
   "UNDERFLOW_SIC_CNTR0"          => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Underflow" ],
   "RSVD0"                        => [  57,   3,   4, 0x0000000000000078, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_READ_ERROR"               => [  58,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "OVERFLOW_VC2_CREDIT"          => [  59,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "VC2 Credit overflow" ],
   "OVERFLOW_VC0_CREDIT"          => [  60,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "VC0 Credit overflow" ],
);

%shub2_01_01161_def =
( NAME    => "SH2_XNPI_ERROR_SUMMARY_ALIAS",
  ADDRESS => 0x0000000050040308,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01161_flds
);


##########################################################################
#                                                                        #
#   SH2_XNPI_ERROR_OVERFLOW                                              #
#                                                                        #
##########################################################################

%shub2_01_01162_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NI1_HEAD_OR_TAIL_CNT_ERROR"   => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "NI1 Head or Tail Count Error" ],
   "NI0_HEAD_OR_TAIL_CNT_ERROR"   => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "NI0 Head or Tail Count Error" ],
   "IILB_HEAD_OR_TAIL_CNT_ERROR"  => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "IILB Head or Tail Count Error" ],
   "IILB_FAST_TAIL_UPR_ERROR"     => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Upper Error" ],
   "NI1_FAST_TAIL_UPR_ERROR"      => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Upper Error" ],
   "NI0_FAST_TAIL_UPR_ERROR"      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Upper Error" ],
   "IILB_FAST_TAIL_LWR_ERROR"     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Lower Error" ],
   "NI1_FAST_TAIL_LWR_ERROR"      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Lower Error" ],
   "NI0_FAST_TAIL_LWR_ERROR"      => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Lower Error" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Underflow" ],
   "NI1_FAST_TAIL_UNDERFLOW"      => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Underflow" ],
   "NI0_FAST_TAIL_UNDERFLOW"      => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Underflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Overflow" ],
   "NI1_FAST_TAIL_OVERFLOW"       => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Overflow" ],
   "NI0_FAST_TAIL_OVERFLOW"       => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Overflow" ],
   "OVERFLOW_CREDIT_MGR_VC2"      => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC2"     => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Underflow" ],
   "OVERFLOW_CREDIT_MGR_VC0"      => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC0"     => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC2"   => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC2"  => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC0"   => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC0"  => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Underflow" ],
   "OVERFLOW_NI1_VC3_CREDIT"      => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Overflow" ],
   "UNDERFLOW_NI1_VC3_CREDIT"     => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Underflow" ],
   "OVERFLOW_NI1_VC1_CREDIT"      => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Overflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT"     => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Underflow" ],
   "OVERFLOW_NI0_VC3_CREDIT"      => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Overflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT"     => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Underflow" ],
   "OVERFLOW_NI0_VC1_CREDIT"      => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Overflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT"     => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Underflow" ],
   "OVERFLOW_NI1_DEBIT3"          => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 3 Overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 1 Overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 3 Overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 1 Overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT"     => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Overflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT"    => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Underflow" ],
   "OVERFLOW_IILB_VC0_CREDIT"     => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Overflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT"    => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Underflow" ],
   "OVERFLOW_NI1_VC2_CREDIT"      => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT"     => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Underflow" ],
   "OVERFLOW_NI1_VC0_CREDIT"      => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Overflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT"     => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Underflow" ],
   "OVERFLOW_NI0_VC2_CREDIT"      => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Overflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT"     => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Underflow" ],
   "OVERFLOW_NI0_VC0_CREDIT"      => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Overflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT"     => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Underflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "IILB Debit 2 Overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "IILB Debit 0 Overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 Debit 2 Overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 Debit 0 Overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI0 Debit 2 Overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI0 Debit 0 Overflow" ],
   "OVERFLOW_SIC_CNTR2"           => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Overflow" ],
   "UNDERFLOW_SIC_CNTR2"          => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Underflow" ],
   "OVERFLOW_SIC_CNTR0"           => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Overflow" ],
   "UNDERFLOW_SIC_CNTR0"          => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Underflow" ],
   "RSVD0"                        => [  57,   3,   4, 0x0000000000000078, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_READ_ERROR"               => [  58,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "OVERFLOW_VC2_CREDIT"          => [  59,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "VC2 Credit overflow" ],
   "OVERFLOW_VC0_CREDIT"          => [  60,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "VC0 Credit overflow" ],
);

%shub2_01_01162_def =
( NAME    => "SH2_XNPI_ERROR_OVERFLOW",
  ADDRESS => 0x0000000050040320,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01162_flds
);


##########################################################################
#                                                                        #
#   SH2_XNPI_ERROR_OVERFLOW_ALIAS                                        #
#                                                                        #
##########################################################################

%shub2_01_01163_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NI1_HEAD_OR_TAIL_CNT_ERROR"   => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "NI1 Head or Tail Count Error" ],
   "NI0_HEAD_OR_TAIL_CNT_ERROR"   => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "NI0 Head or Tail Count Error" ],
   "IILB_HEAD_OR_TAIL_CNT_ERROR"  => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "IILB Head or Tail Count Error" ],
   "IILB_FAST_TAIL_UPR_ERROR"     => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Upper Error" ],
   "NI1_FAST_TAIL_UPR_ERROR"      => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Upper Error" ],
   "NI0_FAST_TAIL_UPR_ERROR"      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Upper Error" ],
   "IILB_FAST_TAIL_LWR_ERROR"     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Lower Error" ],
   "NI1_FAST_TAIL_LWR_ERROR"      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Lower Error" ],
   "NI0_FAST_TAIL_LWR_ERROR"      => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Lower Error" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Underflow" ],
   "NI1_FAST_TAIL_UNDERFLOW"      => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Underflow" ],
   "NI0_FAST_TAIL_UNDERFLOW"      => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Underflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Overflow" ],
   "NI1_FAST_TAIL_OVERFLOW"       => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Overflow" ],
   "NI0_FAST_TAIL_OVERFLOW"       => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Overflow" ],
   "OVERFLOW_CREDIT_MGR_VC2"      => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC2"     => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Underflow" ],
   "OVERFLOW_CREDIT_MGR_VC0"      => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC0"     => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC2"   => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC2"  => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC0"   => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC0"  => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Underflow" ],
   "OVERFLOW_NI1_VC3_CREDIT"      => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Overflow" ],
   "UNDERFLOW_NI1_VC3_CREDIT"     => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Underflow" ],
   "OVERFLOW_NI1_VC1_CREDIT"      => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Overflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT"     => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Underflow" ],
   "OVERFLOW_NI0_VC3_CREDIT"      => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Overflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT"     => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Underflow" ],
   "OVERFLOW_NI0_VC1_CREDIT"      => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Overflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT"     => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Underflow" ],
   "OVERFLOW_NI1_DEBIT3"          => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 3 Overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 1 Overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 3 Overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 1 Overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT"     => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Overflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT"    => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Underflow" ],
   "OVERFLOW_IILB_VC0_CREDIT"     => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Overflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT"    => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Underflow" ],
   "OVERFLOW_NI1_VC2_CREDIT"      => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT"     => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Underflow" ],
   "OVERFLOW_NI1_VC0_CREDIT"      => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Overflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT"     => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Underflow" ],
   "OVERFLOW_NI0_VC2_CREDIT"      => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Overflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT"     => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Underflow" ],
   "OVERFLOW_NI0_VC0_CREDIT"      => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Overflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT"     => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Underflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "IILB Debit 2 Overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "IILB Debit 0 Overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 Debit 2 Overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 Debit 0 Overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI0 Debit 2 Overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI0 Debit 0 Overflow" ],
   "OVERFLOW_SIC_CNTR2"           => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Overflow" ],
   "UNDERFLOW_SIC_CNTR2"          => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Underflow" ],
   "OVERFLOW_SIC_CNTR0"           => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Overflow" ],
   "UNDERFLOW_SIC_CNTR0"          => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Underflow" ],
   "RSVD0"                        => [  57,   3,   4, 0x0000000000000078, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_READ_ERROR"               => [  58,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "OVERFLOW_VC2_CREDIT"          => [  59,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "VC2 Credit overflow" ],
   "OVERFLOW_VC0_CREDIT"          => [  60,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "VC0 Credit overflow" ],
);

%shub2_01_01163_def =
( NAME    => "SH2_XNPI_ERROR_OVERFLOW_ALIAS",
  ADDRESS => 0x0000000050040328,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01163_flds
);


##########################################################################
#                                                                        #
#   SH2_XNPI_ERROR_MASK                                                  #
#                                                                        #
##########################################################################

%shub2_01_01164_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NI1_HEAD_OR_TAIL_CNT_ERROR"   => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "NI1 Head or Tail Count Error" ],
   "NI0_HEAD_OR_TAIL_CNT_ERROR"   => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "NI0 Head or Tail Count Error" ],
   "IILB_HEAD_OR_TAIL_CNT_ERROR"  => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "IILB Head or Tail Count Error" ],
   "IILB_FAST_TAIL_UPR_ERROR"     => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "IILB Fast Tail Upper Error" ],
   "NI1_FAST_TAIL_UPR_ERROR"      => [   4,  59,   1, 0x0800000000000000, 0x00, 1, 0x0000000000000000, "NI1 Fast Tail Upper Error" ],
   "NI0_FAST_TAIL_UPR_ERROR"      => [   5,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "NI0 Fast Tail Upper Error" ],
   "IILB_FAST_TAIL_LWR_ERROR"     => [   6,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "IILB Fast Tail Lower Error" ],
   "NI1_FAST_TAIL_LWR_ERROR"      => [   7,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "NI1 Fast Tail Lower Error" ],
   "NI0_FAST_TAIL_LWR_ERROR"      => [   8,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "NI0 Fast Tail Lower Error" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [   9,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "IILB Fast Tail Underflow" ],
   "NI1_FAST_TAIL_UNDERFLOW"      => [  10,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "NI1 Fast Tail Underflow" ],
   "NI0_FAST_TAIL_UNDERFLOW"      => [  11,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "NI0 Fast Tail Underflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  12,  51,   1, 0x0008000000000000, 0x00, 1, 0x0000000000000000, "IILB Fast Tail Overflow" ],
   "NI1_FAST_TAIL_OVERFLOW"       => [  13,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "NI1 Fast Tail Overflow" ],
   "NI0_FAST_TAIL_OVERFLOW"       => [  14,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "NI0 Fast Tail Overflow" ],
   "OVERFLOW_CREDIT_MGR_VC2"      => [  15,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "VC2 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC2"     => [  16,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "VC2 Credit Manager Underflow" ],
   "OVERFLOW_CREDIT_MGR_VC0"      => [  17,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "VC0 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC0"     => [  18,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "VC0 Credit Manager Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC2"   => [  19,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "VC2 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC2"  => [  20,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "VC2 Steering FIFO Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC0"   => [  21,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "VC0 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC0"  => [  22,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "VC0 Steering FIFO Underflow" ],
   "OVERFLOW_NI1_VC3_CREDIT"      => [  23,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "NI1 VC3 Credit Overflow" ],
   "UNDERFLOW_NI1_VC3_CREDIT"     => [  24,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "NI1 VC3 Credit Underflow" ],
   "OVERFLOW_NI1_VC1_CREDIT"      => [  25,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "NI1 VC1 Credit Overflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT"     => [  26,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "NI1 VC1 Credit Underflow" ],
   "OVERFLOW_NI0_VC3_CREDIT"      => [  27,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "NI0 VC3 Credit Overflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT"     => [  28,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "NI0 VC3 Credit Underflow" ],
   "OVERFLOW_NI0_VC1_CREDIT"      => [  29,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "NI0 VC1 Credit Overflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT"     => [  30,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "NI0 VC1 Credit Underflow" ],
   "OVERFLOW_NI1_DEBIT3"          => [  31,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "NI1 Debit 3 Overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  32,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "NI1 Debit 1 Overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  33,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "NI0 Debit 3 Overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  34,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "NI0 Debit 1 Overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT"     => [  35,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "IILB VC2 Credit Overflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT"    => [  36,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "IILB VC2 Credit Underflow" ],
   "OVERFLOW_IILB_VC0_CREDIT"     => [  37,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "IILB VC0 Credit Overflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT"    => [  38,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "IILB VC0 Credit Underflow" ],
   "OVERFLOW_NI1_VC2_CREDIT"      => [  39,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "NI1 VC2 Credit Overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT"     => [  40,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "NI1 VC2 Credit Underflow" ],
   "OVERFLOW_NI1_VC0_CREDIT"      => [  41,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "NI1 VC0 Credit Overflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT"     => [  42,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "NI1 VC0 Credit Underflow" ],
   "OVERFLOW_NI0_VC2_CREDIT"      => [  43,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "NI0 VC2 Credit Overflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT"     => [  44,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "NI0 VC2 Credit Underflow" ],
   "OVERFLOW_NI0_VC0_CREDIT"      => [  45,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "NI0 VC0 Credit Overflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT"     => [  46,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "NI0 VC0 Credit Underflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  47,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "IILB Debit 2 Overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  48,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "IILB Debit 0 Overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  49,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "NI1 Debit 2 Overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  50,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "NI1 Debit 0 Overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  51,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "NI0 Debit 2 Overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  52,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "NI0 Debit 0 Overflow" ],
   "OVERFLOW_SIC_CNTR2"           => [  53,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "SIC Counter 2 Overflow" ],
   "UNDERFLOW_SIC_CNTR2"          => [  54,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "SIC Counter 2 Underflow" ],
   "OVERFLOW_SIC_CNTR0"           => [  55,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "SIC Counter 0 Overflow" ],
   "UNDERFLOW_SIC_CNTR0"          => [  56,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "SIC Counter 0 Underflow" ],
   "RSVD0"                        => [  57,   3,   4, 0x0000000000000078, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_READ_ERROR"               => [  58,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "LUT Read Error" ],
   "OVERFLOW_VC2_CREDIT"          => [  59,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "VC2 Credit overflow" ],
   "OVERFLOW_VC0_CREDIT"          => [  60,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "VC0 Credit overflow" ],
);

%shub2_01_01164_def =
( NAME    => "SH2_XNPI_ERROR_MASK",
  ADDRESS => 0x0000000050040340,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01164_flds
);


##########################################################################
#                                                                        #
#   SH2_XNPI_FIRST_ERROR                                                 #
#                                                                        #
##########################################################################

%shub2_01_01165_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NI1_HEAD_OR_TAIL_CNT_ERROR"   => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "NI1 Head or Tail Count Error" ],
   "NI0_HEAD_OR_TAIL_CNT_ERROR"   => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "NI0 Head or Tail Count Error" ],
   "IILB_HEAD_OR_TAIL_CNT_ERROR"  => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "IILB Head or Tail Count Error" ],
   "IILB_FAST_TAIL_UPR_ERROR"     => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Upper Error" ],
   "NI1_FAST_TAIL_UPR_ERROR"      => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Upper Error" ],
   "NI0_FAST_TAIL_UPR_ERROR"      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Upper Error" ],
   "IILB_FAST_TAIL_LWR_ERROR"     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Lower Error" ],
   "NI1_FAST_TAIL_LWR_ERROR"      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Lower Error" ],
   "NI0_FAST_TAIL_LWR_ERROR"      => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Lower Error" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Underflow" ],
   "NI1_FAST_TAIL_UNDERFLOW"      => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Underflow" ],
   "NI0_FAST_TAIL_UNDERFLOW"      => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Underflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Overflow" ],
   "NI1_FAST_TAIL_OVERFLOW"       => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Overflow" ],
   "NI0_FAST_TAIL_OVERFLOW"       => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Overflow" ],
   "OVERFLOW_CREDIT_MGR_VC2"      => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC2"     => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Underflow" ],
   "OVERFLOW_CREDIT_MGR_VC0"      => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC0"     => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC2"   => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC2"  => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC0"   => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC0"  => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Underflow" ],
   "OVERFLOW_NI1_VC3_CREDIT"      => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Overflow" ],
   "UNDERFLOW_NI1_VC3_CREDIT"     => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Underflow" ],
   "OVERFLOW_NI1_VC1_CREDIT"      => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Overflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT"     => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Underflow" ],
   "OVERFLOW_NI0_VC3_CREDIT"      => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Overflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT"     => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Underflow" ],
   "OVERFLOW_NI0_VC1_CREDIT"      => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Overflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT"     => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Underflow" ],
   "OVERFLOW_NI1_DEBIT3"          => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 3 Overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 1 Overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 3 Overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 1 Overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT"     => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Overflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT"    => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Underflow" ],
   "OVERFLOW_IILB_VC0_CREDIT"     => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Overflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT"    => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Underflow" ],
   "OVERFLOW_NI1_VC2_CREDIT"      => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT"     => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Underflow" ],
   "OVERFLOW_NI1_VC0_CREDIT"      => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Overflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT"     => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Underflow" ],
   "OVERFLOW_NI0_VC2_CREDIT"      => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Overflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT"     => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Underflow" ],
   "OVERFLOW_NI0_VC0_CREDIT"      => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Overflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT"     => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Underflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "IILB Debit 2 Overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "IILB Debit 0 Overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 Debit 2 Overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 Debit 0 Overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI0 Debit 2 Overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI0 Debit 0 Overflow" ],
   "OVERFLOW_SIC_CNTR2"           => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Overflow" ],
   "UNDERFLOW_SIC_CNTR2"          => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Underflow" ],
   "OVERFLOW_SIC_CNTR0"           => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Overflow" ],
   "UNDERFLOW_SIC_CNTR0"          => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Underflow" ],
   "RSVD0"                        => [  57,   3,   4, 0x0000000000000078, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_READ_ERROR"               => [  58,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "OVERFLOW_VC2_CREDIT"          => [  59,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "VC2 Credit overflow" ],
   "OVERFLOW_VC0_CREDIT"          => [  60,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "VC0 Credit overflow" ],
);

%shub2_01_01165_def =
( NAME    => "SH2_XNPI_FIRST_ERROR",
  ADDRESS => 0x0000000050040360,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01165_flds
);


##########################################################################
#                                                                        #
#   SH2_XNMD_ERROR_SUMMARY                                               #
#                                                                        #
##########################################################################

%shub2_01_01166_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NI1_HEAD_OR_TAIL_CNT_ERROR"   => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "NI1 Head or Tail Count Error" ],
   "NI0_HEAD_OR_TAIL_CNT_ERROR"   => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "NI0 Head or Tail Count Error" ],
   "IILB_HEAD_OR_TAIL_CNT_ERROR"  => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "IILB Head or Tail Count Error" ],
   "IILB_FAST_TAIL_UPR_ERROR"     => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Upper Error" ],
   "NI1_FAST_TAIL_UPR_ERROR"      => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Upper Error" ],
   "NI0_FAST_TAIL_UPR_ERROR"      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Upper Error" ],
   "IILB_FAST_TAIL_LWR_ERROR"     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Lower Error" ],
   "NI1_FAST_TAIL_LWR_ERROR"      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Lower Error" ],
   "NI0_FAST_TAIL_LWR_ERROR"      => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Lower Error" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Underflow" ],
   "NI1_FAST_TAIL_UNDERFLOW"      => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Underflow" ],
   "NI0_FAST_TAIL_UNDERFLOW"      => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Underflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Overflow" ],
   "NI1_FAST_TAIL_OVERFLOW"       => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Overflow" ],
   "NI0_FAST_TAIL_OVERFLOW"       => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Overflow" ],
   "OVERFLOW_CREDIT_MGR_VC2"      => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC2"     => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Underflow" ],
   "OVERFLOW_CREDIT_MGR_VC0"      => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC0"     => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC2"   => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC2"  => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC0"   => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC0"  => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Underflow" ],
   "OVERFLOW_NI1_VC3_CREDIT"      => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Overflow" ],
   "UNDERFLOW_NI1_VC3_CREDIT"     => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Underflow" ],
   "OVERFLOW_NI1_VC1_CREDIT"      => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Overflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT"     => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Underflow" ],
   "OVERFLOW_NI0_VC3_CREDIT"      => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Overflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT"     => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Underflow" ],
   "OVERFLOW_NI0_VC1_CREDIT"      => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Overflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT"     => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Underflow" ],
   "OVERFLOW_NI1_DEBIT3"          => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 3 Overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 1 Overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 3 Overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 1 Overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT"     => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Overflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT"    => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Underflow" ],
   "OVERFLOW_IILB_VC0_CREDIT"     => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Overflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT"    => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Underflow" ],
   "OVERFLOW_NI1_VC2_CREDIT"      => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT"     => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Underflow" ],
   "OVERFLOW_NI1_VC0_CREDIT"      => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Overflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT"     => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Underflow" ],
   "OVERFLOW_NI0_VC2_CREDIT"      => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Overflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT"     => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Underflow" ],
   "OVERFLOW_NI0_VC0_CREDIT"      => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Overflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT"     => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Underflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "IILB Debit 2 Overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "IILB Debit 0 Overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 Debit 2 Overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 Debit 0 Overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI0 Debit 2 Overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI0 Debit 0 Overflow" ],
   "OVERFLOW_SIC_CNTR2"           => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Overflow" ],
   "UNDERFLOW_SIC_CNTR2"          => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Underflow" ],
   "OVERFLOW_SIC_CNTR0"           => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Overflow" ],
   "UNDERFLOW_SIC_CNTR0"          => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Underflow" ],
   "RSVD0"                        => [  57,   3,   4, 0x0000000000000078, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_READ_ERROR"               => [  58,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "OVERFLOW_VC2_CREDIT"          => [  59,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "VC2 Credit overflow" ],
   "OVERFLOW_VC0_CREDIT"          => [  60,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "VC0 Credit overflow" ],
);

%shub2_01_01166_def =
( NAME    => "SH2_XNMD_ERROR_SUMMARY",
  ADDRESS => 0x0000000050040400,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01166_flds
);


##########################################################################
#                                                                        #
#   SH2_XNMD_ERROR_SUMMARY_ALIAS                                         #
#                                                                        #
##########################################################################

%shub2_01_01167_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NI1_HEAD_OR_TAIL_CNT_ERROR"   => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "NI1 Head or Tail Count Error" ],
   "NI0_HEAD_OR_TAIL_CNT_ERROR"   => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "NI0 Head or Tail Count Error" ],
   "IILB_HEAD_OR_TAIL_CNT_ERROR"  => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "IILB Head or Tail Count Error" ],
   "IILB_FAST_TAIL_UPR_ERROR"     => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Upper Error" ],
   "NI1_FAST_TAIL_UPR_ERROR"      => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Upper Error" ],
   "NI0_FAST_TAIL_UPR_ERROR"      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Upper Error" ],
   "IILB_FAST_TAIL_LWR_ERROR"     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Lower Error" ],
   "NI1_FAST_TAIL_LWR_ERROR"      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Lower Error" ],
   "NI0_FAST_TAIL_LWR_ERROR"      => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Lower Error" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Underflow" ],
   "NI1_FAST_TAIL_UNDERFLOW"      => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Underflow" ],
   "NI0_FAST_TAIL_UNDERFLOW"      => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Underflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Overflow" ],
   "NI1_FAST_TAIL_OVERFLOW"       => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Overflow" ],
   "NI0_FAST_TAIL_OVERFLOW"       => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Overflow" ],
   "OVERFLOW_CREDIT_MGR_VC2"      => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC2"     => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Underflow" ],
   "OVERFLOW_CREDIT_MGR_VC0"      => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC0"     => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC2"   => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC2"  => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC0"   => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC0"  => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Underflow" ],
   "OVERFLOW_NI1_VC3_CREDIT"      => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Overflow" ],
   "UNDERFLOW_NI1_VC3_CREDIT"     => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Underflow" ],
   "OVERFLOW_NI1_VC1_CREDIT"      => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Overflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT"     => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Underflow" ],
   "OVERFLOW_NI0_VC3_CREDIT"      => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Overflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT"     => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Underflow" ],
   "OVERFLOW_NI0_VC1_CREDIT"      => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Overflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT"     => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Underflow" ],
   "OVERFLOW_NI1_DEBIT3"          => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 3 Overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 1 Overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 3 Overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 1 Overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT"     => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Overflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT"    => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Underflow" ],
   "OVERFLOW_IILB_VC0_CREDIT"     => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Overflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT"    => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Underflow" ],
   "OVERFLOW_NI1_VC2_CREDIT"      => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT"     => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Underflow" ],
   "OVERFLOW_NI1_VC0_CREDIT"      => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Overflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT"     => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Underflow" ],
   "OVERFLOW_NI0_VC2_CREDIT"      => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Overflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT"     => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Underflow" ],
   "OVERFLOW_NI0_VC0_CREDIT"      => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Overflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT"     => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Underflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "IILB Debit 2 Overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "IILB Debit 0 Overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 Debit 2 Overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 Debit 0 Overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI0 Debit 2 Overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI0 Debit 0 Overflow" ],
   "OVERFLOW_SIC_CNTR2"           => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Overflow" ],
   "UNDERFLOW_SIC_CNTR2"          => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Underflow" ],
   "OVERFLOW_SIC_CNTR0"           => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Overflow" ],
   "UNDERFLOW_SIC_CNTR0"          => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Underflow" ],
   "RSVD0"                        => [  57,   3,   4, 0x0000000000000078, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_READ_ERROR"               => [  58,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "OVERFLOW_VC2_CREDIT"          => [  59,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "VC2 Credit overflow" ],
   "OVERFLOW_VC0_CREDIT"          => [  60,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "VC0 Credit overflow" ],
);

%shub2_01_01167_def =
( NAME    => "SH2_XNMD_ERROR_SUMMARY_ALIAS",
  ADDRESS => 0x0000000050040408,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01167_flds
);


##########################################################################
#                                                                        #
#   SH2_XNMD_ERROR_OVERFLOW                                              #
#                                                                        #
##########################################################################

%shub2_01_01168_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NI1_HEAD_OR_TAIL_CNT_ERROR"   => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "NI1 Head or Tail Count Error" ],
   "NI0_HEAD_OR_TAIL_CNT_ERROR"   => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "NI0 Head or Tail Count Error" ],
   "IILB_HEAD_OR_TAIL_CNT_ERROR"  => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "IILB Head or Tail Count Error" ],
   "IILB_FAST_TAIL_UPR_ERROR"     => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Upper Error" ],
   "NI1_FAST_TAIL_UPR_ERROR"      => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Upper Error" ],
   "NI0_FAST_TAIL_UPR_ERROR"      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Upper Error" ],
   "IILB_FAST_TAIL_LWR_ERROR"     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Lower Error" ],
   "NI1_FAST_TAIL_LWR_ERROR"      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Lower Error" ],
   "NI0_FAST_TAIL_LWR_ERROR"      => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Lower Error" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Underflow" ],
   "NI1_FAST_TAIL_UNDERFLOW"      => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Underflow" ],
   "NI0_FAST_TAIL_UNDERFLOW"      => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Underflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Overflow" ],
   "NI1_FAST_TAIL_OVERFLOW"       => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Overflow" ],
   "NI0_FAST_TAIL_OVERFLOW"       => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Overflow" ],
   "OVERFLOW_CREDIT_MGR_VC2"      => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC2"     => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Underflow" ],
   "OVERFLOW_CREDIT_MGR_VC0"      => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC0"     => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC2"   => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC2"  => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC0"   => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC0"  => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Underflow" ],
   "OVERFLOW_NI1_VC3_CREDIT"      => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Overflow" ],
   "UNDERFLOW_NI1_VC3_CREDIT"     => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Underflow" ],
   "OVERFLOW_NI1_VC1_CREDIT"      => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Overflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT"     => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Underflow" ],
   "OVERFLOW_NI0_VC3_CREDIT"      => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Overflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT"     => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Underflow" ],
   "OVERFLOW_NI0_VC1_CREDIT"      => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Overflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT"     => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Underflow" ],
   "OVERFLOW_NI1_DEBIT3"          => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 3 Overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 1 Overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 3 Overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 1 Overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT"     => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Overflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT"    => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Underflow" ],
   "OVERFLOW_IILB_VC0_CREDIT"     => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Overflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT"    => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Underflow" ],
   "OVERFLOW_NI1_VC2_CREDIT"      => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT"     => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Underflow" ],
   "OVERFLOW_NI1_VC0_CREDIT"      => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Overflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT"     => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Underflow" ],
   "OVERFLOW_NI0_VC2_CREDIT"      => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Overflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT"     => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Underflow" ],
   "OVERFLOW_NI0_VC0_CREDIT"      => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Overflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT"     => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Underflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "IILB Debit 2 Overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "IILB Debit 0 Overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 Debit 2 Overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 Debit 0 Overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI0 Debit 2 Overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI0 Debit 0 Overflow" ],
   "OVERFLOW_SIC_CNTR2"           => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Overflow" ],
   "UNDERFLOW_SIC_CNTR2"          => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Underflow" ],
   "OVERFLOW_SIC_CNTR0"           => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Overflow" ],
   "UNDERFLOW_SIC_CNTR0"          => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Underflow" ],
   "RSVD0"                        => [  57,   3,   4, 0x0000000000000078, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_READ_ERROR"               => [  58,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "OVERFLOW_VC2_CREDIT"          => [  59,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "VC2 Credit overflow" ],
   "OVERFLOW_VC0_CREDIT"          => [  60,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "VC0 Credit overflow" ],
);

%shub2_01_01168_def =
( NAME    => "SH2_XNMD_ERROR_OVERFLOW",
  ADDRESS => 0x0000000050040420,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01168_flds
);


##########################################################################
#                                                                        #
#   SH2_XNMD_ERROR_OVERFLOW_ALIAS                                        #
#                                                                        #
##########################################################################

%shub2_01_01169_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NI1_HEAD_OR_TAIL_CNT_ERROR"   => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "NI1 Head or Tail Count Error" ],
   "NI0_HEAD_OR_TAIL_CNT_ERROR"   => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "NI0 Head or Tail Count Error" ],
   "IILB_HEAD_OR_TAIL_CNT_ERROR"  => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "IILB Head or Tail Count Error" ],
   "IILB_FAST_TAIL_UPR_ERROR"     => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Upper Error" ],
   "NI1_FAST_TAIL_UPR_ERROR"      => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Upper Error" ],
   "NI0_FAST_TAIL_UPR_ERROR"      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Upper Error" ],
   "IILB_FAST_TAIL_LWR_ERROR"     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Lower Error" ],
   "NI1_FAST_TAIL_LWR_ERROR"      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Lower Error" ],
   "NI0_FAST_TAIL_LWR_ERROR"      => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Lower Error" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Underflow" ],
   "NI1_FAST_TAIL_UNDERFLOW"      => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Underflow" ],
   "NI0_FAST_TAIL_UNDERFLOW"      => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Underflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Overflow" ],
   "NI1_FAST_TAIL_OVERFLOW"       => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Overflow" ],
   "NI0_FAST_TAIL_OVERFLOW"       => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Overflow" ],
   "OVERFLOW_CREDIT_MGR_VC2"      => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC2"     => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Underflow" ],
   "OVERFLOW_CREDIT_MGR_VC0"      => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC0"     => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC2"   => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC2"  => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC0"   => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC0"  => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Underflow" ],
   "OVERFLOW_NI1_VC3_CREDIT"      => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Overflow" ],
   "UNDERFLOW_NI1_VC3_CREDIT"     => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Underflow" ],
   "OVERFLOW_NI1_VC1_CREDIT"      => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Overflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT"     => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Underflow" ],
   "OVERFLOW_NI0_VC3_CREDIT"      => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Overflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT"     => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Underflow" ],
   "OVERFLOW_NI0_VC1_CREDIT"      => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Overflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT"     => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Underflow" ],
   "OVERFLOW_NI1_DEBIT3"          => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 3 Overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 1 Overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 3 Overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 1 Overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT"     => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Overflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT"    => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Underflow" ],
   "OVERFLOW_IILB_VC0_CREDIT"     => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Overflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT"    => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Underflow" ],
   "OVERFLOW_NI1_VC2_CREDIT"      => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT"     => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Underflow" ],
   "OVERFLOW_NI1_VC0_CREDIT"      => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Overflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT"     => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Underflow" ],
   "OVERFLOW_NI0_VC2_CREDIT"      => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Overflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT"     => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Underflow" ],
   "OVERFLOW_NI0_VC0_CREDIT"      => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Overflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT"     => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Underflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "IILB Debit 2 Overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "IILB Debit 0 Overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 Debit 2 Overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 Debit 0 Overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI0 Debit 2 Overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI0 Debit 0 Overflow" ],
   "OVERFLOW_SIC_CNTR2"           => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Overflow" ],
   "UNDERFLOW_SIC_CNTR2"          => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Underflow" ],
   "OVERFLOW_SIC_CNTR0"           => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Overflow" ],
   "UNDERFLOW_SIC_CNTR0"          => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Underflow" ],
   "RSVD0"                        => [  57,   3,   4, 0x0000000000000078, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_READ_ERROR"               => [  58,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "OVERFLOW_VC2_CREDIT"          => [  59,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "VC2 Credit overflow" ],
   "OVERFLOW_VC0_CREDIT"          => [  60,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "VC0 Credit overflow" ],
);

%shub2_01_01169_def =
( NAME    => "SH2_XNMD_ERROR_OVERFLOW_ALIAS",
  ADDRESS => 0x0000000050040428,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01169_flds
);


##########################################################################
#                                                                        #
#   SH2_XNMD_ERROR_MASK                                                  #
#                                                                        #
##########################################################################

%shub2_01_01170_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NI1_HEAD_OR_TAIL_CNT_ERROR"   => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "NI1 Head or Tail Count Error" ],
   "NI0_HEAD_OR_TAIL_CNT_ERROR"   => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "NI0 Head or Tail Count Error" ],
   "IILB_HEAD_OR_TAIL_CNT_ERROR"  => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "IILB Head or Tail Count Error" ],
   "IILB_FAST_TAIL_UPR_ERROR"     => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "IILB Fast Tail Upper Error" ],
   "NI1_FAST_TAIL_UPR_ERROR"      => [   4,  59,   1, 0x0800000000000000, 0x00, 1, 0x0000000000000000, "NI1 Fast Tail Upper Error" ],
   "NI0_FAST_TAIL_UPR_ERROR"      => [   5,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "NI0 Fast Tail Upper Error" ],
   "IILB_FAST_TAIL_LWR_ERROR"     => [   6,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "IILB Fast Tail Lower Error" ],
   "NI1_FAST_TAIL_LWR_ERROR"      => [   7,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "NI1 Fast Tail Lower Error" ],
   "NI0_FAST_TAIL_LWR_ERROR"      => [   8,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "NI0 Fast Tail Lower Error" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [   9,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "IILB Fast Tail Underflow" ],
   "NI1_FAST_TAIL_UNDERFLOW"      => [  10,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "NI1 Fast Tail Underflow" ],
   "NI0_FAST_TAIL_UNDERFLOW"      => [  11,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "NI0 Fast Tail Underflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  12,  51,   1, 0x0008000000000000, 0x00, 1, 0x0000000000000000, "IILB Fast Tail Overflow" ],
   "NI1_FAST_TAIL_OVERFLOW"       => [  13,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "NI1 Fast Tail Overflow" ],
   "NI0_FAST_TAIL_OVERFLOW"       => [  14,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "NI0 Fast Tail Overflow" ],
   "OVERFLOW_CREDIT_MGR_VC2"      => [  15,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "VC2 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC2"     => [  16,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "VC2 Credit Manager Underflow" ],
   "OVERFLOW_CREDIT_MGR_VC0"      => [  17,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "VC0 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC0"     => [  18,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "VC0 Credit Manager Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC2"   => [  19,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "VC2 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC2"  => [  20,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "VC2 Steering FIFO Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC0"   => [  21,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "VC0 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC0"  => [  22,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "VC0 Steering FIFO Underflow" ],
   "OVERFLOW_NI1_VC3_CREDIT"      => [  23,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "NI1 VC3 Credit Overflow" ],
   "UNDERFLOW_NI1_VC3_CREDIT"     => [  24,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "NI1 VC3 Credit Underflow" ],
   "OVERFLOW_NI1_VC1_CREDIT"      => [  25,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "NI1 VC1 Credit Overflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT"     => [  26,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "NI1 VC1 Credit Underflow" ],
   "OVERFLOW_NI0_VC3_CREDIT"      => [  27,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "NI0 VC3 Credit Overflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT"     => [  28,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "NI0 VC3 Credit Underflow" ],
   "OVERFLOW_NI0_VC1_CREDIT"      => [  29,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "NI0 VC1 Credit Overflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT"     => [  30,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "NI0 VC1 Credit Underflow" ],
   "OVERFLOW_NI1_DEBIT3"          => [  31,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "NI1 Debit 3 Overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  32,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "NI1 Debit 1 Overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  33,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "NI0 Debit 3 Overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  34,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "NI0 Debit 1 Overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT"     => [  35,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "IILB VC2 Credit Overflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT"    => [  36,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "IILB VC2 Credit Underflow" ],
   "OVERFLOW_IILB_VC0_CREDIT"     => [  37,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "IILB VC0 Credit Overflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT"    => [  38,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "IILB VC0 Credit Underflow" ],
   "OVERFLOW_NI1_VC2_CREDIT"      => [  39,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "NI1 VC2 Credit Overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT"     => [  40,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "NI1 VC2 Credit Underflow" ],
   "OVERFLOW_NI1_VC0_CREDIT"      => [  41,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "NI1 VC0 Credit Overflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT"     => [  42,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "NI1 VC0 Credit Underflow" ],
   "OVERFLOW_NI0_VC2_CREDIT"      => [  43,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "NI0 VC2 Credit Overflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT"     => [  44,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "NI0 VC2 Credit Underflow" ],
   "OVERFLOW_NI0_VC0_CREDIT"      => [  45,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "NI0 VC0 Credit Overflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT"     => [  46,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "NI0 VC0 Credit Underflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  47,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "IILB Debit 2 Overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  48,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "IILB Debit 0 Overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  49,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "NI1 Debit 2 Overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  50,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "NI1 Debit 0 Overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  51,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "NI0 Debit 2 Overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  52,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "NI0 Debit 0 Overflow" ],
   "OVERFLOW_SIC_CNTR2"           => [  53,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "SIC Counter 2 Overflow" ],
   "UNDERFLOW_SIC_CNTR2"          => [  54,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "SIC Counter 2 Underflow" ],
   "OVERFLOW_SIC_CNTR0"           => [  55,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "SIC Counter 0 Overflow" ],
   "UNDERFLOW_SIC_CNTR0"          => [  56,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "SIC Counter 0 Underflow" ],
   "RSVD0"                        => [  57,   3,   4, 0x0000000000000078, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_READ_ERROR"               => [  58,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "LUT Read Error" ],
   "OVERFLOW_VC2_CREDIT"          => [  59,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "VC2 Credit overflow" ],
   "OVERFLOW_VC0_CREDIT"          => [  60,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "VC0 Credit overflow" ],
);

%shub2_01_01170_def =
( NAME    => "SH2_XNMD_ERROR_MASK",
  ADDRESS => 0x0000000050040440,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01170_flds
);


##########################################################################
#                                                                        #
#   SH2_XNMD_FIRST_ERROR                                                 #
#                                                                        #
##########################################################################

%shub2_01_01171_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NI1_HEAD_OR_TAIL_CNT_ERROR"   => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "NI1 Head or Tail Count Error" ],
   "NI0_HEAD_OR_TAIL_CNT_ERROR"   => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "NI0 Head or Tail Count Error" ],
   "IILB_HEAD_OR_TAIL_CNT_ERROR"  => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "IILB Head or Tail Count Error" ],
   "IILB_FAST_TAIL_UPR_ERROR"     => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Upper Error" ],
   "NI1_FAST_TAIL_UPR_ERROR"      => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Upper Error" ],
   "NI0_FAST_TAIL_UPR_ERROR"      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Upper Error" ],
   "IILB_FAST_TAIL_LWR_ERROR"     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Lower Error" ],
   "NI1_FAST_TAIL_LWR_ERROR"      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Lower Error" ],
   "NI0_FAST_TAIL_LWR_ERROR"      => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Lower Error" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Underflow" ],
   "NI1_FAST_TAIL_UNDERFLOW"      => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Underflow" ],
   "NI0_FAST_TAIL_UNDERFLOW"      => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Underflow" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "IILB Fast Tail Overflow" ],
   "NI1_FAST_TAIL_OVERFLOW"       => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI1 Fast Tail Overflow" ],
   "NI0_FAST_TAIL_OVERFLOW"       => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI0 Fast Tail Overflow" ],
   "OVERFLOW_CREDIT_MGR_VC2"      => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC2"     => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "VC2 Credit Manager Underflow" ],
   "OVERFLOW_CREDIT_MGR_VC0"      => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Overflow" ],
   "UNDERFLOW_CREDIT_MGR_VC0"     => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "VC0 Credit Manager Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC2"   => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC2"  => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "VC2 Steering FIFO Underflow" ],
   "OVERFLOW_STEERING_FIFO_VC0"   => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Overflow" ],
   "UNDERFLOW_STEERING_FIFO_VC0"  => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "VC0 Steering FIFO Underflow" ],
   "OVERFLOW_NI1_VC3_CREDIT"      => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Overflow" ],
   "UNDERFLOW_NI1_VC3_CREDIT"     => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 Credit Underflow" ],
   "OVERFLOW_NI1_VC1_CREDIT"      => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Overflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT"     => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 Credit Underflow" ],
   "OVERFLOW_NI0_VC3_CREDIT"      => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Overflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT"     => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 Credit Underflow" ],
   "OVERFLOW_NI0_VC1_CREDIT"      => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Overflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT"     => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 Credit Underflow" ],
   "OVERFLOW_NI1_DEBIT3"          => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 3 Overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 1 Overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 3 Overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 1 Overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT"     => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Overflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT"    => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Underflow" ],
   "OVERFLOW_IILB_VC0_CREDIT"     => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Overflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT"    => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Underflow" ],
   "OVERFLOW_NI1_VC2_CREDIT"      => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT"     => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Underflow" ],
   "OVERFLOW_NI1_VC0_CREDIT"      => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Overflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT"     => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Underflow" ],
   "OVERFLOW_NI0_VC2_CREDIT"      => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Overflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT"     => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Underflow" ],
   "OVERFLOW_NI0_VC0_CREDIT"      => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Overflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT"     => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Underflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "IILB Debit 2 Overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "IILB Debit 0 Overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 Debit 2 Overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 Debit 0 Overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI0 Debit 2 Overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI0 Debit 0 Overflow" ],
   "OVERFLOW_SIC_CNTR2"           => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Overflow" ],
   "UNDERFLOW_SIC_CNTR2"          => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Underflow" ],
   "OVERFLOW_SIC_CNTR0"           => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Overflow" ],
   "UNDERFLOW_SIC_CNTR0"          => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Underflow" ],
   "RSVD0"                        => [  57,   3,   4, 0x0000000000000078, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_READ_ERROR"               => [  58,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "OVERFLOW_VC2_CREDIT"          => [  59,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "VC2 Credit overflow" ],
   "OVERFLOW_VC0_CREDIT"          => [  60,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "VC0 Credit overflow" ],
);

%shub2_01_01171_def =
( NAME    => "SH2_XNMD_FIRST_ERROR",
  ADDRESS => 0x0000000050040460,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01171_flds
);


##########################################################################
#                                                                        #
#   SH2_XNMD_ERROR_SUMMARY_1                                             #
#                                                                        #
##########################################################################

%shub2_01_01172_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNCOR_ERROR3"                 => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 255:192" ],
   "UNCOR_ERROR2"                 => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 191:128" ],
   "UNCOR_ERROR1"                 => [   3,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 127:64" ],
   "UNCOR_ERROR0"                 => [   4,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 63:0" ],
   "SINGLE_BIT_ERROR3"            => [   5,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 255:192" ],
   "SINGLE_BIT_ERROR2"            => [   6,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 191:128" ],
   "SINGLE_BIT_ERROR1"            => [   7,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 127:64" ],
   "SINGLE_BIT_ERROR0"            => [   8,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 63:0" ],
);

%shub2_01_01172_def =
( NAME    => "SH2_XNMD_ERROR_SUMMARY_1",
  ADDRESS => 0x0000000050040410,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01172_flds
);


##########################################################################
#                                                                        #
#   SH2_XNMD_ERROR_SUMMARY_ALIAS_1                                       #
#                                                                        #
##########################################################################

%shub2_01_01173_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNCOR_ERROR3"                 => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 255:192" ],
   "UNCOR_ERROR2"                 => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 191:128" ],
   "UNCOR_ERROR1"                 => [   3,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 127:64" ],
   "UNCOR_ERROR0"                 => [   4,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 63:0" ],
   "SINGLE_BIT_ERROR3"            => [   5,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 255:192" ],
   "SINGLE_BIT_ERROR2"            => [   6,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 191:128" ],
   "SINGLE_BIT_ERROR1"            => [   7,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 127:64" ],
   "SINGLE_BIT_ERROR0"            => [   8,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 63:0" ],
);

%shub2_01_01173_def =
( NAME    => "SH2_XNMD_ERROR_SUMMARY_ALIAS_1",
  ADDRESS => 0x0000000050040418,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01173_flds
);


##########################################################################
#                                                                        #
#   SH2_XNMD_ERROR_OVERFLOW_1                                            #
#                                                                        #
##########################################################################

%shub2_01_01174_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNCOR_ERROR3"                 => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 255:192" ],
   "UNCOR_ERROR2"                 => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 191:128" ],
   "UNCOR_ERROR1"                 => [   3,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 127:64" ],
   "UNCOR_ERROR0"                 => [   4,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 63:0" ],
   "SINGLE_BIT_ERROR3"            => [   5,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 255:192" ],
   "SINGLE_BIT_ERROR2"            => [   6,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 191:128" ],
   "SINGLE_BIT_ERROR1"            => [   7,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 127:64" ],
   "SINGLE_BIT_ERROR0"            => [   8,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 63:0" ],
);

%shub2_01_01174_def =
( NAME    => "SH2_XNMD_ERROR_OVERFLOW_1",
  ADDRESS => 0x0000000050040430,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01174_flds
);


##########################################################################
#                                                                        #
#   SH2_XNMD_ERROR_OVERFLOW_ALIAS_1                                      #
#                                                                        #
##########################################################################

%shub2_01_01175_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNCOR_ERROR3"                 => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 255:192" ],
   "UNCOR_ERROR2"                 => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 191:128" ],
   "UNCOR_ERROR1"                 => [   3,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 127:64" ],
   "UNCOR_ERROR0"                 => [   4,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 63:0" ],
   "SINGLE_BIT_ERROR3"            => [   5,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 255:192" ],
   "SINGLE_BIT_ERROR2"            => [   6,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 191:128" ],
   "SINGLE_BIT_ERROR1"            => [   7,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 127:64" ],
   "SINGLE_BIT_ERROR0"            => [   8,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 63:0" ],
);

%shub2_01_01175_def =
( NAME    => "SH2_XNMD_ERROR_OVERFLOW_ALIAS_1",
  ADDRESS => 0x0000000050040438,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01175_flds
);


##########################################################################
#                                                                        #
#   SH2_XNMD_ERROR_MASK_1                                                #
#                                                                        #
##########################################################################

%shub2_01_01176_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNCOR_ERROR3"                 => [   1,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Uncorrectable Error in Bits 255:192" ],
   "UNCOR_ERROR2"                 => [   2,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Uncorrectable Error in Bits 191:128" ],
   "UNCOR_ERROR1"                 => [   3,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Uncorrectable Error in Bits 127:64" ],
   "UNCOR_ERROR0"                 => [   4,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Uncorrectable Error in Bits 63:0" ],
   "SINGLE_BIT_ERROR3"            => [   5,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Single Bit Error in Bits 255:192" ],
   "SINGLE_BIT_ERROR2"            => [   6,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Single Bit Error in Bits 191:128" ],
   "SINGLE_BIT_ERROR1"            => [   7,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Single Bit Error in Bits 127:64" ],
   "SINGLE_BIT_ERROR0"            => [   8,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Single Bit Error in Bits 63:0" ],
);

%shub2_01_01176_def =
( NAME    => "SH2_XNMD_ERROR_MASK_1",
  ADDRESS => 0x0000000050040450,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01176_flds
);


##########################################################################
#                                                                        #
#   SH2_XNMD_FIRST_ERROR_1                                               #
#                                                                        #
##########################################################################

%shub2_01_01177_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNCOR_ERROR3"                 => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 255:192" ],
   "UNCOR_ERROR2"                 => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 191:128" ],
   "UNCOR_ERROR1"                 => [   3,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 127:64" ],
   "UNCOR_ERROR0"                 => [   4,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 63:0" ],
   "SINGLE_BIT_ERROR3"            => [   5,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 255:192" ],
   "SINGLE_BIT_ERROR2"            => [   6,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 191:128" ],
   "SINGLE_BIT_ERROR1"            => [   7,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 127:64" ],
   "SINGLE_BIT_ERROR0"            => [   8,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 63:0" ],
);

%shub2_01_01177_def =
( NAME    => "SH2_XNMD_FIRST_ERROR_1",
  ADDRESS => 0x0000000050040470,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01177_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_ERROR_SUMMARY                                                 #
#                                                                        #
##########################################################################

%shub2_01_01178_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  13,  51, 0xFFFFFFFFFFFFE000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_RSP_CRED_OF_ERR"           => [   1,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "XN Response Credit Overflow Error" ],
   "XN_REQ_CRED_OF_ERR"           => [   2,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "XN Request Credit Overflow Error" ],
   "CRB_NACK_LIMIT_ERR"           => [   3,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "CRB NACK Limit Error" ],
   "CRB_TO_ERR"                   => [   4,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "CRB Timeout Error" ],
   "XN_RSP_ACC_ERR"               => [   5,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "XN Response Access Error" ],
   "XN_RSP_UNEXP_ERR"             => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "XN Response Unexpected Error" ],
   "XN_RSP_DSB_ERR"               => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "XN Response Data Sideband Error" ],
   "XN_RSP_LG_ERR"                => [   8,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "XN Response Long" ],
   "XN_RSP_SH_ERR"                => [   9,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "XN Response Short Error" ],
   "XN_RSP_HEAD_ERR"              => [  10,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "XN Response Header Error" ],
   "XN_REQ_HEAD_ERR"              => [  11,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "XN Request Header Error" ],
   "XN_RSP_INV_ERR"               => [  12,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "XN Response Invalid Error" ],
   "XN_REQ_INV_ERR"               => [  13,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "XN Request Invalid Error" ],
);

%shub2_01_01178_def =
( NAME    => "SH2_BT_ERROR_SUMMARY",
  ADDRESS => 0x0000000030000000,
  NOTE    => "This register holds error summary information for the BTE. Note: note Masked bits in the SH2_BTE_ERROR_MASK register have NO eff",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01178_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_ERROR_SUMMARY_ALIAS                                           #
#                                                                        #
##########################################################################

%shub2_01_01179_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  13,  51, 0xFFFFFFFFFFFFE000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_RSP_CRED_OF_ERR"           => [   1,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "XN Response Credit Overflow Error" ],
   "XN_REQ_CRED_OF_ERR"           => [   2,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "XN Request Credit Overflow Error" ],
   "CRB_NACK_LIMIT_ERR"           => [   3,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "CRB NACK Limit Error" ],
   "CRB_TO_ERR"                   => [   4,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "CRB Timeout Error" ],
   "XN_RSP_ACC_ERR"               => [   5,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "XN Response Access Error" ],
   "XN_RSP_UNEXP_ERR"             => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "XN Response Unexpected Error" ],
   "XN_RSP_DSB_ERR"               => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "XN Response Data Sideband Error" ],
   "XN_RSP_LG_ERR"                => [   8,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "XN Response Long" ],
   "XN_RSP_SH_ERR"                => [   9,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "XN Response Short Error" ],
   "XN_RSP_HEAD_ERR"              => [  10,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "XN Response Header Error" ],
   "XN_REQ_HEAD_ERR"              => [  11,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "XN Request Header Error" ],
   "XN_RSP_INV_ERR"               => [  12,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "XN Response Invalid Error" ],
   "XN_REQ_INV_ERR"               => [  13,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "XN Request Invalid Error" ],
);

%shub2_01_01179_def =
( NAME    => "SH2_BT_ERROR_SUMMARY_ALIAS",
  ADDRESS => 0x0000000030000080,
  NOTE    => "Each bit in this register maps one-to-one to the bits in the Error note Summary register. All non-reserved bits have W1C access ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01179_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_ERROR_OVERFLOW                                                #
#                                                                        #
##########################################################################

%shub2_01_01180_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  13,  51, 0xFFFFFFFFFFFFE000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_RSP_CRED_OF_ERR"           => [   1,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "XN Response Credit Overflow Error" ],
   "XN_REQ_CRED_OF_ERR"           => [   2,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "XN Request Credit Overflow Error" ],
   "CRB_NACK_LIMIT_ERR"           => [   3,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "CRB NACK Limit Error" ],
   "CRB_TO_ERR"                   => [   4,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "CRB Timeout Error" ],
   "XN_RSP_ACC_ERR"               => [   5,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "XN Response Access Error" ],
   "XN_RSP_UNEXP_ERR"             => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "XN Response Unexpected Error" ],
   "XN_RSP_DSB_ERR"               => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "XN Response Data Sideband Error" ],
   "XN_RSP_LG_ERR"                => [   8,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "XN Response Long" ],
   "XN_RSP_SH_ERR"                => [   9,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "XN Response Short Error" ],
   "XN_RSP_HEAD_ERR"              => [  10,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "XN Response Header Error" ],
   "XN_REQ_HEAD_ERR"              => [  11,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "XN Request Header Error" ],
   "XN_RSP_INV_ERR"               => [  12,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "XN Response Invalid Error" ],
   "XN_REQ_INV_ERR"               => [  13,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "XN Request Invalid Error" ],
);

%shub2_01_01180_def =
( NAME    => "SH2_BT_ERROR_OVERFLOW",
  ADDRESS => 0x0000000030000100,
  NOTE    => "This register holds error summary for BTE errors that occur a note second time before the Error Summary register is cleared. The",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01180_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_ERROR_OVERFLOW_ALIAS                                          #
#                                                                        #
##########################################################################

%shub2_01_01181_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  13,  51, 0xFFFFFFFFFFFFE000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_RSP_CRED_OF_ERR"           => [   1,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "XN Response Credit Overflow Error" ],
   "XN_REQ_CRED_OF_ERR"           => [   2,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "XN Request Credit Overflow Error" ],
   "CRB_NACK_LIMIT_ERR"           => [   3,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "CRB NACK Limit Error" ],
   "CRB_TO_ERR"                   => [   4,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "CRB Timeout Error" ],
   "XN_RSP_ACC_ERR"               => [   5,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "XN Response Access Error" ],
   "XN_RSP_UNEXP_ERR"             => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "XN Response Unexpected Error" ],
   "XN_RSP_DSB_ERR"               => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "XN Response Data Sideband Error" ],
   "XN_RSP_LG_ERR"                => [   8,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "XN Response Long" ],
   "XN_RSP_SH_ERR"                => [   9,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "XN Response Short Error" ],
   "XN_RSP_HEAD_ERR"              => [  10,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "XN Response Header Error" ],
   "XN_REQ_HEAD_ERR"              => [  11,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "XN Request Header Error" ],
   "XN_RSP_INV_ERR"               => [  12,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "XN Response Invalid Error" ],
   "XN_REQ_INV_ERR"               => [  13,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "XN Request Invalid Error" ],
);

%shub2_01_01181_def =
( NAME    => "SH2_BT_ERROR_OVERFLOW_ALIAS",
  ADDRESS => 0x0000000030000180,
  NOTE    => "This is an alias to clear select bits in the Error Overflow note Register. Each bit in this register maps one-to-one to the bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01181_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_FIRST_ERROR                                                   #
#                                                                        #
##########################################################################

%shub2_01_01182_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  13,  51, 0xFFFFFFFFFFFFE000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_RSP_CRED_OF_ERR"           => [   1,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "XN Response Credit Overflow Error" ],
   "XN_REQ_CRED_OF_ERR"           => [   2,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "XN Request Credit Overflow Error" ],
   "CRB_NACK_LIMIT_ERR"           => [   3,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "CRB NACK Limit Error" ],
   "CRB_TO_ERR"                   => [   4,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "CRB Timeout Error" ],
   "XN_RSP_ACC_ERR"               => [   5,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "XN Response Access Error" ],
   "XN_RSP_UNEXP_ERR"             => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "XN Response Unexpected Error" ],
   "XN_RSP_DSB_ERR"               => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "XN Response Data Sideband Error" ],
   "XN_RSP_LG_ERR"                => [   8,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "XN Response Long" ],
   "XN_RSP_SH_ERR"                => [   9,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "XN Response Short Error" ],
   "XN_RSP_HEAD_ERR"              => [  10,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "XN Response Header Error" ],
   "XN_REQ_HEAD_ERR"              => [  11,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "XN Request Header Error" ],
   "XN_RSP_INV_ERR"               => [  12,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "XN Response Invalid Error" ],
   "XN_REQ_INV_ERR"               => [  13,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "XN Request Invalid Error" ],
);

%shub2_01_01182_def =
( NAME    => "SH2_BT_FIRST_ERROR",
  ADDRESS => 0x0000000030000200,
  NOTE    => "This register holds first error summary for the BTE. Once the Error note Summary register is cleared, the next error(s) that occ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01182_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_ERROR_MASK                                                    #
#                                                                        #
##########################################################################

%shub2_01_01183_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  13,  51, 0xFFFFFFFFFFFFE000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_RSP_CRED_OF_ERR"           => [   1,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "XN Response Credit Overflow Error" ],
   "XN_REQ_CRED_OF_ERR"           => [   2,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "XN Request Credit Overflow Error" ],
   "CRB_NACK_LIMIT_ERR"           => [   3,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "CRB NACK Limit Error" ],
   "CRB_TO_ERR"                   => [   4,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "CRB Timeout Error" ],
   "XN_RSP_ACC_ERR"               => [   5,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "XN Response Access Error" ],
   "XN_RSP_UNEXP_ERR"             => [   6,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "XN Response Unexpected Error" ],
   "XN_RSP_DSB_ERR"               => [   7,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "XN Response Data Sideband Error" ],
   "XN_RSP_LG_ERR"                => [   8,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "XN Response Long" ],
   "XN_RSP_SH_ERR"                => [   9,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "XN Response Short Error" ],
   "XN_RSP_HEAD_ERR"              => [  10,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "XN Response Header Error" ],
   "XN_REQ_HEAD_ERR"              => [  11,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "XN Request Header Error" ],
   "XN_RSP_INV_ERR"               => [  12,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "XN Response Invalid Error" ],
   "XN_REQ_INV_ERR"               => [  13,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "XN Request Invalid Error" ],
);

%shub2_01_01183_def =
( NAME    => "SH2_BT_ERROR_MASK",
  ADDRESS => 0x0000000030000280,
  NOTE    => "Bits set in this register will mask out the corresponding bits in note the First Error register and prevent the capture of error",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01183_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_DEBUG_TRIG_COMPARE                                            #
#                                                                        #
##########################################################################

%shub2_01_01184_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_TRIG_CMP"               => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Debug Trigger Compare Pattern" ],
);

%shub2_01_01184_def =
( NAME    => "SH2_BT_DEBUG_TRIG_COMPARE",
  ADDRESS => 0x0000000030000800,
  NOTE    => "This register holds the debug compare value for triggers via the note Debug Port. Upon a match between trigger data and debug_tr",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01184_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_DEBUG_TRIG_SELECT                                             #
#                                                                        #
##########################################################################

%shub2_01_01185_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_TRIG_NIB7_SEL"          => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Debug nibble group 7 select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_TRIG_DATA7_SEL"         => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Debug data group 7 select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_TRIG_NIB6_SEL"          => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Debug nibble group 6 select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_TRIG_DATA6_SEL"         => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Debug data group 6 select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_TRIG_NIB5_SEL"          => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Debug nibble group 5 select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_TRIG_DATA5_SEL"         => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Debug data group 5 select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_TRIG_NIB4_SEL"          => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Debug nibble group 4 select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_TRIG_DATA4_SEL"         => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Debug data group 4 select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_TRIG_NIB3_SEL"          => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Debug nibble group 3 select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_TRIG_DATA3_SEL"         => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Debug data group 3 select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_TRIG_NIB2_SEL"          => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Debug nibble group 2 select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_TRIG_DATA2_SEL"         => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Debug data group 2 select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_TRIG_NIB1_SEL"          => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Debug nibble group 1 select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_TRIG_DATA1_SEL"         => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Debug data group 1 select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_TRIG_NIB0_SEL"          => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Debug nibble group 0 select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_TRIG_DATA0_SEL"         => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Debug data group 0 select" ],
);

%shub2_01_01185_def =
( NAME    => "SH2_BT_DEBUG_TRIG_SELECT",
  ADDRESS => 0x0000000030000880,
  NOTE    => "This register holds the settings for the BTE DEBUG port data and note nibble selects for trigger functionality.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01185_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_DEBUG_TRIG_ENABLE                                             #
#                                                                        #
##########################################################################

%shub2_01_01186_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_TRIG_CMP_EN"            => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Debug Trigger Compare Enable" ],
);

%shub2_01_01186_def =
( NAME    => "SH2_BT_DEBUG_TRIG_ENABLE",
  ADDRESS => 0x0000000030000900,
  NOTE    => "This holds the debug compare enable bits for triggers via the Debug note Port. If a bit is 1, the corresponding bit of the trigg",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01186_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_DEBUG_MUX_SELECT                                              #
#                                                                        #
##########################################################################

%shub2_01_01187_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DEBUG_TRIG_EN"                => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Debug Trigger Select" ],
   "DEBUG_NIB7_SEL"               => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Debug nibble group 7 select" ],
   "RSVD0"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_DATA7_SEL"              => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Debug data group 7 select" ],
   "RSVD1"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_NIB6_SEL"               => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Debug nibble group 6 select" ],
   "RSVD2"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_DATA6_SEL"              => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Debug data group 6 select" ],
   "RSVD3"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_NIB5_SEL"               => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Debug nibble group 5 select" ],
   "RSVD4"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_DATA5_SEL"              => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Debug data group 5 select" ],
   "RSVD5"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_NIB4_SEL"               => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Debug nibble group 4 select" ],
   "RSVD6"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_DATA4_SEL"              => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Debug data group 4 select" ],
   "RSVD7"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_NIB3_SEL"               => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Debug nibble group 3 select" ],
   "RSVD8"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_DATA3_SEL"              => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Debug data group 3 select" ],
   "RSVD9"                        => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_NIB2_SEL"               => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Debug nibble group 2 select" ],
   "RSVD10"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_DATA2_SEL"              => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Debug data group 2 select" ],
   "RSVD11"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_NIB1_SEL"               => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Debug nibble group 1 select" ],
   "RSVD12"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_DATA1_SEL"              => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Debug data group 1 select" ],
   "RSVD13"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_NIB0_SEL"               => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Debug nibble group 0 select" ],
   "RSVD14"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_DATA0_SEL"              => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Debug data group 0 select" ],
);

%shub2_01_01187_def =
( NAME    => "SH2_BT_DEBUG_MUX_SELECT",
  ADDRESS => 0x0000000030000980,
  NOTE    => "This register holds the settings for the BTE DEBUG port data and note nibble selects.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01187_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_TIMEOUT_PULSE                                                 #
#                                                                        #
##########################################################################

%shub2_01_01188_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  13,  51, 0xFFFFFFFFFFFFE000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIMEOUT_PULSE"                => [   1,   0,  13, 0x0000000000001FFF, 0x00, 1, 0x0000000000000000, "Timeout Pulse Control" ],
);

%shub2_01_01188_def =
( NAME    => "SH2_BT_TIMEOUT_PULSE",
  ADDRESS => 0x0000000030001000,
  NOTE    => "This register holds the programmable timeout pulse value for the note BTE timeout pulse counter. The timeout pulse counter count",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01188_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_TIMEOUT_PRESCALE                                              #
#                                                                        #
##########################################################################

%shub2_01_01189_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  20,  44, 0xFFFFFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIMEOUT_PRESCALE"             => [   1,   0,  20, 0x00000000000FFFFF, 0x00, 1, 0x0000000000000000, "Timeout Prescale" ],
);

%shub2_01_01189_def =
( NAME    => "SH2_BT_TIMEOUT_PRESCALE",
  ADDRESS => 0x0000000030001080,
  NOTE    => "This register holds the programmable timeout prescale value for the note BTE timeout prescale counter. The timeout prescale coun",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01189_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_REQ_NACK_LIMIT                                                #
#                                                                        #
##########################################################################

%shub2_01_01190_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  12,  52, 0xFFFFFFFFFFFFF000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_NACK_LIMIT"               => [   1,   0,  12, 0x0000000000000FFF, 0x00, 1, 0x0000000000000000, "Programmable NACK Limit" ],
);

%shub2_01_01190_def =
( NAME    => "SH2_BT_REQ_NACK_LIMIT",
  ADDRESS => 0x0000000030001100,
  NOTE    => "This is the programmable NACK limit for the BTE request controller. note",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01190_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_REQ_PRIORITY                                                  #
#                                                                        #
##########################################################################

%shub2_01_01191_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   4,  60, 0xFFFFFFFFFFFFFFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_PRIORITY"                 => [   1,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Programmable NACKed Request Priority" ],
);

%shub2_01_01191_def =
( NAME    => "SH2_BT_REQ_PRIORITY",
  ADDRESS => 0x0000000030001180,
  NOTE    => "This is to set the increments for NACKed request priority.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01191_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_XN_DATA_COMP_0                                                #
#                                                                        #
##########################################################################

%shub2_01_01192_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "XN_DATA_COMP_0"               => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "XN Data Compare 0" ],
);

%shub2_01_01192_def =
( NAME    => "SH2_BT_XN_DATA_COMP_0",
  ADDRESS => 0x0000000030010800,
  NOTE    => "This register is used in conjunction with the XN_DATA_ENABLE_0 note register to generate a pulse to the debug port when data is ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01192_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_XN_DATA_COMP_1                                                #
#                                                                        #
##########################################################################

%shub2_01_01193_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "XN_DATA_COMP_1"               => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "XN Data Compare 1" ],
);

%shub2_01_01193_def =
( NAME    => "SH2_BT_XN_DATA_COMP_1",
  ADDRESS => 0x0000000030010880,
  NOTE    => "This register is used in conjunction with the XN_DATA_ENABLE_1 note register to generate a pulse to the debug port when data is ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01193_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_XN_DATA_ENABLE_0                                              #
#                                                                        #
##########################################################################

%shub2_01_01194_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "XN_DATA_ENABLE_0"             => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "XN Data Enable 0" ],
);

%shub2_01_01194_def =
( NAME    => "SH2_BT_XN_DATA_ENABLE_0",
  ADDRESS => 0x0000000030010900,
  NOTE    => "This register is used in conjunction with the XN_DATA_COMPARE_0 note register to generate a pulse to the debug port when data is",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01194_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_XN_DATA_ENABLE_1                                              #
#                                                                        #
##########################################################################

%shub2_01_01195_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "XN_DATA_ENABLE_1"             => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "XN Data Enable 1" ],
);

%shub2_01_01195_def =
( NAME    => "SH2_BT_XN_DATA_ENABLE_1",
  ADDRESS => 0x0000000030010980,
  NOTE    => "This register is used in conjunction with the XN_DATA_COMPARE_1 note register to generate a pulse to the debug port when data is",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01195_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_NIQ_CREDIT_CFG                                                #
#                                                                        #
##########################################################################

%shub2_01_01196_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIQ_RSP_CREDIT_LIMIT"         => [   1,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "NIQ Response Credit Limit" ],
   "NIQ_REQ_CREDIT_LIMIT"         => [   2,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "NIQ Request Credit Limit" ],
);

%shub2_01_01196_def =
( NAME    => "SH2_BT_NIQ_CREDIT_CFG",
  ADDRESS => 0x0000000030011000,
  NOTE    => "This register contains the configuration information needed by the note Network Input Queue.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01196_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_NIQ_DYN_CREDIT_STAT                                           #
#                                                                        #
##########################################################################

%shub2_01_01197_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIQ_RSP_CREDIT_CNT"           => [   1,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "NIQ Response Credit Count" ],
   "NIQ_REQ_CREDIT_CNT"           => [   2,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "NIQ Request Credit Count" ],
);

%shub2_01_01197_def =
( NAME    => "SH2_BT_NIQ_DYN_CREDIT_STAT",
  ADDRESS => 0x0000000030011080,
  NOTE    => "This register holds the current state of the credit counters that note are used in the Network Input Queue.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01197_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_NIQ_LAST_CREDIT_STAT                                          #
#                                                                        #
##########################################################################

%shub2_01_01198_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIQ_RSP_CREDIT_CNT"           => [   1,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "NIQ Response Credit Count" ],
   "NIQ_REQ_CREDIT_CNT"           => [   2,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "NIQ Request Credit Count" ],
);

%shub2_01_01198_def =
( NAME    => "SH2_BT_NIQ_LAST_CREDIT_STAT",
  ADDRESS => 0x0000000030011100,
  NOTE    => "This register holds the state of the credit counters that are used note in the Network Input Queue when a soft reset is issued. ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01198_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_HQ_VALID_DETAIL                                               #
#                                                                        #
##########################################################################

%shub2_01_01199_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HQ_VALID_15_0"                => [   1,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "PIO Head Queue Valid Bits 15:0" ],
);

%shub2_01_01199_def =
( NAME    => "SH2_BT_HQ_VALID_DETAIL",
  ADDRESS => 0x0000000030011180,
  NOTE    => "This register holds the head queue valid bits for head queue note entries 0 to 15.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01199_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_HQ_ENTRY_0                                                    #
#                                                                        #
##########################################################################

%shub2_01_01200_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   6,  58, 0xFFFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HQ_VAL"                       => [   1,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "PIO Head Queue 0 Valid" ],
   "HQ_NACK_REC"                  => [   2,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "PIO Head Queue 0 NACK Received" ],
   "HQ_CRB_NUM"                   => [   3,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "PIO Head Queue 0 CRB Number" ],
);

%shub2_01_01200_def =
( NAME    => "SH2_BT_HQ_ENTRY_0",
  ADDRESS => 0x0000000030011200,
  NOTE    => "This register holds the contents of the head queue entry that is at note the top of the head queue.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01200_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_HQ_EJECT                                                      #
#                                                                        #
##########################################################################

%shub2_01_01201_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EJECT_HEAD"                   => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "PIO Head Queue Eject Head" ],
);

%shub2_01_01201_def =
( NAME    => "SH2_BT_HQ_EJECT",
  ADDRESS => 0x0000000030011280,
  NOTE    => "This register is intended to be used as a diagnostic register and note gives software the ability to pop head queue entry 0 off ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01201_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_XN_ERROR_DETAIL_1                                             #
#                                                                        #
##########################################################################

%shub2_01_01202_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid" ],
   "RSVD0"                        => [   1,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECHO"                         => [   2,  52,   9, 0x1FF0000000000000, 0x00, 0, 0x0000000000000000, "Echo Field" ],
   "RSVD1"                        => [   3,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_ERROR"                   => [   4,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "Data Error" ],
   "RSVD2"                        => [   5,  42,   7, 0x0001FC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DESTINATION_ID"               => [   6,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "Message Destination Chiplet ID" ],
   "SOURCE_CHIPLET_ID"            => [   7,  38,   2, 0x000000C000000000, 0x00, 0, 0x0000000000000000, "Message Source ID" ],
   "SOURCE_NODE_ID"               => [   8,  24,  14, 0x0000003FFF000000, 0x00, 0, 0x0000000000000000, "Message Source ID" ],
   "SUPPLEMENTAL"                 => [   9,   8,  16, 0x0000000000FFFF00, 0x00, 0, 0x0000000000000000, "Message Supplemental Field" ],
   "COMMAND"                      => [  10,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Message Command" ],
);

%shub2_01_01202_def =
( NAME    => "SH2_BT_XN_ERROR_DETAIL_1",
  ADDRESS => 0x0000000030020000,
  NOTE    => "This register contains data fields captured from the header of a note bad messsage received from the network. It captures the fi",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01202_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_XN_ERROR_DETAIL_2                                             #
#                                                                        #
##########################################################################

%shub2_01_01203_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  52,  12, 0xFFF0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDRESS"                      => [   1,   3,  49, 0x000FFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "Message Address" ],
);

%shub2_01_01203_def =
( NAME    => "SH2_BT_XN_ERROR_DETAIL_2",
  ADDRESS => 0x0000000030020080,
  NOTE    => "This register captures the address field of the network message note when an error is detected. It is triggered for the same err",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01203_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_ENG_ERROR_STAT                                                #
#                                                                        #
##########################################################################

%shub2_01_01204_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_HOLD3"                    => [   1,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Engine 3 CRB Hold" ],
   "RSVD1"                        => [   2,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_VALID3"                   => [   3,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "Engine 3 CRB valid" ],
   "ERROR3"                       => [   4,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Engine 3 error" ],
   "BUSY3"                        => [   5,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Engine 3 busy" ],
   "CRB_HOLD2"                    => [   6,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Engine 2 CRB Hold" ],
   "RSVD2"                        => [   7,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_VALID2"                   => [   8,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "Engine 2 CRB valid" ],
   "ERROR2"                       => [   9,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "Engine 2 error" ],
   "BUSY2"                        => [  10,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Engine 2 busy" ],
   "CRB_HOLD1"                    => [  11,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Engine 1 CRB Hold" ],
   "RSVD3"                        => [  12,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_VALID1"                   => [  13,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "Engine 1 CRB valid" ],
   "ERROR1"                       => [  14,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Engine 1 error" ],
   "BUSY1"                        => [  15,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Engine 1 busy" ],
   "CRB_HOLD0"                    => [  16,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Engine 0 CRB Hold" ],
   "RSVD4"                        => [  17,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_VALID0"                   => [  18,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Engine 0 CRB valid" ],
   "ERROR0"                       => [  19,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Engine 0 error" ],
   "BUSY0"                        => [  20,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Engine 0 busy" ],
);

%shub2_01_01204_def =
( NAME    => "SH2_BT_ENG_ERROR_STAT",
  ADDRESS => 0x0000000030020100,
  NOTE    => "This register provides current status of all four engines.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01204_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_XMIT_CFG                                                      #
#                                                                        #
##########################################################################

%shub2_01_01205_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 1, 0x0000000000000000, "scratch bits" ],
   "RSVD0"                        => [   1,  28,  32, 0x0FFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_RSP_CRED_CNT"             => [   2,  24,   4, 0x000000000F000000, 0x00, 1, 0x0000000000000000, "Maximum Response Credit Count" ],
   "RSVD1"                        => [   3,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_REQ_CRED_CNT"             => [   4,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "Maximum Request Credit Count" ],
   "RSVD2"                        => [   5,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "THROTTLE_ENABLE"              => [   6,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Transmit Throttle Enable" ],
   "GET_MSG_DISABLE"              => [   7,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Disable GET Messages" ],
   "RSVD3"                        => [   8,   9,   3, 0x0000000000000E00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RIQ_BYPASS_DISABLE"           => [   9,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Request Issue Queue disable" ],
   "RSVD4"                        => [  10,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_LIMIT"                 => [  11,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Engine Credit Limit" ],
);

%shub2_01_01205_def =
( NAME    => "SH2_BT_XMIT_CFG",
  ADDRESS => 0x0000000030021000,
  NOTE    => "Register to control BTE message generation and transmission.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01205_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_XMIT_DYN_CREDIT_STAT                                          #
#                                                                        #
##########################################################################

%shub2_01_01206_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  52,  12, 0xFFF0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_RSP_CREDIT"                => [   1,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "XN Response Credits" ],
   "RSVD1"                        => [   2,  36,  12, 0x0000FFF000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_REQ_CREDIT"                => [   3,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "XN Request Credits" ],
   "RSVD2"                        => [   4,  21,  11, 0x00000000FFE00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_AVAIL"                    => [   5,  16,   5, 0x00000000001F0000, 0x00, 1, 0x0000000000000000, "Number of CRBs available" ],
   "RSVD3"                        => [   6,   5,  11, 0x000000000000FFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_USED"                     => [   7,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Number of CRBs used" ],
);

%shub2_01_01206_def =
( NAME    => "SH2_BT_XMIT_DYN_CREDIT_STAT",
  ADDRESS => 0x0000000030021100,
  NOTE    => "This register contains the current values of the transmit credit note counters.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01206_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_XMIT_LAST_CREDIT_STAT                                         #
#                                                                        #
##########################################################################

%shub2_01_01207_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  52,  12, 0xFFF0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LAST_XN_RSP_CREDIT"           => [   1,  48,   4, 0x000F000000000000, 0x00, 0, 0x0000000000000000, "Last XN Response Credit" ],
   "RSVD1"                        => [   2,  36,  12, 0x0000FFF000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LAST_XN_REQ_CREDIT"           => [   3,  32,   4, 0x0000000F00000000, 0x00, 0, 0x0000000000000000, "Last XN Request Credit" ],
   "RSVD2"                        => [   4,  21,  11, 0x00000000FFE00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LAST_CRB_AVAIL"               => [   5,  16,   5, 0x00000000001F0000, 0x00, 0, 0x0000000000000000, "Last CRB Available" ],
   "RSVD3"                        => [   6,   5,  11, 0x000000000000FFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LAST_CRB_USED"                => [   7,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Last CRB Used" ],
);

%shub2_01_01207_def =
( NAME    => "SH2_BT_XMIT_LAST_CREDIT_STAT",
  ADDRESS => 0x0000000030021180,
  NOTE    => "This register contains the values of transmit counters immediately note prior to the last reset.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01207_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_IQ_STAT                                                       #
#                                                                        #
##########################################################################

%shub2_01_01208_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  49,  15, 0xFFFE000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AIQ_OUTPUT_VALID"             => [   1,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "Accelerated Issue Queue Output Valid" ],
   "RSVD1"                        => [   2,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AIQ_WRITE_ADDR"               => [   3,  40,   4, 0x00000F0000000000, 0x00, 1, 0x0000000000000000, "Accelerated Issue Queue Write Address" ],
   "RSVD2"                        => [   4,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AIQ_READ_ADDR"                => [   5,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "Accelerated Issue Queue Read Address" ],
   "RSVD3"                        => [   6,  17,  15, 0x00000000FFFE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RIQ_OUTPUT_VALID"             => [   7,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Request Issue Queue Output Valid" ],
   "RSVD4"                        => [   8,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RIQ_WRITE_ADDR"               => [   9,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "Request Issue Queue Write Address" ],
   "RSVD5"                        => [  10,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RIQ_READ_ADDR"                => [  11,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Request Issue Queue Read Address" ],
);

%shub2_01_01208_def =
( NAME    => "SH2_BT_IQ_STAT",
  ADDRESS => 0x0000000030021200,
  NOTE    => "Contains status information regarding the Request Issue Queue and note the Accelerated Request Issue Queue.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01208_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_STAT_0                                                    #
#                                                                        #
##########################################################################

%shub2_01_01209_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "RSVD0"                        => [   3,  47,  13, 0x0FFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_TIMEOUT"                  => [   4,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "CRB Timeout Error" ],
   "CRB_ERROR"                    => [   5,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "CRB Response Error" ],
   "CRB_ACCESS_ERROR"             => [   6,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "CRB Access Error" ],
   "RSVD1"                        => [   7,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_BTE_ID"                   => [   8,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "CRB Block Transfer Engine Number" ],
   "RSVD2"                        => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_STATE"                    => [  10,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [  11,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  12,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "RSVD3"                        => [  13,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  14,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%shub2_01_01209_def =
( NAME    => "SH2_BT_CRB_STAT_0",
  ADDRESS => 0x0000000030030000,
  NOTE    => "There are 16 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01209_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_STAT_1                                                    #
#                                                                        #
##########################################################################

%shub2_01_01210_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "RSVD0"                        => [   3,  47,  13, 0x0FFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_TIMEOUT"                  => [   4,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "CRB Timeout Error" ],
   "CRB_ERROR"                    => [   5,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "CRB Response Error" ],
   "CRB_ACCESS_ERROR"             => [   6,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "CRB Access Error" ],
   "RSVD1"                        => [   7,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_BTE_ID"                   => [   8,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "CRB Block Transfer Engine Number" ],
   "RSVD2"                        => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_STATE"                    => [  10,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [  11,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  12,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "RSVD3"                        => [  13,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  14,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%shub2_01_01210_def =
( NAME    => "SH2_BT_CRB_STAT_1",
  ADDRESS => 0x0000000030030200,
  NOTE    => "There are 16 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01210_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_STAT_2                                                    #
#                                                                        #
##########################################################################

%shub2_01_01211_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "RSVD0"                        => [   3,  47,  13, 0x0FFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_TIMEOUT"                  => [   4,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "CRB Timeout Error" ],
   "CRB_ERROR"                    => [   5,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "CRB Response Error" ],
   "CRB_ACCESS_ERROR"             => [   6,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "CRB Access Error" ],
   "RSVD1"                        => [   7,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_BTE_ID"                   => [   8,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "CRB Block Transfer Engine Number" ],
   "RSVD2"                        => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_STATE"                    => [  10,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [  11,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  12,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "RSVD3"                        => [  13,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  14,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%shub2_01_01211_def =
( NAME    => "SH2_BT_CRB_STAT_2",
  ADDRESS => 0x0000000030030400,
  NOTE    => "There are 16 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01211_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_STAT_3                                                    #
#                                                                        #
##########################################################################

%shub2_01_01212_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "RSVD0"                        => [   3,  47,  13, 0x0FFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_TIMEOUT"                  => [   4,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "CRB Timeout Error" ],
   "CRB_ERROR"                    => [   5,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "CRB Response Error" ],
   "CRB_ACCESS_ERROR"             => [   6,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "CRB Access Error" ],
   "RSVD1"                        => [   7,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_BTE_ID"                   => [   8,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "CRB Block Transfer Engine Number" ],
   "RSVD2"                        => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_STATE"                    => [  10,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [  11,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  12,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "RSVD3"                        => [  13,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  14,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%shub2_01_01212_def =
( NAME    => "SH2_BT_CRB_STAT_3",
  ADDRESS => 0x0000000030030600,
  NOTE    => "There are 16 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01212_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_STAT_4                                                    #
#                                                                        #
##########################################################################

%shub2_01_01213_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "RSVD0"                        => [   3,  47,  13, 0x0FFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_TIMEOUT"                  => [   4,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "CRB Timeout Error" ],
   "CRB_ERROR"                    => [   5,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "CRB Response Error" ],
   "CRB_ACCESS_ERROR"             => [   6,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "CRB Access Error" ],
   "RSVD1"                        => [   7,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_BTE_ID"                   => [   8,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "CRB Block Transfer Engine Number" ],
   "RSVD2"                        => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_STATE"                    => [  10,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [  11,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  12,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "RSVD3"                        => [  13,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  14,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%shub2_01_01213_def =
( NAME    => "SH2_BT_CRB_STAT_4",
  ADDRESS => 0x0000000030030800,
  NOTE    => "There are 16 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01213_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_STAT_5                                                    #
#                                                                        #
##########################################################################

%shub2_01_01214_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "RSVD0"                        => [   3,  47,  13, 0x0FFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_TIMEOUT"                  => [   4,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "CRB Timeout Error" ],
   "CRB_ERROR"                    => [   5,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "CRB Response Error" ],
   "CRB_ACCESS_ERROR"             => [   6,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "CRB Access Error" ],
   "RSVD1"                        => [   7,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_BTE_ID"                   => [   8,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "CRB Block Transfer Engine Number" ],
   "RSVD2"                        => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_STATE"                    => [  10,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [  11,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  12,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "RSVD3"                        => [  13,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  14,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%shub2_01_01214_def =
( NAME    => "SH2_BT_CRB_STAT_5",
  ADDRESS => 0x0000000030030a00,
  NOTE    => "There are 16 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01214_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_STAT_6                                                    #
#                                                                        #
##########################################################################

%shub2_01_01215_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "RSVD0"                        => [   3,  47,  13, 0x0FFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_TIMEOUT"                  => [   4,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "CRB Timeout Error" ],
   "CRB_ERROR"                    => [   5,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "CRB Response Error" ],
   "CRB_ACCESS_ERROR"             => [   6,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "CRB Access Error" ],
   "RSVD1"                        => [   7,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_BTE_ID"                   => [   8,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "CRB Block Transfer Engine Number" ],
   "RSVD2"                        => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_STATE"                    => [  10,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [  11,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  12,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "RSVD3"                        => [  13,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  14,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%shub2_01_01215_def =
( NAME    => "SH2_BT_CRB_STAT_6",
  ADDRESS => 0x0000000030030c00,
  NOTE    => "There are 16 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01215_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_STAT_7                                                    #
#                                                                        #
##########################################################################

%shub2_01_01216_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "RSVD0"                        => [   3,  47,  13, 0x0FFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_TIMEOUT"                  => [   4,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "CRB Timeout Error" ],
   "CRB_ERROR"                    => [   5,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "CRB Response Error" ],
   "CRB_ACCESS_ERROR"             => [   6,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "CRB Access Error" ],
   "RSVD1"                        => [   7,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_BTE_ID"                   => [   8,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "CRB Block Transfer Engine Number" ],
   "RSVD2"                        => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_STATE"                    => [  10,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [  11,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  12,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "RSVD3"                        => [  13,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  14,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%shub2_01_01216_def =
( NAME    => "SH2_BT_CRB_STAT_7",
  ADDRESS => 0x0000000030030e00,
  NOTE    => "There are 16 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01216_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_STAT_8                                                    #
#                                                                        #
##########################################################################

%shub2_01_01217_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "RSVD0"                        => [   3,  47,  13, 0x0FFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_TIMEOUT"                  => [   4,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "CRB Timeout Error" ],
   "CRB_ERROR"                    => [   5,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "CRB Response Error" ],
   "CRB_ACCESS_ERROR"             => [   6,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "CRB Access Error" ],
   "RSVD1"                        => [   7,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_BTE_ID"                   => [   8,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "CRB Block Transfer Engine Number" ],
   "RSVD2"                        => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_STATE"                    => [  10,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [  11,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  12,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "RSVD3"                        => [  13,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  14,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%shub2_01_01217_def =
( NAME    => "SH2_BT_CRB_STAT_8",
  ADDRESS => 0x0000000030031000,
  NOTE    => "There are 16 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01217_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_STAT_9                                                    #
#                                                                        #
##########################################################################

%shub2_01_01218_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "RSVD0"                        => [   3,  47,  13, 0x0FFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_TIMEOUT"                  => [   4,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "CRB Timeout Error" ],
   "CRB_ERROR"                    => [   5,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "CRB Response Error" ],
   "CRB_ACCESS_ERROR"             => [   6,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "CRB Access Error" ],
   "RSVD1"                        => [   7,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_BTE_ID"                   => [   8,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "CRB Block Transfer Engine Number" ],
   "RSVD2"                        => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_STATE"                    => [  10,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [  11,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  12,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "RSVD3"                        => [  13,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  14,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%shub2_01_01218_def =
( NAME    => "SH2_BT_CRB_STAT_9",
  ADDRESS => 0x0000000030031200,
  NOTE    => "There are 16 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01218_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_STAT_10                                                   #
#                                                                        #
##########################################################################

%shub2_01_01219_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "RSVD0"                        => [   3,  47,  13, 0x0FFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_TIMEOUT"                  => [   4,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "CRB Timeout Error" ],
   "CRB_ERROR"                    => [   5,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "CRB Response Error" ],
   "CRB_ACCESS_ERROR"             => [   6,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "CRB Access Error" ],
   "RSVD1"                        => [   7,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_BTE_ID"                   => [   8,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "CRB Block Transfer Engine Number" ],
   "RSVD2"                        => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_STATE"                    => [  10,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [  11,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  12,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "RSVD3"                        => [  13,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  14,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%shub2_01_01219_def =
( NAME    => "SH2_BT_CRB_STAT_10",
  ADDRESS => 0x0000000030031400,
  NOTE    => "There are 16 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01219_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_STAT_11                                                   #
#                                                                        #
##########################################################################

%shub2_01_01220_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "RSVD0"                        => [   3,  47,  13, 0x0FFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_TIMEOUT"                  => [   4,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "CRB Timeout Error" ],
   "CRB_ERROR"                    => [   5,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "CRB Response Error" ],
   "CRB_ACCESS_ERROR"             => [   6,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "CRB Access Error" ],
   "RSVD1"                        => [   7,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_BTE_ID"                   => [   8,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "CRB Block Transfer Engine Number" ],
   "RSVD2"                        => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_STATE"                    => [  10,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [  11,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  12,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "RSVD3"                        => [  13,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  14,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%shub2_01_01220_def =
( NAME    => "SH2_BT_CRB_STAT_11",
  ADDRESS => 0x0000000030031600,
  NOTE    => "There are 16 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01220_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_STAT_12                                                   #
#                                                                        #
##########################################################################

%shub2_01_01221_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "RSVD0"                        => [   3,  47,  13, 0x0FFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_TIMEOUT"                  => [   4,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "CRB Timeout Error" ],
   "CRB_ERROR"                    => [   5,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "CRB Response Error" ],
   "CRB_ACCESS_ERROR"             => [   6,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "CRB Access Error" ],
   "RSVD1"                        => [   7,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_BTE_ID"                   => [   8,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "CRB Block Transfer Engine Number" ],
   "RSVD2"                        => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_STATE"                    => [  10,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [  11,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  12,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "RSVD3"                        => [  13,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  14,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%shub2_01_01221_def =
( NAME    => "SH2_BT_CRB_STAT_12",
  ADDRESS => 0x0000000030031800,
  NOTE    => "There are 16 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01221_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_STAT_13                                                   #
#                                                                        #
##########################################################################

%shub2_01_01222_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "RSVD0"                        => [   3,  47,  13, 0x0FFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_TIMEOUT"                  => [   4,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "CRB Timeout Error" ],
   "CRB_ERROR"                    => [   5,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "CRB Response Error" ],
   "CRB_ACCESS_ERROR"             => [   6,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "CRB Access Error" ],
   "RSVD1"                        => [   7,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_BTE_ID"                   => [   8,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "CRB Block Transfer Engine Number" ],
   "RSVD2"                        => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_STATE"                    => [  10,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [  11,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  12,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "RSVD3"                        => [  13,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  14,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%shub2_01_01222_def =
( NAME    => "SH2_BT_CRB_STAT_13",
  ADDRESS => 0x0000000030031a00,
  NOTE    => "There are 16 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01222_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_STAT_14                                                   #
#                                                                        #
##########################################################################

%shub2_01_01223_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "RSVD0"                        => [   3,  47,  13, 0x0FFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_TIMEOUT"                  => [   4,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "CRB Timeout Error" ],
   "CRB_ERROR"                    => [   5,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "CRB Response Error" ],
   "CRB_ACCESS_ERROR"             => [   6,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "CRB Access Error" ],
   "RSVD1"                        => [   7,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_BTE_ID"                   => [   8,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "CRB Block Transfer Engine Number" ],
   "RSVD2"                        => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_STATE"                    => [  10,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [  11,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  12,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "RSVD3"                        => [  13,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  14,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%shub2_01_01223_def =
( NAME    => "SH2_BT_CRB_STAT_14",
  ADDRESS => 0x0000000030031c00,
  NOTE    => "There are 16 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01223_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_STAT_15                                                   #
#                                                                        #
##########################################################################

%shub2_01_01224_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "RSVD0"                        => [   3,  47,  13, 0x0FFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_TIMEOUT"                  => [   4,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "CRB Timeout Error" ],
   "CRB_ERROR"                    => [   5,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "CRB Response Error" ],
   "CRB_ACCESS_ERROR"             => [   6,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "CRB Access Error" ],
   "RSVD1"                        => [   7,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_BTE_ID"                   => [   8,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "CRB Block Transfer Engine Number" ],
   "RSVD2"                        => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_STATE"                    => [  10,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [  11,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  12,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "RSVD3"                        => [  13,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  14,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%shub2_01_01224_def =
( NAME    => "SH2_BT_CRB_STAT_15",
  ADDRESS => 0x0000000030031e00,
  NOTE    => "There are 16 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01224_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_SRC_ADDR_0                                                #
#                                                                        #
##########################################################################

%shub2_01_01225_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%shub2_01_01225_def =
( NAME    => "SH2_BT_CRB_SRC_ADDR_0",
  ADDRESS => 0x0000000030030080,
  NOTE    => "There are 16 of these registers, one for each CRB, and they contain note the address to fetch data from. This register is not va",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01225_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_SRC_ADDR_1                                                #
#                                                                        #
##########################################################################

%shub2_01_01226_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%shub2_01_01226_def =
( NAME    => "SH2_BT_CRB_SRC_ADDR_1",
  ADDRESS => 0x0000000030030280,
  NOTE    => "There are 16 of these registers, one for each CRB, and they contain note the address to fetch data from. This register is not va",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01226_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_SRC_ADDR_2                                                #
#                                                                        #
##########################################################################

%shub2_01_01227_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%shub2_01_01227_def =
( NAME    => "SH2_BT_CRB_SRC_ADDR_2",
  ADDRESS => 0x0000000030030480,
  NOTE    => "There are 16 of these registers, one for each CRB, and they contain note the address to fetch data from. This register is not va",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01227_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_SRC_ADDR_3                                                #
#                                                                        #
##########################################################################

%shub2_01_01228_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%shub2_01_01228_def =
( NAME    => "SH2_BT_CRB_SRC_ADDR_3",
  ADDRESS => 0x0000000030030680,
  NOTE    => "There are 16 of these registers, one for each CRB, and they contain note the address to fetch data from. This register is not va",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01228_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_SRC_ADDR_4                                                #
#                                                                        #
##########################################################################

%shub2_01_01229_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%shub2_01_01229_def =
( NAME    => "SH2_BT_CRB_SRC_ADDR_4",
  ADDRESS => 0x0000000030030880,
  NOTE    => "There are 16 of these registers, one for each CRB, and they contain note the address to fetch data from. This register is not va",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01229_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_SRC_ADDR_5                                                #
#                                                                        #
##########################################################################

%shub2_01_01230_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%shub2_01_01230_def =
( NAME    => "SH2_BT_CRB_SRC_ADDR_5",
  ADDRESS => 0x0000000030030a80,
  NOTE    => "There are 16 of these registers, one for each CRB, and they contain note the address to fetch data from. This register is not va",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01230_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_SRC_ADDR_6                                                #
#                                                                        #
##########################################################################

%shub2_01_01231_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%shub2_01_01231_def =
( NAME    => "SH2_BT_CRB_SRC_ADDR_6",
  ADDRESS => 0x0000000030030c80,
  NOTE    => "There are 16 of these registers, one for each CRB, and they contain note the address to fetch data from. This register is not va",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01231_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_SRC_ADDR_7                                                #
#                                                                        #
##########################################################################

%shub2_01_01232_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%shub2_01_01232_def =
( NAME    => "SH2_BT_CRB_SRC_ADDR_7",
  ADDRESS => 0x0000000030030e80,
  NOTE    => "There are 16 of these registers, one for each CRB, and they contain note the address to fetch data from. This register is not va",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01232_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_SRC_ADDR_8                                                #
#                                                                        #
##########################################################################

%shub2_01_01233_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%shub2_01_01233_def =
( NAME    => "SH2_BT_CRB_SRC_ADDR_8",
  ADDRESS => 0x0000000030031080,
  NOTE    => "There are 16 of these registers, one for each CRB, and they contain note the address to fetch data from. This register is not va",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01233_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_SRC_ADDR_9                                                #
#                                                                        #
##########################################################################

%shub2_01_01234_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%shub2_01_01234_def =
( NAME    => "SH2_BT_CRB_SRC_ADDR_9",
  ADDRESS => 0x0000000030031280,
  NOTE    => "There are 16 of these registers, one for each CRB, and they contain note the address to fetch data from. This register is not va",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01234_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_SRC_ADDR_10                                               #
#                                                                        #
##########################################################################

%shub2_01_01235_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%shub2_01_01235_def =
( NAME    => "SH2_BT_CRB_SRC_ADDR_10",
  ADDRESS => 0x0000000030031480,
  NOTE    => "There are 16 of these registers, one for each CRB, and they contain note the address to fetch data from. This register is not va",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01235_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_SRC_ADDR_11                                               #
#                                                                        #
##########################################################################

%shub2_01_01236_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%shub2_01_01236_def =
( NAME    => "SH2_BT_CRB_SRC_ADDR_11",
  ADDRESS => 0x0000000030031680,
  NOTE    => "There are 16 of these registers, one for each CRB, and they contain note the address to fetch data from. This register is not va",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01236_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_SRC_ADDR_12                                               #
#                                                                        #
##########################################################################

%shub2_01_01237_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%shub2_01_01237_def =
( NAME    => "SH2_BT_CRB_SRC_ADDR_12",
  ADDRESS => 0x0000000030031880,
  NOTE    => "There are 16 of these registers, one for each CRB, and they contain note the address to fetch data from. This register is not va",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01237_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_SRC_ADDR_13                                               #
#                                                                        #
##########################################################################

%shub2_01_01238_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%shub2_01_01238_def =
( NAME    => "SH2_BT_CRB_SRC_ADDR_13",
  ADDRESS => 0x0000000030031a80,
  NOTE    => "There are 16 of these registers, one for each CRB, and they contain note the address to fetch data from. This register is not va",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01238_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_SRC_ADDR_14                                               #
#                                                                        #
##########################################################################

%shub2_01_01239_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%shub2_01_01239_def =
( NAME    => "SH2_BT_CRB_SRC_ADDR_14",
  ADDRESS => 0x0000000030031c80,
  NOTE    => "There are 16 of these registers, one for each CRB, and they contain note the address to fetch data from. This register is not va",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01239_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_SRC_ADDR_15                                               #
#                                                                        #
##########################################################################

%shub2_01_01240_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%shub2_01_01240_def =
( NAME    => "SH2_BT_CRB_SRC_ADDR_15",
  ADDRESS => 0x0000000030031e80,
  NOTE    => "There are 16 of these registers, one for each CRB, and they contain note the address to fetch data from. This register is not va",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01240_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_DEST_ADDR_0                                               #
#                                                                        #
##########################################################################

%shub2_01_01241_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%shub2_01_01241_def =
( NAME    => "SH2_BT_CRB_DEST_ADDR_0",
  ADDRESS => 0x0000000030030100,
  NOTE    => "There are 16 of these registers, one for each CRB, and they contain note the address to store data to.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01241_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_DEST_ADDR_1                                               #
#                                                                        #
##########################################################################

%shub2_01_01242_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%shub2_01_01242_def =
( NAME    => "SH2_BT_CRB_DEST_ADDR_1",
  ADDRESS => 0x0000000030030300,
  NOTE    => "There are 16 of these registers, one for each CRB, and they contain note the address to store data to.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01242_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_DEST_ADDR_2                                               #
#                                                                        #
##########################################################################

%shub2_01_01243_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%shub2_01_01243_def =
( NAME    => "SH2_BT_CRB_DEST_ADDR_2",
  ADDRESS => 0x0000000030030500,
  NOTE    => "There are 16 of these registers, one for each CRB, and they contain note the address to store data to.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01243_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_DEST_ADDR_3                                               #
#                                                                        #
##########################################################################

%shub2_01_01244_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%shub2_01_01244_def =
( NAME    => "SH2_BT_CRB_DEST_ADDR_3",
  ADDRESS => 0x0000000030030700,
  NOTE    => "There are 16 of these registers, one for each CRB, and they contain note the address to store data to.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01244_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_DEST_ADDR_4                                               #
#                                                                        #
##########################################################################

%shub2_01_01245_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%shub2_01_01245_def =
( NAME    => "SH2_BT_CRB_DEST_ADDR_4",
  ADDRESS => 0x0000000030030900,
  NOTE    => "There are 16 of these registers, one for each CRB, and they contain note the address to store data to.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01245_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_DEST_ADDR_5                                               #
#                                                                        #
##########################################################################

%shub2_01_01246_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%shub2_01_01246_def =
( NAME    => "SH2_BT_CRB_DEST_ADDR_5",
  ADDRESS => 0x0000000030030b00,
  NOTE    => "There are 16 of these registers, one for each CRB, and they contain note the address to store data to.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01246_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_DEST_ADDR_6                                               #
#                                                                        #
##########################################################################

%shub2_01_01247_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%shub2_01_01247_def =
( NAME    => "SH2_BT_CRB_DEST_ADDR_6",
  ADDRESS => 0x0000000030030d00,
  NOTE    => "There are 16 of these registers, one for each CRB, and they contain note the address to store data to.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01247_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_DEST_ADDR_7                                               #
#                                                                        #
##########################################################################

%shub2_01_01248_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%shub2_01_01248_def =
( NAME    => "SH2_BT_CRB_DEST_ADDR_7",
  ADDRESS => 0x0000000030030f00,
  NOTE    => "There are 16 of these registers, one for each CRB, and they contain note the address to store data to.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01248_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_DEST_ADDR_8                                               #
#                                                                        #
##########################################################################

%shub2_01_01249_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%shub2_01_01249_def =
( NAME    => "SH2_BT_CRB_DEST_ADDR_8",
  ADDRESS => 0x0000000030031100,
  NOTE    => "There are 16 of these registers, one for each CRB, and they contain note the address to store data to.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01249_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_DEST_ADDR_9                                               #
#                                                                        #
##########################################################################

%shub2_01_01250_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%shub2_01_01250_def =
( NAME    => "SH2_BT_CRB_DEST_ADDR_9",
  ADDRESS => 0x0000000030031300,
  NOTE    => "There are 16 of these registers, one for each CRB, and they contain note the address to store data to.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01250_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_DEST_ADDR_10                                              #
#                                                                        #
##########################################################################

%shub2_01_01251_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%shub2_01_01251_def =
( NAME    => "SH2_BT_CRB_DEST_ADDR_10",
  ADDRESS => 0x0000000030031500,
  NOTE    => "There are 16 of these registers, one for each CRB, and they contain note the address to store data to.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01251_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_DEST_ADDR_11                                              #
#                                                                        #
##########################################################################

%shub2_01_01252_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%shub2_01_01252_def =
( NAME    => "SH2_BT_CRB_DEST_ADDR_11",
  ADDRESS => 0x0000000030031700,
  NOTE    => "There are 16 of these registers, one for each CRB, and they contain note the address to store data to.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01252_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_DEST_ADDR_12                                              #
#                                                                        #
##########################################################################

%shub2_01_01253_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%shub2_01_01253_def =
( NAME    => "SH2_BT_CRB_DEST_ADDR_12",
  ADDRESS => 0x0000000030031900,
  NOTE    => "There are 16 of these registers, one for each CRB, and they contain note the address to store data to.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01253_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_DEST_ADDR_13                                              #
#                                                                        #
##########################################################################

%shub2_01_01254_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%shub2_01_01254_def =
( NAME    => "SH2_BT_CRB_DEST_ADDR_13",
  ADDRESS => 0x0000000030031b00,
  NOTE    => "There are 16 of these registers, one for each CRB, and they contain note the address to store data to.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01254_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_DEST_ADDR_14                                              #
#                                                                        #
##########################################################################

%shub2_01_01255_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%shub2_01_01255_def =
( NAME    => "SH2_BT_CRB_DEST_ADDR_14",
  ADDRESS => 0x0000000030031d00,
  NOTE    => "There are 16 of these registers, one for each CRB, and they contain note the address to store data to.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01255_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_CRB_DEST_ADDR_15                                              #
#                                                                        #
##########################################################################

%shub2_01_01256_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%shub2_01_01256_def =
( NAME    => "SH2_BT_CRB_DEST_ADDR_15",
  ADDRESS => 0x0000000030031f00,
  NOTE    => "There are 16 of these registers, one for each CRB, and they contain note the address to store data to.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01256_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_ENG_CSR_0                                                     #
#                                                                        #
##########################################################################

%shub2_01_01257_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERROR_STAT"                   => [   1,  36,   6, 0x000003F000000000, 0x00, 1, 0x0000000000000000, "Error Status" ],
   "RSVD1"                        => [   2,  34,   2, 0x0000000C00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_READ"                     => [   3,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "Fetch Mode" ],
   "PIO_WRITE"                    => [   4,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Store Mode" ],
   "RSVD2"                        => [   5,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NOTIFY"                       => [   6,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "Notify Mode" ],
   "RSVD3"                        => [   7,  25,   3, 0x000000000E000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ZEROFILL"                     => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Zero Fill Mode" ],
   "RSVD4"                        => [   9,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BUSY"                         => [  10,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "Busy" ],
   "RSVD5"                        => [  11,  17,   3, 0x00000000000E0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERROR"                        => [  12,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Error" ],
   "LENGTH"                       => [  13,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "Transfer Length" ],
);

%shub2_01_01257_def =
( NAME    => "SH2_BT_ENG_CSR_0",
  ADDRESS => 0x0000000030040000,
  NOTE    => "This register sets up some of the attributes of the transfer and note initiates the transfer operation, allows monitoring of the",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01257_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_ENG_SRC_ADDR_0                                                #
#                                                                        #
##########################################################################

%shub2_01_01258_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  54,  10, 0xFFC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR"                         => [   1,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "Address" ],
);

%shub2_01_01258_def =
( NAME    => "SH2_BT_ENG_SRC_ADDR_0",
  ADDRESS => 0x0000000030040080,
  NOTE    => "This register is used to set up the transfer source address and note should be initialized before a transfer is started. It does",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01258_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_ENG_DEST_ADDR_0                                               #
#                                                                        #
##########################################################################

%shub2_01_01259_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  54,  10, 0xFFC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR"                         => [   1,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "Address" ],
);

%shub2_01_01259_def =
( NAME    => "SH2_BT_ENG_DEST_ADDR_0",
  ADDRESS => 0x0000000030040100,
  NOTE    => "This register is used to set up the transfer destination address note and should be initialized before a transfer is started.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01259_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_ENG_NOTIF_ADDR_0                                              #
#                                                                        #
##########################################################################

%shub2_01_01260_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  54,  10, 0xFFC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR"                         => [   1,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "Address" ],
);

%shub2_01_01260_def =
( NAME    => "SH2_BT_ENG_NOTIF_ADDR_0",
  ADDRESS => 0x0000000030040180,
  NOTE    => "This register is used to control where the notification completion note message, if enabled, is sent. This register doesn't need",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01260_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_ENG_CSR_1                                                     #
#                                                                        #
##########################################################################

%shub2_01_01261_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERROR_STAT"                   => [   1,  36,   6, 0x000003F000000000, 0x00, 1, 0x0000000000000000, "Error Status" ],
   "RSVD1"                        => [   2,  34,   2, 0x0000000C00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_READ"                     => [   3,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "Fetch Mode" ],
   "PIO_WRITE"                    => [   4,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Store Mode" ],
   "RSVD2"                        => [   5,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NOTIFY"                       => [   6,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "Notify Mode" ],
   "RSVD3"                        => [   7,  25,   3, 0x000000000E000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ZEROFILL"                     => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Zero Fill Mode" ],
   "RSVD4"                        => [   9,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BUSY"                         => [  10,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "Busy" ],
   "RSVD5"                        => [  11,  17,   3, 0x00000000000E0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERROR"                        => [  12,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Error" ],
   "LENGTH"                       => [  13,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "Transfer Length" ],
);

%shub2_01_01261_def =
( NAME    => "SH2_BT_ENG_CSR_1",
  ADDRESS => 0x0000000030050000,
  NOTE    => "This register sets up some of the attributes of the transfer and note initiates the transfer operation, allows monitoring of the",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01261_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_ENG_SRC_ADDR_1                                                #
#                                                                        #
##########################################################################

%shub2_01_01262_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  54,  10, 0xFFC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR"                         => [   1,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "Address" ],
);

%shub2_01_01262_def =
( NAME    => "SH2_BT_ENG_SRC_ADDR_1",
  ADDRESS => 0x0000000030050080,
  NOTE    => "This register is used to set up the transfer source address and note should be initialized before a transfer is started. It does",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01262_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_ENG_DEST_ADDR_1                                               #
#                                                                        #
##########################################################################

%shub2_01_01263_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  54,  10, 0xFFC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR"                         => [   1,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "Address" ],
);

%shub2_01_01263_def =
( NAME    => "SH2_BT_ENG_DEST_ADDR_1",
  ADDRESS => 0x0000000030050100,
  NOTE    => "This register is used to set up the transfer destination address note and should be initialized before a transfer is started.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01263_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_ENG_NOTIF_ADDR_1                                              #
#                                                                        #
##########################################################################

%shub2_01_01264_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  54,  10, 0xFFC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR"                         => [   1,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "Address" ],
);

%shub2_01_01264_def =
( NAME    => "SH2_BT_ENG_NOTIF_ADDR_1",
  ADDRESS => 0x0000000030050180,
  NOTE    => "This register is used to control where the notification completion note message, if enabled, is sent. This register doesn't need",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01264_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_ENG_CSR_2                                                     #
#                                                                        #
##########################################################################

%shub2_01_01265_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERROR_STAT"                   => [   1,  36,   6, 0x000003F000000000, 0x00, 1, 0x0000000000000000, "Error Status" ],
   "RSVD1"                        => [   2,  34,   2, 0x0000000C00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_READ"                     => [   3,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "Fetch Mode" ],
   "PIO_WRITE"                    => [   4,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Store Mode" ],
   "RSVD2"                        => [   5,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NOTIFY"                       => [   6,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "Notify Mode" ],
   "RSVD3"                        => [   7,  25,   3, 0x000000000E000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ZEROFILL"                     => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Zero Fill Mode" ],
   "RSVD4"                        => [   9,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BUSY"                         => [  10,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "Busy" ],
   "RSVD5"                        => [  11,  17,   3, 0x00000000000E0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERROR"                        => [  12,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Error" ],
   "LENGTH"                       => [  13,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "Transfer Length" ],
);

%shub2_01_01265_def =
( NAME    => "SH2_BT_ENG_CSR_2",
  ADDRESS => 0x0000000030060000,
  NOTE    => "This register sets up some of the attributes of the transfer and note initiates the transfer operation, allows monitoring of the",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01265_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_ENG_SRC_ADDR_2                                                #
#                                                                        #
##########################################################################

%shub2_01_01266_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  54,  10, 0xFFC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR"                         => [   1,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "Address" ],
);

%shub2_01_01266_def =
( NAME    => "SH2_BT_ENG_SRC_ADDR_2",
  ADDRESS => 0x0000000030060080,
  NOTE    => "This register is used to set up the transfer source address and note should be initialized before a transfer is started. It does",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01266_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_ENG_DEST_ADDR_2                                               #
#                                                                        #
##########################################################################

%shub2_01_01267_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  54,  10, 0xFFC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR"                         => [   1,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "Address" ],
);

%shub2_01_01267_def =
( NAME    => "SH2_BT_ENG_DEST_ADDR_2",
  ADDRESS => 0x0000000030060100,
  NOTE    => "This register is used to set up the transfer destination address note and should be initialized before a transfer is started.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01267_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_ENG_NOTIF_ADDR_2                                              #
#                                                                        #
##########################################################################

%shub2_01_01268_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  54,  10, 0xFFC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR"                         => [   1,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "Address" ],
);

%shub2_01_01268_def =
( NAME    => "SH2_BT_ENG_NOTIF_ADDR_2",
  ADDRESS => 0x0000000030060180,
  NOTE    => "This register is used to control where the notification completion note message, if enabled, is sent. This register doesn't need",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01268_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_ENG_CSR_3                                                     #
#                                                                        #
##########################################################################

%shub2_01_01269_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERROR_STAT"                   => [   1,  36,   6, 0x000003F000000000, 0x00, 1, 0x0000000000000000, "Error Status" ],
   "RSVD1"                        => [   2,  34,   2, 0x0000000C00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_READ"                     => [   3,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "Fetch Mode" ],
   "PIO_WRITE"                    => [   4,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Store Mode" ],
   "RSVD2"                        => [   5,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NOTIFY"                       => [   6,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "Notify Mode" ],
   "RSVD3"                        => [   7,  25,   3, 0x000000000E000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ZEROFILL"                     => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Zero Fill Mode" ],
   "RSVD4"                        => [   9,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BUSY"                         => [  10,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "Busy" ],
   "RSVD5"                        => [  11,  17,   3, 0x00000000000E0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERROR"                        => [  12,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Error" ],
   "LENGTH"                       => [  13,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "Transfer Length" ],
);

%shub2_01_01269_def =
( NAME    => "SH2_BT_ENG_CSR_3",
  ADDRESS => 0x0000000030070000,
  NOTE    => "This register sets up some of the attributes of the transfer and note initiates the transfer operation, allows monitoring of the",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01269_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_ENG_SRC_ADDR_3                                                #
#                                                                        #
##########################################################################

%shub2_01_01270_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  54,  10, 0xFFC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR"                         => [   1,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "Address" ],
);

%shub2_01_01270_def =
( NAME    => "SH2_BT_ENG_SRC_ADDR_3",
  ADDRESS => 0x0000000030070080,
  NOTE    => "This register is used to set up the transfer source address and note should be initialized before a transfer is started. It does",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01270_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_ENG_DEST_ADDR_3                                               #
#                                                                        #
##########################################################################

%shub2_01_01271_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  54,  10, 0xFFC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR"                         => [   1,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "Address" ],
);

%shub2_01_01271_def =
( NAME    => "SH2_BT_ENG_DEST_ADDR_3",
  ADDRESS => 0x0000000030070100,
  NOTE    => "This register is used to set up the transfer destination address note and should be initialized before a transfer is started.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01271_flds
);


##########################################################################
#                                                                        #
#   SH2_BT_ENG_NOTIF_ADDR_3                                              #
#                                                                        #
##########################################################################

%shub2_01_01272_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  54,  10, 0xFFC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR"                         => [   1,   7,  47, 0x003FFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "Address" ],
);

%shub2_01_01272_def =
( NAME    => "SH2_BT_ENG_NOTIF_ADDR_3",
  ADDRESS => 0x0000000030070180,
  NOTE    => "This register is used to control where the notification completion note message, if enabled, is sent. This register doesn't need",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01272_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_RDAT_ACK_Q_CONFIG                                             #
#                                                                        #
##########################################################################

%shub2_01_01273_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   2,  62, 0xFFFFFFFFFFFFFFFC, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BYPASS_POP_RESYNC"            => [   1,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Queue Pop Resync" ],
   "BYPASS_PUSH_RESYNC"           => [   2,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Queue Push Resync" ],
);

%shub2_01_01273_def =
( NAME    => "SH2_PI_RDAT_ACK_Q_CONFIG",
  ADDRESS => 0x0000000020053010,
  NOTE    => "This register provides configuration parameters for note the RDAT's Acknowledge Queue.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01273_flds
);


##########################################################################
#                                                                        #
#   SH2_PI_RDAT_DAT_DFR_Q_CONFIG                                         #
#                                                                        #
##########################################################################

%shub2_01_01274_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SPARE"                        => [   0,   3,  61, 0xFFFFFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "B2B_PROC_WRITES"              => [   1,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Back-to-back Writes" ],
   "BYPASS_POP_RESYNC"            => [   2,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Queue Pop Resync" ],
   "BYPASS_PUSH_RESYNC"           => [   3,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Queue Push Resync" ],
);

%shub2_01_01274_def =
( NAME    => "SH2_PI_RDAT_DAT_DFR_Q_CONFIG",
  ADDRESS => 0x0000000020053018,
  NOTE    => "This register provides configuration parameters for note the RDAT's Data/Deferred Queue.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub2_01_01274_flds
);


##########################################################################
#                                                                        #
#   MMR LOOKUP TABLES (BY NAME OR ADDRESS)                               #
#                                                                        #
##########################################################################

%shub2_01_mmr_by_name = 
(
   SH2_JUNK_BUS_TIME            => \%shub2_01_00000_def,
   SH2_JUNK_NACK_RESET          => \%shub2_01_00001_def,
   SH2_JUNK_BUS_LED0            => \%shub2_01_00002_def,
   SH2_JUNK_BUS_LED1            => \%shub2_01_00003_def,
   SH2_JUNK_BUS_LED2            => \%shub2_01_00004_def,
   SH2_JUNK_BUS_LED3            => \%shub2_01_00005_def,
   SH2_LB_LIQ_CTL               => \%shub2_01_00006_def,
   SH2_LB_LOQ_CTL               => \%shub2_01_00007_def,
   SH2_LB_MAX_REP_CREDIT_CNT    => \%shub2_01_00008_def,
   SH2_LB_MAX_REQ_CREDIT_CNT    => \%shub2_01_00009_def,
   SH2_PIO_TIME_OUT             => \%shub2_01_00010_def,
   SH2_PIO_NACK_RESET           => \%shub2_01_00011_def,
   SH2_CONVEYOR_BELT_TIME_OUT   => \%shub2_01_00012_def,
   SH2_CONVEYOR_BELT_CONFIG     => \%shub2_01_00013_def,
   SH2_LB_CREDIT_STATUS         => \%shub2_01_00014_def,
   SH2_LB_DEBUG_LOCAL_SEL       => \%shub2_01_00015_def,
   SH2_LB_DEBUG_MUX0_SEL        => \%shub2_01_00016_def,
   SH2_LB_DEBUG_MUX1_SEL        => \%shub2_01_00017_def,
   SH2_LB_DEBUG_COMPARE_SEL     => \%shub2_01_00018_def,
   SH2_LB_ERROR_DETAIL_1        => \%shub2_01_00019_def,
   SH2_LB_ERROR_DETAIL_2        => \%shub2_01_00020_def,
   SH2_LB_ERROR_DETAIL_3        => \%shub2_01_00021_def,
   SH2_LB_ERROR_DETAIL_4        => \%shub2_01_00022_def,
   SH2_LB_ERROR_DETAIL_5        => \%shub2_01_00023_def,
   SH2_LB_ERROR_DETAIL_6        => \%shub2_01_00024_def,
   SH2_LB_ERROR_MASK            => \%shub2_01_00025_def,
   SH2_LB_ERROR_OVERFLOW        => \%shub2_01_00026_def,
   SH2_LB_ERROR_OVERFLOW_ALIAS  => \%shub2_01_00027_def,
   SH2_LB_ERROR_SUMMARY         => \%shub2_01_00028_def,
   SH2_LB_ERROR_SUMMARY_ALIAS   => \%shub2_01_00029_def,
   SH2_LB_FIRST_ERROR           => \%shub2_01_00030_def,
   SH2_LB_LAST_CREDIT           => \%shub2_01_00031_def,
   SH2_LB_NACK_STATUS0          => \%shub2_01_00032_def,
   SH2_LB_NACK_STATUS1          => \%shub2_01_00033_def,
   SH2_LB_NACK_STATUS2          => \%shub2_01_00034_def,
   SH2_LB_NACK_STATUS3          => \%shub2_01_00035_def,
   SH2_LB_COMPARE_COMPARE       => \%shub2_01_00036_def,
   SH2_LB_COMPARE_DATA          => \%shub2_01_00037_def,
   SH2_PERFORMANCE_COUNT0_CONTROL => \%shub2_01_00038_def,
   SH2_PERFORMANCE_COUNT1_CONTROL => \%shub2_01_00039_def,
   SH2_PERFORMANCE_COUNT2_CONTROL => \%shub2_01_00040_def,
   SH2_PERFORMANCE_COUNT3_CONTROL => \%shub2_01_00041_def,
   SH2_PERFORMANCE_COUNT4_CONTROL => \%shub2_01_00042_def,
   SH2_PERFORMANCE_COUNT5_CONTROL => \%shub2_01_00043_def,
   SH2_PERFORMANCE_COUNT6_CONTROL => \%shub2_01_00044_def,
   SH2_PERFORMANCE_COUNT7_CONTROL => \%shub2_01_00045_def,
   SH2_PROFILE_DN_CONTROL       => \%shub2_01_00046_def,
   SH2_PROFILE_PEAK_CONTROL     => \%shub2_01_00047_def,
   SH2_PROFILE_RANGE            => \%shub2_01_00048_def,
   SH2_PROFILE_UP_CONTROL       => \%shub2_01_00049_def,
   SH2_PERFORMANCE_MONITOR_DESKEW => \%shub2_01_00050_def,
   SH2_PERFORMANCE_COUNTER0     => \%shub2_01_00051_def,
   SH2_PERFORMANCE_COUNTER1     => \%shub2_01_00052_def,
   SH2_PERFORMANCE_COUNTER2     => \%shub2_01_00053_def,
   SH2_PERFORMANCE_COUNTER3     => \%shub2_01_00054_def,
   SH2_PERFORMANCE_COUNTER4     => \%shub2_01_00055_def,
   SH2_PERFORMANCE_COUNTER5     => \%shub2_01_00056_def,
   SH2_PERFORMANCE_COUNTER6     => \%shub2_01_00057_def,
   SH2_PERFORMANCE_COUNTER7     => \%shub2_01_00058_def,
   SH2_PROFILE_COUNTER          => \%shub2_01_00059_def,
   SH2_PROFILE_PEAK             => \%shub2_01_00060_def,
   SH2_INT_CMPA                 => \%shub2_01_00061_def,
   SH2_INT_CMPB                 => \%shub2_01_00062_def,
   SH2_INT_CMPC                 => \%shub2_01_00063_def,
   SH2_INT_CMPD                 => \%shub2_01_00064_def,
   SH2_INT_PROF                 => \%shub2_01_00065_def,
   SH2_RTC                      => \%shub2_01_00066_def,
   SH2_LB_PI_GCLK_SEL           => \%shub2_01_00067_def,
   SH2_SCRATCH0                 => \%shub2_01_00068_def,
   SH2_SCRATCH0_ALIAS           => \%shub2_01_00069_def,
   SH2_SCRATCH1                 => \%shub2_01_00070_def,
   SH2_SCRATCH1_ALIAS           => \%shub2_01_00071_def,
   SH2_SCRATCH2                 => \%shub2_01_00072_def,
   SH2_SCRATCH2_ALIAS           => \%shub2_01_00073_def,
   SH2_SCRATCH3                 => \%shub2_01_00074_def,
   SH2_SCRATCH3_ALIAS           => \%shub2_01_00075_def,
   SH2_SCRATCH4                 => \%shub2_01_00076_def,
   SH2_SCRATCH4_ALIAS           => \%shub2_01_00077_def,
   SH2_SCRATCH5                 => \%shub2_01_00078_def,
   SH2_SCRATCH5_ALIAS           => \%shub2_01_00079_def,
   SH2_SCRATCH5_ALIAS_2         => \%shub2_01_00080_def,
   SH2_SCRATCH6                 => \%shub2_01_00081_def,
   SH2_SCRATCH6_ALIAS           => \%shub2_01_00082_def,
   SH2_SCRATCH6_ALIAS_2         => \%shub2_01_00083_def,
   SH2_SCRATCH7                 => \%shub2_01_00084_def,
   SH2_SCRATCH7_ALIAS           => \%shub2_01_00085_def,
   SH2_SCRATCH7_ALIAS_2         => \%shub2_01_00086_def,
   SH2_SCRATCH8                 => \%shub2_01_00087_def,
   SH2_SCRATCH8_ALIAS           => \%shub2_01_00088_def,
   SH2_SCRATCH8_ALIAS_2         => \%shub2_01_00089_def,
   SH2_SCRATCH9                 => \%shub2_01_00090_def,
   SH2_SCRATCH9_ALIAS           => \%shub2_01_00091_def,
   SH2_SCRATCH9_ALIAS_2         => \%shub2_01_00092_def,
   SH2_SCRATCH10                => \%shub2_01_00093_def,
   SH2_SCRATCH10_ALIAS          => \%shub2_01_00094_def,
   SH2_SCRATCH10_ALIAS_2        => \%shub2_01_00095_def,
   SH2_SCRATCH11                => \%shub2_01_00096_def,
   SH2_SCRATCH11_ALIAS          => \%shub2_01_00097_def,
   SH2_SCRATCH11_ALIAS_2        => \%shub2_01_00098_def,
   SH2_SCRATCH12                => \%shub2_01_00099_def,
   SH2_SCRATCH12_ALIAS          => \%shub2_01_00100_def,
   SH2_SCRATCH12_ALIAS_2        => \%shub2_01_00101_def,
   SH2_SCRATCH13                => \%shub2_01_00102_def,
   SH2_SCRATCH13_ALIAS          => \%shub2_01_00103_def,
   SH2_SCRATCH13_ALIAS_2        => \%shub2_01_00104_def,
   SH2_SCRATCH14                => \%shub2_01_00105_def,
   SH2_SCRATCH14_ALIAS          => \%shub2_01_00106_def,
   SH2_SCRATCH14_ALIAS_2        => \%shub2_01_00107_def,
   SH2_SCRATCH15                => \%shub2_01_00108_def,
   SH2_SCRATCH15_ALIAS          => \%shub2_01_00109_def,
   SH2_SCRATCH15_ALIAS_2        => \%shub2_01_00110_def,
   SH2_SCRATCH16                => \%shub2_01_00111_def,
   SH2_SCRATCH16_ALIAS          => \%shub2_01_00112_def,
   SH2_SCRATCH16_ALIAS_2        => \%shub2_01_00113_def,
   SH2_SCRATCH17                => \%shub2_01_00114_def,
   SH2_SCRATCH17_ALIAS          => \%shub2_01_00115_def,
   SH2_SCRATCH17_ALIAS_2        => \%shub2_01_00116_def,
   SH2_SCRATCH18                => \%shub2_01_00117_def,
   SH2_SCRATCH18_ALIAS          => \%shub2_01_00118_def,
   SH2_SCRATCH18_ALIAS_2        => \%shub2_01_00119_def,
   SH2_SCRATCH19                => \%shub2_01_00120_def,
   SH2_SCRATCH19_ALIAS          => \%shub2_01_00121_def,
   SH2_SCRATCH19_ALIAS_2        => \%shub2_01_00122_def,
   SH2_SCRATCH20                => \%shub2_01_00123_def,
   SH2_SCRATCH20_ALIAS          => \%shub2_01_00124_def,
   SH2_SCRATCH20_ALIAS_2        => \%shub2_01_00125_def,
   SH2_SCRATCH21                => \%shub2_01_00126_def,
   SH2_SCRATCH21_ALIAS          => \%shub2_01_00127_def,
   SH2_SCRATCH21_ALIAS_2        => \%shub2_01_00128_def,
   SH2_SCRATCH22                => \%shub2_01_00129_def,
   SH2_SCRATCH22_ALIAS          => \%shub2_01_00130_def,
   SH2_SCRATCH22_ALIAS_2        => \%shub2_01_00131_def,
   SH2_SCRATCH23                => \%shub2_01_00132_def,
   SH2_SCRATCH23_ALIAS          => \%shub2_01_00133_def,
   SH2_SCRATCH23_ALIAS_2        => \%shub2_01_00134_def,
   SH2_SCRATCH24                => \%shub2_01_00135_def,
   SH2_SCRATCH24_ALIAS          => \%shub2_01_00136_def,
   SH2_SCRATCH24_ALIAS_2        => \%shub2_01_00137_def,
   SH2_EXTIO_INT0               => \%shub2_01_00138_def,
   SH2_EXTIO_INT0_CONFIG        => \%shub2_01_00139_def,
   SH2_EXTIO_INT0_ENABLE        => \%shub2_01_00140_def,
   SH2_EXTIO_INT1               => \%shub2_01_00141_def,
   SH2_EXTIO_INT1_CONFIG        => \%shub2_01_00142_def,
   SH2_EXTIO_INT1_ENABLE        => \%shub2_01_00143_def,
   SH2_EXTIO_INT2               => \%shub2_01_00144_def,
   SH2_EXTIO_INT2_CONFIG        => \%shub2_01_00145_def,
   SH2_EXTIO_INT2_ENABLE        => \%shub2_01_00146_def,
   SH2_EXTIO_INT3               => \%shub2_01_00147_def,
   SH2_EXTIO_INT3_CONFIG        => \%shub2_01_00148_def,
   SH2_EXTIO_INT3_ENABLE        => \%shub2_01_00149_def,
   SH2_INT_NODE_ID_CONFIG       => \%shub2_01_00150_def,
   SH2_IPI_INT                  => \%shub2_01_00151_def,
   SH2_IPI_INT_ENABLE           => \%shub2_01_00152_def,
   SH2_LOCAL_INT0_CONFIG        => \%shub2_01_00153_def,
   SH2_LOCAL_INT0_ENABLE        => \%shub2_01_00154_def,
   SH2_LOCAL_INT1_CONFIG        => \%shub2_01_00155_def,
   SH2_LOCAL_INT1_ENABLE        => \%shub2_01_00156_def,
   SH2_LOCAL_INT2_CONFIG        => \%shub2_01_00157_def,
   SH2_LOCAL_INT2_ENABLE        => \%shub2_01_00158_def,
   SH2_LOCAL_INT3_CONFIG        => \%shub2_01_00159_def,
   SH2_LOCAL_INT3_ENABLE        => \%shub2_01_00160_def,
   SH2_LOCAL_INT4_CONFIG        => \%shub2_01_00161_def,
   SH2_LOCAL_INT4_ENABLE        => \%shub2_01_00162_def,
   SH2_LOCAL_INT5_CONFIG        => \%shub2_01_00163_def,
   SH2_LOCAL_INT5_ENABLE        => \%shub2_01_00164_def,
   SH2_LOCAL_INT6_CONFIG        => \%shub2_01_00165_def,
   SH2_LOCAL_INT6_ENABLE        => \%shub2_01_00166_def,
   SH2_LOCAL_INT7_CONFIG        => \%shub2_01_00167_def,
   SH2_LOCAL_INT7_ENABLE        => \%shub2_01_00168_def,
   SH2_LOCAL_INT8_CONFIG        => \%shub2_01_00169_def,
   SH2_LOCAL_INT8_ENABLE        => \%shub2_01_00170_def,
   SH2_LOCAL_INT9_CONFIG        => \%shub2_01_00171_def,
   SH2_LOCAL_INT9_ENABLE        => \%shub2_01_00172_def,
   SH2_PROFILE_INT_CONFIG       => \%shub2_01_00173_def,
   SH2_PROFILE_INT_ENABLE       => \%shub2_01_00174_def,
   SH2_RTC0_INT_CONFIG          => \%shub2_01_00175_def,
   SH2_RTC0_INT_ENABLE          => \%shub2_01_00176_def,
   SH2_RTC1_INT_CONFIG          => \%shub2_01_00177_def,
   SH2_RTC1_INT_ENABLE          => \%shub2_01_00178_def,
   SH2_RTC2_INT_CONFIG          => \%shub2_01_00179_def,
   SH2_RTC2_INT_ENABLE          => \%shub2_01_00180_def,
   SH2_RTC3_INT_CONFIG          => \%shub2_01_00181_def,
   SH2_RTC3_INT_ENABLE          => \%shub2_01_00182_def,
   SH2_BT0_INT_CONFIG           => \%shub2_01_00183_def,
   SH2_BT0_INT_ENABLE           => \%shub2_01_00184_def,
   SH2_BT1_INT_CONFIG           => \%shub2_01_00185_def,
   SH2_BT1_INT_ENABLE           => \%shub2_01_00186_def,
   SH2_BT2_INT_CONFIG           => \%shub2_01_00187_def,
   SH2_BT2_INT_ENABLE           => \%shub2_01_00188_def,
   SH2_BT3_INT_CONFIG           => \%shub2_01_00189_def,
   SH2_BT3_INT_ENABLE           => \%shub2_01_00190_def,
   SH2_NOTIFICATION_MEMORY_INT0_CONFIG => \%shub2_01_00191_def,
   SH2_NOTIFICATION_MEMORY_INT0_ENABLE => \%shub2_01_00192_def,
   SH2_NOTIFICATION_MEMORY_INT1_CONFIG => \%shub2_01_00193_def,
   SH2_NOTIFICATION_MEMORY_INT1_ENABLE => \%shub2_01_00194_def,
   SH2_NOTIFICATION_MEMORY_INT2_CONFIG => \%shub2_01_00195_def,
   SH2_NOTIFICATION_MEMORY_INT2_ENABLE => \%shub2_01_00196_def,
   SH2_NOTIFICATION_MEMORY_INT3_CONFIG => \%shub2_01_00197_def,
   SH2_NOTIFICATION_MEMORY_INT3_ENABLE => \%shub2_01_00198_def,
   SH2_EVENT_OCCURRED           => \%shub2_01_00199_def,
   SH2_EVENT_OCCURRED_ALIAS     => \%shub2_01_00200_def,
   SH2_EVENT_OVERFLOW           => \%shub2_01_00201_def,
   SH2_EVENT_OVERFLOW_ALIAS     => \%shub2_01_00202_def,
   SH2_ASIC_TO_L1_DATA          => \%shub2_01_00203_def,
   SH2_ASIC_TO_L1_STATUS        => \%shub2_01_00204_def,
   SH2_L1_TO_ASIC_DATA          => \%shub2_01_00205_def,
   SH2_L1_TO_ASIC_STATUS        => \%shub2_01_00206_def,
   SH2_RACK_SLOT_DATA           => \%shub2_01_00207_def,
   SH2_PTC                      => \%shub2_01_00208_def,
   SH2_PTC_PARMS                => \%shub2_01_00209_def,
   SH2_AUTO_REPLY_ENABLE0       => \%shub2_01_00210_def,
   SH2_AUTO_REPLY_ENABLE1       => \%shub2_01_00211_def,
   SH2_AUTO_REPLY_HEADER0       => \%shub2_01_00212_def,
   SH2_AUTO_REPLY_HEADER1       => \%shub2_01_00213_def,
   SH2_ENABLE_RP_AUTO_REPLY     => \%shub2_01_00214_def,
   SH2_ENABLE_RQ_AUTO_REPLY     => \%shub2_01_00215_def,
   SH2_REDIRECT_INVAL           => \%shub2_01_00216_def,
   SH2_DIAG_MSG_CNTRL           => \%shub2_01_00217_def,
   SH2_DIAG_MSG_DATA0L          => \%shub2_01_00218_def,
   SH2_DIAG_MSG_DATA0U          => \%shub2_01_00219_def,
   SH2_DIAG_MSG_DATA1L          => \%shub2_01_00220_def,
   SH2_DIAG_MSG_DATA1U          => \%shub2_01_00221_def,
   SH2_DIAG_MSG_DATA2L          => \%shub2_01_00222_def,
   SH2_DIAG_MSG_DATA2U          => \%shub2_01_00223_def,
   SH2_DIAG_MSG_DATA3L          => \%shub2_01_00224_def,
   SH2_DIAG_MSG_DATA3U          => \%shub2_01_00225_def,
   SH2_DIAG_MSG_DATA4L          => \%shub2_01_00226_def,
   SH2_DIAG_MSG_DATA4U          => \%shub2_01_00227_def,
   SH2_DIAG_MSG_DATA5L          => \%shub2_01_00228_def,
   SH2_DIAG_MSG_DATA5U          => \%shub2_01_00229_def,
   SH2_DIAG_MSG_DATA6L          => \%shub2_01_00230_def,
   SH2_DIAG_MSG_DATA6U          => \%shub2_01_00231_def,
   SH2_DIAG_MSG_DATA7L          => \%shub2_01_00232_def,
   SH2_DIAG_MSG_DATA7U          => \%shub2_01_00233_def,
   SH2_DIAG_MSG_DATA8L          => \%shub2_01_00234_def,
   SH2_DIAG_MSG_DATA8U          => \%shub2_01_00235_def,
   SH2_DIAG_MSG_HDR0            => \%shub2_01_00236_def,
   SH2_DIAG_MSG_HDR1            => \%shub2_01_00237_def,
   SH2_DEBUG_SELECT             => \%shub2_01_00238_def,
   SH2_COMPARE_COMPARE_MASK     => \%shub2_01_00239_def,
   SH2_COMPARE_COMPARE_PATTERN  => \%shub2_01_00240_def,
   SH2_COMPARE_SEL              => \%shub2_01_00241_def,
   SH2_OB_LA_CONTROL            => \%shub2_01_00242_def,
   SH2_OB_LA_START_CONTROL      => \%shub2_01_00243_def,
   SH2_OB_LA_STOP_CONTROL       => \%shub2_01_00244_def,
   SH2_OB_LA_START_ADDRESS      => \%shub2_01_00245_def,
   SH2_OB_LA_END_ADDRESS        => \%shub2_01_00246_def,
   SH2_DEBUG_PORT_CONFIG        => \%shub2_01_00247_def,
   SH2_STOP_CLK_CONTROL         => \%shub2_01_00248_def,
   SH2_STOP_CLK_DELAY_PHASE     => \%shub2_01_00249_def,
   SH2_TSF_ARM_MASK             => \%shub2_01_00250_def,
   SH2_TSF_COUNTER_PRESETS      => \%shub2_01_00251_def,
   SH2_TSF_DECREMENT_CTL        => \%shub2_01_00252_def,
   SH2_TSF_DIAG_MSG_CTL         => \%shub2_01_00253_def,
   SH2_TSF_DISARM_MASK          => \%shub2_01_00254_def,
   SH2_TSF_ENABLE_CTL           => \%shub2_01_00255_def,
   SH2_TSF_SOFTWARE_ARM         => \%shub2_01_00256_def,
   SH2_TSF_SOFTWARE_DISARM      => \%shub2_01_00257_def,
   SH2_TSF_SOFTWARE_TRIGGERED   => \%shub2_01_00258_def,
   SH2_TSF_TRIGGER_MASK         => \%shub2_01_00259_def,
   SH2_TSF_COMPARE0             => \%shub2_01_00260_def,
   SH2_TSF_COMPARE1             => \%shub2_01_00261_def,
   SH2_TSF_COMPARE2             => \%shub2_01_00262_def,
   SH2_TSF_COMPARE3             => \%shub2_01_00263_def,
   SH2_TSF_COMPARE4             => \%shub2_01_00264_def,
   SH2_TSF_COMPARE5             => \%shub2_01_00265_def,
   SH2_TSF_COMPARE6             => \%shub2_01_00266_def,
   SH2_TSF_COMPARE7             => \%shub2_01_00267_def,
   SH2_TSF_COMPARE8             => \%shub2_01_00268_def,
   SH2_TSF_COMPARE9             => \%shub2_01_00269_def,
   SH2_TSF_COMPARE10            => \%shub2_01_00270_def,
   SH2_TSF_COMPARE11            => \%shub2_01_00271_def,
   SH2_TSF_COMPARE12            => \%shub2_01_00272_def,
   SH2_TSF_COMPARE13            => \%shub2_01_00273_def,
   SH2_TSF_COMPARE14            => \%shub2_01_00274_def,
   SH2_TSF_COMPARE15            => \%shub2_01_00275_def,
   SH2_VEC_DATA                 => \%shub2_01_00276_def,
   SH2_VEC_PARMS                => \%shub2_01_00277_def,
   SH2_VEC_ROUTE                => \%shub2_01_00278_def,
   SH2_MCAST_DEST_0A            => \%shub2_01_00279_def,
   SH2_MCAST_DEST_0B            => \%shub2_01_00280_def,
   SH2_MCAST_DEST_1A            => \%shub2_01_00281_def,
   SH2_MCAST_DEST_1B            => \%shub2_01_00282_def,
   SH2_MCAST_DEST_2A            => \%shub2_01_00283_def,
   SH2_MCAST_DEST_2B            => \%shub2_01_00284_def,
   SH2_MCAST_DEST_3A            => \%shub2_01_00285_def,
   SH2_MCAST_DEST_3B            => \%shub2_01_00286_def,
   SH2_MCAST_DEST_4A            => \%shub2_01_00287_def,
   SH2_MCAST_DEST_4B            => \%shub2_01_00288_def,
   SH2_MCAST_DEST_5A            => \%shub2_01_00289_def,
   SH2_MCAST_DEST_5B            => \%shub2_01_00290_def,
   SH2_MCAST_DEST_6A            => \%shub2_01_00291_def,
   SH2_MCAST_DEST_6B            => \%shub2_01_00292_def,
   SH2_MCAST_DEST_7A            => \%shub2_01_00293_def,
   SH2_MCAST_DEST_7B            => \%shub2_01_00294_def,
   SH2_MCAST_DEST_8A            => \%shub2_01_00295_def,
   SH2_MCAST_DEST_8B            => \%shub2_01_00296_def,
   SH2_MCAST_DEST_9A            => \%shub2_01_00297_def,
   SH2_MCAST_DEST_9B            => \%shub2_01_00298_def,
   SH2_MCAST_DEST_10A           => \%shub2_01_00299_def,
   SH2_MCAST_DEST_10B           => \%shub2_01_00300_def,
   SH2_MCAST_DEST_11A           => \%shub2_01_00301_def,
   SH2_MCAST_DEST_11B           => \%shub2_01_00302_def,
   SH2_MCAST_DEST_12A           => \%shub2_01_00303_def,
   SH2_MCAST_DEST_12B           => \%shub2_01_00304_def,
   SH2_MCAST_DEST_13A           => \%shub2_01_00305_def,
   SH2_MCAST_DEST_13B           => \%shub2_01_00306_def,
   SH2_MCAST_DEST_14A           => \%shub2_01_00307_def,
   SH2_MCAST_DEST_14B           => \%shub2_01_00308_def,
   SH2_MCAST_DEST_15A           => \%shub2_01_00309_def,
   SH2_MCAST_DEST_15B           => \%shub2_01_00310_def,
   SH2_MCAST_DEST_16A           => \%shub2_01_00311_def,
   SH2_MCAST_DEST_16B           => \%shub2_01_00312_def,
   SH2_MCAST_DEST_17A           => \%shub2_01_00313_def,
   SH2_MCAST_DEST_17B           => \%shub2_01_00314_def,
   SH2_MCAST_DEST_18A           => \%shub2_01_00315_def,
   SH2_MCAST_DEST_18B           => \%shub2_01_00316_def,
   SH2_MCAST_DEST_19A           => \%shub2_01_00317_def,
   SH2_MCAST_DEST_19B           => \%shub2_01_00318_def,
   SH2_MCAST_DEST_20A           => \%shub2_01_00319_def,
   SH2_MCAST_DEST_20B           => \%shub2_01_00320_def,
   SH2_MCAST_DEST_21A           => \%shub2_01_00321_def,
   SH2_MCAST_DEST_21B           => \%shub2_01_00322_def,
   SH2_MCAST_DEST_22A           => \%shub2_01_00323_def,
   SH2_MCAST_DEST_22B           => \%shub2_01_00324_def,
   SH2_MCAST_DEST_23A           => \%shub2_01_00325_def,
   SH2_MCAST_DEST_23B           => \%shub2_01_00326_def,
   SH2_MCAST_DEST_24A           => \%shub2_01_00327_def,
   SH2_MCAST_DEST_24B           => \%shub2_01_00328_def,
   SH2_MCAST_DEST_25A           => \%shub2_01_00329_def,
   SH2_MCAST_DEST_25B           => \%shub2_01_00330_def,
   SH2_MCAST_DEST_26A           => \%shub2_01_00331_def,
   SH2_MCAST_DEST_26B           => \%shub2_01_00332_def,
   SH2_MCAST_DEST_27A           => \%shub2_01_00333_def,
   SH2_MCAST_DEST_27B           => \%shub2_01_00334_def,
   SH2_MCAST_DEST_28A           => \%shub2_01_00335_def,
   SH2_MCAST_DEST_28B           => \%shub2_01_00336_def,
   SH2_MCAST_DEST_29A           => \%shub2_01_00337_def,
   SH2_MCAST_DEST_29B           => \%shub2_01_00338_def,
   SH2_MCAST_DEST_30A           => \%shub2_01_00339_def,
   SH2_MCAST_DEST_30B           => \%shub2_01_00340_def,
   SH2_MCAST_DEST_31A           => \%shub2_01_00341_def,
   SH2_MCAST_DEST_31B           => \%shub2_01_00342_def,
   SH2_MCAST_DEST_100A          => \%shub2_01_00343_def,
   SH2_MCAST_DEST_100B          => \%shub2_01_00344_def,
   SH2_MCAST_DEST_101A          => \%shub2_01_00345_def,
   SH2_MCAST_DEST_101B          => \%shub2_01_00346_def,
   SH2_MCAST_DEST_102A          => \%shub2_01_00347_def,
   SH2_MCAST_DEST_102B          => \%shub2_01_00348_def,
   SH2_MCAST_DEST_103A          => \%shub2_01_00349_def,
   SH2_MCAST_DEST_103B          => \%shub2_01_00350_def,
   SH2_MCAST_DEST_104A          => \%shub2_01_00351_def,
   SH2_MCAST_DEST_104B          => \%shub2_01_00352_def,
   SH2_MCAST_DEST_105A          => \%shub2_01_00353_def,
   SH2_MCAST_DEST_105B          => \%shub2_01_00354_def,
   SH2_MCAST_DEST_106A          => \%shub2_01_00355_def,
   SH2_MCAST_DEST_106B          => \%shub2_01_00356_def,
   SH2_MCAST_DEST_107A          => \%shub2_01_00357_def,
   SH2_MCAST_DEST_107B          => \%shub2_01_00358_def,
   SH2_MCAST_DEST_108A          => \%shub2_01_00359_def,
   SH2_MCAST_DEST_108B          => \%shub2_01_00360_def,
   SH2_MCAST_DEST_109A          => \%shub2_01_00361_def,
   SH2_MCAST_DEST_109B          => \%shub2_01_00362_def,
   SH2_MCAST_DEST_110A          => \%shub2_01_00363_def,
   SH2_MCAST_DEST_110B          => \%shub2_01_00364_def,
   SH2_MCAST_DEST_111A          => \%shub2_01_00365_def,
   SH2_MCAST_DEST_111B          => \%shub2_01_00366_def,
   SH2_MCAST_DEST_112A          => \%shub2_01_00367_def,
   SH2_MCAST_DEST_112B          => \%shub2_01_00368_def,
   SH2_MCAST_DEST_113A          => \%shub2_01_00369_def,
   SH2_MCAST_DEST_113B          => \%shub2_01_00370_def,
   SH2_MCAST_DEST_114A          => \%shub2_01_00371_def,
   SH2_MCAST_DEST_114B          => \%shub2_01_00372_def,
   SH2_MCAST_DEST_115A          => \%shub2_01_00373_def,
   SH2_MCAST_DEST_115B          => \%shub2_01_00374_def,
   SH2_MCAST_DEST_116A          => \%shub2_01_00375_def,
   SH2_MCAST_DEST_116B          => \%shub2_01_00376_def,
   SH2_MCAST_DEST_117A          => \%shub2_01_00377_def,
   SH2_MCAST_DEST_117B          => \%shub2_01_00378_def,
   SH2_MCAST_DEST_118A          => \%shub2_01_00379_def,
   SH2_MCAST_DEST_118B          => \%shub2_01_00380_def,
   SH2_MCAST_DEST_119A          => \%shub2_01_00381_def,
   SH2_MCAST_DEST_119B          => \%shub2_01_00382_def,
   SH2_MCAST_DEST_120A          => \%shub2_01_00383_def,
   SH2_MCAST_DEST_120B          => \%shub2_01_00384_def,
   SH2_MCAST_DEST_121A          => \%shub2_01_00385_def,
   SH2_MCAST_DEST_121B          => \%shub2_01_00386_def,
   SH2_MCAST_DEST_122A          => \%shub2_01_00387_def,
   SH2_MCAST_DEST_122B          => \%shub2_01_00388_def,
   SH2_MCAST_DEST_123A          => \%shub2_01_00389_def,
   SH2_MCAST_DEST_123B          => \%shub2_01_00390_def,
   SH2_MCAST_DEST_124A          => \%shub2_01_00391_def,
   SH2_MCAST_DEST_124B          => \%shub2_01_00392_def,
   SH2_MCAST_DEST_125A          => \%shub2_01_00393_def,
   SH2_MCAST_DEST_125B          => \%shub2_01_00394_def,
   SH2_MCAST_DEST_126A          => \%shub2_01_00395_def,
   SH2_MCAST_DEST_126B          => \%shub2_01_00396_def,
   SH2_MCAST_DEST_127A          => \%shub2_01_00397_def,
   SH2_MCAST_DEST_127B          => \%shub2_01_00398_def,
   SH2_MCAST_DEST_128A          => \%shub2_01_00399_def,
   SH2_MCAST_DEST_128B          => \%shub2_01_00400_def,
   SH2_MCAST_DEST_129A          => \%shub2_01_00401_def,
   SH2_MCAST_DEST_129B          => \%shub2_01_00402_def,
   SH2_MCAST_DEST_130A          => \%shub2_01_00403_def,
   SH2_MCAST_DEST_130B          => \%shub2_01_00404_def,
   SH2_MCAST_DEST_131A          => \%shub2_01_00405_def,
   SH2_MCAST_DEST_131B          => \%shub2_01_00406_def,
   SH2_CPU_PERM0                => \%shub2_01_00407_def,
   SH2_CPU_PERM1                => \%shub2_01_00408_def,
   SH2_CPU_PERM2                => \%shub2_01_00409_def,
   SH2_CPU_PERM3                => \%shub2_01_00410_def,
   SH2_CPU_PERM_OVR             => \%shub2_01_00411_def,
   SH2_EXT_IO_PERM0             => \%shub2_01_00412_def,
   SH2_EXT_IO_PERM1             => \%shub2_01_00413_def,
   SH2_EXT_IO_PERM2             => \%shub2_01_00414_def,
   SH2_EXT_IO_PERM3             => \%shub2_01_00415_def,
   SH2_EXT_IOI_ACCESS0          => \%shub2_01_00416_def,
   SH2_EXT_IOI_ACCESS1          => \%shub2_01_00417_def,
   SH2_EXT_IOI_ACCESS2          => \%shub2_01_00418_def,
   SH2_EXT_IOI_ACCESS3          => \%shub2_01_00419_def,
   SH2_GC_FIL_CTRL              => \%shub2_01_00420_def,
   SH2_GC_SRC_CTRL              => \%shub2_01_00421_def,
   SH2_HARD_RESET               => \%shub2_01_00422_def,
   SH2_IPI_ACCESS0              => \%shub2_01_00423_def,
   SH2_IPI_ACCESS1              => \%shub2_01_00424_def,
   SH2_IPI_ACCESS2              => \%shub2_01_00425_def,
   SH2_IPI_ACCESS3              => \%shub2_01_00426_def,
   SH2_JTAG_CONFIG0             => \%shub2_01_00427_def,
   SH2_JTAG_CONFIG1             => \%shub2_01_00428_def,
   SH2_NODE_ID                  => \%shub2_01_00429_def,
   SH2_SOFT_RESET               => \%shub2_01_00430_def,
   SH2_NODE_PRESENT_TABLE       => \%shub2_01_00431_def,
   SH2_THROTTLE_INTERVAL        => \%shub2_01_00432_def,
   SH2_THROTTLE_TIME            => \%shub2_01_00433_def,
   SH2_THROTTLE_ENABLE          => \%shub2_01_00434_def,
   SH2_MCAST_INV_CONFIG         => \%shub2_01_00435_def,
   SH2_MCAST_MASK               => \%shub2_01_00436_def,
   SH2_FIRST_ERROR              => \%shub2_01_00437_def,
   SH2_BT_HW_TIME_STAMP         => \%shub2_01_00438_def,
   SH2_LB_HW_TIME_STAMP         => \%shub2_01_00439_def,
   SH2_MD_COR_TIME_STAMP        => \%shub2_01_00440_def,
   SH2_MD_HW_TIME_STAMP         => \%shub2_01_00441_def,
   SH2_MD_UNCOR_TIME_STAMP      => \%shub2_01_00442_def,
   SH2_PI_COR_TIME_STAMP        => \%shub2_01_00443_def,
   SH2_PI_HW_TIME_STAMP         => \%shub2_01_00444_def,
   SH2_PI_UNCOR_TIME_STAMP      => \%shub2_01_00445_def,
   SH2_XN_COR_TIME_STAMP        => \%shub2_01_00446_def,
   SH2_XN_HW_TIME_STAMP         => \%shub2_01_00447_def,
   SH2_XN_UNCOR_TIME_STAMP      => \%shub2_01_00448_def,
   SH2_DEBUG_PORT               => \%shub2_01_00449_def,
   SH2_LB_DEBUG_DATA            => \%shub2_01_00450_def,
   SH2_MD_DEBUG_DATA            => \%shub2_01_00451_def,
   SH2_PI_DEBUG_DATA            => \%shub2_01_00452_def,
   SH2_XN_DEBUG_DATA            => \%shub2_01_00453_def,
   SH2_BT_DEBUG_DATA            => \%shub2_01_00454_def,
   SH2_OB_LA_STATUS             => \%shub2_01_00455_def,
   SH2_OB_LA_SEQUENCE           => \%shub2_01_00456_def,
   SH2_OB_LA_CURRENT_ADDR       => \%shub2_01_00457_def,
   SH2_TSF_ARMED_STATE          => \%shub2_01_00458_def,
   SH2_TSF_COUNTER_VALUE        => \%shub2_01_00459_def,
   SH2_TSF_TRIGGERED_STATE      => \%shub2_01_00460_def,
   SH2_VEC_RDDATA               => \%shub2_01_00461_def,
   SH2_VEC_RETURN               => \%shub2_01_00462_def,
   SH2_VEC_STATUS               => \%shub2_01_00463_def,
   SH2_VEC_STATUS_ALIAS         => \%shub2_01_00464_def,
   SH2_LOGIC_ANALYZER_BUFFER    => \%shub2_01_00465_def,
   SH2_THROTTLE_STATUS          => \%shub2_01_00466_def,
   SH2_MMRBIST_ERR              => \%shub2_01_00467_def,
   SH2_MISC_ERR_HDR_LOWER       => \%shub2_01_00468_def,
   SH2_MISC_ERR_HDR_UPPER       => \%shub2_01_00469_def,
   SH2_DIR_UC_ERR_HDR_LOWER     => \%shub2_01_00470_def,
   SH2_DIR_UC_ERR_HDR_UPPER     => \%shub2_01_00471_def,
   SH2_DIR_COR_ERR_HDR_LOWER    => \%shub2_01_00472_def,
   SH2_DIR_COR_ERR_HDR_UPPER    => \%shub2_01_00473_def,
   SH2_MEM_ERROR_SUMMARY        => \%shub2_01_00474_def,
   SH2_MEM_ERROR_SUMMARY_ALIAS  => \%shub2_01_00475_def,
   SH2_MEM_ERROR_OVERFLOW       => \%shub2_01_00476_def,
   SH2_MEM_ERROR_OVERFLOW_ALIAS => \%shub2_01_00477_def,
   SH2_MEM_ERROR_MASK           => \%shub2_01_00478_def,
   SH2_MISC_ADRS_ERR_HDR_LOWER_A => \%shub2_01_00479_def,
   SH2_DIR_UC_ADRS_ERR_HDR_LOWER_A => \%shub2_01_00480_def,
   SH2_DIR_COR_ADRS_ERR_HDR_LOWER_A => \%shub2_01_00481_def,
   SH2_MEM_FIRST_ERROR          => \%shub2_01_00482_def,
   SH2_MEM_FIRST_ERROR_ALIAS    => \%shub2_01_00483_def,
   SH2_X_DIMM_CFG               => \%shub2_01_00484_def,
   SH2_Y_DIMM_CFG               => \%shub2_01_00485_def,
   SH2_JNR_DIMM_CFG             => \%shub2_01_00486_def,
   SH2_X_ODT_CFG                => \%shub2_01_00487_def,
   SH2_X_CFG                    => \%shub2_01_00488_def,
   SH2_X_DQCT_CFG               => \%shub2_01_00489_def,
   SH2_X_REFRESH_CONTROL        => \%shub2_01_00490_def,
   SH2_X_AMOC_CFG               => \%shub2_01_00491_def,
   SH2_X_AMOC_TAG               => \%shub2_01_00492_def,
   SH2_Y_ODT_CFG                => \%shub2_01_00493_def,
   SH2_Y_CFG                    => \%shub2_01_00494_def,
   SH2_Y_DQCT_CFG               => \%shub2_01_00495_def,
   SH2_Y_REFRESH_CONTROL        => \%shub2_01_00496_def,
   SH2_Y_AMOC_CFG               => \%shub2_01_00497_def,
   SH2_Y_AMOC_TAG               => \%shub2_01_00498_def,
   SH2_MEM_RED_BLACK            => \%shub2_01_00499_def,
   SH2_MISC_MEM_CFG             => \%shub2_01_00500_def,
   SH2_MEM_CREDITS              => \%shub2_01_00501_def,
   SH2_STATUS0                  => \%shub2_01_00502_def,
   SH2_STATUS0_ALIAS            => \%shub2_01_00503_def,
   SH2_STATUS1                  => \%shub2_01_00504_def,
   SH2_STATUS1_ALIAS            => \%shub2_01_00505_def,
   SH2_STATUS2                  => \%shub2_01_00506_def,
   SH2_STATUS2_ALIAS            => \%shub2_01_00507_def,
   SH2_STATUS3                  => \%shub2_01_00508_def,
   SH2_STATUS3_ALIAS            => \%shub2_01_00509_def,
   SH2_CFG                      => \%shub2_01_00510_def,
   SH2_PIO_RQ_CRD_CTL           => \%shub2_01_00511_def,
   SH2_PI_MD_RQ_CRD_CTL         => \%shub2_01_00512_def,
   SH2_PI_MD_RP_CRD_CTL         => \%shub2_01_00513_def,
   SH2_XN_MD_RQ_CRD_CTL         => \%shub2_01_00514_def,
   SH2_XN_MD_RP_CRD_CTL         => \%shub2_01_00515_def,
   SH2_X_TAG0                   => \%shub2_01_00516_def,
   SH2_X_TAG1                   => \%shub2_01_00517_def,
   SH2_X_TAG2                   => \%shub2_01_00518_def,
   SH2_X_TAG3                   => \%shub2_01_00519_def,
   SH2_X_TAG4                   => \%shub2_01_00520_def,
   SH2_X_TAG5                   => \%shub2_01_00521_def,
   SH2_X_TAG6                   => \%shub2_01_00522_def,
   SH2_X_TAG7                   => \%shub2_01_00523_def,
   SH2_Y_TAG0                   => \%shub2_01_00524_def,
   SH2_Y_TAG1                   => \%shub2_01_00525_def,
   SH2_Y_TAG2                   => \%shub2_01_00526_def,
   SH2_Y_TAG3                   => \%shub2_01_00527_def,
   SH2_Y_TAG4                   => \%shub2_01_00528_def,
   SH2_Y_TAG5                   => \%shub2_01_00529_def,
   SH2_Y_TAG6                   => \%shub2_01_00530_def,
   SH2_Y_TAG7                   => \%shub2_01_00531_def,
   SH2_MMRBIST_BASE             => \%shub2_01_00532_def,
   SH2_MMRBIST_CTL              => \%shub2_01_00533_def,
   SH2_MD_DBUG_DATA_CFG         => \%shub2_01_00534_def,
   SH2_MD_DBUG_TRIGGER_CFG      => \%shub2_01_00535_def,
   SH2_MD_DBUG_COMPARE          => \%shub2_01_00536_def,
   SH2_X_TAG_DBUG_SEL           => \%shub2_01_00537_def,
   SH2_X_WBQ_DBUG_SEL           => \%shub2_01_00538_def,
   SH2_X_ARB_DBUG_SEL           => \%shub2_01_00539_def,
   SH2_X_ATL_DBUG_SEL           => \%shub2_01_00540_def,
   SH2_X_ATR_DBUG_SEL           => \%shub2_01_00541_def,
   SH2_X_DQL_DBUG_SEL           => \%shub2_01_00542_def,
   SH2_X_DQR_DBUG_SEL           => \%shub2_01_00543_def,
   SH2_X_DBUG_SEL               => \%shub2_01_00544_def,
   SH2_X_LADDR_CMP              => \%shub2_01_00545_def,
   SH2_X_RADDR_CMP              => \%shub2_01_00546_def,
   SH2_X_TAG_CMP                => \%shub2_01_00547_def,
   SH2_X_TAG_MASK               => \%shub2_01_00548_def,
   SH2_Y_TAG_DBUG_SEL           => \%shub2_01_00549_def,
   SH2_Y_WBQ_DBUG_SEL           => \%shub2_01_00550_def,
   SH2_Y_ARB_DBUG_SEL           => \%shub2_01_00551_def,
   SH2_Y_ATL_DBUG_SEL           => \%shub2_01_00552_def,
   SH2_Y_ATR_DBUG_SEL           => \%shub2_01_00553_def,
   SH2_Y_DQL_DBUG_SEL           => \%shub2_01_00554_def,
   SH2_Y_DQR_DBUG_SEL           => \%shub2_01_00555_def,
   SH2_Y_DBUG_SEL               => \%shub2_01_00556_def,
   SH2_Y_LADDR_CMP              => \%shub2_01_00557_def,
   SH2_Y_RADDR_CMP              => \%shub2_01_00558_def,
   SH2_Y_TAG_CMP                => \%shub2_01_00559_def,
   SH2_Y_TAG_MASK               => \%shub2_01_00560_def,
   SH2_MD_JNR_DBUG_DATA_CFG     => \%shub2_01_00561_def,
   SH2_MD_LAST_CREDIT           => \%shub2_01_00562_def,
   SH2_MEM_REDUCE_XN_TNUMS      => \%shub2_01_00563_def,
   SH2_MEM_CAPTURE_ADDR         => \%shub2_01_00564_def,
   SH2_MEM_CAPTURE_MASK         => \%shub2_01_00565_def,
   SH2_MEM_CAPTURE_HDR          => \%shub2_01_00566_def,
   SH2_MEM_CAPTURE_HDR_ADDR     => \%shub2_01_00567_def,
   SH2_MD_DQLP_MMR_DIR_CONFIG   => \%shub2_01_00568_def,
   SH2_MD_DQLP_MMR_DIR_PRESVEC0 => \%shub2_01_00569_def,
   SH2_MD_DQLP_MMR_DIR_PRESVEC1 => \%shub2_01_00570_def,
   SH2_MD_DQLP_MMR_DIR_PRESVEC2 => \%shub2_01_00571_def,
   SH2_MD_DQLP_MMR_DIR_PRESVEC3 => \%shub2_01_00572_def,
   SH2_MD_DQLP_MMR_DIR_LOCVEC0  => \%shub2_01_00573_def,
   SH2_MD_DQLP_MMR_DIR_LOCVEC1  => \%shub2_01_00574_def,
   SH2_MD_DQLP_MMR_DIR_LOCVEC2  => \%shub2_01_00575_def,
   SH2_MD_DQLP_MMR_DIR_LOCVEC3  => \%shub2_01_00576_def,
   SH2_MD_DQLP_MMR_DIR_LOCVEC4  => \%shub2_01_00577_def,
   SH2_MD_DQLP_MMR_DIR_LOCVEC5  => \%shub2_01_00578_def,
   SH2_MD_DQLP_MMR_DIR_LOCVEC6  => \%shub2_01_00579_def,
   SH2_MD_DQLP_MMR_DIR_LOCVEC7  => \%shub2_01_00580_def,
   SH2_MD_DQLP_MMR_DIR_PRIVEC0  => \%shub2_01_00581_def,
   SH2_MD_DQLP_MMR_DIR_PRIVEC1  => \%shub2_01_00582_def,
   SH2_MD_DQLP_MMR_DIR_PRIVEC2  => \%shub2_01_00583_def,
   SH2_MD_DQLP_MMR_DIR_PRIVEC3  => \%shub2_01_00584_def,
   SH2_MD_DQLP_MMR_DIR_PRIVEC4  => \%shub2_01_00585_def,
   SH2_MD_DQLP_MMR_DIR_PRIVEC5  => \%shub2_01_00586_def,
   SH2_MD_DQLP_MMR_DIR_PRIVEC6  => \%shub2_01_00587_def,
   SH2_MD_DQLP_MMR_DIR_PRIVEC7  => \%shub2_01_00588_def,
   SH2_MD_DQLP_MMR_DIR_TIMER    => \%shub2_01_00589_def,
   SH2_MD_DQLP_MMR_PIOWD_DIR_ENTRY => \%shub2_01_00590_def,
   SH2_MD_DQLP_MMR_PIOWD_DIR_ECC => \%shub2_01_00591_def,
   SH2_MD_DQLP_MMR_XPIORD_XDIR_ENTRY => \%shub2_01_00592_def,
   SH2_MD_DQLP_MMR_XPIORD_XDIR_ECC => \%shub2_01_00593_def,
   SH2_MD_DQLP_MMR_YPIORD_YDIR_ENTRY => \%shub2_01_00594_def,
   SH2_MD_DQLP_MMR_YPIORD_YDIR_ECC => \%shub2_01_00595_def,
   SH2_MD_DQLP_MMR_XCERR1       => \%shub2_01_00596_def,
   SH2_MD_DQLP_MMR_XCERR2       => \%shub2_01_00597_def,
   SH2_MD_DQLP_MMR_XUERR1       => \%shub2_01_00598_def,
   SH2_MD_DQLP_MMR_XUERR2       => \%shub2_01_00599_def,
   SH2_MD_DQLP_MMR_XPERR0       => \%shub2_01_00600_def,
   SH2_MD_DQLP_MMR_XPERR1       => \%shub2_01_00601_def,
   SH2_MD_DQLP_MMR_YCERR1       => \%shub2_01_00602_def,
   SH2_MD_DQLP_MMR_YCERR2       => \%shub2_01_00603_def,
   SH2_MD_DQLP_MMR_YUERR1       => \%shub2_01_00604_def,
   SH2_MD_DQLP_MMR_YUERR2       => \%shub2_01_00605_def,
   SH2_MD_DQLP_MMR_YPERR0       => \%shub2_01_00606_def,
   SH2_MD_DQLP_MMR_YPERR1       => \%shub2_01_00607_def,
   SH2_MD_DQLP_MMR_DIR_CMDTRIG  => \%shub2_01_00608_def,
   SH2_MD_DQLP_MMR_DIR_TBLTRIG  => \%shub2_01_00609_def,
   SH2_MD_DQLP_MMR_DIR_TBLMASK  => \%shub2_01_00610_def,
   SH2_MD_DQLP_MMR_XBIST_H      => \%shub2_01_00611_def,
   SH2_MD_DQLP_MMR_XBIST_L      => \%shub2_01_00612_def,
   SH2_MD_DQLP_MMR_XBIST_ERR_H  => \%shub2_01_00613_def,
   SH2_MD_DQLP_MMR_XBIST_ERR_L  => \%shub2_01_00614_def,
   SH2_MD_DQLP_MMR_XBIST_MASK   => \%shub2_01_00615_def,
   SH2_MD_DQLP_MMR_YBIST_H      => \%shub2_01_00616_def,
   SH2_MD_DQLP_MMR_YBIST_L      => \%shub2_01_00617_def,
   SH2_MD_DQLP_MMR_YBIST_ERR_H  => \%shub2_01_00618_def,
   SH2_MD_DQLP_MMR_YBIST_ERR_L  => \%shub2_01_00619_def,
   SH2_MD_DQLP_MMR_YBIST_MASK   => \%shub2_01_00620_def,
   SH2_MD_DQLP_MMR_AMO_CFG      => \%shub2_01_00621_def,
   SH2_MD_DQLS_MMR_XBIST_H      => \%shub2_01_00622_def,
   SH2_MD_DQLS_MMR_XBIST_L      => \%shub2_01_00623_def,
   SH2_MD_DQLS_MMR_XBIST_ERR_H  => \%shub2_01_00624_def,
   SH2_MD_DQLS_MMR_XBIST_ERR_L  => \%shub2_01_00625_def,
   SH2_MD_DQLS_MMR_XBIST_MASK   => \%shub2_01_00626_def,
   SH2_MD_DQLS_MMR_YBIST_H      => \%shub2_01_00627_def,
   SH2_MD_DQLS_MMR_YBIST_L      => \%shub2_01_00628_def,
   SH2_MD_DQLS_MMR_YBIST_ERR_H  => \%shub2_01_00629_def,
   SH2_MD_DQLS_MMR_YBIST_ERR_L  => \%shub2_01_00630_def,
   SH2_MD_DQLS_MMR_YBIST_MASK   => \%shub2_01_00631_def,
   SH2_MD_DQLS_MMR_JNR_DEBUG    => \%shub2_01_00632_def,
   SH2_MD_DQLS_MMR_XAMOPW_ERR   => \%shub2_01_00633_def,
   SH2_MD_DQLS_MMR_AMO_CFG      => \%shub2_01_00634_def,
   SH2_MD_DQRP_MMR_DIR_CONFIG   => \%shub2_01_00635_def,
   SH2_MD_DQRP_MMR_DIR_PRESVEC0 => \%shub2_01_00636_def,
   SH2_MD_DQRP_MMR_DIR_PRESVEC1 => \%shub2_01_00637_def,
   SH2_MD_DQRP_MMR_DIR_PRESVEC2 => \%shub2_01_00638_def,
   SH2_MD_DQRP_MMR_DIR_PRESVEC3 => \%shub2_01_00639_def,
   SH2_MD_DQRP_MMR_DIR_LOCVEC0  => \%shub2_01_00640_def,
   SH2_MD_DQRP_MMR_DIR_LOCVEC1  => \%shub2_01_00641_def,
   SH2_MD_DQRP_MMR_DIR_LOCVEC2  => \%shub2_01_00642_def,
   SH2_MD_DQRP_MMR_DIR_LOCVEC3  => \%shub2_01_00643_def,
   SH2_MD_DQRP_MMR_DIR_LOCVEC4  => \%shub2_01_00644_def,
   SH2_MD_DQRP_MMR_DIR_LOCVEC5  => \%shub2_01_00645_def,
   SH2_MD_DQRP_MMR_DIR_LOCVEC6  => \%shub2_01_00646_def,
   SH2_MD_DQRP_MMR_DIR_LOCVEC7  => \%shub2_01_00647_def,
   SH2_MD_DQRP_MMR_DIR_PRIVEC0  => \%shub2_01_00648_def,
   SH2_MD_DQRP_MMR_DIR_PRIVEC1  => \%shub2_01_00649_def,
   SH2_MD_DQRP_MMR_DIR_PRIVEC2  => \%shub2_01_00650_def,
   SH2_MD_DQRP_MMR_DIR_PRIVEC3  => \%shub2_01_00651_def,
   SH2_MD_DQRP_MMR_DIR_PRIVEC4  => \%shub2_01_00652_def,
   SH2_MD_DQRP_MMR_DIR_PRIVEC5  => \%shub2_01_00653_def,
   SH2_MD_DQRP_MMR_DIR_PRIVEC6  => \%shub2_01_00654_def,
   SH2_MD_DQRP_MMR_DIR_PRIVEC7  => \%shub2_01_00655_def,
   SH2_MD_DQRP_MMR_DIR_TIMER    => \%shub2_01_00656_def,
   SH2_MD_DQRP_MMR_PIOWD_DIR_ENTRY => \%shub2_01_00657_def,
   SH2_MD_DQRP_MMR_PIOWD_DIR_ECC => \%shub2_01_00658_def,
   SH2_MD_DQRP_MMR_XPIORD_XDIR_ENTRY => \%shub2_01_00659_def,
   SH2_MD_DQRP_MMR_XPIORD_XDIR_ECC => \%shub2_01_00660_def,
   SH2_MD_DQRP_MMR_YPIORD_YDIR_ENTRY => \%shub2_01_00661_def,
   SH2_MD_DQRP_MMR_YPIORD_YDIR_ECC => \%shub2_01_00662_def,
   SH2_MD_DQRP_MMR_XCERR1       => \%shub2_01_00663_def,
   SH2_MD_DQRP_MMR_XCERR2       => \%shub2_01_00664_def,
   SH2_MD_DQRP_MMR_XUERR1       => \%shub2_01_00665_def,
   SH2_MD_DQRP_MMR_XUERR2       => \%shub2_01_00666_def,
   SH2_MD_DQRP_MMR_XPERR0       => \%shub2_01_00667_def,
   SH2_MD_DQRP_MMR_XPERR1       => \%shub2_01_00668_def,
   SH2_MD_DQRP_MMR_YCERR1       => \%shub2_01_00669_def,
   SH2_MD_DQRP_MMR_YCERR2       => \%shub2_01_00670_def,
   SH2_MD_DQRP_MMR_YUERR1       => \%shub2_01_00671_def,
   SH2_MD_DQRP_MMR_YUERR2       => \%shub2_01_00672_def,
   SH2_MD_DQRP_MMR_YPERR0       => \%shub2_01_00673_def,
   SH2_MD_DQRP_MMR_YPERR1       => \%shub2_01_00674_def,
   SH2_MD_DQRP_MMR_DIR_CMDTRIG  => \%shub2_01_00675_def,
   SH2_MD_DQRP_MMR_DIR_TBLTRIG  => \%shub2_01_00676_def,
   SH2_MD_DQRP_MMR_DIR_TBLMASK  => \%shub2_01_00677_def,
   SH2_MD_DQRP_MMR_XBIST_H      => \%shub2_01_00678_def,
   SH2_MD_DQRP_MMR_XBIST_L      => \%shub2_01_00679_def,
   SH2_MD_DQRP_MMR_XBIST_ERR_H  => \%shub2_01_00680_def,
   SH2_MD_DQRP_MMR_XBIST_ERR_L  => \%shub2_01_00681_def,
   SH2_MD_DQRP_MMR_XBIST_MASK   => \%shub2_01_00682_def,
   SH2_MD_DQRP_MMR_YBIST_H      => \%shub2_01_00683_def,
   SH2_MD_DQRP_MMR_YBIST_L      => \%shub2_01_00684_def,
   SH2_MD_DQRP_MMR_YBIST_ERR_H  => \%shub2_01_00685_def,
   SH2_MD_DQRP_MMR_YBIST_ERR_L  => \%shub2_01_00686_def,
   SH2_MD_DQRP_MMR_YBIST_MASK   => \%shub2_01_00687_def,
   SH2_MD_DQRP_MMR_AMO_CFG      => \%shub2_01_00688_def,
   SH2_MD_DQRS_MMR_XBIST_H      => \%shub2_01_00689_def,
   SH2_MD_DQRS_MMR_XBIST_L      => \%shub2_01_00690_def,
   SH2_MD_DQRS_MMR_XBIST_ERR_H  => \%shub2_01_00691_def,
   SH2_MD_DQRS_MMR_XBIST_ERR_L  => \%shub2_01_00692_def,
   SH2_MD_DQRS_MMR_XBIST_MASK   => \%shub2_01_00693_def,
   SH2_MD_DQRS_MMR_YBIST_H      => \%shub2_01_00694_def,
   SH2_MD_DQRS_MMR_YBIST_L      => \%shub2_01_00695_def,
   SH2_MD_DQRS_MMR_YBIST_ERR_H  => \%shub2_01_00696_def,
   SH2_MD_DQRS_MMR_YBIST_ERR_L  => \%shub2_01_00697_def,
   SH2_MD_DQRS_MMR_YBIST_MASK   => \%shub2_01_00698_def,
   SH2_MD_DQRS_MMR_JNR_DEBUG    => \%shub2_01_00699_def,
   SH2_MD_DQRS_MMR_YAMOPW_ERR   => \%shub2_01_00700_def,
   SH2_MD_DQRS_MMR_AMO_CFG      => \%shub2_01_00701_def,
   SH2_ADDRESS_MODE             => \%shub2_01_00702_def,
   SH2_FIRMWARE_REMAP           => \%shub2_01_00703_def,
   SH2_PROCESSOR_TYPE           => \%shub2_01_00704_def,
   SH2_VGA_REMAP                => \%shub2_01_00705_def,
   SH2_FSB_BINIT_CONTROL        => \%shub2_01_00706_def,
   SH2_FSB_POWER_ON_CONFIG      => \%shub2_01_00707_def,
   SH2_FSB_RESET_CONTROL        => \%shub2_01_00708_def,
   SH2_FSB_SYSTEM_AGENT_CONFIG  => \%shub2_01_00709_def,
   SH2_FSB_IO_READ_TRANS        => \%shub2_01_00710_def,
   SH2_FSB_IO_READ_TRANS_ODD    => \%shub2_01_00711_def,
   SH2_FSB_RESET_STATUS         => \%shub2_01_00712_def,
   SH2_FSB_SYMMETRIC_AGENT_STATUS => \%shub2_01_00713_def,
   SH2_MEMORY_WRITE_STATUS_00   => \%shub2_01_00714_def,
   SH2_MEMORY_WRITE_STATUS_01   => \%shub2_01_00715_def,
   SH2_MEMORY_WRITE_STATUS_10   => \%shub2_01_00716_def,
   SH2_MEMORY_WRITE_STATUS_11   => \%shub2_01_00717_def,
   SH2_PIO_WRITE_STATUS_00      => \%shub2_01_00718_def,
   SH2_PIO_WRITE_STATUS_00_ALIAS => \%shub2_01_00719_def,
   SH2_PIO_WRITE_STATUS_01      => \%shub2_01_00720_def,
   SH2_PIO_WRITE_STATUS_01_ALIAS => \%shub2_01_00721_def,
   SH2_PIO_WRITE_STATUS_10      => \%shub2_01_00722_def,
   SH2_PIO_WRITE_STATUS_10_ALIAS => \%shub2_01_00723_def,
   SH2_PIO_WRITE_STATUS_11      => \%shub2_01_00724_def,
   SH2_PIO_WRITE_STATUS_11_ALIAS => \%shub2_01_00725_def,
   SH2_MEMORY_WRITE_STATUS_NON_USER_00 => \%shub2_01_00726_def,
   SH2_MEMORY_WRITE_STATUS_NON_USER_01 => \%shub2_01_00727_def,
   SH2_MEMORY_WRITE_STATUS_NON_USER_10 => \%shub2_01_00728_def,
   SH2_MEMORY_WRITE_STATUS_NON_USER_11 => \%shub2_01_00729_def,
   SH2_PIO_WC_WRITE_STATUS_00   => \%shub2_01_00730_def,
   SH2_PIO_WC_WRITE_STATUS_00_ALIAS => \%shub2_01_00731_def,
   SH2_PIO_WC_WRITE_STATUS_01   => \%shub2_01_00732_def,
   SH2_PIO_WC_WRITE_STATUS_01_ALIAS => \%shub2_01_00733_def,
   SH2_PIO_WC_WRITE_STATUS_10   => \%shub2_01_00734_def,
   SH2_PIO_WC_WRITE_STATUS_10_ALIAS => \%shub2_01_00735_def,
   SH2_PIO_WC_WRITE_STATUS_11   => \%shub2_01_00736_def,
   SH2_PIO_WC_WRITE_STATUS_11_ALIAS => \%shub2_01_00737_def,
   SH2_PI_FSBC_CTP_COMPARATOR   => \%shub2_01_00738_def,
   SH2_PI_FSBC_CTP_DEBUG_PORT   => \%shub2_01_00739_def,
   SH2_PI_FSBC_CTP_COMPARATOR_OPERAND => \%shub2_01_00740_def,
   SH2_PI_FSBC_FTP_COMPARATOR   => \%shub2_01_00741_def,
   SH2_PI_FSBC_FTP_DEBUG_PORT   => \%shub2_01_00742_def,
   SH2_PI_FSBC_FTP_COMPARATOR_OPERAND => \%shub2_01_00743_def,
   SH2_PI_AFI_ERROR_MASK        => \%shub2_01_00744_def,
   SH2_PI_AUTO_REPLY_ENABLE     => \%shub2_01_00745_def,
   SH2_PI_CAM_CONTROL           => \%shub2_01_00746_def,
   SH2_PI_CRBC_TEST_POINT_COMPARE => \%shub2_01_00747_def,
   SH2_PI_CRBC_TEST_POINT_SELECT => \%shub2_01_00748_def,
   SH2_PI_CRBC_TEST_POINT_TRIGGER_SELECT => \%shub2_01_00749_def,
   SH2_PI_CRBP_ERROR_MASK       => \%shub2_01_00750_def,
   SH2_PI_CRBP_FSB_PIPE_COMPARE => \%shub2_01_00751_def,
   SH2_PI_CRBP_FSB_PIPE_MASK    => \%shub2_01_00752_def,
   SH2_PI_CRBP_TEST_POINT_COMPARE => \%shub2_01_00753_def,
   SH2_PI_CRBP_TEST_POINT_SELECT => \%shub2_01_00754_def,
   SH2_PI_CRBP_TEST_POINT_TRIGGER_SELECT => \%shub2_01_00755_def,
   SH2_PI_CRBP_XB_PIPE_COMPARE_0 => \%shub2_01_00756_def,
   SH2_PI_CRBP_XB_PIPE_COMPARE_1 => \%shub2_01_00757_def,
   SH2_PI_CRBP_XB_PIPE_MASK_0   => \%shub2_01_00758_def,
   SH2_PI_CRBP_XB_PIPE_MASK_1   => \%shub2_01_00759_def,
   SH2_PI_DPC_QUEUE_CONFIG      => \%shub2_01_00760_def,
   SH2_PI_FSB_ERROR_INJECTION   => \%shub2_01_00761_def,
   SH2_PI_ERROR_MASK            => \%shub2_01_00762_def,
   SH2_PI_FSB_COMPARE_VALUE     => \%shub2_01_00763_def,
   SH2_PI_FSB_COMPARE_MASK      => \%shub2_01_00764_def,
   SH2_PI_FSB_ERROR_INJECTION   => \%shub2_01_00765_def,
   SH2_PI_FTP_COMPARATOR        => \%shub2_01_00766_def,
   SH2_PI_FTP_COMPARATOR_OPERAND => \%shub2_01_00767_def,
   SH2_PI_FTP_DEBUG_PORT        => \%shub2_01_00768_def,
   SH2_PI_MD2PI_REPLY_VC_CONFIG => \%shub2_01_00769_def,
   SH2_PI_MD2PI_REQUEST_VC_CONFIG => \%shub2_01_00770_def,
   SH2_PI_QUEUE_ERROR_INJECTION => \%shub2_01_00771_def,
   SH2_PI_RDAT_CLEAR_ERROR      => \%shub2_01_00772_def,
   SH2_PI_RDAT_CTP_COMPARATOR   => \%shub2_01_00773_def,
   SH2_PI_RDAT_CTP_COMPARATOR_OPERAND => \%shub2_01_00774_def,
   SH2_PI_RDAT_CTP_DEBUG_PORT   => \%shub2_01_00775_def,
   SH2_PI_RDAT_ERROR_MASK       => \%shub2_01_00776_def,
   SH2_PI_RDAT_FTP_COMPARATOR   => \%shub2_01_00777_def,
   SH2_PI_RDAT_FTP_COMPARATOR_OPERAND => \%shub2_01_00778_def,
   SH2_PI_RDAT_FTP_DEBUG_PORT   => \%shub2_01_00779_def,
   SH2_PI_RDAT_POISON_SNAN_DEP  => \%shub2_01_00780_def,
   SH2_PI_TEST_POINT_COMPARE    => \%shub2_01_00781_def,
   SH2_PI_TEST_POINT_SELECT     => \%shub2_01_00782_def,
   SH2_PI_TEST_POINT_TRIGGER_SELECT => \%shub2_01_00783_def,
   SH2_PI_WDAT_CTP_COMPARATOR   => \%shub2_01_00784_def,
   SH2_PI_WDAT_CTP_COMPARATOR_OPERAND => \%shub2_01_00785_def,
   SH2_PI_WDAT_CTP_DEBUG_PORT   => \%shub2_01_00786_def,
   SH2_PI_WDAT_ERROR_MASK       => \%shub2_01_00787_def,
   SH2_PI_WDAT_FSB_ACK_Q_CONFIG => \%shub2_01_00788_def,
   SH2_PI_WDAT_FSB_CMND_Q_CONFIG => \%shub2_01_00789_def,
   SH2_PI_WDAT_FTP_COMPARATOR   => \%shub2_01_00790_def,
   SH2_PI_WDAT_FTP_COMPARATOR_OPERAND => \%shub2_01_00791_def,
   SH2_PI_WDAT_FTP_DEBUG_PORT   => \%shub2_01_00792_def,
   SH2_PI_WDAT_REPLAY_COUNT_RESET => \%shub2_01_00793_def,
   SH2_PI_XN2PI_REPLY_VC_CONFIG => \%shub2_01_00794_def,
   SH2_PI_XN2PI_REQUEST_VC_CONFIG => \%shub2_01_00795_def,
   SH2_PI_CRB_STALL_SKID        => \%shub2_01_00796_def,
   SH2_PI_AFI_FIRST_ERROR       => \%shub2_01_00797_def,
   SH2_PI_CAM_ADDRESS_READ_DATA => \%shub2_01_00798_def,
   SH2_PI_CAM_LPRA_READ_DATA    => \%shub2_01_00799_def,
   SH2_PI_CAM_STATE_READ_DATA   => \%shub2_01_00800_def,
   SH2_PI_CORRECTED_DETAIL_1    => \%shub2_01_00801_def,
   SH2_PI_CORRECTED_DETAIL_2    => \%shub2_01_00802_def,
   SH2_PI_CORRECTED_DETAIL_3    => \%shub2_01_00803_def,
   SH2_PI_CORRECTED_DETAIL_4    => \%shub2_01_00804_def,
   SH2_PI_CORRECTED_DETAIL_5    => \%shub2_01_00805_def,
   SH2_PI_CORRECTED_DETAIL_6    => \%shub2_01_00806_def,
   SH2_PI_CRBP_FIRST_ERROR      => \%shub2_01_00807_def,
   SH2_PI_ERROR_DETAIL_1        => \%shub2_01_00808_def,
   SH2_PI_ERROR_DETAIL_2        => \%shub2_01_00809_def,
   SH2_PI_ERROR_OVERFLOW        => \%shub2_01_00810_def,
   SH2_PI_ERROR_OVERFLOW_ALIAS  => \%shub2_01_00811_def,
   SH2_PI_ERROR_SUMMARY         => \%shub2_01_00812_def,
   SH2_PI_ERROR_SUMMARY_ALIAS   => \%shub2_01_00813_def,
   SH2_PI_FIRST_ERROR           => \%shub2_01_00814_def,
   SH2_PI_FIRST_ERROR_ALIAS     => \%shub2_01_00815_def,
   SH2_PI_PI2MD_REPLY_VC_STATUS => \%shub2_01_00816_def,
   SH2_PI_PI2MD_REQUEST_VC_STATUS => \%shub2_01_00817_def,
   SH2_PI_PI2XN_REPLY_VC_STATUS => \%shub2_01_00818_def,
   SH2_PI_PI2XN_REQUEST_VC_STATUS => \%shub2_01_00819_def,
   SH2_PI_UNCORRECTED_DETAIL_1  => \%shub2_01_00820_def,
   SH2_PI_UNCORRECTED_DETAIL_2  => \%shub2_01_00821_def,
   SH2_PI_UNCORRECTED_DETAIL_3  => \%shub2_01_00822_def,
   SH2_PI_UNCORRECTED_DETAIL_4  => \%shub2_01_00823_def,
   SH2_PI_UNCORRECTED_DETAIL_5  => \%shub2_01_00824_def,
   SH2_PI_UNCORRECTED_DETAIL_6  => \%shub2_01_00825_def,
   SH2_PI_MD2PI_REPLY_VC_STATUS => \%shub2_01_00826_def,
   SH2_PI_MD2PI_REQUEST_VC_STATUS => \%shub2_01_00827_def,
   SH2_PI_WDAT_REPLAY_COUNT     => \%shub2_01_00828_def,
   SH2_PI_XN2PI_REPLY_VC_STATUS => \%shub2_01_00829_def,
   SH2_PI_XN2PI_REQUEST_VC_STATUS => \%shub2_01_00830_def,
   SH2_CRB_MESSAGE_CONTROL      => \%shub2_01_00831_def,
   SH2_CRB_NACK_LIMIT           => \%shub2_01_00832_def,
   SH2_CRB_TIMEOUT_PRESCALE     => \%shub2_01_00833_def,
   SH2_CRB_TIMEOUT_SKID         => \%shub2_01_00834_def,
   SH2_NI0_LLP_STAT             => \%shub2_01_00835_def,
   SH2_NI0_LLP_RESET            => \%shub2_01_00836_def,
   SH2_NI0_LLP_RESET_EN         => \%shub2_01_00837_def,
   SH2_NI0_LLP_CHAN_MODE        => \%shub2_01_00838_def,
   SH2_NI0_LLP_CONFIG           => \%shub2_01_00839_def,
   SH2_NI0_LLP_TEST_CTL         => \%shub2_01_00840_def,
   SH2_NI0_LLP_CAPT_WD1         => \%shub2_01_00841_def,
   SH2_NI0_LLP_CAPT_WD2         => \%shub2_01_00842_def,
   SH2_NI0_LLP_CAPT_SBCB        => \%shub2_01_00843_def,
   SH2_NI0_LLP_ERR              => \%shub2_01_00844_def,
   SH2_NI0_LLP_ERR1             => \%shub2_01_00845_def,
   SH2_NI0_LLP_ERR2             => \%shub2_01_00846_def,
   SH2_NI0_LLP_PKT              => \%shub2_01_00847_def,
   SH2_NI1_LLP_STAT             => \%shub2_01_00848_def,
   SH2_NI1_LLP_RESET            => \%shub2_01_00849_def,
   SH2_NI1_LLP_RESET_EN         => \%shub2_01_00850_def,
   SH2_NI1_LLP_CHAN_MODE        => \%shub2_01_00851_def,
   SH2_NI1_LLP_CONFIG           => \%shub2_01_00852_def,
   SH2_NI1_LLP_TEST_CTL         => \%shub2_01_00853_def,
   SH2_NI1_LLP_CAPT_WD1         => \%shub2_01_00854_def,
   SH2_NI1_LLP_CAPT_WD2         => \%shub2_01_00855_def,
   SH2_NI1_LLP_CAPT_SBCB        => \%shub2_01_00856_def,
   SH2_NI1_LLP_ERR              => \%shub2_01_00857_def,
   SH2_NI1_LLP_ERR1             => \%shub2_01_00858_def,
   SH2_NI1_LLP_ERR2             => \%shub2_01_00859_def,
   SH2_NI1_LLP_PKT              => \%shub2_01_00860_def,
   SH2_XNNI0_LLP_DEBIT_FLOW     => \%shub2_01_00861_def,
   SH2_XNNI0_LINK_0_FLOW        => \%shub2_01_00862_def,
   SH2_XNNI0_LINK_1_FLOW        => \%shub2_01_00863_def,
   SH2_XNNI0_LINK_2_FLOW        => \%shub2_01_00864_def,
   SH2_XNNI0_LINK_3_FLOW        => \%shub2_01_00865_def,
   SH2_XNNI1_LLP_DEBIT_FLOW     => \%shub2_01_00866_def,
   SH2_XNNI1_LINK_0_FLOW        => \%shub2_01_00867_def,
   SH2_XNNI1_LINK_1_FLOW        => \%shub2_01_00868_def,
   SH2_XNNI1_LINK_2_FLOW        => \%shub2_01_00869_def,
   SH2_XNNI1_LINK_3_FLOW        => \%shub2_01_00870_def,
   SH2_IILB_LOCAL_TABLE         => \%shub2_01_00871_def,
   SH2_IILB_GLOBAL_TABLE        => \%shub2_01_00872_def,
   SH2_IILB_OVER_RIDE_TABLE     => \%shub2_01_00873_def,
   SH2_PI_LOCAL_TABLE           => \%shub2_01_00874_def,
   SH2_PI_GLOBAL_TABLE          => \%shub2_01_00875_def,
   SH2_PI_OVER_RIDE_TABLE       => \%shub2_01_00876_def,
   SH2_PI_RSP_PLANE_HINT        => \%shub2_01_00877_def,
   SH2_NI0_LOCAL_TABLE          => \%shub2_01_00878_def,
   SH2_NI0_GLOBAL_TABLE         => \%shub2_01_00879_def,
   SH2_NI0_OVER_RIDE_TABLE      => \%shub2_01_00880_def,
   SH2_NI1_LOCAL_TABLE          => \%shub2_01_00881_def,
   SH2_NI1_GLOBAL_TABLE         => \%shub2_01_00882_def,
   SH2_NI1_OVER_RIDE_TABLE      => \%shub2_01_00883_def,
   SH2_MD_LOCAL_TABLE           => \%shub2_01_00884_def,
   SH2_MD_GLOBAL_TABLE          => \%shub2_01_00885_def,
   SH2_MD_OVER_RIDE_TABLE       => \%shub2_01_00886_def,
   SH2_MD_RSP_PLANE_HINT        => \%shub2_01_00887_def,
   SH2_XNPI_SIC_FLOW            => \%shub2_01_00888_def,
   SH2_XNPI_TO_NI0_PORT_FLOW    => \%shub2_01_00889_def,
   SH2_XNPI_TO_NI0_PORT_FLOW13  => \%shub2_01_00890_def,
   SH2_XNPI_TO_NI1_PORT_FLOW    => \%shub2_01_00891_def,
   SH2_XNPI_TO_NI1_PORT_FLOW13  => \%shub2_01_00892_def,
   SH2_XNPI_TO_IILB_PORT_FLOW   => \%shub2_01_00893_def,
   SH2_XNPI_ARB_CONFIG          => \%shub2_01_00894_def,
   SH2_XNPI_LOCAL_AGE0          => \%shub2_01_00895_def,
   SH2_XNPI_LOCAL_AGE1          => \%shub2_01_00896_def,
   SH2_XNPI_STEERING_FIFO       => \%shub2_01_00897_def,
   SH2_XNPI_CREDIT_MGR_VC0      => \%shub2_01_00898_def,
   SH2_XNPI_CREDIT_MGR_VC2      => \%shub2_01_00899_def,
   SH2_XNMD_SIC_FLOW            => \%shub2_01_00900_def,
   SH2_XNMD_TO_NI0_PORT_FLOW    => \%shub2_01_00901_def,
   SH2_XNMD_TO_NI0_PORT_FLOW13  => \%shub2_01_00902_def,
   SH2_XNMD_TO_NI1_PORT_FLOW    => \%shub2_01_00903_def,
   SH2_XNMD_TO_NI1_PORT_FLOW13  => \%shub2_01_00904_def,
   SH2_XNMD_TO_IILB_PORT_FLOW   => \%shub2_01_00905_def,
   SH2_XNMD_ARB_CONFIG          => \%shub2_01_00906_def,
   SH2_XNMD_LOCAL_AGE0          => \%shub2_01_00907_def,
   SH2_XNMD_LOCAL_AGE1          => \%shub2_01_00908_def,
   SH2_XNMD_STEERING_FIFO       => \%shub2_01_00909_def,
   SH2_XNMD_CREDIT_MGR_VC0      => \%shub2_01_00910_def,
   SH2_XNMD_CREDIT_MGR_VC2      => \%shub2_01_00911_def,
   SH2_XNII_INTRA_FLOW          => \%shub2_01_00912_def,
   SH2_XNLB_INTRA_FLOW          => \%shub2_01_00913_def,
   SH2_XNIILB_TO_NI0_INTRA_FLOW_DEBIT => \%shub2_01_00914_def,
   SH2_XNIILB_TO_NI0_INTRA_FLOW_DEBIT13 => \%shub2_01_00915_def,
   SH2_XNIILB_TO_NI1_INTRA_FLOW_DEBIT => \%shub2_01_00916_def,
   SH2_XNIILB_TO_NI1_INTRA_FLOW_DEBIT13 => \%shub2_01_00917_def,
   SH2_XNIILB_TO_IILB_INTRA_FLOW_DEBIT => \%shub2_01_00918_def,
   SH2_XNIILB_FR_NI0_INTRA_FLOW_CREDIT => \%shub2_01_00919_def,
   SH2_XNIILB_FR_NI1_INTRA_FLOW_CREDIT => \%shub2_01_00920_def,
   SH2_XNIILB_FR_IILB_INTRA_FLOW_CREDIT => \%shub2_01_00921_def,
   SH2_XNIILB_II_FIFO_CREDIT_CNT => \%shub2_01_00922_def,
   SH2_XNIILB_LB_FIFO_CREDIT_CNT => \%shub2_01_00923_def,
   SH2_XNIILB_ARB_CONFIG_SI     => \%shub2_01_00924_def,
   SH2_XNIILB_ARB_CONFIG_SO     => \%shub2_01_00925_def,
   SH2_XNIILB_AGE_WRAP0         => \%shub2_01_00926_def,
   SH2_XNIILB_AGE_WRAP1         => \%shub2_01_00927_def,
   SH2_XNIILB_AGE_WRAP2         => \%shub2_01_00928_def,
   SH2_XNIILB_TO_PI_INTRA_FLOW_SIC_DEBIT_VC0 => \%shub2_01_00929_def,
   SH2_XNIILB_TO_PI_INTRA_FLOW_SIC_DEBIT_VC2 => \%shub2_01_00930_def,
   SH2_XNIILB_TO_MD_INTRA_FLOW_SIC_DEBIT_VC0 => \%shub2_01_00931_def,
   SH2_XNIILB_TO_MD_INTRA_FLOW_SIC_DEBIT_VC2 => \%shub2_01_00932_def,
   SH2_XNIILB_FR_MD_INTRA_FLOW_CREDIT => \%shub2_01_00933_def,
   SH2_XNIILB_FR_PI_INTRA_FLOW_CREDIT => \%shub2_01_00934_def,
   SH2_XNNI0_TO_IILB_INTRA_FLOW_DEBIT => \%shub2_01_00935_def,
   SH2_XNNI0_TO_PI_INTRA_FLOW_SIC_DEBIT_VC0 => \%shub2_01_00936_def,
   SH2_XNNI0_TO_PI_INTRA_FLOW_SIC_DEBIT_VC2 => \%shub2_01_00937_def,
   SH2_XNNI0_TO_MD_INTRA_FLOW_SIC_DEBIT_VC0 => \%shub2_01_00938_def,
   SH2_XNNI0_TO_MD_INTRA_FLOW_SIC_DEBIT_VC2 => \%shub2_01_00939_def,
   SH2_XNNI0_0_INTRANI_FLOW     => \%shub2_01_00940_def,
   SH2_XNNI0_1_INTRANI_FLOW     => \%shub2_01_00941_def,
   SH2_XNNI0_2_INTRANI_FLOW     => \%shub2_01_00942_def,
   SH2_XNNI0_3_INTRANI_FLOW     => \%shub2_01_00943_def,
   SH2_XNNI0_VCSWITCH_FLOW      => \%shub2_01_00944_def,
   SH2_XNNI0_TIMER_REG          => \%shub2_01_00945_def,
   SH2_XNNI0_IILB_TAILTO        => \%shub2_01_00946_def,
   SH2_XNNI0_NI_TAILTO          => \%shub2_01_00947_def,
   SH2_XNNI0_NI_TAILTO_SUPPORT  => \%shub2_01_00948_def,
   SH2_XNNI0_PI_TAILTO          => \%shub2_01_00949_def,
   SH2_XNNI0_MD_TAILTO          => \%shub2_01_00950_def,
   SH2_XNNI0_DEADLCK_FLOW       => \%shub2_01_00951_def,
   SH2_XNNI0_DEADLCK_FLOW_SUPPORT => \%shub2_01_00952_def,
   SH2_XNNI0_INJECT_AGE         => \%shub2_01_00953_def,
   SH2_XNNI0_NETWORK_AGE        => \%shub2_01_00954_def,
   SH2_XNNI0_ARB_CONFIG         => \%shub2_01_00955_def,
   SH2_XNNI0_LOCAL_AGE0         => \%shub2_01_00956_def,
   SH2_XNNI0_LOCAL_AGE1         => \%shub2_01_00957_def,
   SH2_XNNI0_QUEUE_CNTR         => \%shub2_01_00958_def,
   SH2_XNNI1_TO_IILB_INTRA_FLOW_DEBIT => \%shub2_01_00959_def,
   SH2_XNNI1_TO_PI_INTRA_FLOW_SIC_DEBIT_VC0 => \%shub2_01_00960_def,
   SH2_XNNI1_TO_PI_INTRA_FLOW_SIC_DEBIT_VC2 => \%shub2_01_00961_def,
   SH2_XNNI1_TO_MD_INTRA_FLOW_SIC_DEBIT_VC0 => \%shub2_01_00962_def,
   SH2_XNNI1_TO_MD_INTRA_FLOW_SIC_DEBIT_VC2 => \%shub2_01_00963_def,
   SH2_XNNI1_0_INTRANI_FLOW     => \%shub2_01_00964_def,
   SH2_XNNI1_1_INTRANI_FLOW     => \%shub2_01_00965_def,
   SH2_XNNI1_2_INTRANI_FLOW     => \%shub2_01_00966_def,
   SH2_XNNI1_3_INTRANI_FLOW     => \%shub2_01_00967_def,
   SH2_XNNI1_VCSWITCH_FLOW      => \%shub2_01_00968_def,
   SH2_XNNI1_TIMER_REG          => \%shub2_01_00969_def,
   SH2_XNNI1_IILB_TAILTO        => \%shub2_01_00970_def,
   SH2_XNNI1_NI_TAILTO          => \%shub2_01_00971_def,
   SH2_XNNI1_NI_TAILTO_SUPPORT  => \%shub2_01_00972_def,
   SH2_XNNI1_PI_TAILTO          => \%shub2_01_00973_def,
   SH2_XNNI1_MD_TAILTO          => \%shub2_01_00974_def,
   SH2_XNNI1_DEADLCK_FLOW       => \%shub2_01_00975_def,
   SH2_XNNI1_DEADLCK_FLOW_SUPPORT => \%shub2_01_00976_def,
   SH2_XNNI1_INJECT_AGE         => \%shub2_01_00977_def,
   SH2_XNNI1_NETWORK_AGE        => \%shub2_01_00978_def,
   SH2_XNNI1_ARB_CONFIG         => \%shub2_01_00979_def,
   SH2_XNNI1_LOCAL_AGE0         => \%shub2_01_00980_def,
   SH2_XNNI1_LOCAL_AGE1         => \%shub2_01_00981_def,
   SH2_XNNI1_QUEUE_CNTR         => \%shub2_01_00982_def,
   SH2_XN_DEBUG_SEL             => \%shub2_01_00983_def,
   SH2_XN_DEBUG_TRIG_SEL        => \%shub2_01_00984_def,
   SH2_XN_TRIGGER_COMPARE       => \%shub2_01_00985_def,
   SH2_XN_TRIGGER_DATA          => \%shub2_01_00986_def,
   SH2_XN_IILB_DEBUG_SEL        => \%shub2_01_00987_def,
   SH2_XN_IILB_LB_CMP_EXP_DATA0 => \%shub2_01_00988_def,
   SH2_XN_IILB_LB_CMP_EXP_DATA1 => \%shub2_01_00989_def,
   SH2_XN_IILB_LB_CMP_ENABLE0   => \%shub2_01_00990_def,
   SH2_XN_IILB_LB_CMP_ENABLE1   => \%shub2_01_00991_def,
   SH2_XN_IILB_II_CMP_EXP_DATA0 => \%shub2_01_00992_def,
   SH2_XN_IILB_II_CMP_EXP_DATA1 => \%shub2_01_00993_def,
   SH2_XN_IILB_II_CMP_ENABLE0   => \%shub2_01_00994_def,
   SH2_XN_IILB_II_CMP_ENABLE1   => \%shub2_01_00995_def,
   SH2_XN_IILB_MD_HDR_CMP_EXP_DATA0 => \%shub2_01_00996_def,
   SH2_XN_IILB_MD_HDR_CMP_EXP_DATA1 => \%shub2_01_00997_def,
   SH2_XN_IILB_MD_HDR_CMP_ENABLE0 => \%shub2_01_00998_def,
   SH2_XN_IILB_MD_HDR_CMP_ENABLE1 => \%shub2_01_00999_def,
   SH2_XN_IILB_PI_CMP_EXP_DATA0 => \%shub2_01_01000_def,
   SH2_XN_IILB_PI_CMP_EXP_DATA1 => \%shub2_01_01001_def,
   SH2_XN_IILB_PI_CMP_ENABLE0   => \%shub2_01_01002_def,
   SH2_XN_IILB_PI_CMP_ENABLE1   => \%shub2_01_01003_def,
   SH2_XN_IILB_NI0_CMP_EXP_DATA0 => \%shub2_01_01004_def,
   SH2_XN_IILB_NI0_CMP_EXP_DATA1 => \%shub2_01_01005_def,
   SH2_XN_IILB_NI0_CMP_ENABLE0  => \%shub2_01_01006_def,
   SH2_XN_IILB_NI0_CMP_ENABLE1  => \%shub2_01_01007_def,
   SH2_XN_IILB_NI1_CMP_EXP_DATA0 => \%shub2_01_01008_def,
   SH2_XN_IILB_NI1_CMP_EXP_DATA1 => \%shub2_01_01009_def,
   SH2_XN_IILB_NI1_CMP_ENABLE0  => \%shub2_01_01010_def,
   SH2_XN_IILB_NI1_CMP_ENABLE1  => \%shub2_01_01011_def,
   SH2_XN_NI0_DEBUG_SEL         => \%shub2_01_01012_def,
   SH2_XN_NI0_IILB_CMP_EXP_DATA0 => \%shub2_01_01013_def,
   SH2_XN_NI0_IILB_CMP_EXP_DATA1 => \%shub2_01_01014_def,
   SH2_XN_NI0_IILB_CMP_ENABLE0  => \%shub2_01_01015_def,
   SH2_XN_NI0_IILB_CMP_ENABLE1  => \%shub2_01_01016_def,
   SH2_XN_NI0_PI_CMP_EXP_DATA0  => \%shub2_01_01017_def,
   SH2_XN_NI0_PI_CMP_EXP_DATA1  => \%shub2_01_01018_def,
   SH2_XN_NI0_PI_CMP_ENABLE0    => \%shub2_01_01019_def,
   SH2_XN_NI0_PI_CMP_ENABLE1    => \%shub2_01_01020_def,
   SH2_XN_NI0_NI_CMP_EXP_DATA0  => \%shub2_01_01021_def,
   SH2_XN_NI0_NI_CMP_EXP_DATA1  => \%shub2_01_01022_def,
   SH2_XN_NI0_NI_CMP_ENABLE0    => \%shub2_01_01023_def,
   SH2_XN_NI0_NI_CMP_ENABLE1    => \%shub2_01_01024_def,
   SH2_XN_NI0_LLP_CMP_EXP_DATA0 => \%shub2_01_01025_def,
   SH2_XN_NI0_LLP_CMP_EXP_DATA1 => \%shub2_01_01026_def,
   SH2_XN_NI0_LLP_CMP_ENABLE0   => \%shub2_01_01027_def,
   SH2_XN_NI0_LLP_CMP_ENABLE1   => \%shub2_01_01028_def,
   SH2_XN_NI0_MD_CMP_EXP_HDR0   => \%shub2_01_01029_def,
   SH2_XN_NI0_MD_CMP_EXP_HDR1   => \%shub2_01_01030_def,
   SH2_XN_NI0_MD_CMP_HDR_ENABLE0 => \%shub2_01_01031_def,
   SH2_XN_NI0_MD_CMP_HDR_ENABLE1 => \%shub2_01_01032_def,
   SH2_XN_NI1_DEBUG_SEL         => \%shub2_01_01033_def,
   SH2_XN_NI1_IILB_CMP_EXP_DATA0 => \%shub2_01_01034_def,
   SH2_XN_NI1_IILB_CMP_EXP_DATA1 => \%shub2_01_01035_def,
   SH2_XN_NI1_IILB_CMP_ENABLE0  => \%shub2_01_01036_def,
   SH2_XN_NI1_IILB_CMP_ENABLE1  => \%shub2_01_01037_def,
   SH2_XN_NI1_PI_CMP_EXP_DATA0  => \%shub2_01_01038_def,
   SH2_XN_NI1_PI_CMP_EXP_DATA1  => \%shub2_01_01039_def,
   SH2_XN_NI1_PI_CMP_ENABLE0    => \%shub2_01_01040_def,
   SH2_XN_NI1_PI_CMP_ENABLE1    => \%shub2_01_01041_def,
   SH2_XN_NI1_NI_CMP_EXP_DATA0  => \%shub2_01_01042_def,
   SH2_XN_NI1_NI_CMP_EXP_DATA1  => \%shub2_01_01043_def,
   SH2_XN_NI1_NI_CMP_ENABLE0    => \%shub2_01_01044_def,
   SH2_XN_NI1_NI_CMP_ENABLE1    => \%shub2_01_01045_def,
   SH2_XN_NI1_LLP_CMP_EXP_DATA0 => \%shub2_01_01046_def,
   SH2_XN_NI1_LLP_CMP_EXP_DATA1 => \%shub2_01_01047_def,
   SH2_XN_NI1_LLP_CMP_ENABLE0   => \%shub2_01_01048_def,
   SH2_XN_NI1_LLP_CMP_ENABLE1   => \%shub2_01_01049_def,
   SH2_XN_NI1_MD_CMP_EXP_HDR0   => \%shub2_01_01050_def,
   SH2_XN_NI1_MD_CMP_EXP_HDR1   => \%shub2_01_01051_def,
   SH2_XN_NI1_MD_CMP_HDR_ENABLE0 => \%shub2_01_01052_def,
   SH2_XN_NI1_MD_CMP_HDR_ENABLE1 => \%shub2_01_01053_def,
   SH2_XN_PI_DEBUG_SEL          => \%shub2_01_01054_def,
   SH2_XN_PI_IILB_CMP_EXP_DATA0 => \%shub2_01_01055_def,
   SH2_XN_PI_IILB_CMP_EXP_DATA1 => \%shub2_01_01056_def,
   SH2_XN_PI_IILB_CMP_ENABLE0   => \%shub2_01_01057_def,
   SH2_XN_PI_IILB_CMP_ENABLE1   => \%shub2_01_01058_def,
   SH2_XN_PI_NI0_CMP_EXP_DATA0  => \%shub2_01_01059_def,
   SH2_XN_PI_NI0_CMP_EXP_DATA1  => \%shub2_01_01060_def,
   SH2_XN_PI_NI0_CMP_ENABLE0    => \%shub2_01_01061_def,
   SH2_XN_PI_NI0_CMP_ENABLE1    => \%shub2_01_01062_def,
   SH2_XN_PI_NI1_CMP_EXP_DATA0  => \%shub2_01_01063_def,
   SH2_XN_PI_NI1_CMP_EXP_DATA1  => \%shub2_01_01064_def,
   SH2_XN_PI_NI1_CMP_ENABLE0    => \%shub2_01_01065_def,
   SH2_XN_PI_NI1_CMP_ENABLE1    => \%shub2_01_01066_def,
   SH2_XN_PI_SIC_CMP_DATA0      => \%shub2_01_01067_def,
   SH2_XN_PI_SIC_CMP_DATA1      => \%shub2_01_01068_def,
   SH2_XN_PI_SIC_CMP_DATA_ENABLE0 => \%shub2_01_01069_def,
   SH2_XN_PI_SIC_CMP_DATA_ENABLE1 => \%shub2_01_01070_def,
   SH2_XN_MD_DEBUG_SEL          => \%shub2_01_01071_def,
   SH2_XN_MD_IILB_CMP_EXP_DATA0 => \%shub2_01_01072_def,
   SH2_XN_MD_IILB_CMP_EXP_DATA1 => \%shub2_01_01073_def,
   SH2_XN_MD_IILB_CMP_ENABLE0   => \%shub2_01_01074_def,
   SH2_XN_MD_IILB_CMP_ENABLE1   => \%shub2_01_01075_def,
   SH2_XN_MD_NI0_CMP_EXP_DATA0  => \%shub2_01_01076_def,
   SH2_XN_MD_NI0_CMP_EXP_DATA1  => \%shub2_01_01077_def,
   SH2_XN_MD_NI0_CMP_ENABLE0    => \%shub2_01_01078_def,
   SH2_XN_MD_NI0_CMP_ENABLE1    => \%shub2_01_01079_def,
   SH2_XN_MD_NI1_CMP_EXP_DATA0  => \%shub2_01_01080_def,
   SH2_XN_MD_NI1_CMP_EXP_DATA1  => \%shub2_01_01081_def,
   SH2_XN_MD_NI1_CMP_ENABLE0    => \%shub2_01_01082_def,
   SH2_XN_MD_NI1_CMP_ENABLE1    => \%shub2_01_01083_def,
   SH2_XN_MD_SIC_CMP_EXP_HDR0   => \%shub2_01_01084_def,
   SH2_XN_MD_SIC_CMP_EXP_HDR1   => \%shub2_01_01085_def,
   SH2_XN_MD_SIC_CMP_HDR_ENABLE0 => \%shub2_01_01086_def,
   SH2_XN_MD_SIC_CMP_HDR_ENABLE1 => \%shub2_01_01087_def,
   SH2_XNPI_ECC_INJ_REG         => \%shub2_01_01088_def,
   SH2_XNPI_ECC0_INJ_MASK_REG   => \%shub2_01_01089_def,
   SH2_XNPI_ECC1_INJ_MASK_REG   => \%shub2_01_01090_def,
   SH2_XNPI_ECC2_INJ_MASK_REG   => \%shub2_01_01091_def,
   SH2_XNPI_ECC3_INJ_MASK_REG   => \%shub2_01_01092_def,
   SH2_XNMD_ECC_INJ_REG         => \%shub2_01_01093_def,
   SH2_XNMD_ECC0_INJ_MASK_REG   => \%shub2_01_01094_def,
   SH2_XNMD_ECC1_INJ_MASK_REG   => \%shub2_01_01095_def,
   SH2_XNMD_ECC2_INJ_MASK_REG   => \%shub2_01_01096_def,
   SH2_XNMD_ECC3_INJ_MASK_REG   => \%shub2_01_01097_def,
   SH2_XNMD_ECC_ERR_REPORT      => \%shub2_01_01098_def,
   SH2_NI0_ERROR_SUMMARY_1      => \%shub2_01_01099_def,
   SH2_NI0_ERROR_SUMMARY_1_ALIAS => \%shub2_01_01100_def,
   SH2_NI0_ERROR_SUMMARY_2      => \%shub2_01_01101_def,
   SH2_NI0_ERROR_SUMMARY_2_ALIAS => \%shub2_01_01102_def,
   SH2_NI0_ERROR_OVERFLOW_1     => \%shub2_01_01103_def,
   SH2_NI0_ERROR_OVERFLOW_1_ALIAS => \%shub2_01_01104_def,
   SH2_NI0_ERROR_OVERFLOW_2     => \%shub2_01_01105_def,
   SH2_NI0_ERROR_OVERFLOW_2_ALIAS => \%shub2_01_01106_def,
   SH2_NI0_ERROR_MASK_1         => \%shub2_01_01107_def,
   SH2_NI0_ERROR_MASK_2         => \%shub2_01_01108_def,
   SH2_NI0_FIRST_ERROR_1        => \%shub2_01_01109_def,
   SH2_NI0_FIRST_ERROR_2        => \%shub2_01_01110_def,
   SH2_NI0_ERROR_DETAIL_1       => \%shub2_01_01111_def,
   SH2_NI0_ERROR_DETAIL_2       => \%shub2_01_01112_def,
   SH2_NI1_ERROR_SUMMARY_1      => \%shub2_01_01113_def,
   SH2_NI1_ERROR_SUMMARY_1_ALIAS => \%shub2_01_01114_def,
   SH2_NI1_ERROR_SUMMARY_2      => \%shub2_01_01115_def,
   SH2_NI1_ERROR_SUMMARY_2_ALIAS => \%shub2_01_01116_def,
   SH2_NI1_ERROR_OVERFLOW_1     => \%shub2_01_01117_def,
   SH2_NI1_ERROR_OVERFLOW_1_ALIAS => \%shub2_01_01118_def,
   SH2_NI1_ERROR_OVERFLOW_2     => \%shub2_01_01119_def,
   SH2_NI1_ERROR_OVERFLOW_2_ALIAS => \%shub2_01_01120_def,
   SH2_NI1_ERROR_MASK_1         => \%shub2_01_01121_def,
   SH2_NI1_ERROR_MASK_2         => \%shub2_01_01122_def,
   SH2_NI1_FIRST_ERROR_1        => \%shub2_01_01123_def,
   SH2_NI1_FIRST_ERROR_2        => \%shub2_01_01124_def,
   SH2_NI1_ERROR_DETAIL_1       => \%shub2_01_01125_def,
   SH2_NI1_ERROR_DETAIL_2       => \%shub2_01_01126_def,
   SH2_XN_CORRECTED_DETAIL_1    => \%shub2_01_01127_def,
   SH2_XN_CORRECTED_DETAIL_2    => \%shub2_01_01128_def,
   SH2_XN_CORRECTED_DETAIL_3    => \%shub2_01_01129_def,
   SH2_XN_CORRECTED_DETAIL_4    => \%shub2_01_01130_def,
   SH2_XN_UNCORRECTED_DETAIL_1  => \%shub2_01_01131_def,
   SH2_XN_UNCORRECTED_DETAIL_2  => \%shub2_01_01132_def,
   SH2_XN_UNCORRECTED_DETAIL_3  => \%shub2_01_01133_def,
   SH2_XN_UNCORRECTED_DETAIL_4  => \%shub2_01_01134_def,
   SH2_XNMD_ERROR_DETAIL_1      => \%shub2_01_01135_def,
   SH2_XNPI_ERROR_DETAIL_1      => \%shub2_01_01136_def,
   SH2_XNIILB_ERROR_DETAIL_1    => \%shub2_01_01137_def,
   SH2_XNIILB_ERROR_DETAIL_2    => \%shub2_01_01138_def,
   SH2_XNIILB_ERROR_DETAIL_3    => \%shub2_01_01139_def,
   SH2_NI0_ERROR_DETAIL_3       => \%shub2_01_01140_def,
   SH2_NI1_ERROR_DETAIL_3       => \%shub2_01_01141_def,
   SH2_XN_ERROR_SUMMARY         => \%shub2_01_01142_def,
   SH2_XN_ERROR_SUMMARY_ALIAS   => \%shub2_01_01143_def,
   SH2_XN_ERROR_OVERFLOW        => \%shub2_01_01144_def,
   SH2_XN_ERROR_OVERFLOW_ALIAS  => \%shub2_01_01145_def,
   SH2_XN_ERROR_MASK            => \%shub2_01_01146_def,
   SH2_XN_FIRST_ERROR           => \%shub2_01_01147_def,
   SH2_XNIILB_ERROR_SUMMARY     => \%shub2_01_01148_def,
   SH2_XNIILB_ERROR_SUMMARY_ALIAS => \%shub2_01_01149_def,
   SH2_XNIILB_ERROR_OVERFLOW    => \%shub2_01_01150_def,
   SH2_XNIILB_ERROR_OVERFLOW_ALIAS => \%shub2_01_01151_def,
   SH2_XNIILB_ERROR_MASK        => \%shub2_01_01152_def,
   SH2_XNIILB_FIRST_ERROR       => \%shub2_01_01153_def,
   SH2_XNIILB_ERROR_SUMMARY_1   => \%shub2_01_01154_def,
   SH2_XNIILB_ERROR_SUMMARY_ALIAS_1 => \%shub2_01_01155_def,
   SH2_XNIILB_ERROR_OVERFLOW_1  => \%shub2_01_01156_def,
   SH2_XNIILB_ERROR_OVERFLOW_ALIAS_1 => \%shub2_01_01157_def,
   SH2_XNIILB_ERROR_MASK_1      => \%shub2_01_01158_def,
   SH2_XNIILB_FIRST_ERROR_1     => \%shub2_01_01159_def,
   SH2_XNPI_ERROR_SUMMARY       => \%shub2_01_01160_def,
   SH2_XNPI_ERROR_SUMMARY_ALIAS => \%shub2_01_01161_def,
   SH2_XNPI_ERROR_OVERFLOW      => \%shub2_01_01162_def,
   SH2_XNPI_ERROR_OVERFLOW_ALIAS => \%shub2_01_01163_def,
   SH2_XNPI_ERROR_MASK          => \%shub2_01_01164_def,
   SH2_XNPI_FIRST_ERROR         => \%shub2_01_01165_def,
   SH2_XNMD_ERROR_SUMMARY       => \%shub2_01_01166_def,
   SH2_XNMD_ERROR_SUMMARY_ALIAS => \%shub2_01_01167_def,
   SH2_XNMD_ERROR_OVERFLOW      => \%shub2_01_01168_def,
   SH2_XNMD_ERROR_OVERFLOW_ALIAS => \%shub2_01_01169_def,
   SH2_XNMD_ERROR_MASK          => \%shub2_01_01170_def,
   SH2_XNMD_FIRST_ERROR         => \%shub2_01_01171_def,
   SH2_XNMD_ERROR_SUMMARY_1     => \%shub2_01_01172_def,
   SH2_XNMD_ERROR_SUMMARY_ALIAS_1 => \%shub2_01_01173_def,
   SH2_XNMD_ERROR_OVERFLOW_1    => \%shub2_01_01174_def,
   SH2_XNMD_ERROR_OVERFLOW_ALIAS_1 => \%shub2_01_01175_def,
   SH2_XNMD_ERROR_MASK_1        => \%shub2_01_01176_def,
   SH2_XNMD_FIRST_ERROR_1       => \%shub2_01_01177_def,
   SH2_BT_ERROR_SUMMARY         => \%shub2_01_01178_def,
   SH2_BT_ERROR_SUMMARY_ALIAS   => \%shub2_01_01179_def,
   SH2_BT_ERROR_OVERFLOW        => \%shub2_01_01180_def,
   SH2_BT_ERROR_OVERFLOW_ALIAS  => \%shub2_01_01181_def,
   SH2_BT_FIRST_ERROR           => \%shub2_01_01182_def,
   SH2_BT_ERROR_MASK            => \%shub2_01_01183_def,
   SH2_BT_DEBUG_TRIG_COMPARE    => \%shub2_01_01184_def,
   SH2_BT_DEBUG_TRIG_SELECT     => \%shub2_01_01185_def,
   SH2_BT_DEBUG_TRIG_ENABLE     => \%shub2_01_01186_def,
   SH2_BT_DEBUG_MUX_SELECT      => \%shub2_01_01187_def,
   SH2_BT_TIMEOUT_PULSE         => \%shub2_01_01188_def,
   SH2_BT_TIMEOUT_PRESCALE      => \%shub2_01_01189_def,
   SH2_BT_REQ_NACK_LIMIT        => \%shub2_01_01190_def,
   SH2_BT_REQ_PRIORITY          => \%shub2_01_01191_def,
   SH2_BT_XN_DATA_COMP_0        => \%shub2_01_01192_def,
   SH2_BT_XN_DATA_COMP_1        => \%shub2_01_01193_def,
   SH2_BT_XN_DATA_ENABLE_0      => \%shub2_01_01194_def,
   SH2_BT_XN_DATA_ENABLE_1      => \%shub2_01_01195_def,
   SH2_BT_NIQ_CREDIT_CFG        => \%shub2_01_01196_def,
   SH2_BT_NIQ_DYN_CREDIT_STAT   => \%shub2_01_01197_def,
   SH2_BT_NIQ_LAST_CREDIT_STAT  => \%shub2_01_01198_def,
   SH2_BT_HQ_VALID_DETAIL       => \%shub2_01_01199_def,
   SH2_BT_HQ_ENTRY_0            => \%shub2_01_01200_def,
   SH2_BT_HQ_EJECT              => \%shub2_01_01201_def,
   SH2_BT_XN_ERROR_DETAIL_1     => \%shub2_01_01202_def,
   SH2_BT_XN_ERROR_DETAIL_2     => \%shub2_01_01203_def,
   SH2_BT_ENG_ERROR_STAT        => \%shub2_01_01204_def,
   SH2_BT_XMIT_CFG              => \%shub2_01_01205_def,
   SH2_BT_XMIT_DYN_CREDIT_STAT  => \%shub2_01_01206_def,
   SH2_BT_XMIT_LAST_CREDIT_STAT => \%shub2_01_01207_def,
   SH2_BT_IQ_STAT               => \%shub2_01_01208_def,
   SH2_BT_CRB_STAT_0            => \%shub2_01_01209_def,
   SH2_BT_CRB_STAT_1            => \%shub2_01_01210_def,
   SH2_BT_CRB_STAT_2            => \%shub2_01_01211_def,
   SH2_BT_CRB_STAT_3            => \%shub2_01_01212_def,
   SH2_BT_CRB_STAT_4            => \%shub2_01_01213_def,
   SH2_BT_CRB_STAT_5            => \%shub2_01_01214_def,
   SH2_BT_CRB_STAT_6            => \%shub2_01_01215_def,
   SH2_BT_CRB_STAT_7            => \%shub2_01_01216_def,
   SH2_BT_CRB_STAT_8            => \%shub2_01_01217_def,
   SH2_BT_CRB_STAT_9            => \%shub2_01_01218_def,
   SH2_BT_CRB_STAT_10           => \%shub2_01_01219_def,
   SH2_BT_CRB_STAT_11           => \%shub2_01_01220_def,
   SH2_BT_CRB_STAT_12           => \%shub2_01_01221_def,
   SH2_BT_CRB_STAT_13           => \%shub2_01_01222_def,
   SH2_BT_CRB_STAT_14           => \%shub2_01_01223_def,
   SH2_BT_CRB_STAT_15           => \%shub2_01_01224_def,
   SH2_BT_CRB_SRC_ADDR_0        => \%shub2_01_01225_def,
   SH2_BT_CRB_SRC_ADDR_1        => \%shub2_01_01226_def,
   SH2_BT_CRB_SRC_ADDR_2        => \%shub2_01_01227_def,
   SH2_BT_CRB_SRC_ADDR_3        => \%shub2_01_01228_def,
   SH2_BT_CRB_SRC_ADDR_4        => \%shub2_01_01229_def,
   SH2_BT_CRB_SRC_ADDR_5        => \%shub2_01_01230_def,
   SH2_BT_CRB_SRC_ADDR_6        => \%shub2_01_01231_def,
   SH2_BT_CRB_SRC_ADDR_7        => \%shub2_01_01232_def,
   SH2_BT_CRB_SRC_ADDR_8        => \%shub2_01_01233_def,
   SH2_BT_CRB_SRC_ADDR_9        => \%shub2_01_01234_def,
   SH2_BT_CRB_SRC_ADDR_10       => \%shub2_01_01235_def,
   SH2_BT_CRB_SRC_ADDR_11       => \%shub2_01_01236_def,
   SH2_BT_CRB_SRC_ADDR_12       => \%shub2_01_01237_def,
   SH2_BT_CRB_SRC_ADDR_13       => \%shub2_01_01238_def,
   SH2_BT_CRB_SRC_ADDR_14       => \%shub2_01_01239_def,
   SH2_BT_CRB_SRC_ADDR_15       => \%shub2_01_01240_def,
   SH2_BT_CRB_DEST_ADDR_0       => \%shub2_01_01241_def,
   SH2_BT_CRB_DEST_ADDR_1       => \%shub2_01_01242_def,
   SH2_BT_CRB_DEST_ADDR_2       => \%shub2_01_01243_def,
   SH2_BT_CRB_DEST_ADDR_3       => \%shub2_01_01244_def,
   SH2_BT_CRB_DEST_ADDR_4       => \%shub2_01_01245_def,
   SH2_BT_CRB_DEST_ADDR_5       => \%shub2_01_01246_def,
   SH2_BT_CRB_DEST_ADDR_6       => \%shub2_01_01247_def,
   SH2_BT_CRB_DEST_ADDR_7       => \%shub2_01_01248_def,
   SH2_BT_CRB_DEST_ADDR_8       => \%shub2_01_01249_def,
   SH2_BT_CRB_DEST_ADDR_9       => \%shub2_01_01250_def,
   SH2_BT_CRB_DEST_ADDR_10      => \%shub2_01_01251_def,
   SH2_BT_CRB_DEST_ADDR_11      => \%shub2_01_01252_def,
   SH2_BT_CRB_DEST_ADDR_12      => \%shub2_01_01253_def,
   SH2_BT_CRB_DEST_ADDR_13      => \%shub2_01_01254_def,
   SH2_BT_CRB_DEST_ADDR_14      => \%shub2_01_01255_def,
   SH2_BT_CRB_DEST_ADDR_15      => \%shub2_01_01256_def,
   SH2_BT_ENG_CSR_0             => \%shub2_01_01257_def,
   SH2_BT_ENG_SRC_ADDR_0        => \%shub2_01_01258_def,
   SH2_BT_ENG_DEST_ADDR_0       => \%shub2_01_01259_def,
   SH2_BT_ENG_NOTIF_ADDR_0      => \%shub2_01_01260_def,
   SH2_BT_ENG_CSR_1             => \%shub2_01_01261_def,
   SH2_BT_ENG_SRC_ADDR_1        => \%shub2_01_01262_def,
   SH2_BT_ENG_DEST_ADDR_1       => \%shub2_01_01263_def,
   SH2_BT_ENG_NOTIF_ADDR_1      => \%shub2_01_01264_def,
   SH2_BT_ENG_CSR_2             => \%shub2_01_01265_def,
   SH2_BT_ENG_SRC_ADDR_2        => \%shub2_01_01266_def,
   SH2_BT_ENG_DEST_ADDR_2       => \%shub2_01_01267_def,
   SH2_BT_ENG_NOTIF_ADDR_2      => \%shub2_01_01268_def,
   SH2_BT_ENG_CSR_3             => \%shub2_01_01269_def,
   SH2_BT_ENG_SRC_ADDR_3        => \%shub2_01_01270_def,
   SH2_BT_ENG_DEST_ADDR_3       => \%shub2_01_01271_def,
   SH2_BT_ENG_NOTIF_ADDR_3      => \%shub2_01_01272_def,
   SH2_PI_RDAT_ACK_Q_CONFIG     => \%shub2_01_01273_def,
   SH2_PI_RDAT_DAT_DFR_Q_CONFIG => \%shub2_01_01274_def,
);

%shub2_01_mmr_by_addr = 
(
   0x0000000010020000 => \%shub2_01_00000_def,
   0x0000000010020100 => \%shub2_01_00001_def,
   0x0000000010030000 => \%shub2_01_00002_def,
   0x0000000010030080 => \%shub2_01_00003_def,
   0x0000000010030100 => \%shub2_01_00004_def,
   0x0000000010030180 => \%shub2_01_00005_def,
   0x0000000010040000 => \%shub2_01_00006_def,
   0x0000000010040080 => \%shub2_01_00007_def,
   0x0000000010040100 => \%shub2_01_00008_def,
   0x0000000010040180 => \%shub2_01_00009_def,
   0x0000000010040280 => \%shub2_01_00010_def,
   0x0000000010040300 => \%shub2_01_00011_def,
   0x0000000010040380 => \%shub2_01_00012_def,
   0x0000000010040400 => \%shub2_01_00013_def,
   0x0000000010050000 => \%shub2_01_00014_def,
   0x0000000010050080 => \%shub2_01_00015_def,
   0x0000000010050100 => \%shub2_01_00016_def,
   0x0000000010050180 => \%shub2_01_00017_def,
   0x0000000010050200 => \%shub2_01_00018_def,
   0x0000000010050280 => \%shub2_01_00019_def,
   0x0000000010050300 => \%shub2_01_00020_def,
   0x0000000010050380 => \%shub2_01_00021_def,
   0x0000000010050400 => \%shub2_01_00022_def,
   0x0000000010050480 => \%shub2_01_00023_def,
   0x0000000010050500 => \%shub2_01_00024_def,
   0x0000000010050580 => \%shub2_01_00025_def,
   0x0000000010050600 => \%shub2_01_00026_def,
   0x0000000010050608 => \%shub2_01_00027_def,
   0x0000000010050680 => \%shub2_01_00028_def,
   0x0000000010050688 => \%shub2_01_00029_def,
   0x0000000010050700 => \%shub2_01_00030_def,
   0x0000000010050780 => \%shub2_01_00031_def,
   0x0000000010050800 => \%shub2_01_00032_def,
   0x0000000010050880 => \%shub2_01_00033_def,
   0x0000000010050900 => \%shub2_01_00034_def,
   0x0000000010050980 => \%shub2_01_00035_def,
   0x0000000010050A00 => \%shub2_01_00036_def,
   0x0000000010050A80 => \%shub2_01_00037_def,
   0x0000000010080000 => \%shub2_01_00038_def,
   0x0000000010090000 => \%shub2_01_00039_def,
   0x00000000100A0000 => \%shub2_01_00040_def,
   0x00000000100B0000 => \%shub2_01_00041_def,
   0x00000000100C0000 => \%shub2_01_00042_def,
   0x00000000100D0000 => \%shub2_01_00043_def,
   0x00000000100E0000 => \%shub2_01_00044_def,
   0x00000000100F0000 => \%shub2_01_00045_def,
   0x0000000010100000 => \%shub2_01_00046_def,
   0x0000000010100080 => \%shub2_01_00047_def,
   0x0000000010100100 => \%shub2_01_00048_def,
   0x0000000010100180 => \%shub2_01_00049_def,
   0x0000000010101000 => \%shub2_01_00050_def,
   0x0000000010110000 => \%shub2_01_00051_def,
   0x0000000010120000 => \%shub2_01_00052_def,
   0x0000000010130000 => \%shub2_01_00053_def,
   0x0000000010140000 => \%shub2_01_00054_def,
   0x0000000010150000 => \%shub2_01_00055_def,
   0x0000000010160000 => \%shub2_01_00056_def,
   0x0000000010170000 => \%shub2_01_00057_def,
   0x0000000010180000 => \%shub2_01_00058_def,
   0x0000000010190000 => \%shub2_01_00059_def,
   0x0000000010190080 => \%shub2_01_00060_def,
   0x00000000101B0000 => \%shub2_01_00061_def,
   0x00000000101B0080 => \%shub2_01_00062_def,
   0x00000000101B0100 => \%shub2_01_00063_def,
   0x00000000101B0180 => \%shub2_01_00064_def,
   0x00000000101B0200 => \%shub2_01_00065_def,
   0x00000000101C0000 => \%shub2_01_00066_def,
   0x0000000010060800 => \%shub2_01_00067_def,
   0x00000000101D0000 => \%shub2_01_00068_def,
   0x00000000101D0008 => \%shub2_01_00069_def,
   0x00000000101D0080 => \%shub2_01_00070_def,
   0x00000000101D0088 => \%shub2_01_00071_def,
   0x00000000101D0100 => \%shub2_01_00072_def,
   0x00000000101D0108 => \%shub2_01_00073_def,
   0x00000000101D0180 => \%shub2_01_00074_def,
   0x00000000101D0188 => \%shub2_01_00075_def,
   0x00000000101D0200 => \%shub2_01_00076_def,
   0x00000000101D0208 => \%shub2_01_00077_def,
   0x00000000101D0280 => \%shub2_01_00078_def,
   0x00000000101D0288 => \%shub2_01_00079_def,
   0x00000000101D0290 => \%shub2_01_00080_def,
   0x00000000101D0300 => \%shub2_01_00081_def,
   0x00000000101D0308 => \%shub2_01_00082_def,
   0x00000000101D0310 => \%shub2_01_00083_def,
   0x00000000101D0380 => \%shub2_01_00084_def,
   0x00000000101D0388 => \%shub2_01_00085_def,
   0x00000000101D0390 => \%shub2_01_00086_def,
   0x00000000101D0400 => \%shub2_01_00087_def,
   0x00000000101D0408 => \%shub2_01_00088_def,
   0x00000000101D0410 => \%shub2_01_00089_def,
   0x00000000101D0480 => \%shub2_01_00090_def,
   0x00000000101D0488 => \%shub2_01_00091_def,
   0x00000000101D0490 => \%shub2_01_00092_def,
   0x00000000101D0500 => \%shub2_01_00093_def,
   0x00000000101D0508 => \%shub2_01_00094_def,
   0x00000000101D0510 => \%shub2_01_00095_def,
   0x00000000101D0580 => \%shub2_01_00096_def,
   0x00000000101D0588 => \%shub2_01_00097_def,
   0x00000000101D0590 => \%shub2_01_00098_def,
   0x00000000101D0600 => \%shub2_01_00099_def,
   0x00000000101D0608 => \%shub2_01_00100_def,
   0x00000000101D0610 => \%shub2_01_00101_def,
   0x00000000101D0680 => \%shub2_01_00102_def,
   0x00000000101D0688 => \%shub2_01_00103_def,
   0x00000000101D0690 => \%shub2_01_00104_def,
   0x00000000101D0700 => \%shub2_01_00105_def,
   0x00000000101D0708 => \%shub2_01_00106_def,
   0x00000000101D0710 => \%shub2_01_00107_def,
   0x00000000101D0780 => \%shub2_01_00108_def,
   0x00000000101D0788 => \%shub2_01_00109_def,
   0x00000000101D0790 => \%shub2_01_00110_def,
   0x00000000101D0800 => \%shub2_01_00111_def,
   0x00000000101D0808 => \%shub2_01_00112_def,
   0x00000000101D0810 => \%shub2_01_00113_def,
   0x00000000101D0880 => \%shub2_01_00114_def,
   0x00000000101D0888 => \%shub2_01_00115_def,
   0x00000000101D0890 => \%shub2_01_00116_def,
   0x00000000101D0900 => \%shub2_01_00117_def,
   0x00000000101D0908 => \%shub2_01_00118_def,
   0x00000000101D0910 => \%shub2_01_00119_def,
   0x00000000101D0980 => \%shub2_01_00120_def,
   0x00000000101D0988 => \%shub2_01_00121_def,
   0x00000000101D0990 => \%shub2_01_00122_def,
   0x00000000101D0A00 => \%shub2_01_00123_def,
   0x00000000101D0A08 => \%shub2_01_00124_def,
   0x00000000101D0A10 => \%shub2_01_00125_def,
   0x00000000101D0A80 => \%shub2_01_00126_def,
   0x00000000101D0A88 => \%shub2_01_00127_def,
   0x00000000101D0A90 => \%shub2_01_00128_def,
   0x00000000101D0B00 => \%shub2_01_00129_def,
   0x00000000101D0B08 => \%shub2_01_00130_def,
   0x00000000101D0B10 => \%shub2_01_00131_def,
   0x00000000101D0B80 => \%shub2_01_00132_def,
   0x00000000101D0B88 => \%shub2_01_00133_def,
   0x00000000101D0B90 => \%shub2_01_00134_def,
   0x00000000101D0C00 => \%shub2_01_00135_def,
   0x00000000101D0C08 => \%shub2_01_00136_def,
   0x00000000101D0C10 => \%shub2_01_00137_def,
   0x0000000010000000 => \%shub2_01_00138_def,
   0x0000000010000080 => \%shub2_01_00139_def,
   0x0000000010000200 => \%shub2_01_00140_def,
   0x0000000010000100 => \%shub2_01_00141_def,
   0x0000000010000180 => \%shub2_01_00142_def,
   0x0000000010000280 => \%shub2_01_00143_def,
   0x0000000010000F00 => \%shub2_01_00144_def,
   0x0000000010000F80 => \%shub2_01_00145_def,
   0x0000000010001100 => \%shub2_01_00146_def,
   0x0000000010001000 => \%shub2_01_00147_def,
   0x0000000010001080 => \%shub2_01_00148_def,
   0x0000000010001180 => \%shub2_01_00149_def,
   0x0000000010000300 => \%shub2_01_00150_def,
   0x0000000010000380 => \%shub2_01_00151_def,
   0x0000000010000400 => \%shub2_01_00152_def,
   0x0000000010000480 => \%shub2_01_00153_def,
   0x0000000010000500 => \%shub2_01_00154_def,
   0x0000000010000580 => \%shub2_01_00155_def,
   0x0000000010000600 => \%shub2_01_00156_def,
   0x0000000010000680 => \%shub2_01_00157_def,
   0x0000000010000700 => \%shub2_01_00158_def,
   0x0000000010000780 => \%shub2_01_00159_def,
   0x0000000010000800 => \%shub2_01_00160_def,
   0x0000000010000880 => \%shub2_01_00161_def,
   0x0000000010000900 => \%shub2_01_00162_def,
   0x0000000010000980 => \%shub2_01_00163_def,
   0x0000000010000A00 => \%shub2_01_00164_def,
   0x0000000010000A80 => \%shub2_01_00165_def,
   0x0000000010000B00 => \%shub2_01_00166_def,
   0x0000000010000B80 => \%shub2_01_00167_def,
   0x0000000010000C00 => \%shub2_01_00168_def,
   0x0000000010000C80 => \%shub2_01_00169_def,
   0x0000000010000D00 => \%shub2_01_00170_def,
   0x0000000010000D80 => \%shub2_01_00171_def,
   0x0000000010000E00 => \%shub2_01_00172_def,
   0x0000000010001280 => \%shub2_01_00173_def,
   0x0000000010001300 => \%shub2_01_00174_def,
   0x0000000010001380 => \%shub2_01_00175_def,
   0x0000000010001400 => \%shub2_01_00176_def,
   0x0000000010001480 => \%shub2_01_00177_def,
   0x0000000010001500 => \%shub2_01_00178_def,
   0x0000000010001580 => \%shub2_01_00179_def,
   0x0000000010001600 => \%shub2_01_00180_def,
   0x0000000010001680 => \%shub2_01_00181_def,
   0x0000000010001700 => \%shub2_01_00182_def,
   0x0000000010001780 => \%shub2_01_00183_def,
   0x0000000010001800 => \%shub2_01_00184_def,
   0x0000000010001880 => \%shub2_01_00185_def,
   0x0000000010001900 => \%shub2_01_00186_def,
   0x0000000010001980 => \%shub2_01_00187_def,
   0x0000000010001A00 => \%shub2_01_00188_def,
   0x0000000010001A80 => \%shub2_01_00189_def,
   0x0000000010001B00 => \%shub2_01_00190_def,
   0x0000000010001B80 => \%shub2_01_00191_def,
   0x0000000010001C00 => \%shub2_01_00192_def,
   0x0000000010001C80 => \%shub2_01_00193_def,
   0x0000000010001D00 => \%shub2_01_00194_def,
   0x0000000010001D80 => \%shub2_01_00195_def,
   0x0000000010001E00 => \%shub2_01_00196_def,
   0x0000000010001E80 => \%shub2_01_00197_def,
   0x0000000010001F00 => \%shub2_01_00198_def,
   0x0000000010010000 => \%shub2_01_00199_def,
   0x0000000010010008 => \%shub2_01_00200_def,
   0x0000000010010080 => \%shub2_01_00201_def,
   0x0000000010010088 => \%shub2_01_00202_def,
   0x0000000010038000 => \%shub2_01_00203_def,
   0x0000000010038080 => \%shub2_01_00204_def,
   0x0000000010038100 => \%shub2_01_00205_def,
   0x0000000010038180 => \%shub2_01_00206_def,
   0x0000000010038200 => \%shub2_01_00207_def,
   0x00000000101A0000 => \%shub2_01_00208_def,
   0x00000000101A0100 => \%shub2_01_00209_def,
   0x0000000010062000 => \%shub2_01_00210_def,
   0x0000000010062080 => \%shub2_01_00211_def,
   0x0000000010062100 => \%shub2_01_00212_def,
   0x0000000010062180 => \%shub2_01_00213_def,
   0x0000000010062200 => \%shub2_01_00214_def,
   0x0000000010062280 => \%shub2_01_00215_def,
   0x0000000010062300 => \%shub2_01_00216_def,
   0x0000000010063000 => \%shub2_01_00217_def,
   0x0000000010063080 => \%shub2_01_00218_def,
   0x0000000010063100 => \%shub2_01_00219_def,
   0x0000000010063180 => \%shub2_01_00220_def,
   0x0000000010063200 => \%shub2_01_00221_def,
   0x0000000010063280 => \%shub2_01_00222_def,
   0x0000000010063300 => \%shub2_01_00223_def,
   0x0000000010063380 => \%shub2_01_00224_def,
   0x0000000010063400 => \%shub2_01_00225_def,
   0x0000000010063480 => \%shub2_01_00226_def,
   0x0000000010063500 => \%shub2_01_00227_def,
   0x0000000010063580 => \%shub2_01_00228_def,
   0x0000000010063600 => \%shub2_01_00229_def,
   0x0000000010063680 => \%shub2_01_00230_def,
   0x0000000010063700 => \%shub2_01_00231_def,
   0x0000000010063780 => \%shub2_01_00232_def,
   0x0000000010063800 => \%shub2_01_00233_def,
   0x0000000010063880 => \%shub2_01_00234_def,
   0x0000000010063900 => \%shub2_01_00235_def,
   0x0000000010063980 => \%shub2_01_00236_def,
   0x0000000010063A00 => \%shub2_01_00237_def,
   0x0000000010064000 => \%shub2_01_00238_def,
   0x0000000010064080 => \%shub2_01_00239_def,
   0x0000000010064100 => \%shub2_01_00240_def,
   0x0000000010064180 => \%shub2_01_00241_def,
   0x0000000010064200 => \%shub2_01_00242_def,
   0x0000000010064280 => \%shub2_01_00243_def,
   0x0000000010064300 => \%shub2_01_00244_def,
   0x0000000010064380 => \%shub2_01_00245_def,
   0x0000000010064400 => \%shub2_01_00246_def,
   0x0000000010064600 => \%shub2_01_00247_def,
   0x0000000010065000 => \%shub2_01_00248_def,
   0x0000000010065080 => \%shub2_01_00249_def,
   0x0000000010066000 => \%shub2_01_00250_def,
   0x0000000010066080 => \%shub2_01_00251_def,
   0x0000000010066100 => \%shub2_01_00252_def,
   0x0000000010066180 => \%shub2_01_00253_def,
   0x0000000010066200 => \%shub2_01_00254_def,
   0x0000000010066280 => \%shub2_01_00255_def,
   0x0000000010066300 => \%shub2_01_00256_def,
   0x0000000010066380 => \%shub2_01_00257_def,
   0x0000000010066400 => \%shub2_01_00258_def,
   0x0000000010066480 => \%shub2_01_00259_def,
   0x0000000010066500 => \%shub2_01_00260_def,
   0x0000000010066580 => \%shub2_01_00261_def,
   0x0000000010066600 => \%shub2_01_00262_def,
   0x0000000010066680 => \%shub2_01_00263_def,
   0x0000000010066700 => \%shub2_01_00264_def,
   0x0000000010066780 => \%shub2_01_00265_def,
   0x0000000010066800 => \%shub2_01_00266_def,
   0x0000000010066880 => \%shub2_01_00267_def,
   0x0000000010066900 => \%shub2_01_00268_def,
   0x0000000010066980 => \%shub2_01_00269_def,
   0x0000000010066A00 => \%shub2_01_00270_def,
   0x0000000010066A80 => \%shub2_01_00271_def,
   0x0000000010066B00 => \%shub2_01_00272_def,
   0x0000000010066B80 => \%shub2_01_00273_def,
   0x0000000010066C00 => \%shub2_01_00274_def,
   0x0000000010066C80 => \%shub2_01_00275_def,
   0x0000000010067000 => \%shub2_01_00276_def,
   0x0000000010067080 => \%shub2_01_00277_def,
   0x0000000010067100 => \%shub2_01_00278_def,
   0x0000000010069000 => \%shub2_01_00279_def,
   0x0000000010069080 => \%shub2_01_00280_def,
   0x0000000010069100 => \%shub2_01_00281_def,
   0x0000000010069180 => \%shub2_01_00282_def,
   0x0000000010069200 => \%shub2_01_00283_def,
   0x0000000010069280 => \%shub2_01_00284_def,
   0x0000000010069300 => \%shub2_01_00285_def,
   0x0000000010069380 => \%shub2_01_00286_def,
   0x0000000010069400 => \%shub2_01_00287_def,
   0x0000000010069480 => \%shub2_01_00288_def,
   0x0000000010069500 => \%shub2_01_00289_def,
   0x0000000010069580 => \%shub2_01_00290_def,
   0x0000000010069600 => \%shub2_01_00291_def,
   0x0000000010069680 => \%shub2_01_00292_def,
   0x0000000010069700 => \%shub2_01_00293_def,
   0x0000000010069780 => \%shub2_01_00294_def,
   0x0000000010069800 => \%shub2_01_00295_def,
   0x0000000010069880 => \%shub2_01_00296_def,
   0x0000000010069900 => \%shub2_01_00297_def,
   0x0000000010069980 => \%shub2_01_00298_def,
   0x0000000010069A00 => \%shub2_01_00299_def,
   0x0000000010069A80 => \%shub2_01_00300_def,
   0x0000000010069B00 => \%shub2_01_00301_def,
   0x0000000010069B80 => \%shub2_01_00302_def,
   0x0000000010069C00 => \%shub2_01_00303_def,
   0x0000000010069C80 => \%shub2_01_00304_def,
   0x0000000010069D00 => \%shub2_01_00305_def,
   0x0000000010069D80 => \%shub2_01_00306_def,
   0x0000000010069E00 => \%shub2_01_00307_def,
   0x0000000010069E80 => \%shub2_01_00308_def,
   0x0000000010069F00 => \%shub2_01_00309_def,
   0x0000000010069F80 => \%shub2_01_00310_def,
   0x000000001006A000 => \%shub2_01_00311_def,
   0x000000001006A080 => \%shub2_01_00312_def,
   0x000000001006A100 => \%shub2_01_00313_def,
   0x000000001006A180 => \%shub2_01_00314_def,
   0x000000001006A200 => \%shub2_01_00315_def,
   0x000000001006A280 => \%shub2_01_00316_def,
   0x000000001006A300 => \%shub2_01_00317_def,
   0x000000001006A380 => \%shub2_01_00318_def,
   0x000000001006A400 => \%shub2_01_00319_def,
   0x000000001006A480 => \%shub2_01_00320_def,
   0x000000001006A500 => \%shub2_01_00321_def,
   0x000000001006A580 => \%shub2_01_00322_def,
   0x000000001006A600 => \%shub2_01_00323_def,
   0x000000001006A680 => \%shub2_01_00324_def,
   0x000000001006A700 => \%shub2_01_00325_def,
   0x000000001006A780 => \%shub2_01_00326_def,
   0x000000001006A800 => \%shub2_01_00327_def,
   0x000000001006A880 => \%shub2_01_00328_def,
   0x000000001006A900 => \%shub2_01_00329_def,
   0x000000001006A980 => \%shub2_01_00330_def,
   0x000000001006AA00 => \%shub2_01_00331_def,
   0x000000001006AA80 => \%shub2_01_00332_def,
   0x000000001006AB00 => \%shub2_01_00333_def,
   0x000000001006AB80 => \%shub2_01_00334_def,
   0x000000001006AC00 => \%shub2_01_00335_def,
   0x000000001006AC80 => \%shub2_01_00336_def,
   0x000000001006AD00 => \%shub2_01_00337_def,
   0x000000001006AD80 => \%shub2_01_00338_def,
   0x000000001006AE00 => \%shub2_01_00339_def,
   0x000000001006AE80 => \%shub2_01_00340_def,
   0x000000001006AF00 => \%shub2_01_00341_def,
   0x000000001006AF80 => \%shub2_01_00342_def,
   0x000000001006B000 => \%shub2_01_00343_def,
   0x000000001006B080 => \%shub2_01_00344_def,
   0x000000001006B100 => \%shub2_01_00345_def,
   0x000000001006B180 => \%shub2_01_00346_def,
   0x000000001006B200 => \%shub2_01_00347_def,
   0x000000001006B280 => \%shub2_01_00348_def,
   0x000000001006B300 => \%shub2_01_00349_def,
   0x000000001006B380 => \%shub2_01_00350_def,
   0x000000001006B400 => \%shub2_01_00351_def,
   0x000000001006B480 => \%shub2_01_00352_def,
   0x000000001006B500 => \%shub2_01_00353_def,
   0x000000001006B580 => \%shub2_01_00354_def,
   0x000000001006B600 => \%shub2_01_00355_def,
   0x000000001006B680 => \%shub2_01_00356_def,
   0x000000001006B700 => \%shub2_01_00357_def,
   0x000000001006B780 => \%shub2_01_00358_def,
   0x000000001006B800 => \%shub2_01_00359_def,
   0x000000001006B880 => \%shub2_01_00360_def,
   0x000000001006B900 => \%shub2_01_00361_def,
   0x000000001006B980 => \%shub2_01_00362_def,
   0x000000001006BA00 => \%shub2_01_00363_def,
   0x000000001006BA80 => \%shub2_01_00364_def,
   0x000000001006BB00 => \%shub2_01_00365_def,
   0x000000001006BB80 => \%shub2_01_00366_def,
   0x000000001006BC00 => \%shub2_01_00367_def,
   0x000000001006BC80 => \%shub2_01_00368_def,
   0x000000001006BD00 => \%shub2_01_00369_def,
   0x000000001006BD80 => \%shub2_01_00370_def,
   0x000000001006BE00 => \%shub2_01_00371_def,
   0x000000001006BE80 => \%shub2_01_00372_def,
   0x000000001006BF00 => \%shub2_01_00373_def,
   0x000000001006BF80 => \%shub2_01_00374_def,
   0x000000001006C000 => \%shub2_01_00375_def,
   0x000000001006C080 => \%shub2_01_00376_def,
   0x000000001006C100 => \%shub2_01_00377_def,
   0x000000001006C180 => \%shub2_01_00378_def,
   0x000000001006C200 => \%shub2_01_00379_def,
   0x000000001006C280 => \%shub2_01_00380_def,
   0x000000001006C300 => \%shub2_01_00381_def,
   0x000000001006C380 => \%shub2_01_00382_def,
   0x000000001006C400 => \%shub2_01_00383_def,
   0x000000001006C480 => \%shub2_01_00384_def,
   0x000000001006C500 => \%shub2_01_00385_def,
   0x000000001006C580 => \%shub2_01_00386_def,
   0x000000001006C600 => \%shub2_01_00387_def,
   0x000000001006C680 => \%shub2_01_00388_def,
   0x000000001006C700 => \%shub2_01_00389_def,
   0x000000001006C780 => \%shub2_01_00390_def,
   0x000000001006C800 => \%shub2_01_00391_def,
   0x000000001006C880 => \%shub2_01_00392_def,
   0x000000001006C900 => \%shub2_01_00393_def,
   0x000000001006C980 => \%shub2_01_00394_def,
   0x000000001006CA00 => \%shub2_01_00395_def,
   0x000000001006CA80 => \%shub2_01_00396_def,
   0x000000001006CB00 => \%shub2_01_00397_def,
   0x000000001006CB80 => \%shub2_01_00398_def,
   0x000000001006CC00 => \%shub2_01_00399_def,
   0x000000001006CC80 => \%shub2_01_00400_def,
   0x000000001006CD00 => \%shub2_01_00401_def,
   0x000000001006CD80 => \%shub2_01_00402_def,
   0x000000001006CE00 => \%shub2_01_00403_def,
   0x000000001006CE80 => \%shub2_01_00404_def,
   0x000000001006CF00 => \%shub2_01_00405_def,
   0x000000001006CF80 => \%shub2_01_00406_def,
   0x0000000010060000 => \%shub2_01_00407_def,
   0x0000000010060080 => \%shub2_01_00408_def,
   0x0000000010060100 => \%shub2_01_00409_def,
   0x0000000010060180 => \%shub2_01_00410_def,
   0x0000000010060200 => \%shub2_01_00411_def,
   0x0000000010060280 => \%shub2_01_00412_def,
   0x0000000010060300 => \%shub2_01_00413_def,
   0x0000000010060380 => \%shub2_01_00414_def,
   0x0000000010060400 => \%shub2_01_00415_def,
   0x0000000010060480 => \%shub2_01_00416_def,
   0x0000000010060500 => \%shub2_01_00417_def,
   0x0000000010060580 => \%shub2_01_00418_def,
   0x0000000010060600 => \%shub2_01_00419_def,
   0x0000000010060680 => \%shub2_01_00420_def,
   0x0000000010060700 => \%shub2_01_00421_def,
   0x0000000010060780 => \%shub2_01_00422_def,
   0x0000000010060C00 => \%shub2_01_00423_def,
   0x0000000010060C80 => \%shub2_01_00424_def,
   0x0000000010060D00 => \%shub2_01_00425_def,
   0x0000000010060D80 => \%shub2_01_00426_def,
   0x0000000010060E00 => \%shub2_01_00427_def,
   0x0000000010060E80 => \%shub2_01_00428_def,
   0x0000000010060F00 => \%shub2_01_00429_def,
   0x0000000010061100 => \%shub2_01_00430_def,
   0x0000000010061400 => \%shub2_01_00431_def,
   0x0000000010068000 => \%shub2_01_00432_def,
   0x0000000010068080 => \%shub2_01_00433_def,
   0x0000000010068100 => \%shub2_01_00434_def,
   0x0000000010068200 => \%shub2_01_00435_def,
   0x0000000010068300 => \%shub2_01_00436_def,
   0x0000000010071000 => \%shub2_01_00437_def,
   0x0000000010071080 => \%shub2_01_00438_def,
   0x0000000010071100 => \%shub2_01_00439_def,
   0x0000000010071180 => \%shub2_01_00440_def,
   0x0000000010071200 => \%shub2_01_00441_def,
   0x0000000010071280 => \%shub2_01_00442_def,
   0x0000000010071300 => \%shub2_01_00443_def,
   0x0000000010071380 => \%shub2_01_00444_def,
   0x0000000010071400 => \%shub2_01_00445_def,
   0x0000000010071880 => \%shub2_01_00446_def,
   0x0000000010071900 => \%shub2_01_00447_def,
   0x0000000010071980 => \%shub2_01_00448_def,
   0x0000000010072000 => \%shub2_01_00449_def,
   0x0000000010072180 => \%shub2_01_00450_def,
   0x0000000010072200 => \%shub2_01_00451_def,
   0x0000000010072280 => \%shub2_01_00452_def,
   0x0000000010072300 => \%shub2_01_00453_def,
   0x0000000010072380 => \%shub2_01_00454_def,
   0x0000000010072800 => \%shub2_01_00455_def,
   0x0000000010072880 => \%shub2_01_00456_def,
   0x0000000010072900 => \%shub2_01_00457_def,
   0x0000000010073000 => \%shub2_01_00458_def,
   0x0000000010073080 => \%shub2_01_00459_def,
   0x0000000010073100 => \%shub2_01_00460_def,
   0x0000000010074000 => \%shub2_01_00461_def,
   0x0000000010074080 => \%shub2_01_00462_def,
   0x0000000010074100 => \%shub2_01_00463_def,
   0x0000000010074108 => \%shub2_01_00464_def,
   0x0000000010075000 => \%shub2_01_00465_def,
   0x0000000010077000 => \%shub2_01_00466_def,
   0x0000000000000080 => \%shub2_01_00467_def,
   0x0000000000000088 => \%shub2_01_00468_def,
   0x0000000000000090 => \%shub2_01_00469_def,
   0x0000000000000098 => \%shub2_01_00470_def,
   0x00000000000000A0 => \%shub2_01_00471_def,
   0x00000000000000A8 => \%shub2_01_00472_def,
   0x00000000000000B0 => \%shub2_01_00473_def,
   0x00000000000000B8 => \%shub2_01_00474_def,
   0x00000000000000C0 => \%shub2_01_00475_def,
   0x00000000000000C8 => \%shub2_01_00476_def,
   0x00000000000000D0 => \%shub2_01_00477_def,
   0x00000000000000D8 => \%shub2_01_00478_def,
   0x00000000000000E0 => \%shub2_01_00479_def,
   0x00000000000000E8 => \%shub2_01_00480_def,
   0x00000000000000F0 => \%shub2_01_00481_def,
   0x00000000000000F8 => \%shub2_01_00482_def,
   0x0000000000000100 => \%shub2_01_00483_def,
   0x0000000000010000 => \%shub2_01_00484_def,
   0x0000000000010008 => \%shub2_01_00485_def,
   0x0000000000010010 => \%shub2_01_00486_def,
   0x0000000000010018 => \%shub2_01_00487_def,
   0x0000000000010020 => \%shub2_01_00488_def,
   0x0000000000010028 => \%shub2_01_00489_def,
   0x0000000000010030 => \%shub2_01_00490_def,
   0x0000000000010038 => \%shub2_01_00491_def,
   0x0000000000010040 => \%shub2_01_00492_def,
   0x0000000000010048 => \%shub2_01_00493_def,
   0x0000000000010050 => \%shub2_01_00494_def,
   0x0000000000010058 => \%shub2_01_00495_def,
   0x0000000000010060 => \%shub2_01_00496_def,
   0x0000000000010068 => \%shub2_01_00497_def,
   0x0000000000010070 => \%shub2_01_00498_def,
   0x0000000000010078 => \%shub2_01_00499_def,
   0x0000000000010080 => \%shub2_01_00500_def,
   0x0000000000010088 => \%shub2_01_00501_def,
   0x0000000000010090 => \%shub2_01_00502_def,
   0x0000000000010098 => \%shub2_01_00503_def,
   0x00000000000100A0 => \%shub2_01_00504_def,
   0x00000000000100A8 => \%shub2_01_00505_def,
   0x00000000000100B0 => \%shub2_01_00506_def,
   0x00000000000100B8 => \%shub2_01_00507_def,
   0x00000000000100C0 => \%shub2_01_00508_def,
   0x00000000000100C8 => \%shub2_01_00509_def,
   0x00000000000100D0 => \%shub2_01_00510_def,
   0x00000000000100D8 => \%shub2_01_00511_def,
   0x00000000000100E0 => \%shub2_01_00512_def,
   0x00000000000100E8 => \%shub2_01_00513_def,
   0x00000000000100F0 => \%shub2_01_00514_def,
   0x00000000000100F8 => \%shub2_01_00515_def,
   0x0000000000020000 => \%shub2_01_00516_def,
   0x0000000000020008 => \%shub2_01_00517_def,
   0x0000000000020010 => \%shub2_01_00518_def,
   0x0000000000020018 => \%shub2_01_00519_def,
   0x0000000000020020 => \%shub2_01_00520_def,
   0x0000000000020028 => \%shub2_01_00521_def,
   0x0000000000020030 => \%shub2_01_00522_def,
   0x0000000000020038 => \%shub2_01_00523_def,
   0x0000000000020040 => \%shub2_01_00524_def,
   0x0000000000020048 => \%shub2_01_00525_def,
   0x0000000000020050 => \%shub2_01_00526_def,
   0x0000000000020058 => \%shub2_01_00527_def,
   0x0000000000020060 => \%shub2_01_00528_def,
   0x0000000000020068 => \%shub2_01_00529_def,
   0x0000000000020070 => \%shub2_01_00530_def,
   0x0000000000020078 => \%shub2_01_00531_def,
   0x0000000000020080 => \%shub2_01_00532_def,
   0x0000000000020088 => \%shub2_01_00533_def,
   0x0000000000020100 => \%shub2_01_00534_def,
   0x0000000000020108 => \%shub2_01_00535_def,
   0x0000000000020110 => \%shub2_01_00536_def,
   0x0000000000020118 => \%shub2_01_00537_def,
   0x0000000000020120 => \%shub2_01_00538_def,
   0x0000000000020128 => \%shub2_01_00539_def,
   0x0000000000020130 => \%shub2_01_00540_def,
   0x0000000000020138 => \%shub2_01_00541_def,
   0x0000000000020140 => \%shub2_01_00542_def,
   0x0000000000020148 => \%shub2_01_00543_def,
   0x0000000000020150 => \%shub2_01_00544_def,
   0x0000000000020158 => \%shub2_01_00545_def,
   0x0000000000020160 => \%shub2_01_00546_def,
   0x0000000000020168 => \%shub2_01_00547_def,
   0x0000000000020170 => \%shub2_01_00548_def,
   0x0000000000020178 => \%shub2_01_00549_def,
   0x0000000000020180 => \%shub2_01_00550_def,
   0x0000000000020188 => \%shub2_01_00551_def,
   0x0000000000020190 => \%shub2_01_00552_def,
   0x0000000000020198 => \%shub2_01_00553_def,
   0x00000000000201A0 => \%shub2_01_00554_def,
   0x00000000000201A8 => \%shub2_01_00555_def,
   0x00000000000201B0 => \%shub2_01_00556_def,
   0x00000000000201B8 => \%shub2_01_00557_def,
   0x00000000000201C0 => \%shub2_01_00558_def,
   0x00000000000201C8 => \%shub2_01_00559_def,
   0x00000000000201D0 => \%shub2_01_00560_def,
   0x00000000000201D8 => \%shub2_01_00561_def,
   0x00000000000201E0 => \%shub2_01_00562_def,
   0x00000000000201E8 => \%shub2_01_00563_def,
   0x0000000000020300 => \%shub2_01_00564_def,
   0x0000000000020308 => \%shub2_01_00565_def,
   0x0000000000020310 => \%shub2_01_00566_def,
   0x0000000000020318 => \%shub2_01_00567_def,
   0x0000000000030000 => \%shub2_01_00568_def,
   0x0000000000030100 => \%shub2_01_00569_def,
   0x0000000000030110 => \%shub2_01_00570_def,
   0x0000000000030120 => \%shub2_01_00571_def,
   0x0000000000030130 => \%shub2_01_00572_def,
   0x0000000000030200 => \%shub2_01_00573_def,
   0x0000000000030210 => \%shub2_01_00574_def,
   0x0000000000030220 => \%shub2_01_00575_def,
   0x0000000000030230 => \%shub2_01_00576_def,
   0x0000000000030240 => \%shub2_01_00577_def,
   0x0000000000030250 => \%shub2_01_00578_def,
   0x0000000000030260 => \%shub2_01_00579_def,
   0x0000000000030270 => \%shub2_01_00580_def,
   0x0000000000030300 => \%shub2_01_00581_def,
   0x0000000000030310 => \%shub2_01_00582_def,
   0x0000000000030320 => \%shub2_01_00583_def,
   0x0000000000030330 => \%shub2_01_00584_def,
   0x0000000000030340 => \%shub2_01_00585_def,
   0x0000000000030350 => \%shub2_01_00586_def,
   0x0000000000030360 => \%shub2_01_00587_def,
   0x0000000000030370 => \%shub2_01_00588_def,
   0x0000000000030400 => \%shub2_01_00589_def,
   0x0000000000031000 => \%shub2_01_00590_def,
   0x0000000000031010 => \%shub2_01_00591_def,
   0x0000000000032000 => \%shub2_01_00592_def,
   0x0000000000032010 => \%shub2_01_00593_def,
   0x0000000000032800 => \%shub2_01_00594_def,
   0x0000000000032810 => \%shub2_01_00595_def,
   0x0000000000033000 => \%shub2_01_00596_def,
   0x0000000000033010 => \%shub2_01_00597_def,
   0x0000000000033020 => \%shub2_01_00598_def,
   0x0000000000033030 => \%shub2_01_00599_def,
   0x0000000000033040 => \%shub2_01_00600_def,
   0x0000000000033050 => \%shub2_01_00601_def,
   0x0000000000033800 => \%shub2_01_00602_def,
   0x0000000000033810 => \%shub2_01_00603_def,
   0x0000000000033820 => \%shub2_01_00604_def,
   0x0000000000033830 => \%shub2_01_00605_def,
   0x0000000000033840 => \%shub2_01_00606_def,
   0x0000000000033850 => \%shub2_01_00607_def,
   0x0000000000034000 => \%shub2_01_00608_def,
   0x0000000000034010 => \%shub2_01_00609_def,
   0x0000000000034020 => \%shub2_01_00610_def,
   0x0000000000038000 => \%shub2_01_00611_def,
   0x0000000000038010 => \%shub2_01_00612_def,
   0x0000000000038020 => \%shub2_01_00613_def,
   0x0000000000038030 => \%shub2_01_00614_def,
   0x0000000000038040 => \%shub2_01_00615_def,
   0x0000000000038800 => \%shub2_01_00616_def,
   0x0000000000038810 => \%shub2_01_00617_def,
   0x0000000000038820 => \%shub2_01_00618_def,
   0x0000000000038830 => \%shub2_01_00619_def,
   0x0000000000038840 => \%shub2_01_00620_def,
   0x0000000000034800 => \%shub2_01_00621_def,
   0x0000000000048000 => \%shub2_01_00622_def,
   0x0000000000048010 => \%shub2_01_00623_def,
   0x0000000000048020 => \%shub2_01_00624_def,
   0x0000000000048030 => \%shub2_01_00625_def,
   0x0000000000048040 => \%shub2_01_00626_def,
   0x0000000000048800 => \%shub2_01_00627_def,
   0x0000000000048810 => \%shub2_01_00628_def,
   0x0000000000048820 => \%shub2_01_00629_def,
   0x0000000000048830 => \%shub2_01_00630_def,
   0x0000000000048840 => \%shub2_01_00631_def,
   0x0000000000049000 => \%shub2_01_00632_def,
   0x000000000004A000 => \%shub2_01_00633_def,
   0x000000000004B000 => \%shub2_01_00634_def,
   0x0000000000050000 => \%shub2_01_00635_def,
   0x0000000000050100 => \%shub2_01_00636_def,
   0x0000000000050110 => \%shub2_01_00637_def,
   0x0000000000050120 => \%shub2_01_00638_def,
   0x0000000000050130 => \%shub2_01_00639_def,
   0x0000000000050200 => \%shub2_01_00640_def,
   0x0000000000050210 => \%shub2_01_00641_def,
   0x0000000000050220 => \%shub2_01_00642_def,
   0x0000000000050230 => \%shub2_01_00643_def,
   0x0000000000050240 => \%shub2_01_00644_def,
   0x0000000000050250 => \%shub2_01_00645_def,
   0x0000000000050260 => \%shub2_01_00646_def,
   0x0000000000050270 => \%shub2_01_00647_def,
   0x0000000000050300 => \%shub2_01_00648_def,
   0x0000000000050310 => \%shub2_01_00649_def,
   0x0000000000050320 => \%shub2_01_00650_def,
   0x0000000000050330 => \%shub2_01_00651_def,
   0x0000000000050340 => \%shub2_01_00652_def,
   0x0000000000050350 => \%shub2_01_00653_def,
   0x0000000000050360 => \%shub2_01_00654_def,
   0x0000000000050370 => \%shub2_01_00655_def,
   0x0000000000050400 => \%shub2_01_00656_def,
   0x0000000000051000 => \%shub2_01_00657_def,
   0x0000000000051010 => \%shub2_01_00658_def,
   0x0000000000052000 => \%shub2_01_00659_def,
   0x0000000000052010 => \%shub2_01_00660_def,
   0x0000000000052800 => \%shub2_01_00661_def,
   0x0000000000052810 => \%shub2_01_00662_def,
   0x0000000000053000 => \%shub2_01_00663_def,
   0x0000000000053010 => \%shub2_01_00664_def,
   0x0000000000053020 => \%shub2_01_00665_def,
   0x0000000000053030 => \%shub2_01_00666_def,
   0x0000000000053040 => \%shub2_01_00667_def,
   0x0000000000053050 => \%shub2_01_00668_def,
   0x0000000000053800 => \%shub2_01_00669_def,
   0x0000000000053810 => \%shub2_01_00670_def,
   0x0000000000053820 => \%shub2_01_00671_def,
   0x0000000000053830 => \%shub2_01_00672_def,
   0x0000000000053840 => \%shub2_01_00673_def,
   0x0000000000053850 => \%shub2_01_00674_def,
   0x0000000000054000 => \%shub2_01_00675_def,
   0x0000000000054010 => \%shub2_01_00676_def,
   0x0000000000054020 => \%shub2_01_00677_def,
   0x0000000000058000 => \%shub2_01_00678_def,
   0x0000000000058010 => \%shub2_01_00679_def,
   0x0000000000058020 => \%shub2_01_00680_def,
   0x0000000000058030 => \%shub2_01_00681_def,
   0x0000000000058040 => \%shub2_01_00682_def,
   0x0000000000058800 => \%shub2_01_00683_def,
   0x0000000000058810 => \%shub2_01_00684_def,
   0x0000000000058820 => \%shub2_01_00685_def,
   0x0000000000058830 => \%shub2_01_00686_def,
   0x0000000000058840 => \%shub2_01_00687_def,
   0x0000000000054800 => \%shub2_01_00688_def,
   0x0000000000068000 => \%shub2_01_00689_def,
   0x0000000000068010 => \%shub2_01_00690_def,
   0x0000000000068020 => \%shub2_01_00691_def,
   0x0000000000068030 => \%shub2_01_00692_def,
   0x0000000000068040 => \%shub2_01_00693_def,
   0x0000000000068800 => \%shub2_01_00694_def,
   0x0000000000068810 => \%shub2_01_00695_def,
   0x0000000000068820 => \%shub2_01_00696_def,
   0x0000000000068830 => \%shub2_01_00697_def,
   0x0000000000068840 => \%shub2_01_00698_def,
   0x0000000000069000 => \%shub2_01_00699_def,
   0x000000000006A000 => \%shub2_01_00700_def,
   0x000000000006B000 => \%shub2_01_00701_def,
   0x0000000020110000 => \%shub2_01_00702_def,
   0x0000000020110008 => \%shub2_01_00703_def,
   0x0000000020110010 => \%shub2_01_00704_def,
   0x0000000020110018 => \%shub2_01_00705_def,
   0x0000000020010000 => \%shub2_01_00706_def,
   0x0000000020010008 => \%shub2_01_00707_def,
   0x0000000020010010 => \%shub2_01_00708_def,
   0x0000000020010018 => \%shub2_01_00709_def,
   0x0000000020020000 => \%shub2_01_00710_def,
   0x0000000020020018 => \%shub2_01_00711_def,
   0x0000000020020008 => \%shub2_01_00712_def,
   0x0000000020020010 => \%shub2_01_00713_def,
   0x0000000020070000 => \%shub2_01_00714_def,
   0x0000000020070080 => \%shub2_01_00715_def,
   0x0000000020070100 => \%shub2_01_00716_def,
   0x0000000020070180 => \%shub2_01_00717_def,
   0x0000000020070200 => \%shub2_01_00718_def,
   0x0000000020070208 => \%shub2_01_00719_def,
   0x0000000020070280 => \%shub2_01_00720_def,
   0x0000000020070288 => \%shub2_01_00721_def,
   0x0000000020070300 => \%shub2_01_00722_def,
   0x0000000020070308 => \%shub2_01_00723_def,
   0x0000000020070380 => \%shub2_01_00724_def,
   0x0000000020070388 => \%shub2_01_00725_def,
   0x0000000020070400 => \%shub2_01_00726_def,
   0x0000000020070480 => \%shub2_01_00727_def,
   0x0000000020070500 => \%shub2_01_00728_def,
   0x0000000020070580 => \%shub2_01_00729_def,
   0x0000000020070600 => \%shub2_01_00730_def,
   0x0000000020070608 => \%shub2_01_00731_def,
   0x0000000020070680 => \%shub2_01_00732_def,
   0x0000000020070688 => \%shub2_01_00733_def,
   0x0000000020070700 => \%shub2_01_00734_def,
   0x0000000020070708 => \%shub2_01_00735_def,
   0x0000000020070780 => \%shub2_01_00736_def,
   0x0000000020070788 => \%shub2_01_00737_def,
   0x0000000020050110 => \%shub2_01_00738_def,
   0x00000000200501A0 => \%shub2_01_00739_def,
   0x0000000020050210 => \%shub2_01_00740_def,
   0x0000000020050120 => \%shub2_01_00741_def,
   0x00000000200501B0 => \%shub2_01_00742_def,
   0x0000000020050220 => \%shub2_01_00743_def,
   0x0000000020050080 => \%shub2_01_00744_def,
   0x0000000020050280 => \%shub2_01_00745_def,
   0x0000000020050300 => \%shub2_01_00746_def,
   0x0000000020050380 => \%shub2_01_00747_def,
   0x0000000020050400 => \%shub2_01_00748_def,
   0x0000000020050480 => \%shub2_01_00749_def,
   0x0000000020050500 => \%shub2_01_00750_def,
   0x0000000020050580 => \%shub2_01_00751_def,
   0x0000000020050600 => \%shub2_01_00752_def,
   0x0000000020050680 => \%shub2_01_00753_def,
   0x0000000020050700 => \%shub2_01_00754_def,
   0x0000000020050780 => \%shub2_01_00755_def,
   0x0000000020050800 => \%shub2_01_00756_def,
   0x0000000020050880 => \%shub2_01_00757_def,
   0x0000000020050900 => \%shub2_01_00758_def,
   0x0000000020050980 => \%shub2_01_00759_def,
   0x0000000020050A00 => \%shub2_01_00760_def,
   0x0000000020050C80 => \%shub2_01_00761_def,
   0x0000000020050A80 => \%shub2_01_00762_def,
   0x0000000020050C00 => \%shub2_01_00763_def,
   0x0000000020050B80 => \%shub2_01_00764_def,
   0x0000000020050C80 => \%shub2_01_00765_def,
   0x0000000020052078 => \%shub2_01_00766_def,
   0x0000000020052080 => \%shub2_01_00767_def,
   0x0000000020052088 => \%shub2_01_00768_def,
   0x0000000020050D00 => \%shub2_01_00769_def,
   0x0000000020050D80 => \%shub2_01_00770_def,
   0x0000000020050E00 => \%shub2_01_00771_def,
   0x0000000020052070 => \%shub2_01_00772_def,
   0x0000000020052030 => \%shub2_01_00773_def,
   0x0000000020052038 => \%shub2_01_00774_def,
   0x0000000020052040 => \%shub2_01_00775_def,
   0x0000000020052060 => \%shub2_01_00776_def,
   0x0000000020052048 => \%shub2_01_00777_def,
   0x0000000020052050 => \%shub2_01_00778_def,
   0x0000000020052058 => \%shub2_01_00779_def,
   0x0000000020050E08 => \%shub2_01_00780_def,
   0x0000000020050E80 => \%shub2_01_00781_def,
   0x0000000020050F00 => \%shub2_01_00782_def,
   0x0000000020050F80 => \%shub2_01_00783_def,
   0x0000000020052000 => \%shub2_01_00784_def,
   0x0000000020052008 => \%shub2_01_00785_def,
   0x0000000020052010 => \%shub2_01_00786_def,
   0x0000000020052068 => \%shub2_01_00787_def,
   0x0000000020053008 => \%shub2_01_00788_def,
   0x0000000020052090 => \%shub2_01_00789_def,
   0x0000000020052018 => \%shub2_01_00790_def,
   0x0000000020052020 => \%shub2_01_00791_def,
   0x0000000020052028 => \%shub2_01_00792_def,
   0x0000000020052098 => \%shub2_01_00793_def,
   0x0000000020051000 => \%shub2_01_00794_def,
   0x0000000020051080 => \%shub2_01_00795_def,
   0x0000000020051100 => \%shub2_01_00796_def,
   0x0000000020060080 => \%shub2_01_00797_def,
   0x0000000020060100 => \%shub2_01_00798_def,
   0x0000000020060180 => \%shub2_01_00799_def,
   0x0000000020060200 => \%shub2_01_00800_def,
   0x0000000020060280 => \%shub2_01_00801_def,
   0x0000000020060300 => \%shub2_01_00802_def,
   0x0000000020060308 => \%shub2_01_00803_def,
   0x0000000020060380 => \%shub2_01_00804_def,
   0x0000000020060400 => \%shub2_01_00805_def,
   0x0000000020060408 => \%shub2_01_00806_def,
   0x0000000020060480 => \%shub2_01_00807_def,
   0x0000000020060500 => \%shub2_01_00808_def,
   0x0000000020060580 => \%shub2_01_00809_def,
   0x0000000020060600 => \%shub2_01_00810_def,
   0x0000000020060608 => \%shub2_01_00811_def,
   0x0000000020060680 => \%shub2_01_00812_def,
   0x0000000020060688 => \%shub2_01_00813_def,
   0x0000000020060780 => \%shub2_01_00814_def,
   0x0000000020060788 => \%shub2_01_00815_def,
   0x0000000020060900 => \%shub2_01_00816_def,
   0x0000000020060980 => \%shub2_01_00817_def,
   0x0000000020060A00 => \%shub2_01_00818_def,
   0x0000000020060A80 => \%shub2_01_00819_def,
   0x0000000020060B00 => \%shub2_01_00820_def,
   0x0000000020060B80 => \%shub2_01_00821_def,
   0x0000000020060B88 => \%shub2_01_00822_def,
   0x0000000020060C00 => \%shub2_01_00823_def,
   0x0000000020060C80 => \%shub2_01_00824_def,
   0x0000000020060C88 => \%shub2_01_00825_def,
   0x0000000020060800 => \%shub2_01_00826_def,
   0x0000000020060880 => \%shub2_01_00827_def,
   0x0000000020060E00 => \%shub2_01_00828_def,
   0x0000000020060D00 => \%shub2_01_00829_def,
   0x0000000020060D80 => \%shub2_01_00830_def,
   0x0000000020000000 => \%shub2_01_00831_def,
   0x0000000020000080 => \%shub2_01_00832_def,
   0x0000000020000100 => \%shub2_01_00833_def,
   0x0000000020000180 => \%shub2_01_00834_def,
   0x0000000050000000 => \%shub2_01_00835_def,
   0x0000000050000008 => \%shub2_01_00836_def,
   0x0000000050000010 => \%shub2_01_00837_def,
   0x0000000050000018 => \%shub2_01_00838_def,
   0x0000000050000020 => \%shub2_01_00839_def,
   0x0000000050000028 => \%shub2_01_00840_def,
   0x0000000050000030 => \%shub2_01_00841_def,
   0x0000000050000038 => \%shub2_01_00842_def,
   0x0000000050000040 => \%shub2_01_00843_def,
   0x0000000050000048 => \%shub2_01_00844_def,
   0x0000000050000050 => \%shub2_01_00845_def,
   0x0000000050000058 => \%shub2_01_00846_def,
   0x0000000050000060 => \%shub2_01_00847_def,
   0x0000000050002000 => \%shub2_01_00848_def,
   0x0000000050002008 => \%shub2_01_00849_def,
   0x0000000050002010 => \%shub2_01_00850_def,
   0x0000000050002018 => \%shub2_01_00851_def,
   0x0000000050002020 => \%shub2_01_00852_def,
   0x0000000050002028 => \%shub2_01_00853_def,
   0x0000000050002030 => \%shub2_01_00854_def,
   0x0000000050002038 => \%shub2_01_00855_def,
   0x0000000050002040 => \%shub2_01_00856_def,
   0x0000000050002048 => \%shub2_01_00857_def,
   0x0000000050002050 => \%shub2_01_00858_def,
   0x0000000050002058 => \%shub2_01_00859_def,
   0x0000000050002060 => \%shub2_01_00860_def,
   0x0000000050001030 => \%shub2_01_00861_def,
   0x0000000050001040 => \%shub2_01_00862_def,
   0x0000000050001050 => \%shub2_01_00863_def,
   0x0000000050001060 => \%shub2_01_00864_def,
   0x0000000050001070 => \%shub2_01_00865_def,
   0x0000000050003030 => \%shub2_01_00866_def,
   0x0000000050003040 => \%shub2_01_00867_def,
   0x0000000050003050 => \%shub2_01_00868_def,
   0x0000000050003060 => \%shub2_01_00869_def,
   0x0000000050003070 => \%shub2_01_00870_def,
   0x0000000050020000 => \%shub2_01_00871_def,
   0x0000000050020800 => \%shub2_01_00872_def,
   0x0000000050021000 => \%shub2_01_00873_def,
   0x0000000050022000 => \%shub2_01_00874_def,
   0x0000000050022800 => \%shub2_01_00875_def,
   0x0000000050023000 => \%shub2_01_00876_def,
   0x0000000050023008 => \%shub2_01_00877_def,
   0x0000000050024000 => \%shub2_01_00878_def,
   0x0000000050024800 => \%shub2_01_00879_def,
   0x0000000050025000 => \%shub2_01_00880_def,
   0x0000000050026000 => \%shub2_01_00881_def,
   0x0000000050026800 => \%shub2_01_00882_def,
   0x0000000050027000 => \%shub2_01_00883_def,
   0x0000000050028000 => \%shub2_01_00884_def,
   0x0000000050028800 => \%shub2_01_00885_def,
   0x0000000050029000 => \%shub2_01_00886_def,
   0x0000000050029008 => \%shub2_01_00887_def,
   0x0000000050030000 => \%shub2_01_00888_def,
   0x0000000050030010 => \%shub2_01_00889_def,
   0x0000000050030020 => \%shub2_01_00890_def,
   0x0000000050030030 => \%shub2_01_00891_def,
   0x0000000050030040 => \%shub2_01_00892_def,
   0x0000000050030050 => \%shub2_01_00893_def,
   0x0000000050030060 => \%shub2_01_00894_def,
   0x0000000050030070 => \%shub2_01_00895_def,
   0x0000000050030080 => \%shub2_01_00896_def,
   0x0000000050030090 => \%shub2_01_00897_def,
   0x00000000500300A0 => \%shub2_01_00898_def,
   0x00000000500300B0 => \%shub2_01_00899_def,
   0x0000000050030100 => \%shub2_01_00900_def,
   0x0000000050030110 => \%shub2_01_00901_def,
   0x0000000050030120 => \%shub2_01_00902_def,
   0x0000000050030130 => \%shub2_01_00903_def,
   0x0000000050030140 => \%shub2_01_00904_def,
   0x0000000050030150 => \%shub2_01_00905_def,
   0x0000000050030160 => \%shub2_01_00906_def,
   0x0000000050030170 => \%shub2_01_00907_def,
   0x0000000050030180 => \%shub2_01_00908_def,
   0x0000000050030190 => \%shub2_01_00909_def,
   0x00000000500301A0 => \%shub2_01_00910_def,
   0x00000000500301B0 => \%shub2_01_00911_def,
   0x0000000050030200 => \%shub2_01_00912_def,
   0x0000000050030210 => \%shub2_01_00913_def,
   0x0000000050030220 => \%shub2_01_00914_def,
   0x0000000050030230 => \%shub2_01_00915_def,
   0x0000000050030240 => \%shub2_01_00916_def,
   0x0000000050030250 => \%shub2_01_00917_def,
   0x0000000050030260 => \%shub2_01_00918_def,
   0x00000000500302B0 => \%shub2_01_00919_def,
   0x00000000500302C0 => \%shub2_01_00920_def,
   0x00000000500302D0 => \%shub2_01_00921_def,
   0x0000000050030300 => \%shub2_01_00922_def,
   0x0000000050030310 => \%shub2_01_00923_def,
   0x0000000050030320 => \%shub2_01_00924_def,
   0x0000000050030330 => \%shub2_01_00925_def,
   0x0000000050030340 => \%shub2_01_00926_def,
   0x0000000050030350 => \%shub2_01_00927_def,
   0x0000000050030360 => \%shub2_01_00928_def,
   0x0000000050030270 => \%shub2_01_00929_def,
   0x0000000050030280 => \%shub2_01_00930_def,
   0x0000000050030290 => \%shub2_01_00931_def,
   0x00000000500302A0 => \%shub2_01_00932_def,
   0x00000000500302E0 => \%shub2_01_00933_def,
   0x00000000500302F0 => \%shub2_01_00934_def,
   0x0000000050030400 => \%shub2_01_00935_def,
   0x0000000050030410 => \%shub2_01_00936_def,
   0x0000000050030420 => \%shub2_01_00937_def,
   0x0000000050030430 => \%shub2_01_00938_def,
   0x0000000050030440 => \%shub2_01_00939_def,
   0x0000000050030450 => \%shub2_01_00940_def,
   0x0000000050030460 => \%shub2_01_00941_def,
   0x0000000050030470 => \%shub2_01_00942_def,
   0x0000000050030480 => \%shub2_01_00943_def,
   0x0000000050030490 => \%shub2_01_00944_def,
   0x00000000500304A0 => \%shub2_01_00945_def,
   0x00000000500304B0 => \%shub2_01_00946_def,
   0x00000000500304C0 => \%shub2_01_00947_def,
   0x00000000500304F0 => \%shub2_01_00948_def,
   0x00000000500304D0 => \%shub2_01_00949_def,
   0x00000000500304E0 => \%shub2_01_00950_def,
   0x0000000050030500 => \%shub2_01_00951_def,
   0x0000000050030510 => \%shub2_01_00952_def,
   0x0000000050030520 => \%shub2_01_00953_def,
   0x0000000050030530 => \%shub2_01_00954_def,
   0x0000000050030540 => \%shub2_01_00955_def,
   0x0000000050030550 => \%shub2_01_00956_def,
   0x0000000050030560 => \%shub2_01_00957_def,
   0x0000000050030570 => \%shub2_01_00958_def,
   0x0000000050030600 => \%shub2_01_00959_def,
   0x0000000050030610 => \%shub2_01_00960_def,
   0x0000000050030620 => \%shub2_01_00961_def,
   0x0000000050030630 => \%shub2_01_00962_def,
   0x0000000050030640 => \%shub2_01_00963_def,
   0x0000000050030650 => \%shub2_01_00964_def,
   0x0000000050030660 => \%shub2_01_00965_def,
   0x0000000050030670 => \%shub2_01_00966_def,
   0x0000000050030680 => \%shub2_01_00967_def,
   0x0000000050030690 => \%shub2_01_00968_def,
   0x00000000500306A0 => \%shub2_01_00969_def,
   0x00000000500306B0 => \%shub2_01_00970_def,
   0x00000000500306C0 => \%shub2_01_00971_def,
   0x00000000500306F0 => \%shub2_01_00972_def,
   0x00000000500306D0 => \%shub2_01_00973_def,
   0x00000000500306E0 => \%shub2_01_00974_def,
   0x0000000050030700 => \%shub2_01_00975_def,
   0x0000000050030710 => \%shub2_01_00976_def,
   0x0000000050030720 => \%shub2_01_00977_def,
   0x0000000050030730 => \%shub2_01_00978_def,
   0x0000000050030740 => \%shub2_01_00979_def,
   0x0000000050030750 => \%shub2_01_00980_def,
   0x0000000050030760 => \%shub2_01_00981_def,
   0x0000000050030770 => \%shub2_01_00982_def,
   0x0000000050031000 => \%shub2_01_00983_def,
   0x0000000050031020 => \%shub2_01_00984_def,
   0x0000000050031040 => \%shub2_01_00985_def,
   0x0000000050031050 => \%shub2_01_00986_def,
   0x0000000050031060 => \%shub2_01_00987_def,
   0x0000000050031100 => \%shub2_01_00988_def,
   0x0000000050031110 => \%shub2_01_00989_def,
   0x0000000050031120 => \%shub2_01_00990_def,
   0x0000000050031130 => \%shub2_01_00991_def,
   0x0000000050031140 => \%shub2_01_00992_def,
   0x0000000050031150 => \%shub2_01_00993_def,
   0x0000000050031160 => \%shub2_01_00994_def,
   0x0000000050031170 => \%shub2_01_00995_def,
   0x0000000050031200 => \%shub2_01_00996_def,
   0x0000000050031210 => \%shub2_01_00997_def,
   0x0000000050031220 => \%shub2_01_00998_def,
   0x0000000050031230 => \%shub2_01_00999_def,
   0x0000000050031240 => \%shub2_01_01000_def,
   0x0000000050031250 => \%shub2_01_01001_def,
   0x0000000050031260 => \%shub2_01_01002_def,
   0x0000000050031270 => \%shub2_01_01003_def,
   0x0000000050031280 => \%shub2_01_01004_def,
   0x0000000050031290 => \%shub2_01_01005_def,
   0x00000000500312A0 => \%shub2_01_01006_def,
   0x00000000500312B0 => \%shub2_01_01007_def,
   0x00000000500312C0 => \%shub2_01_01008_def,
   0x00000000500312D0 => \%shub2_01_01009_def,
   0x00000000500312E0 => \%shub2_01_01010_def,
   0x00000000500312F0 => \%shub2_01_01011_def,
   0x00000000500310C0 => \%shub2_01_01012_def,
   0x0000000050031700 => \%shub2_01_01013_def,
   0x0000000050031710 => \%shub2_01_01014_def,
   0x0000000050031720 => \%shub2_01_01015_def,
   0x0000000050031730 => \%shub2_01_01016_def,
   0x0000000050031740 => \%shub2_01_01017_def,
   0x0000000050031750 => \%shub2_01_01018_def,
   0x0000000050031760 => \%shub2_01_01019_def,
   0x0000000050031770 => \%shub2_01_01020_def,
   0x00000000500317C0 => \%shub2_01_01021_def,
   0x00000000500317D0 => \%shub2_01_01022_def,
   0x00000000500317E0 => \%shub2_01_01023_def,
   0x00000000500317F0 => \%shub2_01_01024_def,
   0x0000000050031800 => \%shub2_01_01025_def,
   0x0000000050031810 => \%shub2_01_01026_def,
   0x0000000050031820 => \%shub2_01_01027_def,
   0x0000000050031830 => \%shub2_01_01028_def,
   0x0000000050031B40 => \%shub2_01_01029_def,
   0x0000000050031B50 => \%shub2_01_01030_def,
   0x0000000050031B60 => \%shub2_01_01031_def,
   0x0000000050031B70 => \%shub2_01_01032_def,
   0x00000000500310E0 => \%shub2_01_01033_def,
   0x0000000050031900 => \%shub2_01_01034_def,
   0x0000000050031910 => \%shub2_01_01035_def,
   0x0000000050031920 => \%shub2_01_01036_def,
   0x0000000050031930 => \%shub2_01_01037_def,
   0x0000000050031940 => \%shub2_01_01038_def,
   0x0000000050031950 => \%shub2_01_01039_def,
   0x0000000050031960 => \%shub2_01_01040_def,
   0x0000000050031970 => \%shub2_01_01041_def,
   0x00000000500319C0 => \%shub2_01_01042_def,
   0x00000000500319D0 => \%shub2_01_01043_def,
   0x00000000500319E0 => \%shub2_01_01044_def,
   0x00000000500319F0 => \%shub2_01_01045_def,
   0x0000000050031A00 => \%shub2_01_01046_def,
   0x0000000050031A10 => \%shub2_01_01047_def,
   0x0000000050031A20 => \%shub2_01_01048_def,
   0x0000000050031A30 => \%shub2_01_01049_def,
   0x0000000050031BC0 => \%shub2_01_01050_def,
   0x0000000050031BD0 => \%shub2_01_01051_def,
   0x0000000050031BE0 => \%shub2_01_01052_def,
   0x0000000050031BF0 => \%shub2_01_01053_def,
   0x00000000500310A0 => \%shub2_01_01054_def,
   0x0000000050031300 => \%shub2_01_01055_def,
   0x0000000050031310 => \%shub2_01_01056_def,
   0x0000000050031320 => \%shub2_01_01057_def,
   0x0000000050031330 => \%shub2_01_01058_def,
   0x0000000050031340 => \%shub2_01_01059_def,
   0x0000000050031350 => \%shub2_01_01060_def,
   0x0000000050031360 => \%shub2_01_01061_def,
   0x0000000050031370 => \%shub2_01_01062_def,
   0x0000000050031380 => \%shub2_01_01063_def,
   0x0000000050031390 => \%shub2_01_01064_def,
   0x00000000500313A0 => \%shub2_01_01065_def,
   0x00000000500313B0 => \%shub2_01_01066_def,
   0x0000000050031400 => \%shub2_01_01067_def,
   0x0000000050031410 => \%shub2_01_01068_def,
   0x0000000050031440 => \%shub2_01_01069_def,
   0x0000000050031450 => \%shub2_01_01070_def,
   0x0000000050031080 => \%shub2_01_01071_def,
   0x0000000050031500 => \%shub2_01_01072_def,
   0x0000000050031510 => \%shub2_01_01073_def,
   0x0000000050031520 => \%shub2_01_01074_def,
   0x0000000050031530 => \%shub2_01_01075_def,
   0x0000000050031540 => \%shub2_01_01076_def,
   0x0000000050031550 => \%shub2_01_01077_def,
   0x0000000050031560 => \%shub2_01_01078_def,
   0x0000000050031570 => \%shub2_01_01079_def,
   0x0000000050031580 => \%shub2_01_01080_def,
   0x0000000050031590 => \%shub2_01_01081_def,
   0x00000000500315A0 => \%shub2_01_01082_def,
   0x00000000500315B0 => \%shub2_01_01083_def,
   0x00000000500315C0 => \%shub2_01_01084_def,
   0x00000000500315D0 => \%shub2_01_01085_def,
   0x00000000500315E0 => \%shub2_01_01086_def,
   0x00000000500315F0 => \%shub2_01_01087_def,
   0x0000000050032000 => \%shub2_01_01088_def,
   0x0000000050032010 => \%shub2_01_01089_def,
   0x0000000050032020 => \%shub2_01_01090_def,
   0x0000000050032030 => \%shub2_01_01091_def,
   0x0000000050032040 => \%shub2_01_01092_def,
   0x0000000050032050 => \%shub2_01_01093_def,
   0x0000000050032060 => \%shub2_01_01094_def,
   0x0000000050032070 => \%shub2_01_01095_def,
   0x0000000050032080 => \%shub2_01_01096_def,
   0x0000000050032090 => \%shub2_01_01097_def,
   0x00000000500320A0 => \%shub2_01_01098_def,
   0x0000000050040500 => \%shub2_01_01099_def,
   0x0000000050040508 => \%shub2_01_01100_def,
   0x0000000050040510 => \%shub2_01_01101_def,
   0x0000000050040518 => \%shub2_01_01102_def,
   0x0000000050040520 => \%shub2_01_01103_def,
   0x0000000050040528 => \%shub2_01_01104_def,
   0x0000000050040530 => \%shub2_01_01105_def,
   0x0000000050040538 => \%shub2_01_01106_def,
   0x0000000050040540 => \%shub2_01_01107_def,
   0x0000000050040550 => \%shub2_01_01108_def,
   0x0000000050040560 => \%shub2_01_01109_def,
   0x0000000050040570 => \%shub2_01_01110_def,
   0x0000000050040580 => \%shub2_01_01111_def,
   0x0000000050040590 => \%shub2_01_01112_def,
   0x0000000050040600 => \%shub2_01_01113_def,
   0x0000000050040608 => \%shub2_01_01114_def,
   0x0000000050040610 => \%shub2_01_01115_def,
   0x0000000050040618 => \%shub2_01_01116_def,
   0x0000000050040620 => \%shub2_01_01117_def,
   0x0000000050040628 => \%shub2_01_01118_def,
   0x0000000050040630 => \%shub2_01_01119_def,
   0x0000000050040638 => \%shub2_01_01120_def,
   0x0000000050040640 => \%shub2_01_01121_def,
   0x0000000050040650 => \%shub2_01_01122_def,
   0x0000000050040660 => \%shub2_01_01123_def,
   0x0000000050040670 => \%shub2_01_01124_def,
   0x0000000050040680 => \%shub2_01_01125_def,
   0x0000000050040690 => \%shub2_01_01126_def,
   0x0000000050040070 => \%shub2_01_01127_def,
   0x0000000050040080 => \%shub2_01_01128_def,
   0x00000000500400A0 => \%shub2_01_01129_def,
   0x00000000500400B0 => \%shub2_01_01130_def,
   0x00000000500400C0 => \%shub2_01_01131_def,
   0x00000000500400D0 => \%shub2_01_01132_def,
   0x00000000500400F0 => \%shub2_01_01133_def,
   0x0000000050040100 => \%shub2_01_01134_def,
   0x0000000050040110 => \%shub2_01_01135_def,
   0x0000000050040120 => \%shub2_01_01136_def,
   0x0000000050040130 => \%shub2_01_01137_def,
   0x0000000050040140 => \%shub2_01_01138_def,
   0x0000000050040150 => \%shub2_01_01139_def,
   0x0000000050040160 => \%shub2_01_01140_def,
   0x0000000050040170 => \%shub2_01_01141_def,
   0x0000000050040000 => \%shub2_01_01142_def,
   0x0000000050040008 => \%shub2_01_01143_def,
   0x0000000050040020 => \%shub2_01_01144_def,
   0x0000000050040028 => \%shub2_01_01145_def,
   0x0000000050040040 => \%shub2_01_01146_def,
   0x0000000050040060 => \%shub2_01_01147_def,
   0x0000000050040200 => \%shub2_01_01148_def,
   0x0000000050040208 => \%shub2_01_01149_def,
   0x0000000050040220 => \%shub2_01_01150_def,
   0x0000000050040228 => \%shub2_01_01151_def,
   0x0000000050040240 => \%shub2_01_01152_def,
   0x0000000050040260 => \%shub2_01_01153_def,
   0x0000000050040210 => \%shub2_01_01154_def,
   0x0000000050040218 => \%shub2_01_01155_def,
   0x0000000050040230 => \%shub2_01_01156_def,
   0x0000000050040238 => \%shub2_01_01157_def,
   0x0000000050040250 => \%shub2_01_01158_def,
   0x0000000050040270 => \%shub2_01_01159_def,
   0x0000000050040300 => \%shub2_01_01160_def,
   0x0000000050040308 => \%shub2_01_01161_def,
   0x0000000050040320 => \%shub2_01_01162_def,
   0x0000000050040328 => \%shub2_01_01163_def,
   0x0000000050040340 => \%shub2_01_01164_def,
   0x0000000050040360 => \%shub2_01_01165_def,
   0x0000000050040400 => \%shub2_01_01166_def,
   0x0000000050040408 => \%shub2_01_01167_def,
   0x0000000050040420 => \%shub2_01_01168_def,
   0x0000000050040428 => \%shub2_01_01169_def,
   0x0000000050040440 => \%shub2_01_01170_def,
   0x0000000050040460 => \%shub2_01_01171_def,
   0x0000000050040410 => \%shub2_01_01172_def,
   0x0000000050040418 => \%shub2_01_01173_def,
   0x0000000050040430 => \%shub2_01_01174_def,
   0x0000000050040438 => \%shub2_01_01175_def,
   0x0000000050040450 => \%shub2_01_01176_def,
   0x0000000050040470 => \%shub2_01_01177_def,
   0x0000000030000000 => \%shub2_01_01178_def,
   0x0000000030000080 => \%shub2_01_01179_def,
   0x0000000030000100 => \%shub2_01_01180_def,
   0x0000000030000180 => \%shub2_01_01181_def,
   0x0000000030000200 => \%shub2_01_01182_def,
   0x0000000030000280 => \%shub2_01_01183_def,
   0x0000000030000800 => \%shub2_01_01184_def,
   0x0000000030000880 => \%shub2_01_01185_def,
   0x0000000030000900 => \%shub2_01_01186_def,
   0x0000000030000980 => \%shub2_01_01187_def,
   0x0000000030001000 => \%shub2_01_01188_def,
   0x0000000030001080 => \%shub2_01_01189_def,
   0x0000000030001100 => \%shub2_01_01190_def,
   0x0000000030001180 => \%shub2_01_01191_def,
   0x0000000030010800 => \%shub2_01_01192_def,
   0x0000000030010880 => \%shub2_01_01193_def,
   0x0000000030010900 => \%shub2_01_01194_def,
   0x0000000030010980 => \%shub2_01_01195_def,
   0x0000000030011000 => \%shub2_01_01196_def,
   0x0000000030011080 => \%shub2_01_01197_def,
   0x0000000030011100 => \%shub2_01_01198_def,
   0x0000000030011180 => \%shub2_01_01199_def,
   0x0000000030011200 => \%shub2_01_01200_def,
   0x0000000030011280 => \%shub2_01_01201_def,
   0x0000000030020000 => \%shub2_01_01202_def,
   0x0000000030020080 => \%shub2_01_01203_def,
   0x0000000030020100 => \%shub2_01_01204_def,
   0x0000000030021000 => \%shub2_01_01205_def,
   0x0000000030021100 => \%shub2_01_01206_def,
   0x0000000030021180 => \%shub2_01_01207_def,
   0x0000000030021200 => \%shub2_01_01208_def,
   0x0000000030030000 => \%shub2_01_01209_def,
   0x0000000030030200 => \%shub2_01_01210_def,
   0x0000000030030400 => \%shub2_01_01211_def,
   0x0000000030030600 => \%shub2_01_01212_def,
   0x0000000030030800 => \%shub2_01_01213_def,
   0x0000000030030A00 => \%shub2_01_01214_def,
   0x0000000030030C00 => \%shub2_01_01215_def,
   0x0000000030030E00 => \%shub2_01_01216_def,
   0x0000000030031000 => \%shub2_01_01217_def,
   0x0000000030031200 => \%shub2_01_01218_def,
   0x0000000030031400 => \%shub2_01_01219_def,
   0x0000000030031600 => \%shub2_01_01220_def,
   0x0000000030031800 => \%shub2_01_01221_def,
   0x0000000030031A00 => \%shub2_01_01222_def,
   0x0000000030031C00 => \%shub2_01_01223_def,
   0x0000000030031E00 => \%shub2_01_01224_def,
   0x0000000030030080 => \%shub2_01_01225_def,
   0x0000000030030280 => \%shub2_01_01226_def,
   0x0000000030030480 => \%shub2_01_01227_def,
   0x0000000030030680 => \%shub2_01_01228_def,
   0x0000000030030880 => \%shub2_01_01229_def,
   0x0000000030030A80 => \%shub2_01_01230_def,
   0x0000000030030C80 => \%shub2_01_01231_def,
   0x0000000030030E80 => \%shub2_01_01232_def,
   0x0000000030031080 => \%shub2_01_01233_def,
   0x0000000030031280 => \%shub2_01_01234_def,
   0x0000000030031480 => \%shub2_01_01235_def,
   0x0000000030031680 => \%shub2_01_01236_def,
   0x0000000030031880 => \%shub2_01_01237_def,
   0x0000000030031A80 => \%shub2_01_01238_def,
   0x0000000030031C80 => \%shub2_01_01239_def,
   0x0000000030031E80 => \%shub2_01_01240_def,
   0x0000000030030100 => \%shub2_01_01241_def,
   0x0000000030030300 => \%shub2_01_01242_def,
   0x0000000030030500 => \%shub2_01_01243_def,
   0x0000000030030700 => \%shub2_01_01244_def,
   0x0000000030030900 => \%shub2_01_01245_def,
   0x0000000030030B00 => \%shub2_01_01246_def,
   0x0000000030030D00 => \%shub2_01_01247_def,
   0x0000000030030F00 => \%shub2_01_01248_def,
   0x0000000030031100 => \%shub2_01_01249_def,
   0x0000000030031300 => \%shub2_01_01250_def,
   0x0000000030031500 => \%shub2_01_01251_def,
   0x0000000030031700 => \%shub2_01_01252_def,
   0x0000000030031900 => \%shub2_01_01253_def,
   0x0000000030031B00 => \%shub2_01_01254_def,
   0x0000000030031D00 => \%shub2_01_01255_def,
   0x0000000030031F00 => \%shub2_01_01256_def,
   0x0000000030040000 => \%shub2_01_01257_def,
   0x0000000030040080 => \%shub2_01_01258_def,
   0x0000000030040100 => \%shub2_01_01259_def,
   0x0000000030040180 => \%shub2_01_01260_def,
   0x0000000030050000 => \%shub2_01_01261_def,
   0x0000000030050080 => \%shub2_01_01262_def,
   0x0000000030050100 => \%shub2_01_01263_def,
   0x0000000030050180 => \%shub2_01_01264_def,
   0x0000000030060000 => \%shub2_01_01265_def,
   0x0000000030060080 => \%shub2_01_01266_def,
   0x0000000030060100 => \%shub2_01_01267_def,
   0x0000000030060180 => \%shub2_01_01268_def,
   0x0000000030070000 => \%shub2_01_01269_def,
   0x0000000030070080 => \%shub2_01_01270_def,
   0x0000000030070100 => \%shub2_01_01271_def,
   0x0000000030070180 => \%shub2_01_01272_def,
   0x0000000020053010 => \%shub2_01_01273_def,
   0x0000000020053018 => \%shub2_01_01274_def,
);

@shub2_01_sorted_mmr_name = 
(
   "SH2_ADDRESS_MODE",
   "SH2_ASIC_TO_L1_DATA",
   "SH2_ASIC_TO_L1_STATUS",
   "SH2_AUTO_REPLY_ENABLE0",
   "SH2_AUTO_REPLY_ENABLE1",
   "SH2_AUTO_REPLY_HEADER0",
   "SH2_AUTO_REPLY_HEADER1",
   "SH2_BT0_INT_CONFIG",
   "SH2_BT0_INT_ENABLE",
   "SH2_BT1_INT_CONFIG",
   "SH2_BT1_INT_ENABLE",
   "SH2_BT2_INT_CONFIG",
   "SH2_BT2_INT_ENABLE",
   "SH2_BT3_INT_CONFIG",
   "SH2_BT3_INT_ENABLE",
   "SH2_BT_CRB_DEST_ADDR_0",
   "SH2_BT_CRB_DEST_ADDR_1",
   "SH2_BT_CRB_DEST_ADDR_10",
   "SH2_BT_CRB_DEST_ADDR_11",
   "SH2_BT_CRB_DEST_ADDR_12",
   "SH2_BT_CRB_DEST_ADDR_13",
   "SH2_BT_CRB_DEST_ADDR_14",
   "SH2_BT_CRB_DEST_ADDR_15",
   "SH2_BT_CRB_DEST_ADDR_2",
   "SH2_BT_CRB_DEST_ADDR_3",
   "SH2_BT_CRB_DEST_ADDR_4",
   "SH2_BT_CRB_DEST_ADDR_5",
   "SH2_BT_CRB_DEST_ADDR_6",
   "SH2_BT_CRB_DEST_ADDR_7",
   "SH2_BT_CRB_DEST_ADDR_8",
   "SH2_BT_CRB_DEST_ADDR_9",
   "SH2_BT_CRB_SRC_ADDR_0",
   "SH2_BT_CRB_SRC_ADDR_1",
   "SH2_BT_CRB_SRC_ADDR_10",
   "SH2_BT_CRB_SRC_ADDR_11",
   "SH2_BT_CRB_SRC_ADDR_12",
   "SH2_BT_CRB_SRC_ADDR_13",
   "SH2_BT_CRB_SRC_ADDR_14",
   "SH2_BT_CRB_SRC_ADDR_15",
   "SH2_BT_CRB_SRC_ADDR_2",
   "SH2_BT_CRB_SRC_ADDR_3",
   "SH2_BT_CRB_SRC_ADDR_4",
   "SH2_BT_CRB_SRC_ADDR_5",
   "SH2_BT_CRB_SRC_ADDR_6",
   "SH2_BT_CRB_SRC_ADDR_7",
   "SH2_BT_CRB_SRC_ADDR_8",
   "SH2_BT_CRB_SRC_ADDR_9",
   "SH2_BT_CRB_STAT_0",
   "SH2_BT_CRB_STAT_1",
   "SH2_BT_CRB_STAT_10",
   "SH2_BT_CRB_STAT_11",
   "SH2_BT_CRB_STAT_12",
   "SH2_BT_CRB_STAT_13",
   "SH2_BT_CRB_STAT_14",
   "SH2_BT_CRB_STAT_15",
   "SH2_BT_CRB_STAT_2",
   "SH2_BT_CRB_STAT_3",
   "SH2_BT_CRB_STAT_4",
   "SH2_BT_CRB_STAT_5",
   "SH2_BT_CRB_STAT_6",
   "SH2_BT_CRB_STAT_7",
   "SH2_BT_CRB_STAT_8",
   "SH2_BT_CRB_STAT_9",
   "SH2_BT_DEBUG_DATA",
   "SH2_BT_DEBUG_MUX_SELECT",
   "SH2_BT_DEBUG_TRIG_COMPARE",
   "SH2_BT_DEBUG_TRIG_ENABLE",
   "SH2_BT_DEBUG_TRIG_SELECT",
   "SH2_BT_ENG_CSR_0",
   "SH2_BT_ENG_CSR_1",
   "SH2_BT_ENG_CSR_2",
   "SH2_BT_ENG_CSR_3",
   "SH2_BT_ENG_DEST_ADDR_0",
   "SH2_BT_ENG_DEST_ADDR_1",
   "SH2_BT_ENG_DEST_ADDR_2",
   "SH2_BT_ENG_DEST_ADDR_3",
   "SH2_BT_ENG_ERROR_STAT",
   "SH2_BT_ENG_NOTIF_ADDR_0",
   "SH2_BT_ENG_NOTIF_ADDR_1",
   "SH2_BT_ENG_NOTIF_ADDR_2",
   "SH2_BT_ENG_NOTIF_ADDR_3",
   "SH2_BT_ENG_SRC_ADDR_0",
   "SH2_BT_ENG_SRC_ADDR_1",
   "SH2_BT_ENG_SRC_ADDR_2",
   "SH2_BT_ENG_SRC_ADDR_3",
   "SH2_BT_ERROR_MASK",
   "SH2_BT_ERROR_OVERFLOW",
   "SH2_BT_ERROR_OVERFLOW_ALIAS",
   "SH2_BT_ERROR_SUMMARY",
   "SH2_BT_ERROR_SUMMARY_ALIAS",
   "SH2_BT_FIRST_ERROR",
   "SH2_BT_HQ_EJECT",
   "SH2_BT_HQ_ENTRY_0",
   "SH2_BT_HQ_VALID_DETAIL",
   "SH2_BT_HW_TIME_STAMP",
   "SH2_BT_IQ_STAT",
   "SH2_BT_NIQ_CREDIT_CFG",
   "SH2_BT_NIQ_DYN_CREDIT_STAT",
   "SH2_BT_NIQ_LAST_CREDIT_STAT",
   "SH2_BT_REQ_NACK_LIMIT",
   "SH2_BT_REQ_PRIORITY",
   "SH2_BT_TIMEOUT_PRESCALE",
   "SH2_BT_TIMEOUT_PULSE",
   "SH2_BT_XMIT_CFG",
   "SH2_BT_XMIT_DYN_CREDIT_STAT",
   "SH2_BT_XMIT_LAST_CREDIT_STAT",
   "SH2_BT_XN_DATA_COMP_0",
   "SH2_BT_XN_DATA_COMP_1",
   "SH2_BT_XN_DATA_ENABLE_0",
   "SH2_BT_XN_DATA_ENABLE_1",
   "SH2_BT_XN_ERROR_DETAIL_1",
   "SH2_BT_XN_ERROR_DETAIL_2",
   "SH2_CFG",
   "SH2_COMPARE_COMPARE_MASK",
   "SH2_COMPARE_COMPARE_PATTERN",
   "SH2_COMPARE_SEL",
   "SH2_CONVEYOR_BELT_CONFIG",
   "SH2_CONVEYOR_BELT_TIME_OUT",
   "SH2_CPU_PERM0",
   "SH2_CPU_PERM1",
   "SH2_CPU_PERM2",
   "SH2_CPU_PERM3",
   "SH2_CPU_PERM_OVR",
   "SH2_CRB_MESSAGE_CONTROL",
   "SH2_CRB_NACK_LIMIT",
   "SH2_CRB_TIMEOUT_PRESCALE",
   "SH2_CRB_TIMEOUT_SKID",
   "SH2_DEBUG_PORT",
   "SH2_DEBUG_PORT_CONFIG",
   "SH2_DEBUG_SELECT",
   "SH2_DIAG_MSG_CNTRL",
   "SH2_DIAG_MSG_DATA0L",
   "SH2_DIAG_MSG_DATA0U",
   "SH2_DIAG_MSG_DATA1L",
   "SH2_DIAG_MSG_DATA1U",
   "SH2_DIAG_MSG_DATA2L",
   "SH2_DIAG_MSG_DATA2U",
   "SH2_DIAG_MSG_DATA3L",
   "SH2_DIAG_MSG_DATA3U",
   "SH2_DIAG_MSG_DATA4L",
   "SH2_DIAG_MSG_DATA4U",
   "SH2_DIAG_MSG_DATA5L",
   "SH2_DIAG_MSG_DATA5U",
   "SH2_DIAG_MSG_DATA6L",
   "SH2_DIAG_MSG_DATA6U",
   "SH2_DIAG_MSG_DATA7L",
   "SH2_DIAG_MSG_DATA7U",
   "SH2_DIAG_MSG_DATA8L",
   "SH2_DIAG_MSG_DATA8U",
   "SH2_DIAG_MSG_HDR0",
   "SH2_DIAG_MSG_HDR1",
   "SH2_DIR_COR_ADRS_ERR_HDR_LOWER_A",
   "SH2_DIR_COR_ERR_HDR_LOWER",
   "SH2_DIR_COR_ERR_HDR_UPPER",
   "SH2_DIR_UC_ADRS_ERR_HDR_LOWER_A",
   "SH2_DIR_UC_ERR_HDR_LOWER",
   "SH2_DIR_UC_ERR_HDR_UPPER",
   "SH2_ENABLE_RP_AUTO_REPLY",
   "SH2_ENABLE_RQ_AUTO_REPLY",
   "SH2_EVENT_OCCURRED",
   "SH2_EVENT_OCCURRED_ALIAS",
   "SH2_EVENT_OVERFLOW",
   "SH2_EVENT_OVERFLOW_ALIAS",
   "SH2_EXTIO_INT0",
   "SH2_EXTIO_INT0_CONFIG",
   "SH2_EXTIO_INT0_ENABLE",
   "SH2_EXTIO_INT1",
   "SH2_EXTIO_INT1_CONFIG",
   "SH2_EXTIO_INT1_ENABLE",
   "SH2_EXTIO_INT2",
   "SH2_EXTIO_INT2_CONFIG",
   "SH2_EXTIO_INT2_ENABLE",
   "SH2_EXTIO_INT3",
   "SH2_EXTIO_INT3_CONFIG",
   "SH2_EXTIO_INT3_ENABLE",
   "SH2_EXT_IOI_ACCESS0",
   "SH2_EXT_IOI_ACCESS1",
   "SH2_EXT_IOI_ACCESS2",
   "SH2_EXT_IOI_ACCESS3",
   "SH2_EXT_IO_PERM0",
   "SH2_EXT_IO_PERM1",
   "SH2_EXT_IO_PERM2",
   "SH2_EXT_IO_PERM3",
   "SH2_FIRMWARE_REMAP",
   "SH2_FIRST_ERROR",
   "SH2_FSB_BINIT_CONTROL",
   "SH2_FSB_IO_READ_TRANS",
   "SH2_FSB_IO_READ_TRANS_ODD",
   "SH2_FSB_POWER_ON_CONFIG",
   "SH2_FSB_RESET_CONTROL",
   "SH2_FSB_RESET_STATUS",
   "SH2_FSB_SYMMETRIC_AGENT_STATUS",
   "SH2_FSB_SYSTEM_AGENT_CONFIG",
   "SH2_GC_FIL_CTRL",
   "SH2_GC_SRC_CTRL",
   "SH2_HARD_RESET",
   "SH2_IILB_GLOBAL_TABLE",
   "SH2_IILB_LOCAL_TABLE",
   "SH2_IILB_OVER_RIDE_TABLE",
   "SH2_INT_CMPA",
   "SH2_INT_CMPB",
   "SH2_INT_CMPC",
   "SH2_INT_CMPD",
   "SH2_INT_NODE_ID_CONFIG",
   "SH2_INT_PROF",
   "SH2_IPI_ACCESS0",
   "SH2_IPI_ACCESS1",
   "SH2_IPI_ACCESS2",
   "SH2_IPI_ACCESS3",
   "SH2_IPI_INT",
   "SH2_IPI_INT_ENABLE",
   "SH2_JNR_DIMM_CFG",
   "SH2_JTAG_CONFIG0",
   "SH2_JTAG_CONFIG1",
   "SH2_JUNK_BUS_LED0",
   "SH2_JUNK_BUS_LED1",
   "SH2_JUNK_BUS_LED2",
   "SH2_JUNK_BUS_LED3",
   "SH2_JUNK_BUS_TIME",
   "SH2_JUNK_NACK_RESET",
   "SH2_L1_TO_ASIC_DATA",
   "SH2_L1_TO_ASIC_STATUS",
   "SH2_LB_COMPARE_COMPARE",
   "SH2_LB_COMPARE_DATA",
   "SH2_LB_CREDIT_STATUS",
   "SH2_LB_DEBUG_COMPARE_SEL",
   "SH2_LB_DEBUG_DATA",
   "SH2_LB_DEBUG_LOCAL_SEL",
   "SH2_LB_DEBUG_MUX0_SEL",
   "SH2_LB_DEBUG_MUX1_SEL",
   "SH2_LB_ERROR_DETAIL_1",
   "SH2_LB_ERROR_DETAIL_2",
   "SH2_LB_ERROR_DETAIL_3",
   "SH2_LB_ERROR_DETAIL_4",
   "SH2_LB_ERROR_DETAIL_5",
   "SH2_LB_ERROR_DETAIL_6",
   "SH2_LB_ERROR_MASK",
   "SH2_LB_ERROR_OVERFLOW",
   "SH2_LB_ERROR_OVERFLOW_ALIAS",
   "SH2_LB_ERROR_SUMMARY",
   "SH2_LB_ERROR_SUMMARY_ALIAS",
   "SH2_LB_FIRST_ERROR",
   "SH2_LB_HW_TIME_STAMP",
   "SH2_LB_LAST_CREDIT",
   "SH2_LB_LIQ_CTL",
   "SH2_LB_LOQ_CTL",
   "SH2_LB_MAX_REP_CREDIT_CNT",
   "SH2_LB_MAX_REQ_CREDIT_CNT",
   "SH2_LB_NACK_STATUS0",
   "SH2_LB_NACK_STATUS1",
   "SH2_LB_NACK_STATUS2",
   "SH2_LB_NACK_STATUS3",
   "SH2_LB_PI_GCLK_SEL",
   "SH2_LOCAL_INT0_CONFIG",
   "SH2_LOCAL_INT0_ENABLE",
   "SH2_LOCAL_INT1_CONFIG",
   "SH2_LOCAL_INT1_ENABLE",
   "SH2_LOCAL_INT2_CONFIG",
   "SH2_LOCAL_INT2_ENABLE",
   "SH2_LOCAL_INT3_CONFIG",
   "SH2_LOCAL_INT3_ENABLE",
   "SH2_LOCAL_INT4_CONFIG",
   "SH2_LOCAL_INT4_ENABLE",
   "SH2_LOCAL_INT5_CONFIG",
   "SH2_LOCAL_INT5_ENABLE",
   "SH2_LOCAL_INT6_CONFIG",
   "SH2_LOCAL_INT6_ENABLE",
   "SH2_LOCAL_INT7_CONFIG",
   "SH2_LOCAL_INT7_ENABLE",
   "SH2_LOCAL_INT8_CONFIG",
   "SH2_LOCAL_INT8_ENABLE",
   "SH2_LOCAL_INT9_CONFIG",
   "SH2_LOCAL_INT9_ENABLE",
   "SH2_LOGIC_ANALYZER_BUFFER",
   "SH2_MCAST_DEST_0A",
   "SH2_MCAST_DEST_0B",
   "SH2_MCAST_DEST_100A",
   "SH2_MCAST_DEST_100B",
   "SH2_MCAST_DEST_101A",
   "SH2_MCAST_DEST_101B",
   "SH2_MCAST_DEST_102A",
   "SH2_MCAST_DEST_102B",
   "SH2_MCAST_DEST_103A",
   "SH2_MCAST_DEST_103B",
   "SH2_MCAST_DEST_104A",
   "SH2_MCAST_DEST_104B",
   "SH2_MCAST_DEST_105A",
   "SH2_MCAST_DEST_105B",
   "SH2_MCAST_DEST_106A",
   "SH2_MCAST_DEST_106B",
   "SH2_MCAST_DEST_107A",
   "SH2_MCAST_DEST_107B",
   "SH2_MCAST_DEST_108A",
   "SH2_MCAST_DEST_108B",
   "SH2_MCAST_DEST_109A",
   "SH2_MCAST_DEST_109B",
   "SH2_MCAST_DEST_10A",
   "SH2_MCAST_DEST_10B",
   "SH2_MCAST_DEST_110A",
   "SH2_MCAST_DEST_110B",
   "SH2_MCAST_DEST_111A",
   "SH2_MCAST_DEST_111B",
   "SH2_MCAST_DEST_112A",
   "SH2_MCAST_DEST_112B",
   "SH2_MCAST_DEST_113A",
   "SH2_MCAST_DEST_113B",
   "SH2_MCAST_DEST_114A",
   "SH2_MCAST_DEST_114B",
   "SH2_MCAST_DEST_115A",
   "SH2_MCAST_DEST_115B",
   "SH2_MCAST_DEST_116A",
   "SH2_MCAST_DEST_116B",
   "SH2_MCAST_DEST_117A",
   "SH2_MCAST_DEST_117B",
   "SH2_MCAST_DEST_118A",
   "SH2_MCAST_DEST_118B",
   "SH2_MCAST_DEST_119A",
   "SH2_MCAST_DEST_119B",
   "SH2_MCAST_DEST_11A",
   "SH2_MCAST_DEST_11B",
   "SH2_MCAST_DEST_120A",
   "SH2_MCAST_DEST_120B",
   "SH2_MCAST_DEST_121A",
   "SH2_MCAST_DEST_121B",
   "SH2_MCAST_DEST_122A",
   "SH2_MCAST_DEST_122B",
   "SH2_MCAST_DEST_123A",
   "SH2_MCAST_DEST_123B",
   "SH2_MCAST_DEST_124A",
   "SH2_MCAST_DEST_124B",
   "SH2_MCAST_DEST_125A",
   "SH2_MCAST_DEST_125B",
   "SH2_MCAST_DEST_126A",
   "SH2_MCAST_DEST_126B",
   "SH2_MCAST_DEST_127A",
   "SH2_MCAST_DEST_127B",
   "SH2_MCAST_DEST_128A",
   "SH2_MCAST_DEST_128B",
   "SH2_MCAST_DEST_129A",
   "SH2_MCAST_DEST_129B",
   "SH2_MCAST_DEST_12A",
   "SH2_MCAST_DEST_12B",
   "SH2_MCAST_DEST_130A",
   "SH2_MCAST_DEST_130B",
   "SH2_MCAST_DEST_131A",
   "SH2_MCAST_DEST_131B",
   "SH2_MCAST_DEST_13A",
   "SH2_MCAST_DEST_13B",
   "SH2_MCAST_DEST_14A",
   "SH2_MCAST_DEST_14B",
   "SH2_MCAST_DEST_15A",
   "SH2_MCAST_DEST_15B",
   "SH2_MCAST_DEST_16A",
   "SH2_MCAST_DEST_16B",
   "SH2_MCAST_DEST_17A",
   "SH2_MCAST_DEST_17B",
   "SH2_MCAST_DEST_18A",
   "SH2_MCAST_DEST_18B",
   "SH2_MCAST_DEST_19A",
   "SH2_MCAST_DEST_19B",
   "SH2_MCAST_DEST_1A",
   "SH2_MCAST_DEST_1B",
   "SH2_MCAST_DEST_20A",
   "SH2_MCAST_DEST_20B",
   "SH2_MCAST_DEST_21A",
   "SH2_MCAST_DEST_21B",
   "SH2_MCAST_DEST_22A",
   "SH2_MCAST_DEST_22B",
   "SH2_MCAST_DEST_23A",
   "SH2_MCAST_DEST_23B",
   "SH2_MCAST_DEST_24A",
   "SH2_MCAST_DEST_24B",
   "SH2_MCAST_DEST_25A",
   "SH2_MCAST_DEST_25B",
   "SH2_MCAST_DEST_26A",
   "SH2_MCAST_DEST_26B",
   "SH2_MCAST_DEST_27A",
   "SH2_MCAST_DEST_27B",
   "SH2_MCAST_DEST_28A",
   "SH2_MCAST_DEST_28B",
   "SH2_MCAST_DEST_29A",
   "SH2_MCAST_DEST_29B",
   "SH2_MCAST_DEST_2A",
   "SH2_MCAST_DEST_2B",
   "SH2_MCAST_DEST_30A",
   "SH2_MCAST_DEST_30B",
   "SH2_MCAST_DEST_31A",
   "SH2_MCAST_DEST_31B",
   "SH2_MCAST_DEST_3A",
   "SH2_MCAST_DEST_3B",
   "SH2_MCAST_DEST_4A",
   "SH2_MCAST_DEST_4B",
   "SH2_MCAST_DEST_5A",
   "SH2_MCAST_DEST_5B",
   "SH2_MCAST_DEST_6A",
   "SH2_MCAST_DEST_6B",
   "SH2_MCAST_DEST_7A",
   "SH2_MCAST_DEST_7B",
   "SH2_MCAST_DEST_8A",
   "SH2_MCAST_DEST_8B",
   "SH2_MCAST_DEST_9A",
   "SH2_MCAST_DEST_9B",
   "SH2_MCAST_INV_CONFIG",
   "SH2_MCAST_MASK",
   "SH2_MD_COR_TIME_STAMP",
   "SH2_MD_DBUG_COMPARE",
   "SH2_MD_DBUG_DATA_CFG",
   "SH2_MD_DBUG_TRIGGER_CFG",
   "SH2_MD_DEBUG_DATA",
   "SH2_MD_DQLP_MMR_AMO_CFG",
   "SH2_MD_DQLP_MMR_DIR_CMDTRIG",
   "SH2_MD_DQLP_MMR_DIR_CONFIG",
   "SH2_MD_DQLP_MMR_DIR_LOCVEC0",
   "SH2_MD_DQLP_MMR_DIR_LOCVEC1",
   "SH2_MD_DQLP_MMR_DIR_LOCVEC2",
   "SH2_MD_DQLP_MMR_DIR_LOCVEC3",
   "SH2_MD_DQLP_MMR_DIR_LOCVEC4",
   "SH2_MD_DQLP_MMR_DIR_LOCVEC5",
   "SH2_MD_DQLP_MMR_DIR_LOCVEC6",
   "SH2_MD_DQLP_MMR_DIR_LOCVEC7",
   "SH2_MD_DQLP_MMR_DIR_PRESVEC0",
   "SH2_MD_DQLP_MMR_DIR_PRESVEC1",
   "SH2_MD_DQLP_MMR_DIR_PRESVEC2",
   "SH2_MD_DQLP_MMR_DIR_PRESVEC3",
   "SH2_MD_DQLP_MMR_DIR_PRIVEC0",
   "SH2_MD_DQLP_MMR_DIR_PRIVEC1",
   "SH2_MD_DQLP_MMR_DIR_PRIVEC2",
   "SH2_MD_DQLP_MMR_DIR_PRIVEC3",
   "SH2_MD_DQLP_MMR_DIR_PRIVEC4",
   "SH2_MD_DQLP_MMR_DIR_PRIVEC5",
   "SH2_MD_DQLP_MMR_DIR_PRIVEC6",
   "SH2_MD_DQLP_MMR_DIR_PRIVEC7",
   "SH2_MD_DQLP_MMR_DIR_TBLMASK",
   "SH2_MD_DQLP_MMR_DIR_TBLTRIG",
   "SH2_MD_DQLP_MMR_DIR_TIMER",
   "SH2_MD_DQLP_MMR_PIOWD_DIR_ECC",
   "SH2_MD_DQLP_MMR_PIOWD_DIR_ENTRY",
   "SH2_MD_DQLP_MMR_XBIST_ERR_H",
   "SH2_MD_DQLP_MMR_XBIST_ERR_L",
   "SH2_MD_DQLP_MMR_XBIST_H",
   "SH2_MD_DQLP_MMR_XBIST_L",
   "SH2_MD_DQLP_MMR_XBIST_MASK",
   "SH2_MD_DQLP_MMR_XCERR1",
   "SH2_MD_DQLP_MMR_XCERR2",
   "SH2_MD_DQLP_MMR_XPERR0",
   "SH2_MD_DQLP_MMR_XPERR1",
   "SH2_MD_DQLP_MMR_XPIORD_XDIR_ECC",
   "SH2_MD_DQLP_MMR_XPIORD_XDIR_ENTRY",
   "SH2_MD_DQLP_MMR_XUERR1",
   "SH2_MD_DQLP_MMR_XUERR2",
   "SH2_MD_DQLP_MMR_YBIST_ERR_H",
   "SH2_MD_DQLP_MMR_YBIST_ERR_L",
   "SH2_MD_DQLP_MMR_YBIST_H",
   "SH2_MD_DQLP_MMR_YBIST_L",
   "SH2_MD_DQLP_MMR_YBIST_MASK",
   "SH2_MD_DQLP_MMR_YCERR1",
   "SH2_MD_DQLP_MMR_YCERR2",
   "SH2_MD_DQLP_MMR_YPERR0",
   "SH2_MD_DQLP_MMR_YPERR1",
   "SH2_MD_DQLP_MMR_YPIORD_YDIR_ECC",
   "SH2_MD_DQLP_MMR_YPIORD_YDIR_ENTRY",
   "SH2_MD_DQLP_MMR_YUERR1",
   "SH2_MD_DQLP_MMR_YUERR2",
   "SH2_MD_DQLS_MMR_AMO_CFG",
   "SH2_MD_DQLS_MMR_JNR_DEBUG",
   "SH2_MD_DQLS_MMR_XAMOPW_ERR",
   "SH2_MD_DQLS_MMR_XBIST_ERR_H",
   "SH2_MD_DQLS_MMR_XBIST_ERR_L",
   "SH2_MD_DQLS_MMR_XBIST_H",
   "SH2_MD_DQLS_MMR_XBIST_L",
   "SH2_MD_DQLS_MMR_XBIST_MASK",
   "SH2_MD_DQLS_MMR_YBIST_ERR_H",
   "SH2_MD_DQLS_MMR_YBIST_ERR_L",
   "SH2_MD_DQLS_MMR_YBIST_H",
   "SH2_MD_DQLS_MMR_YBIST_L",
   "SH2_MD_DQLS_MMR_YBIST_MASK",
   "SH2_MD_DQRP_MMR_AMO_CFG",
   "SH2_MD_DQRP_MMR_DIR_CMDTRIG",
   "SH2_MD_DQRP_MMR_DIR_CONFIG",
   "SH2_MD_DQRP_MMR_DIR_LOCVEC0",
   "SH2_MD_DQRP_MMR_DIR_LOCVEC1",
   "SH2_MD_DQRP_MMR_DIR_LOCVEC2",
   "SH2_MD_DQRP_MMR_DIR_LOCVEC3",
   "SH2_MD_DQRP_MMR_DIR_LOCVEC4",
   "SH2_MD_DQRP_MMR_DIR_LOCVEC5",
   "SH2_MD_DQRP_MMR_DIR_LOCVEC6",
   "SH2_MD_DQRP_MMR_DIR_LOCVEC7",
   "SH2_MD_DQRP_MMR_DIR_PRESVEC0",
   "SH2_MD_DQRP_MMR_DIR_PRESVEC1",
   "SH2_MD_DQRP_MMR_DIR_PRESVEC2",
   "SH2_MD_DQRP_MMR_DIR_PRESVEC3",
   "SH2_MD_DQRP_MMR_DIR_PRIVEC0",
   "SH2_MD_DQRP_MMR_DIR_PRIVEC1",
   "SH2_MD_DQRP_MMR_DIR_PRIVEC2",
   "SH2_MD_DQRP_MMR_DIR_PRIVEC3",
   "SH2_MD_DQRP_MMR_DIR_PRIVEC4",
   "SH2_MD_DQRP_MMR_DIR_PRIVEC5",
   "SH2_MD_DQRP_MMR_DIR_PRIVEC6",
   "SH2_MD_DQRP_MMR_DIR_PRIVEC7",
   "SH2_MD_DQRP_MMR_DIR_TBLMASK",
   "SH2_MD_DQRP_MMR_DIR_TBLTRIG",
   "SH2_MD_DQRP_MMR_DIR_TIMER",
   "SH2_MD_DQRP_MMR_PIOWD_DIR_ECC",
   "SH2_MD_DQRP_MMR_PIOWD_DIR_ENTRY",
   "SH2_MD_DQRP_MMR_XBIST_ERR_H",
   "SH2_MD_DQRP_MMR_XBIST_ERR_L",
   "SH2_MD_DQRP_MMR_XBIST_H",
   "SH2_MD_DQRP_MMR_XBIST_L",
   "SH2_MD_DQRP_MMR_XBIST_MASK",
   "SH2_MD_DQRP_MMR_XCERR1",
   "SH2_MD_DQRP_MMR_XCERR2",
   "SH2_MD_DQRP_MMR_XPERR0",
   "SH2_MD_DQRP_MMR_XPERR1",
   "SH2_MD_DQRP_MMR_XPIORD_XDIR_ECC",
   "SH2_MD_DQRP_MMR_XPIORD_XDIR_ENTRY",
   "SH2_MD_DQRP_MMR_XUERR1",
   "SH2_MD_DQRP_MMR_XUERR2",
   "SH2_MD_DQRP_MMR_YBIST_ERR_H",
   "SH2_MD_DQRP_MMR_YBIST_ERR_L",
   "SH2_MD_DQRP_MMR_YBIST_H",
   "SH2_MD_DQRP_MMR_YBIST_L",
   "SH2_MD_DQRP_MMR_YBIST_MASK",
   "SH2_MD_DQRP_MMR_YCERR1",
   "SH2_MD_DQRP_MMR_YCERR2",
   "SH2_MD_DQRP_MMR_YPERR0",
   "SH2_MD_DQRP_MMR_YPERR1",
   "SH2_MD_DQRP_MMR_YPIORD_YDIR_ECC",
   "SH2_MD_DQRP_MMR_YPIORD_YDIR_ENTRY",
   "SH2_MD_DQRP_MMR_YUERR1",
   "SH2_MD_DQRP_MMR_YUERR2",
   "SH2_MD_DQRS_MMR_AMO_CFG",
   "SH2_MD_DQRS_MMR_JNR_DEBUG",
   "SH2_MD_DQRS_MMR_XBIST_ERR_H",
   "SH2_MD_DQRS_MMR_XBIST_ERR_L",
   "SH2_MD_DQRS_MMR_XBIST_H",
   "SH2_MD_DQRS_MMR_XBIST_L",
   "SH2_MD_DQRS_MMR_XBIST_MASK",
   "SH2_MD_DQRS_MMR_YAMOPW_ERR",
   "SH2_MD_DQRS_MMR_YBIST_ERR_H",
   "SH2_MD_DQRS_MMR_YBIST_ERR_L",
   "SH2_MD_DQRS_MMR_YBIST_H",
   "SH2_MD_DQRS_MMR_YBIST_L",
   "SH2_MD_DQRS_MMR_YBIST_MASK",
   "SH2_MD_GLOBAL_TABLE",
   "SH2_MD_HW_TIME_STAMP",
   "SH2_MD_JNR_DBUG_DATA_CFG",
   "SH2_MD_LAST_CREDIT",
   "SH2_MD_LOCAL_TABLE",
   "SH2_MD_OVER_RIDE_TABLE",
   "SH2_MD_RSP_PLANE_HINT",
   "SH2_MD_UNCOR_TIME_STAMP",
   "SH2_MEMORY_WRITE_STATUS_00",
   "SH2_MEMORY_WRITE_STATUS_01",
   "SH2_MEMORY_WRITE_STATUS_10",
   "SH2_MEMORY_WRITE_STATUS_11",
   "SH2_MEMORY_WRITE_STATUS_NON_USER_00",
   "SH2_MEMORY_WRITE_STATUS_NON_USER_01",
   "SH2_MEMORY_WRITE_STATUS_NON_USER_10",
   "SH2_MEMORY_WRITE_STATUS_NON_USER_11",
   "SH2_MEM_CAPTURE_ADDR",
   "SH2_MEM_CAPTURE_HDR",
   "SH2_MEM_CAPTURE_HDR_ADDR",
   "SH2_MEM_CAPTURE_MASK",
   "SH2_MEM_CREDITS",
   "SH2_MEM_ERROR_MASK",
   "SH2_MEM_ERROR_OVERFLOW",
   "SH2_MEM_ERROR_OVERFLOW_ALIAS",
   "SH2_MEM_ERROR_SUMMARY",
   "SH2_MEM_ERROR_SUMMARY_ALIAS",
   "SH2_MEM_FIRST_ERROR",
   "SH2_MEM_FIRST_ERROR_ALIAS",
   "SH2_MEM_REDUCE_XN_TNUMS",
   "SH2_MEM_RED_BLACK",
   "SH2_MISC_ADRS_ERR_HDR_LOWER_A",
   "SH2_MISC_ERR_HDR_LOWER",
   "SH2_MISC_ERR_HDR_UPPER",
   "SH2_MISC_MEM_CFG",
   "SH2_MMRBIST_BASE",
   "SH2_MMRBIST_CTL",
   "SH2_MMRBIST_ERR",
   "SH2_NI0_ERROR_DETAIL_1",
   "SH2_NI0_ERROR_DETAIL_2",
   "SH2_NI0_ERROR_DETAIL_3",
   "SH2_NI0_ERROR_MASK_1",
   "SH2_NI0_ERROR_MASK_2",
   "SH2_NI0_ERROR_OVERFLOW_1",
   "SH2_NI0_ERROR_OVERFLOW_1_ALIAS",
   "SH2_NI0_ERROR_OVERFLOW_2",
   "SH2_NI0_ERROR_OVERFLOW_2_ALIAS",
   "SH2_NI0_ERROR_SUMMARY_1",
   "SH2_NI0_ERROR_SUMMARY_1_ALIAS",
   "SH2_NI0_ERROR_SUMMARY_2",
   "SH2_NI0_ERROR_SUMMARY_2_ALIAS",
   "SH2_NI0_FIRST_ERROR_1",
   "SH2_NI0_FIRST_ERROR_2",
   "SH2_NI0_GLOBAL_TABLE",
   "SH2_NI0_LLP_CAPT_SBCB",
   "SH2_NI0_LLP_CAPT_WD1",
   "SH2_NI0_LLP_CAPT_WD2",
   "SH2_NI0_LLP_CHAN_MODE",
   "SH2_NI0_LLP_CONFIG",
   "SH2_NI0_LLP_ERR",
   "SH2_NI0_LLP_ERR1",
   "SH2_NI0_LLP_ERR2",
   "SH2_NI0_LLP_PKT",
   "SH2_NI0_LLP_RESET",
   "SH2_NI0_LLP_RESET_EN",
   "SH2_NI0_LLP_STAT",
   "SH2_NI0_LLP_TEST_CTL",
   "SH2_NI0_LOCAL_TABLE",
   "SH2_NI0_OVER_RIDE_TABLE",
   "SH2_NI1_ERROR_DETAIL_1",
   "SH2_NI1_ERROR_DETAIL_2",
   "SH2_NI1_ERROR_DETAIL_3",
   "SH2_NI1_ERROR_MASK_1",
   "SH2_NI1_ERROR_MASK_2",
   "SH2_NI1_ERROR_OVERFLOW_1",
   "SH2_NI1_ERROR_OVERFLOW_1_ALIAS",
   "SH2_NI1_ERROR_OVERFLOW_2",
   "SH2_NI1_ERROR_OVERFLOW_2_ALIAS",
   "SH2_NI1_ERROR_SUMMARY_1",
   "SH2_NI1_ERROR_SUMMARY_1_ALIAS",
   "SH2_NI1_ERROR_SUMMARY_2",
   "SH2_NI1_ERROR_SUMMARY_2_ALIAS",
   "SH2_NI1_FIRST_ERROR_1",
   "SH2_NI1_FIRST_ERROR_2",
   "SH2_NI1_GLOBAL_TABLE",
   "SH2_NI1_LLP_CAPT_SBCB",
   "SH2_NI1_LLP_CAPT_WD1",
   "SH2_NI1_LLP_CAPT_WD2",
   "SH2_NI1_LLP_CHAN_MODE",
   "SH2_NI1_LLP_CONFIG",
   "SH2_NI1_LLP_ERR",
   "SH2_NI1_LLP_ERR1",
   "SH2_NI1_LLP_ERR2",
   "SH2_NI1_LLP_PKT",
   "SH2_NI1_LLP_RESET",
   "SH2_NI1_LLP_RESET_EN",
   "SH2_NI1_LLP_STAT",
   "SH2_NI1_LLP_TEST_CTL",
   "SH2_NI1_LOCAL_TABLE",
   "SH2_NI1_OVER_RIDE_TABLE",
   "SH2_NODE_ID",
   "SH2_NODE_PRESENT_TABLE",
   "SH2_NOTIFICATION_MEMORY_INT0_CONFIG",
   "SH2_NOTIFICATION_MEMORY_INT0_ENABLE",
   "SH2_NOTIFICATION_MEMORY_INT1_CONFIG",
   "SH2_NOTIFICATION_MEMORY_INT1_ENABLE",
   "SH2_NOTIFICATION_MEMORY_INT2_CONFIG",
   "SH2_NOTIFICATION_MEMORY_INT2_ENABLE",
   "SH2_NOTIFICATION_MEMORY_INT3_CONFIG",
   "SH2_NOTIFICATION_MEMORY_INT3_ENABLE",
   "SH2_OB_LA_CONTROL",
   "SH2_OB_LA_CURRENT_ADDR",
   "SH2_OB_LA_END_ADDRESS",
   "SH2_OB_LA_SEQUENCE",
   "SH2_OB_LA_START_ADDRESS",
   "SH2_OB_LA_START_CONTROL",
   "SH2_OB_LA_STATUS",
   "SH2_OB_LA_STOP_CONTROL",
   "SH2_PERFORMANCE_COUNT0_CONTROL",
   "SH2_PERFORMANCE_COUNT1_CONTROL",
   "SH2_PERFORMANCE_COUNT2_CONTROL",
   "SH2_PERFORMANCE_COUNT3_CONTROL",
   "SH2_PERFORMANCE_COUNT4_CONTROL",
   "SH2_PERFORMANCE_COUNT5_CONTROL",
   "SH2_PERFORMANCE_COUNT6_CONTROL",
   "SH2_PERFORMANCE_COUNT7_CONTROL",
   "SH2_PERFORMANCE_COUNTER0",
   "SH2_PERFORMANCE_COUNTER1",
   "SH2_PERFORMANCE_COUNTER2",
   "SH2_PERFORMANCE_COUNTER3",
   "SH2_PERFORMANCE_COUNTER4",
   "SH2_PERFORMANCE_COUNTER5",
   "SH2_PERFORMANCE_COUNTER6",
   "SH2_PERFORMANCE_COUNTER7",
   "SH2_PERFORMANCE_MONITOR_DESKEW",
   "SH2_PIO_NACK_RESET",
   "SH2_PIO_RQ_CRD_CTL",
   "SH2_PIO_TIME_OUT",
   "SH2_PIO_WC_WRITE_STATUS_00",
   "SH2_PIO_WC_WRITE_STATUS_00_ALIAS",
   "SH2_PIO_WC_WRITE_STATUS_01",
   "SH2_PIO_WC_WRITE_STATUS_01_ALIAS",
   "SH2_PIO_WC_WRITE_STATUS_10",
   "SH2_PIO_WC_WRITE_STATUS_10_ALIAS",
   "SH2_PIO_WC_WRITE_STATUS_11",
   "SH2_PIO_WC_WRITE_STATUS_11_ALIAS",
   "SH2_PIO_WRITE_STATUS_00",
   "SH2_PIO_WRITE_STATUS_00_ALIAS",
   "SH2_PIO_WRITE_STATUS_01",
   "SH2_PIO_WRITE_STATUS_01_ALIAS",
   "SH2_PIO_WRITE_STATUS_10",
   "SH2_PIO_WRITE_STATUS_10_ALIAS",
   "SH2_PIO_WRITE_STATUS_11",
   "SH2_PIO_WRITE_STATUS_11_ALIAS",
   "SH2_PI_AFI_ERROR_MASK",
   "SH2_PI_AFI_FIRST_ERROR",
   "SH2_PI_AUTO_REPLY_ENABLE",
   "SH2_PI_CAM_ADDRESS_READ_DATA",
   "SH2_PI_CAM_CONTROL",
   "SH2_PI_CAM_LPRA_READ_DATA",
   "SH2_PI_CAM_STATE_READ_DATA",
   "SH2_PI_CORRECTED_DETAIL_1",
   "SH2_PI_CORRECTED_DETAIL_2",
   "SH2_PI_CORRECTED_DETAIL_3",
   "SH2_PI_CORRECTED_DETAIL_4",
   "SH2_PI_CORRECTED_DETAIL_5",
   "SH2_PI_CORRECTED_DETAIL_6",
   "SH2_PI_COR_TIME_STAMP",
   "SH2_PI_CRBC_TEST_POINT_COMPARE",
   "SH2_PI_CRBC_TEST_POINT_SELECT",
   "SH2_PI_CRBC_TEST_POINT_TRIGGER_SELECT",
   "SH2_PI_CRBP_ERROR_MASK",
   "SH2_PI_CRBP_FIRST_ERROR",
   "SH2_PI_CRBP_FSB_PIPE_COMPARE",
   "SH2_PI_CRBP_FSB_PIPE_MASK",
   "SH2_PI_CRBP_TEST_POINT_COMPARE",
   "SH2_PI_CRBP_TEST_POINT_SELECT",
   "SH2_PI_CRBP_TEST_POINT_TRIGGER_SELECT",
   "SH2_PI_CRBP_XB_PIPE_COMPARE_0",
   "SH2_PI_CRBP_XB_PIPE_COMPARE_1",
   "SH2_PI_CRBP_XB_PIPE_MASK_0",
   "SH2_PI_CRBP_XB_PIPE_MASK_1",
   "SH2_PI_CRB_STALL_SKID",
   "SH2_PI_DEBUG_DATA",
   "SH2_PI_DPC_QUEUE_CONFIG",
   "SH2_PI_ERROR_DETAIL_1",
   "SH2_PI_ERROR_DETAIL_2",
   "SH2_PI_ERROR_MASK",
   "SH2_PI_ERROR_OVERFLOW",
   "SH2_PI_ERROR_OVERFLOW_ALIAS",
   "SH2_PI_ERROR_SUMMARY",
   "SH2_PI_ERROR_SUMMARY_ALIAS",
   "SH2_PI_FIRST_ERROR",
   "SH2_PI_FIRST_ERROR_ALIAS",
   "SH2_PI_FSBC_CTP_COMPARATOR",
   "SH2_PI_FSBC_CTP_COMPARATOR_OPERAND",
   "SH2_PI_FSBC_CTP_DEBUG_PORT",
   "SH2_PI_FSBC_FTP_COMPARATOR",
   "SH2_PI_FSBC_FTP_COMPARATOR_OPERAND",
   "SH2_PI_FSBC_FTP_DEBUG_PORT",
   "SH2_PI_FSB_COMPARE_MASK",
   "SH2_PI_FSB_COMPARE_VALUE",
   "SH2_PI_FSB_ERROR_INJECTION",
   "SH2_PI_FSB_ERROR_INJECTION",
   "SH2_PI_FTP_COMPARATOR",
   "SH2_PI_FTP_COMPARATOR_OPERAND",
   "SH2_PI_FTP_DEBUG_PORT",
   "SH2_PI_GLOBAL_TABLE",
   "SH2_PI_HW_TIME_STAMP",
   "SH2_PI_LOCAL_TABLE",
   "SH2_PI_MD2PI_REPLY_VC_CONFIG",
   "SH2_PI_MD2PI_REPLY_VC_STATUS",
   "SH2_PI_MD2PI_REQUEST_VC_CONFIG",
   "SH2_PI_MD2PI_REQUEST_VC_STATUS",
   "SH2_PI_MD_RP_CRD_CTL",
   "SH2_PI_MD_RQ_CRD_CTL",
   "SH2_PI_OVER_RIDE_TABLE",
   "SH2_PI_PI2MD_REPLY_VC_STATUS",
   "SH2_PI_PI2MD_REQUEST_VC_STATUS",
   "SH2_PI_PI2XN_REPLY_VC_STATUS",
   "SH2_PI_PI2XN_REQUEST_VC_STATUS",
   "SH2_PI_QUEUE_ERROR_INJECTION",
   "SH2_PI_RDAT_ACK_Q_CONFIG",
   "SH2_PI_RDAT_CLEAR_ERROR",
   "SH2_PI_RDAT_CTP_COMPARATOR",
   "SH2_PI_RDAT_CTP_COMPARATOR_OPERAND",
   "SH2_PI_RDAT_CTP_DEBUG_PORT",
   "SH2_PI_RDAT_DAT_DFR_Q_CONFIG",
   "SH2_PI_RDAT_ERROR_MASK",
   "SH2_PI_RDAT_FTP_COMPARATOR",
   "SH2_PI_RDAT_FTP_COMPARATOR_OPERAND",
   "SH2_PI_RDAT_FTP_DEBUG_PORT",
   "SH2_PI_RDAT_POISON_SNAN_DEP",
   "SH2_PI_RSP_PLANE_HINT",
   "SH2_PI_TEST_POINT_COMPARE",
   "SH2_PI_TEST_POINT_SELECT",
   "SH2_PI_TEST_POINT_TRIGGER_SELECT",
   "SH2_PI_UNCORRECTED_DETAIL_1",
   "SH2_PI_UNCORRECTED_DETAIL_2",
   "SH2_PI_UNCORRECTED_DETAIL_3",
   "SH2_PI_UNCORRECTED_DETAIL_4",
   "SH2_PI_UNCORRECTED_DETAIL_5",
   "SH2_PI_UNCORRECTED_DETAIL_6",
   "SH2_PI_UNCOR_TIME_STAMP",
   "SH2_PI_WDAT_CTP_COMPARATOR",
   "SH2_PI_WDAT_CTP_COMPARATOR_OPERAND",
   "SH2_PI_WDAT_CTP_DEBUG_PORT",
   "SH2_PI_WDAT_ERROR_MASK",
   "SH2_PI_WDAT_FSB_ACK_Q_CONFIG",
   "SH2_PI_WDAT_FSB_CMND_Q_CONFIG",
   "SH2_PI_WDAT_FTP_COMPARATOR",
   "SH2_PI_WDAT_FTP_COMPARATOR_OPERAND",
   "SH2_PI_WDAT_FTP_DEBUG_PORT",
   "SH2_PI_WDAT_REPLAY_COUNT",
   "SH2_PI_WDAT_REPLAY_COUNT_RESET",
   "SH2_PI_XN2PI_REPLY_VC_CONFIG",
   "SH2_PI_XN2PI_REPLY_VC_STATUS",
   "SH2_PI_XN2PI_REQUEST_VC_CONFIG",
   "SH2_PI_XN2PI_REQUEST_VC_STATUS",
   "SH2_PROCESSOR_TYPE",
   "SH2_PROFILE_COUNTER",
   "SH2_PROFILE_DN_CONTROL",
   "SH2_PROFILE_INT_CONFIG",
   "SH2_PROFILE_INT_ENABLE",
   "SH2_PROFILE_PEAK",
   "SH2_PROFILE_PEAK_CONTROL",
   "SH2_PROFILE_RANGE",
   "SH2_PROFILE_UP_CONTROL",
   "SH2_PTC",
   "SH2_PTC_PARMS",
   "SH2_RACK_SLOT_DATA",
   "SH2_REDIRECT_INVAL",
   "SH2_RTC",
   "SH2_RTC0_INT_CONFIG",
   "SH2_RTC0_INT_ENABLE",
   "SH2_RTC1_INT_CONFIG",
   "SH2_RTC1_INT_ENABLE",
   "SH2_RTC2_INT_CONFIG",
   "SH2_RTC2_INT_ENABLE",
   "SH2_RTC3_INT_CONFIG",
   "SH2_RTC3_INT_ENABLE",
   "SH2_SCRATCH0",
   "SH2_SCRATCH0_ALIAS",
   "SH2_SCRATCH1",
   "SH2_SCRATCH10",
   "SH2_SCRATCH10_ALIAS",
   "SH2_SCRATCH10_ALIAS_2",
   "SH2_SCRATCH11",
   "SH2_SCRATCH11_ALIAS",
   "SH2_SCRATCH11_ALIAS_2",
   "SH2_SCRATCH12",
   "SH2_SCRATCH12_ALIAS",
   "SH2_SCRATCH12_ALIAS_2",
   "SH2_SCRATCH13",
   "SH2_SCRATCH13_ALIAS",
   "SH2_SCRATCH13_ALIAS_2",
   "SH2_SCRATCH14",
   "SH2_SCRATCH14_ALIAS",
   "SH2_SCRATCH14_ALIAS_2",
   "SH2_SCRATCH15",
   "SH2_SCRATCH15_ALIAS",
   "SH2_SCRATCH15_ALIAS_2",
   "SH2_SCRATCH16",
   "SH2_SCRATCH16_ALIAS",
   "SH2_SCRATCH16_ALIAS_2",
   "SH2_SCRATCH17",
   "SH2_SCRATCH17_ALIAS",
   "SH2_SCRATCH17_ALIAS_2",
   "SH2_SCRATCH18",
   "SH2_SCRATCH18_ALIAS",
   "SH2_SCRATCH18_ALIAS_2",
   "SH2_SCRATCH19",
   "SH2_SCRATCH19_ALIAS",
   "SH2_SCRATCH19_ALIAS_2",
   "SH2_SCRATCH1_ALIAS",
   "SH2_SCRATCH2",
   "SH2_SCRATCH20",
   "SH2_SCRATCH20_ALIAS",
   "SH2_SCRATCH20_ALIAS_2",
   "SH2_SCRATCH21",
   "SH2_SCRATCH21_ALIAS",
   "SH2_SCRATCH21_ALIAS_2",
   "SH2_SCRATCH22",
   "SH2_SCRATCH22_ALIAS",
   "SH2_SCRATCH22_ALIAS_2",
   "SH2_SCRATCH23",
   "SH2_SCRATCH23_ALIAS",
   "SH2_SCRATCH23_ALIAS_2",
   "SH2_SCRATCH24",
   "SH2_SCRATCH24_ALIAS",
   "SH2_SCRATCH24_ALIAS_2",
   "SH2_SCRATCH2_ALIAS",
   "SH2_SCRATCH3",
   "SH2_SCRATCH3_ALIAS",
   "SH2_SCRATCH4",
   "SH2_SCRATCH4_ALIAS",
   "SH2_SCRATCH5",
   "SH2_SCRATCH5_ALIAS",
   "SH2_SCRATCH5_ALIAS_2",
   "SH2_SCRATCH6",
   "SH2_SCRATCH6_ALIAS",
   "SH2_SCRATCH6_ALIAS_2",
   "SH2_SCRATCH7",
   "SH2_SCRATCH7_ALIAS",
   "SH2_SCRATCH7_ALIAS_2",
   "SH2_SCRATCH8",
   "SH2_SCRATCH8_ALIAS",
   "SH2_SCRATCH8_ALIAS_2",
   "SH2_SCRATCH9",
   "SH2_SCRATCH9_ALIAS",
   "SH2_SCRATCH9_ALIAS_2",
   "SH2_SOFT_RESET",
   "SH2_STATUS0",
   "SH2_STATUS0_ALIAS",
   "SH2_STATUS1",
   "SH2_STATUS1_ALIAS",
   "SH2_STATUS2",
   "SH2_STATUS2_ALIAS",
   "SH2_STATUS3",
   "SH2_STATUS3_ALIAS",
   "SH2_STOP_CLK_CONTROL",
   "SH2_STOP_CLK_DELAY_PHASE",
   "SH2_THROTTLE_ENABLE",
   "SH2_THROTTLE_INTERVAL",
   "SH2_THROTTLE_STATUS",
   "SH2_THROTTLE_TIME",
   "SH2_TSF_ARMED_STATE",
   "SH2_TSF_ARM_MASK",
   "SH2_TSF_COMPARE0",
   "SH2_TSF_COMPARE1",
   "SH2_TSF_COMPARE10",
   "SH2_TSF_COMPARE11",
   "SH2_TSF_COMPARE12",
   "SH2_TSF_COMPARE13",
   "SH2_TSF_COMPARE14",
   "SH2_TSF_COMPARE15",
   "SH2_TSF_COMPARE2",
   "SH2_TSF_COMPARE3",
   "SH2_TSF_COMPARE4",
   "SH2_TSF_COMPARE5",
   "SH2_TSF_COMPARE6",
   "SH2_TSF_COMPARE7",
   "SH2_TSF_COMPARE8",
   "SH2_TSF_COMPARE9",
   "SH2_TSF_COUNTER_PRESETS",
   "SH2_TSF_COUNTER_VALUE",
   "SH2_TSF_DECREMENT_CTL",
   "SH2_TSF_DIAG_MSG_CTL",
   "SH2_TSF_DISARM_MASK",
   "SH2_TSF_ENABLE_CTL",
   "SH2_TSF_SOFTWARE_ARM",
   "SH2_TSF_SOFTWARE_DISARM",
   "SH2_TSF_SOFTWARE_TRIGGERED",
   "SH2_TSF_TRIGGERED_STATE",
   "SH2_TSF_TRIGGER_MASK",
   "SH2_VEC_DATA",
   "SH2_VEC_PARMS",
   "SH2_VEC_RDDATA",
   "SH2_VEC_RETURN",
   "SH2_VEC_ROUTE",
   "SH2_VEC_STATUS",
   "SH2_VEC_STATUS_ALIAS",
   "SH2_VGA_REMAP",
   "SH2_XNIILB_AGE_WRAP0",
   "SH2_XNIILB_AGE_WRAP1",
   "SH2_XNIILB_AGE_WRAP2",
   "SH2_XNIILB_ARB_CONFIG_SI",
   "SH2_XNIILB_ARB_CONFIG_SO",
   "SH2_XNIILB_ERROR_DETAIL_1",
   "SH2_XNIILB_ERROR_DETAIL_2",
   "SH2_XNIILB_ERROR_DETAIL_3",
   "SH2_XNIILB_ERROR_MASK",
   "SH2_XNIILB_ERROR_MASK_1",
   "SH2_XNIILB_ERROR_OVERFLOW",
   "SH2_XNIILB_ERROR_OVERFLOW_1",
   "SH2_XNIILB_ERROR_OVERFLOW_ALIAS",
   "SH2_XNIILB_ERROR_OVERFLOW_ALIAS_1",
   "SH2_XNIILB_ERROR_SUMMARY",
   "SH2_XNIILB_ERROR_SUMMARY_1",
   "SH2_XNIILB_ERROR_SUMMARY_ALIAS",
   "SH2_XNIILB_ERROR_SUMMARY_ALIAS_1",
   "SH2_XNIILB_FIRST_ERROR",
   "SH2_XNIILB_FIRST_ERROR_1",
   "SH2_XNIILB_FR_IILB_INTRA_FLOW_CREDIT",
   "SH2_XNIILB_FR_MD_INTRA_FLOW_CREDIT",
   "SH2_XNIILB_FR_NI0_INTRA_FLOW_CREDIT",
   "SH2_XNIILB_FR_NI1_INTRA_FLOW_CREDIT",
   "SH2_XNIILB_FR_PI_INTRA_FLOW_CREDIT",
   "SH2_XNIILB_II_FIFO_CREDIT_CNT",
   "SH2_XNIILB_LB_FIFO_CREDIT_CNT",
   "SH2_XNIILB_TO_IILB_INTRA_FLOW_DEBIT",
   "SH2_XNIILB_TO_MD_INTRA_FLOW_SIC_DEBIT_VC0",
   "SH2_XNIILB_TO_MD_INTRA_FLOW_SIC_DEBIT_VC2",
   "SH2_XNIILB_TO_NI0_INTRA_FLOW_DEBIT",
   "SH2_XNIILB_TO_NI0_INTRA_FLOW_DEBIT13",
   "SH2_XNIILB_TO_NI1_INTRA_FLOW_DEBIT",
   "SH2_XNIILB_TO_NI1_INTRA_FLOW_DEBIT13",
   "SH2_XNIILB_TO_PI_INTRA_FLOW_SIC_DEBIT_VC0",
   "SH2_XNIILB_TO_PI_INTRA_FLOW_SIC_DEBIT_VC2",
   "SH2_XNII_INTRA_FLOW",
   "SH2_XNLB_INTRA_FLOW",
   "SH2_XNMD_ARB_CONFIG",
   "SH2_XNMD_CREDIT_MGR_VC0",
   "SH2_XNMD_CREDIT_MGR_VC2",
   "SH2_XNMD_ECC0_INJ_MASK_REG",
   "SH2_XNMD_ECC1_INJ_MASK_REG",
   "SH2_XNMD_ECC2_INJ_MASK_REG",
   "SH2_XNMD_ECC3_INJ_MASK_REG",
   "SH2_XNMD_ECC_ERR_REPORT",
   "SH2_XNMD_ECC_INJ_REG",
   "SH2_XNMD_ERROR_DETAIL_1",
   "SH2_XNMD_ERROR_MASK",
   "SH2_XNMD_ERROR_MASK_1",
   "SH2_XNMD_ERROR_OVERFLOW",
   "SH2_XNMD_ERROR_OVERFLOW_1",
   "SH2_XNMD_ERROR_OVERFLOW_ALIAS",
   "SH2_XNMD_ERROR_OVERFLOW_ALIAS_1",
   "SH2_XNMD_ERROR_SUMMARY",
   "SH2_XNMD_ERROR_SUMMARY_1",
   "SH2_XNMD_ERROR_SUMMARY_ALIAS",
   "SH2_XNMD_ERROR_SUMMARY_ALIAS_1",
   "SH2_XNMD_FIRST_ERROR",
   "SH2_XNMD_FIRST_ERROR_1",
   "SH2_XNMD_LOCAL_AGE0",
   "SH2_XNMD_LOCAL_AGE1",
   "SH2_XNMD_SIC_FLOW",
   "SH2_XNMD_STEERING_FIFO",
   "SH2_XNMD_TO_IILB_PORT_FLOW",
   "SH2_XNMD_TO_NI0_PORT_FLOW",
   "SH2_XNMD_TO_NI0_PORT_FLOW13",
   "SH2_XNMD_TO_NI1_PORT_FLOW",
   "SH2_XNMD_TO_NI1_PORT_FLOW13",
   "SH2_XNNI0_0_INTRANI_FLOW",
   "SH2_XNNI0_1_INTRANI_FLOW",
   "SH2_XNNI0_2_INTRANI_FLOW",
   "SH2_XNNI0_3_INTRANI_FLOW",
   "SH2_XNNI0_ARB_CONFIG",
   "SH2_XNNI0_DEADLCK_FLOW",
   "SH2_XNNI0_DEADLCK_FLOW_SUPPORT",
   "SH2_XNNI0_IILB_TAILTO",
   "SH2_XNNI0_INJECT_AGE",
   "SH2_XNNI0_LINK_0_FLOW",
   "SH2_XNNI0_LINK_1_FLOW",
   "SH2_XNNI0_LINK_2_FLOW",
   "SH2_XNNI0_LINK_3_FLOW",
   "SH2_XNNI0_LLP_DEBIT_FLOW",
   "SH2_XNNI0_LOCAL_AGE0",
   "SH2_XNNI0_LOCAL_AGE1",
   "SH2_XNNI0_MD_TAILTO",
   "SH2_XNNI0_NETWORK_AGE",
   "SH2_XNNI0_NI_TAILTO",
   "SH2_XNNI0_NI_TAILTO_SUPPORT",
   "SH2_XNNI0_PI_TAILTO",
   "SH2_XNNI0_QUEUE_CNTR",
   "SH2_XNNI0_TIMER_REG",
   "SH2_XNNI0_TO_IILB_INTRA_FLOW_DEBIT",
   "SH2_XNNI0_TO_MD_INTRA_FLOW_SIC_DEBIT_VC0",
   "SH2_XNNI0_TO_MD_INTRA_FLOW_SIC_DEBIT_VC2",
   "SH2_XNNI0_TO_PI_INTRA_FLOW_SIC_DEBIT_VC0",
   "SH2_XNNI0_TO_PI_INTRA_FLOW_SIC_DEBIT_VC2",
   "SH2_XNNI0_VCSWITCH_FLOW",
   "SH2_XNNI1_0_INTRANI_FLOW",
   "SH2_XNNI1_1_INTRANI_FLOW",
   "SH2_XNNI1_2_INTRANI_FLOW",
   "SH2_XNNI1_3_INTRANI_FLOW",
   "SH2_XNNI1_ARB_CONFIG",
   "SH2_XNNI1_DEADLCK_FLOW",
   "SH2_XNNI1_DEADLCK_FLOW_SUPPORT",
   "SH2_XNNI1_IILB_TAILTO",
   "SH2_XNNI1_INJECT_AGE",
   "SH2_XNNI1_LINK_0_FLOW",
   "SH2_XNNI1_LINK_1_FLOW",
   "SH2_XNNI1_LINK_2_FLOW",
   "SH2_XNNI1_LINK_3_FLOW",
   "SH2_XNNI1_LLP_DEBIT_FLOW",
   "SH2_XNNI1_LOCAL_AGE0",
   "SH2_XNNI1_LOCAL_AGE1",
   "SH2_XNNI1_MD_TAILTO",
   "SH2_XNNI1_NETWORK_AGE",
   "SH2_XNNI1_NI_TAILTO",
   "SH2_XNNI1_NI_TAILTO_SUPPORT",
   "SH2_XNNI1_PI_TAILTO",
   "SH2_XNNI1_QUEUE_CNTR",
   "SH2_XNNI1_TIMER_REG",
   "SH2_XNNI1_TO_IILB_INTRA_FLOW_DEBIT",
   "SH2_XNNI1_TO_MD_INTRA_FLOW_SIC_DEBIT_VC0",
   "SH2_XNNI1_TO_MD_INTRA_FLOW_SIC_DEBIT_VC2",
   "SH2_XNNI1_TO_PI_INTRA_FLOW_SIC_DEBIT_VC0",
   "SH2_XNNI1_TO_PI_INTRA_FLOW_SIC_DEBIT_VC2",
   "SH2_XNNI1_VCSWITCH_FLOW",
   "SH2_XNPI_ARB_CONFIG",
   "SH2_XNPI_CREDIT_MGR_VC0",
   "SH2_XNPI_CREDIT_MGR_VC2",
   "SH2_XNPI_ECC0_INJ_MASK_REG",
   "SH2_XNPI_ECC1_INJ_MASK_REG",
   "SH2_XNPI_ECC2_INJ_MASK_REG",
   "SH2_XNPI_ECC3_INJ_MASK_REG",
   "SH2_XNPI_ECC_INJ_REG",
   "SH2_XNPI_ERROR_DETAIL_1",
   "SH2_XNPI_ERROR_MASK",
   "SH2_XNPI_ERROR_OVERFLOW",
   "SH2_XNPI_ERROR_OVERFLOW_ALIAS",
   "SH2_XNPI_ERROR_SUMMARY",
   "SH2_XNPI_ERROR_SUMMARY_ALIAS",
   "SH2_XNPI_FIRST_ERROR",
   "SH2_XNPI_LOCAL_AGE0",
   "SH2_XNPI_LOCAL_AGE1",
   "SH2_XNPI_SIC_FLOW",
   "SH2_XNPI_STEERING_FIFO",
   "SH2_XNPI_TO_IILB_PORT_FLOW",
   "SH2_XNPI_TO_NI0_PORT_FLOW",
   "SH2_XNPI_TO_NI0_PORT_FLOW13",
   "SH2_XNPI_TO_NI1_PORT_FLOW",
   "SH2_XNPI_TO_NI1_PORT_FLOW13",
   "SH2_XN_CORRECTED_DETAIL_1",
   "SH2_XN_CORRECTED_DETAIL_2",
   "SH2_XN_CORRECTED_DETAIL_3",
   "SH2_XN_CORRECTED_DETAIL_4",
   "SH2_XN_COR_TIME_STAMP",
   "SH2_XN_DEBUG_DATA",
   "SH2_XN_DEBUG_SEL",
   "SH2_XN_DEBUG_TRIG_SEL",
   "SH2_XN_ERROR_MASK",
   "SH2_XN_ERROR_OVERFLOW",
   "SH2_XN_ERROR_OVERFLOW_ALIAS",
   "SH2_XN_ERROR_SUMMARY",
   "SH2_XN_ERROR_SUMMARY_ALIAS",
   "SH2_XN_FIRST_ERROR",
   "SH2_XN_HW_TIME_STAMP",
   "SH2_XN_IILB_DEBUG_SEL",
   "SH2_XN_IILB_II_CMP_ENABLE0",
   "SH2_XN_IILB_II_CMP_ENABLE1",
   "SH2_XN_IILB_II_CMP_EXP_DATA0",
   "SH2_XN_IILB_II_CMP_EXP_DATA1",
   "SH2_XN_IILB_LB_CMP_ENABLE0",
   "SH2_XN_IILB_LB_CMP_ENABLE1",
   "SH2_XN_IILB_LB_CMP_EXP_DATA0",
   "SH2_XN_IILB_LB_CMP_EXP_DATA1",
   "SH2_XN_IILB_MD_HDR_CMP_ENABLE0",
   "SH2_XN_IILB_MD_HDR_CMP_ENABLE1",
   "SH2_XN_IILB_MD_HDR_CMP_EXP_DATA0",
   "SH2_XN_IILB_MD_HDR_CMP_EXP_DATA1",
   "SH2_XN_IILB_NI0_CMP_ENABLE0",
   "SH2_XN_IILB_NI0_CMP_ENABLE1",
   "SH2_XN_IILB_NI0_CMP_EXP_DATA0",
   "SH2_XN_IILB_NI0_CMP_EXP_DATA1",
   "SH2_XN_IILB_NI1_CMP_ENABLE0",
   "SH2_XN_IILB_NI1_CMP_ENABLE1",
   "SH2_XN_IILB_NI1_CMP_EXP_DATA0",
   "SH2_XN_IILB_NI1_CMP_EXP_DATA1",
   "SH2_XN_IILB_PI_CMP_ENABLE0",
   "SH2_XN_IILB_PI_CMP_ENABLE1",
   "SH2_XN_IILB_PI_CMP_EXP_DATA0",
   "SH2_XN_IILB_PI_CMP_EXP_DATA1",
   "SH2_XN_MD_DEBUG_SEL",
   "SH2_XN_MD_IILB_CMP_ENABLE0",
   "SH2_XN_MD_IILB_CMP_ENABLE1",
   "SH2_XN_MD_IILB_CMP_EXP_DATA0",
   "SH2_XN_MD_IILB_CMP_EXP_DATA1",
   "SH2_XN_MD_NI0_CMP_ENABLE0",
   "SH2_XN_MD_NI0_CMP_ENABLE1",
   "SH2_XN_MD_NI0_CMP_EXP_DATA0",
   "SH2_XN_MD_NI0_CMP_EXP_DATA1",
   "SH2_XN_MD_NI1_CMP_ENABLE0",
   "SH2_XN_MD_NI1_CMP_ENABLE1",
   "SH2_XN_MD_NI1_CMP_EXP_DATA0",
   "SH2_XN_MD_NI1_CMP_EXP_DATA1",
   "SH2_XN_MD_RP_CRD_CTL",
   "SH2_XN_MD_RQ_CRD_CTL",
   "SH2_XN_MD_SIC_CMP_EXP_HDR0",
   "SH2_XN_MD_SIC_CMP_EXP_HDR1",
   "SH2_XN_MD_SIC_CMP_HDR_ENABLE0",
   "SH2_XN_MD_SIC_CMP_HDR_ENABLE1",
   "SH2_XN_NI0_DEBUG_SEL",
   "SH2_XN_NI0_IILB_CMP_ENABLE0",
   "SH2_XN_NI0_IILB_CMP_ENABLE1",
   "SH2_XN_NI0_IILB_CMP_EXP_DATA0",
   "SH2_XN_NI0_IILB_CMP_EXP_DATA1",
   "SH2_XN_NI0_LLP_CMP_ENABLE0",
   "SH2_XN_NI0_LLP_CMP_ENABLE1",
   "SH2_XN_NI0_LLP_CMP_EXP_DATA0",
   "SH2_XN_NI0_LLP_CMP_EXP_DATA1",
   "SH2_XN_NI0_MD_CMP_EXP_HDR0",
   "SH2_XN_NI0_MD_CMP_EXP_HDR1",
   "SH2_XN_NI0_MD_CMP_HDR_ENABLE0",
   "SH2_XN_NI0_MD_CMP_HDR_ENABLE1",
   "SH2_XN_NI0_NI_CMP_ENABLE0",
   "SH2_XN_NI0_NI_CMP_ENABLE1",
   "SH2_XN_NI0_NI_CMP_EXP_DATA0",
   "SH2_XN_NI0_NI_CMP_EXP_DATA1",
   "SH2_XN_NI0_PI_CMP_ENABLE0",
   "SH2_XN_NI0_PI_CMP_ENABLE1",
   "SH2_XN_NI0_PI_CMP_EXP_DATA0",
   "SH2_XN_NI0_PI_CMP_EXP_DATA1",
   "SH2_XN_NI1_DEBUG_SEL",
   "SH2_XN_NI1_IILB_CMP_ENABLE0",
   "SH2_XN_NI1_IILB_CMP_ENABLE1",
   "SH2_XN_NI1_IILB_CMP_EXP_DATA0",
   "SH2_XN_NI1_IILB_CMP_EXP_DATA1",
   "SH2_XN_NI1_LLP_CMP_ENABLE0",
   "SH2_XN_NI1_LLP_CMP_ENABLE1",
   "SH2_XN_NI1_LLP_CMP_EXP_DATA0",
   "SH2_XN_NI1_LLP_CMP_EXP_DATA1",
   "SH2_XN_NI1_MD_CMP_EXP_HDR0",
   "SH2_XN_NI1_MD_CMP_EXP_HDR1",
   "SH2_XN_NI1_MD_CMP_HDR_ENABLE0",
   "SH2_XN_NI1_MD_CMP_HDR_ENABLE1",
   "SH2_XN_NI1_NI_CMP_ENABLE0",
   "SH2_XN_NI1_NI_CMP_ENABLE1",
   "SH2_XN_NI1_NI_CMP_EXP_DATA0",
   "SH2_XN_NI1_NI_CMP_EXP_DATA1",
   "SH2_XN_NI1_PI_CMP_ENABLE0",
   "SH2_XN_NI1_PI_CMP_ENABLE1",
   "SH2_XN_NI1_PI_CMP_EXP_DATA0",
   "SH2_XN_NI1_PI_CMP_EXP_DATA1",
   "SH2_XN_PI_DEBUG_SEL",
   "SH2_XN_PI_IILB_CMP_ENABLE0",
   "SH2_XN_PI_IILB_CMP_ENABLE1",
   "SH2_XN_PI_IILB_CMP_EXP_DATA0",
   "SH2_XN_PI_IILB_CMP_EXP_DATA1",
   "SH2_XN_PI_NI0_CMP_ENABLE0",
   "SH2_XN_PI_NI0_CMP_ENABLE1",
   "SH2_XN_PI_NI0_CMP_EXP_DATA0",
   "SH2_XN_PI_NI0_CMP_EXP_DATA1",
   "SH2_XN_PI_NI1_CMP_ENABLE0",
   "SH2_XN_PI_NI1_CMP_ENABLE1",
   "SH2_XN_PI_NI1_CMP_EXP_DATA0",
   "SH2_XN_PI_NI1_CMP_EXP_DATA1",
   "SH2_XN_PI_SIC_CMP_DATA0",
   "SH2_XN_PI_SIC_CMP_DATA1",
   "SH2_XN_PI_SIC_CMP_DATA_ENABLE0",
   "SH2_XN_PI_SIC_CMP_DATA_ENABLE1",
   "SH2_XN_TRIGGER_COMPARE",
   "SH2_XN_TRIGGER_DATA",
   "SH2_XN_UNCORRECTED_DETAIL_1",
   "SH2_XN_UNCORRECTED_DETAIL_2",
   "SH2_XN_UNCORRECTED_DETAIL_3",
   "SH2_XN_UNCORRECTED_DETAIL_4",
   "SH2_XN_UNCOR_TIME_STAMP",
   "SH2_X_AMOC_CFG",
   "SH2_X_AMOC_TAG",
   "SH2_X_ARB_DBUG_SEL",
   "SH2_X_ATL_DBUG_SEL",
   "SH2_X_ATR_DBUG_SEL",
   "SH2_X_CFG",
   "SH2_X_DBUG_SEL",
   "SH2_X_DIMM_CFG",
   "SH2_X_DQCT_CFG",
   "SH2_X_DQL_DBUG_SEL",
   "SH2_X_DQR_DBUG_SEL",
   "SH2_X_LADDR_CMP",
   "SH2_X_ODT_CFG",
   "SH2_X_RADDR_CMP",
   "SH2_X_REFRESH_CONTROL",
   "SH2_X_TAG0",
   "SH2_X_TAG1",
   "SH2_X_TAG2",
   "SH2_X_TAG3",
   "SH2_X_TAG4",
   "SH2_X_TAG5",
   "SH2_X_TAG6",
   "SH2_X_TAG7",
   "SH2_X_TAG_CMP",
   "SH2_X_TAG_DBUG_SEL",
   "SH2_X_TAG_MASK",
   "SH2_X_WBQ_DBUG_SEL",
   "SH2_Y_AMOC_CFG",
   "SH2_Y_AMOC_TAG",
   "SH2_Y_ARB_DBUG_SEL",
   "SH2_Y_ATL_DBUG_SEL",
   "SH2_Y_ATR_DBUG_SEL",
   "SH2_Y_CFG",
   "SH2_Y_DBUG_SEL",
   "SH2_Y_DIMM_CFG",
   "SH2_Y_DQCT_CFG",
   "SH2_Y_DQL_DBUG_SEL",
   "SH2_Y_DQR_DBUG_SEL",
   "SH2_Y_LADDR_CMP",
   "SH2_Y_ODT_CFG",
   "SH2_Y_RADDR_CMP",
   "SH2_Y_REFRESH_CONTROL",
   "SH2_Y_TAG0",
   "SH2_Y_TAG1",
   "SH2_Y_TAG2",
   "SH2_Y_TAG3",
   "SH2_Y_TAG4",
   "SH2_Y_TAG5",
   "SH2_Y_TAG6",
   "SH2_Y_TAG7",
   "SH2_Y_TAG_CMP",
   "SH2_Y_TAG_DBUG_SEL",
   "SH2_Y_TAG_MASK",
   "SH2_Y_WBQ_DBUG_SEL",
);

@shub2_01_sorted_mmr_addr = 
(
   0x0000000000000080,
   0x0000000000000088,
   0x0000000000000090,
   0x0000000000000098,
   0x00000000000000A0,
   0x00000000000000A8,
   0x00000000000000B0,
   0x00000000000000B8,
   0x00000000000000C0,
   0x00000000000000C8,
   0x00000000000000D0,
   0x00000000000000D8,
   0x00000000000000E0,
   0x00000000000000E8,
   0x00000000000000F0,
   0x00000000000000F8,
   0x0000000000000100,
   0x0000000000010000,
   0x0000000000010008,
   0x0000000000010010,
   0x0000000000010018,
   0x0000000000010020,
   0x0000000000010028,
   0x0000000000010030,
   0x0000000000010038,
   0x0000000000010040,
   0x0000000000010048,
   0x0000000000010050,
   0x0000000000010058,
   0x0000000000010060,
   0x0000000000010068,
   0x0000000000010070,
   0x0000000000010078,
   0x0000000000010080,
   0x0000000000010088,
   0x0000000000010090,
   0x0000000000010098,
   0x00000000000100A0,
   0x00000000000100A8,
   0x00000000000100B0,
   0x00000000000100B8,
   0x00000000000100C0,
   0x00000000000100C8,
   0x00000000000100D0,
   0x00000000000100D8,
   0x00000000000100E0,
   0x00000000000100E8,
   0x00000000000100F0,
   0x00000000000100F8,
   0x0000000000020000,
   0x0000000000020008,
   0x0000000000020010,
   0x0000000000020018,
   0x0000000000020020,
   0x0000000000020028,
   0x0000000000020030,
   0x0000000000020038,
   0x0000000000020040,
   0x0000000000020048,
   0x0000000000020050,
   0x0000000000020058,
   0x0000000000020060,
   0x0000000000020068,
   0x0000000000020070,
   0x0000000000020078,
   0x0000000000020080,
   0x0000000000020088,
   0x0000000000020100,
   0x0000000000020108,
   0x0000000000020110,
   0x0000000000020118,
   0x0000000000020120,
   0x0000000000020128,
   0x0000000000020130,
   0x0000000000020138,
   0x0000000000020140,
   0x0000000000020148,
   0x0000000000020150,
   0x0000000000020158,
   0x0000000000020160,
   0x0000000000020168,
   0x0000000000020170,
   0x0000000000020178,
   0x0000000000020180,
   0x0000000000020188,
   0x0000000000020190,
   0x0000000000020198,
   0x00000000000201A0,
   0x00000000000201A8,
   0x00000000000201B0,
   0x00000000000201B8,
   0x00000000000201C0,
   0x00000000000201C8,
   0x00000000000201D0,
   0x00000000000201D8,
   0x00000000000201E0,
   0x00000000000201E8,
   0x0000000000020300,
   0x0000000000020308,
   0x0000000000020310,
   0x0000000000020318,
   0x0000000000030000,
   0x0000000000030100,
   0x0000000000030110,
   0x0000000000030120,
   0x0000000000030130,
   0x0000000000030200,
   0x0000000000030210,
   0x0000000000030220,
   0x0000000000030230,
   0x0000000000030240,
   0x0000000000030250,
   0x0000000000030260,
   0x0000000000030270,
   0x0000000000030300,
   0x0000000000030310,
   0x0000000000030320,
   0x0000000000030330,
   0x0000000000030340,
   0x0000000000030350,
   0x0000000000030360,
   0x0000000000030370,
   0x0000000000030400,
   0x0000000000031000,
   0x0000000000031010,
   0x0000000000032000,
   0x0000000000032010,
   0x0000000000032800,
   0x0000000000032810,
   0x0000000000033000,
   0x0000000000033010,
   0x0000000000033020,
   0x0000000000033030,
   0x0000000000033040,
   0x0000000000033050,
   0x0000000000033800,
   0x0000000000033810,
   0x0000000000033820,
   0x0000000000033830,
   0x0000000000033840,
   0x0000000000033850,
   0x0000000000034000,
   0x0000000000034010,
   0x0000000000034020,
   0x0000000000034800,
   0x0000000000038000,
   0x0000000000038010,
   0x0000000000038020,
   0x0000000000038030,
   0x0000000000038040,
   0x0000000000038800,
   0x0000000000038810,
   0x0000000000038820,
   0x0000000000038830,
   0x0000000000038840,
   0x0000000000048000,
   0x0000000000048010,
   0x0000000000048020,
   0x0000000000048030,
   0x0000000000048040,
   0x0000000000048800,
   0x0000000000048810,
   0x0000000000048820,
   0x0000000000048830,
   0x0000000000048840,
   0x0000000000049000,
   0x000000000004A000,
   0x000000000004B000,
   0x0000000000050000,
   0x0000000000050100,
   0x0000000000050110,
   0x0000000000050120,
   0x0000000000050130,
   0x0000000000050200,
   0x0000000000050210,
   0x0000000000050220,
   0x0000000000050230,
   0x0000000000050240,
   0x0000000000050250,
   0x0000000000050260,
   0x0000000000050270,
   0x0000000000050300,
   0x0000000000050310,
   0x0000000000050320,
   0x0000000000050330,
   0x0000000000050340,
   0x0000000000050350,
   0x0000000000050360,
   0x0000000000050370,
   0x0000000000050400,
   0x0000000000051000,
   0x0000000000051010,
   0x0000000000052000,
   0x0000000000052010,
   0x0000000000052800,
   0x0000000000052810,
   0x0000000000053000,
   0x0000000000053010,
   0x0000000000053020,
   0x0000000000053030,
   0x0000000000053040,
   0x0000000000053050,
   0x0000000000053800,
   0x0000000000053810,
   0x0000000000053820,
   0x0000000000053830,
   0x0000000000053840,
   0x0000000000053850,
   0x0000000000054000,
   0x0000000000054010,
   0x0000000000054020,
   0x0000000000054800,
   0x0000000000058000,
   0x0000000000058010,
   0x0000000000058020,
   0x0000000000058030,
   0x0000000000058040,
   0x0000000000058800,
   0x0000000000058810,
   0x0000000000058820,
   0x0000000000058830,
   0x0000000000058840,
   0x0000000000068000,
   0x0000000000068010,
   0x0000000000068020,
   0x0000000000068030,
   0x0000000000068040,
   0x0000000000068800,
   0x0000000000068810,
   0x0000000000068820,
   0x0000000000068830,
   0x0000000000068840,
   0x0000000000069000,
   0x000000000006A000,
   0x000000000006B000,
   0x0000000010000000,
   0x0000000010000080,
   0x0000000010000100,
   0x0000000010000180,
   0x0000000010000200,
   0x0000000010000280,
   0x0000000010000300,
   0x0000000010000380,
   0x0000000010000400,
   0x0000000010000480,
   0x0000000010000500,
   0x0000000010000580,
   0x0000000010000600,
   0x0000000010000680,
   0x0000000010000700,
   0x0000000010000780,
   0x0000000010000800,
   0x0000000010000880,
   0x0000000010000900,
   0x0000000010000980,
   0x0000000010000A00,
   0x0000000010000A80,
   0x0000000010000B00,
   0x0000000010000B80,
   0x0000000010000C00,
   0x0000000010000C80,
   0x0000000010000D00,
   0x0000000010000D80,
   0x0000000010000E00,
   0x0000000010000F00,
   0x0000000010000F80,
   0x0000000010001000,
   0x0000000010001080,
   0x0000000010001100,
   0x0000000010001180,
   0x0000000010001280,
   0x0000000010001300,
   0x0000000010001380,
   0x0000000010001400,
   0x0000000010001480,
   0x0000000010001500,
   0x0000000010001580,
   0x0000000010001600,
   0x0000000010001680,
   0x0000000010001700,
   0x0000000010001780,
   0x0000000010001800,
   0x0000000010001880,
   0x0000000010001900,
   0x0000000010001980,
   0x0000000010001A00,
   0x0000000010001A80,
   0x0000000010001B00,
   0x0000000010001B80,
   0x0000000010001C00,
   0x0000000010001C80,
   0x0000000010001D00,
   0x0000000010001D80,
   0x0000000010001E00,
   0x0000000010001E80,
   0x0000000010001F00,
   0x0000000010010000,
   0x0000000010010008,
   0x0000000010010080,
   0x0000000010010088,
   0x0000000010020000,
   0x0000000010020100,
   0x0000000010030000,
   0x0000000010030080,
   0x0000000010030100,
   0x0000000010030180,
   0x0000000010038000,
   0x0000000010038080,
   0x0000000010038100,
   0x0000000010038180,
   0x0000000010038200,
   0x0000000010040000,
   0x0000000010040080,
   0x0000000010040100,
   0x0000000010040180,
   0x0000000010040280,
   0x0000000010040300,
   0x0000000010040380,
   0x0000000010040400,
   0x0000000010050000,
   0x0000000010050080,
   0x0000000010050100,
   0x0000000010050180,
   0x0000000010050200,
   0x0000000010050280,
   0x0000000010050300,
   0x0000000010050380,
   0x0000000010050400,
   0x0000000010050480,
   0x0000000010050500,
   0x0000000010050580,
   0x0000000010050600,
   0x0000000010050608,
   0x0000000010050680,
   0x0000000010050688,
   0x0000000010050700,
   0x0000000010050780,
   0x0000000010050800,
   0x0000000010050880,
   0x0000000010050900,
   0x0000000010050980,
   0x0000000010050A00,
   0x0000000010050A80,
   0x0000000010060000,
   0x0000000010060080,
   0x0000000010060100,
   0x0000000010060180,
   0x0000000010060200,
   0x0000000010060280,
   0x0000000010060300,
   0x0000000010060380,
   0x0000000010060400,
   0x0000000010060480,
   0x0000000010060500,
   0x0000000010060580,
   0x0000000010060600,
   0x0000000010060680,
   0x0000000010060700,
   0x0000000010060780,
   0x0000000010060800,
   0x0000000010060C00,
   0x0000000010060C80,
   0x0000000010060D00,
   0x0000000010060D80,
   0x0000000010060E00,
   0x0000000010060E80,
   0x0000000010060F00,
   0x0000000010061100,
   0x0000000010061400,
   0x0000000010062000,
   0x0000000010062080,
   0x0000000010062100,
   0x0000000010062180,
   0x0000000010062200,
   0x0000000010062280,
   0x0000000010062300,
   0x0000000010063000,
   0x0000000010063080,
   0x0000000010063100,
   0x0000000010063180,
   0x0000000010063200,
   0x0000000010063280,
   0x0000000010063300,
   0x0000000010063380,
   0x0000000010063400,
   0x0000000010063480,
   0x0000000010063500,
   0x0000000010063580,
   0x0000000010063600,
   0x0000000010063680,
   0x0000000010063700,
   0x0000000010063780,
   0x0000000010063800,
   0x0000000010063880,
   0x0000000010063900,
   0x0000000010063980,
   0x0000000010063A00,
   0x0000000010064000,
   0x0000000010064080,
   0x0000000010064100,
   0x0000000010064180,
   0x0000000010064200,
   0x0000000010064280,
   0x0000000010064300,
   0x0000000010064380,
   0x0000000010064400,
   0x0000000010064600,
   0x0000000010065000,
   0x0000000010065080,
   0x0000000010066000,
   0x0000000010066080,
   0x0000000010066100,
   0x0000000010066180,
   0x0000000010066200,
   0x0000000010066280,
   0x0000000010066300,
   0x0000000010066380,
   0x0000000010066400,
   0x0000000010066480,
   0x0000000010066500,
   0x0000000010066580,
   0x0000000010066600,
   0x0000000010066680,
   0x0000000010066700,
   0x0000000010066780,
   0x0000000010066800,
   0x0000000010066880,
   0x0000000010066900,
   0x0000000010066980,
   0x0000000010066A00,
   0x0000000010066A80,
   0x0000000010066B00,
   0x0000000010066B80,
   0x0000000010066C00,
   0x0000000010066C80,
   0x0000000010067000,
   0x0000000010067080,
   0x0000000010067100,
   0x0000000010068000,
   0x0000000010068080,
   0x0000000010068100,
   0x0000000010068200,
   0x0000000010068300,
   0x0000000010069000,
   0x0000000010069080,
   0x0000000010069100,
   0x0000000010069180,
   0x0000000010069200,
   0x0000000010069280,
   0x0000000010069300,
   0x0000000010069380,
   0x0000000010069400,
   0x0000000010069480,
   0x0000000010069500,
   0x0000000010069580,
   0x0000000010069600,
   0x0000000010069680,
   0x0000000010069700,
   0x0000000010069780,
   0x0000000010069800,
   0x0000000010069880,
   0x0000000010069900,
   0x0000000010069980,
   0x0000000010069A00,
   0x0000000010069A80,
   0x0000000010069B00,
   0x0000000010069B80,
   0x0000000010069C00,
   0x0000000010069C80,
   0x0000000010069D00,
   0x0000000010069D80,
   0x0000000010069E00,
   0x0000000010069E80,
   0x0000000010069F00,
   0x0000000010069F80,
   0x000000001006A000,
   0x000000001006A080,
   0x000000001006A100,
   0x000000001006A180,
   0x000000001006A200,
   0x000000001006A280,
   0x000000001006A300,
   0x000000001006A380,
   0x000000001006A400,
   0x000000001006A480,
   0x000000001006A500,
   0x000000001006A580,
   0x000000001006A600,
   0x000000001006A680,
   0x000000001006A700,
   0x000000001006A780,
   0x000000001006A800,
   0x000000001006A880,
   0x000000001006A900,
   0x000000001006A980,
   0x000000001006AA00,
   0x000000001006AA80,
   0x000000001006AB00,
   0x000000001006AB80,
   0x000000001006AC00,
   0x000000001006AC80,
   0x000000001006AD00,
   0x000000001006AD80,
   0x000000001006AE00,
   0x000000001006AE80,
   0x000000001006AF00,
   0x000000001006AF80,
   0x000000001006B000,
   0x000000001006B080,
   0x000000001006B100,
   0x000000001006B180,
   0x000000001006B200,
   0x000000001006B280,
   0x000000001006B300,
   0x000000001006B380,
   0x000000001006B400,
   0x000000001006B480,
   0x000000001006B500,
   0x000000001006B580,
   0x000000001006B600,
   0x000000001006B680,
   0x000000001006B700,
   0x000000001006B780,
   0x000000001006B800,
   0x000000001006B880,
   0x000000001006B900,
   0x000000001006B980,
   0x000000001006BA00,
   0x000000001006BA80,
   0x000000001006BB00,
   0x000000001006BB80,
   0x000000001006BC00,
   0x000000001006BC80,
   0x000000001006BD00,
   0x000000001006BD80,
   0x000000001006BE00,
   0x000000001006BE80,
   0x000000001006BF00,
   0x000000001006BF80,
   0x000000001006C000,
   0x000000001006C080,
   0x000000001006C100,
   0x000000001006C180,
   0x000000001006C200,
   0x000000001006C280,
   0x000000001006C300,
   0x000000001006C380,
   0x000000001006C400,
   0x000000001006C480,
   0x000000001006C500,
   0x000000001006C580,
   0x000000001006C600,
   0x000000001006C680,
   0x000000001006C700,
   0x000000001006C780,
   0x000000001006C800,
   0x000000001006C880,
   0x000000001006C900,
   0x000000001006C980,
   0x000000001006CA00,
   0x000000001006CA80,
   0x000000001006CB00,
   0x000000001006CB80,
   0x000000001006CC00,
   0x000000001006CC80,
   0x000000001006CD00,
   0x000000001006CD80,
   0x000000001006CE00,
   0x000000001006CE80,
   0x000000001006CF00,
   0x000000001006CF80,
   0x0000000010071000,
   0x0000000010071080,
   0x0000000010071100,
   0x0000000010071180,
   0x0000000010071200,
   0x0000000010071280,
   0x0000000010071300,
   0x0000000010071380,
   0x0000000010071400,
   0x0000000010071880,
   0x0000000010071900,
   0x0000000010071980,
   0x0000000010072000,
   0x0000000010072180,
   0x0000000010072200,
   0x0000000010072280,
   0x0000000010072300,
   0x0000000010072380,
   0x0000000010072800,
   0x0000000010072880,
   0x0000000010072900,
   0x0000000010073000,
   0x0000000010073080,
   0x0000000010073100,
   0x0000000010074000,
   0x0000000010074080,
   0x0000000010074100,
   0x0000000010074108,
   0x0000000010075000,
   0x0000000010077000,
   0x0000000010080000,
   0x0000000010090000,
   0x00000000100A0000,
   0x00000000100B0000,
   0x00000000100C0000,
   0x00000000100D0000,
   0x00000000100E0000,
   0x00000000100F0000,
   0x0000000010100000,
   0x0000000010100080,
   0x0000000010100100,
   0x0000000010100180,
   0x0000000010101000,
   0x0000000010110000,
   0x0000000010120000,
   0x0000000010130000,
   0x0000000010140000,
   0x0000000010150000,
   0x0000000010160000,
   0x0000000010170000,
   0x0000000010180000,
   0x0000000010190000,
   0x0000000010190080,
   0x00000000101A0000,
   0x00000000101A0100,
   0x00000000101B0000,
   0x00000000101B0080,
   0x00000000101B0100,
   0x00000000101B0180,
   0x00000000101B0200,
   0x00000000101C0000,
   0x00000000101D0000,
   0x00000000101D0008,
   0x00000000101D0080,
   0x00000000101D0088,
   0x00000000101D0100,
   0x00000000101D0108,
   0x00000000101D0180,
   0x00000000101D0188,
   0x00000000101D0200,
   0x00000000101D0208,
   0x00000000101D0280,
   0x00000000101D0288,
   0x00000000101D0290,
   0x00000000101D0300,
   0x00000000101D0308,
   0x00000000101D0310,
   0x00000000101D0380,
   0x00000000101D0388,
   0x00000000101D0390,
   0x00000000101D0400,
   0x00000000101D0408,
   0x00000000101D0410,
   0x00000000101D0480,
   0x00000000101D0488,
   0x00000000101D0490,
   0x00000000101D0500,
   0x00000000101D0508,
   0x00000000101D0510,
   0x00000000101D0580,
   0x00000000101D0588,
   0x00000000101D0590,
   0x00000000101D0600,
   0x00000000101D0608,
   0x00000000101D0610,
   0x00000000101D0680,
   0x00000000101D0688,
   0x00000000101D0690,
   0x00000000101D0700,
   0x00000000101D0708,
   0x00000000101D0710,
   0x00000000101D0780,
   0x00000000101D0788,
   0x00000000101D0790,
   0x00000000101D0800,
   0x00000000101D0808,
   0x00000000101D0810,
   0x00000000101D0880,
   0x00000000101D0888,
   0x00000000101D0890,
   0x00000000101D0900,
   0x00000000101D0908,
   0x00000000101D0910,
   0x00000000101D0980,
   0x00000000101D0988,
   0x00000000101D0990,
   0x00000000101D0A00,
   0x00000000101D0A08,
   0x00000000101D0A10,
   0x00000000101D0A80,
   0x00000000101D0A88,
   0x00000000101D0A90,
   0x00000000101D0B00,
   0x00000000101D0B08,
   0x00000000101D0B10,
   0x00000000101D0B80,
   0x00000000101D0B88,
   0x00000000101D0B90,
   0x00000000101D0C00,
   0x00000000101D0C08,
   0x00000000101D0C10,
   0x0000000020000000,
   0x0000000020000080,
   0x0000000020000100,
   0x0000000020000180,
   0x0000000020010000,
   0x0000000020010008,
   0x0000000020010010,
   0x0000000020010018,
   0x0000000020020000,
   0x0000000020020008,
   0x0000000020020010,
   0x0000000020020018,
   0x0000000020050080,
   0x0000000020050110,
   0x0000000020050120,
   0x00000000200501A0,
   0x00000000200501B0,
   0x0000000020050210,
   0x0000000020050220,
   0x0000000020050280,
   0x0000000020050300,
   0x0000000020050380,
   0x0000000020050400,
   0x0000000020050480,
   0x0000000020050500,
   0x0000000020050580,
   0x0000000020050600,
   0x0000000020050680,
   0x0000000020050700,
   0x0000000020050780,
   0x0000000020050800,
   0x0000000020050880,
   0x0000000020050900,
   0x0000000020050980,
   0x0000000020050A00,
   0x0000000020050A80,
   0x0000000020050B80,
   0x0000000020050C00,
   0x0000000020050C80,
   0x0000000020050C80,
   0x0000000020050D00,
   0x0000000020050D80,
   0x0000000020050E00,
   0x0000000020050E08,
   0x0000000020050E80,
   0x0000000020050F00,
   0x0000000020050F80,
   0x0000000020051000,
   0x0000000020051080,
   0x0000000020051100,
   0x0000000020052000,
   0x0000000020052008,
   0x0000000020052010,
   0x0000000020052018,
   0x0000000020052020,
   0x0000000020052028,
   0x0000000020052030,
   0x0000000020052038,
   0x0000000020052040,
   0x0000000020052048,
   0x0000000020052050,
   0x0000000020052058,
   0x0000000020052060,
   0x0000000020052068,
   0x0000000020052070,
   0x0000000020052078,
   0x0000000020052080,
   0x0000000020052088,
   0x0000000020052090,
   0x0000000020052098,
   0x0000000020053008,
   0x0000000020053010,
   0x0000000020053018,
   0x0000000020060080,
   0x0000000020060100,
   0x0000000020060180,
   0x0000000020060200,
   0x0000000020060280,
   0x0000000020060300,
   0x0000000020060308,
   0x0000000020060380,
   0x0000000020060400,
   0x0000000020060408,
   0x0000000020060480,
   0x0000000020060500,
   0x0000000020060580,
   0x0000000020060600,
   0x0000000020060608,
   0x0000000020060680,
   0x0000000020060688,
   0x0000000020060780,
   0x0000000020060788,
   0x0000000020060800,
   0x0000000020060880,
   0x0000000020060900,
   0x0000000020060980,
   0x0000000020060A00,
   0x0000000020060A80,
   0x0000000020060B00,
   0x0000000020060B80,
   0x0000000020060B88,
   0x0000000020060C00,
   0x0000000020060C80,
   0x0000000020060C88,
   0x0000000020060D00,
   0x0000000020060D80,
   0x0000000020060E00,
   0x0000000020070000,
   0x0000000020070080,
   0x0000000020070100,
   0x0000000020070180,
   0x0000000020070200,
   0x0000000020070208,
   0x0000000020070280,
   0x0000000020070288,
   0x0000000020070300,
   0x0000000020070308,
   0x0000000020070380,
   0x0000000020070388,
   0x0000000020070400,
   0x0000000020070480,
   0x0000000020070500,
   0x0000000020070580,
   0x0000000020070600,
   0x0000000020070608,
   0x0000000020070680,
   0x0000000020070688,
   0x0000000020070700,
   0x0000000020070708,
   0x0000000020070780,
   0x0000000020070788,
   0x0000000020110000,
   0x0000000020110008,
   0x0000000020110010,
   0x0000000020110018,
   0x0000000030000000,
   0x0000000030000080,
   0x0000000030000100,
   0x0000000030000180,
   0x0000000030000200,
   0x0000000030000280,
   0x0000000030000800,
   0x0000000030000880,
   0x0000000030000900,
   0x0000000030000980,
   0x0000000030001000,
   0x0000000030001080,
   0x0000000030001100,
   0x0000000030001180,
   0x0000000030010800,
   0x0000000030010880,
   0x0000000030010900,
   0x0000000030010980,
   0x0000000030011000,
   0x0000000030011080,
   0x0000000030011100,
   0x0000000030011180,
   0x0000000030011200,
   0x0000000030011280,
   0x0000000030020000,
   0x0000000030020080,
   0x0000000030020100,
   0x0000000030021000,
   0x0000000030021100,
   0x0000000030021180,
   0x0000000030021200,
   0x0000000030030000,
   0x0000000030030080,
   0x0000000030030100,
   0x0000000030030200,
   0x0000000030030280,
   0x0000000030030300,
   0x0000000030030400,
   0x0000000030030480,
   0x0000000030030500,
   0x0000000030030600,
   0x0000000030030680,
   0x0000000030030700,
   0x0000000030030800,
   0x0000000030030880,
   0x0000000030030900,
   0x0000000030030A00,
   0x0000000030030A80,
   0x0000000030030B00,
   0x0000000030030C00,
   0x0000000030030C80,
   0x0000000030030D00,
   0x0000000030030E00,
   0x0000000030030E80,
   0x0000000030030F00,
   0x0000000030031000,
   0x0000000030031080,
   0x0000000030031100,
   0x0000000030031200,
   0x0000000030031280,
   0x0000000030031300,
   0x0000000030031400,
   0x0000000030031480,
   0x0000000030031500,
   0x0000000030031600,
   0x0000000030031680,
   0x0000000030031700,
   0x0000000030031800,
   0x0000000030031880,
   0x0000000030031900,
   0x0000000030031A00,
   0x0000000030031A80,
   0x0000000030031B00,
   0x0000000030031C00,
   0x0000000030031C80,
   0x0000000030031D00,
   0x0000000030031E00,
   0x0000000030031E80,
   0x0000000030031F00,
   0x0000000030040000,
   0x0000000030040080,
   0x0000000030040100,
   0x0000000030040180,
   0x0000000030050000,
   0x0000000030050080,
   0x0000000030050100,
   0x0000000030050180,
   0x0000000030060000,
   0x0000000030060080,
   0x0000000030060100,
   0x0000000030060180,
   0x0000000030070000,
   0x0000000030070080,
   0x0000000030070100,
   0x0000000030070180,
   0x0000000050000000,
   0x0000000050000008,
   0x0000000050000010,
   0x0000000050000018,
   0x0000000050000020,
   0x0000000050000028,
   0x0000000050000030,
   0x0000000050000038,
   0x0000000050000040,
   0x0000000050000048,
   0x0000000050000050,
   0x0000000050000058,
   0x0000000050000060,
   0x0000000050001030,
   0x0000000050001040,
   0x0000000050001050,
   0x0000000050001060,
   0x0000000050001070,
   0x0000000050002000,
   0x0000000050002008,
   0x0000000050002010,
   0x0000000050002018,
   0x0000000050002020,
   0x0000000050002028,
   0x0000000050002030,
   0x0000000050002038,
   0x0000000050002040,
   0x0000000050002048,
   0x0000000050002050,
   0x0000000050002058,
   0x0000000050002060,
   0x0000000050003030,
   0x0000000050003040,
   0x0000000050003050,
   0x0000000050003060,
   0x0000000050003070,
   0x0000000050020000,
   0x0000000050020800,
   0x0000000050021000,
   0x0000000050022000,
   0x0000000050022800,
   0x0000000050023000,
   0x0000000050023008,
   0x0000000050024000,
   0x0000000050024800,
   0x0000000050025000,
   0x0000000050026000,
   0x0000000050026800,
   0x0000000050027000,
   0x0000000050028000,
   0x0000000050028800,
   0x0000000050029000,
   0x0000000050029008,
   0x0000000050030000,
   0x0000000050030010,
   0x0000000050030020,
   0x0000000050030030,
   0x0000000050030040,
   0x0000000050030050,
   0x0000000050030060,
   0x0000000050030070,
   0x0000000050030080,
   0x0000000050030090,
   0x00000000500300A0,
   0x00000000500300B0,
   0x0000000050030100,
   0x0000000050030110,
   0x0000000050030120,
   0x0000000050030130,
   0x0000000050030140,
   0x0000000050030150,
   0x0000000050030160,
   0x0000000050030170,
   0x0000000050030180,
   0x0000000050030190,
   0x00000000500301A0,
   0x00000000500301B0,
   0x0000000050030200,
   0x0000000050030210,
   0x0000000050030220,
   0x0000000050030230,
   0x0000000050030240,
   0x0000000050030250,
   0x0000000050030260,
   0x0000000050030270,
   0x0000000050030280,
   0x0000000050030290,
   0x00000000500302A0,
   0x00000000500302B0,
   0x00000000500302C0,
   0x00000000500302D0,
   0x00000000500302E0,
   0x00000000500302F0,
   0x0000000050030300,
   0x0000000050030310,
   0x0000000050030320,
   0x0000000050030330,
   0x0000000050030340,
   0x0000000050030350,
   0x0000000050030360,
   0x0000000050030400,
   0x0000000050030410,
   0x0000000050030420,
   0x0000000050030430,
   0x0000000050030440,
   0x0000000050030450,
   0x0000000050030460,
   0x0000000050030470,
   0x0000000050030480,
   0x0000000050030490,
   0x00000000500304A0,
   0x00000000500304B0,
   0x00000000500304C0,
   0x00000000500304D0,
   0x00000000500304E0,
   0x00000000500304F0,
   0x0000000050030500,
   0x0000000050030510,
   0x0000000050030520,
   0x0000000050030530,
   0x0000000050030540,
   0x0000000050030550,
   0x0000000050030560,
   0x0000000050030570,
   0x0000000050030600,
   0x0000000050030610,
   0x0000000050030620,
   0x0000000050030630,
   0x0000000050030640,
   0x0000000050030650,
   0x0000000050030660,
   0x0000000050030670,
   0x0000000050030680,
   0x0000000050030690,
   0x00000000500306A0,
   0x00000000500306B0,
   0x00000000500306C0,
   0x00000000500306D0,
   0x00000000500306E0,
   0x00000000500306F0,
   0x0000000050030700,
   0x0000000050030710,
   0x0000000050030720,
   0x0000000050030730,
   0x0000000050030740,
   0x0000000050030750,
   0x0000000050030760,
   0x0000000050030770,
   0x0000000050031000,
   0x0000000050031020,
   0x0000000050031040,
   0x0000000050031050,
   0x0000000050031060,
   0x0000000050031080,
   0x00000000500310A0,
   0x00000000500310C0,
   0x00000000500310E0,
   0x0000000050031100,
   0x0000000050031110,
   0x0000000050031120,
   0x0000000050031130,
   0x0000000050031140,
   0x0000000050031150,
   0x0000000050031160,
   0x0000000050031170,
   0x0000000050031200,
   0x0000000050031210,
   0x0000000050031220,
   0x0000000050031230,
   0x0000000050031240,
   0x0000000050031250,
   0x0000000050031260,
   0x0000000050031270,
   0x0000000050031280,
   0x0000000050031290,
   0x00000000500312A0,
   0x00000000500312B0,
   0x00000000500312C0,
   0x00000000500312D0,
   0x00000000500312E0,
   0x00000000500312F0,
   0x0000000050031300,
   0x0000000050031310,
   0x0000000050031320,
   0x0000000050031330,
   0x0000000050031340,
   0x0000000050031350,
   0x0000000050031360,
   0x0000000050031370,
   0x0000000050031380,
   0x0000000050031390,
   0x00000000500313A0,
   0x00000000500313B0,
   0x0000000050031400,
   0x0000000050031410,
   0x0000000050031440,
   0x0000000050031450,
   0x0000000050031500,
   0x0000000050031510,
   0x0000000050031520,
   0x0000000050031530,
   0x0000000050031540,
   0x0000000050031550,
   0x0000000050031560,
   0x0000000050031570,
   0x0000000050031580,
   0x0000000050031590,
   0x00000000500315A0,
   0x00000000500315B0,
   0x00000000500315C0,
   0x00000000500315D0,
   0x00000000500315E0,
   0x00000000500315F0,
   0x0000000050031700,
   0x0000000050031710,
   0x0000000050031720,
   0x0000000050031730,
   0x0000000050031740,
   0x0000000050031750,
   0x0000000050031760,
   0x0000000050031770,
   0x00000000500317C0,
   0x00000000500317D0,
   0x00000000500317E0,
   0x00000000500317F0,
   0x0000000050031800,
   0x0000000050031810,
   0x0000000050031820,
   0x0000000050031830,
   0x0000000050031900,
   0x0000000050031910,
   0x0000000050031920,
   0x0000000050031930,
   0x0000000050031940,
   0x0000000050031950,
   0x0000000050031960,
   0x0000000050031970,
   0x00000000500319C0,
   0x00000000500319D0,
   0x00000000500319E0,
   0x00000000500319F0,
   0x0000000050031A00,
   0x0000000050031A10,
   0x0000000050031A20,
   0x0000000050031A30,
   0x0000000050031B40,
   0x0000000050031B50,
   0x0000000050031B60,
   0x0000000050031B70,
   0x0000000050031BC0,
   0x0000000050031BD0,
   0x0000000050031BE0,
   0x0000000050031BF0,
   0x0000000050032000,
   0x0000000050032010,
   0x0000000050032020,
   0x0000000050032030,
   0x0000000050032040,
   0x0000000050032050,
   0x0000000050032060,
   0x0000000050032070,
   0x0000000050032080,
   0x0000000050032090,
   0x00000000500320A0,
   0x0000000050040000,
   0x0000000050040008,
   0x0000000050040020,
   0x0000000050040028,
   0x0000000050040040,
   0x0000000050040060,
   0x0000000050040070,
   0x0000000050040080,
   0x00000000500400A0,
   0x00000000500400B0,
   0x00000000500400C0,
   0x00000000500400D0,
   0x00000000500400F0,
   0x0000000050040100,
   0x0000000050040110,
   0x0000000050040120,
   0x0000000050040130,
   0x0000000050040140,
   0x0000000050040150,
   0x0000000050040160,
   0x0000000050040170,
   0x0000000050040200,
   0x0000000050040208,
   0x0000000050040210,
   0x0000000050040218,
   0x0000000050040220,
   0x0000000050040228,
   0x0000000050040230,
   0x0000000050040238,
   0x0000000050040240,
   0x0000000050040250,
   0x0000000050040260,
   0x0000000050040270,
   0x0000000050040300,
   0x0000000050040308,
   0x0000000050040320,
   0x0000000050040328,
   0x0000000050040340,
   0x0000000050040360,
   0x0000000050040400,
   0x0000000050040408,
   0x0000000050040410,
   0x0000000050040418,
   0x0000000050040420,
   0x0000000050040428,
   0x0000000050040430,
   0x0000000050040438,
   0x0000000050040440,
   0x0000000050040450,
   0x0000000050040460,
   0x0000000050040470,
   0x0000000050040500,
   0x0000000050040508,
   0x0000000050040510,
   0x0000000050040518,
   0x0000000050040520,
   0x0000000050040528,
   0x0000000050040530,
   0x0000000050040538,
   0x0000000050040540,
   0x0000000050040550,
   0x0000000050040560,
   0x0000000050040570,
   0x0000000050040580,
   0x0000000050040590,
   0x0000000050040600,
   0x0000000050040608,
   0x0000000050040610,
   0x0000000050040618,
   0x0000000050040620,
   0x0000000050040628,
   0x0000000050040630,
   0x0000000050040638,
   0x0000000050040640,
   0x0000000050040650,
   0x0000000050040660,
   0x0000000050040670,
   0x0000000050040680,
   0x0000000050040690,
);


##########################################################################
#                                                                        #
#   REGISTER SEARCH SUBROUTINES (BY NAME OR ADDRESS)                     #
#                                                                        #
##########################################################################

sub shub2_01_mmr_search_name
{  my $rptr = 0;
   return($rptr) if ( $#_ != 0 );
   $rptr = $shub2_01_mmr_by_name{$_[0]} if ( exists $shub2_01_mmr_by_name{$_[0]} );
   return($rptr);
}

sub shub2_01_mmr_search_addr
{  my $rptr = 0;
   return($rptr) if ( $#_ != 0 );
   $rptr = $shub2_01_mmr_by_addr{$_[0]} if ( exists $shub2_01_mmr_by_addr{$_[0]} );
   return($rptr);
}


##########################################################################
# Number of MMRs    : 1275

1;
