#
#/**************************************************************************
# *                                                                        *
# *               Copyright (C) 1989-1999 Silicon Graphics, Inc.           *
# *                                                                        *
# *  These coded instructions, statements, and computer programs  contain  *
# *  unpublished  proprietary  information of Silicon Graphics, Inc., and  *
# *  are protected by Federal copyright law.  They  may  not be disclosed  *
# *  to  third  parties  or copied or duplicated in any form, in whole or  *
# *  in part, without the prior written consent of Silicon Graphics, Inc.  *
# *                                                                        *
# **************************************************************************/
#
# @(#)$Id: shub_01_mmrs.pm,v 1.2 2005/02/18 23:17:27 meyer Exp $



# The file contains PERL source that represents the MMRs from
#    an ASIC hardware register (hwreg) file.
#
# This file was generated using the "hwr2pl" utility.
# HWREG source file : hwreg_shub.hwreg
# ASIC base name    : "shub_01"
#

$shub_01_defined = 1;


##########################################################################
#                                                                        #
#   SH_FSB_BINIT_CONTROL                                                 #
#                                                                        #
##########################################################################

%shub_01_00000_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BINIT"                        => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Assert the FSB's BINIT# Signal" ],
);

%shub_01_00000_def =
( NAME    => "SH_FSB_BINIT_CONTROL",
  ADDRESS => 0x0000000120010000,
  NOTE    => "FSB BINIT# Control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00000_flds
);


##########################################################################
#                                                                        #
#   SH_FSB_RESET_CONTROL                                                 #
#                                                                        #
##########################################################################

%shub_01_00001_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RESET"                        => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Assert the FSB's RESET# Signal" ],
);

%shub_01_00001_def =
( NAME    => "SH_FSB_RESET_CONTROL",
  ADDRESS => 0x0000000120010080,
  NOTE    => "FSB Reset Control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00001_flds
);


##########################################################################
#                                                                        #
#   SH_FSB_SYSTEM_AGENT_CONFIG                                           #
#                                                                        #
##########################################################################

%shub_01_00002_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  46,  18, 0xFFFFC00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BINIT_EVENT_ENABLES"          => [   1,  32,  14, 0x00003FFF00000000, 0x00, 1, 0x0000000000000000, "FSB error binit enables" ],
   "RSVD1"                        => [   2,  25,   7, 0x00000000FE000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SERIALIZE_FSB_EN"             => [   3,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "serialize processor transactions" ],
   "TDOT"                         => [   4,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "Throttle Data-bus Ownership Transitions" ],
   "RSVD2"                        => [   5,  19,   4, 0x0000000000780000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_SPLIT_FIRMWARE_REMAP"  => [   6,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "Enable bit for Separate Firmware remappings for Each CPU" ],
   "ENABLE_FIRMWARE_REMAP"        => [   7,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "Enable bit for Firmware remapping function" ],
   "IO_TRANS_RSP"                 => [   8,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "IO Transaction Response" ],
   "INTA_RSP_DATA"                => [   9,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Interrupt Acknowledge Response Data" ],
   "SHORT_HANG_EN"                => [  10,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "use short duration hang timeout" ],
   "BNR_THROTTLING_EN"            => [  11,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "stutter FSB request assertion" ],
   "BINIT_ASSERT_EN"              => [  12,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "BINIT Assertion Enabled" ],
   "BERR_SAMPLING_EN"             => [  13,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "BERR Sampling Enabled" ],
   "BERR_ASSERT_EN"               => [  14,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "BERR Assertion Enabled for Bus Errors" ],
   "RSVD3"                        => [  15,   1,   2, 0x0000000000000006, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RCNT_SCNT_EN"                 => [  16,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "RCNT/SCNT Assertion Enabled" ],
);

%shub_01_00002_def =
( NAME    => "SH_FSB_SYSTEM_AGENT_CONFIG",
  ADDRESS => 0x0000000120010100,
  NOTE    => "FSB System Agent Configuration",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00002_flds
);


##########################################################################
#                                                                        #
#   SH_FSB_VGA_REMAP                                                     #
#                                                                        #
##########################################################################

%shub_01_00003_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VGA_REMAPPING_ENABLED"        => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "VGA Remapping Enabled" ],
   "RSVD1"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIRMWARE_REMAP_OFFSET"        => [   3,  49,  12, 0x1FFE000000000000, 0x00, 1, 0x0000000000000000, "Firmware remap offset 35:24" ],
   "NID"                          => [   4,  38,  11, 0x0001FFC000000000, 0x00, 1, 0x0000000000000000, "VGA Remap Node ID" ],
   "ASID"                         => [   5,  36,   2, 0x0000003000000000, 0x00, 1, 0x0000000000000000, "VGA Remap Address Space ID" ],
   "OFFSET"                       => [   6,  17,  19, 0x0000000FFFFE0000, 0x00, 1, 0x0000000000000000, "VGA Remap Node Offset" ],
);

%shub_01_00003_def =
( NAME    => "SH_FSB_VGA_REMAP",
  ADDRESS => 0x0000000120010180,
  NOTE    => "FSB VGA Address Space Remap",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00003_flds
);


##########################################################################
#                                                                        #
#   SH_FSB_RESET_STATUS                                                  #
#                                                                        #
##########################################################################

%shub_01_00004_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RESET_IN_PROGRESS"            => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Reset in Progress" ],
);

%shub_01_00004_def =
( NAME    => "SH_FSB_RESET_STATUS",
  ADDRESS => 0x0000000120020000,
  NOTE    => "FSB Reset Status",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00004_flds
);


##########################################################################
#                                                                        #
#   SH_FSB_SYMMETRIC_AGENT_STATUS                                        #
#                                                                        #
##########################################################################

%shub_01_00005_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   3,  61, 0xFFFFFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CPUS_READY"                   => [   1,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "The Processors are Ready" ],
   "CPU_1_ACTIVE"                 => [   2,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "CPU 1 Active." ],
   "CPU_0_ACTIVE"                 => [   3,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "CPU 0 Active." ],
);

%shub_01_00005_def =
( NAME    => "SH_FSB_SYMMETRIC_AGENT_STATUS",
  ADDRESS => 0x0000000120020080,
  NOTE    => "FSB Symmetric Agent Status",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00005_flds
);


##########################################################################
#                                                                        #
#   SH_GFX_CREDIT_COUNT_0                                                #
#                                                                        #
##########################################################################

%shub_01_00006_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RESET_GFX_STATE"              => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD0"                        => [   1,  20,  43, 0x7FFFFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   2,   0,  20, 0x00000000000FFFFF, 0x00, 1, 0x0000000000000000, "" ],
);

%shub_01_00006_def =
( NAME    => "SH_GFX_CREDIT_COUNT_0",
  ADDRESS => 0x0000000120030000,
  NOTE    => "Graphics-write Credit Count for processor 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00006_flds
);


##########################################################################
#                                                                        #
#   SH_GFX_CREDIT_COUNT_1                                                #
#                                                                        #
##########################################################################

%shub_01_00007_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RESET_GFX_STATE"              => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD0"                        => [   1,  20,  43, 0x7FFFFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   2,   0,  20, 0x00000000000FFFFF, 0x00, 1, 0x0000000000000000, "" ],
);

%shub_01_00007_def =
( NAME    => "SH_GFX_CREDIT_COUNT_1",
  ADDRESS => 0x0000000120030080,
  NOTE    => "Graphics-write Credit Count for processor 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00007_flds
);


##########################################################################
#                                                                        #
#   SH_GFX_MODE_CNTRL_0                                                  #
#                                                                        #
##########################################################################

%shub_01_00008_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   3,  61, 0xFFFFFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RELAXED_ORDERING"             => [   1,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "GFX message routing order" ],
   "MIXED_MODE_CREDITS"           => [   2,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "GFX credits are tracked by D-words and messages" ],
   "DWORD_CREDITS"                => [   3,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "GFX credits are tracked by D-words" ],
);

%shub_01_00008_def =
( NAME    => "SH_GFX_MODE_CNTRL_0",
  ADDRESS => 0x0000000120030100,
  NOTE    => "Graphics credit mode and message ordering for processor 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00008_flds
);


##########################################################################
#                                                                        #
#   SH_GFX_MODE_CNTRL_1                                                  #
#                                                                        #
##########################################################################

%shub_01_00009_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   3,  61, 0xFFFFFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RELAXED_ORDERING"             => [   1,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "GFX message routing order" ],
   "MIXED_MODE_CREDITS"           => [   2,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "GFX credits are tracked by D-words and messages" ],
   "DWORD_CREDITS"                => [   3,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "GFX credits are tracked by D-words" ],
);

%shub_01_00009_def =
( NAME    => "SH_GFX_MODE_CNTRL_1",
  ADDRESS => 0x0000000120030180,
  NOTE    => "Graphics credit mode and message ordering for processor 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00009_flds
);


##########################################################################
#                                                                        #
#   SH_GFX_SKID_CREDIT_COUNT_0                                           #
#                                                                        #
##########################################################################

%shub_01_00010_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  20,  44, 0xFFFFFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SKID"                         => [   1,   0,  20, 0x00000000000FFFFF, 0x00, 1, 0x0000000000000000, "Skid Credit Count" ],
);

%shub_01_00010_def =
( NAME    => "SH_GFX_SKID_CREDIT_COUNT_0",
  ADDRESS => 0x0000000120030200,
  NOTE    => "Graphics-write Skid Credit Count for processor 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00010_flds
);


##########################################################################
#                                                                        #
#   SH_GFX_SKID_CREDIT_COUNT_1                                           #
#                                                                        #
##########################################################################

%shub_01_00011_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  20,  44, 0xFFFFFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SKID"                         => [   1,   0,  20, 0x00000000000FFFFF, 0x00, 1, 0x0000000000000000, "Skid Credit Count" ],
);

%shub_01_00011_def =
( NAME    => "SH_GFX_SKID_CREDIT_COUNT_1",
  ADDRESS => 0x0000000120030280,
  NOTE    => "Graphics-write Skid Credit Count for processor 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00011_flds
);


##########################################################################
#                                                                        #
#   SH_GFX_STALL_LIMIT_0                                                 #
#                                                                        #
##########################################################################

%shub_01_00012_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  26,  38, 0xFFFFFFFFFC000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LIMIT"                        => [   1,   0,  26, 0x0000000003FFFFFF, 0x00, 1, 0x0000000000000000, "Graphics Stall Limit for processor 0" ],
);

%shub_01_00012_def =
( NAME    => "SH_GFX_STALL_LIMIT_0",
  ADDRESS => 0x0000000120030300,
  NOTE    => "Graphics-write Stall Limit for processor 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00012_flds
);


##########################################################################
#                                                                        #
#   SH_GFX_STALL_LIMIT_1                                                 #
#                                                                        #
##########################################################################

%shub_01_00013_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  26,  38, 0xFFFFFFFFFC000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LIMIT"                        => [   1,   0,  26, 0x0000000003FFFFFF, 0x00, 1, 0x0000000000000000, "Graphics Stall Limit for processor 1" ],
);

%shub_01_00013_def =
( NAME    => "SH_GFX_STALL_LIMIT_1",
  ADDRESS => 0x0000000120030380,
  NOTE    => "Graphics-write Stall Limit for processor 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00013_flds
);


##########################################################################
#                                                                        #
#   SH_GFX_STALL_TIMER_0                                                 #
#                                                                        #
##########################################################################

%shub_01_00014_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  26,  38, 0xFFFFFFFFFC000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIMER_VALUE"                  => [   1,   0,  26, 0x0000000003FFFFFF, 0x00, 1, 0x0000000000000000, "Graphics stall timer value for processor 0" ],
);

%shub_01_00014_def =
( NAME    => "SH_GFX_STALL_TIMER_0",
  ADDRESS => 0x0000000120030400,
  NOTE    => "Graphics-write Stall Timer for processor 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00014_flds
);


##########################################################################
#                                                                        #
#   SH_GFX_STALL_TIMER_1                                                 #
#                                                                        #
##########################################################################

%shub_01_00015_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  26,  38, 0xFFFFFFFFFC000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIMER_VALUE"                  => [   1,   0,  26, 0x0000000003FFFFFF, 0x00, 1, 0x0000000000000000, "Graphics stall timer value for processor 1" ],
);

%shub_01_00015_def =
( NAME    => "SH_GFX_STALL_TIMER_1",
  ADDRESS => 0x0000000120030480,
  NOTE    => "Graphics-write Stall Timer for processor 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00015_flds
);


##########################################################################
#                                                                        #
#   SH_GFX_WINDOW_0                                                      #
#                                                                        #
##########################################################################

%shub_01_00016_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "GFX_WINDOW_EN"                => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Graphics Window Enabled" ],
   "RSVD0"                        => [   1,  36,  27, 0x7FFFFFF000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE_ADDR"                    => [   2,  24,  12, 0x0000000FFF000000, 0x00, 1, 0x0000000000000000, "Base Address for processor 0's 16 MB Graphics Window" ],
);

%shub_01_00016_def =
( NAME    => "SH_GFX_WINDOW_0",
  ADDRESS => 0x0000000120030500,
  NOTE    => "Graphics-write Window for processor 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00016_flds
);


##########################################################################
#                                                                        #
#   SH_GFX_WINDOW_1                                                      #
#                                                                        #
##########################################################################

%shub_01_00017_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "GFX_WINDOW_EN"                => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Graphics Window Enabled" ],
   "RSVD0"                        => [   1,  36,  27, 0x7FFFFFF000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE_ADDR"                    => [   2,  24,  12, 0x0000000FFF000000, 0x00, 1, 0x0000000000000000, "Base Address for processor 1's 16 MB Graphics Window" ],
);

%shub_01_00017_def =
( NAME    => "SH_GFX_WINDOW_1",
  ADDRESS => 0x0000000120030580,
  NOTE    => "Graphics-write Window for processor 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00017_flds
);


##########################################################################
#                                                                        #
#   SH_GFX_INTERRUPT_TIMER_LIMIT_0                                       #
#                                                                        #
##########################################################################

%shub_01_00018_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INTERRUPT_TIMER_LIMIT"        => [   1,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "GFX Interrupt Timer Limit" ],
);

%shub_01_00018_def =
( NAME    => "SH_GFX_INTERRUPT_TIMER_LIMIT_0",
  ADDRESS => 0x0000000120030600,
  NOTE    => "Graphics-write Interrupt Limit for processor 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00018_flds
);


##########################################################################
#                                                                        #
#   SH_GFX_INTERRUPT_TIMER_LIMIT_1                                       #
#                                                                        #
##########################################################################

%shub_01_00019_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INTERRUPT_TIMER_LIMIT"        => [   1,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "GFX Interrupt Timer Limit" ],
);

%shub_01_00019_def =
( NAME    => "SH_GFX_INTERRUPT_TIMER_LIMIT_1",
  ADDRESS => 0x0000000120030680,
  NOTE    => "Graphics-write Interrupt Limit for processor 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00019_flds
);


##########################################################################
#                                                                        #
#   SH_GFX_WRITE_STATUS_0                                                #
#                                                                        #
##########################################################################

%shub_01_00020_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RE_ENABLE_GFX_STALL"          => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Re-enable GFX stall logic for this processor" ],
   "RSVD0"                        => [   1,   1,  62, 0x7FFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BUSY"                         => [   2,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Busy" ],
);

%shub_01_00020_def =
( NAME    => "SH_GFX_WRITE_STATUS_0",
  ADDRESS => 0x0000000120040000,
  NOTE    => "Graphics Write Status for processor 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00020_flds
);


##########################################################################
#                                                                        #
#   SH_GFX_WRITE_STATUS_1                                                #
#                                                                        #
##########################################################################

%shub_01_00021_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RE_ENABLE_GFX_STALL"          => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Re-enable GFX stall logic for this processor" ],
   "RSVD0"                        => [   1,   1,  62, 0x7FFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BUSY"                         => [   2,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Busy" ],
);

%shub_01_00021_def =
( NAME    => "SH_GFX_WRITE_STATUS_1",
  ADDRESS => 0x0000000120040080,
  NOTE    => "Graphics Write Status for processor 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00021_flds
);


##########################################################################
#                                                                        #
#   SH_II_INT0                                                           #
#                                                                        #
##########################################################################

%shub_01_00022_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND"                         => [   1,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Send Interrupt" ],
   "IDX"                          => [   2,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
);

%shub_01_00022_def =
( NAME    => "SH_II_INT0",
  ADDRESS => 0x0000000110000000,
  NOTE    => "SHub II Interrupt 0 Send",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00022_flds
);


##########################################################################
#                                                                        #
#   SH_II_INT0_CONFIG                                                    #
#                                                                        #
##########################################################################

%shub_01_00023_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  50,  14, 0xFFFC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE"                         => [   1,  21,  29, 0x0003FFFFFFE00000, 0x00, 1, 0x0000000000000000, "Optional Vector Area" ],
   "RSVD1"                        => [   2,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   3,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   4,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   5,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Interrupt Type" ],
);

%shub_01_00023_def =
( NAME    => "SH_II_INT0_CONFIG",
  ADDRESS => 0x0000000110000080,
  NOTE    => "SHub II Interrupt 0 Configuration Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00023_flds
);


##########################################################################
#                                                                        #
#   SH_II_INT0_ENABLE                                                    #
#                                                                        #
##########################################################################

%shub_01_00024_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "II_ENABLE"                    => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable II Interrupt 0" ],
);

%shub_01_00024_def =
( NAME    => "SH_II_INT0_ENABLE",
  ADDRESS => 0x0000000110000200,
  NOTE    => "SHub II Interrupt 0 Enable Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00024_flds
);


##########################################################################
#                                                                        #
#   SH_II_INT1                                                           #
#                                                                        #
##########################################################################

%shub_01_00025_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND"                         => [   1,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Send Interrupt" ],
   "IDX"                          => [   2,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
);

%shub_01_00025_def =
( NAME    => "SH_II_INT1",
  ADDRESS => 0x0000000110000100,
  NOTE    => "SHub II Interrupt 1 Send",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00025_flds
);


##########################################################################
#                                                                        #
#   SH_II_INT1_CONFIG                                                    #
#                                                                        #
##########################################################################

%shub_01_00026_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  50,  14, 0xFFFC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE"                         => [   1,  21,  29, 0x0003FFFFFFE00000, 0x00, 1, 0x0000000000000000, "Optional Vector Area" ],
   "RSVD1"                        => [   2,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   3,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   4,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   5,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Interrupt Type" ],
);

%shub_01_00026_def =
( NAME    => "SH_II_INT1_CONFIG",
  ADDRESS => 0x0000000110000180,
  NOTE    => "SHub II Interrupt 1 Configuration Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00026_flds
);


##########################################################################
#                                                                        #
#   SH_II_INT1_ENABLE                                                    #
#                                                                        #
##########################################################################

%shub_01_00027_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "II_ENABLE"                    => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable II Interrupt 1" ],
);

%shub_01_00027_def =
( NAME    => "SH_II_INT1_ENABLE",
  ADDRESS => 0x0000000110000280,
  NOTE    => "SHub II Interrupt 1 Enable Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00027_flds
);


##########################################################################
#                                                                        #
#   SH_INT_NODE_ID_CONFIG                                                #
#                                                                        #
##########################################################################

%shub_01_00028_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  12,  52, 0xFFFFFFFFFFFFF000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ID_SEL"                       => [   1,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "Select" ],
   "NODE_ID"                      => [   2,   0,  11, 0x00000000000007FF, 0x00, 1, 0x0000000000000000, "Node ID" ],
);

%shub_01_00028_def =
( NAME    => "SH_INT_NODE_ID_CONFIG",
  ADDRESS => 0x0000000110000300,
  NOTE    => "SHub Interrupt Node ID Configuration",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00028_flds
);


##########################################################################
#                                                                        #
#   SH_IPI_INT                                                           #
#                                                                        #
##########################################################################

%shub_01_00029_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SEND"                         => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Send Interrupt" ],
   "RSVD0"                        => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   2,  52,   8, 0x0FF0000000000000, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   3,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE"                         => [   4,  21,  29, 0x0003FFFFFFE00000, 0x00, 1, 0x0000000000000000, "Optional Vector Area" ],
   "RSVD2"                        => [   5,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   6,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   7,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   8,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Interrupt Type" ],
);

%shub_01_00029_def =
( NAME    => "SH_IPI_INT",
  ADDRESS => 0x0000000110000380,
  NOTE    => "SHub Inter-Processor Interrupt Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00029_flds
);


##########################################################################
#                                                                        #
#   SH_IPI_INT_ENABLE                                                    #
#                                                                        #
##########################################################################

%shub_01_00030_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_ENABLE"                   => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable IPI Interrupt" ],
);

%shub_01_00030_def =
( NAME    => "SH_IPI_INT_ENABLE",
  ADDRESS => 0x0000000110000400,
  NOTE    => "SHub Inter-Processor Interrupt Enable Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00030_flds
);


##########################################################################
#                                                                        #
#   SH_LOCAL_INT0_CONFIG                                                 #
#                                                                        #
##########################################################################

%shub_01_00031_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE"                         => [   3,  21,  29, 0x0003FFFFFFE00000, 0x00, 1, 0x0000000000000000, "Optional Vector Area" ],
   "RSVD2"                        => [   4,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   5,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   6,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   7,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Interrupt Type" ],
);

%shub_01_00031_def =
( NAME    => "SH_LOCAL_INT0_CONFIG",
  ADDRESS => 0x0000000110000480,
  NOTE    => "SHub Local Interrupt 0 Configuration Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00031_flds
);


##########################################################################
#                                                                        #
#   SH_LOCAL_INT0_ENABLE                                                 #
#                                                                        #
##########################################################################

%shub_01_00032_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STOP_CLOCK"                   => [   1,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Stop Clock Interrupt" ],
   "L1_NMI_INT"                   => [   2,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Enable L1 Controller NMI Interrupt" ],
   "UART_INT"                     => [   3,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Enable Junk Bus UART Interrupt" ],
   "SYSTEM_SHUTDOWN_INT"          => [   4,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Enable System Shutdown Interrupt" ],
   "RSVD1"                        => [   5,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_UCE_INT"                   => [   6,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "Enable XN Correctable Error Interrupt" ],
   "MD_UCE_INT"                   => [   7,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Enable MD Correctable Error Interrupt" ],
   "PI_UCE_INT"                   => [   8,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Enable PI Correctable Error Interrupt" ],
   "XN_CE_INT"                    => [   9,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Enable XN Correctable Error Interrupt" ],
   "MD_CE_INT"                    => [  10,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Enable MD Correctable Error Interrupt" ],
   "PI_CE_INT"                    => [  11,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Enable PI Correctable Error Interrupt" ],
   "II_HW_INT"                    => [  12,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Enable II wrapper Hardware interrupt" ],
   "LB_HW_INT"                    => [  13,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Enable LB Hardware interrupt" ],
   "XN_HW_INT"                    => [  14,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Enable XN Hardware interrupt" ],
   "MD_HW_INT"                    => [  15,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Enable MD Hardware interrupt" ],
   "PI_HW_INT"                    => [  16,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable PI Hardware interrupt" ],
);

%shub_01_00032_def =
( NAME    => "SH_LOCAL_INT0_ENABLE",
  ADDRESS => 0x0000000110000500,
  NOTE    => "SHub Local Interrupt 0 Enable",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00032_flds
);


##########################################################################
#                                                                        #
#   SH_LOCAL_INT1_CONFIG                                                 #
#                                                                        #
##########################################################################

%shub_01_00033_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE"                         => [   3,  21,  29, 0x0003FFFFFFE00000, 0x00, 1, 0x0000000000000000, "Optional Vector Area" ],
   "RSVD2"                        => [   4,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   5,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   6,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   7,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Interrupt Type" ],
);

%shub_01_00033_def =
( NAME    => "SH_LOCAL_INT1_CONFIG",
  ADDRESS => 0x0000000110000580,
  NOTE    => "SHub Local Interrupt 1 Configuration Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00033_flds
);


##########################################################################
#                                                                        #
#   SH_LOCAL_INT1_ENABLE                                                 #
#                                                                        #
##########################################################################

%shub_01_00034_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STOP_CLOCK"                   => [   1,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Stop Clock Interrupt" ],
   "L1_NMI_INT"                   => [   2,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Enable L1 Controller NMI Interrupt" ],
   "UART_INT"                     => [   3,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Enable Junk Bus UART Interrupt" ],
   "SYSTEM_SHUTDOWN_INT"          => [   4,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Enable System Shutdown Interrupt" ],
   "RSVD1"                        => [   5,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_UCE_INT"                   => [   6,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "Enable XN Correctable Error Interrupt" ],
   "MD_UCE_INT"                   => [   7,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Enable MD Correctable Error Interrupt" ],
   "PI_UCE_INT"                   => [   8,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Enable PI Correctable Error Interrupt" ],
   "XN_CE_INT"                    => [   9,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Enable XN Correctable Error Interrupt" ],
   "MD_CE_INT"                    => [  10,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Enable MD Correctable Error Interrupt" ],
   "PI_CE_INT"                    => [  11,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Enable PI Correctable Error Interrupt" ],
   "II_HW_INT"                    => [  12,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Enable II wrapper Hardware interrupt" ],
   "LB_HW_INT"                    => [  13,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Enable LB Hardware interrupt" ],
   "XN_HW_INT"                    => [  14,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Enable XN Hardware interrupt" ],
   "MD_HW_INT"                    => [  15,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Enable MD Hardware interrupt" ],
   "PI_HW_INT"                    => [  16,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable PI Hardware interrupt" ],
);

%shub_01_00034_def =
( NAME    => "SH_LOCAL_INT1_ENABLE",
  ADDRESS => 0x0000000110000600,
  NOTE    => "SHub Local Interrupt 1 Enable",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00034_flds
);


##########################################################################
#                                                                        #
#   SH_LOCAL_INT2_CONFIG                                                 #
#                                                                        #
##########################################################################

%shub_01_00035_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE"                         => [   3,  21,  29, 0x0003FFFFFFE00000, 0x00, 1, 0x0000000000000000, "Optional Vector Area" ],
   "RSVD2"                        => [   4,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   5,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   6,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   7,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Interrupt Type" ],
);

%shub_01_00035_def =
( NAME    => "SH_LOCAL_INT2_CONFIG",
  ADDRESS => 0x0000000110000680,
  NOTE    => "SHub Local Interrupt 2 Configuration Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00035_flds
);


##########################################################################
#                                                                        #
#   SH_LOCAL_INT2_ENABLE                                                 #
#                                                                        #
##########################################################################

%shub_01_00036_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STOP_CLOCK"                   => [   1,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Stop Clock Interrupt" ],
   "L1_NMI_INT"                   => [   2,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Enable L1 Controller NMI Interrupt" ],
   "UART_INT"                     => [   3,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Enable Junk Bus UART Interrupt" ],
   "SYSTEM_SHUTDOWN_INT"          => [   4,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Enable System Shutdown Interrupt" ],
   "RSVD1"                        => [   5,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_UCE_INT"                   => [   6,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "Enable XN Correctable Error Interrupt" ],
   "MD_UCE_INT"                   => [   7,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Enable MD Correctable Error Interrupt" ],
   "PI_UCE_INT"                   => [   8,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Enable PI Correctable Error Interrupt" ],
   "XN_CE_INT"                    => [   9,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Enable XN Correctable Error Interrupt" ],
   "MD_CE_INT"                    => [  10,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Enable MD Correctable Error Interrupt" ],
   "PI_CE_INT"                    => [  11,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Enable PI Correctable Error Interrupt" ],
   "II_HW_INT"                    => [  12,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Enable II wrapper Hardware interrupt" ],
   "LB_HW_INT"                    => [  13,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Enable LB Hardware interrupt" ],
   "XN_HW_INT"                    => [  14,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Enable XN Hardware interrupt" ],
   "MD_HW_INT"                    => [  15,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Enable MD Hardware interrupt" ],
   "PI_HW_INT"                    => [  16,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable PI Hardware interrupt" ],
);

%shub_01_00036_def =
( NAME    => "SH_LOCAL_INT2_ENABLE",
  ADDRESS => 0x0000000110000700,
  NOTE    => "SHub Local Interrupt 2 Enable",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00036_flds
);


##########################################################################
#                                                                        #
#   SH_LOCAL_INT3_CONFIG                                                 #
#                                                                        #
##########################################################################

%shub_01_00037_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE"                         => [   3,  21,  29, 0x0003FFFFFFE00000, 0x00, 1, 0x0000000000000000, "Optional Vector Area" ],
   "RSVD2"                        => [   4,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   5,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   6,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   7,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Interrupt Type" ],
);

%shub_01_00037_def =
( NAME    => "SH_LOCAL_INT3_CONFIG",
  ADDRESS => 0x0000000110000780,
  NOTE    => "SHub Local Interrupt 3 Configuration Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00037_flds
);


##########################################################################
#                                                                        #
#   SH_LOCAL_INT3_ENABLE                                                 #
#                                                                        #
##########################################################################

%shub_01_00038_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STOP_CLOCK"                   => [   1,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Stop Clock Interrupt" ],
   "L1_NMI_INT"                   => [   2,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Enable L1 Controller NMI Interrupt" ],
   "UART_INT"                     => [   3,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Enable Junk Bus UART Interrupt" ],
   "SYSTEM_SHUTDOWN_INT"          => [   4,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Enable System Shutdown Interrupt" ],
   "RSVD1"                        => [   5,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_UCE_INT"                   => [   6,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "Enable XN Correctable Error Interrupt" ],
   "MD_UCE_INT"                   => [   7,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Enable MD Correctable Error Interrupt" ],
   "PI_UCE_INT"                   => [   8,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Enable PI Correctable Error Interrupt" ],
   "XN_CE_INT"                    => [   9,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Enable XN Correctable Error Interrupt" ],
   "MD_CE_INT"                    => [  10,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Enable MD Correctable Error Interrupt" ],
   "PI_CE_INT"                    => [  11,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Enable PI Correctable Error Interrupt" ],
   "II_HW_INT"                    => [  12,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Enable II wrapper Hardware interrupt" ],
   "LB_HW_INT"                    => [  13,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Enable LB Hardware interrupt" ],
   "XN_HW_INT"                    => [  14,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Enable XN Hardware interrupt" ],
   "MD_HW_INT"                    => [  15,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Enable MD Hardware interrupt" ],
   "PI_HW_INT"                    => [  16,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable PI Hardware interrupt" ],
);

%shub_01_00038_def =
( NAME    => "SH_LOCAL_INT3_ENABLE",
  ADDRESS => 0x0000000110000800,
  NOTE    => "SHub Local Interrupt 3 Enable",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00038_flds
);


##########################################################################
#                                                                        #
#   SH_LOCAL_INT4_CONFIG                                                 #
#                                                                        #
##########################################################################

%shub_01_00039_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE"                         => [   3,  21,  29, 0x0003FFFFFFE00000, 0x00, 1, 0x0000000000000000, "Optional Vector Area" ],
   "RSVD2"                        => [   4,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   5,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   6,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   7,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Interrupt Type" ],
);

%shub_01_00039_def =
( NAME    => "SH_LOCAL_INT4_CONFIG",
  ADDRESS => 0x0000000110000880,
  NOTE    => "SHub Local Interrupt 4 Configuration Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00039_flds
);


##########################################################################
#                                                                        #
#   SH_LOCAL_INT4_ENABLE                                                 #
#                                                                        #
##########################################################################

%shub_01_00040_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STOP_CLOCK"                   => [   1,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Stop Clock Interrupt" ],
   "L1_NMI_INT"                   => [   2,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Enable L1 Controller NMI Interrupt" ],
   "UART_INT"                     => [   3,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Enable Junk Bus UART Interrupt" ],
   "SYSTEM_SHUTDOWN_INT"          => [   4,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Enable System Shutdown Interrupt" ],
   "RSVD1"                        => [   5,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_UCE_INT"                   => [   6,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "Enable XN Correctable Error Interrupt" ],
   "MD_UCE_INT"                   => [   7,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Enable MD Correctable Error Interrupt" ],
   "PI_UCE_INT"                   => [   8,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Enable PI Correctable Error Interrupt" ],
   "XN_CE_INT"                    => [   9,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Enable XN Correctable Error Interrupt" ],
   "MD_CE_INT"                    => [  10,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Enable MD Correctable Error Interrupt" ],
   "PI_CE_INT"                    => [  11,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Enable PI Correctable Error Interrupt" ],
   "II_HW_INT"                    => [  12,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Enable II wrapper Hardware interrupt" ],
   "LB_HW_INT"                    => [  13,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Enable LB Hardware interrupt" ],
   "XN_HW_INT"                    => [  14,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Enable XN Hardware interrupt" ],
   "MD_HW_INT"                    => [  15,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Enable MD Hardware interrupt" ],
   "PI_HW_INT"                    => [  16,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable PI Hardware interrupt" ],
);

%shub_01_00040_def =
( NAME    => "SH_LOCAL_INT4_ENABLE",
  ADDRESS => 0x0000000110000900,
  NOTE    => "SHub Local Interrupt 4 Enable",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00040_flds
);


##########################################################################
#                                                                        #
#   SH_LOCAL_INT5_CONFIG                                                 #
#                                                                        #
##########################################################################

%shub_01_00041_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE"                         => [   3,  21,  29, 0x0003FFFFFFE00000, 0x00, 1, 0x0000000000000000, "Optional Vector Area" ],
   "RSVD2"                        => [   4,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   5,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   6,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   7,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Interrupt Type" ],
);

%shub_01_00041_def =
( NAME    => "SH_LOCAL_INT5_CONFIG",
  ADDRESS => 0x0000000110000980,
  NOTE    => "SHub Local Interrupt 5 Configuration Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00041_flds
);


##########################################################################
#                                                                        #
#   SH_LOCAL_INT5_ENABLE                                                 #
#                                                                        #
##########################################################################

%shub_01_00042_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STOP_CLOCK"                   => [   1,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Stop Clock Interrupt" ],
   "L1_NMI_INT"                   => [   2,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Enable L1 Controller NMI Interrupt" ],
   "UART_INT"                     => [   3,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Enable Junk Bus UART Interrupt" ],
   "SYSTEM_SHUTDOWN_INT"          => [   4,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Enable System Shutdown Interrupt" ],
   "RSVD1"                        => [   5,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_UCE_INT"                   => [   6,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "Enable XN Correctable Error Interrupt" ],
   "MD_UCE_INT"                   => [   7,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Enable MD Correctable Error Interrupt" ],
   "PI_UCE_INT"                   => [   8,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Enable PI Correctable Error Interrupt" ],
   "XN_CE_INT"                    => [   9,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Enable XN Correctable Error Interrupt" ],
   "MD_CE_INT"                    => [  10,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Enable MD Correctable Error Interrupt" ],
   "PI_CE_INT"                    => [  11,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Enable PI Correctable Error Interrupt" ],
   "II_HW_INT"                    => [  12,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Enable II wrapper Hardware interrupt" ],
   "LB_HW_INT"                    => [  13,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Enable LB Hardware interrupt" ],
   "XN_HW_INT"                    => [  14,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Enable XN Hardware interrupt" ],
   "MD_HW_INT"                    => [  15,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Enable MD Hardware interrupt" ],
   "PI_HW_INT"                    => [  16,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable PI Hardware interrupt" ],
);

%shub_01_00042_def =
( NAME    => "SH_LOCAL_INT5_ENABLE",
  ADDRESS => 0x0000000110000a00,
  NOTE    => "SHub Local Interrupt 5 Enable",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00042_flds
);


##########################################################################
#                                                                        #
#   SH_PROC0_ERR_INT_CONFIG                                              #
#                                                                        #
##########################################################################

%shub_01_00043_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE"                         => [   3,  21,  29, 0x0003FFFFFFE00000, 0x00, 1, 0x0000000000000000, "Optional Vector Area" ],
   "RSVD2"                        => [   4,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   5,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   6,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   7,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Interrupt Type" ],
);

%shub_01_00043_def =
( NAME    => "SH_PROC0_ERR_INT_CONFIG",
  ADDRESS => 0x0000000110000a80,
  NOTE    => "SHub Processor 0 Error Interrupt Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00043_flds
);


##########################################################################
#                                                                        #
#   SH_PROC1_ERR_INT_CONFIG                                              #
#                                                                        #
##########################################################################

%shub_01_00044_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE"                         => [   3,  21,  29, 0x0003FFFFFFE00000, 0x00, 1, 0x0000000000000000, "Optional Vector Area" ],
   "RSVD2"                        => [   4,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   5,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   6,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   7,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Interrupt Type" ],
);

%shub_01_00044_def =
( NAME    => "SH_PROC1_ERR_INT_CONFIG",
  ADDRESS => 0x0000000110000b00,
  NOTE    => "SHub Processor 1 Error Interrupt Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00044_flds
);


##########################################################################
#                                                                        #
#   SH_PROC2_ERR_INT_CONFIG                                              #
#                                                                        #
##########################################################################

%shub_01_00045_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE"                         => [   3,  21,  29, 0x0003FFFFFFE00000, 0x00, 1, 0x0000000000000000, "Optional Vector Area" ],
   "RSVD2"                        => [   4,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   5,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   6,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   7,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Interrupt Type" ],
);

%shub_01_00045_def =
( NAME    => "SH_PROC2_ERR_INT_CONFIG",
  ADDRESS => 0x0000000110000b80,
  NOTE    => "SHub Processor 2 Error Interrupt Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00045_flds
);


##########################################################################
#                                                                        #
#   SH_PROC3_ERR_INT_CONFIG                                              #
#                                                                        #
##########################################################################

%shub_01_00046_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE"                         => [   3,  21,  29, 0x0003FFFFFFE00000, 0x00, 1, 0x0000000000000000, "Optional Vector Area" ],
   "RSVD2"                        => [   4,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   5,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   6,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   7,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Interrupt Type" ],
);

%shub_01_00046_def =
( NAME    => "SH_PROC3_ERR_INT_CONFIG",
  ADDRESS => 0x0000000110000c00,
  NOTE    => "SHub Processor 3 Error Interrupt Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00046_flds
);


##########################################################################
#                                                                        #
#   SH_PROC0_ADV_INT_CONFIG                                              #
#                                                                        #
##########################################################################

%shub_01_00047_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE"                         => [   3,  21,  29, 0x0003FFFFFFE00000, 0x00, 1, 0x0000000000000000, "Optional Vector Area" ],
   "RSVD2"                        => [   4,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   5,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   6,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   7,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Interrupt Type" ],
);

%shub_01_00047_def =
( NAME    => "SH_PROC0_ADV_INT_CONFIG",
  ADDRESS => 0x0000000110000c80,
  NOTE    => "SHub Processor 0 Advisory Interrupt Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00047_flds
);


##########################################################################
#                                                                        #
#   SH_PROC1_ADV_INT_CONFIG                                              #
#                                                                        #
##########################################################################

%shub_01_00048_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE"                         => [   3,  21,  29, 0x0003FFFFFFE00000, 0x00, 1, 0x0000000000000000, "Optional Vector Area" ],
   "RSVD2"                        => [   4,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   5,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   6,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   7,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Interrupt Type" ],
);

%shub_01_00048_def =
( NAME    => "SH_PROC1_ADV_INT_CONFIG",
  ADDRESS => 0x0000000110000d00,
  NOTE    => "SHub Processor 1 Advisory Interrupt Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00048_flds
);


##########################################################################
#                                                                        #
#   SH_PROC2_ADV_INT_CONFIG                                              #
#                                                                        #
##########################################################################

%shub_01_00049_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE"                         => [   3,  21,  29, 0x0003FFFFFFE00000, 0x00, 1, 0x0000000000000000, "Optional Vector Area" ],
   "RSVD2"                        => [   4,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   5,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   6,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   7,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Interrupt Type" ],
);

%shub_01_00049_def =
( NAME    => "SH_PROC2_ADV_INT_CONFIG",
  ADDRESS => 0x0000000110000d80,
  NOTE    => "SHub Processor 2 Advisory Interrupt Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00049_flds
);


##########################################################################
#                                                                        #
#   SH_PROC3_ADV_INT_CONFIG                                              #
#                                                                        #
##########################################################################

%shub_01_00050_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE"                         => [   3,  21,  29, 0x0003FFFFFFE00000, 0x00, 1, 0x0000000000000000, "Optional Vector Area" ],
   "RSVD2"                        => [   4,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   5,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   6,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   7,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Interrupt Type" ],
);

%shub_01_00050_def =
( NAME    => "SH_PROC3_ADV_INT_CONFIG",
  ADDRESS => 0x0000000110000e00,
  NOTE    => "SHub Processor 3 Advisory Interrupt Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00050_flds
);


##########################################################################
#                                                                        #
#   SH_PROC0_ERR_INT_ENABLE                                              #
#                                                                        #
##########################################################################

%shub_01_00051_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PROC0_ERR_ENABLE"             => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable Processor 0 Error Interrupt" ],
);

%shub_01_00051_def =
( NAME    => "SH_PROC0_ERR_INT_ENABLE",
  ADDRESS => 0x0000000110000e80,
  NOTE    => "SHub Processor 0 Error Interrupt Enable Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00051_flds
);


##########################################################################
#                                                                        #
#   SH_PROC1_ERR_INT_ENABLE                                              #
#                                                                        #
##########################################################################

%shub_01_00052_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PROC1_ERR_ENABLE"             => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable Processor 1 Error Interrupt" ],
);

%shub_01_00052_def =
( NAME    => "SH_PROC1_ERR_INT_ENABLE",
  ADDRESS => 0x0000000110000f00,
  NOTE    => "SHub Processor 1 Error Interrupt Enable Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00052_flds
);


##########################################################################
#                                                                        #
#   SH_PROC2_ERR_INT_ENABLE                                              #
#                                                                        #
##########################################################################

%shub_01_00053_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PROC2_ERR_ENABLE"             => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable Processor 2 Error Interrupt" ],
);

%shub_01_00053_def =
( NAME    => "SH_PROC2_ERR_INT_ENABLE",
  ADDRESS => 0x0000000110000f80,
  NOTE    => "SHub Processor 2 Error Interrupt Enable Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00053_flds
);


##########################################################################
#                                                                        #
#   SH_PROC3_ERR_INT_ENABLE                                              #
#                                                                        #
##########################################################################

%shub_01_00054_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PROC3_ERR_ENABLE"             => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable Processor 3 Error Interrupt" ],
);

%shub_01_00054_def =
( NAME    => "SH_PROC3_ERR_INT_ENABLE",
  ADDRESS => 0x0000000110001000,
  NOTE    => "SHub Processor 3 Error Interrupt Enable Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00054_flds
);


##########################################################################
#                                                                        #
#   SH_PROC0_ADV_INT_ENABLE                                              #
#                                                                        #
##########################################################################

%shub_01_00055_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PROC0_ADV_ENABLE"             => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable Processor 0 Advisory Interrupt" ],
);

%shub_01_00055_def =
( NAME    => "SH_PROC0_ADV_INT_ENABLE",
  ADDRESS => 0x0000000110001080,
  NOTE    => "SHub Processor 0 Advisory Interrupt Enable Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00055_flds
);


##########################################################################
#                                                                        #
#   SH_PROC1_ADV_INT_ENABLE                                              #
#                                                                        #
##########################################################################

%shub_01_00056_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PROC1_ADV_ENABLE"             => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable Processor 1 Advisory Interrupt" ],
);

%shub_01_00056_def =
( NAME    => "SH_PROC1_ADV_INT_ENABLE",
  ADDRESS => 0x0000000110001100,
  NOTE    => "SHub Processor 1 Advisory Interrupt Enable Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00056_flds
);


##########################################################################
#                                                                        #
#   SH_PROC2_ADV_INT_ENABLE                                              #
#                                                                        #
##########################################################################

%shub_01_00057_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PROC2_ADV_ENABLE"             => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable Processor 2 Advisory Interrupt" ],
);

%shub_01_00057_def =
( NAME    => "SH_PROC2_ADV_INT_ENABLE",
  ADDRESS => 0x0000000110001180,
  NOTE    => "SHub Processor 2 Advisory Interrupt Enable Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00057_flds
);


##########################################################################
#                                                                        #
#   SH_PROC3_ADV_INT_ENABLE                                              #
#                                                                        #
##########################################################################

%shub_01_00058_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PROC3_ADV_ENABLE"             => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable Processor 3 Advisory Interrupt" ],
);

%shub_01_00058_def =
( NAME    => "SH_PROC3_ADV_INT_ENABLE",
  ADDRESS => 0x0000000110001200,
  NOTE    => "SHub Processor 3 Advisory Interrupt Enable Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00058_flds
);


##########################################################################
#                                                                        #
#   SH_PROFILE_INT_CONFIG                                                #
#                                                                        #
##########################################################################

%shub_01_00059_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE"                         => [   3,  21,  29, 0x0003FFFFFFE00000, 0x00, 1, 0x0000000000000000, "Optional Vector Area" ],
   "RSVD2"                        => [   4,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   5,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   6,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   7,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Interrupt Type" ],
);

%shub_01_00059_def =
( NAME    => "SH_PROFILE_INT_CONFIG",
  ADDRESS => 0x0000000110001280,
  NOTE    => "SHub Profile Interrupt Configuration Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00059_flds
);


##########################################################################
#                                                                        #
#   SH_PROFILE_INT_ENABLE                                                #
#                                                                        #
##########################################################################

%shub_01_00060_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PROFILE_ENABLE"               => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable Profile Interrupt" ],
);

%shub_01_00060_def =
( NAME    => "SH_PROFILE_INT_ENABLE",
  ADDRESS => 0x0000000110001300,
  NOTE    => "SHub Profile Interrupt Enable Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00060_flds
);


##########################################################################
#                                                                        #
#   SH_RTC0_INT_CONFIG                                                   #
#                                                                        #
##########################################################################

%shub_01_00061_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE"                         => [   3,  21,  29, 0x0003FFFFFFE00000, 0x00, 1, 0x0000000000000000, "Optional Vector Area" ],
   "RSVD2"                        => [   4,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   5,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   6,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   7,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Interrupt Type" ],
);

%shub_01_00061_def =
( NAME    => "SH_RTC0_INT_CONFIG",
  ADDRESS => 0x0000000110001380,
  NOTE    => "SHub RTC 0 Interrupt Configuration Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00061_flds
);


##########################################################################
#                                                                        #
#   SH_RTC0_INT_ENABLE                                                   #
#                                                                        #
##########################################################################

%shub_01_00062_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RTC0_ENABLE"                  => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable RTC 0 Interrupt" ],
);

%shub_01_00062_def =
( NAME    => "SH_RTC0_INT_ENABLE",
  ADDRESS => 0x0000000110001400,
  NOTE    => "SHub RTC 0 Interrupt Enable Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00062_flds
);


##########################################################################
#                                                                        #
#   SH_RTC1_INT_CONFIG                                                   #
#                                                                        #
##########################################################################

%shub_01_00063_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE"                         => [   3,  21,  29, 0x0003FFFFFFE00000, 0x00, 1, 0x0000000000000000, "Optional Vector Area" ],
   "RSVD2"                        => [   4,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   5,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   6,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   7,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Interrupt Type" ],
);

%shub_01_00063_def =
( NAME    => "SH_RTC1_INT_CONFIG",
  ADDRESS => 0x0000000110001480,
  NOTE    => "SHub RTC 1 Interrupt Configuration Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00063_flds
);


##########################################################################
#                                                                        #
#   SH_RTC1_INT_ENABLE                                                   #
#                                                                        #
##########################################################################

%shub_01_00064_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RTC1_ENABLE"                  => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable RTC 1 Interrupt" ],
);

%shub_01_00064_def =
( NAME    => "SH_RTC1_INT_ENABLE",
  ADDRESS => 0x0000000110001500,
  NOTE    => "SHub RTC 1 Interrupt Enable Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00064_flds
);


##########################################################################
#                                                                        #
#   SH_RTC2_INT_CONFIG                                                   #
#                                                                        #
##########################################################################

%shub_01_00065_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE"                         => [   3,  21,  29, 0x0003FFFFFFE00000, 0x00, 1, 0x0000000000000000, "Optional Vector Area" ],
   "RSVD2"                        => [   4,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   5,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   6,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   7,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Interrupt Type" ],
);

%shub_01_00065_def =
( NAME    => "SH_RTC2_INT_CONFIG",
  ADDRESS => 0x0000000110001580,
  NOTE    => "SHub RTC 2 Interrupt Configuration Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00065_flds
);


##########################################################################
#                                                                        #
#   SH_RTC2_INT_ENABLE                                                   #
#                                                                        #
##########################################################################

%shub_01_00066_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RTC2_ENABLE"                  => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable RTC 2 Interrupt" ],
);

%shub_01_00066_def =
( NAME    => "SH_RTC2_INT_ENABLE",
  ADDRESS => 0x0000000110001600,
  NOTE    => "SHub RTC 2 Interrupt Enable Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00066_flds
);


##########################################################################
#                                                                        #
#   SH_RTC3_INT_CONFIG                                                   #
#                                                                        #
##########################################################################

%shub_01_00067_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE"                         => [   3,  21,  29, 0x0003FFFFFFE00000, 0x00, 1, 0x0000000000000000, "Optional Vector Area" ],
   "RSVD2"                        => [   4,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   5,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   6,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   7,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Interrupt Type" ],
);

%shub_01_00067_def =
( NAME    => "SH_RTC3_INT_CONFIG",
  ADDRESS => 0x0000000110001680,
  NOTE    => "SHub RTC 3 Interrupt Configuration Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00067_flds
);


##########################################################################
#                                                                        #
#   SH_RTC3_INT_ENABLE                                                   #
#                                                                        #
##########################################################################

%shub_01_00068_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RTC3_ENABLE"                  => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable RTC 3 Interrupt" ],
);

%shub_01_00068_def =
( NAME    => "SH_RTC3_INT_ENABLE",
  ADDRESS => 0x0000000110001700,
  NOTE    => "SHub RTC 3 Interrupt Enable Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00068_flds
);


##########################################################################
#                                                                        #
#   SH_EVENT_OCCURRED                                                    #
#                                                                        #
##########################################################################

%shub_01_00069_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "II_INT1"                      => [   1,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "II 1 Interrupt Pending" ],
   "II_INT0"                      => [   2,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "II 0 Interrupt Pending" ],
   "IPI_INT"                      => [   3,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "IPI Interrupt Pending" ],
   "PROFILE_INT"                  => [   4,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "Profile Interrupt Pending" ],
   "RTC3_INT"                     => [   5,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "RTC 3 Interrupt Pending" ],
   "RTC2_INT"                     => [   6,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "RTC 2 Interrupt Pending" ],
   "RTC1_INT"                     => [   7,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "RTC 1 Interrupt Pending" ],
   "RTC0_INT"                     => [   8,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "RTC 0 Interrupt Pending" ],
   "STOP_CLOCK"                   => [   9,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "Stop Clock Interrupt Pending" ],
   "L1_NMI_INT"                   => [  10,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "L1 Controller NMI Interrupt Pending" ],
   "UART_INT"                     => [  11,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "Junk Bus UART Interrupt Pending" ],
   "SYSTEM_SHUTDOWN_INT"          => [  12,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "System Shutdown Interrupt Pending" ],
   "PROC3_ERR_INT"                => [  13,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "Processor 3 Error Interrupt Pending" ],
   "PROC2_ERR_INT"                => [  14,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "Processor 2 Error Interrupt Pending" ],
   "PROC1_ERR_INT"                => [  15,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Processor 1 Error Interrupt Pending" ],
   "PROC0_ERR_INT"                => [  16,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Processor 0 Error Interrupt Pending" ],
   "PROC3_ADV_INT"                => [  17,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Processor 3 Advisory Interrupt Pending" ],
   "PROC2_ADV_INT"                => [  18,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Processor 2 Advisory Interrupt Pending" ],
   "PROC1_ADV_INT"                => [  19,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Processor 1 Advisory Interrupt Pending" ],
   "PROC0_ADV_INT"                => [  20,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "Processor 0 Advisory Interrupt Pending" ],
   "XN_UCE_INT"                   => [  21,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "XN Uncorrectable Error Interrupt Pending" ],
   "MD_UCE_INT"                   => [  22,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "MD Uncorrectable Error Interrupt Pending" ],
   "PI_UCE_INT"                   => [  23,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "PI Uncorrectable Error Interrupt Pending" ],
   "XN_CE_INT"                    => [  24,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "XN Correctable Error Interrupt Pending" ],
   "MD_CE_INT"                    => [  25,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "MD Correctable Error Interrupt Pending" ],
   "PI_CE_INT"                    => [  26,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "PI Correctable Error Interrupt Pending" ],
   "II_HW_INT"                    => [  27,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "II Wrapper Hardware Interrupt Pending" ],
   "LB_HW_INT"                    => [  28,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "LB Hardware Interrupt Pending" ],
   "XN_HW_INT"                    => [  29,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "XN Hardware Interrupt Pending" ],
   "MD_HW_INT"                    => [  30,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "MD Hardware Interrupt Pending" ],
   "PI_HW_INT"                    => [  31,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "PI Hardware Interrupt Pending" ],
);

%shub_01_00069_def =
( NAME    => "SH_EVENT_OCCURRED",
  ADDRESS => 0x0000000110010000,
  NOTE    => "Event Occurred",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00069_flds
);


##########################################################################
#                                                                        #
#   SH_EVENT_OCCURRED_ALIAS                                              #
#                                                                        #
##########################################################################

%shub_01_00070_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "II_INT1"                      => [   1,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "II 1 Interrupt Pending" ],
   "II_INT0"                      => [   2,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "II 0 Interrupt Pending" ],
   "IPI_INT"                      => [   3,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "IPI Interrupt Pending" ],
   "PROFILE_INT"                  => [   4,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "Profile Interrupt Pending" ],
   "RTC3_INT"                     => [   5,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "RTC 3 Interrupt Pending" ],
   "RTC2_INT"                     => [   6,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "RTC 2 Interrupt Pending" ],
   "RTC1_INT"                     => [   7,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "RTC 1 Interrupt Pending" ],
   "RTC0_INT"                     => [   8,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "RTC 0 Interrupt Pending" ],
   "STOP_CLOCK"                   => [   9,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "Stop Clock Interrupt Pending" ],
   "L1_NMI_INT"                   => [  10,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "L1 Controller NMI Interrupt Pending" ],
   "UART_INT"                     => [  11,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "Junk Bus UART Interrupt Pending" ],
   "SYSTEM_SHUTDOWN_INT"          => [  12,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "System Shutdown Interrupt Pending" ],
   "PROC3_ERR_INT"                => [  13,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "Processor 3 Error Interrupt Pending" ],
   "PROC2_ERR_INT"                => [  14,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "Processor 2 Error Interrupt Pending" ],
   "PROC1_ERR_INT"                => [  15,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Processor 1 Error Interrupt Pending" ],
   "PROC0_ERR_INT"                => [  16,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Processor 0 Error Interrupt Pending" ],
   "PROC3_ADV_INT"                => [  17,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Processor 3 Advisory Interrupt Pending" ],
   "PROC2_ADV_INT"                => [  18,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Processor 2 Advisory Interrupt Pending" ],
   "PROC1_ADV_INT"                => [  19,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Processor 1 Advisory Interrupt Pending" ],
   "PROC0_ADV_INT"                => [  20,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "Processor 0 Advisory Interrupt Pending" ],
   "XN_UCE_INT"                   => [  21,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "XN Uncorrectable Error Interrupt Pending" ],
   "MD_UCE_INT"                   => [  22,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "MD Uncorrectable Error Interrupt Pending" ],
   "PI_UCE_INT"                   => [  23,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "PI Uncorrectable Error Interrupt Pending" ],
   "XN_CE_INT"                    => [  24,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "XN Correctable Error Interrupt Pending" ],
   "MD_CE_INT"                    => [  25,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "MD Correctable Error Interrupt Pending" ],
   "PI_CE_INT"                    => [  26,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "PI Correctable Error Interrupt Pending" ],
   "II_HW_INT"                    => [  27,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "II Wrapper Hardware Interrupt Pending" ],
   "LB_HW_INT"                    => [  28,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "LB Hardware Interrupt Pending" ],
   "XN_HW_INT"                    => [  29,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "XN Hardware Interrupt Pending" ],
   "MD_HW_INT"                    => [  30,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "MD Hardware Interrupt Pending" ],
   "PI_HW_INT"                    => [  31,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "PI Hardware Interrupt Pending" ],
);

%shub_01_00070_def =
( NAME    => "SH_EVENT_OCCURRED_ALIAS",
  ADDRESS => 0x0000000110010008,
  NOTE    => "Event Occurred Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00070_flds
);


##########################################################################
#                                                                        #
#   SH_EVENT_OVERFLOW                                                    #
#                                                                        #
##########################################################################

%shub_01_00071_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PROFILE_INT"                  => [   1,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "Profile Interrupt Overflow" ],
   "RTC3_INT"                     => [   2,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "RTC 3 Interrupt Overflow" ],
   "RTC2_INT"                     => [   3,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "RTC 2 Interrupt Overflow" ],
   "RTC1_INT"                     => [   4,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "RTC 1 Interrupt Overflow" ],
   "RTC0_INT"                     => [   5,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "RTC 0 Interrupt Overflow" ],
   "STOP_CLOCK"                   => [   6,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "Stop Clock Interrupt Overflow" ],
   "L1_NMI_INT"                   => [   7,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "L1 Controller NMI Interrupt Overflow" ],
   "UART_INT"                     => [   8,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "Junk Bus UART Interrupt Overflow" ],
   "SYSTEM_SHUTDOWN_INT"          => [   9,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "System Shutdown Interrupt Overflow" ],
   "PROC3_ERR_INT"                => [  10,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "Processor 3 Error Interrupt Overflow" ],
   "PROC2_ERR_INT"                => [  11,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "Processor 2 Error Interrupt Overflow" ],
   "PROC1_ERR_INT"                => [  12,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Processor 1 Error Interrupt Overflow" ],
   "PROC0_ERR_INT"                => [  13,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Processor 0 Error Interrupt Overflow" ],
   "PROC3_ADV_INT"                => [  14,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Processor 3 Advisory Interrupt Overflow" ],
   "PROC2_ADV_INT"                => [  15,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Processor 2 Advisory Interrupt Overflow" ],
   "PROC1_ADV_INT"                => [  16,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Processor 1 Advisory Interrupt Overflow" ],
   "PROC0_ADV_INT"                => [  17,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "Processor 0 Advisory Interrupt Overflow" ],
   "XN_UCE_INT"                   => [  18,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "XN Correctable Error Interrupt Overflow" ],
   "MD_UCE_INT"                   => [  19,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "MD Correctable Error Interrupt Overflow" ],
   "PI_UCE_INT"                   => [  20,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "PI Correctable Error Interrupt Overflow" ],
   "XN_CE_INT"                    => [  21,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "XN Correctable Error Interrupt Overflow" ],
   "MD_CE_INT"                    => [  22,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "MD Correctable Error Interrupt Overflow" ],
   "PI_CE_INT"                    => [  23,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "PI Correctable Error Interrupt Overflow" ],
   "II_HW_INT"                    => [  24,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "II Wrapper Hardware Interrupt Overflow" ],
   "LB_HW_INT"                    => [  25,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "LB Hardware Interrupt Overflow" ],
   "XN_HW_INT"                    => [  26,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "XN Hardware Interrupt Overflow" ],
   "MD_HW_INT"                    => [  27,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "MD Hardware Interrupt Overflow" ],
   "PI_HW_INT"                    => [  28,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "PI Hardware Interrupt Overflow" ],
);

%shub_01_00071_def =
( NAME    => "SH_EVENT_OVERFLOW",
  ADDRESS => 0x0000000110010080,
  NOTE    => "Event Overflow",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00071_flds
);


##########################################################################
#                                                                        #
#   SH_EVENT_OVERFLOW_ALIAS                                              #
#                                                                        #
##########################################################################

%shub_01_00072_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PROFILE_INT"                  => [   1,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "Profile Interrupt Overflow" ],
   "RTC3_INT"                     => [   2,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "RTC 3 Interrupt Overflow" ],
   "RTC2_INT"                     => [   3,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "RTC 2 Interrupt Overflow" ],
   "RTC1_INT"                     => [   4,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "RTC 1 Interrupt Overflow" ],
   "RTC0_INT"                     => [   5,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "RTC 0 Interrupt Overflow" ],
   "STOP_CLOCK"                   => [   6,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "Stop Clock Interrupt Overflow" ],
   "L1_NMI_INT"                   => [   7,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "L1 Controller NMI Interrupt Overflow" ],
   "UART_INT"                     => [   8,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "Junk Bus UART Interrupt Overflow" ],
   "SYSTEM_SHUTDOWN_INT"          => [   9,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "System Shutdown Interrupt Overflow" ],
   "PROC3_ERR_INT"                => [  10,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "Processor 3 Error Interrupt Overflow" ],
   "PROC2_ERR_INT"                => [  11,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "Processor 2 Error Interrupt Overflow" ],
   "PROC1_ERR_INT"                => [  12,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Processor 1 Error Interrupt Overflow" ],
   "PROC0_ERR_INT"                => [  13,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Processor 0 Error Interrupt Overflow" ],
   "PROC3_ADV_INT"                => [  14,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Processor 3 Advisory Interrupt Overflow" ],
   "PROC2_ADV_INT"                => [  15,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Processor 2 Advisory Interrupt Overflow" ],
   "PROC1_ADV_INT"                => [  16,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Processor 1 Advisory Interrupt Overflow" ],
   "PROC0_ADV_INT"                => [  17,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "Processor 0 Advisory Interrupt Overflow" ],
   "XN_UCE_INT"                   => [  18,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "XN Correctable Error Interrupt Overflow" ],
   "MD_UCE_INT"                   => [  19,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "MD Correctable Error Interrupt Overflow" ],
   "PI_UCE_INT"                   => [  20,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "PI Correctable Error Interrupt Overflow" ],
   "XN_CE_INT"                    => [  21,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "XN Correctable Error Interrupt Overflow" ],
   "MD_CE_INT"                    => [  22,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "MD Correctable Error Interrupt Overflow" ],
   "PI_CE_INT"                    => [  23,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "PI Correctable Error Interrupt Overflow" ],
   "II_HW_INT"                    => [  24,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "II Wrapper Hardware Interrupt Overflow" ],
   "LB_HW_INT"                    => [  25,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "LB Hardware Interrupt Overflow" ],
   "XN_HW_INT"                    => [  26,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "XN Hardware Interrupt Overflow" ],
   "MD_HW_INT"                    => [  27,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "MD Hardware Interrupt Overflow" ],
   "PI_HW_INT"                    => [  28,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "PI Hardware Interrupt Overflow" ],
);

%shub_01_00072_def =
( NAME    => "SH_EVENT_OVERFLOW_ALIAS",
  ADDRESS => 0x0000000110010088,
  NOTE    => "Event Overflow Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00072_flds
);


##########################################################################
#                                                                        #
#   SH_JUNK_BUS_TIME                                                     #
#                                                                        #
##########################################################################

%shub_01_00073_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UART_ENABLE"                  => [   1,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "Uart_Enable" ],
   "UART_SETUP_HOLD"              => [   2,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Uart_Setup_Hold" ],
   "FPROM_ENABLE"                 => [   3,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Fprom_Enable" ],
   "FPROM_SETUP_HOLD"             => [   4,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Fprom_Setup_Hold" ],
);

%shub_01_00073_def =
( NAME    => "SH_JUNK_BUS_TIME",
  ADDRESS => 0x0000000110020000,
  NOTE    => "Junk Bus Timing",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00073_flds
);


##########################################################################
#                                                                        #
#   SH_JUNK_LATCH_TIME                                                   #
#                                                                        #
##########################################################################

%shub_01_00074_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   3,  61, 0xFFFFFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SETUP_HOLD"                   => [   1,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Setup and Hold Time" ],
);

%shub_01_00074_def =
( NAME    => "SH_JUNK_LATCH_TIME",
  ADDRESS => 0x0000000110020080,
  NOTE    => "Junk Bus Latch Timing",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00074_flds
);


##########################################################################
#                                                                        #
#   SH_JUNK_NACK_RESET                                                   #
#                                                                        #
##########################################################################

%shub_01_00075_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PULSE"                        => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Junk bus nack counter reset" ],
);

%shub_01_00075_def =
( NAME    => "SH_JUNK_NACK_RESET",
  ADDRESS => 0x0000000110020100,
  NOTE    => "Junk Bus Nack Counter Reset",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00075_flds
);


##########################################################################
#                                                                        #
#   SH_JUNK_BUS_LED0                                                     #
#                                                                        #
##########################################################################

%shub_01_00076_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LED0_DATA"                    => [   1,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "LED0_data" ],
);

%shub_01_00076_def =
( NAME    => "SH_JUNK_BUS_LED0",
  ADDRESS => 0x0000000110030000,
  NOTE    => "Junk Bus LED0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00076_flds
);


##########################################################################
#                                                                        #
#   SH_JUNK_BUS_LED1                                                     #
#                                                                        #
##########################################################################

%shub_01_00077_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LED1_DATA"                    => [   1,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "LED1_data" ],
);

%shub_01_00077_def =
( NAME    => "SH_JUNK_BUS_LED1",
  ADDRESS => 0x0000000110030080,
  NOTE    => "Junk Bus LED1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00077_flds
);


##########################################################################
#                                                                        #
#   SH_JUNK_BUS_LED2                                                     #
#                                                                        #
##########################################################################

%shub_01_00078_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LED2_DATA"                    => [   1,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "LED2_data" ],
);

%shub_01_00078_def =
( NAME    => "SH_JUNK_BUS_LED2",
  ADDRESS => 0x0000000110030100,
  NOTE    => "Junk Bus LED2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00078_flds
);


##########################################################################
#                                                                        #
#   SH_JUNK_BUS_LED3                                                     #
#                                                                        #
##########################################################################

%shub_01_00079_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LED3_DATA"                    => [   1,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "LED3_data" ],
);

%shub_01_00079_def =
( NAME    => "SH_JUNK_BUS_LED3",
  ADDRESS => 0x0000000110030180,
  NOTE    => "Junk Bus LED3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00079_flds
);


##########################################################################
#                                                                        #
#   SH_JUNK_ERROR_STATUS                                                 #
#                                                                        #
##########################################################################

%shub_01_00080_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STATUS"                       => [   1,  57,   4, 0x1E00000000000000, 0x00, 0, 0x0000000000000000, "Status" ],
   "MODE"                         => [   2,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "Mode" ],
   "CMD"                          => [   3,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "Junk bus command" ],
   "RSVD1"                        => [   4,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDRESS"                      => [   5,   0,  47, 0x00007FFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Failing junk bus address" ],
);

%shub_01_00080_def =
( NAME    => "SH_JUNK_ERROR_STATUS",
  ADDRESS => 0x0000000110030200,
  NOTE    => "Junk Bus Error Status",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00080_flds
);


##########################################################################
#                                                                        #
#   SH_NI0_LLP_STAT                                                      #
#                                                                        #
##########################################################################

%shub_01_00081_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   4,  60, 0xFFFFFFFFFFFFFFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LINK_RESET_STATE"             => [   1,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Status of LLP link." ],
);

%shub_01_00081_def =
( NAME    => "SH_NI0_LLP_STAT",
  ADDRESS => 0x0000000150000000,
  NOTE    => "This register describes the LLP status.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00081_flds
);


##########################################################################
#                                                                        #
#   SH_NI0_LLP_RESET                                                     #
#                                                                        #
##########################################################################

%shub_01_00082_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   2,  62, 0xFFFFFFFFFFFFFFFC, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WARM"                         => [   1,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Send Warm Reset. Generates a pulse." ],
   "LINK"                         => [   2,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Send Link Reset. Generates a pulse." ],
);

%shub_01_00082_def =
( NAME    => "SH_NI0_LLP_RESET",
  ADDRESS => 0x0000000150000008,
  NOTE    => "Writing issues a reset to the network interface",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00082_flds
);


##########################################################################
#                                                                        #
#   SH_NI0_LLP_RESET_EN                                                  #
#                                                                        #
##########################################################################

%shub_01_00083_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OK"                           => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Allow LLP warm reset to reset SHUB" ],
);

%shub_01_00083_def =
( NAME    => "SH_NI0_LLP_RESET_EN",
  ADDRESS => 0x0000000150000010,
  NOTE    => "Controls LLP warm reset propagation",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00083_flds
);


##########################################################################
#                                                                        #
#   SH_NI0_LLP_CHAN_MODE                                                 #
#                                                                        #
##########################################################################

%shub_01_00084_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_CLKQUAD"               => [   1,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Enables quadrature clock in the pfssd" ],
   "ENABLE_RMT_FT_UPD"            => [   2,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Enables remote fine tune updates" ],
   "ENABLE_TUNING"                => [   3,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Enables automatic tuning of channel skew." ],
   "AC_ENCODE"                    => [   4,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Enables nearly dc-free encoding for AC-coupling" ],
   "BITMODE32"                    => [   5,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Enables 32-bit (plus sideband) channel phits" ],
);

%shub_01_00084_def =
( NAME    => "SH_NI0_LLP_CHAN_MODE",
  ADDRESS => 0x0000000150000018,
  NOTE    => "Sets the signaling mode of LLP and channel",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00084_flds
);


##########################################################################
#                                                                        #
#   SH_NI0_LLP_CONFIG                                                    #
#                                                                        #
##########################################################################

%shub_01_00085_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FTU_TIME"                     => [   1,  26,  12, 0x0000003FFC000000, 0x00, 1, 0x0000000000000000, "" ],
   "NULLTIMEOUT"                  => [   2,  20,   6, 0x0000000003F00000, 0x00, 1, 0x0000000000000000, "" ],
   "MAXRETRY"                     => [   3,  10,  10, 0x00000000000FFC00, 0x00, 1, 0x0000000000000000, "" ],
   "MAXBURST"                     => [   4,   0,  10, 0x00000000000003FF, 0x00, 1, 0x0000000000000000, "" ],
);

%shub_01_00085_def =
( NAME    => "SH_NI0_LLP_CONFIG",
  ADDRESS => 0x0000000150000020,
  NOTE    => "Sets the configuration of LLP and channel",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00085_flds
);


##########################################################################
#                                                                        #
#   SH_NI0_LLP_TEST_CTL                                                  #
#                                                                        #
##########################################################################

%shub_01_00086_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CBERROR"                      => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Indicates a Micropacket with a CB error was captured" ],
   "CAPTURED"                     => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "Indicates a Valid Micropacket was captured" ],
   "FAKESNERROR"                  => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "Causes receiver to pretend it saw a sn error" ],
   "SENDSNERROR"                  => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Sends a single sequence number error" ],
   "SENDCBERROR"                  => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "Sends a single error" ],
   "CAPTURECBONLY"                => [   6,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "Only capture a micropacket with a Check Byte error" ],
   "ARMCAPTURE"                   => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "Enable Capture of Next MicroPacket" ],
   "NOISE_MODE"                   => [   8,  54,   2, 0x00C0000000000000, 0x00, 1, 0x0000000000000000, "" ],
   "LFSR_MODE"                    => [   9,  52,   2, 0x0030000000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD1"                        => [  10,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WIRE_SEL"                     => [  11,  44,   6, 0x0003F00000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD2"                        => [  12,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_TEST_MODE"               => [  13,  40,   2, 0x0000030000000000, 0x00, 1, 0x0000000000000000, "Enables continuous send of data" ],
   "PATTERN"                      => [  14,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Send channel data pattern" ],
);

%shub_01_00086_def =
( NAME    => "SH_NI0_LLP_TEST_CTL",
  ADDRESS => 0x0000000150000028,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00086_flds
);


##########################################################################
#                                                                        #
#   SH_NI0_LLP_CAPT_WD1                                                  #
#                                                                        #
##########################################################################

%shub_01_00087_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "low order 64-bit captured word" ],
);

%shub_01_00087_def =
( NAME    => "SH_NI0_LLP_CAPT_WD1",
  ADDRESS => 0x0000000150000030,
  NOTE    => "low order 64-bit captured word",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00087_flds
);


##########################################################################
#                                                                        #
#   SH_NI0_LLP_CAPT_WD2                                                  #
#                                                                        #
##########################################################################

%shub_01_00088_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "high order 64-bit captured word" ],
);

%shub_01_00088_def =
( NAME    => "SH_NI0_LLP_CAPT_WD2",
  ADDRESS => 0x0000000150000038,
  NOTE    => "high order 64-bit captured word",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00088_flds
);


##########################################################################
#                                                                        #
#   SH_NI0_LLP_CAPT_SBCB                                                 #
#                                                                        #
##########################################################################

%shub_01_00089_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  37,  27, 0xFFFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CHARGEUNDERFLOW"              => [   1,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "wire charge counter underflowed, valid if llp_mode enabled" ],
   "CHARGEOVERFLOW"               => [   2,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "wire charge counter overflowed, valid if llp_mode enabled" ],
   "FAKEDALLSNERRORS"             => [   3,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "All faked SN errors have been sent" ],
   "SENTALLSNERRORS"              => [   4,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "All SN errors have been sent" ],
   "SENTALLCBERRORS"              => [   5,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "All CB errors have been sent" ],
   "CAPTUREDRCVCRC"               => [   6,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "CRC" ],
   "CAPTUREDRCVSBSN"              => [   7,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "sideband and sequence" ],
);

%shub_01_00089_def =
( NAME    => "SH_NI0_LLP_CAPT_SBCB",
  ADDRESS => 0x0000000150000040,
  NOTE    => "captured sideband, sequence, and CRC",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00089_flds
);


##########################################################################
#                                                                        #
#   SH_NI0_LLP_ERR                                                       #
#                                                                        #
##########################################################################

%shub_01_00090_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  53,  11, 0xFFE0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WIRE_OVERFLOW"                => [   1,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "wire_error_cnt has overflowed" ],
   "WIRE_CNT"                     => [   2,  28,  24, 0x000FFFFFF0000000, 0x00, 1, 0x0000000000000000, "counts the errors detected on a single wire test" ],
   "POWER_NOT_OK"                 => [   3,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "Detects and traps a loss of power_OK" ],
   "SQUASH"                       => [   4,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "Indicates a micropacket was squashed" ],
   "RCV_LINK_RESET"               => [   5,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Indicates a link reset has been received" ],
   "RETRY_TIMEOUT"                => [   6,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Indicates a retry timeout has occured" ],
   "RETRY_COUNT"                  => [   7,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Counts the retries" ],
   "RX_CB_ERR_COUNT"              => [   8,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Counts the check byte errors received" ],
   "RX_SN_ERR_COUNT"              => [   9,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Counts the sequence number errors received" ],
);

%shub_01_00090_def =
( NAME    => "SH_NI0_LLP_ERR",
  ADDRESS => 0x0000000150000048,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00090_flds
);


##########################################################################
#                                                                        #
#   SH_NI1_LLP_STAT                                                      #
#                                                                        #
##########################################################################

%shub_01_00091_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   4,  60, 0xFFFFFFFFFFFFFFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LINK_RESET_STATE"             => [   1,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Status of LLP link." ],
);

%shub_01_00091_def =
( NAME    => "SH_NI1_LLP_STAT",
  ADDRESS => 0x0000000150002000,
  NOTE    => "This register describes the LLP status.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00091_flds
);


##########################################################################
#                                                                        #
#   SH_NI1_LLP_RESET                                                     #
#                                                                        #
##########################################################################

%shub_01_00092_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   2,  62, 0xFFFFFFFFFFFFFFFC, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WARM"                         => [   1,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Send Warm Reset. Generates a pulse." ],
   "LINK"                         => [   2,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Send Link Reset. Generates a pulse." ],
);

%shub_01_00092_def =
( NAME    => "SH_NI1_LLP_RESET",
  ADDRESS => 0x0000000150002008,
  NOTE    => "Writing issues a reset to the network interface",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00092_flds
);


##########################################################################
#                                                                        #
#   SH_NI1_LLP_RESET_EN                                                  #
#                                                                        #
##########################################################################

%shub_01_00093_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OK"                           => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Allow LLP warm reset to reset SHUB" ],
);

%shub_01_00093_def =
( NAME    => "SH_NI1_LLP_RESET_EN",
  ADDRESS => 0x0000000150002010,
  NOTE    => "Controls LLP warm reset propagation",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00093_flds
);


##########################################################################
#                                                                        #
#   SH_NI1_LLP_CHAN_MODE                                                 #
#                                                                        #
##########################################################################

%shub_01_00094_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_CLKQUAD"               => [   1,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Enables quadrature clock in the pfssd" ],
   "ENABLE_RMT_FT_UPD"            => [   2,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Enables remote fine tune updates" ],
   "ENABLE_TUNING"                => [   3,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Enables automatic tuning of channel skew." ],
   "AC_ENCODE"                    => [   4,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Enables nearly dc-free encoding for AC-coupling" ],
   "BITMODE32"                    => [   5,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Enables 32-bit (plus sideband) channel phits" ],
);

%shub_01_00094_def =
( NAME    => "SH_NI1_LLP_CHAN_MODE",
  ADDRESS => 0x0000000150002018,
  NOTE    => "Sets the signaling mode of LLP and channel",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00094_flds
);


##########################################################################
#                                                                        #
#   SH_NI1_LLP_CONFIG                                                    #
#                                                                        #
##########################################################################

%shub_01_00095_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FTU_TIME"                     => [   1,  26,  12, 0x0000003FFC000000, 0x00, 1, 0x0000000000000000, "" ],
   "NULLTIMEOUT"                  => [   2,  20,   6, 0x0000000003F00000, 0x00, 1, 0x0000000000000000, "" ],
   "MAXRETRY"                     => [   3,  10,  10, 0x00000000000FFC00, 0x00, 1, 0x0000000000000000, "" ],
   "MAXBURST"                     => [   4,   0,  10, 0x00000000000003FF, 0x00, 1, 0x0000000000000000, "" ],
);

%shub_01_00095_def =
( NAME    => "SH_NI1_LLP_CONFIG",
  ADDRESS => 0x0000000150002020,
  NOTE    => "Sets the configuration of LLP and channel",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00095_flds
);


##########################################################################
#                                                                        #
#   SH_NI1_LLP_TEST_CTL                                                  #
#                                                                        #
##########################################################################

%shub_01_00096_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CBERROR"                      => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Indicates a Micropacket with a CB error was captured" ],
   "CAPTURED"                     => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "Indicates a Valid Micropacket was captured" ],
   "FAKESNERROR"                  => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "Causes receiver to pretend it saw a sn error" ],
   "SENDSNERROR"                  => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Sends a single sequence number error" ],
   "SENDCBERROR"                  => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "Sends a single error" ],
   "CAPTURECBONLY"                => [   6,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "Only capture a micropacket with a Check Byte error" ],
   "ARMCAPTURE"                   => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "Enable Capture of Next MicroPacket" ],
   "NOISE_MODE"                   => [   8,  54,   2, 0x00C0000000000000, 0x00, 1, 0x0000000000000000, "" ],
   "LFSR_MODE"                    => [   9,  52,   2, 0x0030000000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD1"                        => [  10,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WIRE_SEL"                     => [  11,  44,   6, 0x0003F00000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD2"                        => [  12,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_TEST_MODE"               => [  13,  40,   2, 0x0000030000000000, 0x00, 1, 0x0000000000000000, "Enables continuous send of data" ],
   "PATTERN"                      => [  14,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Send channel data pattern" ],
);

%shub_01_00096_def =
( NAME    => "SH_NI1_LLP_TEST_CTL",
  ADDRESS => 0x0000000150002028,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00096_flds
);


##########################################################################
#                                                                        #
#   SH_NI1_LLP_CAPT_WD1                                                  #
#                                                                        #
##########################################################################

%shub_01_00097_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "low order 64-bit captured word" ],
);

%shub_01_00097_def =
( NAME    => "SH_NI1_LLP_CAPT_WD1",
  ADDRESS => 0x0000000150002030,
  NOTE    => "low order 64-bit captured word",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00097_flds
);


##########################################################################
#                                                                        #
#   SH_NI1_LLP_CAPT_WD2                                                  #
#                                                                        #
##########################################################################

%shub_01_00098_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "high order 64-bit captured word" ],
);

%shub_01_00098_def =
( NAME    => "SH_NI1_LLP_CAPT_WD2",
  ADDRESS => 0x0000000150002038,
  NOTE    => "high order 64-bit captured word",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00098_flds
);


##########################################################################
#                                                                        #
#   SH_NI1_LLP_CAPT_SBCB                                                 #
#                                                                        #
##########################################################################

%shub_01_00099_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  37,  27, 0xFFFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CHARGEUNDERFLOW"              => [   1,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "wire charge counter underflowed, valid if llp_mode enabled" ],
   "CHARGEOVERFLOW"               => [   2,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "wire charge counter overflowed, valid if llp_mode enabled" ],
   "FAKEDALLSNERRORS"             => [   3,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "All faked SN errors have been sent" ],
   "SENTALLSNERRORS"              => [   4,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "All SN errors have been sent" ],
   "SENTALLCBERRORS"              => [   5,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "All CB errors have been sent" ],
   "CAPTUREDRCVCRC"               => [   6,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "CRC" ],
   "CAPTUREDRCVSBSN"              => [   7,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "sideband and sequence" ],
);

%shub_01_00099_def =
( NAME    => "SH_NI1_LLP_CAPT_SBCB",
  ADDRESS => 0x0000000150002040,
  NOTE    => "captured sideband, sequence, and CRC",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00099_flds
);


##########################################################################
#                                                                        #
#   SH_NI1_LLP_ERR                                                       #
#                                                                        #
##########################################################################

%shub_01_00100_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  53,  11, 0xFFE0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WIRE_OVERFLOW"                => [   1,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "wire_error_cnt has overflowed" ],
   "WIRE_CNT"                     => [   2,  28,  24, 0x000FFFFFF0000000, 0x00, 1, 0x0000000000000000, "counts the errors detected on a single wire test" ],
   "POWER_NOT_OK"                 => [   3,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "Detects and traps a loss of power_OK" ],
   "SQUASH"                       => [   4,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "Indicates a micropacket was squashed" ],
   "RCV_LINK_RESET"               => [   5,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Indicates a link reset has been received" ],
   "RETRY_TIMEOUT"                => [   6,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Indicates a retry timeout has occured" ],
   "RETRY_COUNT"                  => [   7,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Counts the retries" ],
   "RX_CB_ERR_COUNT"              => [   8,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Counts the check byte errors received" ],
   "RX_SN_ERR_COUNT"              => [   9,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Counts the sequence number errors received" ],
);

%shub_01_00100_def =
( NAME    => "SH_NI1_LLP_ERR",
  ADDRESS => 0x0000000150002048,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00100_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI0_LLP_TO_FIFO02_FLOW                                          #
#                                                                        #
##########################################################################

%shub_01_00101_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "vc2 credit captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "vc2 credit dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "vc0 credit captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "vc0 credit dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_FORCE_CRED"         => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2 from debit cntr" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "vc2 withhold" ],
   "DEBIT_VC0_FORCE_CRED"         => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0 from debit cntr" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc0 withhold" ],
);

%shub_01_00101_def =
( NAME    => "SH_XNNI0_LLP_TO_FIFO02_FLOW",
  ADDRESS => 0x0000000150001010,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00101_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI0_LLP_TO_FIFO13_FLOW                                          #
#                                                                        #
##########################################################################

%shub_01_00102_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "vc2 credit captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "vc2 credit dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "vc0 credit captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "vc0 credit dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_FORCE_CRED"         => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2 from debit cntr" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "vc2 withhold" ],
   "DEBIT_VC0_FORCE_CRED"         => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0 from debit cntr" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc0 withhold" ],
);

%shub_01_00102_def =
( NAME    => "SH_XNNI0_LLP_TO_FIFO13_FLOW",
  ADDRESS => 0x0000000150001020,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00102_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI0_LLP_DEBIT_FLOW                                              #
#                                                                        #
##########################################################################

%shub_01_00103_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_CAP"                => [   1,  56,   5, 0x1F00000000000000, 0x00, 0, 0x0000000000000000, "vc3 debit captured value" ],
   "RSVD1"                        => [   2,  53,   3, 0x00E0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_DYN"                => [   3,  48,   5, 0x001F000000000000, 0x00, 0, 0x0000000000000000, "vc3 debit dynamic value" ],
   "RSVD2"                        => [   4,  45,   3, 0x0000E00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_CAP"                => [   5,  40,   5, 0x00001F0000000000, 0x00, 0, 0x0000000000000000, "vc2 debit captured value" ],
   "RSVD3"                        => [   6,  37,   3, 0x000000E000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_DYN"                => [   7,  32,   5, 0x0000001F00000000, 0x00, 0, 0x0000000000000000, "vc2 debit dynamic value" ],
   "RSVD4"                        => [   8,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_CAP"                => [   9,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "vc1 debit captured value" ],
   "RSVD5"                        => [  10,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_DYN"                => [  11,  16,   5, 0x00000000001F0000, 0x00, 0, 0x0000000000000000, "vc1 debit dynamic value" ],
   "RSVD6"                        => [  12,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_CAP"                => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "vc0 debit captured value" ],
   "RSVD7"                        => [  14,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_DYN"                => [  15,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "vc0 debit dynamic value" ],
);

%shub_01_00103_def =
( NAME    => "SH_XNNI0_LLP_DEBIT_FLOW",
  ADDRESS => 0x0000000150001030,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00103_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI0_LINK_0_FLOW                                                 #
#                                                                        #
##########################################################################

%shub_01_00104_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   1,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Captured vc0 credit" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   3,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Dynamic vc0 credit value" ],
   "RSVD2"                        => [   4,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_TEST"              => [   5,   8,   7, 0x0000000000007F00, 0x00, 1, 0x0000000000000000, "vc0 Limit Test" ],
   "DEBIT_VC0_FORCE_CRED"         => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on vc0 from debit cntr" ],
   "RSVD3"                        => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [   8,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc0 withhold" ],
);

%shub_01_00104_def =
( NAME    => "SH_XNNI0_LINK_0_FLOW",
  ADDRESS => 0x0000000150001040,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00104_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI0_LINK_1_FLOW                                                 #
#                                                                        #
##########################################################################

%shub_01_00105_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_CAP"               => [   1,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Captured vc1 credit" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_DYN"               => [   3,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Dynamic vc1 credit value" ],
   "RSVD2"                        => [   4,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_TEST"              => [   5,   8,   7, 0x0000000000007F00, 0x00, 1, 0x0000000000000000, "vc1 Limit Test" ],
   "DEBIT_VC1_FORCE_CRED"         => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on vc1 from debit cntr" ],
   "RSVD3"                        => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_WITHHOLD"           => [   8,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc1 withhold" ],
);

%shub_01_00105_def =
( NAME    => "SH_XNNI0_LINK_1_FLOW",
  ADDRESS => 0x0000000150001050,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00105_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI0_LINK_2_FLOW                                                 #
#                                                                        #
##########################################################################

%shub_01_00106_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Captured vc2 credit" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Dynamic vc2 credit value" ],
   "RSVD2"                        => [   4,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_TEST"              => [   5,   8,   7, 0x0000000000007F00, 0x00, 1, 0x0000000000000000, "vc2 Limit Test" ],
   "DEBIT_VC2_FORCE_CRED"         => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on vc2 from debit cntr" ],
   "RSVD3"                        => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [   8,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc2 withhold" ],
);

%shub_01_00106_def =
( NAME    => "SH_XNNI0_LINK_2_FLOW",
  ADDRESS => 0x0000000150001060,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00106_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI0_LINK_3_FLOW                                                 #
#                                                                        #
##########################################################################

%shub_01_00107_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_CAP"               => [   1,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Captured vc3 credit" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_DYN"               => [   3,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Dynamic vc3 credit value" ],
   "RSVD2"                        => [   4,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_TEST"              => [   5,   8,   7, 0x0000000000007F00, 0x00, 1, 0x0000000000000000, "vc3 Limit Test" ],
   "DEBIT_VC3_FORCE_CRED"         => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on vc3 from debit cntr" ],
   "RSVD3"                        => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_WITHHOLD"           => [   8,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc3 withhold" ],
);

%shub_01_00107_def =
( NAME    => "SH_XNNI0_LINK_3_FLOW",
  ADDRESS => 0x0000000150001070,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00107_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI1_LLP_TO_FIFO02_FLOW                                          #
#                                                                        #
##########################################################################

%shub_01_00108_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "vc2 credit captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "vc2 credit dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "vc0 credit captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "vc0 credit dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_FORCE_CRED"         => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2 from debit cntr" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "vc2 withhold" ],
   "DEBIT_VC0_FORCE_CRED"         => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0 from debit cntr" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc0 withhold" ],
);

%shub_01_00108_def =
( NAME    => "SH_XNNI1_LLP_TO_FIFO02_FLOW",
  ADDRESS => 0x0000000150003010,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00108_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI1_LLP_TO_FIFO13_FLOW                                          #
#                                                                        #
##########################################################################

%shub_01_00109_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "vc2 credit captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "vc2 credit dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "vc0 credit captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "vc0 credit dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_FORCE_CRED"         => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2 from debit cntr" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "vc2 withhold" ],
   "DEBIT_VC0_FORCE_CRED"         => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0 from debit cntr" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc0 withhold" ],
);

%shub_01_00109_def =
( NAME    => "SH_XNNI1_LLP_TO_FIFO13_FLOW",
  ADDRESS => 0x0000000150003020,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00109_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI1_LLP_DEBIT_FLOW                                              #
#                                                                        #
##########################################################################

%shub_01_00110_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_CAP"                => [   1,  56,   5, 0x1F00000000000000, 0x00, 0, 0x0000000000000000, "vc3 debit captured value" ],
   "RSVD1"                        => [   2,  53,   3, 0x00E0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_DYN"                => [   3,  48,   5, 0x001F000000000000, 0x00, 0, 0x0000000000000000, "vc3 debit dynamic value" ],
   "RSVD2"                        => [   4,  45,   3, 0x0000E00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_CAP"                => [   5,  40,   5, 0x00001F0000000000, 0x00, 0, 0x0000000000000000, "vc2 debit captured value" ],
   "RSVD3"                        => [   6,  37,   3, 0x000000E000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_DYN"                => [   7,  32,   5, 0x0000001F00000000, 0x00, 0, 0x0000000000000000, "vc2 debit dynamic value" ],
   "RSVD4"                        => [   8,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_CAP"                => [   9,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "vc1 debit captured value" ],
   "RSVD5"                        => [  10,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_DYN"                => [  11,  16,   5, 0x00000000001F0000, 0x00, 0, 0x0000000000000000, "vc1 debit dynamic value" ],
   "RSVD6"                        => [  12,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_CAP"                => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "vc0 debit captured value" ],
   "RSVD7"                        => [  14,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_DYN"                => [  15,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "vc0 debit dynamic value" ],
);

%shub_01_00110_def =
( NAME    => "SH_XNNI1_LLP_DEBIT_FLOW",
  ADDRESS => 0x0000000150003030,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00110_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI1_LINK_0_FLOW                                                 #
#                                                                        #
##########################################################################

%shub_01_00111_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   1,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Captured vc0 credit" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   3,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Dynamic vc0 credit value" ],
   "RSVD2"                        => [   4,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_TEST"              => [   5,   8,   7, 0x0000000000007F00, 0x00, 1, 0x0000000000000000, "vc0 Limit Test" ],
   "DEBIT_VC0_FORCE_CRED"         => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on vc0 from debit cntr" ],
   "RSVD3"                        => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [   8,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc0 withhold" ],
);

%shub_01_00111_def =
( NAME    => "SH_XNNI1_LINK_0_FLOW",
  ADDRESS => 0x0000000150003040,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00111_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI1_LINK_1_FLOW                                                 #
#                                                                        #
##########################################################################

%shub_01_00112_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_CAP"               => [   1,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Captured vc1 credit" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_DYN"               => [   3,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Dynamic vc1 credit value" ],
   "RSVD2"                        => [   4,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_TEST"              => [   5,   8,   7, 0x0000000000007F00, 0x00, 1, 0x0000000000000000, "vc1 Limit Test" ],
   "DEBIT_VC1_FORCE_CRED"         => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on vc1 from debit cntr" ],
   "RSVD3"                        => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_WITHHOLD"           => [   8,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc1 withhold" ],
);

%shub_01_00112_def =
( NAME    => "SH_XNNI1_LINK_1_FLOW",
  ADDRESS => 0x0000000150003050,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00112_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI1_LINK_2_FLOW                                                 #
#                                                                        #
##########################################################################

%shub_01_00113_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Captured vc2 credit" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Dynamic vc2 credit value" ],
   "RSVD2"                        => [   4,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_TEST"              => [   5,   8,   7, 0x0000000000007F00, 0x00, 1, 0x0000000000000000, "vc2 Limit Test" ],
   "DEBIT_VC2_FORCE_CRED"         => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on vc2 from debit cntr" ],
   "RSVD3"                        => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [   8,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc2 withhold" ],
);

%shub_01_00113_def =
( NAME    => "SH_XNNI1_LINK_2_FLOW",
  ADDRESS => 0x0000000150003060,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00113_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI1_LINK_3_FLOW                                                 #
#                                                                        #
##########################################################################

%shub_01_00114_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_CAP"               => [   1,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Captured vc3 credit" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_DYN"               => [   3,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Dynamic vc3 credit value" ],
   "RSVD2"                        => [   4,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_TEST"              => [   5,   8,   7, 0x0000000000007F00, 0x00, 1, 0x0000000000000000, "vc3 Limit Test" ],
   "DEBIT_VC3_FORCE_CRED"         => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on vc3 from debit cntr" ],
   "RSVD3"                        => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_WITHHOLD"           => [   8,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc3 withhold" ],
);

%shub_01_00114_def =
( NAME    => "SH_XNNI1_LINK_3_FLOW",
  ADDRESS => 0x0000000150003070,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00114_flds
);


##########################################################################
#                                                                        #
#   SH_IILB_LOCAL_TABLE                                                  #
#                                                                        #
##########################################################################

%shub_01_00115_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Indicates that this entry is valid" ],
   "RSVD0"                        => [   1,   6,  57, 0x7FFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL0"                      => [   2,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "ni select for requests" ],
   "V0"                           => [   3,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   4,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
);

%shub_01_00115_def =
( NAME    => "SH_IILB_LOCAL_TABLE",
  ADDRESS => 0x0000000150020000,
  NOTE    => "local lookup table",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00115_flds
);


##########################################################################
#                                                                        #
#   SH_IILB_GLOBAL_TABLE                                                 #
#                                                                        #
##########################################################################

%shub_01_00116_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Indicates that this entry is valid" ],
   "RSVD0"                        => [   1,   6,  57, 0x7FFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL0"                      => [   2,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "ni select for requests" ],
   "V0"                           => [   3,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   4,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
);

%shub_01_00116_def =
( NAME    => "SH_IILB_GLOBAL_TABLE",
  ADDRESS => 0x0000000150020400,
  NOTE    => "global lookup table",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00116_flds
);


##########################################################################
#                                                                        #
#   SH_IILB_OVER_RIDE_TABLE                                              #
#                                                                        #
##########################################################################

%shub_01_00117_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Indicates that this entry is enabled" ],
   "RSVD0"                        => [   1,   6,  57, 0x7FFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL0"                      => [   2,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "ni select" ],
   "V0"                           => [   3,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   4,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Direction field for next chip" ],
);

%shub_01_00117_def =
( NAME    => "SH_IILB_OVER_RIDE_TABLE",
  ADDRESS => 0x0000000150020480,
  NOTE    => "If enabled, bypass the Global/Local tables",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00117_flds
);


##########################################################################
#                                                                        #
#   SH_IILB_RSP_PLANE_HINT                                               #
#                                                                        #
##########################################################################

%shub_01_00118_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
);

%shub_01_00118_def =
( NAME    => "SH_IILB_RSP_PLANE_HINT",
  ADDRESS => 0x0000000150020488,
  NOTE    => "If enabled, invert incoming response only plane hint bit before lookup",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00118_flds
);


##########################################################################
#                                                                        #
#   SH_PI_LOCAL_TABLE                                                    #
#                                                                        #
##########################################################################

%shub_01_00119_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Indicates that this entry is valid" ],
   "RSVD0"                        => [   1,  14,  49, 0x7FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL1"                      => [   2,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "ni select for plane-hint 1" ],
   "V1"                           => [   3,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR1"                         => [   4,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   5,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL0"                      => [   6,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "ni select for requests" ],
   "V0"                           => [   7,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   8,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
);

%shub_01_00119_def =
( NAME    => "SH_PI_LOCAL_TABLE",
  ADDRESS => 0x0000000150021000,
  NOTE    => "local lookup table",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00119_flds
);


##########################################################################
#                                                                        #
#   SH_PI_GLOBAL_TABLE                                                   #
#                                                                        #
##########################################################################

%shub_01_00120_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Indicates that this entry is valid" ],
   "RSVD0"                        => [   1,  14,  49, 0x7FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL1"                      => [   2,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "ni select for plane-hint 1" ],
   "V1"                           => [   3,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR1"                         => [   4,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   5,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL0"                      => [   6,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "ni select for requests" ],
   "V0"                           => [   7,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   8,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
);

%shub_01_00120_def =
( NAME    => "SH_PI_GLOBAL_TABLE",
  ADDRESS => 0x0000000150021400,
  NOTE    => "global lookup table",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00120_flds
);


##########################################################################
#                                                                        #
#   SH_PI_OVER_RIDE_TABLE                                                #
#                                                                        #
##########################################################################

%shub_01_00121_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Indicates that this entry is enabled" ],
   "RSVD0"                        => [   1,  14,  49, 0x7FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL1"                      => [   2,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "ni select" ],
   "V1"                           => [   3,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR1"                         => [   4,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD1"                        => [   5,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL0"                      => [   6,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "ni select" ],
   "V0"                           => [   7,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   8,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Direction field for next chip" ],
);

%shub_01_00121_def =
( NAME    => "SH_PI_OVER_RIDE_TABLE",
  ADDRESS => 0x0000000150021480,
  NOTE    => "If enabled, bypass the Global/Local tables",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00121_flds
);


##########################################################################
#                                                                        #
#   SH_PI_RSP_PLANE_HINT                                                 #
#                                                                        #
##########################################################################

%shub_01_00122_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INVERT"                       => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Invert Response Plane Hint" ],
);

%shub_01_00122_def =
( NAME    => "SH_PI_RSP_PLANE_HINT",
  ADDRESS => 0x0000000150021488,
  NOTE    => "If enabled, invert incoming response only plane hint bit before lookup",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00122_flds
);


##########################################################################
#                                                                        #
#   SH_NI0_LOCAL_TABLE                                                   #
#                                                                        #
##########################################################################

%shub_01_00123_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Indicates that this entry is valid" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "V0"                           => [   2,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   3,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
);

%shub_01_00123_def =
( NAME    => "SH_NI0_LOCAL_TABLE",
  ADDRESS => 0x0000000150022000,
  NOTE    => "local lookup table",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00123_flds
);


##########################################################################
#                                                                        #
#   SH_NI0_GLOBAL_TABLE                                                  #
#                                                                        #
##########################################################################

%shub_01_00124_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Indicates that this entry is valid" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "V0"                           => [   2,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   3,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
);

%shub_01_00124_def =
( NAME    => "SH_NI0_GLOBAL_TABLE",
  ADDRESS => 0x0000000150022400,
  NOTE    => "global lookup table",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00124_flds
);


##########################################################################
#                                                                        #
#   SH_NI0_OVER_RIDE_TABLE                                               #
#                                                                        #
##########################################################################

%shub_01_00125_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Indicates that this entry is enabled" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "V0"                           => [   2,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   3,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Direction field for next chip" ],
);

%shub_01_00125_def =
( NAME    => "SH_NI0_OVER_RIDE_TABLE",
  ADDRESS => 0x0000000150022480,
  NOTE    => "If enabled, bypass the Global/Local tables",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00125_flds
);


##########################################################################
#                                                                        #
#   SH_NI0_RSP_PLANE_HINT                                                #
#                                                                        #
##########################################################################

%shub_01_00126_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
);

%shub_01_00126_def =
( NAME    => "SH_NI0_RSP_PLANE_HINT",
  ADDRESS => 0x0000000150022488,
  NOTE    => "If enabled, invert incoming response only plane hint bit before lookup",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00126_flds
);


##########################################################################
#                                                                        #
#   SH_NI1_LOCAL_TABLE                                                   #
#                                                                        #
##########################################################################

%shub_01_00127_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Indicates that this entry is valid" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "V0"                           => [   2,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   3,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
);

%shub_01_00127_def =
( NAME    => "SH_NI1_LOCAL_TABLE",
  ADDRESS => 0x0000000150023000,
  NOTE    => "local lookup table",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00127_flds
);


##########################################################################
#                                                                        #
#   SH_NI1_GLOBAL_TABLE                                                  #
#                                                                        #
##########################################################################

%shub_01_00128_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Indicates that this entry is valid" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "V0"                           => [   2,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   3,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
);

%shub_01_00128_def =
( NAME    => "SH_NI1_GLOBAL_TABLE",
  ADDRESS => 0x0000000150023400,
  NOTE    => "global lookup table",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00128_flds
);


##########################################################################
#                                                                        #
#   SH_NI1_OVER_RIDE_TABLE                                               #
#                                                                        #
##########################################################################

%shub_01_00129_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Indicates that this entry is enabled" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "V0"                           => [   2,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   3,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Direction field for next chip" ],
);

%shub_01_00129_def =
( NAME    => "SH_NI1_OVER_RIDE_TABLE",
  ADDRESS => 0x0000000150023480,
  NOTE    => "If enabled, bypass the Global/Local tables",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00129_flds
);


##########################################################################
#                                                                        #
#   SH_NI1_RSP_PLANE_HINT                                                #
#                                                                        #
##########################################################################

%shub_01_00130_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
);

%shub_01_00130_def =
( NAME    => "SH_NI1_RSP_PLANE_HINT",
  ADDRESS => 0x0000000150023488,
  NOTE    => "If enabled, invert incoming response only plane hint bit before lookup",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00130_flds
);


##########################################################################
#                                                                        #
#   SH_MD_LOCAL_TABLE                                                    #
#                                                                        #
##########################################################################

%shub_01_00131_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Indicates that this entry is valid" ],
   "RSVD0"                        => [   1,  14,  49, 0x7FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL1"                      => [   2,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "ni select for plane-hint 1" ],
   "V1"                           => [   3,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR1"                         => [   4,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   5,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL0"                      => [   6,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "ni select for requests" ],
   "V0"                           => [   7,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   8,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
);

%shub_01_00131_def =
( NAME    => "SH_MD_LOCAL_TABLE",
  ADDRESS => 0x0000000150024000,
  NOTE    => "local lookup table",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00131_flds
);


##########################################################################
#                                                                        #
#   SH_MD_GLOBAL_TABLE                                                   #
#                                                                        #
##########################################################################

%shub_01_00132_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Indicates that this entry is valid" ],
   "RSVD0"                        => [   1,  14,  49, 0x7FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL1"                      => [   2,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "ni select for plane-hint 1" ],
   "V1"                           => [   3,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR1"                         => [   4,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   5,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL0"                      => [   6,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "ni select for requests" ],
   "V0"                           => [   7,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   8,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
);

%shub_01_00132_def =
( NAME    => "SH_MD_GLOBAL_TABLE",
  ADDRESS => 0x0000000150024400,
  NOTE    => "global lookup table",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00132_flds
);


##########################################################################
#                                                                        #
#   SH_MD_OVER_RIDE_TABLE                                                #
#                                                                        #
##########################################################################

%shub_01_00133_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Indicates that this entry is enabled" ],
   "RSVD0"                        => [   1,  14,  49, 0x7FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL1"                      => [   2,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "ni select" ],
   "V1"                           => [   3,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR1"                         => [   4,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD1"                        => [   5,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL0"                      => [   6,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "ni select" ],
   "V0"                           => [   7,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   8,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Direction field for next chip" ],
);

%shub_01_00133_def =
( NAME    => "SH_MD_OVER_RIDE_TABLE",
  ADDRESS => 0x0000000150024480,
  NOTE    => "If enabled, bypass the Global/Local tables",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00133_flds
);


##########################################################################
#                                                                        #
#   SH_MD_RSP_PLANE_HINT                                                 #
#                                                                        #
##########################################################################

%shub_01_00134_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INVERT"                       => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Invert Response Plane Hint" ],
);

%shub_01_00134_def =
( NAME    => "SH_MD_RSP_PLANE_HINT",
  ADDRESS => 0x0000000150024488,
  NOTE    => "If enabled, invert incoming response only plane hint bit before lookup",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00134_flds
);


##########################################################################
#                                                                        #
#   SH_LB_LIQ_CTL                                                        #
#                                                                        #
##########################################################################

%shub_01_00135_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  19,  45, 0xFFFFFFFFFFF80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FORCE_LINVV_CREDIT"           => [   1,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Force linvv credit" ],
   "FORCE_RP_CREDIT"              => [   2,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Force reply credit" ],
   "FORCE_RQ_CREDIT"              => [   3,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Force request credit" ],
   "RSVD1"                        => [   4,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LIQ_RPL_CTL"                  => [   5,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "LIQ Reply Control" ],
   "RSVD2"                        => [   6,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LIQ_REQ_CTL"                  => [   7,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "LIQ Request Control" ],
);

%shub_01_00135_def =
( NAME    => "SH_LB_LIQ_CTL",
  ADDRESS => 0x0000000110040000,
  NOTE    => "Local Block LIQ Control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00135_flds
);


##########################################################################
#                                                                        #
#   SH_LB_LOQ_CTL                                                        #
#                                                                        #
##########################################################################

%shub_01_00136_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   2,  62, 0xFFFFFFFFFFFFFFFC, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LOQ_RPL_CTL"                  => [   1,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "LOQ Reply Control" ],
   "LOQ_REQ_CTL"                  => [   2,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "LOQ Request Control" ],
);

%shub_01_00136_def =
( NAME    => "SH_LB_LOQ_CTL",
  ADDRESS => 0x0000000110040080,
  NOTE    => "Local Block LOQ Control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00136_flds
);


##########################################################################
#                                                                        #
#   SH_LB_MAX_REP_CREDIT_CNT                                             #
#                                                                        #
##########################################################################

%shub_01_00137_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CNT"                      => [   1,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Max reply credits" ],
);

%shub_01_00137_def =
( NAME    => "SH_LB_MAX_REP_CREDIT_CNT",
  ADDRESS => 0x0000000110040100,
  NOTE    => "Maximum number of reply credits from XN",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00137_flds
);


##########################################################################
#                                                                        #
#   SH_LB_MAX_REQ_CREDIT_CNT                                             #
#                                                                        #
##########################################################################

%shub_01_00138_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CNT"                      => [   1,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Max request credits" ],
);

%shub_01_00138_def =
( NAME    => "SH_LB_MAX_REQ_CREDIT_CNT",
  ADDRESS => 0x0000000110040180,
  NOTE    => "Maximum number of request credits from XN",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00138_flds
);


##########################################################################
#                                                                        #
#   SH_PIO_TIME_OUT                                                      #
#                                                                        #
##########################################################################

%shub_01_00139_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VALUE"                        => [   1,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "PIO time out value" ],
);

%shub_01_00139_def =
( NAME    => "SH_PIO_TIME_OUT",
  ADDRESS => 0x0000000110040200,
  NOTE    => "Local Block PIO time out value",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00139_flds
);


##########################################################################
#                                                                        #
#   SH_PIO_NACK_RESET                                                    #
#                                                                        #
##########################################################################

%shub_01_00140_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PULSE"                        => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "PIO nack counter reset" ],
);

%shub_01_00140_def =
( NAME    => "SH_PIO_NACK_RESET",
  ADDRESS => 0x0000000110040280,
  NOTE    => "Local Block PIO Reset for nack counters",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00140_flds
);


##########################################################################
#                                                                        #
#   SH_CONVEYOR_BELT_TIME_OUT                                            #
#                                                                        #
##########################################################################

%shub_01_00141_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  12,  52, 0xFFFFFFFFFFFFF000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VALUE"                        => [   1,   0,  12, 0x0000000000000FFF, 0x00, 1, 0x0000000000000000, "Conveyor belt time out value" ],
);

%shub_01_00141_def =
( NAME    => "SH_CONVEYOR_BELT_TIME_OUT",
  ADDRESS => 0x0000000110040300,
  NOTE    => "Local Block conveyor belt time out value",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00141_flds
);


##########################################################################
#                                                                        #
#   SH_LB_CREDIT_STATUS                                                  #
#                                                                        #
##########################################################################

%shub_01_00142_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LOQ_RP_CREDIT"                => [   1,  23,   5, 0x000000000F800000, 0x00, 0, 0x0000000000000000, "LOQ reply queue credit counter" ],
   "LOQ_RQ_CREDIT"                => [   2,  18,   5, 0x00000000007C0000, 0x00, 0, 0x0000000000000000, "LOQ request queue credit counter" ],
   "LINVV_CREDIT"                 => [   3,  12,   6, 0x000000000003F000, 0x00, 0, 0x0000000000000000, "LINVV credit counter" ],
   "RSVD1"                        => [   4,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LIQ_RP_CREDIT"                => [   5,   6,   4, 0x00000000000003C0, 0x00, 0, 0x0000000000000000, "LIQ reply queue credit counter" ],
   "RSVD2"                        => [   6,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LIQ_RQ_CREDIT"                => [   7,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "LIQ request queue credit counter" ],
);

%shub_01_00142_def =
( NAME    => "SH_LB_CREDIT_STATUS",
  ADDRESS => 0x0000000110050000,
  NOTE    => "Credit Counter Status Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00142_flds
);


##########################################################################
#                                                                        #
#   SH_LB_DEBUG_LOCAL_SEL                                                #
#                                                                        #
##########################################################################

%shub_01_00143_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TRIGGER_ENABLE"               => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Enable trigger on bit 31 of Analyzer data" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD0"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_CHIPLET_SEL"          => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Chiplet select" ],
   "RSVD1"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD2"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_CHIPLET_SEL"          => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Chiplet select" ],
   "RSVD3"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD4"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_CHIPLET_SEL"          => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Chiplet select" ],
   "RSVD5"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD6"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_CHIPLET_SEL"          => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Chiplet select" ],
   "RSVD7"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD8"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_CHIPLET_SEL"          => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Chiplet select" ],
   "RSVD9"                        => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD10"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_CHIPLET_SEL"          => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 Chiplet select" ],
   "RSVD11"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD12"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_CHIPLET_SEL"          => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 Chiplet select" ],
   "RSVD13"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD14"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_CHIPLET_SEL"          => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Chiplet select" ],
);

%shub_01_00143_def =
( NAME    => "SH_LB_DEBUG_LOCAL_SEL",
  ADDRESS => 0x0000000110050080,
  NOTE    => "LB Debug Port Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00143_flds
);


##########################################################################
#                                                                        #
#   SH_LB_DEBUG_PERF_SEL                                                 #
#                                                                        #
##########################################################################

%shub_01_00144_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_CHIPLET_SEL"          => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Chiplet select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_CHIPLET_SEL"          => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Chiplet select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_CHIPLET_SEL"          => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Chiplet select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_CHIPLET_SEL"          => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Chiplet select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_CHIPLET_SEL"          => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Chiplet select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_CHIPLET_SEL"          => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 Chiplet select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_CHIPLET_SEL"          => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 Chiplet select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_CHIPLET_SEL"          => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Chiplet select" ],
);

%shub_01_00144_def =
( NAME    => "SH_LB_DEBUG_PERF_SEL",
  ADDRESS => 0x0000000110050100,
  NOTE    => "LB Debug Port Performance Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00144_flds
);


##########################################################################
#                                                                        #
#   SH_LB_DEBUG_TRIG_SEL                                                 #
#                                                                        #
##########################################################################

%shub_01_00145_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_NIBBLE_SEL"          => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_CHIPLET_SEL"         => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Chiplet select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_NIBBLE_SEL"          => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_CHIPLET_SEL"         => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Chiplet select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_NIBBLE_SEL"          => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_CHIPLET_SEL"         => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Chiplet select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_NIBBLE_SEL"          => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_CHIPLET_SEL"         => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Chiplet select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_NIBBLE_SEL"          => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_CHIPLET_SEL"         => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Chiplet select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_NIBBLE_SEL"          => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_CHIPLET_SEL"         => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 Chiplet select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_NIBBLE_SEL"          => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_CHIPLET_SEL"         => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 Chiplet select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_NIBBLE_SEL"          => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_CHIPLET_SEL"         => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Chiplet select" ],
);

%shub_01_00145_def =
( NAME    => "SH_LB_DEBUG_TRIG_SEL",
  ADDRESS => 0x0000000110050180,
  NOTE    => "LB Debug Trigger Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00145_flds
);


##########################################################################
#                                                                        #
#   SH_LB_ERROR_DETAIL_1                                                 #
#                                                                        #
##########################################################################

%shub_01_00146_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "VALID" ],
   "RSVD0"                        => [   1,  50,  13, 0x7FFC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_ERR"                     => [   2,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "DATA_ERR" ],
   "HDR_ERR"                      => [   3,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "HDR_ERR" ],
   "RSVD1"                        => [   4,  43,   5, 0x0000F80000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEST"                         => [   5,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Destination Chiplet Code" ],
   "RSVD2"                        => [   6,  38,   2, 0x000000C000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SOURCE"                       => [   7,  24,  14, 0x0000003FFF000000, 0x00, 0, 0x0000000000000000, "Source Node Number and Chiplet Code" ],
   "RSVD3"                        => [   8,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SUPPL"                        => [   9,   8,  14, 0x00000000003FFF00, 0x00, 0, 0x0000000000000000, "Supplemental Field" ],
   "COMMAND"                      => [  10,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "SN2NET Message Code" ],
);

%shub_01_00146_def =
( NAME    => "SH_LB_ERROR_DETAIL_1",
  ADDRESS => 0x0000000110050200,
  NOTE    => "LB Error Detail 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00146_flds
);


##########################################################################
#                                                                        #
#   SH_LB_ERROR_DETAIL_2                                                 #
#                                                                        #
##########################################################################

%shub_01_00147_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDRESS"                      => [   1,   0,  47, 0x00007FFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "PHYSICAL_ADDRESS[49:3]" ],
);

%shub_01_00147_def =
( NAME    => "SH_LB_ERROR_DETAIL_2",
  ADDRESS => 0x0000000110050280,
  NOTE    => "LB Error Detail 2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00147_flds
);


##########################################################################
#                                                                        #
#   SH_LB_ERROR_DETAIL_3                                                 #
#                                                                        #
##########################################################################

%shub_01_00148_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "DATA" ],
);

%shub_01_00148_def =
( NAME    => "SH_LB_ERROR_DETAIL_3",
  ADDRESS => 0x0000000110050300,
  NOTE    => "LB Error Detail 3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00148_flds
);


##########################################################################
#                                                                        #
#   SH_LB_ERROR_DETAIL_4                                                 #
#                                                                        #
##########################################################################

%shub_01_00149_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ROUTE"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Vector Message Route" ],
);

%shub_01_00149_def =
( NAME    => "SH_LB_ERROR_DETAIL_4",
  ADDRESS => 0x0000000110050380,
  NOTE    => "LB Error Detail 4",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00149_flds
);


##########################################################################
#                                                                        #
#   SH_LB_ERROR_DETAIL_5                                                 #
#                                                                        #
##########################################################################

%shub_01_00150_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   7,  57, 0xFFFFFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NACK_B_TIMEOUT"               => [   1,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NACK-B Counter Time-out Error" ],
   "NACK_A_TIMEOUT"               => [   2,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NACK-A Counter Time-out Error" ],
   "COUNT_B_OVERFLOW"             => [   3,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NACK-B Counter Overflow Error" ],
   "COUNT_A_OVERFLOW"             => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NACK-A Counter Overflow Error" ],
   "WRITE_RETRY"                  => [   5,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Write Retry Error" ],
   "PTC1_WRITE"                   => [   6,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "PTC_1 Write Error" ],
   "READ_RETRY"                   => [   7,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Read Retry Error" ],
);

%shub_01_00150_def =
( NAME    => "SH_LB_ERROR_DETAIL_5",
  ADDRESS => 0x0000000110050400,
  NOTE    => "LB Error Detail 5",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00150_flds
);


##########################################################################
#                                                                        #
#   SH_LB_ERROR_MASK                                                     #
#                                                                        #
##########################################################################

%shub_01_00151_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_CREDIT_OVERFLOW"           => [   1,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "Reply Credit Overflow Error Mask" ],
   "RQ_CREDIT_OVERFLOW"           => [   2,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "Request Credit Overflow Error Mask" ],
   "UNEXP_VALID"                  => [   3,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "MMR Address Decode Error Mask" ],
   "RP_FIFO_ERROR"                => [   4,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "Reply Queue Overflow Error Mask" ],
   "RQ_FIFO_ERROR"                => [   5,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "Request Queue Overflow Error Mask" ],
   "GCLK_DROP"                    => [   6,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "Dropped Global Clock Error Mask" ],
   "VECTOR_RP_ROUTE_ERROR"        => [   7,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Vector Reply Route Error Mask" ],
   "VECTOR_RQ_ROUTE_ERROR"        => [   8,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Vector Request Route Error Mask" ],
   "PIO_CB_ERR"                   => [   9,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "PIO Conveyor Belt Error Mask" ],
   "JUNK_BUS_ERR"                 => [  10,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Junk Bus Error Mask" ],
   "PTC_1_TIMEOUT"                => [  11,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "PTC_1 Time-out Error Mask" ],
   "UNEXPECTED_LINV"              => [  12,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "Unexpected LINVV Error Mask" ],
   "LINVV_OVERFLOW"               => [  13,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "LINVV Overflow Error Mask" ],
   "RQ_TIME_OUT"                  => [  14,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Request Time-out Error Mask" ],
   "RQ_BAD_ADDR"                  => [  15,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Request Bad Address Error Mask" ],
   "RP_BAD_DATA"                  => [  16,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Reply Bad Data Error Mask" ],
   "RQ_BAD_DATA"                  => [  17,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Request Bad Data Error Mask" ],
   "RP_LONG"                      => [  18,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Obese Reply Message Error Mask" ],
   "RQ_LONG"                      => [  19,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Obese Request Message Error Mask" ],
   "RP_SHORT"                     => [  20,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Runt Reply Message Error Mask" ],
   "RQ_SHORT"                     => [  21,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Runt Request Message Error Mask" ],
   "RP_BAD_CMD"                   => [  22,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Unsupported Reply Message Error Mask" ],
   "RQ_BAD_CMD"                   => [  23,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Unsupported Request Message Error Mask" ],
);

%shub_01_00151_def =
( NAME    => "SH_LB_ERROR_MASK",
  ADDRESS => 0x0000000110050480,
  NOTE    => "LB Error Mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00151_flds
);


##########################################################################
#                                                                        #
#   SH_LB_ERROR_OVERFLOW                                                 #
#                                                                        #
##########################################################################

%shub_01_00152_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_CREDIT_OVERFLOW_OVRFL"     => [   1,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Reply Credit Overflow Error Overflow" ],
   "RQ_CREDIT_OVERFLOW_OVRFL"     => [   2,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Request Credit Overflow Error Overflow" ],
   "UNEXP_VALID_OVRFL"            => [   3,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MMR Address Decode Error Overflow" ],
   "RP_FIFO_ERROR_OVRFL"          => [   4,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reply Queue Overflow Error Overflow" ],
   "RQ_FIFO_ERROR_OVRFL"          => [   5,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Request Queue Overflow Error Overflow" ],
   "GCLK_DROP_OVRFL"              => [   6,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Dropped Global Clock Error Overflow" ],
   "VECTOR_RP_ROUTE_ERROR_OVRFL"  => [   7,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Vector Reply Route Error Overflow" ],
   "VECTOR_RQ_ROUTE_ERROR_OVRFL"  => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Vector Request Route Error Overflow" ],
   "PIO_CB_ERR_OVRFL"             => [   9,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "PIO Conveyor Belt Error Overflow" ],
   "JUNK_BUS_ERR_OVRFL"           => [  10,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Junk Bus Error Overflow" ],
   "PTC_1_TIMEOUT_OVRFL"          => [  11,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PTC_1 Time-out Error Overflow" ],
   "UNEXPECTED_LINV_OVRFL"        => [  12,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Unexpected LINVV Error Overflow" ],
   "LINVV_OVERFLOW_OVRFL"         => [  13,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "LINVV Overflow Error Overflow" ],
   "RQ_TIME_OUT_OVRFL"            => [  14,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Request Time-out Error Overflow" ],
   "RQ_BAD_ADDR_OVRFL"            => [  15,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Request Bad Address Error Overflow" ],
   "RP_BAD_DATA_OVRFL"            => [  16,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reply Bad Data Error Overflow" ],
   "RQ_BAD_DATA_OVRFL"            => [  17,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Request Bad Data Error Overflow" ],
   "RP_LONG_OVRFL"                => [  18,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Obese Reply Message Error Overflow" ],
   "RQ_LONG_OVRFL"                => [  19,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Obese Request Message Error Overflow" ],
   "RP_SHORT_OVRFL"               => [  20,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Runt Reply Message Error Overflow" ],
   "RQ_SHORT_OVRFL"               => [  21,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Runt Request Message Error Overflow" ],
   "RP_BAD_CMD_OVRFL"             => [  22,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Unsupported Reply Message Error Overflow" ],
   "RQ_BAD_CMD_OVRFL"             => [  23,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Unsupported Request Message Error Overflow" ],
);

%shub_01_00152_def =
( NAME    => "SH_LB_ERROR_OVERFLOW",
  ADDRESS => 0x0000000110050500,
  NOTE    => "LB Error Overflow",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00152_flds
);


##########################################################################
#                                                                        #
#   SH_LB_ERROR_OVERFLOW_ALIAS                                           #
#                                                                        #
##########################################################################

%shub_01_00153_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_CREDIT_OVERFLOW_OVRFL"     => [   1,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Reply Credit Overflow Error Overflow" ],
   "RQ_CREDIT_OVERFLOW_OVRFL"     => [   2,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Request Credit Overflow Error Overflow" ],
   "UNEXP_VALID_OVRFL"            => [   3,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MMR Address Decode Error Overflow" ],
   "RP_FIFO_ERROR_OVRFL"          => [   4,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reply Queue Overflow Error Overflow" ],
   "RQ_FIFO_ERROR_OVRFL"          => [   5,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Request Queue Overflow Error Overflow" ],
   "GCLK_DROP_OVRFL"              => [   6,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Dropped Global Clock Error Overflow" ],
   "VECTOR_RP_ROUTE_ERROR_OVRFL"  => [   7,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Vector Reply Route Error Overflow" ],
   "VECTOR_RQ_ROUTE_ERROR_OVRFL"  => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Vector Request Route Error Overflow" ],
   "PIO_CB_ERR_OVRFL"             => [   9,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "PIO Conveyor Belt Error Overflow" ],
   "JUNK_BUS_ERR_OVRFL"           => [  10,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Junk Bus Error Overflow" ],
   "PTC_1_TIMEOUT_OVRFL"          => [  11,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PTC_1 Time-out Error Overflow" ],
   "UNEXPECTED_LINV_OVRFL"        => [  12,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Unexpected LINVV Error Overflow" ],
   "LINVV_OVERFLOW_OVRFL"         => [  13,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "LINVV Overflow Error Overflow" ],
   "RQ_TIME_OUT_OVRFL"            => [  14,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Request Time-out Error Overflow" ],
   "RQ_BAD_ADDR_OVRFL"            => [  15,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Request Bad Address Error Overflow" ],
   "RP_BAD_DATA_OVRFL"            => [  16,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reply Bad Data Error Overflow" ],
   "RQ_BAD_DATA_OVRFL"            => [  17,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Request Bad Data Error Overflow" ],
   "RP_LONG_OVRFL"                => [  18,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Obese Reply Message Error Overflow" ],
   "RQ_LONG_OVRFL"                => [  19,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Obese Request Message Error Overflow" ],
   "RP_SHORT_OVRFL"               => [  20,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Runt Reply Message Error Overflow" ],
   "RQ_SHORT_OVRFL"               => [  21,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Runt Request Message Error Overflow" ],
   "RP_BAD_CMD_OVRFL"             => [  22,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Unsupported Reply Message Error Overflow" ],
   "RQ_BAD_CMD_OVRFL"             => [  23,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Unsupported Request Message Error Overflow" ],
);

%shub_01_00153_def =
( NAME    => "SH_LB_ERROR_OVERFLOW_ALIAS",
  ADDRESS => 0x0000000110050508,
  NOTE    => "LB Error Overflow Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00153_flds
);


##########################################################################
#                                                                        #
#   SH_LB_ERROR_SUMMARY                                                  #
#                                                                        #
##########################################################################

%shub_01_00154_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_CREDIT_OVERFLOW"           => [   1,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Reply Credit Overflow Error" ],
   "RQ_CREDIT_OVERFLOW"           => [   2,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Request Credit Overflow Error" ],
   "UNEXP_VALID"                  => [   3,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MMR Address Decode Error" ],
   "RP_FIFO_ERROR"                => [   4,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reply Queue Overflow Error" ],
   "RQ_FIFO_ERROR"                => [   5,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Request Queue Overflow Error" ],
   "GCLK_DROP"                    => [   6,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Dropped Global Clock Error" ],
   "VECTOR_RP_ROUTE_ERROR"        => [   7,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Vector Reply Route Error" ],
   "VECTOR_RQ_ROUTE_ERROR"        => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Vector Request Route Error" ],
   "PIO_CB_ERR"                   => [   9,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "PIO Conveyor Belt Error" ],
   "JUNK_BUS_ERR"                 => [  10,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Junk Bus Error" ],
   "PTC_1_TIMEOUT"                => [  11,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PTC_1 Time-out Error" ],
   "UNEXPECTED_LINV"              => [  12,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Unexpected LINVV Error" ],
   "LINVV_OVERFLOW"               => [  13,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "LINVV Overflow Error" ],
   "RQ_TIME_OUT"                  => [  14,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Request Time-out Error" ],
   "RQ_BAD_ADDR"                  => [  15,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Request Bad Address Error" ],
   "RP_BAD_DATA"                  => [  16,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reply Bad Data Error" ],
   "RQ_BAD_DATA"                  => [  17,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Request Bad Data Error" ],
   "RP_LONG"                      => [  18,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Obese Reply Message Error" ],
   "RQ_LONG"                      => [  19,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Obese Request Message Error" ],
   "RP_SHORT"                     => [  20,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Runt Reply Message Error" ],
   "RQ_SHORT"                     => [  21,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Runt Request Message Error" ],
   "RP_BAD_CMD"                   => [  22,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Unsupported Reply Message Error" ],
   "RQ_BAD_CMD"                   => [  23,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Unsupported Request Message Error" ],
);

%shub_01_00154_def =
( NAME    => "SH_LB_ERROR_SUMMARY",
  ADDRESS => 0x0000000110050580,
  NOTE    => "LB Error Summary",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00154_flds
);


##########################################################################
#                                                                        #
#   SH_LB_ERROR_SUMMARY_ALIAS                                            #
#                                                                        #
##########################################################################

%shub_01_00155_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_CREDIT_OVERFLOW"           => [   1,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Reply Credit Overflow Error" ],
   "RQ_CREDIT_OVERFLOW"           => [   2,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Request Credit Overflow Error" ],
   "UNEXP_VALID"                  => [   3,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MMR Address Decode Error" ],
   "RP_FIFO_ERROR"                => [   4,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reply Queue Overflow Error" ],
   "RQ_FIFO_ERROR"                => [   5,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Request Queue Overflow Error" ],
   "GCLK_DROP"                    => [   6,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Dropped Global Clock Error" ],
   "VECTOR_RP_ROUTE_ERROR"        => [   7,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Vector Reply Route Error" ],
   "VECTOR_RQ_ROUTE_ERROR"        => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Vector Request Route Error" ],
   "PIO_CB_ERR"                   => [   9,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "PIO Conveyor Belt Error" ],
   "JUNK_BUS_ERR"                 => [  10,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Junk Bus Error" ],
   "PTC_1_TIMEOUT"                => [  11,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PTC_1 Time-out Error" ],
   "UNEXPECTED_LINV"              => [  12,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Unexpected LINVV Error" ],
   "LINVV_OVERFLOW"               => [  13,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "LINVV Overflow Error" ],
   "RQ_TIME_OUT"                  => [  14,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Request Time-out Error" ],
   "RQ_BAD_ADDR"                  => [  15,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Request Bad Address Error" ],
   "RP_BAD_DATA"                  => [  16,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reply Bad Data Error" ],
   "RQ_BAD_DATA"                  => [  17,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Request Bad Data Error" ],
   "RP_LONG"                      => [  18,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Obese Reply Message Error" ],
   "RQ_LONG"                      => [  19,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Obese Request Message Error" ],
   "RP_SHORT"                     => [  20,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Runt Reply Message Error" ],
   "RQ_SHORT"                     => [  21,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Runt Request Message Error" ],
   "RP_BAD_CMD"                   => [  22,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Unsupported Reply Message Error" ],
   "RQ_BAD_CMD"                   => [  23,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Unsupported Request Message Error" ],
);

%shub_01_00155_def =
( NAME    => "SH_LB_ERROR_SUMMARY_ALIAS",
  ADDRESS => 0x0000000110050588,
  NOTE    => "LB Error Summary Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00155_flds
);


##########################################################################
#                                                                        #
#   SH_LB_FIRST_ERROR                                                    #
#                                                                        #
##########################################################################

%shub_01_00156_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_CREDIT_OVERFLOW"           => [   1,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Reply Credit Overflow Error" ],
   "RQ_CREDIT_OVERFLOW"           => [   2,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Request Credit Overflow Error" ],
   "UNEXP_VALID"                  => [   3,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MMR Address Decode Error" ],
   "RP_FIFO_ERROR"                => [   4,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reply Queue Overflow Error" ],
   "RQ_FIFO_ERROR"                => [   5,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Request Queue Overflow Error" ],
   "GCLK_DROP"                    => [   6,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Dropped Global Clock Error" ],
   "VECTOR_RP_ROUTE_ERROR"        => [   7,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Vector Reply Route Error" ],
   "VECTOR_RQ_ROUTE_ERROR"        => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Vector Request Route Error" ],
   "PIO_CB_ERR"                   => [   9,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "PIO Conveyor Belt Error" ],
   "JUNK_BUS_ERR"                 => [  10,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Junk Bus Error" ],
   "PTC_1_TIMEOUT"                => [  11,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PTC_1 Timeout Error" ],
   "UNEXPECTED_LINV"              => [  12,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Unexpected LINVV Error" ],
   "LINVV_OVERFLOW"               => [  13,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "LINVV Overflow Error" ],
   "RQ_TIME_OUT"                  => [  14,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Request Time-out Error" ],
   "RQ_BAD_ADDR"                  => [  15,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Request Bad Address Error" ],
   "RP_BAD_DATA"                  => [  16,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reply Bad Data Error" ],
   "RQ_BAD_DATA"                  => [  17,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Request Bad Data Error" ],
   "RP_LONG"                      => [  18,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Obese Reply Message Error" ],
   "RQ_LONG"                      => [  19,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Obese Request Message Error" ],
   "RP_SHORT"                     => [  20,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Runt Reply Message Error" ],
   "RQ_SHORT"                     => [  21,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Runt Request Message Error" ],
   "RP_BAD_CMD"                   => [  22,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Unsupported Reply Message Error" ],
   "RQ_BAD_CMD"                   => [  23,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Unsupported Request Message Error" ],
);

%shub_01_00156_def =
( NAME    => "SH_LB_FIRST_ERROR",
  ADDRESS => 0x0000000110050600,
  NOTE    => "LB First Error",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00156_flds
);


##########################################################################
#                                                                        #
#   SH_LB_LAST_CREDIT                                                    #
#                                                                        #
##########################################################################

%shub_01_00157_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LOQ_RP_CREDIT"                => [   1,  23,   5, 0x000000000F800000, 0x00, 0, 0x0000000000000000, "LOQ reply queue credit counter" ],
   "LOQ_RQ_CREDIT"                => [   2,  18,   5, 0x00000000007C0000, 0x00, 0, 0x0000000000000000, "LOQ request queue credit counter" ],
   "LINVV_CREDIT"                 => [   3,  12,   6, 0x000000000003F000, 0x00, 0, 0x0000000000000000, "LINVV credit counter" ],
   "RSVD1"                        => [   4,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LIQ_RP_CREDIT"                => [   5,   6,   4, 0x00000000000003C0, 0x00, 0, 0x0000000000000000, "LIQ reply queue credit counter" ],
   "RSVD2"                        => [   6,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LIQ_RQ_CREDIT"                => [   7,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "LIQ request queue credit counter" ],
);

%shub_01_00157_def =
( NAME    => "SH_LB_LAST_CREDIT",
  ADDRESS => 0x0000000110050680,
  NOTE    => "Credit counter status register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00157_flds
);


##########################################################################
#                                                                        #
#   SH_LB_NACK_STATUS                                                    #
#                                                                        #
##########################################################################

%shub_01_00158_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CB_STATE"                     => [   1,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "Conveyor belt state" ],
   "CB_TIMEOUT_COUNT"             => [   2,  48,  12, 0x0FFF000000000000, 0x00, 1, 0x0000000000000000, "Conveyor belt time out counter" ],
   "JUNK_NACK"                    => [   3,  32,  16, 0x0000FFFF00000000, 0x00, 1, 0x0000000000000000, "Junk bus nack counter" ],
   "RSVD1"                        => [   4,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_NACK_B"                   => [   5,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "PIO nackA counter" ],
   "RSVD2"                        => [   6,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_NACK_A"                   => [   7,   0,  12, 0x0000000000000FFF, 0x00, 1, 0x0000000000000000, "PIO nackA counter" ],
);

%shub_01_00158_def =
( NAME    => "SH_LB_NACK_STATUS",
  ADDRESS => 0x0000000110050700,
  NOTE    => "Nack Counter Status Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00158_flds
);


##########################################################################
#                                                                        #
#   SH_LB_TRIGGER_COMPARE                                                #
#                                                                        #
##########################################################################

%shub_01_00159_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MASK"                         => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Mask to select Debug bits for trigger generation" ],
);

%shub_01_00159_def =
( NAME    => "SH_LB_TRIGGER_COMPARE",
  ADDRESS => 0x0000000110050780,
  NOTE    => "LB Test-point Trigger Compare Mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00159_flds
);


##########################################################################
#                                                                        #
#   SH_LB_TRIGGER_DATA                                                   #
#                                                                        #
##########################################################################

%shub_01_00160_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COMPARE_PATTERN"              => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "debug bit pattern for trigger generation" ],
);

%shub_01_00160_def =
( NAME    => "SH_LB_TRIGGER_DATA",
  ADDRESS => 0x0000000110050800,
  NOTE    => "LB Test-point Trigger Compare Data",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00160_flds
);


##########################################################################
#                                                                        #
#   SH_PI_AEC_CONFIG                                                     #
#                                                                        #
##########################################################################

%shub_01_00161_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   3,  61, 0xFFFFFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MODE"                         => [   1,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "AEC Operation Mode" ],
);

%shub_01_00161_def =
( NAME    => "SH_PI_AEC_CONFIG",
  ADDRESS => 0x0000000120050000,
  NOTE    => "PI Adaptive Error Correction Configuration",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00161_flds
);


##########################################################################
#                                                                        #
#   SH_PI_AFI_ERROR_MASK                                                 #
#                                                                        #
##########################################################################

%shub_01_00162_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MSG_LEN"                      => [   1,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Message Length Error Mask" ],
   "FSB_TBL_MISS"                 => [   2,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: FSB Table Miss Error Mask" ],
   "BAD_SNOOP"                    => [   3,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: FSB Snoop Error Mask" ],
   "LIVELOCK"                     => [   4,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: FSB Livelock Error Mask" ],
   "SHUB_FSB_CE"                  => [   5,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "PI_CE_INT: SHub-to-FSB Correctable Data Error Mask" ],
   "SHUB_FSB_UCE"                 => [   6,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "PI_UCE_INT: SHub-to-FSB Uncorrectable Data Error Mask" ],
   "SHUB_FSB_DQE"                 => [   7,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PI-AFI Queue Error Mask" ],
   "ADDR_PARITY"                  => [   8,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Address Parity Error Mask" ],
   "REQ_PARITY"                   => [   9,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Request Parity Error Mask" ],
   "ADDR_ACCESS"                  => [  10,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Address Access Error Mask" ],
   "REQ_FORMAT"                   => [  11,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Request Format Error Mask" ],
   "IOQ_OVERRUN"                  => [  12,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: IOQ Overrun Error Mask" ],
   "RSP_PARITY"                   => [  13,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Response Parity Error Mask" ],
   "HUNG_BUS"                     => [  14,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Hung Bus Error Mask" ],
   "RSVD1"                        => [  15,   9,  12, 0x00000000001FFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FSB_SHUB_CE"                  => [  16,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "PI_CE_INT: FSB-to-SHUB Correctable Data Error Mask" ],
);

%shub_01_00162_def =
( NAME    => "SH_PI_AFI_ERROR_MASK",
  ADDRESS => 0x0000000120050080,
  NOTE    => "PI AFI Error Mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00162_flds
);


##########################################################################
#                                                                        #
#   SH_PI_AFI_TEST_POINT_COMPARE                                         #
#                                                                        #
##########################################################################

%shub_01_00163_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COMPARE_PATTERN"              => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "debug bit pattern for trigger generation" ],
   "COMPARE_MASK"                 => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Mask to select Debug bits for trigger generation" ],
);

%shub_01_00163_def =
( NAME    => "SH_PI_AFI_TEST_POINT_COMPARE",
  ADDRESS => 0x0000000120050100,
  NOTE    => "PI AFI Test Point Compare",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00163_flds
);


##########################################################################
#                                                                        #
#   SH_PI_AFI_TEST_POINT_SELECT                                          #
#                                                                        #
##########################################################################

%shub_01_00164_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TRIGGER_ENABLE"               => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Trigger Enabled" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7: Nibble Select" ],
   "NIBBLE7_CHIPLET_SEL"          => [   2,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7: Word Select" ],
   "RSVD0"                        => [   3,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   4,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6: Nibble Select" ],
   "NIBBLE6_CHIPLET_SEL"          => [   5,  48,   4, 0x000F000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6: Word Select" ],
   "RSVD1"                        => [   6,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   7,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5: Nibble Select" ],
   "NIBBLE5_CHIPLET_SEL"          => [   8,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "Nibble 5: Word Select" ],
   "RSVD2"                        => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  10,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4: Nibble Select" ],
   "NIBBLE4_CHIPLET_SEL"          => [  11,  32,   4, 0x0000000F00000000, 0x00, 0, 0x0000000000000000, "Nibble 4: Word Select" ],
   "RSVD3"                        => [  12,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  13,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3: Nibble Select" ],
   "NIBBLE3_CHIPLET_SEL"          => [  14,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "Nibble 3: Word Select" ],
   "RSVD4"                        => [  15,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  16,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2: Nibble Select" ],
   "NIBBLE2_CHIPLET_SEL"          => [  17,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "Nibble 2: Word Select" ],
   "RSVD5"                        => [  18,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  19,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1: Nibble Select" ],
   "NIBBLE1_CHIPLET_SEL"          => [  20,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Nibble 1: Word Select" ],
   "RSVD6"                        => [  21,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  22,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0: Nibble Select" ],
   "NIBBLE0_CHIPLET_SEL"          => [  23,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Nibble 0: Word Select" ],
);

%shub_01_00164_def =
( NAME    => "SH_PI_AFI_TEST_POINT_SELECT",
  ADDRESS => 0x0000000120050180,
  NOTE    => "PI AFI Test Point Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00164_flds
);


##########################################################################
#                                                                        #
#   SH_PI_AFI_TEST_POINT_TRIGGER_SELECT                                     #
#                                                                        #
##########################################################################

%shub_01_00165_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_NIBBLE_SEL"          => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "TRIGGER7_CHIPLET_SEL"         => [   2,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Chiplet select" ],
   "RSVD1"                        => [   3,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_NIBBLE_SEL"          => [   4,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "TRIGGER6_CHIPLET_SEL"         => [   5,  48,   4, 0x000F000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Chiplet select" ],
   "RSVD2"                        => [   6,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_NIBBLE_SEL"          => [   7,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "TRIGGER5_CHIPLET_SEL"         => [   8,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Chiplet select" ],
   "RSVD3"                        => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_NIBBLE_SEL"          => [  10,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "TRIGGER4_CHIPLET_SEL"         => [  11,  32,   4, 0x0000000F00000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Chiplet select" ],
   "RSVD4"                        => [  12,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_NIBBLE_SEL"          => [  13,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "TRIGGER3_CHIPLET_SEL"         => [  14,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Chiplet select" ],
   "RSVD5"                        => [  15,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_NIBBLE_SEL"          => [  16,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "TRIGGER2_CHIPLET_SEL"         => [  17,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "Nibble 2 Chiplet select" ],
   "RSVD6"                        => [  18,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_NIBBLE_SEL"          => [  19,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "TRIGGER1_CHIPLET_SEL"         => [  20,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Nibble 1 Chiplet select" ],
   "RSVD7"                        => [  21,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_NIBBLE_SEL"          => [  22,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "TRIGGER0_CHIPLET_SEL"         => [  23,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Nibble 0 Chiplet select" ],
);

%shub_01_00165_def =
( NAME    => "SH_PI_AFI_TEST_POINT_TRIGGER_SELECT",
  ADDRESS => 0x0000000120050200,
  NOTE    => "PI CRBC Test Point Trigger Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00165_flds
);


##########################################################################
#                                                                        #
#   SH_PI_AUTO_REPLY_ENABLE                                              #
#                                                                        #
##########################################################################

%shub_01_00166_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AUTO_REPLY_ENABLE"            => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Auto Reply Enabled" ],
);

%shub_01_00166_def =
( NAME    => "SH_PI_AUTO_REPLY_ENABLE",
  ADDRESS => 0x0000000120050280,
  NOTE    => "PI Auto Reply Enable",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00166_flds
);


##########################################################################
#                                                                        #
#   SH_PI_CAM_CONTROL                                                    #
#                                                                        #
##########################################################################

%shub_01_00167_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "START"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Start CRB CAM read/write operation" ],
   "RSVD0"                        => [   1,  10,  53, 0x7FFFFFFFFFFFFC00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RRB_RD_XFER_CLEAR"            => [   2,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Clear RRB read tranfer pending." ],
   "CAM_WRITE"                    => [   3,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Is CRB CAM MMR function a write." ],
   "RSVD1"                        => [   4,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CAM_INDX"                     => [   5,   0,   7, 0x000000000000007F, 0x00, 1, 0x0000000000000000, "CRB CAM Index to perform read/write on." ],
);

%shub_01_00167_def =
( NAME    => "SH_PI_CAM_CONTROL",
  ADDRESS => 0x0000000120050300,
  NOTE    => "CRB CAM MMR Access Control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00167_flds
);


##########################################################################
#                                                                        #
#   SH_PI_CRBC_TEST_POINT_COMPARE                                        #
#                                                                        #
##########################################################################

%shub_01_00168_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COMPARE_PATTERN"              => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "debug bit pattern for trigger generation" ],
   "COMPARE_MASK"                 => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Mask to select Debug bits for trigger generation" ],
);

%shub_01_00168_def =
( NAME    => "SH_PI_CRBC_TEST_POINT_COMPARE",
  ADDRESS => 0x0000000120050380,
  NOTE    => "PI CRBC Test Point Compare",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00168_flds
);


##########################################################################
#                                                                        #
#   SH_PI_CRBC_TEST_POINT_SELECT                                         #
#                                                                        #
##########################################################################

%shub_01_00169_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TRIGGER_ENABLE"               => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Enable trigger on bit 32 of Analyzer data" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD0"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_CHIPLET_SEL"          => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Chiplet select" ],
   "RSVD1"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD2"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_CHIPLET_SEL"          => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Chiplet select" ],
   "RSVD3"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD4"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_CHIPLET_SEL"          => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Chiplet select" ],
   "RSVD5"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD6"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_CHIPLET_SEL"          => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Chiplet select" ],
   "RSVD7"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD8"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_CHIPLET_SEL"          => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Chiplet select" ],
   "RSVD9"                        => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD10"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_CHIPLET_SEL"          => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 Chiplet select" ],
   "RSVD11"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD12"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_CHIPLET_SEL"          => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 Chiplet select" ],
   "RSVD13"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD14"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_CHIPLET_SEL"          => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Chiplet select" ],
);

%shub_01_00169_def =
( NAME    => "SH_PI_CRBC_TEST_POINT_SELECT",
  ADDRESS => 0x0000000120050400,
  NOTE    => "PI CRBC Test Point Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00169_flds
);


##########################################################################
#                                                                        #
#   SH_PI_CRBC_TEST_POINT_TRIGGER_SELECT                                     #
#                                                                        #
##########################################################################

%shub_01_00170_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_NIBBLE_SEL"          => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_CHIPLET_SEL"         => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Chiplet select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_NIBBLE_SEL"          => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_CHIPLET_SEL"         => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Chiplet select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_NIBBLE_SEL"          => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_CHIPLET_SEL"         => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Chiplet select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_NIBBLE_SEL"          => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_CHIPLET_SEL"         => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Chiplet select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_NIBBLE_SEL"          => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_CHIPLET_SEL"         => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Chiplet select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_NIBBLE_SEL"          => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_CHIPLET_SEL"         => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 Chiplet select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_NIBBLE_SEL"          => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_CHIPLET_SEL"         => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 Chiplet select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_NIBBLE_SEL"          => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_CHIPLET_SEL"         => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Chiplet select" ],
);

%shub_01_00170_def =
( NAME    => "SH_PI_CRBC_TEST_POINT_TRIGGER_SELECT",
  ADDRESS => 0x0000000120050480,
  NOTE    => "PI CRBC Test Point Trigger Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00170_flds
);


##########################################################################
#                                                                        #
#   SH_PI_CRBP_ERROR_MASK                                                #
#                                                                        #
##########################################################################

%shub_01_00171_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  21,  43, 0xFFFFFFFFFFE00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_RP_CRD_OFLOW"              => [   1,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PI-to-XN Reply Credit Overflow Error Mask" ],
   "XN_RQ_CRD_OFLOW"              => [   2,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PI-to-XN Request Credit Overflow Error Mask" ],
   "MD_RP_CRD_OFLOW"              => [   3,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PI-to-MD Reply Credit Overflow Error Mask" ],
   "MD_RQ_CRD_OFLOW"              => [   4,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PI-to-MD Request Credit Overflow Error Mask" ],
   "GFX_INT_1"                    => [   5,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "PROC0_ADV_INT: Mask Graphics-write Interrupt for Processor 1" ],
   "GFX_INT_0"                    => [   6,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "PROC0_ADV_INT: Mask Graphics-write Interrupt for Processor 0" ],
   "NACK_OFLOW"                   => [   7,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: NACK Overflow Error Mask" ],
   "XN_RP_Q_OFLOW"                => [   8,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: XN-to-PI Reply Queue Overflow Error Mask" ],
   "XN_RQ_Q_OFLOW"                => [   9,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: XN-to-PI Request Queue Overflow Error Mask" ],
   "MD_RP_Q_OFLOW"                => [  10,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "PI_HW_INT: MD-to-PI Reply Queue Overflow Error Mask" ],
   "MD_RQ_Q_OFLOW"                => [  11,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "PI_HW_INT: MD-to-PI Request Queue Overflow Error Mask" ],
   "MSG_COLOR_ERR"                => [  12,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Message Color Error Mask" ],
   "FSB_SHUB_CE"                  => [  13,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "PI_CE_INT: FSB-to-SHUB Correctable Data Error Mask" ],
   "FSB_SHUB_UCE"                 => [  14,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "PI_UCE_INT: FSB-to-SHub Uncorrectable Data Error Mask" ],
   "PIO_TO_ERR"                   => [  15,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PIO Time-out Error Mask" ],
   "MEM_TO_ERR"                   => [  16,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Memory Time-out Error Mask" ],
   "PIO_RP_ERR"                   => [  17,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PIO Reply Error Mask" ],
   "MEM_RP_ERR"                   => [  18,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Memory Reply Error Mask" ],
   "XB_PROTO_ERR"                 => [  19,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "PI_HW_INT: XB-pipe Protocol Error Mask" ],
   "GFX_RP_ERR"                   => [  20,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Graphic-write Reply Error Mask" ],
   "FSB_PROTO_ERR"                => [  21,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "PI_HW_INT: FSB-pipe Protocol Error Mask" ],
);

%shub_01_00171_def =
( NAME    => "SH_PI_CRBP_ERROR_MASK",
  ADDRESS => 0x0000000120050500,
  NOTE    => "PI CRBP Error Mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00171_flds
);


##########################################################################
#                                                                        #
#   SH_PI_CRBP_FSB_PIPE_COMPARE                                          #
#                                                                        #
##########################################################################

%shub_01_00172_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  53,  11, 0xFFE0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COMPARE_REQ"                  => [   1,  47,   6, 0x001F800000000000, 0x00, 1, 0x0000000000000000, "REQa or REQb value to compare against" ],
   "COMPARE_ADDRESS"              => [   2,   0,  47, 0x00007FFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Address A or B to compare against" ],
);

%shub_01_00172_def =
( NAME    => "SH_PI_CRBP_FSB_PIPE_COMPARE",
  ADDRESS => 0x0000000120050580,
  NOTE    => "CRBP FSB Pipe Compare",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00172_flds
);


##########################################################################
#                                                                        #
#   SH_PI_CRBP_FSB_PIPE_MASK                                             #
#                                                                        #
##########################################################################

%shub_01_00173_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  53,  11, 0xFFE0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COMPARE_REQ_MASK"             => [   1,  47,   6, 0x001F800000000000, 0x00, 1, 0x0000000000000000, "REQa or REQb mask values" ],
   "COMPARE_ADDRESS_MASK"         => [   2,   0,  47, 0x00007FFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Address A or B mask values" ],
);

%shub_01_00173_def =
( NAME    => "SH_PI_CRBP_FSB_PIPE_MASK",
  ADDRESS => 0x0000000120050600,
  NOTE    => "CRBP Compare Mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00173_flds
);


##########################################################################
#                                                                        #
#   SH_PI_CRBP_TEST_POINT_COMPARE                                        #
#                                                                        #
##########################################################################

%shub_01_00174_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COMPARE_PATTERN"              => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "debug bit pattern for trigger generation" ],
   "COMPARE_MASK"                 => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Mask to select Debug bits for trigger generation" ],
);

%shub_01_00174_def =
( NAME    => "SH_PI_CRBP_TEST_POINT_COMPARE",
  ADDRESS => 0x0000000120050680,
  NOTE    => "PI CRBP Test Point Compare",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00174_flds
);


##########################################################################
#                                                                        #
#   SH_PI_CRBP_TEST_POINT_SELECT                                         #
#                                                                        #
##########################################################################

%shub_01_00175_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TRIGGER_ENABLE"               => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Enable trigger on bit 32 of Analyzer data" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD0"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_CHIPLET_SEL"          => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Chiplet select" ],
   "RSVD1"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD2"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_CHIPLET_SEL"          => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Chiplet select" ],
   "RSVD3"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD4"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_CHIPLET_SEL"          => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Chiplet select" ],
   "RSVD5"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD6"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_CHIPLET_SEL"          => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Chiplet select" ],
   "RSVD7"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD8"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_CHIPLET_SEL"          => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Chiplet select" ],
   "RSVD9"                        => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD10"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_CHIPLET_SEL"          => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 Chiplet select" ],
   "RSVD11"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD12"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_CHIPLET_SEL"          => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 Chiplet select" ],
   "RSVD13"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD14"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_CHIPLET_SEL"          => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Chiplet select" ],
);

%shub_01_00175_def =
( NAME    => "SH_PI_CRBP_TEST_POINT_SELECT",
  ADDRESS => 0x0000000120050700,
  NOTE    => "PI CRBP Test Point Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00175_flds
);


##########################################################################
#                                                                        #
#   SH_PI_CRBP_TEST_POINT_TRIGGER_SELECT                                     #
#                                                                        #
##########################################################################

%shub_01_00176_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_NIBBLE_SEL"          => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_CHIPLET_SEL"         => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Chiplet select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_NIBBLE_SEL"          => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_CHIPLET_SEL"         => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Chiplet select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_NIBBLE_SEL"          => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_CHIPLET_SEL"         => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Chiplet select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_NIBBLE_SEL"          => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_CHIPLET_SEL"         => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Chiplet select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_NIBBLE_SEL"          => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_CHIPLET_SEL"         => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Chiplet select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_NIBBLE_SEL"          => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_CHIPLET_SEL"         => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 Chiplet select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_NIBBLE_SEL"          => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_CHIPLET_SEL"         => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 Chiplet select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_NIBBLE_SEL"          => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_CHIPLET_SEL"         => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Chiplet select" ],
);

%shub_01_00176_def =
( NAME    => "SH_PI_CRBP_TEST_POINT_TRIGGER_SELECT",
  ADDRESS => 0x0000000120050780,
  NOTE    => "PI CRBP Test Point Trigger Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00176_flds
);


##########################################################################
#                                                                        #
#   SH_PI_CRBP_XB_PIPE_COMPARE_0                                         #
#                                                                        #
##########################################################################

%shub_01_00177_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  55,   9, 0xFF80000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COMPARE_COMMAND"              => [   1,  47,   8, 0x007F800000000000, 0x00, 1, 0x0000000000000000, "SN2NET Command to compare against" ],
   "COMPARE_ADDRESS"              => [   2,   0,  47, 0x00007FFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Address to compare against" ],
);

%shub_01_00177_def =
( NAME    => "SH_PI_CRBP_XB_PIPE_COMPARE_0",
  ADDRESS => 0x0000000120050800,
  NOTE    => "CRBP XB Pipe Compare",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00177_flds
);


##########################################################################
#                                                                        #
#   SH_PI_CRBP_XB_PIPE_COMPARE_1                                         #
#                                                                        #
##########################################################################

%shub_01_00178_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  41,  23, 0xFFFFFE0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COMPARE_ECHO"                 => [   1,  32,   9, 0x000001FF00000000, 0x00, 1, 0x0000000000000000, "Echo to compare against" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COMPARE_SUPPLEMENTAL"         => [   3,  16,  14, 0x000000003FFF0000, 0x00, 1, 0x0000000000000000, "Supplemental to compare against" ],
   "RSVD2"                        => [   4,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COMPARE_SOURCE"               => [   5,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "Source to compare against" ],
);

%shub_01_00178_def =
( NAME    => "SH_PI_CRBP_XB_PIPE_COMPARE_1",
  ADDRESS => 0x0000000120050880,
  NOTE    => "CRBP XB Pipe Compare",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00178_flds
);


##########################################################################
#                                                                        #
#   SH_PI_CRBP_XB_PIPE_MASK_0                                            #
#                                                                        #
##########################################################################

%shub_01_00179_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  55,   9, 0xFF80000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COMPARE_COMMAND_MASK"         => [   1,  47,   8, 0x007F800000000000, 0x00, 1, 0x0000000000000000, "SN2NET Command to compare against" ],
   "COMPARE_ADDRESS_MASK"         => [   2,   0,  47, 0x00007FFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Address to compare against" ],
);

%shub_01_00179_def =
( NAME    => "SH_PI_CRBP_XB_PIPE_MASK_0",
  ADDRESS => 0x0000000120050900,
  NOTE    => "CRBP Compare Mask Register 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00179_flds
);


##########################################################################
#                                                                        #
#   SH_PI_CRBP_XB_PIPE_MASK_1                                            #
#                                                                        #
##########################################################################

%shub_01_00180_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  41,  23, 0xFFFFFE0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COMPARE_ECHO_MASK"            => [   1,  32,   9, 0x000001FF00000000, 0x00, 1, 0x0000000000000000, "Echo to compare against" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COMPARE_SUPPLEMENTAL_MASK"    => [   3,  16,  14, 0x000000003FFF0000, 0x00, 1, 0x0000000000000000, "Supplemental to compare against" ],
   "RSVD2"                        => [   4,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COMPARE_SOURCE_MASK"          => [   5,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "Source to compare against" ],
);

%shub_01_00180_def =
( NAME    => "SH_PI_CRBP_XB_PIPE_MASK_1",
  ADDRESS => 0x0000000120050980,
  NOTE    => "CRBP XB Pipe Compare Mask Register 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00180_flds
);


##########################################################################
#                                                                        #
#   SH_PI_DPC_QUEUE_CONFIG                                               #
#                                                                        #
##########################################################################

%shub_01_00181_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  29,  35, 0xFFFFFFFFE0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FWCQ_AF_THRESH"               => [   1,  24,   5, 0x000000001F000000, 0x00, 1, 0x0000000000000000, "FSB WTL Command Queue Almost Full Threshold" ],
   "RSVD1"                        => [   2,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FWCQ_AE_LEVEL"                => [   3,  16,   5, 0x00000000001F0000, 0x00, 1, 0x0000000000000000, "FSB WTL Command Queue Almost Empty Level" ],
   "RSVD2"                        => [   4,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DWCQ_AF_THRESH"               => [   5,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "DXB WTL Command Queue Almost Full Threshold" ],
   "RSVD3"                        => [   6,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DWCQ_AE_LEVEL"                => [   7,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "DXB WTL Command Queue Almost Empty Level" ],
);

%shub_01_00181_def =
( NAME    => "SH_PI_DPC_QUEUE_CONFIG",
  ADDRESS => 0x0000000120050a00,
  NOTE    => "DPC Queue Configuration",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00181_flds
);


##########################################################################
#                                                                        #
#   SH_PI_ERROR_MASK                                                     #
#                                                                        #
##########################################################################

%shub_01_00182_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MSG_LENGTH"                   => [   1,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Message Length Error Mask" ],
   "FSB_TBL_MISS"                 => [   2,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: FSB Table Miss Error Mask" ],
   "BAD_SNOOP"                    => [   3,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: FSB Snoop Error Mask" ],
   "LIVELOCK"                     => [   4,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: FSB Livelock Error Mask" ],
   "SHUB_FSB_CE"                  => [   5,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "PI_CE_INT: SHub-to-FSB Correctable Data Error Mask" ],
   "SHUB_FSB_UCE"                 => [   6,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "PI_UCE_INT: SHub-to-FSB Uncorrectable Data Error Mask" ],
   "SHUB_FSB_DQE"                 => [   7,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PI-AFI Queue Error Mask" ],
   "ADDR_PARITY"                  => [   8,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Address Parity Error Mask" ],
   "REQ_PARITY"                   => [   9,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Request Parity Error Mask" ],
   "ADDR_ACCESS"                  => [  10,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Address Access Error Mask" ],
   "REQ_FORMAT"                   => [  11,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Request Format Error Mask" ],
   "IOQ_OVERRUN"                  => [  12,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: IOQ Overrun Error Mask" ],
   "RSP_PARITY"                   => [  13,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Response Parity Error Mask" ],
   "HUNG_BUS"                     => [  14,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Hung Bus Error Mask" ],
   "XN_RP_CRD_OFLOW"              => [  15,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PI-to-XN Reply Credit Overflow Error Mask" ],
   "XN_RQ_CRD_OFLOW"              => [  16,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PI-to-XN Request Credit Overflow Error Mask" ],
   "MD_RP_CRD_OFLOW"              => [  17,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PI-to-MD Reply Credit Overflow Error Mask" ],
   "MD_RQ_CRD_OFLOW"              => [  18,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PI-to-MD Request Credit Overflow Error Mask" ],
   "GFX_INT_1"                    => [  19,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "PROC1_ADV_INT: Mask Graphics-write Interrupt for Processor 1" ],
   "GFX_INT_0"                    => [  20,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "PROC0_ADV_INT: Mask Graphics-write Interrupt for Processor 0" ],
   "NACK_OFLOW"                   => [  21,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: NACK Overflow Error Mask" ],
   "XN_RP_Q_OFLOW"                => [  22,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: XN-to-PI Reply Queue Overflow Error Mask" ],
   "XN_RQ_Q_OFLOW"                => [  23,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: XN-to-PI Request Queue Overflow Error Mask" ],
   "MD_RP_Q_OFLOW"                => [  24,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "PI_HW_INT: MD-to-PI Reply Queue Overflow Error Mask" ],
   "MD_RQ_Q_OFLOW"                => [  25,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "PI_HW_INT: MD-to-PI Request Queue Overflow Error Mask" ],
   "MSG_COLOR_ERR"                => [  26,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Message Color Error Mask" ],
   "FSB_SHUB_CE"                  => [  27,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "PI_CE_INT: FSB-to-SHub Correctable Data Error Mask" ],
   "FSB_SHUB_UCE"                 => [  28,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "PI_UCE_INT: FSB-to-SHub Uncorrectable Data Error Mask" ],
   "PIO_TO_ERR"                   => [  29,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PIO Time-out Error Mask" ],
   "MEM_TO_ERR"                   => [  30,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Memory Time-out Error Mask" ],
   "PIO_RP_ERR"                   => [  31,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PIO Reply Error Mask" ],
   "MEM_RP_ERR"                   => [  32,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Memory Reply Error Mask" ],
   "XB_PROTO_ERR"                 => [  33,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "PI_HW_INT: XB-pipe Protocol Error Mask" ],
   "GFX_RP_ERR"                   => [  34,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Graphic-write Reply Error Mask" ],
   "FSB_PROTO_ERR"                => [  35,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "PI_HW_INT: FSB-pipe Protocol Error Mask" ],
);

%shub_01_00182_def =
( NAME    => "SH_PI_ERROR_MASK",
  ADDRESS => 0x0000000120050a80,
  NOTE    => "PI Error Mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00182_flds
);


##########################################################################
#                                                                        #
#   SH_PI_EXPRESS_REPLY_CONFIG                                           #
#                                                                        #
##########################################################################

%shub_01_00183_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   3,  61, 0xFFFFFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MODE"                         => [   1,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Express Reply Mode" ],
);

%shub_01_00183_def =
( NAME    => "SH_PI_EXPRESS_REPLY_CONFIG",
  ADDRESS => 0x0000000120050b00,
  NOTE    => "PI Express Reply Configuration",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00183_flds
);


##########################################################################
#                                                                        #
#   SH_PI_FSB_COMPARE_VALUE                                              #
#                                                                        #
##########################################################################

%shub_01_00184_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COMPARE_VALUE"                => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Compare value" ],
);

%shub_01_00184_def =
( NAME    => "SH_PI_FSB_COMPARE_VALUE",
  ADDRESS => 0x0000000120050c00,
  NOTE    => "FSB Compare Value",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00184_flds
);


##########################################################################
#                                                                        #
#   SH_PI_FSB_COMPARE_MASK                                               #
#                                                                        #
##########################################################################

%shub_01_00185_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK_VALUE"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Mask value" ],
);

%shub_01_00185_def =
( NAME    => "SH_PI_FSB_COMPARE_MASK",
  ADDRESS => 0x0000000120050b80,
  NOTE    => "FSB Compare Mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00185_flds
);


##########################################################################
#                                                                        #
#   SH_PI_FSB_ERROR_INJECTION                                            #
#                                                                        #
##########################################################################

%shub_01_00186_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BUS_HANG"                     => [   1,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "Inject an bus hang on the FSB" ],
   "LIVELOCK"                     => [   2,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "Inject a livelock Error on the FSB" ],
   "IOQ_OVERRUN"                  => [   3,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Inject an ioq overrun Error on the FSB" ],
   "RSVD1"                        => [   4,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DW3_UCE_FROM_FSB"             => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Inject a Uncorrectable Error in Doubleword 0 of SIC Data Packet 0" ],
   "DW3_CE_FROM_FSB"              => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "Inject a Correctable Error in Doubleword 0 of SIC Data Packet 0" ],
   "DW2_UCE_FROM_FSB"             => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "Inject a Uncorrectable Error in Doubleword 0 of SIC Data Packet 0" ],
   "DW2_CE_FROM_FSB"              => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Inject a Correctable Error in Doubleword 0 of SIC Data Packet 0" ],
   "DW1_UCE_FROM_FSB"             => [   9,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Inject a Uncorrectable Error in Doubleword 0 of SIC Data Packet 0" ],
   "DW1_CE_FROM_FSB"              => [  10,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Inject a Correctable Error in Doubleword 0 of SIC Data Packet 0" ],
   "DW0_UCE_FROM_FSB"             => [  11,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Inject a Uncorrectable Error in Doubleword 0 of SIC Data Packet 0" ],
   "DW0_CE_FROM_FSB"              => [  12,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Inject a Correctable Error in Doubleword 0 of SIC Data Packet 0" ],
   "RSP_PE_FROM_FSB"              => [  13,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Inject a RSP# Parity Error When Sampling the FSB" ],
   "AP1_PE_FROM_FSB"              => [  14,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Inject an AP[1]# Parity Error When Sampling the FSB" ],
   "AP0_PE_FROM_FSB"              => [  15,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Inject an AP[0]# Parity Error When Sampling the FSB" ],
   "RP_PE_FROM_FSB"               => [  16,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Inject a RP# Parity Error When Sampling the FSB" ],
   "RSVD2"                        => [  17,  10,   6, 0x000000000000FC00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IP1_PE_TO_FSB"                => [  18,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Inject an IP[1]# Parity Error onto the FSB" ],
   "IP0_PE_TO_FSB"                => [  19,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Inject an IP[0]# Parity Error onto the FSB" ],
   "DW1_UCE_TO_FSB"               => [  20,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Inject an Uncorrectable Error in Doubleword 1 onto the FSB" ],
   "DW1_CE_TO_FSB"                => [  21,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Inject a Correctable Error in Doubleword 1 onto the FSB" ],
   "DW0_UCE_TO_FSB"               => [  22,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Inject an Uncorrectable Error in Doubleword 0 onto the FSB" ],
   "DW0_CE_TO_FSB"                => [  23,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Inject a Correctable Error in Doubleword 0 onto the FSB" ],
   "RSP_PE_TO_FSB"                => [  24,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Inject a RSP# Parity Error onto the FSB" ],
   "AP1_PE_TO_FSB"                => [  25,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Inject an AP[1]# Parity Error onto the FSB" ],
   "AP0_PE_TO_FSB"                => [  26,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Inject an AP[0]# Parity Error onto the FSB" ],
   "RP_PE_TO_FSB"                 => [  27,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Inject a RP# Parity Error onto the FSB" ],
);

%shub_01_00186_def =
( NAME    => "SH_PI_FSB_ERROR_INJECTION",
  ADDRESS => 0x0000000120050c80,
  NOTE    => "Inject an Error onto the FSB",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00186_flds
);


##########################################################################
#                                                                        #
#   SH_PI_MD2PI_REPLY_VC_CONFIG                                          #
#                                                                        #
##########################################################################

%shub_01_00187_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CAPTURE_CREDIT_STATUS"        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Capture credit and status information" ],
   "FORCE_CREDIT"                 => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Send an extra credit to sender" ],
   "RSVD0"                        => [   2,  14,  48, 0x3FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CREDITS"                  => [   3,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "Maximum credits from sender" ],
   "DATA_DEPTH"                   => [   4,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "Number of data buffers Available" ],
   "HDR_DEPTH"                    => [   5,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Depth of header Buffer" ],
);

%shub_01_00187_def =
( NAME    => "SH_PI_MD2PI_REPLY_VC_CONFIG",
  ADDRESS => 0x0000000120050d00,
  NOTE    => "MD-to-PI Reply Virtual Channel Configuration",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00187_flds
);


##########################################################################
#                                                                        #
#   SH_PI_MD2PI_REQUEST_VC_CONFIG                                        #
#                                                                        #
##########################################################################

%shub_01_00188_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CAPTURE_CREDIT_STATUS"        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Capture credit and status information" ],
   "FORCE_CREDIT"                 => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Send an extra credit to sender" ],
   "RSVD0"                        => [   2,  14,  48, 0x3FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CREDITS"                  => [   3,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "Maximum credits from sender" ],
   "DATA_DEPTH"                   => [   4,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "Number of data buffers Available" ],
   "HDR_DEPTH"                    => [   5,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Depth of header Buffer" ],
);

%shub_01_00188_def =
( NAME    => "SH_PI_MD2PI_REQUEST_VC_CONFIG",
  ADDRESS => 0x0000000120050d80,
  NOTE    => "MD-to-PI Request Virtual Channel Configuration",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00188_flds
);


##########################################################################
#                                                                        #
#   SH_PI_QUEUE_ERROR_INJECTION                                          #
#                                                                        #
##########################################################################

%shub_01_00189_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XNPI_RPY_BFR"                 => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "RXL_RDY_Q"                    => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "RXL_KILL_Q"                   => [   3,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "PTC_INTR"                     => [   4,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "MDPI_RPY_BFR"                 => [   5,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "FSB_WTL_CMND_Q"               => [   6,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "DXB_WTL_CMND_Q"               => [   7,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "DAT_DFR_Q"                    => [   8,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%shub_01_00189_def =
( NAME    => "SH_PI_QUEUE_ERROR_INJECTION",
  ADDRESS => 0x0000000120050e00,
  NOTE    => "PI Queue Error Injection",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00189_flds
);


##########################################################################
#                                                                        #
#   SH_PI_TEST_POINT_COMPARE                                             #
#                                                                        #
##########################################################################

%shub_01_00190_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COMPARE_PATTERN"              => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 1, 0x0000000000000000, "Pattern of test point data to cause trigger" ],
   "COMPARE_MASK"                 => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "Mask to select test point data for trigger generation" ],
);

%shub_01_00190_def =
( NAME    => "SH_PI_TEST_POINT_COMPARE",
  ADDRESS => 0x0000000120050e80,
  NOTE    => "PI Test Point Compare",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00190_flds
);


##########################################################################
#                                                                        #
#   SH_PI_TEST_POINT_SELECT                                              #
#                                                                        #
##########################################################################

%shub_01_00191_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TRIGGER_ENABLE"               => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Enable trigger on bit 32 of Analyzer data" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 1, 0x0000000000000000, "Nibble X is routed to Nibble 7" ],
   "RSVD0"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_CHIPLET_SEL"          => [   3,  56,   3, 0x0700000000000000, 0x00, 1, 0x0000000000000000, "Nibble 7 data is from Chiplet X" ],
   "RSVD1"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 1, 0x0000000000000000, "Nibble X is routed to Nibble 6" ],
   "RSVD2"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_CHIPLET_SEL"          => [   7,  48,   3, 0x0007000000000000, 0x00, 1, 0x0000000000000000, "Nibble 6 data is from Chiplet X" ],
   "RSVD3"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 1, 0x0000000000000000, "Nibble X is routed to Nibble 5" ],
   "RSVD4"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_CHIPLET_SEL"          => [  11,  40,   3, 0x0000070000000000, 0x00, 1, 0x0000000000000000, "Nibble 5 data is from Chiplet X" ],
   "RSVD5"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "Nibble X is routed to Nibble 4" ],
   "RSVD6"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_CHIPLET_SEL"          => [  15,  32,   3, 0x0000000700000000, 0x00, 1, 0x0000000000000000, "Nibble 4 data is from Chiplet X" ],
   "RSVD7"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 1, 0x0000000000000000, "Nibble X is routed to Nibble 3" ],
   "RSVD8"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_CHIPLET_SEL"          => [  19,  24,   3, 0x0000000007000000, 0x00, 1, 0x0000000000000000, "Nibble 3 data is from Chiplet X" ],
   "RSVD9"                        => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 1, 0x0000000000000000, "Nibble X is routed to Nibble 2" ],
   "RSVD10"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_CHIPLET_SEL"          => [  23,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "Nibble 2 data is from Chiplet X" ],
   "RSVD11"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 1, 0x0000000000000000, "Nibble X is routed to Nibble 1" ],
   "RSVD12"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_CHIPLET_SEL"          => [  27,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "Nibble 1 data is from Chiplet X" ],
   "RSVD13"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 1, 0x0000000000000000, "Nibble X is routed to Nibble 0" ],
   "RSVD14"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_CHIPLET_SEL"          => [  31,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Nibble 0 data is from Chiplet X" ],
);

%shub_01_00191_def =
( NAME    => "SH_PI_TEST_POINT_SELECT",
  ADDRESS => 0x0000000120050f00,
  NOTE    => "PI Test Point Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00191_flds
);


##########################################################################
#                                                                        #
#   SH_PI_TEST_POINT_TRIGGER_SELECT                                      #
#                                                                        #
##########################################################################

%shub_01_00192_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_NIBBLE_SEL"          => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_CHIPLET_SEL"         => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Chiplet select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_NIBBLE_SEL"          => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_CHIPLET_SEL"         => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Chiplet select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_NIBBLE_SEL"          => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_CHIPLET_SEL"         => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Chiplet select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_NIBBLE_SEL"          => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_CHIPLET_SEL"         => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Chiplet select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_NIBBLE_SEL"          => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_CHIPLET_SEL"         => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Chiplet select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_NIBBLE_SEL"          => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_CHIPLET_SEL"         => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 Chiplet select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_NIBBLE_SEL"          => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_CHIPLET_SEL"         => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 Chiplet select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_NIBBLE_SEL"          => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_CHIPLET_SEL"         => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Chiplet select" ],
);

%shub_01_00192_def =
( NAME    => "SH_PI_TEST_POINT_TRIGGER_SELECT",
  ADDRESS => 0x0000000120050f80,
  NOTE    => "PI Test Point Trigger Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00192_flds
);


##########################################################################
#                                                                        #
#   SH_PI_XN2PI_REPLY_VC_CONFIG                                          #
#                                                                        #
##########################################################################

%shub_01_00193_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CAPTURE_CREDIT_STATUS"        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Capture credit and status information" ],
   "FORCE_CREDIT"                 => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Send an extra credit to sender" ],
   "RSVD0"                        => [   2,  14,  48, 0x3FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CREDITS"                  => [   3,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "Maximum credits from sender" ],
   "DATA_DEPTH"                   => [   4,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "Number of data buffers Available" ],
   "HDR_DEPTH"                    => [   5,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Depth of header Buffer" ],
);

%shub_01_00193_def =
( NAME    => "SH_PI_XN2PI_REPLY_VC_CONFIG",
  ADDRESS => 0x0000000120051000,
  NOTE    => "XN-to-PI Reply Virtual Channel Configuration",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00193_flds
);


##########################################################################
#                                                                        #
#   SH_PI_XN2PI_REQUEST_VC_CONFIG                                        #
#                                                                        #
##########################################################################

%shub_01_00194_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CAPTURE_CREDIT_STATUS"        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Capture credit and status information" ],
   "FORCE_CREDIT"                 => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Send an extra credit to sender" ],
   "RSVD0"                        => [   2,  14,  48, 0x3FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CREDITS"                  => [   3,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "Maximum credits from sender" ],
   "DATA_DEPTH"                   => [   4,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "Number of data buffers Available" ],
   "HDR_DEPTH"                    => [   5,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Depth of header Buffer" ],
);

%shub_01_00194_def =
( NAME    => "SH_PI_XN2PI_REQUEST_VC_CONFIG",
  ADDRESS => 0x0000000120051080,
  NOTE    => "XN-to-PI Request Virtual Channel Configuration",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00194_flds
);


##########################################################################
#                                                                        #
#   SH_PI_AEC_STATUS                                                     #
#                                                                        #
##########################################################################

%shub_01_00195_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   3,  61, 0xFFFFFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STATE"                        => [   1,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "AEC State" ],
);

%shub_01_00195_def =
( NAME    => "SH_PI_AEC_STATUS",
  ADDRESS => 0x0000000120060000,
  NOTE    => "PI Adaptive Error Correction Status",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00195_flds
);


##########################################################################
#                                                                        #
#   SH_PI_AFI_FIRST_ERROR                                                #
#                                                                        #
##########################################################################

%shub_01_00196_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MSG_LEN"                      => [   1,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "Runt or Obese message received from SIC" ],
   "FSB_TBL_MISS"                 => [   2,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "AFI FSB request table miss error was detected" ],
   "BAD_SNOOP"                    => [   3,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "AFI bad snoop error was detected" ],
   "LIVELOCK"                     => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "AFI livelock error was detected" ],
   "SHUB_FSB_CE"                  => [   5,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "An correctable ECC error was detected" ],
   "SHUB_FSB_UCE"                 => [   6,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "An un-correctable ECC error was detected" ],
   "SHUB_FSB_DQE"                 => [   7,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "SHUB_FSB_DQE" ],
   "ADDR_PARITY"                  => [   8,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Parity error detected on address" ],
   "REQ_PARITY"                   => [   9,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "Parity error detected during request phase" ],
   "ADDR_ACCESS"                  => [  10,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "Access to Address is not supported" ],
   "REQ_FORMAT"                   => [  11,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "FSB request format not supported" ],
   "IOQ_OVERRUN"                  => [  12,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Over run error detected on IOQ" ],
   "RSP_PARITY"                   => [  13,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Parity error detecte during response phase" ],
   "HUNG_BUS"                     => [  14,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "FSB is hung" ],
   "RSVD1"                        => [  15,   9,  12, 0x00000000001FFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FSB_SHUB_CE"                  => [  16,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "A correctable ECC error was detected" ],
   "FSB_SHUB_UCE"                 => [  17,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "An un-correctable ECC error was detected" ],
);

%shub_01_00196_def =
( NAME    => "SH_PI_AFI_FIRST_ERROR",
  ADDRESS => 0x0000000120060080,
  NOTE    => "PI AFI First Error",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00196_flds
);


##########################################################################
#                                                                        #
#   SH_PI_CAM_ADDRESS_READ_DATA                                          #
#                                                                        #
##########################################################################

%shub_01_00197_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CAM_ADDR_VAL"                 => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB CAM Address Read Data Valid." ],
   "RSVD0"                        => [   1,  48,  15, 0x7FFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CAM_ADDR"                     => [   2,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "CRB CAM Address Read Data." ],
);

%shub_01_00197_def =
( NAME    => "SH_PI_CAM_ADDRESS_READ_DATA",
  ADDRESS => 0x0000000120060100,
  NOTE    => "CRB CAM MMR Address Read Data",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00197_flds
);


##########################################################################
#                                                                        #
#   SH_PI_CAM_LPRA_READ_DATA                                             #
#                                                                        #
##########################################################################

%shub_01_00198_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CAM_LPRA"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "CRB CAM LPRA read data." ],
);

%shub_01_00198_def =
( NAME    => "SH_PI_CAM_LPRA_READ_DATA",
  ADDRESS => 0x0000000120060180,
  NOTE    => "CRB CAM MMR LPRA Read Data",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00198_flds
);


##########################################################################
#                                                                        #
#   SH_PI_CAM_STATE_READ_DATA                                            #
#                                                                        #
##########################################################################

%shub_01_00199_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CAM_RD_DATA_VAL"              => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB CAM MMR read data is valid." ],
   "RSVD0"                        => [   1,  50,  13, 0x7FFC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CAM_LPRA"                     => [   2,  32,  18, 0x0003FFFF00000000, 0x00, 1, 0x0000000000000000, "CRB LPRA Overflow Data." ],
   "RSVD1"                        => [   3,   6,  26, 0x00000000FFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CAM_STATE_RD_PEND"            => [   4,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "CRB CAM State Read Pending." ],
   "CAM_TO"                       => [   5,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "CRB CAM Time-out Status." ],
   "CAM_STATE"                    => [   6,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "CRB CAM State read data." ],
);

%shub_01_00199_def =
( NAME    => "SH_PI_CAM_STATE_READ_DATA",
  ADDRESS => 0x0000000120060200,
  NOTE    => "CRB CAM MMR State Read Data",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00199_flds
);


##########################################################################
#                                                                        #
#   SH_PI_CORRECTED_DETAIL_1                                             #
#                                                                        #
##########################################################################

%shub_01_00200_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DEP"                          => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "Data-ECC-Protection Bits of the First Failing Doubleword" ],
   "SYNDROME"                     => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Syndrome of the First Failing Doubleword" ],
   "ADDRESS"                      => [   2,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Physical Address of the First Failing Doubleword" ],
);

%shub_01_00200_def =
( NAME    => "SH_PI_CORRECTED_DETAIL_1",
  ADDRESS => 0x0000000120060280,
  NOTE    => "PI Corrected Error Detail 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00200_flds
);


##########################################################################
#                                                                        #
#   SH_PI_CORRECTED_DETAIL_2                                             #
#                                                                        #
##########################################################################

%shub_01_00201_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Failing Doubleword Value" ],
);

%shub_01_00201_def =
( NAME    => "SH_PI_CORRECTED_DETAIL_2",
  ADDRESS => 0x0000000120060300,
  NOTE    => "PI Corrected Error Detail 2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00201_flds
);


##########################################################################
#                                                                        #
#   SH_PI_CORRECTED_DETAIL_3                                             #
#                                                                        #
##########################################################################

%shub_01_00202_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DEP"                          => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "Data-ECC-Protection Bits of the First Failing Doubleword" ],
   "SYNDROME"                     => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Syndrome of the First Failing Doubleword" ],
   "ADDRESS"                      => [   2,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Physical Address of the First Failing Doubleword" ],
);

%shub_01_00202_def =
( NAME    => "SH_PI_CORRECTED_DETAIL_3",
  ADDRESS => 0x0000000120060380,
  NOTE    => "PI Corrected Error Detail 3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00202_flds
);


##########################################################################
#                                                                        #
#   SH_PI_CORRECTED_DETAIL_4                                             #
#                                                                        #
##########################################################################

%shub_01_00203_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Failing Doubleword Value" ],
);

%shub_01_00203_def =
( NAME    => "SH_PI_CORRECTED_DETAIL_4",
  ADDRESS => 0x0000000120060400,
  NOTE    => "PI Corrected Error Detail 4",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00203_flds
);


##########################################################################
#                                                                        #
#   SH_PI_CRBP_FIRST_ERROR                                               #
#                                                                        #
##########################################################################

%shub_01_00204_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  21,  43, 0xFFFFFFFFFFE00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_RP_CRD_OFLOW"              => [   1,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "XN Reply Credit Overflow Error" ],
   "XN_RQ_CRD_OFLOW"              => [   2,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "XN Request Credit Overflow Error" ],
   "MD_RP_CRD_OFLOW"              => [   3,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "MD Reply Credit Overflow Error" ],
   "MD_RQ_CRD_OFLOW"              => [   4,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "MD Request Credit Overflow Error" ],
   "GFX_INT_1"                    => [   5,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "GFX transfer interrupt for CPU 1" ],
   "GFX_INT_0"                    => [   6,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "GFX transfer interrupt for CPU 0" ],
   "NACK_OFLOW"                   => [   7,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NACK over flow error" ],
   "XN_RP_Q_OFLOW"                => [   8,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "XN Reply input buffer over flow error" ],
   "XN_RQ_Q_OFLOW"                => [   9,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "XN Request input buffer over flow error" ],
   "MD_RP_Q_OFLOW"                => [  10,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "MD Reply input buffer over flow error" ],
   "MD_RQ_Q_OFLOW"                => [  11,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "MD Request input buffer over flow error" ],
   "MSG_COLOR_ERR"                => [  12,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Message color was wrong" ],
   "FSB_SHUB_CE"                  => [  13,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "A correctable ECC error was detected" ],
   "FSB_SHUB_UCE"                 => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "An un-correctable ECC error was detected" ],
   "PIO_TO_ERR"                   => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "CRB's XB pipe detected a PIO time-out" ],
   "MEM_TO_ERR"                   => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "CRB's XB pipe detected a CRB time-out" ],
   "PIO_RP_ERR"                   => [  17,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "CRB's XB pipe received a PIO error reply message" ],
   "MEM_RP_ERR"                   => [  18,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "CRB's XB pipe received a memory error reply message" ],
   "XB_PROTO_ERR"                 => [  19,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "CRB's XB pipe detected protocol table miss" ],
   "GFX_RP_ERR"                   => [  20,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "CRB's XB pipe received a GFX error reply" ],
   "FSB_PROTO_ERR"                => [  21,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "CRB's FSB pipe detected protocol table miss" ],
);

%shub_01_00204_def =
( NAME    => "SH_PI_CRBP_FIRST_ERROR",
  ADDRESS => 0x0000000120060480,
  NOTE    => "PI CRBP First Error",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00204_flds
);


##########################################################################
#                                                                        #
#   SH_PI_ERROR_DETAIL_1                                                 #
#                                                                        #
##########################################################################

%shub_01_00205_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATUS"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Error Detail 1" ],
);

%shub_01_00205_def =
( NAME    => "SH_PI_ERROR_DETAIL_1",
  ADDRESS => 0x0000000120060500,
  NOTE    => "PI Error Detail 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00205_flds
);


##########################################################################
#                                                                        #
#   SH_PI_ERROR_DETAIL_2                                                 #
#                                                                        #
##########################################################################

%shub_01_00206_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATUS"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Error Status" ],
);

%shub_01_00206_def =
( NAME    => "SH_PI_ERROR_DETAIL_2",
  ADDRESS => 0x0000000120060580,
  NOTE    => "PI Error Detail 2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00206_flds
);


##########################################################################
#                                                                        #
#   SH_PI_ERROR_OVERFLOW                                                 #
#                                                                        #
##########################################################################

%shub_01_00207_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MSG_LENGTH"                   => [   1,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Message Length Error Overflow" ],
   "FSB_TBL_MISS"                 => [   2,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB Table Miss Error Overflow" ],
   "BAD_SNOOP"                    => [   3,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB Snoop Error Overflow" ],
   "LIVELOCK"                     => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB Livelock Error Overflow" ],
   "SHUB_FSB_CE"                  => [   5,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "PI_CE_INT: SHub-to-FSB Correctable Data Error Overflow" ],
   "SHUB_FSB_UCE"                 => [   6,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI_UCE_INT: SHub-to-FSB Uncorrectable Data Error Overflow" ],
   "SHUB_FSB_DQE"                 => [   7,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-AFI Queue Error Overflow" ],
   "ADDR_PARITY"                  => [   8,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Address Parity Error Overflow" ],
   "REQ_PARITY"                   => [   9,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Request Parity Error Overflow" ],
   "ADDR_ACCESS"                  => [  10,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Address Access Error Overflow" ],
   "REQ_FORMAT"                   => [  11,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Request Format Error Overflow" ],
   "IOQ_OVERRUN"                  => [  12,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: IOQ Overrun Error Overflow" ],
   "RSP_PARITY"                   => [  13,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Response Parity Error Overflow" ],
   "HUNG_BUS"                     => [  14,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Hung Bus Error Overflow" ],
   "XN_RP_CRD_OFLOW"              => [  15,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-XN Reply Credit Overflow Error Overflow" ],
   "XN_RQ_CRD_OFLOW"              => [  16,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-XN Request Credit Overflow Error Overflow" ],
   "MD_RP_CRD_OFLOW"              => [  17,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-MD Reply Credit Overflow Error Overflow" ],
   "MD_RQ_CRD_OFLOW"              => [  18,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-MD Request Credit Overflow Error Overflow" ],
   "GFX_INT_1"                    => [  19,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "PROC1_ADV_INT: Graphics-write Interrupt Overflow for Processor 1" ],
   "GFX_INT_0"                    => [  20,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "PROC0_ADV_INT: Graphics-write Interrupt Overflow for Processor 0" ],
   "NACK_OFLOW"                   => [  21,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: NACK Overflow Error Overflow" ],
   "XN_RP_Q_OFLOW"                => [  22,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: XN-to-PI Reply Queue Overflow Error Overflow" ],
   "XN_RQ_Q_OFLOW"                => [  23,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: XN-to-PI Request Queue Overflow Error Overflow" ],
   "MD_RP_Q_OFLOW"                => [  24,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI_HW_INT: MD-to-PI Reply Queue Overflow Error Overflow" ],
   "MD_RQ_Q_OFLOW"                => [  25,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI_HW_INT: MD-to-PI Request Queue Overflow Error Overflow" ],
   "MSG_COLOR_ERR"                => [  26,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Message Color Error Overflow" ],
   "FSB_SHUB_CE"                  => [  27,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "PI_CE_INT: FSB-to-SHub Correctable Data Error Overflow" ],
   "FSB_SHUB_UCE"                 => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "PI_UCE_INT: FSB-to-SHub Uncorrectable Data Error Overflow" ],
   "PIO_TO_ERR"                   => [  29,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PIO Time-out Error Overflow" ],
   "MEM_TO_ERR"                   => [  30,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Memory Time-out Error Overflow" ],
   "PIO_RP_ERR"                   => [  31,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PIO Reply Error Overflow" ],
   "MEM_RP_ERR"                   => [  32,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Memory Reply Error Overflow" ],
   "XB_PROTO_ERR"                 => [  33,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "PI_HW_INT: XB-pipe Protocol Error Overflow" ],
   "GFX_RP_ERR"                   => [  34,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Graphic-write Reply Error Overflow" ],
   "FSB_PROTO_ERR"                => [  35,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB-pipe Protocol Error Overflow" ],
);

%shub_01_00207_def =
( NAME    => "SH_PI_ERROR_OVERFLOW",
  ADDRESS => 0x0000000120060600,
  NOTE    => "PI Error Overflow",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00207_flds
);


##########################################################################
#                                                                        #
#   SH_PI_ERROR_OVERFLOW_ALIAS                                           #
#                                                                        #
##########################################################################

%shub_01_00208_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MSG_LENGTH"                   => [   1,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Message Length Error Overflow" ],
   "FSB_TBL_MISS"                 => [   2,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB Table Miss Error Overflow" ],
   "BAD_SNOOP"                    => [   3,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB Snoop Error Overflow" ],
   "LIVELOCK"                     => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB Livelock Error Overflow" ],
   "SHUB_FSB_CE"                  => [   5,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "PI_CE_INT: SHub-to-FSB Correctable Data Error Overflow" ],
   "SHUB_FSB_UCE"                 => [   6,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI_UCE_INT: SHub-to-FSB Uncorrectable Data Error Overflow" ],
   "SHUB_FSB_DQE"                 => [   7,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-AFI Queue Error Overflow" ],
   "ADDR_PARITY"                  => [   8,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Address Parity Error Overflow" ],
   "REQ_PARITY"                   => [   9,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Request Parity Error Overflow" ],
   "ADDR_ACCESS"                  => [  10,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Address Access Error Overflow" ],
   "REQ_FORMAT"                   => [  11,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Request Format Error Overflow" ],
   "IOQ_OVERRUN"                  => [  12,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: IOQ Overrun Error Overflow" ],
   "RSP_PARITY"                   => [  13,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Response Parity Error Overflow" ],
   "HUNG_BUS"                     => [  14,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Hung Bus Error Overflow" ],
   "XN_RP_CRD_OFLOW"              => [  15,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-XN Reply Credit Overflow Error Overflow" ],
   "XN_RQ_CRD_OFLOW"              => [  16,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-XN Request Credit Overflow Error Overflow" ],
   "MD_RP_CRD_OFLOW"              => [  17,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-MD Reply Credit Overflow Error Overflow" ],
   "MD_RQ_CRD_OFLOW"              => [  18,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-MD Request Credit Overflow Error Overflow" ],
   "GFX_INT_1"                    => [  19,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "PROC1_ADV_INT: Graphics-write Interrupt Overflow for Processor 1" ],
   "GFX_INT_0"                    => [  20,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "PROC0_ADV_INT: Graphics-write Interrupt Overflow for Processor 0" ],
   "NACK_OFLOW"                   => [  21,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: NACK Overflow Error Overflow" ],
   "XN_RP_Q_OFLOW"                => [  22,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: XN-to-PI Reply Queue Overflow Error Overflow" ],
   "XN_RQ_Q_OFLOW"                => [  23,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: XN-to-PI Request Queue Overflow Error Overflow" ],
   "MD_RP_Q_OFLOW"                => [  24,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI_HW_INT: MD-to-PI Reply Queue Overflow Error Overflow" ],
   "MD_RQ_Q_OFLOW"                => [  25,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI_HW_INT: MD-to-PI Request Queue Overflow Error Overflow" ],
   "MSG_COLOR_ERR"                => [  26,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Message Color Error Overflow" ],
   "FSB_SHUB_CE"                  => [  27,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "PI_CE_INT: FSB-to-SHub Correctable Data Error Overflow" ],
   "FSB_SHUB_UCE"                 => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "PI_UCE_INT: FSB-to-SHub Uncorrectable Data Error Overflow" ],
   "PIO_TO_ERR"                   => [  29,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PIO Time-out Error Overflow" ],
   "MEM_TO_ERR"                   => [  30,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Memory Time-out Error Overflow" ],
   "PIO_RP_ERR"                   => [  31,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PIO Reply Error Overflow" ],
   "MEM_RP_ERR"                   => [  32,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Memory Reply Error Overflow" ],
   "XB_PROTO_ERR"                 => [  33,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "PI_HW_INT: XB-pipe Protocol Error Overflow" ],
   "GFX_RP_ERR"                   => [  34,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Graphic-write Reply Error Overflow" ],
   "FSB_PROTO_ERR"                => [  35,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB-pipe Protocol Error Overflow" ],
);

%shub_01_00208_def =
( NAME    => "SH_PI_ERROR_OVERFLOW_ALIAS",
  ADDRESS => 0x0000000120060608,
  NOTE    => "PI Error Overflow Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00208_flds
);


##########################################################################
#                                                                        #
#   SH_PI_ERROR_SUMMARY                                                  #
#                                                                        #
##########################################################################

%shub_01_00209_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MSG_LENGTH"                   => [   1,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Message Length Error" ],
   "FSB_TBL_MISS"                 => [   2,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB Table Miss Error" ],
   "BAD_SNOOP"                    => [   3,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB Snoop Error" ],
   "LIVELOCK"                     => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB Live-lock Error" ],
   "SHUB_FSB_CE"                  => [   5,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "PI_CE_INT: SHub-to-FSB Correctable Data Error" ],
   "SHUB_FSB_UCE"                 => [   6,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI_UCE_INT: SHub-to-FSB Uncorrectable Data Error" ],
   "SHUB_FSB_DQE"                 => [   7,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-AFI Queue Error" ],
   "ADDR_PARITY"                  => [   8,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Address Parity Error" ],
   "REQ_PARITY"                   => [   9,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Request Parity Error" ],
   "ADDR_ACCESS"                  => [  10,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Address Access Error" ],
   "REQ_FORMAT"                   => [  11,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Request Format Error" ],
   "IOQ_OVERRUN"                  => [  12,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: IOQ Overrun Error" ],
   "RSP_PARITY"                   => [  13,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Response Parity Error" ],
   "HUNG_BUS"                     => [  14,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Hung Bus Error" ],
   "XN_RP_CRD_OFLOW"              => [  15,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-XN Reply Credit Overflow Error" ],
   "XN_RQ_CRD_OFLOW"              => [  16,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-XN Request Credit Overflow Error" ],
   "MD_RP_CRD_OFLOW"              => [  17,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-MD Reply Credit Overflow Error" ],
   "MD_RQ_CRD_OFLOW"              => [  18,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-MD Request Credit Overflow Error" ],
   "GFX_INT_1"                    => [  19,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "PROC1_ADV_INT: Graphics-write Interrupt for Processor 1" ],
   "GFX_INT_0"                    => [  20,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "PROC0_ADV_INT: Graphics-write Interrupt for Processor 0" ],
   "NACK_OFLOW"                   => [  21,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: NACK Overflow Error" ],
   "XN_RP_Q_OFLOW"                => [  22,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: XN-to-PI Reply Queue Overflow Error" ],
   "XN_RQ_Q_OFLOW"                => [  23,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: XN-to-PI Request Queue Overflow Error" ],
   "MD_RP_Q_OFLOW"                => [  24,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI_HW_INT: MD-to-PI Reply Queue Overflow Error" ],
   "MD_RQ_Q_OFLOW"                => [  25,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI_HW_INT: MD-to-PI Request Queue Overflow Error" ],
   "MSG_COLOR_ERR"                => [  26,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Message Color Error" ],
   "FSB_SHUB_CE"                  => [  27,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "PI_CE_INT: FSB-to-SHub Correctable Data Error" ],
   "FSB_SHUB_UCE"                 => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "PI_UCE_INT: FSB-to-SHub Uncorrectable Data Error" ],
   "PIO_TO_ERR"                   => [  29,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PIO Time-out Error" ],
   "MEM_TO_ERR"                   => [  30,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Memory Time-out Error" ],
   "PIO_RP_ERR"                   => [  31,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PIO Reply Error" ],
   "MEM_RP_ERR"                   => [  32,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Memory Reply Error" ],
   "XB_PROTO_ERR"                 => [  33,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "PI_HW_INT: XB-pipe Protocol Error" ],
   "GFX_RP_ERR"                   => [  34,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Graphic-write Reply Error" ],
   "FSB_PROTO_ERR"                => [  35,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB-pipe Protocol Error" ],
);

%shub_01_00209_def =
( NAME    => "SH_PI_ERROR_SUMMARY",
  ADDRESS => 0x0000000120060680,
  NOTE    => "PI Error Summary",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00209_flds
);


##########################################################################
#                                                                        #
#   SH_PI_ERROR_SUMMARY_ALIAS                                            #
#                                                                        #
##########################################################################

%shub_01_00210_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MSG_LENGTH"                   => [   1,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Message Length Error" ],
   "FSB_TBL_MISS"                 => [   2,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB Table Miss Error" ],
   "BAD_SNOOP"                    => [   3,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB Snoop Error" ],
   "LIVELOCK"                     => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB Live-lock Error" ],
   "SHUB_FSB_CE"                  => [   5,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "PI_CE_INT: SHub-to-FSB Correctable Data Error" ],
   "SHUB_FSB_UCE"                 => [   6,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PI_UCE_INT: SHub-to-FSB Uncorrectable Data Error" ],
   "SHUB_FSB_DQE"                 => [   7,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-AFI Queue Error" ],
   "ADDR_PARITY"                  => [   8,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Address Parity Error" ],
   "REQ_PARITY"                   => [   9,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Request Parity Error" ],
   "ADDR_ACCESS"                  => [  10,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Address Access Error" ],
   "REQ_FORMAT"                   => [  11,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Request Format Error" ],
   "IOQ_OVERRUN"                  => [  12,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: IOQ Overrun Error" ],
   "RSP_PARITY"                   => [  13,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Response Parity Error" ],
   "HUNG_BUS"                     => [  14,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Hung Bus Error" ],
   "XN_RP_CRD_OFLOW"              => [  15,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-XN Reply Credit Overflow Error" ],
   "XN_RQ_CRD_OFLOW"              => [  16,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-XN Request Credit Overflow Error" ],
   "MD_RP_CRD_OFLOW"              => [  17,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-MD Reply Credit Overflow Error" ],
   "MD_RQ_CRD_OFLOW"              => [  18,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PI-to-MD Request Credit Overflow Error" ],
   "GFX_INT_1"                    => [  19,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "PROC1_ADV_INT: Graphics-write Interrupt for Processor 1" ],
   "GFX_INT_0"                    => [  20,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "PROC0_ADV_INT: Graphics-write Interrupt for Processor 0" ],
   "NACK_OFLOW"                   => [  21,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: NACK Overflow Error" ],
   "XN_RP_Q_OFLOW"                => [  22,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: XN-to-PI Reply Queue Overflow Error" ],
   "XN_RQ_Q_OFLOW"                => [  23,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI_HW_INT: XN-to-PI Request Queue Overflow Error" ],
   "MD_RP_Q_OFLOW"                => [  24,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "PI_HW_INT: MD-to-PI Reply Queue Overflow Error" ],
   "MD_RQ_Q_OFLOW"                => [  25,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "PI_HW_INT: MD-to-PI Request Queue Overflow Error" ],
   "MSG_COLOR_ERR"                => [  26,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Message Color Error" ],
   "FSB_SHUB_CE"                  => [  27,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "PI_CE_INT: FSB-to-SHub Correctable Data Error" ],
   "FSB_SHUB_UCE"                 => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "PI_UCE_INT: FSB-to-SHub Uncorrectable Data Error" ],
   "PIO_TO_ERR"                   => [  29,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PIO Time-out Error" ],
   "MEM_TO_ERR"                   => [  30,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Memory Time-out Error" ],
   "PIO_RP_ERR"                   => [  31,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "PI_HW_INT: PIO Reply Error" ],
   "MEM_RP_ERR"                   => [  32,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Memory Reply Error" ],
   "XB_PROTO_ERR"                 => [  33,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "PI_HW_INT: XB-pipe Protocol Error" ],
   "GFX_RP_ERR"                   => [  34,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "PI_HW_INT: Graphic-write Reply Error" ],
   "FSB_PROTO_ERR"                => [  35,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "PI_HW_INT: FSB-pipe Protocol Error" ],
);

%shub_01_00210_def =
( NAME    => "SH_PI_ERROR_SUMMARY_ALIAS",
  ADDRESS => 0x0000000120060688,
  NOTE    => "PI Error Summary Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00210_flds
);


##########################################################################
#                                                                        #
#   SH_PI_EXPRESS_REPLY_STATUS                                           #
#                                                                        #
##########################################################################

%shub_01_00211_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   3,  61, 0xFFFFFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STATE"                        => [   1,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Express Reply State" ],
);

%shub_01_00211_def =
( NAME    => "SH_PI_EXPRESS_REPLY_STATUS",
  ADDRESS => 0x0000000120060700,
  NOTE    => "PI Express Reply Status",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00211_flds
);


##########################################################################
#                                                                        #
#   SH_PI_FIRST_ERROR                                                    #
#                                                                        #
##########################################################################

%shub_01_00212_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MSG_LENGTH"                   => [   1,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Message Length Error" ],
   "FSB_TBL_MISS"                 => [   2,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: FSB Table Miss Error" ],
   "BAD_SNOOP"                    => [   3,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: FSB Snoop Error" ],
   "LIVELOCK"                     => [   4,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: FSB Livelock Error" ],
   "SHUB_FSB_CE"                  => [   5,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "PI_CE_INT: SHub-to-FSB Correctable Data Error" ],
   "SHUB_FSB_UCE"                 => [   6,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "PI_UCE_INT: SHub-to-FSB Uncorrectable Data Error" ],
   "SHUB_FSB_DQE"                 => [   7,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PI-AFI Queue Error" ],
   "ADDR_PARITY"                  => [   8,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Address Parity Error" ],
   "REQ_PARITY"                   => [   9,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Request Parity Error" ],
   "ADDR_ACCESS"                  => [  10,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Address Access Error" ],
   "REQ_FORMAT"                   => [  11,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Request Format Error" ],
   "IOQ_OVERRUN"                  => [  12,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: IOQ Overrun Error" ],
   "RSP_PARITY"                   => [  13,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Response Parity Error" ],
   "HUNG_BUS"                     => [  14,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Hung Bus Error" ],
   "XN_RP_CRD_OFLOW"              => [  15,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PI-to-XN Reply Credit Overflow Error" ],
   "XN_RQ_CRD_OFLOW"              => [  16,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PI-to-XN Request Credit Overflow Error" ],
   "MD_RP_CRD_OFLOW"              => [  17,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PI-to-MD Reply Credit Overflow Error" ],
   "MD_RQ_CRD_OFLOW"              => [  18,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PI-to-MD Request Credit Overflow Error" ],
   "GFX_INT_1"                    => [  19,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "PROC1_ADV_INT: Graphics-write Interrupt for Processor 1" ],
   "GFX_INT_0"                    => [  20,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "PROC0_ADV_INT: Graphics-write Interrupt for Processor 0" ],
   "NACK_OFLOW"                   => [  21,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: NACK Overflow Error" ],
   "XN_RP_Q_OFLOW"                => [  22,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: XN-to-PI Reply Queue Overflow Error" ],
   "XN_RQ_Q_OFLOW"                => [  23,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: XN-to-PI Request Queue Overflow Error" ],
   "MD_RP_Q_OFLOW"                => [  24,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "PI_HW_INT: MD-to-PI Reply Queue Overflow Error" ],
   "MD_RQ_Q_OFLOW"                => [  25,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "PI_HW_INT: MD-to-PI Request Queue Overflow Error" ],
   "MSG_COLOR_ERR"                => [  26,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Message Color Error" ],
   "FSB_SHUB_CE"                  => [  27,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "PI_CE_INT: FSB-to-SHub Correctable Data Error" ],
   "FSB_SHUB_UCE"                 => [  28,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "PI_UCE_INT: FSB-to-SHub Uncorrectable Data Error" ],
   "PIO_TO_ERR"                   => [  29,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PIO Time-out Error" ],
   "MEM_TO_ERR"                   => [  30,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Memory Time-out Error" ],
   "PIO_RP_ERR"                   => [  31,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PIO Reply Error" ],
   "MEM_RP_ERR"                   => [  32,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Memory Reply Error" ],
   "XB_PROTO_ERR"                 => [  33,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "PI_HW_INT: XB-pipe Protocol Error" ],
   "GFX_RP_ERR"                   => [  34,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Graphic-write Reply Error" ],
   "FSB_PROTO_ERR"                => [  35,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "PI_HW_INT: FSB-pipe Protocol Error" ],
);

%shub_01_00212_def =
( NAME    => "SH_PI_FIRST_ERROR",
  ADDRESS => 0x0000000120060780,
  NOTE    => "PI First Error",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00212_flds
);


##########################################################################
#                                                                        #
#   SH_PI_FIRST_ERROR_ALIAS                                              #
#                                                                        #
##########################################################################

%shub_01_00213_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MSG_LENGTH"                   => [   1,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Message Length Error" ],
   "FSB_TBL_MISS"                 => [   2,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: FSB Table Miss Error" ],
   "BAD_SNOOP"                    => [   3,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: FSB Snoop Error" ],
   "LIVELOCK"                     => [   4,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: FSB Livelock Error" ],
   "SHUB_FSB_CE"                  => [   5,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "PI_CE_INT: SHub-to-FSB Correctable Data Error" ],
   "SHUB_FSB_UCE"                 => [   6,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "PI_UCE_INT: SHub-to-FSB Uncorrectable Data Error" ],
   "SHUB_FSB_DQE"                 => [   7,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PI-AFI Queue Error" ],
   "ADDR_PARITY"                  => [   8,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Address Parity Error" ],
   "REQ_PARITY"                   => [   9,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Request Parity Error" ],
   "ADDR_ACCESS"                  => [  10,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Address Access Error" ],
   "REQ_FORMAT"                   => [  11,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Request Format Error" ],
   "IOQ_OVERRUN"                  => [  12,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: IOQ Overrun Error" ],
   "RSP_PARITY"                   => [  13,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Response Parity Error" ],
   "HUNG_BUS"                     => [  14,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Hung Bus Error" ],
   "XN_RP_CRD_OFLOW"              => [  15,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PI-to-XN Reply Credit Overflow Error" ],
   "XN_RQ_CRD_OFLOW"              => [  16,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PI-to-XN Request Credit Overflow Error" ],
   "MD_RP_CRD_OFLOW"              => [  17,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PI-to-MD Reply Credit Overflow Error" ],
   "MD_RQ_CRD_OFLOW"              => [  18,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PI-to-MD Request Credit Overflow Error" ],
   "GFX_INT_1"                    => [  19,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "PROC1_ADV_INT: Graphics-write Interrupt for Processor 1" ],
   "GFX_INT_0"                    => [  20,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "PROC0_ADV_INT: Graphics-write Interrupt for Processor 0" ],
   "NACK_OFLOW"                   => [  21,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: NACK Overflow Error" ],
   "XN_RP_Q_OFLOW"                => [  22,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: XN-to-PI Reply Queue Overflow Error" ],
   "XN_RQ_Q_OFLOW"                => [  23,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "PI_HW_INT: XN-to-PI Request Queue Overflow Error" ],
   "MD_RP_Q_OFLOW"                => [  24,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "PI_HW_INT: MD-to-PI Reply Queue Overflow Error" ],
   "MD_RQ_Q_OFLOW"                => [  25,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "PI_HW_INT: MD-to-PI Request Queue Overflow Error" ],
   "MSG_COLOR_ERR"                => [  26,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Message Color Error" ],
   "FSB_SHUB_CE"                  => [  27,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "PI_CE_INT: FSB-to-SHub Correctable Data Error" ],
   "FSB_SHUB_UCE"                 => [  28,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "PI_UCE_INT: FSB-to-SHub Uncorrectable Data Error" ],
   "PIO_TO_ERR"                   => [  29,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PIO Time-out Error" ],
   "MEM_TO_ERR"                   => [  30,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Memory Time-out Error" ],
   "PIO_RP_ERR"                   => [  31,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "PI_HW_INT: PIO Reply Error" ],
   "MEM_RP_ERR"                   => [  32,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Memory Reply Error" ],
   "XB_PROTO_ERR"                 => [  33,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "PI_HW_INT: XB-pipe Protocol Error" ],
   "GFX_RP_ERR"                   => [  34,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "PI_HW_INT: Graphic-write Reply Error" ],
   "FSB_PROTO_ERR"                => [  35,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "PI_HW_INT: FSB-pipe Protocol Error" ],
);

%shub_01_00213_def =
( NAME    => "SH_PI_FIRST_ERROR_ALIAS",
  ADDRESS => 0x0000000120060788,
  NOTE    => "PI First Error Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00213_flds
);


##########################################################################
#                                                                        #
#   SH_PI_PI2MD_REPLY_VC_STATUS                                          #
#                                                                        #
##########################################################################

%shub_01_00214_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   6,  58, 0xFFFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUTPUT_CRD_STAT"              => [   1,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "Status of output credits" ],
);

%shub_01_00214_def =
( NAME    => "SH_PI_PI2MD_REPLY_VC_STATUS",
  ADDRESS => 0x0000000120060900,
  NOTE    => "PI-to-MD Reply Virtual Channel Status",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00214_flds
);


##########################################################################
#                                                                        #
#   SH_PI_PI2MD_REQUEST_VC_STATUS                                        #
#                                                                        #
##########################################################################

%shub_01_00215_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   6,  58, 0xFFFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUTPUT_CRD_STAT"              => [   1,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "Status of output credits" ],
);

%shub_01_00215_def =
( NAME    => "SH_PI_PI2MD_REQUEST_VC_STATUS",
  ADDRESS => 0x0000000120060980,
  NOTE    => "PI-to-MD Request Virtual Channel Status",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00215_flds
);


##########################################################################
#                                                                        #
#   SH_PI_PI2XN_REPLY_VC_STATUS                                          #
#                                                                        #
##########################################################################

%shub_01_00216_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   6,  58, 0xFFFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUTPUT_CRD_STAT"              => [   1,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "Status of output credits" ],
);

%shub_01_00216_def =
( NAME    => "SH_PI_PI2XN_REPLY_VC_STATUS",
  ADDRESS => 0x0000000120060a00,
  NOTE    => "PI-to-XN Reply Virtual Channel Status",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00216_flds
);


##########################################################################
#                                                                        #
#   SH_PI_PI2XN_REQUEST_VC_STATUS                                        #
#                                                                        #
##########################################################################

%shub_01_00217_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   6,  58, 0xFFFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUTPUT_CRD_STAT"              => [   1,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "Status of output credits" ],
);

%shub_01_00217_def =
( NAME    => "SH_PI_PI2XN_REQUEST_VC_STATUS",
  ADDRESS => 0x0000000120060a80,
  NOTE    => "PI-to-XN Request Virtual Channel Status",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00217_flds
);


##########################################################################
#                                                                        #
#   SH_PI_UNCORRECTED_DETAIL_1                                           #
#                                                                        #
##########################################################################

%shub_01_00218_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DEP"                          => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "Data-ECC-Protection Bits of the First Failing Doubleword" ],
   "SYNDROME"                     => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Syndrome of the First Failing Doubleword" ],
   "ADDRESS"                      => [   2,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Physical Address of the First Failing Doubleword" ],
);

%shub_01_00218_def =
( NAME    => "SH_PI_UNCORRECTED_DETAIL_1",
  ADDRESS => 0x0000000120060b00,
  NOTE    => "PI Uncorrected Error Detail 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00218_flds
);


##########################################################################
#                                                                        #
#   SH_PI_UNCORRECTED_DETAIL_2                                           #
#                                                                        #
##########################################################################

%shub_01_00219_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Failing Doubleword Value" ],
);

%shub_01_00219_def =
( NAME    => "SH_PI_UNCORRECTED_DETAIL_2",
  ADDRESS => 0x0000000120060b80,
  NOTE    => "PI Uncorrected Error Detail 2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00219_flds
);


##########################################################################
#                                                                        #
#   SH_PI_UNCORRECTED_DETAIL_3                                           #
#                                                                        #
##########################################################################

%shub_01_00220_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DEP"                          => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "Data-ECC-Proctection Bits of the First Failing Doubleword" ],
   "SYNDROME"                     => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Syndrome of the First Failing Doubleword" ],
   "ADDRESS"                      => [   2,   0,  48, 0x0000FFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Physical Address of the First Failing Doubleword" ],
);

%shub_01_00220_def =
( NAME    => "SH_PI_UNCORRECTED_DETAIL_3",
  ADDRESS => 0x0000000120060c00,
  NOTE    => "PI Uncorrected Error Detail 3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00220_flds
);


##########################################################################
#                                                                        #
#   SH_PI_UNCORRECTED_DETAIL_4                                           #
#                                                                        #
##########################################################################

%shub_01_00221_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Failing Doubleword Value" ],
);

%shub_01_00221_def =
( NAME    => "SH_PI_UNCORRECTED_DETAIL_4",
  ADDRESS => 0x0000000120060c80,
  NOTE    => "PI Uncorrected Error Detail 4",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00221_flds
);


##########################################################################
#                                                                        #
#   SH_PI_MD2PI_REPLY_VC_STATUS                                          #
#                                                                        #
##########################################################################

%shub_01_00222_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  12,  52, 0xFFFFFFFFFFFFF000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INPUT_QUEUE_STAT"             => [   1,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Status of MD Reply Input Queue" ],
   "INPUT_DAT_CRD_STAT"           => [   2,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Status of data credits" ],
   "INPUT_HDR_CRD_STAT"           => [   3,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Status of input header credits" ],
);

%shub_01_00222_def =
( NAME    => "SH_PI_MD2PI_REPLY_VC_STATUS",
  ADDRESS => 0x0000000120060800,
  NOTE    => "MD-to-PI Reply Virtual Channel Status",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00222_flds
);


##########################################################################
#                                                                        #
#   SH_PI_MD2PI_REQUEST_VC_STATUS                                        #
#                                                                        #
##########################################################################

%shub_01_00223_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  12,  52, 0xFFFFFFFFFFFFF000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INPUT_QUEUE_STAT"             => [   1,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Status of MD Request Input Queue" ],
   "INPUT_DAT_CRD_STAT"           => [   2,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Status of input data credits" ],
   "INPUT_HDR_CRD_STAT"           => [   3,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Status of input header credits" ],
);

%shub_01_00223_def =
( NAME    => "SH_PI_MD2PI_REQUEST_VC_STATUS",
  ADDRESS => 0x0000000120060880,
  NOTE    => "MD-to-PI Request Virtual Channel Status",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00223_flds
);


##########################################################################
#                                                                        #
#   SH_PI_XN2PI_REPLY_VC_STATUS                                          #
#                                                                        #
##########################################################################

%shub_01_00224_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  12,  52, 0xFFFFFFFFFFFFF000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INPUT_QUEUE_STAT"             => [   1,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Status of XN Reply Input Queue" ],
   "INPUT_DAT_CRD_STAT"           => [   2,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Status of input data credits" ],
   "INPUT_HDR_CRD_STAT"           => [   3,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Status of input header credits" ],
);

%shub_01_00224_def =
( NAME    => "SH_PI_XN2PI_REPLY_VC_STATUS",
  ADDRESS => 0x0000000120060d00,
  NOTE    => "XN-to-PI Reply Virtual Channel Status",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00224_flds
);


##########################################################################
#                                                                        #
#   SH_PI_XN2PI_REQUEST_VC_STATUS                                        #
#                                                                        #
##########################################################################

%shub_01_00225_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  12,  52, 0xFFFFFFFFFFFFF000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INPUT_QUEUE_STAT"             => [   1,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Status of XN Request Input Queue" ],
   "INPUT_DAT_CRD_STAT"           => [   2,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Status of input data credits" ],
   "INPUT_HDR_CRD_STAT"           => [   3,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Status of input header credits" ],
);

%shub_01_00225_def =
( NAME    => "SH_PI_XN2PI_REQUEST_VC_STATUS",
  ADDRESS => 0x0000000120060d80,
  NOTE    => "XN-to-PI Request Virtual Channel Status",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00225_flds
);


##########################################################################
#                                                                        #
#   SH_XNPI_SIC_FLOW                                                     #
#                                                                        #
##########################################################################

%shub_01_00226_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DISABLE_BYPASS_OUT"           => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "disables bypass path-pipe out logic." ],
   "RSVD0"                        => [   1,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   2,  56,   5, 0x1F00000000000000, 0x00, 0, 0x0000000000000000, "vc2 credit captured value" ],
   "RSVD1"                        => [   3,  53,   3, 0x00E0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   4,  48,   5, 0x001F000000000000, 0x00, 0, 0x0000000000000000, "vc2 credit dynamic value" ],
   "RSVD2"                        => [   5,  45,   3, 0x0000E00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_TEST"              => [   6,  40,   5, 0x00001F0000000000, 0x00, 1, 0x0000000000000000, "vc2 credit_test" ],
   "RSVD3"                        => [   7,  37,   3, 0x000000E000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   8,  32,   5, 0x0000001F00000000, 0x00, 0, 0x0000000000000000, "vc0 credit captured value" ],
   "RSVD4"                        => [   9,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [  10,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "vc0 credit dynamic value" ],
   "RSVD5"                        => [  11,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_TEST"              => [  12,  16,   5, 0x00000000001F0000, 0x00, 1, 0x0000000000000000, "vc0 credit_test" ],
   "DEBIT_VC2_FORCE_CRED"         => [  13,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2 from debit cntr" ],
   "RSVD6"                        => [  14,  13,   2, 0x0000000000006000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [  15,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "vc2 withhold" ],
   "DEBIT_VC0_FORCE_CRED"         => [  16,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0 from debit cntr" ],
   "RSVD7"                        => [  17,   5,   2, 0x0000000000000060, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [  18,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "vc0 withhold" ],
);

%shub_01_00226_def =
( NAME    => "SH_XNPI_SIC_FLOW",
  ADDRESS => 0x0000000150030000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00226_flds
);


##########################################################################
#                                                                        #
#   SH_XNPI_TO_NI0_PORT_FLOW                                             #
#                                                                        #
##########################################################################

%shub_01_00227_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "pipe_out vc2 FIFO entries captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "pipe_out vc2 FIFO entries dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "pipe_out vc0 FIFO entries captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "pipe_out vc0 FIFO entries dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_FORCE_CRED"         => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2 from debit cntr" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "vc2 withhold" ],
   "DEBIT_VC0_FORCE_CRED"         => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0 from debit cntr" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc0 withhold" ],
);

%shub_01_00227_def =
( NAME    => "SH_XNPI_TO_NI0_PORT_FLOW",
  ADDRESS => 0x0000000150030010,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00227_flds
);


##########################################################################
#                                                                        #
#   SH_XNPI_TO_NI1_PORT_FLOW                                             #
#                                                                        #
##########################################################################

%shub_01_00228_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "pipe_out vc2 FIFO entries captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "pipe_out vc2 FIFO entries dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "pipe_out vc0 FIFO entries captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "pipe_out vc0 FIFO entries dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_FORCE_CRED"         => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2 from debit cntr" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "vc2 withhold" ],
   "DEBIT_VC0_FORCE_CRED"         => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0 from debit cntr" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc0 withhold" ],
);

%shub_01_00228_def =
( NAME    => "SH_XNPI_TO_NI1_PORT_FLOW",
  ADDRESS => 0x0000000150030020,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00228_flds
);


##########################################################################
#                                                                        #
#   SH_XNPI_TO_IILB_PORT_FLOW                                            #
#                                                                        #
##########################################################################

%shub_01_00229_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "pipe_out vc2 FIFO entries captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "pipe_out vc2 FIFO entries dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "pipe_out vc0 FIFO entries captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "pipe_out vc0 FIFO entries dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_FORCE_CRED"         => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2 from debit cntr" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "vc2 withhold" ],
   "DEBIT_VC0_FORCE_CRED"         => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0 from debit cntr" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc0 withhold" ],
);

%shub_01_00229_def =
( NAME    => "SH_XNPI_TO_IILB_PORT_FLOW",
  ADDRESS => 0x0000000150030030,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00229_flds
);


##########################################################################
#                                                                        #
#   SH_XNPI_FR_NI0_PORT_FLOW_FIFO                                        #
#                                                                        #
##########################################################################

%shub_01_00230_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  45,  19, 0xFFFFE00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENTRY_VC2_TEST"               => [   1,  40,   5, 0x00001F0000000000, 0x00, 1, 0x0000000000000000, "vc2 test credits limit" ],
   "RSVD1"                        => [   2,  37,   3, 0x000000E000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENTRY_VC0_TEST"               => [   3,  32,   5, 0x0000001F00000000, 0x00, 1, 0x0000000000000000, "vc0 test credits limit" ],
   "RSVD2"                        => [   4,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENTRY_VC2_CAP"                => [   5,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "vc2 fifo entry captured value" ],
   "RSVD3"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENTRY_VC2_DYN"                => [   7,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "vc2 fifo entry dynamic value" ],
   "RSVD4"                        => [   8,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENTRY_VC0_CAP"                => [   9,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "vc0 fifo entry captured value" ],
   "RSVD5"                        => [  10,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENTRY_VC0_DYN"                => [  11,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "vc0 fifo entry dynamic value" ],
);

%shub_01_00230_def =
( NAME    => "SH_XNPI_FR_NI0_PORT_FLOW_FIFO",
  ADDRESS => 0x0000000150030040,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00230_flds
);


##########################################################################
#                                                                        #
#   SH_XNPI_FR_NI1_PORT_FLOW_FIFO                                        #
#                                                                        #
##########################################################################

%shub_01_00231_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  45,  19, 0xFFFFE00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENTRY_VC2_TEST"               => [   1,  40,   5, 0x00001F0000000000, 0x00, 1, 0x0000000000000000, "vc2 test credits limit" ],
   "RSVD1"                        => [   2,  37,   3, 0x000000E000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENTRY_VC0_TEST"               => [   3,  32,   5, 0x0000001F00000000, 0x00, 1, 0x0000000000000000, "vc0 test credits limit" ],
   "RSVD2"                        => [   4,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENTRY_VC2_CAP"                => [   5,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "vc2 fifo entry captured value" ],
   "RSVD3"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENTRY_VC2_DYN"                => [   7,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "vc2 fifo entry dynamic value" ],
   "RSVD4"                        => [   8,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENTRY_VC0_CAP"                => [   9,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "vc0 fifo entry captured value" ],
   "RSVD5"                        => [  10,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENTRY_VC0_DYN"                => [  11,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "vc0 fifo entry dynamic value" ],
);

%shub_01_00231_def =
( NAME    => "SH_XNPI_FR_NI1_PORT_FLOW_FIFO",
  ADDRESS => 0x0000000150030050,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00231_flds
);


##########################################################################
#                                                                        #
#   SH_XNPI_FR_IILB_PORT_FLOW_FIFO                                       #
#                                                                        #
##########################################################################

%shub_01_00232_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  45,  19, 0xFFFFE00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENTRY_VC2_TEST"               => [   1,  40,   5, 0x00001F0000000000, 0x00, 1, 0x0000000000000000, "vc2 test credits limit" ],
   "RSVD1"                        => [   2,  37,   3, 0x000000E000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENTRY_VC0_TEST"               => [   3,  32,   5, 0x0000001F00000000, 0x00, 1, 0x0000000000000000, "vc0 test credits limit" ],
   "RSVD2"                        => [   4,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENTRY_VC2_CAP"                => [   5,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "vc2 fifo entry captured value" ],
   "RSVD3"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENTRY_VC2_DYN"                => [   7,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "vc2 fifo entry dynamic value" ],
   "RSVD4"                        => [   8,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENTRY_VC0_CAP"                => [   9,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "vc0 fifo entry captured value" ],
   "RSVD5"                        => [  10,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENTRY_VC0_DYN"                => [  11,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "vc0 fifo entry dynamic value" ],
);

%shub_01_00232_def =
( NAME    => "SH_XNPI_FR_IILB_PORT_FLOW_FIFO",
  ADDRESS => 0x0000000150030060,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00232_flds
);


##########################################################################
#                                                                        #
#   SH_XNMD_SIC_FLOW                                                     #
#                                                                        #
##########################################################################

%shub_01_00233_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DISABLE_BYPASS_OUT"           => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "disables bypass path-pipe out logic." ],
   "RSVD0"                        => [   1,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   2,  56,   5, 0x1F00000000000000, 0x00, 0, 0x0000000000000000, "vc2 credit captured value" ],
   "RSVD1"                        => [   3,  53,   3, 0x00E0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   4,  48,   5, 0x001F000000000000, 0x00, 0, 0x0000000000000000, "vc2 credit dynamic value" ],
   "RSVD2"                        => [   5,  45,   3, 0x0000E00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_TEST"              => [   6,  40,   5, 0x00001F0000000000, 0x00, 1, 0x0000000000000000, "vc2 credit_test" ],
   "RSVD3"                        => [   7,  37,   3, 0x000000E000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   8,  32,   5, 0x0000001F00000000, 0x00, 0, 0x0000000000000000, "vc0 credit captured value" ],
   "RSVD4"                        => [   9,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [  10,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "vc0 credit dynamic value" ],
   "RSVD5"                        => [  11,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_TEST"              => [  12,  16,   5, 0x00000000001F0000, 0x00, 1, 0x0000000000000000, "vc0 credit_test" ],
   "DEBIT_VC2_FORCE_CRED"         => [  13,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2 from debit cntr" ],
   "RSVD6"                        => [  14,  13,   2, 0x0000000000006000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [  15,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "vc2 withhold" ],
   "DEBIT_VC0_FORCE_CRED"         => [  16,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0 from debit cntr" ],
   "RSVD7"                        => [  17,   5,   2, 0x0000000000000060, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [  18,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "vc0 withhold" ],
);

%shub_01_00233_def =
( NAME    => "SH_XNMD_SIC_FLOW",
  ADDRESS => 0x0000000150030100,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00233_flds
);


##########################################################################
#                                                                        #
#   SH_XNMD_TO_NI0_PORT_FLOW                                             #
#                                                                        #
##########################################################################

%shub_01_00234_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "pipe_out vc2 FIFO entries captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "pipe_out vc2 FIFO entries dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "pipe_out vc0 FIFO entries captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "pipe_out vc0 FIFO entries dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_FORCE_CRED"         => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2 from debit cntr" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "vc2 withhold" ],
   "DEBIT_VC0_FORCE_CRED"         => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0 from debit cntr" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc0 withhold" ],
);

%shub_01_00234_def =
( NAME    => "SH_XNMD_TO_NI0_PORT_FLOW",
  ADDRESS => 0x0000000150030110,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00234_flds
);


##########################################################################
#                                                                        #
#   SH_XNMD_TO_NI1_PORT_FLOW                                             #
#                                                                        #
##########################################################################

%shub_01_00235_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "pipe_out vc2 FIFO entries captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "pipe_out vc2 FIFO entries dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "pipe_out vc0 FIFO entries captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "pipe_out vc0 FIFO entries dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_FORCE_CRED"         => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2 from debit cntr" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "vc2 withhold" ],
   "DEBIT_VC0_FORCE_CRED"         => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0 from debit cntr" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc0 withhold" ],
);

%shub_01_00235_def =
( NAME    => "SH_XNMD_TO_NI1_PORT_FLOW",
  ADDRESS => 0x0000000150030120,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00235_flds
);


##########################################################################
#                                                                        #
#   SH_XNMD_TO_IILB_PORT_FLOW                                            #
#                                                                        #
##########################################################################

%shub_01_00236_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "pipe_out vc2 FIFO entries captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "pipe_out vc2 FIFO entries dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "pipe_out vc0 FIFO entries captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "pipe_out vc0 FIFO entries dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_FORCE_CRED"         => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2 from debit cntr" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "vc2 withhold" ],
   "DEBIT_VC0_FORCE_CRED"         => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0 from debit cntr" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc0 withhold" ],
);

%shub_01_00236_def =
( NAME    => "SH_XNMD_TO_IILB_PORT_FLOW",
  ADDRESS => 0x0000000150030130,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00236_flds
);


##########################################################################
#                                                                        #
#   SH_XNMD_FR_NI0_PORT_FLOW_FIFO                                        #
#                                                                        #
##########################################################################

%shub_01_00237_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  45,  19, 0xFFFFE00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENTRY_VC2_TEST"               => [   1,  40,   5, 0x00001F0000000000, 0x00, 1, 0x0000000000000000, "vc2 test credits limit" ],
   "RSVD1"                        => [   2,  37,   3, 0x000000E000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENTRY_VC0_TEST"               => [   3,  32,   5, 0x0000001F00000000, 0x00, 1, 0x0000000000000000, "vc0 test credits limit" ],
   "RSVD2"                        => [   4,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENTRY_VC2_CAP"                => [   5,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "vc2 fifo entry captured value" ],
   "RSVD3"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENTRY_VC2_DYN"                => [   7,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "vc2 fifo entry dynamic value" ],
   "RSVD4"                        => [   8,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENTRY_VC0_CAP"                => [   9,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "vc0 fifo entry captured value" ],
   "RSVD5"                        => [  10,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENTRY_VC0_DYN"                => [  11,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "vc0 fifo entry dynamic value" ],
);

%shub_01_00237_def =
( NAME    => "SH_XNMD_FR_NI0_PORT_FLOW_FIFO",
  ADDRESS => 0x0000000150030140,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00237_flds
);


##########################################################################
#                                                                        #
#   SH_XNMD_FR_NI1_PORT_FLOW_FIFO                                        #
#                                                                        #
##########################################################################

%shub_01_00238_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  45,  19, 0xFFFFE00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENTRY_VC2_TEST"               => [   1,  40,   5, 0x00001F0000000000, 0x00, 1, 0x0000000000000000, "vc2 test credits limit" ],
   "RSVD1"                        => [   2,  37,   3, 0x000000E000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENTRY_VC0_TEST"               => [   3,  32,   5, 0x0000001F00000000, 0x00, 1, 0x0000000000000000, "vc0 test credits limit" ],
   "RSVD2"                        => [   4,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENTRY_VC2_CAP"                => [   5,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "vc2 fifo entry captured value" ],
   "RSVD3"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENTRY_VC2_DYN"                => [   7,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "vc2 fifo entry dynamic value" ],
   "RSVD4"                        => [   8,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENTRY_VC0_CAP"                => [   9,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "vc0 fifo entry captured value" ],
   "RSVD5"                        => [  10,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENTRY_VC0_DYN"                => [  11,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "vc0 fifo entry dynamic value" ],
);

%shub_01_00238_def =
( NAME    => "SH_XNMD_FR_NI1_PORT_FLOW_FIFO",
  ADDRESS => 0x0000000150030150,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00238_flds
);


##########################################################################
#                                                                        #
#   SH_XNMD_FR_IILB_PORT_FLOW_FIFO                                       #
#                                                                        #
##########################################################################

%shub_01_00239_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  45,  19, 0xFFFFE00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENTRY_VC2_TEST"               => [   1,  40,   5, 0x00001F0000000000, 0x00, 1, 0x0000000000000000, "vc2 test credits limit" ],
   "RSVD1"                        => [   2,  37,   3, 0x000000E000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENTRY_VC0_TEST"               => [   3,  32,   5, 0x0000001F00000000, 0x00, 1, 0x0000000000000000, "vc0 test credits limit" ],
   "RSVD2"                        => [   4,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENTRY_VC2_CAP"                => [   5,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "vc2 fifo entry captured value" ],
   "RSVD3"                        => [   6,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENTRY_VC2_DYN"                => [   7,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "vc2 fifo entry dynamic value" ],
   "RSVD4"                        => [   8,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENTRY_VC0_CAP"                => [   9,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "vc0 fifo entry captured value" ],
   "RSVD5"                        => [  10,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENTRY_VC0_DYN"                => [  11,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "vc0 fifo entry dynamic value" ],
);

%shub_01_00239_def =
( NAME    => "SH_XNMD_FR_IILB_PORT_FLOW_FIFO",
  ADDRESS => 0x0000000150030160,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00239_flds
);


##########################################################################
#                                                                        #
#   SH_XNII_INTRA_FLOW                                                   #
#                                                                        #
##########################################################################

%shub_01_00240_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "vc2 credit captured value" ],
   "RSVD1"                        => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  48,   7, 0x007F000000000000, 0x00, 0, 0x0000000000000000, "vc2 credit dynamic value" ],
   "RSVD2"                        => [   4,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_TEST"              => [   5,  40,   7, 0x00007F0000000000, 0x00, 1, 0x0000000000000000, "vc2 credit_test" ],
   "RSVD3"                        => [   6,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   7,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "vc0 credit captured value" ],
   "RSVD4"                        => [   8,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   9,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "vc0 credit dynamic value" ],
   "RSVD5"                        => [  10,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_TEST"              => [  11,  16,   7, 0x00000000007F0000, 0x00, 1, 0x0000000000000000, "vc0 credit_test" ],
   "DEBIT_VC2_FORCE_CRED"         => [  12,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2 from debit cntr" ],
   "RSVD6"                        => [  13,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [  14,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "vc2 withhold" ],
   "DEBIT_VC0_FORCE_CRED"         => [  15,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0 from debit cntr" ],
   "RSVD7"                        => [  16,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [  17,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc0 withhold" ],
);

%shub_01_00240_def =
( NAME    => "SH_XNII_INTRA_FLOW",
  ADDRESS => 0x0000000150030200,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00240_flds
);


##########################################################################
#                                                                        #
#   SH_XNLB_INTRA_FLOW                                                   #
#                                                                        #
##########################################################################

%shub_01_00241_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DISABLE_BYPASS_IN"            => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "" ],
   "CREDIT_VC2_CAP"               => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "vc2 credit captured value" ],
   "RSVD0"                        => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  48,   7, 0x007F000000000000, 0x00, 0, 0x0000000000000000, "vc2 credit dynamic value" ],
   "RSVD1"                        => [   4,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_TEST"              => [   5,  40,   7, 0x00007F0000000000, 0x00, 1, 0x0000000000000000, "vc2 credit_test" ],
   "RSVD2"                        => [   6,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   7,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "vc0 credit captured value" ],
   "RSVD3"                        => [   8,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   9,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "vc0 credit dynamic value" ],
   "RSVD4"                        => [  10,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_TEST"              => [  11,  16,   7, 0x00000000007F0000, 0x00, 1, 0x0000000000000000, "vc0 credit_test" ],
   "DEBIT_VC2_FORCE_CRED"         => [  12,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2 from debit cntr" ],
   "RSVD5"                        => [  13,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [  14,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "vc2 withhold" ],
   "DEBIT_VC0_FORCE_CRED"         => [  15,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0 from debit cntr" ],
   "RSVD6"                        => [  16,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [  17,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc0 withhold" ],
);

%shub_01_00241_def =
( NAME    => "SH_XNLB_INTRA_FLOW",
  ADDRESS => 0x0000000150030210,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00241_flds
);


##########################################################################
#                                                                        #
#   SH_XNIILB_TO_NI0_INTRA_FLOW_DEBIT                                     #
#                                                                        #
##########################################################################

%shub_01_00242_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "vc2 debit captured value" ],
   "RSVD1"                        => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  48,   7, 0x007F000000000000, 0x00, 0, 0x0000000000000000, "vc2 debit dynamic value" ],
   "RSVD2"                        => [   4,  39,   9, 0x0000FF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   5,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "vc0 debit captured value" ],
   "RSVD3"                        => [   6,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   7,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "vc0 debit dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_FORCE_CRED"               => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2 from debit cntr" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_WITHHOLD"                 => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "vc2 withhold" ],
   "VC0_FORCE_CRED"               => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0 from debit cntr" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_WITHHOLD"                 => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc0 withhold" ],
);

%shub_01_00242_def =
( NAME    => "SH_XNIILB_TO_NI0_INTRA_FLOW_DEBIT",
  ADDRESS => 0x0000000150030220,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00242_flds
);


##########################################################################
#                                                                        #
#   SH_XNIILB_TO_NI1_INTRA_FLOW_DEBIT                                     #
#                                                                        #
##########################################################################

%shub_01_00243_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "vc2 debit captured value" ],
   "RSVD1"                        => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  48,   7, 0x007F000000000000, 0x00, 0, 0x0000000000000000, "vc2 debit dynamic value" ],
   "RSVD2"                        => [   4,  39,   9, 0x0000FF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   5,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "vc0 debit captured value" ],
   "RSVD3"                        => [   6,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   7,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "vc0 debit dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_FORCE_CRED"               => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2 from debit cntr" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_WITHHOLD"                 => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "vc2 withhold" ],
   "VC0_FORCE_CRED"               => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0 from debit cntr" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_WITHHOLD"                 => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc0 withhold" ],
);

%shub_01_00243_def =
( NAME    => "SH_XNIILB_TO_NI1_INTRA_FLOW_DEBIT",
  ADDRESS => 0x0000000150030230,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00243_flds
);


##########################################################################
#                                                                        #
#   SH_XNIILB_TO_MD_INTRA_FLOW_DEBIT                                     #
#                                                                        #
##########################################################################

%shub_01_00244_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "vc2 debit captured value" ],
   "RSVD1"                        => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  48,   7, 0x007F000000000000, 0x00, 0, 0x0000000000000000, "vc2 debit dynamic value" ],
   "RSVD2"                        => [   4,  39,   9, 0x0000FF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   5,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "vc0 debit captured value" ],
   "RSVD3"                        => [   6,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   7,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "vc0 debit dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_FORCE_CRED"               => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2 from debit cntr" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_WITHHOLD"                 => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "vc2 withhold" ],
   "VC0_FORCE_CRED"               => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0 from debit cntr" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_WITHHOLD"                 => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc0 withhold" ],
);

%shub_01_00244_def =
( NAME    => "SH_XNIILB_TO_MD_INTRA_FLOW_DEBIT",
  ADDRESS => 0x0000000150030240,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00244_flds
);


##########################################################################
#                                                                        #
#   SH_XNIILB_TO_IILB_INTRA_FLOW_DEBIT                                     #
#                                                                        #
##########################################################################

%shub_01_00245_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "vc2 debit captured value" ],
   "RSVD1"                        => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  48,   7, 0x007F000000000000, 0x00, 0, 0x0000000000000000, "vc2 debit dynamic value" ],
   "RSVD2"                        => [   4,  39,   9, 0x0000FF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   5,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "vc0 debit captured value" ],
   "RSVD3"                        => [   6,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   7,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "vc0 debit dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_FORCE_CRED"               => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2 from debit cntr" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_WITHHOLD"                 => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "vc2 withhold" ],
   "VC0_FORCE_CRED"               => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0 from debit cntr" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_WITHHOLD"                 => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc0 withhold" ],
);

%shub_01_00245_def =
( NAME    => "SH_XNIILB_TO_IILB_INTRA_FLOW_DEBIT",
  ADDRESS => 0x0000000150030250,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00245_flds
);


##########################################################################
#                                                                        #
#   SH_XNIILB_TO_PI_INTRA_FLOW_DEBIT                                     #
#                                                                        #
##########################################################################

%shub_01_00246_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "vc2 debit captured value" ],
   "RSVD1"                        => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  48,   7, 0x007F000000000000, 0x00, 0, 0x0000000000000000, "vc2 debit dynamic value" ],
   "RSVD2"                        => [   4,  39,   9, 0x0000FF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   5,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "vc0 debit captured value" ],
   "RSVD3"                        => [   6,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   7,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "vc0 debit dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_FORCE_CRED"               => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2 from debit cntr" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_WITHHOLD"                 => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "vc2 withhold" ],
   "VC0_FORCE_CRED"               => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0 from debit cntr" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_WITHHOLD"                 => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc0 withhold" ],
);

%shub_01_00246_def =
( NAME    => "SH_XNIILB_TO_PI_INTRA_FLOW_DEBIT",
  ADDRESS => 0x0000000150030260,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00246_flds
);


##########################################################################
#                                                                        #
#   SH_XNIILB_FR_NI0_INTRA_FLOW_CREDIT                                     #
#                                                                        #
##########################################################################

%shub_01_00247_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "vc2 credit captured value" ],
   "RSVD1"                        => [   2,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "vc2 credit dynamic value" ],
   "RSVD2"                        => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_TEST"                     => [   5,  24,   7, 0x000000007F000000, 0x00, 1, 0x0000000000000000, "vc2 credit_test" ],
   "RSVD3"                        => [   6,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   7,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "vc0 credit captured value" ],
   "RSVD4"                        => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   9,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "vc0 credit dynamic value" ],
   "RSVD5"                        => [  10,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_TEST"                     => [  11,   0,   7, 0x000000000000007F, 0x00, 1, 0x0000000000000000, "vc0 credit_test" ],
);

%shub_01_00247_def =
( NAME    => "SH_XNIILB_FR_NI0_INTRA_FLOW_CREDIT",
  ADDRESS => 0x0000000150030270,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00247_flds
);


##########################################################################
#                                                                        #
#   SH_XNIILB_FR_NI1_INTRA_FLOW_CREDIT                                     #
#                                                                        #
##########################################################################

%shub_01_00248_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "vc2 credit captured value" ],
   "RSVD1"                        => [   2,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "vc2 credit dynamic value" ],
   "RSVD2"                        => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_TEST"                     => [   5,  24,   7, 0x000000007F000000, 0x00, 1, 0x0000000000000000, "vc2 credit_test" ],
   "RSVD3"                        => [   6,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   7,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "vc0 credit captured value" ],
   "RSVD4"                        => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   9,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "vc0 credit dynamic value" ],
   "RSVD5"                        => [  10,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_TEST"                     => [  11,   0,   7, 0x000000000000007F, 0x00, 1, 0x0000000000000000, "vc0 credit_test" ],
);

%shub_01_00248_def =
( NAME    => "SH_XNIILB_FR_NI1_INTRA_FLOW_CREDIT",
  ADDRESS => 0x0000000150030280,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00248_flds
);


##########################################################################
#                                                                        #
#   SH_XNIILB_FR_MD_INTRA_FLOW_CREDIT                                     #
#                                                                        #
##########################################################################

%shub_01_00249_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "vc2 credit captured value" ],
   "RSVD1"                        => [   2,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "vc2 credit dynamic value" ],
   "RSVD2"                        => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_TEST"                     => [   5,  24,   7, 0x000000007F000000, 0x00, 1, 0x0000000000000000, "vc2 credit_test" ],
   "RSVD3"                        => [   6,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   7,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "vc0 credit captured value" ],
   "RSVD4"                        => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   9,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "vc0 credit dynamic value" ],
   "RSVD5"                        => [  10,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_TEST"                     => [  11,   0,   7, 0x000000000000007F, 0x00, 1, 0x0000000000000000, "vc0 credit_test" ],
);

%shub_01_00249_def =
( NAME    => "SH_XNIILB_FR_MD_INTRA_FLOW_CREDIT",
  ADDRESS => 0x0000000150030290,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00249_flds
);


##########################################################################
#                                                                        #
#   SH_XNIILB_FR_IILB_INTRA_FLOW_CREDIT                                     #
#                                                                        #
##########################################################################

%shub_01_00250_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "vc2 credit captured value" ],
   "RSVD1"                        => [   2,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "vc2 credit dynamic value" ],
   "RSVD2"                        => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_TEST"                     => [   5,  24,   7, 0x000000007F000000, 0x00, 1, 0x0000000000000000, "vc2 credit_test" ],
   "RSVD3"                        => [   6,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   7,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "vc0 credit captured value" ],
   "RSVD4"                        => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   9,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "vc0 credit dynamic value" ],
   "RSVD5"                        => [  10,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_TEST"                     => [  11,   0,   7, 0x000000000000007F, 0x00, 1, 0x0000000000000000, "vc0 credit_test" ],
);

%shub_01_00250_def =
( NAME    => "SH_XNIILB_FR_IILB_INTRA_FLOW_CREDIT",
  ADDRESS => 0x00000001500302a0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00250_flds
);


##########################################################################
#                                                                        #
#   SH_XNIILB_FR_PI_INTRA_FLOW_CREDIT                                     #
#                                                                        #
##########################################################################

%shub_01_00251_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "vc2 credit captured value" ],
   "RSVD1"                        => [   2,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "vc2 credit dynamic value" ],
   "RSVD2"                        => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_TEST"                     => [   5,  24,   7, 0x000000007F000000, 0x00, 1, 0x0000000000000000, "vc2 credit_test" ],
   "RSVD3"                        => [   6,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   7,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "vc0 credit captured value" ],
   "RSVD4"                        => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   9,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "vc0 credit dynamic value" ],
   "RSVD5"                        => [  10,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_TEST"                     => [  11,   0,   7, 0x000000000000007F, 0x00, 1, 0x0000000000000000, "vc0 credit_test" ],
);

%shub_01_00251_def =
( NAME    => "SH_XNIILB_FR_PI_INTRA_FLOW_CREDIT",
  ADDRESS => 0x00000001500302b0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00251_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI0_TO_PI_INTRA_FLOW_DEBIT                                      #
#                                                                        #
##########################################################################

%shub_01_00252_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "vc2 debit captured value" ],
   "RSVD1"                        => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  48,   7, 0x007F000000000000, 0x00, 0, 0x0000000000000000, "vc2 debit dynamic value" ],
   "RSVD2"                        => [   4,  39,   9, 0x0000FF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   5,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "vc0 debit captured value" ],
   "RSVD3"                        => [   6,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   7,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "vc0 debit dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_FORCE_CRED"               => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2 from debit cntr" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_WITHHOLD"                 => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "vc2 withhold" ],
   "VC0_FORCE_CRED"               => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0 from debit cntr" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_WITHHOLD"                 => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc0 withhold" ],
);

%shub_01_00252_def =
( NAME    => "SH_XNNI0_TO_PI_INTRA_FLOW_DEBIT",
  ADDRESS => 0x0000000150030300,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00252_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI0_TO_MD_INTRA_FLOW_DEBIT                                      #
#                                                                        #
##########################################################################

%shub_01_00253_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "vc2 debit captured value" ],
   "RSVD1"                        => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  48,   7, 0x007F000000000000, 0x00, 0, 0x0000000000000000, "vc2 debit dynamic value" ],
   "RSVD2"                        => [   4,  39,   9, 0x0000FF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   5,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "vc0 debit captured value" ],
   "RSVD3"                        => [   6,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   7,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "vc0 debit dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_FORCE_CRED"               => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2 from debit cntr" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_WITHHOLD"                 => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "vc2 withhold" ],
   "VC0_FORCE_CRED"               => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0 from debit cntr" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_WITHHOLD"                 => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc0 withhold" ],
);

%shub_01_00253_def =
( NAME    => "SH_XNNI0_TO_MD_INTRA_FLOW_DEBIT",
  ADDRESS => 0x0000000150030310,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00253_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI0_TO_IILB_INTRA_FLOW_DEBIT                                     #
#                                                                        #
##########################################################################

%shub_01_00254_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "vc2 debit captured value" ],
   "RSVD1"                        => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  48,   7, 0x007F000000000000, 0x00, 0, 0x0000000000000000, "vc2 debit dynamic value" ],
   "RSVD2"                        => [   4,  39,   9, 0x0000FF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   5,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "vc0 debit captured value" ],
   "RSVD3"                        => [   6,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   7,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "vc0 debit dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_FORCE_CRED"               => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2 from debit cntr" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_WITHHOLD"                 => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "vc2 withhold" ],
   "VC0_FORCE_CRED"               => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0 from debit cntr" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_WITHHOLD"                 => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc0 withhold" ],
);

%shub_01_00254_def =
( NAME    => "SH_XNNI0_TO_IILB_INTRA_FLOW_DEBIT",
  ADDRESS => 0x0000000150030320,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00254_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI0_FR_PI_INTRA_FLOW_CREDIT                                     #
#                                                                        #
##########################################################################

%shub_01_00255_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "vc2 credit captured value" ],
   "RSVD1"                        => [   2,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "vc2 credit dynamic value" ],
   "RSVD2"                        => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_TEST"                     => [   5,  24,   7, 0x000000007F000000, 0x00, 1, 0x0000000000000000, "vc2 credit_test" ],
   "RSVD3"                        => [   6,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   7,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "vc0 credit captured value" ],
   "RSVD4"                        => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   9,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "vc0 credit dynamic value" ],
   "RSVD5"                        => [  10,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_TEST"                     => [  11,   0,   7, 0x000000000000007F, 0x00, 1, 0x0000000000000000, "vc0 credit_test" ],
);

%shub_01_00255_def =
( NAME    => "SH_XNNI0_FR_PI_INTRA_FLOW_CREDIT",
  ADDRESS => 0x0000000150030330,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00255_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI0_FR_MD_INTRA_FLOW_CREDIT                                     #
#                                                                        #
##########################################################################

%shub_01_00256_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "vc2 credit captured value" ],
   "RSVD1"                        => [   2,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "vc2 credit dynamic value" ],
   "RSVD2"                        => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_TEST"                     => [   5,  24,   7, 0x000000007F000000, 0x00, 1, 0x0000000000000000, "vc2 credit_test" ],
   "RSVD3"                        => [   6,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   7,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "vc0 credit captured value" ],
   "RSVD4"                        => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   9,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "vc0 credit dynamic value" ],
   "RSVD5"                        => [  10,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_TEST"                     => [  11,   0,   7, 0x000000000000007F, 0x00, 1, 0x0000000000000000, "vc0 credit_test" ],
);

%shub_01_00256_def =
( NAME    => "SH_XNNI0_FR_MD_INTRA_FLOW_CREDIT",
  ADDRESS => 0x0000000150030340,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00256_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI0_FR_IILB_INTRA_FLOW_CREDIT                                     #
#                                                                        #
##########################################################################

%shub_01_00257_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "vc2 credit captured value" ],
   "RSVD1"                        => [   2,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "vc2 credit dynamic value" ],
   "RSVD2"                        => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_TEST"                     => [   5,  24,   7, 0x000000007F000000, 0x00, 1, 0x0000000000000000, "vc2 credit_test" ],
   "RSVD3"                        => [   6,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   7,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "vc0 credit captured value" ],
   "RSVD4"                        => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   9,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "vc0 credit dynamic value" ],
   "RSVD5"                        => [  10,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_TEST"                     => [  11,   0,   7, 0x000000000000007F, 0x00, 1, 0x0000000000000000, "vc0 credit_test" ],
);

%shub_01_00257_def =
( NAME    => "SH_XNNI0_FR_IILB_INTRA_FLOW_CREDIT",
  ADDRESS => 0x0000000150030350,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00257_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI0_0_INTRANI_FLOW                                              #
#                                                                        #
##########################################################################

%shub_01_00258_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_FORCE_CRED"         => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0 from debit cntr" ],
   "RSVD1"                        => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [   3,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc0 withhold" ],
);

%shub_01_00258_def =
( NAME    => "SH_XNNI0_0_INTRANI_FLOW",
  ADDRESS => 0x0000000150030360,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00258_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI0_1_INTRANI_FLOW                                              #
#                                                                        #
##########################################################################

%shub_01_00259_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_FORCE_CRED"         => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC1 from debit cntr" ],
   "RSVD1"                        => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_WITHHOLD"           => [   3,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc1 withhold" ],
);

%shub_01_00259_def =
( NAME    => "SH_XNNI0_1_INTRANI_FLOW",
  ADDRESS => 0x0000000150030370,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00259_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI0_2_INTRANI_FLOW                                              #
#                                                                        #
##########################################################################

%shub_01_00260_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_FORCE_CRED"         => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC2 from debit cntr" ],
   "RSVD1"                        => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [   3,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc2 withhold" ],
);

%shub_01_00260_def =
( NAME    => "SH_XNNI0_2_INTRANI_FLOW",
  ADDRESS => 0x0000000150030380,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00260_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI0_3_INTRANI_FLOW                                              #
#                                                                        #
##########################################################################

%shub_01_00261_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_FORCE_CRED"         => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC3 from debit cntr" ],
   "RSVD1"                        => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_WITHHOLD"           => [   3,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc3 withhold" ],
);

%shub_01_00261_def =
( NAME    => "SH_XNNI0_3_INTRANI_FLOW",
  ADDRESS => 0x0000000150030390,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00261_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI0_VCSWITCH_FLOW                                               #
#                                                                        #
##########################################################################

%shub_01_00262_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ASYNC_FIFOES"                 => [   1,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "" ],
   "DISABLE_SYNC_BYPASS_OUT"      => [   2,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "" ],
   "DISABLE_SYNC_BYPASS_IN"       => [   3,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD1"                        => [   4,  25,   7, 0x00000000FE000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_VCFIFO_SWITCH"           => [   5,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Swap VC0/2 with VC1/3" ],
   "RSVD2"                        => [   6,  17,   7, 0x0000000000FE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MD_VCFIFO_SWITCH"             => [   7,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Swap VC0/2 with VC1/3" ],
   "RSVD3"                        => [   8,   9,   7, 0x000000000000FE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PI_VCFIFO_SWITCH"             => [   9,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Swap VC0/2 with VC1/3" ],
   "RSVD4"                        => [  10,   1,   7, 0x00000000000000FE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_VCFIFO_DATELINE_SWITCH"    => [  11,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Swap VC0/2 with VC1/3" ],
);

%shub_01_00262_def =
( NAME    => "SH_XNNI0_VCSWITCH_FLOW",
  ADDRESS => 0x00000001500303a0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00262_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI0_TIMER_REG                                                   #
#                                                                        #
##########################################################################

%shub_01_00263_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LINKCLEANUP_REG"              => [   1,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "Link Clean Up" ],
   "RSVD1"                        => [   2,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIMEOUT_REG"                  => [   3,   0,  24, 0x0000000000FFFFFF, 0x00, 1, 0x0000000000000000, "Master Timeout Counter" ],
);

%shub_01_00263_def =
( NAME    => "SH_XNNI0_TIMER_REG",
  ADDRESS => 0x00000001500303b0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00263_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI0_FIFO02_FLOW                                                 #
#                                                                        #
##########################################################################

%shub_01_00264_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  44,  20, 0xFFFFF00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT_VC2_CAP"                => [   1,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "captured counter value" ],
   "RSVD1"                        => [   2,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT_VC2_DYN"                => [   3,  32,   4, 0x0000000F00000000, 0x00, 0, 0x0000000000000000, "counter dynamic value" ],
   "RSVD2"                        => [   4,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT_VC2_LIMIT"              => [   5,  24,   4, 0x000000000F000000, 0x00, 1, 0x0000000000000000, "limit reg zero disables functionality" ],
   "RSVD3"                        => [   6,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT_VC0_CAP"                => [   7,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "captured counter value" ],
   "RSVD4"                        => [   8,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT_VC0_DYN"                => [   9,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "dynamic counter value" ],
   "RSVD5"                        => [  10,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT_VC0_LIMIT"              => [  11,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "limit reg zero disables functionality" ],
);

%shub_01_00264_def =
( NAME    => "SH_XNNI0_FIFO02_FLOW",
  ADDRESS => 0x00000001500303c0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00264_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI0_FIFO13_FLOW                                                 #
#                                                                        #
##########################################################################

%shub_01_00265_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  44,  20, 0xFFFFF00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT_VC3_CAP"                => [   1,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "captured counter value" ],
   "RSVD1"                        => [   2,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT_VC3_DYN"                => [   3,  32,   4, 0x0000000F00000000, 0x00, 0, 0x0000000000000000, "counter dynamic value" ],
   "RSVD2"                        => [   4,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT_VC3_LIMIT"              => [   5,  24,   4, 0x000000000F000000, 0x00, 1, 0x0000000000000000, "limit reg zero disables functionality" ],
   "RSVD3"                        => [   6,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT_VC1_CAP"                => [   7,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "captured counter value" ],
   "RSVD4"                        => [   8,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT_VC1_DYN"                => [   9,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "dynamic counter value" ],
   "RSVD5"                        => [  10,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT_VC1_LIMIT"              => [  11,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "limit reg zero disables functionality" ],
);

%shub_01_00265_def =
( NAME    => "SH_XNNI0_FIFO13_FLOW",
  ADDRESS => 0x00000001500303d0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00265_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI0_NI_FLOW                                                     #
#                                                                        #
##########################################################################

%shub_01_00266_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VC3_CAP"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter captured value" ],
   "VC3_DYN"                      => [   1,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter dynamic value" ],
   "RSVD0"                        => [   2,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_LIMIT"                    => [   3,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "vc3 limit reg, zero disables functionality" ],
   "VC2_CAP"                      => [   4,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "vc2 counter captured value" ],
   "VC2_DYN"                      => [   5,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "vc2 counter dynamic value" ],
   "RSVD1"                        => [   6,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_LIMIT"                    => [   7,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "vc2 limit reg, zero disables functionality" ],
   "VC1_CAP"                      => [   8,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "vc1 counter captured value" ],
   "VC1_DYN"                      => [   9,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "vc1 counter dynamic value" ],
   "RSVD2"                        => [  10,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_LIMIT"                    => [  11,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "vc1 limit reg, zero disables functionality" ],
   "VC0_CAP"                      => [  12,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "vc0 counter captured value" ],
   "VC0_DYN"                      => [  13,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "vc0 counter dynamic value" ],
   "RSVD3"                        => [  14,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_LIMIT"                    => [  15,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "vc0 limit reg, zero disables functionality" ],
);

%shub_01_00266_def =
( NAME    => "SH_XNNI0_NI_FLOW",
  ADDRESS => 0x00000001500303e0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00266_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI0_DEAD_FLOW                                                   #
#                                                                        #
##########################################################################

%shub_01_00267_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VC3_CAP"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter captured value" ],
   "VC3_DYN"                      => [   1,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter dynamic value" ],
   "RSVD0"                        => [   2,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_LIMIT"                    => [   3,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "vc3 limit reg, zero disables functionality" ],
   "VC2_CAP"                      => [   4,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "vc2 counter captured value" ],
   "VC2_DYN"                      => [   5,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "vc2 counter dynamic value" ],
   "RSVD1"                        => [   6,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_LIMIT"                    => [   7,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "vc2 limit reg, zero disables functionality" ],
   "VC1_CAP"                      => [   8,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "vc1 counter captured value" ],
   "VC1_DYN"                      => [   9,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "vc1 counter dynamic value" ],
   "RSVD2"                        => [  10,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_LIMIT"                    => [  11,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "vc1 limit reg, zero disables functionality" ],
   "VC0_CAP"                      => [  12,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "vc0 counter captured value" ],
   "VC0_DYN"                      => [  13,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "vc0 counter dynamic value" ],
   "RSVD3"                        => [  14,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_LIMIT"                    => [  15,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "vc0 limit reg, zero disables functionality" ],
);

%shub_01_00267_def =
( NAME    => "SH_XNNI0_DEAD_FLOW",
  ADDRESS => 0x00000001500303f0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00267_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI0_INJECT_AGE                                                  #
#                                                                        #
##########################################################################

%shub_01_00268_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REPLY_INJECT"                 => [   1,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Value of AGE field for outgoing replies" ],
   "REQUEST_INJECT"               => [   2,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Value of AGE field for outgoing requests" ],
);

%shub_01_00268_def =
( NAME    => "SH_XNNI0_INJECT_AGE",
  ADDRESS => 0x0000000150030400,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00268_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI1_TO_PI_INTRA_FLOW_DEBIT                                      #
#                                                                        #
##########################################################################

%shub_01_00269_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "vc2 debit captured value" ],
   "RSVD1"                        => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  48,   7, 0x007F000000000000, 0x00, 0, 0x0000000000000000, "vc2 debit dynamic value" ],
   "RSVD2"                        => [   4,  39,   9, 0x0000FF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   5,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "vc0 debit captured value" ],
   "RSVD3"                        => [   6,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   7,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "vc0 debit dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_FORCE_CRED"               => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2 from debit cntr" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_WITHHOLD"                 => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "vc2 withhold" ],
   "VC0_FORCE_CRED"               => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0 from debit cntr" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_WITHHOLD"                 => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc0 withhold" ],
);

%shub_01_00269_def =
( NAME    => "SH_XNNI1_TO_PI_INTRA_FLOW_DEBIT",
  ADDRESS => 0x0000000150030500,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00269_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI1_TO_MD_INTRA_FLOW_DEBIT                                      #
#                                                                        #
##########################################################################

%shub_01_00270_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "vc2 debit captured value" ],
   "RSVD1"                        => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  48,   7, 0x007F000000000000, 0x00, 0, 0x0000000000000000, "vc2 debit dynamic value" ],
   "RSVD2"                        => [   4,  39,   9, 0x0000FF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   5,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "vc0 debit captured value" ],
   "RSVD3"                        => [   6,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   7,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "vc0 debit dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_FORCE_CRED"               => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2 from debit cntr" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_WITHHOLD"                 => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "vc2 withhold" ],
   "VC0_FORCE_CRED"               => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0 from debit cntr" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_WITHHOLD"                 => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc0 withhold" ],
);

%shub_01_00270_def =
( NAME    => "SH_XNNI1_TO_MD_INTRA_FLOW_DEBIT",
  ADDRESS => 0x0000000150030510,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00270_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI1_TO_IILB_INTRA_FLOW_DEBIT                                     #
#                                                                        #
##########################################################################

%shub_01_00271_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "vc2 debit captured value" ],
   "RSVD1"                        => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  48,   7, 0x007F000000000000, 0x00, 0, 0x0000000000000000, "vc2 debit dynamic value" ],
   "RSVD2"                        => [   4,  39,   9, 0x0000FF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   5,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "vc0 debit captured value" ],
   "RSVD3"                        => [   6,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   7,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "vc0 debit dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_FORCE_CRED"               => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2 from debit cntr" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_WITHHOLD"                 => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "vc2 withhold" ],
   "VC0_FORCE_CRED"               => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0 from debit cntr" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_WITHHOLD"                 => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc0 withhold" ],
);

%shub_01_00271_def =
( NAME    => "SH_XNNI1_TO_IILB_INTRA_FLOW_DEBIT",
  ADDRESS => 0x0000000150030520,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00271_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI1_FR_PI_INTRA_FLOW_CREDIT                                     #
#                                                                        #
##########################################################################

%shub_01_00272_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "vc2 credit captured value" ],
   "RSVD1"                        => [   2,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "vc2 credit dynamic value" ],
   "RSVD2"                        => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_TEST"                     => [   5,  24,   7, 0x000000007F000000, 0x00, 1, 0x0000000000000000, "vc2 credit_test" ],
   "RSVD3"                        => [   6,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   7,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "vc0 credit captured value" ],
   "RSVD4"                        => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   9,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "vc0 credit dynamic value" ],
   "RSVD5"                        => [  10,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_TEST"                     => [  11,   0,   7, 0x000000000000007F, 0x00, 1, 0x0000000000000000, "vc0 credit_test" ],
);

%shub_01_00272_def =
( NAME    => "SH_XNNI1_FR_PI_INTRA_FLOW_CREDIT",
  ADDRESS => 0x0000000150030530,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00272_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI1_FR_MD_INTRA_FLOW_CREDIT                                     #
#                                                                        #
##########################################################################

%shub_01_00273_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "vc2 credit captured value" ],
   "RSVD1"                        => [   2,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "vc2 credit dynamic value" ],
   "RSVD2"                        => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_TEST"                     => [   5,  24,   7, 0x000000007F000000, 0x00, 1, 0x0000000000000000, "vc2 credit_test" ],
   "RSVD3"                        => [   6,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   7,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "vc0 credit captured value" ],
   "RSVD4"                        => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   9,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "vc0 credit dynamic value" ],
   "RSVD5"                        => [  10,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_TEST"                     => [  11,   0,   7, 0x000000000000007F, 0x00, 1, 0x0000000000000000, "vc0 credit_test" ],
);

%shub_01_00273_def =
( NAME    => "SH_XNNI1_FR_MD_INTRA_FLOW_CREDIT",
  ADDRESS => 0x0000000150030540,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00273_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI1_FR_IILB_INTRA_FLOW_CREDIT                                     #
#                                                                        #
##########################################################################

%shub_01_00274_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "vc2 credit captured value" ],
   "RSVD1"                        => [   2,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "vc2 credit dynamic value" ],
   "RSVD2"                        => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_TEST"                     => [   5,  24,   7, 0x000000007F000000, 0x00, 1, 0x0000000000000000, "vc2 credit_test" ],
   "RSVD3"                        => [   6,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   7,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "vc0 credit captured value" ],
   "RSVD4"                        => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   9,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "vc0 credit dynamic value" ],
   "RSVD5"                        => [  10,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_TEST"                     => [  11,   0,   7, 0x000000000000007F, 0x00, 1, 0x0000000000000000, "vc0 credit_test" ],
);

%shub_01_00274_def =
( NAME    => "SH_XNNI1_FR_IILB_INTRA_FLOW_CREDIT",
  ADDRESS => 0x0000000150030550,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00274_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI1_0_INTRANI_FLOW                                              #
#                                                                        #
##########################################################################

%shub_01_00275_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_FORCE_CRED"         => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0 from debit cntr" ],
   "RSVD1"                        => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [   3,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc0 withhold" ],
);

%shub_01_00275_def =
( NAME    => "SH_XNNI1_0_INTRANI_FLOW",
  ADDRESS => 0x0000000150030560,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00275_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI1_1_INTRANI_FLOW                                              #
#                                                                        #
##########################################################################

%shub_01_00276_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_FORCE_CRED"         => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC1 from debit cntr" ],
   "RSVD1"                        => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_WITHHOLD"           => [   3,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc1 withhold" ],
);

%shub_01_00276_def =
( NAME    => "SH_XNNI1_1_INTRANI_FLOW",
  ADDRESS => 0x0000000150030570,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00276_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI1_2_INTRANI_FLOW                                              #
#                                                                        #
##########################################################################

%shub_01_00277_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_FORCE_CRED"         => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC2 from debit cntr" ],
   "RSVD1"                        => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [   3,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc2 withhold" ],
);

%shub_01_00277_def =
( NAME    => "SH_XNNI1_2_INTRANI_FLOW",
  ADDRESS => 0x0000000150030580,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00277_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI1_3_INTRANI_FLOW                                              #
#                                                                        #
##########################################################################

%shub_01_00278_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_FORCE_CRED"         => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC3 from debit cntr" ],
   "RSVD1"                        => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_WITHHOLD"           => [   3,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc3 withhold" ],
);

%shub_01_00278_def =
( NAME    => "SH_XNNI1_3_INTRANI_FLOW",
  ADDRESS => 0x0000000150030590,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00278_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI1_VCSWITCH_FLOW                                               #
#                                                                        #
##########################################################################

%shub_01_00279_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ASYNC_FIFOES"                 => [   1,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "" ],
   "DISABLE_SYNC_BYPASS_OUT"      => [   2,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "" ],
   "DISABLE_SYNC_BYPASS_IN"       => [   3,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD1"                        => [   4,  25,   7, 0x00000000FE000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_VCFIFO_SWITCH"           => [   5,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Swap VC0/2 with VC1/3" ],
   "RSVD2"                        => [   6,  17,   7, 0x0000000000FE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MD_VCFIFO_SWITCH"             => [   7,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Swap VC0/2 with VC1/3" ],
   "RSVD3"                        => [   8,   9,   7, 0x000000000000FE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PI_VCFIFO_SWITCH"             => [   9,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Swap VC0/2 with VC1/3" ],
   "RSVD4"                        => [  10,   1,   7, 0x00000000000000FE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_VCFIFO_DATELINE_SWITCH"    => [  11,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Swap VC0/2 with VC1/3" ],
);

%shub_01_00279_def =
( NAME    => "SH_XNNI1_VCSWITCH_FLOW",
  ADDRESS => 0x00000001500305a0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00279_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI1_TIMER_REG                                                   #
#                                                                        #
##########################################################################

%shub_01_00280_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LINKCLEANUP_REG"              => [   1,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "Link Clean Up" ],
   "RSVD1"                        => [   2,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIMEOUT_REG"                  => [   3,   0,  24, 0x0000000000FFFFFF, 0x00, 1, 0x0000000000000000, "Master Timeout Counter" ],
);

%shub_01_00280_def =
( NAME    => "SH_XNNI1_TIMER_REG",
  ADDRESS => 0x00000001500305b0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00280_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI1_FIFO02_FLOW                                                 #
#                                                                        #
##########################################################################

%shub_01_00281_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  44,  20, 0xFFFFF00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT_VC2_CAP"                => [   1,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "captured counter value" ],
   "RSVD1"                        => [   2,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT_VC2_DYN"                => [   3,  32,   4, 0x0000000F00000000, 0x00, 0, 0x0000000000000000, "counter dynamic value" ],
   "RSVD2"                        => [   4,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT_VC2_LIMIT"              => [   5,  24,   4, 0x000000000F000000, 0x00, 1, 0x0000000000000000, "limit reg zero disables functionality" ],
   "RSVD3"                        => [   6,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT_VC0_CAP"                => [   7,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "captured counter value" ],
   "RSVD4"                        => [   8,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT_VC0_DYN"                => [   9,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "dynamic counter value" ],
   "RSVD5"                        => [  10,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT_VC0_LIMIT"              => [  11,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "limit reg zero disables functionality" ],
);

%shub_01_00281_def =
( NAME    => "SH_XNNI1_FIFO02_FLOW",
  ADDRESS => 0x00000001500305c0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00281_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI1_FIFO13_FLOW                                                 #
#                                                                        #
##########################################################################

%shub_01_00282_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  44,  20, 0xFFFFF00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT_VC3_CAP"                => [   1,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "captured counter value" ],
   "RSVD1"                        => [   2,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT_VC3_DYN"                => [   3,  32,   4, 0x0000000F00000000, 0x00, 0, 0x0000000000000000, "counter dynamic value" ],
   "RSVD2"                        => [   4,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT_VC3_LIMIT"              => [   5,  24,   4, 0x000000000F000000, 0x00, 1, 0x0000000000000000, "limit reg zero disables functionality" ],
   "RSVD3"                        => [   6,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT_VC1_CAP"                => [   7,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "captured counter value" ],
   "RSVD4"                        => [   8,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT_VC1_DYN"                => [   9,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "dynamic counter value" ],
   "RSVD5"                        => [  10,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT_VC1_LIMIT"              => [  11,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "limit reg zero disables functionality" ],
);

%shub_01_00282_def =
( NAME    => "SH_XNNI1_FIFO13_FLOW",
  ADDRESS => 0x00000001500305d0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00282_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI1_NI_FLOW                                                     #
#                                                                        #
##########################################################################

%shub_01_00283_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VC3_CAP"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter captured value" ],
   "VC3_DYN"                      => [   1,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter dynamic value" ],
   "RSVD0"                        => [   2,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_LIMIT"                    => [   3,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "vc3 limit reg, zero disables functionality" ],
   "VC2_CAP"                      => [   4,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "vc2 counter captured value" ],
   "VC2_DYN"                      => [   5,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "vc2 counter dynamic value" ],
   "RSVD1"                        => [   6,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_LIMIT"                    => [   7,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "vc2 limit reg, zero disables functionality" ],
   "VC1_CAP"                      => [   8,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "vc1 counter captured value" ],
   "VC1_DYN"                      => [   9,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "vc1 counter dynamic value" ],
   "RSVD2"                        => [  10,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_LIMIT"                    => [  11,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "vc1 limit reg, zero disables functionality" ],
   "VC0_CAP"                      => [  12,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "vc0 counter captured value" ],
   "VC0_DYN"                      => [  13,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "vc0 counter dynamic value" ],
   "RSVD3"                        => [  14,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_LIMIT"                    => [  15,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "vc0 limit reg, zero disables functionality" ],
);

%shub_01_00283_def =
( NAME    => "SH_XNNI1_NI_FLOW",
  ADDRESS => 0x00000001500305e0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00283_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI1_DEAD_FLOW                                                   #
#                                                                        #
##########################################################################

%shub_01_00284_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VC3_CAP"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter captured value" ],
   "VC3_DYN"                      => [   1,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter dynamic value" ],
   "RSVD0"                        => [   2,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_LIMIT"                    => [   3,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "vc3 limit reg, zero disables functionality" ],
   "VC2_CAP"                      => [   4,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "vc2 counter captured value" ],
   "VC2_DYN"                      => [   5,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "vc2 counter dynamic value" ],
   "RSVD1"                        => [   6,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_LIMIT"                    => [   7,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "vc2 limit reg, zero disables functionality" ],
   "VC1_CAP"                      => [   8,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "vc1 counter captured value" ],
   "VC1_DYN"                      => [   9,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "vc1 counter dynamic value" ],
   "RSVD2"                        => [  10,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_LIMIT"                    => [  11,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "vc1 limit reg, zero disables functionality" ],
   "VC0_CAP"                      => [  12,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "vc0 counter captured value" ],
   "VC0_DYN"                      => [  13,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "vc0 counter dynamic value" ],
   "RSVD3"                        => [  14,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_LIMIT"                    => [  15,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "vc0 limit reg, zero disables functionality" ],
);

%shub_01_00284_def =
( NAME    => "SH_XNNI1_DEAD_FLOW",
  ADDRESS => 0x00000001500305f0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00284_flds
);


##########################################################################
#                                                                        #
#   SH_XNNI1_INJECT_AGE                                                  #
#                                                                        #
##########################################################################

%shub_01_00285_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REPLY_INJECT"                 => [   1,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Value of AGE field for outgoing replies" ],
   "REQUEST_INJECT"               => [   2,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Value of AGE field for outgoing requests" ],
);

%shub_01_00285_def =
( NAME    => "SH_XNNI1_INJECT_AGE",
  ADDRESS => 0x0000000150030600,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00285_flds
);


##########################################################################
#                                                                        #
#   SH_XN_DEBUG_SEL                                                      #
#                                                                        #
##########################################################################

%shub_01_00286_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TRIGGER_ENABLE"               => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Enable trigger on bit 32 of Analyzer data" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD0"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_RLM_SEL"              => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 RLM select" ],
   "RSVD1"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD2"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_RLM_SEL"              => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 RLM select" ],
   "RSVD3"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD4"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_RLM_SEL"              => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 RLM select" ],
   "RSVD5"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD6"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_RLM_SEL"              => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 RLM select" ],
   "RSVD7"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD8"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_RLM_SEL"              => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 RLM select" ],
   "RSVD9"                        => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD10"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_RLM_SEL"              => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 RLM select" ],
   "RSVD11"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD12"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_RLM_SEL"              => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 RLM select" ],
   "RSVD13"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD14"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_RLM_SEL"              => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 RLM select" ],
);

%shub_01_00286_def =
( NAME    => "SH_XN_DEBUG_SEL",
  ADDRESS => 0x0000000150031000,
  NOTE    => "XN Debug Port Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00286_flds
);


##########################################################################
#                                                                        #
#   SH_XN_DEBUG_TRIG_SEL                                                 #
#                                                                        #
##########################################################################

%shub_01_00287_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_NIBBLE_SEL"          => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_RLM_SEL"             => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 RLM select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_NIBBLE_SEL"          => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_RLM_SEL"             => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 RLM select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_NIBBLE_SEL"          => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_RLM_SEL"             => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 RLM select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_NIBBLE_SEL"          => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_RLM_SEL"             => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 RLM select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_NIBBLE_SEL"          => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_RLM_SEL"             => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 RLM select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_NIBBLE_SEL"          => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_RLM_SEL"             => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 RLM select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_NIBBLE_SEL"          => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_RLM_SEL"             => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 RLM select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_NIBBLE_SEL"          => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_RLM_SEL"             => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 RLM select" ],
);

%shub_01_00287_def =
( NAME    => "SH_XN_DEBUG_TRIG_SEL",
  ADDRESS => 0x0000000150031020,
  NOTE    => "XN Debug trigger Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00287_flds
);


##########################################################################
#                                                                        #
#   SH_XN_TRIGGER_COMPARE                                                #
#                                                                        #
##########################################################################

%shub_01_00288_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MASK"                         => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Mask to select Debug bits for trigger generation" ],
);

%shub_01_00288_def =
( NAME    => "SH_XN_TRIGGER_COMPARE",
  ADDRESS => 0x0000000150031040,
  NOTE    => "XN Debug Compare",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00288_flds
);


##########################################################################
#                                                                        #
#   SH_XN_TRIGGER_DATA                                                   #
#                                                                        #
##########################################################################

%shub_01_00289_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COMPARE_PATTERN"              => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "debug bit pattern for trigger generation" ],
);

%shub_01_00289_def =
( NAME    => "SH_XN_TRIGGER_DATA",
  ADDRESS => 0x0000000150031050,
  NOTE    => "XN Debug Compare Data",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00289_flds
);


##########################################################################
#                                                                        #
#   SH_XN_IILB_DEBUG_SEL                                                 #
#                                                                        #
##########################################################################

%shub_01_00290_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_INPUT_SEL"            => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 input select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_INPUT_SEL"            => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 input select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_INPUT_SEL"            => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 input select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_INPUT_SEL"            => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 input select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_INPUT_SEL"            => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 input select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_INPUT_SEL"            => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 input select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_INPUT_SEL"            => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 input select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_INPUT_SEL"            => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 input select" ],
);

%shub_01_00290_def =
( NAME    => "SH_XN_IILB_DEBUG_SEL",
  ADDRESS => 0x0000000150031060,
  NOTE    => "XN IILB Debug Port Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00290_flds
);


##########################################################################
#                                                                        #
#   SH_XN_PI_DEBUG_SEL                                                   #
#                                                                        #
##########################################################################

%shub_01_00291_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_INPUT_SEL"            => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 input select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_INPUT_SEL"            => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 input select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_INPUT_SEL"            => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 input select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_INPUT_SEL"            => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 input select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_INPUT_SEL"            => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 input select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_INPUT_SEL"            => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 input select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_INPUT_SEL"            => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 input select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_INPUT_SEL"            => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 input select" ],
);

%shub_01_00291_def =
( NAME    => "SH_XN_PI_DEBUG_SEL",
  ADDRESS => 0x00000001500310a0,
  NOTE    => "XN PI Debug Port Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00291_flds
);


##########################################################################
#                                                                        #
#   SH_XN_MD_DEBUG_SEL                                                   #
#                                                                        #
##########################################################################

%shub_01_00292_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_INPUT_SEL"            => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 input select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_INPUT_SEL"            => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 input select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_INPUT_SEL"            => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 input select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_INPUT_SEL"            => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 input select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_INPUT_SEL"            => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 input select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_INPUT_SEL"            => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 input select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_INPUT_SEL"            => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 input select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_INPUT_SEL"            => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 input select" ],
);

%shub_01_00292_def =
( NAME    => "SH_XN_MD_DEBUG_SEL",
  ADDRESS => 0x0000000150031080,
  NOTE    => "XN MD Debug Port Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00292_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI0_DEBUG_SEL                                                  #
#                                                                        #
##########################################################################

%shub_01_00293_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_INPUT_SEL"            => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 input select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_INPUT_SEL"            => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 input select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_INPUT_SEL"            => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 input select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_INPUT_SEL"            => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 input select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_INPUT_SEL"            => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 input select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_INPUT_SEL"            => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 input select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_INPUT_SEL"            => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 input select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_INPUT_SEL"            => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 input select" ],
);

%shub_01_00293_def =
( NAME    => "SH_XN_NI0_DEBUG_SEL",
  ADDRESS => 0x00000001500310c0,
  NOTE    => "XN NI0 Debug Port Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00293_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI1_DEBUG_SEL                                                  #
#                                                                        #
##########################################################################

%shub_01_00294_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_INPUT_SEL"            => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 input select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_INPUT_SEL"            => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 input select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_INPUT_SEL"            => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 input select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_INPUT_SEL"            => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 input select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_INPUT_SEL"            => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 input select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_INPUT_SEL"            => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 input select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_INPUT_SEL"            => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 input select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_INPUT_SEL"            => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 input select" ],
);

%shub_01_00294_def =
( NAME    => "SH_XN_NI1_DEBUG_SEL",
  ADDRESS => 0x00000001500310e0,
  NOTE    => "XN NI1 Debug Port Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00294_flds
);


##########################################################################
#                                                                        #
#   SH_XN_IILB_LB_CMP_EXP_DATA0                                          #
#                                                                        #
##########################################################################

%shub_01_00295_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub_01_00295_def =
( NAME    => "SH_XN_IILB_LB_CMP_EXP_DATA0",
  ADDRESS => 0x0000000150031100,
  NOTE    => "IILB compare LB input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00295_flds
);


##########################################################################
#                                                                        #
#   SH_XN_IILB_LB_CMP_EXP_DATA1                                          #
#                                                                        #
##########################################################################

%shub_01_00296_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub_01_00296_def =
( NAME    => "SH_XN_IILB_LB_CMP_EXP_DATA1",
  ADDRESS => 0x0000000150031110,
  NOTE    => "IILB compare LB input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00296_flds
);


##########################################################################
#                                                                        #
#   SH_XN_IILB_LB_CMP_ENABLE0                                            #
#                                                                        #
##########################################################################

%shub_01_00297_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub_01_00297_def =
( NAME    => "SH_XN_IILB_LB_CMP_ENABLE0",
  ADDRESS => 0x0000000150031120,
  NOTE    => "IILB compare LB input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00297_flds
);


##########################################################################
#                                                                        #
#   SH_XN_IILB_LB_CMP_ENABLE1                                            #
#                                                                        #
##########################################################################

%shub_01_00298_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub_01_00298_def =
( NAME    => "SH_XN_IILB_LB_CMP_ENABLE1",
  ADDRESS => 0x0000000150031130,
  NOTE    => "IILB compare LB input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00298_flds
);


##########################################################################
#                                                                        #
#   SH_XN_IILB_II_CMP_EXP_DATA0                                          #
#                                                                        #
##########################################################################

%shub_01_00299_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub_01_00299_def =
( NAME    => "SH_XN_IILB_II_CMP_EXP_DATA0",
  ADDRESS => 0x0000000150031140,
  NOTE    => "IILB compare II input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00299_flds
);


##########################################################################
#                                                                        #
#   SH_XN_IILB_II_CMP_EXP_DATA1                                          #
#                                                                        #
##########################################################################

%shub_01_00300_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub_01_00300_def =
( NAME    => "SH_XN_IILB_II_CMP_EXP_DATA1",
  ADDRESS => 0x0000000150031150,
  NOTE    => "IILB compare II input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00300_flds
);


##########################################################################
#                                                                        #
#   SH_XN_IILB_II_CMP_ENABLE0                                            #
#                                                                        #
##########################################################################

%shub_01_00301_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub_01_00301_def =
( NAME    => "SH_XN_IILB_II_CMP_ENABLE0",
  ADDRESS => 0x0000000150031160,
  NOTE    => "IILB compare II input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00301_flds
);


##########################################################################
#                                                                        #
#   SH_XN_IILB_II_CMP_ENABLE1                                            #
#                                                                        #
##########################################################################

%shub_01_00302_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub_01_00302_def =
( NAME    => "SH_XN_IILB_II_CMP_ENABLE1",
  ADDRESS => 0x0000000150031170,
  NOTE    => "IILB compare II input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00302_flds
);


##########################################################################
#                                                                        #
#   SH_XN_IILB_MD_CMP_EXP_DATA0                                          #
#                                                                        #
##########################################################################

%shub_01_00303_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub_01_00303_def =
( NAME    => "SH_XN_IILB_MD_CMP_EXP_DATA0",
  ADDRESS => 0x0000000150031180,
  NOTE    => "IILB compare MD input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00303_flds
);


##########################################################################
#                                                                        #
#   SH_XN_IILB_MD_CMP_EXP_DATA1                                          #
#                                                                        #
##########################################################################

%shub_01_00304_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub_01_00304_def =
( NAME    => "SH_XN_IILB_MD_CMP_EXP_DATA1",
  ADDRESS => 0x0000000150031190,
  NOTE    => "IILB compare MD input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00304_flds
);


##########################################################################
#                                                                        #
#   SH_XN_IILB_MD_CMP_ENABLE0                                            #
#                                                                        #
##########################################################################

%shub_01_00305_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub_01_00305_def =
( NAME    => "SH_XN_IILB_MD_CMP_ENABLE0",
  ADDRESS => 0x00000001500311a0,
  NOTE    => "IILB compare MD input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00305_flds
);


##########################################################################
#                                                                        #
#   SH_XN_IILB_MD_CMP_ENABLE1                                            #
#                                                                        #
##########################################################################

%shub_01_00306_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub_01_00306_def =
( NAME    => "SH_XN_IILB_MD_CMP_ENABLE1",
  ADDRESS => 0x00000001500311b0,
  NOTE    => "IILB compare MD input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00306_flds
);


##########################################################################
#                                                                        #
#   SH_XN_IILB_PI_CMP_EXP_DATA0                                          #
#                                                                        #
##########################################################################

%shub_01_00307_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub_01_00307_def =
( NAME    => "SH_XN_IILB_PI_CMP_EXP_DATA0",
  ADDRESS => 0x00000001500311c0,
  NOTE    => "IILB compare PI input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00307_flds
);


##########################################################################
#                                                                        #
#   SH_XN_IILB_PI_CMP_EXP_DATA1                                          #
#                                                                        #
##########################################################################

%shub_01_00308_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub_01_00308_def =
( NAME    => "SH_XN_IILB_PI_CMP_EXP_DATA1",
  ADDRESS => 0x00000001500311d0,
  NOTE    => "IILB compare PI input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00308_flds
);


##########################################################################
#                                                                        #
#   SH_XN_IILB_PI_CMP_ENABLE0                                            #
#                                                                        #
##########################################################################

%shub_01_00309_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub_01_00309_def =
( NAME    => "SH_XN_IILB_PI_CMP_ENABLE0",
  ADDRESS => 0x00000001500311e0,
  NOTE    => "IILB compare PI input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00309_flds
);


##########################################################################
#                                                                        #
#   SH_XN_IILB_PI_CMP_ENABLE1                                            #
#                                                                        #
##########################################################################

%shub_01_00310_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub_01_00310_def =
( NAME    => "SH_XN_IILB_PI_CMP_ENABLE1",
  ADDRESS => 0x00000001500311f0,
  NOTE    => "IILB compare PI input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00310_flds
);


##########################################################################
#                                                                        #
#   SH_XN_IILB_NI0_CMP_EXP_DATA0                                         #
#                                                                        #
##########################################################################

%shub_01_00311_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub_01_00311_def =
( NAME    => "SH_XN_IILB_NI0_CMP_EXP_DATA0",
  ADDRESS => 0x0000000150031200,
  NOTE    => "IILB compare NI0 input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00311_flds
);


##########################################################################
#                                                                        #
#   SH_XN_IILB_NI0_CMP_EXP_DATA1                                         #
#                                                                        #
##########################################################################

%shub_01_00312_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub_01_00312_def =
( NAME    => "SH_XN_IILB_NI0_CMP_EXP_DATA1",
  ADDRESS => 0x0000000150031210,
  NOTE    => "IILB compare NI0 input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00312_flds
);


##########################################################################
#                                                                        #
#   SH_XN_IILB_NI0_CMP_ENABLE0                                           #
#                                                                        #
##########################################################################

%shub_01_00313_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub_01_00313_def =
( NAME    => "SH_XN_IILB_NI0_CMP_ENABLE0",
  ADDRESS => 0x0000000150031220,
  NOTE    => "IILB compare NI0 input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00313_flds
);


##########################################################################
#                                                                        #
#   SH_XN_IILB_NI0_CMP_ENABLE1                                           #
#                                                                        #
##########################################################################

%shub_01_00314_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub_01_00314_def =
( NAME    => "SH_XN_IILB_NI0_CMP_ENABLE1",
  ADDRESS => 0x0000000150031230,
  NOTE    => "IILB compare NI0 input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00314_flds
);


##########################################################################
#                                                                        #
#   SH_XN_IILB_NI1_CMP_EXP_DATA0                                         #
#                                                                        #
##########################################################################

%shub_01_00315_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub_01_00315_def =
( NAME    => "SH_XN_IILB_NI1_CMP_EXP_DATA0",
  ADDRESS => 0x0000000150031240,
  NOTE    => "IILB compare NI1 input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00315_flds
);


##########################################################################
#                                                                        #
#   SH_XN_IILB_NI1_CMP_EXP_DATA1                                         #
#                                                                        #
##########################################################################

%shub_01_00316_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub_01_00316_def =
( NAME    => "SH_XN_IILB_NI1_CMP_EXP_DATA1",
  ADDRESS => 0x0000000150031250,
  NOTE    => "IILB compare NI1 input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00316_flds
);


##########################################################################
#                                                                        #
#   SH_XN_IILB_NI1_CMP_ENABLE0                                           #
#                                                                        #
##########################################################################

%shub_01_00317_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub_01_00317_def =
( NAME    => "SH_XN_IILB_NI1_CMP_ENABLE0",
  ADDRESS => 0x0000000150031260,
  NOTE    => "IILB compare NI1 input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00317_flds
);


##########################################################################
#                                                                        #
#   SH_XN_IILB_NI1_CMP_ENABLE1                                           #
#                                                                        #
##########################################################################

%shub_01_00318_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub_01_00318_def =
( NAME    => "SH_XN_IILB_NI1_CMP_ENABLE1",
  ADDRESS => 0x0000000150031270,
  NOTE    => "IILB compare NI1 input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00318_flds
);


##########################################################################
#                                                                        #
#   SH_XN_MD_IILB_CMP_EXP_DATA0                                          #
#                                                                        #
##########################################################################

%shub_01_00319_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub_01_00319_def =
( NAME    => "SH_XN_MD_IILB_CMP_EXP_DATA0",
  ADDRESS => 0x0000000150031500,
  NOTE    => "MD compare IILB input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00319_flds
);


##########################################################################
#                                                                        #
#   SH_XN_MD_IILB_CMP_EXP_DATA1                                          #
#                                                                        #
##########################################################################

%shub_01_00320_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub_01_00320_def =
( NAME    => "SH_XN_MD_IILB_CMP_EXP_DATA1",
  ADDRESS => 0x0000000150031510,
  NOTE    => "MD compare IILB input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00320_flds
);


##########################################################################
#                                                                        #
#   SH_XN_MD_IILB_CMP_ENABLE0                                            #
#                                                                        #
##########################################################################

%shub_01_00321_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub_01_00321_def =
( NAME    => "SH_XN_MD_IILB_CMP_ENABLE0",
  ADDRESS => 0x0000000150031520,
  NOTE    => "MD compare IILB input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00321_flds
);


##########################################################################
#                                                                        #
#   SH_XN_MD_IILB_CMP_ENABLE1                                            #
#                                                                        #
##########################################################################

%shub_01_00322_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub_01_00322_def =
( NAME    => "SH_XN_MD_IILB_CMP_ENABLE1",
  ADDRESS => 0x0000000150031530,
  NOTE    => "MD compare IILB input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00322_flds
);


##########################################################################
#                                                                        #
#   SH_XN_MD_NI0_CMP_EXP_DATA0                                           #
#                                                                        #
##########################################################################

%shub_01_00323_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub_01_00323_def =
( NAME    => "SH_XN_MD_NI0_CMP_EXP_DATA0",
  ADDRESS => 0x0000000150031540,
  NOTE    => "MD compare NI0 input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00323_flds
);


##########################################################################
#                                                                        #
#   SH_XN_MD_NI0_CMP_EXP_DATA1                                           #
#                                                                        #
##########################################################################

%shub_01_00324_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub_01_00324_def =
( NAME    => "SH_XN_MD_NI0_CMP_EXP_DATA1",
  ADDRESS => 0x0000000150031550,
  NOTE    => "MD compare NI0 input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00324_flds
);


##########################################################################
#                                                                        #
#   SH_XN_MD_NI0_CMP_ENABLE0                                             #
#                                                                        #
##########################################################################

%shub_01_00325_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub_01_00325_def =
( NAME    => "SH_XN_MD_NI0_CMP_ENABLE0",
  ADDRESS => 0x0000000150031560,
  NOTE    => "MD compare NI0 input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00325_flds
);


##########################################################################
#                                                                        #
#   SH_XN_MD_NI0_CMP_ENABLE1                                             #
#                                                                        #
##########################################################################

%shub_01_00326_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub_01_00326_def =
( NAME    => "SH_XN_MD_NI0_CMP_ENABLE1",
  ADDRESS => 0x0000000150031570,
  NOTE    => "MD compare NI0 input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00326_flds
);


##########################################################################
#                                                                        #
#   SH_XN_MD_NI1_CMP_EXP_DATA0                                           #
#                                                                        #
##########################################################################

%shub_01_00327_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub_01_00327_def =
( NAME    => "SH_XN_MD_NI1_CMP_EXP_DATA0",
  ADDRESS => 0x0000000150031580,
  NOTE    => "MD compare NI1 input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00327_flds
);


##########################################################################
#                                                                        #
#   SH_XN_MD_NI1_CMP_EXP_DATA1                                           #
#                                                                        #
##########################################################################

%shub_01_00328_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub_01_00328_def =
( NAME    => "SH_XN_MD_NI1_CMP_EXP_DATA1",
  ADDRESS => 0x0000000150031590,
  NOTE    => "MD compare NI1 input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00328_flds
);


##########################################################################
#                                                                        #
#   SH_XN_MD_NI1_CMP_ENABLE0                                             #
#                                                                        #
##########################################################################

%shub_01_00329_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub_01_00329_def =
( NAME    => "SH_XN_MD_NI1_CMP_ENABLE0",
  ADDRESS => 0x00000001500315a0,
  NOTE    => "MD compare NI1 input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00329_flds
);


##########################################################################
#                                                                        #
#   SH_XN_MD_NI1_CMP_ENABLE1                                             #
#                                                                        #
##########################################################################

%shub_01_00330_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub_01_00330_def =
( NAME    => "SH_XN_MD_NI1_CMP_ENABLE1",
  ADDRESS => 0x00000001500315b0,
  NOTE    => "MD compare NI1 input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00330_flds
);


##########################################################################
#                                                                        #
#   SH_XN_MD_SIC_CMP_EXP_HDR0                                            #
#                                                                        #
##########################################################################

%shub_01_00331_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub_01_00331_def =
( NAME    => "SH_XN_MD_SIC_CMP_EXP_HDR0",
  ADDRESS => 0x00000001500315c0,
  NOTE    => "MD compare SIC input expected header0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00331_flds
);


##########################################################################
#                                                                        #
#   SH_XN_MD_SIC_CMP_EXP_HDR1                                            #
#                                                                        #
##########################################################################

%shub_01_00332_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA"                         => [   1,   0,  42, 0x000003FFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub_01_00332_def =
( NAME    => "SH_XN_MD_SIC_CMP_EXP_HDR1",
  ADDRESS => 0x00000001500315d0,
  NOTE    => "MD compare SIC input expected header1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00332_flds
);


##########################################################################
#                                                                        #
#   SH_XN_MD_SIC_CMP_HDR_ENABLE0                                         #
#                                                                        #
##########################################################################

%shub_01_00333_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub_01_00333_def =
( NAME    => "SH_XN_MD_SIC_CMP_HDR_ENABLE0",
  ADDRESS => 0x00000001500315e0,
  NOTE    => "MD compare SIC header enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00333_flds
);


##########################################################################
#                                                                        #
#   SH_XN_MD_SIC_CMP_HDR_ENABLE1                                         #
#                                                                        #
##########################################################################

%shub_01_00334_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE"                       => [   1,   0,  42, 0x000003FFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub_01_00334_def =
( NAME    => "SH_XN_MD_SIC_CMP_HDR_ENABLE1",
  ADDRESS => 0x00000001500315f0,
  NOTE    => "MD compare SIC header enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00334_flds
);


##########################################################################
#                                                                        #
#   SH_XN_MD_SIC_CMP_DATA0                                               #
#                                                                        #
##########################################################################

%shub_01_00335_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA0"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data0" ],
);

%shub_01_00335_def =
( NAME    => "SH_XN_MD_SIC_CMP_DATA0",
  ADDRESS => 0x0000000150031600,
  NOTE    => "MD compare SIC data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00335_flds
);


##########################################################################
#                                                                        #
#   SH_XN_MD_SIC_CMP_DATA1                                               #
#                                                                        #
##########################################################################

%shub_01_00336_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA1"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data1" ],
);

%shub_01_00336_def =
( NAME    => "SH_XN_MD_SIC_CMP_DATA1",
  ADDRESS => 0x0000000150031610,
  NOTE    => "MD compare SIC data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00336_flds
);


##########################################################################
#                                                                        #
#   SH_XN_MD_SIC_CMP_DATA2                                               #
#                                                                        #
##########################################################################

%shub_01_00337_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA2"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data2" ],
);

%shub_01_00337_def =
( NAME    => "SH_XN_MD_SIC_CMP_DATA2",
  ADDRESS => 0x0000000150031620,
  NOTE    => "MD compare SIC data2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00337_flds
);


##########################################################################
#                                                                        #
#   SH_XN_MD_SIC_CMP_DATA3                                               #
#                                                                        #
##########################################################################

%shub_01_00338_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA3"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data3" ],
);

%shub_01_00338_def =
( NAME    => "SH_XN_MD_SIC_CMP_DATA3",
  ADDRESS => 0x0000000150031630,
  NOTE    => "MD compare SIC data3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00338_flds
);


##########################################################################
#                                                                        #
#   SH_XN_MD_SIC_CMP_DATA_ENABLE0                                        #
#                                                                        #
##########################################################################

%shub_01_00339_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_ENABLE0"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data0" ],
);

%shub_01_00339_def =
( NAME    => "SH_XN_MD_SIC_CMP_DATA_ENABLE0",
  ADDRESS => 0x0000000150031640,
  NOTE    => "MD enable compare SIC data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00339_flds
);


##########################################################################
#                                                                        #
#   SH_XN_MD_SIC_CMP_DATA_ENABLE1                                        #
#                                                                        #
##########################################################################

%shub_01_00340_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_ENABLE1"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data1" ],
);

%shub_01_00340_def =
( NAME    => "SH_XN_MD_SIC_CMP_DATA_ENABLE1",
  ADDRESS => 0x0000000150031650,
  NOTE    => "MD enable compare SIC data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00340_flds
);


##########################################################################
#                                                                        #
#   SH_XN_MD_SIC_CMP_DATA_ENABLE2                                        #
#                                                                        #
##########################################################################

%shub_01_00341_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_ENABLE2"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data2" ],
);

%shub_01_00341_def =
( NAME    => "SH_XN_MD_SIC_CMP_DATA_ENABLE2",
  ADDRESS => 0x0000000150031660,
  NOTE    => "MD enable compare SIC data2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00341_flds
);


##########################################################################
#                                                                        #
#   SH_XN_MD_SIC_CMP_DATA_ENABLE3                                        #
#                                                                        #
##########################################################################

%shub_01_00342_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_ENABLE3"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data3" ],
);

%shub_01_00342_def =
( NAME    => "SH_XN_MD_SIC_CMP_DATA_ENABLE3",
  ADDRESS => 0x0000000150031670,
  NOTE    => "MD enable compare SIC data3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00342_flds
);


##########################################################################
#                                                                        #
#   SH_XN_PI_IILB_CMP_EXP_DATA0                                          #
#                                                                        #
##########################################################################

%shub_01_00343_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub_01_00343_def =
( NAME    => "SH_XN_PI_IILB_CMP_EXP_DATA0",
  ADDRESS => 0x0000000150031300,
  NOTE    => "PI compare IILB input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00343_flds
);


##########################################################################
#                                                                        #
#   SH_XN_PI_IILB_CMP_EXP_DATA1                                          #
#                                                                        #
##########################################################################

%shub_01_00344_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub_01_00344_def =
( NAME    => "SH_XN_PI_IILB_CMP_EXP_DATA1",
  ADDRESS => 0x0000000150031310,
  NOTE    => "PI compare IILB input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00344_flds
);


##########################################################################
#                                                                        #
#   SH_XN_PI_IILB_CMP_ENABLE0                                            #
#                                                                        #
##########################################################################

%shub_01_00345_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub_01_00345_def =
( NAME    => "SH_XN_PI_IILB_CMP_ENABLE0",
  ADDRESS => 0x0000000150031320,
  NOTE    => "PI compare IILB input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00345_flds
);


##########################################################################
#                                                                        #
#   SH_XN_PI_IILB_CMP_ENABLE1                                            #
#                                                                        #
##########################################################################

%shub_01_00346_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub_01_00346_def =
( NAME    => "SH_XN_PI_IILB_CMP_ENABLE1",
  ADDRESS => 0x0000000150031330,
  NOTE    => "PI compare IILB input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00346_flds
);


##########################################################################
#                                                                        #
#   SH_XN_PI_NI0_CMP_EXP_DATA0                                           #
#                                                                        #
##########################################################################

%shub_01_00347_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub_01_00347_def =
( NAME    => "SH_XN_PI_NI0_CMP_EXP_DATA0",
  ADDRESS => 0x0000000150031340,
  NOTE    => "PI compare NI0 input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00347_flds
);


##########################################################################
#                                                                        #
#   SH_XN_PI_NI0_CMP_EXP_DATA1                                           #
#                                                                        #
##########################################################################

%shub_01_00348_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub_01_00348_def =
( NAME    => "SH_XN_PI_NI0_CMP_EXP_DATA1",
  ADDRESS => 0x0000000150031350,
  NOTE    => "PI compare NI0 input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00348_flds
);


##########################################################################
#                                                                        #
#   SH_XN_PI_NI0_CMP_ENABLE0                                             #
#                                                                        #
##########################################################################

%shub_01_00349_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub_01_00349_def =
( NAME    => "SH_XN_PI_NI0_CMP_ENABLE0",
  ADDRESS => 0x0000000150031360,
  NOTE    => "PI compare NI0 input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00349_flds
);


##########################################################################
#                                                                        #
#   SH_XN_PI_NI0_CMP_ENABLE1                                             #
#                                                                        #
##########################################################################

%shub_01_00350_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub_01_00350_def =
( NAME    => "SH_XN_PI_NI0_CMP_ENABLE1",
  ADDRESS => 0x0000000150031370,
  NOTE    => "PI compare NI0 input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00350_flds
);


##########################################################################
#                                                                        #
#   SH_XN_PI_NI1_CMP_EXP_DATA0                                           #
#                                                                        #
##########################################################################

%shub_01_00351_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub_01_00351_def =
( NAME    => "SH_XN_PI_NI1_CMP_EXP_DATA0",
  ADDRESS => 0x0000000150031380,
  NOTE    => "PI compare NI1 input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00351_flds
);


##########################################################################
#                                                                        #
#   SH_XN_PI_NI1_CMP_EXP_DATA1                                           #
#                                                                        #
##########################################################################

%shub_01_00352_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub_01_00352_def =
( NAME    => "SH_XN_PI_NI1_CMP_EXP_DATA1",
  ADDRESS => 0x0000000150031390,
  NOTE    => "PI compare NI1 input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00352_flds
);


##########################################################################
#                                                                        #
#   SH_XN_PI_NI1_CMP_ENABLE0                                             #
#                                                                        #
##########################################################################

%shub_01_00353_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub_01_00353_def =
( NAME    => "SH_XN_PI_NI1_CMP_ENABLE0",
  ADDRESS => 0x00000001500313a0,
  NOTE    => "PI compare NI1 input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00353_flds
);


##########################################################################
#                                                                        #
#   SH_XN_PI_NI1_CMP_ENABLE1                                             #
#                                                                        #
##########################################################################

%shub_01_00354_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub_01_00354_def =
( NAME    => "SH_XN_PI_NI1_CMP_ENABLE1",
  ADDRESS => 0x00000001500313b0,
  NOTE    => "PI compare NI1 input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00354_flds
);


##########################################################################
#                                                                        #
#   SH_XN_PI_SIC_CMP_EXP_HDR0                                            #
#                                                                        #
##########################################################################

%shub_01_00355_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub_01_00355_def =
( NAME    => "SH_XN_PI_SIC_CMP_EXP_HDR0",
  ADDRESS => 0x00000001500313c0,
  NOTE    => "PI compare SIC input expected header0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00355_flds
);


##########################################################################
#                                                                        #
#   SH_XN_PI_SIC_CMP_EXP_HDR1                                            #
#                                                                        #
##########################################################################

%shub_01_00356_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA"                         => [   1,   0,  42, 0x000003FFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub_01_00356_def =
( NAME    => "SH_XN_PI_SIC_CMP_EXP_HDR1",
  ADDRESS => 0x00000001500313d0,
  NOTE    => "PI compare SIC input expected header1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00356_flds
);


##########################################################################
#                                                                        #
#   SH_XN_PI_SIC_CMP_HDR_ENABLE0                                         #
#                                                                        #
##########################################################################

%shub_01_00357_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub_01_00357_def =
( NAME    => "SH_XN_PI_SIC_CMP_HDR_ENABLE0",
  ADDRESS => 0x00000001500313e0,
  NOTE    => "PI compare SIC header enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00357_flds
);


##########################################################################
#                                                                        #
#   SH_XN_PI_SIC_CMP_HDR_ENABLE1                                         #
#                                                                        #
##########################################################################

%shub_01_00358_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE"                       => [   1,   0,  42, 0x000003FFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub_01_00358_def =
( NAME    => "SH_XN_PI_SIC_CMP_HDR_ENABLE1",
  ADDRESS => 0x00000001500313f0,
  NOTE    => "PI compare SIC header enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00358_flds
);


##########################################################################
#                                                                        #
#   SH_XN_PI_SIC_CMP_DATA0                                               #
#                                                                        #
##########################################################################

%shub_01_00359_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA0"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data0" ],
);

%shub_01_00359_def =
( NAME    => "SH_XN_PI_SIC_CMP_DATA0",
  ADDRESS => 0x0000000150031400,
  NOTE    => "PI compare SIC data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00359_flds
);


##########################################################################
#                                                                        #
#   SH_XN_PI_SIC_CMP_DATA1                                               #
#                                                                        #
##########################################################################

%shub_01_00360_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA1"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data1" ],
);

%shub_01_00360_def =
( NAME    => "SH_XN_PI_SIC_CMP_DATA1",
  ADDRESS => 0x0000000150031410,
  NOTE    => "PI compare SIC data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00360_flds
);


##########################################################################
#                                                                        #
#   SH_XN_PI_SIC_CMP_DATA2                                               #
#                                                                        #
##########################################################################

%shub_01_00361_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA2"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data2" ],
);

%shub_01_00361_def =
( NAME    => "SH_XN_PI_SIC_CMP_DATA2",
  ADDRESS => 0x0000000150031420,
  NOTE    => "PI compare SIC data2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00361_flds
);


##########################################################################
#                                                                        #
#   SH_XN_PI_SIC_CMP_DATA3                                               #
#                                                                        #
##########################################################################

%shub_01_00362_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA3"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data3" ],
);

%shub_01_00362_def =
( NAME    => "SH_XN_PI_SIC_CMP_DATA3",
  ADDRESS => 0x0000000150031430,
  NOTE    => "PI compare SIC data3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00362_flds
);


##########################################################################
#                                                                        #
#   SH_XN_PI_SIC_CMP_DATA_ENABLE0                                        #
#                                                                        #
##########################################################################

%shub_01_00363_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_ENABLE0"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data0" ],
);

%shub_01_00363_def =
( NAME    => "SH_XN_PI_SIC_CMP_DATA_ENABLE0",
  ADDRESS => 0x0000000150031440,
  NOTE    => "PI enable compare SIC data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00363_flds
);


##########################################################################
#                                                                        #
#   SH_XN_PI_SIC_CMP_DATA_ENABLE1                                        #
#                                                                        #
##########################################################################

%shub_01_00364_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_ENABLE1"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data1" ],
);

%shub_01_00364_def =
( NAME    => "SH_XN_PI_SIC_CMP_DATA_ENABLE1",
  ADDRESS => 0x0000000150031450,
  NOTE    => "PI enable compare SIC data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00364_flds
);


##########################################################################
#                                                                        #
#   SH_XN_PI_SIC_CMP_DATA_ENABLE2                                        #
#                                                                        #
##########################################################################

%shub_01_00365_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_ENABLE2"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data2" ],
);

%shub_01_00365_def =
( NAME    => "SH_XN_PI_SIC_CMP_DATA_ENABLE2",
  ADDRESS => 0x0000000150031460,
  NOTE    => "PI enable compare SIC data2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00365_flds
);


##########################################################################
#                                                                        #
#   SH_XN_PI_SIC_CMP_DATA_ENABLE3                                        #
#                                                                        #
##########################################################################

%shub_01_00366_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_ENABLE3"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data3" ],
);

%shub_01_00366_def =
( NAME    => "SH_XN_PI_SIC_CMP_DATA_ENABLE3",
  ADDRESS => 0x0000000150031470,
  NOTE    => "PI enable compare SIC data3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00366_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI0_IILB_CMP_EXP_DATA0                                         #
#                                                                        #
##########################################################################

%shub_01_00367_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub_01_00367_def =
( NAME    => "SH_XN_NI0_IILB_CMP_EXP_DATA0",
  ADDRESS => 0x0000000150031700,
  NOTE    => "NI0 compare IILB input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00367_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI0_IILB_CMP_EXP_DATA1                                         #
#                                                                        #
##########################################################################

%shub_01_00368_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub_01_00368_def =
( NAME    => "SH_XN_NI0_IILB_CMP_EXP_DATA1",
  ADDRESS => 0x0000000150031710,
  NOTE    => "NI0 compare IILB input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00368_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI0_IILB_CMP_ENABLE0                                           #
#                                                                        #
##########################################################################

%shub_01_00369_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub_01_00369_def =
( NAME    => "SH_XN_NI0_IILB_CMP_ENABLE0",
  ADDRESS => 0x0000000150031720,
  NOTE    => "NI0 compare IILB input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00369_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI0_IILB_CMP_ENABLE1                                           #
#                                                                        #
##########################################################################

%shub_01_00370_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub_01_00370_def =
( NAME    => "SH_XN_NI0_IILB_CMP_ENABLE1",
  ADDRESS => 0x0000000150031730,
  NOTE    => "NI0 compare IILB input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00370_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI0_PI_CMP_EXP_DATA0                                           #
#                                                                        #
##########################################################################

%shub_01_00371_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub_01_00371_def =
( NAME    => "SH_XN_NI0_PI_CMP_EXP_DATA0",
  ADDRESS => 0x0000000150031740,
  NOTE    => "NI0 compare PI input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00371_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI0_PI_CMP_EXP_DATA1                                           #
#                                                                        #
##########################################################################

%shub_01_00372_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub_01_00372_def =
( NAME    => "SH_XN_NI0_PI_CMP_EXP_DATA1",
  ADDRESS => 0x0000000150031750,
  NOTE    => "NI0 compare PI input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00372_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI0_PI_CMP_ENABLE0                                             #
#                                                                        #
##########################################################################

%shub_01_00373_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub_01_00373_def =
( NAME    => "SH_XN_NI0_PI_CMP_ENABLE0",
  ADDRESS => 0x0000000150031760,
  NOTE    => "NI0 compare PI input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00373_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI0_PI_CMP_ENABLE1                                             #
#                                                                        #
##########################################################################

%shub_01_00374_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub_01_00374_def =
( NAME    => "SH_XN_NI0_PI_CMP_ENABLE1",
  ADDRESS => 0x0000000150031770,
  NOTE    => "NI0 compare PI input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00374_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI0_MD_CMP_EXP_DATA0                                           #
#                                                                        #
##########################################################################

%shub_01_00375_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub_01_00375_def =
( NAME    => "SH_XN_NI0_MD_CMP_EXP_DATA0",
  ADDRESS => 0x0000000150031780,
  NOTE    => "NI0 compare MD input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00375_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI0_MD_CMP_EXP_DATA1                                           #
#                                                                        #
##########################################################################

%shub_01_00376_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub_01_00376_def =
( NAME    => "SH_XN_NI0_MD_CMP_EXP_DATA1",
  ADDRESS => 0x0000000150031790,
  NOTE    => "NI0 compare MD input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00376_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI0_MD_CMP_ENABLE0                                             #
#                                                                        #
##########################################################################

%shub_01_00377_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub_01_00377_def =
( NAME    => "SH_XN_NI0_MD_CMP_ENABLE0",
  ADDRESS => 0x00000001500317a0,
  NOTE    => "NI0 compare MD input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00377_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI0_MD_CMP_ENABLE1                                             #
#                                                                        #
##########################################################################

%shub_01_00378_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub_01_00378_def =
( NAME    => "SH_XN_NI0_MD_CMP_ENABLE1",
  ADDRESS => 0x00000001500317b0,
  NOTE    => "NI0 compare MD input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00378_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI0_NI_CMP_EXP_DATA0                                           #
#                                                                        #
##########################################################################

%shub_01_00379_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub_01_00379_def =
( NAME    => "SH_XN_NI0_NI_CMP_EXP_DATA0",
  ADDRESS => 0x00000001500317c0,
  NOTE    => "NI0 compare NI input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00379_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI0_NI_CMP_EXP_DATA1                                           #
#                                                                        #
##########################################################################

%shub_01_00380_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub_01_00380_def =
( NAME    => "SH_XN_NI0_NI_CMP_EXP_DATA1",
  ADDRESS => 0x00000001500317d0,
  NOTE    => "NI0 compare NI input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00380_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI0_NI_CMP_ENABLE0                                             #
#                                                                        #
##########################################################################

%shub_01_00381_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub_01_00381_def =
( NAME    => "SH_XN_NI0_NI_CMP_ENABLE0",
  ADDRESS => 0x00000001500317e0,
  NOTE    => "NI0 compare NI input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00381_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI0_NI_CMP_ENABLE1                                             #
#                                                                        #
##########################################################################

%shub_01_00382_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub_01_00382_def =
( NAME    => "SH_XN_NI0_NI_CMP_ENABLE1",
  ADDRESS => 0x00000001500317f0,
  NOTE    => "NI0 compare NI input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00382_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI0_LLP_CMP_EXP_DATA0                                          #
#                                                                        #
##########################################################################

%shub_01_00383_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub_01_00383_def =
( NAME    => "SH_XN_NI0_LLP_CMP_EXP_DATA0",
  ADDRESS => 0x0000000150031800,
  NOTE    => "NI0 compare LLP input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00383_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI0_LLP_CMP_EXP_DATA1                                          #
#                                                                        #
##########################################################################

%shub_01_00384_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub_01_00384_def =
( NAME    => "SH_XN_NI0_LLP_CMP_EXP_DATA1",
  ADDRESS => 0x0000000150031810,
  NOTE    => "NI0 compare LLP input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00384_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI0_LLP_CMP_ENABLE0                                            #
#                                                                        #
##########################################################################

%shub_01_00385_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub_01_00385_def =
( NAME    => "SH_XN_NI0_LLP_CMP_ENABLE0",
  ADDRESS => 0x0000000150031820,
  NOTE    => "NI0 compare LLP input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00385_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI0_LLP_CMP_ENABLE1                                            #
#                                                                        #
##########################################################################

%shub_01_00386_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub_01_00386_def =
( NAME    => "SH_XN_NI0_LLP_CMP_ENABLE1",
  ADDRESS => 0x0000000150031830,
  NOTE    => "NI0 compare LLP input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00386_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI1_IILB_CMP_EXP_DATA0                                         #
#                                                                        #
##########################################################################

%shub_01_00387_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub_01_00387_def =
( NAME    => "SH_XN_NI1_IILB_CMP_EXP_DATA0",
  ADDRESS => 0x0000000150031900,
  NOTE    => "NI1 compare IILB input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00387_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI1_IILB_CMP_EXP_DATA1                                         #
#                                                                        #
##########################################################################

%shub_01_00388_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub_01_00388_def =
( NAME    => "SH_XN_NI1_IILB_CMP_EXP_DATA1",
  ADDRESS => 0x0000000150031910,
  NOTE    => "NI1 compare IILB input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00388_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI1_IILB_CMP_ENABLE0                                           #
#                                                                        #
##########################################################################

%shub_01_00389_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub_01_00389_def =
( NAME    => "SH_XN_NI1_IILB_CMP_ENABLE0",
  ADDRESS => 0x0000000150031920,
  NOTE    => "NI1 compare IILB input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00389_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI1_IILB_CMP_ENABLE1                                           #
#                                                                        #
##########################################################################

%shub_01_00390_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub_01_00390_def =
( NAME    => "SH_XN_NI1_IILB_CMP_ENABLE1",
  ADDRESS => 0x0000000150031930,
  NOTE    => "NI1 compare IILB input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00390_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI1_PI_CMP_EXP_DATA0                                           #
#                                                                        #
##########################################################################

%shub_01_00391_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub_01_00391_def =
( NAME    => "SH_XN_NI1_PI_CMP_EXP_DATA0",
  ADDRESS => 0x0000000150031940,
  NOTE    => "NI1 compare PI input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00391_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI1_PI_CMP_EXP_DATA1                                           #
#                                                                        #
##########################################################################

%shub_01_00392_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub_01_00392_def =
( NAME    => "SH_XN_NI1_PI_CMP_EXP_DATA1",
  ADDRESS => 0x0000000150031950,
  NOTE    => "NI1 compare PI input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00392_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI1_PI_CMP_ENABLE0                                             #
#                                                                        #
##########################################################################

%shub_01_00393_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub_01_00393_def =
( NAME    => "SH_XN_NI1_PI_CMP_ENABLE0",
  ADDRESS => 0x0000000150031960,
  NOTE    => "NI1 compare PI input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00393_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI1_PI_CMP_ENABLE1                                             #
#                                                                        #
##########################################################################

%shub_01_00394_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub_01_00394_def =
( NAME    => "SH_XN_NI1_PI_CMP_ENABLE1",
  ADDRESS => 0x0000000150031970,
  NOTE    => "NI1 compare PI input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00394_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI1_MD_CMP_EXP_DATA0                                           #
#                                                                        #
##########################################################################

%shub_01_00395_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub_01_00395_def =
( NAME    => "SH_XN_NI1_MD_CMP_EXP_DATA0",
  ADDRESS => 0x0000000150031980,
  NOTE    => "NI1 compare MD input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00395_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI1_MD_CMP_EXP_DATA1                                           #
#                                                                        #
##########################################################################

%shub_01_00396_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub_01_00396_def =
( NAME    => "SH_XN_NI1_MD_CMP_EXP_DATA1",
  ADDRESS => 0x0000000150031990,
  NOTE    => "NI1 compare MD input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00396_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI1_MD_CMP_ENABLE0                                             #
#                                                                        #
##########################################################################

%shub_01_00397_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub_01_00397_def =
( NAME    => "SH_XN_NI1_MD_CMP_ENABLE0",
  ADDRESS => 0x00000001500319a0,
  NOTE    => "NI1 compare MD input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00397_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI1_MD_CMP_ENABLE1                                             #
#                                                                        #
##########################################################################

%shub_01_00398_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub_01_00398_def =
( NAME    => "SH_XN_NI1_MD_CMP_ENABLE1",
  ADDRESS => 0x00000001500319b0,
  NOTE    => "NI1 compare MD input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00398_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI1_NI_CMP_EXP_DATA0                                           #
#                                                                        #
##########################################################################

%shub_01_00399_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub_01_00399_def =
( NAME    => "SH_XN_NI1_NI_CMP_EXP_DATA0",
  ADDRESS => 0x00000001500319c0,
  NOTE    => "NI1 compare NI input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00399_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI1_NI_CMP_EXP_DATA1                                           #
#                                                                        #
##########################################################################

%shub_01_00400_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub_01_00400_def =
( NAME    => "SH_XN_NI1_NI_CMP_EXP_DATA1",
  ADDRESS => 0x00000001500319d0,
  NOTE    => "NI1 compare NI input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00400_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI1_NI_CMP_ENABLE0                                             #
#                                                                        #
##########################################################################

%shub_01_00401_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub_01_00401_def =
( NAME    => "SH_XN_NI1_NI_CMP_ENABLE0",
  ADDRESS => 0x00000001500319e0,
  NOTE    => "NI1 compare NI input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00401_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI1_NI_CMP_ENABLE1                                             #
#                                                                        #
##########################################################################

%shub_01_00402_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub_01_00402_def =
( NAME    => "SH_XN_NI1_NI_CMP_ENABLE1",
  ADDRESS => 0x00000001500319f0,
  NOTE    => "NI1 compare NI input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00402_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI1_LLP_CMP_EXP_DATA0                                          #
#                                                                        #
##########################################################################

%shub_01_00403_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%shub_01_00403_def =
( NAME    => "SH_XN_NI1_LLP_CMP_EXP_DATA0",
  ADDRESS => 0x0000000150031a00,
  NOTE    => "NI1 compare LLP input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00403_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI1_LLP_CMP_EXP_DATA1                                          #
#                                                                        #
##########################################################################

%shub_01_00404_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%shub_01_00404_def =
( NAME    => "SH_XN_NI1_LLP_CMP_EXP_DATA1",
  ADDRESS => 0x0000000150031a10,
  NOTE    => "NI1 compare LLP input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00404_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI1_LLP_CMP_ENABLE0                                            #
#                                                                        #
##########################################################################

%shub_01_00405_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%shub_01_00405_def =
( NAME    => "SH_XN_NI1_LLP_CMP_ENABLE0",
  ADDRESS => 0x0000000150031a20,
  NOTE    => "NI1 compare LLP input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00405_flds
);


##########################################################################
#                                                                        #
#   SH_XN_NI1_LLP_CMP_ENABLE1                                            #
#                                                                        #
##########################################################################

%shub_01_00406_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%shub_01_00406_def =
( NAME    => "SH_XN_NI1_LLP_CMP_ENABLE1",
  ADDRESS => 0x0000000150031a30,
  NOTE    => "NI1 compare LLP input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00406_flds
);


##########################################################################
#                                                                        #
#   SH_XNPI_ECC_INJ_REG                                                  #
#                                                                        #
##########################################################################

%shub_01_00407_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_CB_CONT3"                => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Replace Syndrome Continous" ],
   "DATA_CB_1SHOT3"               => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Replace Syndrome One-Shot" ],
   "DATA_CONT3"                   => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "toggle mask data" ],
   "DATA_1SHOT3"                  => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "1 shot mask data" ],
   "RSVD0"                        => [   4,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BYTE3"                        => [   5,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Replacement Syndrome" ],
   "DATA_CB_CONT2"                => [   6,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "Replace Syndrome Continous" ],
   "DATA_CB_1SHOT2"               => [   7,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "Replace Syndrome OneShot" ],
   "DATA_CONT2"                   => [   8,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "toggle mask data" ],
   "DATA_1SHOT2"                  => [   9,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "1 shot mask data" ],
   "RSVD1"                        => [  10,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BYTE2"                        => [  11,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Replacement Syndrome" ],
   "DATA_CB_CONT1"                => [  12,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "Replace Syndrome Continous" ],
   "DATA_CB_1SHOT1"               => [  13,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "Replace Syndrome One Shot" ],
   "DATA_CONT1"                   => [  14,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "toggle mask data" ],
   "DATA_1SHOT1"                  => [  15,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "1 shot mask data" ],
   "RSVD2"                        => [  16,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BYTE1"                        => [  17,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Replacement Syndrome" ],
   "DATA_CB_CONT0"                => [  18,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Replace Syndrome Continuous" ],
   "DATA_CB_1SHOT0"               => [  19,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Replace Syndrome One Shot" ],
   "DATA_CONT0"                   => [  20,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "toggle mask data" ],
   "DATA_1SHOT0"                  => [  21,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "1 shot mask data" ],
   "RSVD3"                        => [  22,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BYTE0"                        => [  23,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Replacement Syndrome" ],
);

%shub_01_00407_def =
( NAME    => "SH_XNPI_ECC_INJ_REG",
  ADDRESS => 0x0000000150032000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00407_flds
);


##########################################################################
#                                                                        #
#   SH_XNPI_ECC0_INJ_MASK_REG                                            #
#                                                                        #
##########################################################################

%shub_01_00408_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK_ECC0"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Replacement Data" ],
);

%shub_01_00408_def =
( NAME    => "SH_XNPI_ECC0_INJ_MASK_REG",
  ADDRESS => 0x0000000150032008,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00408_flds
);


##########################################################################
#                                                                        #
#   SH_XNPI_ECC1_INJ_MASK_REG                                            #
#                                                                        #
##########################################################################

%shub_01_00409_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK_ECC1"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Replacement Data" ],
);

%shub_01_00409_def =
( NAME    => "SH_XNPI_ECC1_INJ_MASK_REG",
  ADDRESS => 0x0000000150032010,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00409_flds
);


##########################################################################
#                                                                        #
#   SH_XNPI_ECC2_INJ_MASK_REG                                            #
#                                                                        #
##########################################################################

%shub_01_00410_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK_ECC2"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Replacement Data" ],
);

%shub_01_00410_def =
( NAME    => "SH_XNPI_ECC2_INJ_MASK_REG",
  ADDRESS => 0x0000000150032018,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00410_flds
);


##########################################################################
#                                                                        #
#   SH_XNPI_ECC3_INJ_MASK_REG                                            #
#                                                                        #
##########################################################################

%shub_01_00411_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK_ECC3"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Replacement Data" ],
);

%shub_01_00411_def =
( NAME    => "SH_XNPI_ECC3_INJ_MASK_REG",
  ADDRESS => 0x0000000150032020,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00411_flds
);


##########################################################################
#                                                                        #
#   SH_XNMD_ECC_INJ_REG                                                  #
#                                                                        #
##########################################################################

%shub_01_00412_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_CB_CONT3"                => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Replace Syndrome Continous" ],
   "DATA_CB_1SHOT3"               => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Replace Syndrome One-Shot" ],
   "DATA_CONT3"                   => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "toggle mask data" ],
   "DATA_1SHOT3"                  => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "1 shot mask data" ],
   "RSVD0"                        => [   4,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BYTE3"                        => [   5,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Replacement Syndrome" ],
   "DATA_CB_CONT2"                => [   6,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "Replace Syndrome Continous" ],
   "DATA_CB_1SHOT2"               => [   7,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "Replace Syndrome OneShot" ],
   "DATA_CONT2"                   => [   8,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "toggle mask data" ],
   "DATA_1SHOT2"                  => [   9,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "1 shot mask data" ],
   "RSVD1"                        => [  10,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BYTE2"                        => [  11,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Replacement Syndrome" ],
   "DATA_CB_CONT1"                => [  12,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "Replace Syndrome Continous" ],
   "DATA_CB_1SHOT1"               => [  13,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "Replace Syndrome One Shot" ],
   "DATA_CONT1"                   => [  14,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "toggle mask data" ],
   "DATA_1SHOT1"                  => [  15,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "1 shot mask data" ],
   "RSVD2"                        => [  16,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BYTE1"                        => [  17,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Replacement Syndrome" ],
   "DATA_CB_CONT0"                => [  18,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Replace Syndrome Continuous" ],
   "DATA_CB_1SHOT0"               => [  19,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Replace Syndrome One Shot" ],
   "DATA_CONT0"                   => [  20,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "toggle mask data" ],
   "DATA_1SHOT0"                  => [  21,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "1 shot mask data" ],
   "RSVD3"                        => [  22,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BYTE0"                        => [  23,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Replacement Syndrome" ],
);

%shub_01_00412_def =
( NAME    => "SH_XNMD_ECC_INJ_REG",
  ADDRESS => 0x0000000150032030,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00412_flds
);


##########################################################################
#                                                                        #
#   SH_XNMD_ECC0_INJ_MASK_REG                                            #
#                                                                        #
##########################################################################

%shub_01_00413_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK_ECC0"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Replacement Data" ],
);

%shub_01_00413_def =
( NAME    => "SH_XNMD_ECC0_INJ_MASK_REG",
  ADDRESS => 0x0000000150032038,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00413_flds
);


##########################################################################
#                                                                        #
#   SH_XNMD_ECC1_INJ_MASK_REG                                            #
#                                                                        #
##########################################################################

%shub_01_00414_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK_ECC1"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Replacement Data" ],
);

%shub_01_00414_def =
( NAME    => "SH_XNMD_ECC1_INJ_MASK_REG",
  ADDRESS => 0x0000000150032040,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00414_flds
);


##########################################################################
#                                                                        #
#   SH_XNMD_ECC2_INJ_MASK_REG                                            #
#                                                                        #
##########################################################################

%shub_01_00415_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK_ECC2"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Replacement Data" ],
);

%shub_01_00415_def =
( NAME    => "SH_XNMD_ECC2_INJ_MASK_REG",
  ADDRESS => 0x0000000150032048,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00415_flds
);


##########################################################################
#                                                                        #
#   SH_XNMD_ECC3_INJ_MASK_REG                                            #
#                                                                        #
##########################################################################

%shub_01_00416_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK_ECC3"                    => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Replacement Data" ],
);

%shub_01_00416_def =
( NAME    => "SH_XNMD_ECC3_INJ_MASK_REG",
  ADDRESS => 0x0000000150032050,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00416_flds
);


##########################################################################
#                                                                        #
#   SH_XNMD_ECC_ERR_REPORT                                               #
#                                                                        #
##########################################################################

%shub_01_00417_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  49,  15, 0xFFFE000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECC_DISABLE3"                 => [   1,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "Disable Error Correction" ],
   "RSVD1"                        => [   2,  33,  15, 0x0000FFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECC_DISABLE2"                 => [   3,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "Disable Error Correction" ],
   "RSVD2"                        => [   4,  17,  15, 0x00000000FFFE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECC_DISABLE1"                 => [   5,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Disable Error Correction" ],
   "RSVD3"                        => [   6,   1,  15, 0x000000000000FFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECC_DISABLE0"                 => [   7,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Disable Error Correction" ],
);

%shub_01_00417_def =
( NAME    => "SH_XNMD_ECC_ERR_REPORT",
  ADDRESS => 0x0000000150032058,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00417_flds
);


##########################################################################
#                                                                        #
#   SH_NI0_ERROR_SUMMARY_1                                               #
#                                                                        #
##########################################################################

%shub_01_00418_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TAIL_TIMEOUT_NI_VC3"          => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "NI vc3 tail timeout" ],
   "TAIL_TIMEOUT_NI_VC2"          => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "NI vc2 tail timeout" ],
   "TAIL_TIMEOUT_NI_VC1"          => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI vc1 tail timeout" ],
   "TAIL_TIMEOUT_NI_VC0"          => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI vc0 tail timeout" ],
   "TAIL_TIMEOUT_FIFO13_VC3"      => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Fifo13 vc3 tail timeout" ],
   "TAIL_TIMEOUT_FIFO13_VC1"      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "Fifo13 vc1 tail timeout" ],
   "TAIL_TIMEOUT_FIFO02_VC2"      => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "Fifo02 vc2 tail timeout" ],
   "TAIL_TIMEOUT_FIFO02_VC0"      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "Fifo02 vc0 tail timeout" ],
   "OVERFLOW_NI_FIFO_VC3_CREDIT"  => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc3 credit overflow" ],
   "OVERFLOW_NI_FIFO_VC2_CREDIT"  => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 credit overflow" ],
   "OVERFLOW_NI_FIFO_VC1_CREDIT"  => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc1 credit overflow" ],
   "OVERFLOW_NI_FIFO_VC0_CREDIT"  => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 credit overflow" ],
   "OVERFLOW_MD_FIFO_VC2_CREDIT"  => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 credit overflow" ],
   "OVERFLOW_MD_FIFO_VC0_CREDIT"  => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 credit overflow" ],
   "OVERFLOW_IILB_FIFO_VC2_CREDIT" => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 credit overflow" ],
   "OVERFLOW_IILB_FIFO_VC0_CREDIT" => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 credit overflow" ],
   "OVERFLOW_PI_FIFO_VC2_CREDIT"  => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 credit overflow" ],
   "OVERFLOW_PI_FIFO_VC0_CREDIT"  => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 credit overflow" ],
   "OVERFLOW_MD_FIFO_VC2_PUSH"    => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 push overflow" ],
   "OVERFLOW_MD_FIFO_VC0_PUSH"    => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 push overflow" ],
   "OVERFLOW_IILB_FIFO_VC2_PUSH"  => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 push overflow" ],
   "OVERFLOW_IILB_FIFO_VC0_PUSH"  => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 push overflow" ],
   "OVERFLOW_PI_FIFO_VC2_PUSH"    => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 push overflow" ],
   "OVERFLOW_PI_FIFO_VC0_PUSH"    => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 push overflow" ],
   "OVERFLOW_NI_FIFO_VC2_POP"     => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 pop overflow" ],
   "OVERFLOW_NI_FIFO_VC0_POP"     => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 pop overflow" ],
   "OVERFLOW_MD_FIFO_VC2_POP"     => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 pop overflow" ],
   "OVERFLOW_MD_FIFO_VC0_POP"     => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 pop overflow" ],
   "OVERFLOW_IILB_FIFO_VC2_POP"   => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 pop overflow" ],
   "OVERFLOW_IILB_FIFO_VC0_POP"   => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 pop overflow" ],
   "OVERFLOW_PI_FIFO_VC2_POP"     => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 pop overflow" ],
   "OVERFLOW_PI_FIFO_VC0_POP"     => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 pop overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT3"      => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit3 overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT2"      => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit2 overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT1"      => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit1 overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT0"      => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit0 overflow" ],
   "OVERFLOW_MD_FIFO_DEBIT2"      => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "MD Fifo debit2 overflow" ],
   "OVERFLOW_MD_FIFO_DEBIT0"      => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "MD Fifo debit0 overflow" ],
   "OVERFLOW_IILB_FIFO_DEBIT2"    => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "IILB Fifo debit2 overflow" ],
   "OVERFLOW_IILB_FIFO_DEBIT0"    => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "IILB Fifo debit0 overflow" ],
   "OVERFLOW_PI_FIFO_DEBIT2"      => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "PI Fifo debit2 overflow" ],
   "OVERFLOW_PI_FIFO_DEBIT0"      => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "PI Fifo debit0 overflow" ],
   "OVERFLOW2_VC2_CREDIT"         => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "VC2 credit overflow 2" ],
   "OVERFLOW1_VC2_CREDIT"         => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "VC2 credit overflow 1" ],
   "OVERFLOW0_VC2_CREDIT"         => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "VC2 credit overflow 0" ],
   "OVERFLOW2_VC0_CREDIT"         => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "VC0 credit overflow 2" ],
   "OVERFLOW1_VC0_CREDIT"         => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VC0 credit overflow 1" ],
   "OVERFLOW0_VC0_CREDIT"         => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VC0 credit overflow 0" ],
   "OVERFLOW_FIFO13_VC2_CREDIT"   => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc2 credit overflow" ],
   "OVERFLOW_FIFO13_VC0_CREDIT"   => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc0 credit overflow" ],
   "OVERFLOW_FIFO02_VC2_CREDIT"   => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 credit overflow" ],
   "OVERFLOW_FIFO02_VC0_CREDIT"   => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 credit overflow" ],
   "OVERFLOW_FIFO13_VC3_PUSH"     => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 push overflow" ],
   "OVERFLOW_FIFO13_VC1_PUSH"     => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 push overflow" ],
   "OVERFLOW_FIFO02_VC2_PUSH"     => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 push overflow" ],
   "OVERFLOW_FIFO02_VC0_PUSH"     => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 push overflow" ],
   "OVERFLOW_FIFO13_VC3_POP"      => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 pop overflow" ],
   "OVERFLOW_FIFO13_VC1_POP"      => [  57,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 pop overflow" ],
   "OVERFLOW_FIFO02_VC2_POP"      => [  58,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 pop overflow" ],
   "OVERFLOW_FIFO02_VC0_POP"      => [  59,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 pop overflow" ],
   "OVERFLOW_FIFO13_DEBIT2"       => [  60,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Fifo 13 debit2 overflow" ],
   "OVERFLOW_FIFO13_DEBIT0"       => [  61,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Fifo 13 debit0 overflow" ],
   "OVERFLOW_FIFO02_DEBIT2"       => [  62,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Fifo 02 debit2 overflow" ],
   "OVERFLOW_FIFO02_DEBIT0"       => [  63,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Fifo 02 debit0 overflow" ],
);

%shub_01_00418_def =
( NAME    => "SH_NI0_ERROR_SUMMARY_1",
  ADDRESS => 0x0000000150040500,
  NOTE    => "ni0 Error Summary Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00418_flds
);


##########################################################################
#                                                                        #
#   SH_NI0_ERROR_SUMMARY_1_ALIAS                                         #
#                                                                        #
##########################################################################

%shub_01_00419_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TAIL_TIMEOUT_NI_VC3"          => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "NI vc3 tail timeout" ],
   "TAIL_TIMEOUT_NI_VC2"          => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "NI vc2 tail timeout" ],
   "TAIL_TIMEOUT_NI_VC1"          => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI vc1 tail timeout" ],
   "TAIL_TIMEOUT_NI_VC0"          => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI vc0 tail timeout" ],
   "TAIL_TIMEOUT_FIFO13_VC3"      => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Fifo13 vc3 tail timeout" ],
   "TAIL_TIMEOUT_FIFO13_VC1"      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "Fifo13 vc1 tail timeout" ],
   "TAIL_TIMEOUT_FIFO02_VC2"      => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "Fifo02 vc2 tail timeout" ],
   "TAIL_TIMEOUT_FIFO02_VC0"      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "Fifo02 vc0 tail timeout" ],
   "OVERFLOW_NI_FIFO_VC3_CREDIT"  => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc3 credit overflow" ],
   "OVERFLOW_NI_FIFO_VC2_CREDIT"  => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 credit overflow" ],
   "OVERFLOW_NI_FIFO_VC1_CREDIT"  => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc1 credit overflow" ],
   "OVERFLOW_NI_FIFO_VC0_CREDIT"  => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 credit overflow" ],
   "OVERFLOW_MD_FIFO_VC2_CREDIT"  => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 credit overflow" ],
   "OVERFLOW_MD_FIFO_VC0_CREDIT"  => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 credit overflow" ],
   "OVERFLOW_IILB_FIFO_VC2_CREDIT" => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 credit overflow" ],
   "OVERFLOW_IILB_FIFO_VC0_CREDIT" => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 credit overflow" ],
   "OVERFLOW_PI_FIFO_VC2_CREDIT"  => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 credit overflow" ],
   "OVERFLOW_PI_FIFO_VC0_CREDIT"  => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 credit overflow" ],
   "OVERFLOW_MD_FIFO_VC2_PUSH"    => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 push overflow" ],
   "OVERFLOW_MD_FIFO_VC0_PUSH"    => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 push overflow" ],
   "OVERFLOW_IILB_FIFO_VC2_PUSH"  => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 push overflow" ],
   "OVERFLOW_IILB_FIFO_VC0_PUSH"  => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 push overflow" ],
   "OVERFLOW_PI_FIFO_VC2_PUSH"    => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 push overflow" ],
   "OVERFLOW_PI_FIFO_VC0_PUSH"    => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 push overflow" ],
   "OVERFLOW_NI_FIFO_VC2_POP"     => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 pop overflow" ],
   "OVERFLOW_NI_FIFO_VC0_POP"     => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 pop overflow" ],
   "OVERFLOW_MD_FIFO_VC2_POP"     => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 pop overflow" ],
   "OVERFLOW_MD_FIFO_VC0_POP"     => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 pop overflow" ],
   "OVERFLOW_IILB_FIFO_VC2_POP"   => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 pop overflow" ],
   "OVERFLOW_IILB_FIFO_VC0_POP"   => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 pop overflow" ],
   "OVERFLOW_PI_FIFO_VC2_POP"     => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 pop overflow" ],
   "OVERFLOW_PI_FIFO_VC0_POP"     => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 pop overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT3"      => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit3 overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT2"      => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit2 overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT1"      => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit1 overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT0"      => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit0 overflow" ],
   "OVERFLOW_MD_FIFO_DEBIT2"      => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "MD Fifo debit2 overflow" ],
   "OVERFLOW_MD_FIFO_DEBIT0"      => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "MD Fifo debit0 overflow" ],
   "OVERFLOW_IILB_FIFO_DEBIT2"    => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "IILB Fifo debit2 overflow" ],
   "OVERFLOW_IILB_FIFO_DEBIT0"    => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "IILB Fifo debit0 overflow" ],
   "OVERFLOW_PI_FIFO_DEBIT2"      => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "PI Fifo debit2 overflow" ],
   "OVERFLOW_PI_FIFO_DEBIT0"      => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "PI Fifo debit0 overflow" ],
   "OVERFLOW2_VC2_CREDIT"         => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "VC2 credit overflow 2" ],
   "OVERFLOW1_VC2_CREDIT"         => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "VC2 credit overflow 1" ],
   "OVERFLOW0_VC2_CREDIT"         => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "VC2 credit overflow 0" ],
   "OVERFLOW2_VC0_CREDIT"         => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "VC0 credit overflow 2" ],
   "OVERFLOW1_VC0_CREDIT"         => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VC0 credit overflow 1" ],
   "OVERFLOW0_VC0_CREDIT"         => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VC0 credit overflow 0" ],
   "OVERFLOW_FIFO13_VC2_CREDIT"   => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc2 credit overflow" ],
   "OVERFLOW_FIFO13_VC0_CREDIT"   => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc0 credit overflow" ],
   "OVERFLOW_FIFO02_VC2_CREDIT"   => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 credit overflow" ],
   "OVERFLOW_FIFO02_VC0_CREDIT"   => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 credit overflow" ],
   "OVERFLOW_FIFO13_VC3_PUSH"     => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 push overflow" ],
   "OVERFLOW_FIFO13_VC1_PUSH"     => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 push overflow" ],
   "OVERFLOW_FIFO02_VC2_PUSH"     => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 push overflow" ],
   "OVERFLOW_FIFO02_VC0_PUSH"     => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 push overflow" ],
   "OVERFLOW_FIFO13_VC3_POP"      => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 pop overflow" ],
   "OVERFLOW_FIFO13_VC1_POP"      => [  57,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 pop overflow" ],
   "OVERFLOW_FIFO02_VC2_POP"      => [  58,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 pop overflow" ],
   "OVERFLOW_FIFO02_VC0_POP"      => [  59,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 pop overflow" ],
   "OVERFLOW_FIFO13_DEBIT2"       => [  60,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Fifo 13 debit2 overflow" ],
   "OVERFLOW_FIFO13_DEBIT0"       => [  61,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Fifo 13 debit0 overflow" ],
   "OVERFLOW_FIFO02_DEBIT2"       => [  62,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Fifo 02 debit2 overflow" ],
   "OVERFLOW_FIFO02_DEBIT0"       => [  63,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Fifo 02 debit0 overflow" ],
);

%shub_01_00419_def =
( NAME    => "SH_NI0_ERROR_SUMMARY_1_ALIAS",
  ADDRESS => 0x0000000150040508,
  NOTE    => "ni0 Error Summary Bits Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00419_flds
);


##########################################################################
#                                                                        #
#   SH_NI0_ERROR_SUMMARY_2                                               #
#                                                                        #
##########################################################################

%shub_01_00420_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RETRY_TIMEOUT_ERROR"          => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "LLP_DEADLOCK_VC3"             => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
   "UNDERFLOW_NI_FIFO_VC3_CREDIT" => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc3 credit underflow" ],
   "UNDERFLOW_NI_FIFO_VC2_CREDIT" => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 credit underflow" ],
   "UNDERFLOW_NI_FIFO_VC1_CREDIT" => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc1 credit underflow" ],
   "UNDERFLOW_NI_FIFO_VC0_CREDIT" => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 credit underflow" ],
   "UNDERFLOW_MD_FIFO_VC2_CREDIT" => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 credit underflow" ],
   "UNDERFLOW_MD_FIFO_VC0_CREDIT" => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 credit underflow" ],
   "UNDERFLOW_IILB_FIFO_VC2_CREDIT" => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 credit underflow" ],
   "UNDERFLOW_IILB_FIFO_VC0_CREDIT" => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 credit underflow" ],
   "UNDERFLOW_PI_FIFO_VC2_CREDIT" => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 credit underflow" ],
   "UNDERFLOW_PI_FIFO_VC0_CREDIT" => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 credit underflow" ],
   "UNDERFLOW_MD_FIFO_VC2_PUSH"   => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 push underflow" ],
   "UNDERFLOW_MD_FIFO_VC0_PUSH"   => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 push underflow" ],
   "UNDERFLOW_IILB_FIFO_VC2_PUSH" => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 push underflow" ],
   "UNDERFLOW_IILB_FIFO_VC0_PUSH" => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 push underflow" ],
   "UNDERFLOW_PI_FIFO_VC2_PUSH"   => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 push underflow" ],
   "UNDERFLOW_PI_FIFO_VC0_PUSH"   => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 push underflow" ],
   "UNDERFLOW_NI_FIFO_VC2_POP"    => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 pop underflow" ],
   "UNDERFLOW_NI_FIFO_VC0_POP"    => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 pop underflow" ],
   "UNDERFLOW_MD_FIFO_VC2_POP"    => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 pop underflow" ],
   "UNDERFLOW_MD_FIFO_VC0_POP"    => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 pop underflow" ],
   "UNDERFLOW_IILB_FIFO_VC2_POP"  => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 pop underflow" ],
   "UNDERFLOW_IILB_FIFO_VC0_POP"  => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 pop underflow" ],
   "UNDERFLOW_PI_FIFO_VC2_POP"    => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 pop underflow" ],
   "UNDERFLOW_PI_FIFO_VC0_POP"    => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 pop underflow" ],
   "RSVD1"                        => [  32,  22,  10, 0x00000000FFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW2_VC2_CREDIT"        => [  33,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "VC2 credit underflow 2" ],
   "UNDERFLOW1_VC2_CREDIT"        => [  34,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "VC2 credit underflow 1" ],
   "UNDERFLOW0_VC2_CREDIT"        => [  35,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "VC2 credit underflow 0" ],
   "UNDERFLOW2_VC0_CREDIT"        => [  36,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "VC0 credit underflow 2" ],
   "UNDERFLOW1_VC0_CREDIT"        => [  37,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VC0 credit underflow 1" ],
   "UNDERFLOW0_VC0_CREDIT"        => [  38,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VC0 credit underflow 0" ],
   "UNDERFLOW_FIFO13_VC2_CREDIT"  => [  39,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc2 credit underflow" ],
   "UNDERFLOW_FIFO13_VC0_CREDIT"  => [  40,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc0 credit underflow" ],
   "UNDERFLOW_FIFO02_VC2_CREDIT"  => [  41,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 credit underflow" ],
   "UNDERFLOW_FIFO02_VC0_CREDIT"  => [  42,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 credit underflow" ],
   "UNDERFLOW_FIFO13_VC3_PUSH"    => [  43,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 push underflow" ],
   "UNDERFLOW_FIFO13_VC1_PUSH"    => [  44,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 push underflow" ],
   "UNDERFLOW_FIFO02_VC2_PUSH"    => [  45,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 push underflow" ],
   "UNDERFLOW_FIFO02_VC0_PUSH"    => [  46,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 push underflow" ],
   "UNDERFLOW_FIFO13_VC3_POP"     => [  47,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 pop underflow" ],
   "UNDERFLOW_FIFO13_VC1_POP"     => [  48,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 pop underflow" ],
   "UNDERFLOW_FIFO02_VC2_POP"     => [  49,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 pop underflow" ],
   "UNDERFLOW_FIFO02_VC0_POP"     => [  50,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 pop underflow" ],
   "ILLEGAL_VCIILB"               => [  51,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Illegal VC IILB" ],
   "ILLEGAL_VCMD"                 => [  52,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Illegal VC MD" ],
   "ILLEGAL_VCPI"                 => [  53,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Illegal VC PI" ],
   "ILLEGAL_VCNI"                 => [  54,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Illegal VC NI" ],
);

%shub_01_00420_def =
( NAME    => "SH_NI0_ERROR_SUMMARY_2",
  ADDRESS => 0x0000000150040510,
  NOTE    => "ni0 Error Summary Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00420_flds
);


##########################################################################
#                                                                        #
#   SH_NI0_ERROR_SUMMARY_2_ALIAS                                         #
#                                                                        #
##########################################################################

%shub_01_00421_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RETRY_TIMEOUT_ERROR"          => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "LLP_DEADLOCK_VC3"             => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
   "UNDERFLOW_NI_FIFO_VC3_CREDIT" => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc3 credit underflow" ],
   "UNDERFLOW_NI_FIFO_VC2_CREDIT" => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 credit underflow" ],
   "UNDERFLOW_NI_FIFO_VC1_CREDIT" => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc1 credit underflow" ],
   "UNDERFLOW_NI_FIFO_VC0_CREDIT" => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 credit underflow" ],
   "UNDERFLOW_MD_FIFO_VC2_CREDIT" => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 credit underflow" ],
   "UNDERFLOW_MD_FIFO_VC0_CREDIT" => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 credit underflow" ],
   "UNDERFLOW_IILB_FIFO_VC2_CREDIT" => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 credit underflow" ],
   "UNDERFLOW_IILB_FIFO_VC0_CREDIT" => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 credit underflow" ],
   "UNDERFLOW_PI_FIFO_VC2_CREDIT" => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 credit underflow" ],
   "UNDERFLOW_PI_FIFO_VC0_CREDIT" => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 credit underflow" ],
   "UNDERFLOW_MD_FIFO_VC2_PUSH"   => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 push underflow" ],
   "UNDERFLOW_MD_FIFO_VC0_PUSH"   => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 push underflow" ],
   "UNDERFLOW_IILB_FIFO_VC2_PUSH" => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 push underflow" ],
   "UNDERFLOW_IILB_FIFO_VC0_PUSH" => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 push underflow" ],
   "UNDERFLOW_PI_FIFO_VC2_PUSH"   => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 push underflow" ],
   "UNDERFLOW_PI_FIFO_VC0_PUSH"   => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 push underflow" ],
   "UNDERFLOW_NI_FIFO_VC2_POP"    => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 pop underflow" ],
   "UNDERFLOW_NI_FIFO_VC0_POP"    => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 pop underflow" ],
   "UNDERFLOW_MD_FIFO_VC2_POP"    => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 pop underflow" ],
   "UNDERFLOW_MD_FIFO_VC0_POP"    => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 pop underflow" ],
   "UNDERFLOW_IILB_FIFO_VC2_POP"  => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 pop underflow" ],
   "UNDERFLOW_IILB_FIFO_VC0_POP"  => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 pop underflow" ],
   "UNDERFLOW_PI_FIFO_VC2_POP"    => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 pop underflow" ],
   "UNDERFLOW_PI_FIFO_VC0_POP"    => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 pop underflow" ],
   "RSVD1"                        => [  32,  22,  10, 0x00000000FFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW2_VC2_CREDIT"        => [  33,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "VC2 credit underflow 2" ],
   "UNDERFLOW1_VC2_CREDIT"        => [  34,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "VC2 credit underflow 1" ],
   "UNDERFLOW0_VC2_CREDIT"        => [  35,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "VC2 credit underflow 0" ],
   "UNDERFLOW2_VC0_CREDIT"        => [  36,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "VC0 credit underflow 2" ],
   "UNDERFLOW1_VC0_CREDIT"        => [  37,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VC0 credit underflow 1" ],
   "UNDERFLOW0_VC0_CREDIT"        => [  38,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VC0 credit underflow 0" ],
   "UNDERFLOW_FIFO13_VC2_CREDIT"  => [  39,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc2 credit underflow" ],
   "UNDERFLOW_FIFO13_VC0_CREDIT"  => [  40,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc0 credit underflow" ],
   "UNDERFLOW_FIFO02_VC2_CREDIT"  => [  41,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 credit underflow" ],
   "UNDERFLOW_FIFO02_VC0_CREDIT"  => [  42,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 credit underflow" ],
   "UNDERFLOW_FIFO13_VC3_PUSH"    => [  43,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 push underflow" ],
   "UNDERFLOW_FIFO13_VC1_PUSH"    => [  44,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 push underflow" ],
   "UNDERFLOW_FIFO02_VC2_PUSH"    => [  45,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 push underflow" ],
   "UNDERFLOW_FIFO02_VC0_PUSH"    => [  46,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 push underflow" ],
   "UNDERFLOW_FIFO13_VC3_POP"     => [  47,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 pop underflow" ],
   "UNDERFLOW_FIFO13_VC1_POP"     => [  48,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 pop underflow" ],
   "UNDERFLOW_FIFO02_VC2_POP"     => [  49,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 pop underflow" ],
   "UNDERFLOW_FIFO02_VC0_POP"     => [  50,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 pop underflow" ],
   "ILLEGAL_VCIILB"               => [  51,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Illegal VC IILB" ],
   "ILLEGAL_VCMD"                 => [  52,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Illegal VC MD" ],
   "ILLEGAL_VCPI"                 => [  53,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Illegal VC PI" ],
   "ILLEGAL_VCNI"                 => [  54,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Illegal VC NI" ],
);

%shub_01_00421_def =
( NAME    => "SH_NI0_ERROR_SUMMARY_2_ALIAS",
  ADDRESS => 0x0000000150040518,
  NOTE    => "ni0 Error Summary Bits Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00421_flds
);


##########################################################################
#                                                                        #
#   SH_NI0_ERROR_OVERFLOW_1                                              #
#                                                                        #
##########################################################################

%shub_01_00422_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TAIL_TIMEOUT_NI_VC3"          => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "NI vc3 tail timeout" ],
   "TAIL_TIMEOUT_NI_VC2"          => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "NI vc2 tail timeout" ],
   "TAIL_TIMEOUT_NI_VC1"          => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI vc1 tail timeout" ],
   "TAIL_TIMEOUT_NI_VC0"          => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI vc0 tail timeout" ],
   "TAIL_TIMEOUT_FIFO13_VC3"      => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Fifo13 vc3 tail timeout" ],
   "TAIL_TIMEOUT_FIFO13_VC1"      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "Fifo13 vc1 tail timeout" ],
   "TAIL_TIMEOUT_FIFO02_VC2"      => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "Fifo02 vc2 tail timeout" ],
   "TAIL_TIMEOUT_FIFO02_VC0"      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "Fifo02 vc0 tail timeout" ],
   "OVERFLOW_NI_FIFO_VC3_CREDIT"  => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc3 credit overflow" ],
   "OVERFLOW_NI_FIFO_VC2_CREDIT"  => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 credit overflow" ],
   "OVERFLOW_NI_FIFO_VC1_CREDIT"  => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc1 credit overflow" ],
   "OVERFLOW_NI_FIFO_VC0_CREDIT"  => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 credit overflow" ],
   "OVERFLOW_MD_FIFO_VC2_CREDIT"  => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 credit overflow" ],
   "OVERFLOW_MD_FIFO_VC0_CREDIT"  => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 credit overflow" ],
   "OVERFLOW_IILB_FIFO_VC2_CREDIT" => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 credit overflow" ],
   "OVERFLOW_IILB_FIFO_VC0_CREDIT" => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 credit overflow" ],
   "OVERFLOW_PI_FIFO_VC2_CREDIT"  => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 credit overflow" ],
   "OVERFLOW_PI_FIFO_VC0_CREDIT"  => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 credit overflow" ],
   "OVERFLOW_MD_FIFO_VC2_PUSH"    => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 push overflow" ],
   "OVERFLOW_MD_FIFO_VC0_PUSH"    => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 push overflow" ],
   "OVERFLOW_IILB_FIFO_VC2_PUSH"  => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 push overflow" ],
   "OVERFLOW_IILB_FIFO_VC0_PUSH"  => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 push overflow" ],
   "OVERFLOW_PI_FIFO_VC2_PUSH"    => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 push overflow" ],
   "OVERFLOW_PI_FIFO_VC0_PUSH"    => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 push overflow" ],
   "OVERFLOW_NI_FIFO_VC2_POP"     => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 pop overflow" ],
   "OVERFLOW_NI_FIFO_VC0_POP"     => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 pop overflow" ],
   "OVERFLOW_MD_FIFO_VC2_POP"     => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 pop overflow" ],
   "OVERFLOW_MD_FIFO_VC0_POP"     => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 pop overflow" ],
   "OVERFLOW_IILB_FIFO_VC2_POP"   => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 pop overflow" ],
   "OVERFLOW_IILB_FIFO_VC0_POP"   => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 pop overflow" ],
   "OVERFLOW_PI_FIFO_VC2_POP"     => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 pop overflow" ],
   "OVERFLOW_PI_FIFO_VC0_POP"     => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 pop overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT3"      => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit3 overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT2"      => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit2 overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT1"      => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit1 overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT0"      => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit0 overflow" ],
   "OVERFLOW_MD_FIFO_DEBIT2"      => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "MD Fifo debit2 overflow" ],
   "OVERFLOW_MD_FIFO_DEBIT0"      => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "MD Fifo debit0 overflow" ],
   "OVERFLOW_IILB_FIFO_DEBIT2"    => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "IILB Fifo debit2 overflow" ],
   "OVERFLOW_IILB_FIFO_DEBIT0"    => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "IILB Fifo debit0 overflow" ],
   "OVERFLOW_PI_FIFO_DEBIT2"      => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "PI Fifo debit2 overflow" ],
   "OVERFLOW_PI_FIFO_DEBIT0"      => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "PI Fifo debit0 overflow" ],
   "OVERFLOW2_VC2_CREDIT"         => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "VC2 credit overflow 2" ],
   "OVERFLOW1_VC2_CREDIT"         => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "VC2 credit overflow 1" ],
   "OVERFLOW0_VC2_CREDIT"         => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "VC2 credit overflow 0" ],
   "OVERFLOW2_VC0_CREDIT"         => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "VC0 credit overflow 2" ],
   "OVERFLOW1_VC0_CREDIT"         => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VC0 credit overflow 1" ],
   "OVERFLOW0_VC0_CREDIT"         => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VC0 credit overflow 0" ],
   "OVERFLOW_FIFO13_VC2_CREDIT"   => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc2 credit overflow" ],
   "OVERFLOW_FIFO13_VC0_CREDIT"   => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc0 credit overflow" ],
   "OVERFLOW_FIFO02_VC2_CREDIT"   => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 credit overflow" ],
   "OVERFLOW_FIFO02_VC0_CREDIT"   => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 credit overflow" ],
   "OVERFLOW_FIFO13_VC3_PUSH"     => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 push overflow" ],
   "OVERFLOW_FIFO13_VC1_PUSH"     => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 push overflow" ],
   "OVERFLOW_FIFO02_VC2_PUSH"     => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 push overflow" ],
   "OVERFLOW_FIFO02_VC0_PUSH"     => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 push overflow" ],
   "OVERFLOW_FIFO13_VC3_POP"      => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 pop overflow" ],
   "OVERFLOW_FIFO13_VC1_POP"      => [  57,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 pop overflow" ],
   "OVERFLOW_FIFO02_VC2_POP"      => [  58,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 pop overflow" ],
   "OVERFLOW_FIFO02_VC0_POP"      => [  59,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 pop overflow" ],
   "OVERFLOW_FIFO13_DEBIT2"       => [  60,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Fifo 13 debit2 overflow" ],
   "OVERFLOW_FIFO13_DEBIT0"       => [  61,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Fifo 13 debit0 overflow" ],
   "OVERFLOW_FIFO02_DEBIT2"       => [  62,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Fifo 02 debit2 overflow" ],
   "OVERFLOW_FIFO02_DEBIT0"       => [  63,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Fifo 02 debit0 overflow" ],
);

%shub_01_00422_def =
( NAME    => "SH_NI0_ERROR_OVERFLOW_1",
  ADDRESS => 0x0000000150040520,
  NOTE    => "ni0 Error Overflow Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00422_flds
);


##########################################################################
#                                                                        #
#   SH_NI0_ERROR_OVERFLOW_1_ALIAS                                        #
#                                                                        #
##########################################################################

%shub_01_00423_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TAIL_TIMEOUT_NI_VC3"          => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "NI vc3 tail timeout" ],
   "TAIL_TIMEOUT_NI_VC2"          => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "NI vc2 tail timeout" ],
   "TAIL_TIMEOUT_NI_VC1"          => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI vc1 tail timeout" ],
   "TAIL_TIMEOUT_NI_VC0"          => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI vc0 tail timeout" ],
   "TAIL_TIMEOUT_FIFO13_VC3"      => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Fifo13 vc3 tail timeout" ],
   "TAIL_TIMEOUT_FIFO13_VC1"      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "Fifo13 vc1 tail timeout" ],
   "TAIL_TIMEOUT_FIFO02_VC2"      => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "Fifo02 vc2 tail timeout" ],
   "TAIL_TIMEOUT_FIFO02_VC0"      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "Fifo02 vc0 tail timeout" ],
   "OVERFLOW_NI_FIFO_VC3_CREDIT"  => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc3 credit overflow" ],
   "OVERFLOW_NI_FIFO_VC2_CREDIT"  => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 credit overflow" ],
   "OVERFLOW_NI_FIFO_VC1_CREDIT"  => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc1 credit overflow" ],
   "OVERFLOW_NI_FIFO_VC0_CREDIT"  => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 credit overflow" ],
   "OVERFLOW_MD_FIFO_VC2_CREDIT"  => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 credit overflow" ],
   "OVERFLOW_MD_FIFO_VC0_CREDIT"  => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 credit overflow" ],
   "OVERFLOW_IILB_FIFO_VC2_CREDIT" => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 credit overflow" ],
   "OVERFLOW_IILB_FIFO_VC0_CREDIT" => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 credit overflow" ],
   "OVERFLOW_PI_FIFO_VC2_CREDIT"  => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 credit overflow" ],
   "OVERFLOW_PI_FIFO_VC0_CREDIT"  => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 credit overflow" ],
   "OVERFLOW_MD_FIFO_VC2_PUSH"    => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 push overflow" ],
   "OVERFLOW_MD_FIFO_VC0_PUSH"    => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 push overflow" ],
   "OVERFLOW_IILB_FIFO_VC2_PUSH"  => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 push overflow" ],
   "OVERFLOW_IILB_FIFO_VC0_PUSH"  => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 push overflow" ],
   "OVERFLOW_PI_FIFO_VC2_PUSH"    => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 push overflow" ],
   "OVERFLOW_PI_FIFO_VC0_PUSH"    => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 push overflow" ],
   "OVERFLOW_NI_FIFO_VC2_POP"     => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 pop overflow" ],
   "OVERFLOW_NI_FIFO_VC0_POP"     => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 pop overflow" ],
   "OVERFLOW_MD_FIFO_VC2_POP"     => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 pop overflow" ],
   "OVERFLOW_MD_FIFO_VC0_POP"     => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 pop overflow" ],
   "OVERFLOW_IILB_FIFO_VC2_POP"   => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 pop overflow" ],
   "OVERFLOW_IILB_FIFO_VC0_POP"   => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 pop overflow" ],
   "OVERFLOW_PI_FIFO_VC2_POP"     => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 pop overflow" ],
   "OVERFLOW_PI_FIFO_VC0_POP"     => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 pop overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT3"      => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit3 overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT2"      => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit2 overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT1"      => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit1 overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT0"      => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit0 overflow" ],
   "OVERFLOW_MD_FIFO_DEBIT2"      => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "MD Fifo debit2 overflow" ],
   "OVERFLOW_MD_FIFO_DEBIT0"      => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "MD Fifo debit0 overflow" ],
   "OVERFLOW_IILB_FIFO_DEBIT2"    => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "IILB Fifo debit2 overflow" ],
   "OVERFLOW_IILB_FIFO_DEBIT0"    => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "IILB Fifo debit0 overflow" ],
   "OVERFLOW_PI_FIFO_DEBIT2"      => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "PI Fifo debit2 overflow" ],
   "OVERFLOW_PI_FIFO_DEBIT0"      => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "PI Fifo debit0 overflow" ],
   "OVERFLOW2_VC2_CREDIT"         => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "VC2 credit overflow 2" ],
   "OVERFLOW1_VC2_CREDIT"         => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "VC2 credit overflow 1" ],
   "OVERFLOW0_VC2_CREDIT"         => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "VC2 credit overflow 0" ],
   "OVERFLOW2_VC0_CREDIT"         => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "VC0 credit overflow 2" ],
   "OVERFLOW1_VC0_CREDIT"         => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VC0 credit overflow 1" ],
   "OVERFLOW0_VC0_CREDIT"         => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VC0 credit overflow 0" ],
   "OVERFLOW_FIFO13_VC2_CREDIT"   => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc2 credit overflow" ],
   "OVERFLOW_FIFO13_VC0_CREDIT"   => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc0 credit overflow" ],
   "OVERFLOW_FIFO02_VC2_CREDIT"   => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 credit overflow" ],
   "OVERFLOW_FIFO02_VC0_CREDIT"   => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 credit overflow" ],
   "OVERFLOW_FIFO13_VC3_PUSH"     => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 push overflow" ],
   "OVERFLOW_FIFO13_VC1_PUSH"     => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 push overflow" ],
   "OVERFLOW_FIFO02_VC2_PUSH"     => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 push overflow" ],
   "OVERFLOW_FIFO02_VC0_PUSH"     => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 push overflow" ],
   "OVERFLOW_FIFO13_VC3_POP"      => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 pop overflow" ],
   "OVERFLOW_FIFO13_VC1_POP"      => [  57,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 pop overflow" ],
   "OVERFLOW_FIFO02_VC2_POP"      => [  58,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 pop overflow" ],
   "OVERFLOW_FIFO02_VC0_POP"      => [  59,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 pop overflow" ],
   "OVERFLOW_FIFO13_DEBIT2"       => [  60,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Fifo 13 debit2 overflow" ],
   "OVERFLOW_FIFO13_DEBIT0"       => [  61,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Fifo 13 debit0 overflow" ],
   "OVERFLOW_FIFO02_DEBIT2"       => [  62,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Fifo 02 debit2 overflow" ],
   "OVERFLOW_FIFO02_DEBIT0"       => [  63,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Fifo 02 debit0 overflow" ],
);

%shub_01_00423_def =
( NAME    => "SH_NI0_ERROR_OVERFLOW_1_ALIAS",
  ADDRESS => 0x0000000150040528,
  NOTE    => "ni0 Error Overflow Bits Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00423_flds
);


##########################################################################
#                                                                        #
#   SH_NI0_ERROR_OVERFLOW_2                                              #
#                                                                        #
##########################################################################

%shub_01_00424_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RETRY_TIMEOUT_ERROR"          => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "LLP_DEADLOCK_VC3"             => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
   "UNDERFLOW_NI_FIFO_VC3_CREDIT" => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc3 credit underflow" ],
   "UNDERFLOW_NI_FIFO_VC2_CREDIT" => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 credit underflow" ],
   "UNDERFLOW_NI_FIFO_VC1_CREDIT" => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc1 credit underflow" ],
   "UNDERFLOW_NI_FIFO_VC0_CREDIT" => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 credit underflow" ],
   "UNDERFLOW_MD_FIFO_VC2_CREDIT" => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 credit underflow" ],
   "UNDERFLOW_MD_FIFO_VC0_CREDIT" => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 credit underflow" ],
   "UNDERFLOW_IILB_FIFO_VC2_CREDIT" => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 credit underflow" ],
   "UNDERFLOW_IILB_FIFO_VC0_CREDIT" => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 credit underflow" ],
   "UNDERFLOW_PI_FIFO_VC2_CREDIT" => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 credit underflow" ],
   "UNDERFLOW_PI_FIFO_VC0_CREDIT" => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 credit underflow" ],
   "UNDERFLOW_MD_FIFO_VC2_PUSH"   => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 push underflow" ],
   "UNDERFLOW_MD_FIFO_VC0_PUSH"   => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 push underflow" ],
   "UNDERFLOW_IILB_FIFO_VC2_PUSH" => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 push underflow" ],
   "UNDERFLOW_IILB_FIFO_VC0_PUSH" => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 push underflow" ],
   "UNDERFLOW_PI_FIFO_VC2_PUSH"   => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 push underflow" ],
   "UNDERFLOW_PI_FIFO_VC0_PUSH"   => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 push underflow" ],
   "UNDERFLOW_NI_FIFO_VC2_POP"    => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 pop underflow" ],
   "UNDERFLOW_NI_FIFO_VC0_POP"    => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 pop underflow" ],
   "UNDERFLOW_MD_FIFO_VC2_POP"    => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 pop underflow" ],
   "UNDERFLOW_MD_FIFO_VC0_POP"    => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 pop underflow" ],
   "UNDERFLOW_IILB_FIFO_VC2_POP"  => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 pop underflow" ],
   "UNDERFLOW_IILB_FIFO_VC0_POP"  => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 pop underflow" ],
   "UNDERFLOW_PI_FIFO_VC2_POP"    => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 pop underflow" ],
   "UNDERFLOW_PI_FIFO_VC0_POP"    => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 pop underflow" ],
   "RSVD1"                        => [  32,  22,  10, 0x00000000FFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW2_VC2_CREDIT"        => [  33,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "VC2 credit underflow 2" ],
   "UNDERFLOW1_VC2_CREDIT"        => [  34,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "VC2 credit underflow 1" ],
   "UNDERFLOW0_VC2_CREDIT"        => [  35,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "VC2 credit underflow 0" ],
   "UNDERFLOW2_VC0_CREDIT"        => [  36,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "VC0 credit underflow 2" ],
   "UNDERFLOW1_VC0_CREDIT"        => [  37,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VC0 credit underflow 1" ],
   "UNDERFLOW0_VC0_CREDIT"        => [  38,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VC0 credit underflow 0" ],
   "UNDERFLOW_FIFO13_VC2_CREDIT"  => [  39,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc2 credit underflow" ],
   "UNDERFLOW_FIFO13_VC0_CREDIT"  => [  40,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc0 credit underflow" ],
   "UNDERFLOW_FIFO02_VC2_CREDIT"  => [  41,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 credit underflow" ],
   "UNDERFLOW_FIFO02_VC0_CREDIT"  => [  42,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 credit underflow" ],
   "UNDERFLOW_FIFO13_VC3_PUSH"    => [  43,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 push underflow" ],
   "UNDERFLOW_FIFO13_VC1_PUSH"    => [  44,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 push underflow" ],
   "UNDERFLOW_FIFO02_VC2_PUSH"    => [  45,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 push underflow" ],
   "UNDERFLOW_FIFO02_VC0_PUSH"    => [  46,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 push underflow" ],
   "UNDERFLOW_FIFO13_VC3_POP"     => [  47,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 pop underflow" ],
   "UNDERFLOW_FIFO13_VC1_POP"     => [  48,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 pop underflow" ],
   "UNDERFLOW_FIFO02_VC2_POP"     => [  49,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 pop underflow" ],
   "UNDERFLOW_FIFO02_VC0_POP"     => [  50,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 pop underflow" ],
   "ILLEGAL_VCIILB"               => [  51,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Illegal VC IILB" ],
   "ILLEGAL_VCMD"                 => [  52,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Illegal VC MD" ],
   "ILLEGAL_VCPI"                 => [  53,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Illegal VC PI" ],
   "ILLEGAL_VCNI"                 => [  54,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Illegal VC NI" ],
);

%shub_01_00424_def =
( NAME    => "SH_NI0_ERROR_OVERFLOW_2",
  ADDRESS => 0x0000000150040530,
  NOTE    => "ni0 Error Overflow Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00424_flds
);


##########################################################################
#                                                                        #
#   SH_NI0_ERROR_OVERFLOW_2_ALIAS                                        #
#                                                                        #
##########################################################################

%shub_01_00425_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RETRY_TIMEOUT_ERROR"          => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "LLP_DEADLOCK_VC3"             => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
   "UNDERFLOW_NI_FIFO_VC3_CREDIT" => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc3 credit underflow" ],
   "UNDERFLOW_NI_FIFO_VC2_CREDIT" => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 credit underflow" ],
   "UNDERFLOW_NI_FIFO_VC1_CREDIT" => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc1 credit underflow" ],
   "UNDERFLOW_NI_FIFO_VC0_CREDIT" => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 credit underflow" ],
   "UNDERFLOW_MD_FIFO_VC2_CREDIT" => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 credit underflow" ],
   "UNDERFLOW_MD_FIFO_VC0_CREDIT" => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 credit underflow" ],
   "UNDERFLOW_IILB_FIFO_VC2_CREDIT" => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 credit underflow" ],
   "UNDERFLOW_IILB_FIFO_VC0_CREDIT" => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 credit underflow" ],
   "UNDERFLOW_PI_FIFO_VC2_CREDIT" => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 credit underflow" ],
   "UNDERFLOW_PI_FIFO_VC0_CREDIT" => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 credit underflow" ],
   "UNDERFLOW_MD_FIFO_VC2_PUSH"   => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 push underflow" ],
   "UNDERFLOW_MD_FIFO_VC0_PUSH"   => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 push underflow" ],
   "UNDERFLOW_IILB_FIFO_VC2_PUSH" => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 push underflow" ],
   "UNDERFLOW_IILB_FIFO_VC0_PUSH" => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 push underflow" ],
   "UNDERFLOW_PI_FIFO_VC2_PUSH"   => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 push underflow" ],
   "UNDERFLOW_PI_FIFO_VC0_PUSH"   => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 push underflow" ],
   "UNDERFLOW_NI_FIFO_VC2_POP"    => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 pop underflow" ],
   "UNDERFLOW_NI_FIFO_VC0_POP"    => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 pop underflow" ],
   "UNDERFLOW_MD_FIFO_VC2_POP"    => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 pop underflow" ],
   "UNDERFLOW_MD_FIFO_VC0_POP"    => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 pop underflow" ],
   "UNDERFLOW_IILB_FIFO_VC2_POP"  => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 pop underflow" ],
   "UNDERFLOW_IILB_FIFO_VC0_POP"  => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 pop underflow" ],
   "UNDERFLOW_PI_FIFO_VC2_POP"    => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 pop underflow" ],
   "UNDERFLOW_PI_FIFO_VC0_POP"    => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 pop underflow" ],
   "RSVD1"                        => [  32,  22,  10, 0x00000000FFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW2_VC2_CREDIT"        => [  33,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "VC2 credit underflow 2" ],
   "UNDERFLOW1_VC2_CREDIT"        => [  34,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "VC2 credit underflow 1" ],
   "UNDERFLOW0_VC2_CREDIT"        => [  35,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "VC2 credit underflow 0" ],
   "UNDERFLOW2_VC0_CREDIT"        => [  36,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "VC0 credit underflow 2" ],
   "UNDERFLOW1_VC0_CREDIT"        => [  37,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VC0 credit underflow 1" ],
   "UNDERFLOW0_VC0_CREDIT"        => [  38,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VC0 credit underflow 0" ],
   "UNDERFLOW_FIFO13_VC2_CREDIT"  => [  39,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc2 credit underflow" ],
   "UNDERFLOW_FIFO13_VC0_CREDIT"  => [  40,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc0 credit underflow" ],
   "UNDERFLOW_FIFO02_VC2_CREDIT"  => [  41,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 credit underflow" ],
   "UNDERFLOW_FIFO02_VC0_CREDIT"  => [  42,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 credit underflow" ],
   "UNDERFLOW_FIFO13_VC3_PUSH"    => [  43,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 push underflow" ],
   "UNDERFLOW_FIFO13_VC1_PUSH"    => [  44,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 push underflow" ],
   "UNDERFLOW_FIFO02_VC2_PUSH"    => [  45,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 push underflow" ],
   "UNDERFLOW_FIFO02_VC0_PUSH"    => [  46,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 push underflow" ],
   "UNDERFLOW_FIFO13_VC3_POP"     => [  47,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 pop underflow" ],
   "UNDERFLOW_FIFO13_VC1_POP"     => [  48,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 pop underflow" ],
   "UNDERFLOW_FIFO02_VC2_POP"     => [  49,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 pop underflow" ],
   "UNDERFLOW_FIFO02_VC0_POP"     => [  50,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 pop underflow" ],
   "ILLEGAL_VCIILB"               => [  51,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Illegal VC IILB" ],
   "ILLEGAL_VCMD"                 => [  52,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Illegal VC MD" ],
   "ILLEGAL_VCPI"                 => [  53,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Illegal VC PI" ],
   "ILLEGAL_VCNI"                 => [  54,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Illegal VC NI" ],
);

%shub_01_00425_def =
( NAME    => "SH_NI0_ERROR_OVERFLOW_2_ALIAS",
  ADDRESS => 0x0000000150040538,
  NOTE    => "ni0 Error Overflow Bits Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00425_flds
);


##########################################################################
#                                                                        #
#   SH_NI0_ERROR_MASK_1                                                  #
#                                                                        #
##########################################################################

%shub_01_00426_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TAIL_TIMEOUT_NI_VC3"          => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "NI vc3 tail timeout" ],
   "TAIL_TIMEOUT_NI_VC2"          => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "NI vc2 tail timeout" ],
   "TAIL_TIMEOUT_NI_VC1"          => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "NI vc1 tail timeout" ],
   "TAIL_TIMEOUT_NI_VC0"          => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "NI vc0 tail timeout" ],
   "TAIL_TIMEOUT_FIFO13_VC3"      => [   4,  59,   1, 0x0800000000000000, 0x00, 1, 0x0000000000000000, "Fifo13 vc3 tail timeout" ],
   "TAIL_TIMEOUT_FIFO13_VC1"      => [   5,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "Fifo13 vc1 tail timeout" ],
   "TAIL_TIMEOUT_FIFO02_VC2"      => [   6,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "Fifo02 vc2 tail timeout" ],
   "TAIL_TIMEOUT_FIFO02_VC0"      => [   7,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "Fifo02 vc0 tail timeout" ],
   "OVERFLOW_NI_FIFO_VC3_CREDIT"  => [   8,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "NI Fifo vc3 credit overflow" ],
   "OVERFLOW_NI_FIFO_VC2_CREDIT"  => [   9,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "NI Fifo vc2 credit overflow" ],
   "OVERFLOW_NI_FIFO_VC1_CREDIT"  => [  10,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "NI Fifo vc1 credit overflow" ],
   "OVERFLOW_NI_FIFO_VC0_CREDIT"  => [  11,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "NI Fifo vc0 credit overflow" ],
   "OVERFLOW_MD_FIFO_VC2_CREDIT"  => [  12,  51,   1, 0x0008000000000000, 0x00, 1, 0x0000000000000000, "MD Fifo vc2 credit overflow" ],
   "OVERFLOW_MD_FIFO_VC0_CREDIT"  => [  13,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "MD Fifo vc0 credit overflow" ],
   "OVERFLOW_IILB_FIFO_VC2_CREDIT" => [  14,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "IILB Fifo vc2 credit overflow" ],
   "OVERFLOW_IILB_FIFO_VC0_CREDIT" => [  15,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "IILB Fifo vc0 credit overflow" ],
   "OVERFLOW_PI_FIFO_VC2_CREDIT"  => [  16,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "PI Fifo vc2 credit overflow" ],
   "OVERFLOW_PI_FIFO_VC0_CREDIT"  => [  17,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "PI Fifo vc0 credit overflow" ],
   "OVERFLOW_MD_FIFO_VC2_PUSH"    => [  18,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "MD Fifo vc2 push overflow" ],
   "OVERFLOW_MD_FIFO_VC0_PUSH"    => [  19,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "MD Fifo vc0 push overflow" ],
   "OVERFLOW_IILB_FIFO_VC2_PUSH"  => [  20,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "IILB Fifo vc2 push overflow" ],
   "OVERFLOW_IILB_FIFO_VC0_PUSH"  => [  21,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "IILB Fifo vc0 push overflow" ],
   "OVERFLOW_PI_FIFO_VC2_PUSH"    => [  22,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "PI Fifo vc2 push overflow" ],
   "OVERFLOW_PI_FIFO_VC0_PUSH"    => [  23,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "PI Fifo vc0 push overflow" ],
   "OVERFLOW_NI_FIFO_VC2_POP"     => [  24,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "NI Fifo vc2 pop overflow" ],
   "OVERFLOW_NI_FIFO_VC0_POP"     => [  25,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "NI Fifo vc0 pop overflow" ],
   "OVERFLOW_MD_FIFO_VC2_POP"     => [  26,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "MD Fifo vc2 pop overflow" ],
   "OVERFLOW_MD_FIFO_VC0_POP"     => [  27,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "MD Fifo vc0 pop overflow" ],
   "OVERFLOW_IILB_FIFO_VC2_POP"   => [  28,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "IILB Fifo vc2 pop overflow" ],
   "OVERFLOW_IILB_FIFO_VC0_POP"   => [  29,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "IILB Fifo vc0 pop overflow" ],
   "OVERFLOW_PI_FIFO_VC2_POP"     => [  30,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "PI Fifo vc2 pop overflow" ],
   "OVERFLOW_PI_FIFO_VC0_POP"     => [  31,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "PI Fifo vc0 pop overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT3"      => [  32,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "NI Fifo debit3 overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT2"      => [  33,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "NI Fifo debit2 overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT1"      => [  34,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "NI Fifo debit1 overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT0"      => [  35,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "NI Fifo debit0 overflow" ],
   "OVERFLOW_MD_FIFO_DEBIT2"      => [  36,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "MD Fifo debit2 overflow" ],
   "OVERFLOW_MD_FIFO_DEBIT0"      => [  37,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "MD Fifo debit0 overflow" ],
   "OVERFLOW_IILB_FIFO_DEBIT2"    => [  38,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "IILB Fifo debit2 overflow" ],
   "OVERFLOW_IILB_FIFO_DEBIT0"    => [  39,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "IILB Fifo debit0 overflow" ],
   "OVERFLOW_PI_FIFO_DEBIT2"      => [  40,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "PI Fifo debit2 overflow" ],
   "OVERFLOW_PI_FIFO_DEBIT0"      => [  41,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "PI Fifo debit0 overflow" ],
   "OVERFLOW2_VC2_CREDIT"         => [  42,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "VC2 credit overflow 2" ],
   "OVERFLOW1_VC2_CREDIT"         => [  43,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "VC2 credit overflow 1" ],
   "OVERFLOW0_VC2_CREDIT"         => [  44,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "VC2 credit overflow 0" ],
   "OVERFLOW2_VC0_CREDIT"         => [  45,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "VC0 credit overflow 2" ],
   "OVERFLOW1_VC0_CREDIT"         => [  46,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "VC0 credit overflow 1" ],
   "OVERFLOW0_VC0_CREDIT"         => [  47,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "VC0 credit overflow 0" ],
   "OVERFLOW_FIFO13_VC2_CREDIT"   => [  48,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Fifo 13 vc2 credit overflow" ],
   "OVERFLOW_FIFO13_VC0_CREDIT"   => [  49,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Fifo 13 vc0 credit overflow" ],
   "OVERFLOW_FIFO02_VC2_CREDIT"   => [  50,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Fifo 02 vc2 credit overflow" ],
   "OVERFLOW_FIFO02_VC0_CREDIT"   => [  51,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Fifo 02 vc0 credit overflow" ],
   "OVERFLOW_FIFO13_VC3_PUSH"     => [  52,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "Fifo 13 vc3 push overflow" ],
   "OVERFLOW_FIFO13_VC1_PUSH"     => [  53,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "Fifo 13 vc1 push overflow" ],
   "OVERFLOW_FIFO02_VC2_PUSH"     => [  54,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Fifo 02 vc2 push overflow" ],
   "OVERFLOW_FIFO02_VC0_PUSH"     => [  55,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Fifo 02 vc0 push overflow" ],
   "OVERFLOW_FIFO13_VC3_POP"      => [  56,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Fifo 13 vc3 pop overflow" ],
   "OVERFLOW_FIFO13_VC1_POP"      => [  57,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Fifo 13 vc1 pop overflow" ],
   "OVERFLOW_FIFO02_VC2_POP"      => [  58,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Fifo 02 vc2 pop overflow" ],
   "OVERFLOW_FIFO02_VC0_POP"      => [  59,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Fifo 02 vc0 pop overflow" ],
   "OVERFLOW_FIFO13_DEBIT2"       => [  60,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Fifo 13 debit2 overflow" ],
   "OVERFLOW_FIFO13_DEBIT0"       => [  61,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Fifo 13 debit0 overflow" ],
   "OVERFLOW_FIFO02_DEBIT2"       => [  62,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Fifo 02 debit2 overflow" ],
   "OVERFLOW_FIFO02_DEBIT0"       => [  63,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Fifo 02 debit0 overflow" ],
);

%shub_01_00426_def =
( NAME    => "SH_NI0_ERROR_MASK_1",
  ADDRESS => 0x0000000150040540,
  NOTE    => "ni0 Error Mask Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00426_flds
);


##########################################################################
#                                                                        #
#   SH_NI0_ERROR_MASK_2                                                  #
#                                                                        #
##########################################################################

%shub_01_00427_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RETRY_TIMEOUT_ERROR"          => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "chiplet nomatch" ],
   "LLP_DEADLOCK_VC3"             => [   4,  59,   1, 0x0800000000000000, 0x00, 1, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [   5,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [   6,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [   7,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "llp deadlock vc0" ],
   "UNDERFLOW_NI_FIFO_VC3_CREDIT" => [   8,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "NI Fifo vc3 credit underflow" ],
   "UNDERFLOW_NI_FIFO_VC2_CREDIT" => [   9,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "NI Fifo vc2 credit underflow" ],
   "UNDERFLOW_NI_FIFO_VC1_CREDIT" => [  10,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "NI Fifo vc1 credit underflow" ],
   "UNDERFLOW_NI_FIFO_VC0_CREDIT" => [  11,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "NI Fifo vc0 credit underflow" ],
   "UNDERFLOW_MD_FIFO_VC2_CREDIT" => [  12,  51,   1, 0x0008000000000000, 0x00, 1, 0x0000000000000000, "MD Fifo vc2 credit underflow" ],
   "UNDERFLOW_MD_FIFO_VC0_CREDIT" => [  13,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "MD Fifo vc0 credit underflow" ],
   "UNDERFLOW_IILB_FIFO_VC2_CREDIT" => [  14,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "IILB Fifo vc2 credit underflow" ],
   "UNDERFLOW_IILB_FIFO_VC0_CREDIT" => [  15,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "IILB Fifo vc0 credit underflow" ],
   "UNDERFLOW_PI_FIFO_VC2_CREDIT" => [  16,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "PI Fifo vc2 credit underflow" ],
   "UNDERFLOW_PI_FIFO_VC0_CREDIT" => [  17,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "PI Fifo vc0 credit underflow" ],
   "UNDERFLOW_MD_FIFO_VC2_PUSH"   => [  18,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "MD Fifo vc2 push underflow" ],
   "UNDERFLOW_MD_FIFO_VC0_PUSH"   => [  19,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "MD Fifo vc0 push underflow" ],
   "UNDERFLOW_IILB_FIFO_VC2_PUSH" => [  20,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "IILB Fifo vc2 push underflow" ],
   "UNDERFLOW_IILB_FIFO_VC0_PUSH" => [  21,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "IILB Fifo vc0 push underflow" ],
   "UNDERFLOW_PI_FIFO_VC2_PUSH"   => [  22,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "PI Fifo vc2 push underflow" ],
   "UNDERFLOW_PI_FIFO_VC0_PUSH"   => [  23,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "PI Fifo vc0 push underflow" ],
   "UNDERFLOW_NI_FIFO_VC2_POP"    => [  24,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "NI Fifo vc2 pop underflow" ],
   "UNDERFLOW_NI_FIFO_VC0_POP"    => [  25,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "NI Fifo vc0 pop underflow" ],
   "UNDERFLOW_MD_FIFO_VC2_POP"    => [  26,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "MD Fifo vc2 pop underflow" ],
   "UNDERFLOW_MD_FIFO_VC0_POP"    => [  27,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "MD Fifo vc0 pop underflow" ],
   "UNDERFLOW_IILB_FIFO_VC2_POP"  => [  28,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "IILB Fifo vc2 pop underflow" ],
   "UNDERFLOW_IILB_FIFO_VC0_POP"  => [  29,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "IILB Fifo vc0 pop underflow" ],
   "UNDERFLOW_PI_FIFO_VC2_POP"    => [  30,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "PI Fifo vc2 pop underflow" ],
   "UNDERFLOW_PI_FIFO_VC0_POP"    => [  31,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "PI Fifo vc0 pop underflow" ],
   "RSVD1"                        => [  32,  22,  10, 0x00000000FFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW2_VC2_CREDIT"        => [  33,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "VC2 credit underflow 2" ],
   "UNDERFLOW1_VC2_CREDIT"        => [  34,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "VC2 credit underflow 1" ],
   "UNDERFLOW0_VC2_CREDIT"        => [  35,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "VC2 credit underflow 0" ],
   "UNDERFLOW2_VC0_CREDIT"        => [  36,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "VC0 credit underflow 2" ],
   "UNDERFLOW1_VC0_CREDIT"        => [  37,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "VC0 credit underflow 1" ],
   "UNDERFLOW0_VC0_CREDIT"        => [  38,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "VC0 credit underflow 0" ],
   "UNDERFLOW_FIFO13_VC2_CREDIT"  => [  39,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Fifo 13 vc2 credit underflow" ],
   "UNDERFLOW_FIFO13_VC0_CREDIT"  => [  40,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Fifo 13 vc0 credit underflow" ],
   "UNDERFLOW_FIFO02_VC2_CREDIT"  => [  41,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Fifo 02 vc2 credit underflow" ],
   "UNDERFLOW_FIFO02_VC0_CREDIT"  => [  42,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Fifo 02 vc0 credit underflow" ],
   "UNDERFLOW_FIFO13_VC3_PUSH"    => [  43,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "Fifo 13 vc3 push underflow" ],
   "UNDERFLOW_FIFO13_VC1_PUSH"    => [  44,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "Fifo 13 vc1 push underflow" ],
   "UNDERFLOW_FIFO02_VC2_PUSH"    => [  45,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Fifo 02 vc2 push underflow" ],
   "UNDERFLOW_FIFO02_VC0_PUSH"    => [  46,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Fifo 02 vc0 push underflow" ],
   "UNDERFLOW_FIFO13_VC3_POP"     => [  47,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Fifo 13 vc3 pop underflow" ],
   "UNDERFLOW_FIFO13_VC1_POP"     => [  48,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Fifo 13 vc1 pop underflow" ],
   "UNDERFLOW_FIFO02_VC2_POP"     => [  49,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Fifo 02 vc2 pop underflow" ],
   "UNDERFLOW_FIFO02_VC0_POP"     => [  50,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Fifo 02 vc0 pop underflow" ],
   "ILLEGAL_VCIILB"               => [  51,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Illegal VC IILB" ],
   "ILLEGAL_VCMD"                 => [  52,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Illegal VC MD" ],
   "ILLEGAL_VCPI"                 => [  53,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Illegal VC PI" ],
   "ILLEGAL_VCNI"                 => [  54,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Illegal VC NI" ],
);

%shub_01_00427_def =
( NAME    => "SH_NI0_ERROR_MASK_2",
  ADDRESS => 0x0000000150040550,
  NOTE    => "ni0 Error Mask Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00427_flds
);


##########################################################################
#                                                                        #
#   SH_NI0_FIRST_ERROR_1                                                 #
#                                                                        #
##########################################################################

%shub_01_00428_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TAIL_TIMEOUT_NI_VC3"          => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "NI vc3 tail timeout" ],
   "TAIL_TIMEOUT_NI_VC2"          => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "NI vc2 tail timeout" ],
   "TAIL_TIMEOUT_NI_VC1"          => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI vc1 tail timeout" ],
   "TAIL_TIMEOUT_NI_VC0"          => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI vc0 tail timeout" ],
   "TAIL_TIMEOUT_FIFO13_VC3"      => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Fifo13 vc3 tail timeout" ],
   "TAIL_TIMEOUT_FIFO13_VC1"      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "Fifo13 vc1 tail timeout" ],
   "TAIL_TIMEOUT_FIFO02_VC2"      => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "Fifo02 vc2 tail timeout" ],
   "TAIL_TIMEOUT_FIFO02_VC0"      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "Fifo02 vc0 tail timeout" ],
   "OVERFLOW_NI_FIFO_VC3_CREDIT"  => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc3 credit overflow" ],
   "OVERFLOW_NI_FIFO_VC2_CREDIT"  => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 credit overflow" ],
   "OVERFLOW_NI_FIFO_VC1_CREDIT"  => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc1 credit overflow" ],
   "OVERFLOW_NI_FIFO_VC0_CREDIT"  => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 credit overflow" ],
   "OVERFLOW_MD_FIFO_VC2_CREDIT"  => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 credit overflow" ],
   "OVERFLOW_MD_FIFO_VC0_CREDIT"  => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 credit overflow" ],
   "OVERFLOW_IILB_FIFO_VC2_CREDIT" => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 credit overflow" ],
   "OVERFLOW_IILB_FIFO_VC0_CREDIT" => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 credit overflow" ],
   "OVERFLOW_PI_FIFO_VC2_CREDIT"  => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 credit overflow" ],
   "OVERFLOW_PI_FIFO_VC0_CREDIT"  => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 credit overflow" ],
   "OVERFLOW_MD_FIFO_VC2_PUSH"    => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 push overflow" ],
   "OVERFLOW_MD_FIFO_VC0_PUSH"    => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 push overflow" ],
   "OVERFLOW_IILB_FIFO_VC2_PUSH"  => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 push overflow" ],
   "OVERFLOW_IILB_FIFO_VC0_PUSH"  => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 push overflow" ],
   "OVERFLOW_PI_FIFO_VC2_PUSH"    => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 push overflow" ],
   "OVERFLOW_PI_FIFO_VC0_PUSH"    => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 push overflow" ],
   "OVERFLOW_NI_FIFO_VC2_POP"     => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 pop overflow" ],
   "OVERFLOW_NI_FIFO_VC0_POP"     => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 pop overflow" ],
   "OVERFLOW_MD_FIFO_VC2_POP"     => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 pop overflow" ],
   "OVERFLOW_MD_FIFO_VC0_POP"     => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 pop overflow" ],
   "OVERFLOW_IILB_FIFO_VC2_POP"   => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 pop overflow" ],
   "OVERFLOW_IILB_FIFO_VC0_POP"   => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 pop overflow" ],
   "OVERFLOW_PI_FIFO_VC2_POP"     => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 pop overflow" ],
   "OVERFLOW_PI_FIFO_VC0_POP"     => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 pop overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT3"      => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit3 overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT2"      => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit2 overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT1"      => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit1 overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT0"      => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit0 overflow" ],
   "OVERFLOW_MD_FIFO_DEBIT2"      => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "MD Fifo debit2 overflow" ],
   "OVERFLOW_MD_FIFO_DEBIT0"      => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "MD Fifo debit0 overflow" ],
   "OVERFLOW_IILB_FIFO_DEBIT2"    => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "IILB Fifo debit2 overflow" ],
   "OVERFLOW_IILB_FIFO_DEBIT0"    => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "IILB Fifo debit0 overflow" ],
   "OVERFLOW_PI_FIFO_DEBIT2"      => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "PI Fifo debit2 overflow" ],
   "OVERFLOW_PI_FIFO_DEBIT0"      => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "PI Fifo debit0 overflow" ],
   "OVERFLOW2_VC2_CREDIT"         => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "VC2 credit overflow 2" ],
   "OVERFLOW1_VC2_CREDIT"         => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "VC2 credit overflow 1" ],
   "OVERFLOW0_VC2_CREDIT"         => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "VC2 credit overflow 0" ],
   "OVERFLOW2_VC0_CREDIT"         => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "VC0 credit overflow 2" ],
   "OVERFLOW1_VC0_CREDIT"         => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VC0 credit overflow 1" ],
   "OVERFLOW0_VC0_CREDIT"         => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VC0 credit overflow 0" ],
   "OVERFLOW_FIFO13_VC2_CREDIT"   => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc2 credit overflow" ],
   "OVERFLOW_FIFO13_VC0_CREDIT"   => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc0 credit overflow" ],
   "OVERFLOW_FIFO02_VC2_CREDIT"   => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 credit overflow" ],
   "OVERFLOW_FIFO02_VC0_CREDIT"   => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 credit overflow" ],
   "OVERFLOW_FIFO13_VC3_PUSH"     => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 push overflow" ],
   "OVERFLOW_FIFO13_VC1_PUSH"     => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 push overflow" ],
   "OVERFLOW_FIFO02_VC2_PUSH"     => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 push overflow" ],
   "OVERFLOW_FIFO02_VC0_PUSH"     => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 push overflow" ],
   "OVERFLOW_FIFO13_VC3_POP"      => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 pop overflow" ],
   "OVERFLOW_FIFO13_VC1_POP"      => [  57,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 pop overflow" ],
   "OVERFLOW_FIFO02_VC2_POP"      => [  58,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 pop overflow" ],
   "OVERFLOW_FIFO02_VC0_POP"      => [  59,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 pop overflow" ],
   "OVERFLOW_FIFO13_DEBIT2"       => [  60,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Fifo 13 debit2 overflow" ],
   "OVERFLOW_FIFO13_DEBIT0"       => [  61,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Fifo 13 debit0 overflow" ],
   "OVERFLOW_FIFO02_DEBIT2"       => [  62,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Fifo 02 debit2 overflow" ],
   "OVERFLOW_FIFO02_DEBIT0"       => [  63,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Fifo 02 debit0 overflow" ],
);

%shub_01_00428_def =
( NAME    => "SH_NI0_FIRST_ERROR_1",
  ADDRESS => 0x0000000150040560,
  NOTE    => "ni0 First Error Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00428_flds
);


##########################################################################
#                                                                        #
#   SH_NI0_FIRST_ERROR_2                                                 #
#                                                                        #
##########################################################################

%shub_01_00429_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RETRY_TIMEOUT_ERROR"          => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "LLP_DEADLOCK_VC3"             => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
   "UNDERFLOW_NI_FIFO_VC3_CREDIT" => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc3 credit underflow" ],
   "UNDERFLOW_NI_FIFO_VC2_CREDIT" => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 credit underflow" ],
   "UNDERFLOW_NI_FIFO_VC1_CREDIT" => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc1 credit underflow" ],
   "UNDERFLOW_NI_FIFO_VC0_CREDIT" => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 credit underflow" ],
   "UNDERFLOW_MD_FIFO_VC2_CREDIT" => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 credit underflow" ],
   "UNDERFLOW_MD_FIFO_VC0_CREDIT" => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 credit underflow" ],
   "UNDERFLOW_IILB_FIFO_VC2_CREDIT" => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 credit underflow" ],
   "UNDERFLOW_IILB_FIFO_VC0_CREDIT" => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 credit underflow" ],
   "UNDERFLOW_PI_FIFO_VC2_CREDIT" => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 credit underflow" ],
   "UNDERFLOW_PI_FIFO_VC0_CREDIT" => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 credit underflow" ],
   "UNDERFLOW_MD_FIFO_VC2_PUSH"   => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 push underflow" ],
   "UNDERFLOW_MD_FIFO_VC0_PUSH"   => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 push underflow" ],
   "UNDERFLOW_IILB_FIFO_VC2_PUSH" => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 push underflow" ],
   "UNDERFLOW_IILB_FIFO_VC0_PUSH" => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 push underflow" ],
   "UNDERFLOW_PI_FIFO_VC2_PUSH"   => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 push underflow" ],
   "UNDERFLOW_PI_FIFO_VC0_PUSH"   => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 push underflow" ],
   "UNDERFLOW_NI_FIFO_VC2_POP"    => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 pop underflow" ],
   "UNDERFLOW_NI_FIFO_VC0_POP"    => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 pop underflow" ],
   "UNDERFLOW_MD_FIFO_VC2_POP"    => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 pop underflow" ],
   "UNDERFLOW_MD_FIFO_VC0_POP"    => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 pop underflow" ],
   "UNDERFLOW_IILB_FIFO_VC2_POP"  => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 pop underflow" ],
   "UNDERFLOW_IILB_FIFO_VC0_POP"  => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 pop underflow" ],
   "UNDERFLOW_PI_FIFO_VC2_POP"    => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 pop underflow" ],
   "UNDERFLOW_PI_FIFO_VC0_POP"    => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 pop underflow" ],
   "RSVD1"                        => [  32,  22,  10, 0x00000000FFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW2_VC2_CREDIT"        => [  33,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "VC2 credit underflow 2" ],
   "UNDERFLOW1_VC2_CREDIT"        => [  34,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "VC2 credit underflow 1" ],
   "UNDERFLOW0_VC2_CREDIT"        => [  35,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "VC2 credit underflow 0" ],
   "UNDERFLOW2_VC0_CREDIT"        => [  36,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "VC0 credit underflow 2" ],
   "UNDERFLOW1_VC0_CREDIT"        => [  37,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VC0 credit underflow 1" ],
   "UNDERFLOW0_VC0_CREDIT"        => [  38,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VC0 credit underflow 0" ],
   "UNDERFLOW_FIFO13_VC2_CREDIT"  => [  39,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc2 credit underflow" ],
   "UNDERFLOW_FIFO13_VC0_CREDIT"  => [  40,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc0 credit underflow" ],
   "UNDERFLOW_FIFO02_VC2_CREDIT"  => [  41,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 credit underflow" ],
   "UNDERFLOW_FIFO02_VC0_CREDIT"  => [  42,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 credit underflow" ],
   "UNDERFLOW_FIFO13_VC3_PUSH"    => [  43,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 push underflow" ],
   "UNDERFLOW_FIFO13_VC1_PUSH"    => [  44,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 push underflow" ],
   "UNDERFLOW_FIFO02_VC2_PUSH"    => [  45,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 push underflow" ],
   "UNDERFLOW_FIFO02_VC0_PUSH"    => [  46,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 push underflow" ],
   "UNDERFLOW_FIFO13_VC3_POP"     => [  47,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 pop underflow" ],
   "UNDERFLOW_FIFO13_VC1_POP"     => [  48,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 pop underflow" ],
   "UNDERFLOW_FIFO02_VC2_POP"     => [  49,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 pop underflow" ],
   "UNDERFLOW_FIFO02_VC0_POP"     => [  50,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 pop underflow" ],
   "ILLEGAL_VCIILB"               => [  51,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Illegal VC IILB" ],
   "ILLEGAL_VCMD"                 => [  52,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Illegal VC MD" ],
   "ILLEGAL_VCPI"                 => [  53,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Illegal VC PI" ],
   "ILLEGAL_VCNI"                 => [  54,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Illegal VC NI" ],
);

%shub_01_00429_def =
( NAME    => "SH_NI0_FIRST_ERROR_2",
  ADDRESS => 0x0000000150040570,
  NOTE    => "ni0 First Error Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00429_flds
);


##########################################################################
#                                                                        #
#   SH_NI0_ERROR_DETAIL_1                                                #
#                                                                        #
##########################################################################

%shub_01_00430_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Header bits 63:0" ],
);

%shub_01_00430_def =
( NAME    => "SH_NI0_ERROR_DETAIL_1",
  ADDRESS => 0x0000000150040580,
  NOTE    => "ni0 Chiplet no match header bits 63:0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00430_flds
);


##########################################################################
#                                                                        #
#   SH_NI0_ERROR_DETAIL_2                                                #
#                                                                        #
##########################################################################

%shub_01_00431_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Header bits 127:64" ],
);

%shub_01_00431_def =
( NAME    => "SH_NI0_ERROR_DETAIL_2",
  ADDRESS => 0x0000000150040590,
  NOTE    => "ni0 Chiplet no match header bits 127:64",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00431_flds
);


##########################################################################
#                                                                        #
#   SH_NI1_ERROR_SUMMARY_1                                               #
#                                                                        #
##########################################################################

%shub_01_00432_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TAIL_TIMEOUT_NI_VC3"          => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "NI vc3 tail timeout" ],
   "TAIL_TIMEOUT_NI_VC2"          => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "NI vc2 tail timeout" ],
   "TAIL_TIMEOUT_NI_VC1"          => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI vc1 tail timeout" ],
   "TAIL_TIMEOUT_NI_VC0"          => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI vc0 tail timeout" ],
   "TAIL_TIMEOUT_FIFO13_VC3"      => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Fifo13 vc3 tail timeout" ],
   "TAIL_TIMEOUT_FIFO13_VC1"      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "Fifo13 vc1 tail timeout" ],
   "TAIL_TIMEOUT_FIFO02_VC2"      => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "Fifo02 vc2 tail timeout" ],
   "TAIL_TIMEOUT_FIFO02_VC0"      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "Fifo02 vc0 tail timeout" ],
   "OVERFLOW_NI_FIFO_VC3_CREDIT"  => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc3 credit overflow" ],
   "OVERFLOW_NI_FIFO_VC2_CREDIT"  => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 credit overflow" ],
   "OVERFLOW_NI_FIFO_VC1_CREDIT"  => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc1 credit overflow" ],
   "OVERFLOW_NI_FIFO_VC0_CREDIT"  => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 credit overflow" ],
   "OVERFLOW_MD_FIFO_VC2_CREDIT"  => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 credit overflow" ],
   "OVERFLOW_MD_FIFO_VC0_CREDIT"  => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 credit overflow" ],
   "OVERFLOW_IILB_FIFO_VC2_CREDIT" => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 credit overflow" ],
   "OVERFLOW_IILB_FIFO_VC0_CREDIT" => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 credit overflow" ],
   "OVERFLOW_PI_FIFO_VC2_CREDIT"  => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 credit overflow" ],
   "OVERFLOW_PI_FIFO_VC0_CREDIT"  => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 credit overflow" ],
   "OVERFLOW_MD_FIFO_VC2_PUSH"    => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 push overflow" ],
   "OVERFLOW_MD_FIFO_VC0_PUSH"    => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 push overflow" ],
   "OVERFLOW_IILB_FIFO_VC2_PUSH"  => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 push overflow" ],
   "OVERFLOW_IILB_FIFO_VC0_PUSH"  => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 push overflow" ],
   "OVERFLOW_PI_FIFO_VC2_PUSH"    => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 push overflow" ],
   "OVERFLOW_PI_FIFO_VC0_PUSH"    => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 push overflow" ],
   "OVERFLOW_NI_FIFO_VC2_POP"     => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 pop overflow" ],
   "OVERFLOW_NI_FIFO_VC0_POP"     => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 pop overflow" ],
   "OVERFLOW_MD_FIFO_VC2_POP"     => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 pop overflow" ],
   "OVERFLOW_MD_FIFO_VC0_POP"     => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 pop overflow" ],
   "OVERFLOW_IILB_FIFO_VC2_POP"   => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 pop overflow" ],
   "OVERFLOW_IILB_FIFO_VC0_POP"   => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 pop overflow" ],
   "OVERFLOW_PI_FIFO_VC2_POP"     => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 pop overflow" ],
   "OVERFLOW_PI_FIFO_VC0_POP"     => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 pop overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT3"      => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit3 overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT2"      => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit2 overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT1"      => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit1 overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT0"      => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit0 overflow" ],
   "OVERFLOW_MD_FIFO_DEBIT2"      => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "MD Fifo debit2 overflow" ],
   "OVERFLOW_MD_FIFO_DEBIT0"      => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "MD Fifo debit0 overflow" ],
   "OVERFLOW_IILB_FIFO_DEBIT2"    => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "IILB Fifo debit2 overflow" ],
   "OVERFLOW_IILB_FIFO_DEBIT0"    => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "IILB Fifo debit0 overflow" ],
   "OVERFLOW_PI_FIFO_DEBIT2"      => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "PI Fifo debit2 overflow" ],
   "OVERFLOW_PI_FIFO_DEBIT0"      => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "PI Fifo debit0 overflow" ],
   "OVERFLOW2_VC2_CREDIT"         => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "VC2 credit overflow 2" ],
   "OVERFLOW1_VC2_CREDIT"         => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "VC2 credit overflow 1" ],
   "OVERFLOW0_VC2_CREDIT"         => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "VC2 credit overflow 0" ],
   "OVERFLOW2_VC0_CREDIT"         => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "VC0 credit overflow 2" ],
   "OVERFLOW1_VC0_CREDIT"         => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VC0 credit overflow 1" ],
   "OVERFLOW0_VC0_CREDIT"         => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VC0 credit overflow 0" ],
   "OVERFLOW_FIFO13_VC2_CREDIT"   => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc2 credit overflow" ],
   "OVERFLOW_FIFO13_VC0_CREDIT"   => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc0 credit overflow" ],
   "OVERFLOW_FIFO02_VC2_CREDIT"   => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 credit overflow" ],
   "OVERFLOW_FIFO02_VC0_CREDIT"   => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 credit overflow" ],
   "OVERFLOW_FIFO13_VC3_PUSH"     => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 push overflow" ],
   "OVERFLOW_FIFO13_VC1_PUSH"     => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 push overflow" ],
   "OVERFLOW_FIFO02_VC2_PUSH"     => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 push overflow" ],
   "OVERFLOW_FIFO02_VC0_PUSH"     => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 push overflow" ],
   "OVERFLOW_FIFO13_VC3_POP"      => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 pop overflow" ],
   "OVERFLOW_FIFO13_VC1_POP"      => [  57,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 pop overflow" ],
   "OVERFLOW_FIFO02_VC2_POP"      => [  58,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 pop overflow" ],
   "OVERFLOW_FIFO02_VC0_POP"      => [  59,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 pop overflow" ],
   "OVERFLOW_FIFO13_DEBIT2"       => [  60,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Fifo 13 debit2 overflow" ],
   "OVERFLOW_FIFO13_DEBIT0"       => [  61,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Fifo 13 debit0 overflow" ],
   "OVERFLOW_FIFO02_DEBIT2"       => [  62,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Fifo 02 debit2 overflow" ],
   "OVERFLOW_FIFO02_DEBIT0"       => [  63,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Fifo 02 debit0 overflow" ],
);

%shub_01_00432_def =
( NAME    => "SH_NI1_ERROR_SUMMARY_1",
  ADDRESS => 0x0000000150040600,
  NOTE    => "ni1 Error Summary Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00432_flds
);


##########################################################################
#                                                                        #
#   SH_NI1_ERROR_SUMMARY_1_ALIAS                                         #
#                                                                        #
##########################################################################

%shub_01_00433_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TAIL_TIMEOUT_NI_VC3"          => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "NI vc3 tail timeout" ],
   "TAIL_TIMEOUT_NI_VC2"          => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "NI vc2 tail timeout" ],
   "TAIL_TIMEOUT_NI_VC1"          => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI vc1 tail timeout" ],
   "TAIL_TIMEOUT_NI_VC0"          => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI vc0 tail timeout" ],
   "TAIL_TIMEOUT_FIFO13_VC3"      => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Fifo13 vc3 tail timeout" ],
   "TAIL_TIMEOUT_FIFO13_VC1"      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "Fifo13 vc1 tail timeout" ],
   "TAIL_TIMEOUT_FIFO02_VC2"      => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "Fifo02 vc2 tail timeout" ],
   "TAIL_TIMEOUT_FIFO02_VC0"      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "Fifo02 vc0 tail timeout" ],
   "OVERFLOW_NI_FIFO_VC3_CREDIT"  => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc3 credit overflow" ],
   "OVERFLOW_NI_FIFO_VC2_CREDIT"  => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 credit overflow" ],
   "OVERFLOW_NI_FIFO_VC1_CREDIT"  => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc1 credit overflow" ],
   "OVERFLOW_NI_FIFO_VC0_CREDIT"  => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 credit overflow" ],
   "OVERFLOW_MD_FIFO_VC2_CREDIT"  => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 credit overflow" ],
   "OVERFLOW_MD_FIFO_VC0_CREDIT"  => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 credit overflow" ],
   "OVERFLOW_IILB_FIFO_VC2_CREDIT" => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 credit overflow" ],
   "OVERFLOW_IILB_FIFO_VC0_CREDIT" => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 credit overflow" ],
   "OVERFLOW_PI_FIFO_VC2_CREDIT"  => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 credit overflow" ],
   "OVERFLOW_PI_FIFO_VC0_CREDIT"  => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 credit overflow" ],
   "OVERFLOW_MD_FIFO_VC2_PUSH"    => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 push overflow" ],
   "OVERFLOW_MD_FIFO_VC0_PUSH"    => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 push overflow" ],
   "OVERFLOW_IILB_FIFO_VC2_PUSH"  => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 push overflow" ],
   "OVERFLOW_IILB_FIFO_VC0_PUSH"  => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 push overflow" ],
   "OVERFLOW_PI_FIFO_VC2_PUSH"    => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 push overflow" ],
   "OVERFLOW_PI_FIFO_VC0_PUSH"    => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 push overflow" ],
   "OVERFLOW_NI_FIFO_VC2_POP"     => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 pop overflow" ],
   "OVERFLOW_NI_FIFO_VC0_POP"     => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 pop overflow" ],
   "OVERFLOW_MD_FIFO_VC2_POP"     => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 pop overflow" ],
   "OVERFLOW_MD_FIFO_VC0_POP"     => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 pop overflow" ],
   "OVERFLOW_IILB_FIFO_VC2_POP"   => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 pop overflow" ],
   "OVERFLOW_IILB_FIFO_VC0_POP"   => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 pop overflow" ],
   "OVERFLOW_PI_FIFO_VC2_POP"     => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 pop overflow" ],
   "OVERFLOW_PI_FIFO_VC0_POP"     => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 pop overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT3"      => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit3 overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT2"      => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit2 overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT1"      => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit1 overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT0"      => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit0 overflow" ],
   "OVERFLOW_MD_FIFO_DEBIT2"      => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "MD Fifo debit2 overflow" ],
   "OVERFLOW_MD_FIFO_DEBIT0"      => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "MD Fifo debit0 overflow" ],
   "OVERFLOW_IILB_FIFO_DEBIT2"    => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "IILB Fifo debit2 overflow" ],
   "OVERFLOW_IILB_FIFO_DEBIT0"    => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "IILB Fifo debit0 overflow" ],
   "OVERFLOW_PI_FIFO_DEBIT2"      => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "PI Fifo debit2 overflow" ],
   "OVERFLOW_PI_FIFO_DEBIT0"      => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "PI Fifo debit0 overflow" ],
   "OVERFLOW2_VC2_CREDIT"         => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "VC2 credit overflow 2" ],
   "OVERFLOW1_VC2_CREDIT"         => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "VC2 credit overflow 1" ],
   "OVERFLOW0_VC2_CREDIT"         => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "VC2 credit overflow 0" ],
   "OVERFLOW2_VC0_CREDIT"         => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "VC0 credit overflow 2" ],
   "OVERFLOW1_VC0_CREDIT"         => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VC0 credit overflow 1" ],
   "OVERFLOW0_VC0_CREDIT"         => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VC0 credit overflow 0" ],
   "OVERFLOW_FIFO13_VC2_CREDIT"   => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc2 credit overflow" ],
   "OVERFLOW_FIFO13_VC0_CREDIT"   => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc0 credit overflow" ],
   "OVERFLOW_FIFO02_VC2_CREDIT"   => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 credit overflow" ],
   "OVERFLOW_FIFO02_VC0_CREDIT"   => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 credit overflow" ],
   "OVERFLOW_FIFO13_VC3_PUSH"     => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 push overflow" ],
   "OVERFLOW_FIFO13_VC1_PUSH"     => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 push overflow" ],
   "OVERFLOW_FIFO02_VC2_PUSH"     => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 push overflow" ],
   "OVERFLOW_FIFO02_VC0_PUSH"     => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 push overflow" ],
   "OVERFLOW_FIFO13_VC3_POP"      => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 pop overflow" ],
   "OVERFLOW_FIFO13_VC1_POP"      => [  57,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 pop overflow" ],
   "OVERFLOW_FIFO02_VC2_POP"      => [  58,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 pop overflow" ],
   "OVERFLOW_FIFO02_VC0_POP"      => [  59,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 pop overflow" ],
   "OVERFLOW_FIFO13_DEBIT2"       => [  60,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Fifo 13 debit2 overflow" ],
   "OVERFLOW_FIFO13_DEBIT0"       => [  61,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Fifo 13 debit0 overflow" ],
   "OVERFLOW_FIFO02_DEBIT2"       => [  62,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Fifo 02 debit2 overflow" ],
   "OVERFLOW_FIFO02_DEBIT0"       => [  63,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Fifo 02 debit0 overflow" ],
);

%shub_01_00433_def =
( NAME    => "SH_NI1_ERROR_SUMMARY_1_ALIAS",
  ADDRESS => 0x0000000150040608,
  NOTE    => "ni1 Error Summary Bits Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00433_flds
);


##########################################################################
#                                                                        #
#   SH_NI1_ERROR_SUMMARY_2                                               #
#                                                                        #
##########################################################################

%shub_01_00434_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RETRY_TIMEOUT_ERROR"          => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "LLP_DEADLOCK_VC3"             => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
   "UNDERFLOW_NI_FIFO_VC3_CREDIT" => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc3 credit underflow" ],
   "UNDERFLOW_NI_FIFO_VC2_CREDIT" => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 credit underflow" ],
   "UNDERFLOW_NI_FIFO_VC1_CREDIT" => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc1 credit underflow" ],
   "UNDERFLOW_NI_FIFO_VC0_CREDIT" => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 credit underflow" ],
   "UNDERFLOW_MD_FIFO_VC2_CREDIT" => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 credit underflow" ],
   "UNDERFLOW_MD_FIFO_VC0_CREDIT" => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 credit underflow" ],
   "UNDERFLOW_IILB_FIFO_VC2_CREDIT" => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 credit underflow" ],
   "UNDERFLOW_IILB_FIFO_VC0_CREDIT" => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 credit underflow" ],
   "UNDERFLOW_PI_FIFO_VC2_CREDIT" => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 credit underflow" ],
   "UNDERFLOW_PI_FIFO_VC0_CREDIT" => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 credit underflow" ],
   "UNDERFLOW_MD_FIFO_VC2_PUSH"   => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 push underflow" ],
   "UNDERFLOW_MD_FIFO_VC0_PUSH"   => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 push underflow" ],
   "UNDERFLOW_IILB_FIFO_VC2_PUSH" => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 push underflow" ],
   "UNDERFLOW_IILB_FIFO_VC0_PUSH" => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 push underflow" ],
   "UNDERFLOW_PI_FIFO_VC2_PUSH"   => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 push underflow" ],
   "UNDERFLOW_PI_FIFO_VC0_PUSH"   => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 push underflow" ],
   "UNDERFLOW_NI_FIFO_VC2_POP"    => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 pop underflow" ],
   "UNDERFLOW_NI_FIFO_VC0_POP"    => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 pop underflow" ],
   "UNDERFLOW_MD_FIFO_VC2_POP"    => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 pop underflow" ],
   "UNDERFLOW_MD_FIFO_VC0_POP"    => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 pop underflow" ],
   "UNDERFLOW_IILB_FIFO_VC2_POP"  => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 pop underflow" ],
   "UNDERFLOW_IILB_FIFO_VC0_POP"  => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 pop underflow" ],
   "UNDERFLOW_PI_FIFO_VC2_POP"    => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 pop underflow" ],
   "UNDERFLOW_PI_FIFO_VC0_POP"    => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 pop underflow" ],
   "RSVD1"                        => [  32,  22,  10, 0x00000000FFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW2_VC2_CREDIT"        => [  33,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "VC2 credit underflow 2" ],
   "UNDERFLOW1_VC2_CREDIT"        => [  34,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "VC2 credit underflow 1" ],
   "UNDERFLOW0_VC2_CREDIT"        => [  35,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "VC2 credit underflow 0" ],
   "UNDERFLOW2_VC0_CREDIT"        => [  36,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "VC0 credit underflow 2" ],
   "UNDERFLOW1_VC0_CREDIT"        => [  37,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VC0 credit underflow 1" ],
   "UNDERFLOW0_VC0_CREDIT"        => [  38,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VC0 credit underflow 0" ],
   "UNDERFLOW_FIFO13_VC2_CREDIT"  => [  39,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc2 credit underflow" ],
   "UNDERFLOW_FIFO13_VC0_CREDIT"  => [  40,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc0 credit underflow" ],
   "UNDERFLOW_FIFO02_VC2_CREDIT"  => [  41,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 credit underflow" ],
   "UNDERFLOW_FIFO02_VC0_CREDIT"  => [  42,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 credit underflow" ],
   "UNDERFLOW_FIFO13_VC3_PUSH"    => [  43,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 push underflow" ],
   "UNDERFLOW_FIFO13_VC1_PUSH"    => [  44,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 push underflow" ],
   "UNDERFLOW_FIFO02_VC2_PUSH"    => [  45,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 push underflow" ],
   "UNDERFLOW_FIFO02_VC0_PUSH"    => [  46,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 push underflow" ],
   "UNDERFLOW_FIFO13_VC3_POP"     => [  47,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 pop underflow" ],
   "UNDERFLOW_FIFO13_VC1_POP"     => [  48,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 pop underflow" ],
   "UNDERFLOW_FIFO02_VC2_POP"     => [  49,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 pop underflow" ],
   "UNDERFLOW_FIFO02_VC0_POP"     => [  50,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 pop underflow" ],
   "ILLEGAL_VCIILB"               => [  51,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Illegal VC IILB" ],
   "ILLEGAL_VCMD"                 => [  52,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Illegal VC MD" ],
   "ILLEGAL_VCPI"                 => [  53,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Illegal VC PI" ],
   "ILLEGAL_VCNI"                 => [  54,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Illegal VC NI" ],
);

%shub_01_00434_def =
( NAME    => "SH_NI1_ERROR_SUMMARY_2",
  ADDRESS => 0x0000000150040610,
  NOTE    => "ni1 Error Summary Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00434_flds
);


##########################################################################
#                                                                        #
#   SH_NI1_ERROR_SUMMARY_2_ALIAS                                         #
#                                                                        #
##########################################################################

%shub_01_00435_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RETRY_TIMEOUT_ERROR"          => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "LLP_DEADLOCK_VC3"             => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
   "UNDERFLOW_NI_FIFO_VC3_CREDIT" => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc3 credit underflow" ],
   "UNDERFLOW_NI_FIFO_VC2_CREDIT" => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 credit underflow" ],
   "UNDERFLOW_NI_FIFO_VC1_CREDIT" => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc1 credit underflow" ],
   "UNDERFLOW_NI_FIFO_VC0_CREDIT" => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 credit underflow" ],
   "UNDERFLOW_MD_FIFO_VC2_CREDIT" => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 credit underflow" ],
   "UNDERFLOW_MD_FIFO_VC0_CREDIT" => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 credit underflow" ],
   "UNDERFLOW_IILB_FIFO_VC2_CREDIT" => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 credit underflow" ],
   "UNDERFLOW_IILB_FIFO_VC0_CREDIT" => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 credit underflow" ],
   "UNDERFLOW_PI_FIFO_VC2_CREDIT" => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 credit underflow" ],
   "UNDERFLOW_PI_FIFO_VC0_CREDIT" => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 credit underflow" ],
   "UNDERFLOW_MD_FIFO_VC2_PUSH"   => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 push underflow" ],
   "UNDERFLOW_MD_FIFO_VC0_PUSH"   => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 push underflow" ],
   "UNDERFLOW_IILB_FIFO_VC2_PUSH" => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 push underflow" ],
   "UNDERFLOW_IILB_FIFO_VC0_PUSH" => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 push underflow" ],
   "UNDERFLOW_PI_FIFO_VC2_PUSH"   => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 push underflow" ],
   "UNDERFLOW_PI_FIFO_VC0_PUSH"   => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 push underflow" ],
   "UNDERFLOW_NI_FIFO_VC2_POP"    => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 pop underflow" ],
   "UNDERFLOW_NI_FIFO_VC0_POP"    => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 pop underflow" ],
   "UNDERFLOW_MD_FIFO_VC2_POP"    => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 pop underflow" ],
   "UNDERFLOW_MD_FIFO_VC0_POP"    => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 pop underflow" ],
   "UNDERFLOW_IILB_FIFO_VC2_POP"  => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 pop underflow" ],
   "UNDERFLOW_IILB_FIFO_VC0_POP"  => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 pop underflow" ],
   "UNDERFLOW_PI_FIFO_VC2_POP"    => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 pop underflow" ],
   "UNDERFLOW_PI_FIFO_VC0_POP"    => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 pop underflow" ],
   "RSVD1"                        => [  32,  22,  10, 0x00000000FFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW2_VC2_CREDIT"        => [  33,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "VC2 credit underflow 2" ],
   "UNDERFLOW1_VC2_CREDIT"        => [  34,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "VC2 credit underflow 1" ],
   "UNDERFLOW0_VC2_CREDIT"        => [  35,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "VC2 credit underflow 0" ],
   "UNDERFLOW2_VC0_CREDIT"        => [  36,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "VC0 credit underflow 2" ],
   "UNDERFLOW1_VC0_CREDIT"        => [  37,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VC0 credit underflow 1" ],
   "UNDERFLOW0_VC0_CREDIT"        => [  38,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VC0 credit underflow 0" ],
   "UNDERFLOW_FIFO13_VC2_CREDIT"  => [  39,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc2 credit underflow" ],
   "UNDERFLOW_FIFO13_VC0_CREDIT"  => [  40,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc0 credit underflow" ],
   "UNDERFLOW_FIFO02_VC2_CREDIT"  => [  41,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 credit underflow" ],
   "UNDERFLOW_FIFO02_VC0_CREDIT"  => [  42,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 credit underflow" ],
   "UNDERFLOW_FIFO13_VC3_PUSH"    => [  43,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 push underflow" ],
   "UNDERFLOW_FIFO13_VC1_PUSH"    => [  44,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 push underflow" ],
   "UNDERFLOW_FIFO02_VC2_PUSH"    => [  45,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 push underflow" ],
   "UNDERFLOW_FIFO02_VC0_PUSH"    => [  46,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 push underflow" ],
   "UNDERFLOW_FIFO13_VC3_POP"     => [  47,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 pop underflow" ],
   "UNDERFLOW_FIFO13_VC1_POP"     => [  48,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 pop underflow" ],
   "UNDERFLOW_FIFO02_VC2_POP"     => [  49,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 pop underflow" ],
   "UNDERFLOW_FIFO02_VC0_POP"     => [  50,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 pop underflow" ],
   "ILLEGAL_VCIILB"               => [  51,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Illegal VC IILB" ],
   "ILLEGAL_VCMD"                 => [  52,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Illegal VC MD" ],
   "ILLEGAL_VCPI"                 => [  53,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Illegal VC PI" ],
   "ILLEGAL_VCNI"                 => [  54,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Illegal VC NI" ],
);

%shub_01_00435_def =
( NAME    => "SH_NI1_ERROR_SUMMARY_2_ALIAS",
  ADDRESS => 0x0000000150040618,
  NOTE    => "ni1 Error Summary Bits Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00435_flds
);


##########################################################################
#                                                                        #
#   SH_NI1_ERROR_OVERFLOW_1                                              #
#                                                                        #
##########################################################################

%shub_01_00436_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TAIL_TIMEOUT_NI_VC3"          => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "NI vc3 tail timeout" ],
   "TAIL_TIMEOUT_NI_VC2"          => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "NI vc2 tail timeout" ],
   "TAIL_TIMEOUT_NI_VC1"          => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI vc1 tail timeout" ],
   "TAIL_TIMEOUT_NI_VC0"          => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI vc0 tail timeout" ],
   "TAIL_TIMEOUT_FIFO13_VC3"      => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Fifo13 vc3 tail timeout" ],
   "TAIL_TIMEOUT_FIFO13_VC1"      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "Fifo13 vc1 tail timeout" ],
   "TAIL_TIMEOUT_FIFO02_VC2"      => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "Fifo02 vc2 tail timeout" ],
   "TAIL_TIMEOUT_FIFO02_VC0"      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "Fifo02 vc0 tail timeout" ],
   "OVERFLOW_NI_FIFO_VC3_CREDIT"  => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc3 credit overflow" ],
   "OVERFLOW_NI_FIFO_VC2_CREDIT"  => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 credit overflow" ],
   "OVERFLOW_NI_FIFO_VC1_CREDIT"  => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc1 credit overflow" ],
   "OVERFLOW_NI_FIFO_VC0_CREDIT"  => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 credit overflow" ],
   "OVERFLOW_MD_FIFO_VC2_CREDIT"  => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 credit overflow" ],
   "OVERFLOW_MD_FIFO_VC0_CREDIT"  => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 credit overflow" ],
   "OVERFLOW_IILB_FIFO_VC2_CREDIT" => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 credit overflow" ],
   "OVERFLOW_IILB_FIFO_VC0_CREDIT" => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 credit overflow" ],
   "OVERFLOW_PI_FIFO_VC2_CREDIT"  => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 credit overflow" ],
   "OVERFLOW_PI_FIFO_VC0_CREDIT"  => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 credit overflow" ],
   "OVERFLOW_MD_FIFO_VC2_PUSH"    => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 push overflow" ],
   "OVERFLOW_MD_FIFO_VC0_PUSH"    => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 push overflow" ],
   "OVERFLOW_IILB_FIFO_VC2_PUSH"  => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 push overflow" ],
   "OVERFLOW_IILB_FIFO_VC0_PUSH"  => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 push overflow" ],
   "OVERFLOW_PI_FIFO_VC2_PUSH"    => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 push overflow" ],
   "OVERFLOW_PI_FIFO_VC0_PUSH"    => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 push overflow" ],
   "OVERFLOW_NI_FIFO_VC2_POP"     => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 pop overflow" ],
   "OVERFLOW_NI_FIFO_VC0_POP"     => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 pop overflow" ],
   "OVERFLOW_MD_FIFO_VC2_POP"     => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 pop overflow" ],
   "OVERFLOW_MD_FIFO_VC0_POP"     => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 pop overflow" ],
   "OVERFLOW_IILB_FIFO_VC2_POP"   => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 pop overflow" ],
   "OVERFLOW_IILB_FIFO_VC0_POP"   => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 pop overflow" ],
   "OVERFLOW_PI_FIFO_VC2_POP"     => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 pop overflow" ],
   "OVERFLOW_PI_FIFO_VC0_POP"     => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 pop overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT3"      => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit3 overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT2"      => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit2 overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT1"      => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit1 overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT0"      => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit0 overflow" ],
   "OVERFLOW_MD_FIFO_DEBIT2"      => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "MD Fifo debit2 overflow" ],
   "OVERFLOW_MD_FIFO_DEBIT0"      => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "MD Fifo debit0 overflow" ],
   "OVERFLOW_IILB_FIFO_DEBIT2"    => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "IILB Fifo debit2 overflow" ],
   "OVERFLOW_IILB_FIFO_DEBIT0"    => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "IILB Fifo debit0 overflow" ],
   "OVERFLOW_PI_FIFO_DEBIT2"      => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "PI Fifo debit2 overflow" ],
   "OVERFLOW_PI_FIFO_DEBIT0"      => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "PI Fifo debit0 overflow" ],
   "OVERFLOW2_VC2_CREDIT"         => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "VC2 credit overflow 2" ],
   "OVERFLOW1_VC2_CREDIT"         => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "VC2 credit overflow 1" ],
   "OVERFLOW0_VC2_CREDIT"         => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "VC2 credit overflow 0" ],
   "OVERFLOW2_VC0_CREDIT"         => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "VC0 credit overflow 2" ],
   "OVERFLOW1_VC0_CREDIT"         => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VC0 credit overflow 1" ],
   "OVERFLOW0_VC0_CREDIT"         => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VC0 credit overflow 0" ],
   "OVERFLOW_FIFO13_VC2_CREDIT"   => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc2 credit overflow" ],
   "OVERFLOW_FIFO13_VC0_CREDIT"   => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc0 credit overflow" ],
   "OVERFLOW_FIFO02_VC2_CREDIT"   => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 credit overflow" ],
   "OVERFLOW_FIFO02_VC0_CREDIT"   => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 credit overflow" ],
   "OVERFLOW_FIFO13_VC3_PUSH"     => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 push overflow" ],
   "OVERFLOW_FIFO13_VC1_PUSH"     => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 push overflow" ],
   "OVERFLOW_FIFO02_VC2_PUSH"     => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 push overflow" ],
   "OVERFLOW_FIFO02_VC0_PUSH"     => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 push overflow" ],
   "OVERFLOW_FIFO13_VC3_POP"      => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 pop overflow" ],
   "OVERFLOW_FIFO13_VC1_POP"      => [  57,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 pop overflow" ],
   "OVERFLOW_FIFO02_VC2_POP"      => [  58,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 pop overflow" ],
   "OVERFLOW_FIFO02_VC0_POP"      => [  59,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 pop overflow" ],
   "OVERFLOW_FIFO13_DEBIT2"       => [  60,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Fifo 13 debit2 overflow" ],
   "OVERFLOW_FIFO13_DEBIT0"       => [  61,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Fifo 13 debit0 overflow" ],
   "OVERFLOW_FIFO02_DEBIT2"       => [  62,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Fifo 02 debit2 overflow" ],
   "OVERFLOW_FIFO02_DEBIT0"       => [  63,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Fifo 02 debit0 overflow" ],
);

%shub_01_00436_def =
( NAME    => "SH_NI1_ERROR_OVERFLOW_1",
  ADDRESS => 0x0000000150040620,
  NOTE    => "ni1 Error Overflow Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00436_flds
);


##########################################################################
#                                                                        #
#   SH_NI1_ERROR_OVERFLOW_1_ALIAS                                        #
#                                                                        #
##########################################################################

%shub_01_00437_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TAIL_TIMEOUT_NI_VC3"          => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "NI vc3 tail timeout" ],
   "TAIL_TIMEOUT_NI_VC2"          => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "NI vc2 tail timeout" ],
   "TAIL_TIMEOUT_NI_VC1"          => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI vc1 tail timeout" ],
   "TAIL_TIMEOUT_NI_VC0"          => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI vc0 tail timeout" ],
   "TAIL_TIMEOUT_FIFO13_VC3"      => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Fifo13 vc3 tail timeout" ],
   "TAIL_TIMEOUT_FIFO13_VC1"      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "Fifo13 vc1 tail timeout" ],
   "TAIL_TIMEOUT_FIFO02_VC2"      => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "Fifo02 vc2 tail timeout" ],
   "TAIL_TIMEOUT_FIFO02_VC0"      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "Fifo02 vc0 tail timeout" ],
   "OVERFLOW_NI_FIFO_VC3_CREDIT"  => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc3 credit overflow" ],
   "OVERFLOW_NI_FIFO_VC2_CREDIT"  => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 credit overflow" ],
   "OVERFLOW_NI_FIFO_VC1_CREDIT"  => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc1 credit overflow" ],
   "OVERFLOW_NI_FIFO_VC0_CREDIT"  => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 credit overflow" ],
   "OVERFLOW_MD_FIFO_VC2_CREDIT"  => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 credit overflow" ],
   "OVERFLOW_MD_FIFO_VC0_CREDIT"  => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 credit overflow" ],
   "OVERFLOW_IILB_FIFO_VC2_CREDIT" => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 credit overflow" ],
   "OVERFLOW_IILB_FIFO_VC0_CREDIT" => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 credit overflow" ],
   "OVERFLOW_PI_FIFO_VC2_CREDIT"  => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 credit overflow" ],
   "OVERFLOW_PI_FIFO_VC0_CREDIT"  => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 credit overflow" ],
   "OVERFLOW_MD_FIFO_VC2_PUSH"    => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 push overflow" ],
   "OVERFLOW_MD_FIFO_VC0_PUSH"    => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 push overflow" ],
   "OVERFLOW_IILB_FIFO_VC2_PUSH"  => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 push overflow" ],
   "OVERFLOW_IILB_FIFO_VC0_PUSH"  => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 push overflow" ],
   "OVERFLOW_PI_FIFO_VC2_PUSH"    => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 push overflow" ],
   "OVERFLOW_PI_FIFO_VC0_PUSH"    => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 push overflow" ],
   "OVERFLOW_NI_FIFO_VC2_POP"     => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 pop overflow" ],
   "OVERFLOW_NI_FIFO_VC0_POP"     => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 pop overflow" ],
   "OVERFLOW_MD_FIFO_VC2_POP"     => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 pop overflow" ],
   "OVERFLOW_MD_FIFO_VC0_POP"     => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 pop overflow" ],
   "OVERFLOW_IILB_FIFO_VC2_POP"   => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 pop overflow" ],
   "OVERFLOW_IILB_FIFO_VC0_POP"   => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 pop overflow" ],
   "OVERFLOW_PI_FIFO_VC2_POP"     => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 pop overflow" ],
   "OVERFLOW_PI_FIFO_VC0_POP"     => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 pop overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT3"      => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit3 overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT2"      => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit2 overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT1"      => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit1 overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT0"      => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit0 overflow" ],
   "OVERFLOW_MD_FIFO_DEBIT2"      => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "MD Fifo debit2 overflow" ],
   "OVERFLOW_MD_FIFO_DEBIT0"      => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "MD Fifo debit0 overflow" ],
   "OVERFLOW_IILB_FIFO_DEBIT2"    => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "IILB Fifo debit2 overflow" ],
   "OVERFLOW_IILB_FIFO_DEBIT0"    => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "IILB Fifo debit0 overflow" ],
   "OVERFLOW_PI_FIFO_DEBIT2"      => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "PI Fifo debit2 overflow" ],
   "OVERFLOW_PI_FIFO_DEBIT0"      => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "PI Fifo debit0 overflow" ],
   "OVERFLOW2_VC2_CREDIT"         => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "VC2 credit overflow 2" ],
   "OVERFLOW1_VC2_CREDIT"         => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "VC2 credit overflow 1" ],
   "OVERFLOW0_VC2_CREDIT"         => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "VC2 credit overflow 0" ],
   "OVERFLOW2_VC0_CREDIT"         => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "VC0 credit overflow 2" ],
   "OVERFLOW1_VC0_CREDIT"         => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VC0 credit overflow 1" ],
   "OVERFLOW0_VC0_CREDIT"         => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VC0 credit overflow 0" ],
   "OVERFLOW_FIFO13_VC2_CREDIT"   => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc2 credit overflow" ],
   "OVERFLOW_FIFO13_VC0_CREDIT"   => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc0 credit overflow" ],
   "OVERFLOW_FIFO02_VC2_CREDIT"   => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 credit overflow" ],
   "OVERFLOW_FIFO02_VC0_CREDIT"   => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 credit overflow" ],
   "OVERFLOW_FIFO13_VC3_PUSH"     => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 push overflow" ],
   "OVERFLOW_FIFO13_VC1_PUSH"     => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 push overflow" ],
   "OVERFLOW_FIFO02_VC2_PUSH"     => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 push overflow" ],
   "OVERFLOW_FIFO02_VC0_PUSH"     => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 push overflow" ],
   "OVERFLOW_FIFO13_VC3_POP"      => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 pop overflow" ],
   "OVERFLOW_FIFO13_VC1_POP"      => [  57,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 pop overflow" ],
   "OVERFLOW_FIFO02_VC2_POP"      => [  58,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 pop overflow" ],
   "OVERFLOW_FIFO02_VC0_POP"      => [  59,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 pop overflow" ],
   "OVERFLOW_FIFO13_DEBIT2"       => [  60,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Fifo 13 debit2 overflow" ],
   "OVERFLOW_FIFO13_DEBIT0"       => [  61,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Fifo 13 debit0 overflow" ],
   "OVERFLOW_FIFO02_DEBIT2"       => [  62,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Fifo 02 debit2 overflow" ],
   "OVERFLOW_FIFO02_DEBIT0"       => [  63,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Fifo 02 debit0 overflow" ],
);

%shub_01_00437_def =
( NAME    => "SH_NI1_ERROR_OVERFLOW_1_ALIAS",
  ADDRESS => 0x0000000150040628,
  NOTE    => "ni1 Error Overflow Bits Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00437_flds
);


##########################################################################
#                                                                        #
#   SH_NI1_ERROR_OVERFLOW_2                                              #
#                                                                        #
##########################################################################

%shub_01_00438_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RETRY_TIMEOUT_ERROR"          => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "LLP_DEADLOCK_VC3"             => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
   "UNDERFLOW_NI_FIFO_VC3_CREDIT" => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc3 credit underflow" ],
   "UNDERFLOW_NI_FIFO_VC2_CREDIT" => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 credit underflow" ],
   "UNDERFLOW_NI_FIFO_VC1_CREDIT" => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc1 credit underflow" ],
   "UNDERFLOW_NI_FIFO_VC0_CREDIT" => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 credit underflow" ],
   "UNDERFLOW_MD_FIFO_VC2_CREDIT" => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 credit underflow" ],
   "UNDERFLOW_MD_FIFO_VC0_CREDIT" => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 credit underflow" ],
   "UNDERFLOW_IILB_FIFO_VC2_CREDIT" => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 credit underflow" ],
   "UNDERFLOW_IILB_FIFO_VC0_CREDIT" => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 credit underflow" ],
   "UNDERFLOW_PI_FIFO_VC2_CREDIT" => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 credit underflow" ],
   "UNDERFLOW_PI_FIFO_VC0_CREDIT" => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 credit underflow" ],
   "UNDERFLOW_MD_FIFO_VC2_PUSH"   => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 push underflow" ],
   "UNDERFLOW_MD_FIFO_VC0_PUSH"   => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 push underflow" ],
   "UNDERFLOW_IILB_FIFO_VC2_PUSH" => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 push underflow" ],
   "UNDERFLOW_IILB_FIFO_VC0_PUSH" => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 push underflow" ],
   "UNDERFLOW_PI_FIFO_VC2_PUSH"   => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 push underflow" ],
   "UNDERFLOW_PI_FIFO_VC0_PUSH"   => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 push underflow" ],
   "UNDERFLOW_NI_FIFO_VC2_POP"    => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 pop underflow" ],
   "UNDERFLOW_NI_FIFO_VC0_POP"    => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 pop underflow" ],
   "UNDERFLOW_MD_FIFO_VC2_POP"    => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 pop underflow" ],
   "UNDERFLOW_MD_FIFO_VC0_POP"    => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 pop underflow" ],
   "UNDERFLOW_IILB_FIFO_VC2_POP"  => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 pop underflow" ],
   "UNDERFLOW_IILB_FIFO_VC0_POP"  => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 pop underflow" ],
   "UNDERFLOW_PI_FIFO_VC2_POP"    => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 pop underflow" ],
   "UNDERFLOW_PI_FIFO_VC0_POP"    => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 pop underflow" ],
   "RSVD1"                        => [  32,  22,  10, 0x00000000FFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW2_VC2_CREDIT"        => [  33,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "VC2 credit underflow 2" ],
   "UNDERFLOW1_VC2_CREDIT"        => [  34,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "VC2 credit underflow 1" ],
   "UNDERFLOW0_VC2_CREDIT"        => [  35,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "VC2 credit underflow 0" ],
   "UNDERFLOW2_VC0_CREDIT"        => [  36,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "VC0 credit underflow 2" ],
   "UNDERFLOW1_VC0_CREDIT"        => [  37,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VC0 credit underflow 1" ],
   "UNDERFLOW0_VC0_CREDIT"        => [  38,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VC0 credit underflow 0" ],
   "UNDERFLOW_FIFO13_VC2_CREDIT"  => [  39,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc2 credit underflow" ],
   "UNDERFLOW_FIFO13_VC0_CREDIT"  => [  40,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc0 credit underflow" ],
   "UNDERFLOW_FIFO02_VC2_CREDIT"  => [  41,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 credit underflow" ],
   "UNDERFLOW_FIFO02_VC0_CREDIT"  => [  42,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 credit underflow" ],
   "UNDERFLOW_FIFO13_VC3_PUSH"    => [  43,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 push underflow" ],
   "UNDERFLOW_FIFO13_VC1_PUSH"    => [  44,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 push underflow" ],
   "UNDERFLOW_FIFO02_VC2_PUSH"    => [  45,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 push underflow" ],
   "UNDERFLOW_FIFO02_VC0_PUSH"    => [  46,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 push underflow" ],
   "UNDERFLOW_FIFO13_VC3_POP"     => [  47,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 pop underflow" ],
   "UNDERFLOW_FIFO13_VC1_POP"     => [  48,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 pop underflow" ],
   "UNDERFLOW_FIFO02_VC2_POP"     => [  49,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 pop underflow" ],
   "UNDERFLOW_FIFO02_VC0_POP"     => [  50,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 pop underflow" ],
   "ILLEGAL_VCIILB"               => [  51,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Illegal VC IILB" ],
   "ILLEGAL_VCMD"                 => [  52,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Illegal VC MD" ],
   "ILLEGAL_VCPI"                 => [  53,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Illegal VC PI" ],
   "ILLEGAL_VCNI"                 => [  54,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Illegal VC NI" ],
);

%shub_01_00438_def =
( NAME    => "SH_NI1_ERROR_OVERFLOW_2",
  ADDRESS => 0x0000000150040630,
  NOTE    => "ni1 Error Overflow Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00438_flds
);


##########################################################################
#                                                                        #
#   SH_NI1_ERROR_OVERFLOW_2_ALIAS                                        #
#                                                                        #
##########################################################################

%shub_01_00439_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RETRY_TIMEOUT_ERROR"          => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "LLP_DEADLOCK_VC3"             => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
   "UNDERFLOW_NI_FIFO_VC3_CREDIT" => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc3 credit underflow" ],
   "UNDERFLOW_NI_FIFO_VC2_CREDIT" => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 credit underflow" ],
   "UNDERFLOW_NI_FIFO_VC1_CREDIT" => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc1 credit underflow" ],
   "UNDERFLOW_NI_FIFO_VC0_CREDIT" => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 credit underflow" ],
   "UNDERFLOW_MD_FIFO_VC2_CREDIT" => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 credit underflow" ],
   "UNDERFLOW_MD_FIFO_VC0_CREDIT" => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 credit underflow" ],
   "UNDERFLOW_IILB_FIFO_VC2_CREDIT" => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 credit underflow" ],
   "UNDERFLOW_IILB_FIFO_VC0_CREDIT" => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 credit underflow" ],
   "UNDERFLOW_PI_FIFO_VC2_CREDIT" => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 credit underflow" ],
   "UNDERFLOW_PI_FIFO_VC0_CREDIT" => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 credit underflow" ],
   "UNDERFLOW_MD_FIFO_VC2_PUSH"   => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 push underflow" ],
   "UNDERFLOW_MD_FIFO_VC0_PUSH"   => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 push underflow" ],
   "UNDERFLOW_IILB_FIFO_VC2_PUSH" => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 push underflow" ],
   "UNDERFLOW_IILB_FIFO_VC0_PUSH" => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 push underflow" ],
   "UNDERFLOW_PI_FIFO_VC2_PUSH"   => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 push underflow" ],
   "UNDERFLOW_PI_FIFO_VC0_PUSH"   => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 push underflow" ],
   "UNDERFLOW_NI_FIFO_VC2_POP"    => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 pop underflow" ],
   "UNDERFLOW_NI_FIFO_VC0_POP"    => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 pop underflow" ],
   "UNDERFLOW_MD_FIFO_VC2_POP"    => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 pop underflow" ],
   "UNDERFLOW_MD_FIFO_VC0_POP"    => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 pop underflow" ],
   "UNDERFLOW_IILB_FIFO_VC2_POP"  => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 pop underflow" ],
   "UNDERFLOW_IILB_FIFO_VC0_POP"  => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 pop underflow" ],
   "UNDERFLOW_PI_FIFO_VC2_POP"    => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 pop underflow" ],
   "UNDERFLOW_PI_FIFO_VC0_POP"    => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 pop underflow" ],
   "RSVD1"                        => [  32,  22,  10, 0x00000000FFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW2_VC2_CREDIT"        => [  33,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "VC2 credit underflow 2" ],
   "UNDERFLOW1_VC2_CREDIT"        => [  34,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "VC2 credit underflow 1" ],
   "UNDERFLOW0_VC2_CREDIT"        => [  35,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "VC2 credit underflow 0" ],
   "UNDERFLOW2_VC0_CREDIT"        => [  36,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "VC0 credit underflow 2" ],
   "UNDERFLOW1_VC0_CREDIT"        => [  37,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VC0 credit underflow 1" ],
   "UNDERFLOW0_VC0_CREDIT"        => [  38,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VC0 credit underflow 0" ],
   "UNDERFLOW_FIFO13_VC2_CREDIT"  => [  39,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc2 credit underflow" ],
   "UNDERFLOW_FIFO13_VC0_CREDIT"  => [  40,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc0 credit underflow" ],
   "UNDERFLOW_FIFO02_VC2_CREDIT"  => [  41,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 credit underflow" ],
   "UNDERFLOW_FIFO02_VC0_CREDIT"  => [  42,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 credit underflow" ],
   "UNDERFLOW_FIFO13_VC3_PUSH"    => [  43,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 push underflow" ],
   "UNDERFLOW_FIFO13_VC1_PUSH"    => [  44,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 push underflow" ],
   "UNDERFLOW_FIFO02_VC2_PUSH"    => [  45,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 push underflow" ],
   "UNDERFLOW_FIFO02_VC0_PUSH"    => [  46,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 push underflow" ],
   "UNDERFLOW_FIFO13_VC3_POP"     => [  47,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 pop underflow" ],
   "UNDERFLOW_FIFO13_VC1_POP"     => [  48,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 pop underflow" ],
   "UNDERFLOW_FIFO02_VC2_POP"     => [  49,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 pop underflow" ],
   "UNDERFLOW_FIFO02_VC0_POP"     => [  50,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 pop underflow" ],
   "ILLEGAL_VCIILB"               => [  51,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Illegal VC IILB" ],
   "ILLEGAL_VCMD"                 => [  52,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Illegal VC MD" ],
   "ILLEGAL_VCPI"                 => [  53,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Illegal VC PI" ],
   "ILLEGAL_VCNI"                 => [  54,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Illegal VC NI" ],
);

%shub_01_00439_def =
( NAME    => "SH_NI1_ERROR_OVERFLOW_2_ALIAS",
  ADDRESS => 0x0000000150040638,
  NOTE    => "ni1 Error Overflow Bits Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00439_flds
);


##########################################################################
#                                                                        #
#   SH_NI1_ERROR_MASK_1                                                  #
#                                                                        #
##########################################################################

%shub_01_00440_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TAIL_TIMEOUT_NI_VC3"          => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "NI vc3 tail timeout" ],
   "TAIL_TIMEOUT_NI_VC2"          => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "NI vc2 tail timeout" ],
   "TAIL_TIMEOUT_NI_VC1"          => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "NI vc1 tail timeout" ],
   "TAIL_TIMEOUT_NI_VC0"          => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "NI vc0 tail timeout" ],
   "TAIL_TIMEOUT_FIFO13_VC3"      => [   4,  59,   1, 0x0800000000000000, 0x00, 1, 0x0000000000000000, "Fifo13 vc3 tail timeout" ],
   "TAIL_TIMEOUT_FIFO13_VC1"      => [   5,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "Fifo13 vc1 tail timeout" ],
   "TAIL_TIMEOUT_FIFO02_VC2"      => [   6,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "Fifo02 vc2 tail timeout" ],
   "TAIL_TIMEOUT_FIFO02_VC0"      => [   7,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "Fifo02 vc0 tail timeout" ],
   "OVERFLOW_NI_FIFO_VC3_CREDIT"  => [   8,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "NI Fifo vc3 credit overflow" ],
   "OVERFLOW_NI_FIFO_VC2_CREDIT"  => [   9,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "NI Fifo vc2 credit overflow" ],
   "OVERFLOW_NI_FIFO_VC1_CREDIT"  => [  10,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "NI Fifo vc1 credit overflow" ],
   "OVERFLOW_NI_FIFO_VC0_CREDIT"  => [  11,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "NI Fifo vc0 credit overflow" ],
   "OVERFLOW_MD_FIFO_VC2_CREDIT"  => [  12,  51,   1, 0x0008000000000000, 0x00, 1, 0x0000000000000000, "MD Fifo vc2 credit overflow" ],
   "OVERFLOW_MD_FIFO_VC0_CREDIT"  => [  13,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "MD Fifo vc0 credit overflow" ],
   "OVERFLOW_IILB_FIFO_VC2_CREDIT" => [  14,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "IILB Fifo vc2 credit overflow" ],
   "OVERFLOW_IILB_FIFO_VC0_CREDIT" => [  15,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "IILB Fifo vc0 credit overflow" ],
   "OVERFLOW_PI_FIFO_VC2_CREDIT"  => [  16,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "PI Fifo vc2 credit overflow" ],
   "OVERFLOW_PI_FIFO_VC0_CREDIT"  => [  17,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "PI Fifo vc0 credit overflow" ],
   "OVERFLOW_MD_FIFO_VC2_PUSH"    => [  18,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "MD Fifo vc2 push overflow" ],
   "OVERFLOW_MD_FIFO_VC0_PUSH"    => [  19,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "MD Fifo vc0 push overflow" ],
   "OVERFLOW_IILB_FIFO_VC2_PUSH"  => [  20,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "IILB Fifo vc2 push overflow" ],
   "OVERFLOW_IILB_FIFO_VC0_PUSH"  => [  21,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "IILB Fifo vc0 push overflow" ],
   "OVERFLOW_PI_FIFO_VC2_PUSH"    => [  22,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "PI Fifo vc2 push overflow" ],
   "OVERFLOW_PI_FIFO_VC0_PUSH"    => [  23,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "PI Fifo vc0 push overflow" ],
   "OVERFLOW_NI_FIFO_VC2_POP"     => [  24,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "NI Fifo vc2 pop overflow" ],
   "OVERFLOW_NI_FIFO_VC0_POP"     => [  25,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "NI Fifo vc0 pop overflow" ],
   "OVERFLOW_MD_FIFO_VC2_POP"     => [  26,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "MD Fifo vc2 pop overflow" ],
   "OVERFLOW_MD_FIFO_VC0_POP"     => [  27,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "MD Fifo vc0 pop overflow" ],
   "OVERFLOW_IILB_FIFO_VC2_POP"   => [  28,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "IILB Fifo vc2 pop overflow" ],
   "OVERFLOW_IILB_FIFO_VC0_POP"   => [  29,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "IILB Fifo vc0 pop overflow" ],
   "OVERFLOW_PI_FIFO_VC2_POP"     => [  30,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "PI Fifo vc2 pop overflow" ],
   "OVERFLOW_PI_FIFO_VC0_POP"     => [  31,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "PI Fifo vc0 pop overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT3"      => [  32,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "NI Fifo debit3 overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT2"      => [  33,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "NI Fifo debit2 overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT1"      => [  34,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "NI Fifo debit1 overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT0"      => [  35,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "NI Fifo debit0 overflow" ],
   "OVERFLOW_MD_FIFO_DEBIT2"      => [  36,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "MD Fifo debit2 overflow" ],
   "OVERFLOW_MD_FIFO_DEBIT0"      => [  37,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "MD Fifo debit0 overflow" ],
   "OVERFLOW_IILB_FIFO_DEBIT2"    => [  38,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "IILB Fifo debit2 overflow" ],
   "OVERFLOW_IILB_FIFO_DEBIT0"    => [  39,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "IILB Fifo debit0 overflow" ],
   "OVERFLOW_PI_FIFO_DEBIT2"      => [  40,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "PI Fifo debit2 overflow" ],
   "OVERFLOW_PI_FIFO_DEBIT0"      => [  41,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "PI Fifo debit0 overflow" ],
   "OVERFLOW2_VC2_CREDIT"         => [  42,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "VC2 credit overflow 2" ],
   "OVERFLOW1_VC2_CREDIT"         => [  43,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "VC2 credit overflow 1" ],
   "OVERFLOW0_VC2_CREDIT"         => [  44,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "VC2 credit overflow 0" ],
   "OVERFLOW2_VC0_CREDIT"         => [  45,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "VC0 credit overflow 2" ],
   "OVERFLOW1_VC0_CREDIT"         => [  46,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "VC0 credit overflow 1" ],
   "OVERFLOW0_VC0_CREDIT"         => [  47,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "VC0 credit overflow 0" ],
   "OVERFLOW_FIFO13_VC2_CREDIT"   => [  48,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Fifo 13 vc2 credit overflow" ],
   "OVERFLOW_FIFO13_VC0_CREDIT"   => [  49,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Fifo 13 vc0 credit overflow" ],
   "OVERFLOW_FIFO02_VC2_CREDIT"   => [  50,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Fifo 02 vc2 credit overflow" ],
   "OVERFLOW_FIFO02_VC0_CREDIT"   => [  51,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Fifo 02 vc0 credit overflow" ],
   "OVERFLOW_FIFO13_VC3_PUSH"     => [  52,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "Fifo 13 vc3 push overflow" ],
   "OVERFLOW_FIFO13_VC1_PUSH"     => [  53,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "Fifo 13 vc1 push overflow" ],
   "OVERFLOW_FIFO02_VC2_PUSH"     => [  54,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Fifo 02 vc2 push overflow" ],
   "OVERFLOW_FIFO02_VC0_PUSH"     => [  55,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Fifo 02 vc0 push overflow" ],
   "OVERFLOW_FIFO13_VC3_POP"      => [  56,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Fifo 13 vc3 pop overflow" ],
   "OVERFLOW_FIFO13_VC1_POP"      => [  57,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Fifo 13 vc1 pop overflow" ],
   "OVERFLOW_FIFO02_VC2_POP"      => [  58,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Fifo 02 vc2 pop overflow" ],
   "OVERFLOW_FIFO02_VC0_POP"      => [  59,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Fifo 02 vc0 pop overflow" ],
   "OVERFLOW_FIFO13_DEBIT2"       => [  60,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Fifo 13 debit2 overflow" ],
   "OVERFLOW_FIFO13_DEBIT0"       => [  61,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Fifo 13 debit0 overflow" ],
   "OVERFLOW_FIFO02_DEBIT2"       => [  62,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Fifo 02 debit2 overflow" ],
   "OVERFLOW_FIFO02_DEBIT0"       => [  63,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Fifo 02 debit0 overflow" ],
);

%shub_01_00440_def =
( NAME    => "SH_NI1_ERROR_MASK_1",
  ADDRESS => 0x0000000150040640,
  NOTE    => "ni1 Error Mask Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00440_flds
);


##########################################################################
#                                                                        #
#   SH_NI1_ERROR_MASK_2                                                  #
#                                                                        #
##########################################################################

%shub_01_00441_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RETRY_TIMEOUT_ERROR"          => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "chiplet nomatch" ],
   "LLP_DEADLOCK_VC3"             => [   4,  59,   1, 0x0800000000000000, 0x00, 1, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [   5,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [   6,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [   7,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "llp deadlock vc0" ],
   "UNDERFLOW_NI_FIFO_VC3_CREDIT" => [   8,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "NI Fifo vc3 credit underflow" ],
   "UNDERFLOW_NI_FIFO_VC2_CREDIT" => [   9,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "NI Fifo vc2 credit underflow" ],
   "UNDERFLOW_NI_FIFO_VC1_CREDIT" => [  10,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "NI Fifo vc1 credit underflow" ],
   "UNDERFLOW_NI_FIFO_VC0_CREDIT" => [  11,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "NI Fifo vc0 credit underflow" ],
   "UNDERFLOW_MD_FIFO_VC2_CREDIT" => [  12,  51,   1, 0x0008000000000000, 0x00, 1, 0x0000000000000000, "MD Fifo vc2 credit underflow" ],
   "UNDERFLOW_MD_FIFO_VC0_CREDIT" => [  13,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "MD Fifo vc0 credit underflow" ],
   "UNDERFLOW_IILB_FIFO_VC2_CREDIT" => [  14,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "IILB Fifo vc2 credit underflow" ],
   "UNDERFLOW_IILB_FIFO_VC0_CREDIT" => [  15,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "IILB Fifo vc0 credit underflow" ],
   "UNDERFLOW_PI_FIFO_VC2_CREDIT" => [  16,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "PI Fifo vc2 credit underflow" ],
   "UNDERFLOW_PI_FIFO_VC0_CREDIT" => [  17,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "PI Fifo vc0 credit underflow" ],
   "UNDERFLOW_MD_FIFO_VC2_PUSH"   => [  18,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "MD Fifo vc2 push underflow" ],
   "UNDERFLOW_MD_FIFO_VC0_PUSH"   => [  19,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "MD Fifo vc0 push underflow" ],
   "UNDERFLOW_IILB_FIFO_VC2_PUSH" => [  20,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "IILB Fifo vc2 push underflow" ],
   "UNDERFLOW_IILB_FIFO_VC0_PUSH" => [  21,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "IILB Fifo vc0 push underflow" ],
   "UNDERFLOW_PI_FIFO_VC2_PUSH"   => [  22,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "PI Fifo vc2 push underflow" ],
   "UNDERFLOW_PI_FIFO_VC0_PUSH"   => [  23,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "PI Fifo vc0 push underflow" ],
   "UNDERFLOW_NI_FIFO_VC2_POP"    => [  24,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "NI Fifo vc2 pop underflow" ],
   "UNDERFLOW_NI_FIFO_VC0_POP"    => [  25,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "NI Fifo vc0 pop underflow" ],
   "UNDERFLOW_MD_FIFO_VC2_POP"    => [  26,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "MD Fifo vc2 pop underflow" ],
   "UNDERFLOW_MD_FIFO_VC0_POP"    => [  27,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "MD Fifo vc0 pop underflow" ],
   "UNDERFLOW_IILB_FIFO_VC2_POP"  => [  28,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "IILB Fifo vc2 pop underflow" ],
   "UNDERFLOW_IILB_FIFO_VC0_POP"  => [  29,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "IILB Fifo vc0 pop underflow" ],
   "UNDERFLOW_PI_FIFO_VC2_POP"    => [  30,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "PI Fifo vc2 pop underflow" ],
   "UNDERFLOW_PI_FIFO_VC0_POP"    => [  31,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "PI Fifo vc0 pop underflow" ],
   "RSVD1"                        => [  32,  22,  10, 0x00000000FFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW2_VC2_CREDIT"        => [  33,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "VC2 credit underflow 2" ],
   "UNDERFLOW1_VC2_CREDIT"        => [  34,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "VC2 credit underflow 1" ],
   "UNDERFLOW0_VC2_CREDIT"        => [  35,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "VC2 credit underflow 0" ],
   "UNDERFLOW2_VC0_CREDIT"        => [  36,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "VC0 credit underflow 2" ],
   "UNDERFLOW1_VC0_CREDIT"        => [  37,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "VC0 credit underflow 1" ],
   "UNDERFLOW0_VC0_CREDIT"        => [  38,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "VC0 credit underflow 0" ],
   "UNDERFLOW_FIFO13_VC2_CREDIT"  => [  39,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Fifo 13 vc2 credit underflow" ],
   "UNDERFLOW_FIFO13_VC0_CREDIT"  => [  40,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Fifo 13 vc0 credit underflow" ],
   "UNDERFLOW_FIFO02_VC2_CREDIT"  => [  41,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Fifo 02 vc2 credit underflow" ],
   "UNDERFLOW_FIFO02_VC0_CREDIT"  => [  42,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Fifo 02 vc0 credit underflow" ],
   "UNDERFLOW_FIFO13_VC3_PUSH"    => [  43,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "Fifo 13 vc3 push underflow" ],
   "UNDERFLOW_FIFO13_VC1_PUSH"    => [  44,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "Fifo 13 vc1 push underflow" ],
   "UNDERFLOW_FIFO02_VC2_PUSH"    => [  45,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Fifo 02 vc2 push underflow" ],
   "UNDERFLOW_FIFO02_VC0_PUSH"    => [  46,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Fifo 02 vc0 push underflow" ],
   "UNDERFLOW_FIFO13_VC3_POP"     => [  47,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Fifo 13 vc3 pop underflow" ],
   "UNDERFLOW_FIFO13_VC1_POP"     => [  48,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Fifo 13 vc1 pop underflow" ],
   "UNDERFLOW_FIFO02_VC2_POP"     => [  49,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Fifo 02 vc2 pop underflow" ],
   "UNDERFLOW_FIFO02_VC0_POP"     => [  50,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Fifo 02 vc0 pop underflow" ],
   "ILLEGAL_VCIILB"               => [  51,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Illegal VC IILB" ],
   "ILLEGAL_VCMD"                 => [  52,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Illegal VC MD" ],
   "ILLEGAL_VCPI"                 => [  53,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Illegal VC PI" ],
   "ILLEGAL_VCNI"                 => [  54,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Illegal VC NI" ],
);

%shub_01_00441_def =
( NAME    => "SH_NI1_ERROR_MASK_2",
  ADDRESS => 0x0000000150040650,
  NOTE    => "ni1 Error Mask Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00441_flds
);


##########################################################################
#                                                                        #
#   SH_NI1_FIRST_ERROR_1                                                 #
#                                                                        #
##########################################################################

%shub_01_00442_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TAIL_TIMEOUT_NI_VC3"          => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "NI vc3 tail timeout" ],
   "TAIL_TIMEOUT_NI_VC2"          => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "NI vc2 tail timeout" ],
   "TAIL_TIMEOUT_NI_VC1"          => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI vc1 tail timeout" ],
   "TAIL_TIMEOUT_NI_VC0"          => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI vc0 tail timeout" ],
   "TAIL_TIMEOUT_FIFO13_VC3"      => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Fifo13 vc3 tail timeout" ],
   "TAIL_TIMEOUT_FIFO13_VC1"      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "Fifo13 vc1 tail timeout" ],
   "TAIL_TIMEOUT_FIFO02_VC2"      => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "Fifo02 vc2 tail timeout" ],
   "TAIL_TIMEOUT_FIFO02_VC0"      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "Fifo02 vc0 tail timeout" ],
   "OVERFLOW_NI_FIFO_VC3_CREDIT"  => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc3 credit overflow" ],
   "OVERFLOW_NI_FIFO_VC2_CREDIT"  => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 credit overflow" ],
   "OVERFLOW_NI_FIFO_VC1_CREDIT"  => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc1 credit overflow" ],
   "OVERFLOW_NI_FIFO_VC0_CREDIT"  => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 credit overflow" ],
   "OVERFLOW_MD_FIFO_VC2_CREDIT"  => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 credit overflow" ],
   "OVERFLOW_MD_FIFO_VC0_CREDIT"  => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 credit overflow" ],
   "OVERFLOW_IILB_FIFO_VC2_CREDIT" => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 credit overflow" ],
   "OVERFLOW_IILB_FIFO_VC0_CREDIT" => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 credit overflow" ],
   "OVERFLOW_PI_FIFO_VC2_CREDIT"  => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 credit overflow" ],
   "OVERFLOW_PI_FIFO_VC0_CREDIT"  => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 credit overflow" ],
   "OVERFLOW_MD_FIFO_VC2_PUSH"    => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 push overflow" ],
   "OVERFLOW_MD_FIFO_VC0_PUSH"    => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 push overflow" ],
   "OVERFLOW_IILB_FIFO_VC2_PUSH"  => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 push overflow" ],
   "OVERFLOW_IILB_FIFO_VC0_PUSH"  => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 push overflow" ],
   "OVERFLOW_PI_FIFO_VC2_PUSH"    => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 push overflow" ],
   "OVERFLOW_PI_FIFO_VC0_PUSH"    => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 push overflow" ],
   "OVERFLOW_NI_FIFO_VC2_POP"     => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 pop overflow" ],
   "OVERFLOW_NI_FIFO_VC0_POP"     => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 pop overflow" ],
   "OVERFLOW_MD_FIFO_VC2_POP"     => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 pop overflow" ],
   "OVERFLOW_MD_FIFO_VC0_POP"     => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 pop overflow" ],
   "OVERFLOW_IILB_FIFO_VC2_POP"   => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 pop overflow" ],
   "OVERFLOW_IILB_FIFO_VC0_POP"   => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 pop overflow" ],
   "OVERFLOW_PI_FIFO_VC2_POP"     => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 pop overflow" ],
   "OVERFLOW_PI_FIFO_VC0_POP"     => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 pop overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT3"      => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit3 overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT2"      => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit2 overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT1"      => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit1 overflow" ],
   "OVERFLOW_NI_FIFO_DEBIT0"      => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI Fifo debit0 overflow" ],
   "OVERFLOW_MD_FIFO_DEBIT2"      => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "MD Fifo debit2 overflow" ],
   "OVERFLOW_MD_FIFO_DEBIT0"      => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "MD Fifo debit0 overflow" ],
   "OVERFLOW_IILB_FIFO_DEBIT2"    => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "IILB Fifo debit2 overflow" ],
   "OVERFLOW_IILB_FIFO_DEBIT0"    => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "IILB Fifo debit0 overflow" ],
   "OVERFLOW_PI_FIFO_DEBIT2"      => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "PI Fifo debit2 overflow" ],
   "OVERFLOW_PI_FIFO_DEBIT0"      => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "PI Fifo debit0 overflow" ],
   "OVERFLOW2_VC2_CREDIT"         => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "VC2 credit overflow 2" ],
   "OVERFLOW1_VC2_CREDIT"         => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "VC2 credit overflow 1" ],
   "OVERFLOW0_VC2_CREDIT"         => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "VC2 credit overflow 0" ],
   "OVERFLOW2_VC0_CREDIT"         => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "VC0 credit overflow 2" ],
   "OVERFLOW1_VC0_CREDIT"         => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VC0 credit overflow 1" ],
   "OVERFLOW0_VC0_CREDIT"         => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VC0 credit overflow 0" ],
   "OVERFLOW_FIFO13_VC2_CREDIT"   => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc2 credit overflow" ],
   "OVERFLOW_FIFO13_VC0_CREDIT"   => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc0 credit overflow" ],
   "OVERFLOW_FIFO02_VC2_CREDIT"   => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 credit overflow" ],
   "OVERFLOW_FIFO02_VC0_CREDIT"   => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 credit overflow" ],
   "OVERFLOW_FIFO13_VC3_PUSH"     => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 push overflow" ],
   "OVERFLOW_FIFO13_VC1_PUSH"     => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 push overflow" ],
   "OVERFLOW_FIFO02_VC2_PUSH"     => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 push overflow" ],
   "OVERFLOW_FIFO02_VC0_PUSH"     => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 push overflow" ],
   "OVERFLOW_FIFO13_VC3_POP"      => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 pop overflow" ],
   "OVERFLOW_FIFO13_VC1_POP"      => [  57,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 pop overflow" ],
   "OVERFLOW_FIFO02_VC2_POP"      => [  58,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 pop overflow" ],
   "OVERFLOW_FIFO02_VC0_POP"      => [  59,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 pop overflow" ],
   "OVERFLOW_FIFO13_DEBIT2"       => [  60,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Fifo 13 debit2 overflow" ],
   "OVERFLOW_FIFO13_DEBIT0"       => [  61,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Fifo 13 debit0 overflow" ],
   "OVERFLOW_FIFO02_DEBIT2"       => [  62,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Fifo 02 debit2 overflow" ],
   "OVERFLOW_FIFO02_DEBIT0"       => [  63,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Fifo 02 debit0 overflow" ],
);

%shub_01_00442_def =
( NAME    => "SH_NI1_FIRST_ERROR_1",
  ADDRESS => 0x0000000150040660,
  NOTE    => "ni1 First Error Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00442_flds
);


##########################################################################
#                                                                        #
#   SH_NI1_FIRST_ERROR_2                                                 #
#                                                                        #
##########################################################################

%shub_01_00443_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RETRY_TIMEOUT_ERROR"          => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "LLP_DEADLOCK_VC3"             => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
   "UNDERFLOW_NI_FIFO_VC3_CREDIT" => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc3 credit underflow" ],
   "UNDERFLOW_NI_FIFO_VC2_CREDIT" => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 credit underflow" ],
   "UNDERFLOW_NI_FIFO_VC1_CREDIT" => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc1 credit underflow" ],
   "UNDERFLOW_NI_FIFO_VC0_CREDIT" => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 credit underflow" ],
   "UNDERFLOW_MD_FIFO_VC2_CREDIT" => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 credit underflow" ],
   "UNDERFLOW_MD_FIFO_VC0_CREDIT" => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 credit underflow" ],
   "UNDERFLOW_IILB_FIFO_VC2_CREDIT" => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 credit underflow" ],
   "UNDERFLOW_IILB_FIFO_VC0_CREDIT" => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 credit underflow" ],
   "UNDERFLOW_PI_FIFO_VC2_CREDIT" => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 credit underflow" ],
   "UNDERFLOW_PI_FIFO_VC0_CREDIT" => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 credit underflow" ],
   "UNDERFLOW_MD_FIFO_VC2_PUSH"   => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 push underflow" ],
   "UNDERFLOW_MD_FIFO_VC0_PUSH"   => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 push underflow" ],
   "UNDERFLOW_IILB_FIFO_VC2_PUSH" => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 push underflow" ],
   "UNDERFLOW_IILB_FIFO_VC0_PUSH" => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 push underflow" ],
   "UNDERFLOW_PI_FIFO_VC2_PUSH"   => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 push underflow" ],
   "UNDERFLOW_PI_FIFO_VC0_PUSH"   => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 push underflow" ],
   "UNDERFLOW_NI_FIFO_VC2_POP"    => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc2 pop underflow" ],
   "UNDERFLOW_NI_FIFO_VC0_POP"    => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI Fifo vc0 pop underflow" ],
   "UNDERFLOW_MD_FIFO_VC2_POP"    => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc2 pop underflow" ],
   "UNDERFLOW_MD_FIFO_VC0_POP"    => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "MD Fifo vc0 pop underflow" ],
   "UNDERFLOW_IILB_FIFO_VC2_POP"  => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc2 pop underflow" ],
   "UNDERFLOW_IILB_FIFO_VC0_POP"  => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "IILB Fifo vc0 pop underflow" ],
   "UNDERFLOW_PI_FIFO_VC2_POP"    => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc2 pop underflow" ],
   "UNDERFLOW_PI_FIFO_VC0_POP"    => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI Fifo vc0 pop underflow" ],
   "RSVD1"                        => [  32,  22,  10, 0x00000000FFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW2_VC2_CREDIT"        => [  33,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "VC2 credit underflow 2" ],
   "UNDERFLOW1_VC2_CREDIT"        => [  34,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "VC2 credit underflow 1" ],
   "UNDERFLOW0_VC2_CREDIT"        => [  35,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "VC2 credit underflow 0" ],
   "UNDERFLOW2_VC0_CREDIT"        => [  36,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "VC0 credit underflow 2" ],
   "UNDERFLOW1_VC0_CREDIT"        => [  37,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VC0 credit underflow 1" ],
   "UNDERFLOW0_VC0_CREDIT"        => [  38,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VC0 credit underflow 0" ],
   "UNDERFLOW_FIFO13_VC2_CREDIT"  => [  39,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc2 credit underflow" ],
   "UNDERFLOW_FIFO13_VC0_CREDIT"  => [  40,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Fifo 13 vc0 credit underflow" ],
   "UNDERFLOW_FIFO02_VC2_CREDIT"  => [  41,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 credit underflow" ],
   "UNDERFLOW_FIFO02_VC0_CREDIT"  => [  42,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 credit underflow" ],
   "UNDERFLOW_FIFO13_VC3_PUSH"    => [  43,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 push underflow" ],
   "UNDERFLOW_FIFO13_VC1_PUSH"    => [  44,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 push underflow" ],
   "UNDERFLOW_FIFO02_VC2_PUSH"    => [  45,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 push underflow" ],
   "UNDERFLOW_FIFO02_VC0_PUSH"    => [  46,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 push underflow" ],
   "UNDERFLOW_FIFO13_VC3_POP"     => [  47,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Fifo 13 vc3 pop underflow" ],
   "UNDERFLOW_FIFO13_VC1_POP"     => [  48,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Fifo 13 vc1 pop underflow" ],
   "UNDERFLOW_FIFO02_VC2_POP"     => [  49,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Fifo 02 vc2 pop underflow" ],
   "UNDERFLOW_FIFO02_VC0_POP"     => [  50,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Fifo 02 vc0 pop underflow" ],
   "ILLEGAL_VCIILB"               => [  51,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Illegal VC IILB" ],
   "ILLEGAL_VCMD"                 => [  52,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Illegal VC MD" ],
   "ILLEGAL_VCPI"                 => [  53,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Illegal VC PI" ],
   "ILLEGAL_VCNI"                 => [  54,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Illegal VC NI" ],
);

%shub_01_00443_def =
( NAME    => "SH_NI1_FIRST_ERROR_2",
  ADDRESS => 0x0000000150040670,
  NOTE    => "ni1 First Error Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00443_flds
);


##########################################################################
#                                                                        #
#   SH_NI1_ERROR_DETAIL_1                                                #
#                                                                        #
##########################################################################

%shub_01_00444_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Header bits 63:0" ],
);

%shub_01_00444_def =
( NAME    => "SH_NI1_ERROR_DETAIL_1",
  ADDRESS => 0x0000000150040680,
  NOTE    => "ni1 Chiplet no match header bits 63:0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00444_flds
);


##########################################################################
#                                                                        #
#   SH_NI1_ERROR_DETAIL_2                                                #
#                                                                        #
##########################################################################

%shub_01_00445_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Header bits 127:64" ],
);

%shub_01_00445_def =
( NAME    => "SH_NI1_ERROR_DETAIL_2",
  ADDRESS => 0x0000000150040690,
  NOTE    => "ni1 Chiplet no match header bits 127:64",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00445_flds
);


##########################################################################
#                                                                        #
#   SH_XN_CORRECTED_DETAIL_1                                             #
#                                                                        #
##########################################################################

%shub_01_00446_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECC3_VC"                      => [   1,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "ECC3 Virtual Channel" ],
   "ECC3_WC"                      => [   2,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "ECC3 Word Count" ],
   "ECC3_SYNDROME"                => [   3,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "ECC3 Syndrome" ],
   "RSVD1"                        => [   4,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECC2_VC"                      => [   5,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "ECC2 Virtual Channel" ],
   "ECC2_WC"                      => [   6,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "ECC2 Word Count" ],
   "ECC2_SYNDROME"                => [   7,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "ECC2 Syndrome" ],
   "RSVD2"                        => [   8,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECC1_VC"                      => [   9,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "ECC1 Virtual Channel" ],
   "ECC1_WC"                      => [  10,  24,   2, 0x0000000003000000, 0x00, 0, 0x0000000000000000, "ECC1 Word Count" ],
   "ECC1_SYNDROME"                => [  11,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "ECC1 Syndrome" ],
   "RSVD3"                        => [  12,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECC0_VC"                      => [  13,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "ECC0 Virtual Channel" ],
   "ECC0_WC"                      => [  14,   8,   2, 0x0000000000000300, 0x00, 0, 0x0000000000000000, "ECC0 Word Count" ],
   "ECC0_SYNDROME"                => [  15,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "ECC0 Syndrome" ],
);

%shub_01_00446_def =
( NAME    => "SH_XN_CORRECTED_DETAIL_1",
  ADDRESS => 0x0000000150040070,
  NOTE    => "Corrected error details",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00446_flds
);


##########################################################################
#                                                                        #
#   SH_XN_CORRECTED_DETAIL_2                                             #
#                                                                        #
##########################################################################

%shub_01_00447_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "ECC data" ],
);

%shub_01_00447_def =
( NAME    => "SH_XN_CORRECTED_DETAIL_2",
  ADDRESS => 0x0000000150040080,
  NOTE    => "Corrected error data",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00447_flds
);


##########################################################################
#                                                                        #
#   SH_XN_CORRECTED_DETAIL_3                                             #
#                                                                        #
##########################################################################

%shub_01_00448_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER0"                      => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "ECC header0 (bits 63 - 0)" ],
);

%shub_01_00448_def =
( NAME    => "SH_XN_CORRECTED_DETAIL_3",
  ADDRESS => 0x0000000150040090,
  NOTE    => "Corrected error header0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00448_flds
);


##########################################################################
#                                                                        #
#   SH_XN_CORRECTED_DETAIL_4                                             #
#                                                                        #
##########################################################################

%shub_01_00449_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ERR_GROUP"                    => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Error group" ],
   "RSVD0"                        => [   1,  42,  20, 0x3FFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HEADER1"                      => [   2,   0,  42, 0x000003FFFFFFFFFF, 0x00, 0, 0x0000000000000000, "ECC header1 (bits 104 - 64)" ],
);

%shub_01_00449_def =
( NAME    => "SH_XN_CORRECTED_DETAIL_4",
  ADDRESS => 0x00000001500400a0,
  NOTE    => "Corrected error header1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00449_flds
);


##########################################################################
#                                                                        #
#   SH_XN_UNCORRECTED_DETAIL_1                                           #
#                                                                        #
##########################################################################

%shub_01_00450_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECC3_VC"                      => [   1,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "ECC3 Virtual Channel" ],
   "ECC3_WC"                      => [   2,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "ECC3 Word Count" ],
   "ECC3_SYNDROME"                => [   3,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "ECC3 Syndrome" ],
   "RSVD1"                        => [   4,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECC2_VC"                      => [   5,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "ECC2 Virtual Channel" ],
   "ECC2_WC"                      => [   6,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "ECC2 Word Count" ],
   "ECC2_SYNDROME"                => [   7,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "ECC2 Syndrome" ],
   "RSVD2"                        => [   8,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECC1_VC"                      => [   9,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "ECC1 Virtual Channel" ],
   "ECC1_WC"                      => [  10,  24,   2, 0x0000000003000000, 0x00, 0, 0x0000000000000000, "ECC1 Word Count" ],
   "ECC1_SYNDROME"                => [  11,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "ECC1 Syndrome" ],
   "RSVD3"                        => [  12,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECC0_VC"                      => [  13,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "ECC0 Virtual Channel" ],
   "ECC0_WC"                      => [  14,   8,   2, 0x0000000000000300, 0x00, 0, 0x0000000000000000, "ECC0 Word Count" ],
   "ECC0_SYNDROME"                => [  15,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "ECC0 Syndrome" ],
);

%shub_01_00450_def =
( NAME    => "SH_XN_UNCORRECTED_DETAIL_1",
  ADDRESS => 0x00000001500400b0,
  NOTE    => "Uncorrected error details",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00450_flds
);


##########################################################################
#                                                                        #
#   SH_XN_UNCORRECTED_DETAIL_2                                           #
#                                                                        #
##########################################################################

%shub_01_00451_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Captured SIC data word" ],
);

%shub_01_00451_def =
( NAME    => "SH_XN_UNCORRECTED_DETAIL_2",
  ADDRESS => 0x00000001500400c0,
  NOTE    => "Uncorrected error data",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00451_flds
);


##########################################################################
#                                                                        #
#   SH_XN_UNCORRECTED_DETAIL_3                                           #
#                                                                        #
##########################################################################

%shub_01_00452_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER0"                      => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "ECC header0 (bits 63 - 0)" ],
);

%shub_01_00452_def =
( NAME    => "SH_XN_UNCORRECTED_DETAIL_3",
  ADDRESS => 0x00000001500400d0,
  NOTE    => "Uncorrected error header0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00452_flds
);


##########################################################################
#                                                                        #
#   SH_XN_UNCORRECTED_DETAIL_4                                           #
#                                                                        #
##########################################################################

%shub_01_00453_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ERR_GROUP"                    => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Error group" ],
   "RSVD0"                        => [   1,  42,  20, 0x3FFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HEADER1"                      => [   2,   0,  42, 0x000003FFFFFFFFFF, 0x00, 0, 0x0000000000000000, "ECC header1 (bits 104 - 64)" ],
);

%shub_01_00453_def =
( NAME    => "SH_XN_UNCORRECTED_DETAIL_4",
  ADDRESS => 0x00000001500400e0,
  NOTE    => "Uncorrected error header1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00453_flds
);


##########################################################################
#                                                                        #
#   SH_XNMD_ERROR_DETAIL_1                                               #
#                                                                        #
##########################################################################

%shub_01_00454_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_ADDR"                     => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Look Up Table Read Address" ],
);

%shub_01_00454_def =
( NAME    => "SH_XNMD_ERROR_DETAIL_1",
  ADDRESS => 0x00000001500400f0,
  NOTE    => "Look Up Table Address (md)",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00454_flds
);


##########################################################################
#                                                                        #
#   SH_XNPI_ERROR_DETAIL_1                                               #
#                                                                        #
##########################################################################

%shub_01_00455_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_ADDR"                     => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Look Up Table Read Address" ],
);

%shub_01_00455_def =
( NAME    => "SH_XNPI_ERROR_DETAIL_1",
  ADDRESS => 0x0000000150040100,
  NOTE    => "Look Up Table Address (pi)",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00455_flds
);


##########################################################################
#                                                                        #
#   SH_XNIILB_ERROR_DETAIL_1                                             #
#                                                                        #
##########################################################################

%shub_01_00456_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "header bits [63:0]" ],
);

%shub_01_00456_def =
( NAME    => "SH_XNIILB_ERROR_DETAIL_1",
  ADDRESS => 0x0000000150040110,
  NOTE    => "Chiplet NoMatch header [63:0]",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00456_flds
);


##########################################################################
#                                                                        #
#   SH_XNIILB_ERROR_DETAIL_2                                             #
#                                                                        #
##########################################################################

%shub_01_00457_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "header bits [127:64]" ],
);

%shub_01_00457_def =
( NAME    => "SH_XNIILB_ERROR_DETAIL_2",
  ADDRESS => 0x0000000150040120,
  NOTE    => "Chiplet NoMatch header [127:64]",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00457_flds
);


##########################################################################
#                                                                        #
#   SH_XNIILB_ERROR_DETAIL_3                                             #
#                                                                        #
##########################################################################

%shub_01_00458_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_ADDR"                     => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Look Up Table Read Address" ],
);

%shub_01_00458_def =
( NAME    => "SH_XNIILB_ERROR_DETAIL_3",
  ADDRESS => 0x0000000150040130,
  NOTE    => "Look Up Table Address (iilb)",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00458_flds
);


##########################################################################
#                                                                        #
#   SH_NI0_ERROR_DETAIL_3                                                #
#                                                                        #
##########################################################################

%shub_01_00459_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_ADDR"                     => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Look Up Table Read Address" ],
);

%shub_01_00459_def =
( NAME    => "SH_NI0_ERROR_DETAIL_3",
  ADDRESS => 0x0000000150040140,
  NOTE    => "Look Up Table Address (ni0)",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00459_flds
);


##########################################################################
#                                                                        #
#   SH_NI1_ERROR_DETAIL_3                                                #
#                                                                        #
##########################################################################

%shub_01_00460_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_ADDR"                     => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "Look Up Table Read Address" ],
);

%shub_01_00460_def =
( NAME    => "SH_NI1_ERROR_DETAIL_3",
  ADDRESS => 0x0000000150040150,
  NOTE    => "Look Up Table Address (ni1)",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00460_flds
);


##########################################################################
#                                                                        #
#   SH_XN_ERROR_SUMMARY                                                  #
#                                                                        #
##########################################################################

%shub_01_00461_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_CHIPLET_OR_LUT"          => [   1,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "IILB chiplet nomatch or lut read error" ],
   "IILB_FIFO_UNDERFLOW"          => [   2,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow" ],
   "IILB_CREDIT_UNDERFLOW"        => [   3,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB credit underflow" ],
   "IILB_FIFO_OVERFLOW"           => [   4,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow" ],
   "IILB_CREDIT_OVERFLOW"         => [   5,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "IILB credit overflow" ],
   "IILB_DEBIT_OVERFLOW"          => [   6,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB debit overflow" ],
   "XNPI_LUT_ERROR"               => [   7,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "XNPI look up table error" ],
   "XNPI_UCE_ERROR"               => [   8,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "XNPI uncorrectable error" ],
   "XNPI_SBE_ERROR"               => [   9,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "XNPI single bit error" ],
   "XNPI_CREDIT_UNDERFLOW"        => [  10,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "XNPI credit underflow" ],
   "XNPI_DATA_BUFF_OVERFLOW"      => [  11,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "XNPI data buffer overflow" ],
   "XNPI_DEBIT_OVERFLOW"          => [  12,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "XNPI debit overflow" ],
   "XNPI_CREDIT_OVERFLOW"         => [  13,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "XNMD credit overflow" ],
   "XNMD_LUT_ERROR"               => [  14,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "XNMD look up table error" ],
   "XNMD_UCE_ERROR"               => [  15,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "XNMD uncorrectable error" ],
   "XNMD_SBE_ERROR"               => [  16,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "XNMD single bit error" ],
   "XNMD_CREDIT_UNDERFLOW"        => [  17,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "XNMD credit underflow" ],
   "XNMD_DATA_BUFF_OVERFLOW"      => [  18,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "XNMD data buffer overflow" ],
   "XNMD_DEBIT_OVERFLOW"          => [  19,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "XNMD debit overflow" ],
   "XNMD_CREDIT_OVERFLOW"         => [  20,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "XNMD credit overflow" ],
   "NI1_PIPE_ERROR"               => [  21,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI1 pipe in/out error" ],
   "NI1_LLP_ERROR"                => [  22,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI1 llp error" ],
   "NI1_CREDIT_UNDERFLOW"         => [  23,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI1 credit underflow" ],
   "NI1_PUSH_UNDERFLOW"           => [  24,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 push underflow" ],
   "NI1_POP_UNDERFLOW"            => [  25,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 pop underflow" ],
   "NI1_DEBIT_OVERFLOW"           => [  26,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI1 debit overflow" ],
   "NI1_CREDIT_OVERFLOW"          => [  27,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI1 credit overflow" ],
   "NI1_PUSH_OVERFLOW"            => [  28,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "NI1 push overflow" ],
   "NI1_POP_OVERFLOW"             => [  29,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 pop overflow" ],
   "NI0_PIPE_ERROR"               => [  30,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI0 Pipe in/out errors" ],
   "NI0_LLP_ERROR"                => [  31,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI0 llp error" ],
   "NI0_CREDIT_UNDERFLOW"         => [  32,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI0 credit underflow" ],
   "NI0_PUSH_UNDERFLOW"           => [  33,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 push underflow" ],
   "NI0_POP_UNDERFLOW"            => [  34,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 pop underflow" ],
   "NI0_DEBIT_OVERFLOW"           => [  35,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 debit overflow" ],
   "NI0_CREDIT_OVERFLOW"          => [  36,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 credit overflow" ],
   "NI0_PUSH_OVERFLOW"            => [  37,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "NI0 push overflow" ],
   "NI0_POP_OVERFLOW"             => [  38,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "NI0 pop overflow" ],
);

%shub_01_00461_def =
( NAME    => "SH_XN_ERROR_SUMMARY",
  ADDRESS => 0x0000000150040000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00461_flds
);


##########################################################################
#                                                                        #
#   SH_XN_ERRORS_ALIAS                                                   #
#                                                                        #
##########################################################################

%shub_01_00462_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_CHIPLET_OR_LUT"          => [   1,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "IILB chiplet nomatch or lut read error" ],
   "IILB_FIFO_UNDERFLOW"          => [   2,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow" ],
   "IILB_CREDIT_UNDERFLOW"        => [   3,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB credit underflow" ],
   "IILB_FIFO_OVERFLOW"           => [   4,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow" ],
   "IILB_CREDIT_OVERFLOW"         => [   5,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "IILB credit overflow" ],
   "IILB_DEBIT_OVERFLOW"          => [   6,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB debit overflow" ],
   "XNPI_LUT_ERROR"               => [   7,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "XNPI look up table error" ],
   "XNPI_UCE_ERROR"               => [   8,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "XNPI uncorrectable error" ],
   "XNPI_SBE_ERROR"               => [   9,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "XNPI single bit error" ],
   "XNPI_CREDIT_UNDERFLOW"        => [  10,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "XNPI credit underflow" ],
   "XNPI_DATA_BUFF_OVERFLOW"      => [  11,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "XNPI data buffer overflow" ],
   "XNPI_DEBIT_OVERFLOW"          => [  12,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "XNPI debit overflow" ],
   "XNPI_CREDIT_OVERFLOW"         => [  13,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "XNMD credit overflow" ],
   "XNMD_LUT_ERROR"               => [  14,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "XNMD look up table error" ],
   "XNMD_UCE_ERROR"               => [  15,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "XNMD uncorrectable error" ],
   "XNMD_SBE_ERROR"               => [  16,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "XNMD single bit error" ],
   "XNMD_CREDIT_UNDERFLOW"        => [  17,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "XNMD credit underflow" ],
   "XNMD_DATA_BUFF_OVERFLOW"      => [  18,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "XNMD data buffer overflow" ],
   "XNMD_DEBIT_OVERFLOW"          => [  19,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "XNMD debit overflow" ],
   "XNMD_CREDIT_OVERFLOW"         => [  20,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "XNMD credit overflow" ],
   "NI1_PIPE_ERROR"               => [  21,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI1 pipe in/out error" ],
   "NI1_LLP_ERROR"                => [  22,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI1 llp error" ],
   "NI1_CREDIT_UNDERFLOW"         => [  23,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI1 credit underflow" ],
   "NI1_PUSH_UNDERFLOW"           => [  24,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 push underflow" ],
   "NI1_POP_UNDERFLOW"            => [  25,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 pop underflow" ],
   "NI1_DEBIT_OVERFLOW"           => [  26,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI1 debit overflow" ],
   "NI1_CREDIT_OVERFLOW"          => [  27,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI1 credit overflow" ],
   "NI1_PUSH_OVERFLOW"            => [  28,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "NI1 push overflow" ],
   "NI1_POP_OVERFLOW"             => [  29,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 pop overflow" ],
   "NI0_PIPE_ERROR"               => [  30,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI0 Pipe in/out errors" ],
   "NI0_LLP_ERROR"                => [  31,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI0 llp error" ],
   "NI0_CREDIT_UNDERFLOW"         => [  32,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI0 credit underflow" ],
   "NI0_PUSH_UNDERFLOW"           => [  33,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 push underflow" ],
   "NI0_POP_UNDERFLOW"            => [  34,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 pop underflow" ],
   "NI0_DEBIT_OVERFLOW"           => [  35,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 debit overflow" ],
   "NI0_CREDIT_OVERFLOW"          => [  36,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 credit overflow" ],
   "NI0_PUSH_OVERFLOW"            => [  37,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "NI0 push overflow" ],
   "NI0_POP_OVERFLOW"             => [  38,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "NI0 pop overflow" ],
);

%shub_01_00462_def =
( NAME    => "SH_XN_ERRORS_ALIAS",
  ADDRESS => 0x0000000150040008,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00462_flds
);


##########################################################################
#                                                                        #
#   SH_XN_ERROR_OVERFLOW                                                 #
#                                                                        #
##########################################################################

%shub_01_00463_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_CHIPLET_OR_LUT"          => [   1,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "IILB chiplet nomatch or lut read error" ],
   "IILB_FIFO_UNDERFLOW"          => [   2,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow" ],
   "IILB_CREDIT_UNDERFLOW"        => [   3,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB credit underflow" ],
   "IILB_FIFO_OVERFLOW"           => [   4,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow" ],
   "IILB_CREDIT_OVERFLOW"         => [   5,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "IILB credit overflow" ],
   "IILB_DEBIT_OVERFLOW"          => [   6,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB debit overflow" ],
   "XNPI_LUT_ERROR"               => [   7,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "XNPI look up table error" ],
   "XNPI_UCE_ERROR"               => [   8,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "XNPI uncorrectable error" ],
   "XNPI_SBE_ERROR"               => [   9,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "XNPI single bit error" ],
   "XNPI_CREDIT_UNDERFLOW"        => [  10,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "XNPI credit underflow" ],
   "XNPI_DATA_BUFF_OVERFLOW"      => [  11,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "XNPI data buffer overflow" ],
   "XNPI_DEBIT_OVERFLOW"          => [  12,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "XNPI debit overflow" ],
   "XNPI_CREDIT_OVERFLOW"         => [  13,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "XNMD credit overflow" ],
   "XNMD_LUT_ERROR"               => [  14,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "XNMD look up table error" ],
   "XNMD_UCE_ERROR"               => [  15,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "XNMD uncorrectable error" ],
   "XNMD_SBE_ERROR"               => [  16,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "XNMD single bit error" ],
   "XNMD_CREDIT_UNDERFLOW"        => [  17,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "XNMD credit underflow" ],
   "XNMD_DATA_BUFF_OVERFLOW"      => [  18,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "XNMD data buffer overflow" ],
   "XNMD_DEBIT_OVERFLOW"          => [  19,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "XNMD debit overflow" ],
   "XNMD_CREDIT_OVERFLOW"         => [  20,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "XNMD credit overflow" ],
   "NI1_PIPE_ERROR"               => [  21,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI1 pipe in/out error" ],
   "NI1_LLP_ERROR"                => [  22,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI1 llp error" ],
   "NI1_CREDIT_UNDERFLOW"         => [  23,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI1 credit underflow" ],
   "NI1_PUSH_UNDERFLOW"           => [  24,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 push underflow" ],
   "NI1_POP_UNDERFLOW"            => [  25,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 pop underflow" ],
   "NI1_DEBIT_OVERFLOW"           => [  26,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI1 debit overflow" ],
   "NI1_CREDIT_OVERFLOW"          => [  27,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI1 credit overflow" ],
   "NI1_PUSH_OVERFLOW"            => [  28,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "NI1 push overflow" ],
   "NI1_POP_OVERFLOW"             => [  29,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 pop overflow" ],
   "NI0_PIPE_ERROR"               => [  30,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI0 Pipe in/out errors" ],
   "NI0_LLP_ERROR"                => [  31,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI0 llp error" ],
   "NI0_CREDIT_UNDERFLOW"         => [  32,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI0 credit underflow" ],
   "NI0_PUSH_UNDERFLOW"           => [  33,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 push underflow" ],
   "NI0_POP_UNDERFLOW"            => [  34,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 pop underflow" ],
   "NI0_DEBIT_OVERFLOW"           => [  35,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 debit overflow" ],
   "NI0_CREDIT_OVERFLOW"          => [  36,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 credit overflow" ],
   "NI0_PUSH_OVERFLOW"            => [  37,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "NI0 push overflow" ],
   "NI0_POP_OVERFLOW"             => [  38,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "NI0 pop overflow" ],
);

%shub_01_00463_def =
( NAME    => "SH_XN_ERROR_OVERFLOW",
  ADDRESS => 0x0000000150040020,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00463_flds
);


##########################################################################
#                                                                        #
#   SH_XN_ERROR_OVERFLOW_ALIAS                                           #
#                                                                        #
##########################################################################

%shub_01_00464_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_CHIPLET_OR_LUT"          => [   1,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "IILB chiplet nomatch or lut read error" ],
   "IILB_FIFO_UNDERFLOW"          => [   2,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow" ],
   "IILB_CREDIT_UNDERFLOW"        => [   3,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB credit underflow" ],
   "IILB_FIFO_OVERFLOW"           => [   4,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow" ],
   "IILB_CREDIT_OVERFLOW"         => [   5,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "IILB credit overflow" ],
   "IILB_DEBIT_OVERFLOW"          => [   6,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB debit overflow" ],
   "XNPI_LUT_ERROR"               => [   7,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "XNPI look up table error" ],
   "XNPI_UCE_ERROR"               => [   8,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "XNPI uncorrectable error" ],
   "XNPI_SBE_ERROR"               => [   9,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "XNPI single bit error" ],
   "XNPI_CREDIT_UNDERFLOW"        => [  10,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "XNPI credit underflow" ],
   "XNPI_DATA_BUFF_OVERFLOW"      => [  11,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "XNPI data buffer overflow" ],
   "XNPI_DEBIT_OVERFLOW"          => [  12,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "XNPI debit overflow" ],
   "XNPI_CREDIT_OVERFLOW"         => [  13,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "XNMD credit overflow" ],
   "XNMD_LUT_ERROR"               => [  14,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "XNMD look up table error" ],
   "XNMD_UCE_ERROR"               => [  15,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "XNMD uncorrectable error" ],
   "XNMD_SBE_ERROR"               => [  16,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "XNMD single bit error" ],
   "XNMD_CREDIT_UNDERFLOW"        => [  17,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "XNMD credit underflow" ],
   "XNMD_DATA_BUFF_OVERFLOW"      => [  18,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "XNMD data buffer overflow" ],
   "XNMD_DEBIT_OVERFLOW"          => [  19,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "XNMD debit overflow" ],
   "XNMD_CREDIT_OVERFLOW"         => [  20,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "XNMD credit overflow" ],
   "NI1_PIPE_ERROR"               => [  21,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI1 pipe in/out error" ],
   "NI1_LLP_ERROR"                => [  22,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI1 llp error" ],
   "NI1_CREDIT_UNDERFLOW"         => [  23,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI1 credit underflow" ],
   "NI1_PUSH_UNDERFLOW"           => [  24,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 push underflow" ],
   "NI1_POP_UNDERFLOW"            => [  25,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 pop underflow" ],
   "NI1_DEBIT_OVERFLOW"           => [  26,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI1 debit overflow" ],
   "NI1_CREDIT_OVERFLOW"          => [  27,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI1 credit overflow" ],
   "NI1_PUSH_OVERFLOW"            => [  28,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "NI1 push overflow" ],
   "NI1_POP_OVERFLOW"             => [  29,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 pop overflow" ],
   "NI0_PIPE_ERROR"               => [  30,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI0 Pipe in/out errors" ],
   "NI0_LLP_ERROR"                => [  31,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI0 llp error" ],
   "NI0_CREDIT_UNDERFLOW"         => [  32,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI0 credit underflow" ],
   "NI0_PUSH_UNDERFLOW"           => [  33,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 push underflow" ],
   "NI0_POP_UNDERFLOW"            => [  34,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 pop underflow" ],
   "NI0_DEBIT_OVERFLOW"           => [  35,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 debit overflow" ],
   "NI0_CREDIT_OVERFLOW"          => [  36,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 credit overflow" ],
   "NI0_PUSH_OVERFLOW"            => [  37,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "NI0 push overflow" ],
   "NI0_POP_OVERFLOW"             => [  38,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "NI0 pop overflow" ],
);

%shub_01_00464_def =
( NAME    => "SH_XN_ERROR_OVERFLOW_ALIAS",
  ADDRESS => 0x0000000150040028,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00464_flds
);


##########################################################################
#                                                                        #
#   SH_XN_ERROR_MASK                                                     #
#                                                                        #
##########################################################################

%shub_01_00465_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_CHIPLET_OR_LUT"          => [   1,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "IILB chiplet nomatch or lut read error" ],
   "IILB_FIFO_UNDERFLOW"          => [   2,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "IILB fifo underflow" ],
   "IILB_CREDIT_UNDERFLOW"        => [   3,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "IILB credit underflow" ],
   "IILB_FIFO_OVERFLOW"           => [   4,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "IILB fifo overflow" ],
   "IILB_CREDIT_OVERFLOW"         => [   5,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "IILB credit overflow" ],
   "IILB_DEBIT_OVERFLOW"          => [   6,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "IILB debit overflow" ],
   "XNPI_LUT_ERROR"               => [   7,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "XNPI look up table error" ],
   "XNPI_UCE_ERROR"               => [   8,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "XNPI uncorrectable error" ],
   "XNPI_SBE_ERROR"               => [   9,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "XNPI single bit error" ],
   "XNPI_CREDIT_UNDERFLOW"        => [  10,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "XNPI credit underflow" ],
   "XNPI_DATA_BUFF_OVERFLOW"      => [  11,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "XNPI data buffer overflow" ],
   "XNPI_DEBIT_OVERFLOW"          => [  12,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "XNPI debit overflow" ],
   "XNPI_CREDIT_OVERFLOW"         => [  13,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "XNMD credit overflow" ],
   "XNMD_LUT_ERROR"               => [  14,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "XNMD look up table error" ],
   "XNMD_UCE_ERROR"               => [  15,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "XNMD uncorrectable error" ],
   "XNMD_SBE_ERROR"               => [  16,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "XNMD single bit error" ],
   "XNMD_CREDIT_UNDERFLOW"        => [  17,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "XNMD credit underflow" ],
   "XNMD_DATA_BUFF_OVERFLOW"      => [  18,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "XNMD data buffer overflow" ],
   "XNMD_DEBIT_OVERFLOW"          => [  19,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "XNMD debit overflow" ],
   "XNMD_CREDIT_OVERFLOW"         => [  20,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "XNMD credit overflow" ],
   "NI1_PIPE_ERROR"               => [  21,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "NI1 pipe in/out error" ],
   "NI1_LLP_ERROR"                => [  22,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "NI1 llp error" ],
   "NI1_CREDIT_UNDERFLOW"         => [  23,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "NI1 credit underflow" ],
   "NI1_PUSH_UNDERFLOW"           => [  24,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "NI1 push underflow" ],
   "NI1_POP_UNDERFLOW"            => [  25,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "NI1 pop underflow" ],
   "NI1_DEBIT_OVERFLOW"           => [  26,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "NI1 debit overflow" ],
   "NI1_CREDIT_OVERFLOW"          => [  27,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "NI1 credit overflow" ],
   "NI1_PUSH_OVERFLOW"            => [  28,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "NI1 push overflow" ],
   "NI1_POP_OVERFLOW"             => [  29,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "NI1 pop overflow" ],
   "NI0_PIPE_ERROR"               => [  30,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "NI0 Pipe in/out errors" ],
   "NI0_LLP_ERROR"                => [  31,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "NI0 llp error" ],
   "NI0_CREDIT_UNDERFLOW"         => [  32,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "NI0 credit underflow" ],
   "NI0_PUSH_UNDERFLOW"           => [  33,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "NI0 push underflow" ],
   "NI0_POP_UNDERFLOW"            => [  34,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "NI0 pop underflow" ],
   "NI0_DEBIT_OVERFLOW"           => [  35,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "NI0 debit overflow" ],
   "NI0_CREDIT_OVERFLOW"          => [  36,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "NI0 credit overflow" ],
   "NI0_PUSH_OVERFLOW"            => [  37,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "NI0 push overflow" ],
   "NI0_POP_OVERFLOW"             => [  38,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "NI0 pop overflow" ],
);

%shub_01_00465_def =
( NAME    => "SH_XN_ERROR_MASK",
  ADDRESS => 0x0000000150040040,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00465_flds
);


##########################################################################
#                                                                        #
#   SH_XN_FIRST_ERROR                                                    #
#                                                                        #
##########################################################################

%shub_01_00466_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_CHIPLET_OR_LUT"          => [   1,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "IILB chiplet nomatch or lut read error" ],
   "IILB_FIFO_UNDERFLOW"          => [   2,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow" ],
   "IILB_CREDIT_UNDERFLOW"        => [   3,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB credit underflow" ],
   "IILB_FIFO_OVERFLOW"           => [   4,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow" ],
   "IILB_CREDIT_OVERFLOW"         => [   5,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "IILB credit overflow" ],
   "IILB_DEBIT_OVERFLOW"          => [   6,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB debit overflow" ],
   "XNPI_LUT_ERROR"               => [   7,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "XNPI look up table error" ],
   "XNPI_UCE_ERROR"               => [   8,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "XNPI uncorrectable error" ],
   "XNPI_SBE_ERROR"               => [   9,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "XNPI single bit error" ],
   "XNPI_CREDIT_UNDERFLOW"        => [  10,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "XNPI credit underflow" ],
   "XNPI_DATA_BUFF_OVERFLOW"      => [  11,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "XNPI data buffer overflow" ],
   "XNPI_DEBIT_OVERFLOW"          => [  12,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "XNPI debit overflow" ],
   "XNPI_CREDIT_OVERFLOW"         => [  13,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "XNMD credit overflow" ],
   "XNMD_LUT_ERROR"               => [  14,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "XNMD look up table error" ],
   "XNMD_UCE_ERROR"               => [  15,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "XNMD uncorrectable error" ],
   "XNMD_SBE_ERROR"               => [  16,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "XNMD single bit error" ],
   "XNMD_CREDIT_UNDERFLOW"        => [  17,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "XNMD credit underflow" ],
   "XNMD_DATA_BUFF_OVERFLOW"      => [  18,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "XNMD data buffer overflow" ],
   "XNMD_DEBIT_OVERFLOW"          => [  19,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "XNMD debit overflow" ],
   "XNMD_CREDIT_OVERFLOW"         => [  20,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "XNMD credit overflow" ],
   "NI1_PIPE_ERROR"               => [  21,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI1 pipe in/out error" ],
   "NI1_LLP_ERROR"                => [  22,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI1 llp error" ],
   "NI1_CREDIT_UNDERFLOW"         => [  23,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI1 credit underflow" ],
   "NI1_PUSH_UNDERFLOW"           => [  24,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 push underflow" ],
   "NI1_POP_UNDERFLOW"            => [  25,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 pop underflow" ],
   "NI1_DEBIT_OVERFLOW"           => [  26,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI1 debit overflow" ],
   "NI1_CREDIT_OVERFLOW"          => [  27,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI1 credit overflow" ],
   "NI1_PUSH_OVERFLOW"            => [  28,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "NI1 push overflow" ],
   "NI1_POP_OVERFLOW"             => [  29,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 pop overflow" ],
   "NI0_PIPE_ERROR"               => [  30,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI0 Pipe in/out errors" ],
   "NI0_LLP_ERROR"                => [  31,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI0 llp error" ],
   "NI0_CREDIT_UNDERFLOW"         => [  32,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI0 credit underflow" ],
   "NI0_PUSH_UNDERFLOW"           => [  33,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 push underflow" ],
   "NI0_POP_UNDERFLOW"            => [  34,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 pop underflow" ],
   "NI0_DEBIT_OVERFLOW"           => [  35,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 debit overflow" ],
   "NI0_CREDIT_OVERFLOW"          => [  36,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 credit overflow" ],
   "NI0_PUSH_OVERFLOW"            => [  37,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "NI0 push overflow" ],
   "NI0_POP_OVERFLOW"             => [  38,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "NI0 pop overflow" ],
);

%shub_01_00466_def =
( NAME    => "SH_XN_FIRST_ERROR",
  ADDRESS => 0x0000000150040060,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00466_flds
);


##########################################################################
#                                                                        #
#   SH_XNIILB_ERROR_SUMMARY                                              #
#                                                                        #
##########################################################################

%shub_01_00467_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "LUT_READ_ERROR"               => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "UNDERFLOW_NI1_VC2_CREDIT_OUT" => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_NI1_VC0_CREDIT_OUT" => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_NI0_VC2_CREDIT_OUT" => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_NI0_VC0_CREDIT_OUT" => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_IILB_VC2_CREDIT_OUT" => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_IILB_VC0_CREDIT_OUT" => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_MD_VC2_CREDIT_OUT"  => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_MD_VC0_CREDIT_OUT"  => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_PI_VC2_CREDIT_OUT"  => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_PI_VC0_CREDIT_OUT"  => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_NI1_VC2_CREDIT_OUT"  => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_NI1_VC0_CREDIT_OUT"  => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_NI0_VC2_CREDIT_OUT"  => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_NI0_VC0_CREDIT_OUT"  => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_IILB_VC2_CREDIT_OUT" => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_IILB_VC0_CREDIT_OUT" => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_MD_VC2_CREDIT_OUT"   => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_MD_VC0_CREDIT_OUT"   => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_PI_VC2_CREDIT_OUT"   => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_PI_VC0_CREDIT_OUT"   => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_NI1_DEBIT2"          => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI1 Fifo Debit2 overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI1 Fifo Debit0 overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI0 Fifo Debit2 overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI0 Fifo Debit0 overflow" ],
   "OVERFLOW_MD_DEBIT2"           => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD Fifo Debit2 overflow" ],
   "OVERFLOW_MD_DEBIT0"           => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "MD Fifo Debit0 overflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB Fifo Debit2 overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "IILB Fifo Debit0 overflow" ],
   "OVERFLOW_PI_DEBIT2"           => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI Fifo Debit2 overflow" ],
   "OVERFLOW_PI_DEBIT0"           => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI Fifo Debit0 overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT_IN"  => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit overflow Pipe In" ],
   "UNDERFLOW_NI0_VC2_CREDIT_IN"  => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit overflow Pipe In" ],
   "UNDERFLOW_MD_VC2_CREDIT_IN"   => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "MD VC2 credit overflow Pipe In" ],
   "UNDERFLOW_IILB_VC2_CREDIT_IN" => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit overflow Pipe In" ],
   "UNDERFLOW_PI_VC2_CREDIT_IN"   => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI VC2 credit overflow Pipe In" ],
   "UNDERFLOW_NI1_VC0_CREDIT_IN"  => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit overflow Pipe In" ],
   "UNDERFLOW_NI0_VC0_CREDIT_IN"  => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit overflow Pipe In" ],
   "UNDERFLOW_MD_VC0_CREDIT_IN"   => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "MD VC0 credit overflow Pipe In" ],
   "UNDERFLOW_IILB_VC0_CREDIT_IN" => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit overflow Pipe In" ],
   "UNDERFLOW_PI_VC0_CREDIT_IN"   => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "PI VC0 credit overflow Pipe In" ],
   "OVERFLOW_NI1_VC2_CREDIT_IN"   => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit overflow Pipe In" ],
   "OVERFLOW_NI0_VC2_CREDIT_IN"   => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit overflow Pipe In" ],
   "OVERFLOW_MD_VC2_CREDIT_IN"    => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "MD VC2 credit overflow Pipe In" ],
   "OVERFLOW_IILB_VC2_CREDIT_IN"  => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit overflow Pipe In" ],
   "OVERFLOW_PI_VC2_CREDIT_IN"    => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "PI VC2 credit overflow Pipe In" ],
   "OVERFLOW_NI1_VC0_CREDIT_IN"   => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit overflow Pipe In" ],
   "OVERFLOW_NI0_VC0_CREDIT_IN"   => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit overflow Pipe In" ],
   "OVERFLOW_MD_VC0_CREDIT_IN"    => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD VC0 credit overflow Pipe In" ],
   "OVERFLOW_IILB_VC0_CREDIT_IN"  => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit overflow Pipe In" ],
   "OVERFLOW_PI_VC0_CREDIT_IN"    => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI VC0 credit overflow Pipe In" ],
   "UNDERFLOW_LB_VC2"             => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "LB VC2 fifo underflow" ],
   "UNDERFLOW_LB_VC0"             => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "LB VC0 fifo underflow" ],
   "OVERFLOW_LB_VC2"              => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "LB VC2 fifo overflow" ],
   "OVERFLOW_LB_VC0"              => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "LB VC0 fifo overflow" ],
   "UNDERFLOW_II_VC2"             => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "II VC2 fifo underflow" ],
   "UNDERFLOW_II_VC0"             => [  57,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "II VC0 fifo underflow" ],
   "OVERFLOW_II_VC2"              => [  58,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "II VC2 fifo overflow" ],
   "OVERFLOW_II_VC0"              => [  59,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "II VC0 fifo overflow" ],
   "OVERFLOW_LB_DEBIT2"           => [  60,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "LB debit2 overflow" ],
   "OVERFLOW_LB_DEBIT0"           => [  61,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "LB debit0 overflow" ],
   "OVERFLOW_II_DEBIT2"           => [  62,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "II debit2 overflow" ],
   "OVERFLOW_II_DEBIT0"           => [  63,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "II debit0 overflow" ],
);

%shub_01_00467_def =
( NAME    => "SH_XNIILB_ERROR_SUMMARY",
  ADDRESS => 0x0000000150040200,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00467_flds
);


##########################################################################
#                                                                        #
#   SH_XNIILB_ERRORS_ALIAS                                               #
#                                                                        #
##########################################################################

%shub_01_00468_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "LUT_READ_ERROR"               => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "UNDERFLOW_NI1_VC2_CREDIT_OUT" => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_NI1_VC0_CREDIT_OUT" => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_NI0_VC2_CREDIT_OUT" => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_NI0_VC0_CREDIT_OUT" => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_IILB_VC2_CREDIT_OUT" => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_IILB_VC0_CREDIT_OUT" => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_MD_VC2_CREDIT_OUT"  => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_MD_VC0_CREDIT_OUT"  => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_PI_VC2_CREDIT_OUT"  => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_PI_VC0_CREDIT_OUT"  => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_NI1_VC2_CREDIT_OUT"  => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_NI1_VC0_CREDIT_OUT"  => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_NI0_VC2_CREDIT_OUT"  => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_NI0_VC0_CREDIT_OUT"  => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_IILB_VC2_CREDIT_OUT" => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_IILB_VC0_CREDIT_OUT" => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_MD_VC2_CREDIT_OUT"   => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_MD_VC0_CREDIT_OUT"   => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_PI_VC2_CREDIT_OUT"   => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_PI_VC0_CREDIT_OUT"   => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_NI1_DEBIT2"          => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI1 Fifo Debit2 overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI1 Fifo Debit0 overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI0 Fifo Debit2 overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI0 Fifo Debit0 overflow" ],
   "OVERFLOW_MD_DEBIT2"           => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD Fifo Debit2 overflow" ],
   "OVERFLOW_MD_DEBIT0"           => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "MD Fifo Debit0 overflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB Fifo Debit2 overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "IILB Fifo Debit0 overflow" ],
   "OVERFLOW_PI_DEBIT2"           => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI Fifo Debit2 overflow" ],
   "OVERFLOW_PI_DEBIT0"           => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI Fifo Debit0 overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT_IN"  => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit overflow Pipe In" ],
   "UNDERFLOW_NI0_VC2_CREDIT_IN"  => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit overflow Pipe In" ],
   "UNDERFLOW_MD_VC2_CREDIT_IN"   => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "MD VC2 credit overflow Pipe In" ],
   "UNDERFLOW_IILB_VC2_CREDIT_IN" => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit overflow Pipe In" ],
   "UNDERFLOW_PI_VC2_CREDIT_IN"   => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI VC2 credit overflow Pipe In" ],
   "UNDERFLOW_NI1_VC0_CREDIT_IN"  => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit overflow Pipe In" ],
   "UNDERFLOW_NI0_VC0_CREDIT_IN"  => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit overflow Pipe In" ],
   "UNDERFLOW_MD_VC0_CREDIT_IN"   => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "MD VC0 credit overflow Pipe In" ],
   "UNDERFLOW_IILB_VC0_CREDIT_IN" => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit overflow Pipe In" ],
   "UNDERFLOW_PI_VC0_CREDIT_IN"   => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "PI VC0 credit overflow Pipe In" ],
   "OVERFLOW_NI1_VC2_CREDIT_IN"   => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit overflow Pipe In" ],
   "OVERFLOW_NI0_VC2_CREDIT_IN"   => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit overflow Pipe In" ],
   "OVERFLOW_MD_VC2_CREDIT_IN"    => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "MD VC2 credit overflow Pipe In" ],
   "OVERFLOW_IILB_VC2_CREDIT_IN"  => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit overflow Pipe In" ],
   "OVERFLOW_PI_VC2_CREDIT_IN"    => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "PI VC2 credit overflow Pipe In" ],
   "OVERFLOW_NI1_VC0_CREDIT_IN"   => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit overflow Pipe In" ],
   "OVERFLOW_NI0_VC0_CREDIT_IN"   => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit overflow Pipe In" ],
   "OVERFLOW_MD_VC0_CREDIT_IN"    => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD VC0 credit overflow Pipe In" ],
   "OVERFLOW_IILB_VC0_CREDIT_IN"  => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit overflow Pipe In" ],
   "OVERFLOW_PI_VC0_CREDIT_IN"    => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI VC0 credit overflow Pipe In" ],
   "UNDERFLOW_LB_VC2"             => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "LB VC2 fifo underflow" ],
   "UNDERFLOW_LB_VC0"             => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "LB VC0 fifo underflow" ],
   "OVERFLOW_LB_VC2"              => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "LB VC2 fifo overflow" ],
   "OVERFLOW_LB_VC0"              => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "LB VC0 fifo overflow" ],
   "UNDERFLOW_II_VC2"             => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "II VC2 fifo underflow" ],
   "UNDERFLOW_II_VC0"             => [  57,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "II VC0 fifo underflow" ],
   "OVERFLOW_II_VC2"              => [  58,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "II VC2 fifo overflow" ],
   "OVERFLOW_II_VC0"              => [  59,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "II VC0 fifo overflow" ],
   "OVERFLOW_LB_DEBIT2"           => [  60,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "LB debit2 overflow" ],
   "OVERFLOW_LB_DEBIT0"           => [  61,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "LB debit0 overflow" ],
   "OVERFLOW_II_DEBIT2"           => [  62,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "II debit2 overflow" ],
   "OVERFLOW_II_DEBIT0"           => [  63,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "II debit0 overflow" ],
);

%shub_01_00468_def =
( NAME    => "SH_XNIILB_ERRORS_ALIAS",
  ADDRESS => 0x0000000150040208,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00468_flds
);


##########################################################################
#                                                                        #
#   SH_XNIILB_ERROR_OVERFLOW                                             #
#                                                                        #
##########################################################################

%shub_01_00469_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "LUT_READ_ERROR"               => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "UNDERFLOW_NI1_VC2_CREDIT_OUT" => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_NI1_VC0_CREDIT_OUT" => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_NI0_VC2_CREDIT_OUT" => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_NI0_VC0_CREDIT_OUT" => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_IILB_VC2_CREDIT_OUT" => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_IILB_VC0_CREDIT_OUT" => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_MD_VC2_CREDIT_OUT"  => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_MD_VC0_CREDIT_OUT"  => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_PI_VC2_CREDIT_OUT"  => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_PI_VC0_CREDIT_OUT"  => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_NI1_VC2_CREDIT_OUT"  => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_NI1_VC0_CREDIT_OUT"  => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_NI0_VC2_CREDIT_OUT"  => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_NI0_VC0_CREDIT_OUT"  => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_IILB_VC2_CREDIT_OUT" => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_IILB_VC0_CREDIT_OUT" => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_MD_VC2_CREDIT_OUT"   => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_MD_VC0_CREDIT_OUT"   => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_PI_VC2_CREDIT_OUT"   => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_PI_VC0_CREDIT_OUT"   => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_NI1_DEBIT2"          => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI1 Fifo Debit2 overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI1 Fifo Debit0 overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI0 Fifo Debit2 overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI0 Fifo Debit0 overflow" ],
   "OVERFLOW_MD_DEBIT2"           => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD Fifo Debit2 overflow" ],
   "OVERFLOW_MD_DEBIT0"           => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "MD Fifo Debit0 overflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB Fifo Debit2 overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "IILB Fifo Debit0 overflow" ],
   "OVERFLOW_PI_DEBIT2"           => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI Fifo Debit2 overflow" ],
   "OVERFLOW_PI_DEBIT0"           => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI Fifo Debit0 overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT_IN"  => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit overflow Pipe In" ],
   "UNDERFLOW_NI0_VC2_CREDIT_IN"  => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit overflow Pipe In" ],
   "UNDERFLOW_MD_VC2_CREDIT_IN"   => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "MD VC2 credit overflow Pipe In" ],
   "UNDERFLOW_IILB_VC2_CREDIT_IN" => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit overflow Pipe In" ],
   "UNDERFLOW_PI_VC2_CREDIT_IN"   => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI VC2 credit overflow Pipe In" ],
   "UNDERFLOW_NI1_VC0_CREDIT_IN"  => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit overflow Pipe In" ],
   "UNDERFLOW_NI0_VC0_CREDIT_IN"  => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit overflow Pipe In" ],
   "UNDERFLOW_MD_VC0_CREDIT_IN"   => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "MD VC0 credit overflow Pipe In" ],
   "UNDERFLOW_IILB_VC0_CREDIT_IN" => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit overflow Pipe In" ],
   "UNDERFLOW_PI_VC0_CREDIT_IN"   => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "PI VC0 credit overflow Pipe In" ],
   "OVERFLOW_NI1_VC2_CREDIT_IN"   => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit overflow Pipe In" ],
   "OVERFLOW_NI0_VC2_CREDIT_IN"   => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit overflow Pipe In" ],
   "OVERFLOW_MD_VC2_CREDIT_IN"    => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "MD VC2 credit overflow Pipe In" ],
   "OVERFLOW_IILB_VC2_CREDIT_IN"  => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit overflow Pipe In" ],
   "OVERFLOW_PI_VC2_CREDIT_IN"    => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "PI VC2 credit overflow Pipe In" ],
   "OVERFLOW_NI1_VC0_CREDIT_IN"   => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit overflow Pipe In" ],
   "OVERFLOW_NI0_VC0_CREDIT_IN"   => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit overflow Pipe In" ],
   "OVERFLOW_MD_VC0_CREDIT_IN"    => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD VC0 credit overflow Pipe In" ],
   "OVERFLOW_IILB_VC0_CREDIT_IN"  => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit overflow Pipe In" ],
   "OVERFLOW_PI_VC0_CREDIT_IN"    => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI VC0 credit overflow Pipe In" ],
   "UNDERFLOW_LB_VC2"             => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "LB VC2 fifo underflow" ],
   "UNDERFLOW_LB_VC0"             => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "LB VC0 fifo underflow" ],
   "OVERFLOW_LB_VC2"              => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "LB VC2 fifo overflow" ],
   "OVERFLOW_LB_VC0"              => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "LB VC0 fifo overflow" ],
   "UNDERFLOW_II_VC2"             => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "II VC2 fifo underflow" ],
   "UNDERFLOW_II_VC0"             => [  57,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "II VC0 fifo underflow" ],
   "OVERFLOW_II_VC2"              => [  58,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "II VC2 fifo overflow" ],
   "OVERFLOW_II_VC0"              => [  59,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "II VC0 fifo overflow" ],
   "OVERFLOW_LB_DEBIT2"           => [  60,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "LB debit2 overflow" ],
   "OVERFLOW_LB_DEBIT0"           => [  61,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "LB debit0 overflow" ],
   "OVERFLOW_II_DEBIT2"           => [  62,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "II debit2 overflow" ],
   "OVERFLOW_II_DEBIT0"           => [  63,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "II debit0 overflow" ],
);

%shub_01_00469_def =
( NAME    => "SH_XNIILB_ERROR_OVERFLOW",
  ADDRESS => 0x0000000150040220,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00469_flds
);


##########################################################################
#                                                                        #
#   SH_XNIILB_ERROR_OVERFLOW_ALIAS                                       #
#                                                                        #
##########################################################################

%shub_01_00470_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "LUT_READ_ERROR"               => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "UNDERFLOW_NI1_VC2_CREDIT_OUT" => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_NI1_VC0_CREDIT_OUT" => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_NI0_VC2_CREDIT_OUT" => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_NI0_VC0_CREDIT_OUT" => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_IILB_VC2_CREDIT_OUT" => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_IILB_VC0_CREDIT_OUT" => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_MD_VC2_CREDIT_OUT"  => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_MD_VC0_CREDIT_OUT"  => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_PI_VC2_CREDIT_OUT"  => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_PI_VC0_CREDIT_OUT"  => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_NI1_VC2_CREDIT_OUT"  => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_NI1_VC0_CREDIT_OUT"  => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_NI0_VC2_CREDIT_OUT"  => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_NI0_VC0_CREDIT_OUT"  => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_IILB_VC2_CREDIT_OUT" => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_IILB_VC0_CREDIT_OUT" => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_MD_VC2_CREDIT_OUT"   => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_MD_VC0_CREDIT_OUT"   => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_PI_VC2_CREDIT_OUT"   => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_PI_VC0_CREDIT_OUT"   => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_NI1_DEBIT2"          => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI1 Fifo Debit2 overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI1 Fifo Debit0 overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI0 Fifo Debit2 overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI0 Fifo Debit0 overflow" ],
   "OVERFLOW_MD_DEBIT2"           => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD Fifo Debit2 overflow" ],
   "OVERFLOW_MD_DEBIT0"           => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "MD Fifo Debit0 overflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB Fifo Debit2 overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "IILB Fifo Debit0 overflow" ],
   "OVERFLOW_PI_DEBIT2"           => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI Fifo Debit2 overflow" ],
   "OVERFLOW_PI_DEBIT0"           => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI Fifo Debit0 overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT_IN"  => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit overflow Pipe In" ],
   "UNDERFLOW_NI0_VC2_CREDIT_IN"  => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit overflow Pipe In" ],
   "UNDERFLOW_MD_VC2_CREDIT_IN"   => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "MD VC2 credit overflow Pipe In" ],
   "UNDERFLOW_IILB_VC2_CREDIT_IN" => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit overflow Pipe In" ],
   "UNDERFLOW_PI_VC2_CREDIT_IN"   => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI VC2 credit overflow Pipe In" ],
   "UNDERFLOW_NI1_VC0_CREDIT_IN"  => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit overflow Pipe In" ],
   "UNDERFLOW_NI0_VC0_CREDIT_IN"  => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit overflow Pipe In" ],
   "UNDERFLOW_MD_VC0_CREDIT_IN"   => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "MD VC0 credit overflow Pipe In" ],
   "UNDERFLOW_IILB_VC0_CREDIT_IN" => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit overflow Pipe In" ],
   "UNDERFLOW_PI_VC0_CREDIT_IN"   => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "PI VC0 credit overflow Pipe In" ],
   "OVERFLOW_NI1_VC2_CREDIT_IN"   => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit overflow Pipe In" ],
   "OVERFLOW_NI0_VC2_CREDIT_IN"   => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit overflow Pipe In" ],
   "OVERFLOW_MD_VC2_CREDIT_IN"    => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "MD VC2 credit overflow Pipe In" ],
   "OVERFLOW_IILB_VC2_CREDIT_IN"  => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit overflow Pipe In" ],
   "OVERFLOW_PI_VC2_CREDIT_IN"    => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "PI VC2 credit overflow Pipe In" ],
   "OVERFLOW_NI1_VC0_CREDIT_IN"   => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit overflow Pipe In" ],
   "OVERFLOW_NI0_VC0_CREDIT_IN"   => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit overflow Pipe In" ],
   "OVERFLOW_MD_VC0_CREDIT_IN"    => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD VC0 credit overflow Pipe In" ],
   "OVERFLOW_IILB_VC0_CREDIT_IN"  => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit overflow Pipe In" ],
   "OVERFLOW_PI_VC0_CREDIT_IN"    => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI VC0 credit overflow Pipe In" ],
   "UNDERFLOW_LB_VC2"             => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "LB VC2 fifo underflow" ],
   "UNDERFLOW_LB_VC0"             => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "LB VC0 fifo underflow" ],
   "OVERFLOW_LB_VC2"              => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "LB VC2 fifo overflow" ],
   "OVERFLOW_LB_VC0"              => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "LB VC0 fifo overflow" ],
   "UNDERFLOW_II_VC2"             => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "II VC2 fifo underflow" ],
   "UNDERFLOW_II_VC0"             => [  57,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "II VC0 fifo underflow" ],
   "OVERFLOW_II_VC2"              => [  58,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "II VC2 fifo overflow" ],
   "OVERFLOW_II_VC0"              => [  59,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "II VC0 fifo overflow" ],
   "OVERFLOW_LB_DEBIT2"           => [  60,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "LB debit2 overflow" ],
   "OVERFLOW_LB_DEBIT0"           => [  61,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "LB debit0 overflow" ],
   "OVERFLOW_II_DEBIT2"           => [  62,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "II debit2 overflow" ],
   "OVERFLOW_II_DEBIT0"           => [  63,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "II debit0 overflow" ],
);

%shub_01_00470_def =
( NAME    => "SH_XNIILB_ERROR_OVERFLOW_ALIAS",
  ADDRESS => 0x0000000150040228,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00470_flds
);


##########################################################################
#                                                                        #
#   SH_XNIILB_ERROR_MASK                                                 #
#                                                                        #
##########################################################################

%shub_01_00471_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "LUT_READ_ERROR"               => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "chiplet nomatch" ],
   "UNDERFLOW_NI1_VC2_CREDIT_OUT" => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "NI1 VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_NI1_VC0_CREDIT_OUT" => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "NI1 VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_NI0_VC2_CREDIT_OUT" => [   4,  59,   1, 0x0800000000000000, 0x00, 1, 0x0000000000000000, "NI0 VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_NI0_VC0_CREDIT_OUT" => [   5,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "NI0 VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_IILB_VC2_CREDIT_OUT" => [   6,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "IILB VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_IILB_VC0_CREDIT_OUT" => [   7,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "IILB VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_MD_VC2_CREDIT_OUT"  => [   8,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "MD VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_MD_VC0_CREDIT_OUT"  => [   9,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "MD VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_PI_VC2_CREDIT_OUT"  => [  10,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "PI VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_PI_VC0_CREDIT_OUT"  => [  11,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "PI VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_NI1_VC2_CREDIT_OUT"  => [  12,  51,   1, 0x0008000000000000, 0x00, 1, 0x0000000000000000, "NI1 VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_NI1_VC0_CREDIT_OUT"  => [  13,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "NI1 VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_NI0_VC2_CREDIT_OUT"  => [  14,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "NI0 VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_NI0_VC0_CREDIT_OUT"  => [  15,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "NI0 VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_IILB_VC2_CREDIT_OUT" => [  16,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "IILB VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_IILB_VC0_CREDIT_OUT" => [  17,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "IILB VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_MD_VC2_CREDIT_OUT"   => [  18,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "MD VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_MD_VC0_CREDIT_OUT"   => [  19,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "MD VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_PI_VC2_CREDIT_OUT"   => [  20,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "PI VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_PI_VC0_CREDIT_OUT"   => [  21,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "PI VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_NI1_DEBIT2"          => [  22,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "NI1 Fifo Debit2 overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  23,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "NI1 Fifo Debit0 overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  24,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "NI0 Fifo Debit2 overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  25,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "NI0 Fifo Debit0 overflow" ],
   "OVERFLOW_MD_DEBIT2"           => [  26,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "MD Fifo Debit2 overflow" ],
   "OVERFLOW_MD_DEBIT0"           => [  27,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "MD Fifo Debit0 overflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  28,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "IILB Fifo Debit2 overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  29,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "IILB Fifo Debit0 overflow" ],
   "OVERFLOW_PI_DEBIT2"           => [  30,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "PI Fifo Debit2 overflow" ],
   "OVERFLOW_PI_DEBIT0"           => [  31,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "PI Fifo Debit0 overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT_IN"  => [  32,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "NI1 VC2 credit overflow Pipe In" ],
   "UNDERFLOW_NI0_VC2_CREDIT_IN"  => [  33,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "NI0 VC2 credit overflow Pipe In" ],
   "UNDERFLOW_MD_VC2_CREDIT_IN"   => [  34,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "MD VC2 credit overflow Pipe In" ],
   "UNDERFLOW_IILB_VC2_CREDIT_IN" => [  35,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "IILB VC2 credit overflow Pipe In" ],
   "UNDERFLOW_PI_VC2_CREDIT_IN"   => [  36,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "PI VC2 credit overflow Pipe In" ],
   "UNDERFLOW_NI1_VC0_CREDIT_IN"  => [  37,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "NI1 VC0 credit overflow Pipe In" ],
   "UNDERFLOW_NI0_VC0_CREDIT_IN"  => [  38,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "NI0 VC0 credit overflow Pipe In" ],
   "UNDERFLOW_MD_VC0_CREDIT_IN"   => [  39,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "MD VC0 credit overflow Pipe In" ],
   "UNDERFLOW_IILB_VC0_CREDIT_IN" => [  40,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "IILB VC0 credit overflow Pipe In" ],
   "UNDERFLOW_PI_VC0_CREDIT_IN"   => [  41,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "PI VC0 credit overflow Pipe In" ],
   "OVERFLOW_NI1_VC2_CREDIT_IN"   => [  42,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "NI1 VC2 credit overflow Pipe In" ],
   "OVERFLOW_NI0_VC2_CREDIT_IN"   => [  43,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "NI0 VC2 credit overflow Pipe In" ],
   "OVERFLOW_MD_VC2_CREDIT_IN"    => [  44,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "MD VC2 credit overflow Pipe In" ],
   "OVERFLOW_IILB_VC2_CREDIT_IN"  => [  45,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "IILB VC2 credit overflow Pipe In" ],
   "OVERFLOW_PI_VC2_CREDIT_IN"    => [  46,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "PI VC2 credit overflow Pipe In" ],
   "OVERFLOW_NI1_VC0_CREDIT_IN"   => [  47,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "NI1 VC0 credit overflow Pipe In" ],
   "OVERFLOW_NI0_VC0_CREDIT_IN"   => [  48,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "NI0 VC0 credit overflow Pipe In" ],
   "OVERFLOW_MD_VC0_CREDIT_IN"    => [  49,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "MD VC0 credit overflow Pipe In" ],
   "OVERFLOW_IILB_VC0_CREDIT_IN"  => [  50,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "IILB VC0 credit overflow Pipe In" ],
   "OVERFLOW_PI_VC0_CREDIT_IN"    => [  51,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "PI VC0 credit overflow Pipe In" ],
   "UNDERFLOW_LB_VC2"             => [  52,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "LB VC2 fifo underflow" ],
   "UNDERFLOW_LB_VC0"             => [  53,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "LB VC0 fifo underflow" ],
   "OVERFLOW_LB_VC2"              => [  54,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "LB VC2 fifo overflow" ],
   "OVERFLOW_LB_VC0"              => [  55,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "LB VC0 fifo overflow" ],
   "UNDERFLOW_II_VC2"             => [  56,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "II VC2 fifo underflow" ],
   "UNDERFLOW_II_VC0"             => [  57,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "II VC0 fifo underflow" ],
   "OVERFLOW_II_VC2"              => [  58,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "II VC2 fifo overflow" ],
   "OVERFLOW_II_VC0"              => [  59,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "II VC0 fifo overflow" ],
   "OVERFLOW_LB_DEBIT2"           => [  60,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "LB debit2 overflow" ],
   "OVERFLOW_LB_DEBIT0"           => [  61,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "LB debit0 overflow" ],
   "OVERFLOW_II_DEBIT2"           => [  62,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "II debit2 overflow" ],
   "OVERFLOW_II_DEBIT0"           => [  63,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "II debit0 overflow" ],
);

%shub_01_00471_def =
( NAME    => "SH_XNIILB_ERROR_MASK",
  ADDRESS => 0x0000000150040240,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00471_flds
);


##########################################################################
#                                                                        #
#   SH_XNIILB_FIRST_ERROR                                                #
#                                                                        #
##########################################################################

%shub_01_00472_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "LUT_READ_ERROR"               => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "UNDERFLOW_NI1_VC2_CREDIT_OUT" => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_NI1_VC0_CREDIT_OUT" => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_NI0_VC2_CREDIT_OUT" => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_NI0_VC0_CREDIT_OUT" => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_IILB_VC2_CREDIT_OUT" => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_IILB_VC0_CREDIT_OUT" => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_MD_VC2_CREDIT_OUT"  => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_MD_VC0_CREDIT_OUT"  => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_PI_VC2_CREDIT_OUT"  => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Credit overflow Pipe Out" ],
   "UNDERFLOW_PI_VC0_CREDIT_OUT"  => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_NI1_VC2_CREDIT_OUT"  => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_NI1_VC0_CREDIT_OUT"  => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_NI0_VC2_CREDIT_OUT"  => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_NI0_VC0_CREDIT_OUT"  => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_IILB_VC2_CREDIT_OUT" => [  16,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_IILB_VC0_CREDIT_OUT" => [  17,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_MD_VC2_CREDIT_OUT"   => [  18,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_MD_VC0_CREDIT_OUT"   => [  19,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "MD VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_PI_VC2_CREDIT_OUT"   => [  20,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_PI_VC0_CREDIT_OUT"   => [  21,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "PI VC0 Credit overflow Pipe Out" ],
   "OVERFLOW_NI1_DEBIT2"          => [  22,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI1 Fifo Debit2 overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  23,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI1 Fifo Debit0 overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  24,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI0 Fifo Debit2 overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  25,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI0 Fifo Debit0 overflow" ],
   "OVERFLOW_MD_DEBIT2"           => [  26,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "MD Fifo Debit2 overflow" ],
   "OVERFLOW_MD_DEBIT0"           => [  27,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "MD Fifo Debit0 overflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  28,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB Fifo Debit2 overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  29,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "IILB Fifo Debit0 overflow" ],
   "OVERFLOW_PI_DEBIT2"           => [  30,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PI Fifo Debit2 overflow" ],
   "OVERFLOW_PI_DEBIT0"           => [  31,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "PI Fifo Debit0 overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT_IN"  => [  32,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit overflow Pipe In" ],
   "UNDERFLOW_NI0_VC2_CREDIT_IN"  => [  33,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit overflow Pipe In" ],
   "UNDERFLOW_MD_VC2_CREDIT_IN"   => [  34,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "MD VC2 credit overflow Pipe In" ],
   "UNDERFLOW_IILB_VC2_CREDIT_IN" => [  35,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit overflow Pipe In" ],
   "UNDERFLOW_PI_VC2_CREDIT_IN"   => [  36,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "PI VC2 credit overflow Pipe In" ],
   "UNDERFLOW_NI1_VC0_CREDIT_IN"  => [  37,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit overflow Pipe In" ],
   "UNDERFLOW_NI0_VC0_CREDIT_IN"  => [  38,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit overflow Pipe In" ],
   "UNDERFLOW_MD_VC0_CREDIT_IN"   => [  39,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "MD VC0 credit overflow Pipe In" ],
   "UNDERFLOW_IILB_VC0_CREDIT_IN" => [  40,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit overflow Pipe In" ],
   "UNDERFLOW_PI_VC0_CREDIT_IN"   => [  41,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "PI VC0 credit overflow Pipe In" ],
   "OVERFLOW_NI1_VC2_CREDIT_IN"   => [  42,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit overflow Pipe In" ],
   "OVERFLOW_NI0_VC2_CREDIT_IN"   => [  43,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit overflow Pipe In" ],
   "OVERFLOW_MD_VC2_CREDIT_IN"    => [  44,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "MD VC2 credit overflow Pipe In" ],
   "OVERFLOW_IILB_VC2_CREDIT_IN"  => [  45,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit overflow Pipe In" ],
   "OVERFLOW_PI_VC2_CREDIT_IN"    => [  46,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "PI VC2 credit overflow Pipe In" ],
   "OVERFLOW_NI1_VC0_CREDIT_IN"   => [  47,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit overflow Pipe In" ],
   "OVERFLOW_NI0_VC0_CREDIT_IN"   => [  48,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit overflow Pipe In" ],
   "OVERFLOW_MD_VC0_CREDIT_IN"    => [  49,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "MD VC0 credit overflow Pipe In" ],
   "OVERFLOW_IILB_VC0_CREDIT_IN"  => [  50,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit overflow Pipe In" ],
   "OVERFLOW_PI_VC0_CREDIT_IN"    => [  51,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PI VC0 credit overflow Pipe In" ],
   "UNDERFLOW_LB_VC2"             => [  52,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "LB VC2 fifo underflow" ],
   "UNDERFLOW_LB_VC0"             => [  53,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "LB VC0 fifo underflow" ],
   "OVERFLOW_LB_VC2"              => [  54,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "LB VC2 fifo overflow" ],
   "OVERFLOW_LB_VC0"              => [  55,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "LB VC0 fifo overflow" ],
   "UNDERFLOW_II_VC2"             => [  56,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "II VC2 fifo underflow" ],
   "UNDERFLOW_II_VC0"             => [  57,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "II VC0 fifo underflow" ],
   "OVERFLOW_II_VC2"              => [  58,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "II VC2 fifo overflow" ],
   "OVERFLOW_II_VC0"              => [  59,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "II VC0 fifo overflow" ],
   "OVERFLOW_LB_DEBIT2"           => [  60,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "LB debit2 overflow" ],
   "OVERFLOW_LB_DEBIT0"           => [  61,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "LB debit0 overflow" ],
   "OVERFLOW_II_DEBIT2"           => [  62,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "II debit2 overflow" ],
   "OVERFLOW_II_DEBIT0"           => [  63,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "II debit0 overflow" ],
);

%shub_01_00472_def =
( NAME    => "SH_XNIILB_FIRST_ERROR",
  ADDRESS => 0x0000000150040260,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00472_flds
);


##########################################################################
#                                                                        #
#   SH_XNPI_ERROR_SUMMARY                                                #
#                                                                        #
##########################################################################

%shub_01_00473_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  50,  14, 0xFFFC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_HEADER_CANCEL_FIFO"  => [   1,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "Header Cancel Fifo Overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT"     => [   2,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Overflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT"    => [   3,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Underflow" ],
   "OVERFLOW_IILB_VC0_CREDIT"     => [   4,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Overflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT"    => [   5,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Underflow" ],
   "OVERFLOW_NI1_VC2_CREDIT"      => [   6,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT"     => [   7,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Underflow" ],
   "OVERFLOW_NI1_VC0_CREDIT"      => [   8,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Overflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT"     => [   9,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Underflow" ],
   "OVERFLOW_NI0_VC2_CREDIT"      => [  10,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Overflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT"     => [  11,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Underflow" ],
   "OVERFLOW_NI0_VC0_CREDIT"      => [  12,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Overflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT"     => [  13,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Underflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  14,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB Debit 2 Overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  15,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB Debit 0 Overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  16,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 2 Overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  17,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 0 Overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  18,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 2 Overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  19,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 0 Overflow" ],
   "OVERFLOW_SIC_CNTR2"           => [  20,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Overflow" ],
   "UNDERFLOW_SIC_CNTR2"          => [  21,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Underflow" ],
   "OVERFLOW_SIC_CNTR0"           => [  22,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Overflow" ],
   "UNDERFLOW_SIC_CNTR0"          => [  23,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Underflow" ],
   "UNCOR_ERROR3"                 => [  24,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 255:192" ],
   "UNCOR_ERROR2"                 => [  25,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 191:128" ],
   "UNCOR_ERROR1"                 => [  26,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 127:64" ],
   "UNCOR_ERROR0"                 => [  27,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 63:0" ],
   "SINGLE_BIT_ERROR3"            => [  28,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 255:192" ],
   "SINGLE_BIT_ERROR2"            => [  29,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 191:128" ],
   "SINGLE_BIT_ERROR1"            => [  30,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 127:64" ],
   "SINGLE_BIT_ERROR0"            => [  31,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 63:0" ],
   "LUT_READ_ERROR"               => [  32,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "OVERFLOW_DATABUFF_VC2"        => [  33,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VC2 Data Buffer overflow" ],
   "OVERFLOW_DATABUFF_VC0"        => [  34,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VC0 Data Buffer overflow" ],
   "OVERFLOW_VC2_CREDIT"          => [  35,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "VC2 Credit overflow" ],
   "UNDERFLOW_VC2_CREDIT"         => [  36,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "VC2 Credit underflow" ],
   "OVERFLOW_VC0_CREDIT"          => [  37,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "VC0 Credit overflow" ],
   "UNDERFLOW_VC0_CREDIT"         => [  38,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "VC0 Credit underflow" ],
   "OVERFLOW_IILB_VC2"            => [  39,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo overflow" ],
   "UNDERFLOW_IILB_VC2"           => [  40,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo underflow" ],
   "OVERFLOW_IILB_VC0"            => [  41,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo overflow" ],
   "UNDERFLOW_IILB_VC0"           => [  42,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo underflow" ],
   "OVERFLOW_NI1_VC2"             => [  43,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo overflow" ],
   "UNDERFLOW_NI1_VC2"            => [  44,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo underflow" ],
   "OVERFLOW_NI1_VC0"             => [  45,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo overflow" ],
   "UNDERFLOW_NI1_VC0"            => [  46,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo underflow" ],
   "OVERFLOW_NI0_VC2"             => [  47,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo overflow" ],
   "UNDERFLOW_NI0_VC2"            => [  48,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo underflow" ],
   "OVERFLOW_NI0_VC0"             => [  49,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo overflow" ],
   "UNDERFLOW_NI0_VC0"            => [  50,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo underflow" ],
);

%shub_01_00473_def =
( NAME    => "SH_XNPI_ERROR_SUMMARY",
  ADDRESS => 0x0000000150040300,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00473_flds
);


##########################################################################
#                                                                        #
#   SH_XNPI_ERRORS_ALIAS                                                 #
#                                                                        #
##########################################################################

%shub_01_00474_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  50,  14, 0xFFFC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_HEADER_CANCEL_FIFO"  => [   1,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "Header Cancel Fifo Overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT"     => [   2,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Overflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT"    => [   3,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Underflow" ],
   "OVERFLOW_IILB_VC0_CREDIT"     => [   4,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Overflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT"    => [   5,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Underflow" ],
   "OVERFLOW_NI1_VC2_CREDIT"      => [   6,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT"     => [   7,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Underflow" ],
   "OVERFLOW_NI1_VC0_CREDIT"      => [   8,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Overflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT"     => [   9,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Underflow" ],
   "OVERFLOW_NI0_VC2_CREDIT"      => [  10,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Overflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT"     => [  11,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Underflow" ],
   "OVERFLOW_NI0_VC0_CREDIT"      => [  12,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Overflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT"     => [  13,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Underflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  14,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB Debit 2 Overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  15,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB Debit 0 Overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  16,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 2 Overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  17,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 0 Overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  18,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 2 Overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  19,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 0 Overflow" ],
   "OVERFLOW_SIC_CNTR2"           => [  20,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Overflow" ],
   "UNDERFLOW_SIC_CNTR2"          => [  21,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Underflow" ],
   "OVERFLOW_SIC_CNTR0"           => [  22,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Overflow" ],
   "UNDERFLOW_SIC_CNTR0"          => [  23,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Underflow" ],
   "UNCOR_ERROR3"                 => [  24,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 255:192" ],
   "UNCOR_ERROR2"                 => [  25,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 191:128" ],
   "UNCOR_ERROR1"                 => [  26,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 127:64" ],
   "UNCOR_ERROR0"                 => [  27,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 63:0" ],
   "SINGLE_BIT_ERROR3"            => [  28,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 255:192" ],
   "SINGLE_BIT_ERROR2"            => [  29,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 191:128" ],
   "SINGLE_BIT_ERROR1"            => [  30,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 127:64" ],
   "SINGLE_BIT_ERROR0"            => [  31,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 63:0" ],
   "LUT_READ_ERROR"               => [  32,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "OVERFLOW_DATABUFF_VC2"        => [  33,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VC2 Data Buffer overflow" ],
   "OVERFLOW_DATABUFF_VC0"        => [  34,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VC0 Data Buffer overflow" ],
   "OVERFLOW_VC2_CREDIT"          => [  35,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "VC2 Credit overflow" ],
   "UNDERFLOW_VC2_CREDIT"         => [  36,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "VC2 Credit underflow" ],
   "OVERFLOW_VC0_CREDIT"          => [  37,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "VC0 Credit overflow" ],
   "UNDERFLOW_VC0_CREDIT"         => [  38,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "VC0 Credit underflow" ],
   "OVERFLOW_IILB_VC2"            => [  39,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo overflow" ],
   "UNDERFLOW_IILB_VC2"           => [  40,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo underflow" ],
   "OVERFLOW_IILB_VC0"            => [  41,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo overflow" ],
   "UNDERFLOW_IILB_VC0"           => [  42,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo underflow" ],
   "OVERFLOW_NI1_VC2"             => [  43,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo overflow" ],
   "UNDERFLOW_NI1_VC2"            => [  44,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo underflow" ],
   "OVERFLOW_NI1_VC0"             => [  45,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo overflow" ],
   "UNDERFLOW_NI1_VC0"            => [  46,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo underflow" ],
   "OVERFLOW_NI0_VC2"             => [  47,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo overflow" ],
   "UNDERFLOW_NI0_VC2"            => [  48,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo underflow" ],
   "OVERFLOW_NI0_VC0"             => [  49,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo overflow" ],
   "UNDERFLOW_NI0_VC0"            => [  50,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo underflow" ],
);

%shub_01_00474_def =
( NAME    => "SH_XNPI_ERRORS_ALIAS",
  ADDRESS => 0x0000000150040308,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00474_flds
);


##########################################################################
#                                                                        #
#   SH_XNPI_ERROR_OVERFLOW                                               #
#                                                                        #
##########################################################################

%shub_01_00475_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  50,  14, 0xFFFC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_HEADER_CANCEL_FIFO"  => [   1,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "Header Cancel Fifo Overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT"     => [   2,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Overflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT"    => [   3,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Underflow" ],
   "OVERFLOW_IILB_VC0_CREDIT"     => [   4,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Overflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT"    => [   5,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Underflow" ],
   "OVERFLOW_NI1_VC2_CREDIT"      => [   6,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT"     => [   7,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Underflow" ],
   "OVERFLOW_NI1_VC0_CREDIT"      => [   8,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Overflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT"     => [   9,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Underflow" ],
   "OVERFLOW_NI0_VC2_CREDIT"      => [  10,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Overflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT"     => [  11,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Underflow" ],
   "OVERFLOW_NI0_VC0_CREDIT"      => [  12,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Overflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT"     => [  13,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Underflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  14,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB Debit 2 Overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  15,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB Debit 0 Overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  16,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 2 Overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  17,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 0 Overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  18,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 2 Overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  19,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 0 Overflow" ],
   "OVERFLOW_SIC_CNTR2"           => [  20,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Overflow" ],
   "UNDERFLOW_SIC_CNTR2"          => [  21,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Underflow" ],
   "OVERFLOW_SIC_CNTR0"           => [  22,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Overflow" ],
   "UNDERFLOW_SIC_CNTR0"          => [  23,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Underflow" ],
   "UNCOR_ERROR3"                 => [  24,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 255:192" ],
   "UNCOR_ERROR2"                 => [  25,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 191:128" ],
   "UNCOR_ERROR1"                 => [  26,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 127:64" ],
   "UNCOR_ERROR0"                 => [  27,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 63:0" ],
   "SINGLE_BIT_ERROR3"            => [  28,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 255:192" ],
   "SINGLE_BIT_ERROR2"            => [  29,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 191:128" ],
   "SINGLE_BIT_ERROR1"            => [  30,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 127:64" ],
   "SINGLE_BIT_ERROR0"            => [  31,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 63:0" ],
   "LUT_READ_ERROR"               => [  32,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "OVERFLOW_DATABUFF_VC2"        => [  33,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VC2 Data Buffer overflow" ],
   "OVERFLOW_DATABUFF_VC0"        => [  34,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VC0 Data Buffer overflow" ],
   "OVERFLOW_VC2_CREDIT"          => [  35,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "VC2 Credit overflow" ],
   "UNDERFLOW_VC2_CREDIT"         => [  36,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "VC2 Credit underflow" ],
   "OVERFLOW_VC0_CREDIT"          => [  37,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "VC0 Credit overflow" ],
   "UNDERFLOW_VC0_CREDIT"         => [  38,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "VC0 Credit underflow" ],
   "OVERFLOW_IILB_VC2"            => [  39,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo overflow" ],
   "UNDERFLOW_IILB_VC2"           => [  40,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo underflow" ],
   "OVERFLOW_IILB_VC0"            => [  41,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo overflow" ],
   "UNDERFLOW_IILB_VC0"           => [  42,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo underflow" ],
   "OVERFLOW_NI1_VC2"             => [  43,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo overflow" ],
   "UNDERFLOW_NI1_VC2"            => [  44,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo underflow" ],
   "OVERFLOW_NI1_VC0"             => [  45,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo overflow" ],
   "UNDERFLOW_NI1_VC0"            => [  46,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo underflow" ],
   "OVERFLOW_NI0_VC2"             => [  47,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo overflow" ],
   "UNDERFLOW_NI0_VC2"            => [  48,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo underflow" ],
   "OVERFLOW_NI0_VC0"             => [  49,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo overflow" ],
   "UNDERFLOW_NI0_VC0"            => [  50,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo underflow" ],
);

%shub_01_00475_def =
( NAME    => "SH_XNPI_ERROR_OVERFLOW",
  ADDRESS => 0x0000000150040320,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00475_flds
);


##########################################################################
#                                                                        #
#   SH_XNPI_ERROR_OVERFLOW_ALIAS                                         #
#                                                                        #
##########################################################################

%shub_01_00476_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  50,  14, 0xFFFC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_HEADER_CANCEL_FIFO"  => [   1,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "Header Cancel Fifo Overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT"     => [   2,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Overflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT"    => [   3,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Underflow" ],
   "OVERFLOW_IILB_VC0_CREDIT"     => [   4,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Overflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT"    => [   5,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Underflow" ],
   "OVERFLOW_NI1_VC2_CREDIT"      => [   6,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT"     => [   7,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Underflow" ],
   "OVERFLOW_NI1_VC0_CREDIT"      => [   8,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Overflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT"     => [   9,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Underflow" ],
   "OVERFLOW_NI0_VC2_CREDIT"      => [  10,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Overflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT"     => [  11,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Underflow" ],
   "OVERFLOW_NI0_VC0_CREDIT"      => [  12,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Overflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT"     => [  13,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Underflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  14,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB Debit 2 Overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  15,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB Debit 0 Overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  16,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 2 Overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  17,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 0 Overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  18,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 2 Overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  19,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 0 Overflow" ],
   "OVERFLOW_SIC_CNTR2"           => [  20,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Overflow" ],
   "UNDERFLOW_SIC_CNTR2"          => [  21,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Underflow" ],
   "OVERFLOW_SIC_CNTR0"           => [  22,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Overflow" ],
   "UNDERFLOW_SIC_CNTR0"          => [  23,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Underflow" ],
   "UNCOR_ERROR3"                 => [  24,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 255:192" ],
   "UNCOR_ERROR2"                 => [  25,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 191:128" ],
   "UNCOR_ERROR1"                 => [  26,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 127:64" ],
   "UNCOR_ERROR0"                 => [  27,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 63:0" ],
   "SINGLE_BIT_ERROR3"            => [  28,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 255:192" ],
   "SINGLE_BIT_ERROR2"            => [  29,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 191:128" ],
   "SINGLE_BIT_ERROR1"            => [  30,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 127:64" ],
   "SINGLE_BIT_ERROR0"            => [  31,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 63:0" ],
   "LUT_READ_ERROR"               => [  32,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "OVERFLOW_DATABUFF_VC2"        => [  33,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VC2 Data Buffer overflow" ],
   "OVERFLOW_DATABUFF_VC0"        => [  34,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VC0 Data Buffer overflow" ],
   "OVERFLOW_VC2_CREDIT"          => [  35,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "VC2 Credit overflow" ],
   "UNDERFLOW_VC2_CREDIT"         => [  36,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "VC2 Credit underflow" ],
   "OVERFLOW_VC0_CREDIT"          => [  37,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "VC0 Credit overflow" ],
   "UNDERFLOW_VC0_CREDIT"         => [  38,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "VC0 Credit underflow" ],
   "OVERFLOW_IILB_VC2"            => [  39,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo overflow" ],
   "UNDERFLOW_IILB_VC2"           => [  40,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo underflow" ],
   "OVERFLOW_IILB_VC0"            => [  41,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo overflow" ],
   "UNDERFLOW_IILB_VC0"           => [  42,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo underflow" ],
   "OVERFLOW_NI1_VC2"             => [  43,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo overflow" ],
   "UNDERFLOW_NI1_VC2"            => [  44,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo underflow" ],
   "OVERFLOW_NI1_VC0"             => [  45,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo overflow" ],
   "UNDERFLOW_NI1_VC0"            => [  46,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo underflow" ],
   "OVERFLOW_NI0_VC2"             => [  47,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo overflow" ],
   "UNDERFLOW_NI0_VC2"            => [  48,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo underflow" ],
   "OVERFLOW_NI0_VC0"             => [  49,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo overflow" ],
   "UNDERFLOW_NI0_VC0"            => [  50,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo underflow" ],
);

%shub_01_00476_def =
( NAME    => "SH_XNPI_ERROR_OVERFLOW_ALIAS",
  ADDRESS => 0x0000000150040328,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00476_flds
);


##########################################################################
#                                                                        #
#   SH_XNPI_ERROR_MASK                                                   #
#                                                                        #
##########################################################################

%shub_01_00477_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  50,  14, 0xFFFC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_HEADER_CANCEL_FIFO"  => [   1,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "Header Cancel Fifo Overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT"     => [   2,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "IILB VC2 Credit Overflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT"    => [   3,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "IILB VC2 Credit Underflow" ],
   "OVERFLOW_IILB_VC0_CREDIT"     => [   4,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "IILB VC0 Credit Overflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT"    => [   5,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "IILB VC0 Credit Underflow" ],
   "OVERFLOW_NI1_VC2_CREDIT"      => [   6,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "NI1 VC2 Credit Overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT"     => [   7,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "NI1 VC2 Credit Underflow" ],
   "OVERFLOW_NI1_VC0_CREDIT"      => [   8,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "NI1 VC0 Credit Overflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT"     => [   9,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "NI1 VC0 Credit Underflow" ],
   "OVERFLOW_NI0_VC2_CREDIT"      => [  10,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "NI0 VC2 Credit Overflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT"     => [  11,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "NI0 VC2 Credit Underflow" ],
   "OVERFLOW_NI0_VC0_CREDIT"      => [  12,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "NI0 VC0 Credit Overflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT"     => [  13,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "NI0 VC0 Credit Underflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  14,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "IILB Debit 2 Overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  15,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "IILB Debit 0 Overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  16,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "NI1 Debit 2 Overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  17,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "NI1 Debit 0 Overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  18,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "NI0 Debit 2 Overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  19,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "NI0 Debit 0 Overflow" ],
   "OVERFLOW_SIC_CNTR2"           => [  20,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "SIC Counter 2 Overflow" ],
   "UNDERFLOW_SIC_CNTR2"          => [  21,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "SIC Counter 2 Underflow" ],
   "OVERFLOW_SIC_CNTR0"           => [  22,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "SIC Counter 0 Overflow" ],
   "UNDERFLOW_SIC_CNTR0"          => [  23,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "SIC Counter 0 Underflow" ],
   "UNCOR_ERROR3"                 => [  24,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "Uncorrectable Error in Bits 255:192" ],
   "UNCOR_ERROR2"                 => [  25,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Uncorrectable Error in Bits 191:128" ],
   "UNCOR_ERROR1"                 => [  26,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Uncorrectable Error in Bits 127:64" ],
   "UNCOR_ERROR0"                 => [  27,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "Uncorrectable Error in Bits 63:0" ],
   "SINGLE_BIT_ERROR3"            => [  28,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "Single Bit Error in Bits 255:192" ],
   "SINGLE_BIT_ERROR2"            => [  29,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "Single Bit Error in Bits 191:128" ],
   "SINGLE_BIT_ERROR1"            => [  30,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "Single Bit Error in Bits 127:64" ],
   "SINGLE_BIT_ERROR0"            => [  31,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "Single Bit Error in Bits 63:0" ],
   "LUT_READ_ERROR"               => [  32,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "LUT Read Error" ],
   "OVERFLOW_DATABUFF_VC2"        => [  33,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "VC2 Data Buffer overflow" ],
   "OVERFLOW_DATABUFF_VC0"        => [  34,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "VC0 Data Buffer overflow" ],
   "OVERFLOW_VC2_CREDIT"          => [  35,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "VC2 Credit overflow" ],
   "UNDERFLOW_VC2_CREDIT"         => [  36,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "VC2 Credit underflow" ],
   "OVERFLOW_VC0_CREDIT"          => [  37,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "VC0 Credit overflow" ],
   "UNDERFLOW_VC0_CREDIT"         => [  38,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "VC0 Credit underflow" ],
   "OVERFLOW_IILB_VC2"            => [  39,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "IILB VC2 fifo overflow" ],
   "UNDERFLOW_IILB_VC2"           => [  40,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "IILB VC2 fifo underflow" ],
   "OVERFLOW_IILB_VC0"            => [  41,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "IILB VC0 fifo overflow" ],
   "UNDERFLOW_IILB_VC0"           => [  42,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "IILB VC0 fifo underflow" ],
   "OVERFLOW_NI1_VC2"             => [  43,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "NI1 VC2 fifo overflow" ],
   "UNDERFLOW_NI1_VC2"            => [  44,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "NI1 VC2 fifo underflow" ],
   "OVERFLOW_NI1_VC0"             => [  45,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "NI1 VC0 fifo overflow" ],
   "UNDERFLOW_NI1_VC0"            => [  46,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "NI1 VC0 fifo underflow" ],
   "OVERFLOW_NI0_VC2"             => [  47,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "NI0 VC2 fifo overflow" ],
   "UNDERFLOW_NI0_VC2"            => [  48,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "NI0 VC2 fifo underflow" ],
   "OVERFLOW_NI0_VC0"             => [  49,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "NI0 VC0 fifo overflow" ],
   "UNDERFLOW_NI0_VC0"            => [  50,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "NI0 VC0 fifo underflow" ],
);

%shub_01_00477_def =
( NAME    => "SH_XNPI_ERROR_MASK",
  ADDRESS => 0x0000000150040340,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00477_flds
);


##########################################################################
#                                                                        #
#   SH_XNPI_FIRST_ERROR                                                  #
#                                                                        #
##########################################################################

%shub_01_00478_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  50,  14, 0xFFFC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_HEADER_CANCEL_FIFO"  => [   1,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "Header Cancel Fifo Overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT"     => [   2,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Overflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT"    => [   3,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Underflow" ],
   "OVERFLOW_IILB_VC0_CREDIT"     => [   4,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Overflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT"    => [   5,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Underflow" ],
   "OVERFLOW_NI1_VC2_CREDIT"      => [   6,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT"     => [   7,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Underflow" ],
   "OVERFLOW_NI1_VC0_CREDIT"      => [   8,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Overflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT"     => [   9,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Underflow" ],
   "OVERFLOW_NI0_VC2_CREDIT"      => [  10,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Overflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT"     => [  11,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Underflow" ],
   "OVERFLOW_NI0_VC0_CREDIT"      => [  12,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Overflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT"     => [  13,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Underflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  14,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB Debit 2 Overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  15,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB Debit 0 Overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  16,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 2 Overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  17,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 0 Overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  18,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 2 Overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  19,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 0 Overflow" ],
   "OVERFLOW_SIC_CNTR2"           => [  20,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Overflow" ],
   "UNDERFLOW_SIC_CNTR2"          => [  21,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Underflow" ],
   "OVERFLOW_SIC_CNTR0"           => [  22,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Overflow" ],
   "UNDERFLOW_SIC_CNTR0"          => [  23,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Underflow" ],
   "UNCOR_ERROR3"                 => [  24,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 255:192" ],
   "UNCOR_ERROR2"                 => [  25,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 191:128" ],
   "UNCOR_ERROR1"                 => [  26,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 127:64" ],
   "UNCOR_ERROR0"                 => [  27,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 63:0" ],
   "SINGLE_BIT_ERROR3"            => [  28,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 255:192" ],
   "SINGLE_BIT_ERROR2"            => [  29,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 191:128" ],
   "SINGLE_BIT_ERROR1"            => [  30,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 127:64" ],
   "SINGLE_BIT_ERROR0"            => [  31,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 63:0" ],
   "LUT_READ_ERROR"               => [  32,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "OVERFLOW_DATABUFF_VC2"        => [  33,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VC2 Data Buffer overflow" ],
   "OVERFLOW_DATABUFF_VC0"        => [  34,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VC0 Data Buffer overflow" ],
   "OVERFLOW_VC2_CREDIT"          => [  35,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "VC2 Credit overflow" ],
   "UNDERFLOW_VC2_CREDIT"         => [  36,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "VC2 Credit underflow" ],
   "OVERFLOW_VC0_CREDIT"          => [  37,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "VC0 Credit overflow" ],
   "UNDERFLOW_VC0_CREDIT"         => [  38,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "VC0 Credit underflow" ],
   "OVERFLOW_IILB_VC2"            => [  39,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo overflow" ],
   "UNDERFLOW_IILB_VC2"           => [  40,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo underflow" ],
   "OVERFLOW_IILB_VC0"            => [  41,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo overflow" ],
   "UNDERFLOW_IILB_VC0"           => [  42,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo underflow" ],
   "OVERFLOW_NI1_VC2"             => [  43,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo overflow" ],
   "UNDERFLOW_NI1_VC2"            => [  44,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo underflow" ],
   "OVERFLOW_NI1_VC0"             => [  45,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo overflow" ],
   "UNDERFLOW_NI1_VC0"            => [  46,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo underflow" ],
   "OVERFLOW_NI0_VC2"             => [  47,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo overflow" ],
   "UNDERFLOW_NI0_VC2"            => [  48,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo underflow" ],
   "OVERFLOW_NI0_VC0"             => [  49,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo overflow" ],
   "UNDERFLOW_NI0_VC0"            => [  50,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo underflow" ],
);

%shub_01_00478_def =
( NAME    => "SH_XNPI_FIRST_ERROR",
  ADDRESS => 0x0000000150040360,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00478_flds
);


##########################################################################
#                                                                        #
#   SH_XNMD_ERROR_SUMMARY                                                #
#                                                                        #
##########################################################################

%shub_01_00479_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  50,  14, 0xFFFC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_HEADER_CANCEL_FIFO"  => [   1,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "Header Cancel Fifo Overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT"     => [   2,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Overflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT"    => [   3,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Underflow" ],
   "OVERFLOW_IILB_VC0_CREDIT"     => [   4,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Overflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT"    => [   5,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Underflow" ],
   "OVERFLOW_NI1_VC2_CREDIT"      => [   6,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT"     => [   7,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Underflow" ],
   "OVERFLOW_NI1_VC0_CREDIT"      => [   8,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Overflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT"     => [   9,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Underflow" ],
   "OVERFLOW_NI0_VC2_CREDIT"      => [  10,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Overflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT"     => [  11,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Underflow" ],
   "OVERFLOW_NI0_VC0_CREDIT"      => [  12,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Overflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT"     => [  13,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Underflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  14,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB Debit 2 Overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  15,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB Debit 0 Overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  16,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 2 Overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  17,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 0 Overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  18,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 2 Overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  19,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 0 Overflow" ],
   "OVERFLOW_SIC_CNTR2"           => [  20,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Overflow" ],
   "UNDERFLOW_SIC_CNTR2"          => [  21,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Underflow" ],
   "OVERFLOW_SIC_CNTR0"           => [  22,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Overflow" ],
   "UNDERFLOW_SIC_CNTR0"          => [  23,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Underflow" ],
   "UNCOR_ERROR3"                 => [  24,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 255:192" ],
   "UNCOR_ERROR2"                 => [  25,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 191:128" ],
   "UNCOR_ERROR1"                 => [  26,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 127:64" ],
   "UNCOR_ERROR0"                 => [  27,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 63:0" ],
   "SINGLE_BIT_ERROR3"            => [  28,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 255:192" ],
   "SINGLE_BIT_ERROR2"            => [  29,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 191:128" ],
   "SINGLE_BIT_ERROR1"            => [  30,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 127:64" ],
   "SINGLE_BIT_ERROR0"            => [  31,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 63:0" ],
   "LUT_READ_ERROR"               => [  32,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "OVERFLOW_DATABUFF_VC2"        => [  33,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VC2 Data Buffer overflow" ],
   "OVERFLOW_DATABUFF_VC0"        => [  34,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VC0 Data Buffer overflow" ],
   "OVERFLOW_VC2_CREDIT"          => [  35,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "VC2 Credit overflow" ],
   "UNDERFLOW_VC2_CREDIT"         => [  36,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "VC2 Credit underflow" ],
   "OVERFLOW_VC0_CREDIT"          => [  37,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "VC0 Credit overflow" ],
   "UNDERFLOW_VC0_CREDIT"         => [  38,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "VC0 Credit underflow" ],
   "OVERFLOW_IILB_VC2"            => [  39,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo overflow" ],
   "UNDERFLOW_IILB_VC2"           => [  40,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo underflow" ],
   "OVERFLOW_IILB_VC0"            => [  41,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo overflow" ],
   "UNDERFLOW_IILB_VC0"           => [  42,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo underflow" ],
   "OVERFLOW_NI1_VC2"             => [  43,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo overflow" ],
   "UNDERFLOW_NI1_VC2"            => [  44,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo underflow" ],
   "OVERFLOW_NI1_VC0"             => [  45,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo overflow" ],
   "UNDERFLOW_NI1_VC0"            => [  46,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo underflow" ],
   "OVERFLOW_NI0_VC2"             => [  47,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo overflow" ],
   "UNDERFLOW_NI0_VC2"            => [  48,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo underflow" ],
   "OVERFLOW_NI0_VC0"             => [  49,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo overflow" ],
   "UNDERFLOW_NI0_VC0"            => [  50,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo underflow" ],
);

%shub_01_00479_def =
( NAME    => "SH_XNMD_ERROR_SUMMARY",
  ADDRESS => 0x0000000150040400,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00479_flds
);


##########################################################################
#                                                                        #
#   SH_XNMD_ERRORS_ALIAS                                                 #
#                                                                        #
##########################################################################

%shub_01_00480_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  50,  14, 0xFFFC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_HEADER_CANCEL_FIFO"  => [   1,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "Header Cancel Fifo Overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT"     => [   2,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Overflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT"    => [   3,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Underflow" ],
   "OVERFLOW_IILB_VC0_CREDIT"     => [   4,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Overflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT"    => [   5,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Underflow" ],
   "OVERFLOW_NI1_VC2_CREDIT"      => [   6,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT"     => [   7,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Underflow" ],
   "OVERFLOW_NI1_VC0_CREDIT"      => [   8,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Overflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT"     => [   9,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Underflow" ],
   "OVERFLOW_NI0_VC2_CREDIT"      => [  10,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Overflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT"     => [  11,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Underflow" ],
   "OVERFLOW_NI0_VC0_CREDIT"      => [  12,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Overflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT"     => [  13,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Underflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  14,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB Debit 2 Overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  15,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB Debit 0 Overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  16,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 2 Overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  17,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 0 Overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  18,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 2 Overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  19,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 0 Overflow" ],
   "OVERFLOW_SIC_CNTR2"           => [  20,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Overflow" ],
   "UNDERFLOW_SIC_CNTR2"          => [  21,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Underflow" ],
   "OVERFLOW_SIC_CNTR0"           => [  22,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Overflow" ],
   "UNDERFLOW_SIC_CNTR0"          => [  23,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Underflow" ],
   "UNCOR_ERROR3"                 => [  24,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 255:192" ],
   "UNCOR_ERROR2"                 => [  25,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 191:128" ],
   "UNCOR_ERROR1"                 => [  26,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 127:64" ],
   "UNCOR_ERROR0"                 => [  27,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 63:0" ],
   "SINGLE_BIT_ERROR3"            => [  28,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 255:192" ],
   "SINGLE_BIT_ERROR2"            => [  29,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 191:128" ],
   "SINGLE_BIT_ERROR1"            => [  30,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 127:64" ],
   "SINGLE_BIT_ERROR0"            => [  31,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 63:0" ],
   "LUT_READ_ERROR"               => [  32,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "OVERFLOW_DATABUFF_VC2"        => [  33,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VC2 Data Buffer overflow" ],
   "OVERFLOW_DATABUFF_VC0"        => [  34,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VC0 Data Buffer overflow" ],
   "OVERFLOW_VC2_CREDIT"          => [  35,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "VC2 Credit overflow" ],
   "UNDERFLOW_VC2_CREDIT"         => [  36,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "VC2 Credit underflow" ],
   "OVERFLOW_VC0_CREDIT"          => [  37,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "VC0 Credit overflow" ],
   "UNDERFLOW_VC0_CREDIT"         => [  38,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "VC0 Credit underflow" ],
   "OVERFLOW_IILB_VC2"            => [  39,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo overflow" ],
   "UNDERFLOW_IILB_VC2"           => [  40,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo underflow" ],
   "OVERFLOW_IILB_VC0"            => [  41,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo overflow" ],
   "UNDERFLOW_IILB_VC0"           => [  42,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo underflow" ],
   "OVERFLOW_NI1_VC2"             => [  43,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo overflow" ],
   "UNDERFLOW_NI1_VC2"            => [  44,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo underflow" ],
   "OVERFLOW_NI1_VC0"             => [  45,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo overflow" ],
   "UNDERFLOW_NI1_VC0"            => [  46,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo underflow" ],
   "OVERFLOW_NI0_VC2"             => [  47,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo overflow" ],
   "UNDERFLOW_NI0_VC2"            => [  48,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo underflow" ],
   "OVERFLOW_NI0_VC0"             => [  49,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo overflow" ],
   "UNDERFLOW_NI0_VC0"            => [  50,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo underflow" ],
);

%shub_01_00480_def =
( NAME    => "SH_XNMD_ERRORS_ALIAS",
  ADDRESS => 0x0000000150040408,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00480_flds
);


##########################################################################
#                                                                        #
#   SH_XNMD_ERROR_OVERFLOW                                               #
#                                                                        #
##########################################################################

%shub_01_00481_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  50,  14, 0xFFFC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_HEADER_CANCEL_FIFO"  => [   1,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "Header Cancel Fifo Overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT"     => [   2,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Overflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT"    => [   3,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Underflow" ],
   "OVERFLOW_IILB_VC0_CREDIT"     => [   4,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Overflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT"    => [   5,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Underflow" ],
   "OVERFLOW_NI1_VC2_CREDIT"      => [   6,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT"     => [   7,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Underflow" ],
   "OVERFLOW_NI1_VC0_CREDIT"      => [   8,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Overflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT"     => [   9,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Underflow" ],
   "OVERFLOW_NI0_VC2_CREDIT"      => [  10,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Overflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT"     => [  11,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Underflow" ],
   "OVERFLOW_NI0_VC0_CREDIT"      => [  12,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Overflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT"     => [  13,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Underflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  14,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB Debit 2 Overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  15,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB Debit 0 Overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  16,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 2 Overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  17,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 0 Overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  18,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 2 Overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  19,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 0 Overflow" ],
   "OVERFLOW_SIC_CNTR2"           => [  20,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Overflow" ],
   "UNDERFLOW_SIC_CNTR2"          => [  21,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Underflow" ],
   "OVERFLOW_SIC_CNTR0"           => [  22,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Overflow" ],
   "UNDERFLOW_SIC_CNTR0"          => [  23,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Underflow" ],
   "UNCOR_ERROR3"                 => [  24,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 255:192" ],
   "UNCOR_ERROR2"                 => [  25,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 191:128" ],
   "UNCOR_ERROR1"                 => [  26,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 127:64" ],
   "UNCOR_ERROR0"                 => [  27,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 63:0" ],
   "SINGLE_BIT_ERROR3"            => [  28,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 255:192" ],
   "SINGLE_BIT_ERROR2"            => [  29,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 191:128" ],
   "SINGLE_BIT_ERROR1"            => [  30,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 127:64" ],
   "SINGLE_BIT_ERROR0"            => [  31,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 63:0" ],
   "LUT_READ_ERROR"               => [  32,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "OVERFLOW_DATABUFF_VC2"        => [  33,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VC2 Data Buffer overflow" ],
   "OVERFLOW_DATABUFF_VC0"        => [  34,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VC0 Data Buffer overflow" ],
   "OVERFLOW_VC2_CREDIT"          => [  35,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "VC2 Credit overflow" ],
   "UNDERFLOW_VC2_CREDIT"         => [  36,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "VC2 Credit underflow" ],
   "OVERFLOW_VC0_CREDIT"          => [  37,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "VC0 Credit overflow" ],
   "UNDERFLOW_VC0_CREDIT"         => [  38,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "VC0 Credit underflow" ],
   "OVERFLOW_IILB_VC2"            => [  39,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo overflow" ],
   "UNDERFLOW_IILB_VC2"           => [  40,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo underflow" ],
   "OVERFLOW_IILB_VC0"            => [  41,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo overflow" ],
   "UNDERFLOW_IILB_VC0"           => [  42,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo underflow" ],
   "OVERFLOW_NI1_VC2"             => [  43,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo overflow" ],
   "UNDERFLOW_NI1_VC2"            => [  44,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo underflow" ],
   "OVERFLOW_NI1_VC0"             => [  45,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo overflow" ],
   "UNDERFLOW_NI1_VC0"            => [  46,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo underflow" ],
   "OVERFLOW_NI0_VC2"             => [  47,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo overflow" ],
   "UNDERFLOW_NI0_VC2"            => [  48,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo underflow" ],
   "OVERFLOW_NI0_VC0"             => [  49,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo overflow" ],
   "UNDERFLOW_NI0_VC0"            => [  50,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo underflow" ],
);

%shub_01_00481_def =
( NAME    => "SH_XNMD_ERROR_OVERFLOW",
  ADDRESS => 0x0000000150040420,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00481_flds
);


##########################################################################
#                                                                        #
#   SH_XNMD_ERROR_OVERFLOW_ALIAS                                         #
#                                                                        #
##########################################################################

%shub_01_00482_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  50,  14, 0xFFFC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_HEADER_CANCEL_FIFO"  => [   1,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "Header Cancel Fifo Overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT"     => [   2,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Overflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT"    => [   3,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Underflow" ],
   "OVERFLOW_IILB_VC0_CREDIT"     => [   4,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Overflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT"    => [   5,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Underflow" ],
   "OVERFLOW_NI1_VC2_CREDIT"      => [   6,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT"     => [   7,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Underflow" ],
   "OVERFLOW_NI1_VC0_CREDIT"      => [   8,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Overflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT"     => [   9,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Underflow" ],
   "OVERFLOW_NI0_VC2_CREDIT"      => [  10,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Overflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT"     => [  11,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Underflow" ],
   "OVERFLOW_NI0_VC0_CREDIT"      => [  12,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Overflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT"     => [  13,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Underflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  14,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB Debit 2 Overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  15,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB Debit 0 Overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  16,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 2 Overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  17,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 0 Overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  18,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 2 Overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  19,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 0 Overflow" ],
   "OVERFLOW_SIC_CNTR2"           => [  20,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Overflow" ],
   "UNDERFLOW_SIC_CNTR2"          => [  21,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Underflow" ],
   "OVERFLOW_SIC_CNTR0"           => [  22,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Overflow" ],
   "UNDERFLOW_SIC_CNTR0"          => [  23,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Underflow" ],
   "UNCOR_ERROR3"                 => [  24,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 255:192" ],
   "UNCOR_ERROR2"                 => [  25,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 191:128" ],
   "UNCOR_ERROR1"                 => [  26,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 127:64" ],
   "UNCOR_ERROR0"                 => [  27,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 63:0" ],
   "SINGLE_BIT_ERROR3"            => [  28,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 255:192" ],
   "SINGLE_BIT_ERROR2"            => [  29,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 191:128" ],
   "SINGLE_BIT_ERROR1"            => [  30,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 127:64" ],
   "SINGLE_BIT_ERROR0"            => [  31,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 63:0" ],
   "LUT_READ_ERROR"               => [  32,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "OVERFLOW_DATABUFF_VC2"        => [  33,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VC2 Data Buffer overflow" ],
   "OVERFLOW_DATABUFF_VC0"        => [  34,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VC0 Data Buffer overflow" ],
   "OVERFLOW_VC2_CREDIT"          => [  35,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "VC2 Credit overflow" ],
   "UNDERFLOW_VC2_CREDIT"         => [  36,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "VC2 Credit underflow" ],
   "OVERFLOW_VC0_CREDIT"          => [  37,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "VC0 Credit overflow" ],
   "UNDERFLOW_VC0_CREDIT"         => [  38,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "VC0 Credit underflow" ],
   "OVERFLOW_IILB_VC2"            => [  39,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo overflow" ],
   "UNDERFLOW_IILB_VC2"           => [  40,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo underflow" ],
   "OVERFLOW_IILB_VC0"            => [  41,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo overflow" ],
   "UNDERFLOW_IILB_VC0"           => [  42,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo underflow" ],
   "OVERFLOW_NI1_VC2"             => [  43,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo overflow" ],
   "UNDERFLOW_NI1_VC2"            => [  44,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo underflow" ],
   "OVERFLOW_NI1_VC0"             => [  45,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo overflow" ],
   "UNDERFLOW_NI1_VC0"            => [  46,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo underflow" ],
   "OVERFLOW_NI0_VC2"             => [  47,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo overflow" ],
   "UNDERFLOW_NI0_VC2"            => [  48,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo underflow" ],
   "OVERFLOW_NI0_VC0"             => [  49,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo overflow" ],
   "UNDERFLOW_NI0_VC0"            => [  50,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo underflow" ],
);

%shub_01_00482_def =
( NAME    => "SH_XNMD_ERROR_OVERFLOW_ALIAS",
  ADDRESS => 0x0000000150040428,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00482_flds
);


##########################################################################
#                                                                        #
#   SH_XNMD_ERROR_MASK                                                   #
#                                                                        #
##########################################################################

%shub_01_00483_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  50,  14, 0xFFFC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_HEADER_CANCEL_FIFO"  => [   1,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "Header Cancel Fifo Overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT"     => [   2,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "IILB VC2 Credit Overflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT"    => [   3,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "IILB VC2 Credit Underflow" ],
   "OVERFLOW_IILB_VC0_CREDIT"     => [   4,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "IILB VC0 Credit Overflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT"    => [   5,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "IILB VC0 Credit Underflow" ],
   "OVERFLOW_NI1_VC2_CREDIT"      => [   6,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "NI1 VC2 Credit Overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT"     => [   7,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "NI1 VC2 Credit Underflow" ],
   "OVERFLOW_NI1_VC0_CREDIT"      => [   8,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "NI1 VC0 Credit Overflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT"     => [   9,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "NI1 VC0 Credit Underflow" ],
   "OVERFLOW_NI0_VC2_CREDIT"      => [  10,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "NI0 VC2 Credit Overflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT"     => [  11,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "NI0 VC2 Credit Underflow" ],
   "OVERFLOW_NI0_VC0_CREDIT"      => [  12,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "NI0 VC0 Credit Overflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT"     => [  13,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "NI0 VC0 Credit Underflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  14,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "IILB Debit 2 Overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  15,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "IILB Debit 0 Overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  16,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "NI1 Debit 2 Overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  17,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "NI1 Debit 0 Overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  18,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "NI0 Debit 2 Overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  19,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "NI0 Debit 0 Overflow" ],
   "OVERFLOW_SIC_CNTR2"           => [  20,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "SIC Counter 2 Overflow" ],
   "UNDERFLOW_SIC_CNTR2"          => [  21,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "SIC Counter 2 Underflow" ],
   "OVERFLOW_SIC_CNTR0"           => [  22,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "SIC Counter 0 Overflow" ],
   "UNDERFLOW_SIC_CNTR0"          => [  23,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "SIC Counter 0 Underflow" ],
   "UNCOR_ERROR3"                 => [  24,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "Uncorrectable Error in Bits 255:192" ],
   "UNCOR_ERROR2"                 => [  25,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Uncorrectable Error in Bits 191:128" ],
   "UNCOR_ERROR1"                 => [  26,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Uncorrectable Error in Bits 127:64" ],
   "UNCOR_ERROR0"                 => [  27,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "Uncorrectable Error in Bits 63:0" ],
   "SINGLE_BIT_ERROR3"            => [  28,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "Single Bit Error in Bits 255:192" ],
   "SINGLE_BIT_ERROR2"            => [  29,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "Single Bit Error in Bits 191:128" ],
   "SINGLE_BIT_ERROR1"            => [  30,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "Single Bit Error in Bits 127:64" ],
   "SINGLE_BIT_ERROR0"            => [  31,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "Single Bit Error in Bits 63:0" ],
   "LUT_READ_ERROR"               => [  32,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "LUT Read Error" ],
   "OVERFLOW_DATABUFF_VC2"        => [  33,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "VC2 Data Buffer overflow" ],
   "OVERFLOW_DATABUFF_VC0"        => [  34,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "VC0 Data Buffer overflow" ],
   "OVERFLOW_VC2_CREDIT"          => [  35,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "VC2 Credit overflow" ],
   "UNDERFLOW_VC2_CREDIT"         => [  36,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "VC2 Credit underflow" ],
   "OVERFLOW_VC0_CREDIT"          => [  37,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "VC0 Credit overflow" ],
   "UNDERFLOW_VC0_CREDIT"         => [  38,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "VC0 Credit underflow" ],
   "OVERFLOW_IILB_VC2"            => [  39,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "IILB VC2 fifo overflow" ],
   "UNDERFLOW_IILB_VC2"           => [  40,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "IILB VC2 fifo underflow" ],
   "OVERFLOW_IILB_VC0"            => [  41,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "IILB VC0 fifo overflow" ],
   "UNDERFLOW_IILB_VC0"           => [  42,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "IILB VC0 fifo underflow" ],
   "OVERFLOW_NI1_VC2"             => [  43,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "NI1 VC2 fifo overflow" ],
   "UNDERFLOW_NI1_VC2"            => [  44,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "NI1 VC2 fifo underflow" ],
   "OVERFLOW_NI1_VC0"             => [  45,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "NI1 VC0 fifo overflow" ],
   "UNDERFLOW_NI1_VC0"            => [  46,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "NI1 VC0 fifo underflow" ],
   "OVERFLOW_NI0_VC2"             => [  47,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "NI0 VC2 fifo overflow" ],
   "UNDERFLOW_NI0_VC2"            => [  48,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "NI0 VC2 fifo underflow" ],
   "OVERFLOW_NI0_VC0"             => [  49,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "NI0 VC0 fifo overflow" ],
   "UNDERFLOW_NI0_VC0"            => [  50,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "NI0 VC0 fifo underflow" ],
);

%shub_01_00483_def =
( NAME    => "SH_XNMD_ERROR_MASK",
  ADDRESS => 0x0000000150040440,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00483_flds
);


##########################################################################
#                                                                        #
#   SH_XNMD_FIRST_ERROR                                                  #
#                                                                        #
##########################################################################

%shub_01_00484_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  50,  14, 0xFFFC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_HEADER_CANCEL_FIFO"  => [   1,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "Header Cancel Fifo Overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT"     => [   2,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Overflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT"    => [   3,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Credit Underflow" ],
   "OVERFLOW_IILB_VC0_CREDIT"     => [   4,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Overflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT"    => [   5,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Credit Underflow" ],
   "OVERFLOW_NI1_VC2_CREDIT"      => [   6,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Overflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT"     => [   7,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 Credit Underflow" ],
   "OVERFLOW_NI1_VC0_CREDIT"      => [   8,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Overflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT"     => [   9,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 Credit Underflow" ],
   "OVERFLOW_NI0_VC2_CREDIT"      => [  10,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Overflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT"     => [  11,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 Credit Underflow" ],
   "OVERFLOW_NI0_VC0_CREDIT"      => [  12,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Overflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT"     => [  13,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 Credit Underflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  14,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB Debit 2 Overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  15,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "IILB Debit 0 Overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  16,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 2 Overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  17,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "NI1 Debit 0 Overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  18,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 2 Overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  19,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI0 Debit 0 Overflow" ],
   "OVERFLOW_SIC_CNTR2"           => [  20,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Overflow" ],
   "UNDERFLOW_SIC_CNTR2"          => [  21,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "SIC Counter 2 Underflow" ],
   "OVERFLOW_SIC_CNTR0"           => [  22,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Overflow" ],
   "UNDERFLOW_SIC_CNTR0"          => [  23,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "SIC Counter 0 Underflow" ],
   "UNCOR_ERROR3"                 => [  24,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 255:192" ],
   "UNCOR_ERROR2"                 => [  25,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 191:128" ],
   "UNCOR_ERROR1"                 => [  26,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 127:64" ],
   "UNCOR_ERROR0"                 => [  27,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Uncorrectable Error in Bits 63:0" ],
   "SINGLE_BIT_ERROR3"            => [  28,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 255:192" ],
   "SINGLE_BIT_ERROR2"            => [  29,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 191:128" ],
   "SINGLE_BIT_ERROR1"            => [  30,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 127:64" ],
   "SINGLE_BIT_ERROR0"            => [  31,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Single Bit Error in Bits 63:0" ],
   "LUT_READ_ERROR"               => [  32,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "OVERFLOW_DATABUFF_VC2"        => [  33,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "VC2 Data Buffer overflow" ],
   "OVERFLOW_DATABUFF_VC0"        => [  34,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "VC0 Data Buffer overflow" ],
   "OVERFLOW_VC2_CREDIT"          => [  35,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "VC2 Credit overflow" ],
   "UNDERFLOW_VC2_CREDIT"         => [  36,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "VC2 Credit underflow" ],
   "OVERFLOW_VC0_CREDIT"          => [  37,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "VC0 Credit overflow" ],
   "UNDERFLOW_VC0_CREDIT"         => [  38,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "VC0 Credit underflow" ],
   "OVERFLOW_IILB_VC2"            => [  39,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo overflow" ],
   "UNDERFLOW_IILB_VC2"           => [  40,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo underflow" ],
   "OVERFLOW_IILB_VC0"            => [  41,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo overflow" ],
   "UNDERFLOW_IILB_VC0"           => [  42,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo underflow" ],
   "OVERFLOW_NI1_VC2"             => [  43,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo overflow" ],
   "UNDERFLOW_NI1_VC2"            => [  44,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo underflow" ],
   "OVERFLOW_NI1_VC0"             => [  45,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo overflow" ],
   "UNDERFLOW_NI1_VC0"            => [  46,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo underflow" ],
   "OVERFLOW_NI0_VC2"             => [  47,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo overflow" ],
   "UNDERFLOW_NI0_VC2"            => [  48,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo underflow" ],
   "OVERFLOW_NI0_VC0"             => [  49,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo overflow" ],
   "UNDERFLOW_NI0_VC0"            => [  50,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo underflow" ],
);

%shub_01_00484_def =
( NAME    => "SH_XNMD_FIRST_ERROR",
  ADDRESS => 0x0000000150040460,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00484_flds
);


##########################################################################
#                                                                        #
#   SH_AUTO_REPLY_ENABLE0                                                #
#                                                                        #
##########################################################################

%shub_01_00485_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE0"                      => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Enable 0" ],
);

%shub_01_00485_def =
( NAME    => "SH_AUTO_REPLY_ENABLE0",
  ADDRESS => 0x0000000110061000,
  NOTE    => "Automatic Maintenance Reply Enable 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00485_flds
);


##########################################################################
#                                                                        #
#   SH_AUTO_REPLY_ENABLE1                                                #
#                                                                        #
##########################################################################

%shub_01_00486_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE1"                      => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Enable 1" ],
);

%shub_01_00486_def =
( NAME    => "SH_AUTO_REPLY_ENABLE1",
  ADDRESS => 0x0000000110061080,
  NOTE    => "Automatic Maintenance Reply Enable 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00486_flds
);


##########################################################################
#                                                                        #
#   SH_AUTO_REPLY_HEADER0                                                #
#                                                                        #
##########################################################################

%shub_01_00487_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER0"                      => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Header 0" ],
);

%shub_01_00487_def =
( NAME    => "SH_AUTO_REPLY_HEADER0",
  ADDRESS => 0x0000000110061100,
  NOTE    => "Automatic Maintenance Reply Header 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00487_flds
);


##########################################################################
#                                                                        #
#   SH_AUTO_REPLY_HEADER1                                                #
#                                                                        #
##########################################################################

%shub_01_00488_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER1"                      => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Header 1" ],
);

%shub_01_00488_def =
( NAME    => "SH_AUTO_REPLY_HEADER1",
  ADDRESS => 0x0000000110061180,
  NOTE    => "Automatic Maintenance Reply Header 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00488_flds
);


##########################################################################
#                                                                        #
#   SH_ENABLE_RP_AUTO_REPLY                                              #
#                                                                        #
##########################################################################

%shub_01_00489_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE"                       => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable Reply Auto Reply" ],
);

%shub_01_00489_def =
( NAME    => "SH_ENABLE_RP_AUTO_REPLY",
  ADDRESS => 0x0000000110061200,
  NOTE    => "Enable Automatic Maintenance Reply From Reply Queue",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00489_flds
);


##########################################################################
#                                                                        #
#   SH_ENABLE_RQ_AUTO_REPLY                                              #
#                                                                        #
##########################################################################

%shub_01_00490_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE"                       => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable Request Auto Reply" ],
);

%shub_01_00490_def =
( NAME    => "SH_ENABLE_RQ_AUTO_REPLY",
  ADDRESS => 0x0000000110061280,
  NOTE    => "Enable Automatic Maintenance Reply From Request Queue",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00490_flds
);


##########################################################################
#                                                                        #
#   SH_REDIRECT_INVAL                                                    #
#                                                                        #
##########################################################################

%shub_01_00491_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REDIRECT"                     => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Redirect invalidates to LB instead of MD" ],
);

%shub_01_00491_def =
( NAME    => "SH_REDIRECT_INVAL",
  ADDRESS => 0x0000000110061300,
  NOTE    => "Redirect invalidate to LB instead of PI",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00491_flds
);


##########################################################################
#                                                                        #
#   SH_DIAG_MSG_CNTRL                                                    #
#                                                                        #
##########################################################################

%shub_01_00492_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "BUSY"                         => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Busy" ],
   "START"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Start" ],
   "RSVD0"                        => [   2,  14,  48, 0x3FFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PORT"                         => [   3,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "0 = request port, 1 = reply port" ],
   "ERROR_INJECT_ENABLE"          => [   4,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Enable ERROR_INJECT_POINT field" ],
   "ERROR_INJECT_POINT"           => [   5,   6,   6, 0x0000000000000FC0, 0x00, 0, 0x0000000000000000, "Point message that the error bit would be activated" ],
   "MSG_LENGTH"                   => [   6,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "Message data payload length, 0 - 63" ],
);

%shub_01_00492_def =
( NAME    => "SH_DIAG_MSG_CNTRL",
  ADDRESS => 0x0000000110062000,
  NOTE    => "Diagnostic Message Control Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00492_flds
);


##########################################################################
#                                                                        #
#   SH_DIAG_MSG_DATA0L                                                   #
#                                                                        #
##########################################################################

%shub_01_00493_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_LOWER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Lower 64 bits of Diagnositic Message Data" ],
);

%shub_01_00493_def =
( NAME    => "SH_DIAG_MSG_DATA0L",
  ADDRESS => 0x0000000110062080,
  NOTE    => "Diagnostic Data, lower 64 bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00493_flds
);


##########################################################################
#                                                                        #
#   SH_DIAG_MSG_DATA0U                                                   #
#                                                                        #
##########################################################################

%shub_01_00494_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_UPPER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Upper 64 bits of Diagnositic Message Data" ],
);

%shub_01_00494_def =
( NAME    => "SH_DIAG_MSG_DATA0U",
  ADDRESS => 0x0000000110062100,
  NOTE    => "Diagnostice Data, upper 64 bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00494_flds
);


##########################################################################
#                                                                        #
#   SH_DIAG_MSG_DATA1L                                                   #
#                                                                        #
##########################################################################

%shub_01_00495_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_LOWER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Lower 64 bits of Diagnositic Message Data" ],
);

%shub_01_00495_def =
( NAME    => "SH_DIAG_MSG_DATA1L",
  ADDRESS => 0x0000000110062180,
  NOTE    => "Diagnostic Data, lower 64 bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00495_flds
);


##########################################################################
#                                                                        #
#   SH_DIAG_MSG_DATA1U                                                   #
#                                                                        #
##########################################################################

%shub_01_00496_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_UPPER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Upper 64 bits of Diagnositic Message Data" ],
);

%shub_01_00496_def =
( NAME    => "SH_DIAG_MSG_DATA1U",
  ADDRESS => 0x0000000110062200,
  NOTE    => "Diagnostice Data, upper 64 bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00496_flds
);


##########################################################################
#                                                                        #
#   SH_DIAG_MSG_DATA2L                                                   #
#                                                                        #
##########################################################################

%shub_01_00497_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_LOWER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Lower 64 bits of Diagnositic Message Data" ],
);

%shub_01_00497_def =
( NAME    => "SH_DIAG_MSG_DATA2L",
  ADDRESS => 0x0000000110062280,
  NOTE    => "Diagnostic Data, lower 64 bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00497_flds
);


##########################################################################
#                                                                        #
#   SH_DIAG_MSG_DATA2U                                                   #
#                                                                        #
##########################################################################

%shub_01_00498_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_UPPER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Upper 64 bits of Diagnositic Message Data" ],
);

%shub_01_00498_def =
( NAME    => "SH_DIAG_MSG_DATA2U",
  ADDRESS => 0x0000000110062300,
  NOTE    => "Diagnostice Data, upper 64 bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00498_flds
);


##########################################################################
#                                                                        #
#   SH_DIAG_MSG_DATA3L                                                   #
#                                                                        #
##########################################################################

%shub_01_00499_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_LOWER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Lower 64 bits of Diagnositic Message Data" ],
);

%shub_01_00499_def =
( NAME    => "SH_DIAG_MSG_DATA3L",
  ADDRESS => 0x0000000110062380,
  NOTE    => "Diagnostic Data, lower 64 bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00499_flds
);


##########################################################################
#                                                                        #
#   SH_DIAG_MSG_DATA3U                                                   #
#                                                                        #
##########################################################################

%shub_01_00500_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_UPPER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Upper 64 bits of Diagnositic Message Data" ],
);

%shub_01_00500_def =
( NAME    => "SH_DIAG_MSG_DATA3U",
  ADDRESS => 0x0000000110062400,
  NOTE    => "Diagnostice Data, upper 64 bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00500_flds
);


##########################################################################
#                                                                        #
#   SH_DIAG_MSG_DATA4L                                                   #
#                                                                        #
##########################################################################

%shub_01_00501_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_LOWER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Lower 64 bits of Diagnositic Message Data" ],
);

%shub_01_00501_def =
( NAME    => "SH_DIAG_MSG_DATA4L",
  ADDRESS => 0x0000000110062480,
  NOTE    => "Diagnostic Data, lower 64 bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00501_flds
);


##########################################################################
#                                                                        #
#   SH_DIAG_MSG_DATA4U                                                   #
#                                                                        #
##########################################################################

%shub_01_00502_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_UPPER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Upper 64 bits of Diagnositic Message Data" ],
);

%shub_01_00502_def =
( NAME    => "SH_DIAG_MSG_DATA4U",
  ADDRESS => 0x0000000110062500,
  NOTE    => "Diagnostice Data, upper 64 bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00502_flds
);


##########################################################################
#                                                                        #
#   SH_DIAG_MSG_DATA5L                                                   #
#                                                                        #
##########################################################################

%shub_01_00503_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_LOWER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Lower 64 bits of Diagnositic Message Data" ],
);

%shub_01_00503_def =
( NAME    => "SH_DIAG_MSG_DATA5L",
  ADDRESS => 0x0000000110062580,
  NOTE    => "Diagnostic Data, lower 64 bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00503_flds
);


##########################################################################
#                                                                        #
#   SH_DIAG_MSG_DATA5U                                                   #
#                                                                        #
##########################################################################

%shub_01_00504_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_UPPER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Upper 64 bits of Diagnositic Message Data" ],
);

%shub_01_00504_def =
( NAME    => "SH_DIAG_MSG_DATA5U",
  ADDRESS => 0x0000000110062600,
  NOTE    => "Diagnostice Data, upper 64 bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00504_flds
);


##########################################################################
#                                                                        #
#   SH_DIAG_MSG_DATA6L                                                   #
#                                                                        #
##########################################################################

%shub_01_00505_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_LOWER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Lower 64 bits of Diagnositic Message Data" ],
);

%shub_01_00505_def =
( NAME    => "SH_DIAG_MSG_DATA6L",
  ADDRESS => 0x0000000110062680,
  NOTE    => "Diagnostic Data, lower 64 bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00505_flds
);


##########################################################################
#                                                                        #
#   SH_DIAG_MSG_DATA6U                                                   #
#                                                                        #
##########################################################################

%shub_01_00506_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_UPPER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Upper 64 bits of Diagnositic Message Data" ],
);

%shub_01_00506_def =
( NAME    => "SH_DIAG_MSG_DATA6U",
  ADDRESS => 0x0000000110062700,
  NOTE    => "Diagnostice Data, upper 64 bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00506_flds
);


##########################################################################
#                                                                        #
#   SH_DIAG_MSG_DATA7L                                                   #
#                                                                        #
##########################################################################

%shub_01_00507_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_LOWER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Lower 64 bits of Diagnositic Message Data" ],
);

%shub_01_00507_def =
( NAME    => "SH_DIAG_MSG_DATA7L",
  ADDRESS => 0x0000000110062780,
  NOTE    => "Diagnostic Data, lower 64 bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00507_flds
);


##########################################################################
#                                                                        #
#   SH_DIAG_MSG_DATA7U                                                   #
#                                                                        #
##########################################################################

%shub_01_00508_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_UPPER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Upper 64 bits of Diagnositic Message Data" ],
);

%shub_01_00508_def =
( NAME    => "SH_DIAG_MSG_DATA7U",
  ADDRESS => 0x0000000110062800,
  NOTE    => "Diagnostice Data, upper 64 bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00508_flds
);


##########################################################################
#                                                                        #
#   SH_DIAG_MSG_DATA8L                                                   #
#                                                                        #
##########################################################################

%shub_01_00509_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_LOWER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Lower 64 bits of Diagnositic Message Data" ],
);

%shub_01_00509_def =
( NAME    => "SH_DIAG_MSG_DATA8L",
  ADDRESS => 0x0000000110062880,
  NOTE    => "Diagnostic Data, lower 64 bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00509_flds
);


##########################################################################
#                                                                        #
#   SH_DIAG_MSG_DATA8U                                                   #
#                                                                        #
##########################################################################

%shub_01_00510_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_UPPER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Upper 64 bits of Diagnositic Message Data" ],
);

%shub_01_00510_def =
( NAME    => "SH_DIAG_MSG_DATA8U",
  ADDRESS => 0x0000000110062900,
  NOTE    => "Diagnostice Data, upper 64 bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00510_flds
);


##########################################################################
#                                                                        #
#   SH_DIAG_MSG_HDR0                                                     #
#                                                                        #
##########################################################################

%shub_01_00511_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER0"                      => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Lower 64 bits of Diagnositic Message Header" ],
);

%shub_01_00511_def =
( NAME    => "SH_DIAG_MSG_HDR0",
  ADDRESS => 0x0000000110062980,
  NOTE    => "Diagnostice Data, lower 64 bits of header",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00511_flds
);


##########################################################################
#                                                                        #
#   SH_DIAG_MSG_HDR1                                                     #
#                                                                        #
##########################################################################

%shub_01_00512_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER1"                      => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Upper 64 bits of Diagnositic Message Header" ],
);

%shub_01_00512_def =
( NAME    => "SH_DIAG_MSG_HDR1",
  ADDRESS => 0x0000000110062a00,
  NOTE    => "Diagnostice Data, upper 64 bits of header",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00512_flds
);


##########################################################################
#                                                                        #
#   SH_DEBUG_SELECT                                                      #
#                                                                        #
##########################################################################

%shub_01_00513_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TRIGGER_ENABLE"               => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Enable trigger on bit 31 of Analyzer data" ],
   "RSVD0"                        => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEL_II"                       => [   2,  51,   9, 0x0FF8000000000000, 0x00, 1, 0x0000000000000000, "Select II to debug port" ],
   "DEBUG_II_SEL"                 => [   3,  48,   3, 0x0007000000000000, 0x00, 1, 0x0000000000000000, "Select bits to II port" ],
   "NIBBLE7_CHIPLET_SEL"          => [   4,  45,   3, 0x0000E00000000000, 0x00, 1, 0x0000000000000000, "Nibble7_chiplet_select" ],
   "NIBBLE7_NIBBLE_SEL"           => [   5,  42,   3, 0x00001C0000000000, 0x00, 1, 0x0000000000000000, "Nibble7_nibble_select" ],
   "NIBBLE6_CHIPLET_SEL"          => [   6,  39,   3, 0x0000038000000000, 0x00, 1, 0x0000000000000000, "Nibble6_chiplet_select" ],
   "NIBBLE6_NIBBLE_SEL"           => [   7,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "Nibble6_nibble_select" ],
   "NIBBLE5_CHIPLET_SEL"          => [   8,  33,   3, 0x0000000E00000000, 0x00, 1, 0x0000000000000000, "Nibble5_chiplet_select" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  30,   3, 0x00000001C0000000, 0x00, 1, 0x0000000000000000, "Nibble5_nibble_select" ],
   "NIBBLE4_CHIPLET_SEL"          => [  10,  27,   3, 0x0000000038000000, 0x00, 1, 0x0000000000000000, "Nibble4_chiplet_select" ],
   "NIBBLE4_NIBBLE_SEL"           => [  11,  24,   3, 0x0000000007000000, 0x00, 1, 0x0000000000000000, "Nibble4_nibble_select" ],
   "NIBBLE3_CHIPLET_SEL"          => [  12,  21,   3, 0x0000000000E00000, 0x00, 1, 0x0000000000000000, "Nibble3_chiplet_select" ],
   "NIBBLE3_NIBBLE_SEL"           => [  13,  18,   3, 0x00000000001C0000, 0x00, 1, 0x0000000000000000, "Nibble3_nibble_select" ],
   "NIBBLE2_CHIPLET_SEL"          => [  14,  15,   3, 0x0000000000038000, 0x00, 1, 0x0000000000000000, "Nibble2_chiplet_select" ],
   "NIBBLE2_NIBBLE_SEL"           => [  15,  12,   3, 0x0000000000007000, 0x00, 1, 0x0000000000000000, "Nibble2_nibble_select" ],
   "NIBBLE1_CHIPLET_SEL"          => [  16,   9,   3, 0x0000000000000E00, 0x00, 1, 0x0000000000000000, "Nibble1_chiplet_select" ],
   "NIBBLE1_NIBBLE_SEL"           => [  17,   6,   3, 0x00000000000001C0, 0x00, 1, 0x0000000000000000, "Nibble1_nibble_select" ],
   "NIBBLE0_CHIPLET_SEL"          => [  18,   3,   3, 0x0000000000000038, 0x00, 1, 0x0000000000000000, "Nibble0_chiplet_select" ],
   "NIBBLE0_NIBBLE_SEL"           => [  19,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Nibble0_nibble_select" ],
);

%shub_01_00513_def =
( NAME    => "SH_DEBUG_SELECT",
  ADDRESS => 0x0000000110063000,
  NOTE    => "SHub Debug Port Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00513_flds
);


##########################################################################
#                                                                        #
#   SH_TRIGGER_COMPARE_MASK                                              #
#                                                                        #
##########################################################################

%shub_01_00514_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MASK"                         => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "SHub Trigger Compare Mask" ],
);

%shub_01_00514_def =
( NAME    => "SH_TRIGGER_COMPARE_MASK",
  ADDRESS => 0x0000000110063080,
  NOTE    => "SHub Trigger Compare Mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00514_flds
);


##########################################################################
#                                                                        #
#   SH_TRIGGER_COMPARE_PATTERN                                           #
#                                                                        #
##########################################################################

%shub_01_00515_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA"                         => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "SHub Trigger Compare Pattern" ],
);

%shub_01_00515_def =
( NAME    => "SH_TRIGGER_COMPARE_PATTERN",
  ADDRESS => 0x0000000110063100,
  NOTE    => "SHub Trigger Compare Pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00515_flds
);


##########################################################################
#                                                                        #
#   SH_TRIGGER_SEL                                                       #
#                                                                        #
##########################################################################

%shub_01_00516_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_INPUT_SEL"            => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 input select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_INPUT_SEL"            => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 input select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_INPUT_SEL"            => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 input select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_INPUT_SEL"            => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 input select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_INPUT_SEL"            => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 input select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_INPUT_SEL"            => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 input select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_INPUT_SEL"            => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 input select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_INPUT_SEL"            => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 input select" ],
);

%shub_01_00516_def =
( NAME    => "SH_TRIGGER_SEL",
  ADDRESS => 0x0000000110063180,
  NOTE    => "Trigger select for SHUB debug port",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00516_flds
);


##########################################################################
#                                                                        #
#   SH_STOP_CLK_CONTROL                                                  #
#                                                                        #
##########################################################################

%shub_01_00517_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MODE"                         => [   1,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Clock stop mode select (0-internal, 1-external)" ],
   "POLARITY"                     => [   2,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Clock stop polarity select (0-negative edge, 1-positive edge)" ],
   "EVENT"                        => [   3,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Clock stop format select (1-level, 0-edge)" ],
   "STIMULUS"                     => [   4,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Clock stop stimulus" ],
);

%shub_01_00517_def =
( NAME    => "SH_STOP_CLK_CONTROL",
  ADDRESS => 0x0000000110064000,
  NOTE    => "Stop Clock Control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00517_flds
);


##########################################################################
#                                                                        #
#   SH_STOP_CLK_DELAY_PHASE                                              #
#                                                                        #
##########################################################################

%shub_01_00518_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DELAY"                        => [   1,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Delay phase" ],
);

%shub_01_00518_def =
( NAME    => "SH_STOP_CLK_DELAY_PHASE",
  ADDRESS => 0x0000000110064080,
  NOTE    => "Stop Clock Delay Phase",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00518_flds
);


##########################################################################
#                                                                        #
#   SH_TSF_ARM_MASK                                                      #
#                                                                        #
##########################################################################

%shub_01_00519_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility arm mask" ],
);

%shub_01_00519_def =
( NAME    => "SH_TSF_ARM_MASK",
  ADDRESS => 0x0000000110065000,
  NOTE    => "Trigger sequencing facility arm mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00519_flds
);


##########################################################################
#                                                                        #
#   SH_TSF_COUNTER_PRESETS                                               #
#                                                                        #
##########################################################################

%shub_01_00520_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COUNT_8A"                     => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 8a" ],
   "COUNT_8B"                     => [   1,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 8b" ],
   "COUNT_16"                     => [   2,  32,  16, 0x0000FFFF00000000, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 16" ],
   "COUNT_32"                     => [   3,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 32" ],
);

%shub_01_00520_def =
( NAME    => "SH_TSF_COUNTER_PRESETS",
  ADDRESS => 0x0000000110065080,
  NOTE    => "Trigger sequencing facility counter presets",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00520_flds
);


##########################################################################
#                                                                        #
#   SH_TSF_DECREMENT_CTL                                                 #
#                                                                        #
##########################################################################

%shub_01_00521_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CTL"                          => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter decrement control" ],
);

%shub_01_00521_def =
( NAME    => "SH_TSF_DECREMENT_CTL",
  ADDRESS => 0x0000000110065100,
  NOTE    => "Trigger sequencing facility counter decrement control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00521_flds
);


##########################################################################
#                                                                        #
#   SH_TSF_DIAG_MSG_CTL                                                  #
#                                                                        #
##########################################################################

%shub_01_00522_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE"                       => [   1,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Trigger sequencing facility diagnostic message control" ],
);

%shub_01_00522_def =
( NAME    => "SH_TSF_DIAG_MSG_CTL",
  ADDRESS => 0x0000000110065180,
  NOTE    => "Trigger sequencing facility diagnostic message control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00522_flds
);


##########################################################################
#                                                                        #
#   SH_TSF_DISARM_MASK                                                   #
#                                                                        #
##########################################################################

%shub_01_00523_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility disarm mask" ],
);

%shub_01_00523_def =
( NAME    => "SH_TSF_DISARM_MASK",
  ADDRESS => 0x0000000110065200,
  NOTE    => "Trigger sequencing facility disarm mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00523_flds
);


##########################################################################
#                                                                        #
#   SH_TSF_ENABLE_CTL                                                    #
#                                                                        #
##########################################################################

%shub_01_00524_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CTL"                          => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter enable control" ],
);

%shub_01_00524_def =
( NAME    => "SH_TSF_ENABLE_CTL",
  ADDRESS => 0x0000000110065280,
  NOTE    => "Trigger sequencing facility counter enable control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00524_flds
);


##########################################################################
#                                                                        #
#   SH_TSF_SOFTWARE_ARM                                                  #
#                                                                        #
##########################################################################

%shub_01_00525_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BIT7"                         => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm bit 7" ],
   "BIT6"                         => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm bit 6" ],
   "BIT5"                         => [   3,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm bit 5" ],
   "BIT4"                         => [   4,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm bit 4" ],
   "BIT3"                         => [   5,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm bit 3" ],
   "BIT2"                         => [   6,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm bit 2" ],
   "BIT1"                         => [   7,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm bit 1" ],
   "BIT0"                         => [   8,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm bit 0" ],
);

%shub_01_00525_def =
( NAME    => "SH_TSF_SOFTWARE_ARM",
  ADDRESS => 0x0000000110065300,
  NOTE    => "Trigger sequencing facility software arm",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00525_flds
);


##########################################################################
#                                                                        #
#   SH_TSF_SOFTWARE_DISARM                                               #
#                                                                        #
##########################################################################

%shub_01_00526_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BIT7"                         => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 7" ],
   "BIT6"                         => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 6" ],
   "BIT5"                         => [   3,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 5" ],
   "BIT4"                         => [   4,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 4" ],
   "BIT3"                         => [   5,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 3" ],
   "BIT2"                         => [   6,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 2" ],
   "BIT1"                         => [   7,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 1" ],
   "BIT0"                         => [   8,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 0" ],
);

%shub_01_00526_def =
( NAME    => "SH_TSF_SOFTWARE_DISARM",
  ADDRESS => 0x0000000110065380,
  NOTE    => "Trigger sequencing facility software disarm",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00526_flds
);


##########################################################################
#                                                                        #
#   SH_TSF_SOFTWARE_TRIGGERED                                            #
#                                                                        #
##########################################################################

%shub_01_00527_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BIT7"                         => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 7" ],
   "BIT6"                         => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 6" ],
   "BIT5"                         => [   3,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 5" ],
   "BIT4"                         => [   4,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 4" ],
   "BIT3"                         => [   5,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 3" ],
   "BIT2"                         => [   6,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 2" ],
   "BIT1"                         => [   7,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 1" ],
   "BIT0"                         => [   8,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 0" ],
);

%shub_01_00527_def =
( NAME    => "SH_TSF_SOFTWARE_TRIGGERED",
  ADDRESS => 0x0000000110065400,
  NOTE    => "Trigger sequencing facility software triggered",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00527_flds
);


##########################################################################
#                                                                        #
#   SH_TSF_TRIGGER_MASK                                                  #
#                                                                        #
##########################################################################

%shub_01_00528_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility trigger mask" ],
);

%shub_01_00528_def =
( NAME    => "SH_TSF_TRIGGER_MASK",
  ADDRESS => 0x0000000110065480,
  NOTE    => "Trigger sequencing facility trigger mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00528_flds
);


##########################################################################
#                                                                        #
#   SH_VEC_DATA                                                          #
#                                                                        #
##########################################################################

%shub_01_00529_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data" ],
);

%shub_01_00529_def =
( NAME    => "SH_VEC_DATA",
  ADDRESS => 0x0000000110066000,
  NOTE    => "Vector Write Request Message Data",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00529_flds
);


##########################################################################
#                                                                        #
#   SH_VEC_PARMS                                                         #
#                                                                        #
##########################################################################

%shub_01_00530_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "BUSY"                         => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Busy" ],
   "START"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Start" ],
   "RSVD0"                        => [   2,  46,  16, 0x3FFFC00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_ID"                       => [   3,  35,  11, 0x00003FF800000000, 0x00, 0, 0x0000000000000000, "PIO ID" ],
   "ADDRESS"                      => [   4,   3,  32, 0x00000007FFFFFFF8, 0x00, 0, 0x0000000000000000, "Address[34:3]" ],
   "RSVD1"                        => [   5,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_PORT"                      => [   6,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Network Interface Port Select" ],
   "TYPE"                         => [   7,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Vector Request Message Type" ],
);

%shub_01_00530_def =
( NAME    => "SH_VEC_PARMS",
  ADDRESS => 0x0000000110066080,
  NOTE    => "Vector Message Parameters Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00530_flds
);


##########################################################################
#                                                                        #
#   SH_VEC_ROUTE                                                         #
#                                                                        #
##########################################################################

%shub_01_00531_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ROUTE"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Route" ],
);

%shub_01_00531_def =
( NAME    => "SH_VEC_ROUTE",
  ADDRESS => 0x0000000110066100,
  NOTE    => "Vector Request Message Route",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00531_flds
);


##########################################################################
#                                                                        #
#   SH_CPU_PERM                                                          #
#                                                                        #
##########################################################################

%shub_01_00532_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits" ],
);

%shub_01_00532_def =
( NAME    => "SH_CPU_PERM",
  ADDRESS => 0x0000000110060000,
  NOTE    => "CPU MMR Access Permission Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00532_flds
);


##########################################################################
#                                                                        #
#   SH_CPU_PERM_OVR                                                      #
#                                                                        #
##########################################################################

%shub_01_00533_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "OVERRIDE"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Override" ],
);

%shub_01_00533_def =
( NAME    => "SH_CPU_PERM_OVR",
  ADDRESS => 0x0000000110060080,
  NOTE    => "CPU MMR Access Permission Override",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00533_flds
);


##########################################################################
#                                                                        #
#   SH_EXT_IO_PERM                                                       #
#                                                                        #
##########################################################################

%shub_01_00534_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits" ],
);

%shub_01_00534_def =
( NAME    => "SH_EXT_IO_PERM",
  ADDRESS => 0x0000000110060100,
  NOTE    => "External IO MMR Access Permission Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00534_flds
);


##########################################################################
#                                                                        #
#   SH_EXT_IOI_ACCESS                                                    #
#                                                                        #
##########################################################################

%shub_01_00535_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits" ],
);

%shub_01_00535_def =
( NAME    => "SH_EXT_IOI_ACCESS",
  ADDRESS => 0x0000000110060180,
  NOTE    => "External IO Interrupt Access Permission Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00535_flds
);


##########################################################################
#                                                                        #
#   SH_GC_FIL_CTRL                                                       #
#                                                                        #
##########################################################################

%shub_01_00536_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  58,   6, 0xFC00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERROR_COUNTER"                => [   1,  48,  10, 0x03FF000000000000, 0x00, 1, 0x0000000000000000, "Error counter" ],
   "RSVD1"                        => [   2,  46,   2, 0x0000C00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DROPOUT_THRESH"               => [   3,  36,  10, 0x00003FF000000000, 0x00, 1, 0x0000000000000000, "Dropout threshold" ],
   "RSVD2"                        => [   4,  34,   2, 0x0000000C00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DROPOUT_COUNTER"              => [   5,  24,  10, 0x00000003FF000000, 0x00, 1, 0x0000000000000000, "Dropout Counter" ],
   "RSVD3"                        => [   6,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MASK_ENABLE"                  => [   7,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "Mask Enable" ],
   "MASK_COUNTER"                 => [   8,   8,  12, 0x00000000000FFF00, 0x00, 1, 0x0000000000000000, "Mask Counter" ],
   "RSVD4"                        => [   9,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OFFSET"                       => [  10,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Offset" ],
);

%shub_01_00536_def =
( NAME    => "SH_GC_FIL_CTRL",
  ADDRESS => 0x0000000110060200,
  NOTE    => "SHub Global Clock Filter Control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00536_flds
);


##########################################################################
#                                                                        #
#   SH_GC_SRC_CTRL                                                       #
#                                                                        #
##########################################################################

%shub_01_00537_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SOURCE_SEL"                   => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "Source select (0=ext., 1=Int., 2=SHUB)" ],
   "RSVD1"                        => [   2,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TOGGLE_BIT"                   => [   3,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "Toggle bit" ],
   "RSVD2"                        => [   4,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNTER"                      => [   5,  16,  10, 0x0000000003FF0000, 0x00, 1, 0x0000000000000000, "Counter" ],
   "RSVD3"                        => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_COUNT"                    => [   7,   4,  10, 0x0000000000003FF0, 0x00, 1, 0x0000000000000000, "Max Count" ],
   "RSVD4"                        => [   8,   1,   3, 0x000000000000000E, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_COUNTER"               => [   9,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable Counter" ],
);

%shub_01_00537_def =
( NAME    => "SH_GC_SRC_CTRL",
  ADDRESS => 0x0000000110060280,
  NOTE    => "SHub Global Clock Control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00537_flds
);


##########################################################################
#                                                                        #
#   SH_HARD_RESET                                                        #
#                                                                        #
##########################################################################

%shub_01_00538_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HARD_RESET"                   => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Hard Reset" ],
);

%shub_01_00538_def =
( NAME    => "SH_HARD_RESET",
  ADDRESS => 0x0000000110060300,
  NOTE    => "SHub Hard Reset",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00538_flds
);


##########################################################################
#                                                                        #
#   SH_IO_PERM                                                           #
#                                                                        #
##########################################################################

%shub_01_00539_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits" ],
);

%shub_01_00539_def =
( NAME    => "SH_IO_PERM",
  ADDRESS => 0x0000000110060380,
  NOTE    => "II MMR Access Permission Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00539_flds
);


##########################################################################
#                                                                        #
#   SH_IOI_ACCESS                                                        #
#                                                                        #
##########################################################################

%shub_01_00540_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits" ],
);

%shub_01_00540_def =
( NAME    => "SH_IOI_ACCESS",
  ADDRESS => 0x0000000110060400,
  NOTE    => "II Interrupt Access Permission Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00540_flds
);


##########################################################################
#                                                                        #
#   SH_IPI_ACCESS                                                        #
#                                                                        #
##########################################################################

%shub_01_00541_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits" ],
);

%shub_01_00541_def =
( NAME    => "SH_IPI_ACCESS",
  ADDRESS => 0x0000000110060480,
  NOTE    => "IPI interrupt Access Permission Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00541_flds
);


##########################################################################
#                                                                        #
#   SH_JTAG_CONFIG                                                       #
#                                                                        #
##########################################################################

%shub_01_00542_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GTL_CONFIG_RE"                => [   1,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reference Enable selection for GTL io" ],
   "FSB_CONFIG_AUX"               => [   2,  53,   2, 0x0060000000000000, 0x00, 0, 0x0000000000000000, "Enables BIST" ],
   "FSB_CONFIG_ENABLE_BIST"       => [   3,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "Enables BIST" ],
   "FSB_CONFIG_OUTPUT_TRISTATE"   => [   4,  48,   4, 0x000F000000000000, 0x00, 0, 0x0000000000000000, "Output tristate control" ],
   "FSB_CONFIG_CLOCK_RATIO"       => [   5,  43,   5, 0x0000F80000000000, 0x00, 0, 0x0000000000000000, "" ],
   "FSB_CONFIG_ENABLE_BUS_PARKING" => [   6,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "" ],
   "FSB_CONFIG_SAMPLE_BINIT"      => [   7,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "Enable sampling of BINIT" ],
   "FSB_CONFIG_IOQ_DEPTH"         => [   8,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "In-order Queue Depth" ],
   "JTAG_MCI_OVERRIDE"            => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "jtag_mci_override" ],
   "JTAG_MCI_TARGET"              => [  10,  25,  14, 0x0000007FFE000000, 0x00, 0, 0x0000000000000000, "jtag_mci_target" ],
   "JTAG_MCI_RESET_DELAY"         => [  11,  21,   4, 0x0000000001E00000, 0x00, 0, 0x0000000000000000, "jtag_mci_reset_delay" ],
   "WRT90_OVERRIDE"               => [  12,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "wrt90_override" ],
   "WRT90_OVERRIDER"              => [  13,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "wrt90_overrideR" ],
   "WRT90_TARGET"                 => [  14,   5,  14, 0x000000000007FFE0, 0x00, 0, 0x0000000000000000, "wrt90_target" ],
   "II_CLK_SEL"                   => [  15,   3,   2, 0x0000000000000018, 0x00, 0, 0x0000000000000000, "Selects clock source for IOCLK domain" ],
   "NI_CLK_SEL"                   => [  16,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Selects clock source for NICLK domain" ],
   "MD_CLK_SEL"                   => [  17,   0,   2, 0x0000000000000003, 0x00, 0, 0x0000000000000000, "Select divide freq of DRAMCLK" ],
);

%shub_01_00542_def =
( NAME    => "SH_JTAG_CONFIG",
  ADDRESS => 0x0000000110060500,
  NOTE    => "SHub JTAG configuration",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00542_flds
);


##########################################################################
#                                                                        #
#   SH_SHUB_ID                                                           #
#                                                                        #
##########################################################################

%shub_01_00543_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  57,   7, 0xFE00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_PORT"                      => [   1,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI port of vector reference, 0 = NI0, 1 = NI1" ],
   "RSVD1"                        => [   2,  53,   3, 0x00E0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODES_PER_BIT"                => [   3,  48,   5, 0x001F000000000000, 0x00, 1, 0x0000000000000000, "Nodes Per Bit" ],
   "RSVD2"                        => [   4,  46,   2, 0x0000C00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SHARING_MODE"                 => [   5,  44,   2, 0x0000300000000000, 0x00, 1, 0x0000000000000000, "Sharing mode (Coherency Domain Size)" ],
   "RSVD3"                        => [   6,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   7,  32,  11, 0x000007FF00000000, 0x00, 1, 0x0000000000000000, "Node Identification" ],
   "REVISION"                     => [   8,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Revision" ],
   "PART_NUMBER"                  => [   9,  12,  16, 0x000000000FFFF000, 0x00, 0, 0x0000000000000000, "Part Number" ],
   "MANUFACTURER"                 => [  10,   1,  11, 0x0000000000000FFE, 0x00, 0, 0x0000000000000000, "Manufacturer" ],
   "FORCE1"                       => [  11,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Must be 1" ],
);

%shub_01_00543_def =
( NAME    => "SH_SHUB_ID",
  ADDRESS => 0x0000000110060580,
  NOTE    => "SHub ID Number",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00543_flds
);


##########################################################################
#                                                                        #
#   SH_SHUBS_PRESENT0                                                    #
#                                                                        #
##########################################################################

%shub_01_00544_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SHUBS_PRESENT0"               => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Shubs 0 - 63 Present configuration" ],
);

%shub_01_00544_def =
( NAME    => "SH_SHUBS_PRESENT0",
  ADDRESS => 0x0000000110060600,
  NOTE    => "Shubs 0 - 63 Present. Used for invalidate generation",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00544_flds
);


##########################################################################
#                                                                        #
#   SH_SHUBS_PRESENT1                                                    #
#                                                                        #
##########################################################################

%shub_01_00545_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SHUBS_PRESENT1"               => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Shubs 64 - 127 Present configuration" ],
);

%shub_01_00545_def =
( NAME    => "SH_SHUBS_PRESENT1",
  ADDRESS => 0x0000000110060680,
  NOTE    => "Shubs 64 - 127 Present. Used for invalidate generation",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00545_flds
);


##########################################################################
#                                                                        #
#   SH_SHUBS_PRESENT2                                                    #
#                                                                        #
##########################################################################

%shub_01_00546_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SHUBS_PRESENT2"               => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Shubs 128 - 191 Present configuration" ],
);

%shub_01_00546_def =
( NAME    => "SH_SHUBS_PRESENT2",
  ADDRESS => 0x0000000110060700,
  NOTE    => "Shubs 128 - 191 Present. Used for invalidate generation",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00546_flds
);


##########################################################################
#                                                                        #
#   SH_SHUBS_PRESENT3                                                    #
#                                                                        #
##########################################################################

%shub_01_00547_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SHUBS_PRESENT3"               => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Shubs 192 - 255 Present configuration" ],
);

%shub_01_00547_def =
( NAME    => "SH_SHUBS_PRESENT3",
  ADDRESS => 0x0000000110060780,
  NOTE    => "Shubs 192 - 255 Present. Used for invalidate generation",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00547_flds
);


##########################################################################
#                                                                        #
#   SH_SOFT_RESET                                                        #
#                                                                        #
##########################################################################

%shub_01_00548_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SOFT_RESET"                   => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Soft Reset" ],
);

%shub_01_00548_def =
( NAME    => "SH_SOFT_RESET",
  ADDRESS => 0x0000000110060800,
  NOTE    => "SHub Soft Reset",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00548_flds
);


##########################################################################
#                                                                        #
#   SH_FIRST_ERROR                                                       #
#                                                                        #
##########################################################################

%shub_01_00549_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  19,  45, 0xFFFFFFFFFFF80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PROC_3_ERR"                   => [   1,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "Processor 3 Error" ],
   "PROC_2_ERR"                   => [   2,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "Processor 2 Error" ],
   "PROC_1_ERR"                   => [   3,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Processor 1 Error" ],
   "PROC_0_ERR"                   => [   4,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Processor 0 Error" ],
   "PROC_3_ADV"                   => [   5,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Processor 3 Advisory" ],
   "PROC_2_ADV"                   => [   6,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Processor 2 Advisory" ],
   "PROC_1_ADV"                   => [   7,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Processor 1 Advisory" ],
   "PROC_0_ADV"                   => [   8,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "Processor O Advisory" ],
   "XN_UCE_INT"                   => [   9,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "LB received XN_UC_INT - Uncorrectable Data Error" ],
   "MD_UCE_INT"                   => [  10,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "LB received MD_UC_INT - Uncorrectable Data Error" ],
   "PI_UCE_INT"                   => [  11,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "LB received PI_UC_INT - Uncorrectable Data Error" ],
   "XN_CE_INT"                    => [  12,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "LB received XN_CE_INT - Correctable Data Error" ],
   "MD_CE_INT"                    => [  13,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "LB received MD_CE_INT - Correctable Data Error" ],
   "PI_CE_INT"                    => [  14,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "LB received PI_CE_INT - Correctable Data Error" ],
   "II_HW_INT"                    => [  15,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "LB received II_HW_INT - Not wired in Shub 1x" ],
   "LB_HW_INT"                    => [  16,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "LB received LB_HW_INT - Hardware Error" ],
   "XN_HW_INT"                    => [  17,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "LB received XN_HW_INT - Hardware Error" ],
   "MD_HW_INT"                    => [  18,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "LB received MD_HW_INT - Hardware Error" ],
   "PI_HW_INT"                    => [  19,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "LB received PI_HW_INT - Hardware Error" ],
);

%shub_01_00549_def =
( NAME    => "SH_FIRST_ERROR",
  ADDRESS => 0x0000000110071000,
  NOTE    => "SHub Global First Error Flags",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00549_flds
);


##########################################################################
#                                                                        #
#   SH_II_HW_TIME_STAMP                                                  #
#                                                                        #
##########################################################################

%shub_01_00550_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid Flag" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Time Stamp Value" ],
);

%shub_01_00550_def =
( NAME    => "SH_II_HW_TIME_STAMP",
  ADDRESS => 0x0000000110071080,
  NOTE    => "II Hardware Error Time Stamp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00550_flds
);


##########################################################################
#                                                                        #
#   SH_LB_HW_TIME_STAMP                                                  #
#                                                                        #
##########################################################################

%shub_01_00551_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid Flag" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Time Stamp Value" ],
);

%shub_01_00551_def =
( NAME    => "SH_LB_HW_TIME_STAMP",
  ADDRESS => 0x0000000110071100,
  NOTE    => "LB Hardware Error Time Stamp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00551_flds
);


##########################################################################
#                                                                        #
#   SH_MD_COR_TIME_STAMP                                                 #
#                                                                        #
##########################################################################

%shub_01_00552_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid Flag" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Time Stamp Value" ],
);

%shub_01_00552_def =
( NAME    => "SH_MD_COR_TIME_STAMP",
  ADDRESS => 0x0000000110071180,
  NOTE    => "MD Correctable Data Error Time Stamp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00552_flds
);


##########################################################################
#                                                                        #
#   SH_MD_HW_TIME_STAMP                                                  #
#                                                                        #
##########################################################################

%shub_01_00553_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid Flag" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Time Stamp Value" ],
);

%shub_01_00553_def =
( NAME    => "SH_MD_HW_TIME_STAMP",
  ADDRESS => 0x0000000110071200,
  NOTE    => "MD Hardware Error Time Stamp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00553_flds
);


##########################################################################
#                                                                        #
#   SH_MD_UNCOR_TIME_STAMP                                               #
#                                                                        #
##########################################################################

%shub_01_00554_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid Flag" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Time Stamp Value" ],
);

%shub_01_00554_def =
( NAME    => "SH_MD_UNCOR_TIME_STAMP",
  ADDRESS => 0x0000000110071280,
  NOTE    => "MD Uncorrectable Data Error Time Stamp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00554_flds
);


##########################################################################
#                                                                        #
#   SH_PI_COR_TIME_STAMP                                                 #
#                                                                        #
##########################################################################

%shub_01_00555_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid Flag" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Time Stamp Value" ],
);

%shub_01_00555_def =
( NAME    => "SH_PI_COR_TIME_STAMP",
  ADDRESS => 0x0000000110071300,
  NOTE    => "PI Correctable Data Error Time Stamp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00555_flds
);


##########################################################################
#                                                                        #
#   SH_PI_HW_TIME_STAMP                                                  #
#                                                                        #
##########################################################################

%shub_01_00556_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid Flag" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Time Stamp Value" ],
);

%shub_01_00556_def =
( NAME    => "SH_PI_HW_TIME_STAMP",
  ADDRESS => 0x0000000110071380,
  NOTE    => "PI Hardware Error Time Stamp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00556_flds
);


##########################################################################
#                                                                        #
#   SH_PI_UNCOR_TIME_STAMP                                               #
#                                                                        #
##########################################################################

%shub_01_00557_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid Flag" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Time Stamp Value" ],
);

%shub_01_00557_def =
( NAME    => "SH_PI_UNCOR_TIME_STAMP",
  ADDRESS => 0x0000000110071400,
  NOTE    => "PI Uncorrectable Data Error Time Stamp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00557_flds
);


##########################################################################
#                                                                        #
#   SH_PROC0_ADV_TIME_STAMP                                              #
#                                                                        #
##########################################################################

%shub_01_00558_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid Flag" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Time Stamp Value" ],
);

%shub_01_00558_def =
( NAME    => "SH_PROC0_ADV_TIME_STAMP",
  ADDRESS => 0x0000000110071480,
  NOTE    => "Processor 0 Advisory Time Stamp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00558_flds
);


##########################################################################
#                                                                        #
#   SH_PROC0_ERR_TIME_STAMP                                              #
#                                                                        #
##########################################################################

%shub_01_00559_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid Flag" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Time Stamp Value" ],
);

%shub_01_00559_def =
( NAME    => "SH_PROC0_ERR_TIME_STAMP",
  ADDRESS => 0x0000000110071500,
  NOTE    => "Processor 0 Error Time Stamp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00559_flds
);


##########################################################################
#                                                                        #
#   SH_PROC1_ADV_TIME_STAMP                                              #
#                                                                        #
##########################################################################

%shub_01_00560_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid Flag" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Time Stamp Value" ],
);

%shub_01_00560_def =
( NAME    => "SH_PROC1_ADV_TIME_STAMP",
  ADDRESS => 0x0000000110071580,
  NOTE    => "Processor 1 Advisory Time Stamp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00560_flds
);


##########################################################################
#                                                                        #
#   SH_PROC1_ERR_TIME_STAMP                                              #
#                                                                        #
##########################################################################

%shub_01_00561_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid Flag" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Time Stamp Value" ],
);

%shub_01_00561_def =
( NAME    => "SH_PROC1_ERR_TIME_STAMP",
  ADDRESS => 0x0000000110071600,
  NOTE    => "Processor 1 Error Time Stamp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00561_flds
);


##########################################################################
#                                                                        #
#   SH_PROC2_ADV_TIME_STAMP                                              #
#                                                                        #
##########################################################################

%shub_01_00562_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid Flag" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Time Stamp Value" ],
);

%shub_01_00562_def =
( NAME    => "SH_PROC2_ADV_TIME_STAMP",
  ADDRESS => 0x0000000110071680,
  NOTE    => "Processor 2 Advisory Time Stamp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00562_flds
);


##########################################################################
#                                                                        #
#   SH_PROC2_ERR_TIME_STAMP                                              #
#                                                                        #
##########################################################################

%shub_01_00563_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid Flag" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Time Stamp Value" ],
);

%shub_01_00563_def =
( NAME    => "SH_PROC2_ERR_TIME_STAMP",
  ADDRESS => 0x0000000110071700,
  NOTE    => "Processor 2 Error Time Stamp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00563_flds
);


##########################################################################
#                                                                        #
#   SH_PROC3_ADV_TIME_STAMP                                              #
#                                                                        #
##########################################################################

%shub_01_00564_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid Flag" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Time Stamp Value" ],
);

%shub_01_00564_def =
( NAME    => "SH_PROC3_ADV_TIME_STAMP",
  ADDRESS => 0x0000000110071780,
  NOTE    => "Processor 3 Advisory Time Stamp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00564_flds
);


##########################################################################
#                                                                        #
#   SH_PROC3_ERR_TIME_STAMP                                              #
#                                                                        #
##########################################################################

%shub_01_00565_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid Flag" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Time Stamp Value" ],
);

%shub_01_00565_def =
( NAME    => "SH_PROC3_ERR_TIME_STAMP",
  ADDRESS => 0x0000000110071800,
  NOTE    => "Processor 3 Error Time Stamp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00565_flds
);


##########################################################################
#                                                                        #
#   SH_XN_COR_TIME_STAMP                                                 #
#                                                                        #
##########################################################################

%shub_01_00566_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid Flag" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Time Stamp Value" ],
);

%shub_01_00566_def =
( NAME    => "SH_XN_COR_TIME_STAMP",
  ADDRESS => 0x0000000110071880,
  NOTE    => "XN Correctable Data Error Time Stamp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00566_flds
);


##########################################################################
#                                                                        #
#   SH_XN_HW_TIME_STAMP                                                  #
#                                                                        #
##########################################################################

%shub_01_00567_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid Flag" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Time Stamp Value" ],
);

%shub_01_00567_def =
( NAME    => "SH_XN_HW_TIME_STAMP",
  ADDRESS => 0x0000000110071900,
  NOTE    => "XN Hardware Error Time Stamp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00567_flds
);


##########################################################################
#                                                                        #
#   SH_XN_UNCOR_TIME_STAMP                                               #
#                                                                        #
##########################################################################

%shub_01_00568_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid Flag" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Time Stamp Value" ],
);

%shub_01_00568_def =
( NAME    => "SH_XN_UNCOR_TIME_STAMP",
  ADDRESS => 0x0000000110071980,
  NOTE    => "XN Uncorrectable Data Error Time Stamp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00568_flds
);


##########################################################################
#                                                                        #
#   SH_DEBUG_PORT                                                        #
#                                                                        #
##########################################################################

%shub_01_00569_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_NIBBLE7"                => [   1,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Debug port nibble 7" ],
   "DEBUG_NIBBLE6"                => [   2,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "Debug port nibble 6" ],
   "DEBUG_NIBBLE5"                => [   3,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Debug port nibble 5" ],
   "DEBUG_NIBBLE4"                => [   4,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "Debug port nibble 4" ],
   "DEBUG_NIBBLE3"                => [   5,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Debug port nibble 3" ],
   "DEBUG_NIBBLE2"                => [   6,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Debug port nibble 2" ],
   "DEBUG_NIBBLE1"                => [   7,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Debug port nibble 1" ],
   "DEBUG_NIBBLE0"                => [   8,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Debug port nibble 0" ],
);

%shub_01_00569_def =
( NAME    => "SH_DEBUG_PORT",
  ADDRESS => 0x0000000110072000,
  NOTE    => "SHub Debug Port",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00569_flds
);


##########################################################################
#                                                                        #
#   SH_II_DEBUG_DATA                                                     #
#                                                                        #
##########################################################################

%shub_01_00570_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "II_DATA"                      => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "II debug data" ],
);

%shub_01_00570_def =
( NAME    => "SH_II_DEBUG_DATA",
  ADDRESS => 0x0000000110072080,
  NOTE    => "II Debug Data",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00570_flds
);


##########################################################################
#                                                                        #
#   SH_II_WRAP_DEBUG_DATA                                                #
#                                                                        #
##########################################################################

%shub_01_00571_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "II_WRAP_DATA"                 => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "II wrapper debug data" ],
);

%shub_01_00571_def =
( NAME    => "SH_II_WRAP_DEBUG_DATA",
  ADDRESS => 0x0000000110072100,
  NOTE    => "SHub II Wrapper Debug Data",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00571_flds
);


##########################################################################
#                                                                        #
#   SH_LB_DEBUG_DATA                                                     #
#                                                                        #
##########################################################################

%shub_01_00572_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LB_DATA"                      => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "LB debug data" ],
);

%shub_01_00572_def =
( NAME    => "SH_LB_DEBUG_DATA",
  ADDRESS => 0x0000000110072180,
  NOTE    => "SHub LB Debug Data",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00572_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DEBUG_DATA                                                     #
#                                                                        #
##########################################################################

%shub_01_00573_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MD_DATA"                      => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "MD debug data" ],
);

%shub_01_00573_def =
( NAME    => "SH_MD_DEBUG_DATA",
  ADDRESS => 0x0000000110072200,
  NOTE    => "SHub MD Debug Data",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00573_flds
);


##########################################################################
#                                                                        #
#   SH_PI_DEBUG_DATA                                                     #
#                                                                        #
##########################################################################

%shub_01_00574_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PI_DATA"                      => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "PI Debug Data" ],
);

%shub_01_00574_def =
( NAME    => "SH_PI_DEBUG_DATA",
  ADDRESS => 0x0000000110072280,
  NOTE    => "SHub PI Debug Data",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00574_flds
);


##########################################################################
#                                                                        #
#   SH_XN_DEBUG_DATA                                                     #
#                                                                        #
##########################################################################

%shub_01_00575_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_DATA"                      => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "XN debug data" ],
);

%shub_01_00575_def =
( NAME    => "SH_XN_DEBUG_DATA",
  ADDRESS => 0x0000000110072300,
  NOTE    => "SHub XN Debug Data",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00575_flds
);


##########################################################################
#                                                                        #
#   SH_TSF_ARMED_STATE                                                   #
#                                                                        #
##########################################################################

%shub_01_00576_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STATE"                        => [   1,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility armed state" ],
);

%shub_01_00576_def =
( NAME    => "SH_TSF_ARMED_STATE",
  ADDRESS => 0x0000000110073000,
  NOTE    => "Trigger sequencing facility arm state",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00576_flds
);


##########################################################################
#                                                                        #
#   SH_TSF_COUNTER_VALUE                                                 #
#                                                                        #
##########################################################################

%shub_01_00577_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COUNT_8A"                     => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 8a" ],
   "COUNT_8B"                     => [   1,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 8b" ],
   "COUNT_16"                     => [   2,  32,  16, 0x0000FFFF00000000, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 16" ],
   "COUNT_32"                     => [   3,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 32" ],
);

%shub_01_00577_def =
( NAME    => "SH_TSF_COUNTER_VALUE",
  ADDRESS => 0x0000000110073080,
  NOTE    => "Trigger sequencing facility counter value",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00577_flds
);


##########################################################################
#                                                                        #
#   SH_TSF_TRIGGERED_STATE                                               #
#                                                                        #
##########################################################################

%shub_01_00578_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STATE"                        => [   1,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility triggered state" ],
);

%shub_01_00578_def =
( NAME    => "SH_TSF_TRIGGERED_STATE",
  ADDRESS => 0x0000000110073100,
  NOTE    => "Trigger sequencing facility triggered state",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00578_flds
);


##########################################################################
#                                                                        #
#   SH_VEC_RDDATA                                                        #
#                                                                        #
##########################################################################

%shub_01_00579_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data" ],
);

%shub_01_00579_def =
( NAME    => "SH_VEC_RDDATA",
  ADDRESS => 0x0000000110074000,
  NOTE    => "Vector Reply Message Data",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00579_flds
);


##########################################################################
#                                                                        #
#   SH_VEC_RETURN                                                        #
#                                                                        #
##########################################################################

%shub_01_00580_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ROUTE"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Route" ],
);

%shub_01_00580_def =
( NAME    => "SH_VEC_RETURN",
  ADDRESS => 0x0000000110074080,
  NOTE    => "Vector Reply Message Return Route",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00580_flds
);


##########################################################################
#                                                                        #
#   SH_VEC_STATUS                                                        #
#                                                                        #
##########################################################################

%shub_01_00581_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATUS_VALID"                 => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Status_Valid" ],
   "OVERRUN"                      => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Overrun" ],
   "RSVD0"                        => [   2,  60,   2, 0x3000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SOURCE"                       => [   3,  46,  14, 0x0FFFC00000000000, 0x00, 0, 0x0000000000000000, "Source" ],
   "PIO_ID"                       => [   4,  35,  11, 0x00003FF800000000, 0x00, 0, 0x0000000000000000, "PIO ID" ],
   "ADDRESS"                      => [   5,   3,  32, 0x00000007FFFFFFF8, 0x00, 0, 0x0000000000000000, "Address" ],
   "TYPE"                         => [   6,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Type" ],
);

%shub_01_00581_def =
( NAME    => "SH_VEC_STATUS",
  ADDRESS => 0x0000000110074100,
  NOTE    => "Vector Reply Message Status",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00581_flds
);


##########################################################################
#                                                                        #
#   SH_VEC_STATUS_ALIAS                                                  #
#                                                                        #
##########################################################################

%shub_01_00582_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATUS_VALID"                 => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Status_Valid" ],
   "OVERRUN"                      => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Overrun" ],
   "RSVD0"                        => [   2,  60,   2, 0x3000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SOURCE"                       => [   3,  46,  14, 0x0FFFC00000000000, 0x00, 0, 0x0000000000000000, "Source" ],
   "PIO_ID"                       => [   4,  35,  11, 0x00003FF800000000, 0x00, 0, 0x0000000000000000, "PIO ID" ],
   "ADDRESS"                      => [   5,   3,  32, 0x00000007FFFFFFF8, 0x00, 0, 0x0000000000000000, "Address" ],
   "TYPE"                         => [   6,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Type" ],
);

%shub_01_00582_def =
( NAME    => "SH_VEC_STATUS_ALIAS",
  ADDRESS => 0x0000000110074108,
  NOTE    => "Vector Reply Message Status Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00582_flds
);


##########################################################################
#                                                                        #
#   SH_PERFORMANCE_COUNT0_CONTROL                                        #
#                                                                        #
##########################################################################

%shub_01_00583_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  19,  45, 0xFFFFFFFFFFF80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   1,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "Counter 0 enable peak detection" ],
   "DEC_ENABLE"                   => [   2,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "Counter 0 enable decrement" ],
   "INC_ENABLE"                   => [   3,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Counter 0 enable increment" ],
   "DN_MODE"                      => [   4,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Counter 0 down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [   5,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Counter 0 down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [   6,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Counter 0 down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [   7,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "Counter 0 down stimulus" ],
   "UP_MODE"                      => [   8,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Counter 0 up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [   9,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Counter 0 up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  10,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Counter 0 up format select (1-level, 0-edge)" ],
   "UP_STIMULUS"                  => [  11,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Counter 0 up stimulus" ],
);

%shub_01_00583_def =
( NAME    => "SH_PERFORMANCE_COUNT0_CONTROL",
  ADDRESS => 0x0000000110080000,
  NOTE    => "Performance Counter 0 Control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00583_flds
);


##########################################################################
#                                                                        #
#   SH_PERFORMANCE_COUNT1_CONTROL                                        #
#                                                                        #
##########################################################################

%shub_01_00584_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  19,  45, 0xFFFFFFFFFFF80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   1,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "Counter 1 enable peak detection" ],
   "DEC_ENABLE"                   => [   2,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "Counter 1 enable decrement" ],
   "INC_ENABLE"                   => [   3,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Counter 1 enable increment" ],
   "DN_MODE"                      => [   4,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Counter 1 down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [   5,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Counter 1 down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [   6,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Counter 1 down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [   7,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "Counter 1 down stimulus" ],
   "UP_MODE"                      => [   8,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Counter 1 up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [   9,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Counter 1 up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  10,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Counter 1 up format select (1-level, 0-edge)" ],
   "UP_STIMULUS"                  => [  11,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Counter 1 up stimulus" ],
);

%shub_01_00584_def =
( NAME    => "SH_PERFORMANCE_COUNT1_CONTROL",
  ADDRESS => 0x0000000110090000,
  NOTE    => "Performance Counter 1 Control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00584_flds
);


##########################################################################
#                                                                        #
#   SH_PERFORMANCE_COUNT2_CONTROL                                        #
#                                                                        #
##########################################################################

%shub_01_00585_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  19,  45, 0xFFFFFFFFFFF80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   1,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "Counter 2 enable peak detection" ],
   "DEC_ENABLE"                   => [   2,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "Counter 2 enable decrement" ],
   "INC_ENABLE"                   => [   3,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Counter 2 enable increment" ],
   "DN_MODE"                      => [   4,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Counter 2 down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [   5,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Counter 2 down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [   6,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Counter 2 down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [   7,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "Counter 2 down stimulus" ],
   "UP_MODE"                      => [   8,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Counter 2 up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [   9,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Counter 2 up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  10,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Counter 2 up format select (1-level, 0-edge)" ],
   "UP_STIMULUS"                  => [  11,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Counter 2 up stimulus" ],
);

%shub_01_00585_def =
( NAME    => "SH_PERFORMANCE_COUNT2_CONTROL",
  ADDRESS => 0x00000001100a0000,
  NOTE    => "Performance Counter 2 Control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00585_flds
);


##########################################################################
#                                                                        #
#   SH_PERFORMANCE_COUNT3_CONTROL                                        #
#                                                                        #
##########################################################################

%shub_01_00586_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  19,  45, 0xFFFFFFFFFFF80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   1,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "Counter 3 enable peak detection" ],
   "DEC_ENABLE"                   => [   2,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "Counter 3 enable decrement" ],
   "INC_ENABLE"                   => [   3,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Counter 3 enable increment" ],
   "DN_MODE"                      => [   4,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Counter 3 down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [   5,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Counter 3 down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [   6,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Counter 3 down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [   7,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "Counter 3 down stimulus" ],
   "UP_MODE"                      => [   8,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Counter 3 up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [   9,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Counter 3 up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  10,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Counter 3 up format select (1-level, 0-edge)" ],
   "UP_STIMULUS"                  => [  11,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Counter 3 up stimulus" ],
);

%shub_01_00586_def =
( NAME    => "SH_PERFORMANCE_COUNT3_CONTROL",
  ADDRESS => 0x00000001100b0000,
  NOTE    => "Performance Counter 3 Control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00586_flds
);


##########################################################################
#                                                                        #
#   SH_PERFORMANCE_COUNT4_CONTROL                                        #
#                                                                        #
##########################################################################

%shub_01_00587_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  19,  45, 0xFFFFFFFFFFF80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   1,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "Counter 4 enable peak detection" ],
   "DEC_ENABLE"                   => [   2,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "Counter 4 enable decrement" ],
   "INC_ENABLE"                   => [   3,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Counter 4 enable increment" ],
   "DN_MODE"                      => [   4,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Counter 4 down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [   5,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Counter 4 down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [   6,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Counter 4 down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [   7,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "Counter 4 down stimulus" ],
   "UP_MODE"                      => [   8,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Counter 4 up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [   9,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Counter 4 up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  10,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Counter 4 up format select (1-level, 0-edge)" ],
   "UP_STIMULUS"                  => [  11,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Counter 4 up stimulus" ],
);

%shub_01_00587_def =
( NAME    => "SH_PERFORMANCE_COUNT4_CONTROL",
  ADDRESS => 0x00000001100c0000,
  NOTE    => "Performance Counter 4 Control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00587_flds
);


##########################################################################
#                                                                        #
#   SH_PERFORMANCE_COUNT5_CONTROL                                        #
#                                                                        #
##########################################################################

%shub_01_00588_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  19,  45, 0xFFFFFFFFFFF80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   1,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "Counter 5 enable peak detection" ],
   "DEC_ENABLE"                   => [   2,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "Counter 5 enable decrement" ],
   "INC_ENABLE"                   => [   3,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Counter 5 enable increment" ],
   "DN_MODE"                      => [   4,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Counter 5 down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [   5,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Counter 5 down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [   6,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Counter 5 down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [   7,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "Counter 5 down stimulus" ],
   "UP_MODE"                      => [   8,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Counter 5 up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [   9,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Counter 5 up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  10,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Counter 5 up format select (1-level, 0-edge)" ],
   "UP_STIMULUS"                  => [  11,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Counter 5 up stimulus" ],
);

%shub_01_00588_def =
( NAME    => "SH_PERFORMANCE_COUNT5_CONTROL",
  ADDRESS => 0x00000001100d0000,
  NOTE    => "Performance Counter 5 Control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00588_flds
);


##########################################################################
#                                                                        #
#   SH_PERFORMANCE_COUNT6_CONTROL                                        #
#                                                                        #
##########################################################################

%shub_01_00589_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  19,  45, 0xFFFFFFFFFFF80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   1,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "Counter 6 enable peak detection" ],
   "DEC_ENABLE"                   => [   2,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "Counter 6 enable decrement" ],
   "INC_ENABLE"                   => [   3,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Counter 6 enable increment" ],
   "DN_MODE"                      => [   4,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Counter 6 down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [   5,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Counter 6 down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [   6,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Counter 6 down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [   7,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "Counter 6 down stimulus" ],
   "UP_MODE"                      => [   8,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Counter 6 up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [   9,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Counter 6 up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  10,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Counter 6 up format select (1-level, 0-edge)" ],
   "UP_STIMULUS"                  => [  11,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Counter 6 up stimulus" ],
);

%shub_01_00589_def =
( NAME    => "SH_PERFORMANCE_COUNT6_CONTROL",
  ADDRESS => 0x00000001100e0000,
  NOTE    => "Performance Counter 6 Control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00589_flds
);


##########################################################################
#                                                                        #
#   SH_PERFORMANCE_COUNT7_CONTROL                                        #
#                                                                        #
##########################################################################

%shub_01_00590_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  19,  45, 0xFFFFFFFFFFF80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   1,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "Counter 7 enable peak detection" ],
   "DEC_ENABLE"                   => [   2,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "Counter 7 enable decrement" ],
   "INC_ENABLE"                   => [   3,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Counter 7 enable increment" ],
   "DN_MODE"                      => [   4,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Counter 7 down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [   5,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Counter 7 down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [   6,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Counter 7 down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [   7,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "Counter 7 down stimulus" ],
   "UP_MODE"                      => [   8,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Counter 7 up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [   9,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Counter 7 up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  10,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Counter 7 up format select (1-level, 0-edge)" ],
   "UP_STIMULUS"                  => [  11,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Counter 7 up stimulus" ],
);

%shub_01_00590_def =
( NAME    => "SH_PERFORMANCE_COUNT7_CONTROL",
  ADDRESS => 0x00000001100f0000,
  NOTE    => "Performance Counter 7 Control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00590_flds
);


##########################################################################
#                                                                        #
#   SH_PROFILE_DN_CONTROL                                                #
#                                                                        #
##########################################################################

%shub_01_00591_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MODE"                         => [   1,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Counter mode select (1-internal, 0-external)" ],
   "POLARITY"                     => [   2,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Counter polarity select (1-negative edge, 0-positive edge)" ],
   "EVENT"                        => [   3,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Counter format select (1-level, 0-edge)" ],
   "STIMULUS"                     => [   4,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Counter stimulus" ],
);

%shub_01_00591_def =
( NAME    => "SH_PROFILE_DN_CONTROL",
  ADDRESS => 0x0000000110100000,
  NOTE    => "Profile Counter Down Control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00591_flds
);


##########################################################################
#                                                                        #
#   SH_PROFILE_PEAK_CONTROL                                              #
#                                                                        #
##########################################################################

%shub_01_00592_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   7,  57, 0xFFFFFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "POLARITY"                     => [   1,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Counter polarity select (0-negative edge, 1-positive edge)" ],
   "EVENT"                        => [   2,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Counter format select (1-level, 0-edge)" ],
   "RSVD1"                        => [   3,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STIMULUS"                     => [   4,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Counter stimulus (1-equal, 0-greater than)" ],
);

%shub_01_00592_def =
( NAME    => "SH_PROFILE_PEAK_CONTROL",
  ADDRESS => 0x0000000110100080,
  NOTE    => "Profile Counter Peak Control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00592_flds
);


##########################################################################
#                                                                        #
#   SH_PROFILE_RANGE                                                     #
#                                                                        #
##########################################################################

%shub_01_00593_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RANGE7"                       => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "Profiling range 7" ],
   "RANGE6"                       => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Profiling range 6" ],
   "RANGE5"                       => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "Profiling range 5" ],
   "RANGE4"                       => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Profiling range 4" ],
   "RANGE3"                       => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "Profiling range 3" ],
   "RANGE2"                       => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "Profiling range 2" ],
   "RANGE1"                       => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Profiling range 1" ],
   "RANGE0"                       => [   7,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Profiling range 0" ],
);

%shub_01_00593_def =
( NAME    => "SH_PROFILE_RANGE",
  ADDRESS => 0x0000000110100100,
  NOTE    => "Profile Counter Range",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00593_flds
);


##########################################################################
#                                                                        #
#   SH_PROFILE_UP_CONTROL                                                #
#                                                                        #
##########################################################################

%shub_01_00594_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MODE"                         => [   1,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Counter mode select (1-internal, 0-external)" ],
   "POLARITY"                     => [   2,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Counter polarity select (1-negative edge, 0-positive edge)" ],
   "EVENT"                        => [   3,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Counter format select (1-level, 0-edge)" ],
   "STIMULUS"                     => [   4,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Counter stimulus" ],
);

%shub_01_00594_def =
( NAME    => "SH_PROFILE_UP_CONTROL",
  ADDRESS => 0x0000000110100180,
  NOTE    => "Profile Counter Up Control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00594_flds
);


##########################################################################
#                                                                        #
#   SH_PERFORMANCE_COUNTER0                                              #
#                                                                        #
##########################################################################

%shub_01_00595_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 0" ],
);

%shub_01_00595_def =
( NAME    => "SH_PERFORMANCE_COUNTER0",
  ADDRESS => 0x0000000110110000,
  NOTE    => "Performance Counter 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00595_flds
);


##########################################################################
#                                                                        #
#   SH_PERFORMANCE_COUNTER1                                              #
#                                                                        #
##########################################################################

%shub_01_00596_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 1" ],
);

%shub_01_00596_def =
( NAME    => "SH_PERFORMANCE_COUNTER1",
  ADDRESS => 0x0000000110120000,
  NOTE    => "Performance Counter 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00596_flds
);


##########################################################################
#                                                                        #
#   SH_PERFORMANCE_COUNTER2                                              #
#                                                                        #
##########################################################################

%shub_01_00597_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 2" ],
);

%shub_01_00597_def =
( NAME    => "SH_PERFORMANCE_COUNTER2",
  ADDRESS => 0x0000000110130000,
  NOTE    => "Performance Counter 2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00597_flds
);


##########################################################################
#                                                                        #
#   SH_PERFORMANCE_COUNTER3                                              #
#                                                                        #
##########################################################################

%shub_01_00598_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 3" ],
);

%shub_01_00598_def =
( NAME    => "SH_PERFORMANCE_COUNTER3",
  ADDRESS => 0x0000000110140000,
  NOTE    => "Performance Counter 3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00598_flds
);


##########################################################################
#                                                                        #
#   SH_PERFORMANCE_COUNTER4                                              #
#                                                                        #
##########################################################################

%shub_01_00599_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 4" ],
);

%shub_01_00599_def =
( NAME    => "SH_PERFORMANCE_COUNTER4",
  ADDRESS => 0x0000000110150000,
  NOTE    => "Performance Counter 4",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00599_flds
);


##########################################################################
#                                                                        #
#   SH_PERFORMANCE_COUNTER5                                              #
#                                                                        #
##########################################################################

%shub_01_00600_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 5" ],
);

%shub_01_00600_def =
( NAME    => "SH_PERFORMANCE_COUNTER5",
  ADDRESS => 0x0000000110160000,
  NOTE    => "Performance Counter 5",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00600_flds
);


##########################################################################
#                                                                        #
#   SH_PERFORMANCE_COUNTER6                                              #
#                                                                        #
##########################################################################

%shub_01_00601_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 6" ],
);

%shub_01_00601_def =
( NAME    => "SH_PERFORMANCE_COUNTER6",
  ADDRESS => 0x0000000110170000,
  NOTE    => "Performance Counter 6",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00601_flds
);


##########################################################################
#                                                                        #
#   SH_PERFORMANCE_COUNTER7                                              #
#                                                                        #
##########################################################################

%shub_01_00602_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 7" ],
);

%shub_01_00602_def =
( NAME    => "SH_PERFORMANCE_COUNTER7",
  ADDRESS => 0x0000000110180000,
  NOTE    => "Performance Counter 7",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00602_flds
);


##########################################################################
#                                                                        #
#   SH_PROFILE_COUNTER                                                   #
#                                                                        #
##########################################################################

%shub_01_00603_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNTER"                      => [   1,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Counter Value" ],
);

%shub_01_00603_def =
( NAME    => "SH_PROFILE_COUNTER",
  ADDRESS => 0x0000000110190000,
  NOTE    => "Profile Counter",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00603_flds
);


##########################################################################
#                                                                        #
#   SH_PROFILE_PEAK                                                      #
#                                                                        #
##########################################################################

%shub_01_00604_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNTER"                      => [   1,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Counter Value" ],
);

%shub_01_00604_def =
( NAME    => "SH_PROFILE_PEAK",
  ADDRESS => 0x0000000110190080,
  NOTE    => "Profile Peak Counter",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00604_flds
);


##########################################################################
#                                                                        #
#   SH_PTC_0                                                             #
#                                                                        #
##########################################################################

%shub_01_00605_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "START"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Start" ],
   "RSVD0"                        => [   1,  32,  31, 0x7FFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RID"                          => [   2,   8,  24, 0x00000000FFFFFF00, 0x00, 1, 0x0000000000000000, "Region ID" ],
   "PS"                           => [   3,   2,   6, 0x00000000000000FC, 0x00, 1, 0x0000000000000000, "Page Size" ],
   "RSVD1"                        => [   4,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "A"                            => [   5,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Type" ],
);

%shub_01_00605_def =
( NAME    => "SH_PTC_0",
  ADDRESS => 0x00000001101a0000,
  NOTE    => "Puge Translation Cache Message Configuration Information",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00605_flds
);


##########################################################################
#                                                                        #
#   SH_PTC_1                                                             #
#                                                                        #
##########################################################################

%shub_01_00606_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "START"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "PTC_1 Start" ],
   "RSVD0"                        => [   1,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VPN"                          => [   2,  12,  49, 0x1FFFFFFFFFFFF000, 0x00, 1, 0x0000000000000000, "Virtual page number" ],
);

%shub_01_00606_def =
( NAME    => "SH_PTC_1",
  ADDRESS => 0x00000001101a0080,
  NOTE    => "Puge Translation Cache Message Configuration Information",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00606_flds
);


##########################################################################
#                                                                        #
#   SH_PTC_PARMS                                                         #
#                                                                        #
##########################################################################

%shub_01_00607_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  36,  28, 0xFFFFFFF000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PTC_TO_VAL"                   => [   1,  24,  12, 0x0000000FFF000000, 0x00, 1, 0x0000000000000000, "PTC time-out valid" ],
   "PTC_TO_WRAP"                  => [   2,   0,  24, 0x0000000000FFFFFF, 0x00, 1, 0x0000000000000000, "PTC time-out period" ],
);

%shub_01_00607_def =
( NAME    => "SH_PTC_PARMS",
  ADDRESS => 0x00000001101a0100,
  NOTE    => "PTC Time-out parmaeters",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00607_flds
);


##########################################################################
#                                                                        #
#   SH_INT_CMPA                                                          #
#                                                                        #
##########################################################################

%shub_01_00608_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  55,   9, 0xFF80000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REAL_TIME_CMPA"               => [   1,   0,  55, 0x007FFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Real Time Clock Compare" ],
);

%shub_01_00608_def =
( NAME    => "SH_INT_CMPA",
  ADDRESS => 0x00000001101b0000,
  NOTE    => "RTC Compare Value for Processor A",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00608_flds
);


##########################################################################
#                                                                        #
#   SH_INT_CMPB                                                          #
#                                                                        #
##########################################################################

%shub_01_00609_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  55,   9, 0xFF80000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REAL_TIME_CMPB"               => [   1,   0,  55, 0x007FFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Real Time Clock Compare" ],
);

%shub_01_00609_def =
( NAME    => "SH_INT_CMPB",
  ADDRESS => 0x00000001101b0080,
  NOTE    => "RTC Compare Value for Processor B",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00609_flds
);


##########################################################################
#                                                                        #
#   SH_INT_CMPC                                                          #
#                                                                        #
##########################################################################

%shub_01_00610_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  55,   9, 0xFF80000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REAL_TIME_CMPC"               => [   1,   0,  55, 0x007FFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Real Time Clock Compare" ],
);

%shub_01_00610_def =
( NAME    => "SH_INT_CMPC",
  ADDRESS => 0x00000001101b0100,
  NOTE    => "RTC Compare Value for Processor C",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00610_flds
);


##########################################################################
#                                                                        #
#   SH_INT_CMPD                                                          #
#                                                                        #
##########################################################################

%shub_01_00611_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  55,   9, 0xFF80000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REAL_TIME_CMPD"               => [   1,   0,  55, 0x007FFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Real Time Clock Compare" ],
);

%shub_01_00611_def =
( NAME    => "SH_INT_CMPD",
  ADDRESS => 0x00000001101b0180,
  NOTE    => "RTC Compare Value for Processor D",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00611_flds
);


##########################################################################
#                                                                        #
#   SH_INT_PROF                                                          #
#                                                                        #
##########################################################################

%shub_01_00612_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PROFILE_COMPARE"              => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "Profile Compare" ],
);

%shub_01_00612_def =
( NAME    => "SH_INT_PROF",
  ADDRESS => 0x00000001101b0200,
  NOTE    => "Profile Compare Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00612_flds
);


##########################################################################
#                                                                        #
#   SH_RTC                                                               #
#                                                                        #
##########################################################################

%shub_01_00613_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  55,   9, 0xFF80000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REAL_TIME_CLOCK"              => [   1,   0,  55, 0x007FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Real-time Clock" ],
);

%shub_01_00613_def =
( NAME    => "SH_RTC",
  ADDRESS => 0x00000001101c0000,
  NOTE    => "Real-time Clock",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00613_flds
);


##########################################################################
#                                                                        #
#   SH_SCRATCH0                                                          #
#                                                                        #
##########################################################################

%shub_01_00614_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH0"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 0" ],
);

%shub_01_00614_def =
( NAME    => "SH_SCRATCH0",
  ADDRESS => 0x00000001101d0000,
  NOTE    => "Scratch Register 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00614_flds
);


##########################################################################
#                                                                        #
#   SH_SCRATCH0_ALIAS                                                    #
#                                                                        #
##########################################################################

%shub_01_00615_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH0"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 0" ],
);

%shub_01_00615_def =
( NAME    => "SH_SCRATCH0_ALIAS",
  ADDRESS => 0x00000001101d0008,
  NOTE    => "Scratch Register 0 Alias Address",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00615_flds
);


##########################################################################
#                                                                        #
#   SH_SCRATCH1                                                          #
#                                                                        #
##########################################################################

%shub_01_00616_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH1"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 1" ],
);

%shub_01_00616_def =
( NAME    => "SH_SCRATCH1",
  ADDRESS => 0x00000001101d0080,
  NOTE    => "Scratch Register 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00616_flds
);


##########################################################################
#                                                                        #
#   SH_SCRATCH1_ALIAS                                                    #
#                                                                        #
##########################################################################

%shub_01_00617_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH1"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 1" ],
);

%shub_01_00617_def =
( NAME    => "SH_SCRATCH1_ALIAS",
  ADDRESS => 0x00000001101d0088,
  NOTE    => "Scratch Register 1 Alias Address",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00617_flds
);


##########################################################################
#                                                                        #
#   SH_SCRATCH2                                                          #
#                                                                        #
##########################################################################

%shub_01_00618_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH2"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Scratch register 2" ],
);

%shub_01_00618_def =
( NAME    => "SH_SCRATCH2",
  ADDRESS => 0x00000001101d0100,
  NOTE    => "Scratch Register 2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00618_flds
);


##########################################################################
#                                                                        #
#   SH_SCRATCH2_ALIAS                                                    #
#                                                                        #
##########################################################################

%shub_01_00619_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH2"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Scratch register 2" ],
);

%shub_01_00619_def =
( NAME    => "SH_SCRATCH2_ALIAS",
  ADDRESS => 0x00000001101d0108,
  NOTE    => "Scratch Register 2 Alias Address",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00619_flds
);


##########################################################################
#                                                                        #
#   SH_SCRATCH3                                                          #
#                                                                        #
##########################################################################

%shub_01_00620_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCRATCH3"                     => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Scratch register 3" ],
);

%shub_01_00620_def =
( NAME    => "SH_SCRATCH3",
  ADDRESS => 0x00000001101d0180,
  NOTE    => "Scratch Register 3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00620_flds
);


##########################################################################
#                                                                        #
#   SH_SCRATCH3_ALIAS                                                    #
#                                                                        #
##########################################################################

%shub_01_00621_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCRATCH3"                     => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Scratch register 3" ],
);

%shub_01_00621_def =
( NAME    => "SH_SCRATCH3_ALIAS",
  ADDRESS => 0x00000001101d0188,
  NOTE    => "Scratch Register 3 Alias Address",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00621_flds
);


##########################################################################
#                                                                        #
#   SH_SCRATCH4                                                          #
#                                                                        #
##########################################################################

%shub_01_00622_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCRATCH4"                     => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Scratch register 4" ],
);

%shub_01_00622_def =
( NAME    => "SH_SCRATCH4",
  ADDRESS => 0x00000001101d0200,
  NOTE    => "Scratch Register 4",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00622_flds
);


##########################################################################
#                                                                        #
#   SH_SCRATCH4_ALIAS                                                    #
#                                                                        #
##########################################################################

%shub_01_00623_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCRATCH4"                     => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Scratch register 4" ],
);

%shub_01_00623_def =
( NAME    => "SH_SCRATCH4_ALIAS",
  ADDRESS => 0x00000001101d0208,
  NOTE    => "Scratch Register 4 Alias Address",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00623_flds
);


##########################################################################
#                                                                        #
#   SH_CRB_MESSAGE_CONTROL                                               #
#                                                                        #
##########################################################################

%shub_01_00624_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SYSTEM_FLUSH_DURATION"        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 1, 0x0000000000000000, "Flush duration controls" ],
   "SYSTEM_FLUSH_INTERVAL"        => [   1,  32,  16, 0x0000FFFF00000000, 0x00, 1, 0x0000000000000000, "Flush interval controls" ],
   "RSVD0"                        => [   2,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FUN"                          => [   3,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "fun scratch bits" ],
   "REVISION"                     => [   4,  13,   3, 0x000000000000E000, 0x00, 1, 0x0000000000000000, "quick revision ID" ],
   "ENABLE_PIPE_SNOOP_ERRORS"     => [   5,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "enable FSB pipe snoop errors" ],
   "ENABLE_IVACK_CONSOLIDATION"   => [   6,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "enable IVACK reply consolidation" ],
   "SUPPRESS_BOGUS_WRITES"        => [   7,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "ignor residual write data" ],
   "WRB_ATTRIBUTE_MISMATCH_XB_ENABLE" => [   8,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Enable XB WRB Mismatch check" ],
   "RRB_ATTRIBUTE_MISMATCH_XB_ENABLE" => [   9,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Enable XB RRB Mismatch check" ],
   "IRB_ATTRIBUTE_MISMATCH_FSB_ENABLE" => [  10,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Enable FSB IRB Mismatch check" ],
   "WRB_ATTRIBUTE_MISMATCH_FSB_ENABLE" => [  11,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Enable FSB WRB Mismatch check" ],
   "RRB_ATTRIBUTE_MISMATCH_FSB_ENABLE" => [  12,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Enable FSB RRB Mismatch check" ],
   "MESSAGE_COLOR_ENABLE"         => [  13,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Enable color message processing" ],
   "MESSAGE_COLOR"                => [  14,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Define color of message" ],
   "REMOTE_SPECULATIVE_MESSAGE_ENABLE" => [  15,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Speculative Read Requests to Remote Memory Enabled" ],
   "LOCAL_SPECULATIVE_MESSAGE_ENABLE" => [  16,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Speculative Read Requests to Local Memory Enabled" ],
   "SYSTEM_COHERENCE_ENABLE"      => [  17,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "System Coherence Enabled" ],
);

%shub_01_00624_def =
( NAME    => "SH_CRB_MESSAGE_CONTROL",
  ADDRESS => 0x0000000120000000,
  NOTE    => "Coherent Request Buffer Message Control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00624_flds
);


##########################################################################
#                                                                        #
#   SH_CRB_NACK_LIMIT                                                    #
#                                                                        #
##########################################################################

%shub_01_00625_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Enable NACK limit detection" ],
   "RSVD0"                        => [   1,  16,  47, 0x7FFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRI_FREQ"                     => [   2,  12,   4, 0x000000000000F000, 0x00, 1, 0x0000000000000000, "Frequency at which priority count is incremented" ],
   "LIMIT"                        => [   3,   0,  12, 0x0000000000000FFF, 0x00, 1, 0x0000000000000000, "Nack Count Limit" ],
);

%shub_01_00625_def =
( NAME    => "SH_CRB_NACK_LIMIT",
  ADDRESS => 0x0000000120000080,
  NOTE    => "CRB Nack Limit",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00625_flds
);


##########################################################################
#                                                                        #
#   SH_CRB_TIMEOUT_PRESCALE                                              #
#                                                                        #
##########################################################################

%shub_01_00626_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCALING_FACTOR"               => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "CRB Time-out Prescale Factor" ],
);

%shub_01_00626_def =
( NAME    => "SH_CRB_TIMEOUT_PRESCALE",
  ADDRESS => 0x0000000120000100,
  NOTE    => "Coherent Request Buffer Timeout Prescale",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00626_flds
);


##########################################################################
#                                                                        #
#   SH_CRB_TIMEOUT_SKID                                                  #
#                                                                        #
##########################################################################

%shub_01_00627_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RESET_SKID_COUNT"             => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reset Skid counter" ],
   "INCREMENT_ICC"                => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Increment Intervention Credit Count by one" ],
   "RSVD0"                        => [   2,  12,  50, 0x3FFFFFFFFFFFF000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_TIMEOUT_ENABLE"           => [   3,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "Enable PRB timeouts" ],
   "IRB_TIMEOUT_ENABLE"           => [   4,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "Enable IRB timeouts" ],
   "WRB_TIMEOUT_ENABLE"           => [   5,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Enable WRB timeouts" ],
   "RRB_TIMEOUT_ENABLE"           => [   6,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Enable RRB timeouts" ],
   "RSVD1"                        => [   7,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SKID"                         => [   8,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "CRB Time-out Skid" ],
);

%shub_01_00627_def =
( NAME    => "SH_CRB_TIMEOUT_SKID",
  ADDRESS => 0x0000000120000180,
  NOTE    => "Coherent Request Buffer Timeout Skid Limit",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00627_flds
);


##########################################################################
#                                                                        #
#   SH_MEMORY_WRITE_STATUS_0                                             #
#                                                                        #
##########################################################################

%shub_01_00628_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   6,  58, 0xFFFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   1,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Pending Write Count" ],
);

%shub_01_00628_def =
( NAME    => "SH_MEMORY_WRITE_STATUS_0",
  ADDRESS => 0x0000000120070000,
  NOTE    => "Memory Write Status for CPU 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00628_flds
);


##########################################################################
#                                                                        #
#   SH_MEMORY_WRITE_STATUS_1                                             #
#                                                                        #
##########################################################################

%shub_01_00629_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   6,  58, 0xFFFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   1,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Pending Write Count" ],
);

%shub_01_00629_def =
( NAME    => "SH_MEMORY_WRITE_STATUS_1",
  ADDRESS => 0x0000000120070080,
  NOTE    => "Memory Write Status for CPU 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00629_flds
);


##########################################################################
#                                                                        #
#   SH_PIO_WRITE_STATUS_0                                                #
#                                                                        #
##########################################################################

%shub_01_00630_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "WRITES_OK"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "No pending writes or errors" ],
   "RSVD0"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   2,  56,   6, 0x3F00000000000000, 0x00, 1, 0x0000000000000000, "Count of currently pending PIO writes" ],
   "RSVD1"                        => [   3,  50,   6, 0x00FC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE_ERROR_ADDRESS"          => [   4,   3,  47, 0x0003FFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "Address associated with error response" ],
   "WRITE_ERROR"                  => [   5,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Error response detected" ],
   "WRITE_DEADLOCK"               => [   6,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Deaklock response detected" ],
   "MULTI_WRITE_ERROR"            => [   7,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "More than one PIO write error occured" ],
);

%shub_01_00630_def =
( NAME    => "SH_PIO_WRITE_STATUS_0",
  ADDRESS => 0x0000000120070200,
  NOTE    => "PIO Write Status for CPU 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00630_flds
);


##########################################################################
#                                                                        #
#   SH_PIO_WRITE_STATUS_1                                                #
#                                                                        #
##########################################################################

%shub_01_00631_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "WRITES_OK"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "No pending writes or errors" ],
   "RSVD0"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   2,  56,   6, 0x3F00000000000000, 0x00, 1, 0x0000000000000000, "Count of currently pending PIO writes" ],
   "RSVD1"                        => [   3,  50,   6, 0x00FC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE_ERROR_ADDRESS"          => [   4,   3,  47, 0x0003FFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "Address associated with error response" ],
   "WRITE_ERROR"                  => [   5,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Error response detected" ],
   "WRITE_DEADLOCK"               => [   6,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Deaklock response detected" ],
   "MULTI_WRITE_ERROR"            => [   7,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "More than one PIO write error occured" ],
);

%shub_01_00631_def =
( NAME    => "SH_PIO_WRITE_STATUS_1",
  ADDRESS => 0x0000000120070280,
  NOTE    => "PIO Write Status for CPU 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00631_flds
);


##########################################################################
#                                                                        #
#   SH_PIO_WRITE_STATUS_0_ALIAS                                          #
#                                                                        #
##########################################################################

%shub_01_00632_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "WRITES_OK"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "No pending writes or errors" ],
   "RSVD0"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   2,  56,   6, 0x3F00000000000000, 0x00, 1, 0x0000000000000000, "Count of currently pending PIO writes" ],
   "RSVD1"                        => [   3,  50,   6, 0x00FC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE_ERROR_ADDRESS"          => [   4,   3,  47, 0x0003FFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "Address associated with error response" ],
   "WRITE_ERROR"                  => [   5,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Error response detected" ],
   "WRITE_DEADLOCK"               => [   6,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Deaklock response detected" ],
   "MULTI_WRITE_ERROR"            => [   7,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "More than one PIO write error occured" ],
);

%shub_01_00632_def =
( NAME    => "SH_PIO_WRITE_STATUS_0_ALIAS",
  ADDRESS => 0x0000000120070208,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00632_flds
);


##########################################################################
#                                                                        #
#   SH_PIO_WRITE_STATUS_1_ALIAS                                          #
#                                                                        #
##########################################################################

%shub_01_00633_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "WRITES_OK"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "No pending writes or errors" ],
   "RSVD0"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   2,  56,   6, 0x3F00000000000000, 0x00, 1, 0x0000000000000000, "Count of currently pending PIO writes" ],
   "RSVD1"                        => [   3,  50,   6, 0x00FC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE_ERROR_ADDRESS"          => [   4,   3,  47, 0x0003FFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "Address associated with error response" ],
   "WRITE_ERROR"                  => [   5,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Error response detected" ],
   "WRITE_DEADLOCK"               => [   6,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Deaklock response detected" ],
   "MULTI_WRITE_ERROR"            => [   7,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "More than one PIO write error occured" ],
);

%shub_01_00633_def =
( NAME    => "SH_PIO_WRITE_STATUS_1_ALIAS",
  ADDRESS => 0x0000000120070288,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00633_flds
);


##########################################################################
#                                                                        #
#   SH_MEMORY_WRITE_STATUS_NON_USER_0                                     #
#                                                                        #
##########################################################################

%shub_01_00634_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CLEAR"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Clear pending write count" ],
   "RSVD0"                        => [   1,   6,  57, 0x7FFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   2,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Pending Write Count" ],
);

%shub_01_00634_def =
( NAME    => "SH_MEMORY_WRITE_STATUS_NON_USER_0",
  ADDRESS => 0x0000000120070400,
  NOTE    => "Memory Write Status for CPU 0. OS access only",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00634_flds
);


##########################################################################
#                                                                        #
#   SH_MEMORY_WRITE_STATUS_NON_USER_1                                     #
#                                                                        #
##########################################################################

%shub_01_00635_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CLEAR"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Clear pending write count" ],
   "RSVD0"                        => [   1,   6,  57, 0x7FFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PENDING_WRITE_COUNT"          => [   2,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Pending Write Count" ],
);

%shub_01_00635_def =
( NAME    => "SH_MEMORY_WRITE_STATUS_NON_USER_1",
  ADDRESS => 0x0000000120070480,
  NOTE    => "Memory Write Status for CPU 1. OS access only",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00635_flds
);


##########################################################################
#                                                                        #
#   SH_MMRBIST_ERR                                                       #
#                                                                        #
##########################################################################

%shub_01_00636_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  39,  25, 0xFFFFFF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CANCELLED"                    => [   1,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "mmr/bist was cancelled" ],
   "MULTIPLE_DETECTED"            => [   2,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "multiple errors detected flag" ],
   "DETECTED"                     => [   3,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "error detected flag" ],
   "RSVD1"                        => [   4,  33,   3, 0x0000000E00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR"                         => [   5,   0,  33, 0x00000001FFFFFFFF, 0x00, 1, 0x0000000000000000, "dword address of bist error" ],
);

%shub_01_00636_def =
( NAME    => "SH_MMRBIST_ERR",
  ADDRESS => 0x0000000100000080,
  NOTE    => "Error capture for bist read errors",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00636_flds
);


##########################################################################
#                                                                        #
#   SH_MISC_ERR_HDR_LOWER                                                #
#                                                                        #
##########################################################################

%shub_01_00637_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "set when capture occurs" ],
   "RSVD0"                        => [   1,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE"                        => [   2,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "reference is a write" ],
   "RSVD1"                        => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SRC"                          => [   4,  44,  14, 0x03FFF00000000000, 0x00, 1, 0x0000000000000000, "source node of reference" ],
   "CMD"                          => [   5,  36,   8, 0x00000FF000000000, 0x00, 1, 0x0000000000000000, "command of reference" ],
   "ADDR"                         => [   6,   3,  33, 0x0000000FFFFFFFF8, 0x00, 1, 0x0000000000000000, "upper bits of reference address" ],
);

%shub_01_00637_def =
( NAME    => "SH_MISC_ERR_HDR_LOWER",
  ADDRESS => 0x0000000100000088,
  NOTE    => "Header capture register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00637_flds
);


##########################################################################
#                                                                        #
#   SH_MISC_ERR_HDR_UPPER                                                #
#                                                                        #
##########################################################################

%shub_01_00638_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  29,  35, 0xFFFFFFFFE0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECHO"                         => [   1,  20,   9, 0x000000001FF00000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD1"                        => [   2,   8,  12, 0x00000000000FFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_PKT_SIZE"                  => [   3,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "indicates a pkt size error from xn" ],
   "PI_PKT_SIZE"                  => [   4,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "indicates a pkt size error from pi" ],
   "DIR_ACC"                      => [   5,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "indicates a data request to directory memory error captured" ],
   "RMW_COR"                      => [   6,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "indicates a correctable store rmw" ],
   "RMW_UC"                       => [   7,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "indicates an uncorrectable store rmw" ],
   "NONEXIST_ADDR"                => [   8,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "indicates a non-existent memory error captured" ],
   "ILLEGAL_CMD"                  => [   9,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "indicates an illegal command error captured" ],
   "DIR_PROTOCOL"                 => [  10,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "indicates a directory protocol error captured" ],
);

%shub_01_00638_def =
( NAME    => "SH_MISC_ERR_HDR_UPPER",
  ADDRESS => 0x0000000100000090,
  NOTE    => "Error header capture packet and protocol errors",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00638_flds
);


##########################################################################
#                                                                        #
#   SH_DIR_UC_ERR_HDR_LOWER                                              #
#                                                                        #
##########################################################################

%shub_01_00639_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "set when capture occurs" ],
   "RSVD0"                        => [   1,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE"                        => [   2,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "reference is a write" ],
   "RSVD1"                        => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SRC"                          => [   4,  44,  14, 0x03FFF00000000000, 0x00, 1, 0x0000000000000000, "source node of reference" ],
   "CMD"                          => [   5,  36,   8, 0x00000FF000000000, 0x00, 1, 0x0000000000000000, "command of reference" ],
   "ADDR"                         => [   6,   3,  33, 0x0000000FFFFFFFF8, 0x00, 1, 0x0000000000000000, "upper bits of reference address" ],
);

%shub_01_00639_def =
( NAME    => "SH_DIR_UC_ERR_HDR_LOWER",
  ADDRESS => 0x0000000100000098,
  NOTE    => "Header capture register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00639_flds
);


##########################################################################
#                                                                        #
#   SH_DIR_UC_ERR_HDR_UPPER                                              #
#                                                                        #
##########################################################################

%shub_01_00640_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  29,  35, 0xFFFFFFFFE0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECHO"                         => [   1,  20,   9, 0x000000001FF00000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD1"                        => [   2,   4,  16, 0x00000000000FFFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR_UC"                       => [   3,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "indicates uncorrectable directory error captured" ],
);

%shub_01_00640_def =
( NAME    => "SH_DIR_UC_ERR_HDR_UPPER",
  ADDRESS => 0x00000001000000a0,
  NOTE    => "Error header capture packet and protocol errors",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00640_flds
);


##########################################################################
#                                                                        #
#   SH_DIR_COR_ERR_HDR_LOWER                                             #
#                                                                        #
##########################################################################

%shub_01_00641_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "set when capture occurs" ],
   "RSVD0"                        => [   1,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE"                        => [   2,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "reference is a write" ],
   "RSVD1"                        => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SRC"                          => [   4,  44,  14, 0x03FFF00000000000, 0x00, 1, 0x0000000000000000, "source node of reference" ],
   "CMD"                          => [   5,  36,   8, 0x00000FF000000000, 0x00, 1, 0x0000000000000000, "command of reference" ],
   "ADDR"                         => [   6,   3,  33, 0x0000000FFFFFFFF8, 0x00, 1, 0x0000000000000000, "upper bits of reference address" ],
);

%shub_01_00641_def =
( NAME    => "SH_DIR_COR_ERR_HDR_LOWER",
  ADDRESS => 0x00000001000000a8,
  NOTE    => "Header capture register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00641_flds
);


##########################################################################
#                                                                        #
#   SH_DIR_COR_ERR_HDR_UPPER                                             #
#                                                                        #
##########################################################################

%shub_01_00642_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  29,  35, 0xFFFFFFFFE0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECHO"                         => [   1,  20,   9, 0x000000001FF00000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD1"                        => [   2,   9,  11, 0x00000000000FFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR_COR"                      => [   3,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "indicates correctable directory error captured" ],
);

%shub_01_00642_def =
( NAME    => "SH_DIR_COR_ERR_HDR_UPPER",
  ADDRESS => 0x00000001000000b0,
  NOTE    => "Error header capture packet and protocol errors",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00642_flds
);


##########################################################################
#                                                                        #
#   SH_MEM_ERROR_SUMMARY                                                 #
#                                                                        #
##########################################################################

%shub_01_00643_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_PKT_SIZE"                  => [   1,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: XN-to-MD Message Length Error" ],
   "PI_PKT_SIZE"                  => [   2,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: PI-to-MD Message Length Error" ],
   "RED_BLACK_ERR_TIMEOUT"        => [   3,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Red/Black Time-out Error" ],
   "XN_REQUEST_OVERFLOW"          => [   4,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: XN-to-MD Request Queue Overflow Error" ],
   "PI_REQUEST_OVERFLOW"          => [   5,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: PI-to-MD Request Queue Overflow Error" ],
   "XN_REPLY_OVERFLOW"            => [   6,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: XN-to-MD Reply Queue Overflow Error" ],
   "PI_REPLY_OVERFLOW"            => [   7,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: PI-to-MD Reply Queue Overflow Error" ],
   "RSVD1"                        => [   8,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQRS_INT_HW"                  => [   9,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQRS Hardware Error" ],
   "DQRS_INT_COR"                 => [  10,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQRS Correctable AMO Data Error" ],
   "DQRS_INT_UC"                  => [  11,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQRS Uncorrectable AMO Data Error" ],
   "RSVD2"                        => [  12,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQRP_INT_HW"                  => [  13,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQRP Hardware Error" ],
   "DQRP_INT_COR"                 => [  14,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQRP Correctable AMO Data Error" ],
   "DQRP_INT_UC"                  => [  15,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQRP Uncorrectable AMO Data Error" ],
   "RSVD3"                        => [  16,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQLS_INT_HW"                  => [  17,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQLS Hardware Error" ],
   "DQLS_INT_COR"                 => [  18,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQLS Correctable AMO Data Error" ],
   "DQLS_INT_UC"                  => [  19,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQLS Uncorrectable AMO Data Error" ],
   "RSVD4"                        => [  20,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQLP_INT_HW"                  => [  21,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQLP Hardware Error" ],
   "DQLP_INT_COR"                 => [  22,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQLP Correctable AMO Data Error" ],
   "DQLP_INT_UC"                  => [  23,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQLP Uncorrectable AMO Data Error" ],
   "RSVD5"                        => [  24,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR_ACC"                      => [  25,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Directory Memory Access Error" ],
   "ACY_INT_HW"                   => [  26,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "MD_HW_INT: ACY Hardware Error" ],
   "ACX_INT_HW"                   => [  27,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "MD_HW_INT: ACX Hardware Error" ],
   "DQRP_DIR_COR"                 => [  28,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQRP Correctable Directory Data Error" ],
   "DQRP_DIR_UC"                  => [  29,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQRP Uncorrectable Directory Data Error" ],
   "DQLP_DIR_COR"                 => [  30,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQLP Correctable Directory Data Error" ],
   "DQLP_DIR_UC"                  => [  31,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQLP Uncorrectable Directory Data Error" ],
   "DQRP_DIR_PERR"                => [  32,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQRP Directory Protocol Error" ],
   "DQLP_DIR_PERR"                => [  33,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQLP Directory Protocol Error" ],
   "NONEXIST_ADDR"                => [  34,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Non-existent Memory Address Error" ],
   "ILLEGAL_CMD"                  => [  35,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Illegal Command Error" ],
);

%shub_01_00643_def =
( NAME    => "SH_MEM_ERROR_SUMMARY",
  ADDRESS => 0x00000001000000b8,
  NOTE    => "MD Error Summary",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00643_flds
);


##########################################################################
#                                                                        #
#   SH_MEM_ERROR_SUMMARY_ALIAS                                           #
#                                                                        #
##########################################################################

%shub_01_00644_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_PKT_SIZE"                  => [   1,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: XN-to-MD Message Length Error" ],
   "PI_PKT_SIZE"                  => [   2,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: PI-to-MD Message Length Error" ],
   "RED_BLACK_ERR_TIMEOUT"        => [   3,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Red/Black Time-out Error" ],
   "XN_REQUEST_OVERFLOW"          => [   4,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: XN-to-MD Request Queue Overflow Error" ],
   "PI_REQUEST_OVERFLOW"          => [   5,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: PI-to-MD Request Queue Overflow Error" ],
   "XN_REPLY_OVERFLOW"            => [   6,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: XN-to-MD Reply Queue Overflow Error" ],
   "PI_REPLY_OVERFLOW"            => [   7,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: PI-to-MD Reply Queue Overflow Error" ],
   "RSVD1"                        => [   8,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQRS_INT_HW"                  => [   9,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQRS Hardware Error" ],
   "DQRS_INT_COR"                 => [  10,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQRS Correctable AMO Data Error" ],
   "DQRS_INT_UC"                  => [  11,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQRS Uncorrectable AMO Data Error" ],
   "RSVD2"                        => [  12,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQRP_INT_HW"                  => [  13,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQRP Hardware Error" ],
   "DQRP_INT_COR"                 => [  14,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQRP Correctable AMO Data Error" ],
   "DQRP_INT_UC"                  => [  15,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQRP Uncorrectable AMO Data Error" ],
   "RSVD3"                        => [  16,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQLS_INT_HW"                  => [  17,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQLS Hardware Error" ],
   "DQLS_INT_COR"                 => [  18,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQLS Correctable AMO Data Error" ],
   "DQLS_INT_UC"                  => [  19,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQLS Uncorrectable AMO Data Error" ],
   "RSVD4"                        => [  20,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQLP_INT_HW"                  => [  21,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQLP Hardware Error" ],
   "DQLP_INT_COR"                 => [  22,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQLP Correctable AMO Data Error" ],
   "DQLP_INT_UC"                  => [  23,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQLP Uncorrectable AMO Data Error" ],
   "RSVD5"                        => [  24,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR_ACC"                      => [  25,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Directory Memory Access Error" ],
   "ACY_INT_HW"                   => [  26,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "MD_HW_INT: ACY Hardware Error" ],
   "ACX_INT_HW"                   => [  27,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "MD_HW_INT: ACX Hardware Error" ],
   "DQRP_DIR_COR"                 => [  28,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQRP Correctable Directory Data Error" ],
   "DQRP_DIR_UC"                  => [  29,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQRP Uncorrectable Directory Data Error" ],
   "DQLP_DIR_COR"                 => [  30,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQLP Correctable Directory Data Error" ],
   "DQLP_DIR_UC"                  => [  31,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQLP Uncorrectable Directory Data Error" ],
   "DQRP_DIR_PERR"                => [  32,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQRP Directory Protocol Error" ],
   "DQLP_DIR_PERR"                => [  33,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQLP Directory Protocol Error" ],
   "NONEXIST_ADDR"                => [  34,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Non-existent Memory Address Error" ],
   "ILLEGAL_CMD"                  => [  35,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Illegal Command Error" ],
);

%shub_01_00644_def =
( NAME    => "SH_MEM_ERROR_SUMMARY_ALIAS",
  ADDRESS => 0x00000001000000c0,
  NOTE    => "MD Error Summary Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00644_flds
);


##########################################################################
#                                                                        #
#   SH_MEM_ERROR_OVERFLOW                                                #
#                                                                        #
##########################################################################

%shub_01_00645_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_PKT_SIZE"                  => [   1,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: XN-to-MD Message Length Error Overflow" ],
   "PI_PKT_SIZE"                  => [   2,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: PI-to-MD Message Length Error Overflow" ],
   "RED_BLACK_ERR_TIMEOUT"        => [   3,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Red/Black Time-out Error Overflow" ],
   "XN_REQUEST_OVERFLOW"          => [   4,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: XN-to-MD Request Queue Overflow Error Overflow" ],
   "PI_REQUEST_OVERFLOW"          => [   5,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: PI-to-MD Request Queue Overflow Error Overflow" ],
   "XN_REPLY_OVERFLOW"            => [   6,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: XN-to-MD Reply Queue Overflow Error Overflow" ],
   "PI_REPLY_OVERFLOW"            => [   7,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: PI-to-MD Reply Queue Overflow Error Overflow" ],
   "RSVD1"                        => [   8,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQRS_INT_HW"                  => [   9,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQRS Hardware Error Overflow" ],
   "DQRS_INT_COR"                 => [  10,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQRS Correctable AMO Data Error Overflow" ],
   "DQRS_INT_UC"                  => [  11,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQRS Uncorrectable AMO Data Error Overflow" ],
   "RSVD2"                        => [  12,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQRP_INT_HW"                  => [  13,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQRP Hardware Error Overflow" ],
   "DQRP_INT_COR"                 => [  14,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQRP Correctable AMO Data Error Overflow" ],
   "DQRP_INT_UC"                  => [  15,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQRP Uncorrectable AMO Data Error Overflow" ],
   "RSVD3"                        => [  16,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQLS_INT_HW"                  => [  17,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQLS Hardware Error Overflow" ],
   "DQLS_INT_COR"                 => [  18,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQLS Correctable AMO Data Error Overflow" ],
   "DQLS_INT_UC"                  => [  19,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQLS Uncorrectable AMO Data Error Overflow" ],
   "RSVD4"                        => [  20,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQLP_INT_HW"                  => [  21,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQLP Hardware Error Overflow" ],
   "DQLP_INT_COR"                 => [  22,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQLP Correctable AMO Data Error Overflow" ],
   "DQLP_INT_UC"                  => [  23,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQLP Uncorrectable AMO Data Error Overflow" ],
   "RSVD5"                        => [  24,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR_ACC"                      => [  25,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Directory Access Error Overflow" ],
   "ACY_INT_HW"                   => [  26,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "MD_HW_INT: ACY Hardware Error Overflow" ],
   "ACX_INT_HW"                   => [  27,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "MD_HW_INT: ACX Hardware Error Overflow" ],
   "DQRP_DIR_COR"                 => [  28,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQRP Correctable Directory Data Error Overflow" ],
   "DQRP_DIR_UC"                  => [  29,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQRP Uncorrectable Directory Data Error Overflow" ],
   "DQLP_DIR_COR"                 => [  30,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQLP Correctable Directory Data Error Overflow" ],
   "DQLP_DIR_UC"                  => [  31,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQLP Uncorrectable Directory Data Error Overflow" ],
   "DQRP_DIR_PERR"                => [  32,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQRP Directory Protocol Error Overflow" ],
   "DQLP_DIR_PERR"                => [  33,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQLP Directory Protocol Error Overflow" ],
   "NONEXIST_ADDR"                => [  34,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Non-existent Memory Address Error Overflow" ],
   "ILLEGAL_CMD"                  => [  35,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Illegal Command Error Overflow" ],
);

%shub_01_00645_def =
( NAME    => "SH_MEM_ERROR_OVERFLOW",
  ADDRESS => 0x00000001000000c8,
  NOTE    => "MD Error Overflow",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00645_flds
);


##########################################################################
#                                                                        #
#   SH_MEM_ERROR_OVERFLOW_ALIAS                                          #
#                                                                        #
##########################################################################

%shub_01_00646_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_PKT_SIZE"                  => [   1,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: XN-to-MD Message Length Error Overflow" ],
   "PI_PKT_SIZE"                  => [   2,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: PI-to-MD Message Length Error Overflow" ],
   "RED_BLACK_ERR_TIMEOUT"        => [   3,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Red/Black Time-out Error Overflow" ],
   "XN_REQUEST_OVERFLOW"          => [   4,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: XN-to-MD Request Queue Overflow Error Overflow" ],
   "PI_REQUEST_OVERFLOW"          => [   5,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: PI-to-MD Request Queue Overflow Error Overflow" ],
   "XN_REPLY_OVERFLOW"            => [   6,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: XN-to-MD Reply Queue Overflow Error Overflow" ],
   "PI_REPLY_OVERFLOW"            => [   7,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: PI-to-MD Reply Queue Overflow Error Overflow" ],
   "RSVD1"                        => [   8,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQRS_INT_HW"                  => [   9,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQRS Hardware Error Overflow" ],
   "DQRS_INT_COR"                 => [  10,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQRS Correctable AMO Data Error Overflow" ],
   "DQRS_INT_UC"                  => [  11,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQRS Uncorrectable AMO Data Error Overflow" ],
   "RSVD2"                        => [  12,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQRP_INT_HW"                  => [  13,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQRP Hardware Error Overflow" ],
   "DQRP_INT_COR"                 => [  14,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQRP Correctable AMO Data Error Overflow" ],
   "DQRP_INT_UC"                  => [  15,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQRP Uncorrectable AMO Data Error Overflow" ],
   "RSVD3"                        => [  16,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQLS_INT_HW"                  => [  17,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQLS Hardware Error Overflow" ],
   "DQLS_INT_COR"                 => [  18,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQLS Correctable AMO Data Error Overflow" ],
   "DQLS_INT_UC"                  => [  19,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQLS Uncorrectable AMO Data Error Overflow" ],
   "RSVD4"                        => [  20,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQLP_INT_HW"                  => [  21,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQLP Hardware Error Overflow" ],
   "DQLP_INT_COR"                 => [  22,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQLP Correctable AMO Data Error Overflow" ],
   "DQLP_INT_UC"                  => [  23,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQLP Uncorrectable AMO Data Error Overflow" ],
   "RSVD5"                        => [  24,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR_ACC"                      => [  25,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Directory Access Error Overflow" ],
   "ACY_INT_HW"                   => [  26,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "MD_HW_INT: ACY Hardware Error Overflow" ],
   "ACX_INT_HW"                   => [  27,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "MD_HW_INT: ACX Hardware Error Overflow" ],
   "DQRP_DIR_COR"                 => [  28,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQRP Correctable Directory Data Error Overflow" ],
   "DQRP_DIR_UC"                  => [  29,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQRP Uncorrectable Directory Data Error Overflow" ],
   "DQLP_DIR_COR"                 => [  30,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQLP Correctable Directory Data Error Overflow" ],
   "DQLP_DIR_UC"                  => [  31,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQLP Uncorrectable Directory Data Error Overflow" ],
   "DQRP_DIR_PERR"                => [  32,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQRP Directory Protocol Error Overflow" ],
   "DQLP_DIR_PERR"                => [  33,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQLP Directory Protocol Error Overflow" ],
   "NONEXIST_ADDR"                => [  34,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Non-existent Memory Address Error Overflow" ],
   "ILLEGAL_CMD"                  => [  35,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Illegal Command Error Overflow" ],
);

%shub_01_00646_def =
( NAME    => "SH_MEM_ERROR_OVERFLOW_ALIAS",
  ADDRESS => 0x00000001000000d0,
  NOTE    => "MD Error Overflow Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00646_flds
);


##########################################################################
#                                                                        #
#   SH_MEM_ERROR_MASK                                                    #
#                                                                        #
##########################################################################

%shub_01_00647_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_PKT_SIZE"                  => [   1,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: XN-to-MD Message Length Error Mask" ],
   "PI_PKT_SIZE"                  => [   2,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: PI-to-MD Message Length Error Mask" ],
   "RED_BLACK_ERR_TIMEOUT"        => [   3,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Red/Black Time-out Error Mask" ],
   "XN_REQUEST_OVERFLOW"          => [   4,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: XN-to-MD Request Queue Overflow Error Mask" ],
   "PI_REQUEST_OVERFLOW"          => [   5,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: PI-to-MD Request Queue Overflow Error Mask" ],
   "XN_REPLY_OVERFLOW"            => [   6,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: XN-to-MD Reply Queue Overflow Error Mask" ],
   "PI_REPLY_OVERFLOW"            => [   7,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: PI-to-MD Reply Queue Overflow Error Mask" ],
   "RSVD1"                        => [   8,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQRS_INT_HW"                  => [   9,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQRS Hardware Error Mask" ],
   "DQRS_INT_COR"                 => [  10,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQRS Correctable AMO Data Error Mask" ],
   "DQRS_INT_UC"                  => [  11,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQRS Uncorrectable AMO Data Error Mask" ],
   "RSVD2"                        => [  12,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQRP_INT_HW"                  => [  13,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQRP Hardware Error Mask" ],
   "DQRP_INT_COR"                 => [  14,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQRP Correctable AMO Data Error Mask" ],
   "DQRP_INT_UC"                  => [  15,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQRP Uncorrectable AMO Data Error Mask" ],
   "RSVD3"                        => [  16,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQLS_INT_HW"                  => [  17,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQLS Hardware Error Mask" ],
   "DQLS_INT_COR"                 => [  18,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQLS Correctable AMO Data Error Mask" ],
   "DQLS_INT_UC"                  => [  19,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQLS Uncorrectable AMO Data Error Mask" ],
   "RSVD4"                        => [  20,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQLP_INT_HW"                  => [  21,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQLP Hardware Error Mask" ],
   "DQLP_INT_COR"                 => [  22,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQLP Correctable AMO Data Error Mask" ],
   "DQLP_INT_UC"                  => [  23,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQLP Uncorrectable AMO Data Error Mask" ],
   "RSVD5"                        => [  24,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR_ACC"                      => [  25,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Directory Access Error Mask" ],
   "ACY_INT_HW"                   => [  26,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "MD_HW_INT: ACY Hardware Error Mask" ],
   "ACX_INT_HW"                   => [  27,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "MD_HW_INT: ACX Hardware Error Mask" ],
   "DQRP_DIR_COR"                 => [  28,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQRP Correctable Directory Data Error Mask" ],
   "DQRP_DIR_UC"                  => [  29,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQRP Uncorrectable Directory Data Error Mask" ],
   "DQLP_DIR_COR"                 => [  30,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "MD_CE_INT: DQLP Correctable Directory Data Error Mask" ],
   "DQLP_DIR_UC"                  => [  31,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "MD_UCE_INT: DQLP Uncorrectable Directory Data Error Mask" ],
   "DQRP_DIR_PERR"                => [  32,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQRP Directory Protocol Error Mask" ],
   "DQLP_DIR_PERR"                => [  33,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "MD_HW_INT: DQLP Directory Protocol Error Mask" ],
   "NONEXIST_ADDR"                => [  34,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Non-existent Memory Address Error Mask" ],
   "ILLEGAL_CMD"                  => [  35,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "MD_HW_INT: Illegal Command Error Mask" ],
);

%shub_01_00647_def =
( NAME    => "SH_MEM_ERROR_MASK",
  ADDRESS => 0x00000001000000d8,
  NOTE    => "MD Error Mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00647_flds
);


##########################################################################
#                                                                        #
#   SH_X_DIMM_CFG                                                        #
#                                                                        #
##########################################################################

%shub_01_00648_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  36,  28, 0xFFFFFFF000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FREQ"                         => [   1,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "DIMM frequency select" ],
   "RSVD1"                        => [   2,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIMM3_CS"                     => [   3,  29,   2, 0x0000000060000000, 0x00, 1, 0x0000000000000000, "DIMM 3 chip select, addr[35:34] match" ],
   "DIMM3_REV"                    => [   4,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "DIMM 3 physical banks reversed" ],
   "DIMM3_2BK"                    => [   5,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "DIMM 3 has two physical banks" ],
   "DIMM3_SIZE"                   => [   6,  24,   3, 0x0000000007000000, 0x00, 1, 0x0000000000000000, "DIMM 3 DRAM size" ],
   "RSVD2"                        => [   7,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIMM2_CS"                     => [   8,  21,   2, 0x0000000000600000, 0x00, 1, 0x0000000000000000, "DIMM 2 chip select, addr[35:34] match" ],
   "DIMM2_REV"                    => [   9,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "DIMM 2 physical banks reversed" ],
   "DIMM2_2BK"                    => [  10,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "DIMM 2 has two physical banks" ],
   "DIMM2_SIZE"                   => [  11,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "DIMM 2 DRAM size" ],
   "RSVD3"                        => [  12,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIMM1_CS"                     => [  13,  13,   2, 0x0000000000006000, 0x00, 1, 0x0000000000000000, "DIMM 1 chip select, addr[35:34] match" ],
   "DIMM1_REV"                    => [  14,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "DIMM 1 physical banks reversed" ],
   "DIMM1_2BK"                    => [  15,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "DIMM 1 has two physical banks" ],
   "DIMM1_SIZE"                   => [  16,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "DIMM 1 DRAM size" ],
   "RSVD4"                        => [  17,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIMM0_CS"                     => [  18,   5,   2, 0x0000000000000060, 0x00, 1, 0x0000000000000000, "DIMM 0 chip select, addr[35:34] match" ],
   "DIMM0_REV"                    => [  19,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "DIMM 0 physical banks reversed" ],
   "DIMM0_2BK"                    => [  20,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "DIMM 0 has two physical banks" ],
   "DIMM0_SIZE"                   => [  21,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "DIMM 0 DRAM size" ],
);

%shub_01_00648_def =
( NAME    => "SH_X_DIMM_CFG",
  ADDRESS => 0x0000000100010000,
  NOTE    => "AC Mem Config Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00648_flds
);


##########################################################################
#                                                                        #
#   SH_Y_DIMM_CFG                                                        #
#                                                                        #
##########################################################################

%shub_01_00649_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  36,  28, 0xFFFFFFF000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FREQ"                         => [   1,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "DIMM frequency select" ],
   "RSVD1"                        => [   2,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIMM3_CS"                     => [   3,  29,   2, 0x0000000060000000, 0x00, 1, 0x0000000000000000, "DIMM 3 chip select, addr[35:34] match" ],
   "DIMM3_REV"                    => [   4,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "DIMM 3 physical banks reversed" ],
   "DIMM3_2BK"                    => [   5,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "DIMM 3 has two physical banks" ],
   "DIMM3_SIZE"                   => [   6,  24,   3, 0x0000000007000000, 0x00, 1, 0x0000000000000000, "DIMM 3 DRAM size" ],
   "RSVD2"                        => [   7,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIMM2_CS"                     => [   8,  21,   2, 0x0000000000600000, 0x00, 1, 0x0000000000000000, "DIMM 2 chip select, addr[35:34] match" ],
   "DIMM2_REV"                    => [   9,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "DIMM 2 physical banks reversed" ],
   "DIMM2_2BK"                    => [  10,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "DIMM 2 has two physical banks" ],
   "DIMM2_SIZE"                   => [  11,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "DIMM 2 DRAM size" ],
   "RSVD3"                        => [  12,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIMM1_CS"                     => [  13,  13,   2, 0x0000000000006000, 0x00, 1, 0x0000000000000000, "DIMM 1 chip select, addr[35:34] match" ],
   "DIMM1_REV"                    => [  14,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "DIMM 1 physical banks reversed" ],
   "DIMM1_2BK"                    => [  15,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "DIMM 1 has two physical banks" ],
   "DIMM1_SIZE"                   => [  16,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "DIMM 1 DRAM size" ],
   "RSVD4"                        => [  17,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIMM0_CS"                     => [  18,   5,   2, 0x0000000000000060, 0x00, 1, 0x0000000000000000, "DIMM 0 chip select, addr[35:34] match" ],
   "DIMM0_REV"                    => [  19,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "DIMM 0 physical banks reversed" ],
   "DIMM0_2BK"                    => [  20,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "DIMM 0 has two physical banks" ],
   "DIMM0_SIZE"                   => [  21,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "DIMM 0 DRAM size" ],
);

%shub_01_00649_def =
( NAME    => "SH_Y_DIMM_CFG",
  ADDRESS => 0x0000000100010008,
  NOTE    => "AC Mem Config Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00649_flds
);


##########################################################################
#                                                                        #
#   SH_JNR_DIMM_CFG                                                      #
#                                                                        #
##########################################################################

%shub_01_00650_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  36,  28, 0xFFFFFFF000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FREQ"                         => [   1,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "DIMM frequency select" ],
   "RSVD1"                        => [   2,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIMM3_CS"                     => [   3,  29,   2, 0x0000000060000000, 0x00, 1, 0x0000000000000000, "DIMM 3 chip select, addr[35:34] match" ],
   "DIMM3_REV"                    => [   4,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "DIMM 3 physical banks reversed" ],
   "DIMM3_2BK"                    => [   5,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "DIMM 3 has two physical banks" ],
   "DIMM3_SIZE"                   => [   6,  24,   3, 0x0000000007000000, 0x00, 1, 0x0000000000000000, "DIMM 3 DRAM size" ],
   "RSVD2"                        => [   7,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIMM2_CS"                     => [   8,  21,   2, 0x0000000000600000, 0x00, 1, 0x0000000000000000, "DIMM 2 chip select, addr[35:34] match" ],
   "DIMM2_REV"                    => [   9,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "DIMM 2 physical banks reversed" ],
   "DIMM2_2BK"                    => [  10,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "DIMM 2 has two physical banks" ],
   "DIMM2_SIZE"                   => [  11,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "DIMM 2 DRAM size" ],
   "RSVD3"                        => [  12,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIMM1_CS"                     => [  13,  13,   2, 0x0000000000006000, 0x00, 1, 0x0000000000000000, "DIMM 1 chip select, addr[35:34] match" ],
   "DIMM1_REV"                    => [  14,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "DIMM 1 physical banks reversed" ],
   "DIMM1_2BK"                    => [  15,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "DIMM 1 has two physical banks" ],
   "DIMM1_SIZE"                   => [  16,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "DIMM 1 DRAM size" ],
   "RSVD4"                        => [  17,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIMM0_CS"                     => [  18,   5,   2, 0x0000000000000060, 0x00, 1, 0x0000000000000000, "DIMM 0 chip select, addr[35:34] match" ],
   "DIMM0_REV"                    => [  19,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "DIMM 0 physical banks reversed" ],
   "DIMM0_2BK"                    => [  20,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "DIMM 0 has two physical banks" ],
   "DIMM0_SIZE"                   => [  21,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "DIMM 0 DRAM size" ],
);

%shub_01_00650_def =
( NAME    => "SH_JNR_DIMM_CFG",
  ADDRESS => 0x0000000100010010,
  NOTE    => "AC Mem Config Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00650_flds
);


##########################################################################
#                                                                        #
#   SH_X_PHASE_CFG                                                       #
#                                                                        #
##########################################################################

%shub_01_00651_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQ_SEL_A"                     => [   1,  59,   4, 0x7800000000000000, 0x00, 1, 0x0000000000000000, "DATA MCI select A memory clock latch" ],
   "SEL_A"                        => [   2,  55,   4, 0x0780000000000000, 0x00, 1, 0x0000000000000000, "address,control select A memory clock latch" ],
   "PHE_BUBBLE"                   => [   3,  52,   3, 0x0070000000000000, 0x00, 1, 0x0000000000000000, "MMR phaseE bubble value" ],
   "PHD_BUBBLE"                   => [   4,  49,   3, 0x000E000000000000, 0x00, 1, 0x0000000000000000, "MMR phaseD bubble value" ],
   "PHC_BUBBLE"                   => [   5,  46,   3, 0x0001C00000000000, 0x00, 1, 0x0000000000000000, "MMR phaseC bubble value" ],
   "PHB_BUBBLE"                   => [   6,  43,   3, 0x0000380000000000, 0x00, 1, 0x0000000000000000, "MMR phaseB bubble value" ],
   "PHA_BUBBLE"                   => [   7,  40,   3, 0x0000070000000000, 0x00, 1, 0x0000000000000000, "MMR phaseA bubble value" ],
   "BUBBLE_EN"                    => [   8,  35,   5, 0x000000F800000000, 0x00, 1, 0x0000000000000000, "bubble, idle core clock to wait for memory clock" ],
   "ADD_CP"                       => [   9,  30,   5, 0x00000007C0000000, 0x00, 1, 0x0000000000000000, "add delay clock period to dqct delay chain on phase" ],
   "HOLD_REQ"                     => [  10,  25,   5, 0x000000003E000000, 0x00, 1, 0x0000000000000000, "Hold next request on core clock phase" ],
   "HOLD"                         => [  11,  20,   5, 0x0000000001F00000, 0x00, 1, 0x0000000000000000, "Hold request on core clock phase" ],
   "DQ_LD_B"                      => [  12,  15,   5, 0x00000000000F8000, 0x00, 1, 0x0000000000000000, "DATA MCI load core clock B latch" ],
   "DQ_LD_A"                      => [  13,  10,   5, 0x0000000000007C00, 0x00, 1, 0x0000000000000000, "DATA MCI load core clock A latch" ],
   "LD_B"                         => [  14,   5,   5, 0x00000000000003E0, 0x00, 1, 0x0000000000000000, "Address, control load core clock B latch" ],
   "LD_A"                         => [  15,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Address, control load core clock A latch" ],
);

%shub_01_00651_def =
( NAME    => "SH_X_PHASE_CFG",
  ADDRESS => 0x0000000100010018,
  NOTE    => "AC Phase Config Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00651_flds
);


##########################################################################
#                                                                        #
#   SH_X_CFG                                                             #
#                                                                        #
##########################################################################

%shub_01_00652_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CLR_DIR_CACHE"                => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Clear directory cache tags" ],
   "INV_CAS_ADDR"                 => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Invert cas address bits 3 to 7" ],
   "REQ_CNTR_VAL"                 => [   2,  56,   6, 0x3F00000000000000, 0x00, 1, 0x0000000000000000, "Request counter delay value in CPs" ],
   "REQ_CNTR_DIS"                 => [   3,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "Request delay counter disabled" ],
   "TRCD4_EN"                     => [   4,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "Trcd, ras to case delay of 4 CPs enabled" ],
   "TRCD2_EN"                     => [   5,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "Trcd, ras to cas delay of 2 CPs enabled" ],
   "SSO_WT_EN"                    => [   6,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "Simultaneous switching enabled on output data pins" ],
   "WT_BB_CLR"                    => [   7,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "Bank busy CPs for all write request" ],
   "DC_BB_CLR"                    => [   8,  44,   4, 0x0000F00000000000, 0x00, 1, 0x0000000000000000, "Bank busy CPs for a directory cache read request" ],
   "DA_BB_CLR"                    => [   9,  40,   4, 0x00000F0000000000, 0x00, 1, 0x0000000000000000, "Bank busy CPs for a data read request" ],
   "TA_DLYS"                      => [  10,   8,  32, 0x000000FFFFFFFF00, 0x00, 1, 0x0000000000000000, "Turn around delays" ],
   "DIR_COUNTER_INIT"             => [  11,   2,   6, 0x00000000000000FC, 0x00, 1, 0x0000000000000000, "Dir counter initial value" ],
   "DIRC_RANDOM_REPLACEMENT"      => [  12,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Directory cache random replacement" ],
   "MODE_SERIAL"                  => [  13,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Arbque arbitration in serial mode" ],
);

%shub_01_00652_def =
( NAME    => "SH_X_CFG",
  ADDRESS => 0x0000000100010020,
  NOTE    => "AC Config Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00652_flds
);


##########################################################################
#                                                                        #
#   SH_X_DQCT_CFG                                                        #
#                                                                        #
##########################################################################

%shub_01_00653_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MDIR_RD_SEL"                  => [   1,  20,   4, 0x0000000000F00000, 0x00, 1, 0x0000000000000000, "Dir ready read select" ],
   "DIR_RD_SEL"                   => [   2,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "Dir ready read select" ],
   "DTA_WT_SEL"                   => [   3,  12,   4, 0x000000000000F000, 0x00, 1, 0x0000000000000000, "Data ready write select" ],
   "DTA_RD_SEL"                   => [   4,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "Data ready read select" ],
   "WT_SEL"                       => [   5,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "Write data select" ],
   "RD_SEL"                       => [   6,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Read data select" ],
);

%shub_01_00653_def =
( NAME    => "SH_X_DQCT_CFG",
  ADDRESS => 0x0000000100010028,
  NOTE    => "AC Config Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00653_flds
);


##########################################################################
#                                                                        #
#   SH_X_REFRESH_CONTROL                                                 #
#                                                                        #
##########################################################################

%shub_01_00654_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HALF_RATE"                    => [   1,  24,   4, 0x000000000F000000, 0x00, 1, 0x0000000000000000, "Refresh half rate" ],
   "INTERLEAVE"                   => [   2,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "Refresh interleave" ],
   "HOLD"                         => [   3,  17,   6, 0x00000000007E0000, 0x00, 1, 0x0000000000000000, "Refresh hold" ],
   "INTERVAL"                     => [   4,   8,   9, 0x000000000001FF00, 0x00, 1, 0x0000000000000000, "Refresh interval in core CPs" ],
   "ENABLE"                       => [   5,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Refresh enable" ],
);

%shub_01_00654_def =
( NAME    => "SH_X_REFRESH_CONTROL",
  ADDRESS => 0x0000000100010030,
  NOTE    => "Refresh Control Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00654_flds
);


##########################################################################
#                                                                        #
#   SH_Y_PHASE_CFG                                                       #
#                                                                        #
##########################################################################

%shub_01_00655_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQ_SEL_A"                     => [   1,  59,   4, 0x7800000000000000, 0x00, 1, 0x0000000000000000, "DATA MCI select A memory clock latch" ],
   "SEL_A"                        => [   2,  55,   4, 0x0780000000000000, 0x00, 1, 0x0000000000000000, "address,control select A memory clock latch" ],
   "PHE_BUBBLE"                   => [   3,  52,   3, 0x0070000000000000, 0x00, 1, 0x0000000000000000, "MMR phaseE bubble value" ],
   "PHD_BUBBLE"                   => [   4,  49,   3, 0x000E000000000000, 0x00, 1, 0x0000000000000000, "MMR phaseD bubble value" ],
   "PHC_BUBBLE"                   => [   5,  46,   3, 0x0001C00000000000, 0x00, 1, 0x0000000000000000, "MMR phaseC bubble value" ],
   "PHB_BUBBLE"                   => [   6,  43,   3, 0x0000380000000000, 0x00, 1, 0x0000000000000000, "MMR phaseB bubble value" ],
   "PHA_BUBBLE"                   => [   7,  40,   3, 0x0000070000000000, 0x00, 1, 0x0000000000000000, "MMR phaseA bubble value" ],
   "BUBBLE_EN"                    => [   8,  35,   5, 0x000000F800000000, 0x00, 1, 0x0000000000000000, "bubble, idle core clock to wait for memory clock" ],
   "ADD_CP"                       => [   9,  30,   5, 0x00000007C0000000, 0x00, 1, 0x0000000000000000, "add delay clock period to dqct delay chain on phase" ],
   "HOLD_REQ"                     => [  10,  25,   5, 0x000000003E000000, 0x00, 1, 0x0000000000000000, "Hold next request on core clock phase" ],
   "HOLD"                         => [  11,  20,   5, 0x0000000001F00000, 0x00, 1, 0x0000000000000000, "Hold request on core clock phase" ],
   "DQ_LD_B"                      => [  12,  15,   5, 0x00000000000F8000, 0x00, 1, 0x0000000000000000, "DATA MCI load core clock B latch" ],
   "DQ_LD_A"                      => [  13,  10,   5, 0x0000000000007C00, 0x00, 1, 0x0000000000000000, "DATA MCI load core clock A latch" ],
   "LD_B"                         => [  14,   5,   5, 0x00000000000003E0, 0x00, 1, 0x0000000000000000, "Address, control load core clock B latch" ],
   "LD_A"                         => [  15,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Address, control load core clock A latch" ],
);

%shub_01_00655_def =
( NAME    => "SH_Y_PHASE_CFG",
  ADDRESS => 0x0000000100010038,
  NOTE    => "AC Phase Config Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00655_flds
);


##########################################################################
#                                                                        #
#   SH_Y_CFG                                                             #
#                                                                        #
##########################################################################

%shub_01_00656_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CLR_DIR_CACHE"                => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Clear directory cache tags" ],
   "INV_CAS_ADDR"                 => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Invert cas address bits 3 to 7" ],
   "REQ_CNTR_VAL"                 => [   2,  56,   6, 0x3F00000000000000, 0x00, 1, 0x0000000000000000, "Request counter delay value in CPs" ],
   "REQ_CNTR_DIS"                 => [   3,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "Request delay counter disabled" ],
   "TRCD4_EN"                     => [   4,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "Trcd, ras to case delay of 4 CPs enabled" ],
   "TRCD2_EN"                     => [   5,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "Trcd, ras to cas delay of 2 CPs enabled" ],
   "SSO_WT_EN"                    => [   6,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "Simultaneous switching enabled on output data pins" ],
   "WT_BB_CLR"                    => [   7,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "Bank busy CPs for all write request" ],
   "DC_BB_CLR"                    => [   8,  44,   4, 0x0000F00000000000, 0x00, 1, 0x0000000000000000, "Bank busy CPs for a directory cache read request" ],
   "DA_BB_CLR"                    => [   9,  40,   4, 0x00000F0000000000, 0x00, 1, 0x0000000000000000, "Bank busy CPs for a data read request" ],
   "TA_DLYS"                      => [  10,   8,  32, 0x000000FFFFFFFF00, 0x00, 1, 0x0000000000000000, "Turn around delays" ],
   "DIR_COUNTER_INIT"             => [  11,   2,   6, 0x00000000000000FC, 0x00, 1, 0x0000000000000000, "Dir counter initial value" ],
   "DIRC_RANDOM_REPLACEMENT"      => [  12,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Directory cache random replacement" ],
   "MODE_SERIAL"                  => [  13,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Arbque arbitration in serial mode" ],
);

%shub_01_00656_def =
( NAME    => "SH_Y_CFG",
  ADDRESS => 0x0000000100010040,
  NOTE    => "AC Config Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00656_flds
);


##########################################################################
#                                                                        #
#   SH_Y_DQCT_CFG                                                        #
#                                                                        #
##########################################################################

%shub_01_00657_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MDIR_RD_SEL"                  => [   1,  20,   4, 0x0000000000F00000, 0x00, 1, 0x0000000000000000, "Dir ready read select" ],
   "DIR_RD_SEL"                   => [   2,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "Dir ready read select" ],
   "DTA_WT_SEL"                   => [   3,  12,   4, 0x000000000000F000, 0x00, 1, 0x0000000000000000, "Data ready write select" ],
   "DTA_RD_SEL"                   => [   4,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "Data ready read select" ],
   "WT_SEL"                       => [   5,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "Write data select" ],
   "RD_SEL"                       => [   6,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Read data select" ],
);

%shub_01_00657_def =
( NAME    => "SH_Y_DQCT_CFG",
  ADDRESS => 0x0000000100010048,
  NOTE    => "AC Config Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00657_flds
);


##########################################################################
#                                                                        #
#   SH_Y_REFRESH_CONTROL                                                 #
#                                                                        #
##########################################################################

%shub_01_00658_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HALF_RATE"                    => [   1,  24,   4, 0x000000000F000000, 0x00, 1, 0x0000000000000000, "Refresh half rate" ],
   "INTERLEAVE"                   => [   2,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "Refresh interleave" ],
   "HOLD"                         => [   3,  17,   6, 0x00000000007E0000, 0x00, 1, 0x0000000000000000, "Refresh hold" ],
   "INTERVAL"                     => [   4,   8,   9, 0x000000000001FF00, 0x00, 1, 0x0000000000000000, "Refresh interval in core CPs" ],
   "ENABLE"                       => [   5,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Refresh enable" ],
);

%shub_01_00658_def =
( NAME    => "SH_Y_REFRESH_CONTROL",
  ADDRESS => 0x0000000100010050,
  NOTE    => "Refresh Control Register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00658_flds
);


##########################################################################
#                                                                        #
#   SH_MEM_RED_BLACK                                                     #
#                                                                        #
##########################################################################

%shub_01_00659_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  52,  12, 0xFFF0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERR_TIME"                     => [   1,  16,  36, 0x000FFFFFFFFF0000, 0x00, 1, 0x0000000000000000, "Max clocks to wait after red/black change for old color to clear." ],
   "TIME"                         => [   2,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "Clocks to tag references with a given color" ],
);

%shub_01_00659_def =
( NAME    => "SH_MEM_RED_BLACK",
  ADDRESS => 0x0000000100010058,
  NOTE    => "MD fairness watchdog timers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00659_flds
);


##########################################################################
#                                                                        #
#   SH_MISC_MEM_CFG                                                      #
#                                                                        #
##########################################################################

%shub_01_00660_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  53,  11, 0xFFE0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ALTERNATE_XN_RP_PLANE"        => [   1,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "enables plane alternating for replies to XN" ],
   "RSVD1"                        => [   2,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DISABLED_VICTIMS"             => [   3,  44,   6, 0x0003F00000000000, 0x00, 1, 0x0000000000000000, "number of dir cache victim buffers to take out of circulation in each quadrant of the MD" ],
   "RSVD2"                        => [   4,  41,   3, 0x00000E0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DISABLED_WRITE_TNUMS"         => [   5,  36,   5, 0x000001F000000000, 0x00, 1, 0x0000000000000000, "number of write tnums to take out of circulation" ],
   "RSVD3"                        => [   6,  33,   3, 0x0000000E00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DISABLED_READ_TNUMS"          => [   7,  28,   5, 0x00000001F0000000, 0x00, 1, 0x0000000000000000, "number of read tnums to take out of circulation" ],
   "THROTTLE_CNT"                 => [   8,  20,   8, 0x000000000FF00000, 0x00, 1, 0x0000000000000000, "number of clocks between accepting references" ],
   "RSVD4"                        => [   9,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LOW_VICTIM_BUFFER_THRESHOLD"  => [  10,  12,   6, 0x000000000003F000, 0x00, 1, 0x0000000000000000, "point at which dir cache writes get higher priority" ],
   "RSVD5"                        => [  11,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LOW_WRITE_BUFFER_THRESHOLD"   => [  12,   4,   6, 0x00000000000003F0, 0x00, 1, 0x0000000000000000, "point at which data writes get higher priority" ],
   "XN_RD_SAME_AS_PI"             => [  13,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "disables a one clock delay of XN read data" ],
   "JNR_BYPASS_ENABLE"            => [  14,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "enables bypass path for requests going through ac" ],
   "SPEC_HEADER_ENABLE"           => [  15,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "enables the use of speculative headers from md to pi" ],
   "EXPRESS_HEADER_ENABLE"        => [  16,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "enables the use of express headers from md to pi" ],
);

%shub_01_00660_def =
( NAME    => "SH_MISC_MEM_CFG",
  ADDRESS => 0x0000000100010060,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00660_flds
);


##########################################################################
#                                                                        #
#   SH_PIO_RQ_CRD_CTL                                                    #
#                                                                        #
##########################################################################

%shub_01_00661_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   6,  58, 0xFFFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEPTH"                        => [   1,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Total depth of buffering (in sic packets)" ],
);

%shub_01_00661_def =
( NAME    => "SH_PIO_RQ_CRD_CTL",
  ADDRESS => 0x0000000100010068,
  NOTE    => "pio_rq Credit Circulation Control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00661_flds
);


##########################################################################
#                                                                        #
#   SH_PI_MD_RQ_CRD_CTL                                                  #
#                                                                        #
##########################################################################

%shub_01_00662_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   6,  58, 0xFFFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEPTH"                        => [   1,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Total depth of buffering (in sic packets)" ],
);

%shub_01_00662_def =
( NAME    => "SH_PI_MD_RQ_CRD_CTL",
  ADDRESS => 0x0000000100010070,
  NOTE    => "pi_md_rq Credit Circulation Control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00662_flds
);


##########################################################################
#                                                                        #
#   SH_PI_MD_RP_CRD_CTL                                                  #
#                                                                        #
##########################################################################

%shub_01_00663_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   6,  58, 0xFFFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEPTH"                        => [   1,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Total depth of buffering (in sic packets)" ],
);

%shub_01_00663_def =
( NAME    => "SH_PI_MD_RP_CRD_CTL",
  ADDRESS => 0x0000000100010078,
  NOTE    => "pi_md_rp Credit Circulation Control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00663_flds
);


##########################################################################
#                                                                        #
#   SH_XN_MD_RQ_CRD_CTL                                                  #
#                                                                        #
##########################################################################

%shub_01_00664_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   6,  58, 0xFFFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEPTH"                        => [   1,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Total depth of buffering (in sic packets)" ],
);

%shub_01_00664_def =
( NAME    => "SH_XN_MD_RQ_CRD_CTL",
  ADDRESS => 0x0000000100010080,
  NOTE    => "xn_md_rq Credit Circulation Control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00664_flds
);


##########################################################################
#                                                                        #
#   SH_XN_MD_RP_CRD_CTL                                                  #
#                                                                        #
##########################################################################

%shub_01_00665_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   6,  58, 0xFFFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEPTH"                        => [   1,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Total depth of buffering (in sic packets)" ],
);

%shub_01_00665_def =
( NAME    => "SH_XN_MD_RP_CRD_CTL",
  ADDRESS => 0x0000000100010088,
  NOTE    => "xn_md_rp Credit Circulation Control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00665_flds
);


##########################################################################
#                                                                        #
#   SH_X_TAG0                                                            #
#                                                                        #
##########################################################################

%shub_01_00666_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  20,  44, 0xFFFFFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  20, 0x00000000000FFFFF, 0x00, 0, 0x0000000000000000, "Valid + Tag Address" ],
);

%shub_01_00666_def =
( NAME    => "SH_X_TAG0",
  ADDRESS => 0x0000000100020000,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00666_flds
);


##########################################################################
#                                                                        #
#   SH_X_TAG1                                                            #
#                                                                        #
##########################################################################

%shub_01_00667_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  20,  44, 0xFFFFFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  20, 0x00000000000FFFFF, 0x00, 0, 0x0000000000000000, "Valid + Tag Address" ],
);

%shub_01_00667_def =
( NAME    => "SH_X_TAG1",
  ADDRESS => 0x0000000100020008,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00667_flds
);


##########################################################################
#                                                                        #
#   SH_X_TAG2                                                            #
#                                                                        #
##########################################################################

%shub_01_00668_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  20,  44, 0xFFFFFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  20, 0x00000000000FFFFF, 0x00, 0, 0x0000000000000000, "Valid + Tag Address" ],
);

%shub_01_00668_def =
( NAME    => "SH_X_TAG2",
  ADDRESS => 0x0000000100020010,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00668_flds
);


##########################################################################
#                                                                        #
#   SH_X_TAG3                                                            #
#                                                                        #
##########################################################################

%shub_01_00669_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  20,  44, 0xFFFFFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  20, 0x00000000000FFFFF, 0x00, 0, 0x0000000000000000, "Valid + Tag Address" ],
);

%shub_01_00669_def =
( NAME    => "SH_X_TAG3",
  ADDRESS => 0x0000000100020018,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00669_flds
);


##########################################################################
#                                                                        #
#   SH_X_TAG4                                                            #
#                                                                        #
##########################################################################

%shub_01_00670_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  20,  44, 0xFFFFFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  20, 0x00000000000FFFFF, 0x00, 0, 0x0000000000000000, "Valid + Tag Address" ],
);

%shub_01_00670_def =
( NAME    => "SH_X_TAG4",
  ADDRESS => 0x0000000100020020,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00670_flds
);


##########################################################################
#                                                                        #
#   SH_X_TAG5                                                            #
#                                                                        #
##########################################################################

%shub_01_00671_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  20,  44, 0xFFFFFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  20, 0x00000000000FFFFF, 0x00, 0, 0x0000000000000000, "Valid + Tag Address" ],
);

%shub_01_00671_def =
( NAME    => "SH_X_TAG5",
  ADDRESS => 0x0000000100020028,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00671_flds
);


##########################################################################
#                                                                        #
#   SH_X_TAG6                                                            #
#                                                                        #
##########################################################################

%shub_01_00672_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  20,  44, 0xFFFFFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  20, 0x00000000000FFFFF, 0x00, 0, 0x0000000000000000, "Valid + Tag Address" ],
);

%shub_01_00672_def =
( NAME    => "SH_X_TAG6",
  ADDRESS => 0x0000000100020030,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00672_flds
);


##########################################################################
#                                                                        #
#   SH_X_TAG7                                                            #
#                                                                        #
##########################################################################

%shub_01_00673_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  20,  44, 0xFFFFFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  20, 0x00000000000FFFFF, 0x00, 0, 0x0000000000000000, "Valid + Tag Address" ],
);

%shub_01_00673_def =
( NAME    => "SH_X_TAG7",
  ADDRESS => 0x0000000100020038,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00673_flds
);


##########################################################################
#                                                                        #
#   SH_Y_TAG0                                                            #
#                                                                        #
##########################################################################

%shub_01_00674_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  20,  44, 0xFFFFFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  20, 0x00000000000FFFFF, 0x00, 0, 0x0000000000000000, "Valid + Tag Address" ],
);

%shub_01_00674_def =
( NAME    => "SH_Y_TAG0",
  ADDRESS => 0x0000000100020040,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00674_flds
);


##########################################################################
#                                                                        #
#   SH_Y_TAG1                                                            #
#                                                                        #
##########################################################################

%shub_01_00675_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  20,  44, 0xFFFFFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  20, 0x00000000000FFFFF, 0x00, 0, 0x0000000000000000, "Valid + Tag Address" ],
);

%shub_01_00675_def =
( NAME    => "SH_Y_TAG1",
  ADDRESS => 0x0000000100020048,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00675_flds
);


##########################################################################
#                                                                        #
#   SH_Y_TAG2                                                            #
#                                                                        #
##########################################################################

%shub_01_00676_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  20,  44, 0xFFFFFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  20, 0x00000000000FFFFF, 0x00, 0, 0x0000000000000000, "Valid + Tag Address" ],
);

%shub_01_00676_def =
( NAME    => "SH_Y_TAG2",
  ADDRESS => 0x0000000100020050,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00676_flds
);


##########################################################################
#                                                                        #
#   SH_Y_TAG3                                                            #
#                                                                        #
##########################################################################

%shub_01_00677_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  20,  44, 0xFFFFFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  20, 0x00000000000FFFFF, 0x00, 0, 0x0000000000000000, "Valid + Tag Address" ],
);

%shub_01_00677_def =
( NAME    => "SH_Y_TAG3",
  ADDRESS => 0x0000000100020058,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00677_flds
);


##########################################################################
#                                                                        #
#   SH_Y_TAG4                                                            #
#                                                                        #
##########################################################################

%shub_01_00678_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  20,  44, 0xFFFFFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  20, 0x00000000000FFFFF, 0x00, 0, 0x0000000000000000, "Valid + Tag Address" ],
);

%shub_01_00678_def =
( NAME    => "SH_Y_TAG4",
  ADDRESS => 0x0000000100020060,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00678_flds
);


##########################################################################
#                                                                        #
#   SH_Y_TAG5                                                            #
#                                                                        #
##########################################################################

%shub_01_00679_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  20,  44, 0xFFFFFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  20, 0x00000000000FFFFF, 0x00, 0, 0x0000000000000000, "Valid + Tag Address" ],
);

%shub_01_00679_def =
( NAME    => "SH_Y_TAG5",
  ADDRESS => 0x0000000100020068,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00679_flds
);


##########################################################################
#                                                                        #
#   SH_Y_TAG6                                                            #
#                                                                        #
##########################################################################

%shub_01_00680_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  20,  44, 0xFFFFFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  20, 0x00000000000FFFFF, 0x00, 0, 0x0000000000000000, "Valid + Tag Address" ],
);

%shub_01_00680_def =
( NAME    => "SH_Y_TAG6",
  ADDRESS => 0x0000000100020070,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00680_flds
);


##########################################################################
#                                                                        #
#   SH_Y_TAG7                                                            #
#                                                                        #
##########################################################################

%shub_01_00681_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  20,  44, 0xFFFFFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAG"                          => [   1,   0,  20, 0x00000000000FFFFF, 0x00, 0, 0x0000000000000000, "Valid + Tag Address" ],
);

%shub_01_00681_def =
( NAME    => "SH_Y_TAG7",
  ADDRESS => 0x0000000100020078,
  NOTE    => "AC tag Registers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00681_flds
);


##########################################################################
#                                                                        #
#   SH_MMRBIST_BASE                                                      #
#                                                                        #
##########################################################################

%shub_01_00682_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  50,  14, 0xFFFC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DWORD_ADDR"                   => [   1,   3,  47, 0x0003FFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "bits 49:3 of the memory address" ],
);

%shub_01_00682_def =
( NAME    => "SH_MMRBIST_BASE",
  ADDRESS => 0x0000000100020080,
  NOTE    => "mmr/bist base address",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00682_flds
);


##########################################################################
#                                                                        #
#   SH_MMRBIST_CTL                                                       #
#                                                                        #
##########################################################################

%shub_01_00683_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  45,  19, 0xFFFFE00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RESET_STATE"                  => [   1,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "writing a 1 resets mmrbist hardware, hardware clears on completion" ],
   "RSVD1"                        => [   2,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MEM_IDLE"                     => [   3,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "all memory activity is complete" ],
   "FAIL"                         => [   4,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "mmr/bist had a data or address error" ],
   "IN_PROGRESS"                  => [   5,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "writing a 1 starts operation, hardware clears on completion" ],
   "RSVD2"                        => [   6,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CMD"                          => [   7,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "mmr/bist function" ],
   "RSVD3"                        => [   8,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BLOCK_LENGTH"                 => [   9,   0,  31, 0x000000007FFFFFFF, 0x00, 0, 0x0000000000000000, "number of dwords in operation" ],
);

%shub_01_00683_def =
( NAME    => "SH_MMRBIST_CTL",
  ADDRESS => 0x0000000100020088,
  NOTE    => "Bist base address",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00683_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DBUG_DATA_CFG                                                  #
#                                                                        #
##########################################################################

%shub_01_00684_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE"               => [   1,  60,   3, 0x7000000000000000, 0x00, 1, 0x0000000000000000, "selects which nibble from selected chiplet drives nibble7" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_CHIPLET"              => [   3,  56,   3, 0x0700000000000000, 0x00, 1, 0x0000000000000000, "selects which md chiplet drives nibble7" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE"               => [   5,  52,   3, 0x0070000000000000, 0x00, 1, 0x0000000000000000, "selects which nibble from selected chiplet drives nibble6" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_CHIPLET"              => [   7,  48,   3, 0x0007000000000000, 0x00, 1, 0x0000000000000000, "selects which md chiplet drives nibble6" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE"               => [   9,  44,   3, 0x0000700000000000, 0x00, 1, 0x0000000000000000, "selects which nibble from selected chiplet drives nibble5" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_CHIPLET"              => [  11,  40,   3, 0x0000070000000000, 0x00, 1, 0x0000000000000000, "selects which md chiplet drives nibble5" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE"               => [  13,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "selects which nibble from selected chiplet drives nibble4" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_CHIPLET"              => [  15,  32,   3, 0x0000000700000000, 0x00, 1, 0x0000000000000000, "selects which md chiplet drives nibble4" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE"               => [  17,  28,   3, 0x0000000070000000, 0x00, 1, 0x0000000000000000, "selects which nibble from selected chiplet drives nibble3" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_CHIPLET"              => [  19,  24,   3, 0x0000000007000000, 0x00, 1, 0x0000000000000000, "selects which md chiplet drives nibble3" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE"               => [  21,  20,   3, 0x0000000000700000, 0x00, 1, 0x0000000000000000, "selects which nibble from selected chiplet drives nibble2" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_CHIPLET"              => [  23,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "selects which md chiplet drives nibble2" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE"               => [  25,  12,   3, 0x0000000000007000, 0x00, 1, 0x0000000000000000, "selects which nibble from selected chiplet drives nibble1" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_CHIPLET"              => [  27,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "selects which md chiplet drives nibble1" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE"               => [  29,   4,   3, 0x0000000000000070, 0x00, 1, 0x0000000000000000, "selects which nibble from selected chiplet drives nibble0" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_CHIPLET"              => [  31,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "selects which md chiplet drives nibble0" ],
);

%shub_01_00684_def =
( NAME    => "SH_MD_DBUG_DATA_CFG",
  ADDRESS => 0x0000000100020100,
  NOTE    => "configuration for md debug data muxes",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00684_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DBUG_TRIGGER_CFG                                               #
#                                                                        #
##########################################################################

%shub_01_00685_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "enables triggering on pattern match" ],
   "NIBBLE7_NIBBLE"               => [   1,  60,   3, 0x7000000000000000, 0x00, 1, 0x0000000000000000, "selects which nibble from selected chiplet drives nibble7" ],
   "RSVD0"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_CHIPLET"              => [   3,  56,   3, 0x0700000000000000, 0x00, 1, 0x0000000000000000, "selects which md chiplet drives nibble7" ],
   "RSVD1"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE"               => [   5,  52,   3, 0x0070000000000000, 0x00, 1, 0x0000000000000000, "selects which nibble from selected chiplet drives nibble6" ],
   "RSVD2"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_CHIPLET"              => [   7,  48,   3, 0x0007000000000000, 0x00, 1, 0x0000000000000000, "selects which md chiplet drives nibble6" ],
   "RSVD3"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE"               => [   9,  44,   3, 0x0000700000000000, 0x00, 1, 0x0000000000000000, "selects which nibble from selected chiplet drives nibble5" ],
   "RSVD4"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_CHIPLET"              => [  11,  40,   3, 0x0000070000000000, 0x00, 1, 0x0000000000000000, "selects which md chiplet drives nibble5" ],
   "RSVD5"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE"               => [  13,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "selects which nibble from selected chiplet drives nibble4" ],
   "RSVD6"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_CHIPLET"              => [  15,  32,   3, 0x0000000700000000, 0x00, 1, 0x0000000000000000, "selects which md chiplet drives nibble4" ],
   "RSVD7"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE"               => [  17,  28,   3, 0x0000000070000000, 0x00, 1, 0x0000000000000000, "selects which nibble from selected chiplet drives nibble3" ],
   "RSVD8"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_CHIPLET"              => [  19,  24,   3, 0x0000000007000000, 0x00, 1, 0x0000000000000000, "selects which md chiplet drives nibble3" ],
   "RSVD9"                        => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE"               => [  21,  20,   3, 0x0000000000700000, 0x00, 1, 0x0000000000000000, "selects which nibble from selected chiplet drives nibble2" ],
   "RSVD10"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_CHIPLET"              => [  23,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "selects which md chiplet drives nibble2" ],
   "RSVD11"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE"               => [  25,  12,   3, 0x0000000000007000, 0x00, 1, 0x0000000000000000, "selects which nibble from selected chiplet drives nibble1" ],
   "RSVD12"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_CHIPLET"              => [  27,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "selects which md chiplet drives nibble1" ],
   "RSVD13"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE"               => [  29,   4,   3, 0x0000000000000070, 0x00, 1, 0x0000000000000000, "selects which nibble from selected chiplet drives nibble0" ],
   "RSVD14"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_CHIPLET"              => [  31,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "selects which md chiplet drives nibble0" ],
);

%shub_01_00685_def =
( NAME    => "SH_MD_DBUG_TRIGGER_CFG",
  ADDRESS => 0x0000000100020108,
  NOTE    => "configuration for md debug triggers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00685_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DBUG_COMPARE                                                   #
#                                                                        #
##########################################################################

%shub_01_00686_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 1, 0x0000000000000000, "bits to include in compare of dbug data for trigger" ],
   "PATTERN"                      => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "pattern against which to compare dbug data for trigger" ],
);

%shub_01_00686_def =
( NAME    => "SH_MD_DBUG_COMPARE",
  ADDRESS => 0x0000000100020110,
  NOTE    => "md debug compare pattern and mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00686_flds
);


##########################################################################
#                                                                        #
#   SH_X_MOD_DBUG_SEL                                                    #
#                                                                        #
##########################################################################

%shub_01_00687_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  58,   6, 0xFC00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQR_SEL"                      => [   1,  52,   6, 0x03F0000000000000, 0x00, 1, 0x0000000000000000, "dqctl select" ],
   "DQL_SEL"                      => [   2,  46,   6, 0x000FC00000000000, 0x00, 1, 0x0000000000000000, "dqctr select" ],
   "ATR_SEL"                      => [   3,  35,  11, 0x00003FF800000000, 0x00, 1, 0x0000000000000000, "aintr select" ],
   "ATL_SEL"                      => [   4,  24,  11, 0x00000007FF000000, 0x00, 1, 0x0000000000000000, "aintl select" ],
   "ARB_SEL"                      => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "arbque select" ],
   "WBQ_SEL"                      => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "wbqtg select" ],
   "TAG_SEL"                      => [   7,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "tagmgr select" ],
);

%shub_01_00687_def =
( NAME    => "SH_X_MOD_DBUG_SEL",
  ADDRESS => 0x0000000100020118,
  NOTE    => "MD acx debug select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00687_flds
);


##########################################################################
#                                                                        #
#   SH_X_DBUG_SEL                                                        #
#                                                                        #
##########################################################################

%shub_01_00688_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DBG_SEL"                      => [   1,   0,  24, 0x0000000000FFFFFF, 0x00, 1, 0x0000000000000000, "debug select" ],
);

%shub_01_00688_def =
( NAME    => "SH_X_DBUG_SEL",
  ADDRESS => 0x0000000100020120,
  NOTE    => "MD acx debug select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00688_flds
);


##########################################################################
#                                                                        #
#   SH_X_LADDR_CMP                                                       #
#                                                                        #
##########################################################################

%shub_01_00689_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MASK_VAL"                     => [   1,  32,  28, 0x0FFFFFFF00000000, 0x00, 1, 0x0000000000000000, "Mask value" ],
   "RSVD1"                        => [   2,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CMP_VAL"                      => [   3,   0,  28, 0x000000000FFFFFFF, 0x00, 1, 0x0000000000000000, "Compare value" ],
);

%shub_01_00689_def =
( NAME    => "SH_X_LADDR_CMP",
  ADDRESS => 0x0000000100020128,
  NOTE    => "MD acx address compare",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00689_flds
);


##########################################################################
#                                                                        #
#   SH_X_RADDR_CMP                                                       #
#                                                                        #
##########################################################################

%shub_01_00690_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MASK_VAL"                     => [   1,  32,  28, 0x0FFFFFFF00000000, 0x00, 1, 0x0000000000000000, "Mask value" ],
   "RSVD1"                        => [   2,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CMP_VAL"                      => [   3,   0,  28, 0x000000000FFFFFFF, 0x00, 1, 0x0000000000000000, "Compare value" ],
);

%shub_01_00690_def =
( NAME    => "SH_X_RADDR_CMP",
  ADDRESS => 0x0000000100020130,
  NOTE    => "MD acx address compare",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00690_flds
);


##########################################################################
#                                                                        #
#   SH_X_TAG_CMP                                                         #
#                                                                        #
##########################################################################

%shub_01_00691_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  55,   9, 0xFF80000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SRC"                          => [   1,  41,  14, 0x007FFE0000000000, 0x00, 1, 0x0000000000000000, "Source compare value" ],
   "ADDR"                         => [   2,   8,  33, 0x000001FFFFFFFF00, 0x00, 1, 0x0000000000000000, "Address compare value" ],
   "CMD"                          => [   3,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Command compare value" ],
);

%shub_01_00691_def =
( NAME    => "SH_X_TAG_CMP",
  ADDRESS => 0x0000000100020138,
  NOTE    => "MD acx tagmgr compare",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00691_flds
);


##########################################################################
#                                                                        #
#   SH_X_TAG_MASK                                                        #
#                                                                        #
##########################################################################

%shub_01_00692_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  55,   9, 0xFF80000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SRC"                          => [   1,  41,  14, 0x007FFE0000000000, 0x00, 1, 0x0000000000000000, "Source compare value" ],
   "ADDR"                         => [   2,   8,  33, 0x000001FFFFFFFF00, 0x00, 1, 0x0000000000000000, "Address compare value" ],
   "CMD"                          => [   3,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Command compare value" ],
);

%shub_01_00692_def =
( NAME    => "SH_X_TAG_MASK",
  ADDRESS => 0x0000000100020140,
  NOTE    => "MD acx tagmgr mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00692_flds
);


##########################################################################
#                                                                        #
#   SH_Y_MOD_DBUG_SEL                                                    #
#                                                                        #
##########################################################################

%shub_01_00693_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  58,   6, 0xFC00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DQR_SEL"                      => [   1,  52,   6, 0x03F0000000000000, 0x00, 1, 0x0000000000000000, "dqctl select" ],
   "DQL_SEL"                      => [   2,  46,   6, 0x000FC00000000000, 0x00, 1, 0x0000000000000000, "dqctr select" ],
   "ATR_SEL"                      => [   3,  35,  11, 0x00003FF800000000, 0x00, 1, 0x0000000000000000, "aintr select" ],
   "ATL_SEL"                      => [   4,  24,  11, 0x00000007FF000000, 0x00, 1, 0x0000000000000000, "aintl select" ],
   "ARB_SEL"                      => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "arbque select" ],
   "WBQ_SEL"                      => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "wbqtg select" ],
   "TAG_SEL"                      => [   7,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "tagmgr select" ],
);

%shub_01_00693_def =
( NAME    => "SH_Y_MOD_DBUG_SEL",
  ADDRESS => 0x0000000100020148,
  NOTE    => "MD acy debug select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00693_flds
);


##########################################################################
#                                                                        #
#   SH_Y_DBUG_SEL                                                        #
#                                                                        #
##########################################################################

%shub_01_00694_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DBG_SEL"                      => [   1,   0,  24, 0x0000000000FFFFFF, 0x00, 1, 0x0000000000000000, "debug select" ],
);

%shub_01_00694_def =
( NAME    => "SH_Y_DBUG_SEL",
  ADDRESS => 0x0000000100020150,
  NOTE    => "MD acy debug select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00694_flds
);


##########################################################################
#                                                                        #
#   SH_Y_LADDR_CMP                                                       #
#                                                                        #
##########################################################################

%shub_01_00695_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MASK_VAL"                     => [   1,  32,  28, 0x0FFFFFFF00000000, 0x00, 1, 0x0000000000000000, "Mask value" ],
   "RSVD1"                        => [   2,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CMP_VAL"                      => [   3,   0,  28, 0x000000000FFFFFFF, 0x00, 1, 0x0000000000000000, "Compare value" ],
);

%shub_01_00695_def =
( NAME    => "SH_Y_LADDR_CMP",
  ADDRESS => 0x0000000100020158,
  NOTE    => "MD acy address compare",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00695_flds
);


##########################################################################
#                                                                        #
#   SH_Y_RADDR_CMP                                                       #
#                                                                        #
##########################################################################

%shub_01_00696_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MASK_VAL"                     => [   1,  32,  28, 0x0FFFFFFF00000000, 0x00, 1, 0x0000000000000000, "Mask value" ],
   "RSVD1"                        => [   2,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CMP_VAL"                      => [   3,   0,  28, 0x000000000FFFFFFF, 0x00, 1, 0x0000000000000000, "Compare value" ],
);

%shub_01_00696_def =
( NAME    => "SH_Y_RADDR_CMP",
  ADDRESS => 0x0000000100020160,
  NOTE    => "MD acy address compare",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00696_flds
);


##########################################################################
#                                                                        #
#   SH_Y_TAG_CMP                                                         #
#                                                                        #
##########################################################################

%shub_01_00697_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  55,   9, 0xFF80000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SRC"                          => [   1,  41,  14, 0x007FFE0000000000, 0x00, 1, 0x0000000000000000, "Source compare value" ],
   "ADDR"                         => [   2,   8,  33, 0x000001FFFFFFFF00, 0x00, 1, 0x0000000000000000, "Address compare value" ],
   "CMD"                          => [   3,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Command compare value" ],
);

%shub_01_00697_def =
( NAME    => "SH_Y_TAG_CMP",
  ADDRESS => 0x0000000100020168,
  NOTE    => "MD acy tagmgr compare",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00697_flds
);


##########################################################################
#                                                                        #
#   SH_Y_TAG_MASK                                                        #
#                                                                        #
##########################################################################

%shub_01_00698_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  55,   9, 0xFF80000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SRC"                          => [   1,  41,  14, 0x007FFE0000000000, 0x00, 1, 0x0000000000000000, "Source compare value" ],
   "ADDR"                         => [   2,   8,  33, 0x000001FFFFFFFF00, 0x00, 1, 0x0000000000000000, "Address compare value" ],
   "CMD"                          => [   3,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Command compare value" ],
);

%shub_01_00698_def =
( NAME    => "SH_Y_TAG_MASK",
  ADDRESS => 0x0000000100020170,
  NOTE    => "MD acy tagmgr mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00698_flds
);


##########################################################################
#                                                                        #
#   SH_MD_JNR_DBUG_DATA_CFG                                              #
#                                                                        #
##########################################################################

%shub_01_00699_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_SEL"                  => [   1,  28,   3, 0x0000000070000000, 0x00, 1, 0x0000000000000000, "selects which data package drives nibble7" ],
   "RSVD1"                        => [   2,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_SEL"                  => [   3,  24,   3, 0x0000000007000000, 0x00, 1, 0x0000000000000000, "selects which data package drives nibble6" ],
   "RSVD2"                        => [   4,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_SEL"                  => [   5,  20,   3, 0x0000000000700000, 0x00, 1, 0x0000000000000000, "selects which data package drives nibble5" ],
   "RSVD3"                        => [   6,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_SEL"                  => [   7,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "selects which data package drives nibble4" ],
   "RSVD4"                        => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_SEL"                  => [   9,  12,   3, 0x0000000000007000, 0x00, 1, 0x0000000000000000, "selects which data package drives nibble3" ],
   "RSVD5"                        => [  10,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_SEL"                  => [  11,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "selects which data package drives nibble2" ],
   "RSVD6"                        => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_SEL"                  => [  13,   4,   3, 0x0000000000000070, 0x00, 1, 0x0000000000000000, "selects which data package drives nibble1" ],
   "RSVD7"                        => [  14,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_SEL"                  => [  15,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "selects which data package drives nibble0" ],
);

%shub_01_00699_def =
( NAME    => "SH_MD_JNR_DBUG_DATA_CFG",
  ADDRESS => 0x0000000100020178,
  NOTE    => "configuration for md jnr debug data muxes",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00699_flds
);


##########################################################################
#                                                                        #
#   SH_MD_LAST_CREDIT                                                    #
#                                                                        #
##########################################################################

%shub_01_00700_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TO_LB"                        => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "capture of credits to pi" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_TO_XN"                     => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "capture of reply credits to xn" ],
   "RSVD2"                        => [   4,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RQ_TO_XN"                     => [   5,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "capture of request credits to xn" ],
   "RSVD3"                        => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_TO_PI"                     => [   7,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "capture of reply credits to pi" ],
   "RSVD4"                        => [   8,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RQ_TO_PI"                     => [   9,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "capture of request credits to pi" ],
);

%shub_01_00700_def =
( NAME    => "SH_MD_LAST_CREDIT",
  ADDRESS => 0x0000000100020180,
  NOTE    => "captures last credit values on reset",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00700_flds
);


##########################################################################
#                                                                        #
#   SH_MEM_CAPTURE_ADDR                                                  #
#                                                                        #
##########################################################################

%shub_01_00701_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  44,  20, 0xFFFFF00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CMD"                          => [   1,  36,   8, 0x00000FF000000000, 0x00, 1, 0x0000000000000000, "Command (i.e., SN2NET Message Code)" ],
   "ADDR"                         => [   2,   3,  33, 0x0000000FFFFFFFF8, 0x00, 1, 0x0000000000000000, "Address[35:3]" ],
);

%shub_01_00701_def =
( NAME    => "SH_MEM_CAPTURE_ADDR",
  ADDRESS => 0x0000000100020300,
  NOTE    => "Capture Address",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00701_flds
);


##########################################################################
#                                                                        #
#   SH_MEM_CAPTURE_MASK                                                  #
#                                                                        #
##########################################################################

%shub_01_00702_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  46,  18, 0xFFFFC00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_REMOTE"                => [   1,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "Analyze Messages from Remote (XN)" ],
   "ENABLE_LOCAL"                 => [   2,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "Analyze Messages from Local (PI)" ],
   "CMD"                          => [   3,  36,   8, 0x00000FF000000000, 0x00, 1, 0x0000000000000000, "SN2NET Command Code Mask" ],
   "ADDR"                         => [   4,   3,  33, 0x0000000FFFFFFFF8, 0x00, 1, 0x0000000000000000, "Address[35:3] Mask" ],
);

%shub_01_00702_def =
( NAME    => "SH_MEM_CAPTURE_MASK",
  ADDRESS => 0x0000000100020308,
  NOTE    => "Capture Mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00702_flds
);


##########################################################################
#                                                                        #
#   SH_MEM_CAPTURE_HDR                                                   #
#                                                                        #
##########################################################################

%shub_01_00703_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CNTR"                         => [   0,  58,   6, 0xFC00000000000000, 0x00, 1, 0x0000000000000000, "increments on every capture" ],
   "SRC"                          => [   1,  44,  14, 0x03FFF00000000000, 0x00, 1, 0x0000000000000000, "source node of reference" ],
   "CMD"                          => [   2,  36,   8, 0x00000FF000000000, 0x00, 1, 0x0000000000000000, "command of reference" ],
   "ADDR"                         => [   3,   3,  33, 0x0000000FFFFFFFF8, 0x00, 1, 0x0000000000000000, "upper bits of reference address" ],
);

%shub_01_00703_def =
( NAME    => "SH_MEM_CAPTURE_HDR",
  ADDRESS => 0x0000000100020310,
  NOTE    => "Address capture header register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00703_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_DIR_CONFIG                                            #
#                                                                        #
##########################################################################

%shub_01_00704_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EN_DIRPOIS"                   => [   1,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "enable local poisoning for dir table fall-through" ],
   "EN_DIRECC"                    => [   2,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "enable directory ecc correction" ],
   "SYS_SIZE"                     => [   3,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "system size code" ],
);

%shub_01_00704_def =
( NAME    => "SH_MD_DQLP_MMR_DIR_CONFIG",
  ADDRESS => 0x0000000100030000,
  NOTE    => "DQ directory config register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00704_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_DIR_PRESVEC0                                          #
#                                                                        #
##########################################################################

%shub_01_00705_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "node presence bits, 1=present" ],
);

%shub_01_00705_def =
( NAME    => "SH_MD_DQLP_MMR_DIR_PRESVEC0",
  ADDRESS => 0x0000000100030100,
  NOTE    => "node [63:0] presence bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00705_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_DIR_PRESVEC1                                          #
#                                                                        #
##########################################################################

%shub_01_00706_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "node presence bits, 1=present" ],
);

%shub_01_00706_def =
( NAME    => "SH_MD_DQLP_MMR_DIR_PRESVEC1",
  ADDRESS => 0x0000000100030110,
  NOTE    => "node [127:64] presence bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00706_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_DIR_PRESVEC2                                          #
#                                                                        #
##########################################################################

%shub_01_00707_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "node presence bits, 1=present" ],
);

%shub_01_00707_def =
( NAME    => "SH_MD_DQLP_MMR_DIR_PRESVEC2",
  ADDRESS => 0x0000000100030120,
  NOTE    => "node [191:128] presence bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00707_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_DIR_PRESVEC3                                          #
#                                                                        #
##########################################################################

%shub_01_00708_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "node presence bits, 1=present" ],
);

%shub_01_00708_def =
( NAME    => "SH_MD_DQLP_MMR_DIR_PRESVEC3",
  ADDRESS => 0x0000000100030130,
  NOTE    => "node [255:192] presence bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00708_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_DIR_LOCVEC0                                           #
#                                                                        #
##########################################################################

%shub_01_00709_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%shub_01_00709_def =
( NAME    => "SH_MD_DQLP_MMR_DIR_LOCVEC0",
  ADDRESS => 0x0000000100030200,
  NOTE    => "local vector for acc=0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00709_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_DIR_LOCVEC1                                           #
#                                                                        #
##########################################################################

%shub_01_00710_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%shub_01_00710_def =
( NAME    => "SH_MD_DQLP_MMR_DIR_LOCVEC1",
  ADDRESS => 0x0000000100030210,
  NOTE    => "local vector for acc=1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00710_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_DIR_LOCVEC2                                           #
#                                                                        #
##########################################################################

%shub_01_00711_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%shub_01_00711_def =
( NAME    => "SH_MD_DQLP_MMR_DIR_LOCVEC2",
  ADDRESS => 0x0000000100030220,
  NOTE    => "local vector for acc=2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00711_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_DIR_LOCVEC3                                           #
#                                                                        #
##########################################################################

%shub_01_00712_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%shub_01_00712_def =
( NAME    => "SH_MD_DQLP_MMR_DIR_LOCVEC3",
  ADDRESS => 0x0000000100030230,
  NOTE    => "local vector for acc=3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00712_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_DIR_LOCVEC4                                           #
#                                                                        #
##########################################################################

%shub_01_00713_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%shub_01_00713_def =
( NAME    => "SH_MD_DQLP_MMR_DIR_LOCVEC4",
  ADDRESS => 0x0000000100030240,
  NOTE    => "local vector for acc=4",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00713_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_DIR_LOCVEC5                                           #
#                                                                        #
##########################################################################

%shub_01_00714_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%shub_01_00714_def =
( NAME    => "SH_MD_DQLP_MMR_DIR_LOCVEC5",
  ADDRESS => 0x0000000100030250,
  NOTE    => "local vector for acc=5",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00714_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_DIR_LOCVEC6                                           #
#                                                                        #
##########################################################################

%shub_01_00715_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%shub_01_00715_def =
( NAME    => "SH_MD_DQLP_MMR_DIR_LOCVEC6",
  ADDRESS => 0x0000000100030260,
  NOTE    => "local vector for acc=6",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00715_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_DIR_LOCVEC7                                           #
#                                                                        #
##########################################################################

%shub_01_00716_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%shub_01_00716_def =
( NAME    => "SH_MD_DQLP_MMR_DIR_LOCVEC7",
  ADDRESS => 0x0000000100030270,
  NOTE    => "local vector for acc=7",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00716_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_DIR_PRIVEC0                                           #
#                                                                        #
##########################################################################

%shub_01_00717_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%shub_01_00717_def =
( NAME    => "SH_MD_DQLP_MMR_DIR_PRIVEC0",
  ADDRESS => 0x0000000100030300,
  NOTE    => "privilege vector for acc=0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00717_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_DIR_PRIVEC1                                           #
#                                                                        #
##########################################################################

%shub_01_00718_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%shub_01_00718_def =
( NAME    => "SH_MD_DQLP_MMR_DIR_PRIVEC1",
  ADDRESS => 0x0000000100030310,
  NOTE    => "privilege vector for acc=1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00718_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_DIR_PRIVEC2                                           #
#                                                                        #
##########################################################################

%shub_01_00719_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%shub_01_00719_def =
( NAME    => "SH_MD_DQLP_MMR_DIR_PRIVEC2",
  ADDRESS => 0x0000000100030320,
  NOTE    => "privilege vector for acc=2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00719_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_DIR_PRIVEC3                                           #
#                                                                        #
##########################################################################

%shub_01_00720_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%shub_01_00720_def =
( NAME    => "SH_MD_DQLP_MMR_DIR_PRIVEC3",
  ADDRESS => 0x0000000100030330,
  NOTE    => "privilege vector for acc=3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00720_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_DIR_PRIVEC4                                           #
#                                                                        #
##########################################################################

%shub_01_00721_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%shub_01_00721_def =
( NAME    => "SH_MD_DQLP_MMR_DIR_PRIVEC4",
  ADDRESS => 0x0000000100030340,
  NOTE    => "privilege vector for acc=4",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00721_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_DIR_PRIVEC5                                           #
#                                                                        #
##########################################################################

%shub_01_00722_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%shub_01_00722_def =
( NAME    => "SH_MD_DQLP_MMR_DIR_PRIVEC5",
  ADDRESS => 0x0000000100030350,
  NOTE    => "privilege vector for acc=5",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00722_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_DIR_PRIVEC6                                           #
#                                                                        #
##########################################################################

%shub_01_00723_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%shub_01_00723_def =
( NAME    => "SH_MD_DQLP_MMR_DIR_PRIVEC6",
  ADDRESS => 0x0000000100030360,
  NOTE    => "privilege vector for acc=6",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00723_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_DIR_PRIVEC7                                           #
#                                                                        #
##########################################################################

%shub_01_00724_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%shub_01_00724_def =
( NAME    => "SH_MD_DQLP_MMR_DIR_PRIVEC7",
  ADDRESS => 0x0000000100030370,
  NOTE    => "privilege vector for acc=7",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00724_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_DIR_TIMER                                             #
#                                                                        #
##########################################################################

%shub_01_00725_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIMER_CUR"                    => [   1,  13,   9, 0x00000000003FE000, 0x00, 1, 0x0000000000000000, "value of current timer" ],
   "TIMER_EN"                     => [   2,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "timer enable" ],
   "TIMER_DIV"                    => [   3,   0,  12, 0x0000000000000FFF, 0x00, 1, 0x0000000000000000, "timer divide register" ],
);

%shub_01_00725_def =
( NAME    => "SH_MD_DQLP_MMR_DIR_TIMER",
  ADDRESS => 0x0000000100030400,
  NOTE    => "MD SXRO timer",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00725_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_PIOWD_DIR_ENTRY                                       #
#                                                                        #
##########################################################################

%shub_01_00726_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  58,   6, 0xFC00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ACC"                          => [   1,  55,   3, 0x0380000000000000, 0x00, 1, 0x0000000000000000, "directory access bits" ],
   "PRI"                          => [   2,  52,   3, 0x0070000000000000, 0x00, 1, 0x0000000000000000, "directory priority" ],
   "DIRB"                         => [   3,  26,  26, 0x000FFFFFFC000000, 0x00, 1, 0x0000000000000000, "directory entry B" ],
   "DIRA"                         => [   4,   0,  26, 0x0000000003FFFFFF, 0x00, 1, 0x0000000000000000, "directory entry A" ],
);

%shub_01_00726_def =
( NAME    => "SH_MD_DQLP_MMR_PIOWD_DIR_ENTRY",
  ADDRESS => 0x0000000100031000,
  NOTE    => "directory pio write data",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00726_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_PIOWD_DIR_ECC                                         #
#                                                                        #
##########################################################################

%shub_01_00727_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  14,  50, 0xFFFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECCB"                         => [   1,   7,   7, 0x0000000000003F80, 0x00, 1, 0x0000000000000000, "XOR bits for directory ECC group 2" ],
   "ECCA"                         => [   2,   0,   7, 0x000000000000007F, 0x00, 1, 0x0000000000000000, "XOR bits for directory ECC group 1" ],
);

%shub_01_00727_def =
( NAME    => "SH_MD_DQLP_MMR_PIOWD_DIR_ECC",
  ADDRESS => 0x0000000100031010,
  NOTE    => "directory ecc register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00727_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_XPIORD_XDIR_ENTRY                                     #
#                                                                        #
##########################################################################

%shub_01_00728_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNC"                          => [   1,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error" ],
   "COR"                          => [   2,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error" ],
   "ACC"                          => [   3,  55,   3, 0x0380000000000000, 0x00, 0, 0x0000000000000000, "directory access bits" ],
   "PRI"                          => [   4,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "directory priority" ],
   "DIRB"                         => [   5,  26,  26, 0x000FFFFFFC000000, 0x00, 0, 0x0000000000000000, "directory entry B" ],
   "DIRA"                         => [   6,   0,  26, 0x0000000003FFFFFF, 0x00, 0, 0x0000000000000000, "directory entry A" ],
);

%shub_01_00728_def =
( NAME    => "SH_MD_DQLP_MMR_XPIORD_XDIR_ENTRY",
  ADDRESS => 0x0000000100032000,
  NOTE    => "x directory pio read data",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00728_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_XPIORD_XDIR_ECC                                       #
#                                                                        #
##########################################################################

%shub_01_00729_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  14,  50, 0xFFFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECCB"                         => [   1,   7,   7, 0x0000000000003F80, 0x00, 0, 0x0000000000000000, "group 2 ecc" ],
   "ECCA"                         => [   2,   0,   7, 0x000000000000007F, 0x00, 0, 0x0000000000000000, "group 1 ecc" ],
);

%shub_01_00729_def =
( NAME    => "SH_MD_DQLP_MMR_XPIORD_XDIR_ECC",
  ADDRESS => 0x0000000100032010,
  NOTE    => "x directory ecc",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00729_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_YPIORD_YDIR_ENTRY                                     #
#                                                                        #
##########################################################################

%shub_01_00730_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNC"                          => [   1,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error" ],
   "COR"                          => [   2,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error" ],
   "ACC"                          => [   3,  55,   3, 0x0380000000000000, 0x00, 0, 0x0000000000000000, "directory access bits" ],
   "PRI"                          => [   4,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "directory priority" ],
   "DIRB"                         => [   5,  26,  26, 0x000FFFFFFC000000, 0x00, 0, 0x0000000000000000, "directory entry B" ],
   "DIRA"                         => [   6,   0,  26, 0x0000000003FFFFFF, 0x00, 0, 0x0000000000000000, "directory entry A" ],
);

%shub_01_00730_def =
( NAME    => "SH_MD_DQLP_MMR_YPIORD_YDIR_ENTRY",
  ADDRESS => 0x0000000100032800,
  NOTE    => "y directory pio read data",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00730_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_YPIORD_YDIR_ECC                                       #
#                                                                        #
##########################################################################

%shub_01_00731_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  14,  50, 0xFFFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECCB"                         => [   1,   7,   7, 0x0000000000003F80, 0x00, 0, 0x0000000000000000, "group 2 ecc" ],
   "ECCA"                         => [   2,   0,   7, 0x000000000000007F, 0x00, 0, 0x0000000000000000, "group 1 ecc" ],
);

%shub_01_00731_def =
( NAME    => "SH_MD_DQLP_MMR_YPIORD_YDIR_ECC",
  ADDRESS => 0x0000000100032810,
  NOTE    => "y directory ecc",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00731_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_XCERR1                                                #
#                                                                        #
##########################################################################

%shub_01_00732_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  39,  25, 0xFFFFFF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms uncorrectable ecc error capture" ],
   "MORE"                         => [   2,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one correctable ecc error in group 1" ],
   "VAL"                          => [   3,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error in group 1 bits" ],
   "GRP1"                         => [   4,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 1 bits" ],
);

%shub_01_00732_def =
( NAME    => "SH_MD_DQLP_MMR_XCERR1",
  ADDRESS => 0x0000000100033000,
  NOTE    => "correctable dir ecc group 1 error register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00732_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_XCERR2                                                #
#                                                                        #
##########################################################################

%shub_01_00733_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one correctable ecc error in group 2" ],
   "VAL"                          => [   2,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error in group 2 bits" ],
   "GRP2"                         => [   3,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 2 bits" ],
);

%shub_01_00733_def =
( NAME    => "SH_MD_DQLP_MMR_XCERR2",
  ADDRESS => 0x0000000100033010,
  NOTE    => "correctable dir ecc group 2 error register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00733_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_XUERR1                                                #
#                                                                        #
##########################################################################

%shub_01_00734_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  39,  25, 0xFFFFFF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms uncorrectable ecc error capture" ],
   "MORE"                         => [   2,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one uncorrectable ecc error in group 1" ],
   "VAL"                          => [   3,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error in group 1 bits" ],
   "GRP1"                         => [   4,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 1 bits" ],
);

%shub_01_00734_def =
( NAME    => "SH_MD_DQLP_MMR_XUERR1",
  ADDRESS => 0x0000000100033020,
  NOTE    => "uncorrectable dir ecc group 1 error register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00734_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_XUERR2                                                #
#                                                                        #
##########################################################################

%shub_01_00735_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one uncorrectable ecc error in group 2" ],
   "VAL"                          => [   2,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error in group 2 bits" ],
   "GRP2"                         => [   3,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 2 bits" ],
);

%shub_01_00735_def =
( NAME    => "SH_MD_DQLP_MMR_XUERR2",
  ADDRESS => 0x0000000100033030,
  NOTE    => "uncorrectable dir ecc group 2 error register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00735_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_XPERR                                                 #
#                                                                        #
##########################################################################

%shub_01_00736_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms error capture" ],
   "MORE"                         => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "more than one protocol error" ],
   "VAL"                          => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "protocol error info valid" ],
   "MYBIT"                        => [   4,  52,   8, 0x0FF0000000000000, 0x00, 0, 0x0000000000000000, "ptreq,timeq,timlast,timspec,onlyme,anytim,ptrii,srcii" ],
   "UNC"                          => [   5,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error" ],
   "COR"                          => [   6,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error" ],
   "PRIV"                         => [   7,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "access privilege bit" ],
   "PRIGE"                        => [   8,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "priority was greater-equal" ],
   "SRC"                          => [   9,  34,  14, 0x0000FFFC00000000, 0x00, 0, 0x0000000000000000, "source node of dir operation" ],
   "CMD"                          => [  10,  26,   8, 0x00000003FC000000, 0x00, 0, 0x0000000000000000, "incoming command" ],
   "DIR"                          => [  11,   0,  26, 0x0000000003FFFFFF, 0x00, 0, 0x0000000000000000, "directory entry" ],
);

%shub_01_00736_def =
( NAME    => "SH_MD_DQLP_MMR_XPERR",
  ADDRESS => 0x0000000100033040,
  NOTE    => "protocol error register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00736_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_YCERR1                                                #
#                                                                        #
##########################################################################

%shub_01_00737_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  39,  25, 0xFFFFFF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms uncorrectable ecc error capture" ],
   "MORE"                         => [   2,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one correctable ecc error in group 1" ],
   "VAL"                          => [   3,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error in group 1 bits" ],
   "GRP1"                         => [   4,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 1 bits" ],
);

%shub_01_00737_def =
( NAME    => "SH_MD_DQLP_MMR_YCERR1",
  ADDRESS => 0x0000000100033800,
  NOTE    => "correctable dir ecc group 1 error register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00737_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_YCERR2                                                #
#                                                                        #
##########################################################################

%shub_01_00738_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one correctable ecc error in group 2" ],
   "VAL"                          => [   2,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error in group 2 bits" ],
   "GRP2"                         => [   3,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 2 bits" ],
);

%shub_01_00738_def =
( NAME    => "SH_MD_DQLP_MMR_YCERR2",
  ADDRESS => 0x0000000100033810,
  NOTE    => "correctable dir ecc group 2 error register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00738_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_YUERR1                                                #
#                                                                        #
##########################################################################

%shub_01_00739_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  39,  25, 0xFFFFFF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms uncorrectable ecc error capture" ],
   "MORE"                         => [   2,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one uncorrectable ecc error in group 1" ],
   "VAL"                          => [   3,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error in group 1 bits" ],
   "GRP1"                         => [   4,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 1 bits" ],
);

%shub_01_00739_def =
( NAME    => "SH_MD_DQLP_MMR_YUERR1",
  ADDRESS => 0x0000000100033820,
  NOTE    => "uncorrectable dir ecc group 1 error register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00739_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_YUERR2                                                #
#                                                                        #
##########################################################################

%shub_01_00740_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one uncorrectable ecc error in group 2" ],
   "VAL"                          => [   2,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error in group 2 bits" ],
   "GRP2"                         => [   3,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 2 bits" ],
);

%shub_01_00740_def =
( NAME    => "SH_MD_DQLP_MMR_YUERR2",
  ADDRESS => 0x0000000100033830,
  NOTE    => "uncorrectable dir ecc group 2 error register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00740_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_YPERR                                                 #
#                                                                        #
##########################################################################

%shub_01_00741_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms error capture" ],
   "MORE"                         => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "more than one protocol error" ],
   "VAL"                          => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "protocol error info valid" ],
   "MYBIT"                        => [   4,  52,   8, 0x0FF0000000000000, 0x00, 0, 0x0000000000000000, "ptreq,timeq,timlast,timspec,onlyme,anytim,ptrii,srcii" ],
   "UNC"                          => [   5,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error" ],
   "COR"                          => [   6,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error" ],
   "PRIV"                         => [   7,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "access privilege bit" ],
   "PRIGE"                        => [   8,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "priority was greater-equal" ],
   "SRC"                          => [   9,  34,  14, 0x0000FFFC00000000, 0x00, 0, 0x0000000000000000, "source node of dir operation" ],
   "CMD"                          => [  10,  26,   8, 0x00000003FC000000, 0x00, 0, 0x0000000000000000, "incoming command" ],
   "DIR"                          => [  11,   0,  26, 0x0000000003FFFFFF, 0x00, 0, 0x0000000000000000, "directory entry" ],
);

%shub_01_00741_def =
( NAME    => "SH_MD_DQLP_MMR_YPERR",
  ADDRESS => 0x0000000100033840,
  NOTE    => "protocol error register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00741_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_DIR_CMDTRIG                                           #
#                                                                        #
##########################################################################

%shub_01_00742_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CMD3"                         => [   1,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "command trigger 3" ],
   "CMD2"                         => [   2,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "command trigger 2" ],
   "CMD1"                         => [   3,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "command trigger 1" ],
   "CMD0"                         => [   4,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "command trigger 0" ],
);

%shub_01_00742_def =
( NAME    => "SH_MD_DQLP_MMR_DIR_CMDTRIG",
  ADDRESS => 0x0000000100034000,
  NOTE    => "cmd triggers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00742_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_DIR_TBLTRIG                                           #
#                                                                        #
##########################################################################

%shub_01_00743_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MYBIT"                        => [   1,  34,   8, 0x000003FC00000000, 0x00, 1, 0x0000000000000000, "ptreq,timeq,timlast,timspec,onlyme,anytim,ptrii,srcii" ],
   "DIRST"                        => [   2,  25,   9, 0x00000003FE000000, 0x00, 1, 0x0000000000000000, "shrd,sxro,sub-state" ],
   "PRIGE"                        => [   3,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "priority greater-equal" ],
   "ACC"                          => [   4,  22,   2, 0x0000000000C00000, 0x00, 1, 0x0000000000000000, "uncorrectable error, privilege bit" ],
   "CMD"                          => [   5,  14,   8, 0x00000000003FC000, 0x00, 1, 0x0000000000000000, "incoming request" ],
   "SRC"                          => [   6,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "source of request" ],
);

%shub_01_00743_def =
( NAME    => "SH_MD_DQLP_MMR_DIR_TBLTRIG",
  ADDRESS => 0x0000000100034010,
  NOTE    => "dir table trigger",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00743_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_DIR_TBLMASK                                           #
#                                                                        #
##########################################################################

%shub_01_00744_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MYBIT"                        => [   1,  34,   8, 0x000003FC00000000, 0x00, 1, 0x0000000000000000, "ptreq,timeq,timlast,timspec,onlyme,anytim,ptrii,srcii" ],
   "DIRST"                        => [   2,  25,   9, 0x00000003FE000000, 0x00, 1, 0x0000000000000000, "shrd,sxro,sub-state" ],
   "PRIGE"                        => [   3,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "priority greater-equal" ],
   "ACC"                          => [   4,  22,   2, 0x0000000000C00000, 0x00, 1, 0x0000000000000000, "uncorrectable error, privilege bit" ],
   "CMD"                          => [   5,  14,   8, 0x00000000003FC000, 0x00, 1, 0x0000000000000000, "incoming request" ],
   "SRC"                          => [   6,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "source of request" ],
);

%shub_01_00744_def =
( NAME    => "SH_MD_DQLP_MMR_DIR_TBLMASK",
  ADDRESS => 0x0000000100034020,
  NOTE    => "dir table trigger mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00744_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_XBIST_H                                               #
#                                                                        #
##########################################################################

%shub_01_00745_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  43,  21, 0xFFFFF80000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms data miscompare capture" ],
   "ROT"                          => [   2,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   3,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "RSVD1"                        => [   4,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   5,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%shub_01_00745_def =
( NAME    => "SH_MD_DQLP_MMR_XBIST_H",
  ADDRESS => 0x0000000100038000,
  NOTE    => "rising edge bist/fill pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00745_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_XBIST_L                                               #
#                                                                        #
##########################################################################

%shub_01_00746_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ROT"                          => [   1,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "RSVD1"                        => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   4,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%shub_01_00746_def =
( NAME    => "SH_MD_DQLP_MMR_XBIST_L",
  ADDRESS => 0x0000000100038010,
  NOTE    => "falling edge bist/fill pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00746_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_XBIST_ERR_H                                           #
#                                                                        #
##########################################################################

%shub_01_00747_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "RSVD1"                        => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   4,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%shub_01_00747_def =
( NAME    => "SH_MD_DQLP_MMR_XBIST_ERR_H",
  ADDRESS => 0x0000000100038020,
  NOTE    => "rising edge bist error pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00747_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_XBIST_ERR_L                                           #
#                                                                        #
##########################################################################

%shub_01_00748_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "RSVD1"                        => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   4,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%shub_01_00748_def =
( NAME    => "SH_MD_DQLP_MMR_XBIST_ERR_L",
  ADDRESS => 0x0000000100038030,
  NOTE    => "falling edge bist error pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00748_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_YBIST_H                                               #
#                                                                        #
##########################################################################

%shub_01_00749_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  43,  21, 0xFFFFF80000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms data miscompare capture" ],
   "ROT"                          => [   2,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   3,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "RSVD1"                        => [   4,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   5,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%shub_01_00749_def =
( NAME    => "SH_MD_DQLP_MMR_YBIST_H",
  ADDRESS => 0x0000000100038800,
  NOTE    => "rising edge bist/fill pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00749_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_YBIST_L                                               #
#                                                                        #
##########################################################################

%shub_01_00750_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ROT"                          => [   1,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "RSVD1"                        => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   4,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%shub_01_00750_def =
( NAME    => "SH_MD_DQLP_MMR_YBIST_L",
  ADDRESS => 0x0000000100038810,
  NOTE    => "falling edge bist/fill pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00750_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_YBIST_ERR_H                                           #
#                                                                        #
##########################################################################

%shub_01_00751_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "RSVD1"                        => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   4,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%shub_01_00751_def =
( NAME    => "SH_MD_DQLP_MMR_YBIST_ERR_H",
  ADDRESS => 0x0000000100038820,
  NOTE    => "rising edge bist error pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00751_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLP_MMR_YBIST_ERR_L                                           #
#                                                                        #
##########################################################################

%shub_01_00752_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "RSVD1"                        => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   4,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%shub_01_00752_def =
( NAME    => "SH_MD_DQLP_MMR_YBIST_ERR_L",
  ADDRESS => 0x0000000100038830,
  NOTE    => "falling edge bist error pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00752_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLS_MMR_XBIST_H                                               #
#                                                                        #
##########################################################################

%shub_01_00753_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  43,  21, 0xFFFFF80000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms data miscompare capture" ],
   "ROT"                          => [   2,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   3,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "PAT"                          => [   4,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%shub_01_00753_def =
( NAME    => "SH_MD_DQLS_MMR_XBIST_H",
  ADDRESS => 0x0000000100048000,
  NOTE    => "rising edge bist/fill pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00753_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLS_MMR_XBIST_L                                               #
#                                                                        #
##########################################################################

%shub_01_00754_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ROT"                          => [   1,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "PAT"                          => [   3,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%shub_01_00754_def =
( NAME    => "SH_MD_DQLS_MMR_XBIST_L",
  ADDRESS => 0x0000000100048010,
  NOTE    => "falling edge bist/fill pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00754_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLS_MMR_XBIST_ERR_H                                           #
#                                                                        #
##########################################################################

%shub_01_00755_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "PAT"                          => [   3,   0,  40, 0x000000FFFFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%shub_01_00755_def =
( NAME    => "SH_MD_DQLS_MMR_XBIST_ERR_H",
  ADDRESS => 0x0000000100048020,
  NOTE    => "rising edge bist error pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00755_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLS_MMR_XBIST_ERR_L                                           #
#                                                                        #
##########################################################################

%shub_01_00756_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "PAT"                          => [   3,   0,  40, 0x000000FFFFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%shub_01_00756_def =
( NAME    => "SH_MD_DQLS_MMR_XBIST_ERR_L",
  ADDRESS => 0x0000000100048030,
  NOTE    => "falling edge bist error pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00756_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLS_MMR_YBIST_H                                               #
#                                                                        #
##########################################################################

%shub_01_00757_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  43,  21, 0xFFFFF80000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms data miscompare capture" ],
   "ROT"                          => [   2,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   3,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "PAT"                          => [   4,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%shub_01_00757_def =
( NAME    => "SH_MD_DQLS_MMR_YBIST_H",
  ADDRESS => 0x0000000100048800,
  NOTE    => "rising edge bist/fill pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00757_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLS_MMR_YBIST_L                                               #
#                                                                        #
##########################################################################

%shub_01_00758_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ROT"                          => [   1,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "PAT"                          => [   3,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%shub_01_00758_def =
( NAME    => "SH_MD_DQLS_MMR_YBIST_L",
  ADDRESS => 0x0000000100048810,
  NOTE    => "falling edge bist/fill pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00758_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLS_MMR_YBIST_ERR_H                                           #
#                                                                        #
##########################################################################

%shub_01_00759_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "PAT"                          => [   3,   0,  40, 0x000000FFFFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%shub_01_00759_def =
( NAME    => "SH_MD_DQLS_MMR_YBIST_ERR_H",
  ADDRESS => 0x0000000100048820,
  NOTE    => "rising edge bist error pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00759_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLS_MMR_YBIST_ERR_L                                           #
#                                                                        #
##########################################################################

%shub_01_00760_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "PAT"                          => [   3,   0,  40, 0x000000FFFFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%shub_01_00760_def =
( NAME    => "SH_MD_DQLS_MMR_YBIST_ERR_L",
  ADDRESS => 0x0000000100048830,
  NOTE    => "falling edge bist error pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00760_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLS_MMR_JNR_DEBUG                                             #
#                                                                        #
##########################################################################

%shub_01_00761_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   2,  62, 0xFFFFFFFFFFFFFFFC, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RW"                           => [   1,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "select 0=read 1=write side" ],
   "PX"                           => [   2,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "select 0=pi 1=xn side" ],
);

%shub_01_00761_def =
( NAME    => "SH_MD_DQLS_MMR_JNR_DEBUG",
  ADDRESS => 0x0000000100049000,
  NOTE    => "joiner/fct debug configuration",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00761_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQLS_MMR_XAMOPW_ERR                                            #
#                                                                        #
##########################################################################

%shub_01_00762_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "writing 1 arms ecc error capture" ],
   "RSVD1"                        => [   2,  26,   6, 0x00000000FC000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RUNC"                         => [   3,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc errror on read data" ],
   "RCOR"                         => [   4,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "correctable ecc errror on read data" ],
   "RSYN"                         => [   5,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "memory read data syndrome" ],
   "RSVD2"                        => [   6,  10,   6, 0x000000000000FC00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SUNC"                         => [   7,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "uncorrectable ecc errror on store data" ],
   "SCOR"                         => [   8,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "correctable ecc errror on store data" ],
   "SSYN"                         => [   9,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "store data syndrome" ],
);

%shub_01_00762_def =
( NAME    => "SH_MD_DQLS_MMR_XAMOPW_ERR",
  ADDRESS => 0x000000010004a000,
  NOTE    => "amo/partial rmw ecc error register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00762_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_DIR_CONFIG                                            #
#                                                                        #
##########################################################################

%shub_01_00763_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EN_DIRPOIS"                   => [   1,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "enable local poisoning for dir table fall-through" ],
   "EN_DIRECC"                    => [   2,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "enable directory ecc correction" ],
   "SYS_SIZE"                     => [   3,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "system size code" ],
);

%shub_01_00763_def =
( NAME    => "SH_MD_DQRP_MMR_DIR_CONFIG",
  ADDRESS => 0x0000000100050000,
  NOTE    => "DQ directory config register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00763_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_DIR_PRESVEC0                                          #
#                                                                        #
##########################################################################

%shub_01_00764_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "node presence bits, 1=present" ],
);

%shub_01_00764_def =
( NAME    => "SH_MD_DQRP_MMR_DIR_PRESVEC0",
  ADDRESS => 0x0000000100050100,
  NOTE    => "node [63:0] presence bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00764_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_DIR_PRESVEC1                                          #
#                                                                        #
##########################################################################

%shub_01_00765_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "node presence bits, 1=present" ],
);

%shub_01_00765_def =
( NAME    => "SH_MD_DQRP_MMR_DIR_PRESVEC1",
  ADDRESS => 0x0000000100050110,
  NOTE    => "node [127:64] presence bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00765_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_DIR_PRESVEC2                                          #
#                                                                        #
##########################################################################

%shub_01_00766_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "node presence bits, 1=present" ],
);

%shub_01_00766_def =
( NAME    => "SH_MD_DQRP_MMR_DIR_PRESVEC2",
  ADDRESS => 0x0000000100050120,
  NOTE    => "node [191:128] presence bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00766_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_DIR_PRESVEC3                                          #
#                                                                        #
##########################################################################

%shub_01_00767_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "node presence bits, 1=present" ],
);

%shub_01_00767_def =
( NAME    => "SH_MD_DQRP_MMR_DIR_PRESVEC3",
  ADDRESS => 0x0000000100050130,
  NOTE    => "node [255:192] presence bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00767_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_DIR_LOCVEC0                                           #
#                                                                        #
##########################################################################

%shub_01_00768_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%shub_01_00768_def =
( NAME    => "SH_MD_DQRP_MMR_DIR_LOCVEC0",
  ADDRESS => 0x0000000100050200,
  NOTE    => "local vector for acc=0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00768_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_DIR_LOCVEC1                                           #
#                                                                        #
##########################################################################

%shub_01_00769_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%shub_01_00769_def =
( NAME    => "SH_MD_DQRP_MMR_DIR_LOCVEC1",
  ADDRESS => 0x0000000100050210,
  NOTE    => "local vector for acc=1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00769_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_DIR_LOCVEC2                                           #
#                                                                        #
##########################################################################

%shub_01_00770_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%shub_01_00770_def =
( NAME    => "SH_MD_DQRP_MMR_DIR_LOCVEC2",
  ADDRESS => 0x0000000100050220,
  NOTE    => "local vector for acc=2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00770_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_DIR_LOCVEC3                                           #
#                                                                        #
##########################################################################

%shub_01_00771_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%shub_01_00771_def =
( NAME    => "SH_MD_DQRP_MMR_DIR_LOCVEC3",
  ADDRESS => 0x0000000100050230,
  NOTE    => "local vector for acc=3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00771_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_DIR_LOCVEC4                                           #
#                                                                        #
##########################################################################

%shub_01_00772_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%shub_01_00772_def =
( NAME    => "SH_MD_DQRP_MMR_DIR_LOCVEC4",
  ADDRESS => 0x0000000100050240,
  NOTE    => "local vector for acc=4",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00772_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_DIR_LOCVEC5                                           #
#                                                                        #
##########################################################################

%shub_01_00773_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%shub_01_00773_def =
( NAME    => "SH_MD_DQRP_MMR_DIR_LOCVEC5",
  ADDRESS => 0x0000000100050250,
  NOTE    => "local vector for acc=5",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00773_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_DIR_LOCVEC6                                           #
#                                                                        #
##########################################################################

%shub_01_00774_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%shub_01_00774_def =
( NAME    => "SH_MD_DQRP_MMR_DIR_LOCVEC6",
  ADDRESS => 0x0000000100050260,
  NOTE    => "local vector for acc=6",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00774_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_DIR_LOCVEC7                                           #
#                                                                        #
##########################################################################

%shub_01_00775_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VEC"                          => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "1 node is local" ],
);

%shub_01_00775_def =
( NAME    => "SH_MD_DQRP_MMR_DIR_LOCVEC7",
  ADDRESS => 0x0000000100050270,
  NOTE    => "local vector for acc=7",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00775_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_DIR_PRIVEC0                                           #
#                                                                        #
##########################################################################

%shub_01_00776_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%shub_01_00776_def =
( NAME    => "SH_MD_DQRP_MMR_DIR_PRIVEC0",
  ADDRESS => 0x0000000100050300,
  NOTE    => "privilege vector for acc=0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00776_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_DIR_PRIVEC1                                           #
#                                                                        #
##########################################################################

%shub_01_00777_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%shub_01_00777_def =
( NAME    => "SH_MD_DQRP_MMR_DIR_PRIVEC1",
  ADDRESS => 0x0000000100050310,
  NOTE    => "privilege vector for acc=1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00777_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_DIR_PRIVEC2                                           #
#                                                                        #
##########################################################################

%shub_01_00778_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%shub_01_00778_def =
( NAME    => "SH_MD_DQRP_MMR_DIR_PRIVEC2",
  ADDRESS => 0x0000000100050320,
  NOTE    => "privilege vector for acc=2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00778_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_DIR_PRIVEC3                                           #
#                                                                        #
##########################################################################

%shub_01_00779_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%shub_01_00779_def =
( NAME    => "SH_MD_DQRP_MMR_DIR_PRIVEC3",
  ADDRESS => 0x0000000100050330,
  NOTE    => "privilege vector for acc=3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00779_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_DIR_PRIVEC4                                           #
#                                                                        #
##########################################################################

%shub_01_00780_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%shub_01_00780_def =
( NAME    => "SH_MD_DQRP_MMR_DIR_PRIVEC4",
  ADDRESS => 0x0000000100050340,
  NOTE    => "privilege vector for acc=4",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00780_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_DIR_PRIVEC5                                           #
#                                                                        #
##########################################################################

%shub_01_00781_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%shub_01_00781_def =
( NAME    => "SH_MD_DQRP_MMR_DIR_PRIVEC5",
  ADDRESS => 0x0000000100050350,
  NOTE    => "privilege vector for acc=5",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00781_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_DIR_PRIVEC6                                           #
#                                                                        #
##########################################################################

%shub_01_00782_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%shub_01_00782_def =
( NAME    => "SH_MD_DQRP_MMR_DIR_PRIVEC6",
  ADDRESS => 0x0000000100050360,
  NOTE    => "privilege vector for acc=6",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00782_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_DIR_PRIVEC7                                           #
#                                                                        #
##########################################################################

%shub_01_00783_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OUT"                          => [   1,  14,  14, 0x000000000FFFC000, 0x00, 1, 0x0000000000000000, "out of partition privileges, locvec bit=0" ],
   "IN"                           => [   2,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "in partition privileges, locvec bit=1" ],
);

%shub_01_00783_def =
( NAME    => "SH_MD_DQRP_MMR_DIR_PRIVEC7",
  ADDRESS => 0x0000000100050370,
  NOTE    => "privilege vector for acc=7",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00783_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_DIR_TIMER                                             #
#                                                                        #
##########################################################################

%shub_01_00784_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIMER_CUR"                    => [   1,  13,   9, 0x00000000003FE000, 0x00, 1, 0x0000000000000000, "value of current timer" ],
   "TIMER_EN"                     => [   2,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "timer enable" ],
   "TIMER_DIV"                    => [   3,   0,  12, 0x0000000000000FFF, 0x00, 1, 0x0000000000000000, "timer divide register" ],
);

%shub_01_00784_def =
( NAME    => "SH_MD_DQRP_MMR_DIR_TIMER",
  ADDRESS => 0x0000000100050400,
  NOTE    => "MD SXRO timer",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00784_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_PIOWD_DIR_ENTRY                                       #
#                                                                        #
##########################################################################

%shub_01_00785_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  58,   6, 0xFC00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ACC"                          => [   1,  55,   3, 0x0380000000000000, 0x00, 1, 0x0000000000000000, "directory access bits" ],
   "PRI"                          => [   2,  52,   3, 0x0070000000000000, 0x00, 1, 0x0000000000000000, "directory priority" ],
   "DIRB"                         => [   3,  26,  26, 0x000FFFFFFC000000, 0x00, 1, 0x0000000000000000, "directory entry B" ],
   "DIRA"                         => [   4,   0,  26, 0x0000000003FFFFFF, 0x00, 1, 0x0000000000000000, "directory entry A" ],
);

%shub_01_00785_def =
( NAME    => "SH_MD_DQRP_MMR_PIOWD_DIR_ENTRY",
  ADDRESS => 0x0000000100051000,
  NOTE    => "directory pio write data",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00785_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_PIOWD_DIR_ECC                                         #
#                                                                        #
##########################################################################

%shub_01_00786_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  14,  50, 0xFFFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECCB"                         => [   1,   7,   7, 0x0000000000003F80, 0x00, 1, 0x0000000000000000, "XOR bits for directory ECC group 2" ],
   "ECCA"                         => [   2,   0,   7, 0x000000000000007F, 0x00, 1, 0x0000000000000000, "XOR bits for directory ECC group 1" ],
);

%shub_01_00786_def =
( NAME    => "SH_MD_DQRP_MMR_PIOWD_DIR_ECC",
  ADDRESS => 0x0000000100051010,
  NOTE    => "directory ecc register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00786_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_XPIORD_XDIR_ENTRY                                     #
#                                                                        #
##########################################################################

%shub_01_00787_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNC"                          => [   1,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error" ],
   "COR"                          => [   2,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error" ],
   "ACC"                          => [   3,  55,   3, 0x0380000000000000, 0x00, 0, 0x0000000000000000, "directory access bits" ],
   "PRI"                          => [   4,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "directory priority" ],
   "DIRB"                         => [   5,  26,  26, 0x000FFFFFFC000000, 0x00, 0, 0x0000000000000000, "directory entry B" ],
   "DIRA"                         => [   6,   0,  26, 0x0000000003FFFFFF, 0x00, 0, 0x0000000000000000, "directory entry A" ],
);

%shub_01_00787_def =
( NAME    => "SH_MD_DQRP_MMR_XPIORD_XDIR_ENTRY",
  ADDRESS => 0x0000000100052000,
  NOTE    => "x directory pio read data",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00787_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_XPIORD_XDIR_ECC                                       #
#                                                                        #
##########################################################################

%shub_01_00788_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  14,  50, 0xFFFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECCB"                         => [   1,   7,   7, 0x0000000000003F80, 0x00, 0, 0x0000000000000000, "group 2 ecc" ],
   "ECCA"                         => [   2,   0,   7, 0x000000000000007F, 0x00, 0, 0x0000000000000000, "group 1 ecc" ],
);

%shub_01_00788_def =
( NAME    => "SH_MD_DQRP_MMR_XPIORD_XDIR_ECC",
  ADDRESS => 0x0000000100052010,
  NOTE    => "x directory ecc",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00788_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_YPIORD_YDIR_ENTRY                                     #
#                                                                        #
##########################################################################

%shub_01_00789_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNC"                          => [   1,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error" ],
   "COR"                          => [   2,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error" ],
   "ACC"                          => [   3,  55,   3, 0x0380000000000000, 0x00, 0, 0x0000000000000000, "directory access bits" ],
   "PRI"                          => [   4,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "directory priority" ],
   "DIRB"                         => [   5,  26,  26, 0x000FFFFFFC000000, 0x00, 0, 0x0000000000000000, "directory entry B" ],
   "DIRA"                         => [   6,   0,  26, 0x0000000003FFFFFF, 0x00, 0, 0x0000000000000000, "directory entry A" ],
);

%shub_01_00789_def =
( NAME    => "SH_MD_DQRP_MMR_YPIORD_YDIR_ENTRY",
  ADDRESS => 0x0000000100052800,
  NOTE    => "y directory pio read data",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00789_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_YPIORD_YDIR_ECC                                       #
#                                                                        #
##########################################################################

%shub_01_00790_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  14,  50, 0xFFFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECCB"                         => [   1,   7,   7, 0x0000000000003F80, 0x00, 0, 0x0000000000000000, "group 2 ecc" ],
   "ECCA"                         => [   2,   0,   7, 0x000000000000007F, 0x00, 0, 0x0000000000000000, "group 1 ecc" ],
);

%shub_01_00790_def =
( NAME    => "SH_MD_DQRP_MMR_YPIORD_YDIR_ECC",
  ADDRESS => 0x0000000100052810,
  NOTE    => "y directory ecc",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00790_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_XCERR1                                                #
#                                                                        #
##########################################################################

%shub_01_00791_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  39,  25, 0xFFFFFF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms uncorrectable ecc error capture" ],
   "MORE"                         => [   2,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one correctable ecc error in group 1" ],
   "VAL"                          => [   3,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error in group 1 bits" ],
   "GRP1"                         => [   4,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 1 bits" ],
);

%shub_01_00791_def =
( NAME    => "SH_MD_DQRP_MMR_XCERR1",
  ADDRESS => 0x0000000100053000,
  NOTE    => "correctable dir ecc group 1 error register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00791_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_XCERR2                                                #
#                                                                        #
##########################################################################

%shub_01_00792_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one correctable ecc error in group 2" ],
   "VAL"                          => [   2,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error in group 2 bits" ],
   "GRP2"                         => [   3,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 2 bits" ],
);

%shub_01_00792_def =
( NAME    => "SH_MD_DQRP_MMR_XCERR2",
  ADDRESS => 0x0000000100053010,
  NOTE    => "correctable dir ecc group 2 error register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00792_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_XUERR1                                                #
#                                                                        #
##########################################################################

%shub_01_00793_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  39,  25, 0xFFFFFF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms uncorrectable ecc error capture" ],
   "MORE"                         => [   2,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one uncorrectable ecc error in group 1" ],
   "VAL"                          => [   3,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error in group 1 bits" ],
   "GRP1"                         => [   4,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 1 bits" ],
);

%shub_01_00793_def =
( NAME    => "SH_MD_DQRP_MMR_XUERR1",
  ADDRESS => 0x0000000100053020,
  NOTE    => "uncorrectable dir ecc group 1 error register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00793_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_XUERR2                                                #
#                                                                        #
##########################################################################

%shub_01_00794_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one uncorrectable ecc error in group 2" ],
   "VAL"                          => [   2,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error in group 2 bits" ],
   "GRP2"                         => [   3,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 2 bits" ],
);

%shub_01_00794_def =
( NAME    => "SH_MD_DQRP_MMR_XUERR2",
  ADDRESS => 0x0000000100053030,
  NOTE    => "uncorrectable dir ecc group 2 error register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00794_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_XPERR                                                 #
#                                                                        #
##########################################################################

%shub_01_00795_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms error capture" ],
   "MORE"                         => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "more than one protocol error" ],
   "VAL"                          => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "protocol error info valid" ],
   "MYBIT"                        => [   4,  52,   8, 0x0FF0000000000000, 0x00, 0, 0x0000000000000000, "ptreq,timeq,timlast,timspec,onlyme,anytim,ptrii,srcii" ],
   "UNC"                          => [   5,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error" ],
   "COR"                          => [   6,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error" ],
   "PRIV"                         => [   7,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "access privilege bit" ],
   "PRIGE"                        => [   8,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "priority was greater-equal" ],
   "SRC"                          => [   9,  34,  14, 0x0000FFFC00000000, 0x00, 0, 0x0000000000000000, "source node of dir operation" ],
   "CMD"                          => [  10,  26,   8, 0x00000003FC000000, 0x00, 0, 0x0000000000000000, "incoming command" ],
   "DIR"                          => [  11,   0,  26, 0x0000000003FFFFFF, 0x00, 0, 0x0000000000000000, "directory entry" ],
);

%shub_01_00795_def =
( NAME    => "SH_MD_DQRP_MMR_XPERR",
  ADDRESS => 0x0000000100053040,
  NOTE    => "protocol error register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00795_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_YCERR1                                                #
#                                                                        #
##########################################################################

%shub_01_00796_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  39,  25, 0xFFFFFF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms uncorrectable ecc error capture" ],
   "MORE"                         => [   2,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one correctable ecc error in group 1" ],
   "VAL"                          => [   3,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error in group 1 bits" ],
   "GRP1"                         => [   4,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 1 bits" ],
);

%shub_01_00796_def =
( NAME    => "SH_MD_DQRP_MMR_YCERR1",
  ADDRESS => 0x0000000100053800,
  NOTE    => "correctable dir ecc group 1 error register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00796_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_YCERR2                                                #
#                                                                        #
##########################################################################

%shub_01_00797_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one correctable ecc error in group 2" ],
   "VAL"                          => [   2,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error in group 2 bits" ],
   "GRP2"                         => [   3,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 2 bits" ],
);

%shub_01_00797_def =
( NAME    => "SH_MD_DQRP_MMR_YCERR2",
  ADDRESS => 0x0000000100053810,
  NOTE    => "correctable dir ecc group 2 error register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00797_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_YUERR1                                                #
#                                                                        #
##########################################################################

%shub_01_00798_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  39,  25, 0xFFFFFF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms uncorrectable ecc error capture" ],
   "MORE"                         => [   2,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one uncorrectable ecc error in group 1" ],
   "VAL"                          => [   3,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error in group 1 bits" ],
   "GRP1"                         => [   4,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 1 bits" ],
);

%shub_01_00798_def =
( NAME    => "SH_MD_DQRP_MMR_YUERR1",
  ADDRESS => 0x0000000100053820,
  NOTE    => "uncorrectable dir ecc group 1 error register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00798_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_YUERR2                                                #
#                                                                        #
##########################################################################

%shub_01_00799_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "more than one uncorrectable ecc error in group 2" ],
   "VAL"                          => [   2,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error in group 2 bits" ],
   "GRP2"                         => [   3,   0,  36, 0x0000000FFFFFFFFF, 0x00, 0, 0x0000000000000000, "ecc group 2 bits" ],
);

%shub_01_00799_def =
( NAME    => "SH_MD_DQRP_MMR_YUERR2",
  ADDRESS => 0x0000000100053830,
  NOTE    => "uncorrectable dir ecc group 2 error register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00799_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_YPERR                                                 #
#                                                                        #
##########################################################################

%shub_01_00800_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms error capture" ],
   "MORE"                         => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "more than one protocol error" ],
   "VAL"                          => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "protocol error info valid" ],
   "MYBIT"                        => [   4,  52,   8, 0x0FF0000000000000, 0x00, 0, 0x0000000000000000, "ptreq,timeq,timlast,timspec,onlyme,anytim,ptrii,srcii" ],
   "UNC"                          => [   5,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc error" ],
   "COR"                          => [   6,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "correctable ecc error" ],
   "PRIV"                         => [   7,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "access privilege bit" ],
   "PRIGE"                        => [   8,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "priority was greater-equal" ],
   "SRC"                          => [   9,  34,  14, 0x0000FFFC00000000, 0x00, 0, 0x0000000000000000, "source node of dir operation" ],
   "CMD"                          => [  10,  26,   8, 0x00000003FC000000, 0x00, 0, 0x0000000000000000, "incoming command" ],
   "DIR"                          => [  11,   0,  26, 0x0000000003FFFFFF, 0x00, 0, 0x0000000000000000, "directory entry" ],
);

%shub_01_00800_def =
( NAME    => "SH_MD_DQRP_MMR_YPERR",
  ADDRESS => 0x0000000100053840,
  NOTE    => "protocol error register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00800_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_DIR_CMDTRIG                                           #
#                                                                        #
##########################################################################

%shub_01_00801_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CMD3"                         => [   1,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "command trigger 3" ],
   "CMD2"                         => [   2,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "command trigger 2" ],
   "CMD1"                         => [   3,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "command trigger 1" ],
   "CMD0"                         => [   4,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "command trigger 0" ],
);

%shub_01_00801_def =
( NAME    => "SH_MD_DQRP_MMR_DIR_CMDTRIG",
  ADDRESS => 0x0000000100054000,
  NOTE    => "cmd triggers",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00801_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_DIR_TBLTRIG                                           #
#                                                                        #
##########################################################################

%shub_01_00802_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MYBIT"                        => [   1,  34,   8, 0x000003FC00000000, 0x00, 1, 0x0000000000000000, "ptreq,timeq,timlast,timspec,onlyme,anytim,ptrii,srcii" ],
   "DIRST"                        => [   2,  25,   9, 0x00000003FE000000, 0x00, 1, 0x0000000000000000, "shrd,sxro,sub-state" ],
   "PRIGE"                        => [   3,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "priority greater-equal" ],
   "ACC"                          => [   4,  22,   2, 0x0000000000C00000, 0x00, 1, 0x0000000000000000, "uncorrectable error, privilege bit" ],
   "CMD"                          => [   5,  14,   8, 0x00000000003FC000, 0x00, 1, 0x0000000000000000, "incoming request" ],
   "SRC"                          => [   6,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "source of request" ],
);

%shub_01_00802_def =
( NAME    => "SH_MD_DQRP_MMR_DIR_TBLTRIG",
  ADDRESS => 0x0000000100054010,
  NOTE    => "dir table trigger",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00802_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_DIR_TBLMASK                                           #
#                                                                        #
##########################################################################

%shub_01_00803_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MYBIT"                        => [   1,  34,   8, 0x000003FC00000000, 0x00, 1, 0x0000000000000000, "ptreq,timeq,timlast,timspec,onlyme,anytim,ptrii,srcii" ],
   "DIRST"                        => [   2,  25,   9, 0x00000003FE000000, 0x00, 1, 0x0000000000000000, "shrd,sxro,sub-state" ],
   "PRIGE"                        => [   3,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "priority greater-equal" ],
   "ACC"                          => [   4,  22,   2, 0x0000000000C00000, 0x00, 1, 0x0000000000000000, "uncorrectable error, privilege bit" ],
   "CMD"                          => [   5,  14,   8, 0x00000000003FC000, 0x00, 1, 0x0000000000000000, "incoming request" ],
   "SRC"                          => [   6,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "source of request" ],
);

%shub_01_00803_def =
( NAME    => "SH_MD_DQRP_MMR_DIR_TBLMASK",
  ADDRESS => 0x0000000100054020,
  NOTE    => "dir table trigger mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00803_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_XBIST_H                                               #
#                                                                        #
##########################################################################

%shub_01_00804_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  43,  21, 0xFFFFF80000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms data miscompare capture" ],
   "ROT"                          => [   2,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   3,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "RSVD1"                        => [   4,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   5,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%shub_01_00804_def =
( NAME    => "SH_MD_DQRP_MMR_XBIST_H",
  ADDRESS => 0x0000000100058000,
  NOTE    => "rising edge bist/fill pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00804_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_XBIST_L                                               #
#                                                                        #
##########################################################################

%shub_01_00805_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ROT"                          => [   1,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "RSVD1"                        => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   4,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%shub_01_00805_def =
( NAME    => "SH_MD_DQRP_MMR_XBIST_L",
  ADDRESS => 0x0000000100058010,
  NOTE    => "falling edge bist/fill pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00805_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_XBIST_ERR_H                                           #
#                                                                        #
##########################################################################

%shub_01_00806_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "RSVD1"                        => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   4,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%shub_01_00806_def =
( NAME    => "SH_MD_DQRP_MMR_XBIST_ERR_H",
  ADDRESS => 0x0000000100058020,
  NOTE    => "rising edge bist error pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00806_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_XBIST_ERR_L                                           #
#                                                                        #
##########################################################################

%shub_01_00807_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "RSVD1"                        => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   4,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%shub_01_00807_def =
( NAME    => "SH_MD_DQRP_MMR_XBIST_ERR_L",
  ADDRESS => 0x0000000100058030,
  NOTE    => "falling edge bist error pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00807_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_YBIST_H                                               #
#                                                                        #
##########################################################################

%shub_01_00808_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  43,  21, 0xFFFFF80000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms data miscompare capture" ],
   "ROT"                          => [   2,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   3,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "RSVD1"                        => [   4,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   5,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%shub_01_00808_def =
( NAME    => "SH_MD_DQRP_MMR_YBIST_H",
  ADDRESS => 0x0000000100058800,
  NOTE    => "rising edge bist/fill pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00808_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_YBIST_L                                               #
#                                                                        #
##########################################################################

%shub_01_00809_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ROT"                          => [   1,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "RSVD1"                        => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   4,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%shub_01_00809_def =
( NAME    => "SH_MD_DQRP_MMR_YBIST_L",
  ADDRESS => 0x0000000100058810,
  NOTE    => "falling edge bist/fill pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00809_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_YBIST_ERR_H                                           #
#                                                                        #
##########################################################################

%shub_01_00810_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "RSVD1"                        => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   4,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%shub_01_00810_def =
( NAME    => "SH_MD_DQRP_MMR_YBIST_ERR_H",
  ADDRESS => 0x0000000100058820,
  NOTE    => "rising edge bist error pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00810_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRP_MMR_YBIST_ERR_L                                           #
#                                                                        #
##########################################################################

%shub_01_00811_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "RSVD1"                        => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PAT"                          => [   4,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%shub_01_00811_def =
( NAME    => "SH_MD_DQRP_MMR_YBIST_ERR_L",
  ADDRESS => 0x0000000100058830,
  NOTE    => "falling edge bist error pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00811_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRS_MMR_XBIST_H                                               #
#                                                                        #
##########################################################################

%shub_01_00812_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  43,  21, 0xFFFFF80000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms data miscompare capture" ],
   "ROT"                          => [   2,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   3,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "PAT"                          => [   4,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%shub_01_00812_def =
( NAME    => "SH_MD_DQRS_MMR_XBIST_H",
  ADDRESS => 0x0000000100068000,
  NOTE    => "rising edge bist/fill pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00812_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRS_MMR_XBIST_L                                               #
#                                                                        #
##########################################################################

%shub_01_00813_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ROT"                          => [   1,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "PAT"                          => [   3,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%shub_01_00813_def =
( NAME    => "SH_MD_DQRS_MMR_XBIST_L",
  ADDRESS => 0x0000000100068010,
  NOTE    => "falling edge bist/fill pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00813_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRS_MMR_XBIST_ERR_H                                           #
#                                                                        #
##########################################################################

%shub_01_00814_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "PAT"                          => [   3,   0,  40, 0x000000FFFFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%shub_01_00814_def =
( NAME    => "SH_MD_DQRS_MMR_XBIST_ERR_H",
  ADDRESS => 0x0000000100068020,
  NOTE    => "rising edge bist error pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00814_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRS_MMR_XBIST_ERR_L                                           #
#                                                                        #
##########################################################################

%shub_01_00815_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "PAT"                          => [   3,   0,  40, 0x000000FFFFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%shub_01_00815_def =
( NAME    => "SH_MD_DQRS_MMR_XBIST_ERR_L",
  ADDRESS => 0x0000000100068030,
  NOTE    => "falling edge bist error pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00815_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRS_MMR_YBIST_H                                               #
#                                                                        #
##########################################################################

%shub_01_00816_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  43,  21, 0xFFFFF80000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "writing 1 arms data miscompare capture" ],
   "ROT"                          => [   2,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   3,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "PAT"                          => [   4,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%shub_01_00816_def =
( NAME    => "SH_MD_DQRS_MMR_YBIST_H",
  ADDRESS => 0x0000000100068800,
  NOTE    => "rising edge bist/fill pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00816_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRS_MMR_YBIST_L                                               #
#                                                                        #
##########################################################################

%shub_01_00817_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ROT"                          => [   1,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "rotate left data pattern in next cycle" ],
   "INV"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "invert data pattern in next cycle" ],
   "PAT"                          => [   3,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "data pattern" ],
);

%shub_01_00817_def =
( NAME    => "SH_MD_DQRS_MMR_YBIST_L",
  ADDRESS => 0x0000000100068810,
  NOTE    => "falling edge bist/fill pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00817_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRS_MMR_YBIST_ERR_H                                           #
#                                                                        #
##########################################################################

%shub_01_00818_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "PAT"                          => [   3,   0,  40, 0x000000FFFFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%shub_01_00818_def =
( NAME    => "SH_MD_DQRS_MMR_YBIST_ERR_H",
  ADDRESS => 0x0000000100068820,
  NOTE    => "rising edge bist error pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00818_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRS_MMR_YBIST_ERR_L                                           #
#                                                                        #
##########################################################################

%shub_01_00819_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  42,  22, 0xFFFFFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MORE"                         => [   1,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "more than one bist data miscompare" ],
   "VAL"                          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "bist data miscompare" ],
   "PAT"                          => [   3,   0,  40, 0x000000FFFFFFFFFF, 0x00, 0, 0x0000000000000000, "data pattern" ],
);

%shub_01_00819_def =
( NAME    => "SH_MD_DQRS_MMR_YBIST_ERR_L",
  ADDRESS => 0x0000000100068830,
  NOTE    => "falling edge bist error pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00819_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRS_MMR_JNR_DEBUG                                             #
#                                                                        #
##########################################################################

%shub_01_00820_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   2,  62, 0xFFFFFFFFFFFFFFFC, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RW"                           => [   1,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "select 0=read 1=write side" ],
   "PX"                           => [   2,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "select 0=pi 1=xn side" ],
);

%shub_01_00820_def =
( NAME    => "SH_MD_DQRS_MMR_JNR_DEBUG",
  ADDRESS => 0x0000000100069000,
  NOTE    => "joiner/fct debug configuration",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00820_flds
);


##########################################################################
#                                                                        #
#   SH_MD_DQRS_MMR_YAMOPW_ERR                                            #
#                                                                        #
##########################################################################

%shub_01_00821_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ARM"                          => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "writing 1 arms ecc error capture" ],
   "RSVD1"                        => [   2,  26,   6, 0x00000000FC000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RUNC"                         => [   3,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "uncorrectable ecc errror on read data" ],
   "RCOR"                         => [   4,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "correctable ecc errror on read data" ],
   "RSYN"                         => [   5,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "memory read data syndrome" ],
   "RSVD2"                        => [   6,  10,   6, 0x000000000000FC00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SUNC"                         => [   7,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "uncorrectable ecc errror on store data" ],
   "SCOR"                         => [   8,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "correctable ecc errror on store data" ],
   "SSYN"                         => [   9,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "store data syndrome" ],
);

%shub_01_00821_def =
( NAME    => "SH_MD_DQRS_MMR_YAMOPW_ERR",
  ADDRESS => 0x000000010006a000,
  NOTE    => "amo/partial rmw ecc error register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%shub_01_00821_flds
);


##########################################################################
#                                                                        #
#   MMR LOOKUP TABLES (BY NAME OR ADDRESS)                               #
#                                                                        #
##########################################################################

%shub_01_mmr_by_name = 
(
   SH_FSB_BINIT_CONTROL         => \%shub_01_00000_def,
   SH_FSB_RESET_CONTROL         => \%shub_01_00001_def,
   SH_FSB_SYSTEM_AGENT_CONFIG   => \%shub_01_00002_def,
   SH_FSB_VGA_REMAP             => \%shub_01_00003_def,
   SH_FSB_RESET_STATUS          => \%shub_01_00004_def,
   SH_FSB_SYMMETRIC_AGENT_STATUS => \%shub_01_00005_def,
   SH_GFX_CREDIT_COUNT_0        => \%shub_01_00006_def,
   SH_GFX_CREDIT_COUNT_1        => \%shub_01_00007_def,
   SH_GFX_MODE_CNTRL_0          => \%shub_01_00008_def,
   SH_GFX_MODE_CNTRL_1          => \%shub_01_00009_def,
   SH_GFX_SKID_CREDIT_COUNT_0   => \%shub_01_00010_def,
   SH_GFX_SKID_CREDIT_COUNT_1   => \%shub_01_00011_def,
   SH_GFX_STALL_LIMIT_0         => \%shub_01_00012_def,
   SH_GFX_STALL_LIMIT_1         => \%shub_01_00013_def,
   SH_GFX_STALL_TIMER_0         => \%shub_01_00014_def,
   SH_GFX_STALL_TIMER_1         => \%shub_01_00015_def,
   SH_GFX_WINDOW_0              => \%shub_01_00016_def,
   SH_GFX_WINDOW_1              => \%shub_01_00017_def,
   SH_GFX_INTERRUPT_TIMER_LIMIT_0 => \%shub_01_00018_def,
   SH_GFX_INTERRUPT_TIMER_LIMIT_1 => \%shub_01_00019_def,
   SH_GFX_WRITE_STATUS_0        => \%shub_01_00020_def,
   SH_GFX_WRITE_STATUS_1        => \%shub_01_00021_def,
   SH_II_INT0                   => \%shub_01_00022_def,
   SH_II_INT0_CONFIG            => \%shub_01_00023_def,
   SH_II_INT0_ENABLE            => \%shub_01_00024_def,
   SH_II_INT1                   => \%shub_01_00025_def,
   SH_II_INT1_CONFIG            => \%shub_01_00026_def,
   SH_II_INT1_ENABLE            => \%shub_01_00027_def,
   SH_INT_NODE_ID_CONFIG        => \%shub_01_00028_def,
   SH_IPI_INT                   => \%shub_01_00029_def,
   SH_IPI_INT_ENABLE            => \%shub_01_00030_def,
   SH_LOCAL_INT0_CONFIG         => \%shub_01_00031_def,
   SH_LOCAL_INT0_ENABLE         => \%shub_01_00032_def,
   SH_LOCAL_INT1_CONFIG         => \%shub_01_00033_def,
   SH_LOCAL_INT1_ENABLE         => \%shub_01_00034_def,
   SH_LOCAL_INT2_CONFIG         => \%shub_01_00035_def,
   SH_LOCAL_INT2_ENABLE         => \%shub_01_00036_def,
   SH_LOCAL_INT3_CONFIG         => \%shub_01_00037_def,
   SH_LOCAL_INT3_ENABLE         => \%shub_01_00038_def,
   SH_LOCAL_INT4_CONFIG         => \%shub_01_00039_def,
   SH_LOCAL_INT4_ENABLE         => \%shub_01_00040_def,
   SH_LOCAL_INT5_CONFIG         => \%shub_01_00041_def,
   SH_LOCAL_INT5_ENABLE         => \%shub_01_00042_def,
   SH_PROC0_ERR_INT_CONFIG      => \%shub_01_00043_def,
   SH_PROC1_ERR_INT_CONFIG      => \%shub_01_00044_def,
   SH_PROC2_ERR_INT_CONFIG      => \%shub_01_00045_def,
   SH_PROC3_ERR_INT_CONFIG      => \%shub_01_00046_def,
   SH_PROC0_ADV_INT_CONFIG      => \%shub_01_00047_def,
   SH_PROC1_ADV_INT_CONFIG      => \%shub_01_00048_def,
   SH_PROC2_ADV_INT_CONFIG      => \%shub_01_00049_def,
   SH_PROC3_ADV_INT_CONFIG      => \%shub_01_00050_def,
   SH_PROC0_ERR_INT_ENABLE      => \%shub_01_00051_def,
   SH_PROC1_ERR_INT_ENABLE      => \%shub_01_00052_def,
   SH_PROC2_ERR_INT_ENABLE      => \%shub_01_00053_def,
   SH_PROC3_ERR_INT_ENABLE      => \%shub_01_00054_def,
   SH_PROC0_ADV_INT_ENABLE      => \%shub_01_00055_def,
   SH_PROC1_ADV_INT_ENABLE      => \%shub_01_00056_def,
   SH_PROC2_ADV_INT_ENABLE      => \%shub_01_00057_def,
   SH_PROC3_ADV_INT_ENABLE      => \%shub_01_00058_def,
   SH_PROFILE_INT_CONFIG        => \%shub_01_00059_def,
   SH_PROFILE_INT_ENABLE        => \%shub_01_00060_def,
   SH_RTC0_INT_CONFIG           => \%shub_01_00061_def,
   SH_RTC0_INT_ENABLE           => \%shub_01_00062_def,
   SH_RTC1_INT_CONFIG           => \%shub_01_00063_def,
   SH_RTC1_INT_ENABLE           => \%shub_01_00064_def,
   SH_RTC2_INT_CONFIG           => \%shub_01_00065_def,
   SH_RTC2_INT_ENABLE           => \%shub_01_00066_def,
   SH_RTC3_INT_CONFIG           => \%shub_01_00067_def,
   SH_RTC3_INT_ENABLE           => \%shub_01_00068_def,
   SH_EVENT_OCCURRED            => \%shub_01_00069_def,
   SH_EVENT_OCCURRED_ALIAS      => \%shub_01_00070_def,
   SH_EVENT_OVERFLOW            => \%shub_01_00071_def,
   SH_EVENT_OVERFLOW_ALIAS      => \%shub_01_00072_def,
   SH_JUNK_BUS_TIME             => \%shub_01_00073_def,
   SH_JUNK_LATCH_TIME           => \%shub_01_00074_def,
   SH_JUNK_NACK_RESET           => \%shub_01_00075_def,
   SH_JUNK_BUS_LED0             => \%shub_01_00076_def,
   SH_JUNK_BUS_LED1             => \%shub_01_00077_def,
   SH_JUNK_BUS_LED2             => \%shub_01_00078_def,
   SH_JUNK_BUS_LED3             => \%shub_01_00079_def,
   SH_JUNK_ERROR_STATUS         => \%shub_01_00080_def,
   SH_NI0_LLP_STAT              => \%shub_01_00081_def,
   SH_NI0_LLP_RESET             => \%shub_01_00082_def,
   SH_NI0_LLP_RESET_EN          => \%shub_01_00083_def,
   SH_NI0_LLP_CHAN_MODE         => \%shub_01_00084_def,
   SH_NI0_LLP_CONFIG            => \%shub_01_00085_def,
   SH_NI0_LLP_TEST_CTL          => \%shub_01_00086_def,
   SH_NI0_LLP_CAPT_WD1          => \%shub_01_00087_def,
   SH_NI0_LLP_CAPT_WD2          => \%shub_01_00088_def,
   SH_NI0_LLP_CAPT_SBCB         => \%shub_01_00089_def,
   SH_NI0_LLP_ERR               => \%shub_01_00090_def,
   SH_NI1_LLP_STAT              => \%shub_01_00091_def,
   SH_NI1_LLP_RESET             => \%shub_01_00092_def,
   SH_NI1_LLP_RESET_EN          => \%shub_01_00093_def,
   SH_NI1_LLP_CHAN_MODE         => \%shub_01_00094_def,
   SH_NI1_LLP_CONFIG            => \%shub_01_00095_def,
   SH_NI1_LLP_TEST_CTL          => \%shub_01_00096_def,
   SH_NI1_LLP_CAPT_WD1          => \%shub_01_00097_def,
   SH_NI1_LLP_CAPT_WD2          => \%shub_01_00098_def,
   SH_NI1_LLP_CAPT_SBCB         => \%shub_01_00099_def,
   SH_NI1_LLP_ERR               => \%shub_01_00100_def,
   SH_XNNI0_LLP_TO_FIFO02_FLOW  => \%shub_01_00101_def,
   SH_XNNI0_LLP_TO_FIFO13_FLOW  => \%shub_01_00102_def,
   SH_XNNI0_LLP_DEBIT_FLOW      => \%shub_01_00103_def,
   SH_XNNI0_LINK_0_FLOW         => \%shub_01_00104_def,
   SH_XNNI0_LINK_1_FLOW         => \%shub_01_00105_def,
   SH_XNNI0_LINK_2_FLOW         => \%shub_01_00106_def,
   SH_XNNI0_LINK_3_FLOW         => \%shub_01_00107_def,
   SH_XNNI1_LLP_TO_FIFO02_FLOW  => \%shub_01_00108_def,
   SH_XNNI1_LLP_TO_FIFO13_FLOW  => \%shub_01_00109_def,
   SH_XNNI1_LLP_DEBIT_FLOW      => \%shub_01_00110_def,
   SH_XNNI1_LINK_0_FLOW         => \%shub_01_00111_def,
   SH_XNNI1_LINK_1_FLOW         => \%shub_01_00112_def,
   SH_XNNI1_LINK_2_FLOW         => \%shub_01_00113_def,
   SH_XNNI1_LINK_3_FLOW         => \%shub_01_00114_def,
   SH_IILB_LOCAL_TABLE          => \%shub_01_00115_def,
   SH_IILB_GLOBAL_TABLE         => \%shub_01_00116_def,
   SH_IILB_OVER_RIDE_TABLE      => \%shub_01_00117_def,
   SH_IILB_RSP_PLANE_HINT       => \%shub_01_00118_def,
   SH_PI_LOCAL_TABLE            => \%shub_01_00119_def,
   SH_PI_GLOBAL_TABLE           => \%shub_01_00120_def,
   SH_PI_OVER_RIDE_TABLE        => \%shub_01_00121_def,
   SH_PI_RSP_PLANE_HINT         => \%shub_01_00122_def,
   SH_NI0_LOCAL_TABLE           => \%shub_01_00123_def,
   SH_NI0_GLOBAL_TABLE          => \%shub_01_00124_def,
   SH_NI0_OVER_RIDE_TABLE       => \%shub_01_00125_def,
   SH_NI0_RSP_PLANE_HINT        => \%shub_01_00126_def,
   SH_NI1_LOCAL_TABLE           => \%shub_01_00127_def,
   SH_NI1_GLOBAL_TABLE          => \%shub_01_00128_def,
   SH_NI1_OVER_RIDE_TABLE       => \%shub_01_00129_def,
   SH_NI1_RSP_PLANE_HINT        => \%shub_01_00130_def,
   SH_MD_LOCAL_TABLE            => \%shub_01_00131_def,
   SH_MD_GLOBAL_TABLE           => \%shub_01_00132_def,
   SH_MD_OVER_RIDE_TABLE        => \%shub_01_00133_def,
   SH_MD_RSP_PLANE_HINT         => \%shub_01_00134_def,
   SH_LB_LIQ_CTL                => \%shub_01_00135_def,
   SH_LB_LOQ_CTL                => \%shub_01_00136_def,
   SH_LB_MAX_REP_CREDIT_CNT     => \%shub_01_00137_def,
   SH_LB_MAX_REQ_CREDIT_CNT     => \%shub_01_00138_def,
   SH_PIO_TIME_OUT              => \%shub_01_00139_def,
   SH_PIO_NACK_RESET            => \%shub_01_00140_def,
   SH_CONVEYOR_BELT_TIME_OUT    => \%shub_01_00141_def,
   SH_LB_CREDIT_STATUS          => \%shub_01_00142_def,
   SH_LB_DEBUG_LOCAL_SEL        => \%shub_01_00143_def,
   SH_LB_DEBUG_PERF_SEL         => \%shub_01_00144_def,
   SH_LB_DEBUG_TRIG_SEL         => \%shub_01_00145_def,
   SH_LB_ERROR_DETAIL_1         => \%shub_01_00146_def,
   SH_LB_ERROR_DETAIL_2         => \%shub_01_00147_def,
   SH_LB_ERROR_DETAIL_3         => \%shub_01_00148_def,
   SH_LB_ERROR_DETAIL_4         => \%shub_01_00149_def,
   SH_LB_ERROR_DETAIL_5         => \%shub_01_00150_def,
   SH_LB_ERROR_MASK             => \%shub_01_00151_def,
   SH_LB_ERROR_OVERFLOW         => \%shub_01_00152_def,
   SH_LB_ERROR_OVERFLOW_ALIAS   => \%shub_01_00153_def,
   SH_LB_ERROR_SUMMARY          => \%shub_01_00154_def,
   SH_LB_ERROR_SUMMARY_ALIAS    => \%shub_01_00155_def,
   SH_LB_FIRST_ERROR            => \%shub_01_00156_def,
   SH_LB_LAST_CREDIT            => \%shub_01_00157_def,
   SH_LB_NACK_STATUS            => \%shub_01_00158_def,
   SH_LB_TRIGGER_COMPARE        => \%shub_01_00159_def,
   SH_LB_TRIGGER_DATA           => \%shub_01_00160_def,
   SH_PI_AEC_CONFIG             => \%shub_01_00161_def,
   SH_PI_AFI_ERROR_MASK         => \%shub_01_00162_def,
   SH_PI_AFI_TEST_POINT_COMPARE => \%shub_01_00163_def,
   SH_PI_AFI_TEST_POINT_SELECT  => \%shub_01_00164_def,
   SH_PI_AFI_TEST_POINT_TRIGGER_SELECT => \%shub_01_00165_def,
   SH_PI_AUTO_REPLY_ENABLE      => \%shub_01_00166_def,
   SH_PI_CAM_CONTROL            => \%shub_01_00167_def,
   SH_PI_CRBC_TEST_POINT_COMPARE => \%shub_01_00168_def,
   SH_PI_CRBC_TEST_POINT_SELECT => \%shub_01_00169_def,
   SH_PI_CRBC_TEST_POINT_TRIGGER_SELECT => \%shub_01_00170_def,
   SH_PI_CRBP_ERROR_MASK        => \%shub_01_00171_def,
   SH_PI_CRBP_FSB_PIPE_COMPARE  => \%shub_01_00172_def,
   SH_PI_CRBP_FSB_PIPE_MASK     => \%shub_01_00173_def,
   SH_PI_CRBP_TEST_POINT_COMPARE => \%shub_01_00174_def,
   SH_PI_CRBP_TEST_POINT_SELECT => \%shub_01_00175_def,
   SH_PI_CRBP_TEST_POINT_TRIGGER_SELECT => \%shub_01_00176_def,
   SH_PI_CRBP_XB_PIPE_COMPARE_0 => \%shub_01_00177_def,
   SH_PI_CRBP_XB_PIPE_COMPARE_1 => \%shub_01_00178_def,
   SH_PI_CRBP_XB_PIPE_MASK_0    => \%shub_01_00179_def,
   SH_PI_CRBP_XB_PIPE_MASK_1    => \%shub_01_00180_def,
   SH_PI_DPC_QUEUE_CONFIG       => \%shub_01_00181_def,
   SH_PI_ERROR_MASK             => \%shub_01_00182_def,
   SH_PI_EXPRESS_REPLY_CONFIG   => \%shub_01_00183_def,
   SH_PI_FSB_COMPARE_VALUE      => \%shub_01_00184_def,
   SH_PI_FSB_COMPARE_MASK       => \%shub_01_00185_def,
   SH_PI_FSB_ERROR_INJECTION    => \%shub_01_00186_def,
   SH_PI_MD2PI_REPLY_VC_CONFIG  => \%shub_01_00187_def,
   SH_PI_MD2PI_REQUEST_VC_CONFIG => \%shub_01_00188_def,
   SH_PI_QUEUE_ERROR_INJECTION  => \%shub_01_00189_def,
   SH_PI_TEST_POINT_COMPARE     => \%shub_01_00190_def,
   SH_PI_TEST_POINT_SELECT      => \%shub_01_00191_def,
   SH_PI_TEST_POINT_TRIGGER_SELECT => \%shub_01_00192_def,
   SH_PI_XN2PI_REPLY_VC_CONFIG  => \%shub_01_00193_def,
   SH_PI_XN2PI_REQUEST_VC_CONFIG => \%shub_01_00194_def,
   SH_PI_AEC_STATUS             => \%shub_01_00195_def,
   SH_PI_AFI_FIRST_ERROR        => \%shub_01_00196_def,
   SH_PI_CAM_ADDRESS_READ_DATA  => \%shub_01_00197_def,
   SH_PI_CAM_LPRA_READ_DATA     => \%shub_01_00198_def,
   SH_PI_CAM_STATE_READ_DATA    => \%shub_01_00199_def,
   SH_PI_CORRECTED_DETAIL_1     => \%shub_01_00200_def,
   SH_PI_CORRECTED_DETAIL_2     => \%shub_01_00201_def,
   SH_PI_CORRECTED_DETAIL_3     => \%shub_01_00202_def,
   SH_PI_CORRECTED_DETAIL_4     => \%shub_01_00203_def,
   SH_PI_CRBP_FIRST_ERROR       => \%shub_01_00204_def,
   SH_PI_ERROR_DETAIL_1         => \%shub_01_00205_def,
   SH_PI_ERROR_DETAIL_2         => \%shub_01_00206_def,
   SH_PI_ERROR_OVERFLOW         => \%shub_01_00207_def,
   SH_PI_ERROR_OVERFLOW_ALIAS   => \%shub_01_00208_def,
   SH_PI_ERROR_SUMMARY          => \%shub_01_00209_def,
   SH_PI_ERROR_SUMMARY_ALIAS    => \%shub_01_00210_def,
   SH_PI_EXPRESS_REPLY_STATUS   => \%shub_01_00211_def,
   SH_PI_FIRST_ERROR            => \%shub_01_00212_def,
   SH_PI_FIRST_ERROR_ALIAS      => \%shub_01_00213_def,
   SH_PI_PI2MD_REPLY_VC_STATUS  => \%shub_01_00214_def,
   SH_PI_PI2MD_REQUEST_VC_STATUS => \%shub_01_00215_def,
   SH_PI_PI2XN_REPLY_VC_STATUS  => \%shub_01_00216_def,
   SH_PI_PI2XN_REQUEST_VC_STATUS => \%shub_01_00217_def,
   SH_PI_UNCORRECTED_DETAIL_1   => \%shub_01_00218_def,
   SH_PI_UNCORRECTED_DETAIL_2   => \%shub_01_00219_def,
   SH_PI_UNCORRECTED_DETAIL_3   => \%shub_01_00220_def,
   SH_PI_UNCORRECTED_DETAIL_4   => \%shub_01_00221_def,
   SH_PI_MD2PI_REPLY_VC_STATUS  => \%shub_01_00222_def,
   SH_PI_MD2PI_REQUEST_VC_STATUS => \%shub_01_00223_def,
   SH_PI_XN2PI_REPLY_VC_STATUS  => \%shub_01_00224_def,
   SH_PI_XN2PI_REQUEST_VC_STATUS => \%shub_01_00225_def,
   SH_XNPI_SIC_FLOW             => \%shub_01_00226_def,
   SH_XNPI_TO_NI0_PORT_FLOW     => \%shub_01_00227_def,
   SH_XNPI_TO_NI1_PORT_FLOW     => \%shub_01_00228_def,
   SH_XNPI_TO_IILB_PORT_FLOW    => \%shub_01_00229_def,
   SH_XNPI_FR_NI0_PORT_FLOW_FIFO => \%shub_01_00230_def,
   SH_XNPI_FR_NI1_PORT_FLOW_FIFO => \%shub_01_00231_def,
   SH_XNPI_FR_IILB_PORT_FLOW_FIFO => \%shub_01_00232_def,
   SH_XNMD_SIC_FLOW             => \%shub_01_00233_def,
   SH_XNMD_TO_NI0_PORT_FLOW     => \%shub_01_00234_def,
   SH_XNMD_TO_NI1_PORT_FLOW     => \%shub_01_00235_def,
   SH_XNMD_TO_IILB_PORT_FLOW    => \%shub_01_00236_def,
   SH_XNMD_FR_NI0_PORT_FLOW_FIFO => \%shub_01_00237_def,
   SH_XNMD_FR_NI1_PORT_FLOW_FIFO => \%shub_01_00238_def,
   SH_XNMD_FR_IILB_PORT_FLOW_FIFO => \%shub_01_00239_def,
   SH_XNII_INTRA_FLOW           => \%shub_01_00240_def,
   SH_XNLB_INTRA_FLOW           => \%shub_01_00241_def,
   SH_XNIILB_TO_NI0_INTRA_FLOW_DEBIT => \%shub_01_00242_def,
   SH_XNIILB_TO_NI1_INTRA_FLOW_DEBIT => \%shub_01_00243_def,
   SH_XNIILB_TO_MD_INTRA_FLOW_DEBIT => \%shub_01_00244_def,
   SH_XNIILB_TO_IILB_INTRA_FLOW_DEBIT => \%shub_01_00245_def,
   SH_XNIILB_TO_PI_INTRA_FLOW_DEBIT => \%shub_01_00246_def,
   SH_XNIILB_FR_NI0_INTRA_FLOW_CREDIT => \%shub_01_00247_def,
   SH_XNIILB_FR_NI1_INTRA_FLOW_CREDIT => \%shub_01_00248_def,
   SH_XNIILB_FR_MD_INTRA_FLOW_CREDIT => \%shub_01_00249_def,
   SH_XNIILB_FR_IILB_INTRA_FLOW_CREDIT => \%shub_01_00250_def,
   SH_XNIILB_FR_PI_INTRA_FLOW_CREDIT => \%shub_01_00251_def,
   SH_XNNI0_TO_PI_INTRA_FLOW_DEBIT => \%shub_01_00252_def,
   SH_XNNI0_TO_MD_INTRA_FLOW_DEBIT => \%shub_01_00253_def,
   SH_XNNI0_TO_IILB_INTRA_FLOW_DEBIT => \%shub_01_00254_def,
   SH_XNNI0_FR_PI_INTRA_FLOW_CREDIT => \%shub_01_00255_def,
   SH_XNNI0_FR_MD_INTRA_FLOW_CREDIT => \%shub_01_00256_def,
   SH_XNNI0_FR_IILB_INTRA_FLOW_CREDIT => \%shub_01_00257_def,
   SH_XNNI0_0_INTRANI_FLOW      => \%shub_01_00258_def,
   SH_XNNI0_1_INTRANI_FLOW      => \%shub_01_00259_def,
   SH_XNNI0_2_INTRANI_FLOW      => \%shub_01_00260_def,
   SH_XNNI0_3_INTRANI_FLOW      => \%shub_01_00261_def,
   SH_XNNI0_VCSWITCH_FLOW       => \%shub_01_00262_def,
   SH_XNNI0_TIMER_REG           => \%shub_01_00263_def,
   SH_XNNI0_FIFO02_FLOW         => \%shub_01_00264_def,
   SH_XNNI0_FIFO13_FLOW         => \%shub_01_00265_def,
   SH_XNNI0_NI_FLOW             => \%shub_01_00266_def,
   SH_XNNI0_DEAD_FLOW           => \%shub_01_00267_def,
   SH_XNNI0_INJECT_AGE          => \%shub_01_00268_def,
   SH_XNNI1_TO_PI_INTRA_FLOW_DEBIT => \%shub_01_00269_def,
   SH_XNNI1_TO_MD_INTRA_FLOW_DEBIT => \%shub_01_00270_def,
   SH_XNNI1_TO_IILB_INTRA_FLOW_DEBIT => \%shub_01_00271_def,
   SH_XNNI1_FR_PI_INTRA_FLOW_CREDIT => \%shub_01_00272_def,
   SH_XNNI1_FR_MD_INTRA_FLOW_CREDIT => \%shub_01_00273_def,
   SH_XNNI1_FR_IILB_INTRA_FLOW_CREDIT => \%shub_01_00274_def,
   SH_XNNI1_0_INTRANI_FLOW      => \%shub_01_00275_def,
   SH_XNNI1_1_INTRANI_FLOW      => \%shub_01_00276_def,
   SH_XNNI1_2_INTRANI_FLOW      => \%shub_01_00277_def,
   SH_XNNI1_3_INTRANI_FLOW      => \%shub_01_00278_def,
   SH_XNNI1_VCSWITCH_FLOW       => \%shub_01_00279_def,
   SH_XNNI1_TIMER_REG           => \%shub_01_00280_def,
   SH_XNNI1_FIFO02_FLOW         => \%shub_01_00281_def,
   SH_XNNI1_FIFO13_FLOW         => \%shub_01_00282_def,
   SH_XNNI1_NI_FLOW             => \%shub_01_00283_def,
   SH_XNNI1_DEAD_FLOW           => \%shub_01_00284_def,
   SH_XNNI1_INJECT_AGE          => \%shub_01_00285_def,
   SH_XN_DEBUG_SEL              => \%shub_01_00286_def,
   SH_XN_DEBUG_TRIG_SEL         => \%shub_01_00287_def,
   SH_XN_TRIGGER_COMPARE        => \%shub_01_00288_def,
   SH_XN_TRIGGER_DATA           => \%shub_01_00289_def,
   SH_XN_IILB_DEBUG_SEL         => \%shub_01_00290_def,
   SH_XN_PI_DEBUG_SEL           => \%shub_01_00291_def,
   SH_XN_MD_DEBUG_SEL           => \%shub_01_00292_def,
   SH_XN_NI0_DEBUG_SEL          => \%shub_01_00293_def,
   SH_XN_NI1_DEBUG_SEL          => \%shub_01_00294_def,
   SH_XN_IILB_LB_CMP_EXP_DATA0  => \%shub_01_00295_def,
   SH_XN_IILB_LB_CMP_EXP_DATA1  => \%shub_01_00296_def,
   SH_XN_IILB_LB_CMP_ENABLE0    => \%shub_01_00297_def,
   SH_XN_IILB_LB_CMP_ENABLE1    => \%shub_01_00298_def,
   SH_XN_IILB_II_CMP_EXP_DATA0  => \%shub_01_00299_def,
   SH_XN_IILB_II_CMP_EXP_DATA1  => \%shub_01_00300_def,
   SH_XN_IILB_II_CMP_ENABLE0    => \%shub_01_00301_def,
   SH_XN_IILB_II_CMP_ENABLE1    => \%shub_01_00302_def,
   SH_XN_IILB_MD_CMP_EXP_DATA0  => \%shub_01_00303_def,
   SH_XN_IILB_MD_CMP_EXP_DATA1  => \%shub_01_00304_def,
   SH_XN_IILB_MD_CMP_ENABLE0    => \%shub_01_00305_def,
   SH_XN_IILB_MD_CMP_ENABLE1    => \%shub_01_00306_def,
   SH_XN_IILB_PI_CMP_EXP_DATA0  => \%shub_01_00307_def,
   SH_XN_IILB_PI_CMP_EXP_DATA1  => \%shub_01_00308_def,
   SH_XN_IILB_PI_CMP_ENABLE0    => \%shub_01_00309_def,
   SH_XN_IILB_PI_CMP_ENABLE1    => \%shub_01_00310_def,
   SH_XN_IILB_NI0_CMP_EXP_DATA0 => \%shub_01_00311_def,
   SH_XN_IILB_NI0_CMP_EXP_DATA1 => \%shub_01_00312_def,
   SH_XN_IILB_NI0_CMP_ENABLE0   => \%shub_01_00313_def,
   SH_XN_IILB_NI0_CMP_ENABLE1   => \%shub_01_00314_def,
   SH_XN_IILB_NI1_CMP_EXP_DATA0 => \%shub_01_00315_def,
   SH_XN_IILB_NI1_CMP_EXP_DATA1 => \%shub_01_00316_def,
   SH_XN_IILB_NI1_CMP_ENABLE0   => \%shub_01_00317_def,
   SH_XN_IILB_NI1_CMP_ENABLE1   => \%shub_01_00318_def,
   SH_XN_MD_IILB_CMP_EXP_DATA0  => \%shub_01_00319_def,
   SH_XN_MD_IILB_CMP_EXP_DATA1  => \%shub_01_00320_def,
   SH_XN_MD_IILB_CMP_ENABLE0    => \%shub_01_00321_def,
   SH_XN_MD_IILB_CMP_ENABLE1    => \%shub_01_00322_def,
   SH_XN_MD_NI0_CMP_EXP_DATA0   => \%shub_01_00323_def,
   SH_XN_MD_NI0_CMP_EXP_DATA1   => \%shub_01_00324_def,
   SH_XN_MD_NI0_CMP_ENABLE0     => \%shub_01_00325_def,
   SH_XN_MD_NI0_CMP_ENABLE1     => \%shub_01_00326_def,
   SH_XN_MD_NI1_CMP_EXP_DATA0   => \%shub_01_00327_def,
   SH_XN_MD_NI1_CMP_EXP_DATA1   => \%shub_01_00328_def,
   SH_XN_MD_NI1_CMP_ENABLE0     => \%shub_01_00329_def,
   SH_XN_MD_NI1_CMP_ENABLE1     => \%shub_01_00330_def,
   SH_XN_MD_SIC_CMP_EXP_HDR0    => \%shub_01_00331_def,
   SH_XN_MD_SIC_CMP_EXP_HDR1    => \%shub_01_00332_def,
   SH_XN_MD_SIC_CMP_HDR_ENABLE0 => \%shub_01_00333_def,
   SH_XN_MD_SIC_CMP_HDR_ENABLE1 => \%shub_01_00334_def,
   SH_XN_MD_SIC_CMP_DATA0       => \%shub_01_00335_def,
   SH_XN_MD_SIC_CMP_DATA1       => \%shub_01_00336_def,
   SH_XN_MD_SIC_CMP_DATA2       => \%shub_01_00337_def,
   SH_XN_MD_SIC_CMP_DATA3       => \%shub_01_00338_def,
   SH_XN_MD_SIC_CMP_DATA_ENABLE0 => \%shub_01_00339_def,
   SH_XN_MD_SIC_CMP_DATA_ENABLE1 => \%shub_01_00340_def,
   SH_XN_MD_SIC_CMP_DATA_ENABLE2 => \%shub_01_00341_def,
   SH_XN_MD_SIC_CMP_DATA_ENABLE3 => \%shub_01_00342_def,
   SH_XN_PI_IILB_CMP_EXP_DATA0  => \%shub_01_00343_def,
   SH_XN_PI_IILB_CMP_EXP_DATA1  => \%shub_01_00344_def,
   SH_XN_PI_IILB_CMP_ENABLE0    => \%shub_01_00345_def,
   SH_XN_PI_IILB_CMP_ENABLE1    => \%shub_01_00346_def,
   SH_XN_PI_NI0_CMP_EXP_DATA0   => \%shub_01_00347_def,
   SH_XN_PI_NI0_CMP_EXP_DATA1   => \%shub_01_00348_def,
   SH_XN_PI_NI0_CMP_ENABLE0     => \%shub_01_00349_def,
   SH_XN_PI_NI0_CMP_ENABLE1     => \%shub_01_00350_def,
   SH_XN_PI_NI1_CMP_EXP_DATA0   => \%shub_01_00351_def,
   SH_XN_PI_NI1_CMP_EXP_DATA1   => \%shub_01_00352_def,
   SH_XN_PI_NI1_CMP_ENABLE0     => \%shub_01_00353_def,
   SH_XN_PI_NI1_CMP_ENABLE1     => \%shub_01_00354_def,
   SH_XN_PI_SIC_CMP_EXP_HDR0    => \%shub_01_00355_def,
   SH_XN_PI_SIC_CMP_EXP_HDR1    => \%shub_01_00356_def,
   SH_XN_PI_SIC_CMP_HDR_ENABLE0 => \%shub_01_00357_def,
   SH_XN_PI_SIC_CMP_HDR_ENABLE1 => \%shub_01_00358_def,
   SH_XN_PI_SIC_CMP_DATA0       => \%shub_01_00359_def,
   SH_XN_PI_SIC_CMP_DATA1       => \%shub_01_00360_def,
   SH_XN_PI_SIC_CMP_DATA2       => \%shub_01_00361_def,
   SH_XN_PI_SIC_CMP_DATA3       => \%shub_01_00362_def,
   SH_XN_PI_SIC_CMP_DATA_ENABLE0 => \%shub_01_00363_def,
   SH_XN_PI_SIC_CMP_DATA_ENABLE1 => \%shub_01_00364_def,
   SH_XN_PI_SIC_CMP_DATA_ENABLE2 => \%shub_01_00365_def,
   SH_XN_PI_SIC_CMP_DATA_ENABLE3 => \%shub_01_00366_def,
   SH_XN_NI0_IILB_CMP_EXP_DATA0 => \%shub_01_00367_def,
   SH_XN_NI0_IILB_CMP_EXP_DATA1 => \%shub_01_00368_def,
   SH_XN_NI0_IILB_CMP_ENABLE0   => \%shub_01_00369_def,
   SH_XN_NI0_IILB_CMP_ENABLE1   => \%shub_01_00370_def,
   SH_XN_NI0_PI_CMP_EXP_DATA0   => \%shub_01_00371_def,
   SH_XN_NI0_PI_CMP_EXP_DATA1   => \%shub_01_00372_def,
   SH_XN_NI0_PI_CMP_ENABLE0     => \%shub_01_00373_def,
   SH_XN_NI0_PI_CMP_ENABLE1     => \%shub_01_00374_def,
   SH_XN_NI0_MD_CMP_EXP_DATA0   => \%shub_01_00375_def,
   SH_XN_NI0_MD_CMP_EXP_DATA1   => \%shub_01_00376_def,
   SH_XN_NI0_MD_CMP_ENABLE0     => \%shub_01_00377_def,
   SH_XN_NI0_MD_CMP_ENABLE1     => \%shub_01_00378_def,
   SH_XN_NI0_NI_CMP_EXP_DATA0   => \%shub_01_00379_def,
   SH_XN_NI0_NI_CMP_EXP_DATA1   => \%shub_01_00380_def,
   SH_XN_NI0_NI_CMP_ENABLE0     => \%shub_01_00381_def,
   SH_XN_NI0_NI_CMP_ENABLE1     => \%shub_01_00382_def,
   SH_XN_NI0_LLP_CMP_EXP_DATA0  => \%shub_01_00383_def,
   SH_XN_NI0_LLP_CMP_EXP_DATA1  => \%shub_01_00384_def,
   SH_XN_NI0_LLP_CMP_ENABLE0    => \%shub_01_00385_def,
   SH_XN_NI0_LLP_CMP_ENABLE1    => \%shub_01_00386_def,
   SH_XN_NI1_IILB_CMP_EXP_DATA0 => \%shub_01_00387_def,
   SH_XN_NI1_IILB_CMP_EXP_DATA1 => \%shub_01_00388_def,
   SH_XN_NI1_IILB_CMP_ENABLE0   => \%shub_01_00389_def,
   SH_XN_NI1_IILB_CMP_ENABLE1   => \%shub_01_00390_def,
   SH_XN_NI1_PI_CMP_EXP_DATA0   => \%shub_01_00391_def,
   SH_XN_NI1_PI_CMP_EXP_DATA1   => \%shub_01_00392_def,
   SH_XN_NI1_PI_CMP_ENABLE0     => \%shub_01_00393_def,
   SH_XN_NI1_PI_CMP_ENABLE1     => \%shub_01_00394_def,
   SH_XN_NI1_MD_CMP_EXP_DATA0   => \%shub_01_00395_def,
   SH_XN_NI1_MD_CMP_EXP_DATA1   => \%shub_01_00396_def,
   SH_XN_NI1_MD_CMP_ENABLE0     => \%shub_01_00397_def,
   SH_XN_NI1_MD_CMP_ENABLE1     => \%shub_01_00398_def,
   SH_XN_NI1_NI_CMP_EXP_DATA0   => \%shub_01_00399_def,
   SH_XN_NI1_NI_CMP_EXP_DATA1   => \%shub_01_00400_def,
   SH_XN_NI1_NI_CMP_ENABLE0     => \%shub_01_00401_def,
   SH_XN_NI1_NI_CMP_ENABLE1     => \%shub_01_00402_def,
   SH_XN_NI1_LLP_CMP_EXP_DATA0  => \%shub_01_00403_def,
   SH_XN_NI1_LLP_CMP_EXP_DATA1  => \%shub_01_00404_def,
   SH_XN_NI1_LLP_CMP_ENABLE0    => \%shub_01_00405_def,
   SH_XN_NI1_LLP_CMP_ENABLE1    => \%shub_01_00406_def,
   SH_XNPI_ECC_INJ_REG          => \%shub_01_00407_def,
   SH_XNPI_ECC0_INJ_MASK_REG    => \%shub_01_00408_def,
   SH_XNPI_ECC1_INJ_MASK_REG    => \%shub_01_00409_def,
   SH_XNPI_ECC2_INJ_MASK_REG    => \%shub_01_00410_def,
   SH_XNPI_ECC3_INJ_MASK_REG    => \%shub_01_00411_def,
   SH_XNMD_ECC_INJ_REG          => \%shub_01_00412_def,
   SH_XNMD_ECC0_INJ_MASK_REG    => \%shub_01_00413_def,
   SH_XNMD_ECC1_INJ_MASK_REG    => \%shub_01_00414_def,
   SH_XNMD_ECC2_INJ_MASK_REG    => \%shub_01_00415_def,
   SH_XNMD_ECC3_INJ_MASK_REG    => \%shub_01_00416_def,
   SH_XNMD_ECC_ERR_REPORT       => \%shub_01_00417_def,
   SH_NI0_ERROR_SUMMARY_1       => \%shub_01_00418_def,
   SH_NI0_ERROR_SUMMARY_1_ALIAS => \%shub_01_00419_def,
   SH_NI0_ERROR_SUMMARY_2       => \%shub_01_00420_def,
   SH_NI0_ERROR_SUMMARY_2_ALIAS => \%shub_01_00421_def,
   SH_NI0_ERROR_OVERFLOW_1      => \%shub_01_00422_def,
   SH_NI0_ERROR_OVERFLOW_1_ALIAS => \%shub_01_00423_def,
   SH_NI0_ERROR_OVERFLOW_2      => \%shub_01_00424_def,
   SH_NI0_ERROR_OVERFLOW_2_ALIAS => \%shub_01_00425_def,
   SH_NI0_ERROR_MASK_1          => \%shub_01_00426_def,
   SH_NI0_ERROR_MASK_2          => \%shub_01_00427_def,
   SH_NI0_FIRST_ERROR_1         => \%shub_01_00428_def,
   SH_NI0_FIRST_ERROR_2         => \%shub_01_00429_def,
   SH_NI0_ERROR_DETAIL_1        => \%shub_01_00430_def,
   SH_NI0_ERROR_DETAIL_2        => \%shub_01_00431_def,
   SH_NI1_ERROR_SUMMARY_1       => \%shub_01_00432_def,
   SH_NI1_ERROR_SUMMARY_1_ALIAS => \%shub_01_00433_def,
   SH_NI1_ERROR_SUMMARY_2       => \%shub_01_00434_def,
   SH_NI1_ERROR_SUMMARY_2_ALIAS => \%shub_01_00435_def,
   SH_NI1_ERROR_OVERFLOW_1      => \%shub_01_00436_def,
   SH_NI1_ERROR_OVERFLOW_1_ALIAS => \%shub_01_00437_def,
   SH_NI1_ERROR_OVERFLOW_2      => \%shub_01_00438_def,
   SH_NI1_ERROR_OVERFLOW_2_ALIAS => \%shub_01_00439_def,
   SH_NI1_ERROR_MASK_1          => \%shub_01_00440_def,
   SH_NI1_ERROR_MASK_2          => \%shub_01_00441_def,
   SH_NI1_FIRST_ERROR_1         => \%shub_01_00442_def,
   SH_NI1_FIRST_ERROR_2         => \%shub_01_00443_def,
   SH_NI1_ERROR_DETAIL_1        => \%shub_01_00444_def,
   SH_NI1_ERROR_DETAIL_2        => \%shub_01_00445_def,
   SH_XN_CORRECTED_DETAIL_1     => \%shub_01_00446_def,
   SH_XN_CORRECTED_DETAIL_2     => \%shub_01_00447_def,
   SH_XN_CORRECTED_DETAIL_3     => \%shub_01_00448_def,
   SH_XN_CORRECTED_DETAIL_4     => \%shub_01_00449_def,
   SH_XN_UNCORRECTED_DETAIL_1   => \%shub_01_00450_def,
   SH_XN_UNCORRECTED_DETAIL_2   => \%shub_01_00451_def,
   SH_XN_UNCORRECTED_DETAIL_3   => \%shub_01_00452_def,
   SH_XN_UNCORRECTED_DETAIL_4   => \%shub_01_00453_def,
   SH_XNMD_ERROR_DETAIL_1       => \%shub_01_00454_def,
   SH_XNPI_ERROR_DETAIL_1       => \%shub_01_00455_def,
   SH_XNIILB_ERROR_DETAIL_1     => \%shub_01_00456_def,
   SH_XNIILB_ERROR_DETAIL_2     => \%shub_01_00457_def,
   SH_XNIILB_ERROR_DETAIL_3     => \%shub_01_00458_def,
   SH_NI0_ERROR_DETAIL_3        => \%shub_01_00459_def,
   SH_NI1_ERROR_DETAIL_3        => \%shub_01_00460_def,
   SH_XN_ERROR_SUMMARY          => \%shub_01_00461_def,
   SH_XN_ERRORS_ALIAS           => \%shub_01_00462_def,
   SH_XN_ERROR_OVERFLOW         => \%shub_01_00463_def,
   SH_XN_ERROR_OVERFLOW_ALIAS   => \%shub_01_00464_def,
   SH_XN_ERROR_MASK             => \%shub_01_00465_def,
   SH_XN_FIRST_ERROR            => \%shub_01_00466_def,
   SH_XNIILB_ERROR_SUMMARY      => \%shub_01_00467_def,
   SH_XNIILB_ERRORS_ALIAS       => \%shub_01_00468_def,
   SH_XNIILB_ERROR_OVERFLOW     => \%shub_01_00469_def,
   SH_XNIILB_ERROR_OVERFLOW_ALIAS => \%shub_01_00470_def,
   SH_XNIILB_ERROR_MASK         => \%shub_01_00471_def,
   SH_XNIILB_FIRST_ERROR        => \%shub_01_00472_def,
   SH_XNPI_ERROR_SUMMARY        => \%shub_01_00473_def,
   SH_XNPI_ERRORS_ALIAS         => \%shub_01_00474_def,
   SH_XNPI_ERROR_OVERFLOW       => \%shub_01_00475_def,
   SH_XNPI_ERROR_OVERFLOW_ALIAS => \%shub_01_00476_def,
   SH_XNPI_ERROR_MASK           => \%shub_01_00477_def,
   SH_XNPI_FIRST_ERROR          => \%shub_01_00478_def,
   SH_XNMD_ERROR_SUMMARY        => \%shub_01_00479_def,
   SH_XNMD_ERRORS_ALIAS         => \%shub_01_00480_def,
   SH_XNMD_ERROR_OVERFLOW       => \%shub_01_00481_def,
   SH_XNMD_ERROR_OVERFLOW_ALIAS => \%shub_01_00482_def,
   SH_XNMD_ERROR_MASK           => \%shub_01_00483_def,
   SH_XNMD_FIRST_ERROR          => \%shub_01_00484_def,
   SH_AUTO_REPLY_ENABLE0        => \%shub_01_00485_def,
   SH_AUTO_REPLY_ENABLE1        => \%shub_01_00486_def,
   SH_AUTO_REPLY_HEADER0        => \%shub_01_00487_def,
   SH_AUTO_REPLY_HEADER1        => \%shub_01_00488_def,
   SH_ENABLE_RP_AUTO_REPLY      => \%shub_01_00489_def,
   SH_ENABLE_RQ_AUTO_REPLY      => \%shub_01_00490_def,
   SH_REDIRECT_INVAL            => \%shub_01_00491_def,
   SH_DIAG_MSG_CNTRL            => \%shub_01_00492_def,
   SH_DIAG_MSG_DATA0L           => \%shub_01_00493_def,
   SH_DIAG_MSG_DATA0U           => \%shub_01_00494_def,
   SH_DIAG_MSG_DATA1L           => \%shub_01_00495_def,
   SH_DIAG_MSG_DATA1U           => \%shub_01_00496_def,
   SH_DIAG_MSG_DATA2L           => \%shub_01_00497_def,
   SH_DIAG_MSG_DATA2U           => \%shub_01_00498_def,
   SH_DIAG_MSG_DATA3L           => \%shub_01_00499_def,
   SH_DIAG_MSG_DATA3U           => \%shub_01_00500_def,
   SH_DIAG_MSG_DATA4L           => \%shub_01_00501_def,
   SH_DIAG_MSG_DATA4U           => \%shub_01_00502_def,
   SH_DIAG_MSG_DATA5L           => \%shub_01_00503_def,
   SH_DIAG_MSG_DATA5U           => \%shub_01_00504_def,
   SH_DIAG_MSG_DATA6L           => \%shub_01_00505_def,
   SH_DIAG_MSG_DATA6U           => \%shub_01_00506_def,
   SH_DIAG_MSG_DATA7L           => \%shub_01_00507_def,
   SH_DIAG_MSG_DATA7U           => \%shub_01_00508_def,
   SH_DIAG_MSG_DATA8L           => \%shub_01_00509_def,
   SH_DIAG_MSG_DATA8U           => \%shub_01_00510_def,
   SH_DIAG_MSG_HDR0             => \%shub_01_00511_def,
   SH_DIAG_MSG_HDR1             => \%shub_01_00512_def,
   SH_DEBUG_SELECT              => \%shub_01_00513_def,
   SH_TRIGGER_COMPARE_MASK      => \%shub_01_00514_def,
   SH_TRIGGER_COMPARE_PATTERN   => \%shub_01_00515_def,
   SH_TRIGGER_SEL               => \%shub_01_00516_def,
   SH_STOP_CLK_CONTROL          => \%shub_01_00517_def,
   SH_STOP_CLK_DELAY_PHASE      => \%shub_01_00518_def,
   SH_TSF_ARM_MASK              => \%shub_01_00519_def,
   SH_TSF_COUNTER_PRESETS       => \%shub_01_00520_def,
   SH_TSF_DECREMENT_CTL         => \%shub_01_00521_def,
   SH_TSF_DIAG_MSG_CTL          => \%shub_01_00522_def,
   SH_TSF_DISARM_MASK           => \%shub_01_00523_def,
   SH_TSF_ENABLE_CTL            => \%shub_01_00524_def,
   SH_TSF_SOFTWARE_ARM          => \%shub_01_00525_def,
   SH_TSF_SOFTWARE_DISARM       => \%shub_01_00526_def,
   SH_TSF_SOFTWARE_TRIGGERED    => \%shub_01_00527_def,
   SH_TSF_TRIGGER_MASK          => \%shub_01_00528_def,
   SH_VEC_DATA                  => \%shub_01_00529_def,
   SH_VEC_PARMS                 => \%shub_01_00530_def,
   SH_VEC_ROUTE                 => \%shub_01_00531_def,
   SH_CPU_PERM                  => \%shub_01_00532_def,
   SH_CPU_PERM_OVR              => \%shub_01_00533_def,
   SH_EXT_IO_PERM               => \%shub_01_00534_def,
   SH_EXT_IOI_ACCESS            => \%shub_01_00535_def,
   SH_GC_FIL_CTRL               => \%shub_01_00536_def,
   SH_GC_SRC_CTRL               => \%shub_01_00537_def,
   SH_HARD_RESET                => \%shub_01_00538_def,
   SH_IO_PERM                   => \%shub_01_00539_def,
   SH_IOI_ACCESS                => \%shub_01_00540_def,
   SH_IPI_ACCESS                => \%shub_01_00541_def,
   SH_JTAG_CONFIG               => \%shub_01_00542_def,
   SH_SHUB_ID                   => \%shub_01_00543_def,
   SH_SHUBS_PRESENT0            => \%shub_01_00544_def,
   SH_SHUBS_PRESENT1            => \%shub_01_00545_def,
   SH_SHUBS_PRESENT2            => \%shub_01_00546_def,
   SH_SHUBS_PRESENT3            => \%shub_01_00547_def,
   SH_SOFT_RESET                => \%shub_01_00548_def,
   SH_FIRST_ERROR               => \%shub_01_00549_def,
   SH_II_HW_TIME_STAMP          => \%shub_01_00550_def,
   SH_LB_HW_TIME_STAMP          => \%shub_01_00551_def,
   SH_MD_COR_TIME_STAMP         => \%shub_01_00552_def,
   SH_MD_HW_TIME_STAMP          => \%shub_01_00553_def,
   SH_MD_UNCOR_TIME_STAMP       => \%shub_01_00554_def,
   SH_PI_COR_TIME_STAMP         => \%shub_01_00555_def,
   SH_PI_HW_TIME_STAMP          => \%shub_01_00556_def,
   SH_PI_UNCOR_TIME_STAMP       => \%shub_01_00557_def,
   SH_PROC0_ADV_TIME_STAMP      => \%shub_01_00558_def,
   SH_PROC0_ERR_TIME_STAMP      => \%shub_01_00559_def,
   SH_PROC1_ADV_TIME_STAMP      => \%shub_01_00560_def,
   SH_PROC1_ERR_TIME_STAMP      => \%shub_01_00561_def,
   SH_PROC2_ADV_TIME_STAMP      => \%shub_01_00562_def,
   SH_PROC2_ERR_TIME_STAMP      => \%shub_01_00563_def,
   SH_PROC3_ADV_TIME_STAMP      => \%shub_01_00564_def,
   SH_PROC3_ERR_TIME_STAMP      => \%shub_01_00565_def,
   SH_XN_COR_TIME_STAMP         => \%shub_01_00566_def,
   SH_XN_HW_TIME_STAMP          => \%shub_01_00567_def,
   SH_XN_UNCOR_TIME_STAMP       => \%shub_01_00568_def,
   SH_DEBUG_PORT                => \%shub_01_00569_def,
   SH_II_DEBUG_DATA             => \%shub_01_00570_def,
   SH_II_WRAP_DEBUG_DATA        => \%shub_01_00571_def,
   SH_LB_DEBUG_DATA             => \%shub_01_00572_def,
   SH_MD_DEBUG_DATA             => \%shub_01_00573_def,
   SH_PI_DEBUG_DATA             => \%shub_01_00574_def,
   SH_XN_DEBUG_DATA             => \%shub_01_00575_def,
   SH_TSF_ARMED_STATE           => \%shub_01_00576_def,
   SH_TSF_COUNTER_VALUE         => \%shub_01_00577_def,
   SH_TSF_TRIGGERED_STATE       => \%shub_01_00578_def,
   SH_VEC_RDDATA                => \%shub_01_00579_def,
   SH_VEC_RETURN                => \%shub_01_00580_def,
   SH_VEC_STATUS                => \%shub_01_00581_def,
   SH_VEC_STATUS_ALIAS          => \%shub_01_00582_def,
   SH_PERFORMANCE_COUNT0_CONTROL => \%shub_01_00583_def,
   SH_PERFORMANCE_COUNT1_CONTROL => \%shub_01_00584_def,
   SH_PERFORMANCE_COUNT2_CONTROL => \%shub_01_00585_def,
   SH_PERFORMANCE_COUNT3_CONTROL => \%shub_01_00586_def,
   SH_PERFORMANCE_COUNT4_CONTROL => \%shub_01_00587_def,
   SH_PERFORMANCE_COUNT5_CONTROL => \%shub_01_00588_def,
   SH_PERFORMANCE_COUNT6_CONTROL => \%shub_01_00589_def,
   SH_PERFORMANCE_COUNT7_CONTROL => \%shub_01_00590_def,
   SH_PROFILE_DN_CONTROL        => \%shub_01_00591_def,
   SH_PROFILE_PEAK_CONTROL      => \%shub_01_00592_def,
   SH_PROFILE_RANGE             => \%shub_01_00593_def,
   SH_PROFILE_UP_CONTROL        => \%shub_01_00594_def,
   SH_PERFORMANCE_COUNTER0      => \%shub_01_00595_def,
   SH_PERFORMANCE_COUNTER1      => \%shub_01_00596_def,
   SH_PERFORMANCE_COUNTER2      => \%shub_01_00597_def,
   SH_PERFORMANCE_COUNTER3      => \%shub_01_00598_def,
   SH_PERFORMANCE_COUNTER4      => \%shub_01_00599_def,
   SH_PERFORMANCE_COUNTER5      => \%shub_01_00600_def,
   SH_PERFORMANCE_COUNTER6      => \%shub_01_00601_def,
   SH_PERFORMANCE_COUNTER7      => \%shub_01_00602_def,
   SH_PROFILE_COUNTER           => \%shub_01_00603_def,
   SH_PROFILE_PEAK              => \%shub_01_00604_def,
   SH_PTC_0                     => \%shub_01_00605_def,
   SH_PTC_1                     => \%shub_01_00606_def,
   SH_PTC_PARMS                 => \%shub_01_00607_def,
   SH_INT_CMPA                  => \%shub_01_00608_def,
   SH_INT_CMPB                  => \%shub_01_00609_def,
   SH_INT_CMPC                  => \%shub_01_00610_def,
   SH_INT_CMPD                  => \%shub_01_00611_def,
   SH_INT_PROF                  => \%shub_01_00612_def,
   SH_RTC                       => \%shub_01_00613_def,
   SH_SCRATCH0                  => \%shub_01_00614_def,
   SH_SCRATCH0_ALIAS            => \%shub_01_00615_def,
   SH_SCRATCH1                  => \%shub_01_00616_def,
   SH_SCRATCH1_ALIAS            => \%shub_01_00617_def,
   SH_SCRATCH2                  => \%shub_01_00618_def,
   SH_SCRATCH2_ALIAS            => \%shub_01_00619_def,
   SH_SCRATCH3                  => \%shub_01_00620_def,
   SH_SCRATCH3_ALIAS            => \%shub_01_00621_def,
   SH_SCRATCH4                  => \%shub_01_00622_def,
   SH_SCRATCH4_ALIAS            => \%shub_01_00623_def,
   SH_CRB_MESSAGE_CONTROL       => \%shub_01_00624_def,
   SH_CRB_NACK_LIMIT            => \%shub_01_00625_def,
   SH_CRB_TIMEOUT_PRESCALE      => \%shub_01_00626_def,
   SH_CRB_TIMEOUT_SKID          => \%shub_01_00627_def,
   SH_MEMORY_WRITE_STATUS_0     => \%shub_01_00628_def,
   SH_MEMORY_WRITE_STATUS_1     => \%shub_01_00629_def,
   SH_PIO_WRITE_STATUS_0        => \%shub_01_00630_def,
   SH_PIO_WRITE_STATUS_1        => \%shub_01_00631_def,
   SH_PIO_WRITE_STATUS_0_ALIAS  => \%shub_01_00632_def,
   SH_PIO_WRITE_STATUS_1_ALIAS  => \%shub_01_00633_def,
   SH_MEMORY_WRITE_STATUS_NON_USER_0 => \%shub_01_00634_def,
   SH_MEMORY_WRITE_STATUS_NON_USER_1 => \%shub_01_00635_def,
   SH_MMRBIST_ERR               => \%shub_01_00636_def,
   SH_MISC_ERR_HDR_LOWER        => \%shub_01_00637_def,
   SH_MISC_ERR_HDR_UPPER        => \%shub_01_00638_def,
   SH_DIR_UC_ERR_HDR_LOWER      => \%shub_01_00639_def,
   SH_DIR_UC_ERR_HDR_UPPER      => \%shub_01_00640_def,
   SH_DIR_COR_ERR_HDR_LOWER     => \%shub_01_00641_def,
   SH_DIR_COR_ERR_HDR_UPPER     => \%shub_01_00642_def,
   SH_MEM_ERROR_SUMMARY         => \%shub_01_00643_def,
   SH_MEM_ERROR_SUMMARY_ALIAS   => \%shub_01_00644_def,
   SH_MEM_ERROR_OVERFLOW        => \%shub_01_00645_def,
   SH_MEM_ERROR_OVERFLOW_ALIAS  => \%shub_01_00646_def,
   SH_MEM_ERROR_MASK            => \%shub_01_00647_def,
   SH_X_DIMM_CFG                => \%shub_01_00648_def,
   SH_Y_DIMM_CFG                => \%shub_01_00649_def,
   SH_JNR_DIMM_CFG              => \%shub_01_00650_def,
   SH_X_PHASE_CFG               => \%shub_01_00651_def,
   SH_X_CFG                     => \%shub_01_00652_def,
   SH_X_DQCT_CFG                => \%shub_01_00653_def,
   SH_X_REFRESH_CONTROL         => \%shub_01_00654_def,
   SH_Y_PHASE_CFG               => \%shub_01_00655_def,
   SH_Y_CFG                     => \%shub_01_00656_def,
   SH_Y_DQCT_CFG                => \%shub_01_00657_def,
   SH_Y_REFRESH_CONTROL         => \%shub_01_00658_def,
   SH_MEM_RED_BLACK             => \%shub_01_00659_def,
   SH_MISC_MEM_CFG              => \%shub_01_00660_def,
   SH_PIO_RQ_CRD_CTL            => \%shub_01_00661_def,
   SH_PI_MD_RQ_CRD_CTL          => \%shub_01_00662_def,
   SH_PI_MD_RP_CRD_CTL          => \%shub_01_00663_def,
   SH_XN_MD_RQ_CRD_CTL          => \%shub_01_00664_def,
   SH_XN_MD_RP_CRD_CTL          => \%shub_01_00665_def,
   SH_X_TAG0                    => \%shub_01_00666_def,
   SH_X_TAG1                    => \%shub_01_00667_def,
   SH_X_TAG2                    => \%shub_01_00668_def,
   SH_X_TAG3                    => \%shub_01_00669_def,
   SH_X_TAG4                    => \%shub_01_00670_def,
   SH_X_TAG5                    => \%shub_01_00671_def,
   SH_X_TAG6                    => \%shub_01_00672_def,
   SH_X_TAG7                    => \%shub_01_00673_def,
   SH_Y_TAG0                    => \%shub_01_00674_def,
   SH_Y_TAG1                    => \%shub_01_00675_def,
   SH_Y_TAG2                    => \%shub_01_00676_def,
   SH_Y_TAG3                    => \%shub_01_00677_def,
   SH_Y_TAG4                    => \%shub_01_00678_def,
   SH_Y_TAG5                    => \%shub_01_00679_def,
   SH_Y_TAG6                    => \%shub_01_00680_def,
   SH_Y_TAG7                    => \%shub_01_00681_def,
   SH_MMRBIST_BASE              => \%shub_01_00682_def,
   SH_MMRBIST_CTL               => \%shub_01_00683_def,
   SH_MD_DBUG_DATA_CFG          => \%shub_01_00684_def,
   SH_MD_DBUG_TRIGGER_CFG       => \%shub_01_00685_def,
   SH_MD_DBUG_COMPARE           => \%shub_01_00686_def,
   SH_X_MOD_DBUG_SEL            => \%shub_01_00687_def,
   SH_X_DBUG_SEL                => \%shub_01_00688_def,
   SH_X_LADDR_CMP               => \%shub_01_00689_def,
   SH_X_RADDR_CMP               => \%shub_01_00690_def,
   SH_X_TAG_CMP                 => \%shub_01_00691_def,
   SH_X_TAG_MASK                => \%shub_01_00692_def,
   SH_Y_MOD_DBUG_SEL            => \%shub_01_00693_def,
   SH_Y_DBUG_SEL                => \%shub_01_00694_def,
   SH_Y_LADDR_CMP               => \%shub_01_00695_def,
   SH_Y_RADDR_CMP               => \%shub_01_00696_def,
   SH_Y_TAG_CMP                 => \%shub_01_00697_def,
   SH_Y_TAG_MASK                => \%shub_01_00698_def,
   SH_MD_JNR_DBUG_DATA_CFG      => \%shub_01_00699_def,
   SH_MD_LAST_CREDIT            => \%shub_01_00700_def,
   SH_MEM_CAPTURE_ADDR          => \%shub_01_00701_def,
   SH_MEM_CAPTURE_MASK          => \%shub_01_00702_def,
   SH_MEM_CAPTURE_HDR           => \%shub_01_00703_def,
   SH_MD_DQLP_MMR_DIR_CONFIG    => \%shub_01_00704_def,
   SH_MD_DQLP_MMR_DIR_PRESVEC0  => \%shub_01_00705_def,
   SH_MD_DQLP_MMR_DIR_PRESVEC1  => \%shub_01_00706_def,
   SH_MD_DQLP_MMR_DIR_PRESVEC2  => \%shub_01_00707_def,
   SH_MD_DQLP_MMR_DIR_PRESVEC3  => \%shub_01_00708_def,
   SH_MD_DQLP_MMR_DIR_LOCVEC0   => \%shub_01_00709_def,
   SH_MD_DQLP_MMR_DIR_LOCVEC1   => \%shub_01_00710_def,
   SH_MD_DQLP_MMR_DIR_LOCVEC2   => \%shub_01_00711_def,
   SH_MD_DQLP_MMR_DIR_LOCVEC3   => \%shub_01_00712_def,
   SH_MD_DQLP_MMR_DIR_LOCVEC4   => \%shub_01_00713_def,
   SH_MD_DQLP_MMR_DIR_LOCVEC5   => \%shub_01_00714_def,
   SH_MD_DQLP_MMR_DIR_LOCVEC6   => \%shub_01_00715_def,
   SH_MD_DQLP_MMR_DIR_LOCVEC7   => \%shub_01_00716_def,
   SH_MD_DQLP_MMR_DIR_PRIVEC0   => \%shub_01_00717_def,
   SH_MD_DQLP_MMR_DIR_PRIVEC1   => \%shub_01_00718_def,
   SH_MD_DQLP_MMR_DIR_PRIVEC2   => \%shub_01_00719_def,
   SH_MD_DQLP_MMR_DIR_PRIVEC3   => \%shub_01_00720_def,
   SH_MD_DQLP_MMR_DIR_PRIVEC4   => \%shub_01_00721_def,
   SH_MD_DQLP_MMR_DIR_PRIVEC5   => \%shub_01_00722_def,
   SH_MD_DQLP_MMR_DIR_PRIVEC6   => \%shub_01_00723_def,
   SH_MD_DQLP_MMR_DIR_PRIVEC7   => \%shub_01_00724_def,
   SH_MD_DQLP_MMR_DIR_TIMER     => \%shub_01_00725_def,
   SH_MD_DQLP_MMR_PIOWD_DIR_ENTRY => \%shub_01_00726_def,
   SH_MD_DQLP_MMR_PIOWD_DIR_ECC => \%shub_01_00727_def,
   SH_MD_DQLP_MMR_XPIORD_XDIR_ENTRY => \%shub_01_00728_def,
   SH_MD_DQLP_MMR_XPIORD_XDIR_ECC => \%shub_01_00729_def,
   SH_MD_DQLP_MMR_YPIORD_YDIR_ENTRY => \%shub_01_00730_def,
   SH_MD_DQLP_MMR_YPIORD_YDIR_ECC => \%shub_01_00731_def,
   SH_MD_DQLP_MMR_XCERR1        => \%shub_01_00732_def,
   SH_MD_DQLP_MMR_XCERR2        => \%shub_01_00733_def,
   SH_MD_DQLP_MMR_XUERR1        => \%shub_01_00734_def,
   SH_MD_DQLP_MMR_XUERR2        => \%shub_01_00735_def,
   SH_MD_DQLP_MMR_XPERR         => \%shub_01_00736_def,
   SH_MD_DQLP_MMR_YCERR1        => \%shub_01_00737_def,
   SH_MD_DQLP_MMR_YCERR2        => \%shub_01_00738_def,
   SH_MD_DQLP_MMR_YUERR1        => \%shub_01_00739_def,
   SH_MD_DQLP_MMR_YUERR2        => \%shub_01_00740_def,
   SH_MD_DQLP_MMR_YPERR         => \%shub_01_00741_def,
   SH_MD_DQLP_MMR_DIR_CMDTRIG   => \%shub_01_00742_def,
   SH_MD_DQLP_MMR_DIR_TBLTRIG   => \%shub_01_00743_def,
   SH_MD_DQLP_MMR_DIR_TBLMASK   => \%shub_01_00744_def,
   SH_MD_DQLP_MMR_XBIST_H       => \%shub_01_00745_def,
   SH_MD_DQLP_MMR_XBIST_L       => \%shub_01_00746_def,
   SH_MD_DQLP_MMR_XBIST_ERR_H   => \%shub_01_00747_def,
   SH_MD_DQLP_MMR_XBIST_ERR_L   => \%shub_01_00748_def,
   SH_MD_DQLP_MMR_YBIST_H       => \%shub_01_00749_def,
   SH_MD_DQLP_MMR_YBIST_L       => \%shub_01_00750_def,
   SH_MD_DQLP_MMR_YBIST_ERR_H   => \%shub_01_00751_def,
   SH_MD_DQLP_MMR_YBIST_ERR_L   => \%shub_01_00752_def,
   SH_MD_DQLS_MMR_XBIST_H       => \%shub_01_00753_def,
   SH_MD_DQLS_MMR_XBIST_L       => \%shub_01_00754_def,
   SH_MD_DQLS_MMR_XBIST_ERR_H   => \%shub_01_00755_def,
   SH_MD_DQLS_MMR_XBIST_ERR_L   => \%shub_01_00756_def,
   SH_MD_DQLS_MMR_YBIST_H       => \%shub_01_00757_def,
   SH_MD_DQLS_MMR_YBIST_L       => \%shub_01_00758_def,
   SH_MD_DQLS_MMR_YBIST_ERR_H   => \%shub_01_00759_def,
   SH_MD_DQLS_MMR_YBIST_ERR_L   => \%shub_01_00760_def,
   SH_MD_DQLS_MMR_JNR_DEBUG     => \%shub_01_00761_def,
   SH_MD_DQLS_MMR_XAMOPW_ERR    => \%shub_01_00762_def,
   SH_MD_DQRP_MMR_DIR_CONFIG    => \%shub_01_00763_def,
   SH_MD_DQRP_MMR_DIR_PRESVEC0  => \%shub_01_00764_def,
   SH_MD_DQRP_MMR_DIR_PRESVEC1  => \%shub_01_00765_def,
   SH_MD_DQRP_MMR_DIR_PRESVEC2  => \%shub_01_00766_def,
   SH_MD_DQRP_MMR_DIR_PRESVEC3  => \%shub_01_00767_def,
   SH_MD_DQRP_MMR_DIR_LOCVEC0   => \%shub_01_00768_def,
   SH_MD_DQRP_MMR_DIR_LOCVEC1   => \%shub_01_00769_def,
   SH_MD_DQRP_MMR_DIR_LOCVEC2   => \%shub_01_00770_def,
   SH_MD_DQRP_MMR_DIR_LOCVEC3   => \%shub_01_00771_def,
   SH_MD_DQRP_MMR_DIR_LOCVEC4   => \%shub_01_00772_def,
   SH_MD_DQRP_MMR_DIR_LOCVEC5   => \%shub_01_00773_def,
   SH_MD_DQRP_MMR_DIR_LOCVEC6   => \%shub_01_00774_def,
   SH_MD_DQRP_MMR_DIR_LOCVEC7   => \%shub_01_00775_def,
   SH_MD_DQRP_MMR_DIR_PRIVEC0   => \%shub_01_00776_def,
   SH_MD_DQRP_MMR_DIR_PRIVEC1   => \%shub_01_00777_def,
   SH_MD_DQRP_MMR_DIR_PRIVEC2   => \%shub_01_00778_def,
   SH_MD_DQRP_MMR_DIR_PRIVEC3   => \%shub_01_00779_def,
   SH_MD_DQRP_MMR_DIR_PRIVEC4   => \%shub_01_00780_def,
   SH_MD_DQRP_MMR_DIR_PRIVEC5   => \%shub_01_00781_def,
   SH_MD_DQRP_MMR_DIR_PRIVEC6   => \%shub_01_00782_def,
   SH_MD_DQRP_MMR_DIR_PRIVEC7   => \%shub_01_00783_def,
   SH_MD_DQRP_MMR_DIR_TIMER     => \%shub_01_00784_def,
   SH_MD_DQRP_MMR_PIOWD_DIR_ENTRY => \%shub_01_00785_def,
   SH_MD_DQRP_MMR_PIOWD_DIR_ECC => \%shub_01_00786_def,
   SH_MD_DQRP_MMR_XPIORD_XDIR_ENTRY => \%shub_01_00787_def,
   SH_MD_DQRP_MMR_XPIORD_XDIR_ECC => \%shub_01_00788_def,
   SH_MD_DQRP_MMR_YPIORD_YDIR_ENTRY => \%shub_01_00789_def,
   SH_MD_DQRP_MMR_YPIORD_YDIR_ECC => \%shub_01_00790_def,
   SH_MD_DQRP_MMR_XCERR1        => \%shub_01_00791_def,
   SH_MD_DQRP_MMR_XCERR2        => \%shub_01_00792_def,
   SH_MD_DQRP_MMR_XUERR1        => \%shub_01_00793_def,
   SH_MD_DQRP_MMR_XUERR2        => \%shub_01_00794_def,
   SH_MD_DQRP_MMR_XPERR         => \%shub_01_00795_def,
   SH_MD_DQRP_MMR_YCERR1        => \%shub_01_00796_def,
   SH_MD_DQRP_MMR_YCERR2        => \%shub_01_00797_def,
   SH_MD_DQRP_MMR_YUERR1        => \%shub_01_00798_def,
   SH_MD_DQRP_MMR_YUERR2        => \%shub_01_00799_def,
   SH_MD_DQRP_MMR_YPERR         => \%shub_01_00800_def,
   SH_MD_DQRP_MMR_DIR_CMDTRIG   => \%shub_01_00801_def,
   SH_MD_DQRP_MMR_DIR_TBLTRIG   => \%shub_01_00802_def,
   SH_MD_DQRP_MMR_DIR_TBLMASK   => \%shub_01_00803_def,
   SH_MD_DQRP_MMR_XBIST_H       => \%shub_01_00804_def,
   SH_MD_DQRP_MMR_XBIST_L       => \%shub_01_00805_def,
   SH_MD_DQRP_MMR_XBIST_ERR_H   => \%shub_01_00806_def,
   SH_MD_DQRP_MMR_XBIST_ERR_L   => \%shub_01_00807_def,
   SH_MD_DQRP_MMR_YBIST_H       => \%shub_01_00808_def,
   SH_MD_DQRP_MMR_YBIST_L       => \%shub_01_00809_def,
   SH_MD_DQRP_MMR_YBIST_ERR_H   => \%shub_01_00810_def,
   SH_MD_DQRP_MMR_YBIST_ERR_L   => \%shub_01_00811_def,
   SH_MD_DQRS_MMR_XBIST_H       => \%shub_01_00812_def,
   SH_MD_DQRS_MMR_XBIST_L       => \%shub_01_00813_def,
   SH_MD_DQRS_MMR_XBIST_ERR_H   => \%shub_01_00814_def,
   SH_MD_DQRS_MMR_XBIST_ERR_L   => \%shub_01_00815_def,
   SH_MD_DQRS_MMR_YBIST_H       => \%shub_01_00816_def,
   SH_MD_DQRS_MMR_YBIST_L       => \%shub_01_00817_def,
   SH_MD_DQRS_MMR_YBIST_ERR_H   => \%shub_01_00818_def,
   SH_MD_DQRS_MMR_YBIST_ERR_L   => \%shub_01_00819_def,
   SH_MD_DQRS_MMR_JNR_DEBUG     => \%shub_01_00820_def,
   SH_MD_DQRS_MMR_YAMOPW_ERR    => \%shub_01_00821_def,
);

%shub_01_mmr_by_addr = 
(
   0x0000000120010000 => \%shub_01_00000_def,
   0x0000000120010080 => \%shub_01_00001_def,
   0x0000000120010100 => \%shub_01_00002_def,
   0x0000000120010180 => \%shub_01_00003_def,
   0x0000000120020000 => \%shub_01_00004_def,
   0x0000000120020080 => \%shub_01_00005_def,
   0x0000000120030000 => \%shub_01_00006_def,
   0x0000000120030080 => \%shub_01_00007_def,
   0x0000000120030100 => \%shub_01_00008_def,
   0x0000000120030180 => \%shub_01_00009_def,
   0x0000000120030200 => \%shub_01_00010_def,
   0x0000000120030280 => \%shub_01_00011_def,
   0x0000000120030300 => \%shub_01_00012_def,
   0x0000000120030380 => \%shub_01_00013_def,
   0x0000000120030400 => \%shub_01_00014_def,
   0x0000000120030480 => \%shub_01_00015_def,
   0x0000000120030500 => \%shub_01_00016_def,
   0x0000000120030580 => \%shub_01_00017_def,
   0x0000000120030600 => \%shub_01_00018_def,
   0x0000000120030680 => \%shub_01_00019_def,
   0x0000000120040000 => \%shub_01_00020_def,
   0x0000000120040080 => \%shub_01_00021_def,
   0x0000000110000000 => \%shub_01_00022_def,
   0x0000000110000080 => \%shub_01_00023_def,
   0x0000000110000200 => \%shub_01_00024_def,
   0x0000000110000100 => \%shub_01_00025_def,
   0x0000000110000180 => \%shub_01_00026_def,
   0x0000000110000280 => \%shub_01_00027_def,
   0x0000000110000300 => \%shub_01_00028_def,
   0x0000000110000380 => \%shub_01_00029_def,
   0x0000000110000400 => \%shub_01_00030_def,
   0x0000000110000480 => \%shub_01_00031_def,
   0x0000000110000500 => \%shub_01_00032_def,
   0x0000000110000580 => \%shub_01_00033_def,
   0x0000000110000600 => \%shub_01_00034_def,
   0x0000000110000680 => \%shub_01_00035_def,
   0x0000000110000700 => \%shub_01_00036_def,
   0x0000000110000780 => \%shub_01_00037_def,
   0x0000000110000800 => \%shub_01_00038_def,
   0x0000000110000880 => \%shub_01_00039_def,
   0x0000000110000900 => \%shub_01_00040_def,
   0x0000000110000980 => \%shub_01_00041_def,
   0x0000000110000A00 => \%shub_01_00042_def,
   0x0000000110000A80 => \%shub_01_00043_def,
   0x0000000110000B00 => \%shub_01_00044_def,
   0x0000000110000B80 => \%shub_01_00045_def,
   0x0000000110000C00 => \%shub_01_00046_def,
   0x0000000110000C80 => \%shub_01_00047_def,
   0x0000000110000D00 => \%shub_01_00048_def,
   0x0000000110000D80 => \%shub_01_00049_def,
   0x0000000110000E00 => \%shub_01_00050_def,
   0x0000000110000E80 => \%shub_01_00051_def,
   0x0000000110000F00 => \%shub_01_00052_def,
   0x0000000110000F80 => \%shub_01_00053_def,
   0x0000000110001000 => \%shub_01_00054_def,
   0x0000000110001080 => \%shub_01_00055_def,
   0x0000000110001100 => \%shub_01_00056_def,
   0x0000000110001180 => \%shub_01_00057_def,
   0x0000000110001200 => \%shub_01_00058_def,
   0x0000000110001280 => \%shub_01_00059_def,
   0x0000000110001300 => \%shub_01_00060_def,
   0x0000000110001380 => \%shub_01_00061_def,
   0x0000000110001400 => \%shub_01_00062_def,
   0x0000000110001480 => \%shub_01_00063_def,
   0x0000000110001500 => \%shub_01_00064_def,
   0x0000000110001580 => \%shub_01_00065_def,
   0x0000000110001600 => \%shub_01_00066_def,
   0x0000000110001680 => \%shub_01_00067_def,
   0x0000000110001700 => \%shub_01_00068_def,
   0x0000000110010000 => \%shub_01_00069_def,
   0x0000000110010008 => \%shub_01_00070_def,
   0x0000000110010080 => \%shub_01_00071_def,
   0x0000000110010088 => \%shub_01_00072_def,
   0x0000000110020000 => \%shub_01_00073_def,
   0x0000000110020080 => \%shub_01_00074_def,
   0x0000000110020100 => \%shub_01_00075_def,
   0x0000000110030000 => \%shub_01_00076_def,
   0x0000000110030080 => \%shub_01_00077_def,
   0x0000000110030100 => \%shub_01_00078_def,
   0x0000000110030180 => \%shub_01_00079_def,
   0x0000000110030200 => \%shub_01_00080_def,
   0x0000000150000000 => \%shub_01_00081_def,
   0x0000000150000008 => \%shub_01_00082_def,
   0x0000000150000010 => \%shub_01_00083_def,
   0x0000000150000018 => \%shub_01_00084_def,
   0x0000000150000020 => \%shub_01_00085_def,
   0x0000000150000028 => \%shub_01_00086_def,
   0x0000000150000030 => \%shub_01_00087_def,
   0x0000000150000038 => \%shub_01_00088_def,
   0x0000000150000040 => \%shub_01_00089_def,
   0x0000000150000048 => \%shub_01_00090_def,
   0x0000000150002000 => \%shub_01_00091_def,
   0x0000000150002008 => \%shub_01_00092_def,
   0x0000000150002010 => \%shub_01_00093_def,
   0x0000000150002018 => \%shub_01_00094_def,
   0x0000000150002020 => \%shub_01_00095_def,
   0x0000000150002028 => \%shub_01_00096_def,
   0x0000000150002030 => \%shub_01_00097_def,
   0x0000000150002038 => \%shub_01_00098_def,
   0x0000000150002040 => \%shub_01_00099_def,
   0x0000000150002048 => \%shub_01_00100_def,
   0x0000000150001010 => \%shub_01_00101_def,
   0x0000000150001020 => \%shub_01_00102_def,
   0x0000000150001030 => \%shub_01_00103_def,
   0x0000000150001040 => \%shub_01_00104_def,
   0x0000000150001050 => \%shub_01_00105_def,
   0x0000000150001060 => \%shub_01_00106_def,
   0x0000000150001070 => \%shub_01_00107_def,
   0x0000000150003010 => \%shub_01_00108_def,
   0x0000000150003020 => \%shub_01_00109_def,
   0x0000000150003030 => \%shub_01_00110_def,
   0x0000000150003040 => \%shub_01_00111_def,
   0x0000000150003050 => \%shub_01_00112_def,
   0x0000000150003060 => \%shub_01_00113_def,
   0x0000000150003070 => \%shub_01_00114_def,
   0x0000000150020000 => \%shub_01_00115_def,
   0x0000000150020400 => \%shub_01_00116_def,
   0x0000000150020480 => \%shub_01_00117_def,
   0x0000000150020488 => \%shub_01_00118_def,
   0x0000000150021000 => \%shub_01_00119_def,
   0x0000000150021400 => \%shub_01_00120_def,
   0x0000000150021480 => \%shub_01_00121_def,
   0x0000000150021488 => \%shub_01_00122_def,
   0x0000000150022000 => \%shub_01_00123_def,
   0x0000000150022400 => \%shub_01_00124_def,
   0x0000000150022480 => \%shub_01_00125_def,
   0x0000000150022488 => \%shub_01_00126_def,
   0x0000000150023000 => \%shub_01_00127_def,
   0x0000000150023400 => \%shub_01_00128_def,
   0x0000000150023480 => \%shub_01_00129_def,
   0x0000000150023488 => \%shub_01_00130_def,
   0x0000000150024000 => \%shub_01_00131_def,
   0x0000000150024400 => \%shub_01_00132_def,
   0x0000000150024480 => \%shub_01_00133_def,
   0x0000000150024488 => \%shub_01_00134_def,
   0x0000000110040000 => \%shub_01_00135_def,
   0x0000000110040080 => \%shub_01_00136_def,
   0x0000000110040100 => \%shub_01_00137_def,
   0x0000000110040180 => \%shub_01_00138_def,
   0x0000000110040200 => \%shub_01_00139_def,
   0x0000000110040280 => \%shub_01_00140_def,
   0x0000000110040300 => \%shub_01_00141_def,
   0x0000000110050000 => \%shub_01_00142_def,
   0x0000000110050080 => \%shub_01_00143_def,
   0x0000000110050100 => \%shub_01_00144_def,
   0x0000000110050180 => \%shub_01_00145_def,
   0x0000000110050200 => \%shub_01_00146_def,
   0x0000000110050280 => \%shub_01_00147_def,
   0x0000000110050300 => \%shub_01_00148_def,
   0x0000000110050380 => \%shub_01_00149_def,
   0x0000000110050400 => \%shub_01_00150_def,
   0x0000000110050480 => \%shub_01_00151_def,
   0x0000000110050500 => \%shub_01_00152_def,
   0x0000000110050508 => \%shub_01_00153_def,
   0x0000000110050580 => \%shub_01_00154_def,
   0x0000000110050588 => \%shub_01_00155_def,
   0x0000000110050600 => \%shub_01_00156_def,
   0x0000000110050680 => \%shub_01_00157_def,
   0x0000000110050700 => \%shub_01_00158_def,
   0x0000000110050780 => \%shub_01_00159_def,
   0x0000000110050800 => \%shub_01_00160_def,
   0x0000000120050000 => \%shub_01_00161_def,
   0x0000000120050080 => \%shub_01_00162_def,
   0x0000000120050100 => \%shub_01_00163_def,
   0x0000000120050180 => \%shub_01_00164_def,
   0x0000000120050200 => \%shub_01_00165_def,
   0x0000000120050280 => \%shub_01_00166_def,
   0x0000000120050300 => \%shub_01_00167_def,
   0x0000000120050380 => \%shub_01_00168_def,
   0x0000000120050400 => \%shub_01_00169_def,
   0x0000000120050480 => \%shub_01_00170_def,
   0x0000000120050500 => \%shub_01_00171_def,
   0x0000000120050580 => \%shub_01_00172_def,
   0x0000000120050600 => \%shub_01_00173_def,
   0x0000000120050680 => \%shub_01_00174_def,
   0x0000000120050700 => \%shub_01_00175_def,
   0x0000000120050780 => \%shub_01_00176_def,
   0x0000000120050800 => \%shub_01_00177_def,
   0x0000000120050880 => \%shub_01_00178_def,
   0x0000000120050900 => \%shub_01_00179_def,
   0x0000000120050980 => \%shub_01_00180_def,
   0x0000000120050A00 => \%shub_01_00181_def,
   0x0000000120050A80 => \%shub_01_00182_def,
   0x0000000120050B00 => \%shub_01_00183_def,
   0x0000000120050C00 => \%shub_01_00184_def,
   0x0000000120050B80 => \%shub_01_00185_def,
   0x0000000120050C80 => \%shub_01_00186_def,
   0x0000000120050D00 => \%shub_01_00187_def,
   0x0000000120050D80 => \%shub_01_00188_def,
   0x0000000120050E00 => \%shub_01_00189_def,
   0x0000000120050E80 => \%shub_01_00190_def,
   0x0000000120050F00 => \%shub_01_00191_def,
   0x0000000120050F80 => \%shub_01_00192_def,
   0x0000000120051000 => \%shub_01_00193_def,
   0x0000000120051080 => \%shub_01_00194_def,
   0x0000000120060000 => \%shub_01_00195_def,
   0x0000000120060080 => \%shub_01_00196_def,
   0x0000000120060100 => \%shub_01_00197_def,
   0x0000000120060180 => \%shub_01_00198_def,
   0x0000000120060200 => \%shub_01_00199_def,
   0x0000000120060280 => \%shub_01_00200_def,
   0x0000000120060300 => \%shub_01_00201_def,
   0x0000000120060380 => \%shub_01_00202_def,
   0x0000000120060400 => \%shub_01_00203_def,
   0x0000000120060480 => \%shub_01_00204_def,
   0x0000000120060500 => \%shub_01_00205_def,
   0x0000000120060580 => \%shub_01_00206_def,
   0x0000000120060600 => \%shub_01_00207_def,
   0x0000000120060608 => \%shub_01_00208_def,
   0x0000000120060680 => \%shub_01_00209_def,
   0x0000000120060688 => \%shub_01_00210_def,
   0x0000000120060700 => \%shub_01_00211_def,
   0x0000000120060780 => \%shub_01_00212_def,
   0x0000000120060788 => \%shub_01_00213_def,
   0x0000000120060900 => \%shub_01_00214_def,
   0x0000000120060980 => \%shub_01_00215_def,
   0x0000000120060A00 => \%shub_01_00216_def,
   0x0000000120060A80 => \%shub_01_00217_def,
   0x0000000120060B00 => \%shub_01_00218_def,
   0x0000000120060B80 => \%shub_01_00219_def,
   0x0000000120060C00 => \%shub_01_00220_def,
   0x0000000120060C80 => \%shub_01_00221_def,
   0x0000000120060800 => \%shub_01_00222_def,
   0x0000000120060880 => \%shub_01_00223_def,
   0x0000000120060D00 => \%shub_01_00224_def,
   0x0000000120060D80 => \%shub_01_00225_def,
   0x0000000150030000 => \%shub_01_00226_def,
   0x0000000150030010 => \%shub_01_00227_def,
   0x0000000150030020 => \%shub_01_00228_def,
   0x0000000150030030 => \%shub_01_00229_def,
   0x0000000150030040 => \%shub_01_00230_def,
   0x0000000150030050 => \%shub_01_00231_def,
   0x0000000150030060 => \%shub_01_00232_def,
   0x0000000150030100 => \%shub_01_00233_def,
   0x0000000150030110 => \%shub_01_00234_def,
   0x0000000150030120 => \%shub_01_00235_def,
   0x0000000150030130 => \%shub_01_00236_def,
   0x0000000150030140 => \%shub_01_00237_def,
   0x0000000150030150 => \%shub_01_00238_def,
   0x0000000150030160 => \%shub_01_00239_def,
   0x0000000150030200 => \%shub_01_00240_def,
   0x0000000150030210 => \%shub_01_00241_def,
   0x0000000150030220 => \%shub_01_00242_def,
   0x0000000150030230 => \%shub_01_00243_def,
   0x0000000150030240 => \%shub_01_00244_def,
   0x0000000150030250 => \%shub_01_00245_def,
   0x0000000150030260 => \%shub_01_00246_def,
   0x0000000150030270 => \%shub_01_00247_def,
   0x0000000150030280 => \%shub_01_00248_def,
   0x0000000150030290 => \%shub_01_00249_def,
   0x00000001500302A0 => \%shub_01_00250_def,
   0x00000001500302B0 => \%shub_01_00251_def,
   0x0000000150030300 => \%shub_01_00252_def,
   0x0000000150030310 => \%shub_01_00253_def,
   0x0000000150030320 => \%shub_01_00254_def,
   0x0000000150030330 => \%shub_01_00255_def,
   0x0000000150030340 => \%shub_01_00256_def,
   0x0000000150030350 => \%shub_01_00257_def,
   0x0000000150030360 => \%shub_01_00258_def,
   0x0000000150030370 => \%shub_01_00259_def,
   0x0000000150030380 => \%shub_01_00260_def,
   0x0000000150030390 => \%shub_01_00261_def,
   0x00000001500303A0 => \%shub_01_00262_def,
   0x00000001500303B0 => \%shub_01_00263_def,
   0x00000001500303C0 => \%shub_01_00264_def,
   0x00000001500303D0 => \%shub_01_00265_def,
   0x00000001500303E0 => \%shub_01_00266_def,
   0x00000001500303F0 => \%shub_01_00267_def,
   0x0000000150030400 => \%shub_01_00268_def,
   0x0000000150030500 => \%shub_01_00269_def,
   0x0000000150030510 => \%shub_01_00270_def,
   0x0000000150030520 => \%shub_01_00271_def,
   0x0000000150030530 => \%shub_01_00272_def,
   0x0000000150030540 => \%shub_01_00273_def,
   0x0000000150030550 => \%shub_01_00274_def,
   0x0000000150030560 => \%shub_01_00275_def,
   0x0000000150030570 => \%shub_01_00276_def,
   0x0000000150030580 => \%shub_01_00277_def,
   0x0000000150030590 => \%shub_01_00278_def,
   0x00000001500305A0 => \%shub_01_00279_def,
   0x00000001500305B0 => \%shub_01_00280_def,
   0x00000001500305C0 => \%shub_01_00281_def,
   0x00000001500305D0 => \%shub_01_00282_def,
   0x00000001500305E0 => \%shub_01_00283_def,
   0x00000001500305F0 => \%shub_01_00284_def,
   0x0000000150030600 => \%shub_01_00285_def,
   0x0000000150031000 => \%shub_01_00286_def,
   0x0000000150031020 => \%shub_01_00287_def,
   0x0000000150031040 => \%shub_01_00288_def,
   0x0000000150031050 => \%shub_01_00289_def,
   0x0000000150031060 => \%shub_01_00290_def,
   0x00000001500310A0 => \%shub_01_00291_def,
   0x0000000150031080 => \%shub_01_00292_def,
   0x00000001500310C0 => \%shub_01_00293_def,
   0x00000001500310E0 => \%shub_01_00294_def,
   0x0000000150031100 => \%shub_01_00295_def,
   0x0000000150031110 => \%shub_01_00296_def,
   0x0000000150031120 => \%shub_01_00297_def,
   0x0000000150031130 => \%shub_01_00298_def,
   0x0000000150031140 => \%shub_01_00299_def,
   0x0000000150031150 => \%shub_01_00300_def,
   0x0000000150031160 => \%shub_01_00301_def,
   0x0000000150031170 => \%shub_01_00302_def,
   0x0000000150031180 => \%shub_01_00303_def,
   0x0000000150031190 => \%shub_01_00304_def,
   0x00000001500311A0 => \%shub_01_00305_def,
   0x00000001500311B0 => \%shub_01_00306_def,
   0x00000001500311C0 => \%shub_01_00307_def,
   0x00000001500311D0 => \%shub_01_00308_def,
   0x00000001500311E0 => \%shub_01_00309_def,
   0x00000001500311F0 => \%shub_01_00310_def,
   0x0000000150031200 => \%shub_01_00311_def,
   0x0000000150031210 => \%shub_01_00312_def,
   0x0000000150031220 => \%shub_01_00313_def,
   0x0000000150031230 => \%shub_01_00314_def,
   0x0000000150031240 => \%shub_01_00315_def,
   0x0000000150031250 => \%shub_01_00316_def,
   0x0000000150031260 => \%shub_01_00317_def,
   0x0000000150031270 => \%shub_01_00318_def,
   0x0000000150031500 => \%shub_01_00319_def,
   0x0000000150031510 => \%shub_01_00320_def,
   0x0000000150031520 => \%shub_01_00321_def,
   0x0000000150031530 => \%shub_01_00322_def,
   0x0000000150031540 => \%shub_01_00323_def,
   0x0000000150031550 => \%shub_01_00324_def,
   0x0000000150031560 => \%shub_01_00325_def,
   0x0000000150031570 => \%shub_01_00326_def,
   0x0000000150031580 => \%shub_01_00327_def,
   0x0000000150031590 => \%shub_01_00328_def,
   0x00000001500315A0 => \%shub_01_00329_def,
   0x00000001500315B0 => \%shub_01_00330_def,
   0x00000001500315C0 => \%shub_01_00331_def,
   0x00000001500315D0 => \%shub_01_00332_def,
   0x00000001500315E0 => \%shub_01_00333_def,
   0x00000001500315F0 => \%shub_01_00334_def,
   0x0000000150031600 => \%shub_01_00335_def,
   0x0000000150031610 => \%shub_01_00336_def,
   0x0000000150031620 => \%shub_01_00337_def,
   0x0000000150031630 => \%shub_01_00338_def,
   0x0000000150031640 => \%shub_01_00339_def,
   0x0000000150031650 => \%shub_01_00340_def,
   0x0000000150031660 => \%shub_01_00341_def,
   0x0000000150031670 => \%shub_01_00342_def,
   0x0000000150031300 => \%shub_01_00343_def,
   0x0000000150031310 => \%shub_01_00344_def,
   0x0000000150031320 => \%shub_01_00345_def,
   0x0000000150031330 => \%shub_01_00346_def,
   0x0000000150031340 => \%shub_01_00347_def,
   0x0000000150031350 => \%shub_01_00348_def,
   0x0000000150031360 => \%shub_01_00349_def,
   0x0000000150031370 => \%shub_01_00350_def,
   0x0000000150031380 => \%shub_01_00351_def,
   0x0000000150031390 => \%shub_01_00352_def,
   0x00000001500313A0 => \%shub_01_00353_def,
   0x00000001500313B0 => \%shub_01_00354_def,
   0x00000001500313C0 => \%shub_01_00355_def,
   0x00000001500313D0 => \%shub_01_00356_def,
   0x00000001500313E0 => \%shub_01_00357_def,
   0x00000001500313F0 => \%shub_01_00358_def,
   0x0000000150031400 => \%shub_01_00359_def,
   0x0000000150031410 => \%shub_01_00360_def,
   0x0000000150031420 => \%shub_01_00361_def,
   0x0000000150031430 => \%shub_01_00362_def,
   0x0000000150031440 => \%shub_01_00363_def,
   0x0000000150031450 => \%shub_01_00364_def,
   0x0000000150031460 => \%shub_01_00365_def,
   0x0000000150031470 => \%shub_01_00366_def,
   0x0000000150031700 => \%shub_01_00367_def,
   0x0000000150031710 => \%shub_01_00368_def,
   0x0000000150031720 => \%shub_01_00369_def,
   0x0000000150031730 => \%shub_01_00370_def,
   0x0000000150031740 => \%shub_01_00371_def,
   0x0000000150031750 => \%shub_01_00372_def,
   0x0000000150031760 => \%shub_01_00373_def,
   0x0000000150031770 => \%shub_01_00374_def,
   0x0000000150031780 => \%shub_01_00375_def,
   0x0000000150031790 => \%shub_01_00376_def,
   0x00000001500317A0 => \%shub_01_00377_def,
   0x00000001500317B0 => \%shub_01_00378_def,
   0x00000001500317C0 => \%shub_01_00379_def,
   0x00000001500317D0 => \%shub_01_00380_def,
   0x00000001500317E0 => \%shub_01_00381_def,
   0x00000001500317F0 => \%shub_01_00382_def,
   0x0000000150031800 => \%shub_01_00383_def,
   0x0000000150031810 => \%shub_01_00384_def,
   0x0000000150031820 => \%shub_01_00385_def,
   0x0000000150031830 => \%shub_01_00386_def,
   0x0000000150031900 => \%shub_01_00387_def,
   0x0000000150031910 => \%shub_01_00388_def,
   0x0000000150031920 => \%shub_01_00389_def,
   0x0000000150031930 => \%shub_01_00390_def,
   0x0000000150031940 => \%shub_01_00391_def,
   0x0000000150031950 => \%shub_01_00392_def,
   0x0000000150031960 => \%shub_01_00393_def,
   0x0000000150031970 => \%shub_01_00394_def,
   0x0000000150031980 => \%shub_01_00395_def,
   0x0000000150031990 => \%shub_01_00396_def,
   0x00000001500319A0 => \%shub_01_00397_def,
   0x00000001500319B0 => \%shub_01_00398_def,
   0x00000001500319C0 => \%shub_01_00399_def,
   0x00000001500319D0 => \%shub_01_00400_def,
   0x00000001500319E0 => \%shub_01_00401_def,
   0x00000001500319F0 => \%shub_01_00402_def,
   0x0000000150031A00 => \%shub_01_00403_def,
   0x0000000150031A10 => \%shub_01_00404_def,
   0x0000000150031A20 => \%shub_01_00405_def,
   0x0000000150031A30 => \%shub_01_00406_def,
   0x0000000150032000 => \%shub_01_00407_def,
   0x0000000150032008 => \%shub_01_00408_def,
   0x0000000150032010 => \%shub_01_00409_def,
   0x0000000150032018 => \%shub_01_00410_def,
   0x0000000150032020 => \%shub_01_00411_def,
   0x0000000150032030 => \%shub_01_00412_def,
   0x0000000150032038 => \%shub_01_00413_def,
   0x0000000150032040 => \%shub_01_00414_def,
   0x0000000150032048 => \%shub_01_00415_def,
   0x0000000150032050 => \%shub_01_00416_def,
   0x0000000150032058 => \%shub_01_00417_def,
   0x0000000150040500 => \%shub_01_00418_def,
   0x0000000150040508 => \%shub_01_00419_def,
   0x0000000150040510 => \%shub_01_00420_def,
   0x0000000150040518 => \%shub_01_00421_def,
   0x0000000150040520 => \%shub_01_00422_def,
   0x0000000150040528 => \%shub_01_00423_def,
   0x0000000150040530 => \%shub_01_00424_def,
   0x0000000150040538 => \%shub_01_00425_def,
   0x0000000150040540 => \%shub_01_00426_def,
   0x0000000150040550 => \%shub_01_00427_def,
   0x0000000150040560 => \%shub_01_00428_def,
   0x0000000150040570 => \%shub_01_00429_def,
   0x0000000150040580 => \%shub_01_00430_def,
   0x0000000150040590 => \%shub_01_00431_def,
   0x0000000150040600 => \%shub_01_00432_def,
   0x0000000150040608 => \%shub_01_00433_def,
   0x0000000150040610 => \%shub_01_00434_def,
   0x0000000150040618 => \%shub_01_00435_def,
   0x0000000150040620 => \%shub_01_00436_def,
   0x0000000150040628 => \%shub_01_00437_def,
   0x0000000150040630 => \%shub_01_00438_def,
   0x0000000150040638 => \%shub_01_00439_def,
   0x0000000150040640 => \%shub_01_00440_def,
   0x0000000150040650 => \%shub_01_00441_def,
   0x0000000150040660 => \%shub_01_00442_def,
   0x0000000150040670 => \%shub_01_00443_def,
   0x0000000150040680 => \%shub_01_00444_def,
   0x0000000150040690 => \%shub_01_00445_def,
   0x0000000150040070 => \%shub_01_00446_def,
   0x0000000150040080 => \%shub_01_00447_def,
   0x0000000150040090 => \%shub_01_00448_def,
   0x00000001500400A0 => \%shub_01_00449_def,
   0x00000001500400B0 => \%shub_01_00450_def,
   0x00000001500400C0 => \%shub_01_00451_def,
   0x00000001500400D0 => \%shub_01_00452_def,
   0x00000001500400E0 => \%shub_01_00453_def,
   0x00000001500400F0 => \%shub_01_00454_def,
   0x0000000150040100 => \%shub_01_00455_def,
   0x0000000150040110 => \%shub_01_00456_def,
   0x0000000150040120 => \%shub_01_00457_def,
   0x0000000150040130 => \%shub_01_00458_def,
   0x0000000150040140 => \%shub_01_00459_def,
   0x0000000150040150 => \%shub_01_00460_def,
   0x0000000150040000 => \%shub_01_00461_def,
   0x0000000150040008 => \%shub_01_00462_def,
   0x0000000150040020 => \%shub_01_00463_def,
   0x0000000150040028 => \%shub_01_00464_def,
   0x0000000150040040 => \%shub_01_00465_def,
   0x0000000150040060 => \%shub_01_00466_def,
   0x0000000150040200 => \%shub_01_00467_def,
   0x0000000150040208 => \%shub_01_00468_def,
   0x0000000150040220 => \%shub_01_00469_def,
   0x0000000150040228 => \%shub_01_00470_def,
   0x0000000150040240 => \%shub_01_00471_def,
   0x0000000150040260 => \%shub_01_00472_def,
   0x0000000150040300 => \%shub_01_00473_def,
   0x0000000150040308 => \%shub_01_00474_def,
   0x0000000150040320 => \%shub_01_00475_def,
   0x0000000150040328 => \%shub_01_00476_def,
   0x0000000150040340 => \%shub_01_00477_def,
   0x0000000150040360 => \%shub_01_00478_def,
   0x0000000150040400 => \%shub_01_00479_def,
   0x0000000150040408 => \%shub_01_00480_def,
   0x0000000150040420 => \%shub_01_00481_def,
   0x0000000150040428 => \%shub_01_00482_def,
   0x0000000150040440 => \%shub_01_00483_def,
   0x0000000150040460 => \%shub_01_00484_def,
   0x0000000110061000 => \%shub_01_00485_def,
   0x0000000110061080 => \%shub_01_00486_def,
   0x0000000110061100 => \%shub_01_00487_def,
   0x0000000110061180 => \%shub_01_00488_def,
   0x0000000110061200 => \%shub_01_00489_def,
   0x0000000110061280 => \%shub_01_00490_def,
   0x0000000110061300 => \%shub_01_00491_def,
   0x0000000110062000 => \%shub_01_00492_def,
   0x0000000110062080 => \%shub_01_00493_def,
   0x0000000110062100 => \%shub_01_00494_def,
   0x0000000110062180 => \%shub_01_00495_def,
   0x0000000110062200 => \%shub_01_00496_def,
   0x0000000110062280 => \%shub_01_00497_def,
   0x0000000110062300 => \%shub_01_00498_def,
   0x0000000110062380 => \%shub_01_00499_def,
   0x0000000110062400 => \%shub_01_00500_def,
   0x0000000110062480 => \%shub_01_00501_def,
   0x0000000110062500 => \%shub_01_00502_def,
   0x0000000110062580 => \%shub_01_00503_def,
   0x0000000110062600 => \%shub_01_00504_def,
   0x0000000110062680 => \%shub_01_00505_def,
   0x0000000110062700 => \%shub_01_00506_def,
   0x0000000110062780 => \%shub_01_00507_def,
   0x0000000110062800 => \%shub_01_00508_def,
   0x0000000110062880 => \%shub_01_00509_def,
   0x0000000110062900 => \%shub_01_00510_def,
   0x0000000110062980 => \%shub_01_00511_def,
   0x0000000110062A00 => \%shub_01_00512_def,
   0x0000000110063000 => \%shub_01_00513_def,
   0x0000000110063080 => \%shub_01_00514_def,
   0x0000000110063100 => \%shub_01_00515_def,
   0x0000000110063180 => \%shub_01_00516_def,
   0x0000000110064000 => \%shub_01_00517_def,
   0x0000000110064080 => \%shub_01_00518_def,
   0x0000000110065000 => \%shub_01_00519_def,
   0x0000000110065080 => \%shub_01_00520_def,
   0x0000000110065100 => \%shub_01_00521_def,
   0x0000000110065180 => \%shub_01_00522_def,
   0x0000000110065200 => \%shub_01_00523_def,
   0x0000000110065280 => \%shub_01_00524_def,
   0x0000000110065300 => \%shub_01_00525_def,
   0x0000000110065380 => \%shub_01_00526_def,
   0x0000000110065400 => \%shub_01_00527_def,
   0x0000000110065480 => \%shub_01_00528_def,
   0x0000000110066000 => \%shub_01_00529_def,
   0x0000000110066080 => \%shub_01_00530_def,
   0x0000000110066100 => \%shub_01_00531_def,
   0x0000000110060000 => \%shub_01_00532_def,
   0x0000000110060080 => \%shub_01_00533_def,
   0x0000000110060100 => \%shub_01_00534_def,
   0x0000000110060180 => \%shub_01_00535_def,
   0x0000000110060200 => \%shub_01_00536_def,
   0x0000000110060280 => \%shub_01_00537_def,
   0x0000000110060300 => \%shub_01_00538_def,
   0x0000000110060380 => \%shub_01_00539_def,
   0x0000000110060400 => \%shub_01_00540_def,
   0x0000000110060480 => \%shub_01_00541_def,
   0x0000000110060500 => \%shub_01_00542_def,
   0x0000000110060580 => \%shub_01_00543_def,
   0x0000000110060600 => \%shub_01_00544_def,
   0x0000000110060680 => \%shub_01_00545_def,
   0x0000000110060700 => \%shub_01_00546_def,
   0x0000000110060780 => \%shub_01_00547_def,
   0x0000000110060800 => \%shub_01_00548_def,
   0x0000000110071000 => \%shub_01_00549_def,
   0x0000000110071080 => \%shub_01_00550_def,
   0x0000000110071100 => \%shub_01_00551_def,
   0x0000000110071180 => \%shub_01_00552_def,
   0x0000000110071200 => \%shub_01_00553_def,
   0x0000000110071280 => \%shub_01_00554_def,
   0x0000000110071300 => \%shub_01_00555_def,
   0x0000000110071380 => \%shub_01_00556_def,
   0x0000000110071400 => \%shub_01_00557_def,
   0x0000000110071480 => \%shub_01_00558_def,
   0x0000000110071500 => \%shub_01_00559_def,
   0x0000000110071580 => \%shub_01_00560_def,
   0x0000000110071600 => \%shub_01_00561_def,
   0x0000000110071680 => \%shub_01_00562_def,
   0x0000000110071700 => \%shub_01_00563_def,
   0x0000000110071780 => \%shub_01_00564_def,
   0x0000000110071800 => \%shub_01_00565_def,
   0x0000000110071880 => \%shub_01_00566_def,
   0x0000000110071900 => \%shub_01_00567_def,
   0x0000000110071980 => \%shub_01_00568_def,
   0x0000000110072000 => \%shub_01_00569_def,
   0x0000000110072080 => \%shub_01_00570_def,
   0x0000000110072100 => \%shub_01_00571_def,
   0x0000000110072180 => \%shub_01_00572_def,
   0x0000000110072200 => \%shub_01_00573_def,
   0x0000000110072280 => \%shub_01_00574_def,
   0x0000000110072300 => \%shub_01_00575_def,
   0x0000000110073000 => \%shub_01_00576_def,
   0x0000000110073080 => \%shub_01_00577_def,
   0x0000000110073100 => \%shub_01_00578_def,
   0x0000000110074000 => \%shub_01_00579_def,
   0x0000000110074080 => \%shub_01_00580_def,
   0x0000000110074100 => \%shub_01_00581_def,
   0x0000000110074108 => \%shub_01_00582_def,
   0x0000000110080000 => \%shub_01_00583_def,
   0x0000000110090000 => \%shub_01_00584_def,
   0x00000001100A0000 => \%shub_01_00585_def,
   0x00000001100B0000 => \%shub_01_00586_def,
   0x00000001100C0000 => \%shub_01_00587_def,
   0x00000001100D0000 => \%shub_01_00588_def,
   0x00000001100E0000 => \%shub_01_00589_def,
   0x00000001100F0000 => \%shub_01_00590_def,
   0x0000000110100000 => \%shub_01_00591_def,
   0x0000000110100080 => \%shub_01_00592_def,
   0x0000000110100100 => \%shub_01_00593_def,
   0x0000000110100180 => \%shub_01_00594_def,
   0x0000000110110000 => \%shub_01_00595_def,
   0x0000000110120000 => \%shub_01_00596_def,
   0x0000000110130000 => \%shub_01_00597_def,
   0x0000000110140000 => \%shub_01_00598_def,
   0x0000000110150000 => \%shub_01_00599_def,
   0x0000000110160000 => \%shub_01_00600_def,
   0x0000000110170000 => \%shub_01_00601_def,
   0x0000000110180000 => \%shub_01_00602_def,
   0x0000000110190000 => \%shub_01_00603_def,
   0x0000000110190080 => \%shub_01_00604_def,
   0x00000001101A0000 => \%shub_01_00605_def,
   0x00000001101A0080 => \%shub_01_00606_def,
   0x00000001101A0100 => \%shub_01_00607_def,
   0x00000001101B0000 => \%shub_01_00608_def,
   0x00000001101B0080 => \%shub_01_00609_def,
   0x00000001101B0100 => \%shub_01_00610_def,
   0x00000001101B0180 => \%shub_01_00611_def,
   0x00000001101B0200 => \%shub_01_00612_def,
   0x00000001101C0000 => \%shub_01_00613_def,
   0x00000001101D0000 => \%shub_01_00614_def,
   0x00000001101D0008 => \%shub_01_00615_def,
   0x00000001101D0080 => \%shub_01_00616_def,
   0x00000001101D0088 => \%shub_01_00617_def,
   0x00000001101D0100 => \%shub_01_00618_def,
   0x00000001101D0108 => \%shub_01_00619_def,
   0x00000001101D0180 => \%shub_01_00620_def,
   0x00000001101D0188 => \%shub_01_00621_def,
   0x00000001101D0200 => \%shub_01_00622_def,
   0x00000001101D0208 => \%shub_01_00623_def,
   0x0000000120000000 => \%shub_01_00624_def,
   0x0000000120000080 => \%shub_01_00625_def,
   0x0000000120000100 => \%shub_01_00626_def,
   0x0000000120000180 => \%shub_01_00627_def,
   0x0000000120070000 => \%shub_01_00628_def,
   0x0000000120070080 => \%shub_01_00629_def,
   0x0000000120070200 => \%shub_01_00630_def,
   0x0000000120070280 => \%shub_01_00631_def,
   0x0000000120070208 => \%shub_01_00632_def,
   0x0000000120070288 => \%shub_01_00633_def,
   0x0000000120070400 => \%shub_01_00634_def,
   0x0000000120070480 => \%shub_01_00635_def,
   0x0000000100000080 => \%shub_01_00636_def,
   0x0000000100000088 => \%shub_01_00637_def,
   0x0000000100000090 => \%shub_01_00638_def,
   0x0000000100000098 => \%shub_01_00639_def,
   0x00000001000000A0 => \%shub_01_00640_def,
   0x00000001000000A8 => \%shub_01_00641_def,
   0x00000001000000B0 => \%shub_01_00642_def,
   0x00000001000000B8 => \%shub_01_00643_def,
   0x00000001000000C0 => \%shub_01_00644_def,
   0x00000001000000C8 => \%shub_01_00645_def,
   0x00000001000000D0 => \%shub_01_00646_def,
   0x00000001000000D8 => \%shub_01_00647_def,
   0x0000000100010000 => \%shub_01_00648_def,
   0x0000000100010008 => \%shub_01_00649_def,
   0x0000000100010010 => \%shub_01_00650_def,
   0x0000000100010018 => \%shub_01_00651_def,
   0x0000000100010020 => \%shub_01_00652_def,
   0x0000000100010028 => \%shub_01_00653_def,
   0x0000000100010030 => \%shub_01_00654_def,
   0x0000000100010038 => \%shub_01_00655_def,
   0x0000000100010040 => \%shub_01_00656_def,
   0x0000000100010048 => \%shub_01_00657_def,
   0x0000000100010050 => \%shub_01_00658_def,
   0x0000000100010058 => \%shub_01_00659_def,
   0x0000000100010060 => \%shub_01_00660_def,
   0x0000000100010068 => \%shub_01_00661_def,
   0x0000000100010070 => \%shub_01_00662_def,
   0x0000000100010078 => \%shub_01_00663_def,
   0x0000000100010080 => \%shub_01_00664_def,
   0x0000000100010088 => \%shub_01_00665_def,
   0x0000000100020000 => \%shub_01_00666_def,
   0x0000000100020008 => \%shub_01_00667_def,
   0x0000000100020010 => \%shub_01_00668_def,
   0x0000000100020018 => \%shub_01_00669_def,
   0x0000000100020020 => \%shub_01_00670_def,
   0x0000000100020028 => \%shub_01_00671_def,
   0x0000000100020030 => \%shub_01_00672_def,
   0x0000000100020038 => \%shub_01_00673_def,
   0x0000000100020040 => \%shub_01_00674_def,
   0x0000000100020048 => \%shub_01_00675_def,
   0x0000000100020050 => \%shub_01_00676_def,
   0x0000000100020058 => \%shub_01_00677_def,
   0x0000000100020060 => \%shub_01_00678_def,
   0x0000000100020068 => \%shub_01_00679_def,
   0x0000000100020070 => \%shub_01_00680_def,
   0x0000000100020078 => \%shub_01_00681_def,
   0x0000000100020080 => \%shub_01_00682_def,
   0x0000000100020088 => \%shub_01_00683_def,
   0x0000000100020100 => \%shub_01_00684_def,
   0x0000000100020108 => \%shub_01_00685_def,
   0x0000000100020110 => \%shub_01_00686_def,
   0x0000000100020118 => \%shub_01_00687_def,
   0x0000000100020120 => \%shub_01_00688_def,
   0x0000000100020128 => \%shub_01_00689_def,
   0x0000000100020130 => \%shub_01_00690_def,
   0x0000000100020138 => \%shub_01_00691_def,
   0x0000000100020140 => \%shub_01_00692_def,
   0x0000000100020148 => \%shub_01_00693_def,
   0x0000000100020150 => \%shub_01_00694_def,
   0x0000000100020158 => \%shub_01_00695_def,
   0x0000000100020160 => \%shub_01_00696_def,
   0x0000000100020168 => \%shub_01_00697_def,
   0x0000000100020170 => \%shub_01_00698_def,
   0x0000000100020178 => \%shub_01_00699_def,
   0x0000000100020180 => \%shub_01_00700_def,
   0x0000000100020300 => \%shub_01_00701_def,
   0x0000000100020308 => \%shub_01_00702_def,
   0x0000000100020310 => \%shub_01_00703_def,
   0x0000000100030000 => \%shub_01_00704_def,
   0x0000000100030100 => \%shub_01_00705_def,
   0x0000000100030110 => \%shub_01_00706_def,
   0x0000000100030120 => \%shub_01_00707_def,
   0x0000000100030130 => \%shub_01_00708_def,
   0x0000000100030200 => \%shub_01_00709_def,
   0x0000000100030210 => \%shub_01_00710_def,
   0x0000000100030220 => \%shub_01_00711_def,
   0x0000000100030230 => \%shub_01_00712_def,
   0x0000000100030240 => \%shub_01_00713_def,
   0x0000000100030250 => \%shub_01_00714_def,
   0x0000000100030260 => \%shub_01_00715_def,
   0x0000000100030270 => \%shub_01_00716_def,
   0x0000000100030300 => \%shub_01_00717_def,
   0x0000000100030310 => \%shub_01_00718_def,
   0x0000000100030320 => \%shub_01_00719_def,
   0x0000000100030330 => \%shub_01_00720_def,
   0x0000000100030340 => \%shub_01_00721_def,
   0x0000000100030350 => \%shub_01_00722_def,
   0x0000000100030360 => \%shub_01_00723_def,
   0x0000000100030370 => \%shub_01_00724_def,
   0x0000000100030400 => \%shub_01_00725_def,
   0x0000000100031000 => \%shub_01_00726_def,
   0x0000000100031010 => \%shub_01_00727_def,
   0x0000000100032000 => \%shub_01_00728_def,
   0x0000000100032010 => \%shub_01_00729_def,
   0x0000000100032800 => \%shub_01_00730_def,
   0x0000000100032810 => \%shub_01_00731_def,
   0x0000000100033000 => \%shub_01_00732_def,
   0x0000000100033010 => \%shub_01_00733_def,
   0x0000000100033020 => \%shub_01_00734_def,
   0x0000000100033030 => \%shub_01_00735_def,
   0x0000000100033040 => \%shub_01_00736_def,
   0x0000000100033800 => \%shub_01_00737_def,
   0x0000000100033810 => \%shub_01_00738_def,
   0x0000000100033820 => \%shub_01_00739_def,
   0x0000000100033830 => \%shub_01_00740_def,
   0x0000000100033840 => \%shub_01_00741_def,
   0x0000000100034000 => \%shub_01_00742_def,
   0x0000000100034010 => \%shub_01_00743_def,
   0x0000000100034020 => \%shub_01_00744_def,
   0x0000000100038000 => \%shub_01_00745_def,
   0x0000000100038010 => \%shub_01_00746_def,
   0x0000000100038020 => \%shub_01_00747_def,
   0x0000000100038030 => \%shub_01_00748_def,
   0x0000000100038800 => \%shub_01_00749_def,
   0x0000000100038810 => \%shub_01_00750_def,
   0x0000000100038820 => \%shub_01_00751_def,
   0x0000000100038830 => \%shub_01_00752_def,
   0x0000000100048000 => \%shub_01_00753_def,
   0x0000000100048010 => \%shub_01_00754_def,
   0x0000000100048020 => \%shub_01_00755_def,
   0x0000000100048030 => \%shub_01_00756_def,
   0x0000000100048800 => \%shub_01_00757_def,
   0x0000000100048810 => \%shub_01_00758_def,
   0x0000000100048820 => \%shub_01_00759_def,
   0x0000000100048830 => \%shub_01_00760_def,
   0x0000000100049000 => \%shub_01_00761_def,
   0x000000010004A000 => \%shub_01_00762_def,
   0x0000000100050000 => \%shub_01_00763_def,
   0x0000000100050100 => \%shub_01_00764_def,
   0x0000000100050110 => \%shub_01_00765_def,
   0x0000000100050120 => \%shub_01_00766_def,
   0x0000000100050130 => \%shub_01_00767_def,
   0x0000000100050200 => \%shub_01_00768_def,
   0x0000000100050210 => \%shub_01_00769_def,
   0x0000000100050220 => \%shub_01_00770_def,
   0x0000000100050230 => \%shub_01_00771_def,
   0x0000000100050240 => \%shub_01_00772_def,
   0x0000000100050250 => \%shub_01_00773_def,
   0x0000000100050260 => \%shub_01_00774_def,
   0x0000000100050270 => \%shub_01_00775_def,
   0x0000000100050300 => \%shub_01_00776_def,
   0x0000000100050310 => \%shub_01_00777_def,
   0x0000000100050320 => \%shub_01_00778_def,
   0x0000000100050330 => \%shub_01_00779_def,
   0x0000000100050340 => \%shub_01_00780_def,
   0x0000000100050350 => \%shub_01_00781_def,
   0x0000000100050360 => \%shub_01_00782_def,
   0x0000000100050370 => \%shub_01_00783_def,
   0x0000000100050400 => \%shub_01_00784_def,
   0x0000000100051000 => \%shub_01_00785_def,
   0x0000000100051010 => \%shub_01_00786_def,
   0x0000000100052000 => \%shub_01_00787_def,
   0x0000000100052010 => \%shub_01_00788_def,
   0x0000000100052800 => \%shub_01_00789_def,
   0x0000000100052810 => \%shub_01_00790_def,
   0x0000000100053000 => \%shub_01_00791_def,
   0x0000000100053010 => \%shub_01_00792_def,
   0x0000000100053020 => \%shub_01_00793_def,
   0x0000000100053030 => \%shub_01_00794_def,
   0x0000000100053040 => \%shub_01_00795_def,
   0x0000000100053800 => \%shub_01_00796_def,
   0x0000000100053810 => \%shub_01_00797_def,
   0x0000000100053820 => \%shub_01_00798_def,
   0x0000000100053830 => \%shub_01_00799_def,
   0x0000000100053840 => \%shub_01_00800_def,
   0x0000000100054000 => \%shub_01_00801_def,
   0x0000000100054010 => \%shub_01_00802_def,
   0x0000000100054020 => \%shub_01_00803_def,
   0x0000000100058000 => \%shub_01_00804_def,
   0x0000000100058010 => \%shub_01_00805_def,
   0x0000000100058020 => \%shub_01_00806_def,
   0x0000000100058030 => \%shub_01_00807_def,
   0x0000000100058800 => \%shub_01_00808_def,
   0x0000000100058810 => \%shub_01_00809_def,
   0x0000000100058820 => \%shub_01_00810_def,
   0x0000000100058830 => \%shub_01_00811_def,
   0x0000000100068000 => \%shub_01_00812_def,
   0x0000000100068010 => \%shub_01_00813_def,
   0x0000000100068020 => \%shub_01_00814_def,
   0x0000000100068030 => \%shub_01_00815_def,
   0x0000000100068800 => \%shub_01_00816_def,
   0x0000000100068810 => \%shub_01_00817_def,
   0x0000000100068820 => \%shub_01_00818_def,
   0x0000000100068830 => \%shub_01_00819_def,
   0x0000000100069000 => \%shub_01_00820_def,
   0x000000010006A000 => \%shub_01_00821_def,
);

@shub_01_sorted_mmr_name = 
(
   "SH_AUTO_REPLY_ENABLE0",
   "SH_AUTO_REPLY_ENABLE1",
   "SH_AUTO_REPLY_HEADER0",
   "SH_AUTO_REPLY_HEADER1",
   "SH_CONVEYOR_BELT_TIME_OUT",
   "SH_CPU_PERM",
   "SH_CPU_PERM_OVR",
   "SH_CRB_MESSAGE_CONTROL",
   "SH_CRB_NACK_LIMIT",
   "SH_CRB_TIMEOUT_PRESCALE",
   "SH_CRB_TIMEOUT_SKID",
   "SH_DEBUG_PORT",
   "SH_DEBUG_SELECT",
   "SH_DIAG_MSG_CNTRL",
   "SH_DIAG_MSG_DATA0L",
   "SH_DIAG_MSG_DATA0U",
   "SH_DIAG_MSG_DATA1L",
   "SH_DIAG_MSG_DATA1U",
   "SH_DIAG_MSG_DATA2L",
   "SH_DIAG_MSG_DATA2U",
   "SH_DIAG_MSG_DATA3L",
   "SH_DIAG_MSG_DATA3U",
   "SH_DIAG_MSG_DATA4L",
   "SH_DIAG_MSG_DATA4U",
   "SH_DIAG_MSG_DATA5L",
   "SH_DIAG_MSG_DATA5U",
   "SH_DIAG_MSG_DATA6L",
   "SH_DIAG_MSG_DATA6U",
   "SH_DIAG_MSG_DATA7L",
   "SH_DIAG_MSG_DATA7U",
   "SH_DIAG_MSG_DATA8L",
   "SH_DIAG_MSG_DATA8U",
   "SH_DIAG_MSG_HDR0",
   "SH_DIAG_MSG_HDR1",
   "SH_DIR_COR_ERR_HDR_LOWER",
   "SH_DIR_COR_ERR_HDR_UPPER",
   "SH_DIR_UC_ERR_HDR_LOWER",
   "SH_DIR_UC_ERR_HDR_UPPER",
   "SH_ENABLE_RP_AUTO_REPLY",
   "SH_ENABLE_RQ_AUTO_REPLY",
   "SH_EVENT_OCCURRED",
   "SH_EVENT_OCCURRED_ALIAS",
   "SH_EVENT_OVERFLOW",
   "SH_EVENT_OVERFLOW_ALIAS",
   "SH_EXT_IOI_ACCESS",
   "SH_EXT_IO_PERM",
   "SH_FIRST_ERROR",
   "SH_FSB_BINIT_CONTROL",
   "SH_FSB_RESET_CONTROL",
   "SH_FSB_RESET_STATUS",
   "SH_FSB_SYMMETRIC_AGENT_STATUS",
   "SH_FSB_SYSTEM_AGENT_CONFIG",
   "SH_FSB_VGA_REMAP",
   "SH_GC_FIL_CTRL",
   "SH_GC_SRC_CTRL",
   "SH_GFX_CREDIT_COUNT_0",
   "SH_GFX_CREDIT_COUNT_1",
   "SH_GFX_INTERRUPT_TIMER_LIMIT_0",
   "SH_GFX_INTERRUPT_TIMER_LIMIT_1",
   "SH_GFX_MODE_CNTRL_0",
   "SH_GFX_MODE_CNTRL_1",
   "SH_GFX_SKID_CREDIT_COUNT_0",
   "SH_GFX_SKID_CREDIT_COUNT_1",
   "SH_GFX_STALL_LIMIT_0",
   "SH_GFX_STALL_LIMIT_1",
   "SH_GFX_STALL_TIMER_0",
   "SH_GFX_STALL_TIMER_1",
   "SH_GFX_WINDOW_0",
   "SH_GFX_WINDOW_1",
   "SH_GFX_WRITE_STATUS_0",
   "SH_GFX_WRITE_STATUS_1",
   "SH_HARD_RESET",
   "SH_IILB_GLOBAL_TABLE",
   "SH_IILB_LOCAL_TABLE",
   "SH_IILB_OVER_RIDE_TABLE",
   "SH_IILB_RSP_PLANE_HINT",
   "SH_II_DEBUG_DATA",
   "SH_II_HW_TIME_STAMP",
   "SH_II_INT0",
   "SH_II_INT0_CONFIG",
   "SH_II_INT0_ENABLE",
   "SH_II_INT1",
   "SH_II_INT1_CONFIG",
   "SH_II_INT1_ENABLE",
   "SH_II_WRAP_DEBUG_DATA",
   "SH_INT_CMPA",
   "SH_INT_CMPB",
   "SH_INT_CMPC",
   "SH_INT_CMPD",
   "SH_INT_NODE_ID_CONFIG",
   "SH_INT_PROF",
   "SH_IOI_ACCESS",
   "SH_IO_PERM",
   "SH_IPI_ACCESS",
   "SH_IPI_INT",
   "SH_IPI_INT_ENABLE",
   "SH_JNR_DIMM_CFG",
   "SH_JTAG_CONFIG",
   "SH_JUNK_BUS_LED0",
   "SH_JUNK_BUS_LED1",
   "SH_JUNK_BUS_LED2",
   "SH_JUNK_BUS_LED3",
   "SH_JUNK_BUS_TIME",
   "SH_JUNK_ERROR_STATUS",
   "SH_JUNK_LATCH_TIME",
   "SH_JUNK_NACK_RESET",
   "SH_LB_CREDIT_STATUS",
   "SH_LB_DEBUG_DATA",
   "SH_LB_DEBUG_LOCAL_SEL",
   "SH_LB_DEBUG_PERF_SEL",
   "SH_LB_DEBUG_TRIG_SEL",
   "SH_LB_ERROR_DETAIL_1",
   "SH_LB_ERROR_DETAIL_2",
   "SH_LB_ERROR_DETAIL_3",
   "SH_LB_ERROR_DETAIL_4",
   "SH_LB_ERROR_DETAIL_5",
   "SH_LB_ERROR_MASK",
   "SH_LB_ERROR_OVERFLOW",
   "SH_LB_ERROR_OVERFLOW_ALIAS",
   "SH_LB_ERROR_SUMMARY",
   "SH_LB_ERROR_SUMMARY_ALIAS",
   "SH_LB_FIRST_ERROR",
   "SH_LB_HW_TIME_STAMP",
   "SH_LB_LAST_CREDIT",
   "SH_LB_LIQ_CTL",
   "SH_LB_LOQ_CTL",
   "SH_LB_MAX_REP_CREDIT_CNT",
   "SH_LB_MAX_REQ_CREDIT_CNT",
   "SH_LB_NACK_STATUS",
   "SH_LB_TRIGGER_COMPARE",
   "SH_LB_TRIGGER_DATA",
   "SH_LOCAL_INT0_CONFIG",
   "SH_LOCAL_INT0_ENABLE",
   "SH_LOCAL_INT1_CONFIG",
   "SH_LOCAL_INT1_ENABLE",
   "SH_LOCAL_INT2_CONFIG",
   "SH_LOCAL_INT2_ENABLE",
   "SH_LOCAL_INT3_CONFIG",
   "SH_LOCAL_INT3_ENABLE",
   "SH_LOCAL_INT4_CONFIG",
   "SH_LOCAL_INT4_ENABLE",
   "SH_LOCAL_INT5_CONFIG",
   "SH_LOCAL_INT5_ENABLE",
   "SH_MD_COR_TIME_STAMP",
   "SH_MD_DBUG_COMPARE",
   "SH_MD_DBUG_DATA_CFG",
   "SH_MD_DBUG_TRIGGER_CFG",
   "SH_MD_DEBUG_DATA",
   "SH_MD_DQLP_MMR_DIR_CMDTRIG",
   "SH_MD_DQLP_MMR_DIR_CONFIG",
   "SH_MD_DQLP_MMR_DIR_LOCVEC0",
   "SH_MD_DQLP_MMR_DIR_LOCVEC1",
   "SH_MD_DQLP_MMR_DIR_LOCVEC2",
   "SH_MD_DQLP_MMR_DIR_LOCVEC3",
   "SH_MD_DQLP_MMR_DIR_LOCVEC4",
   "SH_MD_DQLP_MMR_DIR_LOCVEC5",
   "SH_MD_DQLP_MMR_DIR_LOCVEC6",
   "SH_MD_DQLP_MMR_DIR_LOCVEC7",
   "SH_MD_DQLP_MMR_DIR_PRESVEC0",
   "SH_MD_DQLP_MMR_DIR_PRESVEC1",
   "SH_MD_DQLP_MMR_DIR_PRESVEC2",
   "SH_MD_DQLP_MMR_DIR_PRESVEC3",
   "SH_MD_DQLP_MMR_DIR_PRIVEC0",
   "SH_MD_DQLP_MMR_DIR_PRIVEC1",
   "SH_MD_DQLP_MMR_DIR_PRIVEC2",
   "SH_MD_DQLP_MMR_DIR_PRIVEC3",
   "SH_MD_DQLP_MMR_DIR_PRIVEC4",
   "SH_MD_DQLP_MMR_DIR_PRIVEC5",
   "SH_MD_DQLP_MMR_DIR_PRIVEC6",
   "SH_MD_DQLP_MMR_DIR_PRIVEC7",
   "SH_MD_DQLP_MMR_DIR_TBLMASK",
   "SH_MD_DQLP_MMR_DIR_TBLTRIG",
   "SH_MD_DQLP_MMR_DIR_TIMER",
   "SH_MD_DQLP_MMR_PIOWD_DIR_ECC",
   "SH_MD_DQLP_MMR_PIOWD_DIR_ENTRY",
   "SH_MD_DQLP_MMR_XBIST_ERR_H",
   "SH_MD_DQLP_MMR_XBIST_ERR_L",
   "SH_MD_DQLP_MMR_XBIST_H",
   "SH_MD_DQLP_MMR_XBIST_L",
   "SH_MD_DQLP_MMR_XCERR1",
   "SH_MD_DQLP_MMR_XCERR2",
   "SH_MD_DQLP_MMR_XPERR",
   "SH_MD_DQLP_MMR_XPIORD_XDIR_ECC",
   "SH_MD_DQLP_MMR_XPIORD_XDIR_ENTRY",
   "SH_MD_DQLP_MMR_XUERR1",
   "SH_MD_DQLP_MMR_XUERR2",
   "SH_MD_DQLP_MMR_YBIST_ERR_H",
   "SH_MD_DQLP_MMR_YBIST_ERR_L",
   "SH_MD_DQLP_MMR_YBIST_H",
   "SH_MD_DQLP_MMR_YBIST_L",
   "SH_MD_DQLP_MMR_YCERR1",
   "SH_MD_DQLP_MMR_YCERR2",
   "SH_MD_DQLP_MMR_YPERR",
   "SH_MD_DQLP_MMR_YPIORD_YDIR_ECC",
   "SH_MD_DQLP_MMR_YPIORD_YDIR_ENTRY",
   "SH_MD_DQLP_MMR_YUERR1",
   "SH_MD_DQLP_MMR_YUERR2",
   "SH_MD_DQLS_MMR_JNR_DEBUG",
   "SH_MD_DQLS_MMR_XAMOPW_ERR",
   "SH_MD_DQLS_MMR_XBIST_ERR_H",
   "SH_MD_DQLS_MMR_XBIST_ERR_L",
   "SH_MD_DQLS_MMR_XBIST_H",
   "SH_MD_DQLS_MMR_XBIST_L",
   "SH_MD_DQLS_MMR_YBIST_ERR_H",
   "SH_MD_DQLS_MMR_YBIST_ERR_L",
   "SH_MD_DQLS_MMR_YBIST_H",
   "SH_MD_DQLS_MMR_YBIST_L",
   "SH_MD_DQRP_MMR_DIR_CMDTRIG",
   "SH_MD_DQRP_MMR_DIR_CONFIG",
   "SH_MD_DQRP_MMR_DIR_LOCVEC0",
   "SH_MD_DQRP_MMR_DIR_LOCVEC1",
   "SH_MD_DQRP_MMR_DIR_LOCVEC2",
   "SH_MD_DQRP_MMR_DIR_LOCVEC3",
   "SH_MD_DQRP_MMR_DIR_LOCVEC4",
   "SH_MD_DQRP_MMR_DIR_LOCVEC5",
   "SH_MD_DQRP_MMR_DIR_LOCVEC6",
   "SH_MD_DQRP_MMR_DIR_LOCVEC7",
   "SH_MD_DQRP_MMR_DIR_PRESVEC0",
   "SH_MD_DQRP_MMR_DIR_PRESVEC1",
   "SH_MD_DQRP_MMR_DIR_PRESVEC2",
   "SH_MD_DQRP_MMR_DIR_PRESVEC3",
   "SH_MD_DQRP_MMR_DIR_PRIVEC0",
   "SH_MD_DQRP_MMR_DIR_PRIVEC1",
   "SH_MD_DQRP_MMR_DIR_PRIVEC2",
   "SH_MD_DQRP_MMR_DIR_PRIVEC3",
   "SH_MD_DQRP_MMR_DIR_PRIVEC4",
   "SH_MD_DQRP_MMR_DIR_PRIVEC5",
   "SH_MD_DQRP_MMR_DIR_PRIVEC6",
   "SH_MD_DQRP_MMR_DIR_PRIVEC7",
   "SH_MD_DQRP_MMR_DIR_TBLMASK",
   "SH_MD_DQRP_MMR_DIR_TBLTRIG",
   "SH_MD_DQRP_MMR_DIR_TIMER",
   "SH_MD_DQRP_MMR_PIOWD_DIR_ECC",
   "SH_MD_DQRP_MMR_PIOWD_DIR_ENTRY",
   "SH_MD_DQRP_MMR_XBIST_ERR_H",
   "SH_MD_DQRP_MMR_XBIST_ERR_L",
   "SH_MD_DQRP_MMR_XBIST_H",
   "SH_MD_DQRP_MMR_XBIST_L",
   "SH_MD_DQRP_MMR_XCERR1",
   "SH_MD_DQRP_MMR_XCERR2",
   "SH_MD_DQRP_MMR_XPERR",
   "SH_MD_DQRP_MMR_XPIORD_XDIR_ECC",
   "SH_MD_DQRP_MMR_XPIORD_XDIR_ENTRY",
   "SH_MD_DQRP_MMR_XUERR1",
   "SH_MD_DQRP_MMR_XUERR2",
   "SH_MD_DQRP_MMR_YBIST_ERR_H",
   "SH_MD_DQRP_MMR_YBIST_ERR_L",
   "SH_MD_DQRP_MMR_YBIST_H",
   "SH_MD_DQRP_MMR_YBIST_L",
   "SH_MD_DQRP_MMR_YCERR1",
   "SH_MD_DQRP_MMR_YCERR2",
   "SH_MD_DQRP_MMR_YPERR",
   "SH_MD_DQRP_MMR_YPIORD_YDIR_ECC",
   "SH_MD_DQRP_MMR_YPIORD_YDIR_ENTRY",
   "SH_MD_DQRP_MMR_YUERR1",
   "SH_MD_DQRP_MMR_YUERR2",
   "SH_MD_DQRS_MMR_JNR_DEBUG",
   "SH_MD_DQRS_MMR_XBIST_ERR_H",
   "SH_MD_DQRS_MMR_XBIST_ERR_L",
   "SH_MD_DQRS_MMR_XBIST_H",
   "SH_MD_DQRS_MMR_XBIST_L",
   "SH_MD_DQRS_MMR_YAMOPW_ERR",
   "SH_MD_DQRS_MMR_YBIST_ERR_H",
   "SH_MD_DQRS_MMR_YBIST_ERR_L",
   "SH_MD_DQRS_MMR_YBIST_H",
   "SH_MD_DQRS_MMR_YBIST_L",
   "SH_MD_GLOBAL_TABLE",
   "SH_MD_HW_TIME_STAMP",
   "SH_MD_JNR_DBUG_DATA_CFG",
   "SH_MD_LAST_CREDIT",
   "SH_MD_LOCAL_TABLE",
   "SH_MD_OVER_RIDE_TABLE",
   "SH_MD_RSP_PLANE_HINT",
   "SH_MD_UNCOR_TIME_STAMP",
   "SH_MEMORY_WRITE_STATUS_0",
   "SH_MEMORY_WRITE_STATUS_1",
   "SH_MEMORY_WRITE_STATUS_NON_USER_0",
   "SH_MEMORY_WRITE_STATUS_NON_USER_1",
   "SH_MEM_CAPTURE_ADDR",
   "SH_MEM_CAPTURE_HDR",
   "SH_MEM_CAPTURE_MASK",
   "SH_MEM_ERROR_MASK",
   "SH_MEM_ERROR_OVERFLOW",
   "SH_MEM_ERROR_OVERFLOW_ALIAS",
   "SH_MEM_ERROR_SUMMARY",
   "SH_MEM_ERROR_SUMMARY_ALIAS",
   "SH_MEM_RED_BLACK",
   "SH_MISC_ERR_HDR_LOWER",
   "SH_MISC_ERR_HDR_UPPER",
   "SH_MISC_MEM_CFG",
   "SH_MMRBIST_BASE",
   "SH_MMRBIST_CTL",
   "SH_MMRBIST_ERR",
   "SH_NI0_ERROR_DETAIL_1",
   "SH_NI0_ERROR_DETAIL_2",
   "SH_NI0_ERROR_DETAIL_3",
   "SH_NI0_ERROR_MASK_1",
   "SH_NI0_ERROR_MASK_2",
   "SH_NI0_ERROR_OVERFLOW_1",
   "SH_NI0_ERROR_OVERFLOW_1_ALIAS",
   "SH_NI0_ERROR_OVERFLOW_2",
   "SH_NI0_ERROR_OVERFLOW_2_ALIAS",
   "SH_NI0_ERROR_SUMMARY_1",
   "SH_NI0_ERROR_SUMMARY_1_ALIAS",
   "SH_NI0_ERROR_SUMMARY_2",
   "SH_NI0_ERROR_SUMMARY_2_ALIAS",
   "SH_NI0_FIRST_ERROR_1",
   "SH_NI0_FIRST_ERROR_2",
   "SH_NI0_GLOBAL_TABLE",
   "SH_NI0_LLP_CAPT_SBCB",
   "SH_NI0_LLP_CAPT_WD1",
   "SH_NI0_LLP_CAPT_WD2",
   "SH_NI0_LLP_CHAN_MODE",
   "SH_NI0_LLP_CONFIG",
   "SH_NI0_LLP_ERR",
   "SH_NI0_LLP_RESET",
   "SH_NI0_LLP_RESET_EN",
   "SH_NI0_LLP_STAT",
   "SH_NI0_LLP_TEST_CTL",
   "SH_NI0_LOCAL_TABLE",
   "SH_NI0_OVER_RIDE_TABLE",
   "SH_NI0_RSP_PLANE_HINT",
   "SH_NI1_ERROR_DETAIL_1",
   "SH_NI1_ERROR_DETAIL_2",
   "SH_NI1_ERROR_DETAIL_3",
   "SH_NI1_ERROR_MASK_1",
   "SH_NI1_ERROR_MASK_2",
   "SH_NI1_ERROR_OVERFLOW_1",
   "SH_NI1_ERROR_OVERFLOW_1_ALIAS",
   "SH_NI1_ERROR_OVERFLOW_2",
   "SH_NI1_ERROR_OVERFLOW_2_ALIAS",
   "SH_NI1_ERROR_SUMMARY_1",
   "SH_NI1_ERROR_SUMMARY_1_ALIAS",
   "SH_NI1_ERROR_SUMMARY_2",
   "SH_NI1_ERROR_SUMMARY_2_ALIAS",
   "SH_NI1_FIRST_ERROR_1",
   "SH_NI1_FIRST_ERROR_2",
   "SH_NI1_GLOBAL_TABLE",
   "SH_NI1_LLP_CAPT_SBCB",
   "SH_NI1_LLP_CAPT_WD1",
   "SH_NI1_LLP_CAPT_WD2",
   "SH_NI1_LLP_CHAN_MODE",
   "SH_NI1_LLP_CONFIG",
   "SH_NI1_LLP_ERR",
   "SH_NI1_LLP_RESET",
   "SH_NI1_LLP_RESET_EN",
   "SH_NI1_LLP_STAT",
   "SH_NI1_LLP_TEST_CTL",
   "SH_NI1_LOCAL_TABLE",
   "SH_NI1_OVER_RIDE_TABLE",
   "SH_NI1_RSP_PLANE_HINT",
   "SH_PERFORMANCE_COUNT0_CONTROL",
   "SH_PERFORMANCE_COUNT1_CONTROL",
   "SH_PERFORMANCE_COUNT2_CONTROL",
   "SH_PERFORMANCE_COUNT3_CONTROL",
   "SH_PERFORMANCE_COUNT4_CONTROL",
   "SH_PERFORMANCE_COUNT5_CONTROL",
   "SH_PERFORMANCE_COUNT6_CONTROL",
   "SH_PERFORMANCE_COUNT7_CONTROL",
   "SH_PERFORMANCE_COUNTER0",
   "SH_PERFORMANCE_COUNTER1",
   "SH_PERFORMANCE_COUNTER2",
   "SH_PERFORMANCE_COUNTER3",
   "SH_PERFORMANCE_COUNTER4",
   "SH_PERFORMANCE_COUNTER5",
   "SH_PERFORMANCE_COUNTER6",
   "SH_PERFORMANCE_COUNTER7",
   "SH_PIO_NACK_RESET",
   "SH_PIO_RQ_CRD_CTL",
   "SH_PIO_TIME_OUT",
   "SH_PIO_WRITE_STATUS_0",
   "SH_PIO_WRITE_STATUS_0_ALIAS",
   "SH_PIO_WRITE_STATUS_1",
   "SH_PIO_WRITE_STATUS_1_ALIAS",
   "SH_PI_AEC_CONFIG",
   "SH_PI_AEC_STATUS",
   "SH_PI_AFI_ERROR_MASK",
   "SH_PI_AFI_FIRST_ERROR",
   "SH_PI_AFI_TEST_POINT_COMPARE",
   "SH_PI_AFI_TEST_POINT_SELECT",
   "SH_PI_AFI_TEST_POINT_TRIGGER_SELECT",
   "SH_PI_AUTO_REPLY_ENABLE",
   "SH_PI_CAM_ADDRESS_READ_DATA",
   "SH_PI_CAM_CONTROL",
   "SH_PI_CAM_LPRA_READ_DATA",
   "SH_PI_CAM_STATE_READ_DATA",
   "SH_PI_CORRECTED_DETAIL_1",
   "SH_PI_CORRECTED_DETAIL_2",
   "SH_PI_CORRECTED_DETAIL_3",
   "SH_PI_CORRECTED_DETAIL_4",
   "SH_PI_COR_TIME_STAMP",
   "SH_PI_CRBC_TEST_POINT_COMPARE",
   "SH_PI_CRBC_TEST_POINT_SELECT",
   "SH_PI_CRBC_TEST_POINT_TRIGGER_SELECT",
   "SH_PI_CRBP_ERROR_MASK",
   "SH_PI_CRBP_FIRST_ERROR",
   "SH_PI_CRBP_FSB_PIPE_COMPARE",
   "SH_PI_CRBP_FSB_PIPE_MASK",
   "SH_PI_CRBP_TEST_POINT_COMPARE",
   "SH_PI_CRBP_TEST_POINT_SELECT",
   "SH_PI_CRBP_TEST_POINT_TRIGGER_SELECT",
   "SH_PI_CRBP_XB_PIPE_COMPARE_0",
   "SH_PI_CRBP_XB_PIPE_COMPARE_1",
   "SH_PI_CRBP_XB_PIPE_MASK_0",
   "SH_PI_CRBP_XB_PIPE_MASK_1",
   "SH_PI_DEBUG_DATA",
   "SH_PI_DPC_QUEUE_CONFIG",
   "SH_PI_ERROR_DETAIL_1",
   "SH_PI_ERROR_DETAIL_2",
   "SH_PI_ERROR_MASK",
   "SH_PI_ERROR_OVERFLOW",
   "SH_PI_ERROR_OVERFLOW_ALIAS",
   "SH_PI_ERROR_SUMMARY",
   "SH_PI_ERROR_SUMMARY_ALIAS",
   "SH_PI_EXPRESS_REPLY_CONFIG",
   "SH_PI_EXPRESS_REPLY_STATUS",
   "SH_PI_FIRST_ERROR",
   "SH_PI_FIRST_ERROR_ALIAS",
   "SH_PI_FSB_COMPARE_MASK",
   "SH_PI_FSB_COMPARE_VALUE",
   "SH_PI_FSB_ERROR_INJECTION",
   "SH_PI_GLOBAL_TABLE",
   "SH_PI_HW_TIME_STAMP",
   "SH_PI_LOCAL_TABLE",
   "SH_PI_MD2PI_REPLY_VC_CONFIG",
   "SH_PI_MD2PI_REPLY_VC_STATUS",
   "SH_PI_MD2PI_REQUEST_VC_CONFIG",
   "SH_PI_MD2PI_REQUEST_VC_STATUS",
   "SH_PI_MD_RP_CRD_CTL",
   "SH_PI_MD_RQ_CRD_CTL",
   "SH_PI_OVER_RIDE_TABLE",
   "SH_PI_PI2MD_REPLY_VC_STATUS",
   "SH_PI_PI2MD_REQUEST_VC_STATUS",
   "SH_PI_PI2XN_REPLY_VC_STATUS",
   "SH_PI_PI2XN_REQUEST_VC_STATUS",
   "SH_PI_QUEUE_ERROR_INJECTION",
   "SH_PI_RSP_PLANE_HINT",
   "SH_PI_TEST_POINT_COMPARE",
   "SH_PI_TEST_POINT_SELECT",
   "SH_PI_TEST_POINT_TRIGGER_SELECT",
   "SH_PI_UNCORRECTED_DETAIL_1",
   "SH_PI_UNCORRECTED_DETAIL_2",
   "SH_PI_UNCORRECTED_DETAIL_3",
   "SH_PI_UNCORRECTED_DETAIL_4",
   "SH_PI_UNCOR_TIME_STAMP",
   "SH_PI_XN2PI_REPLY_VC_CONFIG",
   "SH_PI_XN2PI_REPLY_VC_STATUS",
   "SH_PI_XN2PI_REQUEST_VC_CONFIG",
   "SH_PI_XN2PI_REQUEST_VC_STATUS",
   "SH_PROC0_ADV_INT_CONFIG",
   "SH_PROC0_ADV_INT_ENABLE",
   "SH_PROC0_ADV_TIME_STAMP",
   "SH_PROC0_ERR_INT_CONFIG",
   "SH_PROC0_ERR_INT_ENABLE",
   "SH_PROC0_ERR_TIME_STAMP",
   "SH_PROC1_ADV_INT_CONFIG",
   "SH_PROC1_ADV_INT_ENABLE",
   "SH_PROC1_ADV_TIME_STAMP",
   "SH_PROC1_ERR_INT_CONFIG",
   "SH_PROC1_ERR_INT_ENABLE",
   "SH_PROC1_ERR_TIME_STAMP",
   "SH_PROC2_ADV_INT_CONFIG",
   "SH_PROC2_ADV_INT_ENABLE",
   "SH_PROC2_ADV_TIME_STAMP",
   "SH_PROC2_ERR_INT_CONFIG",
   "SH_PROC2_ERR_INT_ENABLE",
   "SH_PROC2_ERR_TIME_STAMP",
   "SH_PROC3_ADV_INT_CONFIG",
   "SH_PROC3_ADV_INT_ENABLE",
   "SH_PROC3_ADV_TIME_STAMP",
   "SH_PROC3_ERR_INT_CONFIG",
   "SH_PROC3_ERR_INT_ENABLE",
   "SH_PROC3_ERR_TIME_STAMP",
   "SH_PROFILE_COUNTER",
   "SH_PROFILE_DN_CONTROL",
   "SH_PROFILE_INT_CONFIG",
   "SH_PROFILE_INT_ENABLE",
   "SH_PROFILE_PEAK",
   "SH_PROFILE_PEAK_CONTROL",
   "SH_PROFILE_RANGE",
   "SH_PROFILE_UP_CONTROL",
   "SH_PTC_0",
   "SH_PTC_1",
   "SH_PTC_PARMS",
   "SH_REDIRECT_INVAL",
   "SH_RTC",
   "SH_RTC0_INT_CONFIG",
   "SH_RTC0_INT_ENABLE",
   "SH_RTC1_INT_CONFIG",
   "SH_RTC1_INT_ENABLE",
   "SH_RTC2_INT_CONFIG",
   "SH_RTC2_INT_ENABLE",
   "SH_RTC3_INT_CONFIG",
   "SH_RTC3_INT_ENABLE",
   "SH_SCRATCH0",
   "SH_SCRATCH0_ALIAS",
   "SH_SCRATCH1",
   "SH_SCRATCH1_ALIAS",
   "SH_SCRATCH2",
   "SH_SCRATCH2_ALIAS",
   "SH_SCRATCH3",
   "SH_SCRATCH3_ALIAS",
   "SH_SCRATCH4",
   "SH_SCRATCH4_ALIAS",
   "SH_SHUBS_PRESENT0",
   "SH_SHUBS_PRESENT1",
   "SH_SHUBS_PRESENT2",
   "SH_SHUBS_PRESENT3",
   "SH_SHUB_ID",
   "SH_SOFT_RESET",
   "SH_STOP_CLK_CONTROL",
   "SH_STOP_CLK_DELAY_PHASE",
   "SH_TRIGGER_COMPARE_MASK",
   "SH_TRIGGER_COMPARE_PATTERN",
   "SH_TRIGGER_SEL",
   "SH_TSF_ARMED_STATE",
   "SH_TSF_ARM_MASK",
   "SH_TSF_COUNTER_PRESETS",
   "SH_TSF_COUNTER_VALUE",
   "SH_TSF_DECREMENT_CTL",
   "SH_TSF_DIAG_MSG_CTL",
   "SH_TSF_DISARM_MASK",
   "SH_TSF_ENABLE_CTL",
   "SH_TSF_SOFTWARE_ARM",
   "SH_TSF_SOFTWARE_DISARM",
   "SH_TSF_SOFTWARE_TRIGGERED",
   "SH_TSF_TRIGGERED_STATE",
   "SH_TSF_TRIGGER_MASK",
   "SH_VEC_DATA",
   "SH_VEC_PARMS",
   "SH_VEC_RDDATA",
   "SH_VEC_RETURN",
   "SH_VEC_ROUTE",
   "SH_VEC_STATUS",
   "SH_VEC_STATUS_ALIAS",
   "SH_XNIILB_ERRORS_ALIAS",
   "SH_XNIILB_ERROR_DETAIL_1",
   "SH_XNIILB_ERROR_DETAIL_2",
   "SH_XNIILB_ERROR_DETAIL_3",
   "SH_XNIILB_ERROR_MASK",
   "SH_XNIILB_ERROR_OVERFLOW",
   "SH_XNIILB_ERROR_OVERFLOW_ALIAS",
   "SH_XNIILB_ERROR_SUMMARY",
   "SH_XNIILB_FIRST_ERROR",
   "SH_XNIILB_FR_IILB_INTRA_FLOW_CREDIT",
   "SH_XNIILB_FR_MD_INTRA_FLOW_CREDIT",
   "SH_XNIILB_FR_NI0_INTRA_FLOW_CREDIT",
   "SH_XNIILB_FR_NI1_INTRA_FLOW_CREDIT",
   "SH_XNIILB_FR_PI_INTRA_FLOW_CREDIT",
   "SH_XNIILB_TO_IILB_INTRA_FLOW_DEBIT",
   "SH_XNIILB_TO_MD_INTRA_FLOW_DEBIT",
   "SH_XNIILB_TO_NI0_INTRA_FLOW_DEBIT",
   "SH_XNIILB_TO_NI1_INTRA_FLOW_DEBIT",
   "SH_XNIILB_TO_PI_INTRA_FLOW_DEBIT",
   "SH_XNII_INTRA_FLOW",
   "SH_XNLB_INTRA_FLOW",
   "SH_XNMD_ECC0_INJ_MASK_REG",
   "SH_XNMD_ECC1_INJ_MASK_REG",
   "SH_XNMD_ECC2_INJ_MASK_REG",
   "SH_XNMD_ECC3_INJ_MASK_REG",
   "SH_XNMD_ECC_ERR_REPORT",
   "SH_XNMD_ECC_INJ_REG",
   "SH_XNMD_ERRORS_ALIAS",
   "SH_XNMD_ERROR_DETAIL_1",
   "SH_XNMD_ERROR_MASK",
   "SH_XNMD_ERROR_OVERFLOW",
   "SH_XNMD_ERROR_OVERFLOW_ALIAS",
   "SH_XNMD_ERROR_SUMMARY",
   "SH_XNMD_FIRST_ERROR",
   "SH_XNMD_FR_IILB_PORT_FLOW_FIFO",
   "SH_XNMD_FR_NI0_PORT_FLOW_FIFO",
   "SH_XNMD_FR_NI1_PORT_FLOW_FIFO",
   "SH_XNMD_SIC_FLOW",
   "SH_XNMD_TO_IILB_PORT_FLOW",
   "SH_XNMD_TO_NI0_PORT_FLOW",
   "SH_XNMD_TO_NI1_PORT_FLOW",
   "SH_XNNI0_0_INTRANI_FLOW",
   "SH_XNNI0_1_INTRANI_FLOW",
   "SH_XNNI0_2_INTRANI_FLOW",
   "SH_XNNI0_3_INTRANI_FLOW",
   "SH_XNNI0_DEAD_FLOW",
   "SH_XNNI0_FIFO02_FLOW",
   "SH_XNNI0_FIFO13_FLOW",
   "SH_XNNI0_FR_IILB_INTRA_FLOW_CREDIT",
   "SH_XNNI0_FR_MD_INTRA_FLOW_CREDIT",
   "SH_XNNI0_FR_PI_INTRA_FLOW_CREDIT",
   "SH_XNNI0_INJECT_AGE",
   "SH_XNNI0_LINK_0_FLOW",
   "SH_XNNI0_LINK_1_FLOW",
   "SH_XNNI0_LINK_2_FLOW",
   "SH_XNNI0_LINK_3_FLOW",
   "SH_XNNI0_LLP_DEBIT_FLOW",
   "SH_XNNI0_LLP_TO_FIFO02_FLOW",
   "SH_XNNI0_LLP_TO_FIFO13_FLOW",
   "SH_XNNI0_NI_FLOW",
   "SH_XNNI0_TIMER_REG",
   "SH_XNNI0_TO_IILB_INTRA_FLOW_DEBIT",
   "SH_XNNI0_TO_MD_INTRA_FLOW_DEBIT",
   "SH_XNNI0_TO_PI_INTRA_FLOW_DEBIT",
   "SH_XNNI0_VCSWITCH_FLOW",
   "SH_XNNI1_0_INTRANI_FLOW",
   "SH_XNNI1_1_INTRANI_FLOW",
   "SH_XNNI1_2_INTRANI_FLOW",
   "SH_XNNI1_3_INTRANI_FLOW",
   "SH_XNNI1_DEAD_FLOW",
   "SH_XNNI1_FIFO02_FLOW",
   "SH_XNNI1_FIFO13_FLOW",
   "SH_XNNI1_FR_IILB_INTRA_FLOW_CREDIT",
   "SH_XNNI1_FR_MD_INTRA_FLOW_CREDIT",
   "SH_XNNI1_FR_PI_INTRA_FLOW_CREDIT",
   "SH_XNNI1_INJECT_AGE",
   "SH_XNNI1_LINK_0_FLOW",
   "SH_XNNI1_LINK_1_FLOW",
   "SH_XNNI1_LINK_2_FLOW",
   "SH_XNNI1_LINK_3_FLOW",
   "SH_XNNI1_LLP_DEBIT_FLOW",
   "SH_XNNI1_LLP_TO_FIFO02_FLOW",
   "SH_XNNI1_LLP_TO_FIFO13_FLOW",
   "SH_XNNI1_NI_FLOW",
   "SH_XNNI1_TIMER_REG",
   "SH_XNNI1_TO_IILB_INTRA_FLOW_DEBIT",
   "SH_XNNI1_TO_MD_INTRA_FLOW_DEBIT",
   "SH_XNNI1_TO_PI_INTRA_FLOW_DEBIT",
   "SH_XNNI1_VCSWITCH_FLOW",
   "SH_XNPI_ECC0_INJ_MASK_REG",
   "SH_XNPI_ECC1_INJ_MASK_REG",
   "SH_XNPI_ECC2_INJ_MASK_REG",
   "SH_XNPI_ECC3_INJ_MASK_REG",
   "SH_XNPI_ECC_INJ_REG",
   "SH_XNPI_ERRORS_ALIAS",
   "SH_XNPI_ERROR_DETAIL_1",
   "SH_XNPI_ERROR_MASK",
   "SH_XNPI_ERROR_OVERFLOW",
   "SH_XNPI_ERROR_OVERFLOW_ALIAS",
   "SH_XNPI_ERROR_SUMMARY",
   "SH_XNPI_FIRST_ERROR",
   "SH_XNPI_FR_IILB_PORT_FLOW_FIFO",
   "SH_XNPI_FR_NI0_PORT_FLOW_FIFO",
   "SH_XNPI_FR_NI1_PORT_FLOW_FIFO",
   "SH_XNPI_SIC_FLOW",
   "SH_XNPI_TO_IILB_PORT_FLOW",
   "SH_XNPI_TO_NI0_PORT_FLOW",
   "SH_XNPI_TO_NI1_PORT_FLOW",
   "SH_XN_CORRECTED_DETAIL_1",
   "SH_XN_CORRECTED_DETAIL_2",
   "SH_XN_CORRECTED_DETAIL_3",
   "SH_XN_CORRECTED_DETAIL_4",
   "SH_XN_COR_TIME_STAMP",
   "SH_XN_DEBUG_DATA",
   "SH_XN_DEBUG_SEL",
   "SH_XN_DEBUG_TRIG_SEL",
   "SH_XN_ERRORS_ALIAS",
   "SH_XN_ERROR_MASK",
   "SH_XN_ERROR_OVERFLOW",
   "SH_XN_ERROR_OVERFLOW_ALIAS",
   "SH_XN_ERROR_SUMMARY",
   "SH_XN_FIRST_ERROR",
   "SH_XN_HW_TIME_STAMP",
   "SH_XN_IILB_DEBUG_SEL",
   "SH_XN_IILB_II_CMP_ENABLE0",
   "SH_XN_IILB_II_CMP_ENABLE1",
   "SH_XN_IILB_II_CMP_EXP_DATA0",
   "SH_XN_IILB_II_CMP_EXP_DATA1",
   "SH_XN_IILB_LB_CMP_ENABLE0",
   "SH_XN_IILB_LB_CMP_ENABLE1",
   "SH_XN_IILB_LB_CMP_EXP_DATA0",
   "SH_XN_IILB_LB_CMP_EXP_DATA1",
   "SH_XN_IILB_MD_CMP_ENABLE0",
   "SH_XN_IILB_MD_CMP_ENABLE1",
   "SH_XN_IILB_MD_CMP_EXP_DATA0",
   "SH_XN_IILB_MD_CMP_EXP_DATA1",
   "SH_XN_IILB_NI0_CMP_ENABLE0",
   "SH_XN_IILB_NI0_CMP_ENABLE1",
   "SH_XN_IILB_NI0_CMP_EXP_DATA0",
   "SH_XN_IILB_NI0_CMP_EXP_DATA1",
   "SH_XN_IILB_NI1_CMP_ENABLE0",
   "SH_XN_IILB_NI1_CMP_ENABLE1",
   "SH_XN_IILB_NI1_CMP_EXP_DATA0",
   "SH_XN_IILB_NI1_CMP_EXP_DATA1",
   "SH_XN_IILB_PI_CMP_ENABLE0",
   "SH_XN_IILB_PI_CMP_ENABLE1",
   "SH_XN_IILB_PI_CMP_EXP_DATA0",
   "SH_XN_IILB_PI_CMP_EXP_DATA1",
   "SH_XN_MD_DEBUG_SEL",
   "SH_XN_MD_IILB_CMP_ENABLE0",
   "SH_XN_MD_IILB_CMP_ENABLE1",
   "SH_XN_MD_IILB_CMP_EXP_DATA0",
   "SH_XN_MD_IILB_CMP_EXP_DATA1",
   "SH_XN_MD_NI0_CMP_ENABLE0",
   "SH_XN_MD_NI0_CMP_ENABLE1",
   "SH_XN_MD_NI0_CMP_EXP_DATA0",
   "SH_XN_MD_NI0_CMP_EXP_DATA1",
   "SH_XN_MD_NI1_CMP_ENABLE0",
   "SH_XN_MD_NI1_CMP_ENABLE1",
   "SH_XN_MD_NI1_CMP_EXP_DATA0",
   "SH_XN_MD_NI1_CMP_EXP_DATA1",
   "SH_XN_MD_RP_CRD_CTL",
   "SH_XN_MD_RQ_CRD_CTL",
   "SH_XN_MD_SIC_CMP_DATA0",
   "SH_XN_MD_SIC_CMP_DATA1",
   "SH_XN_MD_SIC_CMP_DATA2",
   "SH_XN_MD_SIC_CMP_DATA3",
   "SH_XN_MD_SIC_CMP_DATA_ENABLE0",
   "SH_XN_MD_SIC_CMP_DATA_ENABLE1",
   "SH_XN_MD_SIC_CMP_DATA_ENABLE2",
   "SH_XN_MD_SIC_CMP_DATA_ENABLE3",
   "SH_XN_MD_SIC_CMP_EXP_HDR0",
   "SH_XN_MD_SIC_CMP_EXP_HDR1",
   "SH_XN_MD_SIC_CMP_HDR_ENABLE0",
   "SH_XN_MD_SIC_CMP_HDR_ENABLE1",
   "SH_XN_NI0_DEBUG_SEL",
   "SH_XN_NI0_IILB_CMP_ENABLE0",
   "SH_XN_NI0_IILB_CMP_ENABLE1",
   "SH_XN_NI0_IILB_CMP_EXP_DATA0",
   "SH_XN_NI0_IILB_CMP_EXP_DATA1",
   "SH_XN_NI0_LLP_CMP_ENABLE0",
   "SH_XN_NI0_LLP_CMP_ENABLE1",
   "SH_XN_NI0_LLP_CMP_EXP_DATA0",
   "SH_XN_NI0_LLP_CMP_EXP_DATA1",
   "SH_XN_NI0_MD_CMP_ENABLE0",
   "SH_XN_NI0_MD_CMP_ENABLE1",
   "SH_XN_NI0_MD_CMP_EXP_DATA0",
   "SH_XN_NI0_MD_CMP_EXP_DATA1",
   "SH_XN_NI0_NI_CMP_ENABLE0",
   "SH_XN_NI0_NI_CMP_ENABLE1",
   "SH_XN_NI0_NI_CMP_EXP_DATA0",
   "SH_XN_NI0_NI_CMP_EXP_DATA1",
   "SH_XN_NI0_PI_CMP_ENABLE0",
   "SH_XN_NI0_PI_CMP_ENABLE1",
   "SH_XN_NI0_PI_CMP_EXP_DATA0",
   "SH_XN_NI0_PI_CMP_EXP_DATA1",
   "SH_XN_NI1_DEBUG_SEL",
   "SH_XN_NI1_IILB_CMP_ENABLE0",
   "SH_XN_NI1_IILB_CMP_ENABLE1",
   "SH_XN_NI1_IILB_CMP_EXP_DATA0",
   "SH_XN_NI1_IILB_CMP_EXP_DATA1",
   "SH_XN_NI1_LLP_CMP_ENABLE0",
   "SH_XN_NI1_LLP_CMP_ENABLE1",
   "SH_XN_NI1_LLP_CMP_EXP_DATA0",
   "SH_XN_NI1_LLP_CMP_EXP_DATA1",
   "SH_XN_NI1_MD_CMP_ENABLE0",
   "SH_XN_NI1_MD_CMP_ENABLE1",
   "SH_XN_NI1_MD_CMP_EXP_DATA0",
   "SH_XN_NI1_MD_CMP_EXP_DATA1",
   "SH_XN_NI1_NI_CMP_ENABLE0",
   "SH_XN_NI1_NI_CMP_ENABLE1",
   "SH_XN_NI1_NI_CMP_EXP_DATA0",
   "SH_XN_NI1_NI_CMP_EXP_DATA1",
   "SH_XN_NI1_PI_CMP_ENABLE0",
   "SH_XN_NI1_PI_CMP_ENABLE1",
   "SH_XN_NI1_PI_CMP_EXP_DATA0",
   "SH_XN_NI1_PI_CMP_EXP_DATA1",
   "SH_XN_PI_DEBUG_SEL",
   "SH_XN_PI_IILB_CMP_ENABLE0",
   "SH_XN_PI_IILB_CMP_ENABLE1",
   "SH_XN_PI_IILB_CMP_EXP_DATA0",
   "SH_XN_PI_IILB_CMP_EXP_DATA1",
   "SH_XN_PI_NI0_CMP_ENABLE0",
   "SH_XN_PI_NI0_CMP_ENABLE1",
   "SH_XN_PI_NI0_CMP_EXP_DATA0",
   "SH_XN_PI_NI0_CMP_EXP_DATA1",
   "SH_XN_PI_NI1_CMP_ENABLE0",
   "SH_XN_PI_NI1_CMP_ENABLE1",
   "SH_XN_PI_NI1_CMP_EXP_DATA0",
   "SH_XN_PI_NI1_CMP_EXP_DATA1",
   "SH_XN_PI_SIC_CMP_DATA0",
   "SH_XN_PI_SIC_CMP_DATA1",
   "SH_XN_PI_SIC_CMP_DATA2",
   "SH_XN_PI_SIC_CMP_DATA3",
   "SH_XN_PI_SIC_CMP_DATA_ENABLE0",
   "SH_XN_PI_SIC_CMP_DATA_ENABLE1",
   "SH_XN_PI_SIC_CMP_DATA_ENABLE2",
   "SH_XN_PI_SIC_CMP_DATA_ENABLE3",
   "SH_XN_PI_SIC_CMP_EXP_HDR0",
   "SH_XN_PI_SIC_CMP_EXP_HDR1",
   "SH_XN_PI_SIC_CMP_HDR_ENABLE0",
   "SH_XN_PI_SIC_CMP_HDR_ENABLE1",
   "SH_XN_TRIGGER_COMPARE",
   "SH_XN_TRIGGER_DATA",
   "SH_XN_UNCORRECTED_DETAIL_1",
   "SH_XN_UNCORRECTED_DETAIL_2",
   "SH_XN_UNCORRECTED_DETAIL_3",
   "SH_XN_UNCORRECTED_DETAIL_4",
   "SH_XN_UNCOR_TIME_STAMP",
   "SH_X_CFG",
   "SH_X_DBUG_SEL",
   "SH_X_DIMM_CFG",
   "SH_X_DQCT_CFG",
   "SH_X_LADDR_CMP",
   "SH_X_MOD_DBUG_SEL",
   "SH_X_PHASE_CFG",
   "SH_X_RADDR_CMP",
   "SH_X_REFRESH_CONTROL",
   "SH_X_TAG0",
   "SH_X_TAG1",
   "SH_X_TAG2",
   "SH_X_TAG3",
   "SH_X_TAG4",
   "SH_X_TAG5",
   "SH_X_TAG6",
   "SH_X_TAG7",
   "SH_X_TAG_CMP",
   "SH_X_TAG_MASK",
   "SH_Y_CFG",
   "SH_Y_DBUG_SEL",
   "SH_Y_DIMM_CFG",
   "SH_Y_DQCT_CFG",
   "SH_Y_LADDR_CMP",
   "SH_Y_MOD_DBUG_SEL",
   "SH_Y_PHASE_CFG",
   "SH_Y_RADDR_CMP",
   "SH_Y_REFRESH_CONTROL",
   "SH_Y_TAG0",
   "SH_Y_TAG1",
   "SH_Y_TAG2",
   "SH_Y_TAG3",
   "SH_Y_TAG4",
   "SH_Y_TAG5",
   "SH_Y_TAG6",
   "SH_Y_TAG7",
   "SH_Y_TAG_CMP",
   "SH_Y_TAG_MASK",
);

@shub_01_sorted_mmr_addr = 
(
   0x0000000100000080,
   0x0000000100000088,
   0x0000000100000090,
   0x0000000100000098,
   0x00000001000000A0,
   0x00000001000000A8,
   0x00000001000000B0,
   0x00000001000000B8,
   0x00000001000000C0,
   0x00000001000000C8,
   0x00000001000000D0,
   0x00000001000000D8,
   0x0000000100010000,
   0x0000000100010008,
   0x0000000100010010,
   0x0000000100010018,
   0x0000000100010020,
   0x0000000100010028,
   0x0000000100010030,
   0x0000000100010038,
   0x0000000100010040,
   0x0000000100010048,
   0x0000000100010050,
   0x0000000100010058,
   0x0000000100010060,
   0x0000000100010068,
   0x0000000100010070,
   0x0000000100010078,
   0x0000000100010080,
   0x0000000100010088,
   0x0000000100020000,
   0x0000000100020008,
   0x0000000100020010,
   0x0000000100020018,
   0x0000000100020020,
   0x0000000100020028,
   0x0000000100020030,
   0x0000000100020038,
   0x0000000100020040,
   0x0000000100020048,
   0x0000000100020050,
   0x0000000100020058,
   0x0000000100020060,
   0x0000000100020068,
   0x0000000100020070,
   0x0000000100020078,
   0x0000000100020080,
   0x0000000100020088,
   0x0000000100020100,
   0x0000000100020108,
   0x0000000100020110,
   0x0000000100020118,
   0x0000000100020120,
   0x0000000100020128,
   0x0000000100020130,
   0x0000000100020138,
   0x0000000100020140,
   0x0000000100020148,
   0x0000000100020150,
   0x0000000100020158,
   0x0000000100020160,
   0x0000000100020168,
   0x0000000100020170,
   0x0000000100020178,
   0x0000000100020180,
   0x0000000100020300,
   0x0000000100020308,
   0x0000000100020310,
   0x0000000100030000,
   0x0000000100030100,
   0x0000000100030110,
   0x0000000100030120,
   0x0000000100030130,
   0x0000000100030200,
   0x0000000100030210,
   0x0000000100030220,
   0x0000000100030230,
   0x0000000100030240,
   0x0000000100030250,
   0x0000000100030260,
   0x0000000100030270,
   0x0000000100030300,
   0x0000000100030310,
   0x0000000100030320,
   0x0000000100030330,
   0x0000000100030340,
   0x0000000100030350,
   0x0000000100030360,
   0x0000000100030370,
   0x0000000100030400,
   0x0000000100031000,
   0x0000000100031010,
   0x0000000100032000,
   0x0000000100032010,
   0x0000000100032800,
   0x0000000100032810,
   0x0000000100033000,
   0x0000000100033010,
   0x0000000100033020,
   0x0000000100033030,
   0x0000000100033040,
   0x0000000100033800,
   0x0000000100033810,
   0x0000000100033820,
   0x0000000100033830,
   0x0000000100033840,
   0x0000000100034000,
   0x0000000100034010,
   0x0000000100034020,
   0x0000000100038000,
   0x0000000100038010,
   0x0000000100038020,
   0x0000000100038030,
   0x0000000100038800,
   0x0000000100038810,
   0x0000000100038820,
   0x0000000100038830,
   0x0000000100048000,
   0x0000000100048010,
   0x0000000100048020,
   0x0000000100048030,
   0x0000000100048800,
   0x0000000100048810,
   0x0000000100048820,
   0x0000000100048830,
   0x0000000100049000,
   0x000000010004A000,
   0x0000000100050000,
   0x0000000100050100,
   0x0000000100050110,
   0x0000000100050120,
   0x0000000100050130,
   0x0000000100050200,
   0x0000000100050210,
   0x0000000100050220,
   0x0000000100050230,
   0x0000000100050240,
   0x0000000100050250,
   0x0000000100050260,
   0x0000000100050270,
   0x0000000100050300,
   0x0000000100050310,
   0x0000000100050320,
   0x0000000100050330,
   0x0000000100050340,
   0x0000000100050350,
   0x0000000100050360,
   0x0000000100050370,
   0x0000000100050400,
   0x0000000100051000,
   0x0000000100051010,
   0x0000000100052000,
   0x0000000100052010,
   0x0000000100052800,
   0x0000000100052810,
   0x0000000100053000,
   0x0000000100053010,
   0x0000000100053020,
   0x0000000100053030,
   0x0000000100053040,
   0x0000000100053800,
   0x0000000100053810,
   0x0000000100053820,
   0x0000000100053830,
   0x0000000100053840,
   0x0000000100054000,
   0x0000000100054010,
   0x0000000100054020,
   0x0000000100058000,
   0x0000000100058010,
   0x0000000100058020,
   0x0000000100058030,
   0x0000000100058800,
   0x0000000100058810,
   0x0000000100058820,
   0x0000000100058830,
   0x0000000100068000,
   0x0000000100068010,
   0x0000000100068020,
   0x0000000100068030,
   0x0000000100068800,
   0x0000000100068810,
   0x0000000100068820,
   0x0000000100068830,
   0x0000000100069000,
   0x000000010006A000,
   0x0000000110000000,
   0x0000000110000080,
   0x0000000110000100,
   0x0000000110000180,
   0x0000000110000200,
   0x0000000110000280,
   0x0000000110000300,
   0x0000000110000380,
   0x0000000110000400,
   0x0000000110000480,
   0x0000000110000500,
   0x0000000110000580,
   0x0000000110000600,
   0x0000000110000680,
   0x0000000110000700,
   0x0000000110000780,
   0x0000000110000800,
   0x0000000110000880,
   0x0000000110000900,
   0x0000000110000980,
   0x0000000110000A00,
   0x0000000110000A80,
   0x0000000110000B00,
   0x0000000110000B80,
   0x0000000110000C00,
   0x0000000110000C80,
   0x0000000110000D00,
   0x0000000110000D80,
   0x0000000110000E00,
   0x0000000110000E80,
   0x0000000110000F00,
   0x0000000110000F80,
   0x0000000110001000,
   0x0000000110001080,
   0x0000000110001100,
   0x0000000110001180,
   0x0000000110001200,
   0x0000000110001280,
   0x0000000110001300,
   0x0000000110001380,
   0x0000000110001400,
   0x0000000110001480,
   0x0000000110001500,
   0x0000000110001580,
   0x0000000110001600,
   0x0000000110001680,
   0x0000000110001700,
   0x0000000110010000,
   0x0000000110010008,
   0x0000000110010080,
   0x0000000110010088,
   0x0000000110020000,
   0x0000000110020080,
   0x0000000110020100,
   0x0000000110030000,
   0x0000000110030080,
   0x0000000110030100,
   0x0000000110030180,
   0x0000000110030200,
   0x0000000110040000,
   0x0000000110040080,
   0x0000000110040100,
   0x0000000110040180,
   0x0000000110040200,
   0x0000000110040280,
   0x0000000110040300,
   0x0000000110050000,
   0x0000000110050080,
   0x0000000110050100,
   0x0000000110050180,
   0x0000000110050200,
   0x0000000110050280,
   0x0000000110050300,
   0x0000000110050380,
   0x0000000110050400,
   0x0000000110050480,
   0x0000000110050500,
   0x0000000110050508,
   0x0000000110050580,
   0x0000000110050588,
   0x0000000110050600,
   0x0000000110050680,
   0x0000000110050700,
   0x0000000110050780,
   0x0000000110050800,
   0x0000000110060000,
   0x0000000110060080,
   0x0000000110060100,
   0x0000000110060180,
   0x0000000110060200,
   0x0000000110060280,
   0x0000000110060300,
   0x0000000110060380,
   0x0000000110060400,
   0x0000000110060480,
   0x0000000110060500,
   0x0000000110060580,
   0x0000000110060600,
   0x0000000110060680,
   0x0000000110060700,
   0x0000000110060780,
   0x0000000110060800,
   0x0000000110061000,
   0x0000000110061080,
   0x0000000110061100,
   0x0000000110061180,
   0x0000000110061200,
   0x0000000110061280,
   0x0000000110061300,
   0x0000000110062000,
   0x0000000110062080,
   0x0000000110062100,
   0x0000000110062180,
   0x0000000110062200,
   0x0000000110062280,
   0x0000000110062300,
   0x0000000110062380,
   0x0000000110062400,
   0x0000000110062480,
   0x0000000110062500,
   0x0000000110062580,
   0x0000000110062600,
   0x0000000110062680,
   0x0000000110062700,
   0x0000000110062780,
   0x0000000110062800,
   0x0000000110062880,
   0x0000000110062900,
   0x0000000110062980,
   0x0000000110062A00,
   0x0000000110063000,
   0x0000000110063080,
   0x0000000110063100,
   0x0000000110063180,
   0x0000000110064000,
   0x0000000110064080,
   0x0000000110065000,
   0x0000000110065080,
   0x0000000110065100,
   0x0000000110065180,
   0x0000000110065200,
   0x0000000110065280,
   0x0000000110065300,
   0x0000000110065380,
   0x0000000110065400,
   0x0000000110065480,
   0x0000000110066000,
   0x0000000110066080,
   0x0000000110066100,
   0x0000000110071000,
   0x0000000110071080,
   0x0000000110071100,
   0x0000000110071180,
   0x0000000110071200,
   0x0000000110071280,
   0x0000000110071300,
   0x0000000110071380,
   0x0000000110071400,
   0x0000000110071480,
   0x0000000110071500,
   0x0000000110071580,
   0x0000000110071600,
   0x0000000110071680,
   0x0000000110071700,
   0x0000000110071780,
   0x0000000110071800,
   0x0000000110071880,
   0x0000000110071900,
   0x0000000110071980,
   0x0000000110072000,
   0x0000000110072080,
   0x0000000110072100,
   0x0000000110072180,
   0x0000000110072200,
   0x0000000110072280,
   0x0000000110072300,
   0x0000000110073000,
   0x0000000110073080,
   0x0000000110073100,
   0x0000000110074000,
   0x0000000110074080,
   0x0000000110074100,
   0x0000000110074108,
   0x0000000110080000,
   0x0000000110090000,
   0x00000001100A0000,
   0x00000001100B0000,
   0x00000001100C0000,
   0x00000001100D0000,
   0x00000001100E0000,
   0x00000001100F0000,
   0x0000000110100000,
   0x0000000110100080,
   0x0000000110100100,
   0x0000000110100180,
   0x0000000110110000,
   0x0000000110120000,
   0x0000000110130000,
   0x0000000110140000,
   0x0000000110150000,
   0x0000000110160000,
   0x0000000110170000,
   0x0000000110180000,
   0x0000000110190000,
   0x0000000110190080,
   0x00000001101A0000,
   0x00000001101A0080,
   0x00000001101A0100,
   0x00000001101B0000,
   0x00000001101B0080,
   0x00000001101B0100,
   0x00000001101B0180,
   0x00000001101B0200,
   0x00000001101C0000,
   0x00000001101D0000,
   0x00000001101D0008,
   0x00000001101D0080,
   0x00000001101D0088,
   0x00000001101D0100,
   0x00000001101D0108,
   0x00000001101D0180,
   0x00000001101D0188,
   0x00000001101D0200,
   0x00000001101D0208,
   0x0000000120000000,
   0x0000000120000080,
   0x0000000120000100,
   0x0000000120000180,
   0x0000000120010000,
   0x0000000120010080,
   0x0000000120010100,
   0x0000000120010180,
   0x0000000120020000,
   0x0000000120020080,
   0x0000000120030000,
   0x0000000120030080,
   0x0000000120030100,
   0x0000000120030180,
   0x0000000120030200,
   0x0000000120030280,
   0x0000000120030300,
   0x0000000120030380,
   0x0000000120030400,
   0x0000000120030480,
   0x0000000120030500,
   0x0000000120030580,
   0x0000000120030600,
   0x0000000120030680,
   0x0000000120040000,
   0x0000000120040080,
   0x0000000120050000,
   0x0000000120050080,
   0x0000000120050100,
   0x0000000120050180,
   0x0000000120050200,
   0x0000000120050280,
   0x0000000120050300,
   0x0000000120050380,
   0x0000000120050400,
   0x0000000120050480,
   0x0000000120050500,
   0x0000000120050580,
   0x0000000120050600,
   0x0000000120050680,
   0x0000000120050700,
   0x0000000120050780,
   0x0000000120050800,
   0x0000000120050880,
   0x0000000120050900,
   0x0000000120050980,
   0x0000000120050A00,
   0x0000000120050A80,
   0x0000000120050B00,
   0x0000000120050B80,
   0x0000000120050C00,
   0x0000000120050C80,
   0x0000000120050D00,
   0x0000000120050D80,
   0x0000000120050E00,
   0x0000000120050E80,
   0x0000000120050F00,
   0x0000000120050F80,
   0x0000000120051000,
   0x0000000120051080,
   0x0000000120060000,
   0x0000000120060080,
   0x0000000120060100,
   0x0000000120060180,
   0x0000000120060200,
   0x0000000120060280,
   0x0000000120060300,
   0x0000000120060380,
   0x0000000120060400,
   0x0000000120060480,
   0x0000000120060500,
   0x0000000120060580,
   0x0000000120060600,
   0x0000000120060608,
   0x0000000120060680,
   0x0000000120060688,
   0x0000000120060700,
   0x0000000120060780,
   0x0000000120060788,
   0x0000000120060800,
   0x0000000120060880,
   0x0000000120060900,
   0x0000000120060980,
   0x0000000120060A00,
   0x0000000120060A80,
   0x0000000120060B00,
   0x0000000120060B80,
   0x0000000120060C00,
   0x0000000120060C80,
   0x0000000120060D00,
   0x0000000120060D80,
   0x0000000120070000,
   0x0000000120070080,
   0x0000000120070200,
   0x0000000120070208,
   0x0000000120070280,
   0x0000000120070288,
   0x0000000120070400,
   0x0000000120070480,
   0x0000000150000000,
   0x0000000150000008,
   0x0000000150000010,
   0x0000000150000018,
   0x0000000150000020,
   0x0000000150000028,
   0x0000000150000030,
   0x0000000150000038,
   0x0000000150000040,
   0x0000000150000048,
   0x0000000150001010,
   0x0000000150001020,
   0x0000000150001030,
   0x0000000150001040,
   0x0000000150001050,
   0x0000000150001060,
   0x0000000150001070,
   0x0000000150002000,
   0x0000000150002008,
   0x0000000150002010,
   0x0000000150002018,
   0x0000000150002020,
   0x0000000150002028,
   0x0000000150002030,
   0x0000000150002038,
   0x0000000150002040,
   0x0000000150002048,
   0x0000000150003010,
   0x0000000150003020,
   0x0000000150003030,
   0x0000000150003040,
   0x0000000150003050,
   0x0000000150003060,
   0x0000000150003070,
   0x0000000150020000,
   0x0000000150020400,
   0x0000000150020480,
   0x0000000150020488,
   0x0000000150021000,
   0x0000000150021400,
   0x0000000150021480,
   0x0000000150021488,
   0x0000000150022000,
   0x0000000150022400,
   0x0000000150022480,
   0x0000000150022488,
   0x0000000150023000,
   0x0000000150023400,
   0x0000000150023480,
   0x0000000150023488,
   0x0000000150024000,
   0x0000000150024400,
   0x0000000150024480,
   0x0000000150024488,
   0x0000000150030000,
   0x0000000150030010,
   0x0000000150030020,
   0x0000000150030030,
   0x0000000150030040,
   0x0000000150030050,
   0x0000000150030060,
   0x0000000150030100,
   0x0000000150030110,
   0x0000000150030120,
   0x0000000150030130,
   0x0000000150030140,
   0x0000000150030150,
   0x0000000150030160,
   0x0000000150030200,
   0x0000000150030210,
   0x0000000150030220,
   0x0000000150030230,
   0x0000000150030240,
   0x0000000150030250,
   0x0000000150030260,
   0x0000000150030270,
   0x0000000150030280,
   0x0000000150030290,
   0x00000001500302A0,
   0x00000001500302B0,
   0x0000000150030300,
   0x0000000150030310,
   0x0000000150030320,
   0x0000000150030330,
   0x0000000150030340,
   0x0000000150030350,
   0x0000000150030360,
   0x0000000150030370,
   0x0000000150030380,
   0x0000000150030390,
   0x00000001500303A0,
   0x00000001500303B0,
   0x00000001500303C0,
   0x00000001500303D0,
   0x00000001500303E0,
   0x00000001500303F0,
   0x0000000150030400,
   0x0000000150030500,
   0x0000000150030510,
   0x0000000150030520,
   0x0000000150030530,
   0x0000000150030540,
   0x0000000150030550,
   0x0000000150030560,
   0x0000000150030570,
   0x0000000150030580,
   0x0000000150030590,
   0x00000001500305A0,
   0x00000001500305B0,
   0x00000001500305C0,
   0x00000001500305D0,
   0x00000001500305E0,
   0x00000001500305F0,
   0x0000000150030600,
   0x0000000150031000,
   0x0000000150031020,
   0x0000000150031040,
   0x0000000150031050,
   0x0000000150031060,
   0x0000000150031080,
   0x00000001500310A0,
   0x00000001500310C0,
   0x00000001500310E0,
   0x0000000150031100,
   0x0000000150031110,
   0x0000000150031120,
   0x0000000150031130,
   0x0000000150031140,
   0x0000000150031150,
   0x0000000150031160,
   0x0000000150031170,
   0x0000000150031180,
   0x0000000150031190,
   0x00000001500311A0,
   0x00000001500311B0,
   0x00000001500311C0,
   0x00000001500311D0,
   0x00000001500311E0,
   0x00000001500311F0,
   0x0000000150031200,
   0x0000000150031210,
   0x0000000150031220,
   0x0000000150031230,
   0x0000000150031240,
   0x0000000150031250,
   0x0000000150031260,
   0x0000000150031270,
   0x0000000150031300,
   0x0000000150031310,
   0x0000000150031320,
   0x0000000150031330,
   0x0000000150031340,
   0x0000000150031350,
   0x0000000150031360,
   0x0000000150031370,
   0x0000000150031380,
   0x0000000150031390,
   0x00000001500313A0,
   0x00000001500313B0,
   0x00000001500313C0,
   0x00000001500313D0,
   0x00000001500313E0,
   0x00000001500313F0,
   0x0000000150031400,
   0x0000000150031410,
   0x0000000150031420,
   0x0000000150031430,
   0x0000000150031440,
   0x0000000150031450,
   0x0000000150031460,
   0x0000000150031470,
   0x0000000150031500,
   0x0000000150031510,
   0x0000000150031520,
   0x0000000150031530,
   0x0000000150031540,
   0x0000000150031550,
   0x0000000150031560,
   0x0000000150031570,
   0x0000000150031580,
   0x0000000150031590,
   0x00000001500315A0,
   0x00000001500315B0,
   0x00000001500315C0,
   0x00000001500315D0,
   0x00000001500315E0,
   0x00000001500315F0,
   0x0000000150031600,
   0x0000000150031610,
   0x0000000150031620,
   0x0000000150031630,
   0x0000000150031640,
   0x0000000150031650,
   0x0000000150031660,
   0x0000000150031670,
   0x0000000150031700,
   0x0000000150031710,
   0x0000000150031720,
   0x0000000150031730,
   0x0000000150031740,
   0x0000000150031750,
   0x0000000150031760,
   0x0000000150031770,
   0x0000000150031780,
   0x0000000150031790,
   0x00000001500317A0,
   0x00000001500317B0,
   0x00000001500317C0,
   0x00000001500317D0,
   0x00000001500317E0,
   0x00000001500317F0,
   0x0000000150031800,
   0x0000000150031810,
   0x0000000150031820,
   0x0000000150031830,
   0x0000000150031900,
   0x0000000150031910,
   0x0000000150031920,
   0x0000000150031930,
   0x0000000150031940,
   0x0000000150031950,
   0x0000000150031960,
   0x0000000150031970,
   0x0000000150031980,
   0x0000000150031990,
   0x00000001500319A0,
   0x00000001500319B0,
   0x00000001500319C0,
   0x00000001500319D0,
   0x00000001500319E0,
   0x00000001500319F0,
   0x0000000150031A00,
   0x0000000150031A10,
   0x0000000150031A20,
   0x0000000150031A30,
   0x0000000150032000,
   0x0000000150032008,
   0x0000000150032010,
   0x0000000150032018,
   0x0000000150032020,
   0x0000000150032030,
   0x0000000150032038,
   0x0000000150032040,
   0x0000000150032048,
   0x0000000150032050,
   0x0000000150032058,
   0x0000000150040000,
   0x0000000150040008,
   0x0000000150040020,
   0x0000000150040028,
   0x0000000150040040,
   0x0000000150040060,
   0x0000000150040070,
   0x0000000150040080,
   0x0000000150040090,
   0x00000001500400A0,
   0x00000001500400B0,
   0x00000001500400C0,
   0x00000001500400D0,
   0x00000001500400E0,
   0x00000001500400F0,
   0x0000000150040100,
   0x0000000150040110,
   0x0000000150040120,
   0x0000000150040130,
   0x0000000150040140,
   0x0000000150040150,
   0x0000000150040200,
   0x0000000150040208,
   0x0000000150040220,
   0x0000000150040228,
   0x0000000150040240,
   0x0000000150040260,
   0x0000000150040300,
   0x0000000150040308,
   0x0000000150040320,
   0x0000000150040328,
   0x0000000150040340,
   0x0000000150040360,
   0x0000000150040400,
   0x0000000150040408,
   0x0000000150040420,
   0x0000000150040428,
   0x0000000150040440,
   0x0000000150040460,
   0x0000000150040500,
   0x0000000150040508,
   0x0000000150040510,
   0x0000000150040518,
   0x0000000150040520,
   0x0000000150040528,
   0x0000000150040530,
   0x0000000150040538,
   0x0000000150040540,
   0x0000000150040550,
   0x0000000150040560,
   0x0000000150040570,
   0x0000000150040580,
   0x0000000150040590,
   0x0000000150040600,
   0x0000000150040608,
   0x0000000150040610,
   0x0000000150040618,
   0x0000000150040620,
   0x0000000150040628,
   0x0000000150040630,
   0x0000000150040638,
   0x0000000150040640,
   0x0000000150040650,
   0x0000000150040660,
   0x0000000150040670,
   0x0000000150040680,
   0x0000000150040690,
);


##########################################################################
#                                                                        #
#   REGISTER SEARCH SUBROUTINES (BY NAME OR ADDRESS)                     #
#                                                                        #
##########################################################################

sub shub_01_mmr_search_name
{  my $rptr = 0;
   return($rptr) if ( $#_ != 0 );
   $rptr = $shub_01_mmr_by_name{$_[0]} if ( exists $shub_01_mmr_by_name{$_[0]} );
   return($rptr);
}

sub shub_01_mmr_search_addr
{  my $rptr = 0;
   return($rptr) if ( $#_ != 0 );
   $rptr = $shub_01_mmr_by_addr{$_[0]} if ( exists $shub_01_mmr_by_addr{$_[0]} );
   return($rptr);
}

1;
